////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmAKN.cpp {X AJl  Stage316M00
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMAKN_CPP__

#include "EnmAKN.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Stage\03\00\K7Stage316M00.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Matsu\mK7Noise.h"
#include "..\Yam\YK7EffectMuzzle.h"
#include "..\Yam\YK7EffectShot.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Yam\YK7EffectFlash.h"

// ǂ̒`
#define WALL_XMIN		(-310.F)
#define WALL_YMIN		(0.F)
#define WALL_ZMIN		(-310.F)

#define WALL_XMAX		(310.F)
#define WALL_YMAX		(50.F)
#define WALL_ZMAX		(310.F)

int K7EnmAKN::mAKNBattleStart = 0;							// AJl{XJtO

#define RUNSHOT_TIME			(30*5)						// AJl̑ˌ̎
#define RUNSHOTWAIT_TIME		(-10)						// AJl̑ˌ̖߂oĂˌɓ܂ł̎

#define AK2_MUZZLEWAIT			(3)							// }YtbV̊Ԋu
#define AK2_SHOTWAIT1			(120)						// P`Ԏ̃VbgłԊu

#define AK2_SHOTDIRBIASRAND		(0.05F)						// ]̃̕oCAXl(S_)
#define AK2_SHOTCOLOR			(CMK(255,255,255,255))		// P`Ԏ̃Vbg̐F
#define AK2_SHOTSIZE			(0.157F)					// P`Ԏ̃Vbg̑傫
#define AK2_SHOTSPEED			(10.9F)						// P`Ԏ̃Vbg̑

#define YUKA_Y					(0.f)
#define LGT_DIST				(110.f)						// CgŏƂ炳鋗

#define AK2_PLAYDMGWIDTH		(8.0F)						// vC[_[W󂯂锼a
#define AK2_PLAYDMGCHECKDIV		(8)

#define AKN_PLAYDMG_EASY		(6)							// ꔭ̃vC[󂯂_[WliC[W[
#define AKN_PLAYDMG_NORMAL		(12)						// ꔭ̃vC[󂯂_[Wlim[}

#define AK2_PLAYDMGWAIT			(6)							// vC[_[W󂯂܂ł̑҂
#define AK2_PLAYDMGWAIT2		(30)						// vC[_[WLZɎ󂯂܂ł̑҂

#define AKN_MUTEKI				(30)						// AJl̖GNオ莞
#define AKN_MUTEKI_ALPHA		(0.2f)						// AJl̖GȂƂ̃l

#define RUN_SPEED				(3.5f)						// AJl̊{Xs[h
#define BOOSTMAX_NORMAL			(2.5f)						// u[XgMAXl
#define BOOSTMAX_EASY			(1.5f)						// u[XgMAXl

static int damageSeTbl[] = {
	SFX_BOSS_AKN_DAMAGE1SOTO,
	SFX_BOSS_AKN_DAMAGE2SOTO,
};


void K7EnmAKN::Dummy( void )
{
}


K7EnmAKN::K7EnmAKN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7AKN, MotionIDTableAKN)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 0;								// goiQƂĂȂ̂łӁj
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// XP[
	
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mInitProcess		= 0;
	mpGun				= (WK7Model *) NULL;
	
//	mBulletNow			= AKN_GUN_BULLET_MAX;
	mPcDamageSetCount	= 0;
	mShotCount			= 0;
	
	K7EnmAKN::mAKNBattleStart = 0;
	
	mBattleCount		= WK7_SEC_TO_FRAME(30);
	mBatteleExit		= 0;
	mBattleProcess		= 0;
	mMuteki				= 0;
	
	mMoveProcess		= CALL_INIT;								// svZX̎w
	
	mStartPos.x			= 0.f;
	mStartPos.y			= 0.f;
	mStartPos.z			= 0.f;
	
	mEndPos.x			= 0.f;
	mEndPos.y			= 0.f;
	mEndPos.z			= 0.f;
	
	mRunPointPtr		= 0;
	
	mShotflag			= false ;
	mpMuz				= (EFFECT *)NULL;
	mShotEfc			= (WK7RenderObjEffect *)NULL;
	mMuzid				= 0;
	pdamagetime			= 0 ;
	pdamagetime2		= 0 ;
	pdamagecon			= 0 ;
	
	mValidAlpha			= false;
	mAlphaInitflag		= false;
	
	mRunSpeed			= RUN_SPEED;
	mBoost				= 1.f;
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){			// C[W[[h̎
		mShotDamage		= AKN_PLAYDMG_EASY;
		mBoostMax		= BOOSTMAX_EASY;
	}else{
		mShotDamage		= AKN_PLAYDMG_NORMAL;
		mBoostMax		= BOOSTMAX_NORMAL;
	}
	
	
//	mMotID				= AKN_MOT_WAIT;
//	mState.Init( KIB_KRR_COMMON_ATK0 );
}
K7EnmAKN::~K7EnmAKN()
{
	WK7PLAYERCONTROL->BattlePadRegulationSet();
	Release();
	WK7RenderObj::SetVfxFlag( true );
}

void K7EnmAKN::Release(void)
{
	gpSound->mReleaseSsm( "seBossAkn.ssm" );
	ShotEnd();
	AlphaEnd();
	DeleteMuzzle() ;
	if ( mShotEfc!=NULL ){
		pCurrentChara()->ReleaseEffect(mShotEfc);
		mShotEfc = NULL;
	}
	DetachGun();
	ReleaseModel    ();
	ReleaseMotionAll();
}
void K7EnmAKN::DetachGun(void)
{
	if ( mpGun ){
		DetachGunModel((s8)GUN_R);
		mpGun = (WK7Model *)0;
	}
	ReleaseGunArchive(GUN_R);
}


bool K7EnmAKN::ControlProcess(void)
{
	Vec myPos;
	s16 dam;

	if ( mpNpcChara==NULL )			return true;
	if ( true == GetNpcPause() ) 	return true;											// |[YȎ
	if ( true == IsLoading() ) 		return true;											// ǂݍݒ
	
	if ( mState == NPC_STATE_INIT )	goto NPC_CTRL_INIT_JUMP;
	
	mpNpcChara->GetPosition(myPos);
	
	AlphaProc();
	ShotProc();
	PlayDamageProc();
	
	if ( mMuteki > 0 ){
		mMuteki--;
	}
	
	// _[W炢`FbN
	if ((true == DamageTest())
	&&	(true == AknDamageTest())
	&&	(mState != NPC_STATE_DMG)								// AȂ
	){
		// HP DEC
		dam = mDamage.mDamPoint;
		// _[W~bg`FbN
		if (DAMTYPE_DANSPATK == mDamage.mDamType){				// _Ae
			dam = 200;
		}
		mData.mHp -= dam;
		
		// }XN̉
		DamageGrenadeSet(dam);
		
		if ( mData.mHp <= 0 ){
			DieMotSet();
		}else{
			AKN_Dmg();
			mState = NPC_STATE_DMG;
			
			// ꐺrd
			gpSound->mPlaySE(damageSeTbl[rand()%2]);
		}
		
		// GtFNgiqbg}[Nj
		{
			WK7Model		*pModel;
			WK7JObj			*pJOBj;
			if ( (pModel = mpNpcChara->GetModel()) != NULL ){
				pJOBj = pModel->GetObj(K7CHRBONE_WAIST);
			}
			
			BloodEfcCall(mDamage.mDamPos, mDamage.mDamDir, myPos, (s16 )dam, pJOBj, 0, 0);
		}
		
		mDamage.mDamHitRequest = 0;
		
//		Cmd_ResetSet();
	}
	
	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		switch (mInitProcess){
		case 0:
			if ( true == StateInit() ){						// ̒mStateςꂿႤ̂
				mState = NPC_STATE_INIT;
				mInitProcess++;
			}
			break;
		case 1:
			// ẽ[hĩ^C~OŃR[)
			if ( -1 == LoadGunArchive((s8)GUN_R) ) break;
			
															// AJlpSEf[^̓ǂݍ
			gpSound->mReadSsm( "seBossAkn.ssm", eBankBoss );
			
			// _ݒij
//			WeakPointEffectSet( K7CHRBONE_SKULL );
			
			mInitProcess++;
			break;
		case 2:
			if ( true == CheckGunArchiveLoad((s8)GUN_R) ) break;
			// nCf̏eɃA^b`
			mpGun = AttachGunModel(	(s8)GUN_R,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_R											// E肩肩
			);
			
			AlphaInit();
			
			mInitProcess++;
			break;
		case 3:
			{
				EFFECT *pYamEfc;
				
				WK7RenderObjEffectInfo	info;
				info.Create();
				
				// VbgGtFNg̍쐬
				pYamEfc = CreateShotEffect( AK2_SHOTCOLOR,
											AK2_SHOTSIZE,
											true,
											60,
											0.1F,
											100,
											CMK( 247,189,119,200),
											SFX_BOSS_AKN_TYOUDAN
				);
				
				if( pYamEfc == NULL ){
					break;
				}else{
					mShotEfc = pCurrentChara()->CreateEffect( pYamEfc ,&info);
					SetShotEffectWall( mShotEfc->GetEffect(),	WALL_XMIN, WALL_XMAX,
																WALL_YMIN, WALL_YMAX,
																WALL_ZMIN, WALL_ZMAX
					);
				
				}
			}
			mInitProcess++;
		case 4:
			if( false == MotSet_Wait(false) ) break;
			mInitProcess++;
			mState = NPC_STATE_WAIT;
			
			break;
		}
		break;
	case NPC_STATE_WAIT:
		
		if ( 1 == K7EnmAKN::mAKNBattleStart ){
			if ( CALL_MOVE == mMoveProcess ){
				if ( mBattleCount && (false == WK7PLAYERCONTROL->PcDieTest()) 				// lĂH
				){
					mBattleCount--;
				}else{
					Cmd_RunSet(AKN_MovePoint[mRunPointPtr]);
					break;
				}
			}
		}
		
		// Ȑ
		if ( true == MotStatus_Wait() ) break;
		
		break;
	case NPC_STATE_RUN:													//  or 茂
		AKN_Run();
		break;
	case NPC_STATE_DMG:
		// _[W
		ShotEnd();
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			mMuteki = AKN_MUTEKI;
			MotSet_Wait(true);
			mState = NPC_STATE_WAIT;
		}
		break;
	case NPC_STATE_EVENT:
		break;
	case NPC_STATE_DIE:
		ShotEnd();
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			ReleaseWeakPoint();
			mState = NPC_STATE_LOSS;
		}
		break;
	case NPC_STATE_LOSS:
		break;
	}
	return false;
}


/*
	
	S[VZbg
	
*/
void K7EnmAKN::DieMotSet(void)
{
	// AJlSVoice
	gpSound->mPlaySE(SFX_BOSS_AKN_DIESOTO);
	
	// SuԂATuʋ֎~
	GameInfo.SetSpecialEnable(false );
	
	/// SuԂ LA
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	/// SuԂ og^XN
	KK7BattleMainTask::BattleMainTaskExit();
	
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotionAKN(AKN_MOT_DIE, false, true, 0.f) ){
		
	}
	mState = NPC_STATE_DIE;
}




/*
	
	
	߁FʒuZbg
	
	
*/
void K7EnmAKN::Cmd_ResetSet(void)
{
	MotStatus_Wait();
	SetPosition(mStartPos);
	mState = NPC_STATE_WAIT;
}


/*
	
	
	߁F
	
	
*/
bool K7EnmAKN::Cmd_RunSet(Vec goPos)
{
	Vec myPos;

	if ( mpNpcChara != NULL ){
		mpNpcChara->GetPosition(myPos);
		mState		= NPC_STATE_RUN;
		mStartPos	= myPos;
		mEndPos		= goPos;
		return true;
	}
	return false;
}


/*
	
	
	胂[VZbg
	
	NPC_STATE_RUN
	
*/
bool K7EnmAKN::AKN_Run(void)
{
	Vec	enePos;
	Vec	dir;
	f32 distRest;

	mpNpcChara->GetPosition(enePos);							// ݒn̎擾
	
	// ړIl̕I
	dir.x = mEndPos.x - enePos.x;
	dir.z = mEndPos.z - enePos.z;
	mGoDir = atan2f((f32 )dir.x, (f32 )dir.z);
	
	SetTargetRotY(mGoDir);
	SetRotCalc(4.f);
	
	// rdĐ
	if(	mpNpcChara!=NULL ){
		WK7Model *pModel = mpNpcChara->GetModel();
		if ((2 == pModel->GetCurrentMotionFrame())
		||	(22 == pModel->GetCurrentMotionFrame())
		){
//			gpSound->mPlaySE3D( FOOT_SE_DEFINE, enePos, 0 );		// rdĐ
		}
	}
	
	if ( mShotCount < 0 ) {					// ˌҋ@
		mShotCount++;
		if ( 0 == mShotCount ){
			mShotCount = RUNSHOT_TIME;		// ˌJn
		}
	}
	
	if ( mShotCount > 0 ) {
	// ˌ[V̍Đ
		if ( mMotID != AKN_MOT_SHOTDASHR ){
			ShotStart( 0.f );
			MotPlayInit(NPC_POSMODE_PROG);
			if( false == PlayCommonMotionAKN(AKN_MOT_SHOTDASHR, true, true, (1.f * mBoost) ) ){
				return false;
			}
		}
		mShotCount--;
	}else{
	// 胂[V̍Đ
		if ( mMotID != AKN_MOT_RUN ){
			ShotEnd();
			MotPlayInit(NPC_POSMODE_PROG);
			if( false == PlayCommonMotionAKN(AKN_MOT_RUN, true, true, (1.f * mBoost) ) ){
				return false;
			}
		}
	}
	
	// ړ
	enePos.x += (mRunSpeed * mBoost * 1.f) * sinf(mRotY);
	enePos.z += (mRunSpeed * mBoost * 1.f) * cosf(mRotY);
	
	SetPosition(enePos);
	
	// ړIn܂ŒǂH
	distRest = GHM_VEC_GET_DIST(&mEndPos, &enePos);
	if ( distRest <= (mRunSpeed * mBoost * 3.f) ){
		
		AiTest_NestShot();						// ̋͂Ⴐ邩ǂ̔f
		
												// ̖ړI̍XV
		if ( mRunPointPtr < (RUNPOINT_MAX-1) ){
			mRunPointPtr++;
		}else{
			mRunPointPtr = 0;
		}
		
		MotSet_Wait(true);
		mState = NPC_STATE_WAIT;
		return true;
	}
	return false;
}


/*
	
	ꃂ[VZbg
	
*/
void K7EnmAKN::AKN_Dmg(void)
{
	// ǂǂĂ
	f32 Hpbk = (f32 )mData.mHpBk;
	f32 Hp   = (f32 )mData.mHp;
	f32 Rate = (Hpbk - Hp) / Hpbk;
	if ( Rate < 0.f ){
		Rate = 0.f;
	}
	mBoost += (mBoostMax * Rate);
	if ( mBoost > mBoostMax ) mBoost = mBoostMax;
	
	mShotCount = 0;								// ˌԂɂJEgNA
	
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotionAKN(AKN_MOT_DAM, false, true, 2.f) ){
		
	}
}


/*
	
	
	lɃ_[Wݒ肷B
	
	
*/
void K7EnmAKN::PcDamageSet(void)
{
	Vec myPos;
	
	mpNpcChara->GetPosition(myPos);
	SetMuzzleCartridgeSound3DFlag() ;
	CreateMuzzleEffect( GUN_R, myPos.y );
	
	mPcDamageSetCount++;
	
	if (((3+rand()%4) <= mPcDamageSetCount)
	&&	(true == PcHitTest())
	){
		mPcDamageSetCount = 0;
//		WK7PLAYERCONTROL->SetPcDamage(myPos, 2, 1);				// |WVA_[WlA[h
		WK7PLAYERCONTROL->SetPcDamage(myPos, AKN_GUN_DAMAGE, 2);				// |WVA_[WlA[h
	}
}

/*
	
	
	obɃ_[W^ĂǂH
	
	
*/
bool K7EnmAKN::PcHitTest(void)
{
	if ((200 == mBattleProcess)
	||	(0 == mBattleProcess)
	||	(20 == mBattleProcess)
	||	(21 == mBattleProcess)
	){
		return false;
	}
	return true;
}


/*
	
	
	oWbN
	
	
*/
void K7EnmAKN::RunLogicSet(u32 time)
{
	mMoveProcess = CALL_MOVE;									// AJlړJn
	mBattleCount = time;
}


bool K7EnmAKN::FrameProcess(void)
{
	MotionProcess();
	
	if( mpNpcChara!=NULL ){
		
		if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
#if FUJITA //030702
			//_B
			{
				Vec eye;
				WK7CAM->GetPosition( eye );
				
				//_JOBJAJɂ炷ʁB
				//f32 dist = 5.f;
				f32 dist = -5.f;
				
				//_̏B
				PlayWeakPoint( eye, dist );
			}
#endif
			// XLjORg[
//			ScanContorol();
			
			// B鏈Rg[
//			HideContorol();
			
			// [VXs[hRg[
			MotionSpeedControl();
			
			// ŏ̈ʒuZbg̎
			if( !mFirstPosSet ){
				
				mFirstPosSet = 1;
				mpNpcChara->SetPosition(mPosition);
				mpNpcChara->SetRotY(mTargetRotY);
				
				// X^[gʒu̕ۑ
				mStartPos = mPosition;
				
				// _[iqbg̃sbN̂߂ɂKvsj
				switch( mpNpcChara->GetRenderID() ){
				case	WK7RENDEROBJ_INVALID_RENDERID:
//				case	WK7RENDEROBJ_RENDERID_MAX:
				case	WK7RENDEROBJ_RENDERID_DEFAULT:
					mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
					mpNpcChara->EnableVfxEffect();
					break;
				default:
					break;
				}
			}
		}
		
		VisibleTest();
	}
	return true;
}

void K7EnmAKN::VisibleTest(void)
{
	bool	visible = mVisible;

	if( visible==true ){
		/*
			
			\II
			
		*/
		// \
		VisibleTestDisp();
	}else{
		// \
		VisibleTestHide();
	}
	// \tOs
	pCurrentChara()->SetRenderFlag(visible);
}



/*
	
	
	AJl{XĎ֐
	
	
*/
void K7EnmAKN::StageProc(WK7Stage *pCurrentStage)
{
	static WK7JObj *pJObj;
	static int exitMode;
	K7Stage316M00 *pStage = (K7Stage316M00 *)pCurrentStage;
	
	switch (mBattleProcess){
	case 0:							// ҋ@
		if ( 1 == K7EnmAKN::mAKNBattleStart ){
			mBattleProcess = 100;
			WK7PLAYERCONTROL->SetOperateEnable(true);
			SetVisible(true);
			RunLogicSet(0);
			
			gpSound->mPlayStreamNo(HPS_BOSS_AKN);						//@퓬ȊJnI
			
			/// LA
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
		}else{
			SetVisible(false);
		}
		break;
	case 100:															// og
		if ( PC_STATE_LOSS == WK7PLAYERCONTROL->GetPcState() ){			// lŏI
				mBattleProcess=2000;
				exitMode = -1;
		}else{
			if (mState == NPC_STATE_LOSS ){								// AJlŏI
				mBattleProcess=1000;
				exitMode = 1;
			}
		}
		break;
	case 1000:
		gpSound->mStopStream();											// 퓬ȏI
		//mCY
//		gpNoise->mSandRequest(eSandLongNoise);											// LȂꍇ
		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);			// Lꍇ
		mBattleProcess=1001;
		break;
	case 1001:
		if ( gpNoise->mGetSandFrameProc()==eSandExec ){
			Release();
			mBattleProcess++;
			WK7PLAYERCONTROL->BattlePadRegulationSet();
			mBatteleExit = exitMode;
		}
		break;
	case 2000:															// lꍇ̑ҋ@ꏊ
		// ŏɉƂ͂
		gpSound->mStopStream();											// 퓬ȏI
		WK7PLAYERCONTROL->BattlePadRegulationSet();
		mBatteleExit = exitMode;
		break;
	default:
		break;
	}
}

/*
	
	
	AJl{XIH
	
	<return>
	-1			{XIilSj
	1			{XIiAJlSj
	0			{X풆
	
*/
int K7EnmAKN::AKNBossEnd(void)
{
	return mBatteleExit;
}

/*
	
	
	̋͂Ⴐ邩ǂ̔f
	
	
*/
void K7EnmAKN::AiTest_NestShot(void)
{
	u8 nextShot = 0;

	if ( GetHp() <= (mData.mHpBk/2) ){
		if ( GetHp() <= (mData.mHpBk/4) ){
			nextShot = 1;
		}else{
			if ( (rand()%2) == 0 ){
				nextShot = 1;
			}
		}
	}else{
		if ( (rand()%4) == 0 ){
			nextShot = 1;
		}
	}
	
//	nextShot = 1;
	
	if ( nextShot ){
		mShotCount = RUNSHOTWAIT_TIME;		// ˌҋ@Jn
	}
}

// VbgX^[g
void K7EnmAKN::ShotStart( f32 bias )
{
	if( mShotflag == true ) return ;
	mMuzzleWaitCon = 0 ;
	mMuzzlecon = 0 ;
	mShotflag = true ;
	mShotbias = bias ;
	CreateMuzzle() ;
}

// VbgGh
void K7EnmAKN::ShotEnd( void )
{
	mShotflag = false ;
	DeleteMuzzle() ;
}

// Vbg̃t[vZX
void K7EnmAKN::ShotProc( void )
{
	s32 wait ;

	if( mShotflag == false ) return ;

	// }YtbVo
	mMuzzlecon ++ ;
	if( mMuzzlecon >= AK2_MUZZLEWAIT )
	{
		SetMuzzleCartridgeSound3DFlag() ;
		mpMuz = CreateMuzzleEffect( GUN_R, YUKA_Y ) ;			
		if( mpMuz != NULL ) mMuzid = GetEffectID( mpMuz ) ;
		mMuzzlecon = 0 ;
	}
	
	// VbgԊu̎Zo
	wait = AK2_SHOTWAIT1;

	// Vbg鏈
	mMuzzleWaitCon += 100 ;
	while( mMuzzleWaitCon >= wait )
	{
		mMuzzleWaitCon -= wait ;
		CreateMuzzle() ;
		mMuzzleWaitCon = 0 ;
	}
}

// }Yo
void K7EnmAKN::CreateMuzzle( void )
{
	HSD_JObj *jobj ;
	Vec dir, pos ;

	jobj = mpGun->GetObj( "MuzFlash00_S1" )->GetJObj() ;
	GetJObjZVec( jobj, &dir ) ;
	dir.y += mShotbias ;
	
	dir.x += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
	dir.y += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
	dir.z += GetRandF2Num( AK2_SHOTDIRBIASRAND, -AK2_SHOTDIRBIASRAND ) ;
	
	VECNormalize( &dir, &dir ) ;
	GetJObjPos( jobj, &pos ) ;
	
	if ((pCurrentChara() != NULL)
	&&	(true == pCurrentChara()->IsValidEffect(mShotEfc))
	){
		AddShotEffect( mShotEfc->GetEffect(), pos, dir, AK2_SHOTSPEED );
	}
	
	// }YˉĐ
	gpSound->mPlaySE3D( SFX_BOSS_AKN_SHOTLV1, pos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
}

// }Y폜
void K7EnmAKN::DeleteMuzzle( void )
{
	if( CheckEffectValidState( mpMuz, mMuzid ) == TRUE )
	{
		DeleteEffect( mpMuz ) ;
		mpMuz = NULL ;
		mMuzid = 0 ;
	}
}


// vC[̃_[W̃R[obN
s8 K7EnmAKN::PlayDamageCallBack( SHOTOBJECT *obj, void *data )
{
	K7EnmAKN *AK2 = ( K7EnmAKN * )data ;
	Vec pos, spos ;
	s32 i ;
	
	// vC[̈ʒu𓾂
	WK7PLAYERCONTROL->GetWaistPosition( &pos );
	
	// Ă邩ׂ
	for( i = 0 ; i < AK2_PLAYDMGCHECKDIV ; i ++ )
	{
		spos.x = obj->pos.x - obj->speed2.x * i / AK2_PLAYDMGCHECKDIV ;
		spos.y = obj->pos.y - obj->speed2.y * i / AK2_PLAYDMGCHECKDIV ;
		spos.z = obj->pos.z - obj->speed2.z * i / AK2_PLAYDMGCHECKDIV ;
	
		// Ă烋[v𔲂
		if( VECDistance( &pos, &spos ) <= AK2_PLAYDMGWIDTH ) break ;
	}
	if( i == AK2_PLAYDMGCHECKDIV ) return 0 ;
	
	// Ă_[Wǉ
	AK2->PlayDamageInc() ;
	
	// I
	return 0 ;
}

// vC[̃_[W`FbN
void K7EnmAKN::PlayDamageCheck( void )
{
	// SĂ̒eۂ񋓁EvC[ɓĂ邩ׂ
	if ((pCurrentChara() != NULL)
	&&	(true == pCurrentChara()->IsValidEffect(mShotEfc))
	&&	(false == WK7PLAYERCONTROL->PcDieTest()) 				// lĂH
	){
		EnumShotEffect( mShotEfc->GetEffect(), PlayDamageCallBack, this ) ;
	}
}

// vC[Ƀ_[Wǉ
void K7EnmAKN::PlayDamageInc( void )
{
	// ^CJE^Zbg
	pdamagetime = 0 ;
	if( pdamagecon == 0 ) pdamagetime2 = 0 ;
	
	// _[W񐔂ǉ
	pdamagecon ++ ;
}

// vC[Ƀ_[W^鏈̃t[vZX
void K7EnmAKN::PlayDamageProc( void )
{
	PlayDamageCheck();

	if( pdamagecon == 0 ) return ;
	
	pdamagetime ++ ;
	pdamagetime2 ++ ;
	if( pdamagetime < AK2_PLAYDMGWAIT && pdamagetime2 < AK2_PLAYDMGWAIT2 ) return ;

	// vC[Ƀ_[W^
	if	(false == WK7PLAYERCONTROL->PcDieTest()) 				// lĂH
	{
		Vec pos ;
		mpNpcChara->GetPosition(pos) ;
		WK7PLAYERCONTROL->SetPcDamage( pos, (s16)(mShotDamage * pdamagecon), 1 ) ;
	}
	
	// JE^̃Zbg
	pdamagecon = 0 ;
	pdamagetime = 0 ;
	pdamagetime2 = 0 ;
}

// ̗LtOZbg
void K7EnmAKN::AlphaValidflag( bool flag )
{
	mValidAlpha = flag ;
}

// ̏
void K7EnmAKN::AlphaInit(void)
{
	if( mAlphaInitflag == true ) return ;

	// IuWFNg̍쐬
	gunalpha = bodyalpha = NULL ;
	
	ghmGcMemSetAllocName("AKNBODY");
	if( ( bodyalpha = new C_SetAlpha( GetModel()->GetObj(0)->GetJObj(), 1.0F ) ) == NULL ) goto ERR ;
	ghmGcMemSetAllocName("AKNGUN");
	if( ( gunalpha = new C_SetAlpha( mpGun->GetObj(0)->GetJObj(), 1.0F ) ) == NULL ) goto ERR ;
	
	mNowAlpha 	= 1.0F ;
	mTargetAlpha= 1.0F ;
	mAlphaSpeed = 0.1F ;
	mHideflag 	= false ;
	
	mValidAlpha	= true ;
	mAlphaInitflag = true ;
	
	return ;
	
ERR :
	if( bodyalpha != NULL ) delete bodyalpha ;
	if( gunalpha != NULL ) delete gunalpha ;
	
	bodyalpha = gunalpha = NULL ;
	
	return ;
}

// ̌n
void K7EnmAKN::AlphaEnd(void)
{
	if( mAlphaInitflag == false ) return ;
	
	if( bodyalpha != NULL ) delete bodyalpha ;
	if( gunalpha != NULL ) delete gunalpha ;
	
	bodyalpha = gunalpha = NULL ;
	
	mAlphaInitflag = false ;
	return ;
}

// l̕ύX
void K7EnmAKN::SetAlpha(bool disp, f32 speed)
{
	mHideflag = !disp ;
	mAlphaSpeed = speed ;
}

// ̃t[vZX
void K7EnmAKN::AlphaProc(void)
{
	Vec myPos;
	
	if ( mpNpcChara == NULL ) return ;
	
	mpNpcChara->GetPosition(myPos);
	
	// ʏ
	{
		mTargetAlpha = 1.0f - LgtDistRate();
		
		if( mTargetAlpha > mNowAlpha )
		{
			mNowAlpha += mAlphaSpeed ;
			if( mNowAlpha > mTargetAlpha ) mNowAlpha = mTargetAlpha ;
		}
		else
		{
			mNowAlpha -= mAlphaSpeed ;
			if( mNowAlpha < mTargetAlpha ) mNowAlpha = mTargetAlpha ;
		}

		if( mValidAlpha )
		{
			bodyalpha->SetVal( mNowAlpha ) ;
			gunalpha->SetVal( mNowAlpha ) ;
		}
		else
		{
			bodyalpha->SetVal( 1.0F ) ;
			gunalpha->SetVal( 1.0F ) ;
		}

		return ;
	}

	if( mHideflag == true )
	{
		if( mNowAlpha != 0.0F )
		{
			mNowAlpha -= mAlphaSpeed ;
			if( mNowAlpha < 0.0F ) mNowAlpha = 0.0F ;
			
			if( mValidAlpha )
			{
				bodyalpha->SetVal( mNowAlpha ) ;
				gunalpha->SetVal( mNowAlpha ) ;
			}
			else
			{
				bodyalpha->SetVal( 1.0F ) ;
				gunalpha->SetVal( 1.0F ) ;
			}
		}
	}
	else
	{
		if( mNowAlpha != 1.0F )
		{
			mNowAlpha += mAlphaSpeed ;
			if( mNowAlpha > 1.0F ) mNowAlpha = 1.0F ;
			
			if( mValidAlpha )
			{
				bodyalpha->SetVal( mNowAlpha ) ;
				gunalpha->SetVal( mNowAlpha ) ;
			}
			else
			{
				bodyalpha->SetVal( 1.0F ) ;
				gunalpha->SetVal( 1.0F ) ;
			}
		}
	}

	if( mNowAlpha == 0.0F && mValidAlpha == true )
	{
		Vec p = {0.0F,0.0F,0.0F} ;
		mpNpcChara->SetPosition( p ) ;
	}
}

WK7Model *K7EnmAKN::GetModel(void)
{
	WK7Chara		*pCharaTmp;
	
	pCharaTmp = pCurrentChara();
	
	if( pCharaTmp==NULL ) return NULL ;
	return pCharaTmp->GetModel() ;
}

/*
	
	
	AJl̏ݒ肷
	
	
	
*/
f32 K7EnmAKN::LgtDistRate(void)
{
	Vec *pPosTmp = AKN_LightPoint;
	Vec myPos;
	f32 min = 1000000.f;
	f32 Rate;
	int i;
	
	if ( mpNpcChara == NULL ) return 0.f;
	
	mpNpcChara->GetPosition(myPos);
	
	for(i=0; i<POSSORT_MAX; i++, pPosTmp++){			// ̓d̋o
		f32 dist;
		dist = GHM_VEC_GET_DIST(pPosTmp, &myPos);
		if ( dist < min ){
			min = dist;
		}
	}
	
	Rate = (LGT_DIST - min) / LGT_DIST;
	if ( Rate < 0.f ){
		Rate = 1.f;
	}else{
		Rate = 1.f - Rate;
	}
	
	return Rate;
}

/*
	
	
	AJlp̃_[WeXg
	
	
	
*/
bool K7EnmAKN::AknDamageTest(void)
{
	if ( mNowAlpha < AKN_MUTEKI_ALPHA ){
		return false;
	}
	if ( mMuteki > 0 ){
		return false;
	}
	return true;
}


/*
	
	
	AJlp[VĐ[`
	
	
	
*/
bool K7EnmAKN::PlayCommonMotionAKN(u32 id, bool loop, bool hokan, f32 sframe, f32 speed)
{
	if ((id == AKN_MOT_RUN)
	||	(id == AKN_MOT_SHOTDASHR)
	||	(id == AKN_MOT_SHOTDASHL)
	||	(id == AKN_MOT_DIE)
	){
		if ( mpNpcChara != NULL ){							// ̂̕vZ𖳌ɂ
			mpNpcChara->SetClothEnable(false);
		}
	}else{
		if ( mpNpcChara != NULL ){							// ̂̕vZLɂ
			mpNpcChara->SetClothEnable(true);
		}
	}
	
	return PlayCommonMotion(id, loop, hokan, sframe, speed);
}

