////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMANG_H__
#define	__ENMANG_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Fujita\c_state.h"
#include "..\Yam\YK7Effect.h"
#include "..\fujita\c_hole.h"

#define ANG (*K7EnmANG::GetInstance())

#define EXPLOSION_WAIT 30
#define FADE_WAIT 120
enum ANG_MOT{
  ANG_MOT_NEUTRAL = 0,
  ANG_MOT_DEAD,
  ANG_MOT_SIT,
  ANG_MOT_MAX
};
enum ANG_STATE{
  ANG_STATE_NEUTRAL,
  ANG_STATE_DAMAGE,
  ANG_STATE_DEAD,
  ANG_STATE_MAX
};
enum {
  ANG_MAX_HIT = 4
};
enum ANG_GAME_STATE{
  ANG_GAME_STATE0,	//HłقB
  ANG_GAME_STATE1,	//ĂقB
  ANG_GAME_STATE2	//ȂėǂB	
};

class K7EnmANG : public K7EnmBoss{
protected:
  static K7EnmANG *instance;
  s32 die_counter;
  EFFECT *yamada_effect[3];
  HSD_Fog *fog;
  WK7HitObjJObj *wing_hit_obj[ANG_MAX_HIT];
  bool wing_hit_flg[ANG_MAX_HIT];
  bool alive;
  C_State state;
  u32 mot_id;
  u32 hit_counter;
  ANG_GAME_STATE game_state;
  C_Hole *hole;
  u8 hole_alpha;
  void Dummy( void );
public:
  static K7EnmANG *GetInstance( void ){ return instance; }
  inline bool IsAlive( void ){	return alive;  }
  static inline bool IsExplode( void ){ 
	if( instance ) return (instance->die_counter > EXPLOSION_WAIT);
	else return false;
  }
  static inline bool IsFaded( void ){ 
	if( instance ) return (instance->die_counter > (EXPLOSION_WAIT + FADE_WAIT));
	else return false;
  }
  static void StopFeather( void ){
	if( instance ){
	for( int i=0; i<2; i++ ){
	  if( instance->yamada_effect[i] && GetEffectValidState( instance->yamada_effect[i] ) ) {
		::DelReqEffect( instance->yamada_effect[i] ) ;
		instance->yamada_effect[i] = 0;
	  }
	}
	}
  }
  inline ANG_STATE GetState( void ) { return (ANG_STATE)((s32)state);}
  void Disappear( void ){ 
	WK7Model *pModel = mpNpcChara->GetModel();
	if( pModel ){
	  mpNpcChara->SetVisible(false);
	  mHideAlphaNow       = 1.0f;
	  pModel->Hide();
	  mpNpcChara->SetRenderFlag(false);
	}
  }
  K7EnmANG(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO-2);
  virtual ~K7EnmANG();
  bool FrameProcess(void);
  bool ControlProcess(void);
  bool ControlProcess776( void );
  bool ControlProcess707( void );
  inline void SetGameState( ANG_GAME_STATE g_ ){ game_state = g_; }
  void AdditionalPreRenderProcess( void );
};

#endif	//__ENMANG_H__

