////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMBOSS_H__
#define	__ENMBOSS_H__

#include "..\Matsu\mK7Sound.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7HitObj.h"
#include "..\fujita\c_particle.h"

#define BOSS_MAX_GEN 64
class C_ParticleSystem{
 public:
  C_ParticleSystem( void ){
	for( int i=0; i<BOSS_MAX_GEN; i++ )  gen[i] = 0;
  }
  ~C_ParticleSystem( void ){
	for( int i=0; i<BOSS_MAX_GEN; i++ )  if( gen[i] ) delete gen[i];
  }
  
  bool GenParticle( s32 no, C_Vec &p, s32 idx=-1 ){
	if( idx >= 0 && idx < BOSS_MAX_GEN ){
	  if( gen[idx] ) delete gen[idx];
	  gen[idx] = new C_Generator( p, no );
	  gen[idx]->Fire();
	  return true;
	}else{
	  for( int i=0; i<BOSS_MAX_GEN; i++ ){
		if( !gen[i] ){
		  gen[i] = new C_Generator( p, no );
		  gen[i]->Fire();
		  return true;
		}else if( !gen[i]->IsAlive() ){
		  delete gen[i];
		  gen[i] = new C_Generator( p, no );
		  gen[i]->Fire();
		  return true;
		}
	  }
	}
	return false;
  }
 private:
  C_Generator *gen[BOSS_MAX_GEN];
  u8 is_started[BOSS_MAX_GEN];
};

class K7EnmBoss : public WK7Enemy{
protected:
  u32 chr_id;
  s16 *mot_tbl;
  s32 last_mot_no;
  static s32 common_state;
  virtual void CreatePackMotion(s16 *pTabelePtr, u32 motCodeId=0);
  void CopyPCPackMotion( u32 chr_id_ );
  s32 AddMotion( s16 *tbl_ );
  WK7HitObjJObj *CreateHitObj( char *name );
  //֎~.
  virtual void Dummy( void ) = 0;
public:
  
 	K7EnmBoss(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio, u32 _chr_id, s16 *_mot_tbl);
	virtual ~K7EnmBoss();
	void WeakPointEffectSet(char *pObjName);
	static s32 GetCommonState( void ){ return common_state; }
	static void SetCommonState( s32 cs_ ){ common_state = cs_; }
};

#endif	//__ENMANG_H__

