////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// Enmang.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMCUR_CPP__

#include "..\Matsu\mK7Sound.h"
#include "EnmCUR.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Yam\YK7EffectMuzzle.h"

#define EASY 0

#define PLAY_SHORT_SCREAM0() { \
  gpSound->mPlaySE( SFX_BOSS_CUR_DMG_A ); \
  gpSound->mPlaySE( SFX_BOSS_CUR_GUN_HIT ); \
} 
#define PLAY_SHORT_SCREAM1() { \
  gpSound->mPlaySE( SFX_BOSS_CUR_DMG_B ); \
  gpSound->mPlaySE( SFX_BOSS_CUR_GUN_HIT ); \
} 
#define PLAY_DEAD()	{ \
  gpSound->mPlaySE( SFX_BOSS_CUR_DIE ); \
  gpSound->mPlaySE( SFX_BOSS_CUR_GUN_HIT ); \
} 
#define PLAY_GET_READY()  gpSound->mPlaySE( SFX_BOSS_CUR_KAMAE )
#define PLAY_FIRE()	{ \
  gpSound->mPlaySE( SFX_BOSS_CUR_SYAGEKI ); \
  gpSound->mPlaySE( SFX_BOSS_CUR_VOICE_ATTACK ); \
} 

int K7EnmCUR::mCURBattleStart = 0;			// J[eBX{XJtO

K7EnmCUR *K7EnmCUR::instance = 0;
C_Vec K7EnmCUR::last_hit_pos;
s16 MotionIDTableCUR[] = {
  20,						//WAKE_NEUTRALB
  100,						//WAKE_TO_SHOTB
  102,						//SHOT_NEUTRALB
  103,						//SHOT_TO_WAKE
  110,						//SHOT_RELOADB
  150,						//SHOT_DAMAGEB
  310,						//WAKE_TO_DEADB
  600,						//SLEEP_TO_WAKEB
  610,						//WAKE_TO_SLEEP
  620,						//WAKE_SLEEP_NEUTRAL
  //0,							// ȂB
  0,						// _[WO
  0,						// _[W
  0,						// _[WEO
  0,						// _[WE
  0,						// _[WO
  0,						// _[W
  0,						// _[WEgO
  0,						// _[WEg
  0,						// _[WgO
  0,						// _[Wg
  0,						// _[WӂƂу_EOiSj
  0,						// _[Wу_EiSj
  0,						// _[WE _E
  0,						// _[W _E
  0,						// _ER
  0,						// _E_[W
  0,						// _EȂ
  0,						// _EȂ瑖
  0,						// _E85cmɍU
  0,						// _E150cmɍU
  -1
};

static GHMGCTASK_HANDLER( HitTask );
static GHMGCTASK_HANDLER( HitTask )
{
  bool *flg = (bool*)task_get_param(0);
  *flg = true;
  task_exit();
}
bool K7EnmCUR::IsMyRenderID( u32 id, Vec *p )
{
  if( p ) last_hit_pos.Set( p->x, p->y, p->z );
  if( !body_hit_obj || !head_hit_obj ) return false;
  if( body_hit_obj->GetRenderID() == id ) return true;
  if( head_hit_obj->GetRenderID() == id ) return true;

  return false;
}
void K7EnmCUR::Dummy( void )
{
}
K7EnmCUR::K7EnmCUR(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7CUR, MotionIDTableCUR )
{
  // Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// _
	mData.mVLossID		= -1;								// ʐѕ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	
  instance = this;

  state.Init( CUR_STATE_STILL );
  shot_times = 2;
  stage = 0;

  body_hit_obj = head_hit_obj = 0;
  body_hit = false;
  head_hit = false;
  game_over = false;
  hit_req = false;
  ppos_old.x = -9999.f;

  mirror = 0;
  mpGun[0] = mpGun[1] = (WK7Model*)-1;

  counter = 0;
  start = false;
  penalty = false;

  pc_hit_count = cur_hit_count = 0;
  gen = 0;
  own_pause = false;
  gun_load = false;
	K7EnmCUR::mCURBattleStart = 0;
}
K7EnmCUR::~K7EnmCUR()
{
  K7EnmCUR::mCURBattleStart = 0;
  instance = 0;
  if( mirror ) mirror->Release(mirror->GetName());
  GHM_SAFE_DELETE( body_hit_obj );
  GHM_SAFE_DELETE( head_hit_obj );
  GHM_SAFE_DELETE( gen );

  if ( mpGun[0] ){
	DetachGunModel((s8)GUN_BRWNGHP_R);
	mpGun[0] = (WK7Model *)0;
  }
  if ( mpGun[1] ){
	DetachGunModel((s8)GUN_BRWNGHP_L);
	mpGun[1] = (WK7Model *)0;
  }
  ReleaseGunArchive(GUN_BRWNGHP_R);
  ReleaseGunArchive(GUN_BRWNGHP_L);
}
bool K7EnmCUR::ControlProcess(void)
{
  if( mState==NPC_STATE_INIT ){ return WK7Npc::ControlProcess(); }
//  if( GetNpcPause()==true ){ return true; }
	
#define MOTION_END( ) (GetCommonMotionState() == WK7MODEL_NOANIM)
#define MOTION_REWIND(  ) (GetCommonMotionState() == AOBJ_ANIM_REWINDED)
#define IS_MOTION( Y ) ((u32)(mot_id == Y))
#define PLAY( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, false )
#define PLAY_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, true )
#define PLAY_LOOP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, false )
#define PLAY_LOOP_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, true )
#define PERCENT( X ) ((HSD_Rand()%101) > (100-X) )
#define MOT_FRAME( ) (  mpRootBone ? mpRootBone->GetCurrentMotionFrame() : 0 ) 

	WK7Model *pModel;
	
	if( (pModel = mpNpcChara->GetModel())==NULL ) return true;
	if ( mpNpcChara==NULL ) return true;
#if 1
	if ( gun_load == false ){
		if( mpNpcChara->GetModel() ){
			if( (mpGun[0] == (WK7Model*)-1) && (mpGun[0] == (WK7Model*)-1) ){
				LoadGunArchive((s8)GUN_BRWNGHP_R);
				LoadGunArchive((s8)GUN_BRWNGHP_L);
				mpGun[0] = mpGun[1] = 0;
			}else{
				if(	(true == CheckGunArchiveLoad((s8)GUN_BRWNGHP_R))
				||	(true == CheckGunArchiveLoad((s8)GUN_BRWNGHP_L))
					// ǂݍݒ
				){
					
				}else{
					// ǂݍ݊
					// nCf̏eɃA^b`
					mpGun[0] = AttachGunModel(	(s8)GUN_BRWNGHP_R,
						NULL,												// NULL I[gŃA^b`
						mpNpcChara->GetModel(),
						GUN_HAND_R											// E肩肩
					);
					
					mpGun[1] = AttachGunModel(	(s8)GUN_BRWNGHP_L,
						NULL,												// NULL I[gŃA^b`
						mpNpcChara->GetModel(),
						GUN_HAND_L											// E肩肩
					);
					gun_load = true;
				}
			}
		}
		return true;
  	}
#else
  if ( (mState == NPC_STATE_INIT) && (true == gun_load) ){  
	//G̈ʒuƁAZbgB
	StateInit(); 
	return true;
  }
#endif
	if( false == gun_load ) return true;								// e̓ǂݍݏIĂȂ
	if( !mFirstPosSet ) return true;									// |WV܂ĂȂ
	
	K7EnmCUR::mCURBattleStart = 1;										// J[eBXJn
	
	if( own_pause || GetNpcPause() ) return true;						// |[YĂ
	Vec ppos;

	
	WK7PLAYERCONTROL->GetPosition( &ppos );
	mTargetRotY = atan2f((f32 )ppos.x - mPosition.x, (f32 )ppos.z - mPosition.z);
	if ( NULL != WK7PLAYERCONTROL->GetWaistObjPtr() ) {
		WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(ppos);
	}

  {//~[Zbg
#if 0
	if( stage==0 ){
	  if( WK7Stage::GetCurrentStage() ){
		stage = WK7Stage::GetCurrentStage();
		HSD_PEDesc		vfx_pe = {
		  ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
		  0,0,
		  255,
		  GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
		  GX_LEQUAL,
		  GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
		};
		stage->AllocRenderID(true, WK7RENDEROBJ_RENDERID_HALF);
		stage->GetJObj("Mizu00")->SetPE( &vfx_pe );
		stage->GetJObj("Mizu00")->SetDstAlpha( stage->ConvRenderIDToAlpha( stage->GetRenderID() ) );
		mirror = WK7Mirror::Create( stage->GetJObj("Mizu00"),stage->GetJObj("locator1"));
		mirror->AddReflectJObj( mpRootBone );
	  }else{
		return true;
	  }
	}
#endif
  }

  f32 rot_div = 1.f;
  do{
	switch( (s32)state ){
	case CUR_STATE_STILL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_WAKE_NEUTRAL );
		  penalty = false;
		  start = false;
		}break;
		case PHASE_PROC:{
		  if( start ){
			state = CUR_STATE_STILL_TO_SHOT;
		  }else if( penalty ){
			state = CUR_STATE_SHOT;
		  }
		}break;
		case PHASE_DTOR:{
		  penalty = false;
		  start = false;
		}break;
		}
	  }break;
	case CUR_STATE_STILL_TO_SHOT:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_WAKE_TO_SHOT );
		  f32 rate0[]={1.f, 1.3f, 1.64f, 1.69f};
		  f32 rate1[]={1.f, 1.1f, 1.3f, 1.5f};
		  f32 *rate;
		  if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			rate = rate1;
		  }else{
			rate = rate0;
		  }
		  if( cur_hit_count<4 && cur_hit_count>=0) 
			mpNpcChara->GetModel()->SetMotionRate(rate[cur_hit_count]);
		}break;
		case PHASE_PROC:{
		  if( MOTION_END() ) state = CUR_STATE_SHOT;
		  else if( body_hit || head_hit ){
			if( cur_hit_count == 3 ){
			  state = CUR_STATE_DEAD;
			}else{
			  state = CUR_STATE_DAMAGE;
			}
		  }
		  if( state.GetPhaseCounter() == 10 ) PLAY_GET_READY();
		}break;
		case PHASE_DTOR:{
		  mpNpcChara->GetModel()->SetMotionRate(1.f);
		}break;
		}
	  }break;
	case CUR_STATE_SHOT:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_SHOT_NEUTRAL );
		}break;
		case PHASE_PROC:{
		  if( MOTION_END() ) state = CUR_STATE_SHOT_TO_STILL;
		  else{
			if( state.GetPhaseCounter() == 0 ) {
			  PLAY_FIRE();
			  CreateMuzzleEffect( GUN_BRWNGHP_R, -82.f );
			  CreateMuzzleEffect( GUN_BRWNGHP_L, -82.f );
			}

			if( state.GetOldStatus() != CUR_STATE_STILL_TO_SHOT ){
			  //yieBVbg̎͏xă_[WB
			  if( state.GetPhaseCounter() == 15 ) hit_req = true;
			}else{
			  if( state.GetPhaseCounter() == 0 ) hit_req = true;
			}
		  }
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case CUR_STATE_SHOT_TO_STILL:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_SHOT_TO_WAKE );
		}break;
		case PHASE_PROC:{
		  if( MOTION_END() ) state = CUR_STATE_STILL;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case CUR_STATE_DAMAGE:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_SHOT_DAMAGE );
		  gen->Fire();
		  if( state.GetPhaseCounter() & 0x1 ){
			PLAY_SHORT_SCREAM0();
		  }else{
			PLAY_SHORT_SCREAM1();
		  }
		}break;
		case PHASE_PROC:{
		  if( IS_MOTION( CUR_MOT_SHOT_DAMAGE ) &&  MOTION_END() ){
			PLAY( CUR_MOT_SHOT_TO_WAKE );
		  }else if( IS_MOTION( CUR_MOT_SHOT_TO_WAKE ) &&  MOTION_END() ){
			state = CUR_STATE_STILL;
		  }
		}break;
		case PHASE_DTOR:{
		  ++cur_hit_count;
		}break;
		}
	  }break;
	case CUR_STATE_DEAD:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  PLAY( CUR_MOT_WAKE_TO_DEAD );
		  PLAY_DEAD();
		  gen->Fire();
		}break;
		case PHASE_PROC:{
		  if( state.GetPhaseCounter() > 30 ) state = CUR_STATE_GAMEOVER;
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	case CUR_STATE_GAMEOVER:
	  {
		switch( state.GetPhase() ){
		case PHASE_CTOR:{
		  game_over = true;
		}break;
		case PHASE_PROC:{
		}break;
		case PHASE_DTOR:{
		}break;
		}
	  }break;
	default:
	  break;
	}

  }while( !state.Proc() );
  mpNpcChara->SetPosition(mPosition);
  mpNpcChara->SetRotY(mTargetRotY);
  SetRotCalc( rot_div );

  if( body_hit_obj ) body_hit_obj->SetEnable( true );
  if( head_hit_obj ) head_hit_obj->SetEnable( true );
  body_hit = head_hit = false;
  ppos_old = ppos;
  return false;
}
WK7JObj *K7EnmCUR::GetRShoulder(void)
{
  return mpNpcChara->GetJObj("HumerusL_joint2");
  //return mpNpcChara->GetJObj("WristR_joint");
}
bool K7EnmCUR::FrameProcess(void)
{
//  if( own_pause || GetNpcPause() ) return true;
  if( own_pause ) return true;
  ++counter;

  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  if( hit_req ){
		C_Vec tgt;
		WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(tgt);
#if !EASY
		if( ++pc_hit_count >= 4 )
		  WK7PLAYERCONTROL->SetPcDamage(ppos_old, (s16)1000, 0);
		else
		  WK7PLAYERCONTROL->SetPcDamage(ppos_old, 0, 0);
#endif
		hit_req = false;
	  }
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
		mFirstPosSet = 1;
		//WvB
		mpNpcChara->SetPosition(mPosition);
		mpNpcChara->SetRotY(mTargetRotY);
		WK7Model *pModel;
		if( (pModel = mpNpcChara->GetModel())!=NULL ){
		  mpNpcChara->SetRenderFlag(true);
		  pModel->Disp();
		}

		mpNpcChara->mpAdditionalPostRender = this;

		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  //mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}

#if 1
		//Vec pos;
		//HSD_JObjGetTranslate( mpNpcChara->GetJObj("Neck_joint")->GetJObj(), &pos );
		gen = new C_Generator( mpNpcChara->GetJObj("Neck_joint")->GetJObj(), 12 );
		body_hit_obj = CreateHitObj( "Cur_Body" );
		body_hit_obj->SetTaskHandler(HitTask);
		body_hit_obj->SetTaskParam(0,(u32)&body_hit);
		head_hit_obj = CreateHitObj( "Cur_Head1" );
		head_hit_obj->SetTaskHandler(HitTask);
		head_hit_obj->SetTaskParam(0,(u32)&head_hit);
#else
		body_hit_obj = CreateHitObj( "zipper" );
		body_hit_obj->SetTaskHandler(HitTask);
		body_hit_obj->SetTaskParam(0,(u32)&body_hit);
#endif
	  }
	}
  }
	
  return true;
}
