////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMCUR_H__
#define	__ENMCUR_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Model.h"
#include "..\Wat\WK7Stage.h"
#include "..\Yam\YK7EffectShot.h"

#include "..\Wat\WK7Enemy.h"
#include "..\Wat\WK7Mirror.h"
#include "EnmBoss.h"
#include "..\Yam\YK7Effect.h"
#include "..\Fujita\c_state.h"
#include "..\fujita\c_radialblur.h"
#define CUR (*K7EnmCUR::GetInstance())

enum CUR_MOT{
  CUR_MOT_WAKE_NEUTRAL = 0,
  CUR_MOT_WAKE_TO_SHOT,
  CUR_MOT_SHOT_NEUTRAL,
  CUR_MOT_SHOT_TO_WAKE,
  CUR_MOT_SHOT_RELOAD,
  CUR_MOT_SHOT_DAMAGE,
  CUR_MOT_WAKE_TO_DEAD,
  CUR_MOT_SLEEP_TO_WAKE,
  CUR_MOT_WAKE_TO_SLEEP,
  CUR_MOT_SLEEP_NEUTRAL,
  CUR_MOT_MAX
};
enum CUR_STATE{
  CUR_STATE_STILL = 0,
  CUR_STATE_STILL_TO_SHOT,
  CUR_STATE_SHOT,
  CUR_STATE_SHOT_TO_STILL,
  CUR_STATE_DAMAGE,
  CUR_STATE_DEAD,
  CUR_STATE_GAMEOVER,
  CUR_STATE_MAX
};
enum {
  CUR_HIT_MAX = 2
};
class K7EnmCUR : public K7EnmBoss{
 private:
  static K7EnmCUR *instance;
  u32 mot_id;
  u32 hp;
  u32 shot_times;
  C_State state;
  WK7Mirror *mirror;
  WK7Stage *stage;
  WK7HitObjJObj *body_hit_obj,*head_hit_obj;
  bool body_hit,head_hit;
  bool game_over;
  s32 counter;
  static C_Vec last_hit_pos;
  Vec ppos_old;
  bool hit_req;
  WK7Model 	*mpGun[2];					// ef
  bool start,penalty,own_pause;
  s32 pc_hit_count,cur_hit_count;
  C_Generator *gen;
  bool gun_load;
 protected:
  void Dummy( void );
 public:
  K7EnmCUR(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
  ~K7EnmCUR();
  static K7EnmCUR *GetInstance( void ){ return instance; }
  virtual bool IsMyRenderID( u32 id, Vec *p );
  bool IsGameOver( void ){ return game_over; }
  Vec &GetPosition( void ){ return mPosition; }
  CUR_STATE GetState( void ){ return (CUR_STATE)((s32)state);}
  bool FrameProcess(void);
  bool ControlProcess(void);
  void SetStart( void ){ start = true; }
  void SetPenalty( void ){ penalty = true; }
  void SetOwnPause( bool f_ ){ 
	if( own_pause != f_ ){
	  WK7Model *pModel;
	  if( f_ ){
		if( mpNpcChara && (pModel = mpNpcChara->GetModel())!=NULL ) pModel->StopMotionAll();
	  }else{
		if( mpNpcChara && (pModel = mpNpcChara->GetModel())!=NULL ) pModel->ReplayMotionAll();
	  }
	  own_pause = f_;
	}
  }
  s32 GetPCHit( void ){ return pc_hit_count; }
  s32 GetNPCHit( void ){ return cur_hit_count; }
  WK7JObj *GetRShoulder( void );
public:
  	static	int	mCURBattleStart;

};

#endif	//__ENMANG_H__

