////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmDE2.cpp {X f|[
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMDE2_CPP__

#include "EnmDE2.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Stage\01\01\K7Stage136M00.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Panel\SK7PanelElevator.h"
#include "..\Panel\SK7PanelElevator2.h"
#include "..\Yam\YK7EffectMuzzle.h"
#include "..\..\..\Scn\K7Scn01.h"

#define SECOND_SHOT_FRAME		(10)


// 퓬ł̗L͈
#define AREA_Z_MIN		(-118.449f)
#define AREA_Z_MAX		(-80.901f)


int K7EnmDE2::mDE2BattleStart = 0;			// f|[{XJtO

#define SFX_BT_HS_DE2UGI_MAX	(4)
static int damageSeTbl[SFX_BT_HS_DE2UGI_MAX] = {
	SFX_BOSS_DE2_GRUNTS0,
	SFX_BOSS_DE2_GRUNTS1,
	SFX_BOSS_DE2_GRUNTS2,
	SFX_BOSS_DE2_GRUNTS3
};

void K7EnmDE2::Dummy( void )
{
}


K7EnmDE2::K7EnmDE2(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7DE2, MotionIDTableDE2)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 0;								// goiQƂĂȂ̂łӁj
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// XP[
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mInitProcess		= 0;
	mpGun[0]			= (WK7Model *) NULL;
	mpGun[1]			= (WK7Model *) NULL;
	
	mBulletNow			= DE2_GUN_BULLET_MAX;
	K7EnmDE2::mDE2BattleStart = 0;
	
	mBattleCount		= WK7_SEC_TO_FRAME(30);
	mBatteleExit		= 0;
	mBattleProcess		= 0;
	
	mMoveProcess		= LOGIC_INIT;								// svZX̎w
	
	mSetRunDist			= 0.f;
	mFinalAtk			= 0;
	
//	mMotID				= DE2_MOT_WAIT;
//	mState.Init( KIB_KRR_COMMON_ATK0 );
}
K7EnmDE2::~K7EnmDE2()
{
	Release();
	 WK7RenderObj::SetVfxFlag( true );
}

void K7EnmDE2::Release(void)
{
	gpSound->mReleaseSsm( "seBossDe2.ssm" );
	DetachGun();
	ReleaseModel    ();
	ReleaseMotionAll();
}
void K7EnmDE2::DetachGun(void)
{
	if ( mpGun[0] ){
		DetachGunModel((s8)GUN_R);
		mpGun[0] = (WK7Model *)0;
	}
	if ( mpGun[1] ){
		DetachGunModel((s8)GUN_L);
		mpGun[1] = (WK7Model *)0;
	}
	ReleaseGunArchive(GUN_R);
	ReleaseGunArchive(GUN_L);
}


bool K7EnmDE2::ControlProcess(void)
{
	Vec enePos;
	Vec myPos;
//	f32 dam;
//	int weakhit;

	if ( mpNpcChara==NULL ) 		return true;
	if ( true == IsLoading() ) 		return true;											// ǂݍݒ
	if ( mState == NPC_STATE_INIT )	goto NPC_CTRL_INIT_JUMP;
	
	if( true == GetNpcPause() ) 	return true;											// |[YȎ
	
	mpNpcChara->GetPosition(myPos);
	
	// _[W炢`FbN
#ifdef _DEBUG
//	if( HSD_PadGetButton(1) & HSD_PAD_A ){
//		goto COMPEL_DMG_JUMP;
//	}
#endif
	
	if ( mData.mHp == 0 ){
		DieMotSet();
	}else{
		
		if ((true == DamageTest())
		&&	(mState != NPC_STATE_DMG)								// AȂ
		){
COMPEL_DMG_JUMP:
		// GȃXe[^X
			if ( mState == NPC_STATE_ACTION ){
				mDamage.mDamHitRequest = 0;
				
			}else{
				DE2_Avoid(AvoidSideGet());
				mDamage.mDamHitRequest = 0;
			}
	//		Cmd_ResetSet();
		}
	}
	
	if ( mBattleCount ){
		mBattleCount--;
	}
	
	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		switch (mInitProcess){
		case 0:
			if ( true == StateInit() ){						// ̒mStateςꂿႤ̂
				mState = NPC_STATE_INIT;
				mInitProcess++;
			}
			break;
		case 1:
			// ẽ[hĩ^C~OŃR[)
			if ( -1 == LoadGunArchive((s8)GUN_L) ) break;
			if ( -1 == LoadGunArchive((s8)GUN_R) ) break;
			
															// f|[pSEf[^̓ǂݍ
			gpSound->mReadSsm( "seBossDe2.ssm", eBankBoss );
			
			// _ݒij
			WeakPointEffectSet( K7CHRBONE_SKULL );
			
			mInitProcess++;
			break;
		case 2:
			if ( true == CheckGunArchiveLoad((s8)GUN_L) ) break;
			if ( true == CheckGunArchiveLoad((s8)GUN_R) ) break;
			// nCf̏eɃA^b`
			mpGun[0] = AttachGunModel(	(s8)GUN_R,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_R											// E肩肩
			);
			mpGun[1] = AttachGunModel(	(s8)GUN_L,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_L											// E肩肩
			);
			
			mInitProcess++;
			break;
		case 3:
			if( false == MotSet_Wait(false) ) break;
			mInitProcess++;
			mState = NPC_STATE_WAIT;
			
			break;
		}
		break;
	case NPC_STATE_WAIT:
		
		if ( 1 == K7EnmDE2::mDE2BattleStart ){
			f32 dist;
			
			switch ( mMoveProcess ){
			case LOGIC_WAIT:
				// Ȑ
				if ( true == MotStatus_Wait() ) break;
				break;
			case LOGIC_MOVE:
				if ( 0 == mBattleCount ){
					// ꖽ߁I
//					switch(rand()%4){
//					case 0:
//						dist = 33.f;
//						break;
//					case 1:
//						dist = 36.f;
//						break;
//					case 2:
//						dist = 39.f;
//						break;
//					default:
						dist = 42.f;
//						break;
//					}
					Cmd_RunSet(dist);
					break;
				}
			}
		}
		break;
	case NPC_STATE_RUN:
		DE2_Run();
		break;
	case NPC_STATE_SHOTPOSE:											// \Jn
		DE2Status_ShotPose();
		break;
	case NPC_STATE_SHOTFREE:											// ˌ\[v
		// \炷Aˌ[VĐ
		switch ( mMoveProcess ){
		case LOGIC_WAIT:
			// ˌȐ
			if ( mFinalAtk ){
				// ꒆłȂ΍Ăюˌ
				LogicSet(LOGIC_MOVE, 0);
				goto ATK_RETRY;
			}
			
			if ( !mBattleCount ){
				if ((PC_STATE_DMG != WK7PLAYERCONTROL->GetPcState()) && (mBulletNow > 0)){
					// ꒆłȂ΍Ăюˌ
					LogicSet(LOGIC_MOVE, 0);
					goto ATK_RETRY;
					
				}
				
				if ( mBulletNow <= 0 ) {
					// ʖ
					DE2_ShotReload();
				}else{
					// lĂȂiˌőҋ@j
					// ˌ\OiĂщ]j
					DE2_Avoid(AvoidSideGet());
		//			Cmd_ResetSet();
		//			DE2Status_ShotPose();
				}
				
			}else{
				DE2_Avoid(AvoidSideGet());
			}
			
			break;	
		case LOGIC_MOVE:
ATK_RETRY:
			if ( -1 ==  AvoidSideTest() ){
				// ˌ\iˌj
				if ( DE2_MOT_SHOTNOW != mMotID ){
					// ˌ[V
					SetRotCalc(1.f);
					MotPlayInit(NPC_POSMODE_PROG);
					if ( false == PlayCommonMotion(DE2_MOT_SHOTNOW, false, true, 0.f) ){
						break;
					}
					mSecondShotTiming = 0;
					mBulletNow -= 1;
					mState = NPC_STATE_SHOTNOW;
					PcDamageSet(0);
				}
			}else{
				// ˌ\OiĂщ]j
				DE2_Avoid(AvoidSideGet());
			}
			break;
		}
		break;
	case NPC_STATE_SHOTNOW:												// ˌ
		mSecondShotTiming++;
		if ( SECOND_SHOT_FRAME == mSecondShotTiming ){
			// lɃ_[W^
//			mBulletNow-=1;
			PcDamageSet(1);
		}
		
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			
			DE2_ShotFree();
			
			// Ƃ肠lq
			LogicSet(LOGIC_WAIT, 0);
			
			// ҋ@Ԃ
			mBattleCount = (u32 )(WK7_SEC_TO_FRAME(1) + rand()%WK7_SEC_TO_FRAME(2));
			
		}
		break;
	case NPC_STATE_SHOTWAIT:											// ˌ߂蒆
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			// Ȑ
			if ( true == MotStatus_Wait() ) break;
		}
		break;
	case NPC_STATE_RELOAD:												// [h
		if ( true == DE2_Status_Reload() ) break;
		break;
	case NPC_STATE_DMG:
		// _[W
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			
			// \Ȃ
			MotSet_ShotPose(1.f, DE2_MOT_SHOTPOSE);
			
		}
		break;
	case NPC_STATE_ACTION:
		// ]
		DE2Status_Avoid();
		break;
	case NPC_STATE_DIE:
		
		if ( pCurrentChara() != NULL ){
			pCurrentChara()->GetPosition(enePos);
			if( 54 == GetCurrentMotionFrame() ){
				gpSound->mPlaySE3D(SFX_BOSS_DE2_DOWNHIZA, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
			}
			if( 158 == GetCurrentMotionFrame() ){
				// ˌ(Epj
				
				{
					// ̏oꏊ쐬
					WK7Model	*pModel;
					WK7JObj 	*pHeadObj;
					Vec HeadPos, shotDir;
					
					if( NULL!=pCurrentChara() ){
						if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
							pHeadObj = pModel->GetObj(K7CHRBONE_SKULL);
							if ( pHeadObj != NULL ){
								pHeadObj->GetWorldPosition(&HeadPos);
								
								shotDir.x = 1.4f;
								shotDir.y = GetRotY();
								shotDir.z = 0.f;
								
								KK7BattleDefaultBloodStart(	HeadPos,
															0.f,
															shotDir,
															pHeadObj
								);
								
							}
						}
					}
				}
				CreateMuzzleEffect( GUN_L, enePos.y );
				CreateMuzzleEffect( GUN_R, enePos.y );
			}
			if( 160 == GetCurrentMotionFrame() ){
				// f|[SSE
				gpSound->mPlaySE(SFX_BOSS_DE2_DIE, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env );
			}
			if( 222 == GetCurrentMotionFrame() ){
				gpSound->mPlaySE3D(SFX_BOSS_DE2_DOWNDIE, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
			}
		}
		
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			ReleaseWeakPoint();
			mState = NPC_STATE_LOSS;
		}
		
		break;
	case NPC_STATE_LOSS:
		break;
	}
	return false;
}


/*
	
	S[VZbg
	
*/
void K7EnmDE2::DieMotSet(void)
{
	if ( mState != NPC_STATE_DIE ){
		
//		MotPlayInit(NPC_POSMODE_DATA);
		WaistToRoot();
		if ( false == PlayCommonMotion(DE2_MOT_DIE, false, true, 0.f) ){
			
		}
		mData.mHp = -1;
		
		mState = NPC_STATE_DIE;
	}
}




/*
	
	
	߁FʒuZbg
	
	
*/
void K7EnmDE2::Cmd_ResetSet(void)
{
	MotStatus_Wait();
	SetPosition(mStartPos);
	mState = NPC_STATE_WAIT;
}


/*
	
	
	߁F
	
	
*/
void K7EnmDE2::Cmd_RunSet(f32 dist)
{
	mState		= NPC_STATE_RUN;
	mSetRunDist	= dist;
}


/*
	
	
	胂[VZbg
	
	NPC_STATE_RUN
	
*/
bool K7EnmDE2::DE2_Run(void)
{
	Vec	enePos;
	f32	runDist;

	// ~ĂƂɎl̈ʒu
	mpNpcChara->GetPosition(enePos);							// ݒn̎擾
	
	// rdĐ
	if(	mpNpcChara!=NULL ){
		WK7Model *pModel = mpNpcChara->GetModel();
		if ((16 == pModel->GetCurrentMotionFrame())
		||	(34 == pModel->GetCurrentMotionFrame())
		){
//			gpSound->mPlaySE3D(SFX_BOSS_DE2_RELOAD, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
		}
	}
	
	// 胂[V̍Đ
	if ( mMotID != DE2_MOT_RUN ){
		MotPlayInit(NPC_POSMODE_PROG);
		if( false == PlayCommonMotion(DE2_MOT_RUN, true, true, 0.f) ){
			return false;
		}
	}
	
	// ړ
	enePos.x += (RUN_SPEED * 1.f) * sinf(mRotY);
	enePos.z += (RUN_SPEED * 1.f) * cosf(mRotY);
	
	SetPosition(enePos);
	
	// ̌vZ
	runDist = GHM_VEC_GET_DIST(&mStartPos, &enePos);
	
	if ( runDist >= mSetRunDist ){
		MotSet_ShotPose(1.f, DE2_MOT_SHOTPOSE);
		return true;
	}
	return false;
}

/*
	
	
	oWbN
	
	
*/
void K7EnmDE2::LogicSet(u32 process, u32 time)
{
	mMoveProcess = process;									// f|[ړJn
	mBattleCount = time;
}


bool K7EnmDE2::FrameProcess(void)
{
	MotionProcess();
	if( mpNpcChara!=NULL ){
		
		if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
#if FUJITA //030702
			//_B
			{
				Vec eye;
				WK7CAM->GetPosition( eye );
				
				//_JOBJAJɂ炷ʁB
				//f32 dist = 5.f;
				f32 dist = -5.f;
				
				//_̏B
				PlayWeakPoint( eye, dist );
			}
#endif
			// XLjORg[
//			ScanContorol();
			
			// B鏈Rg[
//			HideContorol();
			
			// [VXs[hRg[
			MotionSpeedControl();
			
			// ŏ̈ʒuZbg̎
			if( !mFirstPosSet ){
				WK7Model *pModel;
				
				mFirstPosSet = 1;
				mpNpcChara->SetPosition(mPosition);
				mpNpcChara->SetRotY(mTargetRotY);
				
				// X^[gʒu̕ۑ
				mStartPos = mPosition;
				
				SetVisible(true);
				
				if( (pModel = mpNpcChara->GetModel())!=NULL ){
					mpNpcChara->SetRenderFlag(true);
					pModel->Disp();
				}
				
				// _[iqbg̃sbN̂߂ɂKvsj
				switch( mpNpcChara->GetRenderID() ){
				case	WK7RENDEROBJ_INVALID_RENDERID:
//				case	WK7RENDEROBJ_RENDERID_MAX:
				case	WK7RENDEROBJ_RENDERID_DEFAULT:
					mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
					mpNpcChara->EnableVfxEffect();
					break;
				default:
					break;
				}
			}

// Rc
#if 0			
			// nCfȅ
			{
				int i;
				for (i=0; i<2; i++){
					if ( NULL != mpGun[i] ){
						mpGun[i]->FrameProcess();
					}
				}
			}
			
			// nCfe̕`揈
			{
				int i;
				for (i=0; i<2; i++){
					if ( NULL != mpGun[i] ){
						mpGun[i]->RenderProcess();
					}
				}
			}
#endif
		}
	
//		VisibleTest();
	}
	return true;
}

/*
	
	
	f|[{XĎ֐
	
	
*/
void K7EnmDE2::StageProc(WK7Stage *pCurrentStage)
{
	static WK7JObj *pJObj;
	static int exitMode;
	K7Stage136M00 *pStage = (K7Stage136M00 *)pCurrentStage;
	
	switch (mBattleProcess){
	case 0:							// ҋ@
		if ( 1 == K7EnmDE2::mDE2BattleStart ){
			
			//@퓬ȊJnI
			gpSound->mPlayStreamNo(HPS_BOSS_DEP);
			
			WK7PLAYERCONTROL->SetOperateEnable(true);
			LogicSet(LOGIC_MOVE, 0);
			mBattleProcess = 1;
			
			/// LA
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
		}
		break;
	case 1:							// 퓬
		if ( PC_STATE_LOSS == WK7PLAYERCONTROL->GetPcState() ){			// lŏI
				mBattleProcess=2000;
				exitMode = -1;
		}else{
			if (mState == NPC_STATE_LOSS ){								// f|[ŏI
				mBattleProcess=1000;
				exitMode = 1;
			}
		}
		break;
	case 1000:
		// 퓬ȏIi̋Ȃɕςj
		gpSound->mPlayStreamNo(HPS_KRAKUJITU_F);
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_DE2_END);
		
//		Release();
		
		SetEnemyDieInfo(NPC_DIE_DIE, true);									// 񂾏Zbg
		
		mBatteleExit = exitMode;
		WK7PLAYERCONTROL->BattlePadRegulationSet();
		K7EnmDE2::mDE2BattleStart = 0;
		break;
	case 2000:
		// ŏɉƂ͂
		gpSound->mStopStream();											// 퓬ȏI
		WK7PLAYERCONTROL->BattlePadRegulationSet();
		mBatteleExit = exitMode;
		break;
	default:
		break;
	}
}





/*
	
	
	[V
	
	
	<in>
	0			R
	1			L
	
*/
bool K7EnmDE2::DE2_Avoid(int side)
{
	u32 setMotID;
	f32 Speed = 1.f;

	// w
	SetTargetRotY(RotRevision(), true);
	
	MotPlayInit(NPC_POSMODE_DATA);
	if ( side ){
		setMotID = DE2_MOT_L_ROLL;
	}else{
		setMotID = DE2_MOT_R_ROLL;
	}
	
	if ( false == PlayCommonMotion(setMotID, false, true, 0.f, Speed) ){
		return false;
	}
	
	if ( pCurrentChara() != NULL ){
		Vec enePos;
		
		pCurrentChara()->GetPosition(enePos);
		gpSound->mPlaySE3D(SFX_BOSS_DE2_DENGURI, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
	}
	
	mState = NPC_STATE_ACTION;
	return true;
}

/*
	
	
	[V
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmDE2::DE2Status_Avoid(void)
{
	
	if ( pCurrentChara() != NULL ){
		if( 20 == GetCurrentMotionFrame() ){
			Vec eneWasitPos;
			Vec Dir = {0.f, 0.f, 0.f};
			
			if ( mMotID == DE2_MOT_R_ROLL ){
				Dir.y = -3.14f;
			}else{
				Dir.y = 0.f;
			}
			GetWaistPosition(&eneWasitPos);
			KK7FootSmokeEffect(eneWasitPos, Dir);
		}
	}
	
	// I
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		// I
		if ( false == DE2_ShotFree() ) return false;
		return true;
	}
	return false;
}



/*
	
	
	
	
	
	<return>
	0			R
	1			L
	
*/
int K7EnmDE2::AvoidSideGet(void)
{
	int side;
	side = AvoidSideTest();
	if ( -1 == side ){
		side = rand()%2;
	}
	return side;
}


/*
	
	
	
	
	
	<return>
	0			R
	1			L
	
*/
int K7EnmDE2::AvoidSideTest(void)
{
	Vec myPos;
	int side;
	
	GetPosition(myPos);
	
	if ( myPos.z <= AREA_Z_MIN ){
		side = 1;
	}else{
		if ( myPos.z >= AREA_Z_MAX ){
			side = 0;
		}else{
			// _
			side = -1;
		}
	}
	
	return side;
}




/*
	
	
	ˌ[VR
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmDE2::DE2_ShotFree(void)
{
	MotPlayInit(NPC_POSMODE_PROG);
	if ( false == PlayCommonMotion(DE2_MOT_SHOTFREE, true, false, 0.f) ){
		return false;
	}
	mState = NPC_STATE_SHOTFREE;
	return true;
}


/*
	
	
	ˌ\[V
	
	
*/
bool K7EnmDE2::DE2Status_ShotPose(void)
{
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		// \[vĐ
		MotPlayInit(NPC_POSMODE_PROG);
		if ( false == PlayCommonMotion(DE2_MOT_SHOTFREE, true, false, 0.f) ){
			return false;
		}
		mState = NPC_STATE_SHOTFREE;
		return true;
	}
	return false;
}



/*
	
	
	ˌ߂胂[VĐ
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmDE2::DE2_ShotWait(void)
{
	MotPlayInit(NPC_POSMODE_PROG);
	if ( false == PlayCommonMotion(DE2_MOT_SHOTWAIT, false, false, 0.f) ){
		return false;
	}
	mState = NPC_STATE_SHOTWAIT;
	return true;
}


/*
	
	
	[hĐ
	
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmDE2::DE2_ShotReload(void)
{
	MotPlayInit(NPC_POSMODE_PROG);
	if ( false == PlayCommonMotion(DE2_MOT_RELOAD, false, false, 0.f) ){
		return false;
	}
	
	if ( pCurrentChara() != NULL ){
		Vec enePos;
		
		pCurrentChara()->GetPosition(enePos);
		gpSound->mPlaySE3D(SFX_BOSS_DE2_RELOAD, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ
	}
	
	mState = NPC_STATE_RELOAD;
	return true;
}
bool K7EnmDE2::DE2_Status_Reload(void)
{
	// I
	if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
		
		mBulletNow			= DE2_GUN_BULLET_MAX;
		
		// I
		if ( false == DE2_ShotFree() ) return false;
		return true;
	}
	return false;
}


/*
	
	
	f|[Appx␳
	
	
	
*/
f32 K7EnmDE2::RotRevision(void)
{
	f32 myRotY;

	myRotY = GetRotY();
	if ( fabsf(myRotY) <= (PI/2) )		myRotY = 0.f;
	else								myRotY = PI;
	
	return myRotY;
}


/*
	
	
	lɃ_[Wݒ肷B
	
	
*/
void K7EnmDE2::PcDamageSet(int side)
{
	Vec myPos;
	
	mpNpcChara->GetPosition(myPos);
	if ( 0 == side ){
		CreateMuzzleEffect( GUN_L, myPos.y );
	}else{
		CreateMuzzleEffect( GUN_R, myPos.y );
	}
	
	if ( (1 == mBattleProcess) && (true == PcHitTest()) && (!side) ){
		if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
			WK7PLAYERCONTROL->SetPcDamage(myPos, DE2_GUN_DAMAGE_EASY, 0);				// |WVA_[WlA[h
		}else{
			WK7PLAYERCONTROL->SetPcDamage(myPos, DE2_GUN_DAMAGE_NORMAL, 0);				// |WVA_[WlA[h
		}
	}
}


/*
	
	
	obɃ_[W^ĂǂH
	
	
*/
bool K7EnmDE2::PcHitTest(void)
{
	if ((200 == mBattleProcess)
	||	(0 == mBattleProcess)
	||	(20 == mBattleProcess)
	||	(21 == mBattleProcess)
	){
		return false;
	}
	return true;
}













/*
	
	
	f|[Ƀ_[W^ĂǂH
	
	
*/
bool K7EnmDE2::DE2HitTest(Vec *pPos)
{
	f32 dist;
	Vec myPos;
	
	if ( NULL != mpNpcChara ){
		GetWaistPosition(&myPos);
		dist = GHM_VEC_GET_DIST(pPos, &myPos);
		
#define  iwaDist (10.f)
		if ( (mData.mHp > 0) && (dist < iwaDist) ) {
			if ( (myPos.z > -120.f) && (myPos.z < -85.1f) ){
				// f|[S
				// f|[SE
				gpSound->mPlaySE(SFX_BOSS_DE2_GRUNTS3, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackBattleOverlap, eSEGroupBattle00Env );
				mData.mHp = 0;
				return true;
			}
		}
		
	}
	return false;
}

/*
	
	
	f|[{XIH
	
	<return>
	-1			{XIilSj
	1			{XIif|[Sj
	0			{X풆
	
*/
int K7EnmDE2::DE2BossEnd(void)
{
	return mBatteleExit;
}
void K7EnmDE2::FinalAtkCall(void)
{
	mFinalAtk = 1;
}


