////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMFAN_H__
#define	__ENMFAN_H__

#include "..\Wat\WK7Enemy.h"
#include "EnmBoss.h"
#include "..\Fujita\c_state.h"
#include "..\Fujita\c_particle.h"
#include "..\Fujita\c_radialblur.h"

#define FAN (*K7EnmFAN::GetInstance())

enum FAN_MOT{
  FAN_MOT_NEUTRAL = 0,
  FAN_MOT_WAKEUP,
  FAN_MOT_NEUTRAL_TO_SHOT,
  FAN_MOT_SHOT_NEUTRAL,
  FAN_MOT_SHOT_TO_NEUTRAL,
  FAN_MOT_DAMAGE,
  FAN_MOT_MAX
};
enum FAN_STATE{
  FAN_STATE_SLEEP = 0,
  FAN_STATE_WAKEUP,
  FAN_STATE_STAND_STILL,
  FAN_STATE_NEUTRAL,
  FAN_STATE_SHOT,
  FAN_STATE_DAMAGE,
  FAN_STATE_DEAD,
  FAN_STATE_GAMEOVER,
  FAN_STATE_MAX
};
enum {
  FAN_MAX_HIT = 4,
  FAN_MAX_GEN = 4,
  FAN_GEN_TIME = 4
};

class K7EnmFAN : public K7EnmBoss{
protected:
  bool alive;
  static K7EnmFAN *instance;
  C_State state;
  s32 die_counter;
  u32 hit_counter;
  u32 gen_counter;
  u32 stand_still_counter;
  u32 counter;
  u32 no_hit_counter;
  u32 mot_id;
  WK7HitObjJObj *face_hit_obj[FAN_MAX_HIT];
  bool face_hit_flg[FAN_MAX_HIT];
  s32 face_hit_counter[FAN_MAX_HIT];
  EFFECT *yamada_effect[3];
  HSD_Fog *fog;
  u32 appear;
  bool hit_req;
  bool pause_req;
  Vec last_player_pos, aim_pos;
  C_Generator *gen[FAN_MAX_GEN];
  C_Generator *gen_face[FAN_MAX_HIT];
  C_RadialBlur *blur;
  void Dummy( void );
public:
  bool IsMyRenderID( u32 id, Vec *p );
  static K7EnmFAN *GetInstance( void ){ return instance; }
  void AppearReq( u32 flg_ = 1  ){ appear = flg_; }
  inline bool IsAlive( void ){	return alive;  }
  static void StopFeather( void ){
	if( instance ){
	for( int i=0; i<2; i++ ){
	  if( instance->yamada_effect[i] && GetEffectValidState( instance->yamada_effect[i] ) ) {
		::DelReqEffect( instance->yamada_effect[i] ) ;
		instance->yamada_effect[i] = 0;
	  }
	}
	}
  }
  inline FAN_STATE GetState( void ) { return (FAN_STATE)((s32)state);}
  inline void PauseReq( bool p_ ) { pause_req = p_;}

  K7EnmFAN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
  virtual ~K7EnmFAN();
  bool FrameProcess(void);
  bool ControlProcess(void);
  void AdditionalPostRenderProcess( void );
  void AdditionalPreRenderProcess( void );
  void SetupEyeTgtPos( Vec &eye_, Vec &tgt_ );
};

#endif	//__ENMFAN_H__

