////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Objec
//
// EnmGYA.cpp			J MNeBJ
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMGYA_CPP__

#include "EnmGYA.h"

#include "..\Fujita\C_Font.h"
#include "..\Stage\05\01\K7Stage557M00.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Yam\YK7EffectBlood.h"
#include "..\Yam\YK7EffectBloodPack.h"
#include "..\Sato\SK7SpOption.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Yam\YK7EffectExplode.h"
#include "..\Wat\WK7Skill.h"
#include "..\Wat\WK7Player.h"
#include ".\EnmGya.h"

#define MDLCODE_ID				(13)			// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(13)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeGYAMotionIdTable[] = {
	20,							// R
	0,							// 
	0,							// 
	0,							// ^[E
	0,							// ^[
	0,							// ^[
	0,							// UĂѓiNu쓮j
	100,						// 85cmɍU
	100,						// 150cmɍU
	150,						// _[WO
	150,						// _[W
	150,						// _[WO
	0,							// _[W
	190,						// _[WEO
	0,							// _[WE
	200,						// _[WO
	0,							// _[W
	210,						// _[WEgO
	0,							// _[WEg
	230,						// _[WgO
	0,							// _[Wg
	180,						// _[WӂƂу_EOiSj
	180,						// _[Wу_EiSj
	0,							// _[WE _E
	0,							// _[W _E
	0,							// _ER
	0,							// _E_[W
	0,							// _EȂ
	0,							// _EȂ瑖
	0,							// _E玀S
	0,							// _E85cmɍU
	0,							// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	0,						// ݍUi_j
	0,						// ݍUiRj
	0,						// ݍUiJGfj
	0,						// ݍUiR[ej
	0,						// ݍUi}XNj
	0,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};


static f32 DefMissileSpeed			= 1.f;
static f32 DefMissileDiv			= 0.8f;
static int DefMissileKakudoHosei	= 30;
static int DefMissileEfcTiming		= 4;


K7EnmGYA::K7EnmGYA(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor,int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	int i;

	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeGYAMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go(Ƀf[^̕ŏ)
	
	mData.mWeakID		= -1;								// _
	mData.mVLossID		= -1;								// ʌ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP03;
	mData.mScale		= 1.f;
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	
	mData.mAtkPower1	= 1000;
	mData.mAtkPower2	= 1000;
	
	mData.mNoMove		= true;								// ړȂ
	mData.mCounterKurai	= 0;								// ݖ
	
	// Init
	for (i=0; i<GYA_MISSILE_MAX; i++){
		MissileCreate(i, NULL);
	}
	
	mBattleStart		= 0;
	mMissileLv			= 0;
	mMissileNum			= 0;
	mMissileCount		= 0;
	mMissileWait		= 0;
}

/*
	
	
	S
	
	<return>
	true	VK[VZbgꂽ
	false	[V̂܂
	
*/
bool K7EnmGYA::MotStatus_Die(void)
{
	bool dieEnd = false;
	
	if ( mDamage.mDamDieCount > 0 ){
		mDamage.mDamDieCount--;
		if ( 0 >= mDamage.mDamDieCount ){
			dieEnd = true;
		}
	}
	
	if ((WK7MODEL_NOANIM == GetCommonMotionState())
	||	(true == dieEnd)
	){
		DieEnd();
		return true;
	}
	return false;
}

/*
	
	
	~TCXe[W̃qbgIuWFƂď
	
	
*/
void K7EnmGYA::HitObjMake(WK7Stage *pCurrentStage)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	int i;

	for (i=0; i<GYA_MISSILE_MAX; i++){
		if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
			pJObj = pModel->GetObj(pNameMissileObj[i]);
			if ( pJObj != NULL ) {
				pCurrentStage->SetHitObj(pJObj, (u32 )i);
				
				MissileCreate(i, pJObj);					// ~TC̃ZbgAbvɂȂ
			}
		}
	}
}

/*
	
	
	~TCp̎l̈ʒu擾
	
	
*/
void K7EnmGYA::GetPcPos(Vec *pPcPos)
{
	*pPcPos = mOperationPos;
	pPcPos->y += pBattleMain->GetKamaeY(WK7PLAYERCONTROL->GetMainID());
}

void K7EnmGYA::VisibleTestDisp(void)
{
	GYA_MISSILE *pMissile = mMissile;
	WK7Model *pModel;
	s16 i;

	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Disp();
		
		// ~TC̕\E\
		for(i=0, pMissile=mMissile; i<GYA_MISSILE_MAX; i++, pMissile++){
			if ((pMissile->die)
			||	(pMissile->process != GYA_MISSILE_PROCESS_RUN)
			){
				if ( pMissile->pJObjMissile != NULL ) pMissile->pJObjMissile->Hide(false);
			}
		}
	}
}

void K7EnmGYA::VisibleTestHide(void)
{
	WK7Model *pModel;
	if( (pModel = pCurrentChara()->GetModel())!=NULL ){
		pModel->Hide();
	}
}


/*
	
	
	~TC̃NGCg
	
	
*/
void K7EnmGYA::MissileCreate(int id, WK7JObj *pSetJObj)
{
	mMissile[id].pJObjMissile	= pSetJObj;
	mMissile[id].posid			= -1;
	mMissile[id].die			= 0;
	mMissile[id].cnt			= 0;
	mMissile[id].process		= GYA_MISSILE_PROCESS_INIT;
	if ( mMissile[id].pJObjMissile != NULL ){
		mMissile[id].pJObjMissile->Hide(false, true);
	}
}


/*
	
	
	~TC̃Zbg
	
	
*/
void K7EnmGYA::MissileReset(int id)
{
	mMissile[id].posid			= -1;
	mMissile[id].die			= 0;
	mMissile[id].cnt			= 0;
	mMissile[id].process		= GYA_MISSILE_PROCESS_INIT;
	mMissile[id].pos.y			= -100.f;
}


/*
	
	
	~TC
	
	
*/
bool K7EnmGYA::MissileStart(int id)
{
	// Init
	if ( mMissile[id].die ) return false;
	if ( mMissile[id].process != GYA_MISSILE_PROCESS_INIT ) return false;
	
	// ʒu
	if ( false == SerachMissilePos(id) ) {
		return false;
	}
	
	// OK
	mMissile[id].process	= GYA_MISSILE_PROCESS_RUN;
	if ( mMissile[id].pJObjMissile != NULL ){
		mMissile[id].pJObjMissile->Disp(false, true);
	}
	
	// SE
	gpSound->mPlaySE3D(SFX_BT_GLHS_SHOT, mMissile[id].pos, 1, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );
	
	MissileMove(id, DefMissileDiv);
	
	return true;
}
/*
	
	
	~TC̔ˈʒu
	
	
*/
bool K7EnmGYA::SerachMissilePos(int id)
{
	WK7Model *pModel;
	WK7JObj  *pJObj;
	int i, start;

	start = rand()%GYA_SHOTPOS_MAX;
	for(i=0; i<GYA_SHOTPOS_MAX; i++){
//		if ( true == UseMissilePosTest(id, (s8 )start) ){
			// ̗p
			if ( (pModel = pCurrentChara()->GetModel()) != NULL ){
				pJObj = pModel->GetObj(pShotPos[start]);
				if ( pJObj != NULL ){
					// IDZbg
					mMissile[id].posid	= (s8 )i;
					// ˈʒuZbg
					pJObj->GetWorldPosition(&(mMissile[id].pos));
					// ˊpZbg
					if ( start == 0 ){
						mMissile[id].nowRot.x = 0.f;
						mMissile[id].nowRot.y = GetRotY();
						mMissile[id].nowRot.z = 0.f;
					}else{
						pJObj->GetRotation(&(mMissile[id].nowRot));
						mMissile[id].nowRot.y += GetRotY();
						GHM_LIMIT_RANGE(mMissile[id].nowRot.y, PI, -PI);
					}
					
					mMissile[id].tgtRot = mMissile[id].nowRot;
					mMissile[id].speed	= DefMissileSpeed;
					return true;
				}
			}
//		}
		start++;
		if ( start >= GYA_SHOTPOS_MAX ) start = 0;
	}
	
	return false;
}
bool K7EnmGYA::UseMissilePosTest(int myid, s8 useposid)
{
	int i;

	for(i=0; i<GYA_MISSILE_MAX; i++){
		if ( i == myid ) continue;
		if ( mMissile[i].posid == useposid ) return false; // gĂ
	}
	return true;
}



/*
	
	
	~TCړ
	
	
*/
bool K7EnmGYA::MissileMove(int id, f32 delay)
{
	GYA_MISSILE *pMissile = &(mMissile[id]);
	f32 tmp, distzx;
	Vec pcWaistPos;
	Vec *pMyPos, pcRot;
	f32 dist;
	int MissileKakudoHosei = DefMissileKakudoHosei;
	
	if ( pMissile != NULL ) {
		
		pMissile->cnt++;
		
		// lo
		pMyPos = &(pMissile->pos);
		GetPcPos(&pcWaistPos);
#if 0
		{
			Vec tgtRot = pcWaistPos;
			pcRot.y = atan2f(tgtRot.x - pMyPos->x, tgtRot.z - pMyPos->z);
			pcRot.x = atan2f(	tgtRot.y - pMyPos->y,
								sqrtf((tgtRot.x-pMyPos->x)*(tgtRot.x-pMyPos->x)+(tgtRot.z-pMyPos->z)*(tgtRot.z-pMyPos->z))
			);
			pcRot.z = 0.f;
		}
#else
		GetRot(&pcWaistPos, pMyPos, &pcRot);
#endif
		
		// ^[QbgZbg
		pMissile->tgtRot = pcRot;
		
		// px␳
		{
			Vec pcWaistPos;
			
			GetPcPos(&pcWaistPos);
			dist = GHM_VEC_DIST(&(pMissile->pos), &pcWaistPos);
		}
		
static f32 MissileKakudoHoseiDist = (10.f);
		if ( dist <= MissileKakudoHoseiDist ){
static int MissileKakudoHoseiSet = 1;
			MissileKakudoHosei = MissileKakudoHoseiSet;
			delay = 0.9f;
		}
		
		if ( 0 == (pMissile->cnt%MissileKakudoHosei) ){
			tmp = pMissile->tgtRot.y - pMissile->nowRot.y;
			if ( tmp ){
				GHM_LIMIT_RANGE(tmp, PI, -PI);
				pMissile->nowRot.y += tmp * delay;
				GHM_LIMIT_RANGE(pMissile->nowRot.y, PI, -PI);
			}
			tmp = pMissile->tgtRot.x - pMissile->nowRot.x;
			if ( tmp ){
				pMissile->nowRot.x += tmp * delay;
			}
		}
		
		// ړ
		distzx = pMissile->speed * cosf(pMissile->nowRot.x);
		pMissile->pos.y = pMissile->pos.y + pMissile->speed * sinf(pMissile->nowRot.x);
		pMissile->pos.x = pMissile->pos.x + distzx * sinf(pMissile->nowRot.y);
		pMissile->pos.z = pMissile->pos.z + distzx * cosf(pMissile->nowRot.y);
		
		// ړGtFNg
		if(0 == (pMissile->cnt%DefMissileEfcTiming)){
			Vec SmokeRot;
			
			SmokeRot = pMissile->nowRot;
			SmokeRot.y += PI;
			GHM_LIMIT_RANGE(SmokeRot.y, PI, -PI);
			KK7FootSmokeEffect(pMissile->pos, SmokeRot);
		}
		
		// IuWFɃZbg
		pMissile->pJObjMissile->SetWorldPosition(&(pMissile->pos));
		pMissile->pJObjMissile->SetRotation(pMissile->nowRot);
		return true;
	}
	return false;
}


/*
	
	
	~TCeXg
	
	
*/
bool K7EnmGYA::MissileJibakuTest(int id)
{
	GYA_MISSILE *pMissile = &(mMissile[id]);
	Vec pcWaistPos;
	f32 dist;
	
	GetPcPos(&pcWaistPos);
	dist = GHM_VEC_DIST(&(pMissile->pos), &pcWaistPos);
	
	if ( dist <= GYA_MISSILE_JIBAKU_DIST ){
		
		// PCɃ_[W
		// lɂqbgtO𗧂Ă
		WK7PLAYERCONTROL->SetPcDamage(pMissile->pos, (s16 )GYA_MISSILE_DAMAGE, 2);
		
		// j
		CreateSmokeExplodeEffect(	mMissile[id].pos,
									0.5f,
									0
		);

		// UeXg
		MissileYuBakuTest(id);
		
		pMissile->process = GYA_MISSILE_PROCESS_DIE;
		return true;
	}
	return false;
}


/*
	
	
	~TCj
	
	
*/
bool K7EnmGYA::MissileBroken(int id, int mode)
{
	GYA_MISSILE	*pMissile = &(mMissile[id]);
	WK7JObj		 *pJObj = mMissile[id].pJObjMissile;
	Vec pcRot, damPos;
	f32 pcRotY;

	if ((pJObj != NULL)
	&&	(0 == pMissile->die)
	){
		// _[Wo
		WK7PLAYERCONTROL->GetRotY(&pcRotY);
		pcRot.x = 0.f;
		pcRot.y = pcRotY;
		pcRot.z = 0.f;
		
		// _[Wʒuo
		pJObj->GetWorldPosition(&damPos);
		
		// j
		CreateSmokeExplodeEffect(	mMissile[id].pos,
									0.5f,
									0
		);
		if ( mode ){
			// UeXg
			MissileYuBakuTest(id);
		}
		
		pMissile->die = 1;
		
		// qbgnjI i[Voj
		SetNpcDamage(	WK7PLAYERCONTROL->GetCharaPtr(),
						pcRot,									// őp
						damPos,
						1,										// _[WlP
						DAMTYPE_GYARMISSILE
		);
		
		// 
		pJObj->Hide(false, true);
		
		// Xe[^Xς
		pMissile->process = GYA_MISSILE_PROCESS_DIE;
		
		return true;
	}
	return false;
}

/*
	
	
	~TCjiUݒ
	
	
*/
void K7EnmGYA::MissileYuBakuTest(int id)
{
	GYA_MISSILE *pMissile;
	int i;
	f32 dist;
	Vec myPos;

	myPos = mMissile[id].pos;
	for(i=0, pMissile=mMissile; i<GYA_MISSILE_MAX; i++, pMissile++){
		if ( id == i ) continue;
		if ( pMissile->die ) continue;
		if ( pMissile->process != GYA_MISSILE_PROCESS_RUN ) continue;
		
		dist = GHM_VEC_DIST(&(pMissile->pos), &myPos);
		if ( dist <= GYA_MISSILE_YUUBAKU_DIST ){
			// U
			MissileBroken(i, 0);
		}
	}
}




/*
	
	
	~TC
	
	
*/
bool K7EnmGYA::MissileLoss(int id)
{
	GYA_MISSILE	*pMissile = &(mMissile[id]);
	WK7JObj		 *pJObj = mMissile[id].pJObjMissile;

	if ( pJObj != NULL ){
		// 
		pJObj->Hide(false, true);
	}
	
	MissileReset(id);
	return true;
}



/*
	
	
	~TCSji{̎SɃR[
	
	
*/
void K7EnmGYA::MissileAllDie(void)
{
	GYA_MISSILE *pMissile;
	int i;

	for(i=0, pMissile=mMissile; i<GYA_MISSILE_MAX; i++, pMissile++){
		if ( pMissile->die ) continue;
		if ( pMissile->process != GYA_MISSILE_PROCESS_RUN ) continue;
		MissileBroken(i, 0);
	}
	
	mBattleStart = -1;
}






/*
	
	
	MNeBJpꐧ䃋[`
	
	
*/
bool K7EnmGYA::MotSet_DmgExtra(void)
{
	if ( DAMTYPE_GYARMISSILE == mDamage.mDamType ){			// ~TCɃqbgꍇiꂽɂȂ
		return true;
	}
	
//	return true;
	return false;
}


void K7EnmGYA::AllMissileCtrl(void)
{
	int i;

	for(i=0; i<GYA_MISSILE_MAX; i++){
#if 0
		{
			C_Paper		paper(570, 24 + i*16);
			PRINTF("M%d:St%d \n", i, mMissile[i].process);
		}
#endif
		switch (mMissile[i].process){
		case GYA_MISSILE_PROCESS_INIT:				// ˑҋ@
			break;
		case GYA_MISSILE_PROCESS_RUN:
			MissileMove(i, DefMissileDiv);
			if ( true ==  MissileJibakuTest(i) ){
				
			}
			break;
		case GYA_MISSILE_PROCESS_DIE:
			// āAҋ@
			MissileLoss(i);
			break;
		default:
			break;
		}
	}
}
bool K7EnmGYA::AllMissileShot(int num)
{
	int i, ok;

	if ( num > GYA_MISSILE_DOUJI_SHOT ) return false;
	
	for(i=0, ok=0; i<GYA_MISSILE_MAX; i++){
		if ( true == MissileStart(i) ){
			ok++;
			if ( ok >= num ) {
				return true;
			}
		}
	}
	return false;
}


/*
	
	
	~TCi|[Y̎́AɔłȂ
	
	
*/
bool K7EnmGYA::ExtraControlProcess(void)
{
	if ( (mBattleStart==1) && (true == GetEnemyDieTest(GetEneNo())) ){
		// 񂾁H
		MissileAllDie();
	}
	
	if ( (mBattleStart==0) && GetLockOn() ){							// bNIꂽ퓬Jn
		mBattleStart=1;
	}
	
	if ( 1 == mBattleStart ){
		
		AllMissileCtrl();
		
		if ( mMissileWait > 0 ){
			mMissileWait--;
		}
		if ( mMissileCount > 0 ){
			mMissileCount--;
		}
		
		switch (mMissileLv){
		case 0:															// Rǂo
			if ( mMissileWait <= 0 ){
				
				if ( GetHp() <= (mData.mHpBk/3) ){
					mMissileLv = 2;
					if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
						mMissileWait = WK7_SEC_TO_FRAME(3);
					}else{
						mMissileWait = WK7_SEC_TO_FRAME(1);
					}
					break;
				}
				
				if ( mMissileCount <= 0 ){
					s16 max;
					
					AllMissileShot(1);									// ~TC
					
					mMissileCount = 15;
					mMissileNum++;
					
					if ( GetHp() <= (mData.mHpBk/2) ){
						max = 4;
					}else{
						max = 3;
					}
					
					if ( mMissileNum >= max ){
						mMissileNum  = 0;
						mMissileWait = WK7_SEC_TO_FRAME(5);
						mMissileLv = 1;
					}
				}
			}
			break;
		case 1:															// ܂Ƃ߂ĈCɏo
			if ( mMissileWait <= 0 ){
				int HassyaMaxNum = 0;
				
				if ( GetHp() <= (mData.mHpBk/3) ){
					mMissileLv = 2;
					if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
						mMissileWait = WK7_SEC_TO_FRAME(3);
					}else{
						mMissileWait = WK7_SEC_TO_FRAME(1);
					}
					break;
				}
				
				HassyaMaxNum = 4;
				AllMissileShot(HassyaMaxNum);							// ~TC
				mMissileLv = 0;
				
				mMissileWait = WK7_SEC_TO_FRAME(3);
			}
			break;
		case 2:															// f܂
			if ( mMissileWait <= 0 ){
				if ( mMissileCount <= 0 ){
					AllMissileShot(1);									// ~TC
					mMissileCount = 20;
				}
			}
			break;
		}
		
		// Ƃ肠Ŏ
//		if ( mDamage.mDamHitRequest ) {
//			if ( DAMTYPE_GYARMISSILE != mDamage.mDamType ){
//				AllMissileShot((rand()%(GYA_MISSILE_DOUJI_SHOT-1))+1);
//			}
//		}
		
	}
	
	return true;
}
