////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmGYA.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__ENMGYA_H__
#define	__ENMGYA_H__

#include "..\Wat\WK7Enemy.h"

#define GYA_MISSILE_MAX			(8)
#define GYA_SHOTPOS_MAX			(4)

typedef struct _GYA_MISSILE{
	WK7JObj *pJObjMissile;
	Vec pos;
	Vec nowRot;
	Vec tgtRot;
	f32	speed;
	u8	die;
	s8	process;
	s8	posid;
	u32 cnt;
}GYA_MISSILE;


class K7EnmGYA : public WK7Enemy{
protected:
	GYA_MISSILE		mMissile[GYA_MISSILE_MAX];
	s8				mBattleStart;
	u8				mMissileLv;
	s16				mMissileNum;
	s16				mMissileCount;
	s16				mMissileWait;
	
	void MissileCreate(int id, WK7JObj *pSetJObj);
	void MissileReset(int id);
	bool MissileStart(int id);
	bool MissileMove(int id, f32 delay);
	bool MissileJibakuTest(int id);
	void MissileYuBakuTest(int id);
	bool MissileLoss(int id);
	void AllMissileCtrl(void);
	bool AllMissileShot(int num);
	bool SerachMissilePos(int id);
	bool UseMissilePosTest(int myid, s8 useposid);
	void GetPcPos(Vec *pPcPos);
	void MissileAllDie();
public:
	K7EnmGYA(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio=WK7OBJ_DEFAULT_PRIO);
	void HitObjMake(WK7Stage *pCurrentStage);
	bool MotSet_DmgExtra(void);
	bool ExtraControlProcess(void);
	bool MissileBroken(int id, int mode=1);
	void VisibleTestDisp(void);
	void VisibleTestHide(void);
	bool MotStatus_Die(void);
};

#ifdef	__ENMGYA_CPP__

enum GyaMissileProcess{
	GYA_MISSILE_PROCESS_INIT    = 0	,
	GYA_MISSILE_PROCESS_RUN,
	GYA_MISSILE_PROCESS_DIE,
};


#define GYA_MISSILE_JIBAKU_DIST		(1.f)
#define GYA_MISSILE_YUUBAKU_DIST	(20.f)
#define GYA_MISSILE_DOUJI_SHOT		(4)
#define GYA_MISSILE_PC_NERAI_Y		(15.f)

// ~TC̍U
#define GYA_MISSILE_DAMAGE		(20)

char *pNameMissileObj[GYA_MISSILE_MAX] = {
	"Missile0",
	"Missile1",
	"Missile2",
	"Missile3",
	"Missile4",
	"Missile5",
	"Missile6",
	"Missile7",
};

char *pShotPos[GYA_SHOTPOS_MAX] = {
	"shot0",
	"shot1",
	"shot2",
	"shot3",
};


#else


#endif

#endif	//__ENMGYA_H__

