////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmDE2.cpp {X ݂蒷 Stage553M00
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMHNG_CPP__

#include "EnmHNG.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Stage.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Stage\05\01\K7Stage553M00.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Yam\YK7EffectMuzzle.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Yam\YK7EffectDamageBlood.h"
#include "..\Yam\YK7EffectSmokeObj.h"
#include "..\Yam\YK7EffectSmokeObj2.h"
#include "..\Yam\YK7EffectHitMark.h"
#include "..\Yam\YK7EffectImpact.h"
#include "..\Scn\K7Scn05.h"

#ifdef YAMADADEBUG
//	#define DEBUG_EASY
#endif

enum WK7NpcBossHngControlState{
	NPC_HNG_STATE_INIT = NPC_STATE_MAX,	// l
	NPC_HNG_STATE_BATTLE1,				// iK
	NPC_HNG_STATE_BATTLE2,				// iK
	NPC_HNG_STATE_BATTLE3,				// OiK
	NPC_HNG_STATE_DIE,					// S
	NPC_HNG_STATE_RUN,					// 
};

#define CORENAME			"Spine_joint1"	// ̂̕ JObj ̖O
#define HITNAME				"Hit_big"	// }̕ JObj ̖O

#define SHOTDAMAGENORMAL	(10)		// m[}̃_[W
#define SHOTDAMAGEEASY		(5)			// C[W[̃_[W
#define SHOTDAMAGE			((s16)( ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ) ? SHOTDAMAGEEASY : SHOTDAMAGENORMAL ))

#define SHOTMAXWAIT			(120)		// Vbg܂ł̍ő҂
#define SHOTMINWAIT			(30)		// Vbg܂ł̍ŏ҂
#define MUZZLEWAIT			(100)		// }YtbVo܂ł̎
#define SHOTHITWAIT			(3)			// Vbgv[[ɓ܂ł̎
#define YUREMOTTIME			(150.0F)	// hꃂ[Ṽt[(60FPS)
#define MAXYUREPOWER		(4)			// őhp[


#define EASYMOTIONSPEED		(0.3F)
#define NORMALMOTIONSPEED	(0.5F)

// [VXs[h
#ifdef DEBUG_EASY
	#define MOTIONSPEED		EASYMOTIONSPEED
#else
	#define MOTIONSPEED		( ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ) ? EASYMOTIONSPEED : NORMALMOTIONSPEED )
#endif

#define VITAL				(2000)		// ̗
#define HITSIZE				(1.2F)		// }̃qbg͈̔

#define INITPOSX			(0.0F)		// ʒu
#define INITPOSY			(73.177F)
#define INITPOSZ			(42.364F)

#define BHSPOPWAIT		(15)		// ubNgroԊu
#define BHSSMOKESPEED	(0.1F)
#define BHSSMOKE2WAIT	(15)		// ̉҂
#define BHSSMOKE2TIME	(60)		// gr܂Ƃ̕\
#define BHSPOPUPWAIT	(30)		// oĂgro܂ł̎
#define ALLBHSPOPUPWAIT	(60)		// SĂ̂groĂ̑҂

#define WARAIWAIT		(80)		// Ō̃gh҂Ă鎞A΂Ԋu
#define DIEWAIT			(60)		// Ō̃ghhĂ甚܂ł̎
#define BOMWAIT			(60)		// Ă퓬ItO𗧂Ă܂ł̎

#define STREAMFADETIME	(45)		// ȖڂIĂȂtF[hd؂܂ł̎
#define STOPTIME		(150)		// _j̑҂
#define PLAYWAIT		(110)		// agȑon܂ĂȂȂn߂܂ł̑҂

int K7EnmHNG::mHNGBattleStart = 0;			// ݂蒷JtO

// a݉e[u
s32 HNG_KisimiSoundTable[][2] =
{
	-1, -1,
	SFX_BOSS_HNG_YUREL_A, SFX_BOSS_HNG_YURER_A, 
	SFX_BOSS_HNG_YUREL_B, SFX_BOSS_HNG_YURER_B, 
	SFX_BOSS_HNG_YUREL_C, SFX_BOSS_HNG_YURER_C, 
	SFX_BOSS_HNG_YUREL_D, SFX_BOSS_HNG_YURER_D, 
} ;

//	#define SFX_BT_HS_HNGUGI_MAX	(4)
//	static int damageSeTbl[SFX_BT_HS_HNGUGI_MAX] = {
//		SFX_BOSS_HNG_GRUNTS0,
//		SFX_BOSS_HNG_GRUNTS1,
//		SFX_BOSS_HNG_GRUNTS2,
//		SFX_BOSS_HNG_GRUNTS3
//	};

void K7EnmHNG::Dummy( void )
{
}

//  core JObj 擾
WK7JObj *K7EnmHNG::GetCoreJObj( void )
{
	WK7Chara *pCharaTmp = pCurrentChara();
	WK7Model *pModel ;
	
	if( pCharaTmp==NULL ){
		return NULL ;
	}
	if( (pModel = pCharaTmp->GetModel()) == NULL ){
		return NULL ;
	}
	return pModel->GetObj( CORENAME ) ;
}

//  Root JObj 擾
WK7JObj *K7EnmHNG::GetYureJObj( void )
{
	WK7Chara *pCharaTmp = pCurrentChara();
	WK7Model *pModel ;
	
	if( pCharaTmp==NULL ){
		return NULL ;
	}
	if( (pModel = pCharaTmp->GetModel()) == NULL ){
		return NULL ;
	}
	return pModel->GetObj(0) ;
}


// hꃂ[VĐ
bool K7EnmHNG::PlayHNGYureMotion( u32 YurePower, s32 HitPos, bool loop )
{
	WK7Chara		*pCharaTmp;
	WK7Model		*pModel;
	WK7JObj			*JObj ;
	f32 			framebody, framerope ;
	u32				YureID[MAXYUREPOWER+1] =
	{
		HNG_MOT_WAIT,			// R
		HNG_MOT_YURE_S,			// h()
		HNG_MOT_YURE_M,			// h()
		HNG_MOT_YURE_L,			// h()
		HNG_MOT_NUGE,			// Y{E
	} ;
	
	// hp[̏ꍇ͉Ȃ
	if( mYurePower == YurePower ) return true ;

	pCharaTmp = pCurrentChara();
	
	if( pCharaTmp==NULL ){
		return false;
	}
	if( (pModel = pCharaTmp->GetModel()) == NULL ){
		return false;
	}
	if( ( JObj = pModel->GetObj( CORENAME ) ) == NULL ){
		return NULL ;
	}
	
	// ݍĐĂ郂[Ṽt[ۑ
	framerope = pModel->GetCurrentMotionFrame() ;
	framebody = JObj->GetCurrentMotionFrame() ;
	
	// [v̍Đs
//	SpSpeedSet( MOTIONSPEED ) ;
	if( YureID[YurePower] == HNG_MOT_NUGE )
	{
		PlayCommonMotion( HNG_MOT_NUGE, loop, false ,/*true,*/ 0.0F, MOTIONSPEED ) ;
		pModel->SetMotionRate( MOTIONSPEED ) ;

		// {fB̍Đs
		if( BodyMotionID != -1 /*&& YureID[YurePower] != HNG_MOT_NUGE*/ )
			PlayHNGBodyMotion( BodyMotionID, false, true, framebody, 1.0F );
		
		// Y{ɂēxA^b`
		{
			WK7JObj *jobj ;
			
			jobj = pModel->GetObj( "Pant" ) ;
			
			// ̃[V̒~
			jobj->StopMotion( true, true ) ;
			jobj->DetachMotion( true, true ) ;

			jobj->AttachFindMotion( mpNpcMotion[HNG_MOT_NUGE]->GetMotion()->GetModelMotion() ) ;
			jobj->PlayMotion( 0.0F, false, 0.0F ) ;
			jobj->SetMotionRate( MOTIONSPEED ) ;
		}
	}
	else
	{
		if( HitPos == 0 || YurePower != 1 )
		{
			PlayCommonMotion( YureID[YurePower], loop, false/*true*/, mYurePower != 0 ? framerope : 0.0F, MOTIONSPEED ) ;
		}
		else
		{
			PlayCommonMotion( YureID[YurePower], loop, false/*true*/, HitPos == -1 ? YUREMOTTIME / 2.0F : 0.0F, MOTIONSPEED ) ;
		}

		pModel->SetMotionRate( MOTIONSPEED ) ;

		// {fB̍Đs
		if( BodyMotionID != -1 /*&& YureID[YurePower] != HNG_MOT_NUGE*/ )
			PlayHNGBodyMotion( BodyMotionID, false, true, framebody, 1.0F );
	}

	// hp[ۑ
	mYurePower = (s32)YurePower ;

	return true;
}

// [gȉ̕ɂ̂ݎw̃[V𗬂
bool K7EnmHNG::PlayHNGBodyMotion( u32 id, bool loop, bool hokan, f32 sframe, f32 speed )
{
	WK7Chara		*pCharaTmp;
	WK7Model		*pModel;
	WK7CharaMotion	*pCharaMotion;
	WK7ModelMotion	*pModelMotion;
	WK7JObj			*JObj ;
	
	speed = speed ;
	
	pCharaTmp = pCurrentChara();
	
	if( pCharaTmp==NULL ){
		return false;
	}
	if( (pModel = pCharaTmp->GetModel()) == NULL ){
		return false;
	}
	if( id >= WK7MOTION_NPCCMN_NUM ){
		return false;
	}
	
	if ( mpNpcMotion[id] == NULL ){
		return false;
	}
	if( (pCharaMotion=mpNpcMotion[id]->GetMotion())==NULL ){
		return false;
	}
	
	if( (pModelMotion=pCharaMotion->GetModelMotion())==NULL ){
		return false;
	}
	if( ( JObj = pModel->GetObj( CORENAME ) ) == NULL ){
		return NULL ;
	}
//	if( pModelMotion->GetAnimJoint( CORENAME, &Anim ) == false ){
//		return false ;
//	}

//	JObj->SetMotionOperation( true, true, true ) ;
	
	// ̃[V̒~
	JObj->StopMotion( true, true ) ;
	JObj->DetachMotion( true, true ) ;
//	pModel->StopMotion();
//	pModel->DetachMotion();
	
	// VK[V̓o^
	if( JObj->AttachFindMotion(pModelMotion)==0 ){
		return false;
	}
	
	if ( hokan ){
//		pModel->PlayMotion(sframe, true, 8.0f);
		JObj->PlayMotion(sframe, true, 6.0f);
	}else{
		JObj->PlayMotion(sframe, false,0.0f);
	}
	
	JObj->SetMotionLoop(loop);

//	JObj->SetMotionOperation( false, true, true ) ;
	
//	mDefMotSpeed = speed;
//	pModel->SetMotionRate(speed);

	BodyMotionID = id ;
	
//	mMotID = id;
	return true;
}


K7EnmHNG::K7EnmHNG(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7HNG, MotionIDTableHNG)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 0;								// goiQƂĂȂ̂łӁj
	mData.mWeakID		= NPCWEAKOBJID_HEAD;				// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// XP[
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mInitProcess		= 0;
	mpGun				= (WK7Model *) NULL;

	Rope				= NULL ;
	RopeID				= 0 ;
	
	mBulletNow			= HNG_GUN_BULLET_MAX;
	mShotNum			= 0;
	
	K7EnmHNG::mHNGBattleStart = 0;
	
	mBattleCount		= WK7_SEC_TO_FRAME(30);
	mBatteleExit		= 0;
	mBattleProcess		= 0;
	mBattleStart		= false ;
	
	KisimiSoundID		= 0 ;
	
//	mMotID				= HNG_MOT_WAIT;
//	mState.Init( KIB_KRR_COMMON_ATK0 );

	// ef[^̏
	mGunOtosiFlag = false ;
	
	// e֌W̒l
	mShotWait = 0 ;
	mShotCounter = 0 ;
	mShotFlag = false ;
	mShotFireFlag = false ;
	mShotActionFlag = false ;
	
	// gõZbg
	mData.mHp = VITAL ;
	
	// hx̏
	mYurePower = 0 ;
	BodyMotionID = HNG_MOT_WAIT ;
	
	// Y{̏
	mZubonFlag = false ;
	mZubonNugeFlag = false ;
	mZubonKisimiSoundFlag = false ;
	
	// oAtO|
	mBarrierFlag = false ;
	
	// VetO|
	mNewGunFlag = false ;
	
	// }YtbṼ|C^̏
	Muzzle = NULL ;
	MuzzleID = -1 ;
	
	// gr|bvAbvpf[^̏
	{
		for( int i = 0 ; i < 7 ; i ++ ) popHSInit( i ) ;
	}
}
K7EnmHNG::~K7EnmHNG()
{
	 WK7RenderObj::SetVfxFlag( true );
	 Release() ;
}

void K7EnmHNG::Release(void)
{
	gpSound->mReleaseSsm( "seBossHng.ssm" );
	DetachGun();
	ReleaseModel    ();
	ReleaseMotionAll();
	if( CheckEffectValidState( Rope, RopeID ) == TRUE )
		DeleteEffect( Rope ) ;
	Rope = NULL ;
	RopeID = 0 ;
	
	{
		for( int i = 0 ; i < 7 ; i ++ ) 
			popHSEnd( i ) ;
	}
}
void K7EnmHNG::DetachGun(void)
{
	if ( mpGun ){
		DetachGunModel((s8)GUN_R);
		mpGun = (WK7Model *)0;
	}
	ReleaseGunArchive(GUN_R);
}

// aމ̃t[vZX
void K7EnmHNG::KisimiSoundFrame( void )
{
	s32 dir ;
	s32 SoundID ;

	WK7Chara	*pCharaTmp;
	WK7Model	*pModel;
	f32 		frame ;
	
	if( ( pCharaTmp	= pCurrentChara() 		) == NULL ) return ;
	if( ( pModel 	= pCharaTmp->GetModel()	) == NULL ) return ;
	
	// ݍĐĂ郂[Ṽt[ۑ
	frame = pModel->GetCurrentMotionFrame() ;

	dir = frame < YUREMOTTIME / 2.0F ? 1 : 0 ;
	SoundID = HNG_KisimiSoundTable[mYurePower][dir] ;

	if( KisimiSoundID == SoundID ) return ;
	
	if( SoundID != -1 ) PlaySE( (u32)SoundID ) ;
	KisimiSoundID = SoundID ;
}


void K7EnmHNG::BattleStart( void )
{
	if( mBattleStart == true ) return ;
	
	mBattleStart = true ;

	// nCf̏eɃA^b`
	mpGun = AttachGunModel(	(s8)GUN_R,
								NULL,												// NULL I[gŃA^b`
								mpNpcChara->GetModel(),
								GUN_HAND_R											// E肩肩
	);
}


bool K7EnmHNG::ControlProcess(void)
{
	Vec myPos;
//	f32 dam;
//	int weakhit;

	if ( mpNpcChara==NULL ) 		return true;
	if ( true == IsLoading() ) 		return true;											// ǂݍݒ
	if ( mState == NPC_STATE_INIT )	goto NPC_CTRL_INIT_JUMP;
	if ( mBatteleExit == 1 )		return true ;
//	if ( K7SCR_GET_SCENARIO_FLAG(EV055300) == false ) return true ;
	if( mBattleStart == false )
	{
		DamageTest() ;
		return true ;
	}
	
//	if( mPause == true ) 			return true ;
	if ( true == GetNpcPause() ) 	return true;											// |[YȎ
	
	mpNpcChara->GetPosition(myPos);

	{
		for( int i = 0 ; i < 7 ; i ++ ) popHSFrame( i ) ;
	}
	
#if 0
	// _[W炢`FbN
#ifdef _DEBUG
	if( HSD_PadGetButton(1) & HSD_PAD_A ){
		goto COMPEL_DMG_JUMP;
	}
#endif
	
	if ((true == DamageTest())
	&&	(mState != NPC_STATE_DMG)								// AȂ
	){
COMPEL_DMG_JUMP:
//		// GȃXe[^X
//		if ( mState == NPC_STATE_ACTION ){
//			mDamage.mDamHitRequest = 0;
//			
//		}else{
//#if 1
//			MotSet_Avoid(AvoidSideGet());
//			mDamage.mDamHitRequest = 0;
//#else
//			// HP DEC
//			if (((mDamage.mWeakID) == mData.mWeakID)
//			&&	(-1 != mDamage.mWeakID)
//			&&	(mDamage.mDamWeakHitOk)
//			){														// Hi[Vj
//				dam = (f32 )(mDamage.mDamPoint);
//				dam = dam * 1.5f;
//				weakhit = 1;
//			}else{
//				dam = (f32 )(mDamage.mDamPoint);
//				weakhit = 0;
//			}
//			
//			// _[W~bg`FbN
//			if ( dam > 30.f ){
//				dam = 30.f;
//			}
//			mData.mHp -= (s16 )dam;
//			
//			
//			if  ( mData.mHp <= 0 ){
//				DieMotSet();
//			}else{
//				if ( weakhit ){
//					HNG_Dmg();
//					mState = NPC_STATE_DMG;
//				}
//			}
//			
//			// rd
////			gpSound->mPlaySE(damageSeTbl[rand()%SFX_BT_HS_HNGUGI_MAX]);
//			
//			// GtFNgiqbg}[Nj
//			{
//				WK7Model		*pModel;
//				WK7JObj			*pJOBj;
//				if ( (pModel = mpNpcChara->GetModel()) != NULL ){
//					pJOBj = pModel->GetObj(K7CHRBONE_WAIST);
//				}
//				
//				BloodEfcCall(&mDamage, myPos, pJOBj);
//			}
//			
//			mDamage.mDamHitRequest = 0;
//#endif
//		}
////		Cmd_ResetSet();
	}
#endif

	// _[W
	if( DamageTest() == true )
	{
		// ɎSԂ牽Ȃ
		if( (WK7NpcBossHngControlState)mState == NPC_HNG_STATE_DIE )
		{
/*
//			PlaySE( SFX_BOSS_HNG_DIE ) ;
			PlayEffectSEP( SFX_BOSS_HNG_DIE, GetRandI2Num( 100, -100 ) ) ;

			// Ō̃_[WGtFNgo
			CreateDamageBloodEffect( DMGBLD_HNG_LASTHIT, mDamage.mDamPos ) ;
			
			// o
			for( int i = 0 ; i < 30 ; i ++ )
			{
				Vec v ;
				GXColor Color ;
				
				GetDirVec( &v, GetRandFNum( PI ) - PI * 0.5F, GetRandFNum( PI_2 ) ) ;

				Color.r = (u8)VParam[ED_HITM][15] ;
				Color.g = (u8)VParam[ED_HITM][16] ;
				Color.b = (u8)VParam[ED_HITM][17] ;
				CreateBloodEffect( mDamage.mDamPos, v,
									VParam[ED_HITM][5] * 0.01F * 1.0F,		// MaxPower
									VParam[ED_HITM][5] * 0.05F * 1.0F,		// MinPower
									(u32)( VParam[ED_HITM][3] * 2 ),			// BloodNum
									0.2F,							// Size
									0.0F,							// YukaY
									TRUE,							// PerspectiveFlag
									0.0F,							// NoBlood
									0.01F,							// DirIgnore
									PI / 40.0F * VParam[ED_HITM][4 + 1 * 3] ,		// Range
									0.2F,							// BloodSize
									1,								// Mode
									0,								// WaitTime
									VParam[ED_HITM][0],				// FadeOutTime
									VParam[ED_HITM][1],				// FadeRandTime
									0.0F, 0.0F, 0.0F,
									VParam[ED_HITM][13],
									Color, Color,
									FEED_TIME, (u8)VParam[ED_HITM][14],
									0.0F, -1,
									0.0F, 0 ) ;
			}
			
			// ʂh炷
			CreateImpactEffect( 20, 10, (Vec){0.0F, 0.0F, 0.0F}, 5, 0, TRUE ) ;
*/			
			goto HITEND ;
		}
		
		// }XN̏ꍇ͖Ń~X
		if( WK7PLAYERCONTROL->GetMainID() == K7MSK )
		{
			// }YtbṼ[V𖳌ɂ
			ShotReset() ;
		
			PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
			goto HITEND ;
		}
	
	
		// oAtOĂ牽Ȃ
		if( mBarrierFlag == true )
		{
			// sGtFNgo
			CreateDamageBloodEffect( DMGBLD_HNG_MISS, mDamage.mDamPos ) ;
			
			PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
			goto HITEND ;
		}
		
		// ԂOiKꍇ
		if( (WK7NpcBossHngControlState)mState == NPC_HNG_STATE_BATTLE3 )
		{
			if( mNewGunFlag == true )
			{
				PlaySE( SFX_BOSS_HNG_DIE ) ;

				// fւ
				GetCoreJObj()->GetObj( "Body" )->Hide( false, true ) ;
				GetCoreJObj()->GetObj( "Body_Hungry" )->Disp( false, true ) ;
				GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Hide( false, true ) ;
				GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
				GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;

				
				// Ō̃_[WGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_LASTHIT, mDamage.mDamPos ) ;
				
				// o
				for( int i = 0 ; i < 30 ; i ++ )
				{
					Vec v ;
					GXColor Color ;
					
					GetDirVec( &v, GetRandFNum( PI ) - PI * 0.5F, GetRandFNum( PI_2 ) ) ;
/*					CreateHitMarkEffect( 1,				// _[W̑傫( 0: 1: 2: )
							mDamage.mDamPos,	// W
							v,					// 
							GetCoreJObj(),		// e_Ɉԋ߂ JObj
							0.0F				// ̍
							 ) ;
*/
					Color.r = (u8)VParam[ED_HITM][15] ;
					Color.g = (u8)VParam[ED_HITM][16] ;
					Color.b = (u8)VParam[ED_HITM][17] ;
					CreateBloodEffect( mDamage.mDamPos, v,
										VParam[ED_HITM][5] * 0.01F * 1.0F,		// MaxPower
										VParam[ED_HITM][5] * 0.05F * 1.0F,		// MinPower
										(u32)( VParam[ED_HITM][3] * 2 ),			// BloodNum
										0.2F,							// Size
										0.0F,							// YukaY
										TRUE,							// PerspectiveFlag
										0.0F,							// NoBlood
										0.01F,							// DirIgnore
										PI / 40.0F * VParam[ED_HITM][4 + 1 * 3] ,		// Range
										0.2F,							// BloodSize
										1,								// Mode
										0,								// WaitTime
										VParam[ED_HITM][0],				// FadeOutTime
										VParam[ED_HITM][1],				// FadeRandTime
										0.0F, 0.0F, 0.0F,
										VParam[ED_HITM][13],
										Color, Color,
										FEED_TIME, (u8)VParam[ED_HITM][14],
										0.0F, -1,
										0.0F, 0 ) ;
				}
				
				// ʂh炷
				CreateImpactEffect( 20, 10, (Vec){0.0F, 0.0F, 0.0F}, 5, 0, TRUE ) ;
			
	//			mBatteleExit = 1 ;
				mState = ( WK7NpcControlState )NPC_HNG_STATE_DIE ;
				con = mod = 0 ;
				return true ;
			}
			else
			{
				// sGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_MISS, mDamage.mDamPos ) ;
				
				PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
				goto HITEND ;
			}
		}
		
		// }YtbṼ[V𖳌ɂ
		ShotReset() ;

		// Y{EĂȂhꓖ蔻菈s
		if( mZubonFlag == false )
		{
			s8 HitPos, MovDir ;
			
			// Ă𓾂
			MovDir = GetYureDir() ;
			
			// ꂽ𓾂
			HitPos = GetHitPos() ;
			
			// łꂽӏSꍇ͉
			if( HitPos == 0 || mZubonNugeFlag == true )
			{
				// sGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_MISS, mDamage.mDamPos ) ;
				
				PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
				goto HITEND ;
			}
			
			// ĂƌꂽXɗh炷
			if( HitPos == MovDir || mYurePower == 0 )
			{
				s32 yure ;
				bool loop ;
				
				// GtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_SUCCESS, mDamage.mDamPos ) ;
				
				yure = mYurePower + 1 ;
				if( yure >= MAXYUREPOWER )
				{
					yure = MAXYUREPOWER ;
					 
					GetYureJObj()->GetObj( "Hit_big" )->Disp( false, true ) ;
					GetYureJObj()->GetObj( "core_big" )->Disp( false, true ) ;
			
					// Y{EtO𗧂Ă
					mZubonNugeFlag = true ;
					mZubonFlag = false ;
					loop = false ;

					PlaySE( SFX_BOSS_HNG_PANTSSLIPOFF ) ;
					 
					// erȂƂɂ
/*					mShotWait = 0 ;
					mShotCounter = 0 ;
					mShotFlag = false ;
					mShotFireFlag = false ;
					mShotActionFlag = false ;
*/				}
				else
				{
					PlaySE( SFX_BOSS_HNG_DAMAGE ) ;

					loop = true ;
				}
				
				PlaySE( SFX_BOSS_HNG_HIT ) ;
				
				// hꃂ[V̍Đ
				PlayHNGYureMotion( (u32)yure, HitPos, loop ) ;
			}
			else
			{
				s32 yure ;
				
				// sGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_MISS, mDamage.mDamPos ) ;
				
				PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
				
				yure = mYurePower - 1 ;
				if( yure < 0 ) yure = 0 ;
				
				// hꃂ[V̍Đ
				PlayHNGYureMotion( (u32)yure ) ;
			}
		}
		else
		{
			Vec target ;
			s32 damage ;
			f32 length ;
		
			// Y{EĂ珈𕪊

			// }ɃqbgĂ邩ǂ𔻒肷
			GetYureJObj()->GetObj( HITNAME )->GetWorldPosition( &target ) ;
			if( ( length = VECDistance( &mDamage.mDamPos, &target ) ) > HITSIZE )
			{
				// sGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_MISS, mDamage.mDamPos ) ;

//				OSReport( "Length=%f\n", length ) ;
				PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
				goto HITEND ;
			}
			
			// eǂŃ_[WύX
			if( mDamage.mDamType == DAMTYPE_DANSPATK )
			{
				damage = VITAL ;		// eȂꌂ
			}
			else
			{
				damage = mDamage.mDamPoint ;

				// _[WGtFNgo
				CreateDamageBloodEffect( DMGBLD_HNG_DAMAGE, mDamage.mDamPos ) ;
			}
			
			// _[W[V𗬂
			PlayHNGBodyMotion( HNG_MOT_DAM, false, true ) ;

#ifdef	YAMADADEBUG
			OSReport( "Damage=%d\n", damage ) ;
#endif

			// go炷
			mData.mHp -= damage ;

			// goOȉɂȂ甚
			if( mData.mHp <= 0 )
			{
/*				CreateHSDeadEffect( GetYureJObj(),			// GtFNg JObj
								(Vec){ 0.0F, 1.0F, 0.0F }, 			// ł
								VParam[ED_HSD1][0] / 10.0F,			// ԑ
								0.0F,								// ̍
								(u16)( VParam[ED_HSD1][1] * 1 ),	// ̐w
								(u8)VParam[ED_HSD1][2],				// ܂ł̒
								0									// [h(0:ŏČオxArxNgς郂[h
																	//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
																	//			2:X[ɂȂ炸Ad͂ʂɂ
																	//			3:ӂӂ炵ȂYɔł )
																	//			4:mode0 ɕ̊𒲐 
								);
*/

				// fւ
				GetCoreJObj()->GetObj( "Body" )->Hide( false, true ) ;
				GetCoreJObj()->GetObj( "Body_Hungry" )->Hide( false, true ) ;
				GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Disp( false, true ) ;
				GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
				GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;

				PlayEffectSE( SFX_BOSS_HNG_VITALDESTROY ) ;
				PlayEffectSE( SFX_BT_HSNEST_BREAK ) ;
				// 퓬I
//				mBatteleExit = 1 ;

				// e𗎂ƂAtO𗧂Ă
//				mGunOtosiFlag = true ;
//				PlaySE( SFX_BOSS_HNG_GUNFALL ) ;

				// eO	
				DetachGun();
	
				// oAtO𗧂Ă
				mBarrierFlag = true ;
				
				// ԂiKɎĂ
				mState = ( WK7NpcControlState )NPC_HNG_STATE_BATTLE2 ;
				con = 0 ;
				mod = 0 ;
			}
			else
			{
				PlaySE( SFX_BOSS_HNG_VITALSPOT ) ;
			}
		}
	}
	HITEND :
	
	KisimiSoundFrame() ;
		
	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		switch (mInitProcess){
		case 0:
			if ( true == StateInit() ){						// ̒mStateςꂿႤ̂
				mState = NPC_STATE_INIT;
				mInitProcess++;
			}
			break;
		case 1:
			// ẽ[hĩ^C~OŃR[)
			if ( -1 == LoadGunArchive((s8)GUN_R) ) break;
															// pSEf[^̓ǂݍ
			// ǂݍ
			gpSound->mReadSsm( "seBossHng.ssm", eBankBoss ) ;
			
			// _ݒij
//			WeakPointEffectSet( K7CHRBONE_SKULL );
			mInitProcess++;
			break;
		case 2:
			if ( true == CheckGunArchiveLoad((s8)GUN_R) ) break;
			mpGun = NULL ;
			mInitProcess++;
			break;
			
		case 3:
			if( mFirstPosSet == false ) break ;
			
			// [vGtFNg̍쐬
			{
				Vec ropepos = { INITPOSX, 80.0F/*INITPOSY*/, INITPOSZ } ;
				WK7Chara *pCharaTmp = pCurrentChara();
				WK7Model *pModel ;

				if( pCharaTmp==NULL ) break ;
				if( (pModel = pCharaTmp->GetModel()) == NULL ) break ;
				Rope = CreateRopeEffect( 	&ropepos, 	NULL,
											NULL, 		pModel->GetObj( "Rope" ) ) ;
				if( Rope == NULL ) break ;
				RopeID = GetEffectID( Rope ) ;
				pModel->GetObj( "Rope" )->Hide( false, false ) ;
			}
			
			// [ṼZbg
//			PlayCommonMotion( HNG_MOT_YURE_S, true, true ) ;
			
			// [VZbg
			PlayHNGYureMotion( 0 ) ;

			// fZbg
			GetCoreJObj()->GetObj( "Body" )->Disp( false, true ) ;
			GetCoreJObj()->GetObj( "Body_Hungry" )->Hide( false, true ) ;
			GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Hide( false, true ) ;
			GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
			GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;
			
			mInitProcess ++ ;
			break ;
			
		case 4:
//			if( false == MotSet_Wait(false) ) break;
			mInitProcess++;
			con = mod = 0 ;
			mState = ( WK7NpcControlState )NPC_HNG_STATE_BATTLE1 ;
//			mState = NPC_STATE_WAIT;
			break;
		}
		break;
		
	case NPC_HNG_STATE_BATTLE1 :
		// Y{E鏈
		if( mZubonFlag == false )
		{
			if( mZubonNugeFlag == true )
			{
				while( mZubonKisimiSoundFlag == false )
				{
					WK7Chara	*pCharaTmp;
					WK7Model	*pModel;
					f32 		frame ;
					
					if( ( pCharaTmp	= pCurrentChara() 		) == NULL ) break ;
					if( ( pModel 	= pCharaTmp->GetModel()	) == NULL ) break ;
					
					// ݍĐĂ郂[Ṽt[ۑ
					frame = pModel->GetCurrentMotionFrame() ;
					
					if( frame > 55 )
					{
						PlaySE( (u32)HNG_KisimiSoundTable[4][1] ) ;
						mZubonKisimiSoundFlag = true ;
					}
					
					break ;
				}
			
				// [VIĂҋ@[Vs
				if( GetYureJObj()->GetMotionState( true, true ) == AOBJ_NO_ANIM )
				{
					// Y{ItO𗧂Ă
					mZubonFlag = true ;
					mZubonNugeFlag = false ;
					
					PlayHNGYureMotion( 0 ) ;
					PlayHNGBodyMotion( HNG_MOT_WAIT, true, true ) ;
				}
			}
		}
	
		if( con == 0 )
		{
			// ҋ@[VZbg
			mShotActionFlag = false ;
			PlayHNGBodyMotion( HNG_MOT_WAIT, true, true ) ;
			con ++ ;
		}

		// [Vn܂ĂȂ猂		
		if( mShotActionFlag == false && mZubonNugeFlag == false )
		{
			ShotInit() ;
		}
		ShotFrame() ;
		break ;
		
	case NPC_HNG_STATE_BATTLE2 :		// `
		switch( mod )
		{
		case 0 :		// j󂳂꒼E҂
			gpSound->mFadeVolumeStream( 0, STREAMFADETIME ) ;
			con = 0 ;	mod = 100 ;
			break ;
			
		case 100 :		// ҂
			con ++ ;
			if( con < STOPTIME ) break ;
			mod ++ ;	con ++ ;
			break ;
			
		case 101 :		// ubNgro鏈̊Jn
			gpSound->mPlayStreamNo( HPS_BOSS_CHO2, VOLUME_MUSIC, AXDRIVER_MAX_GROUP, false ) ;

			popupHSnum = 0 ;
			mod = 1 ;
			con = BHSPOPWAIT ;
			con2 = 0 ;
			break ;
			
		case 1 :		// ubNgroJn
			// 莞Ԍo߂QȖڊJn
			if( con2 < PLAYWAIT ) con2 ++ ;
			if( con2 == PLAYWAIT )
			{
//				gpSound->mPlayStreamNo( HPS_BOSS_CHO2, VOLUME_MUSIC, AXDRIVER_MAX_GROUP, false ) ;
				con2 ++ ;
			}
			con ++ ;
			if( con >= BHSPOPWAIT )
			{
				con = 0 ;
				popHSRun( popupHSnum ) ;
				popupHSnum ++ ;
				if( popupHSnum == 7 )
				{
					mod ++ ;
				}
			}
			break ;
		
		case 2 :
			// 莞Ԍo߂QȖڊJn
			if( con2 < PLAYWAIT ) con2 ++ ;
			if( con2 == PLAYWAIT )
			{
//				gpSound->mPlayStreamNo( HPS_BOSS_CHO2, VOLUME_MUSIC, AXDRIVER_MAX_GROUP, false ) ;
				con2 ++ ;
			}

			if( CheckpopUpRunFlag() ) break ;
			
			con ++ ;
			if( con >= ALLBHSPOPUPWAIT )
			{
				con = 0 ;
				mod ++ ;
			}
			break ;
			
		case 3 :		// O`ԂɈڍs
			{
				mState = (WK7NpcControlState)NPC_HNG_STATE_BATTLE3 ;
				con = 0 ;
				mod = 0 ;
				
				// e𗎂ƂAtO𗧂Ă
				mGunOtosiFlag = true ;
				PlaySE( SFX_BOSS_HNG_GUNFALL ) ;
			}
			break ;
		}
		break ;
			
	case NPC_HNG_STATE_BATTLE3 :		// O`
		if( mBarrierFlag == false )
		{
			con ++ ;
			if( con >= WARAIWAIT )
			{
				con = 0 ;
				PlaySE( SFX_BOSS_HNG_NODAMAGE ) ;
			}
		}
		break ;
		
	case NPC_HNG_STATE_DIE :			// S
		switch( mod )
		{
		case 0 :	// ҂
			con ++ ;
			if( con >= DIEWAIT )
			{
				con = 0 ;
				mod ++ ;
			}
			break ;
			
		case 1 :	// 
			CreateHSDeadEffect( GetYureJObj(),			// GtFNg JObj
								(Vec){ 0.0F, 1.0F, 0.0F }, 			// ł
								VParam[ED_HSD1][0] / 10.0F,			// ԑ
								0.0F,								// ̍
								(u16)( VParam[ED_HSD1][1] * 1 ),	// ̐w
								(u8)VParam[ED_HSD1][2],				// ܂ł̒
								0									// [h(0:ŏČオxArxNgς郂[h
																	//			1:X[ɂȂ邪AxNgς炸Ad͂ʂɂ 
																	//			2:X[ɂȂ炸Ad͂ʂɂ
																	//			3:ӂӂ炵ȂYɔł )
																	//			4:mode0 ɕ̊𒲐 
								);
								
			// f
			GetYureJObj()->Hide( false, true ) ;
			
			con = 0 ;
			mod ++ ;
			break ;
		
		case 2 :	// ҂
			con ++ ;
			if( con >= BOMWAIT )
			{
				con = 0 ;
				mod ++ ;
			}
			break ;	
			
		case 3 :	// 퓬I
			mBatteleExit = true ;
			break ;
		}
		break ;
		
	case NPC_STATE_WAIT:
/*
		if ( 1 == K7EnmHNG::mHNGBattleStart ){
		}
		
		// Ȑ
		if ( true == MotStatus_Wait() ) break;
*/		
		break;
	case NPC_STATE_RUN:
		break;
	case NPC_STATE_SHOTPOSE:											// \Jn
		break;
	case NPC_STATE_SHOTFREE:											// ˌ\[v
		break;
	case NPC_STATE_SHOTNOW:												// ˌ
		break;
	case NPC_STATE_DMG:
		break;
	case NPC_STATE_ACTION:
		break;
	case NPC_STATE_DIE:
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
//			ReleaseWeakPoint();
			mState = NPC_STATE_LOSS;
		}
		break;
	case NPC_STATE_LOSS:
		break;
	}
	return false;
}


bool K7EnmHNG::FrameProcess(void)
{
	MotionProcess();
	if( mpNpcChara!=NULL ){
		
		if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
#if FUJITA //030702
			//_B
			{
				Vec eye;
				WK7CAM->GetPosition( eye );
				
				//_JOBJAJɂ炷ʁB
				//f32 dist = 5.f;
				f32 dist = -5.f;
				
				//_̏B
//				PlayWeakPoint( eye, dist );
			}
#endif
			// XLjORg[
//			ScanContorol();
			
			// B鏈Rg[
//			HideContorol();
			
			// [VXs[hRg[
//			MotionSpeedControl();
			
			// ŏ̈ʒuZbg̎
			if( !mFirstPosSet ){
				WK7Model *pModel;
				
				mFirstPosSet = 1;
//				mpNpcChara->SetPosition(mPosition);
//				mpNpcChara->SetRotY(mTargetRotY);
				Vec pos = { INITPOSX, INITPOSY, INITPOSZ } ;
				mpNpcChara->SetPosition( pos ) ;
				mpNpcChara->SetRotY( PI ) ;
				
				SetVisible(true);
				
				if( (pModel = mpNpcChara->GetModel())!=NULL ){
					mpNpcChara->SetRenderFlag(true);
					pModel->Disp();
				}
				
				// _[iqbg̃sbN̂߂ɂKvsj
				switch( mpNpcChara->GetRenderID() ){
				case	WK7RENDEROBJ_INVALID_RENDERID:
//				case	WK7RENDEROBJ_RENDERID_MAX:
				case	WK7RENDEROBJ_RENDERID_DEFAULT:
					mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
					mpNpcChara->EnableVfxEffect();
					break;
				default:
					break;
				}
			}
		VisibleTest();
		VisibleReflesh() ;
		}
	}
	return true;
}

// \ԂXV
void K7EnmHNG::VisibleReflesh( void )
{
	if( GetYureJObj() == NULL ) return ;
	if( GetCoreJObj() == NULL ) return ;
	
	// łꍇ
	if( (WK7NpcBossHngControlState)mState == NPC_HNG_STATE_DIE )
	{
		if( mod > 1 )
		{
			GetYureJObj()->Hide( false, true ) ;
		}
		else
		{
			GetCoreJObj()->GetObj( "Body" )->Hide( false, true ) ;
			GetCoreJObj()->GetObj( "Body_Hungry" )->Disp( false, true ) ;
			GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Hide( false, true ) ;
			GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
			GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;
		}
		GetYureJObj()->GetObj( "Pant_02" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "Pant" )->Hide( false, true ) ;
	}
	else
	// ԂOiKꍇ
	if( (WK7NpcBossHngControlState)mState == NPC_HNG_STATE_BATTLE3 )
	{
		GetCoreJObj()->GetObj( "Body" )->Hide( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Hungry" )->Hide( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Disp( false, true ) ;
		GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "Pant_02" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "Pant" )->Hide( false, true ) ;
	}
	else
	// ԂiKꍇ
	if( (WK7NpcBossHngControlState)mState == NPC_HNG_STATE_BATTLE2 )
	{
		GetCoreJObj()->GetObj( "Body" )->Hide( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Hungry" )->Hide( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Disp( false, true ) ;
		GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "Pant_02" )->Hide( false, true ) ;
		GetYureJObj()->GetObj( "Pant" )->Hide( false, true ) ;
	}
	else
	{
		// ȊȌꍇ
		if( mZubonNugeFlag == true || mZubonFlag == true )
		{
			GetYureJObj()->GetObj( "Hit_big" )->Disp( false, true ) ;
			GetYureJObj()->GetObj( "core_big" )->Disp( false, true ) ;
			GetYureJObj()->GetObj( "Pant" )->Hide( false, true ) ;
		}
		else
		{
			GetYureJObj()->GetObj( "Hit_big" )->Hide( false, true ) ;
			GetYureJObj()->GetObj( "core_big" )->Hide( false, true ) ;
		}
		GetCoreJObj()->GetObj( "Body" )->Disp( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Hungry" )->Hide( false, true ) ;
		GetCoreJObj()->GetObj( "Body_Jyouhansin" )->Hide( false, true ) ;
	}

	// W
	GetYureJObj()->GetObj( "Rope" )->Hide( false, false ) ;
	if( mZubonNugeFlag == false )
	{
		GetYureJObj()->GetObj( "Pant_02" )->Hide( false, true ) ;
	}
	return ;	
}

/*
	
	
	Ď֐
	
	
*/
void K7EnmHNG::StageProc(WK7Stage *pCurrentStage)
{
	K7Stage553M00 *pStage = (K7Stage553M00 *)pCurrentStage;
	
	switch (mBattleProcess){
	case 0:							// ҋ@
//		pStage->GetJObj( "curtain" )->Hide( false, true ) ;
		if ( 1 == K7EnmHNG::mHNGBattleStart ){
			mBattleProcess = 1;
		}
		break;
	case 1:							// 퓬
		break ;
	default:
		break;
	}
}

/*
	
	
	IH
	
	<return>
	-1			{XIilSj
	1			{XIif|[Sj
	0			{X풆
	
*/
int K7EnmHNG::HNGBossEnd(void)
{
	return mBatteleExit;
}

// e
void K7EnmHNG::ShotInit( void )
{
	// ܂ł̎Ԃ
	mShotWait = (s16)GetRandI2Num( SHOTMAXWAIT, SHOTMINWAIT ) ;
	mShotCounter = 0 ;
	mShotFlag = false ;
	mShotFireFlag = false ;
	mShotActionFlag = true ;
}

// eԂȂƂɂ
void K7EnmHNG::ShotReset( void )
{
	if( mShotActionFlag == false ) return ;

	// erȂƂɂ
	mShotWait = 0 ;
	mShotCounter = 0 ;
	mShotFlag = false ;
	mShotFireFlag = false ;
	mShotActionFlag = false ;
	if( Muzzle != NULL && CheckEffectValidState( Muzzle, (u32)MuzzleID ) == TRUE )
		DeleteEffect( Muzzle ) ;
	Muzzle = NULL ;
	MuzzleID = -1 ;
	
	// ҋ@[hɂ
	PlayHNGBodyMotion( HNG_MOT_WAIT, true, true ) ;
}

// e̃t[vZX
void K7EnmHNG::ShotFrame( void )
{
	if( mShotActionFlag == false ) return ;

	// en߂Ă邩ǂŏ𕪊
	if( mShotFlag == true )
	{
		// [Ṽt[𓾂
		if( mShotFireFlag == false )
		{
			if( GetCoreJObj()->GetCurrentMotionFrame() >= MUZZLEWAIT )
			{
				PlaySE( SFX_BOSS_HNG_SYAGEKI ) ;
				Muzzle = ::CreateMuzzleEffect( GUN_R, 0.0F ) ;
				MuzzleID = (s32)::GetEffectID( Muzzle ) ;
				mShotFireFlag = true ;
			}
		}
		else
		{
			// Vbg鎞Ԃv[[̓_[W󂯂
			if( mShotCounter == SHOTHITWAIT )
			{
				Vec pos ;
				
				WK7PLAYERCONTROL->GetPosition( &pos ) ;
				WK7PLAYERCONTROL->SetPcDamage( pos, SHOTDAMAGE, 1);				// |WVA_[WlA[h
			}
			mShotCounter ++ ;

			// [VIēxԂɖ߂
			if( GetCoreJObj()->GetMotionState() == AOBJ_NO_ANIM )
			{
				mShotActionFlag = false ;
				PlayHNGBodyMotion( HNG_MOT_WAIT, true, true ) ;
			}
		}
	}
	else
	{
		// n߂JEg
		mShotWait -- ;
		if( mShotWait <= 0 )
		{
			// 
			mShotCounter = 0 ;
			mShotFlag = true ;

			// e[VĐ
			PlayHNGBodyMotion( HNG_MOT_SHOTNOW, false, true ) ;
		}
	}
}

// ݂̗hꃂ[V̕𓾂( -1:  1:E )
s8 K7EnmHNG::GetYureDir( void )
{
	WK7Chara		*pCharaTmp;
	WK7Model		*pModel;
	f32 frame ;

	pCharaTmp = pCurrentChara();
	if( pCharaTmp==NULL ){
		return false;
	}
	if( (pModel = pCharaTmp->GetModel()) == NULL ){
		return false;
	}
	
	frame = pModel->GetCurrentMotionFrame() ;
	if( ( frame < YUREMOTTIME / 4.0F ) ||
		( frame > YUREMOTTIME - YUREMOTTIME / 4.0F ) ) return 1 ;
	else return -1 ;
}

// ꂽ𓾂( -1:g  1:Eg  0:S )
s8 K7EnmHNG::GetHitPos( void )
{
	switch( mDamage.mNearHitID )
	{
	case NPCWEAKOBJID_WAIST :
	case NPCWEAKOBJID_HEAD :
		return 0 ;
		
	case NPCWEAKOBJID_LARM :			// r
	case NPCWEAKOBJID_LFOOT :			// 
		return -1 ;
	
	case NPCWEAKOBJID_RFOOT :			// E
	case NPCWEAKOBJID_RARM :			// Er
		return 1 ;
		
	default : return 0 ;
	}
}

// Đ
void K7EnmHNG::PlaySE( u32 id )
{
	Vec pos ;
	
	GetCoreJObj()->GetWorldPosition( &pos ) ;
//	PlayEffectSE3D( (s32)id, pos ) ;
	PlayEffectSE( (s32)id ) ;
}

void K7EnmHNG::popHSInit( s32 id )
{
	HNGSMOKE *sm = &popupHS[id] ;
	
	sm->mod = 0 ;
	sm->con = 0 ;
	sm->smoke = NULL ;
	sm->smokeid = 0 ;
	sm->smoke2 = NULL ;
	sm->smokeid2 = 0 ;
	sm->runflag = false ;
}

void K7EnmHNG::popHSFrame( s32 id )
{
	HNGSMOKE *sm = &popupHS[id] ;
	
	if( sm->runflag == false ) return ;

	switch( sm->mod )
	{
	case 0 :		// o
		{
			Vec start, end ;
		
			GetCoreJObj()->GetWorldPosition( &start ) ;
			sm->hs = WK7Npc::Find( (u32)( ENENO_5_553M00_BLHS_0 + id ) ) ;
			if( sm->hs == NULL ) break ;
//			sm->hs->pCurrentChara()->GetModel()->GetObj( "Root_joint" )->GetWorldPosition( &end ) ;
			sm->hs->GetPosition( end ) ;

			// GtFNg
			sm->smoke = CreateSmokeObj2Effect( start, end,
									 SMO_HNG_SMALL, SMO_HNG_SMALL,
									 BHSSMOKESPEED ) ;
			if( sm->smoke == NULL ) break ;
			sm->smokeid = GetEffectID( sm->smoke ) ;
			
			sm->mod ++ ;
			sm->con = 0 ;
		}
		break ;
		
	case 1 :
		sm->con ++ ;
		if( sm->con >= BHSSMOKE2WAIT )
		{
			sm->mod ++ ;
			sm->con = 0 ;
		}
		break ;

	case 2 :	// ̉GtFNg𔭐
		{
			Vec pos ;
			
			sm->hs->pCurrentChara()->GetModel()->GetObj( "Root_joint" )->GetWorldPosition( &pos ) ;
				
			sm->smoke2 = CreateSmokeObjEffect( SMO_HNG_BIG, pos, BHSSMOKE2TIME ) ;
			if( sm->smoke2 == NULL ) break ;
			sm->smokeid2 = GetEffectID( sm->smoke2 ) ;
			
			sm->mod ++ ;
			sm->con = 0 ;
		}
		break ;
		
	case 3 :
		sm->con ++ ;
		if( sm->con >= BHSPOPUPWAIT )
		{
			sm->con = 0 ;
			sm->mod ++ ;
		}
		break ;
		
	case 4 :		// gr|bvAbv
		if( sm->hs->AiModeSet_TestPop() == false ) break ;
		
		sm->hs->AiModeSet_PopGo();
		
		sm->runflag = false ;
		sm->mod = 0 ;
		sm->con = 0 ;
		break ;
	}
}

void K7EnmHNG::popHSEnd( s32 id )
{
	HNGSMOKE *sm = &popupHS[id] ;
	
	if( CheckEffectValidState( sm->smoke, sm->smokeid ) == TRUE )
		DeleteEffect( sm->smoke ) ;
	if( CheckEffectValidState( sm->smoke2, sm->smokeid2 ) == TRUE )
		DeleteEffect( sm->smoke2 ) ;
}

bool K7EnmHNG::CheckpopUpRunFlag( void )
{
	s32 i ;

	for( i = 0 ; i < 7 ; i ++ )
		if( popupHS[i].runflag == true ) return true ;
	
	return false ;
}

