////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmKIS.cpp {X LXM
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
/*

	_ړ
	
	_낯
	
	l_ł炢
	
ok	l[hɋA낯
	

*/
////////////////////////////////////////////////////////////////////////////////

#define	__ENMKIS_CPP__

#include "EnmKIS.h"
#include "..\Fujita\C_Font.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7Util.h"
#include "..\Yam\YK7EffectMuzzle.h"
#include "..\Yam\YK7EffectTime.h"
#include "..\Yam\YK7EffectHitNum.h"
#include "..\Yam\YK7EffectMiss.h"
#include "..\Matsu\mK7Noise.h"
#include "..\Wat\K7GlobalFlag.h"
#include "..\Wat\WK7EventScript.h"


#define SECOND_SHOT_FRAME		(10)
#define BATTLE_SEC				(60)
#define BATTLE_TIME				(WK7_SEC_TO_FRAME(BATTLE_SEC))
//#define BATTLE_TIME				(WK7_SEC_TO_FRAME(2))


int K7EnmKIS::mKisBattleStart = 0;			// LXM{XJtO

s16 MotionIDTableKIS[] = {
	20,				// R
	100,			// ˌ\
	101,			// ˌR
	102,			// ˌP
	103,			// ˌQi[vj
	104,			// ˌ
	110,			// [h
	150,			// _[W
	310,			// S
	-1
};



#define SFX_BT_HS_KISUGI_MAX	(2)
static int damageSeTbl[SFX_BT_HS_KISUGI_MAX] = {
	SFX_BOSS_KIS_DMG_VOICE0,
	SFX_BOSS_KIS_DMG_VOICE1
};


void K7EnmKIS::Dummy( void )
{
}


K7EnmKIS::K7EnmKIS(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7KIS, MotionIDTableKIS)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= KIS_HP;							// go
	mData.mWeakID		= -1;								// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// XP[
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mInitProcess		= 0;
	mpGun[0]			= (WK7Model *) NULL;
	mpGun[1]			= (WK7Model *) NULL;
	
	mBulletNow			= KIS_GUN_BULLET_MAX;
	mShotNum			= 0;
	
	K7EnmKIS::mKisBattleStart = 0;
	
	mBattleCount		= BATTLE_TIME;
	mBatteleExit		= true;
	mBattleProcess		= 0;
	
	mpTimer				= NULL;
	mTimerEffectID		= 0xffffffff;
	mpResultScore		= NULL;
	mResultScoreEffectID= 0xffffffff;
	
	mHitNum[0]			= 0;
	mHitNum[1]			= 0;
	
	mPauseChk			= 0;
	mNoHit				= 0;
	
//	mMotID				= KIS_MOT_WAIT;
//	mState.Init( KIB_KRR_COMMON_ATK0 );
	
}
K7EnmKIS::~K7EnmKIS()
{
	Release();
	WK7RenderObj::SetVfxFlag( true );
}

void K7EnmKIS::Release(void)
{
	TimerRelease();
	ScoreRelease();
	// ̔RĂ鉹~
	gpSound->mStopSE(SFX_BOSS_KIS_MERAMERA);
	gpSound->mReleaseSsm( "seBossKis.ssm" );
	DetachGun();
	ReleaseModel    ();
	ReleaseMotionAll();
}
void K7EnmKIS::TimerRelease(void)
{
	// ^C}[GtFNg̉
	if ( mpTimer!=NULL && mTimerEffectID!=0xffffffff && ::CheckEffectValidState(mpTimer,mTimerEffectID)==TRUE ){
		::DelReqEffect(mpTimer);
		mTimerEffectID = 0xffffffff;
	}
	mpTimer        = NULL;
	mTimerEffectID = 0xffffffff;
}

/*
	
	
	XRAGtFNg̍쐬
	
	
*/
bool K7EnmKIS::ScoreCreate(s32 playernum, s32 enemynum)
{
	mpResultScore = CreateHitNumEffect(playernum, enemynum);
	if ( mpResultScore != NULL ){
		mResultScoreEffectID = ::GetEffectID(mpResultScore);
		return true;
	}
	return false;
}
void K7EnmKIS::ScoreRelease(void)
{
	// ^C}[GtFNg̉
	if ( mpResultScore!=NULL && mResultScoreEffectID!=0xffffffff && ::CheckEffectValidState(mpResultScore,mResultScoreEffectID)==TRUE ){
		::DelReqEffect(mpResultScore);
		mResultScoreEffectID = 0xffffffff;
	}
	mpResultScore        = NULL;
	mResultScoreEffectID = 0xffffffff;
}

void K7EnmKIS::DetachGun(void)
{
	if ( mpGun[0] ){
		DetachGunModel((s8)GUN_R);
		mpGun[0] = (WK7Model *)0;
	}
	if ( mpGun[1] ){
		DetachGunModel((s8)GUN_L);
		mpGun[1] = (WK7Model *)0;
	}
	ReleaseGunArchive(GUN_R);
	ReleaseGunArchive(GUN_L);
}

bool K7EnmKIS::ControlProcess(void)
{
	Vec myPos;

	if ( mpNpcChara==NULL )			return true;
	if ( true == IsLoading() ) 		return true;											// ǂݍݒ
	if ( mState == NPC_STATE_INIT )	goto NPC_CTRL_INIT_JUMP;
	
	if ( WK7GameInfo::SPMENU ==  GameInfo.GetMode() ) return true;
	
	mpNpcChara->GetPosition(myPos);
	
	// _[W炢`FbN
	if ((true == DamageTest())
	&&	(!mNoHit)
	){
//		if (mState == NPC_STATE_RELOAD){						// Hi[Vj
		if (((mDamage.mNearHitID) == mData.mWeakID)
		&&	(-1 != mDamage.mNearHitID)
//		&&	(mDamage.mDamWeakHitOk)
		){
			DamageMotSet();
			WeakPointChange();
			mState = NPC_STATE_DMG;
		}
		// ꐺrd
		if ( 0 == (rand()&4) ) {
			gpSound->mPlaySE(damageSeTbl[rand()%SFX_BT_HS_KISUGI_MAX]);
		}
		
		// GtFNgiqbg}[Nj
		mHitNum[0] ++;
		{
			WK7Model		*pModel;
			WK7JObj			*pJOBj;
			if ( (pModel = mpNpcChara->GetModel()) != NULL ){
				pJOBj = pModel->GetObj(K7CHRBONE_WAIST);
			}
			
			BloodEfcCall(mDamage.mDamPos, mDamage.mDamDir, myPos, (s16 )1, pJOBj, 0, 0);

//			KK7BattleDefaultBloodStart(	mDamage.mDamPos,
//										myPos,
//										mDamage.mDamDir,
//										pJOBj
//			);
		}
		
		mDamage.mDamHitRequest = 0;
	}
	
	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		switch (mInitProcess){
		case 0:
			if ( true == StateInit() ){						// ̒mStateςꂿႤ̂
				mState = NPC_STATE_INIT;
				mInitProcess++;
			}
			break;
		case 1:
			// ẽ[hĩ^C~OŃR[)
			if ( -1 == LoadGunArchive((s8)GUN_L) ) break;
			if ( -1 == LoadGunArchive((s8)GUN_R) ) break;
			
															// LXMpSEf[^̓ǂݍ
			gpSound->mReadSsm( "seBossKis.ssm", eBankBoss );
			
			mInitProcess++;
			break;
		case 2:
			if ( true == CheckGunArchiveLoad((s8)GUN_L) ) break;
			if ( true == CheckGunArchiveLoad((s8)GUN_R) ) break;
			if ( eSndStandby != gpSound->mGetProcess() )  break;
			
			// nCf̏eɃA^b`
			mpGun[0] = AttachGunModel(	(s8)GUN_R,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_R											// E肩肩
			);
			mpGun[1] = AttachGunModel(	(s8)GUN_L,
										NULL,												// NULL I[gŃA^b`
										mpNpcChara->GetModel(),
										GUN_HAND_L											// E肩肩
			);
			
			mInitProcess++;
			break;
		case 3:
			
			WeakPointChange();
			
			// ̔RĂ鉹Đ
			gpSound->mPlaySE(SFX_BOSS_KIS_MERAMERA);
			
			if( false == MotSet_Wait(false) ) break;
			mInitProcess++;
			mState = NPC_STATE_WAIT;
			break;
		}
		break;
	case NPC_STATE_WAIT:
		// l\A퓬Jn
#if 0
		if ( PC_STATE_SHOTPOSE == WK7PLAYERCONTROL->GetPcState() ){
			K7EnmKIS::mKisBattleStart = 1;
		}
#endif
		
		if ( 1 == K7EnmKIS::mKisBattleStart ){
			if ( true == MotSet_ShotPose(1.f, KIS_MOT_SHOTPOSE) ){
				break;
			}
		}
		
		// Ȑ
		if ( true == MotStatus_Wait() ) break;
		
		break;
	case NPC_STATE_SHOTPOSE:
		MotStatus_ShotPose(KIS_MOT_SHOTFREE);
		break;
	case NPC_STATE_SHOTFREE:											// ˌ\
		// \炷Aˌ[VĐ
					
		// C
		if ( KIS_MOT_SHOTNOW != mMotID ){
				
				// ˌ[VP
				
			SetRotCalc(1.f);
			MotPlayInit(NPC_POSMODE_DATA);
			if ( false == PlayCommonMotion(KIS_MOT_SHOTNOW, false, true, 0.f) ){
				break;
			}
			
			gpSound->mPlaySE(SFX_BOSS_KIS_SYAGEKI);
			
			mSecondShotTiming = 0;
			mBulletNow-=1;
			PcDamageSet(0);
		}else{
			if ( SECOND_SHOT_FRAME == mSecondShotTiming ){
				// lɃ_[W^
				mBulletNow-=1;
				PcDamageSet(1);
			}
			if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
				
				// ˌ[VQ
				
				MotPlayInit(NPC_POSMODE_DATA);
				if ( false == PlayCommonMotion(KIS_MOT_SHOTNOWLOOP, false, false, 0.f) ){
					break;
				}
				
				gpSound->mPlaySE(SFX_BOSS_KIS_SYAGEKI);
				
				mSecondShotTiming = 0;
				mBulletNow-=1;
				PcDamageSet(0);
				mState = NPC_STATE_SHOTNOW;
			}
		}
		mSecondShotTiming++;
		break;
	case NPC_STATE_SHOTNOW:
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			if ( mBulletNow > 0 ){
				
				// e܂
				// ˌ[VQ
				
				MotPlayInit(NPC_POSMODE_DATA);
				if ( false == PlayCommonMotion(KIS_MOT_SHOTNOWLOOP, false, false, 0.f) ){
					break;
				}
				mSecondShotTiming = 0;
				mBulletNow-=1;
				PcDamageSet(0);
			}else{
				
				// eȂ [h
				
				MotPlayInit(NPC_POSMODE_DATA);
				if ( false == PlayCommonMotion(KIS_MOT_RELOAD, false, true, 0.f) ){
					break;
				}
				mBulletNow = KIS_GUN_BULLET_MAX;
				KisReload();
				mState = NPC_STATE_RELOAD;
			}
		}
		if ( SECOND_SHOT_FRAME == mSecondShotTiming ){
			// lɃ_[W^
			mBulletNow-=1;
			PcDamageSet(1);
		}
		mSecondShotTiming++;
		break;
	case NPC_STATE_RELOAD:
		// ˌ\ւȂ
		MotStatus_Reload(KIS_MOT_SHOTFREE);
		break;
	case NPC_STATE_DMG:
		// _[W
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			// I
			MotStatus_Reload(KIS_MOT_SHOTFREE);
		}
		break;
	case NPC_STATE_EVENT:
		break;
	case NPC_STATE_DIE:
		if ( WK7MODEL_NOANIM == GetCommonMotionState() ){
			ReleaseWeakPoint();
			mState = NPC_STATE_LOSS;
		}
		break;
	case NPC_STATE_LOSS:
		break;
	}
	
	return false;
}

/*
	
	
	lɃ_[Wݒ肷B
	
	
*/
void K7EnmKIS::PcDamageSet(int side)
{
	Vec myPos;
	int baseNum, randNum;
	
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE) ){
		baseNum = 4;
		randNum = 4;
	}else{
		if ((K7CAT == WK7PLAYERCONTROL->GetMainID())
		||	(K7HAY == WK7PLAYERCONTROL->GetMainID())
		){
			baseNum = 0;
			randNum = 1;
		}else{
			baseNum = 2;
			randNum = 3;
		}
	}
	
	if ( 1 == mBattleProcess ){
		
		mpNpcChara->GetPosition(myPos);
		
		if ( 0 == side ){
			CreateMuzzleEffect( GUN_L, myPos.y );
		}else{
			CreateMuzzleEffect( GUN_R, myPos.y );
		}
		
		mShotNum++;
		
		if ( (baseNum+rand()%randNum) <= mShotNum ){
			s16 damageType = 2;
			mShotNum = 0;
			int criticalRate;
			
			// NeBJmݒ
			if ( K7HAY == WK7PLAYERCONTROL->GetMainID() ){
				criticalRate = 8;
			}else{
				criticalRate = 20;
			}
			if ((PC_STATE_DMG != WK7PLAYERCONTROL->GetPcState())
			&&	(0 == (rand()%criticalRate))
			&&	(false == K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE))
			){
				damageType = 0;
			}
			
			WK7PLAYERCONTROL->SetPcDamage(myPos, 0, damageType, SFX_BOSS_KIS_ATC_VOICE, 10);				// |WVA_[WlA[h
			
			mHitNum[1]++;
		}else{
			// ͂ꂽ̃GtFNgRcŒeo
			
			// _ň̋̈ʒuɒe|Cg쐬
			f32 rotY = HSD_Randf() * PI;
			f32 pcRotY;
			Vec sePos;
			
			WK7PLAYERCONTROL->GetWaistPosition(&sePos);
			WK7PLAYERCONTROL->GetRotY(&pcRotY);
			pcRotY = pcRotY + rotY;
			GHM_LIMIT_RANGE(pcRotY, PI, -PI);
			sePos.x += 15.f * sinf(mRotY);
			sePos.z += 15.f * cosf(mRotY);
			
			gpSound->mPlaySE3D( SFX_BT_TYOUDAN, sePos, 1 );		// erdĐ
			
		}
	}
}

/*
	
	ꃂ[VZbg
	
*/
void K7EnmKIS::DamageMotSet(void)
{
	MotPlayInit(NPC_POSMODE_DATA);
	if ( false == PlayCommonMotion(KIS_MOT_DAM, false, true, 0.f, 0.5f) ){
		
	}
	gpSound->mPlaySE(SFX_BOSS_KIS_DMG_VOICE2);
}


/*
	
	S[VZbg
	
*/
void K7EnmKIS::DieMotSet(void)
{
	
	// LXMSSE
	gpSound->mPlaySE(SFX_BOSS_KIS_DIE);
	
#if 0
	MotPlayInit(NPC_POSMODE_DATA);
#else
	WaistToRoot();
#endif
	if ( false == PlayCommonMotion(KIS_MOT_DIE, false, false, 0.f) ){
		
	}
	
	mState = NPC_STATE_DIE;
}



/*
	
	_ύX
	
*/
void K7EnmKIS::WeakPointChange(void)
{
	int weakPos;
	
	weakPos = rand()%KIS_WEAKPOS_MAX;
	
	switch ( weakPos ){
	case 0:
		mData.mWeakID	= NPCWEAKOBJID_HEAD;
		break;
	case 1:
		mData.mWeakID	= NPCWEAKOBJID_RARM;
		break;
	case 2:
	default:
		mData.mWeakID	= NPCWEAKOBJID_LARM;
		break;
	}
	
	WeakPointEffectSet(pKISWeakObjNameTable[weakPos]);
}


//@----------------------------------------------------------------------------------------------






/*	
	
	
	t[vZX
	
	
*/
bool K7EnmKIS::FrameProcess(void)
{
	MotionProcess();
	if( mpNpcChara!=NULL ){
		
		if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
#if FUJITA //030702
			//_B
			{
				Vec eye;
				WK7CAM->GetPosition( eye );
				
				//_JOBJAJɂ炷ʁB
				//f32 dist = 5.f;
				f32 dist = -5.f;
				
				//_̏B
				PlayWeakPoint( eye, dist );
			}
#endif
			// XLjORg[
//			ScanContorol();
			
			// B鏈Rg[
//			HideContorol();
			
			// [VXs[hRg[
			MotionSpeedControl();
			
			// ŏ̈ʒuZbg̎
			if( !mFirstPosSet ){
				WK7Model *pModel;
				
				mFirstPosSet = 1;
				mpNpcChara->SetPosition(mPosition);
				mpNpcChara->SetRotY(mTargetRotY);
				SetVisible(true);
				
				if( (pModel = mpNpcChara->GetModel())!=NULL ){
					mpNpcChara->SetRenderFlag(true);
					pModel->Disp();
				}
				
				// _[iqbg̃sbN̂߂ɂKvsj
				switch( mpNpcChara->GetRenderID() ){
				case	WK7RENDEROBJ_INVALID_RENDERID:
//				case	WK7RENDEROBJ_RENDERID_MAX:
				case	WK7RENDEROBJ_RENDERID_DEFAULT:
					mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
					mpNpcChara->EnableVfxEffect();
					break;
				default:
					break;
				}
			}
// Rc
#if 0
			// nCfȅ
			{
				int i;
				for (i=0; i<2; i++){
					if ( NULL != mpGun[i] ){
						mpGun[i]->FrameProcess();
					}
				}
			}
			
			// nCfe̕`揈
			{
				int i;
				for (i=0; i<2; i++){
					if ( NULL != mpGun[i] ){
						mpGun[i]->RenderProcess();
					}
				}
			}
#endif
		}
	
		VisibleTest();
	}
	return true;
}

/*
	
	
	LXM{XĎ֐
	
	
*/
static Vec camPos, camSet, camTag;
void K7EnmKIS::StageProc(void)
{
	WK7Stage *pCurrentStage;
	WK7JObj  *pJObj;
	f32 	gravi = 0.f;

#ifdef _DEBUG
//		{
//			C_Paper		paper(570, 24 + 16);
//			PRINTF("E%d:P%d \n", mHitNum[0], mHitNum[1]);
//		}
#endif

	switch (mBattleProcess){
	case 0:							// ҋ@
		if ( 1 == K7EnmKIS::mKisBattleStart ){
			// ^C}[
			mpTimer = CreateTimeEffect(BATTLE_SEC);
			if ( mpTimer != NULL ){
				mTimerEffectID = ::GetEffectID(mpTimer);
				
				// JEgJn
				StartTimeEffect(mpTimer);
				
				gpSound->mPlayStreamNo(HPS_BOSS_KIS);			//@퓬ȊJnI
				
				mBattleProcess++;
			}
		}
		break;
	case 1:
		if ( 1 == K7EnmKIS::mKisBattleStart ){
			// LXMƑłIII
			if ( mpTimer != NULL ){
				if ((true == GetPause())
				||	(true == GetBattlePause())
				||	(WK7GameInfo::SPMENU ==  GameInfo.GetMode())
				){
					PauseTimeEffect(mpTimer);					// |[Y^C}[~߂
					gpSound->mSetPauseStream();					// Xg[̈ꎞ~
				}else{
					if ( !mPauseChk ){
						StartTimeEffect(mpTimer);
						gpSound->mReleasePauseStream();			// Xg[̈ꎞ~
						mPauseChk = 0;
					}
				}
			}
			
			if ( 2 == GetTimeEffectState(mpTimer) ){			// ^C}[̃JEg~܂ŁA키
				//  ^C}[OɂȂu
				GameInfo.SetSpecialEnable(false );
				TimerRelease();
				mNoHit = 1;
				mBattleProcess++;
			}
		}
		break;
	case 2:														// Ip̃f|Ă
		Vec pos;
		pCurrentStage = WK7Stage::GetCurrentStage();
		
		pJObj = pCurrentStage->GetJObj("Fall");
		pJObj->GetPosition(pos);
		gravi += (0.98f/10.f);
		pos.y -= 3.f + gravi;
		
		pJObj->SetPosition(pos);
		
		if ( pos.y < 0.f ){
			KK7ShakeCamera();
//			pBattleMain->BattleCamera.CameraShakeCountSet(0);	// Jh炷
			gpSound->mPlaySE(SFX_BOSS_KIS_ZUSIN);				// IuWFNgi[jAh
			mBattleCount = WK7_SEC_TO_FRAME(5);
			mBattleProcess++;
		}
		camPos.x = 60.f;
		camPos.y = 14.f;
		camPos.z = 36.f;
		camTag.x = 0.f;
		camTag.y = 14.f;
		camTag.z = 36.f;
		break;
	case 3:															// |Ă郂f҂
		mBattleCount--;
		if ( 0 == mBattleCount ){
			pBattleMain->BattleMainTaskExit(2);						// og^XNIɏI点
			mBattleProcess++;
		}
		break;
	case 4:
		if ( GameInfo.GetBattleTask() == false ){
			GameInfo.SetMode(WK7GameInfo::PLAY);					// K7SCR_ENTER_PLAYMODE()
			WK7PLAYERCONTROL->SetOperateEnable(false);				// l̑얳
			SetNpcState(NPC_STATE_EVENT);							// LXM̃Xe[^X NPC_STATE_EVENT ɂ
			
			camTag.x = 0.f;
			camTag.y = 13.f;
			camTag.z = 0.f;
			camPos.x = -24.f;
			camPos.y = 13.f;
			camPos.z = 0.f;
			
			camSet.x = -53.f;
			camSet.y = 13.f;
			camSet.z = 0.f;
			
			mBattleCount = WK7_SEC_TO_FRAME(4);
			
			mBattleProcess++;
		}
		break;
	case 5:
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		KK7VecMove(&camSet, &camPos, 32.f);
		WK7CAM->SetPosition       (camPos);
		WK7CAM->SetTargetPosition (camTag);
		mBattleCount--;
		if ( 0 == mBattleCount ){
			// 퓬ȏI
			gpSound->mStopStream();
			mBattleCount = 15;
			mBattleProcess++;
		}
		break;
	case 6:
		if ( 0 == mBattleCount ){
			if ( true == ScoreCreate((s32 )mHitNum[0], (s32 )mHitNum[1]) ){			// XRA\
				mBattleProcess++;
			}
		}else{
			mBattleCount--;
		}
		break;
	case 7:
		pCurrentStage = WK7Stage::GetCurrentStage();
		
		//  ************ 퓬IIII    ******************
		// ŁALXMl̂ǂ炪ʂׂă[VĐ
		if ( 1 == GetHitNumEffectState(mpResultScore) ){
			
			if( (pJObj=pCurrentStage->PlayMotion("Fall", 001))!=NULL ){				// 
				
				gpSound->mPlaySE( SFX_BOSS_KIS_FUKUSHIMA_BREAK );					//tNV}̋B
				
				pJObj->SetMotionLoop(false);
			}
			
			if ( mHitNum[0] > mHitNum[1] ){
				// LXM
				DieMotSet();
				mBattleProcess++;
			}else{
				Vec dummyPos={0.f, 0.f, 0.f};
				// LXM
				WK7PLAYERCONTROL->SetGameOver( PC_GAMEOVER_KISBATTLE );
				WK7PLAYERCONTROL->SetPcDamage(dummyPos, 0, 3);						// |WVA_[WlA[h
				mBattleCount = 10;
				mBattleProcess++;
			}
			
		}
		break;
	case 8:
		if ( mHitNum[0] > mHitNum[1] ){
			if (mState == NPC_STATE_LOSS ){
				ScoreRelease();
				mBattleCount = WK7_SEC_TO_FRAME(2);
				mBattleProcess++;
			}
		}else{
			// ŏɉƂ͂
			if ( mBattleCount-- ){
				
			}else{
				gpSound->mPlaySE(SFX_BOSS_KISUGI_WINVOICE);							// LXM{CX
			}
			WK7PLAYERCONTROL->ClearGameOver();
		}
		break;
	case 9:
		if ( mBattleCount-- ){
		}else{
#if 1
			//mCY
//			gpNoise->mSandRequest(eSandLongNoise);													// LȂꍇ
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);			// Lꍇ

#else
			k7app.SetFadeColor(0);
			k7app.FadeStart(0xff,WK7_DEFAULT_FADE_TICK);
#endif
			mBattleProcess++;
		}
		break;
	case 10:
#if 1
		//mCY҂
		if ( gpNoise->mGetSandFrameProc()==eSandExec ){
			Release();
			mBattleProcess++;
		}
#else
		if ( k7app.IsFade()==false ){
//			GameInfo.SetMode(WK7GameInfo::MOVE);				//K7SCR_EXIT_PLAYMODE();
			Release();
			mBattleProcess++;
		}
#endif
		break;
	default:
		mBatteleExit = false;
		break;
	}
}

/*
	
	
	LXM{XIH
	
	<return>
	false			{XI
	
	
*/
bool K7EnmKIS::KISBossEnd(void)
{
	return mBatteleExit;
}


void K7EnmKIS::KisReload(void)
{
	Vec enePos;
	
	GetPosition(enePos);
	gpSound->mPlaySE3D( SFX_BOSS_KIS_RELOAD, enePos, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env );	// rdĐ	
}




