////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmKun.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMKUN_CPP__

#include "..\Matsu\mK7Sound.h"
#include "..\Fujita\C_Vfx.h"
#include "EnmKUN.h"
//#include "EnmANG.h"

s16 MotionIDTableKUN[] = {
	20,							// R
	40,							//zg̎ŔB
	-1
};

#define APPEAR_COUNT  260
#define HOLE_PRE 10
#define HOLE_POST 40
#define HOLE_FRM (HOLE_PRE+HOLE_POST)
static HSD_JObj *hand_jobj=0;
K7EnmKUN *K7EnmKUN::instance = 0;
static
HSD_FogDesc gFogDesc = {
  GX_FOG_LIN,                                  /* fog type */
  NULL,                                        /* adjdesc */
  85.0f,                                        /* startz */
  (512.f + 1024.0f),                              /* endz */
  {255, 255, 255, 255},                         /* color */
};
bool K7EnmKUN::alive = false;
void K7EnmKUN::Dummy( void )
{
}

K7EnmKUN::K7EnmKUN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
  K7EnmBoss( enemyid, suffix, pAnchor, prio, K7KUN, MotionIDTableKUN )
{
  // Gʂ̃f[^̃Zbg
  mData.mHp			= 100;								// go
  mData.mWeakID		= NPCWEAKOBJID_RARM;				// _
  mData.mVLossID		= NPCWEAKOBJID_LFOOT;				// ʐѕ
  mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
  mData.mScale		= 1.f;								// 
  hole = 0;
  blur = 0;
  save_intensity = WK7RenderObj::VFXGetIntensity();
  WK7RenderObj::VFXSetIntensity(0.f);
  hole_alpha = 224;//eLg[ɈԂłȂB
  alive = true;
  hand_jobj = 0;
  appear_count = 0;
  fog = HSD_FogLoadDesc(&gFogDesc);
  disp_start = false;
  instance = this;
  yamada_effect = 0;
  game_state = KUN_GAME_STATE0;
  mot_id = -1;
  counter = 0;
}
K7EnmKUN::~K7EnmKUN()
{
  if( hole ) delete hole;
  if( blur ) delete blur;
  WK7RenderObj::VFXSetIntensity( save_intensity );
  WK7RenderObj::GetVFX()->SetTargetAlpha( -1 );
  hand_jobj = 0;
  instance = 0;
  if( fog ){
	HSD_FogUnref( fog );
	fog = NULL;
  }
  if( yamada_effect && GetEffectValidState( yamada_effect ) ) ::DelReqEffect( yamada_effect ) ;
  yamada_effect = NULL;
  GHM_SAFE_DELETE(mpAlpha_set);
}
bool K7EnmKUN::IsAppeard( void )
{
  if( instance ){
	if( instance->appear_count > (APPEAR_COUNT+150) ) return true;
	return false;
  }else{
	return false;
  }
}
Vec *K7EnmKUN::GetHitPos( void )
{
  if( instance ){
	//return &(instance->mDamage.mDamPos);
	return &(instance->dam_pos);
  }else{
	return 0;
  }
}

void K7EnmKUN::AdditionalPreRenderProcess( void )
{
  if( game_state == KUN_GAME_STATE1 )  if( hole ) hole->Disp();
}
void K7EnmKUN::AdditionalPostRenderProcess( void )
{
  if( game_state == KUN_GAME_STATE1 )  if( blur ) blur->Disp();
}
bool K7EnmKUN::HitRightHand( Vec &pos )
{
  if( !hand_jobj ) return false;

  Vec hand_pos;
  HSD_JObjSetupMatrix( hand_jobj );
  HSD_MtxGetTranslate( hand_jobj->mtx, &hand_pos );
  if( VECSquareDistance( &pos, &hand_pos ) > (f32)(2*2) ) 
	return false;
  else 
	return true;
}
bool K7EnmKUN::ControlProcess(void)
{
	WK7Model *pModel;
#define MOTION_END( ) (GetCommonMotionState() == WK7MODEL_NOANIM)
#define MOTION_REWIND(  ) (GetCommonMotionState() == AOBJ_ANIM_REWINDED)
#define IS_MOTION( Y ) ((u32)(mot_id == Y))
#define PLAY( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, false )
#define PLAY_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), false, true )
#define PLAY_LOOP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, false )
#define PLAY_LOOP_INTRP( Y ) PlayCommonMotion( (u32)(mot_id = Y), true, true )
#define PERCENT( X ) ((HSD_Rand()%101) > (100-X) )
#define MOT_FRAME( ) (  mpRootBone ? mpRootBone->GetCurrentMotionFrame() : 0 ) 
	if ( mpNpcChara==NULL ) return true;
	if ( mState == NPC_STATE_INIT ) goto NPC_CTRL_INIT_JUMP;
	if( (pModel = mpNpcChara->GetModel())==NULL ) return true;
	
	if( GetNpcPause() ) return true;

	switch( mState ){
	case NPC_STATE_INIT:
NPC_CTRL_INIT_JUMP:
		StateInit();
		break;
	case NPC_STATE_WAIT:
	case NPC_STATE_WALK:
	case NPC_STATE_RUN:
	case NPC_STATE_TURN:
	case NPC_STATE_ATK:
	case NPC_STATE_DMG:
	case NPC_STATE_DMG_FALL:
	case NPC_STATE_LOSS:
	case NPC_STATE_DIE:
	default:
		break;
	}

	if( !disp_start ) return true;
	if( alive == false ) return true;

	if( game_state == KUN_GAME_STATE0 ){
	  if( IS_MOTION( 1 ) ){
	  }else{
		PLAY_LOOP( 1 );
	  }
	  counter = (counter + 1 ) % 360;
	  f32 a_ = sinf( 2.f * (f32)M_PI * counter / 360.f );
	  if( a_ < 0.f ){
		a_ = 0.f;
		GHM_SAFE_DELETE(mpAlpha_set);
		pModel->Hide();
		mpNpcChara->SetRenderFlag(false);
		mpNpcChara->SetVisible(false);
		mPosition = GetEnemyList( GetEneNo() )->pos;
		mPosition.x += (HSD_Rand()%40 - 20);
		pCurrentChara()->SetPosition(mPosition);
	  }else{
		pModel->Disp();
		mpNpcChara->SetRenderFlag(true);
		mpNpcChara->SetVisible(true);
		if( mpAlpha_set == 0 ){
		  mpAlpha_set = new C_SetAlpha( pCurrentChara(), mHideAlphaNow );
		}
		a_ = a_ * a_ * a_;
		mpAlpha_set->SetVal( mHideAlphaNow = a_ );
		if ( true == DamageTest() && mHideAlphaNow > 0.6f){
		  //ǂłǂB
		  alive = false;
		}
	  }

	}else{
	  // _[W炢`FbN
	  //Vec p_ = {52.f, 0.f, -535.f};
	  Vec p_ = {52.f, 0.f, -530.f};
	  mPosition = p_;
	  pCurrentChara()->SetPosition(mPosition);
	  GHM_SAFE_DELETE(mpAlpha_set);
	  pModel->Disp();
	  mpNpcChara->SetRenderFlag(true);
	  mpNpcChara->SetVisible(true);
	  if( IS_MOTION( 0 ) ){
	  }else{
		PLAY_LOOP( 0 );
	  }

	  if ( true == DamageTest() ){
		if( HitRightHand(mDamage.mDamPos) ){
		  dam_pos = mDamage.mDamPos;
		  //B
		  alive = false;
		  //gpSound->mPlaySE( SFX_BOSS_ANGKUN_SLOWMOTION );
		}else  if( !hole ){
		  hole = new C_Hole( mDamage.mpObjBone->GetJObj(), 
							 &mDamage.mDamDir,
							 mDamage.mDamPos.x, 
							 mDamage.mDamPos.y, 
							 mDamage.mDamPos.z, 2.0f, HOLE_PRE, HOLE_POST, hole_alpha );
		  mpNpcChara->mpAdditionalPreRender = this;
		  WK7RenderObj::GetVFX()->SetTargetAlpha( hole_alpha );
		  gpSound->mPlaySE( SFX_BOSS_ANGKUN_HIT_NODAMAGE );
		}
		mDamage.mDamHitRequest = 0;
	  }
	}
	
	return false;
}
bool K7EnmKUN::FrameProcess(void)
{
  if( GetNpcPause() ) return true;

  MotionProcess();
  if( mpNpcChara!=NULL ){
		
	if( mpNpcChara->GetState()==WK7RenderObj::LOADED ){
			
	  {
		WK7Model *pModel;
		if( (pModel = mpNpcChara->GetModel())!=NULL ){
#if 0
		  if( !K7EnmANG::IsExplode() ) {
			pModel->Hide();
			mpNpcChara->SetRenderFlag(false);
		  }else if( ++appear_count ){
			if( appear_count < APPEAR_COUNT ){
			  if( appear_count > (APPEAR_COUNT/2) ){
				pModel->Disp();
				mpNpcChara->SetRenderFlag(true);
			  }
			  f32 val = sinf( (f32)M_PI * appear_count / (f32)APPEAR_COUNT );
			  fog->startz = (1.f-val) * gFogDesc.startz;
			  fog->endz = fog->startz + 10.f + 127.f*(1.f-val);
			  WK7RenderObj::SetFog( fog );
			}
		  }
#endif
#if 0
		  if( disp_start ){
#if 0
			if( !yamada_effect ){
			  Vec p;
			  mpNpcChara->GetJObj()->GetWorldPosition(&p);
			  p.y += 5.f;
			  yamada_effect =  CreateKunSmokeEffect( p );
			}else{
			}
#endif
			pModel->Disp();
			mpNpcChara->SetRenderFlag(true);
		  }else{
			pModel->Hide();
			mpNpcChara->SetRenderFlag(false);
		  }
#endif
		}
	  }


	  //B
	  if( hole ){
		s32 frm = hole->Proc();
		if( frm ){
		  f32 val = sinf( (f32)M_PI * (HOLE_FRM - frm) / (f32)HOLE_FRM )*0.5f;
		  WK7RenderObj::VFXSetIntensity( val );
		}else{
		  delete hole;
		  hole = 0;
		  mpNpcChara->mpAdditionalPreRender = 0;
		  WK7RenderObj::GetVFX()->SetTargetAlpha( -1 );
		  WK7RenderObj::VFXSetIntensity( 0.f );		  
		}
	  }
	  // [VXs[hRg[
	  MotionSpeedControl();
			
	  // ŏ̈ʒuZbg̎
	  if( !mFirstPosSet ){
		//̓͓ȂƓȂȂĂB040108
		mpNpcChara->SetVisible(true);
		mHideAlphaNow       = 1.0f;
		PlayCommonMotion( 0, true, false );
		//u[
		if( !blur ){
		  HSD_JObj *root_jobj = mpNpcChara->GetJObj()->GetJObj();
		  HSD_JObj *target_jobj = mpNpcChara->GetJObj("WristR_joint")->GetJObj();
		  HSD_JObj *add_jobj = mpNpcChara->GetJObj("Knl_Hands")->GetJObj();
		  blur = new C_RadialBlur( root_jobj, target_jobj, add_jobj );
		  //blur->SetScale( 38.f );
		  mpNpcChara->mpAdditionalPostRender = this;
		}
		mFirstPosSet = 1;
		mpNpcChara->SetPosition(mPosition);
		// ꂪȂƑȂB
		switch( mpNpcChara->GetRenderID() ){
		case	WK7RENDEROBJ_INVALID_RENDERID:
		  //			case	WK7RENDEROBJ_RENDERID_MAX:
		case	WK7RENDEROBJ_RENDERID_DEFAULT:
		  mpNpcChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
		  mpNpcChara->EnableVfxEffect();
		  break;
		default:
		  break;
		}
		hand_jobj = mpNpcChara->GetJObj("WristR_joint")->GetJObj();
	  }

	}
  }
	
  return true;
}
