////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmM.cpp			
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
// @@@@K7ENM_L_EGG

////////////////////////////////////////////////////////////////////////////////

#define	__ENMM_CPP__

#include "EnmM.h"
#include "..\Wat\WK7EventScript.h"
#include "..\Wat\K7GlobalFlag.h"

#define MDLCODE_ID				(15)			// dmHQwww ́H̔ԍifj
#define MOTCODE_HS_ID			(2)				// dmHQwww ́H̔ԍi[Vj
#define MOTCODE_EGG_ID			(15)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeMMotionIdTable[] = {
	20,							// R
	50,							// 
	90,							// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	60,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	-1
};

s16 npcTypeMEggMotionIdTable[] = {
	0,							// f
	700,						// f
	20,							// R
	310,						// 
};

// e[u
static int eneFootSeTbl[] = {
	SFX_BT_HS_FOOT_STEP00,
	SFX_BT_HS_FOOT_STEP01,
	SFX_BT_HS_FOOT_STEP02,
	SFX_BT_HS_FOOT_STEP03,
	SFX_BT_HS_FOOT_STEP04,
	SFX_BT_HS_FOOT_STEP05
};


K7EnmM::K7EnmM(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	if ( true == K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7) ){	// zbp[[h
		CreateModel (K7CHRID(K7ENMID(31),      0), false);
		mData.mHopper = 1;
	}else{
		CreateModel (K7CHRID(K7ENMID(2),       suffix), false);
	}
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix), true);
	
	// [Vǂݍ
	CreatePackMotion(npcTypeMMotionIdTable,    MOTCODE_HS_ID);
	CreatePackMotion(npcTypeMEggMotionIdTable, MOTCODE_EGG_ID,	WK7MOTION_NPCCMN_STD_NUM);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	mData.mWeakID		= -1;								// _ijiŏȂ̂Łj
	mData.mVLossID		= -1;								// ʐѕiŏȂ̂Łj
	mData.mFootSe		= SFX_BT_HSEGG_ROLL;				// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= -1;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;								// JE^[U炢\
	mData.mMultiChara	= 1;								// }`L
	mData.mTypeEgg		= 1;								// 
	mData.mAtkDist		= 0.f;								// U
	mData.mAtkDistBk	= mData.mAtkDist;
	
	mEgg				= 1;								// Ԃn܂
}

void K7EnmM::FootSeWalk(Vec myPos)
{
	// rdĐ
	// [vrd{[`FW
	if ( true == EggTest() ){
		if (2 == GetCurrentMotionFrame()){
			gpSound->mPlaySE3D( (int )mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}else{
		if(	(pCurrentChara()!=NULL)
		&&	(mData.mFootSe != 0)
		){
			if ((2  == GetCurrentMotionFrame())
			||	(30 == GetCurrentMotionFrame())
			){
				gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%6], myPos, 0 );		// rdĐ
				if( 2  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
			}
		}
	}
}


void K7EnmM::FootSeRun(Vec myPos)
{
	// [vrd{[`FW
	if ( true == EggTest() ){
		if (2 == GetCurrentMotionFrame()){
			gpSound->mPlaySE3D( (int )mData.mFootSe, myPos, 0 );		// rdĐ
		}
	}else{
		if(	(pCurrentChara()!=NULL)
		&&	(mData.mFootSe != 0)
		){
			WK7Model *pModel = pCurrentChara()->GetModel();
			if ((2  == GetCurrentMotionFrame())
			||	(22 == GetCurrentMotionFrame())
			){
				gpSound->mPlaySE3D( (int )eneFootSeTbl[rand()%6], myPos, 0 );		// rdĐ
				if( 2  == GetCurrentMotionFrame() ){
					FootPaintTestSet(NPCWEAKOBJID_RFOOT);
				}else{
					FootPaintTestSet(NPCWEAKOBJID_LFOOT);
				}
			}
		}
	}
}


