////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmQ.cpp t@gX}C
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMQ_CPP__

#include "EnmQ.h"

#define MDLCODE_ID				(12)		// dmHQwww ́H̔ԍifj
#define MOTCODE_ID				(2)			// dmHQwww ́H̔ԍi[Vj

s16 npcTypeQMotionIdTable[] = {
	20,							// R
	50,							// 
	90,							// 
	120,						// ^[E
	130,						// ^[
	140,						// ^[
	0,							// UĂѓiNu쓮j
	420,						// 85cmɍU
	410,						// 150cmɍU
	150,						// _[WO
	160,						// _[W
	170,						// _[WO
	180,						// _[W
	190,						// _[WEO
	290,						// _[WE
	200,						// _[WO
	300,						// _[W
	210,						// _[WEgO
	220,						// _[WEg
	230,						// _[WgO
	240,						// _[Wg
	260,						// _[WӂƂу_EOiSj
	250,						// _[Wу_EiSj
	310,						// _[WE _E
	320,						// _[W _E
	330,						// _ER
	340,						// _E_[W
	350,						// _EȂ
	360,						// _EȂ瑖
	400,						// _E玀S
	440,						// _E85cmɍU
	430,						// _E150cmɍU
	0,							// [U[ōU
	0,							// [U[gro
	0,							// [U[grB
	0,							// ꎩR̂̂QiXs[hpj
	0,							// Xs[hX}CsJn
	0,							// Xs[hX}C
	500,						// ݍUi_j
	650,						// ݍUiRj
	450,						// ݍUiJGfj
	460,						// ݍUiR[ej
	470,						// ݍUi}XNj
	490,						// ݍUiPrj
	0,							// f
	0,							// f
	-1
};


K7EnmQ::K7EnmQ(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) : WK7Enemy(enemyid,pAnchor,prio)
{
	// fǂݍ
	CreateModel (K7CHRID(K7ENMID(MDLCODE_ID),  suffix));
	
	// [Vǂݍ
	CreatePackMotion(npcTypeQMotionIdTable, MOTCODE_ID);
	
	// Gʂ̃f[^̃Zbg
	mData.mHp			= 100;								// go
	
#if 1
	mData.mWeakID		= -1;
#else
	switch (suffix){										// suffixɂĕʂ̑傫Ⴄ̂ŕʂ̑傫Ƃ_ɂ
	case 0:
		mData.mWeakID	= NPCWEAKOBJID_HEAD;
		break;
	case 1:
		mData.mWeakID	= NPCWEAKOBJID_LARM;
		break;
	case 2:
		mData.mWeakID	= NPCWEAKOBJID_RARM;
		break;
	case 3:
		mData.mWeakID	= NPCWEAKOBJID_LFOOT;
		break;
	case 4:
		mData.mWeakID	= NPCWEAKOBJID_RFOOT;
		break;
	}
#endif
	
	mData.mVLossID		= -1;								// ʌ
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 1.f;								// 
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;					// _ʌŒ
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mCounterKurai	= 1;
}

/*
	
	
	p_[hc̊蓖
	
	
*/
void K7EnmQ::PartsRenderIDSet(void)
{
	u32 renderidex;
	WK7Model *pModel = pCurrentChara()->GetModel();
	
	renderidex = WK7RenderObj::GetUniqueRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	pCurrentChara()->SetRenderIDEx(renderidex);
	
	// ʂJOBJƂĂ
	if ( pModel != NULL ){
		WK7JObj *pJOBJ;
		switch (K7CHR_SUFFIX(mModelID)){
		case 0:
			pJOBJ   = pModel->GetObj("Weak_Head");					// IuWF񂷂̂ǂ
			break;
		case 1:
			pJOBJ   = pModel->GetObj("Weak_Arm_L");					// IuWF񂷂̂ǂ
			break;
		case 2:
			pJOBJ   = pModel->GetObj("Weak_Arm_R");					// IuWF񂷂̂ǂ
			break;
		case 3:
			pJOBJ   = pModel->GetObj("Weak_Foot_L");				// IuWF񂷂̂ǂ
			break;
		case 4:
			pJOBJ   = pModel->GetObj("Weak_Foot_R");				// IuWF񂷂̂ǂ
			break;
		}
		if ( pJOBJ != NULL ){
			pCurrentChara()->SetRenderIDEx(pJOBJ,false,true);		// ݂ɂȂł̂OKȏꍇ
//			pCurrentChara()->SetRenderIDEx(pJOBJ,false,false);		// ݂ɂȂł̂ȏꍇ
		}
	}
}


/*
	
	
	ȖG^C~O擾
	o[`p
	
	<return>
	true			G
	false			GȂ
	
*/
bool K7EnmQ::GetNoDamage(void)
{
	if ( mFantCounter ){							// łɃJE^[Ȗ̐̎
		
		if ( 1 == mDamage.mDamExHitOk ){
			return false;
		}
		if ((DAMTYPE_CATSPATK == mDamage.mDamType)
		||	(DAMTYPE_COUNTER == mDamage.mDamType)
		){
			return false;
		}
		
		return true;
	}
	return false;
}



