////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Enemy Object
//
// EnmTEN.cpp L Vg
//
// Creator       : Kawa
// Creation Date : 03/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__ENMTEN_CPP__

#include "EnmTEN.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Stage.h"
#include "..\Kaw\KK7Effect.h"
#include "..\Kaw\KK7Sound.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Yam\YK7EffectFeather.h"
#include "..\Yam\YK7EffectBlood.h"

#define TEN_ANGLE		(0.07f)
#define TEN_HEIGHT		(1.f)

void K7EnmTEN::Dummy( void )
{
}

#define TEN_WALK_SPEED	(36.481f / 30.f)
//#define WALK_SPEED			(9.694f / 30.f)

K7EnmTEN::K7EnmTEN(u32 enemyid, u32 suffix, ghmGcListObj *pAnchor, int prio) :
 K7EnmBoss(enemyid, suffix, pAnchor, prio, K7TEN, MotionIDTableTEN)
{
	// Gʂ̃f[^̃Zbg
	mData.mHp			= TEN_HP;							// go
	mData.mWeakID		= -1;								// _
	mData.mVLossID		= -1;								// ʐѕA
	mData.mFootSe		= SFX_BT_HS_FOOT_STEP00;			// 
	mData.mScale		= 0.175f;							// XP[
	mData.mBloodTexNum	= BLOODTEX_FEATHER;
	
	mData.mHpBk			= mData.mHp;
	mData.mWeakIDBk		= mData.mWeakID;
	mData.mVLossIDBk	= mData.mVLossID;
	mData.mAtkDist		= 10.f;
	mData.mAtkDistBk	= mData.mAtkDist;
	mData.mCounterKurai	= 0;								// s
	
	WK7RenderObj::SetVfxFlag( false );						// {X͂ɂ傤ɂ؂
	mAngle = 0.f;
	mCircleRadius		= TEN_ANGLE;
	mHeight				= TEN_HEIGHT;
}

K7EnmTEN::~K7EnmTEN()
{
	WK7RenderObj::SetVfxFlag( true );
}

void K7EnmTEN::Release(void)
{
	ReleaseModel    ();
	ReleaseMotionAll();
}


/*
	
	R̂̎̏
	
	
*/
bool K7EnmTEN::MotStatus_Wait(void)
{
	Vec enePos, newPos;
	f32 rotY;

	GetPosition(enePos);
	
	if(	(pCurrentChara()!=NULL)
	&&	(mLoopFootSEno >= 0)
	){
		u8 getVolume, getPan;
		
		// {[쐬
		seVolCalc(enePos, (u8 )mLoopSEVolNow, &getVolume, &getPan, (u8 )0);
		// {[ύXit[wj
		gpSound->mSetVolumeSENo(mLoopFootSEno, getVolume, 1 );
		// pύXit[wj
		gpSound->mSetPanSENo(mLoopFootSEno, getPan );
	}
	
	DmgSpeedSet(1.f);

	if ( mMotID != TEN_MOT_WAIT ){
		MotPlayInit(NPC_POSMODE_PROG);
		mMovePosMode = NPC_POSMODE_PROG;
		
		if( false == PlayCommonMotion(TEN_MOT_WAIT, true, false, 0.f) ){
			return false;
		}
		
	}
	
static f32 incAng = 0.0314f;
	mAngle += incAng;
	
	newPos.x = enePos.x + mCircleRadius * sinf(mAngle);
	newPos.z = enePos.z + mCircleRadius * cosf(mAngle);
	
	newPos.y = mInitPos.y + (mHeight * cosf(mAngle));
	
	SetPosition(newPos);
	
	// GtFNgo
	SetKiraKiraPos();
	
	rotY = atan2f(newPos.x - enePos.x, newPos.z - enePos.z);
	SetRotY(rotY);
	
	return false;
}

f32 K7EnmTEN::GetWalkSpeed(void)
{
	// [VړʂZo
	return TEN_WALK_SPEED;
}
f32 K7EnmTEN::GetRunSpeed(void)
{
	// [VړʂZo
	return TEN_WALK_SPEED;
}


