/*

 	KK7BattleMainTask.h

 Creator       : Kawakami Satoshi (GHM)
 Creation Date : 11/28/2002

*/

#ifndef	__KK7BATTLEMAINTASK_H__
#define	__KK7BATTLEMAINTASK_H__


#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Wat\K7App.h"
#include "..\Wat\WK7Cam.h"
#include "..\Wat\WK7Model.h"
#include "..\Kaw\KK7Define.h"
#include "..\Kaw\KK7Util.h"
#include "..\Kaw\KK7Prim.h"
#include "..\Kaw\KK7BattleCamera.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Player.h"
#include "..\Wat\WK7Stage.h"
#include "..\Wat\EnmList.h"


#define BUI_DIREGET_ID_WEAK			(0)
#define BUI_DIREGET_ID_HEAD			(1)
#define BUI_DIREGET_ID_JOINT		(2)


#define BATTLECAMMODE_KAMAE			(0)
#define BATTLECAMMODE_RELOAD		(1)
#define BATTLECAMMODE_DOWNATK		(2)
#define BATTLECAMMODE_SPATK			(3)
#define BATTLECAMMODE_ACTION		(4)
#define BATTLECAMMODE_MAX			(5)

typedef struct{
	WK7Npc			*mpSortNpc;
	f32				dist;				// 
	s16				kabeFlag;			// ǔp 0:ǒłȂ -1:Gl~[[Nz 1:ǉz
}SORTNPC;

typedef struct{
	S16POSXY		scrPos;				// ݂̃XN[|WV
	
	Vec				saveMyPos;			// ŏogɓĂƂ̃LW̕ۑ
//	Vec				standardRot;		// ׂĂ̊ƂȂpx
	
	Vec				worldPos;			// ݂̃[h|WV(KvȂȂ\)
	
	
//	Vec				worldRot;			// J̕
	Vec				sightRotBureReq;	// TCg̃upx\
	Vec				sightRot;			// TCg̕@[J
	Vec				shotRot;			// _Ă
	Vec				zoomRot;			// Y[̌vZp
//	Vec				camRot;				// TCgiJj̕
	Vec				frameMov;			// TCg̖t[̈ړpx
	Vec				padMov;				// TCg̖t[̈ړpx
}SIGHT;

enum _BATTLEFRAMEPROCESSSTATE{
	BATTLEFRAMEPROCESSSTATE_INIT = 0,
	BATTLEFRAMEPROCESSSTATE_READY,
	BATTLEFRAMEPROCESSSTATE_GO,
	BATTLEFRAMEPROCESSSTATE_EXIT,
};

class KK7BattleMainTask{
protected:
	static 	s16			mBattleProcessExit;						// ogvZXI
	u32					mBattlePad;								// L[pbh
	u32					mBattleTrg;								// L[gK
	f32					mBattlePadAnalogR;
	f32					mBattlePadAnalogL;
	f32					mLpadXF32, mLpadYF32;					// L[kAiRit[gj
	s8					mLpadX, mLpadY;							// L[kAiR
	s8					mRpadX, mRpadY;							// L[qAiR
	s16					mCamChangeMode;							// CJ [h
	s16					mCamLimitFlag;							// CJ ~bgtO
	s16					mSightLimitFlag;						// CTCg ~bgtO
	bool				mSightHitReqest;						// TCgGLN^[ɃqbgĂiPtOj
	s16					mTargetNum;								// L^[Qbg
	bool				mSightBureFlag;							// TCgԂꂳtO
	s16					mActiveCamProcess;						// ANeBuJvZX
	s16					mStartDemoTask;
	s16					mStartDemoCnt;
	s16					mEasyLockOnNum;							// ȒPbNIVXe
	f32					mShutterTiming;							// Vb^[^C~Ov
	
//	s16					mSightHandChangeCounter;				// ˌ̑Ώۃ|Cg؂ւJE^[
	s16					mProcess;								// og\ɂȂ܂ł̏vZXԍ
	s16					mSightHand;								// ˌ̑Ώۃ|Cg
	s16					mZoom;									// Y[[h 0:Y[AEg 1:Y[C
	s16					mZoomProcess;
	s16					mZoomNow;
	bool				mSightEnable;							// TCg\ONOFF
	SORTNPC				mSortNpc[ONE_AREA_MAXENEMY];			// G̋߂p
	
	WK7Cam::Mode		mCamModeSave;							// og[hhm̃J[h̃Z[u
	

	bool				Initialize(WK7Cam *pCamera);
	bool				BattleModeExitTest(void);
//	EFFECT 				*mpYamadaSight;
//	EFFECT 				*mpYamadaShutter;
//	EFFECT				*mpYamadaShutter2;
	WK7RenderObjEffect	*mpShutter2RenderEfc;
	
	bool				HitTest(int mode, WK7PcShotMode ShotMode);
	bool				SightZoomControl(u32 active, bool armDelay);
	u32 				ActiveCameraCtrl(void);
	void				SightBure(f32 *rotX, f32 *rotY);
	void 				SightZoomBure(f32 *rotX, f32 *rotY);
	WK7Npc				*pAutoLockTarget;

public:
	WK7RenderObjEffect	*mpShutterRenderEfc;
	WK7RenderObjEffect	*mpSightRenderEfc;
	u32					mID;									// IuWFNghc K7CHR_MAINID(mID)  Lhc̎擾
	KK7BattleCamera		BattleCamera;
	// Works
	WK7Cam				*mpCamera;								// gpĂJNX̊i[
	SIGHT				mSight;									// CTCg
	Vec					mCamSaveTgt;							// og[hhm̃JW
	Vec					mCamSavePos;							// og[hhm̃JW
	bool				mSightRenderFlag;
	
	s16					mStartDemo;								// ŏ̃J肷鉉of
//	f32					armback_dist;
	
	// Proc
	KK7BattleMainTask();
	virtual ~KK7BattleMainTask();
	
	bool				BattleMainTaskStart(u32 id, WK7Cam *pCamera);
	static bool			GetBattleTask(void);
	
	void				SetTargetNum(s16 num){ mTargetNum = num; };
	s16					GetTargetNum(void){ return mTargetNum; };

	// ȉAgp
	void				ClearCamLimitFlag(void){ mCamLimitFlag = 0; };
	s16					GetCamLimitFlag(void){ return mCamLimitFlag; };
	void				ClearSightLimitFlag(void){ mSightLimitFlag = 0; };
	s16					GetSightLimitFlag(void){ return mSightLimitFlag; };
//	void				SetCamLimitFlag(s16 flag){ mCamLimitFlag = flag; };
	bool				BattlePadRead(void);
	bool				ZoomControl(void);
	void				SightInfoPrimSet(bool zoom);
	void				SightScreenToWorld(f32 px, f32 py);
	void				BattleShotCalc(void);
	bool 				SightShotModeSet(bool flag);			// TCgˌ\ǂݒ肷
	bool				GetSightShotMode(void);
	void				EnemySort(void);

	void BattleShotCtrl(void);
	void SightRotCalc(bool zoom);
	void ShotRotCalc(void);
	void PcPosRotCalc(void);
	void LookSet(bool firstTest, int Process=0, f32 delay=AUTOLOCKON_DELAYSPEED);
	void CameraCalcAndSet(void);
	void SetPosition(Vec *pPos, bool flag=false);
	Vec *GetPosition(void);
	void SetCamRotY(f32 rot, bool flag=false);
	void SetCamRotX(f32 rot, bool flag=false);
	f32 GetCamRotY(void);
	f32 GetCamRotX(void);
	void SetSightRotY(f32 rot);
	void SetSightRotX(f32 rot);
	f32 GetSightRotY(void);
	f32 GetSightRotX(void);
	f32 GetRotY(void);
	f32 GetRotX(void);
	f32 RotXLimitTest(f32 camRotX);
	bool GetCurrentZoomIn(void);
	void SetZoomRotY(f32 rot);
	void SetZoomRotX(f32 rot);
	f32 GetZoomRotY(bool decOK=false);
	f32 GetZoomRotX(bool decOK=false);
	void KK7BattleStartDemo(f32 enemyRotY);
	void				CameraMove(bool zoom);
#if FUJITA
	Vec GetBattleCamEye( void ){ return BattleCamera.pos[NOW]; }
	Vec GetBattleCamTgt( void ){ return BattleCamera.tmpTarget; }
	f32 GetBattleCamFov( void ){ return BattleCamera.cFov; }
#endif	
	
	bool				BattleExit(s16 exitMode);
	// OQƗp
	bool				GetBattleZoomTest(void){				// true  Y[
		if ( 1 == mZoom ) return true;
		return false;
	};
	
	bool NowBalletSet(s16 bullet);								// og^XNɌ݂̎ceύX`
	void BureRequest(Vec bureRot);								// TCgh炷\
	
	
	EFFECT				*pGetYamadaSight(void);
	Vec 				*pGetSaveMyPos(void);
	
	static void			BattleMainTaskExit(int mode=1);			// og^XN̏I 1:Jɖ߂ 2:JŒ̂܂
	static s16 			GetBattleProcessExit(void);
	static void 		InitBattleProcessExit(){ mBattleProcessExit = 0; };
	
	static bool 		BattleMainTaskSetUp(ghmGcTaskController *pTaskFrameCtrl);
	static bool 		BattleMainTaskShutDown(void);
	
	void				CamSaveTgtChange(Vec tgt){ mCamSaveTgt = tgt; }
	void				CamSavePosChange(Vec pos){ mCamSavePos = pos; }
	
	f32					InitialKamaeDirSet(f32 PlRotY);
	void				BattleCameraInitInfoSet(f32 PlRotY, Vec *pPos);
	bool 				BuiDirGet(Vec *pRot, Vec SightPos, int searchPoint, int startEneNo, bool first=false );
	bool 				GetPcCamSetMode(void);
	WK7Npc 				*GetNearNpc(int id=0);
	f32					GetNearNpcDist(int id=0);
	s16					GetNearNpcKabeFlag(int id=0);
	void 				CallAttackCallBackTask(WK7AttackInfo info, s16 sightPx, s16 sightPy, u32 argb, Vec hitPos, WK7Npc *pNpc, WK7AttackinfoType type=WK7ATTACKINFO_TYPE_NORMALSHOT);
	
	void 				SetBasePosition(Vec *pPos);
	void 				SetBaseCamRotY(f32 rot);
	void				AutoLockOnReCharge(void);
	
	f32 				GetKamaeY(u32 mainID);
	
	void 				GetEnemyPositionforMskHitTest(WK7Npc *pNpc, Vec *pPos);
};


#ifdef __KK7BATTLEMAINTASK_CPP__

GHMGCTASK_HANDLER(KK7BattleFrameProcess);
GHMGCTASK_HANDLER(KK7BattleFrameProcessTerm);
//GHMGCTASK_HANDLER(kk7BattleRenderProcess);

bool GetBLockOn(void);
bool GetJyujiLockOn(void);

#else

extern KK7BattleMainTask *pBattleMain;
extern u32 BattleCameraMtxChange;
extern bool GetBLockOn(void);
extern bool GetJyujiLockOn(void);

#endif


#endif

