////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube AppTask
//
// ghmGcAppTask.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__GHMGCAPPTASK_CPP__

#include "ghmGcAppTask.h"
#include "ghmGcApp.h"

ghmGcAppTask::ghmGcAppTask()
{
	mState        = INIT;
	mpApplication = NULL;
	mFlag         = GHMGCAPPTASK_PROCESSFLAGALL;
	mID           = 0xffffffff;
}

ghmGcAppTask::ghmGcAppTask(ghmGcApp *pApp,int prio) : ghmGcListObj(pApp->GetTaskAnchor(),prio)
{
	ASSERTMSG1(pApp!=NULL,"ghmGcAppTask constructor error : NULL Application 0x%08x",(int)this);
	mState        = INIT;
	mpApplication = pApp;
	mFlag         = GHMGCAPPTASK_PROCESSFLAGALL;
	mID           = pApp->GenerateUniqueID();
}

ghmGcAppTask::~ghmGcAppTask()
{
}

bool ghmGcAppTask::Initialize(void)
{
	mState        = EXEC;
	mFlag         = 0;
	return InitializeCallBack();
}

bool ghmGcAppTask::Terminate(void)
{
	if( mState == DELETE ){
		return true;
	}
	mState = TERM;
	mFlag  = GHMGCAPPTASK_PROCESSFLAGALL;
	if( TerminateCallBack()==false ){
		return false;
	}
	mState = DELETE;
	return true;
}

bool ghmGcAppTask::DeleteTerminate(void)
{
	mState = DELETE;
	mFlag  = GHMGCAPPTASK_PROCESSFLAGALL;
	TerminateCallBack();
	return true;
}

