////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Collision
//
// ghmGcColl.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCCOLL_H__
#define	__GHMGCCOLL_H__

#include "ghmGcTypes.h"

class ghmGcCollObj;

class ghmGcPlane{
public:
	Vec			mPosition;			// ʏ̈_
	Vec			mNormal;			// ʂ̖@
	
	int GetCrossState(ghmGcCollObj &obj);
};

class ghmGcViewVolume{
private:
	ghmGcPlane	mClipPlane   [6];	// r[{[̃Nbv
	Vec			mClipPosition[8];	// Nbv{[̒[_W
	Mtx			mCoordinate;		// JWւ̕ϊ}gNX
public:
	
	inline MtxPtr GetCoordinate(void){ return mCoordinate; }
	bool SetCurrent(const Vec &campos,const Vec &camdir,f32 n,f32 f,f32 aspect,f32 fov);
	bool SetCurrent(const Vec &campos,Mtx dirmtx,f32 n,f32 f,f32 aspect,f32 fov);
	bool SetCurrent(HSD_CObj *pCObj);
	int GetCrossState(ghmGcCollObj &obj);
	int GetFarClip(ghmGcCollObj &obj,f32 dist);
};

class ghmGcCollObj{
public:
	enum{
		OUTSIDE = 0,
		CROSSOVER,
		INSIDE,
		UNKNOWN = -1,
	};
	virtual int GetCrossState(const ghmGcPlane &plane) = 0;
	virtual int GetFarClip(Mtx coord,f32 dist) = 0;
};

class ghmGcCollPoint : public ghmGcCollObj{
public:
	Vec			mPosition;			// ʒu
	virtual int GetCrossState(const ghmGcPlane &plane);
	virtual int GetFarClip(Mtx coord,f32 dist);
};

class ghmGcCollSphere : public ghmGcCollObj{
public:
	Vec			mPosition;			// Sʒu
	f32			mRadius;			// ̔a
	virtual int GetCrossState(const ghmGcPlane &plane);
	virtual int GetFarClip(Mtx coord,f32 dist);
};

class ghmGcCollBox : public ghmGcCollObj{
public:
	Mtx			mCoordinate;		// {bNX̎̍Wn
	Vec			mExtent;			// Li{bNXSʒůȇ傫j
	virtual int GetCrossState(const ghmGcPlane &plane);
	virtual int GetFarClip(Mtx coord,f32 dist);
};

#endif	//__GHMGCCOLL_H__

