////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube File Manager
//
// ghmGcFile.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/07/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCFILE_H__
#define	__GHMGCFILE_H__

#include "..\K7App.ini"
#include "ghmGcMem.h"
#include "ghmGcUsb.h"

#ifdef	USE_ISDOLVIEWER
#ifndef	FILE_USB
#define	FILE_USB
#endif
#endif

class ghmGcFile{
public:
	enum ghmGcFileState{
		READFINISH = 1,
		CANCELED = 1,
		CLOSED = 0,
		OPENED = 1,
		READ,
		READRETRY
	};
	enum ghmGcFileChangeDiskState{
		CHANGED = 0,
		CHANGECANCELED = 0,
		IDLE = 0,
		CHANGEING,
		FATAL_ERROR,
		UNKNOWN,
	};
	struct ghmGcFileInfo{
		DVDFileInfo				mFileInfo;
		int						mOffset;
		int						mLength;
		int						mRequestNo;
		volatile s32			mReadStatus;	// 
												//	DVD_STATE_FATAL_ERROR	vIȃG[܂B 
												//	DVD_STATE_END			NGXg͏I܂ / NGXg͂܂B 
												//	DVD_STATE_BUSY			NGXǵAݏłB 
												//	DVD_STATE_WAITING		NGXg̓L[ɓĂA҂łB 
												//	DVD_STATE_NO_DISK		hCuɃfBXN܂B 
												//	DVD_STATE_COVER_OPEN	fBXNJo[JĂ܂B 
												//	DVD_STATE_WRONG_DISK	hCuɊԈfBXNĂ܂B 
												//	DVD_STATE_MOTOR_STOPPED	\ς 
												//	DVD_STATE_IGNORED		DVDPrepareStream̂݁BhCugbNIĂƂȂ̂ŁANGXg͖܂B 
												//	DVD_STATE_CANCELED		NGXg̓LZ܂B 
												//	DVD_STATE_RETRY 		gCG[܂B
		volatile s32			mReadResult;	// ǂݍ݌ʁiG[łȂꍇ͓ǂݍ݃oCgj
												//	DVD_RESULT_FATAL_ERROR	-1
												//  DVD_RESULT_IGNORED		-2
												//	DVD_RESULT_CANCELED		-3
		volatile ghmGcFileState	mState;
	};
protected:
	static ghmGcFile			*mpFileTop;
	static ghmGcMem				*mpAllocHeap;
	static bool					mUseDevCom;
	static DVDDiskID			*mpDiskID;
	static int					mDiskNum;
	static s32					mDriveState;
	static volatile s32			mCurrentDiskID;
	static s32					mReserveDiskID;
	static volatile ghmGcFileChangeDiskState
								mChangeDiskState;
	static DVDCommandBlock		mChangeDiskCommandBlock;
	
	ghmGcFileInfo				mInfo;
	
	ghmGcFile					*mpPrev;
	ghmGcFile					*mpNext;
	
	char						mFileName[64];
#ifdef	FILE_USB
	ghmGcUsb					mUsb;
#endif
	
	static void DevComCallback(int dcReq,void *args,void *sbuf,int cancelflag);
	static void ReadCallBack(s32 result,DVDFileInfo *pFileInfo);
	static void CancelCallBack(s32 result,DVDCommandBlock *pBlock);
	static void ChangeDiskCallback(s32 result, DVDCommandBlock* block);
	static int _GetCurrentDiskID(void);
public:
	
	ghmGcFile();
	~ghmGcFile();
	
	static bool IsDiskStandby(void);
	static int GetDiskNum(void);
	static int GetCurrentDiskID(void){ return mCurrentDiskID; }
	static int GetReserveDiskID(void){ return mReserveDiskID; }
	static bool ChangeDisk(s32 id);
	static s32 GetDriveState(void){ return mDriveState; }
	
	// 
	static bool Initialize(void);
	inline static void SetUseDevCom(bool flag){ mUseDevCom=flag; }
	inline static bool GetUseDevCom(void){ return mUseDevCom; }
	
	static bool Terminate(void);
	
	// AP[Vq[v
	inline bool SetAllocHeap(ghmGcMem *pHeap){ mpAllocHeap=pHeap; return true; }
	inline ghmGcMem* GetAllocHeap(void){ return mpAllocHeap; }
	
	// t[
	static bool FrameProcessAll(void);
	bool FrameProcess(void);
	
	// _O
	static bool RenderProcessAll(void);
	bool RenderProcess(void);
	
	// I[v
	bool Open(char *pFileName);
	// N[Y
	bool Close(void);
	// t@CTCY擾
	u32 GetLength(bool roundup=true);
	
	// LZi^j
	bool CancelB(void);
	// LZi񓯊^j
	bool Cancel(void);
	
	// [hi^j
	void* ReadB(void *pAddr=NULL,s32 offset=0,s32 length=-1);
	// [hi񓯊^j
	void* Read(void *pAddr=NULL,s32 offset=0,s32 length=-1);
	
	inline ghmGcFileState GetState(void){ return mInfo.mState; }
	inline s32 GetReadStatus(void){ return mInfo.mReadStatus; }
	inline s32 GetReadResult(void){ return mInfo.mReadResult; }
};

#include "ghmGcMem.h"

#endif	//__GHMGCFILE_H__

