////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Mathematical Manager
//
// ghmGcMath.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/16/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCMATH_H__
#define	__GHMGCMATH_H__

#include <dolphin.h>
#include <math.h>
#include "ghmGcTypes.h"

class ghmQuaternion : public Quaternion{
public:
	ghmQuaternion(){ x=y=z=w=0.0f; }
	ghmQuaternion(float x0,float y0=0.0f,float z0=0.0f,float w0=0.0f){ x=x0; y=y0; z=z0; w=w0; }
	void QuatSlerp(ghmQuaternion *pq1,ghmQuaternion *pq2,float t);	// pq1pq2`Ԃđ
};

class ghmMath{
private:
	static f32		projection[GX_PROJECTION_SZ];
	static f32		viewport  [GX_VIEWPORT_SZ  ];
public:
	static bool TransPosition(Mtx mtx,Vec &wpos,Vec &spos);
	static int Roll2UpVec(const Vec &eye,float roll,Vec &up);
	static int Roll2UpVec(const Vec &pos,Vec &interest,float roll,Vec &up);
};

#endif	//__GHMGCMATH_H__

