////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Resource Link
//
// ghmGcResLink.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCRESLINK_H__
#define	__GHMGCRESLINK_H__

#include "ghmGcTypes.h"
#include "ghmGcDefine.h"

// }WbNio[
#define	RESLINK_MAGIC_NO				(0x47484d52)			// rbNGfBAioCgI[_[j
#define	RESLINK_MAGIC_NO_LE				(0x524d4847)			// gGfBAioCgI[_[j

// 
#define	RESATTR_GROUP					(0x00000001)			// O[v
#define	RESATTR_NOINSTANCE				(0x00000002)			// ̂Ȃ
class ghmGcResAttr{
	friend class ghmGcResGroup;
protected:
	u32						mOffset;
	u32						mSize;
	u32						mAttr;
	u32						mVersion;
	const char				*mpResourceName;
	u32						mPad[3];
	
	void Initialize(bool convendian);
public:
	
	inline u32 GetOffset(void) const { return mOffset; }
	inline u32 GetAttr(void) const { return mAttr; }
	inline u32 GetSize(void) const { return mSize; }
	inline bool IsGroup(void) const { return (mAttr & RESATTR_GROUP)? true : false; }
	inline bool IsNoInstance(void) const { return (mAttr & RESATTR_NOINSTANCE)? true : false; }
	const char *GetResourceName(void) const;
	
	inline void* operator new(u32,void* p){ return p; }
};

class ghmGcResStrTable{
public:
	u32						mNum;
	const char				**mppStrings;
	u32						mPad[2];
	inline u32 GetNum(void){ return mNum; }
	inline const char* GetString(u32 id){
		if( id >= mNum ){
			return NULL;
		}
		return mppStrings[id];
	}
};

class ghmGcResGroup{
	friend class ghmGcResAttr;
protected:
	u32						mMagicNo;
	u32						mResourceNum;
	u32						mAttrOffset;
	u32						mVersion;
	union{
		ghmGcResStrTable	*mpStrTablePtr;
	};
	u32						mPad[3];
	
	static ghmGcResStrTable	*mpStrTable;
	
	void* operator new(size_t);
	void Initialize(bool convendian);
public:
	
	inline u32 GetResourceNum(void){ return mResourceNum; }
	const ghmGcResAttr* GetFileAttr(int index);
	const char* GetResourceName(int index);
	bool IsGroup(int index);
	bool IsNoInstance(int index);
	void* GetResource(int index);
	u32 GetResourceSize(int index);
	ghmGcResGroup* GetGroup(int index);
	
	void* operator new(u32,void* p);
};

typedef	ghmGcResGroup	ghmGcResLink;

#endif	//__GHMGCRESLINK_H__

