////////////////////////////////////////////////////////////////////////////////
//
// GrassHopperManufacture GameCube Texture
//
// ghmGcTex.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/30/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__GHMGCTEX_H__
#define	__GHMGCTEX_H__

#include "ghmGcTypes.h"

struct GhmGcTlutHeader{
	GXTlutFmt				mFormat;						// tH[}bg
	u_short					mEntryNum;						// Gg[
	u_short					mSPad;
	union{
		struct{
			u_int			mFlagPad : 32;
		};
		u_int				mFlag;
	};
	u_int					mLutPtr;						// bNAbve[uւ̃|C^
	
	u_int					mPad[4];
};

struct GhmGcTexHeader{
	union{
		u_char				mMagicNumber[4];				// }WbNio[
		u32					mMagicNumberU32;
	};
	GXTexFmt				mFormat;						// tH[}bg
	u_short					mWidth;							// eNX`
	u_short					mHeight;						// eNX`
	union{
		struct{
			u_int			mMipmap : 1;					// MIPMAP
			u_int			mFlagPad:31;
		};
		u_int				mFlag;							// tÖ
	};
	
	u_int					mImagePtr;						// C[W{̂ւ̃|C^ĩwb_j
	u_int					mTlutPtr;						// eNX`bNAbve[uf[^ւ̃|C^ĩwb_j
	float					mMinLOD;						// LODŏl
	float					mMaxLOD;						// LODől
	
	u_int					mPad[8];
};

#define	GHMGCTEX_GETIMAGE(header)	((void *)((u32)header + (header)->mImagePtr))

#define	GHMGCTEX_MAGINNUMBER		(0x47435430)

#endif	//__GHMGCTEX_H__

