////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Title Task
//
// MK7TitleTask.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7TITLETASK_H__
#define	__MK7TITLETASK_H__

//---- include ----
#include "mK7common.h"
#include "mK7Sprite.h"
#include "mK7Jimaku.h"

//---- define ----
#define	TITLE_STRING_MAX		(4)		//^Cgʂŕ\镶̍ő吔
#define	TITLE_LOGO_X_LINE_MAX	(17)	//S\XWő吔
#define	TITLE_LOGO_Y_LINE_MAX	(11)	//S\YWő吔
#define	TITLE_LOGO_BOX_LINE_MAX	(4)		//S\锠ɎgC
#define	TITLE_LOGO_BOX_MAX		(75)	//S\锠

//---- enum ----
typedef	enum{
	eTitleReadData,
	eTitleReadSsmWait,
	eTitleLineEffect,
	eTitleBoxEffect,
	eTitleFadeWait,
	eTitleDispTitle,
	eTitleFadeOut,
	eTitleChange,			// Killer7Killer1̓ւ菈
	eTitleChangeWait,
	eTitleProcMax,
}enTitleProc;

typedef	enum{
	eTitleMenu,				// PRESS GAME START
	eTitleMenu1,			// Killer7, Killer1
	eTitleMenu0,			// NEW GAME, CONTNUE, OPTION
	eTitleMenuFadeOut,		// tF[hAEg
	eTitleMenuStrFadeOut,	// Iꂽ̃tF[hAEg
	eTitleMenu2,			// , , 
	eTitleMenu2FadeOut,		// , ,  ĨtF[hAEg
	eTitleMenuMax,
}enTitleMenu;

typedef	enum{
	eTitleSelNew,		// Start
	eTitleSelCon,		// Continue
	eTitleSelOpt,		// OPTION
	eTitleSel0Max,
}enTitleSel0;

typedef	enum{
	eTitleSelKiller7,	// Killer7
	eTitleSelKiller1,	// Killer1
	eTitleSelHopper7,	// Hopper7
	eTitleSel1Max,
}enTitleSel1;

typedef	enum{
	eTitleSelDifficult0,	// , 
	eTitleSelDifficult1,	// 
	eTitleSelDifficultMax,
}enTitleSel2;

typedef	enum{
	eTitleShadowScale,	//cg咆
	eTitleShadowDrop,	//
	eTitleShadowProcMax,
}enTitleShadowProc;

typedef	enum{
	eTitleDifFadeIn,
	eTitleDifExec,
	eTitleDifFadeOut,
	eTitleDifProcMax,
}enTitleDifProc;

typedef	enum{
	eTitleDifBrinkSel,	//IꂽƂ
	eTitleDifBrink1,	//At@50%̏ԂɂȂ
	eTitleDifBrink2,	//ꎞIɓ_łȂȂ
	eTitleDifBrink,		//_
	eTitleDifNoBrink,	//_łȂ
}enTitleDifBlinkProc;

//---- struct ----
typedef	struct{
	stSentence*		dat;		//t@Cǂݍ񂾃f[^
	stFontParam*	fontParam;	//uvwhl̓Ăe[uւ̃|C^
	stTexture		fontTex;	//eNX`
}stFontDat;

typedef	struct{
	size_t				length;		//
	char*				str;		//f[^
	mK7Sprite*			sprt;		//XvCg
	mK7Sprite*			sprtShadow;	//eXvCg
	s16					width;		//
	enTitleShadowProc*	shadowProc;	//ȅ
}stStringDat;

typedef	struct{
	s32			moveTick;	//ړɂ鎞
	s32			moveWait;	//ړ܂ł̑ҋ@
	mK7Sprite	sprt;		//S\郉CXvCg
}stLineEffect;

typedef	struct{
	s32			wait;		//\܂ł̃EGCg
	mK7Sprite	box;		//S\锠XvCg
}stLogoBox;

typedef	struct{
	enTitleDifBlinkProc	blinkProc;
	s32					flame;
}stBlink;

//---- class ----
class MK7TitleTask : public ghmGcAppTask{
protected:
public:
	MK7TitleTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual	~MK7TitleTask();
	
	//R[obN
	virtual	bool	InitializeCallBack(void);
	//_O
	virtual	bool	RenderProcess(void);
	//t[
	virtual	bool	FrameProcess(void);
	//IR[obN
	virtual	bool	TerminateCallBack(void);
	
	//\NGXg
	bool	mTitleFontReq( stStringDat* inStrDat, s16 inX, s16 inY, char* inStr );
	//ɐF
	void	mTitleFontSetRGBA( stStringDat* inStrDat, u32 inRGBA );
	void	mTitleSel0SetRGBA( void );
	void	mTitleSel1SetRGBA( void );
	
	//^Cgʂ̃tF[hAEgݒ
	void	mSetTitleFadeOut( u32 inSelMenu );
	
	//Iꂽj[̔ԍ擾
	u32		mGetSelectNo( void );
	//IĂ郁j[̔ԍ擾
	u32		mGetNowSelectNo( void );
	
	//IĂ郁j[̕h炷
	void	mTitleFontShake( void );
	//w肵j[̕lɈړ
	void	mTitleFontClose( u32 inStringNo, s32 inTick );
	//w肵j[̕ʕɍL
	void	mTitleFontSpread( u32 inStringNo, s32 inTick );
	//j[ړ
	void	mTitleFontMove( u32 inMenuMax );
	
	//S̃CGtFNg
	void	mTitleLogoLineInit( void );
	//S̃CGtFNg
	void	mTitleLogoLineProc( void );
	
	//eNX`̓ǂݍ݂ƃ^CgSt[
	void	mTitleLogoProc( void );
	//[vĎ
	bool	mCheckTitleLoop( void );
	//j[̏
	bool	mTitleMenuStrProc( void );
	//j[̉eʉɈړ
	void	mTitleFontShadowProc( void );
	
	//LZ̃tF[hAEgĂяo
	void	mSetLogoEffectCancel( void );
	//S̍Wݒ
	void	mSetTitleLogoBoxLocate( void );
	
	//ǂݍ񂾃f[^̏
	void	mSetTitleData( void );
	//ՓxIXvCg
	void	mInitDifficultSprt( mK7Sprite* inSprt, stTexture* inTex, s16 inX, s16 inY );
	//ՓxIʂ̕\
	void	mDispDifficult( void );
	//ՓxIʏ
	void	mDifficultProc( void );
	//ՓxĨtF[hAEgݒ
	void	mSetFadeOutDifficult( void );
	//ՓxI̔\
	void	mSetUndispDifficult( void );
	//_ŏ
	void	mCallBlinkProc( mK7Sprite* inSprt, stBlink* inBlink, bool inOnlyBlink );
	//_ŏ̕ύX
	void	mChangeBlink( void );
	//^Cg̕\ύX
	void	mChangeTitle( void );
	
	//Ił镶f[^̃NA
	void	mClearStrData( void );
	
	//ZL[index
	void	mSecretIndexInit( void );
	//Z͔
	void	mSecretModeCheck( void );
	//ZtONA
	void	mSecretModeClear( void );
	
private:
	enTitleProc		mProc;
	
	mK7File			mFile;
	
	void*			mDat;
	ghmGcResLink*	mReslink;
	
	//Killer7^CgS
	stTexture		mTexLogo;
	stTexture		mTexBlar;
	mK7Sprite		mSprtLogo;
	mK7Sprite		mSprtBlar;
	//Killer1^CgS
	stTexture		mTexLogo1;
	stTexture		mTexBlar1;
	mK7Sprite		mSprtLogo1;
	mK7Sprite		mSprtBlar1;
	//Hopper7^CgS
	stTexture		mTexLogo2;
	stTexture		mTexBlar2;
	mK7Sprite		mSprtLogo2;
	mK7Sprite		mSprtBlar2;
	//ۂɕ\^CgXvCgւ̃|C^
	mK7Sprite*		mpSprtLogo;
	mK7Sprite*		mpSprtBlar;
	//Փx
	stTexture		mTexNanido;
	mK7Sprite		mSprtNanido;
	//
	stTexture		mTexKanjiGeki;
	stTexture		mTexKanjiTouA;
	stTexture		mTexColonA;
	stTexture		mTexTextA01;
	stTexture		mTexTextA02;
	mK7Sprite		mSprtKanjiGeki;
	mK7Sprite		mSprtKanjiTouA;
	mK7Sprite		mSprtColonA;
	mK7Sprite		mSprtTextA01;
	mK7Sprite		mSprtTextA02;
	//
	stTexture		mTexKanjiShi;
	stTexture		mTexKanjiTouB;
	stTexture		mTexColonB;
	stTexture		mTexTextB01;
	stTexture		mTexTextB02;
	mK7Sprite		mSprtKanjiShi;
	mK7Sprite		mSprtKanjiTouB;
	mK7Sprite		mSprtColonB;
	mK7Sprite		mSprtTextB01;
	mK7Sprite		mSprtTextB02;
	//
	stTexture		mTexKanjiTi;
	stTexture		mTexTextC;
	mK7Sprite		mSprtKanjiTi;
	mK7Sprite		mSprtKanjiTouC;
	mK7Sprite		mSprtColonC;
	mK7Sprite		mSprtTextC;
	//囓
	stTexture		mTexKanjiBat;
	stTexture		mTexTextD;
	mK7Sprite		mSprtKanjiBat;
	mK7Sprite		mSprtKanjiTouD;
	mK7Sprite		mSprtColonD;
	mK7Sprite		mSprtTextD;
	
	s32				mFadeWaitTick;
	bool			mFadeInFlag;
	
	stFontDat		mFont;
	stStringDat		mStr[TITLE_STRING_MAX];	//j[
	f32*			mOrgX;
	f32*			mOrgY;
	
	enTitleMenu		mTitleMenuProc;
	enTitleSel0		mTitleSel0;
	enTitleSel1		mTitleSel1;
	enTitleSel2		mTitleSel2;
	u32				mSelectFlag;
	bool			mFontRequest;
	
	enTitleDifProc	mTitleDifProc;
	
	s32				mVoicePlayTick;	//΂҂
	
	stLineEffect	mLineX[TITLE_LOGO_X_LINE_MAX];	//S\XC
	stLineEffect	mLineY[TITLE_LOGO_Y_LINE_MAX];	//S\YC
	stLogoBox		mBox[TITLE_LOGO_BOX_MAX];		//S\锠
	
	int				mLineXSENo[TITLE_LOGO_X_LINE_MAX];
	int				mLineYSENo[TITLE_LOGO_Y_LINE_MAX];
	
	f32				mLineSpeed;			//GtFNg̈ړx
	f32				mLineAngle;			//7̕p̐̊px
	s32				mEffectWait;		//GtFNg̕\҂
	
	s32				mLoopTime;			//^Cgʂ̃[v
	u32				mExtModeNum;		//Q[[h(Killer7,Killer8,Hopper8)
	
	bool			mTitleStreamPlay;	//^CgʗpXg[Đ
	
	//
	stBlink			mBlinkKanjiGeki;
	stBlink			mBlinkKanjiTouA;
	stBlink			mBlinkColonA;
	stBlink			mBlinkTextA01;
	stBlink			mBlinkTextA02;
	//
	stBlink			mBlinkKanjiShi;
	stBlink			mBlinkKanjiTouB;
	stBlink			mBlinkColonB;
	stBlink			mBlinkTextB01;
	stBlink			mBlinkTextB02;
	//
	stBlink			mBlinkTi;
	stBlink			mBlinkTouC;
	stBlink			mBlinkColonC;
	stBlink			mBlinkTextC;
	//囓
	stBlink			mBlinkBat;
	stBlink			mBlinkTouD;
	stBlink			mBlinkColonD;
	stBlink			mBlinkTextD;
	
	//̐F
	u32				mRGBASel;
	u32				mRGBACantChoose;
	u32				mRGBANotSel;
	u32				mRGBAShadow;
	
	u32				mSecretKeyIndex;	//ZR}hindex
};

extern	bool	gTitleGoContinue;		//ReBj[ʂ֓tO
extern	bool	gTitleRetFromSSelect;	//ViII߂Ă




#endif	//__MK7TITLETASK_H__

