////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Dim
//
// mK7Dim.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7DIM_CPP__

//---- include ----
#include "mK7Dim.h"
#include "MK7Sound.h"

//---- define ----
#define	DIM_COLOR_HS			(0xe63c0b00)	//HS̐F
#define	DIM_COLOR_SCREEN		(0x00311c00)	//ʂ̐F
#define	DIM_ALPHA				(0xff)			//l̍ől
#define	DIM_STOPFADE_TICK		(1000)			//~ڂ₯:tick




//---- O[oϐ ----
MK7Dim*		gpDim = NULL;




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Dim::MK7Dim()
{
	mFrameProc = eDimStandby;
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Dim::~MK7Dim()
{
}
//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Dim::Init( void )
{
	if( gpDim == NULL ){
		ghmGcMemSetAllocName("MDim");
		gpDim = new MK7Dim;
	}
	gpDim->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Dim::Term( void )
{
	GHM_SAFE_DELETE( gpDim );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Dim::mInit( void )
{
	int	i;
	
	//XvCgݒ
	for( i = 0; i < DIM_MAX; i++ )
	{
		//HS
		mSprtHS[i].mSetSpriteScanHSPrim();
		mSprtHS[i].mRelateTex( &mTex );
		mSprtHS[i].mSetPriority( SPRT_PRI_DIM_HS );
		mSprtHS[i].mSetRGBA( DIM_COLOR_HS );
		mSprtHS[i].mSetDispFlag( false );
		//
		mSprtScreen[i].mSetSpriteNoTexAlphaPrim();
		mSprtScreen[i].mRelateTex( &mTex );
		mSprtScreen[i].mSetPriority( SPRT_PRI_DIM );
		mSprtScreen[i].mSetRGBA( DIM_COLOR_SCREEN );
		mSprtScreen[i].mSetDispFlag( false );
	}
	//PFpl
	mSprtPanel.mSetBoxPrim();
	mSprtPanel.mSetPriority( SPRT_PRI_DIM_MONO );
	mSprtPanel.mSetRGBA( DIM_COLOR_SCREEN );
	mSprtPanel.mSetDispFlag( false );
}
//-----------------------------------------------------------------------------
//NGXg
// in --> ڂ₯鎞(1b=4800tick)ȗDIM_FADEIN_TICK܂
// out -> bool false  XLs
//             true   XLt
//-----------------------------------------------------------------------------
bool
MK7Dim::mRequest( s32 inTick )
{
	int			i;
	GXTexObj*	pTexObj;
	
	//XLsmF
	if( mFrameProc != eDimStandby )
	{
		return( false );
	}
	
	//eNX`擾
	pTexObj = screenImageFullColor.GetTexObj();
	//eNX`ݒ
	mTex.tex = &mTexHeader;
	memcpy( &mTex.obj, pTexObj, sizeof(GXTexObj) );
	mTexHeader.mFormat = GX_TF_RGBA8;
	mTexHeader.mWidth  = WK7_SCREEN_WIDTH;
	mTexHeader.mHeight = WK7_SCREEN_HEIGHT;
	
	//tF[hCɂ鎞Ԃۑ
	mTick    = inTick / 2;
	mScanH   = 0.0f;
	
	//XvCgݒ
	for( i = 0; i < DIM_MAX; i++ )
	{
		//HS
		mSprtHS[i].mSetUV0( 0, 0 );
		mSprtHS[i].mSetXY0( mGetInitX(i), 0 );
		mSprtHS[i].mSetWH( WK7_SCREEN_WIDTH, (s16)mScanH );
		mSprtHS[i].mSetFade( DIM_ALPHA, mTick );
		mSprtHS[i].mSetMove( 0, 0, mTick );
		mSprtHS[i].mSetDispFlag( true );
		//
		mSprtScreen[i].mSetUV0( 0, 0 );
		mSprtScreen[i].mSetXY0( mGetInitX(i), 0 );
		mSprtScreen[i].mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
		mSprtScreen[i].mSetFade( DIM_ALPHA, mTick );
		mSprtScreen[i].mSetMove( 0, 0, mTick );
		mSprtScreen[i].mSetDispFlag( true );
	}
	//PFpl
	mSprtPanel.mSetXY0( 0, 0 );
	mSprtPanel.mSetWH( WK7_SCREEN_WIDTH, (s16)mScanH );
	mSprtPanel.mSetFade( DIM_ALPHA*2/3, mTick );
	mSprtPanel.mSetDispFlag( true );
	
	//SEĐ
	gpSound->mPlaySE( SFX_BT_SCAN_RELEASE,		//SEԍ
					  SOUND_SYSTEM_SE_VOLUME,	//
					  SOUND_PAN_CENTER,			//p
					  eSETrackBattleOverlap,	//gbN
					  eSEGroupBattle00 );		//O[v
	
	//s
	mFrameProc = eDimFadeIn;
	
	return( true );
}
//-----------------------------------------------------------------------------
//~
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Dim::mStop( void )
{
	int	i;
	
	//XLsmF
	if( mFrameProc == eDimStandby || (mFrameProc == eDimFadeOut) )
	{
		return;
	}
	
	for( i = 0; i < DIM_MAX; i++ )
	{
		mSprtHS[i].mSetFade( 0, DIM_STOPFADE_TICK );
		mSprtScreen[i].mSetFade( 0, DIM_STOPFADE_TICK );
	}
	mSprtPanel.mSetFade( 0, DIM_STOPFADE_TICK );
	
	mFrameProc = eDimStopWait;
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Dim::mFrameProcess( void )
{
	int	i;
	
	switch( mFrameProc )
	{
		//tF[hC
		case	eDimFadeIn:
			//tF[hImF
			if( (mSprtHS[0].mGetFadeEnd() == true) && (mSprtScreen[0].mGetFadeEnd() == true) )
			{
				//XL܂ŏIꍇ͉ʂHSʒSɈړȂtF[hAEg
				for( i = 0; i < DIM_MAX; i++ )
				{
					//HS
					mSprtHS[i].mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
					mSprtHS[i].mSetFade( 0, mTick );
					mSprtHS[i].mSetMove( 0, WK7_SCREEN_HEIGHT, mTick );
					//
					mSprtScreen[i].mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
					mSprtScreen[i].mSetFade( 0, mTick );
				}
				//PFpl
				mSprtPanel.mSetWH( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
				mSprtPanel.mSetFade( 0, mTick );
				mSprtPanel.mSetMove( 0, WK7_SCREEN_HEIGHT, mTick );
				mScanH = 0.0f;
				//ړ̃NGXgłĂ̂ňxXLɐi߂鏈
				mScanH += (f32)WK7_SCREEN_HEIGHT / (f32)WK7_TICK_TO_FRAME((f32)mTick);
				for( i = 0; i < DIM_MAX; i++ )
				{
					mSprtHS[i].mSetUV0( 0, (s16)mScanH );
				}
				mFrameProc = eDimFadeOut;
			}else
			{
				//XL܂Ői߂
				mScanH += (f32)WK7_SCREEN_HEIGHT / (f32)WK7_TICK_TO_FRAME((f32)mTick);
				for( i = 0; i < DIM_MAX; i++ )
				{
					mSprtHS[i].mSetH( (s16)mScanH );
				}
				mSprtPanel.mSetH( (s16)mScanH );
			}
			break;
		
		case	eDimFadeOut:
			//tF[hImF
			if( (mSprtScreen[0].mGetFadeEnd() == true) && (mSprtHS[0].mGetFadeEnd() == true) )
			{
				for( i = 0; i < DIM_MAX; i++ )
				{
					mSprtHS[i].mSetDispFlag( false );
					mSprtScreen[i].mSetDispFlag( false );
				}
				mSprtPanel.mSetDispFlag( false );
				mFrameProc = eDimStandby;
			}else
			{
				//XL܂Ői߂
				mScanH += (f32)WK7_SCREEN_HEIGHT / (f32)WK7_TICK_TO_FRAME((f32)mTick);
				for( i = 0; i < DIM_MAX; i++ )
				{
					mSprtHS[i].mSetUV0( 0, (s16)mScanH );
				}
			}
			break;
		
		case	eDimStopWait:
			if( mSprtScreen[0].mGetFadeEnd() == true )
			{
				for( i = 0; i < DIM_MAX; i++ )
				{
					mSprtHS[i].mSetDispFlag( false );
					mSprtScreen[i].mSetDispFlag( false );
				}
				mSprtPanel.mSetDispFlag( false );
				mFrameProc = eDimStandby;
			}
			break;
		
		case	eDimStandby:	//ҋ@
			break;
		
		default:
			break;
	}
}




