////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Flush
//
// mK7Flush.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/22/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7FLUSH_CPP__

//---- include ----
#include "mK7Flush.h"

//---- define ----

//---- O[oϐ ----
MK7Flush*	gpFlush = NULL;

//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Flush::MK7Flush()
{
	mFrameProc = eFlushInit;
	mNowA      = 0;
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Flush::~MK7Flush()
{
}




//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Flush::Init( void )
{
	if( gpFlush == NULL ){
		ghmGcMemSetAllocName("MFlush");
		gpFlush = new MK7Flush;
	}
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Flush::Term( void )
{
	GHM_SAFE_DELETE( gpFlush );
}
//-----------------------------------------------------------------------------
//tbVNGXg
// in --> u32 inRgb       ڕWƂȂF
//        u32 inUpTick    邭Ȃ̂ɂ鎞(P:tick 1b=4800)
//        u32 inDownTick  ÂȂ̂ɂ鎞(P:tick 1b=4800)
// out -> none
//-----------------------------------------------------------------------------
void
MK7Flush::mRequest( u32 inRgb, s32 inUpTick, s32 inDownTick )
{
	//RGBAlݒ
	mRgba     = inRgb << 8;
	//ŏ̃l
	mOrgA     = 0;
	//ڕWƂȂ郿l
	mToA      = 0x40;
	//݂̃l
	mNowA     = 0;
	//邭Ȃ̂ɂ鎞
	mUpTick   = inUpTick;
	//ÂȂ̂ɂ鎞
	mDownTick = inDownTick;
	//tF[hɂ鎞
	mNowTick  = inUpTick;
	//t[sɈڂ
	mFrameProc = eFlushExec;
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Flush::mFrameProcess( void )
{
	switch( mFrameProc )
	{
		case	eFlushInit:		//
			break;
		
		case	eFlushExec:		//s
			if( mNowTick != 0 )
			{
				mNowA    += ((f32)mToA - (f32)mOrgA) / (f32)WK7_TICK_TO_FRAME(mUpTick);
				mNowTick -= WK7_TICK_PER_FRAME;
				if( mNowTick <= 0 )
				{
					mNowA    = (f32)mToA;
					mNowTick = 0;
					//֌Ċelݒ
					mFrameProc = eFlushDecrease;
					//ŏ̃l
					mOrgA     = mToA;
					//ڕWƂȂ郿l
					mToA      = 0;
					//tF[hɂ鎞
					mNowTick  = mDownTick;
				}
				mRgba = (mRgba & 0xffffff00) | (u8)(mNowA);
			}
			break;
		
		case	eFlushDecrease:	//邳
			if( mNowTick != 0 )
			{
				mNowA    += ((f32)mToA - (f32)mOrgA) / (f32)WK7_TICK_TO_FRAME(mDownTick);
				mNowTick -= WK7_TICK_PER_FRAME;
				if( mNowTick <= 0 )
				{
					//I
					mNowA    = (f32)mToA;
					mNowTick = 0;
					mFrameProc = eFlushStandby;
				}
				mRgba = (mRgba & 0xffffff00) | (u8)(mNowA);
			}
			break;
		
		case	eFlushStandby:	//ҋ@
			break;
		
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//`揈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Flush::mRender( void )
{
	//lĂΕ`悷
	if( (int)mNowA )
	{
		//tevݒ
		//J
		mK7Sprite::mSetCamera2D();
		
		//Zobt@r[hݒ
		GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
		//EFBփ_Oۂ̃J[obt@XV[h
		GXSetColorUpdate( GX_TRUE );
		//EFBփ_Oۂ̃At@obt@XV[h
		GXSetAlphaUpdate( GX_FALSE );
		//EFBƂ̃uh@߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
		
		//TEVXe[Wŗp\ɂeNX`W̐ݒ
		GXSetNumTexGens( 0 );
		
		//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
		GXSetNumChans( 1 );
		//GX_COLOR0A0̃CgRg[̐ݒ
		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );

		//TEVXe[W̐ݒ
		GXSetNumTevStages( 1 );
		//TEVXe[WŔJ[
		GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
		
		//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
		GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );	//J[`lgꍇ͂Ăяo
		
		//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
		GXClearVtxDesc();
		//Jg_Lqq̂ꂼ̑̎ނݒ
		GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
		GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
		
		//ꂼ̗̑vf(?)Ǝނݒ
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XY,   GX_S16  , 0 );	//|WV̗vfƎނw
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
		
		//gCAOXgbvGX_VTXFMT0g4_̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
			// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
			GXPosition2s16(                0,                 0 );
			GXColor1u32   ( mRgba );
			
			GXPosition2s16( WK7_SCREEN_WIDTH,                 0 );
			GXColor1u32   ( mRgba );
			
			GXPosition2s16(                0, WK7_SCREEN_HEIGHT );
			GXColor1u32   ( mRgba );
			
			GXPosition2s16( WK7_SCREEN_WIDTH, WK7_SCREEN_HEIGHT );
			GXColor1u32   ( mRgba );
		GXEnd();
	}
}




