////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Noise
//
// mK7Noise.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/01/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7NOISE_H__
#define	__MK7NOISE_H__

//---- include ----
#include "mK7Sprite.h"

//---- define ----
#define	NOISE_WIDTH				(80)	//XvCg̕   (160)
#define	NOISE_HEIGHT			(60)	//XvCg̍ (120)
#define	NOISE_WIDTH_NUM			(K7APP_SCREEN_WIDTH / NOISE_WIDTH)
#define	NOISE_HEIGHT_NUM		(K7APP_SCREEN_HEIGHT / NOISE_HEIGHT)
#define	NOISE_FADEIN_TICK		(200)	//tF[hCɂ鎞
#define	NOISE_FADEOUT_TICK		(600)	//tF[hAEgɂ鎞
#define	NOISE_SAND_BASE_NUM		(2)		//mCỸx[XXvCg
#define	NOISE_SAND_STR_MAX		(4)		//mCY͍̕ő吔
#define	NOISE_SE_NONE			(-1)	//mCYɉoȂ
#define	NOISE_SE_NORMAL			(-2)	//mCYɒʏ̉炷
#define	NOISE_SE_MAP_DEFAULT	(-3)	//}bvԈړftHg

//---- enum ----
//t[vZX̏
typedef	enum{
	eNoiseInit,			//
	eNoiseFileRead,		//eNX`t@Cǂݍ
	eNoiseFadeIn,		//tF[hC
	eNoiseExec,			//s
	eNoiseFadeOut,		//tF[hAEg
	eNoiseFadeStopping,	//tF[hAEg~
	eNoiseFadeFinish,	//tF[hAEgI
	eNoiseStandby,		//ҋ@
	eNoiseFrameProcMax,
}enNoiseFrameProc;
typedef	enum{
	eSandInit,				//
	eSandFileReadBlue,		//eNX`t@Cǂݍ
	eSandFileReadRed,		//ԃeNX`t@Cǂݍ
	eSandFileReadAlph,		//At@xbgEeNX`t@Cǂݍ
	eSandFileReadKata,		//J^JiEeNX`t@Cǂݍ
	eSandFadeIn,			//tF[hC
	eSandExec,				//s
	eSandFadeOut,			//tF[hAEg
	eSandFontDisp,			//\
	eSandFontOut,			//񁕃mCY
	eSandFadeFinish,		//tF[hAEgI
	eSnadScreenImageFree,	//XN[C[W̃
	eSandStandby,			//ҋ@
	eSandFrameProcMax,
}enSandFrameProc;
typedef	enum{
	eSandShortNoise,
	eSandLongNoise,
	eSandNoiseTypeMax,
}enSnadNoiseType;
typedef	enum{
	eNoiseColorBlue,
	eNoiseColorRed,
	eNoiseColorMax,
}enNoiseColor;
/*
typedef	enum{
	//ViI0
	eMapChangeSE0DoorIRON,		//ViI0 S̔
	eMapChangeSE1DoorHeavy,		//ViI0 d
	//ViI1
	eMapChangeSE1Noren,			//ViI1 ̂
	eMapChangeSE1Koushido,		//ViI1 iq
	eMapChangeSE1Syouji,		//ViI1 q
	eMapChangeSE1Fusuma,		//ViI1 ӂ
	eMapChangeSE1KakuDoor,		//ViI1 prEhA
	eMapChangeSE1KakuIO,		//ViI1 prEo
	//ViI2
	eMapChangeSE2BuildingIO,	//ViI2 o
	eMapChangeSE2UruGate,		//ViI2 EC_VeB
	//ViIftHg
	eMapChangeSEDefault,		//eViĨftHg
	//L
	eMapChangeSE1FukuWood,		//ViI1 tNV}EKiO̖؂̏
	eMapChangeSE1KakuFloor,		//ViI1 prEKiւ̏
	//Lp
	eMapChangeSECharaGeki,		//L̏op
	//Ȃ
	eMapChangeSENothing,		//؂ւ̉
	eMapChangeSEMax,
}enMapChangeSE;
*/

//---- struct ----
struct stSentence;
struct stFontParam;
struct stTexture;
typedef	struct{
	stSentence*		dat;		//t@Cǂݍ񂾃f[^
	stFontParam*	fontParam;	//uvwhl̓Ăe[uւ̃|C^
	stTexture		fontTex;	//eNX`
}stNoiseTex;

typedef	struct{
	size_t		length;	//
	char*		str;	//f[^
	mK7Sprite*	sprt;	//XvCg
	s16			width;	//
}stNoiseFont;

//---- class ----
//u[NX
class MK7Noise{
protected:
public:
	//---- ֐ ----
	//RXgN^
	MK7Noise();
	
	//fXgN^
	~MK7Noise();
	
	//
	static
	void	Init( void );
	void	mInit( void );
	
	//㏈
	static
	void	Term( void );
	void	mTerm( void );
	
	//NGXg
	bool	mRequest( s32 inTick, s32 inInTick = NOISE_FADEIN_TICK, s32 inOutTick = NOISE_FADEOUT_TICK, bool inAutoRelease=false );
	//t[
	void	mFrameProcess( void );
	//`揈
	void	mRender( void );
	//
	bool	mRelease( void );
	//mCY̏Ԃ擾
	enNoiseFrameProc	mGetFrameProc( void ){return(mFrameProc);}
	
	//----  ----
	//mN[hݒ
	bool	mSandSetMono( bool inFlag, u32 inRGBA=0xffffffff );
	//NGXg
	bool	mSandRequest( enSnadNoiseType inNoiseType=eSandShortNoise, enNoiseColor inNoiseColor=eNoiseColorBlue, int inSENo=NOISE_SE_NORMAL );
	//
	bool	mSandRelease( char* inStr0=NULL, char* inStr1=NULL, char* inStr2=NULL, char* inStr3=NULL, int inSENo=NOISE_SE_NORMAL, bool inLongRelease=false );
	//mCY̏Ԃ擾
	enSandFrameProc	mGetSandFrameProc( void ){return(mSandFrameProc);}
	//inline	enSandFrameProc	mGetSandFrameProc( void ){return(mSandFrameProc);}
	
	//t[
	void	mSandFrameProcess( void );
	//`揈
	void	mSandRender( void );
	
	//mCỸeNX`擾
	stTexture*	mGetTexPtr( void ){ return( &mTexNoise ); }
	//mCỸeNX`擾
	stTexture*	mGetTexPtrBlue( void ){ return( &mTexBlueNoise ); }
	//ԃmCỸeNX`擾
	stTexture*	mGetTexPtrRed( void ){ return( &mTexRedNoise ); }
	
	//㉺ɕ\镶̃NGXg
	bool		mUpDownStrRequest( char* inStr0, char* inStr1, char* inStr2, char* inStr3, s16 inTick );
	//㉺ɕ\镶̃[X
	bool		mUpDownStrRelease( s16 inTick );
	//㉺ɕ\镶̊Ď
	void		mWatchUpDownStr( void );
	
	inline void SetScreenCopyFlag(bool flag){ mScreenCopyFlag=flag; }
	inline bool GetScreenCopyFlag(void){ return mScreenCopyFlag; }
private:
	//---- class ----
	//t@CNX
	mK7File				mFile;
	//---- ֐ ----
	//YWݒ
	void	mSandSetY( void );
	//
	void	mInitNoiseFont( void );
	//---- ϐ ----
	//ʏmCYp
	enNoiseFrameProc	mFrameProc;
	stTexture			mTexNoise;		//mCYeNX`
	mK7Sprite			mSprtN[NOISE_WIDTH_NUM][NOISE_HEIGHT_NUM];
	s32					mNowTick;
	s32					mFadeInTick;
	s32					mFadeOutTick;
	bool				mAutoRelease;
	//mCYp
	enSandFrameProc		mSandFrameProc;
	enSnadNoiseType		mSandNoiseType;
	GhmGcTexHeader		mTexHeader;
	stTexture			mTexBlueNoise;	//mCYeNX`
	stTexture			mTexRedNoise;	//ԃmCYeNX`
	stTexture			mTexBase;		//XN[VbgeNX`
	s16					mBaseY;
	f32					mBaseYSpeed;
	s32					mBaseNowTick;
	s32					mBaseFadeTick;
	mK7Sprite			mSprtNoise;
	mK7Sprite			mSprtNoiseBottom;
	mK7Sprite			mSprtBase[NOISE_SAND_BASE_NUM];	//ʃXN[pXN[VbgXvCg
	f32					mSandScaleRate;
	bool				mMono;			//Lv`ʂ̃J[[h
	u32					mMonoRGBA;		//mNɌFw\
	
	bool				mNotNoiseSE;				//mCYȊOSE炷tO
	
	bool				mNoiseTrimming;				//g~OtO
	f32					mNoiseHeight;				//2̍
	stNoiseTex			mTexFontAlph;				//At@xbgtex
	stNoiseTex			mTexFontKata;				//J^Jitex
	stNoiseFont			mFont[NOISE_SAND_STR_MAX];	//mCYŎgtHg
	
	bool				mUpDownFontDisp;				//㉺̕tHĝݕ\Ă邩tO
	
	u32					mSandMaxRate;	//̍őgTCY
	s32					mWaitToMap;		//}bvֈڂÕEGCg
	bool				mScreenCopyFlag;
};




//---- extern ----
extern	MK7Noise*	gpNoise;



#endif	//__MK7NOISE_H__




