////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7PosInfo
//
// mK7PosInfo.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7POSINFO_CPP__

//---- include ----
#include "..\wat\WK7Define.h"
#include "mK7PosInfo.h"
#include "mK7Typo.h"

//---- define ----
#define	POSFONT_FILE			"Texture/k7TypoFont.jmb"	//|WVCtHtHgt@C

//---- O[oϐ ----
MK7PosInfo*	gpPosInfo = NULL;




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7PosInfo::MK7PosInfo()
{
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7PosInfo::~MK7PosInfo()
{
}




//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::Init( void )
{
	if( gpPosInfo == NULL ){
		ghmGcMemSetAllocName("MPosInf");
		gpPosInfo = new MK7PosInfo;
	}
	gpPosInfo->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::Term( void )
{
	gpPosInfo->mTerm();
	GHM_SAFE_DELETE( gpPosInfo );
}




//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mInit( void )
{
	int	i, j;
	
	//t[ݒ
	mFrameProc = ePiInit;
	
	//f[^|C^
	mString    = NULL;
	mSprt      = NULL;
	mSprtS     = NULL;
	mFontParam = NULL;
	
	//XvCg
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			mBackBox[i][j].mSetRGBA( 0xffffff00 );
			mBackBox[i][j].mSetXY0( (s16)(i * PI_WIDTH), (s16)(j * PI_HEIGHT) );
			mBackBox[i][j].mSetWH( PI_WIDTH, PI_HEIGHT );
			mBackBox[i][j].mSetBoxPrim();
		}
	}
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mTerm( void )
{
	int	i, j;
	
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			mBackBox[i][j].mSetDispFlag( false );
		}
	}
	//
	GHMGCMEM_SAFE_FREE( mString );
	GHM_SAFE_DELETE_ARRAY( mSprt );
	GHM_SAFE_DELETE_ARRAY( mSprtS );
}




//-----------------------------------------------------------------------------
//NGXg
// in --> char* inString  \(\n΂łŉsĕ\)
// out -> bool false  NGXgs
//             true   NGXg
//-----------------------------------------------------------------------------
bool
MK7PosInfo::mRequest( char* inString )
{
	int		i, j, num, row, line, index;
	int*	offsetTbl;
	
	//łĂȂΔ
	if( mFrameProc != ePiStandby )
		return( false );
	
	//\擾
	mLength = strlen( inString );
	//Ȃ΃_
	if( !mLength )
		return( false );
	//񃁃m
	mString = (char*)K7AppSmallMemAlloc( (int)((sizeof(char) * mLength) + 1) );
	//mۂłȂ_
	if( mString == NULL )
		return( false );
	//Rs[
	strcpy( mString, inString );
	
	//XvCg̃m
	ghmGcMemSetAllocName("MSprite");
	mSprt = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprt == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		return( false );
	}
	
	//eXvCg̃m
	ghmGcMemSetAllocName("MSprite");
	mSprtS = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprtS == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		GHM_SAFE_DELETE_ARRAY( mSprt );
		return( false );
	}
	
	//͐𐔂ĕ\SW߂
	for( num = i = 0; i < mLength; i++ )
	{
		if( mString[i] == '\n' )
			num++;
	}
	num++;
	line = (PI_H_NUM - 1) / num;
	offsetTbl = (int*)K7AppSmallMemAlloc( (int)(sizeof(int) * num) );
	
	//͂Ƃ̕𐔂
	for( num = j = i = 0; i < mLength; i++ )
	{
		//s
		if( mString[i] == '\n' )
		{
			offsetTbl[num] = j;
			j = 0;
			num++;
		}
		j++;
	}
	offsetTbl[num] = j - 1;
	
	//XvCgݒ
	for( num = i = 0; i < mLength; i++ )
	{
		//s
		if( mString[i] == '\n' )
		{
			 row  = 0;
			 num  = num + 1;
			 line = line + 1;
		}else
		//Xy[X
		if( mString[i] == ' ' )
		{
			//
			mSprt[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetRGBA( 0xffffffff );
			mSprt[i].mSetWH( (s16)8, (s16)mFontParam[187].h );
			mSprt[i].mSetU0( (s16)(mFontParam[187].u + mFontParam[187].w) );
			mSprt[i].mSetV0( (s16)mFontParam[187].v );
			mSprt[i].mSetXY0( (s16)(PI_WIDTH * row * 2), (s16)(PI_HEIGHT * line) );
			//e
			mSprtS[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprtS[i].mSetDispFlag( false );
			mSprtS[i].mSetRGBA( 0x000000ff );
			mSprtS[i].mSetWH( (s16)8, (s16)mFontParam[187].h );
			mSprtS[i].mSetU0( (s16)(mFontParam[187].u + mFontParam[187].w) );
			mSprtS[i].mSetV0( (s16)mFontParam[187].v );
			mSprtS[i].mSetXY0( (s16)(PI_WIDTH * row * 2 - 1), (s16)(PI_HEIGHT * line - 1) );
			mSprtS[i].mSetScale( eScaleWH, 1.1f, 1 );
			mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
			//Z
			row++;
		}else
		{
			index = mString[i] - 0x21 + 94;
			//
			mSprt[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetRGBA( 0xffffffff );
			mSprt[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprt[i].mSetU0( (s16)mFontParam[index].u );
			mSprt[i].mSetV0( (s16)mFontParam[index].v );
			mSprt[i].mSetXY0( (s16)( (PI_WIDTH * row * 2) +
			                         (PI_WIDTH * (line % 2)) +
			                         (PI_WIDTH / 4) +
			                         (PI_WIDTH * ((PI_W_NUM / 4) - (offsetTbl[num] / 2) + 1))   ),
			                  (s16)(PI_HEIGHT * line - 4) );
			//e
			mSprtS[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprtS[i].mSetDispFlag( false );
			mSprtS[i].mSetRGBA( 0x000000ff );
			mSprtS[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprtS[i].mSetU0( (s16)mFontParam[index].u );
			mSprtS[i].mSetV0( (s16)mFontParam[index].v );
			mSprtS[i].mSetXY0( (s16)( (PI_WIDTH * row * 2) +
			                          (PI_WIDTH * (line % 2)) +
			                          (PI_WIDTH / 4) +
			                          (PI_WIDTH * ((PI_W_NUM / 4) - (offsetTbl[num] / 2) + 1))
			                          - 1 ),
			                   (s16)(PI_HEIGHT * line - 1) );
			mSprtS[i].mSetScale( eScaleWH, 1.1f, 1 );
			mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
//	 + (PI_WIDTH * ((PI_W_NUM / 4) - (offsetTbl[line] / 2)))
			//Z
			row++;
		}
	}
	
	GHMGCMEM_SAFE_FREE( offsetTbl );
	
	//boxXvCgݒ
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			mBackBox[i][j].mSetDispFlag( true );
			mBackBox[i][j].mSetFadeWithWait( 0xff, 2400, 200*(i+j) );
		}
	}
	
	//t[ݒ
	mFrameProc = ePiFadeIn;
	
	return( true );
}




//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mFrameProcess( void )
{
	switch( mFrameProc )
	{
		//
		case	ePiInit:
			if( gpTypoMng->mGetStatus() == eTypoFontStandby )
			{
				//tHgp[^̈n
				mFontParam = gpTypoMng->mGetFontParamPtr();
				//X^oC
				mFrameProc = ePiStandby;
			}
			break;
		
		//tF[hCI`FbN
		case	ePiFadeIn:
			if( mCheckFadeEnd() == true )
			{
				mFrameProc = ePiWaitFadeReq;
			}
			break;
		
		//lpPiKڏI`FbN
		case	ePiPieceDrop1st:
			if( mCheckFadeEnd() == true )
			{
				mSet2ndDrop();
				mFrameProc = ePiPieceDrop2nd;
			}
			break;
		
		//lpQiKڏI`FbN
		case	ePiPieceDrop2nd:
			if( mCheckFadeEnd() == true )
			{
				mSetSprtDrop();
				mFrameProc = ePiCharFadeOut;
			}
			break;
		
		//tF[hAEgI`FbN
		case	ePiCharFadeOut:
			if( mCheckFadeEndSprt() == true )
			{
				mFrameProc = ePiStandby;
			}
			break;
		
		//tF[hAEgJn҂
		case	ePiWaitFadeReq:
			break;
		
		//X^oC
		case	ePiStandby:
			break;
		
		//ftHg
		default:
			break;
	}
}




//-----------------------------------------------------------------------------
//`揈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mRender( void )
{
}




//-----------------------------------------------------------------------------
//tF[hI`FbN
// in --> none
// out -> bool false  tF[h
//             true   tF[hI
//-----------------------------------------------------------------------------
bool
MK7PosInfo::mCheckFadeEnd( void )
{
	int	i, j;
	//tF[h`FbN
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			if( mBackBox[i][j].mGetFadeEnd() == false )
			{
				return( false );
			}
		}
	}
	return( true );
}
//-----------------------------------------------------------------------------
//tF[hI`FbN
// in --> none
// out -> bool false  tF[h
//             true   tF[hI
//-----------------------------------------------------------------------------
bool
MK7PosInfo::mCheckFadeEndSprt( void )
{
	int	i;
	//tF[h`FbN
	for( i = 0; i < mLength; i++ )
	{
		if( mString[i] != '\n' )
		{
			if( mSprt[i].mGetFadeEnd() == false )
			{
				return( false );
			}
		}
	}
	//tF[hI烁
	GHMGCMEM_SAFE_FREE( mString );
	GHM_SAFE_DELETE_ARRAY( mSprt );
	GHM_SAFE_DELETE_ARRAY( mSprtS );
	return( true );
}




//-----------------------------------------------------------------------------
//1stlp悤ɐݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mSet1stDrop( void )
{
	int	i, j;
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			if( (j % 2) == 0 )
			{
				if( (i % 2) == 0 )
				{
					//mBackBox[i][j].mSetFade( 0x00, 2400 );
					mBackBox[i][j].mSetFadeWithWait( 0x00, 1200, 100*(i+j) );
				}
			}else
			{
				if( (i % 2) != 0 )
				{
					//mBackBox[i][j].mSetFade( 0x00, 2400 );
					mBackBox[i][j].mSetFadeWithWait( 0x00, 1200, 100*(i+j) );
				}
			}
		}
	}
}




//-----------------------------------------------------------------------------
//2ndlp悤ɐݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mSet2ndDrop( void )
{
	int	i, j;
	for( j = 0; j < PI_H_NUM; j++ )
	{
		for( i = 0; i < PI_W_NUM; i++ )
		{
			if( (j % 2) == 0 )
			{
				if( (i % 2) != 0 )
				{
					//mBackBox[i][j].mSetFade( 0x00, 2400 );
					mBackBox[i][j].mSetFadeWithWait( 0x00, 1200, 100*(i+j) );
				}
			}else
			{
				if( (i % 2) == 0 )
				{
					//mBackBox[i][j].mSetFade( 0x00, 2400 );
					mBackBox[i][j].mSetFadeWithWait( 0x00, 1200, 100*(i+j) );
				}
			}
		}
	}
}




//-----------------------------------------------------------------------------
//悤ɐݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7PosInfo::mSetSprtDrop( void )
{
	int	i;
	for( i = 0; i < mLength; i++ )
	{
		if( mString[i] != '\n' )
		{
			mSprt[i].mSetFadeWithWait( 0x00, 1200, i * 100 );
			mSprtS[i].mSetFadeWithWait( 0x00, 1200, i * 100 );
		}
	}
}




//-----------------------------------------------------------------------------
//tF[hAEg悤ɐݒ
// in --> none
// out -> bool false  ʂ܂܂ĂȂ
//             true   NGXg
//-----------------------------------------------------------------------------
bool
MK7PosInfo::mRequestFadeOut( void )
{
	int	i;
	
	if( mFrameProc != ePiWaitFadeReq )
		return( false );
	
	//̃tF[hݒ
	for( i = 0; i < mLength; i++ )
	{
		if( mString[i] != '\n' )
		{
			mSprt[i].mSetDispFlag( true );
			mSprtS[i].mSetDispFlag( true );
		//	mSprt[i].mSetFadeWithWait( 0xff, 1200, i * 100 );
		//	mSprtS[i].mSetFadeWithWait( 0xff, 1200, i * 100 );
		}
	}
	
	//ŏ̔tF[hAEgݒ肷
	mSet1stDrop();
	//t[vZXi߂
	mFrameProc = ePiPieceDrop1st;
	
	return( true );
}




