////////////////////////////////////////////////////////////////////////////////
//
// Killer7  Sound Task
//
// mK7SoundTask.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 02/12/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__MK7SOUNDTASK_H__
#define	__MK7SOUNDTASK_H__

//---- include ----
#include "mK7Sound.h"

//---- define ----
#define	SOUND_TOP_DIR		"/sound"		//TEhfBNg
#define	SOUND_FILE_MAX		(1024)			//1̃fBNgɎ߂t@C
#define	SOUND_STRING_MAX	(128)			//t@C̍ő吔

//---- enum ----
//j[̃[h
typedef	enum{
	eMainMenuMode,
	eSelectSsmMode,
	eSelectHpsMode,
	eSelectVoiMode,
	eMenuModeMax,
}enMenuMode;

//j[̎
typedef	enum{
	eSelectSsm,
	ePlaySe,
	eStopSe,
	eDspSet,
	eDspRateSet,
	ePitchSe,
	eSelectHps,
	ePlayHps,
	eStopHps,
	eSelectVoice,
	ePlayVoice,
	eStopVoice,
	eMenuMax,
}enSoundMenu;

enum{
	eSsm,
	eHps,
};

//---- class ----
class MK7SoundTask : public ghmGcAppTask{
protected:
public:
	MK7SoundTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~MK7SoundTask();
	
	// R[obN
	virtual bool	InitializeCallBack(void);
	
	// t[
	virtual bool	FrameProcess(void);
	
	// IR[obN
	virtual bool	TerminateCallBack(void);
	
	// _O
	virtual bool	RenderProcess(void);

private:
	//---- ֐ ----
	bool			getDirInfo( char* inDirName );				//fBNg̎擾
	void			padProc( void );							//pbh͏
	bool			checkFile( char* inFileName, int inKind );	//t@C`FbN
	void			printStrings( void );						//\
	void			stopHps( void );							//hpst@CĐ~߂
	void			playHps( void );							//hpst@C̍Đ
	void			moveDirSearch( void );						//fBNgړ(ssm)
	void			makeFileList( void );						//t@CXg쐬
	
	//---- ϐ ----
	enMenuMode	mMenuMode;						//j[[h
	s32			mMainCurPos;					//Cj[̃J[\|WV
	s32			mFileSelectCurPos;				//t@CĨJ[\|WV
	int			mSelectSe;						//I𒆂SEԍ
	int			mSeMax;							//se̍ő吔
	int			mOrder;							//seĐۂɕKvȃVtg
	DVDDirEntry	mDirent[SOUND_FILE_MAX];		//fBNg
	s32			mFileTotalEntryNum;				//̃fBNg̃t@C
	char		mDirName[SOUND_STRING_MAX];		//I[vfBNg
	char		mSsmFileName[SOUND_STRING_MAX];	//ݓǂݍ܂Ăssmt@C
	char		mHpsFileName[SOUND_STRING_MAX];	//ݓǂݍ܂Ăhpst@C
	char		mVoiFileName[SOUND_STRING_MAX];	//ݓǂݍ܂Ăhpst@C
	char		mFileList[SOUND_FILE_MAX][SOUND_STRING_MAX];
	s32			mDispListTop;					//\Ă郊Xg̃gbvԍ
	s32			mDispNum;						//1ʓ̕\t@C
	u8			mHpsVol;						//yĐ{[
	u8			mVoiceVol;						//Đ{[
	enDspKind	mDspKind;						//ݐݒ肵ĂDSP̎
	u8			mDspRate;						//ݐݒ肵ĂDSP̊
	s16			mPitchSe;						//SẼsb` -10800`2400
	enDspKind	mOldDspKind;					//TEheXgɓODSP̎
	u8			mOldDspRate;					//TEheXgɓODSP̊
	
	bool		mOldDebugSound;					//TEh[hɓÕfobOtO
};

#endif	//__MK7SOUNDTASK_H__

