////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7TNoise
//
// mK7TNoise.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 07/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7TNOISE_CPP__

//---- include ----
#include "mK7TNoise.h"

//---- define ----
#define	TNOISE_BAND				(64)
#define	TNOISE_FADEOUT_TIME		(2400)
#define	TNOISE_LENGTH			(WK7_SCREEN_WIDTH)
#define	TNOISE_R				(0x7f)
#define	TNOISE_G				(0x7f)
#define	TNOISE_B				(0x7f)
#define	TNOISE_A				(0x90)

//---- O[oϐ ----
MK7TNoise*	gpTNoise = NULL;




//---- ֐ ----
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7TNoise::MK7TNoise()
{
	mFrameProc = eTNoiseInit;
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7TNoise::~MK7TNoise()
{
}




//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::Init( void )
{
	if( gpTNoise == NULL ){
		ghmGcMemSetAllocName("MTNoise");
		gpTNoise = new MK7TNoise;
	}
	gpTNoise->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::Term( void )
{
	gpTNoise->mTerm();
	GHM_SAFE_DELETE( gpTNoise );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mInit( void )
{
	mFrameProc = eTNoiseStandby;
	mLineNum   = 0;
	mFadeTime  = 0;
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mTerm( void )
{
}
//-----------------------------------------------------------------------------
//NGXg
// in --> ڂ₯鎞(1b=4800tick)
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mRequest( s32 inTick )
{
	mLineNum   = TNOISE_BAND;
	mFadeTime  = inTick - TNOISE_FADEOUT_TIME;
	if( mFadeTime <= 0 )
	{
		mFadeTime = TNOISE_FADEOUT_TIME;
		mFrameProc = eTNoiseFadeOut;
	}else
	{
		mFrameProc = eTNoiseExec;
	}
}
//-----------------------------------------------------------------------------
//~
// in --> bool inFadeout true  tF[hAEgŏ
//                       false 
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mStop( bool inFadeout )
{
	if( mFrameProc == eTNoiseExec )
	{
		if( inFadeout == true )
		{
			mFrameProc = eTNoiseFadeOut;
		}else
		{
			mLineNum   = 0;
			mFadeTime  = 0;
			mFrameProc = eTNoiseStandby;
		}
	}
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mFrameProcess( void )
{
	switch( mFrameProc )
	{
		//
		case	eTNoiseInit:
			mFrameProc = eTNoiseStandby;
			break;
		
		//mCYs
		case	eTNoiseExec:
			mFadeTime -= WK7_TICK_PER_FRAME;
			if( mFadeTime <= 0 )
			{
				mFadeTime = TNOISE_FADEOUT_TIME;
				mFrameProc = eTNoiseFadeOut;
			}
			break;
		
		//tF[hAEg
		case	eTNoiseFadeOut:
			mFadeTime -= WK7_TICK_PER_FRAME;
//			mFadeTime -= TNOISE_FADEOUT_TIME / TNOISE_BAND;
			if( mFadeTime <= 0 )
			{
				mLineNum   = 0;
				mFadeTime  = 0;
				mFrameProc = eTNoiseStandby;
			}else
			{
				mLineNum -= (WK7_TICK_PER_FRAME * TNOISE_BAND / TNOISE_FADEOUT_TIME);
			}
			break;
		
		//ҋ@
		case	eTNoiseStandby:
			break;
		
		//ftHg
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//`揈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TNoise::mRender( void )
{
	s16	i, x0;
	u32	color;
	
	//\tOĂΕ\
	if( mLineNum != 0 )
	{
		//tevݒ
		mK7Sprite::mSetCamera2D();
		
		//Zobt@r[hݒ
		GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
		//EFBփ_Oۂ̃J[obt@XV[h
		GXSetColorUpdate( GX_TRUE );
		//EFBփ_Oۂ̃At@obt@XV[h
		GXSetAlphaUpdate( GX_FALSE );
		//EFBƂ̃uh@߂
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
		
		//TEVXe[Wŗp\ɂeNX`W̐ݒ
		GXSetNumTexGens( 0 );
		
		//TEVXe[Wւ̏o͂łJ[`l̐ݒ聨̊GXSetTevOrderŗp
		GXSetNumChans( 1 );
		//GX_COLOR0A0̃CgRg[̐ݒ
		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//		GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
		
		//TEVXe[W̐ݒ
		GXSetNumTevStages( 1 );
		//TEVXe[WŔJ[
		GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
		
		//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
		GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );	//J[`lgꍇ͂Ăяo
		
		//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
		GXClearVtxDesc();
		//Jg_Lqq̂ꂼ̑̎ނݒ
		GXSetVtxDesc( GX_VA_POS,  GX_DIRECT );	//ʒuW̎ނݒ
		GXSetVtxDesc( GX_VA_CLR0, GX_DIRECT );	//J[0̎ނݒ
		
		//ꂼ̗̑vf(?)Ǝނݒ
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ,  GX_S16  , 0 );	//|WV̗vfƎނw
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
		
		//C̑ݒ肷
		GXSetLineWidth( (u8)6, GX_TO_ZERO );
		//CXgbv
		for( i = 0; i < mLineNum; i++ )
		{
			//---- ʏ̃mCY ----
			x0    = (s16)(HSD_Randi(640) - (TNOISE_LENGTH / 2));
			//color = (u32)((HSD_Randi(TNOISE_R) << 24) | (HSD_Randi(TNOISE_G) << 16) | (HSD_Randi(TNOISE_B) << 8) | HSD_Randi(TNOISE_A) );
			color = (u32)HSD_Randi(TNOISE_A);
			color = (u32)((color << 24) | (color << 16) | (color << 8) | color );
			GXBegin( GX_LINES, GX_VTXFMT0, 2 );
				GXPosition3s16( x0, i, 1 );
				GXColor1u32   ( color );
				GXPosition3s16( (s16)(x0 + HSD_Randi(TNOISE_LENGTH)), i, 1 );
				GXColor1u32   ( color );
			GXEnd();
			//---- ʉ̃mCY ----
			x0    = (s16)(HSD_Randi(640) - (TNOISE_LENGTH / 2));
			//color = (u32)((HSD_Randi(TNOISE_R) << 24) | (HSD_Randi(TNOISE_G) << 16) | (HSD_Randi(TNOISE_B) << 8) | HSD_Randi(TNOISE_A) );
			color = (u32)HSD_Randi(TNOISE_A);
			color = (u32)((color << 24) | (color << 16) | (color << 8) | color );
			GXBegin( GX_LINES, GX_VTXFMT0, 2 );
				GXPosition3s16( x0, (s16)(WK7_SCREEN_HEIGHT - i), 1 );
				GXColor1u32   ( color );
				GXPosition3s16( (s16)(x0 + HSD_Randi(TNOISE_LENGTH)), (s16)(WK7_SCREEN_HEIGHT - i), 1 );
				GXColor1u32   ( color );
			GXEnd();
		}
	}
}





