////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Matsuzaki  mK7Typo
//
// mK7Typo.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 04/16/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7TYPO_CPP__

//---- include ----
#include "mK7Typo.h"

//---- define ----
#define	TYPOFONT_FILE			"Texture/k7TypoFont.jmb"	//^C|tHgt@C
#define	TYPOICON_FILE			"Texture/TypoIcon.bin"		//^C|ACRt@C
#define	TYPO_SHADOW_ALPHA		(0x000000c0)				//ẽl
#define	TYPO_SPACE_WIDTH_S		(4)							//Xy[X̕:
#define	TYPO_SPACE_WIDTH_B		(8)							//Xy[X̕:傫
#define	TYPO_CHAR_KIND_MAX		(94)						//̎ނ̍ő吔
#define	TYPO_LASTCHAR_INDEX		((TYPO_CHAR_KIND_MAX*2)-1)	//Ō̕ւindex
#define	TYPO_FADE_SPEED			(2400)						//^C|tF[hx(P:tick)
#define	TYPO_LINE_WIDTH			(8)//(6)					//C̑
#define	TYPO_LINE_LENGTH		(120)						//C̒
#define	TYPO_LINE_YOFFSET		(38)//(40)//(44)//(36)						//tHg烉C܂ł̃ItZbg
#define	TYPO_BIG_FONT_OFFSET	(34)//(36)//(40)//(32)						//傫ȃtHg̕\ItZbg
//#define	TYPO_LINE_YOFFSET		(32)						//tHg烉C܂ł̃ItZbg qMm6
//#define	TYPO_BIG_FONT_OFFSET	(32)						//傫ȃtHg̕\ItZbg           qMm6
//#define	TYPO_LINE_YOFFSET		(36)						//tHg烉C܂ł̃ItZbg Framework_R21B
//#define	TYPO_BIG_FONT_OFFSET	(36)						//傫ȃtHg̕\ItZbg           Framework_R21B
#define	TYPO_ICON_W				(20)	//^C|ACR̕
#define	TYPO_ICON_H				(20)	//^C|ACR̍
#define	TYPO_SHADOW_NUM			(4)		//eɎgXvCg
#define	TYPE_ICON_COLOR_DIR		(0xff640000)	//ACRJ[Ep
#define	TYPE_ICON_COLOR_DOOR	(0x1e780000)	//ACRJ[EhA
#define	TYPE_ICON_COLOR_KEY		(0x1e780000)	//ACRJ[E
#define	TYPE_ICON_COLOR_MAP		(0x1e28a000)	//ACRJ[En}
#define	TYPE_ICON_COLOR_MEMO	(0x1e28a000)	//ACRJ[E
#define	TYPE_ICON_COLOR_VREC	(0x0064aa00)	//ACRJ[E
#define	TYPE_ICON_COLOR_GRAF	(0x0064aa00)	//ACRJ[E
#define	TYPE_ICON_COLOR_EVENT	(0x1e28a000)	//ACRJ[ECxg
#define	TYPE_ICON_COLOR_TV		(0x823ca000)	//ACRJ[Eer

//---- O[oϐ ----
MK7TypoMng*	gpTypoMng = NULL;
MK7Typo*	gTypoTop = NULL;

//---- ֐ ----
/****  typo ****/
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Typo::MK7Typo()
{
	//ϐ
	mSprt      = NULL;
	mSprtS     = NULL;
	mMove      = NULL;
	mLength    = 0;
	mString    = NULL;
	mIcon      = 0;
	//Xg̍\z(VꂽXvCg͏ɃXg̐擪ɂ悤Xg쐬)
	mPrev = NULL;
	mNext = gTypoTop;
	if( mNext != NULL )
		mNext->mPrev = this;	//̎̑O=
	gTypoTop = this;			//Xg̐擪=
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Typo::~MK7Typo()
{
	//Xgč\z
	if( mPrev == NULL )
		gTypoTop     = mNext;	//OȂꍇ̓Xg̃gbv=̎
	else
		mPrev->mNext = mNext;	//Oꍇ͎̑O̎=̎
	if( mNext != NULL )
		mNext->mPrev = mPrev;	//Xg̍ŌłȂΎ̎̑O=̑O
	//
	GHMGCMEM_SAFE_FREE( mString );
	GHM_SAFE_DELETE_ARRAY( mSprt );
	GHM_SAFE_DELETE_ARRAY( mSprtS );
	GHMGCMEM_SAFE_FREE( mMove );
	//ACRNA
	mIcon = 0;
}
//-----------------------------------------------------------------------------
//^C|ACRւindex擾
// in --> u32* inFlag    ACR̕\tOւ̃|C^
//        int* inDirNum  p̕\
// out -> s16  -1        YACRȂ
//             ȊO  ACRւindex
//-----------------------------------------------------------------------------
s16
MK7Typo::mGetIconIndex( u32* inFlag, int* inDirNum )
{
	//ACR
	if( *inFlag & TF_DOOR  ){ *inFlag &= ~TF_DOOR;  return( 4 );  }
	if( *inFlag & TF_KEY   ){ *inFlag &= ~TF_KEY;   return( 5 );  }
	if( *inFlag & TF_MAP   ){ *inFlag &= ~TF_MAP;   return( 6 );  }
	if( *inFlag & TF_MEMO  ){ *inFlag &= ~TF_MEMO;  return( 7 );  }
	if( *inFlag & TF_VREC  ){ *inFlag &= ~TF_VREC;  return( 8 );  }
	if( *inFlag & TF_GRFF  ){ *inFlag &= ~TF_GRFF;  return( 9 );  }
	if( *inFlag & TF_EVENT ){ *inFlag &= ~TF_EVENT; return( 10 ); }
	if( *inFlag & TF_TV    ){ *inFlag &= ~TF_TV;    return( 11 ); }
	//k
	if( *inFlag & TF_N )
	{
		if( inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 0 );
		}
	}
	//kk
	if( *inFlag & TF_NNE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//k
	if( *inFlag & TF_NE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//k
	if( *inFlag & TF_ENE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 1 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//
	if( *inFlag & TF_E )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//쓌
	if( *inFlag & TF_ESE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 1 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//쓌
	if( *inFlag & TF_SE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//쓌
	if( *inFlag & TF_SSE )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 1 );
		}
	}
	//
	if( *inFlag & TF_S )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 2 );
		}
	}
	//쐼
	if( *inFlag & TF_SSW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//쐼
	if( *inFlag & TF_SW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//쐼
	if( *inFlag & TF_WSW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 3 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 2 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//
	if( *inFlag & TF_W )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//k
	if( *inFlag & TF_WNW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 3 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//k
	if( *inFlag & TF_NW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	//kk
	if( *inFlag & TF_NNW )
	{
		if( *inDirNum == 0 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 1 )
		{
			*inDirNum += 1;
			return( 0 );
		}else
		if( *inDirNum == 2 )
		{
			*inDirNum += 1;
			return( 3 );
		}
	}
	
	return( 0 );
}
//-----------------------------------------------------------------------------
//^C|ACRNGCg
// in --> u32              inFlag    ACR̕\tO
//        enTypoDispFormat inFormat  ACR̕\̂
// out -> bool             flase     NGXgs
//                         true      NGXg
//-----------------------------------------------------------------------------
bool
MK7Typo::mCreateIcon( u32 inFlag, enTypoDispFormat inFormat )
{
	int	i, index, dirNum;
	
	//^C|tHgt@Cǂݍ܂ĂȂ΃_
	if( gpTypoMng->mGetTexExist() == false )
		return( false );
	
	//ɕf[^Ăꍇ
	if( (mString != NULL) || (mIcon != 0) )
		mErase();
	
	//ACRw肳ĂȂΔ
	if( inFlag == 0 )
		return( false );
	
	//KvACR𒲂ׂ
	mLength = 0;
	if( inFlag & TF_N     ) mLength+=1; else
	if( inFlag & TF_NNE   ) mLength+=3; else
	if( inFlag & TF_NE    ) mLength+=2; else
	if( inFlag & TF_ENE   ) mLength+=3; else
	if( inFlag & TF_E     ) mLength+=1; else
	if( inFlag & TF_ESE   ) mLength+=3; else
	if( inFlag & TF_SE    ) mLength+=2; else
	if( inFlag & TF_SSE   ) mLength+=3; else
	if( inFlag & TF_S     ) mLength+=1; else
	if( inFlag & TF_SSW   ) mLength+=3; else
	if( inFlag & TF_SW    ) mLength+=2; else
	if( inFlag & TF_WSW   ) mLength+=3; else
	if( inFlag & TF_W     ) mLength+=1; else
	if( inFlag & TF_WNW   ) mLength+=3; else
	if( inFlag & TF_NW    ) mLength+=2; else
	if( inFlag & TF_NNW   ) mLength+=3;
	if( inFlag & TF_DOOR  ) mLength++;
	if( inFlag & TF_KEY   ) mLength++;
	if( inFlag & TF_MAP   ) mLength++;
	if( inFlag & TF_MEMO  ) mLength++;
	if( inFlag & TF_VREC  ) mLength++;
	if( inFlag & TF_GRFF  ) mLength++;
	if( inFlag & TF_EVENT ) mLength++;
	if( inFlag & TF_TV    ) mLength++;
	
	//Ȃ΃_
	if( !mLength )
		return( false );
	
	//ACRtÕRs[
	mIcon = inFlag;
	
	//XvCg̃m
	ghmGcMemSetAllocName("MSprite");
	mSprt = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprt == NULL )
		return( false );
	
	//ϐ
	mWidth      = 0;
	mDispFormat = inFormat;
	dirNum      = 0;
	
	//eNX`ݒ
	for( i = 0; i < mLength; i++ )
	{
		//indexւ̃ItZbgvZ
		index = mGetIconIndex( &mIcon, &dirNum );
		//XvCg
		mSprt[i].mRelateTex( gpTypoMng->mGetTexIconPtr() );
		mSprt[i].mSetWH( TYPO_ICON_W, TYPO_ICON_H );
		mSprt[i].mSetU0( (s16)(TYPO_ICON_W * index) );
		mSprt[i].mSetV0( 0 );
		mSprt[i].mSetDispFlag( false );
		mSprt[i].mSetPriority( SPRT_PRI_TYPO );
		switch( index )
		{
			case	4://
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_DOOR );
				break;
			case	5://
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_KEY );
				break;
			case	6://n}
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_MAP );
				break;
			case	7://
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_MEMO );
				break;
			case	8://
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_VREC );
				break;
			case	9://
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_GRAF );
				break;
			case	10://Cxg
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_EVENT );
				break;
			case	11://er
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_TV );
				break;
			default:
				mSprt[i].mSetRGBA( TYPE_ICON_COLOR_DIR );
				break;
		}
		//2{\
		mSprt[i].mSetScale( eScaleWH, 1.50f, 1 );
		mSprt[i].mScaleProc();
		//vZ
		mWidth += mSprt[i].mGetW();
	}
	
	//ACRtÕRs[EACRindex̎擾ŃtOƂ̂
	mIcon = inFlag;
	
	//XvCǧƏ̏ݒ
	mSprtInit();
	
	return( true );
}
//-----------------------------------------------------------------------------
//^C|NGCg
// in --> char*            inString  ^C|\
//        enTypoDispFormat inFormat  ^C|̕\̂
// out -> bool  flase     NGXgs
//              true      NGXg
//-----------------------------------------------------------------------------
bool
MK7Typo::mCreateStr( char* inString, enTypoDispFormat inFormat )
{
	int		i, j, index, spaceSize;
	bool	BFlag;
	
	//^C|tHgt@Cǂݍ܂ĂȂ΃_
	if( gpTypoMng->mGetTexExist() == false )
		return( false );
	
	//ɕf[^Ăꍇ
	if( (mString != NULL) || (mIcon != 0) )
		mErase();
	
	//\擾
	mLength = strlen( inString );
	//Ȃ΃_
	if( !mLength )
		return( false );
	//񃁃m
	mString = (char*)K7AppSmallMemAlloc( (int)((sizeof(char) * mLength) + 1) );
	//mۂłȂ_
	if( mString == NULL )
		return( false );
	//Rs[
	strcpy( mString, inString );
	
	//XvCg̃m
	ghmGcMemSetAllocName("MSprite");
	mSprt = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprt == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		return( false );
	}
	
	//eXvCg̃m
	ghmGcMemSetAllocName("MSprite");
	mSprtS = new mK7Sprite[mLength*TYPO_SHADOW_NUM];
	//mۂłȂ_
	if( mSprtS == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		GHM_SAFE_DELETE_ARRAY( mSprt );
		return( false );
	}
	
	//YWݒp̃m
	mMove = (stMove*)K7AppSmallMemAlloc( (int)(sizeof(stMove)*mLength) );
	//mۂłȂ_
	if( mMove == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		GHM_SAFE_DELETE_ARRAY( mSprt );
		GHM_SAFE_DELETE_ARRAY( mSprtS );
		return( false );
	}
	
	//ϐ
	mWidth      = 0;
	mDispFormat = inFormat;
	
	//Arial Black tHggtO
	//BFlag       = false;
	BFlag       = true;
	
	//tHgp[^擾
	mFontParam = gpTypoMng->mGetFontParamPtr();
	//eNX`ݒ
	for( i = 0; i < mLength; i++ )
	{
		//ړԏ
		mMove[i].nowTick  = 0;
		mMove[i].nowY     = 0.0f;
		mMove[i].orgY     = 0.0f;
		mMove[i].waitTick = 0;		//ł͈ړ̃tOɎg܂
		//Xy[X̏ꍇ
		if( mString[i] == ' ' )
		{
			//Arial Black ɂ邩ǂf
			if( BFlag == false )
				BFlag = true;
			else
				BFlag = false;
			//Xy[XTCY
			spaceSize = TYPO_SPACE_WIDTH_S;
			//XvCg
			mSprt[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprt[i].mSetWH( (s16)spaceSize, (s16)mFontParam[TYPO_LASTCHAR_INDEX].h );
			mSprt[i].mSetU0( (s16)(mFontParam[TYPO_LASTCHAR_INDEX].u + mFontParam[TYPO_LASTCHAR_INDEX].w) );
			mSprt[i].mSetV0( (s16)mFontParam[TYPO_LASTCHAR_INDEX].v );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetPriority( SPRT_PRI_TYPO );
			//eXvCg
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				mSprtS[i*TYPO_SHADOW_NUM+j].mRelateTex( gpTypoMng->mGetTexStrPtr() );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetWH( (s16)spaceSize, (s16)mFontParam[TYPO_LASTCHAR_INDEX].h );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetU0( (s16)(mFontParam[TYPO_LASTCHAR_INDEX].u + mFontParam[TYPO_LASTCHAR_INDEX].w) );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetV0( (s16)mFontParam[TYPO_LASTCHAR_INDEX].v );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( false );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetPriority( SPRT_PRI_TYPO_SHADOW );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetRGBA( TYPO_SHADOW_ALPHA );
			}
			//^C|̕vZ
			mWidth += mSprt[i].mGetW();
		}else
		//nCt̏ꍇ
		if( mString[i] == '-' )
		{
			//Arial Black ɂ邩ǂf
			if( BFlag == false )
				BFlag = true;
			else
				BFlag = false;
			//indexւ̃ItZbgvZ
			index = mString[i] - 0x21;
			//XvCg
			mSprt[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprt[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprt[i].mSetU0( (s16)mFontParam[index].u );
			mSprt[i].mSetV0( (s16)mFontParam[index].v );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetPriority( SPRT_PRI_TYPO );
			//eXvCg
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				mSprtS[i*TYPO_SHADOW_NUM+j].mRelateTex( gpTypoMng->mGetTexStrPtr() );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetU0( (s16)mFontParam[index].u );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetV0( (s16)mFontParam[index].v );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( false );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetPriority( SPRT_PRI_TYPO_SHADOW );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetRGBA( TYPO_SHADOW_ALPHA );
			}
			//^C|̕vZ
			mWidth += mSprt[i].mGetW();
		}else
		{
			//indexւ̃ItZbgvZ
			if( BFlag == false )
				index = mString[i] - 0x21;
			else
				index = mString[i] - 0x21 + TYPO_CHAR_KIND_MAX;
			//XvCg
			mSprt[i].mRelateTex( gpTypoMng->mGetTexStrPtr() );
			mSprt[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprt[i].mSetU0( (s16)mFontParam[index].u );
			mSprt[i].mSetV0( (s16)mFontParam[index].v );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetPriority( SPRT_PRI_TYPO );
			//eXvCg
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				mSprtS[i*TYPO_SHADOW_NUM+j].mRelateTex( gpTypoMng->mGetTexStrPtr() );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetU0( (s16)mFontParam[index].u );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetV0( (s16)mFontParam[index].v );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( false );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetPriority( SPRT_PRI_TYPO_SHADOW );
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetRGBA( TYPO_SHADOW_ALPHA );
			}
			//^C|̕vZ
			mWidth += mSprt[i].mGetW();
		}
	}
	
	//XvCǧƏ̏ݒ
	mSprtInit();
	
	return( true );
}
#if	0
bool
MK7Typo::mCreateStr( char* inString, enTypoSize inSize, enTypoDispFormat inFormat )
{
	int	i, index, spaceSize;
	
	//^C|tHgt@Cǂݍ܂ĂȂ΃_
	if( gpTypoMng->mGetTexExist() == false )
		return( false );
	
	//ɕf[^Ăꍇ
	if( mString != NULL )
		mErase();
	
	//\擾
	mLength = strlen( inString );
	//Ȃ΃_
	if( !mLength )
		return( false );
	//񃁃m
	mString = (char*)K7AppSmallMemAlloc( (int)((sizeof(char) * mLength) + 1) );
	//mۂłȂ_
	if( mString == NULL )
		return( false );
	//Rs[
	strcpy( mString, inString );
	
	//XvCg̃m
	mSprt = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprt == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		return( false );
	}
	
	//eXvCg̃m
	mSprtS = new mK7Sprite[mLength];
	//mۂłȂ_
	if( mSprtS == NULL )
	{
		GHMGCMEM_SAFE_FREE( mString );
		GHM_SAFE_DELETE_ARRAY( mSprt );
		return( false );
	}
	
	//ϐ
	mWidth      = 0;
	mDispFormat = inFormat;
	
	//tHgp[^擾
	mFontParam = gpTypoMng->mGetFontParamPtr();
	//eNX`ݒ
	for( i = 0; i < mLength; i++ )
	{
		if( mString[i] == ' ' )
		{//Xy[X̏ꍇ
			if( inSize == eTypoSizeSmall )
				spaceSize = TYPO_SPACE_WIDTH_S;
			else
				spaceSize = TYPO_SPACE_WIDTH_B;
			//XvCg
			mSprt[i].mRelateTex( gpTypoMng->mGetTexPtr() );
			mSprt[i].mSetWH( (s16)spaceSize, (s16)mFontParam[TYPO_LASTCHAR_INDEX].h );
			mSprt[i].mSetU0( (s16)(mFontParam[TYPO_LASTCHAR_INDEX].u + mFontParam[TYPO_LASTCHAR_INDEX].w) );
			mSprt[i].mSetV0( (s16)mFontParam[TYPO_LASTCHAR_INDEX].v );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetPriority( SPRT_PRI_TYPO );
			//eXvCg
			mSprtS[i].mRelateTex( gpTypoMng->mGetTexPtr() );
			mSprtS[i].mSetWH( (s16)spaceSize, (s16)mFontParam[TYPO_LASTCHAR_INDEX].h );
			mSprtS[i].mSetU0( (s16)(mFontParam[TYPO_LASTCHAR_INDEX].u + mFontParam[TYPO_LASTCHAR_INDEX].w) );
			mSprtS[i].mSetV0( (s16)mFontParam[TYPO_LASTCHAR_INDEX].v );
			mSprtS[i].mSetDispFlag( false );
			mSprtS[i].mSetPriority( SPRT_PRI_TYPO_SHADOW );
			mSprtS[i].mSetRGBA( TYPO_SHADOW_ALPHA );
			mSprtS[i].mSetScale( eScaleWH, 1.2f, 1 );
			mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
			//^C|̕vZ
			mWidth += mSprt[i].mGetW();
		}else
		{
			//indexւ̃ItZbgvZ
			if( inSize == eTypoSizeSmall )
				index = mString[i] - 0x21;
			else
				index = mString[i] - 0x21 + TYPO_CHAR_KIND_MAX;
			//XvCg
			mSprt[i].mRelateTex( gpTypoMng->mGetTexPtr() );
			mSprt[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprt[i].mSetU0( (s16)mFontParam[index].u );
			mSprt[i].mSetV0( (s16)mFontParam[index].v );
			mSprt[i].mSetDispFlag( false );
			mSprt[i].mSetPriority( SPRT_PRI_TYPO );
			//eXvCg
			mSprtS[i].mRelateTex( gpTypoMng->mGetTexPtr() );
			mSprtS[i].mSetWH( (s16)mFontParam[index].w, (s16)mFontParam[index].h );
			mSprtS[i].mSetU0( (s16)mFontParam[index].u );
			mSprtS[i].mSetV0( (s16)mFontParam[index].v );
			mSprtS[i].mSetDispFlag( false );
			mSprtS[i].mSetPriority( SPRT_PRI_TYPO_SHADOW );
			mSprtS[i].mSetRGBA( TYPO_SHADOW_ALPHA );
			mSprtS[i].mSetScale( eScaleWH, 1.2f, 1 );
			mSprtS[i].mScaleProc();	//XP[𒼂ɔf邽߂ɂŌĂяo
			//^C|̕vZ
			mWidth += mSprt[i].mGetW();
		}
	}
	
	//XvCǧƏ̏ݒ
	mSprtInit();
	
	return( true );
}
#endif
//-----------------------------------------------------------------------------
//XvCǧƏ̏ݒ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSprtInit( void )
{
	int	i, j;
	
	switch( mDispFormat )
	{
		//tF[hCAEg
		case	eTypoFadeInOut:
		case	eTypoFadeInOutWithWait:
			for( i = 0; i < mLength; i++ )
			{
				mSprt[i].mSetFade( 0x00, 1 );
				mSprt[i].mFadeProc();
				if( mIcon == 0 )
				{
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, 1 );
						mSprtS[i*TYPO_SHADOW_NUM+j].mFadeProc();
					}
				}
			}
			break;
		
		//k>k
		case	eTypoReduce:
			for( i = 0; i < mLength; i++ )
			{
				//
				mSprt[i].mSetFade( 0x00, 1 );
				mSprt[i].mFadeProc();
				mSprt[i].mSetScale( eScaleWH, 2.0f, 1 );
				mSprt[i].mScaleProc();
				//e
				if( mIcon == 0 )
				{
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, 1 );
						mSprtS[i*TYPO_SHADOW_NUM+j].mFadeProc();
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetScale( eScaleWH, 2.0f, 1 );
						mSprtS[i*TYPO_SHADOW_NUM+j].mScaleProc();
					}
				}
			}
			break;
		
		//W
		default:
			for( i = 0; i < mLength; i++ )
			{
				mSprt[i].mSetFade( 0x00, 1 );
				mSprt[i].mFadeProc();
				if( mIcon == 0 )
				{
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, 1 );
						mSprtS[i*TYPO_SHADOW_NUM+j].mFadeProc();
					}
				}
			}
			break;
	}
}
//-----------------------------------------------------------------------------
//^C|
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mErase( void )
{
	int i, j;
	
	//\
	for( i = 0; i < mLength; i++ )
	{
		if( mSprt != NULL )
		{
			mSprt[i].mSetDispFlag( false );
		}
		if( mIcon == 0 )
		{
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				if( mSprtS != NULL )
				{
					mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( false );
				}
			}
		}
	}
	mLength = 0;
	mIcon   = 0;
	GHMGCMEM_SAFE_FREE( mString );
	GHM_SAFE_DELETE_ARRAY( mSprt );
	GHM_SAFE_DELETE_ARRAY( mSprtS );
	GHMGCMEM_SAFE_FREE( mMove );
}
//-----------------------------------------------------------------------------
//\Wݒ
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetXY0( s16 inX, s16 inY )
{
	int i, j;
	s16	w = 0;
	for( i = 0; i < mLength; i++ )
	{
		if( i != 0 )
		{
			//ACRłȂ΃IWi̕擾
			if( mIcon == 0 )
			{
				w += mSprt[i-1].mGetOrgW();
			}else
			//ACR͊g傳Ă̂Ō݂̕擾
			{
				w += mSprt[i-1].mGetW();
			}
		}
		mSprt[i].mSetXY0( (s16)(inX + w), inY );
		if( mIcon == 0 )
		{
			//IWiYWۑ
			mMove[i].orgX    = (f32)inY;
			//
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				switch( j )
				{
					case	0:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( (s16)(inX + w - 1), (s16)(inY) );
						break;
					case	1:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( (s16)(inX + w + 1), (s16)(inY) );
						break;
					case	2:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( (s16)(inX + w), (s16)(inY - 1) );
						break;
					case	3:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( (s16)(inX + w), (s16)(inY + 1) );
						break;
					default:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( (s16)(inX + w), (s16)(inY) );
						break;
				}
			}
		}
	}
}
//-----------------------------------------------------------------------------
//^C|̒S\Wݒ
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetXYCenter( s16 inX, s16 inY )
{
	int i;
	s16	offsetX, offsetY;
	for( i = offsetX = 0; i < mLength; i++ )
		offsetX += mSprt[i].mGetOrgW();
	//	offsetX += mSprt[i].mGetW();
	offsetX = (s16)(offsetX / 2);
	offsetY = (s16)(mSprt[0].mGetOrgH() / 2);
	//offsetY = (s16)(mSprt[0].mGetH() / 2);
	mSetXY0( (s16)(inX - offsetX), (s16)(inY - offsetY) );
}
//-----------------------------------------------------------------------------
//RGBAl̐ݒ
// in --> u32 inRgba  RGBAl
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetRGBA( u32 inRgba )
{
	int i;
	for( i = 0; i < mLength; i++ )
	{
		mSprt[i].mSetRGBA( inRgba );
	}
}
//-----------------------------------------------------------------------------
//RGBAl̎擾
// in --> none
// out -> u32 RGBAl
//-----------------------------------------------------------------------------
u32
MK7Typo::mGetRGBA( void )
{
	ASSERT(mLength);//mCreate()Ă܂
	return( mSprt[0].mGetRGBA() );
}
//-----------------------------------------------------------------------------
//RGBl̐ݒ
// in --> u32 inRgb  RGBl
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetRGB( u32 inRgb )
{
	int i;
	for( i = 0; i < mLength; i++ )
	{
		mSprt[i].mSetRGBA( (inRgb & 0xffffff00) | (mSprt[i].mGetA()) );
	}
}
//-----------------------------------------------------------------------------
//tF[h̐ݒ
// in --> u8  inA     ڕWl
//        s32 inTick  tF[hɂ鎞(P:tick)
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetFade( u8 inA, s32 inTick )
{
	int i, j;
	for( i = 0; i < mLength; i++ )
	{
		mSprt[i].mSetFade( inA, inTick );
		if( mIcon == 0 )
		{
			if( inA < (u8)TYPO_SHADOW_ALPHA )
			{
				for( j = 0; j < TYPO_SHADOW_NUM; j++ )
				{
					mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( inA, inTick );
				}
			}else
			{
				for( j = 0; j < TYPO_SHADOW_NUM; j++ )
				{
					mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( (u8)TYPO_SHADOW_ALPHA, inTick );
				}
			}
		}
	}
}
//-----------------------------------------------------------------------------
//tF[h̏I̊mF
// in --> none
// out -> bool false  tF[h
//             true   tF[hI
//-----------------------------------------------------------------------------
bool
MK7Typo::mGetFadeEnd( void )
{
	int	i;
	//񂪓ĂȂ΃tF[hIƂĕԂ
	if( !mLength )
		return( true );
	//SătF[hIĂ邩ׂ
	for( i = 0; i < mLength; i++ )
	{
		if( mSprt[i].mGetFadeEnd() == false )
			return( false );
	}
	return( true );
}
//-----------------------------------------------------------------------------
//ړ̐ݒ
// in --> s16 inX     ړXW
//        s16 inY     ړYW
//        s32 inTick  ړɂ鎞(P:tick)
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetMove( s16 inX, s16 inY, s32 inTick )
{
	int i, j;
	s16	w = 0;
	for( i = 0; i < mLength; i++ )
	{
		if( i != 0 )
		w += mSprt[i-1].mGetW();
		mSprt[i].mSetMove( (s16)(inX + w), inY, inTick );
		if( mIcon == 0 )
		{
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				switch( j )
				{
					case	0:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetMove( (s16)(inX + w - 1), (s16)(inY), inTick );
						break;
					case	1:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetMove( (s16)(inX + w + 1), (s16)(inY), inTick );
						break;
					case	2:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetMove( (s16)(inX + w), (s16)(inY - 1), inTick );
						break;
					case	3:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetMove( (s16)(inX + w), (s16)(inY + 1), inTick );
						break;
					default:
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetMove( (s16)(inX + w), (s16)(inY), inTick );
						break;
				}
			}
		}
	}
}
//-----------------------------------------------------------------------------
//ړI̊mF
// in --> none
// out -> bool false  ړ
//             true   ړI
//-----------------------------------------------------------------------------
bool
MK7Typo::mGetMoveEnd( void )
{
	ASSERT(mLength);//mCreate()Ă܂
	return( mSprt[0].mGetMoveEnd() );
}
//-----------------------------------------------------------------------------
//^C|̃NGCgNGXgǂ`FbN
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Typo::mExistCheck( void )
{
	if( mLength )
		return( true );
	else
		return( false );
}
//-----------------------------------------------------------------------------
//^C|\
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mDisp( void )
{
	int	i, j, randTime;
	switch( mDispFormat )
	{
		//tF[hCAEg
		case	eTypoFadeInOut:
			for( i = 0; i < mLength; i++ )
			{
				//
				mSprt[i].mSetDispFlag( true );
				mSprt[i].mSetFade( 0xff, TYPO_FADE_SPEED );
				if( mIcon == 0 )
				{
					//e
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( true );
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0xff, TYPO_FADE_SPEED );
					}
				}
			}
			break;
		
		//tF[hCAEgEEGCgt
		case	eTypoFadeInOutWithWait:
			for( i = 0; i < mLength; i++ )
			{
				//
				mSprt[i].mSetDispFlag( true );
				mSprt[i].mSetFadeWithWait( 0xff, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
				if( mIcon == 0 )
				{
					//e
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( true );
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0xff, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
					}
				}
			}
			break;
		
		//k>k
		case	eTypoReduce:
			for( i = 0; i < mLength; i++ )
			{
				randTime = HSD_Randi(TYPO_FADE_SPEED) + 1;
				//
				mSprt[i].mSetDispFlag( true );
				mSprt[i].mSetFadeWithWait( 0xff, TYPO_FADE_SPEED, randTime );
				mSprt[i].mSetScaleWithWait( eScaleWH, 1.0f, TYPO_FADE_SPEED, randTime );
				if( mIcon == 0 )
				{
					//e
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( true );
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0xff, TYPO_FADE_SPEED, randTime );
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetScaleWithWait( eScaleWH, 1.0f, TYPO_FADE_SPEED, randTime );
					}
				}
			}
			break;
		
		//W
		default:
			for( i = 0; i < mLength; i++ )
			{
				//
				mSprt[i].mSetDispFlag( true );
				mSprt[i].mSetFade( 0xff, TYPO_FADE_SPEED );
				if( mIcon == 0 )
				{
					//e
					for( j = 0; j < TYPO_SHADOW_NUM; j++ )
					{
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( true );
						mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0xff, TYPO_FADE_SPEED );
					}
				}
			}
			break;
	}
}
//-----------------------------------------------------------------------------
//^C|\
// in --> enTypoSelect eTypoSelect    Iꂽ^C|
//                     eTypoUnselect  IĂȂ^C|
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mUnDisp( enTypoSelect inSelect )
{
	int	i, j, randTime;
	switch( mDispFormat )
	{
		//tF[hCAEg
		case	eTypoFadeInOut:
		//tF[hCAEgEEGCgt
		case	eTypoFadeInOutWithWait:
			for( i = 0; i < mLength; i++ )
			{
				if( inSelect == eTypoSelect )
				{
					//
					//mSprt[i].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
					mSprt[i].mSetFade( 0x00, TYPO_FADE_SPEED );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							//mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, TYPO_FADE_SPEED );
						}
					}
				}else
				{
					//
					mSprt[i].mSetFade( 0x00, TYPO_FADE_SPEED );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, TYPO_FADE_SPEED );
						}
					}
				}
			}
			break;
		
		//k>k
		case	eTypoReduce:
			for( i = 0; i < mLength; i++ )
			{
				if( inSelect == eTypoSelect )
				{
					//xԂ
					//mSprt[i].mSetRGBA( 0xA0000000 | mSprt[i].mGetA() );
					//randTime = HSD_Randi(TYPO_FADE_SPEED) + 1 + TYPO_FADE_SPEED;
					randTime = HSD_Randi(TYPO_FADE_SPEED) + 1;
					//
					mSprt[i].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, randTime );
					mSprt[i].mSetScaleWithWait( eScaleWH, 0.0f, TYPO_FADE_SPEED, randTime );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, randTime );
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetScaleWithWait( eScaleWH, 0.0f, TYPO_FADE_SPEED, randTime );
						}
					}
				}else
				{
					randTime = HSD_Randi(TYPO_FADE_SPEED) + 1;
					//
					mSprt[i].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, randTime );
					mSprt[i].mSetScaleWithWait( eScaleWH, 0.0f, TYPO_FADE_SPEED, randTime );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, randTime );
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetScaleWithWait( eScaleWH, 0.0f, TYPO_FADE_SPEED, randTime );
						}
					}
				}
			}
			break;
		
		//W
		default:
			for( i = 0; i < mLength; i++ )
			{
				if( inSelect == eTypoSelect )
				{
					//
					//mSprt[i].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
					mSprt[i].mSetFade( 0x00, TYPO_FADE_SPEED );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							//mSprtS[i*TYPO_SHADOW_NUM+j].mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, TYPO_FADE_SPEED );
						}
					}
				}else
				{
					//
					mSprt[i].mSetFade( 0x00, TYPO_FADE_SPEED );
					if( mIcon == 0 )
					{
						//e
						for( j = 0; j < TYPO_SHADOW_NUM; j++ )
						{
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetFade( 0x00, TYPO_FADE_SPEED );
						}
					}
				}
			}
			break;
	}
}
//-----------------------------------------------------------------------------
//\tOݒ
// in --> bool false  ^C|\ɂ܂
//             true   ^C|\܂
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typo::mSetDispFlag( bool inFlag )
{
	int	i, j;
	for( i = 0; i < mLength; i++ )
	{
		//
		mSprt[i].mSetDispFlag( inFlag );
		//e
		if( mIcon == 0 )
		{
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				mSprtS[i*TYPO_SHADOW_NUM+j].mSetDispFlag( inFlag );
			}
		}
	}
}
//-----------------------------------------------------------------------------
//^C|̍擾
// in --> none
// out -> s16  ^C|̍
//-----------------------------------------------------------------------------
s16
MK7Typo::mGetHeight( void )
{
	if( mSprt != NULL )
	{
		return( mSprt[0].mGetOrgH() );
	}else
	{
		return( 0 );
	}
}
//-----------------------------------------------------------------------------
//^C|㉺ړ
// in --> none
// out -> none
//-----------------------------------------------------------------------------
#define	TYPO_MOVE_TICK			(4800)			//㉺Ɉړ̂ɂ鎞
#define	TYPO_MOVE_DISTANCE		(4)				//㉺Ɉړő勗
void
MK7Typo::mFrameProcess( void )
{
	int	i, j;
	
	for( i = 0; i < mLength; i++ )
	{
		//㉺Ɉړ
		if( mIcon == 0 )
		{
			//
			if( (mSprt[i].mGetDispFlag() == true)
			 && (mSprt[i].mGetFadeEnd()  == true)
			 && (mSprt[i].mGetScaleEnd() == true) )
			{
				if( mMove[i].nowTick == 0 )
				{
					if( mMove[i].waitTick == 0 )
					{
						mMove[i].nowY     = 0.0f;
						mMove[i].orgY     = 0.0f;
						mMove[i].toY      = (f32)(HSD_Randi(TYPO_MOVE_DISTANCE)-(TYPO_MOVE_DISTANCE/2));
						mMove[i].tick     = TYPO_MOVE_TICK;
						mMove[i].nowTick  = TYPO_MOVE_TICK;
						mMove[i].waitTick = 1;
					}else
					{
						mMove[i].nowY     = mMove[i].nowY;
						mMove[i].orgY     = mMove[i].nowY;
						mMove[i].toY      = 0.0f;
						mMove[i].tick     = TYPO_MOVE_TICK;
						mMove[i].nowTick  = TYPO_MOVE_TICK;
						mMove[i].waitTick = 0;
					}
				}else
				{
					mMove[i].nowY    += ((f32)mMove[i].toY - (f32)mMove[i].orgY) / (f32)WK7_TICK_TO_FRAME((f32)mMove[i].tick);
					mMove[i].nowTick -= WK7_TICK_PER_FRAME;
				}
				mSprt[i].mSetXY0( mSprt[i].mGetX0(), mMove[i].orgX + mMove[i].nowY );
			}
			//e
			for( j = 0; j < TYPO_SHADOW_NUM; j++ )
			{
				if( (mSprtS[i*TYPO_SHADOW_NUM+j].mGetDispFlag() == true)
				 && (mSprtS[i*TYPO_SHADOW_NUM+j].mGetFadeEnd()  == true)
				 && (mSprtS[i*TYPO_SHADOW_NUM+j].mGetScaleEnd() == true) )
				{
					switch( j )
					{
						case	0:
						case	1:
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( mSprtS[i*TYPO_SHADOW_NUM+j].mGetX0(),
																 mMove[i].orgX + mMove[i].nowY );
							break;
						case	2:
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( mSprtS[i*TYPO_SHADOW_NUM+j].mGetX0(),
																 mMove[i].orgX + mMove[i].nowY - 1);
							break;
						case	3:
							mSprtS[i*TYPO_SHADOW_NUM+j].mSetXY0( mSprtS[i*TYPO_SHADOW_NUM+j].mGetX0(),
																 mMove[i].orgX + mMove[i].nowY + 1);
							break;
					}
				}
			}
		}
	}
}
//-----------------------------------------------------------------------------
//W擾
// in --> none
// out -> s16 W
//-----------------------------------------------------------------------------
s16
MK7Typo::mGetX( void )
{
	if( mSprt != NULL )
	{
		return( (s16)mSprt[0].mGetX0() );
	}
	
	return( 0 );
}
s16
MK7Typo::mGetY( void )
{
	if( mMove != NULL )
	{
		return( (s16)mMove[0].orgX );
	}else
	{
		if( mSprt != NULL )
		{
			return( (s16)mSprt[0].mGetY0() );
		}
	}
	
	return( 0 );
}








/****  typos ****/
//-----------------------------------------------------------------------------
//C\
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mLineDisp( void )
{
	switch( mDispType )
	{
		case	eTypoDisp00:
			mLine.mSetDispFlag( true );
			mLine.mSetFade( 0xff, TYPO_FADE_SPEED*2 );
			mLine.mSetVibrate( 2, TYPO_FADE_SPEED*2 );
			break;
		
		//W
		default:
			mLine.mSetDispFlag( true );
			mLine.mSetFade( 0xff, TYPO_FADE_SPEED );
			break;
	}
}
//-----------------------------------------------------------------------------
//C\
// in --> enTypoSelect eTypoSelect    Iꂽ^C|
//                     eTypoUnselect  IĂȂ^C|
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mLineUnDisp( enTypoSelect inSelect )
{
	switch( mDispType )
	{
		case	eTypoDisp00:
			//U~
			mLine.mSetVibrate( 0, 0 );
			//tF[hAEg
			if( inSelect == eTypoSelect )
			{
//				mLine.mSetFadeWithWait( 0x00, TYPO_FADE_SPEED, TYPO_FADE_SPEED*2 );
				mLine.mSetFade( 0x00, TYPO_FADE_SPEED );
			}else
			{
				mLine.mSetFade( 0x00, TYPO_FADE_SPEED );
			}
			break;
		
		//W
		default:
			mLine.mSetFade( 0x00, TYPO_FADE_SPEED );
			break;
	}
}
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Typos::MK7Typos()
{
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7Typos::~MK7Typos()
{
}
//-----------------------------------------------------------------------------
//^C|NGCg
// in --> char* inStringS  ^C|\F
//        char* inStringB  ^C|\F傫
// out -> bool  flase      NGXgs
//              true       NGXg
//-----------------------------------------------------------------------------
bool
MK7Typos::mCreate( char* inStringS, char* inStringB, enTypoDispType inDispType, u32 inIcon )
{
	enTypoDispFormat sKind;
	enTypoDispFormat bKind;
	bool	flagA, flagB;
	
	//̎ނŏƑ傫̌Əݒ肷
	switch( inDispType )
	{
		//00
		case	eTypoDisp00:
			sKind = eTypoFadeInOutWithWait;
			bKind = eTypoReduce;
			break;
		
		//W
		default:
			sKind = eTypoFadeInOut;
			bKind = eTypoFadeInOut;
			break;
	}
	
	//tHgƑ傫tHgNGXg
	if( inIcon != TF_MAX )
	{
		flagA = mTypoS.mCreateIcon( inIcon, eTypoFadeInOutWithWait );
		flagB = mTypoB.mCreateStr( inStringB, eTypoReduce );
	}else
	//ACRƃtHgNGXg
	{
		flagA = mTypoS.mCreateStr( inStringS, sKind );
		flagB = mTypoB.mCreateStr( inStringB, bKind );
	}
	
	//L2NGXgł`FbN
	if( (flagA == true) && (flagB == true) )
	{
		//Əۑ
		mDispType = inDispType;
		//召̃tHgւ̃ItZbg߂
		if( mTypoS.mGetWidth() <= mTypoB.mGetWidth() )
		{
			mOffsetXS = (s16)(mTypoB.mGetWidth() - mTypoS.mGetWidth());
			mOffsetXB = 0;
		}else
		{
			mOffsetXS = 0;
			mOffsetXB = (s16)(mTypoS.mGetWidth() - mTypoB.mGetWidth());
		}
		mOffsetYS = 0;
		mOffsetYB = TYPO_BIG_FONT_OFFSET;
		//C̐ݒ
		mLine.mSetLinePrim();
		//C̑ݒ肷
		mLine.mSetW( TYPO_LINE_WIDTH );
		//RGBA
		mLine.mSetRGBA( 0xffffff00 );
		//\D揇ʐݒ
		mLine.mSetPriority( SPRT_PRI_TYPO );
	}else
	{
		mErase();
		return( false );
	}
	
	return( true );
}
//-----------------------------------------------------------------------------
//^C|
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mErase( void )
{
	mTypoS.mErase();
	mTypoB.mErase();
}
//-----------------------------------------------------------------------------
//\Wݒ
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetXY0( s16 inX, s16 inY )
{
	mTypoS.mSetXY0( (s16)(inX + mOffsetXS), (s16)(inY + mOffsetYS) );
	mTypoB.mSetXY0( (s16)(inX + mOffsetXB), (s16)(inY + mOffsetYB) );
	
	//C̒肷
	if( mTypoS.mGetWidth() <= mTypoB.mGetWidth() )
	{
		if( mTypoB.mGetWidth() > TYPO_LINE_LENGTH )
		{
			mLine.mSetX0( inX );
			mLine.mSetX1( (s16)(inX + mTypoB.mGetWidth()) );
		}else
		{
			mLine.mSetX0( (s16)(inX + mTypoB.mGetWidth() - TYPO_LINE_LENGTH) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + TYPO_LINE_LENGTH) );
		}
	}else
	{
		if( mTypoS.mGetWidth() > TYPO_LINE_LENGTH )
		{
			mLine.mSetX0( inX );
			mLine.mSetX1( (s16)(inX + mTypoS.mGetWidth()) );
		}else
		{
			mLine.mSetX0( (s16)(inX + mTypoS.mGetWidth() - TYPO_LINE_LENGTH) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + TYPO_LINE_LENGTH) );
		}
	}
	mLine.mSetY0( (s16)(inY + TYPO_LINE_YOFFSET) );
	mLine.mSetY1( (s16)(inY + TYPO_LINE_YOFFSET) );
}
//-----------------------------------------------------------------------------
//^C|̒S\Wݒ
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetXYCenter( s16 inX, s16 inY )
{
	//^C|Ƒ傫^C|̍WvZ
	if( mTypoS.mGetWidth() <= mTypoB.mGetWidth() )
	{
		mTypoS.mSetXY0( (s16)(inX + (mTypoB.mGetWidth() / 2) - mTypoS.mGetWidth()), (s16)(inY - TYPO_LINE_YOFFSET) );
		mTypoB.mSetXY0( (s16)(inX - (mTypoB.mGetWidth() / 2)), (s16)(inY - TYPO_LINE_YOFFSET + TYPO_BIG_FONT_OFFSET) );
		//CXW߂
		if( mTypoB.mGetWidth() > TYPO_LINE_LENGTH )
		{
			mLine.mSetX0( (s16)(inX - (mTypoB.mGetWidth() / 2)) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + mTypoB.mGetWidth()) );
		}else
		{
			mLine.mSetX0( (s16)(inX + (mTypoB.mGetWidth() / 2) - TYPO_LINE_LENGTH) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + TYPO_LINE_LENGTH) );
		}
	}else
	{
		mTypoS.mSetXY0( (s16)(inX - (mTypoS.mGetWidth() / 2)), (s16)(inY - TYPO_LINE_YOFFSET) );
		mTypoB.mSetXY0( (s16)(inX + (mTypoS.mGetWidth() / 2) - mTypoB.mGetWidth()), (s16)(inY - TYPO_LINE_YOFFSET + TYPO_BIG_FONT_OFFSET) );
		//CXW߂
		if( mTypoS.mGetWidth() > TYPO_LINE_LENGTH )
		{
			mLine.mSetX0( (s16)(inX - (mTypoS.mGetWidth() / 2)) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + mTypoS.mGetWidth()) );
		}else
		{
			mLine.mSetX0( (s16)(inX + (mTypoS.mGetWidth() / 2) - TYPO_LINE_LENGTH) );
			mLine.mSetX1( (s16)(mLine.mGetX0() + TYPO_LINE_LENGTH) );
		}
	}
	//CYW߂
	mLine.mSetY0( inY );
	mLine.mSetY1( inY );
}
//-----------------------------------------------------------------------------
//RGBAl̐ݒ
// in --> u32 inRgba  RGBAl
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetRGBA( u32 inRgba )
{
//	mTypoS.mSetRGBA( inRgba );
//	mTypoS.mSetRGBA( (0x80ff8000) || (0x000000ff & inRgba) );
//	mTypoS.mSetRGBA( TYPE_ICON_COLOR_DIR || (0x000000ff & inRgba) );
	mTypoB.mSetRGBA( inRgba );
	mLine.mSetRGBA( inRgba );
}
//-----------------------------------------------------------------------------
//RGBAl̎擾
// in --> none
// out -> u32 RGBAl
//-----------------------------------------------------------------------------
u32
MK7Typos::mGetRGBA( void )
{
	return( mTypoS.mGetRGBA() );
}
//-----------------------------------------------------------------------------
//RGBl̐ݒ
// in --> u32 inRgb  RGBl
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetRGB( u32 inRgb )
{
//	mTypoS.mSetRGB( inRgb );
//	mTypoS.mSetRGB( 0x80ff8000 );
//	mTypoS.mSetRGB( TYPE_ICON_COLOR_DIR );
	mTypoB.mSetRGB( inRgb );
	mLine.mSetRGBA( (inRgb & 0xffffff00) | (mLine.mGetA()) );
}
//-----------------------------------------------------------------------------
//tF[h̐ݒ
// in --> u8  inA     ڕWl
//        s32 inTick  tF[hɂ鎞(P:tick)
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetFade( u8 inA, s32 inTick )
{
	mTypoS.mSetFade( inA, inTick );
	mTypoB.mSetFade( inA, inTick );
	mLine.mSetFade( inA, inTick );
}
//-----------------------------------------------------------------------------
//tF[h̏I̊mF
// in --> none
// out -> bool false  ړ
//             true   ړI
//-----------------------------------------------------------------------------
bool
MK7Typos::mGetFadeEnd( void )
{
	if( (mTypoS.mGetFadeEnd() == true)
	 && (mTypoB.mGetFadeEnd() == true) )
		return( true );
	return( false );
}
//-----------------------------------------------------------------------------
//^C|̃NGCgNGXgǂ`FbN
// in --> none
// out -> none
//-----------------------------------------------------------------------------
bool
MK7Typos::mExistCheck( void )
{
	bool	ret;
	
	ret = mTypoS.mExistCheck();
	if( ret )
		return( ret );
	
	ret = mTypoB.mExistCheck();
	
	return( ret );
}
//-----------------------------------------------------------------------------
//^C|\
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mDisp( void )
{
	mTypoS.mDisp();
	mTypoB.mDisp();
	mLineDisp();
}
//-----------------------------------------------------------------------------
//^C|\EWwt
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mDispXY( s16 inX, s16 inY )
{
	mSetXY0( inX, inY );
	mDisp();
}
//-----------------------------------------------------------------------------
//^C|\ESWwt
// in --> s16 inX  \XW
//        s16 inY  \YW
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mDispXYCenter( s16 inX, s16 inY )
{
	mSetXYCenter( inX, inY );
	mDisp();
}
//-----------------------------------------------------------------------------
//^C|\
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mUnDisp( enTypoSelect inSelect )
{
	mTypoS.mUnDisp( inSelect );
	mTypoB.mUnDisp( inSelect );
	mLineUnDisp( inSelect );
}
//-----------------------------------------------------------------------------
//\tOݒ
// in --> bool false  ^C|\ɂ܂
//             true   ^C|\܂
// out -> none
//-----------------------------------------------------------------------------
void
MK7Typos::mSetDispFlag( bool inFlag )
{
	mTypoS.mSetDispFlag( inFlag );
	mTypoB.mSetDispFlag( inFlag );
	mLine.mSetDispFlag( inFlag );
}
//-----------------------------------------------------------------------------
//^C|̕擾
// in --> none
// out -> s16  ^C|Ŝ̕
//-----------------------------------------------------------------------------
s16
MK7Typos::mGetWidth( void )
{
	s16 sW, bW;
	
	sW = mTypoS.mGetWidth();
	bW = mTypoB.mGetWidth();
	
	if( sW >= bW )
	{
		if( sW > TYPO_LINE_LENGTH )
			return( sW );
		else
			return( TYPO_LINE_LENGTH );
	}else
	{
		if( bW > TYPO_LINE_LENGTH )
			return( bW );
		else
			return( TYPO_LINE_LENGTH );
	}
}
//-----------------------------------------------------------------------------
//^C|̍擾
// in --> none
// out -> s16  ^C|Ŝ̍
//-----------------------------------------------------------------------------
s16
MK7Typos::mGetHeight( void )
{
	return( (s16)(mTypoS.mGetHeight() + mTypoB.mGetHeight() + 16) );
}
//-----------------------------------------------------------------------------
//^C|Lƕ̕\t]
// in --> bool inReverse  false  ]Ȃ
//                        true   ]
//        s32  inTick            ]̂ɂ鎞
// out -> none
//-----------------------------------------------------------------------------
#define	TYPO_ICON_OFFSET	(8)
void
MK7Typos::mSetReverse( bool inReverse, s32 inTick )
{
	s16	sx, sy;
	inTick;
	
	if( inReverse == false )
	{
		if( mTypoS.mGetY() > mTypoB.mGetY() )
		{
			sx = mTypoS.mGetX();
			sy = mTypoS.mGetY();
			mTypoS.mSetXY0( (s16)(sx), (s16)(mTypoB.mGetY()) );
			mTypoB.mSetXY0( (s16)(mTypoB.mGetX()), (s16)(sy - TYPO_ICON_OFFSET) );
		}
	}else
	{
		if( mTypoB.mGetY() > mTypoS.mGetY() )
		{
			sx = mTypoS.mGetX();
			sy = mTypoS.mGetY();
			mTypoS.mSetXY0( (s16)(sx), (s16)(mTypoB.mGetY() + TYPO_ICON_OFFSET) );
			mTypoB.mSetXY0( (s16)(mTypoB.mGetX()), (s16)(sy) );
		}
	}
}







/****  typomng ****/
//-----------------------------------------------------------------------------
//RXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7TypoMng::MK7TypoMng()
{
	//
	mFrameProc   = eTypoFontRead;
	mTexStr.tex  = NULL;
	mTexIcon.tex = NULL;
}
//-----------------------------------------------------------------------------
//fXgN^
// in --> none
// out -> none
//-----------------------------------------------------------------------------
MK7TypoMng::~MK7TypoMng()
{
}
//-----------------------------------------------------------------------------
//static
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TypoMng::Init( void )
{
	if( gpTypoMng == NULL ){
		ghmGcMemSetAllocName("MTypoMng");
		gpTypoMng = new MK7TypoMng;
	}
	gpTypoMng->mInit();
}
//-----------------------------------------------------------------------------
//static㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TypoMng::Term( void )
{
	gpTypoMng->mTerm();
	GHM_SAFE_DELETE( gpTypoMng );
}
//-----------------------------------------------------------------------------
//
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TypoMng::mInit( void )
{
	mDat = NULL;
}
//-----------------------------------------------------------------------------
//㏈
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TypoMng::mTerm( void )
{
	//\
	mDispAllStop();
	//f[^(eNX`܂)
	GHMGCMEM_SAFE_FREE( mDat );
	//ACReNX`
	GHMGCMEM_SAFE_FREE( mTexIcon.tex );
}
//-----------------------------------------------------------------------------
//eNX`f[^ǂݍ܂Ă邩擾
// in --> none
// out -> bool false  eNX`ǂݍ܂ĂȂ
//             true   eNX`ǂݍ܂Ă
//-----------------------------------------------------------------------------
bool
MK7TypoMng::mGetTexExist( void )
{
	if( (mTexStr.tex != NULL) && (mTexIcon.tex != NULL) )
		return( true );
	
	return( false );
}
//-----------------------------------------------------------------------------
//t[
// in --> none
// out -> none
//-----------------------------------------------------------------------------
void
MK7TypoMng::mFrameProcess( void )
{
	enFileRead	fileStatus;
	
 	//^C|̑Ď
	switch( mFrameProc )
	{
		//tHgǂݍ
		case	eTypoFontRead:
			//pVXeeNX`ǂݍ
			fileStatus = mFile.mK7FileRead( TYPOFONT_FILE, &((void*)mDat) );
			if( fileStatus == eFileReadSucsess )
			{
				//eNX`AhẌn
				mTexStr.tex = (GhmGcTexHeader*)((char*)mDat + mDat->texOffset);
				//eNX`̏
				mK7InitTexture( &mTexStr );
				//vZXi߂
				mFrameProc = eTypoIconRead;
			}
			break;
		
		//ACRǂݍ
		case	eTypoIconRead:
			//pVXeeNX`ǂݍ
			fileStatus = mFile.mK7FileRead( TYPOICON_FILE, &((void*)mTexIcon.tex) );
			if( fileStatus == eFileReadSucsess )
			{
				//eNX`̏
				mK7InitTexture( &mTexIcon );
				//vZXi߂
				mFrameProc = eTypoFontStandby;
			}
			break;
		
		//X^oC
		case	eTypoFontStandby:
			{
			MK7Typo* typo = gTypoTop;
			while( typo )
			{
				typo->mFrameProcess();
				typo = typo->mNext;
			}
			}
			break;
		
		//ftHg
		default:
			break;
	}
}
//-----------------------------------------------------------------------------
//Ԏ擾
// in --> none
// out -> none
//-----------------------------------------------------------------------------
enTypoFrameProc
MK7TypoMng::mGetStatus( void )
{
	return( mFrameProc );
}
//-----------------------------------------------------------------------------
//SẴ^C|̕\~܂
// in --> none
// out -> false  \~s
//        true   \~
//-----------------------------------------------------------------------------
bool
MK7TypoMng::mDispAllStop( void )
{
	MK7Typo* typo = gTypoTop;
	
	//tHgǂݍ݊֌W̏̂Ƃ͒~ł܂
	if( (mFrameProc == eTypoFontRead)		//tHgǂݍ
	 || (mFrameProc == eTypoIconRead) )	//tHgǂݍݏI
		return( false );
	
	//\&
	while( typo )
	{
		typo->mErase();
		typo = typo->mGetNextTypo();
	}

	return( true );
}
//-----------------------------------------------------------------------------
//^C|p̃eNX`̃|C^擾
// in --> none
// out -> stTexture* eNX`|C^
//-----------------------------------------------------------------------------
stTexture*
MK7TypoMng::mGetTexStrPtr( void )
{
	return( &mTexStr );
}
//-----------------------------------------------------------------------------
//ACRp̃eNX`̃|C^擾
// in --> none
// out -> stTexture* eNX`|C^
//-----------------------------------------------------------------------------
stTexture*
MK7TypoMng::mGetTexIconPtr( void )
{
	return( &mTexIcon );
}
//-----------------------------------------------------------------------------
//tHgp[^̃|C^擾
// in --> none
// out -> stFontParam* tHgp[^|C^
//-----------------------------------------------------------------------------
stFontParam*
MK7TypoMng::mGetFontParamPtr( void )
{
	return( (stFontParam*)((char*)mDat + mDat->charOffset) );
}



