////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Book
//
// SK7PanelBook.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 03/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELBOOK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelBook.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "..\Scn\K7Scn07.h"


#define	PNL007307_BG		"Texture/007307/patch04_bg.BIN"
#define	PNL007307_LAMP		"Texture/007307/patch04_light.BIN"
#define	PNL007307_PLUG0		"Texture/007307/patch04_plug00.BIN"
#define	PNL007307_PLUG1		"Texture/007307/patch04_plug01.BIN"
#define	PNL007307_PLUG2		"Texture/007307/patch04_plug02.BIN"
#define	PNL007307_PLUG3		"Texture/007307/patch04_plug03.BIN"
#define	PNL007307_PLUG4		"Texture/007307/patch04_plug04.BIN"
#define	PNL007307_PLUG5		"Texture/007307/patch04_plug05.BIN"

char* PlugFile[]={PNL007307_PLUG1, PNL007307_PLUG2, PNL007307_PLUG3, PNL007307_PLUG4, PNL007307_PLUG5, };
const f32	tblLampX[]={ 253.0f,344.0f,435.0f,525.0f, };
const f32 	tblLampY[]={ 48.0f,	127.0f,205.0f,285.0f, 364.0f };
const f32 	tblPlagInX[]={268.0f, 359.0f,450.0f,543.0f,};
const f32 	tblPlagInY[]={40.0f, 150.0f,240.0f, 320.0f, 400.0f, };
const f32	tblPlagOutX[]={280.0f, 371.0f,465.0f,557.0f,};
const f32  	tblPlagOutY[]={40.0f, 120.0f, 200.0f, 278.0f, 359.0f };

#define		PLUG_GAPX				(30.0f)
#define		PLUG_GAPY				(30.0f)
#define		PLUGHOLE_MAXW			(4)
#define		PLUGHOLE_MAXH			(5)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelBook::SK7PanelBook( s32 Now ) : SK7PanelBase( Now )
{	
	//	TCg	----------------------------------------------
	if( Now == -1) 	Now = 0;

	for( int i = 0; i < PLUG_NUM; i++ )		memset( &m_LampData[i], NULL, sizeof( TEX_DATA ) );
				
	m_ucSaveAns = m_ucSelectNo = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_PLUG );
	m_bKeyFlag = false;
	m_sNowAnswer 	= (u8)Now;
	m_lDrawTime 	= 0;
	m_iCancelTime 	= 0;
	m_ucTexNo		= 0;

	//	TCg	------------------------------------------------------
	SetCursolPosition( &(Vec){tblPlagInX[m_ucSelectNo%4]+PLUG_GAPX, tblPlagInY[m_ucSelectNo/4]+PLUG_GAPY, 0 } );
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
			
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	Zbg
	m_ucAnswerData[0] = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_4 );
	m_ucAnswerData[1] = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_3 );
	m_ucAnswerData[2] = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_2 );
	m_ucAnswerData[3] = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_1 );
	m_ucAnswerData[4] = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_0 );

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelBook::~SK7PanelBook()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spPlug.Delete();
	m_spLamp.Delete();
	for( int i = 0; i < PLUG_NUM; i++ ){
		GHMGCMEM_SAFE_FREE( m_LampData[i].Header );
	}
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelBook::FrameProcess(void)
{
	bool MoveFlag = false;
	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;		 
		
		//	ĂƂ	-------------------------------
		if( m_bKeyFlag )
		{
			if( CheckKeyT( SK7_KEY_UP ) ){
				if( m_ucSelectNo < PLUGHOLE_MAXW )	break;
				MoveFlag = true;				
				m_ucSelectNo 	-= PLUGHOLE_MAXW;
				SetCursolDir( CURSOL_DIR_UP );
				break;
			}
			if( CheckKeyT( SK7_KEY_DOWN ) ){
				if( m_ucSelectNo >= LAMP_MAX_NUM - PLUGHOLE_MAXW ) break;
				MoveFlag = true;
				m_ucSelectNo 	+= PLUGHOLE_MAXW;
				SetCursolDir( CURSOL_DIR_DOWN );
				break;
			}
			if( CheckKeyT( SK7_KEY_RIGHT ) ){
				if( (m_ucSelectNo%(PLUGHOLE_MAXW)) == PLUGHOLE_MAXW-1 )	break;
				MoveFlag = true;
				m_ucSelectNo++;
				SetCursolDir( CURSOL_DIR_RIGHT );
				break;
			}
			if( CheckKeyT( SK7_KEY_LEFT ) ){
				if( (m_ucSelectNo%PLUGHOLE_MAXW) == 0 )	break;
				MoveFlag = true;
				m_ucSelectNo--;
				SetCursolDir( CURSOL_DIR_LEFT );
				break;
			}
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			if( m_bKeyFlag ){
				if( CheckBookPoint() ){
					m_Proc = PROC_CHECK;
				}else{
					gpSound->mPlaySE(SFX_SYS_SUBSCREEN_BOO);
					break;
				}
			}else{
				gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_GET);
				m_spPlug.SetXY0( tblPlagOutX[m_ucSelectNo%4], tblPlagOutY[m_ucSelectNo/4] );
				m_spPlug.SetTexture( &m_LampData[PLUG_NUM-1],1,1 );
			}
			m_bKeyFlag = (m_bKeyFlag==true) ? false : true;
			break;
		}
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			if( m_bKeyFlag ){
				m_ucSelectNo = m_ucSaveAns;
				m_spPlug.SetXY0( tblPlagInX[m_ucSelectNo%4], tblPlagInY[m_ucSelectNo/4] );
				m_spPlug.SetTexture( &m_LampData[m_ucSelectNo/4], 4, 1 );
				m_spPlug.SetTexNo( (u8)(m_ucSelectNo%4) );
				m_spPlug.SetFlag( true, BLOCK_FLAG );
				SetCursolPosition( &(Vec){tblPlagOutX[m_ucSelectNo%4]+PLUG_GAPX, tblPlagOutY[m_ucSelectNo/4]+PLUG_GAPY, 0 } );
				m_bKeyFlag = false;
				break;
			}
			SetCursolDisp( false );
			m_sNowAnswer = BOOK_CANCEL;
			m_Proc = PROC_CANCEL;			
			break;
		}
		break;
		
	//	`FbNp	----------------------------------------------
	case 	PROC_CHECK:		
		switch( CheckAnswer() )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			m_bKeyFlag = true;
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//
			SetAnswer();
			m_sNowAnswer = BOOK_OK;
			gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_ON);
			m_spPlug.SetXY0( tblPlagInX[m_ucSelectNo%4], tblPlagInY[m_ucSelectNo/4] );
			m_spPlug.SetTexture( &m_LampData[m_ucSelectNo/4], 4, 1 );
			m_spPlug.SetTexNo( (u8)(m_ucSelectNo%4) );
			m_spPlug.SetFlag( true, BLOCK_FLAG );
			m_Proc = PROC_TIME;
			break;
		}
		break;
			
	case 	PROC_TIME:
		if( ++m_iCancelTime > DRAW_KEYTIME ){
			m_Proc = PROC_CANCEL;
		}
		break;


	//	LZ
	case	PROC_CANCEL:
		break;
	}

	s8 bit=0;
	switch( m_ucSelectNo%4 ){
	case 0:		bit |= (CURSOL_DIR_RIGHT);										break;
	case 1:		
	case 2:		bit |= (CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT);						break;
	case 3:		bit |= (CURSOL_DIR_LEFT);										break;
	}
	switch( m_ucSelectNo / 4 ){
	case 0:		bit |=	(CURSOL_DIR_DOWN);					break;
	case 1:		
	case 2:		
	case 3:		bit |= (CURSOL_DIR_DOWN|CURSOL_DIR_UP);		break;	
	case 4:		bit |=	CURSOL_DIR_UP;						break;
 
	}
	//	JMĂ
	SetCursolDir( bit,0 );
			
	if( MoveFlag ){
		if( m_bKeyFlag ){
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			SetCursolPosition( &(Vec){tblPlagOutX[m_ucSelectNo%4]+PLUG_GAPX, tblPlagOutY[m_ucSelectNo/4]+PLUG_GAPY, 0 } );
			m_spPlug.SetXY0( tblPlagOutX[m_ucSelectNo%4], tblPlagOutY[m_ucSelectNo/4] );
		}
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelBook::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}

	//	uhZbg	*******************************************
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	m_spBG.Render();		//	wi
	/*
	for( int i = 0; i < LAMP_LIGHT_NUM; i++ ){
		m_spLamp[i].Render();		//	v	
	}
	*/
	m_spLamp.Render();
	m_spPlug.Render();		//	
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelBook::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelBook::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelBook::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{	
		case	PROC_CANCEL:
			return m_sNowAnswer;
	
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// zuł邩`FbN	
//========================================================================
bool	SK7PanelBook::CheckBookPoint()
{
	int No = (m_ucSelectNo%4);
	switch( m_ucAnswerData[m_ucSelectNo/4] ){
	case 0:	if( No == 0 || No == 3 )	return false;	break;
	case 2: if( No != 3 )	return false;				break;
	case 1: if( No != 0 ) return false;					break;
	}
	return true;
}

//========================================================================
// zuł邩`FbN	
//========================================================================
void	SK7PanelBook::SetAnswer()
{
	u8 Answer=0;
	switch( m_ucAnswerData[m_ucSelectNo/4] ){
	case 0:
		if( (m_ucSelectNo%4) == 1 ){
			Answer = 1;//2;
		}else{
			Answer = 2;//1;
		}
		break;
	case 1:
	case 2:
		
		Answer = 0;
		break;
	}
	switch( m_ucSelectNo/4 ){
	case 0:	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_4 ) = Answer;	break;
	case 1:	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_3 ) = Answer;  break;
	case 2:	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_2 ) = Answer;  break;
	case 3:	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_1 ) = Answer;  break;
	case 4:	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_0 ) = Answer;  break;
	}
	K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_PLUG ) = m_ucSelectNo;

	m_spLamp.SetTexSprite(tblLampX[(m_ucSelectNo%4)], tblLampY[m_ucSelectNo/4], m_spLamp.GetTexture(), 1, LAMP_MAX_NUM, (u8)(m_ucSelectNo) );	
/*
	if( (m_ucSelectNo%4) < 2 ){
		m_spLamp[(m_ucSelectNo/4*2)].SetTexSprite	( tblLampX[(m_ucSelectNo%4)], tblLampY[m_ucSelectNo/4], m_spLamp[0].GetTexture(), 1, LAMP_MAX_NUM, (u8)(m_ucSelectNo) );	
	}else{
		m_spLamp[(m_ucSelectNo/4*2+1)].SetTexSprite	( tblLampX[(m_ucSelectNo%4)], tblLampY[m_ucSelectNo/4], m_spLamp[0].GetTexture(), 1, LAMP_MAX_NUM, (u8)(m_ucSelectNo) );
	}
*/
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelBook::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL007307_BG ) ){
			m_TexProc = LOAD_INPLUG;
		}
		break;
		
	case LOAD_INPLUG:
		if( m_File.OpenTexFile( PlugFile[m_ucTexNo], &m_LampData[m_ucTexNo] ) ){
			InitTexture(&m_LampData[m_ucTexNo]);
			m_ucTexNo++;
			if( m_ucTexNo == PLUG_NUM-1 ){
				m_ucTexNo = 0;
				m_TexProc = LOAD_PLUG;
			}
		}
		break;
		
	case LOAD_PLUG:		
		if( m_File.OpenTexFile( PNL007307_PLUG0, &m_LampData[PLUG_NUM-1] ) ){
			InitTexture(&m_LampData[PLUG_NUM-1]);
			int No = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_PLUG );
			m_spPlug.SetTexSprite( tblPlagInX[No%4], tblPlagInY[No/4], &m_LampData[No/4], 4, 1, (u8)(No%4) );
			m_spPlug.SetVisible( true );
			m_TexProc = LOAD_LAMP;
		}
		break;
		
	case 	LOAD_LAMP:		//	v
		if( m_spLamp.LoadTexture( PNL007307_LAMP, 1, LAMP_MAX_NUM ) ){
			int LampNo = K7EVENT_SCN_VAR( K7SCN07,EVBS_007307_PLUG );
			m_spLamp.SetTexSprite	( tblLampX[(LampNo%4)], tblLampY[(LampNo/4)], m_spLamp.GetTexture(), 1, LAMP_MAX_NUM, (u16)LampNo );			
			m_spLamp.SetVisible		( true );
/*			if( m_ucAnswerData[0] < 2 ){
				m_spLamp.SetTexSprite	( tblLampX[0], tblLampY[0], m_spLamp.GetTexture(), 1, LAMP_MAX_NUM, 0 );			
				m_spLamp.SetVisible		( true );
			}else{
				m_spLamp.SetTexSprite	( tblLampX[1], tblLampY[0], m_spLamp.GetTexture(), 1, LAMP_MAX_NUM, 1 );			
				m_spLamp.SetVisible		( true );
			}	
*/			return true;
		}
		break;
#if 0
		if( m_spLamp[0].LoadTexture( PNL007307_LAMP, 1, LAMP_MAX_NUM ) ){
			u8 LNo=0, RNo=0;
			for( int i = 0; i < LAMP_LIGHT_NUM/2; i++ ){
				switch( m_ucAnswerData[i] ){
				case 0:	LNo = 0, RNo = 3;	break;
				case 1: LNo = 0, RNo = 2;	break;
				case 2: LNo = 1, RNo = 3;	break;
				}
				m_spLamp[i*2].SetTexSprite		( tblLampX[(LNo%4)], tblLampY[i], m_spLamp[0].GetTexture(), 1, LAMP_MAX_NUM, (u8)(LNo+i*4) );
				m_spLamp[i*2+1].SetTexSprite	( tblLampX[(RNo%4)], tblLampY[i], m_spLamp[0].GetTexture(), 1, LAMP_MAX_NUM, (u8)(RNo+i*4) );				
				m_spLamp[i*2].SetVisible( true );
				m_spLamp[i*2+1].SetVisible( true );
			}
			return true;
		}
#endif
	}
	return false;
}

