////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Book
// 
// SK7PanelBook.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 03/25/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELBOOK_H__
#define	__SK7PANELBOOK_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	Ԃl
#define		BOOK_CANCEL				(-1)
#define		BOOK_OK					(1)

//		---------------------------------------------------------------
#define		DRAW_KEYTIME			(30)

#define		PLUG_NUM				(6)
#define		LAMP_LIGHT_NUM			(10)
#define		LAMP_MAX_NUM			(20)

//---- class ----
class SK7PanelBook : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_KEYSET,
		PROC_CHECK,
		PROC_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_INPLUG,
		LOAD_PLUG,
		LOAD_LAMP,
	}eLoadTexProc;
	

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;
	SK7Sprite				m_spPlug;
//	SK7Sprite				m_spLamp[LAMP_LIGHT_NUM];
	SK7Sprite				m_spLamp;
	SK7File					m_File;

	TEX_DATA				m_LampData[PLUG_NUM];
	u8						m_ucSelectNo;			//	ZNgԍ
	u8						m_ucSaveAns;
	Vec						m_vSightPos;			//	|WV
	bool					m_bKeyFlag;				//	Ă邩ǂH
	u32						m_lDrawTime;			//	`掞
	int						m_iCancelTime;
	u8						m_ucAnswerData[PLUG_NUM];
	u8						m_ucTexNo;

public:
	SK7PanelBook( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelBook();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	bool	CheckBookPoint();
	void	SetAnswer();

};

#endif	//__SK7PANELBOOK_H__
