////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Niou
//
// SK7PanelCandle.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCANDLE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelCandle.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"


const VEC2 tblCandlePos[]=
{
	54,68,	170,41,	289,13,	405,41,	522,68,
};
#define		FIRE_TABLE		(36)
#define		FIRE_TIME		(2)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelCandle::SK7PanelCandle( s32 Now ) : SK7PanelBase( Now )
{	
	if( Now == 0 ){
		m_bPlayFlag = false;
	}else{
		m_bPlayFlag = true;
	}
	Vec V;
	V.x = tblCandlePos[0].x+CANDLE_SIZE_X*0.5f;	V.y = tblCandlePos[0].y+CANDLE_SIZE_Y*0.5f; V.z = 0.0f;
	SetCursolPosition( &V );
	
	for( int i = 0; i < CANDLE_NUM; i++ )	m_Candle[i].DrawFlag = false; 
	
	//	ZNg
	m_ucSelectNo 	= 0;
	m_lMoveTime 	= 0;
	m_lSwitchTime 	= 0;
	m_cSaveNo		= 0;
	m_iFireTime		= 0;
	m_bMoveFlag 	= false;
	
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);	

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelCandle::~SK7PanelCandle()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_Candle[0].Candle[0].Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelCandle::FrameProcess(void)
{	
	//	
	if( ++m_iFireTime > FIRE_TIME ){
		MoveFire();
		m_iFireTime = 0;
	}
	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			if( m_bPlayFlag ){
				gpSound->mPlaySE(SFX_SYS_PNL_START);
				m_Proc = PROC_SELECT_MAIN;
			}else{
				m_Proc = PROC_KEYCHECK;
			}
		}
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	XeBbNړ	--------------------------------------
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( m_ucSelectNo == CANDLE_NUM-1 ){
				m_ucSelectNo = 0;
			}else{
				m_ucSelectNo++;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){ tblCandlePos[m_ucSelectNo].x+CANDLE_SIZE_X*0.5f, tblCandlePos[m_ucSelectNo].y+CANDLE_SIZE_Y*0.5f,0.0f} );
			SetCursolDir( CURSOL_DIR_RIGHT,1 );									
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( m_ucSelectNo == 0 ){
				m_ucSelectNo = CANDLE_NUM-1;
			}else{
				m_ucSelectNo--;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){ tblCandlePos[m_ucSelectNo].x+CANDLE_SIZE_X*0.5f, tblCandlePos[m_ucSelectNo].y+CANDLE_SIZE_Y*0.5f,0.0f} );
			SetCursolDir( CURSOL_DIR_LEFT,	1 );									
			break;
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			if( m_Candle[m_ucSelectNo].Candle[0].CheckFlag( RENDER_FLAG ) ) break;
			for( int i = 0; i < CANDLE_SIZE_Y; i++ ){
				m_Candle[m_ucSelectNo].Candle[i].SetVisible( true );
			}
			m_Candle[m_ucSelectNo].No = (u8)m_cSaveNo;
			m_cSaveNo++;
			
			gpSound->mPlaySE(SFX_SCE0_ROUSOKU_TUKU);
			
			//	ׂĂ	---------------------------------------
			if( m_cSaveNo >= CANDLE_NUM ){
				if( m_Candle[0].No == 1 && m_Candle[1].No == 0 && m_Candle[2].No == 3 && m_Candle[3].No == 4 && m_Candle[4].No == 2 ){
//					gpSound->mPlaySE(SFX_SYS_TRUE);
					m_sNowAnswer = 1;
				}else{
					SetCursolDisp( false );
					m_sNowAnswer = 0;
				}
				m_Proc = PROC_SWITCH_TIME;
			}
			break;
		}
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			m_sNowAnswer = -1;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
	
	//	ŏI`FbN	
	case	PROC_SWITCH_TIME:
		if( m_sNowAnswer == 0 ){
			m_Proc = PROC_CANCEL;
		}else{
//			if( !gpSound->mCheckSE( SFX_SYS_TRUE ) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
//			}
		}
		break;
/*		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_spSwitch[m_ucSelectNo].SetVisible( false );
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_Proc = PROC_MESSAGE;
			break;
		}
*/		
		
	case	PROC_KEYCHECK:
		if( DrawMessage( 0 ) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
//		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
//			m_Proc = PROC_CANCEL;
//		}
		break;
					
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_ucSelectNo == 0 )						SetCursolDir( CURSOL_DIR_RIGHT, 0 );						
	else if( m_ucSelectNo == CANDLE_NUM-1 )		SetCursolDir( CURSOL_DIR_LEFT, 	0 );							
	else 										SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT, 0  );	
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelCandle::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < CANDLE_NUM; i++ ){
		for( int j = 0; j < CANDLE_SIZE_Y; j++ ){	
			m_Candle[i].Candle[j].Render();
		}
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelCandle::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelCandle::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelCandle::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_sNowAnswer;
		
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// ̈ړ
//========================================================================
void	SK7PanelCandle::MoveFire()
{
	f32	tbl[FIRE_TABLE] = {
		 0.000f,  0.173f,  0.342f,  0.500f,  0.642f,  0.766f,  0.866f,  0.939f,  0.984f,
		 1.000f,  0.984f,  0.939f,  0.866f,  0.766f,  0.642f,  0.500f,  0.342f,  0.173f,
		 0.000f, -0.173f, -0.342f, -0.500f, -0.642f, -0.766f, -0.866f, -0.939f, -0.984f,
		-1.000f, -0.984f, -0.939f, -0.866f, -0.766f, -0.642f, -0.500f, -0.342f, -0.173f 
	};

	for( int i = 0; i < CANDLE_NUM; i++ ){
		if( !m_Candle[i].Candle[0].CheckFlag( RENDER_FLAG ) )	continue;

		for( int j = 0; j < CANDLE_SIZE_Y; j++ ){	
			m_Candle[i].Candle[j].SetIncX( tbl[m_Candle[i].MoveX] * 1.5f );
			m_Candle[i].MoveX = (m_Candle[i].MoveX + 1) % FIRE_TABLE;
		}
	}
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelCandle::LoadTexData()
{
	char* FileName=NULL;
	switch( m_TexProc )
	{	
	case 	LOAD_BG:	//	wi
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==true ){			
			FileName = PNL007201TEX_BG;
		}else{
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE )==true ){
				FileName = PNL007201TEX_BGEASY;
			}else{
				FileName = PNL007201TEX_BG;
			}
		}
		if( m_spBG.LoadTexture( FileName ) ){
			m_TexProc = LOAD_CANDLE;
		}
		break;
	case  	LOAD_CANDLE:	//	낤
		if( m_Candle[0].Candle[0].LoadTexture( PNL007201TEX_CANDLE, 1, (u8)(CANDLE_SIZE_Y*CANDLE_NUM) )){
			for( int i = 0; i < CANDLE_NUM; i++ ){
				for( int j = 0; j < CANDLE_SIZE_Y; j++ ){
					m_Candle[i].Candle[j].SetTexSpriteTwo	( tblCandlePos[i].x, tblCandlePos[i].y+j, tblCandlePos[i].x+CANDLE_SIZE_X, tblCandlePos[i].y+j+1, m_Candle[0].Candle[0].GetTexture(), 1, CANDLE_SIZE_Y*CANDLE_NUM, (u16)(i*CANDLE_SIZE_Y+j) );
//					m_Candle[i].Candle[j].SetFlag			( true, RENDER_FLAG );
				}
				m_Candle[i].MoveX = 0;
			}
			return true;
		}
		break;
	}
	return false;
}


