////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Niou
//
// SK7PanelCandle.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCANDLE_H__
#define	__SK7PANELCANDLE_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



#define		CANDLE_NUM			(5)
#define		CANDLE_SIZE_X	(64)
#define		CANDLE_SIZE_Y	(96)


//	eNX`[pX
#define	PNL007201TEX_BG			"Texture/007201/candle007201_bg.BIN"
#define	PNL007201TEX_BGEASY		"Texture/007201/candle007201_bg01.BIN"
#define	PNL007201TEX_CANDLE		"Texture/007201/candle007201_fire.BIN"

typedef struct{
	SK7Sprite		Candle[CANDLE_SIZE_Y];
	bool			DrawFlag;
	u8				No;
	int				MoveX;
}CANDLE_DATA;

//---- class ----
class SK7PanelCandle : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_MESSAGE,
		PROC_KEYCHECK,
		PROC_SWITCH_TIME,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_CANDLE,
	}eLoadTexProc;
	


protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	CANDLE_DATA				m_Candle[CANDLE_NUM];
	
	u8						m_ucSelectNo;			//	ZNg
	u32						m_lMoveTime;		
	Vec						m_vSightPos;	
	u32						m_lSwitchTime;
	bool					m_bMoveFlag;
	s8						m_cSaveNo;
	bool					m_bPlayFlag;
	int						m_iFireTime;

public:
	SK7PanelCandle( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelCandle();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();

	void	MoveCandle( SK7Sprite* );
	
	void	MoveFire();
};

#endif	//__SK7PANELCANDLE_H__
