////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelColor.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCOLOR_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../Scn/K7Scn04.h"
#include "SK7PanelColor.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"
#include "../sato/SK7IMenuColor.h"

#define	BAR_LX					(335.0f)
#define BAR_RX					(500.0f)
#define	ANSWER_X				(111)
#define	ANSWER_Y				(280)
#define	ANSWER_SIZE				(55)
#define	OK_X					(89)
#define	OK_Y					(142)
#define	CHARA_HALF_SIZEX		(40)
#define	CHARA_HALF_SIZEY		(30)
#define	KEY_PUSH_TIME			(5)
#define	KEY_BAR_TIME			(0)
#define	BAR_PLUS_X				(6)
#define	BAR_PLUS_Y				(20)
#define	COLOR_NO_GAP			(3)
#define	NO_Y					(290)
#define	NO_PLUS_Y				(35)
#define	OK_CURSOL_X				(122)
#define	OK_CURSOL_Y				(174)

#define	COLOR_PNL_DATA				"Texture/panel/040405.pak"

const f32 tblBarY[]={ 278.0f,318.0f,358.0f };

const VEC2 tblCharaPos[]={
	141,51,
	213,51,
	286,51,
	360,51,
	432,51,
	177,131,
	250,130,
	323,130,
	395,130,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelColor::SK7PanelColor( s32 Now ) : SK7PanelBase( Now, 0, false )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= COLOR_MISS;
		
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_bSEFlag		= false;
	m_iTime 		= 0;
	m_chSelect 		= 0;
	m_chBarSelect	= 0;
	m_chSaveSelect	= 0;
	m_iStopNum		= 0;
	memset( m_AnsColor, 0, sizeof(PANEL_COLOR_ANS)*SELECT_HANDSOME_NUM );
	m_spAnswer.SetSprite	( ANSWER_X, ANSWER_Y, ANSWER_SIZE, ANSWER_SIZE, 0x000000ff );
	m_spAnswer.SetVisible	( true );
	
	SetMessageVisible( false );
	SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );

	CheckColor();
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelColor::~SK7PanelColor()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelColor::FrameProcess(void)
{	
	int i;
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		s8 StopFlagNum=0;
		if( !m_bSEFlag ){
			gpSound->mPlaySE( SFX_SCE4_COLOR_PANEL_SLIDER );
			m_bSEFlag = true;
		}
		for( i = 0; i < COLOR_BAR_NUM; i++ ){
			if( i == 0 && tblAnswer[m_chSelect].r == 0 ){
				StopFlagNum++;
				continue;
			}
			if( i == 1 && tblAnswer[m_chSelect].g == 0 ){
				StopFlagNum++;
				continue;
			}
			if( i == 2 && tblAnswer[m_chSelect].b == 0 ){
				StopFlagNum++;
				continue;
			}
			m_AnsColor[m_chSelect].Color[i]+=3;
			if( m_chSelect == SELECT_HANDSOME_NUM-1 ){
				if( m_AnsColor[m_chSelect].Color[i] >= 255 ){
					m_AnsColor[m_chSelect].Color[i] = 255;
					StopFlagNum++;
				}
			}else{
				if( m_AnsColor[m_chSelect].Color[i] >= K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[m_chSelect*3+i] ){
					m_AnsColor[m_chSelect].Color[i] = K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[m_chSelect*3+i];
					StopFlagNum++;
					if( m_iStopNum < StopFlagNum ){
						gpSound->mPlaySE( SFX_SCE4_ITEMGAMEN_PARTS_UKU );
						m_iStopNum = StopFlagNum; 
					}
				}
			}
			m_spBar[i].SetX0( BAR_LX+( BAR_RX-BAR_LX )/255.0f*m_AnsColor[m_chSelect].Color[i] );
		}
		m_spAnswer.SetColor( (u8)m_AnsColor[m_chSelect].Color[0], (u8)m_AnsColor[m_chSelect].Color[1], (u8)m_AnsColor[m_chSelect].Color[2], 0xff );
		//	AT[`FbN	-------------------------------------
		if( StopFlagNum == COLOR_BAR_NUM ){
			if( m_AnsColor[m_chSelect].Color[0] == tblAnswer[m_chSelect].r &&
				m_AnsColor[m_chSelect].Color[1] == tblAnswer[m_chSelect].g &&
				m_AnsColor[m_chSelect].Color[2] == tblAnswer[m_chSelect].b )
			{
				m_iStopNum = 0;
				
				//	NA
				if( m_chSelect == SELECT_HANDSOME_NUM-1 ){
					gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
					m_spKasan2[m_chSelect].SetVisible( true );
					m_sNowAnswer = COLOR_CLEAR;
					gpSound->mStopSE( SFX_SCE4_COLOR_PANEL_SLIDER );
					m_bSEFlag = false;
					m_Proc = PROC_TIME;
				}else{
					m_bSEFlag = false;
					gpSound->mStopSE( SFX_SCE4_COLOR_PANEL_SLIDER );
					m_Proc = PROC_TIME2;
					break;
				}
			}else{		//	͂
				gpSound->mPlaySE( SFX_SYS_PNL_MISS );
				m_bSEFlag = false;
				gpSound->mStopSE( SFX_SCE4_COLOR_PANEL_SLIDER );
				m_sNowAnswer = COLOR_MISS;
				m_Proc = PROC_TIME;
				break;
			}
		}
		break;
		
	//	ړ	=====================================================
	case PROC_MOVE:
		break;
#if 0				
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			if( m_chSelect == SELECT_HANDSOME_NUM-1 ){
				m_chSaveSelect = m_chSelect;
				m_chSelect = SELECT_HANDSOME_NUM;
				SetMessageVisible( true );
				SetCursolPosition( &(Vec){ OK_CURSOL_X, OK_CURSOL_Y, 0.0f} );							
				break;
			}
			SetMessageVisible( false );
			if( m_chSelect == SELECT_HANDSOME_NUM ){
				m_chSelect = 0;
			}else{
				m_chSelect++;
			}
			if( m_chSelect > SELECT_HANDSOME_NUM-1 ){
				m_chSelect = 0;
			}
			SetBarPosition();
			SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			if( m_chSelect == SELECT_HANDSOME_NUM )	break;
			if( m_chSelect == 0 || m_chSelect == 5 ){
				m_chSaveSelect = m_chSelect;
				SetMessageVisible( true );
				m_chSelect = SELECT_HANDSOME_NUM;
				SetCursolPosition( &(Vec){ OK_CURSOL_X, OK_CURSOL_Y, 0.0f} );			
				break;
			}
			SetMessageVisible( false );
			m_chSelect--;
			if( m_chSelect < 0 ){
				m_chSelect = SELECT_HANDSOME_NUM-1;
			}
			SetBarPosition();
			SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );			
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( m_chSelect == SELECT_HANDSOME_NUM )	break;
			if( m_chSelect < 4 )					break;
			if( m_chSelect == 5 ) 	m_chSelect = 0;
			if( m_chSelect == 6 )	m_chSelect = 2;
			m_iKeyTime = 0;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetBarPosition();
			SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( m_chSelect > 4 )	break;
			if( m_chSelect < 2 )	m_chSelect = 5;
			else					m_chSelect = 6;
			m_iKeyTime = 0;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetBarPosition();
			SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );
			break;
		}
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			if( m_chSelect == SELECT_HANDSOME_NUM ){
				m_Proc = PROC_CHECK;
				break;
			}
			m_chBarSelect = 0;
			m_spKasan.SetXY0	( tblCharaPos[m_chSelect].x, tblCharaPos[m_chSelect].y );
			m_spKasan.SetVisible( true );
			SetCursolPosition( &(Vec){ m_spBar[m_chBarSelect].GetX0()+BAR_PLUS_X, m_spBar[m_chBarSelect].GetY0()+BAR_PLUS_Y, 0.0f } );
			m_Proc = PROC_COLOR_SET;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = COLOR_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
#endif
		
	//	J[Zbg	=============================================
	case	PROC_COLOR_SET:
#if 0
		m_iKeyTime++;
		if( (CheckKeyN( SK7_KEY_RIGHT ) && m_iKeyTime > KEY_BAR_TIME)  || 
			(CheckKeyR( SK7_KEY_RIGHT ) )){
			m_AnsColor[m_chSelect].Color[m_chBarSelect]++;
			if( m_AnsColor[m_chSelect].Color[m_chBarSelect] > 255 )	m_AnsColor[m_chSelect].Color[m_chBarSelect] = 255;
			if( m_AnsColor[m_chSelect].Color[m_chBarSelect] < 0 )	m_AnsColor[m_chSelect].Color[m_chBarSelect] = 0;
			m_spBar[m_chBarSelect].SetX0( BAR_LX+( BAR_RX-BAR_LX )/255.0f*m_AnsColor[m_chSelect].Color[m_chBarSelect] );
			SetCursolPosition( &(Vec){ m_spBar[m_chBarSelect].GetX0()+BAR_PLUS_X, m_spBar[m_chBarSelect].GetY0()+BAR_PLUS_Y, 0.0f } );
			m_spAnswer.SetColor( (u8)m_AnsColor[m_chSelect].Color[0], (u8)m_AnsColor[m_chSelect].Color[1], (u8)m_AnsColor[m_chSelect].Color[2], 0xff );
			m_iKeyTime = 0;
			break;
		}
		if( (CheckKeyN( SK7_KEY_LEFT ) && m_iKeyTime > KEY_BAR_TIME) ||
			(CheckKeyR( SK7_KEY_LEFT ))){
			m_AnsColor[m_chSelect].Color[m_chBarSelect]--;
			if( m_AnsColor[m_chSelect].Color[m_chBarSelect] > 255 )	m_AnsColor[m_chSelect].Color[m_chBarSelect] = 255;
			if( m_AnsColor[m_chSelect].Color[m_chBarSelect] < 0 )	m_AnsColor[m_chSelect].Color[m_chBarSelect] = 0;
			m_spBar[m_chBarSelect].SetX0( BAR_LX+( BAR_RX-BAR_LX )/255.0f*m_AnsColor[m_chSelect].Color[m_chBarSelect] );
			SetCursolPosition( &(Vec){ m_spBar[m_chBarSelect].GetX0()+BAR_PLUS_X, m_spBar[m_chBarSelect].GetY0()+BAR_PLUS_Y, 0.0f } );
			m_spAnswer.SetColor( (u8)m_AnsColor[m_chSelect].Color[0], (u8)m_AnsColor[m_chSelect].Color[1], (u8)m_AnsColor[m_chSelect].Color[2], 0xff );
			m_iKeyTime = 0;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_chBarSelect < 0 )	m_chBarSelect = 2;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetCursolPosition( &(Vec){ m_spBar[m_chBarSelect].GetX0()+BAR_PLUS_X, m_spBar[m_chBarSelect].GetY0()+BAR_PLUS_Y, 0.0f } );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( ++m_chBarSelect > 2 )	m_chBarSelect = 0;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			SetCursolPosition( &(Vec){ m_spBar[m_chBarSelect].GetX0()+BAR_PLUS_X, m_spBar[m_chBarSelect].GetY0()+BAR_PLUS_Y, 0.0f } );
			break;
		}		
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_spKasan.SetVisible( false );
			SetCursolPosition( &(Vec){ tblCharaPos[m_chSelect].x+CHARA_HALF_SIZEX, tblCharaPos[m_chSelect].y+CHARA_HALF_SIZEY, 0.0f} );
			m_Proc = PROC_SELECT_MAIN;
			break;
		}
#endif
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
#if 0
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_spOk.SetVisible( false );
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_spOk.SetVisible( true );
			bool flag = true;
			for( int i = 0; i < SELECT_HANDSOME_NUM; i++ ){
				for( int j = 0; j < COLOR_BAR_NUM; j++ ){
					if( m_AnsColor[i].Color[j] != tblAnswerColor[i].Color[j] ){
						flag = false;
						break;
					}
				}
				if( !flag ) break;
			}
			if( !flag ){
				gpSound->mPlaySE( SFX_SYS_PNL_MISS );
				m_sNowAnswer = COLOR_MISS;
			}else{
				gpSound->mPlaySE( SFX_SYS_EV_CLEAR );
				m_sNowAnswer = COLOR_CLEAR;
			}
			m_Proc = PROC_TIME;
			break;
		}
#endif
		break;
		
	case PROC_TIME2:
		if( ++m_iTime > 20 ){
			m_spKasan2[m_chSelect].SetVisible( true );
			m_chSelect++;
			m_spKasan.SetXY0	( tblCharaPos[m_chSelect].x, tblCharaPos[m_chSelect].y );
			for( i = 0; i < COLOR_BAR_NUM; i++ ){
				m_spBar[i].SetXY0	( BAR_LX, tblBarY[i] );
			}
			m_iTime = 0;
			gpSound->mPlaySE( SFX_SCE4_COLPANEL_LIGHT );
			gpSound->mStopSE( SFX_SCE4_COLOR_PANEL_SLIDER );
			m_bSEFlag = false;
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelColor::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

	m_spBG.Render();					//	wi

	m_spAnswer.Render();
	m_spShadow.Render();
	m_spKasan.Render();

	m_spOk.Render();
	for( int i = 0; i < COLOR_BAR_NUM; i++ ){
		m_spBar[i].Render();
	}
	for( int i = 0; i < SELECT_HANDSOME_NUM; i++ ){
		m_spKasan2[i].Render();
	}
	
	m_pYFont->DrawSetup();
	
	f32 size;
	int SelectNo;
	if( m_chSelect != SELECT_HANDSOME_NUM )	SelectNo = m_chSelect;
	else									SelectNo = m_chSaveSelect;
	
	for( int i = 0; i < COLOR_BAR_NUM; i++ ){
		size = m_pYFont->DrawFSStr	( 0.0f, 		0.0f, 		false, false, 	"%d", m_AnsColor[SelectNo].Color[i] );
		m_pYFont->SetColor2			( 0x1e3c1eff );
		m_pYFont->DrawFSStr			( 270-size, NO_Y+NO_PLUS_Y*i, 	false, true,	"%d", m_AnsColor[SelectNo].Color[i] );
		m_pYFont->SetColor2			( 0x3c5a3c7f );
		m_pYFont->DrawFSStr			( 270-size+COLOR_NO_GAP, NO_Y+NO_PLUS_Y*i+COLOR_NO_GAP, false, true, "%d", m_AnsColor[SelectNo].Color[i] );
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelColor::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelColor::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelColor::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// o[̂ۂݒ
//========================================================================
void		SK7PanelColor::SetBarPosition(void)
{
	for( int i = 0; i < COLOR_BAR_NUM; i++ ){
		m_spBar[i].SetX0( BAR_LX+( BAR_RX-BAR_LX )/255.0f*m_AnsColor[m_chSelect].Color[i] );
	}
	m_spAnswer.SetColor( (u8)m_AnsColor[m_chSelect].Color[0], (u8)m_AnsColor[m_chSelect].Color[1], (u8)m_AnsColor[m_chSelect].Color[2], 0xff );
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelColor::LoadTexData()
{
	if( LoadPackData( COLOR_PNL_DATA, TEX_040405_MAX, PANEL_FONT_YAMADA )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_040405_BACKGROUND] );
		m_spBG.SetVisible	( true );
		
		m_spKasan.SetTexSprite	( tblCharaPos[0].x, tblCharaPos[0].y, &m_pTexture[TEX_040405_BOTTAN_KASAN] );
		m_spKasan.SetBlendNo	( SPR_BLEND_ONE );
		m_spKasan.SetVisible	( true );
		
		m_spShadow.SetTexSprite	( ANSWER_X, ANSWER_Y, &m_pTexture[TEX_040405_COLOR_SHADOW] );
		m_spShadow.SetColor		( 0x0000007f );
		m_spShadow.SetVisible	( true );
		
		for( int i = 0; i < COLOR_BAR_NUM; i++ ){
			m_spBar[i].SetTexSprite	( BAR_LX, tblBarY[i], &m_pTexture[TEX_040405_BAR] );
			m_spBar[i].SetVisible	( true );
		}
		for( int i = 0; i < SELECT_HANDSOME_NUM; i++ ){
			m_spKasan2[i].SetTexSprite	( tblCharaPos[i].x, tblCharaPos[i].y, &m_pTexture[TEX_040405_BOTTAN_KASAN2] );
			m_spKasan2[i].SetBlendNo	( SPR_BLEND_ONE );
			m_spKasan2[i].SetVisible	( false );
		}
		
		m_spOk.SetTexSprite( OK_X, OK_Y, &m_pTexture[TEX_040405_OK_KASAN] );
		m_spOk.SetBlendNo	( SPR_BLEND_ONE );
		m_spOk.SetVisible	( false );
		
		return true;
	}
	return false;
}	
	
//========================================================================
//					쐬F`FbN	
//========================================================================
void		SK7PanelColor::CheckColor()
{
	u8 Rparam,Gparam, Bparam;
	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[0].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+6 ) )	Gparam = tblChipState[6].Color0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+2 ) )	Bparam = tblChipState[2].Color0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[0] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[1] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[2] = Bparam;
	
	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+1 ))	Rparam = tblChipState[1].Color0;
	Gparam = tblChipSetState[1].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+5 ) )	Bparam = tblChipState[5].Color0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[3] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[4] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[5] = Bparam;

	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[2].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+4 ) )	Gparam = tblChipState[4].Color0;
	Bparam = tblChipSetState[3].No0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[6] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[7] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[8] = Bparam;

	Rparam = Gparam = Bparam = 0;
	Rparam = tblChipSetState[4].No0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01 ) ){
		Gparam = tblChipState[0].Color0;
		Bparam = tblChipState[0].Color1;
	}
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[9] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[10] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[11] = Bparam;

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+3 ) )	Rparam = tblChipState[3].Color0;
	Gparam = tblChipSetState[5].No0;
	Bparam = tblChipSetState[5].No1;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[12] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[13] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[14] = Bparam;

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+8 ) ){
		Rparam = tblChipState[8].Color0;
		Gparam = tblChipState[8].Color1;
	}
	Bparam = tblChipSetState[6].No0;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[15] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[16] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[17] = Bparam;

	Rparam = Gparam = Bparam = 0;
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN04_EVFL_COLORCHIP_01+7 ) ){
		Rparam = tblChipState[7].Color0;
		Gparam = tblChipState[7].Color0;
		Bparam = tblChipState[7].Color0;
	}
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[18] = Rparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[19] = Gparam;
	K7EVENT_SCN_VAR(K7SCN04,EVVA_COLORCHIP_COLOR)[20] = Bparam;
}
