////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Poster
//
// SK7PanelComming.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/15/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELCOMMING_H__
#define	__SK7PANELCOMMING_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


#define		COMING_FONT_NUM		(50)
//---- class ----
class SK7PanelComming : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_TIME,
		PROC_MOVE_FONT1,
		PROC_SELECT_MAIN,
		PROC_CLOSE_TIME,
		PROC_CLOSE,
		PROC_FADE_FONT,
		PROC_FADE_BG,
		PROC_KILLER_TIME,
		PROC_FADE_MAIN,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG=0,
		LOAD_FONT,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spFade;
	SK7File					m_File;
	
	VEC2					m_vFontPos[COMING_FONT_NUM];
	f32						m_fUnderY[COMING_FONT_NUM];
	u32						m_lFontColor[COMING_FONT_NUM];
	int						m_iScrollTime;
	bool					m_bMoveStopFlag;
	bool					m_bFontDrawFlag;
	int						m_iSelectNo;
	int						m_iMoveNum;
	int						m_iMoveNum2;	
	int						m_iFontNo;
	int						m_iGyoNo;
	int						m_iGyoNo2;	
	int						m_iTime;
	f32						m_fFontDiff[COMING_FONT_NUM];
	f32						m_fFontDiffSpeed[COMING_FONT_NUM];

	
	//	gp	-----------------------------------------------
	stSentence*			m_Data;
	stOneSentence*		m_SentenceDat;
	stFontParam*		m_FParam;				//uvwhl̓Ăe[uւ̃|C^
	TEX_DATA			m_Tex;


public:
	SK7PanelComming( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelComming();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
	//	tHgf[^ǂ݂
	bool 	SetFontProcess( char* FileName );
	
	//	_Zbg
	void	SetFontVertex();
	
	//	tHg`
	void	RenderFont();
	
	//	tHgړ
	bool	MoveFont();
	bool	MoveFontOne();
	bool	CloseFont();
	void	SetMoveFont();

};

#endif	//__SK7PANELCOMMING_H__
