////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cook
//
// SK7PanelCook.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCOOK_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelCook.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"


const VEC2	tblUtuwaPos[]=
{
	28.0f, 0.0f,
	28.0f, 158.0f,
	28.0f, 319.0f,
	319.0f,0.0f,
	319.0f,158.0f,
	319.0f,319.0f,
};	
	
//========================================================================
//					RXgN^
//========================================================================
SK7PanelCook::SK7PanelCook( s32 Now ) : SK7PanelBase( Now )
{
	m_vSightPos.x = tblUtuwaPos[0].x+UTUWA_SIGHT_X;
	m_vSightPos.y = tblUtuwaPos[0].y+UTUWA_SIGHT_Y;
	m_vSightPos.z = 0.0f;
	
	//	TCg	----------------------------------------------
	SetCursolPosition( &m_vSightPos );
		
	//vZX	----------------------------------------------
	m_Proc 			= PROC_LOAD;
	m_TexProc 		= LOAD_BG;
	m_ucSelectNo 	= 0;
	m_sNowAnswer		= (s8)Now;
	m_lRenderTime	= 0;
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	for( int i = 0; i < UTUWA_NUM; i++ )
	{
		m_spUtuwa[i].SetXY0(tblUtuwaPos[i].x,tblUtuwaPos[i].y);
		m_spUtuwa[i].SetVisible(true);
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelCook::~SK7PanelCook()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	for( int i = 0; i < UTUWA_NUM; i++ )
	{
		m_spUtuwa[i].Delete();
	}	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelCook::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );	
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	XeBbNړ	--------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
		{
			if( m_ucSelectNo == 0 || m_ucSelectNo == 3 )		break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo--;
			m_vSightPos.x = tblUtuwaPos[m_ucSelectNo].x+UTUWA_SIGHT_X;
			m_vSightPos.y = tblUtuwaPos[m_ucSelectNo].y+UTUWA_SIGHT_Y;
			SetCursolPosition( &m_vSightPos );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
		{
			if( m_ucSelectNo == 2 || m_ucSelectNo == 5 )		break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo++;
			m_vSightPos.x = tblUtuwaPos[m_ucSelectNo].x+UTUWA_SIGHT_X;
			m_vSightPos.y = tblUtuwaPos[m_ucSelectNo].y+UTUWA_SIGHT_Y;
			SetCursolPosition( &m_vSightPos );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT )
		{
			if( m_ucSelectNo >= 3 )		break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo += 3;
			m_vSightPos.x = tblUtuwaPos[m_ucSelectNo].x+UTUWA_SIGHT_X;
			m_vSightPos.y = tblUtuwaPos[m_ucSelectNo].y+UTUWA_SIGHT_Y;
			SetCursolPosition( &m_vSightPos );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT )
		{
			if( m_ucSelectNo <= 2 )		break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo -= 3;
			m_vSightPos.x = tblUtuwaPos[m_ucSelectNo].x+UTUWA_SIGHT_X;
			m_vSightPos.y = tblUtuwaPos[m_ucSelectNo].y+UTUWA_SIGHT_Y;
			SetCursolPosition( &m_vSightPos );
			break;
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ) 
		{
			m_Proc = PROC_NOTRENDER;
			break;
		}
#if 0
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			SetCursolDisp( false );	
			m_Proc = PROC_CANCEL;
			break;
		}
#endif
		break;
		
	case	PROC_NOTRENDER:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			switch( m_ucSelectNo )
			{
			case 0:	gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI0);	break;
			case 1:	gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI1); break;
			case 2:	gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI2); break;
			case 3:	gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI3); break;
			case 4:	gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI4); break;
			case 5: gpSound->mPlaySE(SFX_SCE1_PNL_RYOURI5); break;
			}
			m_spUtuwa[m_ucSelectNo].SetVisible(false);
			m_sNowAnswer = (s8)m_ucSelectNo;
			m_lRenderTime = 0;
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case 	PROC_TIME:
		if( ++m_lRenderTime > RENDER_TIME )
		{
			m_lRenderTime = 0;
			m_Proc = PROC_MESSAGE;
		}
		break;
		
	case	PROC_MESSAGE:
		switch( m_ucSelectNo ){
		case 0:		if( DrawMessage( 0 ) )	m_Proc = PROC_CANCEL;	break;
		case 1:		if( DrawMessage( 2 ) )	m_Proc = PROC_CANCEL;	break;
		case 2:		if( DrawMessage( 4 ) )	m_Proc = PROC_CANCEL;	break;
		case 3:		if( DrawMessage( 1 ) )	m_Proc = PROC_CANCEL;	break;
		case 4:		if( DrawMessage( 3 ) )	m_Proc = PROC_CANCEL;	break;
		case 5:		if( DrawMessage( 5 ) )	m_Proc = PROC_CANCEL;	break;
		}
		break;
	
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	switch( m_ucSelectNo ){
	case 0:		SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN );				break;
	case 1:		SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP );	break;
	case 2:		SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_UP );					break;
	case 3:		SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_DOWN );				break;
	case 4:		SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP );	break;
	case 5:		SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_UP );					break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelCook::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < UTUWA_NUM; i++ )
	{
		m_spUtuwa[i].Render();
	}
		 
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelCook::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelCook::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelCook::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_sNowAnswer;
				
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelCook::LoadTexData()
{
	switch( m_TexProc )
	{		
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL000107TEX_BG ) )
		{
			m_TexProc = LOAD_U1;
		}
		break;
	case 	LOAD_U1:	
		if( m_spUtuwa[0].LoadTexture( PNL000107TEX_U1 ) )
		{
			m_TexProc = LOAD_U2;
		}
		break;
	case 	LOAD_U2:	
		if( m_spUtuwa[1].LoadTexture( PNL000107TEX_U2 ) )
		{
			m_TexProc = LOAD_U3;
		}
		break;
	case 	LOAD_U3:	
		if( m_spUtuwa[2].LoadTexture( PNL000107TEX_U3 ) )
		{
			m_TexProc = LOAD_U4;
		}
		break;
	case 	LOAD_U4:	
		if( m_spUtuwa[3].LoadTexture( PNL000107TEX_U4 ) )
		{
			m_TexProc = LOAD_U5;
		}
		break;
	case 	LOAD_U5:	
		if( m_spUtuwa[4].LoadTexture( PNL000107TEX_U5 ) )
		{
			m_TexProc = LOAD_U6;
		}
		break;
	case 	LOAD_U6:	
		if( m_spUtuwa[5].LoadTexture( PNL000107TEX_U6 ) )
		{
			return true;
		}
		break;
	}
	return false;
}

