////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Curtain
//
// SK7PanelCurtain.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELCURTAIN_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelCurtain.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


//========================================================================
//					RXgN^
//========================================================================
SK7PanelCurtain::SK7PanelCurtain( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
	m_chSelect	= (s8)0;

	SetCursolPosition( &(Vec){0,0,0} );
	SetCursolDir( CURSOL_DIR_RIGHT );
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelCurtain::~SK7PanelCurtain()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelCurtain::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_Proc = PROC_MESSAGE;
			break;
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
/*	
	if( m_chSelect == 0 )							SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN );
	else if( m_chSelect == ROULETTE_ANSWER_NUM-1) 	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_UP );
	else											SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN );
*/	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelCurtain::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelCurtain::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelCurtain::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelCurtain::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelCurtain::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL055002TEX_BG ) ){
			return true;
		}
		break;
	}
	return false;
}