////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelEleChange.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELELECHANGE_CPP__


#include "SK7PanelEleChange.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define	ELECHANGE_PACK_DATA			"/Texture/panel/011202.pak"

#define	ELE_CURSOL_X		(483)
const f32 tblCursolY[]={ 184, 293 };

//========================================================================
//					RXgN^
//========================================================================
SK7PanelEleChange::SK7PanelEleChange( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
	m_chSelect		= (s8)Now;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	m_iTime = 0;
		
	SetCursolPosition( &(Vec){ELE_CURSOL_X, tblCursolY[m_chSelect], 0.0f} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelEleChange::~SK7PanelEleChange()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelEleChange::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( m_chSelect == 0 )	break;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			m_chSelect = 0;
			SetCursolPosition( &(Vec){ELE_CURSOL_X, tblCursolY[m_chSelect], 0.0f} );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( m_chSelect == 1 )	break;
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			m_chSelect = 1;
			SetCursolPosition( &(Vec){ELE_CURSOL_X, tblCursolY[m_chSelect], 0.0f} );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = ELECHANGE_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_PNL_SWITCHDENSHI );
			gpSound->mPlaySE( SFX_SYS_PNL_OK );
			m_sNowAnswer = m_chSelect;
			if( m_sNowAnswer == 0 ){
				m_spSwitch[0].SetVisible( true );
				m_spSwitch[1].SetVisible( false );
				m_spLamp[0].SetVisible( true );
				m_spLamp[1].SetVisible( true );
				m_spLamp[2].SetVisible( false );
				m_spLamp[3].SetVisible( false );
			}else{
				m_spSwitch[1].SetVisible( true );
				m_spSwitch[0].SetVisible( false );
				m_spLamp[0].SetVisible( false );
				m_spLamp[1].SetVisible( false );
				m_spLamp[2].SetVisible( true );
				m_spLamp[3].SetVisible( true );
			}
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTime > 20 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelEleChange::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	int i;
	for( i = 0; i < 2; i++ ){
		m_spSwitch[i].Render();
	}
	for( i = 0; i < ELECHANGE_LAMP_NUM; i++ ){
		m_spLamp[i].Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelEleChange::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelEleChange::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelEleChange::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelEleChange::LoadTexData()
{
	if( LoadPackData( ELECHANGE_PACK_DATA, TEX_011202_MAX )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_011202_BASE] );
		m_spBG.SetVisible	( true );
		
		int i;
		const VEC2 tblLapmPos[]={
			247,154,
			401,154,
			247,265,
			401,265,
		};
		for( i = 0; i < ELECHANGE_LAMP_NUM; i++ ){
			m_spLamp[i].SetTexSprite( tblLapmPos[i].x, tblLapmPos[i].y, &m_pTexture[TEX_011202_LIGHT], 2, 2, (u16)i );
		}
		
		const f32 tblSwitchPosY[]={ 158,267 };
		for( i = 0; i < 2; i++ ){
			m_spSwitch[i].SetTexSprite( 286, tblSwitchPosY[i], &m_pTexture[TEX_011202_BUTTON], 1, 2, (u16)i );
		}		
		if( m_sNowAnswer == SETCHANGE_TOP ){
			m_spLamp[0].SetVisible( true );
			m_spLamp[1].SetVisible( true );
			m_spSwitch[0].SetVisible( true );
		}else{
			m_spLamp[2].SetVisible( true );
			m_spLamp[3].SetVisible( true );
			m_spSwitch[1].SetVisible( true );
		}
		return true;
	}
	return false;
}
