////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Elevator
//
// SK7PanelElevator.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELELEVATOR_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../fujita/c_font.h"

#include "SK7PanelElevator.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define		BUTTON_SIZE_X		(44)
#define		BUTTON_SIZE_Y		(44)

#define		BUTTON_SIGHT_X		(20.0f)
#define		BUTTON_SIGHT_Y		(22.0f)

//	{^̃|WV	
const	VEC2 tblButtonPos[]={
	116.0f ,254.0f,
	116.0f ,190.0f,
	193.0f ,286.0f,
	193.0f ,221.0f,
	193.0f ,157.0f,
//	193.0f ,83.0f,
	116.0f ,83.0f,
};

//	CgW
const VEC2 tblLgtPos[]={
	352.0f ,220.0f,
	352.0f ,176.0f,
	352.0f ,264.0f,
	352.0f ,220.0f,
	352.0f ,132.0f,
	352.0f ,44.0f,
};


	
//========================================================================
//					RXgN^
//========================================================================
SK7PanelElevator::SK7PanelElevator( s32 Now ) : SK7PanelBase( Now )
{
	//	Gx[^Kw`FbN
	m_sSelect = (s8)Now;
	m_sNowAnswer = (s8)Now;

	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){tblButtonPos[m_sSelect].x+BUTTON_SIGHT_X,tblButtonPos[m_sSelect].y+BUTTON_SIGHT_Y,0});
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	m_iTime	= 0;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);	
	
	//	{^XvCg	-----------------------------------------
	m_spButton.SetXY0( tblButtonPos[m_sNowAnswer].x, tblButtonPos[m_sNowAnswer].y );
	m_spButton.SetFlag( true, BLOCK_FLAG );
	m_spButton.SetTexNo( 0 );
			
	//	e{^̃Cg	----------------------------------------------
	m_spLgt.SetXY0( 0, 0 );
	m_spLgt.SetFlag( true, BLOCK_FLAG );
	m_spLgt.SetTexNo( 0 );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelElevator::~SK7PanelElevator()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	m_spButton.Delete();
	
	m_spLgt.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelElevator::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp(  true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( m_sSelect >= ELEVATOR_3F )	break;			
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_sSelect += 3;
			Vec V;
			V.x = tblButtonPos[m_sSelect].x+BUTTON_SIGHT_X;	V.y = tblButtonPos[m_sSelect].y+BUTTON_SIGHT_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_RIGHT, 1 );
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( m_sSelect <= ELEVATOR_2F || m_sSelect == ELEVATOR_OPEN )	break;
			if( m_sSelect > ELEVATOR_3F ){
				m_sSelect -= 3;
			}else{
				m_sSelect -= 2;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec V;
			V.x = tblButtonPos[m_sSelect].x+BUTTON_SIGHT_X;	V.y = tblButtonPos[m_sSelect].y+BUTTON_SIGHT_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_LEFT, 1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) )
		{
			if( ++m_sSelect > ELEVATOR_OPEN ){
				m_sSelect = ELEVATOR_OPEN;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec V;
			V.x = tblButtonPos[m_sSelect].x+BUTTON_SIGHT_X;	V.y = tblButtonPos[m_sSelect].y+BUTTON_SIGHT_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_UP, 1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			if( --m_sSelect < ELEVATOR_1F ){
				m_sSelect = ELEVATOR_1F;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec V;
			V.x = tblButtonPos[m_sSelect].x+BUTTON_SIGHT_X;	V.y = tblButtonPos[m_sSelect].y+BUTTON_SIGHT_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_DOWN, 1 );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			SetCursolDisp(  false );	
			m_Proc = PROC_CANCEL;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			if( m_sNowAnswer == m_sSelect )	break;
			m_Proc = PROC_CHECK;
			break;
		}
		break;
		
	//	I`FbN	----------------------------------------
	case 	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_spButton.SetFlag( false, RENDER_FLAG );
			m_spLgt.SetVisible(false);
			m_Proc = PROC_SELECT_MAIN;
			break;

		case	PANEL_CHECK_SET:
	
			gpSound->mPlaySE(SFX_SCE1_PNL_ELVSWITCH);

			//	{^_
			m_spButton.SetXY0( tblButtonPos[m_sSelect].x, tblButtonPos[m_sSelect].y );
			m_spButton.SetTexNo( (u8)m_sSelect );
			m_spButton.SetFlag( true, RENDER_FLAG );
			
			//	Cg
			m_spLgt.SetXY0( tblLgtPos[m_sSelect].x, tblLgtPos[m_sSelect].y );
			m_spLgt.SetTexNo( (u8)m_sSelect );
			m_spLgt.SetVisible( true );

			m_sNowAnswer = m_sSelect;
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case 	PROC_TIME:
		if( ++m_iTime > 20 )
		{
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	switch( m_sSelect ){
	case 0:		SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_RIGHT,0 );						break;
	case 1:		SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN|CURSOL_DIR_RIGHT,0 );		break;
	case 2:		SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN,0 );		break;
	case 3:		SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN,0 );		break;
	case 4:		SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN,0 );		break;
	case 5:		SetCursolDir( CURSOL_DIR_DOWN );		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelElevator::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	m_spButton.Render();				//	{^
	
	m_spLgt.Render();					//	Cg
	
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelElevator::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelElevator::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelElevator::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelElevator::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011301TEX_BG ) )
		{
			m_TexProc = LOAD_BUTTON;
		}
		break;
		
	case LOAD_BUTTON:
		if( m_spButton.LoadTexture( PNL011301TEX_BUTTON, 6, 1 ) )
		{
			m_TexProc = LOAD_LGT;
		}
	 	break;
		
	case LOAD_LGT:
		if( m_spLgt.LoadTexture( PNL011301TEX_LGT, 1, 6 ))
		{
			return true;
		}
		break;
	}
	return false;
}