////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Elevator
//
// SK7PanelElevator.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELELEVATOR_H__
#define	__SK7PANELELEVATOR_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
//#define	ELEVATOR_B1F	()			//	aPe
#define	ELEVATOR_1F		(0)			//	Pe
#define	ELEVATOR_2F		(1)			//	Qe
#define	ELEVATOR_3F		(2)			//	Re
#define	ELEVATOR_4F		(3)			//	Se
#define	ELEVATOR_5F		(4)			//	Te

#define ELEVATOR_OPEN	(5)


//	eNX`[pX
#define	PNL011301TEX_BG				"Texture/011301/ele_BG.BIN"
#define	PNL011301TEX_BUTTON			"Texture/011301/ele_button.BIN"
#define	PNL011301TEX_LGT			"Texture/011301/ele_lgt.BIN"

//---- class ----
class SK7PanelElevator : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CLOSE,
		PROC_CHECK,
		PROC_CANCEL,
		PROC_TIME,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_CURSOL = 0,
		LOAD_BG,
		LOAD_BUTTON,
		LOAD_LGT,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spButton;
	SK7Sprite				m_spLgt;
	
	s8						m_sSelect;
	int						m_iTime;
	

public:
	SK7PanelElevator( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelElevator();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELELEVATOR_H__
