////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Gacha
//
// SK7PanelGacha.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELGACHA_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "..\Scn\K7Scn02.h"

#include "SK7PanelGacha.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7EventItem.h"
#include "../Yam/YK7EffectItemGet.h"


#define		HANDLE_X	(412)
#define		HANDLE_Y	(144)
#define		BALL_X		(287)
#define		BALL_Y		(370)
#define		BALL_MOVE_Y	(180)
#define		SHADOW_X	(272)
#define		SHADOW_Y	(406)
#define		GET_MOVE_TIME	(10)
#define		BALL_MOVE_TIME	(30)
#define		BALL_MOVE_SPEED	(20)

#define		NO_Y		(181)
const f32 tblNoX[]={129,153,176};

#define	 GACHA_PACK_DATA			"/Texture/panel/020202.pak"

const int tblULCL[]={ 
	K7SCN02_EVFL_ULCL01, 
	K7SCN02_EVFL_ULCL02,
	K7SCN02_EVFL_ULCL03,
	K7SCN02_EVFL_ULCL04,
	K7SCN02_EVFL_ULCL05,
	K7SCN02_EVFL_ULCL06,
	K7SCN02_EVFL_ULCL08,
	K7SCN02_EVFL_ULCL09,
	K7SCN02_EVFL_ULCL10,
	K7SCN02_EVFL_ULCL11,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelGacha::SK7PanelGacha( s32 Now ) : SK7PanelBase( Now )
{	
	//vZX	----------------------------------------------
	m_Proc 		= PROC_LOAD;
	m_TexProc 	= LOAD_TEX;
	m_iTime		= 0;
	m_chGetFlag	= 0;
	m_chGetNo	= 0;
	m_fKasoku	= 10.0f;
	m_ucBoundNum= 0;
	m_bBoundFlag= false;
	m_bDoubleFlag=false;

	CheckULCL();	
	SetCursolPosition( &(Vec){476,190,0});
	
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);	
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelGacha::~SK7PanelGacha()
{
	//eNX`	-----------------------------
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelGacha::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	LZ	-------------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		//	_Zbg	---------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			//	_Ƃ	-----------------------------------
			if( K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)  > 0 ){
				gpSound->mPlaySE(SFX_SCE2_PNL_GACHAGACHA);
				//	_炷	---------------------------------------------------
				K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)--;
				//	_\ؑ	----------------------------------------------
				m_spNo[0].SetTexNo( (u16)(K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)/100) );
				m_spNo[1].SetTexNo( (u16)((K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)%100)/10) );
				m_spNo[2].SetTexNo( (u16)((K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)%100)%10) );
				//	nh	---------------------------------------------------
				m_spHandle.SetVisible( true );
				//	{[̍WZbg	------------------------------------------------
				m_spBall.SetY0(BALL_Y-BALL_MOVE_Y);
				m_spBall.SetTexNo( (u16)(rand()%3) );
				SetCursolDisp( false );
				CheckULCL();
				m_Proc = PROC_MOVE_BALL;
			}else{
				gpSound->mPlaySE(SFX_SYS_SUBSCREEN_BOO);
				break;
			}
		}
		break;
	//	{[ړ		-----------------------------------------------------		
	case 	PROC_MOVE_BALL:
		if( MoveBall() ){
			m_iTime = 0;
			m_Proc = PROC_TIME;
			break;
		}
		break;
	//	EGCg		---------------------------------------------------
	case	PROC_TIME:
		if( ++m_iTime > GET_MOVE_TIME ){
			SetHasULCL();
			if( m_bDoubleFlag ){
				OSReport( "1:  messageID:%d\n", (u8)(m_chGetNo+11)) ;
				m_pEffect = CreateItemGetEffect( m_cCheckJmbHandle, (u8)(m_chGetNo+11) );
				gpSound->mPlaySE( SFX_SYS_PNL_MISS );
			}else{
				OSReport( "2:  messageID:%d\n", m_chGetNo ) ;
				m_pEffect = CreateItemGetEffect( m_cCheckJmbHandle, m_chGetNo );
			}
			m_spBall.SetY0(BALL_Y-BALL_MOVE_Y);
			m_spShadow.SetVisible( false );
			m_spHandle.SetVisible( false );
			m_EffectID = GetEffectID( m_pEffect );
			m_iTime = 0;
			
			m_Proc = PROC_GET;
		}
		break;
	//	擾	------------------------------------------------------------
	case	PROC_GET:
		//	Qbgǂ	-------------------------------------
		if( CheckEffectValidState( m_pEffect, m_EffectID ) == FALSE ){
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelGacha::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi

	
	m_spShadow.Render();
	GXSetScissor( 246, 308, (u32)164, (u32)200 );
	m_spBall.Render();
	
	GXSetScissor( 0, 0, (u32)640, (u32)480 );
	for( int i = 0; i < PNL020202_NO_NUM; i++ )	m_spNo[i].Render();
	m_spHandle.Render();
		
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelGacha::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelGacha::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true)
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelGacha::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
//	{[̈ړ֐
//========================================================================
bool	SK7PanelGacha::MoveBall()
{
	m_spBall.SetIncY( m_fKasoku );
	m_fKasoku += 0.55f;//45f;
	
	if( m_spBall.GetY0() >= BALL_Y && m_fKasoku > 0.0f ){
		switch( m_ucBoundNum ){
		case 0: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 255 );	break;
		case 1: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 204 );	break;
		case 2: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 178 );	break;
		case 3: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 153 );	break;
		case 4: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 115 );	break;
		case 5: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 76 );		break;
		case 6: gpSound->mPlaySE( SFX_SCE2_PNL_GACHADERU, 51 );		break;
		}
		m_ucBoundNum++;
		m_spShadow.SetVisible( true );
		m_fKasoku = -7.0f/m_ucBoundNum;
		if( m_ucBoundNum > 6 ){
			m_ucBoundNum = 0;
			m_fKasoku = 10.0f;
			m_spBall.SetY0( BALL_Y );
			return true;
		}
	}else{
		if( m_ucBoundNum <= 1 ){
			m_spShadow.SetVisible( false );
		}
	}
	return false; 
}

//========================================================================
// ER`FbN֐
//========================================================================
void	SK7PanelGacha::CheckULCL()
{
	int	num=0;
	for( int i = 0; i < ULCL_GET_MAX; i++ ){
		if( K7SCR_GET_SCENARIO_FLAG( tblULCL[i] )==true ){
			num++;
		}
	}
#if 0
	if( num == ULCL_GET_MAX-2 ){
		m_chGetFlag = ULCL_GET_RANDAM;
	}else{
		m_chGetFlag = ULCL_GET_NORMAL;
	}
#endif
}


//========================================================================
// ER擾֐
//========================================================================
void	SK7PanelGacha::SetHasULCL()
{
	int GetNo;
	m_bDoubleFlag 	= false;
	m_chGetFlag 	= ULCL_GET_NORMAL;
	//	V[Nbg
	if( (rand()*(100+1)/RAND_MAX%(100+1)+1) == 51 ){
		m_chGetFlag = ULCL_GET_SECRET;
	}else{
		GetNo = (rand()*(9+1)/RAND_MAX%(9+1));
		OSReport( "1:GetNo = %d\n", GetNo ) ;
	}
	//V[Nbg擾
	if( m_chGetFlag == ULCL_GET_SECRET ){
	 	GetNo = ULCL_GET_MAX-1;
		OSReport( "2:GetNo = %d\n", GetNo ) ;

		if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_ULCLSECRET )==true ){
			m_bDoubleFlag = true;
		}else{
			K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_ULCLSECRET );
		}
	}else{
		int SaveNo = GetNo;
		if( K7SCR_GET_SCENARIO_FLAG( tblULCL[GetNo] )==true ){
			OSReport( "3:GetNo = %d\n", GetNo ) ;
			if( rand()%10 > 2 ){
				while(1){
					if( ++GetNo >= ULCL_GET_MAX-1 ){
						GetNo = 0;
					}
					//	_u[ׂăo[W
					if( SaveNo == GetNo ){
						m_bDoubleFlag = true;
						break;
					}
					//	󂫂
					if( K7SCR_GET_SCENARIO_FLAG( tblULCL[GetNo] )!=true ){
						K7SCR_SET_SCENARIO_FLAG( tblULCL[GetNo] );
						break;
					}
				}
			}else{
				m_bDoubleFlag = true;
			}
		}else{
			K7SCR_SET_SCENARIO_FLAG( tblULCL[GetNo] );
		}
	}/*
	if( GetNo > 10 && GetNo < 0 ){
		GetNo = 0;
		if( K7SCR_GET_SCENARIO_FLAG( tblULCL[0] )!=true ){
			m_bDoubleFlag = true;
		}
	}
	
	if( GetNo < 0 || GetNo > 10 )
	{
		GetNo = 0 ;
	}*/
	int num=0;
	for( int i = 0; i < ULCL_GET_MAX-1; i++ ){
		if( K7SCR_GET_SCENARIO_FLAG( tblULCL[i] )==true ){
			num++;
		}
	}
	if( K7SCR_GET_SCENARIO_FLAG( K7SCN02_EVFL_ULCLSECRET ) && num == ULCL_GET_MAX-1 ){
		K7SCR_SET_SCENARIO_FLAG( K7SCN02_EVFL_ULCLGACHA );
	}
	OSReport( "4:GetNo = %d\n", GetNo ) ;
	m_chGetNo = (s8)GetNo;
}

			
//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelGacha::LoadTexData()
{
	switch( m_TexProc ){
	case LOAD_TEX:
		if( LoadPackData( GACHA_PACK_DATA, TEX_020202_MAX )){
			m_spBG.SetTexSprite	( 0, 0, &m_pTexture[GACH_BG] );
			m_spBG.SetVisible	( true );
			
			m_spNo[0].SetTexSprite( tblNoX[0], NO_Y, &m_pTexture[ GACH_NMBR ], 10, 1, (u16)(K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)/100) );
			m_spNo[1].SetTexSprite( tblNoX[1], NO_Y, &m_pTexture[ GACH_NMBR ], 10, 1, (u16)((K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)%100)/10) );
			m_spNo[2].SetTexSprite( tblNoX[2], NO_Y, &m_pTexture[ GACH_NMBR ], 10, 1, (u16)((K7EVENT_SCN_VAR(K7SCN02,EVVA_ULMEDAL)%100)%10) );
			for( int i = 0; i < PNL020202_NO_NUM; i++ )		m_spNo[i].SetVisible( true );
			
			m_spShadow.SetTexSprite	( SHADOW_X, SHADOW_Y, &m_pTexture[ GACH_SHADOW ]);
			m_spShadow.SetVisible	( false );
				
			m_spBall.SetTexSprite	( BALL_X, BALL_Y-BALL_MOVE_Y, &m_pTexture[ GACH_BALL ], 3, 1, 0 );
			m_spBall.SetVisible		( true );
			
			m_spHandle.SetTexSprite	( HANDLE_X, HANDLE_Y, &m_pTexture[ GACH_HANDLE ] );
			m_spHandle.SetVisible	( false );
			m_TexProc = LOAD_EFFECT;
		}
		break;
		
	case LOAD_EFFECT:
		if( CheckMessagePackLoadComp( m_cCheckJmbHandle ) == TRUE ){
			return true;
		}
		break;
	}
//	
	return false;
}

