//
// Killer7 Panel Gacha
//
// SK7PanelGacha.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELGACHA_H__
#define	__SK7PANELGACHA_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"

enum{
	GACH_BG=0,
	GACH_HANDLE,
    GACH_NMBR,
    GACH_SHADOW,
    GACH_BALL,
	TEX_020202_MAX,
};


#define	PNL020202_NO_NUM		(3)
#define		ULCL_GET_MAX	(11)

//---- class ----
class SK7PanelGacha : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MOVE_BALL,
		PROC_TIME,
		PROC_GET,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_TEX=0,
		LOAD_EFFECT,
	}eLoadTexProc;
	
	enum{
		ULCL_GET_NORMAL=0,
		ULCL_GET_SECRET,
		ULCL_GET_RANDAM,
	};

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNo[PNL020202_NO_NUM];
	SK7Sprite				m_spShadow;
	SK7Sprite				m_spBall;
	SK7Sprite				m_spHandle;
	
	EFFECT*					m_pEffect;
	s8						m_chHandle;
	s8						m_chGetNo;
	s8						m_chGetFlag;
	int						m_iTime;
	u32						m_EffectID;
	bool					m_bBoundFlag;
	bool					m_bDoubleFlag;
	f32						m_fKasoku;
	u8						m_ucBoundNum;

	void	CheckULCL();
	void	SetHasULCL();
	bool	MoveBall();

public:
	SK7PanelGacha( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelGacha();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELGACHA_H__
