////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Ino
//
// SK7PanelIno.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELINO_H__
#define	__SK7PANELINO_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	
#define	GAME_INO					(0)
#define GAME_SHIKA					(1)
#define	GAME_CHO					(2)

//	߂l
#define	INO_CANCEL					(-1)
#define	INO_MISS					(0)
#define INO_OK						(1)

//	eNX`[pX
#define	INO_SELECT_NUM					(3)

//---- class ----
class SK7PanelIno : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_MESSAGE,
		PROC_CHECK,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG,
		LOAD_SELECT0,
		LOAD_SELECT1,
		LOAD_SELECT2,
		LOAD_BUTTON_LEFT,
		LOAD_BUTTON_CENTER,
		LOAD_BUTTON_RIGHT,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	u8						m_ucGameNo;
	s8						m_chSelect;
	u8						m_ucNo[INO_SELECT_NUM];
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spSelect[INO_SELECT_NUM];
	SK7Sprite				m_spButton[INO_SELECT_NUM];
	
public:
	SK7PanelIno( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelIno();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELINO_H__
