////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel InputCode6
//
// SK7PanelInputCode6.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/26/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELINPUTCODE6_H__
#define	__SK7PANELINPUTCODE6_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


#define		ALPHABET_NUM		(26)		//	At@xbg̐
#define		INPUT_ANSWER_NUM	(6)			//	̐

#define		ANSWER_LEFT			(13)
#define		ANSWER_RIGHT		(14)

//	Ԃl
#define		CODE_ANSWER_HIT		(1)
#define		CODE_ANSWER_MISS	(0)
#define		CODE_ANSWER_CANCEL	(-1)



//---- class ----
class SK7PanelInputCode6 : public SK7PanelBase
{
	//	t[vZX
	typedef enum 
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_DIAL_CHECK,
		PROC_DIAL_MOVE,
		PROC_ANSWER_HIT,
		PROC_ANSWER_BAT,
		PROC_ANSWER_CHECK,
		PROC_CANCEL,
		PROC_ANSWER_BAT_TIME,
		PROC_TIME,
	}eInputCode6Proc;
	
	//	eNX`ǂݍ
	enum
	{
		LOAD_BG=0,
		LOAD_FONT,
		LOAD_LGT,
		LOAD_DIAL,
	};
	

protected:
	eInputCode6Proc			m_Proc;
	u8						m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spAnswer[INPUT_ANSWER_NUM]; //	̐		
	SK7Sprite				m_spDial;				//	_CA
	SK7Sprite				m_spLgt;
	
	SK7File					m_File[ALPHABET_NUM];

	u32						m_lTime;
	int						m_iKeyTime;
	int						m_iRenderTime;
	s8						m_chSelect;
	u8						m_chAnswer[INPUT_ANSWER_NUM];
	u8						m_chAnswerNo;
		
public:
	SK7PanelInputCode6( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelInputCode6();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
};

#endif	//__SK7PANELINPUTCODE6_H__
