////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelKakejiku.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELKAKEJIKU_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelKakejiku.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"



//========================================================================
//					RXgN^
//========================================================================
SK7PanelKakejiku::SK7PanelKakejiku( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= -1;
	m_chSelect = (s8)Now;
	m_iTime = 0;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	//	v	------------------------------------------------------
	m_spSwitch.SetXY0	( 194, 224 );	
	
	SetCursolPosition( &(Vec){320,430,0} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelKakejiku::~SK7PanelKakejiku()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	m_spSwitch.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelKakejiku::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			if( m_chSelect == KAKEJIKU_SWITCH_OPEN ){
				SetCursolDisp( true );
				m_Proc = PROC_SELECT_MAIN;
			}else{
				SetCursolDisp( false );
				m_Proc = PROC_END;
			}
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = KAKEJIKU_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_sNowAnswer = KAKEJIKU_ON;
			m_spSwitch.SetVisible(true);
			m_Proc = PROC_WAIT;
			break;
		}
		break;
		
	case 	PROC_WAIT:
		if( ++m_iTime > 15 ){
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
						
	//	|X^[
	case	PROC_END:
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelKakejiku::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	if( m_chSelect == KAKEJIKU_SWITCH_OPEN ) m_spSwitch.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelKakejiku::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelKakejiku::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelKakejiku::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelKakejiku::LoadTexData()
{
	switch( m_TexProc ){
	case 	LOAD_BG:	//	wi
		if( m_chSelect == KAKEJIKU_SWITCH_OFF ){
			if( m_spBG.LoadTexture( "/Texture/015201/blue001.BIN" ) ){
				return true;
			}
		}else{
			if( m_spBG.LoadTexture( "/Texture/015201/red.BIN" ) ){
				m_TexProc = LOAD_SWITCH;
			}
		}
		break;
	case 	LOAD_SWITCH:	//	XCb`
		if( m_spSwitch.LoadTexture( "/Texture/015201/red_on01.BIN" ) ){
			m_spSwitch.SetVisible( false );
			return true;
		}
		break;
	}
	return false;
}
