////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Kouro
//
// SK7PanelKouro.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELKOURO_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelKouro.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

//	eNX`[pX
#define	PNL010401TEX_BG			"Texture/010401/kouro002_bg.BIN"
#define	PNL010401TEX_SMOKE		"Texture/010401/kouro002_smoke.BIN"
VEC2 tblOkouPos[]={ 176,288, 272,288, 384,288, };
#define		PANELKOURO_X_TABLE		(36)
#define		SMOKE_TIME				(30)
#define		SMOKE_MOVE_TIME			(2)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelKouro::SK7PanelKouro( s32 Now ) : SK7PanelBase( Now )
{
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	m_chColor 	= 0;
	m_iMoveX  	= 0;
	m_iTime		= 0;
	m_sNowAnswer = 0;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	m_chSelect = (s8)Now;
	
	SetCursolPosition( &(Vec){tblOkouPos[0].x+40,tblOkouPos[0].y+64,0} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelKouro::~SK7PanelKouro()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	m_spOkou[0].Delete();
	m_spSmoke[0].Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelKouro::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( ++m_chColor > COLOR_NUM-1 ){
				m_chColor = COLOR_NUM-1;
				break;
			}
			SetCursolPosition( &(Vec){tblOkouPos[m_chColor].x+40,tblOkouPos[m_chColor].y+64,0} );
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			if( --m_chColor < 0 ){
				m_chColor = 0;
				break;
			}
			SetCursolPosition( &(Vec){tblOkouPos[m_chColor].x+40,tblOkouPos[m_chColor].y+64,0} );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = KOURO_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() ){
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_spOkou[m_chColor].SetVisible(false);
			
			u32 ColorTbl[]={
				0xc8ad6400,
				0x6571c400,
				0xb0554e00,
				
				0x7ab37200,
				0xb3797200,
				0x8059a100,
				
				0x55819400,
				0x909d5100,
				0x96457100,
			};
			
			for( int i = 0; i < SMOKE_SIZE; i++ ){
				m_spSmoke[i].SetColor( ColorTbl[m_chSelect*3 + m_chColor] );
			}
			u8 tblAnswer[]={ 2, 0, 1 };
			if( tblAnswer[m_chSelect] == m_chColor ) 	m_sNowAnswer = KOURO_TRUE;
			else										m_sNowAnswer = KOURO_FALSE;			
			m_Proc = PROC_SMOKE;
			break;
		}
		break;

	//
	case PROC_SMOKE:
		if( ++m_iTime > SMOKE_MOVE_TIME ){
			if( MoveSmoke(true) ){
				m_Proc = PROC_SMOKE2;
			}
			m_iTime = 0;
		}
		break;
		
	case PROC_SMOKE2:
		if( ++m_iTime > SMOKE_MOVE_TIME ){
			if( MoveSmoke(false) ){
				m_Proc = PROC_MESSAGE;
			}
			m_iTime = 0;
		}
		break;
		
	//	bZ[W
	case	PROC_MESSAGE:
		u8 MesNo=0;
		switch(m_chSelect){
		case 0:
			switch(m_chColor){
			case 0:MesNo=3;	break;
			case 1:MesNo=0;	break;
			case 2:MesNo=2;	break;
			}
			break;
			
		case 1:
			switch(m_chColor){
			case 0:MesNo=4;	break;
			case 1:MesNo=2;	break;
			case 2:MesNo=5;	break;
			}
			break;
		
		case 2:
			switch(m_chColor){
			case 0:MesNo=6;	break;
			case 1:MesNo=3;	break;
			case 2:MesNo=1;	break;
			}
			break;
		}
		if( DrawMessage(MesNo) ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelKouro::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	int i;
	m_spBG.Render();					//	wi
	for( i = 0; i < COLOR_NUM; i++ ){
		m_spOkou[i].Render();
	}
	for( i = 0; i < SMOKE_SIZE; i++ ){
		m_spSmoke[i].Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelKouro::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelKouro::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelKouro::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// ̈ړ
//========================================================================
bool	SK7PanelKouro::MoveSmoke( bool State )
{
	f32	tbl[PANELKOURO_X_TABLE] = {
		 0.000f,  0.173f,  0.342f,  0.500f,  0.642f,  0.766f,  0.866f,  0.939f,  0.984f,
		 1.000f,  0.984f,  0.939f,  0.866f,  0.766f,  0.642f,  0.500f,  0.342f,  0.173f,
		 0.000f, -0.173f, -0.342f, -0.500f, -0.642f, -0.766f, -0.866f, -0.939f, -0.984f,
		-1.000f, -0.984f, -0.939f, -0.866f, -0.766f, -0.642f, -0.500f, -0.342f, -0.173f 
	};
	bool alpha = false;
	for( int i = 0; i < SMOKE_SIZE; i++ ){
		m_spSmoke[i].SetIncX( tbl[m_iMoveX] * 1.5f );
		m_iMoveX = (m_iMoveX + 1) % PANELKOURO_X_TABLE;
		if( State ){
			alpha = m_spSmoke[i].AddAlpha( SMOKE_TIME, 0xc0 );
		}else{
			alpha =m_spSmoke[i].DownAlpha( SMOKE_TIME, 0x00 );
		}
	}
	return alpha;
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelKouro::LoadTexData()
{
	int i;
	switch( m_TexProc ){
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL010401TEX_BG ) ){
			m_TexProc = LOAD_OKOU;
		}
		break;

	case 	LOAD_OKOU:	//	
		char str[255];
		sprintf( str, "Texture/%06d/kouro002_%d.BIN", 10400+m_chSelect+1, m_chSelect+1 );
		if( m_spOkou[0].LoadTexture( str, COLOR_NUM, 1 ) ){
			for( i = 0; i < COLOR_NUM; i++ ){
				m_spOkou[i].SetTexture	( m_spOkou[0].GetTexture(), COLOR_NUM, 1 );
				m_spOkou[i].SetXY0		( &tblOkouPos[i] );
				m_spOkou[i].SetFlag		( true, RENDER_FLAG|BLOCK_FLAG );
				m_spOkou[i].SetTexNo	( (u8)i );
			}
			m_TexProc = LOAD_SMOKE;
		}
		break;
	
	case 	LOAD_SMOKE:	//	
		if( m_spSmoke[0].LoadTexture( PNL010401TEX_SMOKE, 1, SMOKE_SIZE ) ){
			for( i = 0; i < SMOKE_SIZE; i++ ){
				m_spSmoke[i].SetTexSpriteTwo( 352, i, 352+80, i+1,  m_spSmoke[0].GetTexture(), 1, SMOKE_SIZE, (u8)i );
				m_spSmoke[i].SetFlag	( true, RENDER_FLAG );
				m_spSmoke[i].SetAlpha	( 0 );
			}
			return true;
		}
		break;
	}
	return false;
}