////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelLock.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PanelLock_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelLock.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

//	eNX`[pX
#define	PNL035012TEX_BG				"Texture/035012/19_base.BIN"
#define	PNL035012TEX_SWITCH			"Texture/035012/btn_down.BIN"
#define	PNL035012TEX_MONI			"Texture/035012/moni.BIN"


//========================================================================
//					RXgN^
//========================================================================
SK7PanelLock::SK7PanelLock( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);

	//	v	------------------------------------------------------
	m_spSwitch.SetXY0	( 188, 222 );
	m_spLamp.SetXY0		( 187, 160 );
	m_spLamp.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );

	//	bN
	if( Now == LOCK_OFF ){
		m_spSwitch.SetVisible(false);
		m_spLamp.SetTexNo(0);
	}
	//	bN
	if( Now == LOCK_ON ){
		m_spSwitch.SetVisible(true);
		m_spLamp.SetTexNo(1);
	}	
	SetCursolPosition( &(Vec){320,250,0} );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelLock::~SK7PanelLock()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();	
	m_spLamp.Delete();
	m_spSwitch.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelLock::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			if( m_sNowAnswer == LOCK_ON ){
				SetCursolDisp( true );
				m_Proc = PROC_SELECT_MAIN;
			}else{
				SetCursolDisp( false );
				m_Proc = PROC_END;
			}
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_sNowAnswer == 1 ){
			}else{
				gpSound->mPlaySE( SFX_SYS_DECIDE );
			}
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			m_sNowAnswer = LOCK_OFF;
			gpSound->mStopSE( SFX_SCE3_CUR_ALARM );
			gpSound->mPlaySE( SFX_SCE3_SECURITY_DEACTIVATED );
			m_spSwitch.SetVisible(false);
			m_spLamp.SetTexNo(0);
			m_Proc = PROC_MESSAGE;
			break;
		}
		break;
		
	//	bZ[W	
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
		break;
				
	//	|X^[
	case	PROC_END:
		if( DrawMessage(1) ){
//		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelLock::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spLamp.Render();
	m_spSwitch.Render();
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelLock::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelLock::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelLock::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelLock::LoadTexData()
{
	switch( m_TexProc ){
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL035012TEX_BG ) ){
			m_TexProc = LOAD_SWITCH;
		}
		break;
	case 	LOAD_SWITCH:	//	XCb`
		if( m_spSwitch.LoadTexture( PNL035012TEX_SWITCH ) ){
			m_TexProc = LOAD_LAMP;
		}
		break;
	case 	LOAD_LAMP:	//	v
		if( m_spLamp.LoadTexture( PNL035012TEX_MONI, 1, 2  ) ){
			return true;
		}
		break;
	}
	return false;
}