////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Mailbox
//
// SK7PanelMailbox.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/24/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELMAILBOX_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "..\Scn\K7Scn02.h"
#include "../wat/WK7EventItem.h"
#include "SK7PanelMailbox.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"


#define	POST_ANSWER		(3)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelMailbox::SK7PanelMailbox( s32 Now ) : SK7PanelBase( Now )
{
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
	
	m_sNowAnswer = MAILBOX_ANSWER_NOHIT;
	m_bAns = false;
	m_iTime = 0;
	
	m_iPostNo = Now;
	
	if( Now == POST_ANSWER ){
		m_bAns = true;
	}
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);	
	
	SetCursolPosition( &(Vec){320,240,0} );

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelMailbox::~SK7PanelMailbox()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelMailbox::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
#if 0		
		if( K7EVENT_SCN_VAR(K7SCN02,EVVA_SPSECRET) > 0)
		{			
			switch( CheckAnswer(2) )
			{
			case	PANEL_CHECK_RETURN:				//Ȃ
				m_Proc = PROC_CANCEL;
				break;

			case	PANEL_CHECK_SET:				//
				if( m_bAns )	m_sNowAnswer = MAILBOX_ANSWER_HIT;
				gpSound->mPlaySE(SFX_SCE2_PNL_POSTIN);
				K7EVENT_SCN_VAR(K7SCN02,EVVA_SPSECRET)--;
				m_Proc = PROC_MESSAGE;
				break;
			}
		}
		else
		{
			if( HSD_PadGetTrigger(0) & HSD_PAD_A )
			{
				SetCursolDisp( false );
				m_Proc = PROC_CANCEL;
				break;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_B )
			{
				SetCursolDisp( false );
				m_Proc = PROC_CANCEL;
				break;
			}
		}
		break;
		
	case	PROC_TIME:
		m_iTime++;
		if( m_bAns )
		{
			if( m_iTime == 30 )
			{
				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
			}
			if( m_iTime == 90 )
			{
				m_iTime = 0;
				m_Proc = PROC_MESSAGE;
			}
		}
		else
		{
			if( m_iTime > 60 )
			{
				m_iTime = 0;
				m_Proc = PROC_CANCEL;
			}
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_MESSAGE2;
		}
		break;

	case	PROC_MESSAGE2:
		if( DrawMessage(1) ){
			SetCursolDisp( true );
			if( m_bAns )	m_Proc = PROC_CANCEL;
			else			m_Proc = PROC_SELECT_MAIN;
		}
		break;
#endif
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelMailbox::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelMailbox::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelMailbox::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelMailbox::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelMailbox::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( tblMailboxTexture[m_iPostNo] ) )
		{
			return true;
		}
		break;

	}
	return false;
}