////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel MainBreaker
//
// SK7PanelMainBreaker.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELMAINBREAKER_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelMainBreaker.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


const VEC2 tblSwitchPos[]=
{
	254.0f, 163.0f,	
	254.0f, 227.0f,
};

Vec tblBreakerCursolPos[]=
{
	318.0f, 190.0f,	0.0f,
	318.0f,	270.0f,	0.0f,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelMainBreaker::SK7PanelMainBreaker( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &tblBreakerCursolPos[Now]);
//	if( Now == MAINBREAKER_ON )	SetCursolDir( CURSOL_DIR_UP ); 
//	else						SetCursolDir( CURSOL_DIR_DOWN );

	m_iTime = 0;
	m_sNowAnswer = Now;
	m_cSelect = (s8)Now;

	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	u[J[
	m_spSwitchOn.SetXY0( tblSwitchPos[MAINBREAKER_ON].x, tblSwitchPos[MAINBREAKER_ON].y );
	m_spSwitchOff.SetXY0( tblSwitchPos[MAINBREAKER_OFF].x, tblSwitchPos[MAINBREAKER_OFF].y );
	if( Now == MAINBREAKER_OFF ){
		m_spSwitchOn.SetVisible(false);
		m_spSwitchOff.SetVisible(true);
	}else{
		m_spSwitchOn.SetVisible(true);
		m_spSwitchOff.SetVisible(false);
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelMainBreaker::~SK7PanelMainBreaker()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spSwitchOn.Delete();
	m_spSwitchOff.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelMainBreaker::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	case	PROC_MESSAGE:
		if( m_sNowAnswer == MAINBREAKER_OFF ){
			if( DrawMessage(1) ){
				m_Proc = PROC_SELECT_MAIN;
			}
		}else{
			if( DrawMessage(0) ){
				m_Proc = PROC_SELECT_MAIN;
			}
		}			
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		//	ĂƂ
		if( m_sNowAnswer == MAINBREAKER_ON ){
			switch( CheckAnswer(-1,false,false) )
			{
//			case	PANEL_CHECK_RETURN:				
//				m_Proc = PROC_CANCEL;
//				break;

			case	PANEL_CHECK_SET:				//u[J[
				m_sNowAnswer = MAINBREAKER_OFF;
				SetCursolDisp( false );
				gpSound->mPlaySE( SFX_SYS_PNL_OK );
				gpSound->mPlaySE( SFX_SCE3_PNL_MAINB_UP );
				m_spSwitchOn.SetVisible(false);
				m_spSwitchOff.SetVisible(true);
				m_Proc = PROC_CHECK;
				break;
			}
		}else{
//			if( DrawMessage(0) ){
				SetCursolDisp( false );
				m_Proc = PROC_CANCEL;
//			}
		}
		break;
		
	//	ŏI`FbN	---------------------------------------
	case	PROC_CHECK:
		if( ++m_iTime > 30 )
		{
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelMainBreaker::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spSwitchOn.Render();
	m_spSwitchOff.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelMainBreaker::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelMainBreaker::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelMainBreaker::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
				
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelMainBreaker::LoadTexData()
{
	switch( m_TexProc )
	{
	
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL030409TEX_BG )){
			m_TexProc = LOAD_ON;
		}
		break;
	case 	LOAD_ON:	
		if( m_spSwitchOn.LoadTexture( PNL030409TEX_ON )){
			m_TexProc = LOAD_OFF;
		}
		break;
	case 	LOAD_OFF:	//	wi
		if( m_spSwitchOff.LoadTexture( PNL030409TEX_OFF )){
			return true;
		}
		break;
	}
	return false;
}