////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ManageKey
//
// SK7PanelManageKey.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELMANAGEKEY_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelManageKey.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"


//	ԍ	--------------------------------------
const s8 tblRoomNo[]=
{
	0,1,2,3,-1,-1,6,-1,8,9,10,11,12,-1,-1,-1,-1,15,16,-1,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelManageKey::SK7PanelManageKey( s32 Now ) : SK7PanelBase( Now )
{
	m_spKey.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
	m_spLamp.SetFlag(true, RENDER_FLAG|BLOCK_FLAG);
	
	//	TCg	----------------------------------------------
	if( Now == -1) 	Now = 0;
	
	m_vSightPos.x = KEYHOLE_X1 + KEYHOLE_GAPX * (Now%KEYHOLE_MAXW);
	m_vSightPos.y = KEYHOLE_Y1 + KEYHOLE_GAPY * ((int)(Now)/KEYHOLE_MAXW);
		
	//	vWݒ	----------------------------------------------
	m_spLamp.SetXY0(m_vSightPos.x+LAMP_X-(Now%KEYHOLE_MAXW)*1.0f,	m_vSightPos.y+LAMP_Y);
	m_spLamp.SetTexNo( (u8)tblRoomNo[Now] );
	
	//	TCg	------------------------------------------------------
	m_vSightPos.z = 0;
	SetCursolPosition( &m_vSightPos );
	
	m_ucSaveAns = m_ucSelectNo = (u8)Now;	//	ꂭƂm
	m_bKeyFlag = false;
	m_sNowAnswer = (u8)Now;
	m_lDrawTime = 0;
	m_iCancelTime = 0;
		
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
			
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//			------------------------------------------------------
	m_spKey.SetXY0( KEYHOLE_X1+PLUG_GAP_X+(KEYHOLE_GAPX*(Now%KEYHOLE_MAXW)), 
					KEYHOLE_Y1+PLUG_GAP_Y+(KEYHOLE_GAPY*((int)Now/KEYHOLE_MAXW) ));
	m_spKey.SetTexNo( (u8)(Now%KEYHOLE_MAXW) );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelManageKey::~SK7PanelManageKey()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spKey.Delete();
	m_spLamp.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelManageKey::FrameProcess(void)
{
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		 
		
		//	ĂƂ	-------------------------------
		if( m_bKeyFlag )
		{
			//	XeBbNړ	--------------------------------------
			if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
			{
				if( m_ucSelectNo < KEYHOLE_MAXW )	break;
				
				gpSound->mPlaySE(SFX_SYS_CURSOR);
				m_ucSelectNo 	-= KEYHOLE_MAXW;
				m_vSightPos.y 	-= KEYHOLE_GAPY;
				SetCursolPosition( &m_vSightPos );
				m_spKey.SetXY0(	KEYHOLE_X1+PLUG_GAP_X+(KEYHOLE_GAPX*(m_ucSelectNo%KEYHOLE_MAXW)), 
								KEYHOLE_Y1+PLUG_GAP_Y+(KEYHOLE_GAPY*((int)m_ucSelectNo/KEYHOLE_MAXW) ));
				break;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
			{
				if( m_ucSelectNo >= KEYHOLE_NUM - KEYHOLE_MAXW ) break;
				
				gpSound->mPlaySE(SFX_SYS_CURSOR);
				m_ucSelectNo 	+= KEYHOLE_MAXW;
				m_vSightPos.y 	+= KEYHOLE_GAPY;
				SetCursolPosition( &m_vSightPos );
				m_spKey.SetXY0(	KEYHOLE_X1+PLUG_GAP_X+(KEYHOLE_GAPX*(m_ucSelectNo%KEYHOLE_MAXW)), 
								KEYHOLE_Y1+PLUG_GAP_Y+(KEYHOLE_GAPY*((int)m_ucSelectNo/KEYHOLE_MAXW) ));
				break;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_RIGHT )
			{
				if( (m_ucSelectNo%(KEYHOLE_MAXW)) == KEYHOLE_MAXW-1 )	break;
				
				gpSound->mPlaySE(SFX_SYS_CURSOR);
				m_ucSelectNo++;
				m_vSightPos.x 	+= KEYHOLE_GAPX;
				SetCursolPosition( &m_vSightPos );
				m_spKey.SetXY0(	KEYHOLE_X1+PLUG_GAP_X+(KEYHOLE_GAPX*(m_ucSelectNo%KEYHOLE_MAXW)), 
								KEYHOLE_Y1+PLUG_GAP_Y+(KEYHOLE_GAPY*((int)m_ucSelectNo/KEYHOLE_MAXW) ));
				break;
			}
			if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_LEFT )
			{
				if( (m_ucSelectNo%KEYHOLE_MAXW) == 0 )	break;
				
				gpSound->mPlaySE(SFX_SYS_CURSOR);
				m_ucSelectNo--;
				m_vSightPos.x 	-= KEYHOLE_GAPX;
				SetCursolPosition( &m_vSightPos );
				m_spKey.SetXY0(	KEYHOLE_X1+PLUG_GAP_X+(KEYHOLE_GAPX*(m_ucSelectNo%KEYHOLE_MAXW)), 
								KEYHOLE_Y1+PLUG_GAP_Y+(KEYHOLE_GAPY*((int)m_ucSelectNo/KEYHOLE_MAXW) ));
				break;
			}
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
		{
			//	hĂƂ
			if(!m_bKeyFlag && m_ucSelectNo == m_sNowAnswer )
			{
				gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_GET);
				m_spKey.SetTexNo( KEY_NUM-1 );
				m_spLamp.SetVisible(false);
				m_bKeyFlag = true;
				break;
			}
			//	ĂƂ
			else
			if(m_bKeyFlag)
			{				
				if( tblRoomNo[m_ucSelectNo] == -1 )	break;
				m_bKeyFlag = false;
				m_sNowAnswer = m_ucSelectNo;
				m_spKey.SetTexNo( (u8)(m_ucSelectNo%KEYHOLE_MAXW) );
				gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_ON);

				m_Proc = PROC_KEYSET;
				break;
			}
		}
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			if( m_bKeyFlag )	break;
			SetCursolDisp( false );
			m_sNowAnswer = ROOM_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
	
	//	jdxƂƂ
	case  	PROC_KEYSET:
		switch( CheckAnswer() )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_GET);
			m_spKey.SetTexNo( KEY_NUM-1 );
			m_spLamp.SetVisible(false);
			m_bKeyFlag = true;
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//
			SetCursolDisp( false );
			gpSound->mPlaySE(SFX_SCE0_PANEL_KEY_ON);
			m_spLamp.SetXY0(m_vSightPos.x+LAMP_X-(m_ucSelectNo%KEYHOLE_MAXW)*1.0f, m_vSightPos.y+LAMP_Y);
			m_spLamp.SetVisible(true);
			m_spLamp.SetTexNo( (u8)tblRoomNo[m_ucSelectNo] );
			if( m_ucSaveAns == m_sNowAnswer ){
				m_sNowAnswer = ROOM_CANCEL;
			}
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case	PROC_TIME:
		if( ++m_iCancelTime > 40 )
		{
			m_iCancelTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	s8 bit=0;
	switch( m_ucSelectNo%4 ){
	case 0:		bit |= (CURSOL_DIR_RIGHT);										break;
	case 1:		
	case 2:		bit |= (CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT);						break;
	case 3:		bit |= (CURSOL_DIR_LEFT);										break;
	}
	switch( m_ucSelectNo / 4 ){
	case 0:		bit |=	(CURSOL_DIR_DOWN);					break;
	case 1:		
	case 2:		
	case 3:		bit |= (CURSOL_DIR_DOWN|CURSOL_DIR_UP);		break;	
	case 4:		bit |=	CURSOL_DIR_UP;						break;
 
	}
	//	JMĂ
	if( m_bKeyFlag ){
		SetCursolDir( bit );
	}else{
		SetCursolDir( bit, false );
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelManageKey::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();		//	wi
	
	m_spLamp.Render();		//	v	
	
	m_spKey.Render();		//	
	
	m_spLampMain.Render();

	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelManageKey::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelManageKey::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelManageKey::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{	
		case	PROC_CANCEL:
			return m_sNowAnswer;
	
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelManageKey::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL000104TEX_BG ) )
		{
			m_TexProc = LOAD_KEY;
		}
		break;
		
	case  	LOAD_KEY:	//	
		if( m_spKey.LoadTexture( PNL000104TEX_KEY, KEY_NUM, 1  ) )
		{
			m_TexProc = LOAD_LAMP;
		}
		break;
		
	case 	LOAD_LAMP:		//	v
		if( m_spLamp.LoadTexture( PNL000104TEX_LAMP, 1, LAMP_NUM ) )
		{
			m_spLampMain.SetTexture( m_spLamp.GetTexture(), 1, LAMP_NUM );
			return true;
		}
	}
	return false;
}

