////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel ManageKey2
//
// SK7PanelManageKey2.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELMANAGEKEY2_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelManageKey2.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


#define		FLOORNO_X			(32)
#define		FLOORNO_Y			(176)
#define		FLOORNO_SIZE_X		(96)	
#define		FLOORNO_SIZE_Y		(112)

#define		NUMBER_SIZE			(64)
#define		WINDOW_FRAME		(10)
#define		TV_FRAME			(20)

//	KW
const VEC2 tblNumberPos[]=
{
	96.0f, 208.0f,
	192.0f, 208.0f,
	288.0f, 208.0f,
	384.0f, 208.0f,
	480.0f, 208.0f,
};

const int tblTvNo00[]={ 0,4,5,-1,};
const int tblTvNo01[]={ 2,4,5,-1,};
const int tblTvNo02[]={ 2,3,4,5,6,-1,};
const int tblTvNo03[]={ 2,6,-1,};
const int tblTvNo04[]={ 0,-1,};

const int *tblTvNoAll[]=
{
	tblTvNo00,
	tblTvNo01,
	tblTvNo02,
	tblTvNo03,
	tblTvNo04,
};

	
//========================================================================
//					RXgN^
//========================================================================
SK7PanelManageKey2::SK7PanelManageKey2( s32 Now ) : SK7PanelBase( Now )
{
	//	TV\
	const VEC2 tblTVPos[]=
	{
		320.0f, 32.0f,
		480.0f, 96.0f,
		480.0f, 256.0f,
		320.0f, 320.0f,
		160.0f, 256.0f,
		160.0f, 96.0f,
		320.0f, 192.0f,
	};
	
	SetCursolPosition( &(Vec){ tblNumberPos[0].x+NUMBER_SIZE*0.5f, tblNumberPos[0].y+NUMBER_SIZE*0.5f,0} );
	SetCursolDir( CURSOL_DIR_RIGHT );

	m_sNowAnswer			= OPEN_FLOOR_1;
	
	//vZX	----------------------------------------------
	m_Proc 				= PROC_LOAD;
	m_TexProc 			= LOAD_TV;
	m_iSelect 			= 0;
	m_iWindowTime 		= 0;
	m_iClearFloor 		= Now;
	m_bWindowFlag		= true;
	m_iTvTime			= 0;
	m_iTvNum			= 0;
	
	int i;
	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(false);
		
	//	j^[	--------------------------------------------------
	for( i = 0; i < ROOM_NUM; i++ )
	{
		m_spTV[i].SetXY0( tblTVPos[i].x, tblTVPos[i].y );
		m_spTV[i].SetTexNo( (u8)i );
		m_spTV[i].SetFlag( true, BLOCK_FLAG );
		m_spTV[i].SetVisible( false );
	}
	
	//	KBG	-------------------------------------------------------
	m_spNoBG.SetXY0( 0, 0 );
	m_spNoBG.SetVisible( true );
	
	//	Kԍ	---------------------------------------------------
	for( i = 0; i < FLOOR_NUM; i++ )
	{
		m_spNumber[i].SetXY0( tblNumberPos[i].x, tblNumberPos[i].y );
		m_spNumber[i].SetFlag( true, BLOCK_FLAG );
		m_spNumber[i].SetTexNo( (u8)i );
		if( m_iClearFloor >= i ){
			m_spNumber[i].SetVisible( true );
		}else{
			m_spNumber[i].SetVisible( false );
		}			
	}
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelManageKey2::~SK7PanelManageKey2()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
		
	m_spTV[0].Delete();
	m_spNoBG.Delete();
	m_spNumber[0].Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelManageKey2::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_MESSAGE;
		}
		break;

	case PROC_MESSAGE:
		switch( m_iClearFloor ){
		case 1:		if( DrawMessage(0) )	m_Proc = PROC_SELECT_MAIN; break;
		case 2:		if( DrawMessage(1) )	m_Proc = PROC_SELECT_MAIN; break;
		case 3:		if( DrawMessage(2) )	m_Proc = PROC_SELECT_MAIN; break;
		case 4:		if( DrawMessage(3) )	m_Proc = PROC_SELECT_MAIN; break;
		default:	m_Proc = PROC_SELECT_MAIN; break;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( ++m_iSelect > FLOOR_NUM-1 )
			{
				m_iSelect = FLOOR_NUM-1;
				break;
			}			
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec V;
			V.x = tblNumberPos[m_iSelect].x+NUMBER_SIZE*0.5f;	V.y = tblNumberPos[m_iSelect].y+NUMBER_SIZE*0.5f; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_RIGHT,1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( --m_iSelect < 0 )
			{
				m_iSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			Vec V;
			V.x = tblNumberPos[m_iSelect].x+NUMBER_SIZE*0.5f;	V.y = tblNumberPos[m_iSelect].y+NUMBER_SIZE*0.5f; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_LEFT,1 );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			//	NAKȂƂȂ
			if( m_iClearFloor < m_iSelect )	break;
			gpSound->mPlaySE(SFX_SYS_DECIDE);
			m_bWindowFlag = true;
			SetCursolDisp( false );
			m_Proc = PROC_LOAD_BG;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	//	Isuaf̃[h	---------------------------------------------
	case	PROC_LOAD_BG:
		if( m_spBG.LoadTexture( tblBgName[m_iSelect] ) ){
			m_spBG.SetVisible(true);
			m_spNoBG.SetVisible(false);
			m_Proc = PROC_TV_DRAW;
		}
		break;
		
	//	erʕ\	-----------------------------------------------------
	case	PROC_TV_DRAW:
		if( ++m_iTvTime > TV_FRAME )
		{
			const int* TVNO = tblTvNoAll[m_iSelect];
			int a = TVNO[m_iTvNum];
			m_spTV[TVNO[m_iTvNum]].SetVisible(true);
			m_iTvNum++;
			gpSound->mPlaySE(SFX_SCE1_PNL_TVON);
			if( TVNO[m_iTvNum] == -1 )
			{
				m_iTvTime = 0;
				m_iTvNum = 0;
				m_Proc = PROC_TIME;
				break;
			}
			m_iTvTime = 0;
			break;
		}
		break;
		
	//	er	----------------------------------------------------
	case 	PROC_TV:
		 
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			for( int i = 0; i < ROOM_NUM; i++ )	m_spTV[i].SetVisible(false);
			m_spNoBG.SetVisible(true);
			m_spBG.SetVisible(false);
			m_spBG.Delete();
			m_bWindowFlag = false; 
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
			break;
		}
		break;
		
	case PROC_TIME:
		if( ++m_iTvTime > 40 )
		{
			m_sNowAnswer = (s8)m_iSelect;
			m_iTvTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;
		

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_iSelect == 0 )				SetCursolDir( CURSOL_DIR_RIGHT,0 );
	else if( m_iSelect == FLOOR_NUM-1 )	SetCursolDir( CURSOL_DIR_LEFT,0 );
	else								SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT,0 );
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelManageKey2::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	int i;
	m_spNoBG.Render();
	for( i = 0; i < FLOOR_NUM; i++ )
	{
		m_spNumber[i].Render();
	}
	m_spBG.Render();					//	wi
		
	for( i = 0; i < ROOM_NUM; i++ )
	{
		m_spTV[i].Render();
	}
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelManageKey2::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelManageKey2::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelManageKey2::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelManageKey2::LoadTexData()
{
	int i;
	
	switch( m_TexProc )
	{
	case	LOAD_TV:
		if( m_spTV[0].LoadTexture( PNL011304TEX_TV, ROOM_NUM, 1 ) )
		{
			for( i = 1; i < ROOM_NUM; i++ )
			{
				m_spTV[i].SetTexture( m_spTV[0].GetTexture(), ROOM_NUM, 1 );
			}
			m_TexProc = LOAD_NOBG;
		}
		break;

	case	LOAD_NOBG:
		if( m_spNoBG.LoadTexture( PNL011304TEX_NOBG ) )
		{
			m_TexProc = LOAD_NUMBER;
		}
		break;
	
	case	LOAD_NUMBER:
		if( m_spNumber[0].LoadTexture( PNL011304TEX_NUMBER, FLOOR_NUM, 1 ) )
		{
			for( i = 1; i < FLOOR_NUM; i++ )
			{
				m_spNumber[i].SetTexture( m_spNumber[0].GetTexture(), FLOOR_NUM, 1 );
			}
			return true;
		}
		break;
	}
	return false;
}
