////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelMatsu
//
// SK7PanelMatsu.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELMATSU_H__
#define	__SK7PANELMATSU_H__


#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	߂l
#define	MATSU_KILL				(0)	//	E
#define	MATSU_NIGASU			(1)	//	


//	eNX`[ԍ
enum{
	TEX_057500_ALIVEBG=0,
	TEX_057500_DEATH,
	TEX_057500_ALIVE,
	TEX_057500_ALIVE01,
	TEX_057500_ALIVE02,
	TEX_057500_GUN_SHOT,
	TEX_057500_GUN_SHOT2,
	TEX_057500_MAT_BACK_GROUND,
	TEX_057500_MUZZLE01,
	TEX_057500_MUZZLE02,
	TEX_057500_MUZZLE03,
	TEX_057500_SEI,
	TEX_057500_KA,
	TEX_057500_SU,
	TEX_057500_SATSU,
	TEX_057500_RU,
	TEX_057500_MAX,
};

#define		MUZZLE_MAX_NUM		(3)
#define		ALIVE_FONT_NUM		(3)
#define		DEATH_FONT_NUM		(2)

typedef struct{
	SK7Sprite	spFont;
	VEC2		vMove;
	f32			fExSpeed;
	int			iExTime;
	int			iExAddTime;
	int			iMoveTime;
}MOVE_FONT;

typedef struct{
	SK7Sprite	spMuzzle;
	f32			SaveEx;
	int			AddTime;
}MUZZLE_PARAM;

//---- class ----
class SK7PanelMatsu : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_FADEIN,
		PROC_SELECT_MAIN,
		PROC_MESSAGE,
		PROC_CHECK,
		PROC_TIME,
		PROC_CANCEL,
	}eFrameProc;
	
	enum{
		FRAME_FONT_ALIVE=0,
		FRAME_FONT_DEATH,
		FRAME_FONT_NONE,
	};
	
protected:
	eFrameProc				m_Proc;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spBack;
	SK7Sprite				m_spAliveBG;
	SK7Sprite				m_spAlive[2];			//	Ă摜
	SK7Sprite				m_spGunShot;
	SK7Sprite				m_spFace;
	SK7Sprite				m_spFlash;
	SK7Sprite				m_spLast;

	MOVE_FONT				m_MFAlive[ALIVE_FONT_NUM];
	MOVE_FONT				m_MFDeath[DEATH_FONT_NUM];
	MOVE_FONT				m_MFAliveS[ALIVE_FONT_NUM];
	MOVE_FONT				m_MFDeathS[DEATH_FONT_NUM];

	MUZZLE_PARAM			m_Muzzle[MUZZLE_MAX_NUM];
	s8						m_chSelect;
	int						m_iTime;
	int						m_iFadeTime;
	int						m_iMuzzleTime;
	bool					m_bAlive;
	bool					m_bAliveBgFlag;
	
	//	֐	------------------------------------------
	void					SetDeathData();
	void					SetMoveDirection( MOVE_FONT* pF );
	void					SetFontEx(MOVE_FONT* pF,int no);

	bool					MoveFadeIn();
	void					MoveFontEx();
	void					MoveFontDirection( u8 flag );
	void					MoveAlive();
	void					MoveDeath();

public:
	SK7PanelMatsu( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelMatsu();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELMATSU_H__
