////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelNine.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELNINE_CPP__

//#define	 __CLEAR_NINE__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "..\Scn\K7Scn03.h"
#include "SK7PanelNine.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


enum{
	LEVER_DIR_UP=0,
	LEVER_DIR_DOWN,
	LEVER_DIR_CENTER,
	LEVER_DIR_LEFT,
	LEVER_DIR_RIGHT,
};

enum{
	SELECT_UP=0,
	SELECT_DOWN,
	SELECT_RIGHT,
	SELECT_LEFT,
};

VEC2	tblLeverPos[]={
	364,0,		//
	364,221,	//
	364,113,	//^
	258,113,	//
	470,113,	//E
};

#define		CAR_POS_X0			(100)
#define		CAR_POS_X1			(147)
#define		CAR_POS_X2			(195)
#define		CAR_POS_Y0			(86)
#define		CAR_POS_Y1			(132)
#define		CAR_POS_Y2			(180)
#define		SELECT_COLOR		(0xe05f00f0)
#define		LEVER_FIRST_SPEED	(5)
#define		LEVER_LAST_SPEED	(5)
#define		NOT_POSITION		(8)
#define		ANSWER_TIME			(30)
#define		CAR_SPEED			(20)
#define		CAR_ALPHA_TIME		(20)


VEC2 tblSelectCarPos[]={
	116.0f,101.0f, 
	162.0f,101.0f,
	210.0f,101.0f,
	116.0f,148.0f,
	162.0f,148.0f,
	210.0f,148.0f,
	116.0f,195.0f,
	162.0f,195.0f,
	210.0f,195.0f,
};

u8	tblAnswerNo[]={ 7,6,5,4,3,8,2,1,0, };

//========================================================================
//					RXgN^
//========================================================================
SK7PanelNine::SK7PanelNine( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= NINE_CANCEL;
	m_chSelect		= (s8)0;
	m_iMoveTime		= 0;
	m_iMoveTime2	= 0;
	m_chMoveNo		= 0;
	m_iTime			= 0;
	m_bReturnFlag	= false;
	m_bMoveFlag		= false;
	m_bAlphaFlag	= false;

	//	e[uZbg	------------------------------------------------
	m_ucCarNo[0] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL);
	m_ucCarNo[1] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UC);
	m_ucCarNo[2] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UR);
	m_ucCarNo[3] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_ML);
	m_ucCarNo[4] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MC);
	m_ucCarNo[5] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MR);
	m_ucCarNo[6] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DL);
	m_ucCarNo[7] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DC);
	m_ucCarNo[8] = K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DR);

	//	̏ꏊNo	------------------------------------------
	int No=0;
	for( int i = 0; i < CAR_NUM; i++, No++ ){
		if( (CAR_NUM-1) == m_ucCarNo[i] ){
			m_chBlackNo = (s8)i;
			No--;
		}else{
			m_Car[No].No = (u8)i;
		}
	}

	SetCursolPosition( &(Vec){394,184,0} );
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN );
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	m_spLever.SetXY0(tblLeverPos[LEVER_DIR_CENTER].x, tblLeverPos[LEVER_DIR_CENTER].y);
	m_spLever.SetFlag( true, RENDER_FLAG );

	for( int i = 0; i < SELECT_NUM; i++ ){
		m_spSelect[i].SetFlag	( true, RENDER_FLAG|NOTEX_FLAG|POINT_FLAG );
		m_spSelect[i].SetColor	( SELECT_COLOR );
		m_spSelect[i].SetSize	( 255 );
	}
	//	ZNgZbg
	SetSelectPos();
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelNine::~SK7PanelNine()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_Car[0].Sprite.Delete();
	m_spLever.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelNine::FrameProcess(void)
{
	if( m_bAlphaFlag ){
		for( int i = 0; i < SELECT_NUM; i++ ){
			if( m_spSelect[i].DownAlpha(CAR_ALPHA_TIME) ){
				m_bAlphaFlag = false;
			}
		}
	}else{
		for( int i = 0; i < SELECT_NUM; i++ ){
			if( m_spSelect[i].AddAlpha(CAR_ALPHA_TIME) ){
				m_bAlphaFlag = true;
			}
		}
	}

	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
#ifdef __CLEAR_NINE__
		if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
			m_sNowAnswer = NINE_CLEAR;
			m_Proc = PROC_CANCEL;
		}
#endif
		f32 X=0,Y=0;
		//		****************************************
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			m_chSelect = LEVER_DIR_DOWN;
			SetCursolDir( CURSOL_DIR_DOWN );
			SetNoSelect();
			gpSound->mPlaySE( SFX_SCE3_CURTIS_9PANELGEAR );
			if( CheckPazzle() )		m_Proc = PROC_MOVE_LEVER;
			break;
		}
		//		****************************************
		if( CheckKeyT( SK7_KEY_UP ) ){
			m_chSelect = LEVER_DIR_UP;
			SetCursolDir( CURSOL_DIR_UP );
			SetNoSelect();
			gpSound->mPlaySE( SFX_SCE3_CURTIS_9PANELGEAR );
			if( CheckPazzle() )		m_Proc = PROC_MOVE_LEVER;
			break;
		}
		//	E	****************************************
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			m_chSelect = LEVER_DIR_RIGHT;
			SetCursolDir( CURSOL_DIR_RIGHT );
			SetNoSelect();
			gpSound->mPlaySE( SFX_SCE3_CURTIS_9PANELGEAR );
			if( CheckPazzle() )		m_Proc = PROC_MOVE_LEVER;
			break;
		}
		//		****************************************
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			m_chSelect = LEVER_DIR_LEFT;
			SetCursolDir( CURSOL_DIR_LEFT );
			SetNoSelect();
			gpSound->mPlaySE( SFX_SCE3_CURTIS_9PANELGEAR );
			if( CheckPazzle() ){
				m_Proc = PROC_MOVE_LEVER;
			}
			break;
		}
		//	LZ	****************************************
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL) = m_ucCarNo[0];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UC) = m_ucCarNo[1];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UR) = m_ucCarNo[2];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_ML) = m_ucCarNo[3];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MC) = m_ucCarNo[4];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MR) = m_ucCarNo[5];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DL) = m_ucCarNo[6];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DC) = m_ucCarNo[7];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DR) = m_ucCarNo[8];
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_sNowAnswer = NINE_CANCEL;
			m_Proc = PROC_CANCEL;
		}
		break;

	//	ړ	=====================================================
	case	PROC_MOVE_LEVER:
		if( MoveLever() ){
			if( !m_bMoveFlag ){
				m_bReturnFlag = true;
				m_Proc = PROC_MOVE_LEVER2;
			}else{
				gpSound->mPlaySE( SFX_SYS_PNL_OK );
				m_Proc = PROC_MOVE_CAR;
			}
		}
		break;
		
	case	PROC_MOVE_LEVER2:
		if( MoveLever() ){
			SetCarAlpha();
			SetCursolDisp( true );
			SetSelectPos();
			m_bReturnFlag = false;
			SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN, false );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	ړ	=====================================================
	case	PROC_MOVE_CAR:
		if( MoveCar() ){
			SetCarAlpha();
			SetSelectPos();
			m_bReturnFlag = false;
			SetCursolDisp( false );
			SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN,false);
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL) = m_ucCarNo[0];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UC) = m_ucCarNo[1];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UR) = m_ucCarNo[2];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_ML) = m_ucCarNo[3];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MC) = m_ucCarNo[4];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MR) = m_ucCarNo[5];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DL) = m_ucCarNo[6];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DC) = m_ucCarNo[7];
			K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DR) = m_ucCarNo[8];
			m_sNowAnswer = NINE_PLAY;
			m_Proc = PROC_CANCEL;//PROC_SELECT_MAIN;
#if 0			
			bool flag = false;
			for( int i = 0; i < CAR_NUM; i++ ){
				if( tblAnswerNo[i] != m_ucCarNo[i] ){
					flag = true;
				}
			}
			if( flag ){
				SetCursolDisp( true );
				SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN,false);
				m_Proc = PROC_SELECT_MAIN;
			}else{
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UL) = m_ucCarNo[0];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UC) = m_ucCarNo[1];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_UR) = m_ucCarNo[2];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_ML) = m_ucCarNo[3];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MC) = m_ucCarNo[4];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_MR) = m_ucCarNo[5];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DL) = m_ucCarNo[6];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DC) = m_ucCarNo[7];
				K7EVENT_SCN_VAR(K7SCN03,PZCARVA_DR) = m_ucCarNo[8];
				SetCursolDisp( false );
				SetNoSelect();
				m_Proc = PROC_CHECK;
			}
#endif
		}
		break;
		
	case	PROC_CHECK: 
		if( ++m_iTime > ANSWER_TIME ){
			m_sNowAnswer = NINE_CLEAR;
			SetCursolDisp( false );
			m_iTime = 0;
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelNine::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	m_spLever.Render();
	
	for( int j = 0; j < SELECT_NUM; j++ ){
		m_spSelect[j].Render();
	}
	for( int i = 0; i < CAR_NUM-1; i++ ){
		m_Car[i].Sprite.Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelNine::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelNine::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelNine::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// o[ړ
//========================================================================
bool	SK7PanelNine::MoveLever()
{
	f32 X=m_spLever.GetX0(),Y=m_spLever.GetY0();
	if( m_bReturnFlag ){
		X += (tblLeverPos[LEVER_DIR_CENTER].x - tblLeverPos[m_chSelect].x)/LEVER_FIRST_SPEED;
		Y += (tblLeverPos[LEVER_DIR_CENTER].y - tblLeverPos[m_chSelect].y)/LEVER_FIRST_SPEED;
	}else{
		X += ( tblLeverPos[m_chSelect].x - tblLeverPos[LEVER_DIR_CENTER].x )/LEVER_FIRST_SPEED;
		Y += ( tblLeverPos[m_chSelect].y - tblLeverPos[LEVER_DIR_CENTER].y )/LEVER_FIRST_SPEED;
	}
	m_spLever.SetXY0( X, Y );
	
	if( ++m_iMoveTime >= LEVER_FIRST_SPEED ){
		m_iMoveTime = 0;
		if( m_bReturnFlag ){
			if( m_bMoveFlag ){
				u8 SaveNo = m_ucCarNo[m_Car[m_chMoveNo].No];
				m_ucCarNo[m_Car[m_chMoveNo].No] = 8;
				m_ucCarNo[m_chBlackNo] = SaveNo;
				m_Car[m_chMoveNo].No = (u8)m_chBlackNo;
				switch( m_chSelect ){
				case LEVER_DIR_LEFT:	m_chBlackNo++;				break;
				case LEVER_DIR_RIGHT:	m_chBlackNo--;				break;
				case LEVER_DIR_UP:		m_chBlackNo+=sqrt(CAR_NUM);	break;
				case LEVER_DIR_DOWN:	m_chBlackNo-=sqrt(CAR_NUM);	break;
				}
			}
//			return true;
		}
		return true;
	}
	return false;
}

//========================================================================
// Ԉړ
//========================================================================
bool	SK7PanelNine::MoveCar()
{
	f32 CX = m_Car[m_chMoveNo].Sprite.GetX0(), CY = m_Car[m_chMoveNo].Sprite.GetY0();
	VEC2 vStart, vEnd;
	GetCarPos((int)m_chBlackNo, &vEnd);
	GetCarPos((int)m_Car[m_chMoveNo].No, 	&vStart);
	CX += (vEnd.x - vStart.x)/CAR_SPEED;
	CY += (vEnd.y - vStart.y)/CAR_SPEED;

	m_iMoveTime2++;
	m_Car[m_chMoveNo].Sprite.SetXY0( CX, CY );
	if( m_iMoveTime2 > CAR_SPEED - LEVER_FIRST_SPEED ){
		m_bReturnFlag = true;
		MoveLever();
	}
	if( m_iMoveTime2 >= CAR_SPEED ){
		m_iMoveTime2 = 0;
		return true;
	}
	
	return false;
}

//========================================================================
// Ԃ̃|WVQbg
//========================================================================
void	SK7PanelNine::GetCarPos( int No , VEC2 *pPos )
{
	f32 MX=CAR_POS_X0,MY=CAR_POS_Y0;
	if( (No % 3) == 1 )		MX = CAR_POS_X1;
	if( (No % 3) == 2 )		MX = CAR_POS_X2;
	if( No > 2 && No < 6 )	MY = CAR_POS_Y1;
	if( No > 5 )			MY = CAR_POS_Y2;
	pPos->x = MX; pPos->y = MY;
}


//========================================================================
// ZNg|WV
//========================================================================
void	SK7PanelNine::SetSelectPos()
{
	int PazNum = (int)sqrt(CAR_NUM);
	
	if( (m_chBlackNo % PazNum) < PazNum-1 ){
		m_spSelect[SELECT_LEFT].SetXY0( tblSelectCarPos[m_chBlackNo+1].x,tblSelectCarPos[m_chBlackNo+1].y );
		m_spSelect[SELECT_LEFT].SetVisible(true);
	}else{
		m_spSelect[SELECT_LEFT].SetVisible(false);
	}
		
	if( (m_chBlackNo % PazNum) > 0 ){
		m_spSelect[SELECT_RIGHT].SetXY0( tblSelectCarPos[m_chBlackNo-1].x,tblSelectCarPos[m_chBlackNo-1].y );
		m_spSelect[SELECT_RIGHT].SetVisible(true);
	}else{
		m_spSelect[SELECT_RIGHT].SetVisible(false);
	}
	
	if( m_chBlackNo >= sqrt(CAR_NUM) ){
		m_spSelect[SELECT_UP].SetXY0( tblSelectCarPos[m_chBlackNo-PazNum].x,tblSelectCarPos[m_chBlackNo-PazNum].y );
		m_spSelect[SELECT_UP].SetVisible(true);
	}else{
		m_spSelect[SELECT_UP].SetVisible(false);
	}
	
	if( m_chBlackNo <= (CAR_NUM-1)-sqrt(CAR_NUM) ){
		m_spSelect[SELECT_DOWN].SetXY0( tblSelectCarPos[m_chBlackNo+PazNum].x,tblSelectCarPos[m_chBlackNo+PazNum].y );
		m_spSelect[SELECT_DOWN].SetVisible(true);
	}else{
		m_spSelect[SELECT_DOWN].SetVisible(false);
	}
}

//========================================================================
// pYړ`FbN
//========================================================================
bool	SK7PanelNine::CheckPazzle()
{
	int PazNum = (int)sqrt(CAR_NUM);
	int MoveNo=0;
	bool retcode=false;
	
	switch( m_chSelect ){
	//	Eɂ`FbN +++++++++++++++++++++++++++++++++
	case	LEVER_DIR_LEFT:
		if( (m_chBlackNo % PazNum) < PazNum-1 ){
			MoveNo = 1;
			retcode = true;
		}
		break;	
	//	ɂ`FbN +++++++++++++++++++++++++++++++++
	case	LEVER_DIR_RIGHT:
		if( (m_chBlackNo % PazNum) > 0 ){
			MoveNo = -1;
			retcode = true;
		}
		break;
	//	ɏア`FbN +++++++++++++++++++++++++++++++++
	case LEVER_DIR_DOWN:
		if( m_chBlackNo >= sqrt(CAR_NUM) ){
			MoveNo = (int)-sqrt(CAR_NUM);
			retcode = true;
		}
		break;
	//	ɉ`FbN +++++++++++++++++++++++++++++++++
	case	LEVER_DIR_UP:
		if( m_chBlackNo <= (CAR_NUM-1)-sqrt(CAR_NUM) ){
			MoveNo = (int)sqrt(CAR_NUM);			
			retcode = true;
		}
		break;
	}
	
	//	ꍇ	++++++++++++++++++++++++++++++++++++++++++++
	if( retcode ){
		//	ړꏊƎԂ݈̌ʒu
		for( m_chMoveNo = 0; m_chMoveNo < CAR_NUM-1; m_chMoveNo++ ){
			if( m_Car[m_chMoveNo].No == m_chBlackNo+MoveNo ){
				break;
			}
		}
	}
	m_bMoveFlag = retcode;
	return true;
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelNine::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL035003TEX_BG ) ){
			m_TexProc = LOAD_LEVER;
		}
		break;
	case 	LOAD_LEVER:	//	o[
		if( m_spLever.LoadTexture( PNL035003TEX_LEVER ) ){
			m_TexProc = LOAD_CAR;
		}
		break;
	case 	LOAD_CAR:	//	
		if( m_Car[0].Sprite.LoadTexture( PNL035003TEX_CAR ) )
		{	
			int	No = 0;
			for( int i = 0; i < CAR_NUM; i++, No++ ){
				if( m_ucCarNo[i] == NOT_POSITION ){
					No--;
					continue;
				}
				f32 X=CAR_POS_X0, Y=CAR_POS_Y0;
				if( (i % 3) == 1 )				X = CAR_POS_X1;
				if( (i % 3) == 2 )				X = CAR_POS_X2;
				if( i > 2 && i < 6 )			Y = CAR_POS_Y1;
				if( i > 5 )						Y = CAR_POS_Y2;
				m_Car[No].Sprite.SetXY0			( X, Y );
				m_Car[No].Sprite.SetColor		( tblCarColor[m_ucCarNo[i]] );
				m_Car[No].Sprite.SetTexture		( m_Car[0].Sprite.GetTexture() );
				m_Car[No].Sprite.SetFlag		( true, RENDER_FLAG );
			}
			return true;
		}
		break;
	}
	return false;
}

