////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Niou
//
// SK7PanelNiou.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/28/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELNIOU_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelNiou.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"


#define		SWITCH_BUTTON_Y		(36)
#define		SWITCH_BUTTON_GAP_Y	(32)
const f32 tblSwitchPosX[]=
{
	 82,
	218,
	352,
	488,
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelNiou::SK7PanelNiou( s32 Now ) : SK7PanelBase( Now )
{
//	if( Now == LIGHT_COLOR_NONE )
//	{
//		Now = LIGHT_COLOR_BLACK;
//	}

	for( int i = 0; i < SWITCH_NUM; i++ ){
		m_spSwitch[i].SetVisible( false );
	}
	if( Now != LIGHT_COLOR_NONE ){
		m_spSwitch[Now].SetVisible( true );
	}
	
	Vec V;
	V.x = tblSwitchPosX[0]+SWITCH_SIGHT_X;	V.y = SWITCH_BUTTON_Y+SWITCH_BUTTON_GAP_Y; V.z = 0.0f;
	SetCursolPosition( &V );
	
	//	ZNg
	m_ucSelectNo 	= 0;
	m_lMoveTime 	= 0;
	m_lSwitchTime 	= 0;
	m_bMoveFlag 	= false;
	
	m_cSaveNo = (s8)Now;
	m_sNowAnswer = Now;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	

}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelNiou::~SK7PanelNiou()
{
	//eNX`	-----------------------------
	m_spBG.Delete();
	m_spSwitch[0].Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelNiou::FrameProcess(void)
{	
	switch( m_Proc ){
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() ){
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		//	XeBbNړ	--------------------------------------
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( m_ucSelectNo == SWITCH_NUM-1 )	break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo++;
			Vec V;
			V.x = tblSwitchPosX[m_ucSelectNo]+SWITCH_SIGHT_X;	V.y = SWITCH_BUTTON_Y+SWITCH_BUTTON_GAP_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_RIGHT,1 );									
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( m_ucSelectNo == 0 )				break;
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			m_ucSelectNo--;
			Vec V;
			V.x = tblSwitchPosX[m_ucSelectNo]+SWITCH_SIGHT_X;	V.y = SWITCH_BUTTON_Y+SWITCH_BUTTON_GAP_Y; V.z = 0.0f;
			SetCursolPosition( &V );
			SetCursolDir( CURSOL_DIR_LEFT,	1 );									
			break;
		}
		//		-----------------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
		{
			if( m_sNowAnswer != m_ucSelectNo ){
				m_Proc = PROC_SWITCH_TIME;
			}
			break;
		}
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			m_sNowAnswer = LIGHT_COLOR_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
	
	//	ŏI`FbN	
	case	PROC_SWITCH_TIME:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_spSwitch[m_ucSelectNo].SetVisible( false );
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_sNowAnswer = m_ucSelectNo;
			for( int i = 0; i < SWITCH_NUM; i++ )	m_spSwitch[i].SetVisible( false );
			m_spSwitch[m_ucSelectNo].SetVisible( true );
			m_Proc = PROC_MESSAGE;
			break;
		}
		break;

#if 0		
	//	ړ		------------------------------------------------
	case	PROC_MOVE_SWITCH:
		if( MoveSwitchPos() )
		{
			gpSound->mPlaySE(SFX_SCE1_WOODSWITCH_SLIDE);
			gpSound->mPlaySE(SFX_SCE1_WOODSWITCH);
//			m_Proc = PROC_MESSAGE;
			if( m_bMoveFlag ){
				m_Proc = PROC_SELECT_MAIN;
			}else{
				m_Proc = PROC_SWITCH_TIME;
			}
		}
		break;
#endif

	case	PROC_MESSAGE:
		switch( m_sNowAnswer ){
		case LIGHT_COLOR_WHITE:		if( DrawMessage(0) ) m_Proc = PROC_CANCEL; break;
		case LIGHT_COLOR_YELLOW:	if( DrawMessage(1) ) m_Proc = PROC_CANCEL; break;
//		case LIGHT_COLOR_BLACK:		if( DrawMessage(2) ) m_Proc = PROC_CANCEL; break;
		case LIGHT_COLOR_RED:		if( DrawMessage(3) ) m_Proc = PROC_CANCEL; break;
		case LIGHT_COLOR_BLUE:		if( DrawMessage(4) ) m_Proc = PROC_CANCEL; break;
		}
		break;
			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_ucSelectNo == 0 )						SetCursolDir( CURSOL_DIR_RIGHT, 0 );						
	else if( m_ucSelectNo == SWITCH_NUM-1 )		SetCursolDir( CURSOL_DIR_LEFT, 	0 );							
	else 										SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT, 0  );	
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelNiou::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < SWITCH_NUM; i++ )
	{
		m_spSwitch[i].Render();
	}
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelNiou::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelNiou::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelNiou::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_sNowAnswer;
		
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelNiou::LoadTexData()
{
	switch( m_TexProc )
	{	
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL000106TEX_BG ) )
		{
			m_TexProc = LOAD_SWITCH0;
		}
		break;
	case  	LOAD_SWITCH0:	//	XCb`P
		if( m_spSwitch[0].LoadTexture( PNL000106TEX_SWITCH, SWITCH_NUM, 1 ))
		{
			for( int i = 0; i < SWITCH_NUM; i++ ){
				m_spSwitch[i].SetTexSprite( tblSwitchPosX[i], SWITCH_BUTTON_Y, m_spSwitch[0].GetTexture(), SWITCH_NUM, 1, (u8)i );
			}
			return true;
		}
		break;
	}
	return false;
}


#if 0
//========================================================================
// J[\ړ	
//========================================================================
bool		SK7PanelNiou::MoveSightPos()
{
	if( ++m_lMoveTime >= 30 )
	{
		f32 SpeedY = SWITCH_UP_Y / SPEED_FRAME;	
		
		Vec	Speed;
		Speed.x = (tblSwitchPosX[0]+SWITCH_SIGHT_X - SIGHT_FIRST_X) / SPEED_FRAME;
		Speed.y = (SWITCH_SIGHT_Y - SIGHT_FIRST_Y) / SPEED_FRAME;
		
		m_vSightPos.x += Speed.x;	
		m_vSightPos.y += Speed.y; 
		m_vSightPos.z = 0.0f;
		
		SetCursolPosition( &m_vSightPos );
	}	
	if( ++m_lMoveTime >= SPEED_FRAME+30 )
	{
		m_lMoveTime = 0;
		return true;
	}
	return false;
}

//========================================================================
// XCb`ړ	
//========================================================================
bool		SK7PanelNiou::MoveSwitchPos()
{	
	f32 SpeedY = SWITCH_UP_Y / SPEED_FRAME;	
		
	if( m_bMoveFlag )
	{
		if( m_sNowAnswer != -1 )
		{
			m_spSwitch[m_sNowAnswer].SetXY0( m_spSwitch[m_sNowAnswer].GetX0(), m_spSwitch[m_sNowAnswer].GetY0()+SpeedY );
		}
		if( m_sNowAnswer != m_cSaveNo )
		{
			m_spSwitch[m_cSaveNo].SetXY0( m_spSwitch[m_cSaveNo].GetX0(), m_spSwitch[m_cSaveNo].GetY0()-SpeedY );
		}
		if( ++m_lMoveTime >= SPEED_FRAME )
		{
			m_sNowAnswer = m_cSaveNo;
			m_lMoveTime = 0;
			return true;
		}
		else	return false;
	}
	else
	{
		if( m_sNowAnswer != -1 )
		{
			m_spSwitch[m_sNowAnswer].SetXY0( m_spSwitch[m_sNowAnswer].GetX0(), m_spSwitch[m_sNowAnswer].GetY0()+SpeedY );
		}
		if( m_sNowAnswer != m_ucSelectNo )
		{
			m_spSwitch[m_ucSelectNo].SetXY0( m_spSwitch[m_ucSelectNo].GetX0(), m_spSwitch[m_ucSelectNo].GetY0()-SpeedY );
		}	
		if( ++m_lMoveTime >= SPEED_FRAME )
		{
			if( m_sNowAnswer == m_ucSelectNo )	m_sNowAnswer = LIGHT_COLOR_BLACK;
			else 							m_sNowAnswer = (s8)m_ucSelectNo;
			m_lMoveTime = 0;
			return true;
		}
		else	return false;
	}
}
#endif







