////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Poster
//
// SK7PanelPoster.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELPOSTER_H__
#define	__SK7PANELPOSTER_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"



typedef struct {
	u32 	MessageID;		//	bZ[WIDԍ
	u8 		MesNum;			//	bZ[W
	u8		MesNo;			//	bZ[Wio[
}MESSAGE_PARAM;


//---- class ----
class SK7PanelPoster : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_SELECT_MAIN,
		PROC_CHECK_MESSAGE,
		PROC_STOP_MESSAGE,
		PROC_CANCEL,
	}eFrameProc;
	
	//	eNX`ǂݍ
	typedef enum
	{
		LOAD_BG=0,
	}eLoadTexProc;

protected:
	eFrameProc				m_Proc;
	eLoadTexProc			m_TexProc;
	
	SK7Sprite				m_spBG;					//	wi
	MESSAGE_PARAM			m_Message;
	
	char*					m_pFileName;
	u8						m_ucMessageNum;
	
	int						m_iPosterNo;

	s8 						m_cJmbHandle;
	EFFECT*					m_pEffect;


public:
	SK7PanelPoster( s32 PosterID, s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelPoster();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELPOSTER_H__
