////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel PsychoTest
//
// SK7PanelPsychoTest.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELPSYCHOTEST_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelPsychoTest.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

#define		PSYCHO_PACK_DATA		"/Texture/panel/020301.pak"

#define		SWITCH_POS_X		(200)
const int	tblSwitchPosX[]={
	200,
	200,
	200,
	200,
	206,
	200,
	200,
};

const int	tblSwitchPosY[]=
{
	189,256,323,
	230,297,364,
	230,297,364,
	230,297,364,
	237,304,371,
	230,297,364,
	230,297,364,
};

#define		SWITCH_HALF_X		(45)
#define		SWITCH_HALF_Y		(50)//40)
#define		QNO_MAX				(7)
#define		WHITE_OUT_TIME		(35)
#define		WHITE_IN_TIME		(35)
#define		WHITE_OUT_TIME2		(65)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelPsychoTest::SK7PanelPsychoTest( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){ tblSwitchPosX[0]+SWITCH_HALF_X ,tblSwitchPosY[0]+SWITCH_HALF_Y,0});

	m_chSelect		= 0;
	m_chQNo			= 0;
	m_sNowAnswer 	= (s8)Now;
	m_bAnswer		= true;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	
	m_spWhite.SetSprite	( 0, 0, 640, 480, 0xffffffff );
	m_spWhite.SetVisible( true );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelPsychoTest::~SK7PanelPsychoTest()
{ 
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelPsychoTest::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_WHITE_IN;
		}
		break;


	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = 2;
			}
			SetCursolPosition( &(Vec){ tblSwitchPosX[m_chQNo]+SWITCH_HALF_X ,tblSwitchPosY[m_chSelect+3*m_chQNo]+SWITCH_HALF_Y,0});
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );			
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( ++m_chSelect > 2 ){
				m_chSelect =  0;
			}
			SetCursolPosition( &(Vec){ tblSwitchPosX[m_chQNo]+SWITCH_HALF_X ,tblSwitchPosY[m_chSelect+3*m_chQNo]+SWITCH_HALF_Y,0});
			gpSound->mPlaySE( SFX_SYS_PNL_MOV_CURSOL );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			m_spSwitch.SetVisible( true );
			m_spSwitch.SetXY0( tblSwitchPosX[m_chQNo], tblSwitchPosY[m_chSelect+3*m_chQNo] );
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_sNowAnswer = TEST_MISS_ANS;
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	//	zCgAEgC	=========================================
	case	PROC_WHITE_OUT:
		if( m_chQNo >= QNO_MAX ){
			if( m_spWhite.AddAlpha( WHITE_OUT_TIME2 ) ){
				m_Proc = PROC_CANCEL;
			}
		}else{
			if( m_spWhite.AddAlpha( WHITE_OUT_TIME ) ){
				m_chSelect = 0;
				m_spSwitch.SetVisible( false );
				m_spBG.SetTexture( &m_pTexture[ TEX_020301_Q1 + m_chQNo ]);
				SetCursolPosition( &(Vec){ tblSwitchPosX[m_chQNo]+SWITCH_HALF_X ,tblSwitchPosY[m_chSelect+3*m_chQNo]+SWITCH_HALF_Y,0});
				m_Proc = PROC_WHITE_IN;
			}
		}
		break;
		
	case 	PROC_WHITE_IN:
		if( m_spWhite.DownAlpha( WHITE_IN_TIME ) ){
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer( -1, true ) )
		{
		case	PANEL_CHECK_RETURN:
			m_spSwitch.SetVisible( false );
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			const u8 tblAnswerNo[]={0,1,2,1,0,2,2};
			
			gpSound->mPlaySE( SFX_SYS_PNL_OK );
			if( m_chSelect != tblAnswerNo[m_chQNo] ){
				m_bAnswer = false;
			}
			m_chQNo++;
			if( m_chQNo >= QNO_MAX ){
				if( m_bAnswer ){
					m_sNowAnswer = TEST_CURRENT_ANS;
				}else{
					m_sNowAnswer = TEST_MISS_ANS;
				}
				SetCursolDisp( false );
				m_Proc = PROC_WHITE_OUT;//PROC_CANCEL;
			}else{
				SetCursolDisp( false );
				m_Proc = PROC_WHITE_OUT;//PROC_SELECT_MAIN;
			}
			break;
		}
		break;
			
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelPsychoTest::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	m_spSwitch.Render();
	
	m_spWhite.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelPsychoTest::mGetFileReadEnd(void)
{
	if( m_Proc >= PROC_SELECT_MAIN )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelPsychoTest::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelPsychoTest::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelPsychoTest::LoadTexData()
{
	if( LoadPackData( PSYCHO_PACK_DATA, TEX_020301_MAX )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_020301_Q1] );
		m_spBG.SetVisible	( true );
		
		m_spSwitch.SetTexSprite	( tblSwitchPosX[0], tblSwitchPosY[0], &m_pTexture[TEX_020301_LGT] );
		m_spSwitch.SetVisible	( false );
		
		return true;
	}
	return false;
}