////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Roulette
//
// SK7PanelRoulette.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELROULETTE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelRoulette.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"



const VEC2 tblRoulettePos[]={
	52,		213,
	75,		211,
	103,	211,
	128,	219,
	153,	228,
	177,	241,
	196,	259,
	213,	278,
	229,	300,
	235,	326,
	242,	351,
	242,	377,
	241,	403,
	235,	428,
};


//========================================================================
//					RXgN^
//========================================================================
SK7PanelRoulette::SK7PanelRoulette( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= ROULETTE_KEY_NONE;
	m_chSelect	= (s8)0;

	SetCursolPosition( &(Vec){tblRoulettePos[m_chSelect].x+BALL_SIZE*0.5f,tblRoulettePos[m_chSelect].y+BALL_SIZE*0.5f,0} );
	SetCursolDir( CURSOL_DIR_RIGHT );
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	for( int i = 0; i < ROULETTE_ANSWER_NUM; i++ ){
		m_spBall[i].SetXY0(tblRoulettePos[i].x, tblRoulettePos[i].y );
		m_spBall[i].SetFlag( true, BLOCK_FLAG );
		m_spBall[i].SetVisible(false);
		m_spBall[i].SetTexNo((u8)i);
	}
	m_spBall[0].SetVisible(true);
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelRoulette::~SK7PanelRoulette()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	for( int i = 0; i < ROULETTE_ANSWER_NUM; i++ ){
		m_spBall[i].Delete();
	}	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelRoulette::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			SetCursolDisp( true );
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ))
		{
			if( --m_chSelect < 0 ){
				m_chSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){tblRoulettePos[m_chSelect].x+BALL_SIZE*0.5f,tblRoulettePos[m_chSelect].y+BALL_SIZE*0.5f,0} );	
			m_spBall[m_chSelect].SetVisible(true);
			m_spBall[m_chSelect+1].SetVisible(false);
			SetCursolDir(CURSOL_DIR_UP, 1);
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			if( ++m_chSelect > ROULETTE_ANSWER_NUM-1 ){
				m_chSelect = ROULETTE_ANSWER_NUM-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &(Vec){tblRoulettePos[m_chSelect].x+BALL_SIZE*0.5f,tblRoulettePos[m_chSelect].y+BALL_SIZE*0.5f,0} );	
			m_spBall[m_chSelect].SetVisible(true);
			m_spBall[m_chSelect-1].SetVisible(false);
			SetCursolDir(CURSOL_DIR_DOWN,1);
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE(SFX_SYS_DECIDE);
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_sNowAnswer = ROULETTE_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			if( m_chSelect == ANSWER_13 ){
				m_sNowAnswer = ROULETTE_KEY_GET;
				m_Proc = PROC_MESSAGE;
				break;
			}
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_CANCEL;
		}
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	if( m_chSelect == 0 )							SetCursolDir( CURSOL_DIR_DOWN, 0 );
	else if( m_chSelect == ROULETTE_ANSWER_NUM-1) 	SetCursolDir( CURSOL_DIR_UP, 0 );
	else											SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN, 0 );
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelRoulette::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i <ROULETTE_ANSWER_NUM; i++ ){
		m_spBall[i].Render();
	}
	
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelRoulette::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelRoulette::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelRoulette::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelRoulette::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL011503TEX_BG ) )
		{
			m_TexProc = LOAD_BALL;
		}
		break;

	case LOAD_BALL:
		if( m_spBall[0].LoadTexture( PNL011503TEX_BALL, ROULETTE_ANSWER_NUM, 1 ) )
		{
			for( int i = 1; i < ROULETTE_ANSWER_NUM; i++ ){
				m_spBall[i].SetTexture( m_spBall[0].GetTexture(), ROULETTE_ANSWER_NUM, 1 );
			}
			return true;
		}
	 	break;
	}
	return false;
}