////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Nine
//
// SK7PanelSecom.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELSECOM_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelSecom.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"

Vec tblSwitchPos[]=
{
	320, 230, 0,
	320, 274, 0, 
};

//========================================================================
//					RXgN^
//========================================================================
SK7PanelSecom::SK7PanelSecom( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	m_sNowAnswer	= Now;
	m_chSelect	= (s8)((Now==SECOM_OFF) ? SWITCH_OFF : SWITCH_ON);
	
	switch( Now ){
	case SWITCH_OFF:		m_chSelect = SWITCH_ON;			break;
	case SWITCH_ON:			m_chSelect = SWITCH_OFF;		break;
	case SWITCH_POSTER_OFF:	m_chSelect = SWITCH_POSTER_ON;	break;
	case SWITCH_POSTER_ON:	m_chSelect = SWITCH_POSTER_OFF;	break;
	}
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
		
	m_spSwitch[SWITCH_ON].SetXY0	( 256, 214 );
	m_spSwitch[SWITCH_OFF].SetXY0	( 256, 258 );	
	m_spLamp[SWITCH_ON].SetXY0		( 419, 151 );
	m_spLamp[SWITCH_OFF].SetXY0		( 393, 151 );

	m_spLamp[SWITCH_ON].SetTexNo	( SWITCH_ON );
	m_spLamp[SWITCH_OFF].SetTexNo	( SWITCH_OFF );
	m_spSwitch[SWITCH_ON].SetTexNo	( SWITCH_ON );
	m_spSwitch[SWITCH_OFF].SetTexNo	( SWITCH_OFF );	
	m_spLamp[SWITCH_ON].SetFlag		( true, BLOCK_FLAG );
	m_spLamp[SWITCH_OFF].SetFlag	( true, BLOCK_FLAG );
	m_spSwitch[SWITCH_ON].SetFlag	( true, BLOCK_FLAG );
	m_spSwitch[SWITCH_OFF].SetFlag	( true, BLOCK_FLAG );	
	
	if( m_chSelect == SWITCH_OFF ||  m_chSelect == SWITCH_POSTER_OFF ){
		m_spLamp[SWITCH_OFF].SetVisible		(true);
		m_spLamp[SWITCH_ON].SetVisible		(false);
		m_spSwitch[SWITCH_OFF].SetVisible	(true);	
		m_spSwitch[SWITCH_ON].SetVisible	(false);
		SetCursolDir( CURSOL_DIR_UP );
	}else
	if( m_chSelect == SWITCH_ON || m_chSelect == SWITCH_POSTER_ON ){
		m_spLamp[SWITCH_OFF].SetVisible		(false);
		m_spLamp[SWITCH_ON].SetVisible		(true);
		m_spSwitch[SWITCH_OFF].SetVisible	(false);	
		m_spSwitch[SWITCH_ON].SetVisible	(true);
		SetCursolDir( CURSOL_DIR_DOWN );
	}
	SetCursolPosition( &tblSwitchPos[m_chSelect] );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelSecom::~SK7PanelSecom()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	m_spLamp[0].Delete();
	m_spSwitch[0].Delete();
	
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelSecom::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			if( m_sNowAnswer == SECOM_MESSAGE ){
				SetCursolDisp( false );
				m_chSelect = 2;
				m_Proc = PROC_MESSAGE;
				break;
			}
			if( m_chSelect == SWITCH_OFF || m_chSelect == SWITCH_ON ){
				SetCursolDisp( true );
				m_Proc = PROC_SELECT_MAIN;
			}else{
				SetCursolDisp( false );
				m_Proc = PROC_END;
			}	
		}
		break;

	//	I	=====================================================
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblSwitchPos[m_chSelect] );
			SetCursolDir( CURSOL_DIR_UP, 1 );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN )){
			if( ++m_chSelect > 1 ){
				m_chSelect = 1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblSwitchPos[m_chSelect] );
			SetCursolDir( CURSOL_DIR_DOWN, 1 );
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			SetCursolDisp( false );
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			m_Proc = PROC_CANCEL;
			break;
		}		
		break;

	//	`FbN	=============================================
	case	PROC_CHECK:
		switch( CheckAnswer() )
		{
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			SetCursolDisp( false );
			m_sNowAnswer = (s32)((m_chSelect==0) ? 1 : 0);
			if( m_chSelect == SWITCH_OFF ){
				gpSound->mPlaySE( SFX_SCE3_SECURITY_DEACTIVATED );
				m_spLamp[SWITCH_OFF].SetVisible		(true);
				m_spLamp[SWITCH_ON].SetVisible		(false);
				m_spSwitch[SWITCH_OFF].SetVisible	(true);	
				m_spSwitch[SWITCH_ON].SetVisible	(false);
			}else{
				gpSound->mPlaySE( SFX_SCE3_SECURITY_ACTIVATED );
				m_spLamp[SWITCH_OFF].SetVisible		(false);
				m_spLamp[SWITCH_ON].SetVisible		(true);
				m_spSwitch[SWITCH_OFF].SetVisible	(false);	
				m_spSwitch[SWITCH_ON].SetVisible	(true);
			}
			m_Proc = PROC_MESSAGE;
			break;
		}
		break;
		
	//	bZ[W	
	case	PROC_MESSAGE:
		if( DrawMessage(m_chSelect) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	|X^[
	case	PROC_END:
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			m_Proc = PROC_CANCEL;
		}
		break;
		
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	if( m_chSelect == SWITCH_ON )	SetCursolDir( CURSOL_DIR_DOWN,0 );
	else							SetCursolDir( CURSOL_DIR_UP,0 );	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelSecom::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
		
	
	for( int i = 0; i < 2; i++ ){
		m_spLamp[i].Render();
		m_spSwitch[i].Render();
	}
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelSecom::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelSecom::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelSecom::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			break;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelSecom::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL035005TEX_BG ) ){
			m_TexProc = LOAD_SWITCH;
		}
		break;
	case 	LOAD_SWITCH:	//	XCb`
		if( m_spSwitch[0].LoadTexture( PNL035005TEX_SWITCH, 1, 2 ) ){
			m_spSwitch[1].SetTexture( m_spSwitch[0].GetTexture(), 1, 2, 1 );
			m_TexProc = LOAD_LAMP;
		}
		break;
	case 	LOAD_LAMP:	//	v
		if( m_spLamp[0].LoadTexture( PNL035005TEX_LAMP, 2, 1  ) ){
			m_spLamp[1].SetTexture( m_spLamp[0].GetTexture(), 2, 1, 1 );
			return true;
		}
		break;
	}
	return false;
}