////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Cho
//
// SK7PanelSecurity.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 11/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELSECURITY_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelSecurity.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"

#define		NO_SIZE_X			(38) 
#define		NO_SIZE_Y			(73)
#define		NO_SIZE_GAP_Y		(4)
#define		NO_MOVE_FRAME		(5)
#define		NO_ANSWER_Y			(195)

const f32 tblAnswerX[]={
	241.0f,
	297.0f,
	353.0f,
	409.0f,
	465.0f,
};

const u8 tblAnswerNo1[]={ 9,1,0,0,7, };//5,5,5,4,9, };
const u8 tblAnswerNo2[]={ 1,5,0,2,0, };//7,2,7,1,2, };

#define		SECURITY_PACK_DATA		"/Texture/panel/055700.pak"

//========================================================================
//					RXgN^
//========================================================================
SK7PanelSecurity::SK7PanelSecurity( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------	
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	SetCursolPosition( &(Vec){ tblAnswerX[0]+NO_SIZE_X*0.5f, NO_ANSWER_Y+NO_SIZE_Y*0.5f, 0} );

	m_bAnswerFlag1 	= false;
	m_bAnswerFlag2	= false;
	m_bFirstCheck	= false;
	m_bKeyState = false;
	m_cSelect	= 0;
	m_iMoveTime	= 0;
	
	//	ԈĂ
	m_sNowAnswer	= SECURITY_MISS;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelSecurity::~SK7PanelSecurity()
{ 
	//eNX`	-----------------------------

}


//========================================================================
// t[
//========================================================================
s16			SK7PanelSecurity::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_MESSAGE;
		}
		break;
#if 1
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
#endif

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			gpSound->mPlaySE( SFX_SYS_DECIDE );
			m_Proc = PROC_CHECK;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			m_sNowAnswer = SECURITY_CANCEL;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_UPDOWN);
			SetCursolDir( CURSOL_DIR_UP );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = true;
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_UPDOWN);
			SetCursolDir( CURSOL_DIR_DOWN );
			m_Proc = PROC_MOVE_NO;
			m_bKeyState = false;
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( --m_cSelect < 0 ){
				m_cSelect = 0;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0( tblAnswerX[m_cSelect], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0( tblAnswerX[m_cSelect], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){tblAnswerX[m_cSelect]+NO_SIZE_X*0.5f,NO_ANSWER_Y+NO_SIZE_Y*0.5f,0});
			SetCursolDir( CURSOL_DIR_LEFT );			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( ++m_cSelect >= SCE_NO_MAX ){
				m_cSelect = SCE_NO_MAX-1;
				break;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			s8 no = (s8)m_spNo[m_cSelect].GetTexNo();
			s8 no1 = (s8)(no+1), no2 = (s8)(no-1);
			if( no1 > 9 )  	(s8)no1 = 0;
			if( no2 < 0 )	(s8)no2 = 9;
			m_spNoPlus1.SetXY0( tblAnswerX[m_cSelect], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo( (u8)no1 );
			m_spNoPlus2.SetXY0( tblAnswerX[m_cSelect], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo( (u8)no2 );
			SetCursolPosition(&(Vec){tblAnswerX[m_cSelect]+NO_SIZE_X*0.5f,NO_ANSWER_Y+NO_SIZE_Y*0.5f,0});
			SetCursolDir( CURSOL_DIR_RIGHT );
			break;
		}
		break;

	//	io[ړ
	case 	PROC_MOVE_NO:
		if( MoveNo( m_bKeyState, m_cSelect ) )
		{
			m_Proc = PROC_SELECT_MAIN;
		}
		break;
		
	//	`FbNp	----------------------------------------------
	case 	PROC_CHECK:		
		int ans;
		if( !m_bFirstCheck ){
			ans = CheckAnswer(-1, true);
		}else{
			ans = CheckAnswer();
		}
		switch( ans )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//			
			bool Answer=true;
			int i;

			if( m_bAnswerFlag1 == false ){
				for( i = 0; i < SCE_NO_MAX; i++ ){
					if( m_spNo[i].GetTexNo() != tblAnswerNo1[i] ){
						Answer = false;
					}
				}
				if( Answer )	m_bAnswerFlag1 = true;
			}
			Answer = true;
			if( m_bAnswerFlag2 == false ){
				for( i = 0; i < SCE_NO_MAX; i++ ){
					if( m_spNo[i].GetTexNo() != tblAnswerNo2[i] ){
						Answer = false;
					}
				}
				if( Answer )	m_bAnswerFlag2 = true;
			}
			//	ڂ̂Ƃ	==========================================
			if( m_bFirstCheck == false ){
				if( m_bAnswerFlag1 == true || m_bAnswerFlag2 == true ){
					//	io[XvCg	------------------------------------------
					for( int i = 0; i < SCE_NO_MAX; i++ ){
						m_spNo[i].SetTexSprite( tblAnswerX[i], NO_ANSWER_Y, &m_pTexture[TEX_055700_NO2], 5, 2, 0 );
					}
					//	܂͂ɂ炷
					m_spNoPlus1.SetTexSprite( tblAnswerX[0], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y, &m_pTexture[TEX_055700_NO2], 5, 2, 1 );
					//	
					m_spNoPlus2.SetTexSprite( tblAnswerX[0], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y, &m_pTexture[TEX_055700_NO2], 5, 2, 9 );
					m_cSelect = 0;
					SetCursolPosition(&(Vec){tblAnswerX[0]+NO_SIZE_X*0.5f,NO_ANSWER_Y+NO_SIZE_Y*0.5f,0});
					m_bFirstCheck = true;	
					SetCursolDisp( true );
					gpSound->mPlaySE( SFX_SYS_PNL_OK );
					m_Proc = PROC_TIME;
				}else{
					SetCursolDisp( false );
					gpSound->mPlaySE(SFX_SYS_PNL_MISS);
					m_Proc = PROC_CANCEL;
				}
			//	2ڂ̂Ƃ	===============================================
			}else{
				SetCursolDisp( false );
				if( m_bAnswerFlag1 == true && m_bAnswerFlag2 == true ){
					m_sNowAnswer	= SECURITY_CLEAR;
//					gpSound->mPlaySE( SFX_SYS_PNL_OK );
					m_Proc = PROC_CANCEL;
					
				}else{
					SetCursolDisp( false );
					gpSound->mPlaySE(SFX_SYS_PNL_MISS);
					m_Proc = PROC_CANCEL;
				}
			}
			break;
		}
		break;
#if 1
	case	PROC_TIME:
		if( DrawMessage(1) )
		{
			m_Proc = PROC_SELECT_MAIN;//PROC_CANCEL;
		}
#endif
		break;

	//	LZ
	case	PROC_CANCEL:
		break;
	}
	if( m_cSelect == 0 )					SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else if( m_cSelect == SCE_NO_MAX-1 )	SetCursolDir( CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	else									SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_DOWN|CURSOL_DIR_UP,0 );
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelSecurity::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	m_spBG.Render();					//	wi

	GXSetScissor( 238, 195, (u32)400, (u32)73 );
	m_spNoPlus1.Render();
	GXSetScissor( 238, 195, (u32)400, (u32)73 );
	m_spNoPlus2.Render();

	GXSetScissor( 238, 195, (u32)400, (u32)73 );
	for( int i = 0; i < SCE_NO_MAX; i++ ){
		m_spNo[i].Render();
	}

	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelSecurity::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelSecurity::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true)
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelSecurity::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}

	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}

	return( PANEL_OPERATE_CANCEL );
}

//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelSecurity::MoveNo(bool state, s8 select)
{
	f32 vSpeedY	= (NO_SIZE_Y+NO_SIZE_GAP_Y)/NO_MOVE_FRAME;
	
	//	Ƃ	
	if( state )		vSpeedY = -vSpeedY;
	
	m_spNo[select].SetXY0	( m_spNo[select].GetX0(), 	m_spNo[select].GetY0()	+ vSpeedY	);
	m_spNoPlus1.SetXY0		( m_spNoPlus1.GetX0(), 		m_spNoPlus1.GetY0() 	+ vSpeedY	);
	m_spNoPlus2.SetXY0		( m_spNoPlus2.GetX0(), 		m_spNoPlus2.GetY0() 	+ vSpeedY	);

	//	ԉZ
	if( ++m_iMoveTime >= NO_MOVE_FRAME ){
		s8 no0 = (s8)m_spNo[select].GetTexNo();
		s8 no1 = (s8)m_spNoPlus1.GetTexNo();
		s8 no2 = (s8)m_spNoPlus2.GetTexNo();
		
		//	ւ
		if( state ){
			if( ++no0 	>= 10 )	no0 = 0;
			if( ++no1 	>= 10 )	no1	= 0;
			if( ++no2	>= 10 )	no2 = 0;

			m_spNo[select].SetXY0	( tblAnswerX[select], NO_ANSWER_Y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( tblAnswerX[select], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( tblAnswerX[select], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}else{
			if( --no0 	< 0 )	no0 = 9;
			if( --no1 	< 0 )	no1	= 9;
			if( --no2	< 0 )	no2 = 9;

			m_spNo[select].SetXY0	( tblAnswerX[select], NO_ANSWER_Y ); 
			m_spNo[select].SetTexNo	( (u8)no0 );
			m_spNoPlus1.SetXY0		( tblAnswerX[select], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y );
			m_spNoPlus1.SetTexNo	( (u8)no1 );
			m_spNoPlus2.SetXY0		( tblAnswerX[select], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y );
			m_spNoPlus2.SetTexNo	( (u8)no2 );
		}
		m_iMoveTime = 0;
		return true;
	}
	
	return false;
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelSecurity::LoadTexData()
{
	if( LoadPackData( SECURITY_PACK_DATA, TEX_055700_MAX )){
		m_spBG.SetTexSprite	( 0, 0, &m_pTexture[TEX_055700_BG] );		
		m_spBG.SetVisible(true);
		for( int i = 0; i < SCE_NO_MAX; i++ ){
			m_spNo[i].SetTexSprite( tblAnswerX[i], NO_ANSWER_Y, &m_pTexture[TEX_055700_NO], 5, 2, 0 );
			m_spNo[i].SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
		}
		m_spNoPlus1.SetTexSprite( tblAnswerX[0], NO_ANSWER_Y + NO_SIZE_Y + NO_SIZE_GAP_Y, &m_pTexture[TEX_055700_NO], 5, 2, 1 );
		m_spNoPlus1.SetFlag		( true, RENDER_FLAG|BLOCK_FLAG );
		m_spNoPlus2.SetTexSprite( tblAnswerX[0], NO_ANSWER_Y - NO_SIZE_Y - NO_SIZE_GAP_Y, &m_pTexture[TEX_055700_NO], 5, 2, 9 );
		m_spNoPlus2.SetFlag		( true, RENDER_FLAG|BLOCK_FLAG );
		return true;
	}
	return false;
}