////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Sofa
//
// SK7PanelSofa.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELSOFA_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelSofa.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage.h"


const VEC2 tblNoPos[]=
{
	282.0f,130.0f,
	325.0f,130.0f,
};

Vec	tblSelectPos[]=
{
	298.0f, 162.0f, 0.0f,
	342.0f, 162.0f, 0.0f,
	319.0f,	256.0f,	0.0f,
};

#define		NO_SIZE_X			(32) 
#define		NO_SIZE_Y			(64)
#define		NO_SIZE_GAP_Y		(4)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelSofa::SK7PanelSofa( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &tblSelectPos[0] );
	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN );
	
	m_sNowAnswer 	= SOFA_MISS;
	m_cSelect 		= 0;
	m_cNoSelect[0]	= 0;
	m_cNoSelect[1]	= 0;
	
	//	10̌
	m_cAnswer[0] = (s8)(Now/10);
	//	1̌
	m_cAnswer[1] = (s8)(Now%10);
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	for( int i = 0; i < 2; i++ ){
		m_spNo[i].SetXY0( tblNoPos[i].x, tblNoPos[i].y );
		m_spNo[i].SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
		m_spNo[i].SetTexNo((u8)0 );
	}

	//	G^[
	m_spEnter.SetXY0( 288.0f, 240.0f );
	m_spEnter.SetVisible(false);
	
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelSofa::~SK7PanelSofa()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();

	m_spNo[0].Delete();
	m_spEnter.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelSofa::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			SetCursolDisp( true );
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_MESSAGE;
		}
		break;
		
	case PROC_MESSAGE:
		if( DrawMessage(0) ){
			m_Proc = PROC_SELECT_MAIN;
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;

		if( HSD_PadGetTrigger(0) & HSD_PAD_A )
		{
			if( m_cSelect == 2 ){
				gpSound->mPlaySE( SFX_SYS_DECIDE );
				m_spEnter.SetVisible(true);	
				m_Proc = PROC_CHECK;
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B )
		{
			gpSound->mPlaySE( SFX_SYS_CANCEL );
			SetCursolDisp( false );
			m_sNowAnswer = SOFA_CANCEL;
			m_Proc = PROC_CANCEL;
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) )
		{
			if( --m_cSelect < 0 ){
				m_cSelect = 2;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblSelectPos[m_cSelect] );	
			SetCursolDir( CURSOL_DIR_LEFT );
			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) )
		{
			if( ++m_cSelect > 2 ){
				m_cSelect = 0;
			}
			gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
			SetCursolPosition( &tblSelectPos[m_cSelect] );
			SetCursolDir( CURSOL_DIR_RIGHT );
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) )
		{
			if( --m_cNoSelect[m_cSelect] < 0 ){
				m_cNoSelect[m_cSelect] = 9;
			}
			gpSound->mPlaySE( SFX_SCE3_PNL_SOFA_INPUT );
			m_spNo[m_cSelect].SetTexNo((u8)m_cNoSelect[m_cSelect] );
			SetCursolDir( CURSOL_DIR_UP );
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) )
		{
			if( ++m_cNoSelect[m_cSelect] > 9 ){
				m_cNoSelect[m_cSelect] = 0;
			}
			gpSound->mPlaySE( SFX_SCE3_PNL_SOFA_INPUT );
			m_spNo[m_cSelect].SetTexNo((u8)m_cNoSelect[m_cSelect] );			
			SetCursolDir( CURSOL_DIR_DOWN );
			break;
		}
		break;
		
	//	`FbNp	----------------------------------------------
	case 	PROC_CHECK:		
		switch( CheckAnswer() )
		{		
		case	PANEL_CHECK_RETURN:				//߂
			m_Proc = PROC_SELECT_MAIN;	
			break;
		
		case	PANEL_CHECK_SET:				//
#if 0
			if( m_spNo[0].GetTexNo() == m_cAnswer[0] && m_spNo[1].GetTexNo() == m_cAnswer[1] ) 
			{
				m_pEffect = CreateMessageEffect( m_cJmbHandle, PNLMES_CLEAR );
			}
			else
			{
				m_pEffect = CreateMessageEffect( m_cJmbHandle, PNLMES_MISS );
			}
#endif
			m_sNowAnswer = SOFA_CLEAR;
			m_Proc = PROC_TIME;
			break;
		}
		break;
		
	case	PROC_TIME:
		if( !GetEffectValidState( m_pEffect ))
		{
			m_Proc = PROC_CANCEL;
		}
		break;
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	if( m_cSelect < 2 )	SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT|CURSOL_DIR_UP|CURSOL_DIR_DOWN,0 );
	else				SetCursolDir( CURSOL_DIR_RIGHT|CURSOL_DIR_LEFT,0 );
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelSofa::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	for( int i = 0; i < 2; i++ ){
		m_spNo[i].Render();
	}
	
	m_spEnter.Render();
	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelSofa::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelSofa::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelSofa::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return (s32)m_sNowAnswer;
			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelSofa::LoadTexData()
{
	switch( m_TexProc )
	{
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL030901TEX_BG )){
			m_TexProc = LOAD_NO;
		}
		break;
	case 	LOAD_NO:	//	wi
		if( m_spNo[0].LoadTexture( PNL030901TEX_NO, 8, 2 )){
			m_spNo[1].SetTexture( m_spNo[0].GetTexture(), 8, 2 );
			m_TexProc = LOAD_ENTER;
		}
		break;
	case 	LOAD_ENTER:	//	wi
		if( m_spEnter.LoadTexture( PNL030901TEX_ENTER )){
			return true;
		}
		break;
	}
	return false;
}