////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Sofa
//
// SK7PanelSofa.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 12/05/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELSOFA_H__
#define	__SK7PANELSOFA_H__

#include "../Lib/ghmGcAppTask.h"
#include "../Lib/ghmGcMem.h"

#include "SK7PanelBase.h"
#include "SK7Sprite.h"


//	wuX}C̏oĂĂi̐j

//	Ԃ
#define	SOFA_CLEAR				(1)		//	NA
#define	SOFA_CANCEL				(0)		//	LZ
#define	SOFA_MISS				(-1)	//	~X


//	eNX`[pX
#define	PNL030901TEX_BG			"Texture/030901/EVENT_030901.BIN"
#define	PNL030901TEX_NO			"Texture/030901/NO.BIN"
#define	PNL030901TEX_ENTER		"Texture/030901/ENTER.BIN"


//---- class ----
class SK7PanelSofa : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_MESSAGE,
		PROC_SELECT_MAIN,
		PROC_CHECK,
		PROC_TIME,
		PROC_CANCEL,
	}eInputCodeProc;
	
	//	eNX`ǂݍ
	typedef enum
	{	
		LOAD_BG,
		LOAD_ENTER,
		LOAD_NO,
	}eLoadTexProc;

protected:
	eInputCodeProc			m_Proc;
	eLoadTexProc			m_TexProc;
	s8						m_cSelect;
	s8						m_cNoSelect[2];
	s8 						m_cJmbHandle;
	s8						m_cAnswer[2];
	EFFECT*					m_pEffect;
	
	SK7Sprite				m_spBG;					//	wi
	SK7Sprite				m_spNo[2];
	SK7Sprite				m_spEnter;

public:
	SK7PanelSofa( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelSofa();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();
	
};

#endif	//__SK7PANELSOFA_H__
