////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelStaff1.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELSTAFF1_CPP__

#include "SK7PanelStaff1.h"
#include "../matsu/mK7Sound.h"
#include "../fujita/c_font.h"
#include "..\Matsu\mK7Jimaku.h"


#define	STAFFROLL1_BIN		"/Texture/panel/059000.pak"
#define	KAN_TIME			(80)//165)
#define	BLACK_TIME			(288)
#define	CENTER_GAP_SIZE		(10)
#define	FONT_LEFT_SIZE		(-6)
#define	FONT_RIGHT_SIZE		(-3)
#define	FONT_MOVE_SPEED		(-1.9925f)//1.865f)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelStaff1::SK7PanelStaff1( s32 Now ) : SK7PanelBase( Now, -1, false, true  )
{	
	m_eProc 	= eLoad;
	m_eLoad		= eLFont;
	m_fSpeed	= FONT_MOVE_SPEED;
	m_iTime		= 0;

	SetCursolDisp( false );
	k7app.SetFadeColor(0x00000000);
	k7app.FadeStart(0x00,0);

	m_spBlack.SetSprite( 0,0,640,480,0x000000ff );
	m_spBlack.SetVisible( true );

	m_spFade.SetSprite( 0,0,640,480,0x00000000 );
	m_spFade.SetVisible( true );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelStaff1::~SK7PanelStaff1()
{
	m_spBG.Delete();
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelStaff1::FrameProcess(void)
{
	if( !m_bCtrl && m_eProc > eLoad )		return 0;
	switch( m_eProc ){
	//	f[^[h	----------------------------------------
	case	eLoad:
		if( Load() ){
			m_iTime = 0;
			m_eProc = eFade;
		}
		break;
		
	case 	eFade:
		if( ++m_iTime > BLACK_TIME ){
			m_iTime = 0;
			m_eProc = eMain;
		}
		break;

	//	staff[	----------------------------------------
	case eMain:
		if( Move() ){
			m_eProc = eFadeMain;
		}
		break;
		
	case eFadeMain:
		if( ++m_iTime > 30 ){
			if( m_spFade.AddAlpha( 90 ) ){
				m_iTime = 0;
				m_spBG.SetVisible( true );
				m_eProc = eFadeMain2;		
			}
		}
		break;
		
	case eFadeMain2:
		if( ++m_iTime > 60 ){
			if( m_spFade.DownAlpha( 60 ) ){
				m_iTime = 0;
				m_eProc = eKan;
			}
		}
		break;
		
	case eKan:
		if( ++m_iTime > KAN_TIME ){
			m_iTime = 0;
			m_eProc = eFade2;
		}
		break;
		
	case eFade2:
		if( m_spFade.AddAlpha( KAN_TIME ) ){
			m_spBG.SetVisible( false );
			m_spFade.SetVisible( false );
			m_eProc = eEnd;
		}
		break;
		
	
	//	LZ
	case	eEnd:
		break;
	}
#ifndef K7APP_MASTER
	if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT )	m_fSpeed +=0.1f;
	if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT )	m_fSpeed -=0.1f;
#endif

	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelStaff1::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	m_spBlack.Render();
	
	for( int i = 0; i < STAFF_TEX_NUM; i++ ){
		m_spStaff[i].Render();
	}
	m_spBG.Render();
	
	m_spFade.Render();

#ifndef K7APP_MASTER
	C_Paper paper2( 10, 80, 15, true, 200, 50 );
	PRINTF("Speed-> %f", m_fSpeed );
#endif

	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelStaff1::mGetFileReadEnd(void)
{
	if( m_eProc > eLoad ){
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelStaff1::mGetSelectEnd(void)
{
	if( (m_eProc == eEnd) ){
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelStaff1::mGetResult(void)
{
	if( mGetSelectEnd() == false ){
		return( PANEL_WORKING );
	}

	switch( m_Proc ){
	case	eEnd:
		return (s32)m_sNowAnswer;
		
	default:
		break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelStaff1::Load()
{
	switch( m_eLoad ){
	case eLFont:
		if( LoadPackData( STAFFROLL1_BIN, STAFF_TEX_NUM )){
			for( int i = 0; i < STAFF_TEX_NUM; i++ ){
				m_spStaff[i].SetTexSprite( 0, 480 + i * 480, &m_pTexture[i] );
				m_spStaff[i].SetFlag( true, RENDER_FLAG|DITHER_FLAG );
			}
			m_eLoad = eLBG;
		}
		break;
			
	case eLBG:
		if( m_spBG.LoadTexture(	"/Texture/End/egao01.BIN" ) ){
 			m_spBG.SetXY0( 0, 0 );
 			m_spBG.SetVisible( false );
			return true;
		}
		break;	
	}	
	return false;
}

//========================================================================
//					
//========================================================================
bool	SK7PanelStaff1::Move()
{
	for( int i = 0; i < STAFF_TEX_NUM; i++ ){
		m_spStaff[i].SetIncY( m_fSpeed );
	}
	if( m_spStaff[STAFF_TEX_NUM-1].GetY0() <= 0 ){
		m_spStaff[STAFF_TEX_NUM-1].SetY0(0);
		return true;
	}
	return false;
}
