////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel 
//
// SK7PanelStaff2.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELSTAFF2_CPP__

#include "SK7PanelStaff2.h"
#include "../matsu/mK7Sound.h"
#include "../fujita/c_font.h"
#include "..\Matsu\mK7Jimaku.h"
#include "../yam/YK7EffectNoise.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7EventScript.h"
#include "../wat/K7GlobalFlag.h"


#define	DRAW_TIME			(180)
#define	FADE_TIME			(9600)
#define	STAFF2_PACK_FILE	"/Texture/panel/060001.pak"
#define	STAFF2_PACK_FILE2	"/Texture/panel/060002.pak"
#define	SHANHAI_FILE		"/Texture/panel/Shanghai100.BIN"

#define	DE2_NAME	(20)
#define	DE2_GAP		(25)

//========================================================================
//					RXgN^
//========================================================================
SK7PanelStaff2::SK7PanelStaff2( s32 Now ) : SK7PanelBase( Now, -1, false  )
{	
	m_eProc 	= eLoad;
	m_lSpeed	= FADE_TIME;
	m_iBlock	= 0;
	m_iTime		= 0;
	m_iLoad		= 0;
	m_iDrawTime = DRAW_TIME;
	m_pPack		= NULL;
	m_pPack		= new SK7PackData;
	m_bRenderNotFlag = false;

	SetCursolDisp( false );
	
	m_spBlack.SetSprite( 0,0,640,480,0x000000ff );
	m_spBlack.SetVisible( true );	
	
	m_spFade.SetSprite( 0,0,640,480, 0 );
	m_spFade.SetVisible( true );
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelStaff2::~SK7PanelStaff2()
{
	GHMGCMEM_SAFE_FREE( m_ShanhaiTex.Header );
	GHM_SAFE_DELETE( m_pPack );
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelStaff2::FrameProcess(void)
{	
	switch( m_eProc ){
	//	f[^[h	----------------------------------------
	case	eLoad:
		if( Load() ){
			gpSound->mStopSEAll();
			gpSound->mPlayStreamNo( HPS_2ND_STAFF_ROLL, 255 );
			m_eProc = eTime;
		}
		break;
		
	case eTime:
		if( ++m_iTime > 55 ){
			m_iTime = 0;
			m_eProc = eMain;
		}
		break;
		
	case eMain:	
		if( Move() ){
			if( m_iBlock == TEX_STAFF_13 ){
				m_eProc = eTime3;
				m_bRenderNotFlag = true;
				break;
			}
			if( m_iBlock == TEX_STAFF_14 ){
				m_eProc = eFade;
				break;
			}
			m_iBlock++;
		}
		break;
		
	case eTime3:
		if( ++m_iTime > 6 ){
			m_bRenderNotFlag = false;
			m_iTime = 0;
			m_iBlock++;
			m_eProc = eMain; 
		}
		break;
		
	case eFade:
#if 0
		m_iTime++;
		if( m_iTime == 10 ){
			m_spName.SetAlpha( 0 );
		}
		if( m_iTime > 60 ){
			m_spName.SetAlpha( 0 );
			m_iBlock++;
			m_iTime = 0;
			m_eProc = eShanhaiStart;
		}
#endif
		if( m_spFade.AddAlpha( 45 ) ){
			m_spFade.SetVisible( false );
			m_spName.SetAlpha( 0 );
			m_iBlock++;
			m_iTime = 0;
			m_eProc = eTime2;
		}
		break;
		
	case eTime2:
		if( ++m_iTime > 60 ){
			m_iTime = 0;
			m_eProc = eShanhaiStart;
		}
		break;
	
	case eShanhaiStart:
		if( m_spName.AddAlpha( 120 ) ){
			m_iTime = 0;
			m_eProc = eShanhai;
		}
		break;
		
	case eShanhai:
		if( ++m_iTime > 70 ){
			m_iTime = 0;
			m_eProc = eEnd;
		}
		break;

	//	LZ
	case	eEnd:
		break;
	}
#ifndef K7APP_MASTER
	if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT )	m_lSpeed +=480;
	if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT )	m_lSpeed -=480;
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP )		m_iDrawTime ++;
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN )	m_iDrawTime --;
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		gpSound->mStopStream();
		gpSound->mPlayStreamNo( HPS_2ND_STAFF_ROLL, 200 );
		m_iBlock	= 0;
		m_iTime		= 0;
		
		m_eProc = eTime;
	}
#endif

	return 0;
}

	
//========================================================================
// _O
//========================================================================
bool		SK7PanelStaff2::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	m_spBlack.Render();
	
	if( m_eProc >= eMain && !m_bRenderNotFlag ){
		if( m_iBlock <= TEX_STAFF_14 ){
			m_spName.SetTexSprite( 0, 0, &m_Texture[m_iBlock] ); 
		}else{
			m_spName.SetTexSprite( 0, 0, &m_ShanhaiTex ); 
		}	
		m_spName.SetVisible( true );
		m_spName.Render();
	}
	m_spFade.Render();
	
#ifndef K7APP_MASTER
	C_Paper paper( 10, 80, 15, true, 200, 50 );
	PRINTF("FADE-> %d", m_lSpeed );
	C_Paper paper2( 10, 30, 15, true, 200, 50 );
	PRINTF("DRAW-> %d",  m_iDrawTime );
#endif

	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelStaff2::mGetFileReadEnd(void)
{
	if( m_eProc > eLoad ){
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelStaff2::mGetSelectEnd(void)
{
	if( (m_eProc == eEnd) ){
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelStaff2::mGetResult(void)
{
	if( mGetSelectEnd() == false ){
		return( PANEL_WORKING );
	}

	switch( m_Proc ){
	case	eEnd:
		return (s32)m_sNowAnswer;
		break;
		
	default:
		break;
	}

	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelStaff2::Load()
{
	switch( m_iLoad ){
	case 0:
		char* pFile=NULL;
 		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) ){
 			pFile = STAFF2_PACK_FILE2;
 		}else{
 			pFile = STAFF2_PACK_FILE;
 		}
		if( m_pPack->OpenPack( pFile ) ){
			for( int i = 0; i < TEX_STAFF_MAX; i++ ){
				m_pPack->GetTexture( &m_Texture[i], i );
			}
			m_iLoad++;
		}
		break;
		
	case 1:
		if( m_File.OpenTexFile( SHANHAI_FILE, &m_ShanhaiTex ) ){
			InitTexture( &m_ShanhaiTex );
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
//					
//========================================================================
bool	SK7PanelStaff2::Move()
{
	int DrawTime = m_iDrawTime;
	if( m_iBlock == TEX_STAFF_01 ) DrawTime += 4;
	if( m_iBlock == TEX_STAFF_14 ) DrawTime += 60;
	if( ++m_iTime > m_iDrawTime ){
		m_iTime = 0;
		return true;
	}
	return false;
}
