////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Toilet
//
// SK7PanelToilet.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/01/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PANELTOILET_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7PanelToilet.h"
#include "../Yam/YK7EffectSight.h"
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7EffectMessage2.h"


//========================================================================
//					RXgN^
//========================================================================
SK7PanelToilet::SK7PanelToilet( s32 Now ) : SK7PanelBase( Now )
{
	//	TCg	----------------------------------------------
	SetCursolPosition( &(Vec){247,262,0});
	//	px
	m_fAngle = 0;
	m_iTime = 0;
	
	m_sNowAnswer = (s8)Now;
	
	m_bNobuFlag = false;
	
	//vZX	----------------------------------------------
	m_Proc = PROC_LOAD;
	m_TexProc = LOAD_BG;

	//	wiXvCg	----------------------------------------------
	m_spBG.SetXY0(0,0);
	m_spBG.SetVisible(true);
	
	//	mu	
	m_spNobu.SetXY0( NOBU_X, NOBU_Y );
	m_spNobu.SetVisible(false);
}


//========================================================================
//					fXgN^
//========================================================================
SK7PanelToilet::~SK7PanelToilet()
{ 
	//eNX`	-----------------------------
	m_spBG.Delete();
	
	m_spNobu.Delete();
		
}


//========================================================================
// t[
//========================================================================
s16			SK7PanelToilet::FrameProcess(void)
{	
	switch( m_Proc )
	{
	//	f[^[h	----------------------------------------
	case	PROC_LOAD:
		if( LoadTexData() )
		{
			gpSound->mPlaySE(SFX_SYS_PNL_START);
			m_Proc = PROC_SELECT_MAIN;//PROC_FIRST_MESSAGE;
		}
		break;
		
	case	PROC_FIRST_MESSAGE:
		if( m_sNowAnswer == NOT_WATER ){
			if( DrawMessage(0) ){
				m_Proc = PROC_SELECT_MAIN;
			}
		}else{
			if( DrawMessage(1) ){
				m_Proc = PROC_SELECT_MAIN;
			}
		}
		break;

	//	I	------------------------------------------------
	case	PROC_SELECT_MAIN:
		//	Rg[łȂƂ	----------------------------
		if( !m_bCtrl )	break;

		//	A{^
		
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A )
		{
			m_Proc = PROC_CHECK;
			break;
		}
		
		//	LZ	-----------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B )
		{
			m_sNowAnswer = NOT_MOVE;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
			break;
		}
		break;
		
	case	PROC_CHECK:
		switch( CheckAnswer() ){
		case	PANEL_CHECK_RETURN:
			m_Proc = PROC_SELECT_MAIN;
			break;
		case	PANEL_CHECK_SET:
			m_spNobu.SetVisible(true);
			SetCursolDisp( false );
			//	
			if( m_sNowAnswer == IN_WATER ) 
			{
				gpSound->mPlaySE(SFX_SCE0_TOILET_WATER_FLOWS);
				gpSound->mPlaySE( SFX_SYS_PNL_OK );
//				gpSound->mPlayStreamNo(HPS_TOILET_KEY);
				m_Proc = PROC_SOUND_CHECK;
				break;
			}else{
				gpSound->mPlaySE( SFX_SYS_PNL_OK );
				gpSound->mPlaySE( SFX_SCE0_TOILET_TWIST_HANDLE );
				gpSound->mPlaySE( SFX_SCE0_TOILET_NO_FLOWS );//	
				m_Proc = PROC_SOUND_CHECK;//PROC_MESSAGE_CHECK;
			}
			break;
		}
		break;

	case 	PROC_MESSAGE_CHECK:
		if( DrawMessage(2) )
		{
			m_Proc = PROC_CANCEL;
		}
		break;
		
	case 	PROC_SOUND_CHECK:
		if( m_sNowAnswer == IN_WATER ){
			if( !gpSound->mCheckSE(SFX_SCE0_TOILET_WATER_FLOWS) ){
				m_Proc = PROC_MESSAGE;
			}
		}else{
			if( !gpSound->mCheckSE(SFX_SCE0_TOILET_NO_FLOWS) ){
				m_Proc = PROC_TIME;
			}
		}
		break;
		
	case	PROC_MESSAGE:
		if( DrawMessage(0) ){
			SetCursolDisp( false );
			gpSound->mPlayStreamNo(HPS_TENSHI_D);
			m_Proc = PROC_CANCEL;//PROC_MESSAGE2;
		}
		break;
		
	case	PROC_MESSAGE2:
		if( DrawMessage(4) ){
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
		break;
		
	case	PROC_TIME:
		if( DrawMessage(1) ){//++m_iTime > 30 ){
//			m_iTime = 0;
			SetCursolDisp( false );
			m_Proc = PROC_CANCEL;
		}
		break;
	
	//	LZ
	case	PROC_CANCEL:
		break;
	}
	
	return 0;
}

//========================================================================
// _O
//========================================================================
bool		SK7PanelToilet::RenderProcess(void)
{
	//	``FbN
	if( m_bRender==false ){
		return true;
	}
	
	m_spBG.Render();					//	wi
	
	m_spNobu.Render();

	
	return true;
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool		SK7PanelToilet::mGetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
// II擾֐
//========================================================================
bool	SK7PanelToilet::mGetSelectEnd(void)
{
	if( (m_Proc == PROC_CANCEL) && GetPanelCursolEnd() == true )
	{
		return( true );
	}	
	return false;
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32		SK7PanelToilet::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( m_Proc )
	{
		case	PROC_CANCEL:
			return m_sNowAnswer;
/*			if( m_bNobuFlag )
			{
				if( m_sNowAnswer == IN_WATER )	return true;
				else						return false;
			}
			else
			{
				return false;
			}
			break;
*/			
		default:
			break;
	}
	return( PANEL_OPERATE_CANCEL );
}


//========================================================================
// eNX`[[h
//========================================================================
bool	SK7PanelToilet::LoadTexData()
{
	switch( m_TexProc )
	{
	
	case 	LOAD_BG:	//	wi
		if( m_spBG.LoadTexture( PNL000603TEX_BG ) )
		{
			m_TexProc = LOAD_NOBU;
		}
		break;
	case  	LOAD_NOBU:	//	mu
		if( m_spNobu.LoadTexture( PNL000603TEX_NOBU ))
		{
			return true;
		}
		break;
	}
	return false;
}


/*
//========================================================================
// ړmu
//========================================================================
bool		SK7PanelToilet::MoveNobu()
{
	m_fAngle -=2;
	
//	Vec V;
//	SetSightEffectPoint( m_ESight, &V );
	
	Mtx m;
	MTXRotDeg( m, 'z', m_fAngle );

	Vec v={-48,-64,0};
	MTXMultVec( m, &v, &v );
	m_spNobu.SetXY0( 320+v.x , 240+v.y );

	v.x = 48; v.y = -64;
	MTXMultVec( m, &v, &v );
	m_spNobu.SetXY1( 320+v.x , 240+v.y );

	v.x = -48; v.y = 64;
	MTXMultVec( m, &v, &v );
	m_spNobu.SetXY2( 320+v.x, 240+v.y );

	v.x = 48; v.y = 64;
	MTXMultVec( m, &v, &v );
	m_spNobu.SetXY3( 320+v.x, 240+v.y );
	
	if( m_fAngle < -50 )	return true;
	return false;
}
*/