////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel SK7PanelTutorial
//
// SK7PanelTutorial.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PANELTUTORIAL_H__
#define	__SK7PANELTUTORIAL_H__


#include "SK7PanelBase.h"
#include "SK7Sprite.h"
#include "SK7Font.h"

//
#define		TUTORIAL_STANDBY			(-2)
#define		TUTORIAL_CANCEL				(-1)
#define		TUTORIAL_SELECT				(0)


#define		TUTORIAL_DATA_MAX			(45)
#define		TUTORIAL_FONT_NUM			(7)
#define		KATEGORI_NUM				(6)
#define		MAX_FONT_NUM				(12)

enum{
	TEX_TUTORIAL_MOJI_01,
	TEX_TUTORIAL_MOJI_02,
	TEX_TUTORIAL_MOJI_03,
	TEX_TUTORIAL_MOJI_06,
	TEX_TUTORIAL_MOJI_04,
	TEX_TUTORIAL_MOJI_05,
	TEX_TUTORIAL_MONKEY_B,
	TEX_TUTORIAL_MONKEY_A,
	TEX_TUTORIAL_PANEL,
	TEX_TUTORIAL_SENTAKU,
	TEX_TUTORIAL_YAJIRUSHI,
	TEX_TUTORIAL_MAX,
};

enum{
	eKihon=0,
	eBattle,
	eBlood,
	eLog,
	eHm1,
	eHm2,
};


//---- class ----
class SK7PanelTutorial : public SK7PanelBase
{
	//	t[vZX
	typedef enum
	{
		PROC_LOAD=0,
		PROC_FIRST,
		PROC_SELECT_MAIN,
		PROC_CANCEL,
		PROC_END,
		PROC_TIME,
	}eFrameProc;
	
	typedef enum{
		eFTitle=0,
		eFYajirushi,
	}eFirstProc;
	
protected:
	eFrameProc				m_Proc;
	eFirstProc				m_eFirst;
	
	SK7Sprite				m_spCursol;
	SK7Sprite				m_spYaji;
	SK7Sprite				m_spYaji2;
	SK7Sprite				m_spEye[MAX_FONT_NUM];
	SK7Sprite				m_spEyeShadow[MAX_FONT_NUM];	
	SK7Sprite				m_spKategori;
	SK7Sprite				m_spKategori2;
	SK7Sprite				m_spTitle[KATEGORI_NUM];
	SK7Sprite				m_spTitle2;
	SK7Sprite				m_spBox[KATEGORI_NUM-1];
	SK7Sprite				m_spBox2[KATEGORI_NUM-1];
	SK7Sprite				m_spShadow;
	SK7Font					m_Font[MAX_FONT_NUM];
	s8						m_chSelect;
	s8						m_chKategori;
	s8						m_chMoveNo;
	s8						m_chFontLine;
	s8						m_iYajiTime;
	s8						m_chFontDrawNo;
	s8						m_chKategoriMax;
	s8						m_chLogNum;
	s32						m_lAnswer;
	int						m_iTime;
	int						m_iCursolTime;
	bool					m_bLookFlag[MAX_FONT_NUM];
	
	
	bool		MoveFirst();
	void		MoveSelect();
	void		SetFont();
	void		SetFontLog();
	void		SetCursol();
	void		SetYajirushi();
	void		SetKategoriBox( bool Alpha );
	void		SetMoveKategori();
	void		SetSelect();
	void		SetMonkey();
	void		SetMonkeyLog();
	bool		MoveKategori();
public:
	SK7PanelTutorial( s32 Now=PANEL_INIT_ARRANGE );
	virtual ~SK7PanelTutorial();
	
	// t[
	virtual s16	 FrameProcess( void );
	
	// _O
	virtual bool RenderProcess( void );
	
	// t@CǂݍݏI擾֐
	virtual bool mGetFileReadEnd( void );

	// Iڎ擾֐
	virtual s32 mGetResult( void );
	
	// II擾֐
	virtual bool mGetSelectEnd( void );
	
	//	eNX`[f[^̓Ǎ	
	bool	LoadTexData();

	//	CU߂ČĂłق
	void	SetReturnMenu();

};

const s32 tblTutorialKihonNo[]={
	0x007111,
	0x007117,
	0x090101,
	0x007116,
	0x007118,
	0x090118,
	0x090112,
	0x090117,
	0x090113,
	0x090115,
	0x090119,
};

const s32 tblTutorialBattleNo[]={
	0x007112,
	0x090116,
	0x090121,
	0x007119,
	0x012102,
	0x012111,
	0x090106,
	0x090120,
	0x090107,
	0x090109,
	0x090108,
};
const s32 tblTutorialBloodNo[]={
	0x012103,
	0x007115,
	0x012100,
	0x012110,
	0x007113,
	0x090114,
	0x090102,
	0x090104,
	0x090105,
	0x090103,
};
const s32 tblTutorialHm1No[]={
	0x090201,
	0x090110,
	0x090111,
	0x090222,
	0x090202,
	0x090203,
	0x090204,
	0x090205,
	0x090221,
	0x090206,
	0x090207,
	0x090208,
};

const s32 tblTutorialHm2No[]={
	0x090209,
	0x090210,
	0x090211,
	0x090212,
	0x090214,
	0x090213,
	0x090215,
	0x090216,
	0x090217,
};

//	ZeBbN
const s32 tblLogNoCel[]={
	0x007101,
	0x007110,
	0x007108,
	0x007106,
	0x007104,
	0x007202,
	0x007307,
	0x007406,
	0x007305,
	0x007407,
	0x007505,
	0x007404,
	NULL,
};
//	tNV}
const s32 tblLogNoFuk[]={
	0x010002,
	0x012112,
	0x010010,
	0x012114,
	NULL,
};          
//	JNr
const s32 tblLogNoKak[]={
	0x011020,
	0x011021,
	0x011022,
	0x011023,
	0x011024,
	NULL,
};          
//	eLTX
const s32 tblLogNoTxs[]={
	0x020110,
	NULL,
};          
//	Vn
const s32 tblLogNoIsz[]={
	0x030020,
	0x030022,
	0x030025,
	0x030026,
	0x030023,
	NULL,
};        
//	J[eBX
const s32 tblLogNoCur[]={
	0x035003,
	0x035005,
	0x012150,
	0x035004,
	0x012151,
	0x035006,
	NULL,
};
//	h~jJ
const s32 tblLogNoDmi[]={
	0x040108,
	0x040101,
	0x040102,
	0x040103,
	0x040106,
	0x040107,
	0x040201,
	0x040202,
	0x040401,
	0x040403,
	NULL,
};
//	gs
const s32 tblLogNoHtl[]={
	0x051121,
	0x051122,
	0x051123,
	0x051124,
	0x051125,
	0x051126,
	NULL,
};
//	wZ
const s32 tblLogNoScl[]={
	0x055511,
	0x055512,
	0x055513,
	0x055514,
	NULL,
};

static const s32* tblLogNoAll[]={
	tblLogNoCel,// ZeBbN
	tblLogNoFuk,// tNV}
	tblLogNoKak,// pr
	tblLogNoTxs,// eLTX
	tblLogNoIsz,// VniCVUJh
	tblLogNoCur,// J[eBX@
	tblLogNoDmi,// h~jJO
	tblLogNoDmi,// h~jJij[[N
	tblLogNoHtl,// zeP
	tblLogNoScl,// wZ
	tblLogNoTxs,// zeQ
	tblLogNoHtl,// R͓
	NULL,
};

static const s32* tblTutorialAllNo[]={
	tblTutorialKihonNo,
	tblTutorialBattleNo,
	tblTutorialBloodNo,
	tblTutorialBloodNo,
	tblTutorialHm1No,
	tblTutorialHm2No,
};


#endif	//__SK7PANELTUTORIAL_H__
