////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 03
//
// mK7PanelSwitch03.cpp
// N[[̃XCb`
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH01_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch03.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000501TEX_OFF	"Texture/000501/cooler_BG.BIN"//02switch_off.bin"
#define	PANEL000501TEX_ON	"Texture/000501/cooler_on.BIN"//02switch.bin"




//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch03::mK7PanelSwitch03( s32 Now ) : SK7PanelBase( Now )
{
	//	JZbg	---------------------------------------------
	SetEffectCamera( WK7CAM->GetCObj() );
	if( (Now == 0) || (Now == PANEL_INIT_ARRANGE) )
	{
		//XCb`off̏Ԃɂ
		mSelectFlag = false;
		SetCursolPosition(&(Vec){327,257,0});
		SetCursolDir( CURSOL_DIR_UP );
	}else
	{
		//XCb`on̏Ԃɂ
		mSelectFlag = true;
		SetCursolPosition(&(Vec){327,227,0});
		SetCursolDir( CURSOL_DIR_DOWN );
	}
	
	
	//ϐ
	mKeyTime        = 0;
	m_iTime			= 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//vZX
	mProc = ePanelSwitch03ReadTexOff;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch03::~mK7PanelSwitch03()
{
	//\
	mSpOff.SetFlag( false, RENDER_FLAG );
	mSpOn.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpOff.Delete();
	mSpOn.Delete();
	
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch03::FrameProcess(void)
{
	Vec switchPosTbl[] = { 327.0f, 227.0f, 0.0f,
						   327.0f, 257.0f, 0.0f, };
	
	switch( mProc )
	{
		//offeNX`ǂݍ
		case	ePanelSwitch03ReadTexOff:
			if( mSpOff.LoadTexture(PANEL000501TEX_OFF) == true )
			{
				mSpOff.SetXY0(   0,   0 );
				mSpOff.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch03ReadTexOn;
			}
			break;
		
		//oneNX`ǂݍ
		case	ePanelSwitch03ReadTexOn:
			if( mSpOn.LoadTexture(PANEL000501TEX_ON) == true )
			{
				mSpOn.SetXY0( 256,   184 );
				if( mSelectFlag == false )
				{
					mSpOn.SetFlag( false, RENDER_FLAG );
					mProc = ePanelSwitch03DispOff;
				}else
				{
					mSpOn.SetFlag( true, RENDER_FLAG );
					mProc = ePanelSwitch03DispOn;
				}
				gpSound->mPlaySE(SFX_SYS_PNL_START);
			}
			break;
		
		//off\
		case	ePanelSwitch03DispOff:
			if( m_bCtrl == true )
			{
				SetCursolDir( CURSOL_DIR_UP,0 );
				if( CheckKeyT( SK7_KEY_UP ) )
				{
					SetCursolPosition( &switchPosTbl[0] );
					SetCursolDir( CURSOL_DIR_UP,1 );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					mProc = ePanelSwitch03DispOn;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = false;
					mProc       = ePanelSwitch03Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch03Cancel;
				}
			}
			break;
		
		//on\
		case	ePanelSwitch03DispOn:
			if( m_bCtrl == true )
			{
				SetCursolDir( CURSOL_DIR_DOWN,0 );
				if( CheckKeyT( SK7_KEY_DOWN ) )
				{
					SetCursolPosition( &switchPosTbl[1]);
					SetCursolDir( CURSOL_DIR_DOWN,1 );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					mProc = ePanelSwitch03DispOff;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = true;
					mProc       = ePanelSwitch03Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch03Cancel;
				}
			}
			break;
		
		//II
		case	ePanelSwitch03Decide:
		case	ePanelSwitch03Cancel:
			//Ō̊mFs
			if( mLastCheck == false )
			{
			
				switch( CheckAnswer() )
				{
					case	PANEL_CHECK_RETURN:
						if( mSelectFlag == false )
						{
							mProc = ePanelSwitch03DispOff;
						}else
						{
							mProc = ePanelSwitch03DispOn;
						}
						break;
					case	PANEL_CHECK_SET:
						gpSound->mPlaySE( SFX_SYS_PNL_OK );
						m_sLastWait = PANEL_LAST_WAIT;
						if( mSelectFlag == false )
						{
							gpSound->mStopSE( SFX_SCE0_COOLER_RUN_LOOP );
							mSpOn.SetFlag( false, RENDER_FLAG );
						}else
						{
							gpSound->mPlaySE( SFX_SCE0_COOLER_RUN_LOOP );
							mSpOn.SetFlag( true, RENDER_FLAG );
						}
						//莞̂SEĐ
						if( mProc == ePanelSwitch03Decide )
						{
							gpSound->mPlaySE( SFX_SCE0_COOLER_SWITCH );
						}
					if( mSelectFlag == false ){
						mProc = ePanelSwitch03Message;//ePanelSwitch03Time;
					}
					else{
						mProc = ePanelSwitch03Message;
					}
						mLastCheck = true;
						break;
				}
			}else
			{
				m_sLastWait = 0;
			}
			break;
		case	ePanelSwitch03Message:
			if( mSelectFlag ){
				if( DrawMessage(0) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch03MessageEnd;
				}
			}else{
				if( DrawMessage(1) ){
					m_sLastWait = 0;
					mProc = ePanelSwitch03MessageEnd;
				}
			}
			break;
		
	case	ePanelSwitch03Time:
		if( ++m_iTime > 20 ){
			m_sLastWait = 0;
			mProc = ePanelSwitch03MessageEnd;
			m_iTime = 0;
		}
		break;

		default:
			break;
	}	
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch03::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpOff.Render();
	mSpOn.Render();
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch03::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch03ReadTexOff) || (mProc == ePanelSwitch03ReadTexOn) )
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch03::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch03::mSetRender( bool inBool )
{
	m_bRender = inBool;
	SetCursolDisp(inBool);
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch03::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 && GetPanelCursolEnd() == true )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch03::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch03Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch03Message:
		case	ePanelSwitch03MessageEnd:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














