////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 04
//
// mK7PanelSwitch04.cpp
//  Ǘlpl EASY NORMAL HARD
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 09/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH04_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch04.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000502TEX_BG		"Texture/000502/ENH_BG.BIN"
#define	PANEL000502TEX_EASY		"Texture/000502/easy_2.BIN"
#define	PANEL000502TEX_NORMAL	"Texture/000502/normal_2.BIN"
#define	PANEL000502TEX_HARD		"Texture/000502/hard_2.BIN"
#define	PANEL000502TEX_PLUG		"Texture/000502/plug.BIN"

#define	PANEL000502_PLUG_WIDTH		(32)

//vOhĂƂ̍W
#define	PANEL000502_PLUG_X			(388)
#define	PANEL000502_PLUG_Y			(155)

//vOĂƂ̍W
#define	PANEL000502_PLUG_X_EASY		(388)
#define	PANEL000502_PLUG_Y_EASY		(155)
#define	PANEL000502_PLUG_X_NORMAL	(388)
#define	PANEL000502_PLUG_Y_NORMAL	(247)
#define	PANEL000502_PLUG_X_HARD		(388)
#define	PANEL000502_PLUG_Y_HARD		(340)
#define	PANEL000502_PLUG_X_STANDBY	(462)
#define	PANEL000502_PLUG_Y_STANDBY	(155)

//pl̍W
#define	PANEL000502_X_EASY			(352)
#define	PANEL000502_Y_EASY			(150)
#define	PANEL000502_X_NORMAL		(352)
#define	PANEL000502_Y_NORMAL		(240)
#define	PANEL000502_X_HARD			(350)
#define	PANEL000502_Y_HARD			(330)

//J[\W
#define	PANEL000502_X_CUR_EASY		(403.0f)
#define	PANEL000502_Y_CUR_EASY		(216.0f)
#define	PANEL000502_X_CUR_NORMAL	(403.0f)
#define	PANEL000502_Y_CUR_NORMAL	(308.0f)
#define	PANEL000502_X_CUR_HARD		(403.0f)
#define	PANEL000502_Y_CUR_HARD		(400.0f)
#define	PANEL000502_X_CUR_STANDBY	(477.0f)
#define	PANEL000502_Y_CUR_STANDBY	(216.0f)

//	------
//vÕeNX`[̉̐ƂĂ̐
#define	PANEL000502_PLUG_WIDTH_NUM		(4)
#define	PANEL000502_PLUG_HEIGHT_NUM		(1)


//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch04::mK7PanelSwitch04( s32 Now ) : SK7PanelBase( Now )
{
	//	JZbg	---------------------------------------------
	SetEffectCamera( WK7CAM->GetCObj() );
	
	//J[\Ԑݒ
	switch( Now )
	{
		case	0:
			SetCursolDir( CURSOL_DIR_DOWN,0 );
			mSelectFlag = 0;
			SetCursolPosition(&(Vec){PANEL000502_X_CUR_EASY,PANEL000502_Y_CUR_EASY,0});
			break;
		
		case	1:
			mSelectFlag = 1;
			SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN,0 );
			SetCursolPosition(&(Vec){PANEL000502_X_CUR_NORMAL,PANEL000502_Y_CUR_NORMAL,0});
			break;
			
		case	2:
			mSelectFlag = 2;
			SetCursolDir( CURSOL_DIR_UP,0 );
			SetCursolPosition(&(Vec){PANEL000502_X_CUR_HARD,PANEL000502_Y_CUR_HARD,0});
			break;
		
		case	PANEL_INIT_ARRANGE:
		default:
			mSelectFlag = 3;
			SetCursolDir( CURSOL_DIR_DOWN,0 );
			SetCursolPosition(&(Vec){PANEL000502_X_CUR_STANDBY,PANEL000502_Y_CUR_STANDBY,0});
			break;
	}
	
	//J[\̑傫
//	SetSightSize( mEfSight, 20, 19 );
	//TCg̕\off
//	SetSightEffectRenderFlag( mEfSight, false );
	SetCursolDisp(false);

	
	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	mNotSelectNo	= (u8)Now;
	
	//vZX
	mProc = ePanelSwitch04ReadTex00;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch04::~mK7PanelSwitch04()
{
	//\
	mSpBg.SetFlag( false, RENDER_FLAG );
	mSpEasy.SetFlag( false, RENDER_FLAG );
	mSpNormal.SetFlag( false, RENDER_FLAG );
	mSpHard.SetFlag( false, RENDER_FLAG );
	mSpPlug.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpBg.Delete();
	mSpEasy.Delete();
	mSpNormal.Delete();
	mSpHard.Delete();
	mSpPlug.Delete();
	
}


//========================================================================
// vOSTlݒ
//========================================================================
void
mK7PanelSwitch04::mSetPlugXYST(void)
{
	//xyWݒ
	if( mInsert == true )
	{
		switch( mSelectFlag )
		{
			case	0:
				SetCursolDir( CURSOL_DIR_UP,0 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X, PANEL000502_PLUG_Y );
				break;
			case	1:
				SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X, PANEL000502_PLUG_Y );
				break;
			case	2:
				SetCursolDir( CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X, PANEL000502_PLUG_Y );
				break;
			case	3:
				SetCursolDir( CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X_STANDBY, PANEL000502_PLUG_Y_STANDBY );
				break;
		}
	}else
	{
		switch( mSelectFlag )
		{
			case	0:
				SetCursolDir( CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X_EASY, PANEL000502_PLUG_Y_EASY );
				break;
			case	1:
				SetCursolDir( CURSOL_DIR_UP|CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X_NORMAL, PANEL000502_PLUG_Y_NORMAL );
				break;
			case	2:
				SetCursolDir( CURSOL_DIR_UP,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X_HARD, PANEL000502_PLUG_Y_HARD );
				break;
			case	3:
				SetCursolDir( CURSOL_DIR_DOWN,1 );
				mSpPlug.SetXY0( PANEL000502_PLUG_X_STANDBY, PANEL000502_PLUG_Y_STANDBY );
				break;
		}
	}
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch04::FrameProcess(void)
{
	Vec switchPosTbl[] = { PANEL000502_X_CUR_EASY,   PANEL000502_Y_CUR_EASY,   0.0f,
						   PANEL000502_X_CUR_NORMAL, PANEL000502_Y_CUR_NORMAL, 0.0f,
						   PANEL000502_X_CUR_HARD,   PANEL000502_Y_CUR_HARD,   0.0f, };
	
	switch( mProc )
	{
		
		//BGeNX`ǂݍ
		case	ePanelSwitch04ReadTex00:
			if( mSpBg.LoadTexture(PANEL000502TEX_BG) == true )
			{
				mSpBg.SetXY0( 0, 0 );
				mSpBg.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch04ReadTex01;
			}
			break;
		
		//EASYeNX`ǂݍ
		case	ePanelSwitch04ReadTex01:
			if( mSpEasy.LoadTexture(PANEL000502TEX_EASY) == true )
			{
				mSpEasy.SetXY0( PANEL000502_X_EASY, 	PANEL000502_Y_EASY );
				mSpEasy.SetFlag( true, COLOR_FLAG );
				mSpEasy.SetColor( 255, 255, 255, 255 );
				if( mSelectFlag == 0 )
					mSpEasy.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch04ReadTex02;
			}
			break;
		
		//NORMALeNX`ǂݍ
		case	ePanelSwitch04ReadTex02:
			if( mSpNormal.LoadTexture(PANEL000502TEX_NORMAL) == true )
			{
				mSpNormal.SetXY0( PANEL000502_X_NORMAL,                          PANEL000502_Y_NORMAL );
				mSpNormal.SetFlag( true, COLOR_FLAG );
				if( mSelectFlag == 1 )
					mSpNormal.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch04ReadTex03;
			}
			break;
		
		//HARDeNX`ǂݍ
		case	ePanelSwitch04ReadTex03:
			if( mSpHard.LoadTexture(PANEL000502TEX_HARD) == true )
			{
				mSpHard.SetXY0( PANEL000502_X_HARD,                          PANEL000502_Y_HARD );
				mSpHard.SetFlag( true, COLOR_FLAG );
				if( mSelectFlag == 2 )
					mSpHard.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch04ReadTex04;
			}
			break;
		
		//PLUGeNX`ǂݍ
		case	ePanelSwitch04ReadTex04:
			if( mSpPlug.LoadTexture(PANEL000502TEX_PLUG, PANEL000502_PLUG_WIDTH_NUM, PANEL000502_PLUG_HEIGHT_NUM ) == true )
			{
				mSpPlug.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );
				mSpPlug.SetTexNo( (u8)mSelectFlag );
				switch( mSelectFlag )
				{
					case	0:
						mInsert = true;
						mProc   = ePanelSwitch04DispEasy;
						break;
					case	1:
						mInsert = true;
						mProc   = ePanelSwitch04DispNormal;
						break;
					case	2:
						mInsert = true;
						mProc   = ePanelSwitch04DispHard;
						break;
					case	3:
						mInsert = false;
						mProc   = ePanelSwitch04Standby;
						break;
				}
				mSetPlugXYST();
			}
			break;
		
		//vOX^oC
		case	ePanelSwitch04Standby:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					gpSound->mPlaySE( SFX_SYS_CURSOR );
					SetCursolPosition( &switchPosTbl[0] );
					mSelectFlag = 0;
					mSetPlugXYST();
					mProc = ePanelSwitch04DispEasy;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch04Cancel;
				}
			}
			break;
		
		//easy\
		case	ePanelSwitch04DispEasy:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					if( mInsert == false )
					{
						gpSound->mPlaySE( SFX_SYS_CURSOR );
						SetCursolPosition( &switchPosTbl[1] );
						mSelectFlag = 1;
						mSetPlugXYST();
						mProc = ePanelSwitch04DispNormal;
					}
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					if( mInsert == false )
					{
						if( mNotSelectNo == 0 )	break;
						gpSound->mPlaySE( SFX_SYS_DECIDE );
						mSetPlugXYST();
						mInsert = true;
						mProc = ePanelSwitch04Decide;
					}else
					{
						gpSound->mPlaySE( SFX_SCE0_PANEL_KEY_GET );
						mInsert = false;
						mSpEasy.SetFlag( false, RENDER_FLAG );
						mSetPlugXYST();
						mSpPlug.SetTexNo(3);
					}

				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch04Cancel;
				}
			}
			break;
		
		//normal\
		case	ePanelSwitch04DispNormal:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					if( mInsert == false )
					{
						gpSound->mPlaySE( SFX_SYS_CURSOR );
						SetCursolPosition( &switchPosTbl[2] );
						mSelectFlag = 2;
						mSetPlugXYST();
						mProc = ePanelSwitch04DispHard;
					}
				}else
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
				{
					if( mInsert == false )
					{
						gpSound->mPlaySE( SFX_SYS_CURSOR );
						SetCursolPosition( &switchPosTbl[0] );
						mSelectFlag = 0;
						mSetPlugXYST();
						mProc = ePanelSwitch04DispEasy;
					}
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					if( mInsert == false )
					{
						if( mNotSelectNo == 1 )	break;
						gpSound->mPlaySE( SFX_SYS_DECIDE );
						mSetPlugXYST();
						mProc = ePanelSwitch04Decide;
					}else
					{
						gpSound->mPlaySE( SFX_SCE0_PANEL_KEY_GET );
						mInsert = false;
						mSpNormal.SetFlag( false, RENDER_FLAG );
						mSetPlugXYST();
						mSpPlug.SetTexNo(3);
					}
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch04Cancel;
				}
			}
			break;
		
		//hard\
		case	ePanelSwitch04DispHard:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
				{
					if( mInsert == false )
					{
						gpSound->mPlaySE( SFX_SYS_CURSOR );
						SetCursolPosition( &switchPosTbl[1] );
						mSelectFlag = 1;
						mSetPlugXYST();
						mProc = ePanelSwitch04DispNormal;
					}
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					if( mInsert == false )
					{
						if( mNotSelectNo == 2 )	break;
						gpSound->mPlaySE( SFX_SYS_DECIDE );
						mSetPlugXYST();
						mProc = ePanelSwitch04Decide;
					}else
					{
						gpSound->mPlaySE( SFX_SCE0_PANEL_KEY_GET );
						mInsert = false;
						mSpHard.SetFlag( false, RENDER_FLAG );
						mSetPlugXYST();
						mSpPlug.SetTexNo(3);
					}
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch04Cancel;
				}
			}
			break;
		
		//II
		case	ePanelSwitch04Decide:
		case	ePanelSwitch04Cancel:
			//Ō̊mFs
			if( mLastCheck == false )
			{
				switch( CheckAnswer() )
				{
					case	PANEL_CHECK_RETURN:
						SetCursolDisp(true);
						mSetPlugXYST();
						mSpPlug.SetTexNo(3);
						mSpEasy.SetFlag( false, RENDER_FLAG );
						mSpNormal.SetFlag( false, RENDER_FLAG );
						mSpHard.SetFlag( false, RENDER_FLAG );

						mInsert = false;
						switch( mSelectFlag )
						{
							case	0:
								mProc = ePanelSwitch04DispEasy;
								break;
							case	1:
								mProc = ePanelSwitch04DispNormal;
								break;
							case	2:
								mProc = ePanelSwitch04DispHard;
								break;
						}
						break;
					case	PANEL_CHECK_SET:
						m_sLastWait = PANEL_LAST_WAIT;
						mLastCheck = true;
						break;
				}
			}else
			{
				if( m_sLastWait > 0 )
				{
					//ŏXCb`̕\؂ւ
					if( m_sLastWait == PANEL_LAST_WAIT )
					{
						switch( mSelectFlag )
						{
							case	0:
								mSpEasy.SetFlag( true, RENDER_FLAG );
								mSpNormal.SetFlag( false, RENDER_FLAG );
								mSpHard.SetFlag( false, RENDER_FLAG );
								break;
							case	1:
								mSpEasy.SetFlag( false, RENDER_FLAG );
								mSpNormal.SetFlag( true, RENDER_FLAG );
								mSpHard.SetFlag( false, RENDER_FLAG );
								break;
							case	2:
								mSpEasy.SetFlag( false, RENDER_FLAG );
								mSpNormal.SetFlag( false, RENDER_FLAG );
								mSpHard.SetFlag( true, RENDER_FLAG );
								break;
						}
						mInsert = true;
						mSetPlugXYST();
						mSpPlug.SetTexNo( (u8)mSelectFlag );
						//莞̂SEĐ
						if( mProc == ePanelSwitch04Decide )
						{
							gpSound->mPlaySE( SFX_SCE0_PANEL_KEY_ON );
						}
					}
					m_sLastWait -= WK7_TICK_PER_FRAME;
				}else
				{
					m_sLastWait = 0;
				}
			}
			break;
		
		default:
			break;
	}
	
	//	Rc	------------------------------
	SetEffectCamera( WK7CAM->GetCObj() );
	
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch04::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpBg.Render();
	mSpEasy.Render();
	mSpNormal.Render();
	mSpHard.Render();
	mSpPlug.Render();
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch04::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch04ReadTex00)
	 || (mProc == ePanelSwitch04ReadTex01)
	 || (mProc == ePanelSwitch04ReadTex02)
	 || (mProc == ePanelSwitch04ReadTex03)
	 || (mProc == ePanelSwitch04ReadTex04)  )
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch04::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch04::mSetRender( bool inBool )
{
	m_bRender = inBool;
//	SetSightEffectRenderFlag( mEfSight, inBool );
	SetCursolDisp( inBool );
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch04::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch04::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch04Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch04Decide:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














