////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Panel Switch 05 pjbN[̃XCb`
//
// mK7PanelSwitch05.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 11/04/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__MK7PANELSWITCH05_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "mK7PanelSwitch05.h"
#include "../Yam/YK7EffectSight.h" 
#include "../wat/WK7Cam.h"
#include "../matsu/mK7Sound.h"




//---- define ----
#define	PANEL000606TEX_BG		"Texture/000606/panic2_BG.BIN"
#define	PANEL000606TEX_CLOSE	"Texture/000606/panic2_close.BIN"
#define	PANEL000606TEX_OPEN		"Texture/000606/panic2_open.BIN"

#define	PANEL000606CLOSE_X		(291)
#define	PANEL000606CLOSE_Y		(172)
#define	PANEL000606OPEN_X		(291)
#define	PANEL000606OPEN_Y		(306)




//========================================================================
//					RXgN^
//========================================================================
mK7PanelSwitch05::mK7PanelSwitch05( s32 Now ) : SK7PanelBase( Now )
{
	if( (Now == 0) || (Now == PANEL_INIT_ARRANGE) )
	{
		//XCb`off̏Ԃɂ
		mSelectFlag = false;
	}else
	{
		//XCb`on̏Ԃɂ
		mSelectFlag = true;
	}
	Vec vPos={320,240,0};
	SetCursolPosition(&vPos);
	SetCursolDisp(false);
	
	//ϐ
	mKeyTime        = 0;
	mLastCheck      = false;
	mInitSelectFlag = mSelectFlag;
	
	//vZX
	mProc = ePanelSwitch05ReadTex00;
}


//========================================================================
//					fXgN^
//========================================================================
mK7PanelSwitch05::~mK7PanelSwitch05()
{
	//\
	mSpBg.SetFlag( false, RENDER_FLAG );
	mSpClose.SetFlag( false, RENDER_FLAG );
	mSpOpen.SetFlag( false, RENDER_FLAG );
	//eNX`
	mSpBg.Delete();
	mSpClose.Delete();
	mSpOpen.Delete();
	
//	DelReqSightEffec( mEfSight );
}


//========================================================================
// t[
//========================================================================
s16
mK7PanelSwitch05::FrameProcess(void)
{
	TEX_DATA*	texDat;
	s16			w, h;
	Vec			temp;
	
	switch( mProc )
	{
	
		//eNX`ǂݍ
		case	ePanelSwitch05ReadTex00:
			if( mSpClose.LoadTexture(PANEL000606TEX_CLOSE) == true )
			{
				texDat = mSpClose.GetTexture();
				w      = (s16)texDat->Header->mWidth;
				h      = (s16)texDat->Header->mHeight;
				mSpClose.SetXY0( PANEL000606CLOSE_X,   PANEL000606CLOSE_Y   );
				mSpClose.SetXY1( PANEL000606CLOSE_X+w, PANEL000606CLOSE_Y   );
				mSpClose.SetXY2( PANEL000606CLOSE_X,   PANEL000606CLOSE_Y+h );
				mSpClose.SetXY3( PANEL000606CLOSE_X+w, PANEL000606CLOSE_Y+h );
				mSpClose.SetColor( 255, 255, 255, 255 );
				mSpClose.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
					mSpClose.SetFlag( true, RENDER_FLAG );
				else
					mSpClose.SetFlag( false, RENDER_FLAG );
				mProc = ePanelSwitch05ReadTex01;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelSwitch05ReadTex01:
			if( mSpOpen.LoadTexture(PANEL000606TEX_OPEN) == true )
			{
				texDat = mSpOpen.GetTexture();
				w      = (s16)texDat->Header->mWidth;
				h      = (s16)texDat->Header->mHeight;
				mSpOpen.SetXY0( PANEL000606OPEN_X,   PANEL000606OPEN_Y   );
				mSpOpen.SetXY1( PANEL000606OPEN_X+w, PANEL000606OPEN_Y   );
				mSpOpen.SetXY2( PANEL000606OPEN_X,   PANEL000606OPEN_Y+h );
				mSpOpen.SetXY3( PANEL000606OPEN_X+w, PANEL000606OPEN_Y+h );
				mSpOpen.SetColor( 255, 255, 255, 255 );
				mSpOpen.SetFlag( true, COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
					mSpOpen.SetFlag( false, RENDER_FLAG );
				else
					mSpOpen.SetFlag( true, RENDER_FLAG );
				mProc = ePanelSwitch05ReadTex02;
			}
			break;
		
		//eNX`ǂݍ
		case	ePanelSwitch05ReadTex02:
			if( mSpBg.LoadTexture(PANEL000606TEX_BG) == true )
			{
				mSpBg.SetXY0(   0,   0 );
				mSpBg.SetXY1( 640,   0 );
				mSpBg.SetXY2(   0, 480 );
				mSpBg.SetXY3( 640, 480 );
				mSpBg.SetColor( 255, 255, 255, 255 );
				mSpBg.SetFlag( true, RENDER_FLAG|COLOR_FLAG|VTX4_FLAG );
				if( mSelectFlag == false )
				{
					texDat = mSpClose.GetTexture();
					w      = (s16)texDat->Header->mWidth;
					h      = (s16)texDat->Header->mHeight;
					temp.x = (f32)(mSpClose.GetX0() + (w / 2));
					temp.y = (f32)(mSpClose.GetY0() + (h / 2));
					SetCursolPosition( &temp );
					SetCursolDir( CURSOL_DIR_DOWN );
					mProc = ePanelSwitch05DispOff;
				}else
				{
					texDat = mSpOpen.GetTexture();
					w      = (s16)texDat->Header->mWidth;
					h      = (s16)texDat->Header->mHeight;
					temp.x = (f32)(mSpOpen.GetX0() + (w / 2));
					temp.y = (f32)(mSpOpen.GetY0() + (h / 2));
					SetCursolDir( CURSOL_DIR_UP );
					SetCursolPosition( &temp );
					mProc = ePanelSwitch05DispOn;
				}
				gpSound->mPlaySE(SFX_SYS_PNL_START);
			}
			break;
		
		//off\
		case	ePanelSwitch05DispOff:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_DOWN )
				{
					texDat = mSpOpen.GetTexture();
					w      = (s16)texDat->Header->mWidth;
					h      = (s16)texDat->Header->mHeight;
					temp.x = (f32)(mSpOpen.GetX0() + (w / 2));
					temp.y = (f32)(mSpOpen.GetY0() + (h / 2));
					SetCursolDir( CURSOL_DIR_UP );
					SetCursolPosition( &temp );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					mProc = ePanelSwitch05DispOn;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = false;
					mProc       = ePanelSwitch05Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp(false);
					mSelectFlag = mInitSelectFlag;
					mProc       = ePanelSwitch05Cancel;
				}
			}
			break;
		
		//on\
		case	ePanelSwitch05DispOn:
			if( m_bCtrl == true )
			{
				if( HSD_PadGetTrigger(0) & HSD_PAD_STICK_UP )
				{
					texDat = mSpClose.GetTexture();
					w      = (s16)texDat->Header->mWidth;
					h      = (s16)texDat->Header->mHeight;
					temp.x = (f32)(mSpClose.GetX0() + (w / 2));
					temp.y = (f32)(mSpClose.GetY0() + (h / 2));
					SetCursolPosition( &temp );
					SetCursolDir( CURSOL_DIR_DOWN );
					gpSound->mPlaySE(SFX_SYS_PNL_MOV_CURSOL);
					mProc = ePanelSwitch05DispOff;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_A )
				{
					gpSound->mPlaySE( SFX_SYS_DECIDE );
					mSelectFlag = true;
					mProc       = ePanelSwitch05Decide;
				}else
				if( HSD_PadGetTrigger(0) == PAD_BUTTON_B )
				{
					gpSound->mPlaySE( SFX_SYS_CANCEL );
					SetCursolDisp( false );
					mSelectFlag = mInitSelectFlag;
					mLastCheck  = true;
					mProc       = ePanelSwitch05Cancel;
				}
			}
			break;
		
		//IIȂ̂ŕ\EGCg
		case	ePanelSwitch05Decide:
		case	ePanelSwitch05Cancel:
			//Ō̊mFs
			if( mLastCheck == false )
			{
				switch( CheckAnswer() )
				{
					case	PANEL_CHECK_RETURN:
						if( mSelectFlag == false )
						{
							mProc = ePanelSwitch05DispOff;
						}else
						{
							mProc = ePanelSwitch05DispOn;
						}
						break;
					case	PANEL_CHECK_SET:
						m_sLastWait = PANEL_LAST_WAIT;
						//XCb`̏Ԑ؂ւ
						if( mSelectFlag == false )
						{
							mSpClose.SetFlag( true, RENDER_FLAG );
							mSpOpen.SetFlag( false, RENDER_FLAG );
						}else
						{
							mSpClose.SetFlag( false, RENDER_FLAG );
							mSpOpen.SetFlag( true, RENDER_FLAG );
						}
						//莞̂SEĐ
						if( mProc == ePanelSwitch05Decide )
						{
							gpSound->mPlaySE( SFX_SYS_DECIDE );	//
						}
						mLastCheck = true;
						mProc = ePanelSwitch05Message;
						break;
				}
			}else{
				m_sLastWait = 0;
			}
			break;
		
	case	ePanelSwitch05Message:
		if( mSelectFlag == true){
			if( DrawMessage( 0 ) ){
				m_sLastWait = 0;
				mProc = ePanelSwitch05MessageEnd;
			}
		}else{
			if( DrawMessage( 1 ) ){
				m_sLastWait = 0;
				mProc = ePanelSwitch05MessageEnd;
			}
		}
		break;
		
		case	ePanelSwitch05MessageEnd:
		break;
		
		default:
			break;
	}
		
	return( 0 );
}

//========================================================================
// _O
//========================================================================
bool
mK7PanelSwitch05::RenderProcess(void)
{
	if( m_bRender == false ){
		return( true );
	}
	
	mSpBg.Render();
	mSpClose.Render();
	mSpOpen.Render();
	
	return( true );
}

//========================================================================
// t@CǂݍݏI擾֐
//========================================================================
bool
mK7PanelSwitch05::mGetFileReadEnd(void)
{
	if( (mProc == ePanelSwitch05ReadTex00)
	 || (mProc == ePanelSwitch05ReadTex01)
	 || (mProc == ePanelSwitch05ReadTex02))
	{
		return( false );
	}
	
	return( true );
}

//========================================================================
// 싖ݒ֐
//========================================================================
void
mK7PanelSwitch05::mSetCtrlFlag( bool inBool )
{
	m_bCtrl = inBool;
}

//========================================================================
// _Oݒ֐
//========================================================================
void
mK7PanelSwitch05::mSetRender( bool inBool )
{
	m_bRender = inBool;
	SetCursolDisp(inBool );
}

//========================================================================
// II擾֐
//========================================================================
bool
mK7PanelSwitch05::mGetSelectEnd(void)
{
	if( m_sLastWait == 0 )
	{
		return( true );
	}
	
	return( false );
}

//========================================================================
// Iڎ擾֐
//========================================================================
s32
mK7PanelSwitch05::mGetResult(void)
{
	if( mGetSelectEnd() == false )
	{
		return( PANEL_WORKING );
	}
	
	switch( mProc )
	{
		case	ePanelSwitch05Cancel:
			return( PANEL_OPERATE_CANCEL );
		
		case	ePanelSwitch05Decide:
		case	ePanelSwitch05Message:
		case	ePanelSwitch05MessageEnd:
			return( mSelectFlag );
		
		default:
			break;
	}
	
	return( PANEL_OPERATE_CANCEL );
}














