////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PlayEf0055  : LGtFNg0055iwuX}C̉j
//
// WK7PlayEf0055.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7PLAYEF0055_CPP__

#include ".\K7PlayEf0055.h"
#include ".\K7PlayEfHSScan.h"

K7PlayEf0055Instance::K7PlayEf0055Instance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffectInstance(pContainer,pAnchor,pJObj)
{
	int			i,j;
	f32			alpha[2][2];
	
	alpha[0][0] = 0.0f;
	alpha[0][1] = K7PLAYEFFECT_HSNONSCAN_ALPHA;
	alpha[1][0] = 1.0f;
	alpha[1][1] = 0.0f;
	
	mRelease = false;
	for(i=0 ; i<3 ; i++){
		for(j=0 ; j<2 ; j++){
			mpJObj[i][j] = NULL;
			if( (pJObj = ((K7PlayEf0055 *)pContainer)->mpJObj[i][j])==NULL ){
				mRelease = true;
				continue;
			}
			mpJObj[i][j] = pJObj;
			pJObj->CreateAlphaControl(alpha[j][0],false);
			pJObj->SetAlpha(alpha[j][1],4800);
			pJObj->Disp(false,true);
			if( j==0 ){
				pJObj->SetZSortPrioS(0,false,true);
			}else{
				WK7JObj		*pChild;
				pJObj->SetZSortPrioS(1,false,true);
				if( (pChild=pJObj->GetObj(K7CHRBONE_NECK,false,true))!=NULL ){
					pChild->SetZSortPrioS(4,false,true);
				}
				if( (pChild=pJObj->GetObj("YN_Face",false,true))!=NULL ){
					pChild->SetZSortPrioS(3,false,true);
				}
				if( (pChild=pJObj->GetObj("Eye_L",false,true))!=NULL ){
					pChild->SetZSortPrioS(2,false,true);
				}
				if( (pChild=pJObj->GetObj("Eye_R",false,true))!=NULL ){
					pChild->SetZSortPrioS(2,false,true);
				}
			}
		}
	}
}

K7PlayEf0055Instance::~K7PlayEf0055Instance()
{
	int		i,j;
	for(i=0 ; i<3 ; i++){
		for(j=0 ; j<2 ; j++){
			if( mpJObj[i][j]==NULL ){
				continue;
			}
			switch( j ){
			case	0: mpJObj[i][j]->SetAlpha(K7PLAYEFFECT_HSNONSCAN_ALPHA,false); break;
			case	1: 
			default:   mpJObj[i][j]->Hide(false,true); mpJObj[i][j]->ReleaseAlphaControl(); break;
			}
		}
	}
}

bool K7PlayEf0055Instance::FrameProcess(bool stopReq)
{
	if( stopReq==true || mRelease==true ){
		return false;
	}
	
	int			i,j;
	bool		result = false;
	
	for(i=0 ; i<3 ; i++){
		for(j=0 ; j<2 ; j++){
			if( mpJObj[i][j]==NULL ){
				continue;
			}
			if( mpJObj[i][j]->IsAnimatingAlpha()==true ){
				result = true;
			}else{
				if( j!=0 ){
					mpJObj[i][j]->Hide(false,true); 
				}
			}
		}
	}
	
	return result;
}

K7PlayEf0055::K7PlayEf0055(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj) : WK7PlayEffect(pPlay,pAnchor,pJObj)
{
	WK7PlayEffectInfo	*pEffectInfo = GetEffectInfo();
	WK7Model			*pModel;
	int					i,j;
	for(i=0 ; i<3 ; i++){
		for(j=0 ; j<2 ; j++){
			mpJObj[i][j] = NULL;
		}
	}
	if( pEffectInfo==NULL ){
		return;
	}
	static	const char	*pObjName[3][2] = {
		{ "HS_N_Root_01","YN1_N" },
		{ "HS_N_Root_02","YN2_N" },
		{ "HS_N_Root_03","YN3_N" },
	};
	if( (pModel = pEffectInfo->mpModel)!=NULL ){
		for(i=0 ; i<3 ; i++){
			for(j=0 ; j<2 ; j++){
				if( (pJObj = pModel->GetObj(pObjName[i][j]))!=NULL ){
					mpJObj[i][j] = pJObj;
					if( j==0 ){
						pJObj->Hide(false,true);
						pJObj->SetDstAlpha(WK7RenderObj::ConvRenderIDToAlpha(WK7RENDEROBJ_RENDERID_HALF+1),false,true);
					}else{
						pJObj->Disp(false,true);
					}
				}
			}
		}
	}
}

WK7PlayEffectInstance* K7PlayEf0055::CreateInstance(WK7JObj *pJObj)
{
	return new K7PlayEf0055Instance(this,&mInstanceAnchor,pJObj);
}

