////////////////////////////////////////////////////////////////////////////////
//
// Killer7 blood
//
// SK7Blood.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7BLOOD_CPP__

#include "SK7Blood.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "SK7Sprite.h"
#include "../matsu/mk7Sound.h"
#include "SK7Common.h"

#define		BLOOD_COLOR		(0xff0000f0)

//========================================================================
//					RXgN^
//========================================================================
SK7Blood::SK7Blood()
{
	for(int i = 0; i < SCENARIO_MAX_NUM; i++ ){
		m_pvMojiPos[i] 		= NULL;			//	|WVf[^
		m_iMojiNum[i] 		= 0;			//	̐
		m_pFontVector[i]	= NULL;
		m_sFontPosNum[i]	= 0;
	}
//	m_X=m_Y=m_Z=0; 
	m_pBloodInfo 			= NULL;
	m_pBloodInfo2 			= NULL;
	m_iBloodNum				= 0;			//	̐
	m_iBloodNum2			= 0;
	m_TexData 				= NULL;
//	m_TexData.Header 		= NULL;
	m_bBloodParam 			= false;
	m_b2DBloodDrawFlag		= false;
	m_sTexProc 				= 0;
	m_iBloodTime 			= 0;
	
}


//========================================================================
//					fXgN^
//========================================================================
SK7Blood::~SK7Blood()
{
}

//========================================================================
//					폜
//========================================================================
void		SK7Blood::Delete()
{
	//	eNX`[폜
//	GHMGCMEM_SAFE_FREE(m_TexData->Header);
	
	//	Wf[^폜
	for( int i = 0; i < SCENARIO_MAX_NUM; i++ ){
		GHM_SAFE_DELETE_ARRAY( m_pFontVector[i] );
		GHM_SAFE_DELETE_ARRAY( m_pvMojiPos[i] );
	}
	//	Rcf[^폜
	GHMGCMEM_SAFE_FREE( m_pBloodInfo );
	GHMGCMEM_SAFE_FREE( m_pBloodInfo2 );	
}

//========================================================================
//					IuWFNgϊ
//========================================================================
void		SK7Blood::CreateBloodObject( WK7Model* pModel, WK7Model* pModel2, u16 Num, f32 Power )
{
	//	Rc񔚔ϊ	--------------------------
	m_iBloodNum 	= ConvModelBlood( &m_pBloodInfo, 	pModel, Num, Power );
	if( pModel2 != NULL ){
		m_iBloodNum2 	= ConvModelBlood( &m_pBloodInfo2, 	pModel2, 30, Power );
	}
}

//========================================================================
//					̍W܂ł̋Zbg
//========================================================================
void		SK7Blood::SetMojiPoint(int sNo)
{
#pragma unused(sNo)
#if 0
	s16 a = 0;
	int i;
	
	for( i = 0; i < m_iBloodNum; i++ ){
		if( i >= m_iMojiNum[sNo]*(a+1) ){
			a++;
		}
		m_pBloodInfo[i].Speed.x = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].x+tblKanjiGap[sNo].x)-m_pBloodInfo[i].Point.x)/MOJI_FRAME;
		m_pBloodInfo[i].Speed.y = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].y+tblKanjiGap[sNo].y)-m_pBloodInfo[i].Point.y)/MOJI_FRAME;
		m_pBloodInfo[i].Speed.z = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].z+tblKanjiGap[sNo].z)-m_pBloodInfo[i].Point.z)/MOJI_FRAME;	
	}
	
	a = 0;
	for(  i = 0; i < m_iBloodNum2; i++ ){
		if( i >= m_iMojiNum[sNo]*(a+1) ){
			a++;
		}
		m_pBloodInfo2[i].Speed.x = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].x+tblKanjiGap[sNo].x)-m_pBloodInfo2[i].Point.x)/MOJI_FRAME;
		m_pBloodInfo2[i].Speed.y = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].y+tblKanjiGap[sNo].y)-m_pBloodInfo2[i].Point.y)/MOJI_FRAME;
		m_pBloodInfo2[i].Speed.z = ((m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].z+tblKanjiGap[sNo].z)-m_pBloodInfo2[i].Point.z)/MOJI_FRAME;	
	}
#endif
}

//========================================================================
//					IuWFNgϊ
//========================================================================
bool		SK7Blood::MoveBlood(int sNo)
{
#pragma unused(sNo)
	m_b2DBloodDrawFlag = true;
	if( m_iBloodTime == 0 ){
		gpSound->mStopSE(SFX_SYS_TITLE_WAIT);
		gpSound->mPlaySE(SFX_SYS_SCENARIO_TITLE,160);
	}

	m_iBloodTime++;

	if( m_iBloodTime > MOJI_STOP_TIME ){
		m_iBloodTime = 0;
		return true;
	}
#if 0
	s16 a = 0;
	int i;
	
	m_iBloodTime++;

	if( m_iBloodTime > MOJI_STOP_TIME ){
		m_iBloodTime = 0;
		return true;
	}
		
	if( m_iBloodTime == MOJI_FRAME ){
		for( i = 0; i < m_iBloodNum; i++ ){
			if( i >= m_iMojiNum[sNo]*(a+1) ){
				a++;
			}
			m_pBloodInfo[i].Point.x = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].x+tblKanjiGap[sNo].x;
			m_pBloodInfo[i].Point.y = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].y+tblKanjiGap[sNo].y;
			m_pBloodInfo[i].Point.z = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].z+tblKanjiGap[sNo].z;
		}
		a = 0;
		for( i = 0; i < m_iBloodNum2; i++ ){
			if( i >= m_iMojiNum[sNo]*(a+1) ){
				a++;
			}
			m_pBloodInfo2[i].Point.x = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].x+tblKanjiGap[sNo].x;
			m_pBloodInfo2[i].Point.y = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].y+tblKanjiGap[sNo].y;
			m_pBloodInfo2[i].Point.z = m_pvMojiPos[sNo][i-m_iMojiNum[sNo]*a].z+tblKanjiGap[sNo].z;
		}
		gpSound->mStopSE(SFX_SYS_TITLE_WAIT);
		gpSound->mPlaySE(SFX_SYS_SCENARIO_TITLE,160);
	}
	if( m_iBloodTime < MOJI_FRAME ){
		for( i = 0; i < m_iBloodNum; i++ ){
			VECTOR_ADD(m_pBloodInfo[i].Point,m_pBloodInfo[i].Speed);
		}
		if( sNo == 1 ){
			for( i = 0; i < m_iBloodNum2; i++ ){
				VECTOR_ADD(m_pBloodInfo2[i].Point,m_pBloodInfo2[i].Speed);
			}
		}
		return false;
	}
#endif
	return false;
}

//========================================================================
//					IuWFNgϊ
//========================================================================
bool		SK7Blood::MoveRedBlood(int sNo)
{
	int i;
	for( i = 0; i < m_iBloodNum; i++ ){
		VECTOR_ADD(m_pBloodInfo[i].Point,m_pBloodInfo[i].Speed);
	}
	if( sNo == 1 ){
		for( i = 0; i < m_iBloodNum2; i++ ){
			VECTOR_ADD(m_pBloodInfo2[i].Point,m_pBloodInfo2[i].Speed);
		}
	}
	//	ړ	======================================
	if( ++m_iBloodTime >= MOJI_STOP_TIME ){
		m_iBloodTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					`
//========================================================================
void		SK7Blood::DrawBlood2D( int No )
{
	if( m_b2DBloodDrawFlag == false )	return;

	Set2DCamera();
	SetGraphMode();
	SetTevStage();
	SetVertex();
	//	|CgXvCgeNX`ݒ
	GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_TRUE);
	
	//	TCYݒ
	GXSetPointSize(75, GX_TO_ONE);
	GXLoadTexObj( &m_TexData->Obj, GX_TEXMAP0 );
	
	int i;
	//	X^[g
	GXBegin( GX_POINTS, GX_VTXFMT0, (u16)m_sFontPosNum[No] );
	
	VEC2U16* pVec = m_pFontVector[No];
	for( i = 0; i < m_sFontPosNum[No]; i++ ){
		GXPosition3f32( pVec[i].x,  pVec[i].y, 0.0f );
		GXColor1u32   ( BLOOD_COLOR );
		GXTexCoord2f32( 0.0f, 0.0f );
	}
	GXEnd();

}

//========================================================================
//					IuWFNg`
//========================================================================
void		SK7Blood::DrawBlood()
{
	if( m_b2DBloodDrawFlag == true )	return;
//	@Jݒ	
	// ˉe
	f32 Fov, Aspect, Near, Far;
	Mtx View;
	Mtx44 mtx;
	
	//	
	HSD_CObjGetPerspective( WK7CAM->GetCObj(), &Fov, &Aspect );
	Near = HSD_CObjGetNear( WK7CAM->GetCObj() );
	Far = HSD_CObjGetFar( WK7CAM->GetCObj() );
	
	// ˉes쐬
	MTXPerspective( mtx, Fov, Aspect, Near, Far );
	GXSetProjection( mtx, GX_PERSPECTIVE );
	
	// r[s̎擾
	HSD_CObjGetViewingMtx( WK7CAM->GetCObj(), View ); 
	
	// }gbNXZbg
	GXLoadPosMtxImm( View, 0 );			//	posr[sZbg
	GXLoadNrmMtxImm( View, 0 );			//	@r[sZbg
	GXSetCurrentMtx( 0 ) ;				//	JgZbg
	
//	@Zbuff@At@ݒ	

	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );	
//	GXSetZMode( GX_FALSE, GX_LEQUAL, GX_FALSE );	//	Zobt@r[h̐ݒ
	GXSetCullMode( GX_CULL_NONE ) ;	//	JO
	GXSetColorUpdate( GX_TRUE );	//	J[obt@̍XVݒ
	
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ
	GXSetNumChans( 1 );
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){255, 255, 255, 255} ) ;
	GXSetChanMatColor( GX_COLOR0A0, (GXColor){255, 255, 255, 255} ) ;
//    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_VTX, GX_SRC_VTX,GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;
//    GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
    GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
		
	//	At@
	GXSetDither      (GX_FALSE);	
	GXSetAlphaUpdate (GX_TRUE);
	GXSetDstAlpha    (GX_TRUE,255);
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);


//	@TEVݒ	

	//uh[hݒ
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	//TEVXe[Wŗp\ɂeNX`W̐ݒ
	GXSetNumTexGens( 1 );
	//eNX`W̕@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	
	//TEVXe[WŔJ[
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );

//	@_ݒ	
	SetVertex();
	
	//	eNX`[h
	GXLoadTexObj( &m_TexData->Obj, GX_TEXMAP0 );

	if( !m_bBloodParam ){
		GXEnableTexOffsets	( GX_TEXCOORD0, GX_FALSE, GX_TRUE );
		GXSetPointSize		( SK7BLOOD_SIZE,GX_TO_ONE );
	
#if __BLOOD_DEBUG__
		static 	f32 MX = 0.0f;
		static	f32 MY = 0.0f;
		static	f32 MZ = 0.0f;
		
		MX += HSD_PadGetNormalSubStickX(0);
		if( HSD_PadGetRepeat(0) & HSD_PAD_UP )		MY += 0.1f;
		if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN )	MY -= 0.1f;
		MZ += HSD_PadGetNormalSubStickY(0);
#endif
		
		int i;
		
		//	X^[g
		GXBegin( GX_POINTS, GX_VTXFMT0, (u16)m_iBloodNum );
		
		for( i = 0; i < m_iBloodNum; i++ )
		{		
			
#if __BLOOD_DEBUG__
			GXPosition3f32( m_pBloodInfo[i].Point.x+MX, m_pBloodInfo[i].Point.y+MY, m_pBloodInfo[i].Point.z+MZ); 
#else
			GXPosition3f32( m_pBloodInfo[i].Point.x, m_pBloodInfo[i].Point.y, m_pBloodInfo[i].Point.z); 
#endif
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 0.0f );
		}
		GXEnd();
		
			//	X^[g
		GXBegin( GX_POINTS, GX_VTXFMT0, (u16)m_iBloodNum2 );
		
		for( i = 0; i < m_iBloodNum2; i++ )
		{			
			GXPosition3f32( m_pBloodInfo2[i].Point.x, m_pBloodInfo2[i].Point.y, m_pBloodInfo2[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 0.0f );
		}	
		GXEnd();
	}else{	
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(m_iBloodNum*4) );
		
		float w = 0.2f;
		float h = 0.2f;
		for( int i = 0; i < m_iBloodNum; i++ )
		{
			GXPosition3f32( m_pBloodInfo[i].Point.x, m_pBloodInfo[i].Point.y, m_pBloodInfo[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 0.0f );
			
			GXPosition3f32( m_pBloodInfo[i].Point.x+w, m_pBloodInfo[i].Point.y, m_pBloodInfo[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 1.0f, 0.0f );
			
			GXPosition3f32( m_pBloodInfo[i].Point.x+w, m_pBloodInfo[i].Point.y+h, m_pBloodInfo[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 1.0f, 1.0f );
			
			GXPosition3f32( m_pBloodInfo[i].Point.x, m_pBloodInfo[i].Point.y+h, m_pBloodInfo[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 1.0f );
		}
		GXEnd();
		
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)(m_iBloodNum2*4) );
		
		for( int i = 0; i < m_iBloodNum2; i++ )
		{
			GXPosition3f32( m_pBloodInfo2[i].Point.x, m_pBloodInfo2[i].Point.y, m_pBloodInfo2[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 0.0f );
			
			GXPosition3f32( m_pBloodInfo2[i].Point.x+w, m_pBloodInfo2[i].Point.y, m_pBloodInfo2[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 1.0f, 0.0f );
			
			GXPosition3f32( m_pBloodInfo2[i].Point.x+w, m_pBloodInfo2[i].Point.y+h, m_pBloodInfo2[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 1.0f, 1.0f );
			
			GXPosition3f32( m_pBloodInfo2[i].Point.x, m_pBloodInfo2[i].Point.y+h, m_pBloodInfo2[i].Point.z); 
			GXColor1u32   ( BLOOD_COLOR );
			GXTexCoord2f32( 0.0f, 1.0f );
		}
		GXEnd();
	}
}


//========================================================================
//					IuWFNgϊ
//========================================================================
bool		SK7Blood::ReadKanjiData2( int no, void* pData )
{
	m_sFontPosNum[no] = m_File.ReadKanjiFile( &m_pFontVector[no], pData );
	return true;
}
