////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Common
//
// SK7Common.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7COMMON_H__
#define	__SK7COMMON_H__

#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTex.h"
#include "../matsu/mK7Jimaku.h"

#define		__NOWNOW__


enum{
	FILE_OPEN = 0,
	FILE_READ,
	FILE_WAIT,
	FILE_CLOSE,
};


#define		SK7_KEY_UP 			(1<<0)
#define		SK7_KEY_DOWN		(1<<1)
#define		SK7_KEY_RIGHT		(1<<2)
#define		SK7_KEY_LEFT		(1<<3)
#define		SK7_KEY_RIGHT_UP	(1<<4)
#define		SK7_KEY_RIGHT_DOWN	(1<<5)
#define		SK7_KEY_LEFT_UP		(1<<6)
#define		SK7_KEY_LEFT_DOWN	(1<<7)

//	eNX`f[^\
typedef struct
{
	GhmGcTexHeader *Header;
	GXTexObj Obj;
}TEX_DATA;

//	QxNg
typedef struct
{
	f32 x,y;
}VEC2;

typedef struct{
	u16 x,y;
}VEC2U16;

typedef struct{
	s16 x,y;
}VEC2S16;

//	eNX`[̍\
typedef struct{
	VEC2	XY;
	u8		TexNo;
}TEX_PARAM;

//	xNgZbg
#define	SET_VECTOR( V, X, Y, Z )\
	{\
		V.x = X;\
		V.y = Y;\
		V.z = Z;\
	}
//	
#define	SET_VEC2XY( VA, X, Y )\
	{\
		VA.x = X;\
		VA.y = Y;\
	}
//	t[Xs[hZbg
#define	SET_FRAMESPEED( SPEED, NEXT, NOW, FRAME )\
	{\
		SPEED.x = (NEXT.x - NOW.x)/FRAME;\
		SPEED.y = (NEXT.y - NOW.y)/FRAME;\
		SPEED.z = (NEXT.z - NOW.z)/FRAME;\
	}
	
//	t[Xs[h+]Zbg
#define	SET_FRAMESPEEDROT( SPEED, NEXT, NOW, FRAME )\
	{\
		SPEED.x 	= (NEXT.x - NOW.x)/FRAME;\
		SPEED.y 	= (NEXT.y - NOW.y)/FRAME;\
		SPEED.z 	= (NEXT.z - NOW.z)/FRAME;\
		SPEED.rot 	= (NEXT.rot - NOW.rot)/FRAME;\
	}
	
//	Xs[hZ
#define	ADD_IMODEL_SPEED( ANS, SPEED )\
	{\
		ANS.x 	+= SPEED.x;\
		ANS.y 	+= SPEED.y;\
		ANS.z 	+= SPEED.z;\
		ANS.rot	+= SPEED.rot;\
	}
	
//	fobNp	f̃|WV߂
#define		DEBUG_GET_MODEL_POS( PMODEL )\
	{\
		Vec vModelPos;\
		Vec vModelRot;\
		PMODEL->GetPosition( &vModelPos );\
		PMODEL->GetRotation( &vModelRot );\
		vModelPos.x += HSD_PadGetNormalStickX(0);\
		vModelPos.y += HSD_PadGetNormalStickY(0);\
		vModelPos.z += HSD_PadGetNormalSubStickY(0);\
		vModelRot.y += HSD_PadGetNormalSubStickX(0);\
		if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){\
			vModelRot.x += 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){\
			vModelRot.x -= 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){\
			vModelRot.z += 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){\
			vModelRot.z -= 0.02f;\
		}\
		GHM_LIMIT_RANGE(vModelRot.x, PI, -PI);\
		GHM_LIMIT_RANGE(vModelRot.y, PI, -PI);\
	 	PMODEL->SetPosition( &vModelPos );\
	 	PMODEL->SetRotation( &vModelRot );\
	}

//	fobNp	J̃|WV߂
#define		DEBUG_GET_CAMERA_POS( PCAMERA )\
	{\
		Vec vCamPos;\
		Vec vCamRot;\
		PCAMERA->GetPosition( vCamPos );\
		PCAMERA->GetRotation( vCamRot );\
		vCamPos.x += HSD_PadGetNormalStickX(0);\
		vCamPos.y += HSD_PadGetNormalStickY(0);\
		vCamPos.z += HSD_PadGetNormalSubStickY(0);\
		vCamRot.y += HSD_PadGetNormalSubStickX(0);\
		if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){\
			vCamRot.x += 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){\
			vCamRot.x -= 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){\
			vCamRot.z += 0.02f;\
		}\
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){\
			vCamRot.z -= 0.02f;\
		}\
		GHM_LIMIT_RANGE(vCamRot.x, PI, -PI);\
		GHM_LIMIT_RANGE(vCamRot.y, PI, -PI);\
	 	PCAMERA->SetPosition( vCamPos.x,vCamPos.y,vCamPos.z );\
	 	PCAMERA->SetRotation( vCamRot.x,vCamRot.y,vCamRot.z );\
	}

//	fobNp@Qc摜̃|WV悤
#define		DEBUG_GET_2D_POS( PSPRITE )\
{\
	Vec vPos = *(PSPRITE.GetPos0());\
	vPos.x += HSD_PadGetNormalStickX(0) * 5.0f;\
	vPos.y -= HSD_PadGetNormalStickY(0) * 5.0f;\
	PSPRITE.SetPos0(vPos);\
}

#define		DEBUG_GET_2D_POS2( PSPRITE )\
{\
	VEC2 vPos;\
	vPos.x = PSPRITE.GetX0();\
	vPos.y = PSPRITE.GetY0();\
	Vec vSize;\
	vSize.x = (PSPRITE.GetSizeX());\
	vSize.y = (PSPRITE.GetSizeY());\
	vPos.x += HSD_PadGetNormalStickX(0) * 5.0f;\
	vPos.y -= HSD_PadGetNormalStickY(0) * 5.0f;\
	vSize.x += HSD_PadGetNormalSubStickX(0) * 5.0f;\
	vSize.y += HSD_PadGetNormalSubStickY(0) * 5.0f;\
	PSPRITE.SetXY0(vPos.x, vPos.y);\
	PSPRITE.SetTwoSize( vSize.x, vSize.y );\
}

//	fobNp@QctHg̃|WV悤
#define		DEBUG_GET_FONT_POS( PFONT )\
{\
	VEC2 vPos = *(PFONT.GetPos());\
	vPos.x += HSD_PadGetNormalStickX(0) * 5.0f;\
	vPos.y -= HSD_PadGetNormalStickY(0) * 5.0f;\
	PFONT.SetPos(&vPos);\
}

//	XvCg̉]
#define		SET_SPRITE_ROT( SP, ANGLE, CENTERX, CENTERY, SIZEX, SIZEY )\
	{\
		Mtx m;\
		MTXRotDeg( m, 'z', ANGLE );\
		(SP)->SetFlag( true, VTX4_FLAG );\
		f32 SX = SIZEX*0.5f, SY = SIZEY*0.5f;\
		Vec v={-SX,-SY,0};\
		MTXMultVec( m, &v, &v );\
		(SP)->SetXY0( CENTERX+v.x , CENTERY+v.y );\
		v.x = SX; v.y = -SY;\
		MTXMultVec( m, &v, &v );\
		(SP)->SetXY1( CENTERX+v.x , CENTERY+v.y );\
		v.x = -SX; v.y = SY;\
		MTXMultVec( m, &v, &v );\
		(SP)->SetXY2( CENTERX+v.x, CENTERY+v.y );\
		v.x = SX; v.y = SY;\
		MTXMultVec( m, &v, &v );\
		(SP)->SetXY3( CENTERX+v.x, CENTERY+v.y );\
	}

//	RctHg
#define		DRAW_FONT_STR( PFONT, X, Y, INDEX, COLOR, EX, CENTER, RENDER  )\
	{\
		PFONT->DrawSetup();\
		PFONT->SetColor2( COLOR );\
		PFONT->SetExRate( EX );\
		PFONT->DrawStr( X, Y, INDEX, CENTER, RENDER );\
	}
#define		DRAW_FONT_STRP( PFONT, X, Y, INDEX, COLOR, EX, CENTER, RENDER, PY  )\
	{\
		PFONT->DrawSetup();\
		PFONT->SetColor2( COLOR );\
		PFONT->SetExRate( EX );\
		PFONT->DrawStrPack( X, Y, INDEX, PY, CENTER, RENDER );\
	}


extern void		InitTexture( TEX_DATA *pData, bool filt=false );
extern void		Get3Dto2D( Vec *pPos, Vec *Ans );
extern bool 	CheckPointLine(Vec *a,Vec *b,Vec *c);
extern bool		CheckPointTriangle(Vec *a,Vec *b,Vec *c, Vec *p);
extern void 	MakeModelMtx ( Vec xAxis, Vec yAxis, Vec zAxis, Mtx m );
extern void		Get2Dto3D( Vec& v, f32 Z );

extern void		Set2DCamera();
extern void		SetGraphMode();
extern void		SetTevStage();
extern void		SetTevStageI4();
extern void		SetTevStageNoTex();
extern void		SetVertex();
extern void		SetVertexNoTex();

extern bool		CheckKeyT( u8 KeyNo );
extern bool		CheckKeyR( u8 KeyNo );
extern bool		CheckKeyN( u8 KeyNo );

extern void		DrawSousaLine();
extern s8		CheckStageNo();
extern u8		GetPlayerNo(u32 MainID);
extern u32		GetPlayerID( u8 MainID );

//
//	t@CNX
class SK7File
{
protected:
	u16			m_sFileEvent; 
	ghmGcFile	m_File;
	
public:
	SK7File();
	~SK7File();
	
	//	t@CǍ݁i񓯊j
	bool		OpenTexFile( char* FileName,TEX_DATA *pTex);
	bool		OpenTexFileB( char* FileName, TEX_DATA *pTex );
	void*		OpenFile( char* FileName );
	bool		OpenDataFile( char* FileName, void** Data );
	int			ReadKanjiFile( Vec** OutData, void* Buff );
	int			ReadKanjiFile( VEC2U16** OutData, void* Buff );
	int			ReadStarFile( VEC2** OutData, void* Buff );
	
	void		Close(){ m_File.Close(); }
};

class Vector3;

class Vector3
{
public:
	f32 x,y,z;
	
	Vector3(){};
	Vector3(f32 inX, f32 inY, f32 inZ);
	Vector3(const Vector3 &v);
	
	Vector3               &operator =  (const Vector3 &v);
	Vector3               &operator += (const Vector3 &v);
	Vector3               &operator -= (const Vector3 &v);
	Vector3               &operator *= (float f);
	Vector3               &operator /= (float f);
	friend bool           operator == (const Vector3 &a, const Vector3 &b);
	friend bool           operator != (const Vector3 &a, const Vector3 &b);
	friend Vector3        operator - (const Vector3 &a);
	friend Vector3        operator + (const Vector3 &a, const Vector3 &b);
	friend Vector3        operator - (const Vector3 &a, const Vector3 &b);
	friend Vector3        operator * (const Vector3 &v, float f);
	friend Vector3        operator * (float f, const Vector3 &v);
	friend Vector3        operator / (const Vector3 &v, float f);
	
	f32                 length() const;
	f32                 lengthSqr() const;
	bool                isZero() const;
	Vector3             &normalize();  
};

#endif	
//__SK7COMMON_H__


