////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7ErrorCheck.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//	
////////////////////////////////////////////////////////////////////////////////

#define	__SK7ERRORCHECK_CPP__

#include "..\Lib\ghmGcFile.h"
#include "SK7ErrorCheck.h"
#include "SK7Pack.h"
#include "SK7Sprite.h"
#include "..\Matsu\mK7EngTelop.h"
#include "..\Matsu\mK7Sound.h"
#include "..\Matsu\mK7Jimaku.h"
#include "..\Matsu\mK7Movie.h"

#define	ERROR_MES_X				(100)
#define	ERROR_MES_Y(NO)			(130+33*NO)
#define	ERROR_FONT_DATA				"/Texture/Error_GC.BIN"
#define	ERROR_MOVIE_INIT_FRAME	(-3)

#define	DRAW_SPRITE\
{\
	SK7Sprite sprite;\
	sprite.SetSprite( 0,0,640,480,0x000000ff );\
	sprite.SetVisible( true );\
	sprite.Render();\
}

unsigned char	error_gc_data[] ATTRIBUTE_ALIGN(32) = {
#include "Error_GC.C"
};

//========================================================================
//					I
//========================================================================
bool 	SK7ErrorCheck::Terminate(void)
{
	m_YFont.Release();
	
	return true;
} 

//========================================================================
//					_O
//========================================================================
bool 	SK7ErrorCheck::RenderProcess(void)
{
//	if( ghmGcFile::GetDriveState() != DVD_STATE_BUSY ){
	m_lErrorNo = ghmGcFile::GetDriveState(); 
//	}
	
	switch( m_lErrorNo ){
	case	DVD_STATE_FATAL_ERROR:
		DRAW_SPRITE;
		SetPause();
		m_YFont.DrawSetup();
		m_YFont.SetExRate(1.2f);
		m_YFont.SetColor2(0xffffffff);
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "G[܂B");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "{̂̃p[{^");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(2), false, true, "dOFFɂA" );
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(3), false, true, "{̂̎戵̎w");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(4), false, true, "]ĂB");
		break;
		
	case	DVD_STATE_NO_DISK:
		DRAW_SPRITE;
		SetPause();
		m_YFont.DrawSetup();
		m_YFont.SetExRate(1.2f);
		m_YFont.SetColor2(0xffffffff);
		if( ghmGcFile::GetReserveDiskID() == 0 ){
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "killer7̃fBXN1");
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "ZbgĂB");
		}else{
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "killer7̃fBXN2");
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "ZbgĂB");
		}
		break;
		
	case	DVD_STATE_COVER_OPEN:
		DRAW_SPRITE;
		SetPause();
		m_YFont.DrawSetup();
		m_YFont.SetExRate(1.2f);
		m_YFont.SetColor2(0xffffffff);
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "fBXNJo[JĂ܂B");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(2), false, true, "Q[𑱂ꍇ́A");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(3), false, true, "fBXNJo[߂ĂB");
		break;
		
	case	DVD_STATE_WRONG_DISK:
		DRAW_SPRITE;
		SetPause();
		m_YFont.DrawSetup();
		m_YFont.SetExRate(1.2f);
		m_YFont.SetColor2(0xffffffff);
		if( ghmGcFile::GetReserveDiskID() == 0 ){
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "killer7̃fBXN1");
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "ZbgĂB");
		}else{
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "killer7̃fBXN2");
			m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "ZbgĂB");
		}
		break;
		
	case	DVD_STATE_RETRY:
		DRAW_SPRITE;
		SetPause();
		m_YFont.DrawSetup();
		m_YFont.SetExRate(1.2f);
		m_YFont.SetColor2(0xffffffff);
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "fBXNǂ߂܂łB");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(1), false, true, "킵́A{̂̎戵");
		m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(2), false, true, "ǂ݂B");
		break;	
		
	case DVD_STATE_BUSY:
		if( m_bErrorFlag ){
			SetPause();
			DispDiscChecking();
		}
		break;
		
	case DVD_STATE_END:
		if( m_bErrorFlag ){
			if( ResetPause() == false ){
				DispDiscChecking();
			}
		}
		break;
	}
	return true;
}

//========================================================================
//					RXgN^
//========================================================================
SK7ErrorCheck::SK7ErrorCheck()
{
	m_lErrorNo  = DVD_STATE_END;
	m_bErrorFlag = false;
	m_ErrorData	 = NULL;
	mMovieFrame  = ERROR_MOVIE_INIT_FRAME;
}

//========================================================================
//					[h
//========================================================================
bool	SK7ErrorCheck::Load()
{
	if( (m_ErrorData = error_gc_data)!= NULL ){
//	if( (m_ErrorData = m_File.OpenFile( ERROR_FONT_DATA ))!= NULL ){
		m_YFont.LoadMem( m_ErrorData );	
		return true;
	}
	return false;
}


//========================================================================
//					fXgN^
//========================================================================
SK7ErrorCheck::~SK7ErrorCheck()
{
	Terminate();
}

//========================================================================
//					fBXN`FbNł\
//========================================================================
void	SK7ErrorCheck::DispDiscChecking(void)
{
	DRAW_SPRITE;
	m_YFont.DrawSetup();
	m_YFont.SetExRate(1.2f);
	m_YFont.SetColor2(0xffffffff);
	m_YFont.DrawFSStr( ERROR_MES_X, ERROR_MES_Y(0), false, true, "fBXN`FbNĂ܂B");
}

//========================================================================
//					|[YZbg
//========================================================================
void	SK7ErrorCheck::SetPause()
{
	m_bErrorFlag = true;
	//
	if( gpJimaku != NULL ){
		if( gpMovie->mGetStatus() == eMvProcStandby ){
			gpJimaku->mSetPause();
		}else{
			//movieĐdecode~܂Ŏ~߂Ȃ
			if( mMovieFrame == gpMovie->mGetFrame() ){
				gpJimaku->mSetPause();
			}else
			{
				mMovieFrame = gpMovie->mGetFrame();
			}
		}
	}
	//pebv
	if( gpEngTelop != NULL ){
		if( gpMovie->mGetStatus() == eMvProcStandby ){
			gpEngTelop->mSetPause();
		}else{
			//movieĐdecode~܂Ŏ~߂Ȃ
			if( mMovieFrame == gpMovie->mGetFrame() ){
				gpEngTelop->mSetPause();
			}
		}
	}
	//TEh
	if( gpSound != NULL ){
		gpSound->mSetPauseStream();
	}
	//[r[
	if( gpMovie != NULL ){
		gpMovie->mSetPause();
	}
}

//========================================================================
//					|[YZbg
//========================================================================
bool	SK7ErrorCheck::ResetPause()
{
	bool jimaku, engTelop, sound, movie;
	jimaku = engTelop = sound = movie = false;
	
	//
	if( gpJimaku != NULL ){
		if( gpMovie->mGetStatus() == eMvProcStandby ){
			gpJimaku->mReleasePause();
			jimaku = true;
		}else{
			//movieĐdecodeJn܂Ŏ͐i߂Ȃ
			if( mMovieFrame != gpMovie->mGetFrame() ){
				gpJimaku->mReleasePause();
				jimaku = true;
				mMovieFrame = ERROR_MOVIE_INIT_FRAME;
			}
		}
	}else{
		jimaku = true;
	}
	//pebv
	if( gpEngTelop != NULL ){
		if( gpMovie->mGetStatus() == eMvProcStandby ){
			gpEngTelop->mReleasePause();
			engTelop = true;
		}else{
			//movieĐdecodeJn܂Ŏ͐i߂Ȃ
			if( mMovieFrame != gpMovie->mGetFrame() ){
				gpEngTelop->mReleasePause();
				engTelop = true;
			}
		}
	}else{
		engTelop = true;
	}
	//TEh
	if( gpSound != NULL ){
		gpSound->mReleasePauseStream();
		sound = true;
	}else{
		sound = true;
	}
	//[r[
	if( gpMovie != NULL ){
		gpMovie->mReleasePause();
		movie = true;
	}else{
		movie = true;
	}
	
	//SẴ|[YłĂG[tO𗎂Ƃ
	if( (jimaku == true) && (engTelop == true) && (sound == true) && (movie == true) )
	{
		m_bErrorFlag = false;
		return true;
	}
	
	return false;
}
