////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Font
//
// SK7Font.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7FONT_H__
#define	__SK7FONT_H__

#include "../matsu/mK7Jimaku.h"
#include "SK7Common.h"
#include "SK7Sprite.h"


#define			SK7FONT_MAX_NUM			(30)
#define			SK7FONT_SPACE			(66.0f)
#define			SK7FONT_MOVE_R			(1.0f)
#define			SK7FONT_MOVE_FRAME		(10)
#define			SK7FONT_MOVE_RANGE		(3.0f)

#define			FONT_EFC_MOVE			(1<<0)	//	ړ
#define			FONT_EFC_BIG			(1<<1)	//	g
#define			FONT_EFC_ONE			(1<<2)	//	ꕶW炵
#define			FONT_EFC_ONEMOVE		(1<<3)	//	ꕶړ
#define			FONT_EFC_RENDER			(1<<4)	//	`tO
#define			FONT_EFC_BIG2			(1<<5)	//	g啶炵
#define			FONT_EFC_SPACE			(1<<6)	//	Xy[X̃TCYZbg
#define			FONT_EFC_TEX			(1<<7)	//	eNX`[݂̂ł̃Zbg

typedef struct{
	stSentence*					m_Data;
	stOneSentence*				m_SentenceDat;
	stFontParam*				m_FParam;				//uvwhl̓Ăe[uւ̃|C^
	TEX_DATA					m_Tex;
}stJimakuParam;



//
//	tHgNX
class SK7Font
{
protected:
	SK7File						m_File;
	stJimakuParam				m_FontData;

	VEC2						m_vEffectMove[SK7FONT_MAX_NUM];
	VEC2						m_vBasePos[SK7FONT_MAX_NUM];
	VEC2						m_vFontPos[SK7FONT_MAX_NUM];
	VEC2						m_vStartPos;
	VEC2						m_vExpan;
	VEC2						m_vOne;
	VEC2						m_vBetween;
	f32							m_fSpaceSize;
	f32							m_fMoveSize;
	u32							m_Color;
	u32							m_lEffectFlag;
	u16							m_usFontNum;
	u16							m_usChageNo;
	u8							m_ucLineNo;
	u8							m_ucBlockNo;
	int							m_iMoveTime;
	int							m_iMoveFrame;
	f32*						m_pfEx;
	
	//	֐	==================================================
	void					SetEffectMove();
	bool					SetFontVector();

public:
	SK7Font();
	~SK7Font();

	//	[h	*****************************************
	bool			LoadFont(char*, u8 LineNo=0, u8 BlockNo=0 );
	
	//	`	*****************************************
	void  			RenderLine();

	//	폜	*****************************************
	void			Delete(){	GHMGCMEM_SAFE_FREE( m_FontData.m_Data );  }
	void			Release();
	
	//	Zbg	*****************************************
	void			SetColor( u32 Color )			{ 	m_Color = Color; }
	void			SetAlpha( u8 Alpha );
	void			SetPos	( VEC2* pPos )			{ 	m_vStartPos = *pPos; }
	void			SetPos	( f32 x, f32 y )		{ 	m_vStartPos.x = x, m_vStartPos.y = y; }
	void			SetX	( f32 x )				{ 	m_vStartPos.x = x; }
	void			SetY	( f32 y )				{ 	m_vStartPos.y = y; }
	void			SetOnePos( u8 No, VEC2* vPos )	{	m_vFontPos[No] = *vPos; }
	void			SetMoveSize( f32 Size )			{	m_fMoveSize = Size; }
	void			SetMoveFrame( int Frame )		{ 	m_iMoveFrame = Frame; }
	void			SetEx	( VEC2* pEx )			{	m_vExpan = *pEx; }
	void			SetEx	( f32 x, f32 y )		{	m_vExpan.x = x, m_vExpan.y = y; }
	void			SetData	( stJimakuParam* pJimaku, u8 LineNo=0, u8 BlockNo=0 ){ m_FontData = *pJimaku; m_ucLineNo = LineNo; m_ucBlockNo = BlockNo; SetFontVector(); }
	void			SetData ( stSentence* pData, u8 LineNo=0, u8 BlockNo=0 );
	void			SetData ( TEX_DATA* pTex, s16* FileNo );
	void			SetFlag	( bool set, int bit){	(set==true) ? m_lEffectFlag |= bit : m_lEffectFlag &= ~bit; }
	void			SetLine	( u8 LineNo, u8 BlockNo=0 ){	m_ucLineNo = LineNo; m_ucBlockNo = BlockNo; SetFontVector(); }
	void			SetSpace( f32 size ){ m_fSpaceSize = size; SetFlag( true, FONT_EFC_SPACE );	SetFontVector(); }
	bool			SetBlockLine( u8 BlockNo, u8 LineNo ){ m_ucBlockNo = BlockNo, m_ucLineNo = LineNo; return SetFontVector();	}
	void			SetChangeFont( u16 FontNo, VEC2* pSize );
	void			SetBetween( f32 x, f32 y ){ m_vBetween.x = x, m_vBetween.y = y; }
	void			InitEffectMovePower(){ for( int i = 0; i < SK7FONT_MAX_NUM; i++ )	m_vEffectMove[i].x = m_vEffectMove[i].y = 0; }
	
	void			SetFontLine( f32 x, f32 y, u32 Color, u8 BlockNo, u8 LineNo, stJimakuParam* pJimaku );
	void  			SetFontLine( f32 x, f32 y, u32 Color, u8 BlockNo, u8 LineNo, stSentence* pJimaku );

	//	Qbg	*****************************************
	stJimakuParam*	GetData()			{	return &m_FontData; }
	VEC2*			GetPos()			{ 	return &m_vStartPos; }
	VEC2*			GetEx()				{	return &m_vExpan; }
	VEC2*			GetOnePos( u8 No )	{ 	return &m_vFontPos[No]; }
	VEC2*			GetBasePos( u8 No )	{	return &m_vBasePos[No]; }
	f32				GetSpace()			{	return m_fSpaceSize; }
	f32				GetFontLengthX(bool space=true);
	f32				GetFontLengthY( u8 no )	{	return m_FontData.m_FParam[m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo].chardat[no]].h; } 
	u16				GetFontNum()		{ 	return m_usFontNum; }
	u32				GetFontColor()		{ 	return m_Color; }
	u8				GetAlpha()			{	return (u8)((m_Color<<24)>>24); }
	u8				GetSpaceNum();
	f32*			GetOneEx()			{	return m_pfEx; }
	u8				GetDataBlockNum();
	u8				GetDataLineNum();
	s32				GetFontLeftNo()		{ 	return m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo].wait; }
	s32				GetFontRightNo()	{ 	return m_FontData.m_SentenceDat[m_ucBlockNo].jimaku[m_ucLineNo].disptime; }
	bool			GetVisible()		{	return (m_lEffectFlag & FONT_EFC_RENDER) ? true : false;  }
};


#endif
//__SK7FONT_H__


