////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuColor
//
// SK7IMenuColor.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUCOLOR_H__
#define	__SK7IMENUCOLOR_H__

#include "SK7IMenuBase.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"

#define		COLOR_CHIP_NUM		(16)
#define		COLOR_ANSWER_NUM	(7)
#define		COLOR_SELECT_NUM	(9)
#define		COLOR_NOW_NUM		(7)

enum{
	TEX_FONT_DATA=0,
	YAM_DATA_MAX,
};

enum{
	TEX_R1PIECE=0,
	TEX_G1PIECE,
	TEX_B1PIECE,
	TEX_RG2PIECE,
	TEX_GB2PIECE,
	TEX_PIECE3,
	TEX_R1PIECE_KASAN,
	TEX_G1PIECE_KASAN,
	TEX_RG2PIECE_KASAN,
	TEX_GB2PIECE_KASAN,
	TEX_PIECE3_KASAN,
	TEX_ARROW,
	TEX_BACKGROUND,
	TEX_COLOR_MAX,
};

//	`bvJ[
enum{
	CHIP_COLOR_R=0,
	CHIP_COLOR_G,
	CHIP_COLOR_B,
	CHIP_COLOR_RG,
	CHIP_COLOR_GB,
	CHIP_COLOR_RGB,
};


const GXColor tblAnswer[]={
	{157,35,44},
	{32,33,163},
	{115,44,142},
	{76,49,52},
	{192,142,182},
	{130,29,54},
	{220,220,220},
	{0,0,0},
	{255,255,255},
};

struct CHIP_STATE{
	VEC2		vPos;
	u8			Color0;			//	J[
	u8			Color1;
	u8			TexNo;			//	eNX`[ԍ
};

typedef struct {
	u8 No0;
	u8 No1;
	u8 TexNo;
}COLOR_NO;



const COLOR_NO	tblChipSetState[]={
	157, 	0, 		CHIP_COLOR_R,
	33, 	0, 		CHIP_COLOR_G,
	115,	0,		CHIP_COLOR_R,
	142,	0,		CHIP_COLOR_B,
	76,		0,		CHIP_COLOR_R,
	142,	182,	CHIP_COLOR_GB,
	54,		0,		CHIP_COLOR_B,
};


//	`bvXeCg
const CHIP_STATE	tblChipState[]={
	353, 	251,		49,		52,			CHIP_COLOR_GB,
	299,	157,		32,		0,			CHIP_COLOR_R,
	407,	110,		44,		0,			CHIP_COLOR_B,
	299,	298,		192,	0,			CHIP_COLOR_R,
	353,	204,		44,		0,			CHIP_COLOR_G,
	407,	157,		163,	0,			CHIP_COLOR_B,
	353,	110,		35,		0,			CHIP_COLOR_G,
	299,	392,		220,	0,			CHIP_COLOR_RGB,
	299,	345,		130,	29,			CHIP_COLOR_RG,	
};

//	J[pl 
class SK7IMenuColor : public SK7IMenuBase
{
protected:
		
	typedef enum{
		PROC_LOAD=0,
		PROC_CAMERA_SET,
		PROC_MOVE,
		PROC_MAIN,
		PROC_END_MOVE,
		PROC_END,
	}eMainProc;
	
	eMainProc			m_Proc;

	SK7File*		m_pFile;
	ghmGcResLink*	m_pResLink;			//	N\[X
	void*			m_pYFontData;
	void*			m_pPackData;		//	f[^
	TEX_DATA*		m_ptData[TEX_COLOR_MAX];
	u8				m_eProc;
	
	
	bool			m_bCatchFlag;
	bool			m_bLRFlag;
	bool			m_bPointFlag;
	s8				m_chSelect;
	s8				m_chChipSelect;
	s8				m_chOldPoint;
	
	SK7Sprite		m_spBG;
	SK7Sprite		m_spChip[COLOR_CHIP_NUM];
	SK7Sprite		m_spAnswer[COLOR_ANSWER_NUM];
	
	YK7StrImage* 	m_pNoFont;					//	RctHg
	
//	֐	--------------------------------------------
	bool	LoadData();
	void	Initialize();
	
	void	SetSelectTexNo		(void);
	int		CheckHasColorChip	( u8 No );
	void	CheckColor();

public:
	SK7IMenuColor();
	virtual ~SK7IMenuColor();
	
	// t[
	virtual bool  FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void);
	
	// II擾֐
	virtual bool GetMenuEnd(void);

	// 싖ݒ֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
	virtual void SetRender(bool flag){ m_bRender=flag; }	

};

#endif	//__SK7IMENUCOLOR_H__

