////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuHato
//
// SK7IMenuHato.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUHATO_H__
#define	__SK7IMENUHATO_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"

#include "SK7IMenuBase.h"
#include "SK7Sprite.h"
#include "../matsu/mK7Jimaku.h"
#include "../wat/WK7Model.h"
#include "../wat/WK7Archive.h"
#include "SK7HatoData.h"
#include "SK7Font.h"
#include "SK7PackData.h"

#define		MEMO_PAGE_MAX		(7)
#define		SCROLL_FONT_NUM		(4)
#define		MEMO_FONT_NUM		(6)
#define		STAGE_MEMO_NUM		(10)
#define		MEMO_MAX_FONT		(800)
#define		MEMO_MAX_RUBI		(400)
#define		HATO_MEMO_MAX_NUM	(8)

enum{
	HAT_DATA_HATO=0,
	HAT_DATA_STAGE,
	HAT_DATA_MOTION_STOP,
	HAT_DATA_MOTION_JUMP,
	HAT_DATA_MOTION_LOOP,
	HAT_DATA_MOTION_LAND,
	HAT_DATA_STAGE_MOTION,
	HAT_DATA_MAX,
};

enum{
	HAT_TEX_N=0,
	HAT_TEX_E,
	HAT_TEX_X,
	HAT_TEX_T,
	HAT_TEX_D,
	
	HAT_TEX_MAX,
};



//	͂Ƃ̃[Vԍ
enum{
	HATO_MOT_STOP=0,
	HATO_MOT_JUMP,
	HATO_MOT_LOOP,
	HATO_MOT_LAND,
	HATO_MOT_MAX,
};

//	tHgJ[ύX\
typedef struct {
	s8		FirstNo;
	s8		LastNo;
	s8		ColorNo;
}FONT_COLOR;

//	͂ƃNX 
class SK7IMenuHato : public SK7IMenuBase
{
protected:
	
	typedef enum{
		LOAD_PACK,
		LOAD_FONT,
	}eLoadProc;
	
	typedef enum{
		PROC_LOAD=0,
		PROC_CAMERA,
		PROC_MEMO_TITLE,
		PROC_HATO_CHECK,
		PROC_HATO_CHECK_RETURN,
		PROC_MEMO_SCROLL,
		PROC_MEMO_FONT,
		PROC_CAMERA_SET,
		PROC_MAIN,
		PROC_END,
	}eMainProc;		
	
	WK7Archive*			m_pArchive;							//	A[JCuNX
	WK7Archive*			m_pStageArchive;
	WK7Archive*			m_pMotionArc[HATO_MOT_MAX];		//	A[JCuNX
	WK7Archive*			m_pMotionStageArc;
	WK7Model*			m_pModel;							//	fNX
	WK7Model*			m_pStageModel;
	WK7ModelMotion* 	m_pMotion[HATO_MOT_MAX];
	WK7ModelMotion* 	m_pStageMotion;
	WK7Light*			m_pLight;
	

	SK7Font				m_FontTitle[HATO_MEMO_MAX_NUM];
	SK7Sprite			m_spScroll[SCROLL_FONT_NUM];
	SK7Sprite			m_spTitleLine;
	SK7File				m_File;
	u8					m_ucMemoNo;
	u8					m_ucMemoNum;
	u8					m_ucPageNum;
	u16					m_sScenarioNo;
	int					m_iTitleNo;
	int					m_iScrollTime;
	int					m_iHatoMoveTime;
	int					m_iKeyTime;
	int					m_iTitleMoveTime;
	bool				m_bEndFontFlag[SCROLL_FONT_NUM];
	bool				m_bHasItem[STAGE_MEMO_NUM];
	bool				m_bMemoVisibleFlag;
	bool				m_bMemoTitleVisibleFlag;
	bool				m_bScrollDir;
	bool				m_bHatoMoveFlag;
	bool				m_bMoveEffectFlag;
	bool				m_bOneFlag;
	bool				m_bReverseFlag;
	u32					m_MemoID;
	f32					m_fTitleSizeX;
	f32					m_fScrollX;
	f32					m_fTitleMoveX[STAGE_MEMO_NUM];
	VEC2				m_vEffectMove[MEMO_MAX_FONT];
	VEC2				m_vFontPos[MEMO_MAX_FONT];
	VEC2				m_vFontSavePos[MEMO_MAX_FONT];
	VEC2				m_vRubiPos[MEMO_MAX_RUBI];
	VEC2				m_vRubiSavePos[MEMO_MAX_RUBI];
	int					m_fMoveTime;
	s8					m_chScrollMoveNo;
	int					m_iScrollMoveTime;
	EFFECT*				m_pEffect;

	eLoadProc			m_eLoadProc;
	eMainProc			m_Proc;
	s8					m_eSelectProc;
	

	//	pbNf[^p	---------------------------------------
	SK7PackData*		m_pPack;
	TEX_DATA			m_Texture[HAT_TEX_MAX];

	//	gp	-----------------------------------------------
	stSentence*			m_Data;
	stOneSentence*		m_SentenceDat;
	stFontParam*		m_FParam;				//uvwhl̓Ăe[uւ̃|C^
	TEX_DATA			m_Tex;
	TEX_DATA			m_RubiTex;

	void				InitScroll();
public:
	SK7IMenuHato( u32 MemoID = 0 );
	virtual ~SK7IMenuHato();
	
	// t[
	virtual bool  FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void);
	
	// II擾֐
	virtual bool GetMenuEnd(void);
	
	// 싖ݒ֐
	virtual void SetCtrlFlag(bool flag){ m_bCtrl=flag; }

	// _O
	virtual void SetRender(bool flag){ m_bRender=flag; }	
	
	//	eNX`[[h
	bool	LoadData();
	
	//	XN[
	bool	ScrollProcess(bool State);
	
	//	tHg[h
	bool	LoadFont(void);
	
	//	f[^̃`FbN
	int		CheckMemoNoFirst(void);
	int		CheckMemoNoMove(bool flag);
	
	//	tHgf[^Zbg
	bool	SetFontProcess( char* FileName );
	
	//	`
	void	RenderMemoTitle();
	void	RenderMemo();

	//	[h
	bool	LoadDataOne( char* );
		
	// t[
	bool  		FrameProcessOne(void);
	
	bool		MoveJumpHato( bool State );
	
	f32			GetFontPosition( stJimaku* pJimaku, int No );
	f32			GetKanjiSize( stJimaku* pJimaku, int No, int Num );
	
	void		SetEffectMove();

	void		SetMemoVertex();
	
	void		MoveScrollFont(void);
};

#endif	//__SK7IMENUHATO_H__

