////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuMAP
//
// SK7IMenuMap.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUMAP_CPP__
//#define	__DEBUG_MAP__

#include "SK7IMenuMap.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Stage.h"
#include "../wat/WK7Player.h"
#include "../wat/WK7SelectIF.h"
#include "../wat/WK7EventItem.h"
#include "../wat/WK7EventScript.h"
#include "../wat/K7GlobalFlag.h"
#include "SK7Pack.h"

#define		CONPAS_R				(22)
#define		CONPAS_CENTER_X			(571)//(581)
#define		CONPAS_CENTER_Y			(100)//(112)
#define		CONPAS_SIZE_X			(15)
#define		CONPAS_SIZE_Y			(25)
#define		CONPAS_HALF_SIZEX		(CONPAS_SIZE_X*0.5f)
#define		CONPAS_HALF_SIZEY		(CONPAS_SIZE_Y*0.5f)
#define		BLINK_FRAME				(60)		//	_
#define		TAMA_BLINK_FRAME		(8)
#define		LINE_SIZE				(6)
#define		LINE_COLOR				(0xffffff66)
#define		MAP_GAP_Y(Y,NO)			(Y+35*NO)
#define		CHILD_BOX_ALPHA_LIVE	(0xff)
#define		CHILD_BOX_ALPHA_DEATH	(0x66)
#define		CHILD_FONT_ALPHA		(0xf0)
#define		CHILD_FONT_EX			(0.6f)
#define		SIDE_LINE_COLOR			(0xffffff7f)
#define		KEY_TIME				(6)

const VEC2 vLineCenter[]={38,83, 38,416};
const VEC2 vWidthLine[]={39,130, 50,130};
const VEC2 vChildBox={56,125};
const VEC2 vBlockName={74, 121};

const MAPICON*	SK7IMenuMap::m_pScnIconTable = NULL;
const MAPICON*	SK7IMenuMap::m_pItmIconTable = NULL;

//========================================================================
//					RXgN^
//========================================================================
SK7IMenuMap::SK7IMenuMap() : SK7IMenuBase()
{
	int i;
	m_eProc 		= eLoad;
	m_eLoad			= eLoadObj;
	m_pPack[0]		= NULL;
	m_pPack[1] 		= NULL;
	m_pYFont		= NULL;
	m_pKasanNum 	= NULL;
	m_pMapBlockPos	= NULL;
	m_pTexture		= NULL;
	m_pspChildBox	= NULL;
	m_chSelectNo	= 0;
	m_ucTexNum 		= 0;
	m_iStageNum		= 0;
	m_chBlockNo		= 0;
	m_chSaveBlockNo = 0;
	m_chSubNo		= 0;
	m_chNowNo		= 0;
	m_iKeyTime		= 0;
	m_bBlinkFlag	= false;
	memset( m_bTamaBlinkFlag, false, TAMAKASAN_MAX_NUM );
	for( i = 0; i < MAP_BLOCK_MAX; i++ ){
		m_pMapKasan[i] 		= NULL;
	}

	ghmGcMemSetAllocName("PACK1");
	m_pPack[0] 	= new SK7PackData;
	ghmGcMemSetAllocName("PACK2");
	m_pPack[1] 	= new SK7PackData;
	ghmGcMemSetAllocName("MAPTEX");
	m_pTexture	= new TEX_DATA[MAP_OBJ_TEX_NUM];
	
	ghmGcMemSetAllocName("MAPFONT");
	m_pYFont	= new YK7StrImage;

//	SetEffectAllDrawFlag(false);
	
	m_ucVolume = gpSound->mGetVolumeStream();
	gpSound->mSetVolumeStream( 50 );
	//	C쐬
	m_RootLine.spCenter.SetLineSprite	( vLineCenter[0].x, vLineCenter[0].y, vLineCenter[1].x, vLineCenter[1].y, LINE_SIZE, LINE_COLOR );
	m_RootLine.spCenter.SetVisible		( true );
	
	gpSound->mPlaySE( SFX_SYS_XMAP_BLINK );
}



//========================================================================
//					fXgN^
//========================================================================
SK7IMenuMap::~SK7IMenuMap()
{
	int i;
	GHM_SAFE_DELETE_ARRAY( m_pTexture );
	for( i = 0; i < MAP_BLOCK_MAX; i++ ){
		GHM_SAFE_DELETE_ARRAY( m_pMapKasan[i] );
	}
	GHM_SAFE_DELETE_ARRAY( m_pMapBlockPos );
	GHM_SAFE_DELETE_ARRAY( m_pKasanNum );
	GHM_SAFE_DELETE_ARRAY( m_pspChildBox );
	GHM_SAFE_DELETE_ARRAY( m_pspChildLine );	
	GHM_SAFE_DELETE( m_pPack[0] );
	GHM_SAFE_DELETE( m_pPack[1] );
	m_pYFont->Release();
	GHM_SAFE_DELETE( m_pYFont );

	gpSound->mSetVolumeStream( m_ucVolume );	
	
//	SetEffectAllDrawFlag(true);
}

//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuMap::FrameProcess(void)
{
	switch( m_eProc ){
	case eLoad:
		if( LoadData() ){
			SetNowMap();	//	݈ʒu擾
			SetBlockChange();
			CheckRenderBox();
			m_eProc = eMain;
		}
		break;
	case eMain:
		MoveBlink();		

		if( !m_bCtrl )	break;
		m_iKeyTime++;
		if( HSD_PadGetTrigger(0) & (HSD_PAD_B|HSD_PAD_X) ){	
			gpSound->mStopSE( SFX_SYS_XMAP_BLINK );
			m_eProc = eEnd;
			break;
		}	
		if( CheckKeyN( SK7_KEY_UP ) && m_iKeyTime > KEY_TIME ){
			if( m_spNowKasan.CheckFlag( RENDER_FLAG ) )	gpSound->mStopSE( SFX_SYS_XMAP_BLINK );
			m_iKeyTime = 0;
			SetSelectBlock(true);
			SetBlockChange();
			break;
		}
		if( CheckKeyN( SK7_KEY_DOWN ) && m_iKeyTime > KEY_TIME ){
			if( m_spNowKasan.CheckFlag( RENDER_FLAG ) )	gpSound->mStopSE( SFX_SYS_XMAP_BLINK );
			m_iKeyTime = 0;
			SetSelectBlock(false);
			SetBlockChange();
			break;
		}
		break;
	case eEnd:
		break;
	}
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuMap::RenderProcess(void)
{
	int i;
	if( !m_bRender )	return true;
		
	m_spBG.Render();
	m_spRootBox.Render();
	m_spTitle.Render();
	m_spDay.Render();
	DrawFont();
	
	
	m_RootLine.spSide[0].Render();
	m_RootLine.spSide[1].Render();
	m_RootLine.spCenter.Render();
	m_spSideLine[0].Render();
	m_spSideLine[1].Render();
	
	for( i = 0; i < m_iStageNum; i++ ){
		m_pspChildBox[i].Render();
		m_pspChildLine[i].Render();
	}
	
	m_spJyosan.Render();
	m_spConpas.Render();
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );

	for( i = 0; i < MAP_KASAN_MAX; i++ ){
		m_spUnder[i].Render();
	}
	u8 alpha = m_spNowKasan.GetAlpha();
	m_spNowKasan.Render();
	m_spNowKasan.SetAlpha( (u8)(alpha*0.5f) );
	m_spNowKasan.Render();
	m_spNowKasan.SetAlpha( alpha );
	for( i = 0; i < MAP_KASAN_MAX; i++ ){
		m_spKasan[i].Render();
	}
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	for( i = 0; i < MAP_ICON_MAX; i++ ){
		m_Line[i].spLine[0].Render();
		m_Line[i].spLine[1].Render();
	}
	for( i = 0; i < MAP_ICON_MAX; i++ ){
		m_spIcon[i].Render();
	}
	for( i = 0; i < TAMAKASAN_MAX_NUM; i++ ){
		m_spTamaKasan[i].Render();
	}
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuMap::GetFileReadEnd(void)
{
	if( m_eProc > eLoad )	return true;
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuMap::GetMenuEnd(void)
{
	if( m_eProc == eEnd )	return true;
	return false;
}

//========================================================================
//					tHg`
//========================================================================
void	SK7IMenuMap::DrawFont(void)
{
	//	傫tHg
	f32 Ex=1.0f;
	//	̑傫`FbN
	if( m_pYFont->DrawStrPack(0,0,m_chBlockNo,3,true,false) >= 94 ){
		Ex = 0.80f;
	}
	if( m_pYFont->GetStrPackLineNum(m_chBlockNo) < 2 ){
		DRAW_FONT_STRP( m_pYFont, tblMapObjPos[MAP_POS_BIG_NAME].x, tblMapObjPos[MAP_POS_BIG_NAME].y, m_chBlockNo, tblMapColor[MAP_COLOR_BIG_NAME], Ex, true, true, 3 );
	}else{
		DRAW_FONT_STRP( m_pYFont, tblMapObjPos[MAP_POS_BIG_NAME].x, tblMapObjPos[MAP_POS_BIG_NAME].y-17.0f, m_chBlockNo, tblMapColor[MAP_COLOR_BIG_NAME], Ex, true, true, 3 );
	}

	//	tHg
	int i;
	u32 Color;
	bool draw=false;
	for( i = 0; i < m_iStageNum; i++ ){
		if( i == m_chBlockNo )	Color = 0xffffff00+CHILD_FONT_ALPHA;
		else					Color = 0xffffff00+CHILD_BOX_ALPHA_DEATH;
		if( m_pspChildBox[i].CheckFlag( RENDER_FLAG ) )		draw = true;
		else												draw = false;
		//		------------------------------------------------------------
		if( m_pYFont->GetStrPackLineNum(i+m_iStageNum) >= 2 ){
			DRAW_FONT_STRP( m_pYFont, vBlockName.x, MAP_GAP_Y(vBlockName.y-6.0f, ((m_iStageNum-1)-i) ), i+m_iStageNum, Color, CHILD_FONT_EX, false, draw, -5  );
		}else{
			DRAW_FONT_STRP( m_pYFont, vBlockName.x, MAP_GAP_Y(vBlockName.y, ((m_iStageNum-1)-i) ), i+m_iStageNum, Color, CHILD_FONT_EX, false, draw, -5 );
		}
	}
}
	
//========================================================================
//					Ip
//========================================================================
void	SK7IMenuMap::SetSelectBlock(bool downflag)
{
	s8 SaveNo = m_chBlockNo;
	int i = 0;
	if( downflag ){
		for( i = m_chBlockNo+1; i < m_iStageNum; i++ ){
			if( m_pspChildBox[i].CheckFlag( RENDER_FLAG ) ){
				m_chBlockNo = (s8)i;
				gpSound->mPlaySE( SFX_SYS_XMAP_TURN );
				return;
			}
		}
		for( i = 0; i < m_chBlockNo; i++ ){
			if( m_pspChildBox[i].CheckFlag( RENDER_FLAG ) ){
				m_chBlockNo = (s8)i;
				gpSound->mPlaySE( SFX_SYS_XMAP_TURN );
				return;
			}			
		}
	}else{
		for( i = m_chBlockNo-1; i >= 0; i-- ){
			if( m_pspChildBox[i].CheckFlag( RENDER_FLAG ) ){
				m_chBlockNo = (s8)i;
				gpSound->mPlaySE( SFX_SYS_XMAP_TURN );
				return;
			}
		}
		for( i = m_iStageNum-1; i > m_chBlockNo; i-- ){
			if( m_pspChildBox[i].CheckFlag( RENDER_FLAG ) ){
				m_chBlockNo = (s8)i;
				gpSound->mPlaySE( SFX_SYS_XMAP_TURN );
				return;
			}			
		}
	}
}

//========================================================================
//					ubN`FW
//========================================================================
void	SK7IMenuMap::SetBlockChange(void)
{
	SetSideLine();
	SetMapData( (s8)m_chBlockNo );			
	SetWentMap( (s8)m_chBlockNo );
	SetChildBox();
	if( m_chSaveBlockNo == m_chBlockNo ){
		m_spNowKasan.SetVisible		( true );
	}else{
		m_spNowKasan.SetVisible		( false );
	}
}

//========================================================================
//					ꏊꏊ擾
//========================================================================
void	SK7IMenuMap::SetNowMap(void)
{
	int 	i,StageNo=0;
	bool	bBlockFlag=false;
	while(1){
		MAP_KASAN* pKasan = &m_pMapKasan[m_chBlockNo][0];
		for( i = 0; i < m_pKasanNum[m_chBlockNo]; i++ ){
			//ݒn	------------------
			if( (K7STGID(pKasan->StageID,pKasan->StageNo) == WK7Stage::GetCurrentStageID()) &&
				(m_chSubNo == pKasan->StageFix)){
				m_spNowKasan.SetTexSprite	( pKasan->x, pKasan->y, &m_pMapTex[pKasan->TexNo] );
				m_spNowKasan.SetColor		( KASAN_COLOR );
				m_spNowKasan.SetFlag		( true, RENDER_FLAG|I4_FLAG );
				m_spNowKasan.SetBlendNo		( SPR_BLEND_ONE );
				bBlockFlag	= true;
				m_chNowNo 	= (s8)i;
				break;
			}
			pKasan++;
			StageNo++;
		}
		if( bBlockFlag ) break;
		pKasan = 0;
		m_chBlockNo++;
	}
	m_chSaveBlockNo = m_chBlockNo;
}

//========================================================================
//					xꏊ
//========================================================================
void	SK7IMenuMap::SetSideLine()
{
	//	[gC
	m_RootLine.spSide[0].SetLineSprite	( vLineCenter[0].x-1, vLineCenter[0].y, vLineCenter[1].x-1, MAP_GAP_Y(vWidthLine[1].y, ((m_iStageNum-1)-m_chBlockNo)), LINE_SIZE, SIDE_LINE_COLOR );
	m_RootLine.spSide[0].SetVisible		( true );
	m_RootLine.spSide[1].SetLineSprite	( vLineCenter[0].x+1, vLineCenter[0].y, vLineCenter[1].x+1, MAP_GAP_Y(vWidthLine[1].y, ((m_iStageNum-1)-m_chBlockNo)), LINE_SIZE, SIDE_LINE_COLOR );
	m_RootLine.spSide[1].SetVisible		( true );
	//	TChC
	m_spSideLine[0].SetLineSprite		( vWidthLine[0].x, MAP_GAP_Y(vWidthLine[0].y-1, ((m_iStageNum-1)-m_chBlockNo)), vWidthLine[1].x, MAP_GAP_Y(vWidthLine[1].y-1, ((m_iStageNum-1)-m_chBlockNo)), LINE_SIZE, SIDE_LINE_COLOR );
	m_spSideLine[0].SetVisible			( true );
	m_spSideLine[1].SetLineSprite		( vWidthLine[0].x, MAP_GAP_Y(vWidthLine[0].y+1, ((m_iStageNum-1)-m_chBlockNo)), vWidthLine[1].x, MAP_GAP_Y(vWidthLine[1].y+1, ((m_iStageNum-1)-m_chBlockNo)), LINE_SIZE, SIDE_LINE_COLOR );
	m_spSideLine[1].SetVisible			( true );	
}

//========================================================================
//					xꏊ
//========================================================================
void	SK7IMenuMap::SetWentMap( s8 BlockNo )
{
	int 	i, KasanNo = 0;
	MAP_KASAN* pKasan = &m_pMapKasan[BlockNo][0];
	MAP_KASAN* pNow	  = &m_pMapKasan[BlockNo][m_chNowNo];

	//	Zׂď
	for( i = 0; i < MAP_KASAN_MAX; i++ ){
		m_spUnder[i].SetVisible( false );
		m_spKasan[i].SetVisible( false );
	}
	//	쐬
	for( i = 0; i < m_pKasanNum[BlockNo]; i++ ){
		m_spUnder[i].SetTexSprite	( pKasan->x, pKasan->y, &m_pMapTex[pKasan->TexNo-1] );
		m_spUnder[i].SetVisible		( true );
		if( (m_chSaveBlockNo == BlockNo && ( i == m_chNowNo || pKasan->TexNo == pNow->TexNo)) || (pKasan->TexNo == KasanNo) ){
			pKasan++;
			continue;
		}
		if( WK7Stage::GetStageMapFlag( K7STGID((u32)pKasan->StageID,pKasan->StageNo), pKasan->StageFix )) {
			KasanNo = pKasan->TexNo;
			m_spKasan[i].SetTexSprite	( pKasan->x, pKasan->y, &m_pMapTex[pKasan->TexNo] );
			m_spKasan[i].SetColor		( KASAN_COLOR2 );
			m_spKasan[i].SetFlag		( true, RENDER_FLAG|I4_FLAG );
			m_spKasan[i].SetBlendNo		( SPR_BLEND_ONE );
		}
		pKasan++;
	}
}

//========================================================================
//					f[^Zbg
//========================================================================
void	SK7IMenuMap::SetMapData( s8 SelectNo )
{
	int i;
	int StageFlowNo = GameInfo.GetScenarioFlow();
	
	//	ACR쐬
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) == true )	return;

	int IconNum=0, TamaNum=0;
	u32 NowStageNo=0;
	MAP_KASAN* pKasan = &m_pMapKasan[SelectNo][0];
	const MAPICON* pScnIcon=NULL;
	const MAPICON* pItmIcon=NULL;
	for( i = 0; i < m_pKasanNum[SelectNo]; i++ ){
		//
		if( NowStageNo == K7STGID((u32)pKasan->StageID, pKasan->StageNo) ){
			pKasan++;
			continue;
		}
		NowStageNo = K7STGID((u32)pKasan->StageID, pKasan->StageNo);
		//	Xe[WACR
		pScnIcon = m_pScnIconTable;
		SetMapIcon( pScnIcon, pKasan, &IconNum, true, &TamaNum );
		//	ACeACR
		pItmIcon = m_pItmIconTable;
		SetMapIcon( pItmIcon, pKasan, &IconNum, false, &TamaNum );
		pKasan++;
	}
	//	gȂ
	for( i = IconNum; i < MAP_ICON_MAX; i++ ){
		m_spIcon[i].SetVisible( false );
		m_Line[i].spLine[0].SetVisible( false );
		m_Line[i].spLine[1].SetVisible( false );
	}
	for( i = TamaNum; i < TAMAKASAN_MAX_NUM; i++ ){
		m_spTamaKasan[i].SetVisible( false );
	}
}

//========================================================================
//					f[^Zbg
//========================================================================
void	SK7IMenuMap::SetMapIcon( const MAPICON* pIcon, MAP_KASAN* pKasan, int* iconnum, bool flag, int* tamanum )
{
	while( pIcon->StageID != NULL ){
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_EASY_MODE )!=true ){
			switch( pIcon->IconNo ){
			case MAP_ICON_BULLET:
			case MAP_ICON_TV:
			case MAP_ICON_SAVE:
				break;
			default:
				pIcon++;
				continue;
			}
		}
		
		//	{ɓ O	JNr̂
		bool SpecialFlag = false;
		if( (pIcon->StageID == K7STGID((u32)pKasan->StageID, pKasan->StageNo)) && pKasan->StageID == 133 ){
			if( pIcon->SubNo == pKasan->StageFix ){
				SpecialFlag = true;
			}
			if( SpecialFlag == false ){
				pIcon++;
				continue;
			}
		}
			
		if( ((pIcon->StageID == K7STGID((u32)pKasan->StageID, pKasan->StageNo)) &&
			(pIcon->SubNo == 0 || pIcon->SubNo == GameInfo.GetScenarioFlow())) || SpecialFlag == true )
		{
			int icontex = pIcon->IconNo+TEX_MOBJ_MAX;
			bool TamaFlag=false;
			//	ACR쐬
			m_spIcon[(*iconnum)].SetTexSprite	( pIcon->vPos.x, pIcon->vPos.y, &m_pTexture[icontex] );
			m_Line[(*iconnum)].spLine[0].SetLineSprite( pIcon->vPos.x+m_pTexture[icontex].Header->mWidth*0.5f, 	pIcon->vPos.y+m_pTexture[icontex].Header->mWidth*0.5f,	pIcon->vLine1.x, 	pIcon->vLine1.y, ICON_LINE_SIZE, ICON_LINE_COLOR );
			m_Line[(*iconnum)].spLine[1].SetLineSprite( pIcon->vLine1.x, 	pIcon->vLine1.y, 	pIcon->vLine2.x, 	pIcon->vLine2.y, ICON_LINE_SIZE, ICON_LINE_COLOR );
			//	܂܉ZACR쐬
			if( pIcon->IconNo == MAP_ICON_BULLET ){
				m_spTamaKasan[(*tamanum)].SetTexSprite( pIcon->vPos.x, pIcon->vPos.y, &m_pTexture[MAP_ICON_BULLET_KASAN+TEX_MOBJ_MAX] );
				m_spTamaKasan[(*tamanum)].SetBlendNo( SPR_BLEND_ONE );
				TamaFlag = true;
			}

			//	tO`FbN
			if( pIcon->IconFlag == NOT_EVENT_FLAG ){
				m_spIcon[(*iconnum)].SetVisible			( true );
				m_Line[(*iconnum)].spLine[0].SetVisible	( true );
				m_Line[(*iconnum)].spLine[1].SetVisible	( true );
			}else{
				if( flag ){
					if( K7SCR_GET_SCENARIO_FLAG( (int)pIcon->IconFlag )==true ){
						m_spIcon[(*iconnum)].SetVisible			( false );
						m_Line[(*iconnum)].spLine[0].SetVisible	( false );
						m_Line[(*iconnum)].spLine[1].SetVisible	( false );
					}else{
						m_spIcon[(*iconnum)].SetVisible			( true );
						m_Line[(*iconnum)].spLine[0].SetVisible	( true );
						m_Line[(*iconnum)].spLine[1].SetVisible	( true );
					}
				}else{
					if( K7SCR_EVHASITEM( pIcon->IconFlag ) ){
						m_Line[(*iconnum)].spLine[0].SetVisible	( false );
						m_Line[(*iconnum)].spLine[1].SetVisible	( false );
						m_spIcon[(*iconnum)].SetVisible			( false );
					}else{
						m_Line[(*iconnum)].spLine[0].SetVisible	( true );
						m_Line[(*iconnum)].spLine[1].SetVisible	( true );
						m_spIcon[(*iconnum)].SetVisible			( true );
					}
				}
			}
			if( TamaFlag ){
				m_spTamaKasan[(*tamanum)].SetVisible	( m_spIcon[(*iconnum)].CheckFlag( RENDER_FLAG ) );
				(*tamanum)++;
				TamaFlag = false;
			}
			(*iconnum)++;
		}
		pIcon++;
	}
}


//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuMap::LoadData(void)
{
	int i=0;
	switch( m_eLoad ){
	case eLoadObj:
		if( m_pPack[0]->OpenPack( MAP_OBJ_DATA ) ){
			//	eNX`[	
			for( i = 0; i < MAP_OBJ_TEX_NUM; i++ ){
				m_pPack[0]->GetTexture( &m_pTexture[i], i );
			}
			//	wi
			m_spBG.SetTexSprite		( 0, 0, &m_pTexture[TEX_MOBJ_BACK_GROUND] );
			m_spBG.SetVisible		( true ); 
			//	Z
			m_spJyosan.SetTexSprite	( 0, 0, &m_pTexture[TEX_MOBJ_JYOSAN] );
			m_spJyosan.SetBlendNo	( SPR_BLEND_MULTI );
			m_spJyosan.SetVisible	( true );
			//	[g{bNX
			m_spRootBox.SetTexSprite( tblMapObjPos[MAP_POS_ROOTBOX].x, tblMapObjPos[MAP_POS_ROOTBOX].y, &m_pTexture[TEX_MOBJ_MAINAS] );
			m_spRootBox.SetVisible	( true );
			//	RpX
			m_spConpas.SetTexSprite	( CONPAS_CENTER_X, CONPAS_CENTER_Y, g_pSpData->GetTexture(TEX_CONP_CONPAS_KASAN) );
			m_spConpas.SetBlendNo	( SPR_BLEND_ONE );
			m_spConpas.SetVisible	( true );
			f32 yrot;
			WK7PLAYERCONTROL->GetRotY(&yrot);
			yrot = -yrot+PI*0.5f-WK7SelectIF::GetStageDirOffset();
			SET_SPRITE_ROT( &m_spConpas, MTXRadToDeg(yrot), CONPAS_CENTER_X+CONPAS_R*cosf( yrot )+CONPAS_HALF_SIZEX, CONPAS_CENTER_Y+CONPAS_R*sinf( yrot )+CONPAS_HALF_SIZEY, CONPAS_SIZE_X, CONPAS_SIZE_Y );
			
			m_eLoad = eLoadMap;
		}
		break;
		
	case eLoadMap:
		
		int StageFlowNo = GameInfo.GetScenarioFlow();
		
		if( m_pPack[1]->OpenPack( tblStageMapData[StageFlowNo] ) ){
			//	RctHg
			m_pPack[1]->GetYamFont( m_pYFont, 0 );
			//	Xe[Wf[^
			int KNo=0,ObjNo = 0,j;
			void* MapData 	= m_pPack[1]->GetData(1);
			m_iStageNum 	= *((u8*)MapData); 	((u8*)MapData)++;
			m_pKasanNum 	= NULL;
			ghmGcMemSetAllocName("MAPBLOCK");
			m_pMapBlockPos	= new VEC2S16[m_iStageNum];
			ghmGcMemSetAllocName("MAPKNUM");
			m_pKasanNum 	= new u8[m_iStageNum];			//	Xe[W쐬

			for( i = 0; i < m_iStageNum; i++ ){
//				m_pMapBlockPos[i].x = *((s16*)MapData);	((s16*)MapData)++;
//				m_pMapBlockPos[i].y = *((s16*)MapData);	((s16*)MapData)++;
				
				m_pKasanNum[i] 		= *((u8*)MapData);	((u8*)MapData)++;
				ghmGcMemSetAllocName("MAPKASAN");
				m_pMapKasan[i] 		= new MAP_KASAN[m_pKasanNum[i]];

				for( j = 0; j < m_pKasanNum[i]; j++ ){
					m_pMapKasan[i][j].StageID 	= *(u16*)MapData;		((u16*)MapData)++;
					m_pMapKasan[i][j].StageNo 	= *(u8*)MapData;		((u8*)MapData)++;
					m_pMapKasan[i][j].StageFix 	= *(u8*)MapData;		((u8*)MapData)++;
					m_pMapKasan[i][j].x 			= *(s16*)MapData;		((s16*)MapData)++;
					m_pMapKasan[i][j].y 			= *(s16*)MapData;		((s16*)MapData)++;
					m_pMapKasan[i][j].TexNo 	= (u8)((*((u8*)MapData)*2+TEX_MAP_FIRST_NO)+1);		((u8*)MapData)++;
				}
			}
			//	eNX`[
			m_ucTexNum = 0;
			for( i = 0; i < TEX_MAP_MAX*2; i++ ){
				if( !m_pPack[1]->GetTexture( &m_pMapTex[i], i+2 ) ){
					m_ucTexNum = (u8)(i-1);
					break;
				}
			}
			//	^Cg	
			m_spTitle.SetTexSprite	( tblMapObjPos[MAP_POS_TITLE].x, tblMapObjPos[MAP_POS_TITLE].y, &m_pMapTex[TEX_MAP_TITLE_NO] );
			m_spTitle.SetVisible	( true );	
			//	ɂ
			m_spDay.SetTexSprite	( tblMapObjPos[MAP_POS_DAY].x, tblMapObjPos[MAP_POS_DAY].y, &m_pMapTex[TEX_MAP_DAY_NO] );
			m_spDay.SetAlpha		( 0xe5 );
			m_spDay.SetVisible		( true );
			//	q{bNX
			ghmGcMemSetAllocName("MAPCHILEB");
			m_pspChildBox 	= new SK7Sprite[m_iStageNum];
			ghmGcMemSetAllocName("MAPCHILEL");
			m_pspChildLine	= new SK7Sprite[m_iStageNum];
			return true;
		}
		break;
	}
	return false;
}
//========================================================================
//					q{bNXSET
//========================================================================
void	SK7IMenuMap::SetChildBox(void)
{
	int i;
	for( i = 0; i < m_iStageNum; i++ ){
		if( i == m_chBlockNo ){
			m_pspChildBox[i].SetTexSprite	( vChildBox.x, MAP_GAP_Y(vChildBox.y, ((m_iStageNum-1)-i)), &m_pTexture[TEX_MOBJ_MAINAS] );
			m_pspChildBox[i].SetAlpha( CHILD_BOX_ALPHA_LIVE );
			m_pspChildLine[i].SetLineSprite	( vWidthLine[0].x, MAP_GAP_Y(vWidthLine[0].y, ((m_iStageNum-1)-i)), vWidthLine[1].x, MAP_GAP_Y(vWidthLine[1].y, ((m_iStageNum-1)-i)), LINE_SIZE, 0xffffffff ); 		
		}else{
			m_pspChildBox[i].SetTexSprite	( vChildBox.x, MAP_GAP_Y(vChildBox.y, ((m_iStageNum-1)-i)), &m_pTexture[TEX_MOBJ_MAINAS] );
			m_pspChildBox[i].SetAlpha		( CHILD_BOX_ALPHA_DEATH );
			m_pspChildLine[i].SetLineSprite	( vWidthLine[0].x, MAP_GAP_Y(vWidthLine[0].y, ((m_iStageNum-1)-i)), vWidthLine[1].x, MAP_GAP_Y(vWidthLine[1].y, ((m_iStageNum-1)-i)), LINE_SIZE, 0xffffff00+CHILD_BOX_ALPHA_DEATH);
		}
	}
}

//========================================================================
//					q{bNX``FbN
//========================================================================
void	SK7IMenuMap::CheckRenderBox(void)
{
	bool 	BlockRender=false;
	int 	i,BlockNo = 0;
	while(1){
		MAP_KASAN* pKasan = &m_pMapKasan[BlockNo][0];
		for( i = 0; i < m_pKasanNum[BlockNo]; i++ ){
			if( WK7Stage::GetStageMapFlag( K7STGID((u32)pKasan->StageID,pKasan->StageNo), pKasan->StageFix)) {
				BlockRender = true;
				break;
			}
			pKasan++;
		}
		// ЂƂł`悵Ă
		if( BlockRender ){
			m_pspChildBox[BlockNo].SetVisible	( true );
			m_pspChildLine[BlockNo].SetVisible	( true );		
		}else{
			m_pspChildBox[BlockNo].SetVisible	( false );
			m_pspChildLine[BlockNo].SetVisible	( false );		
		}
		BlockRender = false;
		if( ++BlockNo >= m_iStageNum )	break;
	}
}
//========================================================================
//					_
//========================================================================
void	SK7IMenuMap::MoveBlink(void)
{
	for( int i = 0; i < TAMAKASAN_MAX_NUM; i++ ){
		if( m_spTamaKasan[i].CheckFlag( RENDER_FLAG ) ){
			if( m_bTamaBlinkFlag[i] ){
				if( m_spTamaKasan[i].DownAlpha( TAMA_BLINK_FRAME ) ){
					m_bTamaBlinkFlag[i] = false;
				}
			}else{				
				if( m_spTamaKasan[i].AddAlpha( TAMA_BLINK_FRAME ) ){
					m_bTamaBlinkFlag[i] = true;
				}
			}
		}
	}
	if( m_spNowKasan.CheckFlag( RENDER_FLAG ) ){
		if( m_bBlinkFlag ){
			if( m_spNowKasan.DownAlpha(BLINK_FRAME) ){
				m_bBlinkFlag = false;
			}
		}else{
			if( m_spNowKasan.AddAlpha( BLINK_FRAME ) ){
				m_bBlinkFlag = true;
			}
		}
	}
}

