////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuMAP
//
// SK7IMenuMap.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7IMENUMAP_H__
#define	__SK7IMENUMAP_H__

#include "SK7IMenuBase.h"
#include "SK7Sprite.h"
#include "SK7MapData.h"
#include "SK7PackData.h"
#include "../Yam/YK7String.h"


//	}bvNX
class SK7IMenuMap : public SK7IMenuBase
{
	typedef enum{
		eLoad=0,
		eMain,
		eEnd,
	}eProc;
	
	typedef enum{
		eLoadObj=0,
		eLoadMap,
	}eData;

protected:
	eProc			m_eProc;
	eData			m_eLoad;
	SK7PackData*	m_pPack[2];
	TEX_DATA*		m_pTexture;
	TEX_DATA		m_pMapTex[TEX_MAP_MAX];
	
	SK7Sprite		m_spBG;
	SK7Sprite		m_spJyosan;
	SK7Sprite		m_spDay;
	SK7Sprite		m_spTitle;
	SK7Sprite		m_spRootBox;
	SK7Sprite*		m_pspChildBox;
	SK7Sprite		m_spUnder[MAP_KASAN_MAX];
	SK7Sprite		m_spKasan[MAP_KASAN_MAX];
	SK7Sprite		m_spNowKasan;
	SK7Sprite		m_spConpas;
	SK7Sprite*		m_pspChildLine;
	SK7Sprite		m_spSideLine[2];
	SK7Sprite		m_spIcon[MAP_ICON_MAX];
	SK7Sprite		m_spTamaKasan[TAMAKASAN_MAX_NUM];
	MAP_KASAN*		m_pMapKasan[MAP_BLOCK_MAX];
	ICONLINE		m_Line[MAP_ICON_MAX];
	VEC2S16*		m_pMapBlockPos;

	YK7StrImage*	m_pYFont;
	MAP_LINE		m_RootLine;
	
	s8				m_chSelectNo;
	s8				m_chBlockNo;
	s8				m_chSaveBlockNo;
	s8				m_chSubNo;
	s8				m_chNowNo;
	u8				m_ucVolume;
	u8				m_ucTexNum;
	u8*				m_pKasanNum;
	int				m_iStageNum;
	int				m_iKeyTime;
	bool			m_bBlinkFlag;
	bool			m_bTamaBlinkFlag[TAMAKASAN_MAX_NUM];
	
	static const MAPICON*	m_pScnIconTable;
	static const MAPICON*	m_pItmIconTable;
	
	bool	LoadData		(void);	
	void	DrawFont		(void);
	void	SetMapData		( s8 );
	void	SetNowMap		(void);
	void	SetWentMap		( s8 );
	void	SetChildBox		(void);
	void	SetSideLine		(void);
	void	SetBlockChange	(void);
	void	MoveBlink		(void);
	void	CheckRenderBox	(void);
	void	SetSelectBlock	(bool);
	void	SetMapIcon( const MAPICON* pIcon, MAP_KASAN* pKasan, int* iconnum, bool flag, int* tamanum );

public:
	SK7IMenuMap();
	virtual ~SK7IMenuMap();
	
	// t[
	virtual bool  FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// t@CǂݍݏI擾֐
	virtual bool GetFileReadEnd(void);
	
	// II擾֐
	virtual bool GetMenuEnd(void);
	
	//	ԍЂƂ
	void	SetSubNo( s8 no ){ m_chSubNo = no; }
	
	//	e[u
	static void SetScnIconTable( const MAPICON* pTable ){ m_pScnIconTable = pTable; }
	static void SetItmIconTable( const MAPICON* pTable ){ m_pItmIconTable = pTable; }
	static const MAPICON* GetScnIconTable(){ return m_pScnIconTable; }
	static const MAPICON* GetItmIconTable(){ return m_pItmIconTable; }
};



#endif	//__SK7IMENUMAP_H__

