////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuPola
//
// SK7IMenuPola.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUPOLA_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "../wat/WK7GameInfo.h"
#include "SK7IMenuPola.h"
#include "../wat/WK7Play.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "../wat/WK7Event.h"
#include "../matsu/mK7Sound.h"

#define		POLA_X			(0)
#define		POLA_Y			(0)
#define		POLA_Z			(0)

#define		STAGE_POS_X		(20.2f)//39.1f)//(10.1f)
#define		STAGE_POS_Y		(-9.262489f)//-16.7f)//(-14.2f)
#define		STAGE_POS_Z		(42.33495f)//28.06f)//(31.1f)
#define		STAGE_ROT_Y		(-1.583186f)//-1.7f)//(1.436817f)
#define		LIGHT_FIRST_X		(30.53797f)
#define		LIGHT_FIRST_Y		(-7.761319f)
#define		LIGHT_Z				(9.562421f)
#define		LIGHT_LAST_X		(-27.96205f)

#define		POLA_MOVE_TIME	(20)


//	Cgݒ 	
#define	DIRLIGHT_COLOR		{ 0xff, 0xff, 0xff, 0xff }					// color

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ LIGHT_FIRST_X,LIGHT_FIRST_Y, LIGHT_Z },		// wobj position
};
static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};


#define	SK7POLA_LIGHT_TYPE		(0xdfffffff)
#define	SK7POLA_LIGHT_ID		(1)


//========================================================================
//					RXgN^
//========================================================================
SK7IMenuPola::SK7IMenuPola( u32 PolaNo ) : SK7IMenuBase()
{
	//	Cg쐬	-----------------------------------
	WK7Light::Create(&dir_light,SK7POLA_LIGHT_TYPE,SK7POLA_LIGHT_ID);
	
	m_pArchive			= NULL;			//	A[JCuNX
	m_pModel			= NULL;			//	fNX
	m_pPolaModel		= NULL;
	m_pPolaArc			= NULL;
	m_pMotionArc		= NULL;
	m_pMotion			= NULL;
	m_iMoveTime			= 0;
	
	//	J[e쐬	------------------------------------------
	if( NULL != (m_pArchive = WK7Archive::Create())){
		m_pArchive->LoadArchive( STAGE_FILE );
	}
	if( NULL != (m_pMotionArc = WK7Archive::Create())){
		m_pMotionArc->LoadArchive	( MOTION_STAGE 	);
	}

	
	char* pstrFileName = NULL;

	if( PolaNo != NOT_POLA_NO ){
		char filename[255];
		sprintf( filename, "/item/pola/POLA_%04x.dat", PolaNo  );
		pstrFileName = filename;
	}else{
		//	̎̃ACeZbgp	--------------------------------------
		if( GameInfo.GetScenarioID() == 1 ){
			bool Get0=false, Get1=false;
			if( WK7Play::HasPlayed(K7EVENTPLAY(01040101)) ){
				Get0 = true;
			}
			if( WK7Play::HasPlayed(K7EVENTPLAY(01060101)) ){
				Get1 = true;
			}
			if( Get1 == true ){
				m_ucPolaNo = 2;
			}else if( Get0 == true ){
				m_ucPolaNo = 1;
			}
		}
//		else{
//			m_ucPolaNo 		= (u8)CheckStageNo();
//		}
		pstrFileName 	= tblPolaFile[m_ucPolaNo].FileName;
	}

	if( pstrFileName != NULL ){
		//	|Ch쐬	-----------------------------------------
		if( NULL != (m_pPolaArc = WK7Archive::Create())){
			m_pPolaArc->LoadArchive( pstrFileName );
		}
	}
	m_eLoadProc = LOAD_STAGE;
	m_Proc = PROC_LOAD;
	
}


//========================================================================
//					fXgN^
//========================================================================
SK7IMenuPola::~SK7IMenuPola()
{
	// Cg
	WK7Light::Release(SK7POLA_LIGHT_TYPE,SK7POLA_LIGHT_ID);
	
	GHM_SAFE_DELETE( m_pModel );
	GHM_SAFE_DELETE( m_pPolaModel );
	//	[Vf[^J
	GHM_SAFE_DELETE( m_pMotion );
	
}

//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuPola::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData() )
		{
			m_Proc = PROC_CAMERA_SET;
		}
		break;
		
	case PROC_CAMERA_SET:
		WK7CAM->SetDesc				( NULL );
		WK7CAM->SetMode				( WK7Cam::WK7CAM_FREE_TARGET );
		WK7CAM->SetPosition			(0.0f, 4.670181f,74.23308f);
		WK7CAM->SetTargetPosition	(0.3129016f,6.450003f,0.0f);

		if( m_pPolaModel == NULL ){
			m_Proc = PROC_MAIN;
		}else{
			m_Proc = PROC_MOVE;
		}
		break;
		
	case PROC_MOVE:
		Vec vModelPos;
		Vec vModelRot;
		m_pPolaModel->GetPosition( &vModelPos );
		m_pPolaModel->GetRotation( &vModelRot );
		
		vModelRot.z += PI/POLA_MOVE_TIME*2;
		
		vModelPos.x -= (tblPolaFile[m_ucPolaNo].vPosFirst.x - tblPolaFile[m_ucPolaNo].vPos.x)/POLA_MOVE_TIME; 
		vModelPos.y -= (tblPolaFile[m_ucPolaNo].vPosFirst.y - tblPolaFile[m_ucPolaNo].vPos.y)/POLA_MOVE_TIME; 
		vModelPos.z -= (tblPolaFile[m_ucPolaNo].vPosFirst.z - tblPolaFile[m_ucPolaNo].vPos.z)/POLA_MOVE_TIME; 

		GHM_LIMIT_RANGE(vModelRot.z, PI, -PI);
	 	m_pPolaModel->SetPosition( &vModelPos );
	 	m_pPolaModel->SetRotation( &vModelRot );		

		if( ++m_iMoveTime >= POLA_MOVE_TIME ){
		 	m_pPolaModel->SetRotation( tblPolaFile[m_ucPolaNo].vRot );
			m_iMoveTime = 0;
			m_Proc = PROC_MAIN;
		}
		break;
		
	case PROC_MAIN:
		if( !m_bCtrl )	break;
	
		if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			if( m_pPolaModel == NULL ){
				m_Proc = PROC_END;
			}else{
				m_Proc = PROC_END_MOVE;
			}
		}
		break;
		
	case PROC_END_MOVE:
		Vec vMPos;
		Vec vMRot;
		m_pPolaModel->GetPosition( &vMPos );
		m_pPolaModel->GetRotation( &vMRot );
		
		vMRot.z += PI/8.0f;
		
		vMPos.x -= (tblPolaFile[m_ucPolaNo].vPosFirst.x - tblPolaFile[m_ucPolaNo].vPos.x)/POLA_MOVE_TIME; 
		vMPos.y -= (tblPolaFile[m_ucPolaNo].vPosFirst.y - tblPolaFile[m_ucPolaNo].vPos.y)/POLA_MOVE_TIME; 
		vMPos.z -= (tblPolaFile[m_ucPolaNo].vPosFirst.z - tblPolaFile[m_ucPolaNo].vPos.z)/POLA_MOVE_TIME; 

		GHM_LIMIT_RANGE(vMRot.z, PI, -PI);
	 	m_pPolaModel->SetPosition( &vMPos );
	 	m_pPolaModel->SetRotation( &vMRot );

		if( ++m_iMoveTime >= POLA_MOVE_TIME ){
			m_Proc = PROC_END;
		}
		break;
		
	case PROC_END: 
		break;
		
	}
	if( m_pModel != NULL )		m_pModel->FrameProcess();
	if( m_pPolaModel != NULL )	m_pPolaModel->FrameProcess();
	
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuPola::RenderProcess(void)
{
	if( !m_bRender )	return true;
		
	//	[hύXifwi̐OɁj
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	
	// JgJݒ
	if(WK7CAM->SetCurrent()==true )
	{
		WK7Light::DispStart();
		WK7Light::DispAll();
		WK7Light::DispEnd();
		
		if( m_pModel 		!= NULL )	m_pModel->RenderProcess();
		if( m_pPolaModel	!= NULL )	m_pPolaModel->RenderProcess();

		WK7CAM->RenderProcess();

		// JgJł̕`I
		WK7CAM->EndCurrent();
	}	
	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuPola::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuPola::GetMenuEnd(void)
{
	if( m_Proc == PROC_END )
	{
		return true;
	}
	return false;
}


//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuPola::LoadData(void)
{
	switch( m_eLoadProc )
	{
	case LOAD_STAGE:
		//	J[e[h
		if( m_pArchive->GetState() == WK7Archive::WK7ARCHIVE_LOADED )
		{
			if(( m_pModel = m_pArchive->CreateModel()) != NULL)
			{
				m_pModel->SetPosition( STAGE_POS_X,	STAGE_POS_Y, STAGE_POS_Z );
				m_pModel->SetRotation( 0.0f, 	STAGE_ROT_Y, 	0.0f );
				m_pModel->Disp();
				m_eLoadProc = LOAD_MOTION;
			}
		}
		break;
		
	case LOAD_MOTION:
		if( m_pMotionArc->GetState() != WK7Archive::WK7ARCHIVE_LOADED )	break;

		if( (m_pMotion = m_pMotionArc->CreateModelMotion()) != NULL )
		{
			m_pModel->AttachMotionAll( m_pMotion );
			m_pModel->PlayMotionAll(0.0f);
			m_eLoadProc = LOAD_POLA;
		}
		break;

	case LOAD_POLA:
		if( m_pPolaArc == NULL ) 	return true;
		if( m_pPolaArc->GetState() == WK7Archive::WK7ARCHIVE_LOADED )
		{
			if(( m_pPolaModel = m_pPolaArc->CreateModel()) != NULL)
			{
				m_pPolaModel->SetPosition( tblPolaFile[m_ucPolaNo].vPosFirst );
				m_pPolaModel->SetRotation( tblPolaFile[m_ucPolaNo].vRot );
				m_pPolaModel->Disp();
				return true;
			}
		}
	}
	return false;
}
