////////////////////////////////////////////////////////////////////////////////
//
// Killer7 IMenuUlmeyda
//
// SK7IMenuUlmeyda.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 10/02/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7IMENUULMEYDA_CPP__

#include "../matsu/mk7Sound.h"
#include "SK7IMenuUlmeyda.h"

#include "../scn/K7Scn02.h"


#define		UL_PACK_DATA		"/sub/UL.pak"
#define		UL_X				(31)
#define		UL_GAP_X			(66)
#define		UL_Y				(180)
#define		UL_Y2				(258)
#define		BIG_X			]	(99)
#define		BIG_Y				(67)
#define		KASAN_X				(65+20)
#define		KASAN_Y				(156)
#define		KASAN_Y2			(235)
#define		KASAN_TIME			(5)

const f32 tblUlSmallX[]={
	65,133,198,266,322,400,
	65,133,198,268,333,401,
};

//	Cgݒ 	
static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 0.000000f, 0.000000f, 20.000000f },		// wobj position
};
static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{0xff,0xff,0xff,0xff},						// color	
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};


//========================================================================
//					RXgN^
//========================================================================
SK7IMenuUlmeyda::SK7IMenuUlmeyda() : SK7IMenuBase()
{
	int i,j;
	m_Proc			= PROC_LOAD;
	m_pFile			= NULL;
	ghmGcMemSetAllocName("SK7ULEFILE");
	m_pFile			= new SK7File;
	for( i = 0; i < TEX_UL_MAX; i++ )	m_ptData[i] = NULL;
	for( i = 0; i < ULMEYDA_NUM; i++ ){
		m_UlModel[i].pArchive 	= NULL;
		m_UlModel[i].pModel 	= NULL;
		for( j = 0; j < ULMEYDA_LIGHT_NUM; j++ ){
			m_UlModel[i].pLight[j] 	= NULL;
		}
	}
	m_pResLink	 	= NULL;
	m_pPackData		= NULL;
	m_chSelect 		= 0;
	m_iTime			= 0;
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetDesc(NULL);
	WK7CAM->SetPosition(0.0f,0.0f,50.0f);
	WK7CAM->SetTargetPosition(0.0f,0.0f,0.0f);

	//	Cg쐬	-----------------------------------
//	WK7Light::Create(&dir_light,0xffffffff,0xffffffff);
}


//========================================================================
//					fXgN^
//========================================================================
SK7IMenuUlmeyda::~SK7IMenuUlmeyda()
{
//	WK7Light::Release(0xffffffff,0xffffffff);

	int i,j;
	for( j = 0; j < ULMEYDA_NUM; j++ ){
		GHM_SAFE_DELETE( m_UlModel[j].pModel );
		for( i = 0; i < ULMEYDA_LIGHT_NUM && m_UlModel[j].pLight[i] != NULL; i++ ){
			GHM_SAFE_DELETE( m_UlModel[j].pLight[i] );
		}
	}
	GHM_SAFE_DELETE( m_pFile );
	for( i = 0; i < TEX_UL_MAX; i++ ){
		GHM_SAFE_DELETE	( m_ptData[i] );
	}
	GHM_SAFE_DELETE	( m_pResLink );
}


//========================================================================
//					
//========================================================================
void	SK7IMenuUlmeyda::Initialize()
{
	int i;
	
	m_spBG.SetTexSprite	( 0, 0, m_ptData[TEX_BACK_GROUND] );
	m_spBG.SetVisible	( true );
	
	int tblULFlag[]={ K7SCN02_EVFL_ULCL01,K7SCN02_EVFL_ULCL02,K7SCN02_EVFL_ULCL03,K7SCN02_EVFL_ULCL04,K7SCN02_EVFL_ULCL05,K7SCN02_EVFL_ULCL06,
							K7SCN02_EVFL_ULCL07,K7SCN02_EVFL_ULCL08,K7SCN02_EVFL_ULCL09,K7SCN02_EVFL_ULCL10,K7SCN02_EVFL_ULCL11,K7SCN02_EVFL_ULCLSECRET };
	for( i = 0; i < ULMEYDA_NUM; i++ ){
		if( i < ULMEYDA_NUM*0.5f ){
			m_spUlmeyda[i].SetTexSprite( tblUlSmallX[i], UL_Y, m_ptData[TEX_SMALL_01+i] );
		}else{
			m_spUlmeyda[i].SetTexSprite( tblUlSmallX[i], UL_Y2, m_ptData[TEX_SMALL_01+i] );
		}
		if( K7SCR_GET_SCENARIO_FLAG(tblULFlag[i]) ){
			m_spUlmeyda[i].SetVisible( true );
		}
	}
	
	m_spKasan.SetTexSprite	( KASAN_X, KASAN_Y, m_ptData[TEX_UL_KASAN] );
	m_spKasan.SetY0			( KASAN_Y+m_spKasan.GetTexSizeY() );
	m_spKasan.SetTwoSize	( m_spKasan.GetTexSizeX(), 0 );//m_spKasan.GetTexSizeY());
	m_spKasan.SetFlag		( true, RENDER_FLAG|SIZE_FLAG );
	m_spKasan.SetBlendNo	( SPR_BLEND_ONE );
}

//========================================================================
//					t[
//========================================================================
bool  	SK7IMenuUlmeyda::FrameProcess(void)
{
	switch( m_Proc )
	{
	case PROC_LOAD:
		if( LoadData() ){
			Initialize();
			m_Proc = PROC_MAIN;
		}
		break;
		
	case PROC_MAIN:
		if( !m_bCtrl )	break;
		
		if( ++m_iTime <= KASAN_TIME ){
			m_spKasan.SetSizeY( m_spKasan.GetSizeY()-(m_spKasan.GetTexSizeY()/KASAN_TIME) );
		}else{
			m_iTime = KASAN_TIME+1;
		}
			
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( ++m_chSelect > ULMEYDA_NUM-1 ){
				m_chSelect = ULMEYDA_NUM-1;
				break;
			}
			if( m_chSelect < ULMEYDA_NUM*0.5f ){
				m_spKasan.SetXY0	( KASAN_X + m_chSelect*UL_GAP_X, KASAN_Y+m_spKasan.GetTexSizeY() );
			}else{
				m_spKasan.SetXY0	( KASAN_X + (m_chSelect-ULMEYDA_NUM*0.5f)*UL_GAP_X, KASAN_Y2+m_spKasan.GetTexSizeY() );
			}
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_spKasan.SetSizeY	( 0 ); 
			m_iTime = 0;
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			if( --m_chSelect < 0 ){
				m_chSelect = 0;
				break;
			}
			if( m_chSelect < ULMEYDA_NUM*0.5f ){
				m_spKasan.SetXY0	( KASAN_X + m_chSelect*UL_GAP_X, KASAN_Y+m_spKasan.GetTexSizeY() );
			}else{
				m_spKasan.SetXY0	( KASAN_X + (m_chSelect-ULMEYDA_NUM*0.5f)*UL_GAP_X, KASAN_Y2+m_spKasan.GetTexSizeY() );
			}
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_spKasan.SetSizeY	( 0 ); 
			m_iTime = 0;
			break;
		}
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( m_chSelect < ULMEYDA_NUM*0.5f )	break;
			m_chSelect -= ULMEYDA_NUM*0.5f;
			m_spKasan.SetXY0	( KASAN_X + m_chSelect*UL_GAP_X, KASAN_Y+m_spKasan.GetTexSizeY() );
			m_spKasan.SetSizeY	( 0 ); 
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_iTime = 0;
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( m_chSelect >= ULMEYDA_NUM*0.5f )	break;
			m_chSelect += ULMEYDA_NUM*0.5f;
			m_spKasan.SetXY0	( KASAN_X + (m_chSelect-ULMEYDA_NUM*0.5f)*UL_GAP_X, KASAN_Y2+m_spKasan.GetTexSizeY() );
			m_spKasan.SetSizeY	( 0 ); 
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			m_iTime = 0;
			break;
		}
		
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( !m_spUlmeyda[m_chSelect].CheckFlag( RENDER_FLAG ) )	break;
			m_spKasan.SetSizeY( -m_spKasan.GetTexSizeY() );
			m_iTime = KASAN_TIME+1;
			gpSound->mPlaySE(SFX_SYS_DECIDE);
			m_UlModel[m_chSelect].pModel->SetPosition( 0,0,0 );
			m_UlModel[m_chSelect].pModel->SetRotation( 0,0,0 );
			m_UlModel[m_chSelect].pModel->Disp();			
			for( int i = 0; i < m_UlModel[m_chSelect].pArchive->GetLightSetNum(); i++ ){
				m_UlModel[m_chSelect].pLight[i]->SetEnable( true );
			}
			m_Proc = PROC_BIG;
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_END;
			break;
		}
		break;
		
	case PROC_BIG:		
		//	h	----------------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			m_UlModel[m_chSelect].pModel->Hide();			
			for( int i = 0; i < m_UlModel[m_chSelect].pArchive->GetLightSetNum(); i++ ){
				m_UlModel[m_chSelect].pLight[i]->SetEnable( false );
			}
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			m_Proc = PROC_MAIN;
			break;
		}
		//		----------------------------------------------
		if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
			m_UlModel[m_chSelect].pModel->SetPosition( 0,0,0 );
			m_UlModel[m_chSelect].pModel->SetRotation( 0,0,0 );
			break;
		}
		//	]	----------------------------------------------
		Vec vModelRot;
		m_UlModel[m_chSelect].pModel->GetRotation( &vModelRot );
		f32 roty = HSD_PadGetNormalStickX(0);
		f32 rotx = HSD_PadGetNormalStickY(0);
		if( roty > 0.4f || roty < -0.4f ){
			vModelRot.y += roty * 0.09f;
		}
		if( rotx > 0.4f || rotx < -0.4f ){
			vModelRot.x += rotx * 0.09f;
		}
		vModelRot.z = 0.0f;
		m_UlModel[m_chSelect].pModel->SetRotation( &vModelRot );
		
		//	gk	----------------------------------------------
		Vec vModelPos;
		m_UlModel[m_chSelect].pModel->GetPosition( &vModelPos );
		vModelPos.z += HSD_PadGetNormalAnalogR(0);
		if( vModelPos.z >= 24.13637f ){
			vModelPos.z = 24.13637f;
		}
		vModelPos.z -= HSD_PadGetNormalAnalogL(0);
		if( vModelPos.z <= 0.0f ){
			vModelPos.z = 0.0f;
		}
		m_UlModel[m_chSelect].pModel->SetPosition( vModelPos );
		break;
		
	case PROC_END:
		break;
	}
	return true;
}

//========================================================================
//					_O
//========================================================================
bool 	SK7IMenuUlmeyda::RenderProcess(void)
{
	if( !m_bRender )	return true;
	int i,j;
	
	m_spBG.Render();
	for( i = 0; i < ULMEYDA_NUM; i++ ){
		m_spUlmeyda[i].Render();
	}
	m_spKasan.Render();
	GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
	
	//	[hύX
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

	HSD_StateInvalidate(HSD_STATE_ALL);
	
	// JgJݒ
	for( j = 0; j < ULMEYDA_NUM; j++ ){
		if( WK7CAM->SetCurrent()==true ){	
			WK7Light::DispStart();
			for( i = 0; i < ULMEYDA_LIGHT_NUM && m_UlModel[j].pLight[i] != NULL; i++ ){
				m_UlModel[j].pLight[i]->Disp();
			}
//			WK7Light::DispAll();
			WK7Light::DispEnd();

			m_UlModel[j].pModel->RenderProcess();
			WK7CAM->EndCurrent();	
		}
	}		
	if(WK7CAM->SetCurrent()==true ){	
		WK7CAM->RenderProcess();
		WK7CAM->EndCurrent();	
	}		

	return true;
}

//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================
bool 	SK7IMenuUlmeyda::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}

//========================================================================
//					j[I֐
//========================================================================
bool 	SK7IMenuUlmeyda::GetMenuEnd(void)
{
	if( m_Proc == PROC_END )
	{
		return true;
	}
	return false;
}

//========================================================================
//					f[^[h
//========================================================================
bool	SK7IMenuUlmeyda::LoadData(void)
{
	int i;
	if( m_pFile->OpenDataFile( UL_PACK_DATA, &m_pPackData ) ){
		ghmGcMemSetAllocName("SK7ULERESLINK");
		if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
			return false;
		}
		//	EC_fZbg	
		for( i = 0; i < ULMEYDA_NUM; i++ ){
			if( NULL != (m_UlModel[i].pArchive = WK7Archive::Create())){
				m_UlModel[i].pArchive->LoadArchive( (void*)m_pResLink->GetResource(i) );
				if( (m_UlModel[i].pModel = m_UlModel[i].pArchive->CreateModel()) != NULL ){

					s32 num, j ;
					num = m_UlModel[i].pArchive->GetLightSetNum() ;
					if( num > ULMEYDA_LIGHT_NUM ) num = ULMEYDA_LIGHT_NUM;
					for( j = 0; j < num; j++ ){
						m_UlModel[i].pLight[j] = WK7Light::Create( m_UlModel[i].pArchive->GetLightSet(j) );
						m_UlModel[i].pLight[j]->SetEnable( false );
					}
					m_UlModel[i].pLight[j] = NULL ;
	
					m_UlModel[i].pModel->SetPosition( 0,0,0 );//&tblModelPosFirst[i] );
					m_UlModel[i].pModel->SetRotation( 0,0,0 );//&tblModelRotFirst[i] );
					m_UlModel[i].pModel->Hide();			
				}
			}
		}
		//	eNX`[Zbg
		for( i = 0; i < TEX_UL_MAX; i++ ){
			ghmGcMemSetAllocName("SK7ULETEXDATA");
			m_ptData[i] = new TEX_DATA;
			if( (m_ptData[i]->Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+ULMEYDA_NUM))==NULL ){
				return false;
			}
			InitTexture( m_ptData[i] );
		}
		GHM_SAFE_DELETE( m_pFile );
		return true;
	}
	return false;
}
