////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Load Task
//
// SK7LoadTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 03/24/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7LOADTASK_H__
#define	__SK7LOADTASK_H__

#include "SK7Sight.h"
#include "../wat/WK7Model.h"
#include "../wat/WK7Archive.h"
#include "SK7Sprite.h"
#include "../Yam/YK7Break.h"
#include "SK7ScenarioData.h"
#include "SK7ScenarioTask.h"
//#include "SK7SaveLoad.h"
#include "SK7SaveBase.h"



#define		SIGHT_SIZE				(60)
#define		SIGHT_SIDE_X			(10.8f)
#define		SIGHT_SIDE_Y			(8.4f)
#define		SIGHT_LINE_MAX			(30)
#define		LINE_R					(50.0f)
#define		SLINE_MOVETIME			(7)
#define		LINE_ANGLE_GAP			(30)
#define		STOP_LINE_R				(0.04f)
#define		STOP_LINE_FRAME			(3)
#define		AFTER_LINE_NUM			(4)
#define		LINE_AFTER_FRAME		(5)
#define		LINE_ONE_ANGLE			(25)
#define		CHARA_FIRST_MOVE_X		(5.0f)
#define		CHARA_MOVE_X			(0)//(-5.0f)
#define		CHARA_MOVE_Y			(0)//(-5.0f)
#define		FRONT_FIRST_X			(-10.0f)
#define		FRONT_FIRST_Y			(10.0f)
#define		BACK_FIRST_X			(-7.725f+5.362504f)
#define		BACK_FIRST_Y			(-6.2f + 3.837506f)
#define		CHARA_HIT_FRAME			(10)
#define		BLOOD_DRAW_TIME 		(20)
#define		MODEL_LOAD_MAX			(4)



//	
class SK7LoadTask : public ghmGcAppTask
{
	//	t[ԍ
	enum{
		FRAME_INIT = 0,
		FRAME_FADE,
		FRAME_TV_LOAD,
		FRAME_LOAD_END,
		FRAME_MAIN,	//	I
		FRAME_LOAD,
		FRAME_CANCEL,
		FRAME_HIT_MOVE_SCENARIO,
		FRAME_CHARA_ENTRANCE,
		FRAME_CANCEL_MOVE_SCENARIO,
		FRAME_MODEL_VIEW,
		FRAME_BLOOD_TIME,
		FRAME_BLOOD_MOVE,	//	̓
		FRAME_CHARA_MOVE,
		FRAME_RETURN_END,
		FRAME_END,
	};

	enum{
		LOAD_ARCHIVE=0,
		LOAD_MODEL0,
		LOAD_MOTION0,
		LOAD_MODEL1,
		LOAD_MOTION1,
		LOAD_MAX,
	};

protected:		
	SK7Sight			m_Sight;

	SK7Sprite			m_spSLine[SIGHT_LINE_MAX];
		
	WK7Archive**		m_ppArchive;			//	A[JCuNX
	WK7Archive**		m_ppMotionArc;
	WK7Model**			m_ppModel;			//	fNX
	WK7ModelMotion** 	m_ppMotion;
	
	SK7SaveBase*		m_pSaveLoad;		//	Z[u[hNX
	SK7Blood			m_Blood;			//	ij
	SK7File				m_File;				//	t@C
	ghmGcResLink*		m_pResLink;			//	N\[X
	void*				m_pPackData;		//	f[^
	TEX_DATA*			m_pTexture;			//	eNX`[f[^
	
	VEC2				m_vLineCenter;		
	int					m_iBloodDrawTime;	//	̕`掞		
	int					m_iCharaMoveTime;
	u16					m_sTexNumber;		//	Ǎ݃t[
	u16					m_sFrameProc;		//	t[
	s16					m_sScenarioNo;		//	ViIԍ
	s8					m_chLineNum;		//	C
	u8					m_ucLoadProc;
	u8					m_ucScenarioNo;
	bool				m_bBloodFlag;		//	H
	bool				m_bLoadFlag;		//	[hIH
	bool				m_bChangeSightFlag;	//	TCg̕ύXtO
	bool				m_bLoadRedFlag;		//	Ԃ̂ł
	bool				m_bReturnFlag;		//	ǂH
	
	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[
	
public:
	SK7LoadTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7LoadTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
		
	//	f[^̃[h	
	bool	LoadData(void);				//	ŏ
	bool 	LoadData2(void);			//	[h
	
	//	f[^̏
	void	DeleteData2();				//	f[^̏

	
	//	Move֐
	void	MoveSight();				//	TCĝǂ
	bool	MoveCharactor();

	//	SET֐
	void	SetBlood(int sNo);			//	̃Zbg
	void	SetSightSize();
	
	//	`֐
	void	RenderSight();					//	TCg̕`惁C
			
	//	f|SQbg
	void	GetModelData();
	void	CheckSightPos();
};

#endif	//__SK7LOADTASK_H__



