////////////////////////////////////////////////////////////////////////////////
//
// Killer7 MemoryCard
//
// SK7MemoryCard.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/25/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7MEMORYCARD_H__
#define	__SK7MEMORYCARD_H__


//	[J[hNX
class SK7MemoryCard{
protected:
	s32				m_sSectorSize[2];			//	eXbgZN^[TCY
	u8*				m_pWorkErea;				//	[NGA
	CARDFileInfo*	m_pCardInfo; 				//	J[hNX
public:
	SK7MemoryCard();
	~SK7MemoryCard();	

	void		CreateCard();					//	J[hf[^쐬
	void		DeleteCard();					//	J[hf[^
	void		CreateCardInfo();				//	J[h
	s32			GetCardInsert	( s32 SlotNo );	//J[h}`FbN
	bool		GetSectorSize	( s32 SlotNo );	//ZN^[8KB`FbN
	s32			SetCardMount	( s32 SlotNo );	//	}Eg`FbN
	s32			SetCardUnMount	( s32 SlotNo );	//	A}Eg
	s32 		SetCardCheck	( s32 SlotNo );	//J[hC`FbN
	s32 		SetCardOpen		( s32 SlotNo, char* FileName );	//	J[hI[v
	s32			SetCardClose	();								//	J[hN[Y
	s32 		SetCardRead		( void* Buff, s32 ReadSize,  s32 Offset );	//	J[h[h
	s32 		SetCardReadB	( void* Buff, s32 ReadSize,  s32 Offset );	//	J[h[hubN
	s32			SetCardFormat	( s32 SlotNo );								//	J[h
	s32			SetCardFormatB	( s32 SlotNo );								//	J[h
	s32			SetCreateCard	( s32 SlotNo, char* FileName, u32 Size );	//	VKt@C쐬
	s32			SetCreateCardB	( s32 SlotNo, char* FileName, u32 Size );	//	VKt@C쐬
	s32			SetWriteCard	( const void* Data, s32 Size, s32 Offset );	//	
	s32			SetDeleteCard	( s32 SlotNo, char* FileName );				//	J[h폜
	s32			SetDeleteCardB	( s32 SlotNo, char* FileName );				//	J[h폜
	s32			SetRenameCard	( s32 SlotNo, const char* OldName, const char* NewName );	//	t@Cl[
	s32			SetRenameCardB	( s32 SlotNo, const char* OldName, const char* NewName );	//	t@Cl[
	s32			SetCardData		( s32 SlotNo );								//	J[hf[^Zbg
	bool 		GetCardErea		( s32 SlotNo, int DataSize );	//	J[hGA`FbN
	s32			GetCardStatus	( s32 SlotNo, CARDStat* CardState );		//	J[hԎ擾
	void		InitCardInfo	(){ memset( m_pCardInfo, 0, sizeof(CARDFileInfo) ); }
};

#endif	//__SK7MEMORYCARD_H__
