////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7OptionTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//	
////////////////////////////////////////////////////////////////////////////////

#define	__SK7OPTIONTASK_CPP__

#include "SK7OptionTask.h"
#include "..\Wat\K7App.h"
#include "..\Wat\WK7MenuTask.h"
#include "../matsu/mk7Sound.h"
#include "../wat/WK7MainTask.h"
#include "../matsu/MK7TitleTask.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7EventScript.h"
#include "../wat/WK7Archive.h"
#include "../yam/YK7EffectNoise.h"
#include "../yam/YK7CharChange.h"

#define		KANA_FONT			"/Yam/CharChange/TVKana_GC.BIN"//
#define		TV_TEX				"/Yam/CharChange/tvtv005_bg.BIN"
#define		ENG_FONT			"/Texture/option_GC.BIN"
#define		OPTION_COLOR		(0x00ff00A5)
#define		OPTION_MES_X		(90)
#define		OPTION_MES_Y(NO)	(120+NO*50)
#define		OPTION_YES_X		(345)//(330)
#define		OPTION_NO_X			(435)//(390)
#define		TELOP_FONT_X		(500)
#define		TELOP_FONT_Y		(343)
#define		TELOP_SPEED			(3)
#define		ANSWER_GAP_X		(6)
#define		ANSWER_GAP_Y		(6)
#define		ANSWER_SIZE_Y		(35)
#define		NAME_FONT_SIZEY		(28)

const int tblOptionNo[]={ K7GLFL_OPT_RECONTROL, K7GLFL_OPT_VIB  };
#define		FADE_SPEED				(WK7_SEC_TO_TICK(0.9f))


//========================================================================
//					R[obN
//========================================================================
bool SK7OptionTask::InitializeCallBack(void)
{	
	//	---------	eXgp̏	------------	//
	HSD_VISetClearClr((GXColor){0,0,0,0xff});
	
	m_Proc 		= eProcLoad;
	m_Load		= eLoadKana;
	m_chSelect	= eSelectControl;
	m_iTime		= 0;
	m_fTelopX	= TELOP_FONT_X;

	m_pNoiseEffect = NULL;
	m_pTaskControl = NULL;
	
	k7app.SetFadeColor( 0x000000ff );
	k7app.FadeStart( 0xff, 0 );

	m_pYEng =  NULL;
	ghmGcMemSetAllocName("OPTION");
	m_pYEng =  new YK7StrImage;
	m_pYEng->Load( ENG_FONT );
	
	m_pYFont = NULL;
	ghmGcMemSetAllocName("OPTION");
	m_pYFont = new YK7StrImage;
	m_pYFont->Load( ENG_FONT );
	
	m_pYKana = NULL;
	ghmGcMemSetAllocName("OPTION");
	m_pYKana = new YK7StrImage;
	m_pYKana->Load( KANA_FONT );
		
	m_spTelop.SetSprite( 20, 333, 500, 48, 0xccccccff );
	m_spTelop.SetVisible( true );

	for( int i = 0; i < eSelectEnd; i++ )	m_spSelect[i].SetVisible( true );
	m_spName.SetVisible( true );

#if 1
	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();
#endif
	//	TEhf[^Ăяo
	gpSound->mReadSsm("seTv.ssm",eBankPlayer);
	
	return true;
}


//========================================================================
//					IR[obN
//========================================================================
bool 	SK7OptionTask::TerminateCallBack(void)
{	
	m_spTV.Delete();
	
	//	TEhf[^J
	gpSound->mReleaseSsm("seTv.ssm");
	//	RcGtFNgI
	DeleteEffect( m_pNoiseEffect );
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);
	screenImageFullColor.FreeBuffer();

	
	if( m_pYFont != NULL )	m_pYFont->Release();
	if( m_pYKana != NULL )	m_pYKana->Release();
	if( m_pYEng != NULL )	m_pYEng->Release();

	GHM_SAFE_DELETE( m_pYFont );
	GHM_SAFE_DELETE( m_pYKana );
	GHM_SAFE_DELETE( m_pYEng );
	
	ghmGcApp *pApp = GetApplication();

	delete this;
	new MK7TitleTask(pApp);
	
	return true;
} 


//========================================================================
//					t[
//========================================================================
bool 	SK7OptionTask::FrameProcess(void)
{
	switch( m_Proc ){
//		[h		
	case	eProcLoad:
		if( LoadTexture() ){
			k7app.FadeStart( 0x00, FADE_SPEED );
			m_Proc = eProcFade;
		}
		break;
		
//		tF[h		
	case	eProcFade:
		if( !k7app.IsFade() ){
			m_Proc = eProcSelect;
		}
		break;
		
//		ZNg		
	case eProcSelect:
		if( CheckKeyT( SK7_KEY_UP ) ){
			if( --m_chSelect < eSelectControl ){
				m_chSelect = eSelectEnd;
			}
			gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
			m_fTelopX	= TELOP_FONT_X;
			break;
		}
		if( CheckKeyT( SK7_KEY_DOWN ) ){
			if( ++m_chSelect >= eSelectMax ){
				m_chSelect = eSelectControl;
			}
			gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
			m_fTelopX	= TELOP_FONT_X;
			break;
		}
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			if( m_chSelect == eSelectEnd ) break;
			if( m_chSelect != eSelectSound && !K7SCR_GET_GLOBAL_FLAG( tblOptionNo[m_chSelect] ) )	break;
			if( m_chSelect == eSelectSound && OSGetSoundMode()==OS_SOUND_MODE_STEREO )	break;

			gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
			if( m_chSelect == eSelectSound ){
				gpSound->mSetSoundMode( HSD_SYNTH_SOUND_MODE_STEREO );
				OSSetSoundMode( OS_SOUND_MODE_STEREO );
			}
			if( m_chSelect != eSelectEnd ){
				K7SCR_RESET_GLOBAL_FLAG( tblOptionNo[m_chSelect] );
			}
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			if( m_chSelect == eSelectEnd ) break;
			if( m_chSelect != eSelectSound && K7SCR_GET_GLOBAL_FLAG( tblOptionNo[m_chSelect] ) )	break;
			if( m_chSelect == eSelectSound && OSGetSoundMode()==OS_SOUND_MODE_MONO )	break;
			gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
			if( m_chSelect == eSelectSound ){
				gpSound->mSetSoundMode( HSD_SYNTH_SOUND_MODE_MONO );
				OSSetSoundMode( OS_SOUND_MODE_MONO );
			}
			if( m_chSelect != eSelectEnd ){
				K7SCR_SET_GLOBAL_FLAG( tblOptionNo[m_chSelect] );
			}
			gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
			break;
		}
		if( ((HSD_PadGetTrigger(0) & HSD_PAD_A) && m_chSelect == eSelectEnd) ||
			( HSD_PadGetTrigger(0) & HSD_PAD_B ))
		{
			gpSound->mPlaySE( SFX_TV_CANCEL );
			k7app.FadeStart( 0xff, FADE_SPEED );
			m_Proc = eProcEnd;
			break;
		}
		break;
	case eProcEnd:
		if( !k7app.IsFade() ){
			DeleteTerminate();
			break;
		}
		break;
	}
	gpSound->mFrameProcess(); 
	SetEffectCamera(WK7CAM->GetCObj());
	WK7Archive::FrameProcessAll();

	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7OptionTask::RenderProcess(void)
{
	int i;
	f32 Size;
	if( m_Proc > eProcLoad ){
		m_spTelop.Render();

		//	ebv̕`	=============================================
		char* tblTelopFont[]={
			"傤@@́@@傤@@@@́@@Ă@@@@Ȃ܂",
//			"܂@@́@@Ђ傤Ă@@@@Ȃ܂",
			"΂Ԃ[@@́@@Ă@@@@Ȃ܂",
			"ǁ@@́@@Ă@@@@Ȃ܂",
			"Ƃ@@Ɂ@@ǂ܂",
		};
		m_pYFont->DrawSetup();
		m_pYFont->SetColor2(0x000000ff);
		Size = m_pYFont->DrawFSStr( 0, 0, false, false,  tblTelopFont[m_chSelect] );
		m_pYFont->DrawFSStr( m_fTelopX, TELOP_FONT_Y, false, true,  tblTelopFont[m_chSelect] );

		m_fTelopX -= TELOP_SPEED;
		if( m_fTelopX+Size < 20 )	m_fTelopX = TELOP_FONT_X;
		
		//	ZNgtHg	============================================
		m_pYEng->DrawSetup();
		m_pYEng->SetExRate( 1.2f );
		
		for( i = 0; i < eSelectEnd; i++ ){
			if( i < eSelectSound ){
				if( K7SCR_GET_GLOBAL_FLAG( tblOptionNo[i] ) ){
					Size = m_pYEng->DrawFSStr( 0, 0, false, false,  "ON" );
					m_spSelect[i].SetSprite( OPTION_YES_X-ANSWER_GAP_X-Size*0.5f, OPTION_MES_Y(i)-ANSWER_GAP_Y, Size+ANSWER_GAP_X*2,ANSWER_SIZE_Y+ANSWER_GAP_Y, OPTION_COLOR );
				}else{
					Size = m_pYEng->DrawFSStr( 0, 0, false, false,  "OFF" );
					m_spSelect[i].SetSprite( OPTION_NO_X-ANSWER_GAP_X-Size*0.5f, OPTION_MES_Y(i)-ANSWER_GAP_Y, Size+ANSWER_GAP_X*2,ANSWER_SIZE_Y+ANSWER_GAP_Y, OPTION_COLOR );
				}
			}else{
				if( OSGetSoundMode()==OS_SOUND_MODE_MONO ){
					Size = m_pYEng->DrawFSStr( 0, 0, false, false,  "MONO" );
					m_spSelect[i].SetSprite( OPTION_YES_X-ANSWER_GAP_X-Size*0.5f, OPTION_MES_Y(i)-ANSWER_GAP_Y, Size+ANSWER_GAP_X*2,ANSWER_SIZE_Y+ANSWER_GAP_Y, OPTION_COLOR );
				}else{
					Size = m_pYEng->DrawFSStr( 0, 0, false, false,  "STEREO" );
					m_spSelect[i].SetSprite( OPTION_NO_X-ANSWER_GAP_X-Size*0.5f, OPTION_MES_Y(i)-ANSWER_GAP_Y, Size+ANSWER_GAP_X*2,ANSWER_SIZE_Y+ANSWER_GAP_Y, OPTION_COLOR );
				}
			}
			m_spSelect[i].Render();
		}
		m_pYFont->DrawSetup();
		m_pYFont->SetExRate( 1.0f );
		
		char* tblOptionName[]={
			"Ƃ[΁[",
//			"܂",
			"ǂ",
			"",
			"Ƃ",
		};
		Size = m_pYFont->DrawFSStr( OPTION_MES_X, OPTION_MES_Y(i), false, true,  tblOptionName[m_chSelect] );

		//	I{bNX	=====================================================
		m_spName.SetSprite( OPTION_MES_X-ANSWER_GAP_X, OPTION_MES_Y(m_chSelect)-ANSWER_GAP_Y,  Size+ANSWER_GAP_X*2, NAME_FONT_SIZEY+ANSWER_GAP_Y*2, OPTION_COLOR );
		m_spName.Render();
		
		for( i = 0; i < eSelectMax; i++ ){
			if( i == m_chSelect )	m_pYFont->SetColor2(0x000000ff);
			else					m_pYFont->SetColor2(OPTION_COLOR);

			m_pYFont->DrawFSStr( OPTION_MES_X, OPTION_MES_Y(i), false, true,  tblOptionName[i] );
		}
		
		m_pYEng->DrawSetup();
		m_pYEng->SetExRate( 1.2f );
		bool flag=false;
		for( i = 0; i < eSelectEnd; i++ ){
			flag=false;
			if( i < eSelectSound ){
				if( K7SCR_GET_GLOBAL_FLAG( tblOptionNo[i] ) )	flag = true;
				if( flag )	m_pYEng->SetColor2(0x000000ff);
				else		m_pYEng->SetColor2(OPTION_COLOR);
				m_pYEng->DrawFSStr( OPTION_YES_X, OPTION_MES_Y(i), true, true,  "ON" );

				if( flag )	m_pYEng->SetColor2(OPTION_COLOR);
				else		m_pYEng->SetColor2(0x000000ff);
				m_pYEng->DrawFSStr( OPTION_NO_X,  OPTION_MES_Y(i), true, true,  "OFF" );
			}else{
				if( OSGetSoundMode()==OS_SOUND_MODE_MONO )		flag = true;
				if( flag )	m_pYEng->SetColor2(0x000000ff);
				else		m_pYEng->SetColor2(OPTION_COLOR);
				m_pYEng->DrawFSStr( OPTION_YES_X, OPTION_MES_Y(i), true, true,  "MONO" );				

				if( flag )	m_pYEng->SetColor2(OPTION_COLOR);
				else		m_pYEng->SetColor2(0x000000ff);
				m_pYEng->DrawFSStr( OPTION_NO_X,  OPTION_MES_Y(i), true, true,  "STEREO" );
			}
		}
		
	}
	DrawSousaLine();
	if( m_pNoiseEffect ){
		MoveEffect(m_pNoiseEffect);
		DrawEffect(m_pNoiseEffect);
	}
	_DrawTVScreen();

	m_spTV.Render();
	m_pTaskControl->FrameProcess();
	return true;
}

//========================================================================
//					RXgN^
//========================================================================
SK7OptionTask::SK7OptionTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
}

//========================================================================
//					fXgN^
//========================================================================
SK7OptionTask::~SK7OptionTask()
{
}

//========================================================================
//					[h
//========================================================================
bool		SK7OptionTask::LoadTexture()
{	
	switch( m_Load ){
	case eLoadKana:
		if( m_pYKana->LoadCheck() ){
			m_Load = eLoadTV;
		}
		break;
		
	case eLoadTV:
		if( m_spTV.LoadTexture( TV_TEX ) ){
			m_spTV.SetXY0( 0, 0 );
			m_spTV.SetVisible( true );
			m_Load = eLoadFont;
		}
		break;
		
	case eLoadFont:
		if( m_pYFont->LoadCheck() ){
			m_pYFont->SetKanaFont( m_pYKana );
			m_Load = eLoadEng;
		}
		break;

	case eLoadEng:
		if( m_pYEng->LoadCheck() ){
//			return true;
			m_Load = eLoadEffect;
		}
		break;
#if 1		
	case eLoadEffect:
		if( EffectSetupCheck() == TRUE ){
			m_pNoiseEffect = CreateNoiseEffect();
			SetEffectIndeManageFlag( m_pNoiseEffect, true );
			SetEffectCamera( WK7CAM->GetCObj() );
			return true;
		}
		break;
#endif
	}

	return false;
}

