////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Logo Task
//
// SK7OptionTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 01/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7OPTIONTASK_H__
#define	__SK7OPTIONTASK_H__

#include "SK7Common.h"
#include "SK7Sprite.h"
#include "../Yam/YK7String.h"
#include "../yam/YK7Effect.h"
#include "../wat/WK7Cam.h"



//	IvV^XNNX
class SK7OptionTask : public ghmGcAppTask
{
	typedef enum{
		eLoadKana=0,
		eLoadTV,
		eLoadFont,
		eLoadEng,
		eLoadEffect,
	}eLoadProc;

	typedef enum{
		eProcLoad=0,
		eProcFade,
		eProcSelect,
		eProcEnd,
	}eOptionProc;
	
	enum{
		eSelectControl=0,
//		eSelectJimaku,
		eSelectVib,
		eSelectSound,
		eSelectEnd,
		eSelectMax,
	};
	
protected:
	eOptionProc			m_Proc;
	eLoadProc			m_Load;
	int					m_iTime;
	s8					m_chSelect;
	f32					m_fTelopX;

	YK7StrImage* 		m_pYEng;						//	p
	YK7StrImage* 		m_pYFont;						//	tHg
	YK7StrImage* 		m_pYKana;						//	J^Ji

	SK7Sprite			m_spTV;
	SK7Sprite			m_spSelect[eSelectMax];
	SK7Sprite			m_spTelop;
	SK7Sprite			m_spFade;
	SK7Sprite			m_spName;

	EFFECT*				m_pNoiseEffect;
	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

#if 0
	//	pbNt@C	-----------------------------------
	SK7File						m_File;
	ghmGcResLink*				m_pResLink;			//	N\[X
	void*						m_pPackData;		//	f[^
	TEX_DATA*					m_pTexture;			//	eNX`[f[^
#endif
	
	
public:
	SK7OptionTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7OptionTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	bool		LoadTexture();
};

#endif	//__SK7OPTIONTASK_H__



