////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Pack
//
// SK7Pack.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7PACK_H__
#define	__SK7PACK_H__

#include "SK7Sprite.h"


//	eNX`[Nt@C	--------------------------------
enum{
	TEX_YAMADA_FONT=0,
	TEX_BLOOD_FONT,
	
	TEX_EYE,
	TEX_EYE2,
	TEX_BOTTOM_001,
	TEX_BOTTOM_002,
	TEX_KAZARI_001,
	TEX_KAZARI_002,
	TEX_KAZARI_003,
	TEX_KAZARI_004,
	TEX_KAZARI_005,
	TEX_PANEL_001,
	TEX_PANEL_002,
	TEX_SIDE_001,
	TEX_SIDE_002,
	TEX_SIDE_003,
	TEX_SIDE_004,
	TEX_SIDE_005,
	TEX_SIDE_006,
	TEX_UP_001,
	TEX_UP_002,
	TEX_UP_003,
	TEX_PANEL,
	TEX_SELECT_1,
	TEX_SELECT_2,
	TEX_SELECT_2b,
	TEX_SELECT_3,
	TEX_SELECT_4,
	TEX_SELECT_5,
	TEX_SELECT_6,
	TEX_SELECT_NAME,
	TEX_ALL_CHARA,
	TEX_NAME_KASAN,
	TEX_BULLET,
	TEX_STONE,
	TEX_RING_KASAN,
	TEX_RING_KASAN2,
	TEX_MEMO,
	TEX_BEAKER_BODY,
	TEX_BEAKER_BOTTOM,
	TEX_BEAKER_MEMORI,
	TEX_BEAKER_TOP,
	TEX_BLOOD,
	TEX_MACINE_A,
	TEX_MACINE_B,
	TEX_MACINE_C,
	TEX_MACINE_KASAN,
	TEX_MACINE_KASANB,
	TEX_SIKENKAN_A,
	TEX_SIKENKAN_B,
	TEX_TUBE_A,
	TEX_TUBE_B,
	TEX_TUBE_C,
	TEX_TUBE_D,
	TEX_TUBE_E,
	TEX_NODE,
	TEX_PIPE,
	TEX_DL,
	TEX_LIGHT,
	
	TEX_GROUP_A,
	TEX_MOJI_A,
	TEX_MOJI_I,
	TEX_MOJI_TE,
	TEX_MOJI_MU,
	TEX_MOJI_JIN,
	TEX_MOJI_KAKU,
	TEX_MOJI_KOU,
	TEX_MOJI_TAI,
	TEX_MOJI_KETSU,
	TEX_MOJI_SEI,
	TEX_MOJI_KAI,
	TEX_MOJI_FUKU,
	TEX_MOJI_ME,
	TEX_MOJI_MO,
	TEX_MOJI_HA,
	TEX_MOJI_TO,
	TEX_MOJI_SORE,
	TEX_MOJI_PLATE,

	TEX_CONP_CIRCLE,
	TEX_CONP_CONPAS_KASAN,
	TEX_CONP_N,
	TEX_CONP_E,
	TEX_CONP_S,
	TEX_CONP_W,
	TEX_ENEMY_KASAN,
	
	TEX_MAX,
};

#define		JMB_NUM			(0)
#define		YAMADA_NUM		(2)
#define		TEXTURE_NOT_NUM	(JMB_NUM+YAMADA_NUM)


//
//					Tu	
//
class 	SK7SpecialData
{
	enum{
		PROC_LOAD_ERROR=0,
		PROC_LOAD_TEXTURE,
		PROC_EFFECT,
		PROC_END,
	};
	
protected:
	SK7File*		m_pFile;
	ghmGcResLink*	m_pResLink;	//	N\[X

	void*			m_pYFontData[2];
	TEX_DATA*		m_ptTexData[TEX_MAX-TEXTURE_NOT_NUM];	//	
	
	void*			m_pPackData;	//	f[^
	u8				m_eProc;
public:
	SK7SpecialData();
	~SK7SpecialData();
	
	//		
	void	Initialize();
	
	//	ǂݍݏI`FbN	
	bool	GetFileReadEnd();

	//	t[̏
	u8		GetState();
	//	Zbg
	void	SetState(u8 proc){ m_eProc = proc; }
	
	//	t[vZX
	void	FrameProcess();
	
	//	
	void	Terminate();	//	G[bZ[W͏Ȃ

	//	擾
	void*		GetYFontData(u8 No=0)		{ return m_pYFontData[No]; }
	TEX_DATA*	GetTexture(u8 No)	{ return m_ptTexData[No-TEXTURE_NOT_NUM]; }
};





//	Xe[WpeNX`[	---------------------------------
enum{
	STAGE_TEX_PHOTO=0,
	STAGE_TEX_ITEM,
	STAGE_TEX_ICON,
	STAGE_TEX_MEDAL,
	STAGE_TEX_MAX,
};

//
//					Xe[Wf[^	
//
class 	SK7StageData
{
	enum{
		PROC_LOAD_TEXTURE=0,
		PROC_END,
	};
	
protected:
	SK7File*		m_pFile;
	ghmGcResLink*	m_pResLink;	//	N\[X

	TEX_DATA*		m_ptTexData[STAGE_TEX_MAX];
	
	void*			m_pPackData;	//	f[^
	u8				m_eProc;
	int				m_iFlow;
public:
	SK7StageData();
	~SK7StageData();
	
	//		
	void	Initialize();
	
	//	ǂݍݏI`FbN	
	bool	GetFileReadEnd();

	//	t[̏
	u8		GetState();

	//	Zbg
	void	SetState(u8 proc){ m_eProc = proc; }
	
	//	t[vZX
	void	FrameProcess();
	
	//	
	void	Terminate();

	//	擾
	TEX_DATA*	GetStageTex(u8 No)	{ return m_ptTexData[No]; }
	int			GetStageFlow()		{ return m_iFlow; }
};


//	O[o	----------------------------------------
extern SK7SpecialData*	g_pSpData;	
extern SK7StageData*	g_pStageData;


#endif	//__SK7PACK_H__
