////////////////////////////////////////////////////////////////////////////////
//
// Killer7 PackData
//
// SK7PackData.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7PACKDATA_CPP__

#include "SK7PackData.h"
#include "../Lib/ghmGcTex.h"

//========================================================================
//					RXgN^
//========================================================================
SK7PackData::SK7PackData()
{
	m_pPackData	= NULL;
	m_pResLink 	= NULL;
}

//========================================================================
//					fXgN^
//========================================================================
SK7PackData::~SK7PackData()
{
	GHM_SAFE_DELETE	( m_pResLink );	
}

//========================================================================
//					I[v
//========================================================================
bool			SK7PackData::OpenPack( char* filename )
{
	if( m_File.OpenDataFile( filename, &m_pPackData ) ){
		if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)!=NULL ){
			return true;
		}
		OSReport("ERROR : NOT OPEN PACK FILE");
	}
	return false;
}

//========================================================================
//					eNX`[f[^擾
//========================================================================
bool			SK7PackData::GetTexture( TEX_DATA* pTex, int no )
{
	if( (pTex->Header = (GhmGcTexHeader*)m_pResLink->GetResource(no))==NULL ){
		return false;
	}
	InitTexture( pTex );
	return true;
}


//========================================================================
//					ff[^擾
//========================================================================
bool			SK7PackData::GetModel( WK7Archive** pArc, WK7Model** pModel, int no )
{
	if( NULL != (*pArc = WK7Archive::Create())){
		(*pArc)->LoadArchive( (void*)m_pResLink->GetResource(no) );
		if( (*pModel = (*pArc)->CreateModel()) != NULL ){
			return true;
		}
	}
	return false;
}

//========================================================================
//					[Vf[^擾
//========================================================================
bool			SK7PackData::GetMotion( WK7Archive** pArc, WK7ModelMotion** pMotion, int no )
{
	if( NULL != (*pArc = WK7Archive::Create())){
		(*pArc)->LoadArchive( (void*)m_pResLink->GetResource(no) );
		if( (*pMotion = (*pArc)->CreateModelMotion()) != NULL ){
			return true;
		}
	}
	return false;
}

//========================================================================
//					RctHgf[^擾
//========================================================================
bool			SK7PackData::GetYamFont( YK7StrImage* pFont, int no )
{
	pFont->LoadMem( (void*)m_pResLink->GetResource(no) );
	return true;
}

//========================================================================
//					f[^擾
//========================================================================
void*			SK7PackData::GetData( int no )
{
	return (void*)m_pResLink->GetResource(no);
}
