////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SaveLoad
//
// SK7SaveData.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 03/19/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SAVEDATA_H__
#define	__SK7SAVEDATA_H__
#include "DVDBanner.h"

#include "..\Wat\WK7GameInfo.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7Stage.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7EventItem.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Wat\WK7Skill.h"

#define		SAVE_FONT_SIZE					(64)						//	Z[utHgTCY
#define		BANNER_SIZE						(6144)						//	oi[TCY
#define		ICON_SIZE						(2048)						//	ACRTCY
#define		SAVE_DATA_NUM					(7)							//	Z[uf[^
#define		NAME_SIZE						(32)						//	Z[uf[^̖O
#define		SECTOR_SIZE						(1024*8)					//	ZN^[TCY
#define		DATACHECK_WORD_NUM				(7)							//	Q[NAf[^`FbNp[h
//#define		SAVE_ALL_SIZE					(SECTOR_SIZE*SAVEDATA_BLOCK)//	Z[uS̃TCY

#define		SAVELOAD_VERSION				(1024)  	//	o[W 1000->1.000ł
typedef unsigned char byte;

//	Z[uf[^	
//
//			ɃZ[uf[^Ă
//
struct SK7SaveGameData{
	union{
		struct{
			u32			mPrevStageBpName     : 1;
			u32			mCurrentStagePathDir : 1;
			u32			mFlagPad             :30;
		};
		u32				mFlag;
	};
	int					mStartScenarioID;
	int					mClearScenarioID;
	int					mClearScenarioID2;
	K7ScenarioFlow		mScenarioFlow;
	K7Area				mAreaID;
	u32					mCharaID;
	u32					mCurrentStageID;
	f32					mCurrentStagePathParam;
	char				mCurrentStagePathName[128];
	u32					mPrevStageID;
	char				mPrevStagePathName[16];
	u32					mPrevStageParam;
	u32					mGlobalFlag     [WK7GAMEINFO_GLOBAL_FLAG_WORK_SIZE  ];
	u8					mGlobalVar      [WK7GAMEINFO_GLOVAL_VAR_SIZE        ];
	u32					mScenarioFlag   [WK7GAMEINFO_SCENARIO_FLAG_WORK_SIZE];
	u8					mScenarioVar    [WK7GAMEINFO_SCENARIO_VAR_SIZE      ];
	u32					mItemFlag       [WK7EVENTITEM_WORKSIZE              ];
	u32					mPlayedFlag     [WK7PLAYTBL_WORKSIZE                ];
	u32					mHarmanRoomFlag [WK7STAGE_HARMANROOM_FLAG_WORK_SIZE ];
	u32					mHarmanTvFlag   [WK7STAGE_HARMANTV_FLAG_WORK_SIZE   ];
	u32					mPassPathFlag   [WK7STAGE_PASSPATH_FLAG_WORK_SIZE   ];
	u32					mSelectObjFlag  [WK7STAGE_SELECTOBJ_FLAG_WORK_SIZE  ];
	u32					mMapFlag        [WK7STAGE_MAP_FLAG_WORK_SIZE        ];
	u32					mCurrentStageParam;
	
	s8					mNpcDieInfo[1+ENENO_MAX];
	u32					mDieInfoBit;				// 񂾂łȂ̃tO
	u32					mCollectInfoBit;			// H
	u32					mReCallInfoBit;				// ĂыNǂH
	u32					mSelOKInfoBit;				// LI\ǂH
	
	s16					mPcHp[K7PCMAX];				// LN^HP
	int					mBpGauge[BP_MAX];			// aoQ[W
	PCSKILLALL			mSkillAll;					// XL
	u32					mTotalEnemyHunt;			// G̑j
	u32					mTotalReCallNum;			// erʓ̈N
	u8					mGalPowerUp;				// KVAp[Abv
	u8					mDanPowerUp;				// _p[Abv
	u8					mMskPowerUp;				// }XNp[Abv
	u32					mComboCount;				// R{JEg
	u32					mCreateSerumVolume;			// 쐬Av̗
	u32					mUsedEnemyCount;			// gp(?)G̗

	u16					mThickBlood;				// hߏItZ
	u16					mThinBlood;					// hߏIt
	u16					mSerumBlood;				// hߏItsu
	s8					mBulletNum;					// eە\
	
	KK7DeadPlayerSaveData	mDeadPlayer[9];
};


//	J[hɏޓe	
//
//				Ȃł
//

struct SK7SaveData{
//	union{
//		struct{
			char				Comment[SAVE_FONT_SIZE];	//	Rgf[^
			byte				Banner[BANNER_SIZE];		//	oi[f[^
			byte				Icon[ICON_SIZE];			//	ACRf[^

			u32					CrcNo;						//	bqbf[^
			u16					Version;					//	o[Wf[^
//			bool				GameClearFlag;				//	Q[NAtO
//			bool				Hopper7Flag;				//	zbp[VtO
			char				GameClearWord[DATACHECK_WORD_NUM];	//	Q[NA`FbNp[h
			SK7SaveGameData		SaveData;					//	Z[uf[^
//		};
//		u8						mData[SAVE_ALL_SIZE];
//	};
//	byte				AddData[SAVE_GAP_DATA];		//	Ȃ
};


#define		SAVEDATA_SIZE		(GHM_ROUNDUP(sizeof(SK7SaveData),SECTOR_SIZE))		//	Z[uf[^TCY
#define		SAVEDATA_BLOCK		(SAVEDATA_SIZE/SECTOR_SIZE)							//	Z[uf[^ɎgubN
extern SK7SaveData* 	g_pSaveData;

#endif	//__SK7SAVEDATA_H__
