////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SaveLoad
//
// SK7SaveLoad.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SAVELOAD_CPP__

//#define	__DEBUG_SAVE__
//#define	__VERSION_CHECK__
//#define		__EFFECT_TV__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include <limits.h>
#include "../wat/K7App.h"
#include "SK7SaveLoad.h"
#include "../matsu/mK7Sound.h"
#include "../Yam/YK7Effect.h"
#include "../wat/WK7GameInfo.h"
#include "../Yam/YK7EffectNoise.h"
#include "../wat/K7GlobalFlag.h"
#include "../yam/YK7CharChange.h"



#define		ICON_TEX_1				"/item/icon1.BIN"
#define		ICON_TEX_7				"/item/icon7.BIN"
#define		SAVE_FILE_NAME			"Killer7"

#define		SAVE_CURSOL_X			(100)
#define		SAVE_CURSOL_Y			(75)
#define		SAVE_NO_X				(123)
#define		SAVE_DATA_X				(167)
#define		SAVE_DATA_Y				(122)//(80)
#define		SAVE_DATA_GAPY			(35)
#define		SAVE_NAME_TIME			(20)
#define		SAVE_NAME_RIGHT_X		(600)
#define		SAVE_FILE_BOX_X			(320)
#define		SAVE_FILE_BOX_Y			(30)
#define		SAVE_BOX_SIZEY			(32)
#define		SAVE_BOX_PLUSX			(40)
#define		COMMENT_MEM_SCN			(17)
#define		COMMENT_MEM_POINT		(19)
#define		CHAN_MOVE_TIME			(30)
#define		CHECK_WAIT_TIME			(50)

//	bZ[WZbgp	--------------------------------------
#define		SET_NEXT_MESSAGE( NO, PROC, SLOTNO, ERROR )\
	{\
		m_NextMes.No 			= NO;\
		m_NextMes.proc 			= PROC;\
		m_NextMes.slotno		= SLOTNO;\
		m_NextMes.bErrorDraw 	= ERROR;\
	}

//	bZ[W̐	------------------------------------------
const u8 tblCheckSelectNum[]={ 2, 3, 3, 2, 3, };

//	bqbp	------------------------------------------
#define 	CRCPOLY1	(0x04c11db7ul)
#define 	CRCPOLY2	(0xedb88320ul)
typedef unsigned char byte;
unsigned long crctable[CHAR_MAX + 1];

void makecrctable1(void);
u32 crc1(int n, byte c[]);
void makecrctable2(void);
u32 crc2(int n, byte c[]);



//========================================================================
//					RXgN^
//========================================================================
SK7SaveLoad::SK7SaveLoad( s8 State )
{
	m_iSaveDataSize  = GHM_ROUNDUP(sizeof(SK7SaveData),SECTOR_SIZE);
	m_iSaveDataBlock = m_iSaveDataSize / SECTOR_SIZE;
	
	//	J[hAPI
	CARDInit();
	
	m_bRender 				= false;					// `tO
	m_bCtrl 				= false;				// 싖tO
	m_ucState				= (u8)State;				// 
	m_bSlotInFlag			= false;
	m_bSelectFlag			= false;		
	m_bLoadFontFlag			= false;
	m_bSaveOkFlag			= false;
	m_bChanFlag				= false;
	m_chSavedFlag			= 0;
	m_ScenarioNo			= 0;
	m_lSlotAColor = m_lSlotBColor = CARD_NOT_COLOR;

	m_chNextProc	 		= 0;					//	̃vbN
	m_chSelect				= 0;					//	J[\ZNgԍ
	m_ucSelectNo			= 0;					//	ZNg@
	m_chSetSlotNo			= 0;					//	Zbgԍ
	m_lReqbyte				= 0;
	m_ucCardFileNo			= 0;
	m_chSaveSelectNo		= 0;
	m_iSaveNameTime			= 0;
	m_ucMoveNameFlag		= 0;
	m_iChanTime				= 0;
	m_ucSelectMes			= 0;
	m_chCheckFlag			= 0;

	m_fSaveNameX			= SAVE_DATA_X;

	SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
	
	m_pWorkErea				= NULL;			
	m_pFile					= NULL;
	m_pBanner				= NULL;
	m_pCardInfo				= NULL;
	m_pIconData				= NULL;
	m_pSaveData				= NULL;
	m_pSavedName			= NULL;
	m_pEffect				= NULL;
	if( m_ucState != SAVE_STATE_CHECK ){
		m_pEffect = CreateNoiseEffect();
		SetEffectIndeManageFlag( m_pEffect, true );
		gpSound->mReleasePcSsm();
		gpSound->mReadSsm("seTv.ssm",eBankPlayer);
	}

	for( int i = 0; i < SAVE_DATA_NUM; i++ ){
		memset( m_SaveName[i].name, '\0', sizeof( char )*32 );
	}
	//	[h̓f[^̃[hȂĂ悢	------------------------------
	switch( m_ucState ){
	case SAVE_STATE_LOAD:
		SetChannel(0);
		m_Proc 	= PROC_SLOT_CHECK;
		break;
	case SAVE_STATE_SAVE:
//		SetChannel(1);
		m_Proc	= PROC_LOAD;
		break;
	case SAVE_STATE_ENDSAVE:
		SetChannel(1);
		m_chSelect = 0;
		CreateCheck( CHECK_MES_ENDSAVE_CHECK );
		m_Proc	= PROC_CHECK_END_SAVE;
		break;
	default:
		m_Proc	= PROC_LOAD;
		break;
	}	
	m_Load		= LOAD_FONT;
}


//========================================================================
//					fXgN^
//========================================================================
SK7SaveLoad:: ~SK7SaveLoad()
{
	GHM_SAFE_DELETE( m_pFile ); 
  	GHM_SAFE_DELETE( m_pBanner );
	m_spTV.Delete();
	GHM_SAFE_DELETE( m_pCardInfo );
	GHMGCMEM_SAFE_FREE( m_pSaveData );
	GHM_SAFE_DELETE_ARRAY( m_pSavedName );
	GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
	GHM_SAFE_DELETE( m_pIconData );
	DeleteEffect( m_pEffect );
	if( m_ucState != SAVE_STATE_CHECK ){
		gpSound->mReleaseSsm("seTv.ssm");	
		gpSound->mReadPcSsmReq( WK7PLAYERCONTROL->GetMainID() );
	}
}

//========================================================================
//					Z[ut[
//========================================================================
bool  		SK7SaveLoad::SaveFrameProcess(void)
{
	s32 CardState[2];
	//	J[h݃`FbN	====================================
	bool Inflag = CheckCardIn( &CardState[0], &CardState[1] );
	//	ĂȂ`FbN	====================================
	CheckSlotInNow( CardState[m_chSetSlotNo] );
	
	//	J[hݕ``FbN	==============================================
	if( m_ucState != SAVE_STATE_CHECK )		CheckCardRender( CardState[0], CardState[1] );
	
	//	`l^C	--------------------------------------------
	if( !m_bChanFlag && m_Proc > PROC_LOAD ){
		if( ++m_iChanTime >= CHAN_MOVE_TIME ){
			m_iChanTime = 0;
			m_bChanFlag = true;
			SetChannelNomral();
		}
	}

	//	C	------------------------------------------------------------
	switch( m_Proc )
	{
	//	f[^[h	==============================================
	case PROC_LOAD:
		m_spChan.SetTexNo(1);
		if( !LoadData()) break;
		if( m_ucState == SAVE_STATE_CHECK ){
			if( Inflag ){
				CreateMessage( CERROR_CHECK_CHECK );
				m_chSetSlotNo = 0;	
				m_Proc = PROC_FIRST_CARD_CHECK;//PROC_CARD_CHECK;
			}else{
				m_chSelect = 0;
				CreateMessage( CERROR_CHECK_NOSLOT );
				m_Proc = PROC_FIRST_SELECT;
			}
		}else{
			if( Inflag ){	
				m_Proc = PROC_SLOT_CHECK;
			}else{
				//	J[hĂȂ	---------------------------------
				CreateMessage( CERROR_MES_NOSLOT );
				SET_NEXT_MESSAGE( -1, PROC_END, 2, false );
				m_Proc = PROC_CARD_MESSAGE;
				return true; 
			}
		}
		break;
		
	//	ŏ̃J[h`FbN	=======================================
	case PROC_FIRST_CARD_CHECK:		CheckFirstCard( CardState[0], CardState[1] ); break;
		
	//	Z[u`FbN		===============================================
	case PROC_CHECK_END_SAVE:		CheckEndSave();						break;
	
	//	ǂ̃Xbgg`FbN	==================================
	case PROC_SLOT_CHECK:			CheckSlotSelect( CardState[0], CardState[1] );		break;	

	//	ꔭbZ[W	===========================================
	case PROC_CARD_MESSAGE:			CheckMessageOne();					break;

	//	J[h݃`FbN	=====================================
	case PROC_CARD_CHECK:			CheckCardSlotIn( m_chSetSlotNo, CardState[m_chSetSlotNo] );	break;

	//	J[h}Eg`FbN	========================================
	case PROC_MOUNT_CHECK:			CheckCardMount( m_chSetSlotNo );	break;
	
	//	j`FbN	============================================
	case PROC_BREAK_CHECK:			CheckCardBreak( m_chSetSlotNo );	break;

	//	Z[uf[^̈`FbN	===================================
	case PROC_SIZE_CHECK:			CheckCardErea( m_chSetSlotNo );		break;
		
	//	ŏ̃Z[uf[^`FbN	========================================
	case PROC_DATA_LOAD_CHECK:		CheckClearCard();					break;
	
	//	Z[uĂf[^\&I	=================================
	case PROC_DATA_DRAW:			CheckCardSavedData();				break;
		
	//	ǂ̈ʒuɃZ[u邩	=======================================
	case PROC_SAVE_SELECT:			CheckSavePoint();					break;
	
	//	Z[u?	===============================================
	case PROC_SAVE_PLAY_CHECK:		CheckSavePlay();					break;
	
	//		=================================================
	case PROC_WRITE:				WriteSaveData();					break;
		
	//	ݏI`FbN	========================================
	case PROC_WRITE_CHECK:			CheckWriteEnd();					break;

	//				================================================
	case PROC_INIT_CHECK:			CheckCardInit( m_chSetSlotNo );		break;	
		
	//	ZNg	====================================================
	case PROC_SELECT_CHECK:			CheckSelectMessage();				break;
				
	//	IbZ[W	====================================================
	case PROC_END_MESSAGE:			EndWriteEvent();					break;

	//	ŏ̃`FbNZNg	====================================================
	case PROC_FIRST_SELECT:		 	CheckCardSelect();					break;
		
	//	҂	==================================================================
	case PROC_WAIT:	
		if( ++m_iCheckTime > CHECK_WAIT_TIME ){
			m_iCheckTime = 0;
			m_Proc = PROC_CHECK_END;
		}
		break;

	//	I	======================================================
	case PROC_WRITE_END: 
	case PROC_READ_END:
	case PROC_CHECK_END:
	case PROC_END:	
		break;
	}
	return true;
}



//========================================================================
//					[ht[
//========================================================================
bool  		SK7SaveLoad::LoadFrameProcess(void)
{
	s32 CardState[2];
	//	J[h݃`FbN	====================================
	bool Inflag = CheckCardIn( &CardState[0], &CardState[1] );
	//	ĂȂ`FbN	====================================
	CheckSlotInNow( CardState[m_chSetSlotNo] );

	//	J[hݕ``FbN	==============================================
	CheckCardRender( CardState[0], CardState[1] );

	//	`l^C	--------------------------------------------
	if( !m_bChanFlag && m_Proc > PROC_LOAD ){
		if( ++m_iChanTime >= CHAN_MOVE_TIME ){
			m_iChanTime = 0;
			m_bChanFlag = true;
			SetChannelNomral();
		}
	}
	
	if( !m_bCtrl )		return true;

	//	C	------------------------------------------------------------
	switch( m_Proc )
	{
	//	f[^[h	==============================================
	case PROC_LOAD:
		if( LoadData()){
			if( Inflag ){	
				m_Proc = PROC_SLOT_CHECK;
			}else{
				//	J[hĂȂ	---------------------------------
				CreateMessage( CERROR_MES_NOSLOT );
				SET_NEXT_MESSAGE( -1, PROC_END, 2, false );
				m_Proc = PROC_CARD_MESSAGE;
				return true; 
			}
		}
		break;
		
	//	ǂ̃Xbgg`FbN	==================================
	case PROC_SLOT_CHECK:			CheckSlotSelect( CardState[0], CardState[1] );				break;

	//	ꔭbZ[W	===========================================
	case PROC_CARD_MESSAGE:			CheckMessageOne();											break;

	//	J[h݃`FbN	=====================================
	case PROC_CARD_CHECK:			CheckCardSlotIn( m_chSetSlotNo, CardState[m_chSetSlotNo] );	break;
		
	//	J[h}Eg`FbN	========================================
	case PROC_MOUNT_CHECK:			CheckCardMount( m_chSetSlotNo );	break;
	
	//	j`FbN	============================================
	case PROC_BREAK_CHECK:			CheckCardBreak( m_chSetSlotNo );	break;
		
	//	f[^ނ邩`FbN	================
	case PROC_SIZE_CHECK:  			CheckCardLoad();					break;
	
	//	Z[uĂf[^\&I	=================================
	case PROC_DATA_DRAW:			CheckCardSavedData();				break;

	//	ǂ[h邩	=======================================
	case PROC_SAVE_SELECT:			CheckSavePoint();					break;
		
	//	[h	====================================================
	case PROC_LOAD_DATA:			LoadSaveData();					break;
		
	//	[h`FbN	============================================
	case PROC_LOAD_CHECK:			CheckLoadEnd();					break;

	//	ZNg	====================================================
	case PROC_SELECT_CHECK:			CheckSelectMessage();				break;

	//	s	=========================================================
	case PROC_NOT_MESSAGE: 			EndNotEvent();						break;

	//				================================================
	case PROC_INIT_CHECK:			CheckCardInit( m_chSetSlotNo );	break;	
	
	//	IbZ[W	====================================================
	case PROC_END_MESSAGE:			EndWriteEvent();					break;
		
	//	폜`FbN	=================================================
	case PROC_DELETE_CHECK:			CheckCardDelete();					break;
		
	//	I	====================================================
	case PROC_READ_END:
	case PROC_END:
		break;
	}
	return true;
}


//========================================================================
//					_O
//========================================================================
bool  		SK7SaveLoad::RenderProcess(void)
{
	if( !m_bRender )	return true;
	
	if( m_ucState != SAVE_STATE_CHECK ){
		//	tHg`
		if( m_bLoadFontFlag )		RenderSaveComment();
		//	XbgZNĝƂ	
		if( m_Proc == PROC_SLOT_CHECK ){
			if( m_ucState == SAVE_STATE_SAVE || m_ucState == SAVE_STATE_ENDSAVE )	RenderSlotName( (u8)m_chSetSlotNo, m_lSlotAColor, m_lSlotBColor, false );
			if( m_ucState == SAVE_STATE_LOAD )	RenderSlotName( (u8)m_chSetSlotNo, m_lSlotAColor, m_lSlotBColor, true );
		}
	}
	//	`FbNpbZ[W
	RenderCheckFont( (u8)m_chSelect );

	//	`l`	
	m_spChan.Render();
	
	//	tHg`
	RenderFont( m_chSetSlotNo );
	
	//	bl̃G[`FbN
	RenderCheckFontError( (u8)m_chSelect );

	DrawSousaLine();
	//	Rceffect
	if( m_ucState != SAVE_STATE_CHECK ){
		MoveEffect(m_pEffect);
		DrawEffect(m_pEffect);
	}
	//	䂪	-----------------------------------------------
	if( m_ucState != SAVE_STATE_CHECK )		_DrawTVScreen();
	
	if( m_ucState != SAVE_STATE_CHECK ){	
		//	su
		m_spTV.Render();
	}
	return true;
}


//========================================================================
//					[hʂ̏
//========================================================================
void			SK7SaveLoad::InitLoad()
{
	m_Proc = PROC_SLOT_CHECK;
}


//========================================================================
//					J[h`FbN
//========================================================================
void			SK7SaveLoad::CheckCardSlotIn( s8 SlotNo, s32 State )
{
	switch( State ){
	case CARD_RESULT_READY:
		GHM_SAFE_DELETE_ARRAY(m_pWorkErea); 
		ghmGcMemSetAllocName("SAVELOAD");
		m_pWorkErea = new u8[CARD_WORKAREA_SIZE];
		OSRoundUp32B	( m_pWorkErea );						//	32byteE
		CARDMountAsync	( SlotNo, m_pWorkErea, NULL, NULL );	//	}Eg
		m_Proc = PROC_MOUNT_CHECK;
		return;
		
	case SK7CARD_SLOTA_NOSUPPORT:
	case SK7CARD_SLOTB_NOSUPPORT:
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_NOTCARD );
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		case SAVE_STATE_CHECK:
			CreateMessage( CERROR_CHECK_NOSLOT );
			m_ucSelectNo = CARD_SELECT_NORMAL;
			m_chSelect = 0;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
		break;

	case CARD_RESULT_BUSY:		m_Proc = PROC_CARD_CHECK;	return;

	default:
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_NOSLOT );
			m_chNextProc = PROC_SLOT_CHECK;
			m_Proc = PROC_CARD_MESSAGE;
			return;
		case SAVE_STATE_CHECK:
			CreateMessage( CERROR_CHECK_NOSLOT );
			m_ucSelectNo = CARD_SELECT_NORMAL;
			m_chSelect = 0;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
	}
}

//========================================================================
//					}Eg`FbN
//========================================================================
void			SK7SaveLoad::CheckCardMount( s8 SlotNo  )
{
	switch( MessageResultCode(SlotNo) ){
	case SK7CARD_OK:
	case SK7CARD_MOUNT_OK:
		CARDCheckAsync( SlotNo, NULL );	//	j`FbN
		m_Proc = PROC_BREAK_CHECK;
		return;
		
	case SK7CARD_ERROR:			//	G[
		GHM_SAFE_DELETE_ARRAY( m_pWorkErea );

		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			if( m_ucSelectNo == CARD_SELECT_INIT ){
				m_chSelect = 0;
				m_bSelectFlag = true;
			}
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		case SAVE_STATE_CHECK:
			m_chSelect = 0;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}

	case SK7CARD_MOUNT_ERROR:	//	J[hꂽ
		if( m_chSetSlotNo < 2 )	CARDUnmount(SlotNo);	
		GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		case SAVE_STATE_CHECK:
			m_chSelect = 0;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
	}
}

//========================================================================
//					uCN`FbN
//========================================================================
void			SK7SaveLoad::CheckCardBreak( s8 SlotNo )
{
	m_chSelect = 0;
	switch( MessageResultCode(SlotNo) ){
	case SK7CARD_OK:		m_Proc = PROC_SIZE_CHECK; return;
	case SK7CARD_ERROR:
	case SK7CARD_MOUNT_OK:
	case SK7CARD_MOUNT_ERROR:
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			if( m_ucSelectNo != CARD_SELECT_INIT ){
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}else{
				m_chSelect	= 0;
				m_bSelectFlag = true;
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;

		case SAVE_STATE_CHECK:
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
	}
}

//========================================================================
//					Z[uf[^`FbN
//========================================================================
bool		SK7SaveLoad::CheckCardExist()
{
	bool ExistFlag = false;
	CARDStat cardstat;
	m_chSavedFlag = 0;
	for( int j = 0; j < SAVE_DATA_NUM; j++ ){
		char FileName[32];
		sprintf( FileName, "%s_%d", SAVE_FILE_NAME, j );
		for( int i = 0; i < 127; i++ ){
			memset( &cardstat, 0, sizeof( CARDStat ) );
			CARDGetStatus( m_chSetSlotNo, i, &cardstat );

			//	t@C`FbN	---------------------------------
			if( strcmp( cardstat.fileName,  FileName )==0 ){	//	L[V̏㏑f[^
				m_chSavedFlag |= (1<<j);						//	tOĂ
				ExistFlag = true;
				continue;
			}
		}
	}
	//	Z[uf[^Ƃ	----------------------------------
	if( ExistFlag )		return true;
	return false;
}

//========================================================================
//					ŏ̃Z[uf[^`FbNNAtO
//========================================================================
void			SK7SaveLoad::CheckClearCard()
{
	//	J[h`FbN
	if( CARDProbeEx( m_chSetSlotNo, NULL, NULL ) != CARD_RESULT_READY ){
		//	`a`FbN
		if( m_chCheckFlag & FCARD_CHECK_A ){
			m_Proc = PROC_FIRST_CARD_CHECK;
			return;
		}
		//	a炨܂iꂵj
		if( m_chCheckFlag & FCARD_CHECK_B ){
			m_Proc = PROC_CHECK_END;
			return;
		}
	}	
	
	//	Z[uf[^ǂݍ݃NAtO擾	-------------------------
	if( m_chSetSlotNo == 0 )	m_chCheckFlag |= FCARD_CHECKEND_A;
	if( m_chSetSlotNo == 1 )	m_chCheckFlag |= FCARD_CHECKEND_B;
	
	GHM_SAFE_DELETE( m_pCardInfo );
	ghmGcMemSetAllocName("SAVELOAD");
	m_pCardInfo 	= new CARDFileInfo;			//	J[hNX
	char FileName[32];
	void* Data=NULL;
	
	//	t@C擾	--------------------------------------------
	for( int i = 0; i < SAVE_DATA_NUM; i++ ){
		memset( m_pCardInfo, 0, sizeof(CARDFileInfo) );
		//	f[^Ƃ	----------------------------------------
		if( m_chSavedFlag & (1<<i) ){
			sprintf( FileName, "%s_%d", SAVE_FILE_NAME, i );
			int Answer = CARDOpen	( m_chSetSlotNo, FileName, m_pCardInfo );				//t@CI[v
			ghmGcMemSetAllocName("SAVELOAD");
			Data = new byte[CARD_READ_SIZE];
			if( -1 > CARDRead( m_pCardInfo, Data, CARD_READ_SIZE, CARD_READ_SIZE*16 )){		//ǂݍ
				OSReport("ERR:SaveLoadReadMiss");
			}
			CARDClose	( m_pCardInfo );										//

			//	NAtOZbg	-------------------------
			if( *((byte*)Data+70) == 1 ){
				GHM_SAFE_DELETE_ARRAY( Data );
				K7SCR_SET_GLOBAL_FLAG( K7GLFL_GAME_CLEAR );
				//	폜	-------------------------------------
				GHM_SAFE_DELETE	( m_pCardInfo );
				CARDUnmount		( m_chSetSlotNo );	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
				m_Proc = PROC_WAIT;//PROC_CHECK_END;
				return;
			}
			GHM_SAFE_DELETE_ARRAY( Data );
		}
	}
	//	폜	-------------------------------------
	GHM_SAFE_DELETE( m_pCardInfo );
	CARDUnmount(m_chSetSlotNo);	
	GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
	//	J[ha`FbNǂ	-------------
	if( m_chCheckFlag & FCARD_CHECKEND_B ){		
		m_Proc = PROC_WAIT;//PROC_CHECK_END;
	}else{
		m_Proc = PROC_FIRST_CARD_CHECK;
	}
}

//========================================================================
//					Z[uf[^\
//========================================================================
void			SK7SaveLoad::CheckCardSavedData()
{
	//	J[hTCY}Ƃɂ`FbN
	if( CARDProbeEx( m_chSetSlotNo, NULL, NULL ) != CARD_RESULT_READY ){
		CreateMessage( CERROR_MES_NOSLOT );
		//	̃bZ[WZbg	----------------------------------
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
	}
	
	GHM_SAFE_DELETE( m_pCardInfo );
	ghmGcMemSetAllocName("SAVELOAD");
	m_pCardInfo 	= new CARDFileInfo;			//	J[hNX

	char FileName[32];
	char DataName2[32];
	void* Data=NULL;
	
	//	t@C擾	--------------------------------------------
	for( int i = 0; i < SAVE_DATA_NUM; i++ ){
		memset( m_pCardInfo, 0, sizeof(CARDFileInfo) );
		//	f[^Ƃ	----------------------------------------
		if( m_chSavedFlag & (1<<i) ){
			sprintf( FileName, "%s_%d", SAVE_FILE_NAME, i );
			int Answer = CARDOpen	( m_chSetSlotNo, FileName, m_pCardInfo );				//t@CI[v
			ghmGcMemSetAllocName("SAVELOAD");
			Data = new byte[CARD_READ_SIZE];
			if( -1 > CARDRead( m_pCardInfo, Data, CARD_READ_SIZE, 0 )){		//ǂݍ
				OSReport("ERR:SaveLoadReadMiss");
			}
			CARDClose	( m_pCardInfo );										//

			const char* Cm = (const char*)Data;
			int No = atoi( &Cm[COMMENT_MEM_SCN] );
			memset( &DataName2, '\0', 32 );
			memcpy( DataName2, (byte*)Data+32, 32 );
			sprintf( m_SaveName[i].name, "[%s] %s", SaveScenarioName[No], DataName2 );
			GHM_SAFE_DELETE_ARRAY( Data );
		}
	}
	//[hf[^	-------------------------
	m_bLoadFontFlag = true;
	//	폜	-------------------------------------
	GHM_SAFE_DELETE( m_pCardInfo );
	//	bZ[W	-----------------------------
	CreateMessage( CERROR_MES_NONE );
	//	Z[uZNg	-------------------------
	m_Proc = PROC_SAVE_SELECT;
}


//========================================================================
//					Z[uʒumF
//========================================================================
void			SK7SaveLoad::CheckSavePoint()
{
	//		-------------------------------------
	if( CheckKeyT( SK7_KEY_UP ) ){
		if( --m_chSaveSelectNo < 0 )		m_chSaveSelectNo = 0;
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	//		-------------------------------------
	if( CheckKeyT( SK7_KEY_DOWN ) ){
		if( ++m_chSaveSelectNo > SAVE_DATA_NUM-1 )	m_chSaveSelectNo = SAVE_DATA_NUM-1;
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	//	I	-------------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
//		if( m_SaveName[m_chSaveSelectNo].name[0] != '\0' ){
		if( m_chSavedFlag & (1<<(m_chSaveSelectNo)) ){
			if( m_ucState == SAVE_STATE_SAVE || m_ucState == SAVE_STATE_ENDSAVE ){
				CreateCheck( CHECK_MES_OVER_WRITE );
				m_chSelect = 1;
				m_Proc = PROC_SAVE_PLAY_CHECK;
				return;
			}else{
				//	[hŃt@Cꍇ	---------------------------
				CreateMessage( CERROR_MES_CHECK );
				m_Proc = PROC_LOAD_DATA;
				return;
			}
		}else{
			if( m_ucState == SAVE_STATE_SAVE || m_ucState == SAVE_STATE_ENDSAVE ){
				if( m_bSaveOkFlag ){
					CreateCheck( CHECK_MES_CHECK );
					m_Proc = PROC_WRITE;
					return;
				}else{
					CreateMessage( CERROR_MES_NO_SPACE );
					//	̃bZ[WZbg	----------------------------------
					SET_NEXT_MESSAGE( CERROR_MES_FILE_REQ, PROC_SAVE_SELECT, 2, false );
					m_Proc = PROC_CARD_MESSAGE;
					return;
				}
			}
			//	[ht@CȂꍇ	-------------------------------
			m_chSaveSelectNo = 0;
			return;
		}
	}
	//	LZ	---------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		m_bLoadFontFlag = false;
		for( int i = 0; i < SAVE_DATA_NUM; i++ )	memset( m_SaveName[i].name, '\0', sizeof( char )*32 );
		gpSound->mPlaySE( SFX_TV_CANCEL );
		m_Proc = PROC_SLOT_CHECK;
		return;
	}
}

//========================================================================
//					Z[uŏImF
//========================================================================
void			SK7SaveLoad::CheckSavePlay()
{
	//		-------------------------------------
	if( CheckKeyT( SK7_KEY_LEFT ) ){
		m_chSelect = 0;
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	//	E	-------------------------------------
	if( CheckKeyT( SK7_KEY_RIGHT ) ){
		m_chSelect = 1;
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	//	I	-------------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		if( m_chSelect == 0 ){
			CreateCheck( CHECK_MES_CHECK );
			m_Proc = PROC_WRITE;
			return;
		}else{
			CreateCheck( CHECK_MES_NONE );
			m_Proc = PROC_SAVE_SELECT;
			return;
		}
	}
	//	LZ	---------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		CreateCheck( CHECK_MES_NONE );
		gpSound->mPlaySE( SFX_TV_CANCEL );
		m_Proc = PROC_SAVE_SELECT;
		return;
	}
}

//========================================================================
//					Z[umF
//========================================================================
void			SK7SaveLoad::CheckEndSave()
{
	//		-------------------------------------
	if( CheckKeyT( SK7_KEY_LEFT ) ){
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		m_chSelect = 0;
		return;
	}
	//	E	-------------------------------------
	if( CheckKeyT( SK7_KEY_RIGHT ) ){
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		m_chSelect = 1;
		return;
	}
	//	I	-------------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		CreateCheck( CHECK_MES_NONE );
		if( m_chSelect == 0 ){
			m_Proc = PROC_SLOT_CHECK;
		}else{
			m_Proc = PROC_END;
		}
	}
}

//========================================================================
//					Z[uf[^`FbN
//========================================================================
void			SK7SaveLoad::CheckCardLoad()
{
	if( CheckCardExist() ){
		m_Proc = PROC_DATA_DRAW;
	}else{
		CreateMessage( CERROR_MES_NOT_DATA );	
		m_Proc = PROC_NOT_MESSAGE;
	}
}



//========================================================================
//					GA`FbN
//========================================================================
void			SK7SaveLoad::CheckCardErea( s8 SlotNo )
{	
	//	TCY`FbN	
	s32 byte=0, filedir=0, nobyte=0;
	//	J[hTCY}Ƃɂ`FbN
	if( CARDProbeEx( m_chSetSlotNo, NULL, NULL ) != CARD_RESULT_READY ){
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_CHECK_NOSLOT );
			m_ucSelectNo = CARD_SELECT_NORMAL;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}else{
			CreateMessage( CERROR_MES_NOSLOT );
			//	̃bZ[WZbg	----------------------------------
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		}
	}
	CARDFreeBlocks( SlotNo, &byte, &filedir );			//	TCYAt@C`FbN
	//	t@C  󂫗eʃ`FbN	
	nobyte = (byte - m_iSaveDataSize);
	m_lReqbyte = (nobyte / -SECTOR_SIZE);
	if( nobyte >= 0 && filedir > 0 )	m_bSaveOkFlag = true;
	else								m_bSaveOkFlag = false;

	//	VK쐬A㏑`FbN	
	if( CheckCardExist() ){
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_CHECK );
			m_Proc = PROC_DATA_DRAW;
			return;
			
		case SAVE_STATE_CHECK:
			m_Proc = PROC_DATA_LOAD_CHECK;
			return;
		}
	}	

	if( m_bSaveOkFlag ){
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_CHECK );
			m_Proc = PROC_DATA_DRAW;
			return;
		case SAVE_STATE_CHECK:
			m_Proc = PROC_DATA_LOAD_CHECK;
			return;
		}
	}else{
		//	A}Eg	--------------------------------------
		if( m_chSetSlotNo < 2 )	CARDUnmount(SlotNo);	
		GHM_SAFE_DELETE_ARRAY( m_pWorkErea );

		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_NO_SPACE );
			//	̃bZ[WZbg	----------------------------------
			SET_NEXT_MESSAGE( CERROR_MES_FILE_REQ, PROC_SLOT_CHECK, 2, false );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		case SAVE_STATE_CHECK: 
			//	󂫂ȂbZ[W	-----------------------------
			CreateMessage( CERROR_CHECK_SIZE );
			m_ucSelectNo = CARD_SELECT_IPL;
			m_chSelect = 0;
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
	}
}

//========================================================================
//					܂܂H`FbN
//========================================================================
void			SK7SaveLoad::CheckSlotInNow( s32 State )
{
	//	J[h}Egȍ~	---------------------------------------------
	if( m_Proc <= PROC_MOUNT_CHECK || m_Proc == PROC_SELECT_CHECK )	return;
	if( m_ucState == SAVE_STATE_CHECK ) return;
	
	//	ꂽ?`FbN	-------------------------------------------
	if( State != CARD_RESULT_READY ){
		//	[NGA폜`FbN	----------------------------------
		CreateMessage	( CERROR_MES_NOSLOT );
		CreateCheck		( CHECK_MES_NONE );
		CreateCheckUp	( CHECK_MESUP_NONE );
		m_bLoadFontFlag	= false;
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		if( m_pWorkErea == NULL ){
			if( m_chSetSlotNo < 2 )	CARDUnmount(m_chSetSlotNo);	
		}

		if( m_pWorkErea == NULL ){
			switch( m_ucState ){
			case SAVE_STATE_SAVE:
			case SAVE_STATE_LOAD:
			case SAVE_STATE_ENDSAVE:
				m_chNextProc = PROC_SLOT_CHECK;
				m_Proc = PROC_CARD_MESSAGE;
				return;
			}
		}else{
			GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			GHM_SAFE_DELETE( m_pCardInfo );
			m_chSelect = CARD_ANSWER_CHANGE;
			m_Proc = PROC_CARD_MESSAGE;
			return;
		}
	}
}

//========================================================================
//					ŏ̃J[h`FbN
//========================================================================
void		SK7SaveLoad::CheckFirstCard( s32 AState, s32 BState )
{
	if( m_chCheckFlag == 0 && AState == CARD_RESULT_READY ){
		m_chSetSlotNo = 0;
		m_chCheckFlag |= FCARD_CHECK_A;
		m_Proc = PROC_CARD_CHECK;
		return;
	}
	m_chCheckFlag |= FCARD_CHECK_A;
	if( !(m_chCheckFlag & FCARD_CHECK_B) && BState == CARD_RESULT_READY ){
		m_chSetSlotNo = 1;
		m_chCheckFlag |= FCARD_CHECK_B;
		m_Proc = PROC_CARD_CHECK;
		return;
	}
	m_chCheckFlag |= FCARD_CHECK_B;
	//	J[hƂɎgȂ	
	if( !(m_chCheckFlag & FCARD_CHECKEND_A) && !(m_chCheckFlag & FCARD_CHECKEND_B) ){
		m_chCheckFlag = 0;
	}
	//	J[hЕ`FbN	
	if( (m_chCheckFlag & FCARD_CHECKEND_A) || (m_chCheckFlag & FCARD_CHECKEND_B) ){
		m_Proc = PROC_WAIT;//PROC_CHECK_END;
		return;
	}
	m_chSelect = 0;
	CreateMessage( CERROR_CHECK_NOSLOT );
	m_Proc = PROC_FIRST_SELECT;
}
	
	
//========================================================================
//					FORMAT
//========================================================================
void			SK7SaveLoad::CheckCardInit( s8 SlotNo )
{
	switch( CARDFormat( SlotNo ) ){
	case CARD_RESULT_NOCARD:
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_INIT_MISS );
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );			
			m_Proc = PROC_CARD_MESSAGE;
			return;
			
		case SAVE_STATE_CHECK:
			CreateMessage( CERROR_CHECK_NOSLOT );
			m_ucSelectNo = CARD_SELECT_NORMAL;
			m_chSelect = 0;
			if( m_pWorkErea != NULL ){
				CARDUnmount(m_chSetSlotNo);	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
		break;

	case CARD_RESULT_IOERROR:
		switch( m_ucState ){
		case SAVE_STATE_SAVE:
		case SAVE_STATE_LOAD:
		case SAVE_STATE_ENDSAVE:
			CreateMessage( CERROR_MES_INIT_MISS );
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );			
			m_Proc = PROC_CARD_MESSAGE;
			return;
		
		case SAVE_STATE_CHECK:
			CreateMessage( CERROR_CHECK_INIT_MISS );
			m_chSelect = 0;
			m_ucSelectNo = CARD_SELECT_NORMAL;
			if( m_pWorkErea != NULL ){
				CARDUnmount(m_chSetSlotNo);	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}
			m_Proc = PROC_FIRST_SELECT;
			return;
		}
		break;

	case CARD_RESULT_READY:
		if( m_ucState == SAVE_STATE_CHECK ){
			m_Proc = PROC_MOUNT_CHECK;
			return;
		}else{
			CreateMessage( CERROR_MES_INIT_OK );
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );			
			m_Proc = PROC_CARD_MESSAGE;
			return;
		}
	}
}

//========================================================================
//					폜`FbN
//========================================================================
void			SK7SaveLoad::CheckCardDelete()
{
	char FileName[32];
	memset( FileName, '\0', sizeof( char )*32 );
	
	sprintf( FileName, "%s_%d", SAVE_FILE_NAME, (int)m_chSaveSelectNo );
	int DeleteAnswer = CARDDelete( m_chSetSlotNo, FileName );
	
	if( m_chSetSlotNo < 2 )	 CARDUnmount( m_chSetSlotNo );			//	A}Eg
	GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
	
	switch( DeleteAnswer ){
	case CARD_RESULT_FATAL_ERROR:
	case CARD_RESULT_NOCARD:
	case CARD_RESULT_NOFILE:
	case CARD_RESULT_NOPERM:
	case CARD_RESULT_BUSY:
	case CARD_RESULT_IOERROR:
		CreateMessage( CERROR_MES_DELETE_MISS );
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
		
	case CARD_RESULT_READY:
		CreateMessage( CERROR_MES_DELETE_OK );
		memset( m_SaveName[m_chSaveSelectNo].name, '\0', sizeof( char )*32 );
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
	}
}

//========================================================================
//					ZNg`FbN
//========================================================================
void			SK7SaveLoad::CheckCardSelect()
{
	//	L[̓`FbN	-----------------------------------------------
	if( !CardAnswerSelect() ){
		m_Proc = PROC_FIRST_SELECT;
		return;
	}
	
	switch( m_chSelect ){
	case 0:					//	̂܂܎n߂
		//	ÎƂ	--------------------------------
		if( m_ucSelectNo == CARD_SELECT_CHECK_INIT ){
			CreateMessage( CERROR_CHECK_CHECK );
			m_Proc = PROC_INIT_CHECK;
			return;
		}else{
			if( m_pWorkErea != NULL ){
				CARDUnmount(m_chSetSlotNo);	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}
			m_Proc = PROC_WAIT;//PROC_CHECK_END;
			return;
		}
		break;

	case 1:					//	J[h`FW
		if( m_pWorkErea != NULL ){
			CARDUnmount(m_chSetSlotNo);	
			GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
		}
		if( m_ucSelectNo == CARD_SELECT_CHECK_INIT ){
			CreateMessage( CERROR_CHECK_INIT );
			m_ucSelectNo 	= CARD_SELECT_INIT;
			m_chSelect 		= 0;
			break;
		}else{
			m_Proc = PROC_FIRST_CARD_CHECK;
			return;
		}
		break;
		
	case 2:
		switch( m_ucSelectNo ){
		case CARD_SELECT_INIT:		//	`FbN
			CreateMessage( CERROR_CHECK_INIT_CHECK );
			m_ucSelectNo 	= CARD_SELECT_CHECK_INIT;
			m_chSelect 		= 0;					
			break;
			
		case CARD_SELECT_IPL:		//	hok
			if( m_pWorkErea != NULL ){				
				CARDUnmount( m_chSetSlotNo );	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
			}
			OSResetSystem( OS_RESET_HOTRESET, 0, TRUE);	
			m_Proc = PROC_CHECK_END;
			return;
		case CARD_SELECT_BREAK:
			break;
		}
		break;				
	}
}

//========================================================================
//					ZNg`FbN
//========================================================================
void			SK7SaveLoad::CheckSelectMessage(void)
{
	if( CheckKeyT( SK7_KEY_RIGHT ) ){
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		m_chSelect = 1;
		return;
	}
	if( CheckKeyT( SK7_KEY_LEFT ) ){
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		m_chSelect = 0;
		return;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		if( m_chSelect == 0 ){
			CreateCheckUp( CHECK_MESUP_NONE );
			switch( m_ucSelectMes ){
			case CHECK_MESUP_INIT_CHECK:
				m_Proc = PROC_INIT_CHECK;
				return;
			case CHECK_MESUP_DELETE_CHECK:
				m_Proc = PROC_DELETE_CHECK;
				return;
			}
			m_Proc = PROC_INIT_CHECK;
			return;
		}else{
			switch( m_ucSelectMes ){
			case CHECK_MESUP_INIT_CHECK:	CreateMessage( CERROR_MES_BREAK_CARD );		break;
			case CHECK_MESUP_DELETE_CHECK:	CreateMessage( CERROR_MES_BREAK );			break;
			}
			SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, true );
			CreateCheckUp( CHECK_MESUP_NONE );
			m_Proc = PROC_CARD_MESSAGE;
			return;
		}
	}
}
	
//========================================================================
//					t@CǂݍݏI擾֐
//========================================================================	 
bool  		SK7SaveLoad::GetFileReadEnd(void)
{
	if( m_Proc > PROC_LOAD )
	{
		return true;
	}
	return false;
}


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7SaveLoad::GetMenuEnd(void)
{
	if( m_Proc == PROC_END || m_Proc == PROC_WRITE_END||
		m_Proc == PROC_READ_END || m_Proc == PROC_CHECK_END )
	{
		return true;
	}
	return false;
}


//========================================================================
//					II擾֐
//========================================================================	 
bool  		SK7SaveLoad::GetProcessEnd(void)
{
	if( m_Proc == PROC_WRITE_END || m_Proc == PROC_READ_END || m_Proc == PROC_CHECK_END ){
		return true;
	}
	return false;
}

//========================================================================
//					II擾֐
//========================================================================
bool  		SK7SaveLoad::LoadData()
{
	switch( m_Load ){
	case LOAD_FONT:
		if( LoadMessage() ){
			if( m_ucState != SAVE_STATE_CHECK )		m_Load = LOAD_TV;
			else									return true;
		}
		break;
		
	case LOAD_TV:
		if( m_spTV.LoadTexture( TV_TEX ) ){
			m_spTV.SetTexSprite( 0, 0, m_spTV.GetTexture() );
			m_spTV.SetVisible( true );
			if( m_ucState == SAVE_STATE_LOAD )	return true;
			ghmGcMemSetAllocName("SFILE");
			m_pFile 	= new SK7File;
			m_Load = LOAD_BANNER;
		}
		break;		
				
	case LOAD_BANNER:
		if( m_pFile->OpenDataFile( DVD_BANNER_FILENAME, &((void*)m_pBanner) ) ){
			m_Load = LOAD_ICON;
		}
		break;
	case LOAD_ICON:
		char* IconFile=NULL;
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) )	IconFile = ICON_TEX_1;
		else											IconFile = ICON_TEX_7;
		if( m_pFile->OpenDataFile( IconFile, &((void*)m_pIconData) )){
			GHM_SAFE_DELETE( m_pFile );
			return true;
		}
		break;
	}
	return false;
}

//========================================================================
//					J[h}`FbN
//========================================================================
bool		SK7SaveLoad::CheckCardIn( s32* SlotStateA, s32* SlotStateB )
{
	s32	SectorSize0=0, SectorSize1=0;
	
	//	J[hhĂ邩`FbN		=======================
	(*SlotStateA) = CARDProbeEx( 0, NULL, &SectorSize0 );	//	XbgA 
	(*SlotStateB) = CARDProbeEx( 1, NULL, &SectorSize1 );	//	XbgB 

	//	ZN^TCY`FbN	------------------------------------------
	if( (*SlotStateA) == CARD_RESULT_READY ){
		if( (SectorSize0 / 1024) != 8 ){
			(*SlotStateA) = SK7CARD_SLOTA_NOSUPPORT;
		}
	}else if( (*SlotStateB) == CARD_RESULT_READY ){
		if( (SectorSize1 / 1024) != 8 ){
			(*SlotStateB) = SK7CARD_SLOTB_NOSUPPORT;
		}
	}
	//	ǂɂJ[hĂȂƂ	
	if( (*SlotStateA) == CARD_RESULT_NOCARD && (*SlotStateB) == CARD_RESULT_NOCARD ){
		return false;
	}
	return true;
}


//========================================================================
//					UgR[hbZ[WZbg
//========================================================================
int			SK7SaveLoad::MessageResultCode( s32 SlotNo )
{
	//	J[hUgR[h`FbN	==================================
	switch( CARDGetResultCode( SlotNo ) ){
	//	AJ[hȂII	----------------------------
	case CARD_RESULT_WRONGDEVICE:
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_MES_NOTCARD );
			m_chSelect = 0;
		}else{
			CreateMessage( CERROR_MES_NOTCARD );
		}
		m_ucSelectNo = CARD_SELECT_NORMAL;
		return SK7CARD_ERROR;

		
	//	J[h˂B	----------------------------------------------------
	case CARD_RESULT_NOCARD:
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_CHECK_NOSLOT );
			m_chSelect = 0;
		}else{
			CreateMessage( CERROR_MES_NOSLOT );
		}
		m_ucSelectNo = CARD_SELECT_NORMAL;
		return SK7CARD_MOUNT_ERROR;
	
	//	܂`FbN	----------------------------------------------------
	case CARD_RESULT_BUSY:
		if( m_ucState != SAVE_STATE_CHECK ){
			CreateMessage( CERROR_MES_CHECK );
		}
		return SK7CARD_BUSY;

	//	COpII	------------------------------------------------
	case CARD_RESULT_ENCODING:
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_CHECK_INIT );
		}else{
			CreateMessage( CERROR_MES_FORMAT );
		}
		m_ucSelectMes = CHECK_MESUP_INIT_CHECK;
		m_ucSelectNo = CARD_SELECT_INIT;
		return SK7CARD_ERROR;

	//	ԂG[	----------------------------------------------------
	case CARD_RESULT_IOERROR:
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_CHECK_BREAK );
		}else{
			CreateMessage( CERROR_MES_BREAK_CARD );
		}
		m_ucSelectNo = CARD_SELECT_BREAK;
		return SK7CARD_ERROR;
	
	//	tH[}bgKvw	--------------------------------------------
	case CARD_RESULT_BROKEN:
		if( m_ucState == SAVE_STATE_CHECK ){
			CreateMessage( CERROR_CHECK_INIT );
		}else{
			CreateMessage( CERROR_MES_FORMAT );
		}
		m_ucSelectNo = CARD_SELECT_INIT;
		m_ucSelectMes = CHECK_MESUP_INIT_CHECK;
		return SK7CARD_MOUNT_OK;

	//	G[Ȃ	--------------------------------------------------------
	case CARD_RESULT_READY:
		 return SK7CARD_OK;
	}
	return SK7CARD_BUSY;
}

//========================================================================
//					bZ[Wf[^
//========================================================================
bool 		SK7SaveLoad::CardAnswerSelect()
{
	//
	if( CheckKeyT( SK7_KEY_UP ) ){
		if( --m_chSelect < 0 )	m_chSelect = 0;
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return false;
	}
	//
	if( CheckKeyT( SK7_KEY_DOWN ) ){
		if( ++m_chSelect > tblCheckSelectNum[m_ucSelectNo]-1 ){
			m_chSelect = (s8)(tblCheckSelectNum[m_ucSelectNo]-1);
		}
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return false;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		return true;
	}
	return false;
}



//========================================================================
//					bZ[WS
//========================================================================
void			SK7SaveLoad::SetCardData()
{
	CARDStat CardState;
	CARDGetStatus( m_chSetSlotNo, m_pCardInfo->fileNo, &CardState);	//	XeC^XAhX̎擾

	// Rg̃ItZbg
	CARDSetCommentAddress(&CardState,0);
	
	// oi[ƃACR̃ItZbg
	CARDSetIconAddress(&CardState, CARD_COMMENT_SIZE);

	// oi[tH[}bg
	CARDSetBannerFormat(&CardState, CARD_STAT_BANNER_RGB5A3);

	// ACRtH[}bg
	CARDSetIconFormat(&CardState, 0, CARD_STAT_ICON_RGB5A3);
	
	//	ACRAj[V
	CARDSetIconSpeed(&CardState, 0, CARD_STAT_SPEED_SLOW);
	CARDSetIconSpeed(&CardState, 1, CARD_STAT_SPEED_END);

	//	Xe[^XZbg
	CARDSetStatusAsync( m_chSetSlotNo, m_pCardInfo->fileNo, &CardState, NULL );	
}

//========================================================================
//					J[h̕``FbN
//========================================================================
void			SK7SaveLoad::CheckCardRender( s32 AState, s32 BState )
{
	if( AState == CARD_RESULT_READY )	m_lSlotAColor = SLOT_FONT_COLOR;
	else								m_lSlotAColor = CARD_NOT_COLOR;

	if( BState == CARD_RESULT_READY )	m_lSlotBColor = SLOT_FONT_COLOR;
	else								m_lSlotBColor = CARD_NOT_COLOR;
	//	Xbg`FbN̂Ƃꂽ
	if( m_Proc == PROC_SLOT_CHECK ){
		if( AState != CARD_RESULT_READY && m_chSetSlotNo == 0 ){
			if( BState != CARD_RESULT_READY )	m_chSetSlotNo = 2;
			else								m_chSetSlotNo = 1;
		}
		if( BState != CARD_RESULT_READY && m_chSetSlotNo == 1 ){
			if( AState != CARD_RESULT_READY )	m_chSetSlotNo = 2;
			else								m_chSetSlotNo = 0;
		}
		if( AState != CARD_RESULT_READY && BState != CARD_RESULT_READY )	m_chSetSlotNo = 2;
	}
}


//========================================================================
//					XbgZNg
//========================================================================
void	  		SK7SaveLoad::CheckSlotSelect( s32 AState, s32 BState )
{
	if( !(AState == CARD_RESULT_BUSY || AState == CARD_RESULT_READY) &&
		!(BState == CARD_RESULT_BUSY || BState == CARD_RESULT_READY) )
	{
//		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
//		CreateMessage( CERROR_MES_NOSLOT );
//		return PROC_CARD_MESSAGE;
		m_chSetSlotNo = 2;
	}
	if( CheckKeyT( SK7_KEY_UP ) ){
		s8 SaveNo = m_chSetSlotNo;
		while(1){
			if( --m_chSetSlotNo < 0 ){
				m_chSetSlotNo =SaveNo;
				break;
			}
			if( m_chSetSlotNo == 0 && AState == CARD_RESULT_READY )		break;
			if( m_chSetSlotNo == 1 && BState == CARD_RESULT_READY )		break;
		}
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	if( CheckKeyT( SK7_KEY_DOWN ) ){
		while(1){
			if( ++m_chSetSlotNo >= 2 ){
				m_chSetSlotNo = 2;
				break;
			}
			if( m_chSetSlotNo == 1 && BState == CARD_RESULT_READY )		break;
		}
		gpSound->mPlaySE( SFX_TV_MOVE_CURSOR );
		return;
	}
	//	XbgI	-----------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		//	TTĂȂƂŃ{^ꍇ
		if( (m_chSetSlotNo == 0 && AState != CARD_RESULT_READY ) ||
			(m_chSetSlotNo == 1 && BState != CARD_RESULT_READY ) )
		{
			m_chSetSlotNo = 2;
			return;
		}
		//	[hȂƂ	
		if( m_chSetSlotNo >= 2 ){
			m_Proc = PROC_END;
			return;
		}
		//	XbgItHg
		m_chSaveSelectNo = 0;
		m_Proc = PROC_CARD_CHECK;
		return;
	}
	//	I	--------------------------------------------
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		gpSound->mPlaySE( SFX_TV_CANCEL );
		if( m_ucState == SAVE_STATE_ENDSAVE	){
			m_Proc = PROC_SLOT_CHECK;
			return;
		}
		m_Proc = PROC_END;
		return;
	}
}

//========================================================================
//					bZ[Wꔭ
//========================================================================
void  		SK7SaveLoad::CheckMessageOne(void)
{
	if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		//	̃bZ[W`FbN	----------------------------------------
		if( m_NextMes.No != -1 ){
			CreateMessage( (u8)m_NextMes.No );
			m_NextMes.No 		= -1;
			return;
		}
		//	G[ʕ`	-------------------------------------------------
		if( m_NextMes.bErrorDraw ){
			CreateMessage( CERROR_MES_NONE );
			m_NextMes.bErrorDraw = false;
		}
		//	I	----------------------------------------------------------
		if( m_bSelectFlag ){
			m_bSelectFlag = false; 
			//	sȗI̎
			CreateCheckUp( m_ucSelectMes );
			m_Proc = PROC_SELECT_CHECK;
			return;
		}
		if( m_chSetSlotNo < 2 )	CARDUnmount( m_chSetSlotNo );
		m_chSetSlotNo = m_NextMes.slotno;
		GHMGCMEM_SAFE_FREE( m_pSaveData );
		GHM_SAFE_DELETE( m_pCardInfo );
		GHM_SAFE_DELETE_ARRAY( m_pSavedName );
		CreateMessage(CERROR_MES_NONE);
		m_Proc =  m_NextMes.proc;
		return;
	}
}



//========================================================================
//					Z[uf[^tHg쐬
//========================================================================
void  		SK7SaveLoad::RenderSaveComment()
{
	f32 SX;
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	f32 size;
	if( m_chSavedFlag & (1<<(m_chSaveSelectNo)) ){
		size = m_pYFont->DrawFSStr( 0.0f, 0.0f, false, false, "%s", m_SaveName[m_chSaveSelectNo].name ); 
	}else{
		size = m_pYFont->DrawFSStr( 0.0f, 0.0f, false, false, "Not Save Data" ); 
	}	
	m_spBoxLine.SetSprite	( SAVE_NO_X, SAVE_DATA_Y+m_chSaveSelectNo*SAVE_DATA_GAPY-2, size+SAVE_BOX_PLUSX, SAVE_BOX_SIZEY, SLOT_FONT_COLOR );
	m_spBoxLine.SetVisible	( true );
	m_spBoxLine.Render		();
	
	for( int i = 0; i < SAVE_DATA_NUM; i++ ){
		if( i == m_chSaveSelectNo && (m_Proc == PROC_WRITE || m_Proc == PROC_WRITE_CHECK) ){
			SX = m_fSaveNameX;
		}else{
			SX = SAVE_DATA_X;
		}
		m_pYFont->DrawSetup();
		if( i == m_chSaveSelectNo )	m_pYFont->SetColor2(0x000000ff);
		else						m_pYFont->SetColor2(SLOT_FONT_COLOR);
		m_pYFont->DrawFSStr( SAVE_NO_X, SAVE_DATA_Y+i*SAVE_DATA_GAPY, false, true, "%d:", (i+1) ); 
		if( m_chSavedFlag & (1<<i) ){
			m_pYFont->DrawFSStr( SX, SAVE_DATA_Y+i*SAVE_DATA_GAPY, false, true, "%s", m_SaveName[i].name ); 
		}else{
			if( i == m_chSaveSelectNo )	m_pYFont->SetColor2(0x000000ff);
			else						m_pYFont->SetColor2(SLOT_FONT_COLOR);
			m_pYFont->DrawFSStr( SX, SAVE_DATA_Y+i*SAVE_DATA_GAPY, false, true, "Not Save Data" ); 
		}	
	}
}


//========================================================================
//					  
//		㏑̂ƂQd݂s t@CQ
//		AQ̃t@CɂȂƂ̓Rg̎ԂŔ
//========================================================================
void 			SK7SaveLoad::WriteSaveData()
{
	if( m_iSaveDataSize <= 0 ){
		return;
	}
	
	//	Xbg݃`FbN	---------------------------
	if( CARDProbeEx( m_chSetSlotNo, NULL, NULL ) != CARD_RESULT_READY ){
		m_Proc = PROC_WRITE_CHECK;
		return;
	}
	
	//	Z[uf[^̍쐬	==========================
	CreateSaveData();
	
	GHM_SAFE_DELETE( m_pCardInfo );
	ghmGcMemSetAllocName("SAVELOAD");
	m_pCardInfo 	= new CARDFileInfo;			//	J[hNX
	memset( m_pCardInfo, 0, sizeof(CARDFileInfo) );

	char FileName[32];
	sprintf( FileName, "%s_%d", SAVE_FILE_NAME, (int)m_chSaveSelectNo );
	
	//	Z[u[h̎	================================
	if( m_chSavedFlag & (1<<(m_chSaveSelectNo)) ){
		CARDOpen( m_chSetSlotNo, FileName, m_pCardInfo );
	}else{
		CARDCreate( m_chSetSlotNo, FileName, (u32)m_iSaveDataSize, m_pCardInfo );
		m_chSavedFlag |= (1<<m_chSaveSelectNo);						//	tOĂ
	}
	
	ghmGcMemSetAllocName("SAVELOAD");
	if( (m_pSaveData = (SK7SaveData *)ghmGcMemAlloc(m_iSaveDataSize))!=NULL ){
		
		memset( m_pSaveData, 0, sizeof(m_SaveData) );// (u32)m_iSaveDataSize);
		memcpy( m_pSaveData, &m_SaveData, sizeof(m_SaveData)  );
		//		----------------------------------
		CARDWriteAsync	( m_pCardInfo, 	m_pSaveData, 		m_iSaveDataSize,		0, NULL );	//	
		
	}
	
	m_ucMoveNameFlag 	= 0;
	m_iSaveNameTime 	= 0;
	m_Proc = PROC_WRITE_CHECK;
}

//========================================================================
//					݃f[^쐬
//========================================================================
void 		SK7SaveLoad::CreateSaveData()
{
	char	comment[SAVE_FONT_SIZE];
	char Time[32];
	memset( comment, 0, sizeof( char )*SAVE_FONT_SIZE );
	GHM_SAFE_DELETE_ARRAY( m_pSavedName );
	ghmGcMemSetAllocName("SAVELOAD");
	m_pSavedName	= new char[32];

	//	Ԏ擾	======================================================
	OSCalendarTime td;
	OSTicksToCalendarTime(OSGetTime(), &td);
	int Year = td.year%2000;

	//	filename	======================================================
#ifdef __DEBUG_SAVE__
	sprintf( comment, "%s  ViI%d %s", KILLER7_COMMENT, 0, SaveScenarioName[0+6] );
	sprintf( Time, "%02d/%02d/%02d %02d:%02d", Year, td.mon+1, td.mday, td.hour, td.min );
	sprintf( m_pSavedName, "[%s] %s", SaveScenarioName[0],Time );
#else
	sprintf( comment, "%s  ViI%d %s", KILLER7_COMMENT, (int)GameInfo.GetScenarioID(), SaveScenarioName[GameInfo.GetScenarioID()+6] );
	sprintf( Time, "%02d/%02d/%02d %02d:%02d", Year, td.mon+1, td.mday, td.hour, td.min );
	sprintf( m_pSavedName, "[%s] %s", SaveScenarioName[GameInfo.GetScenarioID()],Time );
#endif
	memcpy( &comment[32], Time, sizeof(Time) );
	
	//	Z[uf[^Zbg	
	memcpy( &m_SaveData.Comment, 	comment, 			SAVE_FONT_SIZE );			//	Rg
	memcpy( &m_SaveData.Banner, 	m_pBanner->image, 	BANNER_SIZE );	//	oi[  
	memcpy( &m_SaveData.Icon, 	m_pIconData, 			ICON_SIZE );	//	ACR
	m_SaveData.Version 			= SAVELOAD_VERSION;
	m_SaveData.GameClearFlag 	= (K7SCR_GET_GLOBAL_FLAG(K7GLFL_GAME_CLEAR)) ? true : false;
	m_SaveData.CrcNo 			= GetCRC( &m_SaveData );
}

//========================================================================
//					ݏI
//========================================================================
void 			SK7SaveLoad::EndWriteEvent()
{
	if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		m_Proc =  PROC_WRITE_END;
	}
}
//========================================================================
//					bZ[WI
//========================================================================
void 			SK7SaveLoad::EndNotEvent()
{
	if( HSD_PadGetTrigger(0) & (HSD_PAD_A|HSD_PAD_B) ){
		gpSound->mPlaySE( SFX_TV_CONTENTS_CHOICE );
		m_Proc = PROC_END;
	}
}

//========================================================================
//					ݏI
//========================================================================
void			SK7SaveLoad::CheckWriteEnd()
{
	//	ړ	-----------------------------------
	if( m_ucMoveNameFlag == 0 ){
		m_fSaveNameX += (SAVE_NAME_RIGHT_X - SAVE_DATA_X)/SAVE_NAME_TIME;
	}
	else if( m_ucMoveNameFlag == 1 ){
		if( m_iSaveNameTime < SAVE_NAME_TIME ){
			m_fSaveNameX -= (SAVE_NAME_RIGHT_X - SAVE_DATA_X)/SAVE_NAME_TIME;		
		}
	}

	++m_iSaveNameTime;
	
	//	ݏIƍړcheck
	if( CARDGetResultCode(m_chSetSlotNo) == CARD_RESULT_READY ){
		if( m_iSaveNameTime >= SAVE_NAME_TIME ){
			if( m_ucMoveNameFlag == 0 ){
				memcpy( m_SaveName[m_chSaveSelectNo].name, m_pSavedName, 32 );
				GHM_SAFE_DELETE_ARRAY( m_pSavedName );
				m_ucMoveNameFlag = 1;
				m_iSaveNameTime = 0;
				//	J[hZbg	-----------------------------
				SetCardData();
			}
			else if( m_ucMoveNameFlag == 1 ){
				gpSound->mPlaySE( SFX_TV_CHANGE_NOIZ );
				//	N[Y	---------------------------------
				CARDClose(m_pCardInfo);
				
				//	폜	-------------------------------------
				GHM_SAFE_DELETE( m_pCardInfo );
				GHM_SAFE_DELETE( m_pIconData );
				//	A}Eg	-----------------------------------------
				if( m_chSetSlotNo < 2 )	 CARDUnmount(m_chSetSlotNo);	
				GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
				//	I܂B
				CreateCheck( CHECK_MES_SAVEEND );
				m_ucMoveNameFlag 	= 0;
				m_iSaveNameTime 	= 0;
				m_Proc = PROC_END_MESSAGE;
				return;
			}
		}
	}
}

//========================================================================
//					ǂݍ
//========================================================================
void			SK7SaveLoad::LoadSaveData()
{
	if( m_iSaveDataSize <= 0 ){
		return;
	}
	
	//	J[hTCY}Ƃɂ`FbN
	if( CARDProbeEx( m_chSetSlotNo, NULL, NULL ) != CARD_RESULT_READY ){
		CreateMessage( CERROR_MES_NOSLOT );
		m_bLoadFontFlag = false;
		//	̃bZ[WZbg	----------------------------------
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
	}

	GHM_SAFE_DELETE( m_pCardInfo );
	ghmGcMemSetAllocName("SAVELOAD");
	m_pCardInfo 	= new CARDFileInfo;			//	J[hNX
	memset( m_pCardInfo, 0, sizeof(CARDFileInfo) );

	char FileName[32];

	ghmGcMemSetAllocName("SAVELOAD");
	if( (m_pSaveData = (SK7SaveData *)ghmGcMemAlloc(m_iSaveDataSize))==NULL ){
		return;
	}
	
	sprintf( FileName, "%s_%d", SAVE_FILE_NAME, (int)m_chSaveSelectNo );
	int a = CARDOpen	( m_chSetSlotNo, FileName, m_pCardInfo );						//t@CI[v
	
	switch( a ){
	case CARD_RESULT_NOCARD:
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		CreateMessage( CERROR_MES_NOSLOT );		
		break;
	case CARD_RESULT_NOFILE:		
	case CARD_RESULT_BROKEN:		
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		CreateMessage( CERROR_MES_BREAK_DATA );
		m_bSelectFlag = true;
		m_bLoadFontFlag = false;
		m_ucSelectMes = CHECK_MESUP_DELETE_CHECK;
		break;
	case CARD_RESULT_READY:			break;
	default:						
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		CreateMessage( CERROR_MES_BREAK_DATA ); 
		break;
	}
	//	I[v`FbN	----------------------------------------------
	if( a != CARD_RESULT_READY ){
		m_bLoadFontFlag = false;
		//	̃bZ[WZbg	----------------------------------
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
	}	
	CARDReadAsync( m_pCardInfo, m_pSaveData, m_iSaveDataSize, 0, NULL );			//ǂݍ
	m_Proc = PROC_LOAD_CHECK;
}

//========================================================================
//					ǂݍݏI
//========================================================================
void				SK7SaveLoad::CheckLoadEnd()
{
	if( CARDGetResultCode(m_chSetSlotNo) == CARD_RESULT_READY ){
		CARDClose	( m_pCardInfo );										//
		//	폜	-------------------------------------
		GHM_SAFE_DELETE( m_pCardInfo );			//	J[h폜		
		//	Zbg	-----------------------------------
		memcpy( &m_SaveData, m_pSaveData, sizeof(m_SaveData) );
		GHMGCMEM_SAFE_FREE( m_pSaveData );
		
			
		//	bqb`FbN	-----------------------------
		if( CheckCRC( &m_SaveData ) ){
			//	o[W`FbN	---------------------
			if( m_SaveData.Version == SAVELOAD_VERSION ){
				//	Ă邩`FbN	---------------------
				if( m_SaveData.SaveData.mClearScenarioID >= -1 && m_SaveData.SaveData.mClearScenarioID <= 6 ){
					if( m_chSetSlotNo < 2 )	 CARDUnmount( m_chSetSlotNo );			//	A}Eg
					GHM_SAFE_DELETE_ARRAY( m_pWorkErea );
					const char* Cm = m_SaveData.Comment;
					m_ScenarioNo = atoi( &Cm[COMMENT_MEM_SCN] );
					m_Proc = PROC_READ_END;
					return;
				}
			}
		}		
		//	폜`FbN	-------------------------------
		CreateMessage( CERROR_MES_BREAK_DATA );
		m_ucSelectMes = CHECK_MESUP_DELETE_CHECK;
		m_bSelectFlag = true;
		m_bLoadFontFlag = false;
		SET_NEXT_MESSAGE( -1, PROC_SLOT_CHECK, 2, false );
		m_Proc = PROC_CARD_MESSAGE;
		return;
	}
}


	
//========================================================================
//					bqb̎擾
//========================================================================
u32			SK7SaveLoad::GetCRC( SK7SaveData* Data )
{
	Data->CrcNo = 0;								//	CRCNA	
	return crc1( sizeof(SK7SaveData), (byte*)Data );	//	CRC`FbN
}

//========================================================================
//					bqb`FbN	
//========================================================================
bool			SK7SaveLoad::CheckCRC( SK7SaveData* pSave )
{
	u32 CrcNo,CrcNo2;
	if( pSave != NULL ){
		CrcNo = pSave->CrcNo;
		pSave->CrcNo = 0;
		CrcNo2 = GetCRC( pSave );
		if( CrcNo == CrcNo2 ){
			return true;
		}
	}
	return false;
}
//========================================================================
//					bqb
//========================================================================
u32 crc1( int n, byte c[] )
{
	unsigned int i, j;
	unsigned long r;
	r = 0xFFFFFFFFUL;
	for( i = 0; i < n; i++ ){
		r ^= (unsigned long)c[i] << (32 - CHAR_BIT);
		for( j = 0; j < CHAR_BIT; j++ )
		if( r & 0x80000000UL) 	r = (r<<1) ^ CRCPOLY1;
		else					r <<= 1;
	}
	return ~r & 0xFFFFFFFFUL;
}

void makecrctable1(void)
{
	unsigned int i, j;
	unsigned long r;
	
	for( i = 0; i < UCHAR_MAX; i++ ){
		r = ( unsigned long )i << (32 - CHAR_BIT);
		for( j = 0; j < CHAR_BIT; j++ ){
			if( r & 0x80000000ul ) 	r = ( r << 1 ) ^ CRCPOLY1;
			else					r <<= 1;
		}
		crctable[i] = r & 0xfffffffful;
	}
}
/*
u32 crc1(int n, byte c[])
{
	unsigned long r;
	
	r = 0xfffffffful;
	while( --n >= 0 ){
		r = ( r << CHAR_BIT ) ^ crctable[(byte)(r >> (32 - CHAR_BIT)) ^ *c++];
	}
	return ~r & 0xfffffffful;
}
*/

void makecrctable2(void)
{
	unsigned int i, j;
	unsigned long r;
	
	for( i = 0; i <= UCHAR_MAX; i++ ){
		r = i;
		for( j = 0; j < CHAR_BIT; j++ ){
			if( r & 1 ) r = ( r >> 1) ^ CRCPOLY2;
			else		r >>= 1;
		}
		crctable[i] = r;
	}
}

u32 crc2(int n, byte c[])
{
	unsigned long r;
	
	r = 0xfffffffful;
	while( --n >= 0 ){
		r = ( r >> CHAR_BIT ) ^ crctable[(byte)r ^ *c++];
	}
	return r ^ 0xfffffffful;
}

	