////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SaveLoadMessage
//
// SK7SaveLoadMessage.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 02/12/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SAVELOADMESSAGE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include <limits.h>
#include "../wat/K7App.h"
#include "SK7SaveLoadMessage.h"
#include "../matsu/mK7Sound.h"
#include "SK7SaveData.h"
#include "../Yam/YK7Effect.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"
#include "SK7FirstCheck.h"


#define		SAVELOAD_PACK_DATA		"/Texture/save.pak"

#define		BACK_COLOR				(0xffff00af)
#define		SELECT_LINE_COLOR		(0x000000ff)
#define		SELECT_LINE_SIZE		(20)
#define		SLOT_FONT_X				(210)
#define		SLOT_FONT_Y				(150)
#define		SLOT_FONT_GAPY			(50)
#define		SLOT_SELECT_HALFX		(16)
#define		SLOT_SELECT_GAPY		(10)
#define		SLOT_SELECT_SIZEY		(46)
#define		FIRST_MES_X				(60)
#define		FIRST_MES_Y(NO)			(80+32*NO)
#define		FIRST_SELECT_Y(NO)		(310+30*NO)
#define		FIRST_TRI_X				(FIRST_MES_X-30)
#define		FIRST_MES_Y2(NO)		(165+35*NO)
#define		ERROR_MES_X				(118)
#define		ERROR_MES_Y(NO)			(100+30*NO)
#define		ERROR_MES_ONE_Y			(145)
#define		ERROR_MES_ONE_Y2		(175)
#define		CHECK_MES_Y(NO)			(170+30*NO)
#define		CHECK_ANS_Y				(215)
#define		TV_CENTER_Y				(150)
#define		INIT_CHECK_X			(170)
#define		INIT_CHECK_Y			(260)
#define		INIT_YES_X				(200)
#define		INIT_YES_Y				(300)
#define		INIT_NO_X				(285)
#define		INIT_NO_Y				(300)
#define		INIT_ANS_SIZEX			(70)
#define		INIT_ANS_SIZEY			(50)
#define		SELECT_GAP_YX			(-12.0f)
#define		SELECT_GAP_NX			(-20.0f)
#define		SELECT_GAP_YY			(-3.5f)
#define		SELECT_GAP_NY			(-3.5f)
#define		BUTTON_ANIME_TIME		(10)
#define		BUTTON_CENTER_X			(TV_CENTER_X-16)
#define		DRAW_ABUTTON(X,Y,TEXNO)\
	{\
		m_spAButton.SetXY0( BUTTON_CENTER_X, Y );\
		m_spAButton.SetFlag( true, RENDER_FLAG|BLOCK_FLAG );\
		m_spAButton.SetTexNo(TEXNO);\
		m_spAButton.Render();\
	}


//========================================================================
//					RXgN^
//========================================================================
SK7SaveLoadMessage::SK7SaveLoadMessage()
{
	m_pYFont 	= NULL;
	m_pYHira 	= NULL;
	m_pYEng 	= NULL;
	m_pYKana = new YK7StrImage;
	m_pYKana->Load( Y_KANA_TEX );

	m_spBack.SetSprite	( 0.0f, 0.0f, 0.0f, 0.0f, BACK_COLOR );
	m_spBack.SetVisible	( false );

	m_spSelect.SetLineQuad( 0, 0, 0, 0, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
	m_spSelect.SetVisible ( true );
	
	m_iButtonTime = 0;
	
	m_eLoadProc 	= PROC_MES_PACK;
	m_ucMesNo 		= CERROR_MES_NONE;
	m_ucCheckNo		= CHECK_MES_NONE;
	m_ucCheckUpNo 	= CHECK_MESUP_NONE;
}


//========================================================================
//					fXgN^
//========================================================================
SK7SaveLoadMessage::~SK7SaveLoadMessage()
{
	if( m_pYKana != NULL )	m_pYKana->Release();
	GHM_SAFE_DELETE(m_pResLink);

	GHM_SAFE_DELETE( m_pYFont );
	GHM_SAFE_DELETE( m_pYKana );
	GHM_SAFE_DELETE( m_pYHira );
	GHM_SAFE_DELETE( m_pYEng );
	GHM_SAFE_DELETE_ARRAY	( m_pTexture );	
}


//========================================================================
//					f[g
//========================================================================
void		SK7SaveLoadMessage::DeleteMessage()
{
}

//========================================================================
//					`
//========================================================================
void		SK7SaveLoadMessage::RenderFontFirst( s8 slotno, s8 select, s8 state )
{
	if( m_ucMesNo == CERROR_MES_NONE )		return;

	m_pYHira->DrawSetup();
	m_pYHira->SetExRate( 1.1f );
	m_pYHira->SetColor2( 0xffffffbf );

	switch( m_ucMesNo ){
	case CERROR_CHECK_NOSLOT:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "XbgɃ[J[hA"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "Ă܂B"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "̂܂܂͂߂ꍇZ[uł܂B"  );		
		SetCheckSelectFont( CARD_SELECT_NORMAL, select );
		break;
		
	case CERROR_CHECK_NOTCARD:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbg`ɂ̓[J[h"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbgaɂ̓[J[h"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "ȊÔ̂Ă܂B"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "̂܂܂͂߂ꍇZ[uł܂B"  );		
		SetCheckSelectFont( CARD_SELECT_NORMAL, select );
		break;
		
	case CERROR_CHECK_INIT:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbg`̃[J[h́A"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbgã[J[h́A"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "f[^Ă̂ŏKvłB"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "̂܂܂͂߂ꍇZ[uł܂B"  );		
		SetCheckSelectFont( CARD_SELECT_INIT, select );
		break;
		
	case CERROR_CHECK_INIT_CHECK:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "ƃ[J[h"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "St@C܂B"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "낵łH"  );
		SetCheckSelectFont( CARD_SELECT_CHECK_INIT, select );
		break;
		
	case CERROR_CHECK_BREAK:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbg`̃[J[h́A"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbgã[J[h́A"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "Ă̂Ŏgpł܂B"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "̂܂܂͂߂ꍇZ[uł܂B"  );		
		SetCheckSelectFont( CARD_SELECT_NORMAL, select );
		break;
		
	case CERROR_CHECK_SIZE:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbg`̃[J[hɋ󂫗eʂȂA"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Xbgã[J[hɋ󂫗eʂȂA"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "t@C̐Ă܂܂B"  );
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) == true ){
			m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "hopper7Z[uɂ͏ȂƂ"  );
		}else if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) == true ){
			m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "killer8Z[uɂ͏ȂƂ"  );
		}else{
			m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "killer7Z[uɂ͏ȂƂ"  );
		}
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(3), false, true, "t@C1%dubN̋󂫗eʂKvłB", SAVEDATA_BLOCK );
		if( state == CHECK_STATE_KILLER8 || g_bFirstGameCheck ){
			m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(4), false, true, "[J[h̓e𐮗ɂ́A" );
			m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(5), false, true, "{̂̃[J[hʂłȂĂB" );
			SetCheckSelectFont( CARD_SELECT_NORMAL, select );
		}else{
			SetCheckSelectFont( CARD_SELECT_IPL, select );
		}
		break;
		
	case CERROR_CHECK_CHECK:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "`FbNłB"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(1), false, true, "[J[hp[{^"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(2), false, true, "ȂłB"  );
		break;

	case CERROR_INIT_CHECK:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "łB"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(1), false, true, "[J[hp[{^"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(2), false, true, "ȂłB"  );
		break;
		
	case CERROR_CHECK_NO_INIT:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "Xbg`̃[J[h́A"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "Xbgã[J[h́A"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(1), false, true, "gp邱Ƃł܂B"  );
		break;
		
	case CERROR_CHECK_INIT_OK:
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "Xbg`̃[J[h"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(0), false, true, "Xbgã[J[h"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y2(1), false, true, "܂B"  );
		break;
		
	case CERROR_CHECK_INIT_MISS:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(0), false, true, "Ɏs܂B"  );
		if( slotno == 0 )	m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "Xbg`̃[J[h"  );
		else				m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(1), false, true, "Xbgã[J[h"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(2), false, true, "Ă̂"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(3), false, true, "gp邱Ƃł܂B"  );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_MES_Y(4), false, true, "̂܂܂͂߂ꍇZ[uł܂B"  );		
		SetCheckSelectFont( CARD_SELECT_NORMAL, select );
		break;
	}
}

//========================================================================
//					`
//========================================================================
bool		SK7SaveLoadMessage::RenderFont( s8 SlotNo, bool SaveFlag )
{
	if( m_ucMesNo == CERROR_MES_NONE )		return true;
	
	//	{^Aj[V		
	u16 texno;
	if( m_iButtonTime < BUTTON_ANIME_TIME ){
		texno = 0;
	}else if( m_iButtonTime < BUTTON_ANIME_TIME*2 ){
		texno = 1;
	}else{
		m_iButtonTime = 0;
		texno = 0;
	}
	m_iButtonTime++;
	
	//	ӂaf		
	m_spCM.SetVisible( true );
	m_spCM.Render();
	m_pYHira->DrawSetup();
	m_pYHira->SetExRate( 1.0f );
	m_pYHira->SetColor2( 0x000000ff );

	f32 Size=0;

	switch( m_ucMesNo ){
	case CERROR_MES_NOTCARD:
		if( SlotNo == 0 ){
			DrawMessageHira( ERROR_MES_Y(1), "Xbg`ɂ̓[J[h" );
		}else{
			DrawMessageHira( ERROR_MES_Y(1), "Xbgaɂ̓[J[h" );
		}
		DrawMessageHira( ERROR_MES_Y(2), "ȊÔ̂Ă܂B"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(3), texno );
		break;
		
	case CERROR_MES_NOSAVE:		m_pYHira->DrawFSStr( ERROR_MES_X, ERROR_MES_ONE_Y, false, true, "̂܂܎n߂ꍇZ[uł܂B" ); break;
	case CERROR_MES_NOSLOT:
		if( SlotNo == 0 )		DrawMessageHira( ERROR_MES_Y(1), "Xbg`Ƀ[J[h");
		else					DrawMessageHira( ERROR_MES_Y(1), "XbgaɃ[J[h");
		Size = DrawMessageHira( ERROR_MES_Y(2), "Ă܂B" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(3), texno );
		break;
		
	case CERROR_MES_CHECK:		
		DrawMessageHira( ERROR_MES_Y(1), "[J[hp[{^" );
		DrawMessageHira( ERROR_MES_Y(2), "Ȃł"  );
		break;

	case CERROR_MES_INITCHECK:		
		DrawMessageHira( ERROR_MES_Y(1), "łB" );
		DrawMessageHira( ERROR_MES_Y(2), "[J[hp[{^" );
		DrawMessageHira( ERROR_MES_Y(3), "Ȃł"  );
		break;

	case CERROR_MES_DELETECHECK:		
		DrawMessageHira( ERROR_MES_Y(1), "f[^폜łB" );
		DrawMessageHira( ERROR_MES_Y(2), "[J[hp[{^" );
		DrawMessageHira( ERROR_MES_Y(3), "Ȃł"  );
		break;
		
	case CERROR_MES_FORMAT:
		if( SaveFlag )		DrawMessageHira( ERROR_MES_Y(0), "Z[uɎs܂B"  );
		else				DrawMessageHira( ERROR_MES_Y(0), "[hɎs܂B"  );
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h " );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h " );
		DrawMessageHira( ERROR_MES_Y(2), "f[^Ă̂" );
		Size = DrawMessageHira( ERROR_MES_Y(3), "KvłB" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
				
	case CERROR_MES_BREAK_DATA:
		if( SaveFlag )		DrawMessageHira( ERROR_MES_Y(1), "Z[uɎs܂B"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "[hɎs܂B"  );
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(2), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(2), "Xbgã[J[h"  );
		Size = DrawMessageHira( ERROR_MES_Y(3), "gp邱Ƃł܂B"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_BREAK_SAVE:
	case CERROR_MES_BREAK_SAVE_A:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "̃Z[uf[^͂Ă܂B" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(3), texno );
		break;

	case CERROR_MES_BREAK_SAVE_NO:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "̃Z[uf[^͂" );
		Size = DrawMessageHira( ERROR_MES_Y(3), "̂Ŏgpł܂B" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;

	case CERROR_MES_NODATA_KILLER8:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "̃Z[uf[^killer8̃f[^" );
		Size = DrawMessageHira( ERROR_MES_Y(3), "ł͂Ȃ̂Ń[hł܂B" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_NODATA_HOPPER7:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "̃Z[uf[^hopper7̃f[^" );
		Size = DrawMessageHira( ERROR_MES_Y(3), "ł͂Ȃ̂Ń[hł܂B" );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;

	case CERROR_MES_BREAK_CARD:
		if( SaveFlag )		DrawMessageHira( ERROR_MES_Y(1), "Z[uɎs܂B"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "[hɎs܂B"  );
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(2), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(2), "Xbgã[J[h"  );
		Size = DrawMessageHira( ERROR_MES_Y(3), "Ă̂Ŏgpł܂B"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_INIT_CHECK:
		DrawMessageHira( ERROR_MES_Y(1), "ƃJ[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "St@C܂B"  );
		Size = DrawMessageHira( ERROR_MES_Y(3), "낵łH"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_IPL:
		DrawMessageHira( ERROR_MES_Y(1), "[J[h̓e𐮗"  );
		DrawMessageHira( ERROR_MES_Y(2), "ɂ́A{̂̃[J[h" );
		Size = DrawMessageHira( ERROR_MES_Y(3), "ʂōsĂB"  );		
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_NO_SPACE:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		DrawMessageHira( ERROR_MES_Y(2), "󂫗eʂȂAt@C"   );
		DrawMessageHira( ERROR_MES_Y(3), "zĂ܂B"    );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
	
	case CERROR_MES_FILE_REQ:
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) == true ){
			DrawMessageHira( ERROR_MES_Y(0), "hopper7̃f[^"   );
		}else if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) == true ){
			DrawMessageHira( ERROR_MES_Y(0), "killer8̃f[^"   );
		}else{
			DrawMessageHira( ERROR_MES_Y(0), "killer7̃f[^"   );
		}
		DrawMessageHira( ERROR_MES_Y(1), "Z[uɂ́AȂƂA"   );
		DrawMessageHira( ERROR_MES_Y(2), "t@C1%dubN", SAVEDATA_BLOCK   );
		Size = DrawMessageHira( ERROR_MES_Y(3), "󂫗eʂKvłB" );		
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
		
	case CERROR_MES_NOT_DATA:
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(1), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(1), "Xbgã[J[h"  );
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) == true ){
			Size = DrawMessageHira( ERROR_MES_Y(2), "hopper7̃f[^܂"   );
		}else if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 ) == true ){
			Size = DrawMessageHira( ERROR_MES_Y(2), "killer8̃f[^܂"   );
		}else{
			Size = DrawMessageHira( ERROR_MES_Y(2), "killer7̃f[^܂"   );
		}
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(3), texno );
		break;

	case CERROR_MES_INIT_MISS:
		DrawMessageHira( ERROR_MES_Y(1), "Ɏs܂B"   );
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(2), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(2), "Xbgã[J[h"  );
		Size = DrawMessageHira( ERROR_MES_Y(3), "Ă̂Ŏgpł܂B"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
	
	case CERROR_MES_INIT_OK:
		Size = DrawMessageHira( ERROR_MES_ONE_Y, "܂B"    );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_ONE_Y2, texno );
		break;
		
	case CERROR_MES_DELETE_OK:
		Size = DrawMessageHira( ERROR_MES_ONE_Y, "폜܂B"    );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_ONE_Y2, texno );
		break;

	case CERROR_MES_DELETE_MISS:
		DrawMessageHira( ERROR_MES_Y(1), "폜Ɏs܂B"    );
		if( SlotNo == 0 )	DrawMessageHira( ERROR_MES_Y(2), "Xbg`̃[J[h"  );
		else				DrawMessageHira( ERROR_MES_Y(2), "Xbgã[J[h"  );
		Size = DrawMessageHira( ERROR_MES_Y(3), "Ă̂Ŏgpł܂B"  );
		DRAW_ABUTTON( TV_CENTER_X, ERROR_MES_Y(4), texno );
		break;
	}
	return true;
}

//========================================================================
//					`FbNpZNgtHg
//========================================================================
void		SK7SaveLoadMessage::SetCheckSelectFont( u8 state, s8 select )
{
	//	Op̐ݒ	--------------------------------------------------
	m_pYHira->DrawSetup();
	m_pYHira->SetExRate( 1.0f );
	m_pYHira->SetColor2( 0xffffffff );
	m_pYHira->DrawFSStr( FIRST_TRI_X, FIRST_SELECT_Y( select ), false, true, "" );
		
	m_pYHira->DrawSetup();
	m_pYHira->SetExRate( 1.0f );
	m_pYHira->SetColor2( 0xffffffff );
	switch( state ){
	case CARD_SELECT_NORMAL:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(0), false, true, "Z[uł͂߂" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(1), false, true, "[J[h" );
		break;
	case CARD_SELECT_INIT:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(0), false, true, "Z[uł͂߂" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(1), false, true, "[J[h" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(2), false, true, "" );
		break;
	case CARD_SELECT_IPL:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(0), false, true, "Z[uł͂߂" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(1), false, true, "[J[h" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(2), false, true, "ZbgĖ{̃[J[hʂ" );
		break;
	case CARD_SELECT_CHECK_INIT:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(0), false, true, "" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(1), false, true, "Ȃ" );
		break;
	case CARD_SELECT_BREAK:
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(0), false, true, "Z[uł͂߂" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(1), false, true, "[J[h" );
		m_pYHira->DrawFSStr( FIRST_MES_X, FIRST_SELECT_Y(2), false, true, "f[^폜" );
		break;
	}
}

//========================================================================
//					Z[uf[^tHg쐬
//========================================================================
void		SK7SaveLoadMessage::RenderSlotName( u8 select, u32 ColorA, u32 ColorB, bool saveload, bool CursolRender  )
{
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
#if 0
	DEBUG_GET_2D_POS2( m_spBack );
#else
	m_spBack.SetSprite( 149.1875f, 123.8750f, 238.8125f, 176.5625f, BACK_COLOR );
#endif
	
	m_pYFont->DrawSetup();
	m_pYFont->SetExRate( 1.0f );

	if( select > 2 )	select = 2;

	f32 size[3];
	size[0] = m_pYFont->DrawFSStr( 0, 0, false, false, "" ); 
	size[1] = m_pYFont->DrawFSStr( 0, 0, false, false, "" ); 
	if( saveload )	size[2] = m_pYFont->DrawFSStr( 0, 0, false, false, "[ǂȂ" ); 
	else			size[2] = m_pYFont->DrawFSStr( 0, 0, false, false, "[ԂȂ" ); 

	SK7Sprite  spSelect;
	if( select < 2 ){
		spSelect.SetSprite( SLOT_FONT_X-SLOT_SELECT_HALFX, SLOT_FONT_Y+SLOT_FONT_GAPY*select-SLOT_SELECT_GAPY, size[select]+SLOT_SELECT_HALFX*3+8.0f, SLOT_SELECT_SIZEY, SLOT_FONT_COLOR );
	}else{
		spSelect.SetSprite( SLOT_FONT_X-SLOT_SELECT_HALFX, SLOT_FONT_Y+SLOT_FONT_GAPY*select-SLOT_SELECT_GAPY, size[select]+SLOT_SELECT_HALFX*2, SLOT_SELECT_SIZEY, SLOT_FONT_COLOR );
	}
	if( select == 0 ){
		if( ColorA == SLOT_FONT_COLOR ){
			spSelect.SetColor( SLOT_FONT_COLOR );
		}else{
			spSelect.SetColor( SLOT_NOT_COLOR );
		}
	}
	if( select == 1 ){
		if( ColorB == SLOT_FONT_COLOR ){
			spSelect.SetColor( SLOT_FONT_COLOR );
		}else{
			spSelect.SetColor( SLOT_NOT_COLOR );
		}
	}
	spSelect.SetVisible( CursolRender );
	spSelect.Render();

	if( select == 0 ){
		if( CursolRender ){
			m_pYFont->SetColor2(0x000000ff);
			m_spAB[0].SetColor( 0x000000ff );
		}else{
			m_pYFont->SetColor2	( ColorA );
			m_spAB[0].SetColor	( ColorA );
		}
	}else{
		m_pYFont->SetColor2(ColorA);
		m_spAB[0].SetColor( ColorA );
	}
	m_pYFont->DrawFSStr( SLOT_FONT_X, SLOT_FONT_Y, false, true, "" ); 
	m_spAB[0].SetXY0( SLOT_FONT_X+size[0], SLOT_FONT_Y-1.0f ); 
	if( select == 1 ){
		m_pYFont->SetColor2(0x000000ff);
		m_spAB[1].SetColor( 0x000000ff );
	}else{
		m_pYFont->SetColor2(ColorB);
		m_spAB[1].SetColor(ColorB);
	}
	m_pYFont->DrawFSStr( SLOT_FONT_X, SLOT_FONT_Y+SLOT_FONT_GAPY, false, true, "" ); 
	m_spAB[1].SetXY0( SLOT_FONT_X+size[1], SLOT_FONT_Y+SLOT_FONT_GAPY-1.0f ); 
	if( select == 2 )	m_pYFont->SetColor2(0x000000ff);
	else				m_pYFont->SetColor2(SLOT_FONT_COLOR);
	if( saveload )		m_pYFont->DrawFSStr( SLOT_FONT_X, SLOT_FONT_Y+SLOT_FONT_GAPY*2, false, true, "[ǂȂ" ); 
	else				m_pYFont->DrawFSStr( SLOT_FONT_X, SLOT_FONT_Y+SLOT_FONT_GAPY*2, false, true, "[ԂȂ" ); 
	
	m_spAB[0].Render();
	m_spAB[1].Render();
}


//========================================================================
//					e`FbNp
//========================================================================
void		SK7SaveLoadMessage::RenderCheckFont( u8 select )
{
	if( m_ucCheckNo == CHECK_MES_NONE )	return;
	
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
#if 0
	DEBUG_GET_2D_POS2( m_spBack );
#else
#endif
	m_spBack.SetVisible( true );
	m_spBack.SetColor( 0xffff007f );

	m_pYEng->DrawSetup();
	m_pYEng->SetColor2(0x000000ff);
	m_pYEng->SetExRate( 1.6f );
	
	m_pYFont->DrawSetup();
	m_pYFont->SetColor2(0x000000ff);

	switch( m_ucCheckNo ){
	case CHECK_MES_OVER_WRITE:
		m_spBack.SetSprite( 100.75f, 142.75f, 320.625f, 124.0f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr	( TV_CENTER_X, CHECK_MES_Y(0), 	true, true, "킪@Ăł?" ); 
		m_pYEng->DrawFSStr	( INIT_YES_X, 	CHECK_ANS_Y, 	false, true, "YES" );
		m_pYEng->DrawFSStr	( INIT_NO_X, 	CHECK_ANS_Y, 	false, true, "NO"); 
		if( select == 0 )	m_spSelect.SetLineQuad( INIT_YES_X+SELECT_GAP_YX, 	CHECK_ANS_Y+SELECT_GAP_YY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		else				m_spSelect.SetLineQuad( INIT_NO_X+SELECT_GAP_NX,  	CHECK_ANS_Y+SELECT_GAP_NY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		m_spSelect.Render();
		break;

	case CHECK_MES_START_NOW:
		m_spBack.SetSprite( 78.0f, 184.625f, 369.375f, 83.25f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr	( INIT_CHECK_X, INIT_CHECK_Y, 	false, true, "[ށ@@̂܂܂͂߂܂?" ); 
		m_pYEng->DrawFSStr	( INIT_YES_X, 	CHECK_ANS_Y, 	false, true, "YES" );
		m_pYEng->DrawFSStr	( INIT_NO_X, 	CHECK_ANS_Y, 	false, true, "NO"); 
		if( select == 0 )	m_spSelect.SetLineQuad( INIT_YES_X-12.0f, 	CHECK_ANS_Y+SELECT_GAP_YY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		else				m_spSelect.SetLineQuad( INIT_NO_X-18.0f,  	CHECK_ANS_Y+SELECT_GAP_NY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		m_spSelect.Render();
		break;
		
	case CHECK_MES_SAVEEND:
		m_spBack.SetSprite( 78.625f, 153.3125f, 369.625f, 63.3125f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr( TV_CENTER_X, CHECK_MES_Y(0), 	true, true, "[ԁ@@傤܂B" ); 
		break;
		
	case CHECK_MES_CHECK:
		m_spBack.SetSprite( 78.0f, 154.625f, 369.375f, 83.25f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(0), 	true, true, "߂[[ǁ@@ς[ڂ@" ); 
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(1), 	true, true, "Ȃł" ); 
		break;

	case CHECK_MES_SAVECHECK:
		m_spBack.SetSprite( 78.0f, 154.625f, 369.375f, 112.0f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(0), 	true, true, "[ԁ@イłB" ); 
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(1), 	true, true, "߂[[ǁ@@ς[ڂ@" ); 
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(2), 	true, true, "Ȃł" ); 
		break;
		
	case CHECK_MES_LOADCHECK:
		m_spBack.SetSprite( 78.0f, 154.625f, 369.375f, 112.0f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(0), 	true, true, "[ǁ@イłB" ); 
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(1), 	true, true, "߂[[ǁ@@ς[ڂ@" ); 
		m_pYFont->DrawFSStr( TV_CENTER_X, 	CHECK_MES_Y(2), 	true, true, "Ȃł" ); 
		break;

	case CHECK_MES_LOAD:
		m_spBack.SetSprite( 100.75f, 142.75f, 320.625f, 124.0f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr	( TV_CENTER_X, 	CHECK_MES_Y(0), true, true, "́@Ł[@@[ǁ@܂?" ); 
		m_pYEng->DrawFSStr	( INIT_YES_X, 	CHECK_ANS_Y, 	false, true, "YES" );
		m_pYEng->DrawFSStr	( INIT_NO_X, 	CHECK_ANS_Y, 	false, true, "NO"); 
		if( select == 0 )	m_spSelect.SetLineQuad( INIT_YES_X+SELECT_GAP_YX, 	CHECK_ANS_Y+SELECT_GAP_YY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		else				m_spSelect.SetLineQuad( INIT_NO_X+SELECT_GAP_NX,  	CHECK_ANS_Y+SELECT_GAP_NY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		m_spSelect.Render();
		break;
		
	case CHECK_MES_ENDSAVE_CHECK:
		m_spBack.SetSprite( 110.6875f, 144.75f, 306.0625f, 152.25f, BACK_COLOR );
		m_spBack.Render();
		m_pYFont->DrawFSStr	( TV_CENTER_X, 	CHECK_MES_Y(0), 	true, true, "܂ł́@Ł[@" );
		m_pYFont->DrawFSStr	( TV_CENTER_X, 	CHECK_MES_Y(1), 	true, true, "[ԁ@܂?" );
		m_pYEng->DrawFSStr	( INIT_YES_X, 	CHECK_MES_Y(2.5f), 	false, true, "YES" );
		m_pYEng->DrawFSStr	( INIT_NO_X, 	CHECK_MES_Y(2.5f), 	false, true, "NO"); 
		if( select == 0 )	m_spSelect.SetLineQuad( INIT_YES_X-12.0f, 	CHECK_MES_Y(2.35f), INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		else				m_spSelect.SetLineQuad( INIT_NO_X-18.0f,  	CHECK_MES_Y(2.35f), INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
		m_spSelect.Render();
		break;
	}	
}

//========================================================================
//					G[`FbNp
//========================================================================
void		SK7SaveLoadMessage::RenderCheckFontError( u8 select )
{
	if( m_ucCheckUpNo == CHECK_MESUP_NONE )	return;
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
#if 0
	DEBUG_GET_2D_POS2( m_spBack );
#else
	m_spBack.SetSprite( 148.125f, 251.1875f, 227.3125f, 109.5f, BACK_COLOR );
#endif
	m_spBack.SetVisible( true );
	m_spBack.SetColor( 0xffff00ff );
	m_spBack.Render();
	
	m_pYFont->DrawSetup();
	m_pYFont->SetColor2(0x000000ff);
	switch( m_ucCheckUpNo ){
	case CHECK_MESUP_INIT_CHECK:	m_pYFont->DrawFSStr		( TV_CENTER_X, INIT_CHECK_Y, 	true, true, "傫܂?" ); 	break;
	case CHECK_MESUP_DELETE_CHECK:	m_pYFont->DrawFSStr		( TV_CENTER_X, INIT_CHECK_Y, 	true, true, "債܂?" ); 	break;
	}

	m_pYEng->DrawSetup();
	m_pYEng->SetColor2(0x000000ff);
	m_pYEng->SetExRate( 1.6f );
	m_pYEng->DrawFSStr	( INIT_YES_X, 	INIT_YES_Y, 	false, true, "YES" );
	m_pYEng->DrawFSStr	( INIT_NO_X, 	INIT_NO_Y, 		false, true, "NO");

	if( select == 0 ){
		m_spSelect.SetLineQuad( INIT_YES_X+SELECT_GAP_YX, INIT_YES_Y+SELECT_GAP_YY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
	}else{
		m_spSelect.SetLineQuad( INIT_NO_X+SELECT_GAP_NX, INIT_NO_Y+SELECT_GAP_NY, INIT_ANS_SIZEX, INIT_ANS_SIZEY, SELECT_LINE_COLOR, SELECT_LINE_SIZE );
	}
	m_spSelect.Render();
}

//========================================================================
//					bZ[Wf[^[h
//========================================================================
bool			SK7SaveLoadMessage::LoadMessage()
{
	int i;
	switch( m_eLoadProc ){
	case PROC_MES_PACK:
		if( m_File.OpenDataFile( SAVELOAD_PACK_DATA, &m_pPackData ) ){

			ghmGcMemSetAllocName("SAVEMES");
			m_pTexture = new TEX_DATA[TEX_MAX_NUM];
			ghmGcMemSetAllocName("FONT_DATA_NUM");
			m_pYFont 	= new YK7StrImage;
			ghmGcMemSetAllocName("FONT_DATA_NUM");
			m_pYHira 	= new YK7StrImage;
			ghmGcMemSetAllocName("FONT_DATA_NUM");
			m_pYEng 	= new YK7StrImage;
			ghmGcMemSetAllocName("SAVEMES");
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				return false;
			}
			//	RctHg\[X	---------------------------------------
			m_pYHira->LoadMem( (void*)m_pResLink->GetResource(FONT_SAVELOAD_GC) );
			m_pYFont->LoadMem( (void*)m_pResLink->GetResource(FONT_SAVEFONT_GC) );
			m_pYEng->LoadMem( (void*)m_pResLink->GetResource(FONT_SAVEFONT_GC) );

			//	eNX`[pbN		---------------------------------------
			for( i = 0; i < TEX_MAX_NUM; i++ ){
				if( (m_pTexture[i].Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+FONT_DATA_NUM))==NULL ){
					return false;
				}
				InitTexture( &m_pTexture[i] );
			}

			//	XvCg쐬	------------------------------------------------
			m_spAButton.SetTexSprite( 0, 0, &m_pTexture[TEX_A_BOTTAN], 1, 2, 0 );
			m_spAButton.SetVisible	( false );
			
			m_spChan.SetTexture	( &m_pTexture[TEX_SAVE_LOAD], 1, 2 );
			
			m_spCM.SetTexSprite	( 0, 0, &m_pTexture[TEX_TV] );
			m_spCM.SetVisible	( false );

			for( int i = 0; i < 2; i++ ){
				m_spAB[i].SetTexSprite	( 0, 0, &m_pTexture[TEX_A_B], 1, 2, (u16)i );
				m_spAB[i].SetVisible	( true );
				m_spAB[i].SetEX			( 4.2f );
				m_spAB[i].SetColor		( SLOT_FONT_COLOR );
			}
			m_eLoadProc = PROC_MES_KANA;
		}
		break;

	
	case PROC_MES_KANA:
		if( m_pYKana->LoadCheck() ){
			m_pYFont->SetKanaFont( m_pYKana );
			return true;
		}
		break;
	}
	return false;
}
