////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7ScenarioEnd
//
// SK7ScenarioEnd.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 04/13/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SCENARIOEND_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>

#include "SK7ScenarioEnd.h"
#include "..\Wat\K7App.h"
#include "../matsu/mK7Sound.h"
#include "../wat/WK7EventScript.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7Cam.h"
#include "../wat/K7GlobalFlag.h"

#define	FADE_SPEED				(WK7_SEC_TO_TICK(1.0f))

//========================================================================
//					RXgN^
//========================================================================
SK7ScenarioEnd::SK7ScenarioEnd()
{
	mKan.mSetXY0     (0,0);
	mKan.mSetWH      (0,0);
	mKan.mSetUV0     (0,0);
	mKan.mSetRGBA    (0);
	mKan.mSetDispFlag(false);
	mKanTexture.tex  = NULL;
	mpKanTextureData = NULL;
	mpFile           = NULL;
}


//========================================================================
//					fXgN^
//========================================================================
SK7ScenarioEnd:: ~SK7ScenarioEnd()
{
	Release();
}


//========================================================================
//				[X
//========================================================================
void			SK7ScenarioEnd::Release()
{
	GHMGCMEM_SAFE_FREE(mpKanTextureData);
	GHM_SAFE_DELETE   (mpFile);
}

//========================================================================
//					t[
//========================================================================	 
bool  		SK7ScenarioEnd::FrameProcess(void)
{
	while( mpFile->GetState()!=ghmGcFile::READFINISH ){
		K7SCR_RETSYS();
	}
	mpFile->Close();
	GHM_SAFE_DELETE(mpFile);
	
	switch( GameInfo.GetScenarioFlow() ){
//	case K7SCNF_FUK:	gpSound->mPlaySE( SFX_SCE1_KAN_RAKUJITSUZENPEN );	break;
	case K7SCNF_KAK:	gpSound->mPlayStreamNo( HPS_END_01, 255 );			break;
	case K7SCNF_TXS:	gpSound->mPlayStreamNo( HPS_END_02 );				break;
	case K7SCNF_ISZ:	gpSound->mPlayStreamNo( HPS_KAIKOUEND );			break;
	case K7SCNF_DM1:
	case K7SCNF_DM2:	gpSound->mPlayStreamNo( HPS_END_04 );				break;
	}
	
	//	XvCgZbg	--------------------------------------
	mKanTexture.tex = mpKanTextureData;
	mK7InitTexture (&mKanTexture);
	mKan.mRelateTex(&mKanTexture);
	if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) ){
		mKan.mSetXY0 (220,140);
		mKan.mSetWH  (200,200);
	}else{
		mKan.mSetXY0 (  0,  0);
		mKan.mSetWH  (640,480);
	}
	mKan.mSetUV0 (  0,  0);
	mKan.mSetRGBA(0xffffffff);

	WK7CAM->SetCinemaScopeMode(false);
	switch( GameInfo.GetScenarioFlow() ){
	case K7SCNF_KAK:	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.99f));	break;
	case K7SCNF_TXS:	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.918f));break;
//	case K7SCNF_CUR:	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.33f));	break;
	}
	mKan.mSetDispFlag(true);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(5));
	
	k7app.SetFadeColor(0x00000000);
	k7app.FadeStart(0xff,WK7_SEC_TO_TICK(3));
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	mKan.mSetDispFlag(false);
	
	gpSound->mStopStream();
	K7SCR_RETSYS();
	K7SCR_RETSYS();

	return false;
}


//========================================================================
//					II擾֐ 
//========================================================================	 
bool  		SK7ScenarioEnd::LoadData()
{
	ghmGcMemSetAllocName("SScnEnd");
	while( (mpFile=new ghmGcFile)==NULL ){
		K7SCR_RETSYS();
	}
	char* tblKanFile[]={
		"/Texture/End/tenshi.BIN",
		"/Texture/End/rakujitu00.BIN",
		"/Texture/End/rakujitu01.BIN",
		"/Texture/End/kumo.BIN",
		"/Texture/End/kaikou00.BIN",
		"/Texture/End/kaikou01.BIN",
		"/Texture/End/bunsin00.BIN",
		"/Texture/End/bunsin01.BIN",
		"/Texture/End/egao00.BIN",
		"/Texture/End/egao01.BIN",
		"/Texture/End/End.BIN"
	};
	u8 fileno;
	switch( GameInfo.GetScenarioFlow() ){
	case 	K7SCNF_CEL:
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 ) ){
			fileno = 10;
		}else{
			fileno = 0;
		}
		break;
	case 	K7SCNF_FUK:	fileno = 1;		break;
	case 	K7SCNF_KAK:	fileno = 2;		break;
	case 	K7SCNF_TXS:	fileno = 3;		break;
	case 	K7SCNF_ISZ:	fileno = 4;		break;
	case 	K7SCNF_CUR:	fileno = 5;		break;
	case 	K7SCNF_DM1:	fileno = 6;		break;
	case 	K7SCNF_DM2:	fileno = 7;		break;
	case 	K7SCNF_HT1:	fileno = 8;		break;
	case 	K7SCNF_HT2:	fileno = 9;		break;
//	case 	K7SCNF_GNK:	fileno = 14;	break;
	default:			fileno = 0;		break;
	}
	while( mpFile->Open(tblKanFile[fileno])==false ){
		K7SCR_RETSYS();
	}
	while( (mpKanTextureData=(GhmGcTexHeader *)mpFile->Read())==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool  		SK7ScenarioEnd::LoadDataB()
{
	LoadData();
	while( mpFile->GetState()!=ghmGcFile::READFINISH ){
		K7SCR_RETSYS();
	}
	return true;
}

