////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scenario Task
//
// SK7ScenarioTask.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 09/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SCENARIOTASK_CPP__
//#define	__SCENARIO_MAX__
//#define	__MODELDEBUG__		
//#define	__LINEDEBUG__	

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "SK7Common.h"
#include "SK7ScenarioTask.h"
#include "..\Wat\WK7MenuTask.h"
#include "../wat/WK7Cam.h"
#include "../wat/WK7Light.h"
#include "../wat/K7GlobalFlag.h"
#include "../wat/WK7EventScript.h"
#include "../Yam/YK7EffectHSDead.h"
#include "../fujita/C_Particle.h"
#include "../matsu/mk7Sound.h"
#include "../wat/WK7GameInfo.h"
#include "../wat/WK7MainTask.h"
#include "../wat/WK7Sight.h"
#include "../Yam/YK7Break.h"
#include "../matsu/mK7TitleTask.h"
#include "SK7ChangeDisk.h"
#include "SK7FirstCheck.h"

#define		SIGHT_SIZE				(60)
#define		SCENA_CHARA_NUM			(8)	
#define		SCENA_FIRST_X			(650.0f)
#define		SCENA_FIRST_Y			(35.0f)
#define		SCENA_MINI_CURRENT_X	(300.0f)//(150.0f)
#define		SCENA_CURRENT_X			(20.0f)
#define		SCENA_GAP_Y				(10.0f)
#define		SCENA_SIZE_Y			(60.0f)
#define		SCENA_SPEED_FRAME		(10)//20)
#define		SCENA_MOVE_FRAME		(2)
#define		SCENA_MINI_X			(320.0f)//(470)	//	TCY̎̃TCY

#define		CHARA_HIT_FRAME			(10)
#define		BLOOD_DRAW_TIME 		(20)
#define		REDBOX_X				(586)
#define		REDBOX_X2				(548)
#define		REDBOX_Y				(58)
#define		REDBOX_SIZE				(16)//29)
#define		AKIBA_NO				(7)
#define		SCENARIO_HIT_MOVE_X		(130.0f)
#define		SCENARIO_HIT_MOVE_X2	(110.0f)

#define		SHISHI_X				(560.0f)
#define		SHISHI_MOVE_TIME		(5)
#define		BAR_MOVE_SE_TIME		(4)

#define		BAR_X					(116.0f)
#define		BAR_Y					(35)
#define		TARGET_X				(131.0f)
#define		TARGET_Y				(42)
#define		TARGET_SHIX				(570)
#define		TARGET_SHIY				(349)
#define		SCENO_X					(221.0f)
#define		SCENO_SMALL_X			(380.0f)
#define		SCENO_SHIX				(572.0f)
#define		SCENO_Y					(44)
#define		SCENO_SHI_Y				(320.0f)
#define		DAY_SHIX				(603.0f)
#define		DAY_SHIY				(50.0f)
#define		WAKU_X					(581.0f)
#define		WAKU_X2					(585.0f)
#define 	WAKU_SHIX				(579.0f)
#define		WAKU_SHIX2				(583.0f)
#define		WAKU_Y					(55)
#define		WAKU_Y2					(59)
#define		BAR_HALF_SIZEX			(252.0f)
#define		BAR_SIZEY				(64)
#define		SCE_BAR_GAPY			(70)
#define		NO_GAPX					(159.0f)
#define		SHISHI_MOVE_X			(80)
#define		SHISHI_MOVE_GAPX		(63)
#define		RETITLE_NORMAL_EX		(0.6f)
#define		RETITLE_SIZE_EX			(1.0f)
#define		RETITLE_BAR_Y			(360)
#define		RETITLE_SELECT_COLOR	(0x4040ffff)
#define		RETITLE_NOT_COLOR		(0x909090ff)
#define		RETITLE_GAP_Y			(18)
#define		RETITLE_MES_X			(48)
#define		RETITLE_MES_Y			(347)
#define		RETITLE_SAVE_X			(7)
#define		RETITLE_SAVE_Y			(409)
#define		RETITLE_SAVE2_X			(259)
#define		RETITLE_SAVE2_Y			(409)
#define		RETITLE_MOVE_R			(2.0f)
#define		RETITLE_MOVE_FRAME		(5.0f)
#define		RETITLE_SIZE_MAX		(6.0f)

#ifdef __LINEDEBUG__
static VEC2 	VL={0,0};	
static VEC2		VL2={0,0};
#endif

//	xdr^mn|X
const VEC2 tblYesPos[]={
	393,375,
	441,395,
	472,397,
};
const VEC2 tblNoPos[]={
	519,375,
	574,368,
};

//	Cgݒ 	
static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};
static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// CgN
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// CgtO
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{0xff,0xff,0xff,0xff},						// color	
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};


//========================================================================
//					RXgN^
//========================================================================
SK7ScenarioTask::SK7ScenarioTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	m_sFrameProc 			= FRAME_INIT;
	m_sTexNumber 			= 0;
	m_bBloodFlag			= false;
	m_sOldSenarioNo 		= 0;
	m_bChangeSightFlag 		= false;
	m_bReturnFlag			= false;
	m_bMoveNextFlag			= false;
	m_bSEFlag				= false;
	m_iBloodDrawTime		= 0;
	m_iScenarioTime 		= 0;
	m_iCharaMoveTime		= 0;
	m_iShishiTime			= 0;
	m_iMoveSetTime 			= 0;
	m_iMoveAddTime 			= 0;
	m_iBackTime				= 0;
	m_iSETime				= 0;
	m_pTexture				= NULL;
	m_pResLink	 			= NULL;
	m_pPackData				= NULL;
	m_pSaveCheck			= NULL;
	

	//	NAf[^쐬
	int ClearFlag = (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==true) ? GameInfo.GetClearScenarioID2() : GameInfo.GetClearScenarioID();
	if( ClearFlag >= SCENARIO_MAX_NUM ){
		ClearFlag = SCENARIO_MAX_NUM;
	}	
	
	//	ViINAIǂB
	if( ClearFlag == GameInfo.GetScenarioID() ){
		m_bMoveNextFlag = true;
	}else{
		m_bMoveNextFlag = false;
	}
	//	qoƂ
	if( ClearFlag >= K7SCN05 ){
		m_bMoveNextFlag = false;
	}
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7)==true ){
		ClearFlag = -1;
	}
#ifndef K7APP_MASTER_NINTENDO
	if( HSD_PadGetNormalAnalogR(0) >= 0.3f  ){
		m_iScenarioNum 			= SCENARIO_MAX_NUM;		//	ViǏ
		m_sScenarioNo 			= 0;
		m_bMoveNextFlag = false;
	}else
#endif
	{
		m_iScenarioNum = ClearFlag;
		if( m_iScenarioNum < SCENARIO_MAX_NUM-1 )	m_iScenarioNum+=2;
		else										m_iScenarioNum=SCENARIO_MAX_NUM;
		m_sScenarioNo 			= (s16)(m_iScenarioNum-1);
	}
	if( ClearFlag >= K7SCN06 ){
		m_sScenarioNo = 0;
	}

	for( int a = 0; a < MAX_MODEL_NUM; a++ ){
		m_pArchive[a]		= NULL;			//	A[JCuNX
		m_pMotionArc[a]		= NULL;
		m_pModel[a]			= NULL;			//	fNX
		m_pMotion[a]		= NULL;		
	}
				
	for( int i = 0; i < SCENARIO_MAX_NUM; i++ )	m_Sce[i].pspName = NULL;
	
	memset( &m_bScenarioFlag, false, sizeof(bool)*SCENARIO_MAX_NUM );
	
	m_Blood.SetBloodParam( false );
}	

//========================================================================
//					fXgN^
//========================================================================
SK7ScenarioTask::~SK7ScenarioTask()
{
}


//========================================================================
//					R[obN
//========================================================================
bool SK7ScenarioTask::InitializeCallBack(void)
{
	//	---------	eXgp̏	------------	//
	HSD_VISetClearClr((GXColor){0xff,0xff,0xff,0xff});	

#ifndef	K7APP_MASTER
	ghmGcApp	*pApp = GetApplication();
	OSDebugReport("SK7TestTask Init : DefaultHeap = 0x%08x , TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),sizeof(*this));
#ifndef	USE_ISDOLVIEWER
	pApp->SetEnablePerfMeter (true);
	pApp->SetVisiblePerfMeter(true);
	ghmGcMem::SetRender(true);
#endif
#endif
		
	//	Cg쐬	-----------------------------------
	WK7Light::Create(&dir_light,0xffffffff,0xffffffff);

	//	TCg	----------------------------------
	m_Sight.InitSight();
	
	//	J̃|WV	-------------------------------
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetDesc(NULL);
	WK7CAM->SetPosition(0.0f,0.0f,50.0f);
	WK7CAM->SetTargetPosition(0.0f,0.0f,0.0f);
	
	//	RcGtFNg	---------------------------------
	ghmGcMemSetAllocName("SK7SCENATASK");
	m_pTaskControl = new ghmGcTaskController;
	m_pTaskControl->Initialize();
	EffectInit( m_pTaskControl, 200 );
			
	//	tF[h	------------------------------
	m_spFade.SetSprite	( 0, 0, 640, 480, 0x000000ff );
	m_spFade.SetVisible	(true);
	k7app.FadeStart(0x00,1);			//	CtF[h
	
	//	TEhf[^Ăяo
	gpSound->mReadSsm("seSSelect.ssm",eBankScenario);

	//	`FbN{bNX	-------------------------------------------------
	if( m_iScenarioNum == SCENARIO_MAX_NUM ){
		m_spRedBox.SetSprite( REDBOX_X-SHISHI_MOVE_GAPX, (m_sScenarioNo * SCE_BAR_GAPY)+REDBOX_Y, REDBOX_SIZE, REDBOX_SIZE, 0xd00000ff );
	}else{
		m_spRedBox.SetSprite( REDBOX_X, (m_sScenarioNo * SCE_BAR_GAPY)+REDBOX_Y, REDBOX_SIZE, REDBOX_SIZE, 0xd00000ff );
	}

	//	fE[Vǂݍ	---------------------------------------------
	for( int i = 0; i < MAX_MODEL_NUM; i++ ){
		if( NULL != (m_pArchive[i] = WK7Archive::Create())){
			if( m_iScenarioNum-1 > i ){
				m_pArchive[i]->LoadArchive	( tblModelData[i].Normal );
			}else{
				if( m_iScenarioNum >= 3 && i == AKIBA_NO ){				
					m_pArchive[i]->LoadArchive	( tblModelData[i].Normal );
				}else if( m_iScenarioNum == SCENARIO_MAX_NUM && i == AKIBA_NO-1 ){
					if( (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==true  && GameInfo.GetClearScenarioID2() >= K7SCN06) ||
						(K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==false && GameInfo.GetClearScenarioID() >= K7SCN06))
					{
						m_pArchive[i]->LoadArchive	( tblModelData[i].Normal );	
					}else{
						m_pArchive[i]->LoadArchive	( tblModelData[i].Black );
					}
				}else{
					m_pArchive[i]->LoadArchive	( tblModelData[i].Black );
				}
			}	
		}
		//	[V쐬	----------------------------------
		if( tblMotionData[i]  == NULL ) continue;
		if( NULL != (m_pMotionArc[i] = WK7Archive::Create())){
			m_pMotionArc[i]->LoadArchive	( tblMotionData[i] );
		}
	}
	return true;
}


//========================================================================
//					IR[obN
//========================================================================
bool 	SK7ScenarioTask::TerminateCallBack(void)
{
	//ViIf폜
	for( int i = 0; i < MAX_MODEL_NUM; i++ ){
		GHM_SAFE_DELETE( m_pModel[i] );
		GHM_SAFE_DELETE( m_pMotion[i] );
	}

	GHM_SAFE_DELETE			(m_pResLink);
	GHM_SAFE_DELETE_ARRAY	(m_pTexture);
	GHM_SAFE_DELETE			( m_pSaveCheck );
	for( int i = 0; i < SCENARIO_MAX_NUM; i++ )		GHM_SAFE_DELETE_ARRAY	(m_Sce[i].pspName);
		
	//	ij̍폜
	m_Blood.Delete();

	//	RcGtFNgI
	EffectEnd();
	GHM_SAFE_DELETE(m_pTaskControl);

	// Cg
	WK7Light::Release(0xffffffff,0xffffffff);
	
	s16 scenario = m_sScenarioNo;

	//	TEhf[^Ăяo
	gpSound->mReleaseSsm("seSSelect.ssm");

	if( !m_bReturnFlag ){
		//	V[ֈړ	------------------------------------------
		switch( scenario )
		{
		case 0:	GameInfo.SetScenarioID(K7SCN07);	break;
		case 1:	GameInfo.SetScenarioID(K7SCN01);	break;
		case 2: GameInfo.SetScenarioID(K7SCN02);	break;
		case 3:	GameInfo.SetScenarioID(K7SCN03);	break;
		case 4: GameInfo.SetScenarioID(K7SCN04);	break;
		case 5: GameInfo.SetScenarioID(K7SCN05);	break;
		case 6: GameInfo.SetScenarioID(K7SCN06);	break;
		}
		ghmGcApp *pApp = GetApplication();
		delete this;
		k7app.SetFadeColor(0xff000000);
		k7app.FadeStart(0xff,0);

		//	fBXN`FbN	---------------------------------------
		if( (scenario > 3 && ghmGcFile::GetCurrentDiskID() == 0) ||
			(scenario < 4 && ghmGcFile::GetCurrentDiskID() == 1) )
		{
			new SK7ChangeDisk(pApp);
		}else{
			new WK7MainTask(pApp);
		}
	}else{
		ghmGcApp *pApp = GetApplication();
		delete this;
		GameInfo.SetNewGame( false );
		k7app.FadeStart(0xff,0);
		HSD_VISetClearClr((GXColor){0x00,0x00,0x00,0xff});	
		new MK7TitleTask(pApp);		
	}
	return true;
}


//========================================================================
//					t[
//========================================================================
bool 	SK7ScenarioTask::FrameProcess(void)
{	
	//	
	switch( m_sFrameProc ){
	//
	//	f[^[h
	case FRAME_INIT:
		if( LoadData() ){
			//	Z[u[hptOZbg
			if( (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==true && 
				K7SCR_GET_GLOBAL_FLAG(K7GLFL_SCENARIO_CLEAR)!=true) || 
				
				K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7)==true )
			{
				g_bFirstGameCheck = false;
				m_pSaveCheck->SetCtrlFlag(true);
				m_pSaveCheck->SetRender(true);
				m_sFrameProc = FRAME_CARD_CHECK;
			}else{
				m_sFrameProc = FRAME_OPEN_FADE;
			}
		}
		break;
		
	//
	//	J[h`FbN
	case FRAME_CARD_CHECK:
		m_pSaveCheck->FrameProcess();
		if( !m_pSaveCheck->GetMenuEnd() )	break;	//	[hIĂȂ
		m_sFrameProc = FRAME_OPEN_FADE;
		break;

	//
	//	ŏ̃ubNIN
	case FRAME_OPEN_FADE:
		if( m_spFade.DownAlpha(12) ){
			//	ViIJ̃Zbg
			if( !m_bMoveNextFlag ) gpSound->mPlaySE( SFX_SYS_SCENARIO_1TO6 );
			m_sFrameProc = FRAME_SCENARIO_OPEN;
		}
		break;
		
	//
	//	ViIo
	case FRAME_SCENARIO_OPEN:
		if( m_bMoveNextFlag ){
			if( !m_bSEFlag ){
				if( ++m_iSETime > BAR_MOVE_SE_TIME * GameInfo.GetScenarioID() ){
					gpSound->mPlaySE( SFX_SYS_SCENARIO_1TO6 );
					m_bSEFlag = true;
					m_iSETime = 0;
				}
			}
		}else{
			if( ++m_iSETime > BAR_MOVE_SE_TIME ){
				gpSound->mPlaySE( SFX_SYS_SCENARIO_1TO6 );
				m_iSETime = 0;
			}
		}
		if( MoveScenario() ){
			m_iSETime = 0;
			m_bSEFlag = false;
			SetBackColor( 	tblWashiColor[m_sScenarioNo].Up.r, 	tblWashiColor[m_sScenarioNo].Up.g, 	tblWashiColor[m_sScenarioNo].Up.b, 
							tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b );
			m_Sight.SetSightFirst(m_sScenarioNo);
			if( m_iScenarioNum == SCENARIO_MAX_NUM  ){	//	SNA`FbN
				gpSound->mPlaySE( SFX_SYS_SCENARIO_LION );
				m_sFrameProc = FARME_SHISHI_OPEN;
			}else{
				SetCharactorPos();		//	LN^[|WV
				m_sFrameProc = FRAME_CHARA_MOVE;
			}
		}
		break;
		
	//
	//	VVo
	case FARME_SHISHI_OPEN:
		if( MoveShishi() ){
			SetCharactorPos();		//	LN^[|WV
			m_sFrameProc = FRAME_CHARA_MOVE;
		}
		break;
	
		
	//
	//	LN^[ړ
	case FRAME_CHARA_MOVE:
		MoveBackColor();	//	J[
		MoveScenarioBar();	//	o[̈ړ
		if( MoveSightFirst() ){
			m_sFrameProc = FRAME_MAIN;
		}
		break;
		
	//
	//	C
	case FRAME_MAIN:

#ifdef __MODELDEBUG__
	static bool flag = false;
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
		if( flag ) flag = false;
		else		flag = true;
	}
	if( flag ){
		DEBUG_GET_MODEL_POS( m_pModel[m_sScenarioNo] );
	}else{
		DEBUG_GET_MODEL_POS( m_pModel[AKIBA_NO] );
	}
#endif	
		MoveSightFirst();	//	TCg̈ړ
		MoveScenarioBar();	//	o[̈ړ
		
		//	TCg̈ړ`FbN	:;::::::::::::::::::::::::::::::::::::::::::
		if( m_Sight.GetFirstSightMove() ){
			MoveBackColor();	//	J[
			break;
		}else{
			m_spBack.SetColor( 0, tblWashiColor[m_sScenarioNo].Up.r, tblWashiColor[m_sScenarioNo].Up.g, tblWashiColor[m_sScenarioNo].Up.b, tblWashiColor[m_sScenarioNo].Up.a );
			m_spBack.SetColor( 1, tblWashiColor[m_sScenarioNo].Up.r, tblWashiColor[m_sScenarioNo].Up.g, tblWashiColor[m_sScenarioNo].Up.b, tblWashiColor[m_sScenarioNo].Up.a );
			m_spBack.SetColor( 2, tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b, tblWashiColor[m_sScenarioNo].Down.a );
			m_spBack.SetColor( 3, tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b, tblWashiColor[m_sScenarioNo].Down.a );
		}

#ifdef __MODELDEBUG__
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_START ){
			m_sScenarioNo++;
			SetCheckMoveScenario();		//	ViI
			m_Sight.SetSightFirst(m_sScenarioNo);			//	TCg
			SetCharactorPos();			//	LN^[
		}
		break;
#endif
		
		m_sOldSenarioNo = m_sScenarioNo;

		//				
		if( CheckKeyT( SK7_KEY_UP|SK7_KEY_LEFT ) ){
			if( --m_sScenarioNo < 0 ){
				m_sScenarioNo = 0;
				break;	
			}
			if( m_sFrameProc > FRAME_INIT )	SetCheckMoveScenario();		//	ViI
			m_pModel[m_sOldSenarioNo]->Hide();
			m_pModel[AKIBA_NO]->Hide();
			m_Sight.SetSightFirst(m_sScenarioNo);			//	TCg
			SetCharactorPos();			//	LN^[
			SetBackColor( 	tblWashiColor[m_sScenarioNo].Up.r, 	tblWashiColor[m_sScenarioNo].Up.g, 	tblWashiColor[m_sScenarioNo].Up.b, 
							tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b );
			gpSound->mPlaySE(SFX_SYS_TITLE_ART);
			m_spRedBox.SetFlag( false, RENDER_FLAG );
			break;
		}
		//		E		
		if( CheckKeyT( SK7_KEY_DOWN|SK7_KEY_RIGHT )){
			if( ++m_sScenarioNo > (m_iScenarioNum-1) ){
				m_sScenarioNo = (s16)(m_iScenarioNum-1);
				break;
			}
			if( m_sFrameProc > FRAME_INIT )	SetCheckMoveScenario();		//	ViI
			m_pModel[m_sOldSenarioNo]->Hide();
			m_pModel[AKIBA_NO]->Hide();
			m_Sight.SetSightFirst(m_sScenarioNo);			//	TCg
			SetCharactorPos();			//	LN^[
			SetBackColor( 	tblWashiColor[m_sScenarioNo].Up.r, 	tblWashiColor[m_sScenarioNo].Up.g, 	tblWashiColor[m_sScenarioNo].Up.b, 
							tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b );
			gpSound->mPlaySE(SFX_SYS_TITLE_ART);
			m_spRedBox.SetFlag( false, RENDER_FLAG );
			break;
		}
		//		`{^		
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			m_spRedBox.SetFlag( false, RENDER_FLAG );
			gpSound->mPlaySE(SFX_SYS_GUN_SHOT);
			gpSound->mPlaySE(SFX_SYS_KETTEI);
			gpSound->mPlaySE(SFX_SYS_KETTEI_OPEN);

			m_Sight.SetSightPos( 0, 0 );
			m_Sight.SetFSightEndPos();
			
			SetMoveCharactorPos();		//	LN^[WZbg
			SetBackColor( 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, LINE_AFTER_FRAME*2 ); 	//	wiJ[Zbg
			
			m_sFrameProc = FRAME_HIT_MOVE_SCENARIO;
			break;
		}
		//		B{^		
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			gpSound->mPlaySEP( SFX_SYS_CONTINUE_SELECT, -500 );
			SetReturnVisible( true );
			m_sFrameProc = FRAME_CANCEL_MOVE;
			break;
		}
		break;
		
	//
	//	LZs
	case FRAME_CANCEL_MOVE:
		
		for( int i = 0; i < RETITLE_YES_NUM; i++ ){
			if( i < RETITLE_NO_NUM ){
				MoveYesNo( &m_No[i],	&tblNoPos[i] );
				MoveYesNo( &m_NoS[i], 	&tblNoPos[i] );
			}
			MoveYesNo( &m_Yes[i],	&tblYesPos[i] );
			MoveYesNo( &m_YesS[i], 	&tblYesPos[i] );
		}
		
		
		if( CheckKeyT( SK7_KEY_RIGHT ) ){
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			for( int i = 0; i < RETITLE_NO_NUM; i++ ){
				m_No[i].spBody.SetEX	( RETITLE_SIZE_EX );
				m_NoS[i].spBody.SetEX	( RETITLE_SIZE_EX );
				m_No[i].spBody.SetColor ( RETITLE_SELECT_COLOR );
			}
			for( int i = 0; i < RETITLE_YES_NUM; i++ ){			
				m_Yes[i].spBody.SetEX	( RETITLE_NORMAL_EX );
				m_YesS[i].spBody.SetEX	( RETITLE_NORMAL_EX );
				m_Yes[i].spBody.SetColor( RETITLE_NOT_COLOR );
			}
			break;
		}
		if( CheckKeyT( SK7_KEY_LEFT ) ){
			gpSound->mPlaySE(SFX_SYS_CURSOR);
			for( int i = 0; i < RETITLE_YES_NUM; i++ ){			
				m_Yes[i].spBody.SetEX	( RETITLE_SIZE_EX );
				m_YesS[i].spBody.SetEX	( RETITLE_SIZE_EX );
				m_Yes[i].spBody.SetColor( RETITLE_SELECT_COLOR );
			}
			for( int i = 0; i < RETITLE_NO_NUM; i++ ){
				m_No[i].spBody.SetEX	( RETITLE_NORMAL_EX );
				m_NoS[i].spBody.SetEX	( RETITLE_NORMAL_EX );
				m_No[i].spBody.SetColor	( RETITLE_NOT_COLOR );
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( m_Yes[0].spBody.GetExX() >= RETITLE_NORMAL_EX+0.1f ){
				gpSound->mPlaySE(SFX_SYS_DECIDE);
				SetReturnVisible( false );
				m_bReturnFlag = true;
				gTitleRetFromSSelect = true;
				m_sFrameProc = FRAME_END;
				m_spFade.SetColor(0);
				//	NAtO
				K7SCR_RESET_GLOBAL_FLAG( K7GLFL_SCENARIO_CLEAR );
			}else{
				gpSound->mPlaySE(SFX_SYS_CANCEL);
				SetReturnVisible( false );
				m_sFrameProc = FRAME_MAIN;				
			}
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			gpSound->mPlaySE(SFX_SYS_CANCEL);
			SetReturnVisible( false );
			m_sFrameProc = FRAME_MAIN;
			break;
		}
		break;
		
	//
	//	ViIړ
	case FRAME_HIT_MOVE_SCENARIO:
		MoveBackColor();
		if(	MoveHitScenario(true) ){
			gpSound->mPlaySE(SFX_SYS_SIGHT_LOOP);
			SetSightSize();
			m_Sight.SetLineVertex();
			m_Sight.MoveSightLine(false);
			m_Sight.SetSight2D();
			m_sFrameProc = FRAME_MODEL_VIEW;
		}
		break;
		
	//
	//	ViILړ	
	case FRAME_CHARA_ENTRANCE:
		if( ++m_iCharaMoveTime > CHARA_HIT_FRAME ){
			m_iCharaMoveTime = 0;
			m_sFrameProc = FRAME_MODEL_VIEW;
		}
		break;
	
	//
	//	ViILZړ
	case FRAME_CANCEL_MOVE_SCENARIO:
		MoveBackColor();
		MoveCharactor();
		if( MoveHitScenario(false) ){
			m_spRedBox.SetVisible( true );
			m_sFrameProc = FRAME_MAIN;
		}
		break;
		
	//
	//	f`
	case FRAME_MODEL_VIEW:		
		//	wiJ[
		if( ++m_iBackTime < LINE_AFTER_FRAME ){
			MoveBackColor();
		}else{
			m_iBackTime = LINE_AFTER_FRAME;
			m_spBack.SetColor4( 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff );
		}
		//	ړ	::::::::::::::::::::::::::::::::::::::::::
		f32 MoveX=0, MoveY=0;
		MoveX = HSD_PadGetNormalStickX(0)*0.2f;
		MoveY = HSD_PadGetNormalStickY(0)*0.2f;
		m_Sight.SetSightIncPos( MoveX, MoveY );

		//	ĂȂƂۂ	:::::::::::::::::::::::::::::::::::
		if( MoveX == 0 && MoveY == 0 ){
			m_Sight.MoveStopSight();
		}
		m_Sight.SetSight2D();
		//	TCg̃TCY`FbN	--------------------------------------------
		SetSightSize();
		
		//	Ƃ܂ĂƂ̓	--------------------------------------------
		if( MoveX == 0 && MoveY == 0 ) 	m_Sight.MoveSightLine(false);
		else							m_Sight.MoveSightLine(true);
		
 		//	LZ	--------------------------------------
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_B ){
			gpSound->mStopSE(SFX_SYS_SIGHT_LOOP);
			m_iBackTime = 0;
			m_Sight.SetSight2DPos	( 320, 240 );
			m_Sight.InitSightLine();
			m_pModel[m_sScenarioNo]->SetPosition( tblModelPosFirst[m_sScenarioNo] );
			if( m_sScenarioNo == 1 )		m_pModel[AKIBA_NO]->SetPosition( tblModelPosFirst[AKIBA_NO] );
			SetCharactorPos();
			SetBackColor( 	tblWashiColor[m_sScenarioNo].Up.r, 	tblWashiColor[m_sScenarioNo].Up.g, 	tblWashiColor[m_sScenarioNo].Up.b, 
							tblWashiColor[m_sScenarioNo].Down.r, tblWashiColor[m_sScenarioNo].Down.g, tblWashiColor[m_sScenarioNo].Down.b );
			m_sFrameProc = FRAME_CANCEL_MOVE_SCENARIO;
			break;
		}
		//	fII	::::::::::::::::::::::::::::::::::::::::
		if( HSD_PadGetTrigger(0) & PAD_BUTTON_A ){
			//	f ̃Zbg
			SetBlood(m_sScenarioNo);
			break;
		}
#if 0
		//	ł܂II
		if(m_bBloodFlag){
			m_pModel[m_sScenarioNo]->Hide();
			if( m_sScenarioNo == 1 )	m_pModel[AKIBA_NO]->Hide();
			gpSound->mStopSE(SFX_SYS_SIGHT_LOOP);
			gpSound->mPlaySE(SFX_SYS_TITLE_WAIT);
			gpSound->mPlaySE( SFX_SYS_RIFLE );
			
			m_sFrameProc = FRAME_BLOOD_TIME;
			//	ړWZbg
			m_Blood.SetMojiPoint(m_sScenarioNo);
		}
#endif
		break;
		
	//
	//	̕`掞
	case FRAME_BLOOD_TIME:
		//	wiJ[
		if( ++m_iBackTime < LINE_AFTER_FRAME ){
			MoveBackColor();
		}else{
			m_iBackTime = LINE_AFTER_FRAME;
			m_spBack.SetColor4( 0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff );
		}
		if( ++m_iBloodDrawTime > BLOOD_DRAW_TIME )
		{
			m_iBloodDrawTime = 0;
			m_sFrameProc = FRAME_BLOOD_MOVE;
		}
		break;
		
	//
	//	̈ړ
	case FRAME_BLOOD_MOVE:
		//	̈ړ
		if( m_Blood.MoveBlood(m_sScenarioNo) )
		{
			m_spFade.SetColor(0xff000000);
			m_sFrameProc = FRAME_END;
		}
		break;
	
	//
	//	I
	case FRAME_END:
		int AddTime = 66;
		if( m_bReturnFlag )	AddTime = 10;
		if(m_spFade.AddAlpha((u8)AddTime)){
			gpSound->mStopSE(SFX_SYS_SCENARIO_TITLE);
			if( DeleteTerminate()==true ){
				return true;
			}
		}
		break;
	}
	//	y
	gpSound->mFrameProcess(); 

	// J
	WK7CAM->FrameProcess();

	//	Rc	------------------------------
	SetEffectCamera(WK7CAM->GetCObj());
	PARTICLE.Proc(WK7CAM->GetCObj());
	PARTICLE.Proc(WK7CAM->GetCObj());
	
	// Aj[Vs
	for( int i = 0; i < MAX_MODEL_NUM; i++ ){
		if( m_pModel[i] != NULL )		m_pModel[i]->FrameProcess();
	}
	
	m_pTaskControl->FrameProcess();
	WK7Archive::FrameProcessAll();

	return true;
}


//========================================================================
//					_O
//========================================================================
bool 	SK7ScenarioTask::RenderProcess(void)
{	
	//	I肵
	if( m_sFrameProc > FRAME_INIT  ){
		
		m_spBack.Render();
		
		//	[hύXifwi̐OɁj
		GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

		// JgJݒ
		if(WK7CAM->SetCurrent()==true ){	
			WK7Light::DispStart();
			WK7Light::DispAll();
			WK7Light::DispEnd();
			
			for( int i = 0; i < MAX_MODEL_NUM; i++ ){
				m_pModel[i]->RenderProcess();
			}
			WK7CAM->RenderProcess();
			// JgJł̕`I
			WK7CAM->EndCurrent();	
		}		
		//	TCgh[g[N
		WK7Sight::DrawSyncToken();

		//	V[̖O	-----------------------------------
		for( int i = 0; i < m_iScenarioNum; i++ ){
			m_Sce[i].spBar.Render();
			m_Sce[i].spTarget.Render();
			m_Sce[i].spNo.Render();
			m_Sce[i].spWaku[1].Render();
			m_Sce[i].spWaku[0].Render();
			m_Sce[i].spDay.Render();
			for( int j = 0; j < tblSceNameNum[i]; j++ )	m_Sce[i].pspName[j].Render();
		}
		//	Ԃ{bNX
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_CLEAR );
		m_spRedBox.Render();
		GXSetBlendMode	( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );	
		
		//	C`
		RenderSight();

		//	ǂ
		m_spBar.Render();
		m_spReturnTitle.Render();
		if( !GameInfo.GetNewGame() ){
			m_spSave[0].Render();
			m_spSave[1].Render();
		}
		for( int i = 0; i < RETITLE_YES_NUM; i++ ){
			m_YesS[i].spBody.Render();
		}
		for( int i = 0; i < RETITLE_NO_NUM; i++ ){
			m_NoS[i].spBody.Render();	
		}
		for( int i = 0; i < RETITLE_YES_NUM; i++ ){
			m_Yes[i].spBody.Render();
		}
		for( int i = 0; i < RETITLE_NO_NUM; i++ ){
			m_No[i].spBody.Render();	
		}
				
		//	̕`
		if( m_sFrameProc >= FRAME_BLOOD_TIME ){
			//	̕`	-------------------------------
			if( m_bBloodFlag ){
				m_Blood.DrawBlood();
				m_Blood.DrawBlood2D( (int)m_sScenarioNo );
			}
		
			//	Rc	--------------------------------
			PARTICLE.Disp();
			m_pTaskControl->FrameProcess();
		}
	}
	//	tF[h
	m_spFade.Render(); 

	if( m_sFrameProc == FRAME_CARD_CHECK ){
		if( m_pSaveCheck != NULL )	m_pSaveCheck->RenderProcess();
	}
	
	return true;
}



//
//							SCENARIOp
//

//========================================================================
//					[hf[^
//========================================================================
bool		SK7ScenarioTask::LoadData()
{	
	int i;
	int num=0;
	switch( m_sTexNumber ){
	case 0:
		if( m_File.OpenDataFile( SCENARIO_PACK_DATA, &m_pPackData ) ){
			m_pTexture = new TEX_DATA[SCENARIO_TEX_NUM];
			if( (m_pResLink = new((ghmGcResLink *)m_pPackData) ghmGcResLink)==NULL ){
				return false;
			}
			for( i = 0; i < SCENARIO_MAX_NUM; i++ ){
				m_Blood.ReadKanjiData2( i, (void*)m_pResLink->GetResource(i) );
			}
			for( i = 0; i < SCENARIO_TEX_NUM; i++ ){
				if( (m_pTexture[i].Header = (GhmGcTexHeader*)m_pResLink->GetResource(i+SCENARIO_MAX_NUM))==NULL ){
					return false;
				}
				InitTexture( &m_pTexture[i] );
			}
			m_Blood.LoadTexture2( &m_pTexture[SCE_TEX_BLOODS] );

			int SceNum = m_iScenarioNum;
			if( SceNum == SCENARIO_MAX_NUM ){
				SceNum--;
				//	q̃Zbg
				m_Sce[SCENARIO_MAX_NUM-1].spBar.SetTexture	( &m_pTexture[SCE_TEX_TITTLE_BAR] );
				m_Sce[SCENARIO_MAX_NUM-1].spBar.SetVisible	( true );
				m_Sce[SCENARIO_MAX_NUM-1].spBar.SetColor	( 0x000000ff );
				m_Sce[SCENARIO_MAX_NUM-1].spBar.SetSTTwo	( 0.0f, 1.0f, 1.0f, 0.0f );
				SET_SPRITE_ROT( &m_Sce[SCENARIO_MAX_NUM-1].spBar, 90, 592.0f+SHISHI_MOVE_X, 242.0f, 414.0f, 64.0f );			
				//	^[Qbg
				m_Sce[SCENARIO_MAX_NUM-1].spTarget.SetTexture	( &m_pTexture[SCE_TEX_TARGET] );
				m_Sce[SCENARIO_MAX_NUM-1].spTarget.SetVisible	( true );
				SET_SPRITE_ROT( &m_Sce[SCENARIO_MAX_NUM-1].spTarget, -90, 578.0f+SHISHI_MOVE_X, 392.0f, 86.0f, 16.0f );			
				//	no
				m_Sce[SCENARIO_MAX_NUM-1].spNo.SetTexture		( &m_pTexture[SCE_TEX_T06] );
				m_Sce[SCENARIO_MAX_NUM-1].spNo.SetVisible		( true );
				SET_SPRITE_ROT( &m_Sce[SCENARIO_MAX_NUM-1].spNo, -90, 580.0f+SHISHI_MOVE_X, 333.0f, 26.0f, 16.0f );			
				//	g
				m_Sce[SCENARIO_MAX_NUM-1].spWaku[0].SetTexSprite( WAKU_SHIX+SHISHI_MOVE_X, 	WAKU_Y, 	&m_pTexture[SCE_TEX_BOX] );
				m_Sce[SCENARIO_MAX_NUM-1].spWaku[0].SetVisible	( true );
				m_Sce[SCENARIO_MAX_NUM-1].spWaku[1].SetTexSprite( WAKU_SHIX2+SHISHI_MOVE_X, 	WAKU_Y2, 	&m_pTexture[SCE_TEX_BOX] );
				m_Sce[SCENARIO_MAX_NUM-1].spWaku[1].SetAlpha	( 100 );
				m_Sce[SCENARIO_MAX_NUM-1].spWaku[1].SetVisible	( true );
				//	ɂ
				m_Sce[SCENARIO_MAX_NUM-1].spDay.SetTexSprite	( tblDayX[SCENARIO_MAX_NUM-1]+SHISHI_MOVE_X, DAY_SHIY, &m_pTexture[SCE_TEX_TIME06] );
				m_Sce[SCENARIO_MAX_NUM-1].spDay.SetVisible		( true );
				//	l[
				m_Sce[SCENARIO_MAX_NUM-1].pspName = new SK7Sprite[ tblSceNameNum[SCENARIO_MAX_NUM-1] ];
				for( int j = 0; j < tblSceNameNum[SCENARIO_MAX_NUM-1]; j++ ){
					m_Sce[SCENARIO_MAX_NUM-1].pspName[j].SetTexture( &m_pTexture[tblShishiFontPos[j].TexNo] );
					m_Sce[SCENARIO_MAX_NUM-1].pspName[j].SetVisible	( true );
					SET_SPRITE_ROT( &m_Sce[SCENARIO_MAX_NUM-1].pspName[j], -90, tblShishiFontPos[j].Big.x+SHISHI_MOVE_X, tblShishiFontPos[j].Big.y, tblShishiFontPos[j].Mini.x, tblShishiFontPos[j].Mini.y );			
				}
			}
			for( i = 0; i < SceNum; i++ ){
				if( m_bMoveNextFlag ){
					if( i < m_iScenarioNum-1 ){
						SetScenarioBar( &m_Sce[i], true, i );
					}else{
						SetScenarioBar( &m_Sce[i], false, i );
					}
				}else{
					SetScenarioBar( &m_Sce[i], false, i );
				}
			}
			m_spBack.SetTexSprite	( 0, 0, &m_pTexture[ SCE_TEX_WASHI ] );
//			m_spBack.SetColor4		( 0xf, 0xeff9fdff, 0x46a4e7ff, 0x46a4e7ff );
			m_spBack.SetColor		( 0xffffffff );
			m_spBack.SetFlag		( true, RENDER_FLAG|V4COLOR_FLAG );

			//	^Cg߂
			int PlusY = 0;
			if( GameInfo.GetNewGame() ){
				PlusY = RETITLE_GAP_Y;
			}
			m_spReturnTitle.SetTexSprite( RETITLE_MES_X, RETITLE_MES_Y+PlusY, &m_pTexture[SCE_TEX_RETURN_TITLE] );
			
			for( i = 0; i < RETITLE_YES_NUM; i++ ){
				m_Yes[i].spBody.SetTexSprite		( tblYesPos[i].x, tblYesPos[i].y, &m_pTexture[SCE_TEX_Y+i] );
				m_YesS[i].spBody.SetTexSprite	( tblYesPos[i].x, tblYesPos[i].y, &m_pTexture[SCE_TEX_Y+i] );
				m_YesS[i].spBody.SetColor		( 0x000000a0 );
				SetEffectMove( &m_Yes[i].vSpeed );
				SetEffectMove( &m_YesS[i].vSpeed );
//				m_Yes[i].spBody.SetFlag			( true, CENTER_FLAG );
			}
			for( i = 0; i < RETITLE_NO_NUM; i++ ){
				m_No[i].spBody.SetTexSprite				( tblNoPos[i].x, tblNoPos[i].y, &m_pTexture[SCE_TEX_N+i] );
				m_NoS[i].spBody.SetTexSprite			( tblNoPos[i].x, tblNoPos[i].y, &m_pTexture[SCE_TEX_N+i] );
				m_NoS[i].spBody.SetColor				( 0x000000a0 );
				SetEffectMove( &m_No[i].vSpeed );
				SetEffectMove( &m_NoS[i].vSpeed );
//				m_No[i].spBody.SetFlag				( true, CENTER_FLAG );
			}
			m_spSave[0].SetTexSprite	( RETITLE_SAVE_X, RETITLE_SAVE_Y, &m_pTexture[SCE_TEX_SAVE01] );
			m_spSave[0].SetVisible		( true );
			m_spSave[1].SetTexSprite	( RETITLE_SAVE2_X, RETITLE_SAVE2_Y, &m_pTexture[SCE_TEX_SAVE02] );
			m_spSave[1].SetVisible		( true );
			m_spBar.SetSprite			( 0, RETITLE_BAR_Y, 640, 480-RETITLE_BAR_Y, WK7CAM_DEFAULT_CINEMASCOPE_COLOR );
//			m_spBar.SetFlag				( true, V4COLOR_FLAG );
//			m_spBar.SetColor4			( WK7CAM_DEFAULT_CINEMASCOPE_COLOR-0xff, WK7CAM_DEFAULT_CINEMASCOPE_COLOR-0xff,
//										  WK7CAM_DEFAULT_CINEMASCOPE_COLOR,WK7CAM_DEFAULT_CINEMASCOPE_COLOR );
			SetReturnVisible( false );
			m_sTexNumber++;
		}
		break;
		
	case 1:
		num = 0;
		for( i = 0; i < MAX_MODEL_NUM; i++ ){
			if( m_pModel[i] != NULL ){
				num++;
			}else{
				if( m_pArchive[i]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
					if( (m_pModel[i] = m_pArchive[i]->CreateModel()) != NULL ){
						m_pModel[i]->SetPosition( &tblModelPosFirst[i] );
						m_pModel[i]->SetRotation( &tblModelRotFirst[i] );
						m_pModel[i]->Hide();
						num++;
					}
				}
			}
		}
		if( num == MAX_MODEL_NUM ) m_sTexNumber++;
		break;
		
	case 2:
	 	num=0;
		for( i = 0; i < MAX_MODEL_NUM; i++ ){
			if( tblMotionData[i]  == NULL || m_pMotion[i] != NULL ){
				num++;
				continue;
			}
			if( m_pMotionArc[i]->GetState() == WK7Archive::WK7ARCHIVE_LOADED ){
				if( (m_pMotion[i] = m_pMotionArc[i]->CreateModelMotion()) != NULL ){
					m_pModel[i]->AttachMotion( m_pMotion[i] );
					m_pModel[i]->PlayMotion(0.0f);
					num++;
				}
			}
		}
		if( num == MAX_MODEL_NUM )	m_sTexNumber++;
		break;
		
	case 3: 
		if( EffectSetupCheck() == TRUE ){
			USE_PARTICLE;
			SetEffectCamera( WK7CAM->GetCObj() );
			if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==true ||
				K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7)==true )
			{
				m_pSaveCheck = SK7SaveBase::Create( eBaseKiller8Check );
				m_sTexNumber++;
			}else{
				return true;
			}
		}
		break;
		
	case 4:
		if( m_pSaveCheck->LoadData(LOAD_FONT) ){
			return true;
		}
		break;
	default:		return true;
	}
	return false;
}

//========================================================================
//					o[WZbg
//========================================================================
void		SK7ScenarioTask::SetReturnVisible( bool flag )
{
	int i;
	m_spReturnTitle.SetVisible	( flag );
	for( i = 0; i < RETITLE_YES_NUM; i++ ){
		m_Yes[i].spBody.SetVisible			( flag );
		m_YesS[i].spBody.SetVisible			( flag );
	}
	for( i = 0; i < RETITLE_NO_NUM; i++ ){
		m_No[i].spBody.SetVisible			( flag );
		m_NoS[i].spBody.SetVisible			( flag );
	}
	m_spBar.SetVisible			( flag );
	m_spSave[0].SetVisible			( flag );
	m_spSave[1].SetVisible			( flag );
	if( flag ){
		for( i = 0; i < RETITLE_YES_NUM; i++ ){
			m_Yes[i].spBody.SetColor	( RETITLE_NOT_COLOR );
			m_Yes[i].spBody.SetEX		( RETITLE_NORMAL_EX );
			m_YesS[i].spBody.SetEX		( RETITLE_NORMAL_EX );
		}
		for( i = 0; i < RETITLE_NO_NUM; i++ ){
			m_No[i].spBody.SetEX		( RETITLE_SIZE_EX );
			m_NoS[i].spBody.SetEX		( RETITLE_SIZE_EX );
			m_No[i].spBody.SetColor 	( RETITLE_SELECT_COLOR );
		}
	}
}

//========================================================================
//					o[WZbg
//========================================================================
void		SK7ScenarioTask::SetScenarioBar( TITLE_BAR* pSce, bool next, int No )
{
	f32 x,y;
	f32 PlusX = ((640.0f/SCENA_SPEED_FRAME)*(SCENA_MOVE_FRAME*No));
	f32 NextX = ( next==true ) ? 0 : 640.0f;

	if( next ){
		if( GameInfo.GetScenarioID() == No ){
			x = BAR_X;
			y = BAR_Y+SCE_BAR_GAPY*No;
			pSce->spBar.SetTexSpriteTwo	( x, y, x+BAR_HALF_SIZEX*2, y+BAR_SIZEY, &m_pTexture[SCE_TEX_TITTLE_BAR] );
			pSce->spBar.SetVisible		( true );
			pSce->spBar.SetColor		( 0x000000ff );
			//	^[Qbg
			pSce->spTarget.SetTexSprite	( TARGET_X, TARGET_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_TARGET] );
			pSce->spTarget.SetVisible	( true );
			pSce->spTarget.SetAlpha		( 0xff );
			//	no
			pSce->spNo.SetTexSprite		( SCENO_X, SCENO_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_T00+No] );
			pSce->spNo.SetVisible		( true );

			pSce->pspName = new SK7Sprite[ tblSceNameNum[No] ];
			const SCE_FONT_STATE* pSF = tblScenarioFontPos[No];
			for( int j = 0; j < tblSceNameNum[No]; j++ ){
				pSce->pspName[j].SetTexSprite( pSF[j].Big.x, pSF[j].Mini.y+SCE_BAR_GAPY*No, &m_pTexture[pSF[j].TexNo] );
				pSce->pspName[j].SetVisible	( true );
			}
		}else{
			x = (BAR_X+BAR_HALF_SIZEX);
			y = BAR_Y+SCE_BAR_GAPY*No;
			pSce->spBar.SetTexSpriteTwo	( x, y, x+BAR_HALF_SIZEX, y+BAR_SIZEY, &m_pTexture[SCE_TEX_TITTLE_BAR] );
			pSce->spBar.SetVisible		( true );
			pSce->spBar.SetColor		( 0x000000ff );
			//	^[Qbg
			pSce->spTarget.SetTexSprite	( TARGET_X+NO_GAPX, TARGET_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_TARGET] );
			pSce->spTarget.SetVisible	( true );
			pSce->spTarget.SetAlpha		( 0x00 );
			//	no
			pSce->spNo.SetTexSprite		( SCENO_SMALL_X, SCENO_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_T00+No] );
			pSce->spNo.SetVisible		( true );

			pSce->pspName = new SK7Sprite[ tblSceNameNum[No] ];
			const SCE_FONT_STATE* pSF = tblScenarioFontPos[No];
			for( int j = 0; j < tblSceNameNum[No]; j++ ){
				pSce->pspName[j].SetTexSprite( pSF[j].Mini.x, pSF[j].Mini.y+SCE_BAR_GAPY*No, &m_pTexture[pSF[j].TexNo] );
				pSce->pspName[j].SetVisible	( true );
			}
		}
		//	g
		pSce->spWaku[0].SetTexSprite	( WAKU_X, 	WAKU_Y+SCE_BAR_GAPY*No, 	&m_pTexture[SCE_TEX_BOX] );
		pSce->spWaku[0].SetVisible		( true );
		pSce->spWaku[1].SetTexSprite	( WAKU_X2, 	WAKU_Y2+SCE_BAR_GAPY*No, &m_pTexture[SCE_TEX_BOX] );
		pSce->spWaku[1].SetAlpha		( 80 );
		pSce->spWaku[1].SetVisible		( true );
		//	ɂ
		pSce->spDay.SetTexSprite		( tblDayX[No], 40+SCE_BAR_GAPY*No, &m_pTexture[SCE_TEX_TIME00+No] );
		pSce->spDay.SetVisible			( true );
	}else{
		x = (BAR_X+BAR_HALF_SIZEX) + NextX + PlusX;
		y = BAR_Y+SCE_BAR_GAPY*No;
		pSce->spBar.SetTexSpriteTwo	( x, y, x+BAR_HALF_SIZEX, y+BAR_SIZEY, &m_pTexture[SCE_TEX_TITTLE_BAR] );
		pSce->spBar.SetVisible		( true );
		pSce->spBar.SetColor		( 0x000000ff );
		//	^[Qbg
		pSce->spTarget.SetTexSprite	( TARGET_X+NO_GAPX, TARGET_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_TARGET] );
		pSce->spTarget.SetVisible	( true );
		pSce->spTarget.SetAlpha		( 0x00 );
		//	no
		pSce->spNo.SetTexSprite		( SCENO_SMALL_X+NextX+PlusX, SCENO_Y+No*SCE_BAR_GAPY, &m_pTexture[SCE_TEX_T00+No] );
		pSce->spNo.SetVisible		( true );
		//	g
		pSce->spWaku[0].SetTexSprite	( WAKU_X+NextX+PlusX, 	WAKU_Y+SCE_BAR_GAPY*No, 	&m_pTexture[SCE_TEX_BOX] );
		pSce->spWaku[0].SetVisible		( true );
		pSce->spWaku[1].SetTexSprite	( WAKU_X2+NextX+PlusX, 	WAKU_Y2+SCE_BAR_GAPY*No, &m_pTexture[SCE_TEX_BOX] );
		pSce->spWaku[1].SetAlpha		( 80 );
		pSce->spWaku[1].SetVisible		( true );
		//	ɂ
		pSce->spDay.SetTexSprite		( tblDayX[No]+NextX+PlusX, 40+SCE_BAR_GAPY*No, &m_pTexture[SCE_TEX_TIME00+No] );
		pSce->spDay.SetVisible			( true );
		pSce->pspName = new SK7Sprite[ tblSceNameNum[No] ];
		const SCE_FONT_STATE* pSF = tblScenarioFontPos[No];
		for( int j = 0; j < tblSceNameNum[No]; j++ ){
			pSce->pspName[j].SetTexSprite( pSF[j].Mini.x+NextX+PlusX, pSF[j].Mini.y+SCE_BAR_GAPY*No, &m_pTexture[pSF[j].TexNo] );
			pSce->pspName[j].SetVisible	( true );
		}
	}
}

//========================================================================
//					J[ړZbg
//========================================================================
void		SK7ScenarioTask::SetBackColor( u8 SetRU, u8 SetGU, u8 SetBU, u8 SetRD, u8 SetGD, u8 SetBD, u8 Frame )
{
	m_UpColor.r 	= (u8)((SetRU - m_spBack.GetColorR(0))/Frame);
	m_UpColor.g 	= (u8)((SetGU - m_spBack.GetColorG(0))/Frame);
	m_UpColor.b 	= (u8)((SetBU - m_spBack.GetColorB(0))/Frame);
	m_DownColor.r 	= (u8)((SetRD - m_spBack.GetColorR(2))/Frame);
	m_DownColor.g 	= (u8)((SetGD - m_spBack.GetColorG(2))/Frame);
	m_DownColor.b 	= (u8)((SetBD - m_spBack.GetColorB(2))/Frame);
}

//========================================================================
//					J[ړ[u
//========================================================================
void		SK7ScenarioTask::MoveBackColor()
{
	m_spBack.SetColor( 0, (u8)(m_spBack.GetColorR(0)+m_UpColor.r), 		(u8)(m_spBack.GetColorG(0)+m_UpColor.g), 	(u8)(m_spBack.GetColorB(0)+m_UpColor.b), 	0xff );
	m_spBack.SetColor( 1, (u8)(m_spBack.GetColorR(0)+m_UpColor.r), 		(u8)(m_spBack.GetColorG(0)+m_UpColor.g), 	(u8)(m_spBack.GetColorB(0)+m_UpColor.b), 	0xff );
	m_spBack.SetColor( 2, (u8)(m_spBack.GetColorR(2)+m_DownColor.r), 	(u8)(m_spBack.GetColorG(2)+m_DownColor.g), 	(u8)(m_spBack.GetColorB(2)+m_DownColor.b), 	0xff );
	m_spBack.SetColor( 3, (u8)(m_spBack.GetColorR(2)+m_DownColor.r), 	(u8)(m_spBack.GetColorG(2)+m_DownColor.g), 	(u8)(m_spBack.GetColorB(2)+m_DownColor.b), 	0xff );
}

//========================================================================
//					ViȊI𓮂Zbg
//========================================================================
void		SK7ScenarioTask::SetCheckMoveScenario()
{
	if( m_iScenarioNum == SCENARIO_MAX_NUM ){
		if( m_sOldSenarioNo == SCENARIO_MAX_NUM-1 ) return;
#if 0
		m_spScene[m_sOldSenarioNo].SetXYTwo(	SCENA_MINI_CURRENT_X-SHISHI_MOVE_X, 
											m_spScene[m_sOldSenarioNo].GetY0(),
											m_spScene[m_sOldSenarioNo].GetX1(),
											m_spScene[m_sOldSenarioNo].GetY2() );
#endif
	}else{
#if 0
		m_spScene[m_sOldSenarioNo].SetXYTwo(	SCENA_MINI_CURRENT_X, 
											m_spScene[m_sOldSenarioNo].GetY0(),
											m_spScene[m_sOldSenarioNo].GetX1(),
											m_spScene[m_sOldSenarioNo].GetY2() );
#endif
	}
}

//========================================================================
//					LN^[̈ړÕ|WVݒ
//========================================================================
void		SK7ScenarioTask::SetCharactorPos()
{
	Vec vCharaPos;
			
	//	`	-------------------------------------
	m_pModel[m_sScenarioNo]->Disp();
	m_pModel[m_sScenarioNo]->GetPosition( vCharaPos );
	m_pModel[m_sScenarioNo]->SetPosition( vCharaPos.x+tblModelMovePos[m_sScenarioNo].x , vCharaPos.y+tblModelMovePos[m_sScenarioNo].y, vCharaPos.z );
	m_pModel[m_sScenarioNo]->SetRotation( tblModelRotFirst[m_sScenarioNo] );

	//	ViIPl
	if( m_sScenarioNo == 1 ){
		m_pModel[AKIBA_NO]->Disp();
		m_pModel[AKIBA_NO]->GetPosition( vCharaPos );
		m_pModel[AKIBA_NO]->SetPosition( vCharaPos.x+tblModelMovePos[AKIBA_NO].x , vCharaPos.y+tblModelMovePos[AKIBA_NO].y, vCharaPos.z );
		m_pModel[AKIBA_NO]->SetRotation( tblModelRotFirst[AKIBA_NO] );
		if( m_iScenarioNum >= 3 ){
			m_pModel[AKIBA_NO]->GetObj("AKI_Face1")->Hide(false, true);
			m_pModel[AKIBA_NO]->GetObj("AKI_Face2")->Hide(false, true);
			m_pModel[AKIBA_NO]->GetObj("AKI_Face3")->Hide(false, true);
		}
	}
}


//========================================================================
//					LN^[̃|WVݒ
//========================================================================
void		SK7ScenarioTask::SetMoveCharactorPos()
{
	m_pModel[m_sScenarioNo]->SetPosition( tblModelPos[m_sScenarioNo].x, tblModelPos[m_sScenarioNo].y, tblModelPos[m_sScenarioNo].z );
	m_pModel[m_sScenarioNo]->SetRotation( tblModelRot[m_sScenarioNo].x, tblModelRot[m_sScenarioNo].y, tblModelRot[m_sScenarioNo].z );

	//	ViIPl
	if( m_sScenarioNo == 1 ){
		m_pModel[AKIBA_NO]->SetPosition( tblModelPos[AKIBA_NO].x, tblModelPos[AKIBA_NO].y, tblModelPos[AKIBA_NO].z );
		m_pModel[AKIBA_NO]->SetRotation( tblModelRot[AKIBA_NO].x, tblModelRot[AKIBA_NO].y, tblModelRot[AKIBA_NO].z );
	}
}


//========================================================================
//					LN^[̈ړ
//========================================================================
bool		SK7ScenarioTask::MoveCharactor()
{
	Vec vCharaPos;
	
	m_pModel[m_sScenarioNo]->GetPosition( vCharaPos );
	m_pModel[m_sScenarioNo]->SetPosition( vCharaPos.x - (tblModelMovePos[m_sScenarioNo].x / LINE_AFTER_FRAME),
										 vCharaPos.y - (tblModelMovePos[m_sScenarioNo].y / LINE_AFTER_FRAME),
										 vCharaPos.z );
	if( m_sScenarioNo == 1 ){
		m_pModel[AKIBA_NO]->GetPosition( vCharaPos );
		m_pModel[AKIBA_NO]->SetPosition( vCharaPos.x - (tblModelMovePos[AKIBA_NO].x / LINE_AFTER_FRAME),
										 vCharaPos.y - (tblModelMovePos[AKIBA_NO].y / LINE_AFTER_FRAME),
										 vCharaPos.z );
	}
	if( ++m_iCharaMoveTime >= LINE_AFTER_FRAME ){
		m_iCharaMoveTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					ViIf[^̌ړ
//========================================================================
bool		SK7ScenarioTask::MoveHitScenario( bool State )
{
	f32 fMoveHit_x, fMove_x;
	m_iScenarioTime++;

	if( State ){
		fMoveHit_x 	= -SCENARIO_HIT_MOVE_X;
		fMove_x		= SCENARIO_HIT_MOVE_X;
	}else{
		fMoveHit_x 	= SCENARIO_HIT_MOVE_X;
		fMove_x		= -SCENARIO_HIT_MOVE_X;
	}
#if 0
	m_spScene[m_sScenarioNo].SetIncX( fMoveHit_x );
#endif
#if 0
	for( int i = 0; i < m_iScenarioNum; i++ ){
		if( m_sScenarioNo != i ){
			m_spScene[i].SetIncX( fMove_x );
		}
	}
#endif

	m_Sce[m_sScenarioNo].spBar.SetIncX		( fMoveHit_x );
	m_Sce[m_sScenarioNo].spNo.SetIncX		( fMoveHit_x );
	m_Sce[m_sScenarioNo].spWaku[0].SetIncX	( fMoveHit_x );
	m_Sce[m_sScenarioNo].spWaku[1].SetIncX	( fMoveHit_x );
	m_Sce[m_sScenarioNo].spDay.SetIncX		( fMoveHit_x );
	m_Sce[m_sScenarioNo].spTarget.SetIncX	( fMoveHit_x );
	for( int j = 0; j < tblSceNameNum[m_sScenarioNo]; j++ )		m_Sce[m_sScenarioNo].pspName[j].SetIncX( fMoveHit_x );
	
	for( int i = 0; i < m_iScenarioNum; i++ ){
		if( m_sScenarioNo != i ){
			m_Sce[i].spBar.SetIncX		( fMove_x );
			m_Sce[i].spNo.SetIncX		( fMove_x );
			m_Sce[i].spWaku[0].SetIncX	( fMove_x );
			m_Sce[i].spWaku[1].SetIncX	( fMove_x );
			m_Sce[i].spDay.SetIncX		( fMove_x );
			m_Sce[i].spTarget.SetIncX	( fMove_x );
			for( int j = 0; j < tblSceNameNum[i]; j++ )		m_Sce[i].pspName[j].SetIncX( fMove_x );
		}
	}

	if( m_iScenarioTime >= LINE_AFTER_FRAME ){
		m_iScenarioTime = 0;
		return true;	
	}
	return false;
}

//========================================================================
//					ViI̓
//========================================================================
bool		SK7ScenarioTask::MoveScenario()
{
	m_iScenarioTime++;
	
	f32 MoveSpeed = -640.0f/SCENA_SPEED_FRAME;
	
	int SceNum = m_iScenarioNum;
	if( SceNum == SCENARIO_MAX_NUM ) SceNum = SCENARIO_MAX_NUM-1;
	
	for( int i = 0; i < SceNum; i++ ){
		if( m_bScenarioFlag[i] ) continue;
		if( m_bMoveNextFlag && i < SceNum-1 )	continue;
		m_Sce[i].spBar.SetIncX		( MoveSpeed );
		m_Sce[i].spNo.SetIncX		( MoveSpeed );
		m_Sce[i].spWaku[0].SetIncX	( MoveSpeed );
		m_Sce[i].spWaku[1].SetIncX	( MoveSpeed );
		m_Sce[i].spDay.SetIncX		( MoveSpeed );
		for( int j = 0; j < tblSceNameNum[i]; j++ )		m_Sce[i].pspName[j].SetIncX( MoveSpeed );
		
		if( m_iScenarioTime >= SCENA_SPEED_FRAME+i*SCENA_MOVE_FRAME ){
			m_bScenarioFlag[i] = true;
			if( m_bScenarioFlag[SceNum-1] ){
				m_iScenarioTime = 0;
				memset( &m_bScenarioFlag, false, sizeof( bool )*SCENARIO_MAX_NUM );
				return true;
			}
		}
	}
	return false;
}

//========================================================================
//					qoꓮ
//========================================================================
bool 		SK7ScenarioTask::MoveShishi()
{
	int j;
	f32 MoveSpeed = -SHISHI_MOVE_GAPX/SHISHI_MOVE_TIME;
	f32 MoveSpeed2 = -SHISHI_MOVE_X/SHISHI_MOVE_TIME;
	
	for( int i = 0; i < SCENARIO_MAX_NUM-1; i++ ){
		m_Sce[i].spBar.SetIncX		( MoveSpeed );
		m_Sce[i].spNo.SetIncX		( MoveSpeed );
		m_Sce[i].spWaku[0].SetIncX	( MoveSpeed );
		m_Sce[i].spWaku[1].SetIncX	( MoveSpeed );
		m_Sce[i].spTarget.SetIncX	( MoveSpeed );
		m_Sce[i].spDay.SetIncX		( MoveSpeed );
		for( j = 0; j < tblSceNameNum[i]; j++ )		m_Sce[i].pspName[j].SetIncX( MoveSpeed );
	}
	m_Sce[SCENARIO_MAX_NUM-1].spBar.SetIncX		( MoveSpeed2 );
	m_Sce[SCENARIO_MAX_NUM-1].spNo.SetIncX		( MoveSpeed2 );
	m_Sce[SCENARIO_MAX_NUM-1].spWaku[0].SetIncX	( MoveSpeed2 );
	m_Sce[SCENARIO_MAX_NUM-1].spWaku[1].SetIncX	( MoveSpeed2 );
	m_Sce[SCENARIO_MAX_NUM-1].spTarget.SetIncX	( MoveSpeed2 );
	m_Sce[SCENARIO_MAX_NUM-1].spDay.SetIncX		( MoveSpeed2 );
	for( j = 0; j < tblSceNameNum[SCENARIO_MAX_NUM-1]; j++ )		m_Sce[SCENARIO_MAX_NUM-1].pspName[j].SetIncX( MoveSpeed2 );
	
	//q̈ړ	---------------------------------------------------
	if( ++m_iShishiTime >= SHISHI_MOVE_TIME ){
		m_iShishiTime = 0;
		return true;
	}
	return false;
}

//========================================================================
//					
//========================================================================
void		SK7ScenarioTask::SetBlood(int sNo)
{
	const u16 tblBloodNum[]={15,10,20,30,10,33,5};
	//	蔻	-------------------------- 
	u32 ZBuff;
	if( !(m_Sight.GetSight2DPos()->x < 640.0f && m_Sight.GetSight2DPos()->x > 0.0f &&
			m_Sight.GetSight2DPos()->y < 480.0f && m_Sight.GetSight2DPos()->y > 0.0f ))
		return;
		
//	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
	
	GXPeekZ((u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &ZBuff);
//	GXPeekARGB( (u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &CBuff );

	//	obNobt@ȂƂ
	if( ZBuff != 0x00ffffff )
	{	
		//	W擾̂߂ɕ`
		m_bBloodFlag = true;
		
		if( sNo == 1 ){
			m_Blood.CreateBloodObject( m_pModel[m_sScenarioNo], m_pModel[AKIBA_NO] , tblBloodNum[sNo], 1.0f );
		}
		else{
			m_Blood.CreateBloodObject( m_pModel[m_sScenarioNo], NULL, tblBloodNum[sNo], 1.0f );
		}
		m_pModel[m_sScenarioNo]->Hide();
		if( m_sScenarioNo == 1 )	m_pModel[AKIBA_NO]->Hide();
		gpSound->mStopSE(SFX_SYS_SIGHT_LOOP);
		gpSound->mPlaySE(SFX_SYS_TITLE_WAIT);
		gpSound->mPlaySE( SFX_SYS_RIFLE );
		
		m_sFrameProc = FRAME_BLOOD_TIME;
		//	ړWZbg
		m_Blood.SetMojiPoint(m_sScenarioNo);
	}
}


//========================================================================
//					TCgTCY`FbN
//========================================================================
void		SK7ScenarioTask::SetSightSize()
{
	u32 ZBuff;
	
//	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
	
	GXPeekZ((u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &ZBuff);
//	GXPeekARGB( (u16)m_Sight.GetSight2DPos()->x, (u16)m_Sight.GetSight2DPos()->y, &CBuff );

	//	TCY	
	ZBuff &= 0x00ffffff;
	if( ZBuff == 0x00ffffff )	m_Sight.SetSightSize( SIGHT_SIZE/2 );
	else						m_Sight.SetSightSize( SIGHT_SIZE );
}


//========================================================================
//					TCg̕`
//========================================================================
void		SK7ScenarioTask::RenderSight()
{
	//	JZbg
	m_Sight.SetSightCamera();	
	m_Sight.SetAlphaSight();
	
	switch( m_sFrameProc )
	{
	
	//	ŏ̑Î
	case FRAME_SCENARIO_OPEN:
	case FRAME_CHARA_MOVE:
	case FRAME_MAIN:
	case FRAME_CANCEL_MOVE:
		//	TCg
		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, GX_LO_CLEAR );
		GXSetColorUpdate( GX_TRUE );
		for( int i = 0; i < LINE_AFTER_NUM; i++ )
		{
			m_Sight.RenderSightDataFirst( i, m_iScenarioNum, m_sScenarioNo );
		}
		m_Sight.RenderSightFuta((s16)m_iScenarioNum, m_sScenarioNo );
		break;
		
	//	^Cg
	case FRAME_MODEL_VIEW:
		GXSetBlendMode	( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );	
		m_Sight.RenderSight3D(&m_pTexture[SCE_TEX_SIGHT]);
		m_Sight.RenderSight2D();
		break;
	}
}


//========================================================================
//					ViIo[̈ړ
//========================================================================
void		SK7ScenarioTask::MoveScenarioBar()
{

	int SceNum = m_iScenarioNum;
	f32 PlusX = 0;
	if( m_iScenarioNum == SCENARIO_MAX_NUM ){
		SceNum = SCENARIO_MAX_NUM-1;
		PlusX = -SHISHI_MOVE_GAPX;
	}
	int i,j;
	for( i = 0; i < SceNum; i++ ){
		const SCE_FONT_STATE* pSF = tblScenarioFontPos[i];
		if( m_sScenarioNo != i ){
			m_Sce[i].spBar.SetIncXLeft	( BAR_HALF_SIZEX/LINE_AFTER_FRAME );
			if( m_Sce[i].spBar.GetX0() > BAR_X+BAR_HALF_SIZEX+PlusX ){
				m_Sce[i].spBar.SetX0( BAR_X+BAR_HALF_SIZEX+PlusX );
				m_Sce[i].spBar.SetX2( BAR_X+BAR_HALF_SIZEX+PlusX );
			}
			m_Sce[i].spNo.SetIncX		( NO_GAPX/LINE_AFTER_FRAME );
			if( m_Sce[i].spNo.GetX0() > SCENO_SMALL_X+PlusX ){
				m_Sce[i].spNo.SetX0( SCENO_SMALL_X+PlusX );
				m_Sce[i].spNo.SetX2( SCENO_SMALL_X+PlusX );
			}
			m_Sce[i].spTarget.SetIncX( NO_GAPX/LINE_AFTER_FRAME );
			if( m_Sce[i].spTarget.GetX0() > TARGET_X+NO_GAPX+PlusX ){
				m_Sce[i].spTarget.SetX0( TARGET_X+NO_GAPX+PlusX );
				m_Sce[i].spTarget.SetX2( TARGET_X+NO_GAPX+PlusX );
			}
			m_Sce[i].spTarget.DownAlpha(LINE_AFTER_FRAME);
			for( j = 0; j < tblSceNameNum[i]; j++ ){
				m_Sce[i].pspName[j].SetIncX( (pSF[j].Mini.x-pSF[j].Big.x)/LINE_AFTER_FRAME );
				if( m_Sce[i].pspName[j].GetX0() > pSF[j].Mini.x+PlusX ){
					m_Sce[i].pspName[j].SetX0( pSF[j].Mini.x+PlusX );
				}
			}
		}else{
			m_Sce[i].spBar.SetIncXLeft	( -BAR_HALF_SIZEX/LINE_AFTER_FRAME );
			if( m_Sce[i].spBar.GetX0() < BAR_X+PlusX ){
				m_Sce[i].spBar.SetX0( BAR_X+PlusX );
				m_Sce[i].spBar.SetX2( BAR_X+PlusX );
			}
			m_Sce[i].spNo.SetIncX		( -NO_GAPX/LINE_AFTER_FRAME );
			if( m_Sce[i].spNo.GetX0() < SCENO_X+PlusX ){
				m_Sce[i].spNo.SetX0( SCENO_X+PlusX );
				m_Sce[i].spNo.SetX2( SCENO_X+PlusX );
			}
			m_Sce[i].spTarget.SetIncX( -NO_GAPX/LINE_AFTER_FRAME );
			if( m_Sce[i].spTarget.GetX0() < TARGET_X+PlusX ){
				m_Sce[i].spTarget.SetX0( TARGET_X+PlusX );
				m_Sce[i].spTarget.SetX2( TARGET_X+PlusX );
			}
			m_Sce[i].spTarget.AddAlpha(LINE_AFTER_FRAME);
			
			for( j = 0; j < tblSceNameNum[i]; j++ ){
				m_Sce[i].pspName[j].SetIncX( (pSF[j].Big.x-pSF[j].Mini.x)/LINE_AFTER_FRAME );
				if( m_Sce[i].pspName[j].GetX0() < pSF[j].Big.x+PlusX ){
					m_Sce[i].pspName[j].SetX0( pSF[j].Big.x+PlusX );
				}
			}
		}
	}
}


//========================================================================
//					TCg̒_ݒ
//========================================================================
bool		SK7ScenarioTask::MoveSightFirst()
{	
	if( m_Sight.GetFirstSightMove() ){
		//	LN^[̈ړ
		MoveCharactor();
		
		if( m_Sight.MoveFSight() ){
			if( m_iScenarioNum == SCENARIO_MAX_NUM ){
				if( m_sScenarioNo != SCENARIO_MAX_NUM-1 ){
					m_spRedBox.SetXY0		( REDBOX_X-SHISHI_MOVE_GAPX, (m_sScenarioNo * SCE_BAR_GAPY)+REDBOX_Y );
					m_spRedBox.SetTwoSize	( REDBOX_SIZE, REDBOX_SIZE );
				}else{
					m_spRedBox.SetXY0		( REDBOX_X-2, REDBOX_Y );
					m_spRedBox.SetTwoSize	( REDBOX_SIZE, REDBOX_SIZE );
				}
			}else{
				m_spRedBox.SetXY0		( REDBOX_X, (m_sScenarioNo * SCE_BAR_GAPY)+REDBOX_Y );
			}
			m_spRedBox.SetVisible	( true );
			return true;
		}
	}else{
		if( !m_Sight.MoveFSightZan() )	return false;
	}
	return false;
}


//========================================================================
//					̈ړ
//========================================================================
void		SK7ScenarioTask::MoveYesNo( RETITLE_YESNO* pData, const VEC2 *pSide )
{
	bool MoveFlag=false;
	Vec vPos = *pData->spBody.GetPos0();
	vPos.x += pData->vSpeed.x;
	vPos.y += pData->vSpeed.y;

	if( vPos.x > pSide->x+RETITLE_SIZE_MAX ){
		vPos.x = pSide->x+RETITLE_SIZE_MAX;
		MoveFlag = true;
	}
	if( vPos.x < pSide->x-RETITLE_SIZE_MAX ){
		vPos.x = pSide->x-RETITLE_SIZE_MAX;
		MoveFlag = true;
	}
	if( vPos.y > pSide->y+RETITLE_SIZE_MAX ){
		vPos.y = pSide->y+RETITLE_SIZE_MAX;
		MoveFlag = true;
	}
	if( vPos.y < pSide->y-RETITLE_SIZE_MAX ){
		vPos.y = pSide->y-RETITLE_SIZE_MAX;
		MoveFlag = true;
	}
	if( MoveFlag ){
		SetEffectMove( &pData->vSpeed );
	}
	pData->spBody.SetXY0( vPos.x, vPos.y );
}

//========================================================================
//					̈ړGtFNgZbg
//========================================================================
void		SK7ScenarioTask::SetEffectMove( VEC2 *pVec )
{
	f32 SpeedAngle;
	SpeedAngle = MTXDegToRad(rand()%360);
	pVec->x = (RETITLE_MOVE_R*cosf(SpeedAngle))/RETITLE_MOVE_FRAME;
	pVec->y = (RETITLE_MOVE_R*sinf(SpeedAngle))/RETITLE_MOVE_FRAME;
}

