////////////////////////////////////////////////////////////////////////////////
//
// Killer7 blood
//
// SK7Sight.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SIGHT_CPP__

#include "../matsu/mk7Sound.h"
#include "SK7Sight.h"
#include "SK7ScenarioData.h"
#include "../wat/WK7Cam.h"

#define		STOP_LINE_FRAME			(3)
#define		STOP_LINE_R				(0.04f)
#define		SIDE_NUM				(30)
#define		SIGHT_R					(0.15f)
#define		SIGHT_SIDE_X			(10.8f)
#define		SIGHT_SIDE_Y			(8.4f)
#define		LINE_R					(800.0f)
#define		FRONT_FIRST_X			(8.412497f-19.06805f)// 	(-10.0f)
#define		FRONT_FIRST_Y			(6.4625f-15.26205f)//(10.0f)
#define		FRONT_FIRST_X2			(8.412497f-19.06805f+2.606246f)// 	(-10.0f)
#define		FRONT_FIRST_Y2			(6.4625f-15.26205f+0.6747f)//(10.0f)
#define		BACK_FIRST_X			(-2.362496f)//-7.725f+5.362504f)
#define		BACK_FIRST_Y			(-2.362494f)//-6.2f + 3.837506f)
#define		BACK_FIRST_X2			(-2.362496f-3.318208f)//-7.725f+5.362504f)
#define		BACK_FIRST_Y2			(-2.362494f-0.2064815f)//-6.2f + 3.837506f)
#define		LINE_SLOW_SPEED			(PI/360.0f)
#define		SLINE_MOVETIME			(7)
#define		LINE_ANGLE_GAP			(30)
#define		LINE_ONE_ANGLE			(25)

//========================================================================
//					RXgN^
//========================================================================
SK7Sight::SK7Sight()
{
	m_chLineNum 			= 0;
	memset(&m_Sight.vPos2D,		0,	sizeof(Vec));
	memset(&m_Sight.vStopSpeed,	0,	sizeof(Vec));
	m_Sight.vPos.x 			= tblFrontSight[0].x;
	m_Sight.vPos.y 			= tblFrontSight[0].y;
	
	m_Sight.fAngle 			= 0.0f;
	m_Sight.Size 			= 0;
	m_Sight.iTime 			= 10;
	m_Sight.iStopTime 		= 0;
	m_Sight.bMoveFlag 		= false;
	
	for( int i = 0; i < LINE_AFTER_NUM; i++ ){
		m_FSight.vPos[i].x 		= FRONT_FIRST_X;
		m_FSight.vPos[i].y 		= FRONT_FIRST_Y;
		m_FSight.vPos2[i].x 	= BACK_FIRST_X;
		m_FSight.vPos2[i].y 	= BACK_FIRST_Y;
		m_FSight.vPos[i].z 		= tblFrontSight[0].z;
		m_FSight.fOldX[i]		= tblBackSight[0].x;
		m_FSight.vPos2[i].z 	= tblBackSight[0].z;
		m_FSight.bState[i]		= false;
	}
	memset(&m_FSight.vSpeed, 	0, sizeof(Vec));
	memset(&m_FSight.vSpeed2, 	0, sizeof(Vec));
	m_FSight.iTime 			= 0;
	m_FSight.iRenderTime	= 0;
	m_FSight.bRenderFlag	= false;
	m_FSight.bMoveFlag 		= false;
}


//========================================================================
//					fXgN^
//========================================================================
SK7Sight::~SK7Sight()
{
}


//========================================================================
//					QcTCgC
//========================================================================
void		SK7Sight::InitSight()
{
	for( int i = 0; i < SIGHT_LINE_MAX; i++ ){
		m_spSLine[i].SetColor(0xFF000064);
		m_spSLine[i].SetXY0( m_Sight.vPos2D.x, m_Sight.vPos2D.y );
		m_spSLine[i].SetXY1( m_Sight.vPos2D.x, 0.0f);
		m_spSLine[i].SetSize(10);
		if( i == 0 )	m_spSLine[i].SetVisible(true);
		else			m_spSLine[i].SetVisible(false);
		m_spSLine[i].SetFlag(true, LINE_FLAG|NOTEX_FLAG);
		
		m_SightLine[i].fAngle = 0.0f;
		m_SightLine[i].fSaveAngle = 0.0f;
		m_SightLine[i].iAddTime = 0;
		m_SightLine[i].alpha = 255;
		m_SightLine[i].bMoveFlag = false;
		m_SightLine[i].iMoveTime = 0;
		m_SightLine[i].fStopAngle = LINE_SLOW_SPEED;
		m_SightLine[i].iDrawTime = 0;
		m_SightLine[i].bDrawFlag = false;
		m_SightLine[i].iErasesTime = false;
		m_SightLine[i].LineNo = 0;
	}
	m_DSight.iTime1 = m_DSight.iTime2 = 0;
	m_DSight.bLine1Flag = false;
	m_DSight.bLine2Flag = false;
}

//========================================================================
//					QcTCg`
//========================================================================
void		SK7Sight::RenderSight2D()
{
	for( int i = 0; i < SIGHT_LINE_MAX; i++ ){
		m_spSLine[i].Render();
	}
}

//========================================================================
//					CWZbg
//========================================================================
void		SK7Sight::SetLineVertex()
{
	//	WZbg	-----------------------------------------------------
	m_SightLine[0].vPos.x = m_spSLine[0].GetX0()*(LINE_R * cosf(m_SightLine[0].fAngle)) + m_spSLine[0].GetY0()+(LINE_R * sinf(m_SightLine[0].fAngle));	
	m_SightLine[0].vPos.y = m_spSLine[0].GetX0()*(LINE_R * sinf(m_SightLine[0].fAngle)) - m_spSLine[0].GetY0()+(LINE_R * cosf(m_SightLine[0].fAngle));
	//	WZbg
	for( int i = 0; i < SIGHT_LINE_MAX; i++ )
	{
		m_SightLine[i].vPos.x = m_spSLine[i].GetX0()*(LINE_R * cosf(m_SightLine[i].fAngle)) + m_spSLine[i].GetY0()+(LINE_R * sinf(m_SightLine[i].fAngle));	
		m_SightLine[i].vPos.y = m_spSLine[i].GetX0()*(LINE_R * sinf(m_SightLine[i].fAngle)) - m_spSLine[i].GetY0()+(LINE_R * cosf(m_SightLine[i].fAngle));

		m_spSLine[i].SetXY0( m_Sight.vPos2D.x, m_Sight.vPos2D.y );
		m_spSLine[i].SetXY1( m_SightLine[i].vPos.x, m_SightLine[i].vPos.y  );
	
		if( i == 0 )	m_spSLine[i].SetAlpha( 255 );
		else			m_spSLine[i].SetAlpha((u8)(150 - (i*4)));
	}
}		

//========================================================================
//					TCg̒_ݒ
//========================================================================
void		SK7Sight::SetSightFirst( s16 no )
{
	SET_FRAMESPEED( m_FSight.vSpeed, tblFrontSight[no], m_FSight.vPos[0], LINE_AFTER_FRAME );
	SET_FRAMESPEED( m_FSight.vSpeed2, tblBackSight[no], m_FSight.vPos2[0], LINE_AFTER_FRAME );
	
	//	O̍Wۑ
	for( int a = 0; a < LINE_AFTER_NUM; a++ ){
		m_FSight.fOldX[a] = m_FSight.vPos2[a].x;
	}
	m_FSight.bMoveFlag = true;

	m_FSight.bRenderFlag = false;
	m_FSight.iRenderTime = 0;
	memset( &m_FSight.bState, false, sizeof(bool)*LINE_AFTER_NUM );
}


//========================================================================
//					CGtFNg̓
//========================================================================
void		SK7Sight::MoveSightLine(bool state)
{
	//	ĂƂ
	if( state )
	{
		//	ړtÔƂ
		if( !m_SightLine[0].bMoveFlag && !m_SightLine[m_chLineNum-1].bDrawFlag)
		{
			m_SightLine[0].iMoveTime = rand() % SLINE_MOVETIME;
			m_SightLine[0].bMoveFlag = true;
		}
		else
		{
			//	JEg܂킷
			if( ++m_SightLine[0].iAddTime > m_SightLine[0].iMoveTime && !m_SightLine[m_chLineNum-1].bDrawFlag)
			{				
				//	JEg
				m_SightLine[0].iAddTime = 0;

				//	^C
				m_SightLine[0].iMoveTime = 0;

				int iAngle = rand() % 360;
				
				//	pxĂقƂ낶Ȃ
				if(!( iAngle >= 360 - LINE_ANGLE_GAP || iAngle <= LINE_ANGLE_GAP ) ||
					( iAngle >= 180 - LINE_ANGLE_GAP && iAngle <= 180 + LINE_ANGLE_GAP )) 
				{
					//	XOxȉ̂Ƃ
					if( iAngle < 90 )		iAngle -= (LINE_ANGLE_GAP*2);
					//	XO`PTO̊
					if( iAngle >= 90 && iAngle < 180-LINE_ANGLE_GAP )	iAngle += (LINE_ANGLE_GAP*2);
					//	QPO`QVO
					if( iAngle > 210 && iAngle < 270 )	iAngle -= (LINE_ANGLE_GAP*2);
					//	QVO`RRO
					if( iAngle >= 270 && iAngle < 360 - LINE_ANGLE_GAP )
					{
						iAngle += (LINE_ANGLE_GAP*2);
						if( iAngle >= 360 )	iAngle = iAngle - 360;
					}
				}
				bool bPlusMins = false; // falsêƂ́[ truêƂ{
			
				//	Č	----------------------------------------------------------------------
				m_chLineNum = 3;
				//	EォȂ
				if( iAngle > 270 && m_SightLine[0].fSaveAngle < 270 )
				{
					m_chLineNum = (s8)( ((360 - iAngle) + m_SightLine[0].fSaveAngle)/LINE_ONE_ANGLE);
				}
				else
				{
					//	̑@E
					if( iAngle < 270 && m_SightLine[0].fSaveAngle > 270 )
					{
						m_chLineNum = (s8)(( (360-m_SightLine[0].fSaveAngle) + iAngle)/LINE_ONE_ANGLE);
					}
					else
					{
						m_chLineNum = (s8)( (m_SightLine[0].fSaveAngle - iAngle)/LINE_ONE_ANGLE);
					}
				}
				//	Βl
				m_chLineNum = (s8)abs(m_chLineNum);
				
				
				//	px`FbN
				if( iAngle - m_SightLine[0].fSaveAngle > 0 )
				{
					if( iAngle > 270 )	bPlusMins = false;
					else				bPlusMins = true;
				}
				else
				{
					if( iAngle > 270 )	bPlusMins = true;
					else				bPlusMins = false;
				}
				//	Cpxݒ
				if( bPlusMins )
				{
					m_SightLine[0].fMoveAngle = (iAngle - m_SightLine[0].fSaveAngle)/m_chLineNum;
				}
				else
				{			
					if( m_SightLine[0].fSaveAngle >= 180-LINE_ANGLE_GAP && m_SightLine[0].fSaveAngle <= 180+LINE_ANGLE_GAP)
					{
						if( iAngle <= LINE_ANGLE_GAP )
						{
							m_SightLine[0].fMoveAngle = -( m_SightLine[0].fSaveAngle - iAngle )/m_chLineNum;
						}
						if( iAngle >= 360-LINE_ANGLE_GAP )
						{
							m_SightLine[0].fMoveAngle = -( m_SightLine[0].fSaveAngle + (360-iAngle) )/m_chLineNum;
						}
						if( !(iAngle <= LINE_ANGLE_GAP || iAngle >= 360-LINE_ANGLE_GAP))
						{
							m_SightLine[0].fMoveAngle = (iAngle - m_SightLine[0].fSaveAngle)/m_chLineNum;
						}
					}
					else
					{
						if( iAngle > 270 )
						{
							if( m_SightLine[0].fSaveAngle > 270 )	m_SightLine[0].fMoveAngle = (iAngle - m_SightLine[0].fSaveAngle)/m_chLineNum;
							else		m_SightLine[0].fMoveAngle = (iAngle - (360+m_SightLine[0].fSaveAngle))/m_chLineNum;
						}
						else
						{
							if( m_SightLine[0].fSaveAngle > 270 )	m_SightLine[0].fMoveAngle = (iAngle + (360-m_SightLine[0].fSaveAngle))/m_chLineNum;
							else m_SightLine[0].fMoveAngle = ( iAngle - m_SightLine[0].fSaveAngle)/m_chLineNum;
						}
					}
				}
				
				for( int i = 1; i < m_chLineNum; i++ )
				{	
					m_SightLine[i].fAngle = m_SightLine[0].fAngle + ( MTXDegToRad(m_SightLine[0].fMoveAngle*i)); 
					m_SightLine[i].bDrawFlag = true;
				}
				//	pxZbg
				m_SightLine[0].fAngle = MTXDegToRad(iAngle);
				
				//	Z[u
				m_SightLine[0].fSaveAngle = MTXRadToDeg(m_SightLine[0].fAngle);

				//	I
				m_SightLine[0].bMoveFlag = false;
				
				m_spSLine[0].SetVisible(true);
			}
		}
	}
	
	//	cZbg	-----------------------------------------------------
	for( int j = 1; j < m_chLineNum; j++ )
	{
		if( !m_spSLine[j].CheckFlag(RENDER_FLAG) && m_SightLine[j].bDrawFlag )
		{
			//	`
			if( ++m_SightLine[j].iDrawTime >= j )
			{
				m_spSLine[j].SetVisible(true);
			}
		}
		else
		{
			//	
			if( m_spSLine[j].CheckFlag(RENDER_FLAG) && ++m_SightLine[j].iErasesTime >= j*2 )
			{
				m_SightLine[j].iDrawTime = 0;
				m_SightLine[j].iErasesTime = 0;
				m_SightLine[j].bDrawFlag = false;
				m_spSLine[j].SetVisible(false);
			}
		}
	}
	
	//	WZbg	-----------------------------------------------------
	m_SightLine[0].vPos.x = m_spSLine[0].GetX0()*(LINE_R * cosf(m_SightLine[0].fAngle)) + m_spSLine[0].GetY0()+(LINE_R * sinf(m_SightLine[0].fAngle));	
	m_SightLine[0].vPos.y = m_spSLine[0].GetX0()*(LINE_R * sinf(m_SightLine[0].fAngle)) - m_spSLine[0].GetY0()+(LINE_R * cosf(m_SightLine[0].fAngle));
	//	WZbg
	for( int i = 0; i < SIGHT_LINE_MAX; i++ )
	{
		m_SightLine[i].vPos.x = m_spSLine[i].GetX0()*(LINE_R * cosf(m_SightLine[i].fAngle)) + m_spSLine[i].GetY0()+(LINE_R * sinf(m_SightLine[i].fAngle));	
		m_SightLine[i].vPos.y = m_spSLine[i].GetX0()*(LINE_R * sinf(m_SightLine[i].fAngle)) - m_spSLine[i].GetY0()+(LINE_R * cosf(m_SightLine[i].fAngle));

		m_spSLine[i].SetXY0( m_Sight.vPos2D.x, m_Sight.vPos2D.y );
		m_spSLine[i].SetXY1( m_SightLine[i].vPos.x, m_SightLine[i].vPos.y  );
	
		if( i == 0 )	m_spSLine[i].SetAlpha( 255 );
		else			m_spSLine[i].SetAlpha((u8)(150 - (i*4)));
	}
}
//========================================================================
//					TCgRc
//========================================================================
void		SK7Sight::RenderSight3D( TEX_DATA* pTex )
{
	// r[s̎擾
	Mtx View;
	HSD_CObjGetViewingMtx	( WK7CAM->GetCObj(), View ); 
	GXLoadPosMtxImm( View, 0 );			//	posr[sZbg
	GXLoadNrmMtxImm( View, 0 );			//	@r[sZbg
	GXSetCurrentMtx( 0 ) ;				//	JgZbg
	
//	@TEVݒ	

	//TEVXe[Wŗp\ɂeNX`W̐ݒ
	GXSetNumTexGens( 1 );
	//eNX`W̕@w
	GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	
	//TEVXe[WŔJ[
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_RASC, GX_CC_TEXC, GX_CC_ZERO );
	GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_ZERO, GX_CA_RASA, GX_CA_TEXA, GX_CA_ZERO );
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_TRUE, GX_TEVPREV );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0 );


//	@_ݒ	

	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  	GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, 	GX_DIRECT );	//J[0̎ނݒ
	GXSetVtxDesc( GX_VA_TEX0, GX_DIRECT );	//eNX`0̎ނݒ

	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST,   GX_F32,   0 );	//eNX`0̗vfƎނw

	//	Zobt@r[h̐ݒ
	GXSetZMode( GX_FALSE, GX_LEQUAL, GX_FALSE );
	
	//	JO	
	GXSetCullMode( GX_CULL_NONE );
	
	GXLoadTexObj( &pTex->Obj, GX_TEXMAP0 );
	//	|CgXvCgeNX`ݒ
	GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_TRUE);
		
	//	TCYݒ
	GXSetPointSize(m_Sight.Size,GX_TO_ONE);
	
	// 		ӂ	
	
	GXBegin( GX_POINTS, GX_VTXFMT0, (u16)1 );
		
	GXPosition3f32	( m_Sight.vPos.x, m_Sight.vPos.y, BG_Z );
	GXColor4u8 		( 255, 255, 255, 255 );
	GXTexCoord2f32	( 0.0f, 0.0f );
	
	GXEnd();
}



//========================================================================
//					TCgӂ
//========================================================================
void		SK7Sight::RenderSightFuta( s16 Num, s16 No )
{	
	//	@}gNXݒ	

	// r[s̎擾
	Mtx View;
	HSD_CObjGetViewingMtx( WK7CAM->GetCObj(), View ); 
	GXLoadPosMtxImm( View, 0 );			//	posr[sZbg
	GXLoadNrmMtxImm( View, 0 );			//	@r[sZbg
	GXSetCurrentMtx( 0 ) ;				//	JgZbg
	
//	@TEVݒ	

	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 0 );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
	GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo


//	@_ݒ	

	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  	GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, 	GX_DIRECT );	//J[0̎ނݒ

	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	
	//	Zobt@r[h̐ݒ
//	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	GXSetZMode( GX_FALSE, GX_LEQUAL, GX_FALSE );
	
	//	JO
	GXSetCullMode( GX_CULL_NONE );
	
	GXBegin( GX_TRIANGLEFAN, GX_VTXFMT0, (u16)SIDE_NUM+1);
	
	if( Num == SCENARIO_MAX_NUM ){
		GXPosition3f32	( m_FSight.vPos[0].x+tblShishiFront[No].x, m_FSight.vPos[0].y+tblShishiFront[No].y, m_FSight.vPos[0].z); 
	}else{
		GXPosition3f32	( m_FSight.vPos[0].x, m_FSight.vPos[0].y, m_FSight.vPos[0].z); 
	}
	GXColor4u8( 255, 0, 0, 60 );
	
	for( int j = 0; j < SIDE_NUM; j++ )
	{
		f32 T = (2 * PI * j)/(SIDE_NUM-1);
		f32 S = sinf(T), C = cosf(T);

		f32 X = m_FSight.vPos[0].x + SIGHT_R * C;
		f32 Y = m_FSight.vPos[0].y + SIGHT_R * S;
		
		if( Num == SCENARIO_MAX_NUM ){
			X += tblShishiFront[No].x;
			Y += tblShishiFront[No].y;
		}

		GXPosition3f32	( X, Y, m_FSight.vPos[0].z); 
		GXColor4u8( 255, 0, 0, 60 );
	}
	GXEnd();
}
//========================================================================
//					TCg̒_ݒ
//========================================================================
void		SK7Sight::RenderSightDataFirst( int No, int sNum, int sNo )
{		
//	@}gNXݒ	

	// r[s̎擾
	Mtx View;
	HSD_CObjGetViewingMtx( WK7CAM->GetCObj(), View ); 
	GXLoadPosMtxImm( View, 0 );			//	posr[sZbg
	GXLoadNrmMtxImm( View, 0 );			//	@r[sZbg
	GXSetCurrentMtx( 0 ) ;				//	JgZbg
	
//	@TEVݒ	

	//TEVXe[Wŗp\ɂeNX`W̐ݒ聨̊GXSetTevOrderŗp
	GXSetNumTexGens( 0 );
	//TEVXe[W̐ݒ
	GXSetNumTevStages( 1 );
	//TEVXe[WŔJ[
	GXSetTevOp( GX_TEVSTAGE0, GX_PASSCLR );
	//CӎwTEVXe[W̃eNX`pCvC̐ݒ聨łGX_TEVSTAGE0̃pCvCݒ
	GXSetTevOrder( GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0 );		//J[`lgꍇ͂Ăяo


//	@_ݒ	

	//̎_ł̒_Lqq̑SẴAgr[gGX_NONEɃZbg
	GXClearVtxDesc();
	//Jg_Lqq̂ꂼ̑̎ނݒ
	GXSetVtxDesc( GX_VA_POS,  	GX_DIRECT );	//ʒuW̎ނݒ
	GXSetVtxDesc( GX_VA_CLR0, 	GX_DIRECT );	//J[0̎ނݒ

	//ꂼ̗̑vf(?)Ǝނݒ
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS,	 GX_POS_XYZ,  GX_F32  , 0 );	//|WV̗vfƎނw
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0 );	//J[0̗vfƎނw
	
	//	Zobt@r[h̐ݒ
//	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	GXSetZMode( GX_FALSE, GX_LEQUAL, GX_FALSE );
	
	//	JO
	GXSetCullMode( GX_CULL_NONE );

	GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)SIDE_NUM*2);
	
	for( int i = 0; i < SIDE_NUM; i++ )
	{
		f32 theta = (2 * PI * i)/(SIDE_NUM-1);
		f32 SIN = sinf(theta), COS = cosf(theta);
		
		f32 X1,X2,Y1,Y2, PlusX1=0,PlusX2=0, PlusY1=0,PlusY2=0;

#ifdef __LINEDEBUG__
		X1 = m_FSight.vPos2[No].x + SIGHT_R * COS + VL.x;
		Y1 = m_FSight.vPos2[No].y + SIGHT_R * SIN + VL.y;
		X2 = m_FSight.vPos[No].x + SIGHT_R * COS + VL2.x;
		Y2 = m_FSight.vPos[No].y + SIGHT_R * SIN + VL2.y;
		
		VL.x += HSD_PadGetNormalStickX(0)*0.01f;
		VL.y += HSD_PadGetNormalStickY(0)*0.01f;
		VL2.x += HSD_PadGetNormalSubStickX(0)*0.01f;
		VL2.y += HSD_PadGetNormalSubStickY(0)*0.01f;

#else
		X1 = m_FSight.vPos2[No].x + SIGHT_R * COS;
		Y1 = m_FSight.vPos2[No].y + SIGHT_R * SIN;
		X2 = m_FSight.vPos[No].x + SIGHT_R * COS;
		Y2 = m_FSight.vPos[No].y + SIGHT_R * SIN;
#endif
		
		if( sNum == SCENARIO_MAX_NUM ){
			PlusX1 = tblShishiBack[sNo].x;		PlusY1 = tblShishiBack[sNo].y;
			PlusX2 = tblShishiFront[sNo].x;		PlusY2 = tblShishiFront[sNo].y;
		}

		GXPosition3f32	( X1+PlusX1, Y1+PlusY1, m_FSight.vPos2[No].z); 
		if( No == 0 )	GXColor4u8( 255, 0, 0, 60 );
		else if(m_FSight.bState[No] && m_FSight.fOldX[No] != m_FSight.vPos2[No].x && m_FSight.fOldX[No] != 0 ){
				GXColor4u8 		( 255, 0, 0, (u8)(60-(50-No*10)) );
		}else{
			GXColor4u8		( 255, 0, 0, 0 );
		}
				
		GXPosition3f32	( X2+PlusX2, Y2+PlusY2, m_FSight.vPos[No].z ); 
		if( No == 0 )	GXColor4u8( 255, 0, 0, 60 );
		else  if( m_FSight.bState[No] && m_FSight.fOldX[No] != m_FSight.vPos2[No].x && m_FSight.fOldX[No] != 0){
			GXColor4u8 		( 255, 0, 0, (u8)(60-(50-No*10)) );
		}else{
			GXColor4u8		( 255, 0, 0, 0 );
		}
	}
	GXEnd();
}

//========================================================================
//					JZbg
//========================================================================
void		SK7Sight::SetSightCamera()
{
	//	  Jݒ	
	// ˉe
	f32 Fov, Aspect, Near, Far;
	Mtx44 mtx;

	//
	HSD_CObjGetPerspective( WK7CAM->GetCObj(), &Fov, &Aspect );
	Near = HSD_CObjGetNear( WK7CAM->GetCObj() );
	Far = HSD_CObjGetFar( WK7CAM->GetCObj() );
	
	// ˉes쐬
	MTXPerspective( mtx, Fov, Aspect, Near, Far );
	GXSetProjection( mtx, GX_PERSPECTIVE );
}


//========================================================================
//					At@ݒ
//========================================================================
void			SK7Sight::SetAlphaSight()
{
	//TEVXe[Wւ̏o͂łJ[`l̐ݒ
	GXSetNumChans( 1 );
    GXSetAlphaCompare( GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){255, 255, 255, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){255, 255, 255, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//    GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );

	GXSetAlphaUpdate (GX_TRUE);
	GXSetDither      (GX_FALSE);
}


//========================================================================
//					t@[XgTCg̏I
//========================================================================
void			SK7Sight::SetFSightEndPos()
{
	//	f[^
	for( int i = 1; i < LINE_AFTER_NUM; i++ ){
		m_FSight.vPos[i] = m_FSight.vPos[LINE_AFTER_NUM-1];
		m_FSight.vPos2[i] = m_FSight.vPos2[LINE_AFTER_NUM-1];
	}
	memset(&m_FSight.bState, false, sizeof(bool)*LINE_AFTER_NUM );
	memset(&m_FSight.vSpeed, 0, sizeof(Vec));
	memset(&m_FSight.vSpeed2, 0, sizeof(Vec));
}

//========================================================================
//					ĂȂƂ̃TCg
//========================================================================
void			SK7Sight::MoveStopSight()
{
	if( !m_Sight.bMoveFlag ){
		f32 StopAngle = MTXDegToRad(rand()%360);
		m_Sight.vStopSpeed.x = (STOP_LINE_R*cosf(StopAngle))/STOP_LINE_FRAME;
		m_Sight.vStopSpeed.y = (STOP_LINE_R*sinf(StopAngle))/STOP_LINE_FRAME;
		m_Sight.bMoveFlag = true;
	}else{
		if( ++m_Sight.iStopTime <= STOP_LINE_FRAME ){
			m_Sight.vPos.x += m_Sight.vStopSpeed.x;
			m_Sight.vPos.y += m_Sight.vStopSpeed.y;
		}else{
			m_Sight.iStopTime = 0;
			m_Sight.bMoveFlag = false;
		}
	}
	CheckSightSide();
}


//========================================================================
//					TCg̒[
//========================================================================
void			SK7Sight::CheckSightSide()
{
	//	WZbg	----------------------------------------------------
	if( m_Sight.vPos.x >= SIGHT_SIDE_X )	m_Sight.vPos.x = SIGHT_SIDE_X;
	if( m_Sight.vPos.x <= -SIGHT_SIDE_X)	m_Sight.vPos.x = -SIGHT_SIDE_X;
	if( m_Sight.vPos.y >= SIGHT_SIDE_Y )	m_Sight.vPos.y = SIGHT_SIDE_Y;
	if( m_Sight.vPos.y <= -SIGHT_SIDE_Y)	m_Sight.vPos.y = -SIGHT_SIDE_Y;
	
	if( m_Sight.vPos2D.x >= 640.0f )	m_Sight.vPos2D.x = 640.0f;
	if( m_Sight.vPos2D.x <= 0.0f)		m_Sight.vPos2D.x = 0.0f;
	if( m_Sight.vPos2D.y >= 480.0f )	m_Sight.vPos2D.y = 480.0f;
	if( m_Sight.vPos2D.y <= 0.0f)		m_Sight.vPos2D.y = 0.0f;
}

//========================================================================
//					ĂȂƂ̃TCg
//========================================================================
void			SK7Sight::InitSightLine()
{
	for( int j = 1; j < m_chLineNum; j++ ){
		m_SightLine[j].iDrawTime = m_SightLine[j].iErasesTime = 0;
		m_SightLine[j].bDrawFlag = false;
		m_spSLine[j].SetVisible(false);
	}
}

//========================================================================
//					ĂȂƂ̃TCg
//========================================================================
bool			SK7Sight::MoveFSight()
{
	VECAdd( &m_FSight.vPos[0], &m_FSight.vSpeed, &m_FSight.vPos[0] );
	VECAdd( &m_FSight.vPos2[0], &m_FSight.vSpeed2, &m_FSight.vPos2[0] );	

	int i;
	for( i = 1; i < LINE_AFTER_NUM; i++ ){
		if( !m_FSight.bState[i] ){
			m_FSight.vPos[i] 	= m_FSight.vPos[0];
			m_FSight.vPos2[i] 	= m_FSight.vPos2[0];
			m_FSight.bState[i] = true;
			break;
		}
	}
	if( ++m_FSight.iTime >= LINE_AFTER_FRAME ){
		m_FSight.iTime 			= 0;
		m_FSight.bMoveFlag 		= false;
		m_FSight.bRenderFlag 	= true;	
		return true;
	}
	return false;
}

//========================================================================
//					ĂȂƂ̃TCg
//========================================================================
bool			SK7Sight::MoveFSightZan()
{
	if( !m_FSight.bRenderFlag )	return false;

	int i;
	m_FSight.iRenderTime++;
	
	for( i = 0; i < LINE_AFTER_NUM; i++ ){
		if( m_FSight.iRenderTime >= i*3 ){
			if( m_FSight.bState[i] ){
				m_FSight.bState[i] = false;
			}
		}
	}
	if( !m_FSight.bState[LINE_AFTER_NUM-1] ){
		m_FSight.bRenderFlag = false;
		m_FSight.iRenderTime = 0;
	}
	return true;
}

//========================================================================
//					2DTCg
//========================================================================
void			SK7Sight::SetSight2D()
{
	m_Sight.vSavePos = m_Sight.vPos;
	m_Sight.vSavePos.z = BG_Z;

	//	RcWQcWւ̕ϊ
	Get3Dto2D( &m_Sight.vSavePos, &m_Sight.vPos2D );
	CheckSightSide();
}
