////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Sight class
//
// SK7Sight.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SIGHT_H__
#define	__SK7SIGHT_H__

#include "SK7Sprite.h"

#define		LINE_AFTER_NUM			(5)
#define		SIGHT_LINE_MAX			(30)
#define		LINE_AFTER_FRAME		(5)

//@TCgCp
typedef struct
{
	f32 	fAngle;
	f32		fSaveAngle;
	f32		fMoveAngle;
	u32 	iAddTime;
	Vec		vPos;
	u8		alpha;
	bool	bMoveFlag;
	int		iMoveTime;
	f32		fStopAngle;
	u32		iDrawTime;
	bool	bDrawFlag;
	u32		iErasesTime;
	u8		LineNo;
}SIGHT_LINE;

//	TCg`攻p
typedef struct
{
	u32		iTime1;
	u32		iTime2;
	bool	bLine1Flag;
	bool	bLine2Flag;
}SIGHT_DRAW;

//	TCgf[^p
typedef struct
{
	Vec 		vPos;
	Vec			vPos2D;
	Vec 		vSavePos;
	Vec			vStopSpeed;
	u8			Size;
	u32			iTime;
	TEX_DATA 	Tex;
	f32			fAngle;
	bool		bMoveFlag;
	u32			iStopTime;
}SIGHTSTATE;

//	ŏ̃TCg
typedef struct
{
	Vec			vPos[LINE_AFTER_NUM];
	Vec			vPos2[LINE_AFTER_NUM];
	Vec			vSpeed;
	Vec			vSpeed2;
	f32			fOldX[LINE_AFTER_NUM];
	u32			iTime;
	u32			iRenderTime;
	bool		bMoveFlag;
	bool		bRenderFlag;
	bool		bState[LINE_AFTER_NUM];
}FIRST_SIGHT;


//	TCgNX
class SK7Sight
{
protected:
	SIGHTSTATE			m_Sight;			//	TCg̍W
	SIGHT_DRAW			m_DSight;
	SIGHT_LINE			m_SightLine[SIGHT_LINE_MAX];
	FIRST_SIGHT			m_FSight;
	SK7Sprite			m_spSLine[SIGHT_LINE_MAX];
	s8					m_chLineNum;		//	C
public:
	SK7Sight();
	~SK7Sight();
	
	void			InitSight();
	void			InitSightLine();
	void			SetLineVertex();
	void			SetAlphaSight();
	void			SetSightCamera();
	void			SetSightFirst(s16 no);
	void			SetSightPos		( f32 x, f32 y ){ m_Sight.vPos.x = x, m_Sight.vPos.y = y; }
	void			SetSightIncPos	( f32 x, f32 y ){ m_Sight.vPos.x += x; m_Sight.vPos.y += y; }
	void			SetSight2DPos	( f32 x, f32 y ){ m_Sight.vPos2D.x = x, m_Sight.vPos2D.y = y; }
	void			SetSightSize	( u8 size )		{ m_Sight.Size = size; }
	void			SetFSightEndPos();
	void			SetSight2D();
	void			RenderSight2D();
	void 			RenderSight3D(TEX_DATA*pTex);
	void			RenderSightDataFirst( int, int, int );
	void			RenderSightFuta( s16, s16 );
	bool			MoveSightFirst( int num );
	void			MoveSightLine(bool state);
	void			MoveStopSight();
	bool			MoveFSight();
	bool			MoveFSightZan();
	void			CheckSightSide();


	bool			GetFirstSightMove()	{ return m_FSight.bMoveFlag; }
	bool			GetSightMove()		{ return m_Sight.bMoveFlag; }
	Vec*			GetSight2DPos()		{ return &m_Sight.vPos2D; }
	Vec*			GetFirstSightPos()		{ return &m_FSight.vPos[0]; }
	Vec*			GetFirstSightPos2()		{ return &m_FSight.vPos2[0]; }
	bool			GetFirstSightVisible()	{ return m_FSight.bRenderFlag; }
};

#endif	//__SK7SIGHT_H__

