////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7Sprite
//
// SK7Sprite.cpp
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__SK7SPRITE_CPP__

#include <dolphin.h>
#include <sysdolphin\baselib.h>
#include "../wat/WK7Define.h"
#include "../wat/WK7Cam.h"
#include "SK7Common.h"
#include "SK7Sprite.h"


//========================================================================
//					RXgN^
//========================================================================
SK7Sprite::SK7Sprite()
{
	for( int i = 0; i < 4; i++ )
	{
		m_Vector[i].x = 0;
		m_Vector[i].y = 0;
		m_Vector[i].z = -100;//NORMAL_Z;
	}
	m_TexData.Header = NULL;
	m_Size = 1;
	m_ucBlendNo = 0;
	
	m_vEx.x = 1;
	m_vEx.y = 1;
	
	m_S[0] = m_S[2] = 0.0f;
	m_S[1] = m_S[3] = 1.0f;

	m_T[0] = m_T[1] = 0.0f;
	m_T[2] = m_T[3] = 1.0f;
	
	m_Color[0] = m_Color[1] = m_Color[2] = m_Color[3] = 0xffffffff;
	
	m_Flag = 0;
	m_Flag |= COLOR_FLAG;
	m_DstAlpha = 0;
	
	m_WNum = m_HNum = 1;
	m_TexNo = 0;
	
}

//========================================================================
//					fXgN^
//========================================================================
SK7Sprite::~SK7Sprite()
{
}

//========================================================================
//					eNX`[[h
//========================================================================
bool	SK7Sprite::LoadTexture( char* FileName, u16 wno, u16 hno )
{
	if( m_TexFile.OpenTexFile( FileName, &m_TexData ) )
	{
		m_WNum = wno, m_HNum = hno;
		SetFlag( true, TEXLOAD_FLAG );
		InitTexture( &m_TexData );
		return true;
	}
	return false;
}


//========================================================================
//					 ݒ
//========================================================================
void	SK7Sprite::SetEnv()
{
	//	Zobt@r[h̐ݒ
	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
	
	//	JO
	GXSetCullMode( GX_CULL_NONE ) ;

	//TEVXe[Wւ̏o͂łJ[`l̐ݒ
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
	//dither
	if( m_Flag & DITHER_FLAG ){
		GXSetDither      (GX_TRUE);
	}else{
		GXSetDither      (GX_FALSE);
	}	
}

//========================================================================
//					 ݒ
//========================================================================
void	SK7Sprite::SetEnvZ()
{
	//	Zobt@r[h̐ݒ
	GXSetZMode( GX_FALSE, GX_ALWAYS, GX_TRUE );
	
	//	JO
	GXSetCullMode( GX_CULL_NONE ) ;

	//TEVXe[Wւ̏o͂łJ[`l̐ݒ
	GXSetNumChans( 1 );
	//GX_COLOR0A0̃CgRg[̐ݒ
	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE );
//	GXSetChanCtrl( GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX, GX_LIGHT0, GX_DF_NONE, GX_AF_NONE );
	//dither
	GXSetDither      (GX_FALSE);
	
}

//========================================================================
//					At@ݒ
//========================================================================
void		SK7Sprite::SetAlphaColor(bool aflag, bool cflag )
{
	//At@UpDate
	if(aflag)
	{
		GXSetAlphaUpdate(GX_TRUE);
		GXSetDstAlpha(GX_TRUE,m_DstAlpha);	
	}
	else
	{
		GXSetAlphaUpdate(GX_FALSE);
		GXSetDstAlpha(GX_FALSE,m_DstAlpha);
	}
	
	//[Update
	if(cflag)		GXSetColorUpdate(GX_TRUE);
	else			GXSetColorUpdate(GX_FALSE);
	
	//	r
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
}



//========================================================================
//					uh[hݒ
//========================================================================
void		SK7Sprite::SetBlendMode(u8 flag)
{
	switch( flag ){
	case SPR_BLEND_NORMAL:
		if( CheckFlag( SCREEN_FLAG ) ){
			GXSetBlendMode( GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
		}else{
			GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR );
		}
		break;
	case SPR_BLEND_NOT:		GXSetBlendMode( GX_BM_BLEND, GX_BL_DSTALPHA, GX_BL_INVDSTALPHA, GX_LO_CLEAR );			break;
	case SPR_BLEND_ONE:		GXSetBlendMode( GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_ONE, 		GX_LO_CLEAR );			break;
	case SPR_BLEND_MULTI:	GXSetBlendMode( GX_BM_BLEND, GX_BL_ZERO, 	 GX_BL_SRCCLR, 		GX_LO_CLEAR );			break;
	}
}


//========================================================================
//					Zbg
//========================================================================
void		SK7Sprite::SetLineQuad( f32 X, f32 Y, f32 SX, f32 SY, u32 Color, u8 Size  )
{
	m_Vector[0].x = m_Vector[3].x = X;
	m_Vector[1].x = m_Vector[2].x = X + SX;
	m_Vector[0].y = m_Vector[1].y = Y;
	m_Vector[2].y = m_Vector[3].y = Y + SY;

	m_Size = Size;
	m_SizeXY.x = SX;	m_SizeXY.y = SY;
	m_Color[0] = Color;
	
	SetFlag( true, NOTEX_FLAG|LINEQUAD_FLAG );
}

//========================================================================
//					XvCgZbg
//========================================================================
void		SK7Sprite::SetTexSprite( f32 X, f32 Y, TEX_DATA* tex, u16 SNo, u16 TNo, u16 TexNo )
{
	m_TexData = *tex;	
	m_WNum 	= SNo;
	m_HNum 	= TNo;
	m_TexNo = TexNo;
	if( m_WNum > 0 || m_HNum > 0 ){
		SetFlag( true, BLOCK_FLAG );
	}else{
		SetSTTwo(0.0f,0.0f,1.0f,1.0f);
		SetFlag( false, BLOCK_FLAG|NOTEX_FLAG|SIZE_FLAG );
	}
	m_Vector[0].x = X;
	m_Vector[0].y = Y;

}

//========================================================================
//					XvCgZbg
//========================================================================
void		SK7Sprite::SetSprite( f32 X, f32 Y, f32 SX, f32 SY, u32 Color  )
{
	m_Vector[0].x = m_Vector[2].x = X;
	m_Vector[1].x = m_Vector[3].x = X + SX;
	m_Vector[0].y = m_Vector[1].y = Y;
	m_Vector[2].y = m_Vector[3].y = Y + SY;

	m_SizeXY.x = SX;	m_SizeXY.y = SY;
	m_Color[0] = Color;
	SetFlag( true, NOTEX_FLAG|SIZE_FLAG );
}

//========================================================================
//					XvCgZbg
//========================================================================
void		SK7Sprite::SetTexSpriteTwo( f32 X0, f32 Y0, f32 X1, f32 Y1, TEX_DATA* tex, u16 SNo, u16 TNo, u16 TexNo )
{
	m_TexData = *tex;	
	m_WNum 	= SNo;
	m_HNum 	= TNo;
	m_TexNo = TexNo;
	SetFlag( true, VTX4_FLAG );
	if( m_WNum > 0 || m_HNum > 0 ){
		SetFlag( true, BLOCK_FLAG );
	}	
	m_Vector[0].x = m_Vector[2].x = X0;
	m_Vector[1].x = m_Vector[3].x = X1;
	m_Vector[0].y = m_Vector[1].y = Y0;
	m_Vector[2].y = m_Vector[3].y = Y1;

}

//========================================================================
//					XvCgZbg
//========================================================================
void		SK7Sprite::SetSpriteFlex( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, f32 X3, f32 Y3, u32 Color )
{
	m_Vector[0].x = X0,
	m_Vector[1].x = X1;
	m_Vector[2].x = X2;
	m_Vector[3].x = X3;
	m_Vector[0].y = Y0;
	m_Vector[1].y = Y1;
	m_Vector[2].y = Y2;
	m_Vector[3].y = Y3;
	m_Color[0] = Color;
	SetFlag( true, NOTEX_FLAG|VTX4_FLAG );
}

//========================================================================
//					XvCgZbg
//========================================================================
void		SK7Sprite::SetTexSpriteFlex( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, f32 X3, f32 Y3, TEX_DATA* tex, u16 SNo, u16 TNo, u16 TexNo )
{
	m_TexData = *tex;
	
	m_WNum 	= SNo;
	m_HNum 	= TNo;
	m_TexNo = TexNo;
	SetFlag( true, VTX4_FLAG );
	if( m_WNum > 0 || m_HNum > 0 ){
		SetFlag( true, BLOCK_FLAG );
	}	
	m_Vector[0].x = X0,
	m_Vector[1].x = X1;
	m_Vector[2].x = X2;
	m_Vector[3].x = X3;
	m_Vector[0].y = Y0;
	m_Vector[1].y = Y1;
	m_Vector[2].y = Y2;
	m_Vector[3].y = Y3;
}

//========================================================================
//					CXvCgZbg
//========================================================================
void		SK7Sprite::SetTexLineSprite( f32 SX, f32 SY, f32 EX, f32 EY, TEX_DATA* tex, u8 Size  )
{
	m_Vector[0].x = SX;
	m_Vector[1].x = EX;
	m_Vector[0].y = SY;
	m_Vector[1].y = EY;
	
	m_TexData = *tex;
	m_Size = Size;
	SetFlag( true, LINE_FLAG );
}

//========================================================================
//					CXvCgZbg
//========================================================================
void		SK7Sprite::SetLineSprite( f32 SX, f32 SY, f32 EX, f32 EY, u8 Size, u32 Color  )
{
	m_Vector[0].x = SX;
	m_Vector[1].x = EX;
	m_Vector[0].y = SY;
	m_Vector[1].y = EY;
	
	m_Size = Size;
	m_Color[0] = Color;
	SetFlag( true, LINE_FLAG|NOTEX_FLAG );
}

//========================================================================
//					CXvCgZbg
//========================================================================
void		SK7Sprite::SetTriangle( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, u32 Color )
{
	m_Vector[0].x = X0;
	m_Vector[1].x = X1;
	m_Vector[2].x = X2;
	m_Vector[0].y = Y0;
	m_Vector[1].y = Y1;
	m_Vector[2].y = Y2;
	m_Color[0] = Color;
	SetFlag( true, NOTEX_FLAG|TRI_FLAG);
}

//========================================================================
//					|CgXvCgZbg
//========================================================================
void		SK7Sprite::SetTexPointSprite( f32 X, f32 Y, u8 Size, TEX_DATA* tex, u16 SNo, u16 TNo, u16 TexNo )
{
	m_Size = Size;
	SetFlag( true, POINT_FLAG );
	m_TexData = *tex;

	m_WNum 	= SNo;	m_HNum 	= TNo;
	m_TexNo = TexNo;
	if( m_WNum > 0 || m_HNum > 0 ){
		SetFlag( true, BLOCK_FLAG );
	}	
	m_Vector[0].x = X;	m_Vector[0].y = Y;
}


//========================================================================
//					XvCg`
//========================================================================
void		SK7Sprite::RenderSprite()
{
	Vec vPos[4];
	memset( &vPos, 0, sizeof( Vec )*4 );
	//eNX`t	-------------------------------------------------
	if( !CheckFlag( NOTEX_FLAG ) )
	{
		if( m_TexData.Header != NULL || CheckFlag(SCREEN_FLAG) ){
			GXLoadTexObj( &m_TexData.Obj, GX_TEXMAP0 );
		}

		if( !CheckFlag(VTX4_FLAG))
		{
			if( CheckFlag(BLOCK_FLAG) )
			{
				f32 Width 	=  (m_TexData.Header->mWidth*m_vEx.x)/m_WNum;
				f32 Height 	=  (m_TexData.Header->mHeight*m_vEx.y)/m_HNum;
				if( CheckFlag( CENTER_FLAG )){
					vPos[1].x = vPos[3].x = (m_Vector[0].x + Width*0.5f);
					vPos[2].x = vPos[0].x = (m_Vector[0].x - Width*0.5f);
					vPos[1].y = vPos[0].y = (m_Vector[0].y - Height*0.5f);	
					vPos[2].y = vPos[3].y = (m_Vector[0].y + Height*0.5f);
				}else{
					vPos[1].x = vPos[3].x = m_Vector[0].x + Width;
					vPos[2].x = vPos[0].x = m_Vector[0].x;
					vPos[1].y = vPos[0].y = m_Vector[0].y;
					vPos[2].y = vPos[3].y = m_Vector[0].y + Height;
				}
				
				if( m_WNum > 1 )
				{ 
					m_S[0] = m_S[2] = (f32)(1.0f/m_WNum)*m_TexNo - (1.0f*(u16)(m_TexNo/m_WNum));
					m_S[1] = m_S[3] = (f32)(1.0f/m_WNum)*(m_TexNo+1) - (1.0f*(u16)(m_TexNo/m_WNum));
				}
				else
				{
					m_S[0] = m_S[2] = (f32)0.0f;
					m_S[1] = m_S[3] = 1.0f;
				}
				if( m_HNum > 1 )
				{
					m_T[0] = m_T[1] = (f32)(1.0f/m_HNum)*(u16)(m_TexNo/m_WNum);
					m_T[2] = m_T[3] = (f32)(1.0f/m_HNum)*(u16)((m_TexNo+m_WNum)/m_WNum);
				}
				else
				{
					m_T[0] = m_T[1] = 0.0f;
					m_T[2] = m_T[3] = 1.0f;
				}
				if( CheckFlag( SIZE_FLAG )){
					vPos[1].x = vPos[3].x = (m_Vector[0].x + m_SizeXY.x*0.5f);
					vPos[2].x = vPos[0].x = (m_Vector[0].x - m_SizeXY.x*0.5f);
					vPos[1].y = vPos[0].y = (m_Vector[0].y - m_SizeXY.y*0.5f);	
					vPos[2].y = vPos[3].y = (m_Vector[0].y + m_SizeXY.y*0.5f);
				}
			}
			else if( CheckFlag(SIZE_FLAG) ){
				f32 Width 	=  m_SizeXY.x*m_vEx.x;
				f32 Height 	=  m_SizeXY.y*m_vEx.y;
				if( CheckFlag( CENTER_FLAG )){
					vPos[1].x = vPos[3].x = (m_Vector[0].x + Width*0.5f);
					vPos[2].x = vPos[0].x = (m_Vector[0].x - Width*0.5f);
					vPos[1].y = vPos[0].y = (m_Vector[0].y - Height*0.5f);	
					vPos[2].y = vPos[3].y = (m_Vector[0].y + Height*0.5f);
				}else{
					vPos[1].x = vPos[3].x = m_Vector[0].x + Width;
					vPos[2].x = vPos[0].x = m_Vector[0].x;
					vPos[1].y = vPos[0].y = m_Vector[0].y;
					vPos[2].y = vPos[3].y = m_Vector[0].y +  Height;	
				}
			}else{
				f32 Width = m_TexData.Header->mWidth*m_vEx.x;
				f32 Height = m_TexData.Header->mHeight*m_vEx.y;
				if( CheckFlag( CENTER_FLAG )){
					vPos[1].x = vPos[3].x = (m_Vector[0].x + Width*0.5f);
					vPos[2].x = vPos[0].x = (m_Vector[0].x - Width*0.5f);
					vPos[1].y = vPos[0].y = (m_Vector[0].y - Height*0.5f);
					vPos[2].y = vPos[3].y = (m_Vector[0].y + Height*0.5f);
				}else{
					vPos[1].x = vPos[3].x = (s16)(m_Vector[0].x + Width);
					vPos[2].x = vPos[0].x = m_Vector[0].x;
					vPos[1].y = vPos[0].y = m_Vector[0].y;
					vPos[2].y = vPos[3].y = (s16)(m_Vector[0].y + Height);
				}
			}
		}
		else
		{
			for( int i = 0; i < 4; i++ ){
				memcpy( &vPos[i], &m_Vector[i], sizeof( Vec ) ); 
			}
			if( m_WNum > 1 )
			{ 
				m_S[0] = m_S[2] = (f32)(1.0f/m_WNum)*m_TexNo - (1.0f*(u16)(m_TexNo/m_WNum));
				m_S[1] = m_S[3] = (f32)(1.0f/m_WNum)*(m_TexNo+1) - (1.0f*(u16)(m_TexNo/m_WNum));
			}
			else
			{
				m_S[0] = m_S[2] = (f32)0.0f;
				m_S[1] = m_S[3] = 1.0f;
			}
			if( m_HNum > 1 )
			{
				m_T[0] = m_T[1] = (f32)(1.0f/m_HNum)*(u16)(m_TexNo/m_WNum);
				m_T[2] = m_T[3] = (f32)(1.0f/m_HNum)*(u16)((m_TexNo+m_WNum)/m_WNum);
			}
			else
			{
				m_T[0] = m_T[1] = 0.0f;
				m_T[2] = m_T[3] = 1.0f;
			}
		}
	}
	else	//	eNX`[	---------------------------------------
	{
		if( CheckFlag(SIZE_FLAG) ){
			vPos[0].x = vPos[2].x = m_Vector[0].x; 
			vPos[1].x = vPos[3].x = m_Vector[0].x + m_SizeXY.x;
			
			vPos[1].y = vPos[0].y = m_Vector[0].y;
			vPos[2].y = vPos[3].y = m_Vector[0].y + m_SizeXY.y;
		}else if( !CheckFlag(VTX4_FLAG) ){ 
			vPos[0].x = vPos[2].x = 0.0f;
			vPos[1].x = vPos[3].x = 640.0f;
			vPos[0].y = vPos[1].y = 0.0f;
			vPos[2].y = vPos[3].y = 480.0f;
		}else{
			for( int i = 0; i < 4; i++ ){
				memcpy( &vPos[i], &m_Vector[i], sizeof( Vec ) ); 
			}
		}
	}

	//	v~eBu쐬	----------------------
	GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, 4 );
	
		for( int i = 0; i < 4; i++ )
		{
			GXPosition3f32( vPos[i].x, vPos[i].y, vPos[i].z );
//			GXPosition3f32( m_Vector[i].x, m_Vector[i].y, m_Vector[i].z );
			if( CheckFlag(V4COLOR_FLAG) )
			{
			  	GXColor1u32(m_Color[i]);
			}else{
				GXColor1u32(m_Color[0]);
			}
			
			if( !CheckFlag(NOTEX_FLAG) )	GXTexCoord2f32( m_S[i], m_T[i] );
		}
	GXEnd();
}


//========================================================================
//					gCAO`
//========================================================================
void	SK7Sprite::RenderTriangle()
{
	//	eNX`[h
	if( !CheckFlag(NOTEX_FLAG))		GXLoadTexObj( &m_TexData.Obj, GX_TEXMAP0 );
		
	//	v~eBu쐬	----------------------
	GXBegin( GX_TRIANGLES, GX_VTXFMT0, 3 );
		for( int i = 0; i < 3; i++ )
		{
			GXPosition3f32( m_Vector[i].x, m_Vector[i].y, m_Vector[i].z );
			GXColor1u32(m_Color[0]);
			if( !CheckFlag(NOTEX_FLAG))		GXTexCoord2f32( m_S[i], m_T[i] );
		}
	GXEnd();
}


//========================================================================
//					Clp``
//========================================================================
void	SK7Sprite::RenderLineQuad()
{		
	//	eNX`[Ȃ
	GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_FALSE);
	
	//	C
	GXSetLineWidth(m_Size, GX_TO_ZERO);

	//0 |PPP|1
	//  |      |
	//  |      |
	//3  PPP 2
	
	//	W	--------------------------------
	f32 X0 = m_Vector[0].x;
	f32 X1 = m_Vector[0].x + m_SizeXY.x;
	f32 Y0 = m_Vector[0].y;
	f32 Y1 = m_Vector[0].y + m_SizeXY.y;

	//	v~eBu쐬	----------------------
	if( CheckFlag(UPLINE_FLAG) ){
		GXBegin( GX_LINES, GX_VTXFMT0, 6 );
	}else{
		GXBegin( GX_LINES, GX_VTXFMT0, 8 );
	}
	
	//	㉡	-----------------------------------------------------
	if( !CheckFlag(UPLINE_FLAG) ){
		GXPosition3f32( X0 - m_Size*0.06f, Y0, m_Vector[0].z );
		if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[0]);
		else									GXColor1u32(m_Color[0]);
		
		GXPosition3f32( X1 + m_Size*0.06f, Y0, m_Vector[1].z );
		if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[1]);
		else									GXColor1u32(m_Color[0]);
	}

	//		------------------------------------------------------
	GXPosition3f32( X0 - m_Size*0.06f, Y1, m_Vector[3].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[1]);
	else									GXColor1u32(m_Color[0]);

	GXPosition3f32( X1 + m_Size*0.06f, Y1, m_Vector[2].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[2]);
	else									GXColor1u32(m_Color[0]);

	//	Ec	------------------------------------------------------
	GXPosition3f32( X1, Y0, m_Vector[1].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[3]);
	else									GXColor1u32(m_Color[0]);
	
	GXPosition3f32( X1, Y1, m_Vector[2].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[0]);
	else									GXColor1u32(m_Color[0]);

	//	c	------------------------------------------------------
	GXPosition3f32( X0, Y0, m_Vector[0].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[3]);
	else									GXColor1u32(m_Color[0]);
	
	GXPosition3f32( X0, Y1, m_Vector[3].z );
	if( CheckFlag(V4COLOR_FLAG) )			GXColor1u32(m_Color[0]);
	else									GXColor1u32(m_Color[0]);

	GXEnd();
}


//========================================================================
//					|Cg`
//========================================================================
void	SK7Sprite::RenderPoint()
{
	//	eNX`[h
	if( !CheckFlag(NOTEX_FLAG))
	{
		GXLoadTexObj( &m_TexData.Obj, GX_TEXMAP0 );
		//	|CgXvCgeNX`ݒ
		GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_TRUE);
	}
	else
	{
		GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_FALSE);
	}	
	//	TCYݒ
	GXSetPointSize(m_Size,GX_TO_ONE);
	
	//	|Cg
	GXBegin( GX_POINTS, GX_VTXFMT0, 1 );
		GXPosition3f32( m_Vector[0].x, m_Vector[0].y, m_Vector[0].z );
		GXColor1u32(m_Color[0]);
		if( !CheckFlag(NOTEX_FLAG))		GXTexCoord2f32( 0.0f, 0.0f );
	GXEnd();
}

//========================================================================
//					C`
//========================================================================
void	SK7Sprite::RenderLine()
{
	if( !CheckFlag(NOTEX_FLAG))
	{
		GXLoadTexObj( &m_TexData.Obj, GX_TEXMAP0 );
		//	|CgXvCgeNX`ݒ
		GXEnableTexOffsets(GX_TEXCOORD0, GX_TRUE, GX_FALSE);
	}
	else
	{
		GXEnableTexOffsets(GX_TEXCOORD0, GX_FALSE, GX_FALSE);
	}
	
	//	C
	GXSetLineWidth(m_Size, GX_TO_ZERO);

	//	v~eBu쐬	----------------------
	GXBegin( GX_LINES, GX_VTXFMT0, 2 );
		for( int i = 0; i < 2; i++ )
		{
			GXPosition3f32( m_Vector[i].x, m_Vector[i].y, m_Vector[i].z );
			if( CheckFlag(V4COLOR_FLAG) )
			{
				GXColor1u32(m_Color[i]);
			}else{
				GXColor1u32(m_Color[0]);
			}
			if( !CheckFlag(NOTEX_FLAG) )		GXTexCoord2f32( m_S[i*3], m_T[i*3] );
		}
	GXEnd();
}


//========================================================================
//					`
//========================================================================
void	SK7Sprite::Render()
{
	Set2DCamera();
	if( CheckFlag( Z_FLAG ) ){
		SetEnvZ();
	}else{
		SetEnv();
	}
	//\tOmF
	if( CheckFlag(RENDER_FLAG) )
	{
		//	At@[Zbg
		SetAlphaColor(CheckFlag(ALPHA_FLAG),CheckFlag(COLOR_FLAG));
		//	uhZbg
		SetBlendMode( m_ucBlendNo );
		//	eNX`[̂Ƃ
		if( CheckFlag( NOTEX_FLAG ) ){
			SetTevStageNoTex();
			SetVertexNoTex();
		}else{
			if( m_Flag & I4_FLAG ){
				SetTevStageI4();
			}else{
				SetTevStage();
			}
			SetVertex();
		}
		if( CheckFlag(POINT_FLAG ) ){		//	|Cg
			RenderPoint();		
			return;
		}
		if( CheckFlag( LINE_FLAG ) ) {		//	CXvCg
			RenderLine();	
			return;
		}
		if( CheckFlag( TRI_FLAG ) ){		//	gCAO
			RenderTriangle();
			return;
		}
		if( CheckFlag( LINEQUAD_FLAG ) ){		//	Clp`
			RenderLineQuad();
			return;
		}
		if( !CheckFlag(TRI_FLAG|POINT_FLAG|LINE_FLAG|LINEQUAD_FLAG) ){
			RenderSprite();			//	XvCg
			return;
		}
	}	
}

//========================================================================
//					At@[
//========================================================================
void	SK7Sprite::SetAlpha(u8 A)
{
	u8 cR = (u8)(m_Color[0]>>24);
	u8 cG = (u8)((m_Color[0]<<8)>>24);
	u8 cB = (u8)((m_Color[0]<<16)>>24);
	
	//	J[Zbg
	SetColor( cR, cG, cB, A );
}


//========================================================================
//					At@[
//========================================================================
bool	SK7Sprite::DownAlpha(u8 speed, u8 Point)
{
	s16 a = (s16)GetAlpha();
	a -= 255/speed;
	SetAlpha((u8)a);
	if( a <= Point )
	{
		SetAlpha(Point);
		return true;
	}
	return false;
}
//========================================================================
//					At@[i
//========================================================================
bool	SK7Sprite::AddAlpha(u8 speed, u8 Point)
{
	s16 a = (s16)GetAlpha();
	a += 255/speed;
	SetAlpha((u8)a);
	if( a >= Point-5 )
	{
		SetAlpha(Point);
		return true;
	}
	return false;
}

//========================================================================
//					At@[i
//========================================================================
bool		SK7Sprite::FrameAlphaMove( u8 frame, u8 Point )
{
	u8 alpha = GetAlpha();
	alpha += (Point-m_ucSaveAlpha)/frame;
	SetAlpha( alpha );
	return true;
}

//========================================================================
//					eNX`[
//========================================================================
void	SK7Sprite::Delete()
{
	if( m_TexData.Header != NULL && CheckFlag(TEXLOAD_FLAG) )
	{
		GHMGCMEM_SAFE_FREE(m_TexData.Header);
	}
}


//========================================================================
//					]gXvCgݒ
//========================================================================
void	SK7Sprite::SetSpriteRot( f32 Angle, f32 CenterX, f32 CenterY, f32 SizeX, f32 SizeY, f32 rad )
{
	Mtx m;
	MTXRotDeg( m, 'z', Angle );
	SetFlag( true, VTX4_FLAG );
	f32 SX = SizeX*0.5f, SY = SizeY*0.5f;
	
	Vec v={-SX,-SY+rad,0};
	MTXMultVec( m, &v, &v );
	m_Vector[0].x = (CenterX+v.x);
	m_Vector[0].y = (CenterY+v.y);
                                 
	v.x = SX; v.y = -SY+rad;         
	MTXMultVec( m, &v, &v );     
	m_Vector[1].x = (CenterX+v.x);
	m_Vector[1].y = (CenterY+v.y);
	                             
	v.x = -SX; v.y = SY+rad;         
	MTXMultVec( m, &v, &v );     
	m_Vector[2].x = (CenterX+v.x);
	m_Vector[2].y = (CenterY+v.y);
	                             
	v.x = SX; v.y = SY+rad;          
	MTXMultVec( m, &v, &v );     
	m_Vector[3].x = (CenterX+v.x);
	m_Vector[3].y = (CenterY+v.y);
}
