////////////////////////////////////////////////////////////////////////////////
//
// Killer7 SK7Sprite
//
// SK7Sprite.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7SPRITE_H__
#define	__SK7SPRITE_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTex.h"
#include "SK7Common.h"


//	tO	-----------------------------------
#define		RENDER_FLAG		(1<<0)		//	`tO
#define		VTX4_FLAG		(1<<1)		//	S_tO
#define		POINT_FLAG		(1<<2)		//	|CgXvCg
#define		LINE_FLAG		(1<<3)		//	CtO
#define		TEXLOAD_FLAG	(1<<4)		//	eNX`[[h
#define		TRI_FLAG		(1<<6)		//	gCAOtO
#define		ALPHA_FLAG		(1<<7)		//	At@tO
#define		COLOR_FLAG		(1<<8)		//	J[tO
#define		BLEND_FLAG		(1<<9)		//	uhtO
#define		NOTEX_FLAG		(1<<10)		//	eNX`[tO
#define		BLOCK_FLAG		(1<<12)		//	Əc̕ߕt
#define		V4COLOR_FLAG	(1<<13)		//	S_J[
#define		SCREEN_FLAG		(1<<14)		//	XN[tO
#define		Z_FLAG			(1<<15)		//	Žp
#define		SIZE_FLAG		(1<<16)		//	TCYZbg
#define		LINEQUAD_FLAG	(1<<17)		//	lp`쐬
#define		UPLINE_FLAG		(1<<18)		//	̃C
#define		CENTER_FLAG		(1<<19)		//	gkZ^[S
#define		I4_FLAG			(1<<20)		//	I4eNX`[p
#define		DITHER_FLAG		(1<<21)		//	fBUtO

#define		NORMAL_Z			(30)

//	uh[h
enum{
	SPR_BLEND_NORMAL=0,
	SPR_BLEND_NOT,
	SPR_BLEND_ONE,		//	Z
	SPR_BLEND_MULTI,	//	Z
};


//
//	XvCgNX

class	SK7Sprite
{
protected:
	SK7File					m_TexFile;		//	eNX`pt@CNX
	TEX_DATA				m_TexData;		//	eNX`f[^

	Vec				m_Vector[4];			//	Z
	VEC2			m_SizeXY;				//	TCYp
	VEC2			m_vEx;					//	gk{
	f32				m_S[4], m_T[4];			//	STeNX`W
	u32				m_Color[4];
	u32				m_Flag;					//	tO
	u16				m_WNum, m_HNum;			//	̐Ac̐
	u16				m_TexNo;				//	eNX`No
	u8				m_Size;					//	CA|Cg̃TCY
	u8				m_ucBlendNo;			//	uhԍ		
	u8				m_DstAlpha;				//	At@
	u8				m_ucSaveAlpha;			//	Z[uAt@

public:
	SK7Sprite();
	~SK7Sprite();

	//	eNX`[h
	bool			LoadTexture(  char* FileaName, u16 wno=1, u16 hno=1);
	
	//	J Cg ̐ݒ
	void		SetEnv();
	void		SetEnvZ();

	//	XvCg`
	void		RenderSprite();
	//	Op``
	void		RenderTriangle();
	//	C`
	void		RenderLine();
	//	|Cg`
	void		RenderPoint();
	//	tF[h`
	void		RenderFade();
	//	Clp``
	void		RenderLineQuad();

	//	`	
	void		Render();
	
	//	At@[`FbN
	void 		SetAlphaColor(bool aflag, bool cflag );
	//	uh
	void		SetBlendMode(u8 flag);
	
	//	eNX`J
	void 		Delete();

	//	-----------------------------
	//	SET
	//	-----------------------------
	
	//	_J[̃Zbg
	void		SetColor(u8 R, u8 G, u8 B, u8 A){ m_Color[0] = (u32)((R<<24)+(G<<16)+(B<<8)+(A)); }
	void		SetColor(u32 color){ m_Color[0] = color; }
	void		SetColor(u8 No, u8 color){ m_Color[No] = color; }
	void		SetColor(u8 No, u8 R, u8 G, u8 B, u8 A){ m_Color[No] = (u32)((R<<24)+(G<<16)+(B<<8)+(A)); }
	void		SetColor4(u32 c0,u32 c1,u32 c2,u32 c3){ m_Color[0]=c0, m_Color[1]=c1, m_Color[2]=c2, m_Color[3]=c3; } 
	void		SetAlpha(u8 A);
	void		SetBlendNo(u8 No=0){ m_ucBlendNo = No; }
	
	//	_WZbg
	void		SetX0(f32 x){ m_Vector[0].x = x; }
	void		SetX1(f32 x){ m_Vector[1].x = x; }
	void		SetX2(f32 x){ m_Vector[2].x = x; }
	void		SetX3(f32 x){ m_Vector[3].x = x; }

	void		SetY0(f32 y){ m_Vector[0].y = y; }
	void		SetY1(f32 y){ m_Vector[1].y = y; }
	void		SetY2(f32 y){ m_Vector[2].y = y; }
	void		SetY3(f32 y){ m_Vector[3].y = y; }
	
	void		SetXY( int No, f32 x, f32 y){ m_Vector[No].x = x, m_Vector[No].y = y; }
	void		SetXY0(f32 x, f32 y){ m_Vector[0].x = x, m_Vector[0].y = y; }
	void		SetXY1(f32 x, f32 y){ m_Vector[1].x = x, m_Vector[1].y = y; }
	void		SetXY2(f32 x, f32 y){ m_Vector[2].x = x, m_Vector[2].y = y; }
	void		SetXY3(f32 x, f32 y){ m_Vector[3].x = x, m_Vector[3].y = y; }

	void		SetXY0(VEC2* v){ m_Vector[0].x = v->x, m_Vector[0].y = v->y; }
	void		SetXY1(VEC2* v){ m_Vector[1].x = v->x, m_Vector[1].y = v->y; }
	void		SetXY2(VEC2* v){ m_Vector[2].x = v->x, m_Vector[2].y = v->y; }
	void		SetXY3(VEC2* v){ m_Vector[3].x = v->x, m_Vector[3].y = v->y; }
	
	void		SetXYTwo(f32 x0, f32 y0, f32 x1, f32 y1){ m_Vector[0].x=m_Vector[2].x=x0; m_Vector[1].x=m_Vector[3].x=x1; m_Vector[0].y=m_Vector[1].y=y0; m_Vector[2].y=m_Vector[3].y=y1; m_SizeXY.x = (x1-x0); m_SizeXY.y = (y1-y0); }

	void		SetXYZ0(f32 x, f32 y, f32 z){ m_Vector[0].x = x, m_Vector[0].y = y; m_Vector[0].z = z; }
	void		SetXYZ1(f32 x, f32 y, f32 z){ m_Vector[1].x = x, m_Vector[1].y = y; m_Vector[1].z = z; }
	void		SetXYZ2(f32 x, f32 y, f32 z){ m_Vector[2].x = x, m_Vector[2].y = y; m_Vector[2].z = z; }
	void		SetXYZ3(f32 x, f32 y, f32 z){ m_Vector[3].x = x, m_Vector[3].y = y; m_Vector[3].z = z; }
	
	void		SetPos0(Vec v){ m_Vector[0].x = v.x, m_Vector[0].y = v.y, m_Vector[0].z = v.z; }
	void		SetPos1(Vec v){ m_Vector[1].x = v.x, m_Vector[1].y = v.y, m_Vector[1].z = v.z; }
	void		SetPos2(Vec v){ m_Vector[2].x = v.x, m_Vector[2].y = v.y, m_Vector[2].z = v.z; }
	void		SetPos3(Vec v){ m_Vector[3].x = v.x, m_Vector[3].y = v.y, m_Vector[3].z = v.z; }
	
	void		SetIncXLeft(f32 X){ m_Vector[0].x+=X, m_Vector[2].x+=X; }
	void		SetIncXRight(f32 X){ m_Vector[1].x+=X, m_Vector[3].x+=X; }	
	void		SetIncX(f32 X){ m_Vector[0].x+=X,m_Vector[1].x+=X,m_Vector[2].x+=X,m_Vector[3].x+=X; }
	void		SetIncY(f32 Y){ m_Vector[0].y+=Y,m_Vector[1].y+=Y,m_Vector[2].y+=Y,m_Vector[3].y+=Y; }
	void		SetIncXY(f32 X, f32 Y){ m_Vector[0].x+=X,m_Vector[1].x+=X,m_Vector[2].x+=X,m_Vector[3].x+=X;
										m_Vector[0].y+=Y,m_Vector[1].y+=Y,m_Vector[2].y+=Y,m_Vector[3].y+=Y; }

	//	g嗦̎w
	void		SetEX( f32 size ){ m_vEx.x = m_vEx.y = size; };
	void		SetEX( f32 x, f32 y ){ m_vEx.x = x, m_vEx.y = y; }
	
	//	Z̃Zbg
	void		SetZ(f32 z){ m_Vector[0].z = m_Vector[1].z = m_Vector[2].z = m_Vector[3].z = z; }
	
	
	//	|CgACTCY
	void		SetSize(u8 size){ m_Size = size; }
	void		SetIncSize(int size){ m_Size += size; }
	
	//	傫_wTCYZbg
	void		SetTwoSize	( VEC2* vSize )	{ 	m_SizeXY = *vSize;		SetFlag( true, SIZE_FLAG ); }
	void		SetTwoSize	( f32 x, f32 y )	{	m_SizeXY.x = x, m_SizeXY.y = y; SetFlag( true, SIZE_FLAG ); }
	void		SetSizeX	( f32 x )		{ m_SizeXY.x = x; }
	void		SetSizeY	( f32 y )		{ m_SizeXY.y = y; }
	
	void		SetIncSizeX ( f32 x ){ m_SizeXY.x += x; }
	void		SetIncSizeY ( f32 y ){ m_SizeXY.y += y; }
	void		SetIncSizeXY( f32 x, f32 y ){ m_SizeXY.x += x, m_SizeXY.y += y; }
	
	//	eNX`W̃Zbg
	void		SetST0(f32 s, f32 t){ m_S[0] = s, m_T[0] = t; }
	void		SetST1(f32 s, f32 t){ m_S[1] = s, m_T[1] = t; }
	void		SetST2(f32 s, f32 t){ m_S[2] = s, m_T[2] = t; }
	void		SetST3(f32 s, f32 t){ m_S[3] = s, m_T[3] = t; }
	void		SetSTTwo(f32 s0, f32 t0, f32 s1, f32 t1){ m_S[0]=m_S[2]=s0, m_S[1]=m_S[3]=s1, m_T[0]=m_T[1]=t0, m_T[2]=m_T[3]=t1; }

	//	eNX`[mn쐬
	void		SetTexNo(u16 No){ m_TexNo = No; }

	//	tO
	void		SetFlag(bool set, int bit){	(set==true) ? m_Flag |= bit : m_Flag &= ~bit; }
	//	
	void		SetVisible(bool State){ SetFlag( State, RENDER_FLAG ); }
	//	S_
	void		SetVtxFour(bool State){ SetFlag( State, VTX4_FLAG ); }
	//	|Cg
	void		SetPoint(bool State){ SetFlag( State, POINT_FLAG ); }
	//	C
	void		SetLine(bool State){ SetFlag( State, LINE_FLAG ); }
	//	eNX`Zbg
	void		SetTexture(TEX_DATA *tex, u16 wnum=1, u16 hnum=1,u16 TexNo=0 ){ m_TexData = *tex; m_WNum = wnum; m_HNum = hnum; m_TexNo = TexNo; }
	void		SetTexture(GXTexObj *Data){ m_TexData.Obj = *Data; }
	//	At@
	void		SetDstAlpha(u8 alpha){ m_DstAlpha = alpha; }
	
	//	At@Zbgړ
	void		SetAlphaStart(u8 alpha){ m_ucSaveAlpha = alpha; }
	bool		FrameAlphaMove( u8 frame, u8 Point ); 
	//	At@Z
	bool		AddAlpha(u8 speed, u8 Point=0xff);
	//	At@Z
	bool		DownAlpha(u8 speed, u8 Point=0x00);
	
	//	SZbgiCNAbhj
	void		SetLineQuad( f32 X, f32 Y, f32 SX, f32 SY, u32 Color, u8 Size );
	//	m[}
	void		SetTexSprite(f32 X, f32 Y, TEX_DATA* tex, u16 SNo=0, u16 TNo=0, u16 TexNo=0 );
	void		SetSprite(f32 X, f32 Y, f32 SX, f32 SY, u32 Color);
	void		SetTexSpriteTwo( f32 X0, f32 Y0, f32 X1, f32 Y1, TEX_DATA* tex, u16 SNo=0, u16 TNo=0, u16 TexNo=0 );
	void		SetSpriteFlex( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, f32 X3, f32 Y3, u32 Color );
	void		SetTexSpriteFlex( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, f32 X3, f32 Y3, TEX_DATA* tex, u16 SNo=0, u16 TNo=0, u16 TexNo=0 );	
	void		SetSpriteRot( f32 Angle, f32 CenterX, f32 CenterY, f32 SizeX, f32 SizeY, f32 rad=0 );
	//	C
	void		SetLineSprite(f32 SX, f32 SY, f32 EX, f32 EY, u8 Size, u32 Color);
	void		SetTexLineSprite(f32 SX, f32 SY, f32 EX, f32 EY, TEX_DATA* tex, u8 Size);
	//	gCAOZbg
	void		SetTriangle( f32 X0, f32 Y0, f32 X1, f32 Y1, f32 X2, f32 Y2, u32 Color );
	//	|Cg
	void		SetTexPointSprite( f32 X, f32 Y, u8 Size, TEX_DATA* tex, u16 SNo=0, u16 TNo=0, u16 TexNo=0 );
	
	//	------------------------------
	//		CHECK
	//	------------------------------
	bool		CheckFlag(int bit){ return ( m_Flag & bit ) ? true : false;  }
	
	//	------------------------------
	//		GET
	//	------------------------------
	//	W̎擾
	f32			GetX0(){ return m_Vector[0].x; }
	f32			GetY0(){ return m_Vector[0].y; }
	f32			GetX1(){ return m_Vector[1].x; }	
	f32			GetY1(){ return m_Vector[1].y; }
	f32			GetX2(){ return m_Vector[2].x; }
	f32			GetY2(){ return m_Vector[2].y; }
	f32			GetX3(){ return m_Vector[3].x; }
	f32			GetY3(){ return m_Vector[3].y; }
	
	f32			GetS0(){ return m_S[0]; }
	f32			GetS1(){ return m_S[1]; }
	f32			GetS2(){ return m_S[2]; }
	f32			GetS3(){ return m_S[3]; }
	
	f32			GetT0(){ return m_T[0]; }
	f32			GetT1(){ return m_T[1]; }
	f32			GetT2(){ return m_T[2]; }
	f32			GetT3(){ return m_T[3]; }

	
	Vec*		GetPos0(){ return &m_Vector[0]; }
	Vec*		GetPos1(){ return &m_Vector[1]; }
	Vec*		GetPos2(){ return &m_Vector[2]; }
	Vec*		GetPos3(){ return &m_Vector[3]; }
	
	f32			GetSizeX(){ return m_SizeXY.x; }
	f32 		GetSizeY(){ return m_SizeXY.y; }
	
	u16			GetBlockW(){ return m_WNum; }
	u16			GetBlockH(){ return m_HNum; }

	u8			GetAlpha(){	return (u8)((m_Color[0]<<24)>>24); }
	TEX_DATA*	GetTexture(){ return &m_TexData; }
	u16			GetTexNo(){ return m_TexNo; }
	u32			GetColor(){ return m_Color[0]; }
	u32			GetColor(u8 No){ return m_Color[No]; }
	u8			GetColorR(u8 No){ return (u8)(m_Color[No]>>24); }
	u8			GetColorG(u8 No){ return (u8)((m_Color[No]<<8)>>24); }
	u8			GetColorB(u8 No){ return (u8)((m_Color[No]<<16)>>24); }
	
	
	f32			GetTexSizeX(){ return m_TexData.Header->mWidth; }
	f32			GetTexSizeY(bool cut=false){ if( !cut ) return m_TexData.Header->mHeight; else return m_TexData.Header->mHeight/m_HNum;}
	
	f32			GetExX(){ return m_vEx.x; }
	f32			GetExY(){ return m_vEx.y; }

};

#endif