////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// SK7TestTask.h
//
// Creator       : Sato Shinya (GHM)
// Creation Date : 08/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__SK7TESTTASK_H__
#define	__SK7TESTTASK_H__

#include "..\Lib\ghmGcAppTask.h"
#include "..\Lib\ghmGcMem.h"
#include "..\Lib\ghmGcTask.h"
#include "..\Lib\ghmGcFile.h"
#include "..\Lib\ghmGcTex.h"
#include "../wat/WK7Model.h"
#include "../wat/WK7Archive.h"
#include "SK7Sprite.h"
#include "SK7ScenarioTask.h"

#include "SK7PanelBase.h"
#include "SK7Death.h"
#include "SK7LogoTask.h"
#include "SK7IMenuBase.h"
#include "SK7IMenuPola.h"
//#include "SK7SaveLoad.h"
#include "SK7Special.h"
#include "SK7SpOption.h"
#include "SK7NextTask.h"
#include "SK7IMenuMap.h"


enum{
	MAIN_PROC=0,
	DEATH_PROC,
	ULMYDA_PROC,
	POLA_PROC,
	SAVE_PROC,
	CHARA_PROC,
	TEX_PROC,
	NEXT_PROC,
	STAFF1_PROC,
	STAFF2_PROC,
	MAP_PROC,
};

enum{
	MAINPROC_LOAD=0,
	MAINPROC_MOVE,
};

enum{
	LOAD_CHARA_NAME=0,
	LOAD_SPECIAL_NAME,
};

//	eXg^XNNX
class SK7TestTask : public ghmGcAppTask
{
protected:
	SK7Death*		m_pDeath;
	SK7IMenuBase*	m_pUlmeyda;
	SK7IMenuBase*	m_pPola;
//	SK7SaveLoad*	m_pSaveLoad;
	SK7Special*		m_pSpecial;
	SK7SpOption*	m_pSpOption;
	SK7NextTask*	m_pNext;
	SK7IMenuBase*	m_pMap;

	Vec				m_vSight;
	u8				m_chProcNoSelect;
	u8				m_chProcNo;
	u8				m_chSelectNo;
	u8				m_MainProcess;
	u8				m_Load;

	ghmGcTaskController *m_pTaskControl;	//	^XNRg[[

public:
	SK7TestTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~SK7TestTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);

	//	f[^[h
	bool	LoadData();
	
	//	C
	void	MainFrameProcess();
	void	MainRenderProcess();
	//	I
	void	DeleteProcess();
	//	Spt[vZX
	void	DeathProcess();
	//	EC_p
	void	UlmydaProcess();
	//	|Chp
	void	PolaProcess();
	//	Z[u[hp
	void	SaveLoadProcess();
	//	L`FWp
	void	CharaChangeProcess();
	//	lNXgp
	void	NextProcess();
	//	}bvp
	void	MapProcess();
};

#endif	//__SK7TESTTASK_H__



