////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Scn00
//
// K7Scn00.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7SCN00_CPP__
#pragma	warn_unusedarg			off

#include "..\Wat\WK7EventScript.h"
#include "..\Wat\WK7EventItem.h"
#include "..\Wat\WK7HitObj.h"

////////////////////////////////////////////////////////////////////////////////
// CxgfXNv^`
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_BODY_PART
#include ".\K7Scn00.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7Enemy.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Yam\YK7CharChange.h"
#include "..\Yam\YK7EffectMessage.h"

#define DAN_VER			(00)

#if 0
enum{
	MSEXPLODE = 0,
	HSAPPEAR,
	STG000M00_ENMDIE,
	STG002M00_ENMDIE,										// 2F3F̃ANZXL[
	STG003M00_ENMDIE,
	STG004M00_00030101,
	STG004M00_00030103,
	STG004M00_00030104,
	STG004M00_00030105,
	STG004M00_00030106,
	STG004M00_00030107,
	STG004M00_00030108,
	STG004M01_ENMDIE,
	STG006M00_ENMDIE,
	STG006M00_KEYOPEN,
	EV_CONFERENCE,
	EV_DAN_RECOVER,
};

#define	ENMDIE

void K7SCN00_SetExtraCamera(u32 extno);
void K7SCN00_SetExtraCamera(u32 extno)
{
	WK7Extra	*pExtra = (WK7Extra *)WK7Npc::Find(extno);
	if( pExtra==NULL ){
		return;
	}
	WK7Chara	*pChara = pExtra->pCurrentChara();
	if( pChara==NULL ){
		return;
	}
	WK7JObj		*pSkullJObj = pChara->GetJObj(K7CHRBONE_SKULL);
	if( pSkullJObj==NULL ){
		return;
	}
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	
	Vec			pos;
	f32			roty;
	MtxPtr		mtxptr;
	pChara->GetRotY(&roty);
//static f32		dist = 5.0f;
//static f32		dist = 2.0f;
//static f32		yadj = -2.0f;
//static f32		aimdist = 3.0f;
static f32		dist = 2.0f;
static f32		yadj = -1.0f;
static f32		aimdist = 1.5f;
	
	mtxptr = pSkullJObj->GetLocalWorldMatrix();
	
	pos.x = mtxptr[0][3];
	pos.y = mtxptr[1][3];
	pos.z = mtxptr[2][3];
	pos.x += aimdist * sin(roty);
	pos.z += aimdist * cos(roty);
	
	roty += D2R(30.0f);
	GHM_LIMIT_RANGE(roty,PI,-PI);
	
	WK7CAM->SetTargetPosition(pos);
	
	pos.x += dist * sin(roty);
	pos.y += yadj;
	pos.z += dist * cos(roty);
	
	WK7CAM->SetPosition(pos);
}

////////////////////////////////////////////////////////////////////////////////
// nh`
////////////////////////////////////////////////////////////////////////////////

K7EV_HANDLER(K7SCN00_Cancel)
{
}

K7EV_HANDLER(K7SCN00_CancelS)
{
	WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
	pSelectObj->SetEnable(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
}
#endif

K7EV_HANDLER(K7SCN00_Opening)
{
	WK7Play		*pPlay,*pPrevPlay;
	const char	**ppPlayFile;
static	const char	*pPlayTable[] = {
	"00010105",
	"00010101b",
	"00010104",
	"00010101a",
	"00010106",
	"00010103",
//	"00010109",
//	"00010108",
	"00010102",
//	"00010108a",
	"00010107",
//	"00010108b",
//	"00010201",
	"00020101",
	NULL,
};
	
	WK7Play::SetExceptPlayRenderObj(false);
	
	u32		fadetime = 2 * 4800;
	
	pPlay      = 
	pPrevPlay  = NULL;
	ppPlayFile = pPlayTable;
	while( *ppPlayFile!=NULL ){
		while( (pPlay = WK7Play::Create(*ppPlayFile))==NULL ){
			if( pPrevPlay!=NULL && pPrevPlay->GetState()!=WK7Play::PLAY ){
				k7app.FadeStart(0xff,4800);
				k7app.SetFadeColor(0);
				fadetime = 4800;
				while( k7app.IsFade()==true ){
					K7SCR_RETSYS();
				}
				GHM_SAFE_DELETE(pPrevPlay);
			}
			K7SCR_RETSYS();
		}
		if( pPrevPlay!=NULL ){
			while( pPrevPlay->GetState()==WK7Play::PLAY ){
				K7SCR_RETSYS();
			}
		}
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		if( pPrevPlay==NULL ){
			k7app.FadeStart(0x00,fadetime);
		}
		pPlay->Start();
		GHM_SAFE_DELETE(pPrevPlay);
		pPrevPlay = pPlay;
		ppPlayFile++;
	}
	if( pPrevPlay!=NULL ){
		while( pPrevPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
	}
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	GHM_SAFE_DELETE(pPrevPlay);
	
	WK7Play::SetExceptPlayRenderObj(true);
}

HSD_TObj* GetScreenTObj(WK7Model *pModel,const char *pDObjName);
HSD_TObj* GetScreenTObj(WK7Model *pModel,const char *pDObjName)
{
	if( pModel==NULL ){
		return NULL;
	}
	WK7JObj		*pJObj = pModel->GetTopObj();
	if( pJObj==NULL ){
		return NULL;
	}
	HSD_DObj	*pDObj = pJObj->GetDObj(pDObjName);
	if( pDObj==NULL ){
		return NULL;
	}
	HSD_MObj	*pMObj = pDObj->mobj;
	if( pMObj==NULL ){
		return NULL;
	}
	return pMObj->tobj;
}

HSD_TObj* GetScreenTObj(WK7JObj *pJObj);
HSD_TObj* GetScreenTObj(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return NULL;
	}
	HSD_DObj	*pDObj = pJObj->GetDObjByPartialName("Screen");
	if( pDObj==NULL ){
		return NULL;
	}
	HSD_MObj	*pMObj = pDObj->mobj;
	if( pMObj==NULL ){
		return NULL;
	}
	return pMObj->tobj;
}


// ViIOO
K7EV_HANDLER(K7SCN00_Init)
{
	k7app.FadeStart(0xff,2 * 4800);
//	k7app.FadeStart(0xff,0);
//	k7app.SetFadeColor(0);
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
//	
	K7SCR_PC_CREATE(K7CHRID(K7DAN,DAN_VER));			// fǂݍ
	K7SCR_PC_MOTIONCREATE(K7CHRID(K7DAN,DAN_VER));	// [Vǂݍ
	
	K7SCR_PC_CREATEWAIT();						// ǂݍݑ҂
	
//	k7app.FadeStart(0x00,4800);
//	while( !(HSD_PadGetTrigger(1) & HSD_PAD_B) ){
//		K7SCR_RETSYS();
//	}
	
#if 0
#ifdef	_DEBUG
//	K7SCR_GET_SCENARIO_FLAG(STG004M00_00030108)==true  ||
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030101);
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030103);
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030104);
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030105);
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030106);
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030107);
	k7app.FadeStart(0,0);
	k7app.SetFadeColor(0);
	while( WK7Stage::ChangeStage()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_PC_VISIBLE(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
	return;
#endif
#endif
	
	if( !(HSD_PadGetButton(0) & HSD_PAD_Y) )
	K7EV_CALL(K7SCN00_Opening);
	
	u32		stgid = K7STGID(0,0);
	K7SCR_STG_CREATE_B                  (stgid);
	K7SCR_STG_SET_CURRENT               (stgid);
	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set_start","C0",0.5f,K7SCR_CAM_PATHDIR_REV);
//	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set_start","C0_camera3",0.5f,K7SCR_CAM_PATHDIR_REV);
	K7SCR_STG_VISIBLE                   (stgid,true);
	// \
	K7SCR_PC_VISIBLE(true);
	
	// X^[g`FbN|Cg̐ݒ
//	K7SCR_STG_STARTCHKPOINTSET          (stgid);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	
	return;
	
#ifdef	_DEBUG
	while( WK7Stage::ChangeStage()==false ){
		K7SCR_RETSYS();
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
#endif
	
	// \
	K7SCR_PC_VISIBLE(true);
//	K7SCR_PC_SET_CURRENT_PLAYER(K7CHRID(K7DAN,DAN_VER));	
	GameInfo.SetMode(WK7GameInfo::MOVE);

	if( 0 ){
		WK7Stage		*pCurrentStage;
		u32				texid = 0;
		u32				stgid = K7STGID(0,0);
		GhmGcTexHeader	*pTexHeader [2];
		ghmGcFile		file;
		WK7Model		*pModel;
		HSD_TObj		*pScreenTObj[2];
		HSD_ImageDesc	screenImage [2];
		int				i;
		
		pTexHeader[0] = NULL;
		pTexHeader[1] = NULL;
		
		static char *pTexFile[2] = {
			"Wat/TV/TV_Dan.BIN",
			"Wat/TV/TV_Cat.BIN",
		};
		
		for(i=0 ; i<2 ; i++){
			while( file.Open(pTexFile[i])==false ){
				K7SCR_RETSYS();
			}
			pTexHeader[i] = (GhmGcTexHeader *)file.ReadB();
			file.Close();
			if( pTexHeader[i]==NULL ){
				break;
			}
			screenImage[i].image_ptr = GHMGCTEX_GETIMAGE(pTexHeader[i]);
			screenImage[i].width     = pTexHeader[i]->mWidth;
			screenImage[i].height    = pTexHeader[i]->mHeight;
			screenImage[i].format    = pTexHeader[i]->mFormat;
			screenImage[i].mipmap    = pTexHeader[i]->mMipmap;
			screenImage[i].minLOD    = pTexHeader[i]->mMinLOD;
			screenImage[i].maxLOD    = pTexHeader[i]->mMaxLOD;
		}
		if( i<2 ){
			GHMGCMEM_SAFE_FREE(pTexHeader[0]);
			GHMGCMEM_SAFE_FREE(pTexHeader[1]);
			K7SCR_EXIT();
		}
		
		pScreenTObj[0] = NULL;
		pScreenTObj[1] = NULL;
		
		while( 1 ){
			
			while( (pCurrentStage = WK7Stage::GetCurrentStage())==NULL ){
				K7SCR_RETSYS();
			}
			
			if( pCurrentStage->GetID()!=stgid ){
				pScreenTObj[0] = NULL;
				pScreenTObj[1] = NULL;
				K7SCR_RETSYS();
				continue;
			}
			
			if( (pModel=pCurrentStage->GetModel())==NULL ){
				K7SCR_RETSYS();
				continue;
			}
			
			if( pScreenTObj[0]==NULL && (pScreenTObj[0] = GetScreenTObj(pModel,"Screen01"))==NULL ){
				K7SCR_RETSYS();
				continue;
			}
			if( pScreenTObj[1]==NULL && (pScreenTObj[1] = GetScreenTObj(pModel,"Screen02"))==NULL ){
				K7SCR_RETSYS();
				continue;
			}
			
			if( !(HSD_PadGetTrigger(1) & HSD_PAD_X) ){
				K7SCR_RETSYS();
				continue;
			}
			
			texid ^= 1;
			
			pScreenTObj[0]->imagedesc = screenImage +  texid   ;
			pScreenTObj[1]->imagedesc = screenImage + (texid^1);
			K7SCR_RETSYS();
			
		}
		
		GHMGCMEM_SAFE_FREE(pTexHeader[0]);
		GHMGCMEM_SAFE_FREE(pTexHeader[1]);
	}
	
}

K7EV_HANDLER(K7SCN00_Term)
{
}

#if 0
const char		*pTVName = NULL;
K7EV_HANDLER(K7SCN00_TV)
{
	WK7PathBranchPointObjJObj	*pSelectObj = (WK7PathBranchPointObjJObj *)K7EV_GETEVENTPARAM(0);
	WK7Stage					*pStage;
	WK7JObj						*pTVJObj;
	WK7JObj						*pTgtJObj;
	HSD_TObj					*pTObj;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	K7SCR_TIMEWAIT(2400);
	
	if( pTVName!=NULL &&
	    (pStage=WK7Stage::GetCurrentStage())!=NULL &&
	    (pTVJObj=pStage->GetJObj(pTVName))!=NULL &&
	    (pTObj = GetScreenTObj(pTVJObj))!=NULL ){
		
		HSD_ImageDesc	screenImage;
		HSD_ImageDesc	*pOrgImage = pTObj->imagedesc;
		GXTexWrapMode	org_wrap_s,org_wrap_t;
		
		org_wrap_s = pTObj->wrap_s;
		org_wrap_t = pTObj->wrap_t;
		
		pTgtJObj = pSelectObj->GetJObj();
		
		screenImage.image_ptr = screenImageFullColor.GetTexture();
		screenImage.width     = 640;
		screenImage.height    = 480;
		screenImage.format    = GX_TF_RGBA8;
		screenImage.mipmap    = FALSE;
		screenImage.minLOD    = 0.0f;
		screenImage.maxLOD    = 0.0f;
		pTObj->imagedesc = &screenImage;
		pTObj->wrap_s    = GX_CLAMP;
		pTObj->wrap_t    = GX_CLAMP;
		
		Vec			pos,tgt,spos;
		
static f32	sdist = 20.0f;
//static f32	sdist = 12.0f;
		pTgtJObj->GetWorldPosition(tgt);
		WK7PLAYERCONTROL->GetPosition(pos);
		pos.y += 15.0f;
		spos   = pos;
		VECSubtract (&pos,&tgt,&spos);
		VECNormalize(&spos,&spos);
		VECScale    (&spos,&spos,sdist);
		VECAdd      (&spos,&tgt,&spos);
		VECSubtract (&pos,&tgt,&pos);
		VECNormalize(&pos,&pos);
static f32	dist = 8.0f;
		VECScale    (&pos,&pos,dist);
		VECAdd      (&pos,&tgt,&pos);

		// LI\}bv( Rc )
		ClearCharChangeMask() ;
		
		// ̃LN^IłȂ悤ɂ( InitCharChange ̑OɈړ܂ (Rc) )
		SetCharChangeMask((u8)WK7PLAYERCONTROL->GetMainID());
		
		// LN^`FW̏
		InitCharChange();
		
		WK7CAM->StoreState();
		WK7CAM->SetPosition(spos);
		WK7CAM->SetTargetPosition(tgt);
		WK7CAM->StartLinearInterpolateOnLinearPath(pos,
		                                           tgt,
		                                           60.0f * 2.0f);
		WK7PLAYERCONTROL->SetCameraAlphaControl(true);
		
		// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ ) 
		while( GetCharChangeState()==TRUE ){
			K7SCR_RETSYS();
		}
		
		k7app.SetFadeColor(0);
		k7app.FadeStart(0xff,WK7_DEFAULT_FADE_TICK);
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
		WK7CAM->RestoreState();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7PLAYERPATHCONTROL->CameraRenew();
		WK7PLAYERCONTROL->SetCameraAlphaControl(false);
		WK7PLAYERCONTROL->SetAlphaVal           (1.0f);
		
		pTObj->imagedesc = pOrgImage;
		pTObj->wrap_s = org_wrap_s;
		pTObj->wrap_t = org_wrap_t;
		
		WK7PLAYERCONTROL->ChangeChkPoint();			// `FbN|Cg̕ύXs
		
		// LN^`FW̌ns
		EndCharChange();
		
		// ILN^̂hc𓾂
		int		mainid  = GetSelectChar();
		if( mainid >= 0 ){
			u32		charaid = (u32)K7CHRID(mainid,0);
			if( WK7PLAYERCONTROL->GetMainID()!=charaid ){
				WK7PlayerChange(charaid);
			}
		}
		
		k7app.SetFadeColor(0);
		k7app.FadeStart(0x00,WK7_DEFAULT_FADE_TICK);
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
	}
	
	pTVName = NULL;
	
	pSelectObj->SetEnable(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
}

/*
	
	
	Xe[WOOO
	
	
*/
K7EV_HANDLER(K7SCN00_Stg000M00Init)
{
}

K7EV_HANDLER(K7SCN00_Stg000M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg000M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_HORAIZON_B);
}

K7EV_HANDLER(K7SCN00_SelectStg000M00TV)
{
	pTVName = "TV01";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg000M00TV1)
{
	pTVName = "TV02";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_MSExplode)
{
#if 0
	
	if( K7SCR_GET_SCENARIO_FLAG(MSEXPLODE)==true ){
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(MSEXPLODE);
	
	WK7Play				*pPlay = NULL;
	
	WK7CAM->StoreState();
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( (pPlay = WK7Play::Create("00020102a"))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(false);
	
	pPlay->Start();
	
	K7SCR_TIMEWAIT(2400);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_TIMEWAIT(2400);
	
	GHM_SAFE_DELETE(pPlay);
	
	WK7Play::SetExceptPlayRenderObj(true);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	GameInfo.SetMode(WK7GameInfo::MOVE);
	WK7CAM->RestoreState();
	
	gpSound->mPlayStreamNo(HPS_IDOU);
	
#endif
}

K7EV_HANDLER(K7SCN00_HSAppear)
{
	if( K7SCR_GET_SCENARIO_FLAG(HSAPPEAR)==true ){
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(HSAPPEAR);
	
	WK7Play				*pPlay = NULL;
	
	WK7CAM->StoreState();
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( (pPlay = WK7Play::Create("00020102"))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(false);
	
	pPlay->Start();
	
	K7SCR_TIMEWAIT(2400);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	gpSound->mFadeVolumeStream(0,200 * 5);
	
	WK7Npc		*pNpc[3];
	
	while( (pNpc[0] = WK7Npc::Create(ENENO_0_000_00))==NULL ){
		K7SCR_RETSYS();
	}
	while( (pNpc[1] = WK7Npc::Create(ENENO_0_000_01))==NULL ){
		K7SCR_RETSYS();
	}
	while( (pNpc[2] = WK7Npc::Create(ENENO_0_000_02))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_TIMEWAIT(2400);
	
	GHM_SAFE_DELETE(pPlay);
	
	while( pNpc[0]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( pNpc[1]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( pNpc[2]->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(true);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	GameInfo.SetMode(WK7GameInfo::MOVE);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
#ifdef	ENMDIE
	// GĎ
	while( WK7Npc::GetEnemyTotalHitPoint() > 0 && !(HSD_PadGetButton(1) & HSD_PAD_START) ){
		GHMGCTASK_RETSYS();
	}
#endif
	
	K7SCR_SET_SCENARIO_FLAG(STG000M00_ENMDIE);
	
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_HORAIZON_B);
}

K7EV_HANDLER(K7SCN00_SelectStg000M00Elevetor)
{
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG000M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	const char			*pPlayFile;
	WK7Play				*pPlay = NULL;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(2,0);
	switch( WK7PLAYERCONTROL->GetMainID() ){
	case	K7DAN:
		pPlayFile = "00030401";
		break;
	case	K7CON:
		pPlayFile = "00030401a";
		break;
	case	K7GAL:
		pPlayFile = "00030401b";
		break;
	default:
		pPlayFile = NULL;
		break;
	}
	if( pPlayFile != NULL ){
		while( (pPlay = WK7Play::Create(pPlayFile))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE               (currStageID);
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		
		WK7Play::SetExceptPlayRenderObj(false);
		
		pPlay->Start();
		
		K7SCR_TIMEWAIT(2400);
		
		k7app.FadeStart(0x00,4800);
		k7app.SetFadeColor(0);
		
		while( pPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
		
		k7app.FadeStart   (0xff,4800);
		k7app.SetFadeColor(0);
		
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(2400);
		
		GHM_SAFE_DELETE(pPlay);
		
		WK7Play::SetExceptPlayRenderObj(true);
		
//		gpSound->mPlayStreamNo(HPS_IDOU);
		
	}else{
		
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE               (currStageID);
		
	}
	
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_000_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOQ
	
	
*/
K7EV_HANDLER(K7SCN00_Stg002M00Init)
{
#if 0
//	WK7Npc		*pNpc;
//	
//	pNpc = WK7Npc::Create(ENENO_000200);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pNpc = WK7Npc::Create(ENENO_000201);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pNpc = WK7Npc::Create(ENENO_000202);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pNpc = WK7Npc::Create(ENENO_000203);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pNpc = WK7Npc::Create(ENENO_000204);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pNpc = WK7Npc::Create(ENENO_000205);
//	while( pNpc->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	
//	WK7Extra	*pExtra;
//	
//	pExtra = (WK7Extra *)WK7Npc::Create(EXTNO_000200);
//	while( pExtra->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pExtra->SetVisible(true);
//	pExtra->SetRotY(D2R(-90.0f));
//	
//	pExtra = (WK7Extra *)WK7Npc::Create(EXTNO_000201);
//	while( pExtra->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pExtra->SetVisible(true);
//	pExtra->SetRotY(D2R(45.0f));
//	
//	pExtra = (WK7Extra *)WK7Npc::Create(EXTNO_000203);
//	while( pExtra->IsLoading()==true ){
//		K7SCR_RETSYS();
//	}
//	pExtra->SetRotY(D2R(-135.0f));
#endif
	
#ifdef	ENMDIE
	// GĎ
	while( WK7Npc::GetEnemyTotalHitPoint() > 0 && !(HSD_PadGetButton(1) & HSD_PAD_START) ){
		GHMGCTASK_RETSYS();
	}
#endif
	
//#ifdef	ENMDIE
//	// GĎ
//	while( WK7Npc::GetEnemyTotalHitPoint() > 0 && !(HSD_PadGetButton(1) & HSD_PAD_START) ){
//		GHMGCTASK_RETSYS();
//	}
//#endif
//	
//	K7SCR_SET_SCENARIO_FLAG(STG002M00_ENMDIE);
	
}

K7EV_HANDLER(K7SCN00_Stg002M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg002M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_IDOU_B);
	
	// Xe[WQJgɂȂƂ̊Ď
	WK7Stage		*pCurrentStage;
	
	while( (pCurrentStage = WK7Stage::GetCurrentStage())==NULL ){
		K7SCR_RETSYS();
	}
	while( pCurrentStage->GetID() == K7STGID(2,0) ){
		
		if ( false==K7SCR_GET_SCENARIO_FLAG(STG002M00_ENMDIE) ){				// 2F3F̃ANZXL[Qbg tOnm
			if ( true == WK7Npc::GetEnemyDieTest(ENENO_0_002_01) ){
				K7SCR_SET_SCENARIO_FLAG(STG002M00_ENMDIE);					// 2F3F̃ANZXL[Qbg tOnm
//				Yamada
//				CreateMessageEffect( MES_KEYGET );
				gpSound->mPlaySE(SFX_SYS_KEY_GET);
			}
		}
		
		K7SCR_RETSYS();
	}
}

K7EV_HANDLER(K7SCN00_SelectStg002M00Elevetor)
{
#if 0
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG002M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(0,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_002_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	
}

void K7SCN00_SelectStg002M00_TO003(ghmGcTask *pTask,const char *pPathPoint);
void K7SCN00_SelectStg002M00_TO003(ghmGcTask *pTask,const char *pPathPoint)
{
	const char		*pPlayFile;
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	if( K7SCR_GET_SCENARIO_FLAG(STG002M00_ENMDIE)==true ){
		pPlayFile = "00030112";
		nextStageID = K7STGID(3,0);
	}else{
		pPlayFile = "00030112a";
		nextStageID = 0xffffffff;
	}
	
	WK7Play				*pPlay = NULL;
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	while( (pPlay = WK7Play::Create(pPlayFile))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0,4800);
	k7app.SetFadeColor(0);
	
	pPlay->Start();
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	if( nextStageID==0xffffffff ){
		
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
		GHM_SAFE_DELETE(pPlay);
	
		k7app.FadeStart   (0,4800);
		k7app.SetFadeColor(0);
		WK7CAM->RestoreState();
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
		
	}
	
	pCurrStage = WK7Stage::GetCurrentStage();
	currStageID = pCurrStage->GetID();
	while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT(pPathPoint);
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	
}

K7EV_HANDLER(K7SCN00_SelectStg002M00_TO003B)
{
	K7SCN00_SelectStg002M00_TO003(pTask,"jumpB_002_M00");
}

K7EV_HANDLER(K7SCN00_SelectStg002M00_TO003C)
{
	K7SCN00_SelectStg002M00_TO003(pTask,"jumpC_002_M00");
}

K7EV_HANDLER(K7SCN00_SelectStg002M00TV1)
{
	pTVName = "TV02";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg002M00TV2)
{
	pTVName = "TV01";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_EXTNO_000200)
{
	WK7Play				*pPlay = NULL;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	while( (pPlay = WK7Play::Create("00030102"))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	pPlay->Start();
	WK7CAM->RestoreState();
	
	WK7CAM->StoreState();
	K7SCN00_SetExtraCamera(EXTNO_0_002_00);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	WK7CAM->RestoreState();
	
//		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
//		pSelectObj->SetEnable(true);
//		
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_EXTNO_000201)
{
	WK7Play				*pPlay = NULL;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	while( (pPlay = WK7Play::Create("00030109"))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	pPlay->Start();
	WK7CAM->RestoreState();
	
	WK7CAM->StoreState();
	K7SCN00_SetExtraCamera(EXTNO_0_002_01);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	WK7CAM->RestoreState();
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_EXTNO_000203)
{
	WK7Play				*pPlay = NULL;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	while( (pPlay = WK7Play::Create("00030111"))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	pPlay->Start();
	WK7CAM->RestoreState();
	
	WK7CAM->StoreState();
	K7SCN00_SetExtraCamera(EXTNO_0_002_03);
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	WK7CAM->RestoreState();
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOR
	
	
*/
K7EV_HANDLER(K7SCN00_Stg003M00Init)
{
	WK7Npc		*pNpc;
	
	pNpc = WK7Npc::Create(ENENO_0_003_00);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_01);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_02);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_03);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_04);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_05);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_003_06);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
#if 0
#ifdef	ENMDIE
	// GĎ
	while( WK7Npc::GetEnemyTotalHitPoint() > 0 && !(HSD_PadGetButton(1) & HSD_PAD_START) ){
		GHMGCTASK_RETSYS();
	}
#endif
	
	K7SCR_SET_SCENARIO_FLAG(STG003M00_ENMDIE);
#endif
	
}

K7EV_HANDLER(K7SCN00_Stg003M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg003M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
	gpSound->mPlayStreamNo(HPS_IDOU);
}

K7EV_HANDLER(K7SCN00_SelectStg003M00TV)
{
	pTVName = "TV01";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg003M00TV2)
{
	pTVName = "TV02";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO002A)
{
#if 0
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(2,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpB_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO002B)
{
#if 0
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(2,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO004A)
{
#if 0
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(4,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpF_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO004B)
{
#if 0
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(4,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpG_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO006A)
{
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG004M01_ENMDIE)==false ){
//	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(6,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpD_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg003M00_TO006B)
{
#ifdef	ENMDIE
	if( K7SCR_GET_SCENARIO_FLAG(STG004M01_ENMDIE)==false ){
//	if( K7SCR_GET_SCENARIO_FLAG(STG003M00_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(6,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpE_003_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOS
	
	
*/
K7EV_HANDLER(K7SCN00_Stg004M00Init)
{
}

K7EV_HANDLER(K7SCN00_Stg004M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg004M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_CHILLOUT);
}

void K7SCN00_Play(const char *pfname);
void K7SCN00_Play(const char *pfname)
{
	WK7Play		*pPlay;
	ghmGcTask	*pTask;
	
	if( (pTask = ghmGcTaskController::GetCurrentTask())==NULL ){
		return;
	}
	
	while( (pPlay=WK7Play::Create(pfname))==NULL ){
		K7SCR_RETSYS();
	}
	
	WK7CAM->StoreState();
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(false);
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart(0,4800);
	k7app.SetFadeColor(0);
	
	// LJn
	pPlay->Start();
	// LI҂
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_CHILLOUT);
	
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	WK7Play::SetExceptPlayRenderObj(true);
	
	K7EV_PATHCONTROL->CameraRenew();
	WK7CAM->RestoreState();
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030101)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030101)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030101);
	K7SCN00_Play("00030101");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030103)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030103)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030103);
	K7SCN00_Play("00030103");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030104)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030104)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030104);
	K7SCN00_Play("00030104");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030105)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030105)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030105);
	K7SCN00_Play("00030105");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030106)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030106)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030106);
	K7SCN00_Play("00030106");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030107)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030107)==true ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030107);
	K7SCN00_Play("00030107");
}

K7EV_HANDLER(K7SCN00_Stg004M00_00030108)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M00_00030108)==true  ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030101)==false ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030103)==false ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030104)==false ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030105)==false ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030106)==false ||
	    K7SCR_GET_SCENARIO_FLAG(STG004M00_00030107)==false ||
	    WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M00_00030108);
#if 0
	K7SCN00_Play("00030108");
#else
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	pCurrStage = WK7Stage::GetCurrentStage();
	currStageID = pCurrStage->GetID();
	K7SCR_STG_RELEASE               (currStageID);
//	WK7PLAYERCONTROL->ReleaseAll();
//	WK7PLAYERCONTROL->Reset();
	
	K7SCR_TIMEWAIT(2400);
	
	WK7Play		*pPlay;
	
	while( (pPlay=WK7Play::Create("00030108"))==NULL ){
		K7SCR_RETSYS();
	}
	
	WK7CAM->StoreState();
	GameInfo.SetMode(WK7GameInfo::PLAY);
	
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Play::SetExceptPlayRenderObj(false);
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart(0,4800);
	k7app.SetFadeColor(0);
	
	// LJn
	pPlay->Start();
	// LI҂
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	k7app.FadeStart(0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	GHM_SAFE_DELETE(pPlay);
	K7SCR_TIMEWAIT(2400);
	
#if 0
	while( (pPlay=WK7Play::Create("00040101"))==NULL ){
		K7SCR_RETSYS();
	}
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	k7app.FadeStart(0,4800);
	k7app.SetFadeColor(0);
	pPlay->Start();
	pPrevPlay = pPlay;
	K7SCR_TIMEWAIT(2400);
	while( pPrevPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
#endif
//	k7app.FadeStart(0xff,4800);
//	k7app.SetFadeColor(0);
//	while( k7app.IsFade()==true ){
//		K7SCR_RETSYS();
//	}
	
//	GHM_SAFE_DELETE(pPlay);
	
//	WK7PLAYERCONTROL->CreateModel(K7CHRID(K7DAN,0));
//	WK7PLAYERCONTROL->CreatePackMotion(K7CHRID(K7DAN,0));
//	while( true == WK7PLAYERCONTROL->IsLoading() ){
//		K7SCR_RETSYS();
//	}
//	WK7PLAYERCONTROL->SetVisible(true);
	
	nextStageID = K7STGID(4,1);
	while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpE_006_M00");
	
	WK7Npc		*pNpc;
	
	while( (pNpc = WK7Npc::Create(ENENO_0_004_00))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_01))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_02))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_03))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_04))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_05))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_06))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	while( (pNpc = WK7Npc::Create(ENENO_0_004_07))==NULL ){
		K7SCR_RETSYS();
	}
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_STG_VISIBLE               (nextStageID,true);
	WK7Play::SetExceptPlayRenderObj(true);
	
	K7EV_PATHCONTROL->CameraRenew();
	WK7CAM->RestoreState();
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	
//	gpSound->mFadeVolumeStream(0,200 * 3);
	gpSound->mPlayStreamNo(HPS_IDOU_SILEN);
	
	// GĎ
	while( WK7Npc::GetEnemyTotalHitPoint() > 0 && !(HSD_PadGetButton(1) & HSD_PAD_START) ){
		GHMGCTASK_RETSYS();
	}
	K7SCR_SET_SCENARIO_FLAG(STG004M01_ENMDIE);
	
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_CHILLOUT);
#endif
}

K7EV_HANDLER(K7SCN00_Stg004M00_TO003A)
{
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpF_004_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_Stg004M00_TO003B)
{
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpG_004_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOSlOP
	
	
*/
K7EV_HANDLER(K7SCN00_Stg004M01Init)
{
}

K7EV_HANDLER(K7SCN00_Stg004M01Term)
{
}

K7EV_HANDLER(K7SCN00_Stg004M01Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
	gpSound->mPlayStreamNo(HPS_CHILLOUT);
//	gpSound->mPlayStreamNo(HPS_IDOU);
}

K7EV_HANDLER(K7SCN00_Stg004M01_TO003A)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M01_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpF_004_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_Stg004M01_TO003B)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG004M01_ENMDIE)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpG_004_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOU
	
	
*/
K7EV_HANDLER(K7SCN00_Stg006M00Init)
{
	WK7Npc		*pNpc;

	pNpc = WK7Npc::Create(ENENO_0_006_00);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_006_01);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_006_02);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_006_03);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
}

K7EV_HANDLER(K7SCN00_Stg006M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg006M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_HORAIZON);
	
	// Xe[WUJgɂȂƂ̊Ď
	WK7Stage		*pCurrentStage;
	
	while( (pCurrentStage = WK7Stage::GetCurrentStage())==NULL ){
		K7SCR_RETSYS();
	}
	while( pCurrentStage->GetID() == K7STGID(6,0) ){
		
		if ( false==K7SCR_GET_SCENARIO_FLAG(STG006M00_ENMDIE) ){				// 6FGx[^z[̃ANZXL[Qbg tOnm
			if ( true == WK7Npc::GetEnemyDieTest(ENENO_0_006_01) ){
				K7SCR_SET_SCENARIO_FLAG(STG006M00_ENMDIE);					// 6FGx[^z[̃ANZXL[Qbg tOnm
//				Yamada
//				CreateMessageEffect( MES_KEYGET );
				gpSound->mPlaySE(SFX_SYS_KEY_GET);
			}
		}
		
		K7SCR_RETSYS();
	}
}

K7EV_HANDLER(K7SCN00_SelectStg006M00_TO003A)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpE_006_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg006M00_TO003B)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(3,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpD_006_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg006M00_TO007A)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG006M00_KEYOPEN)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(7,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_006_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg006M00_TO007B)
{
	if( K7SCR_GET_SCENARIO_FLAG(STG006M00_KEYOPEN)==false ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(7,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpB_006_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg006M00TV1)
{
	pTVName = "TV01";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg006M00TV2)
{
	pTVName = "TV02";
	K7EV_CALL(K7SCN00_TV);
}

K7EV_HANDLER(K7SCN00_SelectStg006M00KEY)
{
	const char		*pPlayFile;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	if( K7SCR_GET_SCENARIO_FLAG(STG006M00_ENMDIE)==true ){
		K7SCR_SET_SCENARIO_FLAG(STG006M00_KEYOPEN);
		pPlayFile = "00030302";
	}else{
		pPlayFile = "00030302a";
	}
	
	WK7Play				*pPlay = NULL;
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( (pPlay = WK7Play::Create(pPlayFile))==NULL ){
		K7SCR_RETSYS();
	}
	
	while( pPlay->GetState()!=WK7Play::LOADED ){
		K7SCR_RETSYS();
	}
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0,4800);
	k7app.SetFadeColor(0);
	
	pPlay->Start();
	
	while( pPlay->GetState()==WK7Play::PLAY ){
		K7SCR_RETSYS();
	}
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(pPlay);
	
	k7app.FadeStart   (0,4800);
	k7app.SetFadeColor(0);
	
	WK7CAM->RestoreState();
	
	WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
	pSelectObj->SetEnable(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
}

/*
	
	
	Xe[WOOV
	
	
*/
K7EV_HANDLER(K7SCN00_Stg007M00Init)
{
}

K7EV_HANDLER(K7SCN00_Stg007M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg007M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
//	gpSound->mPlayStreamNo(HPS_IDOU);
	gpSound->mPlayStreamNo(HPS_HORAIZON_B);
}

K7EV_HANDLER(K7SCN00_SelectStg007M00_TO006A)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(6,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_007_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg007M00_TO006B)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(6,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpB_007_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg007M00_TO008)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(8,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpD_007_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

K7EV_HANDLER(K7SCN00_SelectStg007M00_TO009)
{
#if 0
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(9,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_007_M00_011_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
#endif
	
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	const char			*pPlayFile;
	WK7Play				*pPlay = NULL;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(9,0);
	switch( WK7PLAYERCONTROL->GetMainID() ){
	case	K7DAN:
		pPlayFile = "00030301";
		break;
	case	K7CON:
		pPlayFile = "00030301a";
		break;
	case	K7GAL:
		pPlayFile = "00030301b";
		break;
	default:
		pPlayFile = NULL;
		break;
	}
	if( pPlayFile != NULL ){
		while( (pPlay = WK7Play::Create(pPlayFile))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE(currStageID);
		
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		
		WK7Play::SetExceptPlayRenderObj(false);
		
		pPlay->Start();
		
		K7SCR_TIMEWAIT(2400);
		
		k7app.FadeStart(0x00,4800);
		k7app.SetFadeColor(0);
		
		while( pPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
		
		k7app.FadeStart   (0xff,4800);
		k7app.SetFadeColor(0);
		
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(2400);
		
		GHM_SAFE_DELETE(pPlay);
		
		WK7Play::SetExceptPlayRenderObj(true);
		
//		gpSound->mPlayStreamNo(HPS_IDOU);
		
	}else{
		
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE(currStageID);
		
	}
	
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_007_M00_011_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOW
	
	
*/
K7EV_HANDLER(K7SCN00_Stg008M00Init)
{
}

K7EV_HANDLER(K7SCN00_Stg008M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg008M00Current)
{
	gpSound->mSetDspRateAll(0);
	gpSound->mPlayStreamNo(HPS_IDOU);
}

K7EV_HANDLER(K7SCN00_SelectStg008M00_TO007)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(7,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpD_008_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

/*
	
	
	Xe[WOOX
	
	
*/
K7EV_HANDLER(K7SCN00_Stg009M00Init)
{
	WK7Npc		*pNpc;

	if( K7SCR_GET_SCENARIO_FLAG(EV_CONFERENCE)==true ||
	    K7SCR_GET_SCENARIO_FLAG(EV_DAN_RECOVER)==true ){
		return;
	}
	
	pNpc = WK7Npc::Create(ENENO_0_009_00);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_009_01);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_009_02);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	pNpc = WK7Npc::Create(ENENO_0_009_03);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_009_04);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
	pNpc = WK7Npc::Create(ENENO_0_009_05);
	while( pNpc->IsLoading()==true ){
		K7SCR_RETSYS();
	}
	
}

K7EV_HANDLER(K7SCN00_Stg009M00Term)
{
}

//#ifndef	HPS_IDOU_SYOUEN
//#define	HPS_IDOU_SYOUEN		HPS_IDOU
//#endif
K7EV_HANDLER(K7SCN00_Stg009M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
	gpSound->mPlayStreamNo(HPS_IDOU_SYOUEN);
}

K7EV_HANDLER(K7SCN00_Stg009M00_TO007)
{
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	const char			*pPlayFile = NULL;
	WK7Play				*pPlay;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	if( K7SCR_GET_SCENARIO_FLAG(EV_DAN_RECOVER)==false ){
		nextStageID = K7STGID(7,0);
	}else{
		nextStageID = K7STGID(11,0);
		switch( WK7PLAYERCONTROL->GetMainID() ){
		case	K7GAL:
			pPlayFile = "00030502";
			break;
		default:
			pPlayFile = NULL;
			break;
		}
	}
	if( pPlayFile != NULL ){
		while( (pPlay = WK7Play::Create(pPlayFile))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE(currStageID);
		
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		
		WK7Play::SetExceptPlayRenderObj(false);
		
		pPlay->Start();
		
		K7SCR_TIMEWAIT(2400);
		
		k7app.FadeStart(0x00,4800);
		k7app.SetFadeColor(0);
		
		while( pPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
		
		k7app.FadeStart   (0xff,4800);
		k7app.SetFadeColor(0);
		
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(2400);
		
		GHM_SAFE_DELETE(pPlay);
		
		WK7Play::SetExceptPlayRenderObj(true);
		
//		gpSound->mPlayStreamNo(HPS_IDOU);
		
	}else{
		
		while( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
			K7SCR_RETSYS();
		}
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		K7SCR_STG_RELEASE(currStageID);
		
	}
	
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	if( nextStageID==K7STGID(11,0) ){
		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("jumpC_009_M00","C7_cam7",0.5f,K7SCR_CAM_PATHDIR_REV);
	}else{
		K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_009_M00");
	}
	K7SCR_STG_VISIBLE               (nextStageID,true);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
}

#define	DANRECOVER_MODEL		K7CHRID(K7DAN,97)
#define	DANRECOVER_MOTION		K7MOTID(K7DAN,9997)
K7EV_HANDLER(K7SCN00_Stg009M00Play)
{
	switch( WK7PLAYERCONTROL->GetMainID() ){
	case	K7DAN:
		break;
	case	K7GAL:
		if( K7SCR_GET_SCENARIO_FLAG(EV_CONFERENCE)==true &&
		    K7SCR_GET_SCENARIO_FLAG(EV_DAN_RECOVER)==false ){
			
			WK7Stage			*pCurrStage,*pNextStage;
			u32					currStageID,nextStageID;
			
			GameInfo.SetMode(WK7GameInfo::PLAY);
			WK7CAM->StoreState();
			
			k7app.FadeStart   (0xff,4800);
			k7app.SetFadeColor(0);
			
			pCurrStage = WK7Stage::GetCurrentStage();
			
			currStageID = pCurrStage->GetID();
			nextStageID = K7STGID(10,0);
			if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
				return;
			}
			while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
				K7SCR_RETSYS();
			}
			while( k7app.IsFade()==true ){
				K7SCR_RETSYS();
			}
			WK7Chara		*pChara;
			while( (pChara = WK7RenderObj::GetChara(DANRECOVER_MODEL))==NULL ){
				K7SCR_RETSYS();
			}
			WK7CharaMotion	*pMotion;
			while( (pMotion = WK7MotionObj::GetCharaMotion(DANRECOVER_MOTION))==NULL ){
				K7SCR_RETSYS();
			}
			while( pChara->GetState()!=WK7RenderObj::LOADED ){
				K7SCR_RETSYS();
			}
			while( pMotion->GetState()!=WK7MotionObj::LOADED ){
				K7SCR_RETSYS();
			}
			
			K7SCR_STG_SET_CURRENT           (nextStageID);
			K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_009_M00");
			K7SCR_STG_VISIBLE               (nextStageID,true);
			K7SCR_STG_RELEASE               (currStageID);
			pChara->SetRenderFlag(true);
			
			k7app.FadeStart(0x00,4800);
			k7app.SetFadeColor(0);
			WK7CAM->RestoreState();
			while( k7app.IsFade()==true ){
				GHMGCTASK_RETSYS();
			}
			
			GameInfo.SetMode(WK7GameInfo::MOVE);
			
			return;
		}
	default:
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	
	WK7Play		*pPlay,*pPrevPlay;
	const char	**ppPlayFile;
static	const char	*pPlayTable[] = {
	"00030402",
//	"00040201",
//	"00040202",
//	"00040203",
//	"00030501",
//	"00030601",
//	"00030602",
//	"00030603",
//	"00030604",
	NULL,
};
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Stage			*pCurrStage;
	u32					currStageID;
	
	WK7Play::SetExceptPlayRenderObj(false);
	pCurrStage = WK7Stage::GetCurrentStage();
	currStageID = pCurrStage->GetID();
	K7SCR_STG_RELEASE(currStageID);
	
	pPlay      = 
	pPrevPlay  = NULL;
	ppPlayFile = pPlayTable;
	while( *ppPlayFile!=NULL ){
		while( (pPlay = WK7Play::Create(*ppPlayFile))==NULL ){
			if( pPrevPlay!=NULL && pPrevPlay->GetState()!=WK7Play::PLAY ){
				k7app.FadeStart(0xff,4800);
				k7app.SetFadeColor(0);
				while( k7app.IsFade()==true ){
					K7SCR_RETSYS();
				}
				GHM_SAFE_DELETE(pPrevPlay);
			}
			K7SCR_RETSYS();
		}
		if( pPrevPlay!=NULL ){
			while( pPrevPlay->GetState()==WK7Play::PLAY ){
				K7SCR_RETSYS();
			}
		}
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		if( pPrevPlay==NULL ){
			k7app.FadeStart(0x00,4800);
			k7app.SetFadeColor(0);
		}
		pPlay->Start();
		GHM_SAFE_DELETE(pPrevPlay);
		pPrevPlay = pPlay;
		ppPlayFile++;
	}
	if( pPrevPlay!=NULL ){
		while( pPrevPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
	}
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	GHM_SAFE_DELETE(pPrevPlay);
	
	K7SCR_SET_SCENARIO_FLAG(EV_CONFERENCE);
	
	WK7Stage			*pNextStage;
	u32					nextStageID;
	nextStageID = K7STGID(9,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	DeleteEffectAll_2();
	K7SCR_STG_SET_CURRENT           (nextStageID);
//	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_009_M00");
	K7SCR_STG_SET_CURRENT_PATH_POINT("set_TV1");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	
	WK7PlayerChange(K7CHRID(K7GAL,0));
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	WK7CAM->RestoreState();
	WK7Play::SetExceptPlayRenderObj(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	
}

K7EV_HANDLER(K7SCN00_SelectStg009M00TV1)
{
	if( K7SCR_GET_SCENARIO_FLAG(EV_CONFERENCE)==true ){
		WK7PathBranchPointObj	*pSelectObj = (WK7PathBranchPointObj *)K7EV_GETEVENTPARAM(0);
		pSelectObj->SetEnable(true);
		GameInfo.SetMode(WK7GameInfo::MOVE);
		return;
	}
	pTVName = "TV01";
	K7EV_CALL(K7SCN00_TV);
}

/*
	
	
	Xe[WOPO
	
	
*/
K7EV_HANDLER(K7SCN00_Stg010M00Init)
{
	WK7Chara	*pChara = WK7RenderObj::CreateChara(DANRECOVER_MODEL);
	if( pChara!=NULL ){
		while( pChara->GetState()!=WK7RenderObj::LOADED ){
			K7SCR_RETSYS();
		}
		WK7CharaMotion		*pMotion = WK7MotionObj::CreateCharaMotion(DANRECOVER_MOTION);
		if( pMotion!=NULL ){
			while( pMotion->GetState()!=WK7MotionObj::LOADED ){
				K7SCR_RETSYS();
			}
		}
		WK7Model		*pModel = pChara->GetModel();
		WK7ModelMotion	*pModelMotion = pMotion->GetModelMotion();
		if( pModel!=NULL && pModelMotion!=NULL ){
			pModel->AttachMotion(pModelMotion);
			pModel->PlayMotion();
		}
	}
}

K7EV_HANDLER(K7SCN00_Stg010M00Term)
{
	WK7Chara		*pChara  = WK7RenderObj::GetChara      (DANRECOVER_MODEL);
	WK7CharaMotion	*pMotion = WK7MotionObj::GetCharaMotion(DANRECOVER_MOTION);
	GHM_SAFE_DELETE(pChara);
	GHM_SAFE_DELETE(pMotion);
}

K7EV_HANDLER(K7SCN00_Stg010M00Current)
{
	gpSound->mSetDspRateAll(SOUND_DEFAULT_DSP_RATE);
	gpSound->mPlayStreamNo(HPS_IDOU_SYOUEN);
}

K7EV_HANDLER(K7SCN00_Stg010M00Play)
{
	WK7Play		*pPlay,*pPrevPlay;
	const char	**ppPlayFile;
static	const char	*pPlayTable[] = {
	"00030501",
	NULL,
};
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Stage			*pCurrStage;
	u32					currStageID;
	
	WK7Play::SetExceptPlayRenderObj(false);
	pCurrStage = WK7Stage::GetCurrentStage();
	currStageID = pCurrStage->GetID();
	K7SCR_STG_RELEASE(currStageID);
	
	pPlay      = 
	pPrevPlay  = NULL;
	ppPlayFile = pPlayTable;
	while( *ppPlayFile!=NULL ){
		while( (pPlay = WK7Play::Create(*ppPlayFile))==NULL ){
			if( pPrevPlay!=NULL && pPrevPlay->GetState()!=WK7Play::PLAY ){
				k7app.FadeStart(0xff,4800);
				k7app.SetFadeColor(0);
				while( k7app.IsFade()==true ){
					K7SCR_RETSYS();
				}
				GHM_SAFE_DELETE(pPrevPlay);
			}
			K7SCR_RETSYS();
		}
		if( pPrevPlay!=NULL ){
			while( pPrevPlay->GetState()==WK7Play::PLAY ){
				K7SCR_RETSYS();
			}
		}
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		if( pPrevPlay==NULL ){
			k7app.FadeStart(0x00,4800);
			k7app.SetFadeColor(0);
		}
		pPlay->Start();
		GHM_SAFE_DELETE(pPrevPlay);
		pPrevPlay = pPlay;
		ppPlayFile++;
	}
	if( pPrevPlay!=NULL ){
		while( pPrevPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
	}
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	GHM_SAFE_DELETE(pPrevPlay);
	
	K7SCR_SET_SCENARIO_FLAG(EV_DAN_RECOVER);
	
	WK7Stage			*pNextStage;
	u32					nextStageID;
	nextStageID = K7STGID(9,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_010_M00");
//	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpC_009_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	
	WK7PlayerChange(K7CHRID(K7GAL,0));
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	WK7CAM->RestoreState();
	WK7Play::SetExceptPlayRenderObj(true);
	GameInfo.SetMode(WK7GameInfo::MOVE);
	
	
}

K7EV_HANDLER(K7SCN00_SelectStg010M00_TO009)
{
#if 0
	WK7Stage			*pCurrStage,*pNextStage;
	u32					currStageID,nextStageID;
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	
	pCurrStage = WK7Stage::GetCurrentStage();
	
	currStageID = pCurrStage->GetID();
	nextStageID = K7STGID(9,0);
	if( (pNextStage = WK7RenderObj::CreateStage(nextStageID))==NULL ){
		return;
	}
	while( pNextStage->GetState()!=WK7RenderObj::LOADED ){
		K7SCR_RETSYS();
	}
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_STG_SET_CURRENT           (nextStageID);
	K7SCR_STG_SET_CURRENT_PATH_POINT("jumpA_010_M00");
	K7SCR_STG_VISIBLE               (nextStageID,true);
	K7SCR_STG_RELEASE               (currStageID);
	
	k7app.FadeStart(0x00,4800);
	k7app.SetFadeColor(0);
	WK7CAM->RestoreState();
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.SetMode(WK7GameInfo::MOVE);
#endif
}

/*
	
	
	Xe[WOPP
	
	
*/
K7EV_HANDLER(K7SCN00_Stg011M00Init)
{
}

K7EV_HANDLER(K7SCN00_Stg011M00Term)
{
}

K7EV_HANDLER(K7SCN00_Stg011M00Current)
{
	gpSound->mSetDspRateAll(0);
	gpSound->mPlayStreamNo(HPS_IDOU_SYOUEN);
}

K7EV_HANDLER(K7SCN00_Stg011M00Play)
{
	WK7Play		*pPlay,*pPrevPlay;
	const char	**ppPlayFile;
static	const char	*pPlayTable[] = {
	"00030601",
	"00030602",
	"00030603",
	"00030604",
	NULL,
};
	
	GameInfo.SetMode(WK7GameInfo::PLAY);
	WK7CAM->StoreState();
	
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	
	WK7Stage			*pCurrStage;
	u32					currStageID;
	
	WK7Play::SetExceptPlayRenderObj(false);
	pCurrStage = WK7Stage::GetCurrentStage();
	currStageID = pCurrStage->GetID();
	K7SCR_STG_RELEASE(currStageID);
	WK7PLAYERCONTROL->ReleaseAll();
	WK7PLAYERCONTROL->Reset();
	
	pPlay      = 
	pPrevPlay  = NULL;
	ppPlayFile = pPlayTable;
	while( *ppPlayFile!=NULL ){
		while( (pPlay = WK7Play::Create(*ppPlayFile))==NULL ){
			if( pPrevPlay!=NULL && pPrevPlay->GetState()!=WK7Play::PLAY ){
				k7app.FadeStart(0xff,4800);
				k7app.SetFadeColor(0);
				while( k7app.IsFade()==true ){
					K7SCR_RETSYS();
				}
				GHM_SAFE_DELETE(pPrevPlay);
			}
			K7SCR_RETSYS();
		}
		if( pPrevPlay!=NULL ){
			while( pPrevPlay->GetState()==WK7Play::PLAY ){
				K7SCR_RETSYS();
			}
		}
		while( pPlay->GetState()!=WK7Play::LOADED ){
			K7SCR_RETSYS();
		}
		if( pPrevPlay==NULL ){
			k7app.FadeStart(0x00,4800);
			k7app.SetFadeColor(0);
		}
		DeleteEffectAll_2();
		pPlay->Start();
		GHM_SAFE_DELETE(pPrevPlay);
		pPrevPlay = pPlay;
		ppPlayFile++;
	}
	if( pPrevPlay!=NULL ){
		while( pPrevPlay->GetState()==WK7Play::PLAY ){
			K7SCR_RETSYS();
		}
	}
	DeleteEffectAll_2();
	k7app.FadeStart   (0xff,4800);
	k7app.SetFadeColor(0);
	while( k7app.IsFade()==true ){
		K7SCR_RETSYS();
	}
	GHM_SAFE_DELETE(pPrevPlay);
	
}
#endif

////////////////////////////////////////////////////////////////////////////////
// nhe[u
////////////////////////////////////////////////////////////////////////////////

#define	K7EV_TBL_PART
#include ".\K7Scn00.h"

