////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M00
//
// K7Stage771M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE771M00_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage771M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Wat\WK7Play.h"
#include "..\..\..\Wat\WK7Npc.h"
#include "..\..\..\Kaw\KK7Sound.h"


K7Stage771M00::K7Stage771M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage771M00_Camera);
	mAmbPlaySE = false;
}

K7Stage771M00::~K7Stage771M00()
{
}

bool K7Stage771M00::InitializeCallBack(void)
{
	WK7JObj		*pJObj;
	
	if( (pJObj=GetJObj("floor"))!=NULL ){
		pJObj->SetZSortPrio(WK7JOBJ_ZSORTPRIO_DEFAULT-1,false,true);
	}
	
	//IԂɂ
	SetSelectObjFlag( K7STGID(771,3), "door_007101", 1, true );
	SetPassPathFlag ( K7STGID(771,3), "door_007101", 1, true );
	
// ƃeXg
//	K7SCR_STG_SET_PATHENABLE("branchE",false);
	
	return true;
}

bool K7Stage771M00::PlayEventCallBack(WK7PlayEventInfo &info)
{
	WK7Play	*pPlay;
	u32		charaid = K7CHRID(K7DAN,0);
	switch( info.mEventNo ){
	case	K7EVENTPLAY(00020101):
		if( WK7Play::HasPlayed(info.mEventNo)==TRUE ){
			return false;
		}
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			GHMGCTASK_RETSYS();
		}
		
		s16		storedBgmID = gpSound->mGetPlayStreamNo();
		
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
		WK7PLAYERCONTROL->SetOperateEnable(false);
		retsys();
		
		while( (pPlay = WK7Play::Create("00020101"))==NULL ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Prepare();
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7Play::StorePlayTB();
		
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->Start();
		GHMGCTASK_RETSYS();
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			GHMGCTASK_RETSYS();
		}
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			GHMGCTASK_RETSYS();
		}
		
		pPlay->SetVisibleAll(false);
		GHMGCTASK_RETSYS();
		GHMGCTASK_RETSYS();
		GHM_SAFE_DELETE(pPlay);
		
		WK7Play::RestorePlayTB();
		
		WK7PLAYERCONTROL->CreateModel(charaid);
		WK7PLAYERCONTROL->CreatePackMotion(charaid);
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			retsys();
		}
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		
		WK7PLAYERCONTROL->SetVisible(true);
		
		WK7PLAYERPATHCONTROL->CameraRenew();
		WK7PLAYERCONTROL->ChangeCallback();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		
		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","curve15",0.5f,WK7PATHINFO_INITDIR_TGTDIR_REV);
//		K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","Entranceway_camera1_fix",0.75f,WK7PATHINFO_INITDIR_TGTDIR_REV);
		gpSound->mPlayStreamNo(storedBgmID);
		
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		
		WK7Play::SetPlayed(info.mEventNo,true);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage771M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	switch( eventNo ){
	case	K7EVENTNO(007102):
#if 0
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_IWAZARU)==TRUE ){
			return true;
		}
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_CP_IWAZARU);
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(IWAZARU);
		
		K7SCR_CHARAPRESENT_DEBUGSTART();
		K7SCR_RESERVENAME(K7SCR_CP_STARTTICK,0,  345,  106, 199,  89, 127, 192);
		K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
		K7SCR_CHARAPRESENT_DEBUGEND();
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		
#endif
		break;
	default:
		return true;
	}
	return true;
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage771M00::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-93.262f, 59.008f, 49.818f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	return( true );
}
