////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M02
//
// K7Stage771M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE771M02_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage771M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Wat\WK7GameInfo.h"
#include "..\..\..\Wat\WK7Player.h"
#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

#define	K7STAGE771M02_HS_NEST_OBJNAME		"HS_nest"
#define	K7STAGE771M02_HS_NEST_PATHNAME		"pass_dan"
#define	K7STAGE771M02_TRUNK					"Trunk"
#define	K7STAGE771M02_RIDDLE_PATHNAME		"event_007101_0"

K7Stage771M02::K7Stage771M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage771M02_Camera);
	pNpcSu = NULL;
}

K7Stage771M02::~K7Stage771M02()
{
}

//K7STAGE_KIHANKUITABLE_START(K7Stage771M02Kui)
//	K7STAGE_KIHANKUITABLE_CAM(1,K7EVENTTAMA(007101),-155.999f, 11.513f, -524.219f, -212.722f, 14.942f, -518.509f)
//K7STAGE_KIHANKUITABLE_END()

bool K7Stage771M02::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage771M02::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage771M02::InitializeCallBack(void)
{
	WK7JObj		*pJObj;
	
	HereComeANewHSInit( PR_HS_TUBA, ENENO_7_771M02_4 );
	
	if( (pJObj=GetJObj(K7STAGE771M02_HS_NEST_OBJNAME))!=NULL ){
		SetHitObj(pJObj,1);
	}
//	CreateKui(K7Stage771M02Kui);
	return true;
}

bool K7Stage771M02::CondChangeCallBack(void)
{
	WK7JObj		*pJObj;
	pJObj = GetJObj(K7STAGE771M02_HS_NEST_OBJNAME);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_771M01)==TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE771M02_RIDDLE_PATHNAME,true);
		K7SCR_STG_SET_PATHENABLE(K7STAGE771M02_HS_NEST_PATHNAME,true);
		K7SCR_JOBJ_HIDE(pJObj);
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE771M02_RIDDLE_PATHNAME,false);
		K7SCR_STG_SET_PATHENABLE(K7STAGE771M02_HS_NEST_PATHNAME,false);
		K7SCR_JOBJ_DISP(pJObj);
	}
	bool	tamaflag = false;
	if( K7SCR_EVHASITEM(K7EVENTZAN(007103))==true ){
		if( (pJObj=PlayMotion(K7STAGE771M02_TRUNK,0,NULL,-1.0f))!=NULL ){
			pJObj->SetMotionLoop(false,false,true);
		}
		if( K7SCR_EVHASITEM(K7EVENTTAMA(007101))==false ){
			tamaflag = true;
		}
	}
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(007101),tamaflag);
	SetVisibleTamaJObj(K7EVENTTAMA(007101),tamaflag);
	RenewTamaEffect(K7EVENTTAMA(007101));
	return true;
}

bool K7Stage771M02::DoorEventCallBack(WK7DoorEventInfo &info)
{
#pragma	unused(info)
//	switch( info.mEventNo ){
//	case	K7EVENTDOOR(007101):
//		if( KihanGateIsOpened()==false ){
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_DONTOPENDOOR);
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}
//		break;
//	default:
//		break;
//	}
	return true;
}
#define CORE_NUM	(1)
bool K7Stage771M02::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	1:
		if( WK7PLAYERCONTROL->GetMainID()!=K7DAN ){
			return false;
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN07_SP_771M01);
		K7SCR_EVCONDCHANGE();
		break;
	default:
		if ( pNpcSu != NULL ) {
			if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
				if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
					// RAj󂵂ĂȂ
					// qbgIuWF𕜊
//					info.mpHitObj->SetEnable(true);
					info.SetHitObjEnable(true);
				}
				return false;
			}
		}
		break;
	}
	return true;
}

bool K7Stage771M02::ZanEventCallBack(WK7ZanEventInfo &info)
{
	bool	trunk;
	switch( info.mEventNo ){
	case	K7EVENTZAN(007103):
		if( K7SCR_EVHASITEM(K7EVENTZAN(007103))==false ){
			trunk = true;
		}else{
			trunk = false;
		}
		ZanEventTask(info);
		if( trunk==true ){
			
			while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
				K7SCR_RETSYS();
			}
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
		
			WK7JObj	*pJObj;
			
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(EVENT_TRUNK);
			
			gpSound->mPlaySE(SFX_SCE0_TRUNK_OPEN);

			if( (pJObj=PlayMotion(K7STAGE771M02_TRUNK,0))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
				
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
				
			}
			
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);
//			K7SCR_STG_MESSAGE_B(K7STAGE771M02_MES_OPEN_TRUNK);
			K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
			
			K7SCR_PC_SETVISIBLE(true);
			
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETTAMA);
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
		}
//		if( K7SCR_EVHASITEM(K7EVENTTAMA(007101))==false ){
//			K7SCR_EVSETITEM(K7EVENTTAMA(007101),true);
//			while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
//				K7SCR_RETSYS();
//			}
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			gpSound->mPlaySE(SFX_SYS_GET_BULLET);
//			K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_GETTAMA);
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//		}
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage771M02::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	switch( eventNo ){
	case	K7EVENTNO(007101):
		if( pathNo!=0 ){
			return true;
		}
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_771M01)==TRUE ){
			return true;
		}
		break;
	case	K7EVENTNO(007104):
#if 0
		if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_CP_HSNEST)==TRUE ){
			return true;
		}
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_CP_HSNEST);
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(EVENT_HSNEST);
		
		K7SCR_CHARAPRESENT_DEBUGSTART();
		K7SCR_RESERVENAME(K7SCR_CP_STARTTICK,0,  354,  232,  75,  86, 387, 341);
		K7SCR_TIMEWAIT(K7SCR_CP_WAITTIME);
		K7SCR_CHARAPRESENT_DEBUGEND();
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
#endif
		
		return true;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage771M02::DieNpcCallBack(WK7DieNpcInfo &info)
{
	if( info.mpNpc==NULL ){
		return true;
	}
	switch( info.mpNpc->GetEneNo() ){
	case	ENENO_7_771M02_1:
		K7SCR_SET_SCENARIO_FLAG(K7SCN07_SP_771M01);
		K7SCR_EVCONDCHANGE();
		return false;
	default:
		break;
	}
	return true;
}


// ̐ݒ
bool K7Stage771M02::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_7_771M02_1);
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_TUBA,
									ENENO_7_771M02_4,								// GID
									NULL,
									CAM771M02_HS_PRESEN_START,
									CAM771M02_HS_PRESEN_END,
									1,
									240,  321, -48, 107, 702, 202 )					// OЉp
	){
		SetManualBranch(false);
//		return( false );
	}
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	return true;
}
