////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage771M04 `[gA
//
// K7Stage771M04.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 07/23/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE771M04_CPP__

#include "..\..\Scn\K7Scn07.h"
#include ".\K7Stage771M04.h"
#include "..\..\Wat\WK7Tutorial.h"
#include "..\..\Wat\WK7Item.h"
#include "..\Sato\SK7Special.h"
#include "..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\Kaw\KK7BattleCtrl.h"

K7Stage771M04::K7Stage771M04(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage771M04_Camera);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetSpecialEnable(false);
	mpEnemy[0] = 
	mpEnemy[1] = NULL;
	mTutoProc  = 0;
}

K7Stage771M04::~K7Stage771M04()
{
	WK7PLAYERCONTROL->BattlePadRegulationReSet(BPADREG_NODECHP);
	WK7Tutorial::Terminate();
	GameInfo.SetMenuMapEnable(true);
	GameInfo.SetSpecialEnable(true);
	BattleCtrl.ClearComboCount();
	BattleCtrl.SetTvEnemyCount(0);
	BattleCtrl.SetTotalEnemyHunt(0);
}

bool K7Stage771M04::LoadAfterInit3(void)
{
	return WK7Stage::LoadAfterInit3();
}

bool K7Stage771M04::IsLoadingAfterInit3(void)
{
	return WK7Stage::IsLoadingAfterInit3();
}

bool K7Stage771M04::CreateCallBack(void)
{
	return true;
}

bool K7Stage771M04::ScanTest(void)
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpEnemy[i]!=NULL && mpEnemy[i]->ScanTest()==true ){
			return true;
		}
	}
	return false;
}

bool K7Stage771M04::EnemyPop(void)
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpEnemy[i]!=NULL ){
			mpEnemy[i]->SetTutorialCmd(NPCTUTO_FIRSTPOP);
		}
	}
	return true;
}

bool K7Stage771M04::EnemyEscape(void)
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpEnemy[i]!=NULL ){
			mpEnemy[i]->SetTutorialCmd(NPCTUTO_ESCAPE);
		}
	}
	return true;
}

bool K7Stage771M04::EnemyLossTest(void)
{
	int		i;
	for(i=0 ; i<2 ; i++){
		if( mpEnemy[i]!=NULL ){
			switch( mpEnemy[i]->GetNpcState() ){
			case	NPC_STATE_LOSS:
			case	NPC_STATE_REPOPWAIT:
				if ( NPC_DIE_JIBAKU != mpEnemy[i]->GetDieMode() ){		// ͎񂾂ƔF߂Ȃ
					return true;
				}
			default:
				break;
			}
		}
	}
	return false;
}

bool K7Stage771M04::SetCurrentCallBack(void)
{
	int		battle;
	u32		tick;
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NODECHP);
	SetCurrentCallBackDefaultProc();
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	WK7Tutorial		*pTutorial;
	if( (pTutorial=WK7Tutorial::GetInstance())!=NULL ){
		pTutorial->SetRender(true);
		pTutorial->DispIwazaru(0);
		pTutorial->DispBack   ();
	}
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	if( pTutorial==NULL ){
		K7SCR_SET_SCENARIO_FLAG(K7SCN07_TUTO);
		return false;
	}
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED && mTutoProc >= 0 ){
		switch( mTutoProc ){
		case	0:
			pTutorial->DispMessage(TUTOMSG_RUN);
			mTutoProc++;
			tick = 0;
			battle = 0;
			break;
		case	1:
			if( HSD_PadGetButton(0) & HSD_PAD_A ){
				tick += WK7_TICK_PER_FRAME;
			}
			if( tick >= WK7_SEC_TO_TICK(3.0f) ){
				// Rb
				pTutorial->HideMessage();
				mTutoProc++;
			}
			break;
		case	2:
			if( pTutorial->IsHiddenMessage()==true ){
				pTutorial->DispMessage(TUTOMSG_TURN);
				mTutoProc = 16;
			}
			break;
		case	16:
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_TURN ){
				// ^[
				pTutorial->HideMessage();
				mTutoProc++;
			}
			break;
		case	17:
			if( pTutorial->IsHiddenMessage()==true ){
				pTutorial->DispMessage(TUTOMSG_KAMAE);
				EnemyPop();
				mTutoProc = 32;
			}
			break;
		case	32:
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_SHOTPOSE ){
				// ˌ\
				pTutorial->HideMessage();
				mTutoProc++;
			}
			break;
		case	33:
			if( pTutorial->IsHiddenMessage()==true ){
				switch( battle ){
				case	1: mTutoProc = 48; pTutorial->DispMessage(TUTOMSG_SCAN);         break;
				case	0: mTutoProc = 64; pTutorial->DispMessage(TUTOMSG_LOCKON);       break;
				case	2: mTutoProc = 80; pTutorial->DispMessage(TUTOMSG_TARGETCHANGE); break;
				case	3: mTutoProc = 96; pTutorial->DispMessage(TUTOMSG_ATTACK);       break;
				default:   mTutoProc = -1; pTutorial->HideMessage(); break;
				}
			}
			break;
		case	48:
			// XL`FbN
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_WAIT ){
				pTutorial->HideMessage();
				mTutoProc = 17;
				break;
			}
			if( ScanTest()==true ){
				// XL
				pTutorial->HideMessage();
				mTutoProc = 33;
				battle++;
				break;
			}
			break;
		case	64:
			// bNI
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_WAIT ){
				pTutorial->HideMessage();
				mTutoProc = 17;
				break;
			}
			if( ::GetBLockOn()==true ){
				// bNI
				pTutorial->HideMessage();
				mTutoProc = 33;
				battle++;
				break;
			}
			break;
		case	80:
			// ^[Qbg`FW
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_WAIT ){
				pTutorial->HideMessage();
				mTutoProc = 17;
				break;
			}
			if( ::GetJyujiLockOn()==true ){
				// ^[Qbg`FW
				pTutorial->HideMessage();
				mTutoProc = 33;
				battle++;
				break;
			}
			break;
		case	96:
			// U
			if( WK7PLAYERCONTROL->GetState()==PC_STATE_WAIT ){
				pTutorial->HideMessage();
				mTutoProc = 17;
				break;
			}
			if( EnemyLossTest()==true ){
				// G|
				pTutorial->HideMessage();
				mTutoProc++;
//				EnemyEscape();
				break;
			}
			break;
		case	97:
			if( pTutorial->IsHiddenMessage()==true ){
				pTutorial->DispMessage(TUTOMSG_RUN);
				mTutoProc = 112;
				K7SCR_SET_SCENARIO_FLAG(K7SCN07_TUTO);
				K7SCR_EVCONDCHANGE();
				break;
			}
			break;
		case	112:
			break;
		default:
			mTutoProc = -1;
			break;
		}
		K7SCR_RETSYS();
	}
	
	return false;
}

bool K7Stage771M04::InitializeCallBack(void)
{
	// CxgS폜
	u32		evno;
	int		i;
	for(i=0,evno=K7EVENTZAN(007110) ; i<8 ; i++,evno++){
		SetZanEnable(evno,false);
		K7SCR_EVNO_SETENABLE(evno,false);
	}
	mpEnemy[0] = WK7Npc::Find( ENENO_TUTORIAL_771M04_0 );
	mpEnemy[1] = WK7Npc::Find( ENENO_TUTORIAL_771M04_1 );
	return true;
}

bool K7Stage771M04::CondChangeCallBack(void)
{
	bool	flag;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_TUTO)==TRUE ){
		flag = true;
	}else{
		flag = false;
	}
	K7SCR_STG_SET_PATHENABLE("door_007102",flag);
//	K7SCR_STG_SET_PATHENABLE("door_007102",true);
	return true;
}

bool K7Stage771M04::DoorEventCallBack(WK7DoorEventInfo &info)
{
	WK7Tutorial		*pTutorial = WK7Tutorial::GetInstance();
	int				index;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(007102):
		if( pTutorial==NULL ){
			break;
		}
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		
		K7SCR_NOISE_REQUEST();
		
		K7SCR_RETSYS();
		pTutorial->HideMessage  ();
		pTutorial->HideIwazaru  ();
		pTutorial->SetSelectMode(false);
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
		
		K7SCR_NOISE_RELEASE();
		
		pTutorial->DispMessage  (TUTOMSG_TRYAGAIN);
		pTutorial->DispIwazaru  (3);
		pTutorial->SetSelectMode(true);
		
		K7SCR_RETSYS();
		while( (index=pTutorial->GetSelectIndex()) < 0 ){
			K7SCR_RETSYS();
		}
		if( index!=WK7TUTORIAL_SELECT_YES ){
			gpSound->mReleaseSsm( WK7TUTORIAL_SSM_NAME);
			GameInfo.ReadScenarioSSM();
			while( gpSound->mGetProcess()!=eSndStandby ){
				K7SCR_RETSYS();
			}
			break;
		}
		
		K7SCR_NOISE_REQUEST();
		
		pTutorial->HideMessage  ();
		pTutorial->HideIwazaru  ();
		pTutorial->SetSelectMode(false);
		
		K7SCR_RETSYS();
		K7SCR_RESET_SCENARIO_FLAG(K7SCN07_TUTO);
		K7SCR_EVCONDCHANGE();
		
		WK7Chara::SetRenderChara(true );
		WK7Stage::SetRenderStage(true );
		WK7Item::SetRenderItem  (true );
		
		K7SCR_NOISE_RELEASE();
		
		mTutoProc = 0;
		pTutorial->DispIwazaru(0);
//		pTutorial->DispMessage(TUTOMSG_RUN);
		pTutorial->SetSelectMode(false);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage771M04::BpArriveCallBack(WK7BpInfo &info)
{
	if( mTutoProc!=112 ){
		return true;
	}
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	if( pTutorial==NULL ){
		return true;
	}
	if( info.IsBranchPointName("set1")==true ){
		pTutorial->DispIwazaru(3);
		pTutorial->DispMessage(TUTOMSG_JUNCTION);
	}
	return true;
}

static	const char *pBpPathList[] = {
	"ps0000",
	"ps0009",
	NULL,
};
bool K7Stage771M04::PathTurnCallBack(WK7PathTurnInfo &info)
{
#pragma	unused(info)
	if( mTutoProc!=112 ){
		return true;
	}
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	const char	*pPathName = WK7PLAYERPATHCONTROL->GetCurrentPathName();
	WK7PathInfo	*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	if( pPathName==NULL || pPathInfo==NULL || pTutorial==NULL ){
		return true;
	}
	int		i;
	for(i=0 ; pBpPathList[i]!=NULL ; i++){
		if( strcmp(pPathName,pBpPathList[i])==0 ){
			pTutorial->DispIwazaru(0);
			pTutorial->DispMessage(TUTOMSG_RUN);
			return true;
		}
	}
	return true;
}

bool K7Stage771M04::PathChangeCallBack(WK7PathChangeInfo &info)
{
	if( mTutoProc!=112 ){
		return true;
	}
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	if( pTutorial==NULL ){
		return true;
	}
	if( info.CompareList(pBpPathList) >= 0 ){
		pTutorial->DispIwazaru(0);
		pTutorial->DispMessage(TUTOMSG_RUN);
	}
	return true;
}

/*
	
	
	Xe[W𔲂ƂɁA̗ʂNA
	
	
*/
bool K7Stage771M04::TerminateCallBack(void)
{
	if ( GameInfo.GetSpOption() != NULL ){
		GameInfo.GetSpOption()->SetBloodGauge( BP_THICK, 0 );
		GameInfo.GetSpOption()->SetBloodGauge( BP_THIN, 0 );
	}
	BattleCtrl.SetBpGauge(BP_THICK, 	(int )0);		//@ZiAvϊÕTuʂɂăr[J[ɗ܂ĂAj
	BattleCtrl.SetBpGauge(BP_THIN,		(int )0);		//@i`[ŴƂɎgAj
	return true;
}

