////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage774M02
//
// K7Stage774M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE774M02_CPP__

#include "..\..\..\Wat\K7GlobalFlag.h"
#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage774M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7EffectBreakObj.h"
#include "..\..\..\Wat\WK7CharaPresent.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Panel\SK7PanelInputCode.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectDraft.h"
#include "..\..\..\Yam\YK7EffectSkillExe2.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"
#include "..\..\..\Yam\YK7EffectBlood.h"
#include "..\..\..\Yam\YK7EffectConveBlood.h"
#include "..\..\..\Yam\YK7EffectHSDead.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

#include "..\..\..\Fujita\C_Font.h"

#define	K7STAGE774M02_BROKENWALL_OBJNAME	"event_007401"
#define	K7STAGE774M02_BROKENWALL_PATHNAME	"pass_msk"
#define	K7STAGE774M02_BROKENWALL_FLAG		K7SCN07_SP_774M02_0
#define	K7STAGE774M02_BROKENWALL_WINDNAME	"wind1"

#define	K7STAGE774M02_BROKENWALL_RIDDLE_PATHNAME	"event_007405_0"

#define	K7STAGE774M02_SECRETWALL_OBJNAME	"secret1_wall"
#define	K7STAGE774M02_SECRETWALL_PATHNAME	"secret1_way"

#define	K7STAGE774M02_SECRETWALL_RIDDLE_PATHNAME	"event_007402_0"

#define	K7STAGE774M02_HINT_HIDE_OBJNAME		"other"

#define	K7STAGE774M02_LOCK_ON			"cyo_padlock_on"	//̂Ă
#define	K7STAGE774M02_LOCK_OFF			"cyo_padlock_off"	//̊JĂ

static Vec windPos = {45.905f, 7.881f, -179.242f};

K7STAGE_BROKENWALLINFO_START(K7Stage774M02_BrokenWallInfo)
	K7STAGE_BROKENWALLINFO_CAM(K7EVENTNO(007401) , "event_007401" , "pass_msk" , K7STAGE774M02_BROKENWALL_FLAG , BROKEN_WALL)
K7STAGE_BROKENWALLINFO_END()

K7Stage774M02::K7Stage774M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpWindEffect = NULL;
	SetOneShotCamLocTbl(K7Stage774M02_Camera);
	SetBrokenWallInfo  (K7Stage774M02_BrokenWallInfo);
	mAmbPlaySE = false;
}

K7Stage774M02::~K7Stage774M02()
{
}

bool K7Stage774M02::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage774M02::InitializeCallBack(void)
{
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage774M02::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage774M02::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(007403):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_3)==false ){
			FixCamMes(PANEL_HINT,K7STAGE774M02_MES_BLOOD_LETTER);
		}else{
			FixCamMes(PANEL_HINT,K7STAGE774M02_MES_PANEL_HINT);
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage774M02::DoorEventCallBack(WK7DoorEventInfo &info)
{
	bool	ret;
	
	switch( info.mEventNo ){
	case	K7EVENTDOOR(007401):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_1)==false ){
			
			u32		mesid;
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
//			K7SCR_PC_SETVISIBLE(false);
			FixCam(CLOSED_DOOR);
			
			if( WK7PLAYERCONTROL->HasSpAbility(PC_SPA_PICKING_TOOL)==true ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN07_SP_774M02_1);
				mesid = K7SCR_SYSMES_OPEN_KEY;
				ret   = true;
				
				// R[esbLOANV
				Vec camTgt = {-63.731f, 7.658f, -111.590f};
				Vec camPos = {-72.046f, 5.707f, -106.388f};
				Vec pcPos  = {-48.f, 	0.f,    -115.0f};
				f32 pcRotY = 1.57f;
//				WK7PLAYERCONTROL->WK7PlayerCyoPicking(PICKING_774M02, &camTgt, &camPos, &pcPos, pcRotY, SFX_PC_CYO_PICKING);
				WK7PLAYERCONTROL->WK7PlayerCyoPicking(PICKING_774M02, &camTgt, &camPos, &pcPos, pcRotY, SFX_PC_CYO_PICKING, true);
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
			}else{
				mesid = K7SCR_SYSMES_CLOSED_BY_KEY;
				ret   = false;
			}
			
			if ( true == ret ){
				
				K7SCR_PC_SETVISIBLE(false);
				FixCam(ONESHOTCAM_PICKINGOK);
				K7SCR_EVCONDCHANGE();
				
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
				info.mCinemaScopeClear = true;
				
//				K7SCR_SYS_MESSAGE_B(mesid);
				
			}else{
				K7SCR_PC_SETVISIBLE(false);
//				K7SCR_SYS_MESSAGE_B(mesid);
//				FixCamWithRiddle(CLOSED_DOOR);
				FixCamMesWithRiddle( CLOSED_DOOR, 2 );
			}
			
			K7SCR_PC_SETVISIBLE(true);
//			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
			
			return ret;
		}
		break;
	case	K7EVENTDOOR(007402):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_007402)==false ){
			// Ípl
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			GameInfo.SetPanelCtrlOffWait(true);
			K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(000304),K7SCR_GET_SCENARIO_FLAG(K7SCN07_DRFL_007402));
			K7SCR_PANEL_START();
			while( GameInfo.GetPanelModeState()!=WK7GameInfo::PMSTATE_TERM_CTRLOFFWAIT ){
				K7SCR_RETSYS();
			}
			GameInfo.SetPanelCtrlOffWait(false);
			switch( K7SCR_PANEL_GETRESULT() ){
			case	CODE_ANSWER_HIT:
				K7SCR_SET_SCENARIO_FLAG(K7SCN07_DRFL_007402);
				GameInfo.SetPanelNoiseCancel(true);
				WK7StageDoorInfo	*pDoorInfo;
				pDoorInfo = WK7Stage::GetDoorInfo(info.mCurrStageID,
				                                  "door_007402",
				                                  info.mNextStageID,
				                                  info.mNextBpName);
				gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,pDoorInfo!=NULL? (int)pDoorInfo->mOpenSeID : NOISE_SE_MAP_DEFAULT);
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				GameInfo.SetPanelNoiseCancel(false);
				break;
			case	CODE_ANSWER_MISS:
			default:
				K7SCR_PANEL_TERMWAIT();
				K7SCR_RETSYS();
				K7SCR_PANEL_EXIT();
				K7SCR_PANEL_EXITWAIT();
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_EVCONDCHANGE();
				return false;
			}
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage774M02::CondChangeCallBack(void)
{
	WK7JObj		*pWindJObj;
	EFFECT		*pWindEffect;
	bool		wind;
	pWindJObj = GetJObj(K7STAGE774M02_BROKENWALL_WINDNAME);
	K7SCR_JOBJ_HIDE(pWindJObj);
	if( K7SCR_GET_SCENARIO_FLAG(K7STAGE774M02_BROKENWALL_FLAG)==true ){
		wind = false;
	}else{
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					CatWindSePlay(windPos, K7STAGE774M02_BROKENWALL_FLAG, SFX_SCE0_SUKIMAKAZE);
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
//				ReleaseEffect(mpWindEffect);
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	WK7JObj		*pJObj;
	bool		flag;
	if( (pJObj=GetJObj(K7STAGE774M02_SECRETWALL_OBJNAME))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_2)==TRUE ){
			flag = true;
			K7SCR_JOBJ_HIDE(pJObj);
		}else{
			flag = false;
			K7SCR_JOBJ_DISP(pJObj);
		}
		K7SCR_STG_SET_PATHENABLE(K7STAGE774M02_SECRETWALL_PATHNAME,flag);
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE774M02_SECRETWALL_RIDDLE_PATHNAME,flag);
	}
	if( (pJObj=GetJObj(K7STAGE774M02_HINT_HIDE_OBJNAME))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_3)==TRUE ){
			K7SCR_JOBJ_HIDE(pJObj);
		}else{
			K7SCR_JOBJ_DISP(pJObj);
		}
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7STAGE774M02_BROKENWALL_FLAG)==TRUE ){
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE774M02_BROKENWALL_RIDDLE_PATHNAME,true);
	}else{
		K7SCR_STG_SET_DISABLEPATHCAMERA(K7STAGE774M02_BROKENWALL_RIDDLE_PATHNAME,false);
	}
	SetVisibleTamaJObj(K7EVENTTAMA(007401),!K7SCR_EVHASITEM(K7EVENTTAMA(007401)));
	RenewTamaEffect(K7EVENTTAMA(007401));
	//R[êJ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_1)==false ){
		DispJObj(K7STAGE774M02_LOCK_ON ,false,true);
		HideJObj(K7STAGE774M02_LOCK_OFF,false,true);
	}else{
		HideJObj(K7STAGE774M02_LOCK_ON ,false,true);
		DispJObj(K7STAGE774M02_LOCK_OFF,false,true);
	}
	return true;
}

bool K7Stage774M02::HitObjCallBack(WK7HitObjInfo &info)
{
#pragma	unused(info)
//	if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
//		info.SetHitObjEnable(true);
////		if( info.mpHitObj!=NULL ){
////			info.mpHitObj->SetEnable(true);
////		}
//		return false;
//	}
//	
//	if( info.mEventNo!=K7EVENTNO(007401) ){
//		return true;
//	}
//	
//	KK7BattleMainTask::BattleMainTaskExit(2);
//	K7SCR_RETSYS();
//	K7SCR_RETSYS();
//	
//	while( GameInfo.SetMode(WK7GameInfo::PLAY)==false ){
//		K7SCR_RETSYS();
//	}
//	
//	K7SCR_ENTER_PLAYMODE();
//	K7SCR_ENTER_DEMOPAUSE();
//	K7SCR_PC_SETVISIBLE(false);
//	
//	WK7JObj		*pJObj;
//	WK7JObj		*pWindJObj;
//	pJObj     = GetJObj(K7STAGE774M02_BROKENWALL_OBJNAME);
//	pWindJObj = GetJObj(K7STAGE774M02_BROKENWALL_WINDNAME);
//	K7SCR_JOBJ_HIDE         (pJObj);
//	K7SCR_JOBJ_HIDE         (pWindJObj);
//	K7SCR_SET_SCENARIO_FLAG (K7STAGE774M02_BROKENWALL_FLAG);
//	K7SCR_STG_SET_PATHENABLE(K7STAGE774M02_BROKENWALL_PATHNAME,true);
//	
//	FixCam(BROKEN_WALL);
//	
//	K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_BREAK_WALL);
//	K7SCR_PC_RETURNVISIBLE();
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
//	
//	return false;
	return true;
}

bool K7Stage774M02::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
	WK7PlayerSpInfoKed	*pKedInfo = WK7PLAYERCONTROL->GetSpInfoKed();
	switch( info.mAbilityID ){
	case	PC_SPA_BLOODY_SHOWER:
		switch( info.mType ){
		case	0:
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_2)==TRUE ){
				WK7PLAYERCONTROL->SetSpAbilityCancel(true);
				return false;
			}
			K7SCR_SET_SCENARIO_FLAG(K7SCN07_SP_774M02_2);
			WK7PLAYERCONTROL->SetSpInfoType(0);
			pKedInfo->mpTargetJObj = GetJObj(K7STAGE774M02_SECRETWALL_OBJNAME);
			pKedInfo->mKedPos .x = 164.996f;
			pKedInfo->mKedPos .y = 0.0f;
			pKedInfo->mKedPos .z = -369.961f;
			pKedInfo->mKedRotY   = PI;
			pKedInfo->mZanPos .x = 158.921f;
			pKedInfo->mZanPos .y = 0.0f;
			pKedInfo->mZanPos .z = -381.642f;
			pKedInfo->mZanRotY   = HALF_PI;
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_MOTSTART     ){
				K7SCR_RETSYS();
			}
			FixCam(SECTRET1);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANAPPEAR    ){
				K7SCR_RETSYS();
			}
			FixCam(SECTRET1_1);
			WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[SECTRET1_2].pos,
			                                           mpOneShotCamera[SECTRET1_2].tgt,
			                                           90.0f);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BAAN ){
				K7SCR_RETSYS();
			}
			FixCam(SECTRET1_3);
//			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_ZANDISAPPEAR ){
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED_BREAKOBJ ){
				K7SCR_RETSYS();
			}
			FixCam(SECTRET1_4);
			while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
				K7SCR_RETSYS();
			}
			return false;
		case	1:
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_3)==TRUE ){
				WK7PLAYERCONTROL->SetSpAbilityCancel(true);
				return false;
			}
			K7SCR_SET_SCENARIO_FLAG(K7SCN07_SP_774M02_3);
			WK7PLAYERCONTROL->SetSpInfoType
			(1);
			pKedInfo->mpTargetJObj = GetJObj(K7STAGE774M02_HINT_HIDE_OBJNAME);
			pKedInfo->mKedPos .x = -60.915f;
			pKedInfo->mKedPos .y = 0.0f;
			pKedInfo->mKedPos .z = -282.927f;
			pKedInfo->mKedRotY   = 0.0f;
			pKedInfo->mZanPos .x = -53.807f;
			pKedInfo->mZanPos .y = 0.0f;
			pKedInfo->mZanPos .z = -277.977f;
			pKedInfo->mZanRotY   = -HALF_PI;
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_MOTSTART     ){
				K7SCR_RETSYS();
			}
			FixCam(PANEL_HINT_0);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_ZANAPPEAR    ){
				K7SCR_RETSYS();
			}
			FixCam(PANEL_HINT_1);
			WK7CAM->StartLinearInterpolateOnLinearPath(mpOneShotCamera[PANEL_HINT_2].pos,
			                                           mpOneShotCamera[PANEL_HINT_2].tgt,
			                                           50.0f);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_KUIKUI ){
				K7SCR_RETSYS();
			}
			FixCam(PANEL_HINT_3);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_BLOODSTART ){
				K7SCR_RETSYS();
			}
			FixCam(PANEL_HINT_1);
			while( WK7PLAYERCONTROL->GetSpProc()!=SPKED2_MESSTART ){
				K7SCR_RETSYS();
			}
			FixCam(PANEL_HINT_4);
			while( WK7PLAYERCONTROL->SpAtkEffectEndTest(mID,K7KED)==false ){
				K7SCR_RETSYS();
			}
			return false;
		default:
			break;
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage774M02::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage774M02::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(007402):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_2)==TRUE ){
			return true;
		}
		break;
	case	K7EVENTNO(007403):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_3)==TRUE ){
			return true;
		}
		break;
	case	K7EVENTNO(007404):
		return true;
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_SP_774M02_1)==TRUE ){
//			return true;
//		}
		break;
	case	K7EVENTNO(007405):
		if( K7SCR_GET_SCENARIO_FLAG(K7STAGE774M02_BROKENWALL_FLAG)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

//------------------------------------------------------------------------------
// JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage774M02::SetCurrentCallBack( void )
{
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){179.393f, 6.109f, -139.322f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){179.304f, 5.650f, -238.937f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){178.675f, 5.650f, -339.073f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-61.103f, 6.027f, -270.497f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-61.112f, 6.018f, -491.161f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-78.312f, 6.018f, -489.846f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		KK7SoundLoopSePlayVolumeChange((Vec){-165.857f, 6.018f, -465.684f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE0_AMB_FAN_LOOP, K7SCR07_AMB_FAN_VOL );
		mAmbPlaySE = true;
	}
	
	K7SCR_EVCONDCHANGE();
	return( true );
}