////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage776M01
//
// K7Stage776M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE776M01_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage776M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7Item.h"

//[V
#define	MOT776M01_OPEN		(0)				//Gx[^̔J
#define	MOT776M01_CLOSE		(1)				//Gx[^̔
//f
#define	MDL776M01_ELEV_DOOR	"elevator_door"	//Gx[^




K7Stage776M01::K7Stage776M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage776M01_Camera );
}

K7Stage776M01::~K7Stage776M01()
{
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage776M01::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT776M01_OPEN );
	CreateOwnStageMotion( MOT776M01_CLOSE );
	
	return( true );
}
//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool K7Stage776M01::SetCurrentCallBack( void )
{
	//776M00痈ꍇ̓Gx[^Cxg
	if( GetPrevStageID() == K7STGID(776,0) )
	{
		//Gx[^oĂ
		ElevGetOff( ELEV_CAMERA_POS,
					ELEV_PLAYER_POS,
					MDL776M01_ELEV_DOOR,
					MOT776M01_OPEN,
					0,
					SFX_SYS_ELEV_DOOR,		//hAJSE
					SFX_SYS_ELEV_MOVE,		//Gx[^ړSE
					SFX_SYS_ELEV_ARRIVE,	//Gx[^SE
					false );				//ɔ[VZbg邩H
		//KVAɕςƂȂΕς
		if( K7SCR_GET_SCENARIO_FLAG(EV77601_CHANGE_GAL) == false )
		{
			//LN^KVAłȂ΃KVAɃ`FW
			if( WK7PLAYERCONTROL->GetMainID() != K7GAL )
			{
				//L|[Y
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				FixCam( EV_CHARACHG_2CAM );
				K7SCR_TIMEWAIT( 4800 * 2 );
				WatchCameraB( K7Stage776M01_Camera[EV_CHARACHG_2PC].tgt,
							  K7Stage776M01_Camera[EV_CHARACHG_2PC].pos,
							  K7CHRID(K7GAL,0), 1 );
				//L|[Y
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
			K7SCR_SET_SCENARIO_FLAG( EV77601_CHANGE_GAL );
		}
		return( false );
	}
	
	return( true );
}
//------------------------------------------------------------------------------
// hACxg
//------------------------------------------------------------------------------
bool K7Stage776M01::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//Gx[^ɏ
		case	K7EVENTDOOR( 007601 ):
			gpSound->mStopSE( SFX_SYS_ELEV_DOOR );
			ElevGetOn( ELEV_CAMERA_POS, ELEV_PLAYER_POS, MDL776M01_ELEV_DOOR, MOT776M01_CLOSE, 0 );
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}
//------------------------------------------------------------------------------
//_o
//------------------------------------------------------------------------------
bool
K7Stage776M01::BpLeaveCallBack( WK7BpInfo &info )
{
	WK7JObj*		pJObj;
	WK7ModelMotion*	pMotion;
	f32	motFrame, totalMotFrame;
	u32	evno   = GetBpEventNo( info );
	int	pathNo = GetBpPathNo( info );
	if( evno==0xffffffff )
	{
		return( true );
	}
	
	//Gx[^̋ŊJCxg
	switch( evno )
	{
		case	K7EVENTNO( 007602 ):
			//Gx[^JF߂Â
			if( pathNo == 0 )
			{
				if( (pJObj=GetJObj(MDL776M01_ELEV_DOOR)) != NULL )
				{
					motFrame = pJObj->GetCurrentMotionFrame( false, true );
					if( motFrame < 0.0f )
					{
						if( (pJObj=PlayMotion(MDL776M01_ELEV_DOOR,MOT776M01_OPEN)) != NULL )
						{
							gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							pJObj->SetMotionLoop( false ,false, true );
						}
					}else
					{
						//鑤̑[V擾ĊJ[V̊Jnt[vZ
						if( (pMotion=GetOwnModelMotion(MOT776M01_CLOSE)) != NULL )
						{
							totalMotFrame = pMotion->GetTotalMotionFrame();
							motFrame = totalMotFrame - motFrame;
						}else
						{
							motFrame = 0.000f;
						}
						if( (pJObj=PlayMotion(MDL776M01_ELEV_DOOR,MOT776M01_OPEN,NULL,motFrame)) != NULL )
						{
							if( motFrame == 0.0f )
							{
								gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							}
							pJObj->SetMotionLoop( false ,false, true );
						}
					}
				}
			}else
			//Gx[^F̂
			if( pathNo == 1 )
			{
				if( (pJObj=GetJObj(MDL776M01_ELEV_DOOR)) != NULL )
				{
					motFrame = pJObj->GetCurrentMotionFrame( false, true );
					if( motFrame < 0.0f )
					{
						if( (pJObj=PlayMotion(MDL776M01_ELEV_DOOR,MOT776M01_CLOSE)) != NULL )
						{
							gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							pJObj->SetMotionLoop( false ,false, true );
						}
					}else
					{
						//J̑[V擾ĊJ[V̊Jnt[vZ
						if( (pMotion=GetOwnModelMotion(MOT776M01_OPEN)) != NULL )
						{
							totalMotFrame = pMotion->GetTotalMotionFrame();
							motFrame = totalMotFrame - motFrame;
						}else
						{
							motFrame = 0.000f;
						}
						if( (pJObj=PlayMotion(MDL776M01_ELEV_DOOR,MOT776M01_CLOSE,NULL,motFrame)) != NULL )
						{
							if( motFrame == 0.0f )
							{
								gpSound->mPlaySE( SFX_SYS_ELEV_DOOR );
							}
							pJObj->SetMotionLoop( false ,false, true );
						}
					}
				}
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}


/*
//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool K7Stage776M01::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(007601):
		// {XJn
		u32		stgid = K7STGID(707,1);
		u32		chrid = K7CHRID(K7HAC,0);
		
		gpNoise->mSandRequest(eSandLongNoise);
		
		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());		// ݂̂goqɃL̃f[^e[uɔf
		WK7PLAYERCONTROL->Reset();
		WK7PLAYERCONTROL->ReleaseAll();
		
		K7SCR_STG_RELEASE    (K7SCR_STG_GET_CURRENTID());
		K7SCR_STG_CREATE_B   (stgid);
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			K7SCR_RETSYS();
		}
		
		K7SCR_RETSYS();
		WK7PLAYERCONTROL->CreateModel(chrid);
		WK7PLAYERCONTROL->CreatePackMotion(chrid);
		K7SCR_RETSYS();
		while( true == WK7PLAYERCONTROL->IsLoading() ){
			K7SCR_RETSYS();
		}
		WK7PLAYERCONTROL->SetOperateEnable(false);
		
		WK7PLAYERCONTROL->SetVisible(true);
		WK7PLAYERPATHCONTROL->CameraRenew();
		WK7PLAYERCONTROL->ChangeCallback();
		
		K7SCR_STG_SET_CURRENT(stgid);
		K7SCR_STG_VISIBLE    (stgid,true);
		
		WK7Stage::SetRenderStage(false);
		WK7Chara::SetRenderChara(false);
		WK7Item::SetRenderItem  (false);
		
		gpNoise->mSandRelease();
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		
		K7SCR_DEBUGPRINT     ("Encounter BOSS !!");
		return false;
	default:
		break;
	}
	return true;
}
*/

