////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage776M02
//
// K7Stage776M02.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE776M02_CPP__

#include "..\..\..\Scn\K7Scn07.h"
#include ".\K7Stage776M02.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Wat\WK7Cam.h"
#include "..\..\..\Kaw\KK7BattleCtrl.h"
#include "..\..\..\Yam\YK7EffectFeather.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"

//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage776M02::K7Stage776M02(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage776M02_Camera );
	mpEffect = NULL;
	mAngelCamera = false;
	WK7PLAYERCONTROL->SetCamRevDisable(true);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage776M02::~K7Stage776M02()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
	//HGtFNg
	if( mpEffect != NULL )
	{
		DeleteEffect( mpEffect );
	}
	WK7PLAYERCONTROL->SetCamRevDisable(false);
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage776M02::CreateCallBack( void )
{
	if( GetPrevStageID() == K7STGID(776,1) ){
		SetManualBranch(true);
	}

	//{X̔g`t@C̓ǂݍ
	gpSound->mReadSsm( "seBossAngKun.ssm", eBankBoss );
	while( gpSound->mGetProcess() != eSndStandby )
	{
		K7SCR_RETSYS();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage776M02::TerminateCallBack( void )
{
	//{X̔g`t@C
	gpSound->mReleaseSsm( "seBossAngKun.ssm");
//	gpSound->mStopSE( SFX_BOSS_ANGKUN_WINGSNOW );
	gpSound->mSetVolumeSE( SFX_BOSS_ANGKUN_WINGSNOW, 0, 200 );
	
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage776M02::SetCurrentCallBack( void )
{
	//Jf[^G[`FbN
	if( mpOneShotCamera == NULL )
	{
		return( false );
	}
	//ǂJɂȂ܂ő҂
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	SetManualBranch(false);
	
	WK7StagePlaceInfo		*pPlaceInfo;
	pPlaceInfo = GetPlaceInfo("branchA");
	SetCameraStartPosition(pPlaceInfo);
	while( SandRelease(pPlaceInfo)==false ){
		K7SCR_RETSYS();
	}
	
	//pX
	BrockPath();
	//776M01痈ꍇɃCxgJn
	if( GetPrevStageID() == K7STGID(776,1) )
	{
		//Vg|`FbN
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007601) == FALSE )
		{
			//Vg̑O
			PreBattleAngel();
			
			// {X풆tO𗧂Ă
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
			
			//Vg
			if( BattleAngel() == true )
			{
				//Vgɏ
		        K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007601 );
				//Vg̑O
				PreBattleFallenAngel();
				
				//Vg
				if( BattleFallenAngel() == true )
				{
					//Vgɏ
					K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007602 );
					//pX
					ReleasePath();
					
					// {X풆tONA
					WK7PLAYERCONTROL->BattlePadRegulationSet();
				}
			}
		}else
		//Vg|`FbN
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN07_EVFL_007602) == FALSE )
		{
			while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
			//Vg̑O
		  //PreBattleFallenAngel();
			//Vg
			
			// {X풆tO𗧂Ă
			WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_BOSSBATTLE);
			
			if( BattleFallenAngel() == true )
			{
				//Vgɏ
				K7SCR_SET_SCENARIO_FLAG( K7SCN07_EVFL_007602 );
				//pX
				ReleasePath();
				// {X풆tONA
				WK7PLAYERCONTROL->BattlePadRegulationSet();
			}
		}else{
			while( gpNoise->mGetSandFrameProc() != eSandStandby ){K7SCR_RETSYS();}
			gpSound->mPlayStreamNo(HPS_TENSHI_A);
		}
	}
	//pX
	ReleasePath();
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return( false );
}

//------------------------------------------------------------------------------
//Vg̑O
//------------------------------------------------------------------------------
void
K7Stage776M02::PreBattleAngel( void )
{
	WK7PathNurbs *pPath = NULL;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	//n[}ɃL`FW
	if( WK7PLAYERCONTROL->GetMainID() != K7HAC )
	{
		
		FixCam( EV_CHARCHG_HAC_2CAM );
		K7SCR_TIMEWAIT( 4800 * 2 );
		WatchCameraB( K7Stage776M02_Camera[EV_CHARCHG_HAC_2PC].tgt,
					  K7Stage776M02_Camera[EV_CHARCHG_HAC_2PC].pos,
					  K7CHRID(K7HAC,0), 1 );
		//L؂ւ̓|[YĂ܂̂ŉ߂ăL|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
	}
	//vC[
	K7SCR_PC_SETVISIBLE( false );
	
	//mCY
	K7SCR_NOISE_REQUEST();
	
	//n[}ƃT}T̃L
	K7SCR_CHARAGEKI_PREPARE( K7EVENTPLAY(00020703) );
	K7SCR_NOISE_RELEASE();
	K7SCR_CHARAGEKI_END_WAIT( K7EVENTPLAY(00020703) );
	WK7Play*	pPlay = WK7Play::Find(K7EVENTPLAY(00020703));
	pPlay->SetVisibleAll( false );
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	GHM_SAFE_DELETE( pPlay );
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::SetPlayed( K7EVENTPLAY(00020703),true );
	
	//n[}ƓVg̃L
	WK7Play::PlayTB( K7EVENTPLAY(00020707) );
	
	//mCY
	K7SCR_NOISE_REQUEST();
	WK7Play::RestorePlayTB();
	
	//vC[\
	K7SCR_PC_SETVISIBLE( true );
	//n[}̍Wړ
	pPath = GetPathNurbs( "play_00020703" );
	WK7Stage::SetCurrentPath( pPath, 1.0f, 0, WK7PATHINFO_INITDIR_TGTDIR_REV );
	
	//ǂJɂȂ܂ő҂
	while( WK7Stage::IsChanging() != false )
	{
		K7SCR_RETSYS();
	}
	
	//pX
	BrockPath();
	
	FixCam(EV_HAC_CAM);
	
	//mCY܂ő҂
	K7SCR_NOISE_RELEASE();
	
	// L|[Y
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
}

//------------------------------------------------------------------------------
//Vg̑O
//------------------------------------------------------------------------------
void
K7Stage776M02::PreBattleFallenAngel( void )
{
	u32				id;
	
	// og[hExit
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
//	if( gpNoise->mGetSandFrameProc() != eSandStandby ){
//		FixCam( EV_CHARCHG_DAN_2CAM );
//		K7SCR_NOISE_RELEASE();
//	}
	
	//n[}瑼LɃ`FW
	if( WK7PLAYERCONTROL->GetMainID() == K7HAC )
	{
		if( BattleCtrl.PcDieTest( K7DAN ) != true )
		{
			id = K7CHRID( K7DAN, 0 );
		}else
		if( BattleCtrl.PcDieTest( K7KED ) != true )
		{
			id = K7CHRID( K7KED, 0 );
		}else
		if( BattleCtrl.PcDieTest( K7KVN ) != true )
		{
			id = K7CHRID( K7KVN, 0 );
		}else
		if( BattleCtrl.PcDieTest( K7CYO ) != true )
		{
			id = K7CHRID( K7CYO, 0 );
		}else
		if( BattleCtrl.PcDieTest( K7CAT ) != true )
		{
			id = K7CHRID( K7CAT, 0 );
		}else
		if( BattleCtrl.PcDieTest( K7MSK ) != true )
		{
			id = K7CHRID( K7MSK, 0 );
		}else
		if( (BattleCtrl.PcDieTest(K7HAY) == false) && (K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true) )
		{
			id = K7CHRID( K7HAY, 0 );
		}else
		{
			id = K7CHRID( K7GAL, 0 );
		}
///		FixCam( EV_CHARCHG_DAN_2CAM );
///		K7SCR_TIMEWAIT( 4800 * 2 );
		WatchCameraB( K7Stage776M02_Camera[EV_CHARCHG_DAN_2PC].tgt,
					  K7Stage776M02_Camera[EV_CHARCHG_DAN_2PC].pos,
					  id, 1 ,false);
	}
	//pX
	BrockPath();
	// L|[Y
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
}

//------------------------------------------------------------------------------
//pX
//------------------------------------------------------------------------------
void
K7Stage776M02::BrockPath( void )
{
	WK7PathNurbs*	pPath;
	
	//OɒʂpX𕕍
	if( (pPath = GetPathNurbs("play_00020703")) != NULL )
	{
		pPath->SetEnable( false );
		pPath->SetEnableEx( false );
	}
	//ɒʂpX𕕍
	if( (pPath = GetPathNurbs("curve47")) != NULL )
	{
		pPath->SetEnable( false );
		pPath->SetEnableEx( false );
	}
}

//------------------------------------------------------------------------------
//pX
//------------------------------------------------------------------------------
void
K7Stage776M02::ReleasePath( void )
{
	WK7PathNurbs*	pPath;
	
	//OɒʂpX
	if( (pPath = GetPathNurbs("play_00020703")) != NULL )
	{
		pPath->SetEnable( true );
		pPath->SetEnableEx( true );
	}
	//ɒʂpX
	if( (pPath = GetPathNurbs("curve47")) != NULL )
	{
		pPath->SetEnable( true );
		pPath->SetEnableEx( true );
	}
}

//------------------------------------------------------------------------------
//Vg
//------------------------------------------------------------------------------
#include "..\..\..\Enm\EnmANG.h"
#include "..\..\..\Enm\EnmFAN.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
bool
K7Stage776M02::BattleAngel( void )
{
  gpSound->mPlayStreamNo(HPS_BOSS_ANG);

  {//B
	while( 0 == K7EnmANG::GetInstance() ) retsys();
	while( 0 == K7EnmFAN::GetInstance() ) retsys();
  }

  {//todo
	//Ԉ֎q͓ȂB
	WK7PLAYERCONTROL->SetTurnAble( false );
	WK7PLAYERCONTROL->SetWalkAble( false );
	//J͌ŒŁB
//	WK7Cam *cam = K7EV_MAINTASK->GetCamera();
//	Vec t = {61.f, 7.f, 169.f}, p = {65.f, 6.f, 176.f};
//	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//	WK7CAM->SetPosition      (p);
//	WK7CAM->SetTargetPosition(t);
	FixCam(EV_HAC_CAM);
  }

  {//퓬B
	while( K7EnmANG::GetInstance() && ANG.GetState() == ANG_STATE_NEUTRAL ){
	  //\LɌB
	  Vec ppos, epos;
	  f32 dir;
	  if ( NULL != WK7PLAYERCONTROL->GetWaistObjPtr() ) {
		WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(ppos);
	  }
	  ANG.GetPosition( epos);
	  dir = atan2f((f32 )epos.x - ppos.x, (f32 )epos.z - ppos.z);
	  WK7PLAYERCONTROL->SetKamaeDir(dir);
	  K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->InitKamaeDir();
  }

  gpSound->mFadeVolumeStream(0,30);
  gpSound->mStopStream();

  {//S`B
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	K7SCR_ENTER_PLAYMODE_B();
	
	//K7SCR_ENTER_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	KK7BattleMainTask::BattleMainTaskExit(2);
	
	//K7SCR_NOISE_REQUEST();
	
	//WK7CAM->SetCinemaScopeMode(true);

	//Vec t = {49.f, 9.f, 86.f}, p = {48.f, 1.f, 115.f};
	Vec t = {49.738f, 3.591f, 88.432f}, p = {49.765f, 0.1f, 100.156f};
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (p);
	WK7CAM->SetTargetPosition(t);

	//K7SCR_NOISE_RELEASE();
	
	//cD
	while( K7EnmANG::GetInstance() && ANG.GetState() == ANG_STATE_DAMAGE ){
	  K7SCR_RETSYS();
	}

	//d
	s32 counter = 120;
	while( --counter ){
	  K7SCR_RETSYS();
	}
	
	//̓
	gpSound->mPlayStreamNo(HPS_BOSS_KUN);
	if( K7EnmFAN::GetInstance() ) FAN.AppearReq(1 );
	K7SCR_RETSYS();
	if( K7EnmANG::GetInstance() ) ANG.Disappear();
	while( K7EnmFAN::GetInstance() && FAN.GetState() == FAN_STATE_WAKEUP ){
	  K7SCR_RETSYS();
	}

	{//Lւ҂B
	  if( K7EnmFAN::GetInstance() ) FAN.PauseReq( true );
	}

	//ẘ猩J
	counter = 0;
	f32 fv_old_ = WK7CAM->GetFov();
	while( 200 > ++counter ){
		f32 rate_ = counter / 120.f; if( rate_>1.f ) rate_ = 1.f;
		C_Vec e0_(43.825f, 3.317f, 52.284f), t0_(47.512f, 2.477f, 76.124f);
		C_Vec e1_(45.360f, 11.734f, 58.353f), t1_(48.505f, 10.800f, 82.268f);
		f32 fv_ = 10.84f;
		
		e0_ = e0_*(1.f-rate_) + e1_*rate_;
		t0_ = t0_*(1.f-rate_) + t1_*rate_;
		
		WK7CAM->SetPosition      (e0_);
		WK7CAM->SetTargetPosition(t0_);
		if ( counter > 1 ){							// ɕςƁAȂpɕςĂ܂̂ŁAPtx点
			WK7CAM->SetFov(fv_);
		}
		
		K7SCR_RETSYS();
	}
	
	//ɖ߂Bi̂Ŏ̃JɋIɕςĂ
	WK7CAM->SetPosition      (K7Stage776M02_Camera[EV_CHARCHG_DAN_2PC].pos);
	WK7CAM->SetTargetPosition(K7Stage776M02_Camera[EV_CHARCHG_DAN_2PC].tgt);
	K7SCR_RETSYS();
	WK7CAM->SetFov(fv_old_);
  }

  if( K7EnmANG::GetInstance() ) return true;
  else return false;
}

//------------------------------------------------------------------------------
//Vg
//------------------------------------------------------------------------------
bool
K7Stage776M02::BattleFallenAngel( void )
{
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	mAngelCamera = true;
	WK7PLAYERCONTROL->SetCamRevDisable(true);
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020707","c1",0.0f,WK7PATHINFO_INITDIR_TGTDIR);
	WK7PLAYERCONTROL->RestorePathPosition();
	WK7PLAYERCONTROL->ClearSwitchBuffer();
	WK7Model		*pModel = WK7PLAYERCONTROL->GetCharaModel();
	if( pModel!=NULL ){
		pModel->FrameProcess();
	}
	WK7CAM->FrameProcess();
	WK7CAM->SetCurrent();
	WK7RenderObj::PrivateLightProcessAll();
  {//todo
	// lQ[I[o[[hł̂H
	//WK7PLAYERCONTROL->SetGameOver(); 
	//퓬̓pXI,OɏoȂ悤ɂȂėǂ̂H
	if( K7EnmANG::GetInstance()==0 ) 
	  gpSound->mPlayStreamNo(HPS_BOSS_KUN);
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	K7SCR_RETSYS();
  }

  {//퓬B
	if( K7EnmFAN::GetInstance() ) {
	  FAN.PauseReq( false );
	  FAN.AppearReq( 2 );
	}
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	while( K7EnmFAN::GetInstance() && FAN.GetState() != FAN_STATE_DEAD ){
	  //\LɌB
	  Vec ppos, epos;
	  f32 dir;
#if 1
	  if( FAN.GetState() == FAN_STATE_DAMAGE ){
		// _[W𕉂ƂɃJς鉉o
		KK7BattleMainTask::BattleMainTaskExit(2);
		K7SCR_ENTER_PLAYMODE_B();
		
		WK7Cam *cam = K7EV_MAINTASK->GetCamera();
		//cam->SetCinemaScopeMode(true);
		//cam->SetCinemaScopeAdjust(false);
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		while( FAN.GetState() == FAN_STATE_DAMAGE ){
			FAN.SetupEyeTgtPos( epos, ppos );
			WK7CAM->SetPosition      (epos);
			WK7CAM->SetTargetPosition(ppos);
			K7SCR_RETSYS();
		}
		
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7PLAYERCONTROL->SetOperateEnable(true);
		//cam->SetCinemaScopeMode(false);
		//cam->SetCinemaScopeAdjust(true);
		K7SCR_EXIT_PLAYMODE();
		
	  }else{
		if ( NULL != WK7PLAYERCONTROL->GetWaistObjPtr() ) {
		  WK7PLAYERCONTROL->GetWaistObjPtr()->GetWorldPosition(ppos);
		}
		FAN.GetPosition( epos);
		dir = atan2f((f32 )epos.x - ppos.x, (f32 )epos.z - ppos.z);
		WK7PLAYERCONTROL->SetKamaeDir(dir);
	  }
#else
#if 0
	  if( !WK7PLAYERCONTROL->PcBattleTaskTest() && 
		  WK7CAMPATHFOLLOWINFO->GetMode() != WK7CamPathFollowInfo::FREE_MODE )
		WK7CAMPATHFOLLOWINFO->SetMode( WK7CamPathFollowInfo::FREE_MODE );

	  WK7Cam *cam = K7EV_MAINTASK->GetCamera();
	  //cam->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	  FAN.SetupEyeTgtPos( epos, ppos );
	  WK7CAM->SetPosition      (epos);
	  WK7CAM->SetTargetPosition(ppos);
	  WK7CAM->SetFov(45.f);
#else
	  
#endif
#endif


	  K7SCR_RETSYS();
	  if ( false == WK7RenderObj::IsValid(this) ){
		// Ă܂ǂHiob
		WK7PLAYERCONTROL->BattlePadRegulationSet();
		gpSound->mStopStream();
		return true;
	  }
	}
	WK7PLAYERCONTROL->InitKamaeDir();
  }
  {
	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_PC_SETVISIBLE( false );
	mAngelCamera = false;
	Vec t = {49.f, 3.591f, 88.432f}, p = {49.765f, 0.1f, 100.156f};
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (p);
	WK7CAM->SetTargetPosition(t);

	//HƉ
	K7EnmFAN *pNpcFan   = (K7EnmFAN*)WK7Npc::Find(ENENO_FAN);
	WK7Model *pFanModel = NULL;
	if( pNpcFan != NULL )
	{
		WK7Chara *pCharaTmp = pNpcFan->pCurrentChara();
		if( pCharaTmp != NULL )
		{
			pFanModel = pCharaTmp->GetModel();
			if( pFanModel != NULL )
			{
				pFanModel->Hide();
				mpEffect = 	CreateFeatherEffect( VParam[ED_FEATHER][13], 
							(Vec){0.0f,0.0f,0.0f},
							VParam[ED_FEATHER][7] * 0.05F, PI_2 * VParam[ED_FEATHER][8] / 360, 
							(u8)VParam[ED_FEATHER][3], VParam[ED_FEATHER][4] * 0.1F, VParam[ED_FEATHER][5] * 0.01F,
							(u8)VParam[ED_FEATHER][1], (u8)VParam[ED_FEATHER][2], VParam[ED_FEATHER][9] * 0.001F, 
							VParam[ED_FEATHER][10] * 10.0F,	0, pFanModel->GetObj( "Root_joint" ), 30/*(s8)VParam[ED_FEATHER][14]*/ ) ;
			}
		}
	}
	K7SCR_TIMEWAIT( 4800 );
	gpSound->mPlaySEP( SFX_BOSS_ANGKUN_WINGSNOW, 300 ,SOUND_SYSTEM_SE_VOLUME/5 );
  }

  {//VgS
	KK7BattleMainTask::BattleMainTaskExit(2);
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_PC_SETVISIBLE(false);
	
	//K7SCR_ENTER_DEMOPAUSE();
	WK7Cam *cam = K7EV_MAINTASK->GetCamera();
	//cam->SetCinemaScopeMode(true);

	//Vec t = {49.f, 9.f, 86.f}, p = {48.f, 1.f, 115.f};
	Vec t = {49.f, 3.591f, 88.432f}, p = {49.765f, 0.1f, 100.156f};
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7CAM->SetPosition      (p);
	WK7CAM->SetTargetPosition(t);

	s32 old = -1, cur;
	while( K7EnmFAN::GetInstance() && (cur = FAN.GetState()) != FAN_STATE_GAMEOVER ){
	  if( cur != old && cur == FAN_STATE_DEAD ) {
		gpSound->mFadeVolumeStream(0,30);
		gpSound->mStopStream();
	  }
	  old = cur;
	  K7SCR_RETSYS();
	}

	{
	  s32 c_ = 60;
	  while( --c_ ) K7SCR_RETSYS();
	}

	WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FOLLOW_MODE);
	WK7CAMPATHFOLLOWINFO->SetPos(WK7CamPathFollowInfo::RENEW_IM);
	WK7PLAYERCONTROL->SetCamRevDisable(false);

	K7SCR_PC_SETVISIBLE( true );
	WK7PLAYERCONTROL->SetOperateEnable(true);
	K7SCR_PC_SETVISIBLE(true);
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	//cam->SetCinemaScopeMode(false);
  }

  //IB
  if( K7EnmFAN::GetInstance() ) return true;
  else return false;
}

bool K7Stage776M02::PathChangeCallBack(WK7PathChangeInfo &info)
{
	if( mAngelCamera==false ){
		return true;
	}
	WK7PathNurbs	*pPath = info.GetPath();
	if( pPath==NULL ){
		return true;
	}
static	Vec		tgt = { 50.0f,10.0f,80.0f };
	Vec			pos,dir;
	
	pPath->GetStartPoint  (pos);
	pPath->GetStartDiffVec(dir);
	
	VECSubtract    (&tgt,&pos,&pos);
	pos.y = 0.0f;
	dir.y = 0.0f;
	VECCrossProduct(&dir,&pos,&pos);
	if( pos.y > 0.0f ){
		WK7CAMPATHFOLLOWINFO->SetPosH(WK7CamPathFollowInfo::POSHR);
	}else{
		WK7CAMPATHFOLLOWINFO->SetPosH(WK7CamPathFollowInfo::POSHL);
	}
	
	if( WK7CAMPATHFOLLOWINFO->GetMode()!=WK7CamPathFollowInfo::TARGETFIX_MODE ){
		WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::TARGETFIX_MODE);
		WK7CAMPATHFOLLOWINFO->SetPos (WK7CamPathFollowInfo::RENEW_IM);
	}
//	WK7CAMPATHFOLLOWINFO->SetPosV(pPathDataDesc->mCamPosV);
//	WK7CAMPATHFOLLOWINFO->SetPosH(pPathDataDesc->mCamPosH);
	WK7CAMPATHFOLLOWINFO->SetTargetFixPosition(tgt);
	return false;
}

WK7CamSet* K7Stage776M02::GetCamSet(u32 /*chrid*/)
{
	if( mAngelCamera==false ){
		return NULL;
	}
static	WK7CamSet	camset[] = {
	WK7CAMSET_DECL_CHR_BEGIN(K7DAN)
					//      fd        ph         pv         tf         th         tv
		WK7CAMSET_DECL_CHR( 7.000f, 20.000f, 10.000f, 20.000f, 20.000f, 20.000f)	// O
		WK7CAMSET_DECL_CHR( 7.000f, 20.000f, 10.000f, 20.000f, 20.000f, 20.000f)	// EO
		WK7CAMSET_DECL_CHR( 7.000f, 20.000f, 10.000f, 20.000f, 20.000f, 20.000f)	// 
		WK7CAMSET_DECL_CHR( 7.000f, 20.000f, 10.000f, 20.000f, 20.000f, 20.000f)	// E
	WK7CAMSET_DECL_CHR_END()
};
	return camset;
}

