////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage100M00
//
// K7Stage100M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE100M00_CPP__

#include "..\..\Scn\K7Scn01.h"
#include ".\K7Stage100M00.h"
#include "..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

#define	K7STAGE100M00_DOOR010009_BROKEN		"BrokenDoor010009"
#define	K7STAGE100M00_DOOR010009_PATH		"FoyerPath"
K7Stage100M00::K7Stage100M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpRainEffect = NULL;
	SetOneShotCamLocTbl(K7Stage100M00_Camera);
}

K7Stage100M00::~K7Stage100M00()
{
//	gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
	ReleaseEffect(mpRainEffect);
}

bool K7Stage100M00::InitializeCallBack(void)
{
//	Vec		point = { 0.0f , 40.0f , 150.0f };
//	mpRainEffect = CreateEffectRain(point,-6.0f,300.0f);
	WK7JObj		*pObj = GetJObj("burn");
	if( pObj!=NULL ){
		pObj->Hide(false,true);
		SetModelFireMaxNumRate( 2.0F ) ;
		CreateEffectModelFire(pObj,MFIRE_WALL);
	}
	u32		stgid = K7STGID(190, 1);
static const char	*pDoorName = "branchF";
	SetSelectObjFlag(stgid,pDoorName,1,true);
	SetPassPathFlag (stgid,pDoorName,1,true);
	return true;
}

bool K7Stage100M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
#pragma unused(info)
#if 0
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010009):
    	K7SCR_DEBUGPRINT("DOOR_010009 Closed : Mask need to break door");
		
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// Jς
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetPosition      (K7Stage100M00_Camera[DOOR_010009].pos);
		WK7CAM->SetTargetPosition(K7Stage100M00_Camera[DOOR_010009].tgt);
		K7SCR_PC_SETVISIBLE(false);
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010009)==false ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010009);
			K7SCR_STGC_MESSAGE_B(K7STAGE100M00_MES_DONT_OPEN_DOOR);
		}else{
			K7SCR_STGC_MESSAGE_B(K7STAGE100M00_MES_BROKEN_BY_POWERFUL_WEAPON);
		}
		
		K7SCR_PC_RETURNVISIBLE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		K7SCR_EVCONDCHANGE();
		return false;
	case	K7EVENTDOOR(010010):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010010)==false ){
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010010);
			
			// Jς
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage100M00_Camera[DOOR_010010].pos);
			WK7CAM->SetTargetPosition(K7Stage100M00_Camera[DOOR_010010].tgt);
			K7SCR_PC_SETVISIBLE(false);
			
//			gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
			
			K7SCR_STGC_MESSAGE_B(K7STAGE100M00_MES_OPEN_GATE);
													// J
			
			K7SCR_PC_RETURNVISIBLE();
		}
		
		gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
		ReleaseEffectAll();
//		gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL);
//		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//			K7SCR_RETSYS();
//		}
//		gpSound->mStopStream();
//		GameInfo.MapSelectInit(MAP_FUKUSHIMA,MAP_GAL_HOME);
//		GameInfo.SetMapSelectValidFlag(MAP_GAL_HOME ,TRUE);
//		GameInfo.SetMapSelectValidFlag(MAP_FUKUSHIMA,TRUE);
//		while( gpNoise->mSandRelease()==false ){
//			K7SCR_RETSYS();
//		}
//		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//			K7SCR_RETSYS();
//		}
//		while( GameInfo.CheckMapSelectEnd()==false ){
//			K7SCR_RETSYS();
//		}
//		GameInfo.MapSelectEnd();
		break;
	case	K7EVENTDOOR(010016):
#if 0
		// ւ̔
		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010002))!=TRUE ){
	    	K7SCR_DEBUGPRINT("DOOR_010016 Closed : need KEY_010002");
			FixCamMes(DOOR_010016,K7STAGE100M00_MES_LOCKED_KEY);
			return false;
		}else if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010016)==false ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010016);
			FixCamMes(DOOR_010016,K7STAGE100M00_MES_USE_KEY);
		}
#endif
	default:
		break;
	}
#endif
	return true;
}

bool K7Stage100M00::SetCurrentCallBack(void)
{
	KK7SoundLoopSePlayVolumeChange((Vec){-15.695f, 1.723f, -285.993f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_FIRE);
	KK7SoundLoopSePlayVolumeChange((Vec){ 13.761f, 1.323f, -217.142f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A  );
	KK7SoundLoopSePlayVolumeChange((Vec){-14.436f, 1.323f, -195.980f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_B  );
	KK7SoundLoopSePlayVolumeChange((Vec){-13.424f, 1.323f, -174.122f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_C  );
	KK7SoundLoopSePlayVolumeChange((Vec){ 13.636f, 1.323f, -144.803f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_FIRE);
	KK7SoundLoopSePlayVolumeChange((Vec){-15.986f, 1.345f, - 82.998f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A  );
//	gpSound->mPlaySE(SFX_SCE1_FUKU_RAIN);
	return true;
}

bool K7Stage100M00::CondChangeCallBack(void)
{
	bool	branch;
	bool	seal;
//	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1)==TRUE ){
//		branch = true;
//		seal   = false;
//	}else{
		branch = false;
		seal   = true;
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP);
//	}
	K7SCR_STG_SET_PATHENABLE("branchC",branch);
	SetVisibleJObj("Seal",seal,false,true);
#if 0
	WK7JObj			*pObj[2];
	pObj[0] = GetObjEventNo(K7EVENTDOOR(010009));
	pObj[1] = GetJObj("BrokenDoor010009");
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DOOR_010009)==FALSE ){
		K7SCR_JOBJ_DISP(pObj[0]);
		K7SCR_JOBJ_HIDE(pObj[1]);
		K7SCR_STG_SET_PATHENABLE(K7STAGE100M00_DOOR010009_PATH,false);
	}else{
		K7SCR_JOBJ_DISP(pObj[1]);
		K7SCR_JOBJ_HIDE(pObj[0]);
		K7SCR_STG_SET_PATHENABLE(K7STAGE100M00_DOOR010009_PATH,true );
	}
#endif
	return true;
}

bool K7Stage100M00::HitObjCallBack(WK7HitObjInfo &info)
{
#pragma unused(info)
#if 0
	WK7JObj		*pObj;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010009):
		info.SetHitObjEnable(true);
//		if( info.mpHitObj!=NULL ){
//			info.mpHitObj->SetEnable(true);
//		}
		if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
			break;
		}
		if( (pObj = GetObjEventNo(info.mEventNo))!=NULL ){
			Vec					pos;
			WK7RenderObjEffect	*pSmokeEffect;
			pObj->GetWorldPosition(pos);
			
			pSmokeEffect = CreateEffectSmoke(pos);
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_DOOR_010009);
			K7SCR_EVCONDCHANGE();
			
			//ogIB
			KK7BattleMainTask::BattleMainTaskExit(2);
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			WK7PLAYERCONTROL->SetVisible(false);
			
			// Wait
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			
			K7SCR_STGC_MESSAGE_B(K7STAGE100M00_MES_BROKEN_DOOR);				// ǂj󂵂
			
			k7app.SetFadeColor(0);
			k7app.FadeStart(0xff,WK7_DEFAULT_FADE_TICK);
			while( k7app.IsFade()==true ){
				K7SCR_RETSYS();
			}
			
			ReleaseEffect(pSmokeEffect);
			
			// ̌L
//			K7SCR_TIMEWAIT(4800);
			while( WK7Stage::ReleaseStageArchive()==false ){
				K7SCR_RETSYS();
			}
			while( WK7Stage::IsReleasedStageArchive()==false ){
				K7SCR_RETSYS();
			}
			k7app.FadeStart(0,0);
			WK7Play::StorePlayTB();
			WK7Play::PlayTB(K7EVENTPLAY(01050101));
			WK7Play::RestorePlayTB();
			k7app.FadeStart(0xff,0);
			while( WK7Stage::RestoreStageArchive()==false ){
				K7SCR_RETSYS();
			}
			while( WK7Stage::IsRestoredStageArchive()==false ){
				K7SCR_RETSYS();
			}
			
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set8","curve7",0.0f,WK7PATHINFO_INITDIR_TGTDIR_REV);
			
			WK7PLAYERCONTROL->SetVisible(true);
			
			k7app.FadeStart(0x00,WK7_DEFAULT_FADE_TICK);
			while( k7app.IsFade()==true ){
				K7SCR_RETSYS();
			}
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		break;
	default:
		break;
	}
#endif
	return true;
}

bool K7Stage100M00::PlayEventCallBack(WK7PlayEventInfo &info)
{
#pragma	unused(info)
	return false;
}

