////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage101M00
//
// K7Stage101M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/04/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE101M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage101M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Kaw\KK7Sound.h"

K7Stage101M00::K7Stage101M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpRainEffect = NULL;
}

K7Stage101M00::~K7Stage101M00()
{
	gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
	ReleaseEffect(mpRainEffect);
}

bool K7Stage101M00::InitializeCallBack(void)
{
//	Vec		point = { 0.0f , 40.0f , -350.0f };
//	mpRainEffect = CreateEffectRain(point,0.0f,1000.0f);
	mpRainEffect = CreateEffectRain(40.0f,0.0f);
	return true;
}

bool K7Stage101M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
#pragma	unused(info)
	return true;
}

bool K7Stage101M00::PathChangeCallBack(WK7PathChangeInfo &info)
{
static	const char	*pSideViewPath[] = {
		"curve15",
//		"curve16",
//		"curve17",
		NULL,
	};
	if( info.CompareList(pSideViewPath) >= 0 ){
		static Vec				railpos[2] = {
//			{ 90.0f , 10.0f , -335.0f },
//			{ 90.0f , 10.0f , -375.0f },
			{ -150.0f , 1.5f , -400.0f },
			{ -150.0f , 1.5f , -300.0f },
		};
		WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::RAIL_MODE);
		WK7CAMPATHFOLLOWINFO->SetRailPosition(railpos);
		return false;
	}
#if 0
static	const char	*pRightFollowPath[] = {
		"curve16",
		NULL,
	};
	if( info.CompareList(pRightFollowPath) >= 0 ){
		WK7CAMPATHFOLLOWINFO->SetPos(WK7CamPathFollowInfo::POSRD);
		return true;
	}
static	const char	*pNormalFollowPath[] = {
		"curve13",
		NULL,
	};
	if( info.CompareList(pNormalFollowPath) >= 0 ){
		WK7CAMPATHFOLLOWINFO->SetPos(WK7CamPathFollowInfo::POSCD);
		return true;
	}
#endif
	return true;
}

bool K7Stage101M00::SetCurrentCallBack(void)
{
//	gpSound->mPlaySE(SFX_SCE1_FUKU_RAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){-  0.002f, 32.374f, -558.668f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){   0.023f, 32.260f, -433.556f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){-124.749f, 32.260f, -433.422f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){-124.520f, 32.374f, -260.825f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){-  0.138f, 32.374f, -260.926f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	KK7SoundLoopSePlayVolumeChange((Vec){-  0.098f, 32.374f, -108.195f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_ROOFRAIN);
	return true;
}

