////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage102M00
//
// K7Stage102M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE102M00_CPP__

#include ".\K7Stage102M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Panel\SK7PanelNiou.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

#define	K7STAGE102M00_MIRACLE_OBJ			"event_010604_cmn"
#define	K7STAGE102M00_PANEL_MOTION_NAME		"event_010600_cmn"
#define	K7STAGE102M00_PANEL_MODEL_NAME0		"event_010600_cmn"
#define	K7STAGE102M00_PANEL_MODEL_NAME1		"event_010601_cmn"

static	const char	*gpFusumaName[2][2] = {
	{ "FusumaGroup01","FusumaGroup02" },
	{ "FusumaGroup03","FusumaGroup04" },
};
static	const char	*gpPathName0[] = {
	"curve1_010602",
	"curve2_010602",
	NULL,
};
static	const char	*gpPathName1[] = {
	"curve3_010603",
	"curve4_010603",
	NULL,
};
static	const char	**gppPathName[2] = {
	gpPathName0,
	gpPathName1,
};
static	const char	*pFusumaMotionName = "FusumaGroup";
//static	const char	*pFusumaMotionName = "Fusuma01";

static	int		enm0[] = {
	//ENENO_1_102_07,
	ENENO_1_102_08,
	ENENO_1_102_09,
	-1,
};
static	int		enm1[] = {
	//ENENO_1_102_10,
	ENENO_1_102_11,
	ENENO_1_102_12,
	-1,
};

K7Stage102M00::K7Stage102M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage102M00_Camera);
	K7SCR_EVSETITEM(K7EVENTTAMA(010001),true);
}

K7Stage102M00::~K7Stage102M00()
{
}

bool K7Stage102M00::CreateCallBack(void)
{
	SetZanEnable(K7EVENTTAMA(010001),false);
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
//	//LLGtFNg
//	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
//		K7SCR_RETSYS();
//	}
	return true;
}

bool K7Stage102M00::TerminateCallBack(void)
{
//	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage102M00::SetCurrentCallBack(void)
{
//	while( WK7Npc::GetNpcPauseAll()==true ){
//		K7SCR_RETSYS();
//	}
	SetCurrentCallBackDefaultProc();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS)==TRUE ){
		return false;
	}
	WK7Stage::SetMoveModeCancel(true);
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS);
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS);
	AppearHS(enm0,enm1);
	K7SCR_EVCONDCHANGE();
	return false;
}

bool K7Stage102M00::CondChangeCallBack(void)
{
	WK7JObj		*pJObj[5];
	int			i;
	
	// ̐Fŏw
	K7EVENT_SCN_VAR(K7SCN01,EVVA_010600) = 2;
	K7EVENT_SCN_VAR(K7SCN01,EVVA_010601) = 1;
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010600);
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010601);
	
	pJObj[0]=GetJObj("NiouN_W");
	pJObj[1]=GetJObj("NiouN_Y");
	pJObj[2]=GetJObj("NiouN_R");
	pJObj[3]=GetJObj("NiouN_B");
	pJObj[4]=GetJObj("NiouN_O");
	for(i=0 ; i<5 ; i++){
		if( pJObj[i]==NULL ){
			continue;
		}
		if( i==K7EVENT_SCN_VAR(K7SCN01,EVVA_010600) ){
			pJObj[i]->Disp(false,true);
		}else{
			pJObj[i]->Hide(false,true);
		}
	}
	if( K7EVENT_SCN_VAR(K7SCN01,EVVA_010600) < 0 && pJObj[4]!=NULL ){
		pJObj[4]->Disp(false,true);
	}
	pJObj[0]=GetJObj("NiouS_W");
	pJObj[1]=GetJObj("NiouS_Y");
	pJObj[2]=GetJObj("NiouS_R");
	pJObj[3]=GetJObj("NiouS_B");
	pJObj[4]=GetJObj("NiouS_O");
	for(i=0 ; i<5 ; i++){
		if( pJObj[i]==NULL ){
			continue;
		}
		if( i==K7EVENT_SCN_VAR(K7SCN01,EVVA_010601) ){
			pJObj[i]->Disp(false,true);
		}else{
			pJObj[i]->Hide(false,true);
		}
	}
	if( K7EVENT_SCN_VAR(K7SCN01,EVVA_010601) < 0 && pJObj[4]!=NULL ){
		pJObj[4]->Disp(false,true);
	}
	ChangeFusuma(0,K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS)==TRUE,-1.0f);
	ChangeFusuma(1,K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS)==TRUE,-1.0f);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS)==TRUE ){
		for(i=0 ; enm0[i] >= 0 ; i++){
//			K7SCR_NPC_POPGO     ((u32)enm0[i]);
//			K7SCR_NPC_SAKUTEKIGO((u32)enm0[i]);
		}
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS)==TRUE ){
		for(i=0 ; enm1[i] >= 0 ; i++){
//			K7SCR_NPC_POPGO     ((u32)enm1[i]);
//			K7SCR_NPC_SAKUTEKIGO((u32)enm1[i]);
		}
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET)==FALSE ){
		HideJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
	}else{
		DispJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
	}
#if 0
	WK7JObj		*pPanelJObj;
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET)==FALSE ){
		HideJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010604),true );
		if( (pPanelJObj=GetJObj(K7STAGE102M00_PANEL_MODEL_NAME0))!=NULL ){
			pPanelJObj->DetachMotion(false,true);
			pPanelJObj->ResetMotion (false,true);
		}
		if( (pPanelJObj=GetJObj(K7STAGE102M00_PANEL_MODEL_NAME1))!=NULL ){
			pPanelJObj->DetachMotion(false,true);
			pPanelJObj->ResetMotion (false,true);
		}
	}else{
		DispJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010604),false);
		if( (pPanelJObj=PlayMotion(K7STAGE102M00_PANEL_MODEL_NAME1,1,K7STAGE102M00_PANEL_MOTION_NAME,-1.0f))!=NULL ){
			pPanelJObj->SetMotionLoop(false,false,true);
		}
		if( (pPanelJObj=PlayMotion(K7STAGE102M00_PANEL_MODEL_NAME0,1,K7STAGE102M00_PANEL_MOTION_NAME,-1.0f))!=NULL ){
			pPanelJObj->SetMotionLoop(false,false,true);
		}
	}
#endif
	SetVisibleTamaJObj(K7EVENTTAMA(010001),false);
//	SetVisibleTamaJObj(K7EVENTTAMA(010001),!K7SCR_EVHASITEM(K7EVENTTAMA(010001)));
//	RenewTamaEffect(K7EVENTTAMA(010001));
	
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(010001),false);	// eێ擾Cxg폜
	
	K7SCR_EVNO_SETENABLE(K7EVENTNO(010604),false);	// `Cxg폜
	K7SCR_EVNO_SETENABLE(K7EVENTNO(010600),false);	// mCxg폜
	K7SCR_EVNO_SETENABLE(K7EVENTNO(010601),false);	// mCxg폜
	
	return true;
}

bool K7Stage102M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010003):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010003)==false ){
			if( K7SCR_EVHASITEM(K7EVITEM_KEY(010000))==FALSE ){
				FixCamWithRiddle(EVENT_NIOU_DOOR);
				return false;
			}else{
			// Jf
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010003);
				
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				K7SCR_PC_SETVISIBLE(false);
				
				FixCam(EVENT_NIOU_DOOR);
				
				HideJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
				
				gpSound->mPlaySE(SFX_SYS_AKASICITEM_SET);
				DispJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET);
				K7SCR_EVSETITEM(K7EVITEM_KEY(010000),false);
				
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
				
				FixCam(DOOR_010003);
				
				gpSound->mPlaySE(SFX_SYS_TRUE);
				
				K7SCR_STGC_MESSAGE_B(K7STAGE102M00_MES_UNLOCKED_KEY);	// bNOꂽ
				
				K7SCR_PC_RETURNVISIBLE();
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
		}
#if 0
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600)!=TRUE ||
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601)!=TRUE ){
			// hAJȂ
			
			K7SCR_DEBUGPRINT("DOOR_010003 Closed");
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// Jς
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage102M00_Camera[DOOR_010003].pos);
			WK7CAM->SetTargetPosition(K7Stage102M00_Camera[DOOR_010003].tgt);
			K7SCR_PC_SETVISIBLE(false);
			
			K7SCR_STGC_MESSAGE_B(K7STAGE102M00_MES_LOCKED_KEY);
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			K7SCR_EVCONDCHANGE();
			return false;
		}else{
			// Jf
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010003)==false ){
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010003);
				
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				// Jς
				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
				WK7CAM->SetPosition      (K7Stage102M00_Camera[DOOR_010003].pos);
				WK7CAM->SetTargetPosition(K7Stage102M00_Camera[DOOR_010003].tgt);
				K7SCR_PC_SETVISIBLE(false);
				
				gpSound->mPlaySE(SFX_SYS_TRUE);
				
				K7SCR_STGC_MESSAGE_B(K7STAGE102M00_MES_UNLOCKED_KEY);	// bNOꂽ
				
				K7SCR_PC_RETURNVISIBLE();
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
			}
		}
#endif
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage102M00::EventCallBack(WK7EventInfo &info)
{
#pragma	unused(info)
#if 0
	s32		result;
	WK7JObj	*pJObj;
	
	switch( info.mEventNo ){
	case	K7EVENTNO(010604):
		// svcȑ`
		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010000))==FALSE ){
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ)==FALSE ){
			
			FixCamWithRiddle(EVENT_010604);
			
		}else{
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);
			
			FixCam(EVENT_010604);
			
			HideJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			gpSound->mPlaySE(SFX_SYS_AKASICITEM_SET);
//			gpSound->mPlaySE(SFX_SCE1_FUKU_STRANGEITEM_HAMERU);
			DispJObj(K7STAGE102M00_MIRACLE_OBJ,false,true);
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			FixCam(EVENT_010604_1);
			gpSound->mPlaySE(SFX_SCE1_FUKU_NIOUZOU_HAKOHIRAKU);
			if( (pJObj=PlayMotion(K7STAGE102M00_PANEL_MODEL_NAME1,1,K7STAGE102M00_PANEL_MOTION_NAME))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
			}
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			FixCam(EVENT_010604_0);
			gpSound->mPlaySE(SFX_SCE1_FUKU_NIOUZOU_HAKOHIRAKU);
			if( (pJObj=PlayMotion(K7STAGE102M00_PANEL_MODEL_NAME0,1,K7STAGE102M00_PANEL_MOTION_NAME))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
			}
			
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET);
			K7SCR_EVSETITEM(K7EVITEM_KEY(010000),false);
			
			K7SCR_EVCONDCHANGE();
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		break;
	case	K7EVENTNO(010600):
		// mk
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET)==FALSE ){
			FixCamWithRiddle(EVENT_010600);
			return false;
		}
		K7SCR_PANEL_SETPANELID(ePanel010600,K7EVENT_SCN_VAR(K7SCN01,EVVA_010600));
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
		
		if( (result=K7SCR_PANEL_GETRESULT()) >= 0 ){
			K7EVENT_SCN_VAR(K7SCN01,EVVA_010600) = result;
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010600);
			switch( result ){
			case	LIGHT_COLOR_RED:
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010600);
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601)==TRUE ){
//					gpSound->mPlaySE(SFX_SCE1_COOKINGROOM_DOOR_OPEN);
//				}
				break;
			case	LIGHT_COLOR_WHITE:
			case	LIGHT_COLOR_YELLOW:
			case	LIGHT_COLOR_BLUE:
			default:
				break;
			}
			K7SCR_EVCONDCHANGE();
			gpSound->mPlaySE(SFX_SCE1_FUKU_LIGHTUP_NIOHZOH);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601)==TRUE ){
				gpSound->mPlaySE(SFX_SCE1_COOKINGROOM_DOOR_OPEN);
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			}
		}
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600   )==TRUE  &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601   )==TRUE  &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS)==FALSE ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS);
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS);
			AppearHS(enm0,enm1);
		}
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010601):
		// m쑤
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET)==FALSE ){
			FixCamWithRiddle(EVENT_010601);
			return false;
		}
		K7SCR_PANEL_SETPANELID(ePanel010600,K7EVENT_SCN_VAR(K7SCN01,EVVA_010601));
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_PANEL_EXITWAIT();
		
		if( (result=K7SCR_PANEL_GETRESULT()) >= 0 ){
			K7EVENT_SCN_VAR(K7SCN01,EVVA_010601) = result;
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010601);
			switch( result ){
			case	LIGHT_COLOR_YELLOW:
				K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010601);
//				if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600)==TRUE ){
//					gpSound->mPlaySE(SFX_SCE1_COOKINGROOM_DOOR_OPEN);
//				}
				break;
			case	LIGHT_COLOR_WHITE:
			case	LIGHT_COLOR_RED:
			case	LIGHT_COLOR_BLUE:
			default:
				break;
			}
			K7SCR_EVCONDCHANGE();
			gpSound->mPlaySE(SFX_SCE1_FUKU_LIGHTUP_NIOHZOH);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			
			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600)==TRUE ){
				gpSound->mPlaySE(SFX_SCE1_COOKINGROOM_DOOR_OPEN);
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
			}
		}
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010600   )==TRUE  &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601   )==TRUE  &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS)==FALSE ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010601_HS);
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010600_HS);
			AppearHS(enm0,enm1);
		}
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EVCONDCHANGE();
		break;
	default:
		break;
	}
#endif
	return true;
}

bool K7Stage102M00::ChangeFusuma(int index,bool flag,f32 startframe)
{
	if( index < 0 || index > 1 ){
		return false;
	}
	
	WK7JObj		*pJObj;
	const char	**ppFusumaName = gpFusumaName[index];
	const char	**ppPathName   = gppPathName [index];
	int			i;
	
	for(i=0 ; i<2 ; i++){
		if( (pJObj=PlayMotion(ppFusumaName[i],0,pFusumaMotionName,startframe))!=NULL ){
			if( flag==true ){
				pJObj->SetMotionLoop(false,false,true);
			}else{
				pJObj->DetachMotion(false,true);
				pJObj->ResetMotion (false,true);
			}
		}
	}
	while( *ppPathName!=NULL ){
		K7SCR_STG_SET_PATHENABLE(*ppPathName,flag);
		ppPathName++;
	}
	
	return true;
}

#if 0
bool K7Stage102M00::AppearHS(int index,int mesid,int camid,int *enmno)
{
#pragma	unused(mesid)
	int		i;
	
	ChangeFusuma(index,true,0.0f);
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7Npc::SetNpcPauseAll(false);
	
	if( enmno!=NULL ){
		for(i=0 ; enmno[i] >= 0 ; i++){
			K7SCR_NPC_POPGO((u32)enmno[i]);
		}
	}
//	K7SCR_NPC_POPGO((u32)enmno  );
//	K7SCR_NPC_POPGO((u32)enmno+1);
//	K7SCR_NPC_POPGO((u32)enmno+2);
	
	// Jς
	FixCam((u32)camid);
	K7SCR_PC_SETVISIBLE(false);
	
//	K7SCR_STG_MESSAGE_B2((u32)mesid);
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
	
	if( enmno!=NULL ){
		for(i=0 ; enmno[i] >= 0 ; i++){
//			K7SCR_NPC_SAKUTEKIGO((u32)enmno[i]);
		}
	}
//	K7SCR_NPC_SAKUTEKIGO((u32)enmno  );
//	K7SCR_NPC_SAKUTEKIGO((u32)enmno+1);
//	K7SCR_NPC_SAKUTEKIGO((u32)enmno+2);
	
	// L|[Y
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(true);

	return true;
}
#endif

bool K7Stage102M00::AppearHS(int *enmno0,int *enmno1)
{
	int		i;
	
	// L|[Y
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7Npc::SetNpcPauseAll(false);
	K7SCR_PC_SETVISIBLE(false);
	
	ChangeFusuma(0,true,0.0f);
	gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
	
	if( enmno0!=NULL ){
		for(i=0 ; enmno0[i] >= 0 ; i++){
			K7SCR_NPC_POPGO((u32)enmno0[i]);
		}
	}
	
	FixCam(EVENT_010600_HS);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
	
	ChangeFusuma(1,true,0.0f);
	gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
	
	if( enmno1!=NULL ){
		for(i=0 ; enmno1[i] >= 0 ; i++){
			K7SCR_NPC_POPGO((u32)enmno1[i]);
		}
	}
	
	FixCam(EVENT_010601_HS);
	
#if 0
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
//	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3));
	
	gpSound->mPlaySE(SFX_SCE1_FUKU_TAMATAMA_ZOOM);
	FixCam(EVENT_NIOU_BULLET0);
	CamMoveToLinearPath(EVENT_NIOU_BULLET1,0.5f);
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.5f));
#else
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
#endif
	
	if( enmno0!=NULL ){
		for(i=0 ; enmno0[i] >= 0 ; i++){
//			K7SCR_NPC_SAKUTEKIGO((u32)enmno0[i]);
		}
	}
	if( enmno1!=NULL ){
		for(i=0 ; enmno1[i] >= 0 ; i++){
//			K7SCR_NPC_SAKUTEKIGO((u32)enmno1[i]);
		}
	}
	
	// L|[Y
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	WK7PLAYERCONTROL->SetOperateEnable(true);

	return true;
}

