////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage104M00
//
// K7Stage104M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE104M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage104M00.h"
#include "..\..\..\Wat\WK7EffectBreakObj.h"
#include "..\..\..\Kaw\KK7Sound.h"

static	char	*p2F_ObjName[3] = {
	"Dark",
	"Bright",
	"FadeOut",
};

K7Stage104M00::K7Stage104M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	GHM_VEC_SET_XYZ(&mShishiodoshiPos,-39.042f, -1.170f, 0.037f);
	mShishiodoshiSE = false;
	mTimer = 0;
	mpSetAlpha = NULL;
	SetOneShotCamLocTbl(K7Stage104M00_Camera);
}

K7Stage104M00::~K7Stage104M00()
{
	GHM_SAFE_DELETE(mpSetAlpha);
}

bool K7Stage104M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

#define	K7STAGE104M00_FADEVOL_SHIFT		(12)
#define	K7STAGE104M00_FADEVOL_BASE		(1<<K7STAGE104M00_FADEVOL_SHIFT)
#define	K7STAGE104M00_SE_FADESPEED		(4 * K7STAGE104M00_FADEVOL_BASE * 30 / WK7_FRAME_RATE)
bool K7Stage104M00::SetCurrentCallBack(void)
{
	WK7JObj	*pJObj;
	u32		maxvol = 0;
	u8		vol,pan;
	int		seid;
	
	SetCurrentCallBackDefaultProc();
	mShishiodoshiSE = false;
	if( (pJObj=GetJObj("SSODS"))!=NULL ){
		pJObj->SetPostFrameProcessCallBack(ShisiodoshiJObjCallBackFunc,this);
	}
	seid = gpSound->mPlaySE(SFX_SCE1_FUKU_SISIODOSI_MIZU,0,SOUND_PAN_CENTER,eSETrackBattleOverlap);
	while( WK7RenderObj::IsValid(this)==true ){
		if( GetState()!=LOADED ){
			break;
		}
		if( mTimer < WK7_TICK_PER_FRAME ){
			if( (pJObj=PlayMotion("SSODS",1))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
			}
			mTimer  = WK7_SEC_TO_TICK(10.0f);
		}else{
			mTimer -= WK7_TICK_PER_FRAME;
		}
		mAlpha.FrameProcess();
		if( mpSetAlpha!=NULL ){
			mpSetAlpha->SetVal(mAlpha.GetValue(),false);
		}
		
static	u32		odosimax = 255 << K7STAGE104M00_FADEVOL_SHIFT;
		if( gpSound->mCheckSE(SFX_SCE1_FUKU_SISIODOSI)==false ){
			if( maxvol < odosimax - K7STAGE104M00_SE_FADESPEED ){
				maxvol += K7STAGE104M00_SE_FADESPEED;
			}else{
				maxvol  = odosimax;
			}
		}else{
			if( maxvol > K7STAGE104M00_SE_FADESPEED ){
				maxvol -= K7STAGE104M00_SE_FADESPEED;
			}else{
				maxvol  = 0;
			}
		}
		vol = (u8)(maxvol >> K7STAGE104M00_FADEVOL_SHIFT);
		seVolCalc2(mShishiodoshiPos,vol,(u8)(vol<40? vol:40),&vol,&pan,200.0f,8.0f);
		gpSound->mSetVolumeSENo(seid,vol,1);
		gpSound->mSetPanSENo   (seid,pan);
		
		K7SCR_RETSYS();
	}
	
	for( ; maxvol > K7STAGE104M00_SE_FADESPEED ; maxvol -= K7STAGE104M00_SE_FADESPEED){
		vol = (u8)(maxvol >> K7STAGE104M00_FADEVOL_SHIFT);
		gpSound->mSetVolumeSENo(seid,vol,1);
		K7SCR_RETSYS();
	}
	gpSound->mStopSE(seid);
	
	return true;
}

bool K7Stage104M00::CondChangeCallBack(void)
{
//	WK7JObj	*pJObj;
//	if( (pJObj=PlayMotion("SSODS",1))!=NULL ){
//		pJObj->SetMotionLoop(true,false,true);
//	}
#if 0
	if( K7SCR_EVHASITEM(K7EVITEM_KEY(010002))==true ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),false);
	}else{
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
			K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),true);
		}else{
			K7SCR_EVNO_SETENABLE(K7EVENTNO(010400),false);
		}
	}
#endif
	
	WK7JObj		*pDispObj,*pHideObj,*pFadeObj;
	pFadeObj = GetJObj(p2F_ObjName[2]);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP)==TRUE ){
		pDispObj = GetJObj(p2F_ObjName[1]);
		pHideObj = GetJObj(p2F_ObjName[0]);
		K7SCR_JOBJ_HIDE(pFadeObj);
	}else{
		pDispObj = GetJObj(p2F_ObjName[0]);
		pHideObj = GetJObj(p2F_ObjName[1]);
		K7SCR_JOBJ_DISP(pFadeObj);
	}
	K7SCR_JOBJ_DISP(pDispObj);
	K7SCR_JOBJ_HIDE(pHideObj);
	
	WK7JObj		*pObj;
	if( (pObj = GetObjEventNo(K7EVENTNO(010404)))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010404)==TRUE ){
			pObj->Hide(false,true);
		}else{
			pObj->Disp(false,true);
		}
	}
	if( (pObj = GetObjEventNo(K7EVENTNO(010405)))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010405)==TRUE ){
			pObj->Hide(false,true);
		}else{
			pObj->Disp(false,true);
		}
	}
	if( (pObj = GetObjEventNo(K7EVENTNO(010406)))!=NULL ){
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010406)==TRUE ){
			pObj->Hide(false,true);
		}else{
			pObj->Disp(false,true);
		}
	}
	return true;
}

bool K7Stage104M00::LightUpCheck(void)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==FALSE ||
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==FALSE ||
	    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==FALSE ){
		return false;
	}
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP)==TRUE ){
		// CgAbvς
		return false;
	}
	
	WK7JObj			*pDispJObj,*pHideJObj,*pFadeJObj;
	
	pHideJObj = GetJObj(p2F_ObjName[0]);
	pDispJObj = GetJObj(p2F_ObjName[1]);
	pFadeJObj = GetJObj(p2F_ObjName[2]);
	
	K7SCR_JOBJ_DISP(pDispJObj);
	K7SCR_JOBJ_HIDE(pHideJObj);
	K7SCR_JOBJ_DISP(pFadeJObj);
	mAlpha.SetValue(0.0f);
	if( (mpSetAlpha = new C_SetAlpha(pDispJObj->GetJObj(),mAlpha.GetValue(),false))!=NULL ){
		mpSetAlpha->SetVal(mAlpha.GetValue(),false);
	}
	
	FixCam(LIGHTPOS);
	
	K7SCR_PANEL_EXITWAIT();
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	K7SCR_PC_SETVISIBLE(false);
	
	FixCam(LIGHTPOS);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
	
	mAlpha.Play(1.0f,WK7_SEC_TO_TICK(2.0f));
	
	while( mAlpha.IsAnimating()==true ){
		K7SCR_RETSYS();
	}
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.5f));
	
	GHM_SAFE_DELETE(mpSetAlpha);
	
	mAlpha.SetValue(1.0f);
	if( (mpSetAlpha = new C_SetAlpha(pFadeJObj->GetJObj(),mAlpha.GetValue(),false))!=NULL ){
		mpSetAlpha->SetVal(mAlpha.GetValue(),false);
	}
	mAlpha.Play(0.0f,WK7_SEC_TO_TICK(2.0f));
	
	FixCam(LIGHTUP);
	
	gpSound->mPlaySE(SFX_SCE1_FUKU_LIGHTUP_2THFLOOR);
	
	while( mAlpha.IsAnimating()==true ){
		K7SCR_RETSYS();
	}
	
	GHM_SAFE_DELETE(mpSetAlpha);
	K7SCR_JOBJ_HIDE(pFadeJObj);
	
	K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(0.5f));
	
//	gpSound->mPlaySE(SFX_SYS_TRUE);
//	gpSound->mPlaySE(SFX_SCE1_FUKU_LIGHTUP_2THFLOOR);
	
	K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_LIGHTUP);			// QKCgAbvꂽ
	
	K7SCR_PC_RETURNVISIBLE();
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP);
	return true;
}

bool K7Stage104M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(010408):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(LIGHTPOS);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_2F_LIGHTUP)==TRUE ){
			K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_LIGHTON);			// Ɩ_Ă
		}else{
			K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_LIGHTOFF);			// ƖݒuĂ
		}
		K7SCR_PC_RETURNVISIBLE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
#if 0
	case	K7EVENTNO(010400):
		// U
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010401)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010402)==TRUE &&
		    K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_010403)==TRUE ){
			// JMɓꂽ
			K7SCR_EVSETITEM(K7EVITEM_KEY(010002),true);
			
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			// Jς
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->SetPosition      (K7Stage104M00_Camera[EVENT_010400].pos);
			WK7CAM->SetTargetPosition(K7Stage104M00_Camera[EVENT_010400].tgt);
			K7SCR_PC_SETVISIBLE(false);
			
			gpSound->mPlaySE(SFX_SYS_TRUE);
			
			K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_GET_KEY);			// uq̌vɓꂽ
			
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		K7SCR_EVCONDCHANGE();
#endif
		break;
	case	K7EVENTNO(010401):
		// FP
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010401);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010401);
			if( LightUpCheck()==false ){
				K7SCR_PANEL_EXITWAIT();
			}
		}else{
			K7SCR_PANEL_EXITWAIT();
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010401);
		}
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010402):
		// FQ
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010402);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010402);
			if( LightUpCheck()==false ){
				K7SCR_PANEL_EXITWAIT();
			}
		}else{
			K7SCR_PANEL_EXITWAIT();
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010402);
		}
		K7SCR_EVCONDCHANGE();
		break;
	case	K7EVENTNO(010403):
		// FR
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel010403);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		if( K7SCR_PANEL_GETRESULT() > 0 ){
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010403);
			if( LightUpCheck()==false ){
				K7SCR_PANEL_EXITWAIT();
			}
		}else{
			K7SCR_PANEL_EXITWAIT();
			K7SCR_RESET_SCENARIO_FLAG(K7SCN01_EVFL_010403);
		}
		K7SCR_EVCONDCHANGE();
		break;
	default:
		break;
	}
	return true;
}

//bool K7Stage104M00::DoorEventCallBack(WK7DoorEventInfo &info)
//{
//	switch( info.mEventNo ){
//	case	K7EVENTDOOR(010001):
//		if( K7SCR_EVHASITEM(K7EVITEM_KEY(010001))==false ){
//			// hAJȂ
//			K7SCR_DEBUGPRINT("DOOR_010001 Closed : need KEY_010001");
//			
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			// Jς
//			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//			WK7CAM->SetPosition      (K7Stage104M00_Camera[DOOR_010001].pos);
//			WK7CAM->SetTargetPosition(K7Stage104M00_Camera[DOOR_010001].tgt);
//			K7SCR_PC_SETVISIBLE(false);
//			
//			K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_LOCKED_KEY);
//			
//			K7SCR_PC_RETURNVISIBLE();
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			
//			K7SCR_EVCONDCHANGE();
//			return false;
//		}else{
//			// Jf
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_DRFL_010001)==false ){
//				
//				K7SCR_SET_SCENARIO_FLAG(K7SCN01_DRFL_010001);
//				
//				K7SCR_ENTER_PLAYMODE();
//				K7SCR_ENTER_DEMOPAUSE();
//				
//				// Jς
//				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//				WK7CAM->SetPosition      (K7Stage104M00_Camera[DOOR_010001].pos);
//				WK7CAM->SetTargetPosition(K7Stage104M00_Camera[DOOR_010001].tgt);
//				K7SCR_PC_SETVISIBLE(false);
//				
//				gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
//				
//				K7SCR_STGC_MESSAGE_B(K7STAGE104M00_MES_USE_CHASHITSU_KEY);
//														// ǔvg
//				
//				K7SCR_PC_RETURNVISIBLE();
//				K7SCR_EXIT_PLAYMODE();
//				K7SCR_EXIT_DEMOPAUSE();
//			}
//		}
//		break;
//	default:
//		break;
//	}
//	return true;
//}

bool K7Stage104M00::HitObjCallBack(WK7HitObjInfo &info)
{
	WK7JObj		*pObj;
	switch( info.mEventNo ){
	case	K7EVENTNO(010404): K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010404); break;
	case	K7EVENTNO(010405): K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010405); break;
	case	K7EVENTNO(010406): K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_010406); break;
	default:
		return true;
	}
	if( (pObj = GetObjEventNo(info.mEventNo))!=NULL ){
		WK7EffectBreakObj	*pEffectBreakObj;
		pObj->Hide(false,true);
static	f32		surfaceSize = 30.0f;
		WK7EffectBreakObj::SetLimitSurfaceSize(surfaceSize);
		if( (pEffectBreakObj = pObj->CreateEffectBreakObj(false,true))!=NULL ){
			pEffectBreakObj->SetVisible(true);
			pEffectBreakObj->Start();
		}
	}
	info.SetHitObjEnable(true);
//	if( info.mpHitObj!=NULL ){
//		info.mpHitObj->SetEnable(true);
//	}
	return false;
}

//static	f32	K7STAGE104M00_SHISHIODOSHI_PLAYSE_FRAME	=	(6.0f);
#define	K7STAGE104M00_SHISHIODOSHI_PLAYSE_FRAME		(6.0f)
bool K7Stage104M00::_ShisiodoshiJObjCallBackFunc(WK7JObj *pJObj)
{
	if( mShishiodoshiSE==false ){
		if( pJObj->GetCurrentMotionFrame(false,true) >= K7STAGE104M00_SHISHIODOSHI_PLAYSE_FRAME ){
			KK7SoundLoopSePlayVolumeChange(mShishiodoshiPos,K7SCR_STG_GET_CURRENTID(),SFX_SCE1_FUKU_SISIODOSI,SOUND_EVENT_SE_VOLUME);
			mShishiodoshiSE = true;
		}
	}else{
		if( gpSound->mCheckSE(SFX_SCE1_FUKU_SISIODOSI)==false ){
			if( pJObj->GetCurrentMotionFrame(false,true) < K7STAGE104M00_SHISHIODOSHI_PLAYSE_FRAME ){
				mShishiodoshiSE = false;
			}
		}
	}
	return true;
}

bool K7Stage104M00::ShisiodoshiJObjCallBackFunc(WK7JObj *pJObj,void *pData)
{
	K7Stage104M00		*pStage = (K7Stage104M00 *)pData;
	if( pStage!=NULL ){
		pStage->_ShisiodoshiJObjCallBackFunc(pJObj);
	}
	return true;
}

