////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage105M00
//
// K7Stage105M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE105M00_CPP__

#include ".\K7Stage105M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

K7Stage105M00::K7Stage105M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage105M00_Camera);
}

K7Stage105M00::~K7Stage105M00()
{
}

bool K7Stage105M00::InitializeCallBack(void)
{
	WK7JObj		*pObj = GetJObj("burn");
	if( pObj!=NULL ){
		pObj->Hide(false,true);
		CreateEffectModelFire(pObj,MFIRE_WALL);
	}
	return true;
}

bool K7Stage105M00::SetCurrentCallBack(void)
{
	KK7SoundLoopSePlayVolumeChange((Vec){418.147f, 0.624f, - 7.896f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A);
	KK7SoundLoopSePlayVolumeChange((Vec){422.303f, 1.201f, -34.674f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_B);
	KK7SoundLoopSePlayVolumeChange((Vec){487.102f, 0.310f, -35.690f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_C);
	return true;
}

bool K7Stage105M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(010410):
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage105M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
	switch( info.mAbilityID ){
	case	PC_SPA_BOOST_JUMP:{
		WK7PlayerSpInfoCyo	*pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
		pCyoInfo->mpToBpName      = "branchJ";
		pCyoInfo->mFromPos.x      =  579.319f;
		pCyoInfo->mFromPos.y      =    0.000f;
		pCyoInfo->mFromPos.z      =   71.971f;
		pCyoInfo->mFromRotY       = -  0.683f;
		pCyoInfo->mToPos  .x      =  576.270f;
		pCyoInfo->mToPos  .y      =   35.011f;
		pCyoInfo->mToPos  .z      =   64.815f;
		pCyoInfo->mToRotY         =        PI;
		pCyoInfo->mStageMessage   = true;
		pCyoInfo->mStageMessageID = K7STAGE105M00_MES_JUMP;
		FixCam(JUMP_0);
		while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){
			K7SCR_RETSYS();
		}
		FixCam(JUMP_1);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){
			K7SCR_RETSYS();
		}
		}return false;
	default:
		break;
	}
	return true;
}

