////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage106M00
//
// K7Stage106M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE106M00_CPP__

#include ".\K7Stage106M00.h"
//#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Sato\SK7SpecialData.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectModelFire.h"

K7Stage106M00::K7Stage106M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int		i;
	for(i=0 ; i<4 ; i++){
		mpSetAlpha[i] = NULL;
	}
	SetOneShotCamLocTbl(K7Stage106M00_Camera);
}

K7Stage106M00::~K7Stage106M00()
{
	int		i;
	for(i=0 ; i<4 ; i++){
		GHM_SAFE_DELETE(mpSetAlpha[i]);
	}
}

bool K7Stage106M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	return true;
}

bool K7Stage106M00::InitializeCallBack(void)
{
	WK7JObj		*pObj = GetJObj("burn");

	HereComeANewHSInit( PR_HS_SPIR, ENENO_1_106_04 );
	K7SCR_JOBJ_HIDE(pObj);
	SetModelFireMaxNumRate( 2.0F ) ;
	CreateEffectModelFire(pObj,MFIRE_WALL);
	return true;
}

bool K7Stage106M00::SetCurrentCallBack(void)
{
	KK7SoundLoopSePlayVolumeChange((Vec){ 14.757f, 0.0f, 401.303f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_AMB_FIRE);
	KK7SoundLoopSePlayVolumeChange((Vec){ 13.535f, 0.0f, 277.432f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_A  );
	KK7SoundLoopSePlayVolumeChange((Vec){ 91.488f, 0.0f, 355.689f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_B  );
	KK7SoundLoopSePlayVolumeChange((Vec){ 90.993f, 0.0f, 277.755f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE1_FUKU_FIRE_C  );
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_SPIR,
									ENENO_1_106_04,								// GID
									NULL,
									CAM106M00_HS_PRESEN_START,
									CAM106M00_HS_PRESEN_END,
									0,
									204,  320, -13, 139, 669, 157 )				// OЉp
	){
		SetManualBranch(false);
		return( true );
	}
	return true;
}

WK7JObj* K7Stage106M00::GetOpenPicObj(void)
{
	return GetJObj("FlowerPic_Opend");
}

WK7JObj* K7Stage106M00::GetClosePicObj(void)
{
	return GetJObj("FlowerPic_Closed");
}

WK7JObj* K7Stage106M00::GetOpenModelObj(void)
{
	return GetJObj("FlowerModel_Opend");
}

WK7JObj* K7Stage106M00::GetCloseModelObj(void)
{
	return GetJObj("FlowerModel_Closed");
}

WK7JObj* K7Stage106M00::GetItemObj(void)
{
	return GetJObj("Item");
//	return GetJObj("Silver_Bullet");
}

bool K7Stage106M00::CondChangeCallBack(void)
{
	// |Cxg
	WK7JObj		*pOpModelObj,*pClModelObj,*pOpPicObj,*pClPicObj,*pItemObj;
	pOpPicObj   = GetOpenPicObj();
	pClPicObj   = GetClosePicObj();
	pOpModelObj = GetOpenModelObj();
	pClModelObj = GetCloseModelObj();
	pItemObj    = GetItemObj();
	DetachMotion();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TSUBO)==TRUE ){
		K7SCR_JOBJ_DISP(pOpPicObj);
		K7SCR_JOBJ_HIDE(pClPicObj);
		K7SCR_JOBJ_DISP(pOpModelObj);
		K7SCR_JOBJ_HIDE(pClModelObj);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015200),false);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_KAKEJIKU)==TRUE ){
			AttachMotion(0,true);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(015201),false);
//			if( K7SCR_EVHASITEM(K7EVITEM_TAMA(010000))==TRUE ){
			if( K7SCR_EVHASITEM(K7EVITEM_KEY(010000))==TRUE || K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ_SET)==TRUE ){
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ)==TRUE ){
				K7SCR_JOBJ_HIDE(pItemObj);
				K7SCR_EVNO_SETENABLE(K7EVENTNO(015202),false);
			}else{
				K7SCR_JOBJ_DISP(pItemObj);
				K7SCR_EVNO_SETENABLE(K7EVENTNO(015202),true );
			}
		}else{
			AttachMotion(1,true);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(015201),true );
			K7SCR_JOBJ_DISP(pItemObj);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(015202),false);
		}
		PlayMotion(-1.0f);
	}else{
		ResetMotion();
		K7SCR_JOBJ_HIDE(pOpPicObj);
		K7SCR_JOBJ_DISP(pClPicObj);
		K7SCR_JOBJ_HIDE(pOpModelObj);
		K7SCR_JOBJ_DISP(pClModelObj);
		K7SCR_JOBJ_DISP(pItemObj);
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015200),true );
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015201),true );
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015202),false);
	}
	SetMotionLoop(false);
	return true;
}

bool K7Stage106M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(015200):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		if( K7SCR_EVEQUIPRING(RING_WATER)==false ){
			
			FixCam(EVENT_015200);
			K7SCR_STGC_MESSAGE_B(K7STAGE106M00_MES_DEAD_FLOWER2);
			
		}else{
			
			OverlapHangingScroll();
			
		}
		
		K7SCR_EVCONDCHANGE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	case	K7EVENTNO(015201):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		FixCam(EVENT_015201);
		
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_TSUBO)==FALSE ){
			
			K7SCR_STG_MESSAGE_B(K7STAGE106M00_MES_DEAD_FLOWER);
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return false;
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_KAKEJIKU);
		gpSound->mPlaySE(SFX_SCE1_FUKU_KAKEJIKU_KAITEN);
		AttachMotion(0,true);
		PlayMotion();
		SetMotionLoop(false);
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
		//IfgEt@t@[
		gpSound->mPlaySE( SFX_SYS_TRUE );
		K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		WK7CAMPATHFOLLOWINFO->SetPos(WK7CamPathFollowInfo::RENEW_IM);
		
		K7SCR_EVCONDCHANGE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	case	K7EVENTNO(015202):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		FixCam(EVENT_015202);
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2.0f));
		
		K7SCR_STG_ITEMGET(K7STAGE106M00_MES_GET_MIRACLE_OBJ);
		K7SCR_STG_ITEMGET_NOTDISPLAYED_B(K7STAGE106M00_MES_GET_MIRACLE_OBJ);
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_MIRACLE_OBJ);
		K7SCR_EVSETITEM(K7EVITEM_KEY(010000),true);
		K7SCR_EVCONDCHANGE();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		K7SCR_STG_ITEMGET_VALID_B(K7STAGE106M00_MES_GET_MIRACLE_OBJ);
		
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage106M00::OverlapHangingScroll(void)
{
	WK7JObj		*pOpModelObj = NULL,*pClModelObj = NULL;
	
	K7SCR_PC_SETVISIBLE(false);
	
	if( (pOpModelObj = GetOpenModelObj ())!=NULL &&
	    (pClModelObj = GetCloseModelObj())!=NULL ){
		
		mAlpha.SetValue(0.0f);
		mAlpha.Play    (1.0f,WK7_SEC_TO_TICK(2));
		
		mpSetAlpha[0] = new C_SetAlpha(pOpModelObj->GetJObj(),       mAlpha.GetValue(),false);
		mpSetAlpha[1] = new C_SetAlpha(pClModelObj->GetJObj(),1.0f - mAlpha.GetValue(),false);
		if( mpSetAlpha[0]!=NULL ){ mpSetAlpha[0]->SetVal(       mAlpha.GetValue(),false); }
		if( mpSetAlpha[1]!=NULL ){ mpSetAlpha[1]->SetVal(1.0f - mAlpha.GetValue(),false); }
		K7SCR_JOBJ_DISP(pOpModelObj);
		K7SCR_JOBJ_DISP(pClModelObj);
		
		FixCam(EVENT_015200);
		K7SCR_STG_MESSAGE_B(K7STAGE106M00_MES_USE_WATER_RING);
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		AttachMotion(1,true);
		PlayMotion();
		SetMotionLoop(false);
		
static int	waittick = 7200;
		K7SCR_TIMEWAIT(waittick);
		gpSound->mPlaySE(SFX_SCE1_FUKU_WATER_FULL);
		
		while( GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		if( mpSetAlpha[0]!=NULL && mpSetAlpha[1]!=NULL ){
				
			while( mAlpha.IsAnimating()==true ){
				
				K7SCR_RETSYS();
				
				mAlpha.FrameProcess();
				
				mpSetAlpha[0]->SetVal(       mAlpha.GetValue(),false);
				mpSetAlpha[1]->SetVal(1.0f - mAlpha.GetValue(),false);
			}
			
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
	}
	
	WK7JObj		*pOpPicObj = NULL,*pClPicObj = NULL;
	
	if( (pOpPicObj = GetOpenPicObj ())!=NULL &&
	    (pClPicObj = GetClosePicObj())!=NULL ){
		
		mAlpha.SetValue(0.0f);
		mAlpha.Play    (1.0f,WK7_SEC_TO_TICK(2));
		
		mpSetAlpha[2] = new C_SetAlpha(pOpPicObj->GetJObj(),       mAlpha.GetValue(),false);
		mpSetAlpha[3] = new C_SetAlpha(pClPicObj->GetJObj(),1.0f - mAlpha.GetValue(),false);
		if( mpSetAlpha[2]!=NULL ){ mpSetAlpha[2]->SetVal(       mAlpha.GetValue(),false); }
		if( mpSetAlpha[3]!=NULL ){ mpSetAlpha[3]->SetVal(1.0f - mAlpha.GetValue(),false); }
		
		K7SCR_JOBJ_DISP(pOpPicObj);
		K7SCR_JOBJ_DISP(pClPicObj);
		
		FixCam(EVENT_015200_2);
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		if( mpSetAlpha[2]!=NULL && mpSetAlpha[3]!=NULL ){
				
			while( mAlpha.IsAnimating()==true ){
				
				K7SCR_RETSYS();
				
				mAlpha.FrameProcess();
				
				mpSetAlpha[2]->SetVal(       mAlpha.GetValue(),false);
				mpSetAlpha[3]->SetVal(1.0f - mAlpha.GetValue(),false);
			}
			
		}
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
	}
	
	K7SCR_JOBJ_DISP(pOpModelObj);
	K7SCR_JOBJ_HIDE(pClModelObj);
	K7SCR_JOBJ_DISP(pOpPicObj);
	K7SCR_JOBJ_HIDE(pClPicObj);
	
	// قɐꂽ
	K7SCR_SET_SCENARIO_FLAG(K7SCN01_TSUBO);
	
	K7SCR_STGC_MESSAGE_B(K7STAGE106M00_MES_BLOOM_FLOWER);		// |̉Ԃ炢
	
	K7SCR_PC_RETURNVISIBLE();
	
	GHM_SAFE_DELETE(mpSetAlpha[0]);
	GHM_SAFE_DELETE(mpSetAlpha[1]);
	GHM_SAFE_DELETE(mpSetAlpha[2]);
	GHM_SAFE_DELETE(mpSetAlpha[3]);
	
	return true;
}

bool K7Stage106M00::HitObjCallBack(WK7HitObjInfo &info)
{
#pragma	unused(info)
#if 0
	switch( info.mEventNo ){
	case	K7EVENTNO(010801):
		break;
	default:
		break;
	}
#endif
	return true;
}

