////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage108M00
//
// K7Stage108M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE108M00_H__
#define	__K7STAGE108M00_H__

#include "..\K7Stage.h"

#if 0
class K7Stage108M00FusumaFire{
public:
	enum{
		IDLE,
		START,
		BURNWAIT,
		BURNING,
		BURNEDWAIT,
		VANISH,
		END,
	};
protected:
	WK7Stage					*mpStage;
	WK7JObj						*mpFusuma;
	C_SetAlpha					*mpSetAlpha;
	int							mState;
	WK7RenderObjEffect			*mpEffect;
	f32							mRot;
	f32							mRotSpd;
	int							mCounter;
	WK7AnimLinearF				mAlpha;
public:
	K7Stage108M00FusumaFire();
	~K7Stage108M00FusumaFire();
	
	bool Initialize(WK7Stage *pStage,WK7JObj *pFusuma);
	bool Setup(bool onoff);
	bool Start(void);
	inline bool IsEnd(void){ return mState==END? true : false; }
	bool FrameProcess(void);
	inline int GetState(void){ return mState; }
};

class K7Stage108M00LampFire{
public:
	enum{
		IDLE,
		START,
		BURNING,
		VANISH,
		END,
	};
protected:
	WK7Stage					*mpStage;
	WK7JObj						*mpFire;
	int							mState;
	WK7RenderObjEffect			*mpEffect;
	int							mCounter;
public:
	K7Stage108M00LampFire();
	~K7Stage108M00LampFire();
	
	bool Initialize(WK7Stage *pStage,WK7JObj *pFire);
	bool Setup(bool onoff);
	bool Start(void);
	inline bool IsEnd(void){ return mState==END? true : false; }
	bool FrameProcess(void);
	inline int GetState(void){ return mState; }
};

class K7Stage108M00Fusuma{
public:
	enum{
		IDLE,
		START,
		LAMPBURN,
		BURNING,
		END,
	};
protected:
	WK7Stage					*mpStage;
	WK7PathNurbs				*mpPath;
	WK7JObj						*mpFusuma;
	WK7JObj						*mpLamp;
	WK7JObj						*mpFire;
	WK7RenderObjEffect			*mpEffect;
	int							mState;
	int							mFlag;
	K7Stage108M00LampFire		mLampFire;
	K7Stage108M00FusumaFire		mFusumaFire[2];
	int							mCounter;
	u32							mMessageID;
	bool LampAlphaSetup(void);
	bool SetPathEnable(bool flag);
public:
	K7Stage108M00Fusuma();
	~K7Stage108M00Fusuma();
	
	bool Initialize(WK7Stage *pStage,WK7PathNurbs *pPath,WK7JObj *pFusuma,WK7JObj *pLamp,WK7JObj *pFire,int flag,u32 mesid);
	bool Setup(int onoff=-1);
	bool Start(void);
	inline bool IsEnd(void){ return mState==END? true : false; }
	inline int GetState(void){ return mState; }
	
	bool FrameProcess(void);
};
#endif

class K7Stage108M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	WK7RenderObjEffect			*mpWindEffect;
//	K7Stage108M00Fusuma			*mpFusuma[4];
	
//	WK7JObj* GetLamp(int i);
//	WK7JObj* GetFire(int i);
//	WK7JObj* GetFusuma(int i);
//	WK7PathNurbs* GetRoute(int i);
//	bool HitLampEffect(int index);
	
	K7Stage108M00();
	K7Stage108M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage108M00();
	
//	virtual bool FrameProcess(void);
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool CondChangeCallBack(void);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &);
	virtual bool BpArriveCallBack  (WK7BpInfo        &);
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
	virtual bool CharaChangeCallBack(WK7CharaChangeInfo &);
};

#ifdef	__K7STAGE108M00_CPP__

enum K7STAGE108M00_ONESHOTCAM{
	DOOR_010008,
	EVENT_010312,
	BROKEN_FUSUMA,
};

K7StageEventOneShotCamera	K7Stage108M00_Camera[] = {
	{{-309.638f, 9.772f, -720.227f},{-292.949f, 10.800f, -692.719f}},		// ՘T̊Ԃ̃bNOꂽƂ̉o
	{{-127.103f, 12.000f, -760.204f},{-97.389f, 11.113f, -753.315f}},		// wuX}Co
	{{-76.217f, 5.617f, -612.981f},{-85.402f, 1.748f, -613.795f}},
};

//enum{
//	K7STAGE108M00_MES_LOCKED_DOOR = 0			,		// ̓bNĂ
//	K7STAGE108M00_MES_UNLOCKED_DOOR				,		// ՘T̊Ԃ̃bNOꂽ
//	K7STAGE108M00_MES_GET_HATOMEMO				,		// uȁvɓꂽ
//	K7STAGE108M00_MES_RING_TONE_010300			,		// FEVENT_010300
//	K7STAGE108M00_MES_RING_TONE_010301			,		// FEVENT_010301
//	K7STAGE108M00_MES_RING_TONE_010302			,		// FEVENT_010302
//	K7STAGE108M00_MES_RING_TONE_010303			,		// FEVENT_010303
//	K7STAGE108M00_MES_RING_TONE_010304			,		// FEVENT_010304
//	K7STAGE108M00_MES_RING_TONE_010305			,		// FEVENT_010305
//	K7STAGE108M00_MES_BURN_FUSUMA_010306		,		// ӂ܂REVENT_010306
//	K7STAGE108M00_MES_BURN_FUSUMA_010307		,		// ӂ܂REVENT_010307
//	K7STAGE108M00_MES_BURN_FUSUMA_010308		,		// ӂ܂REVENT_010308
//	K7STAGE108M00_MES_BURN_FUSUMA_010309		,		// ӂ܂REVENT_010309
//	K7STAGE108M00_MES_BURN_FUSUMA_010310		,		// ӂ܂REVENT_010310
//	K7STAGE108M00_MES_BURN_FUSUMA_010311		,		// ӂ܂REVENT_010311
//	K7STAGE108M00_MES_CAME_HS					,		// wuX}CяoĂ
//};

#endif

#endif	//__K7STAGE108M00_H__

