////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage114M00
//
// K7Stage114M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE114M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage114M00.h"
//#include "..\..\..\Wat\WK7Event.h"

#define	K7SCN01_STG114_SW		(0)
#define	K7SCN01_STG114_SN		(1)
#define	K7SCN01_STG114_SE		(2)
#define	K7SCN01_STG114_WN		(3)
#define	K7SCN01_STG114_WE		(4)
#define	K7SCN01_STG114_WS		(5)
#define	K7SCN01_STG114_NE		(6)
#define	K7SCN01_STG114_NS		(7)
#define	K7SCN01_STG114_NW		(8)
#define	K7SCN01_STG114_ES		(9)
#define	K7SCN01_STG114_EW		(10)
#define	K7SCN01_STG114_EN		(11)
#define	K7SCN01_STG114_MAX		(12)
#define	K7SCN01_BP00			(0x011100)
#define	K7SCN01_BP01			(0x011101)
#define	K7SCN01_BP02			(0x011102)
#define	K7SCN01_BP03			(0x011103)
#define	K7SCN01_BP04			(0x011104)
#define	K7SCN01_BP05			(0x011105)
#define	K7SCN01_BP06			(0x011106)
#define	K7SCN01_BP07			(0x011107)
#define	K7SCN01_BP08			(0x011108)
const char	*gpStg114MotionName = "Fusumagroup";
const char	*gpStg114ModelName[] = {
	"Fusumagroup0",
	"Fusumagroup1",
	"Fusumagroup2",
	"Fusumagroup3",
	"Fusumagroup4",
	"Fusumagroup5",
};
const char	*gpStg114IrregularNextPathTable[][2] = {
	{ "event_011100_1", "event_011102_0" },
	{ "event_011101_1", "event_011103_0" },
	{ "event_011102_1", "event_011100_0" },
	{ "event_011103_1", "event_011101_0" },
	{ NULL , NULL },
};
static const char	*pPictureName[][2] = {
	{ "Picture_Wolf" , "Picture_WolfFront" , },
	{ "Picture_Tiger", "Picture_TigerFront", },
};
K7Stage114M00::K7Stage114M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mAnswerCount  = 0;
	mRightEventNo = 0;
	mPicture      = 0;
	mFront        = 0;
	mpGate[0]     = 
	mpGate[1]     = NULL;
	SetOneShotCamLocTbl(K7Stage114M00_Camera);
}

K7Stage114M00::~K7Stage114M00()
{
}

bool K7Stage114M00::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	CreateOwnStageMotion(   1);
	CreateOwnStageMotion(   2);
	return true;
}

bool K7Stage114M00::InitializeCallBack(void)
{
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d0_event_011106_1",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d0_event_011107_0",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d1_event_011107_1",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d1_event_011104_0",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d2_event_011104_1",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d2_event_011105_0",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d3_event_011105_1",false);
	WK7Stage::K7SCR_STG_SET_PATHENABLE("d3_event_011106_0",false);
	mpGate[0] = GetJObj("FrontGate");
	mpGate[1] = GetJObj("BackGate");
	return true;
}

bool K7Stage114M00::CondChangeCallBack(void)
{
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011100),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011101),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011102),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011103),false);
//	PlayMotion("Fusumagroup12",0,gpStg114MotionName,-1.0f);
//	PlayMotion("Fusumagroup8" ,0,gpStg114MotionName,-1.0f);
//	PlayMotion("Fusumagroup7" ,0,gpStg114MotionName,-1.0f);
	
	WK7JObj		*pJObj;
	if( (pJObj = PlayMotion("d0_Fusumagroup6" ,0,gpStg114MotionName,-1.0f))!=NULL ){
		pJObj->SetMotionLoop(false,false,true);
	}
	if( (pJObj = PlayMotion("d2_Fusumagroup9" ,0,gpStg114MotionName,-1.0f))!=NULL ){
		pJObj->SetMotionLoop(false,false,true);
	}
	return true;
}

bool K7Stage114M00::SetCurrentCallBack(void)
{
	
	InitMember();
	Initialize();
	
	WK7PathNurbs	*pPath = GetPathNurbs("event_011108_2_door_011102_1");
	
	WK7Stage::SetCurrentPath("event_011108","event_011108_0_door_011100_1",0.0f,K7SCR_CAM_PATHDIR_REV);
	if( pPath!=NULL ){
		WK7CAM->SetCurrentPath(pPath,0.0f,0);
	}
//	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("event_011108","event_011108_0",0.0f,K7SCR_CAM_PATHDIR_REV);
	
#if 0
	while( 1 ){
		
		K7SCR_RETSYS();
		
		if( (pStage = WK7Stage::GetCurrentStage())==NULL ){
			break;
		}
		
		int		motid;
		if( HSD_PadGetButton(1) & HSD_PAD_A ){
			motid = 1;
		}else{
			motid = 0;
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
			if( (pJObj=pStage->PlayMotion("Fusumagroup1",motid,"Fusumagroup1"))!=NULL ){
				pJObj->SetMotionLoop(false);
			}
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_LEFT ){
			if( (pJObj=pStage->PlayMotion("Fusumagroup2",motid,"Fusumagroup1"))!=NULL ){
				pJObj->SetMotionLoop(false);
			}
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_UP ){
			if( (pJObj=pStage->PlayMotion("Fusumagroup3",motid,"Fusumagroup1"))!=NULL ){
				pJObj->SetMotionLoop(false);
			}
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_DOWN ){
			if( (pJObj=pStage->PlayMotion("Fusumagroup4",motid,"Fusumagroup1"))!=NULL ){
				pJObj->SetMotionLoop(false);
			}
		}
#endif
	return true;
}

bool K7Stage114M00::EventCallBack(WK7EventInfo &info)
{
	u32		mesid;
	switch( info.mEventNo ){
	case	K7EVENTNO(010200):
		if( mPicture ){
			if( mFront ){
				mesid = K7STAGE114M00_MES_TIGER_LOOK_FRONT;
			}else{
				if( mRightEventNo==K7EVENTDOOR(010012) ){
					mesid = K7STAGE114M00_MES_TIGER_LOOK_RIGHT;
				}else{
					mesid = K7STAGE114M00_MES_TIGER_LOOK_LEFT;
				}
			}
		}else{
			if( mFront ){
				mesid = K7STAGE114M00_MES_WOLF_LOOK_FRONT;
			}else{
				if( mRightEventNo==K7EVENTDOOR(010012) ){
					mesid = K7STAGE114M00_MES_WOLF_LOOK_RIGHT;
				}else{
					mesid = K7STAGE114M00_MES_WOLF_LOOK_LEFT;
				}
			}
		}
		FixCamMes(EVENT_010002,mesid);
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage114M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	u32		mesid;
	
	switch( info.mEventNo ){
	case	K7EVENTDOOR(010012):
	case	K7EVENTDOOR(010013):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		// Jς
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		K7SCR_PC_SETVISIBLE(false);							// l
		switch( info.mEventNo ){
		case	K7EVENTDOOR(010012):
			WK7CAM->SetPosition      (K7Stage114M00_Camera[DOOR_010012].pos);
			WK7CAM->SetTargetPosition(K7Stage114M00_Camera[DOOR_010012].tgt);
			break;
		case	K7EVENTDOOR(010013):
			WK7CAM->SetPosition      (K7Stage114M00_Camera[DOOR_010013].pos);
			WK7CAM->SetTargetPosition(K7Stage114M00_Camera[DOOR_010013].tgt);
			break;
		}
		
		if( mRightEventNo==info.mEventNo ){
			
			if( mPicture==0 ){
				mesid =K7STAGE114M00_MES_PASS_BACK_GATE; 
			}else{
				mesid =K7STAGE114M00_MES_PASS_FRONT_GATE;
			}
			
			// I
			mAnswerCount++;
			
			if( mAnswerCount >= 3 ){
				
				gpSound->mPlaySE(SFX_SYS_TRUE);
				
				K7SCR_STGC_MESSAGE_B(mesid);
			
				// Stage116_M00event_011108,event_011108_0̕Ɉړ
				u32		stgid = K7STGID(116, 0);
				
				gpNoise->mSandRequest(eSandLongNoise);
				
				while( gpNoise->mGetSandFrameProc()!=eSandExec ){
					K7SCR_RETSYS();
				}
				
				K7SCR_PC_RETURNVISIBLE();							// l߂Ao
				
				K7SCR_STG_RELEASE    (mID);
				K7SCR_STG_CREATE_B   (stgid);
				K7SCR_STG_SET_CURRENT(stgid);
				K7SCR_STG_VISIBLE    (stgid,true);
				
				WK7Stage::SandRelease(stgid);
				while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
					K7SCR_RETSYS();
				}
				
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				return false;
				
			}
			
			K7SCR_STGC_MESSAGE_B(mesid);
			
		}else{
			// ͂`
			
			if( mPicture==0 ){
				mesid =K7STAGE114M00_MES_PASS_FRONT_GATE;
			}else{
				mesid =K7STAGE114M00_MES_PASS_BACK_GATE; 
			}
			
			K7SCR_STGC_MESSAGE_B(mesid);
			
			switch( mAnswerCount ){
			case	2:
				mAnswerCount = 0;
				break;
			case	0:
			case	1:
			default:
				break;
			}
		}
		gpNoise->mSandRequest(eSandLongNoise);
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		InitMember();
		Initialize();
		K7SCR_PC_RETURNVISIBLE();							// l߂Ao
		while( gpNoise->mSandRelease()==false ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			K7SCR_RETSYS();
		}
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		return false;
	default:
		break;
	}
	return true;
}

#if 0
static	const char	*gpA1A2[][2] = {
	{ "event_011108_0_door_011100_1" , "e1_event_011108_0" },
	{ "event_011108_2_door_011102_1" , "e1_event_011108_2" },
	{ "event_011102_1"               , "e1_event_011102_1" },
	{ NULL                           , "e1_event_011100_1" },
};

const char* K7Stage114M00::GetLinkPathName(const char *pPathName,const char **gppPathLinkInfo[2])
{
	for( ; gppPathLinkInfo[0]!=NULL ; gppPathLinkInfo++){
		
	}
	return gppPathLinkInfo[0][1];
}

bool K7Stage114M00::ChangePath(const char **gppPathLinkInfo)
{
	
	WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	WK7Path			*pPath0 = GetPath();
	Vec				campos[2],camtgt[2];
	
	if( pPathInfo==NULL || pPath0==NULL ){
		return false;
	}
	
	f32				param   = pPathInfo->GetParam();
	u32				pathdir = pPathInfo->GetDir();
	WK7PathNurbs	*pPath  = pPathInfo->GetPath();
	char			pathname[32];
	
	if( pPath==NULL ){
		return false;
	}
	
	if( strcmp(pPath->GetName(),"event_011108_0_door_011100_1")==0 ){
		strcpy(pathname,"e1_event_011108_0");
	}else{
		strcpy(pathname,"e1_event_011108_2");
	}
	
	pPath->GetPoint(camtgt[0],param);
	
	pPath = pPath0->GetPath(pathname);
	
	WK7PathControl	*pCamPathControl = WK7CAM->GetPathControl();
	WK7PathInfo		*pCamPathInfo;
	
	if( pCamPathControl!=NULL && (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())!=NULL && pPath!=NULL ){
		
		WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
		
		WK7Stage::SetCurrentPath(pPath,param,pathdir);
		
		// Vv[[̈ʒu
		pPath->GetPoint(camtgt[1],param);
		
		camtgt[1].x -= camtgt[0].x;
		camtgt[1].y -= camtgt[0].y;
		camtgt[1].z -= camtgt[0].z;
		
		pPath   = pCamPathInfo->GetPath();
		param   = pCamPathInfo->GetParam();
		pathdir = pCamPathInfo->GetDir();
		
		// Jʒu
		pPath->GetPoint(campos[0],param);
		
//		GetNextPath(evno & 3,pPath->GetName(),pathname);
//		if( strcmp(pPath->GetName(),"event_011108_2")==0 ){
//			strcpy(pathname,"event_011109_1");
//		}else{
//			strcpy(pathname,"event_011109_2");
//		}
		
		if( strcmp(pPath->GetName(),"event_011108_0_door_011100_1")==0 ){
			strcpy(pathname,"e1_event_011108_0");
		}else if( strcmp(pPath->GetName(),"event_011108_2_door_011102_1")==0 ){
			strcpy(pathname,"e1_event_011108_2");
		}else if( strcmp(pPath->GetName(),"event_011102_1")==0 ){
			strcpy(pathname,"e1_event_011102_1");
		}else{
			strcpy(pathname,"e1_event_011100_1");
		}
	
		pPath  = pPath0->GetPath(pathname);
	
		if( pPath!=NULL && pPathFollowInfo!=NULL ){
			
			// VJʒu
			pPath->GetPoint(campos[1],param);
			
			campos[1].x -= campos[0].x;
			campos[1].y -= campos[0].y;
			campos[1].z -= campos[0].z;
			
			pPathFollowInfo->SetCurrentPath(pPath,param,pathdir);
			pPathFollowInfo->SetCamPosReset(false);
			
			pPathFollowInfo->GetPosition      (campos[0]);
			pPathFollowInfo->GetTargetPosition(camtgt[0]);
			
			campos[0].x += campos[1].x;
			campos[0].y += campos[1].y;
			campos[0].z += campos[1].z;
			camtgt[0].x += camtgt[1].x;
			camtgt[0].y += camtgt[1].y;
			camtgt[0].z += camtgt[1].z;
			
			pPathFollowInfo->SetPosition      (campos[0]);
			pPathFollowInfo->SetTargetPosition(camtgt[0]);
			
		}
	}
	
	
}
#endif

bool K7Stage114M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
	int	pathno = GetBpPathNo(info);
	if( pathno < 0 ){
		return true;
	}
	switch( evno ){
	case	K7EVENTDOOR(011100):
	case	K7EVENTDOOR(011101):
	case	K7EVENTDOOR(011102):
	case	K7EVENTDOOR(011103):
		CloseFusuma(evno,(u32)pathno);
		break;
	case	K7EVENTNO(011100):
		if( pathno==0 ){
			Initialize(0);
		  	K7SCR_DEBUGPRINT("EVENT_011100");
			return false;
		}
		break;
	case	K7EVENTNO(011101):
		if( pathno==0 ){
			Initialize(1);
		   	K7SCR_DEBUGPRINT("EVENT_011101");
			return false;
		}
		break;
	case	K7EVENTNO(011102):
		if( pathno==0 ){
			Initialize(2);
		   	K7SCR_DEBUGPRINT("EVENT_011102");
			return false;
		}
		break;
	case	K7EVENTNO(011103):
		if( pathno==0 ){
			Initialize(3);
		   	K7SCR_DEBUGPRINT("EVENT_011103");
			return false;
		}
		break;
	case	K7EVENTNO(011104):
		switch( pathno ){
		case	0:
			ChangeFusuma(K7SCN01_BP04,0);
//			OpenFusuma(K7SCN01_BP04,0);
		   	K7SCR_DEBUGPRINT("EVENT_011104_0");
		   	return false;
		case	1:
			ChangeFusuma(K7SCN01_BP04,1);
//			OpenFusuma(K7SCN01_BP04,1);
		   	K7SCR_DEBUGPRINT("EVENT_011104_1");
			return false;
		}
		break;
	case	K7EVENTNO(011105):
		switch( pathno ){
		case	0:
			ChangeFusuma(K7SCN01_BP05,0);
//			OpenFusuma(K7SCN01_BP05,0);
		   	K7SCR_DEBUGPRINT("EVENT_011105_0");
		   	return false;
		case	1:
			ChangeFusuma(K7SCN01_BP05,1);
//			OpenFusuma(K7SCN01_BP05,1);
		   	K7SCR_DEBUGPRINT("EVENT_011105_1");
			return false;
		}
		break;
	case	K7EVENTNO(011106):
		switch( pathno ){
		case	0:
			ChangeFusuma(K7SCN01_BP06,0);
//			OpenFusuma(K7SCN01_BP06,0);
		   	K7SCR_DEBUGPRINT("EVENT_011106_0");
		   	return false;
		case	1:
			ChangeFusuma(K7SCN01_BP06,1);
//			OpenFusuma(K7SCN01_BP06,1);
		   	K7SCR_DEBUGPRINT("EVENT_011106_1");
			return false;
		}
		break;
	case	K7EVENTNO(011107):
		switch( pathno ){
		case	0:
			ChangeFusuma(K7SCN01_BP07,0);
//			OpenFusuma(K7SCN01_BP07,0);
		   	K7SCR_DEBUGPRINT("EVENT_011107_0");
		   	return false;
		case	1:
			ChangeFusuma(K7SCN01_BP07,1);
//			OpenFusuma(K7SCN01_BP07,1);
		   	K7SCR_DEBUGPRINT("EVENT_011107_1");
			return false;
		}
		break;
	case	K7EVENTNO(011108):
		switch( pathno ){
		case	0:
			if( mFinish==true ){
				
				WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
				WK7Path			*pPath0 = GetPath();
				Vec				campos[2],camtgt[2];
				
				if( pPathInfo==NULL || pPath0==NULL ){
					break;
				}
				f32				param   = pPathInfo->GetParam();
				u32				pathdir = pPathInfo->GetDir();
				WK7PathNurbs	*pPath  = pPathInfo->GetPath();
				char			pathname[32];
				
				if( pPath==NULL ){
					break;
				}
				
				if( strcmp(pPath->GetName(),"event_011108_0_door_011100_1")==0 ){
					strcpy(pathname,"e1_event_011108_0");
				}else{
					strcpy(pathname,"e1_event_011108_2");
				}
				
				pPath->GetPoint(camtgt[0],param);
				
				pPath = pPath0->GetPath(pathname);
//				pathdir ^= 1;
				
				WK7PathControl	*pCamPathControl = WK7CAM->GetPathControl();
				WK7PathInfo		*pCamPathInfo;
				
				if( pCamPathControl!=NULL && (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())!=NULL && pPath!=NULL ){
					
					WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
					
					WK7Stage::SetCurrentPath(pPath,param,pathdir);
					
					// Vv[[̈ʒu
					pPath->GetPoint(camtgt[1],param);
					
					camtgt[1].x -= camtgt[0].x;
					camtgt[1].y -= camtgt[0].y;
					camtgt[1].z -= camtgt[0].z;
					
					pPath   = pCamPathInfo->GetPath();
					param   = pCamPathInfo->GetParam();
					pathdir = pCamPathInfo->GetDir();
					
					// Jʒu
					pPath->GetPoint(campos[0],param);
					
//					GetNextPath(evno & 3,pPath->GetName(),pathname);
//					if( strcmp(pPath->GetName(),"event_011108_2")==0 ){
//						strcpy(pathname,"event_011109_1");
//					}else{
//						strcpy(pathname,"event_011109_2");
//					}
					
					if( strcmp(pPath->GetName(),"event_011108_0__door_011100_1")==0 ){
						strcpy(pathname,"e1_event_011108_0");
					}else if( strcmp(pPath->GetName(),"event_011108_2_door_011102_1")==0 ){
						strcpy(pathname,"e1_event_011108_2");
					}else if( strcmp(pPath->GetName(),"event_011102_1")==0 ){
						strcpy(pathname,"e1_event_011102_1");
					}else{
						strcpy(pathname,"e1_event_011100_1");
					}
				
					pPath  = pPath0->GetPath(pathname);
				
					if( pPath!=NULL && pPathFollowInfo!=NULL ){
						
						// VJʒu
						pPath->GetPoint(campos[1],param);
						
						campos[1].x -= campos[0].x;
						campos[1].y -= campos[0].y;
						campos[1].z -= campos[0].z;
						
						pPathFollowInfo->SetCurrentPath(pPath,param,pathdir);
						pPathFollowInfo->SetCamPosReset(false);
						
						pPathFollowInfo->GetPosition      (campos[0]);
						pPathFollowInfo->GetTargetPosition(camtgt[0]);
						
						campos[0].x += campos[1].x;
						campos[0].y += campos[1].y;
						campos[0].z += campos[1].z;
						camtgt[0].x += camtgt[1].x;
						camtgt[0].y += camtgt[1].y;
						camtgt[0].z += camtgt[1].z;
						
						pPathFollowInfo->SetPosition      (campos[0]);
						pPathFollowInfo->SetTargetPosition(camtgt[0]);
						
					}
				}
				
#if 0
				WK7JObj	*pJObj;
				if( (pJObj = PlayMotion(gpStg114ModelName[0],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				if( (pJObj = PlayMotion(gpStg114ModelName[1],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				if( (pJObj = PlayMotion(gpStg114ModelName[2],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				if( (pJObj = PlayMotion(gpStg114ModelName[3],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				if( (pJObj = PlayMotion(gpStg114ModelName[4],0,gpStg114MotionName, 0.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				if( (pJObj = PlayMotion(gpStg114ModelName[5],1,gpStg114MotionName, 0.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
				gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
				
				WK7Stage::SetPathEnableOnly("event_011109_1",false);
				WK7Stage::SetPathEnableOnly("event_011109_2",false);
#endif
				
				return false;
			}
			ChangeFusuma(K7SCN01_BP08,0);
//			OpenFusuma(K7SCN01_BP08,0);
		   	K7SCR_DEBUGPRINT("EVENT_011108_0");
		   	return false;
		case	1:
			ChangeFusuma(K7SCN01_BP08,1);
//			OpenFusuma(K7SCN01_BP08,1);
		   	K7SCR_DEBUGPRINT("EVENT_011108_1");
			return false;
		case	2:
			ChangeFusuma(K7SCN01_BP08,2);
//			OpenFusuma(K7SCN01_BP08,2);
		   	K7SCR_DEBUGPRINT("EVENT_011108_2");
			return false;
		case	3:
			ChangeFusuma(K7SCN01_BP08,3);
//			OpenFusuma(K7SCN01_BP08,3);
		   	K7SCR_DEBUGPRINT("EVENT_011108_3");
			return false;
		}
		break;
	case	K7EVENTNO(011109):
//		if( mFinish==true ){
//			
//			WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
//			WK7Path			*pPath0 = GetPath();
//			Vec				campos[2],camtgt[2];
//			
//			if( pPathInfo==NULL || pPath0==NULL ){
//				break;
//			}
//			f32				param   = pPathInfo->GetParam();
//			u32				pathdir = pPathInfo->GetDir();
//			WK7PathNurbs	*pPath  = pPathInfo->GetPath();
//			char			pathname[32];
//			
//			strcpy(pathname,"event_011108_2");
//			
//			pPath->GetPoint(camtgt[0],param);
//			
//			pPath = pPath0->GetPath(pathname);
//			pathdir ^= 1;
//			
//			WK7PathControl	*pCamPathControl = WK7CAM->GetPathControl();
//			WK7PathInfo		*pCamPathInfo;
//			
//			if( pCamPathControl!=NULL && (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())!=NULL && pPath!=NULL ){
//				
//				WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
//				
//				WK7Stage::SetCurrentPath(pPath,param,pathdir);
//				
//				// Vv[[̈ʒu
//				pPath->GetPoint(camtgt[1],param);
//				
//				camtgt[1].x -= camtgt[0].x;
//				camtgt[1].y -= camtgt[0].y;
//				camtgt[1].z -= camtgt[0].z;
//				
//				pPath   = pCamPathInfo->GetPath();
//				param   = pCamPathInfo->GetParam();
//				pathdir = pCamPathInfo->GetDir();
//				
//				// Jʒu
//				pPath->GetPoint(campos[0],param);
//				
////				GetNextPath(evno & 3,pPath->GetName(),pathname);
//				if( strcmp(pPath->GetName(),"event_011109_0")==0 ){
//					strcpy(pathname,"event_011108_0");
//				}else if( strcmp(pPath->GetName(),"event_011109_1")==0 ){
//					strcpy(pathname,"event_011108_2");
//				}else if( strcmp(pPath->GetName(),"event_011109_2")==0 ){
//					strcpy(pathname,"event_011102_1");
//				}else{
//					strcpy(pathname,"event_011100_1");
//				}
//			
//				pPath  = pPath0->GetPath(pathname);
//			
//				if( pPath!=NULL && pPathFollowInfo!=NULL ){
//					
//					// VJʒu
//					pPath->GetPoint(campos[1],param);
//					
//					campos[1].x -= campos[0].x;
//					campos[1].y -= campos[0].y;
//					campos[1].z -= campos[0].z;
//					
//					pPathFollowInfo->SetCurrentPath(pPath,param,pathdir);
//					pPathFollowInfo->SetCamPosReset(false);
//					
//					pPathFollowInfo->GetPosition      (campos[0]);
//					pPathFollowInfo->GetTargetPosition(camtgt[0]);
//					
//					campos[0].x += campos[1].x;
//					campos[0].y += campos[1].y;
//					campos[0].z += campos[1].z;
//					camtgt[0].x += camtgt[1].x;
//					camtgt[0].y += camtgt[1].y;
//					camtgt[0].z += camtgt[1].z;
//					
//					pPathFollowInfo->SetPosition      (campos[0]);
//					pPathFollowInfo->SetTargetPosition(camtgt[0]);
//					
//				}
//			}
//			
//			WK7JObj	*pJObj;
//			if( (pJObj = PlayMotion(gpStg114ModelName[0],1,gpStg114MotionName, 0.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//			if( (pJObj = PlayMotion(gpStg114ModelName[1],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//			if( (pJObj = PlayMotion(gpStg114ModelName[2],0,gpStg114MotionName, 0.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//			if( (pJObj = PlayMotion(gpStg114ModelName[3],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//			if( (pJObj = PlayMotion(gpStg114ModelName[4],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//			if( (pJObj = PlayMotion(gpStg114ModelName[5],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
//		}
		break;
	case	K7EVENTNO(011110):
		{
			WK7JObj	*pJObj;
			if( (pJObj = PlayMotion(gpStg114ModelName[4],1,gpStg114MotionName, 0.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
			if( (pJObj = PlayMotion(gpStg114ModelName[5],1,gpStg114MotionName,-1.0f))!=NULL ){ pJObj->SetMotionLoop(false,false,true); }
			WK7Stage::SetPathEnable("event_011110_2",false);
			gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
		}
		break;
	default:
		break;
	}
	return true;
}

//bool K7Stage114M00::BpArriveCallBack(WK7BpInfo &info)
//{
//	u32	evno = GetBpEventNo(info);
//	if( evno==0xffffffff ){
//		return true;
//	}
//	switch( evno ){
//	case	K7EVENTNO(011108):
//	   	K7SCR_DEBUGPRINT("K7SCN01_EV011108_A");
//		if( mFinish==true ){
//			// Xe[WǂݑւJn
//			u32		stgid = K7STGID(115, 1);				// {XLXMAOLɂȂB
//			
//			// L|[Y
//			K7SCR_ENTER_PLAYMODE();
//			K7SCR_ENTER_DEMOPAUSE();
//			
//			gpNoise->mSandRequest(eSandLongNoise);
//			
//			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//				GHMGCTASK_RETSYS();
//			}
//			
//			WK7Stage::DeleteStage(this);
//			K7SCR_STG_CREATE_B   (stgid);
//			K7SCR_STG_VISIBLE    (stgid,true);
//			K7SCR_STG_SET_CURRENT(stgid);
//			
//			gpNoise->mSandRelease();
//			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//				GHMGCTASK_RETSYS();
//			}
//			
//			K7SCR_EXIT_PLAYMODE();
//			K7SCR_EXIT_DEMOPAUSE();
//			return false;
//		}
//	default:
//		break;
//	}
//	return true;
//}

int K7Stage114M00::GetPrevType(void)
{
	if( mTypeStackID <= 0 ){
		return -1;
	}
	return mTypeStack[mTypeStackID-1];
}
int K7Stage114M00::GetNextType(void)
{
	if( mTypeStackID > K7SCN01_STG114_TYPESTACK_NUM-2 ){
		return -1;
	}
	return mTypeStack[mTypeStackID+1];
}
int K7Stage114M00::GetCurrentType(void)
{
	return mTypeStack[mTypeStackID];
}
bool K7Stage114M00::Reverse(void)
{
	if( mTypeStackID <= 0 ){
		return false;
	}
	mTypeStackID--;
	mFinish = false;
	return true;
}
bool K7Stage114M00::Forward(int type)
{
	if( mTypeStackID >= K7SCN01_STG114_TYPESTACK_NUM-1 ){
		return false;
	}
	mTypeStackID++;
	if( mTypeStackID >= 0 && mTypeStackID < K7SCN01_STG114_TYPESTACK_NUM-1 ){
		mTypeStack[mTypeStackID+1] = type;
	}else{
		mFinish = true;
	}
#ifdef	_DEBUG
	char	str[16];
	sprintf(str,"Stack %d",mTypeStackID);
   	K7SCR_DEBUGPRINT(str);
#endif
	return true;
}
bool K7Stage114M00::InitMember(void)
{
	mTypeStackID  = 0;
	for(int i=0 ; i<K7SCN01_STG114_TYPESTACK_NUM ; i++){
		mTypeStack[i] = -1;
	}
	mTypeStack[0] = K7SCN01_STG114_NS;
	mTypeStack[1] = K7SCN01_STG114_NS;
	mFinish         = false;
	mOpenCloseID[1] = -1;
	mOpenCloseID[0] =  0;
	mJunctionDir    =  2;
	PlayMotion(gpStg114ModelName[0],0,gpStg114MotionName,-1.0f);
	return true;
}
bool K7Stage114M00::GetNextPath(u32 dir,const char *pPathName,char *pNextPathName)
{
	int			i;
	if( pPathName==NULL ){
		return false;
	}
	for(i=0 ; gpStg114IrregularNextPathTable[i][0]!=NULL ; i++){
		if( strcmp(gpStg114IrregularNextPathTable[i][0],pPathName)==0 ){
			strcpy(pNextPathName,gpStg114IrregularNextPathTable[i][1]);
			return true;
		}
		if( strcmp(gpStg114IrregularNextPathTable[i][1],pPathName)==0 ){
			strcpy(pNextPathName,gpStg114IrregularNextPathTable[i][0]);
			return true;
		}
	}
	if( pPathName[0]=='d' ){
		switch( pPathName[1] ){
		case	'0':
		case	'1':
		case	'2':
		case	'3':
			strcpy(pNextPathName,pPathName + 3);
			return true;
		default:
			break;
		}
	}
	sprintf(pNextPathName,"d%1d_%s",dir,pPathName);
	return true;
}
#if 0
bool K7Stage114M00::OpenFusuma(u32 eventNo,u32 pathNo)
{
	WK7JObj		*pJObj;
	u32			mdlno;
	
	switch( eventNo ){
	case	K7SCN01_BP04:
		if( pathNo==0 ){
			mdlno = 3;
		}else{
			mdlno = 0;
		}
		break;
	case	K7SCN01_BP05:
		if( pathNo==0 ){
			mdlno = 0;
		}else{
			mdlno = 1;
		}
		break;
	case	K7SCN01_BP06:
		if( pathNo==0 ){
			mdlno = 1;
		}else{
			mdlno = 2;
		}
		break;
	case	K7SCN01_BP07:
		if( pathNo==0 ){
			mdlno = 2;
		}else{
			mdlno = 3;
		}
		break;
	case	K7SCN01_BP08:
		switch( pathNo ){
		case	0:
			mdlno = 0;
			break;
		case	1:
			mdlno = 1;
			break;
		case	2:
			mdlno = 2;
			break;
		case	3:
			mdlno = 3;
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	
	pJObj = PlayMotion(gpStg114ModelName[mdlno],0,gpStg114MotionName);
	gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
	mOpenCloseID[0] = (int)mdlno;
	if( pJObj!=NULL ){
		pJObj->SetMotionLoop(false);
	}
	
	return true;
}
#endif
bool K7Stage114M00::CloseFusuma(u32 eventNo,u32 pathNo)
{
	WK7JObj		*pJObj;
	u32			mdlno;
	int			type = GetCurrentType();
	switch( eventNo ){
	case	K7EVENTDOOR(011100):
		switch( type ){
		case	K7SCN01_STG114_SW:
		case	K7SCN01_STG114_SN:
		case	K7SCN01_STG114_SE:
			break;
		default:
			return false;
		}
		mdlno = 0;
		break;
	case	K7EVENTDOOR(011101):
		switch( type ){
		case	K7SCN01_STG114_WN:
		case	K7SCN01_STG114_WE:
		case	K7SCN01_STG114_WS:
			break;
		default:
			return false;
		}
		mdlno = 1;
		break;
	case	K7EVENTDOOR(011102):
		switch( type ){
		case	K7SCN01_STG114_NE:
		case	K7SCN01_STG114_NS:
		case	K7SCN01_STG114_NW:
			break;
		default:
			return false;
		}
		mdlno = 2;
		break;
	case	K7EVENTDOOR(011103):
		switch( type ){
		case	K7SCN01_STG114_ES:
		case	K7SCN01_STG114_EW:
		case	K7SCN01_STG114_EN:
			break;
		default:
			return false;
		}
		mdlno = 3;
		break;
	case	K7SCN01_BP04:
		if( pathNo ){
			mdlno = 3;
		}else{
			mdlno = 0;
		}
		break;
	case	K7SCN01_BP05:
		if( pathNo ){
			mdlno = 0;
		}else{
			mdlno = 1;
		}
		break;
	case	K7SCN01_BP06:
		if( pathNo ){
			mdlno = 1;
		}else{
			mdlno = 2;
		}
		break;
	case	K7SCN01_BP07:
		if( pathNo ){
			mdlno = 2;
		}else{
			mdlno = 3;
		}
		break;
	case	K7SCN01_BP08:
		switch( pathNo ){
		case	0:
			mdlno = 2;
			break;
		case	1:
			mdlno = 3;
			break;
		case	2:
			mdlno = 0;
			break;
		case	3:
			mdlno = 1;
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011100),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011101),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011102),false);
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011103),false);
	switch( eventNo ){
	case	K7EVENTDOOR(011100): mJunctionDir = 0; SetPathEnable(K7SCN01_BP00,1,false); break;
	case	K7EVENTDOOR(011101): mJunctionDir = 1; SetPathEnable(K7SCN01_BP01,1,false); break;
	case	K7EVENTDOOR(011102): mJunctionDir = 2; SetPathEnable(K7SCN01_BP02,1,false); break;
	case	K7EVENTDOOR(011103): mJunctionDir = 3; SetPathEnable(K7SCN01_BP03,1,false); break;
	}
	K7SCR_EVNO_SETENABLE(eventNo,true);
		
	pJObj = PlayMotion(gpStg114ModelName[mdlno],1,gpStg114MotionName);
	mOpenCloseID[1] = (int)mdlno;
	if( mOpenCloseID[0]==(int)mdlno ){
		mOpenCloseID[0] = -1;
	}
	gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
	if( pJObj!=NULL ){
		pJObj->SetMotionLoop(false);
	}
	
	return true;
}
bool K7Stage114M00::ChangeFusuma(u32 eventNo,u32 pathno)
{
	WK7JObj		*pJObj;
	u32			mdlno;
//	u32			i;
	int			oc;
	int			type = GetCurrentType();
	switch( eventNo ){
	case	K7SCN01_BP04:
		switch( type ){
		case	K7SCN01_STG114_SE:
			mdlno = 3;
			if( pathno ){
				oc = 0;
			}else{
				oc = 1;
			}
			break;
		case	K7SCN01_STG114_ES:
			mdlno = 0;
			if( pathno ){
				oc = 1;
			}else{
				oc = 0;
			}
			break;
		default:
			return false;
		}
		break;
	case	K7SCN01_BP05:
		switch( type ){
		case	K7SCN01_STG114_WS:
			mdlno = 0;
			if( pathno ){
				oc = 0;
			}else{
				oc = 1;
			}
			break;
		case	K7SCN01_STG114_SW:
			mdlno = 1;
			if( pathno ){
				oc = 1;
			}else{
				oc = 0;
			}
			break;
		default:
			return false;
		}
		break;
	case	K7SCN01_BP06:
		switch( type ){
		case	K7SCN01_STG114_NW:
			mdlno = 1;
			if( pathno ){
				oc = 0;
			}else{
				oc = 1;
			}
			break;
		case	K7SCN01_STG114_WN:
			mdlno = 2;
			if( pathno ){
				oc = 1;
			}else{
				oc = 0;
			}
			break;
		default:
			return false;
		}
		break;
	case	K7SCN01_BP07:
		switch( type ){
		case	K7SCN01_STG114_EN:
			mdlno = 2;
			if( pathno ){
				oc = 0;
			}else{
				oc = 1;
			}
			break;
		case	K7SCN01_STG114_NE:
			mdlno = 3;
			if( pathno ){
				oc = 1;
			}else{
				oc = 0;
			}
			break;
		default:
			return false;
		}
		break;
	case	K7SCN01_BP08:
		switch( pathno ){
		case	0:
			switch( type ){
			case	K7SCN01_STG114_SN:
				mdlno = 2;
				oc    = 0;
				break;
			case	K7SCN01_STG114_NS:
				mdlno = 0;
				oc    = 1;
				break;
			default:
				return false;
			}
			break;
		case	1:
			switch( type ){
			case	K7SCN01_STG114_WE:
				mdlno = 3;
				oc    = 0;
				break;
			case	K7SCN01_STG114_EW:
				mdlno = 1;
				oc    = 1;
				break;
			default:
				return false;
			}
			break;
		case	2:
			switch( type ){
			case	K7SCN01_STG114_NS:
				mdlno = 0;
				oc    = 0;
				break;
			case	K7SCN01_STG114_SN:
				mdlno = 2;
				oc    = 1;
				break;
			default:
				return false;
			}
			break;
		case	3:
			switch( type ){
			case	K7SCN01_STG114_EW:
				mdlno = 1;
				oc    = 0;
				break;
			case	K7SCN01_STG114_WE:
				mdlno = 3;
				oc    = 1;
				break;
			default:
				return false;
			}
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	
	pJObj = NULL;
	if( oc > 0 ){
		if( mOpenCloseID[0]!=mdlno ){
			pJObj = PlayMotion(gpStg114ModelName[mdlno],0,gpStg114MotionName);
			mOpenCloseID[0] = (int)mdlno;
			gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
			if( mOpenCloseID[1]==mdlno ){
				mOpenCloseID[1] = -1;
			}
		}
	}else{
		if( mOpenCloseID[1]!=mdlno ){
			pJObj = PlayMotion(gpStg114ModelName[mdlno],1,gpStg114MotionName);
			mOpenCloseID[1] = (int)mdlno;
			gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
			if( mOpenCloseID[0]==mdlno ){
				mOpenCloseID[0] = -1;
			}
		}
	}
	if( pJObj!=NULL ){
		pJObj->SetMotionLoop(false);
	}
	
	return true;
}
#if 0
bool K7Stage114M00::OpenFusuma(u32 eventNo,u32 pathNo)
{
	WK7JObj		*pJObj;
	u32			mdlno[2];
	u32			i;
	switch( eventNo ){
	case	K7SCN01_BP04:
		mdlno[0] = 3; mdlno[1] = 0;
		break;
	case	K7SCN01_BP05:
		mdlno[0] = 0; mdlno[1] = 1;
		break;
	case	K7SCN01_BP06:
		mdlno[0] = 1; mdlno[1] = 2;
		break;
	case	K7SCN01_BP07:
		mdlno[0] = 2; mdlno[1] = 3;
		break;
	case	K7SCN01_BP08:
		switch( pathNo ){
		case	0:
			mdlno[0] = 0; mdlno[1] = 2;
			break;
		case	1:
			mdlno[0] = 1; mdlno[1] = 3;
			break;
		case	2:
			mdlno[0] = 2; mdlno[1] = 0;
			break;
		case	3:
			mdlno[0] = 3; mdlno[1] = 1;
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	if( eventNo!=K7SCN01_BP08 && pathNo ){
		i = mdlno[0]; mdlno[0] = mdlno[1]; mdlno[1] = i;
	}
	
	for(i=0 ; i<4 ; i++){
		if( mdlno[0]==i ){
			pJObj = PlayMotion(gpStg114ModelName[i],0,gpStg114MotionName);
			gpSound->mPlaySE(SFX_SCE1_FUSUMA_FAST);
			mOpenCloseID[0] = (int)i;
		}else if( mdlno[1]==i ){
			pJObj = PlayMotion(gpStg114ModelName[i],1,gpStg114MotionName);
			mOpenCloseID[1] = (int)i;
		}else{
			pJObj = PlayMotion(gpStg114ModelName[i],1,gpStg114MotionName,-1.0f);
		}
		if( pJObj!=NULL ){
			pJObj->SetMotionLoop(false);
		}
	}
	
	return true;
}
#endif
bool K7Stage114M00::SetPathEnable(u32 eventNo,u32 pathNo,bool flag,int enableex)
{
#pragma	unused(enableex)
	char					bpname[64];
	WK7PathBranchPoint		*pBpPoint;
	WK7PathBranch			*pBranch;
	WK7PathNurbs			*pPath;
	sprintf(bpname,"event_%06x",eventNo);
	if( (pBpPoint = GetPathBranchPoint(bpname))==NULL ){
		return false;
	}
	if( eventNo==K7SCN01_BP08 ){
		sprintf(bpname,"event_%06x_%1d_door_01110%1d_1",eventNo,pathNo,pathNo);
	}else{
		sprintf(bpname,"event_%06x_%1d",eventNo,pathNo);
	}
	for(pBranch=pBpPoint->GetTopBranch() ; pBranch!=NULL ; pBranch=pBranch->GetNext()){
		if( (pPath = pBranch->GetPath())==NULL ){
			continue;
		}
		if( strcmp(pPath->GetName(),bpname)!=0 ){
			continue;
		}
		pPath->SetEnable(flag);
		pPath->SetEnableEx(flag);
//		if( enableex > 0 ){
//			pPath->SetEnableEx(true);
//		}else if( enableex==0 ){
//			pPath->SetEnableEx(false);
//		}
		return true;
	}
	return false;
}
static	const char	*pPathNameTable[][4] = {
	{ "event_011108_2","event_011106_1",NULL            ,"event_011107_0", },
	{ "event_011104_0","event_011108_3","event_011107_1",NULL              },
	{ NULL            ,"event_011105_0","event_011108_0","event_011104_1", },
	{ "event_011105_1",NULL            ,"event_011106_0","event_011108_1", },
};
bool K7Stage114M00::SetAroundPathEnable(int fromdir,int todir)
{
	if( fromdir < 0 || todir < 0 || fromdir >= 4 ){
		return false;
	}
	WK7Path		*pPath = GetPath();
	if( pPath==NULL ){
		return false;
	}
	int				i;
	const char		**ppPathName = pPathNameTable[fromdir];
	char			str[32];
	WK7PathNurbs	*pPathNurbs;
	for(i=0 ; i<4 ; i++,ppPathName++){
		if( *ppPathName==NULL ){
			continue;
		}
		sprintf(str,"d%1d_%s",fromdir,*ppPathName);
		if( (pPathNurbs = pPath->GetPath(str))==NULL ){
			continue;
		}
		bool	flag;
		if( todir==i ){
			flag = true;
		}else{
			flag = false;
		}
		pPathNurbs->SetEnable  (flag);
		pPathNurbs->SetEnableEx(flag);
	}
	return true;
}
bool K7Stage114M00::SetPathEnable(u32 eventNo,bool flag,int enableex)
{
#pragma	unused(enableex)
	char					bpname[64];
	WK7PathBranchPoint		*pBpPoint;
	sprintf(bpname,"event_%06x",eventNo);
	if( (pBpPoint = GetPathBranchPoint(bpname))==NULL ){
		return false;
	}
	pBpPoint->SetPathEnable(flag);
	pBpPoint->SetPathEnableEx(flag);
//	if( enableex > 0 ){
//		pBpPoint->SetPathEnableEx(true);
//	}else if( enableex==0 ){
//		pBpPoint->SetPathEnableEx(false);
//	}
	return true;
}
bool K7Stage114M00::Initialize(int dir)
{
	// 
	bool	reverse = false;
	int		pathdir[2];
	// pXXV
	if( dir >= 0 ){
		switch( GetCurrentType() ){
		case	K7SCN01_STG114_SE:
		case	K7SCN01_STG114_WE:
		case	K7SCN01_STG114_NE:
			if( dir!=3 && Reverse()==true ){
				// t
			   	K7SCR_DEBUGPRINT("=== reverse E ===");
				reverse = true;
				break;
			}
			break;
		case	K7SCN01_STG114_SW:
		case	K7SCN01_STG114_EW:
		case	K7SCN01_STG114_NW:
			if( dir!=1 && Reverse()==true ){
				// t
			   	K7SCR_DEBUGPRINT("=== reverse W ===");
				reverse = true;
				break;
			}
			break;
		case	K7SCN01_STG114_SN:
		case	K7SCN01_STG114_EN:
		case	K7SCN01_STG114_WN:
			if( dir!=2 && Reverse()==true ){
				// t
			   	K7SCR_DEBUGPRINT("=== reverse N ===");
				reverse = true;
				break;
			}
			break;
		case	K7SCN01_STG114_ES:
		case	K7SCN01_STG114_WS:
		case	K7SCN01_STG114_NS:
			if( dir!=0 && Reverse()==true ){
				// t
			   	K7SCR_DEBUGPRINT("=== reverse S ===");
				reverse = true;
				break;
			}
			break;
		default:
			break;
		}
		if( reverse==false ){
			// Oɐił
			int		typenum;
			int		type;
			switch( mTypeStackID ){
			case	(K7SCN01_STG114_TYPESTACK_NUM-3):
				type = K7SCN01_STG114_NS;
				break;
			case	(K7SCN01_STG114_TYPESTACK_NUM-4):
				// Ō͓֌
				switch( GetNextType() ){
				case	K7SCN01_STG114_SE:
				case	K7SCN01_STG114_WE:
				case	K7SCN01_STG114_NE:
					type = K7SCN01_STG114_WS;
					break;
				case	K7SCN01_STG114_SW:
				case	K7SCN01_STG114_EW:
				case	K7SCN01_STG114_NW:
					type = K7SCN01_STG114_ES;
					break;
				case	K7SCN01_STG114_SN:
				case	K7SCN01_STG114_EN:
				case	K7SCN01_STG114_WN:
				   	K7SCR_DEBUGPRINT("=== forward N ===");
					return false;
				case	K7SCN01_STG114_ES:
				case	K7SCN01_STG114_WS:
				case	K7SCN01_STG114_NS:
					type = K7SCN01_STG114_NS;
					break;
				default:
					type = K7SCN01_STG114_NS;
					break;
				}
				break;
			default:
				switch( GetNextType() ){
				case	K7SCN01_STG114_SE:
				case	K7SCN01_STG114_WE:
				case	K7SCN01_STG114_NE:
					type = K7SCN01_STG114_WE;
					typenum = 2;
					break;
				case	K7SCN01_STG114_SW:
				case	K7SCN01_STG114_EW:
				case	K7SCN01_STG114_NW:
					type = K7SCN01_STG114_ES;
					typenum = 2;
					break;
				case	K7SCN01_STG114_SN:
				case	K7SCN01_STG114_EN:
				case	K7SCN01_STG114_WN:
				   	K7SCR_DEBUGPRINT("=== forward N ===");
					return false;
				case	K7SCN01_STG114_ES:
				case	K7SCN01_STG114_WS:
				case	K7SCN01_STG114_NS:
					type = K7SCN01_STG114_NE;
					typenum = 3;
					break;
				default:
					break;
				}
				if( typenum > 1 ){
					type += HSD_Rand() % typenum;
				}
				break;
			}
			Forward(type);
		}
	}
	// pXon/off
	SetPathEnable(K7SCN01_BP00,true);
	SetPathEnable(K7SCN01_BP01,true);
	SetPathEnable(K7SCN01_BP02,true);
	SetPathEnable(K7SCN01_BP03,true);
	switch( GetCurrentType() ){
	case	K7SCN01_STG114_SE:
	case	K7SCN01_STG114_ES:
		SetPathEnable(K7SCN01_BP04,true );
		SetPathEnable(K7SCN01_BP05,false);
		SetPathEnable(K7SCN01_BP06,false);
		SetPathEnable(K7SCN01_BP07,false);
		SetPathEnable(K7SCN01_BP08,false);
		break;
	case	K7SCN01_STG114_SW:
	case	K7SCN01_STG114_WS:
		SetPathEnable(K7SCN01_BP04,false);
		SetPathEnable(K7SCN01_BP05,true );
		SetPathEnable(K7SCN01_BP06,false);
		SetPathEnable(K7SCN01_BP07,false);
		SetPathEnable(K7SCN01_BP08,false);
		break;
	case	K7SCN01_STG114_WN:
	case	K7SCN01_STG114_NW:
		SetPathEnable(K7SCN01_BP04,false);
		SetPathEnable(K7SCN01_BP05,false);
		SetPathEnable(K7SCN01_BP06,true );
		SetPathEnable(K7SCN01_BP07,false);
		SetPathEnable(K7SCN01_BP08,false);
		break;
	case	K7SCN01_STG114_NE:
	case	K7SCN01_STG114_EN:
		SetPathEnable(K7SCN01_BP04,false);
		SetPathEnable(K7SCN01_BP05,false);
		SetPathEnable(K7SCN01_BP06,false);
		SetPathEnable(K7SCN01_BP07,true );
		SetPathEnable(K7SCN01_BP08,false);
		break;
	case	K7SCN01_STG114_SN:
	case	K7SCN01_STG114_NS:
		SetPathEnable(K7SCN01_BP04,false);
		SetPathEnable(K7SCN01_BP05,false);
		SetPathEnable(K7SCN01_BP06,false);
		SetPathEnable(K7SCN01_BP07,false);
		SetPathEnable(K7SCN01_BP08,0,true );
		SetPathEnable(K7SCN01_BP08,1,false);
		SetPathEnable(K7SCN01_BP08,2,true );
		SetPathEnable(K7SCN01_BP08,3,false);
		break;
	case	K7SCN01_STG114_WE:
	case	K7SCN01_STG114_EW:
		SetPathEnable(K7SCN01_BP04,false);
		SetPathEnable(K7SCN01_BP05,false);
		SetPathEnable(K7SCN01_BP06,false);
		SetPathEnable(K7SCN01_BP07,false);
		SetPathEnable(K7SCN01_BP08,0,false);
		SetPathEnable(K7SCN01_BP08,1,true );
		SetPathEnable(K7SCN01_BP08,2,false);
		SetPathEnable(K7SCN01_BP08,3,true );
		break;
	default:
	   	K7SCR_DEBUGPRINT("=== current -1 ===");
		return false;
	}
	// ÕpXݒ
	switch( GetPrevType() ){
	case	K7SCN01_STG114_SE:
		SetAroundPathEnable(1,0);
		break;
	case	K7SCN01_STG114_SW:
		SetAroundPathEnable(3,0);
		break;
	case	K7SCN01_STG114_SN:
		SetAroundPathEnable(0,0);
		break;
	case	K7SCN01_STG114_ES:
		SetAroundPathEnable(2,3);
		break;
	case	K7SCN01_STG114_EN:
		SetAroundPathEnable(0,3);
		break;
	case	K7SCN01_STG114_EW:
		SetAroundPathEnable(3,3);
		break;
	case	K7SCN01_STG114_WS:
		SetAroundPathEnable(2,1);
		break;
	case	K7SCN01_STG114_WN:
		SetAroundPathEnable(0,1);
		break;
	case	K7SCN01_STG114_WE:
		SetAroundPathEnable(1,1);
		break;
	case	K7SCN01_STG114_NW:
		SetAroundPathEnable(3,2);
		break;
	case	K7SCN01_STG114_NE:
		SetAroundPathEnable(1,2);
		break;
	case	K7SCN01_STG114_NS:
		SetAroundPathEnable(2,2);
		break;
	default:
		switch( GetCurrentType() ){
		case	K7SCN01_STG114_NS:
		case	K7SCN01_STG114_WS:
		case	K7SCN01_STG114_ES:
			SetPathEnable(K7SCN01_BP02,false);
			SetPathEnable(K7SCN01_BP04,false);
			SetPathEnable(K7SCN01_BP05,false);
			SetPathEnable(K7SCN01_BP08,0,true );
			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		case	K7SCN01_STG114_SN:
		case	K7SCN01_STG114_WN:
		case	K7SCN01_STG114_EN:
			SetPathEnable(K7SCN01_BP00,false);
			SetPathEnable(K7SCN01_BP06,false);
			SetPathEnable(K7SCN01_BP07,false);
			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,true );
			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		case	K7SCN01_STG114_SW:
		case	K7SCN01_STG114_NW:
		case	K7SCN01_STG114_EW:
			SetPathEnable(K7SCN01_BP03,false);
			SetPathEnable(K7SCN01_BP05,false);
			SetPathEnable(K7SCN01_BP06,false);
			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,true );
			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		case	K7SCN01_STG114_SE:
		case	K7SCN01_STG114_WE:
		case	K7SCN01_STG114_NE:
			SetPathEnable(K7SCN01_BP01,false);
			SetPathEnable(K7SCN01_BP04,false);
			SetPathEnable(K7SCN01_BP07,false);
			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,true );
			break;
		}
		break;
	}
	// ̃pXݒ
	switch( GetNextType() ){
	case	K7SCN01_STG114_SE:
		SetAroundPathEnable(2,3);
		break;
	case	K7SCN01_STG114_WE:
		SetAroundPathEnable(3,3);
		break;
	case	K7SCN01_STG114_NE:
		SetAroundPathEnable(0,3);
		break;
	case	K7SCN01_STG114_SW:
		SetAroundPathEnable(2,1);
		break;
	case	K7SCN01_STG114_EW:
		SetAroundPathEnable(1,1);
		break;
	case	K7SCN01_STG114_NW:
		SetAroundPathEnable(0,1);
		break;
	case	K7SCN01_STG114_SN:
		SetAroundPathEnable(2,2);
		break;
	case	K7SCN01_STG114_EN:
		SetAroundPathEnable(1,2);
		break;
	case	K7SCN01_STG114_WN:
		SetAroundPathEnable(3,2);
		break;
	case	K7SCN01_STG114_ES:
		SetAroundPathEnable(1,0);
		break;
	case	K7SCN01_STG114_WS:
		SetAroundPathEnable(3,0);
		break;
	case	K7SCN01_STG114_NS:
		SetAroundPathEnable(0,0);
		break;
	default:
		switch( GetCurrentType() ){
		case	K7SCN01_STG114_WS:
		case	K7SCN01_STG114_NS:
		case	K7SCN01_STG114_ES:
			SetPathEnable(K7SCN01_BP00,false);
			SetPathEnable(K7SCN01_BP08,0,true );
//			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,true );
			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		case	K7SCN01_STG114_SW:
		case	K7SCN01_STG114_NW:
		case	K7SCN01_STG114_EW:
			SetPathEnable(K7SCN01_BP01,false);
			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,true );
//			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,true );
			break;
		case	K7SCN01_STG114_SN:
		case	K7SCN01_STG114_WN:
		case	K7SCN01_STG114_EN:
			SetPathEnable(K7SCN01_BP02,false);
			SetPathEnable(K7SCN01_BP08,0,true );
			SetPathEnable(K7SCN01_BP08,1,false);
			SetPathEnable(K7SCN01_BP08,2,true );
//			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		case	K7SCN01_STG114_SE:
		case	K7SCN01_STG114_WE:
		case	K7SCN01_STG114_NE:
			SetPathEnable(K7SCN01_BP03,false);
			SetPathEnable(K7SCN01_BP08,0,false);
			SetPathEnable(K7SCN01_BP08,1,true );
			SetPathEnable(K7SCN01_BP08,2,false);
			SetPathEnable(K7SCN01_BP08,3,true );
//			SetPathEnable(K7SCN01_BP08,3,false);
			break;
		}
		break;
	}
	// v[[ʒuݒ
	WK7PathInfo		*pPathInfo = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	WK7Path			*pPath0 = GetPath();
	if( pPathInfo!=NULL && pPath0!=NULL ){
		
		f32				param   = pPathInfo->GetParam();
		u32				pathdir = pPathInfo->GetDir();
		WK7PathNurbs	*pPath  = pPathInfo->GetPath();
		u32				evno;
		char			pathname[32];
		WK7PathControl	*pCamPathControl = WK7CAM->GetPathControl();
		WK7PathInfo		*pCamPathInfo;
		Vec				campos[2],camtgt[2];
		u32				pathno;
		
		if( dir >= 0 ){
			// v[[̈ʒu
			pathno = 1;
			if( reverse==false ){
				switch( GetCurrentType() ){
				case	K7SCN01_STG114_SW:
				case	K7SCN01_STG114_SN:
				case	K7SCN01_STG114_SE:
					evno = 0x011100;
					break;
				case	K7SCN01_STG114_WN:
				case	K7SCN01_STG114_WE:
				case	K7SCN01_STG114_WS:
					evno = 0x011101;
					break;
				case	K7SCN01_STG114_NE:
				case	K7SCN01_STG114_NS:
				case	K7SCN01_STG114_NW:
					evno = 0x011102;
					break;
				case	K7SCN01_STG114_ES:
				case	K7SCN01_STG114_EW:
				case	K7SCN01_STG114_EN:
					evno = 0x011103;
					break;
				}
			}else{
				switch( GetCurrentType() ){
				case	K7SCN01_STG114_WS:
				case	K7SCN01_STG114_NS:
				case	K7SCN01_STG114_ES:
					evno = 0x011100;
					break;
				case	K7SCN01_STG114_SW:
				case	K7SCN01_STG114_NW:
				case	K7SCN01_STG114_EW:
					evno = 0x011101;
					break;
				case	K7SCN01_STG114_SN:
				case	K7SCN01_STG114_WN:
				case	K7SCN01_STG114_EN:
					evno = 0x011102;
					break;
				case	K7SCN01_STG114_SE:
				case	K7SCN01_STG114_WE:
				case	K7SCN01_STG114_NE:
					evno = 0x011103;
					break;
				}
			}
			pPath->GetPoint(camtgt[0],param);
			pathdir ^= 1;
		}else{
			switch( GetCurrentType() ){
			case	K7SCN01_STG114_NS:
				pathno = 0;
				break;
			case	K7SCN01_STG114_EW:
				pathno = 1;
				break;
			case	K7SCN01_STG114_SN:
				pathno = 2;
				break;
			case	K7SCN01_STG114_WE:
				pathno = 3;
				break;
			default:
			   	K7SCR_DEBUGPRINT("=== init error ===");
				return false;
			}
			evno    = 0x011108;
			param   = 0.0f;
			pathdir = 0;
		}
		
		sprintf(pathname,"event_%06x_%1d",evno,pathno);
		
		pPath = pPath0->GetPath(pathname);
		
		if( pCamPathControl!=NULL && (pCamPathInfo=pCamPathControl->GetCurrentPathInfo())!=NULL && pPath!=NULL ){
			
			WK7CamPathFollowInfo	*pPathFollowInfo = WK7CAM->GetPathFollowInfo();
			
			WK7Stage::SetCurrentPath(pPath,param,pathdir);
			
			if( dir >= 0 ){
				// Vv[[̈ʒu
				pPath->GetPoint(camtgt[1],param);
				
				camtgt[1].x -= camtgt[0].x;
				camtgt[1].y -= camtgt[0].y;
				camtgt[1].z -= camtgt[0].z;
			}
			
			pPath   = pCamPathInfo->GetPath();
			param   = pCamPathInfo->GetParam();
			pathdir = pCamPathInfo->GetDir();
			
			if( dir >= 0 ){
				
				// Jʒu
				pPath->GetPoint(campos[0],param);
				
				GetNextPath(evno & 3,pPath->GetName(),pathname);
			
				pPath  = pPath0->GetPath(pathname);
			
				if( pPath!=NULL && pPathFollowInfo!=NULL ){
					
					// VJʒu
					pPath->GetPoint(campos[1],param);
					
					campos[1].x -= campos[0].x;
					campos[1].y -= campos[0].y;
					campos[1].z -= campos[0].z;
					
					pPathFollowInfo->SetCurrentPath(pPath,param,pathdir);
					pPathFollowInfo->SetCamPosReset(false);
					
					pPathFollowInfo->GetPosition      (campos[0]);
					pPathFollowInfo->GetTargetPosition(camtgt[0]);
					
					campos[0].x += campos[1].x;
					campos[0].y += campos[1].y;
					campos[0].z += campos[1].z;
					camtgt[0].x += camtgt[1].x;
					camtgt[0].y += camtgt[1].y;
					camtgt[0].z += camtgt[1].z;
					
					pPathFollowInfo->SetPosition      (campos[0]);
					pPathFollowInfo->SetTargetPosition(camtgt[0]);
					
				}
				
			}else{
				
				WK7CAM->SetCurrentPath(WK7PATHINFO_INITDIR_TGTDIR_REV);
				pPathFollowInfo->SetBranchPointMode(false,true);
				pPathFollowInfo->ResetCamPos();
				
			}
			
		}
		
	}
	int		i,j;
	if( dir >= 0 ){
		switch( GetCurrentType() ){
		case	K7SCN01_STG114_SE: pathdir[0] = 0; pathdir[1] = 3; break;
		case	K7SCN01_STG114_ES: pathdir[0] = 3; pathdir[1] = 0; break;
		case	K7SCN01_STG114_SW: pathdir[0] = 0; pathdir[1] = 1; break;
		case	K7SCN01_STG114_WS: pathdir[0] = 1; pathdir[1] = 0; break;
		case	K7SCN01_STG114_WN: pathdir[0] = 1; pathdir[1] = 2; break;
		case	K7SCN01_STG114_NW: pathdir[0] = 2; pathdir[1] = 1; break;
		case	K7SCN01_STG114_NE: pathdir[0] = 2; pathdir[1] = 3; break;
		case	K7SCN01_STG114_EN: pathdir[0] = 3; pathdir[1] = 2; break;
		case	K7SCN01_STG114_SN: pathdir[0] = 0; pathdir[1] = 2; break;
		case	K7SCN01_STG114_NS: pathdir[0] = 2; pathdir[1] = 0; break;
		case	K7SCN01_STG114_WE: pathdir[0] = 1; pathdir[1] = 3; break;
		case	K7SCN01_STG114_EW: pathdir[0] = 3; pathdir[1] = 1; break;
		default:
			break;
		}
		if( reverse==true ){
			int	tmp;
			tmp = pathdir[0]; pathdir[0] = pathdir[1]; pathdir[1] = tmp;
		}
	}else{
		// Ԑݒ
		pathdir[0] =  0;
		pathdir[1] = -1;
		
		WK7Stage::SetPathEnable    ("event_011110_2",true);
		WK7Stage::SetPathEnableOnly("event_011109_1",true);
		WK7Stage::SetPathEnableOnly("event_011109_2",true);
		
		int			correct = HSD_Rand() & 1;
		WK7JObj		*pJObj;
		
		switch( mAnswerCount ){
		case	0:
			mPicture = 1;
			mFront   = 0;
			break;
		case	1:
			mPicture = 0;
			mFront   = 0;
			break;
		case	2:
		default:
			mPicture = (u32)(HSD_Rand() & 1);
			mFront   = 1;
			break;
		}
//		mPicture = (u32)(HSD_Rand() & 1);
//		mFront   = (u32)(HSD_Rand() & 1);
		
		for(i=0 ; i<2 ; i++){
			for(j=0 ; j<2 ; j++){
				if( (pJObj=GetJObj(pPictureName[i][j]))!=NULL ){
					pJObj->Hide(false,true);
				}
			}
		}
		if( (pJObj=GetJObj(pPictureName[mPicture][mFront]))!=NULL ){
			f32		rot;
			f32		scl;
			pJObj->Disp(false,true);
			if( mPicture ){
				// 
				if( !correct ){
					// E
					scl = 1.0f;
					rot = 0.0f;
				}else{
					// 
					scl = -1.0f;
					rot = PI;
				}
			}else{
				// T
				if( correct ){
					// 
					scl = 1.0f;
					rot = 0.0f;
				}else{
					// E
					scl = -1.0f;
					rot = PI;
				}
			}
			if( !mFront ){
				pJObj->SetScale(scl,1.0f,1.0f);
			}
			for(i=0 ; i<2 ; i++){
				if( mpGate[i]==NULL ){
					continue;
				}
				mpGate[i]->SetRotY(rot);
			}
			if( correct ){
				mRightEventNo = K7EVENTDOOR(010013);
			}else{
				mRightEventNo = K7EVENTDOOR(010012);
			}
		}
		
	}
	// ԕύX
	f32		startframe[2];
	WK7JObj	*pJObj;
	for(i=0 ; i<2 ; i++){
		if( mOpenCloseID[i] >= 0 && (pJObj=GetJObj(gpStg114ModelName[mOpenCloseID[i]]))!=NULL ){
			startframe[i] = pJObj->GetCurrentMotionFrame();
		}else{
			startframe[i] = -1;
		}
	}
	for(i=0 ; i<4 ; i++){
		if( pathdir[0]==i ){
			pJObj = PlayMotion(gpStg114ModelName[i],0,gpStg114MotionName,startframe[0]);
			mOpenCloseID[0] = i;
		}else if( pathdir[1]==i ){
			pJObj = PlayMotion(gpStg114ModelName[i],1,gpStg114MotionName,startframe[1]);
			mOpenCloseID[1] = i;
		}else{
			pJObj = PlayMotion(gpStg114ModelName[i],1,gpStg114MotionName,-1.0f);
		}
		if( pJObj!=NULL ){
			pJObj->SetMotionLoop(false);
			pJObj->FrameProcess();
		}
	}
	
	if( reverse==true ){
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011100),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011101),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011102),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011103),false);
		switch( mJunctionDir ){
		case	0:
			SetPathEnable(K7SCN01_BP00,1,false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011100),true);
			break;
		case	1:
			SetPathEnable(K7SCN01_BP01,1,false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011101),true);
			break;
		case	2:
			SetPathEnable(K7SCN01_BP02,1,false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011102),true);
			break;
		case	3:
			SetPathEnable(K7SCN01_BP03,1,false);
			K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011103),true);
			break;
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011100),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011101),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011102),false);
		K7SCR_EVNO_SETENABLE(K7EVENTDOOR(011103),false);
	}
	
	return true;
}

