////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage190M01
//
// K7Stage190M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/05/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE190M01_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include ".\K7Stage190M01.h"
#include "..\Yam\YK7EffectBillboard.h"
#include "..\Yam\YK7EffectImpact.h"
#include "..\Yam\YK7EffectScreen.h"
#include "..\Yam\YK7EffectSmoke.h"

#define	K7STAGE190M01_ROCK_OBJNAME			"event_015000_msk"
#define	K7STAGE190M01_ROCKCLOSE_PATHNAME	"branchF"
#define	K7STAGE190M01_MSK_MOTID				K7MOTID(K7MSK,520)

const u16 SmokParam[20] = 
{	82,		2,		0,		245,		50,
	20,		31,		20,		90,		70,

	180,		180,		180,		255,		5,
	30,		20,		10,		79,		0 } ;

const u16 BillParam[15] = 
{	1,		255,		169,		80,		255,
	3089,		1000,		80,		2,		99,

	10,		2,		1,		300,		0 } ;

K7Stage190M01::K7Stage190M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	mpRainEffect = NULL;
	SetOneShotCamLocTbl( K7Stage190M01_Camera );
	SetupBillboardEffectID( BILLEFF_SPARK ) ;
	Smoke = NULL ;
	Impact = NULL ;
	Screen = NULL ;
	Billboard = NULL ;
}

K7Stage190M01::~K7Stage190M01()
{
	gpSound->mStopSE(SFX_SCE1_FUKU_RAIN);
	ReleaseEffect(mpRainEffect);
	ReleaseBillboardEffectID( BILLEFF_SPARK ) ;
	if( CheckEffectValidState( Billboard, BillboardID ) == TRUE ) DeleteEffect( Billboard ) ;
	if( CheckEffectValidState( Impact, ImpactID ) == TRUE ) DeleteEffect( Impact ) ;
	if( CheckEffectValidState( Screen, ScreenID ) == TRUE ) DeleteEffect( Screen ) ;
	if( CheckEffectValidState( Smoke, SmokeID ) == TRUE ) DeleteEffect( Smoke ) ;
}

bool K7Stage190M01::CreateCallBack(void)
{
	CreateOwnStageMotion(   0);
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE190M01_MSK_MOTID);
	return true;
}

bool K7Stage190M01::InitializeCallBack(void)
{
	mpRainEffect = CreateEffectRain(40.0f,-5.5f);
	mpMskMotion  = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,K7STAGE190M01_MSK_MOTID);
	return true;
}

bool K7Stage190M01::SetCurrentCallBack(void)
{
	SetSelectObjFlag(K7STGID(100,0),"branchF",0,true);
	SetPassPathFlag (K7STGID(100,0),"branchF",2,true);
	if( GetPrevStageID() == K7STGID(190,0) ){
		// }XNɃ`FW
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_CHANGE_MSK)==FALSE &&
		    WK7PLAYERCONTROL->GetMainID()!=K7MSK &&
		    GetAlivePcID(K7MSK)==K7MSK ){
			
			WK7StagePlaceInfo		*pPlaceInfo;
			
			SetManualBranch(true);
			while( WK7Stage::IsChanging()==true ){
				K7SCR_RETSYS();
			}
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			pPlaceInfo = GetPlaceInfo("branchA");
			SetCameraStartPosition(pPlaceInfo);
			while( SandRelease(pPlaceInfo)==false ){
				K7SCR_RETSYS();
			}
			SetCurrentCallBackDefaultProc();
			
			FixCam( EV_CHARACHG_2CAM );
			K7SCR_TIMEWAIT( 4800 * 2 );
			WatchCameraB( K7Stage190M01_Camera[EV_CHARACHG_2PC].tgt,
						  K7Stage190M01_Camera[EV_CHARACHG_2PC].pos,
						  K7CHRID(K7MSK,0), 1 );
			
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			SetManualBranch(false);
			
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_CHANGE_MSK);
			
			return false;
		}
	}
	return true;
}

bool K7Stage190M01::CondChangeCallBack(void)
{
	WK7JObj		*pJObj;
	pJObj = GetJObj(K7STAGE190M01_ROCK_OBJNAME);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_BREAK_ENTROCK)==TRUE ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015000),false);
		K7SCR_STG_SET_PATHENABLE(K7STAGE190M01_ROCKCLOSE_PATHNAME,true);
//		if( (pJObj=PlayMotion(K7STAGE190M01_ROCK_OBJNAME,0))!=NULL ){
//			pJObj->SetMotionLoop(false,false,true);
//		}
		K7SCR_JOBJ_HIDE(pJObj);
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(015000),true);
		K7SCR_STG_SET_PATHENABLE(K7STAGE190M01_ROCKCLOSE_PATHNAME,false);
		
		if( pJObj!=NULL ){
			K7SCR_JOBJ_DISP(pJObj);
			pJObj->DetachMotion(false,true);
			pJObj->ResetMotion(false,true);
		}
	}
	return false;
}

bool K7Stage190M01::EventCallBack(WK7EventInfo &info)
{
	WK7JObj		*pJObj;
	switch( info.mEventNo ){
	case	K7EVENTNO(015000):
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		if( WK7PLAYERCONTROL->GetMainID()==K7MSK ){
static	Vec		pos = { 0.0f , -5.0f , 30.0f };
static	f32		roty = PI;
//static	s32		tick = 6000;
			WK7Model		*pPcModel = WK7PLAYERCONTROL->GetCharaModel();
			WK7StageMotion	*pStageMotion = GetOwnStageMotion(0);
			WK7CameraMotion	*pCamMotion;
			
			K7SCR_NOISE_REQUEST();
			K7SCR_NOISE_REQUEST_WAIT();
			
			WK7Npc::NpcVisibleAll(false);
			
			WK7PLAYERCONTROL->SetEnable(false);
			WK7PLAYERCONTROL->SetClothEnable(false);
//			WK7CAM->SetCinemaScopeMode(true);
			if( pPcModel != NULL ){
				WK7JObj	*pJObj = GetJObj("msk_pos");
				if( pJObj!=NULL ){
					Vec		dir = { 0.0f,0.0f,1.0f };
					pJObj->GetWorldPosition(pos);
					MTXMultVecSR(pJObj->GetLocalWorldMatrix(),&dir,&dir);
					roty = atan2f(dir.x,dir.z);
				}
				pPcModel->SetPosition  (pos);
				pPcModel->SetRotY      (roty);
				pPcModel->AttachMotion (mpMskMotion);
				pPcModel->PlayMotion   ();
				pPcModel->SetMotionLoop(false);
				pPcModel->StopMotion   ();
			}
			if( pStageMotion!=NULL && (pCamMotion=pStageMotion->GetCameraMotion())!=NULL ){
				WK7CAM->AttachMotion(pCamMotion);
				WK7CAM->PlayMotion  ();
				WK7CAM->SetMotionLoop(false);
				WK7CAM->StopMotion  ();
			}
//			FixCam( EV_ROCK_BREAK );
			
			K7SCR_NOISE_RELEASE();
			
//			K7SCR_TIMEWAIT(tick);
			WK7CAM->ReplayMotion();
			pPcModel->ReplayMotion();
			if( (pJObj=PlayMotion(K7STAGE190M01_ROCK_OBJNAME,0))!=NULL ){
				pJObj->SetMotionLoop(false,false,true);
			}
//			K7SCR_TIMEWAIT(tick);
			gpSound->mPlaySE(SFX_SCE1_FUKU_ROCKDESTROY);
			
			Screen = CreateScreenEffect() ;
			if( Screen != NULL )
			{
				SetScreenEffectExRate( Screen, 1.02F ) ;
				SetScreenEffectAddFlag( Screen, FALSE ) ;
				SetScreenEffectAlpha( Screen, 0.45F ) ;
				SetScreenEffectDrawFlag( Screen, TRUE ) ;
				ScreenID = GetEffectID( Screen ) ;
			}
			while( pPcModel->GetMotionState()!=WK7MODEL_NOANIM ){
				int seNo;
				if ( 68 == pPcModel->GetCurrentMotionFrame() ){					// }XNӂ΂萺Đ
					gpSound->mPlaySE( SFX_PC_MSK_POWVOICE_B,
									  SOUND_SYSTEM_SE_VOLUME,					// 
									  SOUND_PAN_CENTER,							// p
									  eSETrackBattleOverlap, 					// gbN
									  eSEGroupBattle00Env );					// O[v
				}
				if ( 74 == pPcModel->GetCurrentMotionFrame() ){					// qbg
					seNo = gpSound->mPlaySE( SFX_BT_KICK_HIT_C,
									  SOUND_SYSTEM_SE_VOLUME,					// 
									  SOUND_PAN_CENTER,							// p
									  eSETrackBattleOverlap, 					// gbN
									  eSEGroupBattle00Env );					// O[v
					gpSound->mSetPitchSENo( seNo, (s16 )-300 );					// 100 ́@{l

					// qbgGtFNgo
					{
						Vec Dir, Pos = { 0.161F, 11.277F, 18.449F } ;

						// y̕𓾂
						{
							Vec p2 = { 0.197F, 11.277F, 15.466F } ;
							VECSubtract( &p2, &Pos, &Dir ) ;
							VECNormalize( &Dir, &Dir ) ;
//							VECScale( &Dir, &Dir, -1.0F ) ;
						}

						// GtFNg
						{
							Vec Dir, SSpeed ;
							GXColor C ;
							
							SSpeed.x = 0.0F ;
							SSpeed.y = -BillParam[8] * 0.001F ;
							SSpeed.z = 0.0F ;
							Dir.x = 0.0F ;	Dir.y = 1.0F ;	Dir.z = 0.0F ;

							C.r = (u8)BillParam[1] ;
							C.g = (u8)BillParam[2] ;
							C.b = (u8)BillParam[3] ;
							C.a = (u8)BillParam[4] ;

							Billboard = CreateBillboardEffect( BILLID_3DLINE, (u8)BillParam[0], Pos,
													1.0F, 0.0F,
													BillParam[5] * 0.001F, BillParam[6] * 0.001F,
													Dir, PI_2 / 360 * BillParam[7],
													TRUE, TRUE,
													SSpeed, BillParam[9] * 0.01F,
													BillParam[10] * 0.01F, BillParam[10] * 0.01F,
													1.0F, 1.0F,
													BillParam[11], BillParam[12],
													0.0F, 0.0F,
													(u32)BillParam[13], FALSE,
													&C, -1, FALSE ) ;
							if( Billboard != NULL )
							{
								BillboardID = GetEffectID( Billboard ) ;
								SetBillboardDirection( Billboard, Dir ) ;
								{
									s32 i ;
									
									for( i = 0 ; i < BillParam[13] ; i ++ )
										AddBillboardEffectObject( Billboard, Pos ) ;
								}
							}
						}
						
						// o
						{
							GXColor Color ;
							Vec Point = { 0.161F, -4.5F, 18.449F } ;
							
							Color.r = (u8)SmokParam[10] ;
							Color.g = (u8)SmokParam[11] ;
							Color.b = (u8)SmokParam[12] ;
							Smoke = CreateSmokeEffect( 1, Point, SmokParam[0] * 0.1F,
												SmokParam[1] * 0.01F, SmokParam[2] * 0.01F,
												0.0F, SmokParam[3],
												(Vec){0.0F,0.0F,0.0F}, 0.0F,
												PI * SmokParam[4] * 0.1F / 180.0F, PI * SmokParam[5] * 0.1F / 180.0F, 
												SmokParam[6] * 0.1F, SmokParam[7] * 0.1F,
												SmokParam[6] * 0.1F, SmokParam[7] * 0.1F,
												SmokParam[8], SmokParam[9], SmokParam[17] * 1.0F,
												Color, Color, Color, (u8)SmokParam[13],
												PI * SmokParam[18] / 180.0F, 0.0F, FALSE, (u8)SmokParam[14], 
												SmokParam[15] * 0.01F, FALSE, 0,
												Color, Color, Color,
												SmokParam[16] * 0.01F ) ;
							if( Smoke != NULL ) SmokeID = GetEffectID( Smoke ) ;
						}
						
						// ʂh炷
						Impact = CreateImpactEffect( 40, 20, (Vec){0.0F, 0.0F, 0.0F}, 5, 0, TRUE ) ;
						if( Impact != NULL ) ImpactID = GetEffectID( Impact ) ;
					}
				}
				K7SCR_RETSYS();
			}
			if( pJObj!=NULL ){
				while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
			}
			while( WK7CAM->GetMotionState()!=WK7MODEL_NOANIM ){
				K7SCR_RETSYS();
			}
			WK7CAM->StopMotion();
			WK7CAM->DetachMotion();
			
#if 0
			while( !(HSD_PadGetTrigger(0) & HSD_PAD_A) ){
				K7SCR_RETSYS();
			}
			WK7PLAYERCONTROL->SetEnable(true);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			return false;
#endif
			
			u32		stgid = K7STGID(100, 0);
static const char	*pDoorName = "branchF";
			SetSelectObjFlag(stgid,pDoorName,0,true);
			SetPassPathFlag (stgid,pDoorName,2,true);
			
//			K7SCR_PC_SETVISIBLE(false);
//			K7SCR_STGC_MESSAGE_B(K7STAGE190M01_MES_ROCK_BREAK);
//			K7SCR_PC_RETURNVISIBLE();
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_BREAK_ENTROCK);
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_MAP_DEFAULT)==false ){
				K7SCR_RETSYS();
			}
			K7SCR_RETSYS();
			WK7CAM->SetCinemaScopeMode(false);
			WK7PLAYERCONTROL->SetEnable(true);
			WK7PLAYERCONTROL->SetClothEnable(true);
			SetRenderFlag(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			WK7Stage::DeleteStage(this);
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				K7SCR_RETSYS();
			}
			gpSound->mStopStream();
			WK7Play		*pPlay;
			while( (pPlay=WK7Play::Create(K7EVENTPLAY(01050101)))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			
			WK7Npc::NpcVisibleAll(true);
			
			// Xe[WWv
			WK7Stage::SetPrevStageID       (K7STGID_INVALID);
			WK7Stage::SetPrevStagePathName (NULL);
			WK7Stage::SetPrevStageBpName   (NULL);
			WK7Stage::SetCurrentStageBpName(NULL);
			WK7Stage::SetCurrentStageParam (NULL);
			K7SCR_STG_CREATE_B(stgid);
			WK7PLAYERCONTROL->RestoreArchive();
			while( WK7PLAYERCONTROL->IsLoading()==true ){
				K7SCR_RETSYS();
			}
			WK7Stage	*pNextStage;
			K7SCR_STG_VISIBLE    (stgid,true);
			K7SCR_STG_SET_CURRENT(stgid);
//			K7SCR_STG_SET_CURRENT_PATH_POINT("branchF");
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("set5","curve5",0.370f,WK7PATHINFO_INITDIR_TGTDIR_REV);
			WK7PLAYERCONTROL->SetVisible(true);
			WK7PLAYERPATHCONTROL->CameraRenew();
			WK7PLAYERCONTROL->ChangeCallback();
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			while( (pNextStage=WK7RenderObj::GetStage(stgid))==NULL ){
				K7SCR_RETSYS();
			}
			WK7StagePlaceInfo		*pPlaceInfo;
			pPlaceInfo = pNextStage->GetPlaceInfo("branchF");
//			pNextStage->SetCameraStartPosition(pPlaceInfo);
			pNextStage->SandRelease(pPlaceInfo);
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
		}else{
			FixCam( EV_ROCK_CLOSE );
			K7SCR_PC_SETVISIBLE(false);
			K7SCR_STGC_MESSAGE_B(K7STAGE190M01_MES_ROCK_CLOSE);
			K7SCR_PC_RETURNVISIBLE();
		}
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	default:
		break;
	}
	return true;
}

