////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage133M00 prRKL
//
// K7Stage133M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE133M00_CPP__

#include "..\..\..\Scn\K7Scn01.h"
#include "..\..\..\Wat\WK7Event.h"
#include ".\K7Stage133M00.h"
#include "..\..\..\Matsu\MK7Sound.h"
#include "..\..\..\Panel\SK7PanelKeiba.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"

// bZ
#define MES133M00_POSTER		(0)			// |X^[\Ă
#define MES113M00_SPCYO_JUMP	(1)			// R[eWv
#define MES113M00_STRAGE		(2)			// `Qbg

// [V
#define MOT133M00_DESKOPEN	(3)				// Jiej

// f
#define MDL133M00_DESK			"Drawer"		// o
#define MDL133M00_STRANGE		"Thing"		// ̑`
#define MDL133M00_TAMA			"tama_011501"

// pX
#define PATH133M00_SPCYO_JUMPSAKI "branchJ"	// R[eWv

// pX
#define	CAMK7STAGE133M00_RIDDLE_PATHNAME		"event_011501_0"		// JpXO

#define CORE_NUM	(1)

K7Stage133M00::K7Stage133M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	pNpcSu = NULL;
	mDeskOpen = false;
	SetOneShotCamLocTbl(K7Stage133M00_Camera);
}

K7Stage133M00::~K7Stage133M00()
{
}

/*
	
	NGCg
	
*/
bool K7Stage133M00::CreateCallBack(void)
{
	CreateOwnStageMotion(MOT133M00_DESKOPEN);
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage133M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	// GԂ̂肠
	WK7PLAYERCONTROL->ClearMuteki();
	return true;
}

/*
	
	
	
*/
bool K7Stage133M00::InitializeCallBack(void)
{
	HereComeANewHSInit( PR_HS_LEGG, ENENO_1_133M00_5 );
	K7SCR_EVCONDCHANGE();

	SetStageMapFlag(0,true);
	GameInfo.SetMenuMapSubNo(0);	
	return true;
}

bool K7Stage133M00::CondChangeCallBack(void)
{
	WK7JObj		*pJObj;

	DeskOpen(0);
	
	ReleaseTamaEffect();
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011502) == true ){				// ñ}[NV[gplς
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011502), false);
		if ( K7SCR_EVHASITEM(K7EVITEM_TAMA(011501)) == false ){				// eO
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011501),  true);
			CreateTamaEffect(K7EVITEM_TAMA(011501));
		}else{
			if( (pJObj=GetJObj(MDL133M00_TAMA)) != NULL ){
				pJObj->Hide(false,true);									// e
			}
			K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011501), false);
		}
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(011502), true);
		K7SCR_EVNO_SETENABLE(K7EVITEM_TAMA(011501),  false);
	}
	
	pJObj = GetJObj(MDL133M00_STRANGE);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011601) == false ){			// `O
		// J\
		K7SCR_STG_SET_DISABLEPATHCAMERA( CAMK7STAGE133M00_RIDDLE_PATHNAME, false );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(011601), true );
		K7SCR_JOBJ_DISP(pJObj);												//svcȑ`̕\
	}else{
		// J
		K7SCR_STG_SET_DISABLEPATHCAMERA( CAMK7STAGE133M00_RIDDLE_PATHNAME, true );
		K7SCR_EVNO_SETENABLE( K7EVENTNO(011601), false );
		K7SCR_JOBJ_HIDE(pJObj);												//svcȑ`̕\
	}
	
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage133M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	// EVENT_011502 ñ}[NV[gpl
	case	K7EVENTNO(011502):
		s32  result;
		bool panelOK = false;
		
		K7SCR_PANEL_SETPANELID_NOPARAM(ePanel011502);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		if( (result = K7SCR_PANEL_GETRESULT()) == KEIBA_WIN ){			// I
			panelOK = true;
			K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011502);
			K7SCR_EVNO_SETENABLE(K7EVENTNO(011502), false);				// ̃Cxg֎~
		}
		K7SCR_RETSYS();
		if ( panelOK == true ){
			FixCam(ONESHOTCAM_011502_RESULT);
		}
		K7SCR_PANEL_EXIT();
		if ( panelOK == true ){
			K7SCR_PANEL_EXITWAIT();
			
			// L|[Y
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE(false);									// l
			
			
			gpSound->mPlaySE(SFX_SYS_EV_CLEAR);									// 
			DeskOpen(1);
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			gpSound->mPlaySE(SFX_SYS_CAMERA_ZOOM);						// Y[op SE
			K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
			
			// L|[Y
			K7SCR_PC_RETURNVISIBLE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
		}
		K7SCR_EVCONDCHANGE();
		break;
	// |X^[
	case	K7EVENTNO(011506):												// |X^[pl
		// L|[Y
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);											// l
		
		// Jς
		FixCam(ONESHOTCAM_011506);
		
//		gpSound->mPlaySE(SFX_SYS_EV_CLEAR);
		
		K7SCR_STGC_MESSAGE_B(MES133M00_POSTER);								// 
		
		// L|[Y
		K7SCR_PC_RETURNVISIBLE();
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
		return false;
		break;
	// svcȑ`
	case	K7EVENTNO(011601):
		//inGame~
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		//svcȑ`
		K7SCR_EVSETITEM( K7EVITEM_KEY(011601), true );
		K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011601);						// tOǗpƂėĂ
		
		//WNV
		K7SCR_EVNO_SETENABLE( K7EVENTNO(011601), false );
		
		//擾SEĐ
//		gpSound->mPlaySE( SFX_SYS_KEY_GET );
		//Jݒ
		FixCam( ONESHOTCAM_011601 );
		
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1));
		
		//svcȑ`̕\
		K7SCR_EVCONDCHANGE();
		
		//ACe擾ʂ\
		K7SCR_STG_ITEMGET_B(MES113M00_STRAGE);
		
		
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		break;
	case	K7EVENTNO(011501):												// R[eWv
		break;
	}
	
	return false;
}


/*	
	
	
	qbgIuWF
	
	
*/
bool K7Stage133M00::HitObjCallBack(WK7HitObjInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(011507):						// |^N
		Vec Pos = {138.751f, 0.292f, -115.652f};
		BombObj(info.mpJObj, K7STG_DEFAULT_BOMBOBJ_DIST, &Pos);
		return false;
		break;
	default:
		if ( pNpcSu != NULL ) {
			if( (info.mEventNo >= pNpcSu->GetHitObjID()) && (info.mEventNo < (pNpcSu->GetHitObjID()+CORE_NUM) ) ){
				if ( false == pNpcSu->CoreHit((int )info.mEventNo, info.mTypeID, info.mHitPos) ) {
					// RAj󂵂ĂȂ
					// qbgIuWF𕜊
					info.SetHitObjEnable(true);
//					info.mpHitObj->SetEnable(true);
				}
				return false;
			}
		}
		break;
	}
	return true;
}


bool K7Stage133M00::DeskOpen(int se)
{
	WK7JObj		*pJObj;
	
	if ( false == K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011502) ) return false;
	
	if ( mDeskOpen == false ){
		mDeskOpen = true;
	}else{
		return false;
	}
	
	if( (pJObj=PlayMotion(MDL133M00_DESK, MOT133M00_DESKOPEN))!=NULL ){
		pJObj->SetMotionLoop(false);
		if ( se ) gpSound->mPlaySE(SFX_SCE1_KAKU_HIKIDASHI_OPEN);			// J
		
		while( pJObj->GetMotionState()!=WK7MODEL_NOANIM ){
			K7SCR_RETSYS();
		}
		return true;
	}
	return false;
}


/*	
	
	R[eWv
	
*/
bool K7Stage133M00::SpAbilityCallBack(WK7SpAbilityInfo &info)
{
	switch( info.mAbilityID ){
	case	PC_SPA_BOOST_JUMP:
		WK7PlayerSpInfoCyo*	pCyoInfo = WK7PLAYERCONTROL->GetSpInfoCyo();
		
//		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011501_SPCYO)==TRUE ){
//			WK7PLAYERCONTROL->SetSpAbilityCancel(true);
//			return false;
//		}
		
//		K7SCR_SET_SCENARIO_FLAG(K7SCN01_EVFL_011501_SPCYO);
		
		pCyoInfo->mpToBpName      = PATH133M00_SPCYO_JUMPSAKI;
		pCyoInfo->mFromPos.x      =  243.840f;
		pCyoInfo->mFromPos.y      =  0.0f;
		pCyoInfo->mFromPos.z      = -216.637f;
		pCyoInfo->mFromRotY       =  -2.826f;
		pCyoInfo->mToPos  .x      =  225.830f;
		pCyoInfo->mToPos  .y      =  31.771f;
		pCyoInfo->mToPos  .z      = -218.785f;
		pCyoInfo->mToRotY         =  2.495f;
		pCyoInfo->mStageMessage   = true;
		pCyoInfo->mStageMessageID = MES113M00_SPCYO_JUMP;
		FixCam(JUMP_0);
		SetStageMapFlag(1,true);
		GameInfo.SetMenuMapSubNo(1);	

		while( WK7PLAYERCONTROL->GetSpProc() < SPCYO_JUMPWAIT ){
			K7SCR_RETSYS();
		}
		FixCam(JUMP_1);
		while( WK7PLAYERCONTROL->GetSpProc()!=SPCYO_IDLE ){
			K7SCR_RETSYS();
		}
		
		return false;
		break;

	default:
		break;
	}
	return true;
}

/*
	
	
	u`|Cgoiʉ߁j
	
	
*/
bool K7Stage133M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
//	int	pathno = GetBpPathNo(info);
//	if( pathno < 0 ){
//		return true;
//	}
	
	switch( evno ){
	case	K7EVENTNO(011501):					// R[eWv
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_EVFL_011601) == false ){			// `O
			// SE
			gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
		}
		return false;
		break;
	}
	
	return true;
}

// ̐ݒ
bool K7Stage133M00::SetCurrentCallBack(void)
{
	pNpcSu = (K7EnmK *)WK7Npc::Find(ENENO_1_133M00_1);
	
	//V^HSЉ
	if( false == HereComeANewHS(	PR_HS_LEGG,
									ENENO_1_133M00_5,								// GID
									NULL,
									CAM133M00_HS_PRESEN_START,
									CAM133M00_HS_PRESEN_END,
									0,
									209,  276, -40,  53, 787, 209 )				// OЉp
	){
		SetManualBranch(false);
//		return( false );
	}
	
	if ( pNpcSu != NULL ) {
		while( pNpcSu->SetUpTest()==false ){
			K7SCR_RETSYS();
		}
		pNpcSu->HitObjMake(WK7Stage::GetCurrentStage(), CORE_NUM);
	}
	
	SetCurrentCallBackDefaultProc();
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(133,0) ){
		Vec pcPos;
		
		WK7PLAYERCONTROL->GetPosition(pcPos);
		if ( pcPos.y > 20.f ){						// Gȍ
			WK7PLAYERCONTROL->SetMuteki();
		}else{
			WK7PLAYERCONTROL->ClearMuteki();
		}
		K7SCR_RETSYS();
	}
	
	return true;
}

// pXύX
bool K7Stage133M00::PathChangeCallBack(WK7PathChangeInfo  &info)
{
	WK7PathNurbs	*pPath = GetPathNurbs("curve18");
	
	if( pPath ==NULL )	return true;
	
	if( pPath==info.GetPath() ){
		SetStageMapFlag(0,true);
		GameInfo.SetMenuMapSubNo(0);			
	}
	return true;
}
