////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage203M01
//
// K7Stage203M01.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/23/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE203M01_CPP__

#include ".\K7Stage203M01.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Sato\SK7PanelBase.h"
#include "..\..\..\Scn\K7Scn02.h"
#include "..\..\..\Yam\YK7EffectLensFlare.h"

//`````````````````````````````````````````````````
//			RXgN^
//`````````````````````````````````````````````````
K7Stage203M01::K7Stage203M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage203M01_Camera );
}

//`````````````````````````````````````````````````
//			fXgN^
//`````````````````````````````````````````````````
K7Stage203M01::~K7Stage203M01()
{
	// n
	::DeleteEffect( LensFlare ) ;
	::ReleaseLensFlareTexture() ;
}

//`````````````````````````````````````````````````
//			NGCg
//`````````````````````````````````````````````````
bool K7Stage203M01::CreateCallBack(void)
{
	CreateOwnStageMotion( 0 );
	return true;
}

//`````````````````````````````````````````````````
//		iǂݍݏÎɑ΂鏉j
//`````````````````````````````````````````````````
bool	K7Stage203M01::InitializeCallBack( void )
{
	// YtA
	if( GetJObj("sun") != NULL )
	{
		::SetupLensFlareTexture() ;
		while( ::CheckLensFlareTexture() == FALSE ){
			K7SCR_RETSYS() ;
		}
		LensFlare = ::CreateLensFlareEffect( GetJObj("sun") ) ;
	}

	if(	K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020301 ) ){
		PlayMotion( 0, -1.0f );
		SimpleModelHide( "q_lamp_no" );
		SimpleModelHide( "q_lamp_ok" );
		SetMotionLoop( false );
	}else{
		SimpleModelDisp( "q_lamp_no" );
		SimpleModelHide( "q_lamp_ok" );
	}
	return true;
}


//`````````````````````````````````````````````````
//			Jg
//`````````````````````````````````````````````````
bool K7Stage203M01::SetCurrentCallBack(void)
{
	return true;
}


//`````````````````````````````````````````````````
//			Cxg
//`````````````````````````````````````````````````
bool K7Stage203M01::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case 	K7EVENTNO(020303):
	case 	K7EVENTNO(020304):
	case 	K7EVENTNO(020305):
	case 	K7EVENTNO(020306):
	case 	K7EVENTNO(020307):
	case 	K7EVENTNO(020308):
	case 	K7EVENTNO(020309):
		K7SCR_PANEL_SETPANELEVNO_NOPARAM(info.mEventNo);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
				
	default:
		return true;
	}

	return false;
}

//`````````````````````````````````````````````````
//			hACxg
//`````````````````````````````````````````````````
bool K7Stage203M01::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
		
//		NCYpl		
	case	K7EVENTDOOR(020301):
		if(	!K7SCR_GET_SCENARIO_FLAG( K7SCN02_DRFL_020301 ) ){
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			K7SCR_PC_SETVISIBLE( false );
			WK7PLAYERCONTROL->SetEnable(false);

			FixCam( 1 );
			K7SCR_TIMEWAIT( 4800*2 );
			
			K7SCR_PANEL_SETPANELEVNO( K7EVENTNO(020301), 0 );		//	Q[gpX[hpl
			K7SCR_PANEL_START();
			K7SCR_PANEL_TERMWAIT();
			K7SCR_RETSYS();
			K7SCR_PANEL_EXIT();
			K7SCR_PANEL_EXITWAIT();
			FixCam( 1 );

			if( K7SCR_PANEL_GETRESULT() == 0 ){					//	
				gpSound->mPlaySE( SFX_SCE2_QUIZPANEL_LAMP );
				SimpleModelDisp( "q_lamp_ok" );
				SimpleModelHide( "q_lamp_no" );
				//	bZ[W
				K7SCR_STGC_MESSAGE_B( 0 );
				FixCam( 0 );
				K7SCR_PC_SETVISIBLE( false );
				//Jݒ
				K7SCR_SET_SCENARIO_FLAG( K7SCN02_DRFL_020301 );			
				K7SCR_RETSYS();
				K7SCR_TIMEWAIT( 4800*2 );
				//[VX^[g
				gpSound->mPlaySE( SFX_SCE2_QUIZ_UNLOCK );
				PlayMotion( 0, 0.0f );
				SetMotionLoop( false );
				while( GetMotionState()!=WK7MODEL_NOANIM ){
					K7SCR_RETSYS();
				}
				K7SCR_TIMEWAIT( 4800*1 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				WK7PLAYERCONTROL->SetEnable(true);
				return true;
			}else{
				//	bZ[W
				K7SCR_STGC_MESSAGE_B( 1 );
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
				WK7PLAYERCONTROL->SetEnable(true);
				return false;
			}
		}else{
			return true;
		}
		break;
	}
	return false;
}

