////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage300M00 
//
// K7Stage300M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE300M00_CPP__

#include "..\..\..\Scn\K7Scn03.h"
#include ".\K7Stage300M00.h"
#include "..\..\..\Wat\WK7Event.h"
#include "..\..\..\Panel\SK7PanelVisitor.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Yam\YK7EffectBillboard.h"
#include "..\..\..\Yam\YK7EffectConfetti.h"

K7Stage300M00::K7Stage300M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage300M00_Camera );
}

K7Stage300M00::~K7Stage300M00()
{
}


/*
	
	
	NGCg
	
	
*/
bool K7Stage300M00::CreateCallBack(void)
{
	// r{[h̃eNX`f[^ǂݍ
	while( WK7RenderObj::CreateEffectBillResource(BILLEFF_BALLOON)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}



/*
	
	
	
	
*/
bool K7Stage300M00::InitializeCallBack(void)
{
	int i;

	for (i=0; i<K7STAGE300_BALLOON_MAX; i++){
		pBalloon[i] = NULL;
	}
	return true;
}


/*
	
	
	DJn
	
	
*/
void K7Stage300M00::BalloonPlay(void)
{
	int i;
	
	for (i=0; i<K7STAGE300_BALLOON_MAX; i++){
		pBalloon[i] = CreateBillBoardEffect(BILLEFF_BALLOON, BalloonPos[i], BALLOON_MAX_Y, VParam[ED_BALLOON][14]);
	}
}


/*
	
	
	DJn
	
	
*/
void K7Stage300M00::BalloonStop(void)
{
	int i;

	for(i=0 ; i<K7STAGE300_BALLOON_MAX ; i++){
		if ( pBalloon[i] != NULL ){
			ReleaseEffect(pBalloon[i]);
		}
	}
}


/*
	
	
	I
	
	
*/
bool K7Stage300M00::TerminateCallBack(void)
{
	BalloonStop();
	// r{[h̃eNX`f[^̊J
	while( WK7RenderObj::ReleaseEffectBillResource(BILLEFF_BALLOON)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}


/*
	
	Jg
	
	
*/
bool K7Stage300M00::SetCurrentCallBack(void)
{
//	Vec eye;
//	EFFECT *pEfc;

	SetCurrentCallBackDefaultProc();								// Ȗ炷
	
	WK7Stage::SetCurrentPath(	WK7Stage::GetPathNurbsAll("curve2"),
								0.894f,
								1,									// Forward
//								WK7PATHINFO_INITDIR_TGTDIR			// 
								WK7PATHINFO_INITDIR_TGTDIR_REV		// wォ
	);
	
	// ԂтGtFNgJn
//	WK7CAM->GetPosition(eye);
//	pStageEfc = CreateEffectConfetti(eye, 2000);
//	pStageEfc = NULL;
	
	// DJn
	BalloonPlay();
	
	// ԂтGtFNg
	while( K7SCR_STG_GET_CURRENTID() == K7STGID(300,0) ){
//		if ( pStageEfc != NULL ){
//			pEfc = pStageEfc->GetEffect();
//			WK7CAM->GetPosition(eye);
//			SetConfettiEffectPoint(pEfc, eye);
//		}
		
		K7SCR_RETSYS();
	}
	return true;
}


/*
	
	Cxg
	
*/
bool K7Stage300M00::EventCallBack(WK7EventInfo &info)
{
	ePanelID panelNo;

	switch( info.mEventNo ){
	case	K7EVENTNO(030101):
		panelNo	 = ePanel030101;
		goto PANEL_GO;
	case	K7EVENTNO(030103):
		panelNo	 = ePanel030103;
		goto PANEL_GO;
	case	K7EVENTNO(030104):
		panelNo	 = ePanel030104;
		goto PANEL_GO;
	case	K7EVENTNO(030105):
		panelNo	 = ePanel030105;
		goto PANEL_GO;
	case	K7EVENTNO(030106):
		panelNo	 = ePanel030106;

PANEL_GO:
		// EVENT_030101 Ґpli邾j
		K7SCR_PANEL_SETPANELID_NOPARAM(panelNo);
		
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		K7SCR_EVCONDCHANGE();
		break;
	default:
		return true;
	}
	
	return false;
}

bool K7Stage300M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32	evno = GetBpEventNo(info);
	if( evno==0xffffffff ){
		return true;
	}
//	int	pathno = GetBpPathNo(info);
//	if( pathno < 0 ){
//		return true;
//	}
	
	switch( evno ){
	case	K7EVENTNO(030001):											// ĎJ
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN03_EVFL_030001)==FALSE ){
			if ( WK7PLAYERCONTROL->GetMainID() != K7CAT ){
				
				K7SCR_SET_SCENARIO_FLAG(K7SCN03_EVFL_030001);
				
				// L|[Y
				K7SCR_ENTER_PLAYMODE();
				K7SCR_ENTER_DEMOPAUSE();
				
				K7SCR_NOISE_REQUEST();
				FixCam(ONESHOTCAM_030001_0);
				K7SCR_NOISE_RELEASE();
				
				// Wait
				K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(2));
				
				WatchCameraB( K7Stage300M00_Camera[ONESHOTCAM_030001].tgt,
							  K7Stage300M00_Camera[ONESHOTCAM_030001].pos,
							  K7CHRID(K7CAT,0), 1 );
				return true;
			}
		}
		break;
	}
	return false;
}
