////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage313M00
//
// K7Stage313M00.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE313M00_H__
#define	__K7STAGE313M00_H__

#include "..\K7Stage.h"

#define STG313M00LAMP_MAX		(4)

struct Stg313M00Lamp{
	WK7RenderObjEffect	*mpEffect[STG313M00LAMP_MAX];
	Vec					pos      [STG313M00LAMP_MAX];
	WK7JObj				*mpJObj  [STG313M00LAMP_MAX];
};

class K7Stage313M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	K7Stage313M00();
	K7Stage313M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~K7Stage313M00();
	
	virtual bool CreateCallBack    (void);
	virtual bool InitializeCallBack(void);
	virtual bool CondChangeCallBack(void);
	virtual bool TerminateCallBack (void);
	virtual bool SetCurrentCallBack(void);
	virtual bool EventCallBack     (WK7EventInfo     &);
	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);
	virtual bool ZanEventCallBack(WK7ZanEventInfo &);
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &){ return true; }		// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
	virtual bool BpLeaveCallBack   (WK7BpInfo        &);
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// Cxg|Cg
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

};

#ifdef __K7STAGE313M00_CPP__

static const char	*pLampObjName[STG313M00LAMP_MAX] = {
	"event_000503",
	"event_000504",
	"event_000505",
	"event_000506",
};

enum K7STAGE313M00_ONESHOTCAM{
	EV_030707,
	EV_030708,
	EV_030708_2,
	JUMP_0,
	JUMP_1,
};


K7StageEventOneShotCamera K7Stage313M00_Camera[] = {
	{{-604.264f, 185.606f, -2255.982f},{-584.623f, 176.965f, -2236.356f}},				// \t@[[hւ̔JƂ
	{{-555.525f, 208.938f, -2242.548f},{-542.612f, 203.936f, -2244.630f}},				// ĎJAbv
	{{-540.372f, 198.120f, -2251.751f},{-548.957f, 207.336f, -2245.630f}},				// ĎJ̃L`FWp
	{{-327.692f, 182.400f, -2260.314f},{-342.790f, 197.546f, -2260.199f}},				// WvJn
	{{-325.747f, 221.091f, -2266.375f},{-339.641f, 231.128f, -2279.163f}},				// Wvn
};

#endif

#endif	//__K7STAGE313M00_H__

