////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage444M01 yh~jJzu
//
// K7Stage444M01.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/07/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE444M01_CPP__

#include "..\..\..\Scn\K7Scn04.h"
#include ".\K7Stage444M01.h"
#include "..\..\..\sato\SK7Special.h"
#include "..\..\..\Kaw\KK7Sound.h"
#include "..\..\..\Wat\WK7SceneBlur.h"

//[V
#define	MOT444M01_WINDMILL_START		(0)		//ԉ]
#define	MOT444M01_WINDMILL				(1)		//ԉ]
#define	MOT444M01_WINDMILL_DOOR_OPEN	(2)		//J
//f
#define	MDL444M01_WINDMILL		"windmill"		//
#define	MDL444M01_DOOR			"gate"			//ԂŊJ
//bZ[W
#define	MES444M01_DOOR_OPEN				(0)		//J
#define	MES444M01_USE_WIND_RING			(1)		//̎wւg
#define	MES441M01_RIDDLE_WINDRING		(2)		//ԑOŕ̎wւg




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage444M01::K7Stage444M01(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	SetOneShotCamLocTbl( K7Stage444M01_Camera );
	mWindMillWorking = false;
	mAmbPlaySE       = false;
	mOldBlurVisible  = SceneBlur.GetVisible();
	SceneBlur.SetVisible( false );
	mpEffectLensFlare = NULL;
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage444M01::~K7Stage444M01()
{
	SceneBlur.SetVisible( mOldBlurVisible );
	ReleaseEffectLensFlare();
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage444M01::CreateCallBack( void )
{
	CreateOwnStageMotion( MOT444M01_WINDMILL_START );
	CreateOwnStageMotion( MOT444M01_WINDMILL );
	// YtA
	SetupEffectLensFlare();
	return( true );
}

bool
K7Stage444M01::InitializeCallBack( void )
{
	while( CheckSetupEffectLensFlare()==false ){
		K7SCR_RETSYS() ;
	}
	mpEffectLensFlare = CreateEffectLensFlare("sun_alpha");
	return true;
}


//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage444M01::CondChangeCallBack( void )
{
	WK7JObj*		pJObj;
	
	//Ԃ񂵂
	if( K7SCR_GET_SCENARIO_FLAG(EV040404) == false )
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040404), true );
		SimpleSetStartMotion( MDL444M01_WINDMILL, MOT444M01_WINDMILL_START );
		mWindMillWorking = false;
	}else
	{
		K7SCR_EVNO_SETENABLE( K7EVENTNO(040404), false );
		if( mWindMillWorking == false )
		{
			pJObj = PlayMotion( MDL444M01_WINDMILL, MOT444M01_WINDMILL );
			pJObj->SetMotionLoop( true ,true, true );
			mWindMillWorking = true;
		}
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Iȉj
//------------------------------------------------------------------------------
bool
K7Stage444M01::TerminateCallBack( void )
{
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage444M01::SetCurrentCallBack( void )
{
	mWindMillWorking = false;
	
	if( mAmbPlaySE == false )
	{
		KK7SoundLoopSePlayVolumeChange((Vec){-340.422f, 65.114f, -543.521f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_SPARROW);
		if( K7SCR_GET_SCENARIO_FLAG(EV040404) == true )
		{
//			KK7SoundLoopSePlayVolumeChange((Vec){-457.705f, 80.450f, -820.673f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
			KK7SoundLoopSePlayVolumeChange((Vec){-420.472f, 75.387f, -785.974f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_WINDMILL_LOOP);
		}
		mAmbPlaySE = true;
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//Cxg
//------------------------------------------------------------------------------
bool
K7Stage444M01::EventCallBack( WK7EventInfo & info )
{
	switch( info.mEventNo )
	{
		//
		case	K7EVENTNO( 040404 ):
			if( K7SCR_GET_SCENARIO_FLAG(EV040404) == false )
			{
				//inGame~
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( false );
				//̎wւ𑕔ĂȂ
				if( K7SCR_EVEQUIPRING(RING_WIND) == false )
				{
					FixCamMesWithRiddle( CAM444M01_WINDMILL, MES441M01_RIDDLE_WINDRING );
				}else
				{
					WindMillWorking();
				}
				//inGameĊJ
				K7SCR_EXIT_PLAYMODE();
				K7SCR_EXIT_DEMOPAUSE();
				K7SCR_PC_SETVISIBLE( true );
			}
			break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );

}

//------------------------------------------------------------------------------
//Ԃ
//------------------------------------------------------------------------------
#define	STG444M01_WINDMILL_MOVE_SEC	(8.0f)	//ԂSEɂ鎞
void
K7Stage444M01::WindMillWorking( void )
{
	WK7JObj*		pJObj;
	WK7Stage*		pStage;
	WK7ModelMotion*	pMotion;
	u32				stgid;
	f32				frame = 1.0f;
	int				seId;
	f32				pitch;
	f32				vol;
	s32				tick;
	u8				streamVol;
	
	//---- ԍ쓮 ----
	//@]
	pMotion = GetOwnModelMotion( MOT444M01_WINDMILL_START );
	if( pMotion != NULL )
	{
		frame = pMotion->GetTotalMotionFrame();
	}
	//Jݒ
	FixCam( CAM444M01_WINDMILL_START );
	K7SCR_STGC_MESSAGE_B( MES444M01_USE_WIND_RING );
	streamVol = gpSound->mGetVolumeStream();
	gpSound->mFadeVolumeStream( (u8)(streamVol*30/100), 200 );
	gpSound->mPlaySE( SFX_SYS_RING_WIND_COMMON );
	//Jړ@WK7CAM_LINIP_LINPATH
	WK7CAM->StartLinearInterpolateOnLinearPath( mpOneShotCamera[CAM444M01_WINDMILL_END].pos,
												mpOneShotCamera[CAM444M01_WINDMILL_END].tgt,
												frame );
	//ԍ쓮
	//SimplePlayMotionB( MDL444M01_WINDMILL, MOT444M01_WINDMILL_START );
	if( (pJObj=PlayMotion(MDL444M01_WINDMILL,MOT444M01_WINDMILL_START)) != NULL )
	{
		pJObj->SetMotionLoop( false );
	}
	
	//Ԃʉ
	tick = WK7_SEC_TO_TICK( STG444M01_WINDMILL_MOVE_SEC );
	pitch = -1200.0f;
	vol   =     1.0f;
	seId = gpSound->mPlaySEP( SFX_SCE4_WINDMILL_LOOP, (s16)pitch, (u8)vol );
	while( tick )
	{
		K7SCR_RETSYS();
		tick  = tick - WK7_TICK_PER_FRAME;
		if( tick <= 0 )
		{
			tick = 0;
		}else
		{
			vol = vol + ((f32)SOUND_SYSTEM_SE_VOLUME - 1.0f) / (f32)(WK7_SEC_TO_FRAME(STG444M01_WINDMILL_MOVE_SEC));
			if( vol > (f32)SOUND_SYSTEM_SE_VOLUME )vol = (f32)SOUND_SYSTEM_SE_VOLUME;
			pitch = pitch + (1200.0f / (f32)(WK7_SEC_TO_FRAME(STG444M01_WINDMILL_MOVE_SEC)));
			if( pitch > 0.000f )pitch = 0.000f;
			if( seId != -1 )
			{
				gpSound->mSetVolumeSENo( seId, (u8)vol, 1 );
				gpSound->mSetPitchSENo( seId, (s16)pitch );
			}
		}
	}
	
	//[VĐ܂ŃEGCg
	while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
	{
		K7SCR_RETSYS();
	}
	
	//---- J ----
	//---- Stage444M00Ăяo ----
	//mCY
	K7SCR_NOISE_REQUEST();
	gpSound->mStopSE( SFX_SCE4_WINDMILL_LOOP );
	K7SCR_PC_SETVISIBLE( false );
	//Xe[WIDݒ
	stgid = K7STGID( 444, 0 );
	//444M01Xe[W
	K7SCR_STG_VISIBLE( mID, false );
	//444M00Xe[WĂяo
	K7SCR_STG_CREATE_B( stgid );
	//444M00Xe[W\
	K7SCR_STG_VISIBLE( stgid, true );
	//Xe[W[V
	pStage = WK7Stage::GetStage( stgid );
	pStage->CreateOwnStageMotion( MOT444M01_WINDMILL_DOOR_OPEN );
	while( pStage->IsOwnMotionObjLoaded() != true )
	{
		K7SCR_RETSYS();
	}
	//Xe[W̕Ԃ
	if( (pJObj=pStage->PlayMotion(MDL444M01_WINDMILL,MOT444M01_WINDMILL)) != NULL )
	{
		pJObj->SetMotionLoop( true );
	}
	// Jς
	FixCam( CAM444M01_DOOR );
	//mCY
	K7SCR_NOISE_RELEASE();
	//J
	gpSound->mPlaySE( SFX_SCE4_TREVOR_GATE_OPEN );
	if( (pJObj=pStage->PlayMotion(MDL444M01_DOOR,MOT444M01_WINDMILL_DOOR_OPEN)) != NULL )
	{
		pJObj->SetMotionLoop( false );
		while( pJObj->GetMotionState(false,true) != WK7MODEL_NOANIM )
		{
			K7SCR_RETSYS();
		}
	}
	K7SCR_STGC_MESSAGE_B( MES444M01_DOOR_OPEN );
	//inGame~
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	//---- Stage444M01ɖ߂Ă ----
	//mCY
	K7SCR_NOISE_REQUEST();
	gpSound->mFadeVolumeStream( streamVol, 200 );
	//444M00Xe[W
	K7SCR_STG_VISIBLE( stgid, false );
	//444M00Xe[W
	K7SCR_STG_RELEASE( stgid );
	//444M01Xe[W\
	K7SCR_STG_VISIBLE( mID, true );
	//LN^\
	K7SCR_PC_SETVISIBLE( true );
	//JPCtH[ɖ߂
	WK7CAM->SetMode( WK7Cam::WK7CAM_PATH_FOLLOW );
	//Ԃ񂵂tOON
	K7SCR_SET_SCENARIO_FLAG( EV040404 );
	//ԃ[v[Vݒ
	K7SCR_EVCONDCHANGE();
	//Ԃ3D炷
//	KK7SoundLoopSePlayVolumeChange((Vec){-457.705f, 80.450f, -820.673f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_AMB_WIND);
	KK7SoundLoopSePlayVolumeChange((Vec){-457.705f, 80.450f, -820.673f}, K7SCR_STG_GET_CURRENTID(), SFX_SCE4_WINDMILL_LOOP);
	//mCY
	K7SCR_NOISE_RELEASE();
}

