////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage514M00
//
// K7Stage514M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE514M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage514M00.h"

K7Stage514M00::K7Stage514M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mElevDoorEventNo = K7EVENTDOOR(051401);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage514M00_Camera);
	K7SCR_RESET_SCENARIO_FLAG(K7SCN05_ENFL_404);
	K7SCR_RESET_SCENARIO_FLAG(K7SCN05_ENFL_406);
	if( GetPrevStageID()==K7STGID(524,0) ){
		const char	*pPrevName;
		if( (pPrevName=GetPrevStagePathName())==NULL ){
			pPrevName = GetPrevStageBpName();
		}
		if( pPrevName!=NULL ){
			if( strcmp(pPrevName,"branch3")==0 ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN05_ENFL_404);
			}else if( strcmp(pPrevName,"branch1")==0 ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN05_ENFL_406);
			}
		}
	}
}

K7Stage514M00::~K7Stage514M00()
{
}

bool K7Stage514M00::CreateCallBack(void)
{
	CreateMotion();
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage514M00::InitializeCallBack(void)
{
	InitElevEvent();
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(515,0),"door_051502");
	return true;
}

bool K7Stage514M00::SetCurrentCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
	}
	StartElevEvent();
	return false;
}

bool K7Stage514M00::CondChangeCallBack(void)
{
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051402),false);
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
	}else{
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090402))==true ){
			OpenElevDoor(true);
		}else{
			CloseElevDoor(true);
		}
	}
	return true;
}

bool K7Stage514M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051401):
//	case	K7EVENTDOOR(051402):
		if( ElevEvent(info,4) < 0 ){
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

