////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage516M00
//
// K7Stage516M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE516M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage516M00.h"

#define	K7STAGE516M00_LOCK_ON			"cyo_padlock_on"	//̂Ă
#define	K7STAGE516M00_LOCK_OFF			"cyo_padlock_off"	//̊JĂ

K7Stage516M00::K7Stage516M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mElevDoorEventNo = K7EVENTDOOR(051601);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage516M00_Camera);
}

K7Stage516M00::~K7Stage516M00()
{
}

bool K7Stage516M00::CreateCallBack(void)
{
	CreateMotion();
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage516M00::InitializeCallBack(void)
{
	InitElevEvent();
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(517,0),"door_051702");
	return true;
}

bool K7Stage516M00::SetCurrentCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
	}
	StartElevEvent();
	return false;
}

bool K7Stage516M00::CondChangeCallBack(void)
{
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051602),false);
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
	}else{
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090702))==true ){
			OpenElevDoor(true);
		}else{
			CloseElevDoor(true);
		}
		SetZanEventEnable(K7EVENTZAN(051125),false);
	}
	K7SCR_STG_SET_PATHENABLE("curve10",false);
	//R[êJ
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051601)==false ){
		DispJObj(K7STAGE516M00_LOCK_ON ,false,true);
		HideJObj(K7STAGE516M00_LOCK_OFF,false,true);
	}else{
		HideJObj(K7STAGE516M00_LOCK_ON ,false,true);
		DispJObj(K7STAGE516M00_LOCK_OFF,false,true);
	}
	return true;
}

bool K7Stage516M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	bool	ret;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051603):
		if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
			break;
		}
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051601)==false ){
//			u32		mesid;
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			
			FixCam(DOOR_051603);
			
			if( WK7PLAYERCONTROL->HasSpAbility(PC_SPA_PICKING_TOOL)==true ){
				K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051601);
//				mesid = K7SCR_SYSMES_OPEN_KEY;
				ret   = true;
				
				// R[esbLOANV
				Vec camTgt = {112.022f, 4.886f, -493.119f};
				Vec camPos = {82.260f, 24.835f, -473.071f};
				Vec pcPos  = { 99.0f , 0.f,     -486.217f};
				f32 pcRotY = 0.f;
				WK7PLAYERCONTROL->WK7PlayerCyoPicking(PICKING_516M00, &camTgt, &camPos, &pcPos, pcRotY, SFX_PC_CYO_PICKING,true);
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
				info.SetCinemaScopeClear(true);
			}else{
//				mesid = K7SCR_SYSMES_CLOSED_BY_KEY;
				ret   = false;
			}
			
			if ( true == ret ){
				K7SCR_PC_SETVISIBLE(false);
				
				FixCam(ONESHOTCAM_PICKINGOK);
				K7SCR_EVCONDCHANGE();
				
				K7SCR_TIMEWAIT( K7SCR_EVENT_RESULT_DISP_TICK );
//				K7SCR_SYS_MESSAGE_B(K7SCR_SYSMES_OPEN_KEY);
				
			}else{
				K7SCR_STG_MESSAGE_B(K7STAGE516M00_MES_LOCK);
			}
			K7SCR_PC_SETVISIBLE(true);
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			K7SCR_EVCONDCHANGE();
			
			return ret;
		}
		break;
	case	K7EVENTDOOR(051601):
//	case	K7EVENTDOOR(051602):
		if( ElevEvent(info,6) < 0 ){
			return false;
		}
		break;
	default:
		break;
	}
	return true;
}

