////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage517M00
//
// K7Stage517M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE517M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage517M00.h"
#include "..\..\K7Stage578M00.h"
#include "..\..\..\Sato\SK7SpecialData.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Yam\YK7EffectPetal.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Kaw\KK7Sound.h"

K7Stage517M00::K7Stage517M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelElev(pAnchor,prio)
{
	mpPetalEffect    = NULL;
	mElevDoorEventNo = K7EVENTDOOR(051701);
	mElevCamID       = ELEVCAM;
	mElevPlayerPosID = ELEVPLAYER;
	SetOneShotCamLocTbl(K7Stage517M00_Camera);
}

K7Stage517M00::~K7Stage517M00()
{
	ReleasePetal();
}

bool K7Stage517M00::CreateCallBack(void)
{
	CreateMotion();
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return K7StageHotelBase::CreateCallBack();
}

bool K7Stage517M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage517M00::CreatePetal(void)
{
	if( IsValidEffect(mpPetalEffect)==true ){
		return true;
	}
	WK7JObj		*pFlowerCollision;
	if( (pFlowerCollision=GetJObj( "FlowerCollision" ))==NULL ){
		return true;
	}
static	Vec	Pos = { -97.068F, 0.0F, -274.225F };
	WK7RenderObjEffectInfo	info;
	info.Create();
	mpPetalEffect = CreateEffect(CreatePetalEffect( 
						Pos,				// SW
						pFlowerCollision,
						0.0F,									// IuWFNgzu͈( JObj ȏꍇɎg( ݂͔Ή ) )
						VParam[ED_PETAL][0] * 0.01F,			// Pʖʐς̃IuWFNg̐

						41.0F,									// ԕق
						
						(f32)VParam[ED_PETAL][2] * PI_2 / 360.0F,	// 摜̉]x
						(f32)VParam[ED_PETAL][3] * 0.01F, 			// ԕق̑傫

						(s32)( (f32)VParam[ED_PETAL][4] * 0.001F * PI2DIV / 360 ),			// ]x
						(s32)( (f32)VParam[ED_PETAL][5] * PI2DIV / 360 ),		// ]ōx

						(f32)VParam[ED_PETAL][6] * 0.001F,			// ㏸x
						(f32)VParam[ED_PETAL][7] * 0.01F,			// ㏸ő呬x

						(f32)VParam[ED_PETAL][8] * 0.1F,				// ㏸n߂鋗
						(u16)( (f32)VParam[ED_PETAL][9] * PI2DIV / 360 ), (u16)( (f32)VParam[ED_PETAL][10] * PI2DIV / 360 ),	// ㏸n߂͈

						(f32)VParam[ED_PETAL][11] * 0.001F,			// k܂x
						(f32)VParam[ED_PETAL][12] * 0.1F		// k܂ōx
					),&info);
	return true;
}

bool K7Stage517M00::ReleasePetal(void)
{
	ReleaseEffect(mpPetalEffect);
	return true;
}

bool K7Stage517M00::InitializeCallBack(void)
{
	InitElevEvent();
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(516,0),"door_051601");
	return true;
}

bool K7Stage517M00::SetCurrentCallBack(void)
{
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_VOLUME);
	}
	StartElevEvent();
	return false;
}

bool K7Stage517M00::CondChangeCallBack(void)
{
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051701)==TRUE ){
		ReleasePetal();
	}else{
		CreatePetal();
	}
	if( mStageInit==false ){
		return true;
	}
	InitPath();
	bool		tamaevflag;
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		OpenElevDoor(true);
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051701)==FALSE || K7SCR_EVHASITEM(K7EVITEM_TAMA(051701))==TRUE ){
			tamaevflag = false;
		}else{
			tamaevflag = true;
		}
		SetZanEventEnable(K7EVENTZAN(052102),false);
	}else{
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090802))==true ){
			OpenElevDoor(true);
		}else{
			CloseElevDoor(true);
		}
		SetZanEventEnable(K7EVENTZAN(051126),false);
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (051701),!K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051701));
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051701),tamaevflag);
	RenewTamaEffect(K7EVENTTAMA(051701));
	SetVisibleTamaJObj(K7EVENTTAMA(051701),tamaevflag);
	return true;
}

bool K7Stage517M00::EventCallBack(WK7EventInfo &info)
{
	LOOPSE	*pLoopSE = NULL;
	u32		count;
	f32		roty;
	switch( info.mEventNo ){
	case	K7EVENTNO(051701):
		// oуCxg
		
		if( K7SCR_EVEQUIPRING(RING_WIND)==false ){
			
			FixCamWithRiddle(FLOWER);
			
			return false;
		}
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
//		K7SCR_PC_SETVISIBLE(false);
		K7SCR_STG_MESSAGE_B(K7STAGE517M00_MES_USE_WIND_RING);
		
		SetVisibleTamaJObj(K7EVENTTAMA(051701),true);
		
		FixCam(BLOW_FLOWER);
		
		if( IsValidEffect(mpPetalEffect)==true && mpPetalEffect->GetEffect()!=NULL ){
			SetPetalEffectStart(mpPetalEffect->GetEffect());
//			gpSound->mPlaySE(SFX_SCE5_HTL_VASE_BREAK);
			Vec		pos;
			WK7CAM->GetPosition(pos);
			pLoopSE = KK7SoundLoopSePlayVolumeChange(pos,K7SCR_STG_GET_CURRENTID(),SFX_SCE5_HTL_VASE_BREAK);
		}
		
static	f32		dist0 = 5.0f;
static	f32		ddist = 0.1f;
		f32		dist;
		for(count=WK7_SEC_TO_TICK(3.0f),roty=0.0f,dist=dist0 ; count>WK7_TICK_PER_FRAME ; count-=WK7_TICK_PER_FRAME,roty+=0.1f,dist+=ddist){
			if( pLoopSE != NULL ){
				WK7CAM->GetPosition(pLoopSE->pos);
				pLoopSE->pos.z += dist * cosf(roty);
				pLoopSE->pos.x += dist * sinf(roty);
			}
			if( roty >= PI ){
				roty -= TWO_PI;
			}
			K7SCR_RETSYS();
		}
//		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(3.0f));
		
//		K7SCR_STG_MESSAGE_B(K7STAGE517M00_MES_BLOW_FLOWER);				// Ԃт炪
		
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051701);
		K7SCR_EVCONDCHANGE();
		
//		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		
//		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051701);
//		K7SCR_EVCONDCHANGE();
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage517M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051701):
		if( ElevEvent(info,7) < 0 ){
			return false;
		}
#if 0
		if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
			// ֍sԂ̃L
			u32		playno = K7EVENTPLAY(05090803);
			WK7Play	*pPlay;
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::StorePlayTB();
			WK7PLAYERCONTROL->ReleaseArchive();
			WK7Stage::DeleteStage(this);
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				GHMGCTASK_RETSYS();
			}
			
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::SetPlayed(playno,true);
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			WK7Chara::SetRenderChara(true);
			WK7Stage::SetRenderStage(true);
			WK7Item::SetRenderItem  (true);
			
		}
#endif
		break;
	case	K7EVENTDOOR(051704):
		if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
			// Ln
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_BAN_HTL)==FALSE ){
			K7Stage578M00_PointInfo		*pPointInfo = K7Stage578M00::GetKihanShortCut(GameInfo.GetScenarioFlow(),1);
			if( pPointInfo==NULL ){
				info.mNextStageID = WK7STAGE_GMSTAGEID;
				info.mParam       = 1;
				strncpy(info.mNextBpName,WK7STAGE_GMSTAGE_BPNAME(1),WK7DOOREVENT_BPNAME_MAX-1);
				WK7Stage::SetCurrentStageParam(info.mParam);
			}
		}
		break;
	default:
		break;
	}
	return true;
}

