////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage519M00
//
// K7Stage519M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE519M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage519M00.h"
#include "..\..\K7Stage578M00.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\sato\SK7ScenarioEnd.h"

K7Stage519M00::K7Stage519M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage519M00_Camera);
}

K7Stage519M00::~K7Stage519M00()
{
}

bool K7Stage519M00::CondChangeCallBack(void)
{
	bool		doorFlag = true;
	
	// WNVʉ߂Ԃɂ
	K7SCR_STG_SET_JUNCTION_PASS(K7STGID(517,0),"door_051704");
	
	K7SCR_STG_SET_PATHENABLE("curve11",false);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090802))==true ){
			doorFlag = false;
		}
	}else{
		if( WK7Play::HasPlayed(K7EVENTPLAY(05040201))==true ){
			doorFlag = false;
		}
	}
	K7SCR_EVNO_SETENABLE(K7EVENTDOOR(051706),doorFlag);
	return true;
}

bool K7Stage519M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
static		const char		*pBpName   = "door_051706";
static		const char		*pPathName = "Acurve10";
//	WK7PlayEventInfo	playEventInfo;
	switch( info.mEventNo ){
	case	K7EVENTDOOR(051705):
		if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
			// Ln
//			if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_BAN_HTL)==FALSE ){
			K7Stage578M00_PointInfo		*pPointInfo = K7Stage578M00::GetKihanShortCut(GameInfo.GetScenarioFlow(),3);
			if( pPointInfo==NULL ){
				info.mNextStageID = WK7STAGE_GMSTAGEID;
				info.mParam       = 3;
				strncpy(info.mNextBpName,WK7STAGE_GMSTAGE_BPNAME(3),WK7DOOREVENT_BPNAME_MAX-1);
				WK7Stage::SetCurrentStageParam(info.mParam);
			}
		}
		break;
	case	K7EVENTDOOR(051706):
		// uho[
		if( GameInfo.GetScenarioFlow()==K7SCNF_HT2 ){
//			playEventInfo.Initialize();
//			playEventInfo.mEventNo = K7EVENTPLAY(05090802);
//			//CxgɔoĂɐݒ肵
//			SetCurrentPath(	GetPathNurbsAll("Acurve10"),
//							2.000f,
//							1,									// 0:forward 1:back
//							WK7PATHINFO_INITDIR_TGTDIR );		// : wォ:WK7PATHINFO_INITDIR_TGTDIR_REV
//			PlayEventTask(playEventInfo);
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			u32		playno = K7EVENTPLAY(05090802);
			WK7Play	*pPlay;
			
			gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN);
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			WK7PLAYERCONTROL->ReleaseArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				GHMGCTASK_RETSYS();
			}
			
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			WK7Play::StorePlayTB();
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			pPlay->SetVisibleAll(false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			GHM_SAFE_DELETE(pPlay);
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			WK7PLAYERCONTROL->RestoreArchive();
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
				GHMGCTASK_RETSYS();
			}
			
			WK7Play::SetPlayed(playno,true);
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			WK7StagePlaceInfo*	pPlaceInfo;
			
			K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR(pBpName,pPathName,0.0f,WK7PATHINFO_INITDIR_TGTDIR);
			
			WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
			
			pPlaceInfo = GetPlaceInfo(pBpName);
			SetCameraStartPosition(pPlaceInfo);
			while( SandRelease(pPlaceInfo,SFX_SCE5_MAP_CHANGE_DOOR_IRON_CLOSE)==false ){
				K7SCR_RETSYS();
			}
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			K7SCR_EVCONDCHANGE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			
			return false;
		}else{
			
			// zePڏIII
			
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			
			if( WK7PLAYERCONTROL->GetMainID()!=K7GAL ){
				
				FixCam( GALCHANGE0 );
				K7SCR_STG_SET_CURRENT_PATH_TOBP_PARAM_DIR(pBpName,pPathName,0.0f,WK7PATHINFO_INITDIR_TGTDIR_REV);
				
				K7SCR_TIMEWAIT( 4800 * 2 );
				
				WatchCameraB( K7Stage519M00_Camera[GALCHANGE1].tgt,
							  K7Stage519M00_Camera[GALCHANGE1].pos,
							  K7CHRID(K7GAL,0), 1 );
				
				K7SCR_ENTER_PLAYMODE_B();
				K7SCR_ENTER_DEMOPAUSE();
			}
			
//			playEventInfo.Initialize();
//			playEventInfo.mEventNo = K7EVENTPLAY(05040201);
//			PlayEventTask(playEventInfo);
			
			WK7Play		*pPlay;
			u32			playno = K7EVENTPLAY(05040201);
			SK7ScenarioEnd	scnEnd;
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,SFX_SCE5_MAP_CHANGE_DOOR_IRON_OPEN)==false ){
				K7SCR_RETSYS();
			}
			gpSound->mFadeVolumeStream( 0, 80 );
			K7SCR_TIMEWAIT( 2400 );
			
			WK7Chara::SetRenderChara(false);
			WK7Stage::SetRenderStage(false);
			WK7Item::SetRenderItem  (false);
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			WK7Play::StorePlayTB();
			WK7PLAYERCONTROL->ReleaseArchive();
			WK7Stage::DeleteStage(this);
			while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
				GHMGCTASK_RETSYS();
			}
			
			while( (pPlay=WK7Play::Create(playno))==NULL ){
				K7SCR_RETSYS();
			}
			pPlay->Prepare();
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PREPARED ){
				K7SCR_RETSYS();
			}
			scnEnd.LoadData();
			pPlay->Start();
			K7SCR_RETSYS();
			while( gpNoise->mSandRelease()==false ){
				K7SCR_RETSYS();
			}
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				K7SCR_RETSYS();
			}
			
			while( pPlay->GetState()!=WK7Play::PLAYED ){
				K7SCR_RETSYS();
			}
			
//			pPlay->SetVisibleAll(false);
//			K7SCR_RETSYS();
//			K7SCR_RETSYS();
//			GHM_SAFE_DELETE(pPlay);
			WK7Play::PlayReleaseAll();
			K7SCR_RETSYS();
			WK7Play::RestorePlayTB();
			K7SCR_RETSYS();
			K7SCR_RETSYS();

			gpSound->mStopStream();
			scnEnd.FrameProcess();
			
//			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
//				K7SCR_RETSYS();
//			}
			k7app.FadeStart(0,0);
			K7SCR_RETSYS();
			scnEnd.Release();
			
			WK7Play::SetPlayed(playno,true);
			
//			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//				K7SCR_RETSYS();
//			}
			
			WK7Chara::SetRenderChara(true);
			WK7Stage::SetRenderStage(true);
			WK7Item::SetRenderItem  (true);
			
//			// }bvړ
//			gpSound->mStopStream();
//			K7SCR_NOISE_RELEASE_TO_MAP();
//			GameInfo.MapSelectInit(MAP_HOTEL,MAP_GAL_HOME);
//			while( GameInfo.CheckMapSelectEnd()==false ){
//				K7SCR_RETSYS();
//			}
//			GameInfo.MapSelectEnd();
			
			K7SCR_MOON_START2();
			K7SCR_MOON_WAIT();
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
				K7SCR_RETSYS();
			}
			K7SCR_RETSYS();
			K7SCR_RETSYS();
			
			GameInfo.SetScenarioFlow(K7SCNF_SCL);
			K7SCR_CHANGE_SCENARIO_DATA();
			// LN^X^[gn_Zbg
			WK7PLAYERCONTROL->ChangeStartChkPoint();
			
			GalEnter(info);
			
		}
		break;
	default:
		break;
	}
	return true;
}

