////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage524M00
//
// K7Stage524M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE524M00_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7Stage524M00.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7EffectEasyAnim.h"
#include "..\..\..\Yam\YK7EffectDraft.h"

#define	K7STAGE524M00_BROKENWALL_WINDNAME	"wind01"
//W
#define	POS524M00_CRACK				((Vec){-24.889f, 13.696f, -119.087f})	//ǂЂъW

K7Stage524M00::K7Stage524M00(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	SetOneShotCamLocTbl(K7Stage524M00_Camera);
	mpWindEffect = NULL;
	mSubNo = -1;
}

K7Stage524M00::~K7Stage524M00()
{
}

bool K7Stage524M00::CreateCallBack(void)
{
	//LLGtFNg
	while( WK7RenderObj::CreateEffectAnimResource(ANIMID_SMALLLIGHT)==NULL ){
		K7SCR_RETSYS();
	}
	return true;
}

bool K7Stage524M00::TerminateCallBack(void)
{
	WK7RenderObj::ReleaseEffectAnimResource(ANIMID_SMALLLIGHT);
	return true;
}

bool K7Stage524M00::SetCurrentCallBack(void)
{
	gpSound->mSetDspRateAll(20);
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT1 ){
		gpSound->mPlayStreamEx(HPS_HOTEL_A,K7SCR05_HOTEL_ROOM_VOLUME);
	}else{
		gpSound->mPlayStreamEx(HPS_HOTEL_B,K7SCR05_HOTEL_ROOM_VOLUME);
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	
	Vec		pos;
	WK7PLAYERPATHCONTROL->GetCurrentPosition(&pos);
	if( pos.x < -100.0f ){
		mSubNo = 1;
	}else{
		mSubNo = 0;
	}
	SetStageMapFlag(mSubNo,true);
	GameInfo.SetMenuMapSubNo((s8)mSubNo);
	
	K7SCR_EVCONDCHANGE();
	return false;
}

bool K7Stage524M00::CharaChangeCallBack(WK7CharaChangeInfo &info)
{
#pragma	unused(info)
	K7SCR_EVCONDCHANGE();
	return true;
}

bool K7Stage524M00::CondChangeCallBack(void)
{
	bool		tamaevflag,evKed;
	InitPath();
	WK7JObj		*pWindJObj;
	EFFECT		*pWindEffect;
	bool		wind,wall;
	pWindJObj = GetJObj(K7STAGE524M00_BROKENWALL_WINDNAME);
	K7SCR_JOBJ_HIDE(pWindJObj);
	if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051401)==true ){
		wind = false;
		wall = false;
	}else{
		wall = true;
		if( WK7PLAYERCONTROL->GetMainID()==K7CAT ){
			wind = true;
		}else{
			wind = false;
		}
	}
	switch( mSubNo ){
	case	0:
		break;
	default:
		wind = false;
		break;
	}
	if( GameInfo.GetScenarioFlow()==K7SCNF_HT1 ){
		evKed = false;
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051401)==FALSE || K7SCR_EVHASITEM(K7EVITEM_TAMA(051401))==TRUE ){
			tamaevflag = false;
		}else{
			tamaevflag = true;
		}
	}else{
		wind = false;
		wall = false;
		tamaevflag = false;
		if( WK7Play::HasPlayed(K7EVENTPLAY(05090402))==true ){
			evKed = false;
			K7SCR_SET_SCENARIO_FLAG( K7SCN05_CGFL_052400 );
		}else{
			evKed = true;
		}
		SetZanEventEnable(K7EVENTZAN(051124),false);
		SetZanEventEnable(K7EVENTZAN(051140),false);
	}
	if( pWindJObj!=NULL ){
		if( wind==true && GetCurrentStageID()==mID ){
			// \
			if( IsValidEffect(mpWindEffect)==false ){
				WK7RenderObjEffectInfo	info;
				info.Create();
				if( (pWindEffect = ::CreateDraft2Effect(pWindJObj,(s32)VParam[ED_DRAFT][2]))!=NULL ){
					mpWindEffect = CreateEffect(pWindEffect,&info);
					
					// ЂъꂽǂoĂĂ錄ԕ
					CatWindSePlay( POS524M00_CRACK, K7SCN05_EV_051401, SFX_SCE5_HTL_SUKIMAWIND16 );
				}
			}
		}else{
			if( mpWindEffect!=NULL ){
				DelReqEffect(mpWindEffect);
				mpWindEffect = NULL;
			}
		}
	}
	K7SCR_EVNO_SETENABLE(K7EVENTNO  (050401),evKed);
	K7SCR_EVNO_SETENABLE(K7EVENTTAMA(051401),tamaevflag);
	RenewTamaEffect(K7EVENTTAMA(051401));
	SetVisibleTamaJObj(K7EVENTTAMA(051401),!K7SCR_EVHASITEM(K7EVITEM_TAMA(051401)));
	SetVisibleJObj    ("event_051401_msk",wall,false,true);
	SetVisibleJObj    ("Bloodstain",GameInfo.GetScenarioFlow()==K7SCNF_HT2,false,true);
	return true;
}

bool K7Stage524M00::HitObjCallBack(WK7HitObjInfo &info)
{
	K7SCR_HITOBJ_SETENABLE(&info,true);
	switch( info.mEventNo ){
	case	K7EVENTNO(051401):
		if( WK7PLAYERCONTROL->GetMainID()!=K7MSK ){
			return false;
		}
		K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051401);
		
		// N[[bgj
		
		//ogIB
		KK7BattleMainTask::BattleMainTaskExit(1);
		
		Vec	pos = { -25.040f,0.0f,-124.246f };
		
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		K7SCR_PC_SETVISIBLE(false);
		
		FixCam(EVENT_051401);
		
		CreateEffectSmoke(pos);
static	int	DELAY_TICK = WK7_SEC_TO_TICK(0.25f);
		K7SCR_TIMEWAIT(DELAY_TICK);
		K7SCR_EVCONDCHANGE();
		
		K7SCR_TIMEWAIT( K7SCR_MSK_WALL_BEFORE_TICK - DELAY_TICK );
		gpSound->mPlaySE( SFX_SYS_TRUE );
		K7SCR_TIMEWAIT( K7SCR_MSK_WALL_AFTER_TICK );
		
//		K7SCR_STG_MESSAGE_B(K7STAGE524M00_MES_BROKEN_CLOSET);				// N[[bgj󂵂
		
		K7SCR_PC_SETVISIBLE(true);
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EVCONDCHANGE();
		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage524M00::BpLeaveCallBack(WK7BpInfo &info)
{
	u32		eventNo = GetBpEventNo(info);
	int		pathNo  = GetBpPathNo (info);
	if( pathNo!=0 ){
		return true;
	}
	switch( eventNo ){
	case	K7EVENTNO(051401):
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN05_EV_051401)==TRUE ){
			return true;
		}
		break;
	default:
		return true;
	}
	gpSound->mPlaySE(SFX_SYS_APPEAR_RIDDLE);
	return true;
}

bool K7Stage524M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(050401):
		WK7PlayEventInfo	playEventInfo;
		playEventInfo.Initialize();
		playEventInfo.mEventNo = K7EVENTPLAY(05090402);
		PlayEventTask(playEventInfo);
		return false;
	default:
		break;
	}
	return true;
}

