////////////////////////////////////////////////////////////////////////////////
//
// Killer7 StageHotelElev
//
// StageHotelElev.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGEHOTELELEV_CPP__

#include "..\..\..\Scn\K7Scn05.h"
#include ".\K7StageHotelElev.h"
#include "..\..\Panel\SK7PanelHotelElevator.h"

K7StageHotelElev::K7StageHotelElev(ghmGcListObj *pAnchor,int prio) : K7StageHotelBase(pAnchor,prio)
{
	mElevDoorEventNo = 0xffffffff;
	mElevCamID       = 0xffffffff;
	mElevPlayerPosID = 0xffffffff;
	mStageInit       = false;
}

K7StageHotelElev::~K7StageHotelElev()
{
}

bool K7StageHotelElev::CreateMotion(void)
{
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOOROPEN );
	WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOORCLOSE);
	return true;
}

bool K7StageHotelElev::OpenElevDoor(bool im)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOOROPEN);
	if( pMotion==NULL ){
		return false;
	}
	mpModel->AttachMotion (pMotion);
	mpModel->PlayMotion   (im==true? -1.0f : 0.0f);
	mpModel->SetMotionLoop(false);
	if( mElevDoorEventNo != 0xffffffff ){
		K7SCR_EVNO_SETENABLE(mElevDoorEventNo,true);
	}
	return true;
}

bool K7StageHotelElev::CloseElevDoor(bool im)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOORCLOSE);
	if( pMotion==NULL ){
		return false;
	}
	mpModel->AttachMotion (pMotion);
	mpModel->PlayMotion   (im==true? -1.0f : 0.0f);
	mpModel->SetMotionLoop(false);
	if( mElevDoorEventNo != 0xffffffff ){
		K7SCR_EVNO_SETENABLE(mElevDoorEventNo,false);
	}
	return true;
}

int K7StageHotelElev::ElevEvent(WK7DoorEventInfo &info,int floor)
{
	
	s32		result;
	
	if( GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
		s32		arg;
		switch( floor ){
		case	1: arg=ELEHOTLE_1F; break;
		case	2: arg=ELEHOTLE_2F; break;
		case	3: arg=ELEHOTLE_3F; break;
		case	4: arg=ELEHOTLE_4F; break;
		case	5: arg=ELEHOTLE_5F; break;
		case	6: arg=ELEHOTLE_6F; break;
		case	7: arg=ELEHOTLE_7F; break;
		case	8: arg=ELEHOTLE_R;  break;
		default: return -1;
		}
		K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(050103),arg);
	//	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(987654),7);
	//	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(987654),floor);
		K7SCR_PANEL_START();
		K7SCR_PANEL_TERMWAIT();
		K7SCR_RETSYS();
		K7SCR_PANEL_EXIT();
		
		result = K7SCR_PANEL_GETRESULT();
		switch( result ){
		case	ELEHOTLE_CANCEL: return -1;
		case	ELEHOTLE_1F: result = 1; break;
		case	ELEHOTLE_2F: result = 2; break;
		case	ELEHOTLE_3F: result = 3; break;
		case	ELEHOTLE_4F: result = 4; break;
		case	ELEHOTLE_5F: result = 5; break;
		case	ELEHOTLE_6F: result = 6; break;
		case	ELEHOTLE_7F: result = 7; break;
		case	ELEHOTLE_R:  result = 8; break;
		default: return -1;
		}
		if( result==floor ){
			result = -1;
		}
	}else{
		result = floor + 1;
	}
	
	K7SCR_PC_SETVISIBLE(true);
	
	if( result > 0 && mpOneShotCamera!=NULL ){
		//LN^̍Wݒ
		if( mElevPlayerPosID!=0xffffffff ){
			f32		x,z;
			WK7PLAYERCONTROL->SetPosition( &mpOneShotCamera[mElevPlayerPosID].pos );
			x = mpOneShotCamera[mElevPlayerPosID].tgt.x - mpOneShotCamera[mElevPlayerPosID].pos.x;
			z = mpOneShotCamera[mElevPlayerPosID].tgt.z - mpOneShotCamera[mElevPlayerPosID].pos.z;
			WK7PLAYERCONTROL->SetRotY(atan2(x,z));
		}
		if( mElevCamID!=0xffffffff ){
			FixCam(mElevCamID);
		}
	}
	
	K7SCR_PANEL_EXITWAIT();
	
	if( result <= 0 ){
		return -1;
	}
	
	const char	*pBpName = NULL;
	
	switch( result ){
	case	1: pBpName = "door_051101"; info.mNextStageID=K7STGID(511,0); break;
	case	2: pBpName = "door_051201"; info.mNextStageID=K7STGID(512,0); break;
	case	3: pBpName = "door_051301"; info.mNextStageID=K7STGID(513,0); break;
	case	4: pBpName = "door_051401"; info.mNextStageID=K7STGID(514,0); break;
	case	5: pBpName = "door_051501"; info.mNextStageID=K7STGID(515,0); break;
	case	6: pBpName = "door_051601"; info.mNextStageID=K7STGID(516,0); break;
	case	7: pBpName = "door_051701"; info.mNextStageID=K7STGID(517,0); break;
	case	8: pBpName = "door_051801"; info.mNextStageID=K7STGID(518,0); break;
	default:
		return -1;
	}
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	if( pBpName!=NULL ){
		strncpy(info.mNextBpName,pBpName,WK7DOOREVENT_BPNAME_MAX-1);
	}
	
	ElevGetOnMotType(mElevCamID,mElevPlayerPosID,"Elevator02",K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOORCLOSE,(u8)(result>floor? 1:0),SFX_SCE5_MAP_CHANGE_ELEV_CLOSE);
	
	WK7Stage::SetCurrentStageParam(1);
	
	return result;
}

bool K7StageHotelElev::InitElevEvent(void)
{
	if( WK7Stage::GetCurrentStageParam()!=1 ){
		mStageInit = true;
		return true;
	}
	SetManualBranch(true);
	return true;
}

bool K7StageHotelElev::StartElevEvent(void)
{
	if( mStageInit==true ){
		return true;
	}
	while( WK7Stage::IsChanging()==true ){
		K7SCR_RETSYS();
	}
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	u8	updown = (u8)( (GetPrevStageID() > mID)? 1 : 0 );
	
	ElevGetOffMotType(mElevCamID,mElevPlayerPosID,"Elevator02",K7MOT_ATTR|K7OBJTYPE_STG,K7STAGEHOTELELEV_MOTION_DOOROPEN,updown,SFX_SCE5_MAP_CHANGE_ELEV_OPEN,SFX_SYS_ELEV_MOVE,SFX_SYS_ELEV_ARRIVE,false);
	
	WK7Chara	*pChara;
	if( (pChara=WK7PLAYERCONTROL->GetCharaPtr())!=NULL ){
		Vec		ofs = {100.0f,0.0f,0.0f};
		pChara->SetClothWarpOffset(ofs);
	}
	
	mStageInit = true;
	SetManualBranch(false);
	
	K7SCR_EVCONDCHANGE();
	
	return true;
}

