////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage122M00 yKVA@zn
//
// K7Stage122M00.cpp
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE122M00_CPP__

#include "..\..\..\Scn\K7Scn06.h"
#include ".\K7Stage122M00.h"
#include "..\..\..\Wat\WK7Item.h"
#include "..\..\..\Kaw\KK7BattleMainTask.h"
#include "..\..\..\Yam\YK7MapSelect.h"
#include "..\..\..\Kaw\KK7Effect.h"

#define	K7STAGE122M00_ENMPOSMAX		(8)
#define	K7STAGE122M00_SIL_CHRID		K7CHRID(K7ZA2,2)

K7Stage122M00::K7Stage122M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int		i;
	mEnmPosID    = 0;
	mEnmState    = 0;
	mEnmRunAway  = false;
	mpSil        = NULL;
	mpSilModel   = NULL;
	mEnmHP       = 4;
	mGrowl       = false;
	mGrowlSeID   = -1;
	mGrowlWait   = 0;
	mGrowlSeProc = 0;
	mDamageSeID  = -1;
	for(i=0 ; i<K7STAGE122M00_SIL_MOTION_NUM ; i++){
		mpSilMotion[i] = NULL;
	}
	SetOneShotCamLocTbl(K7Stage122M00_Camera);
	GameInfo.SetMenuMapEnable(false);
	GameInfo.SetBossFlag     (true );
}

K7Stage122M00::~K7Stage122M00()
{
	GameInfo.SetMenuMapEnable(true );
	GameInfo.SetBossFlag     (false);
}

static	u32		silMotID[] = {
	K7MOTID(K7ZA2, 100),
	K7MOTID(K7ZA2, 110),
	K7MOTID(K7ZA2, 120),
	K7MOTID(K7ZA2, 130),
	K7MOTID(K7ZA2, 115),
};
bool K7Stage122M00::CreateCallBack(void)
{
	int		i;
	mpSil = CreateOwnChara(K7STAGE122M00_SIL_CHRID);
	for(i=0 ; i<K7STAGE122M00_SIL_MOTION_NUM ; i++){
		WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,silMotID[i]);
	}
	return true;
}

bool K7Stage122M00::SilPlayMotion(int index,bool loop)
{
	if( index < 0 || index >= K7STAGE122M00_SIL_MOTION_NUM ){
		return false;
	}
	WK7ModelMotion	*pMotion = mpSilMotion[index];
	if( mpSilModel==NULL || pMotion==NULL ){
		return false;
	}
	mpSilModel->AttachMotion (pMotion);
	mpSilModel->PlayMotion   (0.0f,true,6.0f);
	mpSilModel->SetMotionLoop(loop);
	return true;
}

bool K7Stage122M00::InitializeCallBack(void)
{
	int		i;
	mpSil      = GetOwnChara(K7STAGE122M00_SIL_CHRID);
	mpSilModel = GetOwnModel(K7OBJTYPE_CHR,K7STAGE122M00_SIL_CHRID);
	for(i=0 ; i<K7STAGE122M00_SIL_MOTION_NUM ; i++){
		mpSilMotion[i] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,silMotID[i]);
	}
	if( mpSil!=NULL ){
		WK7JObj		*pJObj;
		mpSil->CreatePrivateLight();
		mpSil->SetStageLight(false);
		if( (pJObj=mpSil->GetJObj())!=NULL ){
			SetHitObj(pJObj,1);
		}
//		SilPlayMotion(K7STAGE122M00_SIL_MOTION_RUN);
		SilPlayMotion(K7STAGE122M00_SIL_MOTION_STANDBY);
	}
	return true;
}

bool K7Stage122M00::PathChangeCallBack(WK7PathChangeInfo &info)
{
static	const char	*pPath0[] = {
//		"curve13",
		"stairs5",
		"curve21",
		"curve24",
		"stairs6",
		"curve25",
		NULL,
	};
static	const char	*pPath1[] = {
		"Acurve26",
		NULL,
	};
static	const char	*pPath2[] = {
		"curve27",
		NULL,
	};
static	const char	*pPath3[] = {
		"curve28",
		NULL,
	};
static	const char	*pPath4[] = {
		"curve29",
		NULL,
	};
static	const char	*pPath5[] = {
		"curve30",
		NULL,
	};
static	const char	*pPath6[] = {
		"curve31",
		NULL,
	};
static	const char	*pPath7[] = {
		"curve32",
		"curve33",
		NULL,
	};
static	const char	**ppPath[] = {
		pPath0,
		pPath1,
		pPath2,
		pPath3,
		pPath4,
		pPath5,
		pPath6,
		pPath7,
		NULL,
	};
	u32		i;
	for(i=0 ; ppPath[i]!=NULL ; i++){
		if( info.CompareList(ppPath[i]) >= 0 ){
			if( mEnmPosID==i ){
				mEnmRunAway = true;
			}
			if( mEnmPosID==K7STAGE122M00_ENMPOSMAX-1 ){
				WK7CAMPATHFOLLOWINFO->SetCurrentPath(WK7PATHINFO_INITDIR_TGTDIR_REV);
			}
			return true;
//			FixCam(i);
//			return false;
		}
	}
//	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	return true;
}

bool K7Stage122M00::CondChangeCallBack(void)
{
	return true;
}

struct K7Stage122M00_EnmInfo{
	Vec				mStayPos;
	f32				mStayRot;
	Vec				mRunAwayPos;
	Vec				mJudgePos;
};

//static K7Stage122M00_EnmInfo		enmInfo[] = {
//	{ { 14.565f, 0.0f,  75.675f},          HALF_PI, { 24.849f, 0.0f,  74.735f} , { -0.249f, 29.417f,  18.980f} },
//	{ { 32.238f, 0.0f, -45.251f},          HALF_PI, { 41.768f, 0.0f, -44.935f} , { 22.600f,    0.0f,  40.420f} },
//	{ { 57.568f, 0.0f,  74.621f},          HALF_PI, { 71.540f, 0.0f,  77.157f} , { 46.078f,    0.0f,   0.105f} },
//	{ {156.633f, 0.0f,  67.918f},               PI, {154.983f, 0.0f,  54.407f} , { 85.455f,    0.0f,  78.850f} },
////	{ { 71.393f, 0.0f,  48.313f},               PI, { 68.247f, 0.0f,  27.843f} , {125.071f,    0.0f,  54.584f} },
//	{ { 71.080f, 0.0f,  44.711f},               PI, {70.449f,  0.0f,  38.174f} , {125.071f,    0.0f,  54.584f} },
//	{ { 77.793f, 0.0f, -43.363f},          HALF_PI, { 89.075f, 0.0f, -47.101f} , { 68.237f,    0.0f,  19.573f} },
//	{ {157.512f, 0.0f, -39.779f},             0.0f, {158.132f, 0.0f, -25.912f} , {100.790f,    0.0f, -48.206f} },
//	{ { 87.535f, 0.0f,  37.592f}, PI * 3.0f / 4.0f, { 87.535f, 0.0f,  37.592f} , { 87.535f,    0.0f,  37.592f} },
//};
static K7Stage122M00_EnmInfo		enmInfo[] = {
	{ { 14.565f, 0.0f,  75.675f},          HALF_PI, { 24.849f, 0.0f,  74.735f} , { -0.249f, 29.417f,  18.980f} },
	{ { 27.339f, 0.0f, -43.047f},          HALF_PI, { 42.751f, 0.0f, -49.208f} , { 22.600f,    0.0f,  40.420f} },
	{ { 49.743f, 0.0f,  74.079f},          HALF_PI, { 67.757f, 0.0f,  77.228f} , { 46.078f,    0.0f,   0.105f} },
	{ {155.659f, 0.0f,  73.521f},               PI, {155.194f, 0.0f,  55.908f} , { 85.455f,    0.0f,  78.850f} },
	{ { 73.921f, 0.0f,  51.844f},               PI, { 71.321f, 0.0f,  36.716f} , {125.071f,    0.0f,  54.584f} },
	{ { 77.793f, 0.0f, -43.363f},          HALF_PI, { 89.075f, 0.0f, -47.101f} , { 68.237f,    0.0f,  19.573f} },
	{ {157.512f, 0.0f, -39.779f},             0.0f, {158.132f, 0.0f, -25.912f} , {100.790f,    0.0f, -48.206f} },
	{ { 87.535f, 0.0f,  37.592f}, PI * 3.0f / 4.0f, { 87.535f, 0.0f,  37.592f} , { 87.535f,    0.0f,  37.592f} },
};

bool K7Stage122M00::GetEnmPos(Vec &pos,f32 &roty)
{
	if( mEnmPosID < 0 || mEnmPosID >= K7STAGE122M00_ENMPOSMAX ){
		return false;
	}
	pos  = enmInfo[mEnmPosID].mStayPos;
	roty = enmInfo[mEnmPosID].mStayRot;
	return true;
}

bool K7Stage122M00::JudgePos(Vec &plpos)
{
	K7Stage122M00_EnmInfo	*pInfo;
	int						i;
	for(i=0,pInfo=enmInfo ; i<K7STAGE122M00_ENMPOSMAX-1 ; i++,pInfo++){
		if( GHM_VEC_DIST(&pInfo->mJudgePos,&plpos) < 5.0f ){
			if( mEnmPosID<=i ){
				mEnmRunAway = true;
				return true;
			}
		}
	}
	return false;
}

bool K7Stage122M00::PlayGrowlSe(int &seid)
{
	if( mGrowl==false ){
		return false;
	}
	if( mGrowlSeID >= 0 && gpSound->mCheckSE(mGrowlSeID)==true ){
		return false;
	}
//	if( mGrowlWait >  WK7_TICK_PER_FRAME ){
//		mGrowlWait -= WK7_TICK_PER_FRAME;
//		return false;
//	}
	if( mDamageSeID >= 0 && gpSound->mCheckSE(mDamageSeID)==true ){
		return false;
	}
	mGrowlWait  = (int)(WK7_SEC_TO_TICK(0.5f) + HSD_Randi(WK7_SEC_TO_TICK(1.0f)));
	mGrowlSeID  = gpSound->mPlaySE(SFX_SCE6_IWAZARU_IKAKU_A + HSD_Randi(SFX_SCE6_IWAZARU_IKI_B - SFX_SCE6_IWAZARU_IKAKU_A + 1));
	mDamageSeID = -1;
	seid = mGrowlSeID;
	return true;
}

bool K7Stage122M00::EnmCtrl(int &seid)
{
	if( mEnmPosID < 0 || mEnmPosID >= K7STAGE122M00_ENMPOSMAX ){
		return false;
	}
	K7Stage122M00_EnmInfo		*pInfo = enmInfo + mEnmPosID;
	Vec							dpos;
	f32							dist;
	switch( mEnmState ){
	case	0:
		if( gpNoise->mGetSandFrameProc()==eSandStandby ){
			mEnmRunAway = true;
			mEnmState++;
		}
	case	1:
		GetEnmPos(mEnmPos,mEnmRotY);
		if( mEnmPosID==K7STAGE122M00_ENMPOSMAX-1 ){
			break;
		}
		if( mEnmRunAway==true ){
			mEnmState++;
			mEnmRunAway = false;
			// 胂[VĐ
			SilPlayMotion(K7STAGE122M00_SIL_MOTION_RUN);
		}
		break;
	case	2:
		VECSubtract(&pInfo->mRunAwayPos,&mEnmPos,&dpos);
		if( (dist=VECMag(&dpos)) < 0.0001f ){
			mEnmState = 1;
			mEnmRunAway = false;
			mEnmPosID++;
			if( mEnmPosID==K7STAGE122M00_ENMPOSMAX-1 ){
				SilPlayMotion(K7STAGE122M00_SIL_MOTION_SHOUT,false);
//				SilPlayMotion(K7STAGE122M00_SIL_MOTION_SHOUT);
				mGrowl = true;
			}else{
				SilPlayMotion(K7STAGE122M00_SIL_MOTION_STANDBY);
			}
			break;
		}else{
static	f32	movedist = 2.0f * 30.0f / WK7_FRAME_RATE;
			if( dist > movedist ){
				dist = movedist;
			}
			VECNormalize(&dpos,&dpos);
			VECScale    (&dpos,&dpos,dist);
			VECAdd      (&mEnmPos,&dpos,&mEnmPos);
		}
		break;
	}
	
	if( mpSil!=NULL ){
		mpSil->SetRenderFlag(true);
		mpSil->SetPosition  (mEnmPos );
		mpSil->SetRotY      (mEnmRotY);
	}
	if( mEnmPosID==K7STAGE122M00_ENMPOSMAX-1 && mpSilModel!=NULL ){
		switch( mGrowlSeProc ){
		case	1:
			if( mpSilModel->GetCurrentMotionFrame() > 60.0f ){
				mGrowlSeProc++;
				PlayGrowlSe(seid);
			}
			break;
		case	2:
			if( mpSilModel->GetCurrentMotionFrame() > 120.0f ){
				mGrowlSeProc++;
				PlayGrowlSe(seid);
			}
			break;
		case	3:
			if( mpSilModel->GetMotionState()!=WK7MODEL_NOANIM ){
				break;
			}
			mGrowlSeProc = 0;
		case	0:
		default:
			SilPlayMotion(K7STAGE122M00_SIL_MOTION_SHOUT,false);
			mGrowlSeProc++;
			break;
		}
	}
	
	return true;
}

bool K7Stage122M00::SetCurrentCallBack(void)
{
	int		seid = -1;
	SetCurrentCallBackDefaultProc();
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		Vec		plpos;
		
		WK7PLAYERCONTROL->GetPosition(&plpos);
		
//		JudgePos(plpos);
		EnmCtrl(seid);
		
		K7SCR_RETSYS();
	}
	
	if( seid >= 0 && gpSound->mCheckSE(seid)==true ){
static	u8		dvol = 4;
		u8		vol  = SOUND_SYSTEM_SE_VOLUME;
		while( vol >= dvol && gpSound->mCheckSE(seid)==true ){
			vol -= dvol;
			gpSound->mSetVolumeSENo(seid,vol,1);
			K7SCR_RETSYS();
		}
		if( gpSound->mCheckSE(seid)==true ){
			gpSound->mStopSENo(seid);
		}
	}
	return false;
}

bool K7Stage122M00::HitObjCallBack(WK7HitObjInfo &info)
{
	if( info.mEventNo!=1 ){
		return true;
	}
	if( mEnmPosID!=K7STAGE122M00_ENMPOSMAX-1 ){
		mEnmRunAway = true;
		return true;
	}
	
	if( mEnmHP ){
		mDamageSeID = gpSound->mPlaySE(SFX_SCE6_IWAZARU_DAMAGE);
		
		mEnmHP--;
		
		// ꃂ[Vo
		SilPlayMotion(K7STAGE122M00_SIL_MOTION_DAMAGE,false);
		
		// ̃GtFNgo
		KK7BattleEffectCharaTypeBloodStart( info.mHitPos, K7DAN );
		return true;
	}
	
	KK7BattleMainTask::BattleMainTaskExit(1);
	K7SCR_RETSYS();
	
	K7SCR_ENTER_PLAYMODE_B();
	K7SCR_ENTER_DEMOPAUSE();
	
	// le|LĐ
	K7SCR_NOISE_REQUEST();
	K7SCR_PC_VISIBLE( false );
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::StorePlayTB();
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	WK7PLAYERCONTROL->SetOperateEnable(false);
//	WK7PLAYERCONTROL->ReleaseArchive();
//	while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
//		K7SCR_RETSYS();
//	}
	WK7Stage::DeleteStage(this);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	WK7Play::SetDontReleasePlayerSsm( true );	//vC[SE͉Ȃ
	WK7Play		*pPlay;
	u32			playno;
	playno = K7EVENTPLAY(05500401);
	while( (pPlay=WK7Play::Create(playno))==NULL ){
		K7SCR_RETSYS();
	}
	pPlay->Prepare();
	while( pPlay->GetState()!=WK7Play::PREPARED ){
		K7SCR_RETSYS();
	}
	pPlay->Start();
	K7SCR_RETSYS();
	
	K7SCR_NOISE_RELEASE();
	
	while( pPlay->GetState()!=WK7Play::PLAYED ){
		K7SCR_RETSYS();
	}
	
	//LɃmCY
	K7SCR_NOISE_REQUEST();
	
	pPlay->SetVisibleAll(false);
	WK7Play::PlayReleaseAll();
	WK7Play::SetPlayed(playno,true);
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	WK7Play::RestorePlayTB();
	gpSound->mStopStream();		//Xe[WBGM~
	//WK7CAM->SetCinemaScopeMode(true);
	
	//[r[ɓOɃmCY̒ԉ
	K7SCR_NOISE_RELEASE_TO_MAP();
	
	// R͓ɃPbgRLĐ
	if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_KILLER1) == true ){
		//Killer8
		if( K7SCR_GET_SCENARIO_FLAG(EV057500)==FALSE ){
			// }cPȂ
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_051002028 );
		}else{
			// }cP
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_051002018 );
		}
	}else{
		//Killer7
		if( K7SCR_GET_SCENARIO_FLAG(EV057500)==FALSE ){
			// }cPȂ
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_05100202 );
		}else{
			// }cP
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_05100201 );
		}
	}
	
	// X^bt[
	K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(060001),0);
	GameInfo.SetPanelReleaseCancel(true);
	GameInfo.SetPanelNoiseCancel(true);
	K7SCR_PANEL_START();
	K7SCR_PANEL_TERMWAIT();
	K7SCR_RETSYS();
	K7SCR_PANEL_EXIT();
	K7SCR_PANEL_EXITWAIT();
	GameInfo.SetPanelNoiseCancel(false);
	GameInfo.SetPanelReleaseCancel(false);
	
	k7app.FadeStart(0,0);
	k7app.SetFadeColor(0);
	
//	GameInfo.MapSelectInit(MAP_SHANGHAI,MAP_SHANGHAI,false);
//	while( GameInfo.CheckMapSelectEnd()==false ){
//		K7SCR_RETSYS();
//	}
//	GameInfo.MapSelectEnd();
	
	K7SCR_NOISE_REQUEST();
	
	u32			stgid = K7STGID(600,0);
	
	K7SCR_STG_CREATE_B   (stgid);
	K7SCR_STG_SET_CURRENT(stgid);
	K7SCR_STG_VISIBLE    (stgid,true);
//	K7SCR_STG_SET_CURRENT_PATH_PARAM_DIR("play_00020101","curve15",0.5f,WK7PATHINFO_INITDIR_TGTDIR_REV);
	
	WK7PLAYERCONTROL->CreateModel     (K7CHRID(K7HAC,0));
	WK7PLAYERCONTROL->CreatePackMotion(K7CHRID(K7HAC,0));
	while( true == WK7PLAYERCONTROL->IsLoading() ){
		K7SCR_RETSYS();
	}
	WK7PLAYERCONTROL->SetVisible(true);
	WK7PLAYERCONTROL->ChangeCallback();
	
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	
	K7SCR_NOISE_RELEASE();
	
//	K7SCR_EXIT_PLAYMODE();
//	K7SCR_EXIT_DEMOPAUSE();
//	GameInfo.SetMode     (WK7GameInfo::TERM           );
//	GameInfo.SetTermState(WK7GameInfo::TERMSTATE_CLEAR);
	
	return false;
}

