////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage122M00 yKVA@zn
//
// K7Stage122M00.h
//
// Creator       : Noboru Matsuzaki (GHM)
// Creation Date : 05/11/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE122M00_H__
#define	__K7STAGE122M00_H__

#include "..\K7Stage.h"

#define	K7STAGE122M00_SIL_MOTION_NUM			(5)
#define	K7STAGE122M00_SIL_MOTION_RUN			(0)
#define	K7STAGE122M00_SIL_MOTION_SHOUT			(1)
#define	K7STAGE122M00_SIL_MOTION_DAMAGE			(2)
#define	K7STAGE122M00_SIL_MOTION_DEAD			(3)
#define	K7STAGE122M00_SIL_MOTION_STANDBY		(4)

class K7Stage122M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	Vec					mEnmPos;
	f32					mEnmRotY;
	int					mEnmPosID;
	bool				mEnmRunAway;
	int					mEnmState;
	int					mEnmHP;
	WK7Chara			*mpSil;
	WK7Model			*mpSilModel;
	WK7ModelMotion		*mpSilMotion[K7STAGE122M00_SIL_MOTION_NUM];
	bool				mGrowl;
	int					mGrowlSeID;
	int					mGrowlWait;
	int					mGrowlSeProc;
	bool				mGrowlSeOK;
	int					mDamageSeID;
	
	K7Stage122M00();
	K7Stage122M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool SilPlayMotion(int index,bool loop=true);
	
	bool JudgePos(Vec &plpos);
	bool GetEnmPos(Vec &pos,f32 &roty);
	bool EnmCtrl(int &seid);
	bool PlayGrowlSe(int &seid);
public:
	virtual ~K7Stage122M00();
	
	virtual bool CreateCallBack    (void);					//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);					//iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);					//ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void);					//Iȉj
	virtual bool SetCurrentCallBack(void);					//JgXe[Wɐݒ莞
//	virtual bool EventCallBack     (WK7EventInfo     &);	//Cxg
//	virtual bool DoorEventCallBack (WK7DoorEventInfo &);	//hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &);	//L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &);	//}bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &);	//Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &);	//_o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &);	//_
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &);	//mobS
	virtual bool HitObjCallBack    (WK7HitObjInfo    &);	//qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &);	//XyVA^bNgp
//	virtual bool SpAbilityCallBack (WK7SpAbilityInfo &);	//XyVAreBgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &);	//erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &);	//erCxgiZ[u|Cgj
	virtual bool PathChangeCallBack(WK7PathChangeInfo &);
};

#ifdef __K7STAGE122M00_CPP__


enum K7STAGE122M00_ONESHOTCAM{
	PATH0,
	PATH1,
	PATH2,
	PATH3,
	PATH4,
	PATH5,
	PATH6,
	PATH7,
};

K7StageEventOneShotCamera	K7Stage122M00_Camera[] = {
	{{-1.690f, 48.524f, 15.500f},{-6.932f, 57.900f, 2.224f}},
	{{24.702f, 7.927f, 68.686f},{27.378f, 5.970f, 92.024f}},
	{{48.861f, 7.927f, -34.249f},{53.969f, 7.386f, -57.256f}},
	{{62.489f, 7.927f, 80.328f},{39.904f, 7.736f, 87.078f}},
	{{145.222f, 7.927f, 54.670f},{168.764f, 6.797f, 54.293f}},
	{{70.975f, 9.254f, 38.908f},{70.777f, 5.361f, 62.156f}},
	{{82.749f, 9.254f, -49.589f},{59.266f, 7.206f, -49.648f}},
	{{149.185f, 8.272f, -28.410f},{168.516f, 3.781f, -41.131f}},
};

#endif

#endif	//__K7STAGE122M00_H__

