////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage121M00
//
// K7Stage121M00.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 12/20/2003
//
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// er
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE121M00_CPP__

#include ".\K7Stage121M00.h"
#include "..\Wat\WK7Event.h"
#include "..\Wat\WK7Npc.h"
#include "..\Wat\WK7SceneBlur.h"
#include "..\Wat\WK7Chara.h"
#include "..\Wat\WK7Item.h"
#include "..\Wat\WK7Play.h"
#include "..\Wat\WK7Shadow.h"
#include "..\Wat\WK7Zan.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Matsu\MK7Movie.h"
#include "..\Yam\YK7CharChange.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7Sound.h"
#include "..\Panel\SK7PanelTutorial.h"

#include "..\Scn\K7Scn01.h"
#include "..\Scn\K7Scn02.h"
#include "..\Scn\K7Scn03.h"
#include "..\Scn\K7Scn04.h"
#include "..\Scn\K7Scn05.h"

#define	K7STAGE121M00_TV_NOISE_SE			SFX_SYS_TV_WHITENOIZ

#define	K7STGTV_ZANEVENT_START()				static K7Stage121M00_ZanEvent	_K7Stage121M00_ZanEvent[] = {
#define	K7STGTV_ZANEVENT(mid,pfx,param,evno)		{ K7STGID((mid),(pfx)),(param),0x##evno|K7EV_TYPE_ZAN },
#define	K7STGTV_ZANEVENT_END()						{ 0xffffffff,0xffffffff,0xffffffff }, \
												};

K7STGTV_ZANEVENT_START()
#include ".\info\K7StageZanInfo.h"
K7STGTV_ZANEVENT_END()


#define	K7STAGE121M00_HAC_CHRID				K7CHRID(K7HAC, 0)
#define	K7STAGE121M00_HAC_MOTID_TV			K7MOTID(K7HAC,35)
#define	K7STAGE121M00_HAC_MOTID_SV			K7MOTID(K7HAC,35)

#define	K7STAGE121M00_SMA_CHRID_TV			K7CHRID(K7SMA,50)
#define	K7STAGE121M00_SMA_CHRID_SV			K7CHRID(K7SMA, 0)
#define	K7STAGE121M00_SMA_MOTID_TV			K7MOTID(K7SMA,20)
#define	K7STAGE121M00_SMA_MOTID_SV			K7MOTID(K7SMA,30)
#define	K7STAGE121M00_SMA_MOTID_REMOCON		K7MOTID(K7SMA,31)

#define	K7STAGE121M00_GRY_CHRID_TV			0xffffffff
#define	K7STAGE121M00_GRY_CHRID_SV			K7CHRID(K7GRY, 0)
#define	K7STAGE121M00_GRY_MOTID_TV			0xffffffff
#define	K7STAGE121M00_GRY_MOTID_SV			K7MOTID(K7GRY,20)
#define	K7STAGE121M00_GRY_MOTID_REMOCON		K7MOTID(K7GRY,30)

//n[}s҃LĐēĂtO
bool	K7Stage121M00::mLookIlltreat = false;




K7Stage121M00::K7Stage121M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	int		i;
	mStageInit          = false;
	mReturnStageID      = 0xffffffff;
	memset(mReturnBpName,0,sizeof(mReturnBpName));
	SetOneShotCamLocTbl(K7Stage121M00_Camera);
	mParam              = 0;
	mSaveRoom           = false;
	mpSma               = NULL;
	mpSmaModel          = NULL;
	mSmaCharaID         = 0xffffffff;
	mSmaMotID           = 0xffffffff;
	mSmaMotIDRemoCon    = 0xffffffff;
	mpZanEvent          = NULL;
	mZanEventNo         = K7EVENTZAN(012100);
	memset(mZanLocatorName,0,K7STAGE121M00_ZANLOCATORNAME_SIZE);
	for(i=0 ; i<K7STAGE121M00_SMA_MOTION_NUM ; i++){
		mpSmaMotion[i] = NULL;
	}
	mpHac               = NULL;
	mpHacModel          = NULL;
	mpHacMotion         = NULL;
	mHacMotID           = 0xffffffff;
	mPcDieFlag          = 0;
	mPcCollectFlag      = 0;
	mPcReCallFlag       = 0;
	mPcSelOKFlag        = 0;
	mEnterPass          = true;
	
	//J[eBX@ɂČx񂪖Ă~
	if( (GameInfo.GetScenarioFlow() == K7SCNF_CUR)
	 && (K7SCR_GET_SCENARIO_FLAG(EV035012) == true) )
	{
		gpSound->mStopSE( SFX_SCE3_CUR_ALARM );
	}
}

K7Stage121M00::~K7Stage121M00()
{
//	gpSound->mStopSE(K7STAGE121M00_TV_NOISE_SE);
	
	GameInfo.SetItemEnable(true);
	GameInfo.SetSpecialEnable(true);
	GameInfo.SetMenuMapEnable(true);
//	WK7PLAYERCONTROL->ClearWalkOnly();
	
	//J[eBX@ɂČx񂪖ĂĐ
	if( (GameInfo.GetScenarioFlow() == K7SCNF_CUR)
	 && (K7SCR_GET_SCENARIO_FLAG(EV035012) == true) )
	{
		gpSound->mPlaySE( SFX_SCE3_CUR_ALARM );
	}
	//wZɂăMNeBJ|ĂGpopȂ
	if( (GameInfo.GetScenarioFlow() == K7SCNF_SCL)
	 && (K7SCR_GET_SCENARIO_FLAG(EV055710) == true) )
	{
		WK7Npc::NpcPopAllEnable( true );
	}
	WK7PLAYERCONTROL->BattlePadRegulationClear();
}

bool K7Stage121M00::CreateCallBack(void)
{
	u32		prevStageID = WK7Stage::GetPrevStageID();
	
	StoreTvFlag();
	
	mParam = WK7Stage::GetCurrentStageParam();
	
	if( prevStageID==WK7STAGE_GALSTAGEID ){
		SetSelOKAll(false);
		switch( GameInfo.GetScenarioFlow() ){
		case	K7SCNF_KAK:	// pr
		case	K7SCNF_CUR:	// J[eBX@
		case	K7SCNF_DM2:	// h~jJ
//		case	K7SCNF_DM3:	// h~jJ
		case	K7SCNF_SCL:	// wZ
		case	K7SCNF_HT2:	// zeQ
			// ViI`ȊO̓Z[u
			mParam |= WK7STAGE_TVSTAGE_SAVEPARAM;
			break;
		case	K7SCNF_CEL:	// ZeBbN
		case	K7SCNF_FUK:	// tNV}
		case	K7SCNF_TXS:	// eLTXO
		case	K7SCNF_ISZ:	// VniCVUJhj
		case	K7SCNF_DM1:	// h~jJO
		case	K7SCNF_HT1:	// zeP
		case	K7SCNF_GNK:	// R͓
		default:
			// ViI`̓Z[ułȂ
			break;
		}
		mpHac = CreateOwnChara(K7STAGE121M00_HAC_CHRID);
		if( mParam & WK7STAGE_TVSTAGE_SAVEPARAM ){
			mHacMotID = K7STAGE121M00_HAC_MOTID_SV;
		}else{
			mHacMotID = K7STAGE121M00_HAC_MOTID_TV;
		}
		WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,mHacMotID);
	}
	mSaveRoom = false;
	if( mParam!=0xffffffff ){
		if( mParam & WK7STAGE_TVSTAGE_SAVEPARAM ){
			mSaveRoom = true;
		}
		mParam &= WK7STAGE_TVSTAGE_PARAMMASK;
		if( mParam==0 ){
			mParam = 1;
		}
		SetHarmanRoomFlag(prevStageID,(int)(mParam-1),true);
	}
	if( GameInfo.GetScenarioID() >= K7SCN05 ){
		if( mSaveRoom==true ){
			mSmaCharaID      = K7STAGE121M00_GRY_CHRID_SV;
			mSmaMotID        = K7STAGE121M00_GRY_MOTID_SV;
			mSmaMotIDRemoCon = K7STAGE121M00_GRY_MOTID_REMOCON;
		}else{
			mSmaCharaID      = K7STAGE121M00_GRY_CHRID_TV;
			mSmaMotID        = K7STAGE121M00_GRY_MOTID_TV;
			mSmaMotIDRemoCon = 0xffffffff;
		}
	}else{
		if( mSaveRoom==true ){
			mSmaCharaID      = K7STAGE121M00_SMA_CHRID_SV;
			mSmaMotID        = K7STAGE121M00_SMA_MOTID_SV;
			mSmaMotIDRemoCon = K7STAGE121M00_SMA_MOTID_REMOCON;
		}else{
			mSmaMotIDRemoCon = 0xffffffff;
			mSmaCharaID      = K7STAGE121M00_SMA_CHRID_TV;
#ifdef	_DEBUG
			mSmaMotID        = 0xffffffff;
#else
			mSmaMotID        = K7MOTID(K7SMA,20);
#endif
			switch( mPrevStageID ){
			case	WK7STAGE_GALSTAGEID:
				switch( GameInfo.GetScenarioID() ){
				case	K7SCN01: 	// 01 
					mSmaMotID        = K7MOTID(K7SMA,44);
					break;
				case	K7SCN02:	// 02 _j
//					mSmaMotID        = K7MOTID(K7SMA,49);
					mSmaMotID        = K7MOTID(K7SMA,40);
					mSmaMotIDRemoCon = K7MOTID(K7SMA,48);
//					mSmaMotID        = K7MOTID(K7SMA,48);
//					mSmaMotIDRemoCon = K7MOTID(K7SMA,49);
					break;
				case	K7SCN03:	// 03 
					mSmaMotID        = K7MOTID(K7SMA,52);
					mSmaMotIDRemoCon = K7MOTID(K7SMA,53);
					break;
				case	K7SCN04:	// 04 g
					mSmaMotID        = K7MOTID(K7SMA,52);
					mSmaMotIDRemoCon = K7MOTID(K7SMA,53);
//					mSmaMotID        = K7MOTID(K7SMA,59);
//					mSmaMotIDRemoCon = K7MOTID(K7SMA,60);
					break;
				case	K7SCN07:	// 00 Vg
				case	K7SCN05:	// 05 Ί
				case	K7SCN06:	// 06 q
				default:
					break;
				}
				break;
			case	K7STGID(772, 1): mSmaMotID = K7MOTID(K7SMA,20); break;
			case	K7STGID(773, 0): mSmaMotID = K7MOTID(K7SMA,61); break;	//K7MOTID(K7SMA,41); break;
//			case	K7STGID(773, 1): mSmaMotID = K7MOTID(K7SMA,61); break;	//K7MOTID(K7SMA,41); break;
//			case	K7STGID(774, 2): mSmaMotID = K7MOTID(K7SMA,42); break;
//				switch( mParam ){
//				case	1:           mSmaMotID = K7MOTID(K7SMA,42); break;
//				default:             mSmaMotID = K7MOTID(K7SMA,43); break;
//				}
//				break;
			case	K7STGID(774, 0): mSmaMotID = K7MOTID(K7SMA,42); break;	//
			case	K7STGID(775, 1): mSmaMotID = K7MOTID(K7SMA,43); break;
//			case	K7STGID(103, 0): mSmaMotID = K7MOTID(K7SMA,45); break;
			case	K7STGID(105, 0): mSmaMotID = K7MOTID(K7SMA,45); break;	//
			case	K7STGID(119, 0): mSmaMotID = K7MOTID(K7SMA,46); break;
			case	K7STGID(107, 0): mSmaMotID = K7MOTID(K7SMA,47); break;
			case	K7STGID(181, 0): mSmaMotID = K7MOTID(K7SMA,40); break;
			case	K7STGID(131, 0): mSmaMotID = K7MOTID(K7SMA,65); break;	//
			case	K7STGID(132, 0): mSmaMotID = K7MOTID(K7SMA,64); break;
			case	K7STGID(133, 0): mSmaMotID = K7MOTID(K7SMA,66); break;	//
			case	K7STGID(203, 0): mSmaMotID = K7MOTID(K7SMA,67); break;	//
			case	K7STGID(208, 0): mSmaMotID = K7MOTID(K7SMA,50); break;
			case	K7STGID(209, 0): mSmaMotID = K7MOTID(K7SMA,51); break;
			case	K7STGID(209, 1): mSmaMotID = K7MOTID(K7SMA,51); break;
			case	K7STGID(322, 0): mSmaMotID = K7MOTID(K7SMA,54); break;
			case	K7STGID(323, 0): mSmaMotID = K7MOTID(K7SMA,68); break;	//
			case	K7STGID(324, 0): mSmaMotID = K7MOTID(K7SMA,69); break;	//
			case	K7STGID(327, 0): mSmaMotID = K7MOTID(K7SMA,55); break;
			case	K7STGID(326, 0): mSmaMotID = K7MOTID(K7SMA,56); break;
			case	K7STGID(354, 0): mSmaMotID = K7MOTID(K7SMA,57); break;
//			case	K7STGID(358, 0): mSmaMotID = K7MOTID(K7SMA,58); break;
			case	K7STGID(413, 0): mSmaMotID = K7MOTID(K7SMA,61); break;
			case	K7STGID(423, 0): mSmaMotID = K7MOTID(K7SMA,62); break;
			case	K7STGID(441, 0): mSmaMotID = K7MOTID(K7SMA,63); break;
			case	K7STGID(442, 0): mSmaMotID = K7MOTID(K7SMA,70); break;	//
			default:                                                break;
			}
		}
	}
	if( mSmaCharaID!=0xffffffff ){
		if( (mpSma = CreateOwnChara(mSmaCharaID))!=NULL ){
			mSmaCharaID = mpSma->GetID();
		}
	}else{
		mpSma = NULL;
	}
	if( mSmaMotID != 0xffffffff ){
		WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,mSmaMotID);
	}
	if( mSmaMotIDRemoCon!=0xffffffff ){
		WK7RenderObj::CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,mSmaMotIDRemoCon);
	}
	mReturnStageID = mPrevStageID;
	if( mpPrevStagePathName != NULL ){
		strncpy(mReturnBpName,mpPrevStagePathName,WK7DOOREVENT_BPNAME_MAX-1);
	}else if( mpPrevStageBpName != NULL ){
		strncpy(mReturnBpName,mpPrevStageBpName,WK7DOOREVENT_BPNAME_MAX-1);
	}
	GameInfo.SetSpecialEnable(false);
	GameInfo.SetMenuMapEnable(false);
//	GameInfo.SetSpecialEnable(true);
//	switch( mPrevStageID ){
//	case	WK7STAGE_GALSTAGEID:
//		GameInfo.SetSpecialEnable(false);
//		break;
//	default:
//		break;
//	}
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
	return true;
}

bool K7Stage121M00::StoreTvFlag(void)
{
	u32		mainid;
	mPcDieFlag     = 0;
	mPcCollectFlag = 0;
	mPcReCallFlag  = 0;
	mPcSelOKFlag   = 0;
	for(mainid=0 ; mainid<K7PCMAX ; mainid++){
		if( BattleCtrl.PcDieTest(mainid)==true ){
			mPcDieFlag |= (1<<mainid);
		}
		if( BattleCtrl.PcCollectTest(mainid)==true ){
			mPcCollectFlag |= (1<<mainid);
		}
		if( BattleCtrl.PcReCallTest(mainid)==true ){
			mPcReCallFlag |= (1<<mainid);
		}
		if( BattleCtrl.PcSelOKTest(mainid)==true ){
			mPcSelOKFlag |= (1<<mainid);
		}
	}
	return true;
}

bool K7Stage121M00::RestoreTvFlag(void)
{
	u32		mainid,mask;
	for(mainid=0,mask=1 ; mainid<K7PCMAX ; mainid++,mask<<=1){
		BattleCtrl.PcDieSet    (mainid,(mPcDieFlag     & mask)? 1 : 0);
		BattleCtrl.PcCollectSet(mainid,(mPcCollectFlag & mask)? 1 : 0);
		BattleCtrl.PcReCallSet (mainid,(mPcReCallFlag  & mask)? 1 : 0);
		BattleCtrl.PcSelOKSet  (mainid,(mPcSelOKFlag   & mask)? 1 : 0);
	}
	mPcDieFlag     = 0;
	mPcCollectFlag = 0;
	mPcReCallFlag  = 0;
	mPcSelOKFlag   = 0;
	return true;
}

bool K7Stage121M00::SmaSetPosition(f32 x,f32 y,f32 z)
{
	if( mpSma==NULL ){
		return false;
	}
	return mpSma->SetPosition(x,y,z);
}

bool K7Stage121M00::SmaSetPosition(const Vec &pos)
{
	if( mpSma==NULL ){
		return false;
	}
	return mpSma->SetPosition(pos);
}

bool K7Stage121M00::SmaSetRotY(f32 roty)
{
	if( mpSma==NULL ){
		return false;
	}
	return mpSma->SetRotY(roty);
}

bool K7Stage121M00::SmaPlayMotion(int index,bool loop)
{
	if( index < 0 || index >= K7STAGE121M00_SMA_MOTION_NUM ){
		return false;
	}
	WK7ModelMotion	*pMotion = mpSmaMotion[index];
	if( mpSmaModel==NULL || pMotion==NULL ){
		return false;
	}
	mpSmaModel->AttachMotion (pMotion);
	mpSmaModel->PlayMotion   ();
	mpSmaModel->SetMotionLoop(loop);
	return true;
}

bool K7Stage121M00::SmaSetVisible(bool flag)
{
	if( mpSma==NULL ){
		return false;
	}
	mpSma->SetRenderFlag(flag);
	return true;
}

bool K7Stage121M00::InitializeCallBack(void)
{
	int		motid;
	mpHac              = GetOwnChara(K7STAGE121M00_HAC_CHRID);
	mpHacModel         = GetOwnModel(K7OBJTYPE_CHR,K7STAGE121M00_HAC_CHRID);
	mpHacMotion        = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,mHacMotID);
	if( mpHac!=NULL ){
		static	Vec	hacpos = {19.025f,  0.0f, 4.0f};
		WK7SHADOW->DeleteCastShadowObj(mpHac);
		WK7SHADOW->AddCastShadowObj   (mpHac->GetJObj());
		mpHac->SetRenderFlag(true);
		mpHac->SetPosition  (hacpos);
		mpHac->SetRotY      (-HALF_PI);
		mpHac->HideJObj     ("Barrett");
		if( mpHacModel!=NULL && mpHacMotion!=NULL ){
			mpHacModel->AttachMotion (mpHacMotion);
			mpHacModel->PlayMotion   ();
			mpHacModel->SetMotionLoop(true);
		}
	}
	mpSma              = GetOwnChara(mSmaCharaID);
	mpSmaModel         = GetOwnModel(K7OBJTYPE_CHR,mSmaCharaID);
	mpSmaMotion[K7STAGE121M00_SMA_MOTION_STANDBY] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,mSmaMotID       );
	mpSmaMotion[K7STAGE121M00_SMA_MOTION_REMOCON] = GetOwnModelMotion(K7MOT_ATTR|K7OBJTYPE_CHR,mSmaMotIDRemoCon);
	motid = K7STAGE121M00_SMA_MOTION_STANDBY;
	SmaSetRotY(0.0f);
	if( mSaveRoom==true ){
		SmaSetPosition(-10.0f, 0.0f,-17.0f);
		WK7PathBranchPointObjJObj	*pBpObj =  WK7Stage::GetBranchPointObj_EventNo(K7EVENTNO(992100));
		WK7JObj						*pJObj;
		if( pBpObj!=NULL && (pJObj=pBpObj->GetJObj())!=NULL ){
			pJObj->SetWorldPosition(-10.095f, 12.345f, -16.176f);
		}
	}else{
		SmaSetPosition(-17.028f, 0.0f,-17.491f);
		if( mReturnStageID==WK7STAGE_GALSTAGEID ){
			switch( GameInfo.GetScenarioID() ){
			case	K7SCN02:	// 02 _j
				if( WK7Play::HasPlayed(K7EVENTPLAY(02020203))==true ){
					motid = K7STAGE121M00_SMA_MOTION_REMOCON;
					SmaSetPosition(26.304f,  0.0f, 10.669f);
					SmaSetRotY(-HALF_PI);
				}
				break;
			case	K7SCN03:	// 03 
				if( WK7Play::HasPlayed(K7EVENTPLAY(03020203))==true ){
					motid = K7STAGE121M00_SMA_MOTION_REMOCON;
					SmaSetPosition(5.876f, 0.0f, 4.0f);
					SmaSetRotY( HALF_PI);
				}else{
					SmaSetPosition(26.304f,  0.0f, 10.669f);
					SmaSetRotY(-HALF_PI);
				}
				break;
			case	K7SCN04:	// 04 g
				SmaSetPosition(5.876f, 0.0f, 4.0f);
				SmaSetRotY( HALF_PI);
				if( K7SCR_GET_SCENARIO_FLAG(MV040001)==true ){
					motid = K7STAGE121M00_SMA_MOTION_REMOCON;
				}
				break;
			case	K7SCN01: 	// 01 
				if( WK7Play::HasPlayed(K7EVENTPLAY(01020203))==false ){
					SmaSetPosition(26.304f,  0.0f, 10.669f);
					SmaSetRotY(-HALF_PI);
				}
				break;
			case	K7SCN07:	// 00 Vg
			case	K7SCN05:	// 05 Ί
			case	K7SCN06:	// 06 q
			default:
				break;
			}
		}
	}
	SmaPlayMotion(motid);
	SmaSetVisible(true);
	
	if( K7CHR_MAINID(mSmaCharaID)==K7GRY ){
		WK7PathBranchPointObjJObj	*pBpObj;
		if( (pBpObj = GetBranchPointObj_EventNo(K7EVENTNO(992100)))!=NULL ){
			pBpObj->SetObjName(0,"Steward");
		}
	}
	if( mpSma!=NULL ){
		mpSma->CreatePrivateLight();
		mpSma->SetStageLight(false);
	}
	
//	int		harmanRoomID;
//	if( mpStageInfo!=NULL && (harmanRoomID=WK7Stage::GetStageHarmanRoomFlagID(mReturnStageID)) >= 0 ){
//		harmanRoomID  += mParam-1;
//		mSelectPathID += mpStageInfo->mSelectPathNum * harmanRoomID;
//		mSelectObjID  += mpStageInfo->mSelectObjNum  * harmanRoomID;
//	}else{
//		mSelectPathID  = -1;
//		mSelectObjID   = -1;
//	}
	
	if( mEnterPass==true ){
		K7SCR_STG_SET_JUNCTION_PASS(K7STGID(120, 0),"door_990001");
	}
	
	return true;
}

bool K7Stage121M00::LoadAfterInit3(void)
{
	if( WK7Stage::LoadAfterInit3()==false ){
		return false;
	}
	
	int		harmanRoomID;
	if( mpStageInfo!=NULL && (harmanRoomID=WK7Stage::GetStageHarmanRoomFlagID(mReturnStageID)) >= 0 ){
		harmanRoomID  += mParam-1;
		mSelectPathID += mpStageInfo->mSelectPathNum * harmanRoomID;
		mSelectObjID  += mpStageInfo->mSelectObjNum  * harmanRoomID;
	}else{
		mSelectPathID  = -1;
		mSelectObjID   = -1;
	}
	
	if( WK7Stage::GetDisableInitializeSelectFlag()==true ){
		mEnterPass = false;
	}
	
	return true;
}

bool K7Stage121M00::TerminateCallBack(void)
{
	if( mReturnStageID==WK7STAGE_GALSTAGEID ){
		RestoreTvFlag();
	}
	return true;
}

bool K7Stage121M00::CondChangeCallBack(void)
{
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_KAMAE_NO);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_MANUALRELOAD);
	if( mSaveRoom==true ){
		K7SCR_EVNO_SETENABLE(K7EVENTNO(992100),true );
	}else{
		K7SCR_EVNO_SETENABLE(K7EVENTNO(992100),false);
	}
	SetVisibleJObj("ALL"       ,!mSaveRoom,false,true);
	SetVisibleJObj("ADDFLOOR"  , mSaveRoom,false,true);
	SetVisibleJObj("SpotLights", mSaveRoom,false,true);
	
	switch( GameInfo.GetScenarioID() ){
	case	K7SCN01:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN01_HIDE_SMA)==TRUE ){
			K7SCR_EVNO_SETENABLE(K7EVENTNO(992100),false);
			SmaSetVisible(false);
		}
		break;
	case 	K7SCN02:
		if( K7SCR_GET_SCENARIO_FLAG(K7SCN02_EVFL_HARMAN)==TRUE ){
			K7SCR_EVNO_SETENABLE(K7EVENTNO(992100),false);
		}
		break;
		
	default:
		break;
	}
	if( mReturnStageID!=WK7STAGE_GALSTAGEID && GameInfo.GetScenarioFlow()!=K7SCNF_HT2 ){
//	if( mpZanEvent!=NULL ){
		K7SCR_EVSETITEM(mZanEventNo,false);
		SetZanEnable(mZanEventNo,true);
		K7SCR_EVNO_SETENABLE(mZanEventNo,true);
	}else{
		K7SCR_EVSETITEM(mZanEventNo,false);
		SetZanEnable(mZanEventNo,false);
		K7SCR_EVNO_SETENABLE(mZanEventNo,false);
	}
	bool	sw;
	if( WK7Stage::GetHarmanTvFlag(mReturnStageID,(int)(mParam-1))==true ){
		sw = true;
	}else{
		sw = false;
	}
	SetVisibleJObj("Display_ON" , sw,false,true);
	SetVisibleJObj("Display_OFF",!sw,false,true);
	
	SetOrigPathCamera(WK7PLAYERPATHCONTROL->GetCurrentPathName());
	return true;
}

bool K7Stage121M00::TvNoiseCallback(void)
{
//	if( gpSound->mCheckSE(K7STAGE121M00_TV_NOISE_SE)==false ){
//		if( WK7Stage::GetHarmanTvFlag(mReturnStageID,(int)(mParam-1))==true ){
//			gpSound->mPlaySE(K7STAGE121M00_TV_NOISE_SE);
//		}
//	}else{
//		if( WK7Stage::GetHarmanTvFlag(mReturnStageID,(int)(mParam-1))==false ){
//			gpSound->mStopSE(K7STAGE121M00_TV_NOISE_SE);
//		}
//	}
	return true;
}

bool K7Stage121M00::MuteNoiseSE(u32 tick)
{
	mNoiseVolMax.SetValue(0,tick);
	mNoiseVolMin.SetValue(0,tick);
	return true;
}

bool K7Stage121M00::RestoreNoiseSE(u32 tick)
{
	mNoiseVolMax.SetValue(192,tick);
	mNoiseVolMin.SetValue( 32,tick);
	return true;
}

bool K7Stage121M00::SetCurrentCallBack(void)
{
	bool	stageMove = false;
	
	if( mStageInit==false ){
		if( WK7Stage::IsChanging()==true ){
			SetManualBranch(true);
			while( WK7Stage::IsChanging()==true ){
				K7SCR_RETSYS();
			}
			SetManualBranch(false);
			WK7StagePlaceInfo		*pPlaceInfo;
			int						seNo;
			pPlaceInfo = GetPlaceInfo(WK7Stage::GetCurrentStageBpName());
			SetOrigPathCamera(WK7PLAYERPATHCONTROL->GetCurrentPathName());
			if( GetPrevStageID() == K7STGID(120,0) ){
				if( mLookIlltreat == true ){
					seNo = NOISE_SE_NONE;
					mLookIlltreat = false;
				}else{
					seNo = SFX_SYS_MAP_CHANGE_HACROOM_DEFOUT;
				}
			}else{
				seNo = SFX_SYS_MAP_CHANGE_DOOR_HAC_CLOSE;
			}
			while( SandRelease(pPlaceInfo,seNo)==false ){
				K7SCR_RETSYS();
			}
			stageMove = true;
		}
		mStageInit = true;
	}
	
//	WK7PLAYERCONTROL->SetWalkOnly();
	if( mSaveRoom==true ){
		gpSound->mPlayStreamEx(HPS_HORAIZON);
	}else{
		gpSound->mPlayStreamEx(HPS_HORAIZON_B);
	}
	
//	SetCurrentCallBackDefaultProc();
	GameInfo.SetItemEnable(false);
	K7SCR_EVCONDCHANGE();
	
	RestoreNoiseSE();
	
	LOOPSE2	*pLoopSE = NULL;
	if( WK7Stage::GetHarmanTvFlag(mReturnStageID,(int)(mParam-1))==true ){
		pLoopSE = KK7SoundLoopSePlayVolumeChange2((Vec){-33.420f, 9.563f, -4.364f},
		                                          mID,
		                                          K7STAGE121M00_TV_NOISE_SE,		// SOUND_EVENT_SE_VOLUME=255
		                                          (u8)mNoiseVolMax.GetValue(),
		                                          (u8)mNoiseVolMin.GetValue(),
		                                          200.0f,
		                                          8.0f);
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		TvNoise();
		K7SCR_RETSYS();
	}
	
	if( stageMove==true ){
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	while( WK7RenderObj::IsValid(this)==true && GetState()==LOADED ){
		if( pLoopSE != NULL ){
			pLoopSE->volMax = (u8)mNoiseVolMax.GetValue();
			pLoopSE->volMin = (u8)mNoiseVolMin.GetValue();
		}
		TvNoise();
		mNoiseVolMax.FrameProcess();
		mNoiseVolMin.FrameProcess();
		K7SCR_RETSYS();
	}
	
	if( WK7RenderObj::IsValid(this)==true && pLoopSE!=NULL ){
		pLoopSE->taskEnd = -1;
	}
	
	return false;
}

bool K7Stage121M00::SelectHarman(WK7TvEventInfo &info,u32 playno,int flag)
{
	bool	blurVisible = SceneBlur.GetVisible();
	bool	result = false;
	
	info.SetSelectObjEnable(true);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		K7SCR_RETSYS();
	}
	
	K7SCR_RETSYS();
	K7SCR_RETSYS();
	
	while( WK7Stage::ReleaseStageArchive()==false ){
		K7SCR_RETSYS();
	}
	
	while( WK7Stage::IsReleasedStageArchive()==false ){
		K7SCR_RETSYS();
	}
	
	BattleCtrl.PcReCallSet (K7HAC, 1);
	BattleCtrl.PcSelOKSet  (K7HAC, 1);
	
//	ClearChangeChara();
//	SetChangeChara(K7DAN,false);
//	SetChangeChara(K7GAL,false);
//	SetChangeChara(K7CON,false);
//	SetChangeChara(K7HAC,true );
//	SetChangeChara(K7CYO,false);
//	SetChangeChara(K7KED,false);
//	SetChangeChara(K7KVN,false);
//	SetChangeChara(K7MSK,false);
	
	// LI\}bv
//	ClearCharChangeMask();
	
	// ̃LN^IłȂ悤ɂ( InitCharChange ̑OɈړ܂ (Rc) )
//	SetCharChangeMask(K7DAN);
//	SetCharChangeMask(K7GAL);
//	SetCharChangeMask(K7CON);
//	SetCharChangeMask(K7HAC);
//	SetCharChangeMask(K7HAS);
//	SetCharChangeMask(K7HAY);
//	SetCharChangeMask(K7CYO);
//	SetCharChangeMask(K7KED);
//	SetCharChangeMask(K7KVN);
//	SetCharChangeMask(K7MSK);
	
	// LN^`FW̏
	// extern s8	InitCharChange( u8 NotCancelFlag = FALSE, s32 CurrentChar = K7GAL, u8 SwitchOnFlag = FALSE ) ;	// LN^`FW̏
	WK7Stage::InitCharChange(false, K7HAC, (u8 )WK7Stage::GetHarmanTvFlag(K7STGID(120,0),0));
	WK7Stage::SetHarmanTvFlag(K7STGID(120,0),0,true);
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	while( CheckCharChangeSetup()==FALSE ){
		K7SCR_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7CAM->StoreState();
	
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ ) 
	while( GetCharChangeState()==TRUE ){
		K7SCR_RETSYS();
	}
	
	if( GetSelectChar()==K7HAC ){
		
		k7app.SetFadeColor(0x00000000);
		k7app.FadeStart(0xff,WK7_SEC_TO_TICK(2.0f));
		
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
		
	}else{
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
			K7SCR_RETSYS();
		}
		
	}
	
	// LN^`FW̌ns
	EndCharChange();
	
	BattleCtrl.PcReCallSet (K7HAC, 0);
	BattleCtrl.PcSelOKSet  (K7HAC, 0);
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	// ILN^̂hc𓾂
	switch( GetSelectChar() ){
	case	K7HAC:{
		
		k7app.FadeStart(0x00,0);
		
		WK7Play		*pPlay;
		while( (pPlay=WK7Play::Create(playno))==NULL ){
			K7SCR_RETSYS();
		}
		pPlay->Prepare();
//		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//			K7SCR_RETSYS();
//		}
		WK7Play::StorePlayTB();
		while( pPlay->GetState()!=WK7Play::PREPARED ){
			K7SCR_RETSYS();
		}
		pPlay->Start();
		K7SCR_RETSYS();
//		while( gpNoise->mSandRelease()==false ){
//			K7SCR_RETSYS();
//		}
//		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//			K7SCR_RETSYS();
//		}
		while( pPlay->GetState()!=WK7Play::PLAYED ){
			K7SCR_RETSYS();
		}
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue,NOISE_SE_NORMAL)==false ){
			K7SCR_RETSYS();
		}
		pPlay->SetVisibleAll(false);
		K7SCR_RETSYS();
		K7SCR_RETSYS();
		GHM_SAFE_DELETE(pPlay);
		WK7Play::RestorePlayTB();
		
		WK7Play::SetPlayed(playno,true);
		
//		ClearChangeChara();
//		SetChangeChara(K7DAN,false);
//		SetChangeChara(K7GAL,false);
//		SetChangeChara(K7CON,false);
//		SetChangeChara(K7HAC,false);
//		SetChangeChara(K7HAS,false);
//		SetChangeChara(K7HAY,false);
//		SetChangeChara(K7CYO,false);
//		SetChangeChara(K7KED,false);
//		SetChangeChara(K7KVN,false);
//		SetChangeChara(K7MSK,false);
		
		result = true;
		
		if( flag >= 0 ){
			K7SCR_SET_SCENARIO_FLAG(flag);
		}
		
		}break;
	default:
		break;
	}
	
	while( WK7Stage::RestoreStageArchive()==false ){
		K7SCR_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		K7SCR_RETSYS();
	}
	
	while( WK7Stage::IsRestoredStageArchive()==false ){
		K7SCR_RETSYS();
	}
	
	// tF[hAEg
//	WK7PLAYERCONTROL->ChangeChkPoint();			// `FbN|Cg̕ύXs
	
	WK7CAM->RestoreState();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	SceneBlur.SetVisible(blurVisible);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	
	K7SCR_EVCONDCHANGE();
	RenewPath();
	
	while( gpNoise->mSandRelease()==false ){
		K7SCR_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		K7SCR_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetVisible(true);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return result;
}

bool K7Stage121M00::SelectHarmanMovie(WK7TvEventInfo &info,u32 movieid)
{
	bool	blurVisible = SceneBlur.GetVisible();
	bool	result = false;
	
	info.SetSelectObjEnable(true);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		K7SCR_RETSYS();
	}
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	while( WK7Stage::ReleaseStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsReleasedStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	BattleCtrl.PcReCallSet (K7HAC, 1);
	BattleCtrl.PcSelOKSet  (K7HAC, 1);
	
//	ClearChangeChara();
//	SetChangeChara(K7DAN,false);
//	SetChangeChara(K7GAL,false);
//	SetChangeChara(K7CON,false);
//	SetChangeChara(K7HAC,true );
//	SetChangeChara(K7CYO,false);
//	SetChangeChara(K7KED,false);
//	SetChangeChara(K7KVN,false);
//	SetChangeChara(K7MSK,false);
	
	// LI\}bv
//	ClearCharChangeMask();
	
	// ̃LN^IłȂ悤ɂ( InitCharChange ̑OɈړ܂ (Rc) )
//	SetCharChangeMask(K7DAN);
//	SetCharChangeMask(K7GAL);
//	SetCharChangeMask(K7CON);
//	SetCharChangeMask(K7HAC);
//	SetCharChangeMask(K7HAS);
//	SetCharChangeMask(K7HAY);
//	SetCharChangeMask(K7CYO);
//	SetCharChangeMask(K7KED);
//	SetCharChangeMask(K7KVN);
//	SetCharChangeMask(K7MSK);
	
	// LN^`FW̏
	// extern s8	InitCharChange( u8 NotCancelFlag = FALSE, s32 CurrentChar = K7GAL, u8 SwitchOnFlag = FALSE ) ;	// LN^`FW̏
	WK7Stage::InitCharChange(false, K7HAC, (u8 )WK7Stage::GetHarmanTvFlag(K7STGID(120,0),0));
	WK7Stage::SetHarmanTvFlag(K7STGID(120,0),0,true);
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( CheckCharChangeSetup()==FALSE ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7CAM->StoreState();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// LN^`FW̏Ԃ𓾂( TRUE:s  FALSE:I͊ɏIĂ ) 
	while( GetCharChangeState()==TRUE ){
		K7SCR_RETSYS();
	}
	
	if( GetSelectChar()==K7HAC ){
		k7app.SetFadeColor(0x00000000);
		k7app.FadeStart(0xff,WK7_SEC_TO_TICK(2.0f));
		while( k7app.IsFade()==true ){
			K7SCR_RETSYS();
		}
	}else{
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	// LN^`FW̌ns
	EndCharChange();
	
	BattleCtrl.PcReCallSet (K7HAC, 0);
	BattleCtrl.PcSelOKSet  (K7HAC, 0);
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	
	// ILN^̂hc𓾂
	switch( GetSelectChar() ){
	case	K7HAC:{
		k7app.FadeStart(0x00,0);
		
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( gpMovie->mGetStatus()!=eMvProcStandby ){
			K7SCR_RETSYS();
		}
//		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//			K7SCR_RETSYS();
//		}
//		while( gpNoise->mSandRelease()==false ){
//			K7SCR_RETSYS();
//		}
//		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//			K7SCR_RETSYS();
//		}
		PlayMovie3(movieid);
		while( gpNoise->mSandRequest(eSandLongNoise)==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsReleasedData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->LoadData()==false ){
			K7SCR_RETSYS();
		}
		while( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			K7SCR_RETSYS();
		}
		
		K7SCR_SET_SCENARIO_FLAG( MV040001 );
		
//		ClearChangeChara();
//		SetChangeChara(K7DAN,false);
//		SetChangeChara(K7GAL,false);
//		SetChangeChara(K7CON,false);
//		SetChangeChara(K7HAC,false);
//		SetChangeChara(K7HAS,false);
//		SetChangeChara(K7HAY,false);
//		SetChangeChara(K7CYO,false);
//		SetChangeChara(K7KED,false);
//		SetChangeChara(K7KVN,false);
//		SetChangeChara(K7MSK,false);
		
		result = true;
		
		}break;
	default:
		break;
	}
	
	while( WK7Stage::RestoreStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsRestoredStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// tF[hAEg
//	WK7PLAYERCONTROL->ChangeChkPoint();			// `FbN|Cg̕ύXs
	
	WK7CAM->RestoreState();
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	
	SceneBlur.SetVisible(blurVisible);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	
	K7SCR_EVCONDCHANGE();
	RenewPath();
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetVisible(true);
	
	K7SCR_EXIT_PLAYMODE();
	K7SCR_EXIT_DEMOPAUSE();
	
	return result;
}

bool K7Stage121M00::TvEventCallBackScn01(WK7TvEventInfo &info)
{
	switch( mReturnStageID ){
	case	K7STGID(120,0):
		if( WK7Play::HasPlayed(K7EVENTPLAY(01020203))==true ){
			info.SetStageID(mReturnStageID);
			info.SetParam  (mParam);
			break;
		}
		SelectHarman(info,K7EVENTPLAY(01020203),K7SCN01_HIDE_SMA);
		return false;
	default:
		break;
	}
	info.SetStageID(mReturnStageID);
	info.SetParam  (mParam);
	return true;
}

bool K7Stage121M00::TvEventCallBackScn02(WK7TvEventInfo &info)
{
	switch( mReturnStageID ){
	case	K7STGID(120,0):
		if( WK7Play::HasPlayed(K7EVENTPLAY(02020203))==true ){
			info.SetStageID(mReturnStageID);
			info.SetParam  (mParam);
			break;
		}
		SelectHarman(info,K7EVENTPLAY(02020203));
		return false;
	default:
		break;
	}
	info.SetStageID(mReturnStageID);
	info.SetParam  (mParam);
	return true;
}

bool K7Stage121M00::TvEventCallBackScn03(WK7TvEventInfo &info)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//Vn
		case	K7SCNF_ISZ:
			if( WK7Play::HasPlayed(K7EVENTPLAY(03020203))==true ){
				info.SetStageID(mReturnStageID);
				info.SetParam  (mParam);
				break;
			}
			SelectHarman(info,K7EVENTPLAY(03020203));
			return false;
		//J[eBX@
		case	K7SCNF_CUR:
		//ftHg
		default:
			info.SetStageID( mReturnStageID );
			info.SetParam( mParam );
			break;
	}
	return( true );
}
	
bool K7Stage121M00::TvEventCallBackScn04(WK7TvEventInfo &info)
{
	switch( GameInfo.GetScenarioFlow() )
	{
		//h~jJO
		case	K7SCNF_DM1:
			if( K7SCR_GET_SCENARIO_FLAG(MV040001) == true ){
				info.SetStageID(mReturnStageID);
				info.SetParam  (mParam);
				break;
			}
			K7SCR_ENTER_PLAYMODE_B();
			K7SCR_ENTER_DEMOPAUSE();
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed,NOISE_SE_NORMAL)==false ){K7SCR_RETSYS();}
			K7SCR_STG_VISIBLE( mID, false );
			K7SCR_STAGE_RELEASE();
			K7SCR_NOISE_RELEASE();
			K7SCR_MOVIE_PLAY_NO_NOISE( K7MOV_04010203 );
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed,NOISE_SE_NORMAL)==false ){K7SCR_RETSYS();}
			K7SCR_STAGE_RESTORE();
			K7SCR_STG_VISIBLE( mID, true );
			K7SCR_SET_SCENARIO_FLAG(MV040001);
			K7SCR_EVCONDCHANGE();
			RenewPath();
			K7SCR_NOISE_RELEASE();
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			//SelectHarmanMovie(info,K7MOV_04010203);	//T_[XEQp
			return false;
		//h~jJ
		//h~jJ
		case	K7SCNF_DM2:
//		case	K7SCNF_DM3:
		//ftHg
		default:
			info.SetStageID( mReturnStageID );
			info.SetParam( mParam );
			break;
	}
	return( true );
}
	
bool K7Stage121M00::TvEventCallBack(WK7TvEventInfo &info)
{
	switch( GameInfo.GetScenarioID() ){
	case	K7SCN01:
		return TvEventCallBackScn01(info);
	case 	K7SCN02:
		return TvEventCallBackScn02(info);
	case 	K7SCN03:
		return TvEventCallBackScn03(info);
	case 	K7SCN04:
		return TvEventCallBackScn04(info);
	default:
		info.SetStageID(mReturnStageID);
		info.SetParam  (mParam);
		break;
	}
	return true;
}

bool K7Stage121M00::DoorEventCallBack(WK7DoorEventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTDOOR(990001):
		if( mReturnStageID != 0xffffffff ){
			info.mNextStageID = mReturnStageID;
			strncpy(info.mNextBpName,mReturnBpName,WK7DOOREVENT_BPNAME_MAX-1);
		}
		break;
	default:
		break;
	}
	return true;
}

bool K7Stage121M00::ChangeZanEventNo(u32 eventNo)
{
	WK7StageZan		*pZan;
	WK7JObj			*pZanLocator;
	if( (pZan = GetZan(mZanEventNo))==NULL || (pZanLocator=GetZanLocator(mZanEventNo))==NULL ){
		return false;
	}
	ChangeEventNo(mZanEventNo,eventNo);
	mZanEventNo = eventNo;
	strncpy(mZanLocatorName,pZanLocator->GetName(),K7STAGE121M00_ZANLOCATORNAME_SIZE-1);
	int		i;
	u32		no = mZanEventNo & K7EV_ID_MASK;
	for(i=7+6-1 ; i>=7 ; i--,no>>=4){
		mZanLocatorName[i] = (char)('0' + (no & 0xf));
	}
	pZanLocator->ChangeName   (mZanLocatorName);
	pZan       ->ChangeEventNo(mZanEventNo); 
	pZan       ->SetForcedDisp(true);
	return true;
}

bool K7Stage121M00::ZanEventCallBack(WK7ZanEventInfo &info)
{
	s32					result;
	u32					eventNo;
	SK7PanelTutorial	*pPanel;
	bool				blur;
	switch( info.mEventNo ){
	case	K7EVENTZAN(012100):
		K7SCR_ENTER_PLAYMODE_B();
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue)==false ){
			GHMGCTASK_RETSYS();
		}
		WK7StageZanInfo	*pZanInfo = WK7Zan::GetCamInfo(info.mEventNo,0);
		if( pZanInfo != NULL ){
			WK7CAM->SetPosition      (pZanInfo->mCamPos);
			WK7CAM->SetTargetPosition(pZanInfo->mCamTgt);
		}
		GameInfo.SetPanelNoiseCancel  (true);
		GameInfo.SetPanelReleaseCancel(true);
		GameInfo.SetPanelInitHideWait (true);
		GameInfo.SetPanelTermHideWait (true);
		K7SCR_PANEL_SETPANELEVNO(K7EVENTNO(070000),0);
		K7SCR_PANEL_START();
		K7SCR_PANEL_INITWAIT();
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		GameInfo.SetPanelInitHideWait (false);
		WK7CAM->SetCinemaScopeMode(true);
//		WK7CAM->SetCinemaScopeColor(0x190519ff);
		WK7CAM->SetCinemaScopeColor(WK7CAM_DEFAULT_CINEMASCOPE_COLOR);
		blur = SceneBlur.GetVisible();
		SceneBlur.SetVisible(false);
		while( gpNoise->mSandRelease()==false ){
			GHMGCTASK_RETSYS();
		}
		pPanel = (SK7PanelTutorial *)GameInfo.GetPanelB();
		while( (result=pPanel->mGetResult()) != TUTORIAL_CANCEL ){
			if( result!=TUTORIAL_STANDBY ){
				eventNo = (u32)result;
				pPanel->mSetRender   (false);
				pPanel->mSetCtrlFlag (false);
				WK7CAM->StoreFov ();
				WK7CAM->StoreNear();
				WK7CAM->StoreFar ();
				WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
				WK7CAM->SetCinemaScopeModeFlag(true);
				
				info.mEventNo = K7EVENTZANID(eventNo);
				ChangeZanEventNo(info.mEventNo);
				SetZanEventInfo (info.mEventNo);
				GameInfo.SetZanCamID(K7EVENTZAN(012100));
//				switch( info.mEventNo ){
//				default:
//					if( (info.mEventNo & 0xff0000)!=0x090000 ){
//						GameInfo.SetZanCamID(K7EVENTZAN(012100));
//					}
//					break;
//				}
//				GameInfo.SetZanNoiseCancel(true);
				GameInfo.SetMode          (WK7GameInfo::ZAN,true);
				GameInfo.SetZanTermWait   (true);
				GameInfo.SetZanManual     (true);
				GameInfo.SetZanCinemaScopeCancel(true);
				while( GameInfo.GetZanState() <  WK7GameInfo::ZANSTATE_TERMWAIT &&
				       GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY  ){
					K7SCR_RETSYS();
				}
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERMWAIT ){
					K7SCR_RETSYS();
				}
				WK7CAM->RestoreFov ();
				WK7CAM->RestoreNear();
				WK7CAM->RestoreFar ();
				WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
				WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
//				WK7PLAYERCONTROL->VitalVisible(true);
				WK7PLAYERCONTROL->SetVisible(true);
				GameInfo.SetZanTermWait   (false);
				
				GameInfo.SetZanTermNoiseWait(true);
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_TERM_NOISEWAIT  ){
					K7SCR_RETSYS();
				}
				GameInfo.SetZanTermNoiseWait(false);
				
				while( GameInfo.GetZanState() != WK7GameInfo::ZANSTATE_STANDBY  ){
					K7SCR_RETSYS();
				}
				GameInfo.SetZanManual       (false);
//				GameInfo.SetZanNoiseCancel  (false);
				
				ChangeZanEventNo(K7EVENTZAN(012100));
				
				pPanel->SetReturnMenu();
				pPanel->mSetRender   (true);
				pPanel->mSetCtrlFlag (true);
				
			}
			K7SCR_RETSYS();
		}
		K7SCR_PANEL_TERMWAIT();
//		K7SCR_RETSYS();
		GameInfo.SetPanelTermHideWait (false);
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue)==false ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
		K7SCR_PANEL_EXIT();
		SceneBlur.SetVisible(true);
		WK7CAM->SetDefaultCinemaScopeColor();
		WK7CAM->SetCinemaScopeMode(false);
		while( gpNoise->mSandRelease()==false ){
			GHMGCTASK_RETSYS();
		}
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
		K7SCR_PANEL_EXITWAIT();
		GameInfo.SetPanelReleaseCancel(false);
		K7SCR_EXIT_PLAYMODE();
		return false;
//		if( mReturnStageID==K7STGID(771,0) ){
//			break;
//		}
//		return false;
	default:
		break;
	}
	return true;
}

bool K7Stage121M00::EventCallBack(WK7EventInfo &info)
{
	switch( info.mEventNo ){
	case	K7EVENTNO(992100):
		// Z[u
		K7SCR_ENTER_PLAYMODE();
		K7SCR_ENTER_DEMOPAUSE();
		
		WK7PLAYERCONTROL->ChangeChkPoint();
		
		K7SCR_PC_SETVISIBLE(false);
		
		WK7CAM->SetFov(GetDefaultCameraFov());
		FixCam(EVENT_992100);
		SmaPlayMotion(K7STAGE121M00_SMA_MOTION_REMOCON,false);
static	f32		t0 = 1.0f,t1 = 0.4f;
		K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(t0));
		gpSound->mPlaySE(SFX_SYS_TV_SWITCH_ON,(SOUND_SYSTEM_SE_VOLUME * 70 / 100));
		K7SCR_TIMEWAIT((int)WK7_SEC_TO_TICK(t1));
		CamMoveToLinearPath(EVENT_992100_1,1.0f);
		K7SCR_TIMEWAIT(WK7_SEC_TO_TICK(1.0f));
		
		while( GameInfo.SetMode(WK7GameInfo::SAVE)==false ){
			K7SCR_RETSYS();
		}
		GameInfo.SetSaveLoadTermHideWait(true);
		
		MuteNoiseSE(WK7_SEC_TO_TICK(0.5f));
		
		K7SCR_PC_SETVISIBLE(true);
		RenewPath();
		while( GameInfo.GetSaveModeState()!=WK7GameInfo::SMSTATE_TERM_FADEWAIT ){
			K7SCR_RETSYS();
		}
		GameInfo.SetSaveLoadTermHideWait(false);
		
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		// T}TR̂
		SmaPlayMotion(K7STAGE121M00_SMA_MOTION_STANDBY);
		
		RestoreNoiseSE(WK7_SEC_TO_TICK(0.5f));
		
		while( GameInfo.GetSaveModeState()!=WK7GameInfo::SMSTATE_STANDBY ){
			K7SCR_RETSYS();
		}
		
		K7SCR_EXIT_DEMOPAUSE();
		K7SCR_EXIT_PLAYMODE();
		
		return false;
	default:
		break;
	}
	return true;
}

K7StageWork* K7Stage121M00::GetWork(void)
{
	switch( mReturnStageID ){
	case	WK7STAGE_GALSTAGEID:
	case	WK7STAGE_TVSTAGEID:
	case	K7STGID_INVALID:
		return WK7Stage::GetWork();
	default:
		break;
	}
	int				workid = GetWorkID(mReturnStageID);
	K7StageWork		*pStgWork;
	if( workid > 0 && workid < GetIDNum() && (pStgWork = GetWorkTop())!=NULL ){
		pStgWork += (workid - 1 + GetIDNum());
		return pStgWork;
	}
	return WK7Stage::GetWork();
}

#define	K7STAGE121M00_FIXCAM_PATH		"door_990001"
static HSD_WObjDesc fixCamEyepos   = {
	NULL,
	{ 0.0f, 20.0f, 20.0f, },
	NULL,
};
static HSD_WObjDesc fixCamInterest = {
	NULL,
	{ 0.0f, 15.0f, 0.0f, },
	NULL,
};
static	HSD_CameraDescPerspective		fixCamDesc = {
	NULL,
	0,
	1,
	{ 0,640,0,480 },
	{ 0,640,0,480 },
	&fixCamEyepos,
	&fixCamInterest,
	0.0f,
	NULL,
	0.1f,
	1000.0f,
	42.184677f,
	1.18f,
};
bool K7Stage121M00::PathChangeCallBack(WK7PathChangeInfo &info)
{
	if( SetOrigPathCamera(info.mpPathName)==true ){
		return false;
	}
	return true;
}
bool K7Stage121M00::SetOrigPathCamera(const char *pPathName)
{
	if( pPathName==NULL ){
		return false;
	}
	WK7CAMPATHFOLLOWINFO->SetStageStartMode(false);
	if( strstr(pPathName,K7STAGE121M00_FIXCAM_PATH)==pPathName ){
		WK7StagePlaceInfo	*pPlaceInfo = GetPlaceInfo(K7STAGE121M00_FIXCAM_PATH);
		SetVisibleJObj("Door",false,false,true);
		SetVisibleJObj("DoorWall",false,false,true);
		if( pPlaceInfo!=NULL ){
			HSD_CameraDesc	*pDescDefault = WK7Cam::GetDescDefault();
			fixCamEyepos  .position = pPlaceInfo->mCamPos;
			fixCamInterest.position = pPlaceInfo->mCamTgt;
			fixCamDesc.nnear  = pDescDefault->perspective.nnear;
			fixCamDesc.ffar   = pDescDefault->perspective.ffar;
			fixCamDesc.fov    = pDescDefault->perspective.fov;
			fixCamDesc.aspect = pDescDefault->perspective.aspect;
			WK7CAMPATHFOLLOWINFO->SetMode(WK7CamPathFollowInfo::FIXED_MODE);
			WK7CAMPATHFOLLOWINFO->SetPathCamera((HSD_CameraDesc *)&fixCamDesc);
			return true;
		}
	}else{
		SetVisibleJObj("Door",true ,false,true);
		if( mSaveRoom==true ){
			SetVisibleJObj("DoorWall",false,false,true);
		}else{
			SetVisibleJObj("DoorWall",true ,false,true);
		}
	}
	return false;
}

