////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage573M00
//
// K7Stage573M00.cpp
//
// Creator       : Watanabe Kazuhisa
// Creation Date : 06/20/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7STAGE573M00_CPP__

#include ".\K7Stage573M00.h"
#include "..\Wat\WK7GameInfo.h"
#include "..\Scn\K7Scn07.h"

//[V
#define	MOT573M00_SHUTTER_OPEN	(0)			//Vb^[J
#define	MOT573M00_SHUTTER_CLOSE	(1)			//Vb^[
//f
#define	MDL573M00_SHUTTER		"shutter"




//------------------------------------------------------------------------------
//RXgN^
//------------------------------------------------------------------------------
K7Stage573M00::K7Stage573M00(ghmGcListObj *pAnchor,int prio) : WK7Stage(pAnchor,prio)
{
	GameInfo.SetMenuMapEnable(false);
	SetOneShotCamLocTbl( K7Stage573M00_Camera );
}

//------------------------------------------------------------------------------
//fXgN^
//------------------------------------------------------------------------------
K7Stage573M00::~K7Stage573M00()
{
	GameInfo.SetMenuMapEnable(true);
}

//------------------------------------------------------------------------------
//iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
//------------------------------------------------------------------------------
bool
K7Stage573M00::CreateCallBack( void )
{
	//[Vt@C
	CreateOwnStageMotion( MOT573M00_SHUTTER_OPEN );
	CreateOwnStageMotion( MOT573M00_SHUTTER_CLOSE );
	return( true );
}

//------------------------------------------------------------------------------
//ԕύXitOɂԕύX邽߂ɗpj
//------------------------------------------------------------------------------
bool
K7Stage573M00::CondChangeCallBack(void)
{
	if( GameInfo.GetScenarioID()!=K7SCN07 ){
		SetZanEventEnable(K7EVENTZAN(007404),false);
	}
	SimpleSetStartMotion( MDL573M00_SHUTTER, MOT573M00_SHUTTER_OPEN );
	return( true );
}

//------------------------------------------------------------------------------
//JgXe[Wɐݒ莞
//------------------------------------------------------------------------------
bool
K7Stage573M00::SetCurrentCallBack( void )
{
	//ÕXe[Wh[z[H
	if( GetPrevStageID() == K7STGID(574,0) )
	{
		SimpleSetStartMotion( MDL573M00_SHUTTER, MOT573M00_SHUTTER_CLOSE );
		//MOVE[hɂȂȂ
		SetMoveModeCancel( true );
		//ǂJɂȂ܂ő҂
		while( WK7Stage::IsChanging() != false )
		{
			K7SCR_RETSYS();
		}
		//inGame~
		K7SCR_ENTER_PLAYMODE_B();
		K7SCR_ENTER_DEMOPAUSE();
		//Jݒ
		//FixCam( CAM573M00_SHUTTER );
		gpSound->mPlaySE( SFX_SCE6_SENKAN_SHUTTER_CLOSE );
		SimplePlayMotionB( MDL573M00_SHUTTER, MOT573M00_SHUTTER_CLOSE );
		K7SCR_TIMEWAIT( 1200 );
		//inGameĊJ
		K7SCR_EXIT_PLAYMODE();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
	return( true );
}

//------------------------------------------------------------------------------
//hACxg
//------------------------------------------------------------------------------
bool
K7Stage573M00::DoorEventCallBack( WK7DoorEventInfo &info )
{
	switch( info.mEventNo )
	{
		//Vb^[
		case	K7EVENTDOOR( 057399 ):
			//inGame~
			K7SCR_ENTER_PLAYMODE();
			K7SCR_ENTER_DEMOPAUSE();
			//K7SCR_PC_SETVISIBLE( false );
			//Jݒ
			FixCam( CAM573M00_SHUTTER );
			gpSound->mPlaySE( SFX_SCE6_SENKAN_SHUTTER_OPEN );
			SimplePlayMotionB( MDL573M00_SHUTTER, MOT573M00_SHUTTER_OPEN );
			K7SCR_TIMEWAIT( 1200 );
			//inGameĊJ
			K7SCR_EXIT_PLAYMODE();
			K7SCR_EXIT_DEMOPAUSE();
			//K7SCR_PC_SETVISIBLE( true );
	    	break;
		
		//ftHg
		default:
			break;
	}
	
	return( true );
}

