////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage578M00
//
// K7Stage578M00.h
//
// Creator       : 
// Creation Date : 03/27/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__K7STAGE578M00_H__
#define	__K7STAGE578M00_H__

#include ".\K7Stage.h"

struct K7Stage578M00_PointInfo{
	u32							mStageID;
	const char					*mpBpName;
	int							mParam;
};

struct K7Stage578M00_LinkInfo{
	int							mScenarioFlow;
	K7Stage578M00_PointInfo		mPoint[2];
};

struct K7Stage578M00_BanCond{
	u32							mPrevStageID;
	int							mFlagID;
	u32							mKihanEnemyNo;
	u32							*mpTamaList;
};

class K7Stage578M00 : public WK7Stage{
	friend class WK7Stage;
protected:
	static	bool			mShortCutEnable;
	
	u32						mReturnStageID;
	u32						mReturnParam;
	char					mReturnBpName[WK7DOOREVENT_BPNAME_MAX];
	K7Stage578M00_BanCond	*mpBanCond;
	WK7Chara				*mpBan;
	WK7Model				*mpBanModel;
	WK7ModelMotion			*mpBanStandbyMotion;
	
	K7Stage578M00();
	K7Stage578M00(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	void	Monban( u32 inEvNo, u32 );	//ԂƂ̉b
	
public:
	virtual ~K7Stage578M00();
	
	virtual bool CreateCallBack    (void);									// iǂݍݗ\sꍇȂǂɗpjǂݍݑOɌĂ΂
	virtual bool InitializeCallBack(void);									// iǂݍݏÎɑ΂鏉j Xe[Wǂݍ݌ɌĂ΂ retrun true  ftHg̓Gǂݍ݂ɍsB
	virtual bool CondChangeCallBack(void);									// ԕύXitOɂԕύX邽߂ɗpj
//	virtual bool TerminateCallBack (void)              { return true; }		// Iȉj
	virtual bool SetCurrentCallBack(void);									// JgXe[Wɐݒ莞
	virtual bool EventCallBack     (WK7EventInfo     &);					// Cxg
	virtual bool DoorEventCallBack (WK7DoorEventInfo &);					// hACxg
//	virtual bool KeyEventCallBack  (WK7KeyEventInfo  &){ return true; }		// L[Cxg
//	virtual bool MapEventCallBack  (WK7MapEventInfo  &){ return true; }		// }bvCxg
//	virtual bool MemoEventCallBack (WK7MemoEventInfo &){ return true; }		// Cxg
//	virtual bool BpLeaveCallBack   (WK7BpInfo        &){ return true; }		// _o
//	virtual bool BpArriveCallBack  (WK7BpInfo        &){ return true; }		// _
//	virtual bool DieNpcCallBack    (WK7DieNpcInfo    &){ return true; }		// mobS
//	virtual bool HitObjCallBack    (WK7HitObjInfo    &){ return true; }		// qbgIuWF
//	virtual bool SpAttackCallBack  (WK7SpAttackInfo  &){ return true; }		// XyVA^bNgp
//	virtual bool TvEventCallBack   (WK7TvEventInfo   &){ return true; }		// erCxg
//	virtual bool LtvEventCallBack  (WK7TvEventInfo   &){ return true; }		// erCxgiZ[u|Cgj

	static K7Stage578M00_PointInfo* GetPointInfo(K7ScenarioFlow flow,int param);
	static K7Stage578M00_PointInfo* GetLinkPoint(u32 stgid,const char *pBpName);
	static bool GetKihanClear(K7ScenarioFlow flow);
	static K7Stage578M00_PointInfo* GetKihanShortCut(K7ScenarioFlow flow,int param);
	static bool SetKihanShortCutEnable(bool flag);
	static bool GetKihanShortCutEnable(void);
};

#ifdef __K7STAGE578M00_CPP__


enum K7STAGE578M00_ONESHOTCAM{
	EV_BAN_OK,
	EV_BAN_NG,
};

K7StageEventOneShotCamera K7Stage578M00_Camera[] = {
	{{0.264f, 14.450f, -26.036f},{0.534f, 19.507f, -5.144f}},		//ԐlCxgOK̃J
	{{4.190f, 11.968f, -43.954f},{-13.799f, 14.180f, -32.393f}},	//ԐlCxgNG̃J
};

#endif

#endif	//__K7STAGE578M00_H__

