////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Application
//
// K7App.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/08/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__K7APP_CPP__

#include ".\K7App.h"
#include ".\WK7MenuTask.h"
#include ".\WK7MainTask.h"
#include ".\WK7MainMenu.h"
#include ".\WK7TestTask.h"
#include ".\WK7ViewerTask.h"
#include ".\WK7Shadow.h"
#include ".\WK7Sight.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Event.h"
#include ".\WK7Define.h"
#include ".\WK7Stage.h"
#include ".\WK7GameInfo.h"
#include ".\WK7Skill.h"
//#include "..\Lib\ghmGcUsb.h"
#include "..\Fujita\fmain.h"
#include "..\Fujita\c_impulse.h"
#include "..\Matsu\MK7TestTask.h"
#include "..\Matsu\MK7TitleTask.h"
#include "..\Matsu\MK7SoundTask.h"
#include "..\Matsu\mK7Sound.h"
#include "..\Matsu\mK7Movie.h"
#include "..\Kaw\KK7TestTask.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Yam\YK7TestTask.h"
#include "..\Sato\SK7LogoTask.h"

#include "..\Lib\ghmGcModule.h"
#include "..\Lib\ghmGcThread.h"

#define	SCREEN_CAPTURE
#if	defined(USE_USB) && !defined(USE_ISDOLVIEWER)
#define	PLAY_SCREEN_CAPTURE
#endif

#if (!defined(_DEBUG) || defined(PLAY_SCREEN_CAPTURE)) && !defined(USE_ISDOLVIEWER)
extern	"C"{
void OSReport(const char* msg, ...)
{
#pragma	unused(msg)
//    va_list marker;
//
//    va_start(marker, msg);
//    vprintf(msg, marker);
//    va_end(marker);
}

void OSVReport(const char* msg, va_list list)
{
#pragma	unused(msg)
#pragma	unused(list)
//    vprintf(msg, list);
}
}
#endif

K7App		k7app;
ghmGcUsb	usbFile;

volatile s64	tokenStartTick = 0;

#if	defined(_DEBUG) && !defined(USE_ISDOLVIEWER) && !defined(K7APP_MASTER)
#define	K7APP_RELDEBUG_STRTBL		"/Module/k7disk1d.str"
#endif

#define	K7APP_THREAD_SUSPEND

#define	K7APP_SYSDOL_MEM_SIZE			(0x00240000)					//  2.25Mbyte
//#define	K7APP_SYSDOL_MEM_SIZE			(0x00280000)					//  2.5Mbyte
#define	K7APP_SMALL_MEM_SIZE			(0x002d4000)					//  
//#define	K7APP_SMALL_MEM_SIZE			(0x00400000)					//  4Mbyte
#define K7APP_AUDIO_MEM_SIZE			(0x00040000)					//  250Kbyte //1Mbyte(fujita.0120)
#if	defined(USE_ISDOLVIEWER) || defined(USE_USB)
#define K7APP_DEFAULT_MEM_SIZE			(GHMGCMEM_HEAPSIZE_MAX)
#else
#define K7APP_DEFAULT_MEM_SIZE			(0x00d1c8a0)					//  
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d5d8a0)					//  
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d63000)					//  
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d5d000)					//  
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d5b000)					//  13Mbyte + 300k(overlay program maxsize)
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d4b000)					//  13Mbyte + 300k(overlay program maxsize)
//#define K7APP_DEFAULT_MEM_SIZE			(0x00d00000)					//  13Mbyte
#endif

#define	K7APP_TOTAL_MEM_SIZE			(K7APP_DEFAULT_MEM_SIZE + K7APP_AUDIO_MEM_SIZE + K7APP_SMALL_MEM_SIZE + K7APP_SYSDOL_MEM_SIZE)

//#define	K7APP_DEFAULT_FIFO_SIZE			(512 * 1024)
#define	K7APP_DEFAULT_FIFO_SIZE			(256 * 1024)

#ifndef	_DEBUG
#undef	K7APP_STREAM_DEFAULT				// Yam
#define K7APP_STREAM_DEFAULT		1		// Yam
#endif


#if	!defined(_DEBUG)
#undef	PLAY_SCREEN_CAPTURE
#endif

#ifdef	USE_ISDOLVIEWER
#include <isdol.h>
#endif

#if	defined(ORBITAL) && !defined(_VIEWER_ONLY)
#define	_VIEWER_ONLY
#endif

#ifndef	K7APP_START_TASK
#define	K7APP_START_TASK		WK7MenuTask
#endif

#ifdef	USE_ISDOLVIEWER
#ifdef	K7APP_START_TASK
#undef	K7APP_START_TASK
#endif
#define	K7APP_START_TASK		WK7MenuTask
//#define	K7APP_START_TASK		WK7ViewerTask
#endif

#ifdef	_VIEWER_ONLY
#ifdef	K7APP_START_TASK
#undef	K7APP_START_TASK
#endif
#define	K7APP_START_TASK		WK7ViewerTask
#endif

#ifdef	K7APP_MASTER
#undef	K7APP_DEFAULT_CLEARCOLOR
#define	K7APP_DEFAULT_CLEARCOLOR	{0x00,0x00,0x00,0x00}
#endif

//#undef	K7APP_START_TASK
//#define	K7APP_START_TASK		WK7MenuTask

class K7AppInitTask : public ghmGcAppTask{
protected:
	int					mProc;
	ghmGcMem			*mpAudioMem;
public:
	K7AppInitTask(ghmGcMem *pAudioMem,ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~K7AppInitTask();
	
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
};

K7AppInitTask::K7AppInitTask(ghmGcMem *pAudioMem,ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	mProc = 0;
	mpAudioMem=pAudioMem;
}

K7AppInitTask::~K7AppInitTask(void)
{
}

bool K7AppInitTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	
#ifdef	_DEBUG
#if	defined(K7APP_STREAM_DEFAULT) && K7APP_STREAM_DEFAULT!=0
	gpSound->mSetSoundDebug(true);
#else
	gpSound->mSetSoundDebug(false);
#endif
#endif
	
	delete this;
	
	// ^XNN
	ghmGcAppTask	*pInitialTask;
	ghmGcMemSetAllocName("InitTask");
//	pInitialTask = new WK7MenuTask(pApp);
	pInitialTask = new K7APP_START_TASK(pApp);
	pInitialTask->Initialize();
	return true;
}

bool K7AppInitTask::FrameProcess(void)
{
	// [fBO
	switch( mProc ){
	case	0:
#ifdef	K7APP_RELDEBUG_STRTBL
		ghmGcModule::InitializeAll(K7APP_RELDEBUG_STRTBL);
#else
		ghmGcModule::InitializeAll();
#endif
		mProc++;
		break;
	case	1:
		if( ghmGcModule::IsInitialized()==false ){
			break;
		}
		mProc++;
	case	2:
		if( MK7Sound::ReadSem() == false )
		{
			break;
		}
		MK7Sound::Init( *mpAudioMem );
		ghmGcFile::SetUseDevCom(true);
		gpSound->mReadSsm( "seSystem.ssm", eBankSystem );
		gpSound->mReadSsm( "seBattle.ssm", eBankBattle );
		mProc++;
		break;
	case	3:
#ifdef	_DEBUG
		WK7CAM->LoadArchive("/Wat/crystal.dat");
#endif
		mProc++;
		break;
	case	4:
		if( WK7CAM->IsLoadedArchive()==false ){
			break;
		}
		mProc++;
	case	5:
		if( C_Font::GetInstance()==NULL ){
			break;
		}
		mProc++;
	case	6:
		PARTICLE.Init();
		mProc++;
		break;
	case	7:
		if( PARTICLE.GetInitProc() < 0 ){
			mProc++;
		}
		break;
	default:
		DeleteTerminate();
		break;
	}
	
	PARTICLE.InitProc();
	
	C_Font::Proc();
	
	WK7CAM->LoadProcess();
	
	// A[JCuRg[
	WK7Archive::FrameProcessAll();
	
	return true;
}


K7App::K7App()
{
	mpMainThread = NULL;
//	mThreadSuspended = false;
	mSemaCnt = 0;
	mpResetProcessCallback = NULL;
	mResetProcessCallbackParam = 0;
}

K7App::~K7App()
{
}

void K7App::K7AppPreRetraceCallBack(u32 retraceCount)
{
	ghmGcApp::PreRetraceCallBack(retraceCount);
//	s32		tmp;
//	tmp = OSDiffTick(OSGetTime(),tokenStartTick);
//	if( tmp >= OS_TIMER_CLOCK * 60 / WK7_FRAME_RATE ){//	if( tmp >= OS_TIMER_CLOCK * 4 / WK7_FRAME_RATE ){
//		GXAbortFrame();
//		GXSetDrawDone();
//		OSReport("GXAbortFrame\n");
//	}
	SEARCHDS(GETDS());
#ifdef	K7APP_THREAD_SUSPEND
	if( mRetraceFlag==true && WK7Sight::GetDrawDone()==true ){
		k7app.SuspendMainThread(false);
	}
#endif
}
//	GXAbortFrame();

void K7App::K7AppPostRetraceCallBack(u32 retraceCount)
{
	ghmGcApp::PostRetraceCallBack(retraceCount);
}

bool K7App::SuspendMainThread(bool flag)
{
//	if( flag==mThreadSuspended ){
//		return true;
//	}
	if( mpMainThread==NULL ){
		return false;
	}
	if( flag==true ){
//		if( OSIsThreadSuspended(mpMainThread)==FALSE ){
//			OSSuspendThread(mpMainThread);
//		}
		mSemaCnt++;
		OSWaitSemaphore(&mSema);
	}else{
		if( mSemaCnt > 0 ){
			mSemaCnt--;
			OSSignalSemaphore(&mSema);
		}
//		if( OSIsThreadSuspended(mpMainThread)==TRUE ){
//			OSResumeThread (mpMainThread);
//		}
	}
//	mThreadSuspended = flag;
	return true;
}

bool K7App::Initialize(void)
{
	
	void			*pFIFO;
//	ghmGcAppTask	*pInitialTask;
	bool			result;
	
	PPCMthid0(PPCMfhid0() | HID0_SPD);
	
	OSInit();											// nr
	
	// NbZ[W
	OSDebugReport("program start\n");
	OSDebugReport("DolphinSDK ver %s %s\n",__SDKVER__,__SDKPATCH__);
	
	mpMainThread = OSGetCurrentThread();
//	mThreadSuspended = false;
	OSInitSemaphore(&mSema,0);
	
	tokenStartTick = OSGetTime();
	
#ifdef	_DEBUG
	mSmallMemDebugPrintTaskID   = -1;
	mAudioMemDebugPrintTaskID   = -1;
	mDefaultMemDebugPrintTaskID = -1;
#endif
	
#ifdef	USE_ISDOLVIEWER
	ghmGcUsb::InitializeISDOL();
#endif
	
#ifdef	USE_USB
	usbFile.Initialize();
#endif
	
	// }l[W
	ghmGcMem::SetTotalHeapNum(4);						// sysdolphinp + ghmGcMemp~2 + Audio(fujita.0120)
	ghmGcMem::Initialize();								// }l[W
	
#ifdef	_DEBUG
	if( (u32)ghmGcMem::GetArenaLo() > 0x80400000 ){
		OSReport(">>>>> Warning : Program Size Over 4Mbyte (0x%08x)!! <<<<<\n",(u32)ghmGcMem::GetArenaLo() & 0x0fffffff);
	}
#endif
	
	// sysdolphinOtBbNݒimۂ̊֌Wł̏ԁj
//	HSD_SetInitParameter(HSD_INIT_RENDER_MODE_OBJ,&GXNtsc480Int);
	HSD_SetInitParameter(HSD_INIT_XFB_MAX_NUM,2);
//	HSD_AllocateXFB(2,&GXNtsc480IntDf);
//	HSD_AllocateXFB(2,&GXNtsc480Prog);
	HSD_AllocateXFB(2,&GXNtsc480Int);
//	HSD_AllocateXFB(HSD_DEFAULT_XFB_MAX_NUM,&GXNtsc480IntDf);
	pFIFO = HSD_AllocateFIFO(K7APP_DEFAULT_FIFO_SIZE);
	HSD_GXSetFifoObj(GXInit(pFIFO,K7APP_DEFAULT_FIFO_SIZE));
	
	// ݂̃A[i擾i}l[WŊǗj
	ghmGcMem::GetCurrentArena();
	
	mSysdolMem            .AssignHeap(K7APP_SYSDOL_MEM_SIZE);
	mSysdolMem            .SetRenderColor(0x00ff00ff);
	
	mSmallMem             .CreateHeap(K7APP_SMALL_MEM_SIZE );
	mSmallMem             .SetRenderColor(0x0000ffff);
	
	mAudioMem             .CreateHeap(K7APP_AUDIO_MEM_SIZE,false);
	mAudioMem             .SetRenderColor(0xffff00ff);
	
	ghmGcMem::mDefaultHeap.CreateHeap(K7APP_DEFAULT_MEM_SIZE);
//	ghmGcMem::mDefaultHeap.CreateHeap(GHMGCMEM_HEAPSIZE_MAX);
	ghmGcMem::mDefaultHeap.SetRenderColor(0xff0000ff);
	
	ghmGcThread::Initialize();
	ghmGcThread::SetAllocHeap(&mSmallMem);
	
	// t@C}l[W
	ghmGcFile::Initialize();
	
	// cuc
	DVDInit();
	
	// tHgpm
//	C_Font::GetInstance();
	
	// new default operator ύX
	ghmGcMem::SetNewHeap(&mSmallMem);
	ghmGcTask::SetAllocHeap(&mSmallMem);
	ghmGcTask::SetReserveAllocHeap(&ghmGcMem::mDefaultHeap);
	
	// sysdolphin
	HSD_SetInitParameter(HSD_INIT_HEAP_ARENA,
	                     (int)mSysdolMem.GetTopAddr(),
	                     (int)mSysdolMem.GetEndAddr());
//	HSD_SetInitParameter(HSD_INIT_HEAP_MAX_NUM,0);
	HSD_SetPixelFmt(GX_PF_RGBA6_Z24, GX_ZC_LINEAR);
	HSD_VISetClearZ(GX_MAX_Z24);
	HSD_VISetGamma(GX_GM_1_0);
	OSSetArenaLo(mSysdolMem.GetTopAddr());
	OSSetArenaHi(mSysdolMem.GetEndAddr());
	HSD_InitComponent();
	mSysdolMem    .ReportAssignHeapHandle(HSD_GetHeap());
	
	// pbhCu
	HSD_PadInit(K7APP_PAD_QUEUE_SIZE,mPadQueue,0,NULL);
	HSD_PadSetRepeat(16 * WK7_FRAME_RATE / 60,4 * WK7_FRAME_RATE / 60);
	
	// Video oenableB
	// ۂ̐ݒvsync荞݂̃R[obNōs
	//\B(Ptڂɂ݂oȂ)
	HSD_VISetClearClr((GXColor)K7APP_DEFAULT_CLEARCOLOR);
	HSD_VISetBlack(GX_FALSE);
	
	HSD_PadSetClampAnalogAB(0,230,10);
	HSD_PadSetScaleAnalogAB(230-10);
	HSD_PadSetClampAnalogLR(0,230,10);
	HSD_PadSetScaleAnalogLR(230-10);
	HSD_PadSetClampStick   (HSD_PAD_CLAMP_CIRCLE, HSD_PAD_CLAMP_SHIFT, 90, 10);
	HSD_PadSetScaleStick   (90-10);
	
	HSD_StateSetDither(TRUE);
//	HSD_SetZSortMode(TRUE,FALSE);
	HSD_SetZSortMode(TRUE,TRUE);
	GXSetMisc( GX_MT_XF_FLUSH, GX_XF_FLUSH_SAFE );
	
	WK7Fade::Initialize();
//	FadeStart(0xff,0);
//	FadeStart(0x00,WK7_TICK_PER_SEC);
	
	mPerfMeter.SetAllocFunc(::operator new);
	mPerfMeter.SetFreeFunc (::operator delete);
	
#ifdef	_DEBUG
	mDebugPrintTaskController.Initialize();
#endif
	
	//audio B(fujita.0120)
	{
#if	0
#if	1	//2003.05.19 Matsuzaki
		static u8*	playlist;
		mK7File		file;
		//PlayListt@Cǂݍ
		file.mK7FileReadB( "/sound/se/se.sem", &(void*)playlist );
		//
		MK7Sound::Init( mAudioMem, playlist );
		ghmGcFile::SetUseDevCom(true);
		//g`f[^ǂݍ
		gpSound->mReadSsm( "seSystem.ssm", eBankSystem );
		gpSound->mReadSsm( "seBattle.ssm", eBankBattle );
#else
	  static u8 playlist[1024 * 100] ATTRIBUTE_ALIGN(32);
	  DVDFileInfo finfo;
	  int entrynum;
	  u32 size;
	  entrynum = DVDConvertPathToEntrynum("/audio/sfx/ssmp/sample.sem");
	  DVDFastOpen(entrynum, &finfo);
	  size = OSRoundUp32B(DVDGetLength(&finfo));
	  DVDRead(&finfo, playlist, (long)DVDGetLength(&finfo), 0);
	  DVDClose(&finfo);
	  //todo ̓f[^ǂ݃Cuo琴B
	  C_Audio::Initialize( mAudioMem, playlist );
	  SND.Print();
#endif
#endif
	}
	mErrorMes.Load();
	
	WK7Model::InitializeAll();
	
	WK7Cam::Initialize();
	
	WK7Shadow::Initialize();
	
	// XNvg
	WK7Script::Initialize(K7SCRIPT_GLOBAL_FLAG_NUM,		// O[otO
	                      0,							// O[oϐchar (s8 )
	                      0,							//               short(s16)
	                      0,							//               int  (s32)
	                      0,							//               long (s64)
	                      0);							//               float(f32)
	
	
	result = ghmGcApp::Initialize();
	
	SetRetraceFrame(WK7_FRAME_COUNT);
	
	WK7CAM;
	WK7PLAYERCONTROL;
	WK7EVENTCONTROLLER;
	WK7SHADOW;
	WK7SIGHT;
	WK7SELECTIF;
	
	WK7RenderObj::GetVFX();
	USE_PARTICLE;
	IMPULSE;
	
	WK7Stage::InitWork();
	
	GameInfo.InitGlobal();
	
#ifdef	_DEBUG
	mStartTick = OSGetTime();
	memset(mTickLog,0,sizeof(mTickLog));
#endif
	
	// XL֘A
	WK7Skill::Init();
	
	WK7Sight::Initialize();
	
	//j[Q[
	BattleCtrl.InitNewGame();
	WK7PLAYERCONTROL->NewGameReset();
	
	//[r[
	MK7Movie::Init();
	
	ghmGcMemSetAllocName("ApIniTsk");
	new K7AppInitTask(&mAudioMem,this);
	
	return result;
}

bool K7App::Terminate(void)
{

#ifdef 	_DEBUG
	if( mSmallMemDebugPrintTaskID >= 0 ){
		mDebugPrintTaskController.Stop(mSmallMemDebugPrintTaskID);
		mSmallMemDebugPrintTaskID  = -1;
	}
	if( mAudioMemDebugPrintTaskID >= 0 ){
		mDebugPrintTaskController.Stop(mAudioMemDebugPrintTaskID);
		mAudioMemDebugPrintTaskID  = -1;
	}
	if( mDefaultMemDebugPrintTaskID >= 0 ){
		mDebugPrintTaskController.Stop(mDefaultMemDebugPrintTaskID);
		mDefaultMemDebugPrintTaskID  = -1;
	}
#endif
	
	WK7Shadow::Terminate();
	
	// XNvgI
	WK7Script::Terminate();
	
	WK7Cam::Terminate();
	
	WK7Model::TerminateAll();
	
	//[r[I
	MK7Movie::Term();
	
	ghmGcModule::TerminateAll();
	
	ghmGcThread::Terminate();
	
	return true;
}

bool K7App::SetRetraceCallBack(void)
{
	HSD_VISetUserPreRetraceCallback (K7AppPreRetraceCallBack );
	HSD_VISetUserPostRetraceCallback(K7AppPostRetraceCallBack);
	return true;
}

#ifdef	K7APP_HEAPCHECK
bool K7App::CheckHeap(ghmGcMem &heap,int &taskid,const char *pheapname)
{
#pragma	unused(heap)
#pragma	unused(taskid)
#pragma	unused(pheapname)
#if	defined(_DEBUG) && !defined(K7APP_MASTER) 
	if( heap.Check()==NULL ){
		if( taskid >= 0 ){
			mDebugPrintTaskController.Stop(taskid);
			taskid = -1;
		}
	}else{
		if( taskid < 0 ){
			char		str[256];
			sprintf(str,"%s is Broken !!",pheapname);
			taskid = K7AppDebugPrintSec(str,-1.0f);
			OSReport(str);
		}
	}
#endif
	return true;
}

bool K7App::CheckHeap(void)
{
	CheckHeap(mSmallMem             ,mSmallMemDebugPrintTaskID  ,"small heap"  );
	CheckHeap(mAudioMem             ,mAudioMemDebugPrintTaskID  ,"audio heap"  );
	CheckHeap(ghmGcMem::mDefaultHeap,mDefaultMemDebugPrintTaskID,"default heap");
	return true;
}
#endif

bool K7App::ResetProcess(void)
{
	switch( mResetProc ){
	case	0:
		if( mResetEnable==false ){
			break;
		}
		if( ghmGcFile::GetDriveState()==DVD_STATE_FATAL_ERROR ){
			break;
		}
		if( OSGetResetButtonState()==FALSE ){
			break;
		}
		mResetProc = 1;
		break;
	case	1:
		if( OSGetResetButtonState()==TRUE ){
			break;
		}
		mResetProc = 2;
	case	2:
		if( mpResetProcessCallback != NULL ){
			if( mpResetProcessCallback(mResetProcessCallbackParam)==false ){
				break;
			}
		}
//		MK7Sound::Term();
		VISetBlack(TRUE);
		VIFlush();
		VIWaitForRetrace();
		mResetProc = 0;
		OSResetSystem(mResetParam,mResetCode,mResetForceMenu);
		return true;
	default:
		break;
	}
	return false;
}

bool K7App::Run(void)
{
	bool	result = true;
#if	!defined(K7APP_MASTER)
//	u32		oc;
//	u32		ocmax = 0;
	mainMenu.SetModeInfo(false);
#if	defined(K7APP_MODEINFO)
	mainMenu.SetModeInfo(K7APP_MODEINFO!=0);
#endif
#if	defined(K7APP_GXWARNING)
	mainMenu.SetGxWarning(K7APP_GXWARNING!=0);
#endif
#endif
	
	GXResetOverflowCount();
	
	while( mTerminate==false ){
		
		// VBlank
		
		if( (result=SynchronizeVBlank())==false ){
			break;
		}
		
#if	!defined(K7APP_MASTER)
//		oc = GXGetOverflowCount();
//		GXResetOverflowCount();
//		
//		if( ocmax < oc ){
//			ocmax = oc;
//		}
#endif
		
		// Zbg
		if( ResetProcess()==true ){
			break;
		}
		
		// t@C
		ghmGcFile::FrameProcessAll();
		
		// _O
		
		//if(gpMovie!=NULL)gpMovie->mRender();	//[r[_O
		
		if( (result=PreRenderProcess())==false ){
			break;
		}
		if( (result=RenderProcess())==false ){
			break;
		}
		if( (result=PostRenderProcess())==false ){
			break;
		}
		
		mFade.RenderProcess();
		
		mErrorMes.RenderProcess();
		
		ghmGcModule::RenderProcessAll();
		
		// t@C
		ghmGcFile::RenderProcessAll();
		
#ifdef	K7APP_HEAPCHECK
		CheckHeap();
#endif
		
#if	!defined(K7APP_MASTER)
//		if( mainMenu.GetModeInfo()==true ){
//			C_Paper		paper(32,420);
//			PRINTF("OC = %d(%d)\n",oc,ocmax);
//		}
#endif
		
		// tHg`
		if( C_Font::GetInstance()!=NULL ){
			C_Font::GetInstance()->Draw();
		}
		
		// ̎gp󋵕\
		ghmGcMem::RenderAll();
		
#if	defined(_DEBUG) && defined(SCREEN_CAPTURE) && defined(USE_USB)
		_ScreenCapture();
#endif
		
		// t[
		
		if(gpMovie!=NULL)gpMovie->mFrameProcess();	//[r[t[
		
		if( (result=PreFrameProcess())==false ){
			break;
		}
		if( (result=FrameProcess())==false ){
			break;
		}
		if( (result=PostFrameProcess())==false ){
			break;
		}
		
		ghmGcModule::FrameProcessAll();
		
#if 0
		if( (HSD_PadGetButton(1) & HSD_PAD_A) && (HSD_PadGetTrigger(1) & HSD_PAD_START) ){
			DumpMemory(0);
		}
#endif
		
		mFade.FrameProcess();
	}
	
#ifdef	USE_USB
	usbFile.Terminate();
#endif
	
#ifdef	_DEBUG
	mDebugPrintTaskController.Terminate();
#endif
	
	return true;
}

bool K7App::PreFrameProcess(void)
{
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	return ghmGcApp::PreFrameProcess();
}

bool K7App::FrameProcess(void)
{
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	return ghmGcApp::FrameProcess();
}

bool K7App::PostFrameProcess(void)
{
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	return ghmGcApp::PostFrameProcess();
}

//bool K7App::PreRenderProcess(void)
//{
//	if( ghmGcFile::IsDiskStandby()==false ){
//		return true;
//	}
//	return ghmGcApp::PreRenderProcess();
//}

//bool K7App::PostRenderProcess(void)
//{
//	if( ghmGcFile::IsDiskStandby()==false ){
//		return true;
//	}
//	return ghmGcApp::PostRenderProcess();
//}

bool K7App::RenderProcess(void)
{
	bool	result;
	
//	if( ghmGcFile::IsDiskStandby()==false ){
//		return true;
//	}
	
	// _OJn
	HSD_StartRender(HSD_RP_SCREEN);
	
	result = ghmGcApp::RenderProcess();
	
	// _OI
	HSD_EndRender();
	
#ifdef	_DEBUG
	{
		C_Paper	paper(0,0,0.75f);
		PRINTF("\n");
		mDebugPrintTaskController.FrameProcess();
	}
#endif
	
	return result;
}

//bool K7App::PostRenderProcess(void)
//{
//	return ghmGcApp::PostRenderProcess();
//}

extern	void testcb(int arg);
bool K7App::SynchronizeVBlank(void)
{
	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
	HSD_VICopyXFBASync             (HSD_RP_SCREEN);
//	WK7Sight::WaitSyncToken();
//	HSD_VISetUserGXDrawDoneCallback(testcb);
//	HSD_VISetUserGXDrawDoneCallback(HSD_VIDrawDoneXFB);
	
	ghmGcAppTask		*pTask;
	ghmGcAppTask		*pNext;
	
	for(pTask=mTaskAnchor.GetNext() ; pTask!=NULL ; pTask=pNext){
		pNext = pTask->GetNext();
		switch( pTask->GetState() ){
		case	ghmGcAppTask::TERM:
			if( pTask->Terminate()==false ){
				break;
			}
		case	ghmGcAppTask::DELETE:
			delete pTask;
			break;
		case	ghmGcAppTask::INIT:
			pTask->Initialize();
			break;
		default:
			pTask->ResetFlag(GHMGCAPPTASK_PROCESSFLAGALL);
			break;
		}
	}
	
	// ptH[}X[^[I
	mPerfMeter.End();
	
#ifdef	K7APP_THREAD_SUSPEND
	SuspendMainThread(true);
#endif
	
	while( mRetraceFlag==false ){}
	
	CLRDS();
	
#ifdef	_DEBUG
	mStartTick = OSGetTime();
#endif
	
	mRetraceFlag = false;
	mRetraceFrameCount = 0;
	mRefreshCount++;
	
	// ptH[}X[^[vJn
	mPerfMeter.Start();
	
	// pbhXV
	BOOL intr;
	intr = OSDisableInterrupts();	/* 荞݋֎~ */
	HSD_PadRenewStatus();
	OSRestoreInterrupts(intr);		/* 荞݋ */
	return true;
}

#ifdef	_DEBUG
void* K7App::SmallAlloc(int size,const char *pident,u32 line)
{
	return mSmallMem.Alloc(size,pident,line);
#else
void* K7App::SmallAlloc(int size)
{
	return mSmallMem.Alloc(size);
#endif
}

bool K7App::SmallFree(void *pMem)
{
#ifdef	_DEBUG
	if( pMem==NULL ){
		OSReport("SmallFree Error !! -> NULL ptr\n");
		return false;
	}
#endif
	return ghmGcMem::Free(pMem);
}

long K7App::SmallGetFreeSize(void)
{
	return mSmallMem.GetFreeSize();
}

#ifdef	_DEBUG
bool K7App::MeasureTick(int id,bool clear)
{
	if( id < 0 || id >= K7APP_TICKLOGNUM ){
		return false;
	}
	if( clear==true ){
		mTickLog[id] = 0;
	}
	s32		tmp;
	tmp = OSDiffTick(OSGetTime(),mStartTick); 
	if( mTickLog[id] < tmp ){
		mTickLog[id] = tmp;
	}
	return true;
}

void K7App::DumpTickLog(int num)
{
	int		i;
	if( num < 0 || num > K7APP_TICKLOGNUM ){
		num = K7APP_TICKLOGNUM;
	}
	for(i=0 ; i<num ; i++){
		OSReport("%02d = %d\n",i,mTickLog[i]);
	}
}

void K7App::ClearTickLog(void)
{
	memset(mTickLog,0,sizeof(mTickLog));
}

bool K7App::OSDumpMemory(int type)
{
	if( type==0 || (type & 1) ){
		ghmGcMem::mDefaultHeap.OSDump();
	}
	if( type==0 || (type & 2) ){
		mSmallMem.OSDump();
	}
	return true;
}

int K7App::DumpMemory(int type)
{
	int		dc = -1,sc = -1;
	if( type==0 || (type & 1) ){
		OSReport("DefaultMem\n");
		dc = ghmGcMem::mDefaultHeap.Dump();
	}
	if( type==0 || (type & 2) ){
		OSReport("SmallMem\n");
		sc = mSmallMem.Dump();
	}
	switch( type ){
	case	0:
		OSReport("TotalAllocCount : %d(%d,%d)\n",dc+sc,dc,sc);
		break;
	case	1:
		OSReport("DefaultMemAllocCount : %d\n",dc);
		break;
	case	2:
		OSReport("SmallMemAllocCount : %d\n",sc);
		break;
	default:
		break;
	}
	return dc+sc;
}

int K7App::DebugPrint(const char *pstr,f32 sec)
{
#ifdef	PLAY_SCREEN_CAPTURE
	return -1;
#endif
#ifdef	USE_ISDOLVIEWER
	return -1;
#endif
	int		len;
	if( pstr==NULL || (len=(int)strlen(pstr))<=0 ){
		return -1;
	}
	ghmGcMemSetAllocName("K7AppDP");
	char	*pAllocString = (char *)K7AppSmallMemAlloc(len + 1);
	if( pAllocString==NULL ){
		return -1;
	}
	strcpy(pAllocString,pstr);
	int				taskid;
	if( (taskid=mDebugPrintTaskController.Start(DebugPrintTask,
	                                            DebugPrintTaskTerm,
	                                            (u32)pAllocString,
	                                            *((u32 *)&sec),
	                                            NULL,
	                                            0x1000,
	                                            256)) < 0 ){
		GHMGCMEM_SAFE_FREE(pAllocString);
		return -1;
	}
	return taskid;
}

void K7App::DebugPrintTask(ghmGcTask *pTask)
{
	char	*pstr = (char *)pTask->GetParam(0);
	u32		secul =         pTask->GetParam(1);
	f32		sec   = *((f32 *)&secul);
	bool	keep  = false;
	if( sec < 0.0f ){
		sec  = 1.0f;
		keep = true;
	}
	while( sec > 0.0f ){
		PRINTF("  ");
		PRINTF(pstr);
		PRINTF("\n");
		if( keep==false ){
			sec -= WK7_INV_FRAME_RATE;
		}
		GHMGCTASK_RETSYS();
	}
}

void K7App::DebugPrintTaskTerm(ghmGcTask *pTask)
{
	const char		*pstr = (const char *)pTask->GetParam(0);
	GHMGCMEM_SAFE_FREE(pstr);
}

bool K7App::DebugPrintDelete(void)
{
	mDebugPrintTaskController.Terminate();
	return true;
}
#endif

#pragma options align= packed

struct BITMAPINFOHEADER{
	u32		biSize;
	u32		biWidth;
	u32		biHeight;
	u16		biPlanes;
	u16		biBitCount;
	u32		biCompression;
	u32		biSizeImage;
	u32		biXPelsPerMeter;
	u32		biYPelsPerMeter;
	u32		biClrUsed;
	u32		biClrImportant;
}ATTRIBUTE_ALIGN(2);

struct BITMAPFILEHEADER{
	u16		bfType;
	u32		bfSize;
	u16		bfReserved1;
	u16		bfReserved2;
	u32		bfOffBits;
}ATTRIBUTE_ALIGN(2);

struct RGBQUAD{
	u8		rgbBlue;
	u8		rgbGreen;
	u8		rgbRed;
	u8		rgbReserved;
};

struct ORG_AR{
	u8		a;
	u8		r;
};

struct ORG_GB{
	u8		g;
	u8		b;
};

struct OUTRGB{
	u8		rgbBlue;
	u8		rgbGreen;
	u8		rgbRed;
};

#define	BI_RGB			0L
#define	BI_RLE8			1L
#define	BI_RLE4			2L
#define	BI_BITFIELDS	3L

#define	CONV_ENDIAN_S(sval)		\
	{ \
		u16		tmp = (u16)(sval); \
		u8		*psrc,*pdst; \
		psrc = ((u8 *)&tmp)+1; \
		pdst = (u8 *)&sval; \
		for(int i=2 ; i>0 ; i--){ \
			*pdst++ = *psrc--; \
		} \
	}
	
#define	CONV_ENDIAN_L(lval)		\
	{ \
		u32		tmp = (u32)(lval); \
		u8		*psrc,*pdst; \
		psrc = ((u8 *)&tmp)+3; \
		pdst = (u8 *)&(lval); \
		for(int i=4 ; i>0 ; i--){ \
			*pdst++ = *psrc--; \
		} \
	}

struct BITMAPHEADER{
	BITMAPFILEHEADER	fileHeader;
	BITMAPINFOHEADER	infoHeader;
}ATTRIBUTE_ALIGN(4);

class Bitmap{
private:
	u32					mWidth;
	u32					mHeight;
	void				*mpImage;
	u32					mImageSize;
public:
	Bitmap(u32 w,u32 h);
	~Bitmap();
	
	bool Flush(void);
	bool SetRGB(int x,int y,u8 r,u8 g,u8 b);
	inline void *GetImage(void){ return mpImage; }
	inline u32 GetImageSize(void){ return mImageSize; }
};

Bitmap::Bitmap(u32 w,u32 h)
{
	mWidth     = w;
	mHeight    = h;
	mImageSize = sizeof(u8) * 3 * w * h;
	mpImage    = ghmGcMemAlloc((int)mImageSize);
	if( mpImage==NULL ){
		ghmGcMemSetAllocName("BitmapIM");
		mpImage = K7AppSmallMemAlloc((int)mImageSize);
	}
	if( mpImage!=NULL ){
		memset(mpImage,0xff,mImageSize);
		DCFlushRange(mpImage,mImageSize);
	}
}

Bitmap::~Bitmap()
{
	GHMGCMEM_SAFE_FREE(mpImage);
}

bool Bitmap::Flush(void)
{
	if( mImageSize <= 0 || mpImage==NULL ){
		return false;
	}
//	DCInvalidateRange(mpImage,mImageSize);
//	DCStoreRange(mpImage,mImageSize);
	DCFlushRange(mpImage,mImageSize);
	return true;
}

bool Bitmap::SetRGB(int x,int y,u8 r,u8 g,u8 b)
{
	if( mpImage == NULL || x < 0 || x >= mWidth || y < 0 || y >= mHeight ){
		return false;
	}
	
	OUTRGB	*pRGB = (OUTRGB *)mpImage;
	
	pRGB += (mWidth * (mHeight-1 - y) + x);
	
	pRGB->rgbRed   = r;
	pRGB->rgbGreen = g;
	pRGB->rgbBlue  = b;
	
	return true;
}

#ifdef	_DEBUG
#ifdef	USE_USB
//#ifdef	USE_ISDOLVIEWER
//#define	CAPTURE_PAD				0
//#else
#define	CAPTURE_PAD				1
//#endif

#define	CAPTURE_BUTTON_RGBA		HSD_PAD_X
#define	CAPTURE_BUTTON_RGB		HSD_PAD_Y
#define	CAPTURE_BUTTON_Z		HSD_PAD_Z
#define	CAPTURE_DATE_FILE_NAME

//#ifdef	USE_USB
#if	defined(USE_USB) && !defined(USE_ISDOLVIEWER) && defined(PLAY_SCREEN_CAPTURE)
static	bool	captureMode       = false;
static	bool	playCaptureMode   = true;
static	bool	ps2Mode           = true;
#else
static	bool	captureMode       = false;
static	bool	playCaptureMode   = false;
static	bool	ps2Mode           = false;
#endif
void SetCaptureMode(bool flag)
{
	captureMode = flag;
}
bool GetCaptureMode(void)
{
	return captureMode;
}
void SetPlayCaptureMode(bool flag)
{
	playCaptureMode = flag;
}
bool GetPlayCaptureMode(void)
{
	return playCaptureMode;
}
void SetPS2Mode(bool flag)
{
	ps2Mode = flag;
}
bool GetPS2Mode(void)
{
	return ps2Mode;
}
		int		captureFrameStart = 0;
static	int		captureFrame = 0;
#define	CAPTURE_FRAME_INTERVAL		(4)
bool K7App::_ScreenCapture(void)
{
	u32		btn = HSD_PadGetButton(CAPTURE_PAD);
	bool	interval = true;
	
	switch( btn & (CAPTURE_BUTTON_RGBA|CAPTURE_BUTTON_RGB|CAPTURE_BUTTON_Z) ){
	case	CAPTURE_BUTTON_RGBA:
		interval = false;
		break;
	case	CAPTURE_BUTTON_RGB:
	case	CAPTURE_BUTTON_Z:
		break;
	default:
#ifdef	PLAY_SCREEN_CAPTURE
		if( GetPlayCaptureMode()==true ){
			WK7Play	*pPlay;
			if( (pPlay = WK7Play::GetCurrentPlay())!=NULL && pPlay->IsPlaying()==true ){
				int		frame = pPlay->GetPlayFrame();
//				int		frame = pPlay->GetPlayCount() / WK7_FRAME_COUNT;
				if( frame >= captureFrameStart ){
					char	fname[256];
					char	rname[256];
					pPlay->GetFileName(rname,false);
					sprintf(fname,"%s_%05d.bmp",rname,frame);
					ScreenCapture(CAPTURE_RGB,fname);
					return true;
				}
			}
		}
#endif
//		captureFrame = 0;
		return false;
	}
	if( interval==true ){
		if( captureFrame % CAPTURE_FRAME_INTERVAL ){
			captureFrame++;
			return true;
		}
	}
	
#ifdef	CAPTURE_DATE_FILE_NAME
	OSCalendarTime	ctime;
	OSTicksToCalendarTime(OSGetTime(),&ctime);
#endif
	int		index = captureFrame / CAPTURE_FRAME_INTERVAL;
	char	fname[256];
	if( btn & CAPTURE_BUTTON_RGBA ){
#ifdef	CAPTURE_DATE_FILE_NAME
		sprintf(fname,"%04d%02d%02d%02d%02d%02dRGB.bmp",ctime.year,ctime.mon+1,ctime.mday,ctime.hour,ctime.min,ctime.sec);
//		sprintf(fname,"%04d%02d%02d%02d%02d%02dRGBA.bmp",ctime.year,ctime.mon+1,ctime.mday,ctime.hour,ctime.min,ctime.sec);
#else
		sprintf(fname,"ScreenCaptureRGB%03d.bmp",index);
//		sprintf(fname,"ScreenCaptureRGBA%03d.bmp",index);
#endif
		ScreenCapture(CAPTURE_RGB,fname);
//		ScreenCapture(CAPTURE_RGBA,fname);
	}else if( btn & CAPTURE_BUTTON_RGB ){
#ifdef	CAPTURE_DATE_FILE_NAME
		sprintf(fname,"%04d%02d%02d%02d%02d%02d.bmp",ctime.year,ctime.mon+1,ctime.mday,ctime.hour,ctime.min,ctime.sec);
#else
		sprintf(fname,"ScreenCapture%03d.bmp",index);
#endif
		ScreenCapture(CAPTURE_RGB,fname);
	}else if( btn & CAPTURE_BUTTON_Z ){
#ifdef	CAPTURE_DATE_FILE_NAME
		sprintf(fname,"%04d%02d%02d%02d%02d%02dZ.bmp",ctime.year,ctime.mon+1,ctime.mday,ctime.hour,ctime.min,ctime.sec);
#else
		sprintf(fname,"ScreenCaptureZ%03d.bmp",index);
#endif
		ScreenCapture(CAPTURE_Z,fname);
	}
	
	captureFrame++;
	return true;
}

bool K7App::ScreenCapture(int mode,const char *pfname)
{
	
	WK7ScreenImage		image;
	
	switch( mode ){
	case	CAPTURE_RGB:
	case	CAPTURE_A:
	case	CAPTURE_RGBA:
		image.SetFormat(GX_TF_RGBA8);
		break;
	case	CAPTURE_Z:
		image.SetFormat(GX_TF_Z24X8);
		break;
	default:
		return false;
	}
	
	if( pfname==NULL ){
		switch( mode ){
		case	CAPTURE_RGB:
			pfname = "ScreenCaptureRGB.bmp";
			break;
		case	CAPTURE_A:
			pfname = "ScreenCaptureA.bmp";
			break;
		case	CAPTURE_RGBA:
			pfname = "ScreenCaptureRGBA.bmp";
			break;
		case	CAPTURE_Z:
			pfname = "ScreenCaptureZ.bmp";
			break;
		}
	}
	
	void				*pData;
	void				*pBitmapImage;
	BITMAPHEADER		*pheader = (BITMAPHEADER *)ghmGcMemAlloc(sizeof(BITMAPHEADER));
	u16					w,h;
	u32					dataSize;
	
	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
	
#ifdef	USE_ISDOLVIEWER
	image.AllocBuffer();
#else
	image.AllocBuffer((void *)0x81800000);
#endif
	pData = image.GetTexture();
	DCFlushRange(pData,image.GetTexSize());
	image.ScreenCopy();
	
	WK7Sight::DrawSyncToken();
	WK7Sight::WaitSyncToken();
//	VIWaitForRetrace();
//	VIWaitForRetrace();
	while( mRetraceFlag==false ){}
//	GXFlush();
//	GXWaitDrawDone();
//	pData = image.GetTexture();
	image.GetSize(&w,&h);
	
	Bitmap				bitmap (w,h);
	Bitmap				*pbitmapex = NULL;
	
	if( bitmap.GetImage()==NULL ){
		OSReport("bitmap memory allocation error!!\n");
		return false;
	}
	
	if( mode==CAPTURE_RGBA ){
		ghmGcMemSetAllocName("Bitmap");
		if( (pbitmapex = new Bitmap(w,h))==NULL || pbitmapex->GetImage()==NULL ){
			OSReport("bitmap memory allocation error!!\n");
			return false;
		}
	}
	
	memset(pheader,0,sizeof(BITMAPHEADER));
	
	ORG_AR				*pOrgAR;
	ORG_GB				*pOrgGB;
	int					x,y,dx,dy;
	
	pOrgAR  = (ORG_AR *)(     pData     );
	pOrgGB  = (ORG_GB *)((u32)pData + 32);
	for(y=0 ; y<h ; y+=4){
		for(x=0 ; x<w ; x+=4){
			for(dy=0 ; dy<4 ; dy++){
				for(dx=0 ; dx<4 ; dx++,pOrgAR++,pOrgGB++){
					switch( mode ){
					case	CAPTURE_RGB:
						bitmap.SetRGB(x+dx,y+dy,pOrgAR->r,pOrgGB->g,pOrgGB->b);
						break;
					case	CAPTURE_A:
						bitmap.SetRGB(x+dx,y+dy,pOrgAR->a,pOrgAR->a,pOrgAR->a);
						break;
					case	CAPTURE_RGBA:
						bitmap.SetRGB(x+dx,y+dy,pOrgAR->r,pOrgGB->g,pOrgGB->b);
						pbitmapex->SetRGB(x+dx,y+dy,pOrgAR->a,pOrgAR->a,pOrgAR->a);
						break;
					case	CAPTURE_Z:
						bitmap.SetRGB(x+dx,y+dy,pOrgAR->r,pOrgGB->g,pOrgGB->b);
						break;
					}
				}
			}
			pOrgAR+=16;
			pOrgGB+=16;
		}
	}
	
	bitmap.Flush();
	if( pbitmapex!=NULL ){
		pbitmapex->Flush();
	}
	
	pBitmapImage = bitmap.GetImage();
	dataSize     = bitmap.GetImageSize();
	
	// \̏
	pheader->fileHeader.bfType          = 0x4d42;					// 'BM'
	pheader->fileHeader.bfSize          = 0;							// t@CTCY
	pheader->fileHeader.bfReserved1     = 0;							// \iKOj
	pheader->fileHeader.bfReserved2     = 0;							// \iKOj
	pheader->fileHeader.bfOffBits       = sizeof(BITMAPFILEHEADER)
	                                    + sizeof(BITMAPINFOHEADER);	// rbg}bvf[^܂ł̃ItZbg
	
	CONV_ENDIAN_S(pheader->fileHeader.bfType);
	
	pheader->infoHeader.biSize          = sizeof(BITMAPINFOHEADER);	// \̃TCY
	pheader->infoHeader.biWidth         = w;							// 
	pheader->infoHeader.biHeight        = pbitmapex!=NULL? h*2UL : h;		// 
//	pheader->infoHeader.biHeight        = h;							// 
	pheader->infoHeader.biPlanes        = 1;							// v[iKPj
//	pheader->infoHeader.biBitCount      = 32;						// sNZ̃rbg
	pheader->infoHeader.biBitCount      = 24;						// sNZ̃rbg
	pheader->infoHeader.biCompression   = BI_RGB;					// 񈳏krbg}bv
	pheader->infoHeader.biSizeImage     = 0;							// BI_RGB̏ꍇAOłnj
	pheader->infoHeader.biXPelsPerMeter = 0;							// pixel/m
	pheader->infoHeader.biYPelsPerMeter = 0;							// pixel/m
	pheader->infoHeader.biClrUsed       = 0;							// ۂɎgpװޯ
	pheader->infoHeader.biClrImportant  = 0;							// dvȶװޯi0ׂ͂āj
	
	CONV_ENDIAN_L(pheader->infoHeader.biSize       );
	CONV_ENDIAN_L(pheader->infoHeader.biWidth      );
	CONV_ENDIAN_L(pheader->infoHeader.biHeight     );
	CONV_ENDIAN_S(pheader->infoHeader.biPlanes     );
	CONV_ENDIAN_S(pheader->infoHeader.biBitCount   );
	CONV_ENDIAN_L(pheader->infoHeader.biCompression);
	
	pheader->fileHeader.bfOffBits += sizeof(RGBQUAD) * pheader->infoHeader.biClrUsed;
	pheader->fileHeader.bfSize     = pheader->fileHeader.bfOffBits + dataSize;
	if( pbitmapex!=NULL ){
		pheader->fileHeader.bfSize += dataSize;
	}
	CONV_ENDIAN_L(pheader->fileHeader.bfSize);
	CONV_ENDIAN_L(pheader->fileHeader.bfOffBits);
	
	usbFile.Open(pfname,FIO_OPEN_CREAT|FIO_OPEN_RDWR);
	
	usbFile.Write(pheader,sizeof(BITMAPHEADER));
	usbFile.Write(pBitmapImage,dataSize);
	
	if( pbitmapex!=NULL ){
		pBitmapImage = pbitmapex->GetImage();
		usbFile.Write(pBitmapImage,dataSize);
	}
	
	usbFile.Close();
	
	GHM_SAFE_DELETE(pbitmapex);
	GHMGCMEM_SAFE_FREE(pheader);
	
	return true;
}
#endif
#endif

