////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Anim
//
// WK7Anim.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7ANIM_H__
#define	__WK7ANIM_H__

// Ԃ̒PʂTICK(=1/4800s)

class WK7Anim{
protected:
public:
	virtual bool FrameProcess(void) = 0;
};

class WK7AnimLinear : public WK7Anim{
protected:
	u32					mCurValue;					// Jgl
	u32					mDstValue;					// ڕWl
	u32					mCount;						// JE^
	u32					mTime;						// Aj[V
	s32					mDelta;						// 
public:
	WK7AnimLinear(u32 value=0);
	~WK7AnimLinear();
	virtual bool FrameProcess(void);
	
	inline u32 GetValue(void){ return mCurValue; }
	inline u32 GetCurValue(void){ return mCurValue; }
	inline u32 GetDstValue(void){ return mDstValue; }
	
	bool IsAnimating(void);
	
	bool Play(u32 dst,u32 tick);
	inline bool SetValue(u32 dst,u32 tick=0){ return Play(dst,tick); }
};

class WK7AnimLinearF : public WK7Anim{
protected:
	f32					mCurValue;					// Jgl
	f32					mDstValue;					// ڕWl
	f32					mSrcValue;					// ̒l
	u32					mCount;						// JE^
	u32					mTime;						// Aj[V
public:
	WK7AnimLinearF(f32 value=0.0f);
	~WK7AnimLinearF();
	virtual bool FrameProcess(void);
	
	inline f32 GetValue(void){ return mCurValue; }
	inline f32 GetCurValue(void){ return mCurValue; }
	inline f32 GetDstValue(void){ return mDstValue; }
	
	bool IsAnimating(void);
	
	bool Play(f32 dst,u32 tick);
	inline bool SetValue(f32 dst,u32 tick=0){ return Play(dst,tick); }
};


#endif	//__WK7ANIM_H__

