////////////////////////////////////////////////////////////////////////////////
//
// Killer7 AreaInfo
//
// WK7AreaInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/06/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7AREAINFO_H__
#define	__WK7AREAINFO_H__

//#include <dolphin.h>

struct WK7AreaFaceVertex{
	Vec						*mpVert;			// ANZXp
	u16						mVertIndex;
	u16						mPad;
};

struct WK7AreaFaceEdge{
	// ׂ荇
	u16						*mpNextFace;
	u16						mNextFaceCount;
	u16						mPad;
};

struct	WK7AreaMaterial;

struct WK7AreaFace{
	WK7AreaFaceVertex		mVert[3];
	WK7AreaFaceEdge			mEdge[3];
	WK7AreaMaterial			*mpMaterial;
};

struct WK7AreaMaterial{
	// }eA
	const char				*mpName;
	
	// ̃}eA
	u16						*mpFaceIndex;
	u16						mFaceIndexCount;
	u16						mPad;
	
	// LtO
	u32						mEnable;
	// 
	u32						mAttr;
	// }eAԍ
	u32						mNo;
	// Cxgԍ
	u32						mEventNo;
	// tO
	union{
		struct{
			u32				mStairs  :  1;
			u32				mFlagPad : 31;
		};
		u32					mFlag;
	};
	
	// gp
	u32						mExtraInfo[8];
};

struct WK7AreaInfo{
	u32						mMagicNo;
	u32						mVersion;
	u16						mVertCount;
	u16						mFaceCount;
	u16						mMaterialCount;
	u16						mNameCount;
	Vec						*mpVert;
	WK7AreaMaterial			*mpMaterial;
	WK7AreaFace				*mpFace;
	const char				**mppName;
	
	// gp
	u32						mExtraInfo[8];
	
	bool Initialize(void);
};

#endif	//__WK7AREAINFO_H__

