////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Camera Object
//
// WK7Cam.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7CAM_H__
#define	__WK7CAM_H__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\WK7Anim.h"
#include ".\WK7Obj.h"
#include ".\WK7Motion.h"
#include ".\WK7Path.h"
//#include "..\Lib\ghmGcDefine.h"
#include "..\Fujita\C_JObj.h"
#include "..\Fujita\C_Trigon.h"

struct WK7StageBpCamInfo;

#define	WK7CAM_RENEW_TICK	(WK7_SEC_TO_TICK(0.125f))

#define	WK7CAM_DEFAULT_CINEMASCOPE_COLOR		(0x2d0a0aff)
//#define	WK7CAM_DEFAULT_CINEMASCOPE_COLOR		(0x730808ff)
//#define	WK7CAM_DEFAULT_CINEMASCOPE_COLOR		(0x6B1C40ff)
//#define	WK7CAM_DEFAULT_CINEMASCOPE_COLOR		(0x350E20ff)
//#define	WK7CAM_DEFAULT_CINEMASCOPE_COLOR		(0x4A0E20ff)

struct WK7CamSetParam{
	f32					mFd;
	f32					mPh;
	f32					mPv;
	f32					mTf;
	f32					mTh;
	f32					mTv;
};
struct WK7CamSet{
	u32					mID;
	WK7CamSetParam		mParam[4];
};

#define	WK7CAMSET_DECL_BEGIN(setid)			static WK7CamSet	camSet##setid[] = {
#define	WK7CAMSET_DECL_CHR_BEGIN(chrid)			{	(chrid), {
#define	WK7CAMSET_DECL_CHR(fd,ph,pv,tf,th,tv)		{ (fd),(ph),(pv),(tf),(th),(tv) },
#define	WK7CAMSET_DECL_CHR_END()					}, },
#define	WK7CAMSET_DECL_CHR_DEF0				WK7CAMSET_DECL_CHR( 15.000f , -2.862f ,  18.064f ,  10.000f ,  0.000f ,  12.000f )	// O
#define	WK7CAMSET_DECL_CHR_DEF1				WK7CAMSET_DECL_CHR( 15.000f ,  2.862f ,  18.064f ,  10.000f ,  0.000f ,  12.000f )	// EO
#define	WK7CAMSET_DECL_CHR_DEF2				WK7CAMSET_DECL_CHR(  7.000f , -2.538f ,  18.641f ,  10.000f ,  0.000f ,  12.000f )	// 
#define	WK7CAMSET_DECL_CHR_DEF3				WK7CAMSET_DECL_CHR(  7.000f ,  2.538f ,  18.641f ,  10.000f ,  0.000f ,  12.000f )	// E
#define	WK7CAMSET_DECL_END()				WK7CAMSET_DECL_CHR_BEGIN(0xffffffff) \
											WK7CAMSET_DECL_CHR_DEF0 \
											WK7CAMSET_DECL_CHR_DEF1 \
											WK7CAMSET_DECL_CHR_DEF2 \
											WK7CAMSET_DECL_CHR_DEF3 \
											WK7CAMSET_DECL_CHR_END() };

// ԗp
class WK7CamInterpolateInfo : public WK7SmallMemObj{
	friend class WK7Cam;
protected:
	Vec								mPrevPosition;
	Vec								mPrevInterest;
	Vec								mInterpolateInterest;
	Vec								mInterpolatePosition;
	f32								mPrevRoll;
	f32								mPrevFov;
	f32								mFov;
	Mtx								mInterpolateMatrix;
	f32								mInterpolateTotalFrame;
	f32								mInterpolateCurrentFrame;
	f32								mInterpolateFov;
	bool Initialize(WK7Cam *pCamera,f32 totalFrame);
	bool FrameProcess(WK7Cam *pCamera);
	bool SetCurrent(WK7Cam *pCamera);
};

// pX̃fBCԗp
class WK7CamDelayInterpolateInfo : public WK7SmallMemObj{
	friend class WK7Cam;
protected:
	Vec								mPrevPosition;
	Vec								mPrevInterest;
	f32								mPrevRoll;
	f32								mPrevFov;
	f32								mFov;
	Mtx								mInterpolateMatrix;
	f32								mInterpolateDelayRate;
	bool Initialize(WK7Cam *pCamera,f32 delayRate);
	bool FrameProcess(WK7Cam *pCamera);
	bool SetCurrent(WK7Cam *pCamera);
};

// ȐpX̒ԗp
class WK7CamCircleInterpolateInfo : public WK7SmallMemObj{
	friend class WK7Cam;
protected:
	Vec								mPrevPosition;
	Vec								mPrevInterest;
	f32								mPrevRoll;
	f32								mPrevFov;
	f32								mFov;
	
	f32								mPrevDist;
	ghmQuaternion					mPrevRotation;
	
	Vec								mInterpolatePosition;
	Vec								mInterpolateInterest;
	
	Mtx								mInterpolateMatrix;
	f32								mInterpolateTotalFrame;
	f32								mInterpolateCurrentFrame;
	f32								mInterpolateFov;
	
	bool GetDirCoorMatrix(ghmQuaternion &q,const Vec &dir);
	bool GetDirCoorMatrix(Mtx mtx,const Vec &dir);
	
	bool Initialize(WK7Cam *pCamera,f32 totalFrame);
	bool FrameProcess(WK7Cam *pCamera);
	bool SetCurrent(WK7Cam *pCamera);
};

class WK7CamPathFollowReverseInfo : public WK7SmallMemObj , public WK7PathControlObj{
protected:
	WK7PathControl					mPathControl;				// ]J̃pXp
	WK7PathControl					*mpTargetPathControl;		// ړIn_pXւ̃|C^
	WK7PathBranchList				*mpBranchList;
	f32								mPrevDistance;
public:
	WK7CamPathFollowReverseInfo(WK7PathControl *pCurrPathControl);
	~WK7CamPathFollowReverseInfo();
	
	bool FrameProcess(void);
	bool SetControlPath(WK7Path *pPath);
	void GetCurrentPosition(Vec *ppos);
	bool Reverse(void);
	
	virtual CallbackResult BranchPointArriveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
};

// pXǔp
class WK7CamPathFollowInfo : public WK7SmallMemObj , public WK7PathControlObj{
	friend class WK7Cam;
public:
	enum{
		FOLLOW_MODE = 0,		// ǔ[h
		FREE_MODE,				// t[[h
		POSFIXED_MODE,			// ʒuŒ
		FIXED_MODE,				// ʒuŒi^[QbgʒuŒj
		RAIL_MODE,				// [[h
		TARGETFIX_MODE,			// _Œ胂[h
	};
	enum{
		POSLD = 0,
		POSLC,
		POSLU,
		POSCD,
		POSCC,
		POSCU,
		POSRD,
		POSRC,
		POSRU,
		
		RENEW      = -1,
		RENEW_IM   = -2,
		RENEW_SLOW = -3,
	};
	enum{
		POSHC = 0,
		POSHR,
		POSHL,
	};
	enum{
		POSVD = 0,
		POSVC,
		POSVU,
	};
	enum{
		RAILTYPE_TOPLAYER = 0,
		RAILTYPE_CAMDIR,
	};
protected:
	WK7PathControl					mPathControl;				// J̃pXp
	WK7PathBranchList				*mpBranchList;				// ^[Qbg܂ł̕򃊃Xg
	bool							mDir;						// ߂Â=true,̂=false
	f32								mMoveDist;					// ړ
	u32								mCamPosReset;				// J̈ʒuZbg
	Vec								mPosition;
	Vec								mTargetPosition;
	Vec								mTargetFixPosition;
	
	f32								mCamHeightCurrent;
	f32								mCamHeightNormal;
	f32								mCamHeightBp;
	
	f32								mTargetHeightCurrent;
	f32								mTargetHeightNormal;
	f32								mTargetHeightBp;
	
	bool							mBranchPointMode;
	
	bool							mBackMirrorMode;
	WK7PathInfo						mOldPathInfo;
	WK7PathControl					*mpReverseIpPathControl;	// ]J̃pXp
	WK7CamPathFollowReverseInfo		*mpReverseInfo;
	
	bool							mEscapeMode;
	f32								mEscapeDist;				// 
	f32								mEscapeDirDist;				// 
	Vec								mEscapeDir;					// 
	Vec								mEscapePosition;			// ʒu
	
	int								mTipReverseProc;
	int								mTipReverseCancel;
	Vec								mTipReversePosition;
	
	HSD_CameraDesc					*mpDesc;
	
	int								mMode;
	
	Vec								mRailPosition[2];
	int								mRailType;
	
	WK7AnimLinearF					mApproachLimitDist;
	WK7AnimLinearF					mAwayLimitDist;
	WK7AnimLinearF					mAdjustDist;
	
//	int								mPos;
	int								mPosHIndex;
	int								mPosVIndex;
	WK7AnimLinearF					mPosH,mPosV,mTgtF,mTgtH,mTgtV;
	
	bool							mStageStartMode;
	Vec								mStageStartCamPosition;
	Vec								mStageStartCamTargetPosition;
	Vec								mStageStartTargetInitPosition;
	
	int								mOldDir;
	
	WK7StageBpCamInfo				*mpBpCamInfo;
	Vec								mBpPosition;
	int								mBpCamInfoPrio;
	
	bool RenewPos(u32 renewTick=WK7CAM_RENEW_TICK);
public:
	WK7CamPathFollowInfo();
	~WK7CamPathFollowInfo();
	
	void SetTipReverseProc(int proc=0){ mTipReverseProc=proc; }
	int GetTipReverseProc(void){ return mTipReverseProc; }
	
	void SetBpCamInfoPrio(int prio=-1);
	inline int GetBpCamInfoPrio(void){ return mBpCamInfoPrio; }
	void SetBpCamInfo(WK7StageBpCamInfo *pInfo);
	inline WK7StageBpCamInfo* GetBpCamInfo(void){ return mpBpCamInfo; }
	inline void SetBpPosition(const Vec &pos){ mBpPosition=pos; }
	inline void GetBpPosition(Vec &pos){ pos=mBpPosition; }
	
	static WK7CamSet* GetCamSet(u32 chrid,int setid);
	
	WK7PathControl* GetPathControl(void){ return &mPathControl; }
	inline bool GetDir(void){ return mDir; }
	
	bool SetTipReverse(bool flag);
	bool TipReverseCancel(void);
	bool SetTipReversePosition(const Vec &pos);
	inline const Vec* GetTipReversePosition(void){ return &mTipReversePosition; }
	inline void GetTipReversePosition(Vec& pos){ pos = mTipReversePosition; }
	
	void SetAdjustDist(f32 dist,u32 tick=0xffffffff);
	inline f32 GetAdjustDist(void){ return mAdjustDist.GetValue(); }
	inline f32 GetAdjustDstDist(void){ return mAdjustDist.GetDstValue(); }
	
	inline f32 GetCurrentApproachLimitDist(void){ return mApproachLimitDist.GetValue(); }
	inline f32 GetCurrentAwayLimitDist    (void){ return mAwayLimitDist    .GetValue(); }
	inline f32 GetCurrentPosH             (void){ return mPosH             .GetValue(); }
	inline f32 GetCurrentPosV             (void){ return mPosV             .GetValue(); }
	inline f32 GetCurrentTgtF             (void){ return mTgtF             .GetValue(); }
	inline f32 GetCurrentTgtV             (void){ return mTgtV             .GetValue(); }
	inline f32 GetCurrentTgtH             (void){ return mTgtH             .GetValue(); }
	
	bool ResetOldDir(void){ mOldDir=-1; return true; }
	int GetOldDir(void){ return mOldDir; }
	
	bool SetPos(int pos);
	bool SetPosV(int pos);
	bool SetPosH(int pos);
	inline int GetPosV(void){ return mPosVIndex; }
	inline int GetPosH(void){ return mPosHIndex; }
//	inline int GetPos(void){ return mPos; }
	bool ReversePosLR(void);
	
	bool SetStageStartDist(f32 dist);
	f32 GetStageStartDist(void);
	void SetStageStartMode(bool flag);
	inline bool GetStageStartMode(void){ return mStageStartMode; }
	void SetStageStartCamPosition(const Vec &pos);
	inline void GetStageStartCamPosition(Vec &pos){ pos=mStageStartCamPosition; }
	void SetStageStartCamTargetPosition(const Vec &pos);
	inline void GetStageStartCamTargetPosition(Vec &pos){ pos=mStageStartCamTargetPosition; }
	void SetStageStartTargetInitPosition(const Vec &pos);
	inline void GetStageStartTargetInitPosition(Vec &pos){ pos=mStageStartTargetInitPosition; }
	
	bool SetControlPath(WK7Path *pPath);
	bool SetCurrentPath(int dir=-1);
	bool SetCurrentPath(WK7PathNurbs *pPath,f32 param,u32 dir);
	bool GetNextPath(void);
	inline void SetCamPosReset(bool flag){ mCamPosReset = (flag==true)? 1UL : 0UL; }
	inline bool GetCamPosReset(void){ return mCamPosReset? true : false; }
	
	inline f32 GetCamHeightCurrent(void){ return mCamHeightCurrent; }
	inline f32 GetTargetHeightCurrent(void){ return mTargetHeightCurrent; }
	
	bool Reverse(void);
	
	bool FrameProcess(WK7Cam *pCamera);
	
	bool Move(f32 dist);
	bool InitEscape(void);
	
	inline void ResetCamPos(void){ mCamPosReset = 1; }
	
	inline void SetPosition(const Vec& pos){ mPosition = pos; }
	inline void SetPosition(f32 x,f32 y,f32 z){ mPosition.x=x; mPosition.y=y; mPosition.z=z; }
	inline void SetPosX(f32 x){ mPosition.x=x; }
	inline void SetPosY(f32 y){ mPosition.y=y; }
	inline void SetPosZ(f32 z){ mPosition.z=z; }
	inline void GetPosition(Vec& pos){ pos = mPosition; }
	inline const Vec& GetPosition(void){ return mPosition; }
	inline f32 GetPosX(void){ return mPosition.x; }
	inline f32 GetPosY(void){ return mPosition.y; }
	inline f32 GetPosZ(void){ return mPosition.z; }
	inline void SetTargetPosition(const Vec& pos){ mTargetPosition = pos; }
	inline void SetTargetPosition(f32 x,f32 y,f32 z){ mTargetPosition.x=x; mTargetPosition.y=y; mTargetPosition.z=z; }
	inline void SetTargetPosX(f32 x){ mTargetPosition.x=x; }
	inline void SetTargetPosY(f32 y){ mTargetPosition.y=y; }
	inline void SetTargetPosZ(f32 z){ mTargetPosition.z=z; }
	inline void GetTargetPosition(Vec& pos){ pos = mTargetPosition; }
	inline const Vec& GetTargetPosition(void){ return mTargetPosition; }
	inline f32 GetTargetPosX(void){ return mTargetPosition.x; }
	inline f32 GetTargetPosY(void){ return mTargetPosition.y; }
	inline f32 GetTargetPosZ(void){ return mTargetPosition.z; }
	
	inline void SetTargetFixPosition(const Vec& pos){ mTargetFixPosition = pos; }
	inline void SetTargetFixPosition(f32 x,f32 y,f32 z){ mTargetFixPosition.x=x; mTargetFixPosition.y=y; mTargetFixPosition.z=z; }
	inline void SetTargetFixPosX(f32 x){ mTargetFixPosition.x=x; }
	inline void SetTargetFixPosY(f32 y){ mTargetFixPosition.y=y; }
	inline void SetTargetFixPosZ(f32 z){ mTargetFixPosition.z=z; }
	inline void GetTargetFixPosition(Vec& pos){ pos = mTargetFixPosition; }
	inline const Vec& GetTargetFixPosition(void){ return mTargetFixPosition; }
	inline f32 GetTargetFixPosX(void){ return mTargetFixPosition.x; }
	inline f32 GetTargetFixPosY(void){ return mTargetFixPosition.y; }
	inline f32 GetTargetFixPosZ(void){ return mTargetFixPosition.z; }
	
//	inline void SetBranchPointMode(bool flag){ mBranchPointMode=flag; }
	void SetBranchPointMode(bool flag,bool im=false);
	inline bool GetBranchPointMode(void){ return mBranchPointMode; }
	void SetBackMirrorMode(bool flag);
	inline bool GetBackMirrorMode(void){ return mBackMirrorMode; }
	
	bool SetMode(int mode);
	inline int GetMode(void){ return mMode; }
//	void SetPathCamera(HSD_CameraDesc *pDesc){ mpDesc = pDesc; }
	void SetPathCamera(HSD_CameraDesc *pDesc);
	inline HSD_CameraDesc* GetPathCamera(void){ return mpDesc; }
	
	bool SetRailPosition(const Vec *ppos);
	bool SetRailPosition(int index,const Vec &pos);
	bool GetRailPosition(int index,Vec &pos);
	bool SetRailType(int type);
	int GetRailType(void){ return mRailType; }
	
//	inline void SetFixed(bool flag){ mFixed=flag; }
//	inline bool GetFixed(void){ return mFixed; }
	
	virtual CallbackResult BranchPointArriveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
	virtual CallbackResult PathChangeCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranch *pSelectBranch,bool interpolate,int inv);
};

#define	WK7CAM_MOTION_PLAY			(0x00000001)
#define	WK7CAM_MOTION_LOOP			(0x00000002)
//
// Camera Object
//
class WK7Cam{
//class WK7Cam : public WK7RenderObj{
public:
	enum Mode{
		WK7CAM_SYSTEM = 0,			// VXeJ
		WK7CAM_FREE_ROT,			// t[Jipxwj
		WK7CAM_FREE_TARGET,			// t[Ji^[Qbgwj
		WK7CAM_PATH_FOLLOW,			// pXǔJ
		WK7CAM_PATH_ANIM,			// pXAjJ
		WK7CAM_LINIP_LINPATH,		// `pX`Ԃňړ
		WK7CAM_DELAYIP_LINPATH,		// `pXfBCԂňړ
		WK7CAM_LINIP_CIRPATH,		// ~ʃpX`Ԃňړ
		WK7CAM_DEBUG = 0x7ffffff	// fobOJ
	};
protected:
#ifdef	_DEBUG
	bool							mDebugMode;
	bool							mDebugOperate;
#endif
	Mode							mMode;						// JgJ[h
	Mode							mPrevMode;					// J[h
	Vec								mPosition;					// Jʒu
	Vec								mRotation;					// J
	Vec								mTargetPosition;			// ^[Qbgʒu
	f32								mTargetDistance;			// ^[Qbg܂ł̋
	
	Vec								mPrevSystemPosition;		// VXeJʒu
	Vec								mPrevSystemTargetPosition;	// VXe^[Qbgʒu
	
	Vec								mRelativePosition;
	Vec								mRelativeRotation;
	
	f32								mFov;						// p
	
	f32								mNear;						// NearClip
	f32								mFar;						// FarClip
	f32								mRoll;						// [l
	
	HSD_CObj						*mpCObj;					// sysdolphinJIuWFNg
	HSD_CObj						*mpCObjWobble;				// Ԃp
	HSD_CObj						*mpCObjCurrent;				// Jg
	f32								mMotionRate;				// Aj[VĐ[g
	u32								mMotionState;				// Aj[V
	
	WK7CamInterpolateInfo			*mpInterpolateInfo;			// ԏ
	WK7CamDelayInterpolateInfo		*mpDelayInterpolateInfo;
	WK7CamCircleInterpolateInfo		*mpCircleInterpolateInfo;
	WK7CamPathFollowInfo			*mpPathFollowInfo;
	
	WK7Path							*mpControlPath;
	
	u32								mCinemaScopeColor;
	
	union{
		struct{
			u32						mPosDirty         : 1;			// 
			u32						mRotDirty         : 1;			// 
			u32						mTgtPosDirty      : 1;			// 
			u32						mFovDirty         : 1;			// 
			u32						mNearDirty        : 1;			// 
			u32						mFarDirty         : 1;			// 
			u32						mRollDirty        : 1;			// 
			u32						mWobbleEnable     : 1;			// 
			u32						mWobbleForced     : 1;			// 
			u32						mCinemaScopeMode  : 1;			// VlXR[h
			u32						mCinemaScopeAdjust: 1;			// VlXR␳
			
			u32						mFlagPad          :21;
		};
		u32							mFlag;							// tO
	};
	
	WK7AnimLinearF					mWobbleMotionRate;
	WK7AnimLinearF					mWobblePosRate;
	WK7AnimLinearF					mWobbleDirRate;
	
	bool							mRenderFlag;				// _OtO
	
	// fobOp
	WK7Archive						*mpTargetArchive;
	WK7Model						*mpTargetModel;
	f32								mCameraMovSpeed;
	f32								mCameraRotSpeed;
	
	// ޔp
	f32								mStoreFov;
	f32								mStoreNear;
	f32								mStoreFar;
	f32								mStoreRoll;
	
	void InitMember(void);
	bool DebugCameraControl(void);
	
	bool SetMotionRate(HSD_WObj *pWObj,f32 rate,bool wholeRateEnable);
	bool SetMotionRate(HSD_CObj *pCObj,f32 rate,bool wholeRateEnable);
	
	bool SetPosRot(void);
	bool SetPosTgt(void);
public:
	WK7Cam();
//	WK7Cam(WK7Obj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7Cam();
	
	static HSD_CameraDesc* GetDescDefault(void);
	WK7PathControl* GetPathControl(void);
	
	inline void ClearRelativePosition(void){ mRelativePosition.x=mRelativePosition.y=mRelativePosition.z=0.0f; }
	inline void SetRelativePosition(const Vec &pos){ mRelativePosition = pos; }
	inline void GetRelativePosition(Vec &pos){ pos = mRelativePosition; }
	inline void SetRelativePosX(f32 posx){ mRelativePosition.x = posx; }
	inline void SetRelativePosY(f32 posy){ mRelativePosition.y = posy; }
	inline void SetRelativePosZ(f32 posz){ mRelativePosition.z = posz; }
	inline f32 GetRelativePosX(void){ return mRelativePosition.x; }
	inline f32 GetRelativePosY(void){ return mRelativePosition.y; }
	inline f32 GetRelativePosZ(void){ return mRelativePosition.z; }
	inline void ClearRelativeRotation(void){ mRelativeRotation.x=mRelativeRotation.y=mRelativeRotation.z=0.0f; }
	inline void SetRelativeRotation(const Vec &rot){ mRelativeRotation = rot; }
	inline void GetRelativeRotation(Vec &rot){ rot = mRelativeRotation; }
	inline void SetRelativeRotX(f32 rotx){ mRelativeRotation.x = rotx; }
	inline void SetRelativeRotY(f32 roty){ mRelativeRotation.y = roty; }
	inline void SetRelativeRotZ(f32 rotz){ mRelativeRotation.z = rotz; }
	inline f32 GetRelativeRotX(void){ return mRelativeRotation.x; }
	inline f32 GetRelativeRotY(void){ return mRelativeRotation.y; }
	inline f32 GetRelativeRotZ(void){ return mRelativeRotation.z; }
	
	inline void SetAnimRelativePosition(const Vec &pos){ SetRelativePosition(pos); }
	inline void GetAnimRelativePosition(Vec &pos){ GetRelativePosition(pos); }
	inline void SetAnimRelativePosX(f32 posx){ SetRelativePosX(posx); }
	inline void SetAnimRelativePosY(f32 posy){ SetRelativePosY(posy); }
	inline void SetAnimRelativePosZ(f32 posz){ SetRelativePosZ(posz); }
	inline f32 GetAnimRelativePosX(void){ return GetRelativePosX(); }
	inline f32 GetAnimRelativePosY(void){ return GetRelativePosY(); }
	inline f32 GetAnimRelativePosZ(void){ return GetRelativePosZ(); }
	inline void SetAnimRelativeRotation(const Vec &rot){ SetRelativeRotation(rot); }
	inline void GetAnimRelativeRotation(Vec &rot){ GetRelativeRotation(rot); }
	inline void SetAnimRelativeRotX(f32 rotx){ SetRelativeRotX(rotx); }
	inline void SetAnimRelativeRotY(f32 roty){ SetRelativeRotY(roty); }
	inline void SetAnimRelativeRotZ(f32 rotz){ SetRelativeRotZ(rotz); }
	inline f32 GetAnimRelativeRotX(void){ return GetRelativeRotX(); }
	inline f32 GetAnimRelativeRotY(void){ return GetRelativeRotY(); }
	inline f32 GetAnimRelativeRotZ(void){ return GetRelativeRotZ(); }
	
	inline bool SetCinemaScopeAdjust(bool flag){ mCinemaScopeAdjust = (flag==true? 1:0); return true; }
	inline bool GetCinemaScopeAdjust(void){ return mCinemaScopeAdjust? true : false; }
	bool SetCinemaScopeMode(bool flag);
	bool SetCinemaScopeModeFlag(bool flag);
	inline bool GetCinemaScopeMode(void){ return mCinemaScopeMode? true : false; }
	inline bool SetCinemaScopeColor(u32 color){ mCinemaScopeColor=color; return true; }
	inline bool SetDefaultCinemaScopeColor(void){ mCinemaScopeColor=WK7CAM_DEFAULT_CINEMASCOPE_COLOR; return true; }
	inline u32 GetCinemaScopeColor(void){ return mCinemaScopeColor; }
	bool SetScissor(void);
	bool SetScissor(HSD_RectU16 &sc_rect);
	bool GetScissor(HSD_RectU16 &sc_rect);
	bool SetViewport(void);
	bool SetViewport(HSD_RectS16 &vp_rect);
	bool GetViewport(HSD_RectS16 &vp_rect);
	
	static bool Set2DMatrix(Mtx view,Mtx44 proj,f32 n=0.0f,f32 f=1.0f);
	bool RenderCinemaScopeFrame(bool flag=false);
	
	bool StoreState(void);
	bool RestoreState(void);
	
	bool StoreFov(void);
	bool StoreFar(void);
	bool StoreNear(void);
	bool StoreRoll(void);
	bool RestoreFov(void);
	bool RestoreFar(void);
	bool RestoreNear(void);
	bool RestoreRoll(void);
	
	bool EnterDebugMode(void);
	bool ExitDebugMode(void);
	bool IsDebugMode(void);
	bool SetDebugOperate(bool flag);
	bool GetDebugOperate(void);
	
	void SetDesc(HSD_CameraDesc *pDesc);
	
	void SetRenderFlag(bool flag){ mRenderFlag = flag; }
	bool GetRenderFlag(void){ return mRenderFlag; }
	
	inline void SetWobbleForced(bool flag){ mWobbleForced = (flag==true)? 1 : 0; }
	inline bool GetWobbleForced(void){ return mWobbleForced? true : false; }
	inline void SetWobbleEnable(bool flag){ mWobbleEnable = (flag==true)? 1 : 0; }
	inline bool GetWobbleEnable(void){ return mWobbleEnable? true : false; }
	
	inline void SetWobblePosRate(f32 rate,u32 tick=0){ mWobblePosRate.SetValue(rate,tick); }
	inline void SetWobblePosRate(f32 rate,f32 sec){ mWobblePosRate.SetValue(rate,WK7_SEC_TO_TICK(sec)); }
	inline f32 GetWobblePosRate(void){ return mWobblePosRate.GetValue(); }
	inline void SetWobbleDirRate(f32 rate,u32 tick=0){ mWobbleDirRate.SetValue(rate,tick); }
	inline void SetWobbleDirRate(f32 rate,f32 sec){ mWobbleDirRate.SetValue(rate,WK7_SEC_TO_TICK(sec)); }
	inline f32 GetWobbleDirRate(void){ return mWobbleDirRate.GetValue(); }
	inline void SetWobbleMotionRate(f32 rate,u32 tick=0){ mWobbleMotionRate.SetValue(rate,tick); }
	inline void SetWobbleMotionRate(f32 rate,f32 sec){ mWobbleMotionRate.SetValue(rate,WK7_SEC_TO_TICK(sec)); }
	inline f32 GetWobbleMotionRate(void){ return mWobbleMotionRate.GetValue(); }
	
	// [V֘A
	bool AttachMotion(HSD_CameraAnim *pCameraAnim);
	bool AttachMotion(WK7CameraMotion *pCameraMotion,int index=-1);
	bool AttachMotion(WK7CameraMotion *pCameraMotion,const char *pname);
	bool DetachMotion(void);
	bool PlayMotion(f32 startframe=0.0f,bool interpolate=false,f32 interpolateframe=0.0f);
	bool ReplayMotion(void);
	bool StopMotion(void);
	bool SetMotionLoop(bool flag);
	bool GetMotionLoop(void);
	int GetMotionState(void);
	bool SetMotionRate(f32 rate=1.0f);
	bool RenewMotionRate(void);
	f32 GetTotalMotionFrame(void);
	f32 GetCurrentMotionFrame(void);
	
	// 
//	virtual bool Initialize(void){ return true; }
	
	// I
//	virtual bool Terminate(void){ return true; }
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// Jݒ
	bool SetCurrent(void);
	bool EndCurrent(void);
	
	// [hݒ
	void SetMode(Mode mode);
	inline Mode GetMode(void){ return mMode; }
	inline Mode GetPrevMode(void){ return mPrevMode; }
	void RestoreMode(void);
	
	// pݒ
	void SetFov(float fov,bool delay=false);
	inline f32 GetFov(void){ return mFov; }
	
	// jAʐݒ
	inline void SetNear(float n){ mNear = n; mNearDirty=1; }
	inline f32 GetNear(void){ return mNear; }
	
	// t@[ʐݒ
	inline void SetFar(float f){ mFar = f; mFarDirty=1; }
	inline f32 GetFar(void){ return mFar; }
	
	// [lݒ
	inline void SetRoll(float n){ mRoll = n; mRollDirty=1; }
	inline f32 GetRoll(void){ return mRoll; }
	
	bool SetAspect(f32 aspect);
	f32 GetAspect(void);
	
	inline f32 GetMotionRate(void){ return mMotionRate; }
	
	// fobOp
	bool LoadArchive(char *pArchiveFileName);
	bool LoadProcess(void);
	bool IsLoadedArchive(void);
	bool FreeArchive(void);
	
	// CObj擾
//	inline HSD_CObj* GetCObj(void){ return mpCObj; }
	inline HSD_CObj* _GetCObj(void){ return mpCObj; }
	inline HSD_CObj* GetCObj(void){ return mpCObjCurrent; }
	inline HSD_CObj* GetCObjCurrent(void){ return mpCObjCurrent; }
	MtxPtr GetViewingMtxPtr(void);
	bool GetViewingMtx(Mtx mtx);
	MtxPtr GetViewingMtxPtrCurrent(void);
	bool GetViewingMtxCurrent(Mtx mtx);
	
	// Jʒuݒ
	inline void SetPosition(const Vec& pos){ mPosition = pos; mPosDirty=1; }
	inline void SetPosition(f32 x,f32 y,f32 z){ mPosition.x=x; mPosition.y=y; mPosition.z=z; mPosDirty=1; }
	inline void SetPosX(f32 x){ mPosition.x=x; mPosDirty=1; }
	inline void SetPosY(f32 y){ mPosition.y=y; mPosDirty=1; }
	inline void SetPosZ(f32 z){ mPosition.z=z; mPosDirty=1; }
	inline void GetPosition(Vec& pos){ pos = mPosition; }
	inline const Vec& GetPosition(void){ return mPosition; }
	inline f32 GetPosX(void){ return mPosition.x; }
	inline f32 GetPosY(void){ return mPosition.y; }
	inline f32 GetPosZ(void){ return mPosition.z; }
	bool GetWorldPosition(Vec& pos);
	bool GetWorldPositions(Vec& pos,Vec& tgt);
	
	// ^[Qbgʒuݒ
	inline void SetTargetPosition(const Vec& pos){ mTargetPosition = pos; mTgtPosDirty=1; }
	inline void SetTargetPosition(f32 x,f32 y,f32 z){ mTargetPosition.x=x; mTargetPosition.y=y; mTargetPosition.z=z; mTgtPosDirty=1; }
	inline void SetTargetPosX(f32 x){ mTargetPosition.x=x; mTgtPosDirty=1; }
	inline void SetTargetPosY(f32 y){ mTargetPosition.y=y; mTgtPosDirty=1; }
	inline void SetTargetPosZ(f32 z){ mTargetPosition.z=z; mTgtPosDirty=1; }
	inline void GetTargetPosition(Vec& pos){ pos = mTargetPosition; }
	inline const Vec& GetTargetPosition(void){ return mTargetPosition; }
	inline f32 GetTargetPosX(void){ return mTargetPosition.x; }
	inline f32 GetTargetPosY(void){ return mTargetPosition.y; }
	inline f32 GetTargetPosZ(void){ return mTargetPosition.z; }
	bool GetWorldTargetPosition(Vec& pos);
	
	// Jݒ
	inline void SetRotation(const Vec& rot){ mRotation = rot; mRotDirty=1; }
	inline void SetRotation(f32 x,f32 y,f32 z){ mRotation.x=x; mRotation.y=y; mRotation.z=z; mRotDirty=1; }
	inline void SetRotX(f32 x){ mRotation.x=x; mRotDirty=1; }
	inline void SetRotY(f32 y){ mRotation.y=y; mRotDirty=1; }
	inline void SetRotZ(f32 z){ mRotation.z=z; mRotDirty=1; }
	inline void GetRotation(Vec& rot){ rot = mRotation; }
	inline const Vec& GetRotation(void){ return mRotation; }
	inline f32 GetRotX(void){ return mRotation.x; }
	inline f32 GetRotY(void){ return mRotation.y; }
	inline f32 GetRotZ(void){ return mRotation.z; }
	void GetRotationCalc(Vec& rot);
	
	// ^[Qbgݒ
	inline bool SetTargetDistance(f32 dist){ if( dist <= 0.0f ){ return false; } mTargetDistance = dist; return true; }
	inline f32 GetTargetDistance(void){ return mTargetDistance; }
	
	bool SetControlPath(WK7Path *pPath);
	bool SetCurrentPath(int dir=-1);
	bool SetCurrentPath(WK7PathNurbs *pPath,f32 param,u32 dir);
	
	static WK7Cam* GetInstance(void);
	static bool Initialize(void);
	static bool Terminate(void);
	
	bool SetBranchPointMode(bool flag,bool im=false);
	bool GetBranchPointMode(void);
	
	bool SetBackMirrorMode(bool flag);
	bool GetBackMirrorMode(void);
	
	bool ReversePathFollow(void);
	
	bool StartLinearInterpolateOnLinearPath(const Vec &pos,const Vec &tgt,f32 totalFrame,f32 fov=-1.0f);
	bool StartDelayInterpolateOnLinearPath(const Vec &pos,const Vec &tgt,f32 delayRate,f32 fov=-1.0f);
	bool StartLinearInterpolateOnCirclePath(const Vec &pos,const Vec &tgt,f32 totalFrame,f32 fov=-1.0f);
	bool StopInterpolate(void);
	
	inline f32 GetCameraMoveSpeed(void){ return mCameraMovSpeed; }
	
	bool ReviseWobble(Vec &campos,Vec &camtgt);
	
	inline WK7CamPathFollowInfo* GetPathFollowInfo(void){ return mpPathFollowInfo; }
};

#define	WK7CAM							WK7Cam::GetInstance()
#define	WK7CAMPATHFOLLOWINFO			WK7CAM->GetPathFollowInfo()

#define	WK7CAM_NOANIM					(AOBJ_NO_ANIM)

#endif	//__WK7CAM_H__

