////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Chara Object
//
// WK7Chara.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7CHARA_H__
#define	__WK7CHARA_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include ".\WK7Archive.h"
#include ".\WK7Obj.h"

//
// Chara Object
//
class WK7Chara : public WK7RenderObj{
	friend class WK7RenderObj;
protected:
	static bool					mRenderChara;
	bool						mStageLight;
	WK7Chara();
	WK7Chara(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
public:
	virtual ~WK7Chara();
	
	inline WK7Chara* GetPrev(void){ return (WK7Chara *)ghmGcListObj::GetPrev(); }
	inline WK7Chara* GetNext(void){ return (WK7Chara *)ghmGcListObj::GetNext(); }
	virtual u32 GetMainID(void);
	virtual u32 GetSuffix(void);
	
	static u32 GetMainID(char *pname);
	static bool GetInitial(u32 mainid,char *pname);
	static bool GetFileName(char *pFileName,u32 id);
	virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	static bool CreateStaticArchive(u32 id);
//	static bool ReleaseArchive(u32 id);
	
	virtual bool Initialize(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	virtual bool DispLight(u32 mirrorType=0,Vec *pPos=NULL);
	
	inline void SetStageLight(bool flag){ mStageLight = flag; }
	inline bool GetStageLight(void){ return mStageLight; }
	
	static bool SetRenderChara(bool flag){ mRenderChara=flag; return true; }
	static bool GetRenderChara(void){ return mRenderChara; }
};

//
// Chara Motion Object
//
class WK7CharaMotion : public WK7MotionObj{
	friend class WK7MotionObj;
protected:
	WK7CharaMotion();
	WK7CharaMotion(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7CharaMotion();
	
	inline WK7CharaMotion* GetPrev(void){ return (WK7CharaMotion *)ghmGcListObj::GetPrev(); }
	inline WK7CharaMotion* GetNext(void){ return (WK7CharaMotion *)ghmGcListObj::GetNext(); }
	
	static bool GetFileName(char *pFileName,u32 id);
	virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	static bool CreateStaticArchive(u32 id);
};

#endif	//__WK7CHARA_H__

