////////////////////////////////////////////////////////////////////////////////
//
// Killer7 CharaPresent
//
// WK7CharaPresent.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7CHARAPRESENT_H__
#define	__WK7CHARAPRESENT_H__

//#include "..\Lib\ghmGcList.h"

class WK7CharaPresentMaskWindow : ghmGcListObj{
	friend class WK7CharaPresent;
protected:
	f32							mPosX,mPosY,mWidth,mHeight;
	bool						mEnable;
	WK7CharaPresentMaskWindow(ghmGcListObj *pAnchor);
	virtual ~WK7CharaPresentMaskWindow();
public:
	WK7CharaPresentMaskWindow* GetNext(void){ return (WK7CharaPresentMaskWindow *)ghmGcListObj::GetNext(); }
	WK7CharaPresentMaskWindow* GetPrev(void){ return (WK7CharaPresentMaskWindow *)ghmGcListObj::GetPrev(); }
	
	inline void SetEnable(bool flag){ mEnable=flag; }
	inline bool GetEnable(void){ return mEnable; }
	
	bool SetRect(f32 x,f32 y,f32 w,f32 h);
	bool FrameProcess(void);
	bool RenderProcess(void);
};

class WK7CharaPresent{
protected:
	ghmGcListObj				mWindowAnchor;
	bool						mEnable;
	bool						mReserved;
	u32							mReserveTick;
	u32							mDeleteTick;
	f32							mWholeMotionRate;
#ifdef	_DEBUG
	bool						mDebugMode;
	u32							mTickCounter;
	bool						mTickCountEnable;
	f32							mNameX,mNameY;
	f32							mWindowX,mWindowY,mWindowW,mWindowH;
	bool RenderProcessEditMode(void);
#endif
	
	static WK7CharaPresent*		gpCharaPresent;
	WK7CharaPresent();
public:
	~WK7CharaPresent();
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	
#ifdef	_DEBUG
	bool StartTickCounter(void);
	bool EndTickCounter(void);
#endif
	
	WK7CharaPresentMaskWindow* AddMaskWindow(f32 x,f32 y,f32 w,f32 h);
	bool DeleteMaskWindow(WK7CharaPresentMaskWindow *pWindow);
	bool DeleteMaskWindowAll(void);
	
	void SetEnable(bool flag);
	inline bool GetEnable(void){ return mEnable; }
	
	void ReserveEnable(u32 tick);
	void ReserveEnableSec(f32 sec);
	
	void ReserveDelete(u32 tick=0xffffffff);
	void ReserveDeleteSec(f32 sec);
	
	void SetReserved(bool flag);
	inline bool GetReserved(void){ return mReserved; }
	
	inline static WK7CharaPresent* GetInstance(void){ return gpCharaPresent; }
	static bool Initialize(void);
	static bool Terminate(void);
	static bool FrameProcessAll(void);
	static bool RenderProcessAll(void);
};

#define	WK7CHARAPRESENT					WK7CharaPresent::GetInstance()
#ifndef	K7APP_MASTER
#define	WK7CHARAPRESENT_DEBUGSTART()	WK7CharaPresent::GetInstance()->StartTickCounter()
#define	WK7CHARAPRESENT_DEBUGEND()		WK7CharaPresent::GetInstance()->EndTickCounter()
#else
#define	WK7CHARAPRESENT_DEBUGSTART()
#define	WK7CHARAPRESENT_DEBUGEND()
#endif

#endif	//__WK7CHARAPRESENT_H__

