////////////////////////////////////////////////////////////////////////////////
//
// Killer7 DeadBodySign
//
// WK7DeadBodySign.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/04/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7DEADBODYSIGN_CPP__

#include ".\WK7DeadBodySign.h"
#include ".\WK7Cam.h"
#include ".\WK7Shadow.h"
#include ".\WK7Item.h"

WK7PolyFace::WK7PolyFace(ghmGcListObj *pAnchor) : ghmGcListObj(pAnchor)
{
	memset(mPosition,0,sizeof(mPosition));
	mFaceColor = 0xffffffff;
}

WK7PolyFace::~WK7PolyFace()
{
}

bool WK7PolyFace::SetPosition(int index,const Vec &pos)
{
	if( index < 0 || index >= 3 ){
		return false;
	}
	mPosition[index] = pos;
	return true;
}

bool WK7PolyFace::GetPosition(int index,Vec &pos)
{
	if( index < 0 || index >= 3 ){
		return false;
	}
	pos = mPosition[index];
	return true;
}

bool WK7PolyFace::FrameProcess(void)
{
	return true;
}

bool WK7PolyFace::RenderProcess(void)
{
	int				i;
//	GXColor			matcolor;
	
//	if( face==true ){
//		matcolor.r = 0x00;
//		matcolor.g = 0xff;
//		matcolor.b = 0x00;
//		matcolor.a = 0x80;
//		GXSetChanMatColor(GX_COLOR0A0,matcolor);
//		GXBegin(GX_TRIANGLES,GX_VTXFMT0,3);
		for(i=0 ; i<3 ; i++){
			GXPosition3f32(mPosition[i].x,mPosition[i].y,mPosition[i].z);
		}
//		GXEnd();
//	}
	
	return true;
}

bool WK7PolyFace::RenderEdge(void)
{
	int				i;
//	GXColor			matcolor;
	
//	if( edge==true ){
//		matcolor.r = 0x00;
//		matcolor.g = 0xff;
//		matcolor.b = 0x00;
//		matcolor.a = 0xff;
//		GXSetChanMatColor(GX_COLOR0A0,matcolor);
		GXBegin(GX_LINESTRIP,GX_VTXFMT0,4);
		for(i=0 ; i<3 ; i++){
			GXPosition3f32(mPosition[i].x,mPosition[i].y,mPosition[i].z);
		}
		GXPosition3f32(mPosition[0].x,mPosition[0].y,mPosition[0].z);
		GXEnd();
//	}
	
	return true;
}

WK7PolyFaceUV::WK7PolyFaceUV(ghmGcListObj *pAnchor) : WK7PolyFace(pAnchor)
{
	memset(mUV,0,sizeof(mUV));
}

WK7PolyFaceUV::~WK7PolyFaceUV()
{
}
	
bool WK7PolyFaceUV::SetUV(int index,f32 u,f32 v)
{
	if( index < 0 || index >= 3 ){
		return false;
	}
	mUV[index][0] = u;
	mUV[index][1] = v;
	return true;
}

bool WK7PolyFaceUV::GetUV(int index,f32 *pu,f32 *pv)
{
	if( index < 0 || index >= 3 ){
		return false;
	}
	if( pu!=NULL ){ *pu=mUV[index][0]; }
	if( pv!=NULL ){ *pv=mUV[index][1]; }
	return true;
}

bool WK7PolyFaceUV::FrameProcess(void)
{
	return true;
}

bool WK7PolyFaceUV::RenderProcess(void)
{
	int				i;
//	GXColor			matcolor;
	
//	if( face==true ){
//		matcolor.r = 0x00;
//		matcolor.g = 0xff;
//		matcolor.b = 0x00;
//		matcolor.a = 0x80;
//		GXSetChanMatColor(GX_COLOR0A0,matcolor);
//		GXBegin(GX_TRIANGLES,GX_VTXFMT0,3);
		for(i=0 ; i<3 ; i++){
			GXPosition3f32(mPosition[i].x,mPosition[i].y,mPosition[i].z);
			GXTexCoord2f32(mUV[i][0],mUV[i][1]);
		}
//		GXEnd();
//	}
	
	return true;
}

bool WK7PolyFaceUV::RenderEdge(void)
{
	int				i;
//	GXColor			matcolor;
	
//	if( edge==true ){
//		matcolor.r = 0x00;
//		matcolor.g = 0xff;
//		matcolor.b = 0x00;
//		matcolor.a = 0xff;
//		GXSetChanMatColor(GX_COLOR0A0,matcolor);
		GXBegin(GX_LINESTRIP,GX_VTXFMT0,4);
		for(i=0 ; i<3 ; i++){
			GXPosition3f32(mPosition[i].x,mPosition[i].y,mPosition[i].z);
//			GXTexCoord2f32(mUV[i][0],mUV[i][1]);
		}
		GXPosition3f32(mPosition[0].x,mPosition[0].y,mPosition[0].z);
//		GXTexCoord2f32(mUV[0][0],mUV[0][1]);
		GXEnd();
//	}
	return true;
}

GhmGcTexHeader*	WK7DeadBodySign::mpTexture   = NULL;
ghmGcFile*		WK7DeadBodySign::mpFile      = NULL;

bool WK7DeadBodySign::Intersect(const Vec &dir,const Vec pos[3])
{
	f32		r;
	f32		pmin,pmax,p;
	
	r    = mBoxSize.x * GHM_FABS(dir.x) + mBoxSize.y * GHM_FABS(dir.y) + mBoxSize.z * GHM_FABS(dir.z);
	pmin = 
	pmax = VECDotProduct(&dir,&pos[0]);
	p    = VECDotProduct(&dir,&pos[1]);
	if( pmin > p ){ pmin = p; }
	if( pmax < p ){ pmax = p; }
	p    = VECDotProduct(&dir,&pos[2]);
	if( pmin > p ){ pmin = p; }
	if( pmax < p ){ pmax = p; }
	
	if( pmin > r || pmax < -r ){
		return false;
	}
	
	return true;
}

bool WK7DeadBodySign::CreatePrim(const Vec pos[3])
{
	Vec		lpos[3],ldir[3],dir;
	int		i,j;
static	bool	check = true;
	
	if( check==true ){
		
		for(i=0 ; i<3 ; i++){
			MTXMultVec(mInvMtx,&pos[i],&lpos[i]);
		}
		VECSubtract(&lpos[1],&lpos[0],&ldir[0]);
		VECSubtract(&lpos[2],&lpos[1],&ldir[1]);
		VECSubtract(&lpos[0],&lpos[2],&ldir[2]);
		
		if( Intersect(mBoxAxis[0],lpos)==false ){
			return false;
		}
		if( Intersect(mBoxAxis[1],lpos)==false ){
			return false;
		}
		if( Intersect(mBoxAxis[2],lpos)==false ){
			return false;
		}
		VECCrossProduct(&ldir[1],&ldir[0],&dir);
		if( Intersect(dir,lpos)==false ){
			return false;
		}
		for(i=0 ; i<3 ; i++){
			for(j=0 ; j<3 ; j++){
				VECCrossProduct(&mBoxAxis[i],&ldir[j],&dir);
				if( Intersect(dir,lpos)==false ){
					return false;
				}
			}
		}
		
	}
	
//static	f32		ofs = 0.1f;
//	Vec			cpos[3];
//	dir.x = 0.0f;
//	dir.y = ofs;
//	dir.z = 0.0f;
//	MTXMultVecSR(mMtx,&dir,&dir);
//	
//	for(i=0 ; i<3 ; i++){
//		VECAdd(&pos[i],&dir,&cpos[i]);
//	}
	
#if 1
	WK7PolyFaceUV		*pFaceUV;
	Vec					scale;
	
	ghmGcMemSetAllocName("WK7PoFUV");
	if( (pFaceUV = new WK7PolyFaceUV(&mPrimAnchor))==NULL ){
		return false;
	}
	
	scale.x = 0.5f / mBoxSize.x;
	scale.y = 0.5f / mBoxSize.y;
	scale.z = 0.5f / mBoxSize.z;
	
	pFaceUV->SetPosition(0,pos[0]);
	pFaceUV->SetPosition(1,pos[1]);
	pFaceUV->SetPosition(2,pos[2]);
//	pFaceUV->SetPosition(0,cpos[0]);
//	pFaceUV->SetPosition(1,cpos[1]);
//	pFaceUV->SetPosition(2,cpos[2]);
	
	pFaceUV->SetUV      (0,-lpos[0].x * scale.x + 0.5f, -lpos[0].z * scale.z + 0.5f);
	pFaceUV->SetUV      (1,-lpos[1].x * scale.x + 0.5f, -lpos[1].z * scale.z + 0.5f);
	pFaceUV->SetUV      (2,-lpos[2].x * scale.x + 0.5f, -lpos[2].z * scale.z + 0.5f);
#else
	WK7PolyFace		*pFace;
	
	if( (pFace = new WK7PolyFace(&mPrimAnchor))==NULL ){
		return false;
	}
	
	pFace->SetPosition(0,pos[0]);
	pFace->SetPosition(1,pos[1]);
	pFace->SetPosition(2,pos[2]);
//	pFace->SetPosition(0,cpos[0]);
//	pFace->SetPosition(1,cpos[1]);
//	pFace->SetPosition(2,cpos[2]);
#endif
	
	return true;
}

bool WK7DeadBodySign::ParsePrim(HSD_PObj *pPObj,const Mtx &mtx)
{
	if( pPObj==NULL ){
		return true;
	}
	
	WK7VtxDescInfo		info;
	u32					stride;
	stride  = WK7JObj::GetStride(pPObj->desc_list,info);
	if( info.mpVertexDesc==NULL ){
		return true;
	}
	
	int					dlsize;
	u8					*pdl;
	int					num,i;
	GXPrimitive			prim;
	WK7GetVertexFunc	*pGetVertex;
	f32					base;
	Vec					pos[3];
	
	pdl     = pPObj->dl;
	dlsize  = (pPObj->dlsize << 5);
	switch( info.mpVertexDesc->comp_type ){
	case	GX_U8:  pGetVertex = WK7JObj::GetVertexU8;  base = 1.0f / (1<<info.mpVertexDesc->frac); break;
	case	GX_S8:  pGetVertex = WK7JObj::GetVertexS8;  base = 1.0f / (1<<info.mpVertexDesc->frac); break;
	case	GX_U16: pGetVertex = WK7JObj::GetVertexU16; base = 1.0f / (1<<info.mpVertexDesc->frac); break;
	case	GX_S16: pGetVertex = WK7JObj::GetVertexS16; base = 1.0f / (1<<info.mpVertexDesc->frac); break;
	case	GX_F32: pGetVertex = WK7JObj::GetVertexF32; base = 1.0f;                                break;
	default:
		return true;
	}
	
	while( dlsize > 0 ){
		u8			*pVertexDL;
		int			id;
		void		*pBasePtr;
		prim    = (GXPrimitive)(pdl[0] & GX_OPCODE_MASK);
		num     = ((int)pdl[1]<<8)|pdl[2];
		i       = 0;
		dlsize -= 3;
		pdl    += 3;
		pVertexDL = pdl + info.mVertexPos;
		pBasePtr  = info.mpVertexDesc->base_ptr;
		switch( prim ){
		case GX_POINTS:
		case GX_LINES:
		case GX_LINESTRIP:
		case GX_QUADS:
			break;
		case GX_TRIANGLES:
			while( num > 0 ){
				id = WK7JObj::DlGetIndex(pVertexDL,info.mpVertexDesc);
				pGetVertex(&pos[i],pBasePtr,id,base);
				MTXMultVec(mtx,&pos[i],&pos[i]);
				num --;
				pVertexDL += stride;
				if( i==2 ){
					i = 0;
					
					ghmGcMemSetAllocName("WPFTri");
					if( CreatePrim(pos)==true ){
						mPrimCount++;
					}
					
				}else{
					i++;
				}
			}
			break;
		case GX_TRIANGLESTRIP:{
			int		pid[2];
			while( num > 0 ){
				id = WK7JObj::DlGetIndex(pVertexDL,info.mpVertexDesc);
				pGetVertex(&pos[i],pBasePtr,id,base);
				MTXMultVec(mtx,&pos[i],&pos[i]);
				num --;
				pVertexDL += stride;
				if( i==2 ){
					if( pid[1] != id && pid[0] != pid[1] ){
						ghmGcMemSetAllocName("WPFTrStr");
						if( CreatePrim(pos)==true ){
							mPrimCount++;
						}
					}
					
					pos[0] = pos[1];
					pos[1] = pos[2];
				}else{
					i++;
				}
				pid[0] = pid[1];
				pid[1] = id;
			}
			}break;
		case GX_TRIANGLEFAN:
			while( num > 0 ){
				id = WK7JObj::DlGetIndex(pVertexDL,info.mpVertexDesc);
				pGetVertex(&pos[i],pBasePtr,id,base);
				MTXMultVec(mtx,&pos[i],&pos[i]);
				num --;
				pVertexDL += stride;
				if( i==2 ){
					
					ghmGcMemSetAllocName("WPFTrFan");
					if( CreatePrim(pos)==true ){
						mPrimCount++;
					}
					
					pos[1] = pos[2];
				}else{
					i++;
				}
			}
			break;
		case GX_NOP:
		default:
			break;
		}
		pdl    += stride * num;
		dlsize -= stride * num;
	}
	
	return true;
}

bool WK7DeadBodySign::ParsePrim(HSD_DObj *pDObj,HSD_DObjDesc *pDObjDesc,const Mtx &mtx)
{
	if( pDObj==NULL || pDObjDesc==NULL ){
		return true;
	}
	const char	*pDObjName;
	if( (pDObjName=::GetDescName(pDObjDesc))==NULL ){
		return true;
	}
	if( strstr(pDObjName,"K7_HIDELINE")==pDObjName ){
		// ̃Agr[gŎn܂}eAgp|S͑ΏۊO
		return true;
	}
	HSD_PObj	*pPObj;
	for(pPObj=HSD_DObjGetPObj(pDObj) ; pPObj!=NULL ; pPObj=HSD_PObjGetNext(pPObj)){
		ParsePrim(pPObj,mtx);
	}
	return true;
}

bool WK7DeadBodySign::ParsePrim(HSD_JObj *pHSDJObj,HSD_Joint *pJoint)
{
	if( pHSDJObj==NULL || pJoint==NULL ){
		return true;
	}
	HSD_DObj		*pDObj;
	HSD_DObjDesc	*pDObjDesc;
	Mtx			mtx;
	
	MTXCopy(HSD_JObjGetMtxPtr(pHSDJObj),mtx);
		
	for(pDObj=HSD_JObjGetDObj(pHSDJObj),pDObjDesc=pJoint->u.dobjdesc ; pDObj!=NULL && pDObjDesc!=NULL ; pDObj=HSD_DObjGetNext(pDObj),pDObjDesc=pDObjDesc->next){
		ParsePrim(pDObj,pDObjDesc,mtx);
	}
	return true;
}

bool WK7DeadBodySign::ParsePrim(WK7JObj *pJObj)
{
	if( pJObj==NULL ){
		return true;
	}
	ParsePrim(pJObj->GetJObj(),pJObj->GetJoint());
	for(pJObj=pJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
		ParsePrim(pJObj);
	}
	return true;
}

#define	WK7DEADBODYSIGN_PAPERBAG_ITEMID			(K7ITEMID(901, 0))
#define	WK7DEADBODYSIGN_PAPERBAG_ITEM_MOTID		(K7MOTID (901,30))
WK7Archive*			WK7DeadBodySign::mpPaperBagArchive       = NULL;
WK7Archive*			WK7DeadBodySign::mpPaperBagMotionArchive = NULL;
WK7DeadBodySign::WK7DeadBodySign(ghmGcListObj *pAnchor,WK7JObj *pJObj,const Mtx &mtx,const Vec &boxSize) : ghmGcListObj(pAnchor)
{
	MTXCopy   (mtx,mMtx   );
	MTXInverse(mtx,mInvMtx);
	mBoxSize   = boxSize;
	mPrimCount = 0;
	mCharaID   = 0xffffffff;
	mVisible   = false;
	GHM_VEC_SET_XYZ(&mBoxAxis[0],mBoxSize.x,0.0f,0.0f);
	GHM_VEC_SET_XYZ(&mBoxAxis[1],0.0f,mBoxSize.y,0.0f);
	GHM_VEC_SET_XYZ(&mBoxAxis[2],0.0f,0.0f,mBoxSize.z);
	ParsePrim(pJObj);
	mpPaperBag       = WK7RenderObj::CreateItem      (WK7DEADBODYSIGN_PAPERBAG_ITEMID    );
	mpPaperBagMotion = WK7MotionObj::CreateItemMotion(WK7DEADBODYSIGN_PAPERBAG_ITEM_MOTID);
	Vec		pos;
	pos.x = mtx[0][3];
	pos.y = mtx[1][3];
	pos.z = mtx[2][3];
	PaperBagSetPosition(pos);
	mCount = 0;
}

WK7DeadBodySign::~WK7DeadBodySign()
{
	GHM_SAFE_DELETE(mpPaperBag      );
	GHM_SAFE_DELETE(mpPaperBagMotion);
}

bool WK7DeadBodySign::LoadData(void)
{
	GHM_SAFE_DELETE   (mpFile   );
	GHMGCMEM_SAFE_FREE(mpTexture);
	GHM_SAFE_DELETE   (mpPaperBagArchive);
	ghmGcMemSetAllocName("DbSignFL");
	if( (mpFile = new ghmGcFile)==NULL ){
		return false;
	}
	if( mpFile->Open("/Wat/DeadBodySign.bin")==false ){
		GHM_SAFE_DELETE(mpFile);
		return false;
	}
	if( (mpTexture=(GhmGcTexHeader *)mpFile->Read())==NULL ){
		GHM_SAFE_DELETE(mpFile);
		return false;
	}
	if( WK7Item::CreateStaticArchive(WK7DEADBODYSIGN_PAPERBAG_ITEMID)==false ){
		return false;
	}
	if( WK7ItemMotion::CreateStaticArchive(WK7DEADBODYSIGN_PAPERBAG_ITEM_MOTID)==false ){
		return false;
	}
	if( (mpPaperBagArchive = WK7Archive::Find(K7OBJTYPE_ITEM,WK7DEADBODYSIGN_PAPERBAG_ITEMID))==NULL ){
		return false;
	}
	if( (mpPaperBagMotionArchive = WK7Archive::Find(K7MOT_ATTR|K7OBJTYPE_ITEM,WK7DEADBODYSIGN_PAPERBAG_ITEM_MOTID))==NULL ){
		return false;
	}
	return true;
}

bool WK7DeadBodySign::IsLoadedData(void)
{
	if( mpTexture!=NULL ){
		if( mpFile!=NULL ){
			if( mpFile->GetState()!=ghmGcFile::READFINISH ){
				return false;
			}
			GHM_SAFE_DELETE(mpFile);
		}
	}
	if( mpPaperBagArchive!=NULL ){
		if( mpPaperBagArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
			return false;
		}
	}
	if( mpPaperBagMotionArchive!=NULL ){
		if( mpPaperBagMotionArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
			return false;
		}
	}
	return true;
}

bool WK7DeadBodySign::ReleaseData(void)
{
	if( mpPaperBagArchive!=NULL ){
		mpPaperBagArchive->SetStatic(false);
		GHM_SAFE_DELETE(mpPaperBagArchive);
	}
	if( mpPaperBagMotionArchive!=NULL ){
		mpPaperBagMotionArchive->SetStatic(false);
		GHM_SAFE_DELETE(mpPaperBagMotionArchive);
	}
	GHM_SAFE_DELETE   (mpFile   );
	GHMGCMEM_SAFE_FREE(mpTexture);
	return true;
}

bool WK7DeadBodySign::SetVisible(bool flag)
{
	mVisible = flag;
	return true;
}

bool WK7DeadBodySign::PaperBagSetVisible(bool flag)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	mpPaperBag->SetRenderFlag(flag);
	return true;
}

bool WK7DeadBodySign::PaperBagGetVisible(void)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->GetRenderFlag();
}

bool WK7DeadBodySign::PaperBagSetPosition(const Vec &pos)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->SetPosition(pos);
}

bool WK7DeadBodySign::PaperBagSetPosition(const Vec *pPos)
{
	if( pPos==NULL ){
		return false;
	}
	return PaperBagSetPosition(*pPos);
}

bool WK7DeadBodySign::PaperBagGetPosition(Vec &pos)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->GetPosition(pos);
}

bool WK7DeadBodySign::PaperBagGetPosition(Vec *pPos)
{
	if( pPos==NULL ){
		return false;
	}
	return PaperBagGetPosition(*pPos);
}

bool WK7DeadBodySign::PaperBagSetRotation(const Vec &rot)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->SetRotation(rot);
}

bool WK7DeadBodySign::PaperBagSetRotation(const Vec *pRot)
{
	if( pRot==NULL ){
		return false;
	}
	return mpPaperBag->SetRotation(*pRot);
}

bool WK7DeadBodySign::PaperBagGetRotation(Vec &rot)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->GetRotation(rot);
}

bool WK7DeadBodySign::PaperBagGetRotation(Vec *pRot)
{
	if( pRot==NULL ){
		return false;
	}
	return mpPaperBag->GetRotation(*pRot);
}

bool WK7DeadBodySign::PaperBagSetRotY(f32 roty)
{
	if( mpPaperBag==NULL ){
		return false;
	}
	return mpPaperBag->SetRotY(roty);
}

f32 WK7DeadBodySign::PaperBagGetRotY(void)
{
	if( mpPaperBag==NULL ){
		return 0.0f;
	}
	f32	roty;
	mpPaperBag->GetRotY(&roty);
	return roty;
}

bool WK7DeadBodySign::FrameProcess(void)
{
	WK7Model		*pModel;
	if( mpPaperBag !=NULL && (pModel=mpPaperBag->GetModel())!=NULL ){
		if( mCount < WK7_TICK_PER_FRAME ){
			WK7ModelMotion	*pModelMotion;
			if( mpPaperBagMotion!=NULL && (pModelMotion=mpPaperBagMotion->GetModelMotion())!=NULL ){
				pModel->AttachMotion (pModelMotion);
				pModel->PlayMotion   ();
				pModel->SetMotionLoop(false);
				mCount  = (HSD_Rand() % WK7_SEC_TO_TICK(10)) + WK7_SEC_TO_TICK(5);
			}
		}else{
			if( pModel->GetMotionState()==WK7MODEL_NOANIM ){
				mCount -= WK7_TICK_PER_FRAME;
			}
		}
	}
	return true;
}

extern "C"{
extern	GXColor GetShadowIntensity( void );
extern	MtxPtr	SetupRampMtx( HSD_CObj* cobj );
extern	HSD_TObj* GetRampTex( void );
}
bool WK7DeadBodySign::RenderProcess(void)
{
	if( mPrimCount <= 0 || mpTexture==NULL || mVisible==false ){
		return true;
	}
	
	C_Shadow		*pCShadow;
	HSD_Shadow		*pHSDShadow;
	HSD_TObj		*pShadowTObj=NULL;
	HSD_TObj		*pRampTObj = GetRampTex();
	if( (pCShadow=WK7SHADOW->GetShadow())!=NULL && (pHSDShadow = pCShadow->GetShadow())!=NULL ){
		pShadowTObj = pHSDShadow->texture;
	}
	
	WK7PolyFace		*pFace;
	Mtx				view;
//	Mtx44			proj;
	Mtx				mtx;
	GXTexObj		texObj;
static	bool		face = true;
static	bool		edge = false;
static	bool		box  = false;
	
	WK7CAM->GetViewingMtxCurrent(view);
	
	// [Jr[ϊ}gNXݒ
	GXLoadPosMtxImm  (view,GX_PNMTX0);
	GXLoadNrmMtxImm  (view,GX_PNMTX0);
	GXSetCurrentMtx  (GX_PNMTX0);
	
	GXSetDither      (GX_FALSE);
	GXSetDstAlpha    (0,0);
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_AND,GX_ALWAYS,0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	
	GXSetBlendMode   (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode    (GX_CULL_NONE);
	
	GXSetZMode       (GX_TRUE,GX_LEQUAL,GX_FALSE);
//	GXSetZMode       (GX_TRUE,GX_LEQUAL,GX_TRUE);
	GXSetZCompLoc    (GX_TRUE);
	GXSetColorUpdate (GX_TRUE);
	GXSetAlphaUpdate (GX_FALSE);
	
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc     (GX_VA_TEX0,GX_DIRECT);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	
	GXInitTexObj     (&texObj,GHMGCTEX_GETIMAGE(mpTexture),
	                          mpTexture->mWidth,
	                          mpTexture->mHeight,
	                          mpTexture->mFormat,
//	                          GX_REPEAT,
//	                          GX_REPEAT,
	                          GX_CLAMP,
	                          GX_CLAMP,
	                          GX_FALSE);
	GXInitTexObjLOD  (&texObj,
	                          GX_LINEAR,
	                          GX_LINEAR,
//	                          GX_NEAR,
//	                          GX_NEAR,
	                          0.0f,
	                          0.0f,
	                          0.0f,
	                          GX_FALSE,
	                          GX_FALSE,
	                          GX_ANISO_1);
	GXLoadTexObj     (&texObj,GX_TEXMAP0);
	
	// VhEeNX`
static	bool	useShadow = true;
	if( useShadow==true && pShadowTObj!=NULL && pRampTObj!=NULL ){
		
	    HSD_ImageDesc	*imagedesc;
	    
		GXSetNumTevStages(4);
		GXSetNumTexGens  (3);
		
	    imagedesc = pRampTObj->imagedesc;
		GXInitTexObj     (&texObj,imagedesc->image_ptr,
		                          imagedesc->width,
		                          imagedesc->height, 
		                          imagedesc->format, 
		                          pRampTObj->wrap_s,
		                          pRampTObj->wrap_t,
		                          GX_FALSE);
		GXInitTexObjLOD  (&texObj,GX_NEAR,
		                          GX_NEAR,
		                          0.0f,
		                          0.0f,
		                          0.0f,
		                          GX_FALSE,
		                          GX_FALSE,
		                          GX_ANISO_1);
		GXLoadTexObj     (&texObj,GX_TEXMAP2);
		
		GXLoadTexMtxImm  (SetupRampMtx(NULL),GX_TEXMTX2,GX_MTX3x4);
		GXSetTexCoordGen (GX_TEXCOORD2,GX_TG_MTX3x4,GX_TG_POS,GX_TEXMTX2);
		
	    imagedesc = pShadowTObj->imagedesc;
		GXInitTexObj     (&texObj,imagedesc->image_ptr,
		                          imagedesc->width,
		                          imagedesc->height,
		                          imagedesc->format, 
		                          pShadowTObj->wrap_s,
		                          pShadowTObj->wrap_t,
		                          GX_FALSE);
		GXInitTexObjLOD  (&texObj,GX_NEAR,
		                          GX_NEAR,
		                          0.0f,
		                          0.0f,
		                          0.0f,
		                          GX_FALSE,
		                          GX_FALSE,
		                          GX_ANISO_1);
		GXLoadTexObj     (&texObj,GX_TEXMAP1);
		
		GXLoadTexMtxImm  (pShadowTObj->mtx,GX_TEXMTX1,GX_MTX3x4);
		GXSetTexCoordGen (GX_TEXCOORD1,GX_TG_MTX3x4,GX_TG_POS,GX_TEXMTX1);
		
		GXSetTevKColor   (GX_KCOLOR3,GetShadowIntensity());
		GXSetTevKColorSel(GX_TEVSTAGE2,GX_TEV_KCSEL_K3_R);
		
		// z
		GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD2,GX_TEXMAP2,GX_COLOR_NULL);
		GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
		GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVREG2);
		GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_APREV);
		GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		
		// VhE
		GXSetTevOrder    (GX_TEVSTAGE2,GX_TEXCOORD1,GX_TEXMAP1,GX_COLOR_NULL);
		GXSetTevColorIn  (GX_TEVSTAGE2,GX_CC_C2,GX_CC_TEXC,GX_CC_KONST,GX_CC_ZERO);
		GXSetTevColorOp  (GX_TEVSTAGE2,GX_TEV_COMP_R8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_FALSE,GX_TEVREG2);
		GXSetTevAlphaIn  (GX_TEVSTAGE2,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_APREV);
		GXSetTevAlphaOp  (GX_TEVSTAGE2,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		
		// |Z
		GXSetTevOrder    (GX_TEVSTAGE3,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR_NULL);
		GXSetTevColorIn  (GX_TEVSTAGE3,GX_CC_CPREV,GX_CC_ZERO,GX_CC_C2,GX_CC_ZERO);
		GXSetTevColorOp  (GX_TEVSTAGE3,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_FALSE,GX_TEVPREV);
		GXSetTevAlphaIn  (GX_TEVSTAGE3,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_APREV);
		GXSetTevAlphaOp  (GX_TEVSTAGE3,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		
	}else{
		GXSetNumTevStages(1);
		GXSetNumTexGens  (1);
	}
	
	GXSetTexCoordGen (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXC,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_RASA,GX_CA_TEXA,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	
static	f32		zofs = -0.00001f;
	GXSetZScaleOffset(1.0f,zofs);
	
	if( face==true ){
static		GXColor			facematcolor = { 0xff , 0xff , 0xff , 0xff };
		GXSetChanMatColor(GX_COLOR0A0,facematcolor);
		GXBegin(GX_TRIANGLES,GX_VTXFMT0,(u16)(3 * mPrimCount));
		for(pFace=(WK7PolyFace *)mPrimAnchor.GetNext() ; pFace!=NULL ; pFace=pFace->GetNext()){
			pFace->RenderProcess();
		}
		GXEnd();
	}
	
	if( edge==true ){
static		GXColor			edgematcolor = { 0x00 , 0xff , 0x00 , 0x80 };
		
		GXClearVtxDesc   ();
		GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
		GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
		
		GXSetNumTexGens  (0);
		
		GXSetNumTevStages(1);
		GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
		GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
		GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
		GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		
		for(pFace=(WK7PolyFace *)mPrimAnchor.GetNext() ; pFace!=NULL ; pFace=pFace->GetNext()){
			pFace->RenderEdge();
		}
	}
	
	if( box==true ){
static		GXColor			boxmatcolor = { 0x00 , 0x00 , 0xff , 0x80 };
		GXSetChanMatColor(GX_COLOR0A0,boxmatcolor);
		
		MTXConcat(view,mMtx,mtx);
		
		GXLoadPosMtxImm  (mtx,GX_PNMTX0);
		GXLoadNrmMtxImm  (mtx,GX_PNMTX0);
		GXSetCurrentMtx  (GX_PNMTX0);
		
		GXClearVtxDesc   ();
		GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
		GXSetVtxAttrFmt  (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
		
		GXSetNumTexGens  (0);
		
		GXSetNumTevStages(1);
		GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
		GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
		GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
		GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
		
		GXBegin(GX_LINES,GX_VTXFMT0,12 * 2);
			
			GXPosition3f32( mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			GXPosition3f32( mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			
			GXPosition3f32( mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			GXPosition3f32( mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x, mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			
			GXPosition3f32( mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			GXPosition3f32( mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32( mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y, mBoxSize.z);
			GXPosition3f32(-mBoxSize.x,-mBoxSize.y,-mBoxSize.z);
			
		GXEnd();
		
	}
	
	GXSetZScaleOffset(1.0f,0.0f);
	
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	return true;
}

