////////////////////////////////////////////////////////////////////////////////
//
// Killer7 DeadBodySign
//
// WK7DeadBodySign.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/04/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7DEADBODYSIGN_H__
#define	__WK7DEADBODYSIGN_H__

//#include <dolphin.h>
//#include <sysdolphin/baselib.h>
//#include "..\Lib\ghmGcList.h"
#include ".\WK7Model.h"

class WK7PolyFace : public ghmGcListObj{
protected:
	Vec							mPosition[3];
	u32							mFaceColor;
public:
	WK7PolyFace(ghmGcListObj *pAnchor);
	virtual ~WK7PolyFace();
	
	inline WK7PolyFace* GetNext(void){ return (WK7PolyFace *)ghmGcListObj::GetNext(); }
	inline WK7PolyFace* GetPrev(void){ return (WK7PolyFace *)ghmGcListObj::GetPrev(); }
	
	bool SetPosition(int index,const Vec &pos);
	bool GetPosition(int index,Vec &pos);
	
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
	virtual bool RenderEdge(void);
};

class WK7PolyFaceUV : public WK7PolyFace{
protected:
	f32							mUV[3][2];
public:
	WK7PolyFaceUV(ghmGcListObj *pAnchor);
	virtual ~WK7PolyFaceUV();
	
	inline WK7PolyFaceUV* GetNext(void){ return (WK7PolyFaceUV *)WK7PolyFace::GetNext(); }
	inline WK7PolyFaceUV* GetPrev(void){ return (WK7PolyFaceUV *)WK7PolyFace::GetPrev(); }
	
	bool SetUV(int index,f32 u,f32 v);
	bool GetUV(int index,f32 *pu,f32 *pv);
	
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
	virtual bool RenderEdge(void);
};

class WK7DeadBodySign : public ghmGcListObj{
protected:
	ghmGcListObj				mPrimAnchor;
	Mtx							mMtx,mInvMtx;
	Vec							mBoxSize;
	Vec							mBoxAxis[3];
	int							mPrimCount;
	u32							mCharaID;
	bool						mVisible;
	WK7Item						*mpPaperBag;
	WK7ItemMotion				*mpPaperBagMotion;
	u32							mCount;
	static ghmGcFile			*mpFile;
	static GhmGcTexHeader		*mpTexture;
	static WK7Archive			*mpPaperBagArchive;
	static WK7Archive			*mpPaperBagMotionArchive;
	
	bool Intersect(const Vec &dir,const Vec pos[3]);
	bool CreatePrim(const Vec pos[3]);
	bool ParsePrim(HSD_PObj *pPObj,const Mtx &mtx);
	bool ParsePrim(HSD_DObj *pDObj,HSD_DObjDesc *pDObjDesc,const Mtx &mtx);
	bool ParsePrim(HSD_JObj *pHSDJObj,HSD_Joint *pJoint);
	bool ParsePrim(WK7JObj *pJObj);
public:
	WK7DeadBodySign(ghmGcListObj *pAnchor,WK7JObj *pJObj,const Mtx &mtx,const Vec &boxSize);
	virtual ~WK7DeadBodySign();
	
	inline WK7DeadBodySign* GetNext(void){ return (WK7DeadBodySign *)ghmGcListObj::GetNext(); }
	inline WK7DeadBodySign* GetPrev(void){ return (WK7DeadBodySign *)ghmGcListObj::GetPrev(); }
	
	inline void SetCharaID(u32 charaid){ mCharaID=charaid; }
	inline u32 GetCharaID(void){ return mCharaID; }
	
	inline int GetPrimCount(void){ return mPrimCount; }
	inline void GetMtx(Mtx mtx){ MTXCopy(mMtx,mtx); }
	inline void GetBoxSize(Vec &boxSize){ boxSize=mBoxSize; }
	
	static bool LoadData(void);
	static bool IsLoadedData(void);
	static bool InitializeData(void);
	static bool ReleaseData(void);
	inline static void* GetTexture(void){ return mpTexture; }
	inline WK7Item* GetPaperBag(void){ return mpPaperBag; }
	
	bool PaperBagSetVisible(bool flag);
	bool PaperBagGetVisible(void);
	bool PaperBagSetPosition(const Vec &pos);
	bool PaperBagSetPosition(const Vec *pPos);
	bool PaperBagGetPosition(Vec &pos);
	bool PaperBagGetPosition(Vec *pPos);
	bool PaperBagSetRotation(const Vec &rot);
	bool PaperBagSetRotation(const Vec *pRot);
	bool PaperBagGetRotation(Vec &rot);
	bool PaperBagGetRotation(Vec *pRot);
	bool PaperBagSetRotY(f32 roty);
	f32 PaperBagGetRotY(void);
	
	bool SetVisible(bool flag);
	inline bool GetVisible(void){ return mVisible; }
	
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
	
	inline static WK7Archive* GetPaperBagArchive(void){ return mpPaperBagArchive; }
	inline static WK7Archive* GetPaperBagMotionArchive(void){ return mpPaperBagMotionArchive; }
};


#endif	//__WK7DEADBODYSIGN_H__

