////////////////////////////////////////////////////////////////////////////////
//
// Killer7 EffectBreakObj
//
// WK7EffectBreakObj.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 03/24/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EFFECTBREAKOBJ_H__
#define	__WK7EFFECTBREAKOBJ_H__

//#include <dolphin.h>
//#include "..\Lib\ghmGcList.h"
#include ".\WK7Model.h"
#include ".\WK7Anim.h"

struct WK7FaceST{
	f32							s,t;
};

class WK7EffectBreakFace : public ghmGcListObj{
	friend class WK7EffectBreakMesh;
	friend class WK7EffectBreakObj;
protected:
	static	f32					mLimitSurfaceSize;
	Vec							mVertex[3];
	Vec							mPosition;
	Vec							mVelocity;
	Vec							mRotation;
	Vec							mRotVelocity;
	Mtx							mLocalWorldMatrix;
//	int							mState;
	
	bool MakeMatrix(void);
public:
	WK7EffectBreakFace(ghmGcListObj *pAnchor);
	virtual ~WK7EffectBreakFace();
	
	inline static void SetLimitSurfaceSize(f32 size=-1.0f){ mLimitSurfaceSize=size; }
	inline static f32 GetLimitSurfaceSize(void){ return mLimitSurfaceSize; }
	
	inline WK7EffectBreakFace* GetNext(void){ return (WK7EffectBreakFace*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakFace* GetPrev(void){ return (WK7EffectBreakFace*)ghmGcListObj::GetPrev(); }
	
//	inline int GetState(void){ return mState; }
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
};

class WK7EffectBreakFaceR : public WK7EffectBreakFace{
	friend class WK7EffectBreakMesh;
	friend class WK7EffectBreakObj;
protected:
public:
	WK7EffectBreakFaceR(ghmGcListObj *pAnchor) : WK7EffectBreakFace(pAnchor){}
	virtual ~WK7EffectBreakFaceR(){}
	
	inline WK7EffectBreakFaceR* GetNext(void){ return (WK7EffectBreakFaceR*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakFaceR* GetPrev(void){ return (WK7EffectBreakFaceR*)ghmGcListObj::GetPrev(); }
	
	virtual bool FrameProcess(void){ return WK7EffectBreakFace::FrameProcess(); }
	virtual bool RenderProcess(void){ return WK7EffectBreakFace::RenderProcess(); }
};

class WK7EffectBreakFaceT : public WK7EffectBreakFace{
	friend class WK7EffectBreakMesh;
protected:
	WK7St						mST[3];
public:
	WK7EffectBreakFaceT(ghmGcListObj *pAnchor);
	virtual ~WK7EffectBreakFaceT();
	
	inline WK7EffectBreakFaceT* GetNext(void){ return (WK7EffectBreakFaceT*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakFaceT* GetPrev(void){ return (WK7EffectBreakFaceT*)ghmGcListObj::GetPrev(); }
	
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
};

class WK7EffectBreakFaceTR : public WK7EffectBreakFaceT{
	friend class WK7EffectBreakMesh;
protected:
	WK7St						mST[3];
public:
	WK7EffectBreakFaceTR(ghmGcListObj *pAnchor) : WK7EffectBreakFaceT(pAnchor){}
	virtual ~WK7EffectBreakFaceTR(){}
	
	inline WK7EffectBreakFaceTR* GetNext(void){ return (WK7EffectBreakFaceTR*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakFaceTR* GetPrev(void){ return (WK7EffectBreakFaceTR*)ghmGcListObj::GetPrev(); }
	
	virtual bool FrameProcess(void){ return WK7EffectBreakFaceT::FrameProcess(); }
	virtual bool RenderProcess(void){ return WK7EffectBreakFaceT::RenderProcess(); }
};

class WK7EffectBreakObj;
class WK7EffectBreakMesh : public ghmGcListObj{
	friend class WK7EffectBreakObj;
protected:
	WK7EffectBreakObj			*mpContainer;
	ghmGcListObj				mFaceAnchor;
	int							mFaceCount;
//	int							mState;
	HSD_DObj					*mpDObj;
	HSD_MObj					*mpMObj;
	HSD_TObj					*mpTObj;
	HSD_TObj					*mpRampTObj;
	
	bool CreateFace(Mtx mtx,Vec *pPos,WK7St *pSt,int level);
	bool ParsePObj(HSD_PObj *pPObj,Mtx mtx,int level);
	bool ParseDObj(HSD_DObj *pDObj,Mtx mtx,int level);
public:
	WK7EffectBreakMesh(ghmGcListObj *pAnchor,WK7EffectBreakObj *pContainer,HSD_DObj *pDObj,Mtx mtx,int level);
	virtual ~WK7EffectBreakMesh();
	
	inline WK7EffectBreakMesh* GetNext(void){ return (WK7EffectBreakMesh*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakMesh* GetPrev(void){ return (WK7EffectBreakMesh*)ghmGcListObj::GetPrev(); }
	
//	inline int GetState(void){ return mState; }
	bool FrameProcess(void);
	bool RenderProcess(void);
};

class WK7EffectBreakObj : public ghmGcListObj{
protected:
	enum{
		WK7EFFECTBREAKOBJ_IDLE = 0,
		WK7EFFECTBREAKOBJ_EXEC,
		WK7EFFECTBREAKOBJ_TERM,
	};
static	ghmGcListObj			mAnchor;
static	Mtx						mViewMatrix;
	ghmGcListObj				mMeshAnchor;
	int							mMeshCount;
	int							mState;
	bool						mVisible;
	WK7AnimLinearF				mAlpha;
	
	bool ParseDObj(HSD_DObj *pDObj,Mtx mtx,int level);
	bool ParseJObj(HSD_JObj *pJObj,int level);
	bool ParseJObj(WK7JObj *pJObj,bool next,bool child,int level);
	
	WK7EffectBreakObj(WK7JObj *pJObj,bool next,bool child,int level);
	~WK7EffectBreakObj();
public:
	inline f32 GetAlpha(void){ return mAlpha.GetValue(); }
	static WK7EffectBreakObj* Create(WK7JObj *pJObj,bool next=false,bool child=true,int level=0);
	static bool Release(WK7EffectBreakObj *pObj);
	static bool Find(WK7EffectBreakObj *pObj);
	static bool IsValid(WK7EffectBreakObj *pObj);
	inline static MtxPtr GetViewMatrix(void){ return mViewMatrix; }
	
	inline WK7EffectBreakObj* GetNext(void){ return (WK7EffectBreakObj*)ghmGcListObj::GetNext(); }
	inline WK7EffectBreakObj* GetPrev(void){ return (WK7EffectBreakObj*)ghmGcListObj::GetPrev(); }
	
	inline static void SetLimitSurfaceSize(f32 size=-1.0f){ WK7EffectBreakFace::SetLimitSurfaceSize(size); }
	inline static f32 GetLimitSurfaceSize(void){ return WK7EffectBreakFace::GetLimitSurfaceSize(); }
	
	static void Clear(void);
	static bool FrameProcessAll(void);
	static bool RenderProcessAll(void);
	
	bool Start(u32 tick=WK7_SEC_TO_TICK(1.0f));
	bool Stop(void);
	bool IsBroken(void);
	
	inline void SetVisible(bool flag){ mVisible=flag; }
	inline bool GetVisible(void){ return mVisible; }
	
	inline int GetState(void){ return mState; }
	bool FrameProcess(void);
	bool RenderProcess(void);
};

#endif	//__WK7EFFECTBREAKOBJ_H__

