////////////////////////////////////////////////////////////////////////////////
//
// Killer7 EventItem
//
// WK7EventItem.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 09/29/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7EVENTITEM_H__
#define	__WK7EVENTITEM_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include ".\WK7Event.h"

#define	K7EVITEM_TYPE_KEY									(K7EV_TYPE_KEY)
#define	K7EVITEM_TYPE_MAP									(K7EV_TYPE_MAP)
#define	K7EVITEM_TYPE_MEMO									(K7EV_TYPE_MEMO)
#define	K7EVITEM_TYPE_VMEMO									(K7EV_TYPE_VMEMO)
#define	K7EVITEM_TYPE_ZAN									(K7EV_TYPE_ZAN)
#define	K7EVITEM_TYPE_TAMA									(K7EV_TYPE_TAMA)
#define	K7EVITEM_TYPE_MASK									(K7EV_TYPE_MASK)
#define	K7EVITEM_KEY(no)									(K7EVITEM_TYPE_KEY  |0x##no)
#define	K7EVITEM_MAP(no)									(K7EVITEM_TYPE_MAP  |0x##no)
#define	K7EVITEM_MEMO(no)									(K7EVITEM_TYPE_MEMO |0x##no)
#define	K7EVITEM_HATOMEMO(no)								(K7EVITEM_TYPE_MEMO |0x##no)
#define	K7EVITEM_VMEMO(no)									(K7EVITEM_TYPE_VMEMO|0x##no)
#define	K7EVITEM_TAPE(no)									K7EVITEM_VMEMO(no)
#define	K7EVITEM_ZAN(no)									(K7EVITEM_TYPE_ZAN  |0x##no)
#define	K7EVITEM_TAMA(no)									(K7EVITEM_TYPE_TAMA |0x##no)

#define	K7EVITEM_KEYID(id)									(K7EVITEM_TYPE_KEY  |id)
#define	K7EVITEM_MAPID(id)									(K7EVITEM_TYPE_MAP  |id)
#define	K7EVITEM_MEMOID(id)									(K7EVITEM_TYPE_MEMO |id)
#define	K7EVITEM_HATOMEMOID(id)								(K7EVITEM_TYPE_MEMO |id)
#define	K7EVITEM_VMEMOID(id)								(K7EVITEM_TYPE_VMEMO|id)
#define	K7EVITEM_TAPEID(id)									K7EVITEM_VMEMOID(id)
#define	K7EVITEM_ZANID(id)									(K7EVITEM_TYPE_ZAN  |id)
#define	K7EVITEM_TAMAID(id)									(K7EVITEM_TYPE_TAMA |id)

struct WK7EventItemTable{
	u32				mItemNo;
};
#define	WK7EVITEMTBL_TERM_ITEMNO			0xffffffff
//#define	WK7EVITEMTBL_TERM_FLAGID			0xffffffff
//#define	WK7EVITEMTBL(item,flag)				{ item , flag },
//#define	WK7EVITEMTBL_TERM					{ WK7EVITEMTBL_TERM_ITEMNO , WK7EVITEMTBL_TERM_FLAGID },
#define	WK7EVITEMTBL(item)					{ item  },
#define	WK7EVITEMTBL_TERM					{ WK7EVITEMTBL_TERM_ITEMNO  },

#define	WK7EVENTITEM_MAX					(128 * 2)
#define	WK7EVENTITEM_WORKSIZE				((WK7EVENTITEM_MAX + 32 - 1 ) / 32)
#define	WK7EVENTITEM_WORKID(id)				(u32)((id) >> 4)
#define	WK7EVENTITEM_WORKBITID(id)			(u32)(((id) & 0xf) << 1)
#define	WK7EVENTITEM_WORKBIT(id)			(u32)(1 << (((id) & 0xf) << 1))
#define	WK7EVENTITEM_SIZE					(WK7EVENTITEM_WORKSIZE * sizeof(u32))
class WK7EventItem{
protected:
	static WK7EventItemTable			*mpTable;
	static u32							mFlag[WK7EVENTITEM_WORKSIZE];
	
	WK7EventItem();
	~WK7EventItem();
public:
	
	static bool Initialize(void);
	
	inline static void SetTable(WK7EventItemTable *pTable){ mpTable=pTable; }
	inline static WK7EventItemTable* GetTable(void){ return mpTable; }
	static WK7EventItemTable* FindTable(u32 itemno);
	static int FindTableID(u32 itemno);
	static bool SetItem(u32 itemno,bool flag);
	static bool HasItem(u32 itemno);
	static bool UseItem(u32 itemno,bool flag);
	static bool IsUsedItem(u32 itemno);
	inline static bool GetItem(u32 itemno){ return HasItem(itemno); }
	static u32* GetFlagTop(void){ return mFlag; }
	
};

#endif	//__WK7EVENTITEM_H__

