////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Extra Object
//
// WK7Extra.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 06/27/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7EXTRA_CPP__

//#include <dolphin.h>
#include ".\WK7Extra.h"
#include ".\WK7Player.h"
#include ".\WK7MainTask.h"
#include ".\WK7SelectIF.h"
//#include "..\Lib\ghmGcFile.h"
//#include "..\Lib\ghmGcMath.h"
#include "..\Kaw\KK7Effect.h"

#include "..\Extra\ExtraA.h"



#define NODAMAGE 0								// 1FGȂ


WK7Extra::WK7Extra(u32 extraid,ghmGcListObj *pAnchor,int prio) : WK7Npc(extraid,TYPE_EXTRA,pAnchor,prio)
{
	mpPathBranchPointObj = NULL;
}

WK7Extra::~WK7Extra()
{
	GHM_SAFE_DELETE(mpPathBranchPointObj);
}

bool WK7Extra::Initialize(void)
{
	// IIuWFNgaݒ
	mSelectObjRadius = 10.0f;
#if 0
#if 1
	K7EventDescStgBpExtraContact	*pDesc;
	K7EventDescData					data;
	data.Initialize();
	while( (pDesc=(K7EventDescStgBpExtraContact *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGBPEXTRACONTACT,data))!=NULL ){
		if( pDesc->mExtraID!=mEneNo ){
			continue;
		}
		WK7Stage		*pStage = WK7RenderObj::GetStage(GetStageID());
		if( pStage==NULL ){
			OSDebugReport("ExtraContact Stage Not Found : %08x\n",GetStageID());
			continue;
		}
		WK7PathBranchPoint	*pBranchPoint = pStage->GetPathBranchPoint(pDesc->mpBpName);
		if( pBranchPoint==NULL ){
			OSDebugReport("ExtraContact BranchPoint Not Found : %s\n",pDesc->mpBpName);
			continue;
		}
		if( (mpPathBranchPointObj = pBranchPoint->AddObj())!=NULL ){
			mpPathBranchPointObj->SetEventID(pDesc->mBase.mID);
			mpPathBranchPointObj->SetObjName(0,pDesc->mpDispName0);
			mpPathBranchPointObj->SetObjName(1,pDesc->mpDispName1);
			mpPathBranchPointObj->SetEnable (true);
		}
		break;
	}
#else
	// IIuWFNg
	ghmGcMemSetAllocName("WK7SelOS");
	if( (mpSelectObj = new WK7SelectObjSphere)!=NULL ){
		mpSelectObj->SetSelectCallback(SelectCallback);
		mpSelectObj->SetParam         (0,(u32)this);
		K7EventDescExtraContact	*pDesc;
		K7EventDescData			data;
		data.Initialize();
		while( (pDesc=(K7EventDescExtraContact *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_EXTRACONTACT,data))!=NULL ){
			if( pDesc->mExtraID==mEneNo ){
				SetSelectEventID  (pDesc->mBase.mID);
				SetSelectObjEnable(true);
				break;
			}
		}
	}
#ifdef	_DEBUG
	else{
		OSReport("Extra SelectObj Creation Failed!!\n");
	}
#endif
	// IuWFNgIs
	SetSelectObjEnable(false);
#endif
#endif
	return true;
}

//WK7Extra* WK7Extra::Create(u32 extraid,u32 stgid,u32 param)
//{
//	WK7Extra		*pExtra;
//	switch( extraid ){
//	case	K7EXTRA_A: pExtra = new K7ExtraA(extraid,&mAnchor); break;
//	default:
//		return NULL;
//	}
//	if( pExtra==NULL ){
//		return NULL;
//	}
//	pExtra->mStageID = stgid;
//	pExtra->mParam   = param;
//	return pExtra;
//}

bool WK7Extra::SetRotY(f32 targety, f32 roty)
{
#pragma	unused(roty)
	mRotY = targety;
	if( mpNpcChara!=NULL ){					// ZbgȂl
		mpNpcChara->SetRotY(targety);
	}
	return true;
}

WK7Extra* WK7Extra::Find(u32 extraid,u32 stgid,u32 param)
{
	WK7Npc		*pNpc = (WK7Npc *)mAnchor.GetNext();
	while( pNpc!=NULL ){
		if( pNpc->GetID()==extraid && pNpc->GetType()==TYPE_EXTRA ){
			if( stgid==0xffffffff || pNpc->GetStageID()==stgid ){
				if( param==0xffffffff || pNpc->GetParam()==param ){
					return (WK7Extra *)pNpc;
				}
			}
		}
		pNpc = pNpc->GetNext();
	}
	return NULL;
}

bool WK7Extra::ReleaseStageExtra(u32 stgid)
{
	WK7Npc			*pNpc = (WK7Npc *)mAnchor.GetNext();
	WK7Npc			*pNext;
	while( pNpc!=NULL ){
		pNext = pNpc->GetNext();
		if( pNpc->GetStageID()==stgid && pNpc->GetType()==TYPE_EXTRA ){
			delete pNpc;
		}
		pNpc = pNext;
	}
	return true;
}

bool WK7Extra::ReleasePathBranchPointObj(WK7PathBranchPointObj *pPathBranchPointObj)
{
	WK7Npc			*pNpc;
	for(pNpc=(WK7Extra *)mAnchor.GetNext() ; pNpc!=NULL ; pNpc=pNpc->GetNext()){
		if( pNpc->GetType()!=TYPE_EXTRA ){
			continue;
		}
		WK7Extra	*pExtra = (WK7Extra *)pNpc;
		if( pExtra->GetPathBranchPointObj()==pPathBranchPointObj ){
			pExtra->SetPathBranchPointObj(NULL);
		}
	}
	return true;
}


bool WK7Extra::SetSelectObjEnable(bool flag)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	WK7SelectObjSphere	*pSelectObj = (WK7SelectObjSphere *)mpSelectObj;
	pSelectObj->SetRadius(mSelectObjRadius);
	pSelectObj->SetEnable(flag);
	return true;
}

bool WK7Extra::GetSelectObjEnable(void)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->GetEnable();
}

bool WK7Extra::SetSelectObjPlayEnable(bool flag)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetPlayEnable(flag);
	return true;
}

bool WK7Extra::GetSelectObjPlayEnable(void)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->GetPlayEnable();
}

bool WK7Extra::SetSelectObjName(int index,const char *pName)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->SetObjName(index,pName);
}

bool WK7Extra::SetSelectObjName(const char *pName0,const char *pName1)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetObjName(0,pName0);
	mpSelectObj->SetObjName(1,pName1);
	return true;
}

const char* WK7Extra::GetSelectObjName(int index)
{
	if( mpSelectObj==NULL ){
		return NULL;
	}
	return mpSelectObj->GetObjName(index);
}

bool WK7Extra::SetSelectEventID(u32 eventid)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetSelectEventID(eventid);
	return true;
}

u32 WK7Extra::GetSelectEventID(void)
{
	if( mpSelectObj==NULL ){
		return 0xffffffff;
	}
	return mpSelectObj->GetSelectEventID();
}

int WK7Extra::SelectCallback(void)
{
	return WK7SelectObj::SELECT_OK;
}

int WK7Extra::SelectCallback(WK7SelectObj *pObj)
{
	if( pObj==NULL ){
		return WK7SelectObj::SELECT_CANCEL;
	}
	WK7Extra		*pExtra = (WK7Extra *)pObj->GetParam(0);
	if( pExtra==NULL ){
		return WK7SelectObj::SELECT_CANCEL;
	}
	return pExtra->SelectCallback();
}



// mState :: NPC_STATE_INIT
bool WK7Extra::StateInit(void)
{
	if ( false == CreateModelInit() )  return false;
	if ( false == MotSet_Wait(false) ) return false;
	SetVisible(true);
//	HideModeDispReq();
	mState = NPC_STATE_WAIT;
	return true;
}


/*
	
	
	eL`h
	
	GLXg͊{IɂȂɂȂ
	
	
*/
bool WK7Extra::Ai(void)
{
	return true;
}



bool WK7Extra::MotSet_Dmg(void)
{
	return true;
}


