////////////////////////////////////////////////////////////////////////////////
//
// Killer7 GameInfo
//
// WK7GameInfo.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7GAMEINFO_CPP__

#include <string.h>
#include ".\WK7GameInfo.h"
#include ".\WK7Cam.h"
#include ".\WK7Player.h"
#include ".\WK7Sight.h"
#include ".\WK7Npc.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Chara.h"
#include ".\WK7CharaPresent.h"
#include ".\WK7Stage.h"
#include ".\WK7Item.h"
#include ".\WK7SceneBlur.h"
#include ".\WK7Stage.h"
#include ".\WK7Event.h"
#include ".\K7GlobalFlag.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Fujita\C_Font.h"
#include "..\Sato\SK7SaveProcess.h"
//#include "..\Sato\SK7SaveLoad.h"
#include "..\Sato\SK7IMenuMap.h"
#include "..\Yam\YK7EffectHSDead.h"
#include "..\Yam\YK7EffectBlood.h"
#include ".\WK7Zan.h" 
#include "..\Sato\SK7IMenuHato.h"
#include "..\Sato\SK7Moon.h"
#include "..\Sato\SK7Special.h"
#include ".\WK7Memo.h" 
#include ".\WK7Tutorial.h" 
#include "..\Yam\YK7MapSelect.h"
#include "..\Kaw\KK7BattleCtrl.h"

#include ".\K7ID.h"
#include ".\WK7EventScript.h"
#include ".\WK7EventItem.h"
#include ".\WK7Event.h"
#include "..\Scn\K7Scn00.h"
#include "..\Scn\K7Scn01.h"
#include "..\Scn\K7Scn02.h"
#include "..\Scn\K7Scn03.h"
#include "..\Scn\K7Scn04.h"
#include "..\Scn\K7Scn05.h"
#include "..\Scn\K7Scn06.h"
#include "..\Scn\K7Scn07.h"
#include "..\Scn\K7Scn97.h"
#include "..\Scn\K7Scn98.h"
#include "..\Scn\K7Scn99.h"

#include "..\Stage\K7Stage121M00.h"

#define	WK7GAMEINFO_PAD_SPMENU		(HSD_PAD_START)
#define	WK7GAMEINFO_PAD_MENUMAP		(HSD_PAD_X)

#define	K7EV_DECL_ENUM

#define	WK7GAMEINFO_MEMO_ROTY_NOUSE			(1000.0f)

#define	WK7GAMEINFO_KEYIDLE_TICK			(WK7_SEC_TO_TICK(30))
//#define	WK7GAMEINFO_KEYIDLE_TICK			(WK7_SEC_TO_TICK(5))

#include "..\Sato\SK7SaveData.h"
WK7GameInfo			GameInfo;
#ifdef	_DEBUG
SK7SaveData			tempSaveData;
#endif

#ifdef	_DEBUG
static void InitVarPointer(void);
static void SetVarPointer(void *pPtr);
#define	INITVARPOINTER()		InitVarPointer()
#define	SETVARPOINTER(ptr)		SetVarPointer(ptr)
#else
#define	INITVARPOINTER()		
#define	SETVARPOINTER(ptr)		
#endif

// O[oϐ֐`
#undef	__K7GLOBALVAR_DECL__
#define	__K7GLOBALVAR_INIT__
#include "K7GlobalFlag.h"
#undef	__K7GLOBALVAR_INIT__

#ifdef	_DEBUG

static	int	varPointerCounter;
static void InitVarPointer(void)
{
	varPointerCounter = 0;
}

static void SetVarPointer(void *pPtr)
{
	GlobalVarType[varPointerCounter].mpVar = pPtr;
	varPointerCounter++;
}

// O[oϐfobOpe[u
#undef	__K7GLOBALVAR_DECL__
#define	__K7GLOBALVAR_DEBUG__
#include "K7GlobalFlag.h"
#undef	__K7GLOBALVAR_DEBUG__

#endif

WK7GameInfo::WK7GameInfo()
{
	
#ifdef	_DEBUG
#define	SAVEDATA_SECTOR_NUM		(2)
	OSReport("SaveData Size = %d\n",sizeof(SK7SaveData));
	if( GHM_ROUNDUP_QUOT(sizeof(SK7SaveData),SECTOR_SIZE) > SAVEDATA_SECTOR_NUM ){
		OSHalt("Warning : SaveData Size Over !!!!!!!!!!!!!!!!!!!!\n");
	}
//	OSReport("SaveData Size = %d\n",(u32)&(((SK7SaveData *)NULL)->SaveData) + sizeof(SK7SaveGameData));
//	if( sizeof(SK7SaveData) > SAVE_ALL_SIZE ){
//		OSHalt("Error : SaveData Size Over !!!!!!!!!!!!!!!!!!!!\n");
//	}
#endif
	
	mMode                  = INIT;
	mPrevMode              = INIT;
	mNewGame               = false;
	mContinue              = false;
	mCharaID               = 0xffffffff;
	mCurrentStageID        = 0xffffffff;
	mCurrentStagePathParam = 0.0f;
	mCurrentStagePathDir   = 0;
	mpCurrentStagePathName = NULL;
	mScenarioID            = K7SCN_UNKNOWN;
	mScenarioFlow          = K7SCNF_UNKNOWN;
	mAreaID                = K7AREA_UNKNOWN;
	mClearScenarioID       = -1;
	mClearScenarioID2      = -1;
//	InitGlobal();
//	InitScenario();
	mpTaskController       = NULL;
	mTaskID                = -1;
	mPrevTaskID            = -1;
//	mpItem                 = NULL;
	mpHatoMemo             = NULL;
	mpMemo                 = NULL;
	mpPanel                = NULL;
	mPanelResult           = -1;
	mPanelFlag             = 0;
	mPanelTermHideWait     = 1;
	mRequestPanelID        = ePanelIDMax;
	mRequestPanelEventNo   = 0xffffffff;
	mRequestPanelParam     = -1;
	mPanelModeState        = PMSTATE_STANDBY;
	mpMemoLocator          = NULL;
	mMemoPosition.x        = 0.0f;
	mMemoPosition.y        = 0.0f;
	mMemoPosition.z        = 0.0f;
	mMemoRotY              = WK7GAMEINFO_MEMO_ROTY_NOUSE;
	mTermState             = TERMSTATE_SUSPEND;
#ifdef	_DEBUG
	mMoonSkip              = false;
	mppFlagName            = NULL;
#endif
	mItemEnable            = true;
	mHanaFlagNum           = 0;
	mHanaFlagWorkSize      = 0;
	mpHanaFlagWork         = NULL;
	mpZan                  = NULL;
	mZanID                 = 0xffffffff;
	mZanCamID              = 0xffffffff;
	mZanPos.x              = 0.0f;
	mZanPos.y              = 0.0f;
	mZanPos.z              = 0.0f;
	mpSpecial              = NULL;
	mSpecialEnable         = true;
	mSpecialResult         = -1;
	mBossFlag              = false;
	mpSpOption             = NULL;
	mRenderSpOption        = false;
	mRenderOptionDisable   = false;
	mKeyIdle               = false;
	mpScenarioSSM          = NULL;
#ifdef	_DEBUG
	mpVarType              = NULL;
#endif
	mpScenarioVar          = NULL;
	mScenarioVarSize       = 0;
	mpSaveLoad             = NULL;
	mSaveModeState         = SMSTATE_STANDBY;
	mpMenuMap              = NULL;
	mMenuMapModeState      = MMMSTATE_STANDBY;
	mMenuMapEnable         = true;
	mMenuMapSubNo          = 0;
	mZanState              = ZANSTATE_STANDBY;
	mZanMesID              = 0xffffffff;
	mZanParam              = 0xffffffff;
	mZanCharaID            = 0xffffffff;
	mZanCharaPresentTick   = 0xffffffff;
	mZanCharaPresentNameID = 0;
	mZanCharaPresentNameX  = 0;
	mZanCharaPresentNameY  = 0;
	mZanCharaPresentWinX   = 0.0f;
	mZanCharaPresentWinY   = 0.0f;
	mZanCharaPresentWinW   = 0.0f;
	mZanCharaPresentWinH   = 0.0f;
	mZanCharaPresentFlag   = -1;
	mDefaultFootSE         = WK7PATH_FOOTSE_WOOD;
	KeyIdleCountStart();
}

WK7GameInfo::~WK7GameInfo()
{
	if( mpTaskController!=NULL ){
		if( mTaskID >= 0 ){
			mpTaskController->Stop(mTaskID);
		}
		if( mPrevTaskID >= 0 ){
			mpTaskController->Stop(mPrevTaskID);
		}
	}
	GHM_SAFE_DELETE(mpMemo    );
	GHM_SAFE_DELETE(mpHatoMemo);
//	GHM_SAFE_DELETE(mpItem    );
	GHM_SAFE_DELETE(mpPanel   );
	GHM_SAFE_DELETE(mpZan     );
	GHM_SAFE_DELETE(mpSpecial );
	GHM_SAFE_DELETE(mpSpOption);
	GHM_SAFE_DELETE(mpSaveLoad);
}

void WK7GameInfo::KeyIdleCountStart(void)
{
	mKeyIdleControl.SetValue(1.0f);
	mKeyIdleControl.Play    (0.0f,WK7GAMEINFO_KEYIDLE_TICK);
}

bool WK7GameInfo::SetAreaID(K7Area id)
{
	if( id==K7AREA_UNKNOWN ){
		mAreaID = id;
		return true;
	}
	mAreaID = id;
	return true;
}

bool WK7GameInfo::SetScenarioFlow(K7ScenarioFlow id)
{
	if( id==K7SCNF_UNKNOWN ){
		mScenarioFlow = id;
		return true;
	}
	switch( mScenarioID ){
	case	K7SCN01:
		switch( id ){
		case	K7SCNF_FUK:
		case	K7SCNF_KAK:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN02:
		switch( id ){
		case	K7SCNF_TXS:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN03:
		switch( id ){
		case	K7SCNF_ISZ:
		case	K7SCNF_CUR:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN04:
		switch( id ){
		case	K7SCNF_DM1:
		case	K7SCNF_DM2:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN05:
		switch( id ){
		case	K7SCNF_HT2:
		case	K7SCNF_SCL:
//#ifdef	_DEBUG
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051101);				//zePeE
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051201);				//zeQegȓ
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051301);				//zeRedR[hؒf
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051401);				//zeSeN[[bgj
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051501);				//zeTeXC̉
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051601);				//zeUeR[eJ
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_EV_051701);				//zeVeo
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_BAN_HTL);				//zeyԁzԐl̕ʉ߂ł
			K7SCR_SET_SCENARIO_FLAG(K7SCN05_KIHAN);					//zeLnI
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051101),true);			//zePe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051201),true);			//zeQe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051301),true);			//zeRe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051401),true);			//zeSe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051501),true);			//zeTe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051601),true);			//zeUe
			K7SCR_EVSETITEM(K7EVITEM_TAMA(051701),true);			//zeVe
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051601),true);			//zeUe
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051101),true);			//zePeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051102),true);			//zeQeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051103),true);			//zeReLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051104),true);			//zeSeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051105),true);			//zeTeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051106),true);			//zeUeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051107),true);			//zeVeLJU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051111),true);			//zeUegBX
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051121),true);			//zePeCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051122),true);			//zeQeCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051123),true);			//zeReCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051124),true);			//zeSeCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051125),true);			//zeUeCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051126),true);			//zeVeCU
			K7SCR_EVSETITEM(K7EVITEM_ZAN (051131),true);			//zeTe~Y
			WK7Play::SetPlayed(K7EVENTPLAY(05010101),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05020101),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05020201),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05020302),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05030101),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05040101),true);
			WK7Play::SetPlayed(K7EVENTPLAY(05040201),true);
//#endif
		case	K7SCNF_HT1:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN06:
		switch( id ){
		case	K7SCNF_GNK:
			break;
		default:
			return false;
		}
		break;
	case	K7SCN07:
		switch( id ){
		case	K7SCNF_CEL:
			break;
		default:
			return false;
		}
		break;
	default:
		return false;
	}
	mScenarioFlow = id;
	
//#ifdef	_DEBUG
	BattleCtrl.InitScenarioFlow();					// ViItH[Ə
	WK7PLAYERCONTROL->ScenarioFlowReset();			// ViItH[Ə
	
	// ̎w
	if( mScenarioID > K7SCN07 ){
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_RING_FIRE);
	}
	// ̎w
	if( mScenarioID > K7SCN01 || (mScenarioID==K7SCN01 && mScenarioFlow==K7SCNF_KAK) ){
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_RING_WATER);
	}
	// ̎w
	if( mScenarioID > K7SCN01 ){
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_RING_WIND);
	}
	// ߋ̎w
	if( mScenarioID > K7SCN03 || (mScenarioID==K7SCN03 && mScenarioFlow==K7SCNF_CUR) ){
		K7SCR_SET_GLOBAL_FLAG(K7GLFL_RING_PAST);
	}
	// 痢
	if( mScenarioID > K7SCN05 || (mScenarioID==K7SCN05 && mScenarioFlow==K7SCNF_HT2) ){
		K7SCR_RESET_GLOBAL_FLAG(K7GLFL_RING_EYE);
	}
	// KVAp[Abv
	if( mScenarioID > K7SCN05 || (mScenarioID==K7SCN05 && mScenarioFlow==K7SCNF_HT2) ){
		BattleCtrl.GalPowerUp();
	}
	// _p[Abv
	if( mScenarioID > K7SCN03 || (mScenarioID==K7SCN03 && mScenarioFlow==K7SCNF_CUR) ){
		BattleCtrl.DanPowerUp();
	}
	// }XNp[Abv
	switch( mScenarioID ){
	case	K7SCN03:
		if( mScenarioFlow==K7SCNF_CUR ){
			BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_TEXAS);
		}
		break;
	case	K7SCN04:
		BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_TEXAS);
		break;
	case	K7SCN05:
		BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_FINAL);
		break;
	case	K7SCN06:
		switch( BattleCtrl.GetMskPowerUp() ){
		case	KK7BATTLECTRL_MSKLV_NORMAL:
		case	KK7BATTLECTRL_MSKLV_TEXAS:
			BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_FINAL);
			break;
		default:
			break;
		}
//		BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_TEKKAMEN);
		break;
	case	K7SCN07:
	case	K7SCN01:
	case	K7SCN02:
	default:
		BattleCtrl.MskPowerUp(KK7BATTLECTRL_MSKLV_NORMAL);
		break;
	}
//#endif
	return true;
}

bool WK7GameInfo::SetScenarioVarWork(void)
{
	int		size;
	switch( mScenarioID ){
	case	K7SCN01: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN01)); break;
	case	K7SCN02: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN02)); break;
	case	K7SCN03: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN03)); break;
	case	K7SCN04: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN04)); break;
	case	K7SCN05: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN05)); break;
	case	K7SCN06: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN06)); break;
	case	K7SCN07: size=sizeof(K7EV_SCN_VAR_DECL(K7SCN07)); break;
	default:         size=-1;                                 break;
	}
	GHMGCMEM_SAFE_FREE(mpScenarioVar);
	if( size <=0 ){
		mScenarioVarSize = 0;
		return true;
	}
	ghmGcMemSetAllocName("GIScnVar");
	if( (mpScenarioVar = K7AppSmallMemAlloc(size))==NULL ){
		mScenarioVarSize = 0;
		return false;
	}
	mScenarioVarSize = size;
	return true;
}

bool WK7GameInfo::SetScenarioID(int id)
{
	if( id==K7SCN_UNKNOWN ){
		mScenarioID = id;
		mDefaultFootSE = WK7PATH_FOOTSE_WOOD;
		return true;
	}
	
	if( id < 0 || id >= K7SCNNUM ){
		return false;
	}
	mScenarioID = id;
	SetScenarioVarWork();
	switch( mScenarioID ){
	case	K7SCN07:
		mDefaultFootSE = WK7PATH_FOOTSE_STONE;
		break;
	case	K7SCN01:
	default:
		mDefaultFootSE = WK7PATH_FOOTSE_WOOD;
		break;
	}
	switch( mScenarioID ){
	case	K7SCN01:
//		WK7SELECTIF->SetBackTexColor(0xffffffff);
//		WK7SELECTIF->SetBackTexColor(0x8000ffff);
//		WK7SELECTIF->SetBackTexColor(0x00ff00ff);
		break;
	case	K7SCN07:
//		WK7SELECTIF->SetBackTexColor(0xff0000ff);
		break;
	default:
//		WK7SELECTIF->SetBackTexColor(0xffc000ff);
		break;
	}
	return true;
}

bool WK7GameInfo::Terminate(void)
{
	ReleaseScenarioSSM();
	if( mpTaskController!=NULL ){
		if( mTaskID >= 0 ){
			mpTaskController->Stop(mTaskID);
			mTaskID  = -1;
		}
		if( mPrevTaskID >= 0 ){
			mpTaskController->Stop(mPrevTaskID);
			mPrevTaskID  = -1;
		}
	}
	GHM_SAFE_DELETE(mpMemo    );
	GHM_SAFE_DELETE(mpHatoMemo);
//	GHM_SAFE_DELETE(mpItem    );
	GHM_SAFE_DELETE(mpPanel   );
	GHM_SAFE_DELETE(mpZan     );
	GHM_SAFE_DELETE(mpSpecial );
	GHM_SAFE_DELETE(mpSpOption);
	GHM_SAFE_DELETE(mpSaveLoad);
	GHM_SAFE_DELETE(mpMenuMap );
	mSpecialEnable    = true;
	mSpecialResult    = -1;
	mBossFlag         = false;
	mSaveModeState    = SMSTATE_STANDBY;
	mMenuMapModeState = MMMSTATE_STANDBY;
	mMenuMapEnable    = true;
	SetCurrentStagePathName(NULL);
	return true;
}

bool WK7GameInfo::InitAfterLoad(void)
{
//	CreateSpOption();
	return true;
}

bool WK7GameInfo::CreateSpOption(void)
{
	if( mpSpOption!=NULL ){
		return true;
	}
	ghmGcMemSetAllocName("SKSPOPT");
	mpSpOption = new SK7SpOption;
	mpSpOption->SetRender(true);
	mpSpOption->SetControl(true);
	SetRenderOption(false);
	return true;
}

bool WK7GameInfo::ReleaseSpOption(void)
{
	GHM_SAFE_DELETE(mpSpOption);
	return true;
}

bool WK7GameInfo::InitGlobal(void)
{
#ifdef	_DEBUG
	if( sizeof(WK7GameVarGlobal) > WK7GAMEINFO_GLOVAL_VAR_SIZE ){
		OSReport("GlobalVar Size Over : %d(%d)\n",sizeof(WK7GameVarGlobal),WK7GAMEINFO_GLOVAL_VAR_SIZE);
	}
#endif
	
	WK7GameVarGlobal	*pGlobalVar;
	
#ifdef	_DEBUG
	tempSaveData.SaveData.mStartScenarioID = K7SCN_UNKNOWN;
#endif
	memset(mGlobalVar   ,0,sizeof(mGlobalVar ));
	memset(mGlobalFlag  ,0,sizeof(mGlobalFlag));
	
	INITVARPOINTER();
	pGlobalVar = (WK7GameVarGlobal *)&mGlobalVar;
	pGlobalVar->Initialize();
	
	WK7StageHanaInfo	*pHanaInfo;
	for(pHanaInfo=stageHanaInfo ; pHanaInfo->mID!=0xffffffff ; pHanaInfo++){
		mHanaFlagNum++;
	}
	
	SetGlobalFlag( K7GLFL_RING_EYE );	//	痢̎wցij
	SetGlobalFlag( K7GLFL_OPT_VIB );	//	oCu[Vݒ

	
//	if( (mHanaFlagWorkSize = GHM_ROUNDUP_QUOT(mHanaFlagNum,32)) > 0 ){
//		mpHanaFlagWork = (u32 *)ghmGcMemAlloc((int)(sizeof(u32) * mHanaFlagWorkSize));
//	}
	
	return true;
}

bool WK7GameInfo::SetCurrentStagePathName(const char *pName)
{
	GHM_SAFE_DELETE_ARRAY(mpCurrentStagePathName);
	if( pName==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("CSTPATH");
	if( (mpCurrentStagePathName=new char[strlen(pName)+1])==NULL ){
		return false;
	}
	strcpy(mpCurrentStagePathName,pName);
	return true;
}

#ifdef	_DEBUG
#define	WK7GAMEINFO_SCN_VAR_CHECK(decl,scn) { \
		int		size; \
		if( (size=sizeof(decl)) > WK7GAMEINFO_SCENARIO_VAR_SIZE ){ \
			OSReport("Scn Var Size Over : scn=%d,size=%d(<=%d)\n",scn,size,WK7GAMEINFO_SCENARIO_VAR_SIZE); \
		} \
	}
#else
#define	WK7GAMEINFO_SCN_VAR_CHECK(decl,scn)
#endif

bool WK7GameInfo::StoreSaveData(SK7SaveData *pSaveData)
{
	int		i,j;
	
	if( pSaveData==NULL ){
		return false;
	}
	
	SK7SaveGameData	*pGameData        = &pSaveData->SaveData;
	WK7PathInfo		*pCurrentInfo     = WK7PLAYERPATHCONTROL->GetCurrentPathInfo();
	WK7PathNurbs	*pCurrentPath     = pCurrentInfo->GetPath();
	const char		*pCurrentPathName;
	u32				*pPlayedFlag      = WK7Play::GetPlaydFlagTop();
	u32				*pHarmanRoomFlag  = WK7Stage::GetHarmanRoomFlagTop();
	u32				*pHarmanTvFlag    = WK7Stage::GetHarmanTvFlagTop();
	u32				*pPassPathFlag    = WK7Stage::GetPassPathFlagTop();
	u32				*pSelectObjFlag   = WK7Stage::GetSelectObjFlagTop();
	u32				*pMapFlag         = WK7Stage::GetMapFlagTop();
	
	if( pCurrentPath!=NULL ){
		if( (pCurrentPathName = pCurrentPath->GetShortName())==NULL ){
			pCurrentPathName = pCurrentPath->GetName();
		}
	}else{
		pCurrentPathName = NULL;
	}
	
	// tONA
	pGameData->mFlag                  = 0;
	
	// JgViI
	pGameData->mStartScenarioID       = mScenarioID;
	
	// NAViI
	pGameData->mClearScenarioID       = mClearScenarioID;
	pGameData->mClearScenarioID2      = mClearScenarioID2;
	
	
	pGameData->mScenarioFlow          = mScenarioFlow;
	pGameData->mAreaID                = mAreaID;
	
	// LN^ԍ
	pGameData->mCharaID               = WK7PLAYERCONTROL->GetID();
	
	// JgXe[W
	pGameData->mCurrentStageID        = WK7Stage::GetCurrentStageID();
	pGameData->mCurrentStagePathParam = pCurrentInfo->GetParam();
	pGameData->mCurrentStagePathDir   = pCurrentInfo->GetDir  ();
	pGameData->mCurrentStageParam     = WK7Stage::GetCurrentStageParam();
	if( pCurrentPathName!=NULL ){
		strncpy(pGameData->mCurrentStagePathName,pCurrentPathName,sizeof(pGameData->mCurrentStagePathName)-1);
#ifdef	_DEBUG
		if( strlen(pCurrentPathName) >= sizeof(pGameData->mCurrentStagePathName) ){
			OSReport("Save CurrentPathName Over : %s\n",pCurrentPathName);
		}
#endif
	}else{
		memset(pGameData->mCurrentStagePathName,0,sizeof(pGameData->mCurrentStagePathName));
	}
	
	// ÕXe[W
	PCCHKPPOINT		*pCheckPoint = WK7PLAYERCONTROL->GetChkPointPtr();
	pGameData->mPrevStageID = pCheckPoint->prevStgID;
	pGameData->mPrevStageBpName = 0;
	if( pCheckPoint->GetPrevBpName() != NULL ){
	 	strncpy(pGameData->mPrevStagePathName,pCheckPoint->GetPrevBpName(),sizeof(pGameData->mPrevStagePathName)-1);
	}
	pGameData->mPrevStageParam = pCheckPoint->prevParam;
	
	// tO֘A
	
	// O[o
	memcpy(pGameData->mGlobalFlag,mGlobalFlag,WK7GAMEINFO_GLOBAL_FLAG_SIZE );
	memcpy(pGameData->mGlobalVar ,mGlobalVar ,WK7GAMEINFO_GLOVAL_VAR_SIZE  );
	
	// eViI
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN07),K7SCN07);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN01),K7SCN01);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN02),K7SCN02);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN03),K7SCN03);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN04),K7SCN04);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN05),K7SCN05);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN06),K7SCN06);
	memcpy(pGameData->mScenarioFlag,mScenarioFlag             ,WK7GAMEINFO_SCENARIO_FLAG_SIZE);
	memcpy(pGameData->mItemFlag    ,WK7EventItem::GetFlagTop(),WK7EVENTITEM_SIZE             );
	if( mpScenarioVar != NULL && mScenarioVarSize > 0 ){
		memcpy(pGameData->mScenarioVar,mpScenarioVar,WK7GAMEINFO_SCENARIO_VAR_SIZE);
	}else{
		memset(pGameData->mScenarioVar,            0,WK7GAMEINFO_SCENARIO_VAR_SIZE);
	}
	
	memcpy(pGameData->mPlayedFlag     ,pPlayedFlag               ,WK7PLAYTBL_SIZE              );
	
	memcpy(pGameData->mHarmanRoomFlag ,pHarmanRoomFlag           ,WK7STAGE_HARMANROOM_FLAG_SIZE);
	memcpy(pGameData->mHarmanTvFlag   ,pHarmanTvFlag             ,WK7STAGE_HARMANTV_FLAG_SIZE  );
	memcpy(pGameData->mPassPathFlag   ,pPassPathFlag             ,WK7STAGE_PASSPATH_FLAG_SIZE  );
	memcpy(pGameData->mSelectObjFlag  ,pSelectObjFlag            ,WK7STAGE_SELECTOBJ_FLAG_SIZE );
	memcpy(pGameData->mMapFlag        ,pMapFlag                  ,WK7STAGE_MAP_FLAG_SIZE       );
	
	// ogn
	for(i=0; i<(1+ENENO_MAX); i++){
		pGameData->mNpcDieInfo[i] = WK7Npc::MemCard_GetDieInfo(i);
	}
	
	BattleCtrl.pGetPcInfo()->GetPcInfo(&pGameData->mDieInfoBit, &pGameData->mCollectInfoBit, &pGameData->mReCallInfoBit, &pGameData->mSelOKInfoBit);
	
	for(i=0; i<K7PCMAX; i++){
		s16 getHp;
		WK7PLAYERCONTROL->GetDataHp((u32 )i, &getHp, NULL);
		pGameData->mPcHp[i] = getHp;
	}
	
	for(i=0; i<BP_MAX; i++){
		pGameData->mBpGauge[i] = BattleCtrl.GetBpGauge(i);
	}
	
	{
		PCSKILLALL *pSkillTop = pWK7Skill->pGetSkillAll();
		memcpy(&pGameData->mSkillAll, pSkillTop, sizeof(PCSKILLALL));
	}
	
	pGameData->mTotalEnemyHunt		= BattleCtrl.GetTotalEnemyHunt();
	pGameData->mTotalReCallNum		= BattleCtrl.GetTotalReCallNum();
	
	pGameData->mGalPowerUp			= BattleCtrl.GetGalPowerUp();
	pGameData->mDanPowerUp			= BattleCtrl.GetDanPowerUp();
	pGameData->mMskPowerUp			= BattleCtrl.GetMskPowerUp();
	pGameData->mComboCount			= BattleCtrl.GetComboCount();
	pGameData->mCreateSerumVolume	= BattleCtrl.GetCreateSerumVolume();
	pGameData->mUsedEnemyCount		= BattleCtrl.GetTvEnemyCount();
	
	pGameData->mThickBlood			= mpSpOption->GetBloodGauge(BP_THICK);
	pGameData->mThinBlood			= mpSpOption->GetBloodGauge(BP_THIN);
	pGameData->mSerumBlood			= mpSpOption->GetBloodGauge(BP_SERUM);
	pGameData->mBulletNum			= mpSpOption->GetBalletNum();
	
	for(i=0,j=0 ; i<K7PCMAX && j<9 ; i++){
		switch( i ){
		case	K7DAN:
		case	K7CAT:
		case	K7MSK:
		case	K7KED:
		case	K7KVN:
		case	K7CYO:
		case	K7GAL:
		case	K7HAC:
		case	K7HAY:
			break;
		default:
			continue;
		}
		BattleCtrl.mDeadPlayer[i].StoreSaveData(pGameData->mDeadPlayer + j);
		j++;
	}
	
	return true;
}

bool WK7GameInfo::RestoreSaveData(SK7SaveData *pSaveData)
{
	int		i,j;

	if( pSaveData==NULL ){
		return false;
	}
	
	SK7SaveGameData	*pGameData        = &pSaveData->SaveData;
	u32				*pPlayedFlag      = WK7Play::GetPlaydFlagTop();
	u32				*pHarmanRoomFlag  = WK7Stage::GetHarmanRoomFlagTop();
	u32				*pHarmanTvFlag    = WK7Stage::GetHarmanTvFlagTop();
	u32				*pPassPathFlag    = WK7Stage::GetPassPathFlagTop();
	u32				*pSelectObjFlag   = WK7Stage::GetSelectObjFlagTop();
	u32				*pMapFlag         = WK7Stage::GetMapFlagTop();
	
	// JgViI
	SetScenarioID(pGameData->mStartScenarioID);
	
	// NAViI
	mClearScenarioID       = pGameData->mClearScenarioID;
	mClearScenarioID2      = pGameData->mClearScenarioID2;
	
	mScenarioFlow          = pGameData->mScenarioFlow;
	mAreaID                = pGameData->mAreaID;
	
	// LN^ԍ
	mCharaID               = pGameData->mCharaID;
	
	// JgXe[W
	mCurrentStageID        = pGameData->mCurrentStageID;
	mCurrentStagePathParam = pGameData->mCurrentStagePathParam;
	mCurrentStagePathDir   = pGameData->mCurrentStagePathDir;
	WK7Stage::SetCurrentStageParam(pGameData->mCurrentStageParam);
	SetCurrentStagePathName(pGameData->mCurrentStagePathName);
	
	// ÕXe[W
	PCCHKPPOINT		*pCheckPoint = WK7PLAYERCONTROL->GetChkPointPtr();
	WK7Stage::SetPrevStageID       (pGameData->mPrevStageID);
	WK7Stage::SetPrevStagePathName (NULL);
	WK7Stage::SetPrevStageBpName   (pGameData->mPrevStagePathName);
	WK7Stage::SetCurrentStageBpName(NULL);
	WK7Stage::SetCurrentStageParam (pGameData->mPrevStageParam);
	pCheckPoint->stgID     = pGameData->mCurrentStageID;
	pCheckPoint->pathParam = pGameData->mCurrentStagePathParam;
	pCheckPoint->pathDir   = pGameData->mCurrentStagePathDir;
	pCheckPoint->SetPathName(pGameData->mCurrentStagePathName);
	pCheckPoint->prevStgID = pGameData->mPrevStageID;
	pCheckPoint->SetPrevBpName(pGameData->mPrevStagePathName);
	pCheckPoint->prevParam = pGameData->mPrevStageParam;
	
	// tO֘A
	
	// O[o
	memcpy(mGlobalFlag,pGameData->mGlobalFlag,WK7GAMEINFO_GLOBAL_FLAG_SIZE );
	memcpy(mGlobalVar ,pGameData->mGlobalVar ,WK7GAMEINFO_GLOVAL_VAR_SIZE  );
	
	// eViI
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN07),K7SCN07);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN01),K7SCN01);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN02),K7SCN02);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN03),K7SCN03);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN04),K7SCN04);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN05),K7SCN05);
	WK7GAMEINFO_SCN_VAR_CHECK(K7EV_SCN_VAR_DECL(K7SCN06),K7SCN06);
	memcpy(mScenarioFlag               ,pGameData->mScenarioFlag,WK7GAMEINFO_SCENARIO_FLAG_SIZE);
	memcpy(WK7EventItem::GetFlagTop()  ,pGameData->mItemFlag    ,WK7EVENTITEM_SIZE             );
	if( mpScenarioVar != NULL && mScenarioVarSize > 0 ){
		memcpy(mpScenarioVar,pGameData->mScenarioVar,(u32)mScenarioVarSize);
	}
	
	memcpy(pPlayedFlag               ,pGameData->mPlayedFlag     ,WK7PLAYTBL_SIZE              );
	
	memcpy(pHarmanRoomFlag           ,pGameData->mHarmanRoomFlag ,WK7STAGE_HARMANROOM_FLAG_SIZE);
	memcpy(pHarmanTvFlag             ,pGameData->mHarmanTvFlag   ,WK7STAGE_HARMANTV_FLAG_SIZE  );
	memcpy(pPassPathFlag             ,pGameData->mPassPathFlag   ,WK7STAGE_PASSPATH_FLAG_SIZE  );
	memcpy(pSelectObjFlag            ,pGameData->mSelectObjFlag  ,WK7STAGE_SELECTOBJ_FLAG_SIZE );
	memcpy(pMapFlag                  ,pGameData->mMapFlag        ,WK7STAGE_MAP_FLAG_SIZE       );
	
	// ogn
	for(i=0; i<(1+ENENO_MAX); i++){
		WK7Npc::MemCard_SetDieInfo(i, pGameData->mNpcDieInfo[i]);
	}
	
	BattleCtrl.pGetPcInfo()->SetPcInfo(pGameData->mDieInfoBit, pGameData->mCollectInfoBit, pGameData->mReCallInfoBit, pGameData->mSelOKInfoBit);
	
	for(i=0; i<K7PCMAX; i++){
		WK7PLAYERCONTROL->SetDataHp((u32 )i, pGameData->mPcHp[i]);
		WK7PLAYERCONTROL->SetHp(pGameData->mPcHp[i]);
	}
	
	for(i=0; i<BP_MAX; i++){
		BattleCtrl.SetBpGauge(i, pGameData->mBpGauge[i]);
	}
	
	{
		PCSKILLALL *pSkillTop = pWK7Skill->pGetSkillAll();
		memcpy(pSkillTop, &pGameData->mSkillAll , sizeof(PCSKILLALL));
	}
	
	BattleCtrl.SetTotalEnemyHunt(pGameData->mTotalEnemyHunt);
	BattleCtrl.SetTotalReCallNum(pGameData->mTotalReCallNum);
	BattleCtrl.SetComboCount(pGameData->mComboCount);
	BattleCtrl.SetCreateSerumVolume(pGameData->mCreateSerumVolume);
	BattleCtrl.SetTvEnemyCount(pGameData->mUsedEnemyCount);
	
	BattleCtrl.GalPowerUp(pGameData->mGalPowerUp);
	BattleCtrl.DanPowerUp(pGameData->mDanPowerUp);
	BattleCtrl.MskPowerUp(pGameData->mMskPowerUp);
	
	K7EVENT_GL_VAR(SpBloodThick) 	= pGameData->mThickBlood;
	K7EVENT_GL_VAR(SpBloodThin) 	= pGameData->mThinBlood;
	K7EVENT_GL_VAR(SpBloodSerum) 	= pGameData->mSerumBlood;
	K7EVENT_GL_VAR(SpBullet) 		= pGameData->mBulletNum;
		
	BattleCtrl.DeadPlayerInit();
	
	for(i=0,j=0 ; i<K7PCMAX && j<9 ; i++){
		switch( i ){
		case	K7DAN:
		case	K7CAT:
		case	K7MSK:
		case	K7KED:
		case	K7KVN:
		case	K7CYO:
		case	K7GAL:
		case	K7HAC:
		case	K7HAY:
			break;
		default:
			continue;
		}
		BattleCtrl.mDeadPlayer[i].RestoreSaveData(pGameData->mDeadPlayer + j);
		j++;
	}
	
	return true;
}

bool WK7GameInfo::ReadScenarioSSM(void)
{
	switch( mScenarioID ){
	case	K7SCN07: mpScenarioSSM = "seScenario0.ssm"; break;
	case	K7SCN01: mpScenarioSSM = "seScenario1.ssm"; break;
	case	K7SCN02: mpScenarioSSM = "seScenario2.ssm"; break;
	case	K7SCN03: mpScenarioSSM = "seScenario3.ssm"; break;
	case	K7SCN04: mpScenarioSSM = "seScenario4.ssm"; break;
	case	K7SCN05: mpScenarioSSM = "seScenario5.ssm"; break;
	case	K7SCN06: mpScenarioSSM = "seScenario6.ssm"; break;
	default:         mpScenarioSSM = NULL;              break;
	}
	if( mpScenarioSSM != NULL ){
		gpSound->mReadSsm((char*)mpScenarioSSM,eBankScenario);
	}
	return true;
}

bool WK7GameInfo::ReleaseScenarioSSM(void)
{
	if( mpScenarioSSM != NULL ){
		gpSound->mReleaseSsm((char*)mpScenarioSSM);
		mpScenarioSSM  = NULL;
	}
	return true;
}

bool WK7GameInfo::InitScenario(void)
{
//	if( mContinue==false ){
//#define	K7EV_VAR_INIT
//		switch( mScenarioID ){
////		case	K7SCN00:
////			#include "..\Scn\K7Scn00.h"
////			break;
//		case	K7SCN01:
//			#include "..\Scn\K7Scn01.h"
//			break;
//		case	K7SCN02:
//			#include "..\Scn\K7Scn02.h"
//			break;
//		case	K7SCN03:
//			#include "..\Scn\K7Scn03.h"
//			break;
//		case	K7SCN04:
//			#include "..\Scn\K7Scn04.h"
//			break;
//		case	K7SCN05:
//			#include "..\Scn\K7Scn05.h"
//			break;
////		case	K7SCN06:
////			#include "..\Scn\K7Scn06.h"
////			break;
//		case	K7SCN07:
//			#include "..\Scn\K7Scn07.h"
//			break;
//		default:
//			break;
//		}
//#undef	K7EV_VAR_INIT
//	}
	
//	if( mContinue==false ){
//		int		i;
//		u32		*pFlagWork;
//		pFlagWork = GetItemFlag(mScenarioID);
//		if( pFlagWork!=NULL ){
//			for(i=0 ; i<WK7EVENTITEM_WORKSIZE ; i++){
//				*pFlagWork++ = 0;
//			}
//		}
//		if( mpHanaFlagWork!=NULL ){
//			WK7StageHanaInfo	*pHanaInfo;
//			u32					uid,lid;
//			uid = 0;
//			lid = 0;
//			for(i=0,pHanaInfo=stageHanaInfo; pHanaInfo->mID!=0xffffffff ; i++,pHanaInfo++){
//				if( pHanaInfo->mScenarioID==mScenarioID ){
//					mpHanaFlagWork[uid] &= ~(1UL<<lid);
//				}
//				lid++;
//				if( lid >= 32 ){
//					lid  = 0;
//					uid++;
//				}
//			}
//		}
//	}
	
	if( GameInfo.GetContinue()==false ){
		switch( GameInfo.GetScenarioID() ){
		case	K7SCN07: GameInfo.SetScenarioFlow(K7SCNF_CEL);     break;
		case	K7SCN01: GameInfo.SetScenarioFlow(K7SCNF_FUK);     break;
		case	K7SCN02: GameInfo.SetScenarioFlow(K7SCNF_TXS);     break;
		case	K7SCN03: GameInfo.SetScenarioFlow(K7SCNF_ISZ);     break;
		case	K7SCN04: GameInfo.SetScenarioFlow(K7SCNF_DM1);     break;
		case	K7SCN05: GameInfo.SetScenarioFlow(K7SCNF_HT1);     break;
		case	K7SCN06: GameInfo.SetScenarioFlow(K7SCNF_GNK);     break;
		default:         GameInfo.SetScenarioFlow(K7SCNF_UNKNOWN); break;
		}
	}
	
	mTermState = TERMSTATE_SUSPEND;
	mItemEnable = true;
	K7SCR_RESET_GLOBAL_FLAG(K7GLFL_SCENARIO_CLEAR);
	
	return true;
}

bool WK7GameInfo::SetTermState(TermState state)
{
	switch( state ){
	case	TERMSTATE_CLEAR:
		switch( mScenarioID ){
		case	K7SCN07:
		case	K7SCN01:
		case	K7SCN02:
		case	K7SCN03:
		case	K7SCN04:
		case	K7SCN05:
		case	K7SCN06:
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )==true ){
				break;
			}
			if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_KILLER1 )==true ){	
				if( mClearScenarioID2 < mScenarioID ){
					mClearScenarioID2 = mScenarioID;
				}
			}else{
				if( mClearScenarioID < mScenarioID ){
					mClearScenarioID = mScenarioID;
				}
			}
			break;
		}
		break;
	case	TERMSTATE_GAMEOVER:
	case	TERMSTATE_GAMEAGAIN:
	case	TERMSTATE_SUSPEND:
		break;
	default:
		return false;
	}
	mTermState = state;
	return true;
}

bool WK7GameInfo::SetMode(Mode mode,bool multi)
{
	if( multi==false && mTaskID >= 0 ){
		return false;
	}
	if( mPrevTaskID >= 0 ){
		return false;
	}
	
	if( mMode==DIE ){
		switch( mode ){
		case	PLAY:
		case	TERM:
		case	INIT:
			break;
		case	MOVE:
		default:
			return false;
		}
	}
	
	mPrevMode   = mMode;
	mPrevTaskID = mTaskID;
	
	if( mMode==TERM ){
		if( mode!=INIT ){
			return false;
		}
		::SetEffectSoundOffFlag(FALSE);
		mMode = mode;
		return true;
	}
	
	KeyIdleCountStart();
	
	switch( mode ){
	case	MOVE:												// ʏړ
		::SetEffectSoundOffFlag(FALSE);
		WK7CAM->DetachMotion();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7SELECTIF->Disappear();
		WK7CAM->SetBranchPointMode(false);
		WK7CAM->SetWobbleEnable(true);
		if( mMode==BATTLE ){
			WK7PLAYERPATHCONTROL->CallPathChagneCallback();
		}
		WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
		WK7PLAYERCONTROL->SetOperateEnable(true);
//		WK7PLAYERCONTROL->VitalVisible(true);
		WK7PLAYERPATHCONTROL->SetActive(true);
		WK7PLAYERCONTROL->SetPathSelectState();
		WK7SELECTIF->SetOperateEnable(true);
		WK7SIGHT->SetVisible(false);
#if 0
		WK7Npc::SetSilhouetteAll(true);
#else
		WK7Npc::SetSilhouetteAll(false);
#endif
//		WK7RenderObj::SetVfxFlag(true);
		WK7SELECTIF->SetVisible(true);
		SetRenderOption(true);
		if( mMode!=BATTLE ){
			InitOptionWindow();
		}
		break;
	case	MOVECAM:											// ʏړiJt[j
		::SetEffectSoundOffFlag(FALSE);
		WK7CAM->DetachMotion();
		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
		WK7CAM->SetWobbleEnable(true);
		WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
		WK7PLAYERCONTROL->SetOperateEnable(true);
//		WK7PLAYERCONTROL->VitalVisible(true);
 		WK7PLAYERPATHCONTROL->SetActive(true);
		WK7PLAYERCONTROL->SetPathSelectState();
		WK7SELECTIF->SetOperateEnable(true);
		WK7SIGHT->SetVisible(false);
#if 0
		WK7Npc::SetSilhouetteAll(true);
#else
		WK7Npc::SetSilhouetteAll(false);
#endif
//		WK7RenderObj::SetVfxFlag(true);
		WK7SELECTIF->SetVisible(false);
		break;
	case	PLAY:												// L
		::SetEffectSoundOffFlag(FALSE);
		if( mpSpOption != NULL ){
			mpSpOption->SetState( SPOPTION_DEMO_CLOSE );
			InitOptionWindow();
		}
//		WK7CAM->DetachMotion();
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetWobbleEnable(false);
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
//		WK7Npc::SetSilhouetteAll(true);
//		WK7RenderObj::SetVfxFlag(false);
		WK7SELECTIF->Disappear();
		SetRenderOption(false);
		break;
	case	DIE:
		::SetEffectSoundOffFlag(FALSE);
		WK7CAM->DetachMotion();
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->SetWobbleEnable(false);
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		break;
	case	BATTLE:												// \̐퓬
		WK7CAM->DetachMotion();
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
//		WK7PLAYERCONTROL->SetOperateEnable(true);
		WK7SIGHT->SetVisible(true);
//		WK7Npc::SetSilhouetteAll(false);
//		WK7RenderObj::SetVfxFlag(true);
//		WK7SELECTIF->Disappear();
		WK7SELECTIF->SetOperateEnable(false);
		WK7SELECTIF->SetVisible(false);
		SetRenderOption(true);
		break;
	case	MOON:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7MOON_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(MoonModeTask,MoonModeTaskTerm,0,0,NULL,-1,K7MOON_PRIO)) < 0 ){
			return false;
		}
//		k7app.SetFadeColor(0xff000000);
//		k7app.FadeStart(0xff,0);
		SetRenderOption(false);
		break;
	case	ITEMMODE:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7ITEM_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(ItemModeTask,ItemModeTaskTerm,0,0,NULL,-1,K7ITEM_PRIO)) < 0 ){
			return false;
		}
//		WK7PLAYERCONTROL->SetEnable(false);
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		K7SCR_ENTER_DEMOPAUSE();
		mPlayerLightEnable = WK7PLAYERCONTROL->GetLightEnable();
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		break;
	case	HATOMEMOMODE:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7HATOMEMO_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(HatoMemoModeTask,HatoMemoModeTaskTerm,0,0,NULL,-1,K7HATOMEMO_PRIO)) < 0 ){
			return false;
		}
		K7SCR_ENTER_DEMOPAUSE();
		WK7CAM->DetachMotion();
//		WK7PLAYERCONTROL->SetEnable(false);
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->//(false);
//		WK7PLAYERCONTROL->SetVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		break;
	case	PANELMODE:
		if( mpTaskController==NULL || mpPanel!=NULL ){
			return false;
		}
		if( mTaskID >= 0 ){
			return false;
		}
#define	K7PANEL_PRIO		(128)
		if( (mTaskID=mpTaskController->Start(PanelModeTask,PanelModeTaskTerm,0,0,NULL,-1,K7PANEL_PRIO)) < 0 ){
			return false;
		}
		K7SCR_ENTER_DEMOPAUSE();
		WK7CAM->DetachMotion();
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		mPanelTermHideWait = 1;
		mPanelReleaseExec  = 0;
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		break;
	case	ZAN:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7ZAN_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(ZanModeTask,ZanModeTaskTerm,0,0,NULL,-1,K7ZAN_PRIO)) < 0 ){
			return false;
		}
		K7SCR_ENTER_DEMOPAUSE();
		WK7CAM->DetachMotion();
		WK7PLAYERCONTROL->SetOperateEnable(false);
//			WK7PLAYERCONTROL->VitalVisible(false);
		WK7PLAYERCONTROL->SetVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		mZanState = ZANSTATE_INIT;
		break;
	case	SPMENU:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7SPMENU_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(SpecialMenuTask,SpecialMenuTaskTerm,0,0,NULL,-1,K7SPMENU_PRIO)) < 0 ){
			return false;
		}
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		K7SCR_ENTER_DEMOPAUSE();
		GameInfo.GetSpOption()->InitOptionWindow();
		SetRenderOption(true);
		break;
	case	SAVE:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7SAVEMODE_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(SaveModeTask,SaveModeTaskTerm,0,0,NULL,-1,K7SAVEMODE_PRIO)) < 0 ){
			return false;
		}
		mSaveModeState = SMSTATE_STANDBY;
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		K7SCR_ENTER_DEMOPAUSE();
		SetRenderOption(false);
		break;
	case	MENUMAP:
		if( mpTaskController==NULL ){
			return false;
		}
#define	K7MENUMAP_PRIO			(128)
		if( (mTaskID=mpTaskController->Start(MenuMapModeTask,MenuMapModeTaskTerm,0,0,NULL,-1,K7MENUMAP_PRIO)) < 0 ){
			return false;
		}
		mMenuMapModeState = MMMSTATE_STANDBY;
		WK7PLAYERCONTROL->SetOperateEnable(false);
//		WK7PLAYERCONTROL->VitalVisible(false);
		WK7SIGHT->SetVisible(false);
		WK7SELECTIF->Disappear();
		K7SCR_ENTER_DEMOPAUSE();
		SetRenderOption(false);
		GameInfo.GetSpOption()->InitOptionWindow();
		break;
	case	TERM:
	case	INIT:
		::SetEffectSoundOffFlag(FALSE);
		SetRenderOption(false);
		break;
	case	MAP:
	default:
		return false;
	}
	mMode = mode;
	return true;
}

bool WK7GameInfo::SetGlobalFlag(int id)
{
	if( id < 0 || id >= WK7GAMEINFO_GLOBAL_FLAG_NUM ){
		return false;
	}
	int			uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	mGlobalFlag[uid] |= (1<<lid);
	return true;
}

bool WK7GameInfo::ResetGlobalFlag(int id)
{
	if( id < 0 || id >= WK7GAMEINFO_GLOBAL_FLAG_NUM ){
		return false;
	}
	int			uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	mGlobalFlag[uid] &= ~(1<<lid);
	return true;
}

int WK7GameInfo::GetGlobalFlag(int id)
{
	if( id < 0 || id >= WK7GAMEINFO_GLOBAL_FLAG_NUM ){
		return -1;
	}
	int			uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	return (mGlobalFlag[uid] & (1<<lid))? 1 : 0;
}

bool WK7GameInfo::ReverseGlobalFlag(int id)
{
	if( id < 0 || id >= WK7GAMEINFO_GLOBAL_FLAG_NUM ){
		return false;
	}
	switch( GetGlobalFlag(id) ){
	case	0:
		SetGlobalFlag(id);
		break;
	case	1:
		ResetGlobalFlag(id);
		break;
	default:
		return false;
	}
	return true;
}

bool WK7GameInfo::ClearGlobalFlag(void)
{
	int					flagid;
	WK7GameVarGlobal	*pGlobalVar;
	
	INITVARPOINTER();
	pGlobalVar = (WK7GameVarGlobal *)&mGlobalVar;
	pGlobalVar->Initialize();
	
	for(flagid=K7GLFL_RING_FIRE ; ResetGlobalFlag(flagid)==true ; flagid++){}
	
//	InitGlobal();
	return true;
}

//u32* WK7GameInfo::GetScenarioFlagWork(int scnid)
//{
//	u32		*pWork;
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	switch( scnid ){
////	case	K7SCN00: pWork=K7EV_SCN_FLAG(K7SCN00); break;
//	case	K7SCN01: pWork=K7EV_SCN_FLAG(K7SCN01); break;
//	case	K7SCN02: pWork=K7EV_SCN_FLAG(K7SCN02); break;
//	case	K7SCN03: pWork=K7EV_SCN_FLAG(K7SCN03); break;
//	case	K7SCN04: pWork=K7EV_SCN_FLAG(K7SCN04); break;
//	case	K7SCN05: pWork=K7EV_SCN_FLAG(K7SCN05); break;
////	case	K7SCN06: pWork=K7EV_SCN_FLAG(K7SCN06); break;
//	case	K7SCN07: pWork=K7EV_SCN_FLAG(K7SCN07); break;
//		break;
//	default:
//		return NULL;
//	}
//	return pWork;
//}

bool WK7GameInfo::SetScenarioFlag(int id)
{
	id  &= K7EV_SCN_FLAG_MASK;
	if( id < 0 || id >= WK7GAMEINFO_SCENARIO_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	mScenarioFlag[uid] |= (1<<lid);
	return true;
}

bool WK7GameInfo::ResetScenarioFlag(int id)
{
	id  &= K7EV_SCN_FLAG_MASK;
	if( id < 0 || id >= WK7GAMEINFO_SCENARIO_FLAG_NUM ){
		return false;
	}
	int		uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	mScenarioFlag[uid] &= ~(1<<lid);
	return true;
}

int WK7GameInfo::GetScenarioFlag(int id)
{
	id  &= K7EV_SCN_FLAG_MASK;
	if( id < 0 || id >= WK7GAMEINFO_SCENARIO_FLAG_NUM ){
		return -1;
	}
	int		uid,lid;
	uid = (id & 0x7fffffe0) >> 5;
	lid =  id & 0x0000001f;
	return (mScenarioFlag[uid] & (1<<lid))? 1 : 0;
}

bool WK7GameInfo::ReverseScenarioFlag(int id)
{
	switch( GetScenarioFlag(id) ){
	case	0:
		SetScenarioFlag(id);
		break;
	case	1:
		ResetScenarioFlag(id);
		break;
	default:
		return false;
	}
	return true;
}

bool WK7GameInfo::ClearScenarioFlag(void)
{
	memset(mScenarioFlag,0,sizeof(mScenarioFlag));
	switch( mScenarioID ){
	case	K7SCN07:
	case	K7SCN01:
	case	K7SCN02:
	case	K7SCN03:
	case	K7SCN04:
	case	K7SCN05:
		SetGlobalFlag(K7GLFL_RING_EYE);		//	痢̎w
		break;
	case	K7SCN06:
		ResetGlobalFlag(K7GLFL_RING_EYE);	//	痢̎w
		break;
	default:
		break;
	}
	return true;
}

bool WK7GameInfo::SetBossFlag(bool flag)
{
	if( mpSpOption==NULL ){
		return false;
	}
	mpSpOption->SetBossFlag(flag);
	mBossFlag = flag;
	return true;
}

//int WK7GameInfo::GetHanaFlagIndex(int scnid,u32 stgid,u32 chrid,u32 seqid)
//{
//	if( mpHanaFlagWork==NULL ){
//		return -1;
//	}
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	if( chrid >= K7PCMAX ){
//		return -1;
//	}
//	WK7StageHanaInfo	*pHanaInfo;
//	int					i;
//	for(i=0,pHanaInfo=stageHanaInfo; pHanaInfo->mID!=0xffffffff ; i++,pHanaInfo++){
//		if( pHanaInfo->mScenarioID!=scnid ){
//			continue;
//		}
//		if( pHanaInfo->mID!=stgid ){
//			continue;
//		}
//		if( K7ITEM_SUFFIX(pHanaInfo->mItemID)!=chrid ){
//			continue;
//		}
//		if( pHanaInfo->mSeqID!=seqid ){
//			continue;
//		}
//		return i;
//	}
//	return -1;
//}
//
//bool WK7GameInfo::SetHanaFlag(u32 hanaid,u32 stgid,int scnid)
//{
//	u32		seqid;
//	u32		chrid;
//	chrid = K7EVENTHANA_CHRID(hanaid);
//	seqid = K7EVENTHANA_SEQID(hanaid);
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	return SetHanaFlag((u32)scnid,stgid,chrid,seqid);
//}
//
//bool WK7GameInfo::SetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid)
//{
//	if( mpHanaFlagWork==NULL ){
//		return false;
//	}
//	int		id = GetHanaFlagIndex((int)scnid,stgid,chrid,seqid);
//	if( id < 0 || id >= mHanaFlagNum ){
//		return false;
//	}
//	u32		uid,lid;
//	uid = (u32)((id & 0x7fffffe0) >> 5);
//	lid = (u32)( id & 0x0000001f      );
//	mpHanaFlagWork[uid] |= (1<<lid);
//	return true;
//}
//
//bool WK7GameInfo::ResetHanaFlag(u32 hanaid,u32 stgid,int scnid)
//{
//	u32		seqid;
//	u32		chrid;
//	chrid = K7EVENTHANA_CHRID(hanaid);
//	seqid = K7EVENTHANA_SEQID(hanaid);
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	return ResetHanaFlag((u32)scnid,stgid,chrid,seqid);
//}
//
//bool WK7GameInfo::ResetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid)
//{
//	if( mpHanaFlagWork==NULL ){
//		return false;
//	}
//	int		id = GetHanaFlagIndex((int)scnid,stgid,chrid,seqid);
//	if( id < 0 || id >= mHanaFlagNum ){
//		return false;
//	}
//	u32		uid,lid;
//	uid = (u32)((id & 0x7fffffe0) >> 5);
//	lid = (u32)( id & 0x0000001f      );
//	mpHanaFlagWork[uid] &= ~(1<<lid);
//	return true;
//}
//
//int WK7GameInfo::GetHanaFlag(u32 hanaid,u32 stgid,int scnid)
//{
//	u32		seqid;
//	u32		chrid;
//	chrid = K7EVENTHANA_CHRID(hanaid);
//	seqid = K7EVENTHANA_SEQID(hanaid);
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	return GetHanaFlag((u32)scnid,stgid,chrid,seqid);
//}
//
//int WK7GameInfo::GetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid)
//{
//	if( mpHanaFlagWork==NULL ){
//		return false;
//	}
//	int		id;
//	id    = GetHanaFlagIndex((int)scnid,stgid,chrid,seqid);
//	if( id < 0 || id >= mHanaFlagNum ){
//		return false;
//	}
//	u32		uid,lid;
//	uid = (u32)((id & 0x7fffffe0) >> 5);
//	lid = (u32)( id & 0x0000001f      );
//	return (mpHanaFlagWork[uid] & (1<<lid))? 1 : 0;
//}
//
//bool WK7GameInfo::ReverseHanaFlag(u32 hanaid,u32 stgid,int scnid)
//{
//	switch( GetHanaFlag(hanaid,stgid,scnid) ){
//	case	0:
//		SetHanaFlag(hanaid,stgid,scnid);
//		break;
//	case	1:
//		ResetHanaFlag(hanaid,stgid,scnid);
//		break;
//	default:
//		return false;
//	}
//	return true;
//}
//
//bool WK7GameInfo::ReverseHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid)
//{
//	switch( GetHanaFlag(scnid,stgid,chrid,seqid) ){
//	case	0:
//		SetHanaFlag(scnid,stgid,chrid,seqid);
//		break;
//	case	1:
//		ResetHanaFlag(scnid,stgid,chrid,seqid);
//		break;
//	default:
//		return false;
//	}
//	return true;
//}

bool WK7GameInfo::SetTaskController(ghmGcTaskController *pTaskController)
{
	if( mpTaskController!=NULL ){
		if( mTaskID >= 0 ){
			mpTaskController->Stop(mTaskID);
			mTaskID  = -1;
		}
		if( mPrevTaskID >= 0 ){
			mpTaskController->Stop(mPrevTaskID);
			mPrevTaskID  = -1;
		}
	}
	mpTaskController = pTaskController;
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// 
////////////////////////////////////////////////////////////////////////////////
void WK7GameInfo::_MoonModeTask(ghmGcTask * /*pTask*/)
{
	ReleaseScenarioSSM();
#ifdef	_DEBUG
	if( mMoonSkip==true ){
		ReadScenarioSSM();
		mMoonSkip = false;
		return;
	}
#endif
	u8		scnid;
	switch( mScenarioID ){
	case	K7SCN07: scnid = 0; break;
	case	K7SCN01: scnid = 1; break;
	case	K7SCN02: scnid = 2; break;
	case	K7SCN03: scnid = 3; break;
	case	K7SCN04: scnid = 4; break;
	case	K7SCN05: scnid = 5; break;
	case	K7SCN06: scnid = 6; break;
		break;
	default:
		return;
	}
	
	ghmGcMemSetAllocName("SKMoon");
	if( (mpMoon = new SK7Moon(scnid))==NULL ){
		return;
	}
	
	WK7RenderObj::SetVisibleAll(false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	
	// ǂݍݏI҂
	while( mpMoon->GetFileReadEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	k7app.FadeStart(0,WK7_TICK_PER_SEC);
	
	mpMoon->SetCtrlFlag(true);
	mpMoon->SetRender  (true);
	
	while( mpMoon->GetMenuEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	k7app.SetFadeColor(0);
	k7app.FadeStart(0xff,WK7_TICK_PER_SEC);
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
//	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue)==false ){
//		GHMGCTASK_RETSYS();
//	}
//	
//	// mCYI҂
//	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
//		GHMGCTASK_RETSYS();
//	}
	
	mpMoon->SetCtrlFlag(false);
	mpMoon->SetRender  (false);
	
	GHM_SAFE_DELETE(mpMoon);
	
	GHMGCTASK_RETSYS();
	ReadScenarioSSM();
	
	WK7RenderObj::SetVisibleAll(true);
	
	k7app.SetFadeColor(0);
	k7app.FadeStart(0x00,WK7_TICK_PER_SEC);
	while( k7app.IsFade()==true ){
		GHMGCTASK_RETSYS();
	}
//	while( gpNoise->mSandRelease()==false ){
//		GHMGCTASK_RETSYS();
//	}
//	
//	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
//		GHMGCTASK_RETSYS();
//	}
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
	
}

void WK7GameInfo::_MoonModeTaskTerm(ghmGcTask * /*pTask*/)
{
	GHM_SAFE_DELETE(mpMoon);
	k7app.SetFadeColor(0);
	k7app.FadeStart(0,0);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
}

void WK7GameInfo::MoonModeTask(ghmGcTask *pTask)
{
	GameInfo._MoonModeTask(pTask);
}

void WK7GameInfo::MoonModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._MoonModeTaskTerm(pTask);
}

////////////////////////////////////////////////////////////////////////////////
// ACe
////////////////////////////////////////////////////////////////////////////////
void WK7GameInfo::_ItemModeTask(ghmGcTask * /*pTask*/)
{
#if 0
	WK7Chara		*pChara;
	WK7Model		*pModel;
	bool			blur = SceneBlur.GetVisible();
	WK7Cam::Mode	cammode = WK7CAM->GetMode();
	bool			vfx  = WK7RenderObj::GetVfxFlag();
	
	WK7CAM->StoreFov ();
	WK7CAM->StoreNear();
	WK7CAM->StoreFar ();
	
	if( (pChara = WK7PLAYERCONTROL->GetCharaPtr())==NULL ||
	    (pModel = pChara->GetModel())==NULL ){
		return;
	}
	
//	WK7PLAYERCONTROL->SetEnable(false);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7SELECTIF->Disappear();
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::ReleaseStageArchive()==false ){
//	while( WK7Stage::ReleaseStageArchive(false)==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsReleasedStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}

	ghmGcMemSetAllocName("SKItem2");
	while( (mpItem = new SK7Item2(pModel,
	                          (u8)WK7PLAYERCONTROL->GetMainID(),
	                          WK7PLAYERCONTROL->GetGunPtr(0),
	                          WK7PLAYERCONTROL->GetGunPtr(1)))==NULL ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	// ǂݍݏI҂
	while( mpItem->CheckLoadState()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	mPlayerLightEnable = WK7PLAYERCONTROL->GetLightEnable();
	WK7PLAYERCONTROL->SetLightEnable(false);
	WK7Light::SetEnableAll(false,K7OBJTYPE_STG);
	WK7SIGHT->SetVisible(false);
	WK7PLAYERCONTROL->SetVisible(false);
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	SceneBlur.SetVisible(false);
	mpItem->SetRender(true);
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7RenderObj::SetVfxFlag(false);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// 싖
	mpItem->SetControl(true);
	
	// I҂
	while( mpItem->CheckExit()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	// ֎~
	mpItem->SetControl(false);
	mpItem->SetRender (false);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	GHMGCTASK_RETSYS();
	GHM_SAFE_DELETE(mpItem);
	while( WK7Stage::RestoreStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	while( WK7Stage::IsRestoredStageArchive()==false ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
	WK7PLAYERCONTROL->SetOperateEnable(false);					// ł͂ob֎~ɂ
//	WK7PLAYERCONTROL->SetEnable(true);
	WK7PLAYERCONTROL->VitalVisible(true);
	WK7PLAYERPATHCONTROL->SetActive(true);
	WK7PLAYERCONTROL->SetPathSelectState();
	WK7PLAYERCONTROL->SetVisible(true);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	SceneBlur.SetVisible(blur);
//	mpItem->SetRender(false);
	WK7CAM->SetMode(cammode);
//	GHM_SAFE_DELETE(mpItem);
	WK7CAM->RestoreFov ();
	WK7CAM->RestoreNear();
	WK7CAM->RestoreFar ();
	WK7Light::SetEnableAll(true,K7OBJTYPE_STG);
	WK7PLAYERCONTROL->SetLightEnable(mPlayerLightEnable);
	WK7RenderObj::SetVfxFlag(vfx);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
															// ő싖ɂȂƂqȂ甲ƃoO@Kawa
	K7SCR_EXIT_DEMOPAUSE();
#endif
}

void WK7GameInfo::_ItemModeTaskTerm(ghmGcTask * /*pTask*/)
{
	WK7PLAYERCONTROL->SetLightEnable(mPlayerLightEnable);
//	GHM_SAFE_DELETE(mpItem);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
	WK7CAM->RestoreFov ();
	WK7CAM->RestoreNear();
	WK7CAM->RestoreFar ();
}

void WK7GameInfo::ItemModeTask(ghmGcTask *pTask)
{
	GameInfo._ItemModeTask(pTask);
}

void WK7GameInfo::ItemModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._ItemModeTaskTerm(pTask);
}

////////////////////////////////////////////////////////////////////////////////
// ng
////////////////////////////////////////////////////////////////////////////////
void WK7GameInfo::_HatoMemoModeTask(ghmGcTask * /*pTask*/)
{
	WK7Chara		*pChara;
	WK7Model		*pModel;
	bool			blur = SceneBlur.GetVisible();
	WK7Cam::Mode	cammode = WK7CAM->GetMode();
	bool			vfx  = WK7RenderObj::GetVfxFlag();
	
	WK7CAM->StoreFov ();
	WK7CAM->StoreNear();
	WK7CAM->StoreFar ();
	
	if( (pChara = WK7PLAYERCONTROL->GetCharaPtr())==NULL ||
	    (pModel = pChara->GetModel())==NULL ){
		return;
	}
	
	ghmGcMemSetAllocName("WK7Memo");
	if( mpMemoLocator!=NULL ){
		if( mMemoRotY==WK7GAMEINFO_MEMO_ROTY_NOUSE ){
			mpMemo = new WK7Memo(mpMemoLocator);
		}else{
			mpMemo = new WK7Memo(mpMemoLocator,mMemoRotY);
		}
	}else{
		mpMemo = new WK7Memo(mMemoPosition,mMemoRotY);
	}
	
	if( mpMemo==NULL ){
		return;
	}
	
	if( WK7Memo::IsLoaded()==false ){
		while( WK7Memo::LoadStart()==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7Memo::IsLoaded()==false ){
			WK7Memo::LoadProcess();
			GHMGCTASK_RETSYS();
		}
	}
	
	WK7SIGHT->SetVisible(false);
//	WK7PLAYERCONTROL->SetVisible(false);
	WK7PLAYERCONTROL->BattlePadRegulationSet(BPADREG_NO_WAIT);
	WK7PLAYERCONTROL->SetOperateEnable(false);
	SceneBlur.SetVisible(false);
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7SELECTIF->Disappear();
	
	K7SCR_TIMEWAIT(4800);
	
	mpMemo->StartLanding();
	while( mpMemo->GetState()!=WK7Memo::STATE_STANDBY ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_TIMEWAIT(4800);
	
	ghmGcMemSetAllocName("SK7IMenu");
	if( (mpHatoMemo = new SK7IMenuHato(mMemoNo & 0xffffff))==NULL ){
		return;
	}
	
	if( gpNoise->mGetSandFrameProc()!=eSandExec ){
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	// ǂݍݏI҂
	while( mpHatoMemo->GetFileReadEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	WK7RenderObj::SetVfxFlag(false);
	
	mpHatoMemo->SetRender(true);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	// 싖
	mpHatoMemo->SetCtrlFlag(true);
	
	// I҂
	while( mpHatoMemo->GetMenuEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	// ֎~
	mpHatoMemo->SetCtrlFlag(false);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	mpHatoMemo->SetRender(false);
	mpMemo->SetVisibleCarrior(false);
	mpMemo->SetCameraSet(true);
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	WK7CAM->RestoreFov ();
	WK7CAM->RestoreNear();
	WK7CAM->RestoreFar ();
	WK7RenderObj::SetVfxFlag(vfx);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_TIMEWAIT(4800);
	
	mpMemo->StartTakeOff();
	while( mpMemo->GetState()!=WK7Memo::STATE_TERM ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_TIMEWAIT(4800);
	
	while( WK7Memo::Terminate()==false ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
//	WK7PLAYERCONTROL->SetEnable(true);
	WK7PLAYERCONTROL->SetOperateEnable(true);
//	WK7PLAYERCONTROL->VitalVisible(true);
	WK7PLAYERPATHCONTROL->SetActive(true);
	WK7PLAYERCONTROL->SetPathSelectState();
//	WK7PLAYERCONTROL->SetVisible(true);
	WK7PLAYERCONTROL->BattlePadRegulationClear();
	SceneBlur.SetVisible(blur);
	WK7CAM->SetMode(cammode);
	K7SCR_EXIT_DEMOPAUSE();
	
}

void WK7GameInfo::_HatoMemoModeTaskTerm(ghmGcTask * /*pTask*/)
{
	GHM_SAFE_DELETE(mpHatoMemo);
	GHM_SAFE_DELETE(mpMemo);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
//	WK7CAM->RestoreFov ();
//	WK7CAM->RestoreNear();
//	WK7CAM->RestoreFar ();
	mpMemoLocator   = NULL;
	mMemoPosition.x = 0.0f;
	mMemoPosition.y = 0.0f;
	mMemoPosition.z = 0.0f;
	mMemoRotY       = WK7GAMEINFO_MEMO_ROTY_NOUSE;
}

void WK7GameInfo::HatoMemoModeTask(ghmGcTask *pTask)
{
	GameInfo._HatoMemoModeTask(pTask);
}

void WK7GameInfo::HatoMemoModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._HatoMemoModeTaskTerm(pTask);
}

////////////////////////////////////////////////////////////////////////////////
// pl
////////////////////////////////////////////////////////////////////////////////
bool WK7GameInfo::SetPanel(SK7PanelBase *pPanel)
{
	if( mMode==PANELMODE ){
		return false;
	}
	mpPanel = pPanel;
	return true;
}

void WK7GameInfo::_PanelModeTask(ghmGcTask * /*pTask*/)
{
	bool			blur = SceneBlur.GetVisible();
	WK7Cam::Mode	cammode = WK7CAM->GetMode();
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
	WK7SELECTIF->Disappear();
	
	mPanelModeState = PMSTATE_INIT_FADEIN;
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	if( !mPanelReleaseCancel ){
		mPanelReleaseExec = 1;
		while( WK7PLAYERCONTROL->ReleaseArchive()==false ){
			GHMGCTASK_RETSYS();
		}
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::RELEASEDARCHIVE ){
			GHMGCTASK_RETSYS();
		}
//		while( WK7Stage::ReleaseStageArchive()==false ){
//			GHMGCTASK_RETSYS();
//		}
//		while( WK7Stage::IsReleasedStageArchive()==false ){
//			GHMGCTASK_RETSYS();
//		}
	}else{
		mPanelReleaseExec = 0;
	}
	
	do{
		if( mRequestPanelID==ePanelIDMax ){
			if( (mpPanel = SK7PanelBase::Create(mRequestPanelEventNo,mRequestPanelParam))==NULL ){
				GHMGCTASK_RETSYS();
			}
		}else{
			if( (mpPanel = SK7PanelBase::Create(mRequestPanelID,mRequestPanelParam))==NULL ){
				GHMGCTASK_RETSYS();
			}
		}
	}while( mpPanel==NULL );
	
	// ǂݍݏI҂
	while( mpPanel->mGetFileReadEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	if( !mPanelNoiseCancel ){
		// mCYI҂
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mPanelModeState = PMSTATE_INIT_FADEWAIT;
	while( mPanelInitHideWait ){
		GHMGCTASK_RETSYS();
	}
	
	if( mPanelReleaseExec ){
		WK7SIGHT->SetVisible(false);
		WK7PLAYERCONTROL->SetVisible(false);
		WK7Chara::SetRenderChara(false);
		WK7Stage::SetRenderStage(false);
		WK7Item::SetRenderItem  (false);
		SceneBlur.SetVisible(false);
	}
	mpPanel->mSetRender(true);
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mSandRelease()==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mPanelModeState = PMSTATE_INIT_FADEOUT;
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mPanelModeState = PMSTATE_EXEC;
	
	// 싖
	mpPanel->mSetCtrlFlag(true);
	
	// II҂ -> pl쒆
	while( mpPanel->mGetSelectEnd()!=true ){
		// Ԍʎ擾
		mPanelResult = mpPanel->mGetResult();
		GHMGCTASK_RETSYS();
	}
	
	mPanelModeState = PMSTATE_TERM_CTRLOFFWAIT;
	
	// ֎~
	mpPanel->mSetCtrlFlag(false);
	
	// ʎ擾
	mPanelResult = mpPanel->mGetResult();
	
	while( mPanelCtrlOffWait ){
		GHMGCTASK_RETSYS();
	}
	
	mPanelModeState = PMSTATE_TERM_FADEIN;
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mpPanel->mSetRender(false);
	
	if( mPanelReleaseExec ){
		while( WK7PLAYERCONTROL->RestoreArchive()==false ){
			GHMGCTASK_RETSYS();
		}
//		while( WK7Stage::RestoreStageArchive()==false ){
//			GHMGCTASK_RETSYS();
//		}
	}
	
	GHMGCTASK_RETSYS();
	
	mPanelModeState = PMSTATE_TERM_DELETEWAIT;
	
	while( mPanelDeleteWait ){
		GHMGCTASK_RETSYS();
	}
	
	GHM_SAFE_DELETE(mpPanel);
	
	if( !mPanelNoiseCancel ){
		// mCYI҂
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
	}
	
	if( mPanelReleaseExec ){
		while( WK7PLAYERCONTROL->GetReleaseState()!=WK7PlayerControl::LOADED ){
			GHMGCTASK_RETSYS();
		}
//		while( WK7Stage::IsRestoredStageArchive()==false ){
//			GHMGCTASK_RETSYS();
//		}
		WK7PLAYERCONTROL->SetVisible(true);
		WK7PLAYERCONTROL->RestorePathPosition();
		WK7Chara::SetRenderChara(true);
		WK7Stage::SetRenderStage(true);
		WK7Item::SetRenderItem  (true);
		SceneBlur.SetVisible(blur);
		WK7CAM->SetMode(cammode);
	}
	
	mPanelModeState = PMSTATE_TERM_FADEWAIT;
	while( mPanelTermHideWait ){
		GHMGCTASK_RETSYS();
	}
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mSandRelease()==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mPanelModeState = PMSTATE_TERM_FADEOUT;
	
	if( !mPanelNoiseCancel ){
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
	}
	
	K7SCR_EXIT_DEMOPAUSE();
	mPanelFlag   = 0;
}

void WK7GameInfo::_PanelModeTaskTerm(ghmGcTask * /*pTask*/)
{
	mPanelModeState = PMSTATE_STANDBY;
	GHM_SAFE_DELETE(mpPanel);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
}

void WK7GameInfo::PanelModeTask(ghmGcTask *pTask)
{
	GameInfo._PanelModeTask(pTask);
}

void WK7GameInfo::PanelModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._PanelModeTaskTerm(pTask);
}

////////////////////////////////////////////////////////////////////////////////
// cvO
////////////////////////////////////////////////////////////////////////////////
bool WK7GameInfo::ReserveZanCharaPresent(u32 tick,int nameID,s16 nameX,s16 nameY,f32 winX,f32 winY,f32 winW,f32 winH,int flag)
{
	mZanCharaPresentTick   = tick;
	mZanCharaPresentNameID = nameID;
	mZanCharaPresentNameX  = nameX;
	mZanCharaPresentNameY  = nameY;
	mZanCharaPresentWinX   = winX;
	mZanCharaPresentWinY   = winY;
	mZanCharaPresentWinW   = winW;
	mZanCharaPresentWinH   = winH;
	mZanCharaPresentFlag   = flag;
	return true;
}
void WK7GameInfo::_ZanModeTask(ghmGcTask * /*pTask*/)
{
	WK7Cam::Mode	cammode = WK7CAM->GetMode();
	
	mZanState = ZANSTATE_INIT;
	
	if( !mZanNoiseCancel ){
		
		mZanState = ZANSTATE_INIT_FADEIN;
		
		while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue)==false ){
			GHMGCTASK_RETSYS();
		}
	}
	
	u32				mesid;
	if( mZanMesID==0xffffffff ){
		if( K7CHR_MAINID(mZanCharaID)==K7ZA7 ){
			// jI
			if( mpSpOption==NULL ){
				mesid = 0;
			}else{
				if( WK7EventItem::HasItem(K7EVITEM_ZANID(mZanID))==true ){
					// ʂԂĂ
					if( WK7EventItem::IsUsedItem(K7EVITEM_ZANID(mZanID))==true ){
						mesid = 2;
					}else{
						u16		blood_point;
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==TRUE ){
							// [h͕KvȌtʂP^PO
							blood_point = BLOOD_POINT / 10;
						}else{
							blood_point = BLOOD_POINT;
						}
						if( mpSpOption->GetBloodGauge(BP_THICK) >= blood_point ){
							mpSpOption->IncBloodGauge(BP_THICK,(short)(-blood_point));
							mesid = 2;
						}else{
							mesid = 3;
//							mesid = 0;
						}
					}
				}else{
					// ʂԂĂȂ
					if( WK7EventItem::IsUsedItem(K7EVITEM_ZANID(mZanID))==true ){
						mesid = 1;
					}else{
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==TRUE ){
							// [h͌tȂ
							mesid = 1;
						}else if( mpSpOption->GetBloodGauge(BP_THIN) >= BLOOD_PACK ){
							mpSpOption->IncBloodGauge(BP_THIN,-BLOOD_PACK);
							mesid = 1;
						}else{
							mesid = 0;
						}
					}
				}
			}
		}else{
			// ȊO
//			if( WK7EventItem::HasItem(K7EVITEM_ZANID(mZanID))==true ){
//				mesid = 1;
//			}else{
				mesid = 0;
//			}
		}
	}else{
		mesid = mZanMesID|0x80000000;
	}
	
	if( !mZanManual ){
		WK7CAM->StoreFov ();
		WK7CAM->StoreNear();
		WK7CAM->StoreFar ();
		WK7SIGHT->SetVisible(false);
		WK7PLAYERCONTROL->SetVisible(false);
		WK7PLAYERCONTROL->SetOperateEnable(false);
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7SELECTIF->Disappear();
	}
	
	ghmGcMemSetAllocName("WK7Zan");
	if( (mpZan = new WK7Zan(mZanID,mZanPos,mZanRot,mesid))==NULL ){
		mZanID = 0xffffffff;
		return;
	}
	mpZan->SetCamID(mZanCamID);
	mpZan->SetParam(mZanParam);
	
	if( mZanCharaLoadCancel ){
		mpZan->CharaLoadCancel();
	}
	
	if( !mZanNoiseCancel ){
		
		mZanState = ZANSTATE_INIT_FADEINWAIT;
		
		while( gpNoise->mGetSandFrameProc()!=eSandExec ){
			GHMGCTASK_RETSYS();
		}
	}
	
	while( mpZan->GetState()!=WK7Zan::STARTWAIT ){
		GHMGCTASK_RETSYS();
	}
	
	mZanState = ZANSTATE_INITWAIT;
	
	while( mZanInitWait ){
		GHMGCTASK_RETSYS();
	}
	
	if( !mZanCinemaScopeCancel ){
		WK7CAM->SetDefaultCinemaScopeColor();
		WK7CAM->SetCinemaScopeMode(true);
	}
	
	if( !mZanNoiseCancel ){
		
		mZanState = ZANSTATE_INIT_FADEOUT;
		
		while( gpNoise->mSandRelease()==false ){
			GHMGCTASK_RETSYS();
		}
		
		mZanState = ZANSTATE_INIT_FADEOUTWAIT;
		
		while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			GHMGCTASK_RETSYS();
		}
	}
	
	mZanState = ZANSTATE_EXECWAIT;
	
	while( mZanExecWait ){
		GHMGCTASK_RETSYS();
	}
	
	mZanState = ZANSTATE_EXEC;
	
	K7SCR_CHARAPRESENT_DEBUGSTART();
	if( !mZanCharaPresentCancel ){
		u32		tick;
		f32		winX,winY,winW,winH;
		s16		nameID;
		s16		nameX,nameY;
		int		flag;
		nameID = (s16)mZanCharaPresentNameID;
		nameX  =      mZanCharaPresentNameX;
		nameY  =      mZanCharaPresentNameY;
		winX   =      mZanCharaPresentWinX;
		winY   =      mZanCharaPresentWinY;
		winW   =      mZanCharaPresentWinW;
		winH   =      mZanCharaPresentWinH;
		flag   =      mZanCharaPresentFlag;
		if( (tick=mZanCharaPresentTick)==0xffffffff ){
			WK7ZanCharaPresentInfo	*pInfo = WK7Zan::Find(mZanID);
			if( pInfo!=NULL ){
				tick   =      pInfo->mTick;
				nameID = (s16)pInfo->mNameID;
				nameX  =      pInfo->mNameX;
				nameY  =      pInfo->mNameY;
				winX   =      pInfo->mWinX;
				winY   =      pInfo->mWinY;
				winW   =      pInfo->mWinW;
				winH   =      pInfo->mWinH;
				flag   =      pInfo->mFlag;
			}
		}
		if( tick!=0xffffffff ){
			WK7Stage	*pStage = WK7Stage::GetCurrentStage();
			if( pStage!=NULL && (flag < 0 || GameInfo.GetGlobalFlag(flag)==false) ){
				//pStage->SetNameData();	// cvO\[Xg悤ɕύX
				WK7CHARAPRESENT->ReserveEnable(tick);
				WK7CHARAPRESENT->AddMaskWindow(winX,winY,winW,winH);
				pStage->ReserveCharaName(tick,nameID,nameX,nameY);
				GameInfo.SetGlobalFlag(flag);
			}
		}
	}
	mpZan->StartRequest();
	while( mpZan->GetState()!=WK7Zan::IDLE ){
		GHMGCTASK_RETSYS();
	}
	K7SCR_CHARAPRESENT_DEBUGEND();
	
	mZanState = ZANSTATE_TERMWAIT;
	
	while( mZanTermWait ){
		GHMGCTASK_RETSYS();
	}
	
	// h~jJJ[`bv
	WK7StageZan	*pZan;
	mesid = 0xffffffff;
	if( mZanCharaID==K7CHRID(K7ZA2,1) ){
		WK7Stage				*pStage = WK7Stage::GetCurrentStage();
		if( pStage!=NULL ){
		//	WK7StageZan				*pZan         = pStage->GetZan(K7EVENTZANID(mZanID));
			pZan = pStage->GetZan(K7EVENTZANID(mZanID));
			WK7StageZanColChipInfo	*pColChipInfo = WK7StageZan::GetZanColChipInfo(K7EVENTZANID(mZanID));
			if( pColChipInfo!=NULL && pZan!=NULL ){
//				u32		mesid;
				switch( pColChipInfo->mColorID ){
				case	K7ZAN_COL_R:   mesid = K7SCR_SYSMES_COLORCHIP_R;   break;
				case	K7ZAN_COL_G:   mesid = K7SCR_SYSMES_COLORCHIP_G;   break;
				case	K7ZAN_COL_RG:  mesid = K7SCR_SYSMES_COLORCHIP_RG;  break;
				case	K7ZAN_COL_B:   mesid = K7SCR_SYSMES_COLORCHIP_B;   break;
				case	K7ZAN_COL_GB:  mesid = K7SCR_SYSMES_COLORCHIP_GB;  break;
				case	K7ZAN_COL_RGB: mesid = K7SCR_SYSMES_COLORCHIP_RGB; break;
				case	K7ZAN_COL_RB:
				default:
					mesid = 0xffffffff;
					break;
				}
				if( mesid != 0xffffffff ){
					K7SCR_SYS_ITEMGET(mesid);
					K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(mesid);
				}
			}
		}
	}
	
	if( mZanCharaID!=K7CHRID(K7ZA2,1) ){
		if( !mZanNoiseCancel ){
			
			mZanState = ZANSTATE_TERM_FADEIN;
			
			while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorBlue)==false ){
				GHMGCTASK_RETSYS();
			}
		}
	}
	
	GHMGCTASK_RETSYS();
	GHMGCTASK_RETSYS();
	mpZan->Release();
	
	if( !mZanManual ){
		WK7CAM->RestoreFov ();
		WK7CAM->RestoreNear();
		WK7CAM->RestoreFar ();
		WK7PLAYERCONTROL->GetPathControl()->CameraRenew();
		WK7CAM->SetMode(cammode);
//		WK7PLAYERCONTROL->VitalVisible(true);
		WK7PLAYERCONTROL->SetVisible(true);
	}
	
	if( mZanCharaID!=K7CHRID(K7ZA2,1) ){
		if( !mZanNoiseCancel ){
			
			mZanState = ZANSTATE_TERM_FADEINWAIT;
			
			while( gpNoise->mGetSandFrameProc()!=eSandExec ){
				GHMGCTASK_RETSYS();
			}
		}
	}
	
	mZanState = ZANSTATE_TERM_NOISEWAIT;
	
	while( mZanTermNoiseWait ){
		GHMGCTASK_RETSYS();
	}
	
	if( !mZanCinemaScopeCancel ){
		WK7CAM->SetCinemaScopeMode(false);
	}
	
	if( mZanCharaID!=K7CHRID(K7ZA2,1) ){
		if( !mZanNoiseCancel ){
			
			mZanState = ZANSTATE_TERM_FADEOUT;
			
			while( gpNoise->mSandRelease()==false ){
				GHMGCTASK_RETSYS();
			}
			
			mZanState = ZANSTATE_TERM_FADEOUTWAIT;
			
			while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
				GHMGCTASK_RETSYS();
			}
		}
	}
	
#if	0
	if( mZanCharaID==K7CHRID(K7ZA2,1) ){
		// h~jJJ[`bv
		WK7Stage				*pStage = WK7Stage::GetCurrentStage();
		if( pStage!=NULL ){
			WK7StageZan				*pZan         = pStage->GetZan(K7EVENTZANID(mZanID));
			WK7StageZanColChipInfo	*pColChipInfo = WK7StageZan::GetZanColChipInfo(K7EVENTZANID(mZanID));
			if( pColChipInfo!=NULL && pZan!=NULL ){
				u32		mesid;
				switch( pColChipInfo->mColorID ){
				case	K7ZAN_COL_R:   mesid = K7SCR_SYSMES_COLORCHIP_R;   break;
				case	K7ZAN_COL_G:   mesid = K7SCR_SYSMES_COLORCHIP_G;   break;
				case	K7ZAN_COL_RG:  mesid = K7SCR_SYSMES_COLORCHIP_RG;  break;
				case	K7ZAN_COL_B:   mesid = K7SCR_SYSMES_COLORCHIP_B;   break;
				case	K7ZAN_COL_GB:  mesid = K7SCR_SYSMES_COLORCHIP_GB;  break;
				case	K7ZAN_COL_RGB: mesid = K7SCR_SYSMES_COLORCHIP_RGB; break;
				case	K7ZAN_COL_RB:
				default:
					mesid = 0xffffffff;
					break;
				}
				if( mesid != 0xffffffff ){
					K7SCR_SYS_ITEMGET(mesid);
					K7SCR_SYS_ITEMGET_NOTDISPLAYED_B(mesid);
					pZan->InitIwazaru();
					K7SCR_SYS_ITEMGET_VALID_B(mesid);
				}
			}
		}
	}
#else
	if( mZanCharaID==K7CHRID(K7ZA2,1) ){
		if( mesid != 0xffffffff ){
			if( pZan!=NULL ){
				pZan->InitIwazaru();
			}
			K7SCR_SYS_ITEMGET_VALID_B(mesid);
		}
	}
#endif
	
	if( !mZanManual ){
		WK7PLAYERCONTROL->SetOperateEnable(true);
		WK7PLAYERPATHCONTROL->SetActive(true);
		WK7PLAYERCONTROL->SetPathSelectState();
		K7SCR_EXIT_DEMOPAUSE();
	}
	
}

void WK7GameInfo::_ZanModeTaskTerm(ghmGcTask * /*pTask*/)
{
	GHM_SAFE_DELETE(mpZan);
	mTaskID = -1;
	if( !mZanManual ){
		if( mPrevMode!=ZAN ){
			if( mPrevTaskID >= 0 ){
				mTaskID     = mPrevTaskID;
				mMode       = mPrevMode;
				mPrevTaskID = -1;
				mPrevMode   = PLAY;
			}else{
				SetMode(mPrevMode);
			}
		}
	}else{
		if( mPrevTaskID >= 0 ){
			mTaskID     = mPrevTaskID;
			mMode       = mPrevMode;
			mPrevTaskID = -1;
			mPrevMode   = PLAY;
		}
	}
	mZanState              = ZANSTATE_STANDBY;
	mZanMesID              = 0xffffffff;
	mZanParam              = 0xffffffff;
	mZanInitWait           = 0;
	mZanExecWait           = 0;
	mZanTermWait           = 0;
	mZanNoiseCancel        = 0;
	mZanCinemaScopeCancel  = 0;
	mZanManual             = 0;
	mZanCharaLoadCancel    = 0;
	mZanCharaPresentTick   = 0xffffffff;
	mZanCharaPresentNameID = 0;
	mZanCharaPresentNameX  = 0;
	mZanCharaPresentNameY  = 0;
	mZanCharaPresentWinX   = 0.0f;
	mZanCharaPresentWinY   = 0.0f;
	mZanCharaPresentWinW   = 0.0f;
	mZanCharaPresentWinH   = 0.0f;
	mZanCharaPresentFlag   = -1;
	mZanID                 = 0xffffffff;
	mZanCamID              = 0xffffffff;
}

void WK7GameInfo::ZanModeTask(ghmGcTask *pTask)
{
	GameInfo._ZanModeTask(pTask);
}

void WK7GameInfo::ZanModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._ZanModeTaskTerm(pTask);
}

bool ChangePrioEffect(EFFECT *pEffect,int prio)
{
	if( pEffect==NULL || GetEffectValidState(pEffect)==FALSE || pEffect->ManageTask==NULL ){
		return false;
	}
	pEffect->ManageTask->ChangePriority(prio);
	return true;
}

bool ChangePrioEffect(EFFECT_TYPE type,int prio)
{
	EFFECT		*pEffect;
	for(pEffect=EffSys.FirstEffect ; pEffect!=NULL ; pEffect=pEffect->Next){
		if( pEffect->Type!=type ){
			continue;
		}
		if( pEffect->ManageTask==NULL ){
			continue;
		}
		pEffect->ManageTask->ChangePriority(prio);
	}
	return true;
}

////////////////////////////////////////////////////////////////////////////////
// \̓j[
// <in>
//	mode	0:Ver
//			1:Ver
////////////////////////////////////////////////////////////////////////////////
EFFECT *WK7GameInfo::PcBomb(WK7JObj *pJObj,const Vec &pos,f32 roty,s8 ReverseFlag, int mode)
{
	EFFECT *pPcBombEfc = NULL;
	f32		distzx;
	Vec		vecp;
	distzx = cosf(0.f);
	vecp.y = sinf(0.f);
	vecp.x = distzx * sinf(roty);
	vecp.z = distzx * cosf(roty);
	
	// obj
	if( pJObj==NULL ){
		return NULL;
	}
	
	// 03/30/04  Rcǉ =============
	if( ReverseFlag == FALSE )
	{
		SetHSDeadEffectTimeRate( 0.5F ) ;
	}
	// ================================
	
	if (mode){
		GXColor color = { 0xf0,0xff,0xff,0xf0 };
		SetHSDeadEffectColor( color, color );	// ɍ쐬wuX}CSGtFNg̐Fݒ肷
	}
	
//	::EffectSetForcedPriority(true,400);
	::EffectSetForcedPriority(true,411-WK7MAINTASK_SCREENCAPTURE_TASK_PRIO+1);
	
	pPcBombEfc = CreateHSDeadEffect(	pJObj,
										vecp,
										VParam[ED_HSD1][0] / 10.0F,	// Power ԑ
										pos.y,
										10,							// BloodNum ̐
										(u8)VParam[ED_HSD1][2],		// Wait
										0,							// Mode
										NULL,						// BInfo
										3000,						// BInfoMaxNum
										NULL,						// BInfoNumBuffer		
										false,						// BloodEffectDeleteFlag
										false,						// ConveFlag
										60,							// ConveWaitTime
										0.01F,						// ConvePower
										(u8 )BLOODTEX_BLOOD,		// BloodTexNumber
										true,						// ImpactFlag
										ReverseFlag				// ReverseFlag
	);
	
	::EffectSetForcedPriority(false);
	
//	ChangePrioEffect(EFF_CONVEBLOOD2,400);
//	ChangePrioEffect(EFF_BLOOD      ,400);
//	ChangePrioEffect(EFF_BLOOD2     ,400);
//	ChangePrioEffect(EFF_MESH       ,400);
	
	return pPcBombEfc;
}
EFFECT *WK7GameInfo::PcBomb(s8 ReverseFlag, int mode)
{
	Vec myPos;
	f32 myRoty;
	
	WK7PLAYERCONTROL->GetRotY(&myRoty);
	WK7PLAYERCONTROL->GetPosition(&myPos);
	
	return PcBomb(WK7PLAYERCONTROL->GetWaistObjPtr(),myPos,myRoty,ReverseFlag,mode);
}

void WK7GameInfo::_SpecialMenuTask(ghmGcTask * /*pTask*/)
{
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7SELECTIF->Disappear();
	
	ghmGcMemSetAllocName("SKSp");
	while( (mpSpecial = new SK7Special(mpSpOption))==NULL ){
		GHMGCTASK_RETSYS();
	}
	
	if( mpSpOption!=NULL ){
		mpSpOption->SetState(SPOPTION_STANBY);
	}
	
	WK7SIGHT->SetVisible(false);
	
	// 싖
	mpSpecial->SetCtrlFlag(true);
	mpSpecial->SetRender  (true);
	
	// I҂
	while( mpSpecial->GetMenuEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	u32 SpecialEventID = mpSpecial->GetEventNo();
	mSpecialResult = mpSpecial->GetResult();
	
	// ֎~
	mpSpecial->SetCtrlFlag(false);
	mpSpecial->SetRender  (false);
	
	GHMGCTASK_RETSYS();
	GHM_SAFE_DELETE(mpSpecial);
	
	if( SpecialEventID==0xffffffff ){
		
		switch( mSpecialResult ){
			// L`FW
		case	RESULT_CHANGE_GAL:						//	KVA
		case	RESULT_CHANGE_DAN:						//	_
		case	RESULT_CHANGE_KED:						//	JGf
		case	RESULT_CHANGE_KVN:						//	PB
		case	RESULT_CHANGE_CYO:						//	R[e
		case	RESULT_CHANGE_CON:						//	R
		case	RESULT_CHANGE_MSK:						//	}XN
		case	RESULT_CHANGE_HAY:{						//	On[}
			u32		charaid;
			switch( mSpecialResult ){
				// L`FW
			case	RESULT_CHANGE_GAL: charaid=K7CHRID(K7GAL,0); break;
			case	RESULT_CHANGE_DAN: charaid=K7CHRID(K7DAN,0); break;
			case	RESULT_CHANGE_KED: charaid=K7CHRID(K7KED,0); break;
			case	RESULT_CHANGE_KVN: charaid=K7CHRID(K7KVN,0); break;
			case	RESULT_CHANGE_CYO: charaid=K7CHRID(K7CYO,0); break;
			case	RESULT_CHANGE_CON: charaid=K7CHRID(K7CAT,0); break;
			case	RESULT_CHANGE_MSK: charaid=K7CHRID(K7MSK,0); break;
			case	RESULT_CHANGE_HAY: charaid=K7CHRID(K7HAY,0); break;
			}
			
			mCharaChangeCancel = 0;
			
			WK7Stage	*pStage = WK7Stage::GetCurrentStage();
			if( pStage!=NULL ){
				WK7CharaChangeInfo		info;
				info.Initialize();
				info.mCurrCharaID = charaid;
				info.mPrevCharaID = WK7PLAYERCONTROL->GetID();
				pStage->CallPreCharaChangeCallBackTask(info);
			}
			
			if( mCharaChangeCancel ){
				break;
			}
			
			BloodCharaChange(charaid);
			
			}break;
			// Z
		case	RESULT_SP_DAN_0:						//	_SP0 	time freeze
		case	RESULT_SP_DAN_1:						//	_SP1 	time slip
		case	RESULT_SP_KED_0:						//	SP0 	open spirit guide
		case	RESULT_SP_KVN_0:						//	PBSP0 cloaking
		case	RESULT_SP_CYO_0:						//	R[eSP0 boost jump
		case	RESULT_SP_CON_0:						//	RSP0 	sonic sight
		case	RESULT_SP_CON_1:						//	RSP1 	wind manipulation
		case	RESULT_SP_MSK_0:						//	}XNSP0 	super strength
			// ACe
		case	RESULT_ITEM_DAN_0:						//	_ITEM0 		ignition fire
		case	RESULT_ITEM_KED_0:						//	ITEM0 	suck blood
		case	RESULT_ITEM_KVN_0:						//	PBITEM0 	system hack
		case	RESULT_ITEM_CYO_0:						//	R[eITEM0 	picking tool
		case	RESULT_ITEM_CON_0:						//	RITEM0 		magic mirror
		case	RESULT_ITEM_MSK_0:						//	}XNITEM0 	magic wallet
			break;
	//	case	RESULT_SP_CHARA:						//	L`FW
	//	case	RESULT_SP_SPECIAL:						//	Zԍ
	//	case	RESULT_SP_ITEM:							//	ACeԍ
		case	RESULT_SP_START:						//	X^[g{^ăACeʂ
		case	RESULT_SP_NONE:							//	ȂB
		default:
			break;
		}
		
		K7SCR_EVCONDCHANGE();
		
		K7SCR_EXIT_DEMOPAUSE();
	}else{
		
		WK7Stage		*pStage = WK7Stage::GetCurrentStage();
		
		if( pStage!=NULL ){
			WK7EventInfo		info;
			info.Initialize();
			info.mEventNo = SpecialEventID;
			pStage->CallEventCallBackTask(info);
		}
		
	}
	
}


//	mode	0:Ver
//			1:Ver }XÑ[Vt
void WK7GameInfo::BloodCharaChange(u32 charaid, int mode, int voice)
{
	EFFECT *pPcBombEfc = NULL;
	int CtrlFrame = WK7_SEC_TO_FRAME(2);
	bool	zupdate;
	bool	render;
	u32		effectID;

	Vec		SavePos;
	WK7PLAYERCONTROL->GetPosition(&SavePos);
	
	// ݂̃LN^̂goqɂɔf
	WK7PLAYERCONTROL->SetDataHp(WK7PLAYERCONTROL->GetMainID(), WK7PLAYERCONTROL->GetHp());		// ݂̂goqɃL̃f[^e[uɔf

	if ( 1== mode ){
		if ( voice == -1 ){
			WK7PLAYERCONTROL->WK7PlayerMskSpAtkPosePlay();
		}else{
			WK7PLAYERCONTROL->WK7PlayerMskSpAtkPosePlay(voice);
		}
		
	}
	
	render  = screenImageMonoColor.GetRender ();
	zupdate = screenImageMonoColor.GetZUpdate();
	screenImageMonoColor.SetRender (true );
	screenImageMonoColor.SetZUpdate(false);
	
	screenImageMonoColor.SetA(0x00);
	screenImageMonoColor.SetA(0xff,WK7_SEC_TO_TICK(0.5f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		GHMGCTASK_RETSYS();
	}
	
	pPcBombEfc	= PcBomb(0, mode);								// objiobj
	effectID	= GetEffectID( pPcBombEfc );					//	GtFNghc̕ۑ
	WK7PLAYERCONTROL->SetVisible(false);
	
//	K7SCR_TIMEWAIT(1200);
	K7SCR_TIMEWAIT(100);
	
	WK7PLAYERCONTROL->SetOperateEnable(false);
	WK7PLAYERCONTROL->Reset();
	WK7PLAYERCONTROL->ReleaseAll();
	
	GHMGCTASK_RETSYS();
	WK7PLAYERCONTROL->CreateModel(charaid);
	WK7PLAYERCONTROL->CreatePackMotion(charaid);
	GHMGCTASK_RETSYS();
	while( true == WK7PLAYERCONTROL->IsLoading() ){
		GHMGCTASK_RETSYS();
	}
	WK7PLAYERCONTROL->SetVisible(false);										// ܂\Ȃ
	
	if ( NULL != pPcBombEfc ){
		while( true == CheckEffectValidState(pPcBombEfc, effectID) ){			// Jñ^C~Ov
			CtrlFrame--;
			if( CtrlFrame <= 0 ) {
				DeleteEffect(pPcBombEfc);
			} 
			GHMGCTASK_RETSYS();
		}
	}
	
	while( WK7PLAYERCONTROL->GetState()==PC_STATE_INIT ){
		GHMGCTASK_RETSYS();
	}
	
	WK7PLAYERCONTROL->SetPosition(&SavePos);
	WK7PLAYERPATHCONTROL->CameraRenew();
	WK7PLAYERCONTROL->ChangeCallback();
	
//	K7SCR_TIMEWAIT(1200);
	K7SCR_TIMEWAIT(100);
	
	WK7Chara	*pChara = WK7PLAYERCONTROL->GetCharaPtr();
	if( pChara!=NULL ){
		pChara->StopMotion();
	}
	
	pPcBombEfc = PcBomb(1, mode);									// obj߂iVobj
	effectID	= GetEffectID( pPcBombEfc );					//	GtFNghc̕ۑ
	if ( NULL != pPcBombEfc ){
		while( false == GetHSDeadConveState(pPcBombEfc) ){			// L\̃^C~Ov
			GHMGCTASK_RETSYS();
		}
		
		if( pChara!=NULL ){
			pChara->ReplayMotion();
		}
		WK7PLAYERCONTROL->SetVisible(true);							// \
		
		while( true == CheckEffectValidState(pPcBombEfc, effectID) ){			// obj߂̃GtFNgI҂
//		while( true == GetEffectValidState(pPcBombEfc) ){			// obj߂̃GtFNgI҂
			GHMGCTASK_RETSYS();
		}
	}else{
		if( pChara!=NULL ){
			pChara->ReplayMotion();
		}
	}
	
	screenImageMonoColor.SetA(0x00,WK7_SEC_TO_TICK(1.0f));
	while( screenImageMonoColor.IsAnimatingA()==true ){
		GHMGCTASK_RETSYS();
	}
	
	screenImageMonoColor.SetRender (render );
	screenImageMonoColor.SetZUpdate(zupdate);
	screenImageMonoColor.SetA(0xff,0);
	
	WK7PLAYERCONTROL->SetOperateEnable(true);
}


void WK7GameInfo::_SpecialMenuTaskTerm(ghmGcTask * /*pTask*/)
{
	GHM_SAFE_DELETE(mpSpecial);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
}

void WK7GameInfo::SpecialMenuTask(ghmGcTask *pTask)
{
	GameInfo._SpecialMenuTask(pTask);
}

void WK7GameInfo::SpecialMenuTaskTerm(ghmGcTask *pTask)
{
	GameInfo._SpecialMenuTaskTerm(pTask);
}

void WK7GameInfo::_SaveModeTask(ghmGcTask * /*pTask*/)
{
	SK7SaveData		*pSaveData;
	
	mSaveModeState = SMSTATE_STANDBY;
	
	ghmGcMemSetAllocName("SKSL");
	while( (mpSaveLoad = SK7SaveBase::Create(eBaseSave))==NULL){
//	while( (mpSaveLoad = new SK7SaveLoad(SAVE_STATE_SAVE))==NULL ){
		GHMGCTASK_RETSYS();
	}
	
	while( (pSaveData = mpSaveLoad->GetSaveData())==NULL ){
		GHMGCTASK_RETSYS();
	}
	
	GameInfo.StoreSaveData(pSaveData);
#ifdef	_DEBUG
//	GameInfo.StoreSaveData(&tempSaveData);
#endif
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_INIT_FADEIN;
	
	while( mpSaveLoad->GetFileReadEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_INIT_FADEWAIT;
	
	while( mSaveLoadInitHideWait ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	
	mpSaveLoad->SetRender(true);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_INIT_FADEOUT;
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_EXEC;
	
	K7SCR_TIMEWAIT(4800);
	
	mpSaveLoad->SetCtrlFlag(true);
	
	// I҂
	while( mpSaveLoad->GetMenuEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	mpSaveLoad->SetCtrlFlag(false);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed)==false ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_TERM_FADEIN;
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_TERM_FADEWAIT;
	while( mSaveLoadTermHideWait ){
		GHMGCTASK_RETSYS();
	}
	
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	mpSaveLoad->SetRender(false);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	mSaveModeState = SMSTATE_TERM_FADEOUT;
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_EXIT_DEMOPAUSE();
}

void WK7GameInfo::_SaveModeTaskTerm(ghmGcTask * /*pTask*/)
{
	mSaveModeState = SMSTATE_STANDBY;
	GHM_SAFE_DELETE(mpSaveLoad);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
}

void WK7GameInfo::SaveModeTask(ghmGcTask *pTask)
{
	GameInfo._SaveModeTask(pTask);
}

void WK7GameInfo::SaveModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._SaveModeTaskTerm(pTask);
}

void WK7GameInfo::_MenuMapModeTask(ghmGcTask * /*pTask*/)
{
	bool			blur = SceneBlur.GetVisible();
	bool			particle = PARTICLE.GetRender();
	
	mMenuMapModeState = MMMSTATE_STANDBY;
	
	ghmGcMemSetAllocName("SKMM");
	while( (mpMenuMap = new SK7IMenuMap())==NULL ){
		GHMGCTASK_RETSYS();
	}
	
	mpMenuMap->SetSubNo(mMenuMapSubNo);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed,SFX_SYS_XMAP_NOIZ)==false ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_INIT_FADEIN;
	
	while( mpMenuMap->GetFileReadEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_INIT_FADEWAIT;
	
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem  (false);
	
	mpMenuMap->SetRender(true);
	SceneBlur.SetVisible(false);
	PARTICLE.SetRender(false);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_INIT_FADEOUT;
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	mpMenuMap->SetCtrlFlag(true);
	
	mMenuMapModeState = MMMSTATE_EXEC;
	
//	K7SCR_TIMEWAIT(4800);
	
	// I҂
	while( mpMenuMap->GetMenuEnd()!=true ){
		GHMGCTASK_RETSYS();
	}
	
	mpMenuMap->SetCtrlFlag(false);
	
	while( gpNoise->mSandRequest(eSandLongNoise,eNoiseColorRed,SFX_SYS_XMAP_NOIZ)==false ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_TERM_FADEIN;
	
	// mCYI҂
	while( gpNoise->mGetSandFrameProc()!=eSandExec ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_TERM_FADEWAIT;
	
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem  (true);
	mpMenuMap->SetRender(false);
	SceneBlur.SetVisible(blur);
	PARTICLE.SetRender(particle);
	
	while( gpNoise->mSandRelease()==false ){
		GHMGCTASK_RETSYS();
	}
	
	mMenuMapModeState = MMMSTATE_TERM_FADEOUT;
	
	while( gpNoise->mGetSandFrameProc()!=eSandStandby ){
		GHMGCTASK_RETSYS();
	}
	
	K7SCR_EXIT_DEMOPAUSE();
}

void WK7GameInfo::_MenuMapModeTaskTerm(ghmGcTask * /*pTask*/)
{
	mMenuMapModeState = MMMSTATE_STANDBY;
	GHM_SAFE_DELETE(mpMenuMap);
	if( mPrevTaskID >= 0 ){
		mTaskID     = mPrevTaskID;
		mMode       = mPrevMode;
		mPrevTaskID = -1;
		mPrevMode   = PLAY;
	}else{
		mTaskID = -1;
		SetMode(mPrevMode);
	}
}

void WK7GameInfo::MenuMapModeTask(ghmGcTask *pTask)
{
	GameInfo._MenuMapModeTask(pTask);
}

void WK7GameInfo::MenuMapModeTaskTerm(ghmGcTask *pTask)
{
	GameInfo._MenuMapModeTaskTerm(pTask);
}

bool WK7GameInfo::FrameProcess(void)
{
	if( WK7EVENTCONTROLLER->GetState()!=WK7EventController::WK7EVENTCONTROLLERSTATE_RUN ){
		return true;
	}
	mKeyIdleControl.FrameProcess();
	if( mpSpOption!=NULL && mpSpecial==NULL ){
		switch( mMode ){
		case	MOVE:
			SetRenderOption(true);
			if( HSD_PadGetButton         (0)         || 
			    HSD_PadGetNormalAnalogR  (0) >  0.0f ||
			    HSD_PadGetNormalAnalogL  (0) >  0.0f ||
			    HSD_PadGetNormalStickX   (0) != 0.0f ||
			    HSD_PadGetNormalStickY   (0) != 0.0f ||
			    HSD_PadGetNormalSubStickX(0) != 0.0f ||
			    HSD_PadGetNormalSubStickY(0) != 0.0f ){
				if( mKeyIdle==true ){
					// ߂^C~O
					mpSpOption->SetState(SPOPTION_BALLET_CLOSE);
				}
				KeyIdleCountStart();
				mKeyIdle = false;
			}else{
				if( mKeyIdleControl.IsAnimating()==false ){
					// oĂ^C~O
					if( mKeyIdle==false ){
						mpSpOption->SetState(SPOPTION_BALLET_MOVE);
					}
					mKeyIdle = true;
				}
			}
			break;
		case	BATTLE:
			break;
		default:
			SetRenderOption(false);
			break;
		}
	}
	if( mpMemo    !=NULL ){ mpMemo    ->FrameProcess();    }
	if( mpHatoMemo!=NULL ){ mpHatoMemo->FrameProcessOne(); }
	if( mpPanel   !=NULL ){ mpPanel   ->FrameProcess();    }
	if( mpMoon    !=NULL ){ mpMoon    ->FrameProcess();    }
	if( mpZan     !=NULL ){ mpZan     ->FrameProcess();    }
	if( mpSaveLoad!=NULL ){
		if( mMode==SAVE ){
			mpSaveLoad->FrameProcess();//SaveFrameProcess();
		}
	}
#if 0
	if( mpItem    !=NULL ){
		mpItem->FrameProcess();
	}else{
		switch( mMode ){
		case	MOVE:
#ifndef	LAS_VEGAS
//			if( HSD_PadGetButton (0)==HSD_PAD_START && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
//				if( mItemEnable==true ){
//					SetMode(ITEMMODE);
//				}
//			}
#endif
			break;
		default:
			break;
		}
	}
#endif
	bool	Keyflag=false;
	if( mpSpecial !=NULL ){
		mpSpecial->FrameProcess();
	}else{
		switch( mMode ){
		case	MOVE:
			if( g_pSpData==NULL ){
				break;
			}
#ifndef	K7APP_MASTER
			if( GameInfo.GetScenarioID()==K7SCN99 ){
				break;
			}
#endif
			if( false==WK7PLAYERCONTROL->GetNaturalTest() ){
				break;
			}
			if( HSD_PadGetButton (0)==WK7GAMEINFO_PAD_SPMENU && (HSD_PadGetTrigger(0) & WK7GAMEINFO_PAD_SPMENU) ){
				if( mSpecialEnable==true && WK7PLAYERCONTROL->GetMainID()!=K7HAC ){
					Keyflag = true;
					SetMode(SPMENU);
					break;
				}
			}
			if( HSD_PadGetButton (0)==WK7GAMEINFO_PAD_MENUMAP && (HSD_PadGetTrigger(0) & WK7GAMEINFO_PAD_MENUMAP) ){
				if( mMenuMapEnable==true ){
					Keyflag = true;
					SetMode(MENUMAP);
					break;
				}
			}
			break;
		default:
			break;
		}
	}
	if( mpSpOption!=NULL ){
		if( Keyflag==false ){
			mpSpOption->FrameProcess();
		}
	}
	switch( mMode ){
	case	MENUMAP:
		if( mpMenuMap!=NULL ){
			mpMenuMap->FrameProcess();
		}
		break;
	case	MAP:
		::MapSelectFrameProcess();
		break;
	case	STAGETITLE:
		::StageTitleFrameProcess();
		break;
	}
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	if( pTutorial!=NULL ){
		pTutorial->FrameProcess();
	}
	return true;
}

bool WK7GameInfo::PreScreenCaptureRenderProcess(void)
{
	if( mpMemo    !=NULL ){ mpMemo    ->RenderProcess(); }
	if( mpHatoMemo!=NULL ){ mpHatoMemo->RenderProcess(); }
//	if( mpItem    !=NULL ){ mpItem    ->RenderProcess(); }
	if( mpPanel   !=NULL ){ mpPanel   ->RenderProcess(); }
	if( mpMoon    !=NULL ){ mpMoon    ->RenderProcess(); }
	switch( mMode ){
	case	MENUMAP:
		if( mpMenuMap!=NULL ){
			mpMenuMap->RenderProcess();
		}
		break;
	case	MAP:
		::MapSelectRenderProcess();
		break;
	case	STAGETITLE:
		::StageTitleRenderProcess();
		break;
	}
	return true;
}

bool WK7GameInfo::RenderProcess(void)
{
	return true;
}

bool WK7GameInfo::PostScreenCaptureRenderProcess(void)
{
	if( mpZan     !=NULL ){ mpZan     ->RenderProcess();       }
	if( mpSpecial !=NULL ){ mpSpecial ->RenderWindowProcess(); }
	if( mpSpOption!=NULL ){ mpSpOption->RenderProcess();       }
	if( mpSpecial !=NULL ){ mpSpecial ->RenderProcess(); }
	if( mpSaveLoad!=NULL ){ mpSaveLoad->RenderProcess(); }
	WK7Tutorial	*pTutorial = WK7Tutorial::GetInstance();
	if( pTutorial!=NULL ){
		pTutorial->RenderProcess();
	}
//	C_Paper		paper(32,240);
//	PRINTF("RenderOption %s\n",mRenderSpOption==true? "true" : "false");
	
	return true;
}

bool WK7GameInfo::PostScreenCaptureRenderProcess2(void)
{
//	if( mpSpecial !=NULL ){ mpSpecial ->RenderProcess(); }
//	if( mpSaveLoad!=NULL ){ mpSaveLoad->RenderProcess(); }
	return true;
}

void* WK7GameInfo::GetScenarioVar(int scnid)
{
	if( scnid >= 0 ){
		if( scnid != mScenarioID ){
			return NULL;
		}
	}
	return mpScenarioVar;
}

#ifdef	_DEBUG
bool WK7GameInfo::SetVarType(K7EVVarType *pVarType)
{
	mpVarType = pVarType;
	return true;
}

K7EVVarType* WK7GameInfo::GetVarTypeTop(int scnid)
{
	if( scnid >= 0 ){
		if( scnid != mScenarioID ){
			return NULL;
		}
	}
	return mpVarType;
//	K7EVVarType		*pVarType;
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	switch( scnid ){
//	case	K7SCN01: pVarType = K7EV_SCN_VARTYPENAME(K7SCN01); break;
//	case	K7SCN02: pVarType = K7EV_SCN_VARTYPENAME(K7SCN02); break;
//	case	K7SCN03: pVarType = K7EV_SCN_VARTYPENAME(K7SCN03); break;
//	case	K7SCN04: pVarType = K7EV_SCN_VARTYPENAME(K7SCN04); break;
//	case	K7SCN05: pVarType = K7EV_SCN_VARTYPENAME(K7SCN05); break;
//	case	K7SCN07: pVarType = K7EV_SCN_VARTYPENAME(K7SCN07); break;
//	default:
//		return NULL;
//	}
//	return pVarType;
}
#endif

//WK7EventItemTable* WK7GameInfo::GetEventItemTable(int scnid)
//{
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	switch( scnid ){
//	case	K7SCN01: return K7EV_SCN_ITEMTABLE(K7SCN01);
//	case	K7SCN02: return K7EV_SCN_ITEMTABLE(K7SCN02);
//	case	K7SCN03: return K7EV_SCN_ITEMTABLE(K7SCN03);
//	case	K7SCN04: return K7EV_SCN_ITEMTABLE(K7SCN04);
//	case	K7SCN05: return K7EV_SCN_ITEMTABLE(K7SCN05);
//	case	K7SCN07: return K7EV_SCN_ITEMTABLE(K7SCN07);
//	default:
//		break;
//	}
//	return NULL;
//	return WK7EventItem::GetTable();
//}

//u32* WK7GameInfo::GetItemFlag(int scnid)
//{
//	if( scnid < 0 ){
//		scnid = mScenarioID;
//	}
//	switch( scnid ){
//	case	K7SCN01: return K7EV_SCN_ITEMFLAG(K7SCN01);
//	case	K7SCN02: return K7EV_SCN_ITEMFLAG(K7SCN02);
//	case	K7SCN03: return K7EV_SCN_ITEMFLAG(K7SCN03);
//	case	K7SCN04: return K7EV_SCN_ITEMFLAG(K7SCN04);
//	case	K7SCN05: return K7EV_SCN_ITEMFLAG(K7SCN05);
//	case	K7SCN07: return K7EV_SCN_ITEMFLAG(K7SCN07);
//	default:
//		break;
//	}
//	return NULL;
//}

bool WK7GameInfo::MapRootCreate(s32 StartID,s32 EndID)
{
	if( mMode!=MAP ){
		return false;
	}
	::MapRootCreate(StartID,EndID);
	return true;
}

bool WK7GameInfo::MapSelectInit(s32 FirstMap,s32 GoolMap,bool ButtonCancel)
{
	switch( mMode ){
	case	TERM:
	case	MAP:
		return false;
	default:
		break;
	}
	mMode = MAP;
	::MapSelectInit(FirstMap,GoolMap,ButtonCancel);
	SceneBlur.SetVisible(false);
	WK7Chara::SetRenderChara(false);
	WK7Stage::SetRenderStage(false);
	WK7Item::SetRenderItem(false);
	return true;
}

bool WK7GameInfo::MapSelectEnd(void)
{
	if( mMode!=MAP ){
		return false;
	}
	::MapSelectEnd();
	mMode = PLAY;
	WK7Chara::SetRenderChara(true);
	WK7Stage::SetRenderStage(true);
	WK7Item::SetRenderItem(true);
	return true;
}

bool WK7GameInfo::CheckMapSelectEnd(void)
{
	return ::CheckMapSelectEnd()==TRUE? true : false;
}

s32 WK7GameInfo::GetMapSelectPoint(void)
{
	return ::GetMapSelectPoint();
}

void WK7GameInfo::SetMapSelectValidFlag(u8 MapID,u8 Flag)
{
	::SetMapSelectValidFlag(MapID,Flag);
}

u8 WK7GameInfo::GetMapSelectValidFlag(u8 MapID)
{
	return ::GetMapSelectValidFlag(MapID);
}

bool WK7GameInfo::StageTitleInit(STAGE_TITLE inNo)
{
	switch( mMode ){
	case	TERM:
	case	STAGETITLE:
		return false;
	default:
		break;
	}
	mMode = STAGETITLE;
	SceneBlur.SetVisible(false);
	::StageTitleInit( inNo );
	return true;
}

bool WK7GameInfo::StageTitleEnd(void)
{
	if( mMode!=STAGETITLE ){
		return false;
	}
	::StageTitleEnd();
	mMode = PLAY;
	return true;
}

bool WK7GameInfo::CheckStageTitleSetup(void)
{
	return ::CheckStageTitleSetup()==TRUE? true : false;
}

bool WK7GameInfo::CheckStageTitleEndState(void)
{
	return ::CheckStageTitleEndState()==TRUE? true : false;
}

void WK7GameInfo::CreateBallet(void)
{
	if( mpSpOption==NULL ){
		return;
	}
	mpSpOption->CreateItem(ITEM_BALLET);
}

void WK7GameInfo::DeleteBallet(void)
{
	if( mpSpOption==NULL ){
		return;
	}
	mpSpOption->DeleteItem(ITEM_BALLET);
}

bool WK7GameInfo::SetRenderOption(bool flag)
{
	if( mpSpOption==NULL || mRenderOptionDisable==true ){
		return false;
	}
	mRenderSpOption = flag;
	mpSpOption->SetRenderEye   (flag);
	if( flag==false ){
		mpSpOption->SetEyeExpan(EYE_EXSTATE_SMALL);
	}else{
		mpSpOption->SetEyeExpan(EYE_EXSTATE_BIG);
	}
	mpSpOption->SetRenderOption(flag);
	if( flag == false ){
		mpSpOption->SetState(SPOPTION_BALLET_CLOSE);
	}
	return true;
}

bool WK7GameInfo::InitOptionWindow(void)
{
	if( mpSpOption==NULL ){
		return false;
	}
	mpSpOption->InitOptionWindow();
	return true;
}

bool WK7GameInfo::OptionDemoClose(void)
{
	if( mpSpOption==NULL ){
		return false;
	}
	mpSpOption->SetState(SPOPTION_DEMO_CLOSE);
	return true;
}

bool WK7GameInfo::GetBattleTask(void)
{
	return KK7BattleMainTask::GetBattleTask();
}

