////////////////////////////////////////////////////////////////////////////////
//
// Killer7 GameInfo
//
// WK7GameInfo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/08/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7GAMEINFO_H__
#define	__WK7GAMEINFO_H__

#include "..\Sato\SK7PanelBase.h"
#include "..\Yam\YK7StageTitle.h"
//#include "..\Sato\SK7Item2.h"
//#include "..\Sato\SK7IMenuHato.h"
//#include "..\Sato\SK7Moon.h"
//#include "..\Sato\SK7Special.h"
//#include ".\WK7Memo.h" 
//#include "..\Yam\YK7MapSelect.h"
//#include ".\WK7Zan.h" 

class WK7JObj;
class WK7Zan;
class WK7Memo;
class SK7Moon;
//class SK7Item2;
class SK7IMenuHato;
class SK7SpOption;
class SK7Special;
class SK7IMenuMap;

#ifndef	TRUE
#define	TRUE			(1)
#endif
#ifndef	FALSE
#define	FALSE			(0)
#endif
#ifndef	ON
#define	ON				(1)
#endif
#ifndef	OFF
#define	OFF				(0)
#endif

#define	WK7GAMEINFO_GLOBAL_FLAG_NUM				(128)
#define	WK7GAMEINFO_SCENARIO_FLAG_NUM			(128)

#define	WK7GAMEINFO_GLOBAL_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7GAMEINFO_GLOBAL_FLAG_NUM  ,32)
#define	WK7GAMEINFO_SCENARIO_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7GAMEINFO_SCENARIO_FLAG_NUM,32)

#define	WK7GAMEINFO_GLOBAL_FLAG_SIZE			(WK7GAMEINFO_GLOBAL_FLAG_WORK_SIZE   * sizeof(u32))
#define	WK7GAMEINFO_SCENARIO_FLAG_SIZE			(WK7GAMEINFO_SCENARIO_FLAG_WORK_SIZE * sizeof(u32))

// O[otO
enum{
	K7GF_K7MSK_LEVELUP = 0,
};

#define	WK7GAMEINFO_GLOVAL_VAR_SIZE		(1024)
#define	WK7GAMEINFO_SCENARIO_VAR_SIZE	(1024)

struct SK7SaveData;
struct K7EVVarType;
struct WK7EventItemTable;
//class SK7SaveLoad;
class SK7SaveBase;
struct WK7GameVarGlobal;

class WK7GameInfo{
public:
	// Q[̃[h
	enum Mode{
		INIT = 0,					// 
		MOVE,						// ړ
		MOVECAM,					// ړiJt[j
		BATTLE,						// 퓬
		PLAY,						// L
		ITEMMODE,					// ACe
		PANELMODE,					// pl
		HATOMEMOMODE,				// ng
		MOON,						// 
		MAP,						// }bvʁiꏊړ\j
		MENUMAP,					// j[}bvʁiXe[Wʒu\j
		STAGETITLE,					// Xe[W^Cg
		ZAN,						// cvO
		SPMENU,						// \̓j[
		DIE,						// S[h
		SAVE,						// Z[u[h
		TERM,						// Q[I
	};
	enum PanelModeState{
		PMSTATE_STANDBY = 0,
		PMSTATE_INIT_FADEIN,
		PMSTATE_INIT_FADEWAIT,
		PMSTATE_INIT_FADEOUT,
		PMSTATE_EXEC,
		PMSTATE_TERM_CTRLOFFWAIT,
		PMSTATE_TERM_FADEIN,
		PMSTATE_TERM_DELETEWAIT,
		PMSTATE_TERM_FADEWAIT,
		PMSTATE_TERM_FADEOUT,
	};
	enum TermState{
		TERMSTATE_CLEAR = 0,		// ViINA
		TERMSTATE_GAMEOVER,			// Q[I[o[iIj
		TERMSTATE_GAMEAGAIN,		// Č
		TERMSTATE_SUSPEND,			// f
	};
	enum SaveModeState{
		SMSTATE_STANDBY = 0,
		SMSTATE_INIT_FADEIN,
		SMSTATE_INIT_FADEWAIT,
		SMSTATE_INIT_FADEOUT,
		SMSTATE_EXEC,
		SMSTATE_TERM_FADEIN,
		SMSTATE_TERM_FADEWAIT,
		SMSTATE_TERM_FADEOUT,
	};
	enum MenuMapModeState{
		MMMSTATE_STANDBY = 0,
		MMMSTATE_INIT_FADEIN,
		MMMSTATE_INIT_FADEWAIT,
		MMMSTATE_INIT_FADEOUT,
		MMMSTATE_EXEC,
		MMMSTATE_TERM_FADEIN,
		MMMSTATE_TERM_FADEWAIT,
		MMMSTATE_TERM_FADEOUT,
	};
	enum ZanState{
		ZANSTATE_STANDBY = 0,
		ZANSTATE_INIT,
		ZANSTATE_INIT_FADEIN,
		ZANSTATE_INIT_FADEINWAIT,
		ZANSTATE_INIT_FADEOUT,
		ZANSTATE_INIT_FADEOUTWAIT,
		ZANSTATE_INITWAIT,
		ZANSTATE_EXECWAIT,
		ZANSTATE_EXEC,
		ZANSTATE_TERMWAIT,
		ZANSTATE_TERM_FADEIN,
		ZANSTATE_TERM_FADEINWAIT,
		ZANSTATE_TERM_NOISEWAIT,
		ZANSTATE_TERM_FADEOUT,
		ZANSTATE_TERM_FADEOUTWAIT,
	};
protected:
	// ViIhc
	int								mScenarioID;
	// ViIt[
	K7ScenarioFlow					mScenarioFlow;
	// GAhc
	K7Area							mAreaID;
	
	// NAViIhc
	int								mClearScenarioID;
	int								mClearScenarioID2;
	
	// j[Q[
	bool							mNewGame;
	
	// n߂
	bool							mContinue;
	u32								mCharaID;
	u32								mCurrentStageID;
	f32								mCurrentStagePathParam;
	u32								mCurrentStagePathDir;
	char							*mpCurrentStagePathName;
	
	// [h
	Mode							mMode;
	Mode							mPrevMode;
	
	// ʊ֘A
	SK7Moon							*mpMoon;
#ifdef	_DEBUG
	bool							mMoonSkip;
	const char						**mppFlagName;
#endif

#if 0 
	
	// ACeʊ֘A
	SK7Item2						*mpItem;
#endif
	bool							mItemEnable;
	bool							mPlayerLightEnable;
	
	// ngʊ֘A
	SK7IMenuHato					*mpHatoMemo;
	u32								mMemoNo;
	WK7Memo							*mpMemo;
	WK7JObj							*mpMemoLocator;
	Vec								mMemoPosition;
	f32								mMemoRotY;
	
	// pl֘A
	ePanelID						mRequestPanelID;
	u32								mRequestPanelEventNo;
	s32								mRequestPanelParam;
	SK7PanelBase					*mpPanel;
	s32								mPanelResult;
	union{
		struct{
			u32						mPanelInitHideWait    : 1;
			u32						mPanelTermHideWait    : 1;
			u32						mPanelNoiseCancel     : 1;
			u32						mPanelCtrlOffWait     : 1;
			u32						mPanelDeleteWait      : 1;
			u32						mPanelReleaseCancel   : 1;
			u32						mPanelReleaseExec     : 1;
			u32						mSaveLoadInitHideWait : 1;
			u32						mSaveLoadTermHideWait : 1;
			u32						mZanInitWait          : 1;
			u32						mZanTermWait          : 1;
			u32						mZanExecWait          : 1;
			u32						mZanNoiseCancel       : 1;
			u32						mZanCinemaScopeCancel : 1;
			u32						mZanManual            : 1;
			u32						mZanTermNoiseWait     : 1;
			u32						mZanCharaLoadCancel   : 1;
			u32						mZanCharaPresentCancel: 1;
			u32						mCharaChangeCancel    : 1;
			u32						mPanelFlagPad         :13;
		};
		u32							mPanelFlag;
	};
	PanelModeState					mPanelModeState;
	u32								mPanelResultCam;
	
	// cvO֘A
	WK7Zan							*mpZan;
	u32								mZanID;
	u32								mZanCamID;
	Vec								mZanPos;
	Vec								mZanRot;
	ZanState						mZanState;
	u32								mZanMesID;
	u32								mZanParam;
	u32								mZanCharaID;
	u32								mZanCharaPresentTick;
	int								mZanCharaPresentNameID;
	s16								mZanCharaPresentNameX;
	s16								mZanCharaPresentNameY;
	f32								mZanCharaPresentWinX;
	f32								mZanCharaPresentWinY;
	f32								mZanCharaPresentWinW;
	f32								mZanCharaPresentWinH;
	int								mZanCharaPresentFlag;
	
	// \̓j[֘A
	SK7SpOption						*mpSpOption;
	bool							mRenderSpOption;
	bool							mRenderOptionDisable;
	SK7Special						*mpSpecial;
	bool							mSpecialEnable;
	s32								mSpecialResult;
	bool							mBossFlag;
	
	SK7SaveBase						*mpSaveLoad;
	SaveModeState					mSaveModeState;
	
	// }bv
	SK7IMenuMap						*mpMenuMap;
	MenuMapModeState				mMenuMapModeState;
	bool							mMenuMapEnable;
	s8								mMenuMapSubNo;
	
	// L[AChǗ
	WK7AnimLinearF					mKeyIdleControl;
	bool							mKeyIdle;
	
	// O[oϐ
	u8								mGlobalVar   [WK7GAMEINFO_GLOVAL_VAR_SIZE];
	// O[otO
	u32								mGlobalFlag  [WK7GAMEINFO_GLOBAL_FLAG_WORK_SIZE  ];
	
	// ViItO
	u32								mScenarioFlag[WK7GAMEINFO_SCENARIO_FLAG_WORK_SIZE];
	void							*mpScenarioVar;
	int								mScenarioVarSize;
	
	ghmGcTaskController				*mpTaskController;
	
	int								mTaskID;
	int								mPrevTaskID;
	
	TermState						mTermState;
	
	u32								*mpHanaFlagWork;
	u32								mHanaFlagWorkSize;
	u32								mHanaFlagNum;
	
#ifdef	_DEBUG
	K7EVVarType						*mpVarType;
#endif
	
	const char						*mpScenarioSSM;
	u16								mDefaultFootSE;
	
	void KeyIdleCountStart(void);
	bool SetScenarioVarWork(void);
	
//	u32* GetScenarioFlagWork(int scnid);
//	int GetHanaFlagIndex(int scnid,u32 stgid,u32 chrid,u32 seqid);
public:
	
	WK7GameInfo();
	virtual ~WK7GameInfo();
	
	WK7GameVarGlobal* GetGlobalVar(void){ return (WK7GameVarGlobal*)mGlobalVar; }
	
	inline u32 GetCharaID(void){ return mCharaID; }
	inline u32 GetCurrentStageID(void){ return mCurrentStageID; }
	inline f32 GetCurrentStagePathParam(void){ return mCurrentStagePathParam; }
	inline u32 GetCurrentStagePathDir(void){ return mCurrentStagePathDir; }
	inline const char* GetCurrentStagePathName(void){ return mpCurrentStagePathName; }
	bool SetCurrentStagePathName(const char *pName);
	
	inline void SetClearScenarioID(int ClearID){ mClearScenarioID = ClearID; }
	inline int GetClearScenarioID(void){ return mClearScenarioID; }
	inline void SetClearScenarioID2(int ClearID){ mClearScenarioID2 = ClearID; }
	inline int GetClearScenarioID2(void){ return mClearScenarioID2; }
	
	inline void SetNewGame(bool flag){ mNewGame=flag; }
	inline bool GetNewGame(void){ return mNewGame; }
	inline void SetContinue(bool flag){ mContinue=flag; }
	inline bool GetContinue(void){ return mContinue; }
	
	bool StoreSaveData(SK7SaveData *pSaveData);
	bool RestoreSaveData(SK7SaveData *pSaveData);
	
	bool Terminate(void);
	bool InitGlobal(void);
	bool InitScenario(void);
	bool InitAfterLoad(void);
	bool ReadScenarioSSM(void);
	bool ReleaseScenarioSSM(void);
	
	bool CreateSpOption(void);
	bool ReleaseSpOption(void);
	
	static void MoonModeTask(ghmGcTask *pTask);
	static void MoonModeTaskTerm(ghmGcTask *pTask);
	void _MoonModeTask(ghmGcTask *pTask);
	void _MoonModeTaskTerm(ghmGcTask *pTask);
	
	static void ItemModeTask(ghmGcTask *pTask);
	static void ItemModeTaskTerm(ghmGcTask *pTask);
	void _ItemModeTask(ghmGcTask *pTask);
	void _ItemModeTaskTerm(ghmGcTask *pTask);
	
	static void HatoMemoModeTask(ghmGcTask *pTask);
	static void HatoMemoModeTaskTerm(ghmGcTask *pTask);
	void _HatoMemoModeTask(ghmGcTask *pTask);
	void _HatoMemoModeTaskTerm(ghmGcTask *pTask);
	
	static void PanelModeTask(ghmGcTask *pTask);
	static void PanelModeTaskTerm(ghmGcTask *pTask);
	void _PanelModeTask(ghmGcTask *pTask);
	void _PanelModeTaskTerm(ghmGcTask *pTask);
	
	static void ZanModeTask(ghmGcTask *pTask);
	static void ZanModeTaskTerm(ghmGcTask *pTask);
	void _ZanModeTask(ghmGcTask *pTask);
	void _ZanModeTaskTerm(ghmGcTask *pTask);
	
	static void SpecialMenuTask(ghmGcTask *pTask);
	static void SpecialMenuTaskTerm(ghmGcTask *pTask);
	void _SpecialMenuTask(ghmGcTask *pTask);
	void _SpecialMenuTaskTerm(ghmGcTask *pTask);
	EFFECT *PcBomb(s8 ReverseFlag, int mode);
	EFFECT *PcBomb(WK7JObj *pJObj,const Vec &pos,f32 roty,s8 ReverseFlag, int mode);
	
	static void SaveModeTask(ghmGcTask *pTask);
	static void SaveModeTaskTerm(ghmGcTask *pTask);
	void _SaveModeTask(ghmGcTask *pTask);
	void _SaveModeTaskTerm(ghmGcTask *pTask);
	inline SK7SaveBase* GetSaveLoad(void){ return mpSaveLoad; }
//	inline SK7SaveLoad* GetSaveLoad(void){ return mpSaveLoad; }
	inline SaveModeState GetSaveModeState(void){ return mSaveModeState; }
	inline void SetSaveLoadInitHideWait(bool flag){ mSaveLoadInitHideWait=(flag==true)?1:0; }
	inline bool GetSaveLoadInitHideWait(void){ return mSaveLoadInitHideWait? true : false; }
	inline void SetSaveLoadTermHideWait(bool flag){ mSaveLoadTermHideWait=(flag==true)?1:0; }
	inline bool GetSaveLoadTermHideWait(void){ return mSaveLoadTermHideWait? true : false; }
	
	static void MenuMapModeTask(ghmGcTask *pTask);
	static void MenuMapModeTaskTerm(ghmGcTask *pTask);
	void _MenuMapModeTask(ghmGcTask *pTask);
	void _MenuMapModeTaskTerm(ghmGcTask *pTask);
	inline MenuMapModeState GetMenuMapModeState(void){ return mMenuMapModeState; }
	inline void SetMenuMapEnable(bool flag){ mMenuMapEnable=flag; }
	inline bool GetMenuMapEnable(void){ return mMenuMapEnable; }
	inline void SetMenuMapSubNo(s8 no){ mMenuMapSubNo = no; }
	inline s8 GetMenuMapSubNo(void){ return mMenuMapSubNo; }
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	bool PreScreenCaptureRenderProcess(void);
	bool PostScreenCaptureRenderProcess(void);
	bool PostScreenCaptureRenderProcess2(void);
	
	bool SetScenarioID(int id);
	inline int GetScenarioID(void){ return mScenarioID; }
	bool SetScenarioFlow(K7ScenarioFlow id);
	inline K7ScenarioFlow GetScenarioFlow(void){ return mScenarioFlow; }
	bool SetAreaID(K7Area id);
	inline K7Area GetAreaID(void){ return mAreaID; }
	
	inline void SetItemEnable(bool flag){ mItemEnable=flag; }
	inline bool GetItemEnable(void){ return mItemEnable; }
	
	inline void SetMemoNo(u32 memono){ mMemoNo=memono; }
	inline u32 GetMemoNo(void){ return mMemoNo; }
	inline void SetMemoLocator(WK7JObj *pLocator){ mpMemoLocator=pLocator; }
	inline WK7JObj* GetMemoLocator(void){ return mpMemoLocator; }
	inline void SetMemoPosition(const Vec &position){ mMemoPosition=position; }
	inline void GetMemoPosition(Vec &position){ position=mMemoPosition; }
	inline void SetMemoRotY(f32 roty){ mMemoRotY=roty; }
	inline f32 GetMemoRotY(void){ return mMemoRotY; }
	
	inline void SetRequestPanelEventNo(u32 evno,s32 param=-1){ mRequestPanelEventNo=evno; mRequestPanelID=ePanelIDMax; mRequestPanelParam=param; }
	inline void SetRequestPanelID(ePanelID id,s32 param=-1){ mRequestPanelID=id; mRequestPanelParam=param; }
	inline ePanelID GetRequestPanelID(void){ return mRequestPanelID; }
	inline s32 GetRequestPanelParam(void){ return mRequestPanelParam; }
	inline void SetPanelInitHideWait(bool flag){ mPanelInitHideWait=(flag==true)?1:0; }
	inline bool GetPanelInitHideWait(void){ return mPanelInitHideWait? true : false; }
	inline void SetPanelTermHideWait(bool flag){ mPanelTermHideWait=(flag==true)?1:0; }
	inline bool GetPanelTermHideWait(void){ return mPanelTermHideWait? true : false; }
	inline void SetPanelNoiseCancel(bool flag){ mPanelNoiseCancel=(flag==true)?1:0; }
	inline bool GetPanelNoiseCancel(void){ return mPanelNoiseCancel? true : false; }
	inline void SetPanelCtrlOffWait(bool flag){ mPanelCtrlOffWait=(flag==true)?1:0; }
	inline bool GetPanelCtrlOffWait(void){ return mPanelCtrlOffWait? true : false; }
	inline void SetPanelDeleteWait(bool flag){ mPanelDeleteWait=(flag==true)?1:0; }
	inline bool GetPanelDeleteWait(void){ return mPanelDeleteWait? true : false; }
	inline void SetPanelReleaseCancel(bool flag){ mPanelReleaseCancel=(flag==true)?1:0; }
	inline bool GetPanelReleaseCancel(void){ return mPanelReleaseCancel? true : false; }
	inline PanelModeState GetPanelModeState(void){ return mPanelModeState; }
	inline SK7PanelBase* GetPanel(void){ return mpPanel; }
	inline SK7PanelBase* GetPanelB(void){
		while( mpPanel==NULL ){
			GHMGCTASK_RETSYS();
		}
		return mpPanel;
	}
	bool SetPanel(SK7PanelBase *pPanel);
	inline void SetPanelTermCamera(u32 camera){ mPanelResultCam=camera; }
	
	inline void SetZanPos(const Vec &pos){ mZanPos=pos; }
	inline void GetZanPos(Vec &pos){ pos=mZanPos; }
	inline void SetZanRot(const Vec &Rot){ mZanRot=Rot; }
	inline void GetZanRot(Vec &Rot){ Rot=mZanRot; }
	inline bool SetZanID(u32 id){ mZanID=id; return true; }
	inline u32 GetZanID(void){ return mZanID; }
	inline bool SetZanCamID(u32 id){ mZanCamID=id; return true; }
	inline u32 GetZanCamID(void){ return mZanCamID; }
	inline WK7Zan* GetZan(void){ return mpZan; }
	inline void SetZanInitWait(bool flag){ mZanInitWait=(flag==true? 1:0); }
	inline bool GetZanInitWait(void){ return mZanInitWait? true : false; }
	inline void SetZanExecWait(bool flag){ mZanExecWait=(flag==true? 1:0); }
	inline bool GetZanExecWait(void){ return mZanExecWait? true : false; }
	inline void SetZanTermWait(bool flag){ mZanTermWait=(flag==true? 1:0); }
	inline bool GetZanTermWait(void){ return mZanTermWait? true : false; }
	inline void SetZanTermNoiseWait(bool flag){ mZanTermNoiseWait=(flag==true? 1:0); }
	inline bool GetZanTermNoiseWait(void){ return mZanTermNoiseWait? true : false; }
	inline void SetZanNoiseCancel(bool flag){ mZanNoiseCancel=(flag==true? 1:0); }
	inline bool GetZanNoiseCancel(void){ return mZanNoiseCancel? true : false; }
	inline void SetZanCinemaScopeCancel(bool flag){ mZanCinemaScopeCancel=(flag==true? 1:0); }
	inline bool GetZanCinemaScopeCancel(void){ return mZanCinemaScopeCancel? true : false; }
	inline void SetZanManual(bool flag){ mZanManual=(flag==true? 1:0); }
	inline bool GetZanManual(void){ return mZanManual? true : false; }
	inline void SetZanCharaLoadCancel(bool flag){ mZanCharaLoadCancel=(flag==true? 1:0); }
	inline bool GetZanCharaLoadCancel(void){ return mZanCharaLoadCancel? true : false; }
	inline void SetZanMesID(u32 mesid){ mZanMesID=mesid; }
	inline u32 GetZanMesID(void){ return mZanMesID; }
	inline void SetZanCharaID(u32 chrid){ mZanCharaID=chrid; }
	inline u32 GetZanCharaID(void){ return mZanCharaID; }
	inline ZanState GetZanState(void){ return mZanState; }
	inline void SetZanCharaPresentCancel(bool flag){ mZanCharaPresentCancel=(flag==true? 1:0); }
	inline bool GetZanCharaPresentCancel(void){ return mZanCharaPresentCancel? true : false; }
	bool ReserveZanCharaPresent(u32 tick,int nameID,s16 nameX,s16 nameY,f32 winX,f32 winY,f32 winW,f32 winH,int flag=-1);
	inline void SetZanParam(u32 Param){ mZanParam=Param; }
	inline u32 GetZanParam(void){ return mZanParam; }
	
	inline void SetSpecialEnable(bool flag){ mSpecialEnable=flag; }
	inline bool GetSpecialEnable(void){ return mSpecialEnable; }
	bool SetBossFlag(bool flag);
	inline bool GetBossFlag(void){ return mBossFlag; }
	inline SK7SpOption* GetSpOption(void){ return mpSpOption; }
	inline SK7Special* GetSpecial(void){ return mpSpecial; }
	
#ifdef	_DEBUG
	inline void SetMoonSkip(bool flag){ mMoonSkip=flag; }
	inline bool SetMoonSkip(void){ return mMoonSkip; }
	void SetFlagName(const char **ppFlagName){ mppFlagName = ppFlagName; }
	const char** GetFlagName(void){ return mppFlagName; }
	bool SetVarType(K7EVVarType *pVarType);
	K7EVVarType* GetVarTypeTop(int scnid=-1);
#endif
	
	bool SetMode(Mode mode,bool multi=false);
	inline Mode GetMode(void){ return mMode; }
	bool SetTermState(TermState state);
	inline TermState GetTermState(void){ return mTermState; }
	
	bool SetGlobalFlag(int id);
	bool ResetGlobalFlag(int id);
	int GetGlobalFlag(int id);
	bool ReverseGlobalFlag(int id);
	bool ClearGlobalFlag(void);
	
	bool SetScenarioFlag(int id);
	bool ResetScenarioFlag(int id);
	int GetScenarioFlag(int id);
	bool ReverseScenarioFlag(int id);
	bool ClearScenarioFlag(void);
	
//	bool SetHanaFlag(u32 hanaid,u32 stgid,int scnid=-1);
//	bool SetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid);
//	bool ResetHanaFlag(u32 hanaid,u32 stgid,int scnid=-1);
//	bool ResetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid);
//	int GetHanaFlag(u32 hanaid,u32 stgid,int scnid=-1);
//	int GetHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid);
//	bool ReverseHanaFlag(u32 hanaid,u32 stgid,int scnid=-1);
//	bool ReverseHanaFlag(u32 scnid,u32 stgid,u32 chrid,u32 seqid);
	
	bool SetTaskController(ghmGcTaskController *pTaskController);
	inline ghmGcTaskController* GetTaskController(void){ return mpTaskController; }
	
	inline s32 GetPanelResult(void){ return mPanelResult; }
	
	inline int GetScenarioVarSize(void){ return mScenarioVarSize; }
	void* GetScenarioVar(int scnid);
//	WK7EventItemTable* GetEventItemTable(int scnid=-1);
//	u32* GetItemFlag(int scnid=-1);
	
	bool MapSelectInit(s32 FirstMap,s32 GoolMap,bool ButtonCancel=true);
	bool MapSelectEnd(void);
	bool CheckMapSelectEnd();
	s32 GetMapSelectPoint(void);
	void SetMapSelectValidFlag(u8 MapID,u8 Flag);
	u8 GetMapSelectValidFlag(u8 MapID);
	bool MapRootCreate(s32 StartID,s32 EndID);
	
	bool StageTitleInit(STAGE_TITLE inNo);
	bool StageTitleEnd(void);
	bool CheckStageTitleSetup(void);
	bool CheckStageTitleEndState(void);
	
	void CreateBallet(void);
	void DeleteBallet(void);
	
	inline void SetRenderOptionDisable(bool flag){ mRenderOptionDisable=flag; }
	inline bool GetRenderOptionDisable(void){ return mRenderOptionDisable; }
	bool SetRenderOption(bool flag);
	inline bool GetRenderOption(void){ return mRenderSpOption; }
	bool InitOptionWindow(void);
	bool OptionDemoClose(void);
	
	inline void SetCharaChangeCancel(bool flag){ mCharaChangeCancel=(flag==true? 1:0); }
	inline bool GetCharaChangeCancel(void){ return mCharaChangeCancel? true : false; }
	
	bool GetBattleTask(void);
	inline u16 GetDefaultSE(void){ return mDefaultFootSE; }
	
	// ̃L`FW
	void BloodCharaChange(u32 charaid, int mode=0, int voice=-1);
};

#ifndef	__WK7GAMEINFO_CPP__
extern	WK7GameInfo			GameInfo;
#endif

#ifdef	_DEBUG
#define	WK7GAMEINFO_SETFLAGNAME(name)		GameInfo.SetFlagName(name)
#define	WK7GAMEINFO_SETVARTYPE(type)		GameInfo.SetVarType(type)
#else
#define	WK7GAMEINFO_SETFLAGNAME(name)		
#define	WK7GAMEINFO_SETVARTYPE(type)		
#endif

extern	bool ChangePrioEffect(EFFECT *pEffect,int prio);
extern	bool ChangePrioEffect(EFFECT_TYPE type,int prio);

#endif	//__WK7GAMEINFO_H__

