////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Item Object
//
// WK7Item.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/09/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7ITEM_H__
#define	__WK7ITEM_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include ".\WK7Archive.h"
#include ".\WK7Obj.h"

//
// Item Object
//
class WK7Item : public WK7RenderObj{
	friend class WK7RenderObj;
protected:
	static bool					mRenderItem;
	bool						mStageLight;
	WK7Item();
	WK7Item(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7Item();
	
	inline WK7Item* GetPrev(void){ return (WK7Item *)ghmGcListObj::GetPrev(); }
	inline WK7Item* GetNext(void){ return (WK7Item *)ghmGcListObj::GetNext(); }
	virtual u32 GetMainID(void);
	virtual u32 GetSuffix(void);
	
	static bool GetFileName(char *pFileName,u32 id);
	inline virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	virtual bool Initialize(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	virtual bool DispLight(u32 mirrorType=0,Vec *pPos=NULL);
	
	inline void SetStageLight(bool flag){ mStageLight = flag; }
	inline bool GetStageLight(void){ return mStageLight; }
	
	static bool CreateStaticArchive(u32 id);
//	static bool ReleaseArchive(u32 id);
	static bool SetRenderItem(bool flag){ mRenderItem=flag; return true; }
	static bool GetRenderItem(void){ return mRenderItem; }
};

//
// Item Motion Object
//
class WK7ItemMotion : public WK7MotionObj{
	friend class WK7MotionObj;
protected:
	WK7ItemMotion();
	WK7ItemMotion(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7ItemMotion();
	
	inline WK7ItemMotion* GetPrev(void){ return (WK7ItemMotion *)ghmGcListObj::GetPrev(); }
	inline WK7ItemMotion* GetNext(void){ return (WK7ItemMotion *)ghmGcListObj::GetNext(); }
	
	static bool GetFileName(char *pFileName,u32 id);
	virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	static bool CreateStaticArchive(u32 id);
};

#endif	//__WK7ITEM_H__

