////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Main Task
//
// WK7MainTask.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7MAINTASK_CPP__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\WK7MainTask.h"
#include ".\WK7MainMenu.h"
#include ".\WK7TestTask.h"
#include ".\WK7MenuTask.h"
#include ".\WK7Script.h"
#include ".\WK7Play.h"
#include ".\WK7Mirror.h"
#include ".\WK7Shadow.h"
#include ".\WK7Sight.h"
#include "..\Fujita\C_Font.h"
#include ".\K7App.h"
#include "..\Fujita\C_Shader.h"
#include "..\Yam\YK7EffectHeader.h"
#include "..\Yam\YK7CharChange.h"
#include ".\WK7Npc.h"
#include ".\WK7SceneBlur.h"
#include ".\WK7HitObj.h"
#include ".\WK7Memo.h"
#include ".\WK7DeadBodySign.h"
#include ".\WK7CharaPresent.h"
#include ".\WK7EffectBreakObj.h"
#include ".\WK7Archive.h"
#include ".\WK7Cam.h"
#include ".\WK7AfterImage.h"
#include ".\WK7Light.h"
#include ".\WK7Chara.h"
#include ".\WK7Player.h"
//#include ".\WK7Enemy.h"
#include ".\WK7Stage.h"
#include ".\WK7Item.h"
#include ".\WK7GameInfo.h"
#include ".\WK7Path.h"
#include ".\WK7SelectIF.h"
#include ".\WK7ScreenImage.h"
#include ".\WK7Fog.h"
//#include "..\Fujita\C_Perf.h"
//#include "..\Fujita\C_LObj.h"
//#include "..\Fujita\C_Particle.h"
//#include "..\Fujita\C_Mirror.h"
#include "..\Matsu\mK7Proc.h"

#include "..\Kaw\KK7BattleCtrl.h"
#include "..\Matsu\MK7TitleTask.h"
#include "..\Sato\SK7LogoTask.h"
#include "..\Sato\SK7Special.h"
#include "..\Sato\SK7Pack.h"
#include "..\Sato\SK7LoadTask.h"
#include "..\Sato\SK7EndSaveTask.h"
#include "..\Sato\SK7NextTask.h"
#include ".\WK7Event.h"
#include ".\WK7EventScript.h"
#if FUJITA
#include "..\Fujita\c_radialblur.h"
#include "..\Fujita\c_impulse.h"
#include "..\Fujita\c_brokenglass.h"
#endif
#include ".\K7GlobalFlag.h"


#define	MAINMENU

#ifndef	_DEBUG
#undef	MAINMENU
#endif


//#define	PRESENTATION
#define	DEBUG_SHADOW

#if	defined(K7APP_MASTER) && !defined(PRESENTATION)
//#define	PRESENTATION
#undef	DEBUG_SHADOW
#endif

WK7MainTask* WK7MainTask::mpMainTask = NULL;
ghmGcTaskController* WK7MainTask::pMFrameProcessTaskController = NULL;
ghmGcTaskController* WK7MainTask::pMRenderProcessTaskController = NULL;


// tJ[XN[C[W
WK7ScreenImage				screenImageFullColor;

// mg[J[XN[C[W
WK7ScreenImage				screenImageMonoColor;

// u[C[W
WK7ScreenImage				blurScreenCImage;
WK7ScreenImage				blurScreenZImage;

//#define	SHADOW

#define	DRAWTEXFMT		GX_TF_RGBA8
//#define	DRAWTEXFMT		GX_TF_I8

int	WK7MainTask::mTaskID = -1;

void	*gpGlassTpl = NULL;

bool WK7MainTask::InitializeCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	
//	K7AppOSDumpMemoryType(1);
//	K7AppDumpMemoryType(1);
	
	WK7MainTask::mTaskID = GetID();
	
#ifdef	K7APP_MASTER
	k7app.SetFadeColor(0xff000000);
	k7app.FadeStart(0xff,0);
#endif
	
	OSDebugReport("WK7MainTask Init : Heap = 0x%08x,0x%08x, TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),k7app.SmallGetFreeSize(),sizeof(*this));
	
	GXColor		clearclr = { 0x00,0x00,0x00,0x00 };
//	GXColor		clearclr = { 0x00,0x00,0x00,0xff };
//	GXColor		clearclr = { 0x40,0x00,0x00,0x00 };
	HSD_VISetClearClr(clearclr);
	screenImageFullColor.SetClearColor(clearclr);
	
#if 0
	{
		ghmGcFile		file;
		if( file.Open("/Wat/glasstex.tpl")==true ){
			gpGlassTpl = file.ReadB();
			file.Close();
		}
	}
#endif
	
	ghmGcMem::SetRender(false);
	k7app.SetVisiblePerfMeter(false);
	k7app.SetEnablePerfMeter (false);
	WK7CAM->SetCinemaScopeMode(false);
	WK7CAM->SetCinemaScopeAdjust(true);
	
	WK7EffectBreakObj::Clear();
	WK7Fog::Initialize();
	WK7RenderObj::InitializeAll();
	WK7CAM->SetWobbleEnable(true);
	WK7CharaPresent::Initialize();
	
	// ^XNRg[
	mFrameProcessTaskController.Initialize();
	mRenderProcessTaskController.Initialize();
	WK7HitObj::SetDefaultTaskController(&mFrameProcessTaskController);
	
	GameInfo.InitScenario();
	GameInfo.SetTaskController(&mFrameProcessTaskController);
	
#ifdef	MAINMENU
	mainMenu.Initialize();
	mainMenu.SetFrameProcessTaskController(&mFrameProcessTaskController);
#if	!defined(K7APP_MASTER) && (!defined(K7APP_MODEINFO) || (defined(K7APP_MODEINFO) && K7APP_MODEINFO!=0 ))
	
#ifndef	USE_ISDOLVIEWER
	mainMenu.SetModeInfo(true);
#else
//	if( !GETCAPTUREMODE() ){
//		mainMenu.SetModeInfo(true);
//	}
#endif
	
#endif
	
#endif
	
	// L
	WK7Play::Initialize();
	
	// 
	WK7Memo::Initialize();
	
#ifdef	_DEBUG
	if( (mCallScenarioID = GameInfo.GetScenarioID())==K7SCN_UNKNOWN ){
		GameInfo.SetScenarioID(K7SCN99);
	}
#endif
	
	// p[eBNVXȅ
//	USE_PARTICLE;
	
//	// GtFNg
//	EffectInit(&mRenderProcessTaskController,WK7MAINTASK_SCREENCAPTURE_TASK_PRIO);
//	
//	// JIuWFNg̃Zbg
//	SetEffectCamera(WK7CAM->GetCObj());
//	
//	//쐬̏
//	mK7InitProc();
//	
//	if( (g_pSpData = new SK7SpecialData)!=NULL ){
//		g_pSpData->Initialize();
//	}
	
//	WK7DeadBodySign::LoadTexture();
	
	// ogRg[[
	BattleCtrl.InitScenario();
	
	// vC[Rg[
	WK7PLAYERCONTROL->Initialize();
	// vC[Rg[ViI
	WK7PLAYERCONTROL->ScenarioReset();
	
	WK7Stage::Clear();
	
	// CxgRg[
	WK7EVENTCONTROLLER->Initialize();
	WK7EVENTCONTROLLER->SetTaskController(&mFrameProcessTaskController,&mRenderProcessTaskController);
//	WK7EVENTCONTROLLER->LoadStaticData();
	
	// Jݒ --------------------------------------------------------------
	WK7CAM->SetRenderFlag(true);
	
#ifdef SHADOW
	// e𔭐郉CgB
	mShadow.SetLight (mpShadowLObj);
	// e𔭐IuWFNgB
	mShadow.AddObject(mpOperateChara->GetCJObj());
//	mShadow.AddObject(     pEnemy[0]->GetCJObj());
//	mShadow.AddObject(     pEnemy[1]->GetCJObj());
//	mShadow.AddObject(     pEnemy[2]->GetCJObj());
	// e󂯂IuWFNgB
//	mShadow.SetShadow(mpOperateChara->GetJObj());
//	mShadow.SetShadow(pStage->GetJObj());
#endif
	
	WK7RenderObj::GetVFX();
	
	WK7Npc::InitializeAll();
	
//	WK7Sight::LoadTexture("Wat/Sight.bin");
//	WK7Sight::Initialize();
	// ƃCM[
//	WK7Sight::LoadTexture("Wat/Sight.bin");
//	WK7SIGHT->SetVisible(true);
	WK7SIGHT->SetPosition(320.0f,240.0f);
	
	// mobAuew VFX vfx ɂ ɂ c
#define VFX_GUNYO_PARAM		(0.06f)
	WK7RenderObj::SetVfxFlag(true);
	WK7RenderObj::VFXSetIntensity(VFX_GUNYO_PARAM);
	
	WK7SHADOW->SetEnable(true);
	
	SceneBlur.CreateScreen( 2.0f, 0.0f,200.0f,0x40);
	SceneBlur.CreateScreen( 0.0f, 2.0f,200.0f,0x40);
	SceneBlur.CreateScreen(-2.0f, 0.0f,300.0f,0x40);
	SceneBlur.CreateScreen( 0.0f,-2.0f,300.0f,0x40);
	
//	if( mpScenarioSSM != NULL ){
//		gpSound->mReadSsm((char*)mpScenarioSSM,eBankScenario);
//	}
	
	mPreScreenCaptureTaskID   = mRenderProcessTaskController.Start(_PreScreenCaptureTask  ,(u32)this,0,NULL,-1,WK7MAINTASK_PRE_SCREENCAPTURE_TASK_PRIO  );
	mScreenCaptureTaskID      = mRenderProcessTaskController.Start(_ScreenCaptureTask     ,(u32)this,0,NULL,-1,WK7MAINTASK_SCREENCAPTURE_TASK_PRIO      );
	mPostScreenCaptureTaskID  = mRenderProcessTaskController.Start(_PostScreenCaptureTask ,(u32)this,0,NULL,-1,WK7MAINTASK_POST_SCREENCAPTURE_TASK_PRIO );
	mPostScreenCapture2TaskID = mRenderProcessTaskController.Start(_PostScreenCapture2Task,(u32)this,0,NULL,-1,WK7MAINTASK_POST_SCREENCAPTURE2_TASK_PRIO);
//	mLastFrameProcessTaskID   = mFrameProcessTaskController .Start(_LastFrameProcessTask  ,(u32)this,0,NULL,-1,WK7MAINTASK_LAST_FRAMEPROCESS_TASK_PRIO  );
	
	WK7SELECTIF->Initialize();
	
	WK7Stage::SetRenderStage(true);
	WK7Chara::SetRenderChara(true);
	WK7Item::SetRenderItem  (true);
	
	GameInfo.SetMode(WK7GameInfo::INIT);
	K7SCR_ENTER_PLAYMODE();
	K7SCR_ENTER_DEMOPAUSE();
	
	return true;
}

bool WK7MainTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();

	//	Xe[WNÂƂɃZ[uf[^ۑ(zbp[V̂Ƃ͂Ȃj
	if( GameInfo.GetTermState()==WK7GameInfo::TERMSTATE_CLEAR ){
		if( K7SCR_GET_GLOBAL_FLAG( K7GLFL_HOPPER7 )!=true ){
			K7SCR_SET_GLOBAL_FLAG(K7GLFL_SCENARIO_CLEAR);
			ghmGcMemSetAllocName("MAINSAVE");
			g_pSaveData = new SK7SaveData;		
			GameInfo.GetSpOption()->SetBloodGauge( BP_THICK, 0 );
			GameInfo.GetSpOption()->SetBloodGauge( BP_THIN, 0 );
			//	SNÂƂɌJ
			if( GameInfo.GetScenarioID()==K7SCN06 ){	
				GameInfo.GetSpOption()->SetBloodGauge( BP_SERUM, 0 );
			}
			BattleCtrl.SetBpGauge( BP_THICK,0 );
			BattleCtrl.SetBpGauge( BP_THIN, 0 );
			K7EVENT_GL_VAR(SpBloodThick) 	= 0;
			K7EVENT_GL_VAR(SpBloodThin)		= 0;
			GameInfo.StoreSaveData( g_pSaveData );
		}else{
			//zbp[V͌̊Ĵ
			GameInfo.GetSpOption()->SetBloodGauge( BP_THICK, 0 );
			GameInfo.GetSpOption()->SetBloodGauge( BP_THIN, 0 );
			GameInfo.GetSpOption()->SetBloodGauge( BP_SERUM, 0 );
		}
	}
	
	WK7EffectBreakObj::Clear();
	
//	if( mpScenarioSSM != NULL ){
//		gpSound->mReleaseSsm((char*)mpScenarioSSM);
//		mpScenarioSSM = NULL;
//	}
	
	if( mPreScreenCaptureTaskID  >= 0 ){
		mRenderProcessTaskController.Stop(mPreScreenCaptureTaskID );
		mPreScreenCaptureTaskID   = -1;
	}
	if( mScreenCaptureTaskID     >= 0 ){
		mRenderProcessTaskController.Stop(mScreenCaptureTaskID    );
		mScreenCaptureTaskID      = -1;
	}
	if( mPostScreenCaptureTaskID >= 0 ){
		mRenderProcessTaskController.Stop(mPostScreenCaptureTaskID);
		mPostScreenCaptureTaskID  = -1;
	}
	if( mPostScreenCapture2TaskID >= 0 ){
		mRenderProcessTaskController.Stop(mPostScreenCapture2TaskID);
		mPostScreenCapture2TaskID  = -1;
	}
	if( mLastFrameProcessTaskID   >= 0 ){
		mFrameProcessTaskController.Stop(mLastFrameProcessTaskID);
		mLastFrameProcessTaskID   = -1;
	}
	
	WK7SELECTIF->Terminate();
	
	gpSound->mStopStream();
	
	// vC[Rg[I
	WK7PLAYERCONTROL->Terminate();
	
	// mob
	WK7Npc::ReleaseAll();
	WK7Npc::TerminateAll();
	
//	WK7Sight::Terminate();
	
	// ~[
//	FreeMirror();
	
	// ogRg[[J
	BattleCtrl.ReleaseScenario();
	
	// I
	WK7Memo::Terminate();
	
	// LI
	WK7Play::Terminate();
	
	SceneBlur.ReleaseScreenAll();
	
#ifdef	MAINMENU
	mainMenu.Terminate();
#endif
	
	WK7CharaPresent::Terminate();
	
	WK7Stage::DeleteStageAll();
	WK7RenderObj::ReleaseAll();
	WK7MotionObj::ReleaseAll();
	
	WK7EVENTCONTROLLER->ReleaseDynamicData();
	WK7EVENTCONTROLLER->ReleaseStaticData();
	
	WK7Archive::ReleaseDynamicAll();
	
	WK7RenderObj::TerminateAll();
	WK7Fog::Terminate();
	
	// ^XNRg[I
	WK7HitObj::SetDefaultTaskController(NULL);
	mFrameProcessTaskController.Terminate();
	mRenderProcessTaskController.Terminate();
	
	// CxgRg[I
	WK7EVENTCONTROLLER->Terminate();
	
	GameInfo.Terminate();
	GameInfo.SetTaskController(NULL);
	
	WK7MainTask::mTaskID = -1;
	
#ifdef	_DEBUG
	if( mCallScenarioID==K7SCN_UNKNOWN ){
		GameInfo.SetScenarioID(mCallScenarioID);
	}
#endif
	GameInfo.SetContinue(false);
	
#ifdef	_DEBUG
	bool		termMenu = mTermMenu;
//	termMenu = true;
#endif
	
	delete this;
	
	GHMGCMEM_SAFE_FREE(gpGlassTpl);
	
	C_Font::C_Line::DeleteAll();
	K7AppDebugPrintDelete();
	
	WK7Stage::Clear();
	
	screenImageFullColor.FreeBuffer();
	screenImageMonoColor.FreeBuffer();
	
	WK7Stage::SetRenderStage(true);
	WK7Chara::SetRenderChara(true);
	WK7Item::SetRenderItem  (true);
	
//	K7AppOSDumpMemoryType(1);
//	K7AppDumpMemoryType(1);
	
//	new WK7TestTask(pApp);
#ifdef	_DEBUG
	if( termMenu==true ){
		ghmGcMemSetAllocName("MenuTask");
		new WK7MenuTask(pApp);
	}else
#endif
	{
		K7SCR_RESET_GLOBAL_FLAG(K7GLFL_SCENARIO_CLEAR);
		switch( GameInfo.GetTermState() ){
		case	WK7GameInfo::TERMSTATE_CLEAR:
			if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_HOPPER7)==true ){
				ghmGcMemSetAllocName("LogoTask");
				new SK7NextTask(pApp);
			}else
			if( GameInfo.GetScenarioID()!=K7SCN06 ){
				K7SCR_SET_GLOBAL_FLAG(K7GLFL_SCENARIO_CLEAR);
				ghmGcMemSetAllocName("NextTask");
				new SK7NextTask(pApp);
			}else{
				ghmGcMemSetAllocName("EndSaveTask");
				new SK7EndSaveTask(pApp);
			}
			break;
		case	WK7GameInfo::TERMSTATE_GAMEAGAIN:
			ghmGcMemSetAllocName("LoadTask");
			new SK7LoadTask(pApp);
			break;
		default:
			ghmGcMemSetAllocName("LogoTask");
			new SK7LogoTask(pApp);
			break;
		}
	}
	
	// 킴ƌ󂫍쐬
//	void *pTestMem[2];
//	pTestMem[0] = ghmGcMemAlloc(2 * 1024 * 1024);
//	pTestMem[1] = ghmGcMemAlloc(     100 * 1024);
//	GHMGCMEM_SAFE_FREE(pTestMem[0]);
	
#if	!defined(ORBITAL) && !defined(USE_ISDOLVIEWER)
	K7AppDumpMemory();
#endif
	
	return true;
}

#include "..\Yam\YK7EffectSkill.h"
bool WK7MainTask::FrameProcess(void)
{
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	if( GameInfo.GetMode()==WK7GameInfo::TERM ){
		DeleteTerminate();
		return true;
	}
	
//static	int	komaokuri = 0;
//	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//		komaokuri ^= 1;
//	}
//	if( komaokuri ){
//		if( !(HSD_PadGetTrigger(1) & HSD_PAD_A) ){
//			return true;
//		}
//	}
	
#if !defined(K7APP_MASTER_NINTENDO) && !defined(_DEBUG)
	if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
		WK7PLAYERCONTROL->StageParamSet(1);
	}
#endif
	
#ifdef	K7APP_DEBUG
#if 1
	// 퓬[h
//	if( HSD_PadGetTrigger(0) & PAD_TRIGGER_R ){
//#ifdef	_DEBUG
//		if( WK7CAM->GetMode()!=WK7Cam::WK7CAM_DEBUG )
//#endif
////		battleMain.BattleMainTaskStart(GetCamera(), &mFrameProcessTaskController, &mRenderProcessTaskController);
//		;
//	}
#ifndef	PRESENTATION
	// fobOJ؂ւ
	if( (HSD_PadGetButton(0) & HSD_PAD_LEFT) && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
//	if( (HSD_PadGetButton(0) & HSD_PAD_Y) && (HSD_PadGetTrigger(0) & HSD_PAD_START) ){
		if( WK7CAM->IsDebugMode()==true ){
			WK7CAM->ExitDebugMode();
		}else{
			WK7CAM->EnterDebugMode();
		}
	}
	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
		WK7SelectItem::SetTargetCircleVisible(WK7SelectItem::GetTargetCircleVisible()==false);
	}
#endif
#endif
#endif
	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//		WK7CAM->SetCinemaScopeMode(WK7CAM->GetCinemaScopeMode()==true? false : true);
//	}
//	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//		WK7Play		*pPlay = WK7Play::CreateB("00020711");
//		pPlay->Start();
//	}
	
#ifdef	MAINMENU
	bool	menuActive = mainMenu.IsActive();
	
	mainMenu.FrameProcess();
	
	if( mainMenu.IsActive()==true || menuActive==true ){
		if( mainMenu.GetChangeFlowProc() > 0 ){
			goto forced_mainprocess;
		}
		if( mainMenu.GetDumpStageInfoProc() >= 0 ){
			goto forced_mainprocess;
		}
		if( mainMenu.IsTermRequested()==true ){
#ifdef	_DEBUG
			mTermMenu = true;
#endif
			if( DeleteTerminate()==true ){
				return true;
			}
		}
		return true;
	}
#endif
	
forced_mainprocess:
	int		i = WK7_FRAME_COUNT;
	while( i-- ){
		PARTICLE.Proc( GetEffectCamera() );
	}
	
#ifdef	_DEBUG
#ifndef	K7APP_MASTER
//	if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
//		K7AppDumpMemory();
//	}
#endif
#endif
	
#if 0
	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
static	u32		tick = WK7_TICK_PER_SEC / 2;
		if( afterImage.GetEnable()==true ){
			afterImage.SetEnable(false);
			afterImage.SetEnableAfterImage(false);
			afterImage.SetBackIntensity(0xff,0);
		}else{
			afterImage.SetEnable(true);
			afterImage.SetEnableAfterImage(false);
			afterImage.SetBackIntensity(0,WK7_TICK_PER_SEC);
		}
	}
#endif
	
	GameInfo.FrameProcess();
	
	screenImageFullColor.FrameProcess();
	screenImageMonoColor.FrameProcess();
	afterImage.FrameProcess();
	
	// ogRg[
	BattleCtrl.FrameProcess();
	
	// mob_[W菈
	WK7Npc::DamageCheckProcessAll();
	
//#ifdef	USE_USB
#ifndef	K7APP_MASTER
//	if( HSD_PadGetTrigger(1) & HSD_PAD_UP ){
//		Vec	pos;
//		pos.x = 0.0f;
//		pos.y = 0.0f;
//		pos.z = 0.0f;
//		WK7PLAYERCONTROL->SetPcDamage(pos,10);
//	}
#endif
	
	// vC[Rg[
	WK7CAM->SetCurrent();
	WK7PLAYERCONTROL->FrameProcess();
	
	// mobRg[
	WK7Npc::ControlProcessAll();
	
	// L
	WK7Play::FrameProcessAll();
	
	// IC^[tFCX
	WK7SELECTIF->FrameProcess();
	
	// J
	WK7CAM->FrameProcess();
	WK7CAM->SetCurrent();
//	{
//		Vec		tgt;
//		WK7CAM->GetTargetPosition(tgt);
//		WK7PLAYERCONTROL->SetLookAtPosition(&tgt);
//	}
	
	// A[JCuRg[
	WK7Archive::FrameProcessAll();
	
	// [VIuWFNg
	WK7MotionObj::FrameProcessAll();
	
	// _OIuWFNg
	WK7RenderObj::FrameProcessAll();
	
	// VhE{[
	WK7RenderObj::FrameProcessEdgeShadow();
	
	//쐬̃t[
	mK7FrameProc();
	
	if( g_pSpData!=NULL ){
		g_pSpData->FrameProcess();
	}
	if( g_pStageData!=NULL ){
		g_pStageData->FrameProcess();
	}
	
	// mobt[
	WK7Npc::FrameProcessAll();
	
	// ~[t[
	WK7Mirror::FrameProcessAll();
	
	// ^XNRg[
	mFrameProcessTaskController.FrameProcess();
	
#ifndef	K7APP_MASTER
//	if( HSD_PadGetTrigger(1) & HSD_PAD_UP ){
//		static Vec	sparkPos = { 0.0f,0.0f,0.0f };
//		CreateMskSparkBom(sparkPos);
//	}
#endif
	
	// GtFNg
	WK7RenderObj::VFXProc();
	
	// TCg
	WK7SIGHT->FrameProcess();
	
	gMask.FrameProcess();
	
	// LN^`FŴPt[̏s
	FrameProcessCharChange();
	
	WK7Memo::LoadProcess();
	
	// CxgRg[
	WK7EVENTCONTROLLER->FrameProcess();
	
	WK7CharaPresent::FrameProcessAll();
	
	WK7EffectBreakObj::FrameProcessAll();
#if FUJITA
	IMPULSE.Proc();
#endif
	
	WK7CAM->SetCurrent();
	
	// DCg
	WK7RenderObj::PrivateLightProcessAll();
	
	// Cg
	WK7Light::FrameProcessAll();
	
	// ԕύX
	WK7RenderObj::StateProcessAll();
	
	// eẽt[
	WK7SHADOW->FrameProcess();
	
#ifndef	K7APP_MASTER
//	{
//		f32		dist = WK7SIGHT->GetPeekDist();
//		C_Paper	paper(32,240);
//		PRINTF("dist = %.3f\n",dist);
//	}
#endif
	
	return true;
}

bool WK7MainTask::LastFrameProcessTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	return true;
}

void WK7MainTask::_LastFrameProcessTask(ghmGcTask *pTask)
{
	WK7MainTask		*pMainTask = (WK7MainTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pMainTask->LastFrameProcessTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

#define	SETDSTOKEN(id)			SETDS(MAINTASK_TH|(id),NULL)
bool WK7MainTask::PreRenderProcess(void)
{
	
	SETDSTOKEN(0x00);
	
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	if( GameInfo.GetMode()==WK7GameInfo::TERM ){
		return true;
	}
	
	HSD_StartRender(HSD_RP_SCREEN);
	
	//eeNX`쐬B
#ifdef SHADOW
	Vec		org;
	org.x = 0.0f;
	org.y = 0.0f;
	org.z = 0.0f;
	mpOperateChara->GetPosition(org);
	mShadow.SetCamera( org, 1000.0f );
//	mShadow.SetCamera( mpCurrentStage->GetCCObj()->GetInterest(), 1000 );
//	f32 r=25.0f;
	f32 r=15.0f;
	mShadow.InitViewingRect( r,-r,-r,r );
	mShadow.AddViewingRect( r,-r,-r,r );
	mShadow.CheckViewingRect();
	mShadow.StartRenderShadow();
	mShadow.EndRenderShadow();
#endif
	
	// LN^`FW݂̌̏Ԃ`悷
//	RenderProcessCharChange();
//	if( GetCharChangeState()==TRUE ){
//		screenImageFullColor.ScreenCopy();
//		// sysdolphinԖ
//		HSD_StateInvalidate(HSD_STATE_ALL);
//		GXSetClipMode(GX_CLIP_ENABLE);
//	}
	
	SETDSTOKEN(0x01);
	
	if( WK7CAM->SetCurrent()==true ){ 
		
		WK7SHADOW->RenderProcess();
		
		WK7CAM->EndCurrent();
	}
	
	SETDSTOKEN(0x02);
	
	if( WK7CAM->SetCurrent()==true ){ 
		
		// ~[_O
		WK7Mirror::RenderProcessAll();
		
		WK7CAM->EndCurrent();
	}
	
//	for(int i=0 ; i<mMirrorNum ; i++){
//		if( MirrorDispStart(i)==true ){
//			
//			// _OIuWFNg
//			WK7RenderObj::RenderProcessAll();
//			
//			MirrorDispEnd(i);
//			
//		}
//	}
	
	SETDSTOKEN(0x03);
	
#if FUJITA
	if( WK7CAM->SetCurrent()==true ){ 
		
		// {Xp̃sJsJ
		C_RadialBlur::RenderProcessAll();
		
		WK7CAM->EndCurrent();
	}
#endif

	HSD_EndRender();
	
	return true;
}

bool WK7MainTask::RenderProcess(void)
{
	SETDSTOKEN(0x10);
	
	if( GameInfo.GetMode()==WK7GameInfo::TERM ){
		return true;
	}
	
	if( ghmGcFile::IsDiskStandby()==false ){
		goto skip_mainrender;
	}
	
	afterImage.PreRenderProcess();
	
	if(gpMovie!=NULL)gpMovie->mRender();	//[r[_O
	
	GXSetZTexture(GX_ZT_DISABLE,GX_TF_Z24X8,0);
	
	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	HSD_StateSetDither(TRUE);
	HSD_StateSetZCompLoc(GX_TRUE);
	
	HSD_SetZSortMode(true,true);
//	HSD_SetZSortMode(true,false);
	
	// JgJݒ
	if( WK7CAM->SetCurrent()==true ){
		
		// Jݒ肪\L̈Ȃ`
		
		SETDSTOKEN(0x11);
		
		// _OIuWFNg
		WK7RenderObj::RenderProcessAll();
		
		SETDSTOKEN(0x12);
		
		WK7Light::DispStart();
		WK7Light::DispAll();
		WK7Light::DispEnd();
		
		WK7PLAYERCONTROL->RenderProcess();
		
		SETDSTOKEN(0x13);
		
#if FUJITA
//		IMPULSE.Disp( screenImageFullColor.GetTexObj() );
//		IMPULSE.Disp( WK7RenderObj::GetVFX()->GetTexObj() );
#endif
		
		// J
		WK7CAM->RenderProcess();
		
		SETDSTOKEN(0x14);
		
		WK7EffectBreakObj::RenderProcessAll();
		
		SETDSTOKEN(0x15);
		
		WK7Stage::RenderDeadBodySignAll();
		
		SETDSTOKEN(0x16);
		
		// JgJł̕`I
		WK7CAM->EndCurrent();
		
		SETDSTOKEN(0x17);
		
		// p[eBNVXe̕`
		PARTICLE.Disp() ;
		
		SETDSTOKEN(0x18);
		
#if FUJITA
		HSD_FogSet( 0 );	  
#endif

	}
	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
//		k7app.ScreenCapture();
//	}
//	if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
//		k7app.ScreenCapture(CAPTURE_RGBA);
//	}
	
#ifndef	PRESENTATION
//	if( HSD_PadGetTrigger(1) & HSD_PAD_LEFT ){
//		WK7Npc::SetSilhouetteAll(WK7Npc::GetSilhouetteAll()==false);
//	}
//	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
//		WK7RenderObj::SetVfxFlag(WK7RenderObj::GetVfxFlag()==false);
//	}
//	
//	if( HSD_PadGetButton(1) & HSD_PAD_UP ){
//		WK7RenderObj::VFXAddIntensity(0.0625f);
//	}
//	if( HSD_PadGetButton(1) & HSD_PAD_DOWN ){
//		WK7RenderObj::VFXAddIntensity(-0.0625f);
//	}
	
//	{
//		f32 aa;
//		aa = WK7RenderObj::VFXGetIntensity();
//	}
	
#endif
	
	// eNX`Rs[
//	WK7RenderObj::VFXCopyTex();
//	// GtFNg`
//	GXPixModeSync();
//	WK7RenderObj::VFXDisp   ();
	
#if 0
	C_ScreenTone	tone( 480-260, 0, 486-255 );
	HSD_StateSetDither(GX_TRUE);
	HSD_StateSetZMode(GX_TRUE,GX_ALWAYS,GX_FALSE);
	tone.Disp();
#endif
	
skip_mainrender:
	// ^XNRg[
	mRenderProcessTaskController.FrameProcess();
	
	WK7Sight::DrawSyncToken();
	
//	WK7Sight::WaitSyncToken();
	
#if	defined(_DEBUG) && defined(USE_USB)
//	if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
//		k7app.ScreenCapture();
//	}
#endif
	
	return true;
}

// XN[Lv`[OiɂRcnj
bool WK7MainTask::PreScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	SETDSTOKEN(0x20);
	
	gMask.RenderProcess();
	
	SETDSTOKEN(0x21);
	
	screenImageFullColor.RenderProcess(false);
	screenImageMonoColor.RenderProcess(false);
	
	SETDSTOKEN(0x22);
	
	GameInfo.PreScreenCaptureRenderProcess();
	
	SETDSTOKEN(0x23);
	
	afterImage.RenderProcess();
	
	SETDSTOKEN(0x24);
	
	return true;
}

void WK7MainTask::_PreScreenCaptureTask(ghmGcTask *pTask)
{
	WK7MainTask		*pMainTask = (WK7MainTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pMainTask->PreScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

// XN[Lv`[
bool WK7MainTask::ScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	SETDSTOKEN(0x30);
	
	RenderProcessCharChange();
	
	SETDSTOKEN(0x31);
	
#if 1
	if( WK7RenderObj::InitEdgeShadowAll()==true ){
		if( WK7CAM->SetCurrent()==true ){
			// {[VhE`
			WK7RenderObj::RenderEdgeShadowAll();
			WK7CAM->EndCurrent();
		}
		// {[VhEhԂ
		WK7RenderObj::RenderEdgeShadowPaint();
	}
#endif
	
	SETDSTOKEN(0x32);
	
	WK7CAM->RenderCinemaScopeFrame(true);
	
	SETDSTOKEN(0x33);
	
	GameInfo.RenderProcess();
	
	SETDSTOKEN(0x34);
	
	// XN[Rs[
	screenImageFullColor.ScreenCopy();
	screenImageMonoColor.ScreenCopy();
	
	SETDSTOKEN(0x35);
	
#ifdef	_DEBUG
//	if( !GETCAPTUREMODE() ){
	if( !GETPS2MODE() ){
#endif
	WK7RenderObj::VFXDisp   ();
#ifdef	_DEBUG
	}
#endif
	
	SETDSTOKEN(0x36);
	
	// i{P
	SceneBlur.RenderProcess(screenImageFullColor.GetTexObj());
	
	SETDSTOKEN(0x37);
	
	return true;
}

void WK7MainTask::_ScreenCaptureTask(ghmGcTask *pTask)
{
	WK7MainTask		*pMainTask = (WK7MainTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pMainTask->ScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
		
	}
}

// XN[Lv`[㏈iɂQcnj
bool WK7MainTask::PostScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	SETDSTOKEN(0x40);
	
	if( ghmGcFile::IsDiskStandby()==true ){
	
		screenImageFullColor.RenderProcess(true);
		screenImageMonoColor.RenderProcess(true);
		
	}
	
	SETDSTOKEN(0x41);
	
	GameInfo.PostScreenCaptureRenderProcess();
	
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	SETDSTOKEN(0x42);
	
	// TCg_O
	WK7SIGHT->RenderProcess();
	
	SETDSTOKEN(0x43);
	
	// IC^[tFCX_O
	WK7SELECTIF->RenderProcess();
	
	SETDSTOKEN(0x44);
	
//	if( WK7PLAYERCONTROL->GetVitalEffect() != NULL ){
//		screenImageFullColor.ScreenCopy();
//	}
	
	WK7CharaPresent::RenderProcessAll();
	
	SETDSTOKEN(0x45);
	
	WK7Play::RenderProcessAll();
	
	SETDSTOKEN(0x46);
	
	//쐬̃_[
	mK7RenderProc();
	
	SETDSTOKEN(0x47);
	
	WK7Npc::RenderProcessAll();
	
	SETDSTOKEN(0x48);
	
#ifdef	MAINMENU
	mainMenu.RenderProcess();
#endif
	
	SETDSTOKEN(0x49);
	
	HSD_StateInvalidate(HSD_STATE_ALL);
	
#ifdef	MAINMENU
#ifdef	DEBUG_SHADOW
	if( mainMenu.GetDispShadow()==true ){
		WK7SHADOW->GetShadow()->DrawTex();
	}
#endif
#endif
	
	SETDSTOKEN(0x4a);
	
	return true;
}

void WK7MainTask::_PostScreenCaptureTask(ghmGcTask *pTask)
{
	WK7MainTask		*pMainTask = (WK7MainTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pMainTask->PostScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

bool WK7MainTask::PostScreenCapture2Task(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	if( ghmGcFile::IsDiskStandby()==false ){
		return true;
	}
	
	SETDSTOKEN(0x50);
	
	GameInfo.PostScreenCaptureRenderProcess2();
	
	SETDSTOKEN(0x51);
	
	return true;
}

void WK7MainTask::_PostScreenCapture2Task(ghmGcTask *pTask)
{
	WK7MainTask		*pMainTask = (WK7MainTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pMainTask->PostScreenCapture2Task(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

WK7MainTask::WK7MainTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	mpMainTask     = this;
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageMonoColor.SetFormat(GX_TF_I8);
	screenImageFullColor.AllocBuffer();
	screenImageMonoColor.AllocBuffer();
//	blurScreenCImage    .SetFormat(GX_TF_RGB5A3);
//	blurScreenCImage    .AllocBuffer();
//	blurScreenCImage    .ScreenCopy();
//	blurScreenZImage    .SetFormat(GX_TF_Z24X8);
//	blurScreenZImage    .AllocBuffer();
//	blurScreenZImage    .ScreenCopy();
//	mppMirror  = NULL;
//	mMirrorNum = 0;
#ifdef	_DEBUG
	mCallScenarioID = -1;
	mTermMenu       = false;
#endif
	pMFrameProcessTaskController	= &mFrameProcessTaskController;
	pMRenderProcessTaskController	= &mRenderProcessTaskController;
//	afterImage.SetClearColor(0x00004000);
	afterImage.SetClearColor(0x00000000);
	afterImage.SetEnable(false);
	mPreScreenCaptureTaskID   = -1;
	mScreenCaptureTaskID      = -1;
	mPostScreenCaptureTaskID  = -1;
	mPostScreenCapture2TaskID = -1;
	mLastFrameProcessTaskID   = -1;
}

WK7MainTask::~WK7MainTask()
{
	screenImageFullColor.FreeBuffer();
	screenImageMonoColor.FreeBuffer();
	if( mpMainTask==this ){
		mpMainTask = NULL;
		pMFrameProcessTaskController	= NULL;
		pMRenderProcessTaskController	= NULL;
	}
}

bool WK7MainTask::SetCurrentStage(u32 id)
{
	WK7Stage		*pStage;
	WK7Path			*pPath;
	WK7Path			*pOldPath;
	WK7Stage		*pOldStage;
	WK7PathControl	*pPathControl;
	
	if( (pStage=WK7RenderObj::GetStage(id))==NULL ){
		return false;
	}
	
	pPathControl = WK7PLAYERCONTROL->GetPathControl();
	
	pOldStage = WK7Stage::GetCurrentStage();
	pOldPath  = pPathControl->GetControlPath();
	
	pPath = pStage->GetPath();
	pPathControl->SetControlPath(pPath);
	pPathControl->SetCameraJump();
	WK7CAM->SetControlPath(pPath);
	if( pPath==NULL ){
		pPathControl->SetActive(false);
	}else{
		pPathControl->SetActive(true);
	}
	WK7SELECTIF->Disappear();
	
	WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
	WK7CAM->SetBranchPointMode(false,true);
	
	if( WK7Stage::SetCurrentStage(id)==false ){
		
		if( pOldStage!=NULL ){
			WK7Stage::SetCurrentStage(pOldStage->GetID());
			pPathControl->SetControlPath(pOldPath);
			if( pOldPath==NULL ){
				pPathControl->SetActive(false);
			}else{
				pPathControl->SetActive(true);
			}
		}
		
//	}else{
//		
//		WK7CAM->SetMode(WK7Cam::WK7CAM_PATH_FOLLOW);
//		WK7CAM->SetBranchPointMode(false);
//		
	}
	
	return true;
}

//bool WK7MainTask::AllocMirrorNum(int num)
//{
//	if( num < 0 ){
//		return false;
//	}
//	if( num==0 ){
//		return FreeMirror();
//	}
//	mMirrorNum = num;
//	mppMirror  = (C_Mirror **)K7AppSmallMemAlloc((int)(sizeof(C_Mirror *) * num));
//	int			i;
//	for(i=0 ; i<num ; i++){
//		mppMirror[i] = NULL;
//	}
//	return true;
//}
//
//bool WK7MainTask::FreeMirror(void)
//{
//	if( mMirrorNum <= 0 ){
//		return false;
//	}
//	int			i;
//	for(i=0 ; i<mMirrorNum ; i++){
//		GHMGCMEM_SAFE_FREE(mppMirror[i]);
//	}
//	GHMGCMEM_SAFE_FREE(mppMirror);
//	return true;
//}
//
//bool WK7MainTask::SetMirror(int index,HSD_JObj *pMirrorObj,
//                                      HSD_JObj *pSizeObj,
//                                      HSD_DObj *pMirrorMat,
//                                      HSD_CObj *pCObj)
//{
//	if( index<0 || index>=mMirrorNum ||
//	    pMirrorObj==NULL ||
//	    pSizeObj  ==NULL ||
//	    pMirrorMat==NULL ||
//	    pCObj     ==NULL ){
//		return false;
//	}
//	ghmGcMemSetAllocName("C_Mirror");
//	mppMirror[index] = new C_Mirror(pMirrorObj,pCObj,pMirrorMat,pSizeObj);
//	return true;
//}
//
//
//
//
//bool WK7MainTask::MirrorDispStart(int index)
//{
//	if( index<0 || index>=mMirrorNum || mppMirror[index]==NULL ){
//		return false;
//	}
//	mppMirror[index]->DispStart();
//	return true;
//}
//
//bool WK7MainTask::MirrorDispEnd(int index)
//{
//	if( index<0 || index>=mMirrorNum || mppMirror[index]==NULL ){
//		return false;
//	}
//	mppMirror[index]->DispEnd();
//	return true;
//}

WK7Cam* WK7MainTask::GetCamera(void)
{
	return WK7CAM;
}

