////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Memo
//
// WK7Memo.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/11/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7MEMO_CPP__

//#include <dolphin.h>
#include ".\WK7Memo.h"
#include ".\WK7Cam.h"
#include ".\WK7Player.h"
#include ".\WK7EventScript.h"
#include ".\WK7EventItem.h"
#include ".\WK7Event.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Yam\YK7Effect.h"

WK7Archive		*WK7Memo::mpArchive  = NULL;
WK7Chara		*WK7Memo::mpHato     = NULL;
bool			WK7Memo::mInitialize = false;
int				WK7Memo::mInitProc   = 0;

#define	HATMOT_LAND			(100)
#define	HATMOT_TAKEOFF		(200)

WK7Memo::WK7Memo(WK7JObj *pLocator)
{
	mCounter              = 0;
	mLandingRotY          = 0.0f;
	mCamRotY              = 0.0f;
	mState                = STATE_IDLE;
	mFlag                 = 0;
	mUseLandingRotY       = 0;
	mCameraSet            = 1;
	mpMessageEffect       = NULL;
	if( (mpLandingPointLocator = pLocator)!=NULL ){
		mpLandingPointLocator->GetWorldPosition(mLandingPoint);
		mLandingRotY    = mpLandingPointLocator->GetRotY();
	}else{
		mLandingPoint.x = 0.0f;
		mLandingPoint.y = 0.0f;
		mLandingPoint.z = 0.0f;
	}
}

WK7Memo::WK7Memo(WK7JObj *pLocator,f32 roty)
{
	mCounter              = 0;
	mLandingRotY          = roty;
	mCamRotY              = 0.0f;
	mState                = STATE_IDLE;
	mFlag                 = 0;
	mUseLandingRotY       = 1;
	mCameraSet            = 1;
	mpMessageEffect       = NULL;
	if( (mpLandingPointLocator = pLocator)!=NULL ){
		mpLandingPointLocator->GetWorldPosition(mLandingPoint);
	}else{
		mLandingPoint.x = 0.0f;
		mLandingPoint.y = 0.0f;
		mLandingPoint.z = 0.0f;
	}
}

WK7Memo::WK7Memo(const Vec &landingPoint,f32 roty)
{
	mCounter              = 0;
	mLandingRotY          = roty;
	mCamRotY              = 0.0f;
	mState                = STATE_IDLE;
	mFlag                 = 0;
	mUseLandingRotY       = 1;
	mCameraSet            = 1;
	mpLandingPointLocator = NULL;
	mLandingPoint         = landingPoint;
	mpMessageEffect       = NULL;
}

WK7Memo::~WK7Memo()
{
}

bool WK7Memo::Initialize(void)
{
	mpArchive = NULL;
	mpHato    = NULL;
//	if( WK7Chara::CreateStaticArchive(K7CHRID(K7HAT,0))==false ){
//		return false;
//	}
//	if( (mpArchive = WK7Archive::Find(K7OBJTYPE_CHR,K7CHRID(K7HAT,0)))==NULL ){
//		return false;
//	}
//	if( (mpHato = WK7RenderObj::CreateChara(K7CHRID(K7HAT,0)))==NULL ){
//		return false;
//	}
//	mpHato->CreateOwnCharaMotion(HATMOT_LAND   );
//	mpHato->CreateOwnCharaMotion(HATMOT_TAKEOFF);
	mInitialize = false;
	mInitProc = 0;
	return true;
}

bool WK7Memo::Terminate(void)
{
	GHM_SAFE_DELETE(mpHato   );
	GHM_SAFE_DELETE(mpArchive);
	mInitialize = false;
	mInitProc   = 0;
	return true;
}

bool WK7Memo::LoadStart(void)
{
	if( mInitProc != 0 ){
		return false;
	}
	mInitProc = 1;
	mpArchive = NULL;
	mpHato    = NULL;
	if( WK7Chara::CreateStaticArchive(K7CHRID(K7HAT,0))==false ){
		return false;
	}
	if( (mpArchive = WK7Archive::Find(K7OBJTYPE_CHR,K7CHRID(K7HAT,0)))==NULL ){
		return false;
	}
	if( (mpHato = WK7RenderObj::CreateChara(K7CHRID(K7HAT,0)))==NULL ){
		return false;
	}
	mpHato->CreateOwnCharaMotion(HATMOT_LAND   );
	mpHato->CreateOwnCharaMotion(HATMOT_TAKEOFF);
	return true;
}

bool WK7Memo::IsLoaded(void)
{
	return mInitialize;
}

bool WK7Memo::LoadProcess(void)
{
	switch( mInitProc ){
	case	0:
		break;
	case	1:
		if( mInitialize==true ){
			return true;
		}
		if( mpHato==NULL ){
			mInitialize = true;
			return true;
		}
		WK7Model	*pModel = mpHato->GetModel();
		if( pModel==NULL ){
			return false;
		}
		mpHato->SetVisible(false);
		mpHato->CreatePrivateLight();
		mpHato->SetStageLight(false);
		mInitialize = true;
		break;
	default:
		break;
	}
	return true;
}

bool WK7Memo::SetCameraPosition(void)
{
	if( !mCameraSet ){
		return false;
	}
static	f32		dist   = 10.0f;
static	f32		height =  7.0f;
//static	f32		dist   = 5.0f;
//static	f32		height = 3.0f;
	Vec		pos,tgt;
	f32		roty;
	
	tgt.x = mLandingPoint.x;
	tgt.y = mLandingPoint.y;
	tgt.z = mLandingPoint.z;
	
	WK7PLAYERCONTROL->GetRotY(&roty);
	pos.x = tgt.x + dist * sinf(roty);
	pos.y = tgt.y - height;
	pos.z = tgt.z + dist * cosf(roty);
	
//	WK7PLAYERCONTROL->GetPosition(&pos);
//	roty  = atan2f(pos.x - tgt.x,pos.z - tgt.z);
//	pos.x = tgt.x + dist * sinf(roty);
//	pos.y = tgt.y + height;
//	pos.z = tgt.z + dist * cosf(roty);
	
//	pos.x = mLandingPoint.x + dist * sinf(mCamRotY);
//	pos.y = mLandingPoint.y + height;
//	pos.z = mLandingPoint.z + dist * cosf(mCamRotY);
	
	WK7CAM->SetPosition      (pos);
	WK7CAM->SetTargetPosition(tgt);
	
	return true;
}

bool WK7Memo::FrameProcess(void)
{
	if( mpHato==NULL ){
		mState = STATE_TERM;
		return false;
	}
	WK7JObj			*pJObj;
	WK7ModelMotion	*pModelMotion; 
	
	WK7Chara	*pPcChara = WK7PLAYERCONTROL->GetCharaPtr();
	if( pPcChara!=NULL ){
		const char	*pObjName;
static	f32		dist  = 0.4f;
static	f32		dandy = 0.40f;
static	f32		catdy = 0.25f;
static	f32		cyody = 0.48f;
static	f32		galdy = 0.60f;
static	f32		hacdy = 0.58f;
static	f32		keddy = 0.20f;
static	f32		kvndy = 0.50f;
static	f32		mskdy = 0.82f;
static	f32		defdy = 0.50f;
		f32		dy;
		pObjName = K7CHRBONE_HUMERUS_L1;
		switch( WK7PLAYERCONTROL->GetMainID() ){
		case	K7DAN: dy = dandy; break;
		case	K7CAT: dy = catdy; pObjName = K7CHRBONE_HUMERUS_R1; break;
		case	K7CYO: dy = cyody; break;
		case	K7GAL: dy = galdy; break;
		case	K7HAC: dy = hacdy; break;
		case	K7KED: dy = keddy; break;
		case	K7KVN: dy = kvndy; break;
		case	K7MSK: dy = mskdy; break;
		default:       dy = defdy; break;
		}
		if( (pJObj = pPcChara->GetJObj(pObjName))!=NULL ){
static	f32	droty = -0.3f;
			WK7PLAYERCONTROL->GetRotY(&mLandingRotY);
			mLandingRotY += droty;
			pJObj->GetWorldPosition(mLandingPoint);
			mLandingPoint.y += dy;
			mLandingPoint.z -= dist * cosf(mLandingRotY);
			mLandingPoint.x -= dist * sinf(mLandingRotY);
			
		}
		mpHato->SetPosition(mLandingPoint);
		mpHato->SetRotY    (mLandingRotY);
	}
	
	SetCameraPosition();
	
	switch( mState ){
	case	STATE_STARTLANDING:
		if( mCounter >  WK7_TICK_PER_FRAME ){
			mCounter -= WK7_TICK_PER_FRAME;
			break;
		}
		mCounter = 0;
		if( (pJObj=mpHato->GetJObj())!=NULL && (pModelMotion=mpHato->GetOwnModelMotion(HATMOT_LAND))!=NULL ){
			pJObj->AttachMotion(pModelMotion);
			pJObj->PlayMotion  ();
			pJObj->SetMotionLoop(false);
		}
		SetVisibleCarrior(true);
		mState = STATE_LANDING;
		mpHato->SetVisible(true);
	case	STATE_LANDING:
//		if( mpLandingPointLocator!=NULL ){
//			mpLandingPointLocator->GetWorldPosition(mLandingPoint);
//			if( mUseLandingRotY ){
//				mLandingRotY = mpLandingPointLocator->GetRotY();
//			}
//			mpHato->SetPosition(mLandingPoint);
//		}
//		mpHato->SetRotY(mLandingRotY);
		if( (pJObj=mpHato->GetJObj())!=NULL ){
			if( pJObj->GetMotionState()!=AOBJ_NO_ANIM ){
				break;
			}
		}
		mState = STATE_STANDBY;
		mCameraSet = 0;
		break;
	case	STATE_STARTTAKEOFF:
		if( (pJObj=mpHato->GetJObj())!=NULL && (pModelMotion=mpHato->GetOwnModelMotion(HATMOT_TAKEOFF))!=NULL ){
			pJObj->StopMotion  ();
			pJObj->DetachMotion();
			pJObj->AttachMotion(pModelMotion);
			pJObj->PlayMotion  ();
			pJObj->SetMotionLoop(false);
			gpSound->mPlaySE(SFX_SYS_HATO_IKU);
		}
		mpMessageEffect = WK7EVENTCONTROLLER->CreateMessage(K7SCR_SYSMES_GETMEMO,-1,-1);
//		K7SCR_SYS_MESSAGE(K7SCR_SYSMES_GETMEMO);
		mState = STATE_TAKEOFF;
	case	STATE_TAKEOFF:
//		if( mpLandingPointLocator!=NULL ){
//			mpLandingPointLocator->GetWorldPosition(mLandingPoint);
//			if( mUseLandingRotY ){
//				mLandingRotY = mpLandingPointLocator->GetRotY();
//			}
//			mpHato->SetPosition(mLandingPoint);
//		}
//		mpHato->SetRotY(mLandingRotY);
		if( (pJObj=mpHato->GetJObj())!=NULL ){
			if( pJObj->GetMotionState()!=AOBJ_NO_ANIM ){
				break;
			}
			pJObj->StopMotion  ();
			pJObj->DetachMotion();
		}
		mState = STATE_MESSAGEWAIT;
	case	STATE_MESSAGEWAIT:
		if( mpMessageEffect!=NULL ){
			if(  WK7EVENTCONTROLLER->IsValidEffect(mpMessageEffect)==true ){
				break;
			}
		}
		mpMessageEffect = NULL;
		mState = STATE_TERM;
	case	STATE_TERM:
		mpHato->SetVisible(false);
	case	STATE_STANDBY:
	case	STATE_IDLE:
	default:
		break;
	}
	
	return true;
}

bool WK7Memo::SetVisibleCarrior(bool flag)
{
	if( mpHato==NULL ){
		return false;
	}
	WK7JObj			*pJObj = mpHato->GetJObj("Carrier");
	if( pJObj==NULL ){
		return false;
	}
	if( flag==true ){
		pJObj->Disp(false,true);
	}else{
		pJObj->Hide(false,true);
	}
	return true;
}

bool WK7Memo::RenderProcess(void)
{
	if( mpHato==NULL ){
		return false;
	}
	return true;
}

bool WK7Memo::StartLanding(void)
{
	switch( mState ){
	case	STATE_IDLE:
	case	STATE_TERM:
		break;
	default:
		return false;
	}
	mState = STATE_STARTLANDING;
	gpSound->mPlaySE(SFX_SYS_HATO_KURU);
	mCounter = (int)WK7_SEC_TO_TICK(0.6f);
	return true;
}

bool WK7Memo::StartTakeOff(void)
{
	switch( mState ){
	case	STATE_STANDBY:
		break;
	default:
		return false;
	}
	mState = STATE_STARTTAKEOFF;
	mCameraSet = 1;
	return true;
}

