////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Memo
//
// WK7Memo.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 10/11/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MEMO_H__
#define	__WK7MEMO_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"

#include ".\WK7Archive.h"
#include ".\WK7Chara.h"

class WK7EventEffect;

class WK7Memo{
public:
	enum State{
		STATE_IDLE = 0,		// ȂɂĂȂ
		STATE_STARTLANDING,	// nJn
		STATE_LANDING,		// n
		STATE_STANDBY,		// ҋ@
		STATE_STARTTAKEOFF,	// Jn
		STATE_TAKEOFF,		// 
		STATE_MESSAGEWAIT,	// bZ[WI҂
		STATE_TERM,			// I
	};
protected:
	static WK7Archive		*mpArchive;
	static WK7Chara			*mpHato;
	static bool				mInitialize;
	static int				mInitProc;
	WK7JObj					*mpLandingPointLocator;
	Vec						mLandingPoint;
	f32						mLandingRotY;
	f32						mCamRotY;
	int						mCounter;
	union{
		struct{
			u32				mUseLandingRotY : 1;
			u32				mCameraSet      : 1;
			u32				mFlagPad        :30;
		};
		u32					mFlag;
	};
	State					mState;
	WK7EventEffect			*mpMessageEffect;
	u32						mMessageEffectID;
	
	bool SetCameraPosition(void);
public:
	WK7Memo(WK7JObj *pLocator);
	WK7Memo(WK7JObj *pLocator,f32 roty);
	WK7Memo(const Vec &landingPoint,f32 roty=0.0f);
	~WK7Memo();
	static bool Initialize(void);
	static bool Terminate(void);
	static bool LoadProcess(void);
	static bool LoadStart(void);
	static bool IsLoaded(void);
	
	inline void SetLandingPointLocator(WK7JObj *pLocator){ mpLandingPointLocator=pLocator; }
	inline WK7JObj* GetLandingPointLocator(void){ return mpLandingPointLocator; }
	inline void SetLandingPoint(const Vec &point){ mLandingPoint=point; }
	inline void GetLandingPoint(Vec &point){ point=mLandingPoint; }
	inline void SetLandingRotY(f32 roty){ mLandingRotY=roty; mUseLandingRotY=1; }
	inline f32 GetLandingRotY(void){ return mLandingRotY; }
	inline void SetCamRotY(f32 roty){ mCamRotY=roty; }
	inline f32 GetCamRotY(void){ return mCamRotY; }
	inline State GetState(void){ return mState; }
	
	inline void SetCameraSet(bool flag){ mCameraSet=(flag==true?1:0); }
	inline bool GetCameraSet(void){ return mCameraSet? true : false; }
	
	bool StartLanding(void);
	bool StartTakeOff(void);
	bool SetVisibleCarrior(bool flag);
	
	bool FrameProcess(void);
	bool RenderProcess(void);
};

#endif	//__WK7MEMO_H__

