////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Menu Task
//
// WK7MenuTask.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/13/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7MENUTASK_CPP__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\WK7MenuTask.h"

#include "..\K7App.ini"
#include ".\K7App.h"
#include ".\WK7MainTask.h"
#include ".\WK7TestTask.h"
#include ".\WK7ViewerTask.h"
#include ".\WK7Event.h"
#include "..\Fujita\fmain.h"
#include "..\Matsu\MK7TestTask.h"
#include "..\Matsu\MK7TitleTask.h"
#include "..\Matsu\MK7SoundTask.h"		//Matsuzaki 2003.02.12
#include "..\Kaw\KK7TestTask.h"
#include "..\Yam\YK7TestTask.h"
#include "..\Sato\SK7TestTask.h"
#include "..\Sato\SK7LogoTask.h"

#ifdef	USE_ISDOLVIEWER
#ifdef	WK7MENU_INIT_SELECTID
#undef	WK7MENU_INIT_SELECTID
#endif
#define	WK7MENU_INIT_SELECTID		MI_VIEWER
#endif

WK7MenuTask::Item	WK7MenuTask::mItem[WK7MenuTask::MI_MAX] = {
	{ WK7MenuTask::MI_MAIN  , "Main"   },
	{ WK7MenuTask::MI_LOGO  , "Logo"   },
	{ WK7MenuTask::MI_TITLE , "Title"  },
	{ WK7MenuTask::MI_KAW   , "Viewer" },
	{ WK7MenuTask::MI_SOUND , "Sound"  },
	{ WK7MenuTask::MI_SATO  , "Sato"   },
	{ WK7MenuTask::MI_YAM   , "Yam"    },
	{ WK7MenuTask::MI_FUJITA, "Fujita" },
	{ WK7MenuTask::MI_MATSU , "Matsu"  },
	{ WK7MenuTask::MI_KAW   , "Kaw"    },
	{ WK7MenuTask::MI_WAT   , "Wat"    },
};

bool WK7MenuTask::InitializeCallBack(void)
{
	
	OSDebugReport("WK7MenuTask Init : Heap = 0x%08x,0x%08x, TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),k7app.SmallGetFreeSize(),sizeof(*this));
	
	k7app.FadeStart(0,0);
	
#ifdef	_DEBUG
	ghmGcApp		*pApp = GetApplication();
	
	pApp->SetVisiblePerfMeter(true);
	pApp->SetEnablePerfMeter (true);
	
	ghmGcMem::SetRender(true);
#endif
	
	HSD_VISetClearClr((GXColor)K7APP_DEFAULT_CLEARCOLOR);
	
	return true;
}

bool WK7MenuTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	ItemID			selectid = mSelectID;
	
	pApp->SetVisiblePerfMeter(false);
	pApp->SetEnablePerfMeter (false);
	ghmGcMem::SetRender(false);
	
	// ̂Ƃ̓oɃANZXĂ͂Ȃ
	delete this;
	
	ghmGcMemSetAllocName("TaskCall");
	
	switch( selectid ){
	case	MI_MAIN:   new WK7SelectScenarioTask(pApp); break;
//	case	MI_MAIN:   new WK7MainTask          (pApp); break;
	case	MI_LOGO:   new SK7LogoTask          (pApp); break;
	case	MI_TITLE:  new MK7TitleTask         (pApp); break;
	case	MI_VIEWER: new WK7ViewerTask        (pApp); break;
	case	MI_SOUND:  new MK7SoundTask         (pApp); break;
	case	MI_SATO:   new SK7TestTask          (pApp); break;
	case	MI_YAM:    new YK7TestTask          (pApp); break;
	case	MI_FUJITA: new FK7MainTask          (pApp); break;
	case	MI_MATSU:  new MK7TestTask          (pApp); break;
	case	MI_KAW:    new KK7TestTask          (pApp); break;
//	case	MI_WAT:    break;
	case	MI_WAT:    new WK7TestTask          (pApp); break;
	default:           new WK7MenuTask          (pApp); break;
	}
	
#if 0
	if( selectid==MI_WAT ){
		
		ghmGcFile		file,strfile;
static	OSModuleHeader	*pOlTestModule = NULL;
static	void			*pBSS          = NULL;
static	const char		*fname[] = {
	"/Module/oltest.rel",
	"/Module/oltest2.rel",
	NULL,
};
static	int		olid = 0;
		if( fname[++olid]==NULL ){
			olid = 0;
		}
		
		if( file.Open((char *)fname[olid])==true ){
			
			if( pOlTestModule!=NULL && pBSS!=NULL ){
				if( pOlTestModule!=NULL && pBSS!=NULL ){
					((void (*)(void))pOlTestModule->epilog)();
					OSUnlink(&pOlTestModule->info);
				}
				GHMGCMEM_SAFE_FREE(pBSS);
				GHMGCMEM_SAFE_FREE(pOlTestModule);
			}
			
			pOlTestModule = (OSModuleHeader *)file.ReadB();
			
			if( pOlTestModule!=NULL && (pBSS = ghmGcMemAlloc((int)pOlTestModule->bssSize))!=NULL ){
				
				OSLink(&pOlTestModule->info,pBSS);
				((void (*)(void))pOlTestModule->prolog)(); 
				
			}
			
		}
		
	}
#endif
	
//	K7AppDumpMemory();
	
	return true;
}

#ifdef	_DEBUG
#define	TMPSAVE
#endif

#ifdef	TMPSAVE
#include "..\Sato\SK7SaveData.h"
extern	SK7SaveData		tempSaveData;
#endif

bool WK7MenuTask::FrameProcess(void)
{
	if( mDelay ){
		mDelay--;
		return true;
	}
	
#ifdef	_DEBUG
	if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
		K7AppDumpMemory();
	}
#endif
	
	u32		trg = HSD_PadGetTrigger(0);
	u32		rpt = HSD_PadGetRepeat (0);
	
	if( trg & (HSD_PAD_START|HSD_PAD_A) ){
		if( DeleteTerminate()==true ){
			return true;
		}
	}
	
//	HSD_PadSetADConvert(HSD_PAD_ADC_CIRCLE, 30, MTXDegToRad(40));
	if( rpt & (HSD_PAD_UP|HSD_PAD_STICK_UP) ){
		mSelectID = (ItemID)((int)mSelectID - 1);
	}
	if( rpt & (HSD_PAD_DOWN|HSD_PAD_STICK_DOWN) ){
		mSelectID = (ItemID)((int)mSelectID + 1);
	}
	if( (int)mSelectID < 0 ){
		mSelectID = (ItemID)((int)MI_MAX-1);
	}else if( (int)mSelectID >= (int)MI_MAX ){
		mSelectID = MI_START;
	}
	
	return true;
}

bool WK7MenuTask::RenderProcess(void)
{
	
	// p
	C_Paper	paper(0,32);
	int		i;
	Item	*pItem;
	char	*pCursor;
	
//	HSD_StartRender(HSD_RP_SCREEN);
	
	HSD_SetZSortMode(true,false);
	
	PRINTF(" Killer7 Menu Select : %s - %s\n\n",__DATE__,__TIME__);
	
	for(i=(int)MI_START,pItem=mItem ; i<(int)MI_MAX ; i++,pItem++){
		if( i==(int)mSelectID ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		PRINTF("  %s %s\n",pCursor,pItem->mpName);
	}
	
//	HSD_EndRender();
	
	return true;
}

WK7MenuTask::WK7MenuTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
#ifdef	WK7MENU_INIT_SELECTID
	mSelectID = WK7MENU_INIT_SELECTID;
#else
	mSelectID = MI_START;
#endif
	mDelay    = 2;
}

WK7MenuTask::~WK7MenuTask()
{
}

WK7SelectScenarioTask::WK7SelectScenarioTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	mScenarioID = GameInfo.GetScenarioID();
	mCursorV    = 0;
	mDelay      = 2;
	mContinue   = false;
}

WK7SelectScenarioTask::~WK7SelectScenarioTask()
{
}

bool WK7SelectScenarioTask::InitializeCallBack(void)
{
	
	OSDebugReport("WK7SelectScenarioTask Init : Heap = 0x%08x,0x%08x, TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),k7app.SmallGetFreeSize(),sizeof(*this));
	
	k7app.FadeStart(0,0);
	
#ifdef	_DEBUG
	ghmGcApp		*pApp = GetApplication();
	pApp->SetVisiblePerfMeter(true);
	pApp->SetEnablePerfMeter (true);
	
	ghmGcMem::SetRender(true);
#endif
	
	return true;
}

bool WK7SelectScenarioTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	bool			callMainTask;
	
	if( mScenarioID < -1 ){
		callMainTask = false;
	}else{
		if( mScenarioID==-1 ){
			GameInfo.SetScenarioID(K7SCN_UNKNOWN);
			WK7ArchiveSetDebugPrintSec(0.0f);
		}else{
			GameInfo.SetScenarioID(mScenarioID);
		}
		callMainTask = true;
	}
	
	pApp->SetVisiblePerfMeter(false);
	pApp->SetEnablePerfMeter (false);
	ghmGcMem::SetRender(false);
	
	// ̂Ƃ̓oɃANZXĂ͂Ȃ
	delete this;
	
	if( callMainTask==true ){
#ifdef	_DEBUG
		GameInfo.SetMoonSkip(true);
#endif
		ghmGcMemSetAllocName("MainTask");
		new WK7MainTask(pApp);
	}else{
		ghmGcMemSetAllocName("MenuTask");
		new WK7MenuTask(pApp);
	}
	
//	K7AppDumpMemory();
	
	return true;
}

bool WK7SelectScenarioTask::FrameProcess(void)
{
	if( mDelay ){
		mDelay--;
		return true;
	}
	
	u32		btn = HSD_PadGetButton (0);
	u32		trg = HSD_PadGetTrigger(0);
	u32		rpt = HSD_PadGetRepeat (0);
	
	if( trg & (HSD_PAD_START|HSD_PAD_A) ){
#ifdef	TMPSAVE
		if( mContinue==true ){
			GameInfo.RestoreSaveData(&tempSaveData);
			GameInfo.SetContinue(true);
		}else{
#endif
			GameInfo.SetContinue(false);
#ifdef	TMPSAVE
		}
#endif
		if( DeleteTerminate()==true ){
			return true;
		}
	}
	if( trg & HSD_PAD_B ){
		mScenarioID = -2;
		if( DeleteTerminate()==true ){
			return true;
		}
	}
	
	switch( mCursorV ){
	case	0:
		if( btn & HSD_PAD_X ){
			if( rpt & (HSD_PAD_UP|HSD_PAD_STICK_UP) ){
				mScenarioID += 10;
			}
			if( rpt & (HSD_PAD_DOWN|HSD_PAD_STICK_DOWN) ){
				mScenarioID -= 10;
			}
			if( mScenarioID < 0 ){
				mScenarioID = 100-1;
			}else if( mScenarioID > 100-1 ){
				mScenarioID = 0;
			}
		}else{
			if( rpt & (HSD_PAD_UP|HSD_PAD_STICK_UP) ){
				mScenarioID++;
			}
			if( rpt & (HSD_PAD_DOWN|HSD_PAD_STICK_DOWN) ){
				mScenarioID--;
			}
			if( mScenarioID < -1 ){
				mScenarioID = 100-1;
			}else if( mScenarioID > 100-1 ){
				mScenarioID = -1;
			}
		}
#ifdef	TMPSAVE
		if( tempSaveData.SaveData.mStartScenarioID!=K7SCN_UNKNOWN ){
			if( rpt & (HSD_PAD_RIGHT|HSD_PAD_STICK_RIGHT) ){
				mContinue = (mContinue==true? false : true);
			}
			if( rpt & (HSD_PAD_LEFT |HSD_PAD_STICK_LEFT ) ){
				mContinue = (mContinue==true? false : true);
			}
		}
#endif
		break;
	default:
		break;
	}
	
	return true;
}

bool WK7SelectScenarioTask::RenderProcess(void)
{
	C_Paper	paper(0,32);
	int		i;
	char	*pCursor;
	
	PRINTF(" Killer7 Scenario Select\n\n");
	
	for(i=0 ; i<1 ; i++){
		if( i==mCursorV ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		switch( i ){
		case	0:
			if( mScenarioID < 0 ){
				PRINTF("  %s   Test\n",pCursor);
			}else{
				PRINTF("  %s   %02d\n",pCursor,mScenarioID);
			}
#ifdef	TMPSAVE
			if( tempSaveData.SaveData.mStartScenarioID==K7SCN_UNKNOWN ){
#endif
				PRINTF("\n      NO SAVE DATA\n");
#ifdef	TMPSAVE
			}else{
				if( mContinue==true ){
					PRINTF("\n      Continue : %02d - %03dM%02d [%s]\n",
					                                   tempSaveData.SaveData.mStartScenarioID,
					                                   K7STG_MAINID(tempSaveData.SaveData.mPrevStageID),
					                                   K7STG_SUFFIX(tempSaveData.SaveData.mPrevStageID),
					                                   tempSaveData.SaveData.mPrevStagePathName);
				}else{
					PRINTF("\n      Start\n");
				}
			}
#endif
			break;
		default:
			break;
		}
	}
	
	return true;
}

