////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Mirror Object
//
// WK7Mirror.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/12/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7MIRROR_H__
#define	__WK7MIRROR_H__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include "..\Fujita\C_Mirror.h"
#include ".\WK7Model.h"
#include ".\WK7Obj.h"

class WK7Mirror;

//
// Mirror Reclect Object
//
class WK7MirrorReflectObj : public WK7Obj{
protected:
	WK7JObj							*mpJObj;					// fIuWFNg
	bool							mChildObj;					// qIuWFNgtO
	bool							mVisible;					// \tO
	
	WK7MirrorReflectObj();
public:
	WK7MirrorReflectObj(WK7JObj *pJObj,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7MirrorReflectObj();
	
	inline WK7MirrorReflectObj* GetPrev(void){ return (WK7MirrorReflectObj *)ghmGcListObj::GetPrev(); }
	inline WK7MirrorReflectObj* GetNext(void){ return (WK7MirrorReflectObj *)ghmGcListObj::GetNext(); }
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	
	inline void SetChildObj(bool flag){ mChildObj = flag; }
	inline bool GetChildObj(void){ return mChildObj; }
	inline void SetVisible(bool flag){ mVisible = flag; }
	inline bool GetVisible(void){ return mVisible; }
};

//
// Mirror Object
//
class WK7Mirror : public WK7Obj{
public:
protected:
	static ghmGcListObj				mAnchor;
	
	u32								mMirrorID;
	
	C_Mirror						*mpMirror;
	WK7JObj							*mpJObj;
	WK7JObj							*mpSizeJObj;
	HSD_DObj						*mpMat;
	
	ghmGcListObj					mRefrectObjAnchor;
	
	void InitMember(void);
	static u32 GetUniqueID(void);
	WK7Mirror();
	WK7Mirror(WK7JObj *pJObj,WK7JObj *pSizeJObj,HSD_DObj *pMirrorMat,ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool DispStart(void);
	bool DispEnd(void);
public:
	virtual ~WK7Mirror();
	
	inline WK7Mirror* GetPrev(void){ return (WK7Mirror *)ghmGcListObj::GetPrev(); }
	inline WK7Mirror* GetNext(void){ return (WK7Mirror *)ghmGcListObj::GetNext(); }
	
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	inline u32 GetMirrorID(void){ return mMirrorID; }
	const char* GetName(void);
	
	// t[
	virtual bool FrameProcess(void);
	static bool FrameProcessAll(void);
	// _O
	bool RenderProcess(void);
	static bool RenderProcessAll(void);
	
	WK7MirrorReflectObj* AddReflectJObj(WK7JObj *pJObj);
	bool DeleteReflectJObj(WK7JObj *pJObj);
	WK7MirrorReflectObj* FindReflectJObj(WK7JObj *pJObj);
	
	static bool ReleaseJObj(WK7JObj *pJObj);
	
	static WK7Mirror* Create(WK7JObj *pJObj,WK7JObj *pSizeJObj,HSD_DObj *pMat=NULL);
	static bool Release(const char *pName);
	static WK7Mirror* Find(const char *pName);
	static WK7Mirror* Find(u32 mirrorid);
	inline static WK7Mirror* Top(void){ return (WK7Mirror *)mAnchor.GetNext(); }
	static void DrawTex( void ){ 
	  WK7Mirror		*pMirror = (WK7Mirror *)mAnchor.GetNext();
	  while( pMirror!=NULL ){
		pMirror->mpMirror->DrawTex();
		pMirror = pMirror->GetNext();
	  }
	}

};

#endif	//__WK7MIRROR_H__

