////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Object
//
// WK7Obj.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/08/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7OBJ_CPP__

//#include <dolphin.h>
#include ".\WK7Obj.h"
#include "..\Fujita\C_Vfx.h"
#include "..\Fujita\c_k7cloth.h"
#include ".\WK7Define.h"
#include ".\WK7Archive.h"
#include ".\WK7Chara.h"
#include ".\WK7Stage.h"
#include ".\WK7Item.h"
#include ".\WK7Event.h"
#include ".\WK7Play.h"
#include ".\WK7HitObj.h"
#include "..\Fujita\C_Font.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include ".\WK7EventScript.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Fog.h"
#include ".\WK7Shadow.h"
#include "..\Yam\YK7EffectModelFire.h"
#include "..\Yam\YK7EffectBreak.h"
#include "..\Yam\YK7EffectBillboard.h"
#include "..\Yam\YK7EffectRain.h"
#include "..\Yam\YK7EffectSmoke.h"
#include "..\Yam\YK7EffectDropWater.h"
#include "..\Yam\YK7EffectEasyAnim.h"
#include "..\Yam\YK7EffectBlood.h"
#include "..\Yam\YK7EffectConfetti.h"
#include "..\Yam\YK7EffectSeenSound.h"

//#define	RAINEFFECTNUM			(50)
#define	RAINEFFECTNUM			(100)

C_VFX*			WK7RenderObj::mpVfx = NULL;
bool			WK7RenderObj::mVfxFlag = false;
bool			WK7RenderObj::mVisibleAllFlag = true;
bool			WK7RenderObj::mIsReservedFileName = false;
char			WK7RenderObj::mReservedFileName[WK7_FNAME_MAX];
ghmGcListObj	WK7RenderObj::mEffectResourceAnchor;
ghmGcListObj	WK7RenderObj::mAnchor;
ghmGcListObj	WK7MotionObj::mAnchor;
#if FUJITA
HSD_Fog*		WK7RenderObj::mpFog = 0;
#endif
static	HSD_PEDesc	normalPEDesc = {
	//J[AAt@AŒAt@݁AZobt@SăGiuB
//	ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE,
	ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
	//GXSetAlphaCompare(),ref0,ref1
	//At@RyA͎gȂB
	0,0,
	//GXSetDstAlpha(),dst_alpha
	WK7RENDEROBJ_RENDERID_DEFAULT_ALPHA,
	//GXSetBlendMode(),type,src_factor,dst_factor,logic_op
	//uh͂Ȃ̂src_factorAdst_factor, logic_op͂ǂł悢B
//	GX_BM_NONE,GX_BL_DSTALPHA,GX_BL_INVDSTALPHA,GX_LO_CLEAR,
	GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
	//GXSetZMode(),func
	//Zr͒ʏǂB
	GX_LEQUAL,
	//GXAlphaCompare,comp0,op,comp1
	//At@RyA͎gȂB
	GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
};

bool WK7RenderObj::SetReserveFileName(const char *pfname)
{
	if( pfname==NULL ){
		return ClearReserveFileName();
	}
	strncpy(mReservedFileName,pfname,WK7_FNAME_MAX-1);
	mIsReservedFileName = true;
	return true;
}

const char* WK7RenderObj::GetReserveFileName(void)
{
	if( mIsReservedFileName==false ){
		return NULL;
	}
	return mReservedFileName;
}

bool WK7RenderObj::ClearReserveFileName(void)
{
	memset(mReservedFileName,0,sizeof(mReservedFileName));
	mIsReservedFileName = true;
	return true;
}

bool WK7RenderObj::InitializeAll(void)
{
	normalPEDesc.dst_alpha = ConvRenderIDToAlpha(WK7RENDEROBJ_RENDERID_HALF-1);
//	WK7Item::CreateStaticArchive(WK7STAGE_HANA_ITEMID_DEF);
	return true;
}

bool WK7RenderObj::IsInitialized(void)
{
//	WK7Item		*pItem;
//	if( (pItem=WK7RenderObj::GetItem(WK7STAGE_HANA_ITEMID_DEF))==NULL ){
//		return false;
//	}
//	if( pItem->GetState()!=WK7RenderObj::LOADED ){
//		return false;
//	}
	return true;
}

bool WK7RenderObj::TerminateAll(void)
{
	WK7Archive		*pArchive = WK7Archive::Find(K7OBJTYPE_ITEM,WK7STAGE_HANA_ITEMID_DEF);
	if( pArchive!=NULL ){
		pArchive->SetStatic(false);
		delete pArchive;
	}
	return true;
}

HSD_PEDesc* WK7RenderObj::GetNormalPEDesc(void)
{
	return &normalPEDesc;
}

C_VFX* WK7RenderObj::GetVFX(void)
{
	if( mpVfx==NULL ){
		ghmGcMemSetAllocName("C_VFX");
		mpVfx = new C_VFX;
	}
	return mpVfx;
}

bool WK7RenderObj::VFXProc(void)
{
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return false;
	}
	pVFX->Proc();
	return true;
}

bool WK7RenderObj::VFXCopyTex(void)
{
	if( mVfxFlag==false ){
		return true;
	}
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return false;
	}
	pVFX->CopyTex();
	return true;
}

bool WK7RenderObj::VFXDisp(void)
{
	if( mVfxFlag==false ){
		return true;
	}
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return false;
	}
	pVFX->Disp();
	return true;
}

bool WK7RenderObj::VFXSetIntensity(f32 i)
{
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return false;
	}
	pVFX->SetIntensity(i);
	return true;
}

f32 WK7RenderObj::VFXGetIntensity(void)
{
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return 0.0f;
	}
	return pVFX->GetIntensity();
}

bool WK7RenderObj::VFXAddIntensity(f32 i)
{
	C_VFX	*pVFX = GetVFX();
	if( pVFX==NULL ){
		return false;
	}
	pVFX->AddIntensity(i);
	return true;
}

void* WK7SmallMemObj::operator new(u32 blocksize)
{
#ifdef	_DEBUG
	const char	*pIdent;
	if( (pIdent=ghmGcMemGetAllocName())==NULL ){
		pIdent = "SmMemObj";
	}
	return K7AppSmallMemAllocName((int)blocksize,pIdent);
#else
	return K7AppSmallMemAlloc((int)blocksize);		// Yam
#endif
}

void WK7SmallMemObj::operator delete(void *pblock)
{
	K7AppSmallMemFree(pblock);
}

void* WK7DefaultMemObj::operator new(u32 blocksize)
{
#ifdef	_DEBUG
	const char	*pIdent;
	if( (pIdent=ghmGcMemGetAllocName())==NULL ){
		pIdent = "SmMemObj";
	}
	return ghmGcMemAllocName((int)blocksize,pIdent);
#else
	return ghmGcMemAlloc((int)blocksize);		// Yam
#endif
}

void WK7DefaultMemObj::operator delete(void *pblock)
{
	ghmGcMem::mDefaultHeap.Free(pblock);
}

WK7Obj::WK7Obj()
{
#if FUJITA
	mpAdditionalPreRender =	  mpAdditionalPostRender = 0;
#endif
}

WK7Obj::WK7Obj(ghmGcListObj *pAnchor,int prio) : ghmGcListObj(pAnchor,prio)
{
#if FUJITA
	mpAdditionalPreRender =	  mpAdditionalPostRender = 0;
#endif
}

WK7Obj::~WK7Obj()
{
}
#if FUJITA
void WK7Obj::AdditionalPreRenderProcess( void )
{
}
void WK7Obj::AdditionalPostRenderProcess( void )
{
}
#endif
WK7RenderSelectObj::WK7RenderSelectObj(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,WK7JObj *pJObj) : ghmGcListObj(pAnchor)
{
	ghmGcMemSetAllocName("SelOSJ");
	if( (mpSelectObj = new WK7SelectObjSphereJObj(pJObj))!=NULL ){
		mpSelectObj->SetObjName       (0,"nameless");
		mpSelectObj->SetObjName       (1,"Object");
		mpSelectObj->SetSelectCallback(WK7RenderSelectObj::SelectCallback);
		mpSelectObj->SetParam         (0,(u32)this);
	}
	mpContainer = pContainer;
}

WK7RenderSelectObj::~WK7RenderSelectObj()
{
	GHM_SAFE_DELETE(mpSelectObj);
}

bool WK7RenderSelectObj::SetSelectObjName(int index,const char *pName)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->SetObjName(index,pName);
}

bool WK7RenderSelectObj::SetSelectObjName(const char *pName0,const char *pName1)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetObjName(0,pName0);
	mpSelectObj->SetObjName(1,pName1);
	return true;
}

const char* WK7RenderSelectObj::GetSelectObjName(int index)
{
	if( mpSelectObj==NULL ){
		return NULL;
	}
	return mpSelectObj->GetObjName(index);
}

bool WK7RenderSelectObj::SetSelectObjEnable(bool flag)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetEnable(flag);
	return true;
}

bool WK7RenderSelectObj::GetSelectObjEnable(void)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->GetEnable();
}

bool WK7RenderSelectObj::SetSelectObjPlayEnable(bool flag)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetPlayEnable(flag);
	return true;
}

bool WK7RenderSelectObj::GetSelectObjPlayEnable(void)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	return mpSelectObj->GetPlayEnable();
}

bool WK7RenderSelectObj::SetSelectEventID(u32 eventid)
{
	if( mpSelectObj==NULL ){
		return false;
	}
	mpSelectObj->SetSelectEventID(eventid);
	return true;
}

u32 WK7RenderSelectObj::GetSelectEventID(void)
{
	if( mpSelectObj==NULL ){
		return 0xffffffff;
	}
	return mpSelectObj->GetSelectEventID();
}

int WK7RenderSelectObj::SelectCallback(void)
{
	return WK7SelectObj::SELECT_OK;
}

int WK7RenderSelectObj::SelectCallback(WK7SelectObj *pObj)
{
	if( pObj==NULL ){
		return WK7SelectObj::SELECT_CANCEL;
	}
	WK7RenderSelectObj		*pSelectObj = (WK7RenderSelectObj *)pObj->GetParam(0);
	if( pSelectObj==NULL ){
		return WK7SelectObj::SELECT_CANCEL;
	}
	return pSelectObj->SelectCallback();
}

u32 WK7RenderObj::GetUniqueRenderID(bool uporder,int startid)
{
	WK7RenderObj	*pObj;
	WK7HitObj		*pHitObj;
	u32				id;
	if( uporder==true ){
		if( startid < 0 ){
			id = 1;
		}else{
			id = (u32)startid;
		}
		do{
			for(pObj=(WK7RenderObj *)mAnchor.GetNext() ; pObj!=NULL ; pObj = pObj->GetNext()){
				if( pObj->mRenderID==id || pObj->mRenderIDEx==id ){
					id++;
					if( id==WK7RENDEROBJ_RENDERID_PLAYER ){
						continue;
					}
					if( id >= WK7RENDEROBJ_RENDERID_MAX ){
						return 0xffffffff;
					}
					break;
				}
			}
			if( pObj==NULL ){
				for(pHitObj=WK7HitObj::GetTopObj() ; pHitObj!=NULL ; pHitObj=pHitObj->GetNext()){
					if( pHitObj->GetRenderID()==id ){
						id++;
						if( id==WK7RENDEROBJ_RENDERID_PLAYER ){
							continue;
						}
						if( id >= WK7RENDEROBJ_RENDERID_MAX ){
							return 0xffffffff;
						}
						break;
					}
				}
			}
		}while( pObj!=NULL || pHitObj!=NULL );
	}else{
		if( startid < 0 ){
			id = WK7RENDEROBJ_RENDERID_MAX-1;
		}else{
			id = (u32)startid;
		}
		do{
			for(pObj=(WK7RenderObj *)mAnchor.GetNext() ; pObj!=NULL ; pObj = pObj->GetNext()){
				if( pObj->mRenderID==id || pObj->mRenderIDEx==id ){
					id--;
					if( id==WK7RENDEROBJ_RENDERID_PLAYER ){
						continue;
					}
					if( id==1 ){
						return 0xffffffff;
					}
					break;
				}
			}
			if( pObj==NULL ){
				for(pHitObj=WK7HitObj::GetTopObj() ; pHitObj!=NULL ; pHitObj=pHitObj->GetNext()){
					if( pHitObj->GetRenderID()==id ){
						id--;
						if( id==WK7RENDEROBJ_RENDERID_PLAYER ){
							continue;
						}
						if( id==1 ){
							return 0xffffffff;
						}
						break;
					}
				}
			}
		}while( pObj!=NULL || pHitObj!=NULL );
	}
	return id;
}

WK7RenderObj::WK7RenderObj()
{
	mpInitThread       = NULL;
	mCreateInit        = true;
	mPrivateLight      = false;
	mppPrivateLight    = NULL;
	mpPrivateLightPos  = NULL;
	mPrivateLightNum   = 0;
	mppPrivateLightSet = NULL;
//	mPlayerLight       = false;
	mLoadWait          = false;
	mRenderFlag        = false;
	mRenderObjFlag     = true;
	mClothEnable       = true;
	mObjLight          = true;
	mDispLight         = 0xffffffff;
	mpArchive          = NULL;
	mpModel            = NULL;
	mpMirrorModel      = NULL;
	mMirrorType        = 0;
//	mpCameraMotion     = NULL;
//	mpLightMotion      = NULL;
//	mpEdgeShadow       = NULL;
//	mpEdgeShadowLight  = NULL;
	mType              = 0xffffffff;
	mID                = 0xffffffff;
	mState             = IDLE;
	mRenderID          = WK7RENDEROBJ_RENDERID_DEFAULT;
	mRenderIDEx        = 0xffffffff;
	mRenderKind        = NORMAL;
	mpCloth            = NULL;
	mClothWarpOffset.x = 
	mClothWarpOffset.y = 
	mClothWarpOffset.z = 0.0f;
}

WK7RenderObj::WK7RenderObj(ghmGcListObj *pAnchor,int prio) : WK7Obj(pAnchor,prio)
{
	mpInitThread       = NULL;
	mCreateInit        = true;
	mPrivateLight      = false;
	mppPrivateLight    = NULL;
	mpPrivateLightPos  = NULL;
	mPrivateLightNum   = 0;
	mppPrivateLightSet = NULL;
//	mPlayerLight       = false;
	mLoadWait          = false;
	mRenderFlag        = false;
	mRenderObjFlag     = true;
	mClothEnable       = true;
	mObjLight          = true;
	mDispLight         = 0xffffffff;
	mpArchive          = NULL;
	mpModel            = NULL;
	mpMirrorModel      = NULL;
	mMirrorType        = 0;
//	mpCameraMotion     = NULL;
//	mpLightMotion      = NULL;
//	mpEdgeShadow       = NULL;
//	mpEdgeShadowLight  = NULL;
	mType              = 0xffffffff;
	mID                = 0xffffffff;
	mState             = IDLE;
	mRenderID          = WK7RENDEROBJ_RENDERID_DEFAULT;
	mRenderKind        = NORMAL;
	mpCloth            = NULL;
	mClothWarpOffset.x = 
	mClothWarpOffset.y = 
	mClothWarpOffset.z = 0.0f;
}

u32 WK7RenderObj::GetMainID(void)
{
	return mID >> 16;
}

u32 WK7RenderObj::GetSuffix(void)
{
	return mID & 0xffff;
}

WK7RenderObj::~WK7RenderObj()
{
	GHM_SAFE_DELETE(mpInitThread);
	ReleasePrivateLight();
	// ֘A郉Cg폜
	if( mType!=0xffffffff || mID!=0xffffffff ){
		WK7Light::Release(mType,mID);
	}
	GHM_SAFE_DELETE(mpCloth);
	WK7RenderObj::DeleteEffectAll();
	// VhE{[폜
//	GHM_SAFE_DELETE(mpEdgeShadow);
//	GHM_SAFE_DELETE(mpCameraMotion);
//	GHM_SAFE_DELETE(mpLightMotion );
	GHM_SAFE_DELETE(mpMirrorModel );
	mMirrorType       = 0;
	GHM_SAFE_DELETE(mpModel       );
}

void WK7RenderObj::SetRenderFlag(bool flag)
{
	mRenderFlag = flag;
	WK7RenderObjRenderObj	*pRenderObjRenderObj;
	WK7RenderObj			*pRenderObj;
	for(pRenderObjRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObjRenderObj!=NULL ; pRenderObjRenderObj=pRenderObjRenderObj->GetNext()){
		if( (pRenderObj = pRenderObjRenderObj->GetRenderObj())==NULL || IsValid(pRenderObj)==false ){
			continue;
		}
		pRenderObj->SetRenderObjFlag(flag);
	}
	WK7RenderObjEffect		*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		pRenderObjEffect->SetDrawFlag(flag);
	}
}

bool WK7RenderObj::GetRenderFlag(bool renderobj)
{
	if( renderobj==true ){
		if( mRenderObjFlag==false ){
			return false;
		}
	}
	return mRenderFlag;
}

bool WK7RenderObj::SetVisibleJObj(const char *pName,bool flag,bool next,bool child)
{
	if( flag==true ){
		return DispJObj(pName,next,child);
	}else{
		return HideJObj(pName,next,child);
	}
}

bool WK7RenderObj::DispJObj(const char *pName,bool next,bool child)
{
	WK7JObj		*pJObj = GetJObj(pName);
	if( pJObj==NULL ){
		return false;
	}
	pJObj->Disp(next,child);
	return true;
}

bool WK7RenderObj::HideJObj(const char *pName,bool next,bool child)
{
	WK7JObj		*pJObj = GetJObj(pName);
	if( pJObj==NULL ){
		return false;
	}
	pJObj->Hide(next,child);
	return true;
}

void WK7RenderObj::SetVisible(bool flag)
{
	if( flag==true ){
		Disp();
	}else{
		Hide();
	}
}

void WK7RenderObj::Disp(void)
{
	SetRenderFlag(true);
	if( mpModel==NULL ){
		return;
	}
	mpModel->Disp(true);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->Disp(true);
	}
}

void WK7RenderObj::Hide(void)
{
	SetRenderFlag(false);
	if( mpModel==NULL ){
		return;
	}
	mpModel->Hide(true);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->Hide(true);
	}
}

bool WK7RenderObj::HideClothCollision(void)
{
	if( mpCloth != NULL ){
		mpCloth->HideCollision();
	}
	return true;
}

void WK7RenderObj::SetClothWarpOffset(const Vec &ofs)
{
	mClothWarpOffset = ofs;
}

void WK7RenderObj::AddClothWarpOffset(const Vec &ofs)
{
	VECAdd(&mClothWarpOffset,&mClothWarpOffset,(Vec *)&ofs);
}

void WK7RenderObj::GetClothWarpOffset(Vec &ofs)
{
	ofs = mClothWarpOffset;
}

bool WK7RenderObj::SetClothEnable(bool flag,bool tobind)
{
	WK7JObj		*pJObj;
	mClothEnable = flag;
	if( flag==true ){
		if( mpModel!=NULL ){
			pJObj = mpModel->GetTopObj();
		}else{
			pJObj = NULL;
		}
		if( mpCloth==NULL && pJObj!=NULL ){
			//zB
			ghmGcMemSetAllocName("C_K7Clot");
			mpCloth = new C_K7Cloth(pJObj->GetJObj(),pJObj->GetJoint());
		}
		if( mpCloth!=NULL ){
			// ƂꂽƂɂƃZbg炵B
			Vec	ofs = {0.1f,0.0f,0.0f};
			if( tobind==true && pJObj!=NULL ){
				pJObj->ResetClothJointToBind();
			}
			mpCloth->SetWarpOfst(ofs);
		}
	}else{
		if( mpModel!=NULL && (pJObj=mpModel->GetTopObj())!=NULL ){
			pJObj->ResetClothJointUserDefinedMatrix();
		}
	}
	return true;
}

bool WK7RenderObj::InitializeLight(void)
{
	// Cgݒ
	C_LightSet		*pLightSet;
	C_LightSet		*pPointLightSet = NULL;
	int				i,num;
	int				type;
	num = mpArchive->GetLightSetNum();
	for(i=0 ; i<num ; i++){
		pLightSet = mpArchive->GetLightSet(i);
		if( pLightSet->lightdesc==NULL ){
			continue;
		}
		switch( type=(pLightSet->lightdesc->flags & LOBJ_TYPE_MASK) ){
		case	LOBJ_POINT:
		case	LOBJ_AMBIENT:
		case	LOBJ_INFINITE:
		case	LOBJ_SPOT:
			break;
		default:
			continue;
		}
		WK7Light	*pLight = WK7Light::Create(pLightSet,mType,mID);
		if( pLight!=NULL ){
			pLight->SetRenderObj(this);
		}
	}
	return true;
}

bool WK7RenderObj::InitializeSelectObj(void)
{
#if 0
	if( mpModel==NULL ){
		return false;
	}
	WK7JObj		*pJObj = mpModel->GetObj("Window");
	if( pJObj==NULL ){
		return false;
	}
	WK7JObj		*pChildJObj;
	for(pChildJObj=pJObj->GetChild() ; pChildJObj!=NULL ; pChildJObj = pChildJObj->GetNext()){
		ghmGcMemSetAllocName("RndrSO");
		WK7RenderSelectObj		*pRenderSelectObj = new WK7RenderSelectObj(&mSelectObjAnchor,this,pChildJObj);
		if( pRenderSelectObj==NULL ){
			continue;
		}
		if( mType==K7OBJTYPE_STG ){
			K7EventDescStgSelectObjContact	*pDesc;
			K7EventDescData					data;
			data.Initialize();
			while( (pDesc=(K7EventDescStgSelectObjContact *)WK7EVENTCONTROLLER->GetEventDesc(K7EVENT_DESC_TYPE_STGSELECTOBJCONTACT,data))!=NULL ){
				if( pDesc->mStgID==mID ){
					if( strcmp(pDesc->mpObjName,pChildJObj->GetName())==0 ){
						pRenderSelectObj->SetSelectEventID(pDesc->mBase.mID);
						pRenderSelectObj->SetSelectObjName(pDesc->mpDispName0,pDesc->mpDispName1);
						break;
					}
				}
			}
		}
		pRenderSelectObj->SetSelectObjEnable(true);
	}
#endif
	return true;
}

bool WK7RenderObj::SetCastShadowCollSphereRedius(f32 r)
{
	WK7CastShadowObj	*pCastShadowObj = WK7SHADOW->FindCastShadowObj(this);
	if( pCastShadowObj==NULL ){
		return false;
	}
	return pCastShadowObj->SetCollSphereRadius(r);
}

f32 WK7RenderObj::GetCastShadowCollSphereRedius(void)
{
	WK7CastShadowObj	*pCastShadowObj = WK7SHADOW->FindCastShadowObj(this);
	if( pCastShadowObj==NULL ){
		return -1.0f;
	}
	return pCastShadowObj->GetCollSphereRadius();
}

bool WK7RenderObj::InitializeShadowVolumeObj(void)
{
	if( mpModel==NULL ){
		return false;
	}
	WK7JObj		*pJObj = mpModel->GetObj("SV");
	if( pJObj==NULL ){
		return false;
	}
	//                                             next ,child
	pJObj->SetRenderMode(WK7JOBJ_RENDERMODE_SHADOW,false,true);
//	WK7JObj		*pChildJObj;
//	for(pChildJObj=pJObj->GetChild() ; pChildJObj!=NULL ; pChildJObj = pChildJObj->GetNext()){
//		pChildJObj->SetRenderMode(WK7JOBJ_RENDERMODE_SHADOW);
//	}
	return true;
}

bool WK7RenderObj::SetMirrorType(u32 mirrorType)
{
	mMirrorType = mirrorType;
	return true;
}

bool WK7RenderObj::CreateMirrorModel(void)
{
	if( mpArchive==NULL || mpModel==NULL || mMirrorType==0 ){
		return false;
	}
	ReleaseMirrorModel();
	if( (mpMirrorModel = mpModel->CreateMirrorModel(mMirrorType))==NULL ){
		return false;
	}
	return true;
}

bool WK7RenderObj::ReleaseMirrorModel(void)
{
	GHM_SAFE_DELETE(mpMirrorModel);
	return true;
}

bool WK7RenderObj::ReleaseArchive(void)
{
	switch( mState ){
	case	LOADED:
		break;
	case	RELEASEARCHIVE:
	case	RELEASEDARCHIVE:
		return true;
	default:
		return false;
	}
	WK7RenderObjRenderObj	*pRenderObj;
	WK7RenderObjMotionObj	*pMotionObj;
	for(pRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		pRenderObj->Release();
	}
	for(pMotionObj=(WK7RenderObjMotionObj *)mMotionObjAnchor.GetNext() ; pMotionObj!=NULL ; pMotionObj=pMotionObj->GetNext()){
		pMotionObj->Release();
	}
	DeleteEffectAll();
	GHM_SAFE_DELETE(mpCloth);
	GHM_SAFE_DELETE(mpMirrorModel );
	GHM_SAFE_DELETE(mpModel       );
	SetArchive(NULL);
	SetState(RELEASEARCHIVE);
	_ReleasePrivateLight();
	WK7Light::Release(mType,mID);
	return true;
}

bool WK7RenderObj::RestoreArchive(void)
{
	switch( mState ){
	case	RELEASEDARCHIVE:
		break;
	case	LOADED:
		return true;
	default:
		return false;
	}
	if( RestoreObj()==false ){
		return false;
	}
	WK7RenderObjRenderObj	*pRenderObj;
	WK7RenderObjMotionObj	*pMotionObj;
	for(pRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		pRenderObj->Restore();
	}
	for(pMotionObj=(WK7RenderObjMotionObj *)mMotionObjAnchor.GetNext() ; pMotionObj!=NULL ; pMotionObj=pMotionObj->GetNext()){
		pMotionObj->Restore();
	}
//	SetState(RESTOREARCHIVE);
	return true;
}

bool WK7RenderObj::LoadReserveProcess(void)
{
	if( mLoadWait==true ){
		return false;
	}
	if( LoadObj(mType,mID)==false ){
//		SetState(IDLE);
		return false;
	}
//	SetState(LOADING);
	return true;
}

bool WK7RenderObj::LoadingProcess(void)
{
	if( mpArchive==NULL ){
		return false;
	}
	if( mpArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
		return false;
	}
	if( IsOwnMotionObjLoaded()==false ){
		return false;
	}
	if( IsOwnRenderObjLoaded()==false ){
		return false;
	}
	if( (mpModel = mpArchive->CreateModel())==NULL ){
		return false;
	}
//	CreateMirrorModel();
//	Initialize();
	return true;
}

void* WK7RenderObj::_InitializeThread(void *pParam)
{
	WK7RenderObj	*pRenderObj = (WK7RenderObj *)pParam;
	void			*pResult    = NULL;
	if( pRenderObj!=NULL ){
		pResult = pRenderObj->InitializeThread();
	}
	return pResult;
}

void* WK7RenderObj::InitializeThread(void)
{
	if( mpModel!=NULL ){
		mpModel->MakeBound();
	}
	if( mClothEnable==true ){
		SetClothEnable(true);
	}
	return NULL;
}

bool WK7RenderObj::LoadAfterInit(void)
{
	ghmGcMemSetAllocName("RO_LA_TH");
	if( (mpInitThread = new ghmGcThread(_InitializeThread,(u32)this,18,WK7RENDEROBJ_INITTHREAD_STACKSIZE))==NULL ){
		return false;
	}
	if( mpInitThread->IsCreated()==false ){
		GHM_SAFE_DELETE(mpInitThread);
		return false;
	}
	mpInitThread->Resume();
	return true;
}

bool WK7RenderObj::IsLoadingAfterInit(void)
{
	if( mpInitThread!=NULL && mpInitThread->IsTerminated()==false ){
		return true;
	}
	GHM_SAFE_DELETE(mpInitThread);
	CreateMirrorModel();
	Initialize();
	return false;
}

bool WK7RenderObj::PrivateLightProcess(void)
{
	if( mPrivateLight==false ){
		return true;
	}
	if( mppPrivateLight==NULL ){
		if( CreatePrivateLight()==false ){
			return false;
		}
		if( mppPrivateLight==NULL ){
			return false;
		}
	}
	
	Vec		pos;
	MtxPtr	vmtx = WK7CAM->GetViewingMtxPtrCurrent();//GetViewingMtxPtr();
	Mtx		ivmtx;
	int		i;
	
	MTXTranspose(vmtx,ivmtx);
	
	for(i=0 ; i<mPrivateLightNum ; i++){
		if( mppPrivateLight[i]==NULL ){
			continue;
		}
		MTXMultVecSR(ivmtx,mpPrivateLightPos + i,&pos);
		mppPrivateLight[i]->SetPosition(&pos,0);
	}
	
	return true;
}

bool WK7RenderObj::LoadedProcess(void)
{
//	PrivateLightProcess();
	mpModel->FrameProcess();
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->FrameProcess();
	}
//	if( mpCloth!=NULL && mClothEnable==true ){
//		mpCloth->Proc();
//	}
	return true;
}

bool WK7RenderObj::ReleaseArchiveProcess(void)
{
	SetState(RELEASEDARCHIVE);
	return true;
}

bool WK7RenderObj::RestoreArchiveProcess(void)
{
	return LoadingProcess();
}

bool WK7RenderObj::Initialize(void)
{
	// Cgݒ
//	InitializeLight();
	// GtFNgNA
	ClearEffect();
	// IIuWFNgݒ
	InitializeSelectObj();
	// VhE{[IuWFNgݒ
	InitializeShadowVolumeObj();
#if FUJITA
//	if( mpModel!=NULL && mpModel->GetTopObj()!=NULL && mClothEnable==true ){
//		//zB
//		ghmGcMemSetAllocName("C_K7Clot");
//		mpCloth = new C_K7Cloth( mpModel->GetTopObj()->GetJObj(), mpModel->GetTopObj()->GetJoint() );
//	}
#endif
	if( mPrivateLight==true ){
		CreatePrivateLight();
	}
	return true;
}

static	f32	LARGE_MOVE_DIST		= 50.0f;
//#define	LARGE_MOVE_DIST		(50.0f)
bool WK7RenderObj::StateProcess(void)
{
	if( mState!=LOADED ){
		return false;
	}
	if( mpCloth!=NULL && mClothEnable==true ){
		if( VECMag(&mClothWarpOffset) > LARGE_MOVE_DIST ){
			mpCloth->SetWarpOfst(mClothWarpOffset);
		}
		mpCloth->Proc();
		mClothWarpOffset.x = 
		mClothWarpOffset.y = 
		mClothWarpOffset.z = 0.0f;
	}
	return true;
}

bool WK7RenderObj::FrameProcess(void)
{
	
	FrameProcessEffect();
	
	switch( mState ){
	case	LOADRESERVE:
		if( LoadReserveProcess()==false ){
			break;
		}
	case	LOADING:
		if( LoadingProcess()==false ){
			break;
		}
		SetState(LOADING_AFTERINIT_CALL);
	case	LOADING_AFTERINIT_CALL:
		if( LoadAfterInit()==false ){
			break;
		}
		SetState(LOADING_AFTERINIT);
	case	LOADING_AFTERINIT:
		if( IsLoadingAfterInit()==true ){
			break;
		}
		SetState(LOADING_AFTERINIT2_CALL);
	case	LOADING_AFTERINIT2_CALL:
		if( LoadAfterInit2()==false ){
			break;
		}
		SetState(LOADING_AFTERINIT2);
	case	LOADING_AFTERINIT2:
		if( IsLoadingAfterInit2()==true ){
			break;
		}
		SetState(LOADING_AFTERINIT3_CALL);
	case	LOADING_AFTERINIT3_CALL:
		if( LoadAfterInit3()==false ){
			break;
		}
		SetState(LOADING_AFTERINIT3);
	case	LOADING_AFTERINIT3:
		if( IsLoadingAfterInit3()==true ){
			break;
		}
		mCreateInit = true;
		SetState(LOADED);
	case	LOADED:
		if( LoadedProcess()==false ){
			break;
		}
		break;
	case	RELEASEARCHIVE:
		if( ReleaseArchiveProcess()==false ){
			break;
		}
		break;
	case	RELEASEDARCHIVE:
		break;
	case	RESTOREARCHIVE:
		if( RestoreArchiveProcess()==false ){
			break;
		}
		if( LoadAfterInit()==false ){
			SetState(LOADING_AFTERINIT_CALL);
		}else{
			SetState(LOADING_AFTERINIT);
		}
		break;
	default:
	case	IDLE:
		return false;
	}
	
	return true;
}

bool WK7RenderObj::CreateLightCallback(WK7Light */*pLight*/)
{
	return true;
}

bool WK7RenderObj::ReleaseLightCallback(WK7Light *pLight)
{
	u32		mask = 1UL<<pLight->GetLightID();
	mDispLight |= mask;
	return true;
}

bool WK7RenderObj::CreateLightCallbackAll(WK7Light *pLight)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		pObj->CreateLightCallback(pLight);
		pObj = pObj->GetNext();
	}
	return true;
}

bool WK7RenderObj::ReleaseLightCallbackAll(WK7Light *pLight)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		pObj->ReleaseLightCallback(pLight);
		pObj = pObj->GetNext();
	}
	return true;
}

static	HSD_WObjDesc	privateLight_pos_wobjdesc = {
	NULL,
	{ -4.0f , 2.0f , 5.0f }
};

static	HSD_LightDesc	privateLightDesc = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE,					// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 0xc0, 0xc0, 0xc0, 0xff },					// color
//	{ 0xff, 0xff, 0xff, 0xff },					// color
	&privateLight_pos_wobjdesc,					// position
	NULL,
	NULL,
};

static HSD_SceneLightSet privateLightSet = {
	&privateLightDesc,
	NULL,
};


bool WK7RenderObj::SetPrivateLight(HSD_SceneLightSet **ppLightSet)
{
	mppPrivateLightSet = ppLightSet;
	return true;
}

bool WK7RenderObj::CreatePrivateLight(void)
{
	int		i;
	mPrivateLight = true;
	_ReleasePrivateLight();
	
	C_LightSet			*pLightSet;
	if( mppPrivateLightSet==NULL ){
		if( mpArchive!=NULL && (mPrivateLightNum=mpArchive->GetLightSetNum()) > 0 ){
			ghmGcMemSetAllocName("ROPLTAR0");
			if( (mppPrivateLight = new WK7Light*[mPrivateLightNum])==NULL ){
				return false;
			}
			for(i=0 ; i<mPrivateLightNum ; i++){
				mppPrivateLight[i] = NULL;
			}
			for(i=0 ; i<mPrivateLightNum ; i++){
				pLightSet = mpArchive->GetLightSet(i);
				if( pLightSet==NULL ){
					_ReleasePrivateLight();
					return NULL;
				}
				if( (mppPrivateLight[i] = WK7Light::Create(pLightSet,mType,mID))==NULL ){
					_ReleasePrivateLight();
					return false;
				}
			}
		}else{
			mPrivateLightNum = 1;
			ghmGcMemSetAllocName("ROPLTAR1");
			if( (mppPrivateLight = new WK7Light*[mPrivateLightNum])==NULL ){
				_ReleasePrivateLight();
				return false;
			}
			if( (mppPrivateLight[0] = WK7Light::Create(new (&privateLightSet) C_LightSet,mType,mID))==NULL ){
				_ReleasePrivateLight();
				return false;
			}
		}
	}else{
		for(mPrivateLightNum=0 ; mppPrivateLightSet[mPrivateLightNum]!=NULL ; mPrivateLightNum++){}
		ghmGcMemSetAllocName("ROPLTAR2");
		if( (mppPrivateLight = new WK7Light*[mPrivateLightNum])==NULL ){
			return false;
		}
		for(i=0 ; i<mPrivateLightNum ; i++){
			mppPrivateLight[i] = NULL;
		}
		for(i=0 ; i<mPrivateLightNum ; i++){
			if( (mppPrivateLight[i] = WK7Light::Create(new (mppPrivateLightSet[i]) C_LightSet,mType,mID))==NULL ){
				_ReleasePrivateLight();
				return false;
			}
		}
	}
	if( mPrivateLightNum > 0 ){
		ghmGcMemSetAllocName("ROPLTPOS");
		if( (mpPrivateLightPos = new Vec[mPrivateLightNum])==NULL ){
			_ReleasePrivateLight();
			return false;
		}
		for(i=0 ; i<mPrivateLightNum ; i++){
			if( mppPrivateLight[i]==NULL ){
				continue;
			}
			mppPrivateLight[i]->GetPosition(mpPrivateLightPos + i,0);
			mppPrivateLight[i]->SetPrivate(true);
		}
	}
	return true;
}

bool WK7RenderObj::_ReleasePrivateLight(void)
{
	int		i;
	if( mppPrivateLight!=NULL ){
		for(i=0 ; i<mPrivateLightNum ; i++){
			GHM_SAFE_DELETE(mppPrivateLight[i]);
		}
		GHM_SAFE_DELETE_ARRAY(mppPrivateLight);
	}
	GHM_SAFE_DELETE_ARRAY(mpPrivateLightPos);
	mPrivateLightNum = 0;
	return true;
}

bool WK7RenderObj::ReleasePrivateLight(void)
{
	_ReleasePrivateLight();
	mPrivateLight = false;
	return true;
}

bool WK7RenderObj::DispPrivateLight(WK7Light *pLight,u32 mirrorType,Vec *pPos)
{
	if( mPrivateLight==false ){
		return false;
	}
	int		i;
	for(i=GetPrivateLightNum()-1 ; i>=0 ; i--){
		if( pLight!=GetPrivateLight(i) ){
			continue;
		}
		if( pLight->GetObjectType()!=mType || pLight->GetObjectID()!=mID ){
			continue;
		}
		pLight->Disp(mirrorType,pPos);
		break;
	}
	return true;
}

bool WK7RenderObj::DispLight(u32 mirrorType,Vec *pPos)
{
//	WK7Light			*pPlayerLight = WK7PLAYERCONTROL->GetLight();
	WK7Light			*pLight;
	WK7LightFindData	data;
	data.Initialize();
	while( (pLight=WK7Light::Find(data))!=NULL ){
		if( mObjLight==false ){
			if( pLight->GetObjectType()==mType && pLight->GetObjectID()==mID ){
				continue;
			}
		}
		if( pLight->GetPrivate()==true ){
			DispPrivateLight(pLight,mirrorType,pPos);
		}else{
			if( mDispLight & pLight->GetLightIDBit() ){
				pLight->Disp(mirrorType,pPos);
			}
		}
	}
	return true;
}

bool WK7RenderObj::SetDispLightAll(bool flag)
{
	if( flag==true ){
		mDispLight = 0xffffffff;
	}else{
		mDispLight = 0x00000000;
	}
	return true;
}

bool WK7RenderObj::SetDispLight(WK7Light *pLight,bool flag)
{
	u32		bit = pLight->GetLightIDBit();
	if( bit==0 ){
		return false;
	}
	if( flag==true ){
		mDispLight |=  bit;
	}else{
		mDispLight &= ~bit;
	}
	return true;
}

bool WK7RenderObj::SetDispLight(u32 id,bool flag)
{
	WK7Light		*pLight = WK7Light::Find(id);
	if( pLight==NULL ){
		return false;
	}
	return SetDispLight(pLight,flag);
}

bool WK7RenderObj::GetDispLight(WK7Light *pLight)
{
	u32		bit = pLight->GetLightIDBit();
	if( bit==0 ){
		return false;
	}
	return (mDispLight & bit)? true : false;
}

bool WK7RenderObj::GetDispLight(u32 id)
{
	WK7Light		*pLight = WK7Light::Find(id);
	if( pLight==NULL ){
		return false;
	}
	return GetDispLight(pLight);
}

typedef	void HSD_ZListCallbackFunc(void *pData);

extern "C"{
extern	void HSD_ZListSetRenderObj(HSD_ZListCallbackFunc *pRenderObjCallbackFunc,void *pRenderObj,u32 mirrorType,const Vec *pMirrorPos);
}

struct _HSD_ZList {
  Mtx pmtx;
  MtxPtr vmtx;
  HSD_JObj *jobj;
  u32 rendermode;

  struct {
    _HSD_ZList *texedge;
    _HSD_ZList *xlu;
  } sort;

  _HSD_ZList *next;

#ifdef	WATANABE
	HSD_ZListCallbackFunc	*pPreCallbackFunc;
	HSD_ZListCallbackFunc	*pPostCallbackFunc;
	void					*pCallbackData;
	HSD_ZListCallbackFunc	*pRenderObjCallbackFunc;
	void					*pRenderObj;
	u32						mirrorType;
	Vec						mirrorPos;
#endif
};

bool WK7RenderObj::_ZSortCallback(u32 mirrorType,Vec *pMirrorPos)
{
	WK7Light::DispStart();
	DispLight(mirrorType,pMirrorPos);
	WK7Light::DispEnd();
	return true;
}

void WK7RenderObj::ZSortCallback(void *list)
{
	_HSD_ZList	*pZList = (_HSD_ZList *)list;
	if( pZList==NULL ){
		return;
	}
	WK7RenderObj	*pRenderObj;
	if( (pRenderObj=(WK7RenderObj *)pZList->pRenderObj)==NULL ){
		return;
	}
	pRenderObj->_ZSortCallback(pZList->mirrorType,&pZList->mirrorPos);
}

bool WK7RenderObj::RenderProcess(void)
{
	if( mRenderFlag==false || mRenderObjFlag==false ){
		return true;
	}
	if( mState != LOADED ){
		return true;
	}
	if( mpModel==NULL ){
		return false;
	}
	
#if FUJITA
	if( mpAdditionalPreRender ) mpAdditionalPreRender->AdditionalPreRenderProcess();
#endif
	HSD_ZListSetRenderObj(WK7RenderObj::ZSortCallback,this,0,NULL);	
	WK7Light::DispStart();
	DispLight();
	WK7Light::DispEnd();
	mpModel->RenderProcess();
	if( mpMirrorModel!=NULL ){
		Vec		pos;
		mpMirrorModel->GetMirrorPos(pos);
		HSD_ZListSetRenderObj(WK7RenderObj::ZSortCallback,this,mpMirrorModel->GetMirrorType(),&pos);	
		WK7Light::DispStart();
		DispLight(mpMirrorModel->GetMirrorType(),&pos);
		WK7Light::DispEnd();
		mpMirrorModel->RenderProcess();
	}
#if FUJITA
	if( mpAdditionalPostRender ) mpAdditionalPostRender->AdditionalPostRenderProcess();
#endif
#if FUJITA
	//fobOp̃Ct[
#ifdef	_DEBUG
//	if( HSD_PadGetButton(0) & HSD_PAD_Z )mpCloth->Disp();
	if( HSD_PadGetButton(1) & HSD_PAD_Z && mpCloth )mpCloth->Disp();
#endif
#endif
	HSD_ZListSetRenderObj(NULL,NULL,0,NULL);	
	return true;
}

bool WK7RenderObj::RenderEdgeShadow(void)
{
	return true;
}

bool WK7RenderObj::SetRenderIDEx(WK7JObj *pJObj,bool next,bool child)
{
	return SetRenderID(pJObj,ConvRenderIDToAlpha(mRenderIDEx),next,child);
}

bool WK7RenderObj::SetRenderID(WK7JObj *pJObj,u32 alpha,bool next,bool child)
{
	if( pJObj==NULL ){
		return true;
	}
	const WK7JObjAttr		*pAttr;
	if( (pAttr=pJObj->GetAttr())==NULL || pAttr->GetNoHit()==false ){
		pJObj->SetDstAlpha((u8)alpha,false,false);
		pJObj->SetAlphaUpdate(true,false,false,JOBJ_XLU);
	}
	SetRenderID(pJObj->GetChild(),alpha,true,true);
	if( next==true && pJObj->GetPrev()==NULL ){
		for(pJObj=pJObj->GetNext() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
			SetRenderID(pJObj,alpha,true,child);
		}
	}
	return true;
}

bool WK7RenderObj::SetRenderIDEx(u32 renderid)
{
	mRenderIDEx = renderid;
	return true;
}

bool WK7RenderObj::SetRenderID(u32 renderid)
{
	if( renderid > WK7RENDEROBJ_RENDERID_MAX ){
		return false;
	}
	mRenderID = renderid;
	if( mpModel!=NULL ){
		mpModel->SetDstAlpha(ConvRenderIDToAlpha(mRenderID));
	}
	return true;
}

bool WK7RenderObj::AllocRenderID(bool uporder,int startid)
{
	mRenderID = 0xffffffff;
	if( (mRenderID = GetUniqueRenderID(uporder,startid))==0xffffffff ){
		FreeRenderID();
	}
	return true;
}

bool WK7RenderObj::SetPlayerRenderID(void)
{
	mRenderID = WK7RENDEROBJ_RENDERID_PLAYER;
	if( mpModel==NULL ){
		return false;
	}
	mpModel->SetPE(&normalPEDesc);
	mpModel->SetDstAlpha(ConvRenderIDToAlpha(mRenderID));
	SetRenderKind(NORMAL);
	return true;
}

bool WK7RenderObj::FreeRenderID(void)
{
	mRenderID = WK7RENDEROBJ_RENDERID_DEFAULT;
	return true;
}

bool WK7RenderObj::EnableVfxEffect(void)
{
static	HSD_PEDesc		vfx_pe = {
		//J[AAt@AŒAt@݁AZobt@SăGiuB
//		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE,
		ENABLE_COLOR_UPDATE|ENABLE_ALPHA_UPDATE|ENABLE_DST_ALPHA|ENABLE_COMPARE|ENABLE_ZUPDATE|ENABLE_DITHER|BEFORE_TEX,
		//GXSetAlphaCompare(),ref0,ref1
		//At@RyA͎gȂB
		0,0,
		//GXSetDstAlpha(),dst_alpha
		//ɌŒl255ށBiCgeNX`̉e͂Ȃj
		255,
		//GXSetBlendMode(),type,src_factor,dst_factor,logic_op
		//uh͂Ȃ̂src_factorAdst_factor, logic_op͂ǂł悢B
		GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR,
//		GX_BM_NONE,  GX_BL_DSTALPHA,  GX_BL_INVDSTALPHA,  GX_LO_CLEAR,
		//GXSetZMode(),func
		//Zr͒ʏǂB
		GX_LEQUAL,
		//GXAlphaCompare,comp0,op,comp1
		//At@RyA͎gȂB
		GX_ALWAYS,GX_AOP_AND,GX_ALWAYS
	};
	if( mpModel==NULL ){
		return false;
	}
	if( mRenderID==WK7RENDEROBJ_RENDERID_DEFAULT ){
		return false;
	}
	mpModel->SetPE(&vfx_pe);
//	mpModel->SetDstAlpha(0xff);
	mpModel->SetDstAlpha(ConvRenderIDToAlpha(mRenderID));
	SetRenderKind(VFXEFFECT);
	return true;
}

u8 WK7RenderObj::ConvRenderIDToAlpha(u32 renderid)
{
	if( renderid==WK7RENDEROBJ_INVALID_RENDERID ){
		return 0;
	}
	if( renderid >= WK7RENDEROBJ_RENDERID_MAX ){
		return 0;
	}
	return (u8)(renderid << 3);
}

u32 WK7RenderObj::ConvAlphaToRenderID(u8 alpha)
{
	return (u32)(alpha >> 3);
}

WK7RenderObj* WK7RenderObj::FindRenderID(u32 renderid)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		if( pObj->GetRenderID()==renderid || pObj->GetRenderIDEx()==renderid ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

//void C_VFX::Disp(void)
//{
//	if( intensity<=0.0f ){
//		return;
//	}
//	C_2DCam cam;
//	if( cam.DispStart() ){
//	  GXSetVerifyLevel( GX_WARN_NONE );
//	  //`l
//	  GXSetNumChans(0);
//
//	  //eNX`
//	  GXLoadTexObj(texture.GetTexObj(), GX_TEXMAP0);
//	  GXLoadTexObj(indirect_texture.GetTexObj(), GX_TEXMAP1);
//
//	  //eNX`W
//	  GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY);
//	  GXSetNumTexGens(1);
//
//	  //Tev1 C_CNg
//	
//#if FUJITA
//	  //̂hc悤ɕύXB 
//	  //𑜓xAԂł̂ɌB
//	  static	GXColor			col = { 0x00,0x00,0x00,0x7f };
//	  
//	  if( target_alpha >= 0 ){
//		col.a = (u8)target_alpha;
//	  }else{
//		col.a = (u8)0x7f;
//	  }
//	  if( r >= 0 ) col.r = (u8)r; else col.r = 0;
//	  if( g >= 0 ) col.g = (u8)g; else col.g = 0;
//	  if( b >= 0 ) col.b = (u8)b; else col.b = 0;
//
//	  GXSetTevColor    (GX_TEVREG0,col);
//#else
//	static	GXColor			col = { 0x00,0x00,0x00,0x7f };
//	GXSetTevColor    (GX_TEVREG0,col);
//#endif
//	GXSetTevKAlphaSel(GX_TEVSTAGE1,GX_TEV_KASEL_1);
//	if( col.r || col.g || col.b ){
//	  GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_CPREV,GX_CC_C0,GX_CC_APREV,GX_CC_ZERO);
//#if 0
//	  //l^
//	  //ƃAt@̏܂ꂽɔwiāAAt@̂ȂɐԂB
//	  //At@̏܂ꂽ̗֊st߂ł́AAt@̂Ȃ̐FiԐFj
//	  //Ă̂ŁAwiPF̏ꍇ͂ŗ֊ŝ݂̐悪邱ƂɂȂB
//	  //GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_C0,GX_CC_CPREV,GX_CC_APREV,GX_CC_ZERO);
//#endif
//	  GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	}else{
//	  GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
//	  GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	}
//	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_A0,GX_CA_KONST,GX_CA_ZERO);
////	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
//	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
//	
////	GXSetTevKAlphaSel(GX_TEVSTAGE0,GX_TEV_KASEL_1);
////	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
////	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
////	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
////	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
////	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
//	
////	GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
////	GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
////	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_APREV);
////	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
////	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
//	
////	GXSetTevOrder    (GX_TEVSTAGE1, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL);
////	GXSetTevOp       (GX_TEVSTAGE1, GX_REPLACE);
//
//	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL);
//	GXSetTevOp(GX_TEVSTAGE0, GX_REPLACE);
//	  
//	  //GXSetAlphaCompare( GX_EQUAL, 255, GX_AOP_OR, GX_EQUAL, 255 );
//	  
////	  GXSetNumTevStages(1);
//	  GXSetNumTevStages(2);
//
//	  //C_CNg
//	  GXSetNumIndStages(1);
//	  GXSetIndTexOrder(GX_INDTEXSTAGE0, GX_TEXCOORD0, GX_TEXMAP1);
//	  GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_8, GX_ITS_8);
//	  GXSetTevIndWarp(GX_TEVSTAGE0,       // tev stage
////	  GXSetTevIndWarp(GX_TEVSTAGE1,       // tev stage
//					  GX_INDTEXSTAGE0,    // indirect stage
//					  GX_TRUE,            // signed offsets?
//					  GX_FALSE,           // replace mode?
//					  GX_ITM_0);          // ind matrix select
//	  GXSetTevDirect (GX_TEVSTAGE1);
//
//	  f32 indMtx[2][3];
//	  Mtx tmpMtx,r,s;
//
//	  MTXRotDeg(r, 'z', counter*20);
//	  MTXScale(s, intensity, intensity, intensity );
//	  MTXConcat( r,s,tmpMtx );
//	  indMtx[0][0] = tmpMtx[0][0]*0.5f;
//	  indMtx[0][1] = tmpMtx[0][1]*0.5f;
//	  indMtx[0][2] = 0.0f;
//	  indMtx[1][0] = tmpMtx[1][0]*0.5f;
//	  indMtx[1][1] = tmpMtx[1][1]*0.5f;
//	  indMtx[1][2] = 0.0f;
//	  GXSetIndTexMtx(GX_ITM_0, indMtx, 1);
//
//	  //PE
//	  GXSetColorUpdate( GX_ENABLE );
//	  GXSetAlphaUpdate( GX_DISABLE );
//	  //GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
////	  GXSetBlendMode(GX_BM_BLEND, GX_BL_DSTALPHA, GX_BL_INVDSTALPHA, GX_LO_CLEAR);
//	  GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
//	  GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
//
//	  //ʑS̕`B
//	  GXRenderModeObj *rmode = HSD_VIGetConfigure();
//	  MTXIdentity(tmpMtx);
//	  GXLoadPosMtxImm(tmpMtx, GX_PNMTX0);
//	  GXSetCurrentMtx( GX_PNMTX0 );
//	  GXClearVtxDesc();
//	  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
//	  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
//	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
//	  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);
//
//#define	ZMID -0.5f
//	  GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
//		GXPosition3f32((f32)0, (f32)0, ZMID);
//		GXTexCoord2f32(0,0);
//		
//		GXPosition3f32((f32)0+(f32)rmode->viWidth, (f32)0, ZMID);
//		GXTexCoord2f32(1,0);
//
//		GXPosition3f32((f32)0+(f32)rmode->viWidth, 
//					   (f32)0+(f32)rmode->viHeight, ZMID);
//		GXTexCoord2f32(1,1);
//			
//		GXPosition3f32((f32)0, (f32)0+(f32)rmode->viHeight, ZMID);
//		GXTexCoord2f32(0,1);
//	  }GXEnd();
//	  GXSetNumIndStages(0);
//	  GXSetTevDirect(GX_TEVSTAGE0);
//	  //GXSetAlphaCompare( GX_ALWAYS, 255, GX_AOP_OR, GX_ALWAYS, 255 );
//	  HSD_StateInvalidate( HSD_STATE_ALL );
//	  cam.DispEnd();
//	}
//}

bool WK7RenderObj::ClearEffect(void)
{
	if( mpModel==NULL ){
		return false;
	}
	HSD_PEDesc	*pPEDesc = GetNormalPEDesc();
	mpModel->SetPE(pPEDesc);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->SetPE(pPEDesc);
	}
	SetRenderKind(NORMAL);
	SetRenderID(WK7RENDEROBJ_RENDERID_DEFAULT);
	return true;
}

bool WK7RenderObj::RestoreObj(void)
{
	WK7Archive	*pArchive;
	if( (pArchive = WK7Archive::Find(mType,mID))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		if( GetReserveFileName()!=NULL ){
			strncpy(filename,GetReserveFileName(),WK7_FNAME_MAX-1);
			ClearReserveFileName();
		}else{
			GetObjFileName(filename,mID);
		}
		// ACe^Cvɐݒ
		pArchive->SetType(mType);
		// hcݒ
		pArchive->SetID  (mID);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	WK7Model	*pModel;
	SetArchive(pArchive);
	if( (pModel = pArchive->CreateModel())==NULL ){
		SetState(RESTOREARCHIVE);
		SetModel(pModel);
	}else{
		SetModel(pModel);
		if( LoadAfterInit()==false ){
			SetState(LOADING_AFTERINIT_CALL);
		}else{
			SetState(LOADING_AFTERINIT);
		}
	}
	return true;
}

bool WK7RenderObj::LoadObj(u32 type,u32 id)
{
	WK7Archive	*pArchive;
	if( mLoadWait==true ){
		SetType (type);
		SetID   (id);
		SetState(LOADRESERVE);
		return true;
	}
	if( (pArchive = WK7Archive::Find(type,id))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		if( GetReserveFileName()!=NULL ){
			strncpy(filename,GetReserveFileName(),WK7_FNAME_MAX-1);
			ClearReserveFileName();
		}else{
			GetObjFileName(filename,id);
		}
		// ACe^Cvɐݒ
		pArchive->SetType(type);
		// hcݒ
		pArchive->SetID  (id);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	WK7Model	*pModel;
	SetArchive(pArchive);
	SetType   (type);
	SetID     (id);
	if( (pModel = pArchive->CreateModel())==NULL ){
		SetState(LOADING);
		SetModel(pModel);
	}else{
		SetModel(pModel);
		if( LoadAfterInit()==false ){
			SetState(LOADING_AFTERINIT_CALL);
		}else{
			SetState(LOADING_AFTERINIT);
		}
	}
	return true;
}

bool WK7RenderObj::IsValid(WK7RenderObj *pRenderObj)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		if( pObj==pRenderObj ){
			return true;
		}
		pObj = pObj->GetNext();
	}
	return false;
}

WK7RenderObj* WK7RenderObj::Find(u32 type,u32 id)
{
	WK7RenderObj		*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		if( pObj->GetType()==type && pObj->GetID()==id ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

//                                CEL FUK KAK TXS ISZ CUR DM1 DM2 HT1 SCL HT2 GNK
static u8	defModelSuffix [] = {   0,  1,  1,  2,  3,  3,  4,  4,  5,  5,  5,255 };		// ftHgTtBbNX
static u8	galModelSuffix [] = {   0,  1,  1,  2,  3,  3,  4,  4,  5,  5,  5,  6 };		// KVAp
static u8	smaModelSuffix [] = {   0,  1,  1,  2,  3,  3,  4,  4,255,255,255,255 };		// T}Tp
static u8	mskModelSuffixN[] = {   0, 10, 20, 30, 40, 50, 60, 70,255,255,255,255 };		// }XNim[}jp
static u8	mskModelSuffixT[] = { 255,255,255,255,  4, 14, 24, 34,255,255,255,255 };		// }XNieLTXjp
static u8	mskModelSuffixF[] = { 255,255,255,255,255,255,255,  5,  5,  5,  5,255 };		// }XNit@Cijp
static u8	mskModelSuffixI[] = { 255,255,255,255,255,255,255,  6,  6,  6,  6,255 };		// }XNiSʁjp
u32 WK7RenderObj::ConvCharaID(u32 charaid)
{
	int		flow;
	
	switch( (flow=GameInfo.GetScenarioFlow()) ){
	case	K7SCNF_CEL:
	case	K7SCNF_FUK:
	case	K7SCNF_KAK:
	case	K7SCNF_TXS:
	case	K7SCNF_ISZ:
	case	K7SCNF_CUR:
	case	K7SCNF_DM1:
	case	K7SCNF_DM2:
	case	K7SCNF_HT1:
	case	K7SCNF_SCL:
	case	K7SCNF_HT2:
	case	K7SCNF_GNK:
		break;
	default:
		return charaid;
	}
	
	u32		mainid = K7CHR_MAINID(charaid);
	u32		suffix = K7CHR_SUFFIX(charaid);
	u8		*pSuffix;
	u32		suffixofs = 0;
	
	switch( mainid ){
	case	K7DAN:
	case	K7CAT:
	case	K7CYO:
	case	K7KED:
	case	K7KVN: pSuffix = defModelSuffix; break;
	case	K7GAL: pSuffix = galModelSuffix; break;
	case	K7SMA:
		if( suffix >= 50 ){
			suffixofs = 50;
		}
		pSuffix = smaModelSuffix;
		break;
	case	K7MSK:
		switch( BattleCtrl.GetMskPowerUp() ){
		case	KK7BATTLECTRL_MSKLV_TEXAS:    pSuffix = mskModelSuffixT; break;
		case	KK7BATTLECTRL_MSKLV_FINAL:    pSuffix = mskModelSuffixF; break;
		case	KK7BATTLECTRL_MSKLV_TEKKAMEN: pSuffix = mskModelSuffixI; break;
		case	KK7BATTLECTRL_MSKLV_NORMAL:
		default:                              pSuffix = mskModelSuffixN; break;
		}
		break;
	default:
	case	K7HAC:
		return charaid;
	}
	
	if( pSuffix[flow]==0xff ){
		return charaid;
	}
	
	return K7CHRID(mainid,pSuffix[flow] + suffixofs);
}

WK7Chara* WK7RenderObj::CreateChara(u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7Chara");
	WK7Chara	*pChara = new WK7Chara(&mAnchor,prio);
	id = ConvCharaID(id);
	if( pChara==NULL || pChara->LoadObj(K7OBJTYPE_CHR,id)==false ){
		GHM_SAFE_DELETE(pChara);
		return NULL;
	}
	return pChara;
}

WK7Stage* WK7RenderObj::CreateStage(u32 id,bool loadwait,int prio)
{
	WK7Stage	*pStage = WK7Stage::CreateStage(id,prio);
	if( pStage==NULL ){
		return NULL;
	}
	pStage->SetType(K7OBJTYPE_STG);
	pStage->SetID  (id);
	pStage->SetLoadWait(loadwait);
	if( WK7EVENTCONTROLLER!=NULL ){
		K7EventDescStgCreate	*pDesc;
		K7EventDescData			data;
		data.Initialize();
		while( (pDesc=(K7EventDescStgCreate *)WK7EVENTCONTROLLER->GetEventDesc(K7EV_DESC_TYPE_STGCREATE,data))!=NULL ){
			if( pDesc->mStgID==id ){
				WK7EVENTCONTROLLER->CallIM(&pDesc->mBase,id);
			}
		}
		// R[obN^XNN
		pStage->CallCreateCallBackTask();
	}
	if( pStage->LoadObj(K7OBJTYPE_STG,id)==false ){
		WK7Stage::DeleteStage(pStage);
		return NULL;
	}
	
	return pStage;
}

WK7Item* WK7RenderObj::CreateItem(u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7Item");
	WK7Item		*pItem  = new WK7Item (&mAnchor,prio);
	if( pItem==NULL || pItem->LoadObj(K7OBJTYPE_ITEM,id)==false ){
		GHM_SAFE_DELETE(pItem);
		return NULL;
	}
	return pItem;
}

WK7RenderObj* WK7RenderObj::CreateRenderObj(u32 type,u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7RdObj");
	WK7RenderObj	*pObj = new WK7RenderObj(&mAnchor,prio);
	if( pObj==NULL || pObj->LoadObj(type,id)==false ){
		GHM_SAFE_DELETE(pObj);
		return NULL;
	}
	return pObj;
}

WK7PlayRenderObj* WK7RenderObj::CreatePlayRenderObj(u32 type,u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7PRObj");
	WK7PlayRenderObj	*pObj = new WK7PlayRenderObj(&mAnchor,prio);
	if( pObj==NULL || pObj->LoadObj(type,id)==false ){
		GHM_SAFE_DELETE(pObj);
		return NULL;
	}
	return pObj;
}

bool WK7RenderObj::PrivateLightProcessAll(void)
{
	WK7RenderObj	*pObj;
	for(pObj=(WK7RenderObj *)mAnchor.GetNext() ; pObj!=NULL ; pObj=pObj->GetNext()){
		pObj->PrivateLightProcess();
	}
	return true;
}

bool WK7RenderObj::StateProcessAll(void)
{
	WK7RenderObj		*pRenderObj;
	for(pRenderObj=WK7RenderObj::GetTopObj() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		pRenderObj->StateProcess();
	}
	return true;
}

bool WK7RenderObj::FrameProcessAll(void)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	WK7RenderObj	*pNextObj;
	
#ifdef	_DEBUG
#if 0
	C_Paper			paper(32,32);
#endif
#endif
	
	while( pObj!=NULL ){
		pNextObj = pObj->GetNext();
		pObj->FrameProcess();
		pObj = pNextObj;
	}
	FrameProcessEffectResource();
	return true;
}

#include ".\WK7Sight.h"
#define	_SETDS()			SETDS(RENDEROBJ_TH|(GETDSCNT() & 0xff),pObj)
bool WK7RenderObj::RenderProcessAll(void)
{
	if( WK7RenderObj::mVisibleAllFlag==false ){
		return true;
	}
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	WK7RenderObj	*pNextObj;
	HSD_StateSetAlphaUpdate(GX_TRUE);
	HSD_StateSetColorUpdate(GX_TRUE);
	WK7JObj::SetCurrentRenderMode(WK7JOBJ_RENDERMODE_NORMAL);
	WK7JObj::SetViewVolume(HSD_CObjGetCurrent());
	WK7Fog::SetCurrentAll();
#if FUJITA
	if( mpFog ) HSD_FogSet( mpFog );
#endif
	RESETDSCNT();
	while( pObj!=NULL ){
		pNextObj = pObj->GetNext();
#ifdef	_DEBUG
		u16		cnt;
		cnt = GETDSCNT();
#endif
		SETDSENABLE(1);
		_SETDS();
		SETDSENABLE(0);
		SETDSCNT(cnt+1);
		pObj->RenderProcess();
		pObj = pNextObj;
	}
	SETDSENABLE(1);
	WK7JObj::SetViewVolume(NULL);
	HSD_StateSetAlphaUpdate(GX_FALSE);
#if FUJITA
	if( mpFog ){  mpFog = 0;	}
#endif
	WK7Fog::EndCurrentAll();
	WK7Fog::Clear();
	return true;
}

bool WK7RenderObj::FrameProcessEdgeShadow(void)
{
	return WK7Model::FrameProcessEdgeShadow();
}

bool WK7RenderObj::InitEdgeShadowAll(void)
{
	if( WK7JObj::GetEdgeShadowObjNum() <= 0 ){
		return false;
	}
	WK7Model::ClearAlpha();
	return true;
}

bool WK7RenderObj::RenderEdgeShadowAll(void)
{
	return WK7Model::RenderProcessEdgeShadow();
}

bool WK7RenderObj::RenderEdgeShadowPaint(void)
{
	return WK7Model::RenderProcessEdgeShadowPaint();
}

bool WK7RenderObj::ReleaseAll(void)
{
	WK7RenderObj	*pObj;
	for(pObj=(WK7RenderObj *)mAnchor.GetNext() ; pObj!=NULL ; pObj=(WK7RenderObj *)mAnchor.GetNext()){
		if( IsValid(pObj)==true ){
			pObj->ReleaseOwnMotionObjAll();
			pObj->ReleaseOwnRenderObjAll();
			delete pObj;
		}
	}
	return true;
}

bool WK7RenderObj::SetMotionRate(f32 rate)
{
	if( mpModel!=NULL ){
		mpModel->SetMotionRate(rate);
	}
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->SetMotionRate(rate);
	}
	return true;
}

bool WK7RenderObj::RenewMotionRate(void)
{
	if( mpModel!=NULL ){
		mpModel->RenewMotionRate();
	}
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->RenewMotionRate();
	}
	return true;
}

bool WK7RenderObj::RenewMotionRateAll(void)
{
	WK7RenderObj	*pObj = (WK7RenderObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		pObj->RenewMotionRate();
		pObj = pObj->GetNext();
	}
	return true;
}

bool WK7RenderObj::SetPosition(f32 x,f32 y,f32 z)
{
	Vec		pos;
	pos.x = x;
	pos.y = y;
	pos.z = z;
	return SetPosition(pos);
}

bool WK7RenderObj::SetPosition(const Vec &pos)
{
	if( mpModel==NULL ){
		return false;
	}
	Vec		oldpos,dpos;
	mpModel->GetPosition(oldpos);
	VECSubtract(&pos,&oldpos,&dpos);
	VECAdd     (&mClothWarpOffset,&dpos,&mClothWarpOffset);
	mpModel->SetPosition(pos);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->SetPosition(pos);
	}
	return true;
}

bool WK7RenderObj::SetRotation(const Vec &rot)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->SetRotation(rot);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->SetRotation(rot);
	}
	return true;
}

bool WK7RenderObj::SetRotY(f32 roty)
{
	if( mpModel==NULL ){
		return false;
	}
	Vec	rot;
	mpModel->GetRotation(rot);
	rot.y = roty;
	mpModel->SetRotation(rot);
	if( mpMirrorModel!=NULL ){
		mpMirrorModel->SetRotation(rot);
	}
	return true;
}

bool WK7RenderObj::GetPosition(Vec &pos)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->GetPosition(pos);
	return true;
}

bool WK7RenderObj::GetRotY(f32 *roty)
{
	if( mpModel==NULL ){
		return false;
	}
	Vec	rot;
	mpModel->GetRotation(rot);
	*roty = rot.y;
	return true;
}

bool WK7RenderObj::GetRotation(Vec &rot)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->GetRotation(rot);
	return true;
}

WK7JObj* WK7RenderObj::GetJObj(const char *pName)
{
	if( mpModel==NULL ){
		return NULL;
	}
	if( pName==NULL ){
		return mpModel->GetTopObj();
	}
	return mpModel->GetObj(pName);
}

WK7JObj* WK7RenderObj::GetJObjPartialName(const char *pName)
{
	if( mpModel==NULL || pName==NULL ){
		return NULL;
	}
	return mpModel->GetObjPartialName2(pName);
}

bool WK7RenderObj::SetAlphaUpdate(bool flag,u32 trsp)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetAlphaUpdate(flag,-1,trsp);
}

bool WK7RenderObj::SetMaterialAmbientColor(GXColor col,u32 tick)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetMaterialAmbientColor(col,tick);
}

bool WK7RenderObj::SetMaterialAmbientColorLE(GXColor col,u32 tick)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetMaterialAmbientColorLE(col,tick);
}

bool WK7RenderObj::SetMaterialDiffuseColor(GXColor col,u32 tick)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetMaterialDiffuseColor(col,tick);
}

bool WK7RenderObj::SetMaterialDiffuseColorLE(GXColor col,u32 tick)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetMaterialDiffuseColorLE(col,tick);
}

int WK7RenderObj::SetEventEnable(u32 eventid,bool flag)
{
	WK7RenderSelectObj	*pSelectObj;
	int					count = 0;
	for(pSelectObj=(WK7RenderSelectObj *)mSelectObjAnchor.GetNext() ; pSelectObj!=NULL ; pSelectObj=pSelectObj->GetNext()){
		if( pSelectObj->GetSelectEventID()!=eventid ){
			continue;
		}
		pSelectObj->SetSelectObjEnable(flag);
		count++;
	}
	return count;
}

int WK7RenderObj::SetEventNoEnable(u32 eventno,bool flag)
{
#pragma	unused(eventno)
#pragma	unused(flag)
	return 0;
}

int WK7RenderObj::SetEventEnableAll(u32 eventid,bool flag)
{
	WK7RenderObj	*pRenderObj;
	int				count = 0;
	for(pRenderObj=(WK7RenderObj *)mAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		count += pRenderObj->SetEventEnable(eventid,flag);
	}
	return count;
}

int WK7RenderObj::SetEventNoEnableAll(u32 eventno,bool flag)
{
	WK7RenderObj	*pRenderObj;
	int				count = 0;
	for(pRenderObj=(WK7RenderObj *)mAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		count += pRenderObj->SetEventNoEnable(eventno,flag);
	}
	return count;
}

bool WK7RenderObj::CallCondChangeAll(void)
{
	WK7RenderObj	*pRenderObj;
	bool			result = true;
	for(pRenderObj=(WK7RenderObj *)mAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		if( pRenderObj->CallCondChange()==false ){
			result = false;
		}
	}
	return result;
}

WK7JObj* WK7RenderObj::SetVisible(const char *pModelName,bool flag)
{
	if( pModelName==NULL ){
		return NULL;
	}
	WK7JObj		*pJObj = GetJObj(pModelName);
	if( pJObj==NULL ){
		return NULL;
	}
	if( flag==true ){
		pJObj->Disp(false,true);
	}else{
		pJObj->Hide(false,true);
	}
	return pJObj;
}

int WK7RenderObj::GetMotionState(void)
{
	if( mpModel==NULL ){
		return WK7MODEL_NOANIM;
	}
	return mpModel->GetMotionState();
}

bool WK7RenderObj::AttachMotionN(const char *pModelName,int motid,const char *pMotionName)
{
	if( mpModel==NULL ){
		return false;
	}
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	if( pMotion==NULL ){
		return false;
	}
	WK7JObj			*pJObj;
	if( (pJObj=mpModel->AttachMotion(pMotion,pModelName,pMotionName,false,true))==NULL ){
		return false;
	}
	return true;
}

bool WK7RenderObj::PlayMotionN(const char *pModelName,f32 startframe,bool interpolate,f32 interpolateframe)
{
	WK7JObj	*pJObj;
	if( pModelName==NULL ){
		pJObj = mpModel->GetTopObj();
	}else{
		pJObj = mpModel->GetObj(pModelName);
	}
	if( pJObj==NULL ){
		return false;
	}
	pJObj->PlayMotion(startframe,interpolate,interpolateframe,false,true);
	return true;
}

bool WK7RenderObj::StopMotionN(const char *pModelName)
{
	WK7JObj	*pJObj;
	if( pModelName==NULL ){
		pJObj = mpModel->GetTopObj();
	}else{
		pJObj = mpModel->GetObj(pModelName);
	}
	if( pJObj==NULL ){
		return false;
	}
	pJObj->StopMotion(false,true);
	return true;
}

bool WK7RenderObj::PauseMotionN(const char *pModelName)
{
	return StopMotionN(pModelName);
}

bool WK7RenderObj::ReplayMotionN(const char *pModelName)
{
	WK7JObj	*pJObj;
	if( pModelName==NULL ){
		pJObj = mpModel->GetTopObj();
	}else{
		pJObj = mpModel->GetObj(pModelName);
	}
	if( pJObj==NULL ){
		return false;
	}
	pJObj->ReplayMotion(false,true);
	return true;
}

bool WK7RenderObj::SetMotionLoopN(const char *pModelName,bool flag)
{
	WK7JObj	*pJObj;
	if( pModelName==NULL ){
		pJObj = mpModel->GetTopObj();
	}else{
		pJObj = mpModel->GetObj(pModelName);
	}
	if( pJObj==NULL ){
		return false;
	}
	pJObj->SetMotionLoop(flag,false,true);
	return true;
}

bool WK7RenderObj::PlayMotion(int motid,f32 startframe)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	if( mpModel==NULL || pMotion==NULL || (mpModel->AttachMotion(pMotion) <= 0) ){
		return false;
	}
	mpModel->PlayMotion(startframe);
	return true;
}

WK7JObj* WK7RenderObj::PlayMotion(const char *pModelName,int motid,const char *pMotionName,f32 startframe)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	WK7JObj			*pJObj;
	if( mpModel==NULL || pMotion==NULL || (pJObj=mpModel->AttachMotion(pMotion,pModelName,pMotionName,false,true))==NULL ){
		return NULL;
	}
	pJObj->PlayMotion(startframe,false,0.0f,false,true);
	return pJObj;
}

WK7JObj* WK7RenderObj::PlayMotion(const char *pModelName,f32 startframe)
{
	WK7JObj		*pJObj = GetJObj(pModelName);
	if( pJObj==NULL ){
		return NULL;
	}
	pJObj->PlayMotion(startframe,false,0.0f,false,true);
	return pJObj;
}

WK7JObj* WK7RenderObj::StopMotion(const char *pModelName)
{
	WK7JObj			*pJObj;
	if( mpModel==NULL || (pJObj=mpModel->GetObj(pModelName))==NULL ){
		return NULL;
	}
	pJObj->StopMotion  (false,true);
	pJObj->DetachMotion(false,true);
	return pJObj;
}

WK7JObj* WK7RenderObj::PauseMotion(const char *pModelName)
{
	WK7JObj			*pJObj;
	if( mpModel==NULL || (pJObj=mpModel->GetObj(pModelName))==NULL ){
		return NULL;
	}
	pJObj->StopMotion(false,true);
	return pJObj;
}

WK7JObj* WK7RenderObj::ReplayMotion(const char *pModelName)
{
	WK7JObj			*pJObj;
	if( mpModel==NULL || (pJObj=mpModel->GetObj(pModelName))==NULL ){
		return NULL;
	}
	pJObj->ReplayMotion(false,true);
	return pJObj;
}

bool WK7RenderObj::SetMotionLoop(bool flag,int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->SetMotionLoop(flag,index);;
}

bool WK7RenderObj::AttachMotionAll(int motid,bool overwrite)
{
	bool	result = false;
	if( AttachMotion(motid,overwrite)==true ){
		result = true;
	}
	if( AttachMatMotion(motid)==true ){
		result = true;
	}
	if( AttachShapeMotion(motid,overwrite)==true ){
		result = true;
	}
	return true;
}

bool WK7RenderObj::AttachMotion(int motid,bool overwrite)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	if( mpModel==NULL || pMotion==NULL || (mpModel->AttachMotion(pMotion,overwrite) <= 0) ){
		return false;
	}
	return true;
}

bool WK7RenderObj::DetachMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->DetachMotion(index);
}

bool WK7RenderObj::ResetMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ResetMotion(index);
}

bool WK7RenderObj::PlayMotion(f32 startframe,bool interpolate,f32 interpolateframe,int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->PlayMotion(startframe,interpolate,interpolateframe,index);
}

bool WK7RenderObj::PlayMotionAll(f32 startframe,bool interpolate,f32 interpolateframe,int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->PlayMotionAll(startframe,interpolate,interpolateframe,index);
}

bool WK7RenderObj::StopMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->StopMotion(index);
}

bool WK7RenderObj::StopMotionAll(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->StopMotionAll(index);
}

bool WK7RenderObj::ReplayMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ReplayMotion(index);
}

bool WK7RenderObj::ReplayMotionAll(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ReplayMotionAll(index);
}

bool WK7RenderObj::AttachMatMotion(int motid)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	if( mpModel==NULL || pMotion==NULL || (mpModel->AttachMatMotion(pMotion) <= 0) ){
		return false;
	}
	return true;
}

bool WK7RenderObj::DetachMatMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->DetachMatMotion(index);
}

bool WK7RenderObj::ResetMatMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ResetMatMotion(index);
}

bool WK7RenderObj::PlayMatMotion(f32 startframe,int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->PlayMatMotion(startframe,index);
}

bool WK7RenderObj::StopMatMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->StopMatMotion(index);
}

bool WK7RenderObj::ReplayMatMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ReplayMatMotion(index);
}

bool WK7RenderObj::AttachShapeMotion(int motid,bool overwrite)
{
	WK7ModelMotion	*pMotion = GetOwnModelMotion((u32)motid);
	if( mpModel==NULL || pMotion==NULL || (mpModel->AttachShapeMotion(pMotion,overwrite) <= 0) ){
		return false;
	}
	return true;
}

bool WK7RenderObj::DetachShapeMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->DetachShapeMotion(index);
}

bool WK7RenderObj::ResetShapeMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ResetShapeMotion(index);
}

bool WK7RenderObj::PlayShapeMotion(f32 startframe,int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->PlayShapeMotion(startframe,index);
}

bool WK7RenderObj::StopShapeMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->StopShapeMotion(index);
}

bool WK7RenderObj::ReplayShapeMotion(int index)
{
	if( mpModel==NULL ){
		return false;
	}
	return mpModel->ReplayShapeMotion(index);
}

WK7RenderObjMotionObj::WK7RenderObjMotionObj(ghmGcListObj *pAnchor,u32 type,u32 id,int prio) : ghmGcListObj(pAnchor,WK7OBJ_DEFAULT_PRIO)
{
	mpMotionObj = NULL;
	mType       = type;
	mID         = id;
	mPrio       = prio;
	Restore();
}

WK7RenderObjMotionObj::~WK7RenderObjMotionObj()
{
	if( IsValid(mpMotionObj)==true ){
		GHM_SAFE_DELETE(mpMotionObj);
	}
}

u32 WK7RenderObjMotionObj::GetType(void)
{
	if( mpMotionObj==NULL ){
		return 0xffffffff;
	}
	return mpMotionObj->GetType();
}

u32 WK7RenderObjMotionObj::GetID(void)
{
	if( mpMotionObj==NULL ){
		return 0xffffffff;
	}
	return mpMotionObj->GetID();
}

WK7ModelMotion* WK7RenderObjMotionObj::GetModelMotion(void)
{
	if( mpMotionObj==NULL ){
		return NULL;
	}
	return mpMotionObj->GetModelMotion();
}

WK7CameraMotion* WK7RenderObjMotionObj::GetCameraMotion(void)
{
	if( mpMotionObj==NULL ){
		return NULL;
	}
	return mpMotionObj->GetCameraMotion();
}

WK7LightMotion* WK7RenderObjMotionObj::GetLightMotion(void)
{
	if( mpMotionObj==NULL ){
		return NULL;
	}
	return mpMotionObj->GetLightMotion();
}

bool WK7RenderObjMotionObj::Release(void)
{
	if( mpMotionObj==NULL ){
		return true;
	}
	if( IsValid(mpMotionObj)==true ){
		GHM_SAFE_DELETE(mpMotionObj);
	}else{
		mpMotionObj = NULL;
	}
	return true;
}

bool WK7RenderObjMotionObj::Restore(void)
{
	if( mpMotionObj!=NULL ){
		return false;
	}
	switch( mType ){
	case	K7MOT_ATTR|K7OBJTYPE_CHR:
		mpMotionObj = WK7MotionObj::CreateCharaMotion(mID,mPrio);
		break;
	case	K7MOT_ATTR|K7OBJTYPE_STG:
		mpMotionObj = WK7MotionObj::CreateStageMotion(mID,mPrio);
		break;
	case	K7MOT_ATTR|K7OBJTYPE_ITEM:
		mpMotionObj = WK7MotionObj::CreateItemMotion(mID,mPrio);
		break;
	default:
		mpMotionObj = WK7MotionObj::CreateMotionObj(mType,mID,mPrio);
		break;
	}
#ifdef	_DEBUG
	if( mpMotionObj==NULL ){
		char	str[64];
		sprintf(str,"Own MotionObj Not Created : Type:%08x,ID:%08x\n",mType,mID);
		OSDebugReport(str);
		K7AppDebugPrint(str);
	}
#endif
	return true;
}

bool WK7RenderObjMotionObj::IsLoaded(void)
{
	if( mpMotionObj==NULL ){
		return true;
	}
	switch( mpMotionObj->GetState() ){
	case	WK7MotionObj::LOADING:
	case	WK7MotionObj::IDLE:
		return false;
	case	WK7MotionObj::LOADED:
	default:
		break;
	}
	return true;
}

WK7ModelMotion* WK7RenderObj::GetOwnModelMotion(u32 type,u32 id)
{
	WK7MotionObj	*pMotion = FindMotionObj(type,id);
	if( pMotion==NULL ){
		return NULL;
	}
	return pMotion->GetModelMotion();
}

WK7CameraMotion* WK7RenderObj::GetOwnCameraMotion(u32 type,u32 id)
{
	WK7MotionObj	*pMotion = FindMotionObj(type,id);
	if( pMotion==NULL ){
		return NULL;
	}
	return pMotion->GetCameraMotion();
}

WK7LightMotion* WK7RenderObj::GetOwnLightMotion(u32 type,u32 id)
{
	WK7MotionObj	*pMotion = FindMotionObj(type,id);
	if( pMotion==NULL ){
		return NULL;
	}
	return pMotion->GetLightMotion();
}

WK7MotionObj* WK7RenderObj::FindMotionObj(u32 type,u32 id)
{
	WK7RenderObjMotionObj	*pMotion = FindRenderObjMotion(type,id);
	if( pMotion==NULL ){
		return NULL;
	}
	return pMotion->GetMotionObj();
}

WK7RenderObjMotionObj* WK7RenderObj::FindRenderObjMotion(u32 type,u32 id)
{
	WK7RenderObjMotionObj	*pMotion;
	for(pMotion=(WK7RenderObjMotionObj *)mMotionObjAnchor.GetNext() ; pMotion!=NULL ; pMotion=pMotion->GetNext()){
		if( type!=0xffffffff && pMotion->GetType()!=type ){
			continue;
		}
		if( pMotion->GetID()!=id ){
			continue;
		}
		return pMotion;
	}
	return NULL;
}

WK7MotionObj* WK7RenderObj::CreateOwnMotionObj(u32 type,u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7ROMO");
	WK7RenderObjMotionObj	*pMotion = new WK7RenderObjMotionObj(&mMotionObjAnchor,type,id,prio);
	if( pMotion==NULL ){
		return NULL;
	}
	return pMotion->GetMotionObj();
}

WK7CharaMotion* WK7RenderObj::CreateOwnCharaMotion(u32 id,int prio)
{
	return (WK7CharaMotion *)CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_CHR,K7MOTID(GetMainID(),id),prio);
}

WK7StageMotion* WK7RenderObj::CreateOwnStageMotion(u32 id,int prio)
{
	return (WK7StageMotion *)CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_STG,K7MOTID(GetMainID(),id),prio);
}

WK7ItemMotion* WK7RenderObj::CreateOwnItemMotion(u32 id,int prio)
{
	return (WK7ItemMotion *)CreateOwnMotionObj(K7MOT_ATTR|K7OBJTYPE_ITEM,K7MOTID(GetMainID(),id),prio);
}

bool WK7RenderObj::IsOwnMotionObjLoaded(void)
{
	WK7RenderObjMotionObj	*pMotion;
	for(pMotion=(WK7RenderObjMotionObj *)mMotionObjAnchor.GetNext() ; pMotion!=NULL ; pMotion=pMotion->GetNext()){
		if( pMotion->IsLoaded()==false ){
			return false;
		}
	}
	return true;
}

bool WK7RenderObj::ReleaseOwnMotionObjAll(void)
{
	WK7RenderObjMotionObj	*pMotion,*pNext;
	for(pMotion=(WK7RenderObjMotionObj *)mMotionObjAnchor.GetNext() ; pMotion!=NULL ; pMotion=pNext){
		pNext = pMotion->GetNext();
		delete pMotion;
	}
	return true;
}

WK7RenderObjRenderObj::WK7RenderObjRenderObj(ghmGcListObj *pAnchor,u32 type,u32 id,int prio) : ghmGcListObj(pAnchor,WK7OBJ_DEFAULT_PRIO)
{
	mpRenderObj = NULL;
	mType       = type;
	mID         = id;
	mPrio       = prio;
	Restore();
}

WK7RenderObjRenderObj::~WK7RenderObjRenderObj()
{
	if( IsValid(mpRenderObj)==true ){
		GHM_SAFE_DELETE(mpRenderObj);
	}
}

u32 WK7RenderObjRenderObj::GetType(void)
{
	if( mpRenderObj==NULL ){
		return 0xffffffff;
	}
	return mpRenderObj->GetType();
}

u32 WK7RenderObjRenderObj::GetID(void)
{
	if( mpRenderObj==NULL ){
		return 0xffffffff;
	}
	return mpRenderObj->GetID();
}

WK7Model* WK7RenderObjRenderObj::GetModel(void)
{
	if( mpRenderObj==NULL ){
		return NULL;
	}
	return mpRenderObj->GetModel();
}

bool WK7RenderObjRenderObj::Release(void)
{
	if( mpRenderObj==NULL ){
		return true;
	}
	if( IsValid(mpRenderObj)==true ){
		GHM_SAFE_DELETE(mpRenderObj);
	}else{
		mpRenderObj = NULL;
	}
	return true;
}

bool WK7RenderObjRenderObj::Restore(void)
{
	if( mpRenderObj!=NULL ){
		return false;
	}
	switch( mType ){
	case	K7OBJTYPE_CHR:
		mpRenderObj = WK7RenderObj::CreateChara(mID,mPrio);
		break;
	case	K7OBJTYPE_STG:
		mpRenderObj = WK7RenderObj::CreateStage(mID,false,mPrio);
		break;
	case	K7OBJTYPE_ITEM:
		mpRenderObj = WK7RenderObj::CreateItem(mID,mPrio);
		break;
	default:
		mpRenderObj = WK7RenderObj::CreateRenderObj(mType,mID,mPrio);
		break;
	}
	if( mpRenderObj != NULL ){
		mID = mpRenderObj->GetID();
	}
#ifdef	_DEBUG
	if( mpRenderObj==NULL ){
		char	str[64];
		sprintf(str,"Own RenderObj Not Created : Type:%08x,ID:%08x\n",mType,mID);
		OSDebugReport(str);
		K7AppDebugPrint(str);
	}
#endif
	return true;
}

bool WK7RenderObjRenderObj::IsLoaded(void)
{
	if( mpRenderObj==NULL ){
		return true;
	}
	switch( mpRenderObj->GetState() ){
	case	WK7RenderObj::LOADRESERVE:
	case	WK7RenderObj::LOADING:
	case	WK7RenderObj::IDLE:
		return false;
	case	WK7RenderObj::LOADED:
	default:
		break;
	}
	return true;
}

WK7Model* WK7RenderObj::GetOwnModel(u32 type,u32 id)
{
	WK7RenderObj	*pRenderObj = FindRenderObj(type,id);
	if( pRenderObj==NULL ){
		return NULL;
	}
	return pRenderObj->GetModel();
}

WK7RenderObj* WK7RenderObj::FindRenderObj(u32 type,u32 id)
{
	WK7RenderObjRenderObj	*pRenderObjRenderObj = FindRenderObjRenderObj(type,id);
	if( pRenderObjRenderObj==NULL ){
		return NULL;
	}
	return pRenderObjRenderObj->GetRenderObj();
}

WK7RenderObjRenderObj* WK7RenderObj::FindRenderObjRenderObj(u32 type,u32 id)
{
	WK7RenderObjRenderObj	*pRenderObjRenderObj;
	for(pRenderObjRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObjRenderObj!=NULL ; pRenderObjRenderObj=pRenderObjRenderObj->GetNext()){
		if( type!=0xffffffff && pRenderObjRenderObj->GetType()!=type ){
			continue;
		}
		if( pRenderObjRenderObj->GetID()!=id ){
			continue;
		}
		return pRenderObjRenderObj;
	}
	return NULL;
}

WK7RenderObj* WK7RenderObj::CreateOwnRenderObj(u32 type,u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7RORO");
	WK7RenderObjRenderObj	*pRenderObjRenderObj = new WK7RenderObjRenderObj(&mRenderObjAnchor,type,id,prio);
	if( pRenderObjRenderObj==NULL ){
		return NULL;
	}
	WK7RenderObj	*pRenderObj = pRenderObjRenderObj->GetRenderObj();
	if( pRenderObj!=NULL ){
		pRenderObj->SetRenderObjFlag(mRenderFlag);
	}
	return pRenderObjRenderObj->GetRenderObj();
}

WK7Chara* WK7RenderObj::CreateOwnChara(u32 id,int prio)
{
	return (WK7Chara *)CreateOwnRenderObj(K7OBJTYPE_CHR,id,prio);
}

WK7Stage* WK7RenderObj::CreateOwnStage(u32 id,int prio)
{
	return (WK7Stage *)CreateOwnRenderObj(K7OBJTYPE_STG,id,prio);
}

WK7Item* WK7RenderObj::CreateOwnItem(u32 id,int prio)
{
	return (WK7Item *)CreateOwnRenderObj(K7OBJTYPE_ITEM,id,prio);
}

bool WK7RenderObj::IsOwnRenderObjLoaded(void)
{
	WK7RenderObjRenderObj	*pRenderObjRenderObj;
	for(pRenderObjRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObjRenderObj!=NULL ; pRenderObjRenderObj=pRenderObjRenderObj->GetNext()){
		if( pRenderObjRenderObj->IsLoaded()==false ){
			return false;
		}
	}
	return true;
}

bool WK7RenderObj::ReleaseOwnRenderObjAll(void)
{
	WK7RenderObjRenderObj	*pRenderObjRenderObj,*pNext;
	for(pRenderObjRenderObj=(WK7RenderObjRenderObj *)mRenderObjAnchor.GetNext() ; pRenderObjRenderObj!=NULL ; pRenderObjRenderObj=pNext){
		pNext = pRenderObjRenderObj->GetNext();
		delete pRenderObjRenderObj;
	}
	return true;
}

bool WK7RenderObjEffectInfo::Initialize(void)
{
	mEffectNum = 0;
	GHMGCMEM_SAFE_FREE(mppEffect);
	return true;
}

bool WK7RenderObjEffectInfo::Create(void)
{
	EFFECT		*pEffect;
	int			i;
	Initialize();
	for(pEffect=EffSys.FirstEffect ; pEffect!=NULL ; pEffect=pEffect->Next){
		mEffectNum++;
	}
	if( mEffectNum <= 0 ){
		return false;
	}
	if( (mppEffect = (EFFECT**)ghmGcMemAlloc((int)(sizeof(EFFECT*) * mEffectNum)))==NULL ){
		if( (mppEffect = (EFFECT**)K7AppSmallMemAlloc((int)(sizeof(EFFECT*) * mEffectNum)))==NULL ){
			mEffectNum = 0;
			return false;
		}
	}
	for(i=0,pEffect=EffSys.FirstEffect ; pEffect!=NULL ; pEffect=pEffect->Next,i++){
		mppEffect[i] = pEffect;
	}
	return true;
}

int WK7RenderObjEffectInfo::Parent(EFFECT *pParent)
{
	EFFECT		*pEffect;
	int			i,count;
	for(pEffect=EffSys.FirstEffect,count=0 ; pEffect!=NULL ; pEffect=pEffect->Next){
		if( pEffect->Parent!=NULL ){
			continue;
		}
		for(i=mEffectNum-1 ; i>=0 ; i--){
			if( pEffect==mppEffect[i] ){
				break;
			}
		}
		if( i<0 ){
			pEffect->Parent = pParent;
			count++;
		}
	}
	return count;
}

int WK7RenderObjEffectInfo::UnParent(EFFECT *pParent)
{
	EFFECT		*pEffect;
	int			count;
	for(pEffect=EffSys.FirstEffect,count=0 ; pEffect!=NULL ; pEffect=pEffect->Next){
		if( pEffect->Parent==NULL ){
			continue;
		}
		if( pEffect->Parent==pParent ){
			pEffect->Parent = NULL;
			count++;
		}
	}
	return count;
}

WK7RenderObjEffect::WK7RenderObjEffect(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect) : ghmGcListObj(pAnchor,GHMGCLIST_DEFAULT_PRIO)
{
	if( (mpEffect = pEffect)!=NULL ){
		mEffectID = GetEffectID(pEffect);
	}else{
		mEffectID = 0xffffffff;
	}
	mType = NORMAL;
	mDamageID = 0xffffffff;
	mpContainer = pContainer;
	mForcedDraw = -1;
	mForcedMove = -1;
}

WK7RenderObjEffect::~WK7RenderObjEffect()
{
	if( mpEffect != NULL && CheckEffectValidState(mpEffect,mEffectID)==TRUE ){
		::DeleteEffect(mpEffect);
	}
	if( mDamageID != 0xffffffff ){
		BattleCtrl.ReleaseDamagePos(mDamageID);
	}
}

bool WK7RenderObjEffect::IsValid(void)
{
	if( mpEffect==NULL ){
		return false;
	}
	if( CheckEffectValidState(mpEffect,mEffectID)==FALSE ){
		return false;
	}
	return true;
}

bool WK7RenderObjEffect::SetDrawFlag(bool flag)
{
	if( IsValid()==false ){
		return false;
	}
	switch( mForcedDraw ){
	case	0: flag=false; break;
	case	1: flag=true;  break;
	}
	SetEffectDrawFlagAll(mpEffect,flag);
	return true;
}

bool WK7RenderObjEffect::SetMoveFlag(bool flag)
{
	if( IsValid()==false ){
		return false;
	}
	switch( mForcedMove ){
	case	0: flag=false; break;
	case	1: flag=true;  break;
	}
	SetEffectMoveFlagAll(mpEffect,flag);
	return true;
}

bool WK7RenderObjEffect::FrameProcess(void)
{
	if( IsValid()==false ){
		return false;
	}
	return true;
}

bool WK7RenderObjEffect::DelReqEffect(void)
{
	if( mpEffect==NULL ){
		return false;
	}
	if( CheckEffectValidState(mpEffect,mEffectID)==FALSE ){
		return false;
	}
	::DelReqEffect(mpEffect);
	return true;
}

WK7RenderObjEffectModelFire::WK7RenderObjEffectModelFire(WK7JObj *pJObj,u8 type,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect)
                            : WK7RenderObjEffect(pAnchor,pContainer,pEffect)
{
	MODELFIREEFFECT		*pMFire;
	if( pEffect != NULL ){
		pMFire        = (MODELFIREEFFECT *)pEffect->Data;
		mBillEffectID = (s8)pMFire->FireSparkID;
	}else{
		pMFire        = NULL;
		mBillEffectID = -1;
	}
	mpJObj    = pJObj;
	mType     = MODELFIRE;
	mFireType = type;
//	switch( type ){
//	case	4:
//		mBillEffectID = BILLEFF_SPFIRE;
//		break;
//	case	5:
//	case	6:
//		mBillEffectID = BILLEFF_SPFIRE2;
//		break;
//	default:
//		mBillEffectID = -1;
//		break;
//	}
	if( mBillEffectID >= 0 ){
		if( WK7RenderObj::CreateEffectBillResource(mBillEffectID)==NULL ){
			mBillEffectID = -1;
		}
	}
}

WK7RenderObjEffectModelFire::~WK7RenderObjEffectModelFire()
{
	if( mBillEffectID >= 0 ){
		WK7RenderObj::ReleaseEffectBillResource(mBillEffectID);
	}
}

WK7RenderObjEffectRain::WK7RenderObjEffectRain(ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect)
                       : WK7RenderObjEffect(pAnchor,pContainer,pEffect) 
{
	mCamControl = false;
	mHeight     = 0.0f;
}

WK7RenderObjEffectRain::WK7RenderObjEffectRain(f32 height,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect)
                       : WK7RenderObjEffect(pAnchor,pContainer,pEffect) 
{
	mCamControl = true;
	mHeight     = height;
}

WK7RenderObjEffectRain::~WK7RenderObjEffectRain()
{
}

bool WK7RenderObjEffectRain::FrameProcess(void)
{
	if( WK7RenderObjEffect::FrameProcess()==false ){
		return false;
	}
	if( mCamControl==true ){
		// Jʒuɍ~点
		Vec		campos;
		WK7CAM->GetPosition(campos);
		campos.y = mHeight;
		::SetRainEffectPoint(mpEffect,campos);
	}
	return true;
}
	
bool WK7RenderObjEffectAnim2::FrameProcess(void)
{
	if( WK7RenderObjEffect::FrameProcess()==false ){
		return false;
	}
	Vec		pos = mPosition;
	if( mpJObj!=NULL ){
		Vec		dpos;
		mpJObj->GetWorldPosition(dpos);
		VECAdd(&pos,&dpos,&pos);
	}
	::SetEasyAnimPoint(mpEffect,pos);
	return true;
}

WK7RenderObjEffect* WK7RenderObj::FindEffect(EFFECT *pEffect)
{
	if( pEffect==NULL ){
		return NULL;
	}
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetEffect()==pEffect ){
			return pRenderObjEffect;
		}
	}
	return NULL;
}

WK7RenderObjEffect* WK7RenderObj::FindEffectAll(EFFECT *pEffect)
{
	WK7RenderObj		*pRenderObj;
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObj=(WK7RenderObj *)mAnchor.GetNext() ; pRenderObj!=NULL ; pRenderObj=pRenderObj->GetNext()){
		if( (pRenderObjEffect=pRenderObj->FindEffect(pEffect))!=NULL ){
			return pRenderObjEffect;
		}
	}
	return NULL;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectBreak(WK7JObj *pJObj)
{
	EFFECT	*pEffect;
	Vec		Base,DPoint,SSpeed;
	
	DPoint.x = pJObj->GetJObj()->mtx[0][3];
	DPoint.y = pJObj->GetJObj()->mtx[1][3];
	DPoint.z = pJObj->GetJObj()->mtx[2][3];
	Base.x = DPoint.x - VParam[ED_BREAK][7] * 0.1F ;
	Base.y = DPoint.y - VParam[ED_BREAK][8] * 0.1F ;
	Base.z = DPoint.z - VParam[ED_BREAK][9] * 0.1F ;
	
	SSpeed.x = 0.0F ;
	SSpeed.y = -VParam[ED_BREAK][2] * 0.01F ;
	SSpeed.z = 0.0F ;
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( (pEffect=CreateBreakEffect(pJObj,Base,
						VParam[ED_BREAK][0] * 0.01F, VParam[ED_BREAK][1] * 0.01F, SSpeed,
						VParam[ED_BREAK][3] * 0.001F, VParam[ED_BREAK][4] * 0.001F,
						VParam[ED_BREAK][5] * 0.001F, VParam[ED_BREAK][6] * 0.001F ))==NULL ){
		return NULL;
	}
	
	ghmGcMemSetAllocName("WK7ROEf");
	WK7RenderObjEffect	*pRenderObjEffect = new WK7RenderObjEffect(&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateBillBoardEffect(s8 effectID,Vec &point,f32 yukaY, u32 MaxObjectNum)
{
	EFFECT	*pEffect;
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( (pEffect=CreateBillboardEffect2(effectID,point,yukaY,MaxObjectNum))==NULL ){
		return NULL;
	}
	
	ghmGcMemSetAllocName("WK7ROEfB");
	WK7RenderObjEffect	*pRenderObjEffect = new WK7RenderObjEffectBill(effectID,&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectSeenSound(Vec &Point,u32 color1,u32 color2)
{
	GXColor	c1,c2;
	EFFECT	*pEfc;
	
	if( color1==0 && color2==0 ){
		c1.r = (u8)VParam[ED_SEENSOUND][1];
		c1.g = (u8)VParam[ED_SEENSOUND][2];
		c1.b = (u8)VParam[ED_SEENSOUND][3];
		c1.a = (u8)VParam[ED_SEENSOUND][4];
		c2.r = (u8)VParam[ED_SEENSOUND][5];
		c2.g = (u8)VParam[ED_SEENSOUND][6];
		c2.b = (u8)VParam[ED_SEENSOUND][7];
		c2.a = (u8)VParam[ED_SEENSOUND][8];
	}else{
		c1 = *((GXColor *)&color1);
		c2 = *((GXColor *)&color2);
	}
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	pEfc = CreateSeenSoundEffect( (Vec)Point,							// W
							VParam[ED_SEENSOUND][13],					// 쐬҂
							VParam[ED_SEENSOUND][11],					// \
							(f32)VParam[ED_SEENSOUND][12] * 0.01F,		// 鑬x
							(f32)VParam[ED_SEENSOUND][9] * 0.01F,		// 
							c1, c2,	// F
							(f32)VParam[ED_SEENSOUND][10] * 0.01F );	// L鑬x
	
	if( pEfc==NULL ){
		return NULL;
	}
	
	return CreateEffect(pEfc,&info);
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectModelFire(const char *pObjName,u8 type,const Vec *ppoint,f32 size)
{
	WK7JObj	*pJObj;
	
	if( mpModel!=NULL && pObjName!=NULL ){
		pJObj = mpModel->GetObj(pObjName);
	}else{
		pJObj = NULL;
	}
	
	return CreateEffectModelFire(pJObj,type,ppoint,size);
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectModelFire(WK7JObj *pJObj,u8 type,const Vec *ppoint,f32 size)
{
	Vec		point;
	EFFECT	*pEffect;
	if( ppoint!=NULL ){
		point = *ppoint;
	}
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( (pEffect=CreateModelFireEffectEasy(pJObj,type,point,size,-1))==NULL ){				// ŌオSEԍ -1ƂȂȂ
		return NULL;
	}
	
	ghmGcMemSetAllocName("WK7MFEf");
	WK7RenderObjEffectModelFire		*pRenderObjEffect = new WK7RenderObjEffectModelFire(pJObj,type,&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}


/*
	ӂԂGtFNg
	<in>
	cpos J|WV
*/
WK7RenderObjEffect* WK7RenderObj::CreateEffectConfetti(Vec &cpos, s32 num)
{
	WK7RenderObjEffectInfo	info;
	info.Create();
	EFFECT	*pEffect = CreateConfettiEffect(	num, cpos,
												VParam[ED_CONFETTI][5] * 0.01F, VParam[ED_CONFETTI][6] * 0.01F, 
												VParam[ED_CONFETTI][2] * 10, VParam[ED_CONFETTI][3],
												0.0F, VParam[ED_CONFETTI][11],
												NULL ) ;
	if( pEffect==NULL ){
		return NULL;
	}
	return CreateEffect(pEffect,&info);
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectRain(f32 height,f32 yukaY,f32 size)
{
	Vec		campos;
	GXColor Color ;
	u16		num ;
	
	WK7CAM->GetPosition(campos);
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	Color.r = (u8)VParam[ED_RAIN][10] ;
	Color.g = (u8)VParam[ED_RAIN][11] ;
	Color.b = (u8)VParam[ED_RAIN][12] ;
	num = (u16)( height > 115.0F ? RAINEFFECTNUM * 2 : RAINEFFECTNUM ) ;
	EFFECT	*pEffect = CreateRainEffect(campos,yukaY,
	                                    VParam[ED_RAIN][6] * 0.01F, VParam[ED_RAIN][7] * 0.001F,
	                                    size,
	                                    (u16)( VParam[ED_RAIN][8] * num ),						// MaxNum
	                                    VParam[ED_RAIN][1] * 0.1F, VParam[ED_RAIN][9] * 0.1F,
//	                                    &Color ) ;
	                                    &Color ,GetJObj() ) ;
	ghmGcMemSetAllocName("WK7RnEf");
	WK7RenderObjEffectRain		*pRenderObjEffect = new WK7RenderObjEffectRain(height,&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectRain(Vec &point,f32 yukaY,f32 size)
{
	GXColor Color ;
	WK7RenderObjEffectInfo	info;
	info.Create();
	Color.r = (u8)VParam[ED_RAIN][10] ;
	Color.g = (u8)VParam[ED_RAIN][11] ;
	Color.b = (u8)VParam[ED_RAIN][12] ;
	EFFECT	*pEffect = CreateRainEffect(point,yukaY,
	                                    VParam[ED_RAIN][6] * 0.01F, VParam[ED_RAIN][7] * 0.001F,
	                                    size,
	                                    (u16)( VParam[ED_RAIN][8] * RAINEFFECTNUM ),					// MaxNum
	                                    VParam[ED_RAIN][1] * 0.1F, VParam[ED_RAIN][9] * 0.1F,
//	                                    &Color ) ;
	                                    &Color ,GetJObj() ) ;
	ghmGcMemSetAllocName("WK7RnEf");
	WK7RenderObjEffectRain		*pRenderObjEffect = new WK7RenderObjEffectRain(&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectSmoke(Vec &point,f32 size)
{
	GXColor Color;
	EFFECT	*pEffect;
	
	Color.r = (u8)VParam[ED_SMOKE_DR][10] ;
	Color.g = (u8)VParam[ED_SMOKE_DR][11] ;
	Color.b = (u8)VParam[ED_SMOKE_DR][12] ;

	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( size < 0.0f )
	{
		pEffect = CreateSmokeEffect( 1, point, VParam[ED_SMOKE_DR][0] * 0.1F,
		                             VParam[ED_SMOKE_DR][1] * 0.01F, VParam[ED_SMOKE_DR][2] * 0.01F,
		                             0.0F, VParam[ED_SMOKE_DR][3],
		                             (Vec){0.0F,0.0F,0.0F}, 0.0F,
		                             PI * VParam[ED_SMOKE_DR][4] * 0.1F / 180.0F, PI * VParam[ED_SMOKE_DR][5] * 0.1F / 180.0F, 
		                             VParam[ED_SMOKE_DR][6] * 0.1F, VParam[ED_SMOKE_DR][7] * 0.1F,
		                             VParam[ED_SMOKE_DR][6] * 0.1F, VParam[ED_SMOKE_DR][7] * 0.1F,
		                             VParam[ED_SMOKE_DR][8], VParam[ED_SMOKE_DR][9], VParam[ED_SMOKE_DR][17] * 1.0F,
		                             Color, Color, Color, (u8)VParam[ED_SMOKE_DR][13],
		                             PI * VParam[ED_SMOKE_DR][18] / 180.0F, 0.0F, FALSE, (u8)VParam[ED_SMOKE_DR][14], 
		                             VParam[ED_SMOKE_DR][15] * 0.01F, FALSE, 0,
		                             Color, Color, Color,
		                             VParam[ED_SMOKE_DR][16] * 0.01F ) ;
	}else
	{
		pEffect = CreateSmokeEffect( 1, point, VParam[ED_SMOKE_DR][0] * 0.1F,
		                             VParam[ED_SMOKE_DR][1] * 0.01F, VParam[ED_SMOKE_DR][2] * 0.01F,
		                             0.0F, VParam[ED_SMOKE_DR][3],
		                             (Vec){0.0F,0.0F,0.0F}, 0.0F,
		                             PI * VParam[ED_SMOKE_DR][4] * 0.1F / 180.0F, PI * VParam[ED_SMOKE_DR][5] * 0.1F / 180.0F, 
		                             size, size * 0.5F,
		                             size, size * 0.5F,
		                             VParam[ED_SMOKE_DR][8], VParam[ED_SMOKE_DR][9], VParam[ED_SMOKE_DR][17] * 1.0F,
		                             Color, Color, Color, (u8)VParam[ED_SMOKE_DR][13],
		                             PI * VParam[ED_SMOKE_DR][18] / 180.0F, 0.0F, FALSE, (u8)VParam[ED_SMOKE_DR][14], 
		                             VParam[ED_SMOKE_DR][15] * 0.01F, FALSE, 0,
		                             Color, Color, Color,
		                             VParam[ED_SMOKE_DR][16] * 0.01F ) ;
	}
	if( pEffect==NULL ){
		return NULL;
	}
	return CreateEffect(pEffect,&info);
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectTama(WK7JObj *pJObj,const Vec& pos,f32 size)
{
	EFFECT	*pEffect;
	Vec		_size,_pos;
	
	_size.x = size;
	_size.y = size;
	_size.z = size;
	
	if( pJObj!=NULL ){
		pJObj->GetWorldPosition(_pos);
		VECAdd(&_pos,&pos,&_pos);
	}else{
		_pos = pos;
	}
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	pEffect = CreateEasyAnimEffect2(ANIMID_SMALLLIGHT,
	                                _pos,
	                                _size,
	                                true,-1);
	
	ghmGcMemSetAllocName("WK7TmEf");
	WK7RenderObjEffectAnim2		*pRenderObjEffect = new WK7RenderObjEffectAnim2(pJObj,pos,ANIMID_SMALLLIGHT,&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffect(EFFECT *pEffect,WK7RenderObjEffectInfo *pInfo)
{
	if( pEffect==NULL ){
		return NULL;
	}
	ghmGcMemSetAllocName("WK7ROEf");
	WK7RenderObjEffect	*pRenderObjEffect = new WK7RenderObjEffect(&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		if( pInfo!=NULL ){
			pInfo->Parent(pEffect);
		}
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectDropWater(Vec &Point,f32 yukaY)
{
	EFFECT	*pEffect;
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( (pEffect=CreateDropWaterEffect(Point,yukaY))==NULL ){
		return NULL;
	}
	
	ghmGcMemSetAllocName("WK7ROEf");
	WK7RenderObjEffect	*pRenderObjEffect = new WK7RenderObjEffect(&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffect* WK7RenderObj::CreateEffectEasyAnim(s8 animID,Vec &Point,Vec &Size,u8 AddBlendFlag)
{
	EFFECT	*pEffect;
	
	WK7RenderObjEffectInfo	info;
	info.Create();
	
	if( (pEffect=CreateEasyAnimEffect2(animID,Point,Size,AddBlendFlag,-1))==NULL ){
		return NULL;
	}
	
	ghmGcMemSetAllocName("WK7ROEfA");
	WK7RenderObjEffect	*pRenderObjEffect = new WK7RenderObjEffectAnim(animID,&mEffectAnchor,this,pEffect);
	
	if( pRenderObjEffect==NULL ){
		::DeleteEffect(pEffect);
	}else{
		info.Parent(pEffect);
		pRenderObjEffect->SetDrawFlag(mRenderFlag);
	}
	
	return pRenderObjEffect;
}

WK7RenderObjEffectAnim* WK7RenderObj::FindEffectEasyAnim(s8 animID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::ANIM ){
			continue;
		}
		WK7RenderObjEffectAnim	*pRenderObjEffectAnim = (WK7RenderObjEffectAnim *)pRenderObjEffect;
		if( pRenderObjEffectAnim->GetAnimID()==animID ){
			return pRenderObjEffectAnim;
		}
	}
	return NULL;
}

bool WK7RenderObj::ReleaseEffectEasyAnim(s8 animID)
{
	WK7RenderObjEffectAnim	*pRenderObjEffectAnim = FindEffectEasyAnim(animID);
	if( pRenderObjEffectAnim==NULL ){
		return false;
	}
	delete pRenderObjEffectAnim;
	return true;
}

WK7RenderObjEffectBill* WK7RenderObj::FindEffectBillBoard(s8 effectID)
{
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect->GetType()!=WK7RenderObjEffect::BILL ){
			continue;
		}
		WK7RenderObjEffectBill	*pRenderObjEffectBill = (WK7RenderObjEffectBill *)pRenderObjEffect;
		if( pRenderObjEffectBill->GetEffectID()==effectID ){
			return pRenderObjEffectBill;
		}
	}
	return NULL;
}

bool WK7RenderObj::ReleaseEffectBillBoard(s8 effectID)
{
	WK7RenderObjEffectBill	*pRenderObjEffectBill = FindEffectBillBoard(effectID);
	if( pRenderObjEffectBill==NULL ){
		return false;
	}
	delete pRenderObjEffectBill;
	return true;
}

bool WK7RenderObj::IsValidEffect(WK7RenderObjEffect *pEffect)
{
	if( pEffect==NULL ){
		return false;
	}
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect==pEffect ){
			return pRenderObjEffect->IsValid();
		}
	}
	return false;
}

bool WK7RenderObj::ReleaseEffect(WK7RenderObjEffect *pEffect)
{
	if( pEffect==NULL ){
		return false;
	}
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect==pEffect ){
			delete pEffect;
			return true;
		}
	}
	return false;
}

bool WK7RenderObj::DelReqEffect(WK7RenderObjEffect *pEffect)
{
	if( pEffect==NULL ){
		return false;
	}
	WK7RenderObjEffect	*pRenderObjEffect;
	for(pRenderObjEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pRenderObjEffect!=NULL ; pRenderObjEffect=pRenderObjEffect->GetNext()){
		if( pRenderObjEffect==pEffect ){
			return pEffect->DelReqEffect();
		}
	}
	return false;
}

bool WK7RenderObj::FrameProcessEffectResource(void)
{
	WK7RenderObjEffectResource	*pResource;
	WK7RenderObjEffectResource	*pNext;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pNext){
		pNext = pResource->GetNext();
		if( pResource->FrameProcess()==false ){
			delete pResource;
		}
	}
	return true;
}

bool WK7RenderObj::FrameProcessEffect(void)
{
	WK7RenderObjEffect		*pEffect;
	WK7RenderObjEffect		*pNext;
	for(pEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pEffect!=NULL ; pEffect=pNext){
		pNext = pEffect->GetNext();
		if( pEffect->FrameProcess()==false ){
			delete pEffect;
		}
	}
	return true;
}

bool WK7RenderObj::DeleteEffectAll(void)
{
	WK7RenderObjEffect		*pEffect;
	WK7RenderObjEffect		*pNext;
	for(pEffect=(WK7RenderObjEffect *)mEffectAnchor.GetNext() ; pEffect!=NULL ; pEffect=pNext){
		pNext = pEffect->GetNext();
		delete pEffect;
	}
	return true;
}

WK7RenderObjEffectResourceAnim* WK7RenderObj::FindAnimResource(s8 animID)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pResource->GetType()!=WK7RenderObjEffectResource::ANIM ){
			continue;
		}
		WK7RenderObjEffectResourceAnim	*pResourceAnim = (WK7RenderObjEffectResourceAnim *)pResource;
		if( pResourceAnim->GetAnimID()==animID ){
			return pResourceAnim;
		}
	}
	return NULL;
}

bool WK7RenderObj::FindAnimResource(WK7RenderObjEffectResource *pSrcResource)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pSrcResource==pResource ){
			return true;
		}
	}
	return false;
}

WK7RenderObjEffectResourceAnim* WK7RenderObj::CreateEffectAnimResource(s8 animID)
{
	WK7RenderObjEffectResourceAnim	*pResourceAnim = FindAnimResource(animID);
	if( pResourceAnim!=NULL ){
		pResourceAnim->IncRefCount();
		return pResourceAnim;
	}
	ghmGcMemSetAllocName("WK7ROERA");
	if( (pResourceAnim = new WK7RenderObjEffectResourceAnim(&mEffectResourceAnchor,animID))==NULL ){
		return NULL;
	}
	if( pResourceAnim->GetAnimID() < 0 ){
		delete pResourceAnim;
		return NULL;
	}
	pResourceAnim->IncRefCount();
	return pResourceAnim;
}

bool WK7RenderObj::ReleaseEffectAnimResource(s8 animID)
{
	WK7RenderObjEffectResourceAnim	*pResourceAnim = FindAnimResource(animID);
	if( pResourceAnim==NULL ){
		return false;
	}
	pResourceAnim->DecRefCount();
	if( pResourceAnim->GetRefCount()<=0 ){
		delete pResourceAnim;
//		OSDebugReport("Release AnimResource %d\n",animID);
	}
	return true;
}

bool WK7RenderObj::ReleaseEffectAnimResource(WK7RenderObjEffectResourceAnim *pResourceAnim)
{
	if( pResourceAnim==NULL ){
		return false;
	}
	if( FindAnimResource(pResourceAnim)==false ){
		return false;
	}
	pResourceAnim->DecRefCount();
	if( pResourceAnim->GetRefCount()<=0 ){
		delete pResourceAnim;
	}
	return true;
}

bool WK7RenderObjEffectResource::FrameProcess(void)
{
	if( mRefCount <= 0 ){
		return false;
	}
	return true;
}

WK7RenderObjEffectResourceAnim::WK7RenderObjEffectResourceAnim(ghmGcListObj *pAnchor,s8 animID) 
                              : WK7RenderObjEffectResource    (pAnchor)
{
	mType = ANIM;
	if( LoadEasyAnimPack(animID) >= 0 ){
		mAnimID = animID;
	}else{
		mAnimID = -1;
	}
}

WK7RenderObjEffectResourceAnim::~WK7RenderObjEffectResourceAnim()
{
	if( mAnimID >= 0 ){
		ReleaseEasyAnimPack(mAnimID);
	}
}

WK7RenderObjEffectResourceBill* WK7RenderObj::FindBillResource(s8 effectID)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pResource->GetType()!=WK7RenderObjEffectResource::BILL ){
			continue;
		}
		WK7RenderObjEffectResourceBill	*pResourceBill = (WK7RenderObjEffectResourceBill *)pResource;
		if( pResourceBill->GetEffectID()==effectID ){
			return pResourceBill;
		}
	}
	return NULL;
}

bool WK7RenderObj::FindBillResource(WK7RenderObjEffectResource *pSrcResource)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pSrcResource==pResource ){
			return true;
		}
	}
	return false;
}

WK7RenderObjEffectResourceBill* WK7RenderObj::CreateEffectBillResource(s8 effectID)
{
	WK7RenderObjEffectResourceBill	*pResourceBill = FindBillResource(effectID);
	if( pResourceBill!=NULL ){
		pResourceBill->IncRefCount();
		return pResourceBill;
	}
	ghmGcMemSetAllocName("WK7ROERB");
	if( (pResourceBill = new WK7RenderObjEffectResourceBill(&mEffectResourceAnchor,effectID))==NULL ){
		return NULL;
	}
	if( pResourceBill->GetEffectID() < 0 ){
		delete pResourceBill;
		return NULL;
	}
	pResourceBill->IncRefCount();
	return pResourceBill;
}

bool WK7RenderObj::ReleaseEffectBillResource(s8 effectID)
{
	WK7RenderObjEffectResourceBill	*pResourceBill = FindBillResource(effectID);
	if( pResourceBill==NULL ){
		return false;
	}
	pResourceBill->DecRefCount();
	if( pResourceBill->GetRefCount()<=0 ){
		delete pResourceBill;
//		OSDebugReport("Release BillResource %d\n",effectID);
	}
	return true;
}

bool WK7RenderObj::ReleaseEffectBillResource(WK7RenderObjEffectResourceBill *pResourceBill)
{
	if( pResourceBill==NULL ){
		return false;
	}
	if( FindBillResource(pResourceBill)==false ){
		return false;
	}
	pResourceBill->DecRefCount();
	if( pResourceBill->GetRefCount()<=0 ){
		delete pResourceBill;
	}
	return true;
}

WK7RenderObjEffectResourceBill::WK7RenderObjEffectResourceBill(ghmGcListObj *pAnchor,s8 effectID) 
                              : WK7RenderObjEffectResource    (pAnchor)
{
	mType = BILL;
	if( SetupBillboardEffectID(effectID) >= 0 ){
		mEffectID = effectID;
	}else{
		mEffectID = -1;
	}
}

WK7RenderObjEffectResourceBill::~WK7RenderObjEffectResourceBill()
{
	if( mEffectID >= 0 ){
		ReleaseBillboardEffectID(mEffectID);
	}
}

WK7RenderObjEffectResourceBillID* WK7RenderObj::FindBillIDResource(s8 billID)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pResource->GetType()!=WK7RenderObjEffectResource::BILLID ){
			continue;
		}
		WK7RenderObjEffectResourceBillID	*pResourceBillID = (WK7RenderObjEffectResourceBillID *)pResource;
		if( pResourceBillID->GetBillID()==billID ){
			return pResourceBillID;
		}
	}
	return NULL;
}

bool WK7RenderObj::FindBillIDResource(WK7RenderObjEffectResource *pSrcResource)
{
	WK7RenderObjEffectResource	*pResource;
	for(pResource=(WK7RenderObjEffectResource *)mEffectResourceAnchor.GetNext() ; pResource!=NULL ; pResource=pResource->GetNext()){
		if( pSrcResource==pResource ){
			return true;
		}
	}
	return false;
}

WK7RenderObjEffectResourceBillID* WK7RenderObj::CreateEffectBillIDResource(s8 billID)
{
	WK7RenderObjEffectResourceBillID	*pResourceBillID = FindBillIDResource(billID);
	if( pResourceBillID!=NULL ){
		pResourceBillID->IncRefCount();
		return pResourceBillID;
	}
	ghmGcMemSetAllocName("WK7ROERB");
	if( (pResourceBillID = new WK7RenderObjEffectResourceBillID(&mEffectResourceAnchor,billID))==NULL ){
		return NULL;
	}
	if( pResourceBillID->GetBillID() < 0 ){
		delete pResourceBillID;
		return NULL;
	}
	pResourceBillID->IncRefCount();
	return pResourceBillID;
}

bool WK7RenderObj::ReleaseEffectBillIDResource(s8 billID)
{
	WK7RenderObjEffectResourceBillID	*pResourceBillID = FindBillIDResource(billID);
	if( pResourceBillID==NULL ){
		return false;
	}
	pResourceBillID->DecRefCount();
	if( pResourceBillID->GetRefCount()<=0 ){
		delete pResourceBillID;
//		OSDebugReport("Release BillIDResource %d\n",billID);
	}
	return true;
}

bool WK7RenderObj::ReleaseEffectBillIDResource(WK7RenderObjEffectResourceBillID *pResourceBillID)
{
	if( pResourceBillID==NULL ){
		return false;
	}
	if( FindBillIDResource(pResourceBillID)==false ){
		return false;
	}
	pResourceBillID->DecRefCount();
	if( pResourceBillID->GetRefCount()<=0 ){
		delete pResourceBillID;
	}
	return true;
}

WK7RenderObjEffectResourceBillID::WK7RenderObjEffectResourceBillID(ghmGcListObj *pAnchor,s8 billID) 
                                : WK7RenderObjEffectResource    (pAnchor)
{
	mType = BILLID;
	if( ::LoadBillboardImage(billID) >= 0 ){
		mBillID = billID;
	}else{
		mBillID = -1;
	}
}

WK7RenderObjEffectResourceBillID::~WK7RenderObjEffectResourceBillID()
{
	if( mBillID >= 0 ){
		::ReleaseBillboardImage(mBillID);
	}
}

WK7MotionObj::WK7MotionObj()
{
	mpArchive      = NULL;
	mpModelMotion  = NULL;
	mpCameraMotion = NULL;
	mpLightMotion  = NULL;
	mType          = 0xffffffff;
	mID            = 0xffffffff;
	mState         = IDLE;
}

WK7MotionObj::WK7MotionObj(ghmGcListObj *pAnchor,int prio) : WK7Obj(pAnchor,prio)
{
	mpArchive      = NULL;
	mpModelMotion  = NULL;
	mpCameraMotion = NULL;
	mpLightMotion  = NULL;
	mType          = 0xffffffff;
	mID            = 0xffffffff;
	mState         = IDLE;
}

WK7MotionObj::~WK7MotionObj()
{
	GHM_SAFE_DELETE(mpModelMotion );
	GHM_SAFE_DELETE(mpCameraMotion);
	GHM_SAFE_DELETE(mpLightMotion );
}

#ifdef	_DEBUG
bool WK7MotionObj::CheckModel(void)
{
	if( mpArchive!=NULL ){
		if( mpArchive->IncludeModelData()==true ){
			OSDebugReport("Including ModelData in Motion %08x,%08x\n",mType,mID);
		}
	}
	return true;
}
#endif

bool WK7MotionObj::ReleaseArchive(void)
{
	switch( mState ){
	case	LOADED:
		break;
	case	RELEASEARCHIVE:
	case	RELEASEDARCHIVE:
		return true;
	default:
		return false;
	}
	SetState(RELEASEARCHIVE);
	return true;
}

bool WK7MotionObj::RestoreArchive(void)
{
	switch( mState ){
	case	RELEASEDARCHIVE:
		break;
	case	LOADED:
		return true;
	default:
		return false;
	}
	if( RestoreObj()==false ){
		return false;
	}
//	SetState(RESTOREARCHIVE);
	return true;
}

bool WK7MotionObj::LoadReserveProcess(void)
{
	SetState(LOADING);
	return true;
}

bool WK7MotionObj::LoadingProcess(void)
{
	if( mpArchive==NULL ){
		return false;
	}
	if( mpArchive->GetState()!=WK7Archive::WK7ARCHIVE_LOADED ){
		return false;
	}
	mpModelMotion  = mpArchive->CreateModelMotion();
	mpCameraMotion = mpArchive->CreateCameraMotion();
	mpLightMotion  = mpArchive->CreateLightMotion ();
#ifdef	_DEBUG
	CheckModel();
#endif
	SetState(LOADED);
	return true;
}

bool WK7MotionObj::LoadedProcess(void)
{
	return true;
}

bool WK7MotionObj::ReleaseArchiveProcess(void)
{
	GHM_SAFE_DELETE(mpModelMotion );
	GHM_SAFE_DELETE(mpCameraMotion);
	GHM_SAFE_DELETE(mpLightMotion );
	return true;
}

bool WK7MotionObj::RestoreArchiveProcess(void)
{
	return LoadingProcess();
}

bool WK7MotionObj::FrameProcess(void)
{
	switch( mState ){
	case	LOADRESERVE:
		if( LoadReserveProcess()==false ){
			break;
		}
	case	LOADING:
		if( LoadingProcess()==false ){
			break;
		}
	case	LOADED:
		if( LoadedProcess()==false ){
			break;
		}
		break;
	case	RELEASEARCHIVE:
		if( ReleaseArchiveProcess()==false ){
			break;
		}
		mState = RELEASEDARCHIVE;
	case	RELEASEDARCHIVE:
		break;
	case	RESTOREARCHIVE:
		if( RestoreArchiveProcess()==false ){
			break;
		}
		mState = LOADED;
		break;
	case	IDLE:
	default:
		return false;
	}
	return true;
}

bool WK7MotionObj::LoadObj(u32 type,u32 id)
{
	type |= K7MOT_ATTR;
	WK7Archive	*pArchive;
	if( (pArchive = WK7Archive::Find(type,id))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		GetObjFileName(filename,id);
		// ^Cvݒ
		pArchive->SetType(type);
		// hcݒ
		pArchive->SetID  (id);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	WK7ModelMotion		*pModelMotion;
	SetArchive(pArchive);
	SetType   (type);
	SetID     (id);
	if( (pModelMotion = pArchive->CreateModelMotion())==NULL ){
		SetState(LOADING);
	}else{
		SetState(LOADED);
		SetCameraMotion(pArchive->CreateCameraMotion());
		SetLightMotion (pArchive->CreateLightMotion ());
#ifdef	_DEBUG
		CheckModel();
#endif
	}
	SetModelMotion(pModelMotion);
	return true;
}

bool WK7MotionObj::RestoreObj(void)
{
	WK7Archive	*pArchive;
	if( (pArchive = WK7Archive::Find(mType,mID))==NULL ){
		if( (pArchive = WK7Archive::Create())==NULL ){
			return false;
		}
		// t@C擾
		char	filename[WK7_FNAME_MAX];
		GetObjFileName(filename,mID);
		// ^Cvݒ
		pArchive->SetType(mType);
		// hcݒ
		pArchive->SetID  (mID);
		// A[JCu[h
		if( pArchive->LoadArchive(filename)==false ){
			delete pArchive;
			return false;
		}
	}
	WK7ModelMotion		*pModelMotion;
	SetArchive(pArchive);
	if( (pModelMotion = pArchive->CreateModelMotion())==NULL ){
		SetState(RESTOREARCHIVE);
	}else{
		SetState(LOADED);
		SetCameraMotion(pArchive->CreateCameraMotion());
		SetLightMotion (pArchive->CreateLightMotion ());
#ifdef	_DEBUG
		CheckModel();
#endif
	}
	SetModelMotion(pModelMotion);
	return true;
}

bool WK7MotionObj::IsValid(WK7MotionObj* pMotionObj)
{
	WK7MotionObj	*pObj = (WK7MotionObj *)mAnchor.GetNext();
	while( pObj!=NULL ){
		if( pObj==pMotionObj ){
			return true;
		}
		pObj = pObj->GetNext();
	}
	return false;
}

WK7MotionObj* WK7MotionObj::Find(u32 type,u32 id)
{
	WK7MotionObj		*pObj = (WK7MotionObj *)mAnchor.GetNext();
	type |= K7MOT_ATTR;
	while( pObj!=NULL ){
		if( pObj->GetType()==type && pObj->GetID()==id ){
			return pObj;
		}
		pObj = pObj->GetNext();
	}
	return NULL;
}

WK7CharaMotion* WK7MotionObj::CreateCharaMotion(u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7CMt");
	WK7CharaMotion	*pCharaMotion = new WK7CharaMotion(&mAnchor,prio);
	if( pCharaMotion==NULL || pCharaMotion->LoadObj(K7MOT_ATTR|K7OBJTYPE_CHR,id)==false ){
		GHM_SAFE_DELETE(pCharaMotion);
		return NULL;
	}
	return pCharaMotion;
}

WK7StageMotion* WK7MotionObj::CreateStageMotion(u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7SMt");
	WK7StageMotion	*pStageMotion = new WK7StageMotion(&mAnchor,prio);
	if( pStageMotion==NULL || pStageMotion->LoadObj(K7MOT_ATTR|K7OBJTYPE_STG,id)==false ){
		GHM_SAFE_DELETE(pStageMotion);
		return NULL;
	}
	return pStageMotion;
}

WK7ItemMotion* WK7MotionObj::CreateItemMotion(u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7IMt");
	WK7ItemMotion	*pItemMotion  = new WK7ItemMotion (&mAnchor,prio);
	if( pItemMotion==NULL || pItemMotion->LoadObj(K7MOT_ATTR|K7OBJTYPE_ITEM,id)==false ){
		GHM_SAFE_DELETE(pItemMotion);
		return NULL;
	}
	return pItemMotion;
}

WK7MotionObj* WK7MotionObj::CreateMotionObj(u32 type,u32 id,int prio)
{
	ghmGcMemSetAllocName("WK7MotOb");
	WK7MotionObj	*pMotion  = new WK7MotionObj(&mAnchor,prio);
	if( pMotion==NULL || pMotion->LoadObj(K7MOT_ATTR|type,id)==false ){
		GHM_SAFE_DELETE(pMotion);
		return NULL;
	}
	return pMotion;
}

bool WK7MotionObj::FrameProcessAll(void)
{
	WK7MotionObj	*pObj = (WK7MotionObj *)mAnchor.GetNext();
	WK7MotionObj	*pNextObj;
	while( pObj!=NULL ){
		pNextObj = pObj->GetNext();
		pObj->FrameProcess();
		pObj = pNextObj;
	}
	return true;
}

bool WK7MotionObj::ReleaseAll(void)
{
	WK7MotionObj	*pObj;
	for(pObj=(WK7MotionObj *)mAnchor.GetNext() ; pObj!=NULL ; pObj=(WK7MotionObj *)mAnchor.GetNext()){
		if( IsValid(pObj)==true ){
			delete pObj;
		}
	}
	return true;
}

u32 WK7MotionObj::GetMainID(void)
{
	return K7MOT_MAINID(mID);
}

u32 WK7MotionObj::GetSuffix(void)
{
	return K7MOT_SUFFIX(mID);
}

