////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Path
//
// WK7Path.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 01/30/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7PATH_H__
#define	__WK7PATH_H__

//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcMem.h"
//#include "..\Lib\ghmGcTex.h"
//#include "..\Lib\ghmGcUsb.h"
//#include "..\Lib\ghmGcList.h"
//#include "..\Lib\ghmGcNurbs.h"

#include ".\WK7Obj.h"
//#include ".\WK7Model.h"

class WK7JObj;

#define	WK7PATH_FOOTSE_DEFAULT		(0)
#define	WK7PATH_FOOTSE_WOOD			(1)		// ؂̘L
#define	WK7PATH_FOOTSE_STONE		(2)		// ΁C̃RN[g
#define	WK7PATH_FOOTSE_WOOD1		(3)		// ~~؂̘L
#define	WK7PATH_FOOTSE_ROOF			(4)		// ̏
#define	WK7PATH_FOOTSE_STONEW		(5)		// GꂽRN[g
#define	WK7PATH_FOOTSE_STONEC		(6)		// ꂢȃRN[g
#define	WK7PATH_FOOTSE_GROUND		(7)		// y
#define	WK7PATH_FOOTSE_GRASS		(8)		// 
#define	WK7PATH_FOOTSE_MUD			(9)		// D
#define	WK7PATH_FOOTSE_IRON			(10)	// 

#define	WK7PATH_FLAT				(0)
#define	WK7PATH_UPSTAIRS			(1)
#define	WK7PATH_DOWNSTAIRS			(2)

struct WK7BranchDesc{
	ghmScenePathSet					*mpPathSet;
	u_int							mDir;
};

struct WK7BranchPointDesc{
	WK7BranchDesc					**mppBranch;
	u_int							mBranchNum;
	const char						*mpName;
	Vec								mPosition;
};

struct WK7PathDataDesc{
	u16								mStartGatePosCount;
	u16								mEndGatePosCount;
	Vec								*mpStartGatePos;
	Vec								*mpEndGatePos;
	char							*mpRouteName;
	union{
		struct{
			u32						mPass           :  1;
			u32						mCamPass        :  1;
			u32						mRouteNameAlloc :  1;
			u32						mFlagPad        : 29;
		};
		u32							mFlag;
	};
	u16								mCamPosV;
	u16								mCamPosH;
	u16								mCamType;
	u16								mFootSE;
	union{
		HSD_CameraDesc				*mpCameraDesc;			// mCamType 0 or 1
		const char					*mpCameraPathName;		//          2
	};
};

struct WK7CameraPathDesc{
	const char						*mpName;
	u32								mFlag;
	HSD_CameraDesc					*mpCameraDesc;
	Vec								mPosition[2];
};

class WK7Path;
class WK7PathNurbs;
class WK7PathBranchPoint;
class WK7PathBranch;


class WK7PathBranchList : public WK7SmallMemObj{
private:
	WK7PathBranch				*mpBranch;
	WK7PathNurbs				*mpPath;
	u32							mDir;
	WK7PathBranchList			*mpParent;
	WK7PathBranchList			*mpChild;
	f32							mDistance;
public:
	
	inline WK7PathBranch* GetBranch(void){ return mpBranch; }
	inline WK7PathBranchList* GetChild(void){ return mpChild; }
	inline WK7PathBranchList* GetParent(void){ return mpParent; }
	
	WK7PathBranchList(WK7PathBranch *pBranch,WK7PathBranchList *pParent);
	~WK7PathBranchList();
	
	void SetChild(WK7PathBranchList *pChild);
	void SetParent(WK7PathBranchList *pParent);
	bool IsIncluded(WK7PathBranch *pBranch,int flag=3);
	
	bool SetPath(WK7PathNurbs *pPath);
	inline WK7PathNurbs* GetPath(void){ return mpPath; }
	bool SetDir(u32 dir);
	inline u32 GetDir(void){ return mDir; }
	
	bool SetDistance(f32 dist);
	inline f32 GetDistance(void){ return mDistance; }
	
	WK7PathBranchList* GetLast(void);
};

////////////////////////////////////////////////////////////////////////////////
//
// _̃pXƕ
//
#define	WK7PATHBRANCH_DIR_MASK		(7)
class WK7PathBranch{
	friend class WK7PathBranchPoint;
protected:
	WK7PathNurbs					*mpPath;				// pX
	WK7PathBranch					*mpPrev;				// Xgp
	WK7PathBranch					*mpNext;				// 
	
	union{
		struct{
			u32						mDir        :  1;		// 0 : start -> end , 1 : end -> start
			u32						mFlagPad    : 31;
		};
		u32							mFlag;
	};
	
	WK7PathBranch(WK7PathNurbs *pPath,WK7PathBranch *pPrev,WK7PathBranch *pNext,u32 dir);
	~WK7PathBranch();
public:
	inline WK7PathNurbs* GetPath(void){ return mpPath; }
	inline WK7PathBranch* GetPrev(void){ return mpPrev; };
	inline WK7PathBranch* GetNext(void){ return mpNext; };
	inline u32 GetDir(void){ return mDir; }
	inline u32 GetFlag(void){ return mFlag; }
	WK7PathBranchPoint* GetEndBranchPoint(void);
	WK7PathBranchPoint* GetStartBranchPoint(void);
	inline WK7PathBranchPoint* GetNextBranchPoint(void){ return GetEndBranchPoint(); }
	WK7PathBranchList* GetBranchList(WK7PathNurbs *pSearchPath,WK7PathBranchList *pParent);
	bool SearchPath(WK7PathNurbs *pSearchPath,f32 param,WK7PathNurbs *pRootPath,int level);
	
	f32 GetParamDistance(f32 param);
	f32 GetStartParamDistance(f32 param);
	f32 GetEndParamDistance(f32 param);
	f32 GetTotalDistance(void);
	
	f32 GetLimitParam(f32 param);
	bool GetPosition(Vec *pPosition,f32 param,bool limit=true);
	bool GetDeltaPosition(Vec *pDeltaPosition,f32 param,bool limit=true);
	bool GetStartPosition(Vec *pPosition);
	bool GetStartDeltaPosition(Vec *pDeltaPosition);
	bool GetEndPosition(Vec *pPosition);
	bool GetEndDeltaPosition(Vec *pDeltaPosition);
	
	bool IsStairs(void);
	int GetStairsState(void);
	bool IsCurb(void);
	
	bool Pass(bool rev=false);
	bool ClearPass(bool rev=false);
	bool HasPassed(bool rev=false);
	bool Select(bool rev=false);
	bool ClearSelect(bool rev=false);
	bool HasSelected(bool rev=false);
};

class WK7PathBranchPointList : public WK7SmallMemObj{
private:
	WK7PathBranchPoint				*mpBranchPoint;
	WK7PathBranchPointList			*mpNext;
public:
	
	inline WK7PathBranchPoint* GetBranchPoint(void){ return mpBranchPoint; }
	inline WK7PathBranchPointList* GetNext(void){ return mpNext; }
	
	WK7PathBranchPointList(WK7PathBranchPoint *pBranchPoint,WK7PathBranchPointList *pTop=NULL){
		mpBranchPoint = pBranchPoint;
		mpNext        = pTop;
	}
	
};

class WK7PathBranchPointObj : public WK7Obj{
	friend class WK7PathBranchPoint;
public:
	enum Type{
		TYPE_NORMAL = 0,
		TYPE_JOBJ,
		TYPE_JOBJDOOR,
		FORCED_DWORD = 0x7fffffff,
	};
protected:
	WK7PathBranchPoint				*mpContainer;
	char							*mpObjName[2];
	u32								mEventID;
	union{
		struct{
			u32						mEnable       : 1;
			u32						mPlayEnable   : 1;
			u32						mEnableSelect : 1;
			u32						mFlagPad      :29;
		};
		u32							mFlag;
	};
	Type							mType;
	Vec								mPosition;
	int								mSelectObjFlagID;
	
	WK7PathBranchPointObj(WK7PathBranchPoint *pContainer,ghmGcListObj *pAnchor);
public:
	virtual ~WK7PathBranchPointObj();
	
	inline WK7PathBranchPointObj* GetPrev(void){ return (WK7PathBranchPointObj *)ghmGcListObj::GetPrev(); }
	inline WK7PathBranchPointObj* GetNext(void){ return (WK7PathBranchPointObj *)ghmGcListObj::GetNext(); }
	
	WK7PathBranchPoint* GetBranchPoint(void){ return mpContainer; }
	inline Type GetType(void){ return mType; }
	inline void SetEnable(bool flag){ mEnable = flag==true? 1:0; }
	inline bool GetEnable(void){ return mEnable? true : false; }
	inline void SetPlayEnable(bool flag){ mPlayEnable = flag==true? 1:0; }
	inline bool GetPlayEnable(void){ return mPlayEnable? true : false; }
	inline void SetEnableSelect(bool flag){ mEnableSelect = (flag==true)? 1 : 0; }
	inline bool GetEnableSelect(void){ return mEnableSelect? true : false; }
	
	inline void SetEventID(u32 eventid){ mEventID = eventid; }
	inline u32 GetEventID(void){ return mEventID; }
	
	bool SetObjName(int index,const char *pName);
	const char* GetObjName(int index);
	
	virtual void SetPosition(const Vec &pos){ mPosition=pos; }
	virtual void GetPosition(Vec &pos){ pos=mPosition; }
	
	bool Select(int dir);
	bool ClearSelect(int dir);
	bool HasSelected(int dir=-1);
};

class WK7PathBranchPointObjJObj : public WK7PathBranchPointObj{
	friend class WK7PathBranchPoint;
protected:
	WK7JObj							*mpJObj;
	u32								mEventNo;
	WK7PathBranchPointObjJObj(WK7PathBranchPoint *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj);
public:
	virtual ~WK7PathBranchPointObjJObj(){}
	
	inline WK7PathBranchPointObjJObj* GetPrev(void){ return (WK7PathBranchPointObjJObj *)ghmGcListObj::GetPrev(); }
	inline WK7PathBranchPointObjJObj* GetNext(void){ return (WK7PathBranchPointObjJObj *)ghmGcListObj::GetNext(); }
	
	virtual void GetPosition(Vec &pos);
	
	inline void SetEventNo(u32 evno){ mEventNo = evno; }
	inline u32 GetEventNo(void){ return mEventNo; }
	inline void SetJObj(WK7JObj *pJObj){ mpJObj=pJObj; }
	inline WK7JObj* GetJObj(void){ return mpJObj; }
};

class WK7PathBranchPointObjJObjDoor : public WK7PathBranchPointObjJObj{
	friend class WK7PathBranchPoint;
protected:
	u32								mNextStageID;
	u32								mParam;
	char							*mpNextPoint;
	WK7PathBranchPointObjJObjDoor(WK7PathBranchPoint *pContainer,ghmGcListObj *pAnchor,WK7JObj *pJObj);
public:
	virtual ~WK7PathBranchPointObjJObjDoor();
	
	inline WK7PathBranchPointObjJObjDoor* GetPrev(void){ return (WK7PathBranchPointObjJObjDoor *)ghmGcListObj::GetPrev(); }
	inline WK7PathBranchPointObjJObjDoor* GetNext(void){ return (WK7PathBranchPointObjJObjDoor *)ghmGcListObj::GetNext(); }
	
	inline void SetNextStageID(u32 stgid){ mNextStageID = stgid; }
	inline u32 GetNextStageID(void){ return mNextStageID; }
	inline void SetParam(u32 param){ mParam = param; }
	inline u32 GetParam(void){ return mParam; }
	bool SetNextPoint(const char *pName);
	inline const char* GetNextPoint(void){ return mpNextPoint; }
};

class WK7PathBranchPointEvent : public ghmGcListObj{
public:
	enum Type{
		BPEVTYPE_ALL = -1,
		BPEVTYPE_ARRIVE = 0,
		BPEVTYPE_ARRIVE_EVNO,
		BPEVTYPE_LEAVE,
		BPEVTYPE_LEAVE_EVNO,
		BPEVTYPE_LEAVE_EVNO_PATHNAME,
	};
protected:
	u32								mEventID;
	Type							mType;
	union{
		struct{
			u32						mEnable    : 1;
			u32						mHasEventNo: 1;
			u32						mFlagPad   :30;
		};
		u32							mFlag;
	};
public:
	WK7PathBranchPointEvent(ghmGcListObj *pAnchor,u32 eventid) : ghmGcListObj(pAnchor,GHMGCLIST_DEFAULT_PRIO){
		mFlag    = 0;
		mEnable  = 1;
		mEventID = eventid;
	}
	virtual ~WK7PathBranchPointEvent(){}
	
	inline WK7PathBranchPointEvent* GetNext(void){ return (WK7PathBranchPointEvent *)ghmGcListObj::GetNext(); }
	inline WK7PathBranchPointEvent* GetPrev(void){ return (WK7PathBranchPointEvent *)ghmGcListObj::GetPrev(); }
	
	inline Type GetType(void){ return mType; }
	inline u32 GetEventID(void){ return mEventID; }
	inline void SetEnable(bool flag){ mEnable = (flag==true? 1:0); }
	inline bool GetEnable(void){ return mEnable? true : false; }
	inline bool HasEventNo(void){ return mHasEventNo? true : false; }
};

class WK7PathBranchPointEventNo : public WK7PathBranchPointEvent{
protected:
	u32								mEventNo;
public:
	WK7PathBranchPointEventNo(ghmGcListObj *pAnchor,u32 eventid,u32 eventno) : WK7PathBranchPointEvent(pAnchor,eventid){
		mEventNo    = eventno;
		mHasEventNo = 1;
	}
	virtual ~WK7PathBranchPointEventNo(){};
	inline void SetEventNo(u32 evno){ mEventNo=evno; }
	inline u32 GetEventNo(void){ return mEventNo; }
	static char* GetPathName(u32 eventno);
};

class WK7PathBranchPointEventArrive : public WK7PathBranchPointEvent{
protected:
public:
	WK7PathBranchPointEventArrive(ghmGcListObj *pAnchor,u32 eventid) : WK7PathBranchPointEvent(pAnchor,eventid){
		mType = BPEVTYPE_ARRIVE;
	}
	virtual ~WK7PathBranchPointEventArrive(){};
};

class WK7PathBranchPointEventArriveEventNo : public WK7PathBranchPointEventNo{
protected:
public:
	WK7PathBranchPointEventArriveEventNo(ghmGcListObj *pAnchor,u32 eventid,u32 eventno) : WK7PathBranchPointEventNo(pAnchor,eventid,eventno){
		mType = BPEVTYPE_ARRIVE_EVNO;
	}
	virtual ~WK7PathBranchPointEventArriveEventNo(){};
};

class WK7PathBranchPointEventLeave : public WK7PathBranchPointEvent{
protected:
public:
	WK7PathBranchPointEventLeave(ghmGcListObj *pAnchor,u32 eventid) : WK7PathBranchPointEvent(pAnchor,eventid){
		mType = BPEVTYPE_LEAVE;
	}
	virtual ~WK7PathBranchPointEventLeave(){};
};

class WK7PathBranchPointEventLeaveEventNo : public WK7PathBranchPointEventNo{
protected:
	WK7PathNurbs					*mpPath;
public:
	WK7PathBranchPointEventLeaveEventNo(ghmGcListObj *pAnchor,WK7PathBranch *pBranch,u32 eventid,u32 eventno,u32 pathno);
	WK7PathBranchPointEventLeaveEventNo(ghmGcListObj *pAnchor,WK7PathBranch *pBranch,u32 eventid,u32 eventno,const char *pPathName);
	virtual ~WK7PathBranchPointEventLeaveEventNo(){}
	inline WK7PathNurbs* GetPath(void){ return mpPath; }
	static char* GetPathName(u32 eventno,u32 pathno);
};

////////////////////////////////////////////////////////////////////////////////
//
// _
//
#define	WK7PATHBRANCHPOINT_NOARRIVEEVENTID					(0xffffffff)
class WK7PathBranchPoint{
	friend class WK7PathNurbs;
	friend class WK7Path;
protected:
	WK7Path							*mpContainer;						// 
	u32								mBranchNum;							// 
	WK7PathBranch					*mpBranch;							// 擪ւ̃|C^
	const char						*mpName;							// |Cg
	char							*mpShortName;						// |CgiV[gj
	Vec								mPosition;							// Wʒu
	u32								mArriveEventID;						// Cxghc
	ghmGcListObj					mObjAnchor;							// IuWFNgAJ[
	
	ghmGcListObj					mEventAnchor;						// CxgAJ[
	
	union{
		struct{
			u32						mMoveDisableAfterEventCall : 1;		// CxgĂяoړ֎~
			u32						mAutoPlay                  : 1;		// I[gCxg
			u32						mBpCamDisable              : 1;		// _J
			u32						mFlagPad                   :29;
		};
		u32							mFlag;								// 
	};
	
	WK7PathBranchPoint				*mpPrev;							// Xgp
	WK7PathBranchPoint				*mpNext;
	
	WK7PathBranchPoint(WK7Path *pContainer,const char *pName,WK7PathBranchPoint *pPrev,WK7PathBranchPoint *pNext);
	~WK7PathBranchPoint();
	
public:
	inline WK7PathBranchPoint* GetPrev(void){ return mpPrev; }
	inline WK7PathBranchPoint* GetNext(void){ return mpNext; }
	
	bool IsValid(WK7PathBranchPointObj *pTgtBranchPointObj);
	bool IsValid(WK7PathBranch *pTgtBranch);
	
	inline WK7Path* GetContaier(void){ return mpContainer; }
	WK7Stage* GetStage(void);
	
	inline void SetPosition(f32 x,f32 y,f32 z){ mPosition.x=x; mPosition.y=y; mPosition.z=z; }
	inline void SetPosition(const Vec &pos){ mPosition=pos; }
	inline void SetPosition(const Vec *ppos){ mPosition=*ppos; }
	
	inline void GetPosition(Vec *ppos){ *ppos=mPosition; }
	inline void GetPosition(f32 &x,f32 &y,f32 &z){ x=mPosition.x; y=mPosition.y; z=mPosition.z; }
	inline const Vec& GetPosition(void){ return mPosition; }
//	inline const Vec* GetPosition(void){ return &mPosition; }
	
	inline u32 GetBranchNum(void){ return mBranchNum; }
	inline const char* GetName(void){ return mpName; }
	inline WK7PathBranch* GetTopBranch(void){ return mpBranch; }
	inline const char* GetShortName(void){ return mpShortName; }
	
	WK7PathBranch* GetBranch(WK7PathNurbs *pPath);
	int AddBranch(WK7PathNurbs *pPath,u32 dir);
	bool RemoveBranch(WK7PathBranch* pBranch);
	bool RemoveBranch(WK7PathNurbs* pPath);
	int SetPathEnable(bool flag);
	int SetPathEnableEx(bool flag);
	
	WK7PathBranchPointObj* AddObj(void);
	WK7PathBranchPointObjJObj* AddObjJObj(WK7JObj *pJObj);
	WK7PathBranchPointObjJObjDoor* AddObjJObjDoor(WK7JObj *pJObj);
	bool RemoveObj(WK7PathBranchPointObj* pObj);
	inline WK7PathBranchPointObj* GetTopObj(void){ return (WK7PathBranchPointObj *)mObjAnchor.GetNext(); }
	WK7PathBranchPointObj* GetObj(const char *pObjName0,const char *pObjName1);
	WK7PathBranchPointObj* GetObj(u32 eventid);
	WK7PathBranchPointObjJObj* GetObj_EventNo(u32 eventno);
	WK7PathBranchPointObjJObj* GetObj(WK7JObj *pJObj);
	int GetEnableObjNum(void);
	int GetObjNum(void);
	int GetEnableBranchPathNum(WK7PathNurbs *pExceptPath=NULL);
	int GetBranchPathNum(void);
	
	int GetEnableBranchNum(WK7PathBranch *pExceptBranch,bool enableex=false);
	int GetEnableBranchNum(WK7PathNurbs *pExceptPath=NULL,bool enableex=false);
//	int GetEnableBranchMoveNum(WK7PathNurbs *pExceptPath,bool enableex=false);
	
	inline void SetArriveEventID(u32 id){ mArriveEventID = id; }
	inline u32 GetArriveEventID(void){ return mArriveEventID; }
	
	inline void SetMoveDisableAfterEventCall(bool flag){ mMoveDisableAfterEventCall = (flag==true)? 1:0; }
	inline bool GetMoveDisableAfterEventCall(void){ return mMoveDisableAfterEventCall? true : false; }
	inline void SetAutoPlay(bool flag){ mAutoPlay = (flag==true)? 1:0; }
	inline bool GetAutoPlay(void){ return mAutoPlay? true : false; }
	
	WK7PathBranch* GetBranchSearchPath(WK7PathNurbs *pSearchPath,f32 *pDist=NULL);
	f32 GetPathDistance(WK7PathNurbs *pSearchPath,WK7PathBranchPointList *pList);
	WK7PathBranchList* GetBranchList(WK7PathNurbs *pSearchPath,WK7PathBranchList *pParent);
	
	bool SearchPath(WK7PathNurbs *pSearchPath,f32 param,WK7PathNurbs *pRootPath,int level);
	
	WK7PathBranch* SelectNextDefaultBranch(const Vec *pDir,WK7PathNurbs *pExceptPath=NULL,bool enableex=false);
	
	int ChangeEventNo(u32 from_evno,u32 to_evno);
	
	int SetEventEnable(u32 eventid,bool flag);
	int SetEventNoEnable(u32 eventno,bool flag);
	int SetObjVisible(u32 eventid,bool flag);
	int SetObjVisibleEventNo(u32 eventno,bool flag);
	WK7JObj* GetObjEventNo(u32 eventno);
	
	inline void SetBpCamDisable(bool flag){ mBpCamDisable=(flag==true? 1:0); }
	inline bool GetBpCamDisable(void){ return mBpCamDisable? true : false; }
	
	WK7PathBranchPointEvent* FindEvent(WK7PathBranchPointEvent *pEvent,u32 eventid);
	WK7PathBranchPointEvent* FindEvent(WK7PathBranchPointEvent *pEvent=NULL,WK7PathBranchPointEvent::Type type=WK7PathBranchPointEvent::BPEVTYPE_ALL);
	
	WK7PathBranchPointEventArrive* CreateArriveEvent(u32 eventid);
	WK7PathBranchPointEventArriveEventNo* CreateArriveEventNo(u32 eventid,u32 eventno);
	WK7PathBranchPointEventLeave* CreateLeaveEvent(u32 eventid);
	WK7PathBranchPointEventLeaveEventNo* CreateLeaveEventNo(u32 eventid,u32 eventno,u32 pathno);
	WK7PathBranchPointEventLeaveEventNo* CreateLeaveEventNo(u32 eventid,u32 eventno,const char *pPathName);
	
	int CallArriveEvent(void);
	int CallLeaveEvent(WK7PathNurbs *pNextPath);
};

#define	WK7PATH_BRANCH_PREFIX	"branch"
#define	WK7PATH_DOOR_PREFIX		"door"
#define	WK7PATH_SHORTPATHNAME_MAX	(32)
////////////////////////////////////////////////////////////////////////////////
//
// P{NurbspXi[_̕_܂ށj
//
class WK7PathNurbs{
	friend class WK7Path;
protected:
	static char						mShortPathNameWork[WK7PATH_SHORTPATHNAME_MAX];
	WK7Path							*mpContainer;
	ghmGcNurbs						mNurbsCurve;				// NURBSp
	ghmScenePathSet					*mpPathSet;					// NURBSpX
	WK7PathNurbs					*mpPrev;					// Xgp
	WK7PathNurbs					*mpNext;					// 
	
	WK7PathBranchPoint				*mpStartBranchPoint;		// [̕_
	WK7PathBranchPoint				*mpEndBranchPoint;			// I[̕_
	
	f32								mStartBranchLimitParam;		// [̕򃊃~bgp[^l
	f32								mEndBranchLimitParam;		// I[̕򃊃~bgp[^l
	
	WK7JObj							*mpStartGate;				// [Q[g
	WK7JObj							*mpEndGate;					// I[Q[g
	
#ifdef	_DEBUG
	Vec								*mpRenderPosition;			// fobOp
	int								mRenderPositionNum;			// 
#endif
	
	union{
		struct{
			u32						mEnable            :  1;	// gp\
			u32						mNoSearchPath      :  1;	// pX͂Ȃ
			u32						mStairs            :  1;	// Ki
			u32						mUpStairs          :  1;	// is葮
			u32						mCurb              :  1;	// i
			u32						mEnableEx          :  1;	// gp\
			u32						mEnableEvent       :  1;	// Cxggp\
			u32						mEnableSelect      :  1;	// I\
			u32						mStageJump         :  1;	// Xe[WWv
			u32						mDisablePathCamera :  1;	// pXJ֎~
			u32						mFlagPad           : 22;
		};
		u32							mFlag;
	};
	
	u32								mEventID;					// Cxghc
	u32								mEventNo;					// Cxgԍ
	u32								mNextStageID;				// ̃Xe[Whc
	u32								mParam;
	char							*mpNextPoint;				// ̃Xe[Wo_
	char							*mpSelectObjName;			// IIuWFNg
	
	WK7PathBranch					*mpSearchBranch;
	WK7PathNurbs					*mpSearchPath;
	f32								mSearchDist;
	int								mSearchLevel;
	
	int								mPassPathFlagID;
	
	static int						mCurrentLevel;
	
	void InitMember(WK7Path *pContainer,ghmScenePathSet *pPathSet,WK7PathNurbs *pPrev,WK7PathNurbs *pNext,u32 stgid);
	bool CreateRenderPosition(void);
	bool ReleaseRenderPosition(void);
	bool SetEvent(u32 stgid);
	bool ParseDoorEvent(u32 stgid);
	bool ParseBranchEvent(u32 stgid);
	bool SetPassFlag(void);
	
	WK7PathNurbs(WK7Path *pContainer,ghmScenePathSet *pPathSet,WK7PathNurbs *pPrev,WK7PathNurbs *pNext,u32 stgid);
public:
	WK7PathNurbs(WK7Path *pContainer,ghmScenePathSet *pPathSet);
	~WK7PathNurbs();
	
	inline WK7Path* GetContaier(void){ return mpContainer; }
	WK7Stage* GetStage(void);
	
	bool Pass(int dir);
	bool ClearPass(int dir);
	bool HasPassed(int dir=-1);
	bool Select(int dir);
	bool ClearSelect(int dir);
	bool HasSelected(int dir=-1);
	
	inline u32 GetEventID(void){ return mEventID; }
	inline u32 GetEventNo(void){ return mEventNo; }
	inline u32 GetNextStageID(void){ return mNextStageID; }
	inline u32 GetParam(void){ return mParam; }
	inline const char* GetNextPoint(void){ return mpNextPoint; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
	
	inline static int GetCurrentLevel(void){ return mCurrentLevel; }
	const char* GetName(void);
	bool SearchName(const char *pName);
	const char* GetShortName(char *pName=NULL);
	static const char* GetShortName(const char *pPathName,char *pName=NULL);
	
	int ChangeEventNo(u32 from_evno,u32 to_evno);
	
	inline void SetEnableEvent(bool flag){ mEnableEvent = (flag==true)? 1 : 0; }
	inline bool GetEnableEvent(void){ return mEnableEvent? true : false; }
	
	inline void SetEnable(bool flag){ mEnable = (flag==true)? 1 : 0; }
	inline bool GetEnable(void){ return mEnable? true : false; }
	inline void SetEnableEx(bool flag){ mEnableEx = (flag==true)? 1 : 0; }
	inline bool GetEnableEx(void){ return mEnableEx? true : false; }
	inline void SetEnableSelect(bool flag){ mEnableSelect = (flag==true)? 1 : 0; }
	inline bool GetEnableSelect(void){ return mEnableSelect? true : false; }
	
	inline void SetStageJump(bool flag){ mStageJump = (flag==true)? 1 : 0; }
	inline bool GetStageJump(void){ return mStageJump? true : false; }
	
	inline void SetDisablePathCamera(bool flag){ mDisablePathCamera = (flag==true)? 1 : 0; }
	inline bool GetDisablePathCamera(void){ return mDisablePathCamera? true : false; }
	
	int SetEventEnable(u32 eventid,bool flag);
	int SetEventNoEnable(u32 eventno,bool flag);
	
	inline void SetStairs(bool flag){ mStairs = (flag==true)? 1 : 0; }
	inline bool GetStairs(void){ return mStairs? true : false; }
	inline void SetUpStairs(bool flag){ mUpStairs = (flag==true)? 1 : 0; }
	inline bool GetUpStairs(void){ return mUpStairs? true : false; }
	inline void SetCurb(bool flag){ mCurb = (flag==true)? 1 : 0; }
	inline bool GetCurb(void){ return mCurb? true : false; }
	
	void ClearSearchPathInfo(void);
	void ClearSearchPathInfoAll(void);
	inline void SetNoSearchPath(bool flag){ mNoSearchPath = (flag==true)? 1 : 0; }
	inline bool GetNoSearchPath(void){ return mNoSearchPath? true : false; }
	inline void SetSearchBranch(WK7PathBranch *pBranch){ mpSearchBranch=pBranch; }
	inline WK7PathBranch* GetSearchBranch(void){ return mpSearchBranch; }
	inline void SetSearchPath(WK7PathNurbs *pPath){ mpSearchPath=pPath; }
	inline WK7PathNurbs* GetSearchPath(void){ return mpSearchPath; }
	inline void SetSearchDist(f32 dist){ mSearchDist=dist; }
	inline f32 GetSearchDist(void){ return mSearchDist; }
	inline void SetSearchLevel(int level){ mSearchLevel=level; }
	inline int GetSearchLevel(void){ return mSearchLevel; }
	
	inline void SetStartGate(WK7JObj *pStartGate){ mpStartGate=pStartGate; }
	inline WK7JObj* GetStartGate(void){ return mpStartGate; }
	inline void SetEndGate(WK7JObj *pEndGate){ mpEndGate=pEndGate; }
	inline WK7JObj* GetEndGate(void){ return mpEndGate; }
	
	bool SetStartBranchPoint(WK7PathBranchPoint *pBranchPoint);
	bool SetEndBranchPoint(WK7PathBranchPoint *pBranchPoint);
	
	bool RemoveStartBranchPoint(void);
	bool RemoveEndBranchPoint(void);
	
	inline WK7PathBranchPoint* GetStartBranchPoint(void){ return mpStartBranchPoint; }
	inline WK7PathBranchPoint* GetEndBranchPoint(void){ return mpEndBranchPoint; }
	inline WK7PathBranchPoint* GetBranchPoint(u32 dir){ return dir? mpEndBranchPoint : mpStartBranchPoint; }
	bool SetStartBranchLimitDist(f32 dist);
	bool SetStartBranchLimitParam(f32 param);
	bool SetEndBranchLimitDist(f32 dist);
	bool SetEndBranchLimitParam(f32 param);
	inline f32 GetStartBranchLimitParam(void){ return mStartBranchLimitParam; }
	inline f32 GetEndBranchLimitParam(void){ return mEndBranchLimitParam; }
	
	WK7PathBranchPoint* GetBranchPoint(WK7PathNurbs *pSearchPath,f32 *pDist=NULL);
	WK7PathBranchList* GetBranchList(WK7PathNurbs *pSearchPath);
	WK7PathBranchList* GetBranchList(f32 srcparam,WK7PathNurbs *pSearchPath,f32 dstparam);
	WK7PathNurbs* GetPath(f32 dist,f32 param,u32 dir,f32 *pParam,u32 *pDir,bool enableex);
	
#ifdef	_DEBUG
	bool RenderPosition(void);
#endif
	
	u16 GetFootSE(void);
	WK7PathDataDesc* GetPathDataDesc(void);
	bool SetRouteName(const char *pRouteName);
	inline ghmScenePathSet* GetPathSet(void){ return mpPathSet; }
	inline ghmNurbsPathDesc* GetDesc(void){ return (mpPathSet==NULL? NULL : mpPathSet->mpDesc); }
	inline ghmGcNurbs* GetNurbsCurve(void){ return &mNurbsCurve; }
	inline WK7PathNurbs* GetPrev(void){ return mpPrev; }
	inline WK7PathNurbs* GetNext(void){ return mpNext; }
	
	f32 GetParamDistance(f32 param);
	f32 GetParam(f32 dist);
	
	inline int GetDegree(void){ return mNurbsCurve.GetDegree(); }
	inline int GetSpanCount(void){ return mNurbsCurve.GetSpanCount(); }
	inline int GetCVCount(void){ return mNurbsCurve.GetCVCount(); }
	inline int GetKnotCount(void){ return mNurbsCurve.GetKnotCount(); }
	inline f32 GetStartParam(void){ return mNurbsCurve.GetStartParam(); }
	inline f32 GetEndParam(void){ return mNurbsCurve.GetEndParam(); }
	inline f32 GetTotalDistance(void){ return mNurbsCurve.GetTotalDistance(); }
	inline bool GetCV(int index,Vec4 &cv){ return mNurbsCurve.GetCV(index,cv); }
	inline float GetKnot(int index){ return mNurbsCurve.GetKnot(index); }
	
	inline bool GetPoint(Vec4 &point,f32 param){ return mNurbsCurve.GetPoint(point,param); }
	inline bool GetPoint(Vec  &point,f32 param){ return mNurbsCurve.GetPoint(point,param); }
	inline bool GetDiffVec(Vec4 &vec,f32 param,int rank=1){ return mNurbsCurve.GetDiffVec(vec,param,rank); }
	inline bool GetDiffVec(Vec  &vec,f32 param,int rank=1){ return mNurbsCurve.GetDiffVec(vec,param,rank); }
	
	inline bool GetStartPoint(Vec4 &point){ return mNurbsCurve.GetStartPoint(point); }
	inline bool GetStartPoint(Vec  &point){ return mNurbsCurve.GetStartPoint(point); }
	inline bool GetStartDiffVec(Vec4 &vec,int rank=1){ return mNurbsCurve.GetStartDiffVec(vec,rank); }
	inline bool GetStartDiffVec(Vec  &vec,int rank=1){ return mNurbsCurve.GetStartDiffVec(vec,rank); }
	
	inline bool GetEndPoint(Vec4 &point){ return mNurbsCurve.GetEndPoint(point); }
	inline bool GetEndPoint(Vec  &point){ return mNurbsCurve.GetEndPoint(point); }
	inline bool GetEndDiffVec(Vec4 &vec,int rank=1){ return mNurbsCurve.GetEndDiffVec(vec,rank); }
	inline bool GetEndDiffVec(Vec  &vec,int rank=1){ return mNurbsCurve.GetEndDiffVec(vec,rank); }
	
	inline f32 CalcDistance(f32 param){ return mNurbsCurve.CalcDistance(param); }
	inline f32 CalcParam(f32 dist){ return mNurbsCurve.CalcParam(dist); }
};


#define	WK7PATHINFO_INITDIR_TGTDIR			(-1)
#define	WK7PATHINFO_INITDIR_TGTDIR_REV		(-2)
////////////////////////////////////////////////////////////////////////////////
//
// pXʒu
//
class WK7PathInfo{
protected:
	WK7PathNurbs					*mpPath;			// pXւ̃N
	f32								mParam;				// pX̃p[^
	u32								mDir;				//  0:A1:t
	Vec								mPosition;
	Vec								mDeltaPosition;
	
public:
	WK7PathInfo(){
		mpPath           = NULL;
		mParam           = 0.0f;
		mDir             = 0;
		mPosition     .x = 
		mPosition     .y = 
		mPosition     .z = 0.0f;
		mDeltaPosition.x = 
		mDeltaPosition.y = 
		mDeltaPosition.z = 0.0f;
	}
	~WK7PathInfo(){};
	
	f32 GetLimitParam(f32 param);
	
	bool SetPath(WK7PathNurbs *pPath,bool limit=true);
	inline WK7PathNurbs* GetPath(void){ return mpPath; }
	inline const char* GetPathName(void){ return mpPath==NULL? NULL : mpPath->GetName(); }
	
	bool SetParam(f32 param,bool limit=true);
	inline f32 GetParam(void){ return mParam; }
	
	bool SetDir(u32 dir);
	inline u32 GetDir(void){ return mDir; }
	
	bool GetPosition(Vec *pPosition);
	bool GetDeltaPosition(Vec *pDeltaPosition);
	bool GetStartPosition(Vec *pPosition);
	bool GetStartDeltaPosition(Vec *pDeltaPosition);
	bool GetEndPosition(Vec *pPosition);
	bool GetEndDeltaPosition(Vec *pDeltaPosition);
	
	bool CheckInterpolateDist(void);
	
	WK7PathNurbs* GetPath(f32 dist,int initdir,f32 *pParam,u32 *pDir,bool enableex);
	WK7PathBranchPoint* GetNextBranchPoint(void);
	WK7PathBranchPoint* GetPrevBranchPoint(void);
	f32 Move(f32 param);
	
	bool SetBranchPath(WK7PathBranch *pBranch);
	
	f32 GetRestLinearDistance(void);
	f32 GetRestDistance(void);
	f32 GetTotalDistance(void);
	f32 GetDistance(void);
	
	inline f32 GetRestLinearDist(void){ return GetRestLinearDistance(); }
	inline f32 GetRestDist(void){ return GetRestDistance(); }
	inline f32 GetDist(void){ return GetDistance(); }
	inline f32 GetTotalDist(void){ return GetTotalDistance(); }
	
	WK7PathBranchList* GetBranchList(WK7PathInfo *pSearchPathInfo);
	
	int GetRelativePosition(WK7PathInfo *pFromPathInfo,WK7PathInfo *pToPathInfo);
	
	bool IsStairs(void);
	int GetStairsState(void);
	bool IsCurb(void);
	
	bool Pass(bool rev=false);
	bool ClearPass(bool rev=false);
	bool HasPassed(bool rev=false);
	bool Select(bool rev=false);
	bool ClearSelect(bool rev=false);
	bool HasSelected(bool rev=false);
};

#define	WK7PATH_DEFAULT_INTERPOLATE_DIST			(10.0f)
class WK7Archive;

////////////////////////////////////////////////////////////////////////////////
//
// pXŚif[^܂ށj
//
class WK7Path{
public:
	enum WK7PathControlState{
		PC_IDLE = 0,
		PC_ACTIVE,
		PC_MAX = 0x7fffffff,
	};
	enum WK7PathControlInterporateState{
		PCI_IDLE = 0,
		PCI_ACTIVE,
		PCI_MAX = 0x7fffffff,
	};
protected:
	static f32						mInterpolateDist;			// ԊJn
	static int						mPassPathFlagID;
	static int						mPassPathFlagIDMax;
	static int						mSelectObjFlagID;
	static int						mSelectObjFlagIDMax;
	WK7Stage						*mpContainer;
	
	// A[JCuf[^
	WK7Archive						*mpArchive;
	
	// pXf[^
	WK7PathNurbs					*mpPathTop;
	WK7PathBranchPoint				*mpBranchPointTop;
	u32								mPathNum;
	u32								mBranchPointNum;
	
	union{
		struct{
			u32						mBpArrive   :  1;		// _B
			u32						mFlagPad    : 31;
		};
		u32							mFlag;
	};
	
	WK7CameraPathDesc				**mppCameraPathDesc;
	
	void InitMember(void);
	bool ParseData(ghmScenePathSet **ppPathSet,WK7BranchPointDesc **ppBranchPointDesc,u32 stgid);
	bool FreeArchive(void);
	bool SetPassFlag(void);
	
public:
	WK7Path(WK7Archive *pArchive,u32 stgid);
	WK7Path();
	~WK7Path();
	
	inline WK7Archive* GetArchive(void){ return mpArchive; }
	
	int GetVersion(void);
	
	bool IsValid(WK7PathBranchPointObj *pTgtBranchPointObj);
	bool IsValid(WK7PathBranch *pTgtBranch);
	bool IsValid(WK7PathBranchPoint *pTgtBranchPoint);
	bool IsValid(WK7PathNurbs *pTgtPath);
	
//	static bool SetFlagID(int startPassPathFlagID,int endPassPathFlagID,int startSelectObjFlagID,int endSelectObjFlagID);
	static bool ClearFlagID(void);
	static bool InvalidFlagID(void);
	inline static void IncPassPathFlagID(void){ mPassPathFlagID+=4; }
	inline static int GetPassPathFlagID(void){ return mPassPathFlagID; }
	inline static int GetPassPathFlagIDMax(void){ return mPassPathFlagIDMax; }
	inline static void IncSelectObjFlagID(void){ mSelectObjFlagID+=2; }
	inline static int GetSelectObjFlagID(void){ return mSelectObjFlagID; }
	inline static int GetSelectObjFlagIDMax(void){ return mSelectObjFlagIDMax; }

	inline void SetContainer(WK7Stage *pContainer){ mpContainer=pContainer; }
	inline WK7Stage* GetContainer(void){ return mpContainer; }
	
	static void DoorEventTask(void);
	static void BranchEventTask(void);
	
	bool ReleaseReference(void);
	
	WK7PathNurbs* AddPath(ghmScenePathSet *pPathSet,u32 stgid);
	bool DeletePath(ghmNurbsPathDesc *pDesc);
	bool DeletePath(ghmScenePathSet *pPathSet);
	WK7PathNurbs* GetPath(ghmNurbsPathDesc *pDesc);
	WK7PathNurbs* GetPath(ghmScenePathSet *pPathSet);
	WK7PathNurbs* GetPath(const char *pName);
	WK7PathNurbs* GetPath_EventNo(u32 evno);
	inline WK7PathNurbs* GetPathTop(void){ return mpPathTop; }
	WK7PathNurbs* SearchPath(const char *pName);
	
	WK7PathBranchPoint* AddBranchPoint(const char *pName);
	bool DeleteBranchPoint(const char *pName);
	WK7PathBranchPoint* GetBranchPoint(const char *pName);
	WK7PathBranchPoint* GetBranchPoint_EventNo(u32 eventno,WK7PathBranchPoint *pBranchPoint=NULL);
	inline WK7PathBranchPoint* GetBranchPointTop(void){ return mpBranchPointTop; }
	WK7PathBranchPointObjJObj* GetObj_EventNo(u32 eventno);
	
	inline u32 GetPathNum(void){ return mPathNum; }
	inline u32 GetBranchPointNum(void){ return mBranchPointNum; }
	
	bool FrameProcess(void);
	bool RenderPath(void);
	
	inline static void SetInterpolateDist(f32 dist){ mInterpolateDist = dist; }
	inline static f32 GetInterpolateDist(void){ return mInterpolateDist; }
	
	WK7CameraPathDesc* GetCameraPath(const char *pName);
	WK7CameraPathDesc* GetCameraPath(WK7PathNurbs *pPath);
	
	HSD_CameraDesc* GetPathCamera(WK7PathNurbs *pPath);
	HSD_CameraAnim* GetPathCameraAnim(WK7PathNurbs *pPath);
	
	int ChangeEventNo(u32 from_evno,u32 to_evno);
	
	int SetEventEnable(u32 eventid,bool flag);
	int SetEventNoEnable(u32 eventno,bool flag);
	int SetObjVisible(u32 eventid,bool flag);
	int SetObjVisibleEventNo(u32 eventno,bool flag);
	WK7JObj* GetObjEventNo(u32 eventno);
	int SetBpCamDisable(const char *pName,bool flag);
};

class WK7PathSelectIF;
class WK7PathControlObj;
////////////////////////////////////////////////////////////////////////////////
//
// pXړ
//
class WK7PathControl : public WK7SmallMemObj{
public:
	enum WK7PathControlState{
		PC_IDLE = 0,
		PC_ACTIVE,
		PC_PATHSELECT,
		PC_MAX = 0x7fffffff,
	};
	enum WK7PathControlInterpolateState{
		PCI_IDLE = 0,
		PCI_ACTIVE,
		PCI_MAX = 0x7fffffff,
	};
protected:
	
//	static WK7PathControl			*mpInstance;
	
	WK7PathControlObj				*mpControlObj;					// Rg[IuWFNg
	
	WK7Path							*mpControlPath;					// pX
	
	WK7PathInfo						mCurrentPath;					// ݂̃pX
	WK7PathInfo						mNextPath;						// ̃pX
	WK7PathInfo						mInterpolatePath;				// ԃpX
	
	WK7PathControlState				mState;							// 
	u32								mActiveCounter;					// ANeBuɂĂ̎
	
	WK7PathControlInterpolateState	mInterpolateState;				// ԏ
	
	f32								mReqMoveDistance;				// NGXgړ
	f32								mPrevMoveDistance;				// Oړ
	f32								mDefaultMoveDistance;			// ʏړ
	WK7AnimLinearF					mIpMoveDistance;				// Ԉړ
	
	f32								mBranchSelectAppearDistance;	// Io
	WK7PathBranch					*mpNextBranch;					// ̕
	
	HSD_CameraAnim					*mpCurrentCameraAnim;			// JgJAj
	f32								mCurrentCameraAnimTotalFrame;	// JgJAjt[
	
	// W
	Vec								mCurrentPosition;
	Vec								mCurrentDir;
	
	union{
		struct{
			u32						mReverseReq           :  1;		// ]NGXg
			u32						mRenew                :  1;		// XVtO
			u32						mCamJump              :  1;		// JWv
			u32						mInterpolateOperate   :  1;		// Ԓ
			u32						mInterpolateDisable   :  1;		// ԋ֎~
			u32						mEventCall            :  1;		// CxgĂяo
			u32						mPathEnableEx         :  1;		// pXgpg̎gp
			u32						mEnable               :  1;		// L^
			u32						mSetCurrentPath       :  1;		// JgpXݒ
			u32						mBranchPointFix       :  1;		// _Œ
			u32						mPathChangeCancel     :  1;		// pXύXLZ
			u32						mPassPathRequest      :  1;		// pXʍstOZbgNGXg
			u32						mInterpolateStop      :  1;		// Ԓ~
			u32						mFlagPad              : 19;
		};
		u32							mFlag;							// tO
	};
	
	bool CreateInterpolatePath(const Vec *pStartPos,const Vec *pStartDir,WK7PathNurbs *pNextPath,f32 nextParam,u32 nextDir);
	bool CreateInterpolatePath(const Vec *pStartPos,const Vec *pStartDir,const Vec *pEndPos,const Vec *pEndDir);
	bool ReleaseInterpolatePath(void);
	
	int CallArriveEvent(WK7PathBranchPoint *pBranchPoint,WK7PathNurbs *pNextPath);
	int CallLeaveEvent(WK7PathBranchPoint *pBranchPoint,WK7PathNurbs *pNextPath);
	int PrePathChangeProcess(WK7PathBranch *pBranch);
	
	bool CallPathChagneCallback(WK7PathNurbs *pPath,int inv);
public:
	WK7PathControl();
	~WK7PathControl();
	
	inline void SetEnable(bool flag){ mEnable=(flag==true)? 1:0; }
	inline bool GetEnable(void){ return mEnable? true : false; }
	inline void SetBranchPointFix(bool flag){ mBranchPointFix=(flag==true)? 1:0; }
	inline bool GetBranchPointFix(void){ return mBranchPointFix? true : false; }
	inline void SetPathChangeCancel(bool flag){ mPathChangeCancel=(flag==true)? 1:0; }
	inline bool GetPathChangeCancel(void){ return mPathChangeCancel? true : false; }
	
//	static WK7PathControl* GetInstance(void);
	bool CallPathTermEvent(WK7PathNurbs *pPath);
	
	inline WK7PathControlState GetState(void){ return mState; }
	inline WK7PathControlInterpolateState GetInterpolateState(void){ return mInterpolateState; }
	
	bool SetControlPath(WK7Path *pPath);
	WK7Path* GetControlPath(void){ return mpControlPath; }
	bool SetCurrentBranchPath(WK7PathBranch *pBranch);
	bool SetCurrentPath(WK7PathNurbs *pPath=NULL,f32 param=0.0f,u32 dir=0);
	bool SetCurrentPath(const char *pName,f32 param=0.0f,u32 dir=0);
	bool SetCurrentPath(const char *pBpName,const char *pPathName,f32 dparam=0.0f);
	bool SetCurrentPathToBp(const char *pBpName,const char *pPathName,f32 dparam=0.0f);
	bool CallPathChagneCallback(void);
	
	bool SetPathSelectMode(void);
	bool SetNextBranch(WK7PathBranch *pBranch);
	inline WK7PathBranch* GetNextBranch(void){ return mpNextBranch; }
	
	inline void GetCurrentPosition(Vec *pPosition){ *pPosition = mCurrentPosition; }
	inline void GetCurrentDir(Vec *pDir){ *pDir = mCurrentDir; }
	
	bool FrameProcess(void);
	bool RenderProcess(void);
	
	bool CameraRenew(void);
	
	bool Move(f32 dist);
	bool SetDefaultMoveDist(f32 dist){ if( dist <= 0.0f ){ return false; } mDefaultMoveDistance = dist; return true; }
	bool Reverse(void);
	bool ReverseCancel(void);
	bool SetActive(bool flag);
	
	bool GetReverseReq(void){ return mReverseReq? true : false; }
	
	inline void SetPathEnableEx(bool flag){ mPathEnableEx=(flag==true? 1:0); }
	inline bool GetPathEnableEx(void){ return mPathEnableEx? true : false; }
	inline void SetPassPathRequest(bool flag){ mPassPathRequest=(flag==true? 1:0); }
	inline bool GetPassPathRequest(void){ return mPassPathRequest? true : false; }
	
	inline void SetInterpolateOperate(bool flag){ mInterpolateOperate=(flag==true? 1:0); }
	inline bool GetInterpolateOperate(void){ return mInterpolateOperate? true : false; }
	inline void SetInterpolateDisable(bool flag){ mInterpolateDisable=(flag==true? 1:0); }
	inline bool GetInterpolateDisable(void){ return mInterpolateDisable? true : false; }
	inline void SetInterpolateStop(bool flag){ mInterpolateStop=(flag==true? 1:0); }
	inline bool GetInterpolateStop(void){ return mInterpolateStop? true : false; }
	inline void SetEventCall(bool flag){ mEventCall=(flag==true? 1:0); }
	inline bool GetEventCall(void){ return mEventCall? true : false; }
	bool InterpolateSkip(void);
	
	inline void SetCameraJump(void){ mCamJump=1; }
	inline void ResetCameraJump(void){ mCamJump=0; }
	inline bool GetCameraJump(void){ return mCamJump? true : false; }
	
	bool SetControlObj(WK7PathControlObj *pObj);
	
	WK7CameraPathDesc* GetCurrentCameraPath(void);
	HSD_CameraDesc* GetCurrentPathCamera(void);
	inline WK7PathInfo* GetCurrentPathInfo(void){ return &mCurrentPath; }
	inline WK7PathInfo* GetInterpolatePathInfo(void){ return &mInterpolatePath; }
	inline WK7PathInfo* GetNextPathInfo(void){ return &mNextPath; }
	WK7PathInfo* GetControlPathInfo(void);
	inline WK7PathNurbs* GetCurrentPath(void){ return mCurrentPath.GetPath(); }
	inline const char* GetCurrentPathName(void){ return mCurrentPath.GetPathName(); }
	inline WK7PathNurbs* GetNextPath(void){ return mCurrentPath.GetPath(); }
	inline const char* GetNextPathName(void){ return mNextPath.GetPathName(); }
	
	WK7CameraPathDesc* GetCameraPath(const char *pName);
	WK7CameraPathDesc* GetCameraPath(WK7PathNurbs *pPath);
	
	u32 GetActiveCounter(void){ return mActiveCounter; }
	
	u16 GetCurrentFootSE(void);
};

//#define	WK7PATHCONTROL	WK7PathControl::GetInstance()

class WK7PathControlObj{
public:
	enum CallbackResult{
		RESULT_OK,
		RESULT_CANCEL,
		RESULT_FAILED,
	};
protected:
public:
	WK7PathControlObj();
	virtual ~WK7PathControlObj();
	
	virtual CallbackResult PreMoveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,f32 restdist);
	virtual CallbackResult PostMoveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,f32 restdist,f32 movedist);
	virtual CallbackResult ReverseCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo);
	virtual CallbackResult RenewCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo);
	virtual CallbackResult PathChangeCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranch *pSelectBranch,bool interpolate,int inv);
	virtual CallbackResult BranchPointArriveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
	virtual CallbackResult PathSelectCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
};

#endif	//__WK7PATH_H__

