////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Play
//
// WK7Play.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/03/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7PLAY_H__
#define	__WK7PLAY_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include "..\Lib\ghmGcList.h"
//#include "..\Lib\ghmGcTask.h"
//#include "..\Lib\ghmGcFile.h"
//#include "..\Lib\ghmGcResLink.h"
#include ".\WK7Script.h"
//#include ".\WK7Obj.h"
//#include ".\WK7Archive.h"
#include ".\WK7Stage.h"
//#include "..\Fujita\C_SetAlpha.h"
//#include "..\Matsu\MK7CharaDisp.h"

class WK7Script;
class C_SetAlpha;
class MK7CharaDisp;

#define	WK7PLAY_TASK_STACK_SIZE			(0x8000)

#define	WK7PLAY_RES_SCRIPT				(0)
#define	WK7PLAY_RES_MODEL				(1)
#define	WK7PLAY_RES_MODELMOTION			(2)
#define	WK7PLAY_RES_MODELSHAPEMOTION	(3)
#define	WK7PLAY_RES_CAMERAMOTION		(4)
#define	WK7PLAY_RES_LIGHTMOTION			(5)
#define	WK7PLAY_RES_JIMAKU				(6)
#define	WK7PLAY_RES_MOTIONLIST			(7)
#define	WK7PLAY_RES_SEPPACKLIST			(8)		// pbNXgiQ̕j
#define	WK7PLAY_RES_CHARANAME			(9)		// lЉpLN^̃f[^

#define	WK7PLAY_RES_RIPSHAPEMOTION		(0x80)

#define	WK7PLAY_RES_ID_SHIFT			(6)

#define	WK7PLAY_RES_BITMASK				(0x8000)

// 
#define	WK7PLAY_TYPE_RES_MODEL(id)				(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_MODEL           <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RES_MODELMOTION(id)		(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_MODELMOTION     <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RES_MODELSHAPEMOTION(id)	(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_MODELSHAPEMOTION<<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RES_CAMERAMOTION(id)		(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_CAMERAMOTION    <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RES_LIGHTMOTION(id)		(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_LIGHTMOTION     <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RES_RIPSHAPEMOTION(id)		(K7OBJTYPE_PLAY|WK7PLAY_RES_BITMASK|(WK7PLAY_RES_RIPSHAPEMOTION  <<WK7PLAY_RES_ID_SHIFT)|id)

#define	WK7PLAY_TYPE_MODEL(id)					(K7OBJTYPE_PLAY|(WK7PLAY_RES_MODEL           <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_MODELMOTION(id)			(K7OBJTYPE_PLAY|(WK7PLAY_RES_MODELMOTION     <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_MODELSHAPEMOTION(id)		(K7OBJTYPE_PLAY|(WK7PLAY_RES_MODELSHAPEMOTION<<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_CAMERAMOTION(id)			(K7OBJTYPE_PLAY|(WK7PLAY_RES_CAMERAMOTION    <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_LIGHTMOTION(id)			(K7OBJTYPE_PLAY|(WK7PLAY_RES_LIGHTMOTION     <<WK7PLAY_RES_ID_SHIFT)|id)
#define	WK7PLAY_TYPE_RIPSHAPEMOTION(id)			(K7OBJTYPE_PLAY|(WK7PLAY_RES_RIPSHAPEMOTION  <<WK7PLAY_RES_ID_SHIFT)|id)

#define	WK7PLAY_PLAYLIGHT_NUM			(8)

struct WK7PlayTable{
	u32			mPlayNo;
	u32			mCinemaScopeColor;
	u32			mPlayChara;
	f32			mBlurDist0,mBlurDist1;
};
#define	WK7PLAYTBL_START()						WK7PlayTable 	playTable[] = {
#define	WK7PLAYTBL_TERM_NO						0xffffffff

#define	WK7PLAYTBL(no,col)								{ 0x##no , (col) , 0xffffffff , -1.0f , -1.0f },
#define	WK7PLAYTBL_CHARA(no,col,chrid)					{ 0x##no , (col) , 1<<(chrid) , -1.0f , -1.0f },
#define	WK7PLAYTBL_CHARAMASK(no,col,chrmask)			{ 0x##no , (col) , (chrmask)  , -1.0f , -1.0f },
#define	WK7PLAYTBL_BLUR(no,col,n,f)						{ 0x##no , (col) , 0xffffffff , (n)   , (f)   },
#define	WK7PLAYTBL_CHARA_BLUR(no,col,chrid,n,f)			{ 0x##no , (col) , 1<<(chrid) , (n)   , (f)   },
#define	WK7PLAYTBL_CHARAMASK_BLUR(no,col,chrmask,n,f)	{ 0x##no , (col) , (chrmask)  , (n)   , (f)   },
#define	WK7PLAYTBL_BLUROFF(no,col)						{ 0x##no , (col) , 0xffffffff , -1.0f ,  0.0f },
#define	WK7PLAYTBL_CHARA_BLUROFF(no,col,chrid)			{ 0x##no , (col) , 1<<(chrid) , -1.0f ,  0.0f },
#define	WK7PLAYTBL_CHARAMASK_BLUROFF(no,col,chrmask)	{ 0x##no , (col) , (chrmask)  , -1.0f ,  0.0f },

#define	WK7PLAYTBL_TERM							{ WK7PLAYTBL_TERM_NO , 0xffffffff , 0xffffffff },
#define	WK7PLAYTBL_END()						WK7PLAYTBL_TERM };

#define	WK7PLAYTBL_MAX							(128)
#define	WK7PLAYTBL_WORKSIZE						((WK7PLAYTBL_MAX + 32 - 1 ) / 32)
#define	WK7PLAYTBL_WORKID(id)					(u32)((id) >> 5)
#define	WK7PLAYTBL_WORKBITID(id)				(u32)((id) & 0x1f)
#define	WK7PLAYTBL_WORKBIT(id)					(u32)(1 << ((id) & 0x1f))
#define	WK7PLAYTBL_SIZE							(WK7PLAYTBL_WORKSIZE * sizeof(u32))

class WK7PlayRenderObj;
class WK7Play;

//
// PlayMotion
//
class WK7PlayMotionBase{
public:
	enum State{
		IDLE = 0,
		LOADING,
		LOADED,
	};
protected:
	WK7Archive							*mpArchive;
	WK7ModelMotion						*mpModelMotion;
	WK7CameraMotion						*mpCameraMotion;
	WK7LightMotion						*mpLightMotion;
	char								*mpFileName;
	State								mState;
	WK7Play								*mpPlay;
	u32									mID;
	bool Initialize(void);
public:
	WK7PlayMotionBase(WK7Play *pPlay);
	virtual ~WK7PlayMotionBase();
	
	bool FrameProcess(void);
	bool SetArchive(void *pArchiveData);
	bool LoadStart(void);
	bool Release(void);
	bool LoadWait(void);
	
	inline void SetID(u32 id){ mID=id; }
	inline u32 GetID(void){ return mID; }
	bool SetFileName(const char *pfname);
	inline const char* GetFileName(void){ return mpFileName; }
	inline WK7ModelMotion* GetModelMotion(void){ return mpModelMotion; }
	inline WK7CameraMotion* GetCameraMotion(void){ return mpCameraMotion; }
	inline WK7LightMotion* GetLightMotion(void){ return mpLightMotion; }
	inline State GetState(void){ return mState; }
};

class WK7PlayMotion : public WK7PlayMotionBase,public ghmGcListObj{
public:
	WK7PlayMotion(WK7Play *pPlay,ghmGcListObj *pAnchor,int prio);
	virtual ~WK7PlayMotion();
	
	inline WK7PlayMotion* GetNext(void){ return (WK7PlayMotion *)ghmGcListObj::GetNext(); }
	inline WK7PlayMotion* GetPrev(void){ return (WK7PlayMotion *)ghmGcListObj::GetPrev(); }
};

#define	WK7PLAYSEPMOTION_IDTYPE				(0x40000000)
#define	WK7PLAYSEPMOTION_IDSHIFT			(4)
#define	WK7PLAYSEPMOTION_MODELCAMERA		(0)
#define	WK7PLAYSEPMOTION_MAT				(1)
#define	WK7PLAYSEPMOTION_SHAPE				(2)
#define	WK7PLAYSEPMOTION_EFFECT				(3)
#define	WK7PLAYSEPMOTION_LIGHT				(4)
//
// PlaySepMotion
//
class WK7PlaySepMotion{
public:
	enum State{
		IDLE = 0,
		LOADING,
		LOADED,
	};
protected:
	WK7PlayMotionBase					mModelCameraMotion;
	WK7PlayMotionBase					mMatMotion;
	WK7PlayMotionBase					mShapeMotion;
	WK7PlayMotionBase					mEffectMotion;
	WK7PlayMotionBase					mLightMotion;
	State								mState;
	WK7Play								*mpPlay;
	char								*mpSepName;
	u32									mID;
public:
	WK7PlaySepMotion(WK7Play *pPlay);
	virtual ~WK7PlaySepMotion();
	
	bool FrameProcess(void);
	bool LoadStart(void);
	bool Release(void);
	bool SetArchive(void *pModelCameraMotionArchiveData,
	                void *pMatMotionArchiveData,
	                void *pShapeMotionArchiveData,
	                void *pEffectMotionArchiveData,
	                void *pLightMotionArchiveData);
	
	bool SetID(u32 id);
	inline u32 GetID(void){ return mID; }
	
	bool SetSepName(const char *pname);
	inline const char* GetSepName(void){ return mpSepName; }
	WK7ModelMotion* GetModelMotion(void);
	WK7CameraMotion* GetCameraMotion(void);
	WK7ModelMotion* GetMatMotion(void);
	WK7ModelMotion* GetShapeMotion(void);
	WK7ModelMotion* GetEffectMotion(void);
	WK7LightMotion* GetLightMotion(void);
	
	inline State GetState(void){ return mState; }
};

#define	WK7PLAYSEPMOTIONPACK_IDSHIFT			(8)
//
// PlaySepMotionPack
//
class WK7PlaySepMotionPack{
public:
	enum State{
		IDLE = 0,
		LOADING,
		LOADED,
	};
protected:
	State								mState;
	WK7Play								*mpPlay;
	char								*mpPackName;
	void								*mpPackData;
	ghmGcResLink						*mpPackResLink;
	ghmGcFile							*mpFile;
	WK7PlaySepMotion					**mppSepMotion;
	u32									mSepMotionNum;
	int									mPlaySepMotion;
	u32									mID;
	bool								mAllocBuffer;
	bool Initialize(void);
public:
	WK7PlaySepMotionPack(WK7Play *pPlay);
	virtual ~WK7PlaySepMotionPack();
	
	bool GetResourceName(char *pResourceName);
	
	bool FrameProcess(void);
	bool LoadStart(void *pBuff=NULL);
	bool Release(void);
	
	bool SetID(u32 id);
	inline u32 GetID(void){ return mID; }
	
	bool IncPlayCount(void);
	inline int GetPlayCount(void){ return mPlaySepMotion; }
	bool SetPackName(const char *pname);
	inline const char* GetPackName(void){ return mpPackName; }
	
	WK7PlaySepMotion* GetSepMotion(int index);
	inline u32 GetSepMotionNum(void){ return mSepMotionNum; }
	WK7PlaySepMotion* GetPlaySepMotion(void);
	WK7PlaySepMotion* GetNextSepMotion(void);
	
	inline State GetState(void){ return mState; }
};

//
// PlayRenderObj
//
class WK7PlayRenderObj : public WK7Stage{
	friend class WK7RenderObj;
protected:
	C_SetAlpha							*mpAlpha;
	WK7PlayMotion						*mpCurrentMotion;
	WK7PlayMotion						*mpCurrentMatMotion;
	WK7PlayMotion						*mpCurrentShapeMotion;
	
	WK7PlayRenderObj();
	WK7PlayRenderObj(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7PlayRenderObj();
	
	virtual bool Initialize(void);
	
	virtual bool DispLight(u32 mirrorType=0,Vec *pPos=NULL);
	
	bool SetAlpha(f32 alpha);
	
	bool PlayMotion(WK7PlayMotion *pMotion,f32 sec=0.0f);
	bool PlayMatMotion(WK7PlayMotion *pMotion);
	bool PlayShapeMotion(WK7PlayMotion *pMotion);
	
	bool StopMotion(void);
	bool StopMatMotion(void);
	bool StopShapeMotion(void);
	
	bool StopMotionAll(void);
};

class WK7PlayLight{
protected:
	WK7Light							*mpLight;
	WK7PlayMotion						*mpCurrentMotion;
public:
	WK7PlayLight();
	~WK7PlayLight();
	
	bool SetLight(WK7Light *pLight);
	inline WK7Light* GetLight(void){ return mpLight; }
	
	bool PlayMotion(WK7PlayMotion *pMotion);
	bool StopMotion(void);
	bool WaitMotion(void);
	bool SetMotionLoop(bool flag);
	
};

struct WK7PlayEffectInfo{
	WK7Model			*mpModel;
	WK7ModelMotion		*mpMotionModelCamera;
	WK7ModelMotion		*mpMotionMat;
	WK7ModelMotion		*mpMotionShape;
	WK7ModelMotion		*mpMotionEffect;
	WK7CameraMotion		*mpMotionCamera;
	WK7LightMotion		*mpMotionLight;
	
	inline void Initialize(void){
		mpModel             = NULL;
		mpMotionModelCamera = NULL;
		mpMotionMat         = NULL;
		mpMotionShape       = NULL;
		mpMotionEffect      = NULL;
		mpMotionCamera      = NULL;
		mpMotionLight       = NULL;
	}
	
};

class WK7Play;
class WK7PlayEffect;
class WK7PlayEffectInstance : public ghmGcListObj{
protected:
	WK7PlayEffect		*mpContainer;
public:
	WK7PlayEffectInstance(WK7PlayEffect *pContainer,ghmGcListObj *pAnchor,WK7JObj */*pJObj*/) : ghmGcListObj(pAnchor){
		mpContainer = pContainer;
	}
	virtual ~WK7PlayEffectInstance(){}
	inline WK7PlayEffectInstance* GetNext(void){ return (WK7PlayEffectInstance *)ghmGcListObj::GetNext(); }
	inline WK7PlayEffectInstance* GetPrev(void){ return (WK7PlayEffectInstance *)ghmGcListObj::GetPrev(); }
	
	WK7Play* GetPlay(void);
	inline WK7PlayEffect* GetContainer(void){ return mpContainer; }
	
	bool DispCharaName(s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool HideCharaName(void);
	bool StopProcess(void);
	bool RestartProcess(void);
	
	virtual bool FrameProcess(bool /*stopReq*/){ return false; }
	virtual bool RenderProcess(void){ return false; }
};

class WK7PlayEffect : public ghmGcListObj{
	friend class WK7Play;
protected:
	WK7Play				*mpContainer;
	u32					mID;
	WK7JObj				*mpJObj;
	bool				mTrigger;
	ghmGcListObj		mInstanceAnchor;
	
	WK7PlayEffectInfo* GetEffectInfo(void);
	bool FreeEffectAll(void);
public:
	WK7PlayEffect(WK7Play *pPlay,ghmGcListObj *pAnchor,WK7JObj *pJObj);
	virtual ~WK7PlayEffect();
	inline WK7PlayEffect* GetNext(void){ return (WK7PlayEffect *)ghmGcListObj::GetNext(); }
	inline WK7PlayEffect* GetPrev(void){ return (WK7PlayEffect *)ghmGcListObj::GetPrev(); }
	
	inline WK7Play* GetContainer(void){ return mpContainer; }
	bool DispCharaName(s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool HideCharaName(void);
	bool StopProcess(void);
	bool RestartProcess(void);
	
	static u32 GetEffectID(WK7JObj *pJObj);
	static u32 GetEffectID(const char *pName);
	
	virtual bool CheckSetup(void);
	virtual bool FrameProcess(void);
	virtual bool RenderProcess(void);
	virtual WK7PlayEffectInstance* CreateInstance(WK7JObj *pJObj);
};

class WK7PlayCharaName : public ghmGcListObj{
protected:
	MK7CharaDisp		*mpCharaDisp;
	bool				mReleaseRequest;
public:
	WK7PlayCharaName(ghmGcListObj *pAnchor);
	virtual ~WK7PlayCharaName();
	
	inline WK7PlayCharaName* GetNext(void){ return (WK7PlayCharaName *)ghmGcListObj::GetNext(); }
	inline WK7PlayCharaName* GetPrev(void){ return (WK7PlayCharaName *)ghmGcListObj::GetPrev(); }
	
	bool Disp(s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool Hide(void);
	bool FrameProcess(void);
	bool Release(void){ Hide(); mReleaseRequest=true; return true; }
};

//
// Play
//
#define	WK7PLAY_RESOURCE_NAME_MAX				(256)
#define	WK7PLAY_STORE_SCENEBLUR_NUM				(4)
class WK7Play : public ghmGcListObj{
public:
	enum State{
		IDLE = 0,
		LOADING,
		PREPARERESOURCE,
		SSMLOADING,
		LOADED,
		PREPARE,
		PREPARING,
		PREPARED,
		PLAY,
		PLAYED,
		RELEASE,
	};
protected:
	static ghmGcListObj			mAnchor;
	static ghmGcTaskController	mTaskController;
	static WK7Play				*mpCurrentPlay;
	static u32					mPlayedFlag[WK7PLAYTBL_WORKSIZE];
	static bool					mPlayTBStored;
	static bool					mCamWobble;
	static s16					mStoredBgmID;
	static bool					mPlayerRelease;
	static bool					mStoredSceneBlurVisible;
	static f32					mStoredSceneBlurDist[WK7PLAY_STORE_SCENEBLUR_NUM];
	static bool					mTermCaptureRenderOn;
	static bool					mTermCaptureRenderMono;
	static bool					mTermCapturePreRender;
	static bool					mInitCaptureRenderOff;
	static bool					mSkipCancel;
	static bool					mDontStopStream;
	static bool					mDontReleasePlayerSsm;
	static bool					mHopper7Mode;
	
	union{
		struct{
			u32					mResAlloc             : 1;	// \[Xm
			u32					mCamStartPosSet       : 1;	// JJnʒuݒ
			u32					mCamStartTargetPosSet : 1;	// J^[QbgJnʒuݒ
			u32					mCamStartFovSet       : 1;	// JJnpݒ
			u32					mCamEndFovSet         : 1;	// JIpݒ
			u32					mSepPlayEnd           : 1;	// ĐI
			u32					mPrepareStream        : 1;	// Xg[
			u32					mTermRequest          : 1;	// Iv
			u32					mTermDisable          : 1;	// I֎~
			u32					mPrepareRequest       : 1;	// v
			u32					mStartRequest         : 1;	// Jnv
			u32					mInitialized          : 1;	// ς
			u32					mPlayCountFlag        : 1;
			u32					mFirstPlay            : 1;
			u32					mReleasePause         : 1;
			u32					mReleaseRequest       : 1;
			u32					mHopper7              : 1;
			u32					mFlagPad              :15;
		};
		u32						mFlag;
	};
	u32							mKeepPlayerSsm;
	u32							mPlayID;					// Lhc
	int							mPlayCount;
	int							mPlayFrame;
	u32							mPlayNo;
	
	State						mState;						// 
	ghmGcFile					*mpFile;					// \[Xǂݍݗp
	void						*mpData;					// ǂݍ݃f[^
	ghmGcResLink				*mpResLink;					// \[X
	int							mTaskID;					// XNvg^XN
	WK7Script					*mpScript;					// XNvgNX
	
	WK7PlayRenderObj			**mppModel;					// f
	u32							mModelNum;					// f
	WK7ModelMotion				**mppModelMotion;			// f[V
	u32							mModelMotionNum;			// f[V
	WK7ModelMotion				**mppModelShapeMotion;		// fVFCv[V
	u32							mModelShapeMotionNum;		// fVFCv[V
	WK7CameraMotion				**mppCameraMotion;			// J[V
	u32							mCameraMotionNum;			// J[V
	WK7LightMotion				**mppLightMotion;			// Cg[V
	u32							mLightMotionNum;			// Cg[V
	WK7ModelMotion				**mppRipShapeMotion;		// bvVFCv[V
	u32							mRipShapeMotionNum;			// bvVFCv[V
	
	Vec							mCamStartPosition;			// JԈړJnʒu
	Vec							mCamEndPosition;			// JԈړIʒu
	Vec							mCamStartTargetPosition;	// J^[QbgԈړJnʒu
	Vec							mCamEndTargetPosition;		// J^[QbgԈړIʒu
	f32							mCamStartFov;				// JԈړJnp
	f32							mCamEndFov;					// JԈړIp
	
	WK7PlayLight				mPlayLights[WK7PLAY_PLAYLIGHT_NUM];
															// [VĐCg
	
	void						*mpJimakuData;				// f[^
	void						*mpTelopData;				// ebvf[^
	
	char						mResourceName[WK7PLAY_RESOURCE_NAME_MAX];
	char						mResourceDir [WK7PLAY_RESOURCE_NAME_MAX];
	
	ghmGcListObj				mMotionAnchor;
	WK7PlayMotion				*mpNextPlayMotion;
	WK7PlayMotion				*mpNextLoadMotion;
	int							mLoadRequestMotionNum;
	WK7PlayMotion				*mpCurrentCameraMotion;
	
	ghmGcListObj				mPlayEffectAnchor;
	
	WK7PlaySepMotionPack		**mppSepMotionPack;
	u32							mSepMotionPackNum;
	int							mPlaySepMotionPack;
	void						*mpSepMotionPackBuffer[2];
	
	u32							mCinemaScopeColor;
	
	WK7PlayEffectInfo			mEffectInfo;
	float						mPrepareSec;
	
	void						*mpCharaNameData;				// LN^̃f[^
	ghmGcListObj				mCharaNameAnchor;
	
	u32							mSsmCharaNo;
	
	EFFECT						*mpPlayEffect;
	u32							mPlayEffectID;
	
	bool GetSsmName(char *pfname);
	bool ReadSsm(void);
	bool ReleaseSsm(void);
	bool ReleasePlayerSsm(void);
	bool RestorePlayerSsm(void);
	
	bool SetPause(void);
	bool ReleasePause(void);
	
	bool SetupProcess(void);
	bool FrameProcessCharaName(void);
	
	bool _ScriptObjectCallMethod(WK7Script *pScript,u16 methodID,u16 objID);
	bool InitScript(void);
	bool InitResource(void *pData);
	bool PrepareResource(void);
	bool IsLoadedResource(void);
	bool InitializeShadowLight(void);
	bool TermResource(void);
	bool GetDirName(const char *pfname,char *pReturnDirName);
	bool GetFileName(const char *pfname,char *pReturnFileName,bool hopper7);
	u32 GetUniquePlayID(void);
	
	bool PlayMotionProcess(void);
	bool SepMotionPackProcess(void);
	int PlaySepMotionPack(void);
	bool PrepareStream(void);
	
	bool PrepareNextSepMotionPack(void);
	bool IsPreparedNextSepMotionPack(void);
	
	bool InitCastShadowPlayRenderObj(WK7PlayRenderObj *pObj,const char *pObjName);
	bool InitCastShadowPlayRenderObj(WK7PlayRenderObj *pObj,const char **ppObjList);
	bool InitReceiveShadowPlayRenderObj(WK7PlayRenderObj *pObj,const char *pObjName);
	bool InitReceiveShadowPlayRenderObj(WK7PlayRenderObj *pObj,const char **ppObjList);
	bool InitShadowPlayRenderObj(WK7PlayRenderObj *pObj);
	
	bool InitializePlayEffect(void);
	bool FrameProcessPlayEffect(void);
	bool RenderProcessPlayEffect(void);
	bool TerminatePlayEffect(void);
	
	bool RetSys(void);
	
	WK7PlayEffect* CreatePlayEffect(WK7JObj *pJObj);
	bool SetDefaultPlayNo(void);
	
	WK7Play();
public:
	virtual ~WK7Play();
	
	bool DispCharaName(s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool HideCharaName(void);
	bool ClearCharaName(void);
	bool StopProcess(void);
	bool RestartProcess(void);
	
	bool ReleaseRequest(void);
	
	inline static void SetHopper7Mode(bool flag){ mHopper7Mode=flag; }
	inline static bool GetHopper7Mode(void){ return mHopper7Mode; }
	inline static void SetTermCaptureRenderOn(bool flag){ mTermCaptureRenderOn=flag; }
	inline static bool GetTermCaptureRenderOn(void){ return mTermCaptureRenderOn; }
	inline static void SetTermCaptureRenderMono(bool flag){ mTermCaptureRenderMono=flag; }
	inline static bool GetTermCaptureRenderMono(void){ return mTermCaptureRenderMono; }
	inline static void SetTermCapturePreRender(bool flag){ mTermCapturePreRender=flag; }
	inline static bool GetTermCapturePreRender(void){ return mTermCapturePreRender; }
	inline static void SetInitCaptureRenderOff(bool flag){ mInitCaptureRenderOff=flag; }
	inline static bool GetInitCaptureRenderOff(void){ return mInitCaptureRenderOff; }
	inline static void SetSkipCancel(bool flag){ mSkipCancel=flag; }
	inline static bool GetSkipCancel(void){ return mSkipCancel; }
	inline static void SetDontStopStream(bool flag){ mDontStopStream=flag; }
	inline static bool GetDontStopStream(void){ return mDontStopStream; }
	inline static void SetDontReleasePlayerSsm(bool flag){ mDontReleasePlayerSsm=flag; }
	inline static bool GetDontReleasePlayerSsm(void){ return mDontReleasePlayerSsm; }
	
	static void ClearCaptureRenderProc(void);
	
	static bool PlayInit(bool player=true,bool release=true);
	static bool LoadWait(u32 no);
	static bool Prepare(u32 no);
	static bool PrepareWait(u32 no,bool release=true);
	static bool Start(u32 no,bool release=true);
	static bool PlayWait(u32 no);
	static bool StartB(u32 no,bool release=true);
	static bool Release(u32 no);
	static bool PlayReleaseAll(void);
	static bool PlayTerm(bool release=true);
	static WK7Play* Find(u32 no);
	inline static WK7Play* GetTop(void){ return (WK7Play *)mAnchor.GetNext(); }
	static bool IsPlaying(void);
	
	inline void SetPlayNo(u32 no){ mPlayNo=no; }
	inline u32 GetPlayNo(void){ return mPlayNo; }
	
	inline void SetCinemaScopeColor(u32 color){ mCinemaScopeColor=color; }
	inline u32 GetCinemaScopeColor(void){ return mCinemaScopeColor; }
	
	bool SetVisibleAll(bool flag);
	bool StopMotionAll(void);
	
	static int GetTableIndex(u32 no);
	static WK7PlayTable* GetTable(u32 no);
	static WK7PlayTable* GetTableTop(void);
	static bool SetPlayed(u32 no,bool flag);
	static bool HasPlayed(u32 no);
	inline static bool GetPlayed(u32 no){ return HasPlayed(no); }
	static u32* GetPlaydFlagTop(void){ return mPlayedFlag; }
	
	bool GetFileName(char *pReturnFileName,bool dir);
	
	inline WK7Play* GetPrev(void){ return (WK7Play *)ghmGcListObj::GetPrev(); }
	inline WK7Play* GetNext(void){ return (WK7Play *)ghmGcListObj::GetNext(); }
	
	inline static WK7Play* GetCurrentPlay(void){ return mpCurrentPlay; }
	inline WK7PlayEffectInfo* GetEffectInfo(void){ return &mEffectInfo; }
	
	inline u32 GetPlayID(void){ return mPlayID; }
	inline int GetPlayCount(void){ return mPlayCount; }
	inline bool GetPlayCountFlag(void){ return mPlayCountFlag? true : false; }
	inline int GetPlayFrame(void){ return mPlayFrame; }
	
	static u32 GetCurrentPlayID(void);
	
	WK7PlaySepMotionPack* GetSepMotionPack(int index);
	WK7PlaySepMotionPack* GetPlaySepMotionPack(void);
	WK7PlaySepMotionPack* GetNextSepMotionPack(void);
	
	WK7PlayMotion* GetNextPlayMotion(void);
	int GetPlayMotionNum(void);
	int GetIdlePlayMotionNum(void);
	
	bool Release(void);
	bool Prepare(void);
	bool Start(void);
	inline void SetState(State state){ mState = state; }
	inline State GetState(void){ return mState; }
	
	inline bool Stop(void){ if( mTermDisable ){ return false; } mTermRequest=1; mDontStopStream=false; return true; }
	
	inline void SetTermDisable(bool flag){ mTermDisable=(flag==true? 1:0); }
	inline bool GetTermDisable(void){ return mTermDisable? true : false; }
	
	bool SetStopScript(bool flag);
	bool GetStopScript(void);
	
	bool Load(const char *pfname);
	bool LoadB(const char *pfname);
	bool Load(void *pResource,const char *pResourceName=NULL);
	
	// t[
	bool FrameProcess(void);
	bool RenderProcess(void);
	
	static bool Initialize(void);
	static bool ReleaseAll(void);
	static bool FrameProcessAll(void);
	static bool RenderProcessAll(void);
	static bool Terminate(void);
	
	static bool ScriptObjectCallMethod(WK7Script *pScript,u16 methodID,u16 objID);
	
	bool ScriptParse(void);
	bool ScriptTerm(void);
	static void ScriptParseHandler(ghmGcTask *pTask);
	static void ScriptParseHandlerTerm(ghmGcTask *pTask);
	
	WK7PlayRenderObj* GetRenderObj(int index);
	WK7PlayRenderObj* GetRenderObjByCharaID(u32 chrid);
	WK7Model* GetModel(int index);
	WK7ModelMotion* GetModelMotion(int index);
	WK7ModelMotion* GetModelShapeMotion(int index);
	WK7CameraMotion* GetCameraMotion(int index);
	WK7LightMotion* GetLightMotion(int index);
	WK7ModelMotion* GetRipShapeMotion(int index);
	
	static WK7Play* Create(u32 no);
	static WK7Play* Create(const char *pfname);
	static WK7Play* CreateB(const char *pfname);
	static WK7Play* Create(void *pResource,const char *pResourceName=NULL);
	static bool PlayTB(u32 evno,bool render=true);
	static bool PlayTB(const char *pfname,bool render=true);
	static bool StorePlayTB(bool render=true);
	static bool RestorePlayTB(bool render=true);
	
	inline const char* GetResourceName(void){ return mResourceName; }
	inline const char* GetResourceDir(void){ return mResourceDir; }
	
	static bool SetExceptPlayRenderObj(bool flag);
	
	// IuWFNg\bh`ohQ
	
	int ModelSetVisible				(int,int);
	int ModelPlayMotion				(int,int);
	int ModelPlayMotionI			(int,int,f32);
	int ModelPlayShapeMotion		(int,int);
	int ModelStopMotion				(int);
	int ModelStopShapeMotion		(int);
	int ModelStopMotionAll			(int);
	int ModelWaitMotion				(int);
	int ModelWaitShapeMotion		(int);
	int ModelWaitMotionAll			(int);
	int ModelSetMotionLoop			(int,int);
	int CameraPlayMotion			(int);
	int CameraPlayMotionI			(int,f32);
	int CameraStopMotion			(void);
	int CameraWaitMotion			(void);
	int CameraSetMotionLoop			(int);
	int LightPlayMotion				(int,int);
	int LightStopMotion				(int);
	int LightWaitMotion				(int);
	int LightSetMotionLoop			(int,int);
	int JimakuDisp					(int);
	int JimakuWait					(void);
	int SePlay						(int);
	int StreamPlay					(int);
	int StreamStop					(void);
	int StreamWait					(int);
	int ModelCreateShadow			(int);
	int ModelSetShadowVisible		(int,int);
	int FadeWait					(void);
	int SeStop						(int);
	int ModelSetLight				(int,int,int);
	int CameraSetStartPosition		(f32,f32,f32);
	int CameraSetEndPosition		(f32,f32,f32);
	int CameraSetStartTargetPosition(f32,f32,f32);
	int CameraSetEndTargetPosition	(f32,f32,f32);
	int CameraLinearIpLinearPath	(f32);
	int CameraDelayIpLinearPath		(f32);
	int CameraLinearIpCirclePath	(f32);
	int CameraSetPosition			(f32,f32,f32);
	int CameraSetTargetPosition		(f32,f32,f32);
	int CameraSetFov				(f32);
	int CameraSetStartFov			(f32);
	int CameraSetEndFov				(f32);
	int StreamFadeVolume			(int,f32);
	int CameraSetNear				(f32);
	int CameraSetFar				(f32);
	int CameraStopIp				(void);
	int CreateExplodeEffect			(f32,f32,f32,f32);
	int SetMuzzleEffect				(int,int,int,int,int);
	int CreateMuzzleEffect			(int,f32);
	int ResetMuzzleEffect			(int);
	int CreateHSExplodeEffect		(f32,f32,f32);
	int ModelSetVfxEffect			(int);
	int ModelResetVfxEffect			(int);
	int ModelSetAlpha				(int,f32);
	int CreateGoreEffect			(f32,f32,f32,f32);
	int CreateFlashEffect			(int,int,int,int,f32,f32);
	
	int ModelPlaySeqMotion			(int);
	int ModelPlaySeqMotionI			(int,f32);
	int ModelPlaySeqMatMotion		(int);
	int ModelPlaySeqShapeMotion		(int);
	int ModelStopSeqMotion			(int);
	int ModelStopSeqMatMotion		(int);
	int ModelStopSeqShapeMotion		(int);
	int ModelStopSeqMotionAll		(int);
	int CameraPlaySeqMotion			(void);
	int CameraPlaySeqMotionI		(f32);
	int CameraStopSeqMotion			(void);
	int LightPlaySeqMotion			(int);
	int LightStopSeqMotion			(int);
	
};

#endif	//__WK7PLAY_H__

