
////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Player Object
//
// WK7Player.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/15/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7PLAYER_H__
#define	__WK7PLAYER_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
#include "..\Yam\YK7EffectHeader.h"
#include ".\WK7Path.h"
//#include ".\WK7Chara.h"
//#include ".\WK7Motion.h"
//#include ".\WK7Npc.h"
//#include ".\WK7Light.h"
//#include "..\Matsu\se\seBattle.h"
//#include "..\Fujita\C_setalpha.h"
//#include "..\Sato\SK7Death.h"
#include ".\Blood.h"
#include ".\WK7Stage.h"
#include ".\Matsu\Se\sePcMsk.h"

class WK7Chara;
class WK7CharaMotion;
class WK7Npc;
class WK7Light;
class C_SetAlpha;

#define	WK7PLAYER_INTERPOLATE_FRAME		(8.0f)

struct WK7PlayerControlPlayMotionInfo{
	u32		mID;
	u32		mCommonID;
	bool	mLoop;
	bool	mHokan;
	f32		mStartFrame;
	f32		mSpeed;
	u32		mParam;
	f32		mIpFrame;
	WK7PlayerControlPlayMotionInfo(){
		mID         = 0xffffffff;
		mCommonID   = 0xffffffff;
		mLoop       = false;
		mHokan      = false;
		mStartFrame = 0.0f;
		mSpeed      = 1.0f;
		mParam      = 0;
		mIpFrame    = 0.0f;
	}
};
typedef	bool WK7PlayerControlPlayMotionCallBack(WK7PlayerControlPlayMotionInfo *pInfo);

// XyVA^bÑQ[W̃}bNXl
//#define PC_SPATK_GAUGE_MAX					(PC_BLOODPOINT_SPATK)

// G߂̍GX^bN
#define MAX_SORT_NPC		(2)

// XLĎs܂ł̎
#define SCAN_RELOAD_TIME					(WK7_SEC_TO_FRAME(0.5f))

// XCb`obt@[ɃZ[uĂL[f[^
#define SW_SAVE								(64)

// ^Cv
#define FOOT_TYPE0	(0)			// 
#define FOOT_TYPE1	(1)			// ~~
#define FOOT_TYPE2	(2)			// 

// `[WVbg̋K萔
#define CHARGESETUP_DAN_MADAN			(3)			// e
#define CHARGESETUP_KVN_TWINTHROW		(1)			// 蓊
#define CHARGESETUP_KVN_CHAINTHROW		(3)			// 
#define CHARGESETUP_MSK_THUNDERCANNON	(1)			// d
#define CHARGESETUP_MSK_GRAVICANNON		(2)			// k
#define CHARGESETUP_MSK_LAUNCHER		(5)			// `[
#define CHARGESETUP_CYO_MAGNUM			(1)			// }Oie

// ~TCő剽ł邩H
#define MISSILE_MAX						(8)	

#if FUJITA
//JɃvC[fB
#define BATTLE_CAM_ATTACH 1
#endif

// obLXe[^X
// ob̃Xe[^Xp
enum WK7PcControlState{
	PC_STATE_INIT = 0,		// l
	PC_STATE_WAIT,			// R
	PC_STATE_TURN,			// ^[
	PC_STATE_RUN,			// 
	PC_STATE_WALK,			// 
	PC_STATE_SHOTPOSE,		// ˌ\
	PC_STATE_SHOTFREE,		// ˌR
	PC_STATE_SHOTNOW,		// ˌ
	PC_STATE_SHOTWAIT,		// ˌEGCg
	PC_STATE_RELOAD,		// [h
	PC_STATE_DOWNATK,		// _EU
	PC_STATE_SPATK,			// XyVA^bNiJn[Vj
	PC_STATE_SPATKNOW,		// XyVA^bNisגj
	PC_STATE_SPATKWAIT,		// XyVA^bNiEGCgj
	PC_STATE_DMG,			// ꒆ
	PC_STATE_DIE,			// ꎀS
	PC_STATE_LOSS,			// ꎀSAI
	PC_STATE_GALEVENT,		// KV[Cxg
	PC_STATE_KERENMI_ATK,	// ݍU
	PC_STATE_CHARGEALL_ATK,	// S͈͍U
	PC_STATE_TAMEUCHI,		// ^E`iXyVA^bNj
};

// ob̈ړ[h
enum WK7PcMovePosMode{
	PC_POSMODE_PROG,
	PC_POSMODE_DATA,
};

// 
enum WK7PcSpAbility{
	PC_SPA_BLOOD_FESTIVAL,					// _ߌ
	
	PC_SPA_BLOODY_SHOWER,					// JGfEt
	PC_SPA_CLOAKING,						// PB
	PC_SPA_BOOST_JUMP,						// R[eWv
	PC_SPA_BOOST_RUN,						// Lbg͂⑖
	
	PC_SPA_PICKING_TOOL,					// R[eJ
//	PC_SPA_SONIC_SIGHT,						// CAT	sonic sight
//	PC_SPA_WIND_MANIPULATION,				// CAT	wind manipulation
	PC_SPA_SUPER_STRENGTH,					// MSK	super strength
	
//	PC_SPAI_IGNITION_FIRE,					// DAN ignition fire
//	PC_SPAI_SUCK_BLOOD,						// KED suck blood
//	PC_SPAI_SYSTEM_HACK,					// KVN system hack
//	PC_SPAI_PICKING_TOOL,					// CYO picking tool
//	PC_SPAI_MAGIC_MIRROR,					// CAT magic mirror
//	PC_SPAI_MAGIC_WALLET,					// MSK magic wallet
	
	PC_SPA_OPEN_SPIRIT_GUIDE = PC_SPA_BLOODY_SHOWER,
	
	PC_SPA_TERM = 0x7fffffff,				// I[
};
#define	WK7PCSPABILITY_TABLE(charaid)		charaid##SpAbility
#define	WK7PCSPABILITY_START(charaid)		WK7PcSpAbility	charaid##SpAbility[] = {
#define	WK7PCSPABILITY(abilityid)				abilityid,
#define	WK7PCSPABILITY_END()				PC_SPA_TERM };

// ob̃Q[I[o[[h
enum WK7PcGameOverMode{
	PC_GAMEOVER_DEFAULT,					// ʏ펀S
	PC_GAMEOVER_ONLY,						// NłȂQ[I[o[
	PC_GAMEOVER_HNGBATTLE,					// ݂蒷p
	PC_GAMEOVER_KISBATTLE,					// LXMp
};


typedef struct _PCDATA{
	s16			mHp;						// qbg|Cg
//	s16			mMaxHp;						// qbg|Cgől
	s16			mGunBallet;					// eiЎej
//	s16			mGunDamage;					// e{_[W
//	f32			mGunWeakSize;				// eŎ_łTCYi傫قǎ_qbg₷j
	s16			mGunTypeR;					// K^Cvq
	s16			mGunTypeL;					// K^Cvk
	s16			mGunStyle;					// KX^Ci0:1 1:2)
	s16			mGunTiming1;				// e˃^C~ÔP
	s16			mGunTiming2;				// e˃^C~ÔQ
//	s16			mCombo;						// R{^C~Õt[
	f32			mMinFov;					// Y[ʂł̊g嗦iɂ͒ڍŏFovlj
	f32			mBure;						// ˌ̃u
	f32			mRunSpeed;					// ړXs[h
//	f32			mRunRate;					// ړ̊
	int			mSeShot;					// se:ˌ
	int			mSeShotPose;				// se:\
	u8			mBloodTexNum;				// ̃GtFNgԍ YK7EffectBlood.h uԂ̎ށv
}PCDATA;


typedef struct _PCDAMAGE{
//	WK7Chara	*mpDamChara;				// _[W^l
//	WK7JObj 	*mpObj;						// _[W֐

///	s16			reaction;
///	s16			se;
	
	Vec			mDamDir;					// _[W
	Vec			mDamPos;					// _[WƂ̃|WVi[hj
	
	s16			mDamPoint;					// _[Wl
	s16			mDamType;					// _[W 0: 1: 2:uLXMȂǁv
	
	s16			mDamHitRequest;				// _[W炢܂\tO
	int			mDamSeId;					// _[W̐prd
	s16			mDamSeTiming;				// _[W̃^C~O
}PCDAMAGE;

typedef struct _PCSPATTACK{					// XyVA^bN
//	s16			mGauge;						// XyVA^bNQ[W
	s16			mRun;						// XyVA^bNsǂH
	s16			mProcess;					// XyVA^bNvZXtO
}PCSPATTACK;

typedef struct _PCCHARGE{						// `[WVbg
	u8							mSetUp;			// ZbgAbviꂪ܂Ɣ\j
	u8							mSetUpUse;		// ZbgAbvgp
	f32							mRate;			// `[Ŵߋ
	f32							mRateBack;		// `[Ŵߋi_[WZbgpj
	u8							mProcess;		// `[W֘ÃvZX
	int							mPlaySE;		// `[Wrd
	s16							mHitTiming;		// `[WVbg̃qbg̃^C~OJEgp
}PCCHARGE;

class PCCHKPPOINT{				// LN^`FbN|Cgݒp
public:
	u32			stgID;						// Xe[Whc
	char		*pPathName;					//
	f32			pathParam;
	u32			pathDir;
	u32			prevStgID;					// OXe[Whc
	char		*pPrevBpName;				// O_
	u32			prevParam;
	PCCHKPPOINT(){
		stgID       = K7STGID_INVALID;
		pPathName   = NULL;
		pathParam   = 0.0f;
		pathDir     = 0;
		prevStgID   = K7STGID_INVALID;
		pPrevBpName = NULL;
		prevParam   = 0;
	}
	~PCCHKPPOINT(){
		GHM_SAFE_DELETE_ARRAY(pPathName);
		GHM_SAFE_DELETE_ARRAY(pPrevBpName);
	}
	void SetPathName(const char *pName){
		GHM_SAFE_DELETE_ARRAY(pPathName);
		if( pName==NULL ){
			return;
		}
		ghmGcMemSetAllocName("PathName");
		pPathName = new char[strlen(pName)+1];
		strcpy(pPathName,pName);
	}
	inline const char* GetPathName(void){ return pPathName; }
	void SetPrevBpName(const char *pName){
		GHM_SAFE_DELETE_ARRAY(pPrevBpName);
		if( pName==NULL ){
			return;
		}
		ghmGcMemSetAllocName("PrBpName");
		pPrevBpName = new char[strlen(pName)+1];
		strcpy(pPrevBpName,pName);
	}
	inline const char* GetPrevBpName(void){ return pPrevBpName; }
	void Reset(void){
		stgID       = K7STGID_INVALID;
		pathParam   = 0.0f;
		pathDir     = 0;
		prevStgID   = K7STGID_INVALID;
		prevParam   = 0;
		SetPathName(NULL);
		SetPrevBpName(NULL);
	}
};

// P[V̊Ǘe[uobpiꂪ[VɊmۂj
class WK7PcMotion : public ghmGcListObj{
protected:
	WK7CharaMotion			*mpMotion;				// [V
	u32						mMotionID;				// [Vhc
	
	WK7PcMotion();
public:
	WK7PcMotion(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	virtual ~WK7PcMotion();
	
	inline WK7PcMotion* GetPrev(void){ return (WK7PcMotion *)ghmGcListObj::GetPrev(); }
	inline WK7PcMotion* GetNext(void){ return (WK7PcMotion *)ghmGcListObj::GetNext(); }
	
	inline u32 GetID(void){ return mMotionID; }
	
	bool CreateMotion(u32 motid);
	bool ReleaseMotion(void);
	inline WK7CharaMotion* GetMotion(void){ return mpMotion; }
	
	bool IsLoading(void);
};


// XyVA^bNp
typedef struct _SPATKCTRL{
	u32		mSaveMainID;
	u32		mSaveStageID;
	EFFECT	*mpLineEffect;
	EFFECT	*mpSkillExeEffectMSK;
	EFFECT	*mpFireMSK;
	
	int		mFrame;
	int		mTask;
}SPATKCTRL;

struct WK7PlayerSpInfoKed{
	// JGf\͗p
	WK7JObj					*mpTargetJObj;
	Vec						mKedPos;
	f32						mKedRotY;
	Vec						mZanPos;
	f32						mZanRotY;
	bool					mStageMessage;
	u32						mStageMessageID;
	int						mDir;					// :0 , E:1
};

struct WK7PlayerSpInfoCyo{
	// R[e\͗p
	const char				*mpToBpName;
	const char				*mpFromBpName;
	Vec						mFromPos;
	f32						mFromRotY;
	Vec						mToPos;
	f32						mToRotY;
	bool					mStageMessage;
	u32						mStageMessageID;
	bool					mLandingSE;
	int						mLandingSEID;
};

enum{
	// JGfE
	SPKED_IDLE = 0,
	SPKED_ZANLOAD,
	SPKED_ZANLOADED,
	SPKED_MOTSTART,
	SPKED_EFCHANGE,
	SPKED_BLOODSTART = SPKED_EFCHANGE,
	SPKED_ZANAPPEAR,
	SPKED_BLOODSTOPREQ,
	SPKED_MOTEND,
	SPKED_ZANDISAPPEAR,
	SPKED_BAAN,
	SPKED_BREAKOBJ,
	SPKED_BROKEOBJ,
	SPKED_MESSTART,
	SPKED_TERM,
	
	// JGftz
	SPKED2_IDLE = 0,
	SPKED2_ZANLOAD,
	SPKED2_ZANLOADED,
	SPKED2_MOTSTART,
	SPKED2_ZANAPPEAR,
	SPKED2_EFCHANGE,
	SPKED2_KUIKUI,
	SPKED2_BLOODSTART,
	SPKED2_MOTEND,
	SPKED2_ZANDISAPPEAR,
	SPKED2_ZANDISAPPEARED,
	SPKED2_MESSTART,
	SPKED2_TERM,
	
	// R[eWv
	SPCYO_IDLE = 0,
	SPCYO_MOTLOAD,
	SPCYO_MOTLOADED,
	SPCYO_JUMP,
	SPCYO_JUMPWAIT,
	SPCYO_LANDING,
	SPCYO_LANDINGWAIT,
	SPCYO_MESSTART,
	SPCYO_TERM,
	
	// }XNAXyVA^bN\
	SPMSK_IDLE = 0,
	SPMSK_MOTLOAD,
	SPMSK_MOTLOADED,
	SPMSK_MOTPLAY,
	
	// R[eAsbLO
	SPCYOPICK_IDLE = 0,
	SPCYOPICK_MOTLOAD,
	SPCYOPICK_MOTLOADED,
	SPCYOPICK_MOTPLAY,
};

enum WK7CyoPickingMode{
	PICKING_774M02=0,			// ZeBbN404
	PICKING_516M00,			// ze6F
	PICKING_131M00,			// prPF
	PICKING_325M01,			// Vn
	PICKING_136M00,			// prn
	PICKING_IDMAX,
};

struct WK7PlayerSpInfo{
	int							mSpProc;
	u32							mType;
	u32							mWaitFlag;
	union{
		WK7PlayerSpInfoKed		mKedInfo;
		WK7PlayerSpInfoCyo		mCyoInfo;
	};
};

// pbhRg[[h
enum WK7BattlePadReg{
	BPADREG_FREE = 0,
	BPADREG_KAMAE_ONLY,					// \̂
	BPADREG_NO_MANUALRELOAD,			// 蓮[h
	BPADREG_NO_WAIT,					// ҋ@[VłȂ
	BPADREG_KAMAE_NO,					// \֎~
	BPADREG_BOSSBATTLE,					// {X풆
	BPADREG_NODECHP,					// goȂ
	BPADREG_HANSAM,						// nT}
};

typedef	int	K7SETBL[K7PCMAX][2];


// G\[gCgp
typedef struct{
	WK7Npc			*mpSortNpc;
	f32				dist;				// 
}SORTNPCLIGHT;

typedef struct {
	int 	inSEno;
	int 	retSEno;
	u8		volMax;
	u32		charaID;
}LOOP_ENESE;

//
// Player Control
//
class WK7PlayerControl : public WK7PathControlObj{
public:
	enum ReleaseState{
		IDLE = 0,
		LOADED,
		RELEASEARCHIVE,
		RELEASEDARCHIVE,
		RESTOREARCHIVE,
	};
	static u32					SpAtkTaskProcessState;
	static s32					TaskIDSetUp;
	static ghmGcTaskController*	mpTaskFrameCtrl;
protected:
	static WK7PlayerControl		*mpPlayerControlInstance;
	
	u32							mID;					// IuWFNghc K7CHR_MAINID(mID)  Lhc̎擾
	u32							mMainID;				// Chc
	u32							mSuffix;				// TtBbNX
	u32							mPrevID;
	u32							mPrevMainID;
	u32							mPrevSuffix;
	u32							mMotID;					// [Vhc
	u32							mDieID;					// O̎񂾃L̃IuWFNghc
	WK7PcControlState			mState;					// vC[
	WK7PcMovePosMode			mMovePosMode;			// [Vړ̈ړ[h
	u32							mInitProcess;			// Gl~[[vSE
	int							mSeLoopTask;
	
	u32							mBattlePadRegulation;	// og̃pbh̋K
	union{
		struct{
			u32					mFirstPosSet     : 1;		// ʒuݒ
			u32					mEnable          : 1;	// SĂ̏̋
			u32					mOperateEnable   : 1;	// 싖iꂼ̏͂ނL[͂OɂȂ邾j
//			u32					mShotMode        : 1;	// 퓬[h
			u32					mPause           : 1;	// |[Y
			u32					mShotPoseSE      : 1;	// \SE
			u32					mLightEnable     : 1;	// Cg
			u32					mTurnReserve     : 1;	// ^[\
			u32					mNoHokanReq      : 1;	// ̕⊮Ȃ
			u32					mWalkOnly        : 1;	// ̂
			u32					mManualVitalDisp : 1;	// 蓮̗͕\
			u32					mBloodUseDisable : 1;	// tgp֎~
#if FUJITA
			u32					mTurnAble        : 1;	// ^[\B
			u32					mWalkAble        : 1;	// ړ\B
#endif
			u32					mCamRevDisable   : 1;	// J]֎~
			u32					mSpAbilityDisable: 1;	// \͋֎~
			u32					mNoShotWaitSeReq : 1;	// \߂̂rd炷̂߂
			u32					mNoShotTiming    : 1;	// ˌ֎~
			u32					mMuteki          : 1;	// G
			u32					mFlagPad         :14;
		};
		u32						mFlag;					// tO
	};
	WK7PathControl				mPathControl;			// pXRg[
	
	WK7Chara					*mpPcChara;				// CLN^[ilj
	WK7JObj						*mpObjWaistBone;		// IuWFNgij
	WK7JObj						*mpObjHandBone;			// IuWFNginCf j
	WK7JObj						*mpObjHandRSkin;		// IuWFNgiEf Ej
	WK7JObj						*mpObjHandLSkin;		// IuWFNgiEf j
	ghmGcListObj				mMotionAnchor;			// [VAJ[
	WK7Model 					*mpHighGun[2];			// nCf̏e
	
//		u32							mScanGaugeEffectID;
//		EFFECT						*mpScanGauge;			// XLQ[WiRcj
//	EFFECT						*mpFire;					// iRcj
	WK7RenderObjEffect			*mpMuzzleRRenderEffect;		// }Yq
	WK7RenderObjEffect			*mpMuzzleLRenderEffect;		// }Yk
	u8							mRMuzzleTiming;				// ^C~O`FbNp
	u8							mLMuzzleTiming;				// ^C~O`FbNp
	s8							SpAtkBillBoardEffectID;		// \̓GtFNgŎgpr{[hID
	s8							CounterSignalEasyAnimID;	// JE^[UVOiŎgpEasyAnimID
	WK7RenderObjEffect			*mpBloodPackRenderEffect;	// tpbN
	WK7RenderObjEffect			*mpChargeShotRenderEffect;	// ^E`GtFNg
	WK7RenderObjEffect			*mpKvnKnifeBlurRenderEffect;// Pr̃iCt̋O
	WK7RenderObjEffect			*mpTubeRenderEffect;		// Rc Ǖ\p
	WK7RenderObjEffect			*mpChargeallAtkRenderEfc;	// S͈͍UGtFNg
	WK7RenderObjEffect			*mpMagnumRenderEfc;			// R[ẽ`[WVbgi}Oij̃GtFNg
	WK7RenderObjEffect			*mpDamageBloodEfc;			// _[WƂ̌̃GtFNg
	WK7RenderObjEffect			*mpWallHitEfc1;				// Ǘp̒e
	WK7RenderObjEffect			*mpWallHitEfc2;				// Ǘp̒e
	u8							mMissilePtr;				// ~TCˏ
	WK7RenderObjEffect			*mpMissileRenderEfc[MISSILE_MAX];	// S͈͍UGtFNg
	f32							mChargeallAtkDir;			// S͈͍UGtFNg
	
//	EFFECT						*mpChargeTame;				// ^E`߃GtFNg
//	u32							mChargeTameEffectID;		// ^E`߃GtFNg
	WK7RenderObjEffect	 		*mpLastBloodEfc;			// Ō̌̃GtFNgĩGtFNgIAj[j
	
															// G̃\[gɕבւÅmۗp
	bool						mVisible;					// \tO
	bool						mVisibleSave;				// \tOobNAbv
	WK7PcShotMode				mShotRequest;				// ˌItO
	Vec							mShotRequestTgtPos;			// ˌIˌiAlj
	class WK7Npc				*mpShotRequestNpc;			// ˌINPCiAlj
	s16							mShotSightPx;				// ˌIXN[WX
	s16							mShotSightPy;				// ˌIXN[WY
	u32							mShotArgb;					// ˌIGetPeekARGB
	Vec							mShotFireRot;				// ˌIGetPeekARGB
	bool						mShotReturn;				// ˌIAl񂪃Zbgꂽ
	
	s16							mWaitCount;					// 삵Ƃ̋xe
	s16							mFreeAcCount;				// R̂̎̃ANV܂ł̃EGCg
	s16							mScanNextCount;				// XL̃EGCgJEg
	s16							mChargeWaitCount;			// `[WẴEGCg
	s16							mShotComboCount;			// Vbg̖ډp
	s16							mDamageCount;				// _[WEGCgJEg
	s16							mNoStandSpAtkCount;			// XyVA^bNgpłȂƂ̃EGCgJEg
	
	int							mReloadCnt;					// [hJE^[
	f32							mReloadRate;				// [hĐXs[h
	s16							mRunStartCnt;				// ͂߂̃JE^[
	s16							mQuickTurnCnt;				// NCbN^[pJE^[
	s16							mRunbleCnt;					// hpJEg
	s16							mFootSeCnt;					// 炵pJE^[
	s16							mEventEndWait;				// CxgÍA\܂ł̃EGCg
	s16							mKerenmiProcess;			// ݐp
	WK7Npc						*mpKerenmNpc;				// ݑΏۂmob
	s16							mDownAtkProcess;			// _EUp
	WK7Npc						*mpDownAtkNpc;				// _EUΏۂmob
	s16							m2ndQuick;					// ZJho[Xg
	s16							m2ndLockOn;					// ZJhbNI
	u8							mQuickTurnPlaySE;			// NCbN^[SEp̃vZX
	s8							mBoostRun;					// ͂⑖
	
	PCDAMAGE					mDamage;					// _[Wp
	PCDATA						mData;						// ob̃f[^
	s16							mNowBullet;					// ݂̒e
	
	PCSPATTACK					mSpAtk;						// \͗p
	PCCHARGE					mCharge;					// `[WVbg
	
	u32							mBattlePadsw;				// og삩̃Rg[
	u32							mBattlePadtrg;				// og삩̃Rg[gK
	f32							mBattlePadAnalogR;			// og삩̃Rg[qAiO
	f32							mBattlePadAnalogL;			// og삩̃Rg[kAiO
	s8							mBattlePadSubStickX;		// og삩̃Rg[bAiOw
	s8							mBattlePadSubStickY;		// og삩̃Rg[bAiOx
	f32							mKamaeDirRequest;			// og\Œ
	Vec							mKamaePosRequest;			// og\ʒuŒ
	f32							mKamaeDirBk;
	Vec							mKamaePosBk;
	s8							mKamaeProcCall;				// \ԁi퓬ԁjOďo
	
	u32							mSw_pointer;				//@XCb`|C^[
	u32							mSw_buffer[SW_SAVE];		//@XCb`obt@[
	u32							mSenkou;					//@s͔f
	
	
	
	WK7PcMotion					*mpCmnMotion[WK7MOTION_PCCMN_TOTAL_MAX];			// [Ve[u
	
	C_SetAlpha					*mpAlpha;
	f32							mAlpha[2];				// l
	bool						mCameraAlphaControl;	// Jɋ߂ÂƎIɔɂȂtO
	bool						mBattleAutoAlphaCtrl;	// Jɋ߂ÂƎIɔɂȂtO(ogp)
	
	PCCHKPPOINT					mChkPoint;				// `FbN|Cg֐
	PCCHKPPOINT					mKamaeSave;				// \ɓƂɂob̃pX̃Z[u
	Vec							mKamaeSavePos;			// \ɓƂɂob̍W̃Z[u
	
	ReleaseState				mReleaseState;			// A[JCu
	WK7PcControlState			mPrevState;				// vC[ԃobNAbv
	
	bool						mSpAbilityCancel;
	u8							mGameOverMode;			// Q[I[o[(S̏j̃[hݒ
	u32							mGameOverModeCharaID;	// S̃L\ID
	
//	WK7Light					*mpLight;				// DCg
	
	Vec							*mpLookAtPosition;
	WK7AnimLinearF				mTurnNeckRateY,mTurnNeckRateX;
	f32							mOldNeckAngleY,mOldNeckAngleX;
	f32							mCurNeckAngleY,mCurNeckAngleX;
	Vec							mSpine2Dir[3];
	Vec							mSkullDir [3];
	WK7JObj						*mpSpine2JObj;			// ʎ擾p
	WK7JObj						*mpSkullJObj;			// iɂ͓Wj]p
	f32							mLimitNeckAngleY;
	f32							mLimitNeckAngleXP,mLimitNeckAngleXM;
#if FUJITA && BATTLE_CAM_ATTACH
	WK7JObj						*mpRootJObj;			//og̎AJ̎qɂB
	Mtx							mMtxCamOfst;			//J̎qɂƂ̃[h
#endif
	f32							mConpasInc;				// RpXCNgp
	f32							mNearEneDirConpas[2];	// GRpX\p
	u8							mNearEneDirConpasChk;	// GRpX\ptO
	
	WK7PlayerSpInfo				mSpInfo;
	
	u32									mPrePlayMotionCallBackParam;
	WK7PlayerControlPlayMotionCallBack	*mpPrePlayMotionCallBack;
	u32									mPostPlayMotionCallBackParam;
	WK7PlayerControlPlayMotionCallBack	*mpPostPlayMotionCallBack;
	
	f32							mManualVital;
	SORTNPCLIGHT				mSortNpcLight[ONE_AREA_MAXENEMY];			// \[g\Cgp
	
	bool InitProcess(bool initdata=true);
	bool ReleaseProcess(void);
	bool ReleaseArchiveProcess(void);
	bool RestoreArchiveProcess(void);
	bool SetReleaseState(ReleaseState state);
	
//	bool Stop(void);
//	bool Walk(void);
//	bool Run(void);
	bool OperateProcess(void);
	bool IsSetUp(void);
	
	void InitDataSet(void);
	bool CreateModelInit(bool initdata);
	
	void MotPlayInit(u32 /*nextMode*/);
	bool MotSet_Wait(bool hokan);
	bool MotSet_Walk(void);
	bool MotSet_Run(void);
	bool MotSet_Turn(void);
	bool MotSet_QuickTurn(void);
	bool MotStatus_Turn(void);
	
	bool MotSet_ShotPose(void);
	bool MotStatus_ShotPose(void);
	bool MotSet_ShotFree(bool cancel);
	bool MotStatus_ShotFree(void);
	bool MotStatus_ShotNow(void);
	bool MotStatus_ShotWait(void);
	int  MotSet_Dmg(void);
	bool MotStatus_Dmg(void);
	bool MotStatus_Die(void);
	bool MotSet_Reload(void);
	bool MotStatus_Reload(void);
	bool MotSet_DownAtk(void);
	bool MotStatus_DownAtk(void);
	bool MotStatus_SpAtk(void);
	bool MotSet_SpAtkNow(void);
	bool MotStatus_SpAtkNow(void);
	bool MotSet_SpAtkWait(void);
	bool MotStatus_SpAtkWait(void);
	bool MotSet_ReloadFromStand(void);
	bool MotStatus_ReloadFromStand(void);
	bool MotSet_KerenmiAtk(int type=0);
	bool MotStatus_KerenmiAtk(void);
	bool MotSet_Tameuchi(void);
	bool MotStatus_Tameuchi(void);
	bool MotSet_ShotWait(void);
	
	bool DamageTest(void);
	
	bool ScanRun(void);
	bool ShotPoseTest(s16 shotmode);
	bool ShotPoseTestPre(int mode);
	bool ScanTest(void);
	
	void DetachGun(void);
	bool SetVitalFrameProcess(void);
	bool SetBullet(s16 mode);
	
	bool SpGaugeTest(void);
	bool SpAtkCharaEndTest(void);
	bool SpAtkStartTestChara(void);
	bool SpAtkCtrl(void);
	bool StandSpAtkStartStateTest(void);
	bool SpAtkStart(int mode);
	
	bool BattleAlphaCtrl(void);
	bool SetAlpha(f32 alpha);
	
	bool GetDefaultActionKey(void);
	bool ReloadTest(void);
	
	bool RunTest(void);
	bool StairTest(f32 moveRate=1.f);
	
	f32 GetRunStartTransRate(void);
	bool FootSePlay(void);
	
	f32 GetQuickTurnTransRate(void);
	bool MotStatus_QuickTurn(void);
	
	bool SenkouTest(void);
	void SenkouSet(u32 frame);
	void ReadSwitch(void);
	bool CommandCheck(u32 *pCmmandTbl);
	bool PressCheck(u32 frame, u32 button);
	
	bool PushKamaeSave(int mode);
	bool PullKamaeSave(void);
	
	static bool SkullJointPostFrameProcessCallBack(WK7JObj *pJObj,void *pData);
#if FUJITA && BATTLE_CAM_ATTACH
	static bool RootJointPostFrameProcessCallBack(WK7JObj *pJObj,void *pData);
#endif

	int ChargeShotCtrl(void);
	bool ChargeRateTest(void);
	bool ChargeSetUpCtrl(void);
	bool ChargeSetUpClear(int mode);
	
	bool DanChargeShotEffectStart(void);
	bool DanChargeShotEffectDel(void);
//	bool KvnChargeTameEffectStart(void);
//	void KvnChargeTameEffectDel(void);
	bool KvnKnifeBlur(void);
	bool KvnKnifeBlurDel(void);
	bool KvnNeckBloodStart(Vec *pAtkDir, Vec *pAtkPos, WK7JObj *pHitObj, s32 inFrame);
	
	void WK7PlayerSpAtkCtrlTaskKED1(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskKED2(SPATKCTRL *pInfo);
	
	bool PcMuzzleEffectCreate(int side, Vec *pPos, WK7JObj *GJObj=NULL);
	bool PcCreateBloodPackEffect(void);
	bool PcReleaseBloodPackEffect(void);
	
	bool PcCreateTubeEffect(void);
	bool PcReleaseTubeEffect(void);
	bool PcTubeVisible(bool flag);
	s32 PcTubeGetNum(void);
	s32 PcTubeBlink(bool blink);
	
#ifdef _DEBUG
	void EnemySetDebug(void);
#endif
	bool FootEffectPlay(int type);
	
	void ChargeSePlay(int seNo);
	void ChargeSeStop(void);
	
	void ConpasIncCalc(void);
	void ConpasIncClear(void);
	void ConpasInc(void);
	
	bool MotSet_ChargeallAtk(void);
	bool MotStatus_ChargeallAtk(void);
	bool CreateMskMissile(int first = 0);
	
	void InitEnemySortLight(void);
	SORTNPCLIGHT *EnemySortLight(void);
	bool NearEnemyDirecDisp(void);
	bool GetCorePosition(Vec *pos, int startCoreNum, WK7Npc **pTargetNpc);
	
	// AreBgpłȂx\
	void NoUseSpAtkWarnning(bool flag);
	
public:
	WK7PlayerControl();
	virtual ~WK7PlayerControl();
	
	static bool InitDataSet(u32 mainid,PCDATA &data);
	
	void DamageInit(void);
	void ClearSwitchBuffer(void);
	
	bool PlayMotion(u32 id, bool loop, bool hokan, f32 sframe, f32 speed=1.f);
	bool TestMotion(u32 id);
	bool PauseMotion(void);
	bool ReplayMotion(void);
	bool _MotSet_Wait(bool hokan);
	
	WK7PlayerControlPlayMotionCallBack* SetPrePlayMotionCallBack(WK7PlayerControlPlayMotionCallBack *pCallBack,u32 param);
	inline WK7PlayerControlPlayMotionCallBack* GetPrePlayMotionCallBack(void){ return mpPrePlayMotionCallBack; }
	inline u32 GetPrePlayMotionCallBackParam(void){ return mPrePlayMotionCallBackParam; }
	WK7PlayerControlPlayMotionCallBack* SetPostPlayMotionCallBack(WK7PlayerControlPlayMotionCallBack *pCallBack,u32 param);
	inline WK7PlayerControlPlayMotionCallBack* GetPostPlayMotionCallBack(void){ return mpPostPlayMotionCallBack; }
	inline u32 GetPostPlayMotionCallBackParam(void){ return mPostPlayMotionCallBackParam; }
	
	void HpRecover(void);
	void DieRecoverAll(void);
	void DeadRecover(u32 deadMainID);
	
	bool CyoMagnumSmokeCreate(void);
	bool CyoMagnumSmokeDel(void);
	
#ifndef K7APP_MASTER_NINTENDO
	void StageParamSet(int mode);
#endif

	// \
	void InitSpInfo(void);
	int GetSpProc(void);
	void SetSpInfoType(u32 type);
	u32 GetSpInfoType(void);
	void SetSpInfoWaitFlag(int id,bool flag);
	bool GetSpInfoWaitFlag(int id);
	WK7PlayerSpInfo* GetSpInfo(void){ return &mSpInfo; }
	WK7PlayerSpInfoKed* GetSpInfoKed(void){ return &mSpInfo.mKedInfo; }
	WK7PlayerSpInfoCyo* GetSpInfoCyo(void){ return &mSpInfo.mCyoInfo; }
	
	static u32 GetStateSpAtkTask(void);
	static bool ResumeSpAtkTask(void);
	static bool SuspendSpAtkTask(void);
	static bool SpAtkTaskSetUp(ghmGcTaskController *pTaskFrameCtrl);
	static bool SpAtkTaskShutDown(void);
	u32 GetSpAtkTaskState(void);
	void WK7PlayerSpAtkCtrlTaskDAN(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskCAT(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskMSK(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskCYO(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskKVN(SPATKCTRL *pInfo);
	void WK7PlayerSpAtkCtrlTaskKED(SPATKCTRL *pInfo);
	void WK7PlayerCyoPicking(int inPickID, Vec *pCamTgt, Vec *pCamPos, Vec *pPcPos, f32 pcRotY, int openSE=-1, bool noiseAndTrimming=false);
	void WK7PlayerMskSpAtkPosePlay(int voiceID=SFX_PC_MSK_TOKUSYU_VOICE);
	
	bool HasSpAbility(WK7PcSpAbility id);
	bool SetPathSelectState(void);
	
	bool _SkullJointPostFrameProcessCallBack(WK7JObj *pJObj);
#if FUJITA && BATTLE_CAM_ATTACH
	bool _RootJointPostFrameProcessCallBack(WK7JObj *pJObj);
	void SetCamOfstMtx( MtxPtr m );
#endif
	
	inline void SetSpAbilityCancel(bool flag){ mSpAbilityCancel=flag; }
	inline bool GetSpAbilityCancel(void){ return mSpAbilityCancel; }
	
	bool SetLookAtPosition(const Vec *pPos);
	bool GetLookAtPosition(Vec *pPos);
	inline void SetLimitNeckAngleY(f32 ang){ mLimitNeckAngleY=ang; }
	inline f32 GetLimitNeckAngleY(void){ return mLimitNeckAngleY; }
	inline void SetLimitNeckAngleXP(f32 ang){ mLimitNeckAngleXP=ang; }
	inline f32 GetLimitNeckAngleXP(void){ return mLimitNeckAngleXP; }
	inline void SetLimitNeckAngleXM(f32 ang){ mLimitNeckAngleXM=ang; }
	inline f32 GetLimitNeckAngleXM(void){ return mLimitNeckAngleXM; }
	bool SpAtkTaskStart(int mode);
	
	static WK7PlayerControl* GetInstance(void);
	inline WK7PathControl* GetPathControl(void){ return &mPathControl; }
	inline ReleaseState GetReleaseState(void){ return mReleaseState; }
	inline WK7PcControlState GetState(void){ return mState; }
//	inline WK7Light* GetLight(void){ return mpLight; }
	WK7Light* GetLight(int index);
	int GetLightNum(void);
	
	WK7PcMotion* GetPcCmnMotion(int index);
	WK7ModelMotion* GetCmnModelMotion(int index);
	int PcGetMotionState(void);
	
	bool ReleaseArchive(void);
	bool RestoreArchive(void);
	
	bool MotSet_SpAtk(void);
	void NpcBomberSet(f32 bombDist);
	
	bool Initialize(void);
	bool Terminate(void);
	
	bool SpAtkEffectEndTest(u32 stageid, u32 saveMainID=0xffffffff);
	
	bool CreateBloodDmg(void);
	void DelBloodDmg(void);
	
	// NewGameɏ֐
	bool NewGameReset(void);
	// ViItH[ɏ֐
	bool ScenarioFlowReset(void);
	// ViIɏ֐
	bool ScenarioReset(void);
	
	// Xe[Wɏ֐
	bool StageReset(void);

	// Lւ̎ɃR[郊Zbg֐
	bool Reset(void);
	
	// t[
	bool FrameProcess(void);
	// _O
	bool RenderProcess(void);
	
	// hcݒ
	void SetID(u32 id);
	u32 GetID(void);
	inline u32 GetMainID(void){ return mMainID; }
	inline u32 GetSuffix(void){ return mSuffix; }
	
	// ҂̂hc擾
	inline u32 GetDieID(void){ return mDieID; }
	
	void WaistToRoot(f32 inSetY);
	void SetLightEnable(bool flag);
	bool GetLightEnable(void);
	void SetOperateEnable(bool flag);
	bool GetOperateEnable(void);
	void SetEnable(bool flag);
	void SetEnableOnly(bool flag);
	bool GetEnable(void);
	void SetPathEnable(bool flag);
	bool GetPathEnable(void);
	
	inline void SetManualVitalDisp(bool flag){ mManualVitalDisp = (flag==true? 1:0); }
	inline bool GetManualVitalDisp(void){ return mManualVitalDisp? true : false; }
	bool SetManualVital(f32 vital);
	inline f32 GetManualVital(void){ return mManualVital; }
	
	inline void SetBloodUseDisable(bool flag){ mBloodUseDisable = (flag==true? 1:0); }
	inline bool GetBloodUseDisable(void){ return mBloodUseDisable? true : false; }
	u16 GetBloodGauge(int type);
	void SetBloodGauge(int type, u16 Point);
	u16 IncBloodGauge(int type, s16 IncPoint);
	
	// R[obN֐
//	virtual CallbackResult PreMoveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,f32 restdist);
	virtual CallbackResult PostMoveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,f32 restdist,f32 movedist);
	virtual CallbackResult ReverseCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo);
	virtual CallbackResult RenewCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo);
	virtual CallbackResult BranchPointArriveCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
	virtual CallbackResult PathSelectCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranchPoint *pBranchPoint);
	virtual CallbackResult PathChangeCallback(WK7PathControl *pPathControl,WK7PathInfo *pInfo,WK7PathBranch *pSelectBranch,bool interpolate,int inv);

	// fǂݍ݊֘A
	int CreateModel(u32 charaid);
	bool ReleaseModel(void);
	
	// vC[S̊J
	bool ReleaseAll(void);

	// [Vǂݍ݊֘A
	static s16 GetMotionID(u32 mainid,u32 index);
	void CreatePackMotion(u32 charaid);
	WK7PcMotion* CreateMotion(u32 motid, u32 cmnid);
	bool ReleaseMotionAll(void);
	
	// ǂݍ݊mF
	bool IsLoading(void);
	
	// L|C^擾
	inline WK7Chara* GetCharaPtr(void){ return mpPcChara; }
	WK7Model* GetCharaModel(void);
	WK7Model* GetGunPtr(int index);

	bool SetClothEnable(bool flag,bool tobind=true);
	bool GetClothEnable(void);
	
	// \n
	void SetVisible(bool flag);
	bool GetVisible(void);
	void StackVisible(bool flag);
	void PullVisible(void);
	void SetGunVisible(bool flag);

	// _[W炢Zbg
	bool SetPcDamage(Vec hitPos, s16 damagePoint, s16 damageType=0, int damageSe=-1, s16 seTiming=0 );
	
	// ʒu擾
	bool GetPosition(Vec *pos);
	bool SetPosition(Vec *pos);
	bool SetPosition(f32 x,f32 y,f32 z);
	inline bool GetPosition(Vec &position){ return GetPosition(&position); }
	bool GetRotY(f32 *roty);
	bool GetRotX(f32 *rotx);
	bool SetRotY(f32 roty);
	bool SetRotX(f32 rotx);
	bool GetWaistPosition(Vec *pPosition){
		if ( mpObjWaistBone != NULL ){
			mpObjWaistBone->GetWorldPosition(pPosition);
			return true;
		}
		return false;
	}
	bool RestorePathPosition(void);
	bool GetPathPosition(Vec *pos);
	bool GetPathDir(Vec *dir);
	
	// V[eBOVbg֌W
	void SetShotFlag(WK7PcShotMode mode);
	void ClearShotFlag(void);
	WK7PcShotMode GetShotFlag(void);
	
	void SetShotReturnInfo(Vec *pTgtPos, WK7Npc *pNpc, s16 sightPx, s16 sightPy, u32 argb, Vec *pShotRot);
	bool GetShotReturnInfo(void);
	void ClearShotReturnInfo(void);

	// WK7JObj o
	inline WK7JObj *GetWaistObjPtr(void){ return mpObjWaistBone; }
	inline WK7JObj *GetHandBone(void){  return mpObjHandBone; }
	inline WK7JObj *GetHandRSkin(void){ return mpObjHandRSkin; }
	inline WK7JObj *GetHandLSkin(void){ return mpObjHandLSkin; }

	// JgL̃qbg|Cg̎擾
	s16 GetHp(void){ return mData.mHp; }
	bool DecHp(s16 decHp);
	bool IncHp(s16 incHp);
	bool SetHp(s16 setHp);
	
	// qɃL̂gof[^擾
	void GetDataHp(u32 mainid, s16 *pNowHp, s16 *pMaxHp);
	// qɃL̂goɃf[^𔽉f
	void SetDataHp(u32 mainid, s16 setHp);
	
	// ce̎擾
	s16 GetBullet(void){ return mNowBullet; }
	s16 GetMaxBullet(void){ return mData.mGunBallet; }
	
	// ݒe_[Wl̎擾
	s16 GetGunDefDamage(void);
	
	// ݒe_[Wl̎擾
	f32 GetGunWeakSize(f32 operationDist);
	
	// ݒY[TCYFovl擾
	f32 GetMinFov(void){ return mData.mMinFov; }
	
	// ݒeu擾
	f32 GetGunBure(void){ return mData.mBure; }
	
	// ݒԎނ擾
	u8 GetBloodTexNum(void){ return mData.mBloodTexNum; }
	
	const PCDATA* GetPcData(void){ return &mData; }
	const PCDATA* GetPcData(u32 mainid);
	
	bool PlayDamageEffect(s16 damType=1);
	
	// og[h甲Ƃ̃Zbg
	void BattleReset(void);
	
	inline void SetCameraAlphaControl(bool flag){ mCameraAlphaControl=flag; }
	inline bool GetCameraAlphaControl(void){ return mCameraAlphaControl; }
	
	// vC[퓬Ԃǂׂ
	bool GetFightTest(void);
	
	// vC[ȐԂǂׂ
	bool GetNaturalTest(void);
	
	// XyVA^bNQ[WINC
	void SpGaugeInc(s16 val, u32 eneTypeID=0xffffffff, s32 eneSuffix=-1);
//	void SpGaugeIncMan(f32 TPRate)

//		void SetmpScanGauge(EFFECT *pEffect);
//		// RcQ[WEm|C^擾
//		EFFECT *GetmpScanGauge(void);
	
	// XL̒l֌W
	f32 GetNowScanPoint(void){ return (f32 )mScanNextCount; }
	f32 GetMaxScanPoint(void){ return (f32 )SCAN_RELOAD_TIME; }
	
	// XyVA^bN̒l֌W
//	f32 GetNowSpAtkPoint(void);
//	f32 GetMaxSpAtkPoint(void);
	
	// XyVA^bÑ[hZbg
	void SpAtkSetMode(int mode){ mSpAtk.mRun = (s16 )mode; }
	
	// }XNp̃XyVA^bNǂׂ
	bool SpAtkMskTest(void);
	// Prp̃XyVA^bNǂׂ
	bool SpAtkKvnTest(void);
	
	// XyVA^bNǂׂ
	bool SpAtkTest(void);
	
	// ogRg[VXe̋N
	void BattleAlphaCtrlSet(bool flag){ mBattleAutoAlphaCtrl = flag; }
	bool BattleAlphaCtrlGet(void){ return mBattleAutoAlphaCtrl; }
	
	// l𔼓ɂ
	void MoveAlphaVal(f32 val){ mAlpha[1] = val; }
	void SetAlphaVal(f32 val){ mAlpha[0] = mAlpha[1] = val; }
	f32 GetAlphaVal(void){ return mAlpha[0]; }
	
	// `FbN|Cgݒn
	PCCHKPPOINT *GetChkPointPtr(void){ return &mChkPoint; }
	bool ChangeStartChkPoint(void);
//	void ChangeStartChkPoint(u32 stgID);
	bool ChangeChkPoint(void);
	
	// \֌W
	void InitKamaeDir(void);
	void SetKamaeDir(f32 dir);				// \̎w
	f32  GetKamaeDir(void);					// \擾
	bool TestKamaeDir(void);				// \ݒ肳Ă邩ǂ
	
	// \ʒu֌W
	void InitKamaePos(void);
	void SetKamaePos(Vec Pos);				// \ʒu̎w
	Vec  *pGetKamaePos(void);				// \ʒu擾
	bool TestKamaePos(void);				// \ʒuݒ肳Ă邩ǂ
	
	// Xe[^X֘A
	WK7PcControlState GetPcState(void){ return mState; }
	void SetPcState(WK7PcControlState state){ mState = state; }
	
	// ݍĐĂ郂[V̎ct[擾
	f32 GetMotRemainFrame(void);
	
	// |[Y֌W
	bool GetPause(void);
	bool SetPause(void);
	bool ResetPause(void);
	
	// S֘ÃGtFNg
	void DieSet(void);
	void DieReset(void);
	
	// Q[I[o[[h̐ݒ
	void SetGameOver(u8 mode=PC_GAMEOVER_ONLY, u32 charaid=0);
	u32 GetGameOver(void){ return mGameOverMode; }
	void ClearGameOver(void){ mGameOverMode = PC_GAMEOVER_DEFAULT; }
	
	// lQ[I[o[ǂ
	bool PcDieTest(void){	\
	if ((mState == PC_STATE_LOSS)||(mState == PC_STATE_DIE))	return true;	\
	else 							return false;	\
	}

#if FUJITA
//	EFFECT *GetVitalEffect( void ){ return mpVital;}				// ̗͕\iRcj	
	//ꕔLN^ňړAUɂB
	inline void SetTurnAble( bool flg_ ) { mTurnAble = flg_; }
	inline void SetWalkAble( bool flg_ ) { mWalkAble = flg_; }
	u32 GetMotID( void ) const { return mMotID; }
#endif
	
	inline void SetCamRevDisable(bool flag){ mCamRevDisable = (flag==true? 1:0); }
	inline bool GetCamRevDisable(void){ return mCamRevDisable? true : false; }
	inline void SetSpAbilityDisable(bool flag){ mSpAbilityDisable = (flag==true? 1:0); }
	inline bool GetSpAbilityDisable(void){ return mSpAbilityDisable? true : false; }
	
	// \̓GtFNgID擾
	s8 GetSpAtkBillBoardEffectID(void){ return SpAtkBillBoardEffectID; }
	
	s8 GetCounterSignalEasyAnimID(void){ return CounterSignalEasyAnimID; }
	
	// tʂ̎擾ij
	s16 GetNowBloodPoint(void);
	// ő匌tʂ̎擾ij
	s16 GetMaxBloodPoint(void){ return (s16 )BLOOD_THIN_GAUGE_MAX; }
	// tʃGtFNg|C^̎擾 NULL NGCgĂȂ
	EFFECT *GetBloodPackEffectPtr(void);
	
	bool ChangeCallback(void);
	
	// ݔ邩̃eXg
	WK7Npc *KerenmiStartTest(WK7Npc *pNpcSide);
	// ݔ
	bool KerenmiStart(WK7Npc *pNpcSide);
	
	// [Vt[̎擾
	f32 GetCurrentMotionFrame(void);
	f32 GetTotalMotionFrame(void);
	
	// iU邩̃eXg
	WK7Npc *DownAtkStartTest(WK7Npc *pNpcSide, f32 dist, s16 kabeFlag, f32 sightRotX);
	// iU
	bool DownAtkStart(WK7Npc *pNpc);
	
	// vOĂяo퓬Ԑ
	bool SetPcBattleMode(Vec *pPos=NULL, f32 rot=0.f);
	bool ExitPcBattleMode(int mode=1);
	bool GetPcBattleMode(void);
	
	// 퓬ԐǂH
	bool PcBattleTaskTest(void);
	
	// ogAJςȂ΂ȂuԂǂ̔
	bool CamChangeBattleSpAtkTest(void);
	
	// 1ŎEꍇ̐
	bool SEPlayCritical(WK7NpcDamType damType);
	
	// ^E`GtFNg|C^̎擾 
	EFFECT *GetChargeShotEffectPtr(void);
	
	// OĂ
	bool HasRing(int ringID);
	
	// O𑕔Ă
	bool EquipRing(int ringID);
	
	// pbhRg[[h̐ݒiog
	void BattlePadRegulationSet(u32 mode=0);
	void BattlePadRegulationReSet(u32 mode);
	void BattlePadRegulationClear(void);
	bool BattlePadRegulationTest(u32 mode);
	
	// ̃[V̕⊮IɂȂ\
	void NextMotionHokanEnableRequest(void){ mNoHokanReq = 1; }
	
	// NPČ̃GtFNgo^
	void LastBloodEffectPtrSet(EFFECT *pEfc);
	bool LastBloodEffectTest(void);
	
	u16 GetCurrentFootSE(void);
	
	static K7SETBL* GetSeTbl(u16 footse);
	static int GetSe(u32 chrmainid,u16 footse,int walkrun);
	int GetSe(u16 footse,int walkrun);
	
	// `[W̃ZbgAbvx̎擾
	u8 GetChargeSetUpLv(void);
	u8 GetChargeSetUpLvMax(void);
	int ChargeSetUpTest(int mode, int *pSEo=NULL);
	
	// [h̐ݒ
	void SetWalkOnly(void);
	void ClearWalkOnly(void);
	
	// ANVJn
	bool ActionCameraPlay(u32 id, f32 sframe, f32 camRotY);
	bool ActionCameraState(void);
	void ActionCameraExit(void);
	
	// ŏ̈ʒuZbgꂽǂH
	bool FirstPosSetTest(void);
	
	// qbgǃ_[WʂĂȂꍇ̃GtFNg
	bool NoDamageHitEffectPlay(WK7PcShotMode ShotMode, Vec *pDamPos);
	
	// e_[W̎擾
	s16 GetGunDamage(int id);
	s16 GetGunDamage(WK7PcShotMode ShotMode);
	s16 GetGunDamage(WK7HitObjInfoType objHit);
	s16 GetGunDamage(WK7NpcDamType damType);
	
	// ԋ߂G擾iCg\[gVerj
	SORTNPCLIGHT *GetEnemySortLight(int id=0);
	
	int GetSeLoopTask(void) { return mSeLoopTask; }
	void SetSeLoopTask(int id) { mSeLoopTask = id; }
	
	// \߂Ƃɂrd炳ȂNGXg
	int GetNoShotWaitSeReq(void) { return mNoShotWaitSeReq; }
	void SetNoShotWaitSeReq(u32 flag=1) { mNoShotWaitSeReq = flag; }
	
	// ǒẽGtFNgi}XNp̐
	bool CreateWallHitEfc(EFFECT *pYamEfc, int mode);
	void DelWallHitEfc(int mode);
	
	// Vbg{^֎~ɂ
	void SetNoShotButton(u32 flag=1);
	void ClearNoShotButton(void);
	
	// Gݒ
	void SetMuteki(void) { mMuteki=1; };
	void ClearMuteki(void) { mMuteki=0; };
	u32 GetMuteki(void) { return mMuteki; };
};


#define	WK7PLAYERCONTROL		WK7PlayerControl::GetInstance()
#define	WK7PLAYERPATHCONTROL	WK7PLAYERCONTROL->GetPathControl()

#ifdef	__WK7PLAYER_CPP__

enum _SPATKTASKPROCESSSTATE{
	SPATKTASKPROCESSSTATE_INIT = 0,
	SPATKTASKPROCESSSTATE_READY,
	SPATKTASKPROCESSSTATE_GO,
	SPATKTASKPROCESSSTATE_EXIT,
};

//enum WK7PlayerControlState{
//	STOP = 0,		// ~
//	RUN,			// 
//	WALK,			// 
//	RTURN,			// E^[
//	LTURN,			// ^[
//	BTURN,			// obN^[
//	GSHOT,			// e
//};

GHMGCTASK_HANDLER(WK7PlayerChangeTaskforDie);
GHMGCTASK_HANDLER(WK7PlayerChangeTaskDebug);
GHMGCTASK_HANDLER(WK7PlayerGameOverTask);
GHMGCTASK_HANDLER(WK7PlayerGalDeadRecoverTask);
GHMGCTASK_HANDLER(WK7PlayerHNGBattleDieTask);

GHMGCTASK_HANDLER(WK7PlayerSpAtkCtrlTask);
GHMGCTASK_HANDLER(WK7PlayerSpAtkCtrlTaskTerm);

GHMGCTASK_HANDLER(WK7EnemySignalSeTask);
GHMGCTASK_HANDLER(WK7EnemySignalSeTermTask);

LOOP_ENESE *WK7EnemySignalSeSetUp(int inSEno, u8 volMax, u32 charaID);

void WK7PlayerChangeTaskforScenario00(u32 charaid);
void WK7PlayerChangeforScenatio00(u32 charaid);
void WK7PlayerChangeforDie(u32 charaid);
void WK7DeadManJumpTest(u32 *pStageID, Vec *pPos);

//void WK7PlayerChangeforDieScn00(u32 charaid);
void WK7PlayerChangeforTV(u32 charaid);


#else
// Extern ---
extern s16 pcMotionIdTable[WK7MOTION_PCCMN_TOTAL_MAX][K7PCMAX];

GHMGCTASK_HANDLER(WK7PlayerChangeTaskforDie);
GHMGCTASK_HANDLER(WK7PlayerChangeTaskDebug);
GHMGCTASK_HANDLER(WK7PlayerGameOverTask);
GHMGCTASK_HANDLER(WK7PlayerGalDeadRecoverTask);
GHMGCTASK_HANDLER(WK7PlayerHNGBattleDieTask);

GHMGCTASK_HANDLER(WK7PlayerSpAtkCtrlTask);
GHMGCTASK_HANDLER(WK7PlayerSpAtkCtrlTaskTerm);

GHMGCTASK_HANDLER(WK7EnemySignalSeTask);
GHMGCTASK_HANDLER(WK7EnemySignalSeTermTask);

extern LOOP_ENESE *WK7EnemySignalSeSetUp(int inSEno, u8 volMax, u8 inMode, u32 charaID);
extern void WK7PlayerChangeTaskforScenario00(u32 charaid);
extern void WK7PlayerChangeforScenatio00(u32 charaid);
extern void WK7PlayerChangeforDie(u32 charaid);
//extern void WK7PlayerChangeforDieScn00(u32 charaid);
extern void WK7PlayerChangeforTV(u32 charaid);


#endif

#endif	//__WK7PLAYER_H__

