////////////////////////////////////////////////////////////////////////////////
//
// Killer7 ScreenImage
//
// WK7ScreenImage.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/18/2003
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7SCREENIMAGE_H__
#define	__WK7SCREENIMAGE_H__

#include <dolphin.h>
#include ".\WK7Anim.h"

//
// XN[C[W
// 
// ftHgtB^w肪|CgTvOɂȂĂ̂Œ
//
class WK7ScreenImage{
protected:
	GXTexObj					mTexObj;
	void						*mpTexture;
	u16							mWidth,mHeight;
	GXTexWrapMode				mWrapS,mWrapT;
	GXTexFmt					mFormat;
	GXTexFilter					mMinFilt;
	GXTexFilter					mMagFilt;
	u32							mTexSize;
	GXColor						mClearColor;
	u32							mClearZ;
	union{
		struct{
			u32					mCopyEnable : 1;
			u32					mRender     : 1;
			u32					mPreRender  : 1;
			u32					mZUpdate    : 1;
			u32					mFullScreen : 1;
			u32					mAllocBuffer: 1;
			u32					mFlagPad    :26;
		};
		u32						mFlag;
	};
	WK7AnimLinear				mR,mG,mB,mA;
public:
	WK7ScreenImage();
	virtual ~WK7ScreenImage();
	
	inline void SetCopyEnable(bool flag){ mCopyEnable = (flag==true)? 1:0; }
	inline bool GetCopyEnable(void){ return mCopyEnable? true : false; }
	
	bool SetSize(u16 w,u16 h);
	bool SetFormat(GXTexFmt fmt);
	bool SetWrapMode(GXTexWrapMode s,GXTexWrapMode t);
	bool SetTexFilter(GXTexFilter min,GXTexFilter mag);
	inline bool SetClearColor(GXColor color){ mClearColor = color; return true; }
	inline bool SetClearZ(u32 z){ mClearZ = z; return true; }
	
	bool AllocBuffer(void *pBuff);
	bool AllocBuffer(void);
	bool FreeBuffer(void);
	bool ScreenCopy(bool clear=false);
	
	bool GetSize(u16 *w,u16 *h);
	inline u16 GetWidth(void){ return mWidth; }
	inline u16 GetHeight(void){ return mHeight; }
	inline GXTexWrapMode GetWrapModeS(void){ return mWrapS; }
	inline GXTexWrapMode GetWrapModeT(void){ return mWrapT; }
	inline GXTexFmt GetFormat(void){ return mFormat; }
	inline GXTexFilter GetTexMinFilter(void){ return mMinFilt; }
	inline GXTexFilter GetTexMagFilter(void){ return mMagFilt; }
	inline u32 GetTexSize(void){ return mTexSize; }
	inline GXColor GetClearColor(void){ return mClearColor; }
	inline u32 GetClearZ(void){ return mClearZ; }
	
	inline static void InvalidateTex(void){ GXInvalidateTexAll(); }
	
	inline GXTexObj* GetTexObj(void){ return &mTexObj; }
	inline void* GetTexture(void){ return mpTexture; }
	inline void LoadTexObj(GXTexMapID id){ GXLoadTexObj(&mTexObj,id); }
	bool InitTexObj(void);
	
	inline void SetRender(bool flag){ mRender = (flag==true? 1:0); }
	inline bool GetRender(void){ return mRender? true : false; }
	inline void SetPreRender(bool flag){ mPreRender = (flag==true? 1:0); }
	inline bool GetPreRender(void){ return mPreRender? true : false; }
	bool RenderProcess(bool flag=true);
	bool FrameProcess(void);
	
	bool SetA(u32 a,u32 tick=0);
	inline u32 GetA(void){ return mA.GetValue(); }
	inline bool IsAnimatingA(void){ return mA.IsAnimating(); }
	bool SetR(u32 r,u32 tick=0);
	inline u32 GetR(void){ return mR.GetValue(); }
	inline bool IsAnimatingR(void){ return mR.IsAnimating(); }
	bool SetG(u32 g,u32 tick=0);
	inline u32 GetG(void){ return mG.GetValue(); }
	inline bool IsAnimatingG(void){ return mG.IsAnimating(); }
	bool SetB(u32 b,u32 tick=0);
	inline u32 GetB(void){ return mB.GetValue(); }
	inline bool IsAnimatingB(void){ return mB.IsAnimating(); }
	
	inline bool SetAlpha(u32 alpha,u32 tick=0){ return SetA(alpha,tick); }
	inline u32 GetAlpha(void){ return GetA(); }
	inline bool IsAnimatingAlpha(void){ return IsAnimatingA(); }
	
	inline void SetZUpdate(bool flag){ mZUpdate = (flag==true? 1:0); }
	inline bool GetZUpdate(void){ return mZUpdate? true : false; }
	
	inline void SetFullScreen(bool flag){ mFullScreen = (flag==true? 1:0); }
	inline bool GetFullScreen(void){ return mFullScreen? true : false; }
};

#endif	//__WK7SCREENIMAGE_H__

