////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Sight
//
// WK7Sight.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 04/21/2003
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7SIGHT_CPP__

//#include <sysdolphin\baselib.h>
//#include <dolphin.h>
#include ".\WK7Sight.h"
//#include ".\WK7Define.h"
#include ".\WK7MainTask.h"
#include ".\WK7Cam.h"
//#include "..\Lib\ghmGcFile.h"

WK7Sight*					WK7Sight::mpSightInstance = NULL;
GhmGcTexHeader*				WK7Sight::mpTexture  = NULL;
GXTexObj					WK7Sight::mTexObj;
int							WK7Sight::mPeekIndex    = 0;
volatile bool				WK7Sight::mCallBackCall = true;
//volatile int				mCallBackFlag = 0;
GXDrawSyncCallback			WK7Sight::mpOldCallback = NULL;
HSD_VIGXDrawDoneCallback	WK7Sight::mpOldDrawDoneCallback = NULL;

WK7Sight* WK7Sight::GetInstance(void)
{
	if( mpSightInstance==NULL ){
		ghmGcMemSetAllocName("WK7Sight");
		mpSightInstance = new WK7Sight;
	}
	return mpSightInstance;
}

WK7Sight::WK7Sight()
{
	mPosX         = 0.0f;
	mPosY         = 0.0f;
	mVisible      = false;
//	mCrossSize    = 6.0f;
	mCrossSize    = 20.0f;
	mHotColor  .r = 0xff;
	mHotColor  .g = 0x00;
	mHotColor  .b = 0x00;
	mHotColor  .a = 0xff;
//	mHotColor  .a = 0xc0;
	mColdColor .r = 0x00;
	mColdColor .g = 0x80;
	mColdColor .b = 0x80;
	mColdColor .a = 0xff;
//	mColdColor .a = 0xc0;
	mCrossColor.r = 0x00;
	mCrossColor.g = 0x00;
	mCrossColor.b = 0x00;
	mCrossColor.a = 0xff;
	mCrossWidth   = 12;
	if( mpTexture==NULL ){
		mSize         = 32.0f;
	}else{
		mSize         = (f32)mpTexture->mWidth * 0.5f;
	}
	memset(&mPeekData[0],0,sizeof(WK7SightPeekData));
	memset(&mPeekData[1],0,sizeof(WK7SightPeekData));
}

WK7Sight::~WK7Sight()
{
	
}

void WK7Sight::DrawDoneCallback(int idx)
{
	if( idx >= 0 ){
		HSD_VIDrawDoneXFB(idx);
	}else{
		if( idx==-2 ){
//			BOOL	intr;
//			intr = OSDisableInterrupts();
			mCallBackCall = true;
//			if( mCallBackFlag > 0 ){
//				mCallBackFlag--;
//			}else{
//				OSReport("DrawDoneCallback Error\n");
//			}
//			OSRestoreInterrupts(intr);
			//荞ݒɒlςz͖IɂKvƂH
			//AŏĂȂƂ͑vȂ̂H
			//ꂶȂCȂB
//			DCFlushRange((void*)mCallBackCall,sizeof(bool));
		}
	}
	if( mpOldDrawDoneCallback != NULL ){
		mpOldDrawDoneCallback(idx);
	}
}

#ifdef	_DEBUG
#include "..\Yam\YK7Effect.h"
#include "..\Yam\YK7EffectElec.h"
#include "..\Yam\YK7EffectSmoke.h"
	struct ___EFFECT{
		EFFECT_TYPE			Type ;
		struct tagEFFECT	*Parent ;
		union{
			ELECEFFECT		*pEffectElec;
			SMOKEEFFECT		*pEffectSmoke;
		};
	};
	union TokenObj{
		void			*pObj;
		WK7RenderObj	*pRenderObj;
		WK7JObj			*pJObj;
		HSD_DObj		*pDObj;
		EFFECT			*pEffect;
		___EFFECT		*pEffect_;
	};

extern	"C"{
	
	#define	TOKENNUM		(512)
	volatile	u16				gSetDrawSyncToken = 0xffff;
	volatile	u16				gGetDrawSyncToken = 0xffff;
	volatile	int				gSetDrawSyncTokenIndex = 0;
	volatile	int				gGetDrawSyncTokenIndex = 0;
	volatile	u16				gSetDrawSyncTokenTable[TOKENNUM] = {0xffff,};
	volatile	TokenObj		gSetDrawSyncObjTable  [TOKENNUM] = {NULL,};
	volatile	u16				gGetDrawSyncTokenTable[TOKENNUM] = {0xffff,};
	volatile	u16				gDrawSyncTokenCounter = 0;
	volatile	int				gDrawSyncTokenEnable  = false;

	void SetDrawSyncTokenEnable(int flag)
	{
		gDrawSyncTokenEnable = flag;
	}

	int GetDrawSyncTokenEnable(void)
	{
		return gDrawSyncTokenEnable? 1:0;
	}

	void ResetDrawSyncCounter(void)
	{
		gDrawSyncTokenCounter = 0;
	}

	void SetDrawSyncCounter(u16 cnt)
	{
		gDrawSyncTokenCounter = cnt;
	}

	u16 GetDrawSyncCounter(void)
	{
		return gDrawSyncTokenCounter;
	}

	void ClearDrawSync(void)
	{
		gSetDrawSyncTokenIndex = 0;
		gGetDrawSyncTokenIndex = 0;
		gSetDrawSyncToken      = 0xffff;
		gGetDrawSyncToken      = 0xffff;
		gDrawSyncTokenCounter  = 0;
		int		i;
		for(i=0 ; i<TOKENNUM ; i++){
			gSetDrawSyncTokenTable[i] = 0xffff;
			gGetDrawSyncTokenTable[i] = 0xffff;
		}
	}

	int SearchDrawSync(u16 token)
	{
		int		i;
		for(i=0 ; i<TOKENNUM ; i++){
			if( gSetDrawSyncTokenTable[i]==token ){
				return i;
			}
		}
		return -1;
	}

	void SetDrawSync(u16 token,void *pObj)
	{
		if( !gDrawSyncTokenEnable ){
			return;
		}
//		BOOL	intr;
//		intr = OSDisableInterrupts();
		gSetDrawSyncToken = token;
		if( gSetDrawSyncTokenIndex < TOKENNUM ){
			gSetDrawSyncTokenTable[gSetDrawSyncTokenIndex] = token;
			gSetDrawSyncObjTable  [gSetDrawSyncTokenIndex].pObj = pObj;
			gSetDrawSyncTokenIndex++;
		}
		gDrawSyncTokenCounter++;
//		OSRestoreInterrupts(intr);
		GXSetDrawSync(token);
	}
	
	u16 GetDrawSyncToken(void)
	{
		return gGetDrawSyncToken;
	}

}
#endif

void WK7Sight::DrawSyncCallback(u16 token)
{
#ifdef	_DEBUG
//	BOOL	intr;
//	intr = OSDisableInterrupts();
	if( gGetDrawSyncTokenIndex < TOKENNUM ){
		gGetDrawSyncTokenTable[gGetDrawSyncTokenIndex] = token;
		gGetDrawSyncTokenIndex++;
	}
	gGetDrawSyncToken = token;
//	OSRestoreInterrupts(intr);
#endif
//	if( token==WK7SIGHT_PEEKTOKEN ){
//		BOOL	intr;
//		intr = OSDisableInterrupts();
//		mCallBackCall = true;
//		OSRestoreInterrupts(intr);
//	}
	if( mpOldCallback != NULL ){
		mpOldCallback(token);
	}
}

bool WK7Sight::Initialize(void)
{
//	mCallBackFlag = 0;
	mCallBackCall         = true;
#ifdef	_DEBUG
	mpOldCallback         = HSD_GXSetUserDrawSyncCallback(DrawSyncCallback);
#endif
	mpOldDrawDoneCallback = HSD_VISetUserGXDrawDoneCallback(DrawDoneCallback);
	GXPokeAlphaRead(GX_READ_NONE);
	WK7Sight::GetInstance();
	return true;
}

bool WK7Sight::Terminate(void)
{
	WaitSyncToken();
	HSD_GXSetUserDrawSyncCallback  (mpOldCallback);
	HSD_VISetUserGXDrawDoneCallback(mpOldDrawDoneCallback);
	mpOldCallback         = NULL;
	mpOldDrawDoneCallback = NULL;
	mCallBackCall         = true;
//	mCallBackFlag = 0;
	return true;
}

extern	volatile s64	tokenStartTick;

bool WK7Sight::DrawSyncToken(void)
{
	BOOL	intr;
	intr = OSDisableInterrupts();
//	mCallBackFlag++;
	mCallBackCall = false;
	tokenStartTick = OSGetTime();
	OSRestoreInterrupts(intr);
//	GXSetDrawSync(WK7SIGHT_PEEKTOKEN);
	GXFlush();
	GXResetWriteGatherPipe();
	HSD_VIGXSetDrawDone(-2);
	return true;
}

bool WK7Sight::GetDrawDone(void)
{
//	if( mCallBackFlag > 0 ){
//		return false;
//	}
	if( mCallBackCall==false ){
		return false;
	}
	return true;
}

bool WK7Sight::WaitSyncToken(void)
{
	s64		startTick = OSGetTime();
//	s32		tmp;
//	while( mCallBackFlag > 0 ){}
	while( mCallBackCall==false ){
//		tmp = OSDiffTick(OSGetTime(),startTick);
//		if( tmp >= OS_TIMER_CLOCK * 4 / WK7_FRAME_RATE ){
//			GXAbortFrame();
//			GXSetDrawDone();
//			OSReport("GXAbortFrame\n");
//			break;
//		}
	}
//	GXSetDrawSync(WK7SIGHT_PEEKTOKEN+1);
	return true;
}

bool WK7Sight::PeekData(void)
{
	s32					x,y;
	mPeekIndex ^= 1;
	WK7SightPeekData	*pPeekData = mPeekData + mPeekIndex;
//#if FUJITA
//	//Qڈȍ~Peek͑҂ȂB
//	if( mCallBackCall==false ){
//		WaitSyncToken();
//	}else{
//	}
//#else
	WaitSyncToken();
//#endif

	DCFlushRange(pPeekData,sizeof(WK7SightPeekData));
	x = (s32)mPosX;
	y = (s32)mPosY;
	if( x < 0 || x > WK7_SCREEN_WIDTH || y < 0 || y > WK7_SCREEN_HEIGHT ){
		pPeekData->State = 0;
	}else{
		pPeekData->State = 1;
		GXPeekARGB((u16)x,(u16)y,&pPeekData->ARGB);
		GXPeekZ   ((u16)x,(u16)y,&pPeekData->Z   );
	}
	return true;
}

bool WK7Sight::LoadTexture(const char *pfname)
{
	ghmGcFile	file;
	if( file.Open((char *)pfname)==false ){
		return false;
	}
	if( (mpTexture = (GhmGcTexHeader *)file.ReadB())==NULL ){
		return false;
	}
	file.Close();
	
	if( mpTexture->mMagicNumberU32!=GHMGCTEX_MAGINNUMBER ){
		GHMGCMEM_SAFE_FREE(mpTexture);
		return false;
	}
	void	*pImage = GHMGCTEX_GETIMAGE(mpTexture);
	GXInitTexObj   (&mTexObj,pImage,mpTexture->mWidth,
	                                mpTexture->mHeight,
	                                mpTexture->mFormat,
	                                GX_CLAMP,
	                                GX_CLAMP,
	                                GX_FALSE);
	GXInitTexObjLOD(&mTexObj,GX_NEAR,
	                         GX_NEAR,
	                         0.0f,
	                         0.0f,
	                         0.0f,
	                         GX_FALSE,
	                         GX_FALSE,
	                         GX_ANISO_1);
	
	return true;
}

bool WK7Sight::FrameProcess(void)
{
	return true;
}

bool WK7Sight::RenderProcess(void)
{
	if( mpTexture==NULL || mVisible==false ){
		return false;
	}
	
	GXTexObj		*pScreenTexObj;
	if( (pScreenTexObj = screenImageFullColor.GetTexObj())==NULL ){
		return false;
	}
	
	Mtx				view;
	Mtx44			proj;
	Vec				vPos;
	Vec				vUp;
	Vec				vAt;
	f32				z = 0.0f;
	f32				x0,y0,x1,y1;
	f32				w,h;
	f32				s0,t0,s1,t1;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z =    0.0f;
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =  300.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-WK7_SCREEN_HEIGHT,0,WK7_SCREEN_WIDTH,0.0f,1024.0f);
	
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	GXLoadTexObj    (&mTexObj     ,GX_TEXMAP0);
	GXLoadTexObj    (pScreenTexObj,GX_TEXMAP1);
	
	GXSetDstAlpha    (GX_FALSE,0);
	GXSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_AND,GX_ALWAYS,0xff);
	GXSetDither      (GX_TRUE);
	
	GXSetNumChans     (0);
	GXSetBlendMode    (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetCullMode     (GX_CULL_NONE);
	GXSetZMode        (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetColorUpdate  (GX_TRUE);
	GXSetAlphaUpdate  (GX_FALSE);
	
	GXClearVtxDesc    ();
	GXSetVtxDesc      (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc      (GX_VA_NRM ,GX_NONE  );
	GXSetVtxDesc      (GX_VA_CLR0,GX_NONE  );
	GXSetVtxDesc      (GX_VA_TEX0,GX_DIRECT);
	GXSetVtxDesc      (GX_VA_TEX1,GX_DIRECT);
	
	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_TEX1,GX_TEX_ST  ,GX_F32  ,0);
	
	GXSetNumTexGens   (2);
	GXSetTexCoordGen  (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	GXSetTexCoordGen  (GX_TEXCOORD1,GX_TG_MTX2x4,GX_TG_TEX1,GX_IDENTITY);
	
	GXSetNumTevStages (3);
	
static	GXColor		cmp_enemy = { 0x00,0x00,0x00,0x7f };
	GXSetTevColor     (GX_TEVREG0,mHotColor );
	GXSetTevColor     (GX_TEVREG1,mColdColor);
	GXSetTevColor     (GX_TEVREG2,cmp_enemy );
	
	GXSetTevKAlphaSel (GX_TEVSTAGE0,GX_TEV_KASEL_1);
	GXSetTevColorIn   (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO);
	GXSetTevColorOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_A2  ,GX_CA_KONST,GX_CA_ZERO);
//	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp   (GX_TEVSTAGE0,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder     (GX_TEVSTAGE0,GX_TEXCOORD1,GX_TEXMAP1,GX_COLOR_NULL);
	
	GXSetTevColorIn   (GX_TEVSTAGE1,GX_CC_C1,GX_CC_C0,GX_CC_APREV,GX_CC_ZERO);
	GXSetTevColorOp   (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE1,GX_CA_A1,GX_CA_A0,GX_CA_APREV,GX_CA_ZERO);
	GXSetTevAlphaOp   (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder     (GX_TEVSTAGE1,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR_NULL);
	
	GXSetTevColorIn   (GX_TEVSTAGE2,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp   (GX_TEVSTAGE2,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE2,GX_CA_ZERO,GX_CA_TEXA,GX_CA_APREV,GX_CA_ZERO);
	GXSetTevAlphaOp   (GX_TEVSTAGE2,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder     (GX_TEVSTAGE2,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR_NULL);
	
	x0 = mPosX - mSize;
	x1 = mPosX + mSize;
	y0 = mPosY - mSize;
	y1 = mPosY + mSize;
	w  = 1.0f / WK7_SCREEN_WIDTH;
	h  = 1.0f / WK7_SCREEN_HEIGHT;
	s0 = x0 * w;
	t0 = y0 * h;
	s1 = x1 * w;
	t1 = y1 * h;
	
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
	
		GXPosition3f32(x0,y0,z);
		GXTexCoord2f32(0.0f,0.0f);
		GXTexCoord2f32(s0,t0);
		
		GXPosition3f32(x1,y0,z);
		GXTexCoord2f32(1.0f,0.0f);
		GXTexCoord2f32(s1,t0);
		
		GXPosition3f32(x1,y1,z);
		GXTexCoord2f32(1.0f,1.0f);
		GXTexCoord2f32(s1,t1);
		
		GXPosition3f32(x0,y1,z);
		GXTexCoord2f32(0.0f,1.0f);
		GXTexCoord2f32(s0,t1);
		
	GXEnd();
	
//	GXSetNumChans     (1);
//	GXSetChanCtrl     (GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
//	GXSetChanMatColor (GX_COLOR0A0,mCrossColor);
	GXSetBlendMode    (GX_BM_NONE,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	
	GXClearVtxDesc    ();
	GXSetVtxDesc      (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc      (GX_VA_TEX0,GX_DIRECT);
	
	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
//	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_CLR0,GX_CLR_RGBA,GX_RGBA8,0);
	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	
//	GXSetNumTexGens   (0);
	
//	GXSetNumTevStages (1);
//	
//	GXSetTevColorIn   (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_RASC);
//	GXSetTevColorOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
//	GXSetTevAlphaOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
//	GXSetTevOrder     (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
	
	GXSetNumTexGens   (1);
	GXSetTexCoordGen  (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	
	GXSetNumTevStages (2);
	
	GXSetTevKAlphaSel (GX_TEVSTAGE0,GX_TEV_KASEL_1);
	GXSetTevColorIn   (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO);
	GXSetTevColorOp   (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_A2  ,GX_CA_KONST,GX_CA_ZERO);
//	GXSetTevAlphaIn   (GX_TEVSTAGE0,GX_CA_TEXA,GX_CA_ZERO,GX_CA_KONST,GX_CA_ZERO);
	GXSetTevAlphaOp   (GX_TEVSTAGE0,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder     (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP1,GX_COLOR_NULL);
	
	GXSetTevColorIn   (GX_TEVSTAGE1,GX_CC_C0,GX_CC_C1,GX_CC_APREV,GX_CC_ZERO);
	GXSetTevColorOp   (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn   (GX_TEVSTAGE1,GX_CA_A1,GX_CA_A0,GX_CA_APREV,GX_CA_ZERO);
	GXSetTevAlphaOp   (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder     (GX_TEVSTAGE1,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR_NULL);
	
	f32		sc,tc;
	
	x0 = mPosX - mCrossSize;
	x1 = mPosX + mCrossSize;
	y0 = mPosY - mCrossSize;
	y1 = mPosY + mCrossSize;
	s0 = x0 * w;
	t0 = y0 * h;
	s1 = x1 * w;
	t1 = y1 * h;
	sc = (s0 + s1) * 0.5f;
	tc = (t0 + t1) * 0.5f;
	
	GXSetLineWidth(mCrossWidth,GX_TO_ZERO);
	
	GXBegin(GX_LINES,GX_VTXFMT0,4);
	
		GXPosition3f32(mPosX,y0,z);
		GXTexCoord2f32(sc,t0);
		GXPosition3f32(mPosX,y1,z);
		GXTexCoord2f32(sc,t1);
		GXPosition3f32(x0,mPosY,z);
		GXTexCoord2f32(s0,tc);
		GXPosition3f32(x1,mPosY,z);
		GXTexCoord2f32(s1,tc);
		
	GXEnd();
	
	return true;
}

void WK7Sight::SetPosition(f32 x,f32 y)
{
	if ( (x > K7APP_SCREEN_WIDTH) || (x < 0.f) )  x = K7APP_SCREEN_WIDTH/2;
	if ( (y > K7APP_SCREEN_HEIGHT) || (y < 0.f) ) y = K7APP_SCREEN_HEIGHT/2;
	mPosX = x;
	mPosY = y;
}

void WK7Sight::GetPosition(f32 &x,f32 &y)
{
	x = mPosX;
	y = mPosY;
}

bool WK7Sight::IsValidPeekData(void)
{
	WK7SightPeekData	*pPeekData = mPeekData + mPeekIndex;
	return pPeekData->State? true : false;
}

u32 WK7Sight::GetPeekARGB(void)
{
	WK7SightPeekData	*pPeekData = mPeekData + mPeekIndex;
	return pPeekData->ARGB;
}

u32 WK7Sight::GetPeekZ(void)
{
	WK7SightPeekData	*pPeekData = mPeekData + mPeekIndex;
	return pPeekData->Z;
}

f32 WK7Sight::GetPeekDist(void)
{
	WK7SightPeekData	*pPeekData = mPeekData + mPeekIndex;
	HSD_CObj			*pCObj     = WK7CAM->GetCObj();
	if( pCObj==NULL ){
		return 0.0f;
	}
	f32				n  = HSD_CObjGetNear(pCObj);
	f32				f  = HSD_CObjGetFar (pCObj);
	f32				zs = (f32)pPeekData->Z;
	f32				z;
	
//static	const f32		zo = 1.0f;
//	z = ((zo / (f-n)) + (f * n / (f-n))) / zo + 1.0f;
	
	zs *= (1.0f / (f32)GX_MAX_Z24);
	z = n / f;
	z = (1.0f - z) * (zs - 1.0f) - z;
	z = - n / z;
	
	return z;
}

bool WK7Sight::ScreenToCamCoord(f32 &x,f32 &y,f32 &z)
{
	HSD_CObj			*pCObj = WK7CAM->GetCObj();
	
	if( pCObj==NULL ){
		return false;
	}
	
	f32				n      = HSD_CObjGetNear  (pCObj);
	f32				f      = HSD_CObjGetFar   (pCObj);
	f32				fovy_2 = HSD_CObjGetFov   (pCObj) * (PI / (2.0f * 180.0f));
	f32				aspect = HSD_CObjGetAspect(pCObj);
	f32				tan_fovy_2 = tanf(fovy_2);
	
	z   = GetPeekDist();
	x   = z * tan_fovy_2 * aspect * (x - (WK7_SCREEN_WIDTH *0.5f)) / (WK7_SCREEN_WIDTH *0.5f);
	y   = z * tan_fovy_2          * (y - (WK7_SCREEN_HEIGHT*0.5f)) / (WK7_SCREEN_HEIGHT*0.5f);
	
	return true;
}

