////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Sprite (mK7Sprite Ɋ)
//
// WK7Sprite.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 05/28/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7SPRITE_CPP__

#include ".\WK7Sprite.h"

WK7Sprite::WK7Sprite(int prio) : mK7Sprite(prio)
{
}

WK7Sprite::~WK7Sprite()
{
}

WK7SpriteT2::WK7SpriteT2(int prio) : WK7Sprite(prio)
{
	mppTex[0] = 
	mppTex[1] = NULL;
	mTevFunc  = SetTevTC0TA1;
	mVtxFunc  = SetVtxTC0TA1;
}

WK7SpriteT2::~WK7SpriteT2()
{
}

void WK7SpriteT2::SetVtxTC0TA1(void)
{
	GXClearVtxDesc ();
	GXSetVtxDesc   (GX_VA_POS, GX_DIRECT);
	GXSetVtxDesc   (GX_VA_CLR0,GX_DIRECT);
	GXSetVtxDesc   (GX_VA_TEX0,GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_POS ,GX_POS_XY  ,GX_F32  ,0);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_CLR0,GX_CLR_RGBA,GX_RGBA8,0);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
}

void WK7SpriteT2::SetTevTC0TA1(void)
{
	GXSetAlphaCompare(GX_ALWAYS,0,GX_AOP_OR,GX_ALWAYS,0);
	GXSetBlendMode   (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetNumTexGens  (1);
	GXSetTexCoordGen (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	GXSetNumTevStages(2);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXC,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ONE);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_ZERO,GX_CA_RASA,GX_CA_TEXA,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevOrder    (GX_TEVSTAGE1,GX_TEXCOORD0,GX_TEXMAP1,GX_COLOR0A0);
}

void WK7SpriteT2::mCallRenderProc(void)
{
	if( mppTex[0]==NULL || mppTex[1]==NULL ){
		return;
	}
	if(	mK7Sprite::mOldTex!=mppTex[0] ){
		GXLoadTexObj(&mppTex[0]->obj,GX_TEXMAP0);
		mK7Sprite::mOldTex = mppTex[0];
	}
	GXLoadTexObj(&mppTex[1]->obj,GX_TEXMAP1);
	
	f32		xRate, yRate,s0,t0,s1,t1,s2,t2,s3,t3;
	
	//x1`x3,y1`y3߂
	mX1 = mX3 = mX0 + (f32)mW;
	mX2 = mX0;
	mY1 = mY0;
	mY2 = mY3 = mY0 + (f32)mH;
	
	//uvl߂邽߂̌vZ
	xRate = 1.0f / (f32)mppTex[0]->tex->mWidth;
	yRate = 1.0f / (f32)mppTex[0]->tex->mHeight;
	s0    = xRate * (f32)mU0;
	t0    = yRate * (f32)mV0;
	s1    = xRate * (f32)mU1;
	t1    = yRate * (f32)mV1;
	s2    = xRate * (f32)mU2;
	t2    = yRate * (f32)mV2;
	s3    = xRate * (f32)mU3;
	t3    = yRate * (f32)mV3;
	
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
		
		GXPosition2f32(mX0,mY0);
		GXColor1u32   (mRgba0);
		GXTexCoord2f32(s0,t0);
		
		GXPosition2f32(mX1,mY1);
		GXColor1u32   (mRgba1);
		GXTexCoord2f32(s1,t1);
		
		GXPosition2f32(mX2,mY2);
		GXColor1u32   (mRgba2);
		GXTexCoord2f32(s2,t2);
		
		GXPosition2f32(mX3,mY3);
		GXColor1u32   (mRgba3);
		GXTexCoord2f32(s3,t3);
		
	GXEnd();
	
}

