////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Stage Object
//
// WK7Stage.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7STAGE_H__
#define	__WK7STAGE_H__

//#include <sysdolphin\baselib.h>
//#include "..\Lib\ghmGcDefine.h"
//#include ".\WK7Archive.h"
//#include ".\WK7AreaInfo.h"
#include ".\WK7Obj.h"
#include ".\WK7Path.h"
#include ".\WK7Light.h"
#include ".\WK7HitObj.h"
#if FUJITA
//#include "..\Fujita\c_trigon.h"
//#include "..\Fujita\c_coll.h"
//#include "..\Fujita\c_border.h"
#endif
//#include ".\WK7Zan.h"
//#include ".\WK7DeadBodySign.h"
#include "vector.h"
#include "..\Matsu\se\seSystem.h"
#include "..\..\Matsu\mK7Sprite.h"
#include "..\Yam\YK7StageTitle.h"
#include "..\Wat\K7GlobalFlag.h"

class WK7Stage;
class WK7DeadBodySign;
class C_TrigonArray;
class C_Coll;
class C_Border;
class WK7HitObj;
class WK7HitObjJObj;
class C_SetAlpha;
struct WK7CamSet;

extern	bool IsValidAll(WK7PathBranchPointObj *pBranchPointObj);
extern	bool IsValidAll(WK7PathBranch *pBranch);
extern	bool IsValidAll(WK7PathBranchPoint *pBranchPoint);
extern	bool IsValidAll(WK7PathNurbs *pPath);

#define	WK7STAGE_GALSTAGEID				K7STGID(120,0)
#define	WK7STAGE_GALSTAGE_ENTER_BPNAME	"door_990000"

#define	WK7STAGE_TVSTAGE_PREFIX			"STGTV"
#define	WK7STAGE_TVSTAGEID				K7STGID(121,0)
#define	WK7STAGE_TVSTAGEID_REAL			WK7STAGE_TVSTAGEID
//#define	WK7STAGE_TVSTAGEID				(0xffffffff)
//#define	WK7STAGE_TVSTAGEID_REAL			K7STGID(121,0)
#define	WK7STAGE_TVSTAGE_BPNAME			"door_990001"
#define	WK7STAGE_TVSTAGE_SAVELETTER		'S'
#define	WK7STAGE_TVSTAGE_SAVEPARAM		(0x80000000)
#define	WK7STAGE_TVSTAGE_PARAMMASK		(0x7fffffff)
#define	WK7STAGE_GMSTAGE_PREFIX			"STGGM"
#define	WK7STAGE_GMSTAGEID				K7STGID(578,0)
#define	WK7STAGE_GMSTAGE_BPNAME_BASE	"door_98000"
#define	WK7STAGE_GMSTAGE_BPNAME(id)		WK7STAGE_GMSTAGE_BPNAME_BASE #id

#define	WK7STAGE_STGBPARRIVE_DEFMOVE_PREFIX		"jump"
#define	WK7STAGE_STGBPARRIVE_DEFPLAY_PREFIX		"play"
#define	WK7STAGE_STGBPARRIVE_PLAY_PREFIX		"play"
#define	WK7STAGE_STGBPARRIVE_DEFMOVE2_PREFIX	"branch"
#define	WK7STAGE_STGBPARRIVE_TV_PREFIX			"tv"
#define	WK7STAGE_STGBPARRIVE_LTV_PREFIX			"ltv"
#define	WK7STAGE_STGBPARRIVE_EVPOINT_PREFIX		"event"
#define	WK7STAGE_STGBPARRIVE_DOOR_PREFIX		"door"
#define	WK7STAGE_STGBPARRIVE_MAP_PREFIX			"map"
#define	WK7STAGE_STGBPARRIVE_KEY_PREFIX			"key"
#define	WK7STAGE_STGBPARRIVE_MEMO_PREFIX		"memo"
#define	WK7STAGE_STGBPARRIVE_VMEMO_PREFIX		"voicem"
#define	WK7STAGE_STGBPARRIVE_RAKU_PREFIX		"rakum"
#define	WK7STAGE_STGBPARRIVE_ZAN_PREFIX			"zan"
#define	WK7STAGE_STGBPARRIVE_TAMA_PREFIX		"tama"

#define	K7STGID_INVALID				(0xffffffff)

class WK7StageBpEventBase{
protected:
	char								*mpBpName;
public:
	WK7StageBpEventBase(){ mpBpName = NULL; }
	virtual ~WK7StageBpEventBase(){ GHM_SAFE_DELETE_ARRAY(mpBpName); }
	
	bool SetBpName(const char *pBpName);
	inline const char* GetBpName(void){ return mpBpName; }
};

#define	WK7STAGEBPARRIVEEVENT_PARSE_ERROR	((const char *)0xffffffff)
class WK7StageBpEventJumpNextStage{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventJump;
protected:
	u32									mStageID;
	char								*mpBpName;
	WK7StageBpEventJumpNextStage		*mpPrev;
	WK7StageBpEventJumpNextStage		*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase=NULL);
public:
	WK7StageBpEventJumpNextStage(WK7StageBpEventJumpNextStage *pPrev);
	virtual ~WK7StageBpEventJumpNextStage();
	
	WK7StageBpEventJumpNextStage* GetPrev(void){ return mpPrev; }
	WK7StageBpEventJumpNextStage* GetNext(void){ return mpNext; }
	
	inline u32 GetStageID(void){ return mStageID; }
	inline const char* GetBpName(void){ return mpBpName; }
};

class WK7StageBpEventJump : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventJumpNextStage	*mpStage;
	const char* ParseBpName(const char *pBpName);
public:
	WK7StageBpEventJump();
	virtual ~WK7StageBpEventJump();
	inline WK7StageBpEventJumpNextStage* GetStageTop(void){ return mpStage; }
};

class WK7StageBpEventPlay : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventPlayPoint;
protected:
	u32									mEventNo;
//	char								*mpBpName;
	char								*mpSelectObjName;
	WK7StageBpEventPlay					*mpPrev;
	WK7StageBpEventPlay					*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pPlayBpName);
public:
	WK7StageBpEventPlay(WK7StageBpEventPlay *pPrev);
	virtual ~WK7StageBpEventPlay();
	WK7StageBpEventPlay* GetPrev(void){ return mpPrev; }
	WK7StageBpEventPlay* GetNext(void){ return mpNext; }
	u32 GetEventNo(void){ return mEventNo; }
//	inline const char* GetBpName(void){ return mpBpName; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
};

class WK7StageBpEventPlayPoint : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventPlay					*mpPlay;
	const char* ParseBpName(const char *pBpName,const char *pPlayBpName=NULL);
public:
	WK7StageBpEventPlayPoint();
	virtual ~WK7StageBpEventPlayPoint();
	
	inline WK7StageBpEventPlay* GetPlayTop(void){ return mpPlay; }
};

class WK7StageBpEventZan : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventZanPoint;
protected:
	u32									mEventNo;
	char								*mpSelectObjName;
	WK7StageBpEventZan					*mpPrev;
	WK7StageBpEventZan					*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pZanBpName);
public:
	WK7StageBpEventZan(WK7StageBpEventZan *pPrev);
	virtual ~WK7StageBpEventZan();
	WK7StageBpEventZan* GetPrev(void){ return mpPrev; }
	WK7StageBpEventZan* GetNext(void){ return mpNext; }
	u32 GetEventNo(void){ return mEventNo; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
};

class WK7StageBpEventZanPoint : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventZan					*mpZan;
	const char* ParseBpName(const char *pBpName,const char *pZanBpName=NULL);
public:
	WK7StageBpEventZanPoint();
	virtual ~WK7StageBpEventZanPoint();
	
	inline WK7StageBpEventZan* GetZanTop(void){ return mpZan; }
};

class WK7StageBpEventBranchNextStage{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventBranch;
protected:
	u32									mStageID;
	u32									mParam;
	char								*mpSelectObjName;
	char								*mpBpName;
	WK7StageBpEventBranchNextStage		*mpPrev;
	WK7StageBpEventBranchNextStage		*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pBranchBpName);
public:
	WK7StageBpEventBranchNextStage(WK7StageBpEventBranchNextStage *pPrev);
	virtual ~WK7StageBpEventBranchNextStage();
	
	WK7StageBpEventBranchNextStage* GetPrev(void){ return mpPrev; }
	WK7StageBpEventBranchNextStage* GetNext(void){ return mpNext; }
	
	inline u32 GetParam(void){ return mParam; }
	inline u32 GetStageID(void){ return mStageID; }
	inline const char* GetBpName(void){ return mpBpName; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
};

class WK7StageBpEventBranch : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventBranchNextStage		*mpStage;
	const char* ParseBpName(const char *pBpName,const char *pBranchBpName=NULL);
public:
	WK7StageBpEventBranch();
	virtual ~WK7StageBpEventBranch();
	
	inline WK7StageBpEventBranchNextStage* GetStageTop(void){ return mpStage; }
};

class WK7StageBpEventDoorNextStage{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventDoor;
protected:
	u32									mStageID;
	u32									mParam;
	u32									mEventNo;
	char								*mpSelectObjName;
	char								*mpBpName;
	WK7StageBpEventDoorNextStage		*mpPrev;
	WK7StageBpEventDoorNextStage		*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pDoorBpName);
public:
	WK7StageBpEventDoorNextStage(WK7StageBpEventDoorNextStage *pPrev);
	virtual ~WK7StageBpEventDoorNextStage();
	
	WK7StageBpEventDoorNextStage* GetPrev(void){ return mpPrev; }
	WK7StageBpEventDoorNextStage* GetNext(void){ return mpNext; }
	
	inline u32 GetStageID(void){ return mStageID; }
	inline u32 GetEventNo(void){ return mEventNo; }
	inline u32 GetParam(void){ return mParam; }
	inline const char* GetBpName(void){ return mpBpName; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
};

class WK7StageBpEventDoor : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventDoorNextStage		*mpStage;
	const char* ParseBpName(const char *pBpName,const char *pDoorBpName=NULL);
public:
	WK7StageBpEventDoor();
	virtual ~WK7StageBpEventDoor();
	
	inline WK7StageBpEventDoorNextStage* GetStageTop(void){ return mpStage; }
};

class WK7StageBpEventTv : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	char								*mpSelectObjName;
	char								*mpScreenObjName;
	const char* ParseBpName(const char *pBpName);
public:
	WK7StageBpEventTv();
	virtual ~WK7StageBpEventTv();
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
	inline const char* GetScreenObjName(void){ return mpScreenObjName; }
};

class WK7StageBpEventLtv : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	char								*mpSelectObjName;
	char								*mpScreenObjName;
	const char* ParseBpName(const char *pBpName);
public:
	WK7StageBpEventLtv();
	virtual ~WK7StageBpEventLtv();
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
	inline const char* GetScreenObjName(void){ return mpScreenObjName; }
};

class WK7StageBpEventPointObj{
	friend class WK7StageBpEvent;
	friend class WK7StageBpEventPoint;
protected:
	u32									mEventNo;
	char								*mpSelectObjName;
	char								*mpBpName;
	WK7StageBpEventPointObj				*mpPrev;
	WK7StageBpEventPointObj				*mpNext;
	const char* ParseBpName(const char *pBpName,WK7StageBpEventBase *pBase,const char *pBranchBpName);
public:
	WK7StageBpEventPointObj(WK7StageBpEventPointObj *pPrev);
	virtual ~WK7StageBpEventPointObj();
	
	WK7StageBpEventPointObj* GetPrev(void){ return mpPrev; }
	WK7StageBpEventPointObj* GetNext(void){ return mpNext; }
	
	inline u32 GetEventNo(void){ return mEventNo; }
	inline const char* GetBpName(void){ return mpBpName; }
	inline const char* GetSelectObjName(void){ return mpSelectObjName; }
};

class WK7StageBpEventPoint : public WK7StageBpEventBase{
	friend class WK7StageBpEvent;
protected:
	WK7StageBpEventPointObj				*mpObj;
	const char* ParseBpName(const char *pBpName,const char *pBranchBpName=NULL);
public:
	WK7StageBpEventPoint();
	virtual ~WK7StageBpEventPoint();
	
	virtual u32 GetType(void);
	
	inline WK7StageBpEventPointObj* GetObjTop(void){ return mpObj; }
};

class WK7StageBpEventMap : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventMap();
	virtual ~WK7StageBpEventMap();
	virtual u32 GetType(void);
};

class WK7StageBpEventKey : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventKey();
	virtual ~WK7StageBpEventKey();
	virtual u32 GetType(void);
};

class WK7StageBpEventMemo : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventMemo();
	virtual ~WK7StageBpEventMemo();
	virtual u32 GetType(void);
};

class WK7StageBpEventVoiceMemo : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventVoiceMemo();
	virtual ~WK7StageBpEventVoiceMemo();
	virtual u32 GetType(void);
};

class WK7StageBpEventRaku : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventRaku();
	virtual ~WK7StageBpEventRaku();
	virtual u32 GetType(void);
};

class WK7StageBpEventTama : public WK7StageBpEventPoint
{
public:
	WK7StageBpEventTama();
	virtual ~WK7StageBpEventTama();
	virtual u32 GetType(void);
};

class WK7StageBpEvent{
protected:
	WK7StageBpEventJump			*mpJump;
	WK7StageBpEventPlayPoint	*mpPlayPoint;
	WK7StageBpEventZanPoint		*mpZanPoint;
	WK7StageBpEventBranch		*mpBranch;
	WK7StageBpEventTv			*mpTv;
	WK7StageBpEventLtv			*mpLtv;
	WK7StageBpEventPoint		*mpPoint;
	WK7StageBpEventDoor			*mpDoor;
	WK7StageBpEventMap			*mpMap;
	WK7StageBpEventKey			*mpKey;
	WK7StageBpEventMemo			*mpMemo;
	WK7StageBpEventVoiceMemo	*mpVoiceMemo;
	WK7StageBpEventRaku			*mpRaku;
	WK7StageBpEventTama			*mpTama;
	char						*mpBpName;
public:
	WK7StageBpEvent(const char *pBpName);
	~WK7StageBpEvent();
	
	bool SearchBpName(const char *pBpName);
	
	inline WK7StageBpEventJump* GetJump(void){ return mpJump; }
	inline WK7StageBpEventPlayPoint* GetPlayPoint(void){ return mpPlayPoint; }
	inline WK7StageBpEventZanPoint* GetZanPoint(void){ return mpZanPoint; }
	inline WK7StageBpEventBranch* GetBranch(void){ return mpBranch; }
	inline WK7StageBpEventTv* GetTv(void){ return mpTv; }
	inline WK7StageBpEventLtv* GetLtv(void){ return mpLtv; }
	inline WK7StageBpEventPoint* GetPoint(void){ return mpPoint; }
	inline WK7StageBpEventDoor* GetDoor(void){ return mpDoor; }
	inline WK7StageBpEventMap* GetMap(void){ return mpMap; }
	inline WK7StageBpEventKey* GetKey(void){ return mpKey; }
	inline WK7StageBpEventMemo* GetMemo(void){ return mpMemo; }
	inline WK7StageBpEventVoiceMemo* GetVoiceMemo(void){ return mpVoiceMemo; }
	inline WK7StageBpEventRaku* GetRaku(void){ return mpRaku; }
	inline WK7StageBpEventTama* GetTama(void){ return mpTama; }
	inline const char* GetBpName(void){ return mpBpName; }
	const char* GetShortBpName(void);
};

struct WK7EventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

#define	WK7DOOREVENT_BPNAME_MAX		(256)
struct WK7DoorEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	u32							mCurrStageID;
	u32							mNextStageID;
	u32							mParam;
	char						mNextBpName[WK7DOOREVENT_BPNAME_MAX];
	WK7StageBpEvent				*mpBpEvent;
	bool						mCinemaScopeClear;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo     = 0xffffffff;
		mCurrStageID = 0xffffffff;
		mNextStageID = 0xffffffff;
		mParam       = 0;
		memset(mNextBpName,0,WK7DOOREVENT_BPNAME_MAX);
		mpSelectObj  = NULL;
		mpBpEvent    = NULL;
		mCinemaScopeClear = false;
	}
	bool SetNextBpName(const char *pName){
		if( pName==NULL ){
			return false;
		}
		strncpy(mNextBpName,pName,WK7DOOREVENT_BPNAME_MAX-1);
		return true;
	}
	inline void SetCinemaScopeClear(bool flag){ mCinemaScopeClear = flag; }
	inline bool GetCinemaScopeClear(void){ return mCinemaScopeClear; }
};

struct WK7KeyEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

struct WK7MapEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

struct WK7MemoEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

struct WK7VoiceMemoEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

struct WK7RakuEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};
typedef	WK7RakuEventInfo	WK7RakuMemoEventInfo;

struct WK7ZanEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
	WK7PathBranchPoint			*mpBranchPoint;
public:
	u32							mEventNo;
	WK7Stage					*mpStage;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void SetBranchPoint(WK7PathBranchPoint* pBranchPoint){ mpBranchPoint=pBranchPoint; }
	WK7PathBranchPoint* GetBranchPoint(void){
		if( IsValidAll(mpBranchPoint)==false ){
			return NULL;
		}
		return mpBranchPoint;
	}
	void Initialize(void){
		mEventNo      = 0xffffffff;
		mpSelectObj   = NULL;
		mpBranchPoint = NULL;
		mpStage       = NULL;
	}
};

struct WK7TamaEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mEventNo    = 0xffffffff;
		mpSelectObj = NULL;
	}
};

struct WK7PlayEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
	WK7PathBranchPoint			*mpBranchPoint;
public:
	u32							mEventNo;
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void SetBranchPoint(WK7PathBranchPoint* pBranchPoint){ mpBranchPoint=pBranchPoint; }
	WK7PathBranchPoint* GetBranchPoint(void){
		if( IsValidAll(mpBranchPoint)==false ){
			return NULL;
		}
		return mpBranchPoint;
	}
	void Initialize(void){
		mEventNo      = 0xffffffff;
		mpSelectObj   = NULL;
		mpBranchPoint = NULL;
	}
};

struct WK7BpInfo{
private:
	WK7PathBranchPoint			*mpBranchPoint;
	WK7PathNurbs				*mpCurrentPath;
	WK7PathNurbs				*mpNextPath;
public:
	void SetCurrentPath(WK7PathNurbs *pPath){ mpCurrentPath=pPath; }
	WK7PathNurbs* GetCurrentPath(void){
		if( IsValidAll(mpCurrentPath)==false ){
			return NULL;
		}
		return mpCurrentPath;
	}
	void SetNextPath(WK7PathNurbs *pPath){ mpNextPath=pPath; }
	WK7PathNurbs* GetNextPath(void){
		if( IsValidAll(mpNextPath)==false ){
			return NULL;
		}
		return mpNextPath;
	}
	void SetBranchPoint(WK7PathBranchPoint* pBranchPoint){ mpBranchPoint=pBranchPoint; }
	WK7PathBranchPoint* GetBranchPoint(void){
		if( IsValidAll(mpBranchPoint)==false ){
			return NULL;
		}
		return mpBranchPoint;
	}
	void Initialize(void){
		mpBranchPoint = NULL;
		mpCurrentPath = NULL;
		mpNextPath    = NULL;
	}
	const char* GetBranchPointName(void);
	const char* GetCurrentPathName(void);
	const char* GetNextPathName(void);
	bool IsBranchPointName(const char *pName);
	bool IsCurrentPathName(const char *pName);
	bool IsNextPathName(const char *pName);
};

struct WK7PathTurnInfo{
private:
public:
	void Initialize(void){}
};

struct WK7PathChangeInfo{
private:
	WK7PathNurbs				*mpPath;
public:
	const char					*mpPathName;
	int							mInvPath;
	void SetPath(WK7PathNurbs *pPath){ mpPath=pPath; }
	WK7PathNurbs* GetPath(void){
		if( IsValidAll(mpPath)==false ){
			return NULL;
		}
		return mpPath;
	}
	void Initialize(void){
		mpPathName         = NULL;
		mpPath             = NULL;
		mInvPath           = 0;
	}
	int CompareList(const char **ppPathList);
};

struct WK7PrePathChangeInfo{
private:
	WK7PathNurbs				*mpCurrPath;
	WK7PathNurbs				*mpNextPath;
public:
	const char					*mpCurrPathName;
	const char					*mpNextPathName;
	int							mInvPath;
	void SetCurrPath(WK7PathNurbs *pPath){ mpCurrPath=pPath; }
	void SetNextPath(WK7PathNurbs *pPath){ mpNextPath=pPath; }
	WK7PathNurbs* GetCurrPath(void){
		if( IsValidAll(mpCurrPath)==false ){
			return NULL;
		}
		return mpCurrPath;
	}
	WK7PathNurbs* GetNextPath(void){
		if( IsValidAll(mpNextPath)==false ){
			return NULL;
		}
		return mpNextPath;
	}
	void Initialize(void){
		mpCurrPathName     = NULL;
		mpCurrPath         = NULL;
		mpNextPathName     = NULL;
		mpNextPath         = NULL;
		mInvPath           = 0;
	}
	int CompareListC(const char **ppPathList);
	int CompareListN(const char **ppPathList);
};

struct WK7HitObjInfo{
private:
	WK7HitObj					*mpHitObj;
public:
	WK7JObj						*mpJObj;
	u32							mEventNo;
	WK7HitObjInfoType			mTypeID;
	
	// ǉ
	s16							mSightPx;
	s16							mSightPy;
	Vec							mHitPos;
	
	bool SetHitObj(WK7HitObj *pHitObj);
	bool SetHitObjEnable(bool flag);
	bool GetHitObjEnable(void);
	bool IsValidHitObj(void);
	
	void Initialize(void){
		mpHitObj = NULL;
		mEventNo = 0xffffffff;
		mpJObj   = NULL;
		mSightPx = 0;
		mSightPy = 0;
		mHitPos.x = 0.f;
		mHitPos.y = 0.f;
		mHitPos.z = 0.f;
	}
};

typedef	WK7HitObjInfo		WK7HanaEventInfo;

class WK7Npc;
struct WK7DieNpcInfo{
	WK7Npc						*mpNpc;
	void Initialize(void){
		mpNpc = NULL;
	}
};

enum WK7AttackinfoType{
	WK7ATTACKINFO_TYPE_NORMALSHOT = 0,				// ʂ̎ˌ
	WK7ATTACKINFO_TYPE_DANCHARGE,					// _̃^E`
	WK7ATTACKINFO_TYPE_KVNCHARGE,					// Pr̃^E`
};
struct WK7AttackInfo{
	u32							mID;
	s16							mScreenX,mScreenY;
	u32							mScreenZ;
	Vec							mHitPos;
	u32							mARGB;
	u32							mEnemyID;
	WK7AttackinfoType			mTypeID;
	void Initialize(void){
		mID       = 0xffffffff;
		mARGB     = 0xffffffff;
		mHitPos.x = 
		mHitPos.y = 
		mHitPos.z = 0.0f;
		mScreenX  = -1;
		mScreenY  = -1;
		mScreenZ  = 0xffffffff;
		mEnemyID  = 0xffffffff;
	}
};

struct WK7SpAttackInfo{
	u32							mID;
	s16							mScreenX,mScreenY;
	u32							mScreenZ;
	Vec							mHitPos;
	u32							mARGB;
	u32							mEnemyID;
	void Initialize(void){
		mID       = 0xffffffff;
		mARGB     = 0xffffffff;
		mHitPos.x = 
		mHitPos.y = 
		mHitPos.z = 0.0f;
		mScreenX  = -1;
		mScreenY  = -1;
		mScreenZ  = 0xffffffff;
		mEnemyID  = 0xffffffff;
	}
};

struct WK7SpAbilityInfo{
	u32							mCharaID;
	u32							mAbilityID;
	u32							mType;
	void Initialize(void){
		mCharaID   = 0xffffffff;
		mAbilityID = 0xffffffff;
		mType      = 0xffffffff;
	}
};

struct WK7TvEventInfo{
private:
	WK7PathBranchPointObjJObj	*mpSelectObj;
	u32							mStageID;
	u32							mParam;
public:
	void SetStageID(u32 stgid){ mStageID=stgid; }
	u32 GetStageID(void){ return mStageID; }
	void SetParam(u32 stgid){ mParam=stgid; }
	u32 GetParam(void){ return mParam; }
	bool SetSelectObjEnable(bool flag){
		if( IsValidAll(mpSelectObj)==false ){
			return false;
		}
		mpSelectObj->SetEnable(flag);
		return true;
	}
	void ClearSelectObj(void){ mpSelectObj=NULL; }
	void SetSelectObj(WK7PathBranchPointObjJObj *pSelectObj){ mpSelectObj=pSelectObj; }
	WK7PathBranchPointObjJObj* GetSelectObj(void){
		if( IsValidAll(mpSelectObj)==false ){
			return NULL;
		}
		return mpSelectObj;
	}
	void Initialize(void){
		mpSelectObj = NULL;
	}
};

struct WK7CharaChangeInfo{
	u32							mCurrCharaID;
	u32							mPrevCharaID;
	void Initialize(void){
		mCurrCharaID = 0xffffffff;
		mPrevCharaID = 0xffffffff;
	}
};


struct WK7StagePlaceInfo{
	u32				mID;
	char			*mpPathName;
	char			*mpName[4];
	Vec				mCamPos,mCamTgt;
};

#define	WK7STGPLINF_START()					WK7StagePlaceInfo	stagePlaceInfo[] = {
#define	WK7STGPLINF_DEF(mid,pfx,n0,n3)		{ K7STGID((mid),(pfx)),NULL,{(n0),NULL,NULL,(n3)},{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f}},
#define	WK7STGPLINF(mid,pfx,n0,n3,pn)		{ K7STGID((mid),(pfx)),(pn),{(n0),NULL,NULL,(n3)},{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f}},
#define	WK7STGPLINF_CAM(mid,pfx,n0,n3,pn,ex,ey,ez,tx,ty,tz)	\
											{ K7STGID((mid),(pfx)),(pn),{(n0),NULL,NULL,(n3)},{(ex),(ey),(ez)},{(tx),(ty),(tz)}},
#define	WK7STGPLINF_END()					{ 0xffffffff,NULL,{"New Stage",NULL,NULL,"ƭ ð"},{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f}}};

struct WK7StageDoorInfo{
	int				mScenarioID;
	u32				mFromID;
	char			*mpBpName;
	u32				mToID;
	char			*mpToBpName;
	int				mOpenSeID;
	int				mCloseSeID;
};

#define	WK7STGDRINF_START()											WK7StageDoorInfo	stageDoorInfo[] = {
#define	WK7STGDRINF_DEF(mid,pfx,se)										{ -1,K7STGID((mid),(pfx)),NULL,0xffffffff,NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINF(mid,pfx,tomid,topfx,se)								{ -1,K7STGID((mid),(pfx)),NULL,K7STGID((tomid),(topfx)),NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINF_BP(mid,pfx,bp,tomid,topfx,se)						{ -1,K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINF_BP2BP(mid,pfx,bp,tomid,topfx,tobp,se)				{ -1,K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),(tobp),(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINFS_DEF(sc,mid,pfx,se)									{ (sc),K7STGID((mid),(pfx)),NULL,0xffffffff,NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINFS(sc,mid,pfx,tomid,topfx,se)							{ (sc),K7STGID((mid),(pfx)),NULL,K7STGID((tomid),(topfx)),NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINFS_BP(sc,mid,pfx,bp,tomid,topfx,se)					{ (sc),K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),NULL,(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINFS_BP2BP(sc,mid,pfx,bp,tomid,topfx,tobp,se)			{ (sc),K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),(tobp),(se),NOISE_SE_MAP_DEFAULT },
#define	WK7STGDRINF2_DEF(mid,pfx,seo,sec)								{ -1,K7STGID((mid),(pfx)),NULL,0xffffffff,NULL,(seo),(sec) },
#define	WK7STGDRINF2(mid,pfx,tomid,topfx,seo,sec)						{ -1,K7STGID((mid),(pfx)),NULL,K7STGID((tomid),(topfx)),NULL,(seo),(sec) },
#define	WK7STGDRINF2_BP(mid,pfx,bp,tomid,topfx,seo,sec)					{ -1,K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),NULL,(seo),(sec) },
#define	WK7STGDRINF2_BP2BP(mid,pfx,bp,tomid,topfx,tobp,seo,sec)			{ -1,K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),(tobp),(seo),(sec) },
#define	WK7STGDRINFS2_DEF(sc,mid,pfx,seo,sec)							{ (sc),K7STGID((mid),(pfx)),NULL,0xffffffff,NULL,(seo),(sec) },
#define	WK7STGDRINFS2(sc,mid,pfx,tomid,topfx,seo,sec)					{ (sc),K7STGID((mid),(pfx)),NULL,K7STGID((tomid),(topfx)),NULL,(seo),(sec) },
#define	WK7STGDRINFS2_BP(sc,mid,pfx,bp,tomid,topfx,seo,sec)				{ (sc),K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),NULL,(seo),(sec) },
#define	WK7STGDRINFS2_BP2BP(sc,mid,pfx,bp,tomid,topfx,tobp,seo,sec)		{ (sc),K7STGID((mid),(pfx)),(bp),K7STGID((tomid),(topfx)),(tobp),(seo),(sec) },
#define	WK7STGDRINF_END()												{ -1,0xffffffff,NULL,0xffffffff,NULL,NOISE_SE_MAP_DEFAULT,NOISE_SE_MAP_DEFAULT } \
																	};

struct WK7StageBpCamInfo{
	u32				mID;
	char			*mpPathName;
	f32				mFov;
	Vec				mCamPos,mCamTgt;
};

#define	WK7STGBPCAMINF_START()										WK7StageBpCamInfo	stageBpCamInfo[] = {
#define	WK7STGBPCAMINF(mid,pfx,pn,ex,ey,ez,tx,ty,tz)					{ K7STGID(mid,pfx),(pn),0.0f,{(ex),(ey),(ez)},{(tx),(ty),(tz)} },
#define	WK7STGBPCAMINF_FOV(mid,pfx,pn,ex,ey,ez,tx,ty,tz,fov)			{ K7STGID(mid,pfx),(pn),(fov),{(ex),(ey),(ez)},{(tx),(ty),(tz)} },
#define	WK7STGBPCAMINF_END()											{ 0xffffffff,NULL,0.0f,{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f} }, \
																	};

struct WK7StageHanaInfo{
	u16				mScenarioID;
	u16				mSeqID;
	u32				mID;
	u32				mItemID;
};

#define	WK7STGHANAINF_START()								WK7StageHanaInfo	stageHanaInfo[] = {
#define	WK7STGHANAINF(scn,mid,pfx,hanaid,chrid,seqid)			{ (scn),(seqid),K7STGID((mid),(pfx)),K7ITEMID((hanaid),(chrid)) },
#define	WK7STGHANAINF_END()									{ 0xffff,0xffff,0xffffffff,0xffffffff } };

#define	WK7STAGE_HANA_ITEMID_DEF							K7ITEMID(600,0)

struct WK7StageZanInfo{
	u32				mZanID;
	Vec				mCamPos,mCamTgt;
	f32				mCamTime;
	f32				mJudgeDistance;
};

#define	WK7STGZANINF_START()								WK7StageZanInfo	stageZanInfo[] = {
#define	WK7STGZANINF(zanid,px,py,pz,tx,ty,tz)					{ 0x##zanid,{(px),(py),(pz)},{(tx),(ty),(tz)},0.0f,-1.0f },
#define	WK7STGZANINF_TM(zanid,px,py,pz,tx,ty,tz,tm)				{ 0x##zanid,{(px),(py),(pz)},{(tx),(ty),(tz)},(tm),-1.0f },
#define	WK7STGZANINF_D(zanid,px,py,pz,tx,ty,tz,d)				{ 0x##zanid,{(px),(py),(pz)},{(tx),(ty),(tz)},0.0f,(d)   },
#define	WK7STGZANINF_TM_D(zanid,px,py,pz,tx,ty,tz,tm,d)			{ 0x##zanid,{(px),(py),(pz)},{(tx),(ty),(tz)},(tm),(d)   },
#define	WK7STGZANINF_END()									{ 0xffffffff,{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f},0.0f,-1.0f}, };

struct WK7StageTamaInfo{
	u32				mTamaID;
	Vec				mCamPos,mCamTgt;
};

#define	K7ZAN_COL_R											(1)
#define	K7ZAN_COL_G											(2)
#define	K7ZAN_COL_RG										(3)
#define	K7ZAN_COL_B											(4)
#define	K7ZAN_COL_RB										(5)
#define	K7ZAN_COL_GB										(6)
#define	K7ZAN_COL_RGB										(7)
struct WK7StageZanColChipInfo{
	u32				mZanID;
	int				mColorID;
	int				mFlagID;
};
//#define	WK7STGZAN_COLCHIP(zanid,col)						case	K7EVENTZANID(0x##zanid): color = (col); break;
#define	WK7STGZAN_COLCHIP(zanid,col,flag)					{ K7EVENTZANID(0x##zanid) , (col) , (flag) },

#define	WK7STGTAMAINF_START()								WK7StageTamaInfo	stageTamaInfo[] = {
#define	WK7STGTAMAINF(tamaid,px,py,pz,tx,ty,tz)					{ 0x##tamaid,{(px),(py),(pz)},{(tx),(ty),(tz)} },
#define	WK7STGTAMAINF_END()									{ 0xffffffff,{0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f} } };

struct WK7StageSoundInfo{
	u32				mID;
	int				mBgmID;
	int				mBgmVol;
	bool			mBgmFade;
	u16				mFootSE;
	u8				mDspRate;
	u8				pad;
};

#define	WK7STGSOUNDINF_START()									WK7StageSoundInfo	stageSoundInfo[] = {
#define	WK7STGSOUNDINF(mid,pfx,bgm,dsp)								{ K7STGID((mid),(pfx)),(bgm),-1   ,true  ,WK7PATH_FOOTSE_DEFAULT,(dsp),0 },
#define	WK7STGSOUNDINF_F(mid,pfx,bgm,dsp,fse)						{ K7STGID((mid),(pfx)),(bgm),-1   ,true  ,(fse)                 ,(dsp),0 },
#define	WK7STGSOUNDINF_VOLFADE(mid,pfx,bgm,dsp,vol,fade)			{ K7STGID((mid),(pfx)),(bgm),(vol),(fade),WK7PATH_FOOTSE_DEFAULT,(dsp),0 },
#define	WK7STGSOUNDINF_VOLFADE_F(mid,pfx,bgm,dsp,vol,fade,fse)		{ K7STGID((mid),(pfx)),(bgm),(vol),(fade),(fse)                 ,(dsp),0 },
#define	WK7STGSOUNDINF_END()									{ 0xffffffff,-1,0xff } };

struct WK7StageSpCond{
	u32				mID;
	u32				mType;
	int				mSpID;
	u32				mCharaMask;
	Vec				mPosition;
	f32				mRadius;
	const char		*mpPathName;
};

#define	WK7STGSPCOND_START()								WK7StageSpCond		stageSpCond[] = {
#define	WK7STGSPCOND(mid,pfx,spid,x,y,z,r)						{ K7STGID((mid),(pfx)),0,(spid),0xffffffff,{(x),(y),(z)},(r),NULL },
#define	WK7STGSPCOND_TYPE(mid,pfx,spid,x,y,z,r,type)			{ K7STGID((mid),(pfx)),(type),(spid),0xffffffff,{(x),(y),(z)},(r),NULL },
#define	WK7STGSPCONDP(mid,pfx,spid,pn)							{ K7STGID((mid),(pfx)),0,(spid),0xffffffff,{0.0f,0.0f,0.0f},-1.0f,(pn) },
#define	WK7STGSPCONDP_TYPE(mid,pfx,spid,pn,type)				{ K7STGID((mid),(pfx)),(type),(spid),0xffffffff,{0.0f,0.0f,0.0f},-1.0f,(pn) },
#define	WK7STGSPCOND_END()										{ 0xffffffff,0xffffffff,-1,0xffffffff,{0.0f,0.0f,0.0f},-1.0f,NULL } \
															};

struct WK7StageInfo{
	u32				mID;
	s8				mFlowID;
	s8				mAreaID;
	u16				mDefaultCamSet;
	u8				mHarmanRoomNum;
	u8				mSelectObjNum;
	u8				mSelectPathNum;
	u8				mMapNum;
	s8				mScenarioID;
	s8				mMultiNum;
	s8				mPad0;
	s8				mPad1;
};

#ifndef	__K7STAGE_CPP__
extern	WK7StagePlaceInfo	stagePlaceInfo[];
extern	WK7StageDoorInfo	stageDoorInfo [];
extern	WK7StageHanaInfo	stageHanaInfo [];
extern	WK7StageZanInfo		stageZanInfo  [];
extern	WK7StageTamaInfo	stageTamaInfo [];
extern	WK7StageInfo		stageList     [];
extern	WK7StageSoundInfo	stageSoundInfo[];
extern	WK7StageSpCond		stageSpCond   [];
extern	WK7StageBpCamInfo	stageBpCamInfo[];
#endif

#define	K7STG_LIST_NUM													(sizeof(stageList) / sizeof(WK7StageInfo) - 1)
#define	K7STG_LIST_START()												WK7StageInfo	stageList[] = {
#define	K7STG_LIST(scn,mid,pfx,flow,area,hrn,so,sp,mp)						{ K7STGID((mid),(pfx)),(K7ScenarioFlow)(flow),(K7Area)(area),0       ,(hrn),(so),(sp),(mp),(scn),0,0,0 },
#define	K7STG_LIST_CAM(scn,mid,pfx,flow,area,hrn,so,sp,mp,camset)			{ K7STGID((mid),(pfx)),(K7ScenarioFlow)(flow),(K7Area)(area),(camset),(hrn),(so),(sp),(mp),(scn),0,0,0 },
#define	K7STG_LISTM(scn,mid,pfx,multi,flow,area,hrn,so,sp,mp)					{ K7STGID((mid),(pfx)),(K7ScenarioFlow)(flow),(K7Area)(area),0       ,(hrn),(so),(sp),(mp),(scn),(multi),0,0 },
#define	K7STG_LISTM_CAM(scn,mid,pfx,multi,flow,area,hrn,so,sp,mp,camset)		{ K7STGID((mid),(pfx)),(K7ScenarioFlow)(flow),(K7Area)(area),(camset),(hrn),(so),(sp),(mp),(scn),(multi),0,0 },
#define	K7STG_LIST_END()													{ 0xffffffff,0,0,0,0,0,0,0,0,0,0,0 }, \
																		};

#define	K7STG_PATH_MAX							(256)
#define	K7STG_OBJ_MAX							(64)

#define	K7STG_PATH_WORKSIZE						GHM_ROUNDUP_QUOT(K7STG_PATH_MAX,32)
#define	K7STG_OBJ_WORKSIZE						GHM_ROUNDUP_QUOT(K7STG_OBJ_MAX ,32)

#define K7STG_DEFAULT_BOMBOBJ_DIST				(50.f)

struct K7StageWork{
	u32			mPassPath [K7STG_PATH_WORKSIZE];
	u32			mSelectObj[K7STG_OBJ_WORKSIZE ];
};

class WK7StageHana : public ghmGcListObj{
protected:
	WK7Model				*mpModel;
public:
	WK7StageHana(ghmGcListObj *pAnchor,WK7Model *pModel);
	virtual ~WK7StageHana();
	
	inline WK7StageHana* GetNext(void){ return (WK7StageHana *)ghmGcListObj::GetNext(); }
	inline WK7StageHana* GetPrev(void){ return (WK7StageHana *)ghmGcListObj::GetPrev(); }
	
	inline WK7Model* GetModel(void){ return mpModel; }
	
	bool FrameProcess(void);
	bool RenderProcess(void);
};

#define	WK7STAGEZAN_MOTIONNUM		(3)
class WK7StageZan : public ghmGcListObj{
protected:
	WK7Stage				*mpContainer;
	u32						mEventNo;
	u32						mCharaID;
	WK7Chara				*mpChara;
	u32						mMotID;
	WK7CharaMotion			*mpCharaMotion[WK7STAGEZAN_MOTIONNUM];
	C_SetAlpha				*mpAlpha;
	Vec						mPosition;
	Vec						mRotation;
	WK7StageZanInfo			*mpInfo;
	WK7AnimLinearF			mAlpha;
	u32						mProc;
	bool					mEnable;
	bool					mForcedDisp;
	
	bool InitYunion(void);
public:
	WK7StageZan(ghmGcListObj *pAnchor,WK7Stage *pContainer,u32 eventNo,u32 charaid,WK7Chara *pChara,u32 motid,WK7CharaMotion *pMotion);
	virtual ~WK7StageZan();
	
	static WK7StageZanColChipInfo* GetZanColChipInfo(u32 eventNo);
	bool InitIwazaru(void);
	WK7JObj* GetColorChip(int color);
	
	inline WK7StageZan* GetNext(void){ return (WK7StageZan *)ghmGcListObj::GetNext(); }
	inline WK7StageZan* GetPrev(void){ return (WK7StageZan *)ghmGcListObj::GetPrev(); }
	
	bool PlayMotion(int index,bool loop=true,f32 startframe=0.0f);
	
	inline u32 GetEventNo(void){ return mEventNo; }
	inline u32 GetCharaID(void){ return mCharaID; }
	
	void ChangeEventNo(u32 eventNo){ mEventNo=eventNo; }
	
	inline void SetEnable(bool flag){ mEnable=flag; }
	inline bool GetEnable(void){ return mEnable; }
	inline void SetForcedDisp(bool flag){ mForcedDisp=flag; }
	inline bool GetForcedDisp(void){ return mForcedDisp; }
	
	inline void SetPosition(const Vec &pos){ mPosition=pos; }
	inline void GetPosition(Vec &pos){ pos=mPosition; }
	inline void SetRotation(const Vec &rot){ mRotation=rot; }
	inline void GetRotation(Vec &rot){ rot=mRotation; }
	inline C_SetAlpha* GetSetAlpha(void){ return mpAlpha; }
	inline void SetInfo(WK7StageZanInfo *pInfo){ mpInfo=pInfo; }
	inline WK7StageZanInfo* GetInfo(void){ return mpInfo; }
	
	bool IsLoading(void);
	bool Initialize(void);
	bool FrameProcess(void);
	WK7Chara* GetChara(void);
	WK7CharaMotion* GetCharaMotion(int index=0);
	WK7Model* GetModel(void);
	WK7ModelMotion* GetModelMotion(int index=0);
};

class	MK7CharaDisp;
class WK7StageCharaName : public ghmGcListObj{
protected:
	MK7CharaDisp		*mpCharaDisp;
	bool				mReleaseRequest;
	u32					mWaitTick;
	s32					mDispTick;
	s16					mNo,mX,mY;
public:
	WK7StageCharaName(ghmGcListObj *pAnchor);
	virtual ~WK7StageCharaName();
	
	inline WK7StageCharaName* GetNext(void){ return (WK7StageCharaName *)ghmGcListObj::GetNext(); }
	inline WK7StageCharaName* GetPrev(void){ return (WK7StageCharaName *)ghmGcListObj::GetPrev(); }
	
	bool Reserve(u32 waitTick,s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool Disp(s16 inNo,s16 inX,s16 inY,s32 inTick=-1);
	bool Hide(void);
	bool FrameProcess(void);
	bool Release(void){ Hide(); mReleaseRequest=true; return true; }
};

typedef struct{
	Vec tgt;
	Vec pos;
}K7StageEventOneShotCamera;

struct K7StageBrokenWallInfo{
	u32				mEventNo;
	const char		*mpWallName;
	const char		*mpPathName;
	int				mFlagID;
	int				mCamID;
};

#define	K7STAGE_BROKENWALLINFO_START(name)					K7StageBrokenWallInfo	name[] = {
#define	K7STAGE_BROKENWALLINFO(evno,wall,path,flag)				{ (evno) , (wall) , (path) , (flag) , -1 },
#define	K7STAGE_BROKENWALLINFO_CAM(evno,wall,path,flag,cam)		{ (evno) , (wall) , (path) , (flag) , (cam) },
#define	K7STAGE_BROKENWALLINFO_END()							{ 0xffffffff , NULL,NULL,-1,-1 }, \
															};

struct K7StageKihanKuiTable{
	u32							mNo;
	u32							mTamaNo;
//	int							mFlagID;
	Vec							mCamPos;
	Vec							mCamTgt;
};

#define	K7STAGE_KIHANKUITABLE_START(name)					K7StageKihanKuiTable	name[] = {
#define	K7STAGE_KIHANKUITABLE(no,tamano)						{ (no) , (tamano) , {0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f} },
#define	K7STAGE_KIHANKUITABLE_CAM(no,tamano,px,py,pz,tx,ty,tz)	\
																{ (no) , (tamano) , {(px),(py),(pz)},{(tx),(ty),(tz)} },
#define	K7STAGE_KIHANKUITABLE_END()								{ 0xffffffff , 0xffffffff , {0.0f,0.0f,0.0f},{0.0f,0.0f,0.0f} }, \
															};


class K7StageKihanKui{
protected:
	WK7JObj						*mpJObj;
	K7StageKihanKuiTable		*mpTable;
public:
	K7StageKihanKui(WK7JObj *pJObj,K7StageKihanKuiTable *pTable);
	~K7StageKihanKui(){}
	
	inline WK7JObj* GetJObj(void){ return mpJObj; }
	inline u32 GetNo(void){ return (mpTable!=NULL)? mpTable->mNo : 0xffffffff; }
	inline u32 GetTamaNo(void){ return (mpTable!=NULL)? mpTable->mTamaNo : 0xffffffff; }
//	inline int GetFlagID(void){ return (mpTable!=NULL)? mpTable->mFlagID : -1; }
	inline bool GetCamPos(Vec &pos){ if( mpTable==NULL ){ return false; } pos=mpTable->mCamPos; return true; }
	inline bool GetCamTgt(Vec &tgt){ if( mpTable==NULL ){ return false; } tgt=mpTable->mCamTgt; return true; }
};

#define	WK7STAGE_KUINUM							(5)
#define	WK7STAGE_HARMANROOM_FLAG_NUM			(32)
#define	WK7STAGE_HARMANROOM_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7STAGE_HARMANROOM_FLAG_NUM,32)
#define	WK7STAGE_HARMANROOM_FLAG_SIZE			(WK7STAGE_HARMANROOM_FLAG_WORK_SIZE * sizeof(u32))
#define	WK7STAGE_HARMANTV_FLAG_NUM				(WK7STAGE_HARMANROOM_FLAG_NUM)
#define	WK7STAGE_HARMANTV_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7STAGE_HARMANTV_FLAG_NUM,32)
#define	WK7STAGE_HARMANTV_FLAG_SIZE				(WK7STAGE_HARMANTV_FLAG_WORK_SIZE * sizeof(u32))

#define	WK7STAGE_PASSPATH_FLAG_NUM				(64 * 4 * 16)
#define	WK7STAGE_PASSPATH_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7STAGE_PASSPATH_FLAG_NUM,32)
#define	WK7STAGE_PASSPATH_FLAG_SIZE				(WK7STAGE_PASSPATH_FLAG_WORK_SIZE * sizeof(u32))
#define	WK7STAGE_SELECTOBJ_FLAG_NUM				(64 * 2 *  8)
#define	WK7STAGE_SELECTOBJ_FLAG_WORK_SIZE		GHM_ROUNDUP_QUOT(WK7STAGE_SELECTOBJ_FLAG_NUM,32)
#define	WK7STAGE_SELECTOBJ_FLAG_SIZE			(WK7STAGE_SELECTOBJ_FLAG_WORK_SIZE * sizeof(u32))
#define	WK7STAGE_MAP_FLAG_NUM					(64)
#define	WK7STAGE_MAP_FLAG_WORK_SIZE				GHM_ROUNDUP_QUOT(WK7STAGE_MAP_FLAG_NUM,32)
#define	WK7STAGE_MAP_FLAG_SIZE					(WK7STAGE_MAP_FLAG_WORK_SIZE * sizeof(u32))

typedef	WK7Stage* WK7StageCreateStageFunc(u32 id,int prio);

#define	WK7RENDEROBJEFFECTMESSAGE_KIND_MESSAGE		(0)
#define	WK7RENDEROBJEFFECTMESSAGE_KIND_ITEMGET		(1)
class WK7RenderObjEffectMessage : public WK7RenderObjEffect{
protected:
	u32					mMessageID;
	s32					mIconID;
	s32					mSoundID;
	int					mKind;
public:
	WK7RenderObjEffectMessage(u32 mesid,s32 icoid,s32 sndid,int kind,ghmGcListObj *pAnchor,WK7RenderObj *pContainer,EFFECT *pEffect) : WK7RenderObjEffect(pAnchor,pContainer,pEffect){
		mMessageID = mesid;
		mIconID    = icoid;
		mSoundID   = sndid;
		mType      = MESSAGE;
		mKind      = kind;
	}
	virtual ~WK7RenderObjEffectMessage(){}
	
	inline WK7RenderObjEffectMessage* GetNext(void){ return (WK7RenderObjEffectMessage *)ghmGcListObj::GetNext(); }
	inline WK7RenderObjEffectMessage* GetPrev(void){ return (WK7RenderObjEffectMessage *)ghmGcListObj::GetPrev(); }
	
	inline u32 GetMessageID(void){ return mMessageID; }
	inline s32 GetIconID(void){ return mIconID; }
	inline s32 GetSoundID(void){ return mSoundID; }
	inline int GetKind(void){ return mKind; }
};

class WK7StageArea : public ghmGcListObj{
	friend class WK7Stage;
protected:
	WK7Stage				*mpContainer;
	bool					mEnable;
	u16						mSeID;
	WK7JObj					*mpJObj;
	vector<C_TrigonArray*>	mTrigons;
public:
	WK7StageArea(ghmGcListObj *pAnchor,WK7JObj *pJObj);
	virtual ~WK7StageArea();
	
	inline WK7StageArea* GetNext(void){ return (WK7StageArea *)ghmGcListObj::GetNext(); }
	inline WK7StageArea* GetPrev(void){ return (WK7StageArea *)ghmGcListObj::GetPrev(); }
	
	bool Include(const Vec &pos);
	
	inline void SetSeID(u16 id){ mSeID=id; }
	inline u16 GetSeID(void){ return mSeID; }
	inline void SetEnable(bool flag){ mEnable=flag; }
	inline bool GetEnable(void){ return mEnable; }
};

#define	WK7STAGE_HITOBJ_ALLOC_RENDERID			(0xffffffff)
#define	WK7STAGE_HITOBJ_ALLOC_ENEMYRENDERID		(0xfffffffe)

//
// Stage Object
//
class WK7Stage : public WK7RenderObj{
	friend class WK7RenderObj;
protected:
	static ghmGcViewVolume				mViewVolume;
	static WK7Stage						*mpCurrentStage;
	static u32							mCurrentStageID;
	static u32							mCurrentStageParam;
	static char							*mpCurrentStageBpName;
	static u32							mPrevStageID;
	static char							*mpPrevStagePathName;
	static char							*mpPrevStageBpName;
	static bool							mChangingStage;
	static bool							mRenderStage;
	static u32							mDefBranchMoveEventID,
										mDefTvEventID,
										mDefLtvEventID,
										mDefDoorEventID,
										mDefKeyEventID,
										mDefMapEventID,
										mDefMemoEventID;
	static bool							mManualBranch;
	static bool							mMoveModeCancel;
	static WK7Stage						*mpReleasedStage;
	static bool							mReleaseStage;
	static bool							mReleasePlayer;
	static bool							mReleasedStage;
	static bool							mReleasedPlayer;
	static char							mPlayerPathName[256];
	static f32							mPlayerPathParam;
	static u32							mPlayerPathDir;
	static Vec							mPlayerPosition;
	static char							mCameraPathName[256];
	static f32							mCameraPathParam;
	static u32							mCameraPathDir;
//	static u32							mChangeChara;
	static bool							mReleasedStageVisible;
	static bool							mReleasedPlayerVisible;
	static bool							mDisableInitializeSelectFlag;
	static u32							mGetKeyMesID;
	static u32							mHarmanRoomFlag[WK7STAGE_HARMANROOM_FLAG_WORK_SIZE];
	static u32							mHarmanTvFlag  [WK7STAGE_HARMANTV_FLAG_WORK_SIZE  ];
	static u32							mPassPathFlag  [WK7STAGE_PASSPATH_FLAG_WORK_SIZE  ];
	static u32							mSelectObjFlag [WK7STAGE_SELECTOBJ_FLAG_WORK_SIZE ];
	static u32							mMapFlag       [WK7STAGE_MAP_FLAG_WORK_SIZE       ];
	static WK7StageBpCamInfo			*mpScenarioBpCamInfo;
	static WK7StagePlaceInfo			*mpScenarioPlaceInfo;
	static WK7StageDoorInfo				*mpScenarioDoorInfo;
//	static WK7StageHanaInfo				*mpScenarioHanaInfo;
	static WK7StageTamaInfo				*mpScenarioTamaInfo;
//	static WK7StageInfo					*mpScenarioStageInfo;
	static WK7StageSoundInfo			*mpScenarioSoundInfo;
	static WK7StageSpCond				*mpScenarioSpCond;
	
	WK7Archive							*mpPathArchive;
	WK7Model							*mpPathModel;
	WK7Path								*mpPath;
	WK7CameraMotion						*mpCameraMotion;
	WK7LightMotion						*mpLightMotion;
	union{
		struct{
			u32							mEdgeShadowVisible :  1;
			u32							mFlagPad           : 31;
		};
		u32								mFlag;
	};
	WK7Light							*mpShadowLight;
#if FUJITA
  	vector<C_TrigonArray*>				mTrigonPtrs;
  	vector<C_Border*>					mBorderPtrs;
	Vec									mFirstNodePos;
	Vec									mFirstNodeNrm;	
	f32									mShortestDist;	
#endif	
	
	int									mMessageHandle;
	ghmGcFile							*mpNameFile;
	void								*mpNameData;
	
	ghmGcListObj						mHanaAnchor;
	
	static	K7StageWork					*mpStgWork;
	static	int							mStgWorkNum;
	static	int							mStgIDNum;
	
	K7StageEventOneShotCamera			*mpOneShotCamera;
	int									mStageEnemyMax;
	
	K7StageBrokenWallInfo				*mpBrokenWallInfo;
	
	K7StageKihanKui						*mpKui[WK7STAGE_KUINUM];
	
	ghmGcListObj						mDeadBodySingAnchor;
	
	ghmGcListObj						mZanAnchor;
	
	ghmGcListObj						mCharaNameAnchor;
	
	WK7JObj								*mpConstraintSky;
	
	static WK7StageCreateStageFunc		*mpCreateStageFunc;
	
	ghmGcListObj						mAreaAnchor;
	u16									mDefaultFootSE;
	s16									mScenarioFlow;
	
	WK7StageInfo						*mpStageInfo;
	s16									mSelectPathID;
	s16									mSelectPathNum;
	s16									mSelectObjID;
	s16									mSelectObjNum;
	s16									mHarmanRoomID;
	s16									mHarmanRoomNum;
	s16									mMapID;
	s16									mMapNum;
	s16									mMultiNum;
	s16									mMultiID;
	
	int									mCollisionIndex;
	
	WK7RenderObjEffect					*mpTamaEffect;
	
//	WK7AreaInfo					*mpAreaInfo;
//	ghmGcFile					*mpAreaInfoFile;
	
	static void SetKeyMesID(u32 mesid){ mGetKeyMesID=mesid; }
//	bool LoadAreaInfo(void);
//	bool IsLoadedAreaInfo(void);
	
	bool CreateDeadBodySign(u32 charaid,const Vec &pos,const Vec &dir);
	
	// ߋCxgp
	GhmGcTexHeader						mTexHeader;
	stTexture							mMonoTex;
	mK7Sprite							mSprt;
	
#ifdef	_DEBUG
	int									mPlaceInfoProc;
	int									mPlaceInfoCount;
	int									mPlaceInfoTick;
	char								mPlaceName[WK7PATH_SHORTPATHNAME_MAX];
#endif
	
	// R[obN^XNĂяo
public:
	bool CallCreateCallBackTask(void);
	bool CallInitializeCallBackTask(void);
	bool CallCondChangeCallBackTask(void);
	bool CallTerminateCallBackTask(void);
	bool CallSetCurrentCallBackTask(void);
	bool CallEventCallBackTask(WK7EventInfo &info);
	bool CallDoorEventCallBackTask(WK7DoorEventInfo &info);
	bool CallKeyEventCallBackTask(WK7KeyEventInfo &info);
	bool CallMapEventCallBackTask(WK7MapEventInfo &info);
	bool CallMemoEventCallBackTask(WK7MemoEventInfo &info);
	bool CallVoiceMemoEventCallBackTask(WK7VoiceMemoEventInfo &info);
	bool CallRakuEventCallBackTask(WK7RakuEventInfo &info);
	bool CallPlayEventCallBackTask(WK7PlayEventInfo &info);
	bool CallBpLeaveCallBackTask(WK7BpInfo &info);
	bool CallBpArriveCallBackTask(WK7BpInfo &info);
	bool CallPathTurnCallBackTask(WK7PathTurnInfo &info);
	bool CallPathChangeCallBackTask(WK7PathChangeInfo &info);
	bool CallPrePathChangeCallBackTask(WK7PrePathChangeInfo &info);
	bool CallHitObjCallBackTask(WK7HitObjInfo &info);
	bool CallDieNpcCallBackTask(WK7DieNpcInfo &info);
	bool CallAttackCallBackTask(WK7AttackInfo &info);
//	bool CallSpAttackCallBackTask(WK7SpAttackInfo &info);
	bool CallSpAbilityCallBackTask(WK7SpAbilityInfo &info);
	bool CallTvEventCallBackTask(WK7TvEventInfo &info);
	bool CallLtvEventCallBackTask(WK7TvEventInfo &info);
	bool CallHanaEventCallBackTask(WK7HanaEventInfo &info);
	bool CallZanEventCallBackTask(WK7ZanEventInfo &info);
	bool CallTamaEventCallBackTask(WK7TamaEventInfo &info);
	bool CallCharaChangeCallBackTask(WK7CharaChangeInfo &info);
	bool CallPreCharaChangeCallBackTask(WK7CharaChangeInfo &info);
	
protected:
	static void _CreateCallBackTask    (ghmGcTask *);
	static void _InitializeCallBackTask(ghmGcTask *);
	static void _CondChangeCallBackTask(ghmGcTask *);
	static void _TerminateCallBackTask (ghmGcTask *);
	static void _SetCurrentCallBackTask(ghmGcTask *);
	static void _EventCallBackTask (ghmGcTask *);
	static void _DoorEventCallBackTask (ghmGcTask *);
	static void _KeyEventCallBackTask (ghmGcTask *);
	static void _MapEventCallBackTask (ghmGcTask *);
	static void _MemoEventCallBackTask (ghmGcTask *);
	static void _VoiceMemoEventCallBackTask (ghmGcTask *);
	static void _RakuEventCallBackTask (ghmGcTask *);
	static void _PlayEventCallBackTask (ghmGcTask *);
	static void _BpLeaveCallBackTask (ghmGcTask *);
	static void _BpArriveCallBackTask (ghmGcTask *);
	static void _PathTurnCallBackTask(ghmGcTask *);
	static void _PathChangeCallBackTask(ghmGcTask *);
	static void _PrePathChangeCallBackTask(ghmGcTask *);
	static void _HitObjCallBackTask(ghmGcTask *);
	static void _DieNpcCallBackTask(ghmGcTask *);
	static void _AttackCallBackTask(ghmGcTask *);
	static void _SpAttackCallBackTask(ghmGcTask *);
	static void _SpAbilityCallBackTask(ghmGcTask *);
	static void _TvEventCallBackTask(ghmGcTask *);
	static void _LtvEventCallBackTask(ghmGcTask *);
	static void _HanaEventCallBackTask(ghmGcTask *);
	static void _ZanEventCallBackTask(ghmGcTask *);
	static void _TamaEventCallBackTask(ghmGcTask *);
	static void _CharaChangeCallBackTask(ghmGcTask *);
	static void _PreCharaChangeCallBackTask(ghmGcTask *);
	
	// JX^}CY֘A ---------------------------
	
	virtual bool CreateCallBack        (void)                   { return true; }		// iǂݍݗ\sꍇȂǂɗpj
	virtual bool InitializeCallBack    (void)                   { return true; }		// iǂݍݏÎɑ΂鏉j
	virtual bool CondChangeCallBack    (void)                   { return true; }		// ԕύXitOɂԕύX邽߂ɗpj
	virtual bool TerminateCallBack     (void)                   { return true; }		// Iȉj
	virtual bool SetCurrentCallBack    (void)                   { return true; }		// JgXe[Wɐݒ莞
	virtual bool EventCallBack         (WK7EventInfo          &){ return true; }		// Cxg
	virtual bool DoorEventCallBack     (WK7DoorEventInfo      &){ return true; }		// hACxg
	virtual bool KeyEventCallBack      (WK7KeyEventInfo       &){ return true; }		// L[Cxg
	virtual bool MapEventCallBack      (WK7MapEventInfo       &){ return true; }		// }bvCxg
	virtual bool MemoEventCallBack     (WK7MemoEventInfo      &){ return true; }		// Cxg
	virtual bool VoiceMemoEventCallBack(WK7VoiceMemoEventInfo &){ return true; }		// e[vi{CXjCxg
	virtual bool RakuEventCallBack     (WK7RakuEventInfo      &){ return true; }		// Cxg
	virtual bool PlayEventCallBack     (WK7PlayEventInfo      &){ return true; }		// LCxg
	virtual bool BpLeaveCallBack       (WK7BpInfo             &){ return true; }		// _o
	virtual bool BpArriveCallBack      (WK7BpInfo             &){ return true; }		// _
	virtual bool PathTurnCallBack      (WK7PathTurnInfo       &){ return true; }		// ^[
	virtual bool PathChangeCallBack    (WK7PathChangeInfo     &){ return true; }		// pXύX
	virtual bool PrePathChangeCallBack (WK7PrePathChangeInfo  &){ return true; }		// pXύXO
	virtual bool HitObjCallBack        (WK7HitObjInfo         &){ return true; }		// IuWFqbg
	virtual bool DieNpcCallBack        (WK7DieNpcInfo         &){ return true; }		// mobS
	virtual bool AttackCallBack        (WK7AttackInfo         &){ return true; }		// v[[̍U
	virtual bool SpAttackCallBack      (WK7SpAttackInfo       &){ return true; }		// XyVA^bNgp
	virtual bool SpAbilityCallBack     (WK7SpAbilityInfo      &){ return true; }		// XyV\͎gp
	virtual bool TvEventCallBack       (WK7TvEventInfo        &){ return true; }		// erCxg
	virtual bool LtvEventCallBack      (WK7TvEventInfo        &){ return true; }		// erCxgiZ[u|Cgj
	virtual bool HanaEventCallBack     (WK7HanaEventInfo      &){ return true; }		// ԃqbg
	virtual bool ZanEventCallBack      (WK7ZanEventInfo       &){ return true; }		// cvOCxg
	virtual bool TamaEventCallBack     (WK7TamaEventInfo      &){ return true; }		// eێ擾Cxg
	virtual bool CharaChangeCallBack   (WK7CharaChangeInfo    &){ return true; }		// L`FW
	virtual bool PreCharaChangeCallBack(WK7CharaChangeInfo    &){ return true; }		// L`FWO
	
	// --------------------------------------------
	
	WK7Stage();
	WK7Stage(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
	
	bool SetCurrentCallBackDefaultProc(void);
	
	bool InitializeFlagCount(void);
	
	virtual bool _RenderEdgeShadowPaint(void);
	static void ChangeStageTask(ghmGcTask *pTask);
	WK7JObj* GetSelectObjTop(void);
	virtual bool InitializeSelectObj(void);
	bool InitializeBranchPointEvent(void);
	bool InitializeBpDefEvent(WK7PathBranchPoint *pBranchPoint);
	bool InitializePath(void);
	bool InitializeBurnEffect(void);
	
	bool AddBranchPointEvent(WK7JObj *pJObj);
	static void TvEventTaskTerm(WK7TvEventInfo &info);
	static void MapEventTaskTerm(WK7MapEventInfo &info);
	static void KeyEventTaskTerm(WK7KeyEventInfo &info);
	static void MemoEventTaskTerm(WK7MemoEventInfo &info);
	static void VoiceMemoEventTaskTerm(WK7VoiceMemoEventInfo &info);
	static void RakuEventTaskTerm(WK7RakuEventInfo &info);
	static void PlayEventTaskTerm(WK7PlayEventInfo &info);
	static void ZanEventTaskTerm(WK7ZanEventInfo &info);
	static void TamaEventTaskTerm(WK7TamaEventInfo &info);
	
	static u32 GetEventNo(const char *pName);
	static u32 GetEventNo(WK7JObj *pJObj);
	bool LoadMessage(void);
	bool IsLoadedMessage(void);
	
	static bool DeleteEffectAll(void);
	static WK7Stage* CreateStage(u32 id,int prio);
	virtual ~WK7Stage();
	bool _Terminate(void);
	
	// t[
	virtual bool LoadAfterInit(void);
	virtual bool IsLoadingAfterInit(void);
	virtual bool LoadAfterInit2(void);
	virtual bool IsLoadingAfterInit2(void);
	virtual bool LoadAfterInit3(void);
	virtual bool IsLoadingAfterInit3(void);
	virtual bool LoadedProcess(void);
	virtual bool LoadingProcess(void);
	virtual bool ReleaseArchiveProcess(void);
	virtual bool RestoreArchiveProcess(void);
	virtual bool StateProcess(void);
	
	bool CreateFootSeArea(void);
	bool ReleaseFootSeArea(void);
	
	bool CreateNpc(void);
	bool InitializeNpc(void);
	bool IsLoadingNpc(void);
	
	bool CreateHana(void);
	bool InitializeHana(void);
	bool IsLoadingHana(void);
	
	bool CreateZan(WK7JObj *pLocator,u32 eventNo);
	bool CreateZan(void);
	bool InitializeZan(void);
	bool IsLoadingZan(void);
	bool ReleaseZan(void);
	bool ZanHitEvent(WK7HitObjInfo &info);
	
	bool CreatePath(void);
	bool IsLoadingPath(void);
	
	bool InitializeGlassObj(void);
	
	bool InitializeConstraintSky(void);
	
	bool InitializeHarmanRoom(void);
	
	bool InitializeHitObj(void);
	
	static void ReleaseStageArchiveTask(ghmGcTask *pTask);
	static void RestoreStageArchiveTask(ghmGcTask *pTask);
	
	virtual bool LoadObj(u32 type,u32 id);
	virtual bool RestoreObj(void);
	
	bool ReleaseHanaAll(void);
	
	bool KihanGateIsOpened(void);
	bool CreateKui(K7StageKihanKuiTable *pTable);
	K7StageKihanKui* GetKui(u32 no);
	
	bool TvNoise(void);
	virtual bool TvNoiseCallback(void){ return true; }
	
	bool KihanDemoFirst(WK7Npc *pNpc,
						int init_camid,
	                    int term_camid,
	                    s16 name_id,
	                    s16 name_x,s16 name_y,
	                    s16 win_x,s16 win_y,s16 win_w,s16 win_h,
	                    s16 manual=0 );
	bool KihanDemo(u32 eneno,int camid);
	
	virtual void* InitializeThread(void);
	void SetCustomScenarioFlow(K7ScenarioFlow flow);
	
	int HideCollision(WK7JObj *pJObj);
	int HideCollision(void);
	
	inline void SetCollisionIndex(int index){ mCollisionIndex=index; }
	inline int GetCollisionIndex(void){ return mCollisionIndex; }
	
	bool RenewTamaEffect(u32 eventNo);
	WK7RenderObjEffect* CreateTamaEffect(WK7JObj *pJObj);
	WK7RenderObjEffect* CreateTamaEffect(const char *pName);
	WK7RenderObjEffect* CreateTamaEffect(u32 eventNo);
	bool ReleaseTamaEffect(void);
	
public:
	inline K7ScenarioFlow GetCustomScenarioFlow(void){ return (K7ScenarioFlow)mScenarioFlow; }
	bool InitializeSelectFlag(void);
	// P̂ݗL
	inline static void SetDisableInitializeSelectFlag(bool flag){ mDisableInitializeSelectFlag=flag; }
	inline static bool GetDisableInitializeSelectFlag(void){ return mDisableInitializeSelectFlag; }
	
#ifdef	_DEBUG
	bool SetPlaceInfoWaring(WK7StagePlaceInfo *pPlaceInfo,const char *pPlaceName);
	bool RenderPlaceInfoWaring(void);
#endif
	
	inline static bool SetScenarioBpCamInfo(WK7StageBpCamInfo *pInfo){ mpScenarioBpCamInfo=pInfo; return true; }
	inline static WK7StageBpCamInfo* GetScenarioBpCamInfo(void){ return mpScenarioBpCamInfo; }
	inline static bool SetScenarioDoorInfo(WK7StageDoorInfo *pInfo){ mpScenarioDoorInfo=pInfo; return true; }
	inline static WK7StageDoorInfo* GetScenarioDoorInfo(void){ return mpScenarioDoorInfo; }
	inline static bool SetScenarioTamaInfo(WK7StageTamaInfo *pInfo){ mpScenarioTamaInfo=pInfo; return true; }
	inline static WK7StageTamaInfo* GetScenarioTamaInfo(void){ return mpScenarioTamaInfo; }
//	inline static bool SetScenarioStageInfo(WK7StageInfo *pInfo){ mpScenarioStageInfo=pInfo; return true; }
//	inline static WK7StageInfo* GetScenarioStageInfo(void){ return mpScenarioStageInfo; }
	inline static bool SetScenarioSoundInfo(WK7StageSoundInfo *pInfo){ mpScenarioSoundInfo=pInfo; return true; }
	inline static WK7StageSoundInfo* GetScenarioSoundInfo(void){ return mpScenarioSoundInfo; }
	inline static bool SetScenarioSpCond(WK7StageSpCond *pCond){ mpScenarioSpCond=pCond; return true; }
	inline static WK7StageSpCond* GetScenarioSpCond(void){ return mpScenarioSpCond; }
	inline static bool SetScenarioPlaceInfo(WK7StagePlaceInfo *pInfo){ mpScenarioPlaceInfo=pInfo; return true; }
	inline static WK7StagePlaceInfo* GetScenarioPlaceInfo(void){ return mpScenarioPlaceInfo; }
	
	static bool SetBpCamInfo(WK7PathBranchPoint *pBranchPoint);
	static WK7StageBpCamInfo* GetBpCamInfo(WK7PathBranchPoint *pBranchPoint);
	static WK7StageBpCamInfo* GetBpCamInfo(const char *pName);
	int SetBpCamDisable(const char *pName,bool flag);
	
	bool CreateCollision(int index=-1);
	bool ReleaseCollision(void);
	
	static bool PlayMovie(u32 id);
	static bool PlayMovie(const char *pFileName);
	static bool PlayMovie2(u32 id);
	static bool PlayMovie2(const char *pFileName);
	static bool PlayMovie3(u32 id);
	static bool PlayMovie3(const char *pFileName);
	static bool IsPlayingMovie(void);
	
	virtual bool ReleaseOwnRenderObjAll(void);
	
	K7StageBrokenWallInfo* GetWallInfo(u32 eventNo);
	static WK7StageZanInfo* GetZanInfo(u32 eventNo);
	static ghmGcViewVolume* GetViewVolume(void){ return &mViewVolume; }
	
	bool PutEnemyWalk(Vec &pos);
	
	WK7HitObjJObj* SetHitObj(WK7JObj *pJObj,u32 eventNo=0xffffffff,u32 renderID=WK7STAGE_HITOBJ_ALLOC_RENDERID);
	inline static void SetCreateStageFunc(WK7StageCreateStageFunc *pfunc){ mpCreateStageFunc = pfunc; }
	inline static WK7StageCreateStageFunc* GetCreateStageFunc(void){ return mpCreateStageFunc; }
	static WK7Stage* CreateStageScn07(u32 id,int prio);
	static WK7Stage* CreateStageScn01(u32 id,int prio);
	static WK7Stage* CreateStageScn02(u32 id,int prio);
	static WK7Stage* CreateStageScn03(u32 id,int prio);
	static WK7Stage* CreateStageScn04(u32 id,int prio);
	static WK7Stage* CreateStageScn05(u32 id,int prio);
	static WK7Stage* CreateStageScn06(u32 id,int prio);
	
	inline WK7Model* GetPathModel(void){ return mpPathModel; }
	virtual WK7JObj* GetJObj(const char *pName=NULL);
	virtual WK7JObj* GetJObjPartialName(const char *pName);
	WK7JObj* GetTamaJObj(u32 eventNo,bool equal=false);
	bool SetVisibleTamaJObj(u32 eventNo,bool flag,bool equal=false);
	bool DispTamaJObj(u32 eventNo,bool equal=false);
	bool HideTamaJObj(u32 eventNo,bool equal=false);
	
	bool ReserveCharaName(u32 waitTick,s16 inNo,s16 inX,s16 inY,s32 inTick=WK7_SEC_TO_TICK(1.f));
	bool DispCharaName(s16 inNo,s16 inX,s16 inY,s32 inTick=WK7_SEC_TO_TICK(1.f));
	bool HideCharaName(void);
	bool ClearCharaName(void);
	bool SetNameData(void);
	bool ReleaseNameData(void);
	bool FrameProcessCharaName(void);
	
	static bool GetZanChara(WK7JObj *pLocator,u32 &charaid,u32 &motid);
	WK7JObj* GetZanLocator(u32 eventNo);
	u32 GetLocatorEventNo(WK7JObj *pLocator);
	
	bool ReleaseDeadBodySign(u32 charaid=0xffffffff);
	bool ReleaseDeadBodySignAll(void);
	WK7DeadBodySign* FindDeadBodySign(u32 charaid);
	bool CreateDeadBodySign(u32 charaid=0xffffffff);
	bool RenderDeadBodySign(void);
	static bool RenderDeadBodySignAll(void);
	
	static WK7StageSoundInfo* GetSoundInfo(u32 stgid);
	static WK7StageTamaInfo* GetTamaInfo(u32 evno);
	
	WK7StageSoundInfo* GetSoundInfo(void);
	bool TestSpAbility(WK7SpAbilityInfo &info);
	
	WK7PathBranchPointObjJObj* GetBranchPointObj_EventNo(u32 evno);
	WK7PathNurbs* GetPathNurbs_EventNo(u32 evno);
	
	bool IsValid(WK7PathBranchPointObj *pBranchPointObj);
	bool IsValid(WK7PathBranch *pBranch);
	bool IsValid(WK7PathBranchPoint *pBranchPoint);
	bool IsValid(WK7PathNurbs *pPath);
	
	virtual bool ReleaseArchive(void);
	virtual bool RestoreArchive(void);
//	virtual bool DispLight(void);
	
	inline s16 GetMultiNum(void){ return mMultiNum; }
	inline void SetMultiID(s16 id){ mMultiID = id; }
	inline s16 GetMultiID(void){ return mMultiID; }
	
	inline s16 GetSelectPathID(void){ return mSelectPathID; }
	inline s16 GetSelectPathNum(void){ return mSelectPathNum; }
	inline s16 GetSelectObjID(void){ return mSelectObjID; }
	inline s16 GetSelectObjNum(void){ return mSelectObjNum; }
	inline s16 GetHarmanRoomID(void){ return mHarmanRoomID; }
	inline s16 GetHarmanRoomNum(void){ return mHarmanRoomNum; }
	inline s16 GetMapID(void){ return mMapID; }
	inline s16 GetMapNum(void){ return mMapNum; }
	
	static bool SetHarmanRoomFlag(u32 stgid,int index,bool flag,int multi=0);
	static bool GetHarmanRoomFlag(u32 stgid,int index,int multi=0);
	static bool SetHarmanRoomFlag(int index,bool flag);
	static bool GetHarmanRoomFlag(int index);
	static u32* GetHarmanRoomFlagTop(void){ return mHarmanRoomFlag; }
	static bool ClearHarmanRoomFlag(void);
	static int GetStageHarmanRoomFlagID(u32 stgid);
	bool SetStageHarmanRoomFlag(int index,bool flag,int multi=-1);
	bool GetStageHarmanRoomFlag(int index,int multi=-1);
	static bool SetHarmanTvFlag(u32 stgid,int index,bool flag,int multi=0);
	static bool GetHarmanTvFlag(u32 stgid,int index,int multi=0);
	static bool SetHarmanTvFlag(int index,bool flag);
	static bool GetHarmanTvFlag(int index);
	static u32* GetHarmanTvFlagTop(void){ return mHarmanTvFlag; }
	static bool ClearHarmanTvFlag(void);
	static int GetStageHarmanTvFlagID(u32 stgid);
	bool SetStageHarmanTvFlag(int index,bool flag,int multi=-1);
	bool GetStageHarmanTvFlag(int index,int multi=-1);
	
	static int GetIDNum(void);
	static int GetWorkNum(void);
	static int GetWorkID(u32 stgid);
	static K7StageWork* GetWorkTop(void);
	static K7StageWork* GetWork(u32 stgid);
	static int GetStageInfoIndex(u32 stgid,bool scn=true);
	static WK7StageInfo* GetStageInfo(u32 stgid,bool scn=true);
	WK7StageInfo* GetStageInfo(void){ return mpStageInfo; }
	int GetWorkID(void);
	virtual K7StageWork* GetWork(void);
	static bool SetPassPathFlag(int id,bool flag);
	static bool GetPassPathFlag(int id);
	static u32* GetPassPathFlagTop(void){ return mPassPathFlag; }
	static bool ClearPassPathFlag(void);
	static int GetStagePassPathFlagID(u32 stgid);
	static bool SetStagePassPathFlag(u32 stgid,int id,int dir,bool flag,int multi=0);
	static bool GetStagePassPathFlag(u32 stgid,int id,int dir,int multi=0);
	bool SetStagePassPathFlag(int id,int dir,bool flag,int multi=-1);
	bool GetStagePassPathFlag(int id,int dir,int multi=-1);
	static bool SetSelectObjFlag(int id,bool flag);
	static bool GetSelectObjFlag(int id);
	static bool ClearSelectObjFlag(void);
	static u32* GetSelectObjFlagTop(void){ return mSelectObjFlag; }
	static int GetStageSelectObjFlagID(u32 stgid);
	static bool SetStageSelectObjFlag(u32 stgid,int id,int dir,bool flag,int multi=0);
	static bool GetStageSelectObjFlag(u32 stgid,int id,int dir,int multi=0);
	bool SetStageSelectObjFlag(int id,int dir,bool flag,int multi=-1);
	bool GetStageSelectObjFlag(int id,int dir,int multi=-1);
	static bool SetMapFlag(int id,bool flag);
	static bool GetMapFlag(int id);
	static bool ClearMapFlag(void);
	static u32* GetMapFlagTop(void){ return mMapFlag; }
	static int GetStageMapFlagID(u32 stgid);
	static bool SetStageMapFlag(u32 stgid,int id,bool flag,int multi=0);
	static bool GetStageMapFlag(u32 stgid,int id,int multi=0);
	bool SetStageMapFlag(int id,bool flag,int multi=-1);
	bool GetStageMapFlag(int id,int multi=-1);
//	int SetPassPathFlag(int id,bool flag);
//	int GetPassPathFlag(int id);
//	int SetSelectObjFlag(int id,bool flag);
//	int GetSelectObjFlag(int id);
//	static int SetPassPathFlag(K7StageWork *pStgWork,int id,bool flag);
//	static int GetPassPathFlag(K7StageWork *pStgWork,int id);
//	static int SetSelectObjFlag(K7StageWork *pStgWork,int id,bool flag);
//	static int GetSelectObjFlag(K7StageWork *pStgWork,int id);
	
//	static bool SetChangeChara(u32 chrid,bool flag);
//	static bool ClearChangeChara(void);
//	static bool SetCharChangeMask(u32 chrid);
//	static bool ClearCharChangeMask(void);
	static bool SetSelOKAll(bool flag);
	
	static bool ReleaseStageArchive(bool player=true);
	static bool RestoreStageArchive(void);
	static bool IsReleasedStageArchive(void);
	static bool IsRestoredStageArchive(void);
	static u32 GetReleasedStageID(void);
	inline static void GetReleasedPlayerPosition(Vec &pos){ pos=mPlayerPosition; }
	
	static u32 GetDefBranchMoveEventID(void){ return mDefBranchMoveEventID; }
	static u32 GetDefTvEventID        (void){ return mDefTvEventID;         }
	static u32 GetDefLtvEventID       (void){ return mDefLtvEventID;        }
	static u32 GetDefDoorEventID      (void){ return mDefDoorEventID;       }
	static u32 GetDefKeyEventID       (void){ return mDefKeyEventID;        }
	static u32 GetDefMapEventID       (void){ return mDefMapEventID;        }
	static u32 GetDefMemoEventID      (void){ return mDefMemoEventID;       }
	static bool IsDefEventID(u32 eventid){
		if( mDefBranchMoveEventID!=NULL && mDefBranchMoveEventID==eventid ){
			return true;
		}
		if( mDefTvEventID        !=NULL && mDefTvEventID        ==eventid ){
			return true;
		}
		if( mDefLtvEventID       !=NULL && mDefLtvEventID       ==eventid ){
			return true;
		}
		if( mDefDoorEventID      !=NULL && mDefDoorEventID      ==eventid ){
			return true;
		}
		if( mDefKeyEventID       !=NULL && mDefKeyEventID       ==eventid ){
			return true;
		}
		if( mDefMapEventID       !=NULL && mDefMapEventID       ==eventid ){
			return true;
		}
		if( mDefMemoEventID      !=NULL && mDefMemoEventID      ==eventid ){
			return true;
		}
		return false;
	}
#ifdef	_DEBUG
	static bool CheckFlag(int scn);
#endif
	static bool InitWork(void);
	static bool ClearFlag(void);
	static bool InitDefEvent(void);
	static bool DeleteStage(WK7Stage *pStage);
	static bool DeleteStageAll(void);
	
	static void SetManualBranch(bool flag){ mManualBranch = flag; }
	static bool GetManualBranch(void){ return mManualBranch; }
	static void SetMoveModeCancel(bool flag){ mMoveModeCancel = flag; }
	static bool GetMoveModeCancel(void){ return mMoveModeCancel; }
	
	bool SandRelease(int closeSeID=-1);
	WK7StagePlaceInfo* GetPlaceInfo(const char *pPathName);
	static bool SandRelease(u32 stgid,int closeSeID=-1);
	static bool SandRelease(WK7StagePlaceInfo *pPlaceInfo,WK7StageDoorInfo *pDoorInfo);
	static bool SandRelease(WK7StagePlaceInfo *pPlaceInfo,int closeSeID=-1);
	static WK7StagePlaceInfo* GetPlaceInfo(u32 id,const char *pPathName);
	static bool SetCameraStartPosition(WK7StagePlaceInfo *pPlaceInfo);
	static bool SetCameraStartPosition(u32 id,const char *pName=NULL);
	bool SetCameraStartPosition(const char *pName=NULL);
	
	WK7StageDoorInfo* GetDoorInfo(const char *pBpName,u32 tostgid,const char *pToBpName);
	static WK7StageDoorInfo* GetDoorInfo(u32 stgid,const char *pBpName,u32 tostgid,const char *pToBpName);
	
	inline WK7Stage* GetPrev(void){ return (WK7Stage *)ghmGcListObj::GetPrev(); }
	inline WK7Stage* GetNext(void){ return (WK7Stage *)ghmGcListObj::GetNext(); }
	virtual u32 GetMainID(void);
	virtual u32 GetSuffix(void);
	
	bool SetPathEnable(const char *pName,bool flag);
	bool SetPathEnableOnly(const char *pName,bool flag);
	bool SetPathEnableEx(const char *pName,bool flag);
	bool SetDisablePathCamera(const char *pName,bool flag);
	
	WK7PathBranchPoint* SearchBranchPoint(const char *pBpName);
	WK7PathNurbs* SearchPath(const char *pName);
	WK7JObj* GetSelectJObj_EventNo(u32 eventno);
	
	static const char* GetStageID(const char *pStageStr,u32 &id);
	static u32 GetStageID(const char *pStageStr);
	static bool GetSelectObjName(WK7JObj *pJObj,char **ppobjname);
	
	HSD_CameraDesc* GetDefaultCameraDesc(void);
	f32 GetDefaultCameraNear(void);
	f32 GetDefaultCameraFar(void);
	static f32 GetDefaultCameraFov(void);
	bool SetDefaultCameraDesc(bool delay=false);
	bool SetDefaultSetting(void);
	static void DefaultPathChangeProcess(void);
	
	static bool ChangeStage(ghmGcTaskController *pTaskController=NULL,int prio=-1);
	
	static void TvEventTask(WK7TvEventInfo &tvEventInfo);
	static void LtvEventTask(WK7TvEventInfo &tvEventInfo);
	static HSD_TObj* GetScreenTObj(WK7JObj *pJObj);
	
	static void DoorEventTask(WK7DoorEventInfo &doorEventInfo);
	static void DoorEventTaskTerm(WK7DoorEventInfo &doorEventInfo,WK7StageDoorInfo *pDoorInfo=NULL);
	static void DoorEventTask(ghmGcTask *pTask);
	
	static void MapEventTask(WK7MapEventInfo &info);
	static void MapEventTask(ghmGcTask *pTask);
	
	static void KeyEventTask(WK7KeyEventInfo &info);
	static void KeyEventTask(ghmGcTask *pTask);
	
	static void MemoEventTask(WK7MemoEventInfo &info);
	static void MemoEventTask(ghmGcTask *pTask);
	
	static void VoiceMemoEventTask(WK7VoiceMemoEventInfo &info);
	static void VoiceMemoEventTask(ghmGcTask *pTask);
	
	static void RakuEventTask(WK7RakuEventInfo &info);
	static void RakuEventTask(ghmGcTask *pTask);
	
	static void PlayEventTask(WK7PlayEventInfo &info);
	static void PlayEventTask(ghmGcTask *pTask);
	
	static void ZanEventTask(WK7ZanEventInfo &info);
	
	static void TamaEventTask(WK7TamaEventInfo &info);
	
	inline static bool SetChanging(bool flag){
		if( mChangingStage==flag ){
			return false;
		}
		mChangingStage = flag;
		return true;
	}
	inline static bool IsChanging(void){ return mChangingStage; }
	static bool GetFileName(char *pFileName,u32 id);
	static bool GetPathFileName(char *pFileName,u32 id);
	inline virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	inline WK7CameraMotion* GetCameraMotion(void){ return mpCameraMotion; }
	inline WK7LightMotion* GetLightMotion(void){ return mpLightMotion; }
	
	virtual bool Initialize(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	// VhE{[_O
	virtual bool RenderEdgeShadow(void);
	bool RenderEdgeShadowPaint(void);
	
	inline WK7Path* GetPath(void){ return mpPath; }
	WK7PathBranchPoint* GetPathBranchPoint(const char *pBpName);
	
	int GetCameraDescNum(void);
	HSD_CameraDesc* GetCameraDesc(int index);
	HSD_CameraDesc* GetCameraDesc(const char *pName);
	
	C_LightSet* GetLightSet(int index);
	inline WK7Light* GetShadowLight(void){ return mpShadowLight; }
	bool FindShadowLight(void);
	
	WK7PathNurbs* GetPathNurbs(const char *pName);
	static WK7PathNurbs* GetPathNurbsAll(const char *pName);
	
	bool CreateEdge(void);
	inline void SetEdgeShadowVisible(bool flag){ mEdgeShadowVisible = (flag==true)? 1:0; }
	inline bool GetEdgeShadowVisible(void){ return mEdgeShadowVisible? true : false; }
	
#if FUJITA
	C_Coll CollisionCheck( Vec &_p0, Vec &_p1, f32 _frad = 10.f );
	Vec FindPath( Vec &_p0, Vec &_p1 );
	Vec GetFirstNodePos( void ){ return mFirstNodePos; }
	Vec GetFirstNodeNrm( void ){ return mFirstNodeNrm; }
	f32 GetShortestDist( void ){ return mShortestDist; }
#endif	
	bool CollisionCheck2(Vec &nowPos, Vec &nextPos);
	
	WK7PathBranchPoint* GetBranchPoint_EventNo(u32 eventno,WK7PathBranchPoint *pBranchPoint=NULL);
	virtual int SetEventEnable(u32 eventid,bool flag);
	virtual int SetEventNoEnable(u32 eventno,bool flag);
	int SetObjVisible(u32 eventid,bool flag);
	int SetObjVisibleEventNo(u32 evno,bool flag);
	WK7JObj* GetObjEventNo(u32 evno);
	int ChangeEventNo(u32 from_evno,u32 to_evno);
	
	static u32 GetBpEventNo(WK7BpInfo &info);
	static int GetBpPathNo(WK7BpInfo &info,bool next=true);
	
	static bool Clear(void);
	static bool SetCurrentStage(u32 id);
	static void SetCurrentStage(WK7Stage *pStage);
	static WK7Stage* GetCurrentStage(void);
	static bool SetCurrentPath(const char *pBpName,const char *pPathName,f32 dparam=0.0f,int initdir=WK7PATHINFO_INITDIR_TGTDIR);
	static bool SetCurrentPathToBp(const char *pBpName,const char *pPathName,f32 dparam=0.0f,int initdir=WK7PATHINFO_INITDIR_TGTDIR);
	bool SetCurrentPath(const char *pPathName,f32 param,u32 dir,int initdir);
	bool RenewPath(void);
	static bool SetCurrentPath(WK7PathNurbs *pPath,f32 param,u32 dir,int initdir);
	static bool SetCurrentPath(WK7PathNurbs *pPath=NULL,f32 param=0.0f,u32 dir=0);
	static u32 GetCurrentStageID(void);
	static void SetCurrentStageParam(u32 param){ mCurrentStageParam=param; }
	static u32 GetCurrentStageParam(void){ return mCurrentStageParam; }
	static bool SetCurrentStageBpName(const char *pName);
	static const char* GetCurrentStageBpName(void);
	static u32 GetPrevStageID(void);
	static bool SetPrevStageID(u32 id);
	static bool SetPrevStagePathName(const char *pName);
	static bool SetPrevStageBpName(const char *pName);
	static const char* GetPrevStagePathName(void);
	static const char* GetPrevStageBpName(void);
	static bool CallStageCondChange(u32 stgid);
	static bool CallCurrentStageCondChange(void);
	virtual bool CallCondChange(void);
	
	static bool DeleteTaskTerm(u32 stgid);
	
	static bool CreateStaticArchive(u32 id);
//	static bool ReleaseArchive(u32 id);
	static bool SetRenderStage(bool flag){ mRenderStage=flag; return true; }
	static bool GetRenderStage(void){ return mRenderStage; }
	
	WK7MotionObj* CreateOwnMotionObj(u32 id,int prio=WK7OBJ_DEFAULT_PRIO);
	
	WK7RenderObjEffectMessage* CreateMessage(u32 messageID,s32 iconID=-1,s32 soundID=-1);
	WK7RenderObjEffectMessage* CallMessage(u32 messageID,s32 iconID,s32 soundID);
	bool CallMessageB(u32 messageID,s32 iconID,s32 soundID);
	bool CallMessageB2(u32 messageID,s32 iconID,s32 soundID);		// messageĂяô
	bool IsValidMessage(u32 messageID);
	bool IsDisplayedMessage(u32 messageID);
	
	WK7RenderObjEffectMessage* CreateItemGet(u32 messageID,bool buttonCancel=true,s32 iconID=-1,s32 soundID=-1);
	WK7RenderObjEffectMessage* CallItemGet(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID);
	//EFFECT* CreateItemGet(u32 messageID,bool buttonCancel=true,s32 iconID=-1,s32 soundID=-1);
	//EFFECT* CallItemGet(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID);
	bool CallItemGetB(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID);
	bool CallItemGetB2(u32 messageID,bool buttonCancel,s32 iconID,s32 soundID);		// messageĂяô
	bool IsValidItemGet(u32 messageID);
	bool IsDisplayedItemGet(u32 messageID);
	
	// iCxgjIuWFNgj
	bool BrokenObj(WK7JObj *pJObj);
	bool BrokenObj(const char *pobjname);
	
	// iCxgjIuWFNgԔj
	bool BrokenFlowerObj(WK7JObj *pJObj, u32 charaid);
	bool BrokenFlowerObj(const char *pobjname, u32 charaid);
	
	// iCxgjĎJ
	bool WatchCameraB(Vec cTPos, Vec cCPos, u32 mID, int mode=0, bool setEndPathFollow=true);
	
	// iCxgju`|CgWv
	bool BranchJumpB(char *name, u32 stageid=0xfffffff);
	
	// iCxgjGx[^[f
	bool ElevatorDemoB(Vec cTPos, Vec cCPos, f32 move, u32 nextStgid=0xffffffff);
	
	// iViIPjf|[p OCxg
	bool Scn1DE2EventB(void);
	bool Scn1SK7PanelElevatorPanelB(u32 stageid);
	bool Scn1BranchJumpB(char *name);
	
	//iCxgjĎJ
	void Scn7KansiCameraCharaChangeInit(void);
	void Scn7KansiCameraCharaChangeB(Vec *pTgt1, Vec *pPos1, Vec *pTgt2, Vec *pPos2, u32 charaid);
	
	//iCxgjhAG[̃Cxg
	void DoorError(Vec *pTgt, Vec *pPos, u32 mesNo);
	
	// iCxgj̐ݒu㏈u
	void BombObj(WK7JObj *pJObj, f32 BombDist=K7STG_DEFAULT_BOMBOBJ_DIST, Vec *pPos=NULL);
	
	bool FixCam( u32 inID);
	bool CamMoveToLinearPath(u32 inID,f32 sec);
	bool CamMoveToLinearPathDelay(u32 inID,f32 delayRate);
	bool CamMoveToCirclePath(u32 inID,f32 sec);
	
	//iCxgj䂩ŒJset
	bool FixCamWithRiddle( u32 inID );
	//iCxgj䂩ŒJsetbZ[Wt
	bool FixCamMesWithRiddle( u32 inID, u32 inMesNo );
	//iCxgjŒJtbZ[W\
	bool FixCamMes( u32 inID, u32 inMesNo ,int preMesSE=-1,int postMesSE=-1);
	bool DoorClear( u32 inID, u32 inMesNo );
	bool DoorError( u32 inID, u32 inMesNo );
	
	bool FixCamMes2( u32 inID, u32 inMesNo ,int preMesSE=-1,int postMesSE=-1);
	bool DoorClear2( u32 inID, u32 inMesNo );
	bool DoorError2( u32 inID, u32 inMesNo );

	//iCxgjŒJtVXebZ[W\
	bool FixCamSysMes( u32 inID, u32 inMesNo ,int preMesSE=-1,int postMesSE=-1);
	
	//ȈՔŁEf\
	bool SimpleModelDisp( char* inModelName );
	//ȈՔŁEf\
	bool SimpleModelHide( char* inModelName );
	//ȈՔŁE[VĐ(mubN^)
	bool SimplePlayMotion( char* inModelName, int inMotNo, char* inMotionName=NULL );
	//ȈՔŁE[VĐ(ubN^)
	bool SimplePlayMotionB( char* inModelName, int inMotNo, char* inMotionName=NULL );
	//ȈՔŁE[V̍ŏ̃t[Œ~
	bool SimpleSetStartMotion( char* inModelName, int inMotNo, char* inMotionName=NULL );
	//ȈՔŁE[V̍Ō̃t[Œ~
	bool SimpleSetLastMotion( char* inModelName, int inMotNo, char* inMotionName=NULL );
	//ȈՔŁEpl\(|X^[Ȃǂ̂\镨)
	bool SimpleCallPanel( u32 inNo );
	//ȈՔŁE}bvړ
	void SimpleMapMove( s32 inFrom, s32 inTo, u32 inHideStageId=K7STGID_INVALID );
	//ȈՔŁEACe擾ʌĂяoif\tj
	void SimpleItemGetMes( u32 inMesID, char* inModel=NULL, bool inRetFollowCam=false );
	//ȈՔŁER[esbLOANV
	bool SimpleCyoPicking( char* inPosLocName, u32 inCamID, int inPickID=1 );
	//V^HS̏Љ
	bool HereComeANewHSInit( int inCheckFlag, u32 inEneNo );
	bool HereComeANewHS( int inCheckFlag, u32 inEneNo, char* inPathName, int inStartCamID, int inEndCamID, s16 inNameID, s16 inNameX, s16 inNameY, s16 inWinX, s16 inWinY, s16 inWinW, s16 inWinH );
	//ȈՔŁE}XNǔj󎞂̃J
	bool SetMskWallCam( u32 inID );
	//wPCĂ邩擾iPCMainID́jĂPCID擾iȗj
	static u32	GetAlivePcID( u32 inPcID=K7PCMAX );
	
	//iCxgjGx[^ł̈ړE
	bool ElevGetOn( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotNo, u8 inUpDown, int inSeDoor=SFX_SYS_ELEV_DOOR, int inSeMove=SFX_SYS_ELEV_MOVE );
	bool ElevGetOnMotType( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotType, u32 inMotNo, u8 inUpDown, int inSeDoor=SFX_SYS_ELEV_DOOR, int inSeMove=SFX_SYS_ELEV_MOVE );
	//iCxgjGx[^ł̈ړE~
	bool ElevGetOff( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotNo, u8 inUpDown, int inSeDoor=SFX_SYS_ELEV_DOOR, int inSeMove=SFX_SYS_ELEV_MOVE, int inSeArrive=SFX_SYS_ELEV_ARRIVE, bool inDoorLastRest=true );
	bool ElevGetOffMotType( u32 inCamID, u32 inPPosID, char* inDoorName, u32 inMotType, u32 inMotNo, u8 inUpDown, int inSeDoor=SFX_SYS_ELEV_DOOR, int inSeMove=SFX_SYS_ELEV_MOVE, int inSeArrive=SFX_SYS_ELEV_ARRIVE, bool inDoorLastRest=true );
	//LĐ
	bool PlayCharaGeki( u32 inNo, bool inChkAlready=true, bool inPreNoise=true, bool inPostNoise=true );
	//VbgL
	bool PlayOneShotCharaGeki( u32 inCamID, int inWaitTick=4800*3, bool inCharDisp=false, int inSE=-1 );
	//IuWF̔\ؑ
	bool AlphaObjChange( WK7JObj* pJObjDisp, WK7JObj* pJObjHide, u32 inTick, int inSE=-1, bool inObjNext=false, bool inZUpdate=false );

	//ߋւ̃GtFNgn
	void PastInit(u32 rgb);
	void GoThePast(u32 rgb, char *pInName=NULL, int inMotNum=0, bool inNoNoize=false);
	void BackTheCurrent(char *pInName=NULL, int inMotNum=0, bool inNoNoize=false);
	void UndispPastFilter( void );
	
	inline void SetOneShotCamLocTbl( K7StageEventOneShotCamera *inpOneShotCamera ){mpOneShotCamera=inpOneShotCamera;}
	inline void SetBrokenWallInfo(K7StageBrokenWallInfo *pInfo){ mpBrokenWallInfo = pInfo; }
	bool ChangeBrokenWallState(void);
	bool BrokeWallEvent(WK7HitObjInfo &info);
	bool ChangeKihanKuiState(void);
	bool KihanKuiEvent(WK7HitObjInfo &info);
	bool ChangeZanEventState(void);
	bool SetZanEnable(u32 zanno,bool flag);
	WK7StageZan* GetZan(u32 eventNo);
	bool SetZanEventEnable(u32 zanno,bool flag);
	
	bool SetZanEventInfo(u32 eventNo);
	
	// Lbgp̕SE([vjĐ
	bool CatWindSePlay(Vec Pos, u32 evFlah, int seID);
	
	//ViI^Cg\
	static void ScenarioTitleDisp( STAGE_TITLE inNo );
	
	//E\Nɉ΂_
	void EffectFireStart( WK7JObj* inJObj, WK7RenderObjEffect* inFire, int inCamID, WK7JObj* inJObjDisp, WK7JObj* inJObjHide );
	//E\N̉΂\
	void EffectFireDisp( WK7JObj* inJObj, WK7RenderObjEffect* inFire );
	//E\N̉΂\
	void EffectFireStop( WK7RenderObjEffect* inFire );
	
	static bool PathChangeCancel(void);
	
	static bool GalEnter(WK7DoorEventInfo &doorEventInfo);
	static bool GalEnter(u32 &id,char *pBpName);
	
	WK7StageArea* GetArea(const Vec& pos);
	u16 GetDefaultFootSE(void);
	
	virtual int GetCamSetID(void){ return -1; }
	virtual WK7CamSet* GetCamSet(u32 /*chrid*/){ return NULL; }
	
	// erL`FW̏
	static s8 InitCharChange(u8 NotCancelFlag,s32 CurrentChar,u8 SwitchOnFlag);
	
	int SetSelectObjFlag(u32 eventNo,int index,bool flag);
	int SetSelectObjFlag(u32 nextStageID,const char *pName,int index=-1,bool flag=true);
	int SetPassPathFlag(u32 nextStageID,const char *pName,int index=-1,bool flag=true);
	
	// YtAGtFNg
	bool SetupEffectLensFlare(void);
	bool CheckSetupEffectLensFlare(void);
	WK7RenderObjEffect* CreateEffectLensFlare(const char *pSunName,u32 *pRenderID=NULL);
	bool ReleaseEffectLensFlare(void);
};

//
// Stage Motion Object
//
class WK7StageMotion : public WK7MotionObj{
	friend class WK7MotionObj;
protected:
	WK7StageMotion();
	WK7StageMotion(ghmGcListObj *pAnchor,int prio=WK7OBJ_DEFAULT_PRIO);
public:
	virtual ~WK7StageMotion();
	
	inline WK7StageMotion* GetPrev(void){ return (WK7StageMotion *)ghmGcListObj::GetPrev(); }
	inline WK7StageMotion* GetNext(void){ return (WK7StageMotion *)ghmGcListObj::GetNext(); }
	
	static bool GetFileName(char *pFileName,u32 id);
	inline virtual bool GetObjFileName(char *pFileName,u32 id){ return GetFileName(pFileName,id); }
	
	static bool CreateStaticArchive(u32 id);
};

#include ".\WK7Cam.h"

#endif	//__WK7STAGE_H__

