////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// WK7TestTask.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7TESTTASK_CPP__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\WK7MainTask.h"
#include ".\WK7MenuTask.h"
#include ".\WK7TestTask.h"
#include ".\WK7Cam.h"
#include ".\WK7Item.h"
#include ".\WK7Stage.h"
#include ".\WK7Chara.h"
#include ".\WK7Model.h"
#include ".\WK7Define.h"
#include "..\Fujita\C_Font.h"
//#include "..\Lib\ghmGcFile.h"
//#include "..\Lib\ghmGcResLink.h"
//#include "..\Lib\ghmGcColl.h"

#include ".\WK7Event.h"
//#include "WK7FilmCut.h"


#define	DIRLIGHT_COLOR		{ 0xff, 0xff, 0xff, 0xff }					// color
//#define	DIRLIGHT_COLOR		{ 128, 128, 128, 0xff }					// color

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_LightDesc amb_light = {
	NULL,
	&dir_light,									// link
	LOBJ_DIFFUSE,								// flags
	LOBJ_AMBIENT,								// attnflags
	{ 0xff, 0xff, 0xff, 0xff },					// color
	NULL,										// position
	NULL,										// interest
	NULL,
};

static HSD_SceneLightSet amb_lightset = {
	&amb_light,
	NULL,
};

static HSD_WObjDesc cameyepos   = {
	NULL,
	{ 0.0f, 20.0f, 20.0f, },
	NULL,
};
static HSD_WObjDesc caminterest = {
	NULL,
	{ 0.0f, 15.0f, 0.0f, },
	NULL,
};
static HSD_CameraDescPerspective camdesc = {
	NULL,
	0,
	1,
	{ 0,640,0,480 },
	{ 0,640,0,480 },
	&cameyepos,
	&caminterest,
	0.0f,
	NULL,
	0.1f,
	1000.0f,
	42.184677f,
	1.18f,
};

static HSD_SceneCameraSet camera_set = {
	(HSD_CameraDesc *)&camdesc,	// desc
	NULL,						// anim
};

WK7Model				*gpModelTable[4];
WK7Model				*gpDanModel = NULL;

OSAlarm					testAlarm;

bool WK7TestTask::InitializeCallBack(void)
{
	ghmGcFile	file;
	ghmGcApp	*pApp = GetApplication();
	
	OSDebugReport("WK7TestTask Init : Heap = 0x%08x,0x%08x, TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),k7app.SmallGetFreeSize(),sizeof(*this));
	
	pApp->SetEnablePerfMeter (true);
	pApp->SetVisiblePerfMeter(true);
	ghmGcMem::SetRender(true);
	
	WK7RenderObj::InitializeAll();
	
	if( file.Open("CharaGeki/00020711/00020711.RSL")==true ){
//	if( file.Open("Wat/00010101.RSL")==true ){
//	if( file.Open("Wat/PlayTest.RSL")==true ){
		void		*pLinkFile;
		if( (pLinkFile=file.ReadB())!=NULL ){
			ghmGcResLink	*pResLink = new(pLinkFile) ghmGcResLink;
		}
		file.Close();
	}
	
	
	
#if 0
	if( (mpTestArchive = WK7Archive::Create())!=NULL ){
		mpTestArchive->LoadArchiveB("Wat/vis.dat");
		mpTestModel = mpTestArchive->CreateModel();
		if( mpTestModel!=NULL ){
			WK7ModelMotion	*pModelMotion = mpTestArchive->CreateModelMotion();
			if( pModelMotion!=NULL ){
				mpTestModel->AttachMotion(pModelMotion);
				mpTestModel->PlayMotion();
				mpTestModel->SetMotionLoop(true);
				delete pModelMotion;
			}
		}
		HSD_CameraDesc	*pCameraDesc = mpTestArchive->GetCameraDesc(0);
		if( pCameraDesc!=NULL ){
			WK7CAM->SetDesc(pCameraDesc);
		}
		WK7LightMotion	*pLightMotion = mpTestArchive->CreateLightMotion();
		C_LightSet		*pLightSet = NULL;
		if( pLightMotion!=NULL ){
			const char	*pLightName = pLightMotion->GetAnimName(0);
			if( pLightName!=NULL ){
				pLightSet = mpTestArchive->GetLightSet(pLightName);
			}else{
				pLightSet = mpTestArchive->GetLightSet(0);
			}
		}else{
			pLightSet = mpTestArchive->GetLightSet(0);
		}
		WK7Light		*pLight = NULL;
		if( pLightSet!=NULL ){
			pLight = WK7Light::Create(pLightSet,0xffffffff,0xffffffff);
		}
		if( pLight!=NULL && pLightMotion!=NULL ){
			pLight->AttachMotion(pLightMotion);
			pLight->PlayMotion  ();
			pLight->SetMotionLoop(true);
			delete pLightMotion;
		}
	}
#endif
	
	if( (mpPointArchive = WK7Archive::Create())!=NULL ){
		mpPointArchive->LoadArchiveB("/Wat/crystal.dat");
		mpPointModel = mpPointArchive->CreateModel();
	}
	
	int		index = 0;
#if 0
	if( (mpPlaneArchive = WK7Archive::Create())!=NULL ){
		mpPlaneArchive->LoadArchiveB("Wat/plane.dat");
		mpPlaneModel = mpPlaneArchive->CreateModel();
		gpModelTable[index++] = mpPlaneModel;
	}
	
	if( (mpBoxArchive = WK7Archive::Create())!=NULL ){
		mpBoxArchive->LoadArchiveB("Wat/box.dat");
		mpBoxModel = mpBoxArchive->CreateModel();
		gpModelTable[index++] = mpBoxModel;
	}
	
	if( (mpSphereArchive = WK7Archive::Create())!=NULL ){
		mpSphereArchive->LoadArchiveB("Wat/sphere.dat");
		mpSphereModel = mpSphereArchive->CreateModel();
		gpModelTable[index++] = mpSphereModel;
	}
	
	WK7Archive				*pDanArchive;
	if( (pDanArchive= WK7Archive::Create())!=NULL ){
		pDanArchive->LoadArchiveB("3Ddata/Model/Chara/Dan/Dan_M00.dat");
		gpDanModel = pDanArchive->CreateModel();
		if( gpDanModel!=NULL ){
			WK7JObj		*pJObj = gpDanModel->GetObj(K7CHRBONE_WRIST_R);
			if( pJObj!=NULL ){
				mpSphereModel->Attach(pJObj);
			}
		}
		gpModelTable[index++] = gpDanModel;
	}
#endif
	
	while( index < 4 ){
		gpModelTable[index++] = NULL;
	}
	
	WK7CAM->SetRenderFlag(true);
	WK7CAM->EnterDebugMode();
	
	ghmGcMemSetAllocName("C_LObj");
	mpLObj       = new C_LObj(new (&amb_lightset       ) C_LightSet);
	
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageFullColor.AllocBuffer();
	screenImageFullColor.ScreenCopy();
	
 	return true;
}

bool WK7TestTask::TerminateCallBack(void)
{
	ghmGcApp			*pApp = GetApplication();
	
	GHM_SAFE_DELETE(mpTestModel  );
	GHM_SAFE_DELETE(mpPointModel );
	
	for(int i=0 ; i<4 ; i++){
		GHM_SAFE_DELETE(gpModelTable[i]);
	}
	
	GHM_SAFE_DELETE(mpLObj);
	
	WK7RenderObj::TerminateAll();
	
	WK7Archive::ReleaseAll();
	
	delete this;
	
	ghmGcMemSetAllocName("MenuTask");
//	new WK7MainTask(pApp);
	new WK7MenuTask(pApp);
	
	K7AppDumpMemory();
	
	return true;
}

void testtask3(ghmGcTask *pTask);
void testtask3(ghmGcTask *pTask)
{
#pragma unused(pTask)
	K7AppDebugPrint("task3");
}

static	int		testtask2cnt = 0;
void testtask2(ghmGcTask *pTask);
void testtask2(ghmGcTask *pTask)
{
#pragma unused(pTask)
	ghmGcTaskController	*pTaskController = (ghmGcTaskController *)GHMGCTASK_GETPARAM(0);
	char				str[64];
	sprintf(str,"%d\n",testtask2cnt++);
	K7AppDebugPrint(str);
	pTaskController->StartIM(testtask3);
}

void testtask(ghmGcTask *pTask);
void testtask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	WK7Item		*pItem = (WK7Item *)GHMGCTASK_GETPARAM(0);
	Vec			pos,vel;
	int			count;
	pos.x = 0.0f;
	pos.y = 5.0f;
	pos.z = 0.0f;
	vel.x = (HSD_Randf() * 1.0f) - 0.5f;
	vel.y = 1.0f;
	vel.z = (HSD_Randf() * 1.0f) - 0.5f;
	pItem->SetRenderFlag(true);
	
	for(count=200 ; count>0 ; count--){
		
		pItem->SetPosition(pos);
		
		GHMGCTASK_RETSYS();
		
		pos.x += vel.x;
		pos.y += vel.y;
		pos.z += vel.z;
		
		vel.y -= 0.02f;
		
		
	}
	
	GHM_SAFE_DELETE(pItem);
}

static	bool	alarmSW = false;
volatile	static	int		alarmCount = 0;
volatile	static	int		vsyncCount = 0;
static void alarmHandler(OSAlarm* alarm, OSContext* context);
static void alarmHandler(OSAlarm* alarm, OSContext* context)
{
#pragma	unused(alarm)
#pragma	unused(context)
	alarmCount++;
}

#if 0
int		testDataSize = -1;
int		testDataEqualSize = -1;
void	*pTestData[2] = { 0,};
#endif

bool WK7TestTask::FrameProcess(void)
{
//	if( HSD_PadGetTrigger(0) & PAD_BUTTON_X ){
//		if( DeleteTerminate()==true ){
//			return true;
//		}
//	}
	
	int		i;
#if 0
static	ghmGcFile		*pfile = NULL;
	
	if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
		if( testDataSize < 0 ){
			GHM_SAFE_DELETE(pfile);
			if( (pfile=new ghmGcFile)!=NULL ){
				if( pfile->Open("/CharaGeki/03010101/03010101_00.pak")==true ){
					pTestData[0] = pfile->Read();
					testDataSize = pfile->GetLength();
					pTestData[1] = ghmGcMemAlloc(testDataSize);
				}
			}
		}
	}
	if( HSD_PadGetTrigger(1) & HSD_PAD_Y ){
static	bool	readproc = false;
		if( readproc==false ){
			if( pTestData[1]!=NULL ){
				pfile->Close();
				if( pfile->Open("/CharaGeki/03010101/03010101_00.pak")==true ){
					memset(pTestData[1],'A',testDataSize);
					pfile->Read(pTestData[1]);
					readproc = true;
				}
			}
		}else{
			if( pfile->Cancel()==true ){
				readproc = false;
			}
		}
	}
	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
		if( pTestData[0] != NULL && pTestData[1] != NULL ){
			u8		*pData[2];
			pData[0] = (u8 *)pTestData[0];
			pData[1] = (u8 *)pTestData[1];
			for(i=0 ; i<testDataSize ; i++,pData[0]++,pData[1]++){
				if( *(pData[0]) != *(pData[1]) ){
					break;
				}
			}
			testDataEqualSize = i;
		}
	}
#endif
	
	vsyncCount++;
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		if( alarmSW==false ){
			u64		time = OS_TIMER_CLOCK;
			time /= WK7_FRAME_RATE;
		 	OSSetPeriodicAlarm(&testAlarm,OSGetTime(),OS_TIMER_CLOCK / WK7_FRAME_RATE,alarmHandler);
		 	alarmSW = true;
			alarmCount = 0;
			vsyncCount = 0;
		}else{
		 	OSCancelAlarm (&testAlarm);
		 	alarmSW = false;
		}
	}
	
	// fobOJ؂ւ
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		if( WK7CAM->IsDebugMode()==true ){
			WK7CAM->ExitDebugMode();
		}else{
			WK7CAM->EnterDebugMode();
		}
	}
	
//static WK7Stage	*pStage = NULL;
//	if( pStage==NULL ){
//		if( (pStage=WK7RenderObj::CreateStage(K7STGID(10,0)))!=NULL ){
//			pStage->SetRenderFlag(true);
//		}
//	}
static WK7Chara	*pChara = NULL;
	if( pChara==NULL ){
		if( (pChara=WK7RenderObj::CreateChara(K7CHRID(K7ENMID(2),0)))!=NULL ){
			pChara->SetRenderFlag(true);
		}
	}
#define	MOTID			( 20)
//#define	MOTID			(100)
static WK7Archive	*pMotionArchive = NULL;
	if( pMotionArchive==NULL ){
		WK7CharaMotion::CreateStaticArchive(K7MOTID(K7ENMID(2),MOTID));
		pMotionArchive = WK7Archive::Find(K7OBJTYPE_CHR,K7MOTID(K7ENMID(2),MOTID));
	}
static WK7CharaMotion	*pCharaMotion = NULL;
	if( pCharaMotion==NULL ){
		pCharaMotion = WK7MotionObj::CreateCharaMotion(K7MOTID(K7ENMID(2),MOTID));
	}
static WK7Archive		*pMotionArchive2[3] = { NULL, };
static WK7ModelMotion	*pModelMotion2  [3] = { NULL, };
static const char		*pMotionName[3] = { "/Wat/HS_BindPose.dat", "/Wat/HS_ArmDownL.dat", "/Wat/HS_ArmDownR.dat" };
static const char		*pJointName[3] = { "Root", "HumerusL_joint1", "HumerusR_joint1" };
	for(i=0 ; i<3 ; i++){
		if( pMotionArchive2[i]==NULL ){
			if( (pMotionArchive2[i] = WK7Archive::Create())!=NULL ){
				pMotionArchive2[i]->LoadArchiveB(pMotionName[i]);
			}
		}else{
			if( pModelMotion2[i]==NULL ){
				pModelMotion2[i] = pMotionArchive2[i]->CreateModelMotion();
			}
		}
	}
static WK7Archive	*pItemArchive = NULL;
	if( pItemArchive==NULL ){
		WK7Item::CreateStaticArchive(K7ITEMID(500,0));
		pItemArchive = WK7Archive::Find(K7OBJTYPE_ITEM,K7ITEMID(500,0));
	}
//	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
//		mTaskController.StartIM(testtask2,(u32)&mTaskController);
//	}
static	int		cnt = -1;
	if( cnt >= 0 ){
		cnt++;
	}
	if( 0 ){
//	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
//		cnt = 0;
		if( pMotionArchive!=NULL && pChara!=NULL ){
			WK7Model		*pModel       = pChara->GetModel();
			WK7ModelMotion	*pModelMotion = pCharaMotion->GetModelMotion();
			if( pModel!=NULL && pModelMotion!=NULL ){
				pModel->AttachMotion(pModelMotion);
				pModel->PlayMotion  ();
				pModel->SetMotionLoop(true);
			}
		}
	}
	
	for(i=0 ; i<3 ; i++){
		switch( i ){
		case	0:
			if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
				break;
			}
			continue;
		case	1:
			if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
				break;
			}
			continue;
		case	2:
			if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
				break;
			}
			continue;
		default:
			continue;
		}
		if( pModelMotion2[i]==NULL || pChara==NULL ){
			continue;
		}
		WK7Model		*pModel = pChara->GetModel();
		if( pModel==NULL ){
			continue;
		}
		WK7JObj			*pJObj;
		bool			loop;
		switch( i ){
		case	0:
			pModel->AttachMotion(pModelMotion2[i]);
			loop = true;
			break;
		default:
			pModel->AttachMotion(pModelMotion2[i],true);
			loop = false;
			break;
		}
		if( (pJObj = pModel->GetObj(pJointName[i]))!=NULL ){
			pJObj->PlayMotion   (false,true);
			pJObj->SetMotionLoop(loop,false,true);
		}
	}
	if( cnt > 0 && (cnt & 1) ){
//	if( (cnt % 3)==0 ){
		WK7Item		*pItem;
		if( (pItem = WK7RenderObj::CreateItem(K7ITEMID(500,0)))!=NULL ){
			mTaskController.Start(testtask,(u32)pItem);
			
		}
	}
	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_START ){
//		if( gpDanModel != NULL ){
//			for(int i=0 ; i<4 ; i++){
//				if( gpModelTable[i]==gpDanModel ){
//					GHM_SAFE_DELETE(gpModelTable[i]);
//					gpDanModel = NULL;
//					break;
//				}
//			}
//		}
//	}
	
	WK7CAM->SetCurrent();
	
//	TestFrameProcess();
	
	// J
	WK7CAM->FrameProcess();
	
	// Cg
	WK7Light::FrameProcessAll();
	
	// A[JCuf[^
	WK7Archive::FrameProcessAll();
	
	WK7MotionObj::FrameProcessAll();
	WK7RenderObj::FrameProcessAll();
	
	// Aj[Vs
	if( mpTestModel != NULL ){
		mpTestModel->FrameProcess();
	}
	if( mpPointModel!=NULL ){
		mpPointModel->FrameProcess();
	}
	if( mpPlaneModel != NULL ){
		mpPlaneModel->FrameProcess();
	}
	if( mpBoxModel != NULL ){
		mpBoxModel->FrameProcess();
	}
	if( mpSphereModel != NULL ){
		mpSphereModel->FrameProcess();
	}
	if( gpDanModel!=NULL ){
		gpDanModel->FrameProcess();
	}
	
	return true;
}

static	Mtx			view2d;
static	Mtx44		proj2d;
bool WK7TestTask::SetCamera2D(float nearz,float farz)
{
	Mtx			view;
	Mtx44		proj;
	
#if 1
	Vec			vPos;
	Vec			vUp;
	Vec			vAt;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z =    0.0f;		// K
//	vPos.z = -300.0f;		// K
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =  300.0f;
//	vAt .z =    0.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-WK7_SCREEN_HEIGHT,0,WK7_SCREEN_WIDTH,nearz,farz);
#else
	MTXIdentity     (view);
	view[2][3] = -300.f;
	MTXOrtho        (proj,0,WK7_	SCREEN_HEIGHT,0,WK7_SCREEN_WIDTH,nearz,farz);
#endif
	
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
	
	memcpy(view2d,view,sizeof(view2d));
	memcpy(proj2d,proj,sizeof(proj2d));
	
	return true;
}

bool WK7TestTask::RenderProcess(void)
{
//	int			i;
	
	{
		C_Paper		paper(0,0);
		
		PRINTF("\n\n  i %d-%02d(%d)\n",alarmCount / WK7_FRAME_RATE,alarmCount % (int)WK7_FRAME_RATE,alarmCount);
		PRINTF(    "  v %d-%02d(%d)\n",vsyncCount / WK7_FRAME_RATE,vsyncCount % (int)WK7_FRAME_RATE,vsyncCount);
		
//		PRINTF("\n\n  testData = %d,%d\n",testDataSize,testDataEqualSize);
//		PRINTF("\n\n  DevCom   = %08x,%08x\n",HSD_DevComIsBusy(1),HSD_DevComIsBusy(2));
	}
	
#if 0
	SetCamera2D();
#endif
	
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	// _OJn
	HSD_StateSetDither(TRUE);
	HSD_StartRender(HSD_RP_SCREEN);
	HSD_SetZSortMode(true,false);
    HSD_StateSetAlphaUpdate(GX_TRUE);
	HSD_StateSetAlphaCompare(GX_ALWAYS,0xff,GX_AOP_OR,GX_ALWAYS,0xff);
	
	GXSetCopyFilter(GX_FALSE,NULL,GX_FALSE,NULL);
	HSD_StateSetDither(GX_FALSE);
	GXSetDither    (GX_FALSE);
	
	// JgJݒ
	if( WK7CAM->SetCurrent()==true ){
		
		// Jݒ肪\L̈Ȃ`
		
		C_LObj::DispStart();
		
		// Cgo^
		if( mpLObj != NULL ){
			HSD_LObj	*pLObj = mpLObj->GetLObj();
			HSD_LObjSetCurrentAll(pLObj);
		}
		
		if( mpPlaneModel != NULL ){
			mpPlaneModel->RenderProcess();
		}
		if( mpBoxModel != NULL ){
			mpBoxModel->RenderProcess();
		}
		if( mpSphereModel != NULL ){
			mpSphereModel->RenderProcess();
		}
		if( gpDanModel!=NULL ){
			gpDanModel->RenderProcess();
		}
		
		C_LObj::DispEnd();
		
		WK7RenderObj::RenderProcessAll();
		
		HSD_StateSetDstAlpha(GX_TRUE,0xff);
	    HSD_StateSetAlphaUpdate(GX_TRUE);
		if( mpPointModel!=NULL ){
			mpPointModel->RenderProcess();
		}
		
		HSD_StateSetDstAlpha(GX_TRUE,0x30);
	    HSD_StateSetAlphaUpdate(GX_TRUE);
		if( mpTestModel != NULL ){
			mpTestModel->RenderProcess();
		}
		
		HSD_StateSetDstAlpha(GX_TRUE,0x80);
	    HSD_StateSetAlphaUpdate(GX_TRUE);
		WK7CAM->RenderProcess();
		
		// JgJł̕`I
		WK7CAM->EndCurrent();
		
	}
	
	// _OI
	HSD_EndRender();
	
	screenImageFullColor.ScreenCopy();
	
//	TestRenderProcess();
	
	// ^XNRg[
	mTaskController.FrameProcess();
	
	return true;
}

WK7TestTask::WK7TestTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	mpLObj             = NULL;
	mpPointArchive     = NULL;
	mpPointModel       = NULL;
	mpTestArchive      = NULL;
	mpTestModel        = NULL;
	mpPlaneArchive     = NULL;
	mpPlaneModel       = NULL;
	mpBoxArchive       = NULL;
	mpBoxModel         = NULL;
	mpSphereArchive    = NULL;
	mpSphereModel      = NULL;
}

WK7TestTask::~WK7TestTask()
{
}

#define	MOV_SPD_MIN			(0.125f)
#define	MOV_SPD_DEFAULT		(MOV_SPD_MIN * 4.0f)
#define	ROT_SPD_MIN			(0.03125f)
#define	ROT_SPD_DEFAULT		(0.03125f)

static int	model_id = 0;
static f32	mov_speed = MOV_SPD_DEFAULT;
static f32	rot_speed = ROT_SPD_DEFAULT;
bool WK7TestTask::TestFrameProcess(void)
{
	WK7Model		*pControlModel;
	Vec				pos,rot;
	Vec				campos,camtgt,camdir;
	
	if( HSD_PadGetTrigger(1) & HSD_PAD_X ){
		model_id = (model_id+1) % 4;
	}
	
	if( (pControlModel=gpModelTable[model_id])!=NULL ){
		
		if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
			mov_speed *= 2.0f;
		}
		if( HSD_PadGetTrigger(1) & HSD_PAD_LEFT ){
			mov_speed *= 0.5f;
		}
		if( mov_speed < MOV_SPD_MIN ){
			mov_speed = MOV_SPD_MIN;
		}
		
		pControlModel->GetPosition(pos);
		pControlModel->GetRotation(rot);
		
		WK7CAM->GetPosition      (campos);
		WK7CAM->GetTargetPosition(camtgt);
		VECSubtract (&camtgt,&campos,&camdir);
		VECNormalize(&camdir,&camdir);
		
		f32		px,py;
		f32		ana_r,ana_l;
		
		px = HSD_PadGetNormalStickX(1);
		py = HSD_PadGetNormalStickY(1);
		
		if( px != 0.0f || py != 0.0f ){
			
			Vec		movevec;
			
			movevec.x = py * camdir.x - px * camdir.z;
			movevec.z = py * camdir.z + px * camdir.x;
			
			pos.x += mov_speed * movevec.x;
			pos.z += mov_speed * movevec.z;
			
		}
		
		if( (ana_r=HSD_PadGetNormalAnalogR(1)) > 0.0f ){
			pos.y += ana_r * mov_speed;
		}
		if( (ana_l=HSD_PadGetNormalAnalogL(1)) > 0.0f ){
			pos.y -= ana_l * mov_speed;
		}
		
		px = HSD_PadGetNormalSubStickX(1);
		py = HSD_PadGetNormalSubStickY(1);
		
		rot.y += rot_speed * px;
		rot.x += rot_speed * py;
		
		GHM_LIMIT_RANGE(rot.x,PI,-PI);
		GHM_LIMIT_RANGE(rot.y,PI,-PI);
		
		pControlModel->SetPosition(pos);
		pControlModel->SetRotation(rot);
		
	}
	
#if 0
static Vec		movcampos = { 0.0f,10.0f,10.0f };
static Vec		movtgtpos = { 0.0f, 0.0f, 0.0f };
static f32		totalframe = 60.0f;
static f32		delayRate  = 0.125f;
	
	if( HSD_PadGetTrigger(0) & HSD_PAD_X ){
		WK7CAM->StartLinearInterpolateOnLinearPath(movcampos,movtgtpos,totalframe);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		WK7CAM->StartDelayInterpolateOnLinearPath(movcampos,movtgtpos,delayRate);
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Z ){
		WK7CAM->StartLinearInterpolateOnCirclePath(movcampos,movtgtpos,totalframe);
	}
#endif
	
	return true;
}

bool WK7TestTask::TestRenderProcess(void)
{
	ghmGcPlane		plane;
	ghmGcCollPoint	point;
	ghmGcCollSphere	sphere;
	ghmGcCollBox	box;
	WK7JObj			*pJObj;
	HSD_JObj		*pHSDJObj;
	HSD_CObj		*pCObj;
	const char		*pType,*pResult,*pViewClip;
	int				i,j,result;
	u32				clip;
	C_Paper			paper(0,0);
	
	mpSphereModel->GetPosition(sphere.mPosition);
	sphere.mRadius  = 10.0f;
	point.mPosition = sphere.mPosition;
	
	box.mExtent.x = 15.0f * 0.5f;
	box.mExtent.y = 10.0f * 0.5f;
	box.mExtent.z = 18.0f * 0.5f;
	if( (pJObj = mpBoxModel->GetObj((int)0))!=NULL && (pHSDJObj=pJObj->GetJObj())!=NULL ){
		MTXCopy(HSD_JObjGetMtxPtr(pHSDJObj),box.mCoordinate);
	}
	if( (pJObj = mpPlaneModel->GetObj((int)0))!=NULL && (pHSDJObj=pJObj->GetJObj())!=NULL ){
		Mtx		mtx;
		MTXCopy(HSD_JObjGetMtxPtr(pHSDJObj),mtx);
		plane.mNormal.x = mtx[0][1];
		plane.mNormal.y = mtx[1][1];
		plane.mNormal.z = mtx[2][1];
		VECNormalize(&plane.mNormal,&plane.mNormal);
		plane.mPosition.x = mtx[0][3];
		plane.mPosition.y = mtx[1][3];
		plane.mPosition.z = mtx[2][3];
	}
	
	ghmGcPlane	view_plane[6];
	Vec			campos,camtgt,camdir;
	ghmGcPlane	*pview_plane;
	f32			n,f,aspect,fov;
	
	WK7CAM->GetPosition      (campos);
	WK7CAM->GetTargetPosition(camtgt);
	VECSubtract(&camtgt,&campos,&camdir);
	VECNormalize(&camdir,&camdir);
	
#if 0
static f32		aspect0 = 1.0f;
	WK7CAM->SetAspect(aspect0);
	WK7CAM->SetFov(60.0f);
#endif
	
	n      = WK7CAM->GetNear  ();
	f      = WK7CAM->GetFar   ();
	aspect = WK7CAM->GetAspect();
	fov    = WK7CAM->GetFov   () * (0.5f * PI / 180.0f);
	pCObj  = WK7CAM->GetCObj();
	
#if 0
static	HSD_RectU16		scissor  = { 160,480,120,360 };
static	HSD_RectS16		viewport = { 160,480,120,360 };
//static	HSD_RectU16		scissor  = { 0,640,0,480 };
//static	HSD_RectS16		viewport = { 0,640,0,480 };
	
	HSD_CObjSetScissor (pCObj,&scissor );
	HSD_CObjSetViewport(pCObj,&viewport);
#endif
	
	Vec			frame_vec[4];
	Vec			vdir,hdir,fdir;
	Mtx			inv_vm;
	Vec			*pframe_vec;
	
	fdir        .x =  0.0f;
	fdir        .y =  0.0f;
	fdir        .z = -1.0f;
	frame_vec[0].x =  0.0f;
	frame_vec[0].y =  tanf(fov);
	frame_vec[0].z =  fdir.z;
	frame_vec[1].x =  frame_vec[0].x;
	frame_vec[1].y = -frame_vec[0].y;
	frame_vec[1].z =  frame_vec[0].z;
	frame_vec[2].x =  frame_vec[0].y * aspect;
	frame_vec[2].y =  0.0f;
	frame_vec[2].z =  frame_vec[0].z;
	frame_vec[3].x = -frame_vec[2].x;
	frame_vec[3].y =  frame_vec[2].y;
	frame_vec[3].z =  frame_vec[2].z;
	
	VECCrossProduct(&fdir,&frame_vec[3],&vdir);
	VECCrossProduct(&fdir,&frame_vec[0],&hdir);
	VECNormalize(&vdir,&vdir);
	VECNormalize(&hdir,&hdir);
	
	VECCrossProduct(&hdir,&frame_vec[0],&frame_vec[0]);
	VECCrossProduct(&frame_vec[1],&hdir,&frame_vec[1]);
	VECCrossProduct(&frame_vec[2],&vdir,&frame_vec[2]);
	VECCrossProduct(&vdir,&frame_vec[3],&frame_vec[3]);
	
	MTXTranspose(pCObj->mtx,inv_vm);
	for(i=0 ; i<4 ; i++){
		MTXMultVecSR(inv_vm,&frame_vec[i],&frame_vec[i]);
		VECNormalize(&frame_vec[i],&frame_vec[i]);
	}
	
	pframe_vec  = frame_vec;
	pview_plane = view_plane;
	// near
	VECScale(&camdir,&pview_plane->mNormal,-1.0f);
	VECScale(&camdir,&pview_plane->mPosition,n);
	VECAdd  (&campos,&pview_plane->mPosition,&pview_plane->mPosition);
	pview_plane++;
	
	// far
	VECScale(&camdir,&pview_plane->mNormal, 1.0f);
	VECScale(&camdir,&pview_plane->mPosition,f);
	VECAdd  (&campos,&pview_plane->mPosition,&pview_plane->mPosition);
	pview_plane++;
	
	// up
	pview_plane->mNormal   = *pframe_vec++;
	pview_plane->mPosition = campos;
	pview_plane++;
	
	// down
	pview_plane->mNormal   = *pframe_vec++;
	pview_plane->mPosition = campos;
	pview_plane++;
	
	// right
	pview_plane->mNormal   = *pframe_vec++;
	pview_plane->mPosition = campos;
	pview_plane++;
	
	// left
	pview_plane->mNormal   = *pframe_vec++;
	pview_plane->mPosition = campos;
	pview_plane++;
	
	ghmGcViewVolume		vv;
	
	vv.SetCurrent(pCObj);
	
	PRINTF("\n\n");
	for(i=0 ; i<3 ; i++){
		
static int method = 0;
if( method ){
		clip = 0;
		for(j=0,pview_plane=view_plane ; j<6 ; j++,pview_plane++){
			switch( i ){
			case	0:
				result = point.GetCrossState(*pview_plane);
				break;
			case	1:
				result = sphere.GetCrossState(*pview_plane);
				break;
			case	2:
				result = box.GetCrossState(*pview_plane);
				break;
			default:
				continue;
			}
			if( result==ghmGcCollObj::OUTSIDE ){
				clip |= 1<<j;
			}
		}
		if( !clip ){
			pViewClip = "Inside";
		}else{
			pViewClip = "Outside";
		}
}else{
		switch( i ){
		case	0:
			result = vv.GetCrossState(point);
			break;
		case	1:
			result = vv.GetCrossState(sphere);
			break;
		case	2:
			result = vv.GetCrossState(box);
			break;
		default:
			continue;
		}
		switch( result ){
		case	ghmGcCollObj::OUTSIDE:
			pViewClip = "Outside";
			break;
		case	ghmGcCollObj::CROSSOVER:
			pViewClip = "Cross Over";
			break;
		case	ghmGcCollObj::INSIDE:
			pViewClip = "Inside";
			break;
		default:
			pViewClip = "Unknown";
			break;
		}
		clip = (u32)result;
}
		
		switch( i ){
		case	0:
			result = point.GetCrossState(plane);
			pType = "Plane-point";
			break;
		case	1:
			result = sphere.GetCrossState(plane);
			pType = "Plane-sphere";
			break;
		case	2:
			result = box.GetCrossState(plane);
			pType = "Plane-box";
			break;
		default:
			pType = "Invalid Type";
			break;
		}
		
		
		switch( result ){
		case	ghmGcCollObj::OUTSIDE:
			pResult = "Outside";
			break;
		case	ghmGcCollObj::CROSSOVER:
			pResult = "Cross Over";
			break;
		case	ghmGcCollObj::INSIDE:
			pResult = "Inside";
			break;
		default:
			pResult = "Unknown";
			break;
		}
		PRINTF(" %12s:%10s,vv(%s %02x)\n",pType,pResult,pViewClip,clip);
		
	}
	
	
	
	
	return true;
}

