////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Test Task
//
// WK7TestTask.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 11/09/2002
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7TESTTASK_H__
#define	__WK7TESTTASK_H__

//#include "..\Lib\ghmGcAppTask.h"
//#include "..\Lib\ghmGcMem.h"
//#include "..\Lib\ghmGcTex.h"
//#include "..\Lib\ghmGcUsb.h"
//#include "..\Lib\ghmGcNurbs.h"
//#include "..\Lib\ghmGcTask.h"

#include ".\WK7Path.h"
#include ".\WK7Archive.h"
#include ".\WK7Light.h"

class WK7TestTask : public ghmGcAppTask{
protected:
	GhmGcTexHeader				*mpTexture;
	GXTexObj					mTexObj;
	
	ghmGcNurbs					mNurbsCurve;
	
	WK7Archive					*mpPointArchive;
	WK7Model					*mpPointModel;
	
	C_LObj						*mpLObj;
	
	ghmGcTaskController			mTaskController;
	
	WK7Archive					*mpTestArchive;
	WK7Model					*mpTestModel;
	
	WK7Archive					*mpPlaneArchive;
	WK7Model					*mpPlaneModel;
	
	WK7Archive					*mpBoxArchive;
	WK7Model					*mpBoxModel;
	
	WK7Archive					*mpSphereArchive;
	WK7Model					*mpSphereModel;
	
	bool SetCamera2D(float nearz=100.0f,float farz=1000.0f);
	
	bool TestFrameProcess(void);
	bool TestRenderProcess(void);
public:
	static bool SetCamera2D(float nearz=0.0f,float farz=1000.0f);
	WK7TestTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~WK7TestTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
	
	GXTexObj* GetTexObj(void){ return &mTexObj; }
};

#endif	//__WK7TESTTASK_H__

