////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Zanryu Shinen Object
//
// WK7Zan.cpp
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7ZAN_CPP__

//#include <dolphin.h>
#include ".\WK7Zan.h"
#include ".\WK7Stage.h"
#include ".\WK7Cam.h"
#include ".\WK7Player.h"
#include ".\K7ID.h"
#include ".\K7GlobalFlag.h"
#include ".\WK7Event.h"
#include "..\fujita\C_Font.h"
#include "..\fujita\C_SetAlpha.h"
#include "..\Matsu\MK7Sound.h"
#include "..\Matsu\MK7EngTelop.h"
#include "..\Matsu\MK7Jimaku.h"
#include "..\Matsu\MK7CharaDisp.h"
#include "..\Matsu\MK7Noise.h"
#include "..\Yam\YK7EffectConveBlood2.h"

#ifdef	_DEBUG
bool	WK7Zan::mDebugInfo = false;
//bool	WK7Zan::mDebugInfo = true;
#endif

#define	WK7ZANCPINF_START()								WK7ZanCharaPresentInfo	zanCharaPresentInfo[] = {
#define	WK7ZANCPINF(zanid,t,nid,nx,ny,wx,wy,ww,wh,fl)		{ 0x##zanid,(t),(nid),(nx),(ny),(wx),(wy),(ww),(wh),(fl) },
#define	WK7ZANCPINF_END()								{ 0xffffffff,0xffffffff,0xffffffff,0,0,0.0f,0.0f,0.0f,0.0f,-1} };

// cvOLN^Љf[^ ////////////////////////////////////////////////
WK7ZANCPINF_START()
#include "..\Stage\info\K7StageZanInfo.h"
WK7ZANCPINF_END()
// cvOLN^Љf[^ ////////////////////////////////////////////////

#ifndef	K7APP_MASTER
#define	WK7ZAN_COUNTHISTORY_NUM		(2)
static	u32		countHistry[WK7ZAN_COUNTHISTORY_NUM];
static	bool	history = false;
#endif
f32		WK7ZAN_FADE_ALPHA = 0.8f;

WK7Zan::WK7Zan(u32 id,const Vec &pos,const Vec &rot,u32 mesid)
{
	mCharaID         = 0xffffffff;
	mCharaVisible    = true;
	mCharaLoadCancel = false;
	mStartRequest    = false;
	mCharaCreate     = true;
	mID              = id;
	mResourceID      = id;
	mMesID           = mesid;
	mParam           = 0xffffffff;
	mStayType        = true;
	mpChara          = NULL;
	mpCharaMotion    = NULL;
	mpBloodEffect    = NULL;
	mState           = INIT;
	mRot             = rot;
	mPos             = pos;
	mOldBgmID        = -1;
	mPlayStream      = -1;
	mpAlpha          = NULL;
	mpFile           = NULL;
	mpJimakuData     = NULL;
	mpTelopData      = NULL;
	mpNameData       = NULL;
	mpResLink        = NULL;
	mpCurrentZanInfo = NULL;
	mpStageZan       = NULL;
	mPrevForcedDisp  = false;
	mCounter         = 0xffffffff;
	mWaitCounter     = 0;
	mMasterVolumeSE  = SOUND_MASTER_VOLUME;
//	mCinemaScopeRate.SetValue(0.0f);
	mStreamCounter  .SetValue(0);
	mAlpha          .SetValue(0.0f);
#ifndef	K7APP_MASTER
	memset(countHistry,0,sizeof(countHistry));
	history = false;
#endif
}

WK7Zan::~WK7Zan()
{
	Terminate();
//	GHM_SAFE_DELETE   (mpAlpha);
//	GHM_SAFE_DELETE   (mpChara);
//	GHM_SAFE_DELETE   (mpCharaMotion);
//	GHM_SAFE_DELETE   (mpFile );
//	GHM_SAFE_DELETE   (mpResLink);
//	GHMGCMEM_SAFE_FREE(mpJimakuData);
//	GHMGCMEM_SAFE_FREE(mpTelopData );
}

//u32 WK7Zan::GetCharaID(WK7Zan::Type type)
//{
//	u32		id;
//	switch( type ){
//	case	ZA1L: id=K7CHRID(K7ZA1,0); break;
//	case	ZA1R: id=K7CHRID(K7ZA1,0); break;
//	case	ZA2 : id=K7CHRID(K7ZA3,0); break;
//	case	ZA3 : id=K7CHRID(K7ZA2,0); break;
////	case	ZA2 : id=K7CHRID(K7ZA2,0); break;
////	case	ZA3 : id=K7CHRID(K7ZA3,0); break;
//	case	ZA4 : id=K7CHRID(K7ZA4,0); break;
//	case	ZA4Y: id=K7CHRID(K7ZA4,0); break;
//	case	ZA4L: id=K7CHRID(K7ZA4,0); break;
//	case	ZA4R: id=K7CHRID(K7ZA4,0); break;
//	case	ZA5 : id=K7CHRID(K7ZA5,0); break;
//	case	BAN : id=K7CHRID(K7BAN,0); break;
//		break;
//	default:
//		return 0xffffffff;
//	}
//	return id;
//}

//u32 WK7Zan::GetMotID(WK7Zan::Type type)
//{
//	u32		id;
//	switch( type ){
//	case	ZA1L: id=K7MOTID(K7ZA1,  20); break;
//	case	ZA1R: id=K7MOTID(K7ZA1,  25); break;
//	case	ZA2 : id=K7MOTID(K7ZA3,  20); break;
//	case	ZA3 : id=K7MOTID(K7ZA2,  20); break;
////	case	ZA2 : id=K7MOTID(K7ZA2,  20); break;
////	case	ZA3 : id=K7MOTID(K7ZA3,  20); break;
//	case	ZA4 : id=K7MOTID(K7ZA4,  20); break;
//	case	ZA4Y: id=K7MOTID(K7ZA4,  21); break;
//	case	ZA4L: id=K7MOTID(K7ZA4,  22); break;
//	case	ZA4R: id=K7MOTID(K7ZA4,  23); break;
//	case	ZA5 : id=K7MOTID(K7ZA5,  20); break;
//	case	BAN : id=K7MOTID(K7BAN,  20); break;
//		break;
//	default:
//		return 0xffffffff;
//	}
//	return id;
//}

bool WK7Zan::SetCamDefault(void)
{
	
	Vec		pos,tgt,dir;
	
	tgt.x = mPos.x;
	tgt.y = mPos.y + 15.0f;
	tgt.z = mPos.z;
	dir.x = sinf(mRot.y);
	dir.y = 0.0f;
	dir.z = cosf(mRot.y);
	
static	f32	dist = 10.0f;
	VECScale(&dir,&dir,dist);
	VECAdd  (&tgt,&dir,&pos);
	
	WK7CAM->SetTargetPosition(tgt);
	WK7CAM->SetPosition      (pos);
	
	return true;
}

bool WK7Zan::SetCamID(u32 id)
{
	mCamID = id;
	return true;
}

bool WK7Zan::SetCamInfo(u32 tick)
{
#ifndef	K7APP_MASTER
	if( history==true ){
		return false;
	}
#endif
	if( mID==0xffffffff ){
		SetCamDefault();
		return false;
	}
	
	WK7StageZanInfo		*pCurrentInfo;
	if( mCamID==0xffffffff ){
		pCurrentInfo = GetCamInfo(mID,tick);
	}else{
		pCurrentInfo = GetCamInfo(mCamID & K7EV_ID_MASK,tick);
	}
	
	if( pCurrentInfo==NULL ){
		return false;
	}
	if( mpCurrentZanInfo==pCurrentInfo ){
		return false;
	}
	
	mpCurrentZanInfo = pCurrentInfo;
	
	if( (pCurrentInfo->mCamPos.x==pCurrentInfo->mCamTgt.x &&
	     pCurrentInfo->mCamPos.y==pCurrentInfo->mCamTgt.y &&
	     pCurrentInfo->mCamPos.z==pCurrentInfo->mCamTgt.z ) ){
		SetCamDefault();
		return true;
	}
	
	WK7CAM->SetTargetPosition(pCurrentInfo->mCamTgt);
	WK7CAM->SetPosition      (pCurrentInfo->mCamPos);
	
	return true;
}

WK7StageZanInfo* WK7Zan::GetCamInfo(u32 id,u32 tick)
{
	if( id==0xffffffff ){
		return NULL;
	}
	f32		time = WK7_TICK_TO_SEC(tick);
	
	WK7StageZanInfo		*pInfo;
	WK7StageZanInfo		*pCurrentInfo = NULL;
	for(pInfo=stageZanInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
		if( pInfo->mZanID!=id ){
			continue;
		}
		if( pInfo->mCamTime > time ){
			continue;
		}
		pCurrentInfo = pInfo;
	}
	return pCurrentInfo;
}

bool WK7Zan::Initialize(void)
{
//	WK7StageZanInfo		*pInfo;
//	if( mID!=0xffffffff ){
//		for(pInfo=stageZanInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
//			if( pInfo->mZanID==mID ){
//				mType  = pInfo->mType;
//				if( mMesID >= pInfo->mAppearCount && mMesID > 0 ){
//					mMesID  = pInfo->mAppearCount-1;
//				}
//				break;
//			}
//		}
//		if( pInfo->mZanID==0xffffffff ){
//			pInfo  = NULL;
//			mMesID = 0xffffffff;
//		}
//	}else{
//		pInfo  = NULL;
//		mMesID = 0xffffffff;
//	}
//	if( mType==UNKNOWN ){
//		mType = ZA1L;
//	}
	WK7Stage		*pCurrentStage = WK7Stage::GetCurrentStage();
	
	if( pCurrentStage!=NULL ){
		
		WK7Path			*pPath = pCurrentStage->GetPath();
		
		if( pPath==NULL ){
			return false;
		}
		WK7PathBranchPointObjJObj	*pBranchPointObjJObj = pPath->GetObj_EventNo(mID|K7EV_TYPE_ZAN);
		if( pBranchPointObjJObj==NULL ){
			mStayType = false;
		}else{
			mStayType = true;
		}
		if( mMesID & 0x80000000 ){
			mMesID &= ~0x80000000;
		}else{
			if( mStayType==false ){
				mMesID = 0;
	//		}else{
	//			if( mMesID > 1 ){
	//				mMesID = 1;
	//			}
			}
		}
		
		if( (mpStageZan=pCurrentStage->GetZan(K7EVENTZANID(mID)))!=NULL ){
			mCharaCreate = false;
			mpChara         = mpStageZan->GetChara();
			mpCharaMotion   = mpStageZan->GetCharaMotion();
			mpAlpha         = mpStageZan->GetSetAlpha();
			mCharaID        = mpStageZan->GetCharaID();
			mPrevForcedDisp = mpStageZan->GetForcedDisp();
			mpStageZan->SetForcedDisp(true);
		}else if( mCharaLoadCancel==false ){
			WK7JObj						*pLocator = pCurrentStage->GetZanLocator(K7EVENTZANID(mID));
			u32			charaid,motid;
			charaid = 0xffffffff;
			motid   = 0xffffffff;
			if( pLocator!=NULL ){
				if( WK7Stage::GetZanChara(pLocator,charaid,motid)==false ){
					charaid = 0xffffffff;
					motid   = 0xffffffff;
				}
			}
			if( charaid==0xffffffff || motid==0xffffffff ){
				if( mStayType==false ){
					if( charaid==0xffffffff ){
						charaid = K7CHRID(K7ZA5,0);
					}
				}else{
					if( charaid==0xffffffff ){
						charaid = K7CHRID(K7ZA4,0);
					}
				}
				if( motid==0xffffffff ){
					motid = K7MOTID(K7CHR_MAINID(charaid),20);
				}
			}
			if( (mpChara = WK7RenderObj::CreateChara(charaid))==NULL ){
				return false;
			}
			mpCharaMotion = WK7MotionObj::CreateCharaMotion(motid);
			mCharaID      = charaid;
		}
		
	}else{
		mMesID &= ~0x80000000;
	}
	
//	mCinemaScopeRate.SetValue(0.0f);
//	mCinemaScopeRate.Play    (1.0f,2400);
	
//	WK7PLAYERCONTROL->GetPosition(&mPos);
	
	SetCamDefault();
	SetCamInfo(0);
	
	// \[X
	PrepareResource();
	
	// Xg[
	PrepareStream();
	
	return true;
}

bool WK7Zan::Release(void)
{
	return Terminate();
}

bool WK7Zan::Terminate(void)
{
	if( mpStageZan!=NULL ){
		mpStageZan->SetForcedDisp(mPrevForcedDisp);
	}
	// Xg[~
	if( mPlayStream >= 0 ){
		gpSound->mStopStream();
		gpSound->mSetPitchStream(0);
		mPlayStream = -1;
	}
	gpSound->mSetMasterVolumeSE(mMasterVolumeSE,200);
	if( mOldBgmID >= 0 ){
	//	gpSound->mPlayStreamNo(mOldBgmID);
		gpSound->mResumeStream();
		mOldBgmID  = -1;
	}
	// ebv~
	gpEngTelop->mDataSet(NULL);
	gpEngTelop->mDispStop();
	// ~
	gpJimaku->mDataSet(NULL);
	gpJimaku->mDispStop();
	// LN^f[^
	gpCharaDispMng->mDataSet(NULL);
	if( mCharaCreate==true ){
		GHM_SAFE_DELETE   (mpAlpha);
		GHM_SAFE_DELETE   (mpChara);
		GHM_SAFE_DELETE   (mpCharaMotion);
	}else{
		mpAlpha       = NULL;
		mpChara       = NULL;
		mpCharaMotion = NULL;
	}
	GHM_SAFE_DELETE   (mpFile );
	GHM_SAFE_DELETE   (mpResLink);
//	GHMGCMEM_SAFE_FREE(mpJimakuData);
//	GHMGCMEM_SAFE_FREE(mpTelopData );
	return true;
}

#define	WK7ZAN_RESOURCE_NAME_MAX			(256)
bool WK7Zan::PrepareStream(void)
{
	char			hpsname[WK7ZAN_RESOURCE_NAME_MAX];
	mOldBgmID = gpSound->mGetPlayStreamNo();
	if( mMesID==0xffffffff ){
		return false;
	}
	sprintf(hpsname,"/sound/Zan/%06x%d.hps",mResourceID & 0xffffff,mMesID);
	gpSound->mPrepareStream(hpsname,WK7ZAN_VOLUME_MUSIC);
	gpSound->mSetPitchStream(-2);
	mStreamCounter.SetValue(0);
	mStreamCounter.Play    (100,WK7_SEC_TO_TICK(1));
	mPlayStream = 0;
	return true;
}

bool WK7Zan::PrepareResource(void)
{
	char			fname[WK7ZAN_RESOURCE_NAME_MAX];
	int				id;
	
	GHM_SAFE_DELETE(mpFile);
	ghmGcMemSetAllocName("ZANPRFL");
	if( (mpFile = new ghmGcFile)==NULL ){
		return false;
	}
	
	if( mMesID==0xffffffff ){
		id = 0;
	}else{
		id = (int)mMesID;
	}
	
	switch( mCharaID ){
	case	K7CHRID(K7ZA7,0):
		// jI
		switch( id ){
		case	0:
			// ftHg͓Zt
			switch( K7EVENTZANID(mID) ){
			case	K7EVENTZAN(007204):
			case	K7EVENTZAN(055533):
				// OjI
				break;
			default:
				mResourceID = 0x010003;
				break;
			}
			break;
		case	3:
			switch( K7EVENTZANID(mID) ){
			case	K7EVENTZAN(055533):
				// OjI
				id = 2;
				break;
			default:
				mResourceID = 0x010003;
				break;
			}
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
	
	for( ; id>=0 ; id--){
		sprintf(fname,"/Message/Zan/%06x%d.zan",mResourceID & 0xffffff,id);
		if( mpFile->Open(fname)==true ){
			break;
		}
	}
	if( id < 0 ){
		GHM_SAFE_DELETE(mpFile);
		return true;
	}
	mMesID = (u32)id;
//	switch( mCharaID ){
//	case	K7CHRID(K7ZA7,0):
//		// jI
//		if( mMesID==0 ){
//			// ftHg͓Zt
//			switch( K7EVENTZANID(mID) ){
//			case	K7EVENTZAN(007204):
//			case	K7EVENTZAN(055533):
//				// OjI
//				break;
//			default:
//				mResourceID = 0x010003;
//				break;
//			}
//		}
//		break;
//	default:
//		break;
//	}
	
	if( (mpResLink = (ghmGcResLink *)mpFile->Read())==NULL ){
		GHM_SAFE_DELETE(mpFile);
		return false;
	}
	
	return true;
}

#define	WK7ZAN_ALPHAANIM_TICK		(WK7_SEC_TO_TICK(2))
bool WK7Zan::Start(void)
{
	WK7JObj			*pJObj;
	HSD_JObj		*pHSDJObj;
	ghmGcResGroup	*pGroup;
	
	if( mpResLink!=NULL ){
		if( (mpResLink = new((void *)mpResLink) ghmGcResLink)==NULL ){
			return false;
		}
	}
	
	// \[X
	if( mpResLink!=NULL && (pGroup=mpResLink->GetGroup(0))!=NULL ){
		mpJimakuData = pGroup->GetResource(0);
		mpTelopData  = pGroup->GetResource(1);
		mpNameData   = pGroup->GetResource(2);
	}
	
	// f[^ݒ
	gpJimaku->mDataSet(mpJimakuData);
	gpJimaku->mSetPause();
	// ebvf[^ݒ
	gpEngTelop->mDataSet(mpTelopData);
	gpEngTelop->mSetPause();
	// LN^f[^ݒ
	gpCharaDispMng->mDataSet(mpNameData);
	// cvOL\
	if( mpChara!=NULL ){
		mpChara->CreatePrivateLight();
		mpChara->SetStageLight(false);
		mpChara->SetRenderFlag(mCharaVisible);
		mpChara->SetPosition  (mPos);
		mpChara->SetRotation  (mRot);
	//	mpChara->AllocRenderID(true,WK7RENDEROBJ_RENDERID_HALF);
	//	mpChara->EnableVfxEffect();
		switch( K7CHR_MAINID(mCharaID) ){
		case	K7ZA7:
			break;
		default:
			if( mpCharaMotion != NULL && mStayType==false ){
				WK7Model		*pModel       = mpChara      ->GetModel();
				WK7ModelMotion	*pModelMotion = mpCharaMotion->GetModelMotion();
				if( pModel!=NULL && pModelMotion!=NULL ){
					pModel->AttachMotion (pModelMotion);
					pModel->PlayMotion   ();
					pModel->SetMotionLoop(true);
				}
			}
			break;
		}
		if( mCharaCreate==true ){
			mAlpha.SetValue(0.0f);
			if( (pJObj = mpChara->GetJObj())!=NULL && (pHSDJObj=pJObj->GetJObj())!=NULL ){
				pJObj->SetCastShadowDisable(true);
				pJObj->SetZSortPrio(WK7JOBJ_ZSORTPRIO_DEFAULT+256);
				ghmGcMemSetAllocName("ZANALPHA");
				mpAlpha = new C_SetAlpha(pHSDJObj,mAlpha.GetValue());
			}
		}else{
			mAlpha.SetValue(WK7ZAN_FADE_ALPHA);
		}
	}
	return true;
}

bool WK7Zan::Term(u32 tick)
{
	mState = TERM;
	if( tick==0 ){
		// Xg[~
		if( mPlayStream >= 0 ){
			gpSound->mStopStream();
			gpSound->mSetPitchStream(0);
			mPlayStream = -1;
		}
		gpEngTelop->mDispStop();
		gpJimaku  ->mDispStop();
		mState = IDLE;
		if( mStayType==false ){
			if( mpChara!=NULL ){
				mpChara->SetRenderFlag(false);
			}
		}
		return true;
	}
	if( mStayType==true ){
		mState = IDLE;
		return true;
	}
//	mCinemaScopeRate.Play(0.0f,2400);
	mAlpha          .Play(0.0f,tick);
	return true;
}

bool WK7Zan::SetCharaVisible(bool flag)
{
	mCharaVisible = flag;
	return true;
}

bool WK7Zan::AlphaControl(void)
{
	if( mpAlpha==NULL ){
		return true;
	}
	mpAlpha->SetVal(mAlpha.GetValue());
	return true;
}

bool WK7Zan::FrameProcess(void)
{
//	mCinemaScopeRate.FrameProcess();
	mStreamCounter  .FrameProcess();
	mAlpha          .FrameProcess();
	
	if( mCounter != 0xffffffff ){
		mCounter += WK7_TICK_PER_FRAME;
	}
	if( mWaitCounter >= WK7_TICK_PER_FRAME ){
		mWaitCounter -= WK7_TICK_PER_FRAME;
	}else{
		mWaitCounter  = 0;
	}
	if( mState != IDLE ){
		if( mpChara!=NULL ){
			if( mpChara->GetRenderFlag()!=mCharaVisible ){
				mpChara->SetRenderFlag(mCharaVisible);
			}
		}
	}
	
	AlphaControl();
	
	switch( mState ){
	case	IDLE:
		break;
	case	INIT:
		if( Initialize()==false ){
			return false;
		}
		mState = LOADING;
		break;
	case	LOADING:
		if( mpChara!=NULL && mpChara->GetState()!=WK7RenderObj::LOADED ){
			break;
		}
		if( mpCharaMotion!=NULL && mpCharaMotion->GetState()!=WK7MotionObj::LOADED ){
			break;
		}
//		if( mStreamCounter.IsAnimating()==true ){
//			break;
//		}
		if( mpResLink!=NULL && mpFile!=NULL ){
//		if( mpJimakuData!=NULL && mpFile!=NULL ){
			if( mpFile->GetState()!=ghmGcFile::READFINISH ){
				break;
			}
		}
		if( Start()==false ){
			break;
		}
//		mState = NOISEWAIT;
		mState = STARTWAIT;
		break;
	case	NOISEWAIT:
		if( gpNoise->mGetSandFrameProc()!=eSandStandby ){
			break;
		}
	case	STARTWAIT:
		if( mStartRequest==false ){
			break;
		}
		if( mCharaCreate==true ){
			mAlpha.Play(WK7ZAN_FADE_ALPHA,WK7ZAN_ALPHAANIM_TICK);
		}
		mState = LOADED;
		break;
	case	LOADED:
		if( mStreamCounter.IsAnimating()==true ){
			break;
		}
		if( mAlpha        .IsAnimating()==true ){
			break;
		}
		switch( K7CHR_MAINID(mCharaID) ){
		case	K7ZA7:
			mState = PLAYINIT;
			switch( mMesID ){
			case	0:
			case	3:
				break;
			default:
				if( mpChara!=NULL ){
					WK7JObj	*pJObj;
					EFFECT	*pEffect;
					bool	blood = false;
					if( K7SCR_EVHASITEM(K7EVENTZANID(mID))==true ){//|| K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==TRUE ){
						pJObj = mpChara->GetJObj(K7ZA7_KAMEN_FACE_OBJNAME);
						if( K7SCR_EVISUSEDITEM(K7EVENTZANID(mID))==false ){
							blood = true;
						}
					}else{
						pJObj = mpChara->GetJObj(K7ZA7_KAMEN_HAND_OBJNAME);
						if( K7SCR_GET_GLOBAL_FLAG(K7GLFL_EASY_MODE)==FALSE && K7SCR_EVISUSEDITEM(K7EVENTZANID(mID))==false ){
							// [hłȂAA܂tnĂȂ
							blood = true;
						}
					}
					if( pJObj!=NULL && blood==true ){
						Vec		v;
						mpChara->ReleaseEffect(mpBloodEffect);
						mpBloodEffect = NULL;
						::GetScreen3DVector(WK7_SCREEN_WIDTH / 2,WK7_SCREEN_HEIGHT,VParam[ED_CONVEBLOOD3][5] * 0.1F,&v) ;
						::SetConveBlood2ConveTime    ( (u8)VParam[ED_CONVEBLOOD3][1] ) ;
						::SetConveBlood2ConveSpeed   ( (f32)VParam[ED_CONVEBLOOD3][0] * 0.001F ) ;
						::SetConveBlood2StartPosition( v, true ) ;
						static f32 rate = 128.0f;
						WK7RenderObjEffectInfo	info;
						info.Create();
						if( (pEffect = ::CreateConveBlood2Effect(pJObj,
							                                     1.0F, 0.0F,
							                                     (f32)VParam[ED_CONVEBLOOD3][2] * 0.01F,
							                                     (f32)VParam[ED_CONVEBLOOD3][3] * 0.01F,
							                                     rate,
							                                     -2))!=NULL ){
															(f32)VParam[ED_CONVEBLOOD3][4] * 0.5F, 
							mpBloodEffect = mpChara->CreateEffect(pEffect);
							info.Parent(pEffect);
						}
						::SetConveBlood2StartPosition( v, false ) ;
						gpSound->mPlaySE(SFX_BT_YOONHYUN_BLOODKYUSHU);
						K7SCR_EVUSEITEM(K7EVENTZANID(mID),true);
						mState = PREPLAING;
						break;
					}
				}
				break;
			}
			break;
		default:
			mState = PLAYINIT;
			break;
		}
		break;
	case	PREPLAING:
		if( mpChara!=NULL && mpChara->IsValidEffect(mpBloodEffect)==true ){
			break;
		}
		mpBloodEffect = NULL;
		mState = PLAYINIT;
//		ResetWaitCounter(u32 tick);
		break;
	case	PLAYINIT:
		mCounter = 0;
		// |[Y
		gpJimaku  ->mReleasePause();
		gpEngTelop->mReleasePause();
		// Xg[Đ
		gpSound->mJustPlayStream( STREAM_PAUSE );
		mMasterVolumeSE = gpSound->mGetMasterVolumeSE();
		gpSound->mSetMasterVolumeSE(0,200);
		mState = PLAYING;
		break;
	case	PLAYING:
		SetCamInfo(mCounter);
#ifndef	K7APP_MASTER
		if( HSD_PadGetTrigger(1) & HSD_PAD_START ){
			int		i;
			for(i=WK7ZAN_COUNTHISTORY_NUM-1 ; i>0 ; i--){
				countHistry[i] = countHistry[i-1];
			}
			countHistry[0] = mCounter;
			history = true;
		}
#endif
		if( mpTelopData!=NULL ){
			if( gpEngTelop->mGetStatus()!=eEngTelopStandby ){
				break;
			}
		}
		if( mpJimakuData!=NULL ){
			if( gpJimaku->mGetStatus()!=eJimakuStandby ){
				break;
			}
#ifndef	K7APP_MASTER
			if( history==true ){
				if( !(HSD_PadGetTrigger(0) & HSD_PAD_A) ){
					break;
				}
			}
#endif
		}else{
			if( !(HSD_PadGetTrigger(0) & HSD_PAD_A) ){
				break;
			}
		}
		Term(WK7ZAN_ALPHAANIM_TICK);
		break;
	case	TERM:
//		if( mCinemaScopeRate.IsAnimating()==true ){
//			break;
//		}
		if( mAlpha          .IsAnimating()==true ){
			break;
		}
		if( mpChara!=NULL ){
			mpChara->SetRenderFlag(false);
		}
		mState = IDLE;
		break;
	default:
		return false;
	}
	switch( mState ){
	case	NOISEWAIT:
	case	LOADED:
	case	PLAYING:
	case	TERM:
		switch( mID ){
#if	defined(K7APP_MASTER) || !defined(K7APP_ZAN_SKIP)
		case	0x007201:
		case	0x007303:
		case	0x007503:
		case	0x007602:
		case	0x010016:
		case	0x010018:
		case	0x011030:
		case	0x011031:
		case	0x030040:
		case	0x030041:
		case	0x030042:
		case	0x035015:
		case	0x035016:
		case	0x051150:
		case	0x055521:
		case	0x055522:
			// PX̓LZłȂ
			break;
#endif
		default:
			if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
				Term(0);
			}
			break;
		}
		break;
	}
	return true;
}

bool WK7Zan::RenderProcess(void)
{
#ifndef	K7APP_MASTER
#ifdef	_DEBUG
	if( mDebugInfo==false ){
		return true;
	}
#endif
	u32			count;
	int			i;
static	int		px = 240,py = 16;
	C_Paper		paper(px,py);
	if( mCounter!=0xffffffff ){
		count = mCounter;
	}else{
		count = 0;
	}
	PRINTF("Zan Process : %.3f(sec) , %d(tick)\n",WK7_TICK_TO_SEC(count),count);
	for(i=0 ; i<WK7ZAN_COUNTHISTORY_NUM ; i++){
		PRINTF("            : %.3f(sec) , %d(tick)\n",WK7_TICK_TO_SEC(countHistry[i]),countHistry[i]);
	}
#endif
//	RenderCinemaScope();
	return true;
}

//static	f32		cinemaScopeSize = 64.0f;
//bool WK7Zan::RenderCinemaScope(void)
//{
//	if( mCinemaScopeRate.GetValue()==0.0f ){
//		return true;
//	}
//	
//	Mtx				view;
//	Mtx44			proj;
//	
//	WK7Cam::Set2DMatrix(view,proj,0.0f,1024.0f);
//	
//	// [Jr[ϊ}gNXݒ
//	GXLoadPosMtxImm   (view,GX_PNMTX0);
//	GXLoadNrmMtxImm   (view,GX_PNMTX0);
//	GXSetCurrentMtx   (GX_PNMTX0);
//	GXSetProjection   (proj,GX_ORTHOGRAPHIC);
//	
//	GXSetScissor      (0,0,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT);
//	GXSetViewport     (0.0f,0.0f,WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,0.0f,1.0f);
//	
//	GXSetAlphaCompare (GX_ALWAYS,0xff,GX_AOP_OR,GX_ALWAYS,0xff);
//	GXSetNumChans     (1);
//	GXSetChanCtrl     (GX_COLOR0A0,GX_FALSE,GX_SRC_REG,GX_SRC_REG,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
//	GXSetBlendMode    (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
//	GXSetCullMode     (GX_CULL_NONE);
//	GXSetDither       (GX_FALSE);
//	GXSetDstAlpha     (GX_FALSE,0);
//	GXSetZMode        (GX_FALSE,GX_ALWAYS,GX_FALSE);
//	GXSetColorUpdate  (GX_TRUE);
//	GXSetAlphaUpdate  (GX_FALSE);
//	
//	GXClearVtxDesc    ();
//	GXSetVtxDesc      (GX_VA_POS ,GX_DIRECT);
//	GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_POS,GX_POS_XYZ,GX_F32,0);
//	
//#define		CINEMA_SCOPE_Z	(1.0f)
//static	u32	CINEMA_SCOPE_COLOR = (0x000000ff);
//	
//	f32		ty,dy;
//	
//	ty = cinemaScopeSize * mCinemaScopeRate.GetValue();
//	dy = WK7_SCREEN_HEIGHT - ty;
//	
//	GXSetChanMatColor (GX_COLOR0A0,*((GXColor *)&CINEMA_SCOPE_COLOR));
//	
//	GXBegin(GX_QUADS,GX_VTXFMT0,8);
//	
//		GXPosition3f32(            0.0f,             0.0f,CINEMA_SCOPE_Z);
//		GXPosition3f32(WK7_SCREEN_WIDTH,             0.0f,CINEMA_SCOPE_Z);
//		GXPosition3f32(WK7_SCREEN_WIDTH,               ty,CINEMA_SCOPE_Z);
//		GXPosition3f32(            0.0f,               ty,CINEMA_SCOPE_Z);
//		
//		GXPosition3f32(            0.0f,               dy,CINEMA_SCOPE_Z);
//		GXPosition3f32(WK7_SCREEN_WIDTH,               dy,CINEMA_SCOPE_Z);
//		GXPosition3f32(WK7_SCREEN_WIDTH,WK7_SCREEN_HEIGHT,CINEMA_SCOPE_Z);
//		GXPosition3f32(            0.0f,WK7_SCREEN_HEIGHT,CINEMA_SCOPE_Z);
//		
//	GXEnd();
//	
//	return true;
//}

WK7ZanCharaPresentInfo* WK7Zan::Find(u32 id)
{
	id &= K7EV_ID_MASK;
	WK7ZanCharaPresentInfo	*pInfo;
	for(pInfo=zanCharaPresentInfo ; pInfo->mZanID!=0xffffffff ; pInfo++){
		if( pInfo->mZanID==id ){
			return pInfo;
		}
	}
	return NULL;
}

