////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Zanryu Shinen Object
//
// WK7Zan.h
//
// Creator       : Watanabe Kazuhisa (GHM)
// Creation Date : 02/22/2004
//
////////////////////////////////////////////////////////////////////////////////

#ifndef	__WK7ZAN_H__
#define	__WK7ZAN_H__

//#include ".\WK7Obj.h"
#include ".\WK7Chara.h"
#include ".\WK7Anim.h"

#define	K7ZA7_KAMEN_HAND_OBJNAME	"Kamen_Hand"
#define	K7ZA7_KAMEN_FACE_OBJNAME	"Kamen_Face"

#define	WK7ZAN_VOLUME_MUSIC					(VOLUME_MUSIC * 13 / 10)

class C_SetAlpha;

struct WK7StageZanInfo;

#define	ZANTYPE(type)		WK7Zan::##type

struct WK7ZanCharaPresentInfo{
	u32				mZanID;
	u32				mTick;
	u32				mNameID;
	s16				mNameX,mNameY;
	f32				mWinX,mWinY,mWinW,mWinH;
	int				mFlag;
};

extern	WK7ZanCharaPresentInfo	zanCharaPresentInfo[];

extern	f32	WK7ZAN_FADE_ALPHA;
//#define	WK7ZAN_FADE_ALPHA			(0.8f)
//#define	WK7ZAN_FADE_ALPHA			(1.0f)

class	WK7StageZan;
//
// Zan Class
//
class WK7Zan{
public:
	enum State{
		IDLE = 0,
		INIT,
		LOADING,
		NOISEWAIT,
		STARTWAIT,
		LOADED,
		PREPLAING,
		PLAYINIT,
		PLAYING,
		TERM,
	};
protected:
	u32						mID;
	u32						mCamID;
	u32						mResourceID;
	bool					mStayType;
	u32						mMesID;
	u32						mParam;
	Vec						mPos;
	Vec						mRot;
	bool					mCharaCreate;
	u32						mCharaID;
	WK7Chara				*mpChara;
	WK7CharaMotion			*mpCharaMotion;
	WK7RenderObjEffect		*mpBloodEffect;
	C_SetAlpha				*mpAlpha;
	State					mState;
//	WK7AnimLinearF			mCinemaScopeRate;
	WK7AnimLinear			mStreamCounter;
	s16						mOldBgmID;
	s16						mPlayStream;
	WK7AnimLinearF			mAlpha;
	ghmGcFile				*mpFile;
	void					*mpJimakuData;
	void					*mpTelopData;
	void					*mpNameData;
	ghmGcResLink			*mpResLink;					// \[X
	WK7StageZan				*mpStageZan;
	
	WK7StageZanInfo			*mpCurrentZanInfo;
	u32						mCounter;
	bool					mStartRequest;
	bool					mCharaLoadCancel;
	bool					mCharaVisible;
	bool					mPrevForcedDisp;
	
	u32						mWaitCounter;
	static u32				mCinemaScopeColor;
#ifdef	_DEBUG
	static bool				mDebugInfo;
#endif
	
	u8						mMasterVolumeSE;
	
	inline bool ResetWaitCounter(u32 tick){ mWaitCounter=tick; return true; }
	inline bool IsWaitEndWait(void){ return (mWaitCounter==0? true:false); }
	
	bool AlphaControl(void);
	bool Start(void);
	bool PrepareStream(void);
	bool PrepareResource(void);
	bool RenderCinemaScope(void);
	bool Term(u32 tick);
	
	// 
	bool Initialize(void);
	
	// I
	bool Terminate(void);
	
public:
	WK7Zan(u32 id,const Vec &pos,const Vec &rot,u32 mesid=0);
	~WK7Zan();
	
	static WK7StageZanInfo* GetCamInfo(u32 id,u32 tick);
	bool SetCamDefault(void);
	bool SetCamInfo(u32 tick);
	bool SetCamID(u32 id);
	
	inline u32 GetCounter(void){ return mCounter; }
	inline State GetState(void){ return mState; }
	
	inline void SetParam(u32 param){ mParam = param; }
	inline u32 GetParam(void){ return mParam; }
	
	bool Release(void);
	
	// t[
	bool FrameProcess(void);
	
	// _O
	bool RenderProcess(void);
	
	inline bool StartRequest(void){ mStartRequest=true; return true; }
	inline bool CharaLoadCancel(void){ mCharaLoadCancel=true; return true; }
	bool SetCharaVisible(bool flag);
	
	inline void* GetNameData(void){ return mpNameData; }
//	static u32 GetCharaID(WK7Zan::Type type);
//	static u32 GetMotID(WK7Zan::Type type);
	
	static WK7ZanCharaPresentInfo* Find(u32 id);
#ifdef	_DEBUG
	inline static bool SetDebugInfo(bool flag){ mDebugInfo=flag; return true; }
	inline static bool GetDebugInfo(void){ return mDebugInfo; }
#endif
};

#endif	//__WK7ZAN_H__

