// =============================================================================
//
// }bvf[^NX
//
//	KMap.cpp
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 02/20/04
//
// =============================================================================

// include ---------------------------------------
#include "KMap.h"

#ifndef __GC
#include <malloc.h>
#include <stdio.h>
#include "BmpLib.h"
#else
#include "../Lib/ghmGcFile.h"
#include "../Wat/K7App.h"
#endif
#include <string.h>
#include <stdlib.h>

// define ----------------------------------------

// data type -------------------------------------

// data ------------------------------------------

// function proto type ---------------------------

// function code ---------------------------------

// }bvt@C̓ǂݍ
bool KMap::Load( char *FilePath )
{
	bool openflag = false ;
	if( initflag == true ) return false ;
	
	Image = NULL ;
	
#ifdef __GC
	// t@CJ
	if( File->Open( FilePath ) == false ) return false ;
	openflag = true ;
	
	// wb_̓ǂݍ
	File->Read( &Data, 0, 6 ) ;
#else
	FILE *fp = NULL ;
	
	// t@CJ
	if( ( fp = fopen( FilePath, "rb" ) ) == NULL ) return false ;
	
	// wb_̓ǂݍ
	fread( &Data, sizeof( Data ), 1, fp ) ;

	// hc̃`FbN
	if( strcmp( Data.Identifier, MAPDATA_IDENTIFIER ) != 0 ) goto ERR ;

	// C[Wf[^ǂݍރ̊m
	Image = ( unsigned char * )MALLOC( Data.Width * Data.Height * 4 ) ;
	if( Image == NULL ) goto ERR ;
	
	// C[W̓ǂݍ
	fread( Image, Data.Width * Data.Height * 4, 1, fp ) ;
	
	// t@C
	fclose( fp ) ;
#endif

	// I
	return true ;
	
	// G[
ERR :
		
	if( Image != NULL )
	{
		FREE( Image ) ;
		Image = NULL ;
	}

#ifdef __GC
	if( openflag == true )
	{
		File->Close() ;
	}
#else
	if( fp != NULL )
	{
		fclose( fp ) ;
		fp = NULL ;
	}
#endif

	// I
	return false ;
}

// ǂݍ݂IĂ邩ׂ( true:I false:܂ )
bool KMap::LoadCheck( void )
{
	if( initflag == true ) return true ;

#ifdef __GC
	if( File == NULL ) return true ;
	File->FrameProcess() ;
	if( File->GetState() != ghmGcFile::READFINISH ) return false ;
	if( Image == NULL )
	{
		// wb_ǂݍݏI
		
		// hc̃`FbN
		if( strcmp( Data.Identifier, MAPDATA_IDENTIFIER ) != 0 ) return false ;
	
		// C[Wf[^ǂݍރ̊m
		Image = ( unsigned char * )MALLOC( (int)( Data.Width * Data.Height * 4 + sizeof( Data ) ) ) ;
		if( Image == NULL ) return false ;
		
		// C[W̓ǂݍ
		File->Read( Image, 0, (long)( Data.Width * Data.Height * 4 + sizeof( Data ) ) ) ;
		
		// I
		return false ;
	}
	else	
	{
		// C[WǂݍݏI
		
		// C[W炷
		memmove( Image, Image + sizeof( Data ), ( unsigned long )( Data.Width * Data.Height * 4 ) ) ;
		
		// t@C
		File->Close() ;
		delete File ;
		File = NULL ;

		// tO𗧂Ă
		initflag = true ;
	
		// I
		return true ;
	}
#else
	// ŏtO𗧂Ă
	initflag = true ;
#endif

	// I
	return true ;
}

// }bv̍쐬
bool KMap::Make( int Width, int Height )
{
	if( initflag == true ) return false ;

	// wb_̃Zbg
	strcpy( Data.Identifier, MAPDATA_IDENTIFIER ) ;
	Data.Width = (unsigned char)Width ;
	Data.Height = (unsigned char)Height ;

	// C[Wf[^ǂݍރ̊m
	Image = ( unsigned char * )MALLOC( Data.Width * Data.Height * 4 ) ;
	if( Image == NULL ) return false ;

	// tO𗧂Ă
	initflag = true ;

	// I
	return true ;
}

// }bv̉
bool KMap::Release( void )
{
	if( initflag == false ) return false ;
	
	// ̉
	if( Image != NULL ) 
	{
		FREE( Image ) ;
		Image = NULL ;
	}

	// I
	return true ;
}

#ifndef __GC

// }bvf[^ۑ
bool KMap::Save( char *FilePath )
{
	FILE *fp ;

	if( initflag == false ) return false ;
	
	// t@CJ
	fp = fopen( FilePath, "wb" ) ;
	if( fp == NULL ) goto ERR ;
	
	// wb_o
	fwrite( &Data, sizeof( Data ), 1, fp ) ;

	// C[Wo
	fwrite( Image, Data.Width * Data.Height * 4, 1, fp ) ;
	
	// t@C
	fclose( fp ) ;
	
	// I
	return true ;
	
	// G[
ERR :
	if( fp != NULL )
	{
		fclose( fp ) ;
		fp = NULL ;
	}
	
	// I
	return false ;
}

// }bvt@C̕ϊ
bool KMap::MapConv( char *BmpFilePath, char *DestPath )
{
	int bmp = -1 ;
	int k = 0 ;
	FILE *fp = NULL ;
	int i, j, w, h, r, g, b ;
	BITMAPINFOHEADER *head ;
	KMap *map = NULL ;
	
	// alot@CJ
	bmp = CreateBitmapDataToFile( BmpFilePath ) ;
	if( bmp < 0 ) return false ;
	
	// wb_̎擾
	head = GetBitmapInfo( bmp ) ;
	w = head->biWidth ;
	h = abs(head->biHeight) ;
	
	// TCỸ}bvf[^쐬
	ghmGcMemSetAllocName("KMap");
	map = new KMap ;
	if( map == NULL ) goto ERR ;
	if( map->Make( w, h ) == false ) goto ERR ;

	// ϊ
	for( i = 0 ; i < h ; i ++ )
	{
		for( j = 0 ; j < w ; j ++ )
		{
			GetPixelRGBBitmapData( j, i, &r, &g, &b, bmp ) ;
//			printf( "r:%x g:%x b:%x  ", r, g, b ) ;
			if( r + g + b == 0 ) k ++ ;
			map->SetMapChip( ( 0xff << 24 ) | ( b << 16 ) | ( g << 8 ) | ( r ), j, i ) ;
		}
	}
	printf( "k=%d", k ) ;
	
	// ۑ
	map->Save( DestPath ) ;

	// }bvf[^폜
	delete map ;
	
	// alof[^폜
	ReleaseBitmapData( bmp ) ;
	
	// I
	return true ;
	
ERR :
	if( map != NULL )
	{
		delete map ;
		map = NULL ;
	}
	
	if( bmp != -1 )
	{
		ReleaseBitmapData( bmp ) ;
	}
	
	if( fp != NULL )
	{
		fclose( fp ) ;
		fp = NULL ;
	}
	
	// I
	return false ;
}

#endif 




