///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7Break
//
// YK7Break.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/26/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
//#include "../Lib/ghmGcMem.h"
#include "./YK7Break.h"
#include "../Wat/K7App.h"
#include "../matsu/mk7Common.h"
#include "./YK7Effect.h"

#include <math.h>
#include <stdlib.h>

//#define ___MEMSIZEDUMP


#if 1
#define ALLOC( size, name, big ) 		((big)?ghmGcMemAllocName((size),(name)):K7AppSmallMemAllocName((size),(name)))
#define FREE( mem, big )				((big)?ghmGcMemFree(mem):K7AppSmallMemFree(mem))
#else
#if 0
#define ALLOC		K7AppSmallMemAllocName
#define FREE		K7AppSmallMemFree
#else
#define ALLOC		ghmGcMemAllocName
#define FREE		ghmGcMemFree
#endif
#endif

// define ---------------------------------------

#define GETINDEX(x,y)	(u16)( (y) == 1 ? *((u8 *)(x)) : *((u16 *)(x)) )

// datatype -------------------------------------

// data -----------------------------------------

MESHMANAGE mm ;

// prototype ------------------------------------

static s32 GetPObjMeshIndexNum( HSD_PObj *PObj, u8 NextFlag ) ;			// PObj ɑ݂Ă`撸_CfbNX̐Ԃ
static void LengthScanCallBack( WK7JObj *JObj, void *Data ) ;			// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐
static s8 LengthPolyScanCallBack( Vec *Point, void *Data ) ;			// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐(|Sp)
static s8 ModelPolygonAreaCallBack( Vec **Point, void *Data ) ;			// f̑ʐς𓾂邽߂̃R[obN֐


// function code --------------------------------

// sysdolphin ̃v~eBuf[^璸_f[^擾
extern s8 CreatePrimitiveMeshData( HSD_JObj *JObj, HSD_DObj *DObj, HSD_PObj *PObj, MESH **MeshBuf,
									u8 UseNormalFlag, u8 UsePosFlag,
									s8 UseColorFlag, s8 UseUvFlag, u8 UseBigMem,
									u8 DObjNextFlag, u8 PObjNextFlag )
{
	HSD_VtxDescList *DescList = NULL ;
	HSD_VtxDescList *PointDesc = NULL, *ColorDesc = NULL, *UvDesc = NULL, *NormalDesc = NULL, *PNMtxIndexDesc = NULL ;
	u16 PointIndexAddress, ColorIndexAddress, UvIndexAddress, NormalIndexAddress, PNMtxIndexAddress ;
	u8 PointIndexByte, ColorIndexByte, UvIndexByte, NormalIndexByte ;
	u8 *PointBP = NULL, *ColorBP = NULL, *UvBP = NULL, *NormalBP = NULL;
	MESH *Mesh ;
	
#ifdef ___MEMSIZEDUMP
	TRACE( "Primitive  SmallFree:%d   BigFree:%d\n", K7AppSmallMemGetFreeSize(), ghmGcMemGetFreeSize() ) ;
#endif
	
	// f[^̏
	*MeshBuf = NULL ;
	Mesh = ( MESH * )ALLOC( sizeof( MESH ), "Y_Mesh", UseBigMem ) ;
	if( Mesh == NULL ) return -1 ;
	memset( Mesh, 0, sizeof( MESH ) ) ;
	PointBP = ColorBP = UvBP = NormalBP = NULL ;
	
	// 傫̈gpĂ邩ǂۑ
	Mesh->BigMemFlag = UseBigMem ;

	// v~eBuIuWFNgւ̃|C^ۑ
	Mesh->PObj = PObj ;
	
	// HSD_JObj IuWFNgւ̃|C^ۑ
	Mesh->JObj = JObj ;

	// v~eBũ^Cv擾
	Mesh->PrimitiveType = (GXPrimitive)*PObj->dl ;

	// _̐擾
	Mesh->IndexDataNum = *( (u16 *)( (u8 *)PObj->dl + 1 ) ) ;

	// evf̃f[^̐ƁAXgChTCY𓾂
	{
		u16 VertexSize ;

		// HSD_VtxDescList \̂̏I[ɗ܂ŌJԂ
		DescList = PObj->desc_list ;
		VertexSize = 0 ;
		while( DescList->attr != GX_VA_NULL )
		{
			// f[^^Cv̏ꍇ̂݃f[^ۑ
			switch( DescList->attr )
			{
			case GX_VA_PNMTXIDX :
				PNMtxIndexAddress = VertexSize ;
				PNMtxIndexDesc = DescList ;
				break ;
			
			case GX_VA_POS :
				if( UsePosFlag == TRUE )
				{
					PointBP = (u8 *)DescList->base_ptr ;
					PointIndexAddress = VertexSize ;
					PointDesc = DescList ;
					switch( DescList->attr_type )
					{
					case GX_INDEX8 : PointIndexByte = 1 ; break ;
					case GX_INDEX16 : PointIndexByte = 2 ; break ;
					default : return -1 ;
					}
				}
				break ;
				
			case GX_VA_CLR0 :
				if( UseColorFlag == TRUE )
				{
					ColorBP = (u8 *)DescList->base_ptr ;
					ColorIndexAddress = VertexSize ;
					ColorDesc = DescList ;
					switch( DescList->attr_type )
					{
					case GX_INDEX8 : ColorIndexByte = 1 ; break ;
					case GX_INDEX16 : ColorIndexByte = 2 ; break ;
					default : return -1 ;
					}
				}
				break ;
							
			case GX_VA_TEX0 :
				if( UseUvFlag == TRUE )
				{
					UvBP = (u8 *)DescList->base_ptr ;
					UvIndexAddress = VertexSize ;
					UvDesc = DescList ;
					switch( DescList->attr_type )
					{
					case GX_INDEX8 : UvIndexByte = 1 ; break ;
					case GX_INDEX16 : UvIndexByte = 2 ; break ;
					default : return -1 ;
					}
				}
				break ;
				
			case GX_VA_NRM :
				if( UseNormalFlag == TRUE )
				{
					NormalBP = (u8 *)DescList->base_ptr ;
					NormalIndexAddress = VertexSize ;
					NormalDesc = DescList ;
					switch( DescList->attr_type )
					{
					case GX_INDEX8 : NormalIndexByte = 1 ; break ;
					case GX_INDEX16 : NormalIndexByte = 2 ; break ;
					default : return -1 ;
					}
				}
				break ;
			}
	
			// f[^̃Agr[g^CvɂĂP_f[^̐Zo
			if( DescList->attr == GX_VA_PNMTXIDX )
			{
				VertexSize += 1 ;
			}
			else
			{
				switch( DescList->attr_type )
				{
				case GX_INDEX8 : VertexSize += 1 ; break ;
				case GX_INDEX16 : VertexSize += 2 ; break ;
				default : return -1 ;
				}
			}
			
			DescList ++ ;
		}

		// P_f[^̃XgChۑ
		Mesh->IndexStride = VertexSize ;
	}

	// evf̃f[^̐擾
	{
		u8 *DisplayList ;
		u16 i, Num, temp ;

		// ōl
		Mesh->PointNum = Mesh->ColorNum = Mesh->UvNum = Mesh->NormalNum = 0 ;

		// Jn
		Num = Mesh->IndexDataNum ;
		DisplayList = (u8 *)PObj->dl + 3 ;
		for( i = 0 ; i < Num ; i ++, DisplayList += Mesh->IndexStride )
		{
			if( PointBP != NULL )
			{
				if( Mesh->PointNum < ( temp = (u16)( GETINDEX( DisplayList + PointIndexAddress, PointIndexByte ) + 1 ) ) )
					Mesh->PointNum = temp ;
			}
			
			if( ColorBP != NULL ) 
			{
				if( Mesh->ColorNum < ( temp = (u16)( GETINDEX( DisplayList + ColorIndexAddress, ColorIndexByte ) + 1 ) ) )
					Mesh->ColorNum = temp ;
			}
		
			if( UvBP != NULL )
			{
				if( Mesh->UvNum < ( temp = (u16)( GETINDEX( DisplayList + UvIndexAddress, UvIndexByte ) + 1 ) ) )
					Mesh->UvNum = temp ;
			}
	
			if( NormalBP != NULL )
			{
				if( Mesh->NormalNum < ( temp = (u16)( GETINDEX( DisplayList + NormalIndexAddress, NormalIndexByte ) + 1 ) ) )
					Mesh->NormalNum = temp ;
			}
		}
	}

	// evf̃mۂ
	{
		if( PNMtxIndexDesc != NULL )
		{
			Mesh->PNMtxIndex = ( u8 * )ALLOC( (s32)( Mesh->IndexDataNum * sizeof( u8 ) ), "Y_PNMIdx", UseBigMem ) ;
			if( Mesh->PNMtxIndex == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
		}

		if( Mesh->PointNum != 0 )
		{
			Mesh->Point = ( Vec * )ALLOC( (s32)( Mesh->PointNum * sizeof( Vec ) * 2 ), "Y_MPos", UseBigMem ) ;
			if( Mesh->Point == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
			Mesh->PointIndex = ( u16 * )ALLOC( (s32)( Mesh->IndexDataNum * sizeof( u16 ) ), "Y_MPosIdx", UseBigMem ) ;
			if( Mesh->PointIndex == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
		}

		if( Mesh->ColorNum != 0 )
		{
			Mesh->Color = ( u32 * )ALLOC( (s32)( Mesh->ColorNum * sizeof( u32 ) * 2 ), "Y_MCr", UseBigMem ) ;
			if( Mesh->Color == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
			Mesh->ColorIndex = ( u16 * )ALLOC( (s32)( Mesh->IndexDataNum * sizeof( u16 ) ), "Y_MCIdx", UseBigMem ) ;
			if( Mesh->ColorIndex == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
		}

		if( Mesh->UvNum != 0 )
		{
			Mesh->Uv = ( UV * )ALLOC( (s32)( Mesh->UvNum * sizeof( UV ) * 2 ), "Y_MUV", UseBigMem ) ;
			if( Mesh->Uv == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
			Mesh->UvIndex = ( u16 * )ALLOC( (s32)( Mesh->IndexDataNum * sizeof( u16 ) ), "Y_MUVIdx", UseBigMem ) ;
			if( Mesh->UvIndex == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
		}

		if( Mesh->NormalNum != 0 )
		{
			Mesh->Normal = ( Vec * )ALLOC( (s32)( Mesh->NormalNum * sizeof( Vec ) * 2 ), "Y_MNrm", UseBigMem ) ;
			if( Mesh->Normal == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
			Mesh->NormalIndex = ( u16 * )ALLOC( (s32)( Mesh->IndexDataNum * sizeof( u16 ) ), "Y_MNrmIdx", UseBigMem ) ;
			if( Mesh->NormalIndex == NULL ){
			 DeletePrimitiveMeshData( Mesh ) ;
			 return -1 ; }
		}
	}

	// CfbNXlRs[
	{
		u16 Num, i ;
		u8 *DisplayList ;

		DisplayList = (u8 *)PObj->dl + 3 ; 
		Num = Mesh->IndexDataNum ;
		for( i = 0 ; i < Num ; i ++, DisplayList += Mesh->IndexStride )
		{
			if( Mesh->PNMtxIndex != NULL )
			{
				Mesh->PNMtxIndex[i] = DisplayList[PNMtxIndexAddress] ;
			}
		
			if( Mesh->Point != NULL )
			{
				Mesh->PointIndex[i] = (u16)GETINDEX( DisplayList + PointIndexAddress, PointIndexByte ) ;
			}

			if( Mesh->Color != NULL )
			{
				Mesh->ColorIndex[i] = (u16)GETINDEX( DisplayList + ColorIndexAddress, ColorIndexByte ) ;
			}
		
			if( Mesh->Uv != NULL )
			{
				Mesh->UvIndex[i] = (u16)GETINDEX( DisplayList + UvIndexAddress, UvIndexByte ) ;
			}
	
			if( Mesh->Normal != NULL )
			{
				Mesh->NormalIndex[i] = (u16)GETINDEX( DisplayList + NormalIndexAddress, NormalIndexByte ) ;
			}
		}
	}

	// evf̃f[^Rs[
	{
		u16 Num, i ;
		u8 *DataP ; 
		u16 Stride ;
		
		// _f[^̃Rs[
		if( PointBP != NULL )
		{
			Vec *V ;
			f32 Div ;
			GXCompType CompType ;
			
			CompType = PointDesc->comp_type ;
			Stride = PointDesc->stride ;
			Div = ( f32 )( 1 << PointDesc->frac ) ; 

			V = Mesh->Point ;
			Num = Mesh->PointNum ;
			DataP = PointBP ;
			for( i = 0 ; i < Num ; i ++, V ++, DataP += Stride )
			{
				switch( CompType )
				{
				case GX_F32 : *V = *( ( Vec * )DataP ) ; break ;
				case GX_U16 : V->x =  (f32)*( (u16 *)DataP ) / Div ; 
								V->y =  (f32)*( (u16 *)&DataP[2] ) / Div ;
								V->z =  (f32)*( (u16 *)&DataP[4] ) / Div ; break ;
				case GX_S16 : V->x =  (f32)*( (s16 *)DataP ) / Div ; 
								V->y =  (f32)*( (s16 *)&DataP[2] ) / Div ;
								V->z =  (f32)*( (s16 *)&DataP[4] ) / Div ; break ;
				}
			}
			DCStoreRange( Mesh->Point, Mesh->PointNum * sizeof( Vec ) ) ;
		}

		// J[f[^̃Rs[
		if( ColorBP != NULL )
		{
			GXCompType CompType ;
			u32 *C, temp ;

			CompType = ColorDesc->comp_type ;
			Stride = ColorDesc->stride ;

			C = Mesh->Color ;
			Num = Mesh->ColorNum ;
			DataP = ColorBP ;
			for( i = 0 ; i < Num ; i ++, C ++, DataP += Stride )
			{
				switch( CompType )
				{
				case GX_RGBA8 : *C = *( ( u32 * )DataP ) ; break ;
				case GX_RGBX8 : *C = *( ( u32 * )DataP ) | 0xff ; break ;
				case GX_RGB8 : *C = (u32)( ( *( ( u8 * )DataP ) << 24 ) | 
											( *( ( u16 * )&DataP[1] ) << 8 ) | 0xff ) ; break ;
				case GX_RGB565 : temp = *( ( u16 * )DataP ) ;
								*C = (u32)( 0xff |
									 ( ( ( ( (u32)temp >> 11 ) & 0x1f ) * 0xff / 0x1f ) << 24 ) | 
									 ( ( ( ( (u32)temp >> 5 ) & 0x3f ) * 0xff / 0x3f ) << 16 ) |
									 ( ( ( (u32)temp & 0x1f ) * 0xff / 0x1f ) << 8 ) ) ; break ;
				case GX_RGBA6 : temp = (u32)( ( *( ( u8 * )DataP ) << 16 ) |
											*( ( u16 * )&DataP[1] ) ) ;
								*C = (u32)(
									 ( ( ( ( (u32)temp >> 18 ) & 0x3f ) * 0xff / 0x3f ) << 24 ) | 
									 ( ( ( ( (u32)temp >> 12 ) & 0x3f ) * 0xff / 0x3f ) << 16 ) |
									 ( ( ( ( (u32)temp >> 6 ) & 0x3f ) * 0xff / 0x3f ) << 8 ) |
									 ( ( (u32)temp & 0x3f ) * 0xff / 0x3f ) ) ; break ;
				case GX_RGBA4 : temp = *( ( u16 * )DataP ) ;
								*C = (u32)( 
									( ( ( ( (u32)temp >> 12 ) & 0xf ) * 0xff / 0xf ) << 24 ) | 
									( ( ( ( (u32)temp >> 8 ) & 0xf ) * 0xff / 0xf ) << 16 ) |
									( ( ( ( (u32)temp >> 4 ) & 0xf ) * 0xff / 0xf ) << 8 ) |
									( ( (u32)temp & 0xf ) * 0xff / 0xf ) ) ; break ;
				}
			}
			DCStoreRange( Mesh->Color, Mesh->ColorNum * sizeof( UV ) ) ;
		}

		// Uvf[^̃Rs[
		if( UvBP != NULL )
		{
			f32 Div ;
			GXCompType CompType ;
			UV *Uv ;

			CompType = UvDesc->comp_type ;
			Stride = UvDesc->stride ;
			Div = ( f32 )( 1 << UvDesc->frac ) ; 

			Uv = Mesh->Uv ;
			Num = Mesh->UvNum ;
			DataP = UvBP ;
			for( i = 0 ; i < Num ; i ++, Uv ++, DataP += Stride )
			{
				switch( CompType )
				{
				case GX_F32 : *Uv = *( ( UV * )DataP ) ; break ;
				case GX_U16 : Uv->u =  (f32)*( (u16 *)DataP ) / Div ;
								Uv->v =  (f32)*( (u16 *)&DataP[2] ) / Div ; break ;
				case GX_S16 : Uv->u =  (f32)*( (s16 *)DataP ) / Div ;
								Uv->v =  (f32)*( (s16 *)&DataP[2] ) / Div ; break ;
				}
			}
			DCStoreRange( Mesh->Uv, Mesh->UvNum * sizeof( UV ) ) ;
		}
		
		// @f[^̃Rs[
		if( NormalBP != NULL )
		{
			Vec *V ;
			f32 Div ;
			GXCompType CompType ;
			
			CompType = NormalDesc->comp_type ;
			Stride = NormalDesc->stride ;
			Div = ( f32 )( 1 << NormalDesc->frac ) ; 

			V = Mesh->Normal ;
			Num = Mesh->NormalNum ;
			DataP = NormalBP ;
			for( i = 0 ; i < Num ; i ++, V ++, DataP += Stride )
			{
				switch( CompType )
				{
				case GX_F32 : *V = *( ( Vec * )DataP ) ; break ;
				case GX_U16 : V->x =  (f32)*( (u16 *)DataP ) / Div ; 
								V->y =  (f32)*( (u16 *)&DataP[2] ) / Div ;
								V->z =  (f32)*( (u16 *)&DataP[4] ) / Div ; break ;
				case GX_S16 : V->x =  (f32)*( (s16 *)DataP ) / Div ; 
								V->y =  (f32)*( (s16 *)&DataP[2] ) / Div ;
								V->z =  (f32)*( (s16 *)&DataP[4] ) / Div ; break ;
				}
			}
			DCStoreRange( Mesh->Normal, Mesh->NormalNum * sizeof( Vec ) ) ;
		}
	}
	
	// ꍇ͎ HSD_PObj ͂
	{
		MESH **act ;
		
		act = &Mesh->Next ;
		if( PObjNextFlag == TRUE && PObj->next != NULL )
		{
			HSD_PObj *pobj ;
		
			pobj = PObj->next ;
			while( pobj != NULL )
			{
				if( CreatePrimitiveMeshData( JObj, DObj, pobj, act,
												UseNormalFlag, UsePosFlag,
												UseColorFlag, UseUvFlag, UseBigMem, FALSE, FALSE ) < 0 )
				{
					DeletePrimitiveMeshData( Mesh ) ;
					return -1 ;
//					break ;
				}
				
				pobj = pobj->next ;
				act = &(*act)->Next ;
			}
		}
//		else
		if( DObj->next != NULL && DObj->next->pobj != NULL && DObjNextFlag == TRUE )
		{
			HSD_DObj *dobj ;
			
			dobj = DObj->next ;
			while( dobj != NULL )
			{
				if( CreatePrimitiveMeshData( JObj, dobj, dobj->pobj, act,
												UseNormalFlag, UsePosFlag,
												UseColorFlag, UseUvFlag, UseBigMem, FALSE, TRUE ) < 0 )
				{
					DeletePrimitiveMeshData( Mesh ) ;
					return -1 ;
//					break ;
				}

				dobj = dobj->next ;
				while( *act != NULL ) act = &(*act)->Next ;
			}
		}
	/*	else
		{
			Mesh->Next = NULL ;
		}
	*/
	}
	
	*MeshBuf = Mesh ;
	
	if( Mesh->Next != NULL )
	{
		Mesh->Next = Mesh->Next ;
	}

	// I
	return 0 ;
}

// bVf[^̌ns
#define RELEASEMEM(x,big)			\
	if( (x) != NULL )				\
	{								\
		FREE( x, (big) ) ;			\
		x = NULL ;					\
	}
extern s8 DeletePrimitiveMeshData( MESH *Mesh, u8 NextFlag )
{
	u8 UseBigMem = Mesh->BigMemFlag ;

	// e탁̊J
	RELEASEMEM(Mesh->Point, UseBigMem )
	RELEASEMEM(Mesh->PointIndex, UseBigMem)
	RELEASEMEM(Mesh->Color, UseBigMem)
	RELEASEMEM(Mesh->ColorIndex, UseBigMem)
	RELEASEMEM(Mesh->Uv, UseBigMem)
	RELEASEMEM(Mesh->UvIndex, UseBigMem)
	RELEASEMEM(Mesh->Normal, UseBigMem)
	RELEASEMEM(Mesh->NormalIndex, UseBigMem)
	RELEASEMEM(Mesh->PNMtxIndex, UseBigMem)
	
	// ꏏɊJ
	if( Mesh->Next != NULL && NextFlag == TRUE )
	{
		MESH *act, *back ;
	
		act = Mesh->Next ;
		while( act != NULL )
		{
			back = act ;
			act = act->Next ;
			DeletePrimitiveMeshData( back, FALSE ) ;
		}
		Mesh->Next = NULL ;
	}

	// ̊J
	RELEASEMEM(Mesh, UseBigMem) ;

	// I
	return 0 ;
}


// bVf[^ɕf[^쐬
#define DIV_SCALE	0.8F
//extern s8 DismemberPrimitiveMeshData( MESH *Src, BASICMESH **Dest )
extern s8 DismemberPrimitiveMeshData( MESH *, BASICMESH ** )
{
/*
#if 0
	u32 i, j, Num ;
	u16 k ;
	BASVERT *Vert ;
	u16 *Index ;
	BASICMESH *BasM ;

	// ̊m
	BasM = *Dest = ( BASICMESH * )K7AppSmallMemAlloc( sizeof( BASICMESH ) ) ;
	if( Dest == NULL )
		return -1 ;
	memset( BasM, 0, sizeof( BASICMESH ) ) ;

	// _f[^̐Zbg
	BasM->VertexNum = (u16)( ( Src->IndexDataNum / 3 ) * 6 ) ;

	// CfbNXz̐Zbg
	BasM->IndexNum = (u16)( ( Src->IndexDataNum / 3 ) * ( 8 * 3 ) ) ;

	// ̃f[^i[郁̈mۂ
	BasM->Vert = ( BASVERT * )K7AppSmallMemAlloc( (s32)( sizeof( BASVERT ) * BasM->VertexNum ) ) ;
	if( BasM->Vert == NULL ){ DeleteBasicMeshData( BasM ) ; return -1 ; }

	// ̃CfbNXzi[郁̈mۂ
	BasM->Index = ( u16 * )K7AppSmallMemAlloc( (s32)( sizeof( u16 ) * BasM->IndexNum ) ) ;
	if( BasM->Index == NULL ){ DeleteBasicMeshData( BasM ) ; return -1 ; }

	// _̃f[^𖄂߂Ă
	Num = Src->IndexDataNum ;
	Vert = BasM->Vert ;
	Index = BasM->Index ;
	k = 0 ;
	for( i = 0 ; i < Num ; i += 3, k += 6, Vert += 6, Index += 8 * 3 )
	{
		// ЂƂ̃|Sf[^ubN쐬
		for( j = 0 ; j < 3 ; j ++ )
		{
			Vert[j].Point = Src->Point[Src->PointIndex[i+j]] ;			Vert[j].Normal = ( Src->Normal != NULL ) ?  Src->Normal[Src->NormalIndex[i+j]] : (Vec){1.0F,0.0F,0.0F} ;
			Vert[j].Uv = Src->Uv[Src->UvIndex[i+j]] ;					Vert[j].Color = ( Src->Color != NULL ) ? Src->Color[Src->ColorIndex[i+j]] : 0xffffffff ;
			VECScale( &Vert[j].Point, &Vert[j+3].Point, DIV_SCALE ) ;	VECScale( &Vert[j].Normal, &Vert[j+3].Normal, -1.0F ) ;
			Vert[j+3].Uv = Vert[j].Uv ;									Vert[j+3].Color = Vert[j].Color ;
		}

		// _CfbNX̃Zbg
		Index[0] = (u16)( k ) ;				Index[1] = (u16)( k + 1 ) ;			Index[2] = (u16)( k + 2 ) ;
		Index[3] = (u16)( k + 5 ) ;			Index[4] = (u16)( k + 4 ) ;			Index[5] = (u16)( k + 3 ) ;
		
		Index[6] =  (u16)( k + 0 ) ;		Index[7] =  (u16)( k + 3 + 0 ) ;	Index[8]  = (u16)( k + 1 ) ;
		Index[9] =  (u16)( k + 3 + 0 ) ;	Index[10] = (u16)( k + 3 + 1 ) ;	Index[11] = (u16)( k + 1 ) ;
		
		Index[12] = (u16)( k + 1 ) ;		Index[13] = (u16)( k + 3 + 1 ) ;	Index[14] = (u16)( k + 2 ) ;
		Index[15] = (u16)( k + 3 + 1 ) ;	Index[16] = (u16)( k + 3 + 2 ) ;	Index[17] = (u16)( k + 2 ) ;
		
		Index[18] = (u16)( k + 2 ) ;		Index[19] = (u16)( k + 3 + 2 ) ;	Index[20] = (u16)k ;
		Index[21] = (u16)( k + 3 + 2 ) ;	Index[22] = (u16)( k + 3 ) ;		Index[23] = (u16)k ;
	}
	
	// f[^LbVtbV
	DCStoreRange( BasM->Vert, sizeof( BASVERT ) * BasM->VertexNum ) ;
	DCStoreRange( BasM->Index, sizeof( u16 ) * BasM->IndexNum ) ;
	
	// ̃bV炻̃bV͂
	if( Src->Next != NULL )
	{
		if( DismemberPrimitiveMeshData( Src->Next, &BasM->Next ) == -1 )
		{
			DeleteBasicMeshData( BasM ) ;
			return -1 ;
		}
	}
	else
	{
		BasM->Next = NULL ;
	}
#endif
*/	
	// I
	return 0 ;
}
		

// bVf[^ɊȈՃbVf[^쐬
extern s8 CreateBasicPrimitiveMeshData( MESH *Src, BASICMESH **Dest, u8 TransformFlag,
											u8 UseNormalFlag, u8 PosOnlyFlag, u8 UseBigMem, u8 NextFlag )
{
	u32 i, /*j,*/ Num ;
	u16 k ;
//	BASVERT *Vert ;
	Vec *DPoint ;				// Wf[^ւ̃|C^
	Vec *DNormal ;				// @f[^ւ̃|C^
	UV *DUv ;					// eNX`Wւ̃|C^
	u32 *DColor ;				// Ff[^ւ̃|C^
	u16 *Index ;
	BASICMESH *BasM ;
	static Mtx PosMtxTable[10], NrmMtxTable[10] ;
//	Mtx *PosMtxTable = ( Mtx * )&WorkBuffer[sizeof( Mtx ) * 60], *NrmMtxTable = ( Mtx * )&WorkBuffer[sizeof( Mtx ) * 70] ;
	
#ifdef ___MEMSIZEDUMP
	TRACE( "BasicPrimitive  SmallFree:%d   BigFree:%d\n", K7AppSmallMemGetFreeSize(), ghmGcMemGetFreeSize() ) ;
#endif

	// ̊m
	*Dest = NULL ;
	BasM = ( BASICMESH * )ALLOC( sizeof( BASICMESH ), "Y_BasMesh", UseBigMem ) ;
	if( BasM == NULL ) return -1 ;				// Kawakami 040118
	memset( BasM, 0, sizeof( BASICMESH ) ) ;
	
	// 傫̈gpĂ邩ǂ̃tOZbg
	BasM->BigMemFlag = UseBigMem ;
	
	// v~eBũ^CvRs[
	BasM->PrimitiveType = Src->PrimitiveType ;

	// _f[^̐Zbg
	BasM->VertexNum = (u16)Src->IndexDataNum ;

	// CfbNXz̐Zbg
	BasM->IndexNum = (u16)BasM->VertexNum ;

	// f[^i[郁̈mۂ
	{
		// XgCh̑傫𓾂
		BasM->Stride = (u16)( 
						( Src->Point != NULL ? sizeof( Vec ) : 0 ) +
						( Src->Color != NULL ? sizeof( u32 ) : 0 ) +
						( Src->Uv != NULL ? sizeof( UV ) : 0 ) +
						( Src->Normal != NULL ? sizeof( Vec ) : 0 )
						) ;

//		BasM->Vert = ( BASVERT * )K7AppSmallMemAlloc( (s32)( sizeof( BASVERT ) * BasM->VertexNum ) ) ;
//		if( BasM->Vert == NULL )
		BasM->VertexData = ALLOC( (s32)( BasM->Stride * BasM->VertexNum ), "Y_BMVert", UseBigMem ) ;
//		if( BasM->Vert == NULL )
		if( BasM->VertexData == NULL )
		{
			DeleteBasicMeshData( BasM ) ; return -1 ;
		}
		
		// ef[^̐擪AhXZbg
		{
			u8 *Point ;
			
			Point = ( u8 * )BasM->VertexData ;
			if( Src->Point == NULL ) BasM->Point = NULL ; else { BasM->Point = ( Vec * )Point ; Point += sizeof( Vec ) ; }
			if( Src->Normal == NULL ) BasM->Normal = NULL ; else { BasM->Normal = ( Vec * )Point ; Point += sizeof( Vec ) ; }
			if( Src->Uv == NULL ) BasM->Uv = NULL ; else { BasM->Uv = ( UV * )Point ; Point += sizeof( UV ) ; }
			if( Src->Color == NULL ) BasM->Color = NULL ; else { BasM->Color = ( u32 * )Point ; Point += sizeof( u32 ) ; }
		}
	}

	// CfbNXzi[郁̈mۂ
	BasM->Index = ( u16 * )ALLOC( (s32)( sizeof( u16 ) * BasM->IndexNum ), "Y_BMIdx", UseBigMem ) ;
	if( BasM->Index == NULL )
	{
		DeleteBasicMeshData( BasM ) ; return -1 ;
	}

	// sCfbNX݂āAgXtH[tOĂspӂ
	HSD_JObjSetupMatrix( Src->JObj ) ;
	if( TransformFlag == TRUE && Src->PNMtxIndex != NULL )
	{
		// se[u̍쐬
		CreateMatrixTable( Src->JObj, Src->PObj, &PosMtxTable[0], &NrmMtxTable[0] ) ;
	}
	else
	{
		BasM->JObj = Src->JObj ;
	}
	
	if( PosOnlyFlag == TRUE )
//	if( PosOnlyFlag == FALSE )
	{
		Vec *Point ;

		Num = Src->IndexDataNum ;
//		Vert = BasM->Vert ;
		DPoint = ( Vec * )BasM->Point ;
		Point = Src->Point ;
		Index = BasM->Index ;

		if( Src->PNMtxIndex != NULL )
		{
			for( i = 0 ; i < Num ; i ++, DPoint = ( Vec * )( ( u8 * )DPoint + BasM->Stride ), /*Vert ++,*/ Index ++ )
			{
				PSMTXMultVec( PosMtxTable[Src->PNMtxIndex[i] / 3], &Point[Src->PointIndex[i]], DPoint/*&Vert->Point*/ ) ;
//				*DPoint = Point[Src->PointIndex[i]] ;
				*Index = (u16)i ;
			}
		}
		else
		{
			Mtx *mtx = &( Src->JObj->mtx ) ;
			for( i = 0 ; i < Num ; i ++, DPoint = ( Vec * )( ( u8 * )DPoint + BasM->Stride ),/*Vert ++,*/ Index ++ )
			{
				PSMTXMultVec( (*mtx), &Point[Src->PointIndex[i]], DPoint/*&Vert->Point*/ ) ;
//				*DPoint = Point[Src->PointIndex[i]] ;
				*Index = (u16)i ;
			}
		}
	}
	else
	{
//#define TYPE1
		// _̃f[^𖄂߂Ă
		{
			Vec *Point, *Normal ;
			u32 *Color ;
			UV *Uv ;
			u8 MtxFlag, CrFlag ;
			u16 Stride ;
	#ifdef 	TYPE1
			u8 *MtxIndex ;
			u16 *PointIndex, *ColorIndex, *UvIndex, *NormalIndex ;
	#endif
			Mtx *mtx = &( Src->JObj->mtx ), Nrm ;

			Nrm[0][0] = (*mtx)[0][0] ; Nrm[0][1] = (*mtx)[0][1] ; Nrm[0][2] = (*mtx)[0][2] ; Nrm[0][3] = 0.0F ;
			Nrm[1][0] = (*mtx)[1][0] ; Nrm[1][1] = (*mtx)[1][1] ; Nrm[1][2] = (*mtx)[1][2] ; Nrm[1][3] = 0.0F ;
			Nrm[2][0] = (*mtx)[2][0] ; Nrm[2][1] = (*mtx)[2][1] ; Nrm[2][2] = (*mtx)[2][2] ; Nrm[2][3] = 0.0F ;

			MtxFlag = Src->PNMtxIndex != NULL ;
			CrFlag = Src->Color != NULL ;
			Normal =  UseNormalFlag == TRUE ? Src->Normal : NULL ;
			Num = Src->IndexDataNum ;
//			Vert = BasM->Vert ;
			DPoint = BasM->Point ;
			DNormal = BasM->Normal ;
			DUv = BasM->Uv ;
			DColor = BasM->Color ;
			Stride = BasM->Stride ;

			Index = BasM->Index ;
			Point = Src->Point ;
			Color = Src->Color ;
			Uv = Src->Uv ;
	#ifdef 	TYPE1
			MtxIndex = Src->PNMtxIndex ;
			PointIndex = Src->PointIndex ;
			ColorIndex = Src->ColorIndex ;
			UvIndex = Src->UvIndex ;
			NormalIndex = Src->NormalIndex ;
	#endif
			k = 0 ;


	#ifdef 	TYPE1
			for( i = 0 ; i < Num ; i ++, k ++, /*Vert ++,*/ 
									DPoint = ( Vec * )( ( u8 * )DPoint + Stride ),
									DNormal = ( Vec * )( ( u8 * )DNormal + Stride ),
									DUv = ( UV * )( ( u8 * )DUv + Stride ),
									DColor = ( u32* )( ( u8 * )DColor + Stride ),
									 Index ++, MtxIndex ++, PointIndex ++, ColorIndex ++, UvIndex ++, NormalIndex ++ )
	#else
			for( i = 0 ; i < Num ; i ++, k ++, /*Vert ++,*/
									DPoint = ( Vec * )( ( u8 * )DPoint + Stride ),
									DNormal = ( Vec * )( ( u8 * )DNormal + Stride ),
									DUv = ( UV * )( ( u8 * )DUv + Stride ),
									DColor = ( u32* )( ( u8 * )DColor + Stride ),
									 Index ++ )
	#endif
			{
				if( TransformFlag == TRUE )
				{
					if( MtxFlag )
					{
	#ifdef 	TYPE1
						PSMTXMultVec( PosMtxTable[*MtxIndex / 3], &Point[*PointIndex], DPoint/*&Vert->Point*/ ) ;
	#else
						PSMTXMultVec( PosMtxTable[Src->PNMtxIndex[k] / 3], &Point[Src->PointIndex[k]], DPoint/*&Vert->Point*/ ) ;
	#endif
	//					MTXMultVec( PosMtxTable[*MtxIndex / 3], &Point[*PointIndex], &Vert->Point ) ;
						if( Normal != NULL )
	#ifdef 	TYPE1
							PSMTXMultVec( NrmMtxTable[*MtxIndex / 3], &Normal[*NormalIndex], DNormal/*&Vert->Normal*/ ) ;
	#else
							PSMTXMultVec( NrmMtxTable[Src->PNMtxIndex[k] / 3], &Normal[Src->NormalIndex[k]], DNormal/*&Vert->Normal*/ ) ;
	#endif
	//						MTXMultVec( NrmMtxTable[*MtxIndex / 3], &Normal[*NormalIndex], &Vert->Normal ) ;
					}
					else
					{
	#ifdef 	TYPE1
						PSMTXMultVec( (*mtx), &Point[*PointIndex], DPoint/*&Vert->Point*/ ) ;
	#else
						PSMTXMultVec( (*mtx), &Point[Src->PointIndex[k]], DPoint/*&Vert->Point*/ ) ;
	#endif
	//					MTXMultVec( (*mtx), &Point[*PointIndex], &Vert->Point ) ;
						if( Normal != NULL )
	#ifdef 	TYPE1
							PSMTXMultVec( Nrm, &Normal[*NormalIndex], DNormal/*&Vert->Normal*/ ) ;
	#else
							PSMTXMultVec( Nrm, &Normal[Src->NormalIndex[k]], DNormal/*&Vert->Normal*/ ) ;
	#endif
	//						MTXMultVec( Nrm, &Normal[*NormalIndex], &Vert->Normal ) ;
					}
				}
				else
				{
	#ifdef 	TYPE1
					/*Vert->Point*/ *DPoint = Point[*PointIndex] ;
	#else
					/*Vert->Point*/ *DPoint = Point[Src->PointIndex[k]] ;
	#endif
					if( Normal != NULL )
	#ifdef 	TYPE1
						/*Vert->Normal*/ *DNormal = Normal[*NormalIndex] ;
	#else
						/*Vert->Normal*/ *DNormal = Normal[Src->NormalIndex[k]] ;
	#endif
				}

	#ifdef 	TYPE1
				if( Uv != NULL ) /*Vert->Uv*/ *DUv = Uv[*UvIndex] ;
	#else
				if( Uv != NULL ) /*Vert->Uv*/ *DUv = Uv[Src->UvIndex[k]] ;
	#endif
	#ifdef 	TYPE1
				if( CrFlag ) /*Vert->Color*/ *DColor = Color[*ColorIndex] ;
	#else
				if( CrFlag ) /*Vert->Color*/ *DColor = Color[Src->ColorIndex[k]] ;
	#endif
				// _CfbNX̃Zbg
				Index[0] = (u16)k ;
			}
		}
	}

	// f[^LbVtbV
//	DCStoreRange( BasM->Vert, sizeof( BASVERT ) * BasM->VertexNum ) ;
	DCStoreRange( BasM->VertexData, (u32)( BasM->Stride * BasM->VertexNum ) ) ;
	DCStoreRange( BasM->Index, sizeof( u16 ) * BasM->IndexNum ) ;

	// ̃bV炻̃bV͂
	if( Src->Next != NULL && NextFlag == TRUE )
	{
		BASICMESH **destact ;
		MESH *srcact ;
		
		destact = &BasM->Next ;
		srcact = Src->Next ;
		while( srcact != NULL )
		{
			if( CreateBasicPrimitiveMeshData( srcact, destact,
												 TransformFlag, UseNormalFlag, PosOnlyFlag,
												  UseBigMem, FALSE ) == -1 )
			{
				DeleteBasicMeshData( BasM ) ;
				return -1 ;
//				break ;
			}
			
			destact = &(*destact)->Next ;
			srcact = srcact->Next ;
		}
	}
//	else
//	{
//		BasM->Next = NULL ;
//	}

	if( BasM->Next != NULL )
	{
		BasM->Next = BasM->Next ;
	}
	
	*Dest = BasM ;
	
	// I
	return 0 ;
}




// ȈՃbVf[^̌ns
extern s8 DeleteBasicMeshData( BASICMESH *BasMesh, u8 NextFlag )
{
	u8 UseBigMem = BasMesh->BigMemFlag ;

	// e탁̊J
/*	if( BasMesh->Vert != NULL )
	{
		K7AppSmallMemFree( BasMesh->Vert ) ;
		BasMesh->Vert = NULL ;
	}
*/
	if( BasMesh->VertexData != NULL )
	{
		FREE( BasMesh->VertexData, UseBigMem ) ;
		BasMesh->VertexData = NULL ;
	}
	if( BasMesh->Index != NULL )
	{
		FREE( BasMesh->Index, UseBigMem ) ;
		BasMesh->Index = NULL ;
	}
	
	// ̃f[^玟̃f[^폜
	if( BasMesh->Next != NULL && NextFlag == TRUE )
	{
		BASICMESH *act, *back ;
		
		act = BasMesh->Next ;
		while( act != NULL )
		{
			back = act ;
			act = act->Next ;
			DeleteBasicMeshData( back, FALSE ) ;
		}
		BasMesh->Next = NULL ;
	}
	
	// ̊J
	FREE( BasMesh, UseBigMem ) ;
	
	// I
	return 0 ;
}


// WK7JObj 烂ff[^쐬( 0:  -1:s )
// Next  TRUE ̏ꍇ Child ͎I TRUE ɂȂ
extern s8 CreateModelData( HSD_JObj *JObj, MODEL **Model, u8 HideCheck, u8 NextFlag, u8 ChildFlag, u8 UseBigMem )
{
	MODEL *Mod ;
	HSD_DObj *dobj ;

	// f̃f[^i[郁̈̊m
	if( ( Mod = *Model = ( MODEL * )ALLOC( sizeof( MODEL ), "Y_Model", UseBigMem ) ) == NULL )
		return -1 ;

	// f[^̃Zbg
	Mod->BigMemFlag = UseBigMem ;
	Mod->JObj = JObj ;
	Mod->Mesh = NULL ;
	Mod->next = Mod->child = NULL ;
	
	// |Sf[^݂ꍇ̓bVf[^쐬
	if( ( dobj = GetHaveMeshDObj( JObj ) ) != NULL &&
		( HideCheck == FALSE ||
		  ( HideCheck == TRUE && ( JObj->flags & JOBJ_HIDDEN ) == 0 ) ) )
	{
		if( CreatePrimitiveMeshData( JObj, dobj, dobj->pobj, &Mod->Mesh, FALSE, TRUE, FALSE, FALSE, UseBigMem ) < 0 )
		{
			FREE( Mod, UseBigMem ) ;
			*Model = NULL ;
			return -1 ;
		}
	}

	// q JObj ݂ ChildFlag Ăꍇ͎q̃IuWFNgf
	if( ChildFlag == TRUE && JObj->child != NULL )
	{
		if( CreateModelData( JObj->child, &Mod->child, HideCheck, TRUE, TRUE, UseBigMem ) < 0 )
		{
			if( Mod->Mesh != NULL ) DeletePrimitiveMeshData( Mod->Mesh ) ;
			FREE( Mod, UseBigMem ) ;
			*Model = NULL ;
			return -1 ;
		}
	}
	
	//  JObj ݂ NextFlag Ăꍇ͎̃IuWFNgf
	if( NextFlag == TRUE && JObj->next != NULL )
	{
		if( CreateModelData( JObj->next, &Mod->next, HideCheck, NextFlag, TRUE, UseBigMem ) < 0 )
		{
			if( Mod->child != NULL ) DeleteModelData( Mod->child ) ;
			if( Mod->Mesh != NULL ) DeletePrimitiveMeshData( Mod->Mesh ) ;
			FREE( Mod, UseBigMem ) ;
			*Model = NULL ;
			return -1 ;
		}
	}
	
	// I
	return 0 ;
}


// ff[^̌ns
extern s8 DeleteModelData( MODEL *Model )
{
	// bVf[^폜
	if( Model->Mesh != NULL )
	{
		DeletePrimitiveMeshData( Model->Mesh ) ;
		Model->Mesh = NULL ;
	}
	
	// q̃fꍇ͎q̃f폜
	if( Model->child != NULL )
	{
		DeleteModelData( Model->child ) ;
		Model->child = NULL ;
	}
	
	// ̃fꍇ͎̃f폜
	if( Model->next != NULL )
	{
		DeleteModelData( Model->next ) ;
		Model->next = NULL ;
	}
	
	// ̃f[^mۂĂ̈J
	FREE( Model, Model->BigMemFlag ) ;
	
	// I
	return 0 ;
}

// MODEL ȈՃff[^쐬( Next  TRUE ̏ꍇ Child ͎I TRUE ɂȂ )
extern s8 CreateBasicModelData( MODEL *Src, BASICMODEL **Dest, u8 HideCheck, u8 UseBigMem,
							u8 NextFlag, u8 ChildFlag )
{
	BASICMODEL *bmod ;

	// ȈՃf̃f[^i[郁̈̊m
	if( ( bmod = *Dest = ( BASICMODEL * )ALLOC( sizeof( BASICMODEL ), "Y_BModel", UseBigMem ) ) == NULL )
		return -1 ;

	// f[^̃Zbg
	bmod->BigMemFlag = UseBigMem ;
	bmod->JObj = Src->JObj ;
	bmod->BasMesh = NULL ;
	bmod->next = bmod->child = NULL ;
	
	// bVf[^݂ꍇ̓bVf[^쐬
	if( Src->Mesh != NULL &&
		( HideCheck == FALSE ||
		  ( HideCheck == TRUE && ( Src->JObj->flags & JOBJ_HIDDEN ) == 0 ) ) )
	{
		if( CreateBasicPrimitiveMeshData( Src->Mesh, &bmod->BasMesh, TRUE, FALSE, TRUE, UseBigMem, TRUE ) < 0 )
		{
			FREE( bmod, UseBigMem ) ;
			*Dest = NULL ;
			return -1 ;
		}
	}

	// q MESH ݂ ChildFlag Ăꍇ͎q̃IuWFNgȈՃf
	if( ChildFlag == TRUE && Src->child != NULL )
	{
		if( CreateBasicModelData( Src->child, &bmod->child, HideCheck, UseBigMem, TRUE, TRUE ) < 0 )
		{
			if( bmod->BasMesh != NULL ) DeleteBasicMeshData( bmod->BasMesh ) ;
			FREE( bmod, UseBigMem ) ;
			*Dest = NULL ;
			return -1 ;
		}
	}
	
	//  MESH ݂ NextFlag Ăꍇ͎̃IuWFNgf
	if( NextFlag == TRUE && Src->next != NULL )
	{
		if( CreateBasicModelData( Src->next, &bmod->next, HideCheck, UseBigMem, TRUE, TRUE ) < 0 )
		{
			if( bmod->child != NULL ) DeleteBasicModelData( bmod->child ) ;
			if( bmod->BasMesh != NULL ) DeleteBasicMeshData( bmod->BasMesh ) ;
			FREE( bmod, UseBigMem ) ;
			*Dest = NULL ;
			return -1 ;
		}
	}
	
	// I
	return 0 ;
}

// ȈՃff[^̌ns
extern s8 DeleteBasicModelData( BASICMODEL *BasModel )
{
	// bVf[^폜
	if( BasModel->BasMesh != NULL )
	{
		DeleteBasicMeshData( BasModel->BasMesh ) ;
		BasModel->BasMesh = NULL ;
	}
	
	// q̃fꍇ͎q̃f폜
	if( BasModel->child != NULL )
	{
		DeleteBasicModelData( BasModel->child ) ;
		BasModel->child = NULL ;
	}
	
	// ̃fꍇ͎̃f폜
	if( BasModel->next != NULL )
	{
		DeleteBasicModelData( BasModel->next ) ;
		BasModel->next = NULL ;
	}

	// ̃f[^mۂĂ̈J
	FREE( BasModel, BasModel->BigMemFlag ) ;

	// I
	return 0 ;
}


// ȈՃf̊ȈՃbVSđ
extern s32 ScanBasicModelMesh( BASICMODEL *BasModel, s8 (*CallBack)( BASICMESH *BasMesh, void *Data ), void *Data )
{
	// bV݂ꍇ̂݃R[obN֐Ă
	if( BasModel->BasMesh != NULL ) CallBack( BasModel->BasMesh, Data ) ;

	// q̃fꍇ͂
	if( BasModel->child != NULL )
		if( ScanBasicModelMesh( BasModel->child, CallBack, Data ) < 0 ) return -1 ;
	
	// ̃fꍇ͂
	if( BasModel->next != NULL )
		if( ScanBasicModelMesh( BasModel->next, CallBack, Data ) < 0 ) return -1 ;
		
	// I
	return 0 ;
}
	
// ȈՃf̃|SSđ
extern s32 ScanBasicModelPrimitive( BASICMODEL *BasModel, s8 (*CallBack)( Vec **Point, void *Data ), void *Data )
{
	// bV݂ꍇ̂ݏ
	if( BasModel->BasMesh != NULL )
	{
		// ׂẴ|SXL
		ScanMeshPrimitive( BasModel->BasMesh, CallBack, Data ) ;
	}
	
	// q̃fꍇ͂
	if( BasModel->child != NULL )
		if( ScanBasicModelPrimitive( BasModel->child, CallBack, Data ) < 0 ) return -1 ;
	
	// ̃fꍇ͂
	if( BasModel->next != NULL )
		if( ScanBasicModelPrimitive( BasModel->next, CallBack, Data ) < 0 ) return -1 ;
		
	// I
	return 0 ;
}



// f̃|Sׂđ
extern s32 ScanModelPrimitive( MODEL *Model,
								s8 (*CallBack)( Vec **Point, void *Data ), void *Data )
{
	// bV݂ꍇ̂ݏ
	if( Model->Mesh != NULL /*&& Model->Mesh->PNMtxIndex == NULL*/ )
	{
		BASICMESH *BasicMesh ;

		// gXtH[̊ȈՃbVf[^쐬
		if( CreateBasicPrimitiveMeshData( Model->Mesh, &BasicMesh, TRUE, FALSE, TRUE, TRUE ) < 0 ) return -1 ;
		
		// ׂẴ|SXL
		ScanMeshPrimitive( BasicMesh, CallBack, Data ) ;
		
		// ȈՃbV폜
		DeleteBasicMeshData( BasicMesh ) ;
	}
	
	// q̃fꍇ͂
	if( Model->child != NULL )
		if( ScanModelPrimitive( Model->child, CallBack, Data ) < 0 ) return -1 ;
	
	// ̃fꍇ͂
	if( Model->next != NULL )
		if( ScanModelPrimitive( Model->next, CallBack, Data ) < 0 ) return -1 ;
	
	// I
	return 0 ;
}


// bV\Ă|SЂƂÂoē̊֐Ă
s32 ScanMeshPrimitive( BASICMESH *BasicMesh, s8 (*CallBack)( Vec **Point, void *Data ),
						void *Data, POSINDEXPOINTLIST *DestPIPList, POSINDEXPOINTLIST *ScanPIPList, u8 NextFlag )
{
	u16 Num, i ;
	Vec *Point[3]/*, Back*/ ;
	s32 PolygonNum ;
	u8 *MPoint ;
	s32 Stride ;
	u16 *Index ;

	// W̐擪AhXZbg
	MPoint = ( u8 * )BasicMesh->Point ;
	Stride = BasicMesh->Stride ;
	Index = BasicMesh->Index ;

	// Wf[^ȂG[
	if( MPoint == NULL ) return -1 ;
	
	// XLp_|C^XgnĂꍇ͂XL
	if( ScanPIPList != NULL && CallBack != NULL )
	{
		Vec **Pos ;
		
		// ׂẴbV𑖍
		Pos = ScanPIPList->PolyPoint ;
		Num = (u16)ScanPIPList->PolyPointNum ;
		for( i = 0 ; i < Num ; i += 3, Pos += 3 )
		{
			if( CallBack( Pos, Data ) < 0 ) return -2 ;
		}
		
		return 0 ;
	}

	// v~eBũ^Cvɂďς
	if( BasicMesh->PrimitiveType == GX_TRIANGLES )
	{
		// Triangle List ̏ꍇ
		
		// R[obNȂ琔Ԃ
		if( CallBack == NULL )
		{
			PolygonNum = BasicMesh->IndexNum / 3 ;
		}
		else
		{
			// ׂẴbV𑖍
			Num = BasicMesh->IndexNum ;
			for( i = 0 ; i < Num ; i += 3 )
			{
//				Point[0] = BasicMesh->Vert[BasicMesh->Index[i]].Point ;
//				Point[1] = BasicMesh->Vert[BasicMesh->Index[i+1]].Point ;
//				Point[2] = BasicMesh->Vert[BasicMesh->Index[i+2]].Point ;
				Point[0] = ( ( Vec * )( MPoint + Index[i] * Stride ) ) ;
				Point[1] = ( ( Vec * )( MPoint + Index[i+1] * Stride ) ) ;
				Point[2] = ( ( Vec * )( MPoint + Index[i+2] * Stride ) ) ;

				if( DestPIPList != NULL )
				{
					DestPIPList->PolyPoint[ i * 3 ] = Point[0] ;
					DestPIPList->PolyPoint[ i * 3 + 1 ] = Point[1] ;
					DestPIPList->PolyPoint[ i * 3 + 2 ] = Point[2] ;
				}
		
				// R[obN֐Ă
				if( CallBack( Point, Data ) < 0 )
					return -2 ;
			}
		}
	}
	else
	if( BasicMesh->PrimitiveType == GX_TRIANGLESTRIP )
	{
		u8 Flag ;
		s32 con = 0 ;
	
		// Trianglestrip ̏ꍇ
		
		PolygonNum = 0 ;
		
		// ŏ̎Op`
		Num = BasicMesh->IndexNum ;
		i = 0 ;
//		Point[0] = BasicMesh->Vert[BasicMesh->Index[i]].Point ;
//		Point[1] = BasicMesh->Vert[BasicMesh->Index[i+1]].Point ;
//		Back = Point[2] = BasicMesh->Vert[BasicMesh->Index[i+2]].Point ;
		Point[0] = ( ( Vec * )( MPoint + Index[i] * Stride ) ) ;
		Point[1] = ( ( Vec * )( MPoint + Index[i+1] * Stride ) ) ;
		Point[2] = ( ( Vec * )( MPoint + Index[i+2] * Stride ) ) ;
//		Back = Point[2] = *( ( Vec * )( MPoint + BasicMesh->Index[i+2] * Stride ) ) ;

		if( DestPIPList != NULL )
		{
			DestPIPList->PolyPoint[ PolygonNum * 3 ] = Point[0] ;
			DestPIPList->PolyPoint[ PolygonNum * 3 + 1 ] = Point[1] ;
			DestPIPList->PolyPoint[ PolygonNum * 3 + 2 ] = Point[2] ;
		}
		
		// R[obN֐Ă
		if( CallBack != NULL )
		{
			if( CallBack( Point, Data ) < 0 )
				return -2 ;
		}
		i += 3 ;
		PolygonNum ++ ;
		
		// ̌ɑׂẴbV𑖍
		Flag = TRUE ;
		while( i < Num )
		{
//			if( con % 3 == 0 )
			{
				if( Flag == FALSE )
				{
	//				Point[0] = BasicMesh->Vert[BasicMesh->Index[i-2]].Point ;
	//				Point[1] = BasicMesh->Vert[BasicMesh->Index[i-1]].Point ;
	//				Point[2] = BasicMesh->Vert[BasicMesh->Index[i]].Point ;
					Point[0] = ( ( Vec * )( MPoint + Index[i-2] * Stride ) ) ;
					Point[1] = ( ( Vec * )( MPoint + Index[i-1] * Stride ) ) ;
					Point[2] = ( ( Vec * )( MPoint + Index[i] * Stride ) ) ;
					
					Flag = TRUE ;
				}
				else
				{
	//				Point[0] = BasicMesh->Vert[BasicMesh->Index[i-1]].Point ;
	//				Point[1] = BasicMesh->Vert[BasicMesh->Index[i-2]].Point ;
	//				Point[2] = BasicMesh->Vert[BasicMesh->Index[i]].Point ;
					Point[0] = ( ( Vec * )( MPoint + Index[i-1] * Stride ) ) ;
					Point[1] = ( ( Vec * )( MPoint + Index[i-2] * Stride ) ) ;
					Point[2] = ( ( Vec * )( MPoint + Index[i] * Stride ) ) ;

					Flag = FALSE ;
				}

				// W΂
				if( ( Point[1]->x == Point[2]->x && Point[1]->y == Point[2]->y && Point[1]->z == Point[2]->z ) ||
					( Point[0]->x == Point[2]->x && Point[0]->y == Point[2]->y && Point[0]->z == Point[2]->z ) ||
					( Point[1]->x == Point[0]->x && Point[1]->y == Point[0]->y && Point[1]->z == Point[0]->z ) )
				{
					i ++ ;
	//				Flag = (u8)( Flag == TRUE ? FALSE : TRUE ) ;
				}
				else
				{
				
					if( DestPIPList != NULL )
					{
						DestPIPList->PolyPoint[ PolygonNum * 3 ] = Point[0] ;
						DestPIPList->PolyPoint[ PolygonNum * 3 + 1 ] = Point[1] ;
						DestPIPList->PolyPoint[ PolygonNum * 3 + 2 ] = Point[2] ;
					}

					if( CallBack != NULL )
					{
						if( CallBack( Point, Data ) < 0 )
							return -2 ;
					}
					PolygonNum ++ ;
					i ++ ;
				}
			}
/*			else
			{
				i ++ ;
			}
*/			con ++ ;

//			Back = *( ( Vec * )( MPoint + BasicMesh->Index[i-1] * Stride ) ) ;
		}
	}
	
	// ̃bV炻Ă
	if( BasicMesh->Next != NULL && NextFlag == TRUE )
	{
		s32 hr ;
		BASICMESH *basm ;
		
		basm = BasicMesh->Next ;
		while( basm != NULL )
		{
			hr = ScanMeshPrimitive( basm, CallBack, Data, DestPIPList, ScanPIPList, FALSE ) ;
			if( hr == -2 )
				return -2 ;
			PolygonNum += hr ;
			basm = basm->Next ;
		}
	}
	
	// I
	return PolygonNum ;
}


// bV\Ă`撸_ÂoăR[obN֐Ă
extern s32 ScanMeshVertex( BASICMESH *BasicMesh, s8 (*CallBack)( Vec *Point, void *Data ),	void *Data, s8 NextFlag )
{
	u16 Num, i ;
	u8 *MPoint ;
	s32 Stride ;
	u16 *Index ;

	// W̐擪AhXZbg
	MPoint = ( u8 * )BasicMesh->Point ;
	Stride = BasicMesh->Stride ;
	Index = BasicMesh->Index ;

	// Wf[^ȂG[
	if( MPoint == NULL ) return -1 ;

	// ׂẴbV𑖍
	Num = BasicMesh->IndexNum ;
	for( i = 0 ; i < Num ; i ++ )
	{
		if( CallBack( ( Vec * )( MPoint + Index[i] * Stride ), Data ) < 0 )
			return -2 ;
	}

	// ̃bV炻Ă
	if( BasicMesh->Next != NULL && NextFlag == TRUE )
	{
		s32 hr ;
		BASICMESH *basm ;
		
		basm = BasicMesh->Next ;
		while( basm != NULL )
		{
			hr = ScanMeshVertex( basm, CallBack, Data, FALSE ) ;
			if( hr == -2 )
				return -2 ;
				
			basm = basm->Next ;
		}
	}
	
	// I
	return 0 ;
}
	




//  JObj Ɋ֘Âv~eBuf[^ׂĂ JObj XL
extern s8 ScanPrimitiveJObj( WK7JObj *JObj,
			void (*CallBack)( WK7JObj *JObj, void *Data ), void *Data, s8 NextFlag )
{
	// v~eBuĂȂR[obN֐͌Ă΂Ȃ
	if( GetHaveMeshDObj( JObj->GetJObj() ) != NULL ) CallBack( JObj, Data ) ;
//	if( JObj->GetJObj()->u.dobj != NULL ) CallBack( JObj, Data ) ;

	// qq
	if( JObj->GetChild() != NULL ) ScanPrimitiveJObj( JObj->GetChild(), CallBack, Data ) ;

	// ̃f[^玟̃f[^
/*
<<<<<<< YK7Break.cpp
	if( JObj->GetNext() != NULL ) ScanPrimitiveJObj( JObj->GetNext(), CallBack, Data ) ;

=======
*/
	if( JObj->GetPrev()==NULL && NextFlag == TRUE ){
		WK7JObj		*pNext;
		for(pNext=JObj->GetNext() ; pNext!=NULL ; pNext=pNext->GetNext()){
			ScanPrimitiveJObj( pNext, CallBack, Data, FALSE ) ;
		}
	}
//	if( JObj->GetNext() != NULL ) ScanPrimitiveJObj( JObj->GetNext(), CallBack, Data ) ;
			
//>>>>>>> 1.29
	// I
	return NULL ;
}


// ȈՃbVf[^ɑ݂Ă|S̐𐔂
extern s32 GetBasicMeshPolygonNum( BASICMESH *BasicMesh )
{
	return ScanMeshPrimitive( BasicMesh, NULL, NULL ) ;
/*
	// v~eBũ^Cvɂď𕪊
	switch( BasicMesh->PrimitiveType )
	{
	case GX_TRIANGLES :
		// gCAOXg̏ꍇ́APɒ_RŊ
		return BasicMesh->VertexNum / 3 ;

	case GX_TRIANGLESTRIP :
		// gCAOXgbv̏ꍇ́AvZ
		return BasicMesh->VertexNum - 2 ;
	}
	
	// I
	return 0 ;
*/
}

// f̑ʐς𓾂邽߂̃R[obN֐
static s8 ModelPolygonAreaCallBack( Vec **Point, void *Data )
{
	*((f32*)Data) += GetPolygonArea( Point ) ;
/*
	Vec d1, d2 ;

	PSVECSubtract( Point[1], Point[0], &d1 ) ;
	PSVECSubtract( Point[2], Point[0], &d2 ) ;

	// ʐςZ
	Area += sqrt( ( ( d1.y * d2.z - d1.z * d2.y ) * ( d1.y * d2.z - d1.z * d2.y ) ) + 
					( ( d1.z * d2.x - d1.x * d2.z ) * ( d1.z * d2.x - d1.x * d2.z ) ) + 
					( ( d1.x * d2.y - d1.y * d2.x ) * ( d1.x * d2.y - d1.y * d2.x ) ) ) / 2.0F ;
*/

	// I
	return 0 ;
}

// f̑ʐς𓾂
extern f32 GetModelPolygonArea( MODEL *Model )
{
	f32 Area ;

	// f̃|Sׂė񋓂
	Area = 0.0F ;
	ScanModelPrimitive( Model, ModelPolygonAreaCallBack, &Area ) ;

	// ZoʐςԂ
	return Area ;
}

// f̑ʐς𓾂
extern f32 GetBasicMeshPolygonArea( BASICMESH *BasicMesh )
{
	f32 Area ;

	// f̃|Sׂė񋓂
	Area = 0.0F ;
	ScanMeshPrimitive( BasicMesh, ModelPolygonAreaCallBack, &Area ) ;

	// ZoʐςԂ
	return Area ;
}
	



// v~eBut JObj ɑ݂Ă|S̐𐔂
extern s32 GetJObjMeshPolygonNum( HSD_JObj *JObj )
{
	BASICMESH *BasM ;
	MESH *Mesh ;
	s32 PolyNum ;
	HSD_DObj *dobj ;

	// |SȂI
	if( ( dobj = GetHaveMeshDObj( JObj ) ) == NULL ) return -1 ;
//	if( JObj->u.dobj == NULL || JObj->u.dobj->pobj == NULL ) return -1 ;

	// |S烁bV쐬
	if( CreatePrimitiveMeshData( JObj, dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) < 0 ) return -1 ;
	if( CreateBasicPrimitiveMeshData( Mesh, &BasM, FALSE, FALSE, TRUE, TRUE ) < 0 )
	{
		DeletePrimitiveMeshData( Mesh ) ;
		return -1 ;
	}

	// 擾
	PolyNum = ScanMeshPrimitive( BasM, NULL, NULL ) ;
	
	// bVf[^̍폜
	DeleteBasicMeshData( BasM ) ;
	DeletePrimitiveMeshData( Mesh ) ;

	// 𐔂ĕԂ
	return PolyNum ;
}

// PObj ɑ݂Ă`撸_CfbNX̐Ԃ
extern s32 GetPObjMeshIndexNum( HSD_PObj *PObj, u8 NextFlag )
{
	s32 IndexNum ;

	IndexNum = 0 ;

	do
	{
		IndexNum = (s32)*( (u16 *)( (u8 *)PObj->dl + 1 ) ) ;
		PObj = PObj->next ;	
	}while( PObj != NULL && NextFlag == TRUE ) ;
	
/*	IndexNum = (s32)*( (u16 *)( (u8 *)PObj->dl + 1 ) ) ;
	
	// 炻
	if( PObj->next != NULL && NextFlag == TRUE )
		IndexNum += GetPObjMeshIndexNum( PObj->next, TRUE ) ;
*/

	// Ԃ
	return IndexNum ;
}


// PObj ɑ݂Ă|S̐𐔂
/*
extern s32 GetPObjMeshPolygonNum( HSD_PObj *PObj, u8 NextFlag )
{
	GXPrimitive PrimitiveType ;
	u16 IndexDataNum ;
	s32 VertexNum ;

	// v~eBũ^Cv擾
	PrimitiveType = (GXPrimitive)*PObj->dl ;

	// _̐擾
	IndexDataNum = *( (u16 *)( (u8 *)PObj->dl + 1 ) ) ;

	// v~eBũ^Cvɂď𕪊
	switch( PrimitiveType )
	{
	case GX_TRIANGLES :
		// gCAOXg̏ꍇ́APɒ_RŊ
		VertexNum = IndexDataNum / 3 ;

	case GX_TRIANGLESTRIP :
		// gCAOXgbv̏ꍇ́AvZ
		VertexNum = IndexDataNum - 2 ;
	}
	
	// 炻
	if( PObj->next != NULL && NextFlag == TRUE )
		VertexNum += GetPObjMeshPolygonNum( PObj->next, TRUE ) ;

	// Ԃ
	return VertexNum ;
}
*/	


// bVf[^{Gx[vt JObj Ase[u쐬
s8 CreateMatrixTable( HSD_JObj *JObj, HSD_PObj *PObj, Mtx *PosMtxTable, Mtx *NrmMtxTable )
{
	HSD_PObj *pobj ;

	// Gx[vXg邩ǂŏ𕪊
	pobj = PObj ; //JObj->u.dobj->pobj ;
	if( pobj->u.envelope_list != NULL )
	{
		HSD_SList *List ;
		HSD_Envelope *Env ;
		HSD_JObj *jobj ;
		u16 i ;
		static Mtx Mtemp, temp ;
//		Mtx &Mtemp = *(( Mtx * )WorkBuffer), &temp = *(( Mtx * )&WorkBuffer[sizeof( Mtx )]) ;
		f32 MaxWeight ;

		List = pobj->u.envelope_list ;
		
		// Gx[v`ĕϊsׂăZbg
		MaxWeight = 0.0F ;
		for( i = 0 ; i < 10 && List != NULL ; i ++, List = List->next )
		{
			// Gx[v擾
			Env = ( HSD_Envelope * )List->data ;
			
			// }gbNX̏
			Mtemp[0][0] = Mtemp[0][1] = Mtemp[0][2] = Mtemp[0][3] = 
			Mtemp[1][0] = Mtemp[1][1] = Mtemp[1][2] = Mtemp[1][3] = 
			Mtemp[2][0] = Mtemp[2][1] = Mtemp[2][2] = Mtemp[2][3] = 0.0F ;

			// Gx[vXg̏I[ɗ܂Ń[vJn
			while( Env != NULL )
			{
//				Mtx m ;
			
//				if( Env->weight > 0.0F )
				{
					// {[𓾂
					jobj = Env->jobj ;

					// vZĂȂƂ܂̂Łc
					HSD_JObjSetupMatrix( jobj ) ;

					// {[̃[JWɗƂލsƃ{[̕ϊs|킹
	//				memcpy( m, jobj->envelopemtx, sizeof( Mtx ) ) ;
	//				MTXIdentity( m ) ;
					PSMTXConcat( jobj->mtx, jobj->envelopemtx, temp ) ;
	//				temp[0][0] = 0.01F ; temp[0][1] = 0.01F ;	temp[0][2] = 0.01F ;	temp[0][3] = 0.01F ;
	//				temp[1][0] = 0.01F ; temp[1][1] = 0.01F ;	temp[1][2] = 0.01F ;	temp[1][3] = 0.01F ;
	//				temp[2][0] = 0.01F ; temp[2][1] = 0.01F ;	temp[2][2] = 0.01F ;	temp[2][3] = 0.01F ;

					// ɃEGCg|킹̂܂ł̍sɑ
	//				MTXScale( temp, temp, Env->weight ) ;
					HSD_MtxScaledAdd( Env->weight, (MtxPtr)temp, (MtxPtr)Mtemp, (MtxPtr)Mtemp ) ;
	//				Mtemp[0][0] += temp[0][0] * Env->weight ; Mtemp[0][1] += temp[0][1] * Env->weight ; Mtemp[0][2] += temp[0][2] * Env->weight ; Mtemp[0][3] += temp[0][3] * Env->weight ;
	//				Mtemp[1][0] += temp[1][0] * Env->weight ; Mtemp[1][1] += temp[1][1] * Env->weight ; Mtemp[1][2] += temp[1][2] * Env->weight ; Mtemp[1][3] += temp[1][3] * Env->weight ;
	//				Mtemp[2][0] += temp[2][0] * Env->weight ; Mtemp[2][1] += temp[2][1] * Env->weight ; Mtemp[2][2] += temp[2][2] * Env->weight ; Mtemp[2][3] += temp[2][3] * Env->weight ;

	//				Mtemp[0][0] += 0.01F ; Mtemp[0][1] += 0.01F ; Mtemp[0][2] += 0.01F ; Mtemp[0][3] += 0.01F ;
	//				Mtemp[1][0] += 0.01F ; Mtemp[1][1] += 0.01F ; Mtemp[1][2] += 0.01F ; Mtemp[1][3] += 0.01F ;
	//				Mtemp[2][0] += 0.01F ; Mtemp[2][1] += 0.01F ; Mtemp[2][2] += 0.01F ; Mtemp[2][3] += 0.01F ;
				}

				// ̃Gx[vɁc
				Env = Env->next ;
			}

			// I}gbNXZbg
//			memcpy( PosMtxTable[i], Mtemp, sizeof( Mtx ) ) ;
//			MTXIdentity( Mtemp ) ;
			PSMTXCopy( Mtemp, PosMtxTable[i] ) ;

			// PʉĖ@sƂĂZbg
			if( NrmMtxTable != NULL )
			{
				f32 r ;

				r = sqrt( Mtemp[0][0] * Mtemp[0][0] + Mtemp[0][1] * Mtemp[0][1] + Mtemp[0][2] * Mtemp[0][2] + 
							Mtemp[1][0] * Mtemp[1][0] + Mtemp[1][1] * Mtemp[1][1] + Mtemp[1][2] * Mtemp[1][2] +
							Mtemp[2][0] * Mtemp[2][0] + Mtemp[2][1] * Mtemp[2][1] + Mtemp[2][2] * Mtemp[2][2] ) ;
				Mtemp[0][0] /= r ; Mtemp[0][1] /= r ; Mtemp[0][2] /= r ; Mtemp[0][3] = 0.0F ;
				Mtemp[1][0] /= r ; Mtemp[1][1] /= r ; Mtemp[1][2] /= r ; Mtemp[1][3] = 0.0F ;
				Mtemp[2][0] /= r ; Mtemp[2][1] /= r ; Mtemp[2][2] /= r ; Mtemp[2][3] = 0.0F ;

				PSMTXCopy( Mtemp, NrmMtxTable[i] ) ;
//				MTXIdentity( NrmMtxTable[i] ) ;
			}
		}
	}
	else
	{
		PSMTXCopy( JObj->mtx, PosMtxTable[0] ) ;
		PSMTXCopy( JObj->mtx, NrmMtxTable[0] ) ;
		NrmMtxTable[0][0][3] = NrmMtxTable[0][1][3] = NrmMtxTable[0][2][3] = 0.0F ;
	}
	
	// I
	return 0 ;
}

// w̔ԍ̒_f[^ PObj  DObj ̃AhX𓾂
extern s8 GetHaveHopeNumberVertexPObj( HSD_JObj *JObj, u32 Number, u32 *HopeNumber, HSD_PObj **PObj, HSD_DObj **DObj )
{
	u32 Num ;
	HSD_PObj *pobj ;
	HSD_DObj *dobj ;

	// nꂽ JObj ɃbVf[^݂ȂG[
	if( ( dobj = GetHaveMeshDObj( JObj ) ) == NULL ) return -1 ;

	// wio[̒_f[^ DObj  PObj 
	dobj = JObj->u.dobj ;
	for(;;)
	{
		pobj = dobj->pobj ;
		
		for(;;)
		{
			if( Number < ( Num = (u32)GetPObjMeshIndexNum( pobj, FALSE ) ) ) goto R1 ;
			Number -= Num ;

			if( pobj->next == NULL ) break ;
			pobj = pobj->next ;
		}
		if( dobj->next == NULL ) return -1 ;
		dobj = dobj->next ;
	}

R1 :
	//  PObj  DObj ƁÃbVf[^ł̒_ԍԂ
	*HopeNumber = Number ;
	*PObj = pobj ;
	*DObj = dobj ;
	return 0 ;
}


// bVf[^̊]̒_ԍ̖@ƍW𓾂
extern s8 GetHopeNumberVertexPositionAndNormal( MESH *Mesh, u32 Number, Vec *PosBuf, Vec *NrmBuf, MtxPtr PosMtxBuf, MtxPtr NrmMtxBuf )
{
//	u32 i, Num ;
//	u16 k ;
	static Mtx PosMtxTable[10], NrmMtxTable[10] ;
//	Mtx *PosMtxTable = ( Mtx * )&WorkBuffer[sizeof( Mtx ) * 20], *NrmMtxTable = ( Mtx * )&WorkBuffer[sizeof( Mtx ) * 30] ;

	if( Mesh->IndexDataNum <= Number )
	{
		Number = (u32)( Mesh->IndexDataNum - 1 ) ;
	}

	// sCfbNX݂āAgXtH[tOĂspӂ
//	HSD_JObjSetupMatrix( Mesh->JObj ) ;
	if( Mesh->PNMtxIndex != NULL )
	{
		// se[u̍쐬
		CreateMatrixTable( Mesh->JObj, Mesh->PObj, PosMtxTable, NrmMtxTable ) ;
	}

	// w̒_̍WƖ@vZ
	{
		if( Mesh->PNMtxIndex != NULL )
		{
			PSMTXMultVec( PosMtxTable[Mesh->PNMtxIndex[Number] / 3], &Mesh->Point[Mesh->PointIndex[Number]], PosBuf ) ;
			if( PosMtxBuf != NULL )
			{
				PSMTXCopy( PosMtxTable[Mesh->PNMtxIndex[Number] / 3], PosMtxBuf ) ;
			}
			
			if( Mesh->Normal != NULL && NrmBuf != NULL )
			{
				PSMTXMultVec( NrmMtxTable[Mesh->PNMtxIndex[Number] / 3], &Mesh->Normal[Mesh->NormalIndex[Number]], NrmBuf ) ;
				if( NrmMtxBuf != NULL )
				{
					PSMTXCopy( NrmMtxTable[Mesh->PNMtxIndex[Number] / 3], NrmMtxBuf ) ;
				}
			}
		}
		else
		{
//			MTXMultVec( Mesh->JObj->mtx, &Mesh->Point[Mesh->PointIndex[Number]], PosBuf ) ;
			PSMTXMultVec( Mesh->JObj->mtx, &Mesh->Point[Mesh->PointIndex[Number]], PosBuf ) ;
			if( PosMtxBuf != NULL )
			{
				PSMTXCopy( Mesh->JObj->mtx, PosMtxBuf ) ;
			}

			if( Mesh->Normal != NULL && NrmBuf != NULL )
			{
#if !FUJITA
/*
				memcpy( Nrm, Mesh->JObj->mtx, sizeof( Mtx ) ) ;
				Nrm[0][3] = Nrm[1][3] = Nrm[2][3] = 0.0F ;
//				MTXMultVec( Nrm, &Mesh->Normal[Mesh->NormalIndex[Number]], NrmBuf ) ;
				PSMTXMultVec( Nrm, &Mesh->Normal[Mesh->NormalIndex[Number]], NrmBuf ) ;
*/
#else
//				MTXMultVecSR( Mesh->JObj->mtx, &Mesh->Normal[Mesh->NormalIndex[Number]], NrmBuf ) ;
				PSMTXMultVecSR( Mesh->JObj->mtx, &Mesh->Normal[Mesh->NormalIndex[Number]], NrmBuf ) ;
				if( NrmMtxBuf != NULL )
				{
					PSMTXCopy( Mesh->JObj->mtx, NrmMtxBuf ) ;
					NrmMtxBuf[0][3] = NrmMtxBuf[1][3] = NrmMtxBuf[2][3] = 0.0F ;
				}
#endif
			}
		}
	}
	// I
	return 0 ;
}

// |S̖ʐς𓾂
extern inline f32 GetPolygonArea( Vec **Point )
{
	Vec d1, d2 ;

	PSVECSubtract( Point[1], Point[0], &d1 ) ;
	PSVECSubtract( Point[2], Point[0], &d2 ) ;

	// ʐςԂ
	return sqrt( ( ( d1.y * d2.z - d1.z * d2.y ) * ( d1.y * d2.z - d1.z * d2.y ) ) + 
				( ( d1.z * d2.x - d1.x * d2.z ) * ( d1.z * d2.x - d1.x * d2.z ) ) + 
				( ( d1.x * d2.y - d1.y * d2.x ) * ( d1.x * d2.y - d1.y * d2.x ) ) ) / 2.0F ;
}

// bVĂŏ dobj 擾
inline extern HSD_DObj *GetHaveMeshDObj( HSD_JObj *JObj )
{
	HSD_DObj *dobj ;
	
	dobj = JObj->u.dobj ;
	while( dobj != NULL )
	{
		if( dobj->pobj != NULL ) return dobj ;
		dobj = dobj->next ;
	}
	
	return NULL ;
}


	
// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐
static void LengthScanCallBack( WK7JObj *JObj, void *Data )
{
	MESH *Mesh ;
	BASICMESH *BasM ;
	LENGTHLIST *LengthInfo = ( LENGTHLIST * )Data ;
	s8 Result ;
	HSD_DObj *dobj ;
	
//	if( JObj->GetJObj()->u.dobj == NULL || JObj->GetJObj()->u.dobj->pobj || NULL ) return ;
	if( ( dobj = GetHaveMeshDObj( JObj->GetJObj() ) ) == NULL ) return ;

	// bVf[^̍쐬
	if( CreatePrimitiveMeshData( JObj->GetJObj(), dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) == -1 ) return ;
	Result = CreateBasicPrimitiveMeshData( Mesh, &BasM, TRUE, FALSE, TRUE, TRUE ) ;
	DeletePrimitiveMeshData( Mesh ) ;
	if( Result == -1 ) return ;

	// bVf[^̑
	LengthInfo->JObj = JObj ;
	LengthInfo->PointCounter = 0 ;
	ScanMeshVertex( BasM, LengthPolyScanCallBack, Data ) ;

	// bVf[^̉
	DeleteBasicMeshData( BasM ) ;
}

// Cӂ̍Wƒ_Ƃ̋v邽߂̃R[obN֐(|Sp)
static s8 LengthPolyScanCallBack( Vec *Point, void *Data )
{
	f32 Length ;
	LENGTHLIST *LengthInfo = ( LENGTHLIST * )Data ;

	// 擾
	Length = PSVECDistance( Point, &LengthInfo->Point ) ;
	
	// ră\[g
	{
		LENGTHLISTCHIP *Chip1, *Chip2, *Chip ;
		
		Chip1 = &LengthInfo->Chip[0] ;
		Chip2 = NULL ;
		while( Chip1 != NULL && Chip1->Length <= Length )
		{
			Chip2 = Chip1 ;
			Chip1 = Chip1->Next ;
		}
		if( Chip1 == NULL )
		{
			if( LengthInfo->MaxNum == LengthInfo->Num )
				goto R_END ;
			
			Chip = &LengthInfo->Chip[ LengthInfo->Num ] ;
			LengthInfo->Num ++ ;

			Chip->Back = Chip2 ;
			Chip->Next = NULL ;
			Chip2->Next = Chip ;				

			LengthInfo->LastChip = Chip ;
		}
		else
		{
			// Sꍇ͒e
			if( Chip1->Length == Length )
				goto R_END ;

			if( LengthInfo->MaxNum == LengthInfo->Num )
			{
				Chip = LengthInfo->LastChip ;
				Chip->Back->Next = NULL ;
				LengthInfo->LastChip = Chip->Back ;
			}
			else
			{
				Chip = &LengthInfo->Chip[ LengthInfo->Num ] ;
				LengthInfo->Num ++ ;
			}

			Chip->Back = Chip2 ;
			if( Chip1 == Chip )
			{
				Chip->Next = NULL ;
				LengthInfo->LastChip = Chip ;
			}
			else
			{
				Chip->Next = Chip1 ;
				Chip1->Back = Chip ;
			}
			Chip2->Next = Chip ;
		}

		Chip->Length = Length ;
		Chip->JObj = LengthInfo->JObj ;
		Chip->Number = LengthInfo->PointCounter ;
	}

R_END :
	
	LengthInfo->PointCounter ++ ;
		
	return 0 ;
}
	
// w̍Wɋ߂_bVƒ_ԍ֐
extern s8 CreateLengthList( WK7JObj *JObj, Vec Point, LENGTHLIST *ListBuf, u8 Num )
{
	LENGTHLISTCHIP *Chip ;
	
	// ṽf[^
	memset( ListBuf, 0, sizeof( LENGTHLIST ) ) ;
	ListBuf->Num = 1 ;
	ListBuf->MaxNum = Num + 1 ;
	ListBuf->Point = Point ;
	ListBuf->LastChip = &ListBuf->Chip[0] ;
	Chip = &ListBuf->Chip[0] ;
	Chip->Length = -1000.0F ;
	Chip->JObj = NULL ;
	Chip->Number = 0 ;
	Chip->Next = Chip->Back = NULL ;

	// bVׂĂ JObj 񋓂
	ScanPrimitiveJObj( JObj, LengthScanCallBack, ListBuf ) ;
	
	// I
	return 0 ;
}

// ȈՒ_f[^\̂璸_|C^Xgf[^쐬
extern s8 CreatePosIndexPointList( BASICMESH *BasM, POSINDEXPOINTLIST *PIPList, u8 UseBigMem )
{
	// |S̐擾
	PIPList->PolyPointNum = ScanMeshPrimitive( BasM, NULL, NULL ) * 3 ;
	
	// Xgi[郁mۂ
	PIPList->PolyPoint = (Vec **)ALLOC( (s32)( sizeof( Vec * ) * PIPList->PolyPointNum ), "Y_PList", UseBigMem ) ;
	if( PIPList->PolyPoint == NULL )
		return -1 ;
	
	// XgɃf[^i[
	ScanMeshPrimitive( BasM, NULL, NULL, PIPList );
	
	// gpĂ郁̈̏ۑ
	PIPList->UseBigMem = UseBigMem ;

	// I
	return 0 ;
}

// _|C^Xgf[^̌n
extern s8 DeletePosIndexPointList( POSINDEXPOINTLIST *PIPList )
{
	// 
	if( PIPList->PolyPoint != NULL )
	{
		FREE( PIPList->PolyPoint, PIPList->UseBigMem ) ;
		PIPList->PolyPoint = NULL ;
	}

	// I
	return 0 ;
}

// bVǗ
extern s32 MeshManageInit( void )
{
	memset( &mm, 0, sizeof( mm ) ) ;
	
	return 0 ;
}

// bVǗ̌n
extern s32 MeshManageTerm( void )
{
	return 0 ;
}


// dobj 烁bVf[^쐬
extern s32 CreateMeshData( WK7JObj *JObj, HSD_DObj *dobj, HSD_PObj *pobj )
{
	s32 ID ;
	MESHINFO *Info ;
	
	//  pobj ɉ͂ĂȂׂ
	for( ID = 0, Info = mm.MeshInfo ;
		ID < MAX_MESHINFONUM &&
		( Info->UseCounter == 0 || ( Info->UseCounter != 0 && Info->dobj != dobj && Info->pobj != pobj ) ) ;
		Info ++, ID ++ ){}

	// Vɍ쐬
	if( ID == MAX_MESHINFONUM )
	{
		// gĂȂf[^T
		for( ID = 0, Info = mm.MeshInfo ;
			ID < MAX_MESHINFONUM && Info->UseCounter != 0 ;
			Info ++, ID ++ ){}

		// 󂫂G[
		if( ID == MAX_MESHINFONUM ) return -1 ;
			
		// bVf[^
		if( CreatePrimitiveMeshData( JObj->GetJObj(), dobj, pobj, &Info->Mesh,
										TRUE,		// Norm
										TRUE,		// Pos
										FALSE,		// Color
										FALSE,		// Uv
										FALSE,		// BigMem
										FALSE,		// DNext
										FALSE		// PNext
										 ) != 0 )
		{
			// ͂ɎsG[
			return -1 ;
		}
		
		// Zbg
		Info->UseCounter = 1;
		Info->dobj = dobj ;
		Info->pobj = pobj ;
	}
	else
	{
		// QƃJE^CNg
		Info->UseCounter ++ ;
	}

	// hcԂ
	return ID ;
}

// dobj 쐬bVf[^
extern s32 ReleaseMeshData( s32 MeshID )
{
	MESHINFO *Info ;
	
	Info = &mm.MeshInfo[MeshID] ;
	
	// QƃJE^fNg
	Info->UseCounter -- ;
	
	// QƐ}CiXɂȂĂG[
	if( Info->UseCounter < 0 )
	{
		Info->UseCounter = 0 ;
		return -1 ;
	}
	
	// QƐOɂȂf[^
	if( Info->UseCounter == 0 )
	{
		DeletePrimitiveMeshData( Info->Mesh ) ;
		
		// f[^𖢎gpԂɂ
		Info->Mesh = NULL ;
		Info->UseCounter = 0 ;
		Info->dobj = NULL ;
	}

	// I
	return 0 ;
}

// dobj ̃bVf[^擾
extern MESHINFO *GetMeshData( s32 MeshID )
{
	return &mm.MeshInfo[MeshID] ;
}


// w̍WɈԋ߂_̏擾
extern s8 CreateVertexHomingData( VERTEXHOMING *HomingBuf, WK7JObj *JObj, Vec Pos )
{
	LENGTHLIST LengthInfo ;
	LENGTHLISTCHIP *info ;
	HSD_PObj *pobj ;
	HSD_DObj *dobj ;
	
	// f̎w̍WɈԋ߂߂P_擾
	CreateLengthList( JObj, Pos, &LengthInfo, 1 ) ;

	// 擾񂩂Xɍׂ𓾂
	{
		// ]̔ԍbVf[^̃AhX𓾂
		if( LengthInfo.Num == 1 ) return -1 ;
		
		info = LengthInfo.Chip[0].Next ;
		if( GetHaveHopeNumberVertexPObj( info->JObj->GetJObj(), (u32)info->Number, &HomingBuf->VertexNumber, &pobj, &dobj ) < 0 ) return -1 ;

		// bVf[^쐬
		{
			if( ( HomingBuf->MeshID = CreateMeshData( info->JObj, dobj, pobj ) ) < 0 ) return -1 ;
			HomingBuf->Mesh = GetMeshData( HomingBuf->MeshID )->Mesh ;
		}
	}
	
	// I
	return 0 ;
}

// w̍WɈԋ߂_̏
extern s8 ReleaseVertexHomingData( VERTEXHOMING *HomingBuf )
{
	// bVf[^
	if( HomingBuf->Mesh != NULL )
	{
		ReleaseMeshData( HomingBuf->MeshID ) ;
		HomingBuf->MeshID = -1 ;
		HomingBuf->Mesh = NULL ;
	}

	// I
	return 0 ;
}

// _ǔ񂩂w̒_̐΍WƂ̓_̖@𓾂
extern s8 GetVertexHomingInfo( VERTEXHOMING *HomingBuf, Vec *PosBuf, Vec *NrmBuf )
{
	GetHopeNumberVertexPositionAndNormal( HomingBuf->Mesh, HomingBuf->VertexNumber, PosBuf, NrmBuf ) ;
	return 0 ;
}


	
	
	
