///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBillboard
//
// YK7EffectBillboard.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/01/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTBILLBOARD_H
#define __YK7EFFECTBILLBOARD_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "../Wat/WK7Model.h"

// define ---------------------------------------

#define BILL_BACKPOINTNUM			5

// r{[hGtFNghcXg
enum
{
	BILLEFF_SPRINKLER = 0,						// XvN[
	BILLEFF_SPFIRE = 1,							// ΂̕
	BILLEFF_SPFIRE2 = 2,						// ΂̕Q(fJC)
	BILLEFF_BLOODRAIN = 3,						// ̉J
	BILLEFF_MISSSHOT = 4,						// ~XVbg
	BILLEFF_TUBA = 5,							// 
	BILLEFF_POPCORN = 6,						// |bvR[
	BILLEFF_STEAM = 7,							// C(R[q[p)
	BILLEFF_BALLOON = 8,						// D
	BILLEFF_SMOKE = 9,							// 
	BILLEFF_SPARK = 10,							// Ή
	BILLEFF_STEAM2 = 11,						// C(p)
	BILLEFF_NUM = 12,							// GtFNg̐
} ;

// r{[hhcXg
enum
{
	BILLID_WATER = 0,							// 
	BILLID_SPFIRE = 1,							// ΂̕
	BILLID_LINE = 2,							// p
	BILLID_3DLINE = 3,							// RcCp
	BILLID_TUBA = 4,							// Ηp
	BILLID_POPCORN = 5,							// |bvR[p
	BILLID_STEAM = 6,							// C
	BILLID_BALLOON = 7,							// D
	BILLID_LIGHT = 8,							// 
	BILLID_SPFIRE2 = 9,							// ΂̕Q
	BILLID_KIRAKIRA = 10,						// LL
	BILLID_NUM = 11,							// hc̐
} ;


// datatype -------------------------------------

// r{[hf[^\
typedef struct tagBILLBOARDIMAGE
{
	u8 UseFlag ;					// gptO
	u8 SetupCompFlag ;				// ZbgAbvtO
	u8 FileFlag ;					// t@Cǂݍ񂾂tO
	GhmGcTexHeader *Tex ;			// ǂݍ񂾃eNX`̐擪AhX
	ghmGcFile *File ;				// t@CǂݍݎɎgNX
	GXTexObj TexObj ;				// r{[heNX`̃eNX`IuWFNg
} BILLBOARDIMAGE ;

// r{[hGtFNgʃf[^
typedef struct tagBILLBOARDUNION
{
	BILLBOARDIMAGE Image[BILLID_NUM] ;			// r{[hC[Wf[^
	s8 EffectState[BILLEFF_NUM] ;				// r{[hGtFNg̃ZbgAbv̏( 2:  1:ǂݍݒ  0:ĂȂ )
	s8 NotDrawFlag ;
} BILLBOARDUNION ;

// r{[hGtFNgIuWFNgf[^
typedef struct tagBILLBOARDEFFECTOBJECT
{
	s8 UseFlag ;							// gptO
	Vec Point ;								// W
	Vec BackPoint[BILL_BACKPOINTNUM] ;		// W̃O
	Vec Speed ;								// Xs[h
	Vec SSpeed ;							// x
	f32 Air ;								// CRɂPt[ӂ̌
	f32 Size ;								// r{[h̃TCY
	u8 u, v ;								// eNX`̂tuW
	f32 Alpha, FadeOutSpeed, FadeInSpeed ;	// At@̍őlƃtF[hAEgXs[h
	f32 a ;									// ݂̃At@l
	u16 TimeCon, DrawTime ;					// \ԂƃJE^
} BILLBOARDEFFECTOBJECT ;

// r{[hGtFNgf[^
typedef struct tagBILLBOARDEFFECT
{
	BILLBOARDEFFECTOBJECT *ObjP ;	// IuWFNgXgւ̃|C^
	u32 ObjNum ;					// IuWFNg̐
	u32 MaxObjectNum ;				// ő[\IuWFNg

	WK7JObj *PosJObj ;				// p[eBN̍쐬ʒu WK7JObj ւ̃|C^

	s8 BillImageID ;				// gpr{[hC[Ŵhc
	u8 AddBlendFlag ;				// ZuhtO

	Vec Point ;						// GtFNg쐬钆SW
	f32 MaxSize, MinSize ;			// r{[h̃TCY
	f32 MaxSpeed, MinSpeed ;		// Xs[h
	Vec Direction ;					// 
	f32 DirectionRange ;			// ̂Ԃ( PI = }180 )
	f32 OirRot, XZRot ;				// IC[pxƂwy]pxɕϊ
	u8 NonDirectionFlag ;			// ȂtO 
	u8 OutSideFlag ;				// Ô݃tO( ȂtO FALSE ̎̂ݗL )
	Vec SSpeed ;					// x
	f32 Air ;						// CRl
	f32 MaxFadeOutSpeed, MinFadeOutSpeed ;// tF[hAEg̑x
	f32 MaxFadeInSpeed, MinFadeInSpeed ;// tF[hAEg̑x
	u16 MaxDrawTime, MinDrawTime ;	// \
	f32 YukaY ;						// ̍
	f32 CreateNumRate ;				// VɃIuWFNg쐬闦
	u8 YukaYValidFlag ;				// YukaY ̒lLǂ̃tO
	GXColor Color ;					// F

	s8 FastDeleteFlag ;				// 폜]tO
	s8 DrawFlag ;					// `tO
	s8 CreateFlag ;					// VɃIuWFNg쐬邩tO
	f32 SpeedRate ;					// ˏXs[hɑ΂oCAX
	f32 CreateRate ;				// IuWFNg̍쐬[gɑ΂oCAX
	f32 CreateCounter ;				// IuWFNg쐬JE^[
	f32 SizeRate ;					// 쐬IuWFNg̃TCY[g

	s8 (*BillObjMoveCallBack)( BILLBOARDEFFECTOBJECT *Obj, struct tagBILLBOARDEFFECT *BillEf, void * ) ;		// IuWFNgɎgpR[obN֐
	void *Data ;					// R[obNɓn

	s32 SoundID ;					// ʉhc
	u8 TenjouModeFlag ;				// YukaY V̍ƂĈǂ̃tO
} BILLBOARDEFFECT ;

// r{[hGtFNgf[^p\
typedef struct tagBILLBOARDEFFECTTASKPARAM
{
	s8 BillImageID ;				// gpr{[hC[Ŵhc
	u8 AddBlendFlag ;				// ZuhtO

	Vec Point ;						// GtFNg쐬钆SW
	f32 MaxSize, MinSize ;			// r{[h̃TCY
	f32 MaxSpeed, MinSpeed ;		// Xs[h
	Vec Direction ;					// 
	f32 DirectionRange ;			// ̂Ԃ( PI = }180 )
	u8 NonDirectionFlag ;			// ȂtO( 0:Ȃ  1:  2:Ӗ )
	u8 OutSideFlag ;				// Ô݃tO
	Vec SSPeed ;					// x
	f32 Air ;						// CRl
	f32 MaxFadeSpeed, MinFadeSpeed ;// tF[hAEg̑x
	u16 MaxDrawTime, MinDrawTime ;	// \
	f32 YukaY ;						// ̍
	f32 CreateNumRate ;				// VɃIuWFNg쐬闦
	u32 MaxObjectNum ;				// IuWFNg̍ő吔
	GXColor *Color ;				// F
	u8 TenjouModeFlag ;				// YukaY V̍ƂĈǂ̃tO
} BILLBOARDEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitBillboardData( void ) ;			// r{[hGtFNg̋ʃf[^
extern s8 CheckBillboardData( void ) ;			// r{[hGtFNg̏풓f[^̓ǂݍ݊𒲂ׂ( TRUE: FALSE:܂ )
extern s8 EndBillboardData( void ) ;			// r{[hGtFNg̋ʃf[^n

extern EFFECT *CreateBillboardEffect2( s8 EffectID, Vec Point, f32 YukaY = 0.0F,
										u32 MaxObjectNum = 0xffffffff, GXColor *Color = NULL, s32 Priority = -130 ) ;	// r{[hGtFNg쐬
extern EFFECT *CreateBillboardEffect( s8 BillImageID, u8 AddBlendFlag, Vec Point,
										f32 MaxSize, f32 MinSize,
										f32 MaxSpeed, f32 MinSpeed,
										Vec Direction, f32 DirectionRange,
										u8 NonDirectionFlag, u8 OutSideFlag,
										Vec SSpeed, f32 Air,
										f32 MaxFadeOutSpeed, f32 MinFadeSpeed,
										f32 MaxFadeInSpeed, f32 MinFadeInSpeed,
										u16 MaxDrawTime, u16 MinDrawTime,
										f32 YukaY, f32 CreateNumRate,
										u32 MaxObjectNum = 1000, u8 YukaYValidFlag = TRUE,
										GXColor *Color = NULL, s32 SoundID = -1,
										u8 TenjouModeFlag = FALSE, s32 Priority = -130 ) ;	// r{[hGtFNg쐬
extern s8 ReleaseBillboardEffect( EFFECT *Effect ) ;						// r{[hGtFNǧns
extern s8 MoveBillboardEffect( EFFECT *Effect ) ;							// r{[hGtFNgPt[
extern s8 DrawBillboardEffect( EFFECT *Effect ) ;							// r{[hGtFNg`悷

extern s8 FastDelReqBillboardEffect( EFFECT *Effect ) ;								// 폜NGXgs
extern s8 SetBillboardPosJObj( EFFECT *Effect, WK7JObj *PosJObj ) ;					// IuWFNg쐬ʒu WK7JObj ւ̃|C^Zbg
extern s8 SetBillboardPoint( EFFECT *Effect, Vec Point ) ;							// r{[h̍WύX
extern s8 SetBillboardDrawFlag( EFFECT *Effect, s8 DrawFlag ) ;						// `tOZbg( TRUE:`  FALSE:` )
extern s8 SetBillboardCreateFlag( EFFECT *Effect, s8 CreateFlag ) ;					// IuWFNg쐬tOZbg( TRUE:쐬  FALSE:쐬Ȃ )
extern s8 SetBillboardSpeedRate( EFFECT *Effect, f32 SpeedRate ) ;					// Xs[hɏZlZbg
extern s8 SetBillboardCreateRate( EFFECT *Effect, f32 CreateRate ) ;				// IuWFNg̍쐬pxύX
extern s8 SetBillboardSizeRate( EFFECT *Effect, f32 SizeRate ) ;					// IuWFNg̃TCYɃoCAX
extern s8 SetBillboardDirection( EFFECT *Effect, Vec Direction ) ;					// IuWFNg𐶐ύX
extern s8 AddBillboardEffectObject( EFFECT *Effect, Vec Point, Vec *Dir = NULL ) ;	// Ăr{[hGtFNgɑ΂ăIuWFNgǉ
extern s8 ClearBillboardEffectObject( EFFECT *Effect ) ;							// Ăr{[hGtFNgׂč폜
extern s32 GetBillboardEffectObjectNum( EFFECT *Effect ) ;							// Ăr{[hGtFNg̐擾
extern s8 SetBillboardEffectMoveCallBackFunction( EFFECT *Effect, s8 (*Function)( BILLBOARDEFFECTOBJECT *, BILLBOARDEFFECT *, void * ), void *Data ) ;	// IuWFNgɎgpR[obN֐o^

extern s8 LoadBillboardImage( s8 BillID ) ;									// r{[hf[^[h
extern s8 SetupBillboardImage( s8 BillID, void *BillData ) ;				// r{[hf[^(bin)Zbg(Rs[͂܂̂ ReleaseBillboardData ܂œnf[^͉Ȃł)
extern s8 ReleaseBillboardImage( s8 BillID ) ;								// r{[hf[^
extern s8 CheckBillboardImageLoadState( s8 BillID ) ;						// r{[hf[^ǂݍ܂Ă邩ǂ`FbN( TRUE:ǂݍ܂Ă   FALSE:ǂݍ܂ĂȂ )
extern BILLBOARDIMAGE *GetBillboardImage( s8 BillID ) ;						// r{[hf[^̃AhX擾

extern s8 SetupBillboardEffectID( s8 BillEffID ) ;							// w̃r{[hGtFNg̃ZbgAbvs
extern s8 ReleaseBillboardEffectID( s8 BillEffID ) ;						// w̃r{[hGtFNǧns
extern s8 CheckBillboardEffectIDState( s8 BillEffID ) ;						// w̃r{[hGtFNg̃ZbgAbvĂ邩擾( TRUE:Ă   FALSE: )

extern s8 SetBillboardAllDrawFlag( s8 Flag ) ;								// r{[hGtFNg`悷邩ǂ̃tOZbg
#endif
