///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectBlur
//
// YK7EffectBlur.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectBlur.h"

// define ---------------------------------------

// data -----------------------------------------

BLURUNION blru ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// u[GtFNg̋ʃf[^
extern s8 InitBlurData( void )
{
	MEMINIT( blru ) ;

	blru.MaxNum = VParam[ED_BLUR][6] ;
	blru.AlphaSpeed = VParam[ED_BLUR][5] * 0.01F ;
	blru.Time = (u8)VParam[ED_BLUR][4] ;
	
	return 0 ;
}

// u[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckBlurData( void )
{
	return TRUE ;
}

// u[GtFNg̋ʃf[^n
extern s8 EndBlurData( void )
{
	MEMINIT( blru ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// u[GtFNg쐬
extern EFFECT *CreateBlurEffect(
									WK7JObj *TopJObj, WK7JObj *BotJObj,		// OՕ`Ɏgp JObj
									GXColor topcolor, GXColor botcolor,		// F
									s32 Priority )				// u[GtFNg쐬
{
	EFFECT *Effect ;
	BLUREFFECT *bl ;
	BLUROBJECT *ob ;
	u16 MaxNum ;
	
	// IuWFNgi[郁̈mۂ
	MaxNum = blru.MaxNum ;
	blru.MaxNum = VParam[ED_BLUR][6] ;
	ob = ( BLUROBJECT * )K7AppSmallMemAllocName( (int)( sizeof( BLUROBJECT ) * MaxNum ), "BlObj" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( BLUROBJECT ) * MaxNum ) ;
	
	// Vu[f[^쐬
	Effect = AddEffectData( EFF_BLUR, (void**)&bl, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}

	// ̏
	HSD_JObjSetupMatrix( TopJObj->GetJObj() ) ;
	HSD_JObjSetupMatrix( BotJObj->GetJObj() ) ;
	bl->BTopPos.x = TopJObj->GetJObj()->mtx[0][3] ;	bl->BTopPos.y = TopJObj->GetJObj()->mtx[1][3] ;	bl->BTopPos.z = TopJObj->GetJObj()->mtx[2][3] ;
	bl->BBotPos.x = BotJObj->GetJObj()->mtx[0][3] ;	bl->BBotPos.y = BotJObj->GetJObj()->mtx[1][3] ;	bl->BBotPos.z = BotJObj->GetJObj()->mtx[2][3] ;
	bl->Obj = ob ;	
	bl->MaxNum = MaxNum ;
	bl->ObjNum = 0 ;
	
	bl->TopJObj = TopJObj ;
	bl->BotJObj = BotJObj ;
	
	bl->topcolor = *((u32 *)&topcolor) ;
	bl->botcolor = *((u32 *)&botcolor) ;
	
	bl->createflag = true ;

	bl->AlphaSpeed = blru.AlphaSpeed ;	
	blru.AlphaSpeed = VParam[ED_BLUR][5] * 0.01F ;

	bl->Time = blru.Time ;
	blru.Time = (u8)VParam[ED_BLUR][4] ;

	// I
	return Effect ;
}

// u[GtFNǧns
extern s8 ReleaseBlurEffect( EFFECT *Effect )
{
	BLUREFFECT *bl = ( BLUREFFECT * )Effect->Data ;

	CHKMEMFREE2( bl->Obj ) ;

	// I
	return 0 ;
}

// u[GtFNgPt[
extern s8 MoveBlurEffect( EFFECT *Effect )
{
	BLUREFFECT *bl = ( BLUREFFECT * )Effect->Data ;
	BLUROBJECT *ob ;
	s32 i, j, num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE && bl->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// IuWFNg̍쐬
	if( bl->ObjNum < bl->MaxNum && Effect->DelReqFlag == FALSE && bl->createflag == true )
	{
		Vec NTopPos, NBotPos ;
	
		HSD_JObjSetupMatrix( bl->TopJObj->GetJObj() ) ;
		HSD_JObjSetupMatrix( bl->BotJObj->GetJObj() ) ;
		NTopPos.x = bl->TopJObj->GetJObj()->mtx[0][3] ;	NTopPos.y = bl->TopJObj->GetJObj()->mtx[1][3] ;	NTopPos.z = bl->TopJObj->GetJObj()->mtx[2][3] ;
		NBotPos.x = bl->BotJObj->GetJObj()->mtx[0][3] ;	NBotPos.y = bl->BotJObj->GetJObj()->mtx[1][3] ;	NBotPos.z = bl->BotJObj->GetJObj()->mtx[2][3] ;

		for( i = 0, ob = bl->Obj ; ob->vflag == true ; i ++, ob ++ ){}
		ob->vflag = true ;
		ob->p[0] = NTopPos ;
		ob->p[1] = NBotPos ;
/*		ob->p[0] = bl->BTopPos ;
		ob->p[1] = NTopPos ;
		ob->p[2] = NBotPos ;
		ob->p[3] = bl->BBotPos ;
*/
#ifndef DEBUG_MODE
		ob->alpha = bl->AlphaSpeed * bl->Time + 1.0F ;
#else
		ob->alpha = ( (f32)VParam[ED_BLUR][5] * 0.01F ) * VParam[ED_BLUR][4] + 1.0F ;
#endif
		
		bl->BTopPos = NTopPos ;
		bl->BBotPos = NBotPos ;
		
		bl->ObjNum ++ ;
		
		// Xgɒǉ
		if( bl->ObjNum == 1 )
		{
			bl->last = bl->first = i ;
			ob->next = -1 ;
			ob->back = -1 ;
		}
		else
		{
			bl->Obj[bl->last].next = i ;
			ob->back = bl->last ;
			ob->next = -1 ;
			bl->last = i ;
		}
	}

	// IuWFNg̏	
	num = bl->ObjNum ;
	ob = bl->Obj ;
	j = 0 ;
	for( i = 0 ; i < num ; j ++, ob ++ )
	{
		if( ob->vflag == false ) continue ;

		i ++ ;
		
#ifndef DEBUG_MODE
		ob->alpha -= bl->AlphaSpeed ;
#else
		ob->alpha -= ( (f32)VParam[ED_BLUR][5] * 0.01F ) ;
#endif
		if( ob->alpha <= 0.0F )
		{
			ob->vflag = false ;
			bl->ObjNum -- ;

			if( bl->first == j ) bl->first = ob->next ;
			if( ob->back != -1 ) bl->Obj[ob->back].next = ob->next ;
			if( ob->next != -1 ) bl->Obj[ob->next].back = ob->back ;
			if( bl->ObjNum == 0 )
			{
				bl->last = bl->first = -1 ;
			}
		}
	}

	// I
	return 0 ;
}

// u[GtFNg`悷
extern s8 DrawBlurEffect( EFFECT *Effect )
{
	BLUREFFECT *bl = ( BLUREFFECT * )Effect->Data ;
	BLUROBJECT *ob ;
//	s32 i, num ;
	u32 topcolor, botcolor ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;

	// `Jn
	if( bl->ObjNum < 2 ) return 0 ;

	GBGN( GX_TRIANGLESTRIP, bl->ObjNum * 2 ) ;
//	num = bl->ObjNum ;
	ob = &bl->Obj[bl->first] ;
//	for( i = 0 ; i < num ; ob ++ )
	for( ;; )
	{
//		if( ob->vflag == false ) continue ;
		
//		i ++ ;

#ifndef DEBUG_MODE
	topcolor = CMKC2( bl->topcolor, (f32)( bl->topcolor & 0xff ) * ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) ) ;
	botcolor = CMKC2( bl->botcolor, (f32)( bl->botcolor & 0xff ) * ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) ) ;
#else
	u32 tc, bc ;
	
	tc = CMK( VParam[ED_BLUR][0], VParam[ED_BLUR][1], VParam[ED_BLUR][2], VParam[ED_BLUR][3] ) ; 
	bc = CMK( VParam[ED_BLUR][7], VParam[ED_BLUR][8], VParam[ED_BLUR][9], VParam[ED_BLUR][10] ) ; 
	topcolor = CMKC2( tc, (f32)( tc & 0xff ) * ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) ) ;
	botcolor = CMKC2( bc, (f32)( bc & 0xff ) * ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) ) ;
#endif
		
		GPV( ob->p[1] ) ;		GCX( botcolor ) ;
		GPV( ob->p[0] ) ;		GCX( topcolor ) ;
//		GPV( ob->p[2] ) ;		GCX( botcolor ) ;
//		GPV( ob->p[3] ) ;		GCX( botcolor ) ;
		
		if( ob->next == -1 ) break ;
		ob = &bl->Obj[ob->next] ;
	}
	GEND() ;

	// I
	return 0 ;
}

// u[GtFNg쐬
extern EFFECT *CreateBlurEffect(
									WK7JObj *JObj,							// FXBlur_Top  FXBlur_Bot Ƃ̃P[^݂ JObj ւ̃|C^
									GXColor topcolor, GXColor botcolor,		// F
									s32 Priority )
{
	WK7JObj *top, *bot ;
	
	top = JObj->GetObj( "FXBlur_Top" ) ;
	bot = JObj->GetObj( "FXBlur_Bot" ) ;
	if( top == NULL || bot == NULL ) return NULL ;
	
	return CreateBlurEffect( top, bot, topcolor, botcolor, Priority ) ;
}

// u[GtFNg쐬邩ǂ̃tO
extern s8 SetBlurCreateFlag( EFFECT *Effect, bool CreateFlag )
{
	BLUREFFECT *bl = ( BLUREFFECT * )Effect->Data ;
	
	bl->createflag = CreateFlag ;
	
	// I
	return 0 ;
}
