///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCentLight
//
// YK7EffectCentLight.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/16/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectCentLight.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

static CENTLIGHTUNION CLU ;
extern LINEUNION LUnion ;


// function proto type --------------------------

// function code --------------------------------

// WGtFNg̋ʃf[^
extern s8 InitCentLightData( void )
{
	MEMINIT(CLU) ;

	// I
	return 0 ;
}

// WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCentLightData( void )
{
	return TRUE ;
}


// WGtFNg̋ʃf[^n
extern s8 EndCentLightData( void )
{
	MEMINIT(CLU) ;

	// I
	return 0 ;
}




// WGtFNg쐬
extern EFFECT *CreateCentLightEffect(
						Vec Pos,							// \W
						f32 MaxSpeed, f32 MinSpeed,			// ő呬xAŏx
						f32 MaxR, f32 MinR,					// ő唼aAŏa
						f32 MaxLength, f32 MinLength,		// ő咷Aŏ
						f32 MaxWait, f32 MinWait,			// S܂ł̋̍őlAŏl
						f32 MaxWaitSpeed, f32 MinWaitSpeed,	// S܂ł̋k߂ő呬xAŏx
						f32 LineWidth,						// ̑
						f32 CreateCost,						// 쐬RXg
						s32 MaxObjNum,						// IuWFNg̍ő吔
						u32 Color,							// F
						u8 Pos2DFlag,						// QcWwtO
						s32 Priority )
{
	EFFECT *Effect ;
	CENTLIGHTEFFECT *cl ;
	CENTLIGHTOBJECT *ob ;
	u32 i ;

	// eNX`ǂݍ܂ĂȂ牽I
	if( CheckLineData() == FALSE ) return 0 ;

	// IuWFNgۑ邽߂̃̈̊m
	if( ( ob = ( CENTLIGHTOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( CENTLIGHTOBJECT ) * MaxObjNum ), "Y_ClObj" ) ) == NULL ) return NULL ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_CENTLIGHT, (void**)&cl, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}

	// p[^ۑE
	cl->JObj		= CLU.JObj ;
	CLU.JObj		= NULL ;
	
	cl->Obj			= ob ;
	cl->ObjNum 		= 0 ;
	cl->MaxObjNum 	= MaxObjNum ;

	cl->Color 		= Color ;
	cl->Pos2DFlag 	= Pos2DFlag ;
	cl->LineWidth 	= LineWidth ;

	cl->MaxSpeed 		= MaxSpeed ;		cl->MinSpeed	 	= MinSpeed ;
	cl->MaxR 			= MaxR ;			cl->MinR 			= MinR ;
	cl->MaxLength 		= MaxLength ;		cl->MinLength 		= MinLength ;
	cl->MaxWait 		= MaxWait ;			cl->MinWait 		= MinWait ;
	cl->MaxWaitSpeed 	= MaxWaitSpeed ;	cl->MinWaitSpeed 	= MinWaitSpeed ;

	cl->CreateCost 	= CreateCost ;
	cl->CreateCounter = 0 ;
	cl->Pos 		= Pos ;

	// IuWFNg̏	
	for( i = 0 ; i < MaxObjNum ; i ++, ob ++ ) ob->vflag = 0 ;

	// I
	return Effect ;
}

// WGtFNǧns
extern s8 ReleaseCentLightEffect( EFFECT *Effect )
{
	CENTLIGHTEFFECT *cl = ( CENTLIGHTEFFECT * )Effect->Data ;

	// CIuWFNgi[pɊmۂĂ̈̊J
	if( cl->Obj != NULL ) CHKMEMFREE2( cl->Obj ) ;
	cl->Obj = NULL ;

	// I
	return 0 ;
}

// WGtFNgPt[
extern s8 MoveCentLightEffect( EFFECT *Effect )
{
	CENTLIGHTEFFECT *cl = ( CENTLIGHTEFFECT * )Effect->Data ;
	CENTLIGHTOBJECT *ob ;
	u32 i, num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && cl->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴCIuWFNg
	ob = cl->Obj ;
	num = (u32)cl->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;

		i ++ ;

		ob->wait -= ob->waitspeed ;

		ob->rotp += ob->speed ;
		if( ob->rotp > PI / 2.0F )
		{
			ob->vflag = 0 ;
			cl->ObjNum -- ;
		}
	}
	
	// 쐬
	if( Effect->DelReqFlag == FALSE )
	{
		cl->CreateCounter += 1.0F ;
		while( cl->CreateCounter >= cl->CreateCost && cl->ObjNum < cl->MaxObjNum )
		{
			cl->CreateCounter -= cl->CreateCost ;
			
			for( ob = cl->Obj ; ob->vflag == 1 ; ob ++ ){}

			ob->vflag 		= 1 ;
			ob->r 			= GetRandF2Num( cl->MaxR,		cl->MinR ) ;
			ob->speed 		= GetRandF2Num( cl->MaxSpeed,	cl->MinSpeed ) ;
			ob->len 		= GetRandF2Num( cl->MaxLength,	cl->MinLength ) ;
			ob->rotp		= -ob->len ;
			ob->rot			= GetRandF2Num( PI_2, 			0.0F ) ;
			ob->waitspeed	= GetRandF2Num( cl->MaxWaitSpeed, cl->MinWaitSpeed ) ;
			ob->wait		= ( ( PI / 2.0F - ob->rotp ) / ob->speed ) * ob->waitspeed + GetRandF2Num( cl->MaxWait, cl->MinWait ) ;

			cl->ObjNum ++ ;
		}
	}

	// I
	return 0 ;
}

// WGtFNg`悷
extern s8 DrawCentLightEffect( EFFECT *Effect )
{
	CENTLIGHTEFFECT *cl = ( CENTLIGHTEFFECT * )Effect->Data ;
	CENTLIGHTOBJECT *ob ;
	u32 i, num ;
	f32 rate ;
//	Mtx tmtx ;
	Vec DPos ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( /*cl->Pos2DFlag ?*/ EF_PROJECT_PERS /*: EF_PROJECT_PERS*/, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;							// `̏

	// eNX`̃[h
	GTLOAD2( LUnion.TestTex ) ;

	// C̑Zbg
	if( cl->Pos2DFlag )
	{
		GXSetLineWidth( (u8)( cl->LineWidth * 6.0F ), GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
		
		DPos = cl->Pos ;
		rate = 1.0F ;
	}
	else
	{
		f32 Width ;
		s32 Width2 ;
		Vec p ;

		if( cl->JObj != NULL )
		{
			HSD_JObjSetupMatrix( cl->JObj->GetJObj() ) ;
			p.x = cl->JObj->GetJObj()->mtx[0][3] ;
			p.y = cl->JObj->GetJObj()->mtx[1][3] ;
			p.z = cl->JObj->GetJObj()->mtx[2][3] ;
		}
		else
		{
			p = cl->Pos ;
		}
		
		// oCAXlZo
		Width = GetScreenSize( &p, ( cl->LineWidth * 6.0F ) * 0.005F ) ;

		Width2 = (s32)Width ;
		if( Width2 < 4 ) Width2 = 4 ;
		if( Width2 > 255 ) Width2 = 255 ;

		GXSetLineWidth( (u8)Width2, GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
		
		GetScreenPosition( &p, &DPos ) ;
		rate = GetScreenSize( &p, 0.01F ) ;
	}

	EffectProjectSetup( EF_PROJECT_ORTHO ) ;							// `̏

	// ]ns̍쐬
//	EffectGetInvViewMatrix( tmtx ) ;

	// `揈	
	GBGN( GX_LINES, cl->ObjNum * 2 ) ;
	
	// IuWFNg̐JԂ
	ob = cl->Obj ;
	num = (u32)cl->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;
		
		i ++ ;
		
//		if( cl->Pos2DFlag )
		{
			f32 p1, p2 ;
			
			p1 = ob->rotp ;
			if( p1 < 0.0F ) 		p1 = 0.0F ;
			if( p1 > PI / 2.0F ) 	p1 = PI / 2.0F ;

			p2 = ob->rotp + ob->len ;
			if( p2 < 0.0F ) 		p2 = 0.0F ;
			if( p2 > PI / 2.0F ) 	p2 = PI / 2.0F ;

			p1 = COSF( p1 ) ;
			p2 = COSF( p2 ) ;

			GP2( COSF( ob->rot ) * ( ob->r * p1 + ob->wait ) * rate + DPos.x, SINF( ob->rot ) * ( ob->r * p1 + ob->wait ) * rate + DPos.y ) ;	GCX( cl->Color ) ;		GT( 0.0F, 0.0F ) ;
			GP2( COSF( ob->rot ) * ( ob->r * p2 + ob->wait ) * rate + DPos.x, SINF( ob->rot ) * ( ob->r * p2 + ob->wait ) * rate + DPos.y ) ;	GCX( cl->Color ) ;		GT( 0.0F, 1.0F ) ;
		}
/*		else
		{
		}
*/		
/*		if( ob->EndFlag == FALSE )
		{
			Vec V1, V2, V ;

			V.x = sinf( ob->Rot ) ;
			V.y = cosf( ob->Rot ) ;
			V.z = 0.0F ;

			// [hɂď𕪊
			if( ob->Mode == 0 )
			{
				VECScale( &V, &V1, ob->Point ) ;
				VECScale( &V, &V2, ob->Point + ob->Length * ob->LengthParam ) ;
			}
			else
			{
				VECScale( &V, &V1, ob->Point - ob->Length * ob->LengthParam ) ;
				VECScale( &V, &V2, ob->Point ) ;
			}

			MTXMultVec( tmtx, &V1, &V1 ) ;
			MTXMultVec( tmtx, &V2, &V2 ) ;

			GP3( V1.x + cl->Point.x, V1.y + cl->Point.y, V1.z + cl->Point.z ) ;
			GC4( ob->Color.r, ob->Color.g, ob->Color.b, 255 ) ;
			GT( 0, 0 ) ;

			GP3( V2.x + cl->Point.x, V2.y + cl->Point.y, V2.z + cl->Point.z ) ;
			GC4( ob->Color.r, ob->Color.g, ob->Color.b, 255 ) ;
			GT( 0, 1.0F ) ;
		}
*/
	}
	GEND() ;

	// I
	return 0 ;
}



// GtFNg̍WύX
extern s8 SetCentLightPos( Vec Pos, EFFECT *Effect )
{
	CENTLIGHTEFFECT *cl = ( CENTLIGHTEFFECT * )Effect->Data ;

	cl->Pos = Pos ;
	
	// I
	return 0 ;
}

// ɍ쐬WGtFNgWǔ JObj o^
extern s8 SetCentLightHomingJObj( WK7JObj *JObj )
{
	CLU.JObj = JObj ;
	
	// I
	return 0 ;
}

// nꂽ JObj  "MuzFlash00_V1" ToAꍇ͏ɂ̃P[^ǔ
extern s8 SetCentLightHomingJObj2( WK7JObj *JObj )
{
	CLU.JObj = JObj->GetObj( "MuzFlash00_V1" ) ;
	if( CLU.JObj == NULL ) CLU.JObj = JObj ;

	// I
	return 0 ;
}


