///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveBlood
//
// YK7EffectConveBlood.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/27/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMesh.h"
#include "./YK7EffectConveBlood.h"
#include "./YK7EffectFlower.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectBloodPack.h"
#include "../Wat/WK7GameInfo.h"
#include "../Sato/SK7SpOption.h"
#include "..\Kaw\KK7BattleMainTask.h"
#include "..\Wat\WK7Player.h"

// define ---------------------------------------

#ifdef FRAME_30
	#define MULSSY				0.02F
#else
	#define MULSSY				0.01F
#endif

#define CONVEBLOODNUM			1.0F

#ifdef FRAME_30
	#define CONVEBLOODFASTTIME			5
	#define CONVEBLOODFASTSCALE			31.0F
	#define CONVEBLOODSLOWSCALE			0.2F
	#define CONVEBLOODKAZEPOWER			0.2F
#else
	#define CONVEBLOODFASTTIME			10
	#define CONVEBLOODFASTSCALE			8.0F
	#define CONVEBLOODSLOWSCALE			0.1F
	#define CONVEBLOODKAZEPOWER			0.1F
#endif
#define CONVEBLOODKAZEKAKUDO			45.0F
#ifdef FRAME_30
	#define CONVEBLOODG					0.002F
	#define CONVEBLOODG2					0.04F
#else
	#define CONVEBLOODG					0.001F
	#define CONVEBLOODG2					0.01F
#endif
#define CONVEBLOODSIZE				( (131.711284141216F) / 300.0F )
#define CONVEBLOODSIZE2				0.2F
#define CONVEBLOODSCALE				1115.7475601F

// ̍W
static Vec BaseVert[4] = 
{
	-0.5F, 0.0F, 0.5F,
	-0.5F, 0.0F, -0.5F,
	0.5F, 0.0F, -0.5F,
	0.5F, 0.0F, 0.5F
} ;

// datatype -------------------------------------

// data -----------------------------------------

CONVEBLOODUNION CBUnion ;

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitConveBloodData( void )
{
	MEMINIT(CBUnion) ;
	
	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckConveBloodData( void ) 
{
	return TRUE ;
}

// GtFNg̋ʃf[^n
extern s8 EndConveBloodData( void )
{
	MEMINIT(CBUnion) ;

	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateConveBloodEffect( EFFECT *BloodEffect, u8 WaitTime, f32 Power, s32 Priority )
{
	EFFECT *Effect ;
	CONVEBLOODEFFECT *ConveBlood ;
	BLOODEFFECT *BloodEffectData = ( BLOODEFFECT * )BloodEffect->Data ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_CONVEBLOOD, (void**)&ConveBlood, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑ
	ConveBlood->BloodEffect = BloodEffect ;
	ConveBlood->WaitTime = WaitTime ;
	ConveBlood->SSPower = Power ;
	ConveBlood->Counter = 0 ;
	ConveBlood->SPower = 0.0F ;
	ConveBlood->Power = 0.0F ;
	ConveBlood->packmeter = GetActBloodMeter() ;
	ConveBlood->DrawNum = 0 ;
//	ConveBlood->EndNum = 0 ;
	ConveBlood->SSPower = Power * ( ConveBlood->packmeter != NULL ? 1.0F : ( BloodEffectData->BloodTexNumber == 0 ? 5.0F : 1.0F ) ) ;
	ConveBlood->FadeoutCounter = 120 ;
	ConveBlood->ObjectAlpha = 1.0F ;
	ConveBlood->TargetPosNum = 0 ;

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseConveBloodEffect( EFFECT *Effect )
{
	CONVEBLOODEFFECT *cb = ( CONVEBLOODEFFECT * )Effect->Data ;
	BLOODEFFECT *Blood = cb->BloodEffectData ;

	if( cb->Counter - cb->WaitTime < 25 )
	{
		OSReport( "YK7EffectConveBlood Hayasugi Delete  Time:%d\n", cb->Counter - cb->WaitTime ) ;
	}
	
	return 0 ;

	// ԂĂWZbg
	if( GetEffectValidState( cb->BloodEffect ) == TRUE && 
		cb->Counter >= cb->WaitTime &&
		cb->ObjNum != 0 &&
		Blood->BloodTexNumber != 0 )
	{
		BLOODOBJECT *Ob ;
		u32 i, Num ;

		// IuWFNg̈ړ
		Num = cb->ObjNum ;
		Ob = Blood->ObjP ;
		if( Ob != NULL )
		{
			for( i = 0 ; i < Num ; Ob ++ )
			{
				// gptOĂ珈
				if( Ob->UseFlag == TRUE )
				{
					i ++ ;

					// 擾W̃Zbgs				
					SetFlowerDrawObj( Blood->BloodTexNumber, Ob, Ob->FadeCount ) ;
				}
			}
		}
	}
	
	if( Blood->BloodTexNumber == BLOODTEX_FEATHER )
	{
		SK7SpOption	*pSpOption = GameInfo.GetSpOption();
		pSpOption->SetEyeAnime2() ;
	}

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveConveBloodEffect( EFFECT *Effect )
{
	CONVEBLOODEFFECT *cb = ( CONVEBLOODEFFECT * )Effect->Data ;
	BLOODEFFECT *Blood = cb->BloodEffectData ;
	u32 Num, i, j, k ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// w̎ԂɗĂ邩ǂŏ𕪊
	if( cb->Counter <= cb->WaitTime )
	{
		// K^CɗuԂɌIuWFNg擾ČIuWFNg͍폜
		if( cb->Counter == cb->WaitTime )
		{
			// GtFNgf[^̃AhX擾
			cb->BloodEffectData = ( BLOODEFFECT * )cb->BloodEffect->Data ;
			
			// ^Cv𒲐
			{
				BLOODEFFECT *OrgBlood = ( BLOODEFFECT *)cb->BloodEffect->Data ;
				BLOODOBJECT *Ob ;
			
				// BLOODEFFECT \̂̃f[^Rs[
				Blood = cb->BloodEffectData ;

				// IuWFNg̐Rs[
				cb->ObjNum = Blood->BloodNum ;

				// IuWFNg̏s
				Num = Blood->BloodNum ;
				Ob = Blood->ObjP ;
				Blood->MoveDrawBloodNum = 0 ;
				Blood->UnMoveDrawBloodNum = 0 ;
				for( j = 0, i = 0 ; i < Num ; i ++, j ++, Ob ++ )
				{
					Ob->UseFlag = TRUE ;
					Ob->EndFlag = FALSE ;
					
					// 荂ႢŃJEglύX
//					if( Ob->y > Blood->Yuka || Blood->BloodTexNumber != 0 )
					if( Ob->y > Blood->Yuka )
					{
						Ob->Type = 0 ;
						Blood->MoveDrawBloodNum ++ ;
					}
					else
					{
						Ob->Type = 1 ;
						Blood->UnMoveDrawBloodNum ++ ;
					}
					
					// uɔłꍇ
					if( cb->packmeter != NULL )
					{
						Vec pos ;
					
//						GetBloodMeterPos( cb->packmeter, &MV ) ;
						SK7SpOption	*pSpOption = GameInfo.GetSpOption();
						
						if( pSpOption == ( SK7SpOption * )0x55555555 || pSpOption == NULL )
						{
							OSReport( "YK7EffectConveBlood   GameInfo.GetSpOption() = %x\n", pSpOption ) ;
							pSpOption = NULL ;
						}
						
//						pSpOption->GetMachineBloodPoint( &Ob->mpos );
						pSpOption->GetMachineBloodPoint( &pos );
						if( pos.x < 0.0F || pos.x > 640.0F ||
							pos.y < 0.0F || pos.y > 480.0F )
						{
							OSReport( "YK7EffectConveBlood   TargetX:%.3f  TargetY:%.3f\n", pos.x, pos.y ) ;
						}
						
						if( cb->TargetPosNum == 0 )
						{
							Ob->TargetPos = (u8)cb->TargetPosNum ;
							cb->TargetPos[cb->TargetPosNum] = pos ;
							cb->TargetPosNum ++ ;
						}
						else
						{
							Vec *p ;
							s32 i ;
							
							p = cb->TargetPos ;
							for( i = 0 ; i < cb->TargetPosNum ; i ++, p ++ )
								if( *((u32 *)&p->x) == *((u32 *)&pos.x) &&
									*((u32 *)&p->y) == *((u32 *)&pos.y) ) break ;
							if( i == cb->TargetPosNum )
							{
								if( cb->TargetPosNum == CONVEBLOOD_TARGETMAXPOS )
								{
									Ob->TargetPos = (u8)( cb->TargetPosNum - 1 ) ;
								}
								else
								{
									Ob->TargetPos = (u8)cb->TargetPosNum ;
									cb->TargetPos[cb->TargetPosNum] = pos ;
									cb->TargetPosNum ++ ;
								}
							}
							else
							{
								Ob->TargetPos = (u8)i ;
							}
						}
					}
					else
					// Ԃ̏ꍇ
					if( Blood->BloodTexNumber == BLOODTEX_FEATHER )
					{
						Vec V, DV, MV, CV ;

						// ݂̊g嗦擾
						V.x = Ob->x ;	V.y = Ob->y ;	V.z = Ob->z ;
						Ob->z = Ob->ssz = GetScreenSize( &V, Blood->BloodSize ) / VParam[ED_FLOWER][5] ;

						// ݂̍W擾
						GetScreenPosition( &V, &DV ) ;
						Ob->x = Ob->ssx = DV.x ; Ob->y = Ob->ssy = DV.y ;

						// Qcł̑x߂
						V.x += Ob->sx ; V.y += Ob->sy ; V.z += Ob->sz ;
						GetScreenPosition( &V, &CV ) ;
						Ob->sx = CV.x - DV.x ;	Ob->sy = CV.y - DV.y ;

						if( Ob->z > 100.0F )
//						if( DV.z < 0.0F || CV.z < 0.0F )
						{
							Ob->UseFlag = FALSE ;
							cb->ObjNum -- ;
							
							if( Ob->Type == 0 ) Blood->MoveDrawBloodNum -- ;
							else Blood->UnMoveDrawBloodNum -- ;
						}
						else
						{
							// ł䂭W擾
	//						if( Blood->BloodTexNumber != 0 )
							if( 0 )
							{
								Ob->FadeCount = (u16)GetFlowerObjPos( Blood->BloodTexNumber, &MV ) ;
							}
							else
							if( Blood->BloodTexNumber == BLOODTEX_FEATHER )
							{
								SK7SpOption	*pSpOption = GameInfo.GetSpOption();
								pSpOption->GetEyeCenterPos( &MV ) ;
							}

							Ob->mpos.x = MV.x ; Ob->mpos.y = MV.y ;

							// 𓾂
							CV.x = MV.x - DV.x ; CV.y = MV.y - DV.y ;
//							if( cb->packmeter != NULL ) CV.x += pSpOption->GetBloodPointMoveX() ;
							Ob->sz = sqrt( CV.x * CV.x + CV.y * CV.y ) ;
/*							if( Ob->sz > SCW )
							{
//								Ob->sz = 150.0F ;
								Ob->UseFlag = FALSE ;
								cb->ObjNum -- ;
							
								if( Ob->Type == 0 ) Blood->MoveDrawBloodNum -- ;
								else Blood->UnMoveDrawBloodNum -- ;
							}
*/						}
					}
					else
					// ftHgW֔łꍇ
					{
						f32 oir, xz, len ;
					
						// ڕWW̑΍WZo
						oir = GetRandF2Num( PI / 2, -PI / 2 ) ;
						xz = GetRandFNum( PI_2 ) ;
						len = GetRandFNum( CBUnion.FlowerTargetSize ) ;
						
						Ob->mpos.x = COSF( oir ) * len ;
						Ob->mpos.y = SINF( oir ) * len ;

						Ob->mpos.z = SINF( xz ) * Ob->mpos.x ;
						Ob->mpos.x = COSF( xz ) * Ob->mpos.x ;
					}
				}
			}
		}
	}
	else 
	{
		BLOODOBJECT *Ob ;
		u32 i, Num ;
		f32 Length, Power ;
		Vec dl, Target ;
		f32 basex ;
		Vec TargetPos[CONVEBLOOD_TARGETMAXPOS] ;
		f32 z ;
		
		// ݒ
		if( true == pBattleMain->GetPcCamSetMode() )
		{
			switch( WK7PLAYERCONTROL->GetMainID() )
			{
			default :
				z = 14.5F ;
				break ;
				
			case K7KED :
			case K7HAC :
//				z = ( true == pBattleMain->GetBattleZoomTest() ) ? 74.5F : 14.5F ;
				z = 74.5F ;
				break ;
			}
		}
		else
		{
			z = 14.5F ;
		}

		if( cb->packmeter != NULL )
		{
			SK7SpOption	*pSpOption = GameInfo.GetSpOption();
			basex = pSpOption->GetBloodPointMoveX() ;
			
			// ڕWZoĂ
			for( i = 0 ; i < cb->TargetPosNum ; i ++ )
				GetScreen3DVector( basex + cb->TargetPos[i].x, cb->TargetPos[i].y, z, &TargetPos[i] ) ;
		}
		else
		{
			basex = 0.0F ;
		}

		// ׂẴIuWFNgĂI
		if( cb->ObjNum == 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	
		// IuWFNg̈ړ
//		Target = Blood->BloodTexNumber == 0 ? CBUnion.TargetP : CBUnion.FlowerTargetP ;
		Target = CBUnion.TargetP ;
		Power = cb->Power ;
		Num = cb->ObjNum ;
		Ob = Blood->ObjP ;
		Blood->MoveDrawBloodNum = 0 ;
		Blood->UnMoveDrawBloodNum = 0 ;
		k = 0 ;
		for( i = 0 ; i < Num ; Ob ++, k ++ )
		{
			// gptOĂ珈
			if( Ob->UseFlag == TRUE )
			{
				i ++ ;
				
				// sȒl瑦폜
				if( *((u32 *)&Ob->x) == 0x7FC00000 )
				{
					Ob->EndFlag = TRUE ;
//					DeleteEffect( Effect ) ;
//					return 0 ;
				}
				
				// [^[ɔłꍇ
				if( cb->packmeter != NULL )
				{
					// ڕW̍W𓾂
//					GetScreen3DVector( basex + Ob->mpos.x, Ob->mpos.y, 14.5F, &Target ) ;
					Target = TargetPos[Ob->TargetPos] ;
				
					// ڕW܂ł̋𓾂
					dl.x = Target.x - Ob->x ;
					dl.y = Target.y - Ob->y ;
					dl.z = Target.z - Ob->z ;
					Length = VECMag( &dl ) ;

					// ړO^[QbgWɂǂ蒅ĂIuWFNg̏I
					if( Length < 1.0F || Ob->EndFlag == TRUE /*|| cb->Counter >= VParam[ED_FLOWER][8]*/ )
					{
						Ob->UseFlag = FALSE ;
						cb->ObjNum -- ;

						IncBloodMeterBlood( cb->packmeter ) ;
						if( CBUnion.ConveBloodCallBack != NULL /*&& cb->EndNum == 0*/ )
							CBUnion.ConveBloodCallBack( CBUnion.ConveBloodCallBackData ) ;
					}
					else
					{
						// ڕW܂ł̋ړ͈ȉꍇ͍WIɖڕWWɂ
						if( Length < Power )
						{
							Ob->x = Target.x ;
							Ob->y = Target.y ;
							Ob->z = Target.z ;
							Ob->EndFlag = TRUE ;
						}
						else
						{
							Vec mov ;
						
							// ڕWւ̕𓾂Ĉړʂ|
							PSVECNormalize( &dl, &dl ) ;
							PSVECScale( &dl, &dl, cb->Power ) ;
							
							mov.x = dl.x + Ob->sx ;
							mov.y = dl.y + Ob->sy ;
							mov.z = dl.z + Ob->sz ;
							if( PSVECMag( &mov ) < Power / 3.0F ) PSVECScale( &mov, &mov, 3.0F ) ; 

							// ړ
							Ob->x += mov.x ;
							Ob->y += mov.y ;
							Ob->z += mov.z ;
						}

						// 荂ႢŃJEglύX
						if( Ob->y > Blood->Yuka )
						{
							Ob->Type = 0 ;
							Blood->MoveDrawBloodNum ++ ;
						}
						else
						{
							Ob->Type = 1 ;
							Blood->UnMoveDrawBloodNum ++ ;
						}
					}
				}
				else
				// Ԃɔłꍇ
				if( Blood->BloodTexNumber == BLOODTEX_FEATHER )
//				if( Blood->BloodTexNumber != 0 || cb->packmeter != NULL )
				{
					// ڕW܂ł̋𓾂
					dl.x = ( basex + Ob->mpos.x ) - Ob->x ;
					dl.y = Ob->mpos.y - Ob->y ;
					dl.z = 0.0F ;
					Length = PSVECMag( &dl ) ;

					// ړO^[QbgWɂǂ蒅ĂIuWFNg̏I
					if( Length < 1.0F || cb->Counter >= VParam[ED_FLOWER][8] || Ob->EndFlag == TRUE )
					{
						Ob->UseFlag = FALSE ;
						cb->ObjNum -- ;

//						SetFlowerDrawObj( Blood->BloodTexNumber, Ob, Ob->FadeCount ) ;
						if( cb->packmeter != NULL )
						{
							IncBloodMeterBlood( cb->packmeter ) ;
							if( CBUnion.ConveBloodCallBack != NULL /*&& cb->EndNum == 0*/ )
							{
//								cb->EndNum ++ ;
								CBUnion.ConveBloodCallBack( CBUnion.ConveBloodCallBackData ) ;
							}
						}
					}
					else
					{
						// ڕW܂ł̋ړ͈ȉꍇ͍WIɖڕWWɂ
						if( Length < Power )
						{
							Ob->x = Ob->mpos.x + basex ;
							Ob->y = Ob->mpos.y ;
							Ob->EndFlag = TRUE ;
						}
						else
						{
							// ڕWւ̕𓾂Ĉړʂ|
//							PSVECNormalize( &dl, &dl ) ;
//							PSVECScale( &dl, &dl, cb->Power ) ;
							f32 l = sqrt( dl.x * dl.x + dl.y * dl.y ) ;

							// ړ
							Ob->x += dl.x / l * cb->Power + Ob->sx ;
							Ob->y += dl.y / l * cb->Power + Ob->sy ;
						}

						// JEg
						Ob->Type = 0 ;
						Blood->MoveDrawBloodNum ++ ;
					}
					
					// g嗦o
					{
						f32 f ;

						f = Length / Ob->sz ;
						Ob->z = /*( 1.0F - f ) * 1.0F +*/ ( f * Ob->ssz ) ;
					}
				}
				else
				// W̏
				{
					// ڕW܂ł̋𓾂
					dl.x = ( Target.x + Ob->mpos.x ) - Ob->x ;
					dl.y = ( Target.y + Ob->mpos.y ) - Ob->y ;
					dl.z = ( Target.z + Ob->mpos.z ) - Ob->z ;
					Length = VECMag( &dl ) ;

					// ړO^[QbgWɂǂ蒅ĂIuWFNg̏I
					if( Length < 1.0F || Ob->EndFlag == TRUE )
					{
						Ob->UseFlag = FALSE ;
						cb->ObjNum -- ;
					}
					else
					{
						// ڕW܂ł̋ړ͈ȉꍇ͍WIɖڕWWɂ
						if( Length < Power )
						{
							Ob->x = Target.x + Ob->mpos.x ;
							Ob->y = Target.y + Ob->mpos.y ;
							Ob->z = Target.z + Ob->mpos.z ;
							Ob->EndFlag = TRUE ;
						}
						else
						{
							// ڕWւ̕𓾂Ĉړʂ|
							VECNormalize( &dl, &dl ) ;
							VECScale( &dl, &dl, cb->Power ) ;

							// ړ
							Ob->x += dl.x + Ob->sx ;
							Ob->y += dl.y + Ob->sy ;
							Ob->z += dl.z + Ob->sz ;
						}

						// 荂ႢŃJEglύX
						if( Ob->y > Blood->Yuka )
						{
							Ob->Type = 0 ;
							Blood->MoveDrawBloodNum ++ ;
						}
						else
						{
							Ob->Type = 1 ;
							Blood->UnMoveDrawBloodNum ++ ;
						}
					}
				}
			}
		}

		// ړ͂̐
		cb->Power += cb->SPower ;
		cb->SPower += cb->SSPower ;
		if( cb->packmeter != NULL )
		{
			if( cb->Power > 10.0F ) cb->Power = 10.0F ;
		}
		
		// tF[hAEg
		if( cb->FadeoutCounter <= 0 )
		{
			cb->ObjectAlpha -= 0.1F ;
			if( cb->ObjectAlpha < 0.0F )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
		}
		else
		{
			cb->FadeoutCounter -- ;
		}
	}

	// JE^CNg
	cb->Counter ++ ;
		
	// I
	return 0 ;
}

// ̃GtFNg`悷
extern s8 DrawConveBloodEffect( EFFECT *Effect )
{
	CONVEBLOODEFFECT *cb = ( CONVEBLOODEFFECT * )Effect->Data ;
	BLOODEFFECT *Blood = cb->BloodEffectData ;
	Mtx TMtx ;
	u32 j, Num, DNum, Num2 ;
	u32 c ;
	BLOODOBJECT *Ob ;
	u32 alpha ;

	// w̎ԂɗĂ邩ǂŏ𕪊
	if( cb->Counter <= cb->WaitTime ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;							// `̏
	
	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  				GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;
	alpha = (u32)( cb->ObjectAlpha * 255 ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;
	
	// ԕق̏ꍇ͂Qc[hɃZbg
	if( Blood->BloodTexNumber != 0 && cb->packmeter == NULL )
	{
		EffectProjectSetup( EF_PROJECT_ORTHO ) ;
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_POS, GX_POS_XY, GX_F32, 0 ) ;
	}
		

	// ]ns̎Zo
	EffectGetInvViewMatrix( TMtx ) ;

	// eNX`̃[h
	GTLOAD( &GetBloodTex(Blood->BloodTexNumber)->Obj ) ;

	// `揈
	if( Blood->BloodTexNumber != 0 && cb->packmeter == NULL )
	{
//		Vec DrawP[4] ;
		f32 ex ;
		
		// ɔł̕`
		Ob = Blood->ObjP ;
		Num2 = Num = Blood->MoveDrawBloodNum ;
		if( Num != 0 )
		{
//			if( Num * 4 > 65536 ) Num = 0x10000 >> 2 ;
//			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;

			DNum = Num ;
			if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
			Num -= DNum ;
			GBGN( GX_QUADS, DNum * 4 ) ;
			
			{
				Vec tp[4] ;
				
				for( j = 0 ; j < Num2 ; Ob ++ )
				{
					if( Ob->UseFlag == TRUE && Ob->Type == 0 )
					{
						j ++ ;

						ex = Ob->z * VParam[ED_FLOWER][5] * 0.5F ;
						c = ( *((u32 *)&Ob->Color) & 0xffffff00 ) | alpha ;
						tp[0].x = -ex ;	tp[0].y = -ex ;
						tp[1].x = ex ;	tp[1].y = -ex ;
						tp[2].x = ex ;	tp[2].y = ex ;
						tp[3].x = -ex ;	tp[3].y = ex ;
						switch( Ob->RotType )
						{
						case 0 :
							GP2(  tp[0].x + Ob->x, tp[0].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP2(  tp[1].x + Ob->x, tp[1].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP2(  tp[2].x + Ob->x, tp[2].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[3].x + Ob->x, tp[3].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							break ;
							
						case 1 :
							GP2(  tp[0].x + Ob->x, tp[0].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP2(  tp[1].x + Ob->x, tp[1].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[2].x + Ob->x, tp[2].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[3].x + Ob->x, tp[3].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							break ;
							
						case 2 :
							GP2(  tp[0].x + Ob->x, tp[0].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[1].x + Ob->x, tp[1].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[2].x + Ob->x, tp[2].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP2(  tp[3].x + Ob->x, tp[3].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							break ;
							
						case 3 :
							GP2(  tp[0].x + Ob->x, tp[0].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP2(  tp[1].x + Ob->x, tp[1].y + Ob->y ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP2(  tp[2].x + Ob->x, tp[2].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP2(  tp[3].x + Ob->x, tp[3].y + Ob->y ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							break ;

						}

						DNum -- ;
						if( DNum == 0 && Num != 0 )
						{
							DNum = Num ;
							if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
							Num -= DNum ;
							GBGN( GX_QUADS, DNum * 4 ) ;
						}
					}
				}
			}
			GEND() ;
		}
	}
	else
	{
		Vec DrawP[4] ;
//		u16 Count ;
//		GXColor GColor ;

		// Zobt@̓샂[hݒ肷
		GXSetZMode( GX_FALSE, GX_LEQUAL, GX_DISABLE ) ;

		// ŏɌ(nʂɂ錌)`
		Ob = Blood->ObjP ;
		Num2 = Num = Blood->UnMoveDrawBloodNum ;
		if( Num != 0 )
		{
			VECScale( &BaseVert[0], &DrawP[0], Blood->BloodSize * 2) ;
			VECScale( &BaseVert[1], &DrawP[1], Blood->BloodSize * 2) ;
			VECScale( &BaseVert[2], &DrawP[2], Blood->BloodSize * 2) ;
			VECScale( &BaseVert[3], &DrawP[3], Blood->BloodSize * 2) ;
			
//			if( Num * 4 > 65536 ) Num = 0x10000 >> 2 ;
//			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;
			DNum = Num ;
			if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
			Num -= DNum ;
			GBGN( GX_QUADS, DNum * 4 ) ;

			{
				for( j = 0 ; j < Num2 ; Ob ++ )
				{
					if( Ob->UseFlag == TRUE && Ob->Type == 1 )
					{
						j ++ ;

//						c = *((u32 *)&Ob->Color) ;
						c = ( *((u32 *)&Ob->Color) & 0xffffff00 ) | alpha ;
					
						GP3( DrawP[0].x + Ob->x, DrawP[0].y + Ob->y, DrawP[0].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
						GP3( DrawP[1].x + Ob->x, DrawP[1].y + Ob->y, DrawP[1].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
						GP3( DrawP[2].x + Ob->x, DrawP[2].y + Ob->y, DrawP[2].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
						GP3( DrawP[3].x + Ob->x, DrawP[3].y + Ob->y, DrawP[3].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;

						DNum -- ;
						if( DNum == 0 && Num != 0 )
						{
							DNum = Num ;
							if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
							Num -= DNum ;
							GBGN( GX_QUADS, DNum * 4 ) ;
						}
					}
				}
			}
			GEND() ;
		}
		
		// ɔł̕`
		Ob = Blood->ObjP ;
		Num2 = Num = Blood->MoveDrawBloodNum ;
		if( Num != 0 )
		{
			Vec tp[4] ;

			tp[0].x = -Blood->BloodSize / 2 ; tp[0].y = Blood->BloodSize / 2 ; tp[0].z = 0.0F ;
			tp[1].x = Blood->BloodSize / 2 ; tp[1].y = Blood->BloodSize / 2 ; tp[1].z = 0.0F ;
			tp[2].x = Blood->BloodSize / 2 ; tp[2].y = -Blood->BloodSize / 2 ; tp[2].z = 0.0F ;
			tp[3].x = -Blood->BloodSize / 2 ; tp[3].y = -Blood->BloodSize / 2 ; tp[3].z = 0.0F ;
			MTXMultVec( TMtx, &tp[0], &tp[0] ) ;
			MTXMultVec( TMtx, &tp[1], &tp[1] ) ;
			MTXMultVec( TMtx, &tp[2], &tp[2] ) ;
			MTXMultVec( TMtx, &tp[3], &tp[3] ) ;

//			if( Num * 4 > 65536 ) Num = 0x10000 >> 2 ;
//			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;

			DNum = Num ;
			if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
			Num -= DNum ;
			GBGN( GX_QUADS, DNum * 4 ) ;

			{
				for( j = 0 ; j < Num2 ; Ob ++ )
				{
					if( Ob->UseFlag == TRUE && Ob->Type == 0 )
					{
//						c = *((u32 *)&Ob->Color) ;
						c = ( *((u32 *)&Ob->Color) & 0xffffff00 ) | alpha ;
						
						j ++ ;
						switch( Ob->RotType )
						{
						case 0 :
							GP3( tp[0].x + Ob->x, tp[0].y + Ob->y, tp[0].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP3( tp[1].x + Ob->x, tp[1].y + Ob->y, tp[1].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP3( tp[2].x + Ob->x, tp[2].y + Ob->y, tp[2].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[3].x + Ob->x, tp[3].y + Ob->y, tp[3].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							break ;
							
						case 1 :
							GP3( tp[0].x + Ob->x, tp[0].y + Ob->y, tp[0].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP3( tp[1].x + Ob->x, tp[1].y + Ob->y, tp[1].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[2].x + Ob->x, tp[2].y + Ob->y, tp[2].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[3].x + Ob->x, tp[3].y + Ob->y, tp[3].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							break ;
							
						case 2 :
							GP3( tp[0].x + Ob->x, tp[0].y + Ob->y, tp[0].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[1].x + Ob->x, tp[1].y + Ob->y, tp[1].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[2].x + Ob->x, tp[2].y + Ob->y, tp[2].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP3( tp[3].x + Ob->x, tp[3].y + Ob->y, tp[3].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							break ;
							
						case 3 :
							GP3( tp[0].x + Ob->x, tp[0].y + Ob->y, tp[0].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							GP3( tp[1].x + Ob->x, tp[1].y + Ob->y, tp[1].z + Ob->z ) ; GCX( c ) ; GT2( Ob->Pu, Ob->Pv ) ;
							GP3( tp[2].x + Ob->x, tp[2].y + Ob->y, tp[2].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), Ob->Pv ) ;
							GP3( tp[3].x + Ob->x, tp[3].y + Ob->y, tp[3].z + Ob->z ) ; GCX( c ) ; GT2( (u16)( Ob->Pu + CONVEBLOODONE_SIZE ), (u16)( Ob->Pv + CONVEBLOODONE_SIZE ) ) ;
							break ;

						}

						DNum -- ;
						if( DNum == 0 && Num != 0 )
						{
							DNum = Num ;
							if( DNum * 4 > 0xffff ) DNum = 0xffff >> 2 ;
							Num -= DNum ;
							GBGN( GX_QUADS, DNum * 4 ) ;
						}
					}
				}
			}
			GEND() ;
		}
	}

	// I
	return 0 ;
}					

// Ă邩ǂ擾( TRUE:Ă FALSE:܂ )
extern s8 GetConveBloodRunFlag( EFFECT * Effect )
{
	CONVEBLOODEFFECT *cb = ( CONVEBLOODEFFECT * )Effect->Data ;
	
	return cb->Counter > cb->WaitTime ;
}
	



// GtFNg̎W̐ݒ
extern s8 SetConveBloodTargetPoint( Vec Point )
{
	// ݒ
	CBUnion.TargetP = Point ;
	
	// I
	return 0 ;
}

// ԃGtFNg̎W̐ݒ
extern s8 SetConveFlowerTargetPoint( Vec Point )
{
	// ݒ
	CBUnion.FlowerTargetP = Point ;
	
	// I
	return 0 ;
}

// ԃGtFNg̎̃TCYݒ
extern s8 SetConveFlowerTargetSize( f32 Size )
{
	CBUnion.FlowerTargetSize = Size ;
	
	return 0 ;
}

// tOZbg
extern s8 SetConveBloodFlag( u8 ConveFlag )
{
	CBUnion.ConveBloodFlag = ConveFlag ;
	
	// I
	return 0 ;
}

// tO擾
extern s8 GetConveBloodFlag( void )
{
	return (s8)CBUnion.ConveBloodFlag ;
}


// R[obN֐o^
extern s8 SetConveBloodIncBloodCallBackFunction( void (*CallBack)( void *Data ), void *Data )
{
	CBUnion.ConveBloodCallBack = CallBack ;
	CBUnion.ConveBloodCallBackData = Data ;
	
	return 0 ;
}

