///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCountDown
//
// YK7EffectCountDown.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/13/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectCountDown.h"
#include "./YK7EffectTime.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define FOLDER					"/Yam/Effect/CountDown/"
#define LOSER_PATH				"font_loser.BIN"
#define LOSER_BLUR_PATH			"font_loser_blur.BIN"
#define WINNER_PATH				"font_winner.BIN"
#define WINNER_BLUR_PATH		"font_winner_blur.BIN"
#define GO_PATH					"go.BIN"

// data -----------------------------------------

COUNTDOWNUNION cdu ;
extern TIMEUNION timu ;

// datatype -------------------------------------

// function proto type --------------------------

s8 TexLoadSet2( TEXDATA *Tex, char *Path ) ;
static f32 __alphaget( s32 count ) ;
static f32 __sizeget( s32 count, f32 min, f32 max ) ;

// function code --------------------------------

static f32 __sizeget( s32 count, f32 min, f32 max )
{
	if( count < 26 ) return count * ( max - min ) / 26 + min ;
	else return max ;
}

static f32 __alphaget( s32 count )
{
	if( count < 5 ) return (f32)count / 5 * 0.70F ;
	else if( count < 17 ) return 0.70F ;
	else if( count < 25 ) return 0.70F * ( 1.0F - (f32)( count - 17 ) / 8 ) ;
	else return 0.0F ;
}

s8 TexLoadSet2( TEXDATA *Tex, char *Path )
{
	char str[100] ;
	
	strcpy( str, FOLDER ) ;
	strcat( str, Path ) ;
	return TexLoadSet( str, Tex ) ;
}


// JEg_EGtFNg̋ʃf[^
extern s8 InitCountDownData( void )
{
	MEMINIT( cdu ) ;

	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_COUNTDOWN )->GetResource( STDAT_CON_font_loser ), &cdu.loser ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_COUNTDOWN )->GetResource( STDAT_CON_font_loser_blur ), &cdu.loser_blur ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_COUNTDOWN )->GetResource( STDAT_CON_font_winner ), &cdu.winner ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_COUNTDOWN )->GetResource( STDAT_CON_font_winner_blur ), &cdu.winner_blur ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_COUNTDOWN )->GetResource( STDAT_CON_go ), &cdu.go ) ;
	
//	TexLoadSet2( &cdu.loser, LOSER_PATH ) ;
//	TexLoadSet2( &cdu.loser_blur, LOSER_BLUR_PATH ) ;
//	TexLoadSet2( &cdu.winner, WINNER_PATH ) ;
//	TexLoadSet2( &cdu.winner_blur, WINNER_BLUR_PATH ) ;
//	TexLoadSet2( &cdu.go, GO_PATH ) ;

	return 0 ;
}

// JEg_EGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCountDownData( void )
{
//	if( TexLoadChk( &cdu.loser ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &cdu.loser_blur ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &cdu.winner ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &cdu.winner_blur ) == FALSE ) return FALSE ;
//	if( TexLoadChk( &cdu.go ) == FALSE ) return FALSE ;

	return TRUE ;
}

// JEg_EGtFNg̋ʃf[^n
extern s8 EndCountDownData( void )
{
	TexRelease( &cdu.loser ) ;
	TexRelease( &cdu.loser_blur ) ;
	TexRelease( &cdu.winner ) ;
	TexRelease( &cdu.winner_blur ) ;
	TexRelease( &cdu.go ) ;

	MEMINIT( cdu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// JEg_EGtFNg쐬
extern EFFECT *CreateCountDownEffect( s32 Priority )				// JEg_EGtFNg쐬
{
	EFFECT *Effect ;
	COUNTDOWNEFFECT *cd ;
	
	// VJEg_Ef[^쐬
	Effect = AddEffectData( EFF_COUNTDOWN, (void**)&cd, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̏
	memset( cd, 0, sizeof( COUNTDOWNEFFECT ) ) ;
	cd->mode1 = cd->mode2 = cd->counter = 0 ;

	// I
	return Effect ;
}

// JEg_EGtFNǧns
extern s8 ReleaseCountDownEffect( EFFECT *Effect )
{
	COUNTDOWNEFFECT *cd = ( COUNTDOWNEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// JEg_EGtFNgPt[
extern s8 MoveCountDownEffect( EFFECT *Effect )
{
	COUNTDOWNEFFECT *cd = ( COUNTDOWNEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	switch( cd->mode1 )
	{
	case 0 :	// 3
		if( cd->counter == 30 )
		{
			cd->counter = 0 ;
			cd->mode1 ++ ;
			
			cd->num[2].alpha = 0.0F ;
		}
		else
		{
			cd->counter ++ ;
			cd->num[2].alpha = __alphaget( cd->counter ) ;
			cd->num[2].size = __sizeget( cd->counter, 160, 512 ) ;
		}
		break ;
		
	case 1 :	// 2
		if( cd->counter == 30 )
		{
			cd->counter = 0 ;
			cd->mode1 ++ ;
			
			cd->num[1].alpha = 0.0F ;
		}
		else
		{
			cd->counter ++ ;
			cd->num[1].alpha = __alphaget( cd->counter ) ;
			cd->num[1].size = __sizeget( cd->counter, 96, 352 ) ;
		}
		break ;

	case 2 :	// 1
		if( cd->counter == 30 )
		{
			cd->counter = 0 ;
			cd->mode1 ++ ;
			
			cd->num[0].alpha = 0.0F ;
		}
		else
		{
			cd->counter ++ ;
			cd->num[0].alpha = __alphaget( cd->counter ) ;
			cd->num[0].size = __sizeget( cd->counter, 52, 180 ) ;
		}
		break ;
		
	case 3 :	// go
		{
			const s16 gw = 118, gh = 64 ;
			const s8 rottable[] = 		{ 5, 		-3, 	7,		-5,		5,		-3,		2,		-8,		6,		-3,		7,		-5, 	10,		-3		} ;
			const s16 sizetable[][2] = 	{ 176,96,	212,114,142,78,	248,134,178,96,	206,112,160,86,	188,102,160,86,	188,102,142,78,	154,84, 118,64,	178,96	} ;
		
			if( cd->counter == 15 )
			{
				cd->mode1 ++ ;
				cd->counter = 0 ;
				cd->goalpha = 0.0F ;
				break ;
			}
			else
			{
				cd->gorot = PI_2 * rottable[cd->counter] / 360 ;
				cd->gosize = (f32)sizetable[cd->counter][0] / gw ;
				
				if( cd->counter < 14 ) cd->goalpha = 0.70F ;
				else if( cd->counter == 14 ) cd->goalpha = 0.35F ;
				else cd->goalpha = 0.0F ;
			
				cd->counter ++ ;
			}
		}
		break ;
	
	case 4 :
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// JEg_EGtFNg`悷
extern s8 DrawCountDownEffect( EFFECT *Effect )
{
	COUNTDOWNEFFECT *cd = ( COUNTDOWNEFFECT * )Effect->Data ;
	s32 i, x, y ;
	COUNTDOWNOBJECT *ob ;

	// `悷
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	x = SCW / 2 ;	y = SCH / 2 ;
	
	// ̕`
	ob = cd->num ;
	for( i = 0 ; i < 3 ; i ++, ob ++ )
	{
		if( ob->alpha != 0.0F ) ;
		{
			DrawExTex( x, y, ob->size / 64.0F, true, &timu.numtex[1][i], CMK( 0xff, 0xff, 0xff, 0xff * ob->alpha ) ) ;
		}
	}

	// go ̕`
	if( cd->goalpha != 0.0F )
		DrawRotTex( x, y, cd->gorot, cd->gosize, &cdu.go, CMK( 0xff, 0xff, 0xff, 0xff * cd->goalpha ) ) ;

	// I
	return 0 ;
}

// JEg_ȄԂ𓾂( 0:3  1:2  2:1  3:go )
extern s8 GetCountDownState( EFFECT *Effect )
{
	COUNTDOWNEFFECT *cd = ( COUNTDOWNEFFECT * )Effect->Data ;
	
	return (s8)cd->mode1 ;
}


