///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCursor
//
// YK7EffectCursor.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/05/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTCURSOR_H
#define __YK7EFFECTCURSOR_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

#define CUR_OBJECTMAXNUM	50
#define CUR_OBJECTNUM		4
#define CUR_MAXAIMAGE		200

// datatype -------------------------------------

// cpIuWFNgf[^
typedef struct tagCURSORAIMAGE
{
	u8 UseFlag ;		// gptO
	u16 x, y ;			// W
	u8 a ;				// At@l
	GXColor Color ;		// F
} CURSORAIMAGE ;

// J[\GtFNgʃf[^
typedef struct tagCURSORUNION
{
	CURSORAIMAGE AImage[CUR_MAXAIMAGE] ;
	u16 AImageNum ;

	TEXDATA AmiTex ;				// Ԋ|eNX`
} CURSORUNION ;

// J[\pIuWFNgf[^
typedef struct tagCURSOROBJECT
{
	f32 x, y ;			// W
	f32 sx, sy ;		// x
	f32 dx, dy ;		// CJ[\ɑ΂鑊΍W
	f32 dxEx, dyEx ;	// dx, dy ɑ΂g嗦
	f32 mx, my ;		// ړ
	f32 Speed ;			// Xs[h
} CURSOROBJECT ;

// J[\GtFNgf[^
typedef struct tagCURSOREFFECT
{
	f32 x, y ;							// TCg̒SW
	f32 x2, y2 ;
	f32 mx, my ;						// ړ
	GXColor Color ;						// F
	
	s8 ShadowFlag ;						// etO
	f32 Alpha ;							// At@
	f32 Bright ;						// Px
	f32 CenterBright ;					// S|Cg̋Px

	s8 FastFlag ;
	s8 EndFlag ;						// ItO
	s8 EndCounter ;
	
	CURSOROBJECT Obj[CUR_OBJECTNUM] ;	// J[\IuWFNg̃f[^
	
	CURSOROBJECT LeftRightObj[2][CUR_OBJECTMAXNUM] ;	// (0:Left 1:Right)
	u16 LeftRightMovNum ;								// ẼJ[\IuWFNg̐
	u16 BackLRMovNum ;

	CURSOROBJECT TopBottomObj[2][CUR_OBJECTMAXNUM] ;	// (0:Top 1:Bottom)
	u16 TopBottomMovNum ;								// ẼJ[\IuWFNg̐
	u16 BackTBMovNum ;
	
	s32 LeftRightCounter ;
	s32 TopBottomCounter ;

	u16 LeftRightNum ;
	u16 TopBottomNum ;

	u8 CenterDrawFlag ;					// SɂObh`悷邩ǂ̃tO
	u8 DrawFlag ;						// `tO
	f32 Alpha2 ;

	u8 AmiDrawFlag ;					// Ԋ|tO
	s32 AmiCounter ;					// Ԋ|JE^[
	f32 AmiYFill ;						// cԊ|hbg
	f32 AmiXFill ;						// Ԋ|hbg
	u32 AmiColorTop, AmiColorBot ;		// Ԃ̉ɕtv[g̐F
	u32 AmiColor ;						// Ԃ̐F

	s8 BrinkMode ;													// _Ń[h( 0:Ă  1:_  2:_ςȂ  3:Ɩ )
	f32 BrinkSinCounter ;											// _Ń[hRpJE^
	s8 BrinkCounter1, BrinkCounter2, BrinkCounter3 ;				// _ŏpJE^[
	s8 BrinkState ;													// _ŏ( 0:Ă  1:_Ă )
	s8 CharBrinkCounter1, CharBrinkCounter2, CharBrinkCounter3  ;	// _ŏpJE^[	
	s8 CharBrinkState ;												// _ŏ( 0:Ă  1:_Ă )
} CURSOREFFECT ;

// J[\GtFNgf[^p\
typedef struct tagCURSOREFFECTTASKPARAM
{
	u8 dummy ;				// ɂȂ
} CURSOREFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitCursorData( void ) ;				// J[\GtFNg̋ʃf[^
extern s8 CheckCursorData( void ) ;				// J[\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndCursorData( void ) ;				// J[\GtFNg̋ʃf[^n

extern EFFECT *CreateCursorEffect( GXColor Color, s8 FastFlag = TRUE, s32 Priority = 255 ) ;	// J[\GtFNg쐬
extern s8 ReleaseCursorEffect( EFFECT *Effect ) ;					// J[\GtFNǧns
extern s8 MoveCursorEffect( EFFECT *Effect ) ;						// J[\GtFNgPt[
extern s8 DrawCursorEffect( EFFECT *Effect ) ;						// J[\GtFNg`悷

extern s8 SetCursorPos( u16 x, u16 y,
						s16 Width, s16 Height, EFFECT *Effect,
						s8 BaseLeftTopFlag = FALSE, s8 InitBaseLeftTopFlag = FALSE ) ;		// J[\̕\WƃTCYύX
extern s8 SetCursorDrawFlag( u8 DrawFlag, EFFECT *Effect ) ;		// J[\GtFNg`悷邩ǂ̃tOZbg
extern s8 GetCursorDrawAlpha( EFFECT * Effect ) ;					// J[\̕`掞̃At@l𓾂
extern s8 SetCenterCursorDrawFlag( u8 DrawFlag, EFFECT *Effect ) ;	// SɂObh`悷邩ǂ̃tOZbg
extern s8 SetCursorColor( EFFECT *Effect, GXColor color ) ;			// FύX

extern s8 SetCursorLeftRightObjectNum( EFFECT *Effect, u16 Num ) ;	// EɂIuWFNg̐ύX
extern s8 SetCursorTopBottomObjectNum( EFFECT *Effect, u16 Num ) ;	// ㉺ɂIuWFNg̐ύX

extern s8 EndReqCursorEffect( EFFECT *Effect ) ;					// J[\̏IJn
extern s8 SetCursorShadowFlag( EFFECT *Effect, s8 Flag ) ;			// J[\ɉe邩ǂ̃tOύX

extern s8 SetCursorAmikakeFlag( EFFECT *Effect, s8 Flag ) ;			// S̃IuWFNg͂ɖԊ|{ǂݒ肷
extern s8 SetCursorBrinkMode( EFFECT *Effect, s8 Mode ) ;			// J[\̓_Ń[hύX( 0:Ă  1:_  2:_ςȂ 3:Ɩ )
extern s8 GetCursorBrinkState( EFFECT *Effect ) ;					// J[\̓_ŏԂ擾( 0:Ă 1:tĂ )
extern s8 GetCursorBrinkState2( EFFECT *Effect ) ;					// J[\̋t_ŏԂ擾( 0:Ă 1:tĂ )
extern f32 GetCursorBrinkState3( EFFECT *Effect ) ;					// J[\̋tŏԂ擾( 0.0F:Ă  1.0F:_Ă )

extern s8 SetCursorAmiColor( EFFECT *Effect, u32 colorami, u32 colortop, u32 colorbottom ) ;		// Ԋ֌W̐Fݒ肷

#endif
