///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectCut2
//
// YK7EffectCut2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectCut2.h"
#include "./YK7File.h"
//#include "./YK7EffectSmoke.h"
#include "./YK7EffectMuzzle.h"
#include "./YK7EffectBlur.h"
#include "./YK7EffectBullet.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_CUT2]

#define KVNS_DIRWIDTH	(PRM[15] * 0.01F * PI_2)
#define KVNS_DIR		((f32)PRM[9] / 360 * PI_2)
#define KVNS_CENLEN		(PRM[16] * 0.1F)
#define KVNS_WIDTH		(PRM[11] * 0.1F)
#define KVNS_HEIGHT		(PRM[12] * 0.01F)

#define KVNS_SPEED		(PRM[10] * 0.1F)
#define KVNS_INCOLOR	(CMK(PRM[1],PRM[2],PRM[3],PRM[4]))
#define KVNS_OUTCOLOR	(CMK(PRM[5],PRM[6],PRM[7],PRM[8]))
#define KVNS_TIME		(PRM[14])

// data -----------------------------------------

CUT2UNION ct2u ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// JbgQGtFNg̋ʃf[^
extern s8 InitCut2Data( void )
{
	MEMINIT( ct2u ) ;

	return 0 ;
}

// JbgQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckCut2Data( void )
{
	return TRUE ;
}

// JbgQGtFNg̋ʃf[^n
extern s8 EndCut2Data( void )
{
	MEMINIT( ct2u ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// JbgQGtFNg쐬
extern EFFECT *CreateCut2Effect(
								Vec pos,					// W
								f32 speed,					// x
								u32 InColor, u32 OutColor,	// OƓ̐F
								Vec *dir, Vec *target,		// Ⴕ̓^[Qbg
								s32 time,					// \
								s32 Priority )
{
	EFFECT *Effect ;
	CUT2EFFECT *ct ;

	if( dir == NULL && target == NULL ) return NULL ;

	// VJbgQf[^쐬
	Effect = AddEffectData( EFF_CUT2, (void**)&ct, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( ct, 0, sizeof( CUT2EFFECT ) ) ;
	
	// l̏
	ct->pos = pos ;
	ct->time = time ;
	ct->con = 0 ;

	// xZbg
	if( dir != NULL )
	{
		VECNormalize( dir, dir ) ;
		ct->speed.x = dir->x * speed ;
		ct->speed.y = dir->y * speed ;
		ct->speed.z = dir->z * speed ;
	}
	else
	{
		Vec dx ;
		
		VECSubtract( target, &pos, &dx ) ;
		VECNormalize( &dx, &dx ) ;
		ct->speed.x = dx.x * speed ;
		ct->speed.y = dx.y * speed ;
		ct->speed.z = dx.z * speed ;
	}
	
	// f̎擾
	ct->model = CopyGunModel( GUN_THKNIFE_R ) ;
	if( ct->model == NULL ) goto ERR ;

	// f̍WZbg
	ct->model->SetPosition( ct->pos ) ;

	// f̕Zbg
	{
		f32 angleY ;
		
		angleY = atan2f( ct->speed.x, ct->speed.z ) ;
		ct->model->SetRotY( angleY /*+ PI / 2.0F*/ ) ;
	}
	
	// u[GtFNg̍쐬
	{
		WK7JObj *out1, *in, *out2 ;
		
		out1 = ct->model->GetObj( "Blur_01" ) ;
		out2 = ct->model->GetObj( "Blur_02" ) ;
		in = ct->model->GetObj( "Blur_03" ) ;
		
		ct->blur1 = CreateBlurEffect( out1, in,
							*((GXColor *)&OutColor), *((GXColor *)&InColor), Priority ) ;
		if( ct->blur1 == NULL ) goto ERR ;
		ct->blur1ID = GetEffectID( ct->blur1 ) ;

		ct->blur2 = CreateBlurEffect( out2, in,
							*((GXColor *)&OutColor), *((GXColor *)&InColor), Priority ) ;
		if( ct->blur2 == NULL ) goto ERR ;
		ct->blur2ID = GetEffectID( ct->blur2 ) ;
	}

	// I
	return Effect ;
	
ERR :
	if( ct->model != NULL ) delete ct->model ;
	if( ct->blur1 != NULL && CheckEffectValidState( ct->blur1, ct->blur1ID ) == TRUE ) DeleteEffect( ct->blur1 ) ;
	if( ct->blur2 != NULL && CheckEffectValidState( ct->blur2, ct->blur2ID ) == TRUE ) DeleteEffect( ct->blur2 ) ;
	DeleteEffect( Effect ) ;
	
	return NULL ;
}

// JbgQGtFNǧns
extern s8 ReleaseCut2Effect( EFFECT *Effect )
{
	CUT2EFFECT *ct = ( CUT2EFFECT * )Effect->Data ;

	if( ct->model != NULL ) delete ct->model ;
	if( ct->blur1 != NULL && CheckEffectValidState( ct->blur1, ct->blur1ID ) == TRUE ) DeleteEffect( ct->blur1 ) ;
	if( ct->blur2 != NULL && CheckEffectValidState( ct->blur2, ct->blur2ID ) == TRUE ) DeleteEffect( ct->blur2 ) ;
	DeleteEffect( Effect ) ;
	
	// I
	return 0 ;
}

// JbgQGtFNgPt[
extern s8 MoveCut2Effect( EFFECT *Effect )
{
	CUT2EFFECT *ct = ( CUT2EFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜
	if( Effect->DelReqFlag == TRUE )
	{
		if( CheckEffectValidState( ct->blur1, ct->blur1ID ) == FALSE &&
			CheckEffectValidState( ct->blur2, ct->blur2ID ) == FALSE )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	
		if( CheckEffectValidState( ct->blur1, ct->blur1ID ) == TRUE && ct->blur1->DelReqFlag == FALSE )
			DelReqEffect( ct->blur1 ) ;

		if( CheckEffectValidState( ct->blur2, ct->blur2ID ) == TRUE && ct->blur2->DelReqFlag == FALSE )
			DelReqEffect( ct->blur2 ) ;
	}
	
	// ړ
	if( ct->con != 0 )
	{
		ct->pos.x += ct->speed.x ;
		ct->pos.y += ct->speed.y ;
		ct->pos.z += ct->speed.z ;
	}
	
	ct->con ++ ;
	if( ct->con > ct->time && Effect->DelReqFlag == FALSE )
	{
		DelReqEffect( Effect ) ;
		return 0 ;
	}
	
	// f̍WZbg
	ct->model->SetPosition( ct->pos ) ;

	// f̕Zbg
	{
		f32 angleY ;
		
		angleY = atan2f( ct->speed.x, ct->speed.z ) ;
		ct->model->SetRotY( angleY /*+ PI / 2.0F*/ ) ;
//		ct->model->SetRotX( PI / 2.0F ) ;
//		ct->model->SetRotZ( PI / 2.0F ) ;
	}
	
	// I
	return 0 ;
}

// JbgQGtFNg`悷
extern s8 DrawCut2Effect( EFFECT *Effect )
{
	CUT2EFFECT *ct = ( CUT2EFFECT * )Effect->Data ;

	// f̃_O
	HSD_StateInvalidate( HSD_STATE_ALL ) ;
	HSD_CObjSetCurrent( GetEffectCamera() ) ;
	WK7Light::DispStart();
	WK7Light::DispAll() ;
//	GetBulletLight()->SetPosition( &(Vec){1.0F,-1.0F,1.0F} ) ;
//	GetBulletLight()->Disp() ;
	WK7Light::DispEnd();
	
	// `
	ct->model->RenderProcess() ;
	
	// _OI
	HSD_CObjEndCurrent() ;
	
	// I
	return 0 ;
}














































// PrVbgGtFNg̋ʃf[^
extern s8 InitKvnShotData( void )
{
	return 0 ;
}

// PrVbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckKvnShotData( void )
{
	return TRUE ;
}

// PrVbgGtFNg̋ʃf[^n
extern s8 EndKvnShotData( void )
{
	// ɂ邱ƂȂ
	return 0 ;
}



// PrVbgGtFNg쐬
extern EFFECT *CreateKvnShotEffect(
								Vec pos,				// W
								f32 speed,				// x
								Vec *dir, Vec *target,	// Ⴕ̓^[Qbg
								s32 Priority )
{
	EFFECT *Effect ;
	KVNSHOTEFFECT *kv ;

	if( dir == NULL && target == NULL ) return NULL ;

	// VPrVbgf[^쐬
	Effect = AddEffectData( EFF_KVNSHOT, (void**)&kv, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( kv, 0, sizeof( KVNSHOTEFFECT ) ) ;
	
	// l̏
	kv->mod = kv->con = 0 ;
	kv->pos = pos ;
	
	// ̎擾
	if( dir != NULL )
	{
		VECNormalize( dir, &kv->dir ) ;
	}
	else
	{
		VECSubtract( target, &pos, &kv->dir ) ;
		VECNormalize( &kv->dir, &kv->dir ) ;
	}

	// iCtGtFNg쐬
	{
		Vec xv, yv, zv,   pv1, dv1,  pv2, dv2 ;
		s32 i, j ;
		f32 rate, dir ;
		
		// O𓾂
		GetXYZVector( kv->dir, &xv, &yv, &zv ) ;

		// iCt̐JԂ
		for( j = 0 ; j < 2 ; j ++ )
		{
			for( i = 0 ; i < KVN_KNIFE_NUM ; i ++ )
			{
				rate = (f32)i / ( KVN_KNIFE_NUM - 1 ) ;
			
				// WZo
				pv1.x = -KVNS_WIDTH / 2.0F + KVNS_WIDTH * rate + KVNS_CENLEN * ( j == 0 ? -1 : 1 ) ;
				pv1.y = j == 0 ? 0.0F : 0.0F ;
				pv1.z = 0.0F ;

				// Zo
				dir = KVNS_DIR * ( j == 0 ? 1 : -1 ) - KVNS_DIRWIDTH / 2.0F + KVNS_DIRWIDTH * rate - PI / 2.0F ;
				dv1.x = COSF( dir ) ;
				dv1.y = 0.0F ;
				dv1.z = -SINF( dir ) ;

				// Zo
				pv2.x = xv.x * pv1.x + yv.x * pv1.y + zv.x * pv1.z + kv->pos.x ;
				pv2.y = xv.y * pv1.x + yv.y * pv1.y + zv.y * pv1.z + kv->pos.y ;
				pv2.z = xv.z * pv1.x + yv.z * pv1.y + zv.z * pv1.z + kv->pos.z ;
				
				dv2.x = xv.x * dv1.x + yv.x * dv1.y + zv.x * dv1.z ;
				dv2.y = xv.y * dv1.x + yv.y * dv1.y + zv.y * dv1.z ;
				dv2.z = xv.z * dv1.x + yv.z * dv1.y + zv.z * dv1.z ;
				
				// iCt쐬
				kv->effect[j][i] = CreateCut2Effect(
										pv2,
										KVNS_SPEED * speed,
										KVNS_INCOLOR, KVNS_OUTCOLOR,
										&dv2, NULL,
										KVNS_TIME,
										Effect->Priority - 1 ) ;
				if( kv->effect[j][i] == NULL ) goto ERR ;
				kv->effectID[j][i] = GetEffectID( kv->effect[j][i] ) ;
			}
		}
	}
	
	// I
	return Effect ;
	
ERR :
	{
		s32 i, j ;
		
		for( i = 0 ; i < 2 ; i ++ )
		{
			for( j = 0 ; j < KVN_KNIFE_NUM ; j ++ )
			{
				if( CheckEffectValidState( kv->effect[i][j], kv->effectID[i][j] ) == TRUE )
				{
					DeleteEffect( kv->effect[i][j] ) ;
				}
			}
		}
	}
	
	return NULL ;
}

// PrVbgGtFNǧns
extern s8 ReleaseKvnShotEffect( EFFECT *Effect )
{
	KVNSHOTEFFECT *kv = ( KVNSHOTEFFECT * )Effect->Data ;

	{
		s32 i, j ;
		
		for( i = 0 ; i < 2 ; i ++ )
		{
			for( j = 0 ; j < KVN_KNIFE_NUM ; j ++ )
			{
				if( CheckEffectValidState( kv->effect[i][j], kv->effectID[i][j] ) == TRUE )
				{
					DeleteEffect( kv->effect[i][j] ) ;
				}
			}
		}
	}
	
	// I
	return 0 ;
}

// PrVbgGtFNgPt[
extern s8 MoveKvnShotEffect( EFFECT *Effect )
{
	KVNSHOTEFFECT *kv = ( KVNSHOTEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// Ď
	{
		s32 i, j ;
		
		for( i = 0 ; i < 2 ; i ++ )
		{
			for( j = 0 ; j < KVN_KNIFE_NUM ; j ++ )
			{
				if( CheckEffectValidState( kv->effect[i][j], kv->effectID[i][j] ) == TRUE )
					break ;
			}
		}
		
		if( i != 2 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	
	// I
	return 0 ;
}

// PrVbgGtFNg`悷
extern s8 DrawKvnShotEffect( EFFECT *Effect )
{
	KVNSHOTEFFECT *kv = ( KVNSHOTEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}



