///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDamageBlood
//
// YK7EffectDamageBlood.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/05/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectDamageBlood.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

static DAMAGEBLOODUNION DBUnion ;
extern LINEUNION LUnion ;


// function proto type --------------------------

// function code --------------------------------

// _[W򖗃GtFNg̋ʃf[^
extern s8 InitDamageBloodData( void )
{
	MEMINIT(DBUnion) ;

	// I
	return 0 ;
}

// _[W򖗃GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDamageBloodData( void )
{
	return TRUE ;
}


// _[W򖗃GtFNg̋ʃf[^n
extern s8 EndDamageBloodData( void )
{
	MEMINIT(DBUnion) ;

	// I
	return 0 ;
}




// _[W򖗃GtFNg쐬
extern EFFECT *CreateDamageBloodEffect( s32 LineNum, Vec Point,
										f32 MaxSpeed, f32 MinSpeed,
										f32 MaxLength, f32 MinLength,
										f32 MaxLengthSpeed, f32 MinLengthSpeed,
										u8 LineWidth, GXColor Color, s32 Priority )
{
	EFFECT *Effect ;
	DAMAGEBLOODEFFECT *DmP ;
	DAMAGEBLOODOBJECT *DmObj ;
	u32 i ;

	// eNX`ǂݍ܂ĂȂ牽I
	if( CheckLineData() == FALSE ) return 0 ;

	// IuWFNgۑ邽߂̃̈̊m
	if( ( DmObj = ( DAMAGEBLOODOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( DAMAGEBLOODOBJECT ) * LineNum ), "Y_DmgObj" ) ) == NULL ) return NULL ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_DMGBLOOD, (void**)&DmP, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( DmObj ) ;
		return NULL ;
	}

	// p[^ۑE
	DmP->ObjNum = LineNum ;
	DmP->EndObjNum = 0 ;
	DmP->Obj = DmObj ;
	DmP->LineWidth = LineWidth ;
	DmP->Point = Point ;

	// CIuWFNg̒l
	for( i = 0 ; i < LineNum ; i ++, DmObj ++ )
	{
		DmObj->Length = rand() * ( MaxLength - MinLength ) / RAND_MAX + MinLength ;
		DmObj->Rot = rand() * PI_2 / RAND_MAX ;
		DmObj->Color = Color ;
		DmObj->Point = 0.0F ;
		DmObj->Mode = 0 ;
		DmObj->LengthParam = 0.0F ;
		DmObj->Speed = rand() * ( MaxSpeed - MinSpeed ) / RAND_MAX + MinSpeed ;
		DmObj->LengthSpeed = rand() * ( MaxLengthSpeed - MinLengthSpeed ) / RAND_MAX + MinLengthSpeed ;
		DmObj->EndFlag = FALSE ;
	}

	// I
	return Effect ;
}

// _[W򖗃GtFNǧns
extern s8 ReleaseDamageBloodEffect( EFFECT *Effect )
{
	DAMAGEBLOODEFFECT *DmP = ( DAMAGEBLOODEFFECT * )Effect->Data ;

	// CIuWFNgi[pɊmۂĂ̈̊J
	if( DmP->Obj != NULL ) CHKMEMFREE2( DmP->Obj ) ;
	DmP->Obj = NULL ;

	// I
	return 0 ;
}

// _[W򖗃GtFNgPt[
extern s8 MoveDamageBloodEffect( EFFECT *Effect )
{
	DAMAGEBLOODEFFECT *Dm = ( DAMAGEBLOODEFFECT * )Effect->Data ;
	DAMAGEBLOODOBJECT *Obj ;
	u32 i ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ璼ɍ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴIuWFNg̏IGtFNg폜
	if( Dm->EndObjNum == Dm->ObjNum )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// ׂẴCIuWFNg
	Obj = Dm->Obj ;
	for( i = 0 ; i < Dm->ObjNum ; i ++, Obj ++ )
	{
		if( Obj->EndFlag == FALSE )
		{
			// 폜ĂȂ
			
			// ʒuړ
			Obj->Point += Obj->Speed ;
			
			// [hɂď𕪊
			if( Obj->Mode == 0 )
			{
				// n_̎͐Lт
				Obj->LengthParam += Obj->LengthSpeed ;
				
				// Lтn_̈ʒuύX
				if( Obj->LengthParam >= 1.0F )
				{
					Obj->LengthParam = 1.0F ;
					Obj->Mode = 1 ;
					Obj->Point += Obj->Length ;
				}
			}
			else
			{
				// On_̎͏k
				Obj->LengthParam -= Obj->LengthSpeed ;
				
				// k݂珈IƂƂȂ̂
				// ItO𗧂āAIIuWFNg̐CNg
				if( Obj->LengthParam < 0.0F )
				{
					Obj->EndFlag = TRUE ;
					Dm->EndObjNum ++ ;
				}
			}
		}
	}

	// I
	return 0 ;
}

// _[W򖗃GtFNg`悷
extern s8 DrawDamageBloodEffect( EFFECT *Effect )
{
	DAMAGEBLOODEFFECT *Dm = ( DAMAGEBLOODEFFECT * )Effect->Data ;
	DAMAGEBLOODOBJECT *Obj ;
	u32 i ;
	Mtx tmtx ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;							// `̏

	// eNX`̃[h
	GTLOAD2( LUnion.TestTex ) ;

	// C̑Zbg
	{
		f32 Width ;
//		Vec CamPoint ;
//		f32 Length ;
		u32 Width2 ;
		
		// oCAXlZo
		{
//			HSD_CObjGetEyePosition( Camera, &CamPoint ) ;
//			Length = VECDistance( &CamPoint, &Dm->Point ) ;
			
//			Width = 1.0F / Length ;
			
			Width = GetScreenSize( &Dm->Point, Dm->LineWidth * 0.05F ) ;
		}
		
//		Width2 = (u32)( Dm->LineWidth * 50.0F * Width ) ;
		Width2 = (u32)Width ;
		if( Width2 < 4 ) Width2 = 4 ;
		if( Width2 > 255 ) Width2 = 255 ;
	
		GXSetLineWidth( (u8)Width2/*Dm->LineWidth*/, GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
	}

	// ]ns̍쐬
	EffectGetInvViewMatrix( tmtx ) ;

	// `揈	
	GBGN( GX_LINES, ( Dm->ObjNum - Dm->EndObjNum ) * 2 ) ;
	
	// IuWFNg̐JԂ
	Obj = Dm->Obj ;
	for( i = 0 ; i < Dm->ObjNum ; i ++, Obj ++ )
	{
		if( Obj->EndFlag == FALSE )
		{
			Vec V1, V2, V ;

			V.x = sinf( Obj->Rot ) ;
			V.y = cosf( Obj->Rot ) ;
			V.z = 0.0F ;

			// [hɂď𕪊
			if( Obj->Mode == 0 )
			{
				VECScale( &V, &V1, Obj->Point ) ;
				VECScale( &V, &V2, Obj->Point + Obj->Length * Obj->LengthParam ) ;
			}
			else
			{
				VECScale( &V, &V1, Obj->Point - Obj->Length * Obj->LengthParam ) ;
				VECScale( &V, &V2, Obj->Point ) ;
			}

			MTXMultVec( tmtx, &V1, &V1 ) ;
			MTXMultVec( tmtx, &V2, &V2 ) ;

			GP3( V1.x + Dm->Point.x, V1.y + Dm->Point.y, V1.z + Dm->Point.z ) ;
			GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, 255 ) ;
			GT( 0, 0 ) ;

			GP3( V2.x + Dm->Point.x, V2.y + Dm->Point.y, V2.z + Dm->Point.z ) ;
			GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, 255 ) ;
			GT( 0, 1.0F ) ;
		}
	}
	GXEnd() ;

	// I
	return 0 ;
}


static const u16 __DmgBldT[][11] =
{
	// 1:F~Xqbg
	{
		124,	88,	23,	9,	10,
		963,	367,	12,	255,	169,
		167,
	},
	
	// 2:Fqbg
	{
		124,	88,	23,	43,	10,
		963,	367,	12,	255,	119,
		38,
	},
	
	// 3:F_[Wqbg
	{
		124,	18,	20,	38,	10,
		150,	127,	12,	255,	0,
		0,
	},

	// 4:FŌ̃qbg
	{
		325,	39,	20,	85,	10,
		150,	127,	17,	255,	0,
		0,
	},
	
	// 5:F_[Wqbg
	{
		100,	75,	9,	11,	7,
		348,	237,	12,	255,	37,
		0,
	},

	// 6:PrFqbg
	{
		62,	70,	41,	25,	6,
		571,	267,	12,	255,	248,
		251,
	},

} ;

// ȈՔ
extern EFFECT *CreateDamageBloodEffect( u8 Type, Vec Pos, u32 *Color )
{
	GXColor Cr ;
	EFFECT *effect ;

	if( Type == 0 )
	{	
		*((u32 *)&Cr) = CMK( VParam[ED_DMGBLOOD][8], VParam[ED_DMGBLOOD][9], VParam[ED_DMGBLOOD][10], 255 ) ;
		effect = CreateDamageBloodEffect(
								(s32)VParam[ED_DMGBLOOD][0], Pos,
								VParam[ED_DMGBLOOD][1] * 0.01F, VParam[ED_DMGBLOOD][2] * 0.01F,
								VParam[ED_DMGBLOOD][3] * 0.1F, VParam[ED_DMGBLOOD][4] * 0.1F,
								VParam[ED_DMGBLOOD][5] * 0.001F, VParam[ED_DMGBLOOD][6] * 0.001F,
								(u8)VParam[ED_DMGBLOOD][7], Cr ) ;
								
#ifdef YAMADADEBUG
#if 1
		OSReport( "	{\n" ) ;
		OSReport( "		%d,	%d,	%d,	%d,	%d,\n", VParam[ED_DMGBLOOD][0], VParam[ED_DMGBLOOD][1], VParam[ED_DMGBLOOD][2], VParam[ED_DMGBLOOD][3], VParam[ED_DMGBLOOD][4] ) ;
		OSReport( "		%d,	%d,	%d,	%d,	%d,\n", VParam[ED_DMGBLOOD][5], VParam[ED_DMGBLOOD][6], VParam[ED_DMGBLOOD][7], VParam[ED_DMGBLOOD][8], VParam[ED_DMGBLOOD][9] ) ;
		OSReport( "		%d,\n", VParam[ED_DMGBLOOD][10] ) ;
		OSReport( "	},\n" ) ;
#endif
#endif
		return effect ;
	}
	else
	{
		Type -= 1 ;
	
		*((u32 *)&Cr) = Color != NULL ? *Color : CMK( __DmgBldT[Type][8], __DmgBldT[Type][9], __DmgBldT[Type][10], 255 ) ;
		return CreateDamageBloodEffect( 	
									(s32)__DmgBldT[Type][0],	// s32 LineNum
									Pos,						// Pos
									__DmgBldT[Type][1] * 0.01F,	__DmgBldT[Type][2] * 0.01F,		// MaxSpeed, MinSpeed
									__DmgBldT[Type][3] * 0.1F, 	__DmgBldT[Type][4] * 0.1F,		// MaxLength, MinLength
									__DmgBldT[Type][5] * 0.001F, __DmgBldT[Type][6] * 0.001F,	// MaxLengthSpeed, MinLenthSpeed
									(u8)__DmgBldT[Type][7],		// LineWidth
									Cr							// Color
									) ;			
	}
	
	return NULL ;
}




