///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDraft
//
// YK7EffectDraft.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectDraft.h"
#include "./YK7EffectLine.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

DRAFTUNION DraUnion ;
extern LINEUNION LUnion ;

// function proto type --------------------------

s8 DraftTexLoadCheck( void ) ;				// [hǂ𒲂ׂ
s8 DraftCallBack( Vec **Pos, void *Data ) ;		// R[obN

// function code --------------------------------

// R[obN
s8 DraftCallBack( Vec **Pos, void *Data )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Data ;
	DRAFTOBJECT *Obj ;
	Vec d1, d2 ;
	f32 Area, x, y ;
	s32 i ;
	
	// ʐς𓾂
	Area = GetPolygonArea( Pos ) ;

	// ʐςm𓱂邩ǂ肷
	if( Area / Dr->MeshArea >= (f32)rand() / RAND_MAX )
	{
		// 
		for( Obj = Dr->ObjP ; Obj->UseFlag == TRUE ; Obj ++ ){}
		Obj->UseFlag = TRUE ;

		// WZo
		{
			d1.x = Pos[1]->x - Pos[0]->x ;	d1.y = Pos[1]->y - Pos[0]->y ;	d1.z = Pos[1]->z - Pos[0]->z ;
			d2.x = Pos[2]->x - Pos[0]->x ;	d2.y = Pos[2]->y - Pos[0]->y ;	d2.z = Pos[2]->z - Pos[0]->z ;
		
			x = (f32)rand() / RAND_MAX ;
			y = ( 1.0F - x ) * rand() / RAND_MAX ;

			Obj->Pos[0].x = x * d1.x + y * d2.x + Pos[0]->x ;
			Obj->Pos[0].y = x * d1.y + y * d2.y + Pos[0]->y ;
			Obj->Pos[0].z = x * d1.z + y * d2.z + Pos[0]->z ;
			
			for( i = 1 ; i < DFOBJ_BACKPOSNUM ; i ++ ) Obj->Pos[i] = Obj->Pos[0] ;
		}
		
		// ړZo
		{
			// |Š擾
			PSVECCrossProduct( &d2, &d1, &Obj->Dir ) ;
			if( Obj->Dir.x + Obj->Dir.y + Obj->Dir.z == 0.0F ) Obj->Dir.y = 1.0F ;
			PSVECNormalize( &Obj->Dir, &Obj->Dir ) ;
		}
		
		// ωړZo
		{
			PSVECSubtract( &Obj->Pos[0], &Dr->CenterPos, &Obj->DDir ) ;
			if( Obj->DDir.x + Obj->DDir.y + Obj->DDir.z != 0.0F )
				PSVECNormalize( &Obj->DDir, &Obj->DDir ) ;
		}
		
		// ̑̏
		Obj->a = (f32)VParam[ED_DRAFT][8] / 255.0F ;
		Obj->Color = (GXColor){255,255,255,255} ;
		Obj->DirT = Dr->InitDirT ;
		Obj->HokoriFlag = (f32)rand() / RAND_MAX < VParam[ED_DRAFT][27] * 0.01F ;

		// IuWFNg̐CNg
		Dr->ObjNum ++ ;

		// I		
		return -1 ;
	}

	// I
	return 0 ;
}
	
	


// [hǂ𒲂ׂ
s8 DraftTexLoadCheck( void )
{
	// I
	return TRUE ;
}



// ԕGtFNg̋ʃf[^
extern s8 InitDraftData( void )
{
	MEMINIT( DraUnion ) ;
	
	// I
	return 0 ;
}

// ԕGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDraftData( void )
{
	return TRUE ;
}



// ԕGtFNg̋ʃf[^n
extern s8 EndDraftData( void )
{
	MEMINIT( DraUnion ) ;
	
	// I
	return 0 ;
}


// ԕ̃GtFNg쐬
extern EFFECT *CreateDraftEffect( WK7JObj *DraftMesh, s32 ObjMaxNum,
									f32 Speed, f32 FadeSp, f32 InitDirT, s32 Priority )
{
	DRAFTEFFECT *Dr ;
	EFFECT *Effect = NULL ;
	DRAFTOBJECT *Obj = NULL ;
	MESH *Mesh = NULL ;
	BASICMESH *BasM = NULL ;
	HSD_JObj *JObj ;
	HSD_DObj *dobj ;
	
	// IuWFNgp̃̊m
	Obj = ( DRAFTOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( DRAFTOBJECT ) * ObjMaxNum ), "Y_DRAFOBJ" ) ;
	if( Obj == NULL ) goto ER ;
	memset( Obj, 0, sizeof( DRAFTOBJECT ) * ObjMaxNum ) ;
	
	// bV̍쐬
	JObj = DraftMesh->GetJObj() ;
	dobj = GetHaveMeshDObj( JObj ) ;
	if( CreatePrimitiveMeshData( JObj, dobj, dobj->pobj, &Mesh, FALSE, TRUE, FALSE, FALSE, TRUE ) < 0 ) goto ER ;
	if( CreateBasicPrimitiveMeshData( Mesh, &BasM, TRUE, FALSE, TRUE, FALSE ) < 0 ) goto ER ;
	DeletePrimitiveMeshData( Mesh ) ;
	Mesh = NULL ;

	// Vԕf[^쐬
	Effect = AddEffectData( EFF_DRAFT, (void**)&Dr, Priority ) ;
	if( Effect == NULL ) goto ER ;
	memset( Dr, 0, sizeof( DRAFTEFFECT ) ) ;

	// ԕf[^
	Dr->ObjP = Obj ;
	Dr->ObjNum = 0 ;
	Dr->ObjMaxNum = ObjMaxNum ;
	Dr->OneCreateCount = (f32)VParam[ED_DRAFT][0] / Speed * 0.001F ;
	Dr->CreateCounter = 0.0F ;
	Dr->Mesh = BasM ;
	Dr->CenterPos.x = JObj->mtx[0][3] ;
	Dr->CenterPos.y = JObj->mtx[1][3] ;
	Dr->CenterPos.z = JObj->mtx[2][3] ;
	Dr->Speed = ( Speed < 0 ) ? VParam[ED_DRAFT][9] * 0.1F : Speed ;
	Dr->MeshArea = GetBasicMeshPolygonArea( BasM ) ;
	Dr->InitDirT = ( InitDirT < 0 ) ? VParam[ED_DRAFT][5] * 0.01F : InitDirT ;
	Dr->FadeSp = ( FadeSp < 0 ) ? (f32)VParam[ED_DRAFT][4] / 255.0F : FadeSp ;

	// I
	return Effect ;

ER :
	if( Obj != NULL ) K7AppSmallMemFree( Obj ) ;
	if( Mesh != NULL ) DeletePrimitiveMeshData( Mesh ) ;
	if( BasM != NULL ) DeleteBasicMeshData( BasM ) ;
	if( Effect != NULL ) DeleteEffect( Effect ) ;
	
	return NULL ;
}

// ԕ̃GtFNǧns
extern s8 ReleaseDraftEffect( EFFECT *Effect )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;

	if( Dr->ObjP != NULL ) K7AppSmallMemFree( Dr->ObjP ) ;
	if( Dr->Mesh != NULL ) DeleteBasicMeshData( Dr->Mesh ) ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ԕ̃GtFNgPt[
extern s8 MoveDraftEffect( EFFECT *Effect )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;
	DRAFTOBJECT *Obj ;
	s32 i, j, Num ;

	if( (DRAFTEFFECT *)NULL == Dr ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( DraftTexLoadCheck() == FALSE ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && Dr->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	for( j = 0 ; j < VParam[ED_DRAFT][11] ; j ++ )
	{
		// ړ
		{
			Vec mov ;
		
			Obj = Dr->ObjP ;
			Num = Dr->ObjNum ;
			for( i = 0 ; i < Num ; Obj ++ )
			{
				if( Obj->UseFlag == TRUE )
				{
					i ++ ;
					
					// Ẅړ
					memmove( &Obj->Pos[1], &Obj->Pos[0], sizeof( Vec ) * ( DFOBJ_BACKPOSNUM - 1 ) ) ;
					
					// ړ
					if( Obj->HokoriFlag == FALSE )
					{
						mov.x = ( ( 1.0F - Obj->DirT ) * Obj->Dir.x + Obj->DirT * Obj->DDir.x ) * Dr->Speed ;
						mov.y = ( ( 1.0F - Obj->DirT ) * Obj->Dir.y + Obj->DirT * Obj->DDir.y ) * Dr->Speed ;
						mov.z = ( ( 1.0F - Obj->DirT ) * Obj->Dir.z + Obj->DirT * Obj->DDir.z ) * Dr->Speed ;
					}
					else
					{
						mov.x = ( ( 1.0F - Obj->DirT ) * Obj->Dir.x + Obj->DirT * Obj->DDir.x ) * Dr->Speed * ( VParam[ED_DRAFT][29] * 0.01F ) ;
						mov.y = ( ( 1.0F - Obj->DirT ) * Obj->Dir.y + Obj->DirT * Obj->DDir.y ) * Dr->Speed * ( VParam[ED_DRAFT][29] * 0.01F ) ;
						mov.z = ( ( 1.0F - Obj->DirT ) * Obj->Dir.z + Obj->DirT * Obj->DDir.z ) * Dr->Speed * ( VParam[ED_DRAFT][29] * 0.01F ) ;
					}
					Obj->Pos[0].x += mov.x ; Obj->Pos[0].y += mov.y ; Obj->Pos[0].z += mov.z ;
					
					// Ԑ
					Obj->DirT += Dr->Speed * VParam[ED_DRAFT][1] * 0.001F ;
	/*				if( Obj->DirT >= 1.0F )
					{
						Obj->UseFlag = FALSE ;
						Dr->ObjNum -- ;
					}
	*/
					Obj->a -= Dr->FadeSp ;
					if( Obj->a < 0.0F )
					{
						Obj->UseFlag = FALSE ;
						Dr->ObjNum -- ;
					}
				}
			}
		}
		
		// JE^߂
		if( Effect->DelReqFlag == FALSE )
		{
			Dr->CreateCounter += 1.0F ;
		
			// 
			while( Dr->CreateCounter > Dr->OneCreateCount && Dr->ObjNum != Dr->ObjMaxNum )
			{
				Dr->CreateCounter -= Dr->OneCreateCount ;
				
				// R[obNĂ
				ScanMeshPrimitive( Dr->Mesh, DraftCallBack, Dr )  ;
			}
		}
	}

	// I
	return 0 ;
}

// ԕ̃GtFNg`悷
extern s8 DrawDraftEffect( EFFECT *Effect )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;
	DRAFTOBJECT *Obj ;
	s32 i, j, Num ;
	Vec d ;

	if( (DRAFTEFFECT *)NULL == Dr ) return 0 ;
	if( DraftTexLoadCheck() == FALSE ) return 0 ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	// eNX`̃[h
	GTLOAD2( LUnion.TestTex ) ;
	
	// C̑Zbg
	GXSetLineWidth( (u8)VParam[ED_DRAFT][7], GX_TO_ONE ) ;
	GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;

	// `
//	GXBegin( GX_LINES, GX_VTXFMT0, (u16)( Dr->ObjNum * ( ( DFOBJ_BACKPOSNUM - 1 ) * 2 ) ) ) ;
	GXBegin( GX_LINES, GX_VTXFMT0, (u16)( Dr->ObjNum * ( ( ( VParam[ED_DRAFT][10] + 1 ) - 1 ) * 2 ) ) ) ;
	{
		Obj = Dr->ObjP ;
		Num = Dr->ObjNum ;
		for( i = 0 ; i < Num ; Obj ++ )
		{
			if( Obj->UseFlag == TRUE )
			{
				i ++ ;

				if( Obj->HokoriFlag == FALSE )
				{
					GP3( Obj->Pos[0].x, Obj->Pos[0].y, Obj->Pos[0].z ) ;
					GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
					GT( 0, 0 ) ;

					GP3( Obj->Pos[1].x, Obj->Pos[1].y, Obj->Pos[1].z ) ;
					GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
					GT( 0, 0.5F ) ;
						
					for( j = 1 ; j < ( VParam[ED_DRAFT][10] + 1 ) - 1 - 1 ; j ++ )
					{
						GP3( Obj->Pos[j].x, Obj->Pos[j].y, Obj->Pos[j].z ) ;
						GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
						GT( 0, 0.5F ) ;

						GP3( Obj->Pos[j+1].x, Obj->Pos[j+1].y, Obj->Pos[j+1].z ) ;
						GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
						GT( 0, 0.5F ) ;
					}
					
					GP3( Obj->Pos[j].x, Obj->Pos[j].y, Obj->Pos[j].z ) ;
					GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
					GT( 0, 0.5F ) ;

					GP3( Obj->Pos[j+1].x, Obj->Pos[j+1].y, Obj->Pos[j+1].z ) ;
					GC4( Obj->Color.r, Obj->Color.g, Obj->Color.b, (u8)( Obj->a * 255 ) ) ;
					GT( 0, 1.0F ) ;
				}
				else
				{
					VECSubtract( &Obj->Pos[0], &Obj->Pos[1], &d ) ;
					if( d.x + d.y + d.z == 0.0F ) d.x = 1.0F ; else VECNormalize( &d, &d ) ;
					VECScale( &d, &d, VParam[ED_DRAFT][28] * 0.01F ) ;
					
					for( j = 1 ; j < ( VParam[ED_DRAFT][10] + 1 ) ; j ++ )
					{
						GP3( Obj->Pos[0].x, Obj->Pos[0].y, Obj->Pos[0].z ) ;
						GC4( (u8)VParam[ED_DRAFT][12], (u8)VParam[ED_DRAFT][13], (u8)VParam[ED_DRAFT][14], (u8)( 255 ) ) ;
						GT( 0, 0 ) ;

						GP3( Obj->Pos[0].x + d.x, Obj->Pos[0].y + d.y, Obj->Pos[0].z + d.z ) ;
						GC4( (u8)VParam[ED_DRAFT][12], (u8)VParam[ED_DRAFT][13], (u8)VParam[ED_DRAFT][14], (u8)( 255 ) ) ;
						GT( 0, 1.0F ) ;
					}
				}
			}
		}
	}
	GXEnd() ;

	// I
	return 0 ;
}


// ԕ̍쐬Xs[hύX
extern s8 SetDraftEffectCreateSpeed( EFFECT *Effect, f32 CreSpeed )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;

	Dr->OneCreateCount = (f32)VParam[ED_DRAFT][0] / CreSpeed * 0.001F ;

	// I
	return 0 ;
}

// ԕ̃Xs[hύX
extern s8 SetDraftEffectSpeed( EFFECT *Effect, f32 Speed )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;

	Dr->Speed = Speed ;

	// I
	return 0 ;
}

// ԕ̃tF[hAEg̑xύX
extern s8 SetDraftEffectFadeSp( EFFECT *Effect, f32 FadeSp )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;

	Dr->FadeSp = FadeSp ;

	// I
	return 0 ;
}

// ԕ̏pxύX
extern s8 SetDraftEffectInitDirT( EFFECT *Effect, f32 InitDirT )
{
	DRAFTEFFECT *Dr = ( DRAFTEFFECT * )Effect->Data ;

	Dr->InitDirT = InitDirT ;

	// I
	return 0 ;
}






// ԕ2GtFNg̋ʃf[^
extern s8 InitDraft2Data( void )
{
	// I
	return 0 ;
}

// ԕ2GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDraft2Data( void )
{
	return TRUE ;
}



// ԕ2GtFNg̋ʃf[^n
extern s8 EndDraft2Data( void )
{
	// I
	return 0 ;
}


// ԕ2̃GtFNg쐬
extern EFFECT *CreateDraft2Effect( WK7JObj *DraftMesh, s32 ObjMaxNum, s32 Priority )
{
	DRAFT2EFFECT *Dr ;
	EFFECT *Effect = NULL, *Draft = NULL ;
	
	// ԕGtFNg쐬
	Draft = CreateDraftEffect( DraftMesh, ObjMaxNum ) ;
	if( Draft == NULL ) goto ER ;

	// Vԕ2f[^쐬
	Effect = AddEffectData( EFF_DRAFT2, (void**)&Dr, Priority ) ;
	if( Effect == NULL ) goto ER ;
	memset( Dr, 0, sizeof( DRAFT2EFFECT ) ) ;
	
	// f[^
	Dr->Draft = Draft ;
	Dr->DraftID = GetEffectID( Draft ) ;
	Dr->Counter = 1 ;
	Dr->t = 1.0F ;
	
	Dr->InitDirt = 1.0F ;
	Dr->InitDirCounter = 0 ;
	
	Dr->NextCreateSp = VParam[ED_DRAFT][15] * 0.01F ;
	Dr->NextInitDir = VParam[ED_DRAFT][17] * 0.01F ;
	Dr->NextSpeed = VParam[ED_DRAFT][19] * 0.1F ;
	MoveDraft2Effect( Effect ) ;

	// I
	return Effect ;

ER :
	if( Draft != NULL ) DeleteEffect( Draft ) ;
	
	return NULL ;
}

// ԕ2̃GtFNǧns
extern s8 ReleaseDraft2Effect( EFFECT *Effect )
{
	DRAFT2EFFECT *Dr = ( DRAFT2EFFECT * )Effect->Data ;

	if( Dr->Draft != NULL && CheckEffectValidState( Dr->Draft, Dr->DraftID ) == TRUE )
	{
		DeleteEffect( Dr->Draft ) ;
		return 0 ;
	}

	// I
	return 0 ;
}

// ԕ2̃GtFNgPt[
extern s8 MoveDraft2Effect( EFFECT *Effect )
{
	DRAFT2EFFECT *Dr = ( DRAFT2EFFECT * )Effect->Data ;

	if( (DRAFT2EFFECT *)NULL == Dr ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( CheckDraft2Data() == FALSE ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && CheckEffectValidState( Dr->Draft, Dr->DraftID ) == FALSE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	if( Dr->InitDirt == 1.0F )
	{
		Dr->InitDirCounter -- ;
		if( Dr->InitDirCounter <= 0 )
		{
			Dr->NowInitDir = Dr->NextInitDir ;
			Dr->NextInitDir = ( rand() * ( VParam[ED_DRAFT][17] - VParam[ED_DRAFT][18] ) / RAND_MAX + VParam[ED_DRAFT][18] ) * 0.01F ;

			Dr->InitDirt = 0.0F ;
			Dr->InitDirCounter = rand() * ( VParam[ED_DRAFT][24] - VParam[ED_DRAFT][25] ) / RAND_MAX + VParam[ED_DRAFT][25]  ;
		}
	}
	Dr->InitDirt += VParam[ED_DRAFT][26] * 0.01F ;
	if( Dr->InitDirt > 1.0F ) Dr->InitDirt = 1.0F ;

	if( Dr->t == 1.0F )
	{
		Dr->Counter -- ;
		if( Dr->Counter <= 0 )
		{
			Dr->NowCreateSp = Dr->NextCreateSp ;
			Dr->NowSpeed = Dr->NextSpeed ;
			
			Dr->NextCreateSp = ( rand() * ( VParam[ED_DRAFT][15] - VParam[ED_DRAFT][16] ) / RAND_MAX + VParam[ED_DRAFT][16] ) * 0.01F ;
			Dr->NextSpeed = ( rand() * ( VParam[ED_DRAFT][19] - VParam[ED_DRAFT][20] ) / RAND_MAX + VParam[ED_DRAFT][20] ) * 0.1F ;
			
			Dr->t = 0.0F ;
			Dr->Counter = rand() * ( VParam[ED_DRAFT][21] - VParam[ED_DRAFT][22] ) / RAND_MAX + VParam[ED_DRAFT][22]  ;
		}
	}
	Dr->t += VParam[ED_DRAFT][23] * 0.01F ;
	if( Dr->t > 1.0F ) Dr->t = 1.0F ;

	SetDraftEffectCreateSpeed( Dr->Draft, ( 1.0F - Dr->t ) * Dr->NowCreateSp + Dr->t * Dr->NextCreateSp ) ;
	SetDraftEffectSpeed( Dr->Draft, ( 1.0F - Dr->t ) * Dr->NowSpeed + Dr->t * Dr->NextSpeed  ) ;
	SetDraftEffectInitDirT( Dr->Draft, ( 1.0F - Dr->t ) * Dr->NowInitDir + Dr->t * Dr->NextInitDir ) ;
	
	// I
	return 0 ;
}

// ԕ2̃GtFNg`悷
extern s8 DrawDraft2Effect( EFFECT *Effect )
{
	DRAFT2EFFECT *Dr = ( DRAFT2EFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}


// 폜NGXgs
extern s8 DelReqDraft2Effect( EFFECT *Effect )
{
	DRAFT2EFFECT *Dr = ( DRAFT2EFFECT * )Effect->Data ;

	DelReqEffect( Dr->Draft ) ;
//	Effect->DelReqFlag = TRUE ;
	
	// I
	return 0 ;
}
