///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectDropWater
//
// YK7EffectDropWater.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/10/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectDropWater.h"
#include "./YK7EffectEasyAnim.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

DROPWATERUNION DwUnion ;

// function proto type --------------------------

// function code --------------------------------

// HGtFNg̋ʃf[^
extern s8 InitDropWaterData( void )
{
	MEMINIT( DwUnion ) ;
	
	// HƔg̃Aj[Vǂݍ
	LoadEasyAnimPack( ANIMID_DROPWATER ) ;
	LoadEasyAnimPack( ANIMID_DROPWATER2 ) ;
	
	// I
	return 0 ;
}

// HGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckDropWaterData( void )
{
	// Hƒ˂H̃Aj[Vf[^܂ǂݏIĖ牽ɏI
	if( CheckEasyAnimPackLoadState( ANIMID_DROPWATER ) == FALSE ||
		CheckEasyAnimPackLoadState( ANIMID_DROPWATER2 ) == FALSE ) return FALSE ;

	return TRUE ;
}

// HGtFNg̋ʃf[^n
extern s8 EndDropWaterData( void )
{
	// 
	ReleaseEasyAnimData( ANIMID_DROPWATER ) ;
	ReleaseEasyAnimData( ANIMID_DROPWATER2 ) ;

	// [
	MEMINIT( DwUnion ) ;

	// I
	return 0 ;
}

// HGtFNg쐬
extern EFFECT *CreateDropWaterEffect( Vec CreatePoint, f32 YukaY,
										s16 CreateWaitTime, s16 CreateWaitRange,
										f32 DropSpeed, s32 Priority )
{
	EFFECT *Effect ;
	DROPWATEREFFECT *Dp ;

	// VHf[^쐬
	Effect = AddEffectData( EFF_DROPWATER, (void**)&Dp, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// f[^̏
	Dp->CreatePoint = CreatePoint ;
	Dp->DropSpeed = DropSpeed < 0.0F ? VParam[ED_DROPWATER][2] * 0.01F : DropSpeed ;
	Dp->YukaY = YukaY ;
	Dp->CreateWaitTime = CreateWaitTime < 0 ? (s16)VParam[ED_DROPWATER][0] : CreateWaitTime ;
	Dp->CreateWaitRange = CreateWaitRange < 0 ? (s16)VParam[ED_DROPWATER][1] : CreateWaitRange ;
	Dp->CreateWait = 0 ;

	Dp->WaterValidFlag = FALSE ;
	Dp->RippleValidFlag = FALSE ;
	Dp->FastDeleteFlag = FALSE ;
	Dp->DropAnim = NULL ;
	Dp->RippleAnim = NULL ;

	// I
	return Effect ;
}

// H̃GtFNǧns
extern s8 ReleaseDropWaterEffect( EFFECT *Effect )
{
	DROPWATEREFFECT *Dp = ( DROPWATEREFFECT * )Effect->Data ;
	
	// GtFNg폜ĂȂ폜
	if( Dp->WaterValidFlag == TRUE && CheckEffectValidState( Dp->DropAnim, Dp->DropID ) == TRUE )
	{
		DeleteEffect( Dp->DropAnim ) ;
	}
	if( Dp->RippleValidFlag == TRUE && CheckEffectValidState( Dp->RippleAnim, Dp->RippleID ) == TRUE  )
	{
		DeleteEffect( Dp->RippleAnim ) ;
	}
	
	// I
	return 0 ;
}

// H̃GtFNgPt[
extern s8 MoveDropWaterEffect( EFFECT *Effect )
{
	DROPWATEREFFECT *Dp = ( DROPWATEREFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂĐHA
	// ͑폜tOĂ폜
	if( ( Effect->DelReqFlag == TRUE && Dp->WaterValidFlag == FALSE && Dp->RippleValidFlag == FALSE ) ||
		( Dp->FastDeleteFlag == TRUE ) )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// Hƒ˂H̃Aj[Vf[^܂ǂݏIĖ牽ɏI
	if( CheckDropWaterData() == FALSE ) return 0 ;
		
	// g䂪Ăꍇ͔g䂪Î҂
	if( Dp->RippleValidFlag == TRUE )
	{
		if( CheckEffectValidState( Dp->RippleAnim, Dp->RippleID ) == FALSE )
		{
			// tO|
			Dp->RippleValidFlag = FALSE ;
			Dp->RippleAnim = NULL ;
		}
	}
			
	// HoĂȂJE^
	if( Dp->WaterValidFlag == FALSE )
	{
		// ҂ԂOȉɂȂ琅HV쐬
		if( Dp->RippleValidFlag == FALSE ) Dp->CreateWait -- ;
		if( Dp->CreateWait <= 0 )
		{
			Vec Size ;
			
			Size.y = Size.x = VParam[ED_DROPWATER][3] * 0.01F ;
			Size.z = 0.0F ;
		
			// VHAj[VGtFNg쐬
			Dp->DropAnim = CreateEasyAnimEffect2( ANIMID_DROPWATER, Dp->CreatePoint, Size,
													FALSE, -1, FALSE ) ;
			if( Dp->DropAnim != NULL )
			{
				Dp->WaterValidFlag = TRUE ;
				Dp->DropID = Dp->DropAnim->ID ;
				
				Dp->Point = Dp->CreatePoint ;
				Dp->SpeedY = 0.0F ;
			}
		}
	}
	else
	{
		// HoĂꍇ͐H̍WύX
		Dp->Point.y += Dp->SpeedY ;
		Dp->SpeedY -= Dp->DropSpeed ;
		
		// WZbg
		SetEasyAnimPoint( Dp->DropAnim, Dp->Point ) ;
		
		
		// ɗĂg쐬
		if( Dp->Point.y <= Dp->YukaY && Dp->RippleValidFlag == FALSE )
		{
			Vec Size ;
			
			// W␳
			Dp->Point.y = Dp->YukaY ;
		
			// HGtFNg͍폜
			DeleteEffect( Dp->DropAnim ) ;
			Dp->DropAnim = NULL ;
			Dp->WaterValidFlag = FALSE ;

			// ɍ쐬܂ł̎ԂZbg
			Dp->CreateWait = (s16)( Dp->CreateWaitTime + rand() * Dp->CreateWaitRange / RAND_MAX - Dp->CreateWaitRange / 2 ) ;
			
			// gAjGtFNg쐬
			Size.y = Size.x = VParam[ED_DROPWATER][4] * 0.01F ;
			Size.z = 0.0F ;
			Dp->Point.y += Size.y * 0.5F ;
			Dp->RippleAnim = CreateEasyAnimEffect2( ANIMID_DROPWATER2, Dp->Point, Size,
													FALSE, -1, TRUE ) ;
			if( Dp->RippleAnim != NULL )
			{
				Dp->RippleValidFlag = TRUE ;
				Dp->RippleID = Dp->RippleAnim->ID ;
				
				// rdF҂I
				static s16	pitchmin = -600;
				static s16	pitchmax =  400;
				s16		pitch = (s16)(HSD_Rand() % (pitchmax - pitchmin) + pitchmin);
				if( GetEffectSoundOffFlag() == FALSE ) PlayEffectSE3DP(SFX_SCE0_WATER_FALL,Dp->Point,pitch);
			}
		}
	}

	// I
	return 0 ;
}
			

// H̃GtFNg`悷
extern s8 DrawDropWaterEffect( EFFECT *Effect )
{
	DROPWATEREFFECT *Dp = ( DROPWATEREFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					



// 폜NGXgs
extern s8 FastDelReqDropWaterEffect( EFFECT *Effect )
{
	DROPWATEREFFECT *Dp = ( DROPWATEREFFECT * )Effect->Data ;

	// tO𗧂Ă	
	Dp->FastDeleteFlag = TRUE ;
	
	// I
	return 0 ;
}

	
// `tOZbg( TRUE:`  FALSE:` )
extern s8 SetDropWaterDrawFlag( EFFECT *Effect, s8 DrawFlag )
{
	DROPWATEREFFECT *Dp = ( DROPWATEREFFECT * )Effect->Data ;

	// tO̕ۑ
	Dp->DrawFlag = (s8)DrawFlag ;
	
	// I
	return 0 ;
}

