///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectElec
//
// YK7EffectElec.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/11/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectElec.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_ELEC]

#define TUBU_SIZE		(PRM[0] * 0.01F)
#define TUBU_AINUM		(PRM[6])
#define TUBU_COLOR		(CMK(PRM[2],PRM[3],PRM[4],PRM[5]))
#define TUBU_MAXSIZE	(PRM[9] * 0.1F)
#define TUBU_MINSIZE	(PRM[10] * 0.1F)

#define ONEDIVLEN		((f32)PRM[20] * 0.1F )
#define MAXROTRATE		((f32)PRM[18] / 360 * PI_2 )
#define MINROTRATE		((f32)PRM[18] / 360 * PI_2 )
#define MAXROTSP		(8)//((f32)PRM[16] / 360 * PI_2 )
#define MINROTSP		(2)//((f32)PRM[17] / 360 * PI_2 )
#define ROTNUM			(PRM[14])
#define ROTW			(PRM[15] * 0.1F)
#define BIAS			(PRM[13] * 0.01F)
#define DIVDIVMAXZ		(PRM[12] * 0.1F)
#define DIVDIVNUM		(PRM[11])
#define DIVNUM			(PRM[1])
#define BUREXYMAX		(PRM[7] * 0.01F)
#define BUREZMAX		(PRM[8] * 0.01F)

#define PDIVNUM			(PRM[22])
#define PMAXZURE		(PRM[21] * 0.1F)

// data -----------------------------------------

ELECUNION elu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// dGtFNg̋ʃf[^
extern s8 InitElecData( void )
{
	MEMINIT( elu ) ;

	return 0 ;
}

// dGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckElecData( void )
{
	return TRUE ;
}

// dGtFNg̋ʃf[^n
extern s8 EndElecData( void )
{
	MEMINIT( elu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// dGtFNg쐬
extern EFFECT *CreateElecEffect(
								Vec pos, Vec target,
								f32 onedivlen,						// ꕪ̍ő咷
								f32 maxwidth, f32 minwidth,			// őEŏ̑
								f32 biaswidth,						// ̕
								s32 billnum,						// ԉ摜̐
								u32 color,							// F
								f32 burewidthbig, f32 burewidthsmall,	// 傫ȂԂ̃TCYƏȂԂ̃TCY
								s32 divnum,							// ꕪԂԂ镪
								s32 div2num,						// 򃉃C̒_
								f32 div2addz,						// 򃉃C̈꒸_ӂ̑Oi
								s32 blendmode,						// uh[h
								bool endPosLockFlag,				// Ō̒_Œɂ邩ǂ̃tO
								bool startPosLockFlag,				// ŏ̒_Œɂ邩ǂ̃tO
								s32 maxbrinkwait, s32 minbrinkwait,	// _ōő҂Ԃƍŏ҂
								s32 Priority )
{
	EFFECT *Effect ;
	ELECEFFECT *el ;

	// Vdf[^쐬
	Effect = AddEffectData( EFF_ELEC, (void**)&el, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// lۑ
	el->pos 			= pos ;
	el->target 			= target ;
	
	el->onedivlen 		= onedivlen ;
	el->maxwidth	 	= maxwidth ;
	el->minwidth 		= minwidth ;
	el->biaswidth 		= biaswidth ;
	el->billnum 		= billnum ;
	el->color 			= color ;
	el->burewidthbig 	= burewidthbig ;
	el->burewidthsmall 	= burewidthsmall ;
	el->divnum 			= divnum ;
	el->div2num 		= div2num ;
	el->div2addz		= div2addz ;
	el->blendmode 		= blendmode ;
	el->endPosLockFlag 	= endPosLockFlag ;
	el->startPosLockFlag = startPosLockFlag ;
	
	el->maxbrinkwait	= maxbrinkwait ;
	el->minbrinkwait	= minbrinkwait ;
	
	el->brinkcon		= 0 ;
	el->brinkwait		= GetRandI2Num( maxbrinkwait, minbrinkwait ) ;
	el->drawflag		= true ;
	
	// [̒𓾂
	el->len = VECDistance( &el->target, &el->pos ) ;

	// ̎Zo
	el->pdivnum = (s32)( el->len / el->onedivlen ) ;
	
	// 򃉃C̕ԃOtBbN̐Zo
	el->div2ainum = (s32)( (f32)el->billnum * ( ( el->div2addz / el->div2num ) / ( el->onedivlen / el->divnum ) ) ) ;
	el->div2ainum = (s32)( (f32)el->div2ainum / el->biaswidth ) ;
	if( el->div2ainum < 2 ) el->div2ainum = 2 ;

	// obt@̊m
	{
		s32 size = (s32)( 
					( el->pdivnum * sizeof( Vec ) ) + 								// parent 
					( el->pdivnum * el->divnum * el->div2num * sizeof( Vec ) ) + 	// buf 
					( el->pdivnum * el->divnum * el->div2num * sizeof( f32 ) ) ) ;	// size 
		el->databuf = K7AppSmallMemAllocName( size, "Y_EleBuf" ) ;
		if( el->databuf == NULL )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		
		el->parent = ( Vec * )el->databuf ;
		el->buf = (Vec *)( (( u8 * )el->parent) + el->pdivnum * sizeof( Vec ) ) ; 
		el->size = (f32 *)( (( u8 * )el->buf) + el->pdivnum * el->divnum * el->div2num * sizeof( Vec ) ) ; 
	}

	// O𓾂
	{
		Vec dir ;
		
		VECSubtract( &el->target, &el->pos, &dir ) ;
		GetDir3( dir, &el->dir ) ;
	}
	
	// ]p̏
	for( s32 i = 0 ; i < MAXROTNUM ; i ++ )
	{
		el->rot[i] 		= 0.0F ;
		el->rotsp[i] 	= GetRandF2Num( MAXROTSP, MINROTSP ) ;
		el->rotw[i] 	= GetRandFNum( ROTW ) ;
		el->rotrate[i] 	= GetRandF2Num( MAXROTRATE, MINROTRATE ) ;
	}
	
	// Pt[sĂ
	MoveElecEffect( Effect ) ;

	// I
	return Effect ;
}

// dGtFNǧns
extern s8 ReleaseElecEffect( EFFECT *Effect )
{
	ELECEFFECT *el = ( ELECEFFECT * )Effect->Data ;

	if( el->databuf != NULL ) K7AppSmallMemFree( el->databuf ) ;

	// I
	return 0 ;
}

// dGtFNgPt[
extern s8 MoveElecEffect( EFFECT *Effect )
{
	ELECEFFECT *el = ( ELECEFFECT * )Effect->Data ;

	if( VParam[ED_ELEC][1] >= MAXDIVNUM ) VParam[ED_ELEC][1] = MAXDIVNUM ;
	if( VParam[ED_ELEC][1] == 0 ) VParam[ED_ELEC][1] = 1 ;

	if( VParam[ED_ELEC][11] >= MAXDIVDIVNUM ) VParam[ED_ELEC][11] = MAXDIVDIVNUM ;
	if( VParam[ED_ELEC][11] == 0 ) VParam[ED_ELEC][11] = 1 ;
	
	if( VParam[ED_ELEC][22] >= MAXPDIVNUM ) VParam[ED_ELEC][22] = MAXPDIVNUM ;
	if( VParam[ED_ELEC][22] == 0 ) VParam[ED_ELEC][22] = 1 ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	el->brinkcon ++ ;
	if( el->brinkcon >= el->brinkwait )
	{
		el->drawflag = !el->drawflag ;
		el->brinkcon = 0 ;
		el->brinkwait = GetRandI2Num( el->maxbrinkwait, el->minbrinkwait ) ;
	}
	
	if( el->maxbrinkwait == 0 ) el->drawflag = true ;
	if( el->drawflag == false ) return 0 ;
	
	// 
	{
		s32 i ;
		
		for( i = 0 ; i < ROTNUM ; i ++ )
		{
			el->rot[i] += el->rotsp[i] ;
		}
	}

	// _̏
	{
		// Kw̃f[^Zbg
		{
			s32 i, j, k, l ;
		
			for( l = 0 ; l < el->pdivnum ; l ++ )
			{
				if( ( l == 0 && el->startPosLockFlag == true ) ||
					( l == el->pdivnum - 1 && el->endPosLockFlag == true ) )
				{
					el->parent[l].y = 0.0F ;	el->parent[l].x = 0.0F ;	el->parent[l].z = 0.0F ;
				}
				else
				{
					el->parent[l].y = GetRandF2Num( el->burewidthbig, 	-el->burewidthbig ) ;
					el->parent[l].x = GetRandF2Num( el->burewidthbig,	-el->burewidthbig ) ;
					el->parent[l].z = 0.0F ;
				}

				// Kw̃f[^Zbg
				{
					f32 maxex, minex ;
					f32 burexymax, *size ;
					Vec *buf ;

					for( i = 0 ; i < el->divnum ; i ++ )
					{
						maxex = el->maxwidth ;
						minex = el->minwidth ;
						burexymax = el->burewidthsmall ;
						buf = el->buf + l * el->divnum * el->div2num + i * el->div2num ;
						size = el->size + l * el->divnum * el->div2num + i * el->div2num ;
						for( j = 0 ; j < el->div2num ; j ++, buf ++, size ++ )
						{
							if( i == 0 || i == el->divnum - 1 )
							{
								buf->y = 0.0F ;	buf->x = 0.0F ;	buf->z = 0.0F ;
							}
							else
							{
								buf->y = GetRandF2Num( burexymax, -burexymax ) ;
								buf->x = GetRandF2Num( burexymax, -burexymax ) ;
								buf->z = GetRandF2Num( BUREZMAX, -BUREZMAX ) ;
							}

							*size = GetRandF2Num( maxex, minex ) ;
							maxex *= el->biaswidth ;
							minex *= el->biaswidth ;
							burexymax *= el->biaswidth ;

							// Z
							for( k = 0 ; k < ROTNUM ; k ++ )
							{
								buf->y += SINF( el->rot[k] + i * el->rotrate[k] ) * el->rotw[k] ;
							}
						}
					}
				}
			}
		}
	}

	
	// I
	return 0 ;
}

// dGtFNg`悷
extern s8 DrawElecEffect( EFFECT *Effect )
{
	ELECEFFECT *el = ( ELECEFFECT * )Effect->Data ;
	Mtx mt ;
	Vec tv[4] ; 
	u32 cr ;
	s32 i, j, k, l, num, con ;

	if( el->drawflag == false ) return 0 ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, (s8)el->blendmode, EF_TEV_USETEX, TRUE ) ;
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;

	// eNX`̃[h
	GTLOAD( GetSmokeTex() ) ;

	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;


	// F̎Zo
	cr = el->color ;

	// `揈
	CreateBillVert( mt, tv, TUBU_SIZE, TUBU_SIZE ) ;
	num = 	(
				( ( el->divnum - 1 ) * ( el->pdivnum - 1 ) ) * el->billnum + 
				( ( el->divnum - 1 ) * ( el->pdivnum - 1 ) ) * ( el->div2num - 1 ) * el->div2ainum 
			) * 4 ;
	if( num > 65535 ) return 0 ;
	con = 0 ;
	GBGN( GX_QUADS, (u16)num ) ;
	{
		Vec addv, kv, addsv, ksv, v1, v2, vs1, vs2, vp1, vp2 ;
		f32 addex, kex, addsex, ksex, vplen ;
		Vec *buf ;
		f32 *size, div2addz ;
		DIR3 dir3, dir2 ;
		Vec dir ;
		f32 ponelen, sonelen ;

		// 傫ȕJԂ
		ponelen = el->len / el->pdivnum ;
		div2addz = el->div2addz / ( el->div2num - 1 ) ;
		buf = el->buf ;
		size = el->size ;
		for( l = 0 ; l < el->pdivnum -1 ; l ++ )
		{
			// WZo
			GetDirPos( &el->dir, &vp1, 	el->parent[l].x, 		el->parent[l].y, 		el->parent[l].z + l * ponelen ) ;
										vp1.x += el->pos.x ;	vp1.y += el->pos.y ;	vp1.z += el->pos.z ;
			GetDirPos( &el->dir, &vp2, 	el->parent[l+1].x, 		el->parent[l+1].y, 	el->parent[l+1].z + ( l + 1 ) * ponelen ) ;
										vp2.x += el->pos.x ;	vp2.y += el->pos.y ;	vp2.z += el->pos.z ;

			// _Ɠ_̊Ԃ̋ƎO擾
			vplen = VECDistance( &vp2, &vp1 ) ;
			{
				Vec dir ;
				VECSubtract( &vp2, &vp1, &dir ) ;
				GetDir3( dir, &dir2 ) ;
			}

//			buf = el->buf + l * el->divnum * el->div2num + i * el->div2num ;
//			size = el->size + l * el->divnum * el->div2num + i * el->div2num ;

			// ȕJԂ
			sonelen = vplen / ( el->divnum - 1 ) ;
			for( i = 0 ; i < el->divnum - 1 ; i ++,	buf += el->div2num,	size += el->div2num )
			{
/*				if( i == el->divnum - 2 )
				{
					i = el->divnum - 2 - 1 ;
					i ++ ;
				}
*/			
				// WZo
				GetDirPos( &dir2, &v1, buf[0].x, 			buf[0].y, 			buf[0].z 			+ i * sonelen ) ;
				v1.x += vp1.x ;		v1.y += vp1.y ;		v1.z += vp1.z ;
				GetDirPos( &dir2, &v2, buf[el->div2num].x, 	buf[el->div2num].y,	buf[el->div2num].z 	+ ( i + 1 ) * sonelen ) ;
				v2.x += vp1.x ;		v2.y += vp1.y ;		v2.z += vp1.z ;

				// Tu̕`
				VECSubtract( &v2, &v1, &dir ) ;
				GetDir3( dir, &dir3 ) ;
				vs1 = v1 ;
				for( k = 1 ; k < el->div2num ; k ++ )
				{
					GetDirPos( &dir3, &vs2, buf[k].x, 	buf[k].y, 	buf[k].z + k * div2addz ) ;
					vs2.x += vs1.x ;	vs2.y += vs1.y ;	vs2.z += vs1.z ;

					// `
					VECSubtract( &vs2, &vs1, &addsv ) ;
					addsv.x /= el->div2ainum  ;		addsv.y /= el->div2ainum ;		addsv.z /= el->div2ainum ;
					ksv = vs1 ;

					addsex = ( size[k] - size[k-1] ) / el->div2ainum ;
					ksex = size[k-1] ;
					for( j = 0 ; j < el->div2ainum ; j ++ )
					{
						GPV4( ksv, tv[0], ksex ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;
						GPV4( ksv, tv[1], ksex ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;
						GPV4( ksv, tv[2], ksex ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;
						GPV4( ksv, tv[3], ksex ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;
						
						con += 4 ;

						ksv.x += addsv.x ;
						ksv.y += addsv.y ;
						ksv.z += addsv.z ;

						ksex += addsex ;
					}

					VECSubtract( &vs2, &vs1, &dir ) ;
					GetDir3( dir, &dir3 ) ;

					vs1 = vs2 ;
				}

				// C̕`
				VECSubtract( &v2, &v1, &addv ) ;
				addv.x /= el->billnum ;		addv.y /= el->billnum ;		addv.z /= el->billnum ;
				kv = v1 ;

				addex = ( size[el->div2num] - size[0] ) / el->billnum ;
				kex = size[0] ;
				for( j = 0 ; j < el->billnum ; j ++ )
				{
					GPV4( kv, tv[0], kex ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;
					GPV4( kv, tv[1], kex ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;
					GPV4( kv, tv[2], kex ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;
					GPV4( kv, tv[3], kex ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;

					con += 4 ;

					kv.x += addv.x ;
					kv.y += addv.y ;
					kv.z += addv.z ;
					
					kex += addex ;
				}
			}
		}
	}
	GEND() ;

	// I
	return 0 ;
}

// dGtFNg̍WύX
extern s8 SetElecPos( EFFECT *Effect, Vec pos, Vec target )
{
	ELECEFFECT *el = ( ELECEFFECT * )Effect->Data ;
	
	el->pos = pos ;
	el->target = target ;
	
	// O𓾂
	{
		Vec dir ;
		
		VECSubtract( &el->target, &el->pos, &dir ) ;
		GetDir3( dir, &el->dir ) ;
	}

	// 𓾂
	el->len = VECDistance( &el->target, &el->pos ) ;

	// I
	return 0 ;
}


// e[u
static const u16 _ElecTable[][30] = 
{
// тт
{	10,		10,		181,		183,		255,
	95,		11,		158,		10,		22,

	11,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		204,	10,		47,		1,
	0,		0,		0,		29,		0 },
// grтт(TCYP)
{	10,		9,		177,		191,		255,
	150,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		47,		10,		28,		1,
	0,		0,		0,		29,		0 },
// grтт(TCYQ)
{	10,		9,		177,		191,		255,
	150,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		57,		10,		28,		1,
	0,		0,		0,		29,		0 },
// grтт(TCYR)
{	10,		9,		177,		191,		255,
	150,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		67,		10,		28,		1,
	0,		0,		0,		29,		0 },
// Wep
{	10,		6,		0,		0,		0,
	255,		11,		152,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		24,		10,		28,		0,
	0,		0,		0,		29,		0 },
// grтт(TCYP)
{	10,		9,		0,		0,		0,
	255,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		47,		10,		28,		0,
	0,		0,		0,		29,		0 },
// grтт(TCYQ)
{	10,		9,		0,		0,		0,
	255,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		57,		10,		28,		0,
	0,		0,		0,		29,		0 },
// grтт(TCYR)
{	10,		9,		9,		0,		0,
	255,		6,		56,		10,		18,

	7,		3,		9,		70,		3,
	0,		0,		0,		3,		1,

	20,		67,		10,		28,		0,
	0,		0,		0,		29,		0 },
} ;


// dGtFNg쐬
extern EFFECT *CreateElecEffect( ELEC_TYPE type,
									Vec pos, Vec target,
									s32 Priority )
{
	const s32 BlendMode[] = { EF_BLEND_ALPHA, EF_BLEND_ADD, EF_BLEND_SUB } ;

	if( type == EL_TEST )
	{
		return CreateElecEffect(
						 	pos, 
							target,
							VParam[ED_ELEC][23] * 0.1F,						// ꕪ̍ő咷
							VParam[ED_ELEC][9] * 0.1F,
							VParam[ED_ELEC][10] * 0.1F,			// őEŏ̑
							VParam[ED_ELEC][13] * 0.01F,						// ̕򂲂ƂɌ銄
							(s32)VParam[ED_ELEC][6],						// ԉ摜̐
							CMK(VParam[ED_ELEC][2],VParam[ED_ELEC][3],VParam[ED_ELEC][4],VParam[ED_ELEC][5]),							// F
							VParam[ED_ELEC][21] * 0.1F,
							VParam[ED_ELEC][7] * 0.01F,		// 傫ȂԂ̃TCYƏȂԂ̃TCY
							(s32)VParam[ED_ELEC][1],							// ꕪԂԂ镪
							(s32)VParam[ED_ELEC][11],						// 򃉃C̒_
							VParam[ED_ELEC][12] * 0.1F,						// 򃉃C̈꒸_ӂ̑Oi
							BlendMode[VParam[ED_ELEC][24]],					// uh[h
							VParam[ED_ELEC][25] == 0 ? false : true,				// Ō̒_Œɂ邩ǂ̃tO
							VParam[ED_ELEC][29] == 0 ? false : true,				// Ō̒_Œɂ邩ǂ̃tO
							(s32)VParam[ED_ELEC][16],		// _ōő҂
							(s32)VParam[ED_ELEC][17],		// _ōŏ҂
							Priority ) ;
	}
	else
	{
		u16 *tb = (u16 *)_ElecTable[type-1] ;
		
		if( type >= EL_MAX ) return 0 ;
		if( VParam[ED_ELEC][27] == 1 )
		{
			u16 t = VParam[ED_ELEC][26] ;
			u16 len = VParam[ED_ELEC][28] ;
			memcpy( VParam[ED_ELEC], tb, sizeof( u16 ) * 30 ) ;
			VParam[ED_ELEC][27] = 0 ;
			VParam[ED_ELEC][26] = t ;
			VParam[ED_ELEC][28] = len ;
		}

		return CreateElecEffect(
						 	pos, 
							target,
							tb[23] * 0.1F,						// ꕪ̍ő咷
							tb[9] * 0.1F,
							tb[10] * 0.1F,						// őEŏ̑
							tb[13] * 0.01F,						// ̕򂲂ƂɌ銄
							(s32)tb[6],							// ԉ摜̐
							CMK(tb[2],tb[3],tb[4],tb[5]),		// F
							tb[21] * 0.1F,
							tb[7] * 0.01F,						// 傫ȂԂ̃TCYƏȂԂ̃TCY
							(s32)tb[1],							// ꕪԂԂ镪
							(s32)tb[11],						// 򃉃C̒_
							tb[12] * 0.1F,						// 򃉃C̈꒸_ӂ̑Oi
							BlendMode[tb[24]],					// uh[h
							tb[25] == 0 ? false : true,				// Ō̒_Œɂ邩ǂ̃tO
							tb[29] == 0 ? false : true,				// Ō̒_Œɂ邩ǂ̃tO
							(s32)tb[16],
							(s32)tb[17],
							Priority ) ;
	 }
	
	return NULL ;
}


