///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectEneShot
//
// YK7EffectEneShot.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/28/2004
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectEneShot.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectBillboard.h"
#include "./YK7EffectCentLight2.h"
//#include "./YK7EffectImpact.h"
#include "./YK7EffectExplode.h"

// define ---------------------------------------

// data type ------------------------------------

// data -----------------------------------------

static ENESHOTUNION enu ;
extern LINEUNION LUnion ;


// function proto type --------------------------

void _XzOirAdjust( f32 &oir, f32 &xz, f32 *oirsp = NULL, f32 *xzsp = NULL ) ;	// oir,xz ]̕␳s
void _XzOirRotPosGet( f32 rot, f32 oir, f32 xz, f32 r, Vec *V ) ;				// oir,xz ]擾	
void _XzOirRotPosGet2( f32 rot, f32 oir, f32 xz, f32 r, Vec *V ) ;				// oir,xz ]擾	
void _EneObjPosSet( ENESHOTOBJECT *ob ) ;						// WZbg
void _EneShotPosSetup( ENESHOTEFFECT *es ) ;					// ڕWւ̕⋗̏

// function code --------------------------------

// oir,xz ]̕␳s
void _XzOirAdjust( f32 &oir, f32 &xz, f32 *oirsp, f32 *xzsp )
{
	xzsp = xzsp ;
	
	// ␳
	if( oir > PI / 2 )
	{
		oir = PI / 2 - ( oir - PI / 2 ) ;
		if( oirsp ) *oirsp *= -1.0F ;
		xz += PI ;
//		if( xzsp ) *xzsp *= -1.0F ;
	}
	if( oir < -PI / 2 )
	{
		oir = -PI / 2 + ( oir + PI / 2 ) ;
		if( oirsp ) *oirsp *= -1.0F ;
		xz += PI ;
//		if( xzsp ) *xzsp *= -1.0F ;
	}
	while( xz < 0.0F ) xz += PI_2 ;
	while( xz > PI_2 ) xz -= PI_2 ;
}

// oir,xz ]擾	
void _XzOirRotPosGet( f32 rot, f32 oir, f32 xz, f32 r, Vec *V )
{
	f32 f ;

	V->x = COSF( rot ) ;	V->z = SINF( rot ) ;	V->y = 0.0F ;
	
	f = 	V->x * COSF( oir ) - V->y * SINF( oir ) ;
	V->y = 	V->x * SINF( oir ) + V->y * COSF( oir ) ;
	V->x = 	f ;

	f = 	V->x * COSF( xz ) - V->z * SINF( xz ) ;
	V->z = 	V->x * SINF( xz ) + V->z * COSF( xz ) ;
	V->x = 	f ;

//	V->x = COSF( oir ) ;		V->y = SINF( oir ) ;
//	V->z = SINF( xz ) * V->x ;	V->x = COSF( xz ) * V->x ;
	V->x *= r ;		V->y *= r ;		V->z *= r ;
}

// oir,xz ]擾	
void _XzOirRotPosGet2( f32 rot, f32 oir, f32 xz, f32 r, Vec *V )
{
//	_XzOirAdjust( oir, xz ) ;
	_XzOirRotPosGet( rot, oir, xz, r, V ) ;
}

// ڕWւ̕⋗̏
void _EneShotPosSetup( ENESHOTEFFECT *es )
{
	if( es->Mode != 0 ) return ;
	
	if( es->PosJObj != NULL )
	{
		Mtx *mp ;
	
		HSD_JObjSetupMatrix( es->PosJObj ) ;
		mp = &( es->PosJObj->mtx ) ;
		es->pos.x = (*mp)[0][3] ;
		es->pos.y = (*mp)[1][3] ;
		es->pos.z = (*mp)[2][3] ;
	}

	VECSubtract( &es->TargetPos, &es->pos, &es->dir ) ;

	if( es->dir.x + es->dir.y + es->dir.z == 0.0F )
	{
		es->len = 1.0F ;
		es->dir.x = 1.0F ;
	}
	else
	{
		es->len = VECMag( &es->dir ) ;
		VECNormalize( &es->dir, &es->dir ) ;
	}
	
	if( es->PosJObj != NULL )
	{
		Mtx m ;
		Vec z ;

//		MTXMultVec( es->PosJObj->mtx, &z, &z ) ;
//		z.x -= es->PosJObj->mtx[0][3] ;
//		z.y -= es->PosJObj->mtx[1][3] ;
//		z.z -= es->PosJObj->mtx[2][3] ;
		
		MTXCopy( es->PosJObj->mtx, m ) ;
		m[2][3] = m[1][3] = m[0][3] = 0.0F ;
		z.x = z.y = 0.0F ; z.z = 1.0F ;
		MTXMultVec( m, &z, &z ) ;
		if( z.x + z.y + z.z > 1.0F ) VECNormalize( &z, &z ) ;
	
		es->pos.x += z.x * 0.2F ;
		es->pos.y += z.y * 0.2F ;
		es->pos.z += z.z * 0.2F ;
	}

	SetCentLight2Pos( es->pos, es->CentLight2 ) ;
}



// WZbg
void _EneObjPosSet( ENESHOTOBJECT *ob )
{
//	_XzOirAdjust( ob->oir, ob->xz, &ob->oirsp, &ob->xzsp ) ;			// ␳
	_XzOirRotPosGet( ob->rot, ob->oir, ob->xz, ob->r, &ob->pos ) ;		// xNg擾
}


// GlM[VbgGtFNg̋ʃf[^
extern s8 InitEneShotData( void )
{
	MEMINIT(enu) ;
	
	enu.AImageNum = 1 ;

	LoadBillboardImage( BILLID_SPFIRE2 ) ;
	
	// I
	return 0 ;
}

// GlM[VbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckEneShotData( void )
{
	if( CheckBillboardImageLoadState( BILLID_SPFIRE2 ) == FALSE ) return FALSE ;
	return TRUE ;
}


// GlM[VbgGtFNg̋ʃf[^n
extern s8 EndEneShotData( void )
{
	ReleaseBillboardImage( BILLID_SPFIRE2 ) ;

	MEMINIT(enu) ;

	// I
	return 0 ;
}




// GlM[VbgGtFNg쐬
extern EFFECT *CreateEneShotEffect(
						s32 MaxCentObjNum,				// SIuWFNg̍ő吔
						s32 MaxOutObjNum,				// OIuWFNg̍ő吔

						Vec StartPos, Vec TargetPos,		// ˍWƖڕWW

						f32 OutRate,						// E
						
						f32 CentMaxSize, f32 CentMinSize,	// SIuWFNgőTCYƍŏTCY
						f32 CentMaxSpeed, f32 CentMinSpeed,	// SIuWFNgő呬xƍŏx
						f32 CentR,	 						// SIuWFNg̈ړa

						f32 OutMaxSize, f32 OutMinSize,		// OIuWFNgőTCYƍŏTCY
						f32 OutMaxSpeed, f32 OutMinSpeed,	// OIuWFNgő呬xƍŏx
						f32 MaxOutR, f32 MinOutR,			// OIuWFNg̈ړa

						f32 OutFadeSpeed,					// ẼAt@ľ鑬x
						f32 SSpeed,							// x
						u32 Color,							// F
						f32 Gravi, 							// d
						s32 Priority )
{
	EFFECT *Effect = NULL, *cent2 = NULL ;
	ENESHOTEFFECT *es = NULL ;
	ENESHOTOBJECT *ob = NULL ;
	u32 i/*, j*/ ;
	
	// ߃GtFNg̍쐬
	{
		Vec p = {20.0F, 20.0F, 0.0F} ;
		GXColor color ;
		
		*((u32 *)&color ) = Color ;
		cent2 = CreateCentLight2Effect(
						(s32)VParam[ED_CENTLIGHT2][0],
						StartPos,
						(f32)VParam[ED_CENTLIGHT2][1] * 0.1F, (f32)VParam[ED_CENTLIGHT2][2] * 0.1F,
						(f32)VParam[ED_CENTLIGHT2][3] * 0.01F, (f32)VParam[ED_CENTLIGHT2][4] * 0.01F,
						(f32)VParam[ED_CENTLIGHT2][5] * 0.001F,
						(f32)VParam[ED_CENTLIGHT2][6] * 0.01F,
						color ) ;
		if( cent2 == NULL ) return NULL ;
	}

	// IuWFNgۑ邽߂̃̈̊m
	if( ( ob = ( ENESHOTOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( ENESHOTOBJECT ) * ( MaxCentObjNum + MaxOutObjNum ) ), "Y_ESObj" ) ) == NULL ) goto ERR ;
	memset( ob, 0, sizeof( ENESHOTOBJECT ) * ( MaxCentObjNum + MaxOutObjNum ) ) ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_ENESHOT, (void**)&es, Priority ) ;
	if( Effect == NULL ) goto ERR ;

	// p[^ۑE
	es->CentLight2 = cent2 ;
	es->CentLight2EffectID = GetEffectID( cent2 ) ;
	es->MaxCentObjNum = MaxCentObjNum ;
	es->MaxOutObjNum = MaxOutObjNum ;
	es->CentObj = ob ;
	es->OutObj = ob + es->MaxCentObjNum ;
	es->CentObjNum = 0 ;
	es->OutObjNum = 0 ;
	
	es->StartPos = StartPos ;
	es->TargetPos = TargetPos ;
	es->OutRate = OutRate ;
	es->CentMaxSize = CentMaxSize ;			es->CentMinSize = CentMinSize ;
	es->CentMaxSpeed = CentMaxSpeed ;		es->CentMinSpeed = CentMinSpeed ;
	es->CentR = CentR ;
	
	es->OutMaxSize = OutMaxSize ;			es->OutMinSize = OutMinSize ;
	es->OutMaxSpeed = OutMaxSpeed ;			es->OutMinSpeed = OutMinSpeed ;
	es->MaxOutR = MaxOutR ;					es->MinOutR = MinOutR ;
	es->Color = Color ;
	es->Gravi = Gravi ;
	
	es->OutFadeSpeed = OutFadeSpeed ;
	es->SSpeed = SSpeed ;
	es->chargerate = 0.0F ;
	es->PosJObj = NULL ;
	
	es->pos = es->StartPos ;
	_EneShotPosSetup( es ) ;

	es->speed = enu.InitSpeed ;
	enu.InitSpeed = 0.0F ;

	es->rotcounter = 0.0F ;
	es->Counter = 0 ;
	es->Mode = 0 ;	

	es->Size = 1.0F ;
	es->SizeCount = 0.0F ;
	
	es->AImageNum = (u32)enu.AImageNum ;
	enu.AImageNum = 1 ;

	es->NotSizeControl = enu.NotSizeControl ;
	enu.NotSizeControl = false ;
	
	es->NotBom = enu.NotBom ;
	enu.NotBom = false ;

	// IuWFNg̏	
	for( i = 0 ; i < MaxCentObjNum + MaxOutObjNum ; i ++, ob ++ )
	{
		ob->vflag = 0 ;
		ob->bnum = 0 ;
	}

	// I
	return Effect ;
	
ERR :
	if( Effect != NULL )
	{
		DeleteEffect( Effect ) ;
	}
	else
	{
		if( ob != NULL ) K7AppSmallMemFree( ob ) ;
		if( cent2 != NULL ) DeleteEffect( cent2 ) ;
	}

	return NULL ;
}

// GlM[VbgGtFNǧns
extern s8 ReleaseEneShotEffect( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;

	// CIuWFNgi[pɊmۂĂ̈̊J
	if( es->CentObj != NULL ) CHKMEMFREE2( es->CentObj ) ;
	if( CheckEffectValidState( es->CentLight2, es->CentLight2EffectID ) == TRUE )
		DeleteEffect( es->CentLight2 ) ;

	// I
	return 0 ;
}

// GlM[VbgGtFNgPt[
extern s8 MoveEneShotEffect( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;
	ENESHOTOBJECT *ob ;
	u32 i, num, m ;
	s32 *bnum ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && ( es->CentObjNum + es->OutObjNum ) == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( es->NotSizeControl )
	{
		es->Size = 1.0F ;
	}
	else
	{
		es->Size = GetRandF2Num( VParam[ED_ENESHOT][25] * 0.01F + 1.0F, 1.0F ) ;
		es->Size *= ( ( es->Mode == 0 ) ? VParam[ED_ENESHOT][0] : VParam[ED_ENESHOT][29] ) * 0.01F ;
		if( es->CentLight2 != NULL ) SetCentLight2Speed( ((f32)VParam[ED_CENTLIGHT2][5] * 0.001F) * ( es->chargerate * 2.0F + 1.0F ), es->CentLight2 ) ;
	}

//	if( es->CentLight2 != NULL ) SetCentLight2Speed( ((f32)VParam[ED_CENTLIGHT2][5] * 0.001F) * ( es->chargerate * 2.0F + 1.0F ), es->CentLight2 ) ;
	
	if( es->Mode == 0 )
	{
		// WĐݒ肷
		_EneShotPosSetup( es ) ;
	}

	// Ԃɂď𕪊
	switch( es->Mode )
	{
	case 0 :		// ҂̏
		break ;

	case 1 :		// ˒
		{
			f32 len ;
			
			len = es->speed ;
			if( len > es->len )
			{
				// B
				es->pos.x += es->dir.x * es->len ;	es->pos.y += es->dir.y * es->len ;	es->pos.z += es->dir.z * es->len ;
				es->len -= len ;

				es->Mode = 2 ;

				// h炷
				if( es->NotBom == false )
				{
//					CreateImpactEffect( 10, 5, (Vec){0.0F, 0.0F, 0.0F}, 5, 0, TRUE ) ;
					CreateSmokeExplodeEffect( es->pos, 4.f, 0, 
						CMK( VParam[ED_ENESHOT][26], VParam[ED_ENESHOT][27], VParam[ED_ENESHOT][28], 255 )   ) ;
				}
			}
			else
			{
				// ړ
				es->pos.x += es->dir.x * es->speed ;	es->pos.y += es->dir.y * es->speed ;	es->pos.z += es->dir.z * es->speed ;
				es->len -= es->speed ;
				es->speed += es->SSpeed ;
			}
		}
		break ;

	case 2 :	// B
		// 
		SetEneShotChargeRate( 0.0F, Effect ) ;
		if( es->OutObjNum == 0 && es->CentObjNum == 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		break ;
	}
	
	es->rotcounter += PI_2 / 30 ;

	// ׂẴCIuWFNg
	for( m = 0 ; m < 2 ; m ++ )
	{
		switch( m )
		{
		case 0 : ob = es->CentObj ; num = (u32)es->CentObjNum ; bnum = &es->CentObjNum ; break ;
		case 1 : ob = es->OutObj ; num = (u32)es->OutObjNum ; bnum = &es->OutObjNum ; break ;
		}

		for( i = 0 ; i < num ; ob ++ )
		{
			if( ob->vflag == 0 ) continue ;

			i ++ ;
			
			if( es->AImageNum != 1 )
			{
				if( ob->bnum >= 2 )
				{
					for( int q = ob->bnum - 2 ; q >= 0 ; q -- )
					{
						ob->bxz[q+1] = ob->bxz[q] ;
						ob->boir[q+1] = ob->boir[q] ;
						ob->brot[q+1] = ob->brot[q] ;
						ob->bapos[q+1] = ob->bapos[q] ;
					}
				}
				ob->bxz[0] = ob->xz ;
				ob->boir[0] = ob->oir ;
				ob->brot[0] = ob->rot ;
				ob->bapos[0] = ob->apos ;
				
				if( ob->bnum != ENE_AIMAGENUM ) ob->bnum ++ ;
			}

			switch( ob->mode )
			{
			case 0 :
				if( es->Mode == 1 && GetRandFNum( 1.0F ) < es->OutRate && m == 1 )
				{
					ob->mode = 1 ;
					ob->mode1pos = ob->apos ;

//					ob->speed.x += es->dir.x * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
//					ob->speed.y += es->dir.y * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
//					ob->speed.z += es->dir.z * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
					ob->speed.x += es->dir.x * -es->speed ;
					ob->speed.y += es->dir.y * -es->speed ;
					ob->speed.z += es->dir.z * -es->speed ;
				}
				else
				{
					Vec back ;
					back = ob->pos ;
					
//					ob->xz += ob->xzsp ;							// ύX
//					ob->oir += ob->oirsp ;
					ob->rot += ob->xzsp ;
					_EneObjPosSet( ob ) ;							// W␳
					VECSubtract( &ob->pos, &back, &ob->speed ) ;	// xZo
					ob->apos.x = ob->pos.x * es->Size + es->pos.x ;			// ΍W̎Zo
					ob->apos.y = ob->pos.y * es->Size + es->pos.y ;
					ob->apos.z = ob->pos.z * es->Size + es->pos.z ;
				}
				break ;
				
			case 1 :
//				ob->xz += ob->xzsp ;							// ύX
//				ob->oir += ob->oirsp ;
//				_EneObjPosSet( ob ) ;							// W␳

				ob->mode1pos.x += ob->speed.x ;
				ob->mode1pos.y += ob->speed.y ;
				ob->mode1pos.z += ob->speed.z ;
				ob->apos.x = ob->mode1pos.x + ob->pos.x ;
				ob->apos.y = ob->mode1pos.y + ob->pos.y ;
				ob->apos.z = ob->mode1pos.z + ob->pos.z ;
				
				ob->speed.y -= es->Gravi ;
				ob->alpha -= ob->fadesp ;
				if( ob->alpha <= 0.0F )
				{
					ob->vflag = 0 ;
					(*bnum) -= 1 ;
				}
				break ;
			}
		}
	}

	// I
	return 0 ;
}

#define OB_NODRAW					\
		GP3( 0.0F, 0.0F, 0.0F ) ; GCX( 0 ) ; GT( 0.0F, 0.0F ) ;\
		GP3( 0.0F, 0.0F, 0.0F ) ; GCX( 0 ) ; GT( 0.0F, 0.0F ) ;\
		GP3( 0.0F, 0.0F, 0.0F ) ; GCX( 0 ) ; GT( 0.0F, 0.0F ) ;\
		GP3( 0.0F, 0.0F, 0.0F ) ; GCX( 0 ) ; GT( 0.0F, 0.0F ) ;

#define OB_DRAW( POS, ALPHA )		\
		cr = CMKC2( es->Color, 255 * ALPHA ) ;\
		siz = ob->size * ob->alpha * es->Size * r ; \
\
		GP3( tv[0].x * siz + (POS).x,\
			 tv[0].y * siz + (POS).y,\
			 tv[0].z * siz + (POS).z ) ;\
		GCX( cr ) ;		GT( 0.0F, 0.0F ) ;\
\
		GP3( tv[1].x * siz + (POS).x,\
			 tv[1].y * siz + (POS).y,\
			 tv[1].z * siz + (POS).z ) ;\
		GCX( cr ) ;		GT( 1.0F, 0.0F ) ;\
\
		GP3( tv[2].x * siz + (POS).x,\
			 tv[2].y * siz + (POS).y,\
			 tv[2].z * siz + (POS).z ) ;\
		GCX( cr ) ;		GT( 1.0F, 1.0F ) ;\
\
		GP3( tv[3].x * siz + (POS).x,\
			 tv[3].y * siz + (POS).y,\
			 tv[3].z * siz + (POS).z ) ;\
		GCX( cr ) ;		GT( 0.0F, 1.0F ) ;


// GlM[VbgGtFNg`悷
extern s8 DrawEneShotEffect( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;
	ENESHOTOBJECT *ob ;
	u32 m, i, j, cr ;
	s32 num, aimagenum, aimagenum2 ;
	f32 doir, dxz, drot, siz, r ;
	Mtx tmtx ;
	Vec tv[4], dvec, pos ;

//	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;			// `̏
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_FALSE, GX_TEVPREV ) ;
	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;					// eNX`̃[h
	EffectGetInvViewMatrix( tmtx ) ;											// ]ns̍쐬
	CreateBillVert( tmtx, tv, 1.0F - es->chargerate * 0.2F,
								1.0F - es->chargerate * 0.2F, es->rotcounter );	// r{[h_̍쐬

	// `揈	
	aimagenum2 = es->AImageNum == 1 ? 1 : ENE_AIMAGENUM ;
	aimagenum = (s32)es->AImageNum ; // (s32)( es->Mode == 0 ? es->AImageNum : 1 ) ;
	GBGN( GX_QUADS, ( ( es->CentObjNum + es->OutObjNum ) * aimagenum * aimagenum2 ) * 4 ) ;
	{
		for( m = 0 ; m < 2 ; m ++ )
		{
			switch( m )
			{
			case 0 : ob = es->CentObj ; num = es->CentObjNum ; break ;
			case 1 : ob = es->OutObj ; num = es->OutObjNum ; break ;
			}

			for( i = 0 ; i < num ; ob ++ )
			{
				if( ob->vflag == 0 ) continue ;

				i ++ ;

				if( aimagenum == 1 )
				{
					r = 1.0F ;
					OB_DRAW( ob->apos, ob->alpha ) ;
				}
				else
				{
					if( es->Mode == 0 /*aimagenum != 1*/ )
					{
						drot = ( ob->rot - ob->brot[0] ) / aimagenum ; 
						dxz = ( ob->xz - ob->bxz[0] ) / aimagenum ;
						doir = ( ob->oir - ob->boir[0] ) / aimagenum ;
						r = 1.0F ;
						for( j = 0 ; j < aimagenum ; j ++ )
						{
							_XzOirRotPosGet2( drot * j + ob->brot[0], doir * j + ob->boir[0], dxz * j + ob->bxz[0], ob->r, &pos ) ;
							pos.x += es->pos.x ; pos.y += es->pos.y ; pos.z += es->pos.z ;
							OB_DRAW( pos, ob->alpha /* / ( j + 1 )*/ ) ;
						}

						for( int q = 0 ; q < aimagenum2 - 1 ; q ++ )
						{
							drot = ( ob->brot[q] - ob->brot[q+1] ) / aimagenum ; 
							dxz = ( ob->bxz[q] - ob->bxz[q+1] ) / aimagenum ;
							doir = ( ob->boir[q] - ob->boir[q+1] ) / aimagenum ;
							r = 1.0F - (f32)q / aimagenum2 ;
							for( j = 0 ; j < aimagenum ; j ++ )
							{
								if( ob->bnum > q )
								{
									_XzOirRotPosGet2( drot * j + ob->brot[q+1], doir * j + ob->boir[q+1], dxz * j + ob->bxz[q+1], ob->r, &pos ) ;
									pos.x += es->pos.x ; pos.y += es->pos.y ; pos.z += es->pos.z ;
									OB_DRAW( pos, ob->alpha /* / ( j + 1 )*/ ) ;
								}
								else
								{
									OB_NODRAW ;
								}
							}
						}
					}
					else
					{
						r = 1.0F ;
						dvec.x = ( ob->apos.x - ob->bapos[0].x ) / aimagenum ;
						dvec.y = ( ob->apos.y - ob->bapos[0].y ) / aimagenum ;
						dvec.z = ( ob->apos.z - ob->bapos[0].z ) / aimagenum ;
						for( j = 0 ; j < aimagenum ; j ++ )
						{
							pos.x = dvec.x * j + ob->bapos[0].x ;
							pos.y = dvec.y * j + ob->bapos[0].y ;
							pos.z = dvec.z * j + ob->bapos[0].z ;
							OB_DRAW( pos, ob->alpha ) ;
						}

						for( int q = 0 ; q < aimagenum2 - 1 ; q ++ )
						{
							r = 1.0F - (f32)q / aimagenum2 ;
							dvec.x = ( ob->bapos[q].x - ob->bapos[q+1].x ) / aimagenum ;
							dvec.y = ( ob->bapos[q].y - ob->bapos[q+1].y ) / aimagenum ;
							dvec.z = ( ob->bapos[q].z - ob->bapos[q+1].z ) / aimagenum ;
							for( j = 0 ; j < aimagenum ; j ++ )
							{
								if( q < ob->bnum )
								{
									pos.x = dvec.x * j + ob->bapos[q+1].x ;
									pos.y = dvec.y * j + ob->bapos[q+1].y ;
									pos.z = dvec.z * j + ob->bapos[q+1].z ;
									OB_DRAW( pos, ob->alpha ) ;
								}
								else
								{
									OB_NODRAW ;
								}
							}
						}
					}
				}
			}
		}
	}
	GEND() ;
	
	// I
	return 0 ;
}


// GtFNg̍WύX
extern s8 SetEneShotPos( Vec Pos, EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;
	
	es->pos = Pos ;
	
	// WĐݒ肷
	_EneShotPosSetup( es ) ;
	
	return 0 ;
}

// ߗݒ肷
extern s8 SetEneShotChargeRate( f32 Rate, EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;
	ENESHOTOBJECT *ob  ;
	s32 nextnum, i, j, m, num, maxnum ;
	s32 sa ;
	s32 *bnum ;
	f32 maxsize, minsize, maxsp, minsp, maxr, minr ;
	
	es->chargerate = Rate ;

	for( m = 0 ; m < 2 ; m ++ )
	{
		switch( m )
		{
		case 0 :
			ob = es->CentObj ; num = es->CentObjNum ;
			bnum = &es->CentObjNum ; nextnum = (s32)( es->MaxCentObjNum * Rate ) ;
			maxsize = es->CentMaxSize ; minsize = es->CentMinSize ;
			maxsp = es->CentMaxSpeed ; minsp = es->CentMinSpeed ;
			maxr = es->CentR ; minr = es->CentR ;
			break ;
			
		case 1 :
			ob = es->OutObj ; num = es->OutObjNum ;
			bnum = &es->OutObjNum ; nextnum = (s32)( es->MaxOutObjNum * Rate ) ;
			maxsize = es->OutMaxSize ; minsize = es->OutMinSize ;
			maxsp = es->OutMaxSpeed ; minsp = es->OutMinSpeed ;
			maxr = es->MaxOutR ; minr = es->MinOutR ;
			break ;
		}

		maxnum = num > nextnum ? num : nextnum ;
		sa = nextnum - num ;
		j = 0 ;
		for( i = 0 ; i < maxnum ; ob ++ )
		{
			if( ob->vflag == FALSE )
			{
				if( sa > 0 )
				{
					i ++ ;
					
					ob->vflag 			= TRUE ;
					ob->xz 				= GetRandFNum( PI_2 ) ;
	//				ob->oir 			= GetRandFNum( PI ) - PI / 2 ;
					ob->oir 			= GetRandFNum( PI_2 ) ;
					ob->rot				= GetRandFNum( PI_2 ) ;
					ob->xzsp 			= GetRandF2Num( maxsp, minsp ) - maxsp / 2 ;
					ob->oirsp 			= GetRandF2Num( maxsp, minsp ) - maxsp / 2 ;
					ob->size	 		= GetRandF2Num( maxsize, minsize ) ;
					ob->r 				= GetRandF2Num( maxr, minr ) ;
					ob->mode 			= 0 ;
					ob->speed.z = ob->speed.y = ob->speed.x = 0.0F ;
					ob->mode1pos = ob->apos = es->pos ;
					ob->fadesp 			= GetRandF2Num( es->OutFadeSpeed, es->OutFadeSpeed * 0.5F ) ;
					ob->alpha 			= 1.0F ;
					
					for( int q = 0 ; q < ENE_AIMAGENUM ; q ++ )
					{
						ob->boir[q] = ob->oir ;
						ob->bxz[q] = ob->xz ;
						ob->brot[q] = ob->rot ;
						ob->bapos[q] = ob->apos ;
					}
					
					(*bnum) += 1 ;
					
					sa -- ;
				}
			}
			else
			{
				i ++ ;
			
				if( sa < 0 && ( ob->mode == 0 || ( es->Mode == 2 ) ) )
				{
					Vec dv ;
					
					sa ++ ;
					
					ob->mode = 1 ;
					ob->mode1pos = ob->apos ;
					
					dv.x = ob->apos.x - ( -es->dir.x * es->speed * VParam[ED_ENESHOT][24] * 0.01F + es->pos.x ) ;
					dv.y = ob->apos.y - ( -es->dir.y * es->speed * VParam[ED_ENESHOT][24] * 0.01F + es->pos.y ) ;
					dv.z = ob->apos.z - ( -es->dir.z * es->speed * VParam[ED_ENESHOT][24] * 0.01F + es->pos.z ) ;
					PSVECNormalize( &dv, &dv ) ;

					ob->speed.x += dv.x * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
					ob->speed.y += dv.y * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
					ob->speed.z += dv.z * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
//					ob->speed.x *= -1.0F ;
//					ob->speed.y *= -1.0F ;
//					ob->speed.z *= -1.0F ;
/*
					ob->speed.x += es->dir.x * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
					ob->speed.y += es->dir.y * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
					ob->speed.z += es->dir.z * es->speed * VParam[ED_ENESHOT][23] * 0.01F ;
*/
				}
			}
		}
	}

	return 0 ;
}

// ło
extern s8 RunEneShot( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;
	
	if( es->Mode == 0 )
	{
		es->Mode = 1 ;
		es->Counter = 0 ;

		DelReqEffect( es->CentLight2 ) ;
		es->CentLight2 = NULL ;
	}
	
	return 0 ;
}

// ڕWWɓBǂ擾
extern s8 HitCheckEneShot( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;

	return (s8)( es->Mode == 2 ? TRUE : FALSE ) ;
}

// ܂ŒǏ] JObj ݒ肷
extern s8 SetEneShotPosJObj( HSD_JObj *PosJObj, EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;

	if( es->Mode != 0 ) return -1 ;

	es->PosJObj = PosJObj ;

	// WĐݒ肷
	_EneShotPosSetup( es ) ;

	return 0 ;
}

// ^[Qbg|WVύX
extern s8 SetEneShotTargetPos( Vec TargetPos, EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;

	// łoÔݕύX\
	if( es->Mode != 0 ) return -1 ;

	es->TargetPos = TargetPos ;
	
	// WĐݒ肷
	_EneShotPosSetup( es ) ;

	return 0 ;
}

// GlM[Vbg
extern s8 CompEneShotEffect( EFFECT *Effect )
{
	ENESHOTEFFECT *es = ( ENESHOTEFFECT * )Effect->Data ;

	es->Counter = 0 ;
	switch( es->Mode )
	{
	case 0 : es->Mode = 2 ; break ;
	case 1 : es->len = 0.0F ; break ;
	}
	
	// I
	return 0 ;
}

// GlM[Vbg̎c̐Zbg(ݒŏ CreateEneShotEffect ̂ݗL)
extern s8 SetEneShotAImageNum( u32 AImageNum )
{
	enu.AImageNum = (s32)AImageNum ;	
	
	return 0 ;
}

// ɍ쐬GlM[VbgɃTCY|Ȃ
extern void SetEneShotNotSizeControl( void )
{
	enu.NotSizeControl = true ;
}

// ɍ쐬GlM[Vbg͔GtFNgoȂ
extern void SetEneShotNotBom( void )
{
	enu.NotBom = true ;
}

// ɍ쐬GlM[Vbgɏxݒ肷
extern void SetEneShotInitSpeed( f32 initspeed )
{
	enu.InitSpeed = initspeed ;
}


