///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFeather
//
// YK7EffectFeather.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 09/22/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectFeather.h"
#include "./YK7Break.h"
#include "../Wat/WK7Archive.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define FEATHERMODEL			"/Yam/Effect/Feather/Feathers_M00.dat"		// Hft@C
//#define FEATHERTEX			"/Yam/Effect/Gore/Kekkon.BIN"				// GtFNgp̃eNX`t@C
#define FEATHERTEX 				"/Yam/Effect/Feather/Feathers1_01.BIN"		// HGtFNgp̃eNX`t@C
#define FEATHERTEX_DIVNUM		3											// eNX`̕

// datatype -------------------------------------

// R[obNŎgpf[^^
typedef struct tagFEATHERCALL
{
	FEATHEREFFECT *Ft ;
	f32 CreateCounter ;
	
	u32 NumCounter ;
} FEATHERCALL ;

// data -----------------------------------------

FEATHERUNION FthUnion ;

static Vec Fv[4] =
{
	{ -0.5F, 0.0F, -0.5F },
	{ 0.5F, 0.0F, -0.5F },
	{ 0.5F, 0.0F, 0.5F },
	{ -0.5F, 0.0F, 0.5F },
} ;


// function proto type --------------------------

static inline void SetRotRadX( Mtx m, f32 Rot ) ;
static inline void SetRotRadY( Mtx m, f32 Rot ) ;
static inline void SetRotRadZ( Mtx m, f32 Rot ) ;
static inline void SetSize( Mtx m, f32 Size ) ;

static s8 FetherCreateCallBack( Vec **Point, void *Data ) ;			// H쐬邽߂̃R[obN֐

// function code --------------------------------

// H쐬邽߂̃R[obN֐
static s8 FetherCreateCallBack( Vec **Point, void *Data )
{
	FEATHERCALL *Call = ( FEATHERCALL * )Data ;
	FEATHEREFFECT *Ft = Call->Ft ;
	FEATHEROBJECT *Ob ;
	f32 Area, x, y  ;
	s32 Num, i ;
	Vec d1, d2, Norm ;
	
	// ʐς߂
	PSVECSubtract( Point[1], Point[0], &d1 ) ;
	PSVECSubtract( Point[2], Point[0], &d2 ) ;
	PSVECCrossProduct( &d2, &d1, &Norm ) ;
	PSVECNormalize( &Norm, &Norm ) ;
	Area = GetPolygonArea( Point ) ;

	// ʐς쐬鐔߂
	Call->CreateCounter += Area * VParam[ED_FEATHER][13] ;
	Num = (s32)Call->CreateCounter ;
	Call->CreateCounter -= (s32)Call->CreateCounter ;

	// IuWFNgǉ
	Ob = &Ft->ObjP[Call->NumCounter] ;
	Call->NumCounter += Num ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
		// f[^
		x = (f32)rand() / RAND_MAX ;
		y = ( 1.0F - x ) * rand() / RAND_MAX ;
		Ob->Point.x = Point[0]->x + d1.x * x + d2.x * y ;
		Ob->Point.y = Point[0]->y + d1.y * x + d2.y * y ;
		Ob->Point.z = Point[0]->z + d1.z * x + d2.z * y ;

		PSVECScale( &Norm, &Ob->Speed, rand() * Ft->Power / RAND_MAX ) ;
		Ob->Rotate.x = rand() * PI_2 / RAND_MAX ;
		Ob->Rotate.y = rand() * PI_2 / RAND_MAX ;
		Ob->Rotate.z = rand() * PI_2 / RAND_MAX ;
		Ob->RotSpeed.x = (f32)rand() / RAND_MAX ;
		Ob->RotSpeed.y = (f32)rand() / RAND_MAX ;
		Ob->RotSpeed.z = (f32)rand() / RAND_MAX ;
		VECNormalize( &Ob->RotSpeed, &Ob->RotSpeed ) ;
		VECScale( &Ob->RotSpeed, &Ob->RotSpeed, Ft->RotSpeed ) ;
		Ob->UseModel = (u8)( rand() * FEATHER_MODELNUM / RAND_MAX ) ;
		if( Ob->UseModel == FEATHER_MODELNUM ) Ob->UseModel -- ;
		Ob->Counter = 0 ;
		Ob->Alpha = 255 ;
		Ob->Color.r = 0 ;		Ob->Color.g = 0 ;
		Ob->Color.b = 0 ;		Ob->Color.a = 0 ;
		Ob->ValidFlag = TRUE ;
	}
	
	// I
	return 0 ;
}



static inline void SetRotRadX( Mtx m, f32 Rot )
{
	m[0][0] = 1.0F ;		m[0][1] = 0.0F ;		m[0][2] = 0.0F ;		m[0][3] = 0.0F ;
	m[1][0] = 0.0F ;		m[1][1] = SINF(Rot) ;	m[1][2] = COSF(Rot) ;	m[1][3] = 0.0F ;
	m[2][0] = 0.0F ;		m[2][1] = COSF(Rot) ;	m[2][2] = -SINF(Rot) ;	m[2][3] = 0.0F ;
}
	
static inline void SetRotRadY( Mtx m, f32 Rot )
{
	m[0][0] = COSF(Rot) ;	m[0][1] = 0.0F ;		m[0][2] = -SINF(Rot) ;	m[0][3] = 0.0F ;
	m[1][0] = 0.0F ;		m[1][1] = 1.0F ;		m[1][2] = 0.0F ;		m[1][3] = 0.0F ;
	m[2][0] = SINF(Rot) ;	m[2][1] = 0.0F ;		m[2][2] = COSF(Rot) ;	m[2][3] = 0.0F ;
}

static inline void SetRotRadZ( Mtx m, f32 Rot )
{
	m[0][0] = COSF(Rot) ;	m[0][1] = -SINF(Rot) ;	m[0][2] = 0.0F ;		m[0][3] = 0.0F ;
	m[1][0] = SINF(Rot) ;	m[1][1] = COSF(Rot) ;	m[1][2] = 0.0F ;		m[1][3] = 0.0F ;
	m[2][0] = 0.0F ;		m[2][1] = 0.0F ;		m[2][2] = 1.0F ;		m[2][3] = 0.0F ;
}

static inline void SetSize( Mtx m, f32 Size )
{
	m[0][0] = Size ;	m[0][1] = 0.0F ;	m[0][2] = 0.0F ;		m[0][3] = 0.0F ;
	m[1][0] = 0.0F ;	m[1][1] = Size ;	m[1][2] = 0.0F ;		m[1][3] = 0.0F ;
	m[2][0] = 0.0F ;	m[2][1] = 0.0F ;	m[2][2] = Size ;		m[2][3] = 0.0F ;
}


// HGtFNg̋ʃf[^
extern s8 InitFeatherData( void )
{
	MEMINIT( FthUnion ) ;

	// HpeNX`[ǂݍ
//	TexLoadSet( FEATHERTEX, &FthUnion.FeatherTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Feathers1_01 ), &FthUnion.FeatherTex ) ;
	
	// Hff[^̓ǂݍ݊Jn
	{
		u32 i ;

		FthUnion.FeatherArc = WK7Archive::Create() ;
//		FthUnion.FeatherArc->LoadArchive( FEATHERMODEL ) ;
		FthUnion.FeatherArc->LoadArchive( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Feathers_M00 ) ) ;
		FthUnion.FeatherArc->SetStatic( true ) ;
		FthUnion.FeatherK7Model = NULL ;

		for( i = 0 ; i < FEATHER_MODELNUM ; i ++ )
		{
			FthUnion.FeatherMesh[i] = NULL ;
		}
	}
	
	// [htO|
	FthUnion.LoadCompFlag = FALSE ;

	// I
	return 0 ;
}

// HGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFeatherData( void )
{
	// t@C̓ǂݍ݂IĂȂ牽ɏI
//	if( TexLoadChk( &FthUnion.FeatherTex ) == FALSE ) return FALSE ;

	// ff[^̓ǂݍ݂IĂȂ牽I
//	if( CHKARCLOAD( FthUnion.FeatherArc ) == FALSE ) return FALSE ;
	
	// ǂݍ݂Ă烂ff[^쐬
	if( FthUnion.LoadCompFlag == FALSE )
	{
		MESH *Mesh ;
		char Name[256] ;
		HSD_DObj *dobj ;
		s32 i ;
	
		// ff[^̍쐬
		FthUnion.FeatherK7Model = FthUnion.FeatherArc->CreateModel() ;
		for( i = 0 ; i < FEATHER_MODELNUM ; i ++ )
		{
			sprintf( Name, "Feather%d", i + 1 ) ;
			dobj = GetHaveMeshDObj( FthUnion.FeatherK7Model->GetObj(Name)->GetJObj() ) ;
			CreatePrimitiveMeshData( FthUnion.FeatherK7Model->GetObj(Name)->GetJObj(),
										dobj, dobj->pobj,
										&Mesh, FALSE, TRUE, FALSE, TRUE, TRUE ) ;
			CreateBasicPrimitiveMeshData( Mesh, &FthUnion.FeatherMesh[i], FALSE, FALSE, FALSE, TRUE ) ;
			DeletePrimitiveMeshData( Mesh ) ;
		}
		
		// ff[^̍폜
		delete FthUnion.FeatherK7Model ;
		FthUnion.FeatherK7Model = NULL ;
		
		// A[JCủ
		delete FthUnion.FeatherArc ;
		FthUnion.FeatherArc = NULL ;

		// ǂݍ݂ItO𗧂Ă
		FthUnion.LoadCompFlag = TRUE ;
	}

	return TRUE ;
}
	


// HGtFNg̋ʃf[^n
extern s8 EndFeatherData( void )
{
	u32 i ;

	// eNX`f[^j
	TexRelease( &FthUnion.FeatherTex ) ;

	// f폜
	if( FthUnion.FeatherK7Model != NULL ){ delete FthUnion.FeatherK7Model ; FthUnion.FeatherK7Model = NULL ; } 
	if( FthUnion.FeatherArc != NULL )
	{
		FthUnion.FeatherArc->SetStatic( false ) ;
		delete FthUnion.FeatherArc ;
		FthUnion.FeatherArc = NULL ;
	}
	for( i = 0 ; i < FEATHER_MODELNUM ; i ++ )
	{
		if( FthUnion.FeatherMesh[i] != NULL ){ DeleteBasicMeshData( FthUnion.FeatherMesh[i] ) ; FthUnion.FeatherMesh[i] = NULL ; }
	}

	// [htO|
	FthUnion.LoadCompFlag = FALSE ;

	// I
	return 0 ;
}


// H̃GtFNg쐬
extern EFFECT *CreateFeatherEffect( s32 FetherNum, Vec Point, f32 Power, f32 RotSpeed,
									u8 QuickTime, f32 QuickRate, f32 DownSpeed,
									u8 CrtTime, u8 FadeSpeed, f32 Air, f32 FeatherR,
									u8 MoveMode, WK7JObj *JObj, s8 WaitTime, f32 Size, s32 Priority )
{
	EFFECT *Effect ;
	FEATHEREFFECT *Ft ;
	u32 i, Num ;
	FEATHEROBJECT *Ob ;

	// 풓f[^̓ǂݍ݃`FbN
	if( CheckFeatherData() == FALSE )return FALSE ;

	// t@C̓ǂݍ݂IĂ炻̑̃f[^\z
/*	if( FthUnion.LoadCompFlag == FALSE )
	{
		MESH *Mesh ;
		char Name[256] ;
		HSD_DObj *dobj ;
	
		// ff[^̍쐬
		FthUnion.FeatherK7Model = FthUnion.FeatherArc->CreateModel() ;
		for( i = 0 ; i < FEATHER_MODELNUM ; i ++ )
		{
			sprintf( Name, "Feather%d", i + 1 ) ;
			dobj = GetHaveMeshDObj( FthUnion.FeatherK7Model->GetObj(Name)->GetJObj() ) ;
			CreatePrimitiveMeshData( FthUnion.FeatherK7Model->GetObj(Name)->GetJObj(),
										dobj, dobj->pobj,
										&Mesh, FALSE, TRUE, FALSE, TRUE, TRUE ) ;
			CreateBasicPrimitiveMeshData( Mesh, &FthUnion.FeatherMesh[i], FALSE, FALSE, FALSE, TRUE ) ;
			DeletePrimitiveMeshData( Mesh ) ;
		}
		
		// ǂݍ݂ItO𗧂Ă
		FthUnion.LoadCompFlag = TRUE ;
	}
*/
	
	// VHf[^쐬
	Effect = AddEffectData( EFF_FEATHER, (void**)&Ft, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// p[^ۑ
	Ft->ObjNum = FetherNum ;
	Ft->Point = Point ;
	Ft->Power = Power ;
	Ft->RotSpeed = RotSpeed ;
	Ft->QuickTime = QuickTime ;
	Ft->QuickRate = QuickRate ;
	Ft->DownSpeed = DownSpeed ;
	Ft->CrtTime = CrtTime ;
	Ft->FadeSpeed = FadeSpeed ;
	Ft->Mode = (u8)VParam[ED_FEATHER][0] ;
	Ft->Air = Air ;
	Ft->FadeOutNum = 0 ;
	Ft->MoveMode = MoveMode ;
	Ft->Counter = 0 ;
	Ft->FeatherR = FeatherR ;
	Ft->FeatherCounter = 0.0F ;
	Ft->OneFeatherPoint = ( CrtTime + ( 255 / FadeSpeed ) ) / (f32)FetherNum ; 
	Ft->WaitTime = WaitTime ;
	Ft->Size = Size ;
	
	// ff[^nĂĉH[h̏ꍇ͏𕪊
	if( JObj != NULL && MoveMode == 0 )
	{
		f32 Area ;
		MODEL *Model ;
	
		// f쐬
		CreateModelData( JObj->GetJObj(), &Model, FALSE, FALSE, TRUE, TRUE ) ;
			
		// |S̑ʐςZo
		Area = GetModelPolygonArea( Model ) ;

		// ʐς琔Zo
		FetherNum = (u16)( Area * FetherNum ) ;

		// HIuWFNg̃f[^i[郁̈mۂ
		Ft->ObjP = ( FEATHEROBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( FEATHEROBJECT ) * FetherNum ), "Y_FthObj" ) ;
		if( Ft->ObjP == NULL )
		{
			// f폜
			DeleteModelData( Model ) ;
		
			DeleteEffect( Effect ) ;
			return NULL ;
		}
		
		// f[^쐬
		{
			FEATHERCALL Call ;
			
			Call.Ft = Ft ;
			Call.CreateCounter = 0.0F ;
			Call.NumCounter = 0 ;
			
			ScanModelPrimitive( Model, FetherCreateCallBack, &Call ) ;

			// ۑ
			Ft->ObjNum = (u16)Call.NumCounter ;
		}

		// f폜
		DeleteModelData( Model ) ;
	}
	else
	{
		// HIuWFNg̃f[^i[郁̈mۂ
		Ft->ObjP = ( FEATHEROBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( FEATHEROBJECT ) * FetherNum ), "Y_FthObj" ) ;
		if( Ft->ObjP == NULL ){ DeleteEffect( Effect ) ; return NULL ; }

		// HIuWFNg̏
		Ob = Ft->ObjP ;
		Num = (u32)Ft->ObjNum ;
		switch( MoveMode )
		{
		case 0 :	// H[h
			for( i = 0 ; i < Num ; i ++, Ob ++ )
			{
				// f[^
				Ob->Point = Point ;
				{
					f32 Oir, Xz ;
					
					Oir = (f32)rand() * PI / RAND_MAX - PI / 2.0F ;
					Xz = (f32)rand() * PI_2 / RAND_MAX ;
					Ob->Speed.x = cosf( Oir ) ;
					Ob->Speed.y = sinf( Oir ) ;
					Ob->Speed.z = sinf( Xz ) * Ob->Speed.x ;
					Ob->Speed.x = cosf( Xz ) * Ob->Speed.x ;
					VECScale( &Ob->Speed, &Ob->Speed, rand() * Power / RAND_MAX ) ;
				}
				Ob->Rotate.x = rand() * PI_2 / RAND_MAX ;
				Ob->Rotate.y = rand() * PI_2 / RAND_MAX ;
				Ob->Rotate.z = rand() * PI_2 / RAND_MAX ;
				Ob->RotSpeed.x = (f32)rand() / RAND_MAX ;
				Ob->RotSpeed.y = (f32)rand() / RAND_MAX ;
				Ob->RotSpeed.z = (f32)rand() / RAND_MAX ;
				VECNormalize( &Ob->RotSpeed, &Ob->RotSpeed ) ;
				VECScale( &Ob->RotSpeed, &Ob->RotSpeed, RotSpeed ) ;
				Ob->UseModel = (u8)( rand() * FEATHER_MODELNUM / RAND_MAX ) ;
				if( Ob->UseModel == FEATHER_MODELNUM ) Ob->UseModel -- ;
				Ob->Counter = 0 ;
				Ob->Alpha = 255 ;
				Ob->Color.r = 0 ;		Ob->Color.g = 0 ;
				Ob->Color.b = 0 ;		Ob->Color.a = 0 ;
				Ob->ValidFlag = TRUE ;
			}
			break ;
			
		case 1 :	// H[h
			for( i = 0 ; i < Num ; i ++, Ob ++ )
			{
				// f[^
				Ob->ValidFlag = FALSE ;
			}
			Ft->FadeOutNum = Ft->ObjNum ;
			break ;
		}
	}

	// I
	return Effect ;
}

// H̃GtFNǧns
extern s8 ReleaseFeatherEffect( EFFECT *Effect )
{
	FEATHEREFFECT *Ft = ( FEATHEREFFECT * )Effect->Data ;

	// HGtFNgIuWFNgp̃J
	CHKMEMFREE2( Ft->ObjP ) ;

	// I
	return 0 ;
}

// H̃GtFNgPt[
extern s8 MoveFeatherEffect( EFFECT *Effect )
{
	FEATHEREFFECT *Ft = ( FEATHEREFFECT * )Effect->Data ;
	u32 i, Num ;
	FEATHEROBJECT *Ob ;
	f32 k ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// ҂Ԃꍇ͑҂
	if( Ft->WaitTime != 0 )
	{
		Ft->WaitTime -- ;
		return 0 ;
	}

	// H̐JԂ
	Num = (u32)Ft->ObjNum ;
	Ob = Ft->ObjP ;
	for( i = 0 ; i < Num ; i ++, Ob ++ )
	{
		// LtOĂȂ牽Ȃ
		if( Ob->ValidFlag == FALSE ) continue ;
		
		// ړ{Zo
		k = Ft->MoveMode != 0 ? 1.0F : ( Ob->Counter < Ft->QuickTime ? 1.0F + ( Ft->QuickRate - 1.0F ) * ( (f32)( Ft->QuickTime - Ob->Counter ) / Ft->QuickTime ) : 1.0F ) ;

		// ړ
		Ob->Point.x += ( Ob->Speed.x ) * k ;
		Ob->Point.y += ( Ob->Speed.y ) * k ;
		Ob->Point.z += ( Ob->Speed.z ) * k ;

		// CR
		Ob->Speed.x *= Ft->Air ;
		Ob->Speed.y *= Ft->Air ;
		Ob->Speed.z *= Ft->Air ;
		
		// ~
		Ob->Point.y -= Ft->DownSpeed ;
		
		// ]
		Ob->Rotate.x += Ob->RotSpeed.x * ( 1.0F + k * 0.1F ) ;
		Ob->Rotate.y += Ob->RotSpeed.y * ( 1.0F + k * 0.1F ) ;
		Ob->Rotate.z += Ob->RotSpeed.z * ( 1.0F + k * 0.1F ) ;
		
		// JE^̃CNg
		Ob->Counter ++ ;
		
		// At@l̃Zbg
		{
			s16 a ;
			
			a = (s16)( Ft->CrtTime > Ob->Counter ? 255 : 
						255 - ( Ob->Counter - Ft->CrtTime ) * Ft->FadeSpeed ) ;
			Ob->Alpha = (u8)( a < 0 ? 0 : a ) ;
		}
		if( Ob->Alpha == 0 )
		{
			Ob->ValidFlag = FALSE ;
			Ft->FadeOutNum ++ ;
		}
		
		// F̃Zbg
		Ob->Color.r = 255 ;
		Ob->Color.g = 255 ;
		Ob->Color.b = 255 ;
		Ob->Color.a = 255 ;
	}
	
	// 샂[hɂď𕪊
	switch( Ft->MoveMode )
	{
	case 0 :
		// H[h
	
		// ׂẲHtF[hAEgꍇ̓GtFNg폜
		if( Ft->FadeOutNum == Ft->ObjNum )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		break ;
		
	case 1 :
		// H~胂[h
		{
			FEATHEROBJECT *Ob ;
		
			// JE^
			Ft->FeatherCounter ++ ;
			
			// JE^Kl𒴂ĂH𕑂~点
			while( Ft->FeatherCounter > Ft->OneFeatherPoint && Ft->FadeOutNum != 0 )
			{
				// gĂȂHf[^T
				for( Ob = Ft->ObjP ; Ob->ValidFlag == TRUE ; Ob ++ ){}
				
				// LtO𗧂Ă
				Ob->ValidFlag = TRUE ;
				
				// W̎Zo
				{
					f32 /*k,*/ r ;
					
//					k = PI_2 * ( (f32)rand() / RAND_MAX ) ;
//					k = (f32)rand() / RAND_MAX ;
					r = rand() * Ft->FeatherR / RAND_MAX ;
					Ob->Point.y = Ft->Point.y ;
					Ob->Point.x = rand() * Ft->FeatherR / RAND_MAX - Ft->FeatherR / 2 + Ft->Point.x ;
					Ob->Point.z = rand() * Ft->FeatherR / RAND_MAX - Ft->FeatherR / 2 + Ft->Point.z ;
//					Ob->Point.x = cosf( k ) * r + Ft->Point.x ;
//					Ob->Point.z = sinf( k ) * r + Ft->Point.z ;
				}
				Ob->Speed.x = 0.0F ;
				Ob->Speed.y = 0.0F ;
				Ob->Speed.z = 0.0F ;
				Ob->Rotate.x = rand() * PI_2 / RAND_MAX ;
				Ob->Rotate.y = rand() * PI_2 / RAND_MAX ;
				Ob->Rotate.z = rand() * PI_2 / RAND_MAX ;
				Ob->RotSpeed.x = (f32)rand() / RAND_MAX ;
				Ob->RotSpeed.y = (f32)rand() / RAND_MAX ;
				Ob->RotSpeed.z = (f32)rand() / RAND_MAX ;
				VECNormalize( &Ob->RotSpeed, &Ob->RotSpeed ) ;
				VECScale( &Ob->RotSpeed, &Ob->RotSpeed, Ft->RotSpeed ) ;
				Ob->UseModel = (u8)( rand() * FEATHER_MODELNUM / RAND_MAX ) ;
				if( Ob->UseModel == FEATHER_MODELNUM ) Ob->UseModel -- ;
				Ob->Counter = 0 ;
				Ob->Alpha = 255 ;
				Ob->Color.r = 0 ;		Ob->Color.g = 0 ;
				Ob->Color.b = 0 ;		Ob->Color.a = 0 ;
				
				// 쒆̉H̐𑝂₷
				Ft->FadeOutNum -- ;
				
				// JE^̒l炷
				Ft->FeatherCounter -= Ft->OneFeatherPoint ;
			}
		}
		break ;
	}	

	// I
	return 0 ;
}

// H̃GtFNg`悷
extern s8 DrawFeatherEffect( EFFECT *Effect )
{
	FEATHEREFFECT *Ft = ( FEATHEREFFECT * )Effect->Data ;
	u32 j, i, k, Num, DrawVertNum, MoveNum ;
	FEATHEROBJECT *Ob ;
	FEATHERUNION *FeatherUnion = &FthUnion ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, Ft->Mode != 0 ? EF_BLEND_ALPHA : EF_BLEND_ADD, EF_TEV_USETEX ) ;

	// eNX`̃[h
	GTLOAD2( FeatherUnion->FeatherTex ) ;

	// `揈
	MoveNum = (u32)( Ft->ObjNum - Ft->FadeOutNum ) ;
	DrawVertNum = 0 ;
	{
		BASICMESH *Bas ;
		u32 Num2 ;
		Mtx m1, ms  ;

		SetSize( ms, Ft->Size ) ;
				
		Ob = Ft->ObjP ;
		Num2 = (u32)Ft->ObjNum ;
		k = 0 ;
		for( j = 0 ; j < Num2 ; j ++, Ob ++ )
		{
			// LtOĂȂ玟
			if( Ob->ValidFlag == FALSE ) continue ;

			if( k == DrawVertNum )
			{
				if( k != 0 ) GXEnd() ;
				MoveNum -= k ;
				k = 0 ;
				DrawVertNum = MoveNum * 16 > 65535 ? 65535 / 16 : MoveNum ;
				
				GBGN( GX_TRIANGLESTRIP, 16 * DrawVertNum ) ;
			}
			k ++ ;
			
			// ȈՃbVf[^ւ̃|C^Zbg
			Bas = FthUnion.FeatherMesh[Ob->UseModel] ;

			// s̎Zo
			{
				Mtx mx, my, mz, m2 /*, ms*/ ;

				SetRotRadX( mx, Ob->Rotate.x ) ;
				SetRotRadY( my, Ob->Rotate.y ) ;
				SetRotRadZ( mz, Ob->Rotate.z ) ;
				
				if( Ft->Size != 1.0F )
				{
					PSMTXConcat( my, ms, m1 ) ;
					PSMTXConcat( mx, m1, m2 ) ;
					PSMTXConcat( mz, m2, m1 ) ;

					m1[0][3] = Ob->Point.x ;
					m1[1][3] = Ob->Point.y ;
					m1[2][3] = Ob->Point.z ;
				}
				else
				{
					PSMTXConcat( my, mx, m1 ) ;
					PSMTXConcat( mz, m1, m2 ) ;

					m2[0][3] = Ob->Point.x ;
					m2[1][3] = Ob->Point.y ;
					m2[2][3] = Ob->Point.z ;
					
					PSMTXCopy( m2, m1 ) ;
				}
			}

			// `
			{
				Vec V ;
				
				// _WJԂ
				Num = Bas->IndexNum ;
				i = 0 ;
				PSMTXMultVec( m1, ((Vec*)( (u8*)Bas->Point + Bas->Stride * Bas->Index[i]) ), &V ) ;
				GPV( V ) ;	GCX( 0xffffffff ) ;
				GT( (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i] ))->u, (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i] ))->v ) ; 
				for( i = 0 ; i < Num ; i ++ )
				{
					PSMTXMultVec( m1, ((Vec*)( (u8*)Bas->Point + Bas->Stride * Bas->Index[i]) ), &V ) ;
					GPV( V ) ;	GCX( 0xffffff00 + Ob->Alpha ) ;
					GT( (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i] ))->u, (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i] ))->v ) ; 
				}
				
				// Ō̒_̏o
				GPV( V ) ;	GCX( 0xffffffff ) ;
				GT( (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i-1] ))->u, (( UV * )( (u8*)Bas->Uv + Bas->Stride * Bas->Index[i-1] ))->v ) ; 
			}
		}
	}
	GXEnd() ;
	
	// I
	return 0 ;
}					


// H钆S_ύX
extern s8 SetFeatherEffectPoint( EFFECT *Effect, Vec Point )
{
	FEATHEREFFECT *Ft = ( FEATHEREFFECT * )Effect->Data ;

	// WύX
	Ft->Point = Point ;

	// I
	return 0 ;
}


