///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlyBlood
//
// YK7EffectFlyBlood.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/31/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectBlood.h"
#include "./YK7EffectFlyBlood.h"
#include "../matsu/mk7Sound.h"

// define ---------------------------------------

#define FLYBLOODTEX 		"/yam/FlyBlood_test9.BIN"		// ьGtFNgp̃eNX`t@C
#define FLYBLOODTEX_SMOKE 	"/yam/FlyBloodSplat_P2.BIN"		// ьGtFNgp̃eNX`t@C

// ь̍W
Vec FlyBaseVert[4] = 
{
	-0.5F,	0.0F,	0.5F,
	-0.5F,	0.0F,	-0.5F,
	0.5F,	0.0F,	-0.5F,
	0.5F,	0.0F,	0.5F
} ;

#define FLYBLOODDEF_NUM		5
#define HOKAN				3


// datatype -------------------------------------

typedef struct tagFLYBLOODDEF
{
	f32 Length, Power, BloodNum, BloodSize ;
} FLYBLOODDEF ;

// data -----------------------------------------

FLYBLOODUNION FBUnion ;

FLYBLOODDEF FlyBloodTable[FLYBLOODDEF_NUM] =
{
//		Length			Power		FlyBloodNum		FlyBloodSize
	{	20.0F,			1.0F,		1.0F,			1.0F	},
	{	40.0F,			1.0F,		0.4F,			1.6666F	},
	{	82.0F,			2.25F,		0.3F,			2.5F	},
	{	155.390366F,	2.75F,		0.3F,			3.3333F	},
	{	231.325882F,	3.5F,		0.3F,			4.8333F	},
} ;

// function proto type --------------------------

// function code --------------------------------


// ьGtFNg̋ʃf[^
extern s8 InitFlyBloodData( void )
{
	MEMINIT(FBUnion) ;

	MeshManageInit() ;

	// I
	return 0 ;
}

// ьGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFlyBloodData( void )
{
	return TRUE ;
}


// ьGtFNg̋ʃf[^n
extern s8 EndFlyBloodData( void )
{
	MEMINIT(FBUnion) ;

	MeshManageTerm() ;

	// I
	return 0 ;
}

// ь̃GtFNg쐬
extern EFFECT *CreateFlyBloodEffect( Vec Point, Vec Direction, f32 yzRot, f32 Power, f32 VibPower, 
										f32 VibRotWidth, f32 VibSpeed, f32 BloodSize,
										f32 AirRes, f32 Gravity, u8 Wait, f32 YukaY,
										u16 FadeOutWait, u16 FadeOutTime,
										GXColor Color, u8 ColorRand,
										f32 Width, s16 Time, WK7JObj *JObj, u32 VertexNumber,
										f32 MovePower, u8 Type, 
										u16 ObjMaxNum, u16 NofObjMaxNum, s32 Priority )
{
	EFFECT *Effect ;
	FLYBLOODEFFECT *FlyBlood ;
	f32 f, Sin, Cos ;
	u32 HopeNumber ;

//	return NULL ;

	// JObj nĂꍇ́Ã{[̃[JWɗƂ
/*	if( JObj != NULL )
	{
		HSD_JObj *jobj ;
		Mtx mtx ;
		
		// vZĂȂƂׂ̈ɌvZ֐
		jobj = JObj->GetJObj() ;
		HSD_JObjSetupMatrix( jobj ) ;
		
		// Wƕ[JɗƂ
		if( jobj->envelopemtx != NULL )
			memcpy( mtx, jobj->envelopemtx, sizeof( Mtx ) ) ;
		else
			if( MTXInverse( jobj->mtx, mtx ) == 0 ) return NULL ;
				
		MTXMultVec( mtx, &Point, &Point ) ;
		
		mtx[2][3] = mtx[1][3] = mtx[0][3] = 0.0F ;
		MTXMultVec( mtx, &Direction, &Direction ) ;
	}
*/
	// Vьf[^쐬
	Effect = AddEffectData( EFF_FLYBLOOD, (void**)&FlyBlood, Priority, 8 ) ;
	if( Effect == NULL ) return NULL ;
	
	memset( FlyBlood, 0, sizeof( FLYBLOODEFFECT ) ) ;
	FlyBlood->Mesh = NULL ;
	FlyBlood->NofObj = NULL ;
	FlyBlood->Obj = NULL ;
	FlyBlood->MeshInfoID = -1 ; 
	
	// JObj nĂꍇ́A_io[WZo
	if( JObj != NULL )
	{
		HSD_PObj *pobj ;
		HSD_DObj *dobj ;
//		HSD_PObj *pobj ;
		
		// ]̔ԍbVf[^̃AhX𓾂
		if( GetHaveHopeNumberVertexPObj( JObj->GetJObj(), VertexNumber, &HopeNumber, &pobj, &dobj ) < 0 ) 
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}

		// ܂bVf[^͂
		{
			if( ( FlyBlood->MeshInfoID = CreateMeshData( JObj, dobj, pobj ) ) < 0 )
			{
				DeleteEffect( Effect ) ;
				return NULL ;
			}
			FlyBlood->Mesh = GetMeshData( FlyBlood->MeshInfoID )->Mesh ;
		}
/*
		if( CreatePrimitiveMeshData( JObj->GetJObj(), pobj, &FlyBlood->Mesh, TRUE, TRUE, FALSE, FALSE ) != 0 )
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}
*/
		// _̍WƖ@擾
		GetHopeNumberVertexPositionAndNormal( FlyBlood->Mesh, HopeNumber/*VertexNumber*/, &Point, &Direction ) ;
/*		Point.x = JObj->GetJObj()->mtx[0][3] ;
		Point.y = JObj->GetJObj()->mtx[1][3] ;
		Point.z = JObj->GetJObj()->mtx[2][3] ;
		Direction.x = 1.0F ;
		Direction.z = Direction.y = 0.0F ;
*/	}

	// 𑪂ăp[^
	{
		Vec BPoint, CPoint ;
		f32 Length, f ;
		FLYBLOODDEF TBDef ;
		s32 i ;
		
		BPoint = Point ;

		HSD_CObjGetEyePosition( GetEffectCamera(), &CPoint ) ;
		Length = sqrt( VECSquareDistance( &BPoint, &CPoint ) ) ;
		
		// ǂ̃e[uɓ邩o
		for( i = 0 ; i < FLYBLOODDEF_NUM && Length > FlyBloodTable[i].Length ; i ++ ){}
		if( i == FLYBLOODDEF_NUM )
		{
			TBDef = FlyBloodTable[i-1] ;
		}
		else
		if( i == 0 )
		{
			TBDef = FlyBloodTable[0] ;
		}
		else
		{
			FLYBLOODDEF *BDef1, *BDef2 ;
			
			BDef2 = &FlyBloodTable[i] ;
			BDef1 = &FlyBloodTable[i-1] ;
			
			f = ( Length - BDef1->Length ) / ( BDef2->Length - BDef1->Length ) ;
			TBDef.BloodSize = f * ( BDef2->BloodSize - BDef1->BloodSize ) + BDef1->BloodSize ;
			TBDef.BloodNum = f * ( BDef2->BloodNum - BDef1->BloodNum ) + BDef1->BloodNum ;
			TBDef.Power = f * ( BDef2->Power - BDef1->Power ) + BDef1->Power ;
		}

		// ␳
		Power *= TBDef.Power ;
		VibPower *= TBDef.Power ;
//		BloodNum = (u32)( BloodNum * TBDef.BloodNum ) ;
//		if( BloodNum == 0 ) BloodNum = 1 ;
		BloodSize *= TBDef.BloodSize ;
	}
	
	// 𕪉
	FlyBlood->xzRot = atan2( Direction.z, Direction.x ) ;
	{
		Sin = SINF( -FlyBlood->xzRot ) ; Cos = COSF( -FlyBlood->xzRot ) ;
		f = Direction.x * Cos - Direction.z * Sin ;
		Direction.z = Direction.x * Sin + Direction.z * Cos ;
		Direction.x = f ;
	}
	FlyBlood->xyRot = atan2( Direction.y, Direction.x ) ;
	FlyBlood->yzRot = yzRot == 0.0F ? rand() * PI / RAND_MAX - PI / 2.0F : yzRot ;
	FlyBlood->yzVibRot = 0.0F ;
	FlyBlood->VibCounter = 0 ;

	// p[^ۑ
	FlyBlood->Power = Power ;
	FlyBlood->VibPower = VibPower ;
	FlyBlood->VibSpeed = VibSpeed ;
	FlyBlood->VibRotWidth = VibRotWidth ;
	FlyBlood->BloodSize = BloodSize ;
	FlyBlood->AirRes = AirRes ;
	FlyBlood->Gravity = Gravity ;
	FlyBlood->Wait = Wait ;
	FlyBlood->YukaY = YukaY ;
	FlyBlood->FadeOutWait = FadeOutWait ;
	FlyBlood->FadeOutTime = FadeOutTime ;
	FlyBlood->Color = Color ;
	FlyBlood->ColorRand = ColorRand ;
	FlyBlood->Point = Point ;
	FlyBlood->Width = Width ;
	FlyBlood->SpeedRate = 1.0F ;
	FlyBlood->Time = Time ;
	FlyBlood->TimeCounter = 0.0F ;
	FlyBlood->JObj = JObj ;
	FlyBlood->VertexNumber = HopeNumber/*VertexNumber*/ ;
	FlyBlood->MovePower = MovePower ;
	FlyBlood->AddPower = 0.0F ;
	FlyBlood->NofObjMaxNum = NofObjMaxNum ;
	FlyBlood->ObjMaxNum = ObjMaxNum ;
	
	// ̊m
	if( ( FlyBlood->NofObj = ( NOFLYBLOODOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( NOFLYBLOODOBJECT ) * NofObjMaxNum ) , "Y_FlbObj" ) ) == NULL )
	{
		DeleteEffect( Effect ) ;
		return NULL ;
	}
	memset( FlyBlood->NofObj, 0, sizeof( NOFLYBLOODOBJECT ) * NofObjMaxNum ) ;
	if( ( FlyBlood->Obj = ( FLYBLOODOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( FLYBLOODOBJECT ) * ObjMaxNum ),  "Y_FldNObj" ) ) == NULL )
	{
		K7AppSmallMemFree( FlyBlood->NofObj ) ;
		FlyBlood->NofObj = NULL ;
		DeleteEffect( Effect ) ;
		return NULL ;
	}
	memset( FlyBlood->Obj, 0, sizeof( FLYBLOODOBJECT ) * ObjMaxNum ) ;

	// px̏
	{
		u16 i ;

		for( i = 0 ; i < FLYBLOOD_VIBSIN ; i ++ )
		{
			FlyBlood->VibSin[i] = rand() * PI_2 / RAND_MAX ;
			FlyBlood->VibSinSp[i] = rand() * ( PI_2 / 30 * VParam[ED_FLYBLOOD][21] ) / RAND_MAX ;
		}
	}

	// IuWFNgf[^
	FlyBlood->ObjNum = 0 ;
	FlyBlood->NofObjNum = 0 ;
	FlyBlood->ObjCounter = 0.0F ;
//	memset( FlyBlood->Obj, 0, sizeof( FlyBlood->Obj ) ) ;
//	memset( FlyBlood->NofObj, 0, sizeof( FlyBlood->NofObj ) ) ;
	FlyBlood->FirstObj = 0 ;
	FlyBlood->LastObj = 0 ;

	// ^CvP͍̎ŏɈCɏo
	if( Type == 1 )
	{
		FLYBLOODOBJECT *Obj ;
		u16 Pattern, i, n, j ;

		for( n = 0 ; n < HOKAN ; n ++ )
		{
			FlyBlood->ObjCounter += FlyBlood->SpeedRate ;
			if( FlyBlood->ObjNum == FlyBlood->ObjMaxNum/*FLYBLOOD_MAXOBJECTNUM*/ ) break ;
			{
				f32 Power, yzRot, f ;
#ifdef _DEBUG
				FLYBLOODOBJECT NewObj ;
#endif
				f32 Total ;

				for( Obj = FlyBlood->Obj, i = 0 ; Obj->UseFlag == TRUE ; Obj ++, i ++ ){}

				// p[^̏
				Pattern = (u16)( rand() * BLOODPAT_NUM / RAND_MAX ) ;
				if( Pattern == BLOODPAT_NUM ) Pattern = 0 ;
				Obj->UseFlag = TRUE ;
				Obj->iu = (u16)( ( UVSCALE * ( Pattern % BLOODPAT_ONELINENUM ) ) / BLOODPAT_ONELINENUM ) ;
				Obj->iv = (u16)( ( UVSCALE * ( Pattern / BLOODPAT_ONELINENUM ) ) / ( BLOODPAT_NUM / BLOODPAT_ONELINENUM ) ) ;

				// ͂Zo
				{
					Power = FlyBlood->Power ;
					Total = 0.0F ;
					for( j = 0 ; j < FLYBLOOD_VIBSIN ; j ++ )
						Total += SINF( FlyBlood->VibSin[j] ) ;
					Power += Total / FLYBLOOD_VIBSIN * FlyBlood->VibPower + FlyBlood->AddPower ;
					Power = Power * ( n + 1 ) / HOKAN ;
				}

				// {[ɏ]ĂꍇƂłȂꍇŏ𕪊
				if( FlyBlood->JObj != NULL )
				{
					Vec Direction ;

					// _̍WƖ@擾
					GetHopeNumberVertexPositionAndNormal( FlyBlood->Mesh, FlyBlood->VertexNumber, &Obj->Point, &Direction ) ;

					// 𕪉
					Direction.x += 0.1f;
					VECNormalize( &Direction, &Direction);
					FlyBlood->xzRot = atan2( Direction.z, Direction.x ) ;
					{
						Sin = SINF( -FlyBlood->xzRot ) ; Cos = COSF( -FlyBlood->xzRot ) ;
						f = Direction.x * Cos - Direction.z * Sin ;
						Direction.z = Direction.x * Sin + Direction.z * Cos ;
						Direction.x = f ;
					}
					FlyBlood->xyRot = atan2( Direction.y, Direction.x ) ;

					// x|
					VECScale( &Obj->Speed, &Obj->Speed, Power ) ;
				}


				{
					// ݒ
					yzRot = FlyBlood->VibRotWidth * SINF( FlyBlood->yzVibRot ) + FlyBlood->yzRot ;
					Obj->Speed.x = Power ;
					Obj->Speed.y = SINF( FlyBlood->xyRot ) * Obj->Speed.x ;
					Obj->Speed.x = COSF( FlyBlood->xyRot ) * Obj->Speed.x ;
					Obj->Speed.z = -SINF( yzRot ) * Obj->Speed.y ;
					Obj->Speed.y = COSF( yzRot ) * Obj->Speed.y ;
					Sin = SINF( FlyBlood->xzRot ) ; Cos = COSF( FlyBlood->xzRot ) ;
					f = Cos * Obj->Speed.x - Sin * Obj->Speed.z ;
					Obj->Speed.z = Sin * Obj->Speed.x + Cos * Obj->Speed.z ;
					Obj->Speed.x = f ;
				}
	
				Obj->Flag = FALSE ;
				Obj->RotType = (u8)( rand() * 4 / RAND_MAX ) ;
				if( Obj->RotType == 4 ) Obj->RotType = 0 ;
				Obj->Width = ( FLYBLOOD_VIBSIN - Total * 2.0f ) * FlyBlood->Width ;
				if( Obj->Width <= 0.0F ) Obj->Width = 0.1F ;

				// F̌
				{
					s16 c ;
					
					Obj->Color = FlyBlood->Color ;
					c = Obj->Color.r ;
					if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
					if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
					Obj->Color.r = (u8)c ;
					c = Obj->Color.g ;
					if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
					if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
					Obj->Color.g = (u8)c ;
					c = Obj->Color.b ;
					if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
					if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
					Obj->Color.b = (u8)c ;
				}

				// AhXݒ
				if( FlyBlood->ObjNum == 0 )
				{
					Obj->back = -1 ;
					Obj->next = -1 ;
					FlyBlood->LastObj = FlyBlood->FirstObj = i ;
				}
				else
				{
					FlyBlood->Obj[FlyBlood->LastObj].next = (s16)i ;
					Obj->back = (s16)FlyBlood->LastObj ;
					Obj->next = -1 ;
					FlyBlood->LastObj = i ;
				}

				// IuWFNg̐̃CNg
				FlyBlood->ObjNum ++ ;
						
				// pxi߂			
				for( j = 0 ; j < FLYBLOOD_VIBSIN ; j ++ )
				{
					FlyBlood->VibSin[j] += FlyBlood->VibSinSp[j] / HOKAN ;
				}

				// h炬̐
				FlyBlood->yzVibRot += FlyBlood->VibSpeed / 10.0F / HOKAN ;
				if( FlyBlood->yzVibRot >= PI_2 ) FlyBlood->yzVibRot -= PI_2 ;
				
				// ZXs[h̉Z
				FlyBlood->AddPower += FlyBlood->MovePower / HOKAN ;

				// JE^̏AIuWFNg̐̃CNg
				FlyBlood->ObjCounter -= FlyBlood->Wait ;

#ifdef _DEBUG
				// ̃IuWFNgۑ
				FlyBlood->BackObj = NewObj ;
#endif
			}
//			FlyBlood->TimeCounter += FlyBlood->SpeedRate ;
		}

		FlyBlood->TimeCounter = FlyBlood->Time * HOKAN ;
	}
		

	// I
	return Effect ;
}

// ь̃GtFNǧns
extern s8 ReleaseFlyBloodEffect( EFFECT *Effect )
{
	FLYBLOODEFFECT *FlyBlood = ( FLYBLOODEFFECT * )Effect->Data ;

	// 쐬bVf[^
	if( FlyBlood->MeshInfoID >= 0 )
		ReleaseMeshData( FlyBlood->MeshInfoID ) ;
/*
	if( FlyBlood->JObj != NULL && FlyBlood->Mesh != NULL )
	{
		DeletePrimitiveMeshData( FlyBlood->Mesh ) ;
		FlyBlood->Mesh = NULL ;
	}
*/
	
	// ̉
	if( FlyBlood->Obj != NULL )
	{
		K7AppSmallMemFree( FlyBlood->Obj ) ;
		FlyBlood->Obj = NULL ;
	}
	if( FlyBlood->NofObj != NULL )
	{
		K7AppSmallMemFree( FlyBlood->NofObj ) ;
		FlyBlood->NofObj = NULL ;
	}

	// I
	return 0 ;
}

// ь̃GtFNgt[ړ
extern s8 MoveFlyBloodEffect( EFFECT *Effect )
{
	FLYBLOODEFFECT *FlyBlood = ( FLYBLOODEFFECT * )Effect->Data ;
	FLYBLOODOBJECT *Obj ;
	NOFLYBLOODOBJECT *NObj ;
	f32 Sin, Cos ;
//	u16 i ;
	Vec Point, Dir ;
	
	// {[ɏ]Ăꍇ͗\ߔ˓_ƕ擾Ă
	if( FlyBlood->JObj != NULL )
	{
		// _̍WƖ@擾
		GetHopeNumberVertexPositionAndNormal( FlyBlood->Mesh, FlyBlood->VertexNumber, &Point, &Dir ) ;
/*		Point.x = FlyBlood->JObj->GetJObj()->mtx[0][3] ;
		Point.y = FlyBlood->JObj->GetJObj()->mtx[1][3] ;
		Point.z = FlyBlood->JObj->GetJObj()->mtx[2][3] ;
		Dir.x = 1.0F ;
		Dir.z = Dir.y = 0.0F ;
*/	}

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE ||
			(	FlyBlood->Time < FlyBlood->TimeCounter &&
				FlyBlood->Time != -1 &&
				FlyBlood->NofObjNum == 0 && FlyBlood->ObjNum == 0
			)
		)
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	{
		u16 Pattern, i, n, j ;

		for( n = 0 ; n < HOKAN ; n ++ )
		{
			FlyBlood->ObjCounter += FlyBlood->SpeedRate ;

			if( Effect->DelReqFlag != TRUE )
			{
				// ςɂȂĂ܂ꍇ͂VɃf[^͍Ȃ
				if( FlyBlood->ObjNum == FlyBlood->ObjMaxNum ) Effect->DelReqFlag = TRUE ;
				
				// JObj \ɂȂVɃf[^͍Ȃ
//				if( ( FlyBlood->JObj->GetJObj()->flags & JOBJ_HIDDEN ) != 0 ) Effect->DelReqFlag = TRUE ;

/*
				if( FlyBlood->JObj != NULL )
				{
					s32 hr ;
					
					hr = FlyBlood->JObj->GetJObj()->flags & JOBJ_HIDDEN ;
					if( hr )
					{
						hr = 0 ;
					}
					else
					{
						hr = 1 ;
					}
				}
*/
				while( 
//					( FlyBlood->JObj != NULL && ( FlyBlood->JObj->GetJObj()->flags & JOBJ_HIDDEN ) == 0 ) &&
					( FlyBlood->JObj != NULL && FlyBlood->JObj->IsHidden() == false ) &&
					Effect->DelReqFlag != TRUE &&
					FlyBlood->ObjCounter >= FlyBlood->Wait &&
					FlyBlood->ObjNum < FlyBlood->ObjMaxNum &&
					( FlyBlood->Time == -1 || FlyBlood->Time > FlyBlood->TimeCounter ) )
				{
					f32 Power, yzRot, f ;
	#ifdef _DEBUG
					FLYBLOODOBJECT NewObj ;
	#endif
					f32 Total ;
	//				Mtx mtx ;

					// gĂȂIuWFNgT
					for( Obj = FlyBlood->Obj, i = 0 ; Obj->UseFlag == TRUE ; Obj ++, i ++ ){}

					// p[^̏
					Pattern = (u16)( rand() * BLOODPAT_NUM / RAND_MAX ) ;
					if( Pattern == BLOODPAT_NUM ) Pattern = 0 ;
					Obj->UseFlag = TRUE ;
					Obj->iu = (u16)( ( UVSCALE * ( Pattern % BLOODPAT_ONELINENUM ) ) / BLOODPAT_ONELINENUM ) ;
					Obj->iv = (u16)( ( UVSCALE * ( Pattern / BLOODPAT_ONELINENUM ) ) / ( BLOODPAT_NUM / BLOODPAT_ONELINENUM ) ) ;

					// ͂Zo
					{
						Power = FlyBlood->Power ;
						Total = 0.0F ;
		//				Power += sin( FlyBlood->VibSin[0] ) * FlyBlood->VibPower ;
						for( j = 0 ; j < FLYBLOOD_VIBSIN ; j ++ )
							Total += SINF( FlyBlood->VibSin[j] ) ;
						Power += Total / FLYBLOOD_VIBSIN * FlyBlood->VibPower + FlyBlood->AddPower ;
					}

					// {[ɏ]ĂꍇƂłȂꍇŏ𕪊
					if( FlyBlood->JObj != NULL )
					{
						Vec Direction ;
	//					f32 Cos, Sin, f ;
						// vZĂȂƂׂ̈Ɋ֐ɂ
	/*					HSD_JObjSetupMatrix( FlyBlood->JObj->GetJObj() ) ;
						
						// s𓾂
						if( FlyBlood->JObj->GetJObj()->mtx != NULL )
						{
							//memcpy( mtx, FlyBlood->JObj->GetJObj()->mtx, sizeof( Mtx ) ) ;
							MTXCopy( FlyBlood->JObj->GetJObj()->mtx,o mtx );
						}
						else
						{
							assert(0);
						}
						
						// Wϊ
						MTXMultVec( mtx, &Obj->Point, &Obj->Point ) ;
	*/
						// _̍WƖ@擾
//						GetHopeNumberVertexPositionAndNormal( FlyBlood->Mesh, FlyBlood->VertexNumber, &Obj->Point, &Direction ) ;
						Obj->Point = Point ;
						Direction = Dir ;

						// 𕪉	
						Direction.x += 0.00001f;
						VECNormalize( &Direction, &Direction);
						FlyBlood->xzRot = atan2( Direction.z, Direction.x ) ;
						{
							Sin = SINF( -FlyBlood->xzRot ) ; Cos = COSF( -FlyBlood->xzRot ) ;
							f = Direction.x * Cos - Direction.z * Sin ;
							Direction.z = Direction.x * Sin + Direction.z * Cos ;
							Direction.x = f ;
						}
						FlyBlood->xyRot = atan2( Direction.y, Direction.x ) ;

						// x|
						VECScale( &Obj->Speed, &Obj->Speed, Power ) ;
	/*					Obj->Point.x = 0.0F ;
						Obj->Point.y = 17.0F ;
						Obj->Point.z = 0.0F ;
						Obj->Speed.x = 2.0F ;
						Obj->Speed.y = 0.0F ;
						Obj->Speed.z = 0.0F ;
	*/				}


	//				else
					{
	//					Obj->Point = FlyBlood->Point ;
						
						// ݒ
				//		Power = FlyBlood->Power + rand() * FlyBlood->VibPower / RAND_MAX - FlyBlood->VibPower / 2.0F ;
						yzRot = FlyBlood->VibRotWidth * SINF( FlyBlood->yzVibRot ) + FlyBlood->yzRot ;
						Obj->Speed.x = Power ;
						Obj->Speed.y = SINF( FlyBlood->xyRot ) * Obj->Speed.x ;
						Obj->Speed.x = COSF( FlyBlood->xyRot ) * Obj->Speed.x ;
						Obj->Speed.z = -SINF( yzRot ) * Obj->Speed.y ;
						Obj->Speed.y = COSF( yzRot ) * Obj->Speed.y ;
						Sin = SINF( FlyBlood->xzRot ) ; Cos = COSF( FlyBlood->xzRot ) ;
						f = Cos * Obj->Speed.x - Sin * Obj->Speed.z ;
						Obj->Speed.z = Sin * Obj->Speed.x + Cos * Obj->Speed.z ;
						Obj->Speed.x = f ;
					}
		
					Obj->Flag = FALSE ;
					Obj->RotType = (u8)( ( rand() * 4 / RAND_MAX ) % 4 ) ;
					Obj->Width = ( FLYBLOOD_VIBSIN - Total * 2.0f ) * FlyBlood->Width ;
					if( Obj->Width <= 0.0F ) Obj->Width = 0.1F ;
		//			Obj->Width = FLYBLOOD_VIBSIN * FlyBlood->Width ;
			
					// ]Ă{[ꍇ́A{[ɍ킹ĕϊ
	/*				if( FlyBlood->JObj != NULL )
					{
						mtx[0][3] = mtx[1][3] = mtx[2][3] = 0.0F ;
						MTXMultVec( mtx, &Obj->Speed, &Obj->Speed ) ;
					}
	*/
					// F̌
					{
						s16 c ;
						
						Obj->Color = FlyBlood->Color ;
						c = Obj->Color.r ;
						if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
						if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
						Obj->Color.r = (u8)c ;
						c = Obj->Color.g ;
						if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
						if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
						Obj->Color.g = (u8)c ;
						c = Obj->Color.b ;
						if( c != 0 ) c += rand() * FlyBlood->ColorRand / RAND_MAX - FlyBlood->ColorRand / 2 ; 
						if( c > 255 ) c = 255 ; if( c < 0 ) c = 0 ; 
						Obj->Color.b = (u8)c ;
					}

					// AhXݒ
					if( FlyBlood->ObjNum == 0 )
					{
						Obj->back = -1 ;
						Obj->next = -1 ;
						FlyBlood->LastObj = FlyBlood->FirstObj = i ;
					}
					else
					{
						FlyBlood->Obj[FlyBlood->LastObj].next = (s16)i ;
						Obj->back = (s16)FlyBlood->LastObj ;
						Obj->next = -1 ;
						FlyBlood->LastObj = i ;
					}

					// IuWFNg̐̃CNg
					FlyBlood->ObjNum ++ ;
							
					// pxi߂			
					for( j = 0 ; j < FLYBLOOD_VIBSIN ; j ++ )
					{
						FlyBlood->VibSin[j] += FlyBlood->VibSinSp[j] / HOKAN ;
					}

					// h炬̐
					FlyBlood->yzVibRot += FlyBlood->VibSpeed / 10.0F / HOKAN ;
					while( FlyBlood->yzVibRot >= PI_2 ) FlyBlood->yzVibRot -= PI_2 ;

					// ZXs[h̉Z
					FlyBlood->AddPower += FlyBlood->MovePower / HOKAN ;

			// 1
					// JE^̏AIuWFNg̐̃CNg
					FlyBlood->ObjCounter -= FlyBlood->Wait ;

	#ifdef _DEBUG
					// ̃IuWFNgۑ
					FlyBlood->BackObj = NewObj ;
	#endif
				}
			}

			// h炬̐
		//	FlyBlood->VibCounter ++ ;
		//	FlyBlood->yzVibRot += FlyBlood->VibSpeed / 10.0F ;
		//	if( FlyBlood->yzVibRot >= PI_2 ) FlyBlood->yzVibRot -= PI_2 ;

		R1:

			// IuWFNg̓쏈s
			if( FlyBlood->ObjNum != 0 )
			{
//				u16 n ;
			
				Obj = &FlyBlood->Obj[FlyBlood->FirstObj] ;
				for(;;)
				{
					if( Obj->Flag == FALSE )
					{
						Obj->Flag = TRUE ;
						
						// ̃IuWFNg
						if( Obj->next == -1 ) break ;
						Obj = &FlyBlood->Obj[Obj->next] ;
					}
					else
					{
						// ړ
						Obj->Point.x += Obj->Speed.x * FlyBlood->SpeedRate * ( 1.0F / HOKAN ) ;
						Obj->Point.y += Obj->Speed.y * FlyBlood->SpeedRate * ( 1.0F / HOKAN ) ;
						Obj->Point.z += Obj->Speed.z * FlyBlood->SpeedRate * ( 1.0F / HOKAN ) ;

						// d͏
						Obj->Speed.y -= FlyBlood->Gravity * FlyBlood->SpeedRate * ( 1.0F / HOKAN ) ;
						
						// CR
						Obj->Speed.x *= FlyBlood->AirRes * FlyBlood->SpeedRate ;
						Obj->Speed.y *= FlyBlood->AirRes * FlyBlood->SpeedRate ;
						Obj->Speed.z *= FlyBlood->AirRes * FlyBlood->SpeedRate ;

						// 蔻菈
						if( Obj->Point.y < FlyBlood->YukaY )
						{
							FLYBLOODOBJECT *temp ;
							
							if( FlyBlood->NofObjNum < FlyBlood->NofObjMaxNum )
							{
								// łȂIuWFNg̃f[^ǉ
								for( NObj = FlyBlood->NofObj ; NObj->UseFlag == TRUE ; NObj ++ ){}
								
								// p[^̐ݒ
								NObj->UseFlag = TRUE ;
								NObj->Point = Obj->Point ;
								NObj->Color = Obj->Color ;
								NObj->Point.y = FlyBlood->YukaY + 0.02F ;
								NObj->Counter = 0.0F ;
								NObj->iu = Obj->iu ;
								NObj->iv = Obj->iv ;
								
								// łȂIuWFNg̃f[^̐CNg
								FlyBlood->NofObjNum ++ ;
							}
							
							// IuWFNg̃Xg͂
							if( Obj->back == -1 )
							{
								if( FlyBlood->ObjNum == 1 )
								{
									FlyBlood->FirstObj = FlyBlood->LastObj = 0 ;
								}
								else
								{
									FlyBlood->FirstObj = (u16)Obj->next ;
									FlyBlood->Obj[Obj->next].back = -1 ;
								}
							}
							else
							if( Obj->next == -1 )
							{
								FlyBlood->Obj[Obj->back].next = -1 ;
								FlyBlood->LastObj = (u16)Obj->back ;
							}
							else
							{
								FlyBlood->Obj[Obj->back].next = Obj->next ;
								FlyBlood->Obj[Obj->next].back = Obj->back ;
							}

							// łIuWFNg̐fNg
							FlyBlood->ObjNum -- ;

							// ̃IuWFNg
							temp = Obj ;
							Obj = temp->next != -1 ? &FlyBlood->Obj[Obj->next] : NULL ;
							
							// IuWFNgf[^̏
							temp->next = temp->back = -1 ;
							temp->UseFlag = FALSE ;

							// Im
							if( Obj == NULL ) break ;
						}
						else
						{
							// ̃IuWFNg
							if( Obj->next == -1 ) break ;
							Obj = &FlyBlood->Obj[Obj->next] ;
						}
					}
				}
			}
			
			// łȂIuWFNg̏
			if( FlyBlood->NofObjNum != 0 )
			{
				u16 i, j, Num ;
				
				NObj = FlyBlood->NofObj ;
				Num = FlyBlood->NofObjNum ;
				j = 0 ;
				for( i = 0 ; j < Num ; i ++, NObj ++ )
				{
					if( NObj->UseFlag == TRUE )
					{
						j ++ ;
						
						// JE^CNg
						NObj->Counter += FlyBlood->SpeedRate / HOKAN ;
						
						// Im
						if( NObj->Counter >= FlyBlood->FadeOutWait + FlyBlood->FadeOutTime )
						{
							// 炷
							FlyBlood->NofObjNum -- ;
						
							// tȌ
							NObj->UseFlag = FALSE ;
						}
					}
				}
			}
		}
	}

	FlyBlood->TimeCounter += FlyBlood->SpeedRate ;
	
	// I
	return 0 ;
}					


// ь̃GtFNg`悷
extern s8 DrawFlyBloodEffect( EFFECT *Effect )
{
#if 1
	FLYBLOODEFFECT *FlyBlood = ( FLYBLOODEFFECT * )Effect->Data ;
	FLYBLOODOBJECT *Obj ;
	NOFLYBLOODOBJECT *NObj ;
//	static Vec NBufH[1000], NBufV[1000] ;
	Vec *NBufH = (Vec *)WorkBuffer, *NBufV = (Vec *)&WorkBuffer[sizeof( Vec ) * 1100] ;
	Mtx TMtx ;
	u32 /*i,*/ j, Num ;
	u8 Bright ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	// J[̐ݒ
    GXSetNumChans(1);
    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
    GXSetChanAmbColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanMatColor( GX_COLOR0A0, (GXColor){200, 0, 0, 255} ) ;
    GXSetChanCtrl( GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  				GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE ) ;

	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;	// _tH[}bg̃Zbg
	EffectGetInvViewMatrix( TMtx ) ;				// ]ns̎Zo
	GXSetLineWidth( 12, GX_TO_ONE ) ;				// ̑Zbg
	GTLOAD( &GetBloodTex(0)->Obj ) ;				// eNX`̃[h
	
	// C̖@Zo
	if( FlyBlood->ObjNum > 1 )
	{
		Vec V, Vt, Vbnh, Vnh, Vbnv, Vnv ;

		// f[^AhX̃Zbg
		Obj = &FlyBlood->Obj[FlyBlood->Obj[FlyBlood->FirstObj].next] ;

		// ŏ̖@vZ
		{
			// xNgvZ
			PSVECSubtract( &Obj->Point, &FlyBlood->Obj[Obj->back].Point, &V ) ;
			if( V.x < 0.00001F && V.y < 0.00001F && V.z < 0.00001F ) V.x = 1.0F ;
			PSVECNormalize( &V, &V ) ;

			// @̎Zo
			Vt.x = 0.0f ; Vt.y = 1.0f ; Vt.z = 0.0F ;
			PSVECCrossProduct( &V, &Vt, &Vbnh ) ;
			if( PSVECMag( &Vbnh ) == 0.0F )
				Vbnh.x = 1.0F ;
			else
				PSVECNormalize( &Vbnh, &Vbnh ) ;
			NBufH[0] = Vbnh ;
			
			// @̕ۑ
			PSVECCrossProduct( &Vbnh, &V, &Vbnv ) ;
			PSVECNormalize( &Vbnv, &Vbnv ) ;
			NBufV[0] = Vbnv ;
			
			// TCY̏Z
			PSVECScale( &NBufV[0], &NBufV[0], Obj->Width ) ;
			PSVECScale( &NBufH[0], &NBufH[0], Obj->Width ) ;
		}

		// JԂ
		for( j = 1 ; j < FlyBlood->ObjNum - 1 ; j ++, Obj = &FlyBlood->Obj[Obj->next] )
		{
			// ̒_A̒_܂ł̃xNg𓾂
			PSVECSubtract( &FlyBlood->Obj[Obj->next].Point, &Obj->Point, &V ) ;
			if( V.x == 0.0F && V.y == 0.0F && V.z == 0.0F ) V.x = 1.0F ;
			PSVECNormalize( &V, &V ) ;
			
			// ̖@̎Zo
			Vt.x = 0.0f ; Vt.y = 1.0f ; Vt.z = 0.0F ;
			PSVECCrossProduct( &V, &Vt, &Vnh ) ;
			if( PSVECMag( &Vnh ) == 0.0F )
				Vnh.x = 1.0F ;
			else
				PSVECNormalize( &Vnh, &Vnh ) ;
			NBufH[j] = Vnh ;
			
			// ̖@̎Zo
			PSVECCrossProduct( &Vnh, &V, &Vnv ) ;
			PSVECNormalize( &Vnv, &Vnv ) ;
			NBufV[j] = Vnv ;

			// TCY̏Z
			PSVECScale( &NBufV[j], &NBufV[j], Obj->Width ) ;
			PSVECScale( &NBufH[j], &NBufH[j], Obj->Width ) ;
			
			// Õf[^̎ւ
			Vbnh = Vnh ;
			Vbnv = Vnv ;
		}
		
		// Ō̖@vZ
		{
			// xNgvZ
			PSVECSubtract( &Obj->Point, &FlyBlood->Obj[Obj->back].Point, &V ) ;
			if( V.x == 0.0F && V.y == 0.0F && V.z == 0.0F ) V.x = 1.0F ;
			PSVECNormalize( &V, &V ) ;

			// @̎Zo
			Vt.x = 0.0f ; Vt.y = 1.0f ; Vt.z = 0.0F ;
			PSVECCrossProduct( &V, &Vt, &Vnh ) ;
			if( PSVECMag( &Vnh ) == 0.0F )
				Vnh.x = 1.0F ;
			else
				PSVECNormalize( &Vnh, &Vnh ) ;
			NBufH[j] = Vnh ;
			
			// @̕ۑ
			PSVECCrossProduct( &Vnh, &V, &Vnv ) ;
			PSVECNormalize( &Vnv, &Vnv ) ;
			NBufV[j] = Vnv ;
			
			// TCY̏Z
			PSVECScale( &NBufV[j], &NBufV[j], Obj->Width ) ;
			PSVECScale( &NBufH[j], &NBufH[j], Obj->Width ) ;
		}
	}

	// `揈
	{
		GXColor GColor ;
		Vec tp[4] ;

		// ŏɌ`
		NObj = FlyBlood->NofObj ;
		Num = FlyBlood->NofObjNum ;
		if( Num != 0 )
		{
			PSVECScale( &FlyBaseVert[0], &tp[0], FlyBlood->BloodSize ) ;
			PSVECScale( &FlyBaseVert[1], &tp[1], FlyBlood->BloodSize ) ;
			PSVECScale( &FlyBaseVert[2], &tp[2], FlyBlood->BloodSize ) ;
			PSVECScale( &FlyBaseVert[3], &tp[3], FlyBlood->BloodSize ) ;
			
			if( Num * 4 > 65535 ) Num = 65535 / 4 ;
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Num * 4 ) ) ;
			{
				for( j = 0 ; j < Num ; NObj ++ )
				{
					if( NObj->UseFlag == TRUE )
					{
						j ++ ;
						
						// `Px̌vZ
						Bright = (u8)( NObj->Counter < FlyBlood->FadeOutWait ? 255 :
										255 - 255 * ( NObj->Counter - FlyBlood->FadeOutWait ) / FlyBlood->FadeOutTime ) ;

						GColor = NObj->Color ;
						GP3( tp[0].x + NObj->Point.x, tp[0].y + NObj->Point.y, tp[0].z + NObj->Point.z ) ; GC2( GColor, Bright ) ; GT2( NObj->iu, NObj->iv ) ;
						GP3( tp[1].x + NObj->Point.x, tp[1].y + NObj->Point.y, tp[1].z + NObj->Point.z ) ; GC2( GColor, Bright ) ; GT2( NObj->iu + BLOODONE_SIZE, NObj->iv ) ;
						GP3( tp[2].x + NObj->Point.x, tp[2].y + NObj->Point.y, tp[2].z + NObj->Point.z ) ; GC2( GColor, Bright ) ; GT2( NObj->iu + BLOODONE_SIZE, NObj->iv + BLOODONE_SIZE ) ;
						GP3( tp[3].x + NObj->Point.x, tp[3].y + NObj->Point.y, tp[3].z + NObj->Point.z ) ; GC2( GColor, Bright ) ; GT2( NObj->iu, NObj->iv + BLOODONE_SIZE ) ;
					}
				}
			}
			GXEnd() ;
		}
		
		EffectTevSetup( EF_TEV_NOTEX ) ;
	
		// ŏɔł錌`悷
		if( FlyBlood->ObjNum > 1 )
		{
			Vec *NV, *NV2, Vbp, Vbm, Vp, Vm ;
			
			// _`o
			{
				u32 ccc, num ;
				ccc = 0 ;
				GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( num = (u32)( ( FlyBlood->ObjNum - 2 ) * 4 + 4 ) ) ) ;
				{
					Obj = &FlyBlood->Obj[FlyBlood->FirstObj] ;
					NV = &NBufH[0] ;
					NV2 = &NBufV[0] ;

					// ŏ̒_̏o
					{
						GColor = Obj->Color ;
						GP3( Obj->Point.x + NV->x, Obj->Point.y + NV->y, Obj->Point.z + NV->z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						GP3( Obj->Point.x - NV->x, Obj->Point.y - NV->y, Obj->Point.z - NV->z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						
						Vbp = *NV ;
						VECScale( &Vbp, &Vbm, -1.0F ) ;
						ccc += 2 ;
						
						Vm = Vbm ;
						Vp = Vbp ;
					}
					NV ++ ;
					NV2 ++ ;
					Obj = &FlyBlood->Obj[Obj->next] ;

	//				tempObj = Obj ;
					for( j = 1 ; j < FlyBlood->ObjNum ; j ++, Obj = &FlyBlood->Obj[Obj->next], NV ++, NV2 ++ )
					{
						// `Px̌vZ
	//					if( j != FlyBlood->ObjNum - 1 )
						{
							GColor = Obj->Color ; 
							GP3( Obj->Point.x + Vp.x, Obj->Point.y + Vp.y, Obj->Point.z + Vp.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							GP3( Obj->Point.x + Vm.x, Obj->Point.y + Vm.y, Obj->Point.z + Vm.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							ccc += 2 ;
						}

						Vp = *NV ;
						VECScale( &Vp, &Vm, -1.0F ) ;

						if( j != FlyBlood->ObjNum - 1 )
						{
							GColor = Obj->Color ; 
							GP3( Obj->Point.x + Vp.x, Obj->Point.y + Vp.y, Obj->Point.z + Vp.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							GP3( Obj->Point.x + Vm.x, Obj->Point.y + Vm.y, Obj->Point.z + Vm.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							ccc += 2 ;
						}
						else break ;
						
						// ۑ
						Vbm = Vm ;
						Vbp = Vp ;
					}
				}
				GXEnd() ;
				
				if( ccc != num )
				{
					OSReport( "Oi!\n" ) ;
				}

				// _`o
				ccc = 0 ;
				GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( num = (u32)( ( FlyBlood->ObjNum - 2 ) * 4 + 4 ) ) ) ;
				{
					Obj = &FlyBlood->Obj[FlyBlood->FirstObj] ;
					NV2 = &NBufH[0] ;
					NV = &NBufV[0] ;

					// ŏ̒_̏o
					{
						GColor = Obj->Color ;
						GP3( Obj->Point.x + NV->x, Obj->Point.y + NV->y, Obj->Point.z + NV->z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						GP3( Obj->Point.x - NV->x, Obj->Point.y - NV->y, Obj->Point.z - NV->z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						ccc += 2 ;
						
						Vbp = *NV ;
						VECScale( &Vbp, &Vbm, -1.0F ) ;
					}
					NV ++ ;
					NV2 ++ ;
					Obj = &FlyBlood->Obj[Obj->next] ;

					for( j = 1 ; j < FlyBlood->ObjNum ; j ++, Obj = &FlyBlood->Obj[Obj->next], NV ++, NV2 ++ )
					{
						// `Px̌vZ
						GColor = Obj->Color ; 
						GP3( Obj->Point.x + Vp.x, Obj->Point.y + Vp.y, Obj->Point.z + Vp.z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						GP3( Obj->Point.x + Vm.x, Obj->Point.y + Vm.y, Obj->Point.z + Vm.z ) ;
						GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
						ccc += 2 ;
					
						Vp = *NV ;
						VECScale( &Vp, &Vm, -1.0F ) ;
						
						// `Px̌vZ
						if( j != FlyBlood->ObjNum - 1 )
						{
							GColor = Obj->Color ; 
							GP3( Obj->Point.x + Vp.x, Obj->Point.y + Vp.y, Obj->Point.z + Vp.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							GP3( Obj->Point.x + Vm.x, Obj->Point.y + Vm.y, Obj->Point.z + Vm.z ) ;
							GC2( GColor, 255 ) ; //GT2( Obj->iu, Obj->iv ) ;
							ccc += 2 ;
						}
						else break ;
						
						// ۑ
						Vbm = Vm ;
						Vbp = Vp ;
					}
				}
				GXEnd() ;
				if( ccc != num )
				{
					OSReport( "Oi!\n" ) ;
				}
			}
		}
	}
#endif
	// I
	return 0 ;
}					


// ь̃GtFNg̓쑬x̔{ݒ肷( 1.0F:100%  2.0F:200% )
extern s8 SetFlyBloodSpeedRate( EFFECT *Effect, f32 SpeedRate )
{
	FLYBLOODEFFECT *FlyBlood = ( FLYBLOODEFFECT * )Effect->Data ;
	
	// xZbg
	FlyBlood->SpeedRate = SpeedRate ;
	
	// I
	return 0 ;
}
	
