///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFlyBlood
//
// YK7EffectFlyBlood.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 07/31/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTFLYBLOOD_H
#define __YK7EFFECTFLYBLOOD_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

//#define FLYBLOOD_MAXOBJECTNUM		300
//#define FLYBLOOD_NOFLYMAXNUM		700
#define FLYBLOOD_VIBSIN				20
#define FLYBLOOD_MESHNUM			100

// datatype -------------------------------------

// ьGtFNgʃf[^
typedef struct tagFLYBLOODUNION
{
	u8 dummy ;
} FLYBLOODUNION ;

// ̃f[^
typedef struct tagNOFLYBLOODOBJECT
{
	u8 UseFlag ;					// gptO

	u16 iu, iv ;					// tuW̃CfbNXl	
	Vec Point ;						// W
	f32 Counter ;					// JE^[
	GXColor Color ;					// F
} NOFLYBLOODOBJECT ;

// ьIuWFNgf[^
typedef struct tagFLYBLOODOBJECT
{
	u8 UseFlag ;					// gptO

	u8 Flag ;
	u16 iu, iv ;					// tuW̃CfbNXl	
	Vec Point ;						// W
	Vec Speed ;						// x
	f32 Width ;						// 
	s16 back, next ;				// ÕIuWFNg̃CfbNX(-1:)
	GXColor Color ;					// F
	u8 RotType ;					// ]^Cv
} FLYBLOODOBJECT ;

// ьGtFNgf[^
typedef struct tagFLYBLOODEFFECT
{
	WK7JObj *JObj ;										// ǂꂩ JObj ɏ]Ăꍇ̏]Ă JObj
	s32 MeshInfoID ;									// bVf[^̂hc
	MESH *Mesh ;										// ǂꂩ JObj ɏ]Ăꍇ JObj ̃bV̓f[^
	u32 VertexNumber ;									// ΏۂƂ钸_̃io[

	Vec Point ;											// _W
	
	u16 Counter ;										// JE^
	f32 xyRot, yzRot, xzRot ;							// ]px
	f32 yzVibRot ;										// h炬̒l 
	u16 VibCounter ;									// h炬vZp̃JE^

	FLYBLOODOBJECT *Obj ;								// ьIuWFNgf[^
	u16 ObjMaxNum ;										// ł錌IuWFNg̍쐬łő吔
	FLYBLOODOBJECT BackObj ;							// OɔłIuWFNg̃f[^
	u16 FirstObj, LastObj ;								// 擪IuWFNgƖ[̃IuWFNg
	u16 ObjNum ;										// ьIuWFNg̐
	f32 ObjCounter ;									// ьIuWFNgJE^[
	u8 Wait ;											// IuWFNgƃIuWFNgo͂Ԋu

	NOFLYBLOODOBJECT *NofObj ;							// łȂIuWFNg̃f[^
	u16 NofObjMaxNum ;									// łȂIuWFNg̍쐬łő吔
	u16 NofObjNum ;										// łȂIuWFNg̃f[^

	f32 Power ;											// p[
	f32 VibPower ;										// p[̗h炬
	f32 VibRotWidth ;									// h炬̕
	f32 VibSin[FLYBLOOD_VIBSIN] ;						// Sing̊px̒l
	f32 VibSinSp[FLYBLOOD_VIBSIN] ;						// Sing̊px
	f32 VibSpeed ;										// h炬̃Xs[h
	f32 BloodSize ;										// ̃TCY
	f32 AirRes ;										// CR
	f32 YukaY ;											// ̍
	f32 Gravity ;										// d͉x
	u16 FadeOutWait ;									// tF[hAEg܂ł̑҂
	u16 FadeOutTime ;									// tF[hAEgn߂Ă܂ł̎
	GXColor Color ;										// F
	u8 ColorRand ;										// F̊gU
	f32 Width ;											// 
	f32 SpeedRate ;										// ĐXs[h
	
	s16 Time ;											// ΂鎞(t[)
	f32 TimeCounter ;									// ԌvpJE^
	f32 MovePower ;										// Xs[h̕ωx
	f32 AddPower ;										// Xs[h̉Z
} FLYBLOODEFFECT ;

// ьGtFNg^XNɓnf[^
typedef struct tagFLYBLOODEFFECTTACKPARAM
{
	Vec Ponit ;				// W
	Vec Direction ;			// 
	f32 yzRot ;				// ](0.0Ń_)
	f32 Power ;				// p[
	f32 VibPower ;			// p[̗h炬
	f32 VibRotWidth ;		// h炬̕
	f32 VibSpeed ;			// h炬̃Xs[h
	f32 BloodSize ;			// ̃TCY
	f32 AirRes ;			// CR
	f32 Gravity ;			// d͉x
	u8 Wait ;				// IuWFNgƃIuWFNgo͂Ԋu
	f32 YukaY ;				// ̍
	u16 FadeOutWait ;		// tF[hAEg܂ł̑҂
	u16 FadeOutTime ;		// tF[hAEgn߂Ă܂ł̎
	GXColor Color ;			// F
	u8 ColorRand ;			// F̊gU
	f32 Width ;				// 
	s16 Time ;				// ΂鎞(t[)
	u32 VertexNumber ;		// ΏۂƂ钸_̃io[
	f32 MovePower ;			// Xs[h̕ωx

	u8 Type ;				// ^Cv(0:AIɌo  1:ŏɈCɏo)
} FLYBLOODEFFECTTASKPARAM ;


// prototype ------------------------------------

extern s8 InitFlyBloodData( void ) ;				// ьGtFNg̋ʃf[^
extern s8 CheckFlyBloodData( void ) ;				// ьGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndFlyBloodData( void ) ;					// ьGtFNg̋ʃf[^n

extern EFFECT *CreateFlyBloodEffect( Vec Ponit, Vec Direction, f32 yzRot, f32 Power, f32 VibPower,
										f32 VibRotWidth, f32 VibSpeed, f32 BloodSize,
										f32 AirRes, f32 Gravity, u8 Wait, f32 YukaY,
										u16 FadeOutWait, u16 FadeOutTime,
										GXColor Color, u8 ColorRand,
										f32 Width, s16 Time, WK7JObj *JObj/* = NULL*/, u32 VertexNumber/* = 0*/,
										f32 MovePower/* = 0.0F*/, u8 Type/* = 0*/,
										u16 ObjMaxNum/* = FLYBLOOD_MAXOBJECTNUM*/, u16 NofObjMaxNum/* = FLYBLOOD_NOFLYMAXNUM*/, s32 Priority = -1 ) ;	// ь̃GtFNg쐬
extern s8 ReleaseFlyBloodEffect( EFFECT *Effect ) ;								// ь̃GtFNǧns
extern s8 MoveFlyBloodEffect( EFFECT *Effect ) ;								// ь̃GtFNgPt[
extern s8 DrawFlyBloodEffect( EFFECT *Effect ) ;								// ь̃GtFNg`悷

extern s8 SetFlyBloodSpeedRate( EFFECT *Effect, f32 SpeedRate ) ;				// ь̃GtFNg̓쑬x̔{ݒ肷( 1.0F:100%  2.0F:200% )

#endif