///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectFootPaint
//
// YK7EffectFootPaint.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/30/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectFootPaint.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define DEFSIZE			(1.5F)
#define FADESPEED		(0.1F)

#define FOOTPAINT_PATH		"/Yam/Effect/Footpaint/Footpaint.BIN"

// data type ------------------------------------

// data -----------------------------------------

static FOOTPAINTUNION _FTU ;

// function proto type --------------------------

// function code --------------------------------

// ՃGtFNg̋ʃf[^
extern s8 InitFootPaintData( void )
{
	MEMINIT(_FTU) ;
	
//	TexLoadSet( FOOTPAINT_PATH, &_FTU.FootPaintTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Footpaint ), &_FTU.FootPaintTex ) ;

	// I
	return 0 ;
}

// ՃGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckFootPaintData( void )
{
//	if( TexLoadChk( &_FTU.FootPaintTex ) == FALSE ) return FALSE ;

	return TRUE ;
}


// ՃGtFNg̋ʃf[^n
extern s8 EndFootPaintData( void )
{
	TexRelease( &_FTU.FootPaintTex ) ;

	MEMINIT(_FTU) ;

	// I
	return 0 ;
}




// ՃGtFNg쐬
extern EFFECT *CreateFootPaintEffect(
						f32 Size,					// TCY
						u32 DrawTime,				// \
						u32 Color,					// F
						s32 Priority )
{
	EFFECT *Effect ;
	FOOTPAINTEFFECT *cl ;
	FOOTPAINTOBJECT *ob ;
	u32 i ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_FOOTPAINT, (void**)&cl, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// p[^ۑE
	cl->ObjNum 		= 0 ;
	cl->Size		= Size ;
	if( cl->Size < 0.0F ) cl->Size = DEFSIZE ;
	cl->Color		= Color ;
	cl->DrawTime	= DrawTime ;

	// IuWFNg̏	
	ob = cl->Obj ;
	for( i = 0 ; i < FOOTPAINT_MAXNUM ; i ++, ob ++ ) ob->vflag = 0 ;

	// I
	return Effect ;
}

// ՃGtFNǧns
extern s8 ReleaseFootPaintEffect( EFFECT *Effect )
{
	FOOTPAINTEFFECT *cl = ( FOOTPAINTEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// ՃGtFNgPt[
extern s8 MoveFootPaintEffect( EFFECT *Effect )
{
	FOOTPAINTEFFECT *cl = ( FOOTPAINTEFFECT * )Effect->Data ;
	FOOTPAINTOBJECT *ob ;
	u32 i, num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && cl->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ׂẴCIuWFNg
	ob = cl->Obj ;
	num = (u32)cl->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;

		i ++ ;

		ob->alpha -= FADESPEED ;
		if( ob->alpha < 0.0F )
		{
			ob->vflag = 0 ;
			cl->ObjNum -- ;
		}
	}
	
	// I
	return 0 ;
}

// ՃGtFNg`悷
extern s8 DrawFootPaintEffect( EFFECT *Effect )
{
	FOOTPAINTEFFECT *cl = ( FOOTPAINTEFFECT * )Effect->Data ;
	FOOTPAINTOBJECT *ob ;
	u32 i, num, cr ;
	f32 sz, Sin, Cos ;
	Vec tv[4] ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;							// `̏

	// eNX`̃[h
	GTLOAD2( _FTU.FootPaintTex ) ;

	// _
	sz = 0.5F * cl->Size ;
	tv[0].x = -sz ;	tv[0].y = 0.0F ;	tv[0].z = -sz ;
	tv[1].x = sz ;	tv[1].y = 0.0F ;	tv[1].z = -sz ;
	tv[2].x = sz ;	tv[2].y = 0.0F ;	tv[2].z = sz ;
	tv[3].x = -sz ;	tv[3].y = 0.0F ;	tv[3].z = sz ;

	// `揈	
	GBGN( GX_QUADS, cl->ObjNum * 4 ) ;
	
	// IuWFNg̐JԂ
	ob = cl->Obj ;
	num = (u32)cl->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;
		
		i ++ ;

		cr = CMKC2( cl->Color, ( ob->alpha > 1.0F ? 1.0F : ob->alpha ) * 255 ) ;
		Sin = SIN( ob->rot ) ;		Cos = COS( ob->rot ) ;
		if( ob->type == FOOT_LEFT )
		{
			GP3( tv[0].x * Cos - tv[0].z * Sin + ob->pos.x, tv[0].y + ob->pos.y, tv[0].x * Sin + tv[0].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 0.0F, 0.0F ) ;
			GP3( tv[1].x * Cos - tv[1].z * Sin + ob->pos.x, tv[1].y + ob->pos.y, tv[1].x * Sin + tv[1].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 1.0F, 0.0F ) ;
			GP3( tv[2].x * Cos - tv[2].z * Sin + ob->pos.x, tv[2].y + ob->pos.y, tv[2].x * Sin + tv[2].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 1.0F, 1.0F ) ;
			GP3( tv[3].x * Cos - tv[3].z * Sin + ob->pos.x, tv[3].y + ob->pos.y, tv[3].x * Sin + tv[3].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 0.0F, 1.0F ) ;
		}
		else
		{
			GP3( tv[0].x * Cos - tv[0].z * Sin + ob->pos.x, tv[0].y + ob->pos.y, tv[0].x * Sin + tv[0].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 1.0F, 0.0F ) ;
			GP3( tv[1].x * Cos - tv[1].z * Sin + ob->pos.x, tv[1].y + ob->pos.y, tv[1].x * Sin + tv[1].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 0.0F, 0.0F ) ;
			GP3( tv[2].x * Cos - tv[2].z * Sin + ob->pos.x, tv[2].y + ob->pos.y, tv[2].x * Sin + tv[2].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 0.0F, 1.0F ) ;
			GP3( tv[3].x * Cos - tv[3].z * Sin + ob->pos.x, tv[3].y + ob->pos.y, tv[3].x * Sin + tv[3].z * Cos + ob->pos.z ) ;	GCX( cr ) ;	GT( 1.0F, 1.0F ) ;
		}
	}
	GEND() ;

	// I
	return 0 ;
}


// ՃGtFNgǉ
extern s8 AddFootPaint( EFFECT *Effect, Vec *Pos, f32 Dir, u8 FootType )
{
	FOOTPAINTEFFECT *cl = ( FOOTPAINTEFFECT * )Effect->Data ;
	FOOTPAINTOBJECT *ob ;
	
	if( cl->ObjNum == FOOTPAINT_MAXNUM ) return -1 ;
	for( ob = cl->Obj ; ob->vflag ; ob ++ ){}

	ob->vflag = TRUE ;
	ob->pos = *Pos ;
	ob->rot = (u16)RCINT(-Dir + PI) ;
	ob->alpha = cl->DrawTime * FADESPEED + 1.0F ;
	ob->type = FootType ;

	cl->ObjNum ++ ;
	
	// I
	return 0 ;
}





