///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectGMark
//
// YK7EffectGMark.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/19/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectGMark.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_GMARK]
#define PR1				ExpTable		

// data -----------------------------------------

GMARKUNION gmu ;

// datatype -------------------------------------

// function proto type --------------------------

static s8 GMarkObjectCreateCallBack( Vec **Point, void *Data ) ;		// IuWFNg쐬R[obN֐

// function code --------------------------------

// IuWFNg쐬R[obN֐
static s8 GMarkObjectCreateCallBack( Vec **Point, void *Data )
{
	GMARKEFFECT *gm = ( GMARKEFFECT * )Data ;
	GMARKOBJECT *ob ;
	f32 area, rate1, rate2, speed ;
	Vec V1, V2, VC ;

	// ʐς߂
	PSVECSubtract( Point[1], Point[0], &V1 ) ;
	PSVECSubtract( Point[2], Point[0], &V2 ) ;
	PSVECCrossProduct( &V1, &V2, &VC ) ;
	area = PSVECMag( &VC ) * 0.5F ;
	PSVECNormalize( &VC, &VC ) ;

	// 쐬JE^ɒlZ
	gm->crecounter += area * gm->crerate ;
	
	// JE^Pȏ̓̓IuWFNg쐬
	while( gm->crecounter >= 1.0F && gm->objnum != gm->maxobjnum )
	{
		gm->crecounter -= 1.0F ;
		gm->objnum ++ ;

		for( ob = gm->obj ; ob->validf == TRUE ; ob ++ ){} 
		
		// l̏
		ob->validf 		= TRUE ;
		
		rate2 			= 1.0F - ( rate1 = GetRandFNum( 1.0F ) ) ; 
		ob->pos.x 		= Point[0]->x + V1.x * rate1 + V2.x * rate2 ;
		ob->pos.y 		= Point[0]->y + V1.y * rate1 + V2.y * rate2 ;
		ob->pos.z 		= Point[0]->z + V1.z * rate1 + V2.z * rate2 ;
		
		speed 			= GetRandF2Num( gm->maxspeed, gm->minspeed ) ;
		ob->speed.x 	= VC.x * speed ;
		ob->speed.y 	= VC.y * speed ;
		ob->speed.z 	= VC.z * speed ;

		ob->size 		= GetRandF2Num( gm->maxsize, gm->minsize ) ;
		ob->sizespeed 	= GetRandF2Num( gm->maxExSpeed, gm->minExSpeed ) ;
	}
	
	return 0 ;
}


// Weqbg}[NGtFNg̋ʃf[^
extern s8 InitGMarkData( void )
{
	MEMINIT( gmu ) ;

	return 0 ;
}

// Weqbg}[NGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckGMarkData( void )
{
	return TRUE ;
}

// Weqbg}[NGtFNg̋ʃf[^n
extern s8 EndGMarkData( void )
{
	MEMINIT( gmu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// Weqbg}[NGtFNg쐬
extern EFFECT *CreateGMarkEffect(
								WK7JObj *JObj,					// JObj IuWFNg
								s32 maxobjnum,					// ő吔

								f32 maxsize, f32 minsize,		// őTCYŏTCY
								f32 maxspeed, f32 minspeed,		// őXs[hŏXs[h
								f32 maxExSpeed, f32 minExSpeed,	// őkxŏkx

								f32 crerate,					// ʐϕӂ̍쐬m

								u32 color,						// F
								s32 Priority )
{
	EFFECT *Effect ;
	GMARKEFFECT *gm ;

	// VWeqbg}[Nf[^쐬
	Effect = AddEffectData( EFF_GMARK, (void**)&gm, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( gm, 0, sizeof( GMARKEFFECT ) ) ;
	
	// IuWFNg̃mۂ
	gm->obj = ( GMARKOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( GMARKOBJECT ) * maxobjnum ), "Y_GMObj" ) ;
	if( gm->obj == NULL ) goto ERR ;
	memset( gm->obj, 0, sizeof( GMARKOBJECT ) * maxobjnum ) ;
	
	// ff[^쐬
	if( CreateModelData( JObj->GetJObj(), &gm->model, TRUE, FALSE, TRUE, FALSE ) == -1 )
		goto ERR ;
		
	// ̑̒lۑ
	gm->JObj = JObj ;
	gm->objnum = 0 ;
	gm->maxobjnum = maxobjnum ;
	gm->maxsize = maxsize ;			gm->minsize = minsize ;
	gm->maxspeed = maxspeed ;		gm->minspeed = minspeed ;
	gm->maxExSpeed = maxExSpeed ;	gm->minExSpeed = minExSpeed ;
	gm->crerate = crerate ;
	gm->color = color ;
	gm->crecounter = 0.0F ;
	
	// I
	return Effect ;
	
ERR :
	if( Effect != NULL ) DeleteEffect( Effect ) ;
	
	// G[
	return NULL ;
}

// Weqbg}[NGtFNǧns
extern s8 ReleaseGMarkEffect( EFFECT *Effect )
{
	GMARKEFFECT *gm = ( GMARKEFFECT * )Effect->Data ;
	
	if( gm->obj != NULL ) K7AppSmallMemFree( gm->obj ) ;
	if( gm->model != NULL ) DeleteModelData( gm->model ) ;
	
	// I
	return 0 ;
}

// Weqbg}[NGtFNgPt[
extern s8 MoveGMarkEffect( EFFECT *Effect )
{
	GMARKEFFECT *gm = ( GMARKEFFECT * )Effect->Data ;
	GMARKOBJECT *ob ;
	s32 num, i ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && gm->objnum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// SẴIuWFNg𓮂
	num = gm->objnum ;
	ob = gm->obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->validf == 0 ) continue ;
		
		i ++ ;
		ob->pos.x += ob->speed.x ;
		ob->pos.y += ob->speed.y ;
		ob->pos.z += ob->speed.z ;

		ob->size -= ob->sizespeed ;
		if( ob->size <= 0.0F )
		{
			ob->validf = FALSE ;
			gm->objnum -- ;
		}
	}
	
	// IuWFNg̍쐬
	if( Effect->DelReqFlag == FALSE )
		ScanModelPrimitive( gm->model, GMarkObjectCreateCallBack, gm ) ;

	// I
	return 0 ;
}

// Weqbg}[NGtFNg`悷
extern s8 DrawGMarkEffect( EFFECT *Effect )
{
	GMARKEFFECT *gm = ( GMARKEFFECT * )Effect->Data ;
	GMARKOBJECT *ob ;
	s32 i ;
	Vec tv[4] ;
	
	if( gm->objnum == 0 ) return 0 ;
	
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	CreateBillVert( NULL, tv ) ;

	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;
	
	GBGN( GX_QUADS, gm->objnum * 4 ) ;
	for( i = 0, ob = gm->obj ; i < gm->objnum ; ob ++ )
	{
		if( ob->validf == 0 ) continue ;
		
		i ++ ;
		GPV4( ob->pos, tv[0], ob->size ) ;	GCX( gm->color ) ;	GT( 0.0F, 0.0F ) ;
		GPV4( ob->pos, tv[1], ob->size ) ;	GCX( gm->color ) ;	GT( 1.0F, 0.0F ) ;
		GPV4( ob->pos, tv[2], ob->size ) ;	GCX( gm->color ) ;	GT( 1.0F, 1.0F ) ;
		GPV4( ob->pos, tv[3], ob->size ) ;	GCX( gm->color ) ;	GT( 0.0F, 1.0F ) ;
	}
	GEND() ;

	// I
	return 0 ;
}



