///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectHitNum
//
// YK7EffectHitNum.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectHitNum.h"
#include "./YK7EffectTime.h"
#include "./YK7EffectCountDown.h"

// define ---------------------------------------

#define AIMAGE1		(0.5F)
#define AIMAGE2		(0.25F)

#define VIBWAIT		(15)
#define COUNTWAIT	(1)
#define MOVETIME	(11)
#define CICLE		(10)
#define LENGTH		(700)

#define TENX		(44)
#define TENY		(-8)
#define ONEX		(79)
#define ONEY		(-8)
#define HITX		(84)
#define HITY		(28)

//los 91,23
//win 132,28

#define PLAYWINX	(490)
#define PLAYLOSX	(476)
#define ENEMWINX	(187)
#define ENEMLOSE	(187)
#define JUDGWINY	(182)
#define JUDGLOSY	(305)

// data -----------------------------------------

HITNUMUNION hnu ;
extern TIMEUNION timu ;
extern COUNTDOWNUNION cdu ;
extern VIBTABLE __VibTable[VIBTIME] ;

// datatype -------------------------------------

// function proto type --------------------------

static void __SetObjMode( HITNUMOBJECT *ob, s32 mode ) ;
static void __ProcObj( HITNUMOBJECT *ob ) ;
static void __DrawObj( HITNUMOBJECT *ob, f32 x, f32 y, f32 alpha, f32 bluralpha, f32 alpha2 ) ;

static void __DrawJudg( u8 WinFlag, f32 x, f32 y, f32 length, f32 rate, f32 alpha, f32 bluralpha, f32 alpha2 ) ;

static void __DrawPlayerHitNum( f32 x, s32 num, f32 alpha, f32 bluralpha, f32 alpha2 ) ;
static void __DrawPlayerHit( f32 x, f32 alpha, f32 bluralpha, f32 alpha2 ) ;
static void __DrawEnemyHitNum( f32 x, s32 num, f32 alpha, f32 bluralpha, f32 alpha2 ) ;
static void __DrawEnemyHit( f32 x, f32 alpha, f32 bluralpha, f32 alpha2 ) ;

// function code --------------------------------

static void __SetObjMode( HITNUMOBJECT *ob, s32 mode )
{
	ob->mode = mode ;
	ob->counter = 0 ;
}

static void __ProcObj( HITNUMOBJECT *ob )
{
	// ( 0:\  1:m[}  2:g  3:傫h )
	switch( ob->mode )
	{
	case 0 : break ;
	case 1 : break ;
	case 2 :
		ob->counter ++ ;
		if( ob->counter == VIBTIME )
		{
			ob->mode = 1 ;
			ob->counter = 0 ;
		}
		break ;
		
	case 3 :
		ob->counter ++ ;
		if( ob->counter == VIBTIME )
		{
			ob->mode = 1 ;
			ob->counter = 0 ;
		}
		break ;
	}
}

static void __DrawObj( HITNUMOBJECT *ob, f32 x, f32 y, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	f32 adx, ady, ex, ex2 ;
	s32 hnd, ten, one ;
	u32 cr, bcr ;
	s32 zure = 10 ;
	
	if( ob->mode == 0 ) return ;
	
	if( ob->mode == 3 )
	{
		adx = __VibTable[ob->counter].x ;
		ady = __VibTable[ob->counter].y ;
		ex = __VibTable[ob->counter].ex ;
		
		ex = 1.0F + ex * (f32)VParam[ED_TIME][2] * 0.1F ;
	}
	else
	if( ob->mode == 2 )
	{
		adx = ady = 0.0F ;
		ex = 1.0F + __VibTable[ob->counter].ex ;
	}
	else
	{
		adx = ady = 0.0F ;
		ex = 1.0F ;
	}
	
	{
		s32 n ;
		
		n = ob->hitnum ;
		if( n > 999 ) n = 999 ;
		one = n % 10 ; n /= 10 ;
		ten = n % 10 ; n /= 10 ;
		hnd = n % 10 ;
	}
	
	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	
	ex2 = ex * ( 42.0F / 64.0F ) ;
	cr = CMK( 255, 255, 255, alpha2 * alpha * 255 ) ;
	bcr = CMK( 255, 255, 255, alpha2 * alpha * /*bluralpha */ 255 ) ;
	x += adx ; y += ady ;
	DrawExTex( x + ( ( hnd == 1 ) ? zure : 0 ), 	y, 			ex, true, hnd == 0 ? &timu.num0tex[1] : &timu.numtex[1][hnd-1], cr ) ;
	DrawExTex( x + TENX, 							y + TENY, 	ex2, true, ten == 0 ? &timu.num0tex[2] : &timu.numtex[1][ten-1], cr ) ;
	DrawExTex( x + ONEX, 							y + ONEY, 	ex2, true, one == 0 ? &timu.num0tex[3] : &timu.numtex[1][one-1], cr ) ;
	DrawExTex( x + HITX,							y + HITY,	ex, true, &timu.hittex[1], cr ) ;

	DrawExTex( x + ( ( hnd == 1 ) ? zure : 0 ), 	y, 			ex * bluralpha, true, hnd == 0 ? &timu.num0blur : &timu.numtex[0][hnd-1], bcr ) ;
	DrawExTex( x + TENX,						 	y + TENY, 	ex2 * bluralpha, true, ten == 0 ? &timu.num0blur : &timu.numtex[0][ten-1], bcr ) ;
	DrawExTex( x + ONEX, 							y + ONEY, 	ex2 * bluralpha, true, one == 0 ? &timu.num0blur : &timu.numtex[0][one-1], bcr ) ;
	DrawExTex( x + HITX,							y + HITY,	ex * bluralpha, true, &timu.hittex[0], bcr ) ;
}


static void __DrawJudg( u8 WinFlag, f32 x, f32 y, f32 length, f32 rate, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	u32 cr, blcr ;

	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 

	x += length * rate ;
	cr = CMK( 255, 255, 255, 255 * alpha * alpha2 ) ;
	blcr = CMK( 255, 255, 255, 255 * /*bluralpha*/alpha * alpha2 ) ;
	DrawExTex( x, y, 1.0F, true, ( WinFlag == TRUE ) ? &cdu.winner : &cdu.loser, cr ) ;
	DrawExTex( x, y, bluralpha, true, ( WinFlag == TRUE ) ? &cdu.winner_blur : &cdu.loser_blur, blcr ) ;
}



static void __DrawPlayerHit( f32 x, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	u32 c1, c2 ;
	
	if( alpha != 1.0F && x == 0.0F ) return ;

	c1 = 0xffffff00 + (u32)( 0xff * alpha * alpha2 ) ;
	c2 = 0xffffff00 + (u32)( 0xff * bluralpha * alpha2 ) ;

	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	DrawTex( 526 + x, 253, &timu.hittex[1], c1 ) ;
	
	if( bluralpha != 0.0F )
	{
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
		DrawTex( 526 + x, 253, &timu.hittex[0], c2 ) ;
	}
}

static void __DrawPlayerHitNum( f32 x, s32 num, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	s32 n3, n2, n1, adx ;
	u32 c1, c2 ;
	
	if( alpha != 1.0F && x == 0.0F ) return ;

	c1 = 0xffffff00 + (u32)( 0xff * alpha * alpha2 ) ;
	c2 = 0xffffff00 + (u32)( 0xff * bluralpha * alpha2 ) ;

	n1 = num % 10 ; num /= 10 ;
	n2 = num % 10 ; num /= 10 ;
	n3 = num % 10 ; num /= 10 ;
	
	adx = n3 == 1 ? 10 : 0 ;
	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	DrawTex3( 532 + x, 212, 532 + x + 42, 212 + 42, n1 == 0 ? &timu.num0tex[2] : &timu.numtex[1][n1-1], c1 ) ;
	DrawTex3( 497 + x, 212, 497 + x + 42, 212 + 42, n2 == 0 ? &timu.num0tex[2] : &timu.numtex[1][n2-1], c1 ) ;
	DrawTex3( 442 + x + adx, 209, 442 + x + 64 + adx, 209 + 64, n3 == 0 ? &timu.num0tex[1] : &timu.numtex[1][n3-1], c1 ) ;
	
	if( bluralpha != 0.0F )
	{
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
		DrawTex3( 532 + x, 212, 532 + x + 42, 212 + 42, n1 == 0 ? &timu.num0blur : &timu.numtex[0][n1-1], c2 ) ;
		DrawTex3( 497 + x, 212, 497 + x + 42, 212 + 42, n2 == 0 ? &timu.num0blur : &timu.numtex[0][n2-1], c2 ) ;
		DrawTex3( 442 + x + adx, 209, 442 + x + 64 + adx, 209 + 64, n3 == 0 ? &timu.num0blur : &timu.numtex[0][n3-1], c2 ) ;
	}
}


static void __DrawEnemyHit( f32 x, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	u32 c1, c2 ;
	
	if( alpha != 1.0F && x == 0.0F ) return ;

	c1 = 0xffffff00 + (u32)( 0xff * alpha * alpha2 ) ;
	c2 = 0xffffff00 + (u32)( 0xff * bluralpha * alpha2 ) ;

	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	DrawTex( 147 + x, 253, &timu.hittex[1], c1 ) ;
	
	if( bluralpha != 0.0F )
	{
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
		DrawTex( 147 + x, 253, &timu.hittex[0], c2 ) ;
	}
}

static void __DrawEnemyHitNum( f32 x, s32 num, f32 alpha, f32 bluralpha, f32 alpha2 )
{
	s32 n3, n2, n1, adx ;
	u32 c1, c2 ;

	if( alpha != 1.0F && x == 0.0F ) return ;
	
	c1 = 0xffffff00 + (u32)( 0xff * alpha * alpha2 ) ;
	c2 = 0xffffff00 + (u32)( 0xff * bluralpha * alpha2 ) ;

	n1 = num % 10 ; num /= 10 ;
	n2 = num % 10 ; num /= 10 ;
	n3 = num % 10 ; num /= 10 ;
	
	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
	GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
	adx = n3 == 1 ? 10 : 0 ;
	DrawTex3( 153 + x, 212, 153 + x + 42, 212 + 42, n1 == 0 ? &timu.num0tex[2] : &timu.numtex[1][n1-1], c1 ) ;
	DrawTex3( 118 + x, 212, 118 + x + 42, 212 + 42, n2 == 0 ? &timu.num0tex[2] : &timu.numtex[1][n2-1], c1 ) ;
	DrawTex3( 63 + x + adx, 209, 63 + x + 64 + adx, 209 + 64, n3 == 0 ? &timu.num0tex[1] : &timu.numtex[1][n3-1], c1 ) ;

	if( bluralpha != 0.0F )
	{
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ONE ) ; 
		DrawTex3( 153 + x, 212, 153 + x + 42, 212 + 42, n1 == 0 ? &timu.num0blur : &timu.numtex[0][n1-1], c2 ) ;
		DrawTex3( 118 + x, 212, 118 + x + 42, 212 + 42, n2 == 0 ? &timu.num0blur : &timu.numtex[0][n2-1], c2 ) ;
		DrawTex3( 63 + x + adx, 209, 63 + x + 64 + adx, 209 + 64, n3 == 0 ? &timu.num0blur : &timu.numtex[0][n3-1], c2 ) ;
	}
}

// qbg\GtFNg̋ʃf[^
extern s8 InitHitNumData( void )
{
	MEMINIT( hnu ) ;

	return 0 ;
}

// qbg\GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckHitNumData( void )
{
	return TRUE ;
}

// qbg\GtFNg̋ʃf[^n
extern s8 EndHitNumData( void )
{
	MEMINIT( hnu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// qbg\GtFNg쐬
extern EFFECT *CreateHitNumEffect(
									s32 playernum, s32 enemynum,		// vC[ƓĜꂼ̃qbg
									s32 Priority )				// qbg\GtFNg쐬
{
	EFFECT *Effect ;
	HITNUMEFFECT *hn ;
	s32 time = VParam[ED_HITNUM][0] ;

	if( VParam[ED_HITNUM][0] == 0 ) VParam[ED_HITNUM][0] = 1 ;
	time = VParam[ED_HITNUM][0] ;
		
	// Vqbg\f[^쐬
	Effect = AddEffectData( EFF_HITNUM, (void**)&hn, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// ̏
	if( playernum == enemynum ) enemynum ++ ;
	hn->playnum = playernum ;
	hn->enemnum = enemynum ;
	hn->windir = (s8)( hn->playnum > hn->enemnum ? 0 : 1 ) ;
	
	hn->winpos[0] = hn->winpos[1] = hn->winpos[2] = 1.0F ;
	hn->winblur = 0.0F ;
	hn->playhit.hitnum = 0 ;	hn->playhit.mode = 0 ;
	hn->enemhit.hitnum = 0 ;	hn->enemhit.mode = 0 ;
	
	hn->mode1 = 0 ;
	hn->mode2 = 0 ;
	hn->counter = 0 ;
	
	hn->alpha = 1.0F ;
	
/*	if( playernum == enemynum )
	{
		hn->playerwin = 0.0F ;
		hn->enemywin = 0.0F ;
	}
	else
	{
		if( playernum > enemynum )
		{
			hn->playerwin = 1.0F ;
			hn->enemywin = 0.0F ;
		}
		else
		{
			hn->playerwin = 0.0F ;
			hn->enemywin = 1.0F ;
		}
	}
	hn->playernum = playernum ;
	hn->enemynum = enemynum ;
	hn->con = 0 ;
	hn->alpha = 1.0F ;
	
	for( i = 0 ; i < 3 ; i ++ )
	{
		hn->pnumcon[i] = time + i ;
		hn->phitcon[i] = time + i + 1 ;

		hn->enumcon[i] = time + i + 1 ;
		hn->ehitcon[i] = time + i ;
	}
*/

	// I
	return Effect ;
}

// qbg\GtFNǧns
extern s8 ReleaseHitNumEffect( EFFECT *Effect )
{
	HITNUMEFFECT *hn = ( HITNUMEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// qbg\GtFNgPt[
extern s8 MoveHitNumEffect( EFFECT *Effect )
{
	HITNUMEFFECT *hn = ( HITNUMEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE )
	{
		hn->alpha -= 0.1F ;
		if( hn->alpha <= 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}

	__ProcObj( &hn->playhit ) ;
	__ProcObj( &hn->enemhit ) ;

	switch( hn->mode1 )
	{
	case 0 :
		__SetObjMode( &hn->playhit, 3 ) ;
		__SetObjMode( &hn->enemhit, 3 ) ;
		
		hn->mode1 ++ ;
		hn->counter = 0 ;
		hn->mode2 = 0 ;
		break ;
		
	case 1 :
		if( hn->playhit.hitnum == hn->playnum &&
			hn->enemhit.hitnum == hn->enemnum )
		{
			hn->mode1 ++ ;
			hn->counter = 0 ;
			hn->mode2 = 0 ;
			break ;
		}
		
		if( hn->mode2 == VIBWAIT )
		{
			if( hn->playnum != hn->playhit.hitnum ) __SetObjMode( &hn->playhit, 2 ) ;
			if( hn->enemnum != hn->enemhit.hitnum ) __SetObjMode( &hn->enemhit, 2 ) ;
			hn->mode2 = 0 ;
		}
		else hn->mode2 ++ ;
		
		if( hn->counter == COUNTWAIT )
		{
			PlayEffectSE( SFX_BOSS_KIS_COUNTUP ) ;
		
			if( hn->playnum != hn->playhit.hitnum )
			{
				hn->playhit.hitnum ++ ;
				if( hn->playnum == hn->playhit.hitnum )
				{
					__SetObjMode( &hn->playhit, 3 ) ;
					PlayEffectSE( SFX_BOSS_KIS_COUNTUP_DECIDE, SOUND_SYSTEM_SE_VOLUME, 192 ) ;
				}
			}

			if( hn->enemnum != hn->enemhit.hitnum )
			{
				hn->enemhit.hitnum ++ ;
				if( hn->enemnum == hn->enemhit.hitnum )
				{
					__SetObjMode( &hn->enemhit, 3 ) ;
					PlayEffectSE( SFX_BOSS_KIS_COUNTUP_DECIDE, SOUND_SYSTEM_SE_VOLUME, 64 ) ;
				}
			}
			
			hn->counter = 0 ;
		}
		else hn->counter ++ ;

		break ;
		
	case 2 :
		if( hn->counter == MOVETIME + 3 )
		{
			PlayEffectSE( SFX_BOSS_KIS_WIN ) ;
			
			hn->mode1 ++ ;
			hn->counter = 0 ;
			hn->mode2 = 0 ;
		}
		else
		{
			hn->winpos[0] = 1.0F - ( 									( hn->counter 		< 11 ) 	? (f32)hn->counter / MOVETIME : 1.0F ) ;
			hn->winpos[1] = 1.0F - ( ( hn->counter < 1 ) ? 0.0F : ( 	( hn->counter - 1 	< 11 ) 	? (f32)( hn->counter - 1 ) / MOVETIME : 1.0F ) ) ;
			hn->winpos[2] = 1.0F - ( ( hn->counter < 2 ) ? 0.0F : ( 	( hn->counter - 2 	< 11 ) 	? (f32)( hn->counter - 2 ) / MOVETIME : 1.0F ) ) ;

			hn->counter ++ ;
		}
		break ;
		
	case 3 :
		{
			f32 w ;
			
			if( hn->counter == CICLE )
			{
				 hn->counter = 0 ;
				 hn->mode2 = 1 ;
			}
			else hn->counter ++ ;
			
			w = hn->mode2 == 0 ? 0.30F : 0.1F ;
			hn->winblur = ( ( SINF( (f32)hn->counter / CICLE * PI_2 + PI + PI / 2 ) + 1.0F ) / 2.0F ) * w + 1.0F ;
		}
		break ;
	}

/*
//	if( hn->con == -1 )
	{
		int j ;
	
		j = 0 ;
		for( i = 0 ; i < 3 ; i ++ )
		{
			if( hn->pnumcon[i] != 0 ) hn->pnumcon[i] -- ; else j ++ ;
			if( hn->enumcon[i] != 0 ) hn->enumcon[i] -- ; else j ++ ;
			if( hn->phitcon[i] != 0 ) hn->phitcon[i] -- ; else j ++ ;
			if( hn->ehitcon[i] != 0 ) hn->ehitcon[i] -- ; else j ++ ;
		}
//		if( j == 12 ) hn->con ++ ;
	}
//	else
	{
		hn->con ++ ;
		if( hn->con == VParam[ED_HITNUM][2] ) hn->con = 0 ;
	}
*/
	// I
	return 0 ;
}

// qbg\GtFNg`悷
extern s8 DrawHitNumEffect( EFFECT *Effect )
{
	HITNUMEFFECT *hn = ( HITNUMEFFECT * )Effect->Data ;
//	s32 i, zure = VParam[ED_HITNUM][1], time = VParam[ED_HITNUM][0]  ;
	f32 a[3] = { 1.0F, AIMAGE1, AIMAGE2 }/*, rot*/  ;
	f32 playbla, enembla ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;

	if( hn->windir == 0 )
	{
		playbla = hn->winblur ;
		enembla = 0.0F ;
		
		__DrawJudg( TRUE, PLAYWINX, JUDGWINY, -LENGTH, hn->winpos[0], a[0], hn->winblur, hn->alpha ) ;
		if( hn->winpos[1] != 0.0F ) __DrawJudg( TRUE, PLAYWINX, JUDGWINY, -LENGTH, hn->winpos[1], a[1], hn->winblur, hn->alpha ) ;
		if( hn->winpos[2] != 0.0F ) __DrawJudg( TRUE, PLAYWINX, JUDGWINY, -LENGTH, hn->winpos[2], a[2], hn->winblur, hn->alpha ) ;

		__DrawJudg( FALSE, ENEMLOSE, JUDGLOSY, LENGTH, hn->winpos[0], a[0], 0.0F, hn->alpha ) ;
		if( hn->winpos[1] != 0.0F ) __DrawJudg( FALSE, ENEMLOSE, JUDGLOSY, LENGTH, hn->winpos[1], a[1], 0.0F, hn->alpha ) ;
		if( hn->winpos[2] != 0.0F ) __DrawJudg( FALSE, ENEMLOSE, JUDGLOSY, LENGTH, hn->winpos[2], a[2], 0.0F, hn->alpha ) ;
	}
	else
	{
		playbla = 0.0F ;
		enembla = hn->winblur ;

		__DrawJudg( FALSE, PLAYLOSX, JUDGLOSY, -LENGTH, hn->winpos[0], a[0], 0.0F, hn->alpha ) ;
		if( hn->winpos[1] != 0.0F ) __DrawJudg( FALSE, PLAYLOSX, JUDGLOSY, -LENGTH, hn->winpos[1], a[1], 0.0F, hn->alpha ) ;
		if( hn->winpos[2] != 0.0F ) __DrawJudg( FALSE, PLAYLOSX, JUDGLOSY, -LENGTH, hn->winpos[2], a[2], 0.0F, hn->alpha ) ;

		__DrawJudg( TRUE, ENEMWINX, JUDGWINY, LENGTH, hn->winpos[0], a[0], hn->winblur, hn->alpha ) ;
		if( hn->winpos[1] != 0.0F ) __DrawJudg( TRUE, ENEMWINX, JUDGWINY, LENGTH, hn->winpos[1], a[1], hn->winblur, hn->alpha ) ;
		if( hn->winpos[2] != 0.0F ) __DrawJudg( TRUE, ENEMWINX, JUDGWINY, LENGTH, hn->winpos[2], a[2], hn->winblur, hn->alpha ) ;
	}

	__DrawObj( &hn->enemhit, 95,  241, 1.0F, enembla, hn->alpha ) ;
	__DrawObj( &hn->playhit, 474, 241, 1.0F, playbla, hn->alpha ) ;
	

/*
	rot = ( SINF( PI_2 * hn->con / VParam[ED_HITNUM][2] ) + 1.0F ) / 2.0F ;

	for( i = 0 ; i < 3 ; i ++ )
	{
		__DrawPlayerHitNum( -zure * hn->pnumcon[i] / time, hn->playernum, a[i], hn->playerwin * rot, hn->alpha ) ;
		__DrawPlayerHit( -zure * hn->phitcon[i] / time, a[i], hn->playerwin * rot, hn->alpha ) ;

		__DrawEnemyHitNum( zure * hn->enumcon[i] / time, hn->enemynum, a[i], hn->enemywin * rot, hn->alpha ) ;
		__DrawEnemyHit( zure * hn->ehitcon[i] / time, a[i], hn->enemywin * rot, hn->alpha ) ;
	}
*/
	// I
	return 0 ;
}

// qbgGtFNg̏Ԃ𓾂( 0:ʂ삯  1:~ )
extern s8 GetHitNumEffectState( EFFECT *Effect )
{
	HITNUMEFFECT *hn = ( HITNUMEFFECT * )Effect->Data ;

//	return 0 ;

//	return (s8)( hn->con == -1 ? 0 : 1 ) ;
	return (s8)( hn->mode1 != 3 ? 0 : 1 ) ;
}


