///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectConveItemGet
//
// YK7EffectConveItemGet.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/23/2004
//
//////////////////////////////////////////////////////////////////////////////

// include --------------------------------------
#include "./YK7EffectItemGet.h"
#include "./YK7EffectMessage2.h"
#include "./YK7EffectMessage.h"
#include "./YK7EffectShutter.h"
#include "../Wat/WK7GameInfo.h"

// define ---------------------------------------

#define PRM					VParam[ED_ITEMGET]
#define OBI_W				100
#define OBI_TIME			12
#define OBI_IN_WAIT			(PRM[5])

#define DEBUGFLAG			(PRM[9])
#define ICONNO				(PRM[10])
#define SCENARIONO			(PRM[11])

#define CLOSE_TIME			(PRM[0])
#define OPEN_TIME			(PRM[1])

#define ICON_SPEED			(PRM[2])
#define ICON_Y				(PRM[3])
#define ICON_AIMAGE1		(0)
#define ICON_AIMAGE1_ALPHA	((f32)PRM[6] * 0.01F)

#define ICON_AIMAGE2		(2)
#define ICON_AIMAGE2_ALPHA	((f32)PRM[7] * 0.01F)

#define ICON_AIMAGE3		(5)
#define ICON_AIMAGE3_ALPHA	((f32)PRM[8] * 0.01F)

#define FLASH_TIME			(PRM[4])

#define HIKARIPATH			"/yam/message/hikari.BIN"
#define SIDEPATH			"/yam/message/side.BIN"

// data type ------------------------------------

// data -----------------------------------------

ITEMGETUNION igu ;

// F
static u8 __SideColor[][3] =
{
	24,69,138,	// Vg
//	138,13,32,	// 
	125,25,40,
	127,21,116,	// _j
	127,104,24,	// 
	133,33,74,	// g
	102,102,102	// Ί
} ;

// ʒu
static s16 __FlashPos[ICON_NUM][2] =
{
	0, 0,			// 0
	0, 0,			// 1
	0, 0,			// 2
	0, 0,			// 3
	0, 0,			// 4
	0, 0,			// 5
	0, 0,			// 6
	0, 0,			// 7
	0, 0,			// 8
	0, 0,			// 9
	0, 0,			// 10
	0, 0,			// 11
	49,208,			// 12
	73,198,			// 13  1
	31,193,			// 14  2
	48, 216,		// 15  
	54,191,			// 16
	51,197,			// 17  3
	48,206,			// 18  4
	64,203,			// 19  5
	64,212,			// 20  6
	48,204,			// 21  7
	56,210,			// 22  8
	79,204,			// 23  9
	0, 0,			// 24
	44,199,			// 25  10
	27,196,			// 26  12
	45,207,			// 27  11
	49,208,			// 28
	49,208,			// 29
	49,208,			// 30
	49,208,			// 31

	53,208,		// 32
	53,208,		// 33
	53,208,		// 34
	53,208,		// 35
	53,208,		// 36
	53,208,		// 37

	53,208,		// 38
	53,208,		// 39
	53,208,		// 40
	53,208,		// 41
	53,208,		// 42
	53,208,		// 43

	55, 244,		// 44
	
	22, 200,		// 45
	
	76, 234,		// 46
	76, 234,		// 47
	76, 234,		// 48

	90, 252,		// 49
	90, 252,		// 50

	47, 223,		// 51

	76, 207,		// 52
	78, 207,		// 53
	
	63,199,			// 54
	41,204,			// 55

	49,208,			// 56
} ;

/*
Ή\

Item	Graph
12
13		1
14		2
15
16		
17		3
18		4
19		5
20		6
21		7
22  	8
23		9
24  
25		10
26		12
27		11
*/

// function proto type --------------------------

// function code --------------------------------

// ACe擾GtFNg̋ʃf[^
extern s8 InitItemGetData( void )
{
	MEMINIT( igu ) ;
	
	igu.ShutterPriority = -1 ;
	
	TexLoadSet( HIKARIPATH, &igu.hikari ) ;
	TexLoadSet( SIDEPATH, &igu.side ) ;
	
	return 0 ;
}

// ACe擾GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckItemGetData( void )
{
	if( TexLoadChk( &igu.hikari ) == FALSE ) return FALSE ;
	if( TexLoadChk( &igu.side ) == FALSE ) return FALSE ;

	return TRUE ;
}

// ACe擾GtFNg̋ʃf[^n
extern s8 EndItemGetData( void )
{
	TexRelease( &igu.hikari ) ;
	TexRelease( &igu.side ) ;

	MEMINIT( igu ) ;

	return 0 ;
}

// ACe擾GtFNg쐬
extern EFFECT *CreateItemGetEffect( 
										s8	PackID,				// bZ[W̃pbNhc
										u16	MessageID,			// bZ[Ŵhc
										s8	ButtonCancelFlag,	// {^LZ\tO
										s32	IconID,				// ACR̂hc
										s32	SoundID,			// TEĥhc
										
										u32 color,				// Vb^[̐F
										s32 Priority )
{
	EFFECT *ef ;
	ITEMGETEFFECT *ig ;
	s32 i ;

	// o^
	ef = AddEffectData( EFF_ITEMGET, (void**)&ig, Priority ) ;
	if( ef == NULL ) return NULL ;
	memset( ig, 0, sizeof( ITEMGETEFFECT ) ) ;
	
	ig->efMes = NULL ;
	ig->efShutter = CreateShutterEffect( (u8)CLOSE_TIME, 0, (u8)OPEN_TIME, 0, FALSE, igu.ShutterPriority == -1 ? 127 : igu.ShutterPriority ) ;	// Vb^[GtFNg̍쐬
	igu.ShutterPriority = -1 ;
	if( ig->efShutter == NULL ) goto ERR ;
//	SetEffectIndeManageFlag( ig->efShutter, TRUE ) ;
	ig->efShutterID = GetEffectID( ig->efShutter ) ;

	ig->color 				= *((u32 *)&color) ;
	ig->PackID 				= PackID ;
	ig->MessageID 			= MessageID ;
	ig->ButtonCancelFlag	= ButtonCancelFlag ;
	ig->IconID				= IconID ;
	ig->SoundID				= SoundID ;
	
	ig->Mode				= 0 ;
	ig->Counter 			= 0 ;
	ig->Counter2			= 0 ;
	ig->FlashCounter 		= -1 ;
	
	ig->left.init() ;
	ig->left.setSingle() ;

	ig->icon.init() ;
	ig->icon.setSingle() ;
	ig->icon.spos( SCW ) ;
	
	for( i = 0 ; i < 7 ; i ++ )
		ig->iconback[i] = SCW ;

	// Xg[̃~[g
	gpSound->mRequestMuteStream();

	// I
	return ef ;
	
ERR :
	if( ig->efShutter ) DeleteEffect( ig->efShutter ) ;
	if( ef ) DeleteEffect( ef ) ;

	return NULL ;
}

// ACe擾GtFNǧns
extern s8 ReleaseItemGetEffect( EFFECT *Effect )
{
	ITEMGETEFFECT *ig = ( ITEMGETEFFECT * )Effect->Data ;

	// Xg[̃~[g
	gpSound->mReleaseMuteStream();
	
	return 0 ;
}

// ACe擾GtFNgPt[
extern s8 MoveItemGetEffect( EFFECT *Effect )
{
	ITEMGETEFFECT *ig = ( ITEMGETEFFECT * )Effect->Data ;

	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( CheckEffectValidState( ig->efShutter, ig->efShutterID ) ) MoveEffect( ig->efShutter ) ;
	if( CheckEffectValidState( ig->efMes, ig->efMesID ) ) MoveEffect( ig->efMes ) ;
	ig->icon.proc() ;
	ig->left.proc() ;

	if( ig->FlashCounter != -1 )
	{
		ig->FlashCounter ++ ;
		if( ig->FlashCounter == 22 )
			ig->FlashCounter = -1 ;
	}

	// ̂
	memmove( &ig->iconback[1], &ig->iconback[0], sizeof( f32) * 6 ) ;
	ig->iconback[0] = ig->icon.x ;

	switch( ig->Mode )
	{
	case 0 :	// Vb^[܂ő҂
		if( GetShutterState( ig->efShutter ) == 0 )
		{
			ig->Mode ++ ;
			ig->Counter = 0 ;
			ig->Counter2 = 0 ;
			
			ig->icon.mov( 1, ICON_SPEED, 0.0F ) ;
		}
		break ;
		
		// ԑ҂
	case 1 :
		ig->Counter ++ ;
		if( ig->Counter == FLASH_TIME )
		{
			ig->FlashCounter = 0 ;
			ig->Counter2 ++ ;
		}
		
		if( ig->Counter == OBI_IN_WAIT )
		{
			ig->left.mov( 0, OBI_TIME, 1.0F ) ;
			ig->efMes = CreateMessage2Effect(
									ig->PackID,
									ig->MessageID,
									ig->ButtonCancelFlag,
									ig->IconID,
									ig->SoundID != -1 ? 0 : -1,
									150, 240,
									NULL,		// F
									2,			// FCfbNX
									TRUE,		// ACR`悵ȂtO
									FALSE,		// XZ^OtO
									TRUE		// YZ^OtO
									) ;
			if( ig->efMes == NULL )
			{
				DeleteEffect( Effect ) ;
				return 0 ; 
			}
			if( ig->SoundID != -1 )
			{
				PlayEffectSE( ig->SoundID ) ;
			}
			
			ig->efMesID = GetEffectID( ig->efMes ) ;
			ig->Counter2 ++ ;
		}

		if( ig->Counter2 == 2 )
		{
			ig->Mode ++ ;
			ig->Counter = 0 ;
			ig->Counter2 = 0 ;
		}	
		break ;
/*		
	case 1 :	// ACȅo҂
		if( ig->icon.getlen() < 1.0F )
		{
			ig->icon.movend() ;
		
			ig->Mode ++ ;
		
			ig->left.mov( 0, OBI_TIME, 1.0F ) ;
			ig->efMes = CreateMessage2Effect( ig->PackID, ig->MessageID, ig->ButtonCancelFlag,
												ig->IconID, ig->SoundID != -1 ? 0 : -1, 320, 240, NULL, 2,
												TRUE, TRUE, TRUE ) ;
			if( ig->efMes == NULL )
			{
				DeleteEffect( Effect ) ;
				return 0 ; 
			}
			if( ig->SoundID != -1 )
			{
//				PlayEffectSE( GetMessageSoundID( (s8)ig->PackID, (s8)ig->MessageID ) ) ;
				PlayEffectSE( ig->SoundID ) ;
			}
			
//			SetEffectIndeManageFlag( ig->efMes, TRUE ) ;
			ig->efMesID = GetEffectID( ig->efMes ) ;
		}
		break ;
*/
	case 2 :	// bZ[W̏I҂
		if( CheckEffectValidState( ig->efMes, ig->efMesID ) == FALSE ||
			GetMessage2EffectCompState( ig->efMes ) == TRUE )
		{
			ig->Mode ++ ;
		
			ig->left.mov( 0, OBI_TIME, 0.0F ) ;
			ig->icon.mov( 0, OBI_TIME, -OBI_W ) ;
		}
		break ;

	case 3 :	// bZ[Wޏo҂
		if( CheckEffectValidState( ig->efMes, ig->efMesID ) == FALSE )
		{
			ig->Mode ++ ;
			
			// Vb^[ޏo
			OpenShutterEffect( ig->efShutter ) ;
		}
		break ;
		
	case 4 :	// Vb^[폜҂
		if( CheckEffectValidState( ig->efShutter, ig->efShutterID ) == FALSE )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		break ;
	}

	// I
	return 0 ;
}

// ACe擾GtFNg`悷
extern s8 DrawItemGetEffect( EFFECT *Effect )
{
	ITEMGETEFFECT *ig = ( ITEMGETEFFECT * )Effect->Data ;
	TEXDATA *icon ;
	u32 sidecr ;
	s8 iconnum ;
	
	// ViIio[̎擾
	{
		s32 snum ;
		
		switch( GameInfo.GetScenarioID() )
		{
		case K7SCN07 : snum = 0 ; break ;
		case K7SCN01 : snum = 1 ; break ;
		case K7SCN02 : snum = 2 ; break ;
		case K7SCN03 : snum = 3 ; break ;
		case K7SCN04 : snum = 4 ; break ;
		case K7SCN05 : snum = 5 ; break ;
		case K7SCN06 : snum = 6 ; break ;
		default : snum = -1 ; break ;
		}
		
		sidecr = snum == -1 ? 0 : CMK( __SideColor[snum][0], __SideColor[snum][1], __SideColor[snum][2], 0xff ) ;

		if( DEBUGFLAG )
		{
			if( PRM[11] > 5 ) PRM[11] = 5 ;
			sidecr = CMK( __SideColor[SCENARIONO][0], __SideColor[SCENARIONO][1], __SideColor[SCENARIONO][2], 0xff ) ;
		}
	}
	
	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );
	
	// GtFNg̕`
//	if( CheckEffectValidState( ig->efShutter, ig->efShutterID ) ) DrawEffect( ig->efShutter ) ;
//	if( CheckEffectValidState( ig->efMes, ig->efMesID ) ) DrawEffect( ig->efMes ) ;

	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// т̕`
	if( ig->left.x != 0.0F )
	{
		f32 x ;
		
		x = ( ig->left.x - 1.0F ) * OBI_W ;
	
//		DrawBox( 0, 0, ig->left.x * OBI_W, SCH, CMK( 0xff, 0xff, 0xff, 0xc0 ) ) ;//CMK2( 0xff, 0xc0 ) ) ;
		DrawTex( x, 0, &igu.side, sidecr ) ;
		DrawTex4( x, 240, x + OBI_W, 480, 0.0F, 1.0F, 1.0F, 0.0F, &igu.side, sidecr ) ;

//		DrawBox( 0, ICON_Y, ig->left.x * OBI_W, ICON_Y + OBI_W, 0xc0 ) ;
	}

	// ACR̕`
	EffectTevSetup( EF_TEV_USETEX ) ;
	if( ig->IconID != -1 )
	{
		icon = GetMessageIconTex((s8)ig->IconID) ;
		iconnum = (s8)ig->IconID ;
	}
	else
	{
		if( GetNoneIconCheck( (s8)ig->PackID, (s8)ig->MessageID ) == FALSE )
		{
			icon = GetMessageIconTex( (s8)ig->PackID, (s8)ig->MessageID ) ;
			if( icon == NULL ) return 0 ;
			iconnum = GetMessageIconNumber( (s8)ig->PackID, (s8)ig->MessageID ) ;
		}
		else
		{
			icon = NULL ;
			iconnum = -1 ;
		}
	}
	
	if( DEBUGFLAG )
	{
		icon = GetMessageIconTex((s8)ICONNO) ;
		iconnum = (s8)ICONNO ;
	}
	
	if( icon != NULL )
	{
		DrawTex3(	ig->iconback[ICON_AIMAGE3],			ICON_Y,
					ig->iconback[ICON_AIMAGE3] + OBI_W,	ICON_Y + OBI_W,	icon, CMK( 255, 255, 255, 255 * ICON_AIMAGE3_ALPHA ) ) ;
		DrawTex3(	ig->iconback[ICON_AIMAGE2],			ICON_Y,
					ig->iconback[ICON_AIMAGE2] + OBI_W,	ICON_Y + OBI_W,	icon, CMK( 255, 255, 255, 255 * ICON_AIMAGE2_ALPHA ) ) ;
		DrawTex3(	ig->iconback[ICON_AIMAGE1],			ICON_Y,
					ig->iconback[ICON_AIMAGE1] + OBI_W,	ICON_Y + OBI_W,	icon, CMK( 255, 255, 255, 255 * ICON_AIMAGE1_ALPHA ) ) ;

		DrawTex3( 	ig->icon.x, 		ICON_Y,
					ig->icon.x + OBI_W, ICON_Y + OBI_W, icon ) ;

		// tbV̕`
		if( __FlashPos[iconnum][0] != 0 && __FlashPos[iconnum][1] != 0 &&
			ig->FlashCounter != -1 )
		{
			f32 ex, alpha ;
			
			if( ig->FlashCounter == 0 ){ ex = 0.42F ; alpha = 1.0F ; }
			else if( ig->FlashCounter <= 8 )
			{
/*				f32 f1, f2 ;
			
				f1 = (f32)( ( 8 - 0 ) * ( ig->FlashCounter - 0 ) ) ;
				f2 = f1 / ( 8 - 0 ) ;
				f1 = f2 * ( 1.0F - 0.42F ) + 0.42F ;
*/			
				ex = (f32)( ig->FlashCounter - 0 ) / ( 8 - 0 ) * ( 1.0F - 0.42F ) + 0.42F ;
				alpha = 1.0F ;
			}
			else if( ig->FlashCounter <= 14 )
			{
				ex = (f32)( ig->FlashCounter - 8 ) / ( 14 - 8 ) * ( 1.1F - 1.0F ) + 1.0F ;
				alpha = 1.0F ;
			}
			else if( ig->FlashCounter <= 22 )
			{
				ex = (f32)( ig->FlashCounter - 14 ) / ( 22 - 14 ) * ( 0.42F - 1.1F ) + 1.1F ;
				alpha = (f32)( ig->FlashCounter - 14 ) / ( 22 - 14 ) * ( 0.0F - 1.0F ) + 1.0F ;
			}

			EffectBlendModeSetup( EF_BLEND_ADD ) ;			
			DrawExTex( __FlashPos[iconnum][0] + ig->icon.x, __FlashPos[iconnum][1],
						ex, true, &igu.hikari, CMK( 0xff, 0xff, 0xff, 255 * alpha ) ) ;
			EffectBlendModeSetup( EF_BLEND_ALPHA ) ;			
		}
	}

	// I
	return 0 ;
}


// ɍ쐬ACe擾GtFNgŎgpVb^[̕`D揇ʂύX
extern void SetItemGetShutterPriority( s32 Priority )
{
	igu.ShutterPriority = Priority ;
}

// ACe擾GtFNg̏Ԃ𓾂( 0:bZ[WoO  1:bZ[Wo )
extern s8 GetItemGetState( EFFECT *Effect )
{
	ITEMGETEFFECT *ig = ( ITEMGETEFFECT * )Effect->Data ;

	return (s8)( ig->Mode < 2 ? 0 : 1 ) ;
}

