///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLaser
//
// YK7EffectLaser.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 10/12/2003
//
//////////////////////////////////////////////////////////////////////////////


#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectLaser.h"

// define ---------------------------------------

// data -----------------------------------------

LASERUNION LsUnion ;

// datatype -------------------------------------

// function code --------------------------------

// [U[GtFNg̋ʃf[^
extern s8 InitLaserData( void )
{
	MEMINIT( LsUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}

// [U[GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLaserData( void )
{
	return TRUE ;
}

// [U[GtFNg̋ʃf[^n
extern s8 EndLaserData( void )
{
	MEMINIT( LsUnion ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// [U[GtFNg쐬
extern EFFECT *CreateLaserEffect( Vec Point1,
									Vec Point2,
									f32 CrtLength,
									f32 Width,
									GXColor Color,
									u16 DivNum,
									f32 CenA,
									s32 Priority )
{
	EFFECT *Effect ;
	LASEREFFECT *LsP ;
	
	// V[U[f[^쐬
	Effect = AddEffectData( EFF_LASER, (void**)&LsP, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// [U[f[^
	LsP->Point1 = Point1 ;
	LsP->Point2 = Point2 ;
	LsP->CrtLength = CrtLength ;
	LsP->Width = Width ;
	LsP->Color = Color ;
	LsP->DivNum = DivNum ;
	LsP->RingFlag = FALSE ;
	LsP->CenA = ( CenA < 0.0F ) ? VParam[ED_LASER][11] * 0.01F : CenA ;
	LsP->DoubleBrightFlag = FALSE ;
	LsP->DLaserFlag = FALSE ;
	LsP->P1A = LsP->P2A = 1.0F ;
	
	LsP->LightRate = 0.0F ;
	LsP->DrawFlag = TRUE ;
	LsP->CrtFlag = TRUE ;
	
	LsP->FastDeleteFlag = FALSE ;
	LsP->BrinkFlag = TRUE ;

	// I
	return Effect ;
}

// [U[GtFNǧns
extern s8 ReleaseLaserEffect( EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	// ɂ邱ƂȂ

	// I
	return 0 ;
}

// [U[GtFNgPt[
extern s8 MoveLaserEffect( EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	// U폜tOĂ邩A
	// 폜tOĂāA[U[̃oCAXO폜
	if( ( Effect->DelReqFlag == TRUE && Ls->LightRate == 0.0F ) ||
		Ls->FastDeleteFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// `tOĂ邩ǂŃoCAX̒lω
	if( Ls->CrtFlag == TRUE )
	{
		Ls->LightRate += VParam[ED_LASER][7] * 0.01F ;
		if( Ls->LightRate >= 1.0F ) Ls->LightRate = 1.0F ;
	}
	else
	{
		Ls->LightRate -= VParam[ED_LASER][7] * 0.01F ;
		if( Ls->LightRate < 0.0F ) Ls->LightRate = 0.0F ;
	}
	
	// Ȍ
	if( Ls->RingFlag == TRUE )
	{
		Ls->RingCounter += Ls->RingSpeed ;
		if( Ls->RingCounter > Ls->RingSpace ) Ls->RingCounter -= Ls->RingSpace ;
	}

	// I
	return 0 ;
}

// [U[GtFNg`悷
extern s8 DrawLaserEffect( EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;
	u8 a ;
	u32 c1, c2, c3 ;
	f32 CrtLength ;
//	static Vec PV[2][100] ;
	Vec (*PV)[100] = ( Vec (*)[100] )WorkBuffer ;
	u16 i, j ;

	if( LsUnion.NotAllDrawFlag == TRUE ) return 0 ;

	// `tO|Ă`悵Ȃ
	if( Ls->DrawFlag == FALSE ) return 0 ;
	
	// _ŏ
	Ls->BrinkFlag = (s8)( Ls->BrinkFlag ? FALSE : TRUE ) ;
//	if( Ls->BrinkFlag == FALSE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;
//	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	
	// PxQ{tOĂPxQ{ɂ
	if( Ls->DoubleBrightFlag == TRUE )
	{
   		GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_4, GX_TRUE, GX_TEVPREV ) ;
   	}

	// `揈
	{
		Vec XVec, YVec, Dir, V ;
		f32 Length ;
		
		// __ւ̕Zo
		Dir.x = Ls->Point2.x - Ls->Point1.x ;
		Dir.y = Ls->Point2.y - Ls->Point1.y ;
		Dir.z = Ls->Point2.z - Ls->Point1.z ;
		Length = PSVECMag( &Dir ) ;
		PSVECNormalize( &Dir, &Dir ) ;

		// Q_Ԃ̋Z␳
		CrtLength = Length < Ls->CrtLength * 3.0F ? Length * 0.48F : Ls->CrtLength ;

		// QZo
		GetXYZVector( Dir, &XVec, &YVec, NULL ) ;
/*		V.x = 0.0F ;
		V.y = 1.0F ;
		V.z = 0.0F ;
		PSVECCrossProduct( &Dir, &V, &YVec ) ;
		PSVECCrossProduct( &Dir, &YVec, &XVec ) ;
*/
		
		// F̎Zo
		c1 = CMKC2( Ls->Color, Ls->Color.a * Ls->LightRate * Ls->P1A ) ;
		c2 = CMK( Ls->Color.r * Ls->CenA, Ls->Color.g * Ls->CenA, Ls->Color.b * Ls->CenA, Ls->Color.a * Ls->LightRate * Ls->CenA ) ;
//		c3 = CMKC2( c1, 0 ) ; 
		c3 = CMK( 0,0,0,0 ) ;

		// ~̍W쐬
		{
			f32 x, y ;
			Vec XV, YV ;
			
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				x = COSF( PI_2 / ( Ls->DivNum - 1 ) * i ) * Ls->Width ;
				y = SINF( PI_2 / ( Ls->DivNum - 1 ) * i ) * Ls->Width ;
				
				PSVECScale( &XVec, &XV, x ) ;
				PSVECScale( &YVec, &YV, y ) ;
				PSVECAdd( &XV, &YV, &V ) ;
				PSVECAdd( &V, &Ls->Point1, &PV[0][i] ) ;
				
				PSVECScale( &Dir, &V, CrtLength ) ;
				PSVECAdd( &V, &PV[0][i], &PV[1][i] ) ;
			}
		}
		
		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[0][i] ) ;	GCX( c1 ) ; 
				GPV( PV[1][i] ) ;	GCX( c2 ) ; 
			}
		}
		GXEnd() ;
		
		// ~̍W쐬
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				PSVECScale( &Dir, &V, Length - CrtLength * 2.0F ) ;
				PSVECAdd( &V, &PV[1][i], &PV[0][i] ) ;
			}
		}

		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[1][i] ) ;	GCX( c2 ) ; 
				GPV( PV[0][i] ) ;	GCX( c2 ) ; 
			}
		}
		GXEnd() ;
		
		// ~̍W쐬
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				PSVECScale( &Dir, &V, CrtLength ) ;
				PSVECAdd( &V, &PV[0][i], &PV[1][i] ) ;
			}
		}

		a = (u8)( Ls->Color.a * Ls->LightRate * Ls->P2A ) ;
		
		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[0][i] ) ;	GCX( c2 ) ; 
				GPV( PV[1][i] ) ;	GCX( c3 ) ; 
			}
		}
		GXEnd() ;
	}

	// `揈
	if( Ls->DLaserFlag == TRUE )
//	if( 0 )
	{
		Vec XVec, YVec, Dir, V ;
		f32 Length ;
		
		// __ւ̕Zo
		Dir.x = Ls->Point2.x - Ls->Point1.x ;
		Dir.y = Ls->Point2.y - Ls->Point1.y ;
		Dir.z = Ls->Point2.z - Ls->Point1.z ;
		Length = PSVECMag( &Dir ) ;
		PSVECNormalize( &Dir, &Dir ) ;

		// Q_Ԃ̋Z␳
		CrtLength = Length < Ls->CrtLength * 3.0F ? Length * 0.48F : Ls->CrtLength ;

		// QZo
		GetXYZVector( Dir, &XVec, &YVec, NULL ) ;
		
		// F̎Zo
		c1 = CMKC2( Ls->DLaserColor, Ls->DLaserColor.a * Ls->LightRate ) ;
		c2 = CMK( Ls->DLaserColor.r * Ls->CenA, Ls->DLaserColor.g * Ls->CenA, Ls->DLaserColor.b * Ls->CenA, Ls->DLaserColor.a * Ls->LightRate * Ls->CenA ) ;
//		c3 = CMKC2( c1, 0 ) ; 
		c3 = CMK( 0,0,0,0 ) ;

		// ~̍W쐬
		{
			f32 x, y ;
			Vec XV, YV ;
			
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				x = COSF( PI_2 / ( Ls->DivNum - 1 ) * i ) * Ls->DLaserWidth ;
				y = SINF( PI_2 / ( Ls->DivNum - 1 ) * i ) * Ls->DLaserWidth ;
				
				PSVECScale( &XVec, &XV, x ) ;
				PSVECScale( &YVec, &YV, y ) ;
				PSVECAdd( &XV, &YV, &V ) ;
				PSVECAdd( &V, &Ls->Point1, &PV[0][i] ) ;
				
				PSVECScale( &Dir, &V, CrtLength ) ;
				PSVECAdd( &V, &PV[0][i], &PV[1][i] ) ;
			}
		}
		
		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[0][i] ) ;	GCX( c1 ) ; 
				GPV( PV[1][i] ) ;	GCX( c2 ) ; 
			}
		}
		GXEnd() ;
		
		// ~̍W쐬
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				PSVECScale( &Dir, &V, Length - CrtLength * 2.0F ) ;
				PSVECAdd( &V, &PV[1][i], &PV[0][i] ) ;
			}
		}

		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[1][i] ) ;	GCX( c2 ) ; 
				GPV( PV[0][i] ) ;	GCX( c2 ) ; 
			}
		}
		GXEnd() ;
		
		// ~̍W쐬
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				PSVECScale( &Dir, &V, CrtLength ) ;
				PSVECAdd( &V, &PV[0][i], &PV[1][i] ) ;
			}
		}
		
		a = (u8)( Ls->Color.a * Ls->LightRate * Ls->P2A ) ;
		
		// ~̕`
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Ls->DivNum * 2 ) ) ;
		{
			for( i = 0 ; i < Ls->DivNum ; i ++ )
			{
				GPV( PV[0][i] ) ;	GCX( c2 ) ; 
				GPV( PV[1][i] ) ;	GCX( c3 ) ; 
			}
		}
		GXEnd() ;
	}

	// O̕`
	if( Ls->RingFlag == TRUE )
	{
		f32 Length ;
		s32 Num ;
		Vec xv, yv, zv, Pos ;
		f32 Sin, Cos ;

		// `悷郊O̐𐔂
		Length = VECDistance( &Ls->Point2, &Ls->Point1 ) ;
		Num = (s32)( Length / Ls->RingSpace ) ;
		
		// R𓾂
		{
			VECSubtract( &Ls->Point2, &Ls->Point1, &zv ) ;
			VECNormalize( &zv, &zv ) ;
			yv.x = 0.0F ;	yv.y = 1.0F ;	yv.z = 0.0F ;
			VECCrossProduct( &zv, &yv, &xv ) ;
			VECCrossProduct( &xv, &zv, &yv ) ;
		}

		// {ƂȂ钸_𖄂߂
		{
			Mtx m ;

			m[0][0] = xv.x ; m[0][1] = yv.x ; m[0][2] = zv.x ; m[0][3] = 0.0F ;
			m[1][0] = xv.y ; m[1][1] = yv.y ; m[1][2] = zv.y ; m[1][3] = 0.0F ;
			m[2][0] = xv.z ; m[2][1] = yv.z ; m[2][2] = zv.z ; m[2][3] = 0.0F ;

			for( i = 0 ; i < Ls->RingDivNum ; i ++ )
			{
				Sin = SINF( ( PI_2 / ( Ls->RingDivNum - 1 ) ) * i ) ;
				Cos = COSF( ( PI_2 / ( Ls->RingDivNum - 1 ) ) * i ) ;
				PV[0][i].x = Cos * ( Ls->Width + Ls->RingLaserSpace ) ;
				PV[0][i].y = Sin * ( Ls->Width + Ls->RingLaserSpace ) ;
				PV[0][i].z = 0.0F ;
				PSMTXMultVec( m, &PV[0][i], &PV[0][i] ) ;

				PV[1][i].x = Cos * ( Ls->Width + Ls->RingLaserSpace + Ls->RingWidth ) ;
				PV[1][i].y = Sin * ( Ls->Width + Ls->RingLaserSpace + Ls->RingWidth ) ;
				PV[1][i].z = 0.0F ;
				PSMTXMultVec( m, &PV[0][i], &PV[0][i] ) ;
			}
		}

		// `Jn
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( Num * ( Ls->RingDivNum * 2 + 2 ) ) ) ;
		{
			for( i = 0 ; i < Num ; i ++ )
			{
				Pos.x = Ls->Point1.x + zv.x * ( Ls->RingSpace * i + Ls->RingCounter ) ;
				Pos.y = Ls->Point1.y + zv.y * ( Ls->RingSpace * i + Ls->RingCounter ) ;
				Pos.z = Ls->Point1.z + zv.z * ( Ls->RingSpace * i + Ls->RingCounter ) ;

				GP3( PV[0][0].x + Pos.x, PV[0][0].y + Pos.y, PV[0][0].z + Pos.z ) ;
				GCX( 0xffffffff )  ;
				for( j = 0 ; j < Ls->RingDivNum ; j ++ )
				{
					GP3( PV[0][j].x + Pos.x, PV[0][j].y + Pos.y, PV[0][j].z + Pos.z ) ;
					GCX( c1 ) ;

					GP3( PV[1][j].x + Pos.x, PV[1][j].y + Pos.y, PV[1][j].z + Pos.z ) ;
					GCX( c2 ) ;
				}
				GP3( PV[1][j-1].x + Pos.x, PV[1][j-1].y + Pos.y, PV[1][j-1].z + Pos.z ) ;
				GCX( 0 ) ;
			}
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}

// [U[GtFNĝQ_ݒ肷
extern s8 SetLaserEffectPoint( EFFECT *Effect, Vec *Point1, Vec *Point2 ) 
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;
	
	if( Point1 != NULL ) Ls->Point1 = *Point1 ;
	if( Point2 != NULL ) Ls->Point2 = *Point2 ;
	
	// I
	return 0 ;
}

// [U[GtFNg`悷邩ǂZbg(nIȂ)
extern s8 SetLaserEffectDrawFlag( EFFECT *Effect, s8 DrawFlag )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;
	
	Ls->DrawFlag = DrawFlag ;
	
	// I
	return 0 ;
}

// [U[GtFNg`悷邩ǂZbg(tF[ho[W)
extern s8 SetLaserEffectRenderFlag( EFFECT *Effect, s8 RenderFlag )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;
	
	Ls->CrtFlag = RenderFlag ;
	
	// I
	return 0 ;
}


// [U[GtFNg̑폜NGXgs
extern s8 FastDelLaserEffect( EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	Ls->FastDeleteFlag = TRUE ;
	
	// I
	return 0 ;
}

// e_ł̃At@lZbg
extern s8 SetLaserEffectAlpha( f32 P1A, f32 CenA, f32 P2A, EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	Ls->CenA = CenA ;
	Ls->P1A = P1A ;
	Ls->P2A = P2A ;
	
	// I
	return 0 ;
}

// [U[̐FZbg
extern s8 SetLaserEffectColor( GXColor *Color, EFFECT *Effect )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	Ls->Color = *Color ;
	
	// I
	return 0 ;
}


// [U[ɃO
extern s8 SetLaserEffectRing( EFFECT *Effect, u8 RingFlag, f32 RingWidth, f32 RingLaserSpace,
								s16 RingDivNum, f32 RingSpace, f32 RingSpeed )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	// Zbg
	Ls->RingFlag = RingFlag ;
	Ls->RingWidth = RingWidth ;
	Ls->RingLaserSpace = RingLaserSpace ;
	Ls->RingDivNum = RingDivNum ;
	Ls->RingSpace = RingSpace ;
	Ls->RingSpeed = RingSpeed ;
	Ls->RingCounter = 0.0F ;

	// I
	return 0 ;
}

// Qd[U[̃ZbgAbvs
extern s8 SetLaserEffectDouble( EFFECT *Effect, u8 DoubleLaserFlag, f32 Width, GXColor Color )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	Ls->DLaserFlag = (s8)DoubleLaserFlag ;
	Ls->DLaserWidth = Width ;
	Ls->DLaserColor = Color ;
	
	// I
	return 0 ;
}
	
// Q{̋Pxgp邩ǂ̃tO
extern s8 SetLaserEffectDoubleBrightFlag( EFFECT *Effect, u8 DoubleBrightFlag )
{
	LASEREFFECT *Ls = ( LASEREFFECT * )Effect->Data ;

	Ls->DoubleBrightFlag = (s8)DoubleBrightFlag ;
	
	// I
	return 0 ;
}

// [U[GtFNĝׂĂ`悷邩ǂZbg
extern s8 SetLaserEffectAllDrawFlag( s8 Flag )
{
	LsUnion.NotAllDrawFlag = !Flag ;
	
	// I
	return 0 ;
}	



