///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLensFlare
//
// YK7EffectLensFlare.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/24/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include <dolphin/gx.h>
#include "./YK7EffectLensFlare.h"
//#include "../Wat/WK7MainTask.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_LENSFLARE]

#define FLARE_TEXPATH	"/Yam/Effect/LensFlare/c_lens_"		// YtAeNX`̃pX
#define OBJECTNUM		(10)									// YtAIuWFNg̐

#define CENTERX			(SCW/2)			// ʒS
#define CENTERY			(SCH/2)			// ʒS

#define TOKENCODE		(0x2481)

// datatype -------------------------------------

typedef struct tagLENSFLAREINFO
{
	s8 texno ;			// gpeNX`ԍ
	f32 pos ;			// ʒS瑾z̈ʒu܂ł 1.0F Ƃ΋
	f32 size ;			// eNX`TCY( 1.0F : 100% )
} LENSFLAREINFO ;

// data -----------------------------------------

LENSFLAREUNION lfu ;

// IuWFNge[u
static LENSFLAREINFO _LensFlareTable[OBJECTNUM] =
{
	0, 1.0F, 1.5F,
	1, 0.7F, 1.0F,
	1, 0.6F, 0.6F,
	2, 0.1F, 0.35F,
	3, -0.1F, 0.35F,
	3, -0.2F, 0.28F,
	3, -0.3F, 0.25F,
	4, -0.5F, 0.8F,
	5, -0.75F, 0.4F,
	5, -1.0F, 0.4F
} ;

// function proto type --------------------------

// R[obN֐
void LensFlareCallBack( u16 token ) ;

// function code --------------------------------

// R[obN֐
void LensFlareCallBack( u16 token )
{
	LENSFLAREEFFECT *lf = ( LENSFLAREEFFECT * )lfu.Active->Data ;
	Vec /*temp,*/ Sun ;
	
	if( token == TOKENCODE )
	{
		// z̍WZo
//		GetJObjPos( lf->JObj->GetJObj(), &temp ) ;
//		GetScreenPosition( &temp, &Sun ) ;
		Sun = lf->SunPos ;

	//	lf->Image->ScreenCopy() ;

		// Zo
		{
			s32 i, j, num ;
		
			union
			{
				u32 code ;
				struct
				{
					u8 a, r, g, b ;
				} ; 
			} color ;
			
		#define AREA	(8)
			num = 0 ;
			for( i = 0 ; i < AREA ; i ++ )
			{
				for( j = 0 ; j < AREA ; j ++ )
				{
					s32 x, y ;
					
					x = (s32)( Sun.x + j * 2 - ( AREA * 2 ) / 2 ) ;
					y = (s32)( Sun.y + i * 2 - ( AREA * 2 ) / 2 ) ;
					if( !( x < 0 || y < 0 || x > SCW || y > SCH ) )
					{
						GXPeekARGB( (u16)x, (u16)y, &color.code ) ;
						if( lf->AlphaModeFlag == true )
						{
							if( color.a >= lf->MinAlpha && color.a < lf->MaxAlpha )
								num ++ ;
						}
						else
						{
							if( color.b + color.g + color.r >= 247 * 3 )
								num ++ ;
						}
					}
				}
			}
			lf->alpha = (u8)( 255 * ( (f32)num / (AREA * AREA) ) ) ;
		#undef AREA
		}
	}

	if( lf->oldcallback != NULL )
		lf->oldcallback( token ) ;	
}

// YtAGtFNg̋ʃf[^
extern s8 InitLensFlareData( void )
{
	MEMINIT( lfu ) ;

	return 0 ;
}

// YtAGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLensFlareData( void )
{
	return TRUE ;
}

// YtAGtFNg̋ʃf[^n
extern s8 EndLensFlareData( void )
{
	// ꉞ܂
	ReleaseLensFlareTexture() ;

	MEMINIT( lfu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// YtAGtFNg쐬
extern EFFECT *CreateLensFlareEffect(
								WK7JObj *JObj,				// z JObj
								bool AlphaModeFlag,			// őz𔻒f邩̃tO
								u8 MaxAlpha, u8 MinAlpha, 	// őz𔻒fꍇ̑zƔ肷At@l͈̔
								s32 Priority )
{
	EFFECT *Effect ;
	LENSFLAREEFFECT *lf ;
//	WK7ScreenImage *Image ;
	
/*	// XN[C[Wf[^쐬
	Image = new WK7ScreenImage ;
	Image->SetFormat( GX_TF_RGB565 ) ;
	if( Image == NULL ) return NULL ;
	if( Image->AllocBuffer() == false )
	{
		delete Image ;
		return NULL ;
	}
*/
	// VYtAf[^쐬
	Effect = AddEffectData( EFF_LENSFLARE, (void**)&lf, Priority ) ;
	if( Effect == NULL )
	{
//		delete Image ;
		return NULL ;
	}
	memset( lf, 0, sizeof( LENSFLAREEFFECT ) ) ;
	
	// lۑ
	lf->JObj = JObj ;
	lf->AlphaModeFlag = AlphaModeFlag ;
	lf->MaxAlpha = MaxAlpha ;
	lf->MinAlpha = MinAlpha ;
	
	// ANeBuݒ
	{
		EFFECT *temp = lfu.Active ;
		u32 id = lfu.ActiveID ;
				
		lfu.Active = Effect ;
		lfu.ActiveID = GetEffectID( Effect ) ;

		if( CheckEffectValidState( temp, id ) == TRUE )
		{
			lf->oldcallback = ( ( LENSFLAREEFFECT * )temp->Data )->oldcallback ;
			DeleteEffect( temp ) ;
		}
		else
		{
			// R[obN֐̓o^
			lf->oldcallback = GXSetDrawSyncCallback( LensFlareCallBack ) ;
		}
	}

	// I
	return Effect ;
}

// YtAGtFNǧns
extern s8 ReleaseLensFlareEffect( EFFECT *Effect )
{
	LENSFLAREEFFECT *lf = ( LENSFLAREEFFECT * )Effect->Data ;

//	if( lf->Image != NULL )
//		delete lf->Image ;
		
	if( lfu.Active == Effect )
	{
		GXDrawSyncCallback old ;
	
		// R[obN֐߂
		old = GXSetDrawSyncCallback( lf->oldcallback ) ;
		if( old != LensFlareCallBack ) GXSetDrawSyncCallback( old ) ;

		lfu.Active = NULL ;
		lfu.ActiveID = 0xffffffff ;
	}

	// I
	return 0 ;
}

// YtAGtFNgPt[
extern s8 MoveLensFlareEffect( EFFECT *Effect )
{
	LENSFLAREEFFECT *lf = ( LENSFLAREEFFECT * )Effect->Data ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// I
	return 0 ;
}

// YtAGtFNg`悷
extern s8 DrawLensFlareEffect( EFFECT *Effect )
{
	LENSFLAREEFFECT *lf = ( LENSFLAREEFFECT * )Effect->Data ;
	LENSFLAREINFO *tb ;
	s32 i ;
	f32 rot, len ;
	Vec temp, Sun, Dir ;
	u32 cr ;

	u32 xOrig, yOrig, wd, ht ;

	GXGetScissor( &xOrig, &yOrig, &wd, &ht ) ;
#ifdef YAMADADEBUG	
	{
		static s32 time = 0 ;
		
		time ++ ;
		if( time == 30 )
		{
			time = 0 ;
			OSReport( "xOrig:%d   yOrig:%d   wd:%d   ht:%d    Sun.x:%.3f  Sun.y:%.3f\n", xOrig, yOrig, wd, ht, lf->SunPos.x, lf->SunPos.y ) ;
		}
	}
#endif
	
	
	// R[
	GXSetDrawSync( TOKENCODE ) ;
	
	// zpxȏႤĂꍇ͏Ȃ
	{
		f32 hr ;
		Mtx /*mtx,*/invmtx;
		Vec CPos, ZVec, SPos, DVec ;
	
		EffectGetInvViewMatrix( invmtx ) ;
//		MTXInverse(mtx,invmtx);
		
//		CPos.x = -mtx[0][3];	CPos.y = -mtx[1][3];	CPos.z = -mtx[2][3];
		invmtx[2][3] = invmtx[1][3] = invmtx[0][3] = 0.0F ;
		HSD_CObjGetEyePosition( GetEffectCamera(), &CPos ) ;
		
		ZVec.x = 0.0F ; 	ZVec.y = 0.0F ; 	ZVec.z = 1.0F ;
//		MTXMultVec( invmtx, &CPos, &CPos ) ;
		MTXMultVec( invmtx, &ZVec, &ZVec ) ;
		GetJObjPos( lf->JObj->GetJObj(), &SPos ) ;
		VECSubtract( &SPos, &CPos, &DVec ) ;
		
		if( VECMag(&DVec) < 0.0001f ){
			return 0;
		}
		
		VECNormalize( &DVec, &DVec ) ;
		hr = VECDotProduct( &DVec, &ZVec ) ;
		if( hr > 0.0F ) return 0 ;
	}

	// ҂
/*	{
		OSTick tick ;
		tick = OSGetTick() ;
		while( OSTicksToMilliseconds(OSGetTick()) - OSTicksToMilliseconds(tick) < VParam[ED_GMARK][12] ){}
	}
*/
	// zʊOɂ牽
	GetJObjPos( lf->JObj->GetJObj(), &temp ) ;
	GetScreenPosition( &temp, &Sun ) ;
	lf->SunPos = Sun ;
	if( Sun.x < 0.0F || Sun.x >= SCW ||
		Sun.y < 0.0F || Sun.y >= SCH ) return 0 ;
		
	// Zo
/*	{
		s32 i, j, num, num2, num3, con ;
		OSTick tick ;
		
		union
		{
			u32 code ;
			struct
			{
				u8 a, r, g, b ;
			} ; 
		} color ;
		
		con = 0 ;
		tick = OSGetTick() ;
		
	LABEL1 :
	#define AREA	(4)
		num = 0 ;
		num2 = 0 ;
		num3 = 0 ;
		for( i = 0 ; i < AREA ; i ++ )
		{
			for( j = 0 ; j < AREA ; j ++ )
			{
				s32 x, y ;
				
				x = (s32)( Sun.x + j - AREA / 2 ) ;
				y = (s32)( Sun.y + i - AREA / 2 ) ;
				if( x < 0 || y < 0 || x > SCW || y > SCH )
				{
				}
				else
				{
					num2 ++ ;
					
					GXPeekARGB( (u16)x, (u16)y, &color.code ) ;
//					GXPokeARGB( (u16)x, (u16)y, 0 ) ;
					if( color.b + color.g + color.r == 0 ) num3 ++ ;

					if( color.b + color.g + color.r > 200 * 3 ||
						( color.b > color.g + 30 && color.b > color.r + 30 ) )
						num ++ ;
				}
			}
		}
		cr = CMK( 255,255,255,255 * ( (f32)num / (AREA * AREA) ) ) ;
		
		if( num == 0 && num3 == (AREA * AREA) && num2 == (AREA * AREA) && con == 0 )
		{
			while( OSTicksToMilliseconds(OSGetTick()) - OSTicksToMilliseconds(tick) < VParam[ED_GMARK][12] ){}
			con ++ ;
			goto LABEL1 ;
		}
	#undef AREA
	}
*/
	cr = CMK( 255,255,255,lf->alpha ) ;

	// `揀	
	EffectRenderSetup( EF_PROJECT_ORTHO, lfu.type == LENSFLARETEX_ADD ? EF_BLEND_ADD : EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	// SƂ̊pxƋ𓾂
	Dir.x = Sun.x - CENTERX ;
	Dir.y = Sun.y - CENTERY ;
	len = sqrtf( Dir.x * Dir.x + Dir.y * Dir.y ) ;
	rot = atan2( Dir.y, Dir.x ) ;
	
	// `
	tb = _LensFlareTable ;
	for( i = 0 ; i < OBJECTNUM ; i ++, tb ++ )
	{
		DrawRotTex( Dir.x * tb->pos + CENTERX, (f32)( Dir.y * tb->pos + CENTERY ) /*/ SCH * ht*/ + yOrig,
					rot, tb->size, &lfu.Tex[tb->texno], cr ) ;
	}

	// I
	return 0 ;
}

// YtAGtFNg̃eNX`̏Jn
extern s8 SetupLensFlareTexture( LENSFLARETEXTYPE type )
{
	s32 i ;
	char name[64] ;

//	type = LENSFLARETEX_ALPHA ;

	if( lfu.SetupFlag == true ) return true ;
	if( lfu.SetupStartFlag == true ) return true ;
	
	for( i = 0 ; i < LENSFLARE_TEXNUM ; i ++ )
	{
		switch( type )
		{
		case LENSFLARETEX_ADD : 	sprintf( name, "%s%02d.BIN", FLARE_TEXPATH, i + 1 ) ; break ;
		case LENSFLARETEX_ALPHA : 	sprintf( name, "%s%02dd.BIN", FLARE_TEXPATH, i + 1 ) ; break ;
		}
		TexLoadSet( name, &lfu.Tex[i] ) ;
	}
	
	// ^Cvۑ
	lfu.type = type ;
	
	// ZbgAbvX^[gtO𗧂Ă
	lfu.SetupStartFlag = true ;
	lfu.SetupFlag = false ;
	
	// I
	return 0 ;
}

// YtAGtFNg̃eNX`̏̊`FbN( TRUE:  FALSE:܂ )
extern s8 CheckLensFlareTexture( void )
{
	s32 i ;

	if( lfu.SetupFlag == true ) return TRUE ;
	if( lfu.SetupStartFlag == false ) return FALSE ;
	
	// ǂݍ݊`FbN
	for( i = 0 ; i < LENSFLARE_TEXNUM ; i ++ )
	{
		if( TexLoadChk( &lfu.Tex[i] ) == FALSE ) return FALSE ;
	}
	
	// tOZbg
	lfu.SetupFlag = true ;
	lfu.SetupStartFlag = false ;
	
	return TRUE ;
}

// YtAGtFNg̃eNX`̌n
extern s8 ReleaseLensFlareTexture( void )
{
	s32 i ;

	if( lfu.SetupFlag == false ) return TRUE ;
	if( lfu.SetupStartFlag == true ) return FALSE ;
	
	// n
	for( i = 0 ; i < LENSFLARE_TEXNUM ; i ++ )
	{
		TexRelease( &lfu.Tex[i] ) ;
	}
	
	// tO|
	lfu.SetupFlag = false ;
	lfu.SetupStartFlag = false ;

	// I
	return 0 ;
}



