///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLight
//
// YK7EffectLight.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/28/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectLight.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define LIGHT_FILENAME			"/Yam/Effect/Flash/Tex"

// datatype -------------------------------------

// data -----------------------------------------

LIGHTUNION LigUnion ;

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitLightData( void )
{
	MEMINIT( LigUnion ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLightData( void )
{
	return TRUE ;
}


// GtFNg̋ʃf[^n
extern s8 EndLightData( void )
{
	MEMINIT( LigUnion ) ;

	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateLightEffect( WK7JObj *JObj,				// "P1" ` "P4" ܂ł JObj  WK7JObj ւ̃|C^
					s32 TexNumber,								// eNX`ԍ
					f32 MaxY, f32 MinY,							// ̍ő̍ƍŏ̍
					f32 MaxSinSpeed, f32 MinSinSpeed,				// TCXs[h̍ő呬xƍŏx
					f32 ExRate,									// 㕔ł̊g嗦
					 s32 Priority )
{
	LIGHTEFFECT *Light ;
	EFFECT *Effect ;
	WK7JObj *Pos[4] ;
	s32 i ;
	char Str[12] ;
	
	// P1  P4 ܂ł WK7JObj G[
	for( i = 0 ; i < 4 ; i ++ )
	{
		sprintf( Str, "P%02d", i ) ;	
		if( ( Pos[i] = JObj->GetObj( Str ) ) == NULL ) return NULL ;
	}

	// Vf[^쐬
	Effect = AddEffectData( EFF_LIGHT, (void**)&Light, Priority ) ;
	if( Effect == NULL ) return NULL ;
	
	// f[^
	Light->MinY = MinY ;
	Light->MaxY = MaxY ;
	Light->MaxSinSpeed = MaxSinSpeed ;
	Light->MinSinSpeed = MinSinSpeed ;
	Light->TexNumber = TexNumber ;
	Light->ExRate = ExRate ;

	Light->SinCounter = 0.0F ;
	Light->SinSpeed = rand() * ( Light->MaxSinSpeed - Light->MinSinSpeed ) / RAND_MAX + Light->MinSinSpeed ;
	Light->Y = rand() * ( Light->MaxY - Light->MinY ) / RAND_MAX + Light->MinY ;

	for( i = 0 ; i < 4 ; i ++ )
		Light->Pos[i] = Pos[i] ;

	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseLightEffect( EFFECT *Effect )
{
	LIGHTEFFECT *Light = ( LIGHTEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveLightEffect( EFFECT *Effect )
{
	LIGHTEFFECT *Light = ( LIGHTEFFECT * )Effect->Data ;

	if( (LIGHTEFFECT *)NULL == Light ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// ڂ
	Light->SinCounter += Light->SinSpeed ;
	if( Light->SinCounter > PI_2 )
	{
		Light->SinCounter = 0.0F ;
		Light->SinSpeed = rand() * ( Light->MaxSinSpeed - Light->MinSinSpeed ) / RAND_MAX + Light->MinSinSpeed ;
		Light->Y = rand() * ( Light->MaxY - Light->MinY ) / RAND_MAX + Light->MinY ;
	}

	// I
	return 0 ;
}
	
// ̃GtFNg`悷
extern s8 DrawLightEffect( EFFECT *Effect )
{
	LIGHTEFFECT *Light = ( LIGHTEFFECT * )Effect->Data ;
	LIGHTTEX *Tex ;
	HSD_JObj *JObj ;
//	static Vec Pos1[4][20], Pos2[4][20] ;
	Vec (*Pos1)[20] = ( Vec (*)[20] )WorkBuffer, (*Pos2)[20] = ( Vec (*)[20] )&WorkBuffer[sizeof( Vec ) * 4 * 20];
	Vec /*Pos1[4], Pos2[4],*/ Dir1, Dir2, d1, d2 ;
	f32 Length1, Length2 ;
	s32 i, j ;
	u32 DivNum ;
	f32 Y ;
	u8 a1, a2 ;
	 
	if( (LIGHTEFFECT *)NULL == Light ) return 0 ;
	
	// eNX`f[^擾
	Tex = &LigUnion.Tex[Light->TexNumber] ;
	
	a1 = (u8)VParam[ED_LIGHT][7] ;
	a2 = (u8)VParam[ED_LIGHT][8] ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;
	
	// eNX`[h
	GTLOAD2( Tex->Tex ) ;
	
	// |S_Zo
	{
		// S_擾
		for( i = 0 ; i < 4 ; i ++ )
		{
			JObj = Light->Pos[i]->GetJObj() ;
			HSD_JObjSetupMatrix( JObj ) ;
			Pos1[i][0].x = JObj->mtx[0][3] ;
			Pos1[i][0].y = JObj->mtx[1][3] ;
			Pos1[i][0].z = JObj->mtx[2][3] ;
		}

		// Zo
		Y = sinf( Light->SinCounter ) * Light->Y + Light->Y ;

		// e_Ԃ̋㕔̒_Zo
		VECSubtract( &Pos1[1][0], &Pos1[0][0], &Dir1 ) ;
		VECNormalize( &Dir1, &Dir1 ) ;
		VECSubtract( &Pos1[3][0], &Pos1[0][0], &Dir2 ) ;
		VECNormalize( &Dir2, &Dir2 ) ;
		Length1 = VECDistance( &Pos1[0][0], &Pos1[1][0] ) * ( Light->ExRate - 1.0F ) / 2.0F ;
		Length2 = VECDistance( &Pos1[1][0], &Pos1[2][0] ) * ( Light->ExRate - 1.0F ) / 2.0F ;

		VECScale( &Dir1, &Dir1, Length1 ) ;
		VECScale( &Dir2, &Dir2, Length2 ) ;
		
		Pos2[0][0].x = Pos1[0][0].x - Dir1.x - Dir2.x ;  
		Pos2[0][0].y = Pos1[0][0].y - Dir1.y - Dir2.y + Y ; 
		Pos2[0][0].z = Pos1[0][0].z - Dir1.z - Dir2.z ; 
		
		Pos2[1][0].x = Pos1[1][0].x + Dir1.x - Dir2.x ;  
		Pos2[1][0].y = Pos1[1][0].y + Dir1.y - Dir2.y + Y ;
		Pos2[1][0].z = Pos1[1][0].z + Dir1.z - Dir2.z ; 
		
		Pos2[2][0].x = Pos1[2][0].x + Dir1.x + Dir2.x ;  
		Pos2[2][0].y = Pos1[2][0].y + Dir1.y + Dir2.y + Y ;
		Pos2[2][0].z = Pos1[2][0].z + Dir1.z + Dir2.z ; 
		
		Pos2[3][0].x = Pos1[3][0].x - Dir1.x + Dir2.x ;  
		Pos2[3][0].y = Pos1[3][0].y - Dir1.y + Dir2.y + Y ;
		Pos2[3][0].z = Pos1[3][0].z - Dir1.z + Dir2.z ; 
		
		// 𓾂
		if( VParam[ED_LIGHT][6] < 1 ) VParam[ED_LIGHT][6] = 1 ;
		DivNum = (u32)VParam[ED_LIGHT][6] ;

		for( j = 0 ; j < 4 ; j ++ )
		{
			if( j + 1 == 4 )
			{
				VECSubtract( &Pos1[0][0], &Pos1[j][0], &d1 ) ;
				VECSubtract( &Pos2[0][0], &Pos2[j][0], &d2 ) ;
			}
			else
			{
				VECSubtract( &Pos1[j+1][0], &Pos1[j][0], &d1 ) ;
				VECSubtract( &Pos2[j+1][0], &Pos2[j][0], &d2 ) ;
			}

			for( i = 1 ; i < DivNum ; i ++ )
			{
				Pos1[j][i].x = Pos1[j][0].x + d1.x * ( (f32)i / DivNum ) ;
				Pos1[j][i].y = Pos1[j][0].y + d1.y * ( (f32)i / DivNum ) ;
				Pos1[j][i].z = Pos1[j][0].z + d1.z * ( (f32)i / DivNum ) ;
				
				Pos2[j][i].x = Pos2[j][0].x + d2.x * ( (f32)i / DivNum ) ;
				Pos2[j][i].y = Pos2[j][0].y + d2.y * ( (f32)i / DivNum ) ;
				Pos2[j][i].z = Pos2[j][0].z + d2.z * ( (f32)i / DivNum ) ;
			}
		}
	}

	// |S̕`
	GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)( 8 * DivNum + 2 ) ) ;
	{
		for( i = 0 ; i < DivNum ; i ++ )
		{
			GPV( Pos1[0][i] ) ;	GC1( 255, a1 ) ;	GT( (f32)i / DivNum, 1.0F ) ;
			GPV( Pos2[0][i] ) ;	GC1( 255, a2 ) ;	GT( (f32)i / DivNum, 0.0F ) ;
		}

		for( i = 0 ; i < DivNum ; i ++ )
		{
			GPV( Pos1[1][i] ) ;	GC1( 255, a1 ) ;	GT( 1.0F - ( (f32)i / DivNum ), 1.0F ) ;
			GPV( Pos2[1][i] ) ;	GC1( 255, a2 ) ;	GT( 1.0F - ( (f32)i / DivNum ), 0.0F ) ;
		}

		for( i = 0 ; i < DivNum ; i ++ )
		{
			GPV( Pos1[2][i] ) ;	GC1( 255, a1 ) ;	GT( (f32)i / DivNum, 1.0F ) ;
			GPV( Pos2[2][i] ) ;	GC1( 255, a2 ) ;	GT( (f32)i / DivNum, 0.0F ) ;
		}

		for( i = 0 ; i < DivNum ; i ++ )
		{
			GPV( Pos1[3][i] ) ;	GC1( 255, a1 ) ;	GT( 1.0F - ( (f32)i / DivNum ), 1.0F ) ;
			GPV( Pos2[3][i] ) ;	GC1( 255, a2 ) ;	GT( 1.0F - ( (f32)i / DivNum ), 0.0F ) ;
		}

		GPV( Pos1[0][0] ) ;	GC1( 255, a1 ) ;	GT( 0.0F, 1.0F ) ;
		GPV( Pos2[0][0] ) ;	GC1( 255, a2 ) ;	GT( 0.0F, 0.0F ) ;
	}
	GXEnd() ;

	// I
	return 0 ;
}


// eNX`̏s
extern s8 SetupLightTex( s32 TexNumber )
{
	LIGHTTEX *Tex = &LigUnion.Tex[TexNumber] ;

	if( Tex->Count == 0 )
	{
		char FileName[64] ;
		
		sprintf( FileName, "%s%02d.BIN", LIGHT_FILENAME, TexNumber ) ;
		TexLoadSet( FileName, &Tex->Tex ) ;
	}
	
	Tex->Count ++ ;
	
	// I
	return 0 ;
}
	
// eNX`̏ǂ擾( TRUE: FALSE:܂ )
extern s8 CheckLightTex( s32 TexNumber )
{
	LIGHTTEX *Tex = &LigUnion.Tex[TexNumber] ;

	if( Tex->Count == 0 ) return FALSE ;
	
	return TexLoadChk( &Tex->Tex ) ;
}

// eNX`
extern s8 ReleaseLightTex( s32 TexNumber )
{
	LIGHTTEX *Tex = &LigUnion.Tex[TexNumber] ;

	if( Tex->Count == 0 ) return FALSE ;
	
	Tex->Count -- ;
	if( Tex->Count == 0 )
	{
		TexRelease( &Tex->Tex ) ;
	}
	
	// I
	return 0 ;
}

// eNX`擾
extern GXTexObj *GetLightTex( s32 TexNumber )
{
	LIGHTTEX *Tex = &LigUnion.Tex[TexNumber] ;

	if( Tex->Count == 0 ) return NULL ;
	
	// I
	return &Tex->Tex.Data.Obj ;
}


