//////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLineRoll
//
// YK7EffectLineRoll.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 11/04/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------

#include "./YK7EffectLineRoll.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectScreen.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

static LINEROLLUNION RLUnion ;
extern LINEUNION LUnion ;


// function proto type --------------------------

// function code --------------------------------


// W]GtFNg̋ʃf[^
extern s8 InitLineRollData( void )
{
	MEMINIT(RLUnion) ;

	// I
	return 0 ;
}

// W]GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLineRollData( void )
{
	return TRUE ;
}

// W]GtFNg̋ʃf[^n
extern s8 EndLineRollData( void )
{
	MEMINIT(RLUnion) ;

	// I
	return 0 ;
}




// W]GtFNg쐬
extern EFFECT *CreateLineRollEffect( s32 LineNum, f32 RotSpeed,
									 f32 InSpeed, s32 InTime, s32 OutTime,
									 f32 MaxLength, f32 MinLength,
									 u8 LineWidth,
									 GXColor Color1, GXColor Color2,
									 u8 RandColor, f32 Rate, 
									  s32 Priority )
{
	EFFECT *Effect, *ScreenEffect ;
	LINEROLLEFFECT *LrP ;
	LINEROLLOBJECT *LrObj ;
	u32 i ;
	s32 j ;
	
	// eNX`ǂݍ܂ĂȂ牽I
	if( CheckLineData() == FALSE ) return 0 ;
	
	if( ( ScreenEffect = CreateScreenEffect() ) == NULL ) return NULL ;
	SetScreenEffectAddFlag( ScreenEffect, (s8)VParam[ED_LINEROLL][20] ) ;
	SetScreenEffectAlpha( ScreenEffect, (f32)VParam[ED_LINEROLL][18] / 255.0F ) ;
	SetScreenEffectExRate( ScreenEffect, (f32)VParam[ED_LINEROLL][19] * 0.01F ) ;
	SetScreenEffectDrawFlag( ScreenEffect, TRUE ) ;

	// IuWFNgۑ邽߂̃̈̊m
	if( ( LrObj = ( LINEROLLOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( LINEROLLOBJECT ) * LineNum ), "Y_LrObj" ) ) == NULL )
	{
		DeleteEffect( ScreenEffect ) ;
		return NULL ;
	}

	// VCf[^쐬
	Effect = AddEffectData( EFF_LINEROLL, (void**)&LrP, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( ScreenEffect ) ;
		K7AppSmallMemFree( LrObj ) ;
		return NULL ;
	}

	// p[^ۑE
	LrP->FastDeleteFlag = FALSE ;
	LrP->Mode = 0 ;
	LrP->Counter1 = LrP->Counter2 = 0 ;
	LrP->ObjNum = LineNum ;
	LrP->RotSpeed = RotSpeed ;
	LrP->InSpeed = InSpeed ;
	LrP->InTime = InTime ;
	LrP->OutTime = OutTime ;
	LrP->Alpha = 0.0F ;
	LrP->BaseRot = 0.0F ;
	LrP->Adjust = 0.0F ;
	LrP->Obj = LrObj ;
	LrP->LineWidth = LineWidth ;
	LrP->ScreenEffect = ScreenEffect ;

	// CIuWFNg̒l
	for( i = 0 ; i < LineNum ; i ++, LrObj ++ )
	{
		LrObj->Length = rand() * ( MaxLength - MinLength ) / RAND_MAX + MinLength ;
		LrObj->Rot = rand() * PI_2 / RAND_MAX ;
		
		LrObj->Color = ( (f32)rand() / RAND_MAX < Rate ) ? Color1 : Color2 ;
		LrObj->Color.a = 255 ;

		j = LrObj->Color.r + ( LrObj->Color.r != 0 ? rand() * (s32)RandColor / RAND_MAX - RandColor / 2 : 0 ) ;
		if( j < 0 ) j = 0 ;
		if( j > 255 ) j = 255 ;
		LrObj->Color.r = (u8)j ;

		j = LrObj->Color.g + ( LrObj->Color.g != 0 ? rand() * (s32)RandColor / RAND_MAX - RandColor / 2 : 0 ) ;
		if( j < 0 ) j = 0 ;
		if( j > 255 ) j = 255 ;
		LrObj->Color.g = (u8)j ;

		j = LrObj->Color.b + ( LrObj->Color.b != 0 ? rand() * (s32)RandColor / RAND_MAX - RandColor / 2 : 0 ) ;
		if( j < 0 ) j = 0 ;
		if( j > 255 ) j = 255 ;
		LrObj->Color.b = (u8)j ;
	}
	
	// I
	return Effect ;
}

// W]GtFNǧns
extern s8 ReleaseLineRollEffect( EFFECT *Effect )
{
	LINEROLLEFFECT *LrP = ( LINEROLLEFFECT * )Effect->Data ;

	// CIuWFƊi[pɊmۂĂ̈̊J
	if( LrP->Obj != NULL ) CHKMEMFREE2( LrP->Obj ) ;
	LrP->Obj = NULL ;
	DeleteEffect( LrP->ScreenEffect ) ;

	// I
	return 0 ;
}

// W]GtFNgPt[
extern s8 MoveLineRollEffect( EFFECT *Effect )
{
	LINEROLLEFFECT *Lr = ( LINEROLLEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ璼ɍ폜
	if( Lr->FastDeleteFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	SetScreenEffectAddFlag( Lr->ScreenEffect, (s8)VParam[ED_LINEROLL][20] ) ;
	SetScreenEffectAlpha( Lr->ScreenEffect, (f32)VParam[ED_LINEROLL][18] / 255.0F ) ;
	SetScreenEffectExRate( Lr->ScreenEffect, (f32)VParam[ED_LINEROLL][19] * 0.01F ) ;
	
	// [hɂď𕪊
	switch( Lr->Mode )
	{
	case 0 :		// 
		{
			// At@lő
			Lr->Alpha = 1.0F ;

			// JE^i߂
			Lr->Counter1 ++ ;
			
			// ␳lɔf
			Lr->Adjust = 1.0F - GetSanjiFunction( -Lr->InSpeed, 1.0F, Lr->InTime, Lr->Counter1 ) ;
			
			// ԂĂ玟̓
			if( Lr->Counter1 == Lr->InTime )
			{
				Lr->Mode ++ ;
				Lr->Counter1 = 0 ;
			}
		}
		break ;
		
	case 1 :		// 蓮쒆
		{
			// {]WZ
			Lr->BaseRot += Lr->RotSpeed ;
		}
		break ;
		
	case 2 :		// ޏo
		{
			// JE^i߂
			Lr->Counter1 ++ ;
			
			// At@lZo
			Lr->Alpha = 1.0F - (f32)Lr->Counter1 / Lr->OutTime ;
			
			// At@lOɂȂGtFNg폜
			if( Lr->OutTime == Lr->Counter1 )
			{
				DeleteEffect( Effect ) ;
				return 0 ;
			}
		}
		break ;
	}

	// I
	return 0 ;
}


// W]GtFNg`悷
extern s8 DrawLineRollEffect( EFFECT *Effect )
{
	LINEROLLEFFECT *Lr = ( LINEROLLEFFECT * )Effect->Data ;
	LINEROLLOBJECT *Obj ;
	u32 i, Num ;
	u8 Alpha ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// C̑Zbg
	{
		GXSetLineWidth( (u8)Lr->LineWidth, GX_TO_ONE ) ;
		GXEnableTexOffsets( GX_TEXCOORD0, GX_ENABLE, GX_ENABLE ) ;
	}

	// `At@ľvZ
	Alpha = (u8)( Lr->Alpha * 255 ) ;
	
	// C̕`
	{
		// eNX`̃[h
		GTLOAD2( LUnion.TestTex ) ;

		GBGN( GX_LINES, Lr->ObjNum * 2 ) ;
		{
			f32 Sin, Cos, f ;
		
			// `
			Obj = Lr->Obj ;
			Num = (u32)Lr->ObjNum ;
			for( i = 0 ; i < Num ; i ++, Obj ++ )
			{
				Sin = sinf( Obj->Rot + Lr->BaseRot ) ;
				Cos = cosf( Obj->Rot + Lr->BaseRot ) ;

				f = VParam[ED_LINEROLL][1] - Obj->Length * Lr->Adjust ;
				GP2( SCW / 2 - ( Cos * f ),  SCH / 2 - ( Sin * f * 0.75F ) ) ;
				GC2( Obj->Color, Alpha ) ;	GT( 0, 0 ) ;
				
				f = VParam[ED_LINEROLL][1] ;
				GP2( SCW / 2 - ( Cos * f ),  SCH / 2 - ( Sin * f * 0.75F ) ) ;
				GC2( Obj->Color, Alpha ) ;	GT( 0, 1.0F ) ;
			}
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}


// 폜NGXgs
extern s8 DelReqLineRollEffect( EFFECT *Effect )
{
	LINEROLLEFFECT *Lr = ( LINEROLLEFFECT * )Effect->Data ;
	
//	DelReqEffect( Effect ) ;
	Lr->Mode = 2 ;
	Lr->Counter2 = Lr->Counter1 = 0 ;
	
	// I
	return 0 ;
}

// 폜NGXgs
extern s8 FastDelReqLineRollEffect( EFFECT *Effect )
{
	LINEROLLEFFECT *Lr = ( LINEROLLEFFECT * )Effect->Data ;

	Lr->FastDeleteFlag = TRUE ;
	
	// I
	return 0 ;
}

