///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectLockOn
//
// YK7EffectLockOn.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/03/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectLockOn.h"
#include "./YK7EffectShutter.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

LOCKONUNION LocOUnion ;

// function proto type --------------------------

static s8 DrawLockOnSquare( f32 t, f32 a, Vec *Target, GXColor Color ) ;		// bNIGtFNg`悷

// function code --------------------------------

// bNIGtFNg`悷
static s8 DrawLockOnSquare( f32 t, f32 a, Vec *Target, GXColor Color )
{
	f32 f, w, h, Sin, Cos, Angle ;
	Vec TP, TPos[4] ;
	u8 al = (u8)( a * 255 ) ;

	// S_̍WZo
	{
		// ^[Qbg̍W擾
		GetScreenPosition( Target, &TP ) ;

		// \TCY̎擾
		f = GetScreenSize( Target, (f32)VParam[ED_LOCKON][3] * 1.0F ) ;
		w = ( ( SCW - f ) * ( 1.0F - t ) + f ) / 2.0F ;
		h = ( ( SCH - f ) * ( 1.0F - t ) + f ) / 2.0F ;

		// ]
		Angle = fmod( t * VParam[ED_LOCKON][4] * ( PI / 2.0F ), PI_2 ) ;
		Sin = sinf( Angle ) ;		Cos = cosf( Angle ) ;

		TPos[0].x = Cos * (-w) - Sin * (-h) ;	TPos[0].y = Sin * (-w) + Cos * (-h) ;
		TPos[1].x = Cos * (w) - Sin * (-h) ;	TPos[1].y = Sin * (w) + Cos * (-h) ;
		TPos[2].x = -TPos[0].x ;				TPos[2].y = -TPos[0].y ;
		TPos[3].x = -TPos[1].x ;				TPos[3].y = -TPos[1].y ;
	}
		
	// `
	{
		GP2( TPos[0].x + TP.x, TPos[0].y + TP.y ) ;	GC2( Color, al ) ;
		GP2( TPos[1].x + TP.x, TPos[1].y + TP.y ) ;	GC2( Color, al ) ;

		GP2( TPos[1].x + TP.x, TPos[1].y + TP.y ) ;	GC2( Color, al ) ;
		GP2( TPos[2].x + TP.x, TPos[2].y + TP.y ) ;	GC2( Color, al ) ;

		GP2( TPos[2].x + TP.x, TPos[2].y + TP.y ) ;	GC2( Color, al ) ;
		GP2( TPos[3].x + TP.x, TPos[3].y + TP.y ) ;	GC2( Color, al ) ;

		GP2( TPos[3].x + TP.x, TPos[3].y + TP.y ) ;	GC2( Color, al ) ;
		GP2( TPos[0].x + TP.x, TPos[0].y + TP.y ) ;	GC2( Color, al ) ;
	}
	
	// I
	return 0 ;
}


// bNIGtFNg̋ʃf[^
extern s8 InitLockOnData( void )
{
	MEMINIT( LocOUnion ) ;

	// I
	return 0 ;
}

// bNIGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckLockOnData( void )
{
	return TRUE ;
}

// bNIGtFNg̋ʃf[^n
extern s8 EndLockOnData( void )
{
	MEMINIT( LocOUnion ) ;

	// I
	return 0 ;
}


// bNĨGtFNg쐬
extern EFFECT *CreateLockOnEffect( Vec *TargetPos, GXColor *Color, s32 Priority )
{
	LOCKONEFFECT *LockOn ;
	EFFECT *Effect ;

	// VbNIf[^쐬
	Effect = AddEffectData( EFF_LOCKON, (void**)&LockOn, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// bNIf[^
	LockOn->TargetPos = *TargetPos ;
	LockOn->bt = LockOn->t = 0.0F ;
	LockOn->alpha = (f32)VParam[ED_LOCKON][11] / 255.0F ;
	if( Color != NULL )
	{
		LockOn->Color = *Color ;
	}
	else
	{
		LockOn->Color.r = (u8)VParam[ED_LOCKON][7] ;
		LockOn->Color.g = (u8)VParam[ED_LOCKON][8] ;
		LockOn->Color.b = (u8)VParam[ED_LOCKON][9] ;
	}
	LockOn->DrawFlag = TRUE ;

	// I
	return Effect ;
}

// bNĨGtFNǧns
extern s8 ReleaseLockOnEffect( EFFECT *Effect )
{
	LOCKONEFFECT *LockOn = ( LOCKONEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// bNĨGtFNgPt[
extern s8 MoveLockOnEffect( EFFECT *Effect )
{
	LOCKONEFFECT *L = ( LOCKONEFFECT * )Effect->Data ;

	if( (LOCKONEFFECT *)NULL == L ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	L->bt = L->t ;	
	if( Effect->DelReqFlag == FALSE )
	{
		L->t += 1.0F / VParam[ED_LOCKON][0] ;
		if( L->t > 1.0F ) L->t = 1.0F ;
		L->alpha = (f32)VParam[ED_LOCKON][11] / 255.0F ;
	}
	else
	{
		L->t -= 1.0F / VParam[ED_LOCKON][10] ;
		L->alpha = L->t * ( (f32)VParam[ED_LOCKON][11] / 255.0F ) ;
		if( L->t < 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}

	// I
	return 0 ;
}


// bNĨGtFNg`悷
extern s8 DrawLockOnEffect( EFFECT *Effect )
{
	LOCKONEFFECT *L = ( LOCKONEFFECT * )Effect->Data ;

	if( (LOCKONEFFECT *)NULL == L ) return 0 ;
	if( L->DrawFlag == FALSE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;

	// ̑Zbg
	GXSetLineWidth( (u8)VParam[ED_LOCKON][1], GX_TO_ONE ) ;

	// `Jn
	if( L->t != L->bt )
	{
		s32 i ;
	
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( VParam[ED_LOCKON][6] * 8 ) ) ;
		
		for( i = 0 ; i < VParam[ED_LOCKON][6] ; i ++ )
		{
			DrawLockOnSquare( L->bt + ( L->t - L->bt ) * ( (f32)i / VParam[ED_LOCKON][6] ),
								(f32)VParam[ED_LOCKON][11] / 255.0F / VParam[ED_LOCKON][6] * L->alpha * ( VParam[ED_LOCKON][12] * 0.01F ), &L->TargetPos, L->Color ) ;
		}
		
		GXEnd() ;
	}
	else
	{
		GXBegin( GX_LINES, GX_VTXFMT0, (u16)8 ) ;
	
		DrawLockOnSquare( L->t, (f32)VParam[ED_LOCKON][11] / 255.0F * L->alpha, &L->TargetPos, L->Color ) ;
		
		GXEnd() ;
	}
		
	// I
	return 0 ;
}

// bNI̕\WύX
extern s8 ChangeLockOnPoint( Vec *TargetPos, EFFECT *Effect )
{
	LOCKONEFFECT *LockOn = ( LOCKONEFFECT * )Effect->Data ;
	
	LockOn->TargetPos = *TargetPos ;
	
	// I
	return 0 ;
}
	

// bNIGtFNg`悷邩ǂ̃tOZbg
extern s8 SetLockOnDrawFlag( u8 DrawFlag, EFFECT *Effect )
{
	LOCKONEFFECT *LockOn = ( LOCKONEFFECT * )Effect->Data ;
	
	LockOn->DrawFlag = (s8)DrawFlag ;
	
	// I
	return 0 ;
}
	

