///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMesh
//
// YK7EffectMesh.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/30/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMesh.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define TEST_TEXTURE "/yam/wall4.BIN"		// eXgpeNX`

// datatype -------------------------------------

typedef struct tagMESHEFFECTRENDERINFO
{
	u32 color ;
	bool LightFlag ;
} MESHEFFECTRENDERINFO ; 

// data -----------------------------------------

MESHUNION MesUnion ;

// function proto type --------------------------

s8 __RenderMeshCallBack( BASICMESH *BasMesh, void *Data ) ;		// ȈՃbV`悷R[obN֐


// function code --------------------------------

// ȈՃbV`悷R[obN֐
s8 __RenderMeshCallBack( BASICMESH *BasMesh, void *Data )
{
	bool LightFlag = (( MESHEFFECTRENDERINFO * )Data)->LightFlag ;
	u32 color = (( MESHEFFECTRENDERINFO * )Data)->color ;

	// `Jn
	{
		BASICMESH *bmesh ;

		bmesh = BasMesh ;
		while( bmesh != NULL )
		{
			DCStoreRange( bmesh->VertexData, (u32)( bmesh->Stride * bmesh->VertexNum ) ) ;
			GXSetArray( GX_VA_POS, bmesh->Point, (u8)bmesh->Stride ) ;

			GBGN( bmesh->PrimitiveType, bmesh->IndexNum ) ;
			{
				u32 Num ;
				u16 *Index ;

				Index = bmesh->Index ;
				for( Num = (u32)bmesh->IndexNum ; Num ; Num --, Index ++ )
				{
					GXPosition1x16( *Index ) ;
					if( LightFlag )
						GXNormal3f32( 1.0F, 0.0F, 0.0F ) ;
					else
						GCX( color ) ;
					GT( 0.0F, 0.0F ) ;
				}
			}
			GEND() ;

			bmesh = bmesh->Next ;
		}
	}
	
	return 0 ;
}


// bVGtFNg̋ʃf[^
extern s8 InitMeshData( void )
{
	MEMINIT(MesUnion) ;
	
//	TexLoadSet( TEST_TEXTURE, &MesUnion.TestTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_wall4 ), &MesUnion.TestTex ) ;

	// I
	return 0 ;
}

// bVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMeshData( void )
{
//	if( TexLoadChk( &MesUnion.TestTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// bVGtFNg̋ʃf[^n
extern s8 EndMeshData( void )
{
	TexRelease( &MesUnion.TestTex ) ;
	
	// I
	return 0 ;
}




// bVGtFNg쐬
extern EFFECT *CreateMeshEffect(
 							BASICMODEL *BasModel,		// \郁bV
							Vec Point,					// \W
							u8 ReleaseFlag,				// GtFNg鎞Ƀff[^폜邩ǂ̃tO
						 	u32 Color,					// F	
						 	bool AddFlag,				// ZuhtO
							s32 Priority )
{
	EFFECT *Effect ;
	MESHEFFECT *MeshP ;
	
	// eXgeNX`ǂݍ܂ĂȂ牽I
	if( CheckMeshData() == FALSE ) return 0 ;
	
	// t@C
//	CLOSECHK( MesUnion.TexFile ) ;

	// VbVf[^쐬
	Effect = AddEffectData( EFF_MESH, (void**)&MeshP, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// bVf[^
//	MeshP->Mesh = Mesh ;
	MeshP->ReleaseFlag = ReleaseFlag ;
	MeshP->BasModel = BasModel ;
	MeshP->Point = Point ;
	MeshP->Counter = 0 ;
	MeshP->Alpha = 255 ;
	MeshP->LightFlag = TRUE ;
	MeshP->Color = Color ;
	MeshP->AddFlag = AddFlag ;

//	// x[VbNbV쐬
//	CreateBasicPrimitiveMeshData( MeshP->Mesh, &MeshP->BasMesh, TRUE, FALSE, TRUE, FALSE ) ;

//	MeshP->BasMesh = NULL ;

	// I
	return Effect ;

//	return NULL ;
}

// bVGtFNǧns
extern s8 ReleaseMeshEffect( EFFECT *Effect )
{
	MESHEFFECT *ms = ( MESHEFFECT * )Effect->Data ;

	// bVf[^̌ns
//	ReleasePrimitiveMeshData( ms->Mesh ) ;

	// x[VbNbVf[^̌ns
/*	if( ms->BasMesh != NULL )
	{
		DeleteBasicMeshData( ms->BasMesh ) ;
		ms->BasMesh = NULL ;
	}
*/
	// x[VbNof[^̌ns
	if( ms->BasModel != NULL && ms->ReleaseFlag == TRUE )
	{
		DeleteBasicModelData( ms->BasModel ) ;
		ms->BasModel = NULL ;
	}

	// I
	return 0 ;
}

// bVGtFNgPt[
extern s8 MoveMeshEffect( EFFECT *Effect )
{
	MESHEFFECT *ms = ( MESHEFFECT * )Effect->Data ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		ms->DeleteCounter ++ ;
		if( ms->DeleteCounter >= 2 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}

	// ɂ邱ƂȂ	
	ms->Counter ++ ;

	// I
	return 0 ;
}

// bVGtFNg`悷
extern s8 DrawMeshEffect( EFFECT *Effect )
{
#if 1
	MESHEFFECT *ms = ( MESHEFFECT * )Effect->Data ;
	Mtx View ;
	GXLightObj Light ;
	u32 color ;
	MESHEFFECTRENDERINFO rinfo ;
	
	if( Effect->DelReqFlag == TRUE ) return 0 ;
	
	EffectRenderSetup( EF_PROJECT_PERS, ms->AddFlag == true ? EF_BLEND_ADD : EF_BLEND_ALPHA, EF_TEV_USETEX ) ;		// `̏

	// r[}gbNX擾
	EffectGetViewMatrix( View ) ;

	// s̃Zbg
	{
		Mtx Matrix ;

		// gXtH[̍sƊ|킹ăZbg
		MTXTrans( Matrix, ms->Point.x, ms->Point.y, ms->Point.z ) ; 
		MTXConcat( View, Matrix, View ) ;

		GXLoadPosMtxImm( View, 0 ) ;
		GXLoadNrmMtxImm( View, 0 ) ;
		GXSetCurrentMtx( 0 ) ;
	}

	// CgIuWFNg̃Zbg
	if( ms->LightFlag == TRUE )
	{
		GXInitLightColor( &Light, (GXColor){255, 255, 255, 255} ) ;
		GXInitLightPos( &Light, sin( PI / 20 * ms->Counter ) * 100000.0F,
								cos( PI / 20 * ms->Counter ) * 100000.0F, 100000.0F ) ;
		GXInitLightDir( &Light, (f32) -sin( PI / 20 * ms->Counter ),
								(f32) -cos( PI / 20 * ms->Counter ), -1.0F ) ;
		GXInitLightSpot( &Light, 0.0F, GX_SP_OFF ) ;
		GXInitLightDistAttn( &Light, 0.0F, 0.0F, GX_DA_OFF ) ;
		GXLoadLightObjImm( &Light, GX_LIGHT1 ) ;

		// J[̐ݒ
	    GXSetNumChans(1);
	    GXSetAlphaCompare( GX_GREATER, 20, GX_AOP_AND, GX_ALWAYS, 0);
	    GXSetChanAmbColor( GX_COLOR0A0, *((GXColor *)&ms->Color) ) ; // (GXColor){200, 0, 0, 255} ) ;
	    GXSetChanMatColor( GX_COLOR0A0, *((GXColor *)&ms->Color) ) ; // (GXColor){200, 0, 0, 255} ) ;
	    GXSetChanCtrl( GX_COLOR0A0, GX_ENABLE, GX_SRC_REG, GX_SRC_REG,
	  				GX_LIGHT1, GX_DF_CLAMP, GX_AF_SPOT ) ;

		// _tH[}bg̃Zbg
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_NRM, GX_NRM_XYZ, GX_F32, 0 ) ;
	}
	else
	{
		color = CMK( 200, 0, 0, ms->Alpha ) ;
	}

	// GXFIFOɓnf[^̃Zbg	
    GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS, GX_INDEX16) ;
	if( ms->LightFlag == TRUE )
		GXSetVtxDesc(GX_VA_NRM, GX_DIRECT) ;
	else
		GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT) ;
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT) ;

	// eNX`̃[h
	GTLOAD2( MesUnion.TestTex ) ;
	
	// `揈Jn
	{
		rinfo.LightFlag = ms->LightFlag ;
		rinfo.color = color ;
		ScanBasicModelMesh( ms->BasModel, __RenderMeshCallBack, &rinfo ) ;
	}

#endif

	// I
	return 0 ;
}					

// `掞̃At@lݒ肷
extern s8 SetMeshEffectAlpha( EFFECT *Effect, u8 Alpha )
{
	MESHEFFECT *ms = ( MESHEFFECT * )Effect->Data ;
	
	ms->Alpha = Alpha ;
	
	return 0 ;
}

// Cg̗Lݒ肷
extern s8 SetMeshEffectLightValidFlag( EFFECT *Effect, u8 Flag )
{
	MESHEFFECT *ms = ( MESHEFFECT * )Effect->Data ;
	
	ms->LightFlag = Flag ;
	
	return 0 ;
}




	



