///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMessage2
//
// YK7EffectMessage2.cpp
//
// Creator	   : Takumi Yamada (GHM)
// Creation Date : 12/09/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMessage2.h"
#include "./YK7EffectMessage.h"
#include "./YK7EffectCursor.h"
#include "./YK7EffectStaticData.h"
#include "../matsu/mK7Jimaku.h"
#include "../matsu/mk7Sound.h"
#include "../Wat/WK7SelectIF.h"

// define ---------------------------------------

#define ICONCHK(x)			( (x)->IconID != -1 ? (x)->IconID == (s32)MES_NOICON : GetNoneIconCheck( (s8)(x)->PackID, (s8)(x)->MessageID ) )
#define ICONTEXSIZE			64
#define BUTTONTEX			"/Yam/Message/but.BIN"

#define ADDY				(PR1[25])

#define PR1					(s32)VParam[ED_MES_V2]
#define PR2					(s32)VParam[ED_MES_V2_2]

#define AMICOLOR			(CMK(PR2[16],PR2[17],PR2[18],PR2[19]))
#define AMITOPCOLOR			(CMK(PR2[8],PR2[9],PR2[10],PR2[11]))
#define AMIBOTCOLOR			(CMK(PR2[12],PR2[13],PR2[14],PR2[15]))

// datatype -------------------------------------

// data -----------------------------------------

MESSAGE2UNION Ms2Union ;

// function proto type --------------------------

static s8 GetMessage2Post( void ) ;							// bZ[WQ|Xg𓾂
static s8 ReleaseMessage2Post( s8 PostID ) ;				// bZ[WQ|XgJ
static s8 SetStrDrawFlag( EFFECT *Effect, s8 Flag ) ;

static void ObjectInit( MESSAGE2OBJECT *Obj, f32 x, f32 y, f32 w, f32 h, u16 CharID = 0 ) ;
static void ObjectSpeedSet( MESSAGE2OBJECTANIM *Dat ) ;
static void ObjectStart( MESSAGE2OBJECTANIM *Dat, s8 WaitTime ) ;
static void ObjectStart( MESSAGE2OBJECT *Obj, s8 WaitTime ) ;
static void ObjectEnd( MESSAGE2OBJECT *Obj, s8 WaitTime ) ;
static void ObjectMove( MESSAGE2OBJECT *Obj ) ;
static void ObjectDraw( MESSAGE2OBJECT *Obj, f32 u, f32 v, f32 uw, f32 vh, GXColor *Color, u8 RedColorFlag ) ;

// function code --------------------------------

static void ObjectDraw( MESSAGE2OBJECT *Obj, f32 u, f32 v, f32 uw, f32 vh, GXColor *Color, u8 RedColorFlag )
{
	f32 x, y, w, h ;
	s32 i ;
	u32 cr ;
	MESSAGE2OBJECTANIM *d ;

	d = Obj->d ;
	for( i = 0 ; i < 2 ; i ++, d ++ )
	{
		if( Obj->CharID & 0x8000 && RedColorFlag == FALSE )
		{
			switch( Obj->CharID )
			{
			case CHARID_ITEM :
				cr = CMK( PR2[3], PR2[4], PR2[5],
							i == 0 ? 0 : Color->a * d->Alpha ) ;
				break ;
			}
		}
		else
		{
			if( i == 0 )
			{
				cr = CMK( 0, 0, 0, Color->a * d->Alpha ) ;
			}
			else
			{
				cr = CMK( Color->r * d->Alpha,
							Color->g * d->Alpha,
							Color->b * d->Alpha,
							Color->a * d->Alpha ) ;
			}
		}
		x = d->x + Obj->w / 2.0F ;
		y = d->y + Obj->h / 2.0F ;
		if( i == 0 )
		{
			x += PR1[16] ;
			y += PR1[17] ;
		}
		w = Obj->w / 2.0F ;
		h = Obj->h / 2.0F * d->ExRate ;

		DrawTex4NB( x - w, y - h,
					x + w, y + h,
					u,		v,
					u + uw,	v + vh, cr ) ;
	}
}
	

static void ObjectMove( MESSAGE2OBJECT *Obj )
{
	s32 i ;
	MESSAGE2OBJECTANIM *d ;

	d = Obj->d ;
	for( i = 0 ; i < 2 ; i ++, d ++ )
	{
		if( d->MoveCounter == 0 )
		{
			ObjectSpeedSet( d ) ;
			d->MoveCounter = (s8)PR1[8] ;
		}
		else d->MoveCounter -- ;

		// ړ
		{
			if( d->x <= Obj->BaseX - PR1[6] ) d->x = Obj->BaseX - PR1[6] ;
			if( d->x >= Obj->BaseX + PR1[6] ) d->x = Obj->BaseX + PR1[6] ;
			if( d->y <= Obj->BaseY - PR1[6] ) d->y = Obj->BaseY - PR1[6] ;
			if( d->y >= Obj->BaseY + PR1[6] ) d->y = Obj->BaseY + PR1[6] ;

			d->x += d->sx ;
			d->y += d->sy ;
		}
		
		switch( d->Mode )
		{
		case 0 :
			if( d->WaitCounter == -1 )
			{
				d->ExRate = 0.0F ;
			}
			else
			{
				if( d->WaitCounter != 0 )
				{
					d->WaitCounter -- ;
					if( d->WaitCounter == 0 )
					{
						d->ExRate = PR1[10] * 0.01F ;
					}
				}
				else
				{
					if( d->ExRate > 1.0F )
					{
						d->ExRate -= PR1[11] * 0.01F ;
						if( d->ExRate < 1.0F ) d->ExRate = 1.0F ;
					}
				}
				d->Alpha = ( ( PR1[10] * 0.01F ) - d->ExRate ) / ( ( PR1[10] * 0.01F ) - 1.0F ) ;
			}
			break ;
			
		case 1 :
			{
				if( d->WaitCounter != 0 )
				{
					d->WaitCounter -- ;
				}
				else
				{
					if( d->ExRate > 0.0F )
					{
						d->ExRate -= PR1[11] * 0.01F ;
						if( d->ExRate < 0.0F ) d->ExRate = 0.0F ;
					}
				}
				d->Alpha = d->ExRate ;
				if( d->Alpha > 1.0F ) d->Alpha = 1.0F ;
			}
			break ;
		}
	}
}

static void ObjectEnd( MESSAGE2OBJECT *Obj, s8 WaitTime )
{
	Obj->d[1].Mode = Obj->d[0].Mode = 1 ;
	Obj->d[1].WaitCounter = Obj->d[0].WaitCounter = WaitTime ;
}

static void ObjectStart( MESSAGE2OBJECTANIM *Dat, s8 WaitTime )
{
	Dat->Mode = 0 ;
	Dat->WaitCounter = WaitTime ;
}

static void ObjectStart( MESSAGE2OBJECT *Obj, s8 WaitTime )
{
	ObjectStart( &Obj->d[0], WaitTime ) ;
	ObjectStart( &Obj->d[1], WaitTime ) ;
}

static void ObjectSpeedSet( MESSAGE2OBJECTANIM *Dat )
{
	f32 Angle ;

	Angle = rand() * PI_2 / RAND_MAX ;
	Dat->sx = cosf( Angle ) * PR1[7] * 0.01F ;
	Dat->sy = sinf( Angle ) * PR1[7] * 0.01F ;
}

static void ObjectInit( MESSAGE2OBJECT *Obj, f32 x, f32 y, f32 w, f32 h, u16 CharID )
{
	s32 i ;
	MESSAGE2OBJECTANIM *d ;

	Obj->BaseX = x ;
	Obj->BaseY = y ;
	Obj->w = w ;
	Obj->h = h ;
	Obj->CharID = CharID ;

	d = Obj->d ;
	for( i = 0 ; i < 2 ; i ++, d ++ )
	{
		d->x = x ;
		d->y = y ;
		d->sx = d->sy = 0.0F ;
		d->ExRate = 0.0F ;
		d->WaitCounter = -1 ;
		d->Mode = 0 ;
		d->MoveCounter = 0 ;
	}
}


static s8 SetStrDrawFlag( EFFECT *Effect, s8 Flag )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	s32 i, j, k, l, m ;
	s8 Mode ;
	MESSAGE2OBJECT *Obj ;
	MESSAGE2LINE *Line ;
	MESSAGE2OBJECTANIM *d ;

	Mes->StrDrawFlag = Flag ;
	
	Mode = (s8)( Flag == TRUE ? 0 : 1 ) ;
	
	Line = Mes->StrData ;
	for( l = 0 ; l < Mes->StrDataNum ; l ++, Line ++ )
	{
		Obj = Line->StrInfo ;
		for( i = 0 ; i < Line->StrLen ; i ++, Obj ++ )
		{
			Obj->d[1].Mode = Obj->d[0].Mode = Mode ;
			Obj->d[1].WaitCounter = Obj->d[0].WaitCounter = -1 ;
		}
		
		Obj = Line->RubiInfo ;
		for( i = 0 ; i < Line->RubiNum ; i ++, Obj ++ )
		{
			Obj->d[1].Mode = Obj->d[0].Mode = Mode ;
			Obj->d[1].WaitCounter = Obj->d[0].WaitCounter = -1 ;
		}
	}

	if( Mes->StrDrawFlag == FALSE )
	{
		Line = Mes->StrData ;
		for( l = 0 ; l < Mes->StrDataNum ; l ++, Line ++ )
		{
			for( i = 0 ; i < Line->StrLen * 2 ; i ++ )
			{
				Obj = Line->StrInfo ;
				k = rand() * ( ( Line->StrLen * 2 ) - i ) / ( RAND_MAX + 1 ) + 1 ;
				for( j = 0 ; j < k ; Obj ++ )
				{
					d = Obj->d ;
					for( m = 0 ; m < 2 ; m ++, d ++ )
					{
						if( d->WaitCounter == -1 )
						{
							j ++ ;
							if( j == k )
							{
								d->WaitCounter = (s8)( i * PR1[15] ) ;
								break ;
							}
						}
					}
				}
			}
			
			for( i = 0 ; i < Line->RubiNum * 2 ; i ++ )
			{
				Obj = Line->RubiInfo ;
				k = rand() * ( ( Line->RubiNum * 2 ) - i ) / ( RAND_MAX + 1 ) + 1 ;
				for( j = 0 ; j < k ; Obj ++ )
				{
					d = Obj->d ;
					for( m = 0 ; m < 2 ; m ++, d ++ )
					{
						if( d->WaitCounter == -1 )
						{
							j ++ ;
							if( j == k )
							{
								d->WaitCounter = (s8)( i * PR1[15] ) ;
								break ;
							}
						}
					}
				}
			}			
		}
	}
	else
	{
		Line = Mes->StrData ;
		for( l = 0 ; l < Mes->StrDataNum ; l ++, Line ++ )
		{
			for( i = 0 ; i < Line->StrLen * 2 ; i ++ )
			{
				Obj = Line->StrInfo ;
				k = rand() * ( ( Line->StrLen * 2 ) - i ) / ( RAND_MAX + 1 ) + 1 ;
				for( j = 0 ; j < k ; Obj ++ )
				{
					d = Obj->d ;
					for( m = 0 ; m < 2 ; m ++, d ++ )
					{
						if( d->WaitCounter == -1 )
						{
							j ++ ;
							if( j == k )
							{
								d->WaitCounter = (s8)( i * PR1[15] ) ;
								d->ExRate = PR1[10] * 0.01F ;
								break ;
							}
						}
					}
				}
			}
			
			
			for( i = 0 ; i < Line->RubiNum * 2 ; i ++ )
			{
				Obj = Line->RubiInfo ;
				k = rand() * ( ( Line->RubiNum * 2 ) - i ) / ( RAND_MAX + 1 ) + 1 ;
				for( j = 0 ; j < k ; Obj ++ )
				{
					d = Obj->d ;
					for( m = 0 ; m < 2 ; m ++, d ++ )
					{
						if( d->WaitCounter == -1 )
						{
							j ++ ;
							if( j == k )
							{
								d->WaitCounter = (s8)( i * PR1[15] ) ;
								d->ExRate = PR1[10] * 0.01F ;
								break ;
							}
						}
					}
				}
			}
		}
	}

	// I
	return 0 ;
}	
					
					
					
	

// bZ[WQ|Xg𓾂
static s8 GetMessage2Post( void )
{
	u8 i ;

	// ɂׂẴbZ[WQ|XggĂG[
	if( Ms2Union.ObjectNum == MAX_MESSAGE2NUM )
		return -1 ;

	// gĂȂ|XgT
	for( i = 0 ; Ms2Union.Object[i] != FALSE ; i ++ ){}
	
	// |XgɃZbg
	Ms2Union.Object[i] = TRUE ;
	
	// LĂ|Xg̐𑝂₷
	Ms2Union.ObjectNum ++ ;
	
	// |XghcԂ
	return (s8)i ;
}

// bZ[WQ|XgJ
static s8 ReleaseMessage2Post( s8 PostID )
{
	// ɖɂȂĂ牽I
	if( Ms2Union.Object[PostID] == FALSE ) return -1 ;
	
	// |XgJ
	Ms2Union.Object[PostID] = FALSE ;
	
	// LĂ|Xg̐炷
	Ms2Union.ObjectNum -- ;
	
	// I
	return 0 ;
}


// bZ[WQGtFNg̋ʃf[^
extern s8 InitMessage2Data( void )
{
	MEMINIT( Ms2Union ) ;
	
	// {^eNX`̓ǂݍ݂Jn
//	TexLoadSet( BUTTONTEX, &Ms2Union.ButTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_but ), &Ms2Union.ButTex ) ;
	
	// I
	return 0 ;
}

// bZ[WQGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMessage2Data( void )
{
//	if( TexLoadChk( &Ms2Union.ButTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// bZ[WQGtFNg̋ʃf[^n
extern s8 EndMessage2Data( void )
{
	// {^eNX`̌n
	TexRelease( &Ms2Union.ButTex ) ;

	MEMINIT( Ms2Union ) ;
	
	// I
	return 0 ;
}

// bZ[WQGtFNg쐬
extern EFFECT *CreateMessage2Effect( s8 PackID, u16 MessageID, s8 ButtonCancelFlag,
									s32 IconID, s32 SoundID,
									s16 x, s16 y,
									GXColor *Color, s8 ColorTableIndex,
									s8 IconNotDrawFlag, s8 CenterXFlag, s8 CenterYFlag,
									s32 Priority )
{
	MESSAGE2EFFECT *Mes ;
	EFFECT *Effect, *Cursor ;
	s8 PostID ;
	GXColor Col ;
	
	ColorTableIndex = ColorTableIndex ;
	if( Color != NULL )
	{
		Col = *Color ;
	}
	else
	{
		Col.r = 255 ;
		Col.g = 255 ;
		Col.b = 255 ;
		Col.a = 255 ;
	}
	

	// \ Y WZo
	if( y == -1 )
	{
		PostID = (s8)( Ms2Union.RunMes == NULL ? 1 : 0 ) ;
		// |Xghc𓾂
//		PostID = GetMessage2Post() ;
//		if( PostID == -1 ) PostID = -10 ;
//		if( PostID == -1 ) return NULL ;
//		y = (s16)( PR1[2] - PR1[1] * PostID ) ;
	}
	else
	{
		PostID = -1 ;
	}
	
	// J[\GtFNg쐬
	Cursor = CreateCursorEffect( Col, FALSE, Priority - 1 ) ;
	if( Cursor == NULL )
	{
/*		if( PostID != -1 )
		{
			ReleaseMessage2Post( PostID ) ;
		}
*/
		return NULL ;
	}
	SetCursorShadowFlag( Cursor, TRUE ) ;
	SetCursorAmiColor( Cursor, AMICOLOR, AMITOPCOLOR, AMIBOTCOLOR ) ;

	// VbZ[WQf[^쐬
	Effect = AddEffectData( EFF_MESSAGE2, (void**)&Mes, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Cursor ) ;
//		if( PostID != -1 ) ReleaseMessage2Post( PostID ) ;
		return NULL ;
	}

	// ۑ
	Mes->Color = Col ;
	Mes->IconID = IconID ;
	Mes->SoundID = SoundID ;
	Mes->PackID = PackID ;
	Mes->PostID = PostID ;
	Mes->MessageID = MessageID ;
	Mes->StrDrawFlag = FALSE ;
	Mes->ButtonCancelFlag = ButtonCancelFlag ;
	Mes->IconCounter2 = Mes->IconCounter1 = 0 ;
	Mes->IconMode = 0 ;
	Mes->IconCursor = NULL ;
	Mes->IconNotDrawFlag = IconNotDrawFlag ;

	Mes->Mode = 0 ;
	Mes->Counter2 = Mes->Counter1 = 0 ;

	if( PostID != -1 )
	{
		if( PostID == 0 )
		{
			Mes->MatiMes = Ms2Union.RunMes ;
			Mes->MatiMesID = GetEffectID( Mes->MatiMes ) ;
		}

		Ms2Union.RunMes = Effect ;
	}

	// J[\GtFNgۑ
	Mes->Cursor = Cursor ;
	
	// 
	{
		s32 y, MesID, LineNo, hr, ContFlag ;
		MESSAGE2LINE *Line ;

		MesID = MessageID ;
		Mes->StrDataNum = 0 ;
		Mes->MaxWidth = 0 ;
		Mes->MaxStrLen = 0 ;
		Line = Mes->StrData ;
		y = (s32)( PR1[3] / 2.0F )  ;
		do
		{
			LineNo = 0 ;
			ContFlag = FALSE ;
			do
			{
				// 
				hr = GetMessageStringUvInfo( PackID, (s8)MesID, (s8)LineNo, Line->StrBuf, Line->CharID, NULL, Line->RubiInfo2 ) ;
				if( hr == -1 ) break ;
				Line->StrLen = hr ;
				if( Mes->MaxStrLen < Line->StrLen ) Mes->MaxStrLen = Line->StrLen ;

				Line->StrWidth = GetMessageStringLength( PackID, (s8)MesID, (s8)LineNo ) ;	// 擾
				if( Line->StrWidth > Mes->MaxWidth ) Mes->MaxWidth = Line->StrWidth ;		// ő剡̒lXV
				Line->Height = Line->StrBuf[0]->h ;											// 擾

				Line->y = y + ADDY ;						// Zbg
				y += Line->StrBuf[0]->h + 15 ;

				Mes->StrDataNum ++ ;						// C𑝂₷
				LineNo ++ ;									// si߂
				Line ++ ;									// AhXi߂

				// `FbN
				if( GetMessageContinueState( PackID, (s8)MesID, (s8)( LineNo - 1 ) ) == TRUE ) ContFlag = TRUE ;
			}while(1) ;

			if( ContFlag == FALSE ) break ;

			// vX
			y += PR2[6] ;

			// bZ[WhcCNg
			MesID ++ ;
		}while(1) ;

		Mes->Height = (s32)( y + PR1[3] / 2.0F ) ;
	}
	
	// J[\̈ʒuZbg
	{
		s32 Width, WinW, WinH, WinW2 ;
		
		Width = Mes->MaxWidth ;

		// bZ[W̕\ʒuZbg	
		y = (s16)( y == -1 ? SCH - ( Mes->Height + PR2[7] ) : y ) ;
		Mes->x = x == -1 ? (s16)( ( SCW - ( Width + ( ButtonCancelFlag == TRUE ? PR1[24] : 0 ) ) ) / 2 ) : x ;
		Mes->y = y ;

		// Z^Oꍇ͍WZ^O
		if( CenterXFlag ) Mes->x -= Mes->MaxWidth / 2 ;
		if( CenterYFlag ) Mes->y -= Mes->Height / 2 ;
	
		WinW2 = WinW = Width + PR1[4] + ( ButtonCancelFlag == TRUE ? PR1[24] : 0 ) ;
		WinH = Mes->Height ;

		// Obh̃TCYŕ␳
		Mes->LRGridNum = WinW / PR1[0] + ( WinW % PR1[0] != 0 ? 1 : 0 ) - 1 ;
		Mes->TBGridNum = WinH / PR1[0] + ( WinH % PR1[0] != 0 ? 1 : 0 ) - 1 ;
		WinW = ( Mes->LRGridNum + 1 ) * PR1[0] ;
		WinH = ( Mes->TBGridNum + 1 ) * PR1[0] ;
		
		Mes->WinX = Mes->x - ( ( WinW - ( Width + ( ButtonCancelFlag == TRUE ? PR1[24] : 0 ) ) ) / 2 ) ;
		Mes->WinY = ( Mes->y + ( Mes->Height /*- PR1[3]*/ ) / 2 ) - WinH / 2 ;
		Mes->WinW = WinW ;
		Mes->WinH = WinH ;
		SetCursorPos( (u16)Mes->WinX, (u16)Mes->WinY, (s16)Mes->WinW, (s16)Mes->WinH, Mes->Cursor, TRUE, FALSE ) ;
		SetCursorDrawFlag( TRUE, Mes->Cursor ) ;
//		SetCursorPos( (u16)Mes->WinX, (u16)Mes->WinY, (s16)Mes->WinW, (s16)Mes->WinH, Mes->Cursor, TRUE, FALSE ) ;
	}

	// IuWFNg̏Zbg
	{
		s32 i, j, x, y, h ;
		stFontParam *Info ;
		MESSAGE2OBJECT *Obj, *RObj ;
		MESSAGE2LINE *Line ;
		MESSAGERUBI *Rubi ;
		
		Line = Mes->StrData ;
		for( j = 0 ; j < Mes->StrDataNum ; j ++, Line ++ )
		{
			Obj = Line->StrInfo ;
			x = Mes->x ;
			y = Line->y + Mes->y ;
			h = 0 ;
			for( i = 0 ; Line->StrBuf[i] != NULL ; i ++, Obj ++ )
			{
				Info = Line->StrBuf[i] ;
				
				if( Info != FONT_NULLPOINT )
				{
					ObjectInit( Obj, x, y, Info->w, Info->h, Line->CharID[i] ) ;
					if( Info->h > h ) h = Info->h ;
					x += Info->w ;
				}
				else
				{
					x += (s32)PR2[2] ;
				}
			}

			// ȑ
			{
				f32 w, rw, stx, sty ;
				s32 k ;
			
				RObj = Line->RubiInfo ;
				Rubi = Line->RubiInfo2 ;
				Line->RubiNum = 0 ;
				for( i = 0 ; Rubi->fromNum != -1 ; i ++, Rubi ++ )
				{
					// S镶̕Zo
					w = 0 ; Obj = &Line->StrInfo[Rubi->fromNum] ;
					stx = Obj->BaseX ; sty = Obj->BaseY ;
					for( k = 0 ; k < Rubi->toNum ; k ++ ) w += Obj->w ;
					
					// r̕𓾂
					rw = Rubi->rNum * 13 ;

					// X^[gʒu𒲐
					stx = ( stx + w / 2.0F ) - rw / 2.0F ;
	
					// rIuWFNg
					for( k = 0 ; k < Rubi->rNum ; k ++, RObj ++, Line->RubiNum ++ )
					{
						ObjectInit( RObj, stx + ( rw / Rubi->rNum ) * k, sty - JIMAKU_RUBI_H,
											JIMAKU_RUBI_W, JIMAKU_RUBI_H, (u16)( ( i << 8 ) | k ) ) ;
//						ObjectInit( RObj, stx + ( w / ( Rubi->rNum + 0.5F ) * ( k + 0.25F ) ), sty - JIMAKU_RUBI_H,
//											JIMAKU_RUBI_W, JIMAKU_RUBI_H, (u16)( ( i << 8 ) | k ) ) ;
					}
				}
			}
		}
		

		// {^LZꍇ̓{^IuWFNg
		if( ButtonCancelFlag == TRUE )
		{
			ObjectInit( &Mes->ButObj,
						Mes->x + Mes->MaxWidth + PR1[24] / 2,
						Mes->y + ( Mes->Height - PR1[3] - Ms2Union.ButTex.Data.Header->mHeight ) + ADDY,
										Ms2Union.ButTex.Data.Header->mWidth, Ms2Union.ButTex.Data.Header->mHeight ) ;
		}
	}

	// ACRꍇ̓ACRp̃ObhJ[\쐬
	if( ICONCHK(Mes) == FALSE && Mes->IconNotDrawFlag == FALSE )
	{
//		Mes->IconY = Mes->PostID * PR2[1] ;
		Mes->IconY = 0 ;
		Mes->IconCursor = CreateCursorEffect( Col, FALSE ) ;
		if( Mes->IconCursor == NULL )
		{
			DeleteEffect( Effect ) ;
			return NULL ;
		}
		SetCursorShadowFlag( Mes->IconCursor, TRUE ) ;
		SetCursorAmiColor( Mes->IconCursor, AMICOLOR, AMITOPCOLOR, AMIBOTCOLOR ) ;
		SetCursorPos( (u16)( PR1[19] - PR1[21] / 2 ),
						(u16)( PR1[20] - PR1[22] / 2 + Mes->IconY ),
						(s16)PR1[21], (s16)PR1[22], Mes->IconCursor,
						TRUE, FALSE ) ;
		ObjectInit( &Mes->IconObj, PR1[19] - ICONTEXSIZE / 2.0F,
									PR1[20] - ICONTEXSIZE / 2.0F + Mes->IconY,
									ICONTEXSIZE, ICONTEXSIZE ) ;
	}

	// I
	return Effect ;
}

// bZ[WQ̃GtFNǧns
extern s8 ReleaseMessage2Effect( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;

	// |XgJ
//	if( Mes->PostID != -1 ) ReleaseMessage2Post( Mes->PostID ) ;
	if( Mes->PostID != -1 )
	{
		if( Ms2Union.RunMes == Effect )
		{
			Ms2Union.RunMes = NULL ;
		}
	}

	// J[\GtFNg폜
	DeleteEffect( Mes->Cursor ) ;
	if( Mes->IconCursor != NULL ) DeleteEffect( Mes->IconCursor ) ;

	// I
	return 0 ;
}

// bZ[WQ̃GtFNgPt[
extern s8 MoveMessage2Effect( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	
	// ܂eNX`ǂݍ܂ĂȂ牽I
	if( CheckMessage2Data() == FALSE ) return 0 ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// bZ[WpbNǂݍݏIĖ牽I
	if( CheckMessagePackLoadComp( Mes->PackID ) == FALSE ) return 0 ;

	if( Mes->PostID == 0 )
	{
		if( CheckEffectValidState( Mes->MatiMes, Mes->MatiMesID ) == TRUE ) return 0 ;
		if( Ms2Union.RunMes == NULL ) Ms2Union.RunMes = Effect ;
		Mes->PostID = 1 ;
	}

	if( Mes->Counter2 != PR1[18] )
	{
		Mes->Counter2 ++ ;
		if( Mes->Counter2 == PR1[18] )
		{
			SetCursorLeftRightObjectNum( Mes->Cursor, (u16)Mes->LRGridNum ) ;
			SetCursorTopBottomObjectNum( Mes->Cursor, (u16)Mes->TBGridNum ) ;
			if( GetEffectSoundOffFlag() == FALSE )
			{
				PlayEffectSE( SFX_SYS_MESSE_DERU, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
				
				// wւwւ̔炷
				{
					s8 id ;
					
					id = (s8)( Mes->IconID != -1 ? Mes->IconID : GetMessageIconNumber( (s8)Mes->PackID, (s8)Mes->MessageID ) ) ;
					if( id != -1 && Mes->IconNotDrawFlag == FALSE )
					{
						s8 YubiwaIDList[] = { 12, 16, 28, 29, 30, 31, -1 } ;
						s32 i ;
						
						for( i = 0 ; YubiwaIDList[i] != -1 && YubiwaIDList[i] != id ; i ++ ){}
						if( YubiwaIDList[i] == id )
						{
							PlayEffectSE( SFX_SYS_MESSE_RINGROAR ) ;
						}
					}
				}
			}
		}
	}
	
	if( ICONCHK(Mes) == FALSE && Mes->IconNotDrawFlag == FALSE )
	{
		switch( Mes->IconMode )
		{
		case 0 :
			Mes->IconCounter1 ++ ;
			if( Mes->IconCounter1 == PR1[23] )
			{
				SetCursorDrawFlag( TRUE, Mes->IconCursor ) ;
				Mes->IconMode ++ ;
				Mes->IconCounter1 = 0 ;
			}
			break ;
			
		case 1 :
			Mes->IconCounter1 ++ ;
			if( Mes->IconCounter1 == PR1[18] )
			{
				SetCursorLeftRightObjectNum( Mes->IconCursor, 1 ) ;
				SetCursorTopBottomObjectNum( Mes->IconCursor, 1 ) ;
			}
			if( Mes->IconCounter1 == PR1[12] )
			{
				Mes->IconCounter1 = 0 ;
				Mes->IconMode = 3 ;
				ObjectStart( &Mes->IconObj, 1 ) ;
				SetCursorAmikakeFlag( Mes->IconCursor, TRUE ) ;
			}
			break ;
			
		case 2 :
			break ;
			
		case 3 :
			if( Mes->Mode >= 2 )
			{
				if( Mes->IconCounter1 == 0 )
				{
					ObjectEnd( &Mes->IconObj, 0 ) ;
				}

				if( Mes->IconCounter1 == Mes->MaxStrLen )
				{
					SetCursorPos( (u16)( PR1[19] - PR1[21] / 2 ),
									(u16)( PR1[20] - PR1[22 / 2] + Mes->IconY ),
									-1, 0, Mes->IconCursor, TRUE, FALSE ) ;
					EndReqCursorEffect( Mes->IconCursor ) ;
					Mes->IconCounter1 ++ ;
				}
				else Mes->IconCounter1 ++ ;
			}
			break ;
		}
	}
	ObjectMove( &Mes->IconObj ) ;

	switch( Mes->Mode )
	{
	case 0 :
		Mes->Counter1 ++ ;
		if( Mes->Counter1 == PR1[12] )
		{
			if( GetEffectSoundOffFlag() == FALSE && Mes->SoundID != 0 )
			{
				PlayEffectSE( Mes->SoundID != -1 ? Mes->SoundID : (s32)GetMessageSoundID( (s8)Mes->PackID, (s8)Mes->MessageID ),
								SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
			}

			SetCursorAmikakeFlag( Mes->Cursor, TRUE ) ;
								
			SetStrDrawFlag( Effect, TRUE ) ;
			Mes->Mode ++ ;
			Mes->Counter1 = 0 ;
		}
		break ;
		
	case 1 :
		if( Mes->ButtonCancelFlag == TRUE )
		{
			if( Mes->Counter1 == 0 )
			{
				SetCursorBrinkMode( Mes->Cursor, 1 ) ;
				Mes->Counter1 ++ ;

				ObjectStart( &Mes->ButObj, 1 ) ;
			}
		
			u32 Input = HSD_PadGetTrigger(0) ;
			if( ( ( Input & PAD_BUTTON_A ) != 0 ) || ( ( Input & PAD_BUTTON_B ) != 0 ) )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
				
				if( GetEffectSoundOffFlag() == FALSE )
					PlayEffectSE( SFX_SYS_MESSE_BUTTON, SOUND_SYSTEM_SE_VOLUME, SOUND_PAN_CENTER, eSETrackSystemOverlap, eSEGroupSystem00 ) ;
				
				SetCursorBrinkMode( Mes->Cursor, 2 ) ;
				if( Mes->IconCursor != NULL ) SetCursorBrinkMode( Mes->IconCursor, 2 ) ;
				ObjectEnd( &Mes->ButObj, 1 ) ;
			}
		}
		else
		{
			Mes->Counter1 ++ ;
			if( Mes->Counter1 == PR1[13] )
			{
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
		}
		break ;

	case 2 :
		{
			if( Mes->Counter1 == 0 )
			{
				SetStrDrawFlag( Effect, FALSE ) ;
			}
			
			Mes->Counter1 ++ ;
			if( Mes->Counter1 == Mes->MaxStrLen )
			{
				SetCursorPos( (u16)Mes->WinX , (u16)( Mes->WinY + Mes->WinH / 2 ),
								(s16)Mes->WinW, 0, Mes->Cursor, TRUE, FALSE ) ;
				EndReqCursorEffect( Mes->Cursor ) ;
				
				Mes->Mode ++ ;
				Mes->Counter1 = 0 ;
			}
		}
		break ;

	case 3 :
		Mes->Counter1 ++ ;
		if( Mes->Counter1 == PR1[14] )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		break ;
	}

	// ړ
	{
		MESSAGE2OBJECT *Obj ;
		MESSAGE2LINE *Line ;
		s32 i, j ;

		Line = Mes->StrData ;
		for( j = 0 ; j < Mes->StrDataNum ; j ++, Line ++ )
		{
			Obj = Line->StrInfo ;
			for( i = 0 ; Line->StrBuf[i] != NULL ; i ++, Obj ++ )
			{
				if( Line->StrBuf[i] != FONT_NULLPOINT )
				{
					ObjectMove( Obj ) ;
				}
			}
			
			Obj = Line->RubiInfo ;
			for( i = 0 ; i < Line->RubiNum ; i ++, Obj ++ )
			{
				ObjectMove( Obj ) ;
			}
		}
	}
	
	// {^̈ړ
	ObjectMove( &Mes->ButObj ) ;

	// I
	return 0 ;
}
			


// bZ[WQ̃GtFNg`悷
extern s8 DrawMessage2Effect( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	s32 SpaceNum, StrLen, i, j ;
	stFontParam *UV ;
	GhmGcTexHeader *Tex ;
	MESSAGE2LINE *Line ;
	GXColor Color ;

	//VUO͈̔͐ݒ(!?)
	GXSetScissor( 0, 0, SCW, SCH );

	//r[|[g̐ݒ
	GXSetViewport( 0.0f, 0.0f, (f32)K7APP_SCREEN_WIDTH, (f32)K7APP_SCREEN_HEIGHT, 0.0f, 1.0f );

	// ܂eNX`ǂݍ܂ĂȂ牽I
	if( TexLoadChk( &Ms2Union.ButTex ) == FALSE ) return 0 ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	Line = Mes->StrData ;
	for( j = 0 ; j < Mes->StrDataNum ; j ++, Line ++ )
	{
		// ̒ƃXy[X̐𐔂
		{
			for( SpaceNum = 0, StrLen = 0 ;
				 Line->StrBuf[StrLen] != NULL ; StrLen ++ )
			{
				if( Line->StrBuf[StrLen] == FONT_NULLPOINT ) SpaceNum ++ ;
			}
		}
		
		// `揈
		{
			MESSAGE2OBJECT *Obj ;
			
			if( Mes->ButtonCancelFlag == TRUE && Mes->Mode >= 2 )
			{
				Color.r = (u8)VParam[ED_CURSOR2][25] ;
				Color.g = (u8)VParam[ED_CURSOR2][26] ;
				Color.b = (u8)VParam[ED_CURSOR2][27] ;
				Color.a = Mes->Color.a ;
			}
			else
			{
				Color = Mes->Color ;
			}
		
			// eNX`̃[h
			GTLOAD( GetMessageTexObj( Mes->PackID ) ) ;
			Tex = GetMessageTexHeader( Mes->PackID ) ;
		
			GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( ( StrLen - SpaceNum ) * 8) ) ;
			{
				Obj = Line->StrInfo ;
				for( i = 0 ; i < StrLen ; i ++, Obj ++ )
				{
					UV = Line->StrBuf[i] ;
					
					if( UV == FONT_NULLPOINT ) continue ;
					
					ObjectDraw( Obj, (f32)( UV->u ) / Tex->mWidth, (f32)( UV->v ) / Tex->mHeight,
									(f32)( UV->w ) / Tex->mWidth, (f32)( UV->h ) / Tex->mHeight, &Color,
									Mes->ButtonCancelFlag == TRUE && Mes->Mode >= 2 ) ;
				}
			}
			GXEnd() ;

			{
				MESSAGEUV *rubi ;
				TEXDATA *Tex = GetMessageRubiTexData() ;
				const f32 uw = ( (f32)16 - 1.0F ) / Tex->Data.Header->mWidth, vh = ( (f32)16 - 1.0F ) / Tex->Data.Header->mHeight ;
			
				GTLOAD( &GetMessageRubiTexData()->Data.Obj ) ;
			
				GBGN( GX_QUADS, Line->RubiNum * 8 ) ;
				{
					Obj = Line->RubiInfo ;
					for( i = 0 ; i < Line->RubiNum ; i ++, Obj ++ )
					{
						rubi = &Line->RubiInfo2[ Obj->CharID >> 8 ].CharUv[ Obj->CharID & 0xff ] ;

						ObjectDraw( Obj, rubi->u + 0.5F / Tex->Data.Header->mWidth,
										 rubi->v + 0.5F / Tex->Data.Header->mWidth,
										uw, vh, &Color,
										Mes->ButtonCancelFlag == TRUE && Mes->Mode >= 2 ) ;
					}
				}
				GEND() ;
			}
		}
	}

	// ACR̕`
	if( ICONCHK(Mes) == FALSE && Mes->IconNotDrawFlag == FALSE )
	{
		// eNX`̃[h
		GTLOAD( Mes->IconID != -1 ? GetMessageIconTexObj( (s8)Mes->IconID ) :
									GetMessageIconTexObj( (s8)Mes->PackID, (s8)Mes->MessageID ) ) ;	
		
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)8 ) ;
		{
			ObjectDraw( &Mes->IconObj, 0.0F, 0.0F, 1.0F, 1.0F, &(GXColor){255,255,255,255}, FALSE ) ;
		}
		GXEnd() ;
	}
	
	// {^̕`
	if( Mes->ButtonCancelFlag == TRUE )
	{
		GXColor Color ;
	
		GTLOAD2( Ms2Union.ButTex ) ;

		Color = Mes->Color ;
		if( GetCursorBrinkState2( Mes->Cursor ) == 1 )
		{
			Color.r = (u8)VParam[ED_CURSOR2][25] ;
			Color.g = (u8)VParam[ED_CURSOR2][26] ;
			Color.b = (u8)VParam[ED_CURSOR2][27] ;
		}

		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)8 ) ;
		{
			ObjectDraw( &Mes->ButObj, 0.0F, 0.0F, 1.0F, 1.0F, &Color, FALSE ) ;
		}
		GXEnd() ;
	}

	// I
	return 0 ;
}


// ~Ԃ
extern u8 StopReleaseMessage2Effect( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	
	Mes->StopFlag = FALSE ;
	
	// I
	return 0 ;
}

// ~Ԃł邩ǂ擾( TRUE:~ FALSE: )
extern s8 GetStopStateMessage2Effect( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	
	// lԂ
	return (s8)( Mes->Mode == 1 ? TRUE : FALSE ) ;
}

// ޏoJnĂ邩ǂ擾( TRUE:JnĂ  FALSE:܂ ) 
extern s8 GetMessage2EffectCompState( EFFECT *Effect )
{
	MESSAGE2EFFECT *Mes = ( MESSAGE2EFFECT * )Effect->Data ;
	
	// lԂ
	return (s8)( Mes->Mode >= 2 ? TRUE : FALSE ) ;
}

	

