///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMiss
//
// YK7EffectMiss.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/16/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectMiss.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define MISSTEX 			"/Yam/Effect/Miss/Miss.BIN"		// ~XGtFNgp̃eNX`t@C
#define MISSTEX_DIVNUM		2								// eNX`̕
#define MISSTEX_ONES		(1.0F/(MISSTEX_DIVNUM))
#define MISS_MODELNUM		4								// ~XeNX`̑

// datatype -------------------------------------

// data -----------------------------------------

MISSUNION MisUnion ;

// function proto type --------------------------

// function code --------------------------------

// ~XGtFNg̋ʃf[^
extern s8 InitMissData( void )
{
	MEMINIT( MisUnion ) ;

	// I
	return 0 ;
}

// ~XGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMissData( void )
{
	return TRUE ;
}


// ~XGtFNg̋ʃf[^n
extern s8 EndMissData( void )
{
	MEMINIT( MisUnion ) ;

	// I
	return 0 ;
}


// ~X̃GtFNg쐬
extern EFFECT *CreateMissEffect( Vec Point, GXColor *Color, s32 Priority )
{
	EFFECT *Effect, *BillEff ;
	MISSEFFECT *Ms ;
	
	// r{[hGtFNgf[^쐬
	BillEff = CreateBillboardEffect2( BILLEFF_MISSSHOT, Point, 0.0F, 0xffffffff, Color ) ;
	if( BillEff == NULL ) return NULL ;

	// V~Xf[^쐬
	Effect = AddEffectData( EFF_MISS, (void**)&Ms, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( BillEff ) ;
		return NULL ;
	}

	// p[^ۑ
	Ms->Point = Point ;
	Ms->LineBill = BillEff ;

	// I
	return Effect ;
}

// ~X̃GtFNǧns
extern s8 ReleaseMissEffect( EFFECT *Effect )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;
	
	// r{[hGtFNg폜
	DeleteEffect( Ms->LineBill ) ;

	// I
	return 0 ;
}

// ~X̃GtFNgPt[
extern s8 MoveMissEffect( EFFECT *Effect )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// I
	return 0 ;
}

// ~X̃GtFNg`悷
extern s8 DrawMissEffect( EFFECT *Effect )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;
	
	// I
	return 0 ;
}					

// ~XVbg̃GtFNgǉ
extern s8 AddMissEffectObject( EFFECT *Effect, Vec *Point )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;

	if( Point != NULL ) Ms->Point = *Point ;
	
	// J̕ɈꔭԂ
	{
		HSD_CObj *CObj ;
		Vec CPoint, Dir ;
	
		// J̈ʒu𓾂
		CObj = GetEffectCamera() ;
		HSD_CObjGetEyePosition( CObj, &CPoint ) ;
		
		// J̕𓾂
		VECSubtract( &CPoint, &Ms->Point, &Dir ) ;
		VECNormalize( &Dir, &Dir ) ;
		
		// Zbg
		SetBillboardDirection( Ms->LineBill, Dir ) ;
		
		// ꔭ
		AddBillboardEffectObject( Ms->LineBill, Ms->Point ) ;
	}
	
	// I
	return 0 ;
}					

// 쐬~XGtFNgUׂč폜
extern s8 ClearMissEffectObject( EFFECT *Effect )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;

	// IuWFNgׂč폜	
	ClearBillboardEffectObject( Ms->LineBill ) ;
	
	// I
	return 0 ;
}					



	
// ~XVbgWύX
extern s8 SetMissEffectPoint( EFFECT *Effect, Vec Point )
{
	MISSEFFECT *Ms = ( MISSEFFECT * )Effect->Data ;

	// WύX
	Ms->Point = Point ;

	// I
	return 0 ;
}


