///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectMuzzleFlash
//
// YK7EffectMuzzle.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/19/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "../fujita/c_font.h"
#include "./YK7EffectMuzzle.h"
#include "./YK7EffectCartridge.h"
#include "./YK7EffectSmoke.h"
#include "../fujita/c_particle.h"
#include "../matsu/mk7Sound.h"
#include "./YK7EffectStaticData.h"

//#include "./YK7EffectBlur.h"
#include "./YK7EffectCentLight.h"

// define ---------------------------------------

#define MUZZLEV1TEX	"/yam/Effect/MuzzleFlash/MuzzleFlash_V1.BIN"		// MuzzleFlash_V1.BIN
#define MUZZLEH1TEX	"/yam/Effect/MuzzleFlash/MuzzleFlash_H1.BIN"		// MuzzleFlash_H1.BIN
#define MUZZLEX1TEX	"/yam/Effect/MuzzleFlash/MuzzleFlash_X1.BIN"		// MuzzleFlash_X1.BIN
#define FSTFOLDER	"/yam/Effect/MuzzleFlash/FST/"
#define FSTNAME		"MuzzleFlash"
#define GUNMODELFOLDER "/Yam/Effect/MuzzleFlash/GunModel/"

static s8 FstTexNumber[GUN_NUM+1] =
{
	3,	// 0 I[hn[}
	2,	// 1 J[eBX
	2,	// 2 J[eBX
	2,	// 3 On[}
	3,	// 4 _
	4,	// 5 Lbg
	4,	// 6 Lbg
	5,	// 7 ~Y
	0,	// 8 }XN
	0,	// 9 }XN
	2,	// 10 
	0,	// 11 KVA
	5,	// 12 R[e
	4,	// 13 LXM
	4,	// 14 LXM
	3,	// 15 Ng
	5,	// 16 f|[
	5,	// 17 f|[
	6,	// 18 Pr
	6,	// 19 Pr
	2,	// 20 
	2,	// 21 II^
	2,	// 22 WFt@[Y
	2,	// 23 NnV
	2,	// 24 _bh[
	3,	// 25 G~[
	7,	// 26 _Q
	3,	// 27 L[
	4,	// 28 On[}
} ;

// [Vt@C
static const char *GunMotionFileName[GUN_NUM+1] =
{
	"BarrettR_A00.dat",	// I[hn[}
	"BrwngHPL_A00.dat",	// J[eBX
	"BrwngHPR_A00.dat",	// J[eBX
	"ColtGovR_A00.dat",	// On[}
	"ColtPytR_A00.dat",	// _
//	"Glock26L_A00.dat",	// Lbg
	"Glock26R_A00.dat",	// Lbg
	"Glock26R_A00.dat",	// Lbg
	"WthrPPKL_A00.dat",	// ~Y
	"M79GLncL_A00.dat",	// }XN
	"M79GLncR_A00.dat",	// }XN
	"ColtGStR_A00.dat",	// 
	"WthrPP2R_A00.dat",	// KVA
	"EnfieldR_A00.dat",	// R[e
	"KimBrPSL_A00.dat",	// LXM
	"KimBrPSR_A00.dat",	// LXM
	"Pyth6inR_A00.dat",	// Ng
	"CougarFL_A00.dat",	// f|[
	"CougarFR_A00.dat",	// f|[
	"ThKnifeR_A00.dat",	// Pr
	"ThKnifeR_A00.dat",	// Pr
	"MP5ARflR_A00.dat",	// 
	NULL,	// II^
	NULL,	// WFt@[Y
	NULL,	// NnV
	NULL,	// _bh[
	"SWM29MBR_A00.dat",	// G~[
	"ColtPspR_A00.dat",	// _Q
	"PythnR_A00.dat",	// L[
	"Thompson_A00.dat",	// On[}
} ;

static char *GunName[GUN_NUM+1] =
{
	"Barrett",		// I[hn[}
	"BrowningHP_R",	// J[eBX
	"BrowningHP_R",	// J[eBX
	"ColtGov",		// On[}
	"ColtPython_R",	// _
	"Glock26_R",	// Lbg
	"Glock26_R",	// Lbg
	"WaltherPPK",	// ~Y
	"M79GLnchr_RL",	// }XN
	"M79GLnchr_RL",	// }XN
	"ColtGS",		// 
	"WaltherPPK2",	// KVA
	"Enfield_R",	// R[e
	"KimbrPS_LR",	// LXM
	"KimbrPS_LR",	// LXM
	"Pyth6in",		// Ng
	"CougarF_RL",	// f|[
	"CougarF_RL",	// f|[
	"HkKnife",		// Pr
	"ThKnife",		// Pr
	"MP5",			// 
	"Jericho941",	// II^
	"DesertE",		// WFt@[Y
	"SWM36CS",		// NnV
	"SWM629Hr",		// _bh[
	"",				// G~[
	"", 			// _
	"Pythn25",		// L[
	"Thompson",		// On[}
} ;
	
// ft@C
static const char *GunModelFileName[GUN_NUM+1] = 
{
	"BarrettR_M00.dat",	// I[hn[}
	"BrwngHPL_M00.dat",	// J[eBX
	"BrwngHPR_M00.dat",	// J[eBX
	"ColtGovR_M00.dat",	// On[}
	"ColtPytR_M00.dat",	// _
	"Glock26L_M00.dat",	// Lbg
	"Glock26R_M00.dat",	// Lbg
	"WthrPPKL_M00.dat",	// ~Y
	"M79GLncL_M00.dat",	// }XN
	"M79GLncR_M00.dat",	// }XN
	"ColtGStR_M00.dat",	// 
	"WthrPP2R_M00.dat",	// KVA
	"EnfieldR_M00.dat",	// R[e
	"KimBrPSL_M00.dat",	// LXM
	"KimBrPSR_M00.dat",	// LXM
	"Pyth6inR_M00.dat",	// Ng
	"CougarFL_M00.dat",	// f|[
	"CougarFR_M00.dat",	// f|[
	"HkKnifeL_M00.dat",	// Pr
	"ThKnifeR_M00.dat",	// Pr
	"MP5ARflR_M00.dat",	// 
	"JerichoR_M00.dat",	// II^
	"DesertER_M00.dat",	// WFt@[Y
	"SWM36CSR_M00.dat",	// NnV
	"SW629HrR_M00.dat",	// _bh[
	"SWM29MBR_M00.dat",	// G~[
	"ColtPspR_M00.dat",	// _Q
	"PythnR_M00.dat",	// L[
	"Thompson_M00.dat"	// On[}
} ;

// eƉ̂hcΉ\( 0:}Y  1:J[gbW )
static s32 GunSoundTable[GUN_NUM][2] =
{
	SFX_PC_HAC_SYAGEKI,			SFX_PC_HAC_YAKKYOU,		// I[hn[}
	SFX_BOSS_CUR_SYAGEKI,		-50,					// J[eBX
	SFX_BOSS_CUR_SYAGEKI,		-50,					// J[eBX
	SFX_PC_HAY_SYAGEKI,			SFX_PC_HAY_YAKKYOU,		// On[}
	SFX_PC_DAN_SYAGEKI,			SFX_PC_DAN_YAKKYOU,		// _
	-1/*SFX_PC_CAT_SYAGEKI*/,	SFX_PC_CAT_YAKKYOU,		// Lbg
	-1/*SFX_PC_CAT_SYAGEKI*/,	SFX_PC_CAT_YAKKYOU,		// Lbg
	-1,							-1,						// ~Y
	SFX_PC_MSK_SYAGEKI,			-1,						// }XN
	SFX_PC_MSK_SYAGEKI,			-1,						// }XN
	SFX_PC_KED_SYAGEKI,			SFX_PC_KED_YAKKYOU,		// 
	SFX_PC_GAL_SYAGEKI,			SFX_PC_GAL_YAKKYOU,		// KVA
	-1/*SFX_PC_CYO_SYAGEKI*/,	SFX_PC_CYO_YAKKYOU,		// R[e
	SFX_BOSS_KIS_SYAGEKI,		SFX_BOSS_KIS_YAKKYOU,	// LXM
	SFX_BOSS_KIS_SYAGEKI,		SFX_BOSS_KIS_YAKKYOU,	// LXM
	-1,							-1,						// Ng
	SFX_BOSS_DE2_SYAGEKI,		SFX_BOSS_DE2_YAKKYOU,	// f|[
	SFX_BOSS_DE2_SYAGEKI,		SFX_BOSS_DE2_YAKKYOU,	// f|[
	SFX_PC_KVN_SYAGEKI,			-1, 					// Pr
	SFX_PC_KVN_SYAGEKI,			-1,						// Pr
	-1,							SFX_BOSS_AKN_YAKKYOU,	// 
	-1,							-1,						// II^
	-1,							-1,						// WFt@[Y
	-1,							-1, 					// NnV
	-1,							-1,						// _bh[
	SFX_PC_GAL_SYAGEKI2,		SFX_PC_GAL_YAKKYOU,		// G~[
	SFX_PC_DAN_SYAGEKI2,		SFX_PC_DAN_YAKKYOU,		// _Q
	-1,							-1,						// L[
	SFX_PC_HAY_SYAGEKI2,		SFX_PC_HAY_YAKKYOU,		// On[}
} ;

// ẽ}YtbV^Cv̒`
// 0:ʏ̃}YtbV		1:}XN̉^Cv		2:Pr^Cv		3:Ȃ
static u8 GunMuzzleType[GUN_NUM] =
{
	0,		// I[hn[}
	0,		// J[eBX
	0,		// J[eBX
	0,		// On[}
	0,		// _
	3,		// Lbg
	3,		// Lbg
	0,		// ~Y
	1,		// }XN
	1,		// }XN
	0,		// 
	0,		// KVA
	0,		// R[e
	0,		// LXM
	0,		// LXM
	0,		// Ng
	0,		// f|[
	0,		// f|[
	2,		// Pr
	2,		// Pr
	0,		// 
	0,		// II^
	0,		// WFt@[Y
	0,		// NnV
	0,		// _bh[
	0,		// G~[
	0,		// _Q
	0,		// L[
	3,		// On[}
} ;
	
// datatype -------------------------------------

// data -----------------------------------------

MUZZLEUNION MuzUnion ;

// function proto type --------------------------

static bool MuzzlePreFrameProcessCallBack( WK7JObj *pJObj,void *pData ) ;	// }YtbVt[vZX
static bool MuzzlePostRenderProcessCallBack( WK7JObj *pJObj,void *pData ) ;	// }YtbV_OvZX
static void MuzzlePosGetProcess( MUZZLEPARTS *Parts, MUZZLEEFFECT *Muz ) ;	// W擾鏈s

static s8 LoadFstTex( s8 Number ) ;				// erseNX`̓ǂݍ
static bool LoadFstChk( s8 Number ) ;			// erseNX`̓ǂݍ݃`FbN
static s8 ReleaseFstTex( s8 Number ) ;			// erseNX`̉

// function code --------------------------------

// erseNX`̓ǂݍ
static s8 LoadFstTex( s8 Number )
{
	s32 i ;
	char path[128] ;

	if( MuzUnion.FstTexCount[Number] != 0 )
	{
		MuzUnion.FstTexCount[Number] ++ ;
		return TRUE ;
	}

	for( i = 0 ; i < FST_TEXNUM ; i ++ )
	{
		sprintf( path, "%s%s%d_FstP%d.BIN", FSTFOLDER, FSTNAME, Number, i+1 ) ;
		TexLoadSet( path, &MuzUnion.FstTex[Number][i] ) ;
	}
	
	MuzUnion.FstTexCount[Number] ++ ;

	return TRUE ;
}

// erseNX`̓ǂݍ݃`FbN
static bool LoadFstChk( s8 Number )
{
	s32 i ;

	if( MuzUnion.FstTexCount[Number] == 0 ) return false ;

	for( i = 0 ; i < FST_TEXNUM ; i ++ )
		if( TexLoadChk( &MuzUnion.FstTex[Number][i] ) == FALSE ) return false ;
	
	return true ;
}

// erseNX`̉
static s8 ReleaseFstTex( s8 Number )
{
	s32 i ;

	if( MuzUnion.FstTexCount[Number] == 0 ) return true ;
	
	MuzUnion.FstTexCount[Number] -- ;
	if( MuzUnion.FstTexCount[Number] != 0 ) return true ;

	for( i = 0 ; i < FST_TEXNUM ; i ++ )
		TexRelease( &MuzUnion.FstTex[Number][i] ) ;
		
	return true ;
}


// W擾鏈s
static void MuzzlePosGetProcess( MUZZLEPARTS *Parts, MUZZLEEFFECT *Muz )
{
	HSD_JObj *jobj ;

	jobj = Parts->JObj ;
	Parts->DrawFlag = ( jobj->flags & JOBJ_HIDDEN ) == 0 ;
	if( ( jobj->flags & JOBJ_HIDDEN ) != 0 || Parts->MtxCopyFlag == FALSE )
	{
		Parts->Point.x = jobj->mtx[0][3] ;
		Parts->Point.y = jobj->mtx[1][3] ;
		Parts->Point.z = jobj->mtx[2][3] ;
		Parts->DrawFlag = FALSE ;
		Parts->MtxCopyFlag = TRUE ;
		memcpy( Parts->TransMtx, &jobj->mtx, sizeof( Mtx ) ) ;
	}
	else
	{
		Muz->MuzzleFlag = TRUE ;
	}
}

// }YtbVt[vZX
static bool MuzzlePreFrameProcessCallBack( WK7JObj *pJObj,void *pData )
{
	GUNDATA *Gun = ( GUNDATA * )pData ;

	pJObj = pJObj ;

	if( Gun->UserModelData != NULL )
	{
		Gun->UserModelData->FrameProcess() ;
	}
	else
	{
		Gun->ModelData->FrameProcess() ;
	}

	// I
	return true ;
}

// }YtbV_OvZX
static bool MuzzlePostRenderProcessCallBack( WK7JObj *pJObj,void *pData )
{
	if( pJObj==NULL ){
		return true;
	}
	if( pJObj->IsHidden()==true ){
		return true;
	}
	
	GUNDATA *Gun = ( GUNDATA * )pData ;
	HSD_TrspMask	trsp       = WK7JObj::GetRenderProcessTrpsMask  ();
	u32				rendermode = WK7JObj::GetRenderProcessRenderMode();
	
	if( Gun->UserModelData != NULL )
	{
		Gun->UserModelData->RenderProcess(trsp,rendermode) ;
	}
	else
	{
		Gun->ModelData->RenderProcess(trsp,rendermode) ;
	}
	
	// I
	return true ;
}


// w̏ẽf[^ǂݍ
extern s8 LoadGunArchive( s8 GunID, bool FstTexFlag )
{
	if( MuzUnion.GunDataID[GunID] != -1 ) return -1 ;
	
	MuzUnion.GunDataID[GunID] = LoadGunArchive2( GunID, FstTexFlag ) ;
	if( MuzUnion.GunDataID[GunID] < 0 ) return -1 ;
	
	return 0 ;
}


// w̏ẽf[^ǂݍ
extern s8 LoadGunArchive2( s8 GunID, bool FstTexFlag )
{
	GUNARCDATA *GArc ;
	GUNDATA *Gun ;
	s32 /*hr,*/ i ;
	char Str[256] ;

	GArc = &MuzUnion.GunArc[GunID] ;
	
	// ɏef[^tG[
	if( MAX_GUNDATANUM == MuzUnion.GunDataNum ) 
	{
		OSReport( "eő吔 %s ȏ LoadGunArchive ܂\n", MAX_GUNDATANUM ) ;
		return -1 ;
	}
	
	// gĂȂef[^T
	Gun = MuzUnion.GunData ;
	for( i = 0 ; i < MAX_GUNDATANUM && Gun->UseFlag == TRUE ; i ++, Gun ++ ){}
	
	// A[JCu܂ǂݍ܂ĂȂǂݍ
	if( GArc->Count == 0 )
	{
		// t@CΉI
		if( GunModelFileName[GunID] == NULL )
		{
			OSReport( "ff[^̖e( ID: %d )ǂݍƂ܂\n", GunID ) ;
			return -1 ;
		}

		// ef[^[h
		GArc->MotionArc = GArc->ModelArc = (WK7Archive * )1 ;

		// [VA[JCu̓ǂݍ
		if( GunMotionFileName[GunID] != NULL )
		{
			sprintf( Str, "%s%s", GUNMODELFOLDER, GunMotionFileName[GunID] ) ;
			if( ( GArc->MotionArc = WK7Archive::Create() ) == NULL )
				return -1 ;
			if( GArc->MotionArc->LoadArchive( Str ) == false )
				return -1 ;
			GArc->MotionArc->SetStatic( true ) ;
		}
		else
		{
			GArc->MotionArc = NULL ;
		}

		// fA[JCu̓ǂݍ
		sprintf( Str, "%s%s", GUNMODELFOLDER, GunModelFileName[GunID] ) ;
		if( ( GArc->ModelArc = WK7Archive::Create() ) == NULL )
			return -1 ;
		if( GArc->ModelArc->LoadArchive( Str ) == false )
			return -1 ;
		GArc->ModelArc->SetStatic( true ) ;
		
		// eNX`̓ǂݍ
/*		for( int i = 0 ; i < FST_TEXNUM ; i ++ )
		{
			if( MuzUnion.MuzzleNumberUserSetFlag == TRUE )
			{
				sprintf( Str, "%s%s%d_FstP%d.BIN", FSTFOLDER, FSTNAME, MuzUnion.UserSetMuzzleNumber, i+1 ) ;
			}
			else
			{
				sprintf( Str, "%s%s%s_FstP%d.BIN", FSTFOLDER, FSTNAME, FstTexName[GunID], i+1 ) ;
			}
			hr = TexLoadSet( Str, &GArc->Fst[i] ) ;
			if( hr == FALSE )
				return -1 ;
		}
*/
		if( FstTexFlag == true )
		{
			if( MuzUnion.MuzzleNumberUserSetFlag == TRUE )
			{
	//			sprintf( Str, "%s%s%d_FstP%d.BIN", FSTFOLDER, FSTNAME, MuzUnion.UserSetMuzzleNumber, i+1 ) ;
				LoadFstTex( (s8)MuzUnion.UserSetMuzzleNumber ) ;
			}
			else
			{
	//			sprintf( Str, "%s%s%s_FstP%d.BIN", FSTFOLDER, FSTNAME, FstTexName[GunID], i+1 ) ;
				LoadFstTex( FstTexNumber[GunID] ) ;
			}
		}
		GArc->FstTexFlag = FstTexFlag ;
	}
	
	// gpeA[JCu̎QƐCNg
	GArc->Count ++ ;

	// |C^
	Gun->AttachJObj = NULL ;
//	Gun->MuzzleEffect = NULL ;
	Gun->MotionData = NULL ;
	Gun->ModelData = NULL ;
	Gun->UserMotionData = NULL ;
	Gun->UserModelData = NULL ;
	Gun->UserJObjData = NULL ;
	
	// gpẽA[JCuhcۑ
	Gun->GunID = (u8)GunID ;
	
	// gptO𗧂Ă
	Gun->UseFlag = TRUE ;
	
	// ef[^gpĂ鐔𑝂₷
	MuzUnion.GunDataNum ++ ;

	// ef[^̃CfbNXԂ
	return (s8)i ;
}

// w̏e̓ǂݍݏI҂( ߂l TRUE:܂ǂݍݏIĂȂ FALSE:ǂݍ݂͏IĂ )
extern s8 CheckGunArchiveLoad( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	return CheckGunArchiveLoad2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// w̏e̓ǂݍݏI҂( ߂l TRUE:܂ǂݍݏIĂȂ FALSE:ǂݍ݂͏IĂ )
extern s8 CheckGunArchiveLoad2( s8 GunDataID )
{
	GUNDATA *Gun ;
	GUNARCDATA *GArc ;

	Gun = &MuzUnion.GunData[GunDataID] ;
	GArc = &MuzUnion.GunArc[Gun->GunID] ;

	// ǂݍ݂ĂȂ牽I
	if( GArc->ModelArc == NULL ) return -1 ;

	// ǂݍݏIĂ邩ׂ
	if( GArc->FstTexFlag == true )
	{
		if( MuzUnion.MuzzleNumberUserSetFlag == TRUE )
		{
			if( LoadFstChk( (s8)MuzUnion.UserSetMuzzleNumber ) == false ) return TRUE ;
		}
		else
		{
			if( LoadFstChk( FstTexNumber[Gun->GunID] ) == false ) return TRUE ;
		}
	}
//	for( u16 i = 0 ; i < FST_TEXNUM ; i ++ )
//		if( TexLoadChk( &GArc->Fst[i] ) == FALSE ) return TRUE ;
		
	if( CHKARCLOAD( GArc->MotionArc ) == FALSE ) return TRUE ;
	if( CHKARCLOAD( GArc->ModelArc ) == FALSE ) return TRUE ;
	
	GArc = NULL ;
	
	return FALSE ;
}

// w̏ẽf[^J
extern s8 ReleaseGunArchive( s8 GunID )
{
	s8 hr ;

	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	hr = ReleaseGunArchive2( (s8)MuzUnion.GunDataID[GunID] ) ;
	MuzUnion.GunDataID[GunID] = -1 ;
	
	return hr ;
}

// w̏ẽf[^J
extern s8 ReleaseGunArchive2( s8 GunDataID )
{
	GUNDATA *Gun ;
	GUNARCDATA *GArc ;

	Gun = &MuzUnion.GunData[GunDataID] ;
	
	// gĂȂ牽I
	if( Gun->UseFlag == FALSE ) return 0 ;
	
	GArc = &MuzUnion.GunArc[Gun->GunID] ;
	
	// ff[^f^b`
	DetachGunModel2( GunDataID ) ;
	
	// e̎gptO|
	Gun->UseFlag = FALSE ;

	// |C^
	Gun->AttachJObj = NULL ;
//	Gun->MuzzleEffect = NULL ;
	Gun->MotionData = NULL ;
	Gun->ModelData = NULL ;
	Gun->UserMotionData = NULL ;
	Gun->UserModelData = NULL ;
	Gun->UserJObjData = NULL ;
	
	// ẽf[^̐fNg
	MuzUnion.GunDataNum -- ;
	
	// ẽA[JCu̎QƐfNg
	GArc->Count -- ;
	
	// xQƂĂ鐔OɂȂA[JCu
	if( GArc->Count == 0 )
	{
		// ɊJĂ牽I
		if( GArc->ModelArc == NULL ) return -1 ;
	
		// A[JCu폜
		if( GArc->MotionArc > (WK7Archive *)1 )
		{
			while( CHKARCLOAD( GArc->MotionArc ) == FALSE ) GArc->MotionArc->FrameProcess() ;
			delete GArc->MotionArc ;
		}
		GArc->MotionArc = NULL ;

		if( GArc->ModelArc > (WK7Archive *)1 )
		{
			while( CHKARCLOAD( GArc->ModelArc ) == FALSE ) GArc->ModelArc->FrameProcess() ;
			delete GArc->ModelArc ;
		}
		GArc->ModelArc = NULL ;

		// eNX`̉
/*		for( u8 i = 0 ; i < FST_TEXNUM ; i ++ )
		{
			TexRelease( &GArc->Fst[i] ) ;
		}
*/
		if( GArc->FstTexFlag == true )
		{
			if( MuzUnion.MuzzleNumberUserSetFlag == TRUE )
			{
				ReleaseFstTex( (s8)MuzUnion.UserSetMuzzleNumber ) ;
			}
			else
			{
				ReleaseFstTex( FstTexNumber[Gun->GunID] ) ;
			}
		}
	}

	// I
	return 0 ;
}

// Oŗpӂff[^o^
extern s8 SetUserGunModel( s8 GunID, WK7Model *Model, WK7ModelMotion *Motion, WK7JObj *JObj  )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	return SetUserGunModel2( (s8)MuzUnion.GunDataID[GunID], Model, Motion, JObj ) ;
}

// Oŗpӂff[^o^
extern s8 SetUserGunModel2( s8 GunDataID, WK7Model *Model, WK7ModelMotion *Motion, WK7JObj *JObj  )
{
	GUNDATA *Gun ;

	Gun = &MuzUnion.GunData[GunDataID] ;

	// |C^Zbĝ
	Gun->UserMotionData = Motion ;
	Gun->UserModelData = Model ;
	Gun->UserJObjData = JObj ;
	Gun->AttachJObj = NULL ;

	// I
	return 0; 
}

// Off[^̓o^ԂZbg
extern s8 ResetUserGunModel( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	return ResetUserGunModel2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// Off[^̓o^ԂZbg
extern s8 ResetUserGunModel2( s8 GunDataID )
{
	GUNDATA *Gun ;
	
	Gun = &MuzUnion.GunData[GunDataID] ;

	// ɃZbgĂȂ牽I
	if( Gun->UserMotionData == NULL ) return -1 ;
	
	// ff[^f^b`
	DetachGunModel2( GunDataID ) ;

	// |C^
	Gun->UserMotionData = NULL ;
	Gun->UserModelData = NULL ;
	Gun->UserJObjData = NULL ;
	Gun->AttachJObj = NULL ;

	// I
	return 0 ;
}	

/*
// n
extern s8 EndGunData( s8 GunDataID )
{
	GUNDATA *Gun ;

	Gun = &MuzUnion.GunData[GunDataID] ;

	// A[JCuf[^Ăłꍇ̏
	if( Gun->UseMotionData == NULL && Gun->UserModelData == NULL )
	{
		ReleaseGunArchive2( GunDataID ) ;
	}
	else
	{
		ResetUserGunModel2( GunDataID ) ;
	}

	// I
	return 0 ;
}
*/

// ff[^A WK7JObj Ɏw̏ẽfA^b`
extern WK7Model *AttachGunModel( s8 GunID, WK7JObj *JObj, WK7Model *Model, s8 Hand )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return AttachGunModel2( (s8)MuzUnion.GunDataID[GunID], JObj, Model, Hand ) ;
}

// ff[^A WK7JObj Ɏw̏ẽfA^b`
extern WK7Model *AttachGunModel2( s8 GunDataID, WK7JObj *JObj, WK7Model *Model, s8 Hand )
{
	GUNARCDATA *GArc ;
	GUNDATA *Gun ;
	WK7Model *AttachModel ;

	Gun = &MuzUnion.GunData[GunDataID] ;
	GArc = &MuzUnion.GunArc[Gun->GunID] ;

	// f^b`
	DetachGunModel2( GunDataID ) ;

	// A[JCuf[^Ăłꍇ̏
	if( Gun->UserModelData == NULL && Gun->UserMotionData == NULL )
	{
		// f[^[hĂȂ牽I
		if( CHKARCLOAD( GArc->MotionArc ) == FALSE || 
			CHKARCLOAD( GArc->ModelArc ) == FALSE ) return NULL ;

		// ff[^ɂG[
//		if( Gun->ModelData != NULL ) 
//			return NULL ;

		// ff[^̍쐬
		Gun->ModelData = GArc->ModelArc->CreateModel() ;
		if( Gun->ModelData == NULL )
			return NULL ;
		Gun->MotionData = GArc->MotionArc != NULL ? GArc->MotionArc->CreateModelMotion() : NULL ;
//		if( Gun->MotionData == NULL )
//			return NULL ;

		AttachModel = Gun->ModelData ;
	}
	else
	{
		// o^f[^ꍇ͉I
		if( Gun->UserMotionData == NULL ) return NULL ;

		AttachModel = Gun->UserModelData ;
	}

	// ff[^̃|C^炻 WK7JObj 擾
	if( JObj == NULL )
	{
		if( Model == NULL ) return NULL ;

		// ff[^A^b` WK7JObj 擾
		JObj = Model->GetObj( Hand == GUN_HAND_R ? "GunPos_R" : "GunPos_L" ) ;

		// G[
		if( JObj == NULL ) return NULL ;
	}

	// A^b`
	if( AttachModel->Attach( JObj ) == false )
		return NULL ;

	// R[obN֐o^
	JObj->SetPreFrameProcessCallBack( MuzzlePreFrameProcessCallBack, Gun ) ;
	JObj->SetPostRenderProcessCallBack( MuzzlePostRenderProcessCallBack, Gun ) ;
	
//	if( Gun->GunID == GUN_HKKNIFE_L )
//	{
//		u32 topcolor = CMK( VParam[ED_BLUR][0], VParam[ED_BLUR][1], VParam[ED_BLUR][2], VParam[ED_BLUR][3] ) ; 
//		u32 botcolor = CMK( VParam[ED_BLUR][7], VParam[ED_BLUR][8], VParam[ED_BLUR][9], VParam[ED_BLUR][10] ) ; 
//		
//		CreateBlurEffect( AttachModel->GetObj(0), *((GXColor *)&topcolor), *((GXColor *)&botcolor) ) ;
//	}

/*	if( Gun->GunID == GUN_THKNIFE_R )
	{
		Vec p = { 320.0F, 240.0F, 0.0F } ;
	
		SetCentLightHomingJObj2( AttachModel->GetObj(0) ) ;
		CreateCentLightEffect( p, 
								VParam[ED_CENTLIGHT][0] * PI_2 / 360,	VParam[ED_CENTLIGHT][1] * PI_2 / 360,
								VParam[ED_CENTLIGHT][2],				VParam[ED_CENTLIGHT][3],
								VParam[ED_CENTLIGHT][4] * PI_2 / 360,	VParam[ED_CENTLIGHT][5] * PI_2 / 360,
								(f32)VParam[ED_CENTLIGHT][14],			(f32)VParam[ED_CENTLIGHT][15],
								(f32)VParam[ED_CENTLIGHT][16] * 0.1F,	(f32)VParam[ED_CENTLIGHT][17] * 0.1F,
								(f32)VParam[ED_CENTLIGHT][6] * 0.1F,
								(f32)VParam[ED_CENTLIGHT][7] * 0.01F,
								(s32)VParam[ED_CENTLIGHT][8],
								CMK( VParam[ED_CENTLIGHT][9], VParam[ED_CENTLIGHT][10], VParam[ED_CENTLIGHT][11], VParam[ED_CENTLIGHT][12] ),
								FALSE
								) ; 
	}
*/

	// A^b` WK7JObj ۑĂ
	Gun->AttachJObj = JObj ;

	// AhX
//	Gun->MuzzleEffect = NULL ;

	// fAhXԂ
	return AttachModel ;
}

// ẽfɃ[VA^b`( Type:0 }Y[V  Type:1 [h[V )
extern s8 AttachGunMotion( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	return AttachGunMotion2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ẽfɃ[VA^b`( Type:0 }Y[V  Type:1 [h[V )
extern s8 AttachGunMotion2( s8 GunDataID )
{
	GUNDATA *Gun ;
	GUNARCDATA *GArc ;
	WK7Model *AttachModel ;
	WK7JObj *AttachJObj ;
	WK7ModelMotion *AttachMotion ;
	HSD_AnimJoint *AnimJoint ;

	Gun = &MuzUnion.GunData[GunDataID] ;
	GArc = &MuzUnion.GunArc[Gun->GunID] ;

	// A[JCuf[^Ăłꍇ̏
	AttachJObj = Gun->UserJObjData ;
	if( Gun->UserModelData == NULL && Gun->UserMotionData == NULL )
	{
		// f[^[hĂȂ牽I
		if( CHKARCLOAD( GArc->MotionArc ) == FALSE || 
			CHKARCLOAD( GArc->ModelArc ) == FALSE ) return NULL ;

		// A^b`郂fƃ[VZbg
		AttachModel = Gun->ModelData ;
		AttachMotion = Gun->MotionData ;
	}
	else
	{
		AttachModel = Gun->UserModelData != NULL ? Gun->UserModelData : Gun->ModelData ;
		AttachMotion = Gun->UserMotionData != NULL ? Gun->UserMotionData : Gun->MotionData ;
	}
	
	// ̃GtFNggĂɃf^b`Ă܂tO𗧂Ă
	if( GetEffectValidState( Gun->MuzzleEffect ) == TRUE && Gun->MuzzleEffect->Type == EFF_MUZZLE )
	{
//		MUZZLEEFFECT *Mz = ( MUZZLEEFFECT * )Gun->MuzzleEffect->Data ;

//		Mz->DetachFlag = TRUE ;
		DeleteEffect( Gun->MuzzleEffect ) ;
//		Gun->MuzzleEffect = NULL ;
	}

	// ɃAj[Vf[^A^b`ĂƂ̂߂
	// Aj[Vf[^̃f^b`{
	if( AttachJObj != NULL )
	{
		AttachJObj->DetachMotion() ;
	}
	else
	{
		AttachModel->GetObj(0)->DetachMotion() ;
	}

	// Aj[Vf[^A^b`
	if( AttachMotion == NULL ) return -1 ;
	AttachMotion->GetAnimJoint( AttachModel->GetObj(0)->GetName(), &AnimJoint ) ;
	if( AttachJObj != NULL )
	{
		AttachJObj->AttachMotion( AnimJoint ) ;
		AttachJObj->SetMotionLoop( AnimJoint ) ;
		AttachJObj->SetMotionRate( 1.0F ) ;
	}
	else
	{
		AttachModel->AttachMotion( AnimJoint ) ;
		AttachModel->SetMotionLoop( false ) ;
		AttachModel->SetMotionRate(1.0F) ;
	}

	// AhX
//	Gun->MuzzleEffect = NULL ;

	// I
	return 0 ;
}
	

// A^b`
extern s8 DetachGunModel( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return -1 ;
	return DetachGunModel2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// A^b`
extern s8 DetachGunModel2( s8 GunDataID )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;
	WK7Model *AttachModel ;
	WK7JObj *AttachJObj ;

	// A^b`Ė牽I
	if( Gun->AttachJObj == NULL ) return -1 ;

	// A[JCuf[^Ăłꍇ̏
	AttachJObj = Gun->UserJObjData ;
	if( Gun->UserMotionData == NULL && Gun->UserModelData == NULL )
	{
		AttachModel = Gun->ModelData ;
	}
	else
	{
		AttachModel = ( Gun->UserModelData != NULL ) ? Gun->UserModelData : Gun->ModelData ;
	}

	// ̃GtFNggĂɃf^b`Ă܂tO𗧂Ă
	if( GetEffectValidState( Gun->MuzzleEffect ) == TRUE && Gun->MuzzleEffect->Type == EFF_MUZZLE )
	{
		MUZZLEEFFECT *Mz = ( MUZZLEEFFECT * )Gun->MuzzleEffect->Data ;

		Mz->DetachFlag = TRUE ;
//		Gun->MuzzleEffect = NULL ;
	}

	// f^b`
	if( AttachJObj != NULL )
	{
		AttachJObj->DetachMotion() ;
	}
	else
	{
		AttachModel->GetObj(0)->DetachMotion() ;
		AttachModel->Detach() ;
	}

	// R[obN֐o^
	Gun->AttachJObj->SetPreFrameProcessCallBack( NULL, NULL ) ;
	Gun->AttachJObj->SetPostRenderProcessCallBack( NULL, NULL ) ;

	// A[JCuf[^Ăłꍇ̓ff[^폜
	{
		if( Gun->MotionData != NULL ) delete Gun->MotionData ;
		if( Gun->ModelData != NULL ) delete Gun->ModelData ;
		Gun->MotionData = NULL ;
		Gun->ModelData = NULL ;
	}

	// |C^
	Gun->AttachJObj = NULL ;

	// I
	return 0 ;
}

// ŵhc̏ẽf[^擾
extern GUNDATA *GetGunData( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return GetGunData2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ŵhc̏ẽf[^擾
extern GUNDATA *GetGunData2( s8 GunDataID )
{
	return &MuzUnion.GunData[GunDataID] ;
}

// ŵhc̏ẽff[^擾
extern WK7Model *GetGunModel( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return GetGunModel2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ŵhc̏ẽff[^𕡐
extern WK7Model *CopyGunModel( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return CopyGunModel2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ŵhc̏ẽff[^擾
extern WK7Model *GetGunModel2( s8 GunDataID )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;
//	return Gun->MotionArc != NULL && CHKARCLOAD( Gun->ModelArc ) == TRUE  ? Gun->ModelData : Gun->UserModelData ;
	return Gun->UserModelData != NULL ? Gun->UserModelData : Gun->ModelData ;
}

// ŵhc̏ẽff[^𕡐
extern WK7Model *CopyGunModel2( s8 GunDataID )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;
	GUNARCDATA *GArc = &MuzUnion.GunArc[Gun->GunID] ;
	return GArc->ModelArc != NULL && CHKARCLOAD( GArc->ModelArc ) == TRUE ? GArc->ModelArc->CreateModel() : NULL ;
}

// ŵhc̏ẽ[Vf[^擾															
extern WK7ModelMotion *GetGunMotion( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return GetGunMotion2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ŵhc̏ẽ[Vf[^擾															
extern WK7ModelMotion *GetGunMotion2( s8 GunDataID )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;
//	return Gun->MotionArc != NULL && CHKARCLOAD( Gun->MotionArc ) == TRUE ? Gun->MotionData : Gun->UserMotionData ;
	return Gun->UserMotionData != NULL ? Gun->UserMotionData : Gun->MotionData ;
}

// ŵhc̏êin擾
extern WK7JObj *GetGunJObj( s8 GunID )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return GetGunJObj2( (s8)MuzUnion.GunDataID[GunID] ) ;
}

// ŵhc̏êin擾
extern WK7JObj *GetGunJObj2( s8 GunDataID )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;
	return Gun->UserJObjData != NULL ? Gun->UserJObjData : ( Gun->UserModelData != NULL ? Gun->UserModelData->GetObj(0) : ( GetGunModel2( GunDataID ) != NULL ? GetGunModel2( GunDataID )->GetObj(0) : NULL ) ) ;
}


// ŵhc̏ẽff[^̃ff[^̃NIeBύX
extern s8 ChangeGunModelQuality( s8 GunID, u8 HiModelFlag )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;
	return ChangeGunModelQuality2( (s8)MuzUnion.GunDataID[GunID], HiModelFlag ) ;
}

// ŵhc̏ẽff[^̃ff[^̃NIeBύX
extern s8 ChangeGunModelQuality2( s8 GunDataID, u8 HiModelFlag )
{
	GUNDATA *Gun = &MuzUnion.GunData[GunDataID] ;

	// ͉Ȃ
	HiModelFlag = HiModelFlag ;

	// I
	return 0 ;
}

// }YtbVW HSD_JObj 擾
extern HSD_JObj *GetMuzzlePosJObj( s8 GunID )
{
	WK7JObj *JObj = GetGunJObj( GunID ), *tmp ;
	
	if( JObj == NULL ) 
		return NULL ;

	JObj = JObj->GetObj( "MuzzleFlash" ) ; 
	if( JObj == NULL ) return NULL ;
	tmp = JObj->GetObj( "MuzFlash00_H1" )  ;
	if( tmp == NULL ) tmp = JObj->GetObj( "MuzFlash00_S1" ) ;
	return tmp->GetJObj() ;
}

	

// }YtbVGtFNg̋ʃf[^
extern s8 InitMuzzleData( void )
{
//	s8 hr ;
	s32 i ;
	MUZZLEUNION *MuzzleUnion = &MuzUnion ;
	
	MEMINIT(MuzUnion) ;
	
	for( i = 0 ; i < GUN_NUM ; i ++ )
	{
		MuzUnion.GunDataID[i] = -1 ;
	}

	// }YtbṼeNX`[ǂݍ
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_MuzzleFlash_V1 ), &MuzzleUnion->V1 ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_MuzzleFlash_H1 ), &MuzzleUnion->H1 ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_MuzzleFlash_X1 ), &MuzzleUnion->X1 ) ;
//	hr = TexLoadSet( MUZZLEV1TEX, &MuzzleUnion->V1 ) ;
//	hr = TexLoadSet( MUZZLEX1TEX, &MuzzleUnion->X1 ) ;
//	hr = TexLoadSet( MUZZLEH1TEX, &MuzzleUnion->H1 ) ;

	// I
	return 0 ;
}

// }YtbVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckMuzzleData( void )
{
//	if( TexLoadChk( &MuzUnion.V1 ) == FALSE || 
//		TexLoadChk( &MuzUnion.X1 ) == FALSE || 
//		TexLoadChk( &MuzUnion.H1 ) == FALSE ) return FALSE ;
		
	return TRUE ;
}

// }YtbVGtFNg̋ʃf[^n
extern s8 EndMuzzleData( void )
{
	// eNX`t@CĂȂăIuWFNg폜
	TexRelease( &MuzUnion.V1 ) ;
	TexRelease( &MuzUnion.X1 ) ;
	TexRelease( &MuzUnion.H1 ) ;
	
	// I
	return 0 ;
}

// }YtbṼGtFNg쐬
extern EFFECT *CreateMuzzleEffect( s8 GunID, f32 YukaY, WK7JObj *GJObj, s8 MotionAttach, s32 Priority )
{
	if( MuzUnion.GunDataID[GunID] == -1 ) return NULL ;

	return CreateMuzzleEffect2( (s8)MuzUnion.GunDataID[GunID], YukaY, GJObj, MotionAttach, Priority ) ;
}

// }YtbṼGtFNg쐬
extern EFFECT *CreateMuzzleEffect2( s8 GunDataID, f32 YukaY, WK7JObj *GJObj, s8 MotionAttach, s32 Priority )
{
	MUZZLEEFFECT *Mz ;
	EFFECT *Effect ;
	WK7JObj *GunJObj ;
	WK7ModelMotion *Motion ;
	GUNDATA *Gun = &MuzUnion.GunData[ GunDataID ] ;
	GUNARCDATA *GArc = &MuzUnion.GunArc[Gun->GunID] ;
	u8 CartridgeEffect3DSoundFlag ;
	
	CartridgeEffect3DSoundFlag = MuzUnion.CartridgeEffect3DSoundFlag ;
	MuzUnion.CartridgeEffect3DSoundFlag = FALSE ;

	// eNX`t@C̓ǂݍ݂IĂȂGtFNg\Ȃ
	if( CheckMuzzleData() == FALSE ) return 0 ;
	
	// }Y[Vf[^Ȃꍇ͉I
//	if( Gun->MotionArc == NULL ) return 0 ;

	if( GetEffectValidState( Gun->MuzzleEffect ) == TRUE && Gun->MuzzleEffect->Type == EFF_MUZZLE )
	{
		MUZZLEEFFECT *Muz = ( MUZZLEEFFECT * )( ( EFFECT * )Gun->MuzzleEffect )->Data ;
		Muz->DetachFlag = TRUE ;
		DeleteEffect( Gun->MuzzleEffect ) ;
		Gun->MuzzleEffect = NULL ;
	}
		
	if( GJObj != NULL ) 
	{
		GJObj = GJObj->GetObj( GunName[Gun->GunID] ) ;
		SetUserGunModel2( GunDataID, NULL, NULL, GJObj ) ;
		
		if( MotionAttach == TRUE )
		{
			Motion = GArc->MotionArc->CreateModelMotion() ;
			GJObj->GetChild()->AttachFindMotion( Motion ) ;
			GJObj->GetChild()->PlayMotion( 0.0F ) ;
			GJObj->GetChild()->SetMotionLoop( false ) ;
		}
	}

	// ẽ[VJn
	{
		// ẽff[^擾
		if( ( GunJObj = GetGunJObj2( GunDataID ) ) == NULL ) return 0 ; 

//		if( GetEffectValidState( Gun->MuzzleEffect ) == FALSE ) Gun->MuzzleEffect = NULL ;

		if( Gun->UserJObjData == NULL )
		{
			// ReloadTypeFlag ̒lɂčĐ郂[VύX
			if( AttachGunMotion2( GunDataID ) == -1 )
			{
				return NULL ;
			}

			// [V̍ĐJns
			{
		 		GunJObj->StopMotion() ;
				GunJObj->PlayMotion(0.0F) ;
				GunJObj->ReplayMotion() ;
			}
		}
	}

	// V}YtbVf[^쐬
	Effect = AddEffectData( EFF_MUZZLE, (void**)&Mz, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( Mz, 0, sizeof( MUZZLEEFFECT ) ) ;

	Gun->MuzzleEffect = Effect;
	Mz->GunModel = GunJObj ;	// ẽAhXۑ
	Mz->GunDataID = GunDataID ;	// êhcۑ
	Mz->YukaY = YukaY ;			// ̍ۑ
	Mz->DetachFlag = FALSE ;
	Mz->Counter = 0 ;			// JE^
	Mz->SoundFlag = FALSE ;
	Mz->MuzCounter = 0 ;
	Mz->CountFlag = FALSE ;
	Mz->MuzzleFlag = FALSE ;
	Mz->KnifeRot = 0.0F ;
	Mz->CartridgeEffect3DSoundFlag = CartridgeEffect3DSoundFlag ;

	Mz->DirectJObjFlag = GJObj != NULL ;
	Mz->MotionAttachFlag = MotionAttach ;
	Mz->GunMotion = Motion ;
	Mz->DirectJObj = GJObj != NULL ? GJObj->GetChild() : NULL ;

	Mz->Obj.HReverseFlag = rand() < RAND_MAX / 2 ;
	Mz->Obj.VReverseFlag = rand() < RAND_MAX / 2 ;
	Mz->Obj.FstNumber = (u8)( rand() * FST_TEXNUM / RAND_MAX ) ;
	if( Mz->Obj.FstNumber == FST_TEXNUM ) Mz->Obj.FstNumber = FST_TEXNUM - 1 ;

	// J[gbW̃IuWFNg擾
	GetCartridgeJObj( Mz->GunModel, &Mz->Cartridge ) ;
	Mz->CartridgeFlag = FALSE ;

	// [h^Cvł͂Ȃꍇ̓P[^͂
	{
		MUZZLEPARTS *VParts ;
		MUZZLEPARTS *HParts ;
		MUZZLEPARTS *XParts ;
		MUZZLEPARTS *SParts ;
		u8 VNum ;
		u8 HNum ;
		u8 XNum ;
		u8 SNum ;
		
		MUZZLEOBJECT *MObj ;
		WK7JObj *Obj ;
		WK7JObj *Moto ;
		char Str[64] ;

		VParts = ( MUZZLEPARTS * )WorkBuffer ;
		HParts = VParts + 15 ;
		XParts = HParts + 15 ;
		SParts = XParts + 15 ;
		
		MObj = &Mz->Obj ;
			
		// }YtbV݂̑mF
		Moto = Mz->GunModel->GetObj( "MuzzleFlash" ) ;
		if( Moto == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
		
		// }YtbṼf[^
		u32 i ;
		MObj->SNum = MObj->VNum = MObj->HNum = MObj->XNum = 0 ;
		SNum = VNum = HNum = XNum = 0 ;
		for( i = 0 ; ; i ++ )
		{
			// OԂ珇Ԃɑ
			strcpy( Str, "MuzFlash" ) ;
			if( i < 10 ) strcat( Str, "0" ) ;
			sprintf( &Str[strlen( Str )], "%d", i ) ;

			// Ȃ烋[v𔲂
			Obj = Moto->GetObj( Str ) ;
			if( Obj == NULL ) break ;

			// 璆g𒲂ׂ
			Obj = Obj->GetChild() ;
			while( Obj != NULL )
			{
				// ȊO̕܂ŖO납炳̂ڂāA^Cv擾
				strcpy( Str, Obj->GetName() ) ;
				{
					u32 j ;
					Mtx *mp ;

					j = strlen( Str ) - 1 ;
					while( j != 0 && Str[j] < '9' && Str[j] > '0' ) j -- ;

					// ̓f[^ʂɃf[^ۑ邾	
					HSD_JObjSetupMatrix( Obj->GetJObj() ) ;
					mp = &( Obj->GetJObj()->mtx ) ;
					switch( Str[j] )
					{
					case 'X' :	XParts[XNum].JObj = Obj->GetJObj() ;
								XParts[XNum].Type = MUZ_TYPE_X ;
								XParts[XNum].Point.x = (*mp)[0][3] ; XParts[XNum].Point.y = (*mp)[1][3] ; XParts[XNum].Point.z = (*mp)[2][3] ; 
								XParts[XNum].Flag = FALSE ;
								XParts[XNum].MtxCopyFlag = FALSE ;
								XNum ++ ;
								break ;
								
					case 'V' :	VParts[VNum].JObj = Obj->GetJObj() ;
								VParts[VNum].Type = MUZ_TYPE_V ;
								VParts[VNum].Point.x = (*mp)[0][3] ; VParts[VNum].Point.y = (*mp)[1][3] ; VParts[VNum].Point.z = (*mp)[2][3] ; 
								VParts[VNum].Flag = FALSE ;
								VParts[VNum].MtxCopyFlag = FALSE ;
								VParts[VNum].RotRand = rand() * PI_2 / RAND_MAX ;
								VNum ++ ;
								break ;
								
					case 'H' :	HParts[HNum].JObj = Obj->GetJObj() ;
								HParts[HNum].Type = MUZ_TYPE_H ;
								HParts[HNum].Point.x = (*mp)[0][3] ; HParts[HNum].Point.y = (*mp)[1][3] ; HParts[HNum].Point.z = (*mp)[2][3] ; 
								HParts[HNum].Flag = FALSE ;
								HParts[HNum].MtxCopyFlag = FALSE ;
								HNum ++ ;
								break ;

					case 'S' :	SParts[SNum].JObj = Obj->GetJObj() ;
								SParts[SNum].JObj2 = Obj->GetJObj() ;
								SParts[SNum].Type = MUZ_TYPE_S ;
								SParts[SNum].Point.x = (*mp)[0][3] ; SParts[SNum].Point.y = (*mp)[1][3] ; SParts[SNum].Point.z = (*mp)[2][3] ; 

								// }Ỹ^Cvɂď𕪊
								if( GunMuzzleType[Gun->GunID] == 0 )
								{
									SParts[SNum].Smoke = new C_Generator( SParts[SNum].JObj2, i == 0 ? 4 :3 ) ;
								}
								
								SParts[SNum].Flag = FALSE ;
								SParts[SNum].MtxCopyFlag = FALSE ;
								SNum ++ ;
								break ;
					}
				}
				
				// 
				Obj = Obj->GetNext() ;
			}
		}
		
		// 擾IAf[^Rs[
		MObj->VParts = ( MUZZLEPARTS * )K7AppSmallMemAllocName( (s32)( sizeof( MUZZLEPARTS ) * VNum ), "Y_MuzV" ) ;
		if( MObj->VParts == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
		MObj->VNum = VNum ;
		memcpy( MObj->VParts, VParts, sizeof( MUZZLEPARTS ) * VNum ) ;
		
		MObj->HParts = ( MUZZLEPARTS * )K7AppSmallMemAllocName( (s32)( sizeof( MUZZLEPARTS ) * HNum ), "Y_MuzH" ) ;
		if( MObj->HParts == NULL ){ DeleteEffect( Effect ) ; return NULL ; }
		MObj->HNum = HNum ;
		memcpy( MObj->HParts, HParts, sizeof( MUZZLEPARTS ) * HNum ) ;
		
		MObj->XParts = ( MUZZLEPARTS * )K7AppSmallMemAllocName( (s32)( sizeof( MUZZLEPARTS ) * XNum ), "Y_MuzX" ) ;
		if( MObj->XParts == NULL ) { DeleteEffect( Effect ) ; return NULL ; }
		MObj->XNum = XNum ;
		memcpy( MObj->XParts, XParts, sizeof( MUZZLEPARTS ) * XNum ) ;
		
		MObj->SParts = ( MUZZLEPARTS * )K7AppSmallMemAllocName( (s32)( sizeof( MUZZLEPARTS ) * SNum ), "Y_MuzS" ) ;
		if( MObj->SParts == NULL ) { DeleteEffect( Effect ) ; return NULL ; }
		MObj->SNum = SNum ;
		memcpy( MObj->SParts, SParts, sizeof( MUZZLEPARTS ) * SNum ) ;
	}

	// I
	return Effect ;
}


// }YtbṼGtFNǧns
extern s8 ReleaseMuzzleEffect( EFFECT *Effect )
{
	GUNDATA *Gun ;
	MUZZLEEFFECT *Mz = ( MUZZLEEFFECT * )Effect->Data ;
	MUZZLEOBJECT *MObj = &Mz->Obj ;
	int i ;

	Gun = &MuzUnion.GunData[Mz->GunDataID] ;
	{
		// }Ỹ^Cvɂď𕪊
		if( GunMuzzleType[Gun->GunID] == 0 )
		{
			// p[eBN̍폜
			for( i = 0 ; i < Mz->Obj.SNum ; i ++ )
			{
				if( Mz->Obj.SParts[i].Smoke != NULL )
				{
					delete Mz->Obj.SParts[i].Smoke ;
				}
			}
		}

		// ̊Js
		CHKMEMFREE2( MObj->VParts ) ;
		CHKMEMFREE2( MObj->XParts ) ;
		CHKMEMFREE2( MObj->HParts ) ;
		CHKMEMFREE2( MObj->SParts ) ;
	}
	
	if( Gun->MuzzleEffect == Effect )
	{
		Gun->MuzzleEffect = NULL ;
	}
	
	if( Mz->DetachFlag == FALSE &&
		GetGunModel2( Mz->GunDataID ) != NULL )
	{
		GUNDATA *Gun = GetGunData2( Mz->GunDataID ) ;
//		Gun->MuzzleEffect = NULL ;
	}
	
	if( Mz->DirectJObjFlag == TRUE )
	{
		if( Mz->MotionAttachFlag == TRUE )
		{
			Mz->DirectJObj->DetachMotion() ;
			delete Mz->GunMotion ;
		}
		SetUserGunModel2( Mz->GunDataID, NULL, NULL, NULL ) ;
	}

	return 0 ;
}

// }YtbṼGtFNgPt[
extern s8 MoveMuzzleEffect( EFFECT *Effect )
{
	MUZZLEEFFECT *Mz = ( MUZZLEEFFECT * )Effect->Data ;
	GUNDATA *Gun = &MuzUnion.GunData[Mz->GunDataID] ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( FstTexNumber[Gun->GunID] == 6 )
	{
		if( ( Mz->Obj.VParts[0].JObj->flags & JOBJ_HIDDEN ) == 0 )
		{
			goto R1 ;
		}
	}
	
	{
		if( Mz->CountFlag == TRUE && Mz->DetachFlag == FALSE )
		{
			Mz->MuzCounter ++ ;
			if( Mz->MuzCounter == VParam[ED_MUZ][10] )
			{
				Vec Point ;
				
R1 :
				Point.x = Mz->GunModel->GetJObj()->mtx[0][3] ;
				Point.y = Mz->GunModel->GetJObj()->mtx[1][3] ;
				Point.z = Mz->GunModel->GetJObj()->mtx[2][3] ;
				if( GetEffectSoundOffFlag() == FALSE && GunSoundTable[Gun->GunID][0] >= 0 )
				{
					if( Gun->GunID == GUN_THOMPSON )
					{
						const s32 sound_table[] = { SFX_PC_HAY_SYAGEKI, SFX_PC_HAY_SYAGEKI2, SFX_PC_HAY_SYAGEKI3 } ;
						PlayEffectSE3D( (s32)sound_table[GetRandINum(3)], Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
					}
					else
					{
						PlayEffectSE3D( (s32)GunSoundTable[Gun->GunID][0], Point, 0, SOUND_SYSTEM_SE_VOLUME, eSETrackBattleOverlap, eSEGroupBattle00Env ) ;
					}
				}
			}
		}
	}

	if( GunMuzzleType[Gun->GunID] == 2 )
	{
		Mz->KnifeRot += PI / 180.0F ;
	}
	
	// Aj[Vꍇ̓Aj[VI_ŏI
	{
		if( Mz->DetachFlag == TRUE || 
			( GetGunModel2( Mz->GunDataID ) == NULL && GetGunJObj2( Mz->GunDataID ) == NULL ) ||
			Mz->GunModel->GetMotionState() == WK7MODEL_NOANIM )
		{
			int i, Num ;
			
			// oIĂȂƂ
			{
				if( GunMuzzleType[Gun->GunID] == 0 )
				{
					Num = Mz->Obj.SNum ;
					for( i = 0 ; i < Num ; i ++ )
					{
						if( Mz->Obj.SParts[i].Smoke->IsAlive() != 0 ) break ;
					}
					if( i == Mz->Obj.SNum )
					{
						DeleteEffect( Effect ) ;
						return 0 ;
					}
				}
				else
				{
					DeleteEffect( Effect ) ;
					return 0 ;
				}
			}
		}
	}

	if( Mz->DetachFlag == TRUE ) return 0 ;

	// J[gbW̕\ԂnmJ[gbWro
	if( Mz->Counter != 0 && 
		Mz->Cartridge != NULL &&
		Mz->CartridgeFlag == FALSE &&
		Gun->GunID != -1 && 
		( Mz->Cartridge->GetJObj()->flags & JOBJ_HIDDEN ) == 0 )
	{
		SetCartridgeSound3DFlag( Mz->CartridgeEffect3DSoundFlag == TRUE ? true : false ) ;
		CreateCartridgeEffect( Mz->GunModel, Mz->YukaY, GunSoundTable[Gun->GunID][1] ) ;
		Mz->CartridgeFlag = TRUE ;
	}

	// ˏ
	{
		int i ;

		for( i = 0 ; i < Mz->Obj.SNum ; i ++ )
		{
			if( Mz->Counter != 0 && Mz->Obj.SParts[i].Flag == FALSE &&
				 ( Mz->Obj.SParts[i].JObj2->flags & JOBJ_HIDDEN ) == 0 )
			{
				if( Mz->SoundFlag == FALSE )
				{
					Mz->CountFlag = TRUE ;
				}

				// }Ỹ^Cvɂď𕪊
				if( GunMuzzleType[Gun->GunID] == 0 )
				{
					Mz->Obj.SParts[i].Smoke->Fire() ;
				}
				else
				if( GunMuzzleType[Gun->GunID] == 1 )
				{
					Vec Dir, Point ;
					Mtx mtx ;
					HSD_JObj *JObj = Mz->Obj.SParts[i].JObj2 ;
					GXColor Color ;
					
					memcpy( mtx, JObj->mtx, sizeof( Mtx ) ) ;
					Point.x = JObj->mtx[0][3] ;
					Point.y = JObj->mtx[1][3] ;
					Point.z = JObj->mtx[2][3] ;
					
					mtx[0][3] = mtx[1][3] = mtx[2][3] = 0.0F ;
					Dir.x = 0.0F ;
					Dir.y = 0.0F ;
					Dir.z = 1.0F ;
					MTXMultVec( mtx, &Dir, &Dir ) ;

					Color.r = (u8)VParam[ED_SMOKE][7] ;
					Color.g = (u8)VParam[ED_SMOKE][8] ;
					Color.b = (u8)VParam[ED_SMOKE][9] ;
					Color.a = 255 ;
					
					CreateSmokeEffect( (u8)VParam[ED_SMOKE][0], Point, VParam[ED_SMOKE][1] * 0.1F,
										0.0F, 0.0F,
										0.0F, VParam[ED_SMOKE][2],
										Dir,  PI_2 * VParam[ED_SMOKE][3] / 360.0F,
										PI_2 / 720.0F, PI_2 / 720.0F,
										8.0F * VParam[ED_SMOKE][4] * 0.01F, 7.0F * ( VParam[ED_SMOKE][4] * 0.11F ),
										8.0F * VParam[ED_SMOKE][4] * 0.01F, 7.0F * ( VParam[ED_SMOKE][4] * 0.11F ),
										VParam[ED_SMOKE][5], VParam[ED_SMOKE][6], 0.0F,
										Color, Color, Color, (u8)VParam[ED_SMOKE][10],
										0.0F, 0.0F, (u8)VParam[ED_SMOKE][11], (u8)VParam[ED_SMOKE][12], 
										VParam[ED_SMOKE][13] * 0.01F, FALSE, 0,
										Color, Color, Color,
										VParam[ED_SMOKE][14] * 0.01F, 500 ) ; 

				}
				
				Mz->Obj.SParts[i].Flag = TRUE ;
			}
		}
	}

	// W
	{
		int i, Num ;
		HSD_JObj *jobj ;
		MUZZLEPARTS *pt ;
		
		for( i = 0 ; i < Mz->Obj.XNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.XParts[i], Mz ) ;

		for( i = 0 ; i < Mz->Obj.HNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.HParts[i], Mz ) ;

		for( i = 0 ; i < Mz->Obj.VNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.VParts[i], Mz ) ;

		Num = Mz->Obj.SNum ;
		pt = Mz->Obj.SParts ;
		for( i = 0 ; i < Num ; i ++, pt ++ )
		{
			jobj = pt->JObj ;
			pt->DrawFlag = ( jobj->flags & JOBJ_HIDDEN ) == 0 ;
			if( ( jobj->flags & JOBJ_HIDDEN ) == 0 )
			{
				if( GunMuzzleType[ Gun->GunID ] == 1 ||
					( Mz->Obj.VNum == 0 &&
					  Mz->Obj.HNum == 0 &&
					  Mz->Obj.XNum == 0 ) )
				{
					Mz->MuzzleFlag = TRUE ;
				}
			}
		}
	}

	// JE^߂
	Mz->Counter ++ ;
	
	// I
	return 0 ;
}
	
// }YtbṼGtFNg`悷
#define TUV		0
#define TUV2	0
#define R 200
#define G 130
#define B 61
extern s8 DrawMuzzleEffect( EFFECT *Effect )
{
	MUZZLEEFFECT *Mz = ( MUZZLEEFFECT * )Effect->Data ;
	MUZZLEUNION *MuzzleUnion = &MuzUnion ;
	GUNDATA *Gun = &MuzUnion.GunData[Mz->GunDataID] ;
	HSD_JObj *Vert ;
	Mtx View ;
	u8 RenderType ;
	
	if( Mz->DetachFlag == TRUE ) return 0 ;
	if( Mz->GunModel->GetMotionState() == WK7MODEL_NOANIM ) return 0 ;
	
	// r[s擾
	HSD_CObjGetViewingMtx( GetEffectCamera(), View ) ; 
/*	
	// W
	{
		int i, Num ;
		HSD_JObj *jobj ;
		MUZZLEPARTS *pt ;
		
		for( i = 0 ; i < Mz->Obj.XNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.XParts[i], Mz ) ;

		for( i = 0 ; i < Mz->Obj.HNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.HParts[i], Mz ) ;

		for( i = 0 ; i < Mz->Obj.VNum ; i ++ )
			MuzzlePosGetProcess( &Mz->Obj.VParts[i], Mz ) ;

		Num = Mz->Obj.SNum ;
		pt = Mz->Obj.SParts ;
		for( i = 0 ; i < Num ; i ++, pt ++ )
		{
			jobj = pt->JObj ;
			pt->DrawFlag = ( jobj->flags & JOBJ_HIDDEN ) == 0 ;
			if( ( jobj->flags & JOBJ_HIDDEN ) == 0 )
			{
				if( GunMuzzleType[ Gun->GunID ] == 1 ||
					( Mz->Obj.VNum == 0 &&
					  Mz->Obj.HNum == 0 &&
					  Mz->Obj.XNum == 0 ) )
				{
					Mz->MuzzleFlag = TRUE ;
				}
			}
		}
	}
*/
	// eƃJƂ̋}YtbṼ[h肷
	{
		Vec CamP, MuzP ;
		f32 Length ;
		HSD_JObj *GunJ = Mz->GunModel->GetJObj() ;
		
		CamP.x = View[0][3] ;		CamP.y = View[1][3] ;		CamP.z = View[2][3] ;
		MuzP.x = GunJ->mtx[0][3] ;	MuzP.y = GunJ->mtx[1][3] ;	MuzP.z = GunJ->mtx[2][3] ;		
		Length = VECDistance( &CamP, &MuzP ) ;		

		RenderType = MuzUnion.Render2DFlag ;
	}

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// `揈
	{
		Mtx GView ;
		u16 j, s ;
		MUZZLEOBJECT *Obj ;
		f32 r1, r2 ;

		// r[s̓]us(ts)߂
		MTXIdentity( GView ) ;
		GView[0][0] = View[0][0] ;		GView[1][0] = View[0][1] ;		GView[2][0] = View[0][2] ;
		GView[0][1] = View[1][0] ;		GView[1][1] = View[1][1] ;		GView[2][1] = View[1][2] ;
		GView[0][2] = View[2][0] ;		GView[1][2] = View[2][1] ;		GView[2][2] = View[2][2] ;

		// ׂẴ}YtbVIuWFNg`
		{
			u8 a ;
		
			Obj = &Mz->Obj ;

			r1 = Obj->r1 ;
			r2 = Obj->r2 ;

			// VeNX`gpOtBbN̕`
			if( Obj->VNum != 0 )
			{
				MUZZLEPARTS *Parts ;
				Vec Point, p[4] ;
				f32 r, Sin, Cos, x ;
				u8 cr, cg, cb ;

				// eNX`̃[h
				if( RenderType == 1 )
				{
					GUNARCDATA *GArc = &MuzUnion.GunArc[Gun->GunID] ;
					GTLOAD2( MuzUnion.FstTex[FstTexNumber[Gun->GunID]][Obj->FstNumber]/*GArc->Fst[Obj->FstNumber]*/ ) ;
				}
				else
				{
					GTLOAD2( MuzzleUnion->V1 ) ;
				}
				
				// `Jn
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( RenderType != 1 ? 4 * Obj->VNum : 4 ) ) ;
				
				// VeNX`gpĂOtBbN̐JԂ
				for( j = 0 ; j < Obj->VNum && ( RenderType != 1 || j != 1 ) ; j ++ )
				{
					Vert = Obj->VParts[j].JObj ;
					Parts = &Obj->VParts[j] ;

					{
						// WZbg
						HSD_JObjSetupMatrix( Vert ) ;
						Point = Parts->Point ;
						r = Vert->scale.y ;

						// 
						{
							if( GunMuzzleType[Gun->GunID] != 2 )
							{
								Sin = sin( Parts->RotRand ) ;
								Cos = cos( Parts->RotRand ) ;
							}
							else
							{
								Sin = sin( Mz->KnifeRot ) ;
								Cos = cos( Mz->KnifeRot ) ;
							}
							
//							r = 2.0F ;
						
							// ̓_̏Zbg
							p[0].x = -r ;		p[0].y = r ;		p[0].z = 0.0F ;
							p[1].x = r ;		p[1].y = r ;		p[1].z = 0.0F ;
							p[2].x = r ;		p[2].y = -r ;		p[2].z = 0.0F ;
							p[3].x = -r ;		p[3].y = -r ;		p[3].z = 0.0F ;
							
							// ]
							x = p[0].x * Cos - p[0].y * Sin ;
							p[0].y = p[0].x * Sin + p[0].y * Cos ;
							p[0].x = x ;
							x = p[1].x * Cos - p[1].y * Sin ;
							p[1].y = p[1].x * Sin + p[1].y * Cos ;
							p[1].x = x ;
							x = p[2].x * Cos - p[2].y * Sin ;
							p[2].y = p[2].x * Sin + p[2].y * Cos ;
							p[2].x = x ;
							x = p[3].x * Cos - p[3].y * Sin ;
							p[3].y = p[3].x * Sin + p[3].y * Cos ;
							p[3].x = x ;
							

							// ɑ΂]
							MTXMultVec( GView, &p[0], &p[0] ) ;
							MTXMultVec( GView, &p[1], &p[1] ) ;
							MTXMultVec( GView, &p[2], &p[2] ) ;
							MTXMultVec( GView, &p[3], &p[3] ) ;
							
							s = (u16)( ( Vert->scale.x - 1.0F ) * 255 ) ;
							a = (u8)( ( s > 255 ) ? 255 : s ) ; 
							if( Parts->DrawFlag == FALSE && Gun->GunID != GUN_THOMPSON ) a = 0 ;
							
							if( RenderType == 1 )
							{
								cr = 255 ;
								cg = 255 ;
								cb = 255 ;
								
//								a = 255 ;
							}
							else
							{
								cr = R ;
								cg = G ;
								cb = B ;
							}
					
							// sړďo
							GP3( p[0].x + Point.x, p[0].y + Point.y, p[0].z + Point.z ) ;	GC4( cr, cg, cb, a ) ;
							GT2( (u16)( Obj->HReverseFlag == FALSE ? TUV : UVSCALE - TUV ), (u16)( Obj->VReverseFlag == FALSE ? TUV : UVSCALE - TUV ) ) ;
							GP3( p[1].x + Point.x, p[1].y + Point.y, p[1].z + Point.z ) ;	GC4( cr, cg, cb, a ) ;
							GT2( (u16)( Obj->HReverseFlag == FALSE ? UVSCALE - TUV : TUV ), (u16)( Obj->VReverseFlag == FALSE ? TUV : UVSCALE - TUV ) ) ;
							GP3( p[2].x + Point.x, p[2].y + Point.y, p[2].z + Point.z ) ;	GC4( cr, cg, cb, a ) ;
							GT2( (u16)( Obj->HReverseFlag == FALSE ? UVSCALE - TUV : TUV ), (u16)( Obj->VReverseFlag == FALSE ? UVSCALE - TUV : TUV ) ) ;
							GP3( p[3].x + Point.x, p[3].y + Point.y, p[3].z + Point.z ) ;	GC4( cr, cg, cb, a ) ;
							GT2( (u16)( Obj->HReverseFlag == FALSE ? TUV : UVSCALE - TUV ), (u16)( Obj->VReverseFlag == FALSE ? UVSCALE - TUV : TUV ) ) ;
						}
					}
				}
				GXEnd() ;
			}

			// HeNX`gpp[c̕`
			if( Obj->HNum != 0 && RenderType != 1 )
			{
				Vec Point, LeftVec, RightVec, DepthVec, p[4] ;
				f32 Length, r ;
				Mtx mtemp ;
				MUZZLEPARTS *Parts ;
				
				// eNX`̃[h
				GTLOAD2( MuzzleUnion->H1 ) ;
				
				// `Jn
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Obj->HNum * 4 ) ) ;
				
				// HeNX`gpĂp[c̐JԂ
				for( j = 0 ; j < Obj->HNum ; j ++ )
				{
					Vert = Obj->HParts[j].JObj ;
					Parts = &Obj->HParts[j] ;

					// WZbg
					HSD_JObjSetupMatrix( Vert ) ;
					Point = Parts->Point ;
					Length = Vert->scale.z ;
					r = Vert->scale.y ;
					
					// ]݂̂𓾂
					memcpy( mtemp, Obj->HParts[j].TransMtx, sizeof( Mtx ) ) ;
					mtemp[0][3] = mtemp[1][3] = mtemp[2][3] = 0.0F ;

					// Z𓾂
					DepthVec.y = DepthVec.x = 0.0F ;
					DepthVec.z = 1.0F ;
					MTXMultVec( mtemp, &DepthVec, &DepthVec ) ;
					VECNormalize( &DepthVec, &DepthVec ) ;
					VECScale( &DepthVec, &DepthVec, Length ) ;
					
					// X𓾂
					RightVec.z = RightVec.y = 0.0F ;
					RightVec.x = 1.0F ;
					MTXMultVec( mtemp, &RightVec, &RightVec ) ;
					VECNormalize( &RightVec, &RightVec ) ;
					VECScale( &RightVec, &RightVec, r ) ;
					VECScale( &RightVec, &LeftVec, -1.0F ) ;

					// WZbg
					p[0] = LeftVec ;
					VECAdd( &DepthVec, &LeftVec, &p[1] ) ;
					p[2] = RightVec ;
					VECAdd( &DepthVec, &RightVec, &p[3] ) ;
					
					VECAdd( &p[0], &Point, &p[0] ) ;	VECAdd( &p[1], &Point, &p[1] ) ;
					VECAdd( &p[2], &Point, &p[2] ) ;	VECAdd( &p[3], &Point, &p[3] ) ;

					s = (u16)( ( Vert->scale.x - 1.0F ) * 255 ) ;
					a = (u8)( ( s > 255 ) ? 255 : s ) ; 
					
					// `
					GPV( p[0] ) ;	GC4( R, G, B,a ) ; GT2( TUV, TUV ) ;
					GPV( p[1] ) ;	GC4( R, G, B,a ) ; GT2( UVSCALE-TUV2, TUV ) ;
					GPV( p[3] ) ;	GC4( R, G, B,a ) ; GT2( UVSCALE-TUV2, UVSCALE-TUV2 ) ;
					GPV( p[2] ) ;	GC4( R, G, B,a ) ; GT2( TUV, UVSCALE-TUV2 ) ;
				}
			
				// `揈I
				GXEnd() ;
			}
	
			// XeNX`gpp[c̕`
			if( Obj->XNum != 0 && RenderType != 1 )
			{
				Vec Point, LeftVec, RightVec, DepthVec, p[4] ;
				f32 Length, r ;
				Mtx mtemp ;
				MUZZLEPARTS *Parts ;

				// eNX`̃[h
				GTLOAD2( MuzzleUnion->X1 ) ;
				
				// `Jn
				GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Obj->XNum * 4 ) ) ;
				
				// XeNX`gpĂp[c̐JԂ
				for( j = 0 ; j < Obj->XNum ; j ++ )
				{
					Vert = Obj->XParts[j].JObj ;
					Parts = &Obj->XParts[j] ;

					// WZbg
					Point = Parts->Point ; 
					Length = Vert->scale.z ;
					r = Vert->scale.y ;
					
					s = (u16)( ( Vert->scale.x - 1.0F ) * 255 ) ;
					a = (u8)( ( s > 255 ) ? 255 : s ) ; 

					// ]݂̂𓾂
					memcpy( mtemp, Obj->XParts[j].TransMtx, sizeof( Mtx ) ) ;
					mtemp[0][3] = mtemp[1][3] = mtemp[2][3] = 0.0F ;
					
					// Z𓾂
					DepthVec.y = DepthVec.x = 0.0F ;
					DepthVec.z = 1.0F ;
					MTXMultVec( mtemp, &DepthVec, &DepthVec ) ;
					VECNormalize( &DepthVec, &DepthVec ) ;
					VECScale( &DepthVec, &DepthVec, Length ) ;
					
					// X𓾂
					RightVec.z = RightVec.x = 0.0F ;
					RightVec.y = 1.0F ;
					MTXMultVec( mtemp, &RightVec, &RightVec ) ;
					VECNormalize( &RightVec, &RightVec ) ;
					VECScale( &RightVec, &RightVec, r ) ;
					VECScale( &RightVec, &LeftVec, -1.0F ) ;

					// WZbg
					p[0] = LeftVec ;
					VECAdd( &DepthVec, &LeftVec, &p[1] ) ;
					p[2] = RightVec ;
					VECAdd( &DepthVec, &RightVec, &p[3] ) ;
					
					VECAdd( &p[0], &Point, &p[0] ) ;	VECAdd( &p[1], &Point, &p[1] ) ;
					VECAdd( &p[2], &Point, &p[2] ) ;	VECAdd( &p[3], &Point, &p[3] ) ;

					// `
					GPV( p[0] ) ;	GC4( R, G, B,a ) ; GT2( TUV, UVSCALE-TUV2 ) ;
					GPV( p[1] ) ;	GC4( R, G, B,a ) ; GT2( TUV, TUV ) ;
					GPV( p[3] ) ;	GC4( R, G, B,a ) ; GT2( UVSCALE-TUV2, TUV ) ;
					GPV( p[2] ) ;	GC4( R, G, B,a ) ; GT2( UVSCALE-TUV2, UVSCALE-TUV2 ) ;
				}
			
				// `揈I
				GXEnd() ;
			}

		}
	}
	
	// I
	return 0 ;
}

// ɍ쐬}YtbVJ[gbWGtFNg̉RcɂtOZbg
extern s8 SetMuzzleCartridgeSound3DFlag( void )
{
	MuzUnion.CartridgeEffect3DSoundFlag = TRUE ;
	
	return 0 ;
}


// }YtbVQc|SŃ_O邩tOZbg
extern s8 SetMuzzle2DFlag( u8 Render2DFlag )
{	
	MuzUnion.Render2DFlag = Render2DFlag ;
	
	// I
	return 0 ;
}

extern s8 SetMuzzleNumberUserSetFlag( u8 Flag )
{
	MuzUnion.MuzzleNumberUserSetFlag = Flag ;
	
	return 0 ;
}

extern s8 SetUserMuzzleNumber( u8 Number )
{
	MuzUnion.UserSetMuzzleNumber = Number ;
	
	return 0 ;
}

// }YtbVoĂ邩ǂ擾
extern s8 CheckMuzzleAction( EFFECT *Effect )
{
	MUZZLEEFFECT *Mz ;

	if( GetEffectValidState( Effect ) == FALSE ) return FALSE ;
	if( Effect->Type != EFF_MUZZLE ) return FALSE ;
	Mz = ( MUZZLEEFFECT * )Effect->Data ;

	// tOԂ	
	return Mz->MuzzleFlag ;
}
	



