///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectPetal
//
// YK7EffectPetal.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/22/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectPetal.h"
#include "./YK7EffectLine.h"
#include "./YK7Break.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define PETALPATH		"/yam/effect/petal/h_petal01.BIN"

// data -----------------------------------------

PETALUNION ptu ;
extern LINEUNION LUnion ;

// datatype -------------------------------------

// function proto type --------------------------

static s8 __PatelObjNumCountCallBack( Vec **Pos, void *Data ) ;		// IuWFNg̐𐔂R[obN
static s8 __PatelObjCreateCallBack( Vec **Pos, void *Data ) ;		// IuWFNg쐬R[obN

// function code --------------------------------

// IuWFNg̐𐔂R[obN
static s8 __PatelObjNumCountCallBack( Vec **Pos, void *Data )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Data ;

	// ʐς쐬鐔߂
	pt->objnumcounter += GetPolygonArea( Pos ) * pt->objrate ;

	return 0 ;
}

// IuWFNg쐬R[obN
static s8 __PatelObjCreateCallBack( Vec **Pos, void *Data )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Data ;
	PETALOBJECT *ob ;
	Vec d1, d2, p, pos ;
	f32 x, y, dx, dz ;
	
	p = *Pos[0] ;
	VECSubtract( Pos[1], &p, &d1 ) ;
	VECSubtract( Pos[2], &p, &d2 ) ;

	// ʐς쐬鐔߂
	pt->objnumcounter += GetPolygonArea( Pos ) * pt->objrate ;
	
	// 쐬
	while( pt->objnumcounter >= 1.0F )
	{
		pt->objnumcounter -= 1.0F ;

		ob = &pt->obj[pt->objnum] ;
		
		ob->valid 	= TRUE ;
		ob->upflag 	= FALSE ;

		x 			= GetRandFNum( 1.0F ) ;
		y			= ( 1.0F - x ) * GetRandFNum( 1.0F ) ;
		pos.x		= p.x + d1.x * x + d2.x * y ;
		pos.y		= p.y + d1.y * x + d2.y * y ;
		pos.z		= p.z + d1.z * x + d2.z * y ;
		
		dx			= pos.x - pt->Pos.x ;
		dz			= pos.z - pt->Pos.z ;

		ob->len 	= sqrtf( dx * dx + dz * dz ) ;
		ob->rot		= RCINT( atan2f( dz, dx ) ) ;
		ob->y		= pos.y + 0.01F + GetRandFNum( pt->size * VParam[ED_PETAL][16] * 0.1F ) ;
		ob->ysp		= 0.0F ;

		ob->u		= GetRandINum( 2 ) == 0 ? 0.5F : 0 ;
		ob->v		= GetRandINum( 2 ) == 0 ? 0.5F : 0 ;

		pt->objnum ++ ;		
	}

	return 0 ;
}



// ԕكGtFNg̋ʃf[^
extern s8 InitPetalData( void )
{
	MEMINIT( ptu ) ;
	
//	TexLoadSet( PETALPATH, &ptu.petal ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_h_petal01 ), &ptu.petal ) ;

	return 0 ;
}

// ԕكGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckPetalData( void )
{
//	if( TexLoadChk( &ptu.petal ) == FALSE ) return FALSE ;
	
	return TRUE ;
}

// ԕكGtFNg̋ʃf[^n
extern s8 EndPetalData( void )
{
	TexRelease( &ptu.petal ) ;

	MEMINIT( ptu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// ԕكGtFNg쐬
extern EFFECT *CreatePetalEffect(
								Vec Pos,				// SW

								WK7JObj *areaJObj,		// zuꏊ̃bV JObj
								f32 objarea,			// IuWFNgzu͈( JObj ȏꍇɎg( ݂͔Ή ) )
								f32 objrate,			// Pʖʐς̃IuWFNg̐

								f32 deady,				// ԕق
								
								f32 rotspeed,			// ]x
								f32 size, 				// ԕق̑傫

								s32 rotsspeed,			// ]x
								s32 rotmaxspeed,		// ]ōx

								f32 upsspeed,			// ㏸x
								f32 upmaxspeed,			// ㏸ő呬x
								
								f32 uplen,				// ㏸n߂鋗
								u16 uprotS, u16 uprotE,	// ㏸n߂͈

								f32 lensspeed,			// k܂x
								f32 lenmaxspeed,		// k܂ōx
								s32 Priority )				// ԕكGtFNg쐬
{
	EFFECT *Effect = NULL ;
	PETALEFFECT *pt ;
	PETALOBJECT *obj = NULL ;
	
	MESH *mesh = NULL ;
	BASICMESH *basmesh = NULL ;
	HSD_DObj *dobj ;

	if( areaJObj == NULL ) return NULL ;

	if( areaJObj->GetObj( "FlowerCollision" ) != NULL ) areaJObj = areaJObj->GetObj( "FlowerCollision" ) ;
	dobj = GetHaveMeshDObj( areaJObj->GetJObj() ) ;
	if( dobj == NULL ) return NULL ;

	// Vԕكf[^쐬
	Effect = AddEffectData( EFF_PETAL, (void**)&pt, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( pt, 0, sizeof( PETALEFFECT ) ) ;
	
	// ̃Zbg
	pt->startflag	= false ;
	pt->Pos			= Pos ;

	pt->areaJObj	= areaJObj ;
	pt->objarea		= objarea ;
	pt->objrate		= objrate ;

	pt->obj 		= NULL ;
	pt->objnum		= 0 ;
	pt->objnumcounter = 0 ;

	pt->deady		= deady ;

	pt->rotcount	= 0.0F ;
	pt->rotspeed	= rotspeed ;	
	pt->size		= size ;

	pt->rotsp		= 0 ;
	pt->rotssp		= rotsspeed ;
	pt->rotmaxsp	= rotmaxspeed ;
	
	pt->upssp 		= upsspeed ;
	pt->upmaxsp		= upmaxspeed ;
	
	pt->uplen		= uplen ;
	pt->uprotS		= uprotS ;
	pt->uprotE		= uprotE ;
	
	pt->lensp		= 0.0F ;
	pt->lenssp		= lensspeed ;
	pt->lenmaxsp	= lenmaxspeed ;

	// IuWFNg̍쐬
	{
		if( CreatePrimitiveMeshData( areaJObj->GetJObj(), dobj, dobj->pobj, &mesh,
										FALSE, TRUE, FALSE, FALSE, TRUE ) < 0 ) goto ERR ;
		if( CreateBasicPrimitiveMeshData( mesh, &basmesh, TRUE, FALSE, TRUE, TRUE ) < 0 ) goto ERR ;
		DeletePrimitiveMeshData( mesh ) ;
		mesh = NULL ;
		
		// IuWFNg̐Zo
		ScanMeshPrimitive( basmesh, __PatelObjNumCountCallBack, pt ) ;
		pt->objnum = (s32)( pt->objnumcounter + 1.0F ) ;

		// IuWFNg̃f[^j̍郁̊m
		pt->obj = ( PETALOBJECT * )K7AppSmallMemAllocName( (s32)( pt->objnum * sizeof( PETALOBJECT ) ), "Y_PatObj" ) ;
		if( pt->obj == NULL ) goto ERR ;
		memset( pt->obj, 0, pt->objnum * sizeof( PETALOBJECT ) ) ;
		
		// IuWFNg̍쐬
		pt->objnumcounter = 0.0F ;
		pt->objnum = 0 ;
		ScanMeshPrimitive( basmesh, __PatelObjCreateCallBack, pt ) ;
		DeleteBasicMeshData( basmesh ) ;
		basmesh = NULL ;
	}
	
	pt->updrawnum = 0 ;
	pt->downdrawnum = pt->objnum ;
	pt->counter = 0 ;

	// I
	return Effect ;
	
ERR :
	if( Effect ) DeleteEffect( Effect ) ;
	if( mesh ) DeletePrimitiveMeshData( mesh ) ;
	if( basmesh ) DeleteBasicMeshData( basmesh ) ;
	
	return NULL ;
}

// ԕكGtFNǧns
extern s8 ReleasePetalEffect( EFFECT *Effect )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Effect->Data ;
	
	if( pt->obj != NULL ) K7AppSmallMemFree( pt->obj ) ;

	// I
	return 0 ;
}

// ԕكGtFNgPt[
extern s8 MovePetalEffect( EFFECT *Effect )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Effect->Data ;
	PETALOBJECT *ob ;
	s32 num, i ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE || pt->objnum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	pt->updrawnum = 0 ;
	pt->downdrawnum = 0 ;
	
	if( pt->startflag ) pt->counter ++ ;
	
	// IuWFNg̓
	num = pt->objnum ;
	ob = pt->obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->valid == 0 ) continue ;
		
		i ++ ;
		
		if( pt->startflag )
		{
//			ob->len -= ob->len / (f32)VParam[ED_PETAL][13] * pt->lensp ;
			ob->len -= pt->lensp ;
//			if( ob->len < 0.0F ) ob->len = 0.0F ; 
			ob->rot = IROTSAFE( (s32)( ob->rot + pt->rotsp * ob->len * 0.01F ) ) ;
		
			if( ob->upflag == TRUE )
			{
				if( ob->ysp < pt->upmaxsp ) ob->ysp += pt->upssp ;
				ob->y += ob->ysp ;
				
				if( ob->y > pt->deady )
				{
					ob->valid = FALSE ;
					pt->objnum -- ;
				}
				else
				{
					pt->updrawnum ++ ;
				}
			}
			else
			{
				s16 zure ;
				
				zure = (s16)( ob->len / pt->uplen * PI2DIV ) ;
			
				if( ob->len < pt->uplen &&
					( ( ob->rot >= pt->uprotS + zure && ob->rot <= pt->uprotE + zure ) ||
						( ob->rot >= pt->uprotS + zure - PI2DIV && ob->rot <= pt->uprotE + zure - PI2DIV ) )
					|| ( GetRandINum( 1000 ) < VParam[ED_PETAL][15] ) || ( pt->counter > VParam[ED_PETAL][17] ) )
				{
					ob->upflag = TRUE ;
					ob->ysp = GetRandFNum( pt->upssp ) ;
					ob->y += GetRandFNum( pt->upssp ) ;

					pt->updrawnum ++ ;
				}
				else
				{
//					pt->downdrawnum ++ ;
					pt->updrawnum ++ ;
				}
			}
		}
		else
		{
			if( ob->upflag == TRUE )
			{
				pt->updrawnum ++ ;
			}
			else
			{
//				pt->downdrawnum ++ ;
				pt->updrawnum ++ ;
			}
		}
	}

	// 
	if( pt->startflag )
	{
		pt->rotsp += pt->rotssp ;
		if( pt->rotsp > pt->rotmaxsp ) pt->rotsp = pt->rotmaxsp ;
		
		pt->lensp += pt->lenssp ;
		if( pt->lensp > pt->lenmaxsp ) pt->lensp = pt->lenmaxsp ;

		pt->rotcount += pt->rotspeed ;
		if( pt->rotcount > PI_2 ) pt->rotcount -= PI_2 ;
	}
	
	// I
	return 0 ;
}

// ԕكGtFNg`悷
extern s8 DrawPetalEffect( EFFECT *Effect )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Effect->Data ;
	PETALOBJECT *ob ;
	Vec tv[4], pos ;
	s32 drawnum, matinum ;
	s32 i ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	GXSetZMode( GX_TRUE, GX_LEQUAL, GX_ENABLE ) ;
	GXSetAlphaCompare( GX_GEQUAL, 80, GX_AOP_AND, GX_ALWAYS, 0 ) ;
	
	// eNX`̃[h
	GTLOAD2( ptu.petal ) ;
	
	// łԕق`悷
	if( pt->updrawnum != 0 )
	{
		matinum = pt->updrawnum ;
		
		// r{[h_쐬
		CreateBillVert( NULL, tv, pt->size * 0.5F, pt->size * 0.5F, pt->rotcount ) ;		// r{[h_쐬

		// `Jn
		drawnum = matinum ;
		if( drawnum * 4 > 65535 ) drawnum = 65535 / 4 ;
		matinum -= drawnum ;
		
		GBGN( GX_QUADS, drawnum * 4 ) ;
		
		ob = pt->obj ;
		for( i = 0 ; i < pt->updrawnum ; ob ++ )
		{
//			if( ob->valid == FALSE || ob->upflag == FALSE ) continue ;
			if( ob->valid == FALSE  ) continue ;
			
			i ++ ;
			
			pos.x = COS( ob->rot ) * ob->len + pt->Pos.x ;
			pos.y = ob->y ;
			pos.z = SIN( ob->rot ) * ob->len + pt->Pos.z ;
			
			GPV3( tv[0], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u, 			ob->v ) ;
			GPV3( tv[1], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u + 0.5F, 	ob->v ) ;
			GPV3( tv[2], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u + 0.5F, 	ob->v + 0.5F ) ;
			GPV3( tv[3], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u, 			ob->v + 0.5F ) ;
			
			drawnum -- ;
			if( drawnum == 0 )
			{
				GEND() ;
				if( matinum != 0 )
				{
					drawnum = matinum ;
					if( drawnum * 4 > 65535 ) drawnum = 65535 / 4 ;
					matinum -= drawnum ;
					
					GBGN( GX_QUADS, drawnum * 4 ) ;
				}
			}
		}
	}
	
	// nʂɗĂԕق`悷
/*	if( pt->downdrawnum != 0 )
	{
		matinum = pt->downdrawnum ;

		tv[0].x = -pt->size * 0.5F ;	tv[0].y = 0.0F ;	tv[0].z = -pt->size  * 0.5F ;
		tv[1].x = pt->size * 0.5F ;		tv[1].y = 0.0F ;	tv[1].z = -pt->size  * 0.5F ;
		tv[2].x = pt->size * 0.5F ;		tv[2].y = 0.0F ;	tv[2].z = pt->size  * 0.5F ;
		tv[3].x = -pt->size * 0.5F ;	tv[3].y = 0.0F ;	tv[3].z = pt->size  * 0.5F ;

		// `Jn
		drawnum = matinum ;
		if( drawnum * 4 > 65535 ) drawnum = 65535 / 4 ;
		matinum -= drawnum ;
		
		GBGN( GX_QUADS, drawnum * 4 ) ;
		
		ob = pt->obj ;
		for( i = 0 ; i < pt->downdrawnum ; ob ++ )
		{
			if( ob->valid == FALSE || ob->upflag == TRUE ) continue ;
			
			i ++ ;
			
			pos.x = COS( ob->rot ) * ob->len + pt->Pos.x ;
			pos.y = ob->y ;
			pos.z = SIN( ob->rot ) * ob->len + pt->Pos.z ;
			
			GPV3( tv[0], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u, 			ob->v ) ;
			GPV3( tv[1], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u + 0.5F, 	ob->v ) ;
			GPV3( tv[2], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u + 0.5F, 	ob->v + 0.5F ) ;
			GPV3( tv[3], pos ) ;	GCX( 0xffffffff ) ;	GT( ob->u, 			ob->v + 0.5F ) ;
			
			drawnum -- ;
			if( drawnum == 0 ) GEND() ;
			if( matinum != 0 )
			{
				drawnum = matinum ;
				if( drawnum * 4 > 65535 ) drawnum = 65535 / 4 ;
				matinum -= drawnum ;
				
				GBGN( GX_QUADS, drawnum * 4 ) ;
			}
		}
	}
*/
	// I
	return 0 ;
}

// ԕكGtFNgJn
extern s8 SetPetalEffectStart( EFFECT *Effect )
{
	PETALEFFECT *pt = ( PETALEFFECT * )Effect->Data ;
	
	pt->startflag = true ;
	return 0 ;
}

