///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectRain
//
// YK7EffectRain.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTRAIN_H
#define __YK7EFFECTRAIN_H

// include --------------------------------------
#include "./YK7Effect.h"
#include "./YK7Break.h"

// define ---------------------------------------

// datatype -------------------------------------

// JGtFNgʃf[^
typedef struct tagRAINUNION
{
	TEXDATA RainTex ;					// J̃eNX`f[^

	s8 NotAllDrawFlag ;					// `tO
	WK7JObj *Collision2JObj ;			// U邯ǍႤp̃bVin
} RAINUNION ;

// JIuWFNgf[^
typedef struct tagRAINOBJECT
{
	u8 ValidFlag ;				// LtO
	u8 BotFlag ;				// ntO
	u8 YukaIndex ;				// ̍tO
	Vec Point ;					// W
	Vec Speed ;					// Xs[h
	u16 Counter ;				// JE^[
} RAINOBJECT ;

// JGtFNgf[^
typedef struct tagRAINEFFECT
{
	RAINOBJECT *ObjP ;				// JIuWFNgf[^zւ̃|C^
	u16 *RenderList ;				// `惊Xg
	u16 RenderNum ;					// `搔
	u16 *BotRenderList ;			// nXg
	u16 BotRenderNum ;				// n
	u16 ObjNum ;					// JIuWFNg̐
	u16 Counter ;					// pJE^[
	u8 Mode ;						// `惂[h(0:Add  1:Alpha)

	u16 MaxObjNum ;					// IuWFNg̍ő吔
	Vec Point ;						// W
	f32 DownSpeed ;					// J鑬x
	f32 DownSSpeed ;				// Jx
	f32 RainR ;						// J~锼a
	f32 YukaY[3] ;					// ̍
	f32 LineWidth ;					// ̑
	f32 LineLen ;					// ̒
	GXColor Color ;					// F

	f32 RainCounter ;				// J~点JE^
	f32 OneRainPoint ;				// JꖇôɕKvȃJEgl
	s32 ValidCounter ;
	s32 VertCounter ;				// _JE^[
	
	f32 BiasAlpha ;					// At@̕␳l
	
	BASICMESH *Mesh ;				// 蔻pbVf[^
	POSINDEXPOINTLIST PIPList ;		// _|CgXg
	BASICMESH *Mesh2 ;				// U邯Ǎw^蔻pbVf[^
	POSINDEXPOINTLIST PIPList2 ;	// _|CgXgQ
} RAINEFFECT ;

// JGtFNg^XNɓnf[^
typedef struct tagRAINEFFECTTACKPARAM
{
	u16 MaxNum ;					// JIuWFNg̍ő吔
	Vec Point ;						// JGtFNg郏[hW
	f32 DownSpeed ;					// J鑬x
	f32 DownSSpeed ;				// Jx
	f32 RainR ;						// J~锼a
	f32 LineWidth ;					// ̑
	f32 LineLen ;					// ̒
	GXColor *Color ;				// F
	WK7JObj *JObj ;					// J~炳ȂbVĂ JObj ւ̃|C^
} RAINEFFECTTASKPARAM ;

// prototype ------------------------------------

extern s8 InitRainData( void ) ;				// JGtFNg̋ʃf[^
extern s8 CheckRainData( void ) ;				// JtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndRainData( void ) ;					// JGtFNg̋ʃf[^n

extern EFFECT *CreateRainEffect( Vec Point, f32 YukaY,
									f32 DownSpeed, f32 DownSSpeed,
									f32 RainR, u16 MaxNum,
									f32 LineWidth, f32 LineLen,
									GXColor *Color, WK7JObj *JObj = NULL,
									f32 BiasAlpha = 1.0F, s32 Priority = -130 ) ;	// J̃GtFNg쐬
extern s8 ReleaseRainEffect( EFFECT *Effect ) ;							// J̃GtFNǧns
extern s8 MoveRainEffect( EFFECT *Effect ) ;							// J̃GtFNgPt[
extern s8 DrawRainEffect( EFFECT *Effect ) ;							// J̃GtFNg`悷

extern s8 SetRainEffectPoint( EFFECT *Effect, Vec Point ) ;				// J钆S_ύX
extern s8 SetRainCollision2JObj( WK7JObj *JObj ) ;						// ̍Ⴄʒu񃁃bV JObj o^

extern s8 SetRainAllDrawFlag( s8 Flag ) ;								// JGtFNg̑SĂ`悷邩ǂ̃tOZbg
extern s8 SetRainObjectCreateSpeed( EFFECT *Effect, s32 CreateNum ) ;	// Pt[ō쐬J̗ʂύX

#endif

