///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSeenSound
//
// YK7EffectSeenSound.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectSeenSound.h"

// define ---------------------------------------

// data -----------------------------------------

SEENSOUNDUNION ssndu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// 鉹GtFNg̋ʃf[^
extern s8 InitSeenSoundData( void )
{
	MEMINIT( ssndu ) ;

	return 0 ;
}

// 鉹GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSeenSoundData( void )
{
	return TRUE ;
}

// 鉹GtFNg̋ʃf[^n
extern s8 EndSeenSoundData( void )
{
	MEMINIT( ssndu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// 鉹GtFNg쐬
extern EFFECT *CreateSeenSoundEffect(
									Vec pos,							// W
									u32 crewait,						// 쐬҂
									u32 time,							// \
									f32 outspeed,						// 鑬x
									f32 width,							// 
									GXColor color1, GXColor color2,		// F
									f32 speed,							// x
									bool oneflag,						// ̂݃tO
									s32 Priority )				// 鉹GtFNg쐬
{
	EFFECT *Effect ;
	SEENSOUNDEFFECT *sd ;
	
	// V鉹f[^쐬
	Effect = AddEffectData( EFF_SEENSOUND, (void**)&sd, Priority ) ;
	if( Effect == NULL ) return NULL ;
	memset( sd, 0, sizeof( *sd ) ) ;

	// ̏
	sd->pos = pos ;
	sd->objnum = 0 ;
	sd->crecounter = crewait ;
	sd->crewait = crewait ;
	
	sd->alpha = time * outspeed + 1.0F ;
	sd->alphaspeed = outspeed ;
	sd->speed = speed ;
	sd->color1 = *((u32 *)&color1 ) ;
	sd->color2 = *((u32 *)&color2 ) ;
	sd->width = width ;
	sd->oneflag = oneflag ;

	// I
	return Effect ;
}

// 鉹GtFNǧns
extern s8 ReleaseSeenSoundEffect( EFFECT *Effect )
{
	SEENSOUNDEFFECT *sd = ( SEENSOUNDEFFECT * )Effect->Data ;

	// I
	return 0 ;
}

// 鉹GtFNgPt[
extern s8 MoveSeenSoundEffect( EFFECT *Effect )
{
	SEENSOUNDEFFECT *sd = ( SEENSOUNDEFFECT * )Effect->Data ;
	SEENSOUNDOBJECT *ob ;
	s32 i ;
	u32 num ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE && sd->objnum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// 
	ob = sd->obj ;
	num = sd->objnum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == 0 ) continue ;
		
		i ++ ;
		ob->r += sd->speed ;
		ob->alpha -= sd->alphaspeed ;
		if( ob->alpha < 0.0F )
		{
			ob->vflag = 0 ;
			sd->objnum -- ;
		}
	}
	
	// 쐬
	if( Effect->DelReqFlag == FALSE && sd->objnum < SEENSOUND_MAXOBJNUM )
	{
		sd->crecounter ++ ;
		if( sd->crecounter > sd->crewait )
		{
			sd->crecounter = 0 ;
			
			for( ob = sd->obj ; ob->vflag == 1 ; ob ++ ){}
			ob->vflag = 1 ;
			ob->r = 0.0F ;
			ob->alpha = sd->alpha ;
			
			sd->objnum ++ ;
			
			if( sd->oneflag == true )
			{
				DelReqEffect( Effect ) ;
				return 0 ;
			}
		}
	}

	// I
	return 0 ;
}

// 鉹GtFNg`悷
extern s8 DrawSeenSoundEffect( EFFECT *Effect )
{
	SEENSOUNDEFFECT *sd = ( SEENSOUNDEFFECT * )Effect->Data ;
	SEENSOUNDOBJECT *ob ;
	Vec *tv = ( Vec * )WorkBuffer ;
	u32 divnum, i, j ;
	f32 x, y, z, alpha ;
	u32 c1, c2 ;
	Mtx tmtx ;

	if( VParam[ED_SEENSOUND][0] < 3 ) VParam[ED_SEENSOUND][0] = 3 ;
	divnum = VParam[ED_SEENSOUND][0] ;

	if( sd->objnum == 0 ) return 0 ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_NOTEX ) ;
	GXSetZMode( GX_FALSE, GX_LESS, GX_FALSE ) ;

	x = sd->pos.x ;
	y = sd->pos.y ;
	z = sd->pos.z ;
	
	// ]us擾
	EffectGetInvViewMatrix( tmtx ) ;
	
	// 
	for( i = 0 ; i < divnum ; i ++ )
	{
		tv[i].x = COSF( PI_2 / ( divnum - 1 ) * i ) ;
		tv[i].y = SINF( PI_2 / ( divnum - 1 ) * i ) ;
		tv[i].z = 0.0F ;
		
		MTXMultVec( tmtx, &tv[i], &tv[i] ) ;
	}

	// `Jn
	GBGN( GX_TRIANGLESTRIP, sd->objnum * ( divnum * 2 ) + ( sd->objnum - 1 ) * 2 ) ;

	ob = sd->obj ;
	for( i = 0 ; i < sd->objnum ; ob ++ )	
	{
		if( ob->vflag == 0 ) continue ;
		
		if( i > 0 )
		{
			GP3( tv[0].x * ob->r + x, 					tv[0].y * ob->r + y, 					tv[0].z * ob->r + z ) ;					GCX( 0 ) ;
		}

		// ~`		
		alpha = ob->alpha ;
		if( alpha > 1.0F ) alpha = 1.0F ;
		c1 = CMKC2( sd->color1, ( sd->color1 & 0xff ) * alpha ) ;
		c2 = CMKC2( sd->color2, ( sd->color2 & 0xff ) * alpha ) ;
		
		for( j = 0 ; j < divnum ; j ++ )
		{
			GP3( tv[j].x * ob->r + x, 					tv[j].y * ob->r + y, 					tv[j].z * ob->r + z ) ;					GCX( c1 ) ;
			GP3( tv[j].x * ( ob->r + sd->width ) + x, 	tv[j].y * ( ob->r + sd->width ) + y, 	tv[j].z * ( ob->r + sd->width ) + z ) ;	GCX( c2 ) ;
		}
		
		if( i < sd->objnum - 1 )
		{
			GP3( tv[divnum-1].x * ( ob->r + sd->width ) + x, 	tv[divnum-1].y * ( ob->r + sd->width ) + y, 	tv[divnum-1].z * ( ob->r + sd->width ) + z ) ;	GCX( 0 ) ;
		}

		i ++ ;
	}

	// `I	
	GEND() ;

	// I
	return 0 ;
}

