///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectShot
//
// YK7EffectShot.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectShot.h"
#include "./YK7EffectFlyBullet.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_SHOT]

#define AINUM			((s32)PRM[10])			// c̐
#define AIALPHA			((f32)PRM[11] * 0.01F)	// c̃
#define AIAREA			((f32)PRM[12] * 0.01F)	// c͈̔

// data -----------------------------------------

SHOTUNION shtu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// VbgGtFNg̋ʃf[^
extern s8 InitShotData( void )
{
	MEMINIT( shtu ) ;

	return 0 ;
}

// VbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckShotData( void )
{
	return TRUE ;
}

// VbgGtFNg̋ʃf[^n
extern s8 EndShotData( void )
{
	MEMINIT( shtu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}




// VbgGtFNg쐬
extern EFFECT *CreateShotEffect(
								u32 color,			// F
								f32 size,			// TCY
								bool addflag,		// ZtO
								s32 drawtime,		// `掞
								f32 alphaspeed,		// x
								s32 maxnum,			// ő吔
								u32	flashcolor,		// ě
								s32	sound,			// e
								s32 Priority )		// VbgGtFNg쐬
{
	EFFECT *Effect ;
	SHOTEFFECT *st ;
	SHOTOBJECT *ob ;

	// ̊m
	ob = ( SHOTOBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( SHOTOBJECT ) * maxnum ), "Y_StObj" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( SHOTOBJECT ) * maxnum ) ;

	// VVbgf[^쐬
	Effect = AddEffectData( EFF_SHOT, (void**)&st, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}
	
	// lۑ
	st->obj 		= ob ;
	st->objnum 		= 0 ;
	st->maxobjnum 	= maxnum ;
	
	st->color 		= color ;
	st->size 		= size ;
	st->addflag 	= addflag ;
	
	st->alpha		= drawtime * alphaspeed + 1.0F ;
	st->alphaspeed	= alphaspeed ;
	
	st->wallvalid 	= false ;
	st->addratecon	= 0 ;
	
	st->flashcolor	= flashcolor ;
	st->sound		= sound ;

	// I
	return Effect ;
}

// VbgGtFNǧns
extern s8 ReleaseShotEffect( EFFECT *Effect )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	
	// ̉
	if( st->obj != NULL ) K7AppSmallMemFree( st->obj ) ;
	st->obj = NULL ;

	// I
	return 0 ;
}

// VbgGtFNgPt[
extern s8 MoveShotEffect( EFFECT *Effect )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	SHOTOBJECT *ob ;
	s32 num, i ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && st->objnum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// VbgIuWFNgSď
	ob = st->obj ;
	num = st->objnum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->validf == 0 ) continue ;
		
		i ++ ;
		
		// ړ
		if( ob->initflag == 0 )
		{
			f32 f ;
			
			f = GetRandFNum( 1.0F ) ;
			ob->pos.x += ob->speed2.x * f ;
			ob->pos.y += ob->speed2.y * f ;
			ob->pos.z += ob->speed2.z * f ;

			ob->initflag = 1 ;
			st->addratecon ++ ;
			if( st->addratecon >= 5 ) st->addratecon = 0 ;
		}
		else
		{
			ob->pos.x += ob->speed2.x ;
			ob->pos.y += ob->speed2.y ;
			ob->pos.z += ob->speed2.z ;
		}
		
		// J
		ob->alpha -= st->alphaspeed ;
		if( ob->alpha <= 0.0F )
		{
			ob->validf = 0 ;
			st->objnum -- ;
			continue ;
		}
		
		// 蔻
		if( st->wallvalid == true )
		{
			Vec hitpos ;
			f32 t ;
		
			if( ob->pos.x < st->xmin ){ t = ( st->xmin - ob->pos.x ) / ob->speed2.x ; }
			else if( ob->pos.x > st->xmax ){ t = ( ob->pos.x - st->xmax ) / ob->speed2.x ; }
			else if( ob->pos.y < st->ymin ){ t = ( st->ymin - ob->pos.y ) / ob->speed2.y ; }
			else if( ob->pos.y > st->ymax ){ t = ( ob->pos.y - st->ymax ) / ob->speed2.y ; }
			else if( ob->pos.z < st->zmin ){ t = ( st->zmin - ob->pos.z ) / ob->speed2.z ; }
			else if( ob->pos.z > st->zmax ){ t = ( ob->pos.z - st->zmax ) / ob->speed2.z ; }
			else continue ;

			// qbgꏊ̎Zo
			hitpos.x = ob->pos.x - ob->speed2.x * t ;
			hitpos.y = ob->pos.y - ob->speed2.y * t ;
			hitpos.z = ob->pos.z - ob->speed2.z * t ;
			
			// e
			if( st->sound != -1 ) PlayEffectSE3D( st->sound, hitpos ) ;
			
			// eGtFNgo
			CreateFlyBulletEffect( 
								hitpos,						// pos
								*((GXColor *)&st->color),	// color
								2.5F,						// power
								2.1F,						// gravity
								st->ymin,					// yukay
								0.5F,						// bias
								st->flashcolor
								 ) ;
			
			ob->validf = 0 ;
			st->objnum -- ;
			continue ;
		}
	}

	// I
	return 0 ;
}

// VbgGtFNg`悷
extern s8 DrawShotEffect( EFFECT *Effect )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	SHOTOBJECT *ob ;
	Mtx mt ;
	Vec tv[4], pos ;
	s32 i, j ;
	f32 t ;
	u32 color ;

	if( st->objnum == 0 ) return 0 ;

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;
    GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;

	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;
	
	// _̍쐬
	CreateBillVert( mt, tv, st->size, st->size, GetRandFNum( PI_2 ) ) ;
	
	// eNX`̃[h
	GTLOAD( &GetBillboardImage( BILLID_SPFIRE2 )->TexObj ) ;
	
	// F̏
	color = CMKC2( st->color, ( st->color & 0xff ) * AIALPHA ) ;
	
	// SẴIuWFNg`
	GBGN( GX_QUADS, ( st->objnum * 4 ) * AINUM ) ;
	ob = st->obj ;
	for( i = 0 ; i < st->objnum ; ob ++ )
	{
		if( ob->validf == 0 ) continue ;

		i ++ ;

		// c`		
		t = 0.0F ;
		for( j = 0 ; j < AINUM ; j ++, t += 1.0F / AINUM )
		{
			pos.x = ob->pos.x - ob->speed2.x * t * AIAREA ;
			pos.y = ob->pos.y - ob->speed2.y * t * AIAREA ;
			pos.z = ob->pos.z - ob->speed2.z * t * AIAREA ;
		
			GPV3( tv[0], pos ) ;	GCX( color ) ;	GT( 0.0F, 0.0F ) ;
			GPV3( tv[1], pos ) ;	GCX( color ) ;	GT( 1.0F, 0.0F ) ;
			GPV3( tv[2], pos ) ;	GCX( color ) ;	GT( 1.0F, 1.0F ) ;
			GPV3( tv[3], pos ) ;	GCX( color ) ;	GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;

	// I
	return 0 ;
}

// VbgGtFNgǉ
extern s8 AddShotEffect( EFFECT *Effect, Vec pos, Vec dir, f32 speed )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	SHOTOBJECT *ob ;
	
	// tǉ
	if( st->objnum == st->maxobjnum ) return 0 ;
	
	// gĂȂIuWFNgT
	for( ob = st->obj ; ob->validf == 1 ; ob ++ ){}

	// 
	ob->validf 		= 1 ;
	ob->pos 		= pos ;
	ob->dir 		= dir ;
	ob->speed 		= speed ;
	ob->alpha 		= st->alpha ;
	ob->speed2.x 	= dir.x * speed ;
	ob->speed2.y 	= dir.y * speed ;
	ob->speed2.z 	= dir.z * speed ;
	ob->initflag	= 0 ;
	
	// CNg
	st->objnum ++ ;
	
	// I
	return 0 ;
}

// ǂݒ肷
extern s8 SetShotEffectWall( EFFECT *Effect, f32 xmin, f32 xmax, f32 ymin, f32 ymax, f32 zmin, f32 zmax )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;

	// ǂ̏Lɂ
	st->wallvalid = true ;
	st->xmin = xmin ;
	st->xmax = xmax ;
	st->ymin = ymin ;
	st->ymax = ymax ;
	st->zmin = zmin ;
	st->zmax = zmax ;

	// I
	return 0 ;	
}

// LȃVbg񋓂
extern s8 EnumShotEffect( EFFECT *Effect, s8 (*callback)( SHOTOBJECT *obj, void *data ), void *data )
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	SHOTOBJECT *ob ;
	s32 i ;
	
	if( st->objnum == 0 ) return 0 ;
	
	// 񋓂
	ob = st->obj ;
	for( i = 0 ; i < st->objnum ; ob ++ )
	{
		if( ob->validf == 0 ) continue ;
		
		i ++ ;
		
		// R[obNĂ
		if( callback( ob, data ) != 0 ) break ;
	}
	
	// I
	return 0 ;
}

// Vbg̕ύX
extern s8 ChangeShotInfo( EFFECT *Effect,
							u32 	color,		// F
							f32 	size		// TCY
							)
{
	SHOTEFFECT *st = ( SHOTEFFECT * )Effect->Data ;
	
	st->color = color ;
	st->size = size ;
	
	// I
	return 0 ;
}

