///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectShot
//
// YK7EffectShot.h
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/04/2004
//
//////////////////////////////////////////////////////////////////////////////

#ifndef __YK7EFFECTSHOT_H
#define __YK7EFFECTSHOT_H

// include --------------------------------------
#include "./YK7Effect.h"

// define ---------------------------------------

// datatype -------------------------------------

// VbgGtFNgʃf[^
typedef struct tagSHOTUNION
{
	u8 dummy ;
} SHOTUNION ;

// VbgIuWFNgf[^
typedef struct tagSHOTOBJECT
{
	s8 validf ;
	s8 initflag ;
	Vec dir ;
	Vec speed2 ;
	Vec pos ;
	f32 alpha ;
	f32 speed ;
} SHOTOBJECT ;

// VbgGtFNgf[^
typedef struct tagSHOTEFFECT
{
	SHOTOBJECT *obj ;
	s32 objnum ;
	s32 maxobjnum ;

	u32 color ;			// F
	f32 size ;			// TCY
	bool addflag ;		// ZtO
	f32 alpha ;			// 
	f32 alphaspeed ;	// x
	
	s32 addratecon ;	// WZlJE^

	bool wallvalid ;	// Ǐ
	f32 xmin, xmax, zmin, zmax, ymin, ymax ;
	
	u32 flashcolor ;	// ě
	s32 sound ;			// e
} SHOTEFFECT ;



// prototype ------------------------------------

extern s8 InitShotData( void ) ;			// VbgGtFNg̋ʃf[^
extern s8 CheckShotData( void ) ;			// VbgGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 EndShotData( void ) ;				// VbgGtFNg̋ʃf[^n

extern EFFECT *CreateShotEffect( 
								u32 	color 		= 0xffffffff,	// F
								f32 	size 		= 0.157F,		// TCY
								bool 	addflag 	= true,			// ZtO
								s32 	drawtime 	= 60,			// `掞
								f32 	alphaspeed 	= 0.1F,			// x
								s32 	maxnum 		= 100,			// ő吔
								u32		flashcolor	= CMK( 247, 189, 119, 200 ),	// ě
								s32		sound		= -1,			// e
								s32 Priority = -2 ) ;			// VbgGtFNg쐬

extern s8 ReleaseShotEffect( EFFECT *Effect ) ;					// VbgGtFNǧns
extern s8 MoveShotEffect( EFFECT *Effect ) ;					// VbgGtFNgPt[
extern s8 DrawShotEffect( EFFECT *Effect ) ;					// VbgGtFNg`悷

extern s8 AddShotEffect( EFFECT *Effect, Vec pos, Vec dir, f32 speed = 13.9F) ;				// VbgGtFNgǉ
extern s8 SetShotEffectWall( EFFECT *Effect, f32 xmin, f32 xmax,
											 f32 ymin, f32 ymax,
											 f32 zmin, f32 zmax ) ;							// ǂݒ肷
extern s8 EnumShotEffect( EFFECT *Effect,
							s8 (*callback)( SHOTOBJECT *obj, void *data ), void *data ) ;	// LȃVbg񋓂
extern s8 ChangeShotInfo( EFFECT *Effect,
							u32 	color = 0xffffffff,	// F
							f32 	size = 0.157F		// TCY
							) ;							// Vbg̕ύX

#endif

