///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSmoke2
//
// YK7EffectSmoke2.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 06/09/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectSmoke2.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_SMOKE2]

// data -----------------------------------------

SMOKE2UNION sm2u ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// QGtFNg̋ʃf[^
extern s8 InitSmoke2Data( void )
{
	MEMINIT( sm2u ) ;

	return 0 ;
}

// QGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSmoke2Data( void )
{
	return TRUE ;
}

// QGtFNg̋ʃf[^n
extern s8 EndSmoke2Data( void )
{
	MEMINIT( sm2u ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// QGtFNg쐬
extern EFFECT *CreateSmoke2Effect(
								Vec pos,				// W
								s32 maxnum,				// IuWFNg̍ő吔

								f32 yspeed,				// ㏸x
								f32 xspeed,				// ɐiޑ
								f32 rot1sp, f32 rot2sp,	// x

								f32 crerate,			// 쐬x
								
								f32 size,				// PIuWFNg̃TCY

								f32 maxalpha,			// ő̃At@l
								f32 upalphaspeed,		// At@l㏸鑬x
								f32 downalphaspeed,		// At@l~鑬x
								
								u32 color,				// F
								f32 createarea,			// 쐬͈
								
								s32 dietime,			// GtFNĝ܂ł̎
								s32 Priority )
{
	EFFECT *Effect ;
	SMOKE2EFFECT *sb ;
	SMOKE2OBJECT *ob ;
	
	ob = ( SMOKE2OBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( SMOKE2OBJECT ) * maxnum ), "Y_SMO2OB" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( SMOKE2OBJECT ) * maxnum ) ;

	// VQf[^쐬
	Effect = AddEffectData( EFF_SMOKE2, (void**)&sb, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}
	
	// lۑ
	sb->pos				= pos ;
	sb->obj 			= ob ;
	sb->num 			= 0 ;
	sb->maxnum 			= maxnum ;
	sb->xspeed 			= xspeed ;
	sb->yspeed 			= yspeed ;
	sb->rot1			= 0.0F ;
	sb->rot2 			= 0.0F ;
	sb->rot1sp			= rot1sp ;
	sb->rot2sp			= rot2sp ;
	sb->crerate			= crerate ;
	sb->crecounter		= 0.0F ;
	sb->size 			= size ;
	sb->maxalpha 		= maxalpha ;
	sb->upalphaspeed 	= upalphaspeed ;
	sb->downalphaspeed 	= downalphaspeed ;
	sb->color 			= color ;	
	sb->dietime			= dietime ;
	sb->diecounter		= 0 ;
	sb->alpha			= 1.0F ;
	sb->createarea		= createarea ;
	sb->maxalphacon		= 0.0F ;

	// I
	return Effect ;
}

// QGtFNǧns
extern s8 ReleaseSmoke2Effect( EFFECT *Effect )
{
	SMOKE2EFFECT *sb = ( SMOKE2EFFECT * )Effect->Data ;
	
	if( sb->obj != NULL ) K7AppSmallMemFree( sb->obj ) ;

	// I
	return 0 ;
}

// QGtFNgPt[
extern s8 MoveSmoke2Effect( EFFECT *Effect )
{
	SMOKE2EFFECT *sb = ( SMOKE2EFFECT * )Effect->Data ;
	SMOKE2OBJECT *ob ;
	s32 i, num ;
	f32 rot1, rot2 ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE )
	{
		sb->alpha -= sb->downalphaspeed ;
		if( sb->alpha < 0.0F )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
	}
	
	if( Effect->DelReqFlag == FALSE && sb->dietime != -1 )
	{
		sb->diecounter ++ ;
		if( sb->dietime <= sb->diecounter )
		{
			DelReqEffect( Effect ) ;
		}
	}

	// S̃IuWFNg
	num = sb->num ;
	ob = sb->obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->vflag == FALSE ) continue ;
		
		i ++ ;
		
		ob->pos.x += ob->speed.x ;
		ob->pos.y += ob->speed.y ;
		ob->pos.z += ob->speed.z ;
		
		if( ob->maxalphaflag == TRUE )
		{
			ob->alpha -= ob->downalphaspeed ;
			if( ob->alpha <= 0.0F )
			{
				ob->vflag = FALSE ;
				sb->num -- ;
			}
		}
		else
		{
			ob->alpha += ob->upalphaspeed ;
			if( ob->alpha >= sb->maxalpha )
			{
				ob->maxalphaflag = TRUE ;
			}
		}
	}
	
	// ]l̐
	sb->rot1 += ( rot1 = sb->rot1sp * GetRandFNum( 1.0F ) ) ;	if( sb->rot1 > PI_2 ) sb->rot1 -= PI_2 ;
	sb->rot2 += ( rot2 = sb->rot2sp * GetRandFNum( 1.0F ) ) ;	if( sb->rot2 > PI_2 ) sb->rot2 -= PI_2 ;
	
	// IuWFNg̒ǉ
	if( sb->num < sb->maxnum )
	{
		s32 cnum ;
		f32 rate, sprate, xzrot, len ;
		
		sb->crecounter += 1.0F ;

		cnum = (s32)( sb->crecounter / sb->crerate ) ;
		for( i = 0 ; i < cnum ; i ++ )
		{
			if( sb->num >= sb->maxnum ) break ;

			sb->crecounter -= sb->crerate ;
			sb->num ++ ;
		
			for( ob = sb->obj ; ob->vflag ; ob ++ ){}

			rate = (f32)i / cnum ;
			
			// f[^
			ob->vflag = TRUE ;
			
			ob->maxalpha = sb->maxalphacon ;

			ob->speed.y = sb->yspeed ;
			sprate = SINF( sb->rot2 * rate ) * 0.5F + 0.5F ;
			ob->speed.x = SINF( sb->rot1 + - rot1 * rate ) * sb->xspeed * sprate ;
			ob->speed.z = COSF( sb->rot1 + - rot1 * rate ) * sb->xspeed * sprate ;

			ob->pos = sb->pos ;
			{
				s32 r, g, b, rnd ;
				GXColor cr ;
				
				rnd = GetRandINum( 20 ) - 10 ;
				cr = *((GXColor *)&sb->color) ;
				r = cr.r + rnd ;
				if( r > 255 ) r = 255 ; else if( r < 0 ) r = 0 ;
				g = cr.g + rnd ;
				if( g > 255 ) g = 255 ; else if( g < 0 ) g = 0 ;
				b = cr.b + rnd ;
				if( b > 255 ) b = 255 ; else if( b < 0 ) b = 0 ;
				ob->color = CMK( r, g, b, cr.a ) ;
			}
			
			xzrot = GetRandFNum( PI_2 ) ;
			len = GetRandFNum( sb->createarea ) ;

			ob->pos.x += SINF( xzrot ) * len ;
			ob->pos.z += COSF( xzrot ) * len ;

			ob->pos.x += ob->speed.x * rate ;
			ob->pos.y += ob->speed.y * rate ;
			ob->pos.z += ob->speed.z * rate ;
			
			ob->alpha = 0.0F ;
			ob->downalphaspeed = GetRandF2Num( sb->downalphaspeed, sb->downalphaspeed * 0.9F ) + 0.01F ;
			ob->upalphaspeed = GetRandF2Num( sb->upalphaspeed, sb->upalphaspeed * 0.9F ) + 0.01F ;
			
			ob->maxalphaflag = FALSE ;
		}
	}
	
	sb->maxalphacon += 0.1F ;
	if( sb->maxalphacon > 1.0F ) sb->maxalphacon = 1.0F ;

	// I
	return 0 ;
}

// QGtFNg`悷
extern s8 DrawSmoke2Effect( EFFECT *Effect )
{
	SMOKE2EFFECT *sb = ( SMOKE2EFFECT * )Effect->Data ;
	SMOKE2OBJECT *ob ;
	Mtx mt ;
	Vec tv[4] ;
	u32 cr ;
	s32 i ;
	
	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX, TRUE ) ;
	GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_2, GX_TRUE, GX_TEVPREV ) ;

	// eNX`̃[h
	GTLOAD( GetSmokeTex() ) ;

	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;

	// _̏
	CreateBillVert( mt, tv, sb->size, sb->size ) ;

	// `揈
	if( sb->num == 0 ) return 0 ;
	GBGN( GX_QUADS, sb->num * 4 ) ;
	{
		// ΍W
		ob = sb->obj ;
		for( i = 0 ; i < sb->num ; ob ++ )
		{
			if( ob->vflag == FALSE ) continue ;
			
			i ++ ;

			cr = CMKC2( ob->color, ( ob->alpha > 1.0F ? sb->alpha * ( sb->color & 0xff ) : sb->alpha * ob->alpha * ( sb->color & 0xff ) ) * ob->maxalpha ) ;
			GPV3( ob->pos, tv[0] ) ;	GCX( cr ) ;		GT( 0.0F, 0.0F ) ;
			GPV3( ob->pos, tv[1] ) ;	GCX( cr ) ;		GT( 1.0F, 0.0F ) ;
			GPV3( ob->pos, tv[2] ) ;	GCX( cr ) ;		GT( 1.0F, 1.0F ) ;
			GPV3( ob->pos, tv[3] ) ;	GCX( cr ) ;		GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;

	// I
	return 0 ;
}

/*
const u16 _SBTable[][20] =
{
	{	// 
		100, 10, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},

	{	// 
		100, 3, 128, 0, 0,
		255, 35, 68, 30, 30,

		10, 10, 8, 10, 20,
		0, 0,
	},
} ;


// QGtFNg쐬
extern EFFECT *CreateSmoke2Effect(
								u8 type, Vec pos,
								s32 dietime,				// S
								s32 Priority )
{
	if( type < 2 )
	{
#ifdef	YAMADADEBUG
		OSReport( "	{\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[0], PRM[1], PRM[2], PRM[3], PRM[4] ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[5], PRM[6], PRM[7], PRM[8], PRM[9] ) ;
		OSReport( "\n" ) ;
		OSReport( "		%d, %d, %d, %d, %d,\n", PRM[10], PRM[11], PRM[12], PRM[13], PRM[14] ) ;
		OSReport( "		%d, %d,\n", PRM[15], PRM[16] ) ;
		OSReport( "	},\n" ) ;
#endif
	
		if( type == 0 )
			return CreateSmoke2Effect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)false,			// W^Cv
									dietime, 
									Priority ) ;			// QGtFNg쐬
		else
			return CreateSmoke2Effect(
									PRM[0] * 10,				// ő吔
									
									pos,				// ʒu
									PRM[1] * 1.0F,			// TCY
									CMK( PRM[2],PRM[3],PRM[4],PRM[5] ),				// F
									
								//	f32 maxsize, minsize ;	// őTCYƍŏTCY
									PRM[6] * 0.1F,				// TCY
									PRM[7] * 0.01F, PRM[8] * 0.01F,	// ő呬xŏx
									PRM[9] * 0.01F, PRM[10] * 0.01F, 		// ㏸ő僿xƍŏx
									PRM[11] * 0.01F, PRM[12] * 0.01F,	// ~ő僿xƍŏx
									PRM[13] * 0.1F,			// őAt@l
									1.0F / PRM[14],			// 쐬[g
									(bool)true,			// W^Cv
									dietime,
									Priority ) ;			// QGtFNg쐬
	}
	else
	{
		type -= 2 ;

		return CreateSmoke2Effect(
								_SBTable[type][0] * 10,				// ő吔
								
								pos,				// ʒu
								_SBTable[type][1] * 1.0F,			// TCY
								CMK( _SBTable[type][2],_SBTable[type][3],_SBTable[type][4],_SBTable[type][5] ),				// F
								
							//	f32 maxsize, minsize ;	// őTCYƍŏTCY
								_SBTable[type][6] * 0.1F,				// TCY
								_SBTable[type][7] * 0.01F, _SBTable[type][8] * 0.01F,	// ő呬xŏx
								_SBTable[type][9] * 0.01F, _SBTable[type][10] * 0.01F, 		// ㏸ő僿xƍŏx
								_SBTable[type][11] * 0.01F, _SBTable[type][12] * 0.01F,	// ~ő僿xƍŏx
								_SBTable[type][13] * 0.1F,			// őAt@l
								1.0F / _SBTable[type][14],			// 쐬[g
								(bool)true,			// W^Cv
								dietime,
								
								Priority ) ;			// QGtFNg쐬
	}
	
	return NULL ;
}
*/


// QGtFNg̔WύX
extern s8 SetSmoke2EffectPos( EFFECT *Effect, Vec pos )
{
	SMOKE2EFFECT *sb = ( SMOKE2EFFECT * )Effect->Data ;
	
	sb->pos = pos ;

	// I
	return 0 ;	
}


