///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSnow
//
// YK7EffectSnow.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 12/02/2003
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSnow.h"
#include "./YK7Break.h"
#include "../Wat/WK7Archive.h"
#include "./YK7EffectLine.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define SNOWTEX 			"/Yam/Effect/Snow/Snow.BIN"		// GtFNgp̃eNX`t@C
#define SNOWTEX_DIVNUM		2								// eNX`̕
#define SNOWTEX_ONES		(1.0F/(SNOWTEX_DIVNUM))
#define SNOW_MODELNUM		4								// eNX`̑

// datatype -------------------------------------

// data -----------------------------------------

SNOWUNION SnwUnion ;
extern LINEUNION LUnion ;

// function proto type --------------------------

// function code --------------------------------

// GtFNg̋ʃf[^
extern s8 InitSnowData( void )
{
	MEMINIT( SnwUnion ) ;

	// peNX`[ǂݍ
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_Snow ), &SnwUnion.SnowTex ) ;
//	TexLoadSet( SNOWTEX, &SnwUnion.SnowTex ) ;

	// I
	return 0 ;
}

// GtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSnowData( void )
{
	if( TexLoadChk( &SnwUnion.SnowTex ) == FALSE ) return FALSE ;
	
	return TRUE ;
}


// GtFNg̋ʃf[^n
extern s8 EndSnowData( void )
{
	// eNX`f[^j
	TexRelease( &SnwUnion.SnowTex ) ;

	// I
	return 0 ;
}


// ̃GtFNg쐬
extern EFFECT *CreateSnowEffect( Vec Point, f32 YukaY,
									f32 MaxSpeed, f32 MinSpeed,
									f32 MaxRotSpeed, f32 MinRotSpeed,
									f32 MaxBureWidth, f32 MinBureWidth,
									f32 SnowR, u16 MaxNum,
									GXColor *Color, s32 Priority )
{
	EFFECT *Effect ;
	SNOWEFFECT *Sn ;
	SNOWOBJECT *Ob ;

	// t@C̓ǂݍ݂IĂȂ牽ɏI
	if( CheckSnowData() == FALSE ) return 0 ;

	// ̊m
	Ob = ( SNOWOBJECT * )K7AppSmallMemAllocName( (s32)( ( sizeof( SNOWOBJECT ) + sizeof( u16 ) * 2 ) * MaxNum ), "Y_SnwObj" ) ;
	if( Ob == NULL ) return NULL ;
	memset( Ob, 0, ( sizeof( SNOWOBJECT ) + sizeof( u16 ) * 2 ) * MaxNum ) ;

	// Vf[^쐬
	Effect = AddEffectData( EFF_SNOW, (void**)&Sn, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( Ob ) ;
		return NULL ;
	}
	
	// p[^ۑ
	Sn->ObjP = Ob ;
	Sn->RenderList = (u16*)( (u8*)Sn->ObjP + sizeof( SNOWOBJECT ) * MaxNum ) ;
	Sn->RenderNum = 0 ;
	Sn->BotRenderList = (u16*)( (u8*)Sn->RenderList + sizeof( u16 ) * MaxNum ) ;
	Sn->BotRenderNum = 0 ;
	Sn->ObjNum = 0 ;
	Sn->Counter = 0 ;
	Sn->Mode = 1 ;
	Sn->MaxBureWidth = MaxBureWidth ;
	Sn->MinBureWidth = MinBureWidth ;
	
	Sn->MaxObjNum = MaxNum ;
	Sn->Point = Point ;
	Sn->MaxSpeed = MaxSpeed ;
	Sn->MinSpeed = MinSpeed ;
	Sn->MaxRotSpeed = MaxRotSpeed ;
	Sn->MinRotSpeed = MinRotSpeed ;
	Sn->SnowR = SnowR ;
	Sn->YukaY = YukaY ;
	Sn->Color = ( Color != NULL ) ? *Color : (GXColor){255,255,255,255} ;
	
	Sn->SnowCounter = 0.0F ;
	Sn->OneSnowPoint = 1.0F / VParam[ED_SNOW][0] ;
	Sn->ValidCounter = 0 ;
	
	// I
	return Effect ;
}

// ̃GtFNǧns
extern s8 ReleaseSnowEffect( EFFECT *Effect )
{
	SNOWEFFECT *Sn = ( SNOWEFFECT * )Effect->Data ;

	// GtFNgIuWFNgp̃J
	CHKMEMFREE2( Sn->ObjP ) ;

	// I
	return 0 ;
}

// ̃GtFNgPt[
extern s8 MoveSnowEffect( EFFECT *Effect )
{
	SNOWEFFECT *Sn = ( SNOWEFFECT * )Effect->Data ;
	u32 i, j, Num ;
	SNOWOBJECT *Ob ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE ) 
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}

	// ̐JԂ
	Num = Sn->ObjNum ;
	Ob = Sn->ObjP ;
	Sn->RenderNum = 0 ;
	Sn->BotRenderNum = 0 ;
	for( i = 0, j = 0 ; i < Num ; Ob ++, j ++ )
	{
		// LtOĂȂ牽Ȃ
		if( Ob->ValidFlag == FALSE ) continue ;

		i ++ ;
		
		// ړ
		if( Ob->BotFlag == TRUE ) 
		{
			Ob->Counter ++ ;
			if( Ob->Counter == 3 )
			{
				Ob->ValidFlag = FALSE ;
				Sn->ObjNum -- ;
			}
			else
			{
				Sn->BotRenderList[Sn->BotRenderNum] = (u16)j ;
				Sn->BotRenderNum ++ ;
			}
		}
		else
		{
			Ob->Point.y -= Ob->Speed.y ;
			Ob->Rot += Ob->RotSp ;
//			Ob->Speed.y += Sn->DownSSpeed ;
			if( Sn->YukaY > Ob->Point.y ) 
			{
				Ob->Point.y = Sn->YukaY ;
				Ob->BotFlag = TRUE ;
				Ob->Counter = 0 ;
				Sn->BotRenderList[Sn->BotRenderNum] = (u16)j ;
				Sn->BotRenderNum ++ ;
			}
			else
			{
				Sn->RenderList[Sn->RenderNum] = (u16)j ;
				Sn->RenderNum ++ ;
			}
		}
	}
	
	// ᕑ~胂[h
	{
		// JE^
		Sn->SnowCounter += 1.0F ;

		// JE^Kl𒴂Ă𕑂~点
		while( Sn->SnowCounter > Sn->OneSnowPoint && Sn->ObjNum != Sn->MaxObjNum )
		{
			// gĂȂf[^T
			for( Ob = &Sn->ObjP[Sn->ValidCounter] ; Ob->ValidFlag == TRUE ; )
			{
				Sn->ValidCounter ++ ;
				Ob ++ ;
				if( Sn->ValidCounter == Sn->MaxObjNum )
				{
					Ob = Sn->ObjP ;
					Sn->ValidCounter = 0 ;
				}
			}

			Sn->RenderList[Sn->RenderNum] = (u16)Sn->ValidCounter ;
			Sn->RenderNum ++ ;
			
			Sn->ValidCounter ++ ;
			if( Sn->ValidCounter == Sn->MaxObjNum ) Sn->ValidCounter = 0 ;
	
			// LtO𗧂Ă
			Ob->ValidFlag = TRUE ;
			Ob->BotFlag = FALSE ;
			
			// 𑝂₷
			Sn->ObjNum ++ ;
			Sn->SnowCounter -= Sn->OneSnowPoint ;

			// ̃Zbg
			{
				f32 r ;
				
				r = rand() * Sn->SnowR / RAND_MAX ;
				Ob->Point.y = Sn->Point.y + rand() * (f32)VParam[ED_SNOW][14] / RAND_MAX ;
				Ob->Point.x = rand() * Sn->SnowR / RAND_MAX - Sn->SnowR / 2 + Sn->Point.x ;
				Ob->Point.z = rand() * Sn->SnowR / RAND_MAX - Sn->SnowR / 2 + Sn->Point.z ;
			}
			Ob->Speed.x = Ob->Speed.z = 0.0F ;
			Ob->Speed.y = rand() * ( Sn->MaxSpeed - Sn->MinSpeed ) / RAND_MAX + Sn->MinSpeed ;
			Ob->Rot = 0.0F ;
			Ob->RotSp = rand() * ( Sn->MaxRotSpeed - Sn->MinRotSpeed ) / RAND_MAX + Sn->MinRotSpeed ;
			Ob->BureWidth = rand() * ( Sn->MaxBureWidth - Sn->MinBureWidth ) / RAND_MAX + Sn->MinBureWidth ;
			Ob->Counter = 0 ;
		}
	}

	// I
	return 0 ;
}

// ̃GtFNg`悷
extern s8 DrawSnowEffect( EFFECT *Effect )
{
	SNOWEFFECT *Sn = ( SNOWEFFECT * )Effect->Data ;
	Mtx TMtx ;
	u32 j ;
	SNOWOBJECT *Ob ;
	SNOWUNION *SnowUnion = &SnwUnion ;
	Vec CamP, p2 ;
	Vec p[4] ;
	
	if( SnwUnion.NotAllDrawFlag == TRUE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// ]us擾
	EffectGetInvViewMatrix( TMtx ) ;

	// eNX`̃[h
	GTLOAD2( SnwUnion.SnowTex ) ;

	// `揈
	if( Sn->RenderNum != 0 )
	{
		GXBegin( GX_QUADS, GX_VTXFMT0, (u16)( Sn->RenderNum * 4 ) ) ;
		{
			u32 Num, color  ;
			f32 a ;
			u16 *List ;
			SNOWOBJECT *ObjP ;
			f32 Size, AddX ;

			Size = VParam[ED_SNOW][12] * 0.01F ;
			p[0].x = -Size ; p[0].y = Size ; p[0].z = 0.0F ;
			p[1].x = Size ; p[1].y = Size ; p[1].z = 0.0F ;
			p[2].x = Size ; p[2].y = -Size ; p[2].z = 0.0F ;
			p[3].x = -Size ; p[3].y = -Size ; p[3].z = 0.0F ;
			
			Num = Sn->RenderNum ;
			List = Sn->RenderList ;
			ObjP = Sn->ObjP ;
			for( j = 0 ; j < Num ; j ++, List ++ )
			{
				Ob = &ObjP[*List] ;

				// ɂăAt@lZo
				a = 1.0F - PSVECDistance( &CamP, &Ob->Point ) / VParam[ED_SNOW][13] ;
				if( a < VParam[ED_SNOW][11] * 0.01F ) a = VParam[ED_SNOW][11] * 0.01F ;
				color = CMKC2( Sn->Color, a * 255 ) ;
				
				// Ԃꕝ̌vZ
				AddX = Ob->BureWidth * sinf( Ob->Rot ) ;
				
				// _̃Zbg
				p2 = p[0] ; p2.x += AddX ;
				PSMTXMultVec( TMtx, &p2, &p2 ) ;
				GP3( p2.x + Ob->Point.x, p2.y + Ob->Point.y, p2.z + Ob->Point.z ) ;
				GCX( color ) ;			GT( 0.0F, 0.0F ) ;

				p2 = p[1] ; p2.x += AddX ;
				PSMTXMultVec( TMtx, &p2, &p2 ) ;
				GP3( p2.x + Ob->Point.x, p2.y + Ob->Point.y, p2.z + Ob->Point.z ) ;
				GCX( color ) ;			GT( 1.0F, 0.0F ) ;

				p2 = p[2] ; p2.x += AddX ;
				PSMTXMultVec( TMtx, &p2, &p2 ) ;
				GP3( p2.x + Ob->Point.x, p2.y + Ob->Point.y, p2.z + Ob->Point.z ) ;
				GCX( color ) ;			GT( 1.0F, 1.0F ) ;

				p2 = p[3] ; p2.x += AddX ;
				PSMTXMultVec( TMtx, &p2, &p2 ) ;
				GP3( p2.x + Ob->Point.x, p2.y + Ob->Point.y, p2.z + Ob->Point.z ) ;
				GCX( color ) ;			GT( 0.0F, 1.0F ) ;
			}
		}
		GXEnd() ;
	}
	
	// I
	return 0 ;
}					


// Ⴊ钆S_ύX
extern s8 SetSnowEffectPoint( EFFECT *Effect, Vec Point )
{
	SNOWEFFECT *Sn = ( SNOWEFFECT * )Effect->Data ;

	// WύX
	Sn->Point = Point ;

	// I
	return 0 ;
}

// GtFNg̑SĂ`悷邩ǂݒ肷
extern s8 SetSnowAllDrawFlag( s8 Flag )
{
	SnwUnion.NotAllDrawFlag = (s8)( Flag == TRUE ? FALSE : TRUE ) ;

	return 0 ;
}


