///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSpSkillGage
//
// YK7EffectSpSkillGage.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 08/21/2003
//
//////////////////////////////////////////////////////////////////////////////

#define __NOCODE

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSpSkillGage.h"

// define ---------------------------------------

#define STR_SAERCH			"Yam/Effect/SaerchAndRelease/Search.BIN"
#define STR_RELEASE			"Yam/Effect/SaerchAndRelease/Release.BIN"
#define SAERCH_MAX_Y		480

// datatype -------------------------------------

// data -----------------------------------------

SPSKILLGAGEUNION SpSkUnion ;

// function code --------------------------------

// XLQ[W̋ʃf[^
extern s8 InitSpSkillGageData( void )
{
	MEMINIT( SpSkUnion ) ;
#ifndef __NOCODE

	// wSaerchx̃eNX`[ǂݍ
	TexLoadSet( STR_SAERCH, &SpSkUnion.SaerchTex ) ;

	// wReleasex̃eNX`[ǂݍ
	TexLoadSet( STR_RELEASE, &SpSkUnion.ReleaseTex ) ;
#endif
	
	// I
	return 0 ;
}

// XLQ[WGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSpSkillGageData( void )
{
#ifndef __NOCODE
	if( TexLoadChk( &SpSkUnion.SaerchTex ) == FALSE ||
		TexLoadChk( &SpSkUnion.ReleaseTex ) == FALSE ) return FALSE ;
#endif
		
	return TRUE ;
}

// XLQ[W̋ʃf[^n
extern s8 EndSpSkillGageData( void )
{
#ifndef __NOCODE
	// 
	TexRelease( &SpSkUnion.SaerchTex ) ;
	TexRelease( &SpSkUnion.ReleaseTex ) ;
#endif
	
	// I
	return 0 ;
}

#ifndef __NOCODE

// XLQ[WGtFNg쐬
extern EFFECT *CreateSpSkillGageEffect( Vec Point, u8 Type, s32 Priority )
{
	SPSKILLGAGEEFFECT *SpSkillGage ;
	EFFECT *Effect ;

	// VXLQ[Wf[^쐬
	Effect = AddEffectData( EFF_SPSKILLGAGE, (void**)&SpSkillGage, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// XLQ[Wf[^
	SpSkillGage->Type = Type ;
	SpSkillGage->Point = Point ;
	
	SpSkillGage->LineGage = 0.0F ;
	SpSkillGage->ChargeState = 1.0F ;

	SpSkillGage->RenderFlag = FALSE ;
	
	SpSkillGage->Bright = 1.0F ;
	SpSkillGage->BrightAdd = 0 ;
	
	// TCXs[h
	{
		u32 i ;
		
		for( i = 0 ; i < VParam[ED_SAR][16] ; i ++ )
			SpSkillGage->SinSpeed[i] = rand() * ( PI_2 / 100 * VParam[ED_SAR][17]) / RAND_MAX ;
		SpSkillGage->SinCounter = 0 ;
	}
	
	// ]܂ł̃t[Zbg
	SpSkillGage->Pi2Time = (u32)( rand() * VParam[ED_SAR][18] / RAND_MAX ) ;
	SpSkillGage->BrightHeight = rand() * 0.8F / RAND_MAX + 0.2F ;
	SpSkillGage->BrightCounter = 0 ;
	SpSkillGage->SinCount = 0.0F ;

	// I
	return Effect ;
}
#endif

// XLQ[WGtFNǧns
extern s8 ReleaseSpSkillGageEffect( EFFECT *Effect )
{
#ifndef __NOCODE
	SPSKILLGAGEEFFECT *SpSkillGage = ( SPSKILLGAGEEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
#else
	Effect = Effect ;
	return 0 ;
#endif
}

// XLQ[WGtFNgPt[
extern s8 MoveSpSkillGageEffect( EFFECT *Effect )
{
#ifndef __NOCODE
	SPSKILLGAGEEFFECT *SpGage = ( SPSKILLGAGEEFFECT * )Effect->Data ;

	if( (SPSKILLGAGEEFFECT *)NULL == SpGage ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// ̃eNX`ǂݍ܂ĂȂ牽I
	if( CheckSpSkillGageData() == FALSE ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE )
	{
		DeleteEffect( Effect ) ;
		
		// I
		return 0 ;
	}
	
	// ̘g̐
	if( SpGage->ChargeState == 1.0F )
	{
		// Q[W}bNX̂Ƃ͑₷
		if( SpGage->BrightAdd == 0 ) SpGage->BrightAdd = 1 ;
		SpGage->LineGage += VParam[ED_SAR][0] * 0.01F ;
		if( SpGage->LineGage > 4.0F ) SpGage->LineGage = 4.0F ;
		
		// 邳̐
		SpGage->Bright += SpGage->BrightAdd * ( (f32)VParam[ED_SAR][15] / 255 ) ;
		if( SpGage->Bright > 1.0F )
		{
			SpGage->BrightAdd *= -1 ; SpGage->Bright = 1.0F ;
		}
		if( SpGage->Bright < 0.0F )
		{
			SpGage->BrightAdd *= -1 ; SpGage->Bright = 0.0F ;
		}
		
		// 邳̃Zbg
		{
			u32 i ;
			f32 Total ;
			
			Total = 0.0F ;
			for( i = 0 ; i < VParam[ED_SAR][16]/*SIN_NUM*/ ; i ++ )
				Total = sinf( fmod( SpGage->SinCounter * SpGage->SinSpeed[i], PI_2 ) ) ;
				
			SpGage->Bright = ( Total / ( VParam[ED_SAR][16]/*SIN_NUM*/ * 2.0F ) + 0.5F ) * 1.3F ;
			if( SpGage->Bright > 1.0F ) SpGage->Bright = 1.0F ;

			// JE^̃CNg
			SpGage->SinCounter ++ ;
		}
		
		// 邳̃Zbg
		{
			SpGage->Bright = ( ( sinf( PI_2 * (f32)SpGage->BrightCounter / SpGage->Pi2Time ) + 1.0F ) / 2.0F ) * SpGage->BrightHeight ;
			if( SpGage->Bright > 1.0F ) SpGage->Bright = 1.0F ;
			SpGage->BrightCounter ++ ;
			if( SpGage->Pi2Time <= SpGage->BrightCounter )
			{
				SpGage->Pi2Time = (u32)( rand() * VParam[ED_SAR][18] / RAND_MAX ) ;
				SpGage->BrightHeight = rand() * 0.8F / RAND_MAX + 0.2F ;
				SpGage->BrightCounter = 0 ;
			}
		}

		// }bNX̂Ƃ̓e[uVbt
		{
			u8 i, j, k ;
			u32 r ;
			s8 Table[LINE_DIVNUM] ;

			// e[u
			for( i = 0 ; i < LINE_DIVNUM ; i ++ ) Table[i] = -1 ;

			// Zbg
			for( i = 0 ; i < LINE_DIVNUM ; i ++ )
			{
				r = (u32)( rand() * ( LINE_DIVNUM - i - 1 ) / RAND_MAX ) ;
				if( r == ( LINE_DIVNUM - i - 1 ) ) r = (u32)( ( LINE_DIVNUM - i - 1 - 1 ) ) ;
				r += 1 ;
				
				j = 0 ;
				k = 0 ;
				for( ;; )
				{
					if( Table[k] == -1 ) j ++ ;
					if( j == r ) break ;
					k ++ ;
				}
				
				SpGage->DivTable[i] = (f32)k / LINE_DIVNUM ;
				Table[k] = 1 ;
			}
		}
		
		SpGage->SinCount = 0.0F ;
	}
	else
	{
		// 邳̃Zbg
		SpGage->Bright = 0.0F ;

		// ȊÔƂ͌炷
		SpGage->LineGage -= VParam[ED_SAR][0] * 0.01F ;
		if( SpGage->LineGage < 0.0F ) SpGage->LineGage = 0.0F ;
		
		SpGage->SinCount += (f32)VParam[ED_SAR][28] / 360.0F ;
		if( SpGage->SinCount >= PI ) SpGage->SinCount -= PI ;
	}
	
	// `Jn̏p̃JE^i߂
	SpGage->RenderCounter += VParam[ED_SAR][13] * 0.01F ;
	if( SpGage->RenderCounter > 1.0F ) SpGage->RenderCounter = 1.0F ;

	// I
	return 0 ;
#else
	Effect = Effect ;
	return 0 ;
#endif
}

// XLQ[WGtFNg`悷
extern s8 DrawSpSkillGageEffect( EFFECT *Effect )
{
#ifndef __NOCODE
	SPSKILLGAGEEFFECT *SpGage = ( SPSKILLGAGEEFFECT * )Effect->Data ;
	u16 Width, Height ;
	Vec Point ;
	u16 Color1 ;
	GhmGcTexHeader *Head ;
	f32 x, y, Bright ;
	u8 r, g, b, a ;

	if( (SPSKILLGAGEEFFECT *)NULL == SpGage ) return 0 ;
	if( SpGage->RenderFlag == FALSE ) return 0 ;

	// ̃eNX`ǂݍ܂ĂȂ牽I
	if( CheckSpSkillGageData() == FALSE ) return 0 ;

	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;

	// _tH[}bg̃Zbg
	GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U16, UVSHFTBIT ) ;

	// OtBbÑTCY擾
	{
		Head = SpGage->Type == 0 ? SpSkUnion.SaerchTex.Data.Header : SpSkUnion.ReleaseTex.Data.Header ;
		Width = Head->mWidth ;
		Height = Head->mHeight ;
	}

	// WZbg
	{
		Point = SpGage->Point ;
		if( SpGage->Type == 0 )
		{
			if( SpGage->ChargeState != 1.0F )
			{
				Point.y += ( SAERCH_MAX_Y - ( Height + Point.y ) ) * SpGage->ChargeState ;
			}
		}
	}

	Bright = sinf( SpGage->SinCount ) * 0.5F + 0.5F ;
	
	// ̕`
	if( SpGage->Type == 0 && SpGage->ChargeState != 1.0F )
	{
		u16 c ;
	
		// eNX`̃[h
		GTLOAD2( SpGage->Type == 0 ? SpSkUnion.SaerchTex : SpSkUnion.ReleaseTex ) ;
		
		// F̃Zbg
		if( SpGage->Type == 0 )
		{
			r = (u8)( VParam[ED_SAR][1] * Bright ) ;
			g = (u8)( VParam[ED_SAR][2] * Bright ) ;
			b = (u8)( VParam[ED_SAR][3] * Bright ) ;
			a = (u8)VParam[ED_SAR][27] ;
		}
		else
		{
			c = (u16)( VParam[ED_SAR][4] + SpGage->Bright * 255 ) ;
			r = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][5] + SpGage->Bright * 255 ) ;
			g = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][6] + SpGage->Bright * 255 ) ;
			b = (u8)( c > 255 ? 255 : c ) ;
			a = 255 ;
		}

		// `
		x = ( SCW - Width ) * 0.5F + VParam[ED_SAR][19] - 128 ;
		y = ( SCH - Height ) * 0.5F + VParam[ED_SAR][20] - 128 ;
		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP2( x, y ) ;					GC4( r, g, b, a ) ; GT2( 0		, 0 ) ;
			GP2( x + Width, y ) ;			GC4( r, g, b, a ) ; GT2( UVSCALE	, 0 ) ;
			GP2( x + Width, y + Height ) ;	GC4( r, g, b, a ) ; GT2( UVSCALE	, UVSCALE ) ;
			GP2( x, y + Height ) ;			GC4( r, g, b, a ) ; GT2( 0		, UVSCALE ) ;
		}
		GXEnd() ;
	}

	// ̕`
	if( SpGage->Type == 1 )
	{
		u8 r, g, b, a ;
		u16 c ;
	
		// eNX`̃[h
		GTLOAD2( SpGage->Type == 0 ? SpSkUnion.SaerchTex : SpSkUnion.ReleaseTex ) ;
		
		// `
		if( SpGage->Type == 0 )
		{
			c = (u16)( VParam[ED_SAR][1] + SpGage->Bright * 255 ) ;
			r = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][2] + SpGage->Bright * 255 ) ;
			g = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][3] + SpGage->Bright * 255 ) ;
			b = (u8)( c > 255 ? 255 : c ) ;
			a = 255 ;
		}
		else
		{
			c = (u16)( VParam[ED_SAR][4] + SpGage->Bright * 255 ) ;
			r = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][5] + SpGage->Bright * 255 ) ;
			g = (u8)( c > 255 ? 255 : c ) ;
			c = (u16)( VParam[ED_SAR][6] + SpGage->Bright * 255 ) ;
			b = (u8)( c > 255 ? 255 : c ) ;
			a = 255 ;
		}

		GXBegin( GX_QUADS, GX_VTXFMT0, 4 ) ;
		{
			GP2( Point.x, Point.y ) ;
			GC4( r, g, b, a ) ; GT2( 0, 0 ) ;
			GP2( Point.x + Width, Point.y ) ;
			GC4( r, g, b, a ) ; GT2( UVSCALE, 0 ) ;
			GP2( Point.x + Width, Point.y + Height ) ;
			GC4( r, g, b, a ) ; GT2( UVSCALE, UVSCALE ) ;
			GP2( Point.x, Point.y + Height ) ;
			GC4( r, g, b, a ) ; GT2( 0, UVSCALE ) ;
		}
		GXEnd() ;
	}

	
	// ̘g̕`
	if( SpGage->Type == 0 && SpGage->ChargeState != 1.0F )
	{
		u16 Width2, Height2 ;
		f32 x[8], y[8] ;
		u8 r2, g2, b2, a2 ;
	
		// eNX`[hɕύX
		EffectTevSetup( EF_TEV_NOTEX ) ;
		
		// ̑Zbg		
		GXSetLineWidth( (u8)VParam[ED_SAR][23], GX_TO_ONE ) ;

		Width = (u16)( Head->mWidth + VParam[ED_SAR][21] * 2 ) ;
		Height = (u16)( Head->mHeight + VParam[ED_SAR][22] * 2 ) ;
		Width2 = (u16)( Head->mWidth + ( VParam[ED_SAR][21] + VParam[ED_SAR][23] ) * 2 ) ;
		Height2 = (u16)( Head->mHeight + ( VParam[ED_SAR][22] + VParam[ED_SAR][23] ) * 2 ) ;

		x[0] = ( SCW - Width2 ) * 0.5F + VParam[ED_SAR][19] - 128 ;		y[0] = ( SCH - Height2 ) * 0.5F + VParam[ED_SAR][20] - 128 ;
		x[1] = ( SCW - Width ) * 0.5F + VParam[ED_SAR][19] - 128 ;		y[1] = ( SCH - Height ) * 0.5F + VParam[ED_SAR][20] - 128 ;

		x[2] = ( SCW - Width2 ) * 0.5F + Width2 + VParam[ED_SAR][19] - 128 ;	y[2] = ( SCH - Height2 ) * 0.5F + VParam[ED_SAR][20] - 128 ;
		x[3] = ( SCW - Width ) * 0.5F + Width + VParam[ED_SAR][19] - 128 ;		y[3] = ( SCH - Height ) * 0.5F + VParam[ED_SAR][20] - 128 ;

		x[4] = ( SCW - Width2 ) * 0.5F + Width2 + VParam[ED_SAR][19] - 128 ;	y[4] = ( SCH - Height2 ) * 0.5F + Height2 + VParam[ED_SAR][20] - 128 ;
		x[5] = ( SCW - Width ) * 0.5F + Width + VParam[ED_SAR][19] - 128 ;		y[5] = ( SCH - Height ) * 0.5F + Height + VParam[ED_SAR][20] - 128 ;

		x[6] = ( SCW - Width2 ) * 0.5F + VParam[ED_SAR][19] - 128 ;		y[6] = ( SCH - Height2 ) * 0.5F + Height2 + VParam[ED_SAR][20] - 128 ;
		x[7] = ( SCW - Width ) * 0.5F + VParam[ED_SAR][19] - 128 ;		y[7] = ( SCH - Height ) * 0.5F + Height + VParam[ED_SAR][20] - 128 ;

		r = (u8)( VParam[ED_SAR][1] * Bright ) ;
		g = (u8)( VParam[ED_SAR][2] * Bright ) ;
		b = (u8)( VParam[ED_SAR][3] * Bright ) ;
		a = (u8)VParam[ED_SAR][27] ;

		r2 = (u8)( VParam[ED_SAR][24] * Bright ) ;
		g2 = (u8)( VParam[ED_SAR][25] * Bright ) ;
		b2 = (u8)( VParam[ED_SAR][26] * Bright ) ;
		a2 = (u8)VParam[ED_SAR][27] ;
			
		GXBegin( GX_TRIANGLESTRIP, GX_VTXFMT0, (u16)10 ) ;
		{
			GP2( x[1], y[1] ) ;	GC4( r2, g2, b2, a2 ) ; 
			GP2( x[0], y[0] ) ;	GC4( r, g, b, a ) ;

			GP2( x[3], y[3] ) ;	GC4( r2, g2, b2, a2 ) ;
			GP2( x[2], y[2] ) ;	GC4( r, g, b, a ) ;

			GP2( x[5], y[5] ) ;	GC4( r2, g2, b2, a2 ) ;
			GP2( x[4], y[4] ) ;	GC4( r, g, b, a ) ;

			GP2( x[7], y[7] ) ;	GC4( r2, g2, b2, a2 ) ;
			GP2( x[6], y[6] ) ;	GC4( r, g, b, a ) ;

			GP2( x[1], y[1] ) ;	GC4( r2, g2, b2, a2 ) ;
			GP2( x[0], y[0] ) ;	GC4( r, g, b, a ) ;
		}
		GXEnd() ;
	}

	// _O[hɕύX
	{
		// eNX`[hɕύX
		EffectTevSetup( EF_TEV_NOTEX ) ;

		// _tH[}bg̃Zbg
		GXSetVtxAttrFmt( GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA4, 0 ) ;

		// ̑Zbg		
		GXSetLineWidth( (u8)VParam[ED_SAR][7], GX_TO_ONE ) ;
	}

		
	if( SpGage->Type == 1 && SpGage->LineGage != 0.0F )
	{
		u16 LineNum ;
	
		// FZbg	
		Color1 = SpGage->Type == 0 ? GXPackedRGBA4( VParam[ED_SAR][1], VParam[ED_SAR][2], VParam[ED_SAR][3], 255 ) :
									GXPackedRGBA4( VParam[ED_SAR][4], VParam[ED_SAR][5], VParam[ED_SAR][6], 255 ) ;

		LineNum = (u16)( SpGage->LineGage < 1.0F ? 1 :
						( SpGage->LineGage < 2.0F ? 2 :
						 ( SpGage->LineGage < 3.0F ? 3 : 4 ) ) ) ;

		GXBegin( GX_LINES, GX_VTXFMT0, (u16)( LineNum * 2 ) ) ;
		{
			// ̃C`悷
			if( LineNum > 0 )
			{
				f32 LineLength, Width2 ;

				if( SpGage->Type == 0 )
				{
					Width2 = Width * VParam[ED_SAR][14] * 0.01F ;
					LineLength = SpGage->LineGage > 1.0F ? 1.0F : SpGage->LineGage - 0.0F ;
					GP2( Point.x + Width2 , Point.y + Height  ) ; 	GXColor1u16( Color1 ) ; 
					GP2( Point.x + Width2 - Width2 * LineLength , Point.y + Height  ) ; 	GXColor1u16( Color1 ) ; 
				}
				else
				{
					LineLength = SpGage->LineGage > 1.0F ? 1.0F : SpGage->LineGage - 0.0F ;
					GP2( Point.x + Width , Point.y + Height  ) ; 	GXColor1u16( Color1 ) ; 
					GP2( Point.x + Width - Width * LineLength , Point.y + Height  ) ; 	GXColor1u16( Color1 ) ; 
				}
			}
			
			// ̃C`悷
			if( LineNum > 1 )
			{
				f32 LineLength ;

				LineLength = SpGage->LineGage > 2.0F ? 1.0F : SpGage->LineGage - 1.0F ;
				GP2( Point.x , Point.y + Height  ) ; 	GXColor1u16( Color1 ) ; 
				GP2( Point.x , Point.y + Height - LineLength * Height  ) ; 	GXColor1u16( Color1 ) ; 
			}
			
			// 㑤̃C`悷
			if( LineNum > 2 )
			{
				f32 LineLength ;

				LineLength = SpGage->LineGage > 3.0F ? 1.0F : SpGage->LineGage - 2.0F ;
				GP2( Point.x , Point.y  ) ; 	GXColor1u16( Color1 ) ; 
				GP2( Point.x + LineLength * Width , Point.y  ) ; 	GXColor1u16( Color1 ) ; 
			}
			
			// ẼC`悷
			if( LineNum > 3 )
			{
				f32 LineLength ;

				LineLength = SpGage->LineGage > 4.0F ? 1.0F : SpGage->LineGage - 3.0F ;
				GP2( Point.x + Width , Point.y  ) ; 	GXColor1u16( Color1 ) ; 
				GP2( Point.x + Width , Point.y + LineLength * Height  ) ; 	GXColor1u16( Color1 ) ; 
			}
			
		}
		GXEnd() ;
	}

	// ^Cvɂď𕪊
	if( SpGage->Type == 0 )
	{
		f32 y ;
	
		// ̑Zbg		
		GXSetLineWidth( (u8)VParam[ED_SAR][7], GX_TO_ONE ) ;
		
		// T[`̏ꍇ̏s

		// FZbg	
		Color1 = SpGage->Type == 0 ? GXPackedRGBA4( VParam[ED_SAR][1], VParam[ED_SAR][2], VParam[ED_SAR][3], 255 ) :
									GXPackedRGBA4( VParam[ED_SAR][4], VParam[ED_SAR][5], VParam[ED_SAR][6], 255 ) ;

		// ɃC`悷
		y = SpGage->ChargeState == 1.0F ? 0.0F : SpGage->ChargeState * SCH ;
		GXBegin( GX_LINES, GX_VTXFMT0, 2 ) ;
		{
			GP2( 0				, y ) ;	GXColor1u16( Color1 ) ;
			GP2( SCW	, y ) ;	GXColor1u16( Color1 ) ;
		}
		GXEnd() ;
	}
	else
	{
		u16 LineNum, i ;
		f32 HLength, OneLength ;
	
		// \͂̏ꍇ̏s
		
		// FZbg	
		Color1 = SpGage->Type == 0 ? GXPackedRGBA4( VParam[ED_SAR][1], VParam[ED_SAR][2], VParam[ED_SAR][3], 255 ) :
									GXPackedRGBA4( VParam[ED_SAR][4], VParam[ED_SAR][5], VParam[ED_SAR][6], 255 ) ;

		// [^[̂܂C`悷
		if( SpGage->ChargeState * SpGage->RenderCounter != 0.0F )
		{
			f32 f, f2 ;
			
			// `悷郉C̐Zo
			{
				f = ( SpGage->ChargeState * SpGage->RenderCounter ) * LINE_DIVNUM ;
				f2 = fmod( f, 1.0F ) ;
				LineNum = (u16)( (s32)( f - f2 ) + ( f2 != 0.0F ? 1 : 0 ) ) ;
			}
			
			// ʂ̏c̎c̒ƁAꂽ{̃C̒Zo
			HLength = SCH - ( Point.y ) ;
			OneLength = HLength / LINE_DIVNUM ;
			
			// `揈Jn
			GXBegin( GX_LINES, GX_VTXFMT0, (u16)( LineNum * 2 ) ) ;
			{
				// e[uɏĂ䂭
				for( i = 0 ; i < LineNum - 1 ; i ++ )
				{
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength ) ; GXColor1u16( Color1 ) ;
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength + OneLength ) ; GXColor1u16( Color1 ) ;
				}
				
				// Ō̈{`
				if( f2 != 0.0F )
				{
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength ) ; GXColor1u16( Color1 ) ;
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength + OneLength * f2 ) ; GXColor1u16( Color1 ) ;
				}
				else
				{
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength ) ; GXColor1u16( Color1 ) ;
					GP2( Point.x + Width, Point.y + Height + SpGage->DivTable[i] * HLength + OneLength ) ; GXColor1u16( Color1 ) ;
				}
			}
			GXEnd() ;
		}
	}

	// I
	return 0 ;
#else
	Effect = Effect ;
	return 0 ;
#endif
}

// `[WZbg(1.0F:őlBҋ@   0.0F:܂ĂȂ)
extern s8 SetSpSkillGageRate( f32 GageRate, EFFECT *Effect )
{
#ifndef __NOCODE
	SPSKILLGAGEEFFECT *SpSkillGage = ( SPSKILLGAGEEFFECT * )Effect->Data ;

	SpSkillGage->ChargeState = GageRate ;
	
	// I
	return 0 ;
#else
	GageRate = GageRate ;
	Effect = Effect ;
	return 0 ;
#endif
}

// XLQ[W`悷邩ǂ̃tOZbg
extern s8 SetSpSkillGageRenderFlag( u8 RenderFlag, EFFECT *Effect )
{
#ifndef __NOCODE
	SPSKILLGAGEEFFECT *SpSkillGage = ( SPSKILLGAGEEFFECT * )Effect->Data ;
	
	SpSkillGage->RenderFlag = RenderFlag ;
	SpSkillGage->RenderCounter = 0.0F ;
	
	// I
	return 0 ;
#else
	RenderFlag = RenderFlag ;
	Effect = Effect ;
	return 0 ;
#endif
}


