///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectSteam
//
// YK7EffectSteam.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 01/31/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectSteam.h"
#include "./YK7EffectBillboard.h"

// define ---------------------------------------

// datatype -------------------------------------

// data -----------------------------------------

STEAMUNION SteUnion ;

// function proto type --------------------------

// function code --------------------------------

// CGtFNg̋ʃf[^
extern s8 InitSteamData( void )
{
	MEMINIT( SteUnion ) ;

	SetupBillboardEffectID( BILLEFF_STEAM ) ;
	
	// I
	return 0 ;
}

// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckSteamData( void )
{
	if( CheckBillboardEffectIDState( BILLEFF_STEAM ) == FALSE ) return FALSE ;

	return TRUE ;
}


// CGtFNg̋ʃf[^n
extern s8 EndSteamData( void )
{
	MEMINIT( SteUnion ) ;
	
	ReleaseBillboardEffectID( BILLEFF_STEAM ) ;

	// I
	return 0 ;
}


// C̃GtFNg쐬
extern EFFECT *CreateSteamEffect(	WK7JObj *JObj,				// CoWĂ JObj ւ̃|C^
									f32 CreateSpeed,			// 쐬x
									f32 Size,					// C̑傫
									s32 BillID,					// GtFNg^Cv
									s32 Priority )
{
	STEAMEFFECT *Steam ;
	EFFECT *Effect, *Bill ;

	// r{[hGtFNg쐬
	Bill = CreateBillboardEffect2( (s8)BillID, (Vec){0.0F,0.0F,0.0F}, 0.0F,
									(u32)( VParam[ED_STEAM][14] ), NULL, -4 ) ;
	if( Bill == NULL ) return NULL ;

	// r{[hGtFNg̃ZbgAbv
	SetBillboardCreateFlag( Bill, FALSE ) ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_STEAM, (void**)&Steam, Priority ) ;
	if( Effect == NULL )
	{
		DeleteEffect( Bill ) ;
		return NULL ;
	}

	// f[^̏
	Steam->BillEffID = GetEffectID( Bill ) ;
	Steam->BillEff = Bill ;
	Steam->CreateCounter = 0.0F ;
	Steam->CreateSpeed = CreateSpeed ;
	Steam->Size = Size ;
	Steam->JObj = JObj ;

	// I
	return Effect ;
}

// C̃GtFNǧns
extern s8 ReleaseSteamEffect( EFFECT *Effect )
{
	STEAMEFFECT *Steam = ( STEAMEFFECT * )Effect->Data ;

	if( CheckEffectValidState( Steam->BillEff, Steam->BillEffID ) == TRUE )
	{
		DeleteEffect( Steam->BillEff ) ;
	}

	// ɂ邱ƂȂ
	return 0 ;
}

// C̃GtFNgPt[
extern s8 MoveSteamEffect( EFFECT *Effect )
{
	STEAMEFFECT *ST = ( STEAMEFFECT * )Effect->Data ;

	if( (STEAMEFFECT *)NULL == ST ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && GetBillboardEffectObjectNum( ST->BillEff ) == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	// r{[h쐬
	if( Effect->DelReqFlag == FALSE )
	{
		Vec Pos ;
		f32 Rate ;

		Rate = ( ST->JObj->GetJObj()->rotate.z * 360.0F / PI_2 ) - 1.0F ;
		ST->CreateCounter += (f32)ST->CreateSpeed * Rate ;
		while( ST->CreateCounter > 1.0F )
		{
			ST->CreateCounter -= 1.0F ;

			// JObj ̍W𓾂
			HSD_JObjSetupMatrix( ST->JObj->GetJObj() ) ;
			Pos.x = ST->JObj->GetJObj()->mtx[0][3] ;
			Pos.y = ST->JObj->GetJObj()->mtx[1][3] ;
			Pos.z = ST->JObj->GetJObj()->mtx[2][3] ;
			
			// 
			AddBillboardEffectObject( ST->BillEff, Pos, NULL ) ;
		}
	}
	
	// I
	return 0 ;
}
	
// C̃GtFNg`悷
extern s8 DrawSteamEffect( EFFECT *Effect )
{
	STEAMEFFECT *ST = ( STEAMEFFECT * )Effect->Data ;

	if( (STEAMEFFECT *)NULL == ST ) return 0 ;

	// I
	return 0 ;
}

// C̃TCY
extern s8 SetSteamEffectSize( EFFECT *Effect, f32 Size )
{
	STEAMEFFECT *Steam = ( STEAMEFFECT * )Effect->Data ;

	Steam->Size = Size ;
	SetBillboardSizeRate( Steam->BillEff, Steam->Size ) ;

	// I
	return 0 ;
}
	

