///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectTeleport
//
// YK7EffectTeleport.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 02/02/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

// include --------------------------------------
#include "./YK7EffectTeleport.h"
#include "./YK7EffectLight.h"

// define ---------------------------------------

#define MAXDIVNUM	30

// datatype -------------------------------------

// data -----------------------------------------

TELEPORTUNION TlpUnion ;

// function code --------------------------------

// e|[gGtFNg̋ʃf[^
extern s8 InitTeleportData( void )
{
	MEMINIT( TlpUnion ) ;

	// I
	return 0 ;
}

// e|[gGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckTeleportData( void )
{
	return TRUE ;
}


// e|[gGtFNg̋ʃf[^n
extern s8 EndTeleportData( void )
{
	MEMINIT( TlpUnion ) ;

	// I
	return 0 ;
}


// e|[g̃GtFNg쐬
extern EFFECT *CreateTeleportEffect(
					Vec Pos,								// GtFNg̒SW
					s32 TexNumber,							// gpeNX`io[

					f32 Width,								// ŏ̕
					f32 Height,								// ő̍

					f32 MaxSinSpeed, f32 MinSinSpeed,		// TCXs[h̍ŏlƍől

					f32 mHyouSpeed,							// ڕW̒lɋ߂Â	
					f32 HeightSubRate,						// Ƃɍ闦
					GXColor Color,							// F
					 s32 Priority )
{
	TELEPORTEFFECT *Tl ;
	TELEPORTOBJECT *ob ;
	EFFECT *Effect ;

	// Ve|[gf[^쐬
	Effect = AddEffectData( EFF_TELEPORT, (void**)&Tl, Priority ) ;
	if( Effect == NULL ) return NULL ;

	// f[^
	Tl->Pos = Pos ;
	Tl->TexNumber = TexNumber ;
	Tl->Width = Width ;
	Tl->Height = Height ;
	Tl->MaxSinSpeed = MaxSinSpeed ;
	Tl->MinSinSpeed = MinSinSpeed ;
	Tl->mHyouSpeed = mHyouSpeed ;
	Tl->HeightSubRate = HeightSubRate ;
	Tl->Color = Color ;
	Tl->ScaleExFlag = FALSE ;
	
	// IuWFNg̏s
	{
		f32 h ;
		s32 i ;

		h = Tl->Height ;
		ob = Tl->Obj ;
		for( i = 0 ; i < VParam[ED_TELEPORT][18] ; i ++, ob ++, h *= Tl->HeightSubRate )
		{
			ob->Width = ( VParam[ED_TELEPORT][0] * 0.1F ) * i + Tl->Width ;
			ob->MaxHeight = h ;
			ob->a = 0.0F ;
			ob->Height = 0.0F ;
			ob->SinCounter = 0.0F ;
		}
	}
	SetTeleportEffectRenderFlag( TRUE, Effect, FALSE ) ;

	// I
	return Effect ;
}

// e|[g̃GtFNǧns
extern s8 ReleaseTeleportEffect( EFFECT *Effect )
{
	TELEPORTEFFECT *Tl = ( TELEPORTEFFECT * )Effect->Data ;

	// ɂ邱ƂȂ
	return 0 ;
}

// e|[g̃GtFNgPt[
extern s8 MoveTeleportEffect( EFFECT *Effect )
{
	TELEPORTEFFECT *Tl = ( TELEPORTEFFECT * )Effect->Data ;
	TELEPORTOBJECT *ob ;

	if( (TELEPORTEFFECT *)NULL == Tl ) return 0 ;
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	// 폜tOĂ폜
	if( Effect->DelReqFlag == TRUE && Tl->ScaleExFlag == FALSE )
	{
		if( Tl->DeleteCounter == 0 )
		{
			DeleteEffect( Effect ) ;
			return 0 ;
		}
		else
		{
			Tl->DeleteCounter -- ;
		}
	}
	
	// ڂ
	{
		s32 i ;
		u8 ScaleExFlag ;

		ob = Tl->Obj ;
		ScaleExFlag = FALSE ;
		for( i = 0 ; i < VParam[ED_TELEPORT][18] ; i ++, ob ++ )
		{
			if( ob->Wait != 0 )
			{
				ob->Wait -- ;
			}
			else
			{
				if( ob->ScaleExFlag == TRUE )
				{
					ScaleExFlag = TRUE ;
					ob->Height += (f32)( ob->mHeight - ob->Height ) / ( Tl->mHyouSpeed / ( (f32)VParam[ED_TELEPORT][19] * 0.1F ) ) ;

					if( ob->a < ob->ma )
					{
						ob->a += (f32)VParam[ED_TELEPORT][2] / 255.0F * ( (f32)VParam[ED_TELEPORT][19] * 0.1F ) ;
						if( ob->a > ob->ma ) ob->a = ob->ma ;
					}
					else
					{
						ob->a -= (f32)VParam[ED_TELEPORT][2] / 255.0F * ( (f32)VParam[ED_TELEPORT][19] * 0.1F ) ;
						if( ob->a < ob->ma ) ob->a = ob->ma ;
					}

					if( fabs(ob->mHeight - ob->Height) < 1.0F )
					{
						ob->ScaleExFlag = FALSE ;
						
						if( Effect->DelReqFlag == TRUE )
						{
							SetTeleportEffectRenderFlag( FALSE, Effect, FALSE ) ;
						}
						else
						{
							SetTeleportEffectRenderFlag( TRUE, Effect, FALSE ) ;
						}
					}
				}
				else
				{
					ob->Height += (f32)( ob->mHeight - ob->Height ) / Tl->mHyouSpeed ;

					if( ob->a < ob->ma )
					{
						ob->a += (f32)VParam[ED_TELEPORT][2] / 255.0F ;
						if( ob->a > ob->ma ) ob->a = ob->ma ;
					}
					else
					{
						ob->a -= (f32)VParam[ED_TELEPORT][2] / 255.0F ;
						if( ob->a < ob->ma ) ob->a = ob->ma ;
					}
				}
				
			}
			
			ob->SinCounter += ob->SinSpeed ;
			if( ob->SinCounter > PI_2 ) ob->SinCounter -= PI_2 ;
		}
		
		Tl->ScaleExFlag = ScaleExFlag ;
	}
	
	// I
	return 0 ;
}
	
// e|[g̃GtFNg`悷
extern s8 DrawTeleportEffect( EFFECT *Effect )
{
	TELEPORTEFFECT *Tl = ( TELEPORTEFFECT * )Effect->Data ;
	TELEPORTOBJECT *ob ;
	s32 i, j, DivNum ;
	u32 color ;
	f32 xx[MAXDIVNUM], zz[MAXDIVNUM] ;
	f32 Sin, Cos, SinWidth, RotLength ;
	Vec p ;
	 
	if( (TELEPORTEFFECT *)NULL == Tl ) return 0 ;
	
	if( VParam[ED_TELEPORT][18] > TELEPOBJ_MAXNUM ) VParam[ED_TELEPORT][18] = TELEPOBJ_MAXNUM ;
	
	DivNum = VParam[ED_TELEPORT][1] ;
	RotLength = VParam[ED_TELEPORT][7] * PI_2 / ( DivNum - 1 ) ;

	// ~
	for( i = 0 ; i < DivNum ; i ++ )
	{
		xx[i] = COSF( PI_2 / ( DivNum - 1 ) * i ) ;
		zz[i] = SINF( PI_2 / ( DivNum - 1 ) * i ) ;
	}
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS,	EF_BLEND_ADD, EF_TEV_USETEX ) ;	
	
	// eNX`Zbg
	if( GetLightTex( Tl->TexNumber ) == NULL ) return 0 ;
	GTLOAD( GetLightTex( Tl->TexNumber ) ) ;
	
	// e|[gGtFNg`悷
	GBGN( GX_TRIANGLESTRIP, ( DivNum * 2 + 2 ) * VParam[ED_TELEPORT][18] ) ;
	{
		ob = Tl->Obj ;
		for( i = 0 ; i < VParam[ED_TELEPORT][18] ; i ++, ob ++ )
		{
			j = 0 ;
			
			color = CMKC2( Tl->Color, ob->a * 255 * ( Tl->Color.a / 255.0F ) ) ;

			// Sin  Cos Zo
			if( i % 2 == 0 )
			{
				Sin = SINF( -ob->SinCounter ) ;
				Cos = COSF( -ob->SinCounter ) ;
			}
			else
			{
				Sin = SINF( ob->SinCounter ) ;
				Cos = COSF( ob->SinCounter ) ;
			}
			
			// y ̐GꕝZo
			SinWidth = ( ob->Height * VParam[ED_TELEPORT][5] * 0.01F ) / 2.0F ;
		
			// ŏ̒_o
			p.x = ( xx[0] * Cos - zz[0] * Sin ) * ob->Width + Tl->Pos.x ;
			p.z = ( xx[0] * Sin + zz[0] * Cos ) * ob->Width + Tl->Pos.z ;
//			p.y = ob->Height - SinWidth + SINF( -ob->SinCounter + RotLength * j ) * SinWidth ;
			p.y = 0.0F + Tl->Pos.y ;
			
			GPV( p ) ;	GCX( color ) ;	GT( 0.0F, 1.0F ) ;
		
			// _o
			for( j = 0 ; j < DivNum ; j ++ )
			{
				p.x = ( xx[j] * Cos - zz[j] * Sin ) * ob->Width + Tl->Pos.x ;
				p.z = ( xx[j] * Sin + zz[j] * Cos ) * ob->Width + Tl->Pos.z ;
				p.y = 0.0F + Tl->Pos.y ;
				
				GPV( p ) ;	GCX( color ) ;	GT( ( 1.0F / DivNum ) * j, 1.0F ) ;

			
				p.y = ( ob->Height - SinWidth + SINF( -ob->SinCounter + RotLength * j ) * SinWidth ) + Tl->Pos.y ;

				GPV( p ) ;	GCX( color ) ;	GT( ( 1.0F / DivNum ) * j, 0.0F ) ;
			}
			
			// Ō̒_o
			GPV( p ) ;	GCX( color ) ;	GT( ( 1.0F / DivNum ) * j, 0.0F ) ;
		}
	}
	GXEnd() ;

	// I
	return 0 ;
}

// 폜NGXgs
extern s8 DelReqTeleportEffect( EFFECT *Effect )
{
	TELEPORTEFFECT *Tl = ( TELEPORTEFFECT * )Effect->Data ;
	
	Tl->DeleteCounter = (u8)VParam[ED_TELEPORT][6] ;

	// I
	return 0 ;
}

// `tOZbg
extern s8 SetTeleportEffectRenderFlag( s8 Flag, EFFECT *Effect, s8 ScaleExFlag )
{
	TELEPORTEFFECT *Tl = ( TELEPORTEFFECT * )Effect->Data ;
	TELEPORTOBJECT *ob ;
	s32 i ;
	
	// IuWFNg̃ZbgAbvs
	ob = Tl->Obj ;
	for( i = 0 ; i < VParam[ED_TELEPORT][18] ; i ++, ob ++ )
	{
		if( Flag == TRUE )
		{
			if( ScaleExFlag == TRUE )
			{
				ob->ma = 1.0F ;
				ob->mHeight = ob->MaxHeight * ( (f32)VParam[ED_TELEPORT][20] * 0.1F ) ;
				ob->ScaleExFlag = TRUE ;
			}
			else
			{
				ob->ma = 1.0F ;
				ob->mHeight = ob->MaxHeight ;
				ob->ScaleExFlag = FALSE ;
			}
		}
		else
		{
			ob->ma = 0.0F ;
			ob->mHeight = 0.0F ;
			ob->ScaleExFlag = FALSE ;
		}

		ob->SinSpeed = GetRandF2Num( Tl->MaxSinSpeed, Tl->MinSinSpeed ) ;
		ob->SinCounter = GetRandFNum( PI_2 ) ;
		ob->Wait = (u8)( i * VParam[ED_TELEPORT][4] ) ;
	}

	Tl->ScaleExFlag = (u8)ScaleExFlag ;

	// I
	return 0 ;
}
	

