///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectVapor
//
// YK7EffectVapor.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 05/24/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectVapor.h"
#include "./YK7File.h"
#include "./YK7EffectSmoke.h"

// define ---------------------------------------

#define PRM				(s32)VParam[ED_VAPOR]

#define VAPORCOLOR(x)		(CMK(255,80,80,(x) * 255))
#define VAPORSIZE			(1.0F)			// CGtFNg̃TCY
#define VAPORTIME			(10)			// CGtFNgoĂ鎞

#define TEX01PATH		"/Yam/Effect/Vapor/KVN_effect_a01.BIN"
#define TEX02PATH		"/Yam/Effect/Vapor/KVN_effect_a02.BIN"

// data -----------------------------------------

VAPORUNION vpu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// CGtFNg̋ʃf[^
extern s8 InitVaporData( void )
{
	MEMINIT( vpu ) ;

	return 0 ;
}

// CGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckVaporData( void )
{
	return TRUE ;
}

// CGtFNg̋ʃf[^n
extern s8 EndVaporData( void )
{
	MEMINIT( vpu ) ;
	
	// ɂ邱ƂȂ
	return 0 ;
}



// CGtFNg쐬
extern EFFECT *CreateVaporEffect(
								s32 objmaxnum,
								f32 crerate,

								WK7JObj *JObj,
								Vec *pos, Vec *dir,		// JObj Ȃꍇ
								f32 speed,
								f32 air,
								f32 maxsize, f32 minsize,
								f32 sizespeed,
								f32 rotspeed,
								f32 rotrange,
								u32 color,
								s32 drawtime,
								f32 fadespeed,
								u32 outtime,
								u32 stoptime,

								s32 soundid,
								s32 Priority )
{
	EFFECT *Effect ;
	VAPOREFFECT *vp ;
	VAPOROBJECT *ob ;
	
	ob = ( VAPOROBJECT * )K7AppSmallMemAllocName( (s32)( sizeof( VAPOROBJECT ) * objmaxnum ), "Y_VAPOB" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( VAPOROBJECT ) * objmaxnum ) ;

	// VCf[^쐬
	Effect = AddEffectData( EFF_VAPOR, (void**)&vp, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}
	
	// lۑ
	vp->obj			= ob ;
	vp->objnum		= 0 ;
	vp->objmaxnum	= objmaxnum ;
	vp->JObj		= JObj ;
	if( pos != NULL ) vp->pos = *pos ; else GetJObjPos( JObj->GetJObj(), &vp->pos ) ;
	if( dir != NULL ) vp->dir = *dir ;
	vp->speed		= speed ;
	vp->air			= air ;
	vp->maxsize		= maxsize ;
	vp->minsize		= minsize ;
	vp->sizespeed	= sizespeed ;
	vp->rotspeed	= rotspeed ;
	vp->rotrange	= rotrange ;
	{
		s32 t ;
		
		t = GetRandINum( (s32)( outtime + stoptime ) ) ;
		if( t > stoptime )
		{
			vp->mod = 1 ;
			vp->con = (s32)( t - stoptime ) ;
		}
		else
		{
			vp->mod = 0 ;
			vp->con = t ;
		}
	}
	
	vp->stoptime	= stoptime ;
	vp->outtime		= outtime ;

	vp->color		= color ;
	vp->crerate		= crerate ;
	vp->crecounter	= 0.0F ;
	
	vp->initalpha	= drawtime * fadespeed + 1.0F ;
	vp->fadespeed 	= fadespeed ;
	
	vp->soundid		= soundid ;

	// I
	return Effect ;
}

// CGtFNǧns
extern s8 ReleaseVaporEffect( EFFECT *Effect )
{
	VAPOREFFECT *vp = ( VAPOREFFECT * )Effect->Data ;
	
	if( vp->obj != NULL ) K7AppSmallMemFree( vp->obj ) ;

	// I
	return 0 ;
}

// CGtFNgPt[
extern s8 MoveVaporEffect( EFFECT *Effect )
{
	VAPOREFFECT *vp = ( VAPOREFFECT * )Effect->Data ;
	VAPOROBJECT *ob ;
	s32 i, num ;
	
	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;
	
	if( Effect->DelReqFlag == TRUE && vp->objnum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
	num = vp->objnum ;
	ob = vp->obj ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->validf == FALSE ) continue ;
		
		i ++ ;
		
		ob->pos.x += ob->speed.x ;
		ob->pos.y += ob->speed.y ;
		ob->pos.z += ob->speed.z ;
		ob->speed.x *= vp->air ;
		ob->speed.y *= vp->air ;
		ob->speed.z *= vp->air ;
		ob->size += vp->sizespeed ;
		if( ob->size >= 1.0F )
		{
			ob->size = 1.0F ;
		}
		
		ob->alpha -= vp->fadespeed ;
		if( ob->alpha <= 0.0F )
		{
			ob->validf = FALSE ;
			vp->objnum -- ;
		}
	}
	
	if( vp->mod == 0 )
	{
		vp->con ++ ;
		if( vp->con >= vp->stoptime )
		{
			vp->mod = 1 ;
			vp->con = 0 ;
			
			if( vp->soundid != -1 ) PlayEffectSE3D( vp->soundid, vp->pos ) ;
		}
	}
	else
	{
		vp->con ++ ;
		if( vp->con >= vp->outtime )
		{
			vp->mod = 0 ;
			vp->con = 0 ;
		}
	
		if( Effect->DelReqFlag == FALSE ) vp->crecounter += 1.0F ;
		while( Effect->DelReqFlag == FALSE && vp->objnum != vp->objmaxnum && vp->crecounter > vp->crerate )
		{
			f32 oir, xz, len, ang, speed  ;
			
			vp->objnum ++ ;
			vp->crecounter -= vp->crerate ;
			
			for( ob = vp->obj ; ob->validf ; ob ++ ){}

			ob->validf = TRUE ;
			if( vp->JObj != NULL )
			{
				GetJObjZVec( vp->JObj->GetJObj(), &ob->speed ) ;
				GetJObjPos( vp->JObj->GetJObj(), &ob->pos ) ;
			}
			else
			{
				ob->pos = vp->pos ;
				ob->speed = vp->dir ;
			}
			
			GetDirAngle( ob->speed, &oir, &xz ) ;
			len = GetRandFNum( vp->rotrange ) ;
			ang = GetRandFNum( PI_2 ) ;
			oir += SINF( ang ) * len ;
			xz += COSF( ang ) * len ;
			GetDirVec( &ob->speed, oir, xz ) ;
			
			ob->alpha = vp->initalpha ;

			speed = GetRandF2Num( vp->speed, vp->speed / 2.0F ) ;
			ob->speed.x *= speed ;
			ob->speed.y *= speed ;
			ob->speed.z *= speed ;

			speed = GetRandFNum( 1.0F ) ;
			ob->pos.x += ob->speed.x * speed ;
			ob->pos.y += ob->speed.y * speed ;
			ob->pos.z += ob->speed.z * speed ;

			ob->size = 0.0F ;
			ob->rot = 0.0F ;
		}
	}

	// I
	return 0 ;
}

// CGtFNg`悷
extern s8 DrawVaporEffect( EFFECT *Effect )
{
	VAPOREFFECT *vp = ( VAPOREFFECT * )Effect->Data ;
	VAPOROBJECT *ob ;
	Mtx mt ;
	Vec tv[4] ;
	u32 cr ;
	s32 i ;
	f32 size ;

	// `̏
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ALPHA, EF_TEV_USETEX, TRUE ) ;

	// eNX`̃[h
	GTLOAD( GetSmokeTex() ) ;

	// ts̎擾
	EffectGetInvViewMatrix( mt ) ;

	// _̏
	CreateBillVert( mt, tv ) ;

	if( vp->objnum == 0 ) return 0 ;
	
	GBGN( GX_QUADS, vp->objnum * 4 ) ;
	{
		ob = vp->obj ;
		for( i = 0 ; i < vp->objnum ; ob ++ )
		{
			if( ob->validf == FALSE ) continue ;
			
			i ++ ;

			size = ob->size * ( vp->maxsize - vp->minsize ) + vp->minsize ;

			cr = CMKC2( vp->color, ob->alpha > 1.0F ? ( vp->color & 0xff ) : ob->alpha * ( vp->color & 0xff ) ) ;			
			GP3( ob->pos.x + tv[0].x * size, ob->pos.y + tv[0].y * size, ob->pos.z + tv[0].z * size ) ;
			GCX( cr ) ;			GT( 0.0F, 0.0F ) ;

			GP3( ob->pos.x + tv[1].x * size, ob->pos.y + tv[1].y * size, ob->pos.z + tv[1].z * size ) ;
			GCX( cr ) ;			GT( 1.0F, 0.0F ) ;

			GP3( ob->pos.x + tv[2].x * size, ob->pos.y + tv[2].y * size, ob->pos.z + tv[2].z * size ) ;
			GCX( cr ) ;			GT( 1.0F, 1.0F ) ;

			GP3( ob->pos.x + tv[3].x * size, ob->pos.y + tv[3].y * size, ob->pos.z + tv[3].z * size ) ;
			GCX( cr ) ;			GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;

	// I
	return 0 ;
}

#define TYPENUM		(2)
const s32 _VPTable[TYPENUM][20] =
{
	{	// 0:775M01p
		651,	80,		100,	15,		255,
		255,	255,	128,	10,		20,

		10,		2,		10,		10,		50,
		40,		SFX_SCE0_STEAM_MINI,		0,		0,		0,
	},

	{	// 0:775M02p
		712,	80,		227,	35,		255,
		255,	255,	128,	6,		3,

		10,		2,		10,		10,		50,
		40,		SFX_SCE0_STEAM_BIG,		0,		0,		0,
	},
} ;

// CGtFNg쐬
extern EFFECT *CreateVaporEffect(
								u8 type,				// ^Cv( 0: 775M01p )
								WK7JObj *JObj,
								Vec *pos, Vec *dir,		// JObj Ȃꍇ
								s32 Priority )
{
	if( type >= TYPENUM ) return NULL ;
	return CreateVaporEffect(
			_VPTable[type][8] * 100,			// maxobjnum
			1.0F / _VPTable[type][9],			// crerate
			
			JObj,								// jobj
			pos, dir,							// pos, dir
			_VPTable[type][0] * 0.01F,			// speed
			_VPTable[type][1] * 0.01F,			// air
			_VPTable[type][2] * 0.1F, _VPTable[type][3] * 0.1F,		// maxsize, minsize
			_VPTable[type][11] * 0.01F,			// sizespeed
			0.0F,								// rotspeed
			_VPTable[type][10] * PI_2 / 360.0F,	// rotrange
			CMK( _VPTable[type][4], _VPTable[type][5], _VPTable[type][6], _VPTable[type][7] ),	// color,
			(s32)_VPTable[type][12],			// drawtime
			_VPTable[type][13] * 0.01F,			// fadespeed
			(u32)_VPTable[type][15],			// outtime
			(u32)_VPTable[type][14],			// stoptime
			_VPTable[type][16],					// soundid
			Priority ) ;
}


