///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7EffectWash
//
// YK7EffectWash.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 04/08/2004
//
//////////////////////////////////////////////////////////////////////////////

#define	__YK7TESTTASK_CPP__

//#define DEBUG_MODE

// include --------------------------------------
#include "./YK7EffectWash.h"
#include "./YK7EffectStaticData.h"

// define ---------------------------------------

#define TEXPATH		"/Yam/Effect/Wash/Wash.BIN"

#define PR			VParam[ED_WASH]
#define SIZE		((f32)PR[0] * 0.01F)

// data -----------------------------------------

WASHUNION whu ;

// datatype -------------------------------------

// function proto type --------------------------

// function code --------------------------------

// EHbVGtFNg̋ʃf[^
extern s8 InitWashData( void )
{
	MEMINIT( whu ) ;

//	TexLoadSet( TEXPATH, &whu.WashTex ) ;
	TexLoadSetMem( EffSys.PackFile->GetGroup()->GetGroup( STDAT_OTHER )->GetResource( STDAT_OTH_WASH ), &whu.WashTex ) ;

	
	return 0 ;
}

// EHbVGtFNgɎgp풓f[^̓ǂݍ݂ǂ擾( TRUE:  FALSE:܂ )
extern s8 CheckWashData( void )
{
//	if( TexLoadChk( &whu.WashTex ) == FALSE ) return FALSE ;
	return TRUE ;
}

// EHbVGtFNg̋ʃf[^n
extern s8 EndWashData( void )
{
	TexRelease( &whu.WashTex ) ;

	MEMINIT( whu ) ;
	
	// I
	return 0 ;
}




// EHbVGtFNg쐬
extern EFFECT *CreateWashEffect(
						s32 MaxNum,					// ő吔
						f32 CreateRate,				// IuWFNg쐬鑬x
						
						WK7JObj *JObj,				// EIbV̍ŏʈʒuW JObj
						f32 Len,					// EIbV̒

						f32 YukaY,					// ̍

						f32 Gravity,				// d
						f32 MaxSpeed, f32 MinSpeed,	// ő呬xAŏx

						GXColor color1,				// FP
						GXColor color2,				// FQ
						s32 Priority )				// EHbVGtFNg쐬
{
	EFFECT *Effect ;
	WASHEFFECT *wh ;
	WASHOBJECT *ob ;
	
	// IuWFNgi[郁̈mۂ
	ob = ( WASHOBJECT * )K7AppSmallMemAllocName( (int)( sizeof( WASHOBJECT ) * MaxNum ), "WhObj" ) ;
	if( ob == NULL ) return NULL ;
	memset( ob, 0, sizeof( WASHOBJECT ) * MaxNum ) ;
	
	// VEHbVf[^쐬
	Effect = AddEffectData( EFF_WASH, (void**)&wh, Priority ) ;
	if( Effect == NULL )
	{
		K7AppSmallMemFree( ob ) ;
		return NULL ;
	}

	// ̏
	wh->Obj 			= ob ;
	wh->ObjNum 			= 0 ;
	wh->MaxNum 			= MaxNum ;
	wh->CreateRate 		= CreateRate ;
	wh->CreateCounter 	= 0.0F ;
	
	wh->JObj 			= JObj ;
	wh->Len 			= Len ;

	wh->YukaY			= YukaY ;

	wh->SpeedRate 		= 0.0F ;
	wh->Gravity 		= Gravity ;
	wh->MaxSpeed 		= MaxSpeed ;
	wh->MinSpeed 		= MinSpeed ;
	
	wh->color 			= *((u32 *)&color1) ;
	wh->colorrate 		= 0.0F ;
	wh->color1 			= color1 ;
	wh->color2 			= color2 ;

	// I
	return Effect ;
}

// EHbVGtFNǧns
extern s8 ReleaseWashEffect( EFFECT *Effect )
{
	WASHEFFECT *wh = ( WASHEFFECT * )Effect->Data ;

	CHKMEMFREE2( wh->Obj ) ;

	// I
	return 0 ;
}

// EHbVGtFNgPt[
extern s8 MoveWashEffect( EFFECT *Effect )
{
	WASHEFFECT *wh = ( WASHEFFECT * )Effect->Data ;
	WASHOBJECT *ob ;
	s32 i, num ;
//	static Vec p ;
//	static bool f = false ;

	if( StopFlag == TRUE && RunFrame == 0 ) return 0 ;

	if( Effect->DelReqFlag == TRUE && wh->ObjNum == 0 )
	{
		DeleteEffect( Effect ) ;
		return 0 ;
	}
	
//	GetRandFNum( 1.0F ) ;
	
	wh->CreateCounter += 1.0F ;
	while( wh->CreateCounter >= 1.0F && wh->ObjNum < wh->MaxNum && Effect->DelReqFlag == FALSE )
	{
		f32 len, speed ;
	
		for( ob = wh->Obj ; ob->validf ; ob ++ ){}

		ob->validf = TRUE ;

		len = GetRandFNum( wh->Len ) ;
		wh->JObj->GetWorldPosition( &ob->pos ) ;
/*		if( f == false )
		{
			wh->JObj->GetWorldPosition( &p ) ;
			f = true ;			
		}
		ob->pos = p ;
*/		ob->pos.y -= len ;
		
		GetDirVec( &ob->speed, GetRandFNum( PI - PI / 4 ) - ( PI - PI / 4 ) / 2, GetRandFNum( PI_2 ) ) ;
		speed = GetRandF2Num( wh->MaxSpeed, wh->MinSpeed ) ;
		ob->speed.x *= speed ;
		ob->speed.y *= speed ;
		ob->speed.z *= speed ;
	
		wh->ObjNum ++ ;
	}
	
	ob = wh->Obj ;
	num = wh->ObjNum ;
	for( i = 0 ; i < num ; ob ++ )
	{
		if( ob->validf == FALSE ) continue ;
		
		i ++ ;
		
		ob->speed.y -= wh->Gravity ;
		ob->pos.x += ob->speed.x ;
		ob->pos.y += ob->speed.y ;
		ob->pos.z += ob->speed.z ;
		
		if( ob->pos.y <= wh->YukaY )
		{
			ob->validf = FALSE ;
			wh->ObjNum -- ;
		}
	}

	// I
	return 0 ;
}

// EHbVGtFNg`悷
extern s8 DrawWashEffect( EFFECT *Effect )
{
	WASHEFFECT *wh = ( WASHEFFECT * )Effect->Data ;
	WASHOBJECT *ob ;
	s32 i, drawnum, num ;
	Vec tp[4] ;

	if( wh->ObjNum == 0 ) return 0 ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_PERS, EF_BLEND_ADD, EF_TEV_USETEX ) ;
	
	CreateBillVert( NULL, &tp[0], SIZE, SIZE, 0.0F ) ;
	
	GTLOAD2( whu.WashTex ) ;

	wh->color = (u32)
				( (u8)( wh->colorrate * (f32)wh->color2.r + ( 1.0F - wh->colorrate ) * (f32)wh->color1.r ) << 24 ) |
				( (u8)( wh->colorrate * (f32)wh->color2.g + ( 1.0F - wh->colorrate ) * (f32)wh->color1.g ) << 16 ) |
				( (u8)( wh->colorrate * (f32)wh->color2.b + ( 1.0F - wh->colorrate ) * (f32)wh->color1.b ) << 8 ) |
				( (u8)( wh->colorrate * (f32)wh->color2.a + ( 1.0F - wh->colorrate ) * (f32)wh->color1.a ) ) ;
	
/*
	GBGN( GX_QUADS, 4 ) ;
	{
		ob = wh->Obj ;
		for( i = 0 ; i < 1 ; ob ++ )
		{
			if( ob->validf == FALSE ) continue ;
			
			i ++ ;
			GPV3( tp[0], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 0.0F ) ;
			GPV3( tp[1], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 0.0F ) ;
			GPV3( tp[2], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 1.0F ) ;
			GPV3( tp[3], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 1.0F ) ;
		}
	}
	GEND() ;
*/
	
/*	if( wh->ObjNum * 4 > 65535 )
	{
		wh->ObjNum = 0 ;
	}
*/
//	OSReport( "Num:%d\n", wh->ObjNum ) ;

#define NUM (65535/4)

	num = wh->ObjNum ;
	drawnum = num ;
	if( drawnum > NUM ) drawnum = NUM ;
	num -= drawnum ;
	
	GBGN( GX_QUADS, drawnum * 4 ) ;
	{
		ob = wh->Obj ;
		for( i = 0 ; i < wh->ObjNum ; ob ++ )
		{
			if( ob->validf == FALSE ) continue ;
			
			i ++ ;
			
			GPV3( tp[0], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 0.0F ) ;
			GPV3( tp[1], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 0.0F ) ;
			GPV3( tp[2], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 1.0F ) ;
			GPV3( tp[3], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 1.0F ) ;
			
			drawnum -- ;
			if( drawnum == 0 )
			{
				GEND() ;
				if( num != 0 )
				{
					drawnum = num ;
					if( drawnum > NUM ) drawnum = NUM ;
					num -= drawnum ;
					
					GBGN( GX_QUADS, drawnum * 4 ) ;
				}
			}			
		}
	}
//	GEND() ;
	
/*
	GBGN( GX_QUADS, wh->ObjNum * 4 ) ;
	{
		ob = wh->Obj ;
		for( i = 0 ; i < wh->ObjNum ; ob ++ )
		{
			if( ob->validf == FALSE ) continue ;
			
			i ++ ;
			
//			GBGN( GX_QUADS, 4 ) ;
			GPV3( tp[0], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 0.0F ) ;
			GPV3( tp[1], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 0.0F ) ;
			GPV3( tp[2], ob->pos ) ;	GCX( wh->color ) ;		GT( 1.0F, 1.0F ) ;
			GPV3( tp[3], ob->pos ) ;	GCX( wh->color ) ;		GT( 0.0F, 1.0F ) ;
//			GEND() ;
		}
	}
	GEND() ;
*/
	// sysdolphinԖ
//	HSD_StateInvalidate(HSD_STATE_ALL);

	// I
	return 0 ;
}




// EHbṼXs[hɑ΂oCAXZbg
extern s8 SetWashSpeedRate( EFFECT *Effect, f32 rate )
{
	WASHEFFECT *wh = ( WASHEFFECT * )Effect->Data ;
	
	wh->SpeedRate = rate ;
	
	// I
	return 0 ;
}

// EIbV̐F̊ύX
extern s8 SetWashColorRate( EFFECT *Effect, f32 colorrate )
{
	WASHEFFECT *wh = ( WASHEFFECT * )Effect->Data ;
	
	wh->colorrate = colorrate ;
	
	// I
	return 0 ; ;
}

