///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7MapSelect
//
// YK7MapSelect.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 09/10/2003
//
//////////////////////////////////////////////////////////////////////////////

#ifdef YAMADADEBUG
	#define AUTO
	//#define OLD_MAP
//	#define DEBUG_0
	#ifdef _DEBUG
	#define DEBUG_MODE
	#endif
#else
	#define AUTO
	//#define OLD_MAP
	#ifdef _DEBUG
	#define DEBUG_MODE
	#endif
#endif

//#define DEBUG_MAP

// include --------------------------------------
#include "./YK7MapSelect.h"
#include "./YK7Effect.h"
#include "../matsu/mk7Sound.h"
#include "./KMap.h"
#include "./YK7String.h"
#include <stdio.h>
#include "./YK7Move.h"
#include "./CSelect.h"
#include "./YK7EffectSound.h"

// define ---------------------------------------

#define PR	VParam[ED_MAPSELECT]

#define STREAM_FADEOUTTIME		(400)
#define AFTERIMAGE_NUM			8					// c̐
#define AFTERIMAGE_MAXNUM		32					// c̍ő吔
#define MAP_MAXSELECTNUM		10					// Iő

#ifdef YAMADADEBUG
	#if 1
		#define TEXTSIZE		(info->TextSize * 0.01F)	// ꏊ̉
	#else
		#define TEXTSIZE		(PRM[3] * 0.01F)			// ꏊ̉
	#endif
#else
	#define TEXTSIZE		(info->TextSize * 0.01F)	// ꏊ̉
#endif

#define LINE_MINALPHA			(255 * 20 / 100)
#define LINE_ALPHA				((f32)PRM[26] * 0.01F)		// \(蒅)̃At@l
#define LINE_COLOR(a)			(CMK(100,100,100,(a)))		// C̐F

#define MAPSTARTWAIT			(80)						// }bvJn܂ł̑҂
#define MAPENDWAIT				(50)						// }bvȊ҂
#define MAPENDWAIT2				(50)						// }bvȊ҂
#define PIC_ZOOMSPEED			(12.0F)						// }bvIɎʐ^傫Ȃ鑬x
#define PIC_OUTZOOMRATE			(0.66F)						// }bv̎ʐ^tF[hAEgn߂g嗦
#define PIC_INITEXRATE			(IMAGEW / (f32)SCW)			// }bv̎ʐ^̏g嗦

#define NAMEJIKAN				(-2)						// 
#define NAMEBOTTOMY				(-PRM[9])					// ɖO\ꂽۂ̒xWl
#define MAXROOTNUM				(30)						// }bvړ̍ő僋[gʉ߃|Cg
#define NAMEZURE				(PRM[25])					// ÕYhbg
#define NAMEZURESPEED			((f32)PRM2[23] * 0.001F)	// ÕY̐ڃXs[h
#define PICZURESPEED			((f32)45 * 0.001F)			// ʐ^̃Y̐ڃXs[h

#define NAMEZUREX				(PRM[27])	// s於̃YsNZ
#define NAMEZUREY				(PRM[28])
#define NAMEZUREX2				(PRM[12])
#define NAMEZUREY2				(PRM[13])
#define NAMESHDA2				(PRM[11] * 255 / 100)

#define NAMESHDR				(0)			// s於e̐F
#define NAMESHDG				(0)
#define NAMESHDB				(30 * 255 / 100)
#define NAMESHDA				(PRM[29] * 255 / 100)

#define PICSHDR					(0)			// ʐ^̉e̐F
#define PICSHDG					(0)
#define PICSHDB					(30 * 255 / 100)
#define PICSHDA					(PRM[23] * 255 / 100)

#define PICZURE					(PRM[14])
#define PICSHDZURE				(PRM[22])

#define SELCHIPMUL				(79)
#define SELCHIPR				(29)		// IĂȂ`bv̐F
#define SELCHIPG				(78)
#define SELCHIPB				(5)
#define SELCHIPA				(185)

#define SELCHIPR2				(140)		// IĂ`bv̐F
#define SELCHIPG2				(19)
#define SELCHIPB2				(19)


#define CHIPSIZE				(PRM2[4])			// `bṽTCY
#define CHIPSUKIMA				(PRM2[5])			// `bvm̌Ԃ̕


#define REDBLURTEX				"/Yam/Map/red_blur.BIN"	// ԃu[eNX`pX
#define REDBLURSPEED			(0.02F)				// ԃu[L鑬x
#define REDBLURWAIT				(0.6F)				// ̃u[oĂ玟̃u[o܂ł̊Ԋu
#define REDBLURSIZE				(256)				// ԃu[̍őTCY

#define MAPZOOMSPEED			((f32)PRM[10] * 0.001F)	// }bṽY[CAAEg̑x
#define PICZOOMSPEED			((f32)40 * 0.001F)	// ʐ^̃Y[Xs[h

#define MAPFILEFOLDER			"/Yam/Map/"			// }bv֌W̃t@Ci[ĂtH_[
#define MAPFONTPATH				"MapFont_GC.BIN"	// }bv̍s\ɎgtHg̃pX

#define MAP_WIDTH				(64)				// }bv`bv̍ő啝
#define MAP_HEIGHT				(48)				// }bv`bv̍ŏ
#define MAP_OUTRAND				(PRM2[9])			// }bv`bv̑ޏȏޏoW̕

#define PRM2					(s32)VParam[ED_MAPSELECT2]
#define PRM						(s32)VParam[ED_MAPSELECT]

#define IMAGEW					(160)
#define IMAGEH					(120)

#define BIGIMAGEW				(640)
#define BIGIMAGEH				(480)

#define SCREENCONV(x)			((x) * (SCW / BIGMAPSIZE))

#define SMALLMAPUNITNUMX		(64)
#define SMALLMAPUNITNUMY		(48)
#define BIGMAPONECHIPUNITNUM	(BIGMAPSIZE/SMALLMAPSIZE)

#define MAPDIVNUM				(64.0F)
#define SMALLMAPSIZE			(1.0F / 16.0F)
#define BIGMAPSIZE				(1.0F)
#define BIGMAPSIZEH				(BIGMAPSIZE*((f32)SCH / SCW))
#define SMALLMAPONECHIPSIZE		(SMALLMAPSIZE / MAPDIVNUM)
#define BIGMAPONECHIPSIZE		(BIGMAPSIZE / MAPDIVNUM)

#define MAXCHIPSIZE				(1.0F / MAPDIVNUM)
#define MINCHIPSIZE				(MAXCHIPSIZE / 2.0F)
#define CHIPSIZEUNIT			(SMALLMAPONECHIPSIZE)

#define CAMLOOKSCALEX			(0.5F)
#define CAMLOOKSCALEY			(CAMLOOKSCALEX * ((f32)SCH / (f32)SCW))

#define CHIPMAXPACKNUM			(1)


#ifdef DEBUG_MAP
s32 DebugMapNumber = 0 ;
bool DebugFlag = false ;
char *DebugMapList[] =
{
	"shi_a01.BIN",
	"shi_a02.BIN",
	"shi_b01.BIN",
	"shi_b02.BIN",
	"shi_c02.BIN",
	"washi_a01.BIN",
	"washi_b01.BIN",
	
/*	"domi_a01.BIN",
	"domi_a02.BIN", 
	"domi_a03.BIN",
	"F5_a01.BIN",
	"F5_a02.BIN",
	"F5_a03.BIN",
	"N.Y_a01.BIN",
	"N.Y_a02.BIN",
	"N.T_a03.BIN",
	"N.Y_a04.BIN",
	"world_a01.BIN",
	"world_a02.BIN",
	"world_a03.BIN",
*/
	/*"A12_a02_03.BIN", "A12_a02.BIN", "B5_a01.BIN", "B5_a04.BIN", "M-34300Y18720S100W500H300_a01.BIN",
	"mapimage_a01.BIN", "usa-blue_a03.BIN",*/ NULL 
} ;
#endif

// data type ------------------------------------

// `̍\
typedef struct tagRECTU16 
{
	u8 left, top ;				// `̍WƉEW
} RECTU16 ;

// I
typedef struct tagMAPSELECTINFO
{
	s8 MapID ;			// shc
	RECTU16 Rect ;		// Ig
} MAPSELECTINFO ;

// e}bvƂ̏
typedef struct tagMAPINFO
{
	u8 SelectValidFlag ;							// ILtO
	u8 DataLoadFlag ;								// f[^[htO
	KMap *Pattern ;									// }bvp^[NX
	TEXDATA ImageTex ;								// ĨC[WeNX`
	s8 ParentMap ;									// ẽ}bvhc(ꍇ -1 )
	u8 MapType ;									// }bv̏^Cv(0:  1:  2:߂  3:ړ)
	s8 TextX, TextY ;								// eLXg\W
	u8 TextSize ;									// eLXg̉
	s8 ImageX, ImageY ;								// }bvC[W\W
	u8 ParentX, ParentY ;							// e}bvł̍W

	char *MapName ;									// Ĩ}bv
	MAPSELECTINFO Select[MAP_MAXSELECTNUM] ;		// I
	u8 SelectNum ;									// I̐

	u8 MapSize ;									// e}bvƂ̃TCY
} MAPINFO ;


// c
typedef struct tagAFTERIMAGE
{
	u8 UseFlag ;								// gptO
	f32 x1, y1, x2, y2,  x3, y3, x4, y4 ;		// n_ƏI_
	f32 MoveCounter ;							// ړJE^[
	u8 a ;										// At@l
} AFTERIMAGE ;

// }bvʗp̃f[^\
typedef struct tagMAPSELECT
{
	bool InitStartFlag ;				// JntO
	bool InitCompFlag ;					// tO
	s32 InitMode, InitCounter ;			// ڕϐAJE^[
	
	bool ButtonCancelFlag ;				// {^LZtO

	s16 State ;							// (0:I҂  1:Y[C@2:Y[AEg)
	s32 Counter, Counter2 ;				// ėpJE^
	u8 EndFlag ;						// ItO
	s32 Result ;						// ʏ( -1ȊO:Iꂽ  -1:LZꂽ )

	YK7StrImage *Font ;					// }bv\ptHg
	TEXDATA LineTex ;					// IgƂȂeNX`
	TEXDATA RedBlur ;					// ԃu[eNX`
	s32 CrtMap ;						// \Ă}bv̂hc
	s32 SelectMap ;						// IĂ}bṽf[^̃CfbNX
	u32 CurCounter ;					// IJ[\Ɏgł낤JE^

	AFTERIMAGE AfterImage[AFTERIMAGE_MAXNUM] ;	// c̏
	u16 AfterImageNum ;							// c̐

	f32 TextZureX[2], TextZureY[2] ;		// ̃Yʒu
	f32 ImageZureX[2], ImageZureY[2] ;		// 摜̃Yʒu
	f32 ImageZureXB[2] ;
	bool ImageZureXBFlag[2] ;
	f32 ZureRate[2], ZureRateB ;			// Y̗
	f32 PicZureRate[2], PicZureRateB ;		// ʐ^̃Y̗
	u8 NowInfoValid ;
	MAPINFO *BackInfo ;
	s32 BackSelect ;
	
	bool PicExDrawFlag ;				// ʐ^g`tO
	f32 PicExRate ;						// ʐ^g嗦

	f32 ZomeCounter ;					// Y[CAAEgɎgJE^[
	f32 RenderZomeCounter ;				// `ɎgY[l
	MAPINFO *MoveMap ;					// ړ}bv̏
	s32 MoveMapID ;						// ړ}bv̂hc
	MAPINFO *OldMap ;					// ړO}bv̏
	
	u16 FadeCounter ;					// tF[hCAAEgpJE^[
	s8 FadeDir ;						// tF[h̕Ayё傫
	
	s32 MoveRoot[MAXROOTNUM] ;			// }bvړ̃[g|Cg(-1:͏ɍsÄӖ)
	s8 MoveParentFlag[MAXROOTNUM] ;		// }bv̎̈ړ悪e}bvǂ̃tO( TRUE:e  FALSE:Kw )
	u8 MoveRootPointNum ;				// }bvړ̃[g|Cg̐
	s32 FirstMap, GoolMap ;				// }bṽX^[gn_ƍs

	s32 MoveRootCounter ;				// [gpJE^[
	s32 MoveRootNumber ;				// [gȂ
	
//	f32 Bright ;						// I\̈̐F̓x
	CMov Bright ;						// I\̈̐F̓x
//	u8 BrightAddDir ;					// Z

	s32 MovSoundID ;					// ړ
	s32 WarpSoundID ;					// [v
	
	f32 camEx ;							// }bvg嗦
	f32 camX, camY ;					// }bv̒_

	u8 DrawMode ;						// `惂[h( 0:IuWFNg[h  1:XP[O[h )
	s32 BigMap, SmallMap ;				// XP[O[h̃rbO}bvƃX[}bv
	f32 Rate ;							// XP[O[ḧړ( 1.0F:X[@0.0F:rbO )
	f32 AlphaRate ;						// XP[O[h̃At@l
	
	f32 RedBlurRate ;					// ԃu[̃[g
	f32 RedBlurRate2 ;
	
	s32 StreamFadeOutCounter ;
} MAPSELECT ;

// }bv\pIuWFNg\
typedef struct tagMAPCHIP
{
	u8 DrawFlag ;				// `悷邩ǂtO
	u32 color ;					// F
//	u8 ColorFlag ;				// FttO
//	u8 ActiveFlag ;				// ANeButO
	f32 x, y ;					// W
	f32 mx, my ;				// ړ
	f32 movx, movy ;			// ڕWW
	s8 Wait ;					// ҂
	u16 SinC ;					// TCJE^
} MAPCHIP ;

// }bv\pf[^\
typedef struct tagMAPGRAPHDATA
{
	MAPCHIP (*Chip)[MAP_WIDTH] ;
	MAPCHIP (*BackChip)[MAP_WIDTH] ;
	s32 DrawCount, BackDrawCount ;
} MAPGRAPHDATA ;

// data -----------------------------------------

#define __YK7_MAP_TABLE
#include "./YK7Map.h"

// ͊֌Wۑϐ
static u32 EdgeInput = 0;
static u32 OldInput = 0;

static MAPGRAPHDATA MapG = { NULL, NULL, 0, 0 } ;
static MAPSELECT Map ;


// function proto type --------------------------

static s8 MapSelectLoadFunc( void ) ;													// }bṽf[^ǂݍޏ( TRUE:   FALSE:܂ )

static s8 InitMapGraph( void ) ;														// }bv
static s8 EndMapGraph( void ) ;															// }bvn
static s8 ChangeMapGraph( s32 MapID, s8 ChangeType, s32 movx = -1, s32 movy = -1 ) ;	// }bvύX(MapID:-2ŏuԑޏo -1őޏo   ChangeType:0.L 1. 2.o)
static s8 MapGraphFrameProcess( void ) ;												// }bv𓮂
static s8 MapGraphRenderProcess( void ) ;												// }bv`悷

static s8 LoadMapData( s32 MapID, u8 CompLoadFlag = FALSE ) ;		// }bvf[^̓ǂݍ
static s8 CheckMapData( s32 MapID ) ;								// }bvf[^̓ǂݍ݊`FbN( TRUE:ǂݍ݂͊Ă  FALSE:܂ǂݍݒ )
static s8 ReleaseMapData( s32 MapID ) ;								// }bvf[^̉
static void UpdateInput( void ) ;										// ͏̍XV

static s8 LoadMapTex( s32 MapID ) ;					// }bveNX`̓ǂݍ
static s8 CheckMapTex( s32 MapID ) ;				// }bveNX`̓ǂݍ݊`FbN( TRUE:ǂݍ݂͊Ă  FALSE:܂ǂݍݒ )
static s8 ReleaseMapTex( s32 MapID ) ;				// }bveNX`̉

static s8 InitAfterImage( void ) ;										// c
static s8 AddAfterImage( s32 ParentMapID, s32 MapID1, s32 MapID2 ) ;	// c𑝂₷
static s8 FrameProcessAfterImage( void ) ;								// cPt[s
static s8 RenderProcessAfterImage( void ) ;								// c`悷
static MAPSELECTINFO *GetMapSelectInfo( s32 MapID ) ;					// w̃}bvhc̑IW𓾂

static void ZureInit( u8 NextValid ) ;
static void ZureFrameProcessInc( void ) ;
static void ZureFrameProcessDec( void ) ;

static s32 __MapDrawBase( s32 BigMap, s32 SmallMap,
							f32 CamX, f32 CamY, f32 ZoomRate,
							f32 SmallMapSize, s32 MapResolution,
							f32 chipSize, s32 packNum, f32 alpha, f32 alpha2 ) ;
static s32 __MapDraw( s32 BigMap, s32 SmallMap,
						f32 CamX, f32 CamY, f32 ZoomRate,
						f32 SmallMapSize, s32 MapResolution ) ;		// }bv̕`

//extern s8 MapRootCreate( s32 StartID, s32 EndID ) ;		// }bvړ̌oHTi[

#define CRTIF						MapTable[Map.CrtMap]
#define CRTINFO(Index)				MapTable[CRTIF.Select[(Index)].MapID]
#define SELMAPID					(CRTIF.Select[Map.SelectMap].MapID)
#define SELMAPINFO					CRTIF.Select[Map.SelectMap]

// function code --------------------------------

// }bv
static s8 InitMapGraph( void )
{
	if( MapG.Chip == NULL )
	{
		MapG.Chip = (MAPCHIP (*)[MAP_WIDTH])ghmGcMemAllocName( sizeof( MAPCHIP ) * MAP_WIDTH * MAP_HEIGHT, "MapMem1" ) ;
		if( MapG.Chip == NULL )
		{
			OSReport( "}bvۑ郁̊mۂɎs܂P\n" ) ;
			return -1 ;
		}
		MapG.BackChip = (MAPCHIP (*)[MAP_WIDTH])ghmGcMemAllocName( sizeof( MAPCHIP ) * MAP_WIDTH * MAP_HEIGHT, "MapMem2" ) ;
		if( MapG.BackChip == NULL )
		{
			ghmGcMemFree( MapG.Chip ) ;
			MapG.Chip = NULL ;
			
			OSReport( "}bvۑ郁̊mۂɎs܂Q\n" ) ;
			return -1 ;
		}
	}
	
	MapG.DrawCount = 0 ;
	MapG.BackDrawCount = 0 ;
	
	// I
	return 0 ;
}

// }bvn
static s8 EndMapGraph( void )
{
	if( MapG.Chip != NULL ) ghmGcMemFree( MapG.Chip ) ;
	if( MapG.BackChip != NULL ) ghmGcMemFree( MapG.BackChip ) ;
	
	MEMINIT( MapG ) ;

	// I
	return 0 ;
}


// }bṽf[^ǂݍޏ( TRUE:   FALSE:܂ )
static s8 MapSelectLoadFunc( void )
{
	s32 i ;

	if( Map.InitCompFlag == true ) return TRUE ;
	if( Map.InitStartFlag == false ) return FALSE ;
	
	switch( Map.InitMode )
	{
	case 0 :	// }bvop̃f[^
		if( InitMapGraph() == -1 ) break ;
		Map.InitMode ++ ;
		
	case 1 :	// ԃu[eNX`̓ǂݍ݊Jn
		TexLoadSet( REDBLURTEX, &Map.RedBlur ) ;
		Map.InitMode ++ ;
		
	case 2 :	// tHgNX̍쐬
		ghmGcMemSetAllocName("YStrImg");
		Map.Font = new YK7StrImage ;						// tHgNX̍쐬
		if( Map.Font == NULL ) break ;

		Map.InitMode ++ ;
		
	case 3 :	// tHg̓ǂݍ
		{
			char FileName[128] ;
			
			sprintf( FileName, "%s%s", MAPFILEFOLDER, MAPFONTPATH ) ;
			if( Map.Font->Load( FileName ) == false ) break ;
		}
		Map.InitMode ++ ;

	case 4 :	// oH̍쐬
		if( MapRootCreate( Map.FirstMap, Map.GoolMap ) < 0 ) break ;
		Map.InitMode ++ ;
		
	case 5 :	// SẴ}bvǂݍ
		for( i = 0 ; i < MAP_NUM ; i ++ ) LoadMapData( i, TRUE ) ;
		Map.InitMode ++ ;
		
	case 6 :	// SẴ}bv̓ǂݍݑ҂
		for( i = 0 ; i < MAP_NUM ; i ++ ) if( CheckMapData( i ) == FALSE ) break ;
		if( i != MAP_NUM ) break ;
		Map.InitMode ++ ;

	case 7 :	// ŏɕ\}bv̏
		Map.CrtMap = MapTable[Map.FirstMap].ParentMap ;
	#ifdef DEBUG_MAP
		Map.CrtMap = MAP_WASHINGTON_DC ;
	#endif
		LoadMapTex( (s8)Map.CrtMap ) ;
		Map.InitMode ++ ;
		
	case 8 :	// ŏɕ\}bv̓ǂݍݏI҂
		if( CheckMapTex( Map.CrtMap ) == FALSE ) break ;
		Map.InitMode ++ ;
	
	case 9 :	// ̑̏
		// \}bv̕ύX
		ChangeMapGraph( -2, 2 ) ;

		// IĂ}bvZbg
		for( i = 0 ; i < CRTIF.SelectNum && CRTIF.Select[i].MapID != Map.FirstMap ; i ++ ){}
		Map.SelectMap = i != CRTIF.SelectNum ? i : 0 ;

		SetMapSelectValidFlag( (u8)Map.FirstMap, TRUE ) ;
		SetMapSelectValidFlag( (u8)Map.GoolMap, TRUE ) ;

		// cǉ
		InitAfterImage() ;
		AddAfterImage( Map.CrtMap, -1, SELMAPID ) ;

		Map.InitMode ++ ;
		
	case 10 :	// ǂݍݏI҂
		// ԃeNX`̓ǂݍݏI`FbN
		if( TexLoadChk( &Map.RedBlur ) == FALSE ) break ;

		// tHgt@C̓ǂݍݑ҂
		if( Map.Font->LoadCheck() == false ) break ;

		Map.InitMode ++ ;
		
	case 11 :	// I
		Map.InitStartFlag = false ;
		Map.InitCompFlag = true ;
		
		return TRUE ;
		break ;
	}
	
	// ɗǂݍ݂͂܂IĂȂ
	return FALSE ;
}


// }bvύX(MapID:-1őޏo  ChangeType:0.L 1. 2.o )
static s8 ChangeMapGraph( s32 MapID, s8 ChangeType, s32 movx, s32 movy )
{
	f32 x, y, xx, yy ;
	s32 i, j, l, xnum, ynum ;
	MAPCHIP *Bk, *Nw ;
	
	if( Map.DrawMode == 0 )
	{
		switch( ChangeType )
		{
		case 0 : PlayEffectSE( SFX_MAP_KAKUSAN ) ; break ;
		case 1 : PlayEffectSE( SFX_MAP_KAKUSAN ) ; break ;
		case 2 : break ;
		}
	}

	// }bvf[^ޏopɃRs[
	memcpy( MapG.BackChip, MapG.Chip, sizeof( *MapG.Chip ) ) ;

	// ޏoʒuZbg
	xnum = SCW / CHIPSIZE ;	ynum = SCH / CHIPSIZE ;
	movx *= CHIPSIZE ;		movy *= CHIPSIZE ;
	for( i = 0 ; i < ynum ; i ++ )
	{
		Bk = MapG.BackChip[i] ;
		Nw = MapG.Chip[i] ;
		for( j = 0 ; j < xnum ; j ++, Bk ++, Nw ++ )
		{
			*Bk = *Nw ;

			if( MapID == -2 )
			{
				Bk->DrawFlag = FALSE ;
			}
			else
			{
				if( ChangeType == 1 )
				{
					xx = 100 ;	yy = 100 ;
					while( xx > -CHIPSIZE && xx < SCW && yy > -CHIPSIZE && yy < SCH )
					{
						xx = -MAP_OUTRAND + rand() * ( SCW + MAP_OUTRAND * 2 ) / RAND_MAX ;
						yy = -MAP_OUTRAND + rand() * ( SCH + MAP_OUTRAND * 2 ) / RAND_MAX ;
					}
					Bk->movx = xx ;
					Bk->movy = yy ;
				}
				else
				{
					Bk->movx = movx ;
					Bk->movy = movy ;
				}
			}
		}
	}
			
	// }bvf[^͂Ď߂
	y = 0 ;
	xnum = SCW / CHIPSIZE ;
	ynum = SCH / CHIPSIZE ;
	MapG.BackDrawCount = ( MapID == -2 ) ? 0 : MapG.DrawCount ;
	MapG.DrawCount = 0 ;

//	MapG.BackDrawCount = 0 ;

	l = 0 ;
	for( i = 0 ; i < ynum ; i ++, y += CHIPSIZE )
	{
		x = 0 ;
		Bk = MapG.BackChip[i] ;
		Nw = MapG.Chip[i] ;
		for( j = 0 ; j < xnum ; j ++, x += CHIPSIZE, Bk ++, Nw ++ )
		{
			if( MapID < 0 )
			{
				Nw->DrawFlag = FALSE ;
			}
			else
			{
				MapG.DrawCount ++ ;

				Nw->DrawFlag = TRUE ;
				Nw->color = MapTable[MapID].Pattern->GetMapChip( j, i ) | 0xff ;
	//			Nw->color = 0xffffffff ;
	//			Nw->ColorFlag = FALSE ;
	//			Nw->ActiveFlag = FALSE ;

				if( Nw->color == 0xff ) l ++ ;

				switch( ChangeType )
				{
				case 1 :
					Nw->x = movx ;
					Nw->y = movy ;
					break ;

				case 2 :
				case 0 :
					xx = 100 ;
					yy = 100 ;
					while( xx > -CHIPSIZE && xx < SCW && yy > -CHIPSIZE && yy < SCH )
					{
						xx = -MAP_OUTRAND + rand() * ( SCW + MAP_OUTRAND * 2 ) / RAND_MAX ;
						yy = -MAP_OUTRAND + rand() * ( SCH + MAP_OUTRAND * 2 ) / RAND_MAX ;
					}
					Nw->x = xx ;
					Nw->y = yy ;
					break ;
				}
				Nw->my = Nw->mx = 0 ;
				Nw->movx = x ;
				Nw->movy = y ;
				Nw->Wait = (s8)( rand() * PRM2[8] / RAND_MAX ) ;
			}
		}
	}

	// I
	return 0 ;
}

// }bv𓮂
static s8 MapGraphFrameProcess( void )
{
	f32 sp ;
	s32 i, j, xnum, ynum ;
	MAPCHIP *Bk, *Nw ;
	
	if( VParam[ED_MAPSELECT][4] < 10 ) VParam[ED_MAPSELECT][4] = 10 ;

	// ړ
	sp = PRM2[6] * 0.1F ;
	MapG.DrawCount = 0 ;
	MapG.BackDrawCount = 0 ;
	xnum = SCW / CHIPSIZE ;	ynum = SCH / CHIPSIZE ;
	for( i = 0 ; i < ynum ; i ++ )
	{
		Bk = MapG.BackChip[i] ;
		Nw = MapG.Chip[i] ;
		for( j = 0 ; j < xnum ; j ++, Bk ++, Nw ++ )
		{
			if( Nw->DrawFlag )
			{
				MapG.DrawCount ++ ;
				if( Nw->Wait <= 0 )
				{
					Nw->x += Nw->mx = ( Nw->movx - Nw->x ) / sp ;
					Nw->y += Nw->mx = ( Nw->movy - Nw->y ) / sp ;
				}
				else
				{
					Nw->Wait -- ;
				}
			}

			if( Bk->DrawFlag )
			{
				MapG.BackDrawCount ++ ;
				if( Bk->Wait <= 0 )
				{
					Bk->x += Bk->mx = ( Bk->movx - Bk->x ) / sp ;
					Bk->y += Bk->mx = ( Bk->movy - Bk->y ) / sp ;
				}
				else
				{
					Bk->Wait -- ;
				}
			}
		}
	}

	// I
	return 0 ;
}

// }bv`悷
static s8 MapGraphRenderProcess( void )
{
	f32 suk, siz ;
	s32 i, j, k, xnum, ynum  ;
	u32 c1, c2 ;
	MAPCHIP *Bk, *Nw ;
	u8 a, a2 ;
	f32 mmx, mmy, x, y, f ;

	xnum = SCW / CHIPSIZE ;
	ynum = SCH / CHIPSIZE ;

	if( VParam[ED_MAPSELECT][4] < 10 ) VParam[ED_MAPSELECT][4] = 10 ;
//	if( 65535 < xnum * ynum * 4 ) return 0 ;
	if( PRM2[16] < 1 ) VParam[ED_MAPSELECT][4] = 1 ;

	// `̏
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	
	GTLOAD( GetFlatTex() ) ;
	
	f = 1.0F / PRM2[16] * ( (f32)PRM2[17] * 0.01F ) ;
	if( f > 1.0F ) f = 1.0F ;
	a = (u8)( f * 255 ) ;

	c1 = CMK( PRM2[10], PRM2[11], PRM2[12], a ) ;
	c2 = CMK( PRM2[13], PRM2[14], PRM2[15], a ) ;
	a2 = (u8)( 255 / PRM2[16] ) ;

	// `Jn
	if( MapG.DrawCount != 0 )
	{
		u32 allnum, num, c ;
		
		allnum = (u32)( MapG.DrawCount * 4 * PRM2[16] ) ;
		num = allnum > 0xffff ? 0xffff & ~3 : allnum ;
		allnum -= num ;

		GBGN( GX_QUADS, num ) ;
		c = 0 ;
		siz = CHIPSIZE - CHIPSUKIMA * 2 ;
		suk = CHIPSUKIMA ;
		for( i = 0 ; i < ynum ; i ++ )
		{
			Nw = MapG.Chip[i] ;
			for( j = 0 ; j < xnum ; j ++, Nw ++ )
			{
				if( Nw->DrawFlag )
				{
					x = Nw->x ;
					y = Nw->y ;
					mmx = -Nw->mx / PRM2[16] ;
					mmy = -Nw->my / PRM2[16] ;
					for( k = 0 ; k < PRM2[16] ; k ++, x += mmx, y += mmy )
					{
//						DrawBoxNB( x + suk, y + suk, x + suk + siz, y + suk + siz, c1 ) ;
						DrawTex3NBM( x + suk, y + suk, x + suk + siz, y + suk + siz, CMKC2( Nw->color, a2 ) ) ;

						c += 4 ;
						if( c == num )
						{
							c = 0 ;
							GEND() ;
							num = allnum > 0xffff ? 0xffff & ~3 : allnum ;
							allnum -= num ;
							if( num != 0 ) GBGN( GX_QUADS, num ) ;
						}
					}
				}
			}
		}
		if( c != 0 ) GEND() ;
	}

	if( MapG.BackDrawCount != 0 )
	{
		u32 allnum, num, c ;
		
		allnum = (u32)( MapG.BackDrawCount * 4 * PRM2[16] ) ;
		num = allnum > 0xffff ? 0xffff & ~3 : allnum ;
		allnum -= num ;

		GBGN( GX_QUADS, num ) ;

		// `悷
		c = 0 ;
		siz = CHIPSIZE - CHIPSUKIMA * 2 ;
		suk = CHIPSUKIMA ;
		for( i = 0 ; i < ynum ; i ++ )
		{
			Bk = MapG.BackChip[i] ;
			for( j = 0 ; j < xnum ; j ++, Bk ++ )
			{
				if( Bk->DrawFlag )
				{
					x = Bk->x ;
					y = Bk->y ;
					mmx = -Bk->mx / PRM2[16] ;
					mmy = -Bk->my / PRM2[16] ;
					for( k = 0 ; k < PRM2[16] ; k ++, x += mmx, y += mmy )
					{
//						DrawTex3NB( x + suk, y + suk, x + suk + siz, y + suk + siz, c2 ) ;
						DrawTex3NBM( x + suk, y + suk, x + suk + siz, y + suk + siz, CMKC2( Bk->color, a2 ) ) ;

						c += 4 ;
						if( c == num )
						{
							c = 0 ;
							GEND() ;
							num = allnum > 0xffff ? 0xffff & ~3 : allnum ;
							allnum -= num ;
							if( num != 0 ) GBGN( GX_QUADS, num ) ;
						}
					}
				}
			}
		}
		if( c != 0 ) GEND() ;
	}

	// I
	return 0 ;
}



// }bvړ̌oHTi[
extern s8 MapRootCreate( s32 StartID, s32 EndID )
{
	s8 MapCheckFlag[MAP_NUM] ;
	s32 *Root = (s32 *)WorkBuffer, *Root2 = (s32 *)&WorkBuffer[sizeof( u32 ) * MAXROOTNUM] ;
	u8 RootNum, RootNum2 ;
	MAPINFO *Info ;
	s32 i ;

	// }bv`FbNtO
	memset( MapCheckFlag, 0, sizeof( MapCheckFlag ) ) ;
	
	// X^[gn_̃tO𗧂Ă
	MapCheckFlag[StartID] = TRUE ;
	
	// [g̐
	memset( Root, 0, sizeof( s32 ) * MAXROOTNUM ) ;
	RootNum = 1 ;
	Root[0] = StartID ;
	
	// [gTJn
	while( EndID != Root[RootNum-1] )
	{
		// ݂̃|Cg̏𓾂
		Info = &MapTable[Root[RootNum-1]] ;

		// ݂̃|Cgړł|Cg𒲂ׂ
		for( i = 0 ; i < Info->SelectNum ; i ++ )
		{
			if( MapCheckFlag[Info->Select[i].MapID] == FALSE )
			{
				Root[RootNum] = Info->Select[i].MapID ;
				RootNum ++ ;
				MapCheckFlag[Info->Select[i].MapID] = TRUE ;
				break ;
			}
		}
		
		// ׂĒ׏Iꍇ͈ɏ
		if( i == Info->SelectNum )
		{
			// eȂ}bvG[
			if( Info->ParentMap == -1 ) return -1 ;
		
			// ܂ׂĂȂꏊǂŏ𕪊
			if( MapCheckFlag[Info->ParentMap] == FALSE )
			{
				// ܂ׂĂȂꏊ̏ꍇ͎̒ʂ蓹c
				Root[RootNum] = Info->ParentMap ;
				RootNum ++ ;
				MapCheckFlag[Info->ParentMap] = TRUE ;
			}
			else
			{
				// ɒʂĂꏊɖ߂ꍇ͒PɃ[g
				RootNum -- ;
			}
		}
	}
	
	// [gVFCvAbv
	{
		RootNum2 = 0 ;
		for( i = 0 ; i < RootNum ; i ++, RootNum2 ++ )
		{
			Root2[RootNum2] = Root[i] ;
			if( i < RootNum - 2 &&
				Root[i+1] == MapTable[Root[i]].ParentMap &&
				Root[i+1] == MapTable[Root[i+2]].ParentMap ) i ++ ;
		}
	}
	
	// s悪X^[gn_ꍇ̗O
	if( RootNum2 == 1 )
	{
		RootNum2 ++ ;
		Root2[1] = StartID ;
	}

	// [gۑ
	memcpy( Map.MoveRoot, Root2, sizeof( s32 ) * RootNum2 ) ;
	Map.MoveRootPointNum = RootNum2 ;
	
	// }bvړ[g̎qeƂȂړ`FbN
	{
		// [g̐JԂ
		for( i = 0 ; i < Map.MoveRootPointNum - 1 ; i ++ )
		{
			Map.MoveParentFlag[i] = ( Map.MoveRoot[i+1] == MapTable[Map.MoveRoot[i]].ParentMap ) ;
		}
	}

	// I
	return 0 ;
}



// c
static s8 InitAfterImage( void )
{
	u32 i ;
	
	for( i = 0 ; i < AFTERIMAGE_MAXNUM ; i ++ )
		Map.AfterImage[i].UseFlag = FALSE ;
	Map.AfterImageNum = 0 ;

	// I
	return 0 ;
}

// cPt[s
static s8 FrameProcessAfterImage( void )
{
	u32 i, Num ;
	AFTERIMAGE *Af ;

	// o^Ă邷ׂĂ̎c	
	Af = Map.AfterImage ;
	Num = Map.AfterImageNum ;
	for( i = 0 ; i < Num ; Af ++ )
	{
		// gĂȂ玟
		if( Af->UseFlag == FALSE ) continue ;
		
		// JEg
		i ++ ;
		
		// ŏړĂA폜
		if( Af->MoveCounter == 1.0F )
		{
			Af->UseFlag = FALSE ;
			Map.AfterImageNum -- ;
		}
		else
		{
			// ړ
			Af->MoveCounter += PRM[8] * 0.01F ;
			if( Af->MoveCounter > 1.0F ) Af->MoveCounter = 1.0F ;
		}
	}
	
	// I
	return 0 ;
}

// c`悷
static s8 RenderProcessAfterImage( void )
{
	u32 i, Num ;
	AFTERIMAGE *Af ;
	f32 x1, y1, x2, y2, cx, cy ;
	u32 cr, cr2 ;
	
	// `揀
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ADD, EF_TEV_NOTEX ) ;

	// `Jn
	GBGN( GX_LINES, Map.AfterImageNum * 16 ) ;

	// o^Ă邷ׂĂ̎c	
	Af = Map.AfterImage ;
	Num = Map.AfterImageNum ;
	for( i = 0 ; i < Num ; Af ++ )
	{
		if( Af->UseFlag == FALSE ) continue ;
		
		// JEg
		i ++ ;
	
		// WZo
		x1 = ( Af->x3 - Af->x1 ) * Af->MoveCounter + Af->x1 ;
		y1 = ( Af->y3 - Af->y1 ) * Af->MoveCounter + Af->y1 ;

		x2 = ( Af->x4 - Af->x2 ) * Af->MoveCounter + Af->x2 ;
		y2 = ( Af->y4 - Af->y2 ) * Af->MoveCounter + Af->y2 ;
		
		cx = ( x2 - x1 ) / 2.0F + x1 ;
		cy = ( y2 - y1 ) / 2.0F + y1 ;

		cr = LINE_COLOR( Af->a ) ;
		cr2 = LINE_COLOR( LINE_MINALPHA ) ;
		
		// `
		DrawLine2NB( 0, y1, cr2,	cx, y1, cr ) ;
		DrawLine2NB( cx, y1, cr,	SCW, y1, cr2 ) ;

		DrawLine2NB( 0, y2, cr2, cx, y2, cr ) ;
		DrawLine2NB( cx, y2, cr,  SCW, y2, cr2 ) ;


		DrawLine2NB( x1, 0, cr2, x1, cy, cr ) ;
		DrawLine2NB( x1, cy, cr, x1, SCH, cr2 ) ;

		DrawLine2NB( x2, 0, cr2, x2, cy, cr ) ;
		DrawLine2NB( x2, cy, cr, x2, SCH, cr2 ) ;
/*
		DrawLineNB( 0, y1, SCW, y1, color ) ;
		DrawLineNB( 0, y2, SCW, y2, color ) ;

		DrawLineNB( x1, 0, x1, SCH, color ) ;
		DrawLineNB( x2, 0, x2, SCH, color ) ;
*/
	}
	
	// `I
	GEND() ;
	
	// I
	return 0 ;
}

// w̃}bvhc̑IW𓾂
static MAPSELECTINFO *GetMapSelectInfo( s32 MapID )
{
	MAPINFO *mp ;
	s32 i, j ;

	mp = MapTable ;	
	for( i = 0 ; i < MAP_NUM ; i ++, mp ++ )
	{
		for( j = 0 ; j < mp->SelectNum ; j ++ )
		{
			if( mp->Select[j].MapID == MapID ) return &mp->Select[j] ;
		}
	}

	return NULL ;
}

static void ZureInit( u8 NextValid )
{
	Map.BackInfo = &MapTable[CRTIF.Select[Map.SelectMap].MapID] ;
	Map.BackSelect = Map.SelectMap ;

	Map.TextZureX[1] = Map.TextZureX[0] ;
	Map.TextZureY[1] = Map.TextZureY[0] ;

	Map.ImageZureX[1] = Map.ImageZureX[0] ;
	Map.ImageZureY[1] = Map.ImageZureY[0] ;
	Map.ZureRate[1] = Map.ZureRate[0] ;
	Map.PicZureRate[1] = Map.PicZureRate[0] ;

	Map.NowInfoValid = NextValid ;

	Map.TextZureX[0] = GetRandF2Num( PRM2[22], -PRM2[22] ) ;
	Map.TextZureY[0] = GetRandF2Num( PRM2[22], -PRM2[22] ) ;

	Map.ImageZureX[0] = GetRandF2Num( PRM2[22], -PRM2[22] ) ;
	Map.ImageZureY[0] = GetRandF2Num( PRM2[22], -PRM2[22] ) ;
	Map.ZureRate[0] = 1.0F ;
	Map.ZureRateB = 1.0F ;
	Map.PicZureRate[0] = 1.0F ;
	Map.PicZureRateB = 1.0F ;
}

static void ZureFrameProcessInc( void )
{
	Map.ZureRate[1] -= NAMEZURESPEED * 2 ;
	if( Map.ZureRate[1] < 0.0F ) Map.ZureRate[1] = 0.0F ;

	Map.ZureRate[0] += NAMEZURESPEED * 2 ;
	if( Map.ZureRate[0] > 1.0F ) Map.ZureRate[0] = 1.0F ;


	Map.PicZureRate[1] -= PICZURESPEED * 1.5F ;
	if( Map.PicZureRate[1] < 0.0F ) Map.PicZureRate[1] = 0.0F ;

	Map.PicZureRate[0] += PICZURESPEED * 1.5F ;
	if( Map.PicZureRate[0] > 1.0F ) Map.PicZureRate[0] = 1.0F ;
}

static void ZureFrameProcessDec( void )
{
	Map.ZureRate[0] -= NAMEZURESPEED ;
	if( Map.ZureRate[0] < 0.0F ) Map.ZureRate[0] = 0.0F ;

	Map.ZureRate[1] += NAMEZURESPEED ;
	if( Map.ZureRate[1] > 1.0F ) Map.ZureRate[1] = 1.0F ;


	Map.PicZureRate[0] -= PICZURESPEED ;
	if( Map.PicZureRate[0] < 0.0F ) Map.PicZureRate[0] = 0.0F ;

	Map.PicZureRate[1] += PICZURESPEED ;
	if( Map.PicZureRate[1] > 1.0F ) Map.PicZureRate[1] = 1.0F ;
}


// }bv̕`{֐
static s32 __MapDrawBase( s32 BigMap, s32 SmallMap,
							f32 CamX, f32 CamY, f32 ZoomRate,
							f32 SmallMapSize, s32 MapResolution,
							f32 chipSize, s32 packNum, f32 alpha, f32 alpha2 )
{
	f32 addsize, l, r, t, b ;
	s32 ml, mt, mr, mb, px, py, px2, py2 ;
	f32 startx, starty, lookw, lookh ; 
	f32 addsizeSc, startxSc, startySc, x, y, chipSizeSc ;
	s32 packAllNum, i, j, m, n, numx, numy, allnum ;
	s32 startxnum, startynum, cr, cg, cb, packNum2, packAllNum2, packAddNum2 ;
	u32 code, code2, con, BigMapOneChipUnitNum ;
	s32 ca, ca2 ;
	f32 ChipSizeUnit ;
	KMap *bm, *sm ;
	MAPINFO *bminfo, *sminfo ;
	
	// `bvTCY߂
	SmallMapSize = 1.0F / SmallMapSize ;
	BigMapOneChipUnitNum = (u32)( 1.0F / SmallMapSize ) ;
	
	ca = (s32)( alpha * 255 ) ;
	ca2 = (s32)( alpha2 * 255 ) ;
	
	f32 f4 = MINCHIPSIZE ;
	ChipSizeUnit = SmallMapSize / MAPDIVNUM ;
	packAllNum = packNum * packNum ;
	
	if( packNum > CHIPMAXPACKNUM )
	{
		packNum2 = CHIPMAXPACKNUM ;
		packAllNum2 = CHIPMAXPACKNUM * CHIPMAXPACKNUM ;
		packAddNum2 = packNum / CHIPMAXPACKNUM ;
	}
	else
	{
		packNum2 = packNum ;
		packAllNum2 = packAllNum ;
		packAddNum2 = 1 ;
	}

	// }bv̏Ă
	bminfo = &MapTable[BigMap] ;
	sminfo = &MapTable[SmallMap] ;

	// l
	bm = bminfo->Pattern ;
	sm = sminfo->Pattern ;

	ml = (s32)( sminfo->ParentX * BigMapOneChipUnitNum - ( SMALLMAPUNITNUMX - BigMapOneChipUnitNum ) / 2 ) ;
	mt = (s32)( sminfo->ParentY * BigMapOneChipUnitNum - ( SMALLMAPUNITNUMY - BigMapOneChipUnitNum ) / 2 ) ;
	mr = ml + SMALLMAPUNITNUMX ;
	mb = mt + SMALLMAPUNITNUMY ;

	lookw = ( CAMLOOKSCALEX * 2.0F ) / ZoomRate ;
	lookh = ( CAMLOOKSCALEY * 2.0F ) / ZoomRate ;

	addsize = chipSize ;

	l = CamX - lookw / 2.0F ;	r = l + lookw ;
	t = CamY - lookh / 2.0F ;	b = l + lookh ;

	numx = (s32)( ( CAMLOOKSCALEX * 2.0F ) / chipSize ) + 2 ;
	numy = (s32)( ( CAMLOOKSCALEY * 2.0F ) / chipSize ) + 1 ;
	allnum = numx * numy ;
	
	f32 f1, f2, f3 ;

	f3 = ChipSizeUnit ;
	f1 = fmod( l, ChipSizeUnit ) ;
	f2 = l - fmod( l, ChipSizeUnit ) ;
	
	startxnum = (s32)( ( l - fmod( l, ChipSizeUnit ) ) / ChipSizeUnit ) / packNum * packNum ;
	startynum = (s32)( ( t - fmod( t, ChipSizeUnit ) ) / ChipSizeUnit ) / packNum * packNum ;
	startx = (f32)startxnum * ChipSizeUnit ;
	starty = (f32)startynum * ChipSizeUnit ;
//	startx = l ;
//	starty = t ;
	
	// ʏł̃TCYɕϊ
	addsizeSc = SCREENCONV( addsize ) ;
	startxSc = SCREENCONV( startx * ZoomRate ) ;
	startySc = SCREENCONV( starty * ZoomRate ) ;
	chipSizeSc = SCREENCONV( chipSize ) ;
	
	// `Jn
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;
	GBGN( GX_QUADS, allnum * 4 ) ;
	{
		y = startySc - SCREENCONV( t * ZoomRate ) ;
//		y = SCREENCONV( fmod(t,CHIPSIZEUNIT) ) ;
//		y = 0.0F ;
//		y = SCREENCONV( fmod( chipSize - ( starty - t ), chipSize ) ) ;
		py = startynum ;
		for( i = 0 ; i < numy ; i ++, y += addsizeSc, py += packNum )
		{
//			x = SCREENCONV( fmod(l,CHIPSIZEUNIT) ) ;
			x = startxSc - SCREENCONV( l * ZoomRate ) ;
//			x = 0.0F ;
//			x = SCREENCONV( fmod( chipSize - ( startx - l ), chipSize ) ) ;
			px = startxnum ;
			for( j = 0 ; j < numx ; j ++, x += addsizeSc, px += packNum )
			{
				cb = cg = cr = 0 ;
				py2 = py ;
				con = 0 ;
				for( m = 0 ; m < packNum ; m += packAddNum2, py2 += packAddNum2 )
				{
					px2 = px ;	
					for( n = 0 ; n < packNum ; n += packAddNum2, px2 += packAddNum2 )
					{
						code2 = bm->GetMapChip( (int)( px2 * MapResolution / BigMapOneChipUnitNum ), (int)( py * MapResolution / BigMapOneChipUnitNum ) ) ;
						if( px2 >= ml && px2 < mr && py2 >= mt && py2 < mb )
						{
							code = sm->GetMapChip( ( px2 - ml ) * MapResolution, ( py2 - mt ) * MapResolution ) ;
							cr += ( ca2 * ( ( code >> 24 ) & 0xff ) + ( 255 - ca2 ) * ( ( code2 >> 24 ) & 0xff ) ) / 255 ;
							cg += ( ca2 * ( ( code >> 16 ) & 0xff ) + ( 255 - ca2 ) * ( ( code2 >> 16 ) & 0xff ) ) / 255 ;
							cb += ( ca2 * ( ( code >> 8 ) & 0xff ) + ( 255 - ca2 ) * ( ( code2 >> 8 ) & 0xff ) ) / 255 ;
						}
						else
						{
							cr += ( code2 >> 24 ) & 0xff ;
							cg += ( code2 >> 16 ) & 0xff ;
							cb += ( code2 >> 8 ) & 0xff ;
						}

//						cr += ( code >> 24 ) & 0xff ;
//						cg += ( code >> 16 ) & 0xff ;
//						cb += ( code >> 8 ) & 0xff ;
						
						con ++ ;
					}
				}

				DrawBoxNB( x + 1, y + 1, x + addsizeSc - 1, y + addsizeSc - 1,
							CMK( cr / con, cg / con, cb / con, ca ) ) ;
			}
		}
	}
	GEND() ;
	
	return packNum ;
}


// }bv̕`
static s32 __MapDraw( s32 BigMap, s32 SmallMap,
						f32 CamX, f32 CamY, f32 ZoomRate,
						f32 SmallMapSize, s32 MapResolution, f32 alpha )
{
	f32 chipSize ;
	s32 packNum ;
	f32 ChipSizeUnit ;
	
	// `bvTCY߂
	SmallMapSize = 1.0F / SmallMapSize ;
	
	ChipSizeUnit = SmallMapSize / MAPDIVNUM ;
	chipSize = ChipSizeUnit * ZoomRate ;
	packNum = 1 ;
	while( chipSize <= MINCHIPSIZE )
	{
		chipSize *= 2.0F ;
		packNum *= 2 ;
	}
	
	__MapDrawBase( BigMap, SmallMap,
					CamX, CamY, ZoomRate,
					1.0F / SmallMapSize, MapResolution,
					chipSize, packNum, ( chipSize - MINCHIPSIZE ) / MINCHIPSIZE, alpha ) ;

	__MapDrawBase( BigMap, SmallMap,
					CamX, CamY, ZoomRate,
					1.0F / SmallMapSize, MapResolution,
					chipSize * 2, packNum * 2, 1.0F - ( chipSize - MINCHIPSIZE ) / MINCHIPSIZE, alpha ) ;
					
	return 0 ;
}


// c𑝂₷
static s8 AddAfterImage( s32 ParentMapID, s32 MapID1, s32 MapID2 )
{
	AFTERIMAGE *Af ;
	u16 i ;
	f32 dx1, dy1, dx2, dy2, siz, suk ;
	f32 x1, y1, x2, y2, x3, y3, x4, y4 ;
	RECTU16 *rect, rc ;
	s32 Index1, Index2 ;
	MAPINFO *mp ;

	mp = &MapTable[ParentMapID] ;

	siz = CHIPSIZE ;
	suk = CHIPSUKIMA ;

	// WZbg
	if( MapID1 == -1 )
	{
		x1 = 0 ;					y1 = 0 ;
		x2 = SCW ;					y2 = SCH ;
	}
	else
	{
		for( i = 0 ; i < mp->SelectNum && mp->Select[i].MapID != MapID1 ; i ++ ){}
		if( i == mp->SelectNum ) return -1 ;
		Index1 = i ;
	
		rect = &rc ;
		rc.left = MapTable[MapTable[ParentMapID].Select[Index1].MapID].ParentX ;
		rc.top = MapTable[MapTable[ParentMapID].Select[Index1].MapID].ParentY ;
//		rc.right = (u16)( rc.left + 1 ) ;
//		rc.bottom = (u16)( rc.top + 1 ) ;
		x1 = rect->left * siz + suk ;	y1 = rect->top * siz + suk ;
		x2 = x1 + siz - suk * 2 ;		y2 = y1 + siz - suk * 2 ;
	}

	if( MapID2 == -1 )
	{
		x3 = 0 ;					y3 = 0 ;
		x4 = SCW ;					y4 = SCH ;
	}
	else
	{
		for( i = 0 ; i < mp->SelectNum && mp->Select[i].MapID != MapID2 ; i ++ ){}
		if( i == mp->SelectNum ) return -1 ;
		Index2 = i ;
	
		rect = &rc ;
		rc.left = MapTable[MapTable[ParentMapID].Select[Index2].MapID].ParentX ;
		rc.top = MapTable[MapTable[ParentMapID].Select[Index2].MapID].ParentY ;
//		rc.right = (u16)( rc.left + 1 ) ;
//		rc.bottom = (u16)( rc.top + 1 ) ;
		x3 = rect->left * siz + suk ;	y3 = rect->top * siz + suk ;
		x4 = x3 + siz - suk * 2 ;		y4 = y3 + siz - suk * 2 ;
	}

	// xNgZo
	dx1 = x3 - x1 ;		dy1 = y3 - y1 ;
	dx2 = x4 - x2 ;		dy2 = y4 - y2 ;
	
	// ǉׂc̐JԂ
	for( i = 0 ; i < AFTERIMAGE_NUM ; i ++ )
	{
		// f[^̐ɂςς牽I
		if( Map.AfterImageNum == AFTERIMAGE_MAXNUM ) break ;

		// gĂȂcf[^T
		for( Af = Map.AfterImage ; Af->UseFlag == TRUE ; Af ++ ){}
		
		// Zbg
		Af->x1 = dx1 * i / AFTERIMAGE_NUM + x1 ;		Af->y1 = dy1 * i / AFTERIMAGE_NUM + y1 ;
		Af->x2 = dx2 * i / AFTERIMAGE_NUM + x2 ;		Af->y2 = dy2 * i / AFTERIMAGE_NUM + y2 ;
		Af->x3 = x3 ;									Af->y3 = y3 ;
		Af->x4 = x4 ;									Af->y4 = y4 ;
		
		Af->a = (u8)( PRM2[21]/**i*/ * 255 / AFTERIMAGE_NUM ) ;
		Af->MoveCounter = 0.0F ;
		Af->UseFlag = TRUE ;
		
		// 𑝂₷
		Map.AfterImageNum ++ ;
	}
	
	// I
	return 0 ;
}


// ͏̍XV
static void UpdateInput( void )
{
#ifndef AUTO

	u32 NowInput ;
	s8 sY, sX ;

	// ̃t[ł̓͒l擾
	NowInput = HSD_PadGetButton(0) ;

	// AiO͂̏Ԃ܂߂
	sY = HSD_PadGetStickY(0) ;
	sX = HSD_PadGetStickX(0) ;
	if( sY > 10 ) NowInput |= PAD_BUTTON_DOWN ;
	if( sY < -10 ) NowInput |= PAD_BUTTON_UP ;
	if( sX > 10 ) NowInput |= PAD_BUTTON_RIGHT ;
	if( sX < -10 ) NowInput |= PAD_BUTTON_LEFT ;

	// GbW
	EdgeInput = NowInput & ~OldInput ;
	
	// ̃t[̓͏ԂۑĂ
	OldInput = NowInput ;
#else
	// Ԃ 0 ł͂Ȃ牽Ȃ
	EdgeInput = 0 ;
	if( Map.State == 0 )
	{
		// ړJE^CNg
		Map.MoveRootCounter ++ ;
		
		if( ( Map.MoveRootNumber == 0 && Map.MoveRootCounter >= (s32)PRM[18] ) ||
			( Map.MoveRoot[Map.MoveRootNumber+1] == SELMAPID && MapTable[Map.MoveRoot[Map.MoveRootNumber+1]].MapType == 3 && Map.MoveRootCounter >= (s32)PRM[20] ) ||
			( Map.MoveRootNumber != 0 && ( Map.MoveRoot[Map.MoveRootNumber+1] != SELMAPID || MapTable[Map.MoveRoot[Map.MoveRootNumber+1]].MapType != 3 ) && Map.MoveRootCounter >= (s32)PRM[19] ) )
		{
			// ړ悪eǂŏ𕪊
			if( Map.MoveParentFlag[Map.MoveRootNumber] == TRUE )
			{
				// ړ悪ȅꍇ͋K̎Ԃoe}bvɈړ
//				if( Map.MoveRootCounter >= (s32)PRM[18] )
				{
					EdgeInput = PAD_BUTTON_B ;
					Map.MoveRootCounter = 0 ;
					Map.MoveRootNumber ++ ;
				}
			}
			else
			{
				// ړ悪eł͂ȂA݃tH[JXĂ}bvsƂ
				// Ⴄꍇ͑IύX
				if( Map.MoveRoot[Map.MoveRootNumber+1] != SELMAPID )
				{
					if( Map.MoveRoot[Map.MoveRootNumber] == SELMAPID )
					{
//						if( Map.MoveRootCounter >= (s32)PRM[18] )
						{
							EdgeInput = PAD_BUTTON_RIGHT ;
							Map.MoveRootCounter = 0 ;
						}
					}
					else
					{
//						if( Map.MoveRootCounter >= (s32)PRM[19] )
						{
							EdgeInput = PAD_BUTTON_RIGHT ;
							Map.MoveRootCounter = 0 ;
						}
					}
				}
				else
				{
					// tH[JXĂ}bvړ̏ꍇ͌
//					if( Map.MoveRootCounter >= (s32)PRM[20] )
					{
						EdgeInput = PAD_BUTTON_A ;
						Map.MoveRootCounter = 0 ;
						Map.MoveRootNumber ++ ;
					}
				}
			}
		}
	}

#endif
	
	// I
}


// }bvf[^̓ǂݍ
static s8 LoadMapData( s32 MapID, u8 CompLoadFlag )
{
	char FileName[256] ;
//	int i ;
	
	if( MapTable[MapID].MapType == 3 ) return 0 ;
	
	CompLoadFlag = CompLoadFlag ;

#ifdef DEBUG_MAP
	// ɓǂݍ݂Ă牽I
	if( MapTable[MapID].DataLoadFlag == TRUE ) ReleaseMapData( MapID ) ;
	
	// }bvp^[̓ǂݍ
	{
		sprintf( FileName, "%s%s", MAPFILEFOLDER, DebugMapList[DebugMapNumber] ) ;
		ghmGcMemSetAllocName("YMap");
		MapTable[MapID].Pattern = new KMap ;
		MapTable[MapID].Pattern->Load( FileName ) ;
	}
#else
	// ɓǂݍ݂Ă牽I
	if( MapTable[MapID].DataLoadFlag == TRUE ) return 0 ;

	// }bvp^[̓ǂݍ
	{
		sprintf( FileName, "%smap%02d.BIN", MAPFILEFOLDER, MapID ) ;
		ghmGcMemSetAllocName("YMap");
		MapTable[MapID].Pattern = new KMap ;
		MapTable[MapID].Pattern->Load( FileName ) ;
	}
#endif

	// I摜̓ǂݍ
/*	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
	{
		sprintf( FileName, "%smap%02d_Img.BIN", MAPFILEFOLDER, MapTable[MapID].Select[i].MapID ) ;
		TexLoadSet( FileName, &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) ;
	}
*/
	// I
	return 0 ;
}

// }bvf[^̓ǂݍ݊`FbN( TRUE:ǂݍ݂͊Ă  FALSE:܂ǂݍݒ )
static s8 CheckMapData( s32 MapID )
{
//	s32 i ;

	if( MapTable[MapID].MapType == 3 ) return TRUE ;
	
	// ǂݍ݂ɊĂ牽I
	if( MapTable[MapID].DataLoadFlag == TRUE ) return TRUE ;

	// ǂݍ݊̃`FbNs
	if( MapTable[MapID].Pattern->LoadCheck() == false ) return FALSE ;

/*
	// I摜̓ǂݍ݃`FbN
	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
		if( TexLoadChk( &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) == FALSE ) return FALSE ;
*/

	// [hĂ烍[h̃tO𗧂Ă
	MapTable[MapID].DataLoadFlag = TRUE ;

	// TRUE Ԃ
	return TRUE ;
}

// }bvf[^̉
static s8 ReleaseMapData( s32 MapID )
{
//	s32 i ;

	if( MapTable[MapID].MapType == 3 ) return 0 ;
	
	// ̏s
	if( MapTable[MapID].Pattern != NULL ) delete MapTable[MapID].Pattern ;
	
/*
	// I摜̓ǂݍ݃`FbN
	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
		TexRelease( &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) ;
*/
	ReleaseMapTex( MapID ) ;

	// [h̃tO|
	MapTable[MapID].DataLoadFlag = FALSE ;

	// I
	return 0 ;
}

// }bveNX`̓ǂݍ
static s8 LoadMapTex( s32 MapID )
{
	s32 i ;
	char FileName[128] ;

	// I摜̓ǂݍ
	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
	{
		sprintf( FileName, "%smap%02d_Img.BIN", MAPFILEFOLDER, MapTable[MapID].Select[i].MapID ) ;
		TexLoadSet( FileName, &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) ;
	}
	
	return 0 ;
}

// }bveNX`̓ǂݍ݊`FbN( TRUE:ǂݍ݂͊Ă  FALSE:܂ǂݍݒ )
static s8 CheckMapTex( s32 MapID )
{
	s32 i ;

	// I摜̓ǂݍ݃`FbN
	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
		if( TexLoadChk( &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) == FALSE ) return FALSE ;

	// TRUE Ԃ
	return TRUE ;
}

// }bveNX`̉
static s8 ReleaseMapTex( s32 MapID )
{
	s32 i ;

	// I摜̓ǂݍ݃`FbN
	for( i = 0 ; i < MapTable[MapID].SelectNum ; i ++ )
		TexRelease( &MapTable[MapTable[MapID].Select[i].MapID].ImageTex ) ;

	// I
	return 0 ;
}



// }bvZNg̏
extern s8 MapSelectInit( s32 FirstMap, s32 GoolMap, bool ButtonCancelFlag )
{
//	s32 i ;
	
	if( Map.InitStartFlag != false ) return -1 ;
	if( Map.InitCompFlag == true ) return -1 ;
	
	// ڏϐ̏
	Map.InitStartFlag = true ;
	Map.InitCompFlag = false ;
	Map.InitMode = 0 ;
	Map.InitCounter = 0 ;

	// o鏉s


	// ȂtF[hAEg
	gpSound->mFadeVolumeStream( 0, 150 ) ;
	
	// ԂZbg
	Map.State = -5 ;
	Map.Counter = 0 ;
	
	// F̐ڏ̏
	Map.Bright.init() ;
	Map.Bright.setSingle() ;
	Map.Bright.mov( 2, 1.0F / ( PRM[21] * 0.01F ), 1.0F ) ;
	
	// ړ֌W̏
	Map.FirstMap = FirstMap ;
	Map.GoolMap = GoolMap ;
	Map.MoveRootCounter = 0 ;
	Map.MoveRootNumber = 0 ;
	Map.MovSoundID = -1 ;
	Map.WarpSoundID = -1 ;
	Map.PicExDrawFlag = false ;
	Map.PicExRate = 0.0F ;
	Map.ButtonCancelFlag = ButtonCancelFlag ;
//	Map.ButtonCancelFlag = false ;
	
	Map.ImageZureXB[1] 		= Map.ImageZureXB[0] 		= 0.0F ;
	Map.ImageZureXBFlag[0] 	= Map.ImageZureXBFlag[0] 	= false ;

	Map.BackInfo = NULL ;
	ZureInit( TRUE ) ;
	Map.BackInfo = NULL ;

	// JE^[̏
	Map.CurCounter = 0 ;

	// ̑̃f[^̏
	Map.MoveMap = NULL ;
	Map.OldMap = NULL ;
	Map.EndFlag = FALSE ;
	Map.Result = -1 ;
	Map.DrawMode = 0 ;
	Map.RedBlurRate = 0.0F ;
	Map.RedBlurRate2 = -1.0F ;
	Map.StreamFadeOutCounter = 0 ;
	Map.Font = NULL ;
//	*((u32 *)&Map.Rate) = 0xffffffff ;
	Map.Rate = 1.0F ;

	// [
	memset( Map.AfterImage, 0, sizeof( Map.AfterImage ) ) ;
	Map.AfterImageNum = 0 ;

	// ILtOׂē|
	{
		u32 i ;

		for( i = 0 ; i < MAP_NUM ; i ++ )
#ifndef AUTO
			MapTable[i].SelectValidFlag = TRUE ;
#else
			MapTable[i].SelectValidFlag = FALSE ;
#endif
	}

	if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
	Map.MovSoundID = -1 ;
	
	// I
	return 0 ;
}













#if 0
/*
// }bvZNg̏
extern s8 MapSelectInit( s32 FirstMap, s32 GoolMap )
{
	s32 i ;
	
	if( Map.InitStartFlag != false ) return -1 ;
	if( Map.InitCompFlag == true ) return -1 ;
	
	// ڏϐ̏
	Map.InitStartFlag = true ;
	Map.InitCompFlag = false ;
	Map.InitMode = 0 ;
	Map.InitCounter = 0 ;

	// o鏉s
	InitMapGraph() ;
//	gpSound->mReadSsm( "seMapSelect.ssm", eBank3 ) ;	// t@C̓ǂݍ
	ghmGcMemSetAllocName("YStrImg");
	Map.Font = new YK7StrImage ;						// tHgNX̍쐬
	if( Map.Font == NULL )
	{
		OSReport( "}bvptHg̍쐬Ɏs܂\n" ) ;
		return -1 ;
	}
	
	{
		char FileName[128] ;
		
		sprintf( FileName, "%s%s", MAPFILEFOLDER, MAPFONTPATH ) ;
		if( Map.Font->Load( FileName ) == false )
		{
			OSReport( "}bvptHg̓ǂݍ݂Ɏs܂\n" ) ;
			delete Map.Font ;
			return -1 ;
		}
	}
	
	gpSound->mFadeVolumeStream( 0, 150 ) ;
//	gpSound->mStopStream() ;

	TexLoadSet( REDBLURTEX, &Map.RedBlur ) ;	// ԃu[eNX`̓ǂݍ
	
	Map.State = -5 ;				// ԂZbg
	Map.Counter = 0 ;
	
	Map.Bright.init() ;			// F̐ڏ̏
	Map.Bright.setSingle() ;
	Map.Bright.mov( 2, 1.0F / ( PRM[21] * 0.01F ), 1.0F ) ;
//	Map.BrightAddDir = FALSE ;
	
	Map.FirstMap = FirstMap ;	// ړ֌W̏
	Map.GoolMap = GoolMap ;
	Map.MoveRootCounter = 0 ;
	Map.MoveRootNumber = 0 ;
	Map.MovSoundID = -1 ;
	Map.WarpSoundID = -1 ;
	Map.PicExDrawFlag = false ;
	Map.PicExRate = 0.0F ;
	
	Map.ImageZureXB[1] 		= Map.ImageZureXB[0] 		= 0.0F ;
	Map.ImageZureXBFlag[0] 	= Map.ImageZureXBFlag[0] 	= false ;

	Map.BackInfo = NULL ;
	ZureInit( TRUE ) ;
	Map.BackInfo = NULL ;
	
	if( MapRootCreate( FirstMap, GoolMap ) < 0 ) return -1 ;		// oH̍쐬

	Map.CrtMap = MapTable[FirstMap].ParentMap ;						// ŏɕ\}bv̏
#ifdef DEBUG_MAP
	Map.CrtMap = MAP_WASHINGTON_DC ;
#endif
////	LoadMapData( (s8)Map.CrtMap, TRUE ) ;
////	while( CheckMapData( Map.CrtMap ) == FALSE ){}
	LoadMapTex( (s8)Map.CrtMap ) ;
	while( CheckMapTex( Map.CrtMap ) == FALSE ){}

	// SẴ}bvǂݍ
	for( i = 0 ; i < MAP_NUM ; i ++ ) LoadMapData( i, TRUE ) ;
	for(;;)
	{
		for( i = 0 ; i < MAP_NUM ; i ++ ) if( CheckMapData( i ) == FALSE ) break ;
		if( i == MAP_NUM ) break ;
	}

	ChangeMapGraph( -2, 2 ) ;										// \}bv̕ύX

	// IĂ}bvZbg
	{
		s32 i ;
		
		for( i = 0 ; i < CRTIF.SelectNum && CRTIF.Select[i].MapID != FirstMap ; i ++ ){}
		Map.SelectMap = i != CRTIF.SelectNum ? i : 0 ;
	}

	// JE^[̏
	Map.CurCounter = 0 ;

	// ̑̃f[^̏
	Map.MoveMap = NULL ;
	Map.OldMap = NULL ;
	Map.EndFlag = FALSE ;
	Map.Result = -1 ;
	Map.DrawMode = 0 ;
	Map.RedBlurRate = 0.0F ;
	Map.RedBlurRate2 = -1.0F ;
	Map.StreamFadeOutCounter = 0 ;

	// [
	memset( Map.AfterImage, 0, sizeof( Map.AfterImage ) ) ;
	Map.AfterImageNum = 0 ;

	// ILtOׂē|
	{
		u32 i ;

		for( i = 0 ; i < MAP_NUM ; i ++ )
#ifndef AUTO
			MapTable[i].SelectValidFlag = TRUE ;
#else
			MapTable[i].SelectValidFlag = FALSE ;
#endif
	}

	SetMapSelectValidFlag( (u8)FirstMap, TRUE ) ;
	SetMapSelectValidFlag( (u8)GoolMap, TRUE ) ;

	if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
	Map.MovSoundID = -1 ;
//	Map.MovSoundID = PlayEffectSE( SFX_MAP_SEL_MOJIL ) ;
	
	// cǉ
	InitAfterImage() ;
	AddAfterImage( Map.CrtMap, -1, SELMAPID ) ;

	// I
	return 0 ;
}
*/
#endif







// }bvZNǧn
extern s8 MapSelectEnd( void )
{
	s32 i ;
	
	if( Map.InitCompFlag == false && Map.InitStartFlag == false ) return 0 ;

	// ԃu[eNX`̉
	TexRelease( &Map.RedBlur ) ;
	
	// ׂẴf[^
	for( i = 0 ; i < MAP_NUM ; i ++ )
		ReleaseMapData( i ) ;

	// yt@C̉
//	gpSound->mReleaseSsm( "seMapSelect.ssm" ) ;
	
	// }bvtHg̉
	if( Map.Font != NULL )
	{
		delete Map.Font ;
		Map.Font = NULL ;
	}
	
/*	if( Map.WarpSoundID != -1 )
	{
		gpSound->mStopSENo( Map.WarpSoundID ) ;
		Map.WarpSoundID = -1 ;
	}
*/	
	if( Map.MovSoundID != -1 )
	{
		gpSound->mStopSENo( Map.MovSoundID ) ;
		Map.MovSoundID = -1 ;
	}

	// ̉
	EndMapGraph() ;
	
	// tO|
	Map.InitCompFlag = false ;
	Map.InitStartFlag = false ;

	// I
	return 0 ;
}

// }bvZNg̃t[vZX
extern s8 MapSelectFrameProcess( void )
{
	// I܂ŉȂ
	if( MapSelectLoadFunc() == FALSE ) return 0 ;

	// IĂ牽Ȃ
	if( Map.EndFlag == TRUE ) return 0 ;

	// ȂtF[hAEg܂ő҂
	if( Map.StreamFadeOutCounter < 15 )
	{
		Map.StreamFadeOutCounter ++ ;
	
		if( Map.StreamFadeOutCounter >= 15 )
			gpSound->mPlayStreamNo( HPS_MAP, VOLUME_MUSIC, AXDRIVER_MAX_GROUP, false ) ;
			
		return 0 ;
	}

	// g`t@C̓ǂݍݑ҂
//	if( gpSound->mGetProcess() != eSndStandby ) return 0 ;

	UpdateInput() ;					// ͏Ԃ̍XV
	FrameProcessAfterImage() ;		// c
	MapGraphFrameProcess() ;		// }bv`bv쏈

	// ̋̕ω
	Map.Bright.proc() ;
	if( Map.Bright.eop() == true )
		Map.Bright.mov( 2, 1.0F / ( PRM[21] * 0.01F ), ( Map.Bright.x == 1.0F ) ? 0.0F : 1.0F ) ;

	// X^[g{^ꂽLZ
//#ifdef DEBUG_MODE
	if( Map.ButtonCancelFlag == true && ( HSD_PadGetTrigger(0) & PAD_BUTTON_START )/*PAD_BUTTON_B*/ )
	{
		Map.EndFlag = TRUE ;
		Map.Result = Map.GoolMap ;
		gpSound->mFadeVolumeStream( 0, STREAM_FADEOUTTIME ) ;
		return 0 ;
	}
//#endif	

	// ԃu[
	if( ( Map.Rate == 1.0F || Map.Rate == 0.0F ) &&
		( TexValidChk( &MapTable[SELMAPID].ImageTex ) == TRUE ) 
//		( Map.MoveRootNumber == 0 || Map.MoveRootNumber == Map.MoveRootPointNum - 1 )
		 )
	{
		if( Map.RedBlurRate >= 0.0F )
		{
			Map.RedBlurRate += REDBLURSPEED ;
			if( Map.RedBlurRate >= REDBLURWAIT && Map.RedBlurRate2 < 0.0F )
			{
				Map.RedBlurRate2 = 0.0F ;
				if( Map.PicExDrawFlag == false && ( TexValidChk( &MapTable[SELMAPID].ImageTex ) == TRUE ) ) PlayEffectSE( SFX_MAP_SEL_WARP ) ;
			}
			
			if( Map.RedBlurRate >= 1.0F )
			{
				Map.RedBlurRate = -1.0F ;
			}
		}

		if( Map.RedBlurRate2 >= 0.0F )
		{
			Map.RedBlurRate2 += REDBLURSPEED ;
			if( Map.RedBlurRate2 >= REDBLURWAIT && Map.RedBlurRate < 0.0F )
			{
				Map.RedBlurRate = 0.0F ;
				if( Map.PicExDrawFlag == false && ( TexValidChk( &MapTable[SELMAPID].ImageTex ) == TRUE ) ) PlayEffectSE( SFX_MAP_SEL_WARP ) ;
			}
			
			if( Map.RedBlurRate2 >= 1.0F )
			{
				Map.RedBlurRate2 = -1.0F ;
			}
		}
	}
		
	// Ԃɂď𕪊
	switch( Map.State )
	{
	case 200 :		// II
		Map.Counter ++ ;
		if( Map.Counter == MAPENDWAIT )
		{
			Map.Counter = 0 ;
			Map.State += 10 ;
			
			PlayEffectSE( SFX_MAP_PHOTO_ZOOMIN ) ;
			
			gpSound->mFadeVolumeStream( 0, STREAM_FADEOUTTIME ) ;
			
			Map.PicExDrawFlag = true ;
			Map.PicExRate = 0.0F ;
		}
		break ;
		
	case 210 :		// ʐ^g
		Map.PicExRate += ( 1.0F - Map.PicExRate ) / PIC_ZOOMSPEED ;
		if( Map.PicExRate >= 0.98F )
		{
			Map.PicExRate = 1.0F ;
			Map.Counter = 0 ;
			Map.State += 10 ;
		}
		break ;
		
	case 220 :		// I҂Q
		Map.Counter ++ ;
		if( Map.Counter == MAPENDWAIT2 )
		{
			Map.Counter = 0 ;
			Map.State += 10 ;
		}
		break ;
		
	case 230 :		// I
		Map.EndFlag = TRUE ;
		Map.Result = Map.MoveMapID ;
		break ;
	
	case -5 :		// Jn҂
		// ꏊ̃t[vZX
		ZureFrameProcessDec() ;
		Map.Counter ++ ;
		if( Map.Counter >= MAPSTARTWAIT )
		{
			PlayEffectSE( SFX_MAP_SHUSOKU ) ;
//			PlayEffectSE( SFX_MAP_SEL_ZOOM ) ;
//			CreateSoundEffect( SFX_MAP_SEL_ZOOM_KAKUTEI, 10, (Vec){0.0F,0.0F,0.0F}, TRUE ) ;
			ChangeMapGraph( Map.CrtMap, 2 ) ;								// \}bv̕ύX
			Map.State = 0 ;
		}
		break ;
		
	case 500 :
		// ꏊ̃t[vZX
		Map.BackSelect = -1 ;
		ZureFrameProcessInc() ;

		Map.Counter ++ ;
		if( Map.Counter >= 15 )
		{
			Map.State = (s16)Map.Counter2 ;
			Map.Counter = 0 ;
		}
		break ;
		
	case 0 :		// I҂
		if( Map.AfterImageNum == 0 )
		{
			switch( Map.MovSoundID )
			{
			case -1 :
				break ;
			
			case -4 :
				PlayEffectSE( SFX_MAP_SEL_ZOOM_KAKUTEI ) ;
				Map.MovSoundID = -1 ;
				break ;
			
			default :
				gpSound->mStopSENo( Map.MovSoundID ) ;
				Map.MovSoundID = -4 ;
				break ;
			}
		}

		// ꏊ̃t[vZX
		ZureFrameProcessDec() ;
	
		// J[\삪ꂽꍇ͑IΏۂύX
		if( EdgeInput & PAD_BUTTON_LEFT )
		{
			s32 Index ;

			ZureInit( TRUE ) ;			
			Index = Map.SelectMap ;

			PlayEffectSE( SFX_MAP_SEL_ZOOM ) ;
			
			if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
			Map.MovSoundID = -1 ;
			Map.MovSoundID = PlayEffectSE( SFX_MAP_SEL_MOJIL ) ;

			// I\ȍڂ܂ňړ
			do
			{
				Map.SelectMap -- ;
				if( Map.SelectMap < 0 ) Map.SelectMap = CRTIF.SelectNum - 1 ;
			} while( CRTINFO(Map.SelectMap).SelectValidFlag == FALSE ) ;

			// cǉ
			if( Index != Map.SelectMap )
			{
				InitAfterImage() ;
				AddAfterImage( Map.CrtMap, CRTIF.Select[Index].MapID, SELMAPID ) ;
			}
		}
		else
		if( EdgeInput & PAD_BUTTON_RIGHT )
		{
			s32 Index ;
			
			ZureInit( TRUE ) ;			
			Index = Map.SelectMap ;
			
			PlayEffectSE( SFX_MAP_SEL_ZOOM ) ;

			if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
			Map.MovSoundID = -1 ;
			Map.MovSoundID = PlayEffectSE( SFX_MAP_SEL_MOJIL ) ;
			
			// I\ȍڂ܂ňړ
			do
			{
				Map.SelectMap ++ ;
				if( Map.SelectMap >= CRTIF.SelectNum ) Map.SelectMap = 0 ;
			} while( CRTINFO(Map.SelectMap).SelectValidFlag == FALSE ) ;
			
			// cǉ
			if( Index != Map.SelectMap )
			{
				InitAfterImage() ;
				AddAfterImage( Map.CrtMap, CRTIF.Select[Index].MapID, SELMAPID ) ;
			}
		}
		
		// {^ꂽԂY[CɕύX
		if( EdgeInput & PAD_BUTTON_A )
		{
			// Y[C̏s
			Map.Counter2 = 10 ;
			Map.Counter = 0 ;
			Map.State = 500 ;
			Map.ZomeCounter = 0.0F ;
			Map.BackInfo = NULL ;
			Map.RenderZomeCounter = 0.0F ;
			Map.MoveMap = &MapTable[SELMAPID] ;
			Map.MoveMapID = SELMAPID ;
			Map.OldMap = &CRTIF ;

#ifdef DEBUG_MAP
			DebugMapNumber ++ ;
			if( DebugMapList[DebugMapNumber] == NULL ) DebugMapNumber = 0 ;
			if( DebugFlag == false )
			{
//				Map.CrtMap = MAP_NY ;
				Map.MoveMap = &MapTable[MAP_NY] ;
				Map.MoveMapID = MAP_NY ;
			}
			else
			{
//				Map.CrtMap = MAP_WASHINGTON_DC ;
				Map.MoveMap = &MapTable[MAP_WASHINGTON_DC] ;
				Map.MoveMapID = MAP_WASHINGTON_DC ;
			}
			DebugFlag = !DebugFlag ;
#endif

			// ړ}bvꍇ͏Is
			if( MapTable[Map.MoveMapID].MapType == 3 )
			{
				Map.DrawMode = 0 ;
			
				Map.State = 200 ;
				Map.Counter = 0 ;
				
				ChangeMapGraph( -1, 1 ) ;

				return 0 ;
			}

			// }bvf[^[hJn
#ifndef DEBUG_MAP
			if( CRTINFO( Map.SelectMap ).MapType != 3 )
#endif
////				LoadMapData( Map.MoveMapID ) ;
				LoadMapTex( Map.MoveMapID ) ;
		}
		else
		// LZ{^ꂽԂY[AEgɕύX
		if( EdgeInput & PAD_BUTTON_B )
		{
			// e}bvLZԂɃZbg
			if( CRTIF.ParentMap == -1 )
			{
				Map.EndFlag = TRUE ;
				Map.Result = -1 ;
				return 0 ;
			}
			
			// Y[AEg̏s
			Map.Counter2 = 11 ;
			Map.Counter = 0 ;
			Map.State = 500 ;
			Map.ZomeCounter = 0.0F ;
			Map.RenderZomeCounter = 0.0F ;
			Map.MoveMap = &MapTable[CRTIF.ParentMap] ;
			Map.MoveMapID = CRTIF.ParentMap ;
			Map.BackInfo = NULL ;
			Map.OldMap = &CRTIF ;

#ifdef DEBUG_MAP
			DebugMapNumber -- ;
			if( DebugMapNumber == -1 )
			{
				DebugMapNumber = 0 ;
				while( DebugMapList[DebugMapNumber+1] != NULL ) DebugMapNumber ++ ;
			}
			if( DebugFlag == false )
			{
//				Map.CrtMap = MAP_NY ;
				Map.MoveMap = &MapTable[MAP_NY] ;
				Map.MoveMapID = MAP_NY ;
			}
			else
			{
//				Map.CrtMap = MAP_WASHINGTON_DC ;
				Map.MoveMap = &MapTable[MAP_WASHINGTON_DC] ;
				Map.MoveMapID = MAP_WASHINGTON_DC ;
			}
			DebugFlag = !DebugFlag ;
#endif

			// }bvf[^[hJn
////			LoadMapData( Map.MoveMapID ) ;
			LoadMapTex( Map.MoveMapID ) ;
//			if( MapTable[Map.MoveMapID].ParentMap != -1 )
//				LoadMapData( MapTable[Map.MoveMapID].ParentMap ) ;
		}

		break ;

	case 10 :		// Y[C[h҂
////		if( CheckMapData( Map.MoveMapID ) == TRUE )
		if( CheckMapTex( Map.MoveMapID ) == TRUE )
		{
			Map.Counter = 0 ;
			Map.State = 1 ;

			if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
			Map.MovSoundID = -1 ;
			Map.MovSoundID = PlayEffectSE( SFX_MAP_SEL_MOJIL ) ;
			
			// cǉ
			InitAfterImage() ;
			AddAfterImage( Map.CrtMap, SELMAPID, -1 ) ;

			// `惂[hύX
			Map.DrawMode = 1 ;
			Map.BigMap = Map.CrtMap ;
			Map.SmallMap = Map.MoveMapID ;
			Map.Rate = 0.0F ;
			Map.AlphaRate = 1.0F ;
			Map.RedBlurRate = 0.0F ;
			Map.RedBlurRate2 = -0.5F ;
		}
		break ;

	case 11 :		// Y[AEg[h҂
////		if( CheckMapData( Map.MoveMapID ) == TRUE &&
////		/*	( MapTable[Map.MoveMapID].ParentMap == -1 || CheckMapData( MapTable[Map.MoveMapID].ParentMap ) == TRUE )*/ )
		if( CheckMapTex( Map.MoveMapID ) == TRUE )
		{
			Map.Counter = 0 ;
			Map.State = 2 ;
			
			if( Map.MovSoundID != -1 ) gpSound->mStopSENo( Map.MovSoundID ) ;
			Map.MovSoundID = -1 ;
			Map.MovSoundID = PlayEffectSE( SFX_MAP_SEL_MOJIL ) ;
			
			// cǉ
			InitAfterImage() ;
			AddAfterImage( Map.CrtMap, SELMAPID, -1 ) ;

			// `惂[hύX
			Map.DrawMode = 1 ;
			Map.BigMap = Map.MoveMapID ;
			Map.SmallMap = Map.CrtMap ;
			Map.Rate = 1.0F ;
			Map.AlphaRate = 1.0F ;
			Map.RedBlurRate = 0.0F ;
			Map.RedBlurRate2 = -0.5F ;
		}
		break ;

	case 1 :		// Y[C
		if( Map.Counter == 0 )
		{
			PlayEffectSE( SFX_MAP_SEL_KAKUDAI ) ;
			Map.Counter = 1 ;
			
			ZureInit( FALSE ) ;
		}
		
		// Y[CJE^CNg
//		Map.ZomeCounter += 1.0F / PRM[17] ;
		Map.ZomeCounter += MAPZOOMSPEED ;
		Map.RenderZomeCounter = 1.0F - GetSanjiFunction( -PRM[16] * 0.01F, 1.0F, PRM[17], Map.ZomeCounter * PRM[17] ) ;

		// ԃZbg
		{
			Map.Rate = Map.ZomeCounter ;
		}

		// Y[C؂珈𕪊
		if( Map.ZomeCounter > 1.0F )
		{
			s32 i ;
		
			gpSound->mStopSENo( Map.MovSoundID ) ;
			PlayEffectSE( SFX_MAP_SEL_ZOOM ) ;
			
			// O̐ẽ}bṽf[^
////			if( CRTIF.ParentMap != -1 )
////				ReleaseMapData( CRTIF.ParentMap ) ;
			if( CRTIF.ParentMap != -1 )
				ReleaseMapTex( CRTIF.ParentMap ) ;

			// f[^XV
			Map.CrtMap = Map.MoveMapID ;
			Map.SelectMap = 0 ;
			Map.State = 0 ;
			Map.RenderZomeCounter = 0.0F ;

			if( Map.PicExDrawFlag == false && ( TexValidChk( &MapTable[SELMAPID].ImageTex ) == TRUE ) ) PlayEffectSE( SFX_MAP_SEL_WARP ) ;
			
#ifdef AUTO
			// ICfbNXZbg
			for( i = 0 ; Map.MoveRoot[Map.MoveRootNumber+1] != CRTIF.Select[i].MapID ; i ++ ){}
			Map.SelectMap = i ;
#endif
			
			// F̐ڏ̏
			Map.Bright.spos( 0.0F ) ;
	
			// cǉ
			InitAfterImage() ;
//			AddAfterImage( -1, SELMAPID ) ;
			AddAfterImage( Map.CrtMap, -1, SELMAPID ) ;

			// }bv̕ύX
#ifdef DEBUG_MAP
			ChangeMapGraph( Map.CrtMap, 1, 0, 0 ) ;
#else
			ChangeMapGraph( Map.CrtMap, 1, GetMapSelectInfo(Map.CrtMap)->Rect.left, GetMapSelectInfo(Map.CrtMap)->Rect.top ) ;
#endif
			ZureInit( TRUE ) ;
			Map.BackInfo = NULL ;
			
			// `惂[h̕ύX
//			Map.DrawMode = 0 ;
			Map.DrawMode = 1 ;
			Map.SmallMap = Map.MoveMapID ;
			Map.BigMap = Map.CrtMap ;
			Map.Rate = 0.0F ;
			Map.RedBlurRate = 0.0F ;
			Map.RedBlurRate2 = -0.5F ;
		}
		break ;
		
	case 2 :		// Y[AEg
		if( Map.Counter == 0 )
		{
			PlayEffectSE( SFX_MAP_SEL_KAKUDAI ) ;
			Map.Counter = 1 ;

			ZureInit( FALSE ) ;
		}
	
		// Y[AEgJE^CNg
//		Map.ZomeCounter += 1.0F / PRM[17] ;
		Map.ZomeCounter += MAPZOOMSPEED ;
		Map.RenderZomeCounter = 1.0F - GetSanjiFunction( -PRM[16] * 0.01F, 1.0F, PRM[17], Map.ZomeCounter * PRM[17] ) ;
		
		// ԃZbg
		{
			Map.Rate = 1.0F - Map.ZomeCounter ;
		}

		// Y[AEg؂珈𕪊
		if( Map.ZomeCounter > 1.0F )
		{
			s32 i ;
		
			gpSound->mStopSENo( Map.MovSoundID ) ;
			PlayEffectSE( SFX_MAP_SEL_ZOOM ) ;
			
			ZureInit( TRUE ) ;
			Map.BackInfo = NULL ;
			
			// }bv̕ύX
#ifdef DEBUG_MAP
			ChangeMapGraph( Map.MoveMapID, 0, 0, 0 ) ;
#else
			ChangeMapGraph( Map.MoveMapID, 0, GetMapSelectInfo(Map.CrtMap)->Rect.left, GetMapSelectInfo(Map.CrtMap)->Rect.top ) ;
#endif

			// Õ}bṽf[^
////			ReleaseMapData( Map.CrtMap ) ;
			ReleaseMapTex( Map.CrtMap ) ;

			// ICfbNXZbg
			for( i = 0 ; Map.CrtMap != MapTable[CRTIF.ParentMap].Select[i].MapID ; i ++ ){}
			Map.SelectMap = i ;

			// F̐ڏ̏
			Map.Bright.spos( 0.0F ) ;
	
			// f[^XV
			Map.CrtMap = Map.MoveMapID ;
			Map.State = 0 ;

			// cǉ
			InitAfterImage() ;
//			AddAfterImage( -1, SELMAPID ) ;
			AddAfterImage( Map.CrtMap, -1, SELMAPID ) ;
			
			// `惂[h̕ύX
//			Map.DrawMode = 0 ;
			Map.DrawMode = 1 ;
			Map.BigMap = Map.CrtMap ;
			Map.SmallMap = Map.MoveMapID ;
			Map.Rate = 0.0F ;
			Map.RedBlurRate = 0.0F ;
			Map.RedBlurRate2 = -0.5F ;
			if( Map.PicExDrawFlag == false && ( TexValidChk( &MapTable[SELMAPID].ImageTex ) == TRUE ) ) PlayEffectSE( SFX_MAP_SEL_WARP ) ;
		}
		break ;
	}

	// I
	return 0 ;
}

// }bvZNg̕`vZX
extern s8 MapSelectRenderProcess( void )
{
	f32 PicX, PicY ;
	TEXDATA *PicTex = NULL ;

	if( MapSelectLoadFunc() == FALSE ) return 0 ;

	if( Map.EndFlag == TRUE ) return 0 ;					// IĂ牽Ȃ
//	if( TexLoadChk( &Map.RedBlur ) == FALSE ) return 0 ;	// ԃeNX`̓ǂݍݑ҂

	// g`t@C̓ǂݍݑ҂
//	if( gpSound->mGetProcess() != eSndStandby ) return 0 ;

	// f[^ǂݍݏIĖ牽I
	if( CheckMapData( Map.CrtMap ) == FALSE || CheckMapTex( Map.CrtMap ) == FALSE )
		return 0 ;

	// tHgt@C̓ǂݍݑ҂
//	if( Map.Font->LoadCheck() == false ) return 0 ;

	if( Map.StreamFadeOutCounter < 15 ) return 0 ;

	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_NOTEX ) ;		// `揀
//	DrawBox( 0, 0, SCW, SCH, CMK( PRM2[18], PRM2[19], PRM2[20], 0xff ) ) ;		// ʏ
	DrawBox( 0, 0, SCW, SCH, 0xff ) ;		// ʏ

	// }bv̕`
	if( Map.DrawMode == 0 )
	{
		MapGraphRenderProcess() ;
	}
	else
	{
		f32 smallX, smallY, f1, f2, f3 ;
	
		f1 = BIGMAPSIZE / SMALLMAPSIZE ;
		f2 = BIGMAPSIZE ;
		f3 = ( BIGMAPSIZE / SMALLMAPSIZE - BIGMAPSIZE ) * Map.Rate + BIGMAPSIZE ;
	
		smallX = (f32)MapTable[Map.SmallMap].ParentX * BIGMAPONECHIPSIZE + BIGMAPONECHIPSIZE / 2.0F ;
		smallY = (f32)MapTable[Map.SmallMap].ParentY * BIGMAPONECHIPSIZE + BIGMAPONECHIPSIZE / 2.0F ;
		__MapDraw( Map.BigMap, Map.SmallMap,
//					smallX, smallY,
					( smallX - BIGMAPSIZE / 2.0F ) * Map.Rate + BIGMAPSIZE / 2.0F,
					( smallY - BIGMAPSIZEH / 2.0F ) * Map.Rate + BIGMAPSIZEH / 2.0F,
					( BIGMAPSIZE / ( 1.0F / MapTable[Map.SmallMap].MapSize ) - BIGMAPSIZE ) * Map.Rate + BIGMAPSIZE,
					MapTable[Map.SmallMap].MapSize, 1, Map.Rate ) ;
	}
	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;

	// ēx
	EffectTevSetup( EF_TEV_NOTEX ) ;
	EffectBlendModeSetup( EF_BLEND_ALPHA ) ;

#ifdef DEBUG_MAP
	return 0 ;
#endif

	// }bv̕`
/*	switch( Map.State )
	{
	case -5 :
	case 0 :		// sI𒆂̏
	case 1 :
	case 2 :
	case 10 :
	case 11 :
	case 200 :
	case 210 :
	case 220 :
*/
		// sg̕`
		{
			RECTU16 *Rect, rc ;
			f32 siz, suk, cx, cy ;
			u32 cr, cr2 ;

			rc.left		= MapTable[SELMAPINFO.MapID].ParentX ;
			rc.top 		= MapTable[SELMAPINFO.MapID].ParentY ;
//			rc.right	= (u16)( rc.left + 1 ) ;
//			rc.bottom	= (u16)( rc.top + 1 ) ;
//			Rect = &SELMAPINFO.Rect ;
			Rect = &rc ;
		
			// ̑Zbg
			GXSetLineWidth( (u8)PRM[7], GX_TO_ONE ) ;
			
			siz = CHIPSIZE ;
			suk = CHIPSUKIMA ;

#ifndef DEBUG_0		
			
			if( Map.AfterImageNum == 0 && Map.Rate == 1.0F || Map.Rate == 0.0F )
			{
				cr = CMK( 255, 255, 255, 255 * LINE_ALPHA ) ;
				cr2 = CMK( 255, 255, 255, LINE_MINALPHA * LINE_ALPHA ) ;

				cx = Rect->left * siz + (f32)siz / 2.0F ;
				cy = Rect->top * siz + (f32)siz / 2.0F ;

				EffectTevSetup( EF_TEV_NOTEX ) ;				
				GBGN( GX_LINES, 16 ) ;
				DrawLine2NB( 0, 	Rect->top * siz + suk,	 		cr2, 	cx, 	Rect->top * siz + suk, 			cr ) ;
				DrawLine2NB( cx,	Rect->top * siz + suk, 			cr,		SCW, 	Rect->top * siz + suk, 			cr2 ) ;

				DrawLine2NB( 0, 	Rect->top * siz + siz - suk,	cr2,  	cx, 	Rect->top * siz + siz - suk, 	cr ) ;
				DrawLine2NB( cx, 	Rect->top * siz + siz - suk,	cr,		SCW, 	Rect->top * siz + siz - suk, 	cr2 ) ;

				DrawLine2NB( Rect->left * siz + suk,		0, 		cr2,	Rect->left * siz + suk,			cy,		cr ) ;
				DrawLine2NB( Rect->left * siz + suk,		cy,		cr, 	Rect->left * siz + suk,			SCH, 	cr2 ) ;

				DrawLine2NB( Rect->left * siz + siz - suk, 	0, 		cr2,	Rect->left * siz + siz - suk, 	cy,		cr ) ;
				DrawLine2NB( Rect->left * siz + siz - suk, 	cy, 	cr,		Rect->left * siz + siz - suk, 	SCH, 	cr2 ) ;
				GEND() ;
			}
#endif

			// c̕`
			RenderProcessAfterImage() ;
		}

#ifdef DEBUG_0		
	return 0 ;
#endif
	
		// I\ȍsFႢŕ`
		if( Map.Rate == 1.0F || Map.Rate == 0.0F )
		{
			u32 i ;
			
			for( i = 0 ; i < CRTIF.SelectNum ; i ++ )
			{
				if( CRTINFO(i).SelectValidFlag == TRUE )
				{
					RECTU16 *Rect, rc ;
					u8 r, g, b ;
					f32 siz, suk ;
					MAPINFO *info ;
					MAPSELECTINFO *selinfo ;

					rc.left		= MapTable[CRTIF.Select[i].MapID].ParentX ;
					rc.top		= MapTable[CRTIF.Select[i].MapID].ParentY ;
//					rc.right	= (u16)( rc.left + 1 ) ;
//					rc.bottom	= (u16)( rc.top + 1 ) ;
//					Rect = &CRTIF.Select[i].Rect ;
					Rect = &rc ;

				    if( i == Map.SelectMap )
				    {
						u32 r2, g2, b2 ;
						
						r2 = (u32)( SELCHIPMUL * SELCHIPR2 / 10 ) ;		if( r2 > 255 ) r2 = 255 ;
						g2 = (u32)( SELCHIPMUL * SELCHIPG2 / 10 ) ;		if( g2 > 255 ) g2 = 255 ;
						b2 = (u32)( SELCHIPMUL * SELCHIPB2 / 10 ) ;		if( b2 > 255 ) b2 = 255 ;

						r = (u8)( (1.0F - Map.Bright.x ) * SELCHIPR2 + Map.Bright.x * r2 ) ;
						g = (u8)( (1.0F - Map.Bright.x ) * SELCHIPG2 + Map.Bright.x * g2 ) ;
						b = (u8)( (1.0F - Map.Bright.x ) * SELCHIPB2 + Map.Bright.x * b2 ) ;

						// s`
						if( Map.NowInfoValid == 1 )
						{
							info = &MapTable[CRTIF.Select[i].MapID] ;
							selinfo = &CRTIF.Select[Map.SelectMap] ;
							if( TexValidChk( &info->ImageTex ) == true )
							{
								f32 x, y, x2, y2, adx, ady, w, h ;
								s32 alpha ;
								
								if( Map.ImageZureXBFlag[0] == false &&
									Map.PicZureRateB > Map.PicZureRate[0] )
								{
									PlayEffectSE( SFX_MAP_PHOTO_ZOOMOUT ) ;
									Map.ImageZureXBFlag[0] = true ;
								}
								else
								if( Map.ImageZureXBFlag[0] == true && 
									Map.PicZureRateB < Map.PicZureRate[0] )
								{
									PlayEffectSE( SFX_MAP_PHOTO_ZOOMIN ) ;
									Map.ImageZureXBFlag[0] = false ;
								}
								Map.ZureRateB = Map.ZureRate[0] ;
								Map.PicZureRateB = Map.PicZureRate[0] ;
								
								PicTex = &info->ImageTex ;

								w = ( ( BIGIMAGEW - IMAGEW ) * Map.PicZureRate[0] + IMAGEW ) / 2.0F ;
								h = ( ( BIGIMAGEH - IMAGEH ) * Map.PicZureRate[0] + IMAGEH ) / 2.0F ;
								adx = (s32)( Map.ImageZureX[0] * Map.PicZureRate[0] ) ;
								ady = (s32)( Map.ImageZureY[0] * Map.PicZureRate[0] ) ;
								alpha = (s32)( 255 * ( 1.0F - Map.PicZureRate[0] ) ) ;
							
								EffectTevSetup( EF_TEV_USETEX ) ;
								EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
								PicX = x = info->ParentX * CHIPSIZE + ( info->ImageX == 0 ? -IMAGEW - PICZURE : CHIPSIZE + PICZURE ) + adx + IMAGEW / 2.0F ;
								PicY = y = info->ParentY * CHIPSIZE + ( info->ImageY == 0 ? -IMAGEH - PICZURE : CHIPSIZE + PICZURE ) + ady + IMAGEH / 2.0F ;
//								PicX = x = selinfo->Rect.left * CHIPSIZE + ( info->ImageX == 0 ? -IMAGEW - PICZURE : CHIPSIZE + PICZURE ) + adx + IMAGEW / 2.0F ;
//								PicY = y = selinfo->Rect.top * CHIPSIZE + ( info->ImageY == 0 ? -IMAGEH - PICZURE : CHIPSIZE + PICZURE ) + ady + IMAGEH / 2.0F ;
								x2 = x + ( info->ImageX == 0 ? -PICSHDZURE : PICSHDZURE ) ;
								y2 = y + ( info->ImageY == 0 ? -PICSHDZURE : PICSHDZURE ) ;
								
								// g̕`
								EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
								DrawLineBox( x - w, y - h,
											 x + w, y + h, CMK( 0, 0, 0, 255 * alpha / 255 ) ) ;
								DrawBox( x2 - w, y2 - h,
										 x2 + w, y2 + h,
										 CMK( PICSHDR, PICSHDG, PICSHDB, PICSHDA * alpha / 255 ) ) ;
								
/*
								if( Map.WarpSoundID == -1 && Map.ZureRate[0] == 0.0F )
								{
//									Map.WarpSoundID = PlayEffectSEP( SFX_MAP_SEL_WARP, (s16)( ( PR[24] - 100 ) * 10 ) ) ;
									Map.WarpSoundID = PlayEffectSE( SFX_MAP_SEL_WARP ) ;
								}
								else
								if( Map.WarpSoundID != -1 && Map.ZureRate[0] != 0.0F )
								{
									gpSound->mStopSENo( Map.WarpSoundID ) ;
									Map.WarpSoundID = -1 ;
								}
*/

								DrawTex3( x - w, y - h, x + w, y + h, &info->ImageTex, 0xffffff00 + alpha ) ;
	//							DrawTex3( ( info->ImageX + selinfo->Rect.left + 1 ) * CHIPSIZE, ( selinfo->Rect.top + info->ImageY + 1 ) * CHIPSIZE,
	//										( info->ImageX + selinfo->Rect.left + 1 ) * CHIPSIZE + 160, ( selinfo->Rect.top + info->ImageY + 1 ) * CHIPSIZE + 120, &info->ImageTex, 0xffffffff ) ;
							}
							else
							{
								Map.ImageZureXBFlag[0] = false ;
							}

							// s敶`
							{
								s32 x, y, x2, y2, x3, y3, h ;
								s32 adx, ady, alpha ;
								f32 w ;
								
								adx = (s32)( Map.TextZureX[0] * Map.ZureRate[0] ) ;
								ady = (s32)( Map.TextZureY[0] * Map.ZureRate[0] ) ;
								alpha = (s32)( 255 * ( 1.0F - Map.ZureRate[0] ) ) ;
								
								Map.Font->DrawSetup() ;
								Map.Font->SetJikan( NAMEJIKAN ) ;
								Map.Font->SetExRate2( TEXTSIZE, 1.0F ) ;
								h = CHIPSIZE * 3 ;
								w = Map.Font->DrawSStr( 0, 0, info->MapName, false, false ) ;
								Map.Font->SetExRate( 1.0F ) ;
								
								x = (s32)( info->ParentX * CHIPSIZE + ( info->TextX == 0 ? -w - NAMEZURE : CHIPSIZE + NAMEZURE ) + adx ) ;
								y = info->ParentY * CHIPSIZE + ( info->TextY == 0 ? -h - NAMEZURE  : CHIPSIZE + NAMEZURE + NAMEBOTTOMY ) + ady ;
//								x = selinfo->Rect.left * CHIPSIZE + ( info->TextX == 0 ? -w - NAMEZURE : CHIPSIZE + NAMEZURE ) + adx ;
//								y = selinfo->Rect.top * CHIPSIZE + ( info->TextY == 0 ? -h - NAMEZURE  : CHIPSIZE + NAMEZURE ) + ady ;
								x2 = x + ( info->TextX == 0 ? -NAMEZUREX : NAMEZUREX ) ;
								y2 = y + ( info->TextY == 0 ? -NAMEZUREY : NAMEZUREY ) ;
								x3 = x2 + ( info->TextX == 0 ? -NAMEZUREX2 : NAMEZUREX2 ) ;
								y3 = y2 + ( info->TextY == 0 ? -NAMEZUREY2 : NAMEZUREY2 ) ;
								Map.Font->SetExRate2( TEXTSIZE, 1.0F ) ;
								Map.Font->SetColor2( CMK( NAMESHDR, NAMESHDG, NAMESHDB, NAMESHDA * alpha / 255 ) ) ;
								Map.Font->DrawSStr( x2, y2, info->MapName ) ;
								Map.Font->SetColor2( CMK( NAMESHDR, NAMESHDG, NAMESHDB, NAMESHDA2 * alpha / 255 ) ) ;
								Map.Font->DrawSStr( x3, y3, info->MapName ) ;
								Map.Font->SetColor2( 0xffffff00 + alpha ) ;
								Map.Font->DrawSStr( x, y, info->MapName ) ;
								Map.Font->SetColor2( 0xffffffff ) ;
	//							Map.Font->DrawSStr( ( info->TextX + selinfo->Rect.left + 1 ) * CHIPSIZE,
	//												( info->TextY + selinfo->Rect.top - 3 ) * CHIPSIZE, info->MapName ) ;
								Map.Font->SetExRate( 1.0F ) ;
								EffectTevSetup( EF_TEV_NOTEX ) ;
								EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
							}
						}
						else
						{
/*							if( Map.WarpSoundID != -1 )
							{
								gpSound->mStopSENo( Map.WarpSoundID ) ;
								Map.WarpSoundID = -1 ;
							}
*/						}

						if( Map.BackInfo != NULL )
						{
							info = Map.BackInfo ;
							selinfo = &CRTIF.Select[Map.BackSelect] ;
							if( TexValidChk( &info->ImageTex ) == true )
							{
								s32 x, y, x2, y2, adx, ady, alpha ;

								if( Map.ImageZureXBFlag[1] == false )
								{
									PlayEffectSE( SFX_MAP_PHOTO_ZOOMOUT ) ;
								}
								Map.ImageZureXBFlag[1] = true ;
								
								adx = (s32)( Map.ImageZureX[1] * Map.PicZureRate[1] ) ;
								ady = (s32)( Map.ImageZureY[1] * Map.PicZureRate[1] ) ;
								alpha = (s32)( 255 * ( 1.0F - Map.PicZureRate[1] ) ) ;
							
								EffectTevSetup( EF_TEV_USETEX ) ;
								x = info->ParentX * CHIPSIZE + ( info->ImageX == 0 ? -IMAGEW - PICZURE: CHIPSIZE + PICZURE ) + adx ;
								y = info->ParentY * CHIPSIZE + ( info->ImageY == 0 ? -IMAGEH - PICZURE: CHIPSIZE + PICZURE ) + ady ;
//								x = selinfo->Rect.left * CHIPSIZE + ( info->ImageX == 0 ? -IMAGEW - PICZURE: CHIPSIZE + PICZURE ) + adx ;
//								y = selinfo->Rect.top * CHIPSIZE + ( info->ImageY == 0 ? -IMAGEH - PICZURE: CHIPSIZE + PICZURE ) + ady ;
								x2 = x + ( info->ImageX == 0 ? -PICSHDZURE : PICSHDZURE ) ;
								y2 = y + ( info->ImageY == 0 ? -PICSHDZURE : PICSHDZURE ) ;
								
								// g̕`
								EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
								DrawLineBox( x, y,
											 x + IMAGEW, y + IMAGEH, CMK( 0, 0, 0, 255 * alpha ) ) ;
								DrawBox( x2, y2,
										 x2 + IMAGEW, y2 + IMAGEH,
										 CMK( PICSHDR, PICSHDG, PICSHDB, PICSHDA * alpha / 255 ) ) ;
										 
								DrawTex3( x, y, x + IMAGEW, y + IMAGEH, &info->ImageTex, 0xffffff00 + alpha ) ;
	//							DrawTex3( ( info->ImageX + selinfo->Rect.left + 1 ) * CHIPSIZE, ( selinfo->Rect.top + info->ImageY + 1 ) * CHIPSIZE,
	//										( info->ImageX + selinfo->Rect.left + 1 ) * CHIPSIZE + 160, ( selinfo->Rect.top + info->ImageY + 1 ) * CHIPSIZE + 120, &info->ImageTex, 0xffffffff ) ;
							}
							else
							{
								Map.ImageZureXBFlag[1] = false ;
							}

							{
								s32 x, y, x2, y2, x3, y3, h ;
								s32 adx, ady, alpha ;
								f32 w ;
								
								adx = (s32)( Map.TextZureX[1] * Map.ZureRate[1] ) ;
								ady = (s32)( Map.TextZureY[1] * Map.ZureRate[1] ) ;
								alpha = (s32)( 255 * ( 1.0F - Map.ZureRate[1] ) ) ;
							
								Map.Font->DrawSetup() ;
								Map.Font->SetJikan( NAMEJIKAN ) ;
								h = CHIPSIZE * 3 ;
								Map.Font->SetExRate2( TEXTSIZE, 1.0F ) ;
								w = (s32)Map.Font->DrawSStr( 0, 0, info->MapName, false, false ) ;
								Map.Font->SetExRate( 1.0F ) ;

								x = (s32)( info->ParentX * CHIPSIZE + ( info->TextX == 0 ? -w - NAMEZURE  : CHIPSIZE + NAMEZURE ) + adx ) ;
								y = info->ParentY * CHIPSIZE + ( info->TextY == 0 ? -h - NAMEZURE : CHIPSIZE + NAMEZURE + NAMEBOTTOMY ) + ady ;
//								x = selinfo->Rect.left * CHIPSIZE + ( info->TextX == 0 ? -w - NAMEZURE  : CHIPSIZE + NAMEZURE ) + adx ;
//								y = selinfo->Rect.top * CHIPSIZE + ( info->TextY == 0 ? -h - NAMEZURE : CHIPSIZE + NAMEZURE ) + ady ;
								x2 = x + ( info->TextX == 0 ? -NAMEZUREX : NAMEZUREX ) ;
								y2 = y + ( info->TextY == 0 ? -NAMEZUREY : NAMEZUREY ) ;
								x3 = x2 + ( info->TextX == 0 ? -NAMEZUREX2 : NAMEZUREX2 ) ;
								y3 = y2 + ( info->TextY == 0 ? -NAMEZUREY2 : NAMEZUREY2 ) ;
								Map.Font->SetExRate2( TEXTSIZE, 1.0F ) ;
								Map.Font->SetColor2( CMK( NAMESHDR, NAMESHDG, NAMESHDB, NAMESHDA * alpha / 255 ) ) ;
								Map.Font->DrawSStr( x2, y2, info->MapName ) ;
								Map.Font->SetColor2( CMK( NAMESHDR, NAMESHDG, NAMESHDB, NAMESHDA2 * alpha / 255 ) ) ;
								Map.Font->DrawSStr( x3, y3, info->MapName ) ;
								Map.Font->SetColor2( 0xffffff00 + alpha ) ;
								Map.Font->DrawSStr( x, y, info->MapName ) ;
								Map.Font->SetColor2( 0xffffffff ) ;
								Map.Font->SetExRate( 1.0F ) ;
	//							Map.Font->DrawSStr( ( info->TextX + selinfo->Rect.left + 1 ) * CHIPSIZE,
	//												( info->TextY + selinfo->Rect.top - 3 ) * CHIPSIZE, info->MapName ) ;
								EffectTevSetup( EF_TEV_NOTEX ) ;
								EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
							}
						}


						siz = CHIPSIZE - CHIPSUKIMA * 2 ;
						suk = CHIPSUKIMA ;
		
						DrawBox( Rect->left * CHIPSIZE + suk, Rect->top * CHIPSIZE + suk, 
									Rect->left * CHIPSIZE + siz, Rect->top * CHIPSIZE + siz, CMK( r, g, b, SELCHIPA ) ) ; 
				    }
				    else
				    {
						u32 r2, g2, b2 ;
						
						r2 = (u32)( SELCHIPMUL * SELCHIPR / 10 ) ;		if( r2 > 255 ) r2 = 255 ;
						g2 = (u32)( SELCHIPMUL * SELCHIPG / 10 ) ;		if( g2 > 255 ) g2 = 255 ;
						b2 = (u32)( SELCHIPMUL * SELCHIPB / 10 ) ;		if( b2 > 255 ) b2 = 255 ;
						
						r = (u8)( (1.0F - Map.Bright.x ) * SELCHIPR + Map.Bright.x * r2 ) ;
						g = (u8)( (1.0F - Map.Bright.x ) * SELCHIPG + Map.Bright.x * g2 ) ;
						b = (u8)( (1.0F - Map.Bright.x ) * SELCHIPB + Map.Bright.x * b2 ) ;
				    }

//					siz = CHIPSIZE - CHIPSUKIMA * 2 ;
//					suk = CHIPSUKIMA ;
	
//					DrawBox( Rect->left * CHIPSIZE + suk, Rect->top * CHIPSIZE + suk, 
//								Rect->left * CHIPSIZE + siz, Rect->top * CHIPSIZE + siz, CMK( r, g, b, SELCHIPA ) ) ; 

					// Ԃu[̕`
				    if( i == Map.SelectMap )
				    {
				    	f32 x, y, s ;
				    
				    	EffectBlendModeSetup( EF_BLEND_ADD ) ;
				    	
				    	x = Rect->left * CHIPSIZE + siz * 0.5F ;
				    	y = Rect->top * CHIPSIZE + siz * 0.5F ;

				    	s = Map.RedBlurRate * 128.0F ;
				    	if( s > 0.0F )
					    	DrawTex3( x - s, y - s, x + s, y + s, &Map.RedBlur, CMK( 255, 0, 0, 255 * ( 1.0F - Map.RedBlurRate ) ) ) ;

				    	s = Map.RedBlurRate2 * 128.0F ;
				    	if( s > 0.0F )
				    		DrawTex3( x - s, y - s, x + s, y + s, &Map.RedBlur, CMK( 255, 0, 0, 255 * ( 1.0F - Map.RedBlurRate2 ) ) ) ;
				    }
				}
			}
		}

/*		break ;
		
	case 1 : 	// Y[C̏
		// c̕`
		RenderProcessAfterImage() ;
		break ;
		
	case 2 :	// Y[AEg̏
		// c̕`
		RenderProcessAfterImage() ;
		break ;
	}
*/	
	// ʐ^̊g`
	if( Map.PicExDrawFlag == true && PicTex != NULL )
	{
		f32 x[2], y[2], w, h ;
		f32 b ;
	
		EffectBlendModeSetup( EF_BLEND_ALPHA ) ;
		
		w = IMAGEW * 0.5F ;
		h = IMAGEH * 0.5F ;
		
		x[0] = PicX - w ;	y[0] = PicY - h ;
		x[1] = PicX + w ;	y[1] = PicY + h ;
		
		x[0] = ( -2 - x[0] ) * Map.PicExRate + x[0] ;			y[0] = ( -2 - y[0] ) * Map.PicExRate + y[0] ;
		x[1] = ( ( SCW + 2 ) - x[1] ) * Map.PicExRate + x[1] ;	y[1] = ( ( SCH + 2 ) - y[1] ) * Map.PicExRate + y[1] ;

		b = Map.PicExRate > PIC_OUTZOOMRATE ? 1.0F - ( Map.PicExRate - PIC_OUTZOOMRATE ) / ( 1.0F - PIC_OUTZOOMRATE ) : 1.0F ;
		
		DrawBox( 0, 0, SCW, SCH, CMK( 0, 0, 0, 255 * ( 1.0F - b ) ) ) ;
		DrawTex3( x[0], y[0], x[1], y[1], PicTex, CMK( b * 255, b * 255, b * 255, 255 ) ) ;
	}

	// I
	return 0 ;
}


// }bvZNgIǂ擾( TRUE:I  FALSE:܂s )
extern s8 CheckMapSelectEnd( void )
{
	return (s8)Map.EndFlag ;
}

// }bvZNgőIꂽ(Ă)ꏊhc𓾂(-1:LZꂽ -1ȊO:I}bvhc
extern s32 GetMapSelectPoint( void )
{
	return Map.Result ;
}

// }bvZNg̗L̃tOZbg
extern void SetMapSelectValidFlag( u8 MapID, u8 Flag )
{
	MapTable[MapID].SelectValidFlag = Flag ;
	
	// TRUE ̏ꍇ́AẽtOĂ
	if( Flag == TRUE )
	{
		s32 ID ;
		ID = MapTable[MapID].ParentMap ;
		while( ID != -1 )
		{
			MapTable[ID].SelectValidFlag = TRUE ;
			ID = MapTable[ID].ParentMap ;
		}
	}
}

// }bvZNg̗L̃tO擾
extern u8 GetMapSelectValidFlag( u8 MapID )
{
	return MapTable[MapID].SelectValidFlag ;
}	


