///////////////////////////////////////////////////////////////////////////////
//
// Killer7 Yamada  YK7Model
//
// YK7Model.cpp
//
// Creator       : Takumi Yamada (GHM)
// Creation Date : 03/09/2004
//
//////////////////////////////////////////////////////////////////////////////

// include --------------------------------------
#include "./YK7Model.h"
#include "./YK7Effect.h"

// define ---------------------------------------

// data type ------------------------------------

// function proto type --------------------------

extern void ModelReleaseTask( ghmGcTask *pTask ) ;		// ff[^̊Js
extern void ModelLoadTask( ghmGcTask *pTask ) ;			// ff[^̓ǂݍݏs

static bool ModelPreFrameProcessCallBack( WK7JObj *pJObj,void *pData ) ;	// f̃t[vZX
static bool ModelPostRenderProcessCallBack( WK7JObj *pJObj,void *pData ) ;	// f̃_OvZX

// function code --------------------------------

// f̃t[vZX
static bool ModelPreFrameProcessCallBack( WK7JObj *pJObj,void *pData )
{
	YMODEL *model = (YMODEL *)pData ;
	
	pJObj = pJObj ;
	
	if( model->d != NULL ) model->d->FrameProcess() ;
	
	return true ;
}

// f̃_OvZX
static bool ModelPostRenderProcessCallBack( WK7JObj *pJObj,void *pData )
{
	YMODEL *model = (YMODEL *)pData ;

	pJObj = pJObj ;
	
	if( model->d != NULL ) model->d->RenderProcess() ;
	
	return true ;
}


// ff[^̓ǂݍݏs
extern void ModelLoadTask( ghmGcTask *pTask )
{
	YMODEL *model = ( YMODEL * )GHMGCTASK_GETPARAM(0) ;
	
	pTask = pTask ;
	
	if( model->file.GetState() == YK7File::ST_NOOPEN )
	{
		while( model->file.Open( model->path ) == false ) retsys() ;
	}
	
	while( ( model->buf = ghmGcMemAllocName( (s32)model->file.GetLength(), "YL_Model" ) ) == NULL ) retsys() ;

	model->file.Read( model->buf, 0, (s32)model->file.GetLength() ) ;
	while( model->file.GetState() != YK7File::ST_IDLE )
	{
		model->file.FrameProcess() ;
		retsys() ;
	}
	model->file.Close() ;

	while( ( model->a = WK7Archive::Create() ) == NULL ) retsys() ;
	model->a->SetStatic( true ) ;

	model->a->LoadArchive( model->buf ) ;
	model->d = model->a->CreateModel() ;
	model->m = model->a->CreateModelMotion() ;

	{
		s32 num, i ;
		num = model->a->GetLightSetNum() ;
		if( num > MODEL_LIGHT_MAXNUM ) num = MODEL_LIGHT_MAXNUM ;
		for( i = 0 ; i < num ; i ++ )
		{
			model->l[i] = WK7Light::Create( model->a->GetLightSet(i) ) ;
		}
		model->l[i] = NULL ;
	}
	
	model->loadflag = true ;
	
	model->LoadTask = NULL ;
}

// ff[^̊Js
extern void ModelReleaseTask( ghmGcTask *pTask )
{
	YMODEL *model = ( YMODEL * )GHMGCTASK_GETPARAM(0) ;
	
	pTask = pTask ;

	if( model->LoadTask != NULL ) delete model->LoadTask ;
	model->LoadTask = NULL ;
	
	if( model->file.GetState() != YK7File::ST_NOOPEN )
	{
		if( model->file.GetState() == YK7File::ST_READ )
		{
			model->file.Cancel() ;
			while( model->file.GetState() == YK7File::ST_READ ) retsys() ;
		}
		
		model->file.Close() ;
		while( model->file.GetState() != YK7File::ST_NOOPEN )
		{
			model->file.FrameProcess() ;
			retsys() ;
		}
	}

	DetachModelMotion( model ) ;
	if( model->d != NULL ) delete model->d ;
	model->d = NULL ;
	
/*
	while( CHKARCLOAD( model->a ) == FALSE )
	{
		model->a->FrameProcess() ;
		retsys() ;
	}
*/
	if( model->m != NULL ) delete model->m ;
	model->m = NULL ;

	{
		s32 i ;
		
		for( i = 0 ; model->l[i] != NULL ; i ++ )
		{
			delete model->l[i] ;
			model->l[i] = NULL ;
		}
	}
	
	if( model->a != NULL ) delete model->a ;
	model->a = NULL ;

	model->ReleaseTask = NULL ;
	
	model->loadflag = false ;

	return ;
}

// ɓǂݍ܂ĂA[JCu烂f쐬
extern bool CreateModel( WK7Archive *arc, YMODEL *model ) 
{
	model->a = NULL ;
	model->d = arc->CreateModel() ;
	model->m = arc->CreateModelMotion() ;
	model->buf = NULL ;
	model->ReleaseTask = NULL ;
	model->LoadTask = NULL ;
	memset( model->l, 0, sizeof( model->l ) ) ;
	model->file.Init( -1 ) ;
	model->path[0] = '\0' ;
	
	{
		s32 num, i ;
		num = arc->GetLightSetNum() ;
		if( num > MODEL_LIGHT_MAXNUM ) num = MODEL_LIGHT_MAXNUM ;
		for( i = 0 ; i < num ; i ++ )
		{
			model->l[i] = WK7Light::Create( arc->GetLightSet(i) ) ;
		}
		model->l[i] = NULL ;
	}
	
	model->loadflag = true ;
	
	return true ;
}

// ɓǂݍ܂ĂA[JCuC[W烂f쐬
extern bool CreateModelMem( void *Buf, YMODEL *model )
{
	model->loadflag = false ;
	
	model->ReleaseTask = NULL ;
	model->LoadTask = NULL ;
	model->buf = NULL ;
	model->file.Init( -1 ) ;
	model->path[0] = '\0' ;

	model->d = NULL ;
	model->m = NULL ;
	model->a = NULL ;
	memset( model->l, 0, sizeof( model->l ) ) ;


	if( ( model->a = WK7Archive::Create() ) == NULL ) goto ERR ;
	if( model->a->LoadArchive( Buf ) == false ) goto ERR ;
	model->a->SetStatic( true ) ;
	
	model->d = model->a->CreateModel() ;
	model->m = model->a->CreateModelMotion() ;
	model->buf = NULL ;
	model->ReleaseTask = NULL ;
	model->LoadTask = NULL ;
	memset( model->l, 0, sizeof( model->l ) ) ;
	model->file.Init( -1 ) ;
	model->path[0] = '\0' ;
	
	{
		s32 num, i ;
		num = model->a->GetLightSetNum() ;
		if( num > MODEL_LIGHT_MAXNUM ) num = MODEL_LIGHT_MAXNUM ;
		for( i = 0 ; i < num ; i ++ )
		{
			model->l[i] = WK7Light::Create( model->a->GetLightSet(i) ) ;
		}
		model->l[i] = NULL ;
	}
	
	model->loadflag = true ;
	
	return true ;

ERR :
	if( model->d != NULL ) delete model->d ;
	model->d = NULL ;
	if( model->m != NULL ) delete model->m ;
	model->m = NULL ;
	if( model->a != NULL ) delete model->a ;
	model->a = NULL ;
	
	return false ;
}


// ff[^̓ǂݍ
extern bool LoadModel( char *filename, YMODEL *model )
{
	s32 id ;
	
	model->loadflag = false ;
	
	model->ReleaseTask = NULL ;
	model->LoadTask = NULL ;
	model->buf = NULL ;
	model->file.Init( -1 ) ;
	strcpy( model->path, filename ) ;

	model->d = NULL ;
	model->m = NULL ;
	model->a = NULL ;
	memset( model->l, 0, sizeof( model->l ) ) ;

	if( ( id = EffSys.TaskCon->Start( ModelLoadTask, (u32)model, 0, NULL, 16 * 1024, (s32)500 ) ) == -1 ) return false ;
	model->LoadTask = EffSys.TaskCon->GetTask( id ) ;
	
	return true ;



	model->a = WK7Archive::Create() ;
	if( model->a == NULL ) return false ;

/*	if( model->a->LoadArchive( filename ) == false )
	{
		delete model->a ;
		model->a = NULL ;

		return false ;
	}
*/
	model->a->SetStatic( true ) ;
	
	if( model->file.Open( filename ) == false ) goto ERR ;

	if( ( model->buf = ghmGcMemAlloc( (s32)model->file.GetLength() ) ) == NULL ) return true ;
	model->file.Read( model->buf, 0, (s32)model->file.GetLength() ) ;

	return true ;
	
ERR :
	if( model->file.GetState() != YK7File::ST_NOOPEN ) model->file.Close() ;
	if( model->a != NULL ) delete model->a ;
	model->a = NULL ;
	if( model->buf != NULL ) ghmGcMemFree( model->buf ) ;
	model->buf = NULL ;
	
	return false ;
}

// ff[^ǂݍݏI`FbN( true:I false:܂ )
extern bool CheckModel( YMODEL *model )
{
	if( model->loadflag == true ) return true ;
//	if( model->d != NULL ) return true ;

	return false ;

//	model->a->FrameProcess() ;
//	if( CHKARCLOAD( model->a ) == FALSE ) return false ;

	if( model->buf == NULL )
	{
		if( ( model->buf = ghmGcMemAlloc( (s32)model->file.GetLength() ) ) == NULL ) return false ;
		model->file.Read( model->buf, 0, (s32)model->file.GetLength() ) ;
	}

	model->file.FrameProcess() ;
	if( model->file.GetState() != YK7File::ST_IDLE ) return false ;
	model->file.Close() ;

	model->a->LoadArchive( model->buf ) ;

	model->d = model->a->CreateModel() ;
//	if( model->d == NULL ) return false ;
	
	model->m = model->a->CreateModelMotion() ;
	
	s32 num, i ;
	
	num = model->a->GetLightSetNum() ;
	if( num > MODEL_LIGHT_MAXNUM ) num = MODEL_LIGHT_MAXNUM ;
	for( i = 0 ; i < num ; i ++ )
	{
		model->l[i] = WK7Light::Create( model->a->GetLightSet(i) ) ;
	}
	model->l[i] = NULL ;
	
	model->loadflag = true ;
	
	return true ;
}

// ff[^̉
extern bool ReleaseModel( YMODEL *model )
{
	if( ( model->loadflag == false && model->LoadTask == NULL ) ||
		model->ReleaseTask != NULL ) return true ;
//	if( model->a == NULL ) return true ;

//	if( CHKARCLOAD( model->a ) == FALSE )
//	if( model->file.GetState() != YK7File::ST_NOOPEN )
	if( model->LoadTask != NULL )
	{
		s32 id ;
	
//		model->file.Close() ;
		if( ( id = EffSys.TaskCon->Start( ModelReleaseTask, (u32)model, NULL, NULL, 16 * 1024, (s32)500 ) ) >= 0 ) return true ;
		model->ReleaseTask = EffSys.TaskCon->GetTask( id ) ;
	}
	else
	{
		DetachModelMotion( model ) ;
		if( model->d != NULL )
		{
			delete model->d ;
			model->d = NULL ;
		}
		if( model->m != NULL )
		{
			delete model->m ;
			model->m = NULL ;
		}
		s32 i ;
		
		for( i = 0 ; model->l[i] != NULL ; i ++ )
		{
			delete model->l[i] ;
			model->l[i] = NULL ;
		}

		if( model->a != NULL )
		{
			if( model->buf != NULL )
			{
				model->a->FreeArchive() ;
				while( model->a->GetState() != WK7Archive::WK7ARCHIVE_VACANT )
				{
					model->a->FrameProcess() ;
				}
			}
			delete model->a ;
			model->a = NULL ;
		}
		
		if( model->buf != NULL )
		{
			ghmGcMemFree( model->buf ) ;
			model->buf = NULL ;
		}
		
		model->loadflag = false ;
	}

	return true ;
}

// ff[^̉`FbN
extern bool CheckModelRelease( YMODEL *model )
{
//	if( model->buf == NULL ) return true ;
	if( model->loadflag == false ) return true ;
	
	return false ;

	model->file.FrameProcess() ;
	if( model->file.GetState() != YK7File::ST_NOOPEN ) return false ;

	ghmGcMemFree( model->buf ) ;
	model->buf = NULL ;

	return true ;
}

// fA^b`
extern bool AttachModel( YMODEL *dest, char *AttachName, YMODEL *src ) 
{
	if( src->loadflag == false || dest->loadflag == false ) return false ;
	
	if( src->d == NULL || dest->d == NULL ) return false ;
	if( dest->d->GetObj( AttachName ) == NULL ) return false ;
	
	src->d->Attach( dest->d->GetObj( AttachName ) ) ;
	dest->d->GetObj( AttachName )->SetPreFrameProcessCallBack( ModelPreFrameProcessCallBack, src ) ;
	dest->d->GetObj( AttachName )->SetPostRenderProcessCallBack( ModelPostRenderProcessCallBack, src ) ;

	return true ;
}

// fŃ^b`
extern bool DetachModel( YMODEL *dest, char *DetachName, YMODEL *src )
{
	if( src->loadflag == false || dest->loadflag == false ) return false ;
	
	if( src->d == NULL || dest->d == NULL ) return false ;
	if( dest->d->GetObj( DetachName ) == NULL ) return false ;
	
	src->d->Detach() ;
	dest->d->GetObj( DetachName )->SetPreFrameProcessCallBack( NULL, NULL ) ;
	dest->d->GetObj( DetachName )->SetPostRenderProcessCallBack( NULL, NULL ) ;

	return true ;
}


// w̃[VfɃA^b`
extern bool AttachModelMotion( YMODEL *model, YMODEL *motion )
{
	return AttachModelMotion( model, NULL, motion ) ;
}

// w̃[VfɃA^b`
extern bool AttachModelMotion( YMODEL *model, YMOTION *motion, YMODEL *motion2 )
{
	HSD_AnimJoint *Anim ;

	if( model->d == NULL ) return false ;
	if( motion2 == NULL && motion != NULL && CheckMotion( motion ) == FALSE ) return false ;
	if( CheckModel( model ) == FALSE ) return false ;

	DetachModelMotion( model ) ;

	if( motion == NULL )
	{
		if( motion2 == NULL || motion2->m == NULL )
		{
			if( model->m != NULL )
			{
				model->m->GetAnimJoint( model->d->GetObj(0)->GetName(), &Anim ) ;	// Aj[VWCg̎擾
			}
			else
			{
				return false ;
			}
		}
		else
		{
			motion2->m->GetAnimJoint( model->d->GetObj(0)->GetName(), &Anim ) ;	// Aj[VWCg̎擾
		}
	}
	else
	{
		motion->d->GetAnimJoint( model->d->GetObj(0)->GetName(), &Anim ) ;	// Aj[VWCg̎擾
	}

	model->d->AttachMotion( Anim ) ;		// Aj[ṼA^b`
	model->d->SetMotionRate( 1.0F ) ;		// [V̍ĐxZbg
	
	return true ;
}

// w̃[VfɃA^b`
extern bool AttachModelMotionAll( YMODEL *model, YMODEL *motion )
{
	return AttachModelMotionAll( model, NULL, motion ) ;
}

// w̃[VfɃA^b`
extern bool AttachModelMotionAll( YMODEL *model, YMOTION *motion, YMODEL *motion2 )
{
	WK7ModelMotion *m ;

	if( model->d == NULL ) return false ;
	if( motion2 == NULL && motion != NULL && CheckMotion( motion ) == FALSE ) return false ;
	if( CheckModel( model ) == FALSE ) return false ;
	
//	DetachModelMotionAll( model ) ;

	if( motion == NULL )
	{
		if( motion2 == NULL || motion2->m == NULL )
		{
			if( model->m != NULL )
			{
				m = model->m ;
			}
			else
			{
				return false ;
			}
		}
		else
		{
			m = motion2->m ;
		}
	}
	else
	{
		m = motion->d ;
	}

	model->d->AttachMotionAll( m ) ;		// Aj[ṼA^b`
	model->d->SetMotionRate( 1.0F ) ;		// [V̍ĐxZbg
	
	return true ;
}


// [Ṽf^b`
extern bool DetachModelMotion( YMODEL *model )
{
	if( model->d != NULL && model->d->GetObj(0) != NULL ) model->d->GetObj(0)->DetachMotion() ;
	return true ;
}

// [VĐ
extern bool PlayModelMotion( YMODEL *model, f32 PlayTime, bool LoopFlag )
{
	model->d->PlayMotion( PlayTime, true, 6.0F ) ;
	model->d->SetMotionLoop( LoopFlag ) ;
//	model->d->FrameProcess() ;
	
	return true ;
}

// [VĐ
extern bool PlayModelMotionAll( YMODEL *model, f32 PlayTime, bool LoopFlag )
{
	model->d->PlayMotionAll( PlayTime ) ;
	model->d->SetMotionLoop( LoopFlag ) ;
//	model->d->FrameProcess() ;
	
	return true ;
}


// [VĐǂ𓾂( TRUE:Đ  FALSE:~ )
extern bool CheckModelMotion( YMODEL *model )
{
	return model->d->GetMotionState() != AOBJ_NO_ANIM ;
}

// ff[^ɃCg݂ꍇ́ÃCgLɂ
extern bool DispModelLight( YMODEL *model, s32 LightNumber )
{
	if( LightNumber == -1 )
	{
		s32 i ;
		
		for( i = 0 ; i < MODEL_LIGHT_MAXNUM && model->l[i] != NULL ; i ++ ) 
		{
			model->l[i]->Disp() ;
		}
	}
	else
	{
		if( model->l[LightNumber] != NULL )
			model->l[LightNumber]->Disp() ;
	}

	return true ;
}



// ɓǂݍ܂ĂA[JCu烂[V쐬
extern bool CreateMotion( WK7Archive *arc, YMOTION *motion )
{
	motion->a = NULL ;
	motion->d = arc->CreateModelMotion() ;
	
	return true ;
}


// [Vf[^̓ǂݍ
extern bool LoadMotion( char *filename, YMOTION *motion )
{
	motion->d = NULL ;
	motion->buf = NULL ;
	motion->a = NULL ;
	motion->file.Init( -1 ) ;

	motion->a = WK7Archive::Create() ;
	if( motion->a == NULL ) return false ;
	
	if( motion->file.Open( filename ) == false ) goto ERR ;
	if( ( motion->buf = ghmGcMemAlloc( (s32)motion->file.GetLength() ) ) == NULL ) goto ERR ;
	motion->file.Read( motion->buf, 0, (s32)motion->file.GetLength() ) ;
	
/*	if( motion->a->LoadArchive( filename ) == false )
	{
		delete motion->a ;
		motion->a = NULL ;

		return false ;
	}
*/	motion->a->SetStatic( true ) ;

	return true ;

ERR :
	if( motion->file.GetState() != YK7File::ST_NOOPEN ) motion->file.Close() ;
	if( motion->a != NULL ) delete motion->a ;
	motion->a = NULL ;
	if( motion->buf != NULL ) ghmGcMemFree( motion->buf ) ;
	motion->buf = NULL ;

	return true ;
}

// [Vf[^ǂݍݏI`FbN( true:I false:܂ )
extern bool CheckMotion( YMOTION *motion )
{
	if( motion->d != NULL ) return true ;
	motion->a->FrameProcess() ;
//	if( CHKARCLOAD( motion->a ) == FALSE ) return false ;

	motion->file.FrameProcess() ;
	if( motion->file.GetState() != YK7File::ST_IDLE ) return false ;
	motion->file.Close() ;
	
	motion->a->LoadArchive( motion->buf ) ;
	
	motion->d = motion->a->CreateModelMotion() ;
	if( motion->d == NULL ) return false ;
	
	return true ;
}

// [Vf[^̉
extern bool ReleaseMotion( YMOTION *motion )
{
	if( motion->a == NULL ) return true ;

/*	
	while( CHKARCLOAD( motion->a ) == FALSE )
	{
		motion->a->FrameProcess() ;
	}
*/
	
	if( motion->d != NULL )
	{
		delete motion->d ;
		motion->d = NULL ;
	}

	if( motion->a != NULL )
	{
		motion->a->FreeArchive() ;
		while( motion->a->GetState() != WK7Archive::WK7ARCHIVE_VACANT )
		{
			motion->a->FrameProcess() ;
		}
	
		delete motion->a ;
		motion->a = NULL ;
	}

	if( motion->file.GetState() == YK7File::ST_NOOPEN )
	{
		if( motion->buf != NULL )
		{
			ghmGcMemFree( motion->buf ) ;
			motion->buf = NULL ;
		}
	}
	else
	{
		motion->file.Close() ;
	}

	return true ;
}

// [Vf[^̉`FbN
extern bool CheckMotionRelease( YMOTION *motion )
{
	if( motion->buf == NULL ) return true ;
	
	motion->file.FrameProcess() ;
	if( motion->file.GetState() != YK7File::ST_NOOPEN ) return false ;

	ghmGcMemFree( motion->buf ) ;
	motion->buf = NULL ;

	return true ;
}




