// =============================================================================
//
//	tHgC[WNX
//
//	YK7String.cpp
//
//	Creator			: Takumi Yamada(GHM)
//	Creation Date	: 02/24/04
//
// =============================================================================

// include ---------------------------------------
#include "./YK7String.h"
#include "./YK7Effect.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <STDARG.h>

// define ----------------------------------------

// function proto type ---------------------------

// data type -------------------------------------

// data ------------------------------------------

// function code ---------------------------------

// class code ------------------------------------

// QoCgׂ( true:QoCg  false:PoCg )
bool YK7StrImage::MultiByteCharCheck( const char *Buf )
{
	return ( (unsigned char)*Buf >= 0x81 && (unsigned char)*Buf <= 0x9F ) || ( (unsigned char)*Buf >= 0xE0 && (unsigned char)*Buf <= 0xFC ) ;
}


// RXgN^
YK7StrImage::YK7StrImage()
{
	initflag = false ;
	ReverseFlag = false ;
	color = (GXColor){ 255, 255, 255, 255 } ;
	KanaFont = NULL ;
	jikan = 0 ;
	kanaY = 0 ;
}

// fXgN^
YK7StrImage::~YK7StrImage()
{
	Release() ;
}

// w̃R[hɑΉOtBbNꍇ͂̏̕Ԃ( Ȃ -1 Ԃ )
int YK7StrImage::GetCodeGraph( int Code, SICHR **chrbuf )
{
	int i ;
	SICHR *cr ;

	if( initflag == false ) return -1 ;

	// w̕R[h݂邩ׂ
	cr = chr ;
	for( i = 0 ; i < head->ChrNum && cr->Code != Code ; i ++, cr ++ ){}
	if( i == head->ChrNum ) return -1 ;

	// 炻̃AhXƃf[^CfbNXԂ
	if( chrbuf != NULL ) *chrbuf = cr ;
	return i ;
}


// t@C̓ǂݍ
bool YK7StrImage::Load( char *FilePath )
{
	unsigned int size ;

	if( initflag == true ) return false ;

	head = NULL ;
	
	// t@CJ
	ghmGcMemSetAllocName("YStrImg");
	File = new ghmGcFile ;
	if( File == NULL ) goto ERR ;
	if( File->Open( FilePath ) == false ) goto ERR ;
	size = File->GetLength() ;
	
	// Kvȃmۂ
	head = ( STRIMAGEFILEHEAD * )ghmGcMemAllocName( (int)size, "YK7_FontImage" ) ;
	if( head == NULL ) goto ERR ;
	
	// ǂݍ݊Jn
	File->Read( head, 0, (long)size ) ;

	MemImageFlag = false ;
	
	// I
	return true ;
	
ERR :
	if( File )
	{
		delete File ;
		File = NULL ;
	}
		
	if( head != NULL )
	{
		ghmGcMemFree( head ) ;
		head = NULL ;
	}

	// I
	return false ;
}


// [hI`FbN( true:I   false:܂ )
bool YK7StrImage::LoadCheck( void )
{
	int headsize ;

	if( initflag == true ) return true ;
	
	if( head == NULL && File == NULL ) return false ;

	// ǂݍݏI`FbN
	File->FrameProcess() ;
	if( File->GetState() != ghmGcFile::READFINISH ) return false ;
	
	// t@C
	delete File ;
	File = NULL ;

	// ǂݍ݂ĂZbgAbv
	strpack = ( SISTRPACK * )( (u8 *)head + sizeof( STRIMAGEFILEHEAD ) ) ;
	str = ( SISTR * )( (u8 *)strpack + sizeof( SISTRPACK ) * head->StrPackNum ) ;
	chr = ( SICHR * )( (u8 *)str + sizeof( SISTR ) * head->StrNum ) ;
	headsize = ( (u8 *)chr + sizeof( SICHR ) * head->ChrNum ) - (u8 *)head ;
	headsize += headsize % 32 != 0 ? 32 - headsize % 32 : 0 ;
	THeader = ( GhmGcTexHeader * )( (u8 *)head + headsize ) ;
	exY = exX = 1.0F ;
	
	// eNX`̃ZbgAbv
	GXInitTexObj( &TObj, GHMGCTEX_GETIMAGE(THeader),
					 THeader->mWidth, THeader->mHeight, THeader->mFormat,
					 GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
	GXInitTexObjLOD( &TObj, GX_LINEAR, GX_LINEAR,
						THeader->mMinLOD, THeader->mMaxLOD, 0.0F,
						GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
						
	// ZbgAbv
	initflag = true ;

	MemImageFlag = false ;
	
	// I
	return true ;
}

// ɓWJꂽt@CC[WZbgAbv(n͉̈Ă͂ȂB̓NXs)
bool YK7StrImage::LoadMem( void *MemImage )
{
	int headsize ;

	if( initflag == true ) return true ;
	
	head = ( STRIMAGEFILEHEAD * )MemImage ;

	// ǂݍ݂ĂZbgAbv
	strpack = ( SISTRPACK * )( (u8 *)head + sizeof( STRIMAGEFILEHEAD ) ) ;
	str = ( SISTR * )( (u8 *)strpack + sizeof( SISTRPACK ) * head->StrPackNum ) ;
	chr = ( SICHR * )( (u8 *)str + sizeof( SISTR ) * head->StrNum ) ;
	headsize = ( (u8 *)chr + sizeof( SICHR ) * head->ChrNum ) - (u8 *)head ;
	headsize += headsize % 32 != 0 ? 32 - headsize % 32 : 0 ;
	THeader = ( GhmGcTexHeader * )( (u8 *)head + headsize ) ;
	exY = exX = 1.0F ;
	
	// eNX`̃ZbgAbv
	GXInitTexObj( &TObj, GHMGCTEX_GETIMAGE(THeader),
					 THeader->mWidth, THeader->mHeight, THeader->mFormat,
					 GX_CLAMP, GX_CLAMP, GX_FALSE ) ;
	GXInitTexObjLOD( &TObj, GX_LINEAR, GX_LINEAR,
						THeader->mMinLOD, THeader->mMaxLOD, 0.0F,
						GX_FALSE, GX_FALSE, GX_ANISO_1 ) ;
						
	// ZbgAbv
	initflag = true ;
	
	MemImageFlag = true ;
	
	// I
	return true ;
}

// f[^̉
bool YK7StrImage::Release( void )
{
	if( initflag == false ) return false ;
	
	if( MemImageFlag == false )
	{
		// ̈̉
		ghmGcMemFree( head ) ;
	}
	
	head = NULL ;

	initflag = false ;

	// I
	return true ;
}

// t`悷
float YK7StrImage::DrawFSStr( float x, float y, bool center, bool drawflag, char *string, ... )
{
	va_list VaList ;
	char String[ 256 ] ;

	// Oo͗p̃XgZbg
	va_start( VaList, string ) ;

	// ҏW̕擾
	vsprintf( String, string, VaList ) ;

	// ϒXg̃|C^Zbg
	va_end( VaList ) ;

	// `悷
	return DrawSStr( x, y, String, center, drawflag ) ;
}
	


// `悷镶̐擾
int YK7StrImage::GetDrawNum( char *string )
{
	s32 drawnum ;
	int Code ;
	bool multi ;
	
	drawnum = 0 ;
	while( *string != '\0' )
	{
		if( *string == '\n' )
		{
			string ++ ;
		}
		else
		{
			multi = MultiByteCharCheck( string ) ;
			Code = multi == true ? *((u16 *)string) : *string ; 
			if( GetCodeGraph( Code, NULL ) == -1 )
			{
				if( KanaFont != NULL )
				{
					if( KanaFont->GetCodeGraph( Code, NULL ) != -1 )
					{
						drawnum ++ ;
					}
				}
			}
			else
			{
				drawnum ++ ;
			}

			string += multi == true ? 2 : 1 ;
		}
	}

	// I
	return drawnum ;
}


// PoCg̕`悷(ɂQoCg܂܂Ă邩ǂ͍lȂ)
float YK7StrImage::DrawSStr( float x, float y, char *string, bool center, bool drawflag, bool setup )
{
	SICHR *cr ;
	int graph ;
	bool flag, multi ;
	int Code ;
	float ix = x, w, dw ;
	
	flag = false ;

	if( initflag == false ) return -1 ;
	if( center == true && drawflag == true )
	{
		return DrawSStr( x - DrawSStr( 0, 0, string, false, false ) / 2.0F, y,
							string, false, true ) ;
	}

	dw = 0 ;
	while( *string != '\0' )
	{
		if( *string == '\n' )
		{
			x = ix ;
			y += head->Height ;
			string ++ ;
		}
		else
		{
			multi = MultiByteCharCheck( string ) ;
			Code = multi == true ? *((u16 *)string) : *string ; 
			graph = GetCodeGraph( Code, &cr ) ;
			if( graph != -1 )
			{
				if( drawflag == true )
				{
					if( flag == true && setup == true ) DrawSetup() ;
					flag = false ;
					DrawChar( x, y, graph, setup ) ;
				}
				w = (f32)( cr->addx - head->Tume ) * exX + jikan ;
//				w = (f32)( cr->dx + cr->w) * exX + jikan ;
				x += w ;
				dw += w ;
			}
			else
			if( KanaFont != NULL )
			{
				graph = KanaFont->GetCodeGraph( Code, &cr ) ;
				if( graph != -1 )
				{
					if( drawflag == true )
					{
						if( flag == false && setup == true ) KanaFont->DrawSetup() ;
						flag = true ;
						KanaFont->SetExRate2( exX, exY ) ;
						KanaFont->DrawChar( x, y + kanaY, graph, setup ) ;
					}
					w = (f32)( cr->addx - head->Tume ) * exX + jikan ;
//					w = (f32)( cr->dx + cr->w) * exX + jikan ;
					x += w ;
					dw += w ;
				}
			}

			string += multi == true ? 2 : 1 ;
		}
	}
	
	if( drawflag == true && flag == true && setup == true ) DrawSetup() ;

	// I
	return dw - ( -head->Tume ) ;
}

// w̃CfbNX̕pbN̍s擾
int YK7StrImage::GetStrPackLineNum( int index )
{
	SISTRPACK *pack = &strpack[index] ;
	int num ;
	
	// 𐔂
	for( num = 0 ; pack->StrIndex[num] != -1 ; num ++ ){}

	// I
	return num ;
}


// w̃CfbNX̕`悷
float YK7StrImage::DrawStr( float x, float y, int index, bool center, bool drawflag )
{
	SISTR *st = &str[index] ;
	SICHR *cr ;
	int i ;
	float dw ;
	float w ;

	if( initflag == false ) return false ;
	
	if( center == true && drawflag == true )
	{
		return DrawStr( x - DrawStr( 0, 0, index, false, false ) / 2.0F, y, index, false, true ) ;
	}

	// `Jn
	dw = 0 ;
	for( i = 0 ; st->ChrIndex[i] != -1 ; i ++ )
	{
		cr = &chr[st->ChrIndex[i]] ;
		if( drawflag == true ) DrawChar( x, y, st->ChrIndex[i] ) ; 

		w = ( cr->addx - head->Tume ) * exX + jikan ;
		dw += w ;
		x += w ;
	}

	// I
	return dw - ( - head->Tume ) ;
}

// w̃CfbNX̕pbN`悷
float YK7StrImage::DrawStrPack( float x, float y, int index, int wait, bool center, bool drawflag )
{
	SISTRPACK *pack = &strpack[index] ;
	float maxw, dw ;
	int i ;
	
	
	// `
	maxw = 0.0F ;
	for( i = 0 ; pack->StrIndex[i] != -1 ; i ++ )
	{
		dw = DrawStr( x, y + i * ( head->Height + wait ) * exY, pack->StrIndex[i], center, drawflag ) ;
		if( dw > maxw ) maxw = dw ;
	}

	// I
	return maxw ;
}


// `悷邽߂̏s
void YK7StrImage::DrawSetup( void )
{
	EffectRenderSetup( EF_PROJECT_ORTHO, EF_BLEND_ALPHA, EF_TEV_USETEX ) ;
	EffectTexColorIgnoreSetup( TRUE ) ;
//	EffectProjectSetup( EF_PROJECT_ORTHO ) ;		// ˉes̃ZbgAbv
//	EffectTevSetup( EF_TEV_USETEX ) ;				// TEṼZbgAbv
//	GXSetBlendMode( GX_BM_BLEND, GX_BL_INVSRCALPHA, GX_BL_SRCALPHA, GX_LO_SET ) ;

	// eNX`[h
	GTLOAD( &TObj ) ;
	
	// I
}

// ꕶ`悷( g GXBegin GXEnd g )
void YK7StrImage::DrawChar( float x, float y, int index, bool setup )
{
	SICHR *c = &chr[index] ;
	f32 x1, y1, x2, y2, u1, v1, u2, v2 ;
	
	if( ReverseFlag )
	{
		x1 = x + exX * (f32)c->dx ;						y1 = y + exY * (f32)c->dy ;
		x2 = x + exX * (f32)( c->dx + c->w ) ;			y2 = y + exY * (f32)( c->dy + c->h ) ;
		u1 = (f32)c->x / THeader->mWidth ;				v1 = (f32)( c->y + c->h ) / THeader->mHeight ;
		u2 = (f32)( c->x + c->w ) / THeader->mWidth ;	v2 = (f32)c->y / THeader->mHeight ;
	}
	else
	{
		x1 = x + exX * (f32)c->dx ; 					y1 = y + exY * (f32)c->dy ;
		x2 = x + exX * (f32)( c->dx + c->w ) ;			y2 = y + exY * (f32)( c->dy + c->h ) ;
		u1 = (f32)c->x / THeader->mWidth ; 				v1 = (f32)c->y / THeader->mHeight ;
		u2 = (f32)( c->x + c->w ) / THeader->mWidth ; 	v2 = (f32)( c->y + c->h ) / THeader->mHeight ;
	}

	if( setup == true )
	{
		GTLOAD( &TObj ) ;
		EffectTexColorIgnoreSetup( TRUE ) ;
		DrawTex4( x1, y1, x2, y2, u1, v1, u2, v2, NULL, *((u32*)&color) ) ;
		EffectTexColorIgnoreSetup( FALSE ) ;
	}
	else
	{
		DrawTex4NB( x1, y1, x2, y2, u1, v1, u2, v2, *((u32*)&color) ) ;
	}
/*
	GBGN( GX_QUADS, 4 ) ;
	GP2( x + c->dx, 					y + exY * c->dy 			) ;	GC( color ) ;	GT( (f32)c->x / THeader->mWidth, 			(f32)c->y / THeader->mHeight ) ;
	GP2( x + ( c->dx + exX * c->w ),	y + exY * c->dy 			) ;	GC( color ) ;	GT( (f32)( c->x + c->w ) / THeader->mWidth, (f32)c->y / THeader->mHeight ) ;
	GP2( x + ( c->dx + exX * c->w ),	y + exY * ( c->dy + c->h )	) ;	GC( color ) ;	GT( (f32)( c->x + c->w ) / THeader->mWidth, (f32)( c->y + c->h ) / THeader->mHeight ) ;
	GP2( x + c->dx, 					y + exY * ( c->dy + c->h )	) ;	GC( color ) ;	GT( (f32)c->x / THeader->mWidth, 			(f32)( c->y + c->h ) / THeader->mHeight ) ;
	GEND() ;
*/

	// I
}

// `ɎgpFZbg
void YK7StrImage::SetColor( GXColor *Color )
{
	color = ( Color != NULL ) ? *Color : (GXColor){ 255, 255, 255, 255 } ;
	if( KanaFont ) KanaFont->SetColor( Color ) ;
}

// `ɎgpFZbg
void YK7StrImage::SetColor2( u32 color )
{
	this->color = *((GXColor *)&color) ;
	if( KanaFont ) KanaFont->SetColor2( color ) ;
}
