#include "common.h"
#include "c_backlight.h"

C_BackLight *C_BackLight::instance = 0;

#define Clamp(val,min,max) \
    ((val) = (((val) < (min)) ? (min) : ((val) > (max)) ? (max) : (val)))
#include "Grade_01_CMPR_image.c"
static HSD_ImageDesc gBackLightImageDesc = {
  (void*)Grade_01_CMPR_image,                        /* eNX`C[W */
  32, 128,                                       /* width height */
  (GXTexFmt)GX_TF_CMPR,	                          /* eNX`tH[}bg*/
  GX_FALSE,                                       /* mipmap tO */
  0.000000f, 0.000000f,	                          /* minLOD, maxLOD */
};
static HSD_TObjDesc gBackLightTObjDesc = {
  NULL,					//class_name
  NULL,					//next
  GX_TEXMAP7,			//id(ŏ㏑̂łǂłǂ)
  GX_TG_NRM,			//TexGeñ\[XB
  { 0.0F, 0.0F, 0.0F },	//rotate
  { 0.0F, 0.0F, 0.0F },	//scale  
  { 0.0F, 0.0F, 0.0F },	//translate  
  GX_CLAMP,				//wrap_s
  GX_REPEAT,			//wrap_t
  1,					//repeat_s
  3,					//repeat_t
  TEX_COORD_BACKLIGHT|TEX_LIGHTMAP_EXT| \
  TEX_COLORMAP_ADD|TEX_ALPHAMAP_NONE,  /* TEX_COORD_BACKLIGHTĂ */
  0.99F,					//blending
  GX_LINEAR,			//magFilt
  &gBackLightImageDesc,	//*imagedesc
  NULL,					//*tlutdesc
  NULL,					//*lod
  NULL,					//*tev
};

C_BackLight::C_BackLight( void )
{
}

C_BackLight &C_BackLight::GetInstance( void )
{
  if( !instance ) instance = new C_BackLight();
  return *instance;
}

void C_BackLight::_Clear( HSD_JObj* _jobj )
{
  HSD_DObj *dobj;
  HSD_MObj *mobj;

  for (dobj = HSD_JObjGetDObj(_jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
	  if( mobj->tobj_backlight ){
		HSD_TObjRemove( mobj->tobj_backlight );
		mobj->tobj_backlight = 0;
		HSD_MObjCompileTev(mobj);
	  }
	}
  }
  if(_jobj->child){
	_Clear(_jobj->child);
  }
  if(_jobj->next){
	_Clear(_jobj->next);
  }
}
//obNCgOB
void C_BackLight::Clear( HSD_JObj *jobj )
{
  _Clear( jobj );
}

//obNCgB
void C_BackLight::_Set( HSD_JObj *_jobj, f32 _intensity, 
						C_Vec &_pos, C_Vec &_dir, f32 _ang, HSD_TObjDesc *_tobj_desc )
{
  HSD_DObj *dobj;
  HSD_MObj *mobj;

  for (dobj = HSD_JObjGetDObj(_jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
	  mobj->tobj_backlight = HSD_TObjLoadDesc(_tobj_desc);
	  //eNX`Aj[Vp̒l𗬗pB
	  mobj->tobj_backlight->translate = _pos;
	  mobj->tobj_backlight->scale = _dir;
	  mobj->tobj_backlight->rotate.x = _ang;
	  mobj->tobj_backlight->rotate.y = _intensity;
	  mobj->tobj_backlight->tlut_no = (u8)manual;
	  HSD_MObjCompileTev(mobj);
	}
  }
  if(_jobj->child){
	_Set(_jobj->child, _intensity, _pos, _dir, _ang, _tobj_desc);
  }
  if(_jobj->next){
	_Set(_jobj->next, _intensity, _pos, _dir, _ang, _tobj_desc);
  }
}
void C_BackLight::Set( HSD_JObj *jobj, f32 intensity, HSD_LObj *lobj, HSD_TObjDesc *tobj_desc )
{
  //CeVeB𐳋KB
  Clamp( intensity, 0.f, 1.f );

  //Ô폜B
  Clear( jobj );

  //w肪΃ftHgeNX`B
  if( !tobj_desc ){
	tobj_desc = &gBackLightTObjDesc;
  }

  //ftHg}jA[hB
  manual = true;

  //lobj猸pƈʒuA𓾂B
  C_Vec pos(0.f),dir(0.f);
  f32 cone_angle=0.f;
  if( lobj ){
	switch( (lobj->flags & LOBJ_TYPE_MASK) ){
	case LOBJ_SPOT:{
	  //_֌xNgƁǍ̓ςƂB
	  //烂fɌxNgƁǍ̓ςƂB
	  //炩t̋肷B
	  HSD_LObjGetPosition( lobj, &pos );
	  HSD_LObjGetInterest( lobj, &dir );
	  dir -= pos; dir.Nrm();
	  cone_angle = cosf( (f32)M_PI * lobj->u.spot.cutoff / 180.f );
	  manual = false;
	}break;
	default:
	  //}jA[hƔfB
	  break;
	}
  }
  _Set( jobj, intensity, pos, dir, cone_angle, tobj_desc );
}
