#ifndef ___C_BALL_H___
#define ___C_BALL_H___
//#include "common.h"
#include "c_jobj.h"
#include "c_vec.h"
#include "c_coll.h"
#include "c_trigon.h"

#define kGravity ((f32)(-0.1f))

class C_Ball{
 public:
  C_Ball( C_JObj &j, C_TrigonArray &t):jobj(j),trigon(t){
	Init();
  }

  void Proc( void );
  void Disp( void){
	jobj.Disp();
  }
  void DispHitTrigon( void ){
	if( tri_ptr ){
	  trigon.DispStart();
	  tri_ptr->Disp();
	  trigon.DispEnd();
	}
  }
  C_Vec &GetTrs( void ){ return trs; }
  C_Vec &GetTrsOld( void ){ return old_trs; }


 private:
  C_JObj &jobj;
  C_TrigonArray &trigon;
  C_Trigon *tri_ptr;
  C_Vec trs,vel,acl,old_trs;
  s32 count;
  void Init( void ){
	trs.x = trs.z = 0.0f;
	trs.y = 60.f;
	old_trs = trs;
	HSD_JObjSetTranslate( jobj.GetJObj(), &trs );

	vel.x = vel.y = vel.z = 0.0f;
	acl = C_Vec( 2.f * (HSD_Rand()%100 / 100.f) - 1.f,
				 0.f,
				 2.f * (HSD_Rand()%100 / 100.f) - 1.f );
	acl *= 0.005f;
	count = 0;
	tri_ptr = 0;
  }
};
#endif





