#include "common.h"
#include "c_border.h"
#include "math.h"

C_Border::C_Border( C_TrigonArray &_t )
  : trigons(_t)
{
  Init( _t );
}
void C_Border::Init( C_TrigonArray &_t )
{
  trigons = _t;
  int flg = 0;
  int trigon_num = (int)trigons.GetNum();
  f32 ofst = 3.f;

  //SOp`ċE𒊏oB
  for( u32 i=0; i<trigon_num; i++ ){
	C_Trigon& tri = trigons.GetTrigon(i);
	s16* idx = tri.GetIdx();

	//SŐB
	for( u32 j=0; j<3; j++ ){
	  s16 i0,i1;
	  i0 = idx[j]; i1 = idx[(j+1)%3];

	  //triȊȎSOp`B
	  flg = 0;
	  for( u32 k=0; k<trigon_num; k++ ){
		if( i != k ){
		  C_Trigon& tri0 = trigons.GetTrigon(k);
		  s16* idx0 = tri0.GetIdx();

		  //ŐLĂB
		  if( (i0 == idx0[0] && i1 == idx0[2]) ||
			  (i0 == idx0[1] && i1 == idx0[0]) ||
			  (i0 == idx0[2] && i1 == idx0[1]) ){
			flg ++;
			break;
		  }
		}
	  }

	  if( !flg ){
		//VKo^
		C_BorderLine l( tri.GetVtx()[j], tri.GetVtx()[(j+1)%3], tri.GetEdgeNrm(j), i0,i1);
		lines.push_back( l );
	  }
	}
  }

  line_num = lines.size();

  //O[v߂B
  //iMo鋫ȄWO[vj
  for( u32 i=0; i<line_num; i++ ){
	lines[i].group = -1;
  }
  s16 group_id = 0;
  for( u32 i=0; i<line_num; i++ ){
	if( lines[i].group < 0 ){
	  lines[i].group = group_id;
	  s16 idx_start = lines[i].idx[0];
	  s16 idx_goal = lines[i].idx[1];
	  while( 1 ){
		s32 flg = 0;
		for( u32 j=0; j<line_num; j++ ){
		  if( i!=j && lines[j].group < 0 ){
			for( u32 k=0; k<2; k++ ){
			  if( lines[j].idx[k] == idx_start ){
				idx_start = lines[j].idx[!k];
				lines[j].group = group_id;
				flg++;
			  }
			}
		  }
		}
		if( idx_start == idx_goal || !flg ) break;
	  }
	  group_id++;
	}
  }

  //m[hZoB
  s16 no = 0;
  for( u32 i=0; i<line_num; i++ ){
	lines[i].flg = 0;
  }
  for( u32 i=0; i<line_num; i++ ){
	for( u32 j=0; j<2; j++ ){
	  //ς݁B
	  if( lines[i].flg & (0x1 << j) ) continue;
	  s16 idx0 = lines[i].idx[j];
	  C_Vec n0 = lines[i].n;
	  C_Vec p = lines[i].p[j];
	  lines[i].flg |= (0x1<<j);
	  for( u32 k=0; k<line_num; k++ ){
		if( i!=k ){
		  for( u32 l=0; l<2; l++ ){
			s16 idx1 = lines[k].idx[l];
			C_Vec n1 = lines[k].n;
			C_Vec v1 = lines[k].p[!l] - lines[k].p[l]; 
			v1.Nrm();
			//_LĂāAPWOxȏJĂB
			if( idx1 == idx0 ){
			  lines[k].flg |= (0x1<<l);
			  if( (n0|v1) < (-0.001f) ){
				C_Vec n = n0+n1;
				n.Nrm();
				p += (n*ofst);
				C_NodePoint node( p, no++, lines[k].group, n );
				nodes.push_back( node );
			  }
			}
		  }
		}
	  }
	}
  }

  nodes_num = nodes.size();

  //m[hԂɒڍs邩ǂ̃N𒣂B
  for( u32 i=0; i<nodes_num; i++ ){
	for( u32 j=0; j<nodes_num; j++ ){
	  if( i != j ){
		u32 flg = 0;
		for( u32 k=0; k<line_num; k++ ){
		  if( lines[k].Cross( nodes[i].p, nodes[j].p ) ){
			flg++;
			break;
		  }else{
		  }
		}
		if( flg==0 ){
		  C_NodeLink l(&nodes[i], &nodes[j]);
		  nodes[i].direct_link.push_back( l );
		}
	  }
	}
  }

  //ŒZpX\mہB
  shortest_path.resize( nodes_num );
  for( u32 i=0; i<nodes_num; i++ ) shortest_path[i].resize( nodes_num );
  //ŒZpXB
  for( u32 i=0; i<nodes_num; i++ ) FindShortestPath( i );

#if 0
  for( u32 i=0; i<nodes_num; i++ ){
	for( u32 j=0; j<nodes_num; j++ ){
	  OSReport( "%3d(%3d) ", shortest_path[i][j].first_node->no, (int)shortest_path[i][j].shortest_len );
	}
	OSReport( "\n" );
  }
#endif

  //OSReport( "nodes %d\n", nodes_num );
  //OSReport( "lines %d\n", line_num );
}

//_startSm[hւ̍ŒZƍŏ̌oRm[h𒲂ׂB
class DATA{
  friend class C_Border;
public:
  f32 len;
  s32 fixed;
  C_NodePoint *first_node;
  C_NodePoint *current_node;
  DATA( void ){ len = MAXFLOAT; fixed = 0; first_node = current_node = 0;}
  bool operator < (const DATA a) const { return this->len < a.len; }
};
void C_Border::FindShortestPath( u32 _start )
{
  f32 travel_len=0.f;
  DATA data_list[1024];

  //gւ̌oH͖B
  data_list[_start].len = 0.f;
  data_list[_start].fixed = 1;
  data_list[_start].first_node = &nodes[_start];

  C_NodePoint *n = &nodes[_start];
  for( u32 i=0; i<(nodes_num-1); i++ ){
	//ڍsߓ_SĊJB
	for( u32 j=0; j<n->direct_link.size(); j++ ){
	  C_NodePoint *d = n->direct_link[j].dst;
	  f32 len = n->direct_link[j].len + travel_len;

	  //łɊJĂ镨ƋrBꍇXVB
	  if( !(data_list[ (u32)(d->no) ].fixed) && data_list[ (u32)(d->no) ].len > len ){
		data_list[ (u32)(d->no) ].len = len;
		data_list[ (u32)(d->no) ].current_node = d;
		if( n == &nodes[_start] ){
		  //o_ɒڍsߓ_first_nodegɁB
		  data_list[ (u32)(d->no) ].first_node = d;
		}else{
		  //łȂꍇAOɊm肵m[hfirst_node̗pB
		  data_list[ (u32)(d->no) ].first_node = data_list[ (u32)(n->no) ].first_node;
		}
	  }
	}
	//ԋ߂m[hmɂB
	DATA *data = 0;
	f32 len = MAXFLOAT;
	for( u32 j=0; j<nodes_num; j++ ){
	  if( !(data_list[j].fixed) && len > data_list[j].len ){
		len = data_list[j].len;
		data = &data_list[j];
	  }
	}
	//̃m[ho_ƂČJԂB
	if( data ){
	  data->fixed = 1;
	  travel_len = data->len;
	  n = data->current_node;
	}
  }

  for( u32 i=0; i<nodes_num; i++ ){
	shortest_path[_start][i].shortest_len = data_list[i].len;
	shortest_path[_start][i].first_node = data_list[i].first_node;
  }
	
}

void C_Border::DispStart( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_ENABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );

  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetLineWidth( (u8)16,GX_TO_ZERO );
  GXSetPointSize( (u8)40,GX_TO_ZERO );
}

void C_Border::DispEnd( void )
{
  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_Border::DispLine( u32 idx, u32 flg, u32 col )
{
#pragma unused(flg)

  //|SƂΑǁA
  //ǂfobOpȂ̂ŃdB
#if 1
  C_Vec vtx[3],nrm;
  //todo VecC_Vec̃TCYłȂƂ΂ȂH
  MTXMultVecArray(trigons.GetMtx(), lines[idx].p, vtx, 2);
  MTXMultVecSR(trigons.GetMtx(), &lines[idx].n, &nrm);
  C_BorderLine l( vtx[0], vtx[1], nrm, -1, -1 );
  l.Disp(col,1);
#else
  lines[idx].Disp( col,flg );
#endif
}
void C_Border::DispNode( u32 idx, u32 flg, u32 col )
{
#pragma unused(flg)

  //|SƂΑǁA
  //ǂfobOpȂ̂ŃdB
#if 1
  C_Vec vtx;
  MTXMultVec(trigons.GetMtx(), &nodes[idx].p, &vtx);
  C_NodePoint n( vtx, -1, -1, vtx );
  n.Disp(col,1);
  //HSD_DmpVector( "", &vtx );
#else
  nodes[idx].Disp( col,flg );
#endif
}

void C_BorderLine::Disp( u32 col, u32 flg )
{
#pragma unused(flg)
  GXBegin(GX_LINESTRIP, GX_VTXFMT0, 2);
  GXPosition3f32(p[0].x, p[0].y, p[0].z);
  GXColor1u32(col);
  GXPosition3f32(p[1].x, p[1].y, p[1].z);
  GXColor1u32(col);
  GXEnd();
}

inline void PERP2D( Vec &v ){
  //x,zʂŁAvɂXOx܂킷B
  v.y = v.x; v.x = -v.z; v.z = v.y;
}
inline int SGN(f32 x)
{
  //if (fabs(x) < FLT_EPSILON) return 0;
  if (ABS(x) < FLT_EPSILON) return 0;
  return (x<0.f) ? -1 : 1;
}
bool C_BorderLine::Cross( C_Vec &_s, C_Vec &_e )
{
  C_3DBBOX b;
  b.SetUp(_s,_e);
  if( b.min_x > bbox.max_x || b.max_x < bbox.min_x ||
	  //	  b.min_y > bbox.max_y || b.max_y < bbox.min_y ||
	  b.min_z > bbox.max_z || b.max_z < bbox.min_z ) return false;

  //O̕ʂɓeB
  C_Vec s = _s; s.y = 0.f;
  C_Vec e = _e; e.y = 0.f;
  C_Vec p0 = p[0]; p0.y = 0.f;
  C_Vec p1 = p[1]; p1.y = 0.f;


#if 0
  //Oσo[W |ZQSB
  C_Vec l0 = p1 - p0;
  C_Vec l1 = s - p0;
  C_Vec l2 = e - p0;
  C_Vec cp01 = l0 & l1;
  C_Vec cp02 = l0 & l2;

  //_C̍AEɎU݂Ă邩H
  if( (cp01 | cp02) < 0.f ){
	l0 = e - s;
	l1 = p0 - s;
	l2 = p1 - s;
	cp01 = l0 & l1;
	cp02 = l0 & l2;
	if( (cp01 | cp02) < 0.f ) 
	  return true;
	else 
	  return false;
  }else{
	return false;
  }
#else
  //σo[W@|ZPQB
  C_Vec l0 = p1 - p0;
  PERP2D( l0 );
  C_Vec l1 = s - p0;
  C_Vec l2 = e - p0;
  //f32 l0_dot_l1 = l0 | l1;
  //f32 l0_dot_l2 = l0 | l2;
  f32 l0_dot_l1 = l0.x * l1.x + l0.z * l1.z;
  f32 l0_dot_l2 = l0.x * l2.x + l0.z * l2.z;

  //p1-p0ɒ[_B
  if( l0_dot_l1 == 0.f || l0_dot_l2 == 0.f ) return true;

  if( SGN( l0_dot_l1 * l0_dot_l2 ) < 0 ){
	l0 = e - s;
	PERP2D( l0 );
	l1 = p0 - s;
	l2 = p1 - s;
	//l0_dot_l1 = l0 | l1;
	//l0_dot_l2 = l0 | l2;
	l0_dot_l1 = l0.x * l1.x + l0.z * l1.z;
	l0_dot_l2 = l0.x * l2.x + l0.z * l2.z;

	//e-sɒ[_B
	if( l0_dot_l1 == 0.f || l0_dot_l2 == 0.f ) return true;

	//e == s ȂĂȂƔfB
	if( l0.IsZero() ) return false;

	if( SGN( l0_dot_l1 * l0_dot_l2 ) < 0 )
	  return true;
	else 
	  return false;
  }else{
	return false;
  }
#endif
}

void C_NodePoint::Disp( u32 col, u32 flg )
{
#pragma unused(flg)
  GXBegin(GX_POINTS, GX_VTXFMT0, 1);
  GXPosition3f32(p.x, p.y, p.z);
  GXColor1u32(col);
  GXEnd();

#if 0
  for( u32 i=0; i<direct_link.size(); i++ ){
	GXBegin(GX_LINES, GX_VTXFMT0, 2);
	GXPosition3f32(p.x, p.y, p.z);
	GXColor1u32(col);
	GXPosition3f32(direct_link[i].dst->p.x, direct_link[i].dst->p.y, direct_link[i].dst->p.z);
	GXColor1u32(col);
	GXEnd();
  }
#endif
}

#if 0
#define DEBUGPRINT 0
#define TRIGGER (HSD_PadGetTrigger(0) & HSD_PAD_Z )
//#define TRIGGER 1
#define TAB ("   ")
#if DEBUGPRINT
static u32 gVisit;
static s16 gDepth;
static s16 gRoot[1024];
static C_NodePoint *gLastNode;
#endif
void C_Border::_FindPath( C_NodePoint &n, f32 d )
{
#if DEBUGPRINT
  gVisit++;
#endif

  //n-eԂ𒼐ڍs邩ǂH
  if( n.len2dst >= 0.f ){
#if DEBUGPRINT
	if( TRIGGER ){
	  for( int i=0; i<gDepth; i++ )OSReport( TAB );
	  OSReport( "%d reached\n", n.no );
	}
#endif
	//B̓؂ł̒T͏IB
	f32 dist = d + n.len2dst;
	if( dist < shortest_way ){
	  //ŏ̒ʉߓ_ƍŒZLB
	  first_node = possible_first_node;
	  shortest_way = dist;
#if DEBUGPRINT
	  gLastNode = &n;
	  if( TRIGGER ){
		for( int i=0; i<gDepth; i++ )OSReport( TAB );
		for( int i=0; i<gDepth; i++ ){
		  OSReport( "%d ", gRoot[i] );
		}
		OSReport( "%f\n", dist );
	  }
#endif
	}
	return;
  }

  //ʉ߃tO𗧂ĂB
  if( n.flg != 2 ) n.flg = 1;

#if DEBUGPRINT
  if( TRIGGER ){
	for( int i=0; i<gDepth; i++ )OSReport( TAB );
	OSReport( "%d started---------------\n", n.no );
  }
#endif
  //m[h̃NǂB
  for( u32 i=0; i<n.direct_link.size(); i++ ){
	if( n.direct_link[i].dst->flg ){
	  //(flg == 2)ڍsm[hɉ肵čsƂĂ邩A
	  //(flg == 1)t߂肵悤ƂĂB
#if DEBUGPRINT
	  if( TRIGGER ){
		for( int i=0; i<(gDepth+1); i++ )OSReport( TAB );
		OSReport( "%d stop(%d)  ", n.direct_link[i].dst->no, n.direct_link[i].dst->flg );
		for( int j=0; j<(gDepth+1); j++ ){
		  OSReport( "%d ", gRoot[j] );
		}
		OSReport( "%d DEAD END\n", n.direct_link[i].dst->no );
	  }
#endif
	}else{
#if DEBUGPRINT
	  if( TRIGGER ){
		gRoot[gDepth++] = n.direct_link[i].dst->no;
		for( int i=0; i<gDepth; i++ )OSReport( TAB );
		OSReport( "%d continue(%d)\n", n.direct_link[i].dst->no, n.direct_link[i].dst->flg );
	  }
#endif
	  if( !n.direct_link[i].dst->possible ) continue;
	  f32 dist = d + n.direct_link[i].len;

	  _FindPath( *n.direct_link[i].dst, dist );
#if DEBUGPRINT
	  if( TRIGGER ){
		gDepth--;
	  }
#endif
	}
  }

  //ʉ߃tO낷B
  if( n.flg != 2 ) n.flg = 0;
#if DEBUGPRINT
  if( TRIGGER ){
	for( int i=0; i<gDepth; i++ )OSReport( TAB );
	OSReport( "%d ended---------------\n", n.no );
  }
#endif
  
}
#endif
#if 1
C_Vec C_Border::FindPath( C_Vec &_start, C_Vec &_end )
{
#if 1
  //n_ƏI_C_Border̃[JɕϊB
  C_Vec start, end;
  MTXMultVec( trigons.GetIMtx(), &_start, &start );
  MTXMultVec( trigons.GetIMtx(), &_end, &end );

  //start-endԂ𒼐ڍs邩ǂH
  u32 flg = 0;
  for( u32 i=0; i<line_num; i++ ){
	if( lines[i].Cross( start, end ) ){
	  flg++;  break;
	}
  }

  //ڍsBIB
  if( flg == 0 ) return _end;

  //L[̏ꍇAlL̃T[`͂Pt[Pxł͂B
  s32 search_end=0;
  s32 search_start=0;
  if( last_end != end ){
	for( u32 i=0; i<nodes_num; i++ )  nodes[i].possible &= 0xfffd;
	last_end = end;
	search_end = 1;
  }
  if( last_start != start ){
	for( u32 i=0; i<nodes_num; i++ )  nodes[i].possible &= 0xfffe;
	last_start = start;
	search_start = 1;
  }

  //start-node[s]ɕǂȂToB
  if( search_start ){
	for( u32 i=0; i<nodes_num; i++ ){
	  u32 flg = 0;
	  for( u32 j=0; j<line_num; j++ ){
		if( lines[j].Cross( start, nodes[i].p ) ){
		  flg++;
		  break;
		}
	  }
	  if( flg == 0 ){
		nodes[i].possible |= (0x1<<0);
		nodes[i].len2start = nodes[i].p.Dist(start);
	  }else{
		nodes[i].len2start = -1.f;
	  }
	}
  }

  //end-node[e]ɕǂȂToB
  if( search_end ){
	for( u32 i=0; i<nodes_num; i++ ){
	  u32 flg = 0;
	  for( u32 j=0; j<line_num; j++ ){
		if( lines[j].Cross( end, nodes[i].p ) ){
		  flg++;
		  break;
		}
	  }
	  if( flg == 0 ){
		nodes[i].possible |= (0x1<<1);
		nodes[i].len2end = nodes[i].p.Dist(end);
	  }else{
		nodes[i].len2end = -1.f;
	  }
	}
  }

  //shortest_path[s][e]ŏ̕ToB
  shortest_way = MAXFLOAT;
  first_node = 0;
  for( u32 i=0; i<nodes_num; i++ ){
	for( u32 j=0; j<nodes_num; j++ ){	
	  //Jnߓ_(nodes[i])ƍŏIߓ_(nodes[j])
	  if( (nodes[i].possible & (0x1<<0)) && (nodes[j].possible & (0x1<<1)) ){
		if( j == i ){
		  //oRߓ_͈B
		  if( shortest_way > nodes[i].len2start + nodes[j].len2end ){
			first_node = &nodes[i];
			shortest_way = nodes[i].len2start + nodes[j].len2end;
		  }
		}else{
		  if( shortest_way > shortest_path[i][j].shortest_len + nodes[i].len2start + nodes[j].len2end ){
			first_node = &nodes[i];
			shortest_way = shortest_path[i][j].shortest_len + nodes[i].len2start + nodes[j].len2end;
		  }
		}
	  }
	}
  }

  //shortest_path[s][e].first_nodeɌB
  if( first_node ) {
	//ŏ̒ʉߓ_ڎwB
	//O[oɕϊB
	MTXMultVec( trigons.GetMtx(), &(first_node->p), &end );
	return end;
  }else{
	//ݒnE̊Oɂ\B
	//pXȂꍇAȂB
	//return _start;
	//Ƃ܂̂ŁAend̂܂ܕԂƂɂB
	return _end;
  }
#endif
}
#else
C_Vec C_Border::FindPath( C_Vec &_start, C_Vec &_end )
{
  //n_ƏI_C_Border̃[JɕϊB
  C_Vec start, end;
  MTXMultVec( trigons.GetIMtx(), &_start, &start );
  MTXMultVec( trigons.GetIMtx(), &_end, &end );

  for( u32 i=0; i<nodes_num; i++ ){
	nodes[i].possible = 0;
  }

  //start-endԂ𒼐ڍs邩ǂH
  u32 flg = 0;
  for( u32 i=0; i<line_num; i++ ){
	if( lines[i].Cross( start, end ) ){
	  for( u32 j=0; j<nodes_num; j++ ){
		if( lines[i].group == nodes[j].group )
		  nodes[j].possible = 1;
	  }
	  flg++;
	}
  }

  //ڍsBIB
  if( flg == 0 ) return _end;

  //ŏƁAʉߓ_B
  shortest_way = MAXFLOAT;
  first_node = 0;

  //Sm[hɑ΂end-node[i]Ԃɕǂ邩ǂfB
  u32 possibles = 0;
  u32 last_node_num = 0;
  for( u32 i=0; i<nodes_num; i++ ){
	u32 flg = 0;
	for( u32 j=0; j<line_num; j++ ){
	  if( lines[j].Cross( end, nodes[i].p ) ){
		flg++;
		break;
	  }
	}
	if( flg == 0 ){
	  nodes[i].len2dst = nodes[i].p.Dist(end);
	  last_node_num++;
	  if( nodes[i].possible ) possibles++;
	}else{
	  nodes[i].len2dst = -1.f;
	}
  }

  //ŁAnodes[].len2dst >= 0.f && nodes[].possibleЂƂȂꍇlB
  //tO𗧂ĂĂĂBł̂H
  if( !possibles ){
	u32 flg = 0;
	for( u32 i=0; i<nodes_num; i++ ){
	  if( nodes[i].len2dst >= 0.f && !nodes[i].possible ){
		for( u32 j=0; j<nodes[i].direct_link.size(); j++ ){
		  //N悪possibleł΍̗pB
		  if( nodes[i].direct_link[j].dst->possible ){
			flg++;
			nodes[i].possible = 1;
		  }
		}
	  }
	}
	if( flg==0 ){
	  //ň̃p^[B
	  for( u32 i=0; i<nodes_num; i++ ) nodes[i].possible = 1;
	}
  }

#if 0
  OSReport( "possible last nodes:" );
  for( u32 i=0; i<nodes_num; i++ ){
	if( nodes[i].len2dst >= 0.f && nodes[i].possible) OSReport( "%d(%f)", i, nodes[i].len2dst );
  }
  OSReport( "\n" );
#endif


  //ڕWn_E̊Oɂ\B
  if( last_node_num == 0 ){
	return _end;
  }

  //Sm[hɑ΂start-node[i]Ԃɕǂ邩ǂfB
  possibles = 0;
  for( u32 i=0; i<nodes_num; i++ ){
	u32 flg = 0;
	for( u32 j=0; j<line_num; j++ ){
	  if( lines[j].Cross( start, nodes[i].p ) ){
		flg++;
		break;
	  }
	}
	if( flg == 0 ){
	  //X^[gn_Ƃč̗pB
	  nodes[i].flg = 2;
	  if( nodes[i].possible ) possibles++;
	}else{
	  nodes[i].flg = 0;
	}
  }

  //ŁAnodes[].flg == 2 && nodes[].possibleЂƂȂꍇlB
  //tO𗧂ĂĂĂBł̂H
  if( !possibles ){
	u32 flg = 0;
	for( u32 i=0; i<nodes_num; i++ ){
	  if( nodes[i].flg == 2 && !nodes[i].possible ){
		for( u32 j=0; j<nodes[i].direct_link.size(); j++ ){
		  //N悪possibleł΍̗pB
		  if( nodes[i].direct_link[j].dst->possible ){
			flg++;
			nodes[i].possible = 1;
		  }
		}
	  }
	}
	if( flg==0 ){
	  //ň̃p^[B
	  for( u32 i=0; i<nodes_num; i++ ) nodes[i].possible = 1;
	}
  }
#if DEBUGPRINT
  if( TRIGGER ){
	OSReport( "start nodes: " );
	for( u32 i=0; i<nodes_num; i++ ){
	  if( nodes[i].flg ) OSReport( "%d ", nodes[i].no );
	}
	OSReport( "\n" );
  }
#endif

#if DEBUGPRINT
  gVisit = 0;
#endif
  for( u32 i=0; i<nodes_num; i++ ){
	if( nodes[i].flg == 2 && nodes[i].possible ){
#if DEBUGPRINT
	  if( TRIGGER ){
		OSReport( "---- %d ----\n", nodes[i].no );
	  }
#endif
	  for( u32 j=0; j<nodes_num; j++ ){
		if( nodes[j].flg != 2 ) nodes[j].flg = 0;
	  }

	  //ʉߓ_Ƃnodes[i]LB
	  possible_first_node = &nodes[i];

	  //start-node[i]Ԃ̋B
	  f32 dist = start.Dist( nodes[i].p );

#if DEBUGPRINT
	  if( TRIGGER ){
		gDepth = 0;
		gRoot[gDepth++] = nodes[i].no;
	  }
#endif
	  //node[i]o_ƂĒTJnB
	  _FindPath( nodes[i], dist );
	  
	}
  }
#if DEBUGPRINT
  OSReport( "%d\n", gVisit );
  if( TRIGGER ){
	if( first_node ) 
	  OSReport( "chosen %d %f\n", first_node->no, shortest_way );
	else			
	  OSReport( "not found\n" );
  }
#endif

  //OSReport( "%d -> %d\n", first_node->no, gLastNode->no );


  if( first_node ) {
	//ŏ̒ʉߓ_ڎwB
	//O[oɕϊB
	MTXMultVec( trigons.GetMtx(), &(first_node->p), &end );
	return end;
  }else{
	//ݒnE̊Oɂ\B
	//pXȂꍇAȂB
	//return _start;
	//Ƃ܂̂ŁAend̂܂ܕԂƂɂB
	return _end;
  }
}
#endif
//Ō̒ʉߓ_̌ɂĕԂB
class VECDIST{
public:
  VECDIST( void ){dist = -1.f;}
  bool operator < (const VECDIST a) const { return this->dist < a.dist; }
  C_Vec pos;
  f32 dist;
};
u32 C_Border::FindPossibleLastNode( C_Vec &end, C_Vec *node_pos, u32 max_num )
{
  vector< VECDIST > vecdist;

  u32 num = 0;
#if 1
  //end̓O[oȂ̂ŁAC_Border̃[JɕϊB
  C_Vec e;
  MTXMultVec( trigons.GetIMtx(), &end, &e );

  for( u32 i=0; i<nodes_num; i++ ){
	u32 flg = 0;
	for( u32 j=0; j<line_num; j++ ){
	  if( lines[j].Cross( e, nodes[i].p ) ){
		flg++;
		break;
	  }
	}
	if( flg == 0 ){
	  VECDIST t;
	  t.pos = nodes[i].p;
	  t.dist = nodes[i].p.Dist( end );
	  vecdist.push_back( t );
	  num++;
	  if( num == max_num ) break;
	}
  }
  if( num ){
	vector< VECDIST >::iterator f = vecdist.begin();
	vector< VECDIST >::iterator e = vecdist.end();
	std::sort( f, e );
	for( u32 i=0; i<num; i++ ){
	  //OSReport( "%f ", vecdist[i].dist );
	  //O[oWɕϊĕԂB
	  MTXMultVec( trigons.GetMtx(), &vecdist[i].pos, &node_pos[i] );
	  //node_pos[i] = vecdist[i].pos;
	}
	//OSReport( "\n" );
	return num;
  }
#endif
  return num;
}




