#ifndef ___C_BORDER_H___
#define ___C_BORDER_H___

//#include "common.h"
#include "c_vec.h"
#include "vector.h"
#include "list.h"
#include "c_trigon.h"

class C_BorderLine{
  friend class C_Border;
 public:
  C_BorderLine( C_Vec &_p0, C_Vec &_p1, C_Vec &_n, s16 i0, s16 i1 ){
	p[0] = _p0;
	p[1] = _p1;
	n = _n;
	idx[0] = i0;
	idx[1] = i1;
	bbox.SetUp( p[0], p[1] );
  }
  bool Cross( C_Vec &_s, C_Vec &_e );
  void Disp( u32 col, u32 flg );
 protected:
  C_3DBBOX bbox;
  C_Vec p[2];
  C_Vec n;
  s16 idx[2];
  s16 group;
  s16 flg;
};
class C_NodeLink;
class C_NodePoint{
  friend class C_Border;
  friend class C_NodeLink;
 public:
  C_NodePoint( C_Vec &_p, s16 _no, s16 _g, C_Vec &_n ){
	p = _p;
	n = _n;
	no = _no;
	group = _g;
	possible = 0;
  }
  void Disp( u32 col, u32 flg );
 protected:
  C_Vec p,n;
  vector<C_NodeLink> direct_link;
  f32 len2start;
  f32 len2end;
  s16 flg;
  s16 no;
  s16 group;
  s16 possible;
};
class C_NodeLink{
  friend class C_NodePoint;
  friend class C_Border;
 public:
  C_NodeLink( C_NodePoint *_src, C_NodePoint *_dst ){
	dst = _dst;
	C_Vec d = _dst->p - _src->p;
	len = d.Mag();
  }
 private:
  C_NodePoint *dst;
  f32 len;
};

class C_Border{
 public:
  C_Border( C_TrigonArray &_t );
  void Init( C_TrigonArray &_t );
  void DispStart( void );
  void DispEnd( void );
  void DispLine( u32 idx, u32 flg=0, u32 col=(u32)(0x88<<24 | 0xff<<16 | 0x88<<8 |0x88) );
  void DispNode( u32 idx, u32 flg=0, u32 col=(u32)(0xff<<24 | 0x88<<16 | 0x88<<8 |0x88) );
  void DispAll( void ){
	DispStart();
	for( int i=0; i<line_num; i++ ){
	  DispLine( (u32)i, 0 );
	}
	for( int i=0; i<nodes_num; i++ ){
	  DispNode( (u32)i, 0 );
	}
	DispEnd();
  }
  C_Vec FindPath( C_Vec &_start, C_Vec &_end );
  C_Vec GetNodePos( u32 idx ){ return nodes[idx].p; }
  u32 GetNodeNum( void ){ return nodes_num; }
  u32 FindPossibleLastNode( C_Vec &end, C_Vec *node_pos, u32 max_num );
  void FindShortestPath( u32 start );
  Vec GetFirstNodePos( void ){ if( first_node ) return first_node->p; else return last_start;}
  Vec GetFirstNodeNrm( void ){ if( first_node ) return first_node->n; else return last_start;}
  f32 GetShortestDist( void ){ return shortest_way; }
 protected:
  class C_ShortestPathArray{
	//ŒZƍŏɌoRׂߓ_oĂB
  public:
	C_ShortestPathArray( void ){
	  first_node = 0;
	  shortest_len = -1.f;
	}
	C_NodePoint *first_node;
	f32	shortest_len;
  private:
  };
  C_TrigonArray& trigons;
  vector<C_BorderLine> lines;
  vector<C_NodePoint> nodes;
  vector< vector< C_ShortestPathArray > > shortest_path;
  u32 line_num;
  u32 nodes_num;
  f32 shortest_way;
  C_NodePoint *first_node, *possible_first_node;
  C_Vec last_end;
  C_Vec last_start;

  void _FindPath( C_NodePoint &n, f32 d );
};

#endif


