//#include "common.h"
#include "..\Yam\YK7EffectVital.h"
/********************************/
typedef struct
{
    u16             numEntries;
    u8              unpacked;
    u8              pad8;

    GXTlutFmt       format;
    Ptr             data;

}CLUTHeader, *CLUTHeaderPtr;

extern VITALUNION VitUnion ;
/********************************/
typedef struct
{
    u16             height;
    u16             width;

    u32             format;
    Ptr             data;

    GXTexWrapMode   wrapS;
    GXTexWrapMode   wrapT;

    GXTexFilter     minFilter;
    GXTexFilter     magFilter;

    float           LODBias;

    u8              edgeLODEnable;
    u8              minLOD;
    u8              maxLOD;
    u8              unpacked;

}TEXHeader, *TEXHeaderPtr;

/********************************/
typedef struct
{
    TEXHeaderPtr        textureHeader;
    CLUTHeaderPtr       CLUTHeader;

}TEXDescriptor, *TEXDescriptorPtr;

/********************************/
typedef struct
{
    u32                 versionNumber;

    u32                 numDescriptors;
    TEXDescriptorPtr    descriptorArray;

}TEXPalette, *TEXPalettePtr;

//#include "out.c"
extern unsigned char broken_glass_IA8[];

typedef	struct{
	f32					x,y,z;
	f32					s,t;
	f32					is,it;
	u32					col;
}GlassPosInfo;

enum {
  BROKEN_GLASS_TEX_NUM = 4
};
class C_BrokenGlass{
 public:
  //eNX`TCY
  //G					640X480
  //C_CNg		320x240
  //ɌŒB
  C_BrokenGlass( GXTexObj *_picture, f32 _rate ,void *pTpl=NULL){
	rate = _rate;
	if( rate >= 1.f ) rate = 1.f;
	if( rate <= 0.f ) rate = 0.f;
	picture = _picture;
	if( pTpl!=NULL ){
		tpl = (TEXPalettePtr)pTpl;
//	}else{
//		tpl = (TEXPalettePtr)broken_glass_IA8;
	}
	if(tpl->versionNumber != 2142000 )
	  OSHalt("invalid version number for texture palette");
	
	//OSReport( "%0x %0x\n", (u32)tpl->descriptorArray, (u32)tpl );
	if( (u32)tpl->descriptorArray < (u32)0x80000000 ){
	  tpl->descriptorArray = (TEXDescriptorPtr)(((u32)(tpl->descriptorArray)) + ((u32)tpl));
	
	  //ĔzuB
	  for ( int i = 0; i < tpl->numDescriptors; i++ ){
		if(tpl->descriptorArray[i].textureHeader){
		  tpl->descriptorArray[i].textureHeader = 
			(TEXHeaderPtr)(((u32)(tpl->descriptorArray[i].textureHeader)) + ((u32)tpl));	
		  
		  if(!(tpl->descriptorArray[i].textureHeader->unpacked)){
			tpl->descriptorArray[i].textureHeader->data = 
			  (Ptr)((u32)(tpl->descriptorArray[i].textureHeader->data) + (u32)tpl);
			tpl->descriptorArray[i].textureHeader->unpacked = 1;
		  }
		}
		
		if(tpl->descriptorArray[i].CLUTHeader){
		  tpl->descriptorArray[i].CLUTHeader = 
			(CLUTHeaderPtr)((u32)(tpl->descriptorArray[i].CLUTHeader) + (u32)tpl);		
		  
		  if(!(tpl->descriptorArray[i].CLUTHeader->unpacked)){
			tpl->descriptorArray[i].CLUTHeader->data = 
			  (Ptr)((u32)(tpl->descriptorArray[i].CLUTHeader->data) + (u32)tpl);
			tpl->descriptorArray[i].CLUTHeader->unpacked = 1;
		  }
		}
	  }
	}
	
	//TexObj쐬B
	//ƂȂ̂ŁAbh̓Ro[gȂłˁB
	for ( int i = 0; i < tpl->numDescriptors; i++ ){
	  GXBool mipMap;
	  GXTexObj to;
	  TEXDescriptorPtr tdp = tpl->descriptorArray + i;
	  if(tdp->textureHeader->minLOD == tdp->textureHeader->maxLOD)
		mipMap = GX_FALSE;
	  else
		mipMap = GX_TRUE;
	  
	  GXInitTexObj(&to, 
				   tdp->textureHeader->data, 
				   tdp->textureHeader->width, 
				   tdp->textureHeader->height, 
				   (GXTexFmt)tdp->textureHeader->format,
				   tdp->textureHeader->wrapS, 
				   tdp->textureHeader->wrapT, 
				   mipMap); 
	  
	  
	  GXInitTexObjLOD(&to, 
					  //GX_NEAR,
					  //GX_NEAR,
					  GX_LINEAR,
					  GX_LINEAR,
					  //tdp->textureHeader->minFilter, 
					  //tdp->textureHeader->magFilter, 
					  tdp->textureHeader->minLOD, 
					  tdp->textureHeader->maxLOD, 
					  tdp->textureHeader->LODBias,
					  GX_DISABLE,
					  tdp->textureHeader->edgeLODEnable,
					  GX_ANISO_1);  
	  indirect[ i ] = to;
	}
  }
  void Proc( void );

  bool DispDirect( EFFECT *Effect ){
	if( !Effect ) return false;

 	VITALEFFECT *Vital = ( VITALEFFECT * )Effect->Data ;

	if( (VITALEFFECT *)NULL == Vital ) return false; 
	if( Vital->DrawFlag == FALSE ) return false;
	if( VitUnion.NotDrawFlag == true ) return false;

	rate = Vital->TempVitalRate;
	if( rate >= 1.f ) rate = 1.f;
	if( rate <= 0.f ) rate = 0.f;
	return Disp();
  }


  bool Disp( void ){
	//O͉̎ȂB
#if 0
	rate = ( sinf( (f32)M_PI * ((VIGetRetraceCount()/4)%180) / 180.f ) );
#else
	if( rate >= 1.f ) return false;
#endif

	TEXDescriptorPtr tdp = tpl->descriptorArray;
	GXRenderModeObj *rmode = HSD_VIGetConfigure();

	Mtx44  pMtx;
	Mtx    mMtx;

	//Transform
	GXSetViewport(  0.0f, 0.0f, rmode->fbWidth, rmode->xfbHeight,  0.0f,   1.0f);
	GXSetScissor(  0, 0, rmode->fbWidth, rmode->xfbHeight);
	MTXOrtho( pMtx, 0.0f, (float)480, 0.0f, (float)640, 0.0f, 100 );
	GXSetProjection( pMtx, GX_ORTHOGRAPHIC );
	MTXIdentity( mMtx );
	GXLoadPosMtxImm( mMtx, GX_PNMTX0 );
	GXSetCurrentMtx( GX_PNMTX0 );

	//PE
	GXSetColorUpdate( GX_ENABLE );
	GXSetAlphaUpdate( GX_DISABLE );
	GXSetZMode( GX_DISABLE, GX_ALWAYS, GX_DISABLE );
	//GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetBlendMode(GX_BM_BLEND, GX_BL_INVSRCALPHA,GX_BL_SRCALPHA,GX_LO_CLEAR);
	//GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetDither( GX_DISABLE );
	//CHANNEL
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_ENABLE,		// enable channel
				  GX_SRC_VTX,		// amb source
				  GX_SRC_VTX,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
	GXSetNumChans(1);

	//TEX
	GXLoadTexObj(picture, GX_TEXMAP0);

#if 1
#define	DECL_GLASSPOS(x,y,s,t)	{ K7APP_SCREEN_WIDTH * (x) , K7APP_SCREEN_HEIGHT * (y) , ZMID , (x) , (y) , (s) , (t) , 0xffffffff },
//#define	DECL_GLASSPOS(x,y,s,t)	{ K7APP_SCREEN_WIDTH * (x) , K7APP_SCREEN_HEIGHT * (y) , ZMID , (x) , (y) , (s) , (t) , 0xff8080ff },
static	GlassPosInfo	glass_pos[][4] = {
	{
		DECL_GLASSPOS(0.5f,0.0f,0.0f,0.0f)
		DECL_GLASSPOS(1.0f,0.0f,1.0f,0.0f)
		DECL_GLASSPOS(0.5f,0.5f,0.0f,1.0f)
		DECL_GLASSPOS(1.0f,0.5f,1.0f,1.0f)
	},
	{
		DECL_GLASSPOS(1.0f,0.5f,1.0f,0.0f)
		DECL_GLASSPOS(0.5f,0.5f,0.0f,0.0f)
		DECL_GLASSPOS(1.0f,1.0f,1.0f,1.0f)
		DECL_GLASSPOS(0.5f,1.0f,0.0f,1.0f)
	},
	{
		DECL_GLASSPOS(0.0f,0.5f,0.0f,0.0f)
		DECL_GLASSPOS(0.5f,0.5f,1.0f,0.0f)
		DECL_GLASSPOS(0.0f,1.0f,0.0f,1.0f)
		DECL_GLASSPOS(0.5f,1.0f,1.0f,1.0f)
	},
};
static	s8				glass_flag0[] = { 0 , -1 };
static	s8				glass_flag1[] = { 0 , 1 , -1 };
static	s8				glass_flag2[] = { 0 , 1 , 2 , 5 , -1 };
static	s8				glass_flag3[] = { 0 , 1 , 2 , 3 , 4 , 5 , -1 };
//static	s8				glass_flag0[] = { 1 , -1 };
//static	s8				glass_flag1[] = { 1 , 4 , -1 };
//static	s8				glass_flag2[] = { 0 , 1 , 3 , 4 , -1 };
//static	s8				glass_flag3[] = { 0 , 1 , 2 , 3 , 4 , 5 , -1 };
//static	s8				glass_flag0[] = { 1 , -1 };
//static	s8				glass_flag1[] = { 0 , 1 , -1 };
//static	s8				glass_flag2[] = { 0 , 1 , 2 , 3 , -1 };
//static	s8				glass_flag3[] = { 0 , 1 , 2 , 3 , 4 , 5 , -1 };
static	s8				*glass_flag[BROKEN_GLASS_TEX_NUM] = {
	glass_flag0,
	glass_flag1,
	glass_flag2,
	glass_flag3,
};
	int		i,texno;
	s32		no = (s32)(BROKEN_GLASS_TEX_NUM * (1.f-rate));
	if( no >= BROKEN_GLASS_TEX_NUM ) no = BROKEN_GLASS_TEX_NUM-1;
	if( no < 0 ) no = 0;
	
	for(i=0 ; i<6 ; i++){
		mDispFlag[i] = false;
	}
	for(i=0 ; glass_flag[no][i] >= 0 ; i++){
		mDispFlag[glass_flag[no][i]] = true;
	}
	
	//TEXGEN
	GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY);
	GXSetTexCoordGen(GX_TEXCOORD1, GX_TG_MTX2x4, GX_TG_TEX1, GX_IDENTITY);
	GXSetNumTexGens(2);

	//TEV
	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	//GXSetTevOp( GX_TEVSTAGE0, GX_REPLACE );
//	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_RASC,GX_CC_TEXC,GX_CC_ZERO);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
#if 0
	GXSetNumTevStages( 1 );
#else
	GXSetTevOrder(GX_TEVSTAGE1, GX_TEXCOORD1, GX_TEXMAP2, GX_COLOR_NULL);
	GXSetTevColorIn  (GX_TEVSTAGE1,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_CPREV);
	GXSetTevColorOp  (GX_TEVSTAGE1,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	{
#if 0
	  GXColor color={
		(VIGetRetraceCount()/60) % 256, 
		(VIGetRetraceCount()/60) % 256, 
		(VIGetRetraceCount()/60) % 256, 
		(VIGetRetraceCount()/60) % 256
	  };
#else
	  //GXColor color={127,127,127,0x7f};
	  GXColor color={127,127,127,(u8)126};
#endif
#if 0
	  //color.a = 		(VIGetRetraceCount()/30) % 256;
	  if( HSD_PadGetButton(1) & HSD_PAD_UP ) gCount -= 1;
	  if( HSD_PadGetButton(1) & HSD_PAD_DOWN ) gCount += 1;
	  gCount = gCount %256;
	  color.a = (u8)gCount;
	  OSReport( "%d\n", color. a );
#endif
	  GXSetTevColor( GX_TEVREG0, color );
	}
	GXSetTevAlphaIn  (GX_TEVSTAGE1,GX_CA_TEXA,GX_CA_A0,GX_CA_ONE,GX_CA_ZERO);
	GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_COMP_A8_EQ,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	//GXSetTevAlphaOp  (GX_TEVSTAGE1,GX_TEV_COMP_A8_GT,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	//GXSetTevSwapModeTable(GX_TEV_SWAP0,GX_CH_RED,GX_CH_GREEN,GX_CH_BLUE,GX_CH_RED);
	//GXSetTevSwapMode     (GX_TEVSTAGE1,GX_TEV_SWAP0,GX_TEV_SWAP0);
	//GX_TEV_COMP_A8_EQ d + ((a[A] == b[A]) ? c : 0 ); 
	//GXSetAlphaCompare(GX_NEQUAL,127,GX_AOP_AND,GX_ALWAYS,255);// wat
	GXSetNumTevStages( 2 );
#endif

	//DL
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX1, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0,  GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX1, GX_TEX_ST, GX_F32, 0);

	GXSetNumIndStages(1);
	GXSetIndTexOrder(GX_INDTEXSTAGE0, GX_TEXCOORD1, GX_TEXMAP1);
	GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_1, GX_ITS_1);
	GXSetTevIndWarp(GX_TEVSTAGE0,       // tev stage
					GX_INDTEXSTAGE0,    // indirect stage
					GX_TRUE,            // signed offsets?
					GX_FALSE,           // replace mode?
					GX_ITM_0);          // ind matrix select
	
	f32 indMtx[2][3];
	Mtx tmpMtx,r,s;
	MTXRotDeg(r, 'z', 0);
	MTXScale(s, 1.0f, 1.0f, 0.f );
	//MTXScale(s, 0.0f, (3.f + 0.5f * sinf(VIGetRetraceCount()%180) * (f32)M_PI / 180.f), 0.f );
	//MTXScale(s, trs[(u32)id].x*0.01f, trs[(u32)id].y*0.01f, 0.f );
	//OSReport( "%f %f\n", trs[(u32)id].y*0.01f );
	MTXConcat( r,s,tmpMtx );
	
	indMtx[0][0] = tmpMtx[0][0]*0.5f;
	indMtx[0][1] = tmpMtx[0][1]*0.5f;
	indMtx[0][2] = 0.0f;
	indMtx[1][0] = tmpMtx[1][0]*0.5f;
	indMtx[1][1] = tmpMtx[1][1]*0.5f;
	indMtx[1][2] = 0.0f;
	GXSetIndTexMtx(GX_ITM_0, indMtx, 1);

//	s32 no = (s32)(BROKEN_GLASS_TEX_NUM * (1.f-rate));
//	if( no >= BROKEN_GLASS_TEX_NUM ) no = BROKEN_GLASS_TEX_NUM-1;
//	if( no < 0 ) no = 0;
	
	for(i=0,texno=0 ; i<6 ; i+=2,texno++){
		
#if 0
		GXLoadTexObj(&indirect[texno], GX_TEXMAP1);
#else
		GXLoadTexObj(&indirect[texno], GX_TEXMAP1);
		GXLoadTexObj(&indirect[texno], GX_TEXMAP2);
#endif
		
		if( mDispFlag[i]==true ){
			DispTri(&glass_pos[texno][0],&glass_pos[texno][1],&glass_pos[texno][2]);
		}
		if( mDispFlag[i+1]==true ){
			DispTri(&glass_pos[texno][1],&glass_pos[texno][2],&glass_pos[texno][3]);
		}
	}
	
	GXSetTevSwapModeTable(GX_TEV_SWAP0,GX_CH_RED,GX_CH_GREEN,GX_CH_BLUE,GX_CH_ALPHA);
	GXSetTevSwapMode     (GX_TEVSTAGE1,GX_TEV_SWAP0,GX_TEV_SWAP0);
#else
	s32 no = (s32)(BROKEN_GLASS_TEX_NUM * (1.f-rate));
	if( no >= BROKEN_GLASS_TEX_NUM ) no = BROKEN_GLASS_TEX_NUM-1;
	if( no < 0 ) no = 0;
	GXLoadTexObj(&indirect[ no ], GX_TEXMAP1);
	//OSReport( "%d(%f)\n", (s32)(BROKEN_GLASS_TEX_NUM * (1.f-rate)), rate );
	//GXLoadTexObj(&indirect[ (s32)0 ], GX_TEXMAP1);
	
	//TEXGEN
	GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
	GXSetNumTexGens(1);

	//TEV
	GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
	//GXSetTevOp( GX_TEVSTAGE0, GX_REPLACE );
	GXSetTevColorIn  (GX_TEVSTAGE0,GX_CC_ZERO,GX_CC_ZERO,GX_CC_ZERO,GX_CC_TEXC);
	GXSetTevColorOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetTevAlphaIn  (GX_TEVSTAGE0,GX_CA_ZERO,GX_CA_ZERO,GX_CA_ZERO,GX_CA_RASA);
	GXSetTevAlphaOp  (GX_TEVSTAGE0,GX_TEV_ADD,GX_TB_ZERO,GX_CS_SCALE_1,GX_TRUE,GX_TEVPREV);
	GXSetNumTevStages( 1 );

	//DL
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0,  GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	//C_CNg
	
	// modified by watanabe 04/01/12
	GXIndTexScale	ssc,tsc;
	switch( tpl->descriptorArray[no].textureHeader->width ){
	case	640: ssc = GX_ITS_1;   break;
	case	320: ssc = GX_ITS_2;   break;
	case	160: ssc = GX_ITS_4;   break;
	case	 80: ssc = GX_ITS_8;   break;
	case	 40: ssc = GX_ITS_16;  break;
	case	 20: ssc = GX_ITS_32;  break;
	case	 10: ssc = GX_ITS_64;  break;
	case	  5: ssc = GX_ITS_128; break;
	default:     return false;
	}
	switch( tpl->descriptorArray[no].textureHeader->height ){
	case	480: tsc = GX_ITS_1;   break;
	case	240: tsc = GX_ITS_2;   break;
	case	120: tsc = GX_ITS_4;   break;
	case	 60: tsc = GX_ITS_8;   break;
	case	 30: tsc = GX_ITS_16;  break;
	case	 15: tsc = GX_ITS_32;  break;
	default:     return false;
	}
	
	GXSetNumIndStages(1);
	GXSetIndTexOrder(GX_INDTEXSTAGE0, GX_TEXCOORD0, GX_TEXMAP1);
	// modified by watanabe 04/01/12
	GXSetIndTexCoordScale(GX_INDTEXSTAGE0, ssc, tsc);
//	GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_2, GX_ITS_2);
	//GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_4, GX_ITS_4);
	GXSetTevIndWarp(GX_TEVSTAGE0,       // tev stage
					GX_INDTEXSTAGE0,    // indirect stage
					GX_TRUE,            // signed offsets?
					GX_FALSE,           // replace mode?
					GX_ITM_0);          // ind matrix select
	
	f32 indMtx[2][3];
	Mtx tmpMtx,r,s;
	MTXRotDeg(r, 'z', 0);
	MTXScale(s, 1.0f, 1.0f, 0.f );
	//MTXScale(s, 0.0f, (3.f + 0.5f * sinf(VIGetRetraceCount()%180) * (f32)M_PI / 180.f), 0.f );
	//MTXScale(s, trs[(u32)id].x*0.01f, trs[(u32)id].y*0.01f, 0.f );
	//OSReport( "%f %f\n", trs[(u32)id].y*0.01f );
	MTXConcat( r,s,tmpMtx );
	
	indMtx[0][0] = tmpMtx[0][0]*0.5f;
	indMtx[0][1] = tmpMtx[0][1]*0.5f;
	indMtx[0][2] = 0.0f;
	indMtx[1][0] = tmpMtx[1][0]*0.5f;
	indMtx[1][1] = tmpMtx[1][1]*0.5f;
	indMtx[1][2] = 0.0f;
	GXSetIndTexMtx(GX_ITM_0, indMtx, 1);

	//rate = sinf(((VIGetRetraceCount()/4)%180) * (f32)M_PI / 180.f );

	#if 1
		f32 w = 640.f, h = 480.f;
		u32 col0 = 0x000000ff;
		GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
		  GXPosition3f32( 0, 0, ZMID);
		  GXColor1u32(col0);
		  GXTexCoord2f32( 0,0 );
		  
		  GXPosition3f32( w, 0, ZMID);
		  GXColor1u32(col0);
		  GXTexCoord2f32( 1,0 );
		  
		  GXPosition3f32( w, h, ZMID);
		  GXColor1u32(col0);
		  GXTexCoord2f32( 1,1 );
		  
		  GXPosition3f32( 0, h, ZMID);
		  GXColor1u32(col0);
		  GXTexCoord2f32( 0,1);
		}GXEnd();
	#else
	#define kDiv 16
		C_Vec dir[kDiv];
		f32 w = 640.f, h = 480.f;
	#if 0
		f32 v_len = h * 0.5f;
		f32 h_len = w * 0.5f;
		f32 d_len = sqrtf( v_len*v_len + h_len*h_len );
	#endif
		Vec pos[kDiv * 3];
		for( int i=0; i<kDiv; i++ ){
		  f32 rad = -(360 * i / kDiv) * 2.f * (f32)M_PI / 360.f;
		  C_Vec ctr(w*0.5f, h*0.5f, 0.f);
		  C_Vec p( cosf( rad ), sinf( rad ), 0.f );
		  dir[i] = p;
		  pos[i] = dir[i] * 400.f + ctr;
		  pos[kDiv+i] = dir[i] * 400.f * rate + ctr;
		  pos[kDiv*2+i] = dir[i] * 400.f * rate * 0.9f + ctr;
		}
	#define	ZMID -0.5f
		
		for( int i=0; i<kDiv; i++ ){
		  int p0 = i;
		  int p1 = i==(kDiv-1) ? 0 : i+1;
		  int p2 = p1+kDiv;
		  int p3 = p0+kDiv;
		  u32 col0 = 0x000000ff;
		  GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
			GXPosition3f32( pos[p0].x, pos[p0].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p0].x/w,pos[p0].y/h);
			
			GXPosition3f32( pos[p1].x, pos[p1].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p1].x/w,pos[p1].y/h);
			
			GXPosition3f32( pos[p2].x, pos[p2].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p2].x/w,pos[p2].y/h);
			
			GXPosition3f32( pos[p3].x, pos[p3].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p3].x/w,pos[p3].y/h);
		  }GXEnd();
		}

		for( int i=0; i<kDiv; i++ ){
		  int p0 = i; p0 += kDiv;
		  int p1 = i==(kDiv-1) ? 0 : i+1; p1 += kDiv;
		  int p2 = p1+kDiv;
		  int p3 = p0+kDiv;
		  u32 col0 = 0x000000ff;
		  u32 col1 = 0x00000000;
		  GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
			GXPosition3f32( pos[p0].x, pos[p0].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p0].x/w,pos[p0].y/h);
			
			GXPosition3f32( pos[p1].x, pos[p1].y, ZMID);
			GXColor1u32(col0);
			GXTexCoord2f32( pos[p1].x/w,pos[p1].y/h);
			
			GXPosition3f32( pos[p2].x, pos[p2].y, ZMID);
			GXColor1u32(col1);
			GXTexCoord2f32( pos[p2].x/w,pos[p2].y/h);
			
			GXPosition3f32( pos[p3].x, pos[p3].y, ZMID);
			GXColor1u32(col1);
			GXTexCoord2f32( pos[p3].x/w,pos[p3].y/h);
		  }GXEnd();
		}
	#endif
#endif
	GXSetNumIndStages(0);
	GXSetTevDirect(GX_TEVSTAGE0);
	HSD_StateInvalidate( HSD_STATE_ALL );
	
	return true;
  }
  void SetRate( f32 _rate ){ rate = _rate; }
 protected:
  void DispTri(GlassPosInfo *pPos0,GlassPosInfo *pPos1,GlassPosInfo *pPos2){
	u32 col0 = 0x000000ff;
	GXBegin(GX_TRIANGLES, GX_VTXFMT0, 3);
#define	OFS		(-1.0f)
//#define	OFS		(0.0f)
//#define	OFS		(-0.5f)
	  GXPosition3f32(pPos0->x + OFS,pPos0->y + OFS,pPos0->z);
	  GXColor1u32   (pPos0->col);
	  GXTexCoord2f32(pPos0->s,pPos0->t);
	  GXTexCoord2f32(pPos0->is,pPos0->it);
	  
	  GXPosition3f32(pPos1->x + OFS,pPos1->y + OFS,pPos1->z);
	  GXColor1u32   (pPos1->col);
	  GXTexCoord2f32(pPos1->s,pPos1->t);
	  GXTexCoord2f32(pPos1->is,pPos1->it);
	  
	  GXPosition3f32(pPos2->x + OFS,pPos2->y + OFS,pPos2->z);
	  GXColor1u32   (pPos2->col);
	  GXTexCoord2f32(pPos2->s,pPos2->t);
	  GXTexCoord2f32(pPos2->is,pPos2->it);
	  
	GXEnd();
  }
  GXTexObj *picture;
  GXTexObj indirect[BROKEN_GLASS_TEX_NUM];
  TEXPalettePtr tpl;
  f32 rate;
  
  bool mDispFlag[6];
  //static int gCount;
 private:
};



