#ifndef ___C_CLOTH___
#define ___C_CLOTH___

//#include "common.h"
#include "c_vec.h"
#include "c_trigon.h"
#include "vector.h"

class C_Cloth {
 public:
  enum BIND_TYPE{
	RIGID_BIND,
	SPRING_BIND
  };
  typedef struct{
	s32	p1,p2;	// _f[^ւ̃CfbNX
	f32	length;	// XvOR
	f32	Ks;		// d
	f32	Kd;		// ܂
  }SPRING;
  typedef struct{
	C_Vec pos;	//ʒu
	C_Vec vel;	//x
	C_Vec force;	//
	f32	mass;//
	f32	InvMass;//ʂ̋t
	BIND_TYPE state;
	HSD_JObj *jobj;
	C_Vec org_dir;
	C_Vec org_trs;
	f32 org_len;
	f32 dumping;
	s32 hit_flg;
	C_Vec cp,cn,cv;
  }PARTICLE;
  typedef struct{
	PARTICLE* ptcl[4];
  }PATCH;
 private:
  s32 proc_counter;
  s32 grid_x,grid_y;
  s32 warp_counter;
  s32 num_ptcl;
  s32 num_spring;
  f32 const_spring;
  f32 const_dspring;
  C_Vec gravity;
  C_Vec wind;
  C_Vec warp_ofst;
  f32 constrain_pow;
  f32 constrain_pow_min;
  f32 dtime;
  PARTICLE *cur,*next,*ptcl_buf[2];
  SPRING *spring;
  vector<C_TrigonArray*> trigons;
	
  void Integrate( void );
  void ComputeForce( void );
  void ResolveCollision( void );
 public:
  //--- RXgN^ ---
  C_Cloth( s16 bone_num, s16 joint_num, HSD_JObj *jobj[] );

  //--- fXgN^ ---
  virtual ~C_Cloth();

  //--- s֐ ---
  void Proc(void);

  //--- \֐ ---
  void Disp(void);

  //--- ̌ ---
  void SetWind( C_Vec &w ){ wind = w; }

  //--- |S ---
  //|S𑼂̓ɂgȂ̂ŁA
  //|Ŝ͑ŎĂ炤B
  void AddTrigon( C_TrigonArray *t ){ trigons.push_back(t); }

  //p[^[ォZbgB
  void ResetParams( s16 bone_num, s16 joint_num, f32 params[][3] );

  //W΂ƂɕzLт̂hB
  //ړʂĂB
  inline void SetWarpOfst( const Vec &ofst_ ) { warp_ofst = ofst_;}
  inline void GetWarpOfst( Vec &ofst_ ) { ofst_ = warp_ofst; }

  void SetConstrainPow( f32 p_, f32 m_ ) { constrain_pow = p_; constrain_pow_min = m_; }
};

#endif


