#ifndef ___C_COBJ_H___
#define ___C_COBJ_H___

//#include "common.h"
#include "c_scenedesc.h"
#include "c_vec.h"

//sysdolphincobj̃bp[B
//
class C_CObj {
 public:
  //RXgN^
  //
  C_CObj(const C_CameraSet* cs) : camera_set(cs){
	cobj = HSD_CObjLoadDesc(camera_set->camdesc);
  }
  C_CObj() : camera_set(0){ cobj = HSD_CObjAlloc(); }

  //fXgN^
  //
  virtual ~C_CObj(){ if(cobj) HSD_CObjUnref(cobj); }

  //ANV̐B
  //
  u32 GetActionNum() const { return camera_set->GetActionNum(); }

  //ANVݒB
  //
  void SetAction(const char* name){
	HSD_CObjAddAnim(cobj, camera_set->GetAction(name));
	HSD_CObjReqAnim(cobj, 0.0f);
  }
  void SetAction(u32 no){
	HSD_CObjAddAnim(cobj, camera_set->GetAction(no));
	HSD_CObjReqAnim(cobj, 0.0f);
  }

  //Đp[^B
  //
  void SetRate(f32 rate){
	HSD_ForeachAnim(cobj, COBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetRate, AOBJ_ARG_AF, rate);
  }
  void SetCurrentFrame(f32 time){
	HSD_ForeachAnim(cobj, COBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetCurrentFrame, AOBJ_ARG_AF, time);
  }
  virtual void Proc(){ HSD_CObjAnim(cobj); }

  virtual bool DispStart(){
	int		rt = HSD_CObjSetCurrent(cobj);
	current = this;
	return rt != 0;
  }
  virtual void DispEnd(){
	HSD_CObjEndCurrent();
	current = 0;
  }
  static C_CObj* GetCurrent() { return current; }
  HSD_CObj *GetCObj( void ){ return cobj; }

  //aspect
  //
  f32 GetAspect( void ){ return HSD_CObjGetAspect( cobj ); }
  void SetAspect( f32 aspect ){ HSD_CObjSetAspect( cobj, aspect ); }

  //Fov
  //
  f32 GetFov( void ){ return HSD_CObjGetFov( cobj ); }
  void GetFov( f32 fov ){ HSD_CObjSetFov( cobj, fov ); }

  //mtx
  //
  MtxPtr GetMtx( void ){ return HSD_CObjGetViewingMtxPtr( cobj ); }
  MtxPtr GetInvMtx( void ){ return HSD_CObjGetInvViewingMtxPtr( cobj ); }

  //eye
  C_Vec& GetEyePos( void ){ HSD_CObjGetEyePosition( cobj, &v ); return (C_Vec&)v; }
  void SetEyePos( C_Vec& eye ){ HSD_CObjSetEyePosition( cobj, &eye ); }

  //interest
  C_Vec& GetInterest( void ){ HSD_CObjGetInterest( cobj, &v ); return (C_Vec&)v; }
  void SetInterest( C_Vec& interest ){ HSD_CObjSetInterest( cobj, &interest ); }

  //up
  C_Vec& GetUpVector( void ){ HSD_CObjGetUpVector( cobj, &v); return (C_Vec&)v; }
  void SetUpVector( C_Vec& up ){ HSD_CObjSetUpVector( cobj, &up ); }


 private:
  static C_CObj*		current;
  static C_Vec			v;
  const C_CameraSet*	camera_set;
  HSD_CObj*			cobj;
};
	
#endif
