#include "common.h"
#include "c_coll.h"
#include "utility.h"

#define	MTX_USE_PS
static
bool WithinTrigon( const Vec& vecPos, const Vec& vec0, const Vec& vec1, const Vec& vec2)
{
  Vec	nml;
  Vec	vt0, vt1, vt2;
	
#if 1
  PSVECSubtract((Vec*)&vec0, (Vec*)&vec1, &vt0);
  PSVECSubtract((Vec*)&vec1, (Vec*)&vec2, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &nml);	//O
#endif  
  f32		fa0, fa1, fa2;
  
  PSVECSubtract((Vec*)&vec1, (Vec*)&vec0, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec0, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa0 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  PSVECSubtract((Vec*)&vec2, (Vec*)&vec1, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec1, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa1 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  PSVECSubtract((Vec*)&vec0, (Vec*)&vec2, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec2, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa2 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  if ((fa0>=0 && fa1>=0 && fa2>=0) || (fa0<=0 && fa1<=0 && fa2<=0)) return true;

  return false;
}
static
u8 Line2Plane(const Vec& vecS, const Vec& vecE, 
			  const Vec& vecP, const Vec& vecNrm, Vec& vecInt)
{
  Vec	vt0, vt1;
  u8		ret = 0;
	
  PSVECSubtract((Vec*)&vecS, (Vec*)&vecP, &vt0);
  PSVECSubtract((Vec*)&vecE, (Vec*)&vecS, &vt1);
  
  f32 fs = PSVECDotProduct((Vec*)&vecNrm, (Vec*)&vecS);
  f32 fe = PSVECDotProduct((Vec*)&vecNrm, (Vec*)&vecE);
  f32 fb = PSVECDotProduct((Vec*)&vecNrm, (Vec*)&vecP);
  if(fs > fe && fs >= fb && fe <= fb){
	ret = 3;
	f32 l = (fs - fb)/(fs - fe);
	if(l < 0.0f)	l = 0.0f;
	if(l > 1.0f)	l = 1.0f;
	PSVECScale(&vt1, &vecInt, l);
	PSVECAdd(&vecInt, (Vec*)&vecS, &vecInt);
  }
	
  return ret;
}

class C_Nearest{
public:
  C_Vec pos,nrm,org;
  C_Trigon *trigon_ptr;
  s32 num;
  f32 dist;

  C_Nearest( C_Vec &o ) : org(o), num(0), dist(MAXFLOAT){
  }
  void Comp( C_Vec &p, C_Vec &n, C_Trigon *t ){
	//OSReport( "%f %f\n", org.Dist( pos ), org.Dist( p ) );
	//HSD_DmpVector( "", &p );
	f32 d = org.Dist(p);
	if( dist > d ){
	  //OSReport( "%d:: %f : %f\n", num, dist, d );
	  pos = p; nrm = n; trigon_ptr = t;
	  dist = d;
	  num++;
	}
  }
};

void C_Coll::Init( void )
{
  result = COLL_NONE;
  trigon_ptr = 0;
}
C_Coll::C_Coll( void )
{
  Init();
}

//todo
//is̓肾lqbgB
//{Ԃ͂ƂƂȂƁB
//#define CHEAT_VAL ((f32)(2.1f))
#define CHEAT_VAL ((f32)(0.001f))
C_Coll::C_Coll( C_TrigonArray &ta, C_Vec &p1_, C_Vec &p2_, f32 r, bool flg )
{
  Init();

  C_Vec p1 = p1_, p2 = p2_, p0;

  //p̃fǂ
  s32 move_flg = ta.status.dirty ? 3 : 1;

  //p̃fA
  //ĂȂ񂾂炠ȂB
  if( p2.Dist(p1) < FLT_EPSILON && move_flg==1 ) return;

  for( int type=0; type<2 && !result; type++ ){
	s32 col_type;
	if( type == 0 ){
	  //p̃fĂꍇA
	  //p̃fɁAn_߂荞ł܂ꍇ𔻒B
	  if( ta.status.dirty && flg ){
		//̏B
		//Pt[O̎n_𓖂pf̏WɎĂB
		//́A߂荞łȂƂۏ؂ꂽ_B(̃nYj
		MTXMultVec( ta.old_inv_mtx, &p1_, &p1 );
		MTXMultVec( ta.cur_inv_mtx, &p1_, &p2 );
		col_type = COLL_TYPE2;
	  }else continue;
	}else{
	  //n_߂荞ł͂Ȃ̂Œʏ폈B
	  //̏B
	  //𓖂pf̏WɎčsB
	  MTXMultVec( ta.cur_inv_mtx, &p1_, &p1 );
	  MTXMultVec( ta.cur_inv_mtx, &p2_, &p2 );
	  col_type = COLL_TYPE1;
	}

	C_Vec line = p2 - p1;
	f32 len = line.Mag();
	if( len > FLT_EPSILON ){
	  line.Nrm();
	  C_3DBBOX bbox;
	  bbox.SetUp( p1, p2 );
	  bbox.AddRegion( r );

	  C_Nearest near(p1);

	  //todo
	  //S|SBoJۂB
	  s32 c=0;
	  for( u32 i=0; i<ta.GetNum(); i++ ){
		C_Trigon &t = ta.trigon[i];
		C_3DBBOX tbbox = t.GetBBox();
		C_Vec tnrm = t.GetNrm();
		C_Vec tctr = t.GetCtr();
		C_Vec *tp = t.GetVtx();
		s32 res = 0;
	  
		//3p`ƐƂ̃oEfBO{bNXB
		//
		if( tbbox.min_x > bbox.max_x || tbbox.max_x < bbox.min_x ||
			tbbox.min_y > bbox.max_y || tbbox.max_y < bbox.min_y ||
			tbbox.min_z > bbox.max_z || tbbox.max_z < bbox.min_z ){
		  c++;
		  continue;
		}
	  
		//؂؂̃f͖ƌO
		if( VECDotProduct( &line, &tnrm ) >= .0f ) continue;
	  
		//ƖʂƂ̓蔻B
		//
		//ao点B
		C_Vec ctr = tctr + tnrm*r;
		//p0 (44.559353 1903.490723 -817.552612)
		//p1 (44.508556 1903.490723 -826.025513)
		//p2 (165.389954 1903.490723 -826.025513)

		if( 2 <= Line2Plane( p1, p2, ctr, tnrm, pos ) &&
			WithinTrigon( pos, tp[0], tp[1], tp[2] ) ){
		  
#if 0
		  if( i == 26 ){
			HSD_DmpVector( "tp[0]", &tp[0] );
			HSD_DmpVector( "tp[1]", &tp[1] );
			HSD_DmpVector( "tp[2]", &tp[2] );
		  }
#endif
		  nrm = tnrm;
		  res = col_type;
		  trigon_ptr = &t;
		}
		if( res ){
		  near.Comp( pos,nrm,trigon_ptr );
		  result = res;
		  //OSReport( "normal\n" );
		  //OSReport( "%d\n", i );
		  continue;
		}
		if( r == 0.f ) continue;
	  
		//ƕӂ̂蔻B
		//
		for(int j = 0; j < 3; j++){
		  Vec		n, n0, n1, tt;
		  float		l, tl, tl2, tl3;
		
		  //Pӂ̖@xNgBn
		  VECSubtract(&tp[(j+1)%3], &tp[j], &n);
		  l = VECMag(&n);
		  VECScale(&n, &n, 1.0f/l);
		
		  //ƁAӂɑ΂ĐȃxNgn0
		  VECScale(&n, &n1, VECDotProduct(&line, &n));
		  VECSubtract(&line, &n1, &n1);
		  VECNormalize(&n1, &n1);
		  VECCrossProduct(&n, &n1, &n0);
		
		  //ƁAӂ̒[_񂾂̂ƓсB
		  VECSubtract(&tp[j], &p1, &tt);
		  tl = VECDotProduct(&tt, &n0);
		  if(fabsf(tl) <= r && (tl2 = VECDotProduct(&line, &n1)) != 0.0f){
			float		ds, d;

			tl3 = VECDotProduct(&tp[j], &n1);
			d = sqrtf(r*r - tl*tl);
			if((ds = VECDotProduct(&p1, &n1)) <= tl3
			   && VECDotProduct(&p2, &n1) >= tl3-d){
			  d = (tl3 - ds - d)/tl2;
			  if(d < 0.0f)	d = 0.0f;
			  if(d > len)	d = len;
			  VECScale(&line, &tt, d);
			  VECAdd(&tt, &p1, &tt);
			  tl2 = VECDotProduct(&n, &tt);
			  if(VECDotProduct(&n, &tp[j]) <= tl2 && 
				 VECDotProduct(&n,&tp[(j+1)%3]) >= tl2 ){
				pos = tt;
				trigon_ptr = &t;
				VECSubtract(&tt, &tp[j], &tt);
				VECScale(&n, &n, VECDotProduct(&n,&tt));
				VECSubtract(&tt,&n,&n);
				VECNormalize(&n, &n);
				nrm = n;
				res = col_type;
				break;
			  }
			}
		  }
		}
		if( res ){
		  near.Comp( pos,nrm,trigon_ptr );
		  result = res;
		  //OSReport("edge\n");
		  continue;
		}
	
#if 1
		//Ɠ_̓蔻
		for(int j = 0; j < 3; j++){
		  Vec		n, n0, tt;
		  float		tl;
		
		  //n__ւ̃xNgB
		  VECSubtract(&tp[j], &p1, &n0);
		  VECScale(&line, &n, VECDotProduct(&line, &n0));
		  VECSubtract(&n, &n0, &tt);
		  //̂Q
		  tl = tt.x*tt.x + tt.y*tt.y + tt.z*tt.z;
		  if((tl = r*r - tl) >= 0.0f){
			VECScale(&line, &tt, sqrtf(tl));
			VECSubtract(&n, &tt, &n);
			tl = VECDotProduct(&line, &n);
			if(0.0f < tl && tl <= len){
			  VECAdd(&n, &p1, &pos);
			
			  trigon_ptr = &t;
			  VECSubtract(&pos, &tp[j], &n);
			  VECNormalize(&n, &n);
			  nrm = n;
			  res = col_type;
			  break;
			}
		  }
		}
		if( res ){
		  near.Comp( pos,nrm,trigon_ptr );
		  result = res;
		  continue;
		}
#endif
	  }
	  //OSReport( "%d / %d\n", c, ta.GetNum() );
	  if( result ){
		pos = near.pos;
		nrm = near.nrm;
		trigon_ptr = near.trigon_ptr;
	  }
	}
  }

  if( result ){
	C_Vec dir = nrm, pos0 = pos;
	dir *= CHEAT_VAL;
	pos0 = pos0 + dir;
	
	MTXMultVecSR( ta.cur_mtx, &nrm, &nrm );
	MTXMultVec( ta.cur_mtx, &pos0, &pos );

	if( result == COLL_TYPE2 ){
	  MTXMultVec( ta.old_mtx, &pos0, &pos0 );
	  //̍WntB
	  vel = pos0 - pos;
	}
  }
}
