#include "common.h"
#include "c_debri.h"

u32 C_Debri::num_all = 0;
bool C_Debri::wait_flg = false;

C_Debri::C_Debri( HSD_JObj *_gen, C_Vec &_dir, C_Vec &_target, HSD_JObj *_mdl, 
				  f32 _speed, f32 _force, f32 _r, s32 _life, bool _ret )
{
  mdl_jobj = _mdl;
  gen_jobj = _gen;
  HSD_JObjSetupMatrix( _gen );
  HSD_MtxGetTranslate( _gen->mtx, &pos );
  dir = _dir;
  tgt_pos = _target;
  speed = _speed;
  force = _force;
  ret = _ret;
  radius = _r;
  state.Init( ON_MARK );
  org_dir = tgt_pos - pos;
  life = _life;
  rot.x = 0;
  rot.y = 0;
  rot.z = HSD_Rand()%180;
  gen = 0;
  no = (s32)num_all++;
  start_wait = (s32)((1.f - force) * 400) + HSD_Rand() % 120;
  wait_flg = false;
}
C_Debri::~C_Debri()
{
  if( gen ) delete gen;
}
void C_Debri::AddParticle( s32 id )
{
  if( gen ) delete gen;
  C_Vec dummy;
  gen = new C_Generator( dummy, id );
  gen->Fire();
}
void C_Debri::ResetTarget( C_Vec &target )
{
  tgt_pos = target;
  org_dir = tgt_pos - pos;
}
s32 C_Debri::GetState( void )
{
  return (s32)state;
}
void C_Debri::SetOfstPos( C_Vec &p_ )
{
  C_Vec ofst_(8.f,0.f,0.f);
  Mtx m_;
  f32 r_ = (360 / 6) * (no%6) + 30.f + state.GetPhaseCounter() * force * 80.f;
  MTXRotDeg( m_, 'z', r_ );
  MTXMultVec( m_, &ofst_, &p_ );
}
void C_Debri::Proc( const C_Vec &tgt_ )
{
  do{
	switch( (s32)state ){
	case ON_MARK:{
	  switch( state.GetPhase() ){
	  case PHASE_CTOR:{
		tgt_pos = pos;
		tgt_pos.y += 19.f;
	  }break;
	  case PHASE_PROC:{
		C_Vec ofst_;
		SetOfstPos( ofst_ );
		C_Vec t_ = tgt_pos + ofst_;
		C_Vec dir_ = t_ - pos;
		if( dir_.Mag() < 2.f ){
		  state = READY;
		}else{
		  dir_ *= 0.5f;
		  pos += dir_;
		}
	  }break;
	  case PHASE_DTOR:{
	  }break;
	  }
	}break;
	case READY:{
	  switch( state.GetPhase() ){
	  case PHASE_CTOR:{
	  }break;
	  case PHASE_PROC:{
		if( --start_wait < 0 ){
		 if( !wait_flg ) state = RUN;
		}
		C_Vec ofst_;
		SetOfstPos( ofst_ );
		C_Vec t_ = tgt_pos + ofst_;
		C_Vec dir_ = t_ - pos;
		dir_ *= 0.5f;
		pos += dir_;
		//OSReport( "%d\n", start_wait );
	  }break;
	  case PHASE_DTOR:{
	  }break;
	  }
	}break;
	case RUN:{
	  switch( state.GetPhase() ){
	  case PHASE_CTOR:{
		//ŏB
		tgt_pos = tgt_;
	  }break;
	  case PHASE_PROC:{
		C_Vec dir_ = tgt_pos - pos;
		dir_.Nrm();
		dir_ *= 1.f;
		pos += dir_;
		if( tgt_pos.Dist( pos ) < radius )	state = HIT;
		{
		  C_Vec dir1_ = tgt_; dir1_ -= pos;
		  if( ret==false && (dir1_ | dir_) < 0.f )	state = FAIL;
		}
	  }break;
	  case PHASE_DTOR:{
	  }break;
	  }
	}break;
	case HIT:{
	  switch( state.GetPhase() ){
	  case PHASE_CTOR:{
		if( gen ) delete gen;
		gen = 0;
	  }break;
	  case PHASE_PROC:{
	  }break;
	  case PHASE_DTOR:{
	  }break;
	  }
	}break;
	case FAIL:{
	  switch( state.GetPhase() ){
	  case PHASE_CTOR:{
		if( gen ) delete gen;
		gen = 0;
	  }break;
	  case PHASE_PROC:{
	  }break;
	  case PHASE_DTOR:{
	  }break;
	  }
	}break;
	}
  }while( !state.Proc() );


  rot.z += (15.f + ((HSD_Rand()%100) / 100.f) * 15.f);
  if( gen ){
	gen->SetPos( pos );
	gen->SetRot( rot );
  }


#if 0
  if( life > 0 ){
	//Ԑ؂
	life--;
	if( life == 0 ) state = FAIL;
  }

  if( tgt_pos.Dist( pos ) < radius ){
	//B
	state = HIT;
  }else if( ret==false && (org_dir | dir) < 0.f ){
	//sB
	state = FAIL;
  }else{
	//ǔB
	C_Vec aim = tgt_pos - pos;
	C_Vec axis;
	aim.Nrm();

	f32 dpro = ( dir | aim );
	f32 r = acosf( dpro );
	if( !isnan(r) ){//dpro==1.ft߂łȓ̂ŁB
#if 0
	  if( isnan(r) ) {
		OSReport( "%f\n", dpro );
		HSD_DmpVector( "dir", &dir );
		HSD_DmpVector( "aim", &aim );
	  }
#endif
	  //OSReport( "acos %f", r );
	  axis = dir & aim;
	  if( !axis.IsZero() ){
		//HSD_DmpVector( "axis", &axis );
		Mtx m;
		MTXRotAxisRad( m, &axis, r * force );
		MTXMultVecSR( m, &dir, &dir );
		//HSD_DmpVector( "dir", &dir );
	  }
	}
	C_Vec add = dir * speed;
	pos += add;
	if( !pos.IsValid() ) state = FAIL;

	//rot.x += 30.f;
	//rot.y += 30.f;
	rot.z += (15.f + ((HSD_Rand()%100) / 100.f) * 15.f);

	if( gen ){
	  //HSD_JObj *jobj = gen->GetJObj();
	  //HSD_JObjSetUserDefinedMtx( jobj, m );
	  gen->SetPos( pos );
	  gen->SetRot( rot );
	}
  }
#endif
}
void C_Debri::Disp( void )
{
  //ANeBułΕ\B
  if( (s32)state == ON_MARK ||
	  (s32)state == READY ||
	  (s32)state == RUN ){
	if( mdl_jobj ){
	  Mtx t,s,r,ry,rz,m;
#pragma unused(rz,r,ry)
	  //MTXRotDeg( r, 'x', rot.x );
	  //MTXRotDeg( ry, 'y', rot.y );
	  //MTXRotDeg( rz, 'z', rot.z );
	  //MTXConcat( r, ry, r );
	  //MTXConcat( r, rz, r );
	  MTXRotDeg( r, 'z', rot.z );
	  MTXScale( s, radius, radius, radius );
	  MTXTrans( t, pos.x, pos.y, pos.z );
	  MTXConcat( t, s, m );
	  MTXConcat( m, r, m );
	  HSD_JObjSetUserDefinedMtx( mdl_jobj, m );
	  HSD_JObjDispAll(mdl_jobj, 0, HSD_TRSP_ALL, 0);
	  
	}else{
	  HSD_CObj *cobj = HSD_CObjGetCurrent();

	  GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );
	  
	  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
	  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
	  GXSetNumTevStages(1);
	  GXSetNumTexGens(0);
	  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
	  GXSetChanCtrl(GX_COLOR0A0,
					GX_DISABLE,		// enable channel
					GX_SRC_REG,		// amb source
					GX_SRC_REG,		// mat source
					GX_LIGHT_NULL,	// light mask
					GX_DF_CLAMP,	// diffuse function
					GX_AF_NONE);
	  GXSetNumChans(1);
	  GXColor col={255,127,127,255};
	  GXSetChanMatColor( GX_COLOR0A0, col );
	  GXSetChanAmbColor( GX_COLOR0A0, col );
	  
	  GXSetColorUpdate( GX_TRUE );
	  GXSetCullMode( GX_CULL_BACK );
	  GXSetAlphaUpdate( GX_FALSE );
	  GXSetDstAlpha( GX_FALSE, 0 );
	  
	  Mtx t,s,m;
	  f32 scl;
	  scl = radius;
	  MTXScale( s, scl, scl, scl );
	  MTXTrans( t, pos.x, pos.y, pos.z );
	  MTXConcat( t, s, m );
	  MTXConcat( HSD_CObjGetViewingMtxPtr(cobj), m, m );
	  GXLoadPosMtxImm( m, GX_PNMTX0);
	  GXSetCurrentMtx( GX_PNMTX0 );
	  GXDrawSphere( 16,16 );
	  HSD_StateInvalidate( HSD_STATE_ALL );
	}
  }
}

bool C_Debri::IsHit( C_Vec &hit_pos, f32 r_ )
{
  if( pos.Dist( hit_pos ) < (radius+r_) ) return true;
  else return false;
}
