#ifndef ___C_DEBRI_H___
#define ___C_DEBRI_H___
//#include "common.h"
#include "c_particle.h"
#include "c_vec.h"
#include "c_state.h"

class C_Debri{
 public:
  enum {
	ON_MARK,
	READY,
	RUN,
	HIT,
	FAIL,
  };
	
  C_Debri( HSD_JObj *_gen, C_Vec &_dir, C_Vec &_target, HSD_JObj *_mdl=0, f32 _speed = 0.1f, 
		   f32 _force = 0.01f, f32 _r = 1.f, s32 _life = -1, bool _ret = false  );
  ~C_Debri();
  void ResetTarget( C_Vec &target );
  void AddParticle( s32 id );
					  
  s32 GetState( void );
  bool IsHit( C_Vec &hit_pos, f32 r_ = 0.f );
  C_Vec &GetPos( void ){ return pos;}
  C_Vec &GetRot( void ){ return rot;}
  void Proc( const C_Vec &tgt_ );
  void Disp( void );
  static void SetWaitFlg( bool f_ ){ wait_flg = f_; }
 protected:
  HSD_JObj *gen_jobj,*mdl_jobj;
  C_Vec tgt_pos,pos,dir,org_dir,rot;
  f32 speed,force,radius;
  C_Generator *gen;
  C_State state;
  bool ret;
  s32 life;
  s32 no;
  s32 start_wait;
  static u32 num_all;
  static bool wait_flg;
  void SetOfstPos( C_Vec &p_ );
 private:
};

#endif
