#include "common.h"
#include "c_edgeshadow.h"
#include "c_pesetup.h"
#include "utility.h"
#if K7
#include "../Wat/WK7Model.h"
#endif
static
void DrawSquare( C_Vec p[], u32 col, u32 flg )
{
  if( !flg ){
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);
	for( int i=0; i<4; i++ ){
	  GXPosition3f32(p[i].x, p[i].y, p[i].z);
	  GXColor1u32(col);
	}
	GXEnd();
  }
  else{
	GXSetLineWidth( (u8)16,GX_TO_ZERO );
	GXBegin( GX_LINESTRIP, GX_VTXFMT0, 5 );
	for( int i=0; i<5; i++ ){
	  GXPosition3f32(p[i%4].x, p[i%4].y, p[i%4].z);
	  GXColor1u32(col);
	}
	GXEnd();
  }
}
C_EdgeShadow::C_EdgeShadow( C_Vec& e, u8 s, f32 len )
{
  SetEyePos( e );
  ray_len = len;
  edge_num = 0;
  jobj_num = 0;
#if K7
  wk7jobj_num = 0;
#endif
  shadow_col = s;
  //TCY̓płŕςĂ炤B
  u32 size = GXGetTexBufferSize(640, 480, GX_TF_I8, GX_FALSE, 0);
  ghmGcMemSetAllocName("C_EdShTx");
  tex = new u8[ size ];
  GXInitTexObj( &texobj, tex, 640,480, GX_TF_I8, GX_CLAMP, GX_CLAMP, GX_FALSE );
  GXInitTexObjLOD(&texobj, GX_NEAR, GX_NEAR, 0, 0, 0, 0, 0, GX_ANISO_1);
}
C_EdgeShadow::C_EdgeShadow( void )
{
  ray_len = 0.f;
  edge_num = 0;
  jobj_num = 0;
  shadow_col = 0;
  //TCY̓płŕςĂ炤B
  u32 size = GXGetTexBufferSize(640, 480, GX_TF_I8, GX_FALSE, 0);
  ghmGcMemSetAllocName("C_EdShTx");
  tex = new u8[ size ];
  GXInitTexObj( &texobj, tex, 640,480, GX_TF_I8, GX_CLAMP, GX_CLAMP, GX_FALSE );
  GXInitTexObjLOD(&texobj, GX_NEAR, GX_NEAR, 0, 0, 0, 0, 0, GX_ANISO_1);
}
C_EdgeShadow::~C_EdgeShadow()
{
  if( tex ) delete tex;
}

void C_EdgeShadow::Add( C_EdgeArray& e )
{
  edges.push_back( &e );
  edge_num++;
}
void C_EdgeShadow::Add( HSD_JObj *j )
{
  jobjs.push_back( j );
  jobj_num++;
}

bool C_EdgeShadow::Delete( HSD_JObj *j )
{
  vector<HSD_JObj*>::iterator	i;
  for(i=jobjs.begin() ; i!=jobjs.end() ; i++){
	if( *i==j ){
	  jobjs.erase(i);
	  jobj_num--;
	  return true;
	}
  }
  return false;
//  int	i;
//  for(i=0 ; i<jobj_num ; i++){
//	if( jobjs[i]==j ){
//	  jobjs.erase(i);
//	  return true;
//	}
//  }
//  return false;

//  jobjs.erase(j);
//  return true;
}
#if K7
void C_EdgeShadow::Add( WK7JObj *j )
{
  wk7jobjs.push_back( j );
  wk7jobj_num++;
}
bool C_EdgeShadow::Delete( WK7JObj *j )
{
  vector<WK7JObj*>::iterator	i;
  for(i=wk7jobjs.begin() ; i!=wk7jobjs.end() ; i++){
	if( *i==j ){
	  wk7jobjs.erase(i);
	  wk7jobj_num--;
	  return true;
	}
  }
  return false;
//  int	i;
//  for(i=0 ; i<jobj_num ; i++){
//	if( jobjs[i]==j ){
//	  jobjs.erase(i);
//	  return true;
//	}
//  }
//  return false;

//  jobjs.erase(j);
//  return true;
}
#endif

void C_EdgeShadow::Proc( void )
{
  bool flg = false;
  if( eye_pos != old_eye_pos ){
	flg = true;
	old_eye_pos = eye_pos;
  }

  for( u32 i=0; i<edge_num; i++ ){
	edges[i]->Proc();
	//fACgꍇ
	//\ČvZB
	if( flg || edges[i]->IsDirty() ){
	  edges[i]->RecalcFlg( eye_pos );
	}
  }
}

void C_EdgeShadow::DispStart( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  GXSetColorUpdate( GX_FALSE );
  GXSetAlphaUpdate( GX_TRUE );
  GXSetZMode( GX_TRUE, GX_LEQUAL, GX_FALSE );

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );

  if( edge_num ){
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel(CeBOȂj
				  GX_SRC_VTX,		// amb source
				  GX_SRC_VTX,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);

	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  }else if( jobj_num ){
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel(CeBOȂj
				  GX_SRC_REG,		// amb source
				  GX_SRC_REG,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
#if !K7
  }
#else
  }else if( wk7jobj_num ){
	GXSetChanCtrl(GX_COLOR0A0,
				  GX_DISABLE,		// enable channel(CeBOȂj
				  GX_SRC_REG,		// amb source
				  GX_SRC_REG,		// mat source
				  GX_LIGHT_NULL,	// light mask
				  GX_DF_CLAMP,	// diffuse function
				  GX_AF_NONE);
	GXSetDither(GX_FALSE);
  }
#endif
  GXSetNumChans(1);
  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_EdgeShadow::DispEnd( void )
{
  //eNX`ƂāAAt@Rs[B
  //TCY̓płŕςĂ炤B
  GXSetTexCopySrc(0, 0, 640, 480);
  GXSetTexCopyDst(640, 480, GX_CTF_A8, GX_FALSE);
  GXSetColorUpdate( GX_FALSE );
  GXSetAlphaUpdate( GX_TRUE );
  GXCopyTex(tex, GX_TRUE);
  GXPixModeSync();
  GXInvalidateTexAll();

  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_EdgeShadow::Disp( u32 idx, u32 flg, u32 col )
{
  if( edge_num ){
	col = ((u32)(col & 0xffffff00)) | ((u8)shadow_col);
	u32 edge_num = edges[idx]->GetNum();
	C_TrigonArray& trigon = edges[idx]->GetTrigon();
	C_Vec vtx[MAX_EDGE_NUM][4];
  
	u32 num = 0;
	for( u32 i=0; i<edge_num; i++ ){
	  C_Edge& e = edges[idx]->GetEdge( i );
	  if( e.GetFlg() ){
		C_Vec dir0,dir1;
		C_Vec* v = vtx[num++];
		
		if( e.GetFlg() == 1 ){
		  v[0] = e.GetVtx(0); v[1] = e.GetVtx(1);
		}else{
		  v[0] = e.GetVtx(1); v[1] = e.GetVtx(0);
		}
		MTXMultVec(trigon.GetMtx(), &v[0], &v[0]);
		MTXMultVec(trigon.GetMtx(), &v[1], &v[1]);
		dir0 = v[0] - eye_pos; dir0 *= (ray_len/v[0].Mag());
		dir1 = v[1] - eye_pos; dir1 *= (ray_len/v[1].Mag());
		v[3] = v[0] + dir0;
		v[2] = v[1] + dir1;
		ASSERT2( (num < MAX_EDGE_NUM), "Too many Edges." ) ;
	  }
	}

	//\ʕ`B
	GXSetCullMode( GX_CULL_BACK );
	GXSetBlendMode(GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	//GXSetDstAlpha( GX_TRUE, shadow_col );
	for( u32 i=0; i<num; i++ ){
	  DrawSquare( vtx[i], col, 0 );
	}

	//ʕ`B
	GXSetCullMode( GX_CULL_FRONT );
	GXSetBlendMode(GX_BM_SUBTRACT, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	//GXSetDstAlpha( GX_TRUE, 255 );
	for( u32 i=0; i<num; i++ ){
	  DrawSquare( vtx[i], col, 0 );
	}

	//fobOp̐B
	if( flg ){
	  GXSetColorUpdate( GX_TRUE );
	  GXSetAlphaUpdate( GX_FALSE );
	  for( u32 i=0; i<num; i++ ){
		DrawSquare( vtx[i], col, 1 );
	  }
	  GXSetColorUpdate( GX_FALSE );
	  GXSetAlphaUpdate( GX_TRUE );
	}
  }else if( jobj_num ){
	//J[ݒB
	GXColor c;
	c.r = (u8)(((u32)(col & 0xff000000))>>24);
	c.g = (u8)(((u32)(col & 0xff0000))>>16);
	c.b = (u8)(((u32)(col & 0xff00))>>8);
	c.a = (u8)(((u32)(col & 0xff))>>0);
	GXSetChanMatColor( GX_COLOR0A0, c );
	shadow_col = c.a;
	//\ʕ`B
	{
	  GXSetCullMode( GX_CULL_BACK );
	  GXSetBlendMode(GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	  HSD_JObjDispAll(jobjs[idx], 0, HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
	}

	//ʕ`B
	{
	  GXSetCullMode( GX_CULL_FRONT );
	  GXSetBlendMode(GX_BM_SUBTRACT, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	  HSD_JObjDispAll(jobjs[idx], 0, HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
	}
#if !K7
  }
#else
  }else if( wk7jobj_num ){
	//J[ݒB
	GXColor c;
	c.r = (u8)(((u32)(col & 0xff000000))>>24);
	c.g = (u8)(((u32)(col & 0xff0000))>>16);
	c.b = (u8)(((u32)(col & 0xff00))>>8);
	c.a = (u8)(((u32)(col & 0xff))>>0);
	GXSetChanMatColor( GX_COLOR0A0, c );
	shadow_col = c.a;
	//\ʕ`B
	{
	  GXSetCullMode( GX_CULL_BACK );
	  GXSetBlendMode(GX_BM_BLEND, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	  wk7jobjs[idx]->RenderProcess(false,true,HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
	}

	//ʕ`B
	{
	  GXSetCullMode( GX_CULL_FRONT );
	  GXSetBlendMode(GX_BM_SUBTRACT, GX_BL_ONE, GX_BL_ONE, GX_LO_CLEAR);
	  wk7jobjs[idx]->RenderProcess(false,true,HSD_TRSP_OPA, RENDER_SHADOW|RENDER_EFFECT);
	}
  }
#endif

}


void C_EdgeShadow::DispShadow( u32 color )
{
  //JݒB
  GXRenderModeObj *rmode = HSD_VIGetConfigure();
  HSD_CObj *cobj = HSD_CObjAlloc();
  HSD_CObjSetProjectionType(cobj, COBJ_PROJECTION_ORTHO);
  HSD_CObjSetViewportfx4(cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetScissorx4  (cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetNear (cobj,   0.0F);
  HSD_CObjSetFar  (cobj, 200.0F);
  HSD_CObjSetOrtho(cobj, 0.f, (f32)(rmode->viHeight), 0.f, (f32)(rmode->viWidth));
  Vec	eyepos   = {0.0f, 0.0f, 100.0f};
  Vec	interest = {0.0f, 0.0f,   0.0f};
  Vec	up       = {0.0f, 1.0f,   0.0f};
  Mtx	mtxView;
  MTXLookAt(mtxView, &eyepos, &up, &interest);
  HSD_CObjSetUserDefinedMtx(cobj, mtxView);
	
  //`lB
  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);
	
    //eNX`
  GXLoadTexObj(&texobj, GX_TEXMAP0);

  GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
  GXSetNumTexGens(1);

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
  //F̓`l̂̂gB
  GXSetTevColorIn( GX_TEVSTAGE0, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC );
  GXSetTevColorOp( GX_TEVSTAGE0, GX_TEV_ADD, GX_TB_ZERO, 
				   GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV );
  //At@̓eNX`̂̂gB
  //̂ƂAshadow_colɓB
  //GXColor col = {0,0,0,shadow_col};
  GXColor col = {0,0,0,(u8)(color & 0xff)};
//  GXColor col = {0,0,0,shadow_col};
  GXSetTevColor( GX_TEVREG0, col );
  GXSetTevAlphaIn( GX_TEVSTAGE0, GX_CA_TEXA, GX_CA_ZERO, GX_CA_A0, GX_CA_ZERO );
  GXSetTevAlphaOp( GX_TEVSTAGE0, GX_TEV_COMP_A8_GT, GX_TB_ZERO, 
				   GX_CS_SCALE_1, GX_FALSE, GX_TEVPREV );
  GXSetNumTevStages(1);

  //PE
  GXSetBlendMode(GX_BM_BLEND, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);

  GXSetZMode( GX_DISABLE, GX_ALWAYS, GX_DISABLE );
  GXSetAlphaUpdate( GX_DISABLE );
  GXSetColorUpdate( GX_ENABLE );
  GXSetCullMode( GX_CULL_BACK );
	
  if (HSD_CObjSetCurrent(cobj)) {
	Mtx	mat;
	MTXIdentity(mat);
    GXLoadPosMtxImm(mat, GX_PNMTX0);
	GXSetCurrentMtx( GX_PNMTX0 );
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	#define	ZMID -0.5f
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);
		GXPosition3f32((f32)0, (f32)0, ZMID);
		GXColor1u32( color );
//		GXColor4u8( 0, 0, 0, 0 );
		GXTexCoord2f32(0,0);

		GXPosition3f32((f32)0+(f32)rmode->viWidth, (f32)0, ZMID);
		GXColor1u32( color );
//		GXColor4u8( 0, 0, 0, 0 );
		GXTexCoord2f32(1,0);

		GXPosition3f32((f32)0+(f32)rmode->viWidth, 
					   (f32)0+(f32)rmode->viHeight, ZMID);
		GXColor1u32( color );
//		GXColor4u8( 0, 0, 0, 0 );
		GXTexCoord2f32(1,1);

		GXPosition3f32((f32)0, (f32)0+(f32)rmode->viHeight, ZMID);
		GXColor1u32( color );
//		GXColor4u8( 0, 0, 0, 0 );
		GXTexCoord2f32(0,1);
	GXEnd();

	HSD_CObjEndCurrent();
  }
  HSD_CObjUnref( cobj );

  GXSetZMode( GX_ENABLE, GX_LEQUAL, GX_ENABLE );
  GXSetAlphaUpdate( GX_DISABLE );
  GXSetDither(GX_TRUE);

  HSD_StateInvalidate(HSD_STATE_ALL);
}





