#ifndef ___C_EDGESHADOW_H___
#define ___C_EDGESHADOW_H___

//#include "common.h"
#include "c_edge.h"

#define K7 1
#if K7
//#include "../Wat/WK7Model.h"
class WK7JObj;
#endif

#define kDefaultRayLength 100.f

class C_EdgeShadow{
 public:
  C_EdgeShadow( C_Vec& e, u8 s = 128, f32 len = kDefaultRayLength );
  C_EdgeShadow( void );
  ~C_EdgeShadow();
  void Add( C_EdgeArray& e );
  void Add( HSD_JObj *j );
  bool Delete( HSD_JObj *j );
#if K7
  void Add( WK7JObj *j );
  bool Delete( WK7JObj *j );
#endif
  void Proc( void );
  void SetEyePos( C_Vec& e ){ old_eye_pos = eye_pos; eye_pos = e; }
  void DispStart( void );
  void DispEnd( void );
  void Disp( u32 idx, u32 flg=0, u32 col=(u32)(0x88<<24 | 0xff<<16 | 0x88<<8 |0x88) );
  void DispAll( u32 flg = 0 ,u32 col=(u32)(0x88<<24 | 0xff<<16 | 0x88<<8 |0x88) ){
	DispStart();
	for( int i=0; i<edge_num; i++ ){
	  Disp( (u32)i, flg ,col);
	}
	for( int i=0; i<jobj_num; i++ ){
	  Disp( (u32)i, flg ,col);
	}
#if K7
	for( int i=0; i<wk7jobj_num; i++ ){
	  Disp( (u32)i, flg ,col);
	}
#endif
	DispEnd();
  }
  void DispShadow( u32 col );
 private:
  enum {
	MAX_EDGE_NUM = 1000
  };
  C_Vec eye_pos;
  C_Vec old_eye_pos;
  f32 ray_len;
  s32 edge_num;
  s32 jobj_num;
  u8 shadow_col;	
  vector<C_EdgeArray*> edges;
  vector<HSD_JObj*> jobjs;
#if K7
  s32 wk7jobj_num;
  vector<WK7JObj*> wk7jobjs;
#endif
  u8 *tex;
  GXTexObj texobj;
};













#endif
