#include "common.h"
#include "c_envelope.h"

C_Envelope::C_Envelope( HSD_JObj *_jobj )
{
  jobj = _jobj;
  HSD_DObj *dobj;
  HSD_PObj *pobj;
  num_pobj = 0;

  for (dobj = HSD_JObjGetDObj(jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	for( pobj = HSD_DObjGetPObj(dobj); pobj; pobj = HSD_PObjGetNext(pobj) ){
	  num_pobj++;
	}
  }

  pobjs = new C_EnvelopePObj[ num_pobj ];
  for(int i=0 ; i<num_pobj ; i++){
	pobjs[i].pobj   = NULL;
	pobjs[i].trigon = NULL;
  }

  s32 counter=0;
  for (dobj = HSD_JObjGetDObj(jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	for( pobj = HSD_DObjGetPObj(dobj); pobj; pobj = HSD_PObjGetNext(pobj) ){
	  //}gbNẌ̗B
	  //́AVFCvȊÔonai͎gĂȂ炱ł悢B
	  pobj->aobj = (HSD_AObj*)new Mtx [10];
	  for( int i=0; i<3*4*10; i++ ){
		f32 *tmp = (f32*)pobj->aobj;
		tmp[i] = 0.f;
	  }
	  pobjs[counter].pobj = pobj;
	  //C_TrigonArray͓őSonaiĂ܂.
	  //jobjɂmtkkw肷邱ƂŁApobjȂȂB
	  pobjs[counter].trigon = new C_TrigonArray( pobj, (HSD_JObj*)0 );
	  counter++;
	}
  }

}

C_Envelope::~C_Envelope()
{
  for( int i=0; i<num_pobj; i++ ){
	if( pobjs[i].pobj->aobj != NULL ){
	  delete [] pobjs[i].pobj->aobj;
	  pobjs[i].pobj->aobj = NULL;
	}
	if( pobjs[i].trigon != NULL ){
	  delete pobjs[i].trigon;
	  pobjs[i].trigon = NULL;
	}
  }
  delete [] pobjs;
}

s32 C_Envelope::GetTrigonNum( void )
{
  s32 trigon_num = 0;
  for( u32 i=0; i< num_pobj; i++ ){
	trigon_num += pobjs[i].trigon->GetNum();
  }
  return trigon_num;
}

bool C_Envelope::IsReady( void )
{
  bool flg = false;
  for( u32 i=0; i< num_pobj; i++ ){
	HSD_PObj *pobj = pobjs[i].pobj;
	f32 *mtx = (f32*)pobj->aobj;
	for( int j=0; j<3*4*10; j++ ){
	  if( mtx[j] != 0.f ){ flg = true; break; }
	}
  }
  return flg;
}
C_Trigon &C_Envelope::GetTrigon( s32 idx )
{
  s32 trigon_num = 0;
  for( u32 i=0; i< num_pobj; i++ ){
	HSD_PObj *pobj = pobjs[i].pobj;
	//f32 *mtx = (f32*)pobj->aobj;
	Mtx *mtx = (Mtx*)pobj->aobj;
	//B
	if( (trigon_num + pobjs[i].trigon->GetNum() ) > idx ){
	  idx -= trigon_num;
	  C_Trigon &tri = pobjs[i].trigon->GetTrigon((u32)idx);
	  C_Vec *src, dst[3];
	  s16 *mtx_idx;
	  
	  src = tri.GetVtx();
	  mtx_idx = tri.GetMtxIdx();
	  
	  for( u32 k=0; k<3; k++ ){
		//MTXMultVec( (MtxPtr)&mtx[ mtx_idx[k] * 3 * 4 ], &src[k], &dst[k] );
		MTXMultVec( (MtxPtr)&mtx[ mtx_idx[k] ], &src[k], &dst[k] );
	  }
	  
	  tmp_trigon = C_Trigon( dst, 0, tri.GetIdx(), tri.GetMtxIdx() );
	  break;
	}else{
	  trigon_num += pobjs[i].trigon->GetNum();
	}
  }


  return tmp_trigon;
}


void C_Envelope::Disp( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  u32 col=0xffff0000;
  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_ENABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
#if 0
  Mtx m;
  MTXIdentity( m );
  GXLoadPosMtxImm(m, GX_PNMTX0);
#endif
  GXSetCurrentMtx( GX_PNMTX0 );

  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetLineWidth( (u8)8*6,GX_TO_ZERO );

  static int  flg = 0;
  for( u32 i=0; i< num_pobj; i++ ){
	u32 trigon_num = pobjs[i].trigon->GetNum();
	HSD_PObj *pobj = pobjs[i].pobj;
	//f32 *mtx = (f32*)pobj->aobj;
	Mtx *mtx = (Mtx*)pobj->aobj;
	for( u32 j=0; j<trigon_num; j++ ){
	  C_Trigon &tri = pobjs[i].trigon->GetTrigon(j);
	  C_Vec *src, dst[3];
	  s16 *mtx_idx;

	  src = tri.GetVtx();
	  mtx_idx = tri.GetMtxIdx();

	  for( u32 k=0; k<3; k++ ){
		//MTXMultVec( (MtxPtr)&mtx[ mtx_idx[k] * 3 * 4 ], &src[k], &dst[k] );
		MTXMultVec( (MtxPtr)&mtx[ mtx_idx[k] ], &src[k], &dst[k] );
	  }
	  //OSReport( "%d %d %d\n", mtx_idx[0], mtx_idx[1], mtx_idx[2] );

	  for( u32 k=0; k<3; k++ ){
		u32 p0 = k;
		u32 p1 = (k==2) ? 0 : k+1;
		GXBegin(GX_LINES, GX_VTXFMT0, 2);
		GXPosition3f32(dst[p0].x, dst[p0].y, dst[p0].z);
		GXColor1u32(col);
		GXPosition3f32(dst[p1].x, dst[p1].y, dst[p1].z);
		GXColor1u32(col);
		GXEnd();
	  }
	  if( !flg ){
		//OSReport( "-- %4d --\n", j );
		//tri.DebugPrint();
	  }
	}
  }
  flg = 1;
}


void C_Envelope::DispNodePos( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  u32 col=0xffff0000;
  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_ENABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );

  GXSetZMode( GX_FALSE, GX_ALWAYS, GX_FALSE );
  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetPointSize( (u8)30,GX_TO_ZERO );

  for( u32 i=0; i< num_pobj; i++ ){
	u32 trigon_num = pobjs[i].trigon->GetNum();
	HSD_PObj *pobj = pobjs[i].pobj;
	Mtx *mtx = (Mtx*)pobj->aobj;
	for( u32 j=0; j<10; j++ ){
	  C_Vec src(0.f), dst;
	  MTXMultVec( (MtxPtr)&mtx[ j ], &src, &dst );
	  GXBegin(GX_POINTS, GX_VTXFMT0, 1);
	  GXPosition3f32(dst.x, dst.y, dst.z);
	  GXColor1u32(col);
	  GXEnd();
	}
  }
}

