#ifndef ___C_FONT_H___
#define ___C_FONT_H___

//#include "common.h"
#include "c_rect.h"
#include "..\Lib\ghmGcMem.h"
#include  <stdio.h>
#include  <stdarg.h>
#include  <string.h>

struct GhmGcTexHeader;

class C_Paper : public C_Rect{
 public:
  // x_, y_		p̈ʒuB(0,0)
  // s_			̃XP[B1.f == 16sNZB
  // f_			̉肠ȂB
  // w_, h_		p̕AB@
  C_Paper( s32 x_=0, s32 y_=0, f32 s_=1.f, bool f_=false, s32 w_=640, s32 h_=480, u32 _c = 0xffffffff ) : 
	C_Rect( x_, y_, w_, h_ ), scl(s_), flg(f_), col(_c){
	cur_x = x_;
	cur_y = y_;
	cur = this;
  }
  virtual ~C_Paper(){
	cur = 0;
  }
  static void Return( s32 size ){ if( cur ) cur->cur_y += size; }
  static void Reset( void ){ if( cur ) cur->cur_x = cur->x; cur->cur_y = cur->y; }
  static s32 GetX(void){ return cur ? cur->cur_x : 0; }
  static s32 GetY(void){ return cur ? cur->cur_y : 0; }
  static f32 GetScale(void){ return cur ? cur->scl : 1.f; }
  static bool GetFlag(void){ return cur ? cur->flg : false; }
  static C_Paper *GetCurPtr(void){ return cur; }
  static u32 GetCol(void){ return cur ? cur->col : 0xffffffff; }
 private:
  s32 cur_x,cur_y;
  f32 scl;
  bool flg;
  u32 col;
  static C_Paper *cur;

  //new֎~B
  void* operator new( size_t );
};


#define PRINTF	C_Font::GetInstance()->Print

class C_Font{
  friend class C_Paper;
 public:
//  static C_Font& GetInstance( void );
  static C_Font* GetInstance( void ){ return instance; }
  void Print( char *fmt, ... );
  void Draw( void );
  void DrawFontChar(int x, int y, int z, int xChar, int yChar);
  void LoadSheet(void* image, GXTexMapID texMapID);
  int Puts(s32 x, s32 y, s32 z, char* string);
  static bool Proc( void );


 private:

  class C_Line{
  public:
	s32 x,y;
	f32 scl;
	bool flg;
	u32 col;
	C_Rect scissor;
	char *str;
	static C_Line *top;
	C_Line *next;

	C_Line( char* s, s32 x_, s32 y_, C_Rect &r, f32 s_, bool f_, u32 c_ ) : 
	  x(x_),y(y_),scissor(r),scl(s_), flg(f_), col(c_){
	  ghmGcMemSetAllocName("C_Line");
	  str = new char[strlen(s)+1];
	  if( str ){
		strcpy( str, s );
		if( top ){
		  C_Line *tmp = top;
		  top = this;
		  this->next = tmp;
		}else{
		  top = this;
		  this->next = 0;
		}
	  }
	}

	void SetScissor( void );
//	void SetScissor( void ){
//	  GXSetScissor( (u32)scissor.GetX(), (u32)scissor.GetY(), 
//					(u32)scissor.GetW(), (u32)scissor.GetH() );
//	}

	static void DeleteAll( void ){
	  C_Line *tmp = top;
	  while( tmp ){
		C_Line *next = tmp->next;
		delete tmp;
		tmp = next;
	  }
	}
	static void PrintAll( void ){
	  C_Line *tmp = top;
	  while( tmp ){
		C_Line *next = tmp->next;
		OSReport( "%d %d %s\n", tmp->x,tmp->y, tmp->str );
		tmp = next;
	  }
	}
  private:
	~C_Line(){
	  if( this == top ) top = 0;
	  if( str!=NULL ){
		delete str;
	  }
	}
  };

  static GhmGcTexHeader *mpFontHeader;
  static void            *mpFontImage;
  static ghmGcFile       *mpFile;
  static int             mProc;
  static C_Font *instance;
  OSFontHeader* font_header;
  void*         last_sheet;
  f32			font_scl;
  s16           size;      // GX_S16, 4
  s16           space;     // GX_S16, 4
  GXTexObj      fontTexObj;

  //łȂ悤ɂB
  C_Font( void );
  void _Print( char* str, f32 s_ );

};

#endif
