#include "common.h"
#include "c_hole.h"


C_Hole::C_Hole( HSD_JObj *_jobj, Vec *dir, f32 x, f32 y, f32 z, f32 r, s32 _pre, s32 _post, u8 _alpha )
{
#pragma unused(dir)
  jobj = _jobj;
  HSD_JObjRef( jobj );
  radius = r;
  pre = _pre;
  post = _post;
  frame = counter = post + pre;
  alpha = _alpha;
  //abs_dir.Set(dir.x,dir.y,dir.z);
  //abs_dir *= -1;
#if 0
  C_Vec z_axis(*dir);
  y_axis.Set(0.f,1.f,0.f);
  x_axis = z_axis & y_axis;
  y_axis = z_axis & x_axis;
  x_axis.Nrm();
  y_axis.Nrm();
#endif

  //[hłposAjobj̃[JɕϊB
  Mtx imtx;
  C_Vec pos( x,y,z );
  HSD_JObjSetupMatrix( jobj );
  MTXInverse( HSD_JObjGetMtxPtr( jobj ), imtx );
  MTXMultVec( imtx, &pos, &rel_pos );
  //MTXMultVecSR( imtx, &abs_dir, &rel_dir );

  for( int i=0; i<MAXHOLE; i++ ){
	ofst[i].Set( radius*(HSD_Rand()%100)/100.f,
				 radius*(HSD_Rand()%100)/100.f,
				 radius*(HSD_Rand()%100)/100.f);
  }
}

C_Hole::~C_Hole()
{
}

s32 C_Hole::Proc( void )
{
  if( counter ){
	counter--;
	HSD_JObjSetupMatrix( jobj );
	MTXMultVec( HSD_JObjGetMtxPtr( jobj ), &rel_pos, &abs_pos );
	//MTXMultVec( HSD_JObjGetMtxPtr( jobj ), &rel_dir, &abs_dir );
  }
  return counter;
}

void C_Hole::Disp( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  GXSetZMode( GX_TRUE, GX_LEQUAL, GX_TRUE );

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_REG,		// amb source
				GX_SRC_REG,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);
  GXColor col={255,127,127,255};
  GXSetChanMatColor( GX_COLOR0A0, col );
  GXSetChanAmbColor( GX_COLOR0A0, col );

  GXSetColorUpdate( GX_FALSE );
  GXSetCullMode( GX_CULL_BACK );

  Mtx t,s,m;
  f32 val, scl;
  if( counter < (frame - pre) ){
	//㔼B
	val = (counter) / (f32)post;
  }else{
	//OB
	val = (frame-counter) / (f32)pre;
  }
#if 0
  scl = radius * val;
  MTXScale( s, scl, scl, scl );
  for( int i=0; i<MAXHOLE; i++ ){
	C_Vec ofst = this->ofst[i] * val;
	MTXTrans( t, abs_pos.x+ofst.x, abs_pos.y+ofst.y, abs_pos.z+ofst.z );
	MTXConcat( t, s, m );
	MTXConcat( HSD_CObjGetViewingMtxPtr(cobj), m, m );
	GXLoadPosMtxImm( m, GX_PNMTX0);
	GXSetCurrentMtx( GX_PNMTX0 );
	GXDrawSphere( 8,8 );
  }
#else
  //^̋B
  scl = radius * val * val * 0.9f;
  GXSetAlphaUpdate( GX_FALSE );
  GXSetDstAlpha( GX_FALSE, 0 );
  GXSetZScaleOffset( 1.f, -0.0001f );
  MTXScale( s, scl, scl, scl );
  MTXTrans( t, abs_pos.x, abs_pos.y, abs_pos.z );
  MTXConcat( t, s, m );
  MTXConcat( HSD_CObjGetViewingMtxPtr(cobj), m, m );
  GXLoadPosMtxImm( m, GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );
  GXDrawSphere( 16,16 );
  GXSetZScaleOffset( 1.f, 0.f );

  //ŐB
  scl = radius * val;
  GXSetAlphaUpdate( GX_TRUE );
  GXSetDstAlpha( GX_FALSE, alpha );
  MTXScale( s, scl, scl, scl );
  MTXTrans( t, abs_pos.x, abs_pos.y, abs_pos.z );
  MTXConcat( t, s, m );
  MTXConcat( HSD_CObjGetViewingMtxPtr(cobj), m, m );
  GXLoadPosMtxImm( m, GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );
  GXDrawSphere( 16,16 );
#endif
  HSD_StateInvalidate( HSD_STATE_ALL );
}






