#ifndef ___C_IMPULSE_H___
#define ___C_IMPULSE_H___

//#include "common.h"
#include "c_vec.h"
#include "vector.h"
#include "list.h"
#include "c_vfx.h"

#define kShockWaveNum 1
class C_ShockWave{
 public:
  C_ShockWave( C_Vec &_pos, C_Vec &_dir, f32 _speed=1.5f, s32 _life=30 );
  ~C_ShockWave();
  s32 Proc( void );
  void Disp( void );
  s32 GetCounter( void ){ return counter; }
  s32 GetLife( void ){ return life; }
 private:
  C_Vec dir[kShockWaveNum];
  s32 life,counter;
  HSD_JObj *jobjs[kShockWaveNum];
};

class C_ShockWaveSet{
 public:
  C_ShockWaveSet( Vec *_start, Vec *_end, f32 _speed );
  ~C_ShockWaveSet();
  s32 Proc( void );
  void Disp( void );
  void DispBullet( void );
  s32 GetNum( void ){ return (s32)waves.size(); }
  C_Vec &GetPos( void ){ return pos; }
 private:
  C_Vec pos,end;
  C_Vec dir;
  f32 speed;
  vector<C_ShockWave*> waves;
  HSD_JObj *jobj;
  HSD_JObj *bullet_jobj;
  bool hit;
};

#define IMPULSE (C_Impulse::GetInstance())
class C_Impulse{
 public:
  static C_Impulse& GetInstance( void );
  s32 Proc( void );
  void Disp( GXTexObj *_tobj );
  C_ShockWaveSet *Request( Vec *_start, Vec *_end, f32 _speed );
  bool TerminateAll( void );
  C_Vec *GetPos( C_ShockWaveSet *wave );
 private:
  static C_Impulse* instance;
  vector<C_ShockWaveSet*> wavesets;
  GXTexObj texobj;
  C_Tex indirect_texture_rand;
  C_Impulse( void );
  ~C_Impulse();
};
#endif
