#include "common.h"
#include "c_k7cloth.h"
#include "../Wat/WK7Npc.h"
#include "c_scenedesc.h"
#include "stdlib.h"

//#define kClothJointPrefix ((char*)"ClothJoint_")
//#define kClothCollisionPrefix ((char*)"ClothCollision_")
#define kMaxJoints 20
//#define kMaxJoints 16
//#define kMaxJoints 256
#define kMaxCloths 16

C_K7Cloth::~C_K7Cloth()
{
  u32 size = trigon.size();
  for( u32 i=0; i<size; i++ ) delete trigon[i];
  size = cloth.size();
  for( u32 i=0; i<size; i++ ) delete cloth[i];
}
C_K7Cloth::C_K7Cloth( HSD_JObj *_jobj, HSD_Joint *_joint )
{
  joints_num = 0;
  trigon.clear();
  cloth.clear();
  root_jobj = _jobj;
  root_joint = _joint;
  collision_jobj = NULL;
  JOINTS joints[ kMaxJoints ];
  constrain_pow_flg = false;

  //ZIuWFNg̃f[^W߂B
//  GetClothData( root_jobj, root_joint, joints );
  for( ; _joint != NULL ; _jobj=_jobj->next,_joint=_joint->next){
	GetClothData( _jobj, _joint, joints );
  }

  if( !joints_num ) return;
//  OSReport( "cloth : (%d %d)\n", trigon.size(), cloth.size() );
  SetCloth( joints );
}

void C_K7Cloth::Proc( void )
{
  if( !constrain_pow_flg ){
	f32 p_=30.f,m_=6.f;
	if( WK7Npc::Find(ENENO_AK2) ){
	  p_ = 5.f, m_ = 1.f;
	}else if( WK7Npc::Find(ENENO_AKN) ){
	  p_ = 5.f, m_ = 1.f;
	}
	for( u32 i=0; i<cloth.size(); i++ ) cloth[i]->SetConstrainPow( p_, m_ );
	constrain_pow_flg = true;
  }

  for( u32 i=0; i<trigon.size(); i++ ) trigon[i]->Proc();
  for( u32 i=0; i<cloth.size(); i++ ) cloth[i]->Proc();
}

void C_K7Cloth::Disp( void )
{
  for( u32 i=0; i<trigon.size(); i++ ) trigon[i]->DispAll();
  for( u32 i=0; i<cloth.size(); i++ ) cloth[i]->Disp();
}

void C_K7Cloth::SetWind( Vec &_w )
{
  C_Vec w(_w);
  for( u32 i=0; i<cloth.size(); i++ ) cloth[i]->SetWind( w );
}

void C_K7Cloth::GetClothData( HSD_JObj *_jobj, HSD_Joint *_joint, JOINTS _joints[] )
{
  if( OK == _GetClothData( GetDescName(_joint), &_joints[joints_num] ) ){
	if( joints_num < (kMaxJoints-1) ){
	  _joints[joints_num].jobj = _jobj;
	  joints_num++;
	}
  }
  for(_joint=_joint->child,_jobj=_jobj->child ; _joint!=NULL ; _joint=_joint->next,_jobj=_jobj->next){
	GetClothData( _jobj, _joint, _joints );
  }
//  if(_joint->child){
//	GetClothData( _jobj->child, _joint->child, _joints );
//  }
//  if(_joint->next){
//	GetClothData( _jobj->next, _joint->next, _joints );
//  }
}

C_K7Cloth::DATA_STATUS C_K7Cloth::_GetClothData( const char *top, JOINTS *data )
{
  u32 len = strlen( kClothJointPrefix );
  data->name = 0;
  data->len = data->bone_no = data->joint_no = -1;

  //vtBbNX𒲂ׂB
  if( !strncmp( kClothJointPrefix, top, len ) ){
	data->name = top = &top[len];
	//O𒲂ׂB
	for( int i=0; top[i]!='\0'; i++ ){
	  if( i>=2 && top[i] == '_' ){ 
		char b[2]={'\0',}; b[0] = top[i-2];
		char j[2]={'\0',}; j[0] = top[i-1];
		data->bone_no = (s8)atoi( (const char*)&b );
		data->joint_no = (s8)atoi( (const char*)&j );
		data->len = (s8)(i-3+1);//CfbNXȂ̂1𑫂B
		top = &top[i+1]; 
		break;
	  }
	}
	if( data->len > 0 && data->bone_no >= 0 && data->joint_no >= 0 ){
	  //p[^[𒲂ׂB
	  int num = sscanf( top, "%f_%f_%f", 
				&(data->spring_const), &(data->dumping_const), &(data->mass) );
	  if( num == 3 ){
		return OK;
	  }else{
		return WRONG_PARAM;
	  }
	}else{
	  return WRONG_NAME;
	}
  }else{
	return WRONG_PREFIX;
  }
}


s32 C_K7Cloth::SortAdd( JOINTS joint, JOINTS data[], s32 _count )
{
  if( _count == (kMaxJoints-1) ) return _count;

  //͂ƂȂƎv̂Ńou\[gB
  s32 i;
  for( i=_count; i; i-- ){
	if( data[i-1] < joint ){
	  data[i] = joint;
	  break;
	}else{
	  data[i] = data[i-1];
	}
  }
  //ɒǉB
  if( i == 0 )data[0] = joint;

  return ++ _count;
}
void C_K7Cloth::SetCloth( JOINTS data[] )
{
  //ZIuWFNg̐ƁAO߂B
  typedef struct{
	const char *name;
	s8 len;
  }NAMES;
  NAMES names[ kMaxCloths ] = {0,};
  s32 num = 0;
  for( int i=0; i<joints_num; i++ ){
	//o^ꂽOǂH
	s32 flg = 0;
	for( int j=0; j<num; j++ ){
	  if( !strncmp( names[j].name, data[i].name, names[j].len ) ){ flg = 1; break; }
	}
	//VKɓo^B
	if( !flg && num<(kMaxCloths-1)){
	  names[num].name = data[i].name;
	  names[num++].len = data[i].len;
	}
  }

  //OƂɓo^B
  JOINTS tmp[ kMaxJoints ];
  for( int i=0; i<num; i++ ){
	//names[].nametmpɃRs[B
	s32 count = 0;
	for( int j=0; j<joints_num; j++ ){
	  if( !strncmp( names[i].name, data[j].name, names[i].len ) ){
		//char s[32];
		//strncpy( s, data[j].name, data[j].len );
		//OSReport( "------- %d(%s) -------\n", count, s );
		count = SortAdd( data[j], tmp, count );
		//for( int k=0; k<count; k++ ) tmp[k].Print();
	  }
	}


	s32 jnum=-1,bnum=-1;
	if( count && IsValid( tmp, count, jnum, bnum ) ){
	  char str[128]={'\0',};
	  strncpy( str, tmp[0].name, tmp[0].len );
//	  collision_jobj = GetCollisionJObj( root_jobj, root_joint, str );
	  {
		HSD_JObj	*_jobj;
		HSD_Joint	*_joint;
		for(_joint=root_joint,_jobj=root_jobj ; _joint!=NULL ; _joint=_joint->next,_jobj=_jobj->next){
		  if( (collision_jobj = GetCollisionJObj( _jobj, _joint, str ))!=NULL ){
			break;
		  }
		}
	  }

	  //ۂɓo^B
	  C_Cloth *c;
	  {
		HSD_JObj *jobjs[ kMaxJoints ];
		for( int i=0; i<count; i++ ){
		  jobjs[i] = tmp[i].jobj;
		  //tmp[i].Print();
		}
		c = new C_Cloth( (s16)bnum, (s16)jnum, jobjs );
	  }

	  {
		f32 params[kMaxJoints][3];
#if 1
		for( int i=0; i<count; i++ ){
		  params[i][0] = tmp[i].spring_const;
		  params[i][1] = tmp[i].dumping_const;
		  params[i][2] = tmp[i].mass;
		}
#else
		params[0][0] = 10.f; params[0][1] = 75.f; params[0][2] = 80.f;
		params[1][0] = 10.f; params[1][1] = 80.f; params[1][2] = 80.f;
		params[2][0] = 16.f; params[2][1] = 85.f; params[2][2] = 75.f;

		params[3][0] = 10.f; params[3][1] = 75.f; params[3][2] = 80.f;
		params[4][0] = 10.f; params[4][1] = 80.f; params[4][2] = 80.f;
		params[5][0] = 16.f; params[5][1] = 85.f; params[5][2] = 75.f;

		params[6][0] = 10.f; params[6][1] = 75.f; params[6][2] = 80.f;
		params[7][0] = 10.f; params[7][1] = 80.f; params[7][2] = 80.f;
		params[8][0] = 16.f; params[8][1] = 85.f; params[8][2] = 75.f;
#endif
		c->ResetParams( (s16)bnum, (s16)jnum, params );
	  }

	  //RWfB
	  if( collision_jobj ){
		HSD_JObjSetFlagsAll( collision_jobj, JOBJ_HIDDEN );

		u32 s = trigon.size();
		C_ExtractTrigonArray t( collision_jobj, trigon );
		for( u32 i=s; i<trigon.size(); i++ ) c->AddTrigon( trigon[i] );
	  }

	  //o^B
	  cloth.push_back( c );
	}
  }
}
bool C_K7Cloth::HideCollision(void)
{
  if( collision_jobj ){
	HSD_JObjSetFlagsAll( collision_jobj, JOBJ_HIDDEN );
  }
  return true;
}

HSD_JObj *C_K7Cloth::GetCollisionJObj( HSD_JObj *_jobj, HSD_Joint *_joint, char *_name )
{
  char str[256]={'\0',};

  sprintf( str, "%s%s", kClothCollisionPrefix, _name );
  u32 len = strlen( str );

  //Prefix + O𒲂ׂB
  if( !strncmp( GetDescName(_joint), str, len ) ){
	return _jobj;
  }

  HSD_JObj *j;
  for(_joint=_joint->child,_jobj=_jobj->child ; _joint!=NULL ; _joint=_joint->next,_jobj=_jobj->next){
	if( (j = GetCollisionJObj( _jobj, _joint, _name )) != NULL ){
	  return j;
	}
  }
  return NULL;
//  HSD_JObj *j = 0;
//  if(_joint->child){
//	j = GetCollisionJObj( _jobj->child, _joint->child, _name );
//	if( j ) return j;
//  }
//  if(_joint->next){
//	j = GetCollisionJObj( _jobj->next, _joint->next, _name );
//	if( j ) return j;
//  }
//  
//  return j;
}

bool C_K7Cloth::IsValid( JOINTS _joints[], s32 _count, s32 &_j, s32 &_b )
{
  s32 max_joint=-1;
  s32 max_bone=-1;

  //ԍAԐڔԍōő̂̂𔲂oĂB
  for( int i=0; i<_count; i++ ){
	if( max_joint < _joints[i].joint_no ) max_joint = _joints[i].joint_no;
	if( max_bone < _joints[i].bone_no ) max_bone = _joints[i].bone_no;
  }

  int no = 0;
  for( int i=0; i<(max_bone+1); i++ ){
	for( int j=0; j<(max_joint+1); j++ ){
	  if( no < _count &&
		  _joints[no].joint_no == (s8)j && 
		  _joints[no].bone_no == (s8)i ) no++;
	  else
		return false;
	}
  }

  //B
  _j = max_joint+1;
  _b = max_bone+1;
  return true;
}









