#ifndef ___C_LOBJ_H___
#define ___C_LOBJ_H___

//#include "common.h"
#include "c_scenedesc.h"
#include "c_vec.h"
#include "utility.h"

//sysdolphinlobj̃bp[B
//
class C_LObj {
 public:
  //RXgN^
  //
  C_LObj(const C_LightSet* light) : light_set(light){
	lobj = HSD_LObjLoadDesc(light_set->lightdesc);
  }
  C_LObj() : light_set(0){ lobj = HSD_LObjAlloc(); }

  //fXgN^
  //
//  virtual ~C_LObj(){ if(lobj) HSD_LObjUnref(lobj); }
  virtual ~C_LObj(){ if(lobj) HSD_LObjRemoveAll(lobj); }

  //lobjdesc
  //
  const C_LightSet* GetLightSet() const { return light_set; }

  //ANV̐
  //
  u32 GetActionNum() const { return light_set->GetActionNum(); }

  //ANVwB
  //
  void SetAction(const char* name){
	HSD_LObjAddAnimAll(lobj, light_set->GetAction(name));
	HSD_LObjReqAnimAll(lobj, 0.0f);
  }
  void SetAction(u32 no){
	HSD_LObjAddAnimAll(lobj, light_set->GetAction(no));
	HSD_LObjReqAnimAll(lobj, 0.0f);
  }

  //Đp[^
  //
  void SetRate(f32 rate){
	HSD_ForeachAnim(lobj, LOBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetRate, AOBJ_ARG_AF, rate);
  }
  void SetCurrentFrame(f32 time){
	HSD_ForeachAnim(lobj, LOBJ_TYPE, ALL_TYPE_BITS
					, (HSD_ForeachFunc)HSD_AObjSetCurrentFrame, AOBJ_ARG_AF, time);
  }
  void Proc(){ HSD_LObjAnimAll(lobj); }

  //ŁAlobj.Disp()͂ށB
  //
  static void DispStart() { HSD_LObjDeleteCurrentAll(0); }
  static void DispEnd() { HSD_LObjSetupInit(HSD_CObjGetCurrent()); }

  void Disp(bool all=false) { if( all==true ){ HSD_LObjAddCurrentAll(lobj); }else{ HSD_LObjAddCurrent(lobj); } }

  HSD_LObj* GetLObj( void ){
	return lobj;
  }
  C_Vec GetPosition( void ){
	C_Vec pos( lobj->position->position );
	return pos;
  }


 private:
  HSD_LObj*			lobj;
  const C_LightSet*	light_set;
};

#endif



