#include "common.h"
#include "c_perf.h"

#define DEFAULT_DL_SIZE		(32*1024)
	
void	C_Perf::StartProc(void) { PERFEventStart(UPDATE); }
void	C_Perf::EndProc  (void) { PERFEventEnd  (UPDATE); }
void	C_Perf::StartRender(void) { PERFEventStart(RENDER); }
void	C_Perf::EndRender  (void) { PERFEventEnd  (RENDER); }

void C_Perf::DrawInit(void)
{
}
void* C_Perf::Alloc(u32 size)
{
  void *ret = new u8[size];
  return ret;
}
void C_Perf::Free(void* ptr)
{
  delete ptr;
}

void C_Perf::Start(void)
{
	// start measurement frame
	PERFStartFrame();
	PERFStartAutoSampling(1.0f);
}

void C_Perf::End(void)
{
	PERFEndFrame();
	PERFStopAutoSampling();
}

void C_Perf::Dump(void)
{
	// swap display list buffers
	GXBeginDisplayList(DL[DLIdx], DEFAULT_DL_SIZE);
	PERFDumpScreen();
	DLSize[DLIdx] = GXEndDisplayList();
}

void C_Perf::Draw(void)
{
	PERFPreDraw();
	GXCallDisplayList(DL[DLIdx], DLSize[DLIdx]);
	PERFPostDraw();
	DLIdx = (DLIdx + 1) % 2;
}

C_Perf::~C_Perf()
{
}
C_Perf::C_Perf( void )
{
	PERFInit(NUM_SAMPLES, NUM_FRAMES, NUM_TYPES, Alloc, Free, DrawInit);
	
	PERFSetDrawRASBar  (TRUE );
	PERFSetDrawXFBars  (TRUE );
	PERFSetDrawCPUBar  (TRUE );
	PERFSetDrawBWBar   (TRUE );
	PERFSetDrawBWBarKey(TRUE );
	
	// default display list size for displaying perf graph
	// create display list buffers
	DL[0]     = (u8*)Alloc(DEFAULT_DL_SIZE);
	DL[1]     = (u8*)Alloc(DEFAULT_DL_SIZE);
	DLSize[0] = 
	DLSize[1] = 0;
	DLIdx     = 0;
	
	PERFSetEvent(RENDER, "RENDER", PERF_CPU_GP_EVENT);
	PERFSetEvent(UPDATE, "UPDATE", PERF_CPU_EVENT);
}
