#ifndef ___C_SEAWEAD_H___
#define ___C_SEAWEAD_H___

//#include "common.h"
#include "c_vec.h"
//#include "c_trigon.h"
//#include "vector.h"
//#include "c_vfx.h"

class C_SeaWead {
 public:
  enum BIND_TYPE{
	RIGID_BIND,
	SPRING_BIND,
	CONSTRAINT_BIND,
	SOFT_CONSTRAINT_BIND,
	NO_BIND,
	MAX_JOBJ = 1
  };
  typedef struct{
	s32	p1,p2;	// _f[^ւ̃CfbNX
	f32	length;	// XvOR
	f32 max_len;//ő̒B
	f32	Ks;		// d
	f32	Kd;		// ܂
  }SEAWEAD_SPRING;
  typedef struct{
	C_Vec pos;	//ʒu
	C_Vec vel;	//x
	C_Vec force;//
	f32	mass;//
	f32	InvMass;//ʂ̋t
	BIND_TYPE state;
  }SEAWEAD_PARTICLE;
 private:
  static f32 dtime;
  static s32 ref;
  static C_Vec gravity;
  s32 num_ptcl;
  f32 const_spring;
  f32 const_dspring;
  f32 const_dumping;
  C_Vec wind;
  s32 fun_flg;
  u32 col;
  C_Vec fun_pos[2],fun_force[2];
  C_Vec anchor_pos;
  C_Vec soft_constraint_force;
  SEAWEAD_PARTICLE *cur,*next,*ptcl_buf[2];
  SEAWEAD_SPRING *spring;
  u8 line_width;
	
  void Integrate( void );
  void ComputeForce( void );
 public:
  //--- RXgN^ ---
  C_SeaWead( s16 _num_ptcl, C_Vec &_world_pos, C_Vec &_dir,
			 f32 _len, f32 _mass, f32 _const_spring, f32 _const_dspring );

  //--- fXgN^ ---
  virtual ~C_SeaWead();

  //--- s֐ ---
  void Proc(void);

  //--- \֐ ---
  void Disp(void);
  static void DispStart(void);
  static void DispEnd(void);
  //--- ̌ ---
  void SetWind( C_Vec &w ){ wind = w; }
  
  //@B
  void SetFun( C_Vec &w, C_Vec &f ){ 
	if( fun_flg == 2 ) return;
	else{
	  fun_pos[fun_flg] = w; fun_force[fun_flg++] = f;
	}
  }

  //[ŒB
  void SetTipPos( C_Vec &pos ){ cur[0].state = next[0].state = CONSTRAINT_BIND; cur[0].pos = pos; }
  //[̕ݒB
  void SetTipDir( C_Vec &dir ){ cur[0].state = next[0].state = SOFT_CONSTRAINT_BIND; soft_constraint_force = dir; }
  //Ԃ擾B
  BIND_TYPE GetType( u32 i_ ) const {
	if(num_ptcl>i_) return cur[i_].state;
	else return NO_BIND;
  }
  void SetPos( u32 i_, const C_Vec &p_ ) const {
	if(num_ptcl>i_){
	  cur[i_].state = next[i_].state = CONSTRAINT_BIND;
	  cur[i_].pos = next[i_].pos = p_;
	}
  }
  
  //tB
  void SetAnchorPos( C_Vec &pos ) { anchor_pos = pos; }
  void SetRigidBind( s32 idx = -1  ) { 
	if( idx >= 0 ) cur[idx].state = next[idx].state = RIGID_BIND; 
	else{
	  for( int i=0; i<num_ptcl; i++ ){
		cur[i].state = next[i].state = RIGID_BIND;
	  }
	}
  }
  void SetSpringBind( s32 idx = -1  ) { 
	if( idx >= 0 ) cur[idx].state = next[idx].state = SPRING_BIND; 
	else{
	  for( int i=0; i<num_ptcl; i++ ){
		cur[i].state = next[i].state = SPRING_BIND;
	  }
	}
  }
  void SetShrink( void );
  s32 GetNumParticle( void ){ return num_ptcl; }
  
  BIND_TYPE GetState( s32 idx ){ return cur[idx].state; }
  void SetConstDumping( f32 _d ){ const_dumping = _d; }

  void Reset( C_Vec &_world_pos, C_Vec &_dir, f32 _len );
  inline void SetLineWidthRate( f32 r_ ) { if( r_>0.f && r_<1.f ) line_width = (u8)(8 *r_); }
};

#endif


