#include "common.h"
#include "c_setalpha.h"
C_SetAlpha::C_SetAlpha( HSD_JObj *_jobj, f32 a , bool next ){
  Init( _jobj, a , next );
}
C_SetAlpha::C_SetAlpha( WK7Chara *_chara, f32 a , bool next ){
  Init( _chara->GetModel()->GetTopObj()->GetJObj(), a , next);
}
void C_SetAlpha::Init( HSD_JObj *_jobj, f32 a , bool next ){
  num = 0;
  save = NULL;
  root_jobj = _jobj;
  root_jobj_flag = root_jobj->flags;
  alpha = a;

  HSD_JObjSetFlags(root_jobj, JOBJ_ROOT_XLU);
  HSD_JObjRef(root_jobj);

  //̒lƂĂB
  if( (num = GetMatCount(root_jobj,next)) <= 0 ){
	return;
  }
  if( (save=new SAVEDATA[num])==NULL ){
	num = 0;
	return;
  }
  Save( root_jobj,0,next);
  //ύXB
  SetVal( alpha );
}
// modified by wat 03/12/21
void C_SetAlpha::SetVal( f32 a , bool zupdate){ 
  alpha = a; 

  for (int i=0; i<num; i++ ){
	HSD_JObjSetFlags(save[i].jobj, JOBJ_XLU);
	HSD_DObjModifyFlags(save[i].dobj, DOBJ_XLU, DOBJ_TRSP_MASK);
	save[i].mobj->mat->alpha = alpha;
	save[i].mobj->rendermode |= RENDER_XLU;
	save[i].mobj->rendermode |= RENDER_ALPHA_MAT;
	save[i].mobj->rendermode |= RENDER_NO_ZUPDATE;
	if( save[i].mobj->pe ){
	  //save[i].pe_flags = save[i].mobj->pe->flags;;
	  //save[i].mobj->pe->flags &= (~ENABLE_ZUPDATE);
	  if( zupdate==false ){
		save[i].mobj->pe->flags &= (~ENABLE_ZUPDATE);
	  }
	}
	HSD_MObjCompileTev(save[i].mobj);
  }
}
C_SetAlpha::~C_SetAlpha(){
  root_jobj->flags = root_jobj_flag;
  HSD_JObjUnref( root_jobj );

  //ɖ߂B
  for (int i=0; i<num; i++ ){
	save[i].jobj->flags = save[i].jobj_flags;
	save[i].mobj->mat->alpha = save[i].alpha;
	save[i].mobj->rendermode = save[i].mobj_rendermode;
	save[i].dobj->flags = save[i].dobj_flags;
	if( save[i].mobj->pe ) save[i].mobj->pe->flags = save[i].pe_flags;
	//HSD_DObjModifyFlags(save[i].dobj, DOBJ_OPA, DOBJ_TRSP_MASK);
	HSD_MObjCompileTev(save[i].mobj);
	HSD_JObjUnref( save[i].jobj );
	//HSD_MObjRef( save[i].mobj );
	//HSD_DObjRef( save[i].dobj );
  }
  if( save!=NULL ){
	delete[] save;
  }
}
int C_SetAlpha::GetMatCount(HSD_JObj* _jobj,bool next){
  HSD_DObj *dobj;
  HSD_MObj *mobj;
  int		  count = 0;
  for (dobj = HSD_JObjGetDObj(_jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
	  if( mobj->mat ){
		count++;
	  }
	}
  }
  if(_jobj->child){
	count += GetMatCount(_jobj->child,true);
  }
  if( next==true ){
	HSD_JObj	*pnext;
	for(pnext=_jobj->next ; pnext!=NULL ; pnext=pnext->next){
	  count += GetMatCount(pnext,false);
	}
  }
  return count;
}
int C_SetAlpha::Save(HSD_JObj* _jobj,int count,bool next){
  HSD_DObj *dobj;
  HSD_MObj *mobj;
  if( count >= num ) return count;
  for (dobj = HSD_JObjGetDObj(_jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
	  if( mobj->mat ){
		HSD_JObjRef( _jobj );
		//HSD_MObjRef( mobj );
		//HSD_DObjRef( dobj );
		save[count].jobj = _jobj;
		save[count].mobj = mobj;
		save[count].dobj = dobj;
		save[count].jobj_flags = _jobj->flags;
		save[count].alpha = mobj->mat->alpha;
		save[count].mobj_rendermode = mobj->rendermode;
		save[count].dobj_flags = dobj->flags;
		if( mobj->pe ) {
		  save[count].pe_flags = mobj->pe->flags;
		}
		count++;
		if( count >= num ) return count;
		//		  save[num].jobj = _jobj;
		//		  save[num].mobj = mobj;
		//		  save[num].dobj = dobj;
		//		  save[num].jobj_flags = _jobj->flags;
		//		  save[num].alpha = mobj->mat->alpha;
		//		  save[num].mobj_rendermode = mobj->rendermode;
		//		  save[num].dobj_flags = dobj->flags;
		//		  if( mobj->pe ) {
		//			save[num].pe_flags = mobj->pe->flags;
		//		  }
		//		  num++;
		//			if( num >= MAX_SAVE_NUM ) return;
	  }
	}
  }
  if(_jobj->child){
	count = Save(_jobj->child,count,true);
  }
  if( next==true ){
	HSD_JObj	*pnext;
	for(pnext=_jobj->next ; pnext!=NULL ; pnext=pnext->next){
	  count = Save(pnext,count,false);
	}
  }
  return count;
  //	if(_jobj->child){
  //	  Save(_jobj->child);
  //	}
  //	if(_jobj->next){
  //	  Save(_jobj->next);
  //	}
}


