#include "common.h"
#include "c_shadow.h"


extern f32 gDist;
extern f32 gNear;
extern f32 gFar;


void C_Shadow::SetShadowCamZOfst( f32 z){ z_ofst = z; }
f32 C_Shadow::GetShadowCamZOfst( void ){ return z_ofst; }

void C_Shadow::SetShadowCamDist( f32 d ){ gDist = d; }
f32 C_Shadow::GetShadowCamDist( void ){ return gDist; }

//eJ̉ʁB
void C_Shadow::SetShadowCamFar( f32 f ){ gFar = f; }
f32 C_Shadow::GetShadowCamFar( void ){ return gFar; }

//eJ̋ߕʁB
void C_Shadow::SetShadowCamNear( f32 n ){ gNear = n; }
f32 C_Shadow::GetShadowCamNear( void ){ return gNear; }

C_Shadow::C_Shadow( u16 w, u16 h, u8 i )
{
  Vec	dir = {0.0f,0.0f,1.0f};
  lobj = NULL;
  width = w;
  height = h;
  intensity = i;
  shadow = HSD_ShadowAlloc();
  HSD_ShadowSetSize(shadow, w, h);
  HSD_ShadowSetActive(shadow, 1);
  SetCamera(dir,1.0f);
  InitViewingRect(1.0f,-1.0f,-1.0f,1.0f);
  
  z_ofst = -0.004f ;
}

void C_Shadow::SetLight(C_LObj *l)
{
  lobj = l->GetLObj();
  switch (HSD_LObjGetType(lobj)) {
  case LOBJ_INFINITE:
	HSD_CObjSetProjectionType(shadow->camera, COBJ_PROJECTION_ORTHO);
	break;
  case LOBJ_AMBIENT:
  case LOBJ_POINT:
  case LOBJ_SPOT:
  default:
	ASSERT2(0, "Wrong type light for shadow.\n");
	break;
  }
  HSD_CObjSetNear(shadow->camera,     0.1f);
  HSD_CObjSetFar (shadow->camera, 32768.0f);
}

void C_Shadow::SetCamera( Vec &v, f32 dist )
{
  if( lobj==NULL ) return;
  HSD_CObjSetInterest(shadow->camera, &v);
  HSD_ShadowCopyLightPos(shadow, lobj, dist);
}

void C_Shadow::InitViewingRect(f32 top, f32 bottom, f32 left, f32 right)
{
  if( lobj==NULL ) return;
  Vec	interest, eyepos, up;
	
  HSD_CObjGetInterest   (shadow->camera, &interest);
  HSD_CObjGetEyePosition(shadow->camera, &eyepos);
  HSD_CObjGetUpVector   (shadow->camera, &up);
	
  HSD_ViewingRectInit(&vrect, &eyepos, &interest, &up, FALSE);
  HSD_ViewingRectAddRect(&vrect, &interest, top, bottom, left, right);
}

void _AddViewingRect(HSD_ViewingRect &vrect,HSD_JObj *jobj,f32 top, f32 bottom, f32 left, f32 right,bool next=false);
void _AddViewingRect(HSD_ViewingRect &vrect,HSD_JObj *jobj,f32 top, f32 bottom, f32 left, f32 right,bool next)
{
	Vec	pos;
	pos.x = jobj->mtx[0][3];
	pos.y = jobj->mtx[1][3];
	pos.z = jobj->mtx[2][3];
	HSD_ViewingRectAddRect(&vrect, &pos, top, bottom, left, right);
	if( jobj->child!=NULL ){
		_AddViewingRect(vrect,jobj->child,top,bottom,left,right,true);
	}
	if( next==true && jobj->next!=NULL ){
		_AddViewingRect(vrect,jobj->next,top,bottom,left,right,false);
	}
}

void C_Shadow::AddViewingRect(f32 top, f32 bottom, f32 left, f32 right)
{
  HSD_SList*		p_objlist;
	
  //shadow 𔭐jobj ǂview voluem 𒀎LĂ
//  Vec	pos;
  for (p_objlist = shadow->objects; p_objlist; p_objlist = p_objlist->next) {
	HSD_JObj *p_jobj = (HSD_JObj *)p_objlist->data;
//	pos.x = p_jobj->mtx[0][3];
//	pos.y = p_jobj->mtx[1][3];
//	pos.z = p_jobj->mtx[2][3];
	
	_AddViewingRect(vrect,p_jobj,top, bottom, left, right);
//	//J̒ɃIuWFNg܂悤ɒlZbgB
//	//傫ƂĂΈSA܂傫Ɖẻ𑜓xB
//	HSD_ViewingRectAddRect(&vrect, &pos, top, bottom, left, right);
  }
}

void C_Shadow::CheckViewingRect(void)
{
  if (HSD_ViewingRectCheck(&vrect)) {
	HSD_ShadowSetViewingRect(shadow, 
							 vrect.top, vrect.bottom, vrect.left, vrect.right);
  } else {
	HSD_ShadowSetViewingRect(shadow, 1024.0F, -1024.0F, -1024.0F, 1024.0F);
  }
}

void C_Shadow::StartRenderShadow(void)
{
  HSD_ShadowInit(shadow);
  //ۂɂ͂̒ł͕`悵ȂƂɂB
  HSD_ShadowStartRender(shadow);
  GXSetZScaleOffset( 1.f, z_ofst );
  //HSD_CObjSetCurrent(shadow->camera);
}

void C_Shadow::EndRenderShadow(void)
{
  HSD_CObjEndCurrent();	
  HSD_ShadowEndRender(shadow);
  GXSetZScaleOffset( 1.f, 0.f );
}




void  C_Shadow::DrawTex( void )
{

  HSD_Shadow*sdw = shadow;

  HSD_TObj *t = sdw->texture;
  if( !t ) return;

  //eNX`[h
  GXTexObj r;
  GXInitTexObj(&r, t->imagedesc->image_ptr,
				   t->imagedesc->width, t->imagedesc->height, 
				   t->imagedesc->format, 
				   t->wrap_s, t->wrap_t,
				   t->imagedesc->mipmap? GX_TRUE : GX_FALSE);
  GXInitTexObjLOD(&r, GX_NEAR, GX_NEAR, 0, 0, 0, 0, 0, GX_ANISO_1);
  GXLoadTexObj(&r, GX_TEXMAP0);

  //JݒB
  GXRenderModeObj *rmode = HSD_VIGetConfigure();
  HSD_CObj *cobj = HSD_CObjAlloc();
  HSD_CObjSetProjectionType(cobj, COBJ_PROJECTION_ORTHO);
  HSD_CObjSetViewportfx4(cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetScissorx4  (cobj, 0, (u16)rmode->viWidth, 0, (u16)rmode->viHeight);
  HSD_CObjSetNear (cobj,   0.0F);
  HSD_CObjSetFar  (cobj, 200.0F);
  HSD_CObjSetOrtho(cobj, 0.f, 480.f, 0.f, 640.f);
  Vec	eyepos   = {0.0f, 0.0f, 100.0f};
  Vec	interest = {0.0f, 0.0f,   0.0f};
  Vec	up       = {0.0f, 1.0f,   0.0f};
  Mtx	mtxView;
  MTXLookAt(mtxView, &eyepos, &up, &interest);
  HSD_CObjSetUserDefinedMtx(cobj, mtxView);
	
  //Tev
  GXColor col={255,0,0,0};
  GXSetTevColor(GX_TEVREG1,col);

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_MODULATE);
  GXSetNumTevStages(1);
  //TexCoord
  Mtx	mat;
  MTXIdentity(mat);
  GXLoadTexMtxImm(mat, GX_TEXMTX0, GX_MTX2x4);
  GXSetTexCoordGen( GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_TEXMTX0 );
  GXSetNumTexGens(1);

  //PE
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
	
  //`lB
  GXSetChanCtrl(GX_COLOR0A0,
				GX_DISABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);
	
  if (HSD_CObjSetCurrent(cobj)) {
    GXLoadPosMtxImm(mat, GX_PNMTX0);
	GXClearVtxDesc();
	GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
	GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);
	GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	#define	ZMID -0.5f
	u32 col=(u32)(0x88<<24 | 0x88<<16 | 0x88<<8 |0x88);
	GXBegin(GX_QUADS, GX_VTXFMT0, 4);
		GXPosition3f32(0, 0, ZMID);
		GXColor1u32(col);
		GXTexCoord2f32(0,0);
		
		GXPosition3f32(320, 0, ZMID);
		GXColor1u32(col);
		GXTexCoord2f32(1,0);
		
		GXPosition3f32(320, 240, ZMID);
		GXColor1u32(col);
		GXTexCoord2f32(1,1);
		
		GXPosition3f32(0, 240, ZMID);
		GXColor1u32(col);
		GXTexCoord2f32(0,1);
	GXEnd();
	HSD_CObjEndCurrent();
  }
  HSD_CObjUnref( cobj );
  HSD_StateInvalidate(HSD_STATE_ALL);
}

