
#ifndef ___C_SHADOW_H___
#define ___C_SHADOW_H___

//#include "common.h"
#include "c_lobj.h"
#include "c_jobj.h"

class C_Shadow{
 public:
  C_Shadow( u16 w, u16 h, u8 i=127 );
  bool ObjExist( void ){ return (shadow->objects)?true:false; }
  //Cg̐ݒRs[B
  void SetLight( C_LObj *l );
  //eIuWFNgǉB
  void AddObject( C_JObj *j ){
	HSD_ShadowAddObject( shadow, j->GetJObj() );
  }
  void AddObject( HSD_JObj *j ){
	HSD_ShadowAddObject( shadow, j );
  }
  //eIuWFNg폜B
  void DeleteObject( C_JObj *j ){
	HSD_ShadowDeleteObject( shadow, j->GetJObj() );
  }
  void DeleteObject( HSD_JObj *j ){
	HSD_ShadowDeleteObject( shadow, j );
  }
  //e̔ZݒB
  void SetIntensity( u8 i ){
	HSD_ShadowSetIntensity(shadow, intensity = i );
  }
  u8 GetIntensity( void ){
	return intensity;
  }
  //eeNX`_OAJ̐ݒB
  void SetCamera(Vec &vecInt, f32 fDistance);
  void InitViewingRect(f32 top, f32 bottom, f32 left, f32 right);
  void AddViewingRect(f32 top, f32 bottom, f32 left, f32 right);
  //Jݒ肪ȂĂ邩ǂB
  void CheckViewingRect(void);

  //_OB
  void StartRenderShadow(void);
  void EndRenderShadow(void);

  //eݒ̎擾B
  HSD_Shadow* GetShadow( void ){ return shadow; }

  //e𗎂ƂIuWFNg̐ݒB
  void SetShadow( HSD_DObj* dobj ){
	for (; dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjSetFlags(mobj, RENDER_SHADOW);
		HSD_MObjCompileTev(mobj);
	  }
	}
  }
  void SetShadow( HSD_JObj* jobj ){

	HSD_DObj *dobj;
	for (dobj=HSD_JObjGetDObj(jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjSetFlags(mobj, RENDER_SHADOW);
		HSD_MObjCompileTev(mobj);
	  }
	}
	if( jobj->child ) SetShadow( jobj->child );
	if( jobj->next ) SetShadow( jobj->next );
  }
  void ClearShadow( HSD_JObj* jobj ){

	HSD_DObj *dobj;
	for (dobj=HSD_JObjGetDObj(jobj); dobj; dobj = HSD_DObjGetNext(dobj)) {
	  HSD_MObj *mobj;
	  if ((mobj = HSD_DObjGetMObj(dobj)) != NULL) {
		HSD_MObjClearFlags(mobj, RENDER_SHADOW);
		HSD_MObjCompileTev(mobj);
	  }
	}
	if( jobj->child ) ClearShadow( jobj->child );
	if( jobj->next ) ClearShadow( jobj->next );
  }
  
  //eeNX``B
  void  DrawTex( void );
  HSD_ViewingRect* GetViewingRect(void){ return &vrect; }


  //̕ӂ̃p[^[Zl̉𑜓xɋB
  //eAO֌WꍇƕςB
  

  //eJƉeJ_̋B
  void SetShadowCamDist( f32 );
  f32 GetShadowCamDist( void );

  //eJ̉ʁB
  void SetShadowCamFar( f32 );
  f32 GetShadowCamFar( void );

  //eJ̋ߕʁB
  void SetShadowCamNear( f32 );
  f32 GetShadowCamNear( void );

  //eeNX`ۂAƎOɂ邱ƂɂꍇB
  void SetShadowCamZOfst( f32 );
  f32 GetShadowCamZOfst( void );

 private:
  HSD_LObj* lobj;
  HSD_Shadow* shadow;
  HSD_ViewingRect vrect;
  u8 intensity;
  u16 width,height;
  f32 z_ofst;
};

#endif

