#include "common.h"
#include "c_texture.h"

C_Texture::C_Texture( TEXPalettePtr t )
{
  tpl = t;
  dvd = 0;
  Init();
}
C_Texture::C_Texture( char *fname )
{
  //*.tplǂݍ݁B
  dvd = new C_DVD(fname);
  dvd->Read();
  tpl = (TEXPalettePtr)dvd->GetAddr();
  Init();
}
void C_Texture::Init( void )
{

  if(tpl->versionNumber != 2142000 )
	OSHalt("invalid version number for texture palette");
	
  OSReport( "%0x %0x\n", (u32)tpl->descriptorArray, (u32)tpl );
  tpl->descriptorArray = (TEXDescriptorPtr)(((u32)(tpl->descriptorArray)) + ((u32)tpl));
  //ĔzuB
  for ( int i = 0; i < tpl->numDescriptors; i++ ){
	if(tpl->descriptorArray[i].textureHeader){
	  tpl->descriptorArray[i].textureHeader = 
		(TEXHeaderPtr)(((u32)(tpl->descriptorArray[i].textureHeader)) + ((u32)tpl));	

	  if(!(tpl->descriptorArray[i].textureHeader->unpacked)){
		tpl->descriptorArray[i].textureHeader->data = 
		  (Ptr)((u32)(tpl->descriptorArray[i].textureHeader->data) + (u32)tpl);
		tpl->descriptorArray[i].textureHeader->unpacked = 1;
	  }
	}

	if(tpl->descriptorArray[i].CLUTHeader){
	  tpl->descriptorArray[i].CLUTHeader = 
		(CLUTHeaderPtr)((u32)(tpl->descriptorArray[i].CLUTHeader) + (u32)tpl);		

	  if(!(tpl->descriptorArray[i].CLUTHeader->unpacked)){
		tpl->descriptorArray[i].CLUTHeader->data = 
		  (Ptr)((u32)(tpl->descriptorArray[i].CLUTHeader->data) + (u32)tpl);
		tpl->descriptorArray[i].CLUTHeader->unpacked = 1;
	  }
	}
  }

  //TexObj쐬B
  //ƂȂ̂ŁAbh̓Ro[gȂłˁB
  for ( int i = 0; i < tpl->numDescriptors; i++ ){
	GXBool mipMap;
	GXTexObj to;
	TEXDescriptorPtr tdp = tpl->descriptorArray + i;
	if(tdp->textureHeader->minLOD == tdp->textureHeader->maxLOD)
		mipMap = GX_FALSE;
	else
		mipMap = GX_TRUE;

	GXInitTexObj(&to, 
				 tdp->textureHeader->data, 
				 tdp->textureHeader->width, 
    			 tdp->textureHeader->height, 
				 (GXTexFmt)tdp->textureHeader->format,
	   			 tdp->textureHeader->wrapS, 
				 tdp->textureHeader->wrapT, 
				 mipMap); 

	
	GXInitTexObjLOD(&to, 
					GX_NEAR,
					GX_NEAR,
					//tdp->textureHeader->minFilter, 
					//tdp->textureHeader->magFilter, 
					tdp->textureHeader->minLOD, 
					tdp->textureHeader->maxLOD, 
					tdp->textureHeader->LODBias,
					GX_DISABLE,
					tdp->textureHeader->edgeLODEnable,
					GX_ANISO_1);  
	tobj.push_back( to );
	trs.push_back( C_Vec(0.f) );
  }

}

C_Texture::~C_Texture()
{
  if( dvd )delete dvd;
}

GXTexObj C_Texture::GetGXTexObj( int id )
{
  return tobj[ (u32)id ];
}

void C_Texture::Disp( int id, int ind_id )
{
  TEXDescriptorPtr tdp = tpl->descriptorArray + id;
  GXRenderModeObj *rmode = HSD_VIGetConfigure();

  Mtx44  pMtx;
  Mtx    mMtx;

  //Transform
  GXSetViewport(  0.0f, 0.0f, rmode->fbWidth, rmode->xfbHeight,  0.0f,   1.0f);
  GXSetScissor(  0, 0, rmode->fbWidth, rmode->xfbHeight);
  MTXOrtho( pMtx, 0.0f, (float)480, 0.0f, (float)640, 0.0f, 100 );
  GXSetProjection( pMtx, GX_ORTHOGRAPHIC );
  //MTXIdentity( mMtx );
  MTXTrans( mMtx, trs[(u32)id].x, trs[(u32)id].y, trs[(u32)id].z );
  GXLoadPosMtxImm( mMtx, GX_PNMTX0 );
  GXSetCurrentMtx( GX_PNMTX0 );

  //PE
  GXSetColorUpdate( GX_ENABLE );
  GXSetAlphaUpdate( GX_ENABLE );
  GXSetZMode( GX_DISABLE, GX_ALWAYS, GX_DISABLE );
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);

  //CHANNEL
  GXSetNumChans( 0 );

  //TEX
  GXLoadTexObj(&tobj[(u32)id], GX_TEXMAP0);
  if( ind_id>=0 ){
	GXLoadTexObj(&tobj[(u32)ind_id], GX_TEXMAP1);
  }

  //TEXGEN
  GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY );
  GXSetNumTexGens(1);

  //TEV
  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR_NULL);
  GXSetTevOp( GX_TEVSTAGE0, GX_REPLACE );
  GXSetNumTevStages( 1 );

  //C_CNg
  if( ind_id >= 0 ){
	GXSetNumIndStages(1);
	GXSetIndTexOrder(GX_INDTEXSTAGE0, GX_TEXCOORD0, GX_TEXMAP1);
	GXSetIndTexCoordScale(GX_INDTEXSTAGE0, GX_ITS_2, GX_ITS_2);
	GXSetTevIndWarp(GX_TEVSTAGE0,       // tev stage
					GX_INDTEXSTAGE0,    // indirect stage
					GX_TRUE,            // signed offsets?
					GX_FALSE,           // replace mode?
					GX_ITM_0);          // ind matrix select
	
	f32 indMtx[2][3];
	Mtx tmpMtx,r,s;
	MTXRotDeg(r, 'z', 0);
	MTXScale(s, 0.0f, 1.8f, 0.f );
	//MTXScale(s, trs[(u32)id].x*0.01f, trs[(u32)id].y*0.01f, 0.f );
	//OSReport( "%f %f\n", trs[(u32)id].y*0.01f );
	MTXConcat( r,s,tmpMtx );
	indMtx[0][0] = tmpMtx[0][0]*0.5f;
	indMtx[0][1] = tmpMtx[0][1]*0.5f;
	indMtx[0][2] = 0.0f;
	indMtx[1][0] = tmpMtx[1][0]*0.5f;
	indMtx[1][1] = tmpMtx[1][1]*0.5f;
	indMtx[1][2] = 0.0f;
	GXSetIndTexMtx(GX_ITM_0, indMtx, 1);
  }

  //DL
  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

#define	ZMID -0.5f
  f32 cx = rmode->viWidth * 0.5f;
  f32 cy = rmode->viHeight * 0.5f;
  f32 hw = tdp->textureHeader->width * 0.5f;
  f32 hh = tdp->textureHeader->height * 0.5f;
  GXBegin(GX_QUADS, GX_VTXFMT0, 4);{
	GXPosition3f32(cx - hw, cy - hh, ZMID);
	GXTexCoord2f32(0,0);
	
	GXPosition3f32(cx + hw, cy - hh, ZMID);
	GXTexCoord2f32(1,0);

	GXPosition3f32(cx + hw, cy + hh, ZMID);
	GXTexCoord2f32(1,1);

	GXPosition3f32(cx - hw, cy + hh, ZMID);
	GXTexCoord2f32(0,1);
  }GXEnd();
  GXSetNumIndStages(0);
  GXSetTevDirect(GX_TEVSTAGE0);
  HSD_StateInvalidate( HSD_STATE_ALL );
}





