#ifndef ___C_TEXTURE_H___
#define ___C_TEXTURE_H___

//#include "common.h"
#include "..\Lib\ghmGcMem.h"
#include "vector.h"
#include "c_dvd.h"
#include "c_vec.h"

/********************************/
typedef struct
{
    u16             numEntries;
    u8              unpacked;
    u8              pad8;

    GXTlutFmt       format;
    Ptr             data;

}CLUTHeader, *CLUTHeaderPtr;

/********************************/
typedef struct
{
    u16             height;
    u16             width;

    u32             format;
    Ptr             data;

    GXTexWrapMode   wrapS;
    GXTexWrapMode   wrapT;

    GXTexFilter     minFilter;
    GXTexFilter     magFilter;

    float           LODBias;

    u8              edgeLODEnable;
    u8              minLOD;
    u8              maxLOD;
    u8              unpacked;

}TEXHeader, *TEXHeaderPtr;

/********************************/
typedef struct
{
    TEXHeaderPtr        textureHeader;
    CLUTHeaderPtr       CLUTHeader;

}TEXDescriptor, *TEXDescriptorPtr;

/********************************/
typedef struct
{
    u32                 versionNumber;

    u32                 numDescriptors;
    TEXDescriptorPtr    descriptorArray;

}TEXPalette, *TEXPalettePtr;

class C_Texture{
 public:
  C_Texture( char *fname );
  C_Texture( TEXPalettePtr t );
  ~C_Texture();
  GXTexObj GetGXTexObj( int id = 0 );
  void Disp( int id = 0, int ind_id = -1 );
  void Trs( int id, f32 x, f32 y, f32 z ){
	trs[ (u32)id ].x = x;
	trs[ (u32)id ].y = y;
	trs[ (u32)id ].z = z;
  }
 protected:
  C_DVD *dvd;
  TEXPalettePtr tpl;
  vector<GXTexObj> tobj;
  vector<C_Vec> trs;
  void Init( void );
 private:
};


#endif

