#include "common.h"
#include "c_trigon.h"
#include "utility.h"
#include "c_border.h"
#include "K7App.h"
#include "vector.h"

#define _NO_STL_ 1

s32 C_TrigonArray::heap_no = 0;
void C_3DBBOX::SetUp( C_Vec p[], s32 num )
{
  f32 _min[3]={MAXFLOAT,};
  f32 _max[3]={-MAXFLOAT,};

  for( int i=0; i<num; i++ ){
	if( _min[0] > p[i].x ) _min[0] = p[i].x;
	if( _min[1] > p[i].y ) _min[1] = p[i].y;
	if( _min[2] > p[i].z ) _min[2] = p[i].z;
	if( _max[0] < p[i].x ) _max[0] = p[i].x;
	if( _max[1] < p[i].y ) _max[1] = p[i].y;
	if( _max[2] < p[i].z ) _max[2] = p[i].z;
  }
  min_x = _min[0];
  min_y = _min[1];
  min_z = _min[2];
  max_x = _max[0];
  max_y = _max[1];
  max_z = _max[2];
}
void C_3DBBOX::SetUp( C_Vec &p0, C_Vec &p1 )
{
  min_x = p0.x < p1.x ? p0.x : p1.x;
  min_y = p0.y < p1.y ? p0.y : p1.y;
  min_z = p0.z < p1.z ? p0.z : p1.z;
  max_x = p0.x > p1.x ? p0.x : p1.x;
  max_y = p0.y > p1.y ? p0.y : p1.y;
  max_z = p0.z > p1.z ? p0.z : p1.z;
}
void C_3DBBOX::AddRegion( f32 r )
{
  min_x -= r;
  min_y -= r;
  min_z -= r;
  max_x += r;
  max_y += r;
  max_z += r;
}

//vector<>pɕKvB
//gȂł傤
C_Trigon::C_Trigon( void )
{
}

C_Trigon::C_Trigon( C_Vec &p0, C_Vec &p1, C_Vec &p2, C_TrigonArray *_array  )
{
  p[0] = p0; p[1] = p1; p[2] = p2;
  array = _array;
  hit_edge = 0;
  SetUp();
}

void C_Trigon::DebugPrint( void )
{
  for( int i=0; i<3; i++ ){
	OSReport( "%d: %f %f %f (%d:%4d)\n", i, p[i].x, p[i].y, p[i].z, mtx_idx[i], idx[i] );
  }
  OSReport( "\n" );
}
C_Trigon::C_Trigon( C_Vec *p0, C_TrigonArray *_array, s16 *i, s16 *mi )
{
  p[0] = p0[0]; p[1] = p0[1]; p[2] = p0[2];
  if( i ){
	idx[0] = i[0];  idx[1] = i[1];  idx[2] = i[2];
  }else{
	idx[0] = idx[1] = idx[2] = -1;
  }

  if( mi ){
	mtx_idx[0] = mi[0];  mtx_idx[1] = mi[1];  mtx_idx[2] = mi[2];
  }else{
	mtx_idx[0] = mtx_idx[1] = mtx_idx[2] = -1;
  }

  array = _array;
	
  //DebugPrint();
  hit_edge = 0;
  SetUp();
}

C_Trigon::~C_Trigon()
{
}

void C_Trigon::Disp( u32 col, u32 flg )
{
#pragma unused(flg)
  if( !disp_flg ) return;

  //if( flg ){
#if 0
  if( 0 ){
	C_Vec n = (nrm*5.f) + ctr;

	GXBegin(GX_LINES, GX_VTXFMT0, 2);
	GXPosition3f32(ctr.x, ctr.y, ctr.z);
	GXColor1u32(col);
	GXPosition3f32(n.x, n.y, n.z);
	GXColor1u32(col);
	GXEnd();

	for( int i=0; i<3; i++ ){
	  if( hit_edge == (u8)i ){
		C_Vec p0 = p[i];
		C_Vec p1 = p[(i+1)%3];
		C_Vec c = (p0+p1)*0.5f;
		C_Vec n = (edge_nrm[i]*1.5f) + c;
		
		GXBegin(GX_LINES, GX_VTXFMT0, 2);
		GXPosition3f32(c.x, c.y, c.z);
		GXColor1u32(col);
		GXPosition3f32(n.x, n.y, n.z);
		GXColor1u32(col);
		GXEnd();
		hit_edge = 0;
	  }
	}
  }
#endif
  GXBegin(GX_LINESTRIP, GX_VTXFMT0, 4);
  GXPosition3f32(p[0].x, p[0].y, p[0].z);
  GXColor1u32(col);
  GXPosition3f32(p[1].x, p[1].y, p[1].z);
  GXColor1u32(col);
  GXPosition3f32(p[2].x, p[2].y, p[2].z);

  GXColor1u32(col);
  GXPosition3f32(p[0].x, p[0].y, p[0].z);
  GXColor1u32(col);
  GXEnd();

  if( hit_edge != 0  ){
	hit_edge -= 1;
	int idx0 = hit_edge;
	int idx1 = (hit_edge + 1) % 3;
	u32 col = 0xff0000ff;
	GXBegin(GX_LINES, GX_VTXFMT0, 2);
	GXPosition3f32(p[idx0].x, p[idx0].y, p[idx0].z);
	GXColor1u32(col);
	GXPosition3f32(p[idx1].x, p[idx1].y, p[idx1].z);
	GXColor1u32(col);
	GXEnd();
	hit_edge = 0;
  }

  //disp_flg = 0;
}

void C_Trigon::SetUp( void )
{
  nrm = (p[0]-p[1]) & (p[2]-p[1]);
  nrm.Nrm();
  
  ctr = p[0] + p[1] + p[2];
  ctr *= 0.3333333f;

  //GbW̖@B
  for( int i=0; i<3; i++ ){
	C_Vec p0 = p[i];
	C_Vec p1 = p[(i+1)%3];
	C_Vec l0 = ctr - p0;
	C_Vec l1 = p1 - p0;	  
	l1.Nrm();
	l1 *= (l0 | l1);
	edge_nrm[i] = l0 - l1;
	edge_nrm[i].Nrm();
  }
  disp_flg = 1;
  bbox.SetUp( p, 3 );
}

s16* C_Trigon::GetIdx( void )
{
  return idx;
}

C_Vec* C_Trigon::GetVtx( void )
{
  return p;
}

C_3DBBOX& C_Trigon::GetBBox( void )
{
  return bbox;
}

C_Vec& C_Trigon::GetNrm( void )
{
  return nrm;
}

C_Vec& C_Trigon::GetCtr( void )
{
  return ctr;
}

C_Vec& C_Trigon::GetEdgeNrm( u32 idx )
{
  return edge_nrm[idx];
}

#if 0
static
bool WithinTrigon( const Vec& vecPos, const Vec& vec0, const Vec& vec1, const Vec& vec2)
{
  Vec	nml;
  Vec	vt0, vt1, vt2;
	
#if 0
  PSVECSubtract((Vec*)&vec0, (Vec*)&vec1, &vt0);
  PSVECSubtract((Vec*)&vec1, (Vec*)&vec2, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &nml);	//O
#endif
  
  f32		fa0, fa1, fa2;
  
  PSVECSubtract((Vec*)&vec1, (Vec*)&vec0, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec0, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa0 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  PSVECSubtract((Vec*)&vec2, (Vec*)&vec1, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec1, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa1 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  PSVECSubtract((Vec*)&vec0, (Vec*)&vec2, &vt0);
  PSVECSubtract((Vec*)&vecPos, (Vec*)&vec2, &vt1);
  PSVECCrossProduct(&vt0, &vt1, &vt2);	//O
  fa2 = PSVECDotProduct(&nml, &vt2);		//
  //if( PSVECMag(&vt2)<1.f ) return false;
  
  if ((fa0>=0 && fa1>=0 && fa2>=0) || (fa0<=0 && fa1<=0 && fa2<=0)) return true;

  return false;
}
#endif
bool C_Trigon::Include(const C_Vec &_p)
{
	return Include(*((const Vec*)&_p));
}
bool C_Trigon::Include(const Vec &_p)
{
	int			i;
	Vec			*p0,*p1;
	Vec			edge,cdir,op;
	f32			ip0,ip;
	ip0 = 0.0f;
	for(i=0,p1=&p[2] ; i<3 ; i++,p1=p0){
		p0 = &p[i];
		PSVECSubtract( p1,p0,&edge);
		PSVECSubtract(&_p,p0,&cdir);
		PSVECCrossProduct(&cdir,&edge,&op);
		ip = PSVECDotProduct(&op,&nrm);
		if( ip0==0.0f ){
			ip0 = ip;
		}else if( ip0 > 0.0f ){
			if( ip < 0.0f ){
				return false;
			}
		}else{
			if( ip > 0.0f ){
				return false;
			}
		}
	}
	return true;
}
bool C_Trigon::GetCrossEdge( C_Vec &_s, C_Vec &_e, C_Vec &_n, C_Vec &_p )
{
#pragma unused(_p)
  //x,zʂɓeB
  C_Vec e,s;
#if 1
  if( !array ) return false;

  //_s,_e̓O[oȂ̂ŁAC_Trigoñ[JɕϊB
  MTXMultVec( array->GetIMtx(), &_s, &s ); s.y = 0.f;
  MTXMultVec( array->GetIMtx(), &_e, &e ); e.y = 0.f;
  C_Vec dir = e - s; 
  if( !dir.IsZero() ) dir.Nrm();
  s -= (dir*0.5f);

  //ӂ̖@ɂ܂łꍇ͂ȂB

  for( int i=0; i<3; i++ ){
	C_Vec p0 = p[i];
	C_Vec p1 = p[(i+1)%3];
	p0.y = 0.f;
	p1.y = 0.f;
	C_BorderLine l( p0, p1, edge_nrm[i], -1, -1 );

	//ӂ̖@ƐisB
	if( (edge_nrm[i] | (dir)) <= 0 ){
	  //ӂƁAisĂ邩H
	  if( l.Cross( s, e ) ) {
		MTXMultVecSR( array->GetMtx(), &edge_nrm[i], &_n );
		hit_edge = (u8)(i+1);
		return true;
	  }
	}
  }
  return false;
#else
  e = _e; e.y = 0.f;
  s = _s; s.y = 0.f;

  //B
  C_Vec dir = e - s;
#if 0
  if( WithinTrigon( e, p[0], p[1], p[2] ) ) 
	OSReport( "end in\n" );
  else
	OSReport( "end out\n" );

  if( WithinTrigon( s, p[0], p[1], p[2] ) ) 
	OSReport( "start in\n" );
  else
	OSReport( "start out\n" );
#endif
	
  //ӂɏĂꍇlB
  //s -= (dir*0.5f);

  for( int i=0; i<3; i++ ){
	C_Vec p0 = p[i];
	C_Vec p1 = p[(i+1)%3];
	p0.y = 0.f;
	p1.y = 0.f;
	C_Vec l0 = p1 - p0;
	C_Vec l1 = s - p0;
	C_Vec l2 = e - p0;
	C_Vec cp01 = l0 & l1;
	C_Vec cp02 = l0 & l2;
	//܂B
#if 0
	OSReport( "%d : %f\n", i, (cp01|cp02) );
	HSD_DmpVector( " cp01", &cp01 );
	HSD_DmpVector( " cp02", &cp02 );
	HSD_DmpVector( " p0", &p0 );
	HSD_DmpVector( " p1", &p1 );
	HSD_DmpVector( " s", &s );
	HSD_DmpVector( " e", &e );
	HSD_DmpVector( " l0", &l0 );
	HSD_DmpVector( " l1", &l1 );
	HSD_DmpVector( " l2", &l2 );
#endif
	if( (cp01 | cp02) <= 0.f && (edge_nrm[i] | dir) <= 0.f){
	  _n = edge_nrm[i];

	  //isɋ߂̒_ԂB
	  l0 = p0 - s;
	  if( (dir|l0) > 0.f )
		_p = p0;
	  else
		_p = p1;

	  //fobO\pB
	  //hit_edge = (s16)i;

	  return true;
	}
  }
  //HSD_DmpVector( "", &dir );
  return false;
#endif
}

static
u32 GetStride( HSD_VtxDescList *desc, u32 size[] )
{
  u32 stride=0;

  for ( ; desc && desc->attr != GX_VA_NULL; desc++) {
	switch (desc->attr) {
	case GX_VA_PNMTXIDX:
	case GX_VA_TEX0MTXIDX:
	case GX_VA_TEX1MTXIDX:
	case GX_VA_TEX2MTXIDX:
	case GX_VA_TEX3MTXIDX:
	case GX_VA_TEX4MTXIDX:
	case GX_VA_TEX5MTXIDX:
	case GX_VA_TEX6MTXIDX:
	case GX_VA_TEX7MTXIDX:
	  //TCY͏ɁAu8Ȃ̂Ŏۂɂ͐ӖB
	  stride += 1; size[4]++;
	  break;
	case GX_VA_POS:
	  if (desc->attr_type == GX_INDEX16) {
		stride += 2; size[0] = 2;
	  } else {
		stride += 1; size[0] = 1;
	  }
	  break;
	case GX_VA_NRM:
	case GX_VA_NBT:
	  if (desc->attr_type == GX_INDEX16) {
		stride += 2; size[1] = 2;
	  } else {
		stride += 1; size[1] = 1;
	  }
	  break;
	case GX_VA_TEX0:
	case GX_VA_TEX1:
	case GX_VA_TEX2:
	case GX_VA_TEX3:
	case GX_VA_TEX4:
	case GX_VA_TEX5:
	case GX_VA_TEX6:
	case GX_VA_TEX7:
	  if (desc->attr_type == GX_INDEX16) {
		stride += 2; size[2] = 2;
	  } else {
		stride += 1; size[2] = 1;
	  }
	  break;
	case GX_VA_CLR0:
	case GX_VA_CLR1:
	  if (desc->attr_type == GX_INDEX16) {
		stride += 2; size[3] = 2;
	  } else
		if (desc->attr_type == GX_INDEX8) {
		  stride += 1; size[3] = 1;
		} else{//_CNgB
		  switch (desc->comp_type) {
		  case GX_RGB565:
		  case GX_RGBA4:
			stride += 2; size[3] = 2;
			break;
		  case GX_RGB8:
		  case GX_RGBA6:
			stride += 3; size[3] = 3;
			break;
		  case GX_RGBA8:
		  case GX_RGBX8:
			stride += 4; size[3] = 4;
			break;
		  }
		}
	  break;
	default:
	  break;
	}
  }
  
  return stride;
}

static s16 gIdx;
static s16 gMtxIdx;
static s32 gEnvelopeFlg;
//f32
inline void GetVertexF32X16(void* pvtxbuff, u8 *dl, int dp, Vec *pv) { 
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u16*)dl);
  *pv = *((Vec*)pvtxbuff + *(u16*)dl); dp/*dummy*/; 
}
inline void GetVertexF32X8 (void* pvtxbuff, u8 *dl, int dp, Vec *pv) { 
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u8*)dl);
  *pv = *((Vec*)pvtxbuff + *(u8 *)dl); dp/*dummy*/; 
}
//u8,s8
typedef struct { u8  x, y, z; } VecU8;
typedef struct { s8  x, y, z; } VecS8;
inline void GetVertexU8X16(void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u16*)dl);
  pv->x = (f32)((VecU8*)pvtxbuff + *(u16*)dl)->x / dp;
  pv->y = (f32)((VecU8*)pvtxbuff + *(u16*)dl)->y / dp;
  pv->z = (f32)((VecU8*)pvtxbuff + *(u16*)dl)->z / dp;
}
inline void GetVertexU8X8 (void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u8*)dl);
  pv->x = (f32)((VecU8*)pvtxbuff + *(u8 *)dl)->x / dp;
  pv->y = (f32)((VecU8*)pvtxbuff + *(u8 *)dl)->y / dp;
  pv->z = (f32)((VecU8*)pvtxbuff + *(u8 *)dl)->z / dp;
}
inline void GetVertexS8X16(void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u16*)dl);
  pv->x = (f32)((VecS8*)pvtxbuff + *(u16*)dl)->x / dp;
  pv->y = (f32)((VecS8*)pvtxbuff + *(u16*)dl)->y / dp;
  pv->z = (f32)((VecS8*)pvtxbuff + *(u16*)dl)->z / dp;
}
inline void GetVertexS8X8 (void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u8*)dl);
  pv->x = (f32)((VecS8*)pvtxbuff + *(u8 *)dl)->x / dp;
  pv->y = (f32)((VecS8*)pvtxbuff + *(u8 *)dl)->y / dp;
  pv->z = (f32)((VecS8*)pvtxbuff + *(u8 *)dl)->z / dp;
}

//u16,s16
typedef struct { u16 x, y, z; } VecU16;
typedef struct { s16 x, y, z; } VecS16;
inline void GetVertexU16X16(void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u16*)dl);
  pv->x = (f32)((VecU16*)pvtxbuff + *(u16*)dl)->x / dp;
  pv->y = (f32)((VecU16*)pvtxbuff + *(u16*)dl)->y / dp;
  pv->z = (f32)((VecU16*)pvtxbuff + *(u16*)dl)->z / dp;
}
inline void GetVertexU16X8 (void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u8*)dl);
  pv->x = (f32)((VecU16*)pvtxbuff + *(u8 *)dl)->x / dp;
  pv->y = (f32)((VecU16*)pvtxbuff + *(u8 *)dl)->y / dp;
  pv->z = (f32)((VecU16*)pvtxbuff + *(u8 *)dl)->z / dp;
}
inline void GetVertexS16X16(void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u16*)dl);
  pv->x = (f32)((VecS16*)pvtxbuff + *(u16*)dl)->x / dp;
  pv->y = (f32)((VecS16*)pvtxbuff + *(u16*)dl)->y / dp;
  pv->z = (f32)((VecS16*)pvtxbuff + *(u16*)dl)->z / dp;
}
inline void GetVertexS16X8 (void* pvtxbuff, u8 *dl, int dp, Vec *pv){
  if( gEnvelopeFlg ) {gMtxIdx = (s16)((*dl)/3); dl+=gEnvelopeFlg;}
  gIdx = (s16)(*(u8*)dl);
  pv->x = (f32)((VecS16*)pvtxbuff + *(u8 *)dl)->x / dp;
  pv->y = (f32)((VecS16*)pvtxbuff + *(u8 *)dl)->y / dp;
  pv->z = (f32)((VecS16*)pvtxbuff + *(u8 *)dl)->z / dp;
}

static 
bool IsValid( C_Vec p[3] )
{
  C_Vec v0,v1,nrm;
//  VECSubtract( &p[2], &p[1], &v0 );
//  VECSubtract( &p[0], &p[1], &v1 );
  PSVECSubtract( &p[2], &p[1], &v0 );
  PSVECSubtract( &p[0], &p[1], &v1 );
  
  //                                   PSVEC  C_VEC ̈ႢŋNs΍B
  if( v0.IsZero() || v1.IsZero() || v0==v1 ){
	return false;
  }

  PSVECCrossProduct( &v0, &v1, &nrm );
  if( !nrm.IsValid() || nrm.IsZero()){
	return false;
  }
  nrm.Nrm();

  if( !nrm.IsValid() ){
	return false;
  }else{
	return true;
  }
}

C_TrigonArray::C_TrigonArray( f32 size, s32 row, s32 col )
{
  trigon_num = 0;

  jobj = 0;
  MTXIdentity( cur_mtx );
  MTXIdentity( old_mtx );
  MTXInverse( cur_mtx, cur_inv_mtx );
  MTXInverse( old_mtx, old_inv_mtx );
  status.dirty = 0;

  f32 ofst_r = size * row * 0.5f;
  f32 ofst_c = size * col * 0.5f;

#if _NO_STL_
  if( !heap_no )
	trigon = (C_Trigon*)K7AppSmallMemAlloc( (int)((sizeof(C_Trigon) * (col-1)*(row-1))) );
  else
	trigon = (C_Trigon*)ghmGcMem::mDefaultHeap.Alloc((int)((sizeof(C_Trigon) * (col-1)*(row-1))) );
  if( trigon == 0 ) return ;
#endif
  for( int i=0; i<(col-1); i++ ){
	for( int j=0; j<(row-1); j++ ){
	  C_Vec p0( size*i - ofst_c, 0.f, size*j - ofst_r );
	  C_Vec p1( size*(i+1) - ofst_c, 0.f, size*j - ofst_r );
	  C_Vec p2( size*(i+1) - ofst_c, 0.f, size*(j+1) - ofst_r );
	  C_Vec p3( size*i - ofst_c, 0.f, size*(j+1) - ofst_r );

#if _NO_STL_
	  trigon[trigon_num++] = C_Trigon(p0,p1,p2, this );
	  trigon[trigon_num++] = C_Trigon(p0,p2,p3, this );
#else
	  trigon.push_back( C_Trigon(p0, p1, p2, this) );
	  trigon_num ++;
	  
	  trigon.push_back( C_Trigon(p0, p2, p3, this) );
	  trigon_num ++;
#endif
	}
  }
}

C_TrigonArray::C_TrigonArray( HSD_PObj *pobj, HSD_JObj *j )
{
  C_Vec p[3];

  trigon_num = 0;

  jobj = j;
  MTXIdentity( cur_mtx );
  MTXIdentity( old_mtx );
  MTXInverse( cur_mtx, cur_inv_mtx );
  MTXInverse( old_mtx, old_inv_mtx );
  status.dirty = 0;

  u32 num_vert,num_tri;
  HSD_PObjCountVertices( pobj, &num_vert, &num_tri );
#if _NO_STL_
  if( !heap_no )
	trigon = (C_Trigon*)K7AppSmallMemAlloc( (int)((sizeof(C_Trigon) * num_tri)) );
  else
	trigon = (C_Trigon*)ghmGcMem::mDefaultHeap.Alloc((int)((sizeof(C_Trigon) * num_tri)) );
  if( trigon == 0 ) return ;
#else
  trigon.reserve( num_tri );
#endif

  //SPObjJԂB
  for( ; pobj; pobj = (jobj ? HSD_PObjGetNext(pobj) : (HSD_PObj*)0) ){

	gMtxIdx = 0;

	//DL̃AhXB
	u8 *dl_begin = pobj->dl;
	u8 *dl_end = dl_begin + (pobj->dlsize << 5);

	u32 size[5]={0,};
#if 0
	u32 stride = GetStride( pobj->desc_list, size );
	Vec* base_ptr = (Vec*)pobj->desc_list->base_ptr;
	GXCompType comp_type = pobj->desc_list->comp_type;
	//_̈ʒuB
	int dot = 1 << pobj->desc_list->frac;
#else
	u32 stride = GetStride( pobj->desc_list, size );

	//GF[vfΉB
	gEnvelopeFlg = (s16)size[4];

	//_񂾂KvB
	HSD_VtxDescList *desc;
	for (desc = pobj->desc_list; desc->attr != GX_VA_NULL; desc++) {
	  if( desc->attr == GX_VA_POS ) break;
	}

	Vec* base_ptr = (Vec*)desc->base_ptr;
	GXCompType comp_type = desc->comp_type;
	//_̈ʒuB
	int dot = 1 << desc->frac;
#endif

	void	(*GetVertex)(void*, u8*, int, Vec*);
	switch (comp_type) {
	case GX_U8:
		GetVertex = (size[0] == 2) ? GetVertexU8X16 : GetVertexU8X8;
		break;
	case GX_S8:
		GetVertex = (size[0] == 2) ? GetVertexS8X16 : GetVertexS8X8;
		break;
	case GX_U16:
		GetVertex = (size[0] == 2) ? GetVertexU16X16 : GetVertexU16X8;
		break;
	case GX_S16:
		GetVertex = (size[0] == 2) ? GetVertexS16X16 : GetVertexS16X8;
		break;
	case GX_F32:
		GetVertex = (size[0] == 2) ? GetVertexF32X16 : GetVertexF32X8;
		break;
	}
	

	for( u8 *dl = dl_begin; dl<dl_end; ){
	  s16 idx[3],mtx_idx[3];
	  GXPrimitive prim = (GXPrimitive)( dl[0] & GX_OPCODE_MASK );
	  GXVtxFmt vtxfmt = (GXVtxFmt)( dl[0] & GX_VAT_MASK );
	  int num = dl[1] << 8 | dl[2];

	  dl += 3;

	  switch (prim) {
	  case GX_NOP:
		break;
	  case GX_POINTS:
	  case GX_LINES:
	  case GX_LINESTRIP:
		dl += stride * num;
		break;
	  case GX_TRIANGLES:
		num /= 3;
		for (int i = 0; i < num; i++) {
		  GetVertex(base_ptr, dl+stride*0, dot, &p[0]); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*1, dot, &p[1]); idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*2, dot, &p[2]); idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  if( IsValid( p ) ){
#if 0
			trigon.push_back( C_Trigon(p,this,idx,mtx_idx) );
			trigon_num ++;
#else
			trigon[trigon_num++] = C_Trigon(p,this,idx,mtx_idx);
#endif
		  }
		  dl += stride * 3;
		}
		break;
	  case GX_TRIANGLESTRIP:
		for (int i = 2; i < num; i++) {
		  if (i & 1) {
			GetVertex(base_ptr, dl+stride*0, dot, &p[0]); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
			GetVertex(base_ptr, dl+stride*2, dot, &p[1]); idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
			GetVertex(base_ptr, dl+stride*1, dot, &p[2]); idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  } else {
			GetVertex(base_ptr, dl+stride*0, dot, &p[0]); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
			GetVertex(base_ptr, dl+stride*1, dot, &p[1]); idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
			GetVertex(base_ptr, dl+stride*2, dot, &p[2]); idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  }
		  if( IsValid(p) ){
#if 0
			trigon.push_back( C_Trigon(p,this,idx,mtx_idx) );
			trigon_num ++;
#else
			trigon[trigon_num++] = C_Trigon(p,this,idx,mtx_idx);
#endif
		  }
		  dl += stride;
		}
		dl += stride * 2;
		break;
	  case GX_TRIANGLEFAN:
		C_Vec vs;
		GetVertex(base_ptr, dl+stride*0, dot, &vs); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
		for (int i = 2; i < num; i++) {
		  p[0] = vs;
		  GetVertex(base_ptr, dl+stride*1, dot, &p[1]); idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*2, dot, &p[2]); idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  if( IsValid(p) ){
#if 0
			trigon.push_back( C_Trigon(p,this,idx,mtx_idx) );
			trigon_num ++;
#else
			trigon[trigon_num++] = C_Trigon(p,this,idx,mtx_idx);
#endif
		  }
		  dl += stride;
		}
		dl += stride * 2;
		break;
	  case GX_QUADS:
		num /= 4;
		for (int i = 0; i < num; i++) {
		  GetVertex(base_ptr, dl+stride*0, dot, &p[0]); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*1, dot, &p[1]);	idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*2, dot, &p[2]);	idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  if( IsValid(p) ){
#if 0
			trigon.push_back( C_Trigon(p,this,idx,mtx_idx) );
			trigon_num ++;
#else
			trigon[trigon_num++] = C_Trigon(p,this,idx,mtx_idx);
#endif
		  }
		  GetVertex(base_ptr, dl+stride*0, dot, &p[0]); idx[0] = gIdx; mtx_idx[0] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*2, dot, &p[1]);	idx[1] = gIdx; mtx_idx[1] = gMtxIdx;
		  GetVertex(base_ptr, dl+stride*3, dot, &p[2]);	idx[2] = gIdx; mtx_idx[2] = gMtxIdx;
		  if( IsValid(p) ){
#if 0
			trigon.push_back( C_Trigon(p,this,idx,mtx_idx) );
			trigon_num ++;
#else
			trigon[trigon_num++] = C_Trigon(p,this,idx,mtx_idx);
#endif
		  }
		  dl += stride * 4;
		}
		break;
	  default:
		break;
	  }
	}

  }
}

C_TrigonArray::~C_TrigonArray()
{
  //ghmGcMem::mDefaultHeap.Free(trigon);
  GHMGCMEM_SAFE_FREE( trigon );
}


void C_TrigonArray::DispStart( void )
{
  HSD_CObj *cobj = HSD_CObjGetCurrent();

  GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
  GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  GXSetNumTevStages(1);
  GXSetNumTexGens(0);
  GXSetBlendMode(GX_BM_NONE, GX_BL_SRCALPHA, GX_BL_INVSRCALPHA, GX_LO_CLEAR);
  GXSetChanCtrl(GX_COLOR0A0,
				GX_ENABLE,		// enable channel
				GX_SRC_VTX,		// amb source
				GX_SRC_VTX,		// mat source
				GX_LIGHT_NULL,	// light mask
				GX_DF_CLAMP,	// diffuse function
				GX_AF_NONE);
  GXSetNumChans(1);

  GXLoadPosMtxImm(HSD_CObjGetViewingMtxPtr(cobj), GX_PNMTX0);
  GXSetCurrentMtx( GX_PNMTX0 );

  GXClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS,  GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0,  GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS,  GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetLineWidth( (u8)16,GX_TO_ZERO );
}

void C_TrigonArray::DispEnd( void )
{
  HSD_StateInvalidate( HSD_STATE_ALL );
}

void C_TrigonArray::Disp( u32 idx, u32 flg, u32 col )
{
#pragma unused(flg)

  //|SƂΑǁA
  //ǂfobOpȂ̂ŃdB
#if 1
  C_Vec vtx[3];
  //todo VecC_Vec̃TCYłȂƂ΂ȂH
  MTXMultVecArray(cur_mtx, trigon[idx].p, vtx, 3);
  C_Trigon tnew( vtx,this );
  //tnew.Disp(col,flg);
  tnew.Disp(col,1);
#else
  trigon[idx].Disp( col,flg );
#endif
}

void C_TrigonArray::Proc( void )
{
  status.dirty = 0;
  if( jobj ){
	HSD_JObjSetupMatrix( jobj );
	//jobj̈ړgꍇB
	if( !ISSAMEMTX((jobj->mtx), cur_mtx) ){
	  //}gNXύXꂽB
	  status.dirty = 1;
	  MTXCopy( cur_mtx, old_mtx );
	  MTXCopy( cur_inv_mtx, old_inv_mtx );
	  MTXCopy( jobj->mtx, cur_mtx );
	  MTXInverse( cur_mtx, cur_inv_mtx );
	}
  }else{
	//vOꍇB
	if( !ISSAMEMTX(old_mtx, cur_mtx) ){
	  //}gNXύXꂽB
	  status.dirty = 1;
	  MTXCopy( cur_mtx, old_mtx );
	  MTXCopy( cur_inv_mtx, old_inv_mtx );
	  MTXCopy( cur_mtx, cur_mtx );
	  MTXInverse( cur_mtx, cur_inv_mtx );
	}
  }
}

bool C_TrigonArray::Include(const C_Vec &_p)
{
	return Include(*((Vec*)&_p));
}

bool C_TrigonArray::Include(const Vec &_p)
{
	int		i;
	Vec		pos;
	MTXMultVec(cur_inv_mtx,&_p,&pos);
	for(i=0 ; i<trigon_num ; i++){
		if( trigon[i].Include(pos)==true ){
			return true;
		}
	}
	return false;
}

