#ifndef ___C_TUMOR_H___
#define ___C_TUMOR_H___
//#include "common.h"
#include "c_particle.h"
#include "..\Wat\WK7Obj.h"
#include "..\Wat\K7ID.h"

enum TUMOR_LEVEL{
  TUMOR_NONE = -1,
  TUMOR_LOW,
  TUMOR_MID,
  TUMOR_HIGH,
  TUMOR_MAX,
};
class C_TumorSet{
 public:
  C_TumorSet( WK7JObj *bone0, WK7JObj *bone1 = 0, WK7JObj *bone2 = 0, 
			  WK7JObj *bone3=0, WK7JObj *bone4=0, WK7JObj *bone5=0 );
  void Proc( const Vec &_eye, const f32 _dist );
  void Start( s32 _idx, TUMOR_LEVEL _level );
  void Stop( s32 _idx );
  TUMOR_LEVEL AddLevel( s32 _idx );
  TUMOR_LEVEL SubLevel( s32 _idx );
  TUMOR_LEVEL SetLevel( s32 _idx, TUMOR_LEVEL _level );
  virtual ~C_TumorSet();
 protected:

  //ᇁB
  class C_Tumor{
	friend class C_TumorSet;
  public:
	C_Tumor( void );
	virtual ~C_Tumor();
	void Init( WK7JObj *_bone );
	void Proc( const Vec &_eye, const f32 _dist=-5.f );
	void Start( TUMOR_LEVEL _level );
	void Stop( void );
	TUMOR_LEVEL AddLevel( void );
	TUMOR_LEVEL SubLevel( void );
	TUMOR_LEVEL SetLevel( TUMOR_LEVEL _level );
  protected:
	//xƃp[eBNhčB
	class C_Level{
	public:
	  C_Level( TUMOR_LEVEL _l = TUMOR_NONE );
	  C_Level& operator ++ ();
	  C_Level& operator -- ();
	  C_Level& operator = ( TUMOR_LEVEL _level );
	  operator TUMOR_LEVEL ();
	  s32 GetPtclNo( void );
	  ~C_Level();
	protected:
	  s32 Regulate( void );
	  s32 pno[TUMOR_MAX];
	  s32 level;
	private:
	};
	  
	
	void SetupJObj( void );
	void SetupGen( TUMOR_LEVEL _level = TUMOR_LOW );
	WK7JObj *parent_bone;
	C_Generator *gen;
	HSD_JObj *parent_jobj, *jobj;
	C_Level level;
	bool fire;
  };
  C_Tumor tumor[NPCWEAKOBJID_MAX];
 private:
};

#endif
