
#ifndef	__FMAIN_H__
#define	__FMAIN_H__

#include "mobj.h"
//#include "common.h"
#include <vector>
#include "utility.h"
#include "c_dvd.h"
#include "c_scene.h"
#include "c_scenedesc.h"
#include "c_shader.h"
#include "c_shadow.h"
#include "c_trigon.h"
#include "c_cyclic.h"
#include "c_coll.h"
#include "c_ball.h"
#include "c_perf.h"
#include "c_font.h"
#include "..\Lib\ghmGcAppTask.h"
#include "..\Wat\K7App.h"

class C_SphereCam {
 public:
  C_SphereCam( void ) : int_pos(0.f,10.f,0.f){
	latitude = 90.f;
	longtitude = -90.f;
	length = 40.f;
	tick = 2.f;
	scl = 1.f;
	Proc();
  }
  void Proc( void ){
	f32 s_la = sinf( latitude * (f32)M_PI / 180.f );
	f32 s_lo = sinf( longtitude * (f32)M_PI / 180.f );
	f32 c_la = cosf( latitude * (f32)M_PI / 180.f );
	f32 c_lo = cosf( longtitude * (f32)M_PI / 180.f );
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
	  Mtx m;
	  GetMtx( m );
	  C_Vec y( m[1][0], m[1][1], m[1][2] );
	  C_Vec x( m[0][0], m[0][1], m[0][2] );
	  y *= scl;
	  x *= scl;
	  if( HSD_PadGetButton(0) & HSD_PAD_UP ) int_pos += y;
	  if( HSD_PadGetButton(0) & HSD_PAD_DOWN ) int_pos -= y;
	  if( HSD_PadGetButton(0) & HSD_PAD_LEFT ) int_pos += x;
	  if( HSD_PadGetButton(0) & HSD_PAD_RIGHT ) int_pos -= x;
	}else{
	  if( HSD_PadGetButton(0) & HSD_PAD_RIGHT ) longtitude += tick;
	  if( HSD_PadGetButton(0) & HSD_PAD_LEFT ) longtitude -= tick;
	  if( HSD_PadGetButton(0) & HSD_PAD_UP ) latitude += tick;
	  if( HSD_PadGetButton(0) & HSD_PAD_DOWN ) latitude -= tick;
	  if( latitude < 1.f ) latitude = 1.f;
	  if( latitude > 179.f ) latitude = 179.f;
	}

	if( HSD_PadGetButton(0) & HSD_PAD_L ) length -= scl;
	if( HSD_PadGetButton(0) & HSD_PAD_R ) length += scl;
	if( length <= 0 ) length = 1.f;

	eye_pos.x = int_pos.x + s_la * c_lo * length;
	eye_pos.y = int_pos.y + c_la * length;
	eye_pos.z = int_pos.z + s_la * s_lo * length;
  }
  void Copy( C_CObj *cobj ){
	cobj->SetInterest( int_pos );
	cobj->SetEyePos( eye_pos );
  }
  void GetMtx( Mtx m ){
	C_Vec view = int_pos - eye_pos;
	view.Nrm();
	C_Vec up( 0.f, 1.f, 0.f );
	C_Vec left = up & view;
	up = left & view;
	m[0][0] = left.x; m[0][1] = left.y; m[0][2] = left.z;
	m[1][0] = up.x; m[1][1] = up.y; m[1][2] = up.z;
	m[2][0] = view.x; m[2][1] = view.y; m[2][2] = view.z;
  }
  void SetScale( f32 _scl ){
	scl = _scl;
  }
  void SetIntPos( C_Vec eye ){
	int_pos = eye;
  }
  C_Vec GetIntPos( void ){
	return int_pos;
  }
  void SetLatitude( f32 lat ){
	latitude = lat;
  }
  void SetLongtitude( f32 lon ){
	longtitude = lon;
  }
  void SetLength( f32 len ){
	length = len;
  }
  void Print( void ){
	OSReport( "int_pos: %f %f %f\n", int_pos.x, int_pos.y, int_pos.z );
	OSReport( "eye_pos: %f %f %f\n", eye_pos.x, eye_pos.y, eye_pos.z );
	OSReport( "lat:     %f\n", latitude );
	OSReport( "lon:     %f\n", longtitude );
	OSReport( "len:     %f\n", length );
	OSReport( "scl:		%f\n", scl );
  }
 private:
  C_Vec int_pos;
  C_Vec eye_pos;
  f32 latitude,longtitude,length,tick,scl;
};
class FK7MainTask : public ghmGcAppTask{
protected:
  ghmGcApp *_pApp;
public:
	FK7MainTask(ghmGcApp *pApp,int prio=GHMGCLIST_DEFAULT_PRIO);
	virtual ~FK7MainTask();
	
	// R[obN
	virtual bool InitializeCallBack(void);
	
	// IR[obN
	virtual bool TerminateCallBack(void);
	
	// t[
	virtual bool FrameProcess(void);
	
	// _O
	virtual bool RenderProcess(void);
};

#endif

