/*
 * Copyright 1999-2002 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: displayfunc.c,v 1.10 2004/08/06 09:26:03 TypeR Exp $
 */

#ifdef FUJITA
#pragma cplusplus			off
#pragma cpp_extensions		off
#pragma warn_implicitconv	off
#endif

#include <string.h>
#include "sysdolphin/baselib/config.h"
#include "sysdolphin/baselib/displayfunc.h"
#include "sysdolphin/baselib/debug.h"
#include "sysdolphin/baselib/mtx.h"
#include "sysdolphin/baselib/cobj.h"
#include "sysdolphin/baselib/lobj.h"
#include "sysdolphin/baselib/quatlib.h"
#include "sysdolphin/baselib/tev.h"
#include "sysdolphin/baselib/state.h"
#include "sysdolphin/baselib/list.h"
#include "sysdolphin/baselib/memory.h"
#include "sysdolphin/baselib/perf.h"
#include "sysdolphin/baselib/util.h"

static HSD_PtclCallback sptcl_callback = NULL; /* static(JObjǏ]^)
						  p[eBN */
static GXColor hsd_background_color = {0, 0, 0, 0};

static HSD_ObjAllocData zlist_alloc_data;

typedef struct _HSD_ZList HSD_ZList;

#ifdef	WATANABE
typedef	void HSD_ZListCallbackFunc(void *pData);
void					*pZListCallbackData     = NULL;
HSD_ZListCallbackFunc	*pPreZListCallbackFunc  = NULL;
HSD_ZListCallbackFunc	*pPostZListCallbackFunc = NULL;
HSD_ZListCallbackFunc	*pZListRenderObjCallbackFunc = NULL;
void					*pZListRenderObj = NULL;
u32						ZListMirrorType = 0;
Vec						ZListMirrorPos;
u32						ZListPrio = 0;

void HSD_ZListSetPrio(u32 prio);
void HSD_ZListSetPrio(u32 prio)
{
	ZListPrio = prio;
}

void HSD_ZListSetRenderObj(HSD_ZListCallbackFunc *pRenderObjCallbackFunc,void *pRenderObj,u32 mirrorType,const Vec *pMirrorPos);
void HSD_ZListSetRenderObj(HSD_ZListCallbackFunc *pRenderObjCallbackFunc,void *pRenderObj,u32 mirrorType,const Vec *pMirrorPos)
{
	pZListRenderObjCallbackFunc = pRenderObjCallbackFunc;
	pZListRenderObj = pRenderObj;
	ZListMirrorType = mirrorType;
	if( pMirrorPos!=NULL ){
		ZListMirrorPos = *pMirrorPos;
	}
}

void HSD_ZListSetCallbackFunc(HSD_ZListCallbackFunc *pPreCallbackFunc,HSD_ZListCallbackFunc *pPostCallbackFunc,void *pData);
void HSD_ZListSetCallbackFunc(HSD_ZListCallbackFunc *pPreCallbackFunc,HSD_ZListCallbackFunc *pPostCallbackFunc,void *pData)
{
	pZListCallbackData     = pData;
	pPreZListCallbackFunc  = pPreCallbackFunc;
	pPostZListCallbackFunc = pPostCallbackFunc;
}
#endif

struct _HSD_ZList {
  Mtx pmtx;
  MtxPtr vmtx;
  HSD_JObj *jobj;
  u32 rendermode;

  struct {
    HSD_ZList *texedge;
    HSD_ZList *xlu;
  } sort;

  HSD_ZList *next;

#ifdef	WATANABE
	HSD_ZListCallbackFunc	*pPreCallbackFunc;
	HSD_ZListCallbackFunc	*pPostCallbackFunc;
	void					*pCallbackData;
	HSD_ZListCallbackFunc	*pRenderObjCallbackFunc;
	void					*pRenderObj;
	u32						mirrorType;
	Vec						mirrorPos;
	int						prio;
#endif
};

static int	 zsort_listing = 0;
static int	 zsort_sorting = 0;

static HSD_ZList *zlist_top = NULL;
static HSD_ZList **zlist_bottom = &zlist_top;

static HSD_ZList *zlist_texedge_top = NULL;
static HSD_ZList **zlist_texedge_bottom = &zlist_texedge_top;
static int	 zlist_texedge_nb = 0;

static HSD_ZList *zlist_xlu_top = NULL;
static HSD_ZList **zlist_xlu_bottom = &zlist_xlu_top;
static int	 zlist_xlu_nb = 0;


HSD_ObjAllocData *
HSD_ZListGetAllocData(void)
{
  return &zlist_alloc_data;
}

void
HSD_ZListInitAllocData(void)
{
  HSD_ObjAllocInit(&zlist_alloc_data, sizeof(HSD_ZList), 4);
}

static HSD_ZList *
HSD_ZListAlloc(void)
{
  HSD_ZList *list;

  list = HSD_ObjAlloc(&zlist_alloc_data);
  memset(&list->vmtx, 0, sizeof(HSD_ZList) - sizeof(Mtx));

  return list;
}

static void
HSD_ZListFree(HSD_ZList *ptr)
{
  HSD_ObjFree(&zlist_alloc_data, ptr);
}

/**
 * @package State
 * 
 * e`惂[hPOS/CLR0̃_CNg[hɐݒ肷B
 * 
 * _O[h̐ݒ莞ɂ  rendermode RENDER_ZMODE_ALWAYS
 * RENDER_NO_ZUPDATE B
 * 
 * @see HSD_SetupRenderMode
 */
void
HSD_StateInitDirect(GXVtxFmt fmt, u32 rendermode)
{
#if 0
  static int c;

  HSD_Report("HSD_StateInitDirect in (%d)\n", c);
#endif
  HSD_ClearVtxDesc();
  GXSetVtxAttrFmt(fmt, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(fmt, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  HSD_StateInitTev();
  HSD_SetupRenderMode(rendermode|RENDER_ZMODE_ALWAYS|RENDER_NO_ZUPDATE);
  GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);
  GXSetCurrentMtx(GX_PNMTX0);
}

/*
 * joint Wn Y ۂŁAZ xNgieʂ̖@A
 * ܂ joint Wň_王_ւ̃xNgjƕsɂȂ悤ɁA
 * }gNX蒼B
 *
 * ASYF
 * xNg  cz (K݁jƂ΁A
 *  ny =  oy
 *  nz = |oz| * cz
 *  nx = |ox| / |oy ~ cz| * oy ~ cz
 * 
 * A
 *   ox, oy, oz: jointWX,Y,ZxNg(XP[܂)
 *   nx, ny, nz: r{[hꂽX,Y,ZxNg
 *
 * F
 * joint WnĂȂꍇAc݂͎̏ B
 * 
 * p[XyNeBu␳ŁAJIuWFNgւ̃xNgƃIuWFNg
 * YsȏꍇA܂̓p[XyNeBu␳ȂŃIuWFNgYJ
 * WnZƕsȏꍇ͕ϊsȂB
 */
static void
mkVBillBoardMtx(HSD_JObj *jobj, MtxPtr src, MtxPtr dst)
{
  Vec pos, ax, ay, az;
  Vec uy;
  float sx, sz;
  float mag;

  HSD_MtxColVec(src, 3, &pos);

  /* joint Wn Y JWnł̃xNgƂē */
  HSD_MtxColVec(src, 1, &ay);
  VECScale(&ay, &uy, 1.0F/(VECMag(&ay) + FLT_EPSILON));

  sx = HSD_MtxColMag(src, 0);
  sz = HSD_MtxColMag(src, 2);

  if (jobj->flags & JOBJ_PBILLBOARD) {
    VECScale(&pos, &az, -1.0F/(VECMag(&pos) + FLT_EPSILON));
    VECCrossProduct(&uy, &az, &ax);
  } else {
    VECCrossProduct(&uy, &(Vec){0, 0, 1}, &ax);
  }
  mag = VECMag(&ax);
  if (mag < FLT_EPSILON) {
    goto PASS;
  }
  sx /= mag;
  VECCrossProduct(&ax, &uy, &az);
  sz /= VECMag(&az) + FLT_EPSILON;

  MTXRowCol(dst, 0, 0) = sx * ax.x;
  MTXRowCol(dst, 1, 0) = sx * ax.y;
  MTXRowCol(dst, 2, 0) = sx * ax.z;

  HSD_MtxSetColVec(dst, 1, &ay);

  MTXRowCol(dst, 0, 2) = sz * az.x;
  MTXRowCol(dst, 1, 2) = sz * az.y;
  MTXRowCol(dst, 2, 2) = sz * az.z;

  HSD_MtxSetColVec(dst, 3, &pos);
  return;

PASS:
  MTXCopy(src, dst);
}

/*
 * joint Wn Y ̕J̏悤
 * joint Wn X ŉ]B
 *
 * PBillboard ̏ꍇ́AY ͎_IuWFNg̒Sւ̃xNg
 * B
 *
 * F
 * joint WnĂȂꍇAc݂͎̏ B
 * 
 * ȉ̃P[Xł͐ȕῗłȂB
 *   p[XyNeBu␳LȏꍇŁA
 *     o IuWFNgʒuJWYɂꍇB
 *     o IuWFNgXAJW_IuWFNgʒuɌ
 *       xNgY90x]xNgƕsȏꍇB
 *   p[XyNeBu␳ȏꍇŁA
 *     o IuWFNgXJWnYƕsȏꍇB
 */
static void
mkHBillBoardMtx(HSD_JObj *jobj, MtxPtr src, MtxPtr dst)
{
  Vec pos, ax, ay, az;
  Vec ux;
  float sy, sz;
  float mag;

  HSD_MtxColVec(src, 3, &pos);

  /* joint Wn X JWnł̃xNgƂē */
  HSD_MtxColVec(src, 0, &ax);
  VECScale(&ax, &ux, 1.0F/(VECMag(&ax) + FLT_EPSILON));

  sy = HSD_MtxColMag(src, 1);
  sz = HSD_MtxColMag(src, 2);

  if (jobj->flags & JOBJ_PBILLBOARD) {
    /* J̌_ joint ̌_ւ̃xNgɒ Y xNg
     *  ay ƂB
     */
    ay.y = sqrtf(pos.x * pos.x + pos.z * pos.z) + FLT_EPSILON;
    ay.x = -pos.y / ay.y * pos.x;
    ay.z = -pos.y / ay.y * pos.z;
    VECNormalize(&ay, &ay);
  } else {
    HSD_VecSet(&ay, 0, 1, 0);
  }
  VECCrossProduct(&ux, &ay, &az);
  mag = VECMag(&az);
  if (mag < FLT_EPSILON) {
    goto PASS;
  }
  sz /= mag;
  VECCrossProduct(&az, &ux, &ay);
  sy /= VECMag(&ay) + FLT_EPSILON;

  HSD_MtxSetColVec(dst, 0, &ax);

  MTXRowCol(dst, 0, 1) = sy * ay.x;
  MTXRowCol(dst, 1, 1) = sy * ay.y;
  MTXRowCol(dst, 2, 1) = sy * ay.z;

  MTXRowCol(dst, 0, 2) = sz * az.x;
  MTXRowCol(dst, 1, 2) = sz * az.y;
  MTXRowCol(dst, 2, 2) = sz * az.z;

  HSD_MtxSetColVec(dst, 3, &pos);
  return;

PASS:
  MTXCopy(src, dst);
}

/*
 * eʁA܂̓IuWFNǧ_王_ւ̃xNgɑ΂
 * ΂r{[hB
 *
 * {IȃASYF
 *
 *   xNgieʂ̖@A܂̓IuWFNg_王ւ̃xNgj
 *
 * IuWFNg Y xNgɒ鐬 Y' ߁A
 * xNg Y' ̊OςX ߂B
 * Z ͊xNgƂB
 *
 * F
 * src }gNXɂĕϊWnĂȂꍇAԂ
 * X͕ۂȂB
 * IuWFNgƃJʒuɂꍇAɕϊłȂB
 */
static void
mkBillBoardMtx(HSD_JObj *jobj, MtxPtr src, MtxPtr dst)
{
  Vec ax, ay, az, pos;
  float sx, sy, sz;
  float mag;

  sx = HSD_MtxColMag(src, 0);
  sz = HSD_MtxColMag(src, 2);
  HSD_MtxColVec(src, 1, &ay);
  sy = VECMag(&ay);
  HSD_MtxColVec(src, 3, &pos);

  if (jobj->flags & JOBJ_PBILLBOARD) {
    VECScale(&pos, &az, -1.0F/(VECMag(&pos) + FLT_EPSILON));
  } else {
    HSD_VecSet(&az, 0, 0, 1);
  }
  VECScale(&ay, &ay, 1.0F/(sy + FLT_EPSILON));
  VECCrossProduct(&ay, &az, &ax);
  mag = VECMag(&ax);
  if (mag >= FLT_EPSILON) {
    sx /= mag;
    VECCrossProduct(&az, &ax, &ay);
    sy /= VECMag(&ay) + FLT_EPSILON;
  } else {
    ay.y = sqrtf(az.x * az.x + az.z * az.z) + FLT_EPSILON;
    ay.x = -az.y / ay.y * az.x;
    ay.z = -az.y / ay.y * az.z;
    VECCrossProduct(&ay, &az, &ax);
    sx /= VECMag(&ax) + FLT_EPSILON;
  }

  MTXRowCol(dst, 0, 0) = sx * ax.x;
  MTXRowCol(dst, 1, 0) = sx * ax.y;
  MTXRowCol(dst, 2, 0) = sx * ax.z;

  MTXRowCol(dst, 0, 1) = sy * ay.x;
  MTXRowCol(dst, 1, 1) = sy * ay.y;
  MTXRowCol(dst, 2, 1) = sy * ay.z;

  MTXRowCol(dst, 0, 2) = sz * az.x;
  MTXRowCol(dst, 1, 2) = sz * az.y;
  MTXRowCol(dst, 2, 2) = sz * az.z;

  HSD_MtxSetColVec(dst, 3, &pos);
  return;
}

/*
 * ˂ɓeʂɐ΂Az ̂݃IuWFNg̃Aj[V
 * ȂB
 */
static void
mkRBillBoardMtx(HSD_JObj *jobj, MtxPtr src, MtxPtr dst)
{
  Mtx rot, scl;
  float sx, sy, sz;
  
  /* scale lZbg */
  sx = HSD_MtxColMag(src, 0);
  sy = HSD_MtxColMag(src, 1);
  sz = HSD_MtxColMag(src, 2);
  MTXScale(scl, sx, sy, sz);

  MTXRotRad(rot, 'z', jobj->rotate.z);
  MTXRowCol(rot, 0, 3) = MTXRowCol(src, 0, 3);
  MTXRowCol(rot, 1, 3) = MTXRowCol(src, 1, 3);
  MTXRowCol(rot, 2, 3) = MTXRowCol(src, 2, 3);

  MTXConcat(rot, scl, dst);
}

void
HSD_JObjMakePositionMtx(HSD_JObj *jobj, Mtx vmtx, Mtx pmtx)
{
  Mtx mtx;

  if (jobj->flags & JOBJ_BILLBOARD_FIELD) {
    MTXConcat(vmtx, jobj->mtx, mtx);
    switch (jobj->flags & JOBJ_BILLBOARD_FIELD) {
    case JOBJ_BILLBOARD:			/* X,Y t[ */
      mkBillBoardMtx(jobj, mtx, pmtx);
      break;
    case JOBJ_VBILLBOARD:			/* x̉̉]Œ */
      mkVBillBoardMtx(jobj, mtx, pmtx);
      break;
    case JOBJ_HBILLBOARD:			/* w̉̉]Œ */
      mkHBillBoardMtx(jobj, mtx, pmtx);
      break;
    case JOBJ_RBILLBOARD:
      mkRBillBoardMtx(jobj, mtx, pmtx);
      break;
    default:
      HSD_Halt("unkown type of billboard.\n");
    }
  } else {
    MTXConcat(vmtx, jobj->mtx, pmtx);
  }
}

/*
 * (J֐)
 * 
 * w肵jobjт̐cjobĵŏ̃XPgm[hԂB
 * (XPgm[h: Gx[v̐_)
 * 
 * @return
 * XPgm[hꍇ͂jobjւ̃|C^ԂB
 * ȂꍇNULLԂB
 */
HSD_JObj *
HSD_JObjFindSkeleton(HSD_JObj *jobj)
{
  assert(jobj);
  for (; jobj; jobj=jobj->parent) {
    if (jobj->flags&(JOBJ_SKELETON|JOBJ_SKELETON_ROOT)) {
      return jobj;
    }
  }
  return NULL;
}

/*
 * Gx[v̊Wn݂Afm[h̏Wn𓾂B
 * 
 * Wn J(x,y) :
 *   _ʒuɂƂ x ̍Wnɂ y ̍Wn
 * IWn M(x,y) : 
 *   _ړƂ x ̍Wnɂ y ̍Wn
 *
 * Gx[ṽ[gm[hrƂB
 * fm[h m ɂƂ߂Ac[ŏʂ̐m[h܂
 * [gm[h x Ƃ΁AJ(r, m) ͎̂悤ɒ`B
 *
 *   J(r,m) = J(r,x) M(x,m)
 * 
 * ́Am[h̏Wn͕ωȂ̂ɑ΂Afm[h
 * Wn x  m ̊Ԃjobj̃Aj[VlȂ΂ȂȂ
 * ߁B
 * 
 *   J(r,m) =: J(r,x) M(x,m)	if (r != x != m)
 *           |        M(x,m)	if (r == x != m)
 *           | J(r,x)		if (r != x == m)
 *           | E		if (r == x == m)
 *
 *
 * Softimage ̃Gx[vƂ̑ΉF
 *
 *  Model Joint o          Null Joint o
 * ------------------        -----------------
 * O[oGx[v(Null Joint o͂͏oȂj
 *  r/m - s - ...
 *  (r = x = m)
 *
 * [JGx[v
 *  r - s - ...                r/m - s - ...
 *   \
 *    m
 *  (r = x != m)               (r = x = m)
 *
 * fKwNullꂽꍇA
 *  r - s - ...                r - s - ...
 *   \                          \
 *    N - m                      m
 *  (r = x != m)               (r = x != m)
 *
 * [J`FC
 *  r - s - s - ...            r - s/m - s - ...
 *       \
 *        m
 *  (r != x != m)              (r != x = m)
 *   
 * fKwNullꂽꍇA
 *  r - s - s ...              r - s - s - ...
 *       \                          \
 *        N - m                      m
 *  (r != x != m)              (r != x != m)
 *
 *
 * @param m	fm[h
 * @param mtx	ϊ}gNX̑AhX
 *
 * @return
 * fm[h[gm[hƓꍇNULLAłȂ
 * mtxԂB
 */
MtxPtr
_HSD_mkEnvelopeModelNodeMtx(HSD_JObj *m, MtxPtr mtx)
{
  if (m->flags & JOBJ_SKELETON_ROOT) {			/* r == x == m */
    return NULL;
  } else {
    HSD_JObj *x = HSD_JObjFindSkeleton(m);
    assert(x);

    if (x == m) {					/* r != x == m */
      MTXInverse(x->envelopemtx, mtx);
    } else if (x->flags & JOBJ_SKELETON_ROOT) {		/* r == x != m */
      HSD_MtxInverseConcat(x->mtx, m->mtx, mtx);
    } else {						/* r != x != m */
      Mtx n;
      MTXConcat(x->mtx, x->envelopemtx, n);
      HSD_MtxInverseConcat(n, m->mtx, mtx);
    }

    return mtx;
  }
}

#define	DOBJ_TH					(0xfc00)
#ifdef	_DEBUG
extern	void SetDrawSync(u16 token,void *pObj);
extern	void ResetDrawSyncCounter(void);
extern	u16 GetDrawSyncCounter(void);
#define	SETDS(id,obj)		//SetDrawSync((u16)(DOBJ_TH|(id)),(obj))
#define	RESETDSCNT()		ResetDrawSyncCounter()
#define	GETDSCNT()			GetDrawSyncCounter()
#else
#define	SETDS(id,obj)		
#define	RESETDSCNT()		
#define	GETDSCNT()			
#endif
/*
 * ۂDObj`悷B
 *
 * @param jobj		`悵dobjjobj
 * @param vmtx		JWnւ̕ϊs (CX^X␳s܂)
 * @param pmtx		JWnɂIuWFNg̃[JWns
 * @param xlu_kind	`惂[hJOBJ_OPA, TEXEDGE, XLÛꂩP
 *			SHADOW̘_a
 */
void
HSD_JObjDispSub(HSD_JObj *jobj,
		MtxPtr vmtx,
		MtxPtr pmtx,
		HSD_TrspMask trsp_mask,
		u32 rendermode)
{
  HSD_DObj *dobj;
  u32 dobj_trsp;
  
  RESETDSCNT();

  HSD_JObjSetCurrent(jobj);

  dobj_trsp = trsp_mask << DOBJ_TRSP_SHIFT;

  if (!(rendermode & RENDER_SHADOW)) {
#ifndef UNUSED_SPECULAR
    if (jobj->flags & JOBJ_SPECULAR) {
      HSD_LObjSetupSpecularInit(pmtx);
    }
#endif
  }

  HSD_PObjClearMtxMark(NULL, HSD_MTX_NONE);
  for (dobj = jobj->u.dobj; dobj; dobj = dobj->next) {
    if (dobj->flags & DOBJ_HIDDEN)
      continue;
    
//    if( notexcancel                      &&
//        dobj->mobj->tobj          ==NULL &&
//        dobj->mobj->tobj_toon     ==NULL &&
//        dobj->mobj->tobj_gradation==NULL ){
//      continue;
//    }
    
    if (dobj->flags & dobj_trsp) {
      HSD_DObjSetCurrent(dobj);
      SETDS(GETDSCNT(),dobj);
#if HSD_DISP_METHOD_LEVEL > 2
      HSD_DObjDisp(dobj, vmtx, pmtx, rendermode);
#else
      HSD_DOBJ_METHOD(dobj)->disp(dobj, vmtx, pmtx, rendermode);
#endif
    }
  }
  HSD_DObjSetCurrent(NULL);
  HSD_JObjSetCurrent(NULL);
}

static void
HSD_JObjDispDObj(HSD_JObj *jobj, MtxPtr vmtx,
		 HSD_TrspMask trsp_mask, u32 rendermode)
{
  Mtx pmtx;
  HSD_CObj *cobj;
  u32 xlu_bits;

  if (jobj->flags & JOBJ_HIDDEN)
    return;

#ifdef	WATANABE
  HSD_JObjSetupMatrix(jobj);
#endif
  
  xlu_bits = jobj->flags & (trsp_mask << JOBJ_TRSP_SHIFT);
  if (!xlu_bits)
    return;

#ifndef	WATANABE
  HSD_JObjSetupMatrix(jobj);
#endif

  if (!vmtx) {
    cobj = HSD_CObjGetCurrent();
    vmtx = HSD_CObjGetViewingMtxPtrDirect(cobj);
  }

#if HSD_DISP_METHOD_LEVEL > 3
  HSD_JObjMakePositionMtx(jobj, vmtx, pmtx);
#else
  HSD_JOBJ_METHOD(jobj)->make_pmtx(jobj, vmtx, pmtx);
#endif

  if (xlu_bits & JOBJ_OPA) {
#if HSD_DISP_METHOD_LEVEL > 3
    HSD_JObjDispSub(jobj, vmtx, pmtx, HSD_TRSP_OPA, rendermode);
#else
    HSD_JOBJ_METHOD(jobj)->disp(jobj, vmtx, pmtx, HSD_TRSP_OPA, rendermode);
#endif
  }

  if (!zsort_listing) {
    if (xlu_bits & JOBJ_TEXEDGE) {
#if HSD_DISP_METHOD_LEVEL > 3
      HSD_JObjDispSub(jobj, vmtx, pmtx, HSD_TRSP_TEXEDGE, rendermode);
#else
      HSD_JOBJ_METHOD(jobj)->disp(jobj, vmtx, pmtx,
				  HSD_TRSP_TEXEDGE, rendermode);
#endif
    }
    if (xlu_bits & JOBJ_XLU) {
#if HSD_DISP_METHOD_LEVEL > 3
      HSD_JObjDispSub(jobj, vmtx, pmtx, HSD_TRSP_XLU, rendermode);
#else
      HSD_JOBJ_METHOD(jobj)->disp(jobj, vmtx, pmtx, HSD_TRSP_XLU, rendermode);
#endif
    }
  } else {
    if (xlu_bits & (JOBJ_TEXEDGE | JOBJ_XLU)) {
      HSD_ZList *zlist;

      zlist = HSD_ZListAlloc();
#ifdef	WATANABE
	zlist->pPreCallbackFunc       = pPreZListCallbackFunc;
	zlist->pPostCallbackFunc      = pPostZListCallbackFunc;
	zlist->pCallbackData          = pZListCallbackData;
	zlist->pRenderObjCallbackFunc = pZListRenderObjCallbackFunc;
	zlist->pRenderObj             = pZListRenderObj;
	zlist->mirrorType             = ZListMirrorType;
	zlist->mirrorPos              = ZListMirrorPos;
	zlist->prio                   = ZListPrio;
#endif
      MTXCopy(pmtx, zlist->pmtx);
      if (vmtx) {
	zlist->vmtx = HSD_MtxAlloc();
	MTXCopy(vmtx, zlist->vmtx);
      }
      zlist->jobj = jobj;
      zlist->rendermode = rendermode;

      *zlist_bottom = zlist;
      zlist_bottom = &zlist->next;

      if (xlu_bits & JOBJ_TEXEDGE) {
	*zlist_texedge_bottom = zlist;
	 zlist_texedge_bottom = &zlist->sort.texedge;
	 zlist_texedge_nb ++;
      }
      if (xlu_bits & JOBJ_XLU) {
	*zlist_xlu_bottom = zlist;
	 zlist_xlu_bottom = &zlist->sort.xlu;
	 zlist_xlu_nb ++;
      }
    }
  }
}

#define ZLIST_NEXT(list,offset) (*(HSD_ZList **)(((u8 *)(list)) + (offset)))

static HSD_ZList *
zlist_sort(HSD_ZList *list, int nb, int offset)
{
  HSD_ZList *fore, *hind, **ptr;
  int nb_fore, nb_hind;
  int i;

  if (nb <= 1) {
    if (list) {
      ZLIST_NEXT(list, offset) = NULL;
    }
    return list;
  }
  nb_fore = nb / 2;
  nb_hind = nb - nb_fore;

  hind = list;
  for (i=0; i<nb_fore; i++) {
    hind = ZLIST_NEXT(hind, offset);
  }

  fore = zlist_sort(list, nb_fore, offset);
  hind = zlist_sort(hind, nb_hind, offset);

  list = NULL;
  ptr = &list;

  while (fore && hind) {
#ifdef	WATANABE
    if( fore->prio < hind->prio || (fore->prio==hind->prio && (MTXRowCol(fore->pmtx, 2, 3) <= MTXRowCol(hind->pmtx, 2, 3))) ){
      *ptr = fore;
      fore = ZLIST_NEXT(fore, offset);
    }else{
      *ptr = hind;
      hind = ZLIST_NEXT(hind, offset);
    }
#else
    if (MTXRowCol(fore->pmtx, 2, 3) <= MTXRowCol(hind->pmtx, 2, 3)) {
      *ptr = fore;
      fore = ZLIST_NEXT(fore, offset);
    } else {
      *ptr = hind;
      hind = ZLIST_NEXT(hind, offset);
    }
#endif
    ptr = &ZLIST_NEXT(*ptr, offset);
  }

  if (fore) {
    *ptr = fore;
  } else if (hind) {
    *ptr = hind;
  }

  return list;
}

#ifdef	WATANABE
#define HSD_OFFSET(stru, member)	((int)(&((stru *) 0)->member))
#else
#define OFFSET(stru, member)	((int)(&((stru *) 0)->member))
#endif

/*
 * zsort sB
 *
 * @warning
 * bottom ̃|C^͐ʒuwȂȂ̂ŁAȍ~Xgւ
 * ǉsĂ͂ȂȂB
 */
void
_HSD_ZListSort(void)
{
  if (zsort_sorting) {
    zlist_texedge_top = zlist_sort(zlist_texedge_top,
				   zlist_texedge_nb,
#ifdef	WATANABE
				   HSD_OFFSET(HSD_ZList, sort.texedge));
#else
				   OFFSET(HSD_ZList, sort.texedge));
#endif
    zlist_xlu_top     = zlist_sort(zlist_xlu_top,
				   zlist_xlu_nb,
#ifdef	WATANABE
				   HSD_OFFSET(HSD_ZList, sort.xlu));
#else
				   OFFSET(HSD_ZList, sort.xlu));
#endif
  }
}

/*
 */
void
_HSD_ZListDisp(void)
{
  HSD_ZList *list;
  MtxPtr vmtx;
  HSD_CObj *cobj;
#ifdef	WATANABE
  void	*pOldRenderObj = NULL;
  u32	oldMirrorType = 0xffffffff;
#endif

  cobj = HSD_CObjGetCurrent();
  vmtx = HSD_CObjGetViewingMtxPtrDirect(cobj);

  list = zlist_texedge_top;
  while (list) {
#ifdef	WATANABE
	if( list->pPreCallbackFunc != NULL ){
		list->pPreCallbackFunc(list->pCallbackData);
	}
	if( list->pRenderObj != NULL && list->pRenderObjCallbackFunc!=NULL ){
		if( list->pRenderObj != pOldRenderObj ||
		    list->mirrorType != oldMirrorType ){
			list->pRenderObjCallbackFunc(list);
		}
		pOldRenderObj = list->pRenderObj;
		oldMirrorType = list->mirrorType;
	}
#endif
#if HSD_DISP_METHOD_LEVEL > 3
    HSD_JObjDispSub(list->jobj,
		    (list->vmtx)? list->vmtx : vmtx,
		    list->pmtx,
		    HSD_TRSP_TEXEDGE,
		    list->rendermode);
#else
    HSD_JOBJ_METHOD(list->jobj)->disp(list->jobj,
				      (list->vmtx)? list->vmtx : vmtx,
				      list->pmtx,
				      HSD_TRSP_TEXEDGE,
				      list->rendermode);
#endif
#ifdef	WATANABE
	if( list->pPostCallbackFunc != NULL ){
		list->pPostCallbackFunc(list->pCallbackData);
	}
#endif
    list = list->sort.texedge;
  }

  list = zlist_xlu_top;
  while (list) {
#ifdef	WATANABE
	if( list->pPreCallbackFunc != NULL ){
		list->pPreCallbackFunc(list->pCallbackData);
	}
	if( list->pRenderObj != NULL && list->pRenderObjCallbackFunc!=NULL ){
		if( list->pRenderObj != pOldRenderObj ||
		    list->mirrorType != oldMirrorType ){
			list->pRenderObjCallbackFunc(list);
		}
		pOldRenderObj = list->pRenderObj;
		oldMirrorType = list->mirrorType;
	}
#endif
#if HSD_DISP_METHOD_LEVEL > 3
    HSD_JObjDispSub(list->jobj,
		    (list->vmtx)? list->vmtx : vmtx,
		    list->pmtx,
		    HSD_TRSP_XLU,
		    list->rendermode);
#else
    HSD_JOBJ_METHOD(list->jobj)->disp(list->jobj,
				      (list->vmtx)? list->vmtx : vmtx,
				      list->pmtx,
				      HSD_TRSP_XLU,
				      list->rendermode);
#endif
#ifdef	WATANABE
	if( list->pPostCallbackFunc != NULL ){
		list->pPostCallbackFunc(list->pCallbackData);
	}
#endif
    list = list->sort.xlu;
  }

  _HSD_ZListClear();
}

/*
 */
void
_HSD_ZListClear(void)
{
  HSD_ZList *list;

  list = zlist_top;
  while (list) {
    HSD_ZList *next = list->next;
    if (list->vmtx) {
      HSD_MtxFree(list->vmtx);
    }
    HSD_ZListFree(list);
    list = next;
  }
  zlist_top = NULL;
  zlist_bottom = &zlist_top;

  zlist_texedge_top = NULL;
  zlist_texedge_bottom = &zlist_texedge_top;
  zlist_texedge_nb = 0;

  zlist_xlu_top = NULL;
  zlist_xlu_bottom = &zlist_xlu_top;
  zlist_xlu_nb = 0;
}

/**
 * @package Global
 *
 * Z\[g̃[hݒ肷B
 * 
 *  listing ɐ^w肵ꍇA߃^Cv JOBJ_TEXEDGE, JOBJ_XLU 
 * fXgɓo^āAHSD_CObjEndCurrent()Ăяoɂ܂Ƃ߂ĕ`悷B
 * 
 * HSD_CObjEndCurrent()ĂяoA܂߃^CvJOBJ_TEXEDGẼf
 * Xg̓o^ɕ`悳B
 * 
 * ē߃^CvJOBJ_XLŨf`悳邪A sorting ɐ^
 * w肵ꍇɂ́AXgJWnłZWlɂ\[eBOA
 * ZŃJƂf`悷B
 * (TEXEDGEf̓\[gȂ)
 * 
 * listing = ȔꍇAsortingp[^͖B
 *
 * @see HSD_GetZSortMode
 */
void
HSD_SetZSortMode(int listing, int sorting)
{
  zsort_listing = listing;
  zsort_sorting = sorting;
}

/**
 * @package Global
 *
 * Z\[g̃[h擾
 * 
 * @see HSD_SetZSortMode
 */
void
HSD_GetZSortMode(int *listing, int *sorting)
{
  if (listing) {
    *listing = zsort_listing;
  }
  if (sorting) {
    *sorting = zsort_sorting;
  }
}

/**
 * @package JObj
 * 
 * jobj P\B
 *
 * {֐HSD_JObjDispAll()ejobj`悷邽߂ɌĂяoB
 * [U{֐𒼐ڎgpꍇACX^XɊւă[Ug
 * lȂ΂ȂȂ(vmtx̉Q)B
 * 
 * trsp_mask ɂ́Ajobj dobj ̂\̂̓߃^Cv
 * _aw肷Bgpł^Cv͈ȉ̂RށB
 * <pre>
 *    trsp_mask       |  Ӗ
 *  ------------------+----------------------------
 *   HSD_TRSP_OPA     | sIuWFNg`
 *   HSD_TRSP_XLU     | IuWFNg`
 *   HSD_TRSP_TEXEDGE | At@2l̃IuWFNg`
 * </pre>
 *
 * rendermode RENDER_SHADOW rbg𗧂ĂꍇAeNX`/}eA
 * ݒ͈؍sȂB
 * 
 * jobj CX^XƂĕ`悷ꍇAvmtx ɃCX^X␳}gNX
 * 炩߂r[CO}gNXw肷BłȂꍇɂ́A
 * vmtx ɂ NULL w肷΂悢B
 * 
 * CX^Xm[hx Ƃ̃}X^[m[hy ^ꂽACX^X
 * ␳}gNX͎œB
 * <pre>
 *   Mi = Mx Inv(My)
 * </pre>
 * 
 * Ⴆ΁Â悤jobj KwlB
 * <pre>
 *   jobj0 -+--> jobj1 --> jobj3
 *          |
 *          +--> jobj2 ( --> jobj1 )
 * </pre>
 * jobj2 jobj1 ̃CX^XƂ(jobj1 == jobj2->child)B
 * 
 * J̃r[CO}gNXMv ƂAejobj ̃[JWϊ
 * }gNXm, O[oWϊ}gNXM ƂB
 * <pre>
 *   M0 = m0
 *   M1 = M0 m1
 *   M2 = M0 m2
 *   M3 = M1 m3
 * </pre>
 * 
 * ̎ACX^X␳}gNXMi ́Aȉ̎ŗ^B
 * <pre>
 *   Mi = M2 Inv(M1)
 * </pre>
 * 
 * jobj3ʏ̃fƂĕ`悷ꍇɁAn[hEFAɃ[h
 * }gNX͈ȉ̂悤ɂċ߂B
 * <pre>
 *   M = Mv m0 m1 m3
 *     = Mv M3
 * </pre>
 * 
 * jobj3 CX^XƂĕ`悷ꍇ, n[hEFAɃ[h
 * }gNXM' ͈ȉ̂悤ɂċ߂B
 * <pre>
 *   M' = Mv M2 m3
 *      = Mv M2 Inv(M1) M1 m3
 *      = Mv Mi M3
 *      = Mv' M3
 * </pre>
 * AA
 * <pre>
 *   Mv' = Mv Mi
 * </pre>
 * 
 * @param vmtx		r[CO}gNX(CX^Xp)
 * @param trsp_mask	`悷dobj̃^Cv
 * @param rendermode	`IvV
 *
 * @see HSD_JObjDispAll
 * @see CObj#HSD_CObjGetViewingMtx
 */
void
HSD_JObjDisp(HSD_JObj *jobj, MtxPtr vmtx,
	     HSD_TrspMask trsp_mask, u32 rendermode)
{
  if (jobj == NULL)
    return;

  if (union_type_dobj(jobj)) {
    HSD_JObjDispDObj(jobj, vmtx, trsp_mask, rendermode);
  } else if (union_type_ptcl(jobj)) {
    HSD_SList *sp;
    if (sptcl_callback) {
      for (sp = jobj->u.ptcl; sp; sp = sp->next) {
	if (((u32)sp->data) & JOBJ_PTCL_ACTIVE) {
	  u32 bank = JOBJ_PTCL_BANK_MASK&((u32)sp->data);
	  u32 offset =
	    (JOBJ_PTCL_OFFSET_MASK&((u32)sp->data))>>JOBJ_PTCL_OFFSET_SHIFT;
	  (*sptcl_callback)(0, bank, offset, jobj);
	}
	sp->data = (void *)((u32)sp->data & ~JOBJ_PTCL_ACTIVE);
      }
    }
  }
}


/**
 * p[eBNp̃R[obN֐ZbgB
 * 
 * R[obN֐ func ɂ jobj, p[eBÑoNA
 * p[eBÑoNł̃ItZbgƂēnB
 * ̊֐ŃZbgp[eBNp֐͖p[eB
 * Np̂̂łȂĂ͂ȂȂBp[eBN̓p[eB
 * N JObj RST lQƂ邪ȍ~ JObj ɂ
 * Ǐ]ȂB
 *
 * @param func	R[obN֐
 */
void
HSD_JObjSetSPtclCallback(HSD_PtclCallback func)
{
  sptcl_callback = func;
}

/**
 * @package Global
 *
 * wiFw肷B
 *
 * @see HSD_GetEraseColor
 */
void
HSD_SetEraseColor(u8 r, u8 g, u8 b, u8 a)
{
  hsd_background_color.r = r;
  hsd_background_color.g = g;
  hsd_background_color.b = b;
  hsd_background_color.a = a;
}

/**
 * @package Global
 *
 * wiF̐ݒl擾B
 *
 * @see HSD_SetEraseColor
 */
GXColor
HSD_GetEraseColor(void)
{
  return hsd_background_color;
}

/**
 * @package Global
 *
 * `̈NAB
 * 
 * `̈̓JWnŎw肷B
 * zŎw肵XYʏŋ`̈`B
 * 
 * l̓J near, far p[^ɑ΂āA
 * <pre>
 *   near &lt; -z &lt; -far
 * </pre>
 * łȂ΂ȂȂ(Z ͉s}CiXjB
 * 
 * F(RGB), At@lAZlꂼNA邩ۂwłB
 * 
 * FEAt@lNAꍇAHSD_SetEraseColor()
 * wiFw肷B
 *
 * @warning
 * Sʂ̃NAɂ͖0.03t[B
 * 
 * z̓|SzWlƂȂ肠܂ŋ`̒`ɎgpB
 * ۂZobt@ɏ̂Zobt@̍őlłB
 *
 * @param enable_color	FNA
 * @param enable_alpha	At@lNA
 * @param enable_depth	Zobt@NA
 *
 * @see HSD_SetEraseColor
 */
void
HSD_EraseRect(float top, float bottom, float left, float right, float z,
	      int enable_color, int enable_alpha, int enable_depth)
{
  GXTexObj texobj;
  static u8 depth_image[] ATTRIBUTE_ALIGN(32) = {
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
    255, 255, 255, 255, 255, 255, 255, 255,
  };
  GXColor color;

  if (!enable_color && !enable_alpha && !enable_depth)
    return;

  if (enable_depth) {
    GXInitTexObj(&texobj, depth_image, 4, 4, GX_TF_Z8,
                 GX_REPEAT, GX_REPEAT, GX_DISABLE);
    GXLoadTexObj(&texobj, GX_TEXMAP0);
    GXSetNumTexGens(1);
    GXSetTexCoordGen(GX_TEXCOORD0, GX_TG_MTX2x4, GX_TG_TEX0, GX_IDENTITY);
    GXSetNumTevStages(1);
    GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD0, GX_TEXMAP0, GX_COLOR0A0);
    GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
    GXSetZTexture(GX_ZT_REPLACE, GX_TF_Z8, 0);
  } else {
    GXSetNumTexGens(0);
    GXSetNumTevStages(1);
    GXSetTevOrder(GX_TEVSTAGE0, GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0);
    GXSetTevOp(GX_TEVSTAGE0, GX_PASSCLR);
  }

  GXSetCullMode(GX_CULL_NONE);

  GXSetAlphaCompare(GX_ALWAYS, 0, GX_AOP_OR, GX_ALWAYS, 0);
  GXSetZCompLoc(GX_TRUE);
  GXSetZMode(GX_ENABLE, GX_ALWAYS, enable_depth? GX_ENABLE : GX_DISABLE);
  GXSetBlendMode(GX_BM_LOGIC, GX_BL_ONE, GX_BL_ZERO, GX_LO_COPY);
  GXSetColorUpdate(enable_color? GX_ENABLE : GX_DISABLE);
  GXSetAlphaUpdate(enable_alpha? GX_ENABLE : GX_DISABLE);

  GXSetNumChans(1);
  GXSetChanCtrl(GX_COLOR0A0, GX_DISABLE, GX_SRC_REG, GX_SRC_VTX,
  		GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);

  GXClearVtxDesc();
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_TEX0, GX_TEX_ST, GX_U8, 0);
  GXLoadPosMtxImm(HSD_identityMtx, GX_PNMTX0);
  GXSetCurrentMtx(GX_PNMTX0);
  GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
  GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);
  GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);

  color = HSD_GetEraseColor();
  GXBegin(GX_QUADS, GX_VTXFMT0, 4);
  GXPosition3f32(left, top, z);
  GXColor4u8(color.r, color.g, color.b, color.a);
  GXTexCoord2u8(0, 0);
  GXPosition3f32(right, top, z);
  GXColor4u8(color.r, color.g, color.b, color.a);
  GXTexCoord2u8(1, 0);
  GXPosition3f32(right, bottom, z);
  GXColor4u8(color.r, color.g, color.b, color.a);
  GXTexCoord2u8(1, 1);
  GXPosition3f32(left, bottom, z);
  GXColor4u8(color.r, color.g, color.b, color.a);
  GXTexCoord2u8(0, 1);
  GXEnd();

  GXSetZTexture(GX_ZT_DISABLE, GX_TF_Z8, 0);

  HSD_StateInvalidate(HSD_STATE_ALL);
}

extern void _HSD_DispForgetMemory(void);
void
_HSD_DispForgetMemory(void)
{
  zlist_top = NULL;
  zlist_bottom = &zlist_top;

  zlist_texedge_top = NULL;
  zlist_texedge_bottom = &zlist_texedge_top;
  zlist_texedge_nb = 0;

  zlist_xlu_top = NULL;
  zlist_xlu_bottom = &zlist_xlu_top;
  zlist_xlu_nb = 0;
}
