/*
 * Copyright 1999-2002 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: mobj.h,v 1.7 2004/07/27 02:14:29 TypeR Exp $
 */

#ifndef __SYSDOLPHIN_MOBJ_H__
#define __SYSDOLPHIN_MOBJ_H__

#include <dolphin.h>
#include "sysdolphin/baselib/config.h"
#include "tobj.h"
#include "sysdolphin/baselib/object.h"
#include "sysdolphin/baselib/objalloc.h"
#include "sysdolphin/baselib/class.h"
#include "sysdolphin/baselib/texp.h"

#ifdef __cplusplus
extern "C" {
#endif

#define	HSD_A_M_AMBIENT_R   1	/* ArGgJ[ */
#define	HSD_A_M_AMBIENT_G   2	/* ArGgJ[ */
#define	HSD_A_M_AMBIENT_B   3	/* ArGgJ[ */
#define	HSD_A_M_DIFFUSE_R   4	/* fBt[YJ[ */
#define	HSD_A_M_DIFFUSE_G   5	/* fBt[YJ[ */
#define	HSD_A_M_DIFFUSE_B   6	/* fBt[YJ[ */
#define	HSD_A_M_SPECULAR_R  7 	/* XyLJ[ */
#define	HSD_A_M_SPECULAR_G  8	/* XyLJ[ */
#define	HSD_A_M_SPECULAR_B  9 	/* XyLJ[ */
#define	HSD_A_M_ALPHA      10	/* gXyAV[ */
/* PEVF[_gpAj[V */
#define	HSD_A_M_PE_REF0    	11	/*  */
#define	HSD_A_M_PE_REF1    	12	/*  */
#define	HSD_A_M_PE_DSTALPHA	13	/*  */

/*+
 * HSD_Material\̂̓}eÃJ[ێ邽߂̍\̂łB
 */
typedef struct _HSD_Material {
  GXColor		ambient;   /*+ ArGgJ[ */
  GXColor		diffuse;   /*+ fBt[YJ[ */
  GXColor		specular;  /*+ XyLJ[ */
  float			alpha;     /*+ At@l */
  float			shininess; /*+ XyLshininess */
} HSD_Material;

typedef struct _HSD_PEDesc {
  u8	flags;	       /*+ etO */
  u8	ref0;          /*+ GXSetAlphaCompare()p */
  u8	ref1;          /*+ GXSetAlphaCompare()p */
  u8	dst_alpha;     /*+ GXSetDstAlpha()p */
  u8   	type;          /*+ GXSetBlendMode()p */
  u8	src_factor;    /*+ GXSetBlendMode()p */
  u8	dst_factor;    /*+ GXSetBlendMode()p */
  u8	logic_op;      /*+ GXSetBlendMode()p */
  u8	z_comp;        /*+ GXSetZMode()p */
  u8	alpha_comp0;   /*+ GXSetAlphaCompare()p */
  u8	alpha_op;      /*+ GXSetAlphaCompare()p */
  u8	alpha_comp1;   /*+ GXSetAlphaCompare()p */
} HSD_PEDesc;

typedef struct _HSD_MObjDesc {
  char			 *class_name;
  u32                    rendermode;
  struct _HSD_TObjDesc   *texdesc;
  HSD_Material           *mat;
  struct _HSD_RenderDesc *renderdesc;		// tĂĂ
  HSD_PEDesc             *pedesc;
} HSD_MObjDesc;

/*+
 * HSD_MObj\̂̓f̃}eAێ邽߂̍\̂łB<br>
 */
typedef struct _HSD_MObj {
  HSD_Class		 parent; /*+ eNX̃o */

# define RENDER_CONSTANT    (1<<0) /* (obsolete) */
# define RENDER_VERTEX      (1<<1) /* (obsolete) */

# define RENDER_DIFFUSE_BITS (3<<0) /*+ fBt[YF[hrbg */
# define RENDER_DIFFUSE_SHIFT 0
# define RENDER_DIFFUSE_MAT0 (0<<0) /*+ }eA[h <br>
				        fBt[YFƂă}eAgp
					(f[^݊p)B*/
# define RENDER_DIFFUSE_MAT  (1<<0) /*+ }eA[h <br>
					fBt[YFƂă}eAgp
					B*/
# define RENDER_DIFFUSE_VTX  (2<<0) /*+ _J[[h <br>
					fBt[YFƂĒ_J[gp
					B*/
# define RENDER_DIFFUSE_BOTH (3<<0) /*+ }eAE_J[[h<br>
					fBt[YFƂă}eAƒ_
					J[̗gpB*/

# define RENDER_DIFFUSE     (1<<2) /*+ fBt[YCeBO B<br>
                                       ̃rbgZbgĂ
				       fBt[YCgB
				       */
# define RENDER_SPECULAR    (1<<3) /*+ XyLCeBOB<br>
                                       ̃rbgZbgĂƃXyL
				       CgA}eAJ[
				       ƂăXyLJ[pB
				       <br>
                                       XyLJ[Material\̂
				       specular pB*/
# define CHANNEL_FIELD      (RENDER_CONSTANT|\
			     RENDER_VERTEX|\
			     RENDER_DIFFUSE|\
			     RENDER_SPECULAR)
# define RENDER_TEX0        (1<<4)  /*+ eNX`1(gp)B */
# define RENDER_TEX1        (1<<5)  /*+ eNX`2(gp)B */
# define RENDER_TEX2        (1<<6)  /*+ eNX`3(gp)B */
# define RENDER_TEX3        (1<<7)  /*+ eNX`4(gp)B */
# define RENDER_TEX4        (1<<8)  /*+ eNX`5(gp)B */
# define RENDER_TEX5        (1<<9)  /*+ eNX`6(gp)B */
# define RENDER_TEX6        (1<<10) /*+ eNX`7(gp)B */
# define RENDER_TEX7        (1<<11) /*+ eNX`8(gp)B */
# define RENDER_TEXTURES    (RENDER_TEX0|\
	 		     RENDER_TEX1|\
			     RENDER_TEX2|\
			     RENDER_TEX3|\
			     RENDER_TEX4|\
			     RENDER_TEX5|\
			     RENDER_TEX6|\
			     RENDER_TEX7)
# define RENDER_TOON	    (1<<12) /*+ TOON _OB */

# define RENDER_ALPHA_BITS   (3<<13)	/*+ At@l[hrbg}XN */
# define RENDER_ALPHA_SHIFT  13
# define RENDER_ALPHA_COMPAT (0<<13)	/*+ ݊[h<br>
				            fBt[YF[hgB*/
# define RENDER_ALPHA_MAT    (1<<13)	/*+ }eA[h<br>
					    At@lƂă}eA
					    gpB*/
# define RENDER_ALPHA_VTX    (2<<13)    /*+ _At@[h <br>
					    At@lƂĒ_At@
					    gpB*/
# define RENDER_ALPHA_BOTH   (3<<13)    /*+ }eAE_At@[h <br>
					    At@lƂă}eA
					    _At@̗gpB*/

#define RENDER_ZOFST	(1<<24)/*Z̃ItZbgB*/
#define RENDER_EFFECT	(1<<25)/*}eAݒ肵ȂǁAʕ`~߂*/

/* RENDER_SHADOW tO
 * mobj->rendermodeɂ̃tOĂꍇAshadow projection 󂯂
 * ƂӖB
 *
 * HSD_JObjDisp()̈rendermodeɂ̃tOĂꍇɂ́ADL
 * Ăяô݂sBRenderiing[h}jAݒ肷邱ƂŁAVGb
 * g`ƂoB
 */
# define RENDER_SHADOW	     (1<<26) /*+ VhEB */
# define RENDER_ZMODE_ALWAYS (1<<27) /*+ ZlrȂɏɕ\B */
# define RENDER_DF_NONE      (1<<28) /*+ Cg Diffuse FunctionB<br>
				         ̃rbgZbgĂƃ`
					 ldiff_fnGX_DN_NONEɃZbg
					 B<br> */
# define RENDER_NO_ZUPDATE   (1<<29) /*+ ZlAbvf[gȂB<br>
                                         ̃rbgZbgĂZl
					 Abvf[gsȂB*/
# define RENDER_XLU 	     (1<<30) /*+ [hB<br>
				         ̃rbgZbgĂƔ
					 [hł̕\sB*/
# define RENDER_USER         (1<<31) /*  (obsoletej
					 [U`}eA
                                         ̃rbgZbgĂƃ[U
					 `̃}eAƂMaterial \
					 ̂̏RenderDesc \̂̏
					 pB*/
  u32                    rendermode; /*+ _\[h */
  struct _HSD_TObj       *tobj;      /*+ eNX`\TObjւ̃|C^ */
  HSD_Material           *mat;       /*+ }eÃJ[\
				       Materialւ̃|C^ */
  HSD_PEDesc		 *pe;	     /*+ JX^PEݒ */
  struct _HSD_AObj       *aobj;      /*+ Aj[V\AObjւ̃|C^*/
#ifdef USE_TEXTURE_MATERIAL
  HSD_TObj		 *ambient_tobj; /* gp */
  HSD_TObj		 *specular_tobj; /* gp */
#endif
  HSD_TExpTevDesc	 *tevdesc;   /*+ Tev ݒ */
  HSD_TExp		 *texp;	     /*+ TevReg/Konst ݒ */

  //FUJITA
  HSD_TObj *tobj_toon; //vpB
  HSD_TObj *tobj_gradation; //Of[VpB
  HSD_TObj *tobj_backlight;//tpB
  f32 zofst;
} HSD_MObj;

typedef struct _HSD_MatAnim {
  struct _HSD_MatAnim *next;
  struct _HSD_AObjDesc *aobjdesc;
  struct _HSD_TexAnim *texanim;
  struct _HSD_RenderAnim *renderanim;
} HSD_MatAnim;

typedef struct _HSD_MatAnimJoint {
  struct _HSD_MatAnimJoint *child;
  struct _HSD_MatAnimJoint *next;
  struct _HSD_MatAnim *matanim;
} HSD_MatAnimJoint;

typedef struct _HSD_MObjInfo {
  HSD_ClassInfo	parent;

  /* methods */
  void	    (*setup)		(HSD_MObj *mobj, u32 rendermode);
  int	    (*load)		(HSD_MObj *mobj, HSD_MObjDesc *desc);
  HSD_TExp* (*make_texp)	(HSD_MObj *mobj,
  				 HSD_TObj *tobj_top, HSD_TExp **list);
  void	    (*setup_tev)	(HSD_MObj *mobj,
				 HSD_TObj *tobj, u32 rendermode);
  void	    (*update)		(void *obj, u32 type, FObjData *val);
  void	    (*unset)		(HSD_MObj *mobj, u32 rendermode);
} HSD_MObjInfo;

extern HSD_MObjInfo hsdMObj;

#define HSD_MOBJ(o)		((HSD_MObj *)(o))
#define HSD_MOBJ_INFO(i)	((HSD_MObjInfo *)(i))
#define HSD_MOBJ_METHOD(o)	HSD_MOBJ_INFO(HSD_CLASS_METHOD(o))

#ifndef _NFUNCPROTO

void	  HSD_MObjRemoveAnim		(HSD_MObj *mobj);
void	  HSD_MObjRemoveAnimByFlags	(HSD_MObj *mobj, u32 flags);
void	  HSD_MObjAddAnim		(HSD_MObj *mobj, HSD_MatAnim *mad);
void	  HSD_MObjReqAnimByFlags	(HSD_MObj *mobj,
					 float starframe, u32 flags);
void	  HSD_MObjReqAnim		(HSD_MObj *mobj, float startframe);
void	  HSD_MObjAnim			(HSD_MObj *mobj);
void	  HSD_MObjSetAnimResult		(HSD_MObj *mobj);
HSD_TObj *HSD_MObjGetTObj		(HSD_MObj *mobj);
void	  HSD_MObjCompileTev		(HSD_MObj *mobj);
void	  HSD_MObjAddTObj		(HSD_MObj *mobj, HSD_TObj *tobj);
void	  HSD_MObjAddTObjPrev		(HSD_MObj *mobj,
					 HSD_TObj *tobj, HSD_TObj *prev);
void	  HSD_MObjAddTObjNext		(HSD_MObj *mobj,
					 HSD_TObj *tobj, HSD_TObj *next);
void	  HSD_MObjRemove		(HSD_MObj *mobj);
HSD_MObj *HSD_MObjAlloc			(void);
void	  HSD_MObjFree			(HSD_MObj *mobj);
HSD_MObj *HSD_MObjLoadDesc		(HSD_MObjDesc *mdesc);

void	  HSD_MObjSetDefaultClass	(HSD_MObjInfo *info);
HSD_MObjInfo *HSD_MObjGetDefaultClass	(void);

void	  HSD_MObjSetAmbientColor	(HSD_MObj *mobj, u8 r, u8 g, u8 b);
void	  HSD_MObjSetDiffuseColor	(HSD_MObj *mobj, u8 r, u8 g, u8 b);
void	  HSD_MObjSetSpecularColor	(HSD_MObj *mobj, u8 r, u8 g, u8 b);
void	  HSD_MObjSetAlpha		(HSD_MObj *mobj, float alpha);
void	  HSD_MObjSetShininess		(HSD_MObj *mobj, float shininess);

u32	  HSD_MObjGetFlags		(HSD_MObj *mobj);
void	  HSD_MObjSetFlags		(HSD_MObj *mobj, u32 flags);
void	  HSD_MObjClearFlags		(HSD_MObj *mobj, u32 flags);
void	  HSD_MObjModifyFlags		(HSD_MObj *mobj, u32 flags, u32 mask);

void	  HSD_MObjAddShadowTexture	(HSD_TObj *tobj);
void	  HSD_MObjDeleteShadowTexture	(HSD_TObj *tobj);
HSD_TObj *HSD_MObjGetShadowTexture	(void);

HSD_MObj *HSD_MObjGetCurrent		(void);

/*
 * T.B.D
 */
HSD_Material *HSD_MaterialAlloc		(void);
void	  HSD_MaterialRemove		(HSD_Material *mat);
void	  HSD_MaterialFree		(HSD_Material *mat);

void HSD_MObjSetToonTextureImage	(HSD_ImageDesc *toonimage);
HSD_TObj *HSD_MObjGetToonTexture	(void);

/* INTERNAL USE ONLY */

void	  HSD_MObjSetCurrent		(HSD_MObj *mobj);
void	  HSD_MObjSetup			(HSD_MObj *mobj, u32 rendermode);
void	  HSD_MObjUnset			(HSD_MObj *mobj, u32 rendermode);

#endif // !_NFUNCPROTO

#ifdef __cplusplus
}
#endif

#endif /* __SYSDOLPHIN_MOBJ_H__ */
