/* $Id: psdisp.c,v 1.13 2004/07/28 19:48:12 fujita! Exp $ */
/*
 * Particle system
 *
 * Copyright 1999-2002 HAL Laboratory, Inc. All rights reserved.
 */
/*
 * p[eBN̕\֐
 */

#ifdef FUJITA
#pragma cplusplus			off
#pragma cpp_extensions		off
#pragma warn_implicitconv	off
#endif

#include <string.h>
#include <float.h>
#include "sysdolphin/baselib.h"
#include "sysdolphin/particle/particle.h"
#include "sysdolphin/particle/psdisp.h"
#include "pslist.h"

#ifndef ROTATE_EPS
#define ROTATE_EPS 0.01  /* ̊pxȉ͂O(radian)ƌȂ */
#endif
#ifndef FLT_EPSILON
#define FLT_EPSILON (1E-5)
#endif
#if DOLPHIN_API_AGE < 1
#define GXSetCurrentMtx(idx) GXSetDefaultMtx(idx)
#endif

#ifdef _DEBUG
#define DUMMY_NRM
#endif

extern void psSetupTevInvalidState(void);
extern void psSetupTevCommon(void);
extern void psSetupTev(Particle *pp);

/*
 * FOG
 */
static HSD_Fog *particleFog = NULL; /* gptHO */
/* ÂtHO菜VtHOݒ肷 */
void psSetFog(HSD_Fog *fog)
{
  if (particleFog)
    HSD_FogUnref(particleFog);

  if (fog)
    HSD_FogRef(fog);
  particleFog = fog;
}
/* tHO菜 */
void psRemoveFog(void)
{
  if (particleFog) {
    HSD_FogUnref(particleFog);
    particleFog = NULL;
  }
}



static int prevPointSize; /* Oɕ`悵|CgTCY */
static int prevLineWidth; /* Oɕ`悵CTCY */

/* \t[ԍ */
/* AppSRT}gbNX̌vZ팸邽߂̃t[ԍ */
u8 psFrameNum = 123;

static Mtx vmtx;		/* r[COs */
static Mtx rvmtx;		/* tr[COsir{[hpj */
static float rx0, rx1, ry0, ry1, rz0, rz1;	/* tr[COs񂩂狁߂XP[l */
static f32 prj[GX_PROJECTION_SZ]; /* Projection */
static Mtx pvmtx; /* ProjectionEvmtx */
#if PS_APPSRT
static Mtx rvmtxRot;	//rvmtx̉]
#endif

/* eNX`UVlAetbvp̃f[^p */
static u8 billboard_tex0_u8[] ATTRIBUTE_ALIGN(32) = {
  /* normal */
  0, 1,   0, 0,   1, 0,   1, 1,
  /* flip S */
  1, 1,   1, 0,   0, 0,   0, 1,
  /* flip T */
  0, 0,   0, 1,   1, 1,   1, 0,
  /* flip S&T */
  1, 0,   1, 1,   0, 1,   0, 0
};

#if PS_TEXDIRECTION
  int texc[4][4] = {
    0, 1, 2, 3,
    3, 2, 1, 0,
    1, 0, 3, 2,
    2, 3, 0, 1
  };
  int td;
#define SENDTEXCOORD(x,flg) \
        GXTexCoord1x8(texc[td][x] + ((flg >> FLIPSHIFT) & FLIPMASK)*4)
#else
#define SENDTEXCOORD(x,flg) \
        GXTexCoord1x8(x + ((flg >> FLIPSHIFT) & FLIPMASK)*4)
#endif


//#define SENDTEXCOORD(x,flg) \
//        GXTexCoord1x8(x + ((flg >> FLIPSHIFT) & FLIPMASK)*4)

#ifdef DUMMY_NRM
static s8 nrm_s8[] ATTRIBUTE_ALIGN(32) = {0};
#define SENDDUMMYNRM GXNormal1x8(0);
#else
#define SENDDUMMYNRM
#endif


/* _fBXNv^̐ݒ */
static void setVtxDesc(int fmt)
{
  GXClearVtxDesc();
  switch(fmt) {
  case 0:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    GXSetVtxDesc(GX_VA_TEX0, GX_INDEX8);	  
    break;
  case 1:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    break;
  case 2:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);	  
    GXSetVtxDesc(GX_VA_TEX0, GX_INDEX8);	  
    break;
  case 3:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);	  
    break;
  case 4:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);	  
    break;
  case 5:
    GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
#ifdef DUMMY_NRM
    GXSetVtxDesc(GX_VA_NRM, GX_INDEX8);
#endif
    GXSetVtxDesc(GX_VA_CLR0, GX_DIRECT);	  
    GXSetVtxDesc(GX_VA_TEX0, GX_DIRECT);	  
    break;
  }
}

static int prevBlendMode;
/* uh[h̐ݒ */
inline void setBlendMode(int blendmode)
{
  if (prevBlendMode != blendmode) {
    prevBlendMode = blendmode;
    switch (blendmode) {
    case 0:
     // ʏF@F@@GF x G + nF x (1.0 - G)
#if 0//FUJITA
      GXSetBlendMode(GX_BM_BLEND ,
		     GX_BL_DSTALPHA, //
		     GX_BL_ONE, //
		     GX_LO_CLEAR);
#else
      GXSetBlendMode(GX_BM_BLEND,
		     GX_BL_SRCALPHA,
		     GX_BL_INVSRCALPHA,
		     GX_LO_CLEAR);
#endif
      break;
    case 1:
      // ZF@F@@GF x G + nF x 1.0
      GXSetBlendMode(GX_BM_BLEND,
		     GX_BL_SRCALPHA,
		     GX_BL_ONE,
		     GX_LO_CLEAR);
      break;
    case 2:
      // ZF@F@@nF - GF  i͖j
      GXSetBlendMode(GX_BM_SUBTRACT ,
		     GX_BL_SRCALPHA, //
		     GX_BL_INVSRCALPHA, //
		     GX_LO_CLEAR);
	break;
    case 3:
      // ZF@F@@GF x nF  i͖j
      GXSetBlendMode(GX_BM_BLEND,
		     GX_BL_DSTCLR,
		     GX_BL_ZERO,
		     GX_LO_CLEAR);
    	break;
    default:
      OSReport("Particle:setBlendMode:Unknown mode\n");
      break;
    }
  }
}

/* ̂Pt[Öʒu߂ */
static void calcTornadoLastPos(Particle *pp, float *x, float *y, float *z)
{
  float radius;
  float px, py, pz;
  float sina, sinb, cosa, cosb;
  float vx0, vz0;
  Generator *gp;
  
  gp = pp->gen;		/* eWFl[^ */
  if (gp == NULL) {
    *x = pp->x;
    *y = pp->y;
    *z = pp->z;
    return;
  }
  
  sina = sinf(pp->grav);		/* sina, sinb, cosa, cosb𓾂 */
  sinb = sinf(pp->fric);
  cosa = cosf(pp->grav);
  cosb = cosf(pp->fric);

  vz0 = pp->vz - gp->aux.tornado.vel;
  vx0 = pp->vx - gp->grav;

  radius = ABS(gp->radius);
  radius += vz0 * tanf(ABS(gp->angle));/* p[eBN݂̑~ */
  radius *= pp->vy;
  px = radius * cosf(vx0);
  py = radius * sinf(vx0);
  pz = vz0;
  
  /* ~̓_̈ʒuvZ */
  *x =  px     *cosb           + pz     *sinb + gp->x;
  *y = -px*sina*sinb + py*cosa + pz*sina*cosb + gp->y;
  *z = -px*cosa*sinb - py*sina + pz*cosa*cosb + gp->z;
}

#if	PS_APPSRT
static void calcTornadoLastPosAPPSRT(Particle *pp, float *x, float *y, float *z)
{
  Mtx	mtx;
  Vec	v;
		
  calcTornadoLastPos( pp, x, y, z );

  HSD_MTXSRT( mtx, &pp->appsrt->sca,/*&sca,*/ &pp->appsrt->rot, &pp->appsrt->tra, NULL);
  v.x = *x; v.y = *y; v.z = *z;
  MTXMultVec( mtx, &v, &v );	// ʒuAppSRT
  *x = v.x; *y = v.y; *z = v.z;	
}
#endif

/* ----------------------------------------------------------------------------
 * J[̌
 */
/* ԃJ[ */
static void getColorPrimEnv(Particle *pp, GXColor *primCol, GXColor *envCol)
{
  if (pp->primColCount) {
    int scale = 65536 * pp->primColRemain  / pp->primColCount;
    primCol->r = ((pp->primColTarget.r<<16)
		  + (pp->primCol.r - pp->primColTarget.r)*scale) >> 16;
    primCol->g = ((pp->primColTarget.g<<16)
		  + (pp->primCol.g - pp->primColTarget.g)*scale) >> 16;
    primCol->b = ((pp->primColTarget.b<<16)
		  + (pp->primCol.b - pp->primColTarget.b)*scale) >> 16;
    primCol->a = ((pp->primColTarget.a<<16)
		  + (pp->primCol.a - pp->primColTarget.a)*scale) >> 16;
  } else {
    *primCol = pp->primCol;
  }
  if (pp->envColCount) {
    int scale = 65536 * pp->envColRemain  / pp->envColCount;
    envCol->r = ((pp->envColTarget.r<<16)
		 + (pp->envCol.r - pp->envColTarget.r)*scale) >> 16;
    envCol->g = ((pp->envColTarget.g<<16)
		 + (pp->envCol.g - pp->envColTarget.g)*scale) >> 16;
    envCol->b = ((pp->envColTarget.b<<16)
		 + (pp->envCol.b - pp->envColTarget.b)*scale) >> 16;
    envCol->a = ((pp->envColTarget.a<<16)
		 + (pp->envCol.a - pp->envColTarget.a)*scale) >> 16;
  } else {
    *envCol = pp->envCol;
  }
}

/* }eAJ[ */
static void getColorMatAmb(Particle *pp, GXColor *matCol, GXColor *ambCol)
{
  if (pp->matColCount) {
    int scale = 65536 * pp->matColRemain  / pp->matColCount;
    matCol->r = matCol->g = matCol->b =
      ((pp->matRGBTarget<<16) + (pp->matRGB - pp->matRGBTarget)*scale) >> 16;
    matCol->a =
      ((pp->matATarget<<16) + (pp->matA - pp->matATarget)*scale) >> 16;
  } else {
    matCol->r = matCol->g = matCol->b = pp->matRGB;
    matCol->a = pp->matA;
  }
  if (pp->ambColCount) {
    int scale = 65536 * pp->ambColRemain  / pp->ambColCount;
    ambCol->r = ambCol->g = ambCol->b =
      ((pp->ambRGBTarget<<16) + (pp->ambRGB - pp->ambRGBTarget)*scale) >> 16;
    ambCol->a =
      ((pp->ambATarget<<16) + (pp->ambA - pp->ambATarget)*scale) >> 16;
  } else {
    ambCol->r = ambCol->g = ambCol->b = pp->ambRGB;
    ambCol->a = pp->ambA;
  }
}

/* ----------------------------------------------------------------------------
 * Cg`l
 */
/*
 * `lݒ
 *  Lighting  Trail ̏ꍇɎg
 *
 */
static int prevChanCtrl;
inline void setupChanCtrl(Particle *pp)
{
  if ((pp->kind & (DispLighting | Trail)) == prevChanCtrl)
    return;
  prevChanCtrl = pp->kind & (DispLighting | Trail);

  GXSetNumChans(1);

  switch (prevChanCtrl) {
  case Trail:
    /* Tevɒ_̃J[nׂɎgp */
    GXSetChanCtrl(GX_COLOR0A0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX,
		  GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);
    break;
  case DispLighting:
    GXSetChanCtrl(GX_COLOR0, GX_TRUE, GX_SRC_REG, GX_SRC_REG,
		  HSD_LObjGetLightMaskDiffuse(),
		  GX_DF_NONE,
		  HSD_LObjGetLightMaskAttnFunc() ? GX_AF_SPOT : GX_AF_NONE);
    GXSetChanCtrl(GX_ALPHA0, GX_FALSE, GX_SRC_REG, GX_SRC_REG,
		  GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);
    break;
  case DispLighting|Trail:
    GXSetChanCtrl(GX_COLOR0, GX_TRUE, GX_SRC_REG, GX_SRC_REG,
		  HSD_LObjGetLightMaskDiffuse(),
		  GX_DF_NONE,
		  HSD_LObjGetLightMaskAttnFunc() ? GX_AF_SPOT : GX_AF_NONE);
    GXSetChanCtrl(GX_ALPHA0, GX_FALSE, GX_SRC_VTX, GX_SRC_VTX,
		  GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);
    break;
  default: /* `lgȂ */
    GXSetChanCtrl(GX_COLOR0A0, GX_FALSE, GX_SRC_REG, GX_SRC_REG,
		  GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);
    break;
  }
  GXSetChanCtrl(GX_COLOR1A1, GX_FALSE, GX_SRC_REG, GX_SRC_REG,
		GX_LIGHT_NULL, GX_DF_NONE, GX_AF_NONE);
  return;
}

static GXColor prevChanMat, prevChanAmb;
/* `lEWX^̐ݒ */
inline void setupChanReg(Particle *pp)
{
  GXColor mat, amb;

  GXColor dummy;
  HSD_LObj *lamb;

  /* Lighting łȂƂ́AWX^͎gȂ */
  if (!(pp->kind & DispLighting))
    return;
  
  getColorMatAmb(pp, &dummy, &amb);
  if (pp->kind & PrimEnv) {
    mat.r = mat.g = mat.b = 255;
  } else {
    getColorPrimEnv(pp, &mat, &dummy);
    amb.r = ((int)amb.r * (int)mat.r) >> 8;
    amb.g = ((int)amb.g * (int)mat.g) >> 8;
    amb.b = ((int)amb.b * (int)mat.b) >> 8;
  }

  if (mat.r != prevChanMat.r
      || mat.g != prevChanMat.g
      || mat.b != prevChanMat.b) {
    prevChanMat = mat;
    GXSetChanMatColor(GX_COLOR0, mat);
  }
  lamb = HSD_LObjGetActiveByID(GX_LIGHT_AMBIENT);
  if (lamb != NULL) {
    HSD_MulColor(&amb, &lamb->color, &amb);
  } else {
    amb.r = amb.g = amb.b = 0;
  }
  if (amb.r != prevChanAmb.r
      || amb.g != prevChanAmb.g
      || amb.b != prevChanAmb.b) {
    prevChanAmb = amb;
    GXSetChanAmbColor(GX_COLOR0, amb);
  }
}

/* Trail gpɒ_f[^ƂđׂF̃x[X */
inline void getClrTrail(Particle *pp, GXColor *col)
{
  GXColor dummy;

  switch (pp->kind & (DispLighting | PrimEnv)) {
  case 0:
  case DispLighting:
    getColorPrimEnv(pp, col, &dummy);
    return;
  case PrimEnv:
  case DispLighting|PrimEnv:
    col->r = col->g = col->b = col->a = 255;
    break;
  }
}

/* ----------------------------------------------------------------------------
 * TevReg
 */
static GXColor prevColorPrim, prevColorEnv, prevColorMat;
inline void setupTevReg(Particle *pp)
{
  GXColor primCol, envCol;
  getColorPrimEnv(pp, &primCol, &envCol);

  if ((pp->kind & PrimEnv)
      || !(pp->kind & DispLighting) && !(pp->kind & Trail)) {
    
    if (prevColorPrim.r != primCol.r
	|| prevColorPrim.g != primCol.g
	|| prevColorPrim.b != primCol.b
	|| prevColorPrim.a != primCol.a) {
      prevColorPrim = primCol;
      GXSetTevColor(GX_TEVREG0, primCol);
    }
    if (pp->kind & PrimEnv) {
      if (prevColorEnv.r != envCol.r
	  || prevColorEnv.g != envCol.g
	  || prevColorEnv.b != envCol.b
	  || prevColorEnv.a != envCol.a) {
	prevColorEnv = envCol;
	GXSetTevColor(GX_TEVREG1, prevColorEnv);
      }
    } else {
      if (prevColorEnv.r != 0
	  || prevColorEnv.g != 0
	  || prevColorEnv.b != 0
	  || prevColorEnv.a != 0) {
	prevColorEnv.r = prevColorEnv.g = prevColorEnv.b
	  = prevColorEnv.a = 0;
	GXSetTevColor(GX_TEVREG1, prevColorEnv);
      }
    }
  }
  if (pp->kind & DispLighting) {
    GXColor mat, amb;
    getColorMatAmb(pp, &mat, &amb);
    if (pp->kind & PrimEnv) {
      if (prevColorMat.r != mat.r
	  || prevColorMat.g != mat.g
	  || prevColorMat.b != mat.b
	  || prevColorMat.a != mat.a) {
	prevColorMat = mat;
	GXSetTevColor(GX_TEVREG2, prevColorMat);
      }
    } else {
      mat.a = (mat.a * primCol.a) >> 8;
      if (prevColorMat.r != mat.r
	  || prevColorMat.g != mat.g
	  || prevColorMat.b != mat.b
	  || prevColorMat.a != mat.a) {
	prevColorMat = mat;
	GXSetTevColor(GX_TEVREG2, prevColorMat);
      }
    }
  }
}

static GXPosNrmMtx currentMtx;
inline void psSetCurrentMtx(GXPosNrmMtx idx)
{
  if (idx == currentMtx)
    return;
  currentMtx = idx;
  GXSetCurrentMtx(idx);
}

/* _tH[}bg̕ʖ` */
#define VTXFMT_PTi  GX_VTXFMT0
#define VTXFMT_P    GX_VTXFMT1
#define VTXFMT_PCTi GX_VTXFMT2
#define VTXFMT_PC   GX_VTXFMT3
#define VTXFMT_PTd  GX_VTXFMT4
#define VTXFMT_PCTd GX_VTXFMT5

/* ----------------------------------------------------------------------------
 * _f[^𗬂
 */

/* |CgƂĕ\ */
/* ȗqz */
/* |Cg̐ */
/*   TCYʏŌŒ */
inline Particle *psDispSubPoint(Particle *pp) 
{
  u8 size;
#if PS_USE_POINTCOMPRESS == 1
  int cnt;
  Particle *np, *pr;

  float pos[16*3];
  float *dl;
#endif

  psSetCurrentMtx(GX_PNMTX0); /* vmtx */

  size = pp->size > 42.5 ? 255 : pp->size * 6;
  if (prevPointSize != size) {
    prevPointSize = size;
    GXSetPointSize(size, GX_TO_ONE);
  }

#if PS_USE_POINTCOMPRESS != 1
  if (pp->kind & DispTexture) {
    setVtxDesc(0);
    GXBegin(GX_POINTS, VTXFMT_PTi, 1);
  } else {
    setVtxDesc(1);
    GXBegin(GX_POINTS, VTXFMT_P, 1);
  }
  GXPosition3f32(pp->x, pp->y, pp->z);
  SENDDUMMYNRM
    if (pp->kind & DispTexture)
      GXTexCoord1x8(1);
  GXEnd();
  return pp;
#else
  dl = pos;
  *dl++ = pp->x;
  *dl++ = pp->y;
  *dl++ = pp->z;
  cnt = 1;
  for (np = _psListGetNext(pp), pr = pp;
       np;
       pr = np, np = _psListGetNext(np)) {
    if (np->size != pp->size
#if PSAPPSRT
	|| np->appsrt
#endif
	|| ((np->kind ^ pp->kind) & (DispPoint|DispTexture|DispLighting|Trail))
	|| np->primColCount
	|| np->primCol.r != pp->primCol.r
	|| np->primCol.g != pp->primCol.g
	|| np->primCol.b != pp->primCol.b
	|| np->primCol.a != pp->primCol.a
	/* eNX`̏ꍇ͑Ȃ̂ŁAenvCol͖ */
	|| (np->kind & DispTexture))
      break;
    if ((pp->kind & DispLighting)
	&& (np->matColCount || np->ambColCount  /* Aj[VtNG */
	    || np->matRGB != pp->matRGB || np->matA != pp->matA
	    || np->ambRGB != pp->ambRGB || np->ambA != pp->ambA))
      break;
    
    *dl++ = np->x;
    *dl++ = np->y;
    *dl++ = np->z;
    cnt++;
    if (cnt == 16) {
      dl = pos;
      if (pp->kind & DispTexture) {
	setVtxDesc(0);
	GXBegin(GX_POINTS, VTXFMT_PTi, 16);
      } else {
	setVtxDesc(1);
	GXBegin(GX_POINTS, VTXFMT_P, 16);
      }
      while (cnt--) {
	GXPosition3f32(dl[0], dl[1], dl[2]);
	dl += 3;
	SENDDUMMYNRM
	  if (pp->kind & DispTexture)
	    GXTexCoord1x8(1);
      }
      GXEnd();
      dl = pos;
      cnt = 0;
    }
  }
  if (cnt) {
    dl = pos;
    if (pp->kind & DispTexture) {
      setVtxDesc(0);
      GXBegin(GX_POINTS, VTXFMT_PTi, cnt);
    } else {
      setVtxDesc(1);
      GXBegin(GX_POINTS, VTXFMT_P, cnt);
    }
    while (cnt--) {
      GXPosition3f32(dl[0], dl[1], dl[2]);
      dl += 3;
      SENDDUMMYNRM
	if (pp->kind & DispTexture)
	  GXTexCoord1x8(1);
    }
    GXEnd();
  }
  return pr;
#endif
}

/* TP */
inline Particle *psDispSubPointTrail(Particle *pp) 
{
  u8 size;
#if PS_USE_POINTCOMPRESS != 1
  float px, py, pz;
  GXColor col;
#else
  int cnt;
  Particle *np, *pr;

  float pos[16*3*2];
  float *dl;
  GXColor col[16*2];
  GXColor *cp;
#endif

  psSetCurrentMtx(GX_PNMTX0); /* vmtx */

  size = pp->size > 42.5 ? 255 : pp->size * 6;
  if (prevLineWidth != size) {
    prevLineWidth = size;
    GXSetLineWidth(size, GX_TO_ONE);
  }

#if PS_USE_POINTCOMPRESS != 1
  if (pp->kind & Tornado) {
    calcTornadoLastPos(pp, &px, &py, &pz);
  } else {
    px = pp->x - pp->vx;
    py = pp->y - pp->vy;
    pz = pp->z - pp->vz;
  }
  getClrTrail(pp, &col);

  if (pp->kind & DispTexture) {
    setVtxDesc(2);
    GXBegin(GX_LINES, VTXFMT_PCTi, 2);
  } else {
    setVtxDesc(3);
    GXBegin(GX_LINES, VTXFMT_PC, 2);
  }
  GXPosition3f32(px, py, pz);
  SENDDUMMYNRM
    GXColor4u8(col.r, col.g, col.b, col.a * pp->trail);
  if (pp->kind & DispTexture)
    GXTexCoord1x8(0);
  GXPosition3f32(pp->x, pp->y, pp->z);
  SENDDUMMYNRM
    GXColor4u8(col.r, col.g, col.b, col.a);
  if (pp->kind & DispTexture)
    GXTexCoord1x8(1);
  GXEnd();
  return pp;
#else
  dl = pos;
  cp = col;
  *dl++ = pp->x;
  *dl++ = pp->y;
  *dl++ = pp->z;
  if (pp->kind & Tornado) {
    float x, y, z;
    calcTornadoLastPos(pp, &x, &y, &z);
    *dl++ = x;
    *dl++ = y;
    *dl++ = z;
  } else {
    *dl++ = pp->x - pp->vx;
    *dl++ = pp->y - pp->vy;
    *dl++ = pp->z - pp->vz;
  }
  getClrTrail(pp, cp);
  *(cp+1) = *cp;
  (cp+1)->a *= pp->trail;
  cp += 2;
  cnt = 1;
  for (np = _psListGetNext(pp), pr = pp;
       np;
       pr = np, np = _psListGetNext(np)) {
    if (np->size != pp->size
#if PS_APPSRT
	|| np->appsrt
#endif
	|| ((np->kind^pp->kind) & (DispPoint|DispTexture|DispLighting|Trail))
	|| (np->kind & DispTexture))
      break;
    
    *dl++ = np->x;
    *dl++ = np->y;
    *dl++ = np->z;
    if (np->kind & Tornado) {
      float x, y, z;
      calcTornadoLastPos(np, &x, &y, &z);
      *dl++ = x;
      *dl++ = y;
      *dl++ = z;
    } else {
      *dl++ = np->x - np->vx;
      *dl++ = np->y - np->vy;
      *dl++ = np->z - np->vz;
    }
    getClrTrail(np, cp);
    *(cp+1) = *cp;
    (cp+1)->a *= np->trail;
    cp += 2;
    cnt++;
    if (cnt == 16) {
      dl = pos;
      cp = col;
      if (pp->kind & DispTexture) {
	setVtxDesc(2);
	GXBegin(GX_LINES, VTXFMT_PCTi, 16*2);
      } else {
	setVtxDesc(3);
	GXBegin(GX_LINES, VTXFMT_PC, 16*2);
      }
      while (cnt--) {
	GXPosition3f32(dl[3], dl[4], dl[5]);
	SENDDUMMYNRM
	  GXColor4u8((cp+1)->r, (cp+1)->g, (cp+1)->b, (cp+1)->a);
	if (pp->kind & DispTexture)
	  GXTexCoord1x8(0);
	GXPosition3f32(dl[0], dl[1], dl[2]);
	SENDDUMMYNRM
	  GXColor4u8(cp->r, cp->g, cp->b, cp->a);
	if (pp->kind & DispTexture)
	  GXTexCoord1x8(1);
	dl += 6;
	cp += 2;
      }
      GXEnd();
      dl = pos;
      cp = col;
      cnt = 0;
    }
  }
  if (cnt) {
    dl = pos;
    cp = col;
    if (pp->kind & DispTexture) {
      setVtxDesc(2);
      GXBegin(GX_LINES, VTXFMT_PCTi, cnt*2);
    } else {
      setVtxDesc(3);
      GXBegin(GX_LINES, VTXFMT_PC, cnt*2);
    }
    while (cnt--) {
      GXPosition3f32(dl[3], dl[4], dl[5]);
      SENDDUMMYNRM
	GXColor4u8((cp+1)->r, (cp+1)->g, (cp+1)->b, (cp+1)->a);
      if (pp->kind & DispTexture)
	GXTexCoord1x8(0);
      GXPosition3f32(dl[0], dl[1], dl[2]);
      SENDDUMMYNRM
	GXColor4u8(cp->r, cp->g, cp->b, cp->a);
      if (pp->kind & DispTexture)
	GXTexCoord1x8(1);
      dl += 6;
      cp += 2;
    }
    GXEnd();
  }
  return pr;
#endif
}

//
//	|S
//
inline void psDispSubMakePolygon(
				 Particle *pp, u8 *texform,
				 float x, float y, float z,
				 float ppvx, float ppvy, float ppvz,
				 float x0, float y0, float z0,
				 float x1, float y1, float z1 )
{
  psSetCurrentMtx(GX_PNMTX0); /* vmtx */
  if (pp->kind & Trail) {
    GXColor mat;
    float tx, ty, tz;

    if (pp->kind & Tornado) {
#if	PS_APPSRT
      if( pp->appsrt )
      	calcTornadoLastPosAPPSRT(pp, &tx, &ty, &tz);
      else
#endif
      	calcTornadoLastPos(pp, &tx, &ty, &tz);
      
    } else {
      tx = x - ppvx;
      ty = y - ppvy;
      tz = z - ppvz;
    }
    getClrTrail(pp, &mat);

    if (!texform) { /*  `w薳 */
      if (pp->kind & DispTexture) {
	setVtxDesc(2);
	GXBegin(GX_QUADS, VTXFMT_PCTi, 4);
      } else {
	setVtxDesc(3);
	GXBegin(GX_QUADS, VTXFMT_PC, 4);
      }
      
      GXPosition3f32(tx - x0, ty - y0, tz - z0);
      SENDDUMMYNRM
	GXColor4u8(mat.r, mat.g, mat.b, mat.a * pp->trail);
      if (pp->kind & DispTexture)
	SENDTEXCOORD(0, pp->kind);
      GXPosition3f32(x - x1, y - y1, z - z1);
      SENDDUMMYNRM
	GXColor4u8(mat.r, mat.g, mat.b, mat.a);
      if (pp->kind & DispTexture)
	SENDTEXCOORD(1, pp->kind);
      GXPosition3f32(x + x0, y + y0, z + z0);
      SENDDUMMYNRM
	GXColor4u8(mat.r, mat.g, mat.b, mat.a);
      if (pp->kind & DispTexture)
	SENDTEXCOORD(2, pp->kind);
      GXPosition3f32(tx + x1, ty + y1, tz + z1);
      SENDDUMMYNRM
	GXColor4u8(mat.r, mat.g, mat.b, mat.a * pp->trail);
      if (pp->kind & DispTexture)
	SENDTEXCOORD(3, pp->kind);
      GXEnd();
    } else {
      /* `w肠*/
      u32 nbPrimitive;
      float itrail;
      float vlen;

      itrail = (1.0F - pp->trail) * 255;

      vlen = sqrtf(x1 * x1 + y1 * y1 + z1 * z1);
      if (fabs(vlen) < FLT_MIN)
	goto TheEnd;
      vlen = sqrtf((x-tx)*(x-tx) + (y-ty)*(y-ty) + (z-tz)*(z-tz)) / vlen;
      if (vlen < 1.0F)
	vlen = 1.0F;
      x1 *= vlen;
      y1 *= vlen;
      z1 *= vlen;

      nbPrimitive = *(u32*)texform;
      texform += 4;
      for (; nbPrimitive > 0; nbPrimitive--) {
	int i;
	GXPrimitive primitivetype;
	u8 nbVtx;

	primitivetype = (GXPrimitive)*texform++;
	nbVtx = *texform++;
	texform += 2; // pad
	if (pp->kind & DispTexture) {
	  setVtxDesc(5);
	  GXBegin(primitivetype, VTXFMT_PCTd, nbVtx);
	} else {
	  setVtxDesc(3);
	  GXBegin(primitivetype, VTXFMT_PC, nbVtx);
	}
	for (i = 0; i < nbVtx; i++) {
	  int ta;
	  float u, v;
	  float u0, v0;
	  u = *(float*)texform;
	  texform += 4;
	  u0 = (u - 0.5F) * 2.0F;
	  if (pp->kind & TexFlipS)
	    u = 1.0F - u;
	  v = *(float*)texform;
	  texform += 4;
	  ta = 255 - v * itrail;
	  if (ta < 0)
	    ta =  0;
	  if (ta > 255)
	    ta = 255;
	  v0 = (v - 0.5F) * 2.0F;
	  if (pp->kind & TexFlipT)
	    v = 1.0F - v;
	  GXPosition3f32(x + x0*u0 + x1*v0,
			 y + y0*u0 + y1*v0,
			 z + z0*u0 + z1*v0);
	  SENDDUMMYNRM
	    GXColor4u8(mat.r, mat.g, mat.b, (u8)ta);
	  if (pp->kind & DispTexture)
	    GXTexCoord2f32(u, v);
	}
	GXEnd();
      }
    }
  } else {
    if (!texform) { // `w薳
      if (pp->kind & DispTexture) {
	setVtxDesc(0);
	GXBegin(GX_QUADS, VTXFMT_PTi, 4);
      } else {
	setVtxDesc(1);
	GXBegin(GX_QUADS, VTXFMT_P, 4);
      }
     
      GXPosition3f32(x - x0, y - y0, z - z0);
      SENDDUMMYNRM
	if (pp->kind & DispTexture)
	  SENDTEXCOORD(0, pp->kind);
      GXPosition3f32(x - x1, y - y1, z - z1);
      SENDDUMMYNRM
	if (pp->kind & DispTexture)
	  SENDTEXCOORD(1, pp->kind);
      GXPosition3f32(x + x0, y + y0, z + z0);
      SENDDUMMYNRM
	if (pp->kind & DispTexture)
	  SENDTEXCOORD(2, pp->kind);
      GXPosition3f32(x + x1, y + y1, z + z1);
      SENDDUMMYNRM
	if (pp->kind & DispTexture)
	  SENDTEXCOORD(3, pp->kind);
      GXEnd();
    } else {
      /* `w肠*/
      u32 nbPrimitive;

      nbPrimitive = *(u32*)texform;
      texform += 4;
      for (; nbPrimitive > 0; nbPrimitive--) {
	int i;
	GXPrimitive primitivetype;
	u8 nbVtx;


	primitivetype = (GXPrimitive)*texform++;
	nbVtx = *texform++;
	texform += 2; // pad
	if (pp->kind & DispTexture) {
	  setVtxDesc(4);
	  GXBegin(primitivetype, VTXFMT_PTd, nbVtx);
	} else {
	  setVtxDesc(1);
	  GXBegin(primitivetype, VTXFMT_P, nbVtx);
	}
	for (i = 0; i < nbVtx; i++) {
	  float u, v;
	  float u0, v0;
	  u = *(float*)texform;
	  texform += 4;
	  u0 = (u - 0.5F) * 2.0F;
	  if (pp->kind & TexFlipS)
	    u = 1.0F - u;
	  v = *(float*)texform;
	  texform += 4;
	  v0 = (v - 0.5F) * 2.0F;
	  if (pp->kind & TexFlipT)
	    v = 1.0F - v;
	  GXPosition3f32(x + x0*u0 + x1*v0,
			 y + y0*u0 + y1*v0,
			 z + z0*u0 + z1*v0);
	  SENDDUMMYNRM
	    if (pp->kind & DispTexture)
	      GXTexCoord2f32(u, v);
	}
	GXEnd();
      }
    }
  }

 TheEnd:;


}



/* ʏ̕\(APPSRTȂASȃr{[h) */
inline void psDispSub(Particle *pp, u8 *texform)
{
  register float x, y, z;
  register float x0, x1, y0, y1, z0, z1;
  float rotate;

  x = pp->x;
  y = pp->y;
  z = pp->z;

  if (texform) {
    x0 = rvmtx[0][0] * pp->size;
    x1 = -rvmtx[0][1] * pp->size;
    y0 = rvmtx[1][0] * pp->size;
    y1 = -rvmtx[1][1] * pp->size;
    z0 = rvmtx[2][0] * pp->size;
    z1 = -rvmtx[2][1] * pp->size;
  } else {
    x0 = rx0 * pp->size;
    x1 = rx1 * pp->size;
    y0 = ry0 * pp->size;
    y1 = ry1 * pp->size;
    z0 = rz0 * pp->size;
    z1 = rz1 * pp->size;
  }


  if ((pp->kind & Trail) || (pp->kind & DirVec)) {

    float tx, ty;
    if (prj[0] == 0) { /* Perspective */
      float vx, vy, vz, tw, pw;
      if (pp->kind & Tornado) {
	calcTornadoLastPos(pp, &vx, &vy, &vz);
      } else {
	vx = pp->x - pp->vx;
	vy = pp->y - pp->vy;
	vz = pp->z - pp->vz;
      }

      tx = (vmtx[2][0]*pp->x + vmtx[2][1]*pp->y
      	+ vmtx[2][2]*pp->z + vmtx[2][3]);
      if( tx == 0.0F ) goto NoRot;
      pw = -1.0F / tx;
      
      ty = (vmtx[2][0]*vx + vmtx[2][1]*vy
		    + vmtx[2][2]*vz + vmtx[2][3]);
      if( ty == 0.0F ) goto NoRot;    
      tw = -1.0F / ty;
      
      tx = pw * (pvmtx[0][0]*pp->x + pvmtx[0][1]*pp->y
		 + pvmtx[0][2]*pp->z + pvmtx[0][3])
	-  tw * (pvmtx[0][0]*vx + pvmtx[0][1]*vy
		 + pvmtx[0][2]*vz + pvmtx[0][3]);
      ty = pw * (pvmtx[1][0]*pp->x + pvmtx[1][1]*pp->y
		 + pvmtx[1][2]*pp->z + pvmtx[1][3])
	-  tw * (pvmtx[1][0]*vx + pvmtx[1][1]*vy
		 + pvmtx[1][2]*vz + pvmtx[1][3]);
    } else { /* Ortho */
      if (pp->kind & Tornado) {
	float x, y, z, vx, vy, vz;
	calcTornadoLastPos(pp, &x, &y, &z);
	vx = pp->x - x;
	vy = pp->y - y;
	vz = pp->z - z;
	tx = pvmtx[0][0]*vx + pvmtx[0][1]*vy + pvmtx[0][2]*vz;
	ty = pvmtx[1][0]*vx + pvmtx[1][1]*vy + pvmtx[1][2]*vz;
      } else {
	tx = pvmtx[0][0]*pp->vx + pvmtx[0][1]*pp->vy + pvmtx[0][2]*pp->vz;
	ty = pvmtx[1][0]*pp->vx + pvmtx[1][1]*pp->vy + pvmtx[1][2]*pp->vz;
      }
    }
    if (fabs(ty) < FLT_MIN) {
      if (tx >= 0.0F)
	rotate = M_PI_2;
      else
	rotate = -M_PI_2;
    } else {
      rotate = atan2f(tx, ty);
    }
    if (pp->kind & DirVec)

      rotate += pp->rotate;
  } else {
NoRot:;
    rotate = pp->rotate;
  }

  if (fabs(rotate) > ROTATE_EPS) {
    Mtx mtx;
    Vec axis;
    Vec v0, v1;
    v0.x = x0;
    v0.y = y0;
    v0.z = z0;
    v1.x = x1;
    v1.y = y1;
    v1.z = z1;
    axis.x = y0*z1 - z0*y1;
    axis.y = z0*x1 - x0*z1;
    axis.z = x0*y1 - y0*x1;
    MTXRotAxisRad(mtx, &axis, rotate);
    x0 = mtx[0][0]*v0.x + mtx[0][1]*v0.y + mtx[0][2]*v0.z;
    y0 = mtx[1][0]*v0.x + mtx[1][1]*v0.y + mtx[1][2]*v0.z;
    z0 = mtx[2][0]*v0.x + mtx[2][1]*v0.y + mtx[2][2]*v0.z;
    x1 = mtx[0][0]*v1.x + mtx[0][1]*v1.y + mtx[0][2]*v1.z;
    y1 = mtx[1][0]*v1.x + mtx[1][1]*v1.y + mtx[1][2]*v1.z;
    z1 = mtx[2][0]*v1.x + mtx[2][1]*v1.y + mtx[2][2]*v1.z;
  }

  /*|S*/
  psDispSubMakePolygon( pp, texform, x,y,z, pp->vx,
			pp->vy, pp->vz, x0,y0,z0, x1,y1,z1 );
	
}

#if	PS_APPSRT
/*
  //	APPSRTt
*/
inline void psDispSubAppSRT(Particle *pp, u8 *texform)
{
  register float x0, x1, y0, y1, z0, z1;
  float rotate;
  register float ppx, ppy, ppz;
  register float ppvx, ppvy, ppvz;
  
 
  Vec v,v0,v1;
  Mtx	srmtx;
  Vec	sca = {1,1,1};
  Vec tra ={0,0,0};
  Quaternion rot={0,0,0};

  if (pp->appsrt->frameNum != psFrameNum) {
    if (pp->appsrt->status != PS_APPSTATUS_STILL)
      //AppSRT}gNXvZ
      HSD_MTXSRT( pp->appsrt->mmtx, &pp->appsrt->sca,
		  &pp->appsrt->rot, &pp->appsrt->tra, NULL);
    if (pp->appsrt->status == PS_APPSTATUS_ONCE)
      pp->appsrt->status = PS_APPSTATUS_STILL;
    
  }
  /* ̃t[ŌvZƂL^ */
  pp->appsrt->frameNum = psFrameNum;

  MTXCopy( pp->appsrt->mmtx, srmtx );
  srmtx[0][3] -= pp->appsrt->tra.x;	
  srmtx[1][3] -= pp->appsrt->tra.y;	
  srmtx[2][3] -= pp->appsrt->tra.z;	//gX[g

  v.x = pp->vx; v.y = pp->vy; v.z = pp->vz;
  MTXMultVec( srmtx, &v, &v );	// xAppSRT
  //r{[h
  if( pp->appsrt->billboard && !(pp->kind & Tornado)  )
    MTXMultVec( rvmtxRot, &v, &v );

  ppvx = v.x; ppvy = v.y; ppvz = v.z;	

  v.x = pp->x; v.y = pp->y; v.z = pp->z;
  if( pp->appsrt->billboard ){
    //r{[h
    MTXMultVec( srmtx, &v, &v );	// ʒuAppSRT
    MTXMultVec( rvmtxRot, &v, &v );
    v.x += pp->appsrt->tra.x;
    v.y += pp->appsrt->tra.y;
    v.z += pp->appsrt->tra.z;
  } else 
    MTXMultVec( pp->appsrt->mmtx, &v, &v );	// ʒuAppSRT
  ppx = v.x; ppy = v.y; ppz = v.z;	

	
  if ( texform ) {
    Mtx	mtx;
    MTXScale( mtx, pp->appsrt->sca.x, pp->appsrt->sca.y, 1.0 );
    MTXConcat( rvmtx, mtx, mtx );
    x0 = mtx[0][0] * pp->size;
    x1 = -mtx[0][1] * pp->size;
    y0 = mtx[1][0] * pp->size;
    y1 = -mtx[1][1] * pp->size;
    z0 = mtx[2][0] * pp->size;
    z1 = -mtx[2][1] * pp->size;

  } else {

    v0.x = pp->appsrt->sca.x  + vmtx[0][3];
    v0.y = pp->appsrt->sca.y  + vmtx[1][3];
    v0.z = 0 + vmtx[2][3];
    v1.x = pp->appsrt->sca.x  + vmtx[0][3];
    v1.y = -pp->appsrt->sca.y + vmtx[1][3];
    v1.z = 0 + vmtx[2][3];
		
    MTXMultVec( rvmtx, &v0, &v0 );
    x0 = v0.x * pp->size;
    y0 = v0.y * pp->size;;
    z0 = v0.z * pp->size;;

    MTXMultVec( rvmtx, &v1, &v1 );

    x1 = v1.x * pp->size;;
    y1 = v1.y * pp->size;;
    z1 = v1.z * pp->size;;
  }

  if ((pp->kind & Trail) || (pp->kind & DirVec) ) {

    float tx, ty;

    if (prj[0] == 0) { /* Perspective */
      float vx, vy, vz, tw, pw;
      if (pp->kind & Tornado) {

	calcTornadoLastPos(pp, &vx, &vy, &vz);
	v.x = vx; v.y = vy; v.z = vz;
	if( pp->appsrt->billboard ){	//r{[h
	  MTXMultVec( srmtx, &v, &v );	
	  MTXMultVec( rvmtxRot, &v, &v );
	  v.x += pp->appsrt->tra.x;
	  v.y += pp->appsrt->tra.y;
	  v.z += pp->appsrt->tra.z;
	} else 
	  MTXMultVec( pp->appsrt->mmtx, &v, &v );	// ʒuAppSRT
	vx = v.x; vy = v.y; vz = v.z;

      } else {
	vx = ppx - ppvx;
	vy = ppy - ppvy;
	vz = ppz - ppvz;

      }
      tx =  (vmtx[2][0]*ppx + vmtx[2][1]*ppy
		    + vmtx[2][2]*ppz + vmtx[2][3]);
      if( tx == 0.0F )
      	goto NoRot;
      pw = -1.0F / tx;

      ty = (vmtx[2][0]*vx + vmtx[2][1]*vy
		    + vmtx[2][2]*vz + vmtx[2][3]);
      if( ty == 0.0F )
      	goto NoRot;
      tw = -1.0F / ty;
		    
      tx = pw * (pvmtx[0][0]*ppx + pvmtx[0][1]*ppy
		 + pvmtx[0][2]*ppz + pvmtx[0][3])
	-  tw * (pvmtx[0][0]*vx + pvmtx[0][1]*vy
		 + pvmtx[0][2]*vz + pvmtx[0][3]);

      ty = pw * (pvmtx[1][0]*ppx + pvmtx[1][1]*ppy
		 + pvmtx[1][2]*ppz + pvmtx[1][3])
	-  tw * (pvmtx[1][0]*vx + pvmtx[1][1]*vy
		 + pvmtx[1][2]*vz + pvmtx[1][3]);

    } else { /* Ortho */
      if (pp->kind & Tornado) {
	float vx, vy, vz;

	calcTornadoLastPos(pp, &vx, &vy, &vz);
	v.x = vx; v.y = vy; v.z = vz;
	if( pp->appsrt->billboard ){	//r{[h
	  MTXMultVec( srmtx, &v, &v );	
	  MTXMultVec( rvmtxRot, &v, &v );
	  v.x += pp->appsrt->tra.x;
	  v.y += pp->appsrt->tra.y;
	  v.z += pp->appsrt->tra.z;
	} else 
	  MTXMultVec( pp->appsrt->mmtx, &v, &v );	// ʒuAppSRT
	vx = ppx - v.x;
	vy = ppy - v.y;
	vz = ppz - v.z;

	tx = pvmtx[0][0]*vx + pvmtx[0][1]*vy + pvmtx[0][2]*vz;
	ty = pvmtx[1][0]*vx + pvmtx[1][1]*vy + pvmtx[1][2]*vz;
      } else {
	tx = pvmtx[0][0]*ppvx + pvmtx[0][1]*ppvy + pvmtx[0][2]*ppvz;
	ty = pvmtx[1][0]*ppvx + pvmtx[1][1]*ppvy + pvmtx[1][2]*ppvz;
      }
    }
    if (fabs(ty) < FLT_MIN) {
      if (tx >= 0.0F)
	rotate = M_PI_2;
      else
	rotate = -M_PI_2;
    } else {
      rotate = atan2f(tx, ty);
    }
    if (pp->kind & DirVec)

      rotate += pp->rotate;
  } else {
NoRot:;
    rotate = pp->rotate;
  }

#if PS_APPSRTROTATE
  
  if (!(pp->kind & Trail) && !(pp->kind & DirVec)) {

	float tx, ty, tw, pw;
	Vec v;

	v.x = 0;
	v.y = 1;
	v.z = 0;
	MTXMultVec( srmtx, &v, &v );	


	tx =  (vmtx[2][0]*v.x + vmtx[2][1]*v.y
	   + vmtx[2][2]*v.z + vmtx[2][3]);
	if( tx == 0.0F ) goto NoRot2;
	pw = -1.0F / tx;

	ty = vmtx[2][3];
	if( ty == 0.0F ) goto NoRot2;
	tw = -1.0F / ty;
			    
	tx = pw * (pvmtx[0][0]*v.x + pvmtx[0][1]*v.y
		 + pvmtx[0][2]*v.z + pvmtx[0][3])
	   -  tw * (pvmtx[0][3]);

	ty = pw * (pvmtx[1][0]*v.x + pvmtx[1][1]*v.y
		 + pvmtx[1][2]*v.z + pvmtx[1][3])
		 -  tw * (pvmtx[1][3]);
		 

    if (fabs(ty) < FLT_MIN) {
      if (tx >= 0.0F)
	rotate = M_PI_2;
      else
	rotate = -M_PI_2;
    } else {
      rotate = atan2f(tx, ty);
    }
    if (pp->kind & DirVec)

      rotate += pp->rotate;
  } else {
NoRot2:;
    rotate = pp->rotate;
   }		 
#endif


  if (fabs(rotate) > ROTATE_EPS) {
    Mtx mtx;
    Vec axis;
    Vec v0, v1;
    
    v0.x = x0;
    v0.y = y0;
    v0.z = z0;
    v1.x = x1;
    v1.y = y1;
    v1.z = z1;
    axis.x = y0*z1 - z0*y1;
    axis.y = z0*x1 - x0*z1;
    axis.z = x0*y1 - y0*x1;	/* @𓾂(O) */
    MTXRotAxisRad(mtx, &axis, rotate);
    x0 = mtx[0][0]*v0.x + mtx[0][1]*v0.y + mtx[0][2]*v0.z;
    y0 = mtx[1][0]*v0.x + mtx[1][1]*v0.y + mtx[1][2]*v0.z;
    z0 = mtx[2][0]*v0.x + mtx[2][1]*v0.y + mtx[2][2]*v0.z;
    x1 = mtx[0][0]*v1.x + mtx[0][1]*v1.y + mtx[0][2]*v1.z;
    y1 = mtx[1][0]*v1.x + mtx[1][1]*v1.y + mtx[1][2]*v1.z;
    z1 = mtx[2][0]*v1.x + mtx[2][1]*v1.y + mtx[2][2]*v1.z;
  }

#if PS_TEXDIRECTION
  if (pp->appsrt->mmtx[0][0] < 0.0F)
    td = 1;
  else
    td = 0;
  if (pp->appsrt->mmtx[1][1] < 0.0F)
    td += 2;
#endif

  //|S
  psDispSubMakePolygon( pp, texform, ppx,ppy,ppz, 
			ppvx, ppvy, ppvz, x0,y0,z0, x1,y1,z1 );
}



inline void psDispSubAPPSRTPoint(Particle *pp)
{
  float tx, ty, tz;
  u8 size;
  register float ppx, ppy, ppz;
  register float ppvx, ppvy, ppvz;
  
  Vec v;
  Mtx	srmtx;
  Vec	sca = {1,1,1};
  Vec tra ={0,0,0};
  Quaternion rot={0,0,0};

  psSetCurrentMtx(GX_PNMTX0); /* vmtx */

  if (pp->appsrt->frameNum != psFrameNum) {
    if (pp->appsrt->status != PS_APPSTATUS_STILL)
      //AppSRT}gNXvZ
      HSD_MTXSRT( pp->appsrt->mmtx, &pp->appsrt->sca, &pp->appsrt->rot, &pp->appsrt->tra, NULL);
    if (pp->appsrt->status == PS_APPSTATUS_ONCE)
      pp->appsrt->status = PS_APPSTATUS_STILL;
    
  }
  /* ̃t[ŌvZƂL^ */
  pp->appsrt->frameNum = psFrameNum;

  MTXCopy( pp->appsrt->mmtx, srmtx );
  srmtx[0][3] -= pp->appsrt->tra.x;	
  srmtx[1][3] -= pp->appsrt->tra.y;	
  srmtx[2][3] -= pp->appsrt->tra.z;	//gX[g

  v.x = pp->vx; v.y = pp->vy; v.z = pp->vz;
  MTXMultVec( srmtx, &v, &v );	// xAppSRT
  //r{[h
  if( pp->appsrt->billboard )
    MTXMultVec( rvmtxRot, &v, &v );
  ppvx = v.x; ppvy = v.y; ppvz = v.z;	

  v.x = pp->x; v.y = pp->y; v.z = pp->z;
  if( pp->appsrt->billboard ){
    //r{[h
    MTXMultVec( srmtx, &v, &v );	// ʒuAppSRT
    MTXMultVec( rvmtxRot, &v, &v );
    v.x += pp->appsrt->tra.x;
    v.y += pp->appsrt->tra.y;
    v.z += pp->appsrt->tra.z;
  } else 
    MTXMultVec( pp->appsrt->mmtx, &v, &v );	// ʒuAppSRT
  ppx = v.x; ppy = v.y; ppz = v.z;	

  if (pp->kind & Tornado) {
    calcTornadoLastPosAPPSRT(pp, &tx, &ty, &tz);
  } else {

    tx = ppx - ppvx;
    ty = ppy - ppvy;
    tz = ppz - ppvz;
  }

  size = pp->size > 42.5 ? 255 : pp->size * 6;

  if (pp->kind & Trail) {
    GXColor mat;
    if (prevLineWidth != size) {
      prevLineWidth = size;
      GXSetLineWidth(size, GX_TO_ONE);
    }
    getClrTrail(pp, &mat);
    if (pp->kind & DispTexture) {
      setVtxDesc(2);
      GXBegin(GX_LINES, VTXFMT_PCTi, 2);
    } else {
      setVtxDesc(3);
      GXBegin(GX_LINES, VTXFMT_PC, 2);
    }
    GXPosition3f32(tx, ty, tz);
    SENDDUMMYNRM
      GXColor4u8(mat.r, mat.g, mat.b, mat.a * pp->trail);
    if (pp->kind & DispTexture)
      GXTexCoord1x8(0);
    GXPosition3f32(ppx, ppy, ppz);
    SENDDUMMYNRM
      GXColor4u8(mat.r, mat.g, mat.b, mat.a);
    if (pp->kind & DispTexture)
      GXTexCoord1x8(1);
    GXEnd();
  } else {
    if (prevPointSize != size) {
      prevPointSize = size;
      GXSetPointSize(size, GX_TO_ONE);
    }
    if (pp->kind & DispTexture) {
      setVtxDesc(0);
      GXBegin(GX_POINTS, VTXFMT_PTi, 1);
    } else {
      setVtxDesc(1);
      GXBegin(GX_POINTS, VTXFMT_P, 1);
    }
    GXPosition3f32(ppx, ppy, ppz);
    SENDDUMMYNRM
      if (pp->kind & DispTexture)
	GXTexCoord1x8(1);
    GXEnd();
  }
}
#endif






/* ----------------------------------------------------------------------------
 * `惁C
 */
//#if FUJITA
f32 gParticleW = 0.f;
f32 gParticleH = 0.f;
f32 gParticleX = 0.f;
f32 gParticleY = 0.f;
//#endif
void psDispParticles(u32 target_link, u32 sw )
{
  Particle *pp;
  int linkNo;
  HSD_CObj *cobj;
  HSD_TlutDesc tlutdesc;
  GXTexObj texobj;

  /* O̕` */
  u8 *prevTex;		/* OɃ[heNX`f[^ւ̃|C^ */
  int prevTexEdge;
  int prevMirror;               /* Õ~[ݒ */
  u8 aCmpParam1, aCmpParam2;    /* ̃At@p[^ */
  int prevACmpMode = 0;           /* ÕAt@[h */
  u8 prevACmpParam1 = 0;          /* ÕAt@p[^P */
  u8 prevACmpParam2 = 255;        /* ÕAt@p[^Q */
  int doInitialize = TRUE;      /* ꂽtO */
  int prevTexInterp = 0; /* Ôsԕ@ 0:Linear 1:Near */
  u16 *prevLut; /* Tlut */
  u32 prevKind; /* Oɕ`悵p[eBNkind */
  u8 *texform = NULL;
#if FUJITA
  f32 vp_save[GX_VIEWPORT_SZ];
  f32 vp[GX_VIEWPORT_SZ];
  u32 x,y,w,h;
  GXGetViewportv(vp_save);
  GXGetViewportv(vp);
  vp[0] = gParticleX;
  vp[1] = gParticleY;
  vp[2] = gParticleW;
  vp[3] = gParticleH;
  GXGetScissor( &x, &y, &w, &h );
  //OSReport( "%f %f %f %f\n", gParticleX, gParticleY, gParticleW, gParticleH );
#endif
  if (sw == PS_TRSP_OPA) {
    /* t[ԍXV
     * ĩt[ōsvZǂ̔fɎgpj */
    if (psFrameNum < 0xff)
      psFrameNum++;
    else
      psFrameNum = 1;
    return; /* sŕ`̂͂Ȃ */
  }

  /* p[eBNANeCuXgɕ` */
  for (linkNo = 0; linkNo < PS_NUM_LINK; linkNo++) {
    Particle *listTexedge, *listXlu;
    if ((target_link & (1 << linkNo)) == 0)
      continue;	/* target_link̑ΏۃrbgItȂ\Ȃ */
    /* \̂߂Ƀ\[g */
    particleSort(linkNo, &listTexedge, &listXlu);
    switch (sw) {
    case PS_TRSP_TEXEDGE:
      pp = listTexedge;
      break;
    case PS_TRSP_XLU:
      pp = listXlu;
      break;
    default:
      pp = NULL;
      continue; // for (linkNo...)
    }

    for (; pp != NULL;
	 prevKind = pp->kind, pp = _psListGetNext(pp)) {
      if (sw == PS_TRSP_TEXEDGE && !(pp->kind & TexEdge))
	break;
      if (pp->size < FLT_EPSILON)
	continue;

      if (doInitialize) {
	prevPointSize = -1;
	prevLineWidth = -1;
	prevChanCtrl = -1;
	
	prevLut = NULL;
	prevTex = NULL;		/* OɃ[heNX` */
	psSetupTevInvalidState();
	prevMirror = -1;
	prevTexEdge = -1;

	prevKind &= ~DispFog; /* default : FogȂ */
	HSD_FogSet(NULL);

	prevChanMat.r = prevChanMat.g = prevChanMat.b = 255;
	prevChanAmb.r = prevChanAmb.g = prevChanAmb.b = 255;
	prevChanMat.a = prevChanAmb.a = 255; /* ͍Đݒ肳Ȃ */
	GXSetChanMatColor(GX_COLOR0A0, prevChanMat);
	GXSetChanAmbColor(GX_COLOR0A0, prevChanAmb);

	psSetupTevInvalidState();
	psSetupTevCommon();

	prevColorPrim.r = 255;
	prevColorPrim.g = 255;
	prevColorPrim.b = 255;
	prevColorPrim.a = 255; 
	prevColorEnv.r = 0;
	prevColorEnv.g = 0;
	prevColorEnv.b = 0;
	prevColorEnv.a = 0;
	prevColorMat.r = 255;
	prevColorMat.g = 255;
	prevColorMat.b = 255;
	prevColorMat.a = 255;
	GXSetTevColor(GX_TEVREG0, prevColorPrim);
	GXSetTevColor(GX_TEVREG1, prevColorEnv);
	GXSetTevColor(GX_TEVREG2, prevColorMat);

				/*
				 * P.E ݒ
				 */
	prevBlendMode = -1;
				/*GXSetDither(GX_TRUE);*/
	GXSetZCompLoc(GX_FALSE);


	cobj = HSD_CObjGetCurrent();
	HSD_CObjGetViewingMtx(cobj, vmtx); /* ݂̃r[COs𓾂 */
	MTXInverse(vmtx, rvmtx);	   /* tr[COs𓾂 */
	{
	  GXGetProjectionv(prj);
	  /* gݒ肷 */
	  if (prj[0] == 0) { /* Perspective*/
	    pvmtx[0][0] = prj[1]*vmtx[0][0] + prj[2]*vmtx[2][0];
	    pvmtx[0][1] = prj[1]*vmtx[0][1] + prj[2]*vmtx[2][1];
	    pvmtx[0][2] = prj[1]*vmtx[0][2] + prj[2]*vmtx[2][2];
	    pvmtx[0][3] = prj[1]*vmtx[0][3] + prj[2]*vmtx[2][3];
	    pvmtx[1][0] = prj[3]*vmtx[1][0] + prj[4]*vmtx[2][0];
	    pvmtx[1][1] = prj[3]*vmtx[1][1] + prj[4]*vmtx[2][1];
	    pvmtx[1][2] = prj[3]*vmtx[1][2] + prj[4]*vmtx[2][2];
	    pvmtx[1][3] = prj[3]*vmtx[1][3] + prj[4]*vmtx[2][3];
	  } else { /* Ortho */
	    pvmtx[0][0] = prj[1]*vmtx[0][0] + prj[2];
	    pvmtx[0][1] = prj[1]*vmtx[0][1] + prj[2];
	    pvmtx[0][2] = prj[1]*vmtx[0][2] + prj[2];
	    pvmtx[0][3] = prj[1]*vmtx[0][3] + prj[2];
	    pvmtx[1][0] = prj[3]*vmtx[1][0] + prj[4];
	    pvmtx[1][1] = prj[3]*vmtx[1][1] + prj[4];
	    pvmtx[1][2] = prj[3]*vmtx[1][2] + prj[4];
	    pvmtx[1][3] = prj[3]*vmtx[1][3] + prj[4];
	  }
	};
	rx0 = rvmtx[0][0] + rvmtx[0][1]; /* ̂߃XP[lOvZ */
	rx1 = rvmtx[0][0] - rvmtx[0][1];
	ry0 = rvmtx[1][0] + rvmtx[1][1];
	ry1 = rvmtx[1][0] - rvmtx[1][1];
	rz0 = rvmtx[2][0] + rvmtx[2][1];
	rz1 = rvmtx[2][0] - rvmtx[2][1];
	GXLoadPosMtxImm(vmtx, GX_PNMTX0);
	{
	  Mtx m = {1,0,0,0, 0,1,0,0, 0,0,1,0};
	  GXLoadPosMtxImm(m, GX_PNMTX1);
	}
	currentMtx = GX_PNMTX1;
	psSetCurrentMtx(GX_PNMTX0);
	GXEnableTexOffsets(GX_TEXCOORD0, GX_TRUE, GX_TRUE);
	

#if PS_APPSRT
	HSD_MtxGetRotationMtx( rvmtx, rvmtxRot, 'z','x' );
#endif
	
	GXSetCullMode(GX_CULL_BACK);
	
	GXSetArray(GX_VA_TEX0, billboard_tex0_u8, 2);
#ifdef DUMMY_NRM
	GXSetArray(GX_VA_NRM, nrm_s8, 3);
#endif

	GXSetVtxAttrFmt(VTXFMT_PTi, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_PTi, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif
	GXSetVtxAttrFmt(VTXFMT_PTi, GX_VA_TEX0, GX_TEX_ST, GX_U8, 0);

	GXSetVtxAttrFmt(VTXFMT_P, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_P, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif

	GXSetVtxAttrFmt(VTXFMT_PCTi, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_PCTi, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif
	GXSetVtxAttrFmt(VTXFMT_PCTi, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(VTXFMT_PCTi, GX_VA_TEX0, GX_TEX_ST, GX_U8, 0);

	GXSetVtxAttrFmt(VTXFMT_PC, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_PC, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif
	GXSetVtxAttrFmt(VTXFMT_PC, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);

	GXSetVtxAttrFmt(VTXFMT_PTd, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_PTd, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif
	GXSetVtxAttrFmt(VTXFMT_PTd, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	GXSetVtxAttrFmt(VTXFMT_PCTd, GX_VA_POS, GX_POS_XYZ, GX_F32, 0);
#ifdef DUMMY_NRM
	GXSetVtxAttrFmt(VTXFMT_PCTd, GX_VA_NRM, GX_NRM_XYZ, GX_S8, 0);
#endif
	GXSetVtxAttrFmt(VTXFMT_PCTd, GX_VA_CLR0, GX_CLR_RGBA, GX_RGBA8, 0);
	GXSetVtxAttrFmt(VTXFMT_PCTd, GX_VA_TEX0, GX_TEX_ST, GX_F32, 0);

	doInitialize = FALSE;
      } /* if (doInitialize) */

      setBlendMode((pp->kind >> BLENDSHIFT) & BLENDMASK);

      /* At@XbVhAj */
      if (pp->aCmpCount) {
	int scale = 65536 * pp->aCmpRemain  / pp->aCmpCount;
	aCmpParam1 = ((pp->aCmpParam1Target<<16)
		      + (pp->aCmpParam1 - pp->aCmpParam1Target)*scale) >> 16;
	aCmpParam2 = ((pp->aCmpParam2Target<<16)
		      + (pp->aCmpParam2 - pp->aCmpParam2Target)*scale) >> 16;
      } else {
	aCmpParam1 = pp->aCmpParam1;
	aCmpParam2 = pp->aCmpParam2;
      }
      if (prevACmpMode != pp->aCmpMode
	  || prevACmpParam1 != aCmpParam1
	  || prevACmpParam2 != aCmpParam2) {
	prevACmpMode = pp->aCmpMode;
	prevACmpParam1 = aCmpParam1;
	prevACmpParam2 = aCmpParam2;
	GXSetAlphaCompare((GXCompare)((prevACmpMode >> 3) & 7),
			  prevACmpParam1,
			  (GXAlphaOp)((prevACmpMode >> 6) & 3),
			  (GXCompare)(prevACmpMode & 7),
			  prevACmpParam2);
      }

      /* TEV̐ݒ */
      psSetupTev(pp);
      /* J[̐ݒ */
      setupChanCtrl(pp);
      setupChanReg(pp);
      /* sduWX^ݒ */
      setupTevReg(pp);

	  HSD_StateSetAlphaUpdate  (GX_DISABLE);
	  //GXSetAlphaUpdate( GX_FALSE );
      if ((pp->kind & (TexEdge| NoZComp)) != prevTexEdge) {
		prevTexEdge = pp->kind & ( TexEdge | NoZComp);
		if (prevTexEdge & TexEdge ) {
		  GXSetZMode((pp->kind & NoZComp)?GX_FALSE:GX_TRUE, GX_LEQUAL, GX_TRUE);
		} else {
		  GXSetZMode((pp->kind & NoZComp)?GX_FALSE:GX_TRUE, GX_LEQUAL, GX_FALSE);
		}
#if FUJITA
		//qpB
		if( (pp->kind & NoZComp) ){
		  f32			c_mask_x,c_mask_y,c_mask_w,c_mask_h;
		  //GXSetZMode(GX_TRUE, GX_LEQUAL, GX_FALSE);
		  //GXSetZMode(GX_TRUE, GX_GREATER, GX_FALSE);
		  //GXSetViewportv(vp);
		  
		  // modified by watanabe 031130
		  c_mask_x = gParticleX;
		  c_mask_y = gParticleY;
		  c_mask_w = gParticleW;
		  c_mask_h = gParticleH;
		  if( c_mask_x + c_mask_w > GHM_SCREEN_WIDTH ){
		  	c_mask_w -= c_mask_x + c_mask_w - GHM_SCREEN_WIDTH;
		  }
		  if( c_mask_x > GHM_SCREEN_WIDTH ){
		  	c_mask_x = GHM_SCREEN_WIDTH;
		  	c_mask_w = 0.0f;
		  }else if( c_mask_x < 0.0f ){
		  	c_mask_w += c_mask_x;
		  	c_mask_x  = 0.0f;
		  }
		  if( c_mask_y + c_mask_h > GHM_SCREEN_HEIGHT ){
		  	c_mask_h -= c_mask_y + c_mask_h - GHM_SCREEN_HEIGHT;
		  }
		  if( c_mask_y > GHM_SCREEN_HEIGHT ){
		  	c_mask_y = GHM_SCREEN_HEIGHT;
		  	c_mask_h = 0.0f;
		  }else if( c_mask_y < 0.0f ){
		  	c_mask_h += c_mask_y;
		  	c_mask_y  = 0.0f;
		  }
		  // modified by watanabe 031130
		  //		  GXSetScissor( (u32)c_mask_x, (u32)c_mask_y, (u32)c_mask_w, (u32)c_mask_h );
		  GXSetScissor( (u32)gParticleX, (u32)gParticleY, (u32)gParticleW, (u32)gParticleH );
		}else{
		  GXSetScissor( x, y, w, h );
		  //GXSetViewportv(vp_save);
		}
#endif
      }

      if ((pp->kind ^ prevKind) & DispFog) {
	if (pp->kind & DispFog) {
	  HSD_FogSet(particleFog);
	} else {
	  HSD_FogSet(NULL);
	}
      }

      /* `ݒ */
      if (psFormGroupArray[pp->bank]
	  && psFormGroupArray[pp->bank][pp->texGroup]
	  && psFormGroupArray[pp->bank][pp->texGroup]->formTable) {
	texform
	  = (psFormGroupArray[pp->bank][pp->texGroup]->formTable)[pp->poseNum];
      } else {
	texform = NULL;
      }

      /* eNX`̐ݒ */
      if (pp->kind & DispTexture) {
	TexGroup *texgroup;
	int texfmt, texwidth, texheight;
	u8 *tex;
	GXBool texmipmap;
	HSD_TexLODDesc *texlod;	
	GXTlutObj tlutobj;
	GXTexWrapMode texwrap_s, texwrap_t;
	u32 texmapping = TEX_COORD_UV;
	HSD_TlutDesc *textlutdesc = NULL;
	float texmtx_s, texmtx_t;
	u8 **textable;

	if (pp->kind & MirrorS) {
	  texmtx_s = 2;
	  texwrap_s = GX_MIRROR;
	} else {
	  texmtx_s = 1;
	  texwrap_s = GX_CLAMP;
	}
	if (pp->kind & MirrorT) {
	  texmtx_t = 2;
	  texwrap_t = GX_MIRROR;
	} else {
	  texmtx_t = 1;
	  texwrap_t = GX_CLAMP;
	}

				/* eNX`}gbNX̌vZ */
	if ((pp->kind & (MirrorS|MirrorT)) != prevMirror) {
	  Mtx texmtx;

	  prevMirror = pp->kind & (MirrorS|MirrorT);
	  prevTex = NULL; /* wrapς̂œǂݒ*/
	  /* ~[ */
	  MTXScale(texmtx, texmtx_s, texmtx_t, 1);
	  if (pp->kind & MirrorT) {
	    texmtx[1][3] = 1;
	  }
	  GXLoadTexMtxImm(texmtx, GX_TEXMTX0, GX_MTX2x4);
	  GXSetTexCoordGen(GX_TEXCOORD0,
			   GX_TG_MTX2x4,
			   GX_TG_TEX0,
			   GX_TEXMTX0);
	}
	  
	texgroup = psTexGroupArray[pp->bank][pp->texGroup];
	if (texgroup) {
	  texfmt = texgroup->fmt;
	  texwidth = texgroup->width;
	  texheight = texgroup->height;
	  textable = texgroup->texTable;
	} else {
	  texfmt = 0;
	  texwidth = texheight = 0;
	  textable = NULL;
	}
	if (textable)
	  tex = textable[pp->poseNum];
	else
	  tex = NULL;
	texmipmap = GX_FALSE;
	texlod = NULL;
		
				/* TLUT̐ݒ */
	if (texfmt == GX_TF_C4
	    || texfmt == GX_TF_C8
	    /* || texfmt == GX_TF_X14X2 */) {
	  u16 **paltbl;
	  
	  if (textable) {
	    paltbl = (u16**)(&textable[texgroup->num]);

	    if (paltbl) {
	      if (pp->palNum != PSNoPal) {
		/* pbgAj[Vw肠 */
		tlutdesc.lut = paltbl[pp->palNum];
	      } else {
		/* pbgAj[VwȂ */
		if ((pp->kind & ComTLUT) == 0)
		  tlutdesc.lut = paltbl[pp->poseNum];
		else
		  tlutdesc.lut = paltbl[0];
	      }
	      if (tlutdesc.lut != prevLut) {
		tlutdesc.fmt = (GXTlutFmt)texgroup->tlutfmt;
		tlutdesc.tlut_name = GX_TLUT0;
		tlutdesc.n_entries = (texfmt == GX_TF_C4) ? 16 : 256;
	    
		GXInitTlutObj(&tlutobj, tlutdesc.lut, tlutdesc.fmt,
			      tlutdesc.n_entries);
		GXLoadTlut(&tlutobj, tlutdesc.tlut_name);
	      }
	      prevTex = NULL; /* eNX`ǂݒȂ΂ȂȂI */
	    }
	  }
	}

				/* eNX`̓ǂݍ */
	if (prevTex != tex && tex != NULL) {
	  prevTex = tex;
	  
	  assert(texmapping != TEX_COORD_HILIGHT &&
		 texmapping != TEX_COORD_REFLECTION);
	  switch (texfmt) {
	  case GX_TF_C4:
	  case GX_TF_C8:
	    /* case GX_TF_C14X2: */
	    GXInitTexObjCI(&texobj, (void*)tex,
			   texwidth, texheight,
			   (GXCITexFmt)texfmt,
			   texwrap_s, texwrap_t,
			   texmipmap, GX_TLUT0);
	    break;
	  case GX_TF_I4:
	  case GX_TF_I8:
	  case GX_TF_IA4:
	  case GX_TF_IA8:
	  case GX_TF_RGB565:
	  case GX_TF_RGB5A3:
	  case GX_TF_RGBA8:
	  case GX_TF_CMPR:
	    GXInitTexObj(&texobj, (void*)tex,
			 texwidth, texheight, (GXTexFmt)texfmt,
			 texwrap_s, texwrap_t, texmipmap);
	    break;
	  default:
	    assert(0);
	  }
	  prevTexInterp = pp->kind & TexInterpNear;
	  GXInitTexObjLOD(&texobj,
			  prevTexInterp ? GX_NEAR : GX_LINEAR,
			  prevTexInterp ? GX_NEAR : GX_LINEAR,
			  0.0, 0.0F, 0.0F,
			  GX_FALSE, GX_FALSE, GX_ANISO_1);
	  GXLoadTexObj(&texobj, GX_TEXMAP0);
	}

	if (prevTexInterp != (pp->kind & TexInterpNear)) {
	  prevTexInterp = pp->kind & TexInterpNear;
	  GXInitTexObjLOD(&texobj,
			  prevTexInterp ? GX_NEAR : GX_LINEAR,
			  prevTexInterp ? GX_NEAR : GX_LINEAR,
			  0.0, 0.0F, 0.0F,
			  GX_FALSE, GX_FALSE, GX_ANISO_1);
	  GXLoadTexObj(&texobj, GX_TEXMAP0);
	}
      } // end of DispTexture
      
      if (pp->kind & DispPoint) { /* use GX_POINTS */
#if PS_APPSRT
	if (pp->appsrt) {
	  psDispSubAPPSRTPoint(pp);
	} else {
#endif
	  if (pp->kind & Trail) {
	    pp = psDispSubPointTrail(pp); /* ܂Ƃ߂ĕ` */
	  } else { 
	    pp = psDispSubPoint(pp); /* ܂Ƃ߂ĕ` */
	  }
#if PS_APPSRT
	}
#endif
      } else {

#if PS_APPSRT
	if (pp->appsrt)
	
	  psDispSubAppSRT(pp, texform);
	else
#endif
	  psDispSub(pp, texform);
      }
    }
  }
#if FUJITA
  GXSetScissor( x, y, w, h );
#endif
  if (!doInitialize)
    HSD_StateInvalidate(HSD_STATE_ALL);
}

