/*
 * Copyright 1999-2001 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: shadow.c,v 1.9 2004/07/27 02:14:29 TypeR Exp $
 */
//#define  FUJITA 1

#ifdef FUJITA
#pragma cplusplus			off
#pragma cpp_extensions		off
#pragma warn_implicitconv	off
#define DIST 3000.f
//#define STEP 1.f
//#define NEAR (DIST - DIST/2.f)
//#define FAR (DIST + DIST/2.f)
#define NEAR 100.f
#define FAR 1000.f

 f32 gDist = DIST;
 f32 gNear = DIST - DIST * 0.5f;
 f32 gFar = DIST + DIST * 0.5f;
/*
AGX_TF_Z8ŃRs[悤ɂB
AyeNX`쐬鎞ɁAZobt@̔rAXV\ɂB
AzeNX`p̃}gNX쐬AOǂ߂悤ɂB
---optional---
*/
#endif

#include <string.h>
#include "sysdolphin/baselib/shadow.h"
#include "sysdolphin/baselib/memory.h"
#include "sysdolphin/baselib/mtx.h"
#include "sysdolphin/baselib/displayfunc.h"
#include "sysdolphin/baselib/tev.h"
#include "sysdolphin/baselib/state.h"
#include "sysdolphin/baselib/perf.h"
#include "sysdolphin/baselib/debug.h"
#include "sysdolphin/baselib/mobj.h"

#if DOLPHIN_API_AGE < 1
#define GXSetCurrentMtx(id) GXSetDefaultMtx(id)
#endif

static HSD_ObjAllocData shadow_alloc_data;

static void makeMatrix(HSD_Shadow *shadow);

/** @package internal */

/**
 * HSD_Shadow \̂̃Ǘ擾B
 *
 * @return Ǘւ̃|C^B
 */
HSD_ObjAllocData *
HSD_ShadowGetAllocData(void)
{
  return &shadow_alloc_data;
}

/**
 * Shadow ֌W̃Ǘ̏B
 *
 * @tip {֐HSD_Init֐Ă΂邽߁AʏgpKv͂ȂB
 *
 * @see Global#HSD_Init
 */
void
HSD_ShadowInitAllocData(void)
{
  HSD_ObjAllocInit(&shadow_alloc_data, sizeof(HSD_Shadow), 4);
}


/** @package Shadow */

static HSD_TObj *
allocShadowTObj(void)
{
  HSD_TObj *tobj;

  tobj = HSD_TObjAlloc();
  tobj->src = GX_TG_POS;
  tobj->wrap_s = GX_CLAMP;
  tobj->wrap_t = GX_CLAMP;
  tobj->flag = TEX_COORD_SHADOW |
	       TEX_LIGHTMAP_SHADOW |
	       TEX_COLORMAP_MODULATE |
	       TEX_ALPHAMAP_PASS;
  tobj->imagedesc = HSD_ImageDescAlloc();

  return tobj;
}

static void
removeShadowTObj(HSD_TObj *tobj)
{
  HSD_ImageDescFree(tobj->imagedesc);
  HSD_TObjFree(tobj);
}

/**
 * Shadow Projection p\̂𐶐B
 * 
 * HSD_Shadow \̂́AShadow Texture Projection Ɏgpe
 * ێBshadow𐶐ɂ͖{֐̌Aȉ̏sB
 * 
 * <ol>
 *   <li>shadow->camera̎ˉe^Cvݒ肷(HSD_CObjSetProjectionType).
 * <pre>
 *  light type | camera projection type
 * ------------+--------------------------
 *  DIFFUSE    |  COBJ_PROJECTION_ORTHO
 *  POINT/SPOT |  COBJ_PROJECTION_FRUSTUM
 * </pre>
 *       L̐ݒ͕WIȂ̂ŁAႤ^Cv̎ˉep[^ݒ肷
 *       Ƃ\B
 * 
 *   <li>^Cvɋʂ̃p[^ݒ肷B
 * <pre>
 * HSD_CObjSetNear(...)
 * HSD_CObjSetFar(...)
 * </pre>
 *   <li>Shadow Texture ̃C[WTCYw肷(default: 256x256)B
 *   <li>eIuWFNg(JObj)o^(HSD_ShadowAddObject)B
 *   <li>ANeBuɐݒ肷(HSD_ShadowSetActive)B
 * </ol>
 * 
 * Shadow Texture ͌уIuWFNg̈ʒuEE傫ς邽т
 * Ȃ΂ȂȂB
 * ʏ̓V[̕`ɐ旧Shadow Texture ̃ItXN[_O
 * sB
 * 
 * <ol>
 *   <li>J̎ˉep[^ݒ肷B
 * <pre>
 * HSD_CObjSetEyePosition(), HSD_CObjSetInterest(), HSD_ShadowCopyLightPos(),
 * HSD_CObjSetFrustum(), HSD_CObjSetOrtho(), ...
 * HSD_ViewingRect*()֐QpłB
 * </pre>
 *
 *   <li>HSD_ShadowInit()<br>
 *       eP̏ꍇ́Å֐͂PxĂׂ΂悢B̏ꍇ́Aeshadow
 *       _OOɌĂяoB
 *
 *   <li>_OsB
 * <pre>
 * HSD_StartRender(HSD_RP_OFFSCREEN);
 * HSD_ShadowStartRender();
 * HSD_ShadowEndRender();
 * HSD_EndRender();
 * </pre>
 *  </ol>
 * 
 * shadow ̕KvȂHSD_ShadowRemove()ō\̂폜B
 *
 * @see HSD_ShadowRemove
 * @see HSD_ShadowSetActive
 * @see HSD_ShadowAddObject
 * @see HSD_ShadowCopyLightPos
 * @see HSD_ViewingRectInit
 * @see HSD_ViewingRectAddSphere
 * @see HSD_ViewingRectAddRect
 * @see HSD_ViewingRectCheck
 * @see CObj#HSD_CObjSetProjectionType
 * @see CObj#HSD_CObjSetFrustum
 * @see CObj#HSD_CObjSetOrtho
 * @see CObj#HSD_CObjSetNear
 * @see CObj#HSD_CObjSetFar
 * @see CObj#HSD_CObjSetInterest
 * @see Global#HSD_StartRender
 * @see Global#HSD_EndRender
 */
HSD_Shadow *
HSD_ShadowAlloc(void)
{
  HSD_Shadow *shadow;

  shadow = HSD_ObjAlloc(&shadow_alloc_data);
  dumpObjAlloc(&shadow_alloc_data, "shadow: alloc");
  memset(shadow, 0, sizeof(HSD_Shadow));
  shadow->camera = HSD_CObjAlloc();
  shadow->texture = allocShadowTObj();

  shadow->scaleS = 0.5F;
  shadow->scaleT = -0.5F;
  shadow->transS = 0.5F;
  shadow->transT = 0.5F;
  shadow->intensity = 0;

#ifdef LIB_FIX
#if FUJITA
  shadow->texture->imagedesc->format = GX_TF_I8;
#else
  shadow->texture->imagedesc->format = GX_TF_I8;
#endif
#else
  shadow->texture->imagedesc->format = GX_TF_I4;
#endif
  shadow->texture->imagedesc->width = 256;
  shadow->texture->imagedesc->height = 256;

  HSD_CObjSetViewportfx4(shadow->camera, 0, 256, 0, 256);
  HSD_CObjSetScissorx4  (shadow->camera, 0, 256, 0, 256);

  return shadow;
}

/**
 * HSD_Shadow\̂pB
 *
 * @warning
 * {֐̓oɂčlȂ̂ŁAʏ̍폜ɂHSD_ShadowRemove
 * gp邱ƁB
 *
 * @see HSD_ShadowAlloc
 * @see HSD_ShadowRemove
 */
void
HSD_ShadowFree(HSD_Shadow *shadow)
{
  HSD_ObjFree(&shadow_alloc_data, shadow);
  dumpObjAlloc(&shadow_alloc_data, "shadow: free");
}

/**
 * HSD_Shadow \̂폜B
 * 
 * HSD_Shadow\̂ƍ\̂̃o폜B
 * 
 * @warning
 * {֐HSD_ShadowSetUserData()Őݒ肳郆[Uf[^͍lȂB
 * Kvɉă[Uf[^̃̈Ĵ̓vO}
 * ӔCłB
 *
 * @see HSD_ShadowAlloc
 * @see HSD_ShadowSetUserData
 */
void
HSD_ShadowRemove(HSD_Shadow *shadow)
{
  if (!shadow) return;

  HSD_CObjUnref(shadow->camera);
  HSD_ShadowDeleteObject(shadow, NULL);
  if (shadow->active) {
    HSD_MObjDeleteShadowTexture(shadow->texture);
  }
  if (shadow->texture->imagedesc->image_ptr) {
    HSD_Free(shadow->texture->imagedesc->image_ptr);
  }
  removeShadowTObj(shadow->texture);

  HSD_ShadowFree(shadow);
}

/**
 * Shadow Texture 𐶐邽߂̐ݒsB
 * 
 * {֐Shadow Texture ItXN[Ń_O邽߂
 * VXeݒsBݒԂ͕ێ̂łP Shadow ݂̂
 * ꍇ1xݒ肷΂悢B
 * 
 * Shadow Lȏꍇ́Aꂼshadow HSD_ShadowStartRender()
 * OɌĂяoB
 *
 * @see HSD_ShadowStartRender
 * @see HSD_ShadowAlloc
 */
void
HSD_ShadowInit(HSD_Shadow *shadow)
{
  HSD_ImageDesc *idesc;

  assert(shadow);
  idesc = shadow->texture->imagedesc;
  GXSetTexCopySrc(0, 0, idesc->width, idesc->height);
#if GX_REV >= 2
#ifdef LIB_FIX
#if FUJITA
  //荞݂ZeNX`ɂB
  GXSetTexCopyDst(idesc->width, idesc->height, GX_TF_Z8, GX_FALSE);
#else
  GXSetTexCopyDst(idesc->width, idesc->height, GX_CTF_R8, GX_FALSE);
#endif
#else
  GXSetTexCopyDst(idesc->width, idesc->height, GX_CTF_R4, GX_FALSE);
#endif
#else
#ifdef LIB_FIX
  GXSetTexCopyDst(idesc->width, idesc->height, GX_TF_I8, GX_FALSE);
#else
  GXSetTexCopyDst(idesc->width, idesc->height, GX_TF_I4, GX_FALSE);
#endif
#endif
}

/**
 * Shadow Texture ̃TCYݒ肷B
 * 
 * Shadow Texture ̃TCÝAEFB̃TCYŐB
 * width/heightƂQ̔{łȂ΂ȂȂB
 *
 * @warning
 * {֐̌ĂяoɃeNX`pmۂB
 * 2ڈȍ~̌ĂяoŃTCYقȂꍇAmۂB
 * ʂȃ蓖Ăh߁A{֐̎gp1xɐׂłB
 * 
 * @param width		eNX`̉ [2 , 640] (default: 256)
 * @param height	eNX`̍ [2 , 528] (default: 256)
 *
 * @see HSD_ShadowAlloc
 */
void
HSD_ShadowSetSize(HSD_Shadow *shadow, u16 width, u16 height)
{
  u32 size;
  HSD_ImageDesc *idesc;

  assert(shadow);
  assert(width > 0);
  assert(height > 0);

  idesc = shadow->texture->imagedesc;
  if (!idesc->image_ptr || 
      idesc->width != width ||
      idesc->height != height)
	{
	  if (idesc->image_ptr)
		HSD_Free(idesc->image_ptr);

#ifdef LIB_FIX
#if FUJITA
	  size = GXGetTexBufferSize(width, height, GX_TF_I8, GX_FALSE, 0);
#else
	  size = GXGetTexBufferSize(width, height, GX_TF_I8, GX_FALSE, 0);
#endif
#else
	  size = GXGetTexBufferSize(width, height, GX_TF_I4, GX_FALSE, 0);
#endif
	  assert(size > 0);
	  idesc->image_ptr = HSD_Alloc(size);
	  idesc->width = width;
	  idesc->height = height;

	  HSD_CObjSetViewportfx4(shadow->camera, 0, width, 0, height);
	  HSD_CObjSetScissorx4  (shadow->camera, 0, width, 0, height);
	}
}

static void
drawBackgroundRect(HSD_Shadow *shadow)
{
#pragma unused(shadow)

  GXLoadPosMtxImm(HSD_identityMtx, GX_PNMTX0);
  HSD_PerfCountMtxLoad();
  GXSetCurrentMtx(GX_PNMTX0);
  HSD_ClearVtxDesc();
  GXSetVtxDesc(GX_VA_POS, GX_DIRECT);
  GXSetVtxAttrFmt(GX_VTXFMT0, GX_VA_POS, GX_POS_XY, GX_U8, 0);
  HSD_StateSetCullMode(GX_CULL_BACK);

  GXBegin(GX_QUADS, GX_VTXFMT0, 4);
  GXPosition2u8(0, 1);
  GXPosition2u8(1, 1);
  GXPosition2u8(1, 0);
  GXPosition2u8(0, 0);
  GXEnd();
}

/**
 * Shadow Texture ̃ItXN[_OJnB
 * 
 * `悳̂͗\HSD_ShadowAddObject()ɂēo^ꂽ
 * jobj[gƂjobjc[łB
 * 
 * {֐̎sIAHSD_ShadowEndRender()ɂAEFBShadow Image
 * eNX`ɕϊB
 *
 * @warning
 * HSD_ShadowStartRender()HSD_ShadowEndRender()̊Ԃł́AEFBύX悤
 * ׂ͔łB
 * 
 * {֐Viewport/ScissorύXB
 *
 * @see HSD_ShadowEndRender
 * @see HSD_ShadowAlloc
 */
#if FUJITA
static GXColor gShadowIntensity;
GXColor GetShadowIntensity( void );
GXColor GetShadowIntensity( void )
{
  return gShadowIntensity;
}
#endif

void
HSD_ShadowStartRender(HSD_Shadow *shadow)
{
  HSD_CObj *cobj;
  HSD_ImageDesc *idesc;

  assert(shadow);
  assert(shadow->camera);
  assert(shadow->texture);
  assert(shadow->texture->imagedesc);

  cobj = shadow->camera;
  idesc = shadow->texture->imagedesc;

#if FUJITA
  gShadowIntensity.r =
	gShadowIntensity.g =
	gShadowIntensity.b = 255 - shadow->intensity;
  HSD_CObjSetNear(cobj, gNear);
  HSD_CObjSetFar(cobj, gFar);
#endif
  HSD_CObjSetCurrent(cobj);

  if (shadow->objects) {
    /* Setup rendering mode */
    {
#if 0
      static HSD_Chan chan = {
	NULL,
	GX_COLOR0A0, 0,
	{0, 0, 0, 0},		// amb
	{0, 0, 0, 255},		// mat
	GX_FALSE,
	GX_SRC_REG,
	GX_SRC_REG,
	GX_LIGHT_NULL,
	GX_DF_CLAMP,
	GX_AF_NONE,
	NULL,
      };
      static HSD_TevDesc tev = {
	NULL, TEVCONF_MODE,
	GX_TEVSTAGE0,
	GX_TEXCOORD_NULL,
	GX_TEXMAP_NULL,
	GX_COLOR0A0,
	{
	  GX_TEV_ADD, GX_CC_ZERO, GX_CC_ZERO, GX_CC_ZERO, GX_CC_RASC,
	  GX_CS_SCALE_1, GX_TB_ZERO, GX_TRUE, GX_TEVPREV,
	  GX_TEV_ADD, GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_RASA,
	  GX_CS_SCALE_1, GX_TB_ZERO, GX_TRUE, GX_TEVPREV,
	  GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
	  GX_TEV_SWAP0,
	  GX_TEV_SWAP0,
	  GX_TEV_KCSEL_1,
	  GX_TEV_KASEL_1,
#endif
	}
      };
      static HSD_PEDesc pedesc = {
#if FUJITA
		//Zobt@XV\ɂB
		ENABLE_COMPARE | ENABLE_ZUPDATE | BEFORE_TEX,
#else
		ENABLE_COLOR_UPDATE | BEFORE_TEX,
#endif
		0,		// ref0
		0,		// ref1
		0,		// dist_alpha
		GX_BM_NONE,	// blend mode
		GX_BL_SRCALPHA,
		GX_BL_INVSRCALPHA,
		GX_LO_SET,
#if FUJITA
		GX_LESS,
#else
		GX_ALWAYS,
#endif
		GX_ALWAYS,
		GX_AOP_AND,
		GX_ALWAYS
      };
      Mtx44 pm;

      HSD_StateInitTev();
      HSD_SetupTevStageAll(&tev);

      HSD_StateSetNumTexGens();

      HSD_SetupPEMode(0, &pedesc);

#if !FUJITA
      chan.mat_color.r = 255;
      chan.mat_color.g = 255;
      chan.mat_color.b = 255;

      HSD_SetupChannelAll(&chan);

      MTXOrtho(pm, 1, 0, 0, 1, -1, 1);
      GXSetProjection(pm, GX_ORTHOGRAPHIC);

      GXSetViewport(0, 0, idesc->width, idesc->height, 0, 1);
      GXSetScissor(0, 0, idesc->width, idesc->height);

      drawBackgroundRect(shadow);

#if 0 // shadow texture ɋ`̗֊s`
      chan.mat_color.r = 0;
      chan.mat_color.g = 0;
      chan.mat_color.b = 0;

      HSD_SetupChannelAll(&chan);

      GXSetScissor(2, 2, idesc->width-4, idesc->height-4);

      drawBackgroundRect(shadow);

      chan.mat_color.r = 255;
      chan.mat_color.g = 255;
      chan.mat_color.b = 255;

      HSD_SetupChannelAll(&chan);

      GXSetScissor(4, 4, idesc->width-8, idesc->height-8);

      drawBackgroundRect(shadow);
#endif

      chan.mat_color.r = shadow->intensity;
      chan.mat_color.g = shadow->intensity;
      chan.mat_color.b = shadow->intensity;
#endif
      HSD_SetupChannelAll(&chan);
#else
#endif
      GXSetScissor(2, 2, idesc->width-4, idesc->height-4);
    }

    /* Start rendering */
    {
//      HSD_SList *list;
#if FUJITA
	  f32 max=-MAXFLOAT,min=MAXFLOAT;
#if 0
	  Vec e;
	  HSD_CObjGetEyePosition(shadow->camera, &e);
      for (list=shadow->objects; list; list=list->next) {
		Vec trs;
		f32 t;
		HSD_MTXGetTranslate(((HSD_JObj *)list->data)->mtx, &trs);
		//HSD_DmpVector( "", &trs );
		VECSubtract( &e, &trs, &trs );

		t = VECSquareMag( &trs );
		if( t > max ) max = t;
		if( t < min ) min = t;
	  }
	  
	  min = sqrtf( min ) - 10.0f;
	  max = sqrtf( max ) + 300.0f;
	  if( min <= 0 ) min = 1.0f;
#else
	  //ꌈߑłłłˁH
	  //ƁAdistance=>2000
	  //̓TvƂĂlŊƂȂŁB
	  min = NEAR;
	  max = FAR;
#endif
	  //	  HSD_CObjSetNear(cobj, min);
	  //HSD_CObjSetFar(cobj, max);
#endif	  

		//ۂɕ`̂̓L[̃VXeɔCB030903
#if 0
      /* }eAݒȂ[h(RENDER_SHADOW)Ń_O */
	  for (list=shadow->objects; list; list=list->next){

#ifdef LIB_FIX
#if !FUJITA
		HSD_JObjDispAll(list->data, NULL,
						(HSD_TrspMask)(HSD_TRSP_OPA|HSD_TRSP_XLU|HSD_TRSP_TEXEDGE),
						RENDER_SHADOW);
#else
		HSD_JObjDispAll(list->data, NULL,
		(HSD_TrspMask)(HSD_TRSP_OPA),
		RENDER_SHADOW);
#endif
#else
		HSD_JObjDispAll(list->data, NULL,
						(HSD_TrspMask)(HSD_TRSP_OPA|HSD_TRSP_TEXEDGE),
						RENDER_SHADOW);
#endif
	  }
#endif

	  //#if FUJITA
#if 0
	  //łȋCB
	  for (list=shadow->objects; list; list=list->next) {
		HSD_JObjDispAll(list->data, NULL,
						(HSD_TrspMask)(HSD_TRSP_XLU|HSD_TRSP_TEXEDGE),
						0);
	  }
#endif
	}
#if 0
	//GhJgC_Shadow̎dB
	HSD_CObjEndCurrent();
#endif
  }

}

/**
 * Shadow Texture ̃ItXN[_OIB
 * 
 * EFBɕ`悳ꂽShadow Image eNX`ɕϊB
 * eNX`C[W̃Rs[ɂ́A\ߐݒ肳ꂽClearColorɂ
 * obt@̓NAB
 * 
 * @warning
 * HSD_ShadowStartRender()HSD_ShadowEndRender()̊Ԃł́AEFBύX悤
 * ׂ͔łB
 *
 * @see HSD_ShadowStartRender
 * @see HSD_ShadowAlloc
 */
void
HSD_ShadowEndRender(HSD_Shadow *shadow)
{
  HSD_ImageDesc *idesc;

  assert(shadow);

  idesc = shadow->texture->imagedesc;
  if (!idesc->image_ptr)
    HSD_ShadowSetSize(shadow, idesc->width, idesc->height);

  GXCopyTex(idesc->image_ptr, GX_TRUE);
  GXPixModeSync();

  /* FIXME! XVtexturetbV悤ɂ */
  GXInvalidateTexAll();

  makeMatrix(shadow);
}

/**
 * ̈ʒu񂩂AShadowpJ̈ʒuݒ肷B
 * 
 * DiffusȅꍇAJInterest̗ɋdistance
 * ړ_ɃJEyePositionݒ肷B
 * 
 * Spot/Point̏ꍇAPositionJEyePositionɃRs[B
 * 
 * @tip
 * HSD_CObjSetEyePosition֐gpĂ悢B
 * JInterestHSD_CObjSetInterest֐Őݒ肷B
 * 
 * @see HSD_ShadowAlloc
 * @see CObj#HSD_CObjSetInterest
 * @see CObj#HSD_CObjSetEyePosition
 */
void
HSD_ShadowCopyLightPos(HSD_Shadow *shadow, HSD_LObj *lobj, float distance)
{
  Vec position, interest, lpos;

  assert(shadow);
  assert(lobj);
  
  switch (HSD_LObjGetType(lobj)) {
  case LOBJ_INFINITE:
    HSD_CObjGetInterest(shadow->camera, &interest);
    HSD_LObjGetPosition(lobj, &lpos);
	
#if FUJITA
	//ꌈߑłłłˁH
	//ƁANear=>1000, FAR=>3000
	//̓TvƂĂlŊƂȂŁB
	//distance = DIST;
#if 0
	{
	  f32 *fp = 0;
	  if( HSD_PadGetButton(1) & HSD_PAD_B ) fp = &gDist;
	  if( HSD_PadGetButton(1) & HSD_PAD_A ) fp = &gNear;
	  if( HSD_PadGetButton(1) & HSD_PAD_X ) fp = &gFar;
	  if( fp ){
		if( HSD_PadGetButton(1) & HSD_PAD_RIGHT ) (*fp) -= 1.f;
		if( HSD_PadGetButton(1) & HSD_PAD_LEFT ) (*fp) += 1.f;
		OSReport( "%f, %f, %f\n", gDist, gNear, gFar );
	  }
	}
#endif
	distance = gDist;
#endif
	VECScale(&lpos, &lpos, distance / VECMag(&lpos));
    VECAdd(&interest, &lpos, &position);
    HSD_CObjSetEyePosition(shadow->camera, &position);
    break;

  case LOBJ_SPOT:
  case LOBJ_POINT:
    HSD_LObjGetPosition(lobj, &position);
    HSD_CObjSetEyePosition(shadow->camera, &position);
    break;

  default:
    assert(0);
  }
}

/**
 * Shadow Texture Projection ̗LEݒ肷B
 * 
 * activeTRUȄꍇAShadow Projection LɂȂB
 * ꂽeHSD_MObj\̂̃tORENDER_SHADOWrbg̗Ăꂽ
 * IuWFNgɑ΂ēeB
 * 
 * activeFALSȄꍇAShadow Projection ͖B
 * ƂShadow Texture 𐶐Ăe͍sȂB
 * 
 * @see HSD_ShadowAlloc
 * @see MObj#HSD_MObjAddShadowTexture
 */
void
HSD_ShadowSetActive(HSD_Shadow *shadow, int active)
{
  HSD_ImageDesc *idesc;

  assert(shadow);

  if ((shadow->active && active) || (!shadow->active && !active)) 
    return;

  shadow->active = active;
  if (active) {
    idesc = shadow->texture->imagedesc;
    if (!idesc->image_ptr)
      HSD_ShadowSetSize(shadow, idesc->width, idesc->height);

    HSD_MObjAddShadowTexture(shadow->texture);
  } else {
    HSD_MObjDeleteShadowTexture(shadow->texture);
  }
}

/**
 * eIuWFNgo^B
 * 
 * Shadow TexturẽItXN[_OŃ_OIuWFNg
 * w肷B
 * I[o[wbhŏɂ邽߁Ae̐ɕKvȃIuWFNĝ݂
 * o^B
 * 
 * @param jobj	̃IuWFNgɎ̉e𓊉eIuWFNg
 *
 * @see HSD_ShadowDeleteObject
 */
void
HSD_ShadowAddObject(HSD_Shadow *shadow, HSD_JObj *jobj)
{
  HSD_SList *list;

  if (!shadow || !jobj) return;

  for (list=shadow->objects; list; list=list->next) {
    if (list->data == jobj) {
      return;
    }
  }
  shadow->objects = HSD_SListPrepend(shadow->objects, jobj);
  HSD_JObjRef(jobj);
}

/**
 * o^ĂIuWFNgAw肵IuWFNg폜B
 * 
 * jobjw肳ꂽꍇÃIuWFNgShadow폜B
 * jobj  NULL̏ꍇAׂẴIuWFNg폜B
 *
 * @see HSD_ShadowAddObject
 */
void
HSD_ShadowDeleteObject(HSD_Shadow *shadow, HSD_JObj *jobj)
{
  if (!shadow) return;

  if (jobj) {
    HSD_SList **list = &(shadow->objects);
    for (; *list; list = &((*list)->next)) {
      if ((*list)->data == jobj) {
	HSD_JObjUnref(jobj);
	(*list) = HSD_SListRemove(*list);
	return;
      }
    }
  } else {
    while (shadow->objects) {
      HSD_JObjUnref(shadow->objects->data);
      shadow->objects = HSD_SListRemove(shadow->objects);
    }
  }
}

/*
 * texture projection p}gNX𐶐B
 * ꂽ}gNXtobjɋLAn[hEFÃ[hOŁA
 * ̂Ƃ`撆jobj̃}gNXƊ|킳B
 * 
 * tobjmtx_dirtyrbgƃ}gNX󂳂B
 */
#if FUJITA
MtxPtr SetupRampMtx( HSD_CObj* cobj );
MtxPtr SetupRampMtx( HSD_CObj* cobj )
{
  static Mtx m,t;
  static f32 old_f = -1, old_n = -1;

  if( cobj ){
	f32 n = HSD_CObjGetNear(cobj);
	f32 f = HSD_CObjGetFar(cobj);

	//ωꍇ̂݁B
	//if( old_f != f || old_n != n ){
	if( 1 ){

	  // Precision control
	  //!!!eNX`̃tH[}bgςύX邱ƁB
	  f32 tscale = 16.0F;
	  f32 range = f - n;

	  //OSReport( "end %f %f\n", n,f );
	  old_f = f;
	  old_n = n;
	  // Make a zero matrix
	  MTXScale(t, 0.0F, 0.0F, 0.0F);
        
	  switch (HSD_CObjGetProjectionType(cobj)) {
	  case COBJ_PROJECTION_FRUSTUM:
	  case COBJ_PROJECTION_PERSPECTIVE:
        // Depth lookup matrix
        // in order to generate:
        //     s = (1 + N/z) * F / (F - N)
        //     t = s * tscale due to the texture size
        MTXRowCol(t, 0, 2) = f / range;
        MTXRowCol(t, 0, 3) = f * n / range;
        MTXRowCol(t, 1, 2) = MTXRowCol(t, 0, 2) * tscale;
        MTXRowCol(t, 1, 3) = MTXRowCol(t, 0, 3) * tscale;
        MTXRowCol(t, 2, 2) = 1.0F;
		break;
	  case COBJ_PROJECTION_ORTHO:
        // Depth lookup matrix
        // in order to generate:
        //     s = - (z + N) / (F - N)
        //     t = s * tscale due to the texture size
		MTXRowCol(t, 0, 2) = - 1.0F / range;
        MTXRowCol(t, 0, 3) = - n / range;
        MTXRowCol(t, 1, 2) = MTXRowCol(t, 0, 2) * tscale;
        MTXRowCol(t, 1, 3) = MTXRowCol(t, 0, 3) * tscale;
        MTXRowCol(t, 2, 3) = 1.0F;
		//OSReport( "%f %f\n", n, f );
		break;
	  default:
		break;
	  }
	}
	//HSD_DmpMatrix( "--- depth", t );
	//HSD_DmpMatrix( "--- s view", HSD_CObjGetViewingMtxPtrDirect(cobj) );
	MTXConcat(t, HSD_CObjGetViewingMtxPtrDirect(cobj), m);
  }
  return m;
}
#endif

static void
makeMatrix(HSD_Shadow *shadow)
{
  Mtx Mprj;

  if (HSD_CObjGetEyeDistance(shadow->camera) < FLT_EPSILON) {
    // ͂Ɋ֌WȂAST = (0,0)Ƀ}bvB
    static Mtx m = {
      0, 0, 0, 0,
      0, 0, 0, 0,
      0, 0, 0, 1
    };
    MTXCopy(m, shadow->texture->mtx);
    return;
  }

  switch (HSD_CObjGetProjectionType(shadow->camera)) {
  case COBJ_PROJECTION_PERSPECTIVE:
    MTXLightPerspective(Mprj,
			shadow->camera->projection_param.perspective.fov,
			shadow->camera->projection_param.perspective.aspect,
			shadow->scaleS, shadow->scaleT,
			shadow->transS, shadow->transT);
    break;

  case COBJ_PROJECTION_FRUSTUM:
    MTXLightFrustum    (Mprj,
			shadow->camera->projection_param.frustum.top,
			shadow->camera->projection_param.frustum.bottom,
			shadow->camera->projection_param.frustum.left,
			shadow->camera->projection_param.frustum.right,
			shadow->camera->nnear,
			shadow->scaleS, shadow->scaleT,
			shadow->transS, shadow->transT);
    break;

  case COBJ_PROJECTION_ORTHO:
    MTXLightOrtho      (Mprj,
			shadow->camera->projection_param.ortho.top,
			shadow->camera->projection_param.ortho.bottom,
			shadow->camera->projection_param.ortho.left,
			shadow->camera->projection_param.ortho.right,
			shadow->scaleS, shadow->scaleT,
			shadow->transS, shadow->transT);
    break;

  default:
    assert(0);
  }

  MTXConcat(Mprj, HSD_CObjGetViewingMtxPtrDirect(shadow->camera),
			shadow->texture->mtx);
#if FUJITA
  SetupRampMtx( shadow->camera );
#endif
}

/**
 * Shadow Texture View Volumeݒ肷B
 *
 * Viewing Rect (top, bottom, left, right) ̓J̒_ł
 * `ƂB
 * 
 * @see HSD_ShadowAlloc
 */
void
HSD_ShadowSetViewingRect(HSD_Shadow *shadow,
			 float top, float bottom,
			 float left, float right)
{
  HSD_CObj *cobj;
  float distance;

  assert(shadow);

  cobj = shadow->camera;
  distance = HSD_CObjGetEyeDistance(cobj);
  if (distance < FLT_EPSILON) {
    return;
  }

  switch (HSD_CObjGetProjectionType(cobj)) {
  case COBJ_PROJECTION_PERSPECTIVE:
    {
      float width, height;

      if (fabs(top) > fabs(bottom)) {
	height = fabs(top);
      } else {
	height = fabs(bottom);
      }
      if (fabs(left) > fabs(right)) {
	width = fabs(left);
      } else {
	width = fabs(right);
      }
      HSD_CObjSetAspect(cobj, width / (height + FLT_EPSILON));
      HSD_CObjSetFov(cobj, MTXRadToDeg(atan2f(height, distance)));
    }
    break;

  case COBJ_PROJECTION_ORTHO:
    HSD_CObjSetOrtho(cobj, top, bottom, left, right);
    break;
    
  case COBJ_PROJECTION_FRUSTUM:
    {
      float scale = HSD_CObjGetNear(cobj) / distance;
      if (scale < FLT_EPSILON) {
	scale = FLT_EPSILON;
      }
      HSD_CObjSetFrustum(cobj,
      			 scale * top, scale * bottom,
			 scale * left, scale * right);
    }
    break;

  default:
    assert(0);
  }
}

/**
 * HSD_ViewingRect\̂B
 * 
 * {\̂Shadow Projection peNX`̐ɎgpœK
 * View Volume ߂邽߂ɎgpB
 * 
 * {֐ɂ\̂̂AHSD_ViewingRectAdd{Sphere,Rect}֐
 * JԂĂяoAw肵̈܂ލŏView Volume߂鎖oB
 *
 * @tip
 * Viewing Rect̊g傪AHSD_ViewingRectCheck()ɂAViewing Rect
 * ̃p[^Kł邩`FbNB
 * 
 * @param position	Jʒu
 * @param interest	_
 * @param upvector	J̏\xNgiK̕Kv)
 * @param perspective	ˉeˉe(Perspective/Frustum)ȂTRUE.
 * 
 * @see HSD_ViewingRectAddSphere
 * @see HSD_ViewingRectAddRect
 * @see HSD_ViewingRectCheck
 */
void
HSD_ViewingRectInit(HSD_ViewingRect *rect,
		    VecPtr position, VecPtr interest, VecPtr upvector,
		    int perspective)
{
  assert(rect);

  rect->invalid = 0;
  rect->origin = *position;
  VECSubtract(interest, position, &rect->eye_v);
  if (vec_normalize_check(&rect->eye_v, &rect->eye_vn) < 0) {
    rect->invalid = 1;
    return;
  }
  VECCrossProduct(&rect->eye_vn, upvector, &rect->right_v);
  if (vec_normalize_check(&rect->right_v, &rect->right_v) < 0) {
    HSD_VecGetOrthogonal(&rect->eye_vn, &rect->right_v);
    VECNormalize(&rect->right_v, &rect->right_v);
  }
  VECCrossProduct(&rect->right_v, &rect->eye_vn, &rect->up_v);
  rect->distance = VECMag(&rect->eye_v);

  rect->top = rect->right = -MAXFLOAT;
  rect->bottom = rect->left = MAXFLOAT;
  rect->perspective = perspective? 1 : 0;
}

/**
 * ꂽViewing RectangleKB
 *
 * @return	Kł΂PAłȂ΂OԂB
 */
int
HSD_ViewingRectCheck(HSD_ViewingRect *rect)
{
  assert(rect);
  return !(rect->invalid) &&
  	 rect->top > rect->bottom && rect->right > rect->left;
}

/**
 * w肵Bounding Rect܂悤Viewing Rectangleg傷B
 * 
 * top, bottom, left, right͂ꂼpositionʒułBounding Rect̑傫
 * 킷B
 * 
 * top = bottom, left = rightw肵ꍇA_\łB
 * 
 * Bounding Rect Viewing Rect position Bounding Rect position ւ
 * xNgɒʏɏɂƂB
 * eʂ̏/HSD_ViewingRectInit()ɂposition, interest,
 * upvector茈肳B
 *
 * @warning
 * {֐̎gpɐ旧āAHSD_ViewingRectInit()ɂ菉ĂB
 *
 * @tip
 * HSD_ViewingRectAddSphere()ɎgpłB
 * 
 * Viewing Rect̊g傪AHSD_ViewingRectCheck()ɂAViewing Rect
 * ̃p[^Kł邩`FbNB
 * 
 * @see HSD_ViewingRectInit
 * @see HSD_ViewingRectCheck
 * @see HSD_ViewingRectAddSphere
 */
void
HSD_ViewingRectAddRect(HSD_ViewingRect *rect, VecPtr position,
		       float top, float bottom, float left, float right)
{
  float x, y, dot, scale;
  Vec o2p, e2p;

  assert(rect);
  assert(position);

  if (rect->invalid) {
    return;
  }

  VECSubtract(position, &rect->origin, &o2p);
  dot = VECDotProduct(&o2p, &rect->eye_vn);
  if (rect->perspective) {
    if (dot <= 0.0F) return;
    scale = rect->distance / dot;
    VECScale(&o2p, &o2p, scale);
    VECSubtract(&o2p, &rect->eye_v, &e2p);
    x = VECDotProduct(&rect->right_v, &e2p);
    y = VECDotProduct(&rect->up_v, &e2p);

    /* {Rect̊e_scalel͈قȂ */
    top *= scale;
    bottom *= scale;
    left *= scale;
    right *= scale;
  } else {
    Vec tmp;
    VECScale(&rect->eye_vn, &tmp, dot);
    VECSubtract(&o2p, &tmp, &e2p);
    x = VECDotProduct(&rect->right_v, &e2p);
    y = VECDotProduct(&rect->up_v, &e2p);
  }

  if (x + right > rect->right) {
    rect->right = x + right;
  }
  if (x + left < rect->left) {
    rect->left = x + left;
  }
  if (y + top > rect->top) {
    rect->top = y + top;
  }
  if (y + bottom < rect->bottom) {
    rect->bottom = y + bottom;
  }
}

/**
 * w肵Bounding Sphere܂悤Viewing Rectangleg傷B
 * 
 * radius = 0 ̏ꍇA_\B
 * 
 * @param position	Bounding Sphere ̒S_
 * @param radius	Bounding Sphere ̔a
 * 
 * @warning
 * {֐̎gpɐ旧āAHSD_ViewingRectInit()ɂ菉ĂB
 *
 * @tip
 * HSD_ViewingRectAddRect()ɎgpłB
 * 
 * Viewing Rect̊g傪AHSD_ViewingRectCheck()ɂAViewing Rect
 * ̃p[^Kł邩`FbNB
 *
 * @see HSD_ViewingRectInit
 * @see HSD_ViewingRectCheck
 * @see HSD_ViewingRectAddRect
 */
void
HSD_ViewingRectAddSphere(HSD_ViewingRect *rect, VecPtr position, float radius)
{
  float x, y, dot, scale, a, b, c, r2, d2, ep2;
  Vec o2p, e2p;

  assert(rect);
  assert(position);

  if (rect->invalid) {
    return;
  }

  VECSubtract(position, &rect->origin, &o2p);
  dot = VECDotProduct(&o2p, &rect->eye_vn);
  if (rect->perspective) {
    if (dot <= 0.0F) return;
    scale = rect->distance / dot;
    radius *= scale;
    if (rect->distance <= radius) {
      /* sphere is too close to eye position */
      return;
    }

    VECScale(&o2p, &o2p, scale);
    VECSubtract(&o2p, &rect->eye_v, &e2p);
    x = VECDotProduct(&rect->right_v, &e2p);
    y = VECDotProduct(&rect->up_v, &e2p);

    if (radius > 0.0F) {
      r2 = radius * radius;
      d2 = rect->distance * rect->distance;
      ep2 = VECDotProduct(&e2p, &e2p);
      a = d2 - r2;					// always positive
      b = r2 * sqrtf(ep2);
      c = (d2 + ep2) * r2;
      assert(a > 0.0F);

      radius = (b + sqrtf(b * b + a * c)) / a;
    }
  } else {
    Vec tmp;
    VECScale(&rect->eye_vn, &tmp, dot);
    VECSubtract(&o2p, &tmp, &e2p);
    x = VECDotProduct(&rect->right_v, &e2p);
    y = VECDotProduct(&rect->up_v, &e2p);
  }

  if (x + radius > rect->right) {
    rect->right = x + radius;
  }
  if (x - radius < rect->left) {
    rect->left = x - radius;
  }
  if (y + radius > rect->top) {
    rect->top = y + radius;
  }
  if (y - radius < rect->bottom) {
    rect->bottom = y - radius;
  }
}
