/*
 * Copyright 1999-2001 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: tobj.c,v 1.12 2004/07/27 02:14:30 TypeR Exp $
 */

#define TEST 0
#ifdef FUJITA
#include <controller.h>
#pragma cplusplus			off
#pragma cpp_extensions		off
#pragma warn_implicitconv	off
#endif

#if FUJITA
/*
  HSD_MObjSetup(){
    HSD_TObjSetup(){
      HSD_TObjAssignResources();
      TObjSetupMtx();
    }
    HSD_TObjSetupTextureCoordGen();

    MObjSetupTev(){
      HSD_TObjSetupVolatileTev(){
	    TObjSetupTevModulateShadow();
	  }
    }	
  }

  1.HSD_TObjAssignResources(HSD_TObj *tobj_top)
  if(tobj_coord(tobj) == TEX_COORD_SHADOW)
  ̎ɁA\[X蓖ĂύXB	  
  eNX`̊蓖(shadow,ramp)
  eNX`W̊蓖(shadow,ramp)
  Tev̊蓖(shadow,ramp,compare)
  (eNX`́AۂɃ[hB)

  2.HSD_TObjSetupTextureCoordGen(HSD_TObj *tobj)
  Ŋ蓖ĂꂽCoordGenݒB

  3.TObjSetupMtx(HSD_TObj *tobj)
  CoordGenŎgp}gbNX[h

  3.TObjSetupTevModulateShadow(HSD_TObj *shadow)
  Tev̐ݒBiRij


*/
#endif




#include <string.h>
#include "tobj.h"
#include "sysdolphin/baselib/anim.h"
#include "sysdolphin/baselib/aobj.h"
#include "sysdolphin/baselib/cobj.h"
#include "sysdolphin/baselib/debug.h"
#include "sysdolphin/baselib/lobj.h"
#include "sysdolphin/baselib/tev.h"
#include "mobj.h"
#include "sysdolphin/baselib/jobj.h"
#include "sysdolphin/baselib/mtx.h"
#include "sysdolphin/baselib/state.h"
#include "sysdolphin/baselib/memory.h"
#include "sysdolphin/baselib/texp.h"
#include "sysdolphin/baselib/initialize.h"
#include "private.h"

static void TObjInfoInit(void);

HSD_TObjInfo hsdTObj = { TObjInfoInit };

static HSD_TObjInfo *default_class = NULL;

#define GX_MAX_TEXMTX 10
static HSD_TObj *tobj_head;

/** @package TObj */

#if FUJITA
//̂shadow.cɂB
extern MtxPtr SetupRampMtx( HSD_CObj* cobj );
extern GXColor GetShadowIntensity( void );

//zeNX`̍쐬B
static HSD_TObj* RampTex = NULL;
HSD_TObj* GetRampTex( void );
HSD_TObj* GetRampTex( void ){ return RampTex; }
static HSD_TObj* CreateRampTex8  ( void );
static HSD_TObj* CreateRampTex8( void )
{
  u8*   data;
  u32   size, i, offset;
    
  HSD_TObj *tobj;

  tobj = HSD_TObjAlloc();
  tobj->src = GX_TG_POS;
  tobj->wrap_s = GX_CLAMP;
  tobj->wrap_t = GX_REPEAT;
  tobj->imagedesc = HSD_ImageDescAlloc();
  tobj->imagedesc->format = GX_TF_I8;
  tobj->imagedesc->width = 16;
  tobj->imagedesc->height = 16;
  tobj->imagedesc->mipmap = GX_FALSE;
  size = GXGetTexBufferSize(16, 16, GX_TF_I8, GX_FALSE, 0);
  tobj->imagedesc->image_ptr = data = HSD_Alloc(size);

  // Write ramp data pattern
  for ( i = 0 ; i < 0x100 ; ++i ){
	// I8 format tile offset
	offset = ((i & 0x80) >> 2)
	  + ((i & 0x70) >> 4)
	  + ((i & 0x0C) << 4)
	  + ((i & 0x03) << 3);
	*(data+offset) = (u8)i;
  }
  DCFlushRange(data, size);

  return tobj;
}
#endif

/**
 * 1 tobj Ƃ̉̍\̂ɑ΂flags Ŏw肳ꂽAj[V폜B
 * 
 * @see HSD_TObjRemoveAnim
 * @see HSD_TObjRemoveAnimAllByFlags
 */
void
HSD_TObjRemoveAnimByFlags(HSD_TObj *tobj, u32 flags)
{
  if (tobj == NULL)
    return;

  if (flags & TOBJ_ANIM) {
    HSD_AObjRemove(tobj->aobj);
    tobj->aobj = NULL;
  }
}

/**
 * AꂽׂĂ tobj Ƃ̉̊Kwɑ΂ 
 * flags Ŏw肳ꂽAj[V폜B
 * 
 * @see hSD_TObjRemoveAnimAll
 * @see HSD_TObjRemoveAnimByFlags
 */
void
HSD_TObjRemoveAnimAllByFlags(HSD_TObj *tobj, u32 flags)
{
  HSD_TObj *tp;

  if(tobj == NULL)
    return;

  for (tp = tobj; tp; tp = tp->next) {
    HSD_TObjRemoveAnimByFlags(tp, flags);
  }
}

/**
 * 1 tobj Ƃ̉̍\̂ɑ΂SẴAj[V폜B
 * 
 * @see HSD_TObjRemoveAnimAll
 * @see HSD_TObjRemoveAnimByFlags
 */
void
HSD_TObjRemoveAnim(HSD_TObj *tobj)
{
  HSD_TObjRemoveAnimByFlags(tobj, ALL_ANIM);
}

/**
 * AꂽׂĂ tobj Ƃ̉̊Kw̑SẴAj[V폜B
 * 
 * @see HSD_TObjRemoveAnim
 * @see HSD_TObjRemoveAnimAllByFlags
 */
void
HSD_TObjRemoveAnimAll(HSD_TObj *tobj)
{
  HSD_TObjRemoveAnimAllByFlags(tobj, ALL_ANIM);
}

static HSD_TexAnim *
lookupTextureAnim(int id, HSD_TexAnim *texanim)
{
  HSD_TexAnim *ta;

  for (ta = texanim; ta; ta = ta->next) {
    if (ta->id == id) return ta;
  }
  return NULL;
}

/**
 * 1 tobj Ƃ̉̍\̂ɑ΂Aj[Vo^B
 * 
 *  texanim 擪ƂAj[Vf[^̃Xĝ
 * eNX`ID ̈vf[^̃Aj[Vtobjɓo^B
 * 
 * @see HSD_TObjAddAnimAll
 */
void
HSD_TObjAddAnim(HSD_TObj *tobj, HSD_TexAnim *texanim)
{
  HSD_TexAnim *ta;

  if (tobj == NULL)
    return ;

  if ((ta = lookupTextureAnim(tobj->anim_id, texanim)) != NULL) {
    int i;
#if 0
    HSD_Report("ta->nb_tluttbl (%d)\n", ta->nb_tluttbl);
#endif
    if (tobj->aobj) {
      HSD_AObjRemove(tobj->aobj);
    }
    tobj->aobj = HSD_AObjLoadDesc(ta->aobjdesc);
    tobj->imagetbl = ta->imagetbl;

    if (tobj->tluttbl) {
      for (i=0; tobj->tluttbl[i]; i++) {
	HSD_TlutRemove(tobj->tluttbl[i]);
      }
      HSD_Free(tobj->tluttbl);
    }

    if (ta->nb_tluttbl) {
      tobj->tluttbl = HSD_Alloc((int) sizeof(HSD_Tlut*) * (ta->nb_tluttbl + 1));
      for (i = 0; i < ta->nb_tluttbl; i++) {
	tobj->tluttbl[i] = HSD_TlutLoadDesc(ta->tluttbl[i]);
      }
      tobj->tluttbl[i] = NULL;
    } else {
      tobj->tluttbl = NULL;
    }
    tobj->tlut_no = (u8) -1;
  }
}

/**
 * AꂽׂĂ tobj Ƃȉ̊Kwɑ΂ăAj[Vo^B
 * 
 * @warning
 * eNX`̃Aj[Vf[^͑̃Aj[Vf[^Ƃ
 * N\قȂAAj[V̕Kvtobjpɂ̂݃f[^
 * ݂Btobjtexanim̑Ή̓eNX`IDv邩ۂ
 * 肷B
 * 
 * Aj[Vf[^tobjƓԂŘAĂȂ΂ȂȂB
 * 
 * @see HSD_TObjAddAnim
 */
void
HSD_TObjAddAnimAll(HSD_TObj *tobj, HSD_TexAnim *texanim)
{
  HSD_TObj *tp;

  if (tobj == NULL)
    return;

  for (tp = tobj; tp; tp = tp->next) {
    HSD_TObjAddAnim(tp, texanim);
  }
}

/**
 *  1 tobj Ƃ̉̍\̂ɑ΂flags Ŏw肳ꂽAj[
 *  V̊JnwB
 * 
 * @see HSD_TObjReqAnimAll
 * @see HSD_TObjReqAnimByFlags
 */
void
HSD_TObjReqAnimByFlags(HSD_TObj *tobj, float startframe, u32 flags)
{
#ifdef XDEBUG
  HSD_Report("HSD_TObjReqAnimByFlags in\n");
#endif
  if (tobj == NULL)
    return;

#ifdef XDEBUG
  HSD_Report("tobj id (%d)\n", tobj->id);
#endif

  if (flags & TOBJ_ANIM) {
    HSD_AObjReqAnim(tobj->aobj, startframe);
  }
}

/**
 * AꂽׂĂ tobj Ƃȉ̊Kwɑ΂
 * flags Ŏw肳ꂽAj[V̊JnwB
 * 
 * @see HSD_TObjReqAnimAll
 * @see HSD_TObjReqAnimByFlags
 */
void
HSD_TObjReqAnimAllByFlags(HSD_TObj *tobj, float startframe, u32 flags)
{
  HSD_TObj *tp;

#ifdef XDEBUG
  HSD_Report("HSD_TObjReqAnimAllByFlags in\n");
#endif
  if (tobj == NULL)
    return;

  for (tp = tobj; tp; tp = tp->next) {
    HSD_TObjReqAnimByFlags(tp, startframe, flags);
  }
}

/**
 * 1 tobj Ƃ̉̍\̂ɑ΂ăAj[V̊JnwB
 * 
 * @see HSD_TObjReqAnimAll
 * @see HSD_TObjReqAnimByFlags
 */
void
HSD_TObjReqAnim(HSD_TObj *tobj, float startframe)
{
#ifdef XDEBUG
  HSD_Report("HSD_TObjReqAnim in tobj id (%d)\n", tobj != NULL ? tobj->id : -1);
#endif
  HSD_TObjReqAnimByFlags(tobj, startframe, TOBJ_ANIM);
}

/**
 * AꂽׂĂ tobj Ƃ̉̊Kwɑ΂ăAj[V̊JnwB
 * 
 * @see HSD_TObjReqAnim
 * @see HSD_TObjReqAnimAllByFlags
 */
void
HSD_TObjReqAnimAll(HSD_TObj *tobj, float startframe)
{
#ifdef XDEBUG
  HSD_Report("HSD_TObjReqAnimAll in\n");
#endif
  HSD_TObjReqAnimAllByFlags(tobj, startframe, TOBJ_ANIM);
}

/*
 * TObj ̃Aj[ṼAbvf[g֐
 */	
static void
TObjUpdateFunc(void *obj, u32 type, FObjData *val)
{
  HSD_TObj *tobj = obj;

#ifdef XDEBUG
  HSD_Report("TObjUpdateFunc tobj (%x) ID (%d)\n",
	     tobj, tobj != NULL ? tobj->id : -1);
#endif
  if (tobj == NULL)
    return;

  switch (type) {
  case HSD_A_T_TIMG:
    {
      int n;
      assert(tobj->imagetbl);
#ifdef XDEBUG
      HSD_Report("TIMG val (%f)\n", val->fv);
#endif
      n = (int)val->fv;
      if (tobj->imagetbl[n]) {
	tobj->imagedesc = tobj->imagetbl[n];
      }
#ifdef XDEBUG
      HSD_Report("image_ptr (%x) fmt (%x) w/h (%d, %d) mipmap (%d)\n",
		 tobj->imagedesc->image_ptr,
		 tobj->imagedesc->format,
		 tobj->imagedesc->width, tobj->imagedesc->height,
		 tobj->imagedesc->mipmap);
#endif
    }
    break;
  case HSD_A_T_TCLT:
    {
      if (tobj->tluttbl) {
	tobj->tlut_no = (u8) val->fv;
      }
    }
    break;
  case HSD_A_T_BLEND:
    tobj->blending = HSD_ClampFloat(val->fv, 0, 1);
    break;
  case HSD_A_T_ROTX:
    tobj->rotate.x = val->fv;
    goto mtxdirty;
  case HSD_A_T_ROTY:
    tobj->rotate.y = val->fv;
    goto mtxdirty;
  case HSD_A_T_ROTZ:
    tobj->rotate.z = val->fv;
    goto mtxdirty;
  case HSD_A_T_TRAU:
    tobj->translate.x = val->fv;
    goto mtxdirty;
  case HSD_A_T_TRAV:
    tobj->translate.y = val->fv;
    goto mtxdirty;
  case HSD_A_T_SCAU:
    tobj->scale.x = val->fv;
    goto mtxdirty;
  case HSD_A_T_SCAV:
    tobj->scale.y = val->fv;
  mtxdirty:
    tobj->flag |= TEX_MTX_DIRTY;
    break;
  case HSD_A_T_LOD_BIAS:
    if (tobj->lod) {
      tobj->lod->LODBias = val->fv;
    }
    break;
  case HSD_A_T_KONST_R:
    if (tobj->tev) {
      tobj->tev->konst.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_KONST_G:
    if (tobj->tev) {
      tobj->tev->konst.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_KONST_B:
    if (tobj->tev) {
      tobj->tev->konst.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_KONST_A:
    if (tobj->tev) {
      tobj->tev->konst.a = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV0_R:
    if (tobj->tev) {
      tobj->tev->tev0.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV0_G:
    if (tobj->tev) {
      tobj->tev->tev0.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV0_B:
    if (tobj->tev) {
      tobj->tev->tev0.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV0_A:
    if (tobj->tev) {
      tobj->tev->tev0.a = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV1_R:
    if (tobj->tev) {
      tobj->tev->tev1.r = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV1_G:
    if (tobj->tev) {
      tobj->tev->tev1.g = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV1_B:
    if (tobj->tev) {
      tobj->tev->tev1.b = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TEV1_A:
    if (tobj->tev) {
      tobj->tev->tev1.a = (u8)(255.0F * HSD_ClampFloat(val->fv, 0, 1));
    }
    break;
  case HSD_A_T_TS_BLEND:
    tobj->blending = HSD_ClampFloat(val->fv, 0, 1);
    break;
  }
#ifdef XDEBUG
  HSD_Report("TObjUpdateFunc out\n");
#endif
}

/**
 * 1 tobj Ƃ̉̍\̂ɑ΂ăAj[Vߎs
 * 
 * @see HSD_TObjAnimAll
 */ 
void
HSD_TObjAnim(HSD_TObj *tobj)
{
  if (tobj == NULL)
    return;

#if HSD_ANIM_METHOD_LEVEL <= 1
  HSD_AObjInterpretAnim(tobj->aobj, tobj, HSD_TOBJ_METHOD(tobj)->update);
#else
  HSD_AObjInterpretAnim(tobj->aobj, tobj, TObjUpdateFunc);
#endif
}

/**
 * AꂽׂĂ tobj Ƃȉ̊Kwɑ΂ăAj[Vߎs
 * 
 * @see HSD_TObjAnim
 */ 
void
HSD_TObjAnimAll(HSD_TObj *tobj)
{
  HSD_TObj *tp;

  if (tobj == NULL)
    return;

  for (tp = tobj; tp; tp = tp->next) {
    HSD_TObjAnim(tp);
  }
}

static int
TObjLoad(HSD_TObj *tobj, HSD_TObjDesc *td)
{
  tobj->next = HSD_TObjLoadDesc(td->next);
  tobj->anim_id = (u16) td->id;
  tobj->src = td->src;
  tobj->mtxid = GX_IDENTITY;
  tobj->rotate.x = td->rotate.x;
  tobj->rotate.y = td->rotate.y;
  tobj->rotate.z = td->rotate.z;
  tobj->scale = td->scale;
  tobj->translate = td->translate;
  tobj->wrap_s = td->wrap_s;
  tobj->wrap_t = td->wrap_t;
  tobj->repeat_s = td->repeat_s;
  tobj->repeat_t = td->repeat_t;
  tobj->flag = td->flag;
  tobj->blending = td->blending;
  tobj->magFilt = td->magFilt;
  tobj->imagedesc = td->imagedesc;
  tobj->tlut = HSD_TlutLoadDesc(td->tlutdesc);
  tobj->lod = td->lod;
  tobj->aobj = NULL;
  tobj->flag |= TEX_MTX_DIRTY;
  tobj->tlut_no = (u8) -1;
  tobj->tev = HSD_TObjTevLoadDesc(td->tev);

  /*
   * eNX`LbV̖KvłƐ錾B
   */
  _HSD_NeedCacheInvalidate(HSD_CACHE_TEX);

  return 0;
}

/**
 * TObjDesc [h
 * 
 * @see HSD_TObjAlloc
 * @see HSD_TObjRemoveAll
 * @see HSD_TObjSetDefaultClass
 */
HSD_TObj *
HSD_TObjLoadDesc(HSD_TObjDesc *td)
{
  if (td != NULL) {
    HSD_TObj *tobj;
    HSD_ClassInfo *info;
    
    if (!td->class_name ||
        !(info = hsdSearchClassInfo(td->class_name)))
    {
      tobj = HSD_TObjAlloc();
    } else {
      tobj = hsdNew(info);
      assert(tobj);
    }
    HSD_TOBJ_METHOD(tobj)->load(tobj, td);
    return tobj;
  } else {
    return NULL;
  }
}

/**
 * TlutDesc [h
 * 
 * @see HSD_TlutRemove
 * @see HSD_TlutAlloc
 */
HSD_Tlut *
HSD_TlutLoadDesc(HSD_TlutDesc *tlutdesc)
{
#if !FUJITA
  if (tlutdesc != NULL)  {
    HSD_Tlut *new = HSD_TlutAlloc();
    memcpy(new, tlutdesc, sizeof(HSD_Tlut));
    return new;
  }
#else
  if (tlutdesc != NULL)  {
    HSD_Tlut *n = HSD_TlutAlloc();
    memcpy(n, tlutdesc, sizeof(HSD_Tlut));
    return n;
  }
#endif
  return NULL;
}

/**
 * tobj̃JX^Tevݒ[h
 * 
 * @see HSD_TObjTevAlloc
 * @see HSD_TObjTevRemove
 */
HSD_TObjTev *
HSD_TObjTevLoadDesc(HSD_TObjTevDesc *tevdesc)
{
#if !FUJITA
  if (tevdesc != NULL)  {
    HSD_TObjTev *new = HSD_TObjTevAlloc();
    memcpy(new, tevdesc, sizeof(HSD_TObjTev));
    return new;
  }
#else
  if (tevdesc != NULL)  {
    HSD_TObjTev *n = HSD_TObjTevAlloc();
    memcpy(n, tevdesc, sizeof(HSD_TObjTev));
    return n;
  }
#endif
  return NULL;
}

/*
 * (J֐)
 */
HSD_TObj *
_HSD_TObjGetCurrentByType(HSD_TObj *from, u32 mapping)
{
  HSD_TObj *tp;

  if (from == NULL) {
    tp = tobj_head;
  } else {
    tp = from->next;
  }

  for (; tp; tp=tp->next) {
    if (tobj_coord(tp) == mapping)
      return tp;
  }

  return NULL;
}

/*
 * (J֐)
 * ݗLĂTObĵPCfbNXw肵Ď擾B
 */
HSD_TObj*
HSD_TObjGetActiveByIndex(int idx)
{
  HSD_TObj *tobj;

  for (tobj = tobj_head; tobj; tobj=tobj->next) {
    if (tobj->id != GX_TEXMAP_NULL) {
      if (idx == 0) {
	return tobj;
      } else {
	idx --;
      }
    }
  }
  return NULL;
}

static u32
HSD_TexMapID2PTTexMtx(GXTexMapID id)
{
  switch (id) {
  case GX_TEXMAP0:
    return GX_PTTEXMTX0;
  case GX_TEXMAP1:
    return GX_PTTEXMTX1;
  case GX_TEXMAP2:
    return GX_PTTEXMTX2;
  case GX_TEXMAP3:
    return GX_PTTEXMTX3;
  case GX_TEXMAP4:
    return GX_PTTEXMTX4;
  case GX_TEXMAP5:
    return GX_PTTEXMTX5;
  case GX_TEXMAP6:
    return GX_PTTEXMTX6;
  case GX_TEXMAP7:
    return GX_PTTEXMTX7;
  default:
    HSD_Halt("unexpected texmap id.\n");
  }
  return 0;
}

static int current_TexCoordID_index;

#define initCurrentTexCoordID()	(current_TexCoordID_index = 0)
#define getCurrentTexCoord() 	HSD_Index2TexCoord(current_TexCoordID_index++)

static void
MakeTextureMtx(HSD_TObj *tobj)
{
  Vec scale;
  
  assert(tobj->repeat_s && tobj->repeat_t);
#if 1					/* UNUSED_TEXMTXINVERSE */
  {
    Mtx m;
    Vec trans;
    Quaternion rot;

    scale.x = fabsf(tobj->scale.x) < EPSILON
      ? 0.0F : (float)tobj->repeat_s/tobj->scale.x;
    scale.y = fabsf(tobj->scale.y) < EPSILON
      ? 0.0F : (float)tobj->repeat_t/tobj->scale.y;
    scale.z = tobj->scale.z;
    rot.x = tobj->rotate.x;
    rot.y = tobj->rotate.y;
    rot.z = -tobj->rotate.z;
    trans.x = -tobj->translate.x;
    trans.y = -(tobj->translate.y
		+ (tobj->wrap_t == GX_MIRROR
		   ? 1.0F / (tobj->repeat_t / tobj->scale.y)
		   : 0.0F));
    trans.z = tobj->translate.z;
    
    MTXTrans(tobj->mtx, trans.x, trans.y, trans.z);
    HSD_MkRotationMtx(m, &rot);
    MTXConcat(m, tobj->mtx, tobj->mtx);
    MTXScale(m, scale.x, scale.y, scale.z);
    MTXConcat(m, tobj->mtx, tobj->mtx);
  }
#else
  scale.x = tobj->scale.x/(float)tobj->repeat_s;
  scale.y = tobj->scale.y/(float)tobj->repeat_t;
  scale.z = tobj->scale.z;
  HSD_MtxSRT(tobj->mtx, &scale, &tobj->rotate, &tobj->translate, NULL);
  MTXInverse(tobj->mtx, tobj->mtx);
#endif
}

static void
TObjSetupMtx(HSD_TObj *tobj)
{
  if (tobj_coord(tobj) == TEX_COORD_TOON)
    return ;

  if (tobj->flag & TEX_MTX_DIRTY) {
#if HSD_DISP_METHOD_LEVEL > 1
    MakeTextureMtx(tobj);
#else
    HSD_TOBJ_METHOD(tobj)->make_mtx(tobj);
#endif
    tobj->flag &= ~TEX_MTX_DIRTY;
  }
  switch (tobj_coord(tobj)) {
  case TEX_COORD_REFLECTION:
    {
      /*
       * mtx = tobj->mtx * | 1/2  0   0  1/2 |
       *		   | 0   -1/2 0  1/2 |
       *		   | 0    0   0  1   |
       *		   | 0    0   0  1   |
       */

      Mtx mtx;
      int i;

      for (i=0; i<3; i++) {
	mtx[i][0] =  0.5F * tobj->mtx[i][0];
	mtx[i][1] = -0.5F * tobj->mtx[i][1];
	mtx[i][2] =  0.0F;
	mtx[i][3] =  0.5F * tobj->mtx[i][0] +
		     0.5F * tobj->mtx[i][1] +
			    tobj->mtx[i][2] +
			    tobj->mtx[i][3];
      }

      GXLoadTexMtxImm(mtx, tobj->mtxid, GX_MTX3x4);
    }
    break;

  case TEX_COORD_HILIGHT:
    {
      HSD_LObj *lobj;
      
      if ((lobj = HSD_LObjGetCurrentByType(LOBJ_INFINITE)) != NULL) {
		HSD_CObj *cobj;
		Vec ldir, half;
		Mtx mtx;
		MtxPtr vmtx;

		/* 1D highlight map */

		cobj = HSD_CObjGetCurrent();
		assert(cobj);
		vmtx = HSD_CObjGetViewingMtxPtrDirect(cobj);
		HSD_LObjGetLightVector(lobj, &ldir);
		MTXMultVecSR(vmtx, &ldir, &ldir);

		ldir.z += -1.0F;

		VECNormalize(&ldir, &half);

		/* mtx = tobj->mtx * |-1/2 0  0  1/2| * | hx hy hz 0 |
		 *                   | 0   0  0  0  |   | 0  0  0  0 |
		 *                   | 0   0  0  1  |   | 0  0  0  0 |
		 *                   | 0   0  0  1  |   | 0  0  0  1 |
		 */

		half.x *= -0.5;
		half.y *= -0.5;
		half.z *= -0.5;

		mtx[0][0] = tobj->mtx[0][0] * half.x;
		mtx[0][1] = tobj->mtx[0][0] * half.y;
		mtx[0][2] = tobj->mtx[0][0] * half.z;
		mtx[0][3] = tobj->mtx[0][0] * 0.5F + tobj->mtx[0][3]; 
		mtx[1][0] = tobj->mtx[1][0] * half.x;
		mtx[1][1] = tobj->mtx[1][0] * half.y;
		mtx[1][2] = tobj->mtx[1][0] * half.z;
		mtx[1][3] = tobj->mtx[1][0] * 0.5F + tobj->mtx[1][3];         
		mtx[2][0] = 
		  mtx[2][1] = 
		  mtx[2][2] = 0.0F;
		mtx[2][3] = 1.0F;

		GXLoadTexMtxImm(mtx, tobj->mtxid, GX_MTX3x4);
      } else {
	/*
	 * ꍇuvW(1, 1)ɂčsB
	 * ̍Wpixel0ɂĂhighlighťʂȂȂB
	 */
	static Mtx zero = {
	  0.0F, 0.0F, 0.0F, 1.0F,
	  0.0F, 0.0F, 0.0F, 1.0F,
	  0.0F, 0.0F, 0.0F, 0.0F
	};
	GXLoadTexMtxImm(zero, tobj->mtxid, GX_MTX3x4);
      }
    }
    break;

  case TEX_COORD_SHADOW:
    {
      HSD_CObj *cobj = HSD_CObjGetCurrent();
      Mtx mtx;

#if FUJITA
	  //ŁAQ̃}gNX[h

	  //zeNX`
	  MTXConcat(SetupRampMtx(NULL), HSD_CObjGetInvViewingMtxPtrDirect(cobj), mtx);
	  GXLoadTexMtxImm(mtx, (GXTexMtx)(tobj->mtxid), GX_MTX3x4);

	  //VhEyeNX`
      MTXConcat(tobj->mtx, HSD_CObjGetInvViewingMtxPtrDirect(cobj), mtx);
      GXLoadTexMtxImm(mtx, 
					  (GXTexMtx)HSD_TexMapID2PTTexMtx((GXTexMapID)(tobj->id+1)),
					  GX_MTX3x4);
#else
      MTXConcat(tobj->mtx, HSD_CObjGetInvViewingMtxPtrDirect(cobj), mtx);

      GXLoadTexMtxImm(mtx, tobj->mtxid, GX_MTX3x4);
#endif
    }
    break;
  
#if FUJITA
  case TEX_COORD_GRADATION:
    {
      HSD_CObj *cobj = HSD_CObjGetCurrent();
	  Mtx mtx;

	  //JA≺ĂꍇB
	  //eNX`SWɃItZbgB
	  //jf̓[hYɍsB
	  Vec eye,y={0.f,1.f,0.f};
	  f32 dpro,ofst=0.5f,th=0.33f,w=0.5f;
	  Mtx	vmtx;
	  HSD_CObjGetViewingMtx(cobj,vmtx);
	  eye.x =  0.0f;
	  eye.y =  0.0f;
	  eye.z = -1.0f;
	  MTXTranspose(vmtx,vmtx);
	  MTXMultVecSR(vmtx,&eye,&eye);
//	  if( HSD_CObjGetEyeVector( cobj, &eye ) ){
		dpro = VECDotProduct( &eye, &y );
		//30xȏjAɊ蓖ĂB
		if( dpro > th ){
		  ofst += (w * (dpro-th) / (1.0-th));
//		  ofst -= (w * (dpro-th) / (1.0-th));		// modified by wat , 06/13/2003 
		}else if( dpro < -th ){
		  dpro *= -1;
		  ofst -= (w * (dpro-th) / (1.0-th));
//		  ofst += (w * (dpro-th) / (1.0-th));		// modified by wat , 06/13/2003 
		}
//	  }
	  //HSD_DmpVector( "", &up );
	  //OSReport( "%f : %f\n", ofst, dpro );

	  //YWЂԂĂB̂炵B
//	  MTXLightPerspective(mtx, HSD_CObjGetFov(cobj), HSD_CObjGetAspect(cobj), 0.5, -0.5, 0.5, ofst);		// modified by wat , 06/13/2003 
	  MTXLightPerspective(mtx, HSD_CObjGetFov(cobj), HSD_CObjGetAspect(cobj), 0.5, 0.5, 0.5, ofst);
      GXLoadTexMtxImm(mtx, (GXTexMtx)tobj->mtxid, GX_MTX3x4);
	}
	break;
#endif
#if FUJITA
  case TEX_COORD_BACKLIGHT:
    {
	  static f32 scale,trans;
      HSD_CObj *cobj = HSD_CObjGetCurrent();
      HSD_JObj *jobj = HSD_JObjGetCurrent();
	  Mtx mtx,view,ms,mdl;
	  //Ƒ߂ɂƂB
	  f32 intensity = tobj->rotate.y + 0.5;

	  //f̈ʒuB
	  MTXCopy( HSD_JObjGetMtxPtr(jobj), mdl );

	  if( tobj->tlut_no ){
		//}jA[hB
		trans = intensity;
		HSD_CObjGetViewingMtx( cobj, view );
	  }else{
		//CǧpAʒuAw肳ĂB
		Vec mdl_pos,cam_pos,lgt_pos,lgt_dir,cam_dir;
		Vec lgt2mdl,lgt2cam,cam2mdl,up={0.f,1.f,0.f};
		f32 cam2lgt_dpro,mdl2lgt_dpro,lgt2cam_dpro,max_dpro;
		//f̈ʒuB
		HSD_MtxGetTranslate( mdl, &mdl_pos );
		//_B
		HSD_CObjGetEyePosition( cobj, &cam_pos );
		//xNgB
		HSD_CObjGetEyeVector( cobj, &cam_dir );
		//Cg̈ʒuB
		lgt_pos = tobj->translate;
		//Ǝ˃xNgB
		lgt_dir = tobj->scale;
		//cos( cutoff )
		max_dpro = tobj->rotate.x;

		//Cg烂fւ̌B
		VECSubtract( &mdl_pos, &lgt_pos, &lgt2mdl );
		VECNormalize( &lgt2mdl, &lgt2mdl );
		//CgJւ̌B
		VECSubtract( &cam_pos, &lgt_pos, &lgt2cam );
		VECNormalize( &lgt2cam, &lgt2cam );
		//J烂fւ̌B
		VECSubtract( &mdl_pos, &cam_pos, &cam2mdl );
		VECNormalize( &cam2mdl, &cam2mdl );

		//J烉Cg郔[}gbNXB
		MTXLookAt( view, &cam_pos, &up, &lgt_pos );

		trans = 0.f;
		scale = 0.f;
#if 0
		//fR[ɓĂB
		mdl2lgt_dpro = VECDotProduct( &lgt2mdl, &lgt_dir );
		if( mdl2lgt_dpro > max_dpro ){
		  f32 base = 0.6f;
		  trans = base * (mdl2lgt_dpro-max_dpro)/(1.f-max_dpro);
		  scale = 0.9f;
		  //JR[ɓĂB
		  lgt2cam_dpro = VECDotProduct( &lgt2cam, &lgt_dir );
		  //if( lgt2cam_dpro > max_dpro ){
		  if( 1 ){
			//xNgƁA_烉Cgւ̃xNg̓ρB
			Vec cam2lgt;
			VECScale( &lgt2cam, &cam2lgt, -1.f );
			cam2lgt_dpro = VECDotProduct( &cam2lgt, &cam2mdl );
			//trans += (intensity - base) * cam2lgt_dpro * 
			//(lgt2cam_dpro-max_dpro)/(1.f-max_dpro);
			trans += (intensity - base) * cam2lgt_dpro;
		  }
		}
#else
#pragma unused( lgt2cam_dpro )
		{
		  //J烂fAJ烉CgAꂼ̃xNgǂꂭ炢߂H
		  Vec cam2lgt;
		  VECScale( &lgt2cam, &cam2lgt, -1.f );
		  cam2lgt_dpro = VECDotProduct( &cam2lgt, &cam2mdl );
		  if( cam2lgt_dpro < 0.f ) cam2lgt_dpro = 0.f;

		  //fR[̒Sɂǂꂭ炢߂H
		  mdl2lgt_dpro = VECDotProduct( &lgt2mdl, &lgt_dir );
		  mdl2lgt_dpro = (mdl2lgt_dpro-max_dpro)/(1.f-max_dpro);
		  if( mdl2lgt_dpro < 0.f ) mdl2lgt_dpro = 0.f;

		  trans = intensity * mdl2lgt_dpro * cam2lgt_dpro;
		  scale = 0.8f;
		}
#endif
	  }

	  // JYɑ΂ĂXOxɉ񂷁B
	  MTXRotDeg(mtx, 'Y', -90);
	  MTXConcat(mtx, view, mtx);
	  MTXConcat(mtx, mdl, mtx);
	  MTXInverse(mtx, ms);
	  MTXTranspose(ms, mtx);

	  //XP[AgXB
	  MTXScale(ms, scale, 0.5F, 1.0F);
	  MTXConcat(ms, mtx, mtx);
	  MTXTrans(ms, trans, 0.5F, 0.0F);
	  MTXConcat(ms, mtx, mtx);

	  // Load into the hardware
	  GXLoadTexMtxImm(mtx, (GXTexMtx)tobj->mtxid, GX_MTX2x4);

#if 0
#define Clamp(val,min,max) \
    ((val) = (((val) < (min)) ? (min) : ((val) > (max)) ? (max) : (val)))
	  // eNX`XP[,ItZbgB
	  {
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ) scale += 0.01f;
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ) scale -= 0.01f;
		if( HSD_PadGetTrigger(0) & HSD_PAD_X ) trans += 0.01f;
		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ) trans -= 0.01f;
		Clamp( scale, 0.f, 1.f );
		Clamp( trans, 0.f, 1.f );
		OSReport( "%f %f\n", scale, trans );
	  }
#endif
	}
	break;
#endif
  default:
    if (tobj_bump(tobj)) {
      GXLoadTexMtxImm(tobj->mtx, tobj->mtxid, GX_MTX2x4);
    } else {
      GXLoadTexMtxImm(tobj->mtx, tobj->mtxid, GX_MTX3x4);
    }
    break;
  }
}

static void
setupTextureCoordGen(HSD_TObj *tobj)
{
  switch (tobj_coord(tobj)) {
  case TEX_COORD_SHADOW:
#if FUJITA
	//ŁASHADOWꍇ͂QCoordGenݒB
	//z
    GXSetTexCoordGen2((GXTexCoordID)(tobj->coord),
					  GX_TG_MTX3x4,
					  GX_TG_POS,
					  GX_PNMTX0,
					  GX_DISABLE,
					  (tobj->mtxid));

	//VhEyeNX`
    GXSetTexCoordGen2((GXTexCoordID)(tobj->coord+1),
					  GX_TG_MTX3x4,
					  GX_TG_POS,
					  GX_PNMTX0,
					  GX_DISABLE,
					  (GXTexMtx)HSD_TexMapID2PTTexMtx((GXTexMapID)(tobj->id+1)));
#else
    GXSetTexCoordGen2(tobj->coord,
					  GX_TG_MTX3x4,
					  GX_TG_POS,
					  GX_PNMTX0,
					  GX_DISABLE,
					  tobj->mtxid);
#endif
    break;
#if FUJITA
  case TEX_COORD_GRADATION:
	//Of[VB
    GXSetTexCoordGen2(tobj->coord,
					  GX_TG_MTX3x4,
					  GX_TG_POS,
					  GX_PNMTX0,
					  GX_DISABLE,
					  tobj->mtxid);
	break;
#endif
#if FUJITA
  case TEX_COORD_BACKLIGHT:
	//tB
    GXSetTexCoordGen(tobj->coord, GX_TG_MTX2x4, GX_TG_NRM, tobj->mtxid);
	break;
#endif
  case TEX_COORD_REFLECTION:
  case TEX_COORD_HILIGHT:
    GXSetTexCoordGen2(tobj->coord,
		      GX_TG_MTX3x4,
		      GX_TG_NRM,
		      GX_TEXMTX0,
		      GX_ENABLE,
		      tobj->mtxid);
    break;
  default:
    if (tobj_bump(tobj)) {
      /*
       * BUMP̌iɂPost TransformuvW͑Ȃ̂ŁA
       * ϊ}gNXPos/Tex MtxɃ[hȂ΂ȂȂB
       */
      GXSetTexCoordGen(tobj->coord,
		       GX_TG_MTX2x4,
		       tobj->src,
		       tobj->mtxid);
    } else {
      GXSetTexCoordGen2(tobj->coord,
		       GX_TG_MTX2x4,
		       tobj->src,
		       GX_IDENTITY,
		       GX_FALSE,
		       tobj->mtxid);
    }
  }
}

#if DOLPHIN_API_AGE >= 1 && !defined(MAC) && !defined(WIN32)
static void
setupTextureCoordGenBump(HSD_TObj *bump)
{
  u32 mask;
  int i;
  static GXTexGenType func[] = {
    GX_TG_BUMP0,
    GX_TG_BUMP1,
    GX_TG_BUMP2,
    GX_TG_BUMP3,
    GX_TG_BUMP4,
    GX_TG_BUMP5,
    GX_TG_BUMP6,
    GX_TG_BUMP7,
  };

  mask = HSD_LObjGetLightMaskDiffuse();
  for (i=0; i<MAX_GXLIGHT-1; i++) {
    if (mask & (1<<i)) {
      break;
    }
  }
  if (i >= MAX_GXLIGHT-1) {
    i = 0;
  }

  GXSetTexCoordGen((GXTexCoordID)(bump->coord + 1), 
		   func[i],
		   HSD_TexCoordID2TexGenSrc(bump->coord),
		   GX_IDENTITY);
}
#endif

static void
setupTextureCoordGenToon(HSD_TObj *toon)
{
  GXSetTexCoordGen(toon->coord, 
		   GX_TG_SRTG,
		   toon->src,
		   GX_IDENTITY);
}

/**
 * eNX`W̐ݒB
 * 
 * tobj擪ɘAꂽSTObj̍WɕKv
 * n[hEFAݒ肳BBump}bsOgpꍇA
 * Wn[hEFAPKvƂB
 * @warning
 * ov}bvꍇAŌ̃eNX`݂̂LƂȂA
 * ͖̑B
 * 
 * gp郊\[X̊蓖Ă͗\HSD_TObjAssignResources()
 * pčsĂB
 * 
 * @see HSD_TObjAssignResources
 */
void
HSD_TObjSetupTextureCoordGen(HSD_TObj *tobj)
{
  for ( ; tobj != NULL; tobj = tobj->next) {
    if (tobj->id == GX_TEXMAP_NULL)
      continue;

    if (tobj_bump(tobj)) {
      /* ov̏ꍇ tobj->coord ̎ ID  bumpcoord ɂ */
      setupTextureCoordGen(tobj);
#ifndef UNUSED_BUMP
#if DOLPHIN_API_AGE >= 1 && !defined(EMU)
      setupTextureCoordGenBump(tobj);
#endif
#endif
    }
    else if (tobj_coord(tobj) == TEX_COORD_TOON) {
      setupTextureCoordGenToon(tobj);
    } else {
      setupTextureCoordGen(tobj);
    }
  }
}

/*
 * shadow projection texture prev J[Ɋ|B
 * 
 * shadown܂tobj̃NɊ܂܂邷ׂĂTEX_COORD_SHADOW
 * eNX`ɂtev stageݒ肷B
 * ŏIImodulateꂽJ[prevWX^ɏo͂B
 * 
 * alpha lprev l̂܂܏o͂B
 */
static void
TObjSetupTevModulateShadow(HSD_TObj *shadow)
{
  static HSD_TevDesc tevdesc = {
    NULL, TEVCONF_MODE,
    (GXTevStageID)(-1),
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR_NULL,
    GX_TEV_ADD,
	//clr_a, clr_b, clr_c, clr_d
    GX_CC_ZERO,		GX_CC_CPREV,	GX_CC_TEXC,	GX_CC_ZERO,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
	// out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;
    GX_TEV_ADD,
    GX_CA_ZERO,		GX_CA_ZERO,	GX_CA_ZERO,	GX_CA_APREV,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };

#if FUJITA
#define CHANGE 1
  //todo 
  //shadow.intensity̒lĂ郌WX^ɓB
  //̂Ƃ킹āATexpƉ͂邱ƁB

  //todo
  //TexpƉ͂āARENDER_SHADOWȂ
  //e̒Oout_regTEVREG0ƂɂȂ悤ɂ鎖B
  static HSD_TevDesc tevdesc_pass = {
	//next, flags
    NULL, TEVCONF_MODE,
	//stage
    (GXTevStageID)(-1),
	//coord, texmap, rasc
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR_NULL,
	//clr_op
    GX_TEV_ADD,
	//clr_a, clr_b, clr_c, clr_d
    GX_CC_ZERO,		GX_CC_ZERO,	GX_CC_ZERO,	GX_CC_CPREV,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
	GX_CS_SCALE_1,	GX_TB_ZERO,	GX_TRUE,	GX_TEVREG2,
	// out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;

	//At@͂̂܂
    GX_TEV_ADD,
    GX_CA_ZERO,		GX_CA_ZERO,	GX_CA_ZERO,	GX_CA_APREV,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };

  //zeNX`bNAbvTev
  //CgƂ̋ARampTex̃tH[}bgɈkĎoB
  static HSD_TevDesc tevdesc_ramp = {
	//next, flags
    NULL, TEVCONF_MODE,
	//stage
    (GXTevStageID)(-1),
	//coord, texmap, rasc
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR_NULL,
	//clr_op
    GX_TEV_ADD,
	//clr_a, clr_b, clr_c, clr_d
	GX_CC_ZERO,		GX_CC_ZERO,	GX_CC_ZERO,	GX_CC_TEXC,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
#if !CHANGE
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_TRUE,	GX_TEVPREV,
#else
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_TRUE,	GX_TEVREG2,
#endif
	// out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;

	//At@͂̂܂
    GX_TEV_ADD,
    GX_CA_ZERO,		GX_CA_ZERO,	GX_CA_ZERO,	GX_CA_APREV,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };

  //shadowiyeNX`j𓊉eB
  static HSD_TevDesc tevdesc_shadow = {
	//next, flags
    NULL, TEVCONF_MODE,
	//stage
    (GXTevStageID)(-1),
	//coord, texmap, rasc
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR_NULL,
	//clr_op
    GX_TEV_COMP_R8_GT,
	//clr_a, clr_b, clr_c, clr_d
#if !CHANGE
    GX_CC_CPREV,	GX_CC_TEXC,	GX_CC_KONST,	GX_CC_ZERO,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_FALSE,	GX_TEVPREV,
	//out_reg = d + ((a op b) ? c : 0);
#else
    GX_CC_C2,	GX_CC_TEXC,	GX_CC_KONST,	GX_CC_ZERO,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_FALSE,	GX_TEVREG2,
	//out_reg = d + ((a op b) ? c : 0);
#endif

	//At@͂̂܂܁B
    GX_TEV_ADD,
    GX_CA_ZERO,		GX_CA_ZERO,	GX_CA_ZERO,	GX_CA_APREV,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };

  //Oǐʂ󂯂āATEVREG0̐F𒲐B
  static HSD_TevDesc tevdesc_comp = {
	//next, flags
    NULL, TEVCONF_MODE,
	//stage
    (GXTevStageID)(-1),
	//coord, texmap, rasc
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR_NULL,
	//clr_op
    GX_TEV_ADD,
	//clr_a, clr_b, clr_c, clr_d
#if !CHANGE
	GX_CC_C2,	GX_CC_ZERO, GX_CC_CPREV,	GX_CC_ZERO,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
	// out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;
#else
	GX_CC_CPREV,	GX_CC_ZERO, GX_CC_C2,	GX_CC_ZERO,
	//clr_scl, clr_bias, clr_clamp, clr_out_reg
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
	// out_reg = (d (op) ((1.0 - c)*a + c*b) + bias) * scl;
#endif

	//At@͂̂܂܁B
    GX_TEV_ADD,
    GX_CA_ZERO,		GX_CA_ZERO,	GX_CA_ZERO,	GX_CA_APREV,
    GX_CS_SCALE_1,	GX_TB_ZERO,	GX_ENABLE,	GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };
#endif

  for (; shadow && tobj_coord(shadow) == TEX_COORD_SHADOW;
       shadow=shadow->next) {

#if FUJITA
#if !CHANGE
	//΂΂ǁARs[ƂB
	tevdesc_pass.stage = HSD_StateAssignTev();
    HSD_SetupTevStage(&tevdesc_pass);
#endif

	//z
	tevdesc_ramp.stage = HSD_StateAssignTev();
	tevdesc_ramp.coord = shadow->coord;
	tevdesc_ramp.map = shadow->id;
    HSD_SetupTevStage(&tevdesc_ramp);

	//if( HSD_PadGetButton(0) & HSD_PAD_X ){
	if( 0 ){
	}else{
#if 0
	  GXColorS10 c;

	  c.r = -GetShadowIntensity().r;
	  c.g = -GetShadowIntensity().g;
	  c.b = -GetShadowIntensity().b;
	  c.a = -GetShadowIntensity().a;

	  GXSetTevColorS10( GX_TEVREG1, c );
#endif

	//́ARXgRԂȂĕ
	//܂gȂƌOłߕtĂB
	GXSetTevKColor( GX_KCOLOR3, GetShadowIntensity() );
	GXSetTevKColorSel( tevdesc_shadow.stage,  GX_TEV_KCSEL_K3_R );
 
	//VhEyeNX`
	tevdesc_shadow.stage = HSD_StateAssignTev();
	tevdesc_shadow.coord = (GXTexCoordID)(shadow->coord + 1);
	tevdesc_shadow.map = (GXTexMapID)(shadow->id + 1);
    HSD_SetupTevStage(&tevdesc_shadow);

	//rpTev
	tevdesc_comp.stage = HSD_StateAssignTev();
    HSD_SetupTevStage(&tevdesc_comp);
	}
#else
    tevdesc.stage = HSD_StateAssignTev();
    tevdesc.coord = shadow->coord;
    tevdesc.map = shadow->id;
    HSD_SetupTevStage(&tevdesc);
#endif
  }

}

#if DOLPHIN_API_AGE >= 1 && !defined(MAC) && !defined(WIN32)
static void
SetupEmbossBumpTev(HSD_TObj *bump)
{
  static HSD_TevDesc tevdesc = {
    NULL, TEVCONF_MODE,
    (GXTevStageID)(-1),
    GX_TEXCOORD_NULL, GX_TEXMAP_NULL, GX_COLOR0A0, 
    GX_TEV_SUB,
    GX_CC_ZERO, GX_CC_TEXC, GX_CC_RASC, GX_CC_CPREV,
    GX_CS_SCALE_1, GX_TB_ZERO, GX_ENABLE, GX_TEVPREV,
    GX_TEV_SUB,
    GX_CA_ZERO, GX_CA_ZERO, GX_CA_ZERO, GX_CA_APREV,
    GX_CS_SCALE_1, GX_TB_ZERO, GX_ENABLE, GX_TEVPREV,
    GX_TC_LINEAR,
#if DOLPHIN_API_AGE >= 4 && GX_REV >= 2
    GX_TEV_SWAP0,
    GX_TEV_SWAP0,
    GX_TEV_KCSEL_1,
    GX_TEV_KASEL_1
#endif
  };

#ifdef PRINT_DEBUG
  HSD_Report("SetupEmbossBumpTev in\n");
#endif
  tevdesc.stage = HSD_StateAssignTev();
  tevdesc.coord = bump->coord;
  tevdesc.map = bump->id;
  tevdesc.u.tevconf.clr_op = GX_TEV_ADD;
  tevdesc.u.tevconf.alpha_op = GX_TEV_ADD;
  tevdesc.u.tevconf.clr_clamp = GX_DISABLE;
  HSD_SetupTevStage(&tevdesc);
  tevdesc.stage = HSD_StateAssignTev();
  tevdesc.coord = (GXTexCoordID)(bump->coord + 1);
  tevdesc.u.tevconf.clr_op = GX_TEV_SUB;
  tevdesc.u.tevconf.alpha_op = GX_TEV_SUB;
  tevdesc.u.tevconf.clr_clamp = GX_ENABLE;
  HSD_SetupTevStage(&tevdesc);
}
#endif

/**
 * ǉ Tev ݒ
 * 
 * tobj 擪ƂeNX`̃XĝAÓIɌłȂ
 * ^CṽeNX`pTEVXe[W݂̐ݒɒǉB
 * 
 * @tip ݂̊֐Őݒ肳̂̓ovƃVh[eNX`B
 */
void
HSD_TObjSetupVolatileTev(HSD_TObj *tobj, u32 rendermode)
{
#pragma unused(rendermode)

  for (; tobj; tobj=tobj->next) {
    if (tobj->id == GX_TEXMAP_NULL)
      continue;

#if !defined(UNUSED_BUMP) && DOLPHIN_API_AGE >= 1 && !defined(EMU)
    if (tobj_bump(tobj)) {
      SetupEmbossBumpTev(tobj);
    }
#endif
    if (tobj_lightmap(tobj) & TEX_LIGHTMAP_SHADOW) {
      TObjSetupTevModulateShadow(tobj);
      break;
    }
  }
}

static void
MakeColorGenTExp(u32 lightmap,
		 HSD_TObj *tobj,
		 HSD_TExp **c,
		 HSD_TExp **a,
		 HSD_TExp **list,
		 int repeat)
{
#pragma unused(lightmap)
#pragma unused(repeat)

  HSD_TObjTev *tev = tobj->tev;
  u8 *in;
  HSD_TExp *e0, *tmp;
  int i;

  HSD_TExp *konst_rgb;
  HSD_TExp *konst_r;
  HSD_TExp *konst_g;
  HSD_TExp *konst_b;
  HSD_TExp *konst_a;
  HSD_TExp *reg0_rgb;
  HSD_TExp *reg0_a;
  HSD_TExp *reg1_rgb;
  HSD_TExp *reg1_a;

  int use_k_rgb = 0;
  int use_k_r = 0;
  int use_k_g = 0;
  int use_k_b = 0;
  int use_k_a = 0;
  int use_reg0_rgb = 0;
  int use_reg0_a = 0;
  int use_reg1_rgb = 0;
  int use_reg1_a = 0;

  /* ǂ̒萔gpĂ邩ׂ */
  in = &tev->color_a;
  for (i=0; i<4; i++) {
    switch (in[i]) {
    case TOBJ_TEV_CC_KONST_RGB: use_k_rgb = 1; break;
    case TOBJ_TEV_CC_KONST_RRR: use_k_r = 1; break;
    case TOBJ_TEV_CC_KONST_GGG: use_k_g = 1; break;
    case TOBJ_TEV_CC_KONST_BBB: use_k_b = 1; break;
    case TOBJ_TEV_CC_KONST_AAA: use_k_a = 1; break;
    case TOBJ_TEV_CC_TEX0_RGB:  use_reg0_rgb = 1; break;
    case TOBJ_TEV_CC_TEX0_AAA: use_reg0_a = 1; break;
    case TOBJ_TEV_CC_TEX1_RGB: use_reg1_rgb = 1; break;
    case TOBJ_TEV_CC_TEX1_AAA: use_reg1_a = 1; break;
    default:
      break;
    }
  }
  in = &tev->alpha_a;
  for (i=0; i<4; i++) {
    switch (in[i]) {
    case TOBJ_TEV_CA_KONST_R:
      use_k_r = 1;
      break;
    case TOBJ_TEV_CA_KONST_G:
      use_k_g = 1;
      break;
    case TOBJ_TEV_CA_KONST_B:
      use_k_b = 1;
      break;
    case TOBJ_TEV_CA_KONST_A:
      use_k_a = 1;
      break;
    case TOBJ_TEV_CA_TEX0_A:
      use_reg0_a = 1;
      break;
    case TOBJ_TEV_CA_TEX1_A:
      use_reg1_a = 1;
      break;
    default:
      break;
    }
  }

  if (use_k_rgb) {
    konst_rgb = HSD_TExpCnst(&tobj->tev->konst, HSD_TE_RGB, HSD_TE_U8, list);
  }
  if (use_k_r) {
    konst_r = HSD_TExpCnst(&tobj->tev->konst.r, HSD_TE_X, HSD_TE_U8, list);
  }
  if (use_k_g) {
    konst_g = HSD_TExpCnst(&tobj->tev->konst.g, HSD_TE_X, HSD_TE_U8, list);
  }
  if (use_k_b) {
    konst_b = HSD_TExpCnst(&tobj->tev->konst.b, HSD_TE_X, HSD_TE_U8, list);
  }
  if (use_k_a) {
    konst_a = HSD_TExpCnst(&tobj->tev->konst.a, HSD_TE_X, HSD_TE_U8, list);
  }
  if (use_reg0_rgb) {
    reg0_rgb = HSD_TExpCnst(&tobj->tev->tev0, HSD_TE_RGB, HSD_TE_U8, list);
  }
  if (use_reg0_a) {
    reg0_a = HSD_TExpCnst(&tobj->tev->tev0.a, HSD_TE_X, HSD_TE_U8, list);
  }
  if (use_reg1_rgb) {
    reg1_rgb = HSD_TExpCnst(&tobj->tev->tev1, HSD_TE_RGB, HSD_TE_U8, list);
  }
  if (use_reg1_a) {
    reg1_a = HSD_TExpCnst(&tobj->tev->tev1.a, HSD_TE_X, HSD_TE_U8, list);
  }

  e0 = HSD_TExpTev(list);
  HSD_TExpOrder  (e0, tobj, GX_COLOR_NULL);

  if (tev->active & TOBJ_TEVREG_ACTIVE_COLOR_TEV) {
    HSD_TEInput sel[4];
    HSD_TExp *exp[4];
    int i;

    in = &tev->color_a;
    for (i=0; i<4; i++) {
      switch (in[i]) {
      case GX_CC_ZERO:
	sel[i] = HSD_TE_0;
	exp[i] = HSD_TEXP_ZERO;
	break;
      case GX_CC_ONE:
	sel[i] = HSD_TE_1;
	exp[i] = HSD_TEXP_ZERO;
	break;
      case GX_CC_HALF:
	sel[i] = HSD_TE_4_8;
	exp[i] = HSD_TEXP_ZERO;
	break;
      case GX_CC_TEXC:
        sel[i] = HSD_TE_RGB;
	exp[i] = HSD_TEXP_TEX;
	break;
      case GX_CC_TEXA:
        sel[i] = HSD_TE_A;
	exp[i] = HSD_TEXP_TEX;
	break;
      case TOBJ_TEV_CC_KONST_RGB:
	sel[i] = HSD_TE_RGB;
	exp[i] = konst_rgb;
	break;
      case TOBJ_TEV_CC_KONST_RRR:
	sel[i] = HSD_TE_X;
	exp[i] = konst_r;
	break;
      case TOBJ_TEV_CC_KONST_GGG:
	sel[i] = HSD_TE_X;
	exp[i] = konst_g;
	break;
      case TOBJ_TEV_CC_KONST_BBB:
	sel[i] = HSD_TE_X;
	exp[i] = konst_b;
	break;
      case TOBJ_TEV_CC_KONST_AAA:
	sel[i] = HSD_TE_X;
	exp[i] = konst_a;
	break;
      case TOBJ_TEV_CC_TEX0_RGB:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpColorOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpColorIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_RGB, reg0_rgb);
	sel[i] = HSD_TE_RGB;
	exp[i] = tmp;
	break;
      case TOBJ_TEV_CC_TEX0_AAA:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpColorOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpColorIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_X, reg0_a);
	sel[i] = HSD_TE_RGB;
	exp[i] = tmp;
	break;
      case TOBJ_TEV_CC_TEX1_RGB:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpColorOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpColorIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_RGB, reg1_rgb);
	sel[i] = HSD_TE_RGB;
	exp[i] = tmp;
	break;
      case TOBJ_TEV_CC_TEX1_AAA:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpColorOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpColorIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_X, reg1_a);
	sel[i] = HSD_TE_RGB;
	exp[i] = tmp;
	break;
      default:
	assert(0);
	break;
      }
    }

    HSD_TExpColorOp(e0, (GXTevOp)tev->color_op,
			(GXTevBias)tev->color_bias,
			(GXTevScale)tev->color_scale,
			tev->color_clamp);
    HSD_TExpColorIn(e0, sel[0], exp[0],
			sel[1], exp[1],
			sel[2], exp[2],
			sel[3], exp[3]);
    *c = e0;
  }

  if (tev->active & TOBJ_TEVREG_ACTIVE_ALPHA_TEV) {
    HSD_TEInput sel[4];
    HSD_TExp *exp[4];
    int i;

    in = &tev->alpha_a;
    for (i=0; i<4; i++) {
      switch (in[i]) {
      case GX_CA_ZERO:
	sel[i] = HSD_TE_0;
	exp[i] = HSD_TEXP_ZERO;
	break;
      case GX_CA_TEXA:
        sel[i] = HSD_TE_A;
	exp[i] = HSD_TEXP_TEX;
	break;
      case TOBJ_TEV_CA_KONST_R:
	sel[i] = HSD_TE_X;
	exp[i] = konst_r;
	break;
      case TOBJ_TEV_CA_KONST_G:
	sel[i] = HSD_TE_X;
	exp[i] = konst_g;
	break;
      case TOBJ_TEV_CA_KONST_B:
	sel[i] = HSD_TE_X;
	exp[i] = konst_b;
	break;
      case TOBJ_TEV_CA_KONST_A:
	sel[i] = HSD_TE_X;
	exp[i] = konst_a;
	break;
      case TOBJ_TEV_CA_TEX0_A:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpAlphaOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpAlphaIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_X, reg0_a);
	sel[i] = HSD_TE_A;
	exp[i] = tmp;
	break;
      case TOBJ_TEV_CA_TEX1_A:
	tmp = HSD_TExpTev(list);
	HSD_TExpOrder  (tmp, NULL, GX_COLOR_NULL);
	HSD_TExpAlphaOp(tmp, GX_TEV_ADD, GX_TB_ZERO,
			     GX_CS_SCALE_1, GX_ENABLE);
	HSD_TExpAlphaIn(tmp, HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_0, HSD_TEXP_ZERO,
			     HSD_TE_X, reg1_a);
	sel[i] = HSD_TE_A;
	exp[i] = tmp;
	break;
      default:
	assert(0);
	break;
      }
    }

    HSD_TExpAlphaOp(e0, (GXTevOp)tev->alpha_op,
			(GXTevBias)tev->alpha_bias,
			(GXTevScale)tev->alpha_scale,
			tev->alpha_clamp);
    HSD_TExpAlphaIn(e0, sel[0], exp[0],
			sel[1], exp[1],
			sel[2], exp[2],
			sel[3], exp[3]);

    *a = e0;
  }
}

static void
TObjMakeTExp(HSD_TObj *tobj,
	     u32 lightmap,
	     u32 lightmap_done,
	     HSD_TExp **c,
	     HSD_TExp **a,
	     HSD_TExp **list)
{
  HSD_TExp *e0, *e1;
  HSD_TExp *c_src, *a_src;
  HSD_TEInput c_sel, a_sel;
  int repeat = (lightmap_done & tobj_lightmap(tobj)) != 0;

  c_src = HSD_TEXP_TEX;
  c_sel = HSD_TE_RGB;

  a_src = HSD_TEXP_TEX;
  a_sel = HSD_TE_A;

  e0 = HSD_TExpTev(list);

  if (tobj->tev &&
      (tobj->tev->active & (TOBJ_TEVREG_ACTIVE_COLOR_TEV|
			    TOBJ_TEVREG_ACTIVE_ALPHA_TEV)))
  {
    MakeColorGenTExp(lightmap, tobj, &c_src, &a_src, list, repeat);
  }

  HSD_TExpOrder(e0, tobj, GX_COLOR_NULL);

  switch (tobj_colormap(tobj)) {
  case TEX_COLORMAP_ALPHA_MASK:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_RGB, *c,
			c_sel, c_src,
			a_sel, a_src,
			HSD_TE_0, HSD_TEXP_ZERO);
    break;
  case TEX_COLORMAP_RGB_MASK:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_RGB, *c,
			c_sel, c_src,
			c_sel, c_src,
			HSD_TE_0, HSD_TEXP_ZERO);
    break;
  case TEX_COLORMAP_BLEND:
    e1 = HSD_TExpCnst(&tobj->blending, HSD_TE_X, HSD_TE_F32, list);
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_RGB, *c,
			c_sel, c_src,
			HSD_TE_X, e1,
			HSD_TE_0, HSD_TEXP_ZERO);
    break;
  case TEX_COLORMAP_MODULATE:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_RGB, *c,
			c_sel, c_src,
			HSD_TE_0, HSD_TEXP_ZERO);
    break;
  case TEX_COLORMAP_REPLACE:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			c_sel, c_src);
    break;
  case TEX_COLORMAP_NONE:
  case TEX_COLORMAP_PASS:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_RGB, *c);
    break;
  case TEX_COLORMAP_ADD:
    HSD_TExpColorOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, c_sel, c_src,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_RGB, *c);
    break;
  case TEX_COLORMAP_SUB:
    HSD_TExpColorOp(e0, GX_TEV_SUB, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
    HSD_TExpColorIn(e0, c_sel, c_src,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_0, HSD_TEXP_ZERO,
			HSD_TE_RGB, *c);
    break;
  default:
    assert(0);
  }
  *c = e0;

  if (!repeat) {
    switch (tobj_alphamap(tobj)) {
    case TEX_ALPHAMAP_ALPHA_MASK:
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, HSD_TE_A, *a,
			  a_sel, a_src,
			  a_sel, a_src,
			  HSD_TE_0, HSD_TEXP_ZERO);
      break;
    case TEX_ALPHAMAP_BLEND:
      e1 = HSD_TExpCnst(&tobj->blending, HSD_TE_X, HSD_TE_F32, list);
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, HSD_TE_A, *a,
			  a_sel, a_src,
			  HSD_TE_X, e1,
			  HSD_TE_0, HSD_TEXP_ZERO);
      break;
    case TEX_ALPHAMAP_MODULATE:
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_A, *a,
			  a_sel, a_src,
			  HSD_TE_0, HSD_TEXP_ZERO);
      break;
    case TEX_ALPHAMAP_REPLACE:
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  a_sel, a_src);
      break;
    case TEX_ALPHAMAP_NONE:
    case TEX_ALPHAMAP_PASS:
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_A, *a);
      break;
    case TEX_ALPHAMAP_ADD:
      HSD_TExpAlphaOp(e0, GX_TEV_ADD, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, a_sel, a_src,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_A, *a);
      break;
    case TEX_ALPHAMAP_SUB:
      HSD_TExpAlphaOp(e0, GX_TEV_SUB, GX_TB_ZERO, GX_CS_SCALE_1, GX_ENABLE);
      HSD_TExpAlphaIn(e0, a_sel, a_src,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_0, HSD_TEXP_ZERO,
			  HSD_TE_A, *a);
      break;
    default:
      assert(0);
    }
    *a = e0;
  }
}

/**
 * eNX`gp郊\[X肷
 * 
 *  tobj_top AꂽׂĂTObjɂāA
 * Kvȃ\[X蓖ĂB
 * 
 * @warning
 * Toon/BumpeNX`ꍇ́AŌ̂P݂̂LɂȂ
 *
 * @return
 * tex coord 
 */
int
HSD_TObjAssignResources(HSD_TObj *tobj_top)
{
  HSD_TObj *tobj;
  u32 texmap_no = 0;
  u32 texcoord_no = 0;
  u32 limit = 8;
  HSD_TObj *bump = NULL;
  HSD_TObj *toon = NULL;
#if FUJITA
  HSD_TObj *shadow = NULL;
  HSD_TObj *gradation = NULL;
  HSD_TObj *backlight = NULL;
#endif

  if (tobj_top == NULL)
    return 0;

  //fujita
  //eNX`AeNX`WAeNX`}gNX
  //̎蓖ĂĂB
  //ŁASHADOWꍇɗ]vɃ\[XmۂĂ܂.

  //gE[ovΔoĂB
  for (tobj = tobj_top; tobj; tobj = tobj->next) {
    if (tobj_coord(tobj) == TEX_COORD_TOON) {
      toon = tobj;
    } else if (tobj_bump(tobj)) {
      bump = tobj;
    }
#if FUJITA
	else if(tobj_coord(tobj) == TEX_COORD_SHADOW){
	  //SHADOWɊւĂ͐擪̓z]B
	  //܂Ae͂ЂƂB
	  if( !shadow ) shadow = tobj;
	}else if(tobj_coord(tobj) == TEX_COORD_GRADATION ){
	  //Of[VB
	  gradation = tobj;
	}else if(tobj_coord(tobj) == TEX_COORD_BACKLIGHT ){
	  //obNCgB
	  backlight = tobj;
	}
#endif
  }

  //eNX`̃~bg͌ĂB
  if (toon)
    limit -= 1;
  if (bump)
    limit -= 2;
#if FUJITA
  //Of[Vp
  if (gradation)
	limit -= 1;

  //obNCgp
  if (backlight)
	limit -= 1;

  //zAVhÊQĝ
  if( shadow )
	limit -= 2;
#endif


  /* eeNX`TexCoordO犄蓖Ă */
  for (tobj = tobj_top; tobj; tobj = tobj->next) {
    if (tobj_coord(tobj) == TEX_COORD_TOON) {
      if (tobj != toon) {
	tobj->id = GX_TEXMAP_NULL;
      }
    } else if (tobj_bump(tobj)) {
      if (tobj != bump) {
		tobj->id = GX_TEXMAP_NULL;
      }
#if FUJITA
    } else if (tobj_coord(tobj) == TEX_COORD_SHADOW) {
	  //_u鎖͂Ȃ̂łȂ񂾂ǁB
      if (tobj != shadow) {
		tobj->id = GX_TEXMAP_NULL;
      }
    } else if (tobj_coord(tobj) == TEX_COORD_GRADATION) {
	  //_u͂ȂB
      if (tobj != gradation) {
		tobj->id = GX_TEXMAP_NULL;
      }
    } else if (tobj_coord(tobj) == TEX_COORD_BACKLIGHT) {
	  //_u͂ȂB
      if (tobj != backlight) {
		tobj->id = GX_TEXMAP_NULL;
      }
#endif
    } else if (texmap_no < limit) {
	  //eNX`
      tobj->id = HSD_Index2TexMap(texmap_no ++);
	  //}gNX
      tobj->mtxid = HSD_TexMapID2PTTexMtx(tobj->id);
	  //CoordGen
      switch (tobj_coord(tobj)) {
      case TEX_COORD_REFLECTION:
      case TEX_COORD_HILIGHT:
#if !FUJITA
      case TEX_COORD_SHADOW:
#endif
		tobj->coord = HSD_Index2TexCoord(texcoord_no ++);
		break;
      default:
        break;
      }
    } else {
      tobj->id = GX_TEXMAP_NULL;
    }
  }

  //tc[̃eNX`
  for (tobj = tobj_top; tobj; tobj = tobj->next) {
    if (tobj->id != GX_TEXMAP_NULL && !tobj_bump(tobj)) {
      switch (tobj_coord(tobj)) {
      case TEX_COORD_UV:
	tobj->coord = HSD_Index2TexCoord(texcoord_no ++);
        break;
      default:
	break;
      }
    }
  }

#if FUJITA
  //Of[VB
  //ʏeNX`̈ԍŌB
  if( gradation ){
	gradation->id = HSD_Index2TexMap(texmap_no++);
    gradation->coord = HSD_Index2TexCoord(texcoord_no++);
    gradation->mtxid = HSD_TexMapID2PTTexMtx(gradation->id);
  }
  if( backlight ){
	backlight->id = HSD_Index2TexMap(texmap_no++);
    backlight->coord = HSD_Index2TexCoord(texcoord_no++);
    //backlight->mtxid = HSD_TexMapID2PTTexMtx(backlight->id);
	backlight->mtxid = GX_TEXMTX9;//bump͎gȂȂB
  }
#endif
#if FUJITA
  //VhE
  if (shadow) {
	//shadowpB
	shadow->id = HSD_Index2TexMap(texmap_no);
    shadow->coord = HSD_Index2TexCoord(texcoord_no);
    shadow->mtxid = HSD_TexMapID2PTTexMtx(shadow->id);

	//zpɂPmۂĂ܂B
    texcoord_no += 2;
	texmap_no += 2;
  }
#endif
  //ov
  if (bump) {
    bump->id = HSD_Index2TexMap(texmap_no ++);
    bump->mtxid = GX_TEXMTX9;
    bump->coord = HSD_Index2TexCoord(texcoord_no);
    texcoord_no += 2;
  }
  //gE[
  if (toon) {
    toon->id = HSD_Index2TexMap(texmap_no ++);
    toon->coord = HSD_Index2TexCoord(texcoord_no ++);
  }

  return (int) texcoord_no;
}

static int
DifferentTluts(HSD_Tlut *t0, HSD_Tlut *t1)
{
  return (t0->lut != t0->lut) ||
//  	 (t0->fmt != t1->fmt) ||
  	 (t0->n_entries != t1->n_entries);
}

/*
 * (J֐)
 * 
 * TObj ݒ
 */
void
HSD_TObjSetup(HSD_TObj *tobj)
{
  GXTlutObj tlutobj;
  GXTexObj texobj;
  int num;
  HSD_Tlut *tluts[8];
  int nb_tluts = 0;
  u32 tlut_name = GX_TLUT0;
  u32 big_tlut_name = GX_BIGTLUT0;
  int i;
  
  tobj_head = tobj;

  if (tobj == NULL)
    return;

  num = HSD_TObjAssignResources(tobj);
  if (num > 0) {
    HSD_StateRegisterTexGen(HSD_Index2TexCoord(num - 1u));
  }

  for (; tobj; tobj = tobj->next) {
    static HSD_TexLODDesc default_lod = {
      GX_LIN_MIP_LIN,
      0.0F,
      GX_FALSE,
      GX_FALSE,
      GX_ANISO_1,
    };
    HSD_TexLODDesc *lod;
    HSD_ImageDesc *imagedesc = tobj->imagedesc;
    GXTexFilter min_filter;

    if (tobj->id == GX_TEXMAP_NULL)
      continue;

    TObjSetupMtx(tobj);
    assert(imagedesc);
    assert(imagedesc->image_ptr);

    lod = tobj->lod != NULL ? tobj->lod : &default_lod;
    min_filter = lod->minFilt;

    switch (imagedesc->format) {
    case GX_TF_C4:     case GX_TF_C8:     case GX_TF_C14X2:
      {
	HSD_Tlut *tlut;

	if (tobj->tlut_no != (u8) -1) {
	  tlut = tobj->tluttbl[tobj->tlut_no];
	} else {
	  tlut = tobj->tlut;
	}

	assert(tlut);

	/*
	 * łɓTLUT[hĂ邩`FbNB
	 */

	for (i=0; i<nb_tluts; i++) {
	  if (!DifferentTluts(tluts[i], tlut)) {
	    break;
	  }
	}
	if (i < nb_tluts) {
	  /*
	   * łɃ[hĂΓTLUT NAMEėpB
	   */
	  tlut->tlut_name = tluts[i]->tlut_name;
	} else if (nb_tluts < 8) {
	  /*
	   * ߂ĂTLUT̏ꍇɂ̓GgɉGX_TLUT[0-15]܂́A
	   * GX_BIGTLUT[0-3]蓖ĂB
	   */
	  if (tlut->n_entries > 256) {
	    tlut->tlut_name = big_tlut_name ++;
	  } else {
	    tlut->tlut_name = tlut_name ++;
	  }
	  GXInitTlutObj(&tlutobj, tlut->lut, tlut->fmt, tlut->n_entries);
	  GXLoadTlut(&tlutobj, tlut->tlut_name);
	  tluts[nb_tluts++] = tlut;
	} else {
	  /*
	   * TLUTW𒴂ꍇ
	   */
	  tlut->tlut_name = GX_TLUT0;
	}

	GXInitTexObjCI(&texobj, imagedesc->image_ptr,
		       imagedesc->width, imagedesc->height,
		       (GXCITexFmt)imagedesc->format,
		       tobj->wrap_s, tobj->wrap_t,
		       imagedesc->mipmap? GX_TRUE : GX_FALSE,
		       tlut->tlut_name);
	if (min_filter == GX_LIN_MIP_LIN) {
	  /*
	   * It is not compatible with CI texture
	   */
	  min_filter = GX_LIN_MIP_NEAR;
	}
      }
      break;

    case GX_TF_I4:     case GX_TF_I8:     case GX_TF_IA4:   case GX_TF_IA8:
    case GX_TF_RGB565: case GX_TF_RGB5A3: case GX_TF_RGBA8: case GX_TF_CMPR:
      GXInitTexObj(&texobj, imagedesc->image_ptr,
		   imagedesc->width, imagedesc->height, imagedesc->format, 
		   tobj->wrap_s, tobj->wrap_t,
		   imagedesc->mipmap? GX_TRUE : GX_FALSE);
      break;

    default:
      assert(0);
    }

    if (!imagedesc->mipmap) {
      min_filter &= 0x01;
    }
    GXInitTexObjLOD(&texobj, min_filter, tobj->magFilt, 
					imagedesc->minLOD, imagedesc->maxLOD, lod->LODBias,
					lod->bias_clamp, lod->edgeLODEnable, lod->max_aniso);

#if FUJITA
	//eꍇɂ́AzeNX`ǂݍށB
	if(tobj_coord(tobj) == TEX_COORD_SHADOW ){
	  GXTexObj r;
	  //zeNX`B
	  //̈ł悢B
	  if( !RampTex ){
		RampTex = CreateRampTex8();
	  }

      GXInitTexObj(&r, RampTex->imagedesc->image_ptr,
				   RampTex->imagedesc->width, RampTex->imagedesc->height, 
				   RampTex->imagedesc->format, 
				   RampTex->wrap_s, RampTex->wrap_t,
				   RampTex->imagedesc->mipmap? GX_TRUE : GX_FALSE);
	  GXInitTexObjLOD(&r, GX_NEAR, GX_NEAR, 0, 0, 0, 0, 0, GX_ANISO_1);
	  GXLoadTexObj(&r, tobj->id);

	  GXLoadTexObj(&texobj, (GXTexMapID)(tobj->id+1));
	}else{
	  GXLoadTexObj(&texobj, tobj->id);
	}
#else
    GXLoadTexObj(&texobj, tobj->id);
#endif
  }
}
 
/**
 * GXTexGenSrc̒_eNX`W GX_TG_TEX0 ` GX_TG_TEX7 
 * ΉCfbNX𓾂B
 * 
 * <pre>
 * idx | tgtex
 * ----+------------
 *  0  | GX_TG_TEX0
 *  1  | GX_TG_TEX1
 *  2  | GX_TG_TEX2
 *  3  | GX_TG_TEX3
 *  4  | GX_TG_TEX4
 *  5  | GX_TG_TEX5
 *  6  | GX_TG_TEX6
 *  7  | GX_TG_TEX7
 * </pre>
 * 
 * @warning
 * tgtexLȊȌꍇassertB
 */
u32
HSD_TGTex2Index(GXTexGenSrc tgtex)
{
  switch (tgtex) {
  case GX_TG_TEX0: return 0;
  case GX_TG_TEX1: return 1;
  case GX_TG_TEX2: return 2;
  case GX_TG_TEX3: return 3;
  case GX_TG_TEX4: return 4;
  case GX_TG_TEX5: return 5;
  case GX_TG_TEX6: return 6;
  case GX_TG_TEX7: return 7;
  default: assert(0);
  }
  return GX_TG_TEX0;
}

/**
 * GXTexCoordIDΉGXTexGenSrcl𓾂B
 * 
 * <pre>
 *      coord    |   return val
 * --------------+------------------
 *  GX_TEXCOORD0 | GX_TG_TEXCOORD0
 *  GX_TEXCOORD1 | GX_TG_TEXCOORD1
 *  GX_TEXCOORD2 | GX_TG_TEXCOORD2
 *  GX_TEXCOORD3 | GX_TG_TEXCOORD3
 *  GX_TEXCOORD4 | GX_TG_TEXCOORD4
 *  GX_TEXCOORD5 | GX_TG_TEXCOORD5
 *  GX_TEXCOORD6 | GX_TG_TEXCOORD6
 *  GX_TEXCOORD7 | GX_TG_TEXCOORD7
 * </pre>
 *
 * @warning
 *  coord ɗ^ꂽlLɊ܂܂ȂꍇAassertB
 */
GXTexGenSrc
HSD_TexCoordID2TexGenSrc(GXTexCoordID coord)
{
  switch (coord) {
  case GX_TEXCOORD0: return GX_TG_TEXCOORD0;
  case GX_TEXCOORD1: return GX_TG_TEXCOORD1;
  case GX_TEXCOORD2: return GX_TG_TEXCOORD2;
  case GX_TEXCOORD3: return GX_TG_TEXCOORD3;
  case GX_TEXCOORD4: return GX_TG_TEXCOORD4;
  case GX_TEXCOORD5: return GX_TG_TEXCOORD5;
  case GX_TEXCOORD6: return GX_TG_TEXCOORD6;
  case GX_TEXCOORD7:
  default: 
    assert(0);
  }
  return GX_TG_TEXCOORD0;
}

/**
 * GXTexCoordIDΉCfbNX擾B
 * 
 * <pre>
 *   idx  | GXTexCoordID
 * -------+---------------
 *    0   | GX_TEXCOORD0
 *    1   | GX_TEXCOORD1
 *    2   | GX_TEXCOORD2
 *    3   | GX_TEXCOORD3
 *    4   | GX_TEXCOORD4
 *    5   | GX_TEXCOORD5
 *    6   | GX_TEXCOORD6
 *    7   | GX_TEXCOORD7
 * </pre>
 * 
 * @warning
 *  coord_id ɗ^ꂽlLɊ܂܂ȂꍇAassertB
 * 
 * @see HSD_Index2TexCoord
 */
u32
HSD_TexCoord2Index(GXTexCoordID coord_id)
{
  switch (coord_id) {
  case GX_TEXCOORD0: return 0;
  case GX_TEXCOORD1: return 1;
  case GX_TEXCOORD2: return 2;
  case GX_TEXCOORD3: return 3;
  case GX_TEXCOORD4: return 4;
  case GX_TEXCOORD5: return 5;
  case GX_TEXCOORD6: return 6;
  case GX_TEXCOORD7: return 7;
  default: assert(0);
  }
  return GX_TEXCOORD0;
}

/**
 * CfbNXΉGXTexCoordIDl𓾂B
 * 
 * ΉHSD_TexCoord2IndexQƁB
 * 
 * @see HSD_TexCoord2Index
 */
GXTexCoordID
HSD_Index2TexCoord(u32 index)
{
  switch (index) {
  case 0: return GX_TEXCOORD0;
  case 1: return GX_TEXCOORD1;
  case 2: return GX_TEXCOORD2;
  case 3: return GX_TEXCOORD3;
  case 4: return GX_TEXCOORD4;
  case 5: return GX_TEXCOORD5;
  case 6: return GX_TEXCOORD6;
  case 7: return GX_TEXCOORD7;
  default: assert(0);
  }
  return GX_TEXCOORD0;
}

/**
 * GXTexMtxΉCfbNXl擾B
 * 
 * <pre>
 *   idx | GXTexMtx
 *  -----+------------
 *    0  | GX_TEXMTX0
 *    1  | GX_TEXMTX1
 *    2  | GX_TEXMTX2
 *    3  | GX_TEXMTX3
 *    4  | GX_TEXMTX4
 *    5  | GX_TEXMTX5
 *    6  | GX_TEXMTX6
 *    7  | GX_TEXMTX7
 *    8  | GX_TEXMTX8
 *    9  | GX_TEXMTX9
 *   10  | GX_IDENTITY
 * </pre>
 *
 * @warning
 * ̒lLɊ܂܂ȂꍇassertB
 * 
 * @see HSD_Index2TexMtx
 */
u32
HSD_TexMtx2Index(GXTexMtx texmtx)
{
  switch (texmtx) {
  case GX_TEXMTX0: return 0;
  case GX_TEXMTX1: return 1;
  case GX_TEXMTX2: return 2;
  case GX_TEXMTX3: return 3;
  case GX_TEXMTX4: return 4;
  case GX_TEXMTX5: return 5;
  case GX_TEXMTX6: return 6;
  case GX_TEXMTX7: return 7;
  case GX_TEXMTX8: return 8;
  case GX_TEXMTX9: return 9;
  case GX_IDENTITY: return 10;
  default:
    HSD_Halt("specified texmtx id desn't exist.\n");
  }
  return (u32) -1;
}

/**
 * CfbNXΉGXTexMtxl𓾂B
 * 
 * ΉHSD_TexMtx2Index()QƁB
 * 
 * @warning
 * indexɑΉlꍇassertB
 * 
 * @see HSD_TexMtx2Index
 */
GXTexMtx
HSD_Index2TexMtx(u32 index)
{
  switch (index) {
  case 0: return GX_TEXMTX0;
  case 1: return GX_TEXMTX1;
  case 2: return GX_TEXMTX2;
  case 3: return GX_TEXMTX3;
  case 4: return GX_TEXMTX4;
  case 5: return GX_TEXMTX5;
  case 6: return GX_TEXMTX6;
  case 7: return GX_TEXMTX7;
  case 8: return GX_TEXMTX8;
  case 9: return GX_TEXMTX9;
  case 10: return GX_IDENTITY;
  default:
    HSD_Report("texmtx index exceed hardware limit (%d).\n", index);
    HSD_Halt("");
  }
  return GX_IDENTITY;
}

/**
 * CfbNXΉGXTexMapID𓾂B
 * 
 * <pre>
 *  idx |  GXTexMapID
 * -----+--------------
 *   0  |  GX_TEXMAP0
 *   1  |  GX_TEXMAP1
 *   2  |  GX_TEXMAP2
 *   3  |  GX_TEXMAP3
 *   4  |  GX_TEXMAP4
 *   5  |  GX_TEXMAP5
 *   6  |  GX_TEXMAP6
 *   7  |  GX_TEXMAP7
 * </pre>
 * 
 * @warning
 * ɑΉGXTexMapIDꍇassertB
 * 
 * @see HSD_TexMap2Index
 */
GXTexMapID
HSD_Index2TexMap(u32 index)
{
  switch (index) {
  case 0: return GX_TEXMAP0;
  case 1: return GX_TEXMAP1;
  case 2: return GX_TEXMAP2;
  case 3: return GX_TEXMAP3;
  case 4: return GX_TEXMAP4;
  case 5: return GX_TEXMAP5;
  case 6: return GX_TEXMAP6;
  case 7: return GX_TEXMAP7;
  default: assert(0);
  }
  return GX_TEXMAP0;
}

/**
 * GXTexMapIDΉCfbNXl擾B
 * 
 * ΉHSD_Index2TexMap()QƁB
 * 
 * @see HSD_Index2TexMap
 */
u32
HSD_TexMap2Index(GXTexMapID mapid)
{
  switch (mapid) {
  case GX_TEXMAP0: return 0;
  case GX_TEXMAP1: return 1;
  case GX_TEXMAP2: return 2;
  case GX_TEXMAP3: return 3;
  case GX_TEXMAP4: return 4;
  case GX_TEXMAP5: return 5;
  case GX_TEXMAP6: return 6;
  case GX_TEXMAP7: return 7;
  default: assert(0);
  }
  return 0;
}

/**
 * 1 tobj Ƃ̉̍\̂폜
 * 
 * @see HSD_TObjRemoveAll
 */
void
HSD_TObjRemove(HSD_TObj *tobj)
{
  hsdDelete(tobj);
}

/**
 * AꂽׂĂ tobj Ƃ̉̊Kw폜
 * 
 * @see HSD_TObjRemove
 */
void
HSD_TObjRemoveAll(HSD_TObj *tobj)
{
  while (tobj) {
    HSD_TObj *next = tobj->next;
    HSD_TObjRemove(tobj);
    tobj = next;
  }
}

/**
 * tobj  next 擾
 */
HSD_TObj *
HSD_TObjGetNext(HSD_TObj *tobj)
{
  if (tobj == NULL)
    return NULL;

  return tobj->next;
}

/**
 * tobj  next  new N
 */
void
HSD_TObjAddNext(HSD_TObj *tobj, HSD_TObj *new)
{
  if (tobj == NULL || new == NULL)
    return;

  new->next = tobj->next;
  tobj->next = new;
}

/**
 * ftHgNX̎w
 * 
 * tobjƂăftHgŐIuWFNg̃NXw肷B
 * 
 * włNXhsdTObjA̓oNXłȂ΂ȂȂB
 * 
 * @see HSD_TObjGetDefaultClass
 * @see HSD_TObjAlloc
 * @see HSD_TObjLoadDesc
 */
void
HSD_TObjSetDefaultClass(HSD_TObjInfo *info)
{
  if (info) {
    assert(hsdIsDescendantOf(info, &hsdTObj));
  }
  default_class = info;
}

/**
 * ftHgNX̎擾
 * 
 * tobjƂăftHgŐIuWFNg̃NX擾B
 * 
 * @see HSD_TObjSetDefaultClass
 * @see HSD_TObjAlloc
 * @see HSD_TObjLoadDesc
 */
HSD_TObjInfo *
HSD_TObjGetDefaultClass(void)
{
  return default_class? default_class : &hsdTObj;
}

/**
 * tobj P쐬
 * 
 * @see HSD_TObjRemove
 * @see HSD_TObjSetDefaultClass
 */
HSD_TObj *
HSD_TObjAlloc(void)
{
#if !FUJITA
  HSD_TObj *new = hsdNew(HSD_TObjGetDefaultClass());
  assert(new);
  return new;
#else
  HSD_TObj *n = hsdNew(HSD_TObjGetDefaultClass());
  assert(n);
  return n;
#endif
}

/**
 * tobj j
 * 
 * @warning
 * {֐̓olȂBʏ̍폜ɂHSD_TObjRemove()
 * gp邱ƁB
 *
 * @see HSD_TObjRemove
 */
void
HSD_TObjFree(HSD_TObj *tobj)
{
  if (tobj) HSD_CLASS_METHOD(tobj)->destroy(HSD_CLASS(tobj));
}

/**
 * Tlut 1쐬
 * 
 * @see HSD_TlutRemove
 * @see HSD_TlutLoadDesc
 */
HSD_Tlut *
HSD_TlutAlloc(void)
{
  HSD_Tlut *tlut = hsdAllocMemPiece(sizeof(HSD_Tlut));
  assert(tlut);
  memset(tlut, 0, sizeof(HSD_Tlut));
  return tlut;
}

/**
 * Tlut jB
 * 
 * @warning
 * {֐̓olȂBʏ̍폜ɂHSD_TlutRemove()
 * gp邱ƁB
 *
 * @see HSD_TlutRemove
 */
void
HSD_TlutFree(HSD_Tlut *tlut)
{
  hsdFreeMemPiece(tlut, sizeof(HSD_Tlut));
}

/**
 * Tlut 폜B
 * 
 * @see HSD_TlutAlloc
 * @see HSD_TlutLoadDesc
 */
void
HSD_TlutRemove(HSD_Tlut *tlut)
{
  if (tlut) {
    HSD_TlutFree(tlut);
  }
}

/**
 * TObjTev 1쐬
 * 
 * @see HSD_TObjTevRemove
 */
HSD_TObjTev *
HSD_TObjTevAlloc(void)
{
  HSD_TObjTev *tev = hsdAllocMemPiece(sizeof(HSD_TObjTev));
  assert(tev);
  memset(tev, 0, sizeof(HSD_TObjTev));
  return tev;
}

/**
 * TObjTev j
 * 
 * @warning
 * {֐̓olȂBʏ̍폜ɂHSD_TObjTevRemove()
 * gp邱ƁB
 * 
 * @see HSD_TObjTevRemove
 */
void
HSD_TObjTevFree(HSD_TObjTev *tev)
{
  hsdFreeMemPiece(tev, sizeof(HSD_TObjTev));
}

/**
 * TObjTev 폜
 *
 * @see HSD_TObjTevAlloc
 * @see HSD_TObjTevLoadDesc
 */
void
HSD_TObjTevRemove(HSD_TObjTev *tev)
{
  if (tev) {
    HSD_TObjTevFree(tev);
  }
}

/**
 * ImageDesc 1쐬
 * 
 * @see HSD_ImageDescRemove
 */
HSD_ImageDesc *
HSD_ImageDescAlloc(void)
{
  HSD_ImageDesc *idesc = hsdAllocMemPiece(sizeof(HSD_ImageDesc));
  assert(idesc);
  memset(idesc, 0, sizeof(HSD_ImageDesc));
  return idesc;
}

/**
 * ImageDesc j
 * 
 * @warning
 * {֐̓olȂBʏ̍폜ɂHSD_ImageDescRemove()
 * gp邱ƁB
 * 
 * @see HSD_ImageDescRemove
 */
void
HSD_ImageDescFree(HSD_ImageDesc *idesc)
{
  hsdFreeMemPiece(idesc, sizeof(HSD_ImageDesc));
}

/**
 * ImageDesc 폜
 * 
 * @see HSD_ImageDescAlloc
 */
void
HSD_ImageDescRemove(HSD_ImageDesc *idesc)
{
  HSD_ImageDescFree(idesc);
}

/**
 * EFBeNX`C[WRs[B
 * 
 *  origx  origy ɂ́AEFBł̍̃sNZʒuw肷B
 * Rs[镝э̓Rs[̃C[W̃TCYɂČ܂B
 * 
 * EFBeNX`𐶐΂AeNX`̕э͂Ƃ
 * Q̔{łȂ΂ȂȂB
 * 
 * sync  1 w肵ꍇAeNX`̃Rs[܂
 * GX߂̔s҂B܂AeNX`LbV𖳌
 * ꂽeNX`񐳂gp悤ɂB
 * ̃eNX`ꍇ͍Ō1xs΂悢B
 *
 * @warning
 * C[W̃XP[O͏oȂBvO}́AeNX`C[W
 * TCYlăr[|[gݒ肵Ȃ΂ȂȂB
 *
 * @param idesc		eNX`C[Wւ̃|C^
 * @param origx		Rs[̊Jnʒu x W
 *                      (2̔{łȂ΂ȂȂ)
 * @param origy		Rs[̊Jnʒu y W
 *                      (2̔{łȂ΂ȂȂ)
 * @param clear		Rs[EFBNA
 * @param sync		Rs[܂ŁAGX߂҂
 */
void
HSD_ImageDescCopyFromEFB(HSD_ImageDesc *idesc,
			 u16 origx, u16 origy,
			 GXBool clear, int sync)
{
  if (!idesc) return;

  GXSetTexCopySrc(origx, origy, idesc->width, idesc->height);
  GXSetTexCopyDst(idesc->width, idesc->height, idesc->format,
  		  idesc->mipmap? GX_TRUE : GX_FALSE);
  if (clear) {
    HSD_StateSetZMode(GX_TRUE, GX_LEQUAL, GX_TRUE);
  }
  GXCopyTex(idesc->image_ptr, clear);
  if (sync) {
    GXPixModeSync();
    GXInvalidateTexAll();
  }
}

static int
TObjInit(HSD_Class *o)
{
  int res;

  if ((res = HSD_PARENT_INFO(&hsdTObj)->init(o)) >= 0) {
    HSD_TObj *tobj = HSD_TOBJ(o);

    tobj->anim_id = -1;

    return 0;
  }
  return res;
}

static void
TObjRelease(HSD_Class *o)
{
  HSD_TObj *tobj = HSD_TOBJ(o);

  HSD_AObjRemove(tobj->aobj);
  HSD_TlutRemove(tobj->tlut);
  HSD_TObjTevRemove(tobj->tev);
  if (tobj->tluttbl) {
    int i;
    for (i=0; tobj->tluttbl[i]; i++) {
      HSD_TlutRemove(tobj->tluttbl[i]);
    }
    HSD_Free(tobj->tluttbl);
  }

  HSD_PARENT_INFO(&hsdTObj)->release(o);
}

static void
TObjAmnesia(HSD_ClassInfo *info)
{
  if (info == HSD_CLASS_INFO(default_class)) {
    default_class = NULL;
  }
  if (info == HSD_CLASS_INFO(&hsdTObj)) {
    tobj_head = NULL;
  }
  HSD_PARENT_INFO(&hsdTObj)->amnesia(info);
}

static void
TObjInfoInit(void)
{
  hsdInitClassInfo(HSD_CLASS_INFO(&hsdTObj),
  		   HSD_CLASS_INFO(&hsdObj),
		   HSD_BASE_CLASS_LIBRARY,
		   "hsd_tobj",
		   sizeof(HSD_TObjInfo),
		   sizeof(HSD_TObj));
  
  HSD_CLASS_INFO(&hsdTObj)->init     = TObjInit;
  HSD_CLASS_INFO(&hsdTObj)->release  = TObjRelease;
  HSD_CLASS_INFO(&hsdTObj)->amnesia  = TObjAmnesia;
  HSD_TOBJ_INFO(&hsdTObj)->load      = TObjLoad;
  HSD_TOBJ_INFO(&hsdTObj)->make_texp = TObjMakeTExp;

  hsdTObj.make_mtx = MakeTextureMtx;
  hsdTObj.update   = TObjUpdateFunc;
}
