/*
 * Copyright 1999-2001 HAL Laboratory, Inc. All rights reserved.
 *
 * $Id: tobj.h,v 1.3 2004/07/27 02:14:30 TypeR Exp $
 */

#ifndef __SYSDOLPHIN_TOBJ_H__
#define __SYSDOLPHIN_TOBJ_H__

#include <dolphin.h>
#include "sysdolphin/baselib/config.h"
#include "sysdolphin/baselib/object.h"
#include "sysdolphin/baselib/struct.h"
#include "sysdolphin/baselib/texp.h"
#include "sysdolphin/baselib/fobj.h"

#ifdef __cplusplus
extern "C" {
#endif

#define MAX_TEXTURE 8

#define	HSD_A_T_TIMG	     1	/* eNX`p^p^ */
#define	HSD_A_T_TRAU	     2  /* eNX` Usړ */
#define	HSD_A_T_TRAV	     3  /* eNX` Vsړ */
#define	HSD_A_T_SCAU	     4  /* eNX` UXP[ */
#define	HSD_A_T_SCAV	     5  /* eNX` VXP[ */
#define HSD_A_T_ROTX	     6  /* eNX` X] */
#define HSD_A_T_ROTY	     7  /* eNX` Y] */
#define HSD_A_T_ROTZ	     8  /* eNX` Z] */
#define HSD_A_T_BLEND	     9  /* eNX` uh */
#define HSD_A_T_TCLT	    10  /* pbgAj[V*/
#define HSD_A_T_LOD_BIAS    11
#define HSD_A_T_KONST_R     12
#define HSD_A_T_KONST_G     13
#define HSD_A_T_KONST_B     14
#define HSD_A_T_KONST_A     15
#define HSD_A_T_TEV0_R      16
#define HSD_A_T_TEV0_G      17
#define HSD_A_T_TEV0_B      18
#define HSD_A_T_TEV0_A      19
#define HSD_A_T_TEV1_R      20
#define HSD_A_T_TEV1_G      21
#define HSD_A_T_TEV1_B      22
#define HSD_A_T_TEV1_A      23
#define HSD_A_T_TS_BLEND    24	/* eNX`VF[_𗘗pꍇ
				   uhl̃Aj[V */

typedef struct _HSD_TlutDesc {
  void          *lut;
  GXTlutFmt     fmt;
  u32           tlut_name;	/* gp */
  u16           n_entries;
} HSD_TlutDesc;

/*+
 * HSD_Tlut \̂̓eNX`̃pbgێ\̂łB
 */
typedef struct _HSD_Tlut {
  void          *lut;		/*+ eNX`bNAbve[u */
  GXTlutFmt     fmt;		/*+ tlut tH[}bg */
  u32           tlut_name;	/*+ tlut  (蓖Čʂi[) */
  u16           n_entries;	/*+ pbg */
} HSD_Tlut;

/*+
 * HSD_TexLODDesc\̂̓eNX`̃~bv}bvێ\̂łB
 */
typedef struct _HSD_TexLODDesc {
  GXTexFilter   minFilt;       /*+ texel/pixel <= 1.0̎ɗp
				 eNX`tB^[^Cv */
  f32           LODBias;       /*+ LODoCAXl */
  GXBool        bias_clamp;    /*+ bias_clamp */
  GXBool        edgeLODEnable; /*+ edge lod enable */
  GXAnisotropy  max_aniso;     /*+ anisotropictB^[ől */
} HSD_TexLODDesc;

/*+
 * HSD_ImageDesc\̂̓eNX`̃sNZێ\̂łB
 */
typedef struct _HSD_ImageDesc {
  void		 *image_ptr;	/*+ eNX`C[Wւ̃|C^ */
  u16		 width;		/*+ eNX`̕ */
  u16 		 height;	/*+ eNX`̍ */
  GXTexFmt	 format;	/*+ eNX`tH[}bg*/
  u32		 mipmap;	/*+ ̃tOTRUEmipmap */
  f32            minLOD;	/*+ LODŏlB0.0`10.0܂ł̕_l */
  f32            maxLOD;	/*+ LODőlB0.0`10.0܂ł̕_l */
} HSD_ImageDesc;

typedef struct {
  u8 color_op;
  u8 alpha_op;
  u8 color_bias;
  u8 alpha_bias;
  u8 color_scale;
  u8 alpha_scale;
  u8 color_clamp;
  u8 alpha_clamp;
  u8 color_a, color_b, color_c, color_d;
#define TOBJ_TEV_CC_KONST_RGB (0x01<<7|0)
#define TOBJ_TEV_CC_KONST_RRR (0x01<<7|1)
#define TOBJ_TEV_CC_KONST_GGG (0x01<<7|2)
#define TOBJ_TEV_CC_KONST_BBB (0x01<<7|3)
#define TOBJ_TEV_CC_KONST_AAA (0x01<<7|4)
#define TOBJ_TEV_CC_TEX0_RGB (0x01<<7|5)
#define TOBJ_TEV_CC_TEX0_AAA (0x01<<7|6)
#define TOBJ_TEV_CC_TEX1_RGB (0x01<<7|7)
#define TOBJ_TEV_CC_TEX1_AAA (0x01<<7|8)
  u8 alpha_a, alpha_b, alpha_c, alpha_d;
#define TOBJ_TEV_CA_KONST_R (0x01<<6|0)
#define TOBJ_TEV_CA_KONST_G (0x01<<6|1)
#define TOBJ_TEV_CA_KONST_B (0x01<<6|2)
#define TOBJ_TEV_CA_KONST_A (0x01<<6|3)
#define TOBJ_TEV_CA_TEX0_A (0x01<<6|4)
#define TOBJ_TEV_CA_TEX1_A (0x01<<6|5)
  GXColor konst, tev0, tev1;
  u32 active;
#define	TOBJ_TEVREG_ACTIVE_KONST_R	(0x01<<0)
#define	TOBJ_TEVREG_ACTIVE_KONST_G	(0x01<<1)
#define	TOBJ_TEVREG_ACTIVE_KONST_B	(0x01<<2)
#define	TOBJ_TEVREG_ACTIVE_KONST_A	(0x01<<3)
#define	TOBJ_TEVREG_ACTIVE_KONST \
(TOBJ_TEVREG_ACTIVE_KONST_R|TOBJ_TEVREG_ACTIVE_KONST_G \
 |TOBJ_TEVREG_ACTIVE_KONST_B|TOBJ_TEVREG_ACTIVE_KONST_A)
#define	TOBJ_TEVREG_ACTIVE_TEV0_R	(0x01<<4)
#define	TOBJ_TEVREG_ACTIVE_TEV0_G	(0x01<<5)
#define	TOBJ_TEVREG_ACTIVE_TEV0_B	(0x01<<6)
#define	TOBJ_TEVREG_ACTIVE_TEV0_A	(0x01<<7)
#define	TOBJ_TEVREG_ACTIVE_TEV0 \
(TOBJ_TEVREG_ACTIVE_TEV0_R|TOBJ_TEVREG_ACTIVE_TEV0_G \
 |TOBJ_TEVREG_ACTIVE_TEV0_B|TOBJ_TEVREG_ACTIVE_TEV0_A)
#define	TOBJ_TEVREG_ACTIVE_TEV1_R	(0x01<<8)
#define	TOBJ_TEVREG_ACTIVE_TEV1_G	(0x01<<9)
#define	TOBJ_TEVREG_ACTIVE_TEV1_B	(0x01<<10)
#define	TOBJ_TEVREG_ACTIVE_TEV1_A	(0x01<<11)
#define	TOBJ_TEVREG_ACTIVE_TEV1 \
(TOBJ_TEVREG_ACTIVE_TEV1_R|TOBJ_TEVREG_ACTIVE_TEV1_G \
 |TOBJ_TEVREG_ACTIVE_TEV1_B|TOBJ_TEVREG_ACTIVE_TEV1_A)
#define	TOBJ_TEVREG_ACTIVE_COLOR_TEV	(0x01<<30)
#define	TOBJ_TEVREG_ACTIVE_ALPHA_TEV	(0x01<<31)
} HSD_TObjTevDesc;

typedef struct {
  u8 color_op;
  u8 alpha_op;
  u8 color_bias;
  u8 alpha_bias;
  u8 color_scale;
  u8 alpha_scale;
  u8 color_clamp;
  u8 alpha_clamp;
  u8 color_a, color_b, color_c, color_d;
  u8 alpha_a, alpha_b, alpha_c, alpha_d;
  GXColor konst, tev0, tev1;
  u32 active;
} HSD_TObjTev;

typedef struct _HSD_TObjDesc {
  char		       *class_name;

  struct _HSD_TObjDesc *next;
  GXTexMapID           id;
  GXTexGenSrc          src;
  Vec                  rotate;
  Vec                  scale;
  Vec                  translate;
  GXTexWrapMode        wrap_s;
  GXTexWrapMode        wrap_t;
  u8                   repeat_s;
  u8                   repeat_t;
  u32		       flag;
  float                blending;
  GXTexFilter	       magFilt;		/*+ texel/pixel > 1.0̎ɗp
					  eNX`tB^[^Cv */
  HSD_ImageDesc	       *imagedesc;
  HSD_TlutDesc         *tlutdesc;
  HSD_TexLODDesc       *lod;		/*+ LODDescւ̃|C^ */
  HSD_TObjTevDesc      *tev;		/*+ TObjTevDescւ̃|C^ */
} HSD_TObjDesc;

/*+
 * HSD_TObj\̂Texture \\̂łB
 */
struct _HSD_TObj {
  HSD_Obj	    object;     /*+ Object\*/
		    
  struct _HSD_TObj  *next;      /*+ N*/
  GXTexMapID        id;         /*+ eNX`ID */
  GXTexGenSrc       src;        /*+ eNX`W̃\[X*/
  u32		    mtxid;      /*+ }gNXID */
  Quaternion        rotate;     /*+ eNX`]l */
  Vec               scale;      /*+ eNX`XP[l */
  Vec               translate;  /*+ eNX`s[gl */
  GXTexWrapMode     wrap_s;     /*+ sbv[h */
  GXTexWrapMode     wrap_t;     /*+ tbv[h */
  u8                repeat_s;   /*+ ss[gl */
  u8                repeat_t;   /*+ ts[gl */
  u16		    anim_id;	/*+ tobjdesc->id */

  u32               flag;	/*+ }bsO^Cv */
  /* Tex coord ̐^Cv */
# define TEX_COORD_UV           0  /*+ UV}bsO */
# define TEX_COORD_REFLECTION   1  /*+ tNV}bsO */
# define TEX_COORD_HILIGHT      2  /*+ nCCg}bsO */
# define TEX_COORD_SHADOW       3  /*+ VhE}bsO */
# define TEX_COORD_TOON 	4  /*+ Toon */
  //FUJITA(Of[VpɐV݁j
# define TEX_COORD_GRADATION	5
# define TEX_COORD_BACKLIGHT	6
# define TEX_COORD_MASK 	(0x0f) /* }XNl */
# define tobj_coord(T) ((T)->flag & TEX_COORD_MASK) /* }N*/

  /* tev ̍^Cv */
# define TEX_LIGHTMAP_DIFFUSE	(0x1<<4) /*+ diffuse}bv */
# define TEX_LIGHTMAP_SPECULAR	(0x1<<5) /*+ specular}bv */
# define TEX_LIGHTMAP_AMBIENT	(0x1<<6) /*+ ambient}bv */
# define TEX_LIGHTMAP_EXT	(0x1<<7) /*+ Reflection/Hilight  */
# define TEX_LIGHTMAP_SHADOW	(0x1<<8) /*+ shadow}bv */
# define TEX_LIGHTMAP_MASK \
  (TEX_LIGHTMAP_DIFFUSE \
   |TEX_LIGHTMAP_SPECULAR \
   |TEX_LIGHTMAP_AMBIENT \
   |TEX_LIGHTMAP_EXT \
   |TEX_LIGHTMAP_SHADOW) /* }XNl */
# define tobj_lightmap(T) ((T)->flag & TEX_LIGHTMAP_MASK) /* }N*/

# define TEX_COLORMAP_NONE		(0<<16) /*+ J[}bvȂ */
# define TEX_COLORMAP_ALPHA_MASK	(1<<16) /*+ At@}XN */
# define TEX_COLORMAP_RGB_MASK		(2<<16) /*+ RGB}XN */
# define TEX_COLORMAP_BLEND		(3<<16) /*+ uh */
# define TEX_COLORMAP_MODULATE		(4<<16) /*+ WCg */
# define TEX_COLORMAP_REPLACE		(5<<16) /*+ vCX */
# define TEX_COLORMAP_PASS		(6<<16) /*+ pX */
# define TEX_COLORMAP_ADD		(7<<16) /*+ Z */
# define TEX_COLORMAP_SUB		(8<<16) /*+ Z */
# define TEX_COLORMAP_MASK		(0x0f<<16) /* }XNl */
# define tobj_colormap(T) ((T)->flag & TEX_COLORMAP_MASK) /* }N*/

# define TEX_ALPHAMAP_NONE		(0<<20) /*+ At@}bvȂ */
# define TEX_ALPHAMAP_ALPHA_MASK	(1<<20) /*+ At@}XN */
# define TEX_ALPHAMAP_BLEND		(2<<20) /*+ uh */
# define TEX_ALPHAMAP_MODULATE		(3<<20) /*+ WCg */
# define TEX_ALPHAMAP_REPLACE		(4<<20) /*+ vCX */
# define TEX_ALPHAMAP_PASS		(5<<20) /*+ pX */
# define TEX_ALPHAMAP_ADD		(6<<20) /*+ Z */
# define TEX_ALPHAMAP_SUB		(7<<20) /*+ Z */
# define TEX_ALPHAMAP_MASK		(0x0f<<20) /* }XNl */
# define tobj_alphamap(T) ((T)->flag & TEX_ALPHAMAP_MASK) /* }N*/

# define TEX_BUMP			(0x1<<24) /*+ bump}bv */
# define tobj_bump(T) ((T)->flag & TEX_BUMP) /* }N */
# define TEX_MTX_DIRTY			(1<<31) /* internal use only */
  
  float             blending;   /*+ blend l */
  GXTexFilter	    magFilt;	/*+ texel/pixel > 1.0̎ɗp
				  eNX`tB^[^Cv */
  HSD_ImageDesc	    *imagedesc; /*+ ImageDescւ̃|C^ */
  HSD_Tlut          *tlut;      /*+ Tlutւ̃|C^ */
  HSD_TexLODDesc    *lod;	/*+ LODDescւ̃|C^ */
  struct _HSD_AObj  *aobj;      /*+ AObjւ̃|C^ */
  HSD_ImageDesc	    **imagetbl; /*+ eNX`XCb`pC[We[u */
  HSD_Tlut	    **tluttbl;	/*+ TLUTXCb`pe[u */
  u8		    tlut_no;	/*+ pbgAj[ṼJgtlutԍB
  				    (u8) -1 ̓JgtlutZbgĂȂ
				    Ƃ\B̏ꍇ̓o tlutgp
				    B */
  Mtx 		    mtx;        /*+ eNX`}gNX */
  GXTexCoordID	    coord;      /*+ eNX`Wo͐ */
  HSD_TObjTev       *tev;	/*+ iTevݒ */
};

typedef struct _HSD_TObjInfo {
  HSD_ObjInfo		parent;

  void (*make_mtx)	(HSD_TObj *tobj);
  int (*load)		(HSD_TObj *tobj, HSD_TObjDesc *desc);
  void (*make_texp)	(HSD_TObj *tobj,
  			 u32 lightmap,
			 u32 lightmap_done,
  			 HSD_TExp **c,
			 HSD_TExp **a,
			 HSD_TExp **list);
  void (*update)	(void *obj, u32 type, FObjData *val);

} HSD_TObjInfo;

typedef struct _HSD_TexAnim {
  struct _HSD_TexAnim  *next;
  GXTexMapID           id;
  struct _HSD_AObjDesc *aobjdesc;
  HSD_ImageDesc	       **imagetbl;
  HSD_TlutDesc	       **tluttbl;
  u16 		       nb_imagetbl;
  u16 		       nb_tluttbl;
} HSD_TexAnim;

#define HSD_TOBJ(o)		((HSD_TObj *)(o))
#define HSD_TOBJ_INFO(i)	((HSD_TObjInfo *)(i))
#define HSD_TOBJ_METHOD(o)	HSD_TOBJ_INFO(HSD_CLASS_METHOD(o))

extern HSD_TObjInfo hsdTObj;

#ifndef _NFUNCPROTO

void	  HSD_TObjRemoveAnim		(HSD_TObj *tobj);
void	  HSD_TObjRemoveAnimAll		(HSD_TObj *tobj);
void	  HSD_TObjRemoveAnimByFlags	(HSD_TObj *tobj, u32 flags);
void	  HSD_TObjRemoveAnimAllByFlags	(HSD_TObj *tobj, u32 flags);
void	  HSD_TObjAddAnim		(HSD_TObj *tobj, HSD_TexAnim *tanim);
void	  HSD_TObjAddAnimAll		(HSD_TObj *tobj, HSD_TexAnim *tanim);
void	  HSD_TObjReqAnimByFlags	(HSD_TObj *tobj,
					 float startframe, u32 flags);
void	  HSD_TObjReqAnimAllByFlags	(HSD_TObj *tobj,
					 float startframe, u32 flags);
void	  HSD_TObjReqAnim		(HSD_TObj *tobj, float startframe);
void	  HSD_TObjReqAnimAll		(HSD_TObj *tobj, float startframe);
void	  HSD_TObjAnim			(HSD_TObj *tobj);
void	  HSD_TObjAnimAll		(HSD_TObj *tobj);
HSD_TObj *HSD_TObjGetNext		(HSD_TObj *tobj);
HSD_TObj *HSD_TObjAlloc			(void);
void	  HSD_TObjFree			(HSD_TObj *tobj);
void	  HSD_TObjRemove		(HSD_TObj *tobj);
void	  HSD_TObjRemoveAll		(HSD_TObj *tobj);
void	  HSD_TObjAddNext		(HSD_TObj *tobj, HSD_TObj *next);

void	  HSD_TObjSetDefaultClass	(HSD_TObjInfo *info);
HSD_TObjInfo *HSD_TObjGetDefaultClass	(void);

HSD_Tlut *HSD_TlutLoadDesc		(HSD_TlutDesc *desc);
HSD_Tlut *HSD_TlutAlloc			(void);
void	  HSD_TlutFree			(HSD_Tlut *tlut);
void	  HSD_TlutRemove		(HSD_Tlut *tlut);

HSD_TObjTev *HSD_TObjTevLoadDesc	(HSD_TObjTevDesc *tev);
HSD_TObjTev *HSD_TObjTevAlloc		(void);
void	  HSD_TObjTevFree		(HSD_TObjTev *tev);
void	  HSD_TObjTevRemove		(HSD_TObjTev *tev);

HSD_TObj *HSD_TObjLoadDesc		(HSD_TObjDesc *desc);
void	  HSD_TObjSetup			(HSD_TObj *tobj);
void	  HSD_TObjSetupTextureCoordGen	(HSD_TObj *tobj);
void	  HSD_TObjSetupVolatileTev	(HSD_TObj *tobj, u32 rendermode);
int	  HSD_TObjAssignResources	(HSD_TObj *tobj_top);

HSD_ImageDesc *HSD_ImageDescAlloc	(void);
void	  HSD_ImageDescFree		(HSD_ImageDesc *idesc);
void	  HSD_ImageDescRemove		(HSD_ImageDesc *idesc);
void	  HSD_ImageDescCopyFromEFB	(HSD_ImageDesc *idesc,
					 u16 origx,
					 u16 origy,
					 GXBool clear,
					 int sync);

u32	     HSD_TexCoord2Index		(GXTexCoordID coord_id);
GXTexCoordID HSD_Index2TexCoord		(u32 index);
u32	     HSD_TexMap2Index		(GXTexMapID mapid);
GXTexMapID   HSD_Index2TexMap		(u32 index);
u32	     HSD_TGTex2Index		(GXTexGenSrc tgtex);
u32	     HSD_TexMtx2Index		(GXTexMtx texmtx);
GXTexMtx     HSD_Index2TexMtx		(u32 index);
GXTexGenSrc  HSD_TexCoordID2TexGenSrc	(GXTexCoordID coord);

/* INTERNAL USE ONLY */

HSD_TObj    *_HSD_TObjGetCurrentByType	(HSD_TObj *from, u32 mapping);
HSD_TObj    *HSD_TObjGetActiveByIndex	(int idx);

#endif // !_NFUNCPROTO

#ifdef __cplusplus
}
#endif

#endif /* __SYSDOLPHIN_TOBJ_H__ */
