////////////////////////////////////////////////////////////////////////////////
//
// Killer7 Viewer Task
//
// WK7ViewerTask.cpp
//
// Creator       : Kawakami Satoshi (GHM)
// Creation Date : 11/28/2002
//
////////////////////////////////////////////////////////////////////////////////

#define	__WK7VIEWERTASK_CPP__

//#include <dolphin.h>
//#include <sysdolphin\baselib.h>
#include ".\WK7ViewerTask.h"
#include ".\WK7MenuTask.h"
#include ".\WK7MainTask.h"
#include ".\WK7MainMenu.h"
#include ".\WK7GameInfo.h"
#include ".\WK7HitObj.h"
#include ".\K7App.h"
#include "..\Fujita\C_Font.h"
#include "..\Fujita\C_Shader.h"
#include ".\WK7Mirror.h"
#include ".\WK7Npc.h"
#include ".\WK7Sight.h"
#include ".\WK7Stage.h"
#include ".\WK7Chara.h"
#include ".\WK7Item.h"
#include ".\WK7SelectIF.h"
#include ".\WK7Shadow.h"
#include ".\WK7Zan.h"
#include "..\Matsu\mK7Flush.h"
#include "..\Matsu\mK7Dim.h"
#include "..\Matsu\mK7Noise.h"
#include ".\WK7CharaPresent.h"
#include "..\Yam\YK7Effect.h"
#include "..\Sato\SK7PanelBase.h"
#include "..\Sato\SK7Special.h"
#include "..\Sato\SK7Pack.h"
#include "..\Kaw\KK7BattleCtrl.h"
#include "..\fujita\c_radialblur.h"
#include ".\WK7Memo.h"
#include ".\WK7Event.h"
#include ".\WK7Fog.h"
#include "..\Matsu\MK7Movie.h"
#include "..\Matsu\MK7Proc.h"
#include "..\Yam\YK7EffectMessage2.h"

#define	VER						"1.32"
// 1.32   ... XyL[Ή
// 1.31   ... L̃t@C̑OɃ[gtH_w}
// 1.30   ... kւ
// 1.29   ... [vw肪ĂȂꍇ̃J̃[V̘AĐoOCB
// 1.28   ... [Vf[^ɖ肪ꍇA[jO\
// 1.27   ... f̃[VɃJ[VĂJ[VǂݍłȂƂɌĐ
//            A[JCuf[^̃o[W\
// 1.26   ... ff[^ǂ񂾍ہA[VifJjĂAق̃[VȂƂɌĐ
// 1.25   ... pX@ɐVo[Wǉ
// 1.24   ... I[r^ɓno[W(03/10/10)
// 1.23   ... Exit@\ǉ
// 1.22   ... ꕨΉ
// 1.21   ... CgҏW@\
// 1.20   ... Kw\\Hideon/offAJ^[QbgʒuJgKwɐݒ
// 1.19   ... eNX`AjĐ@\
// 1.18   ... }eAAjĐ@\
// 1.17   ... i{PҏWVFCv[VĐoOC
// 1.16.1 ... LAĐ̓ǂݍ݃oOC
// 1.16   ... 30fpsALAĐ
// 1.15   ... ԂҏWA\

//#define	AFTERIMAGE_TEST

struct WK7ViewerMenuItem{
	WK7ViewerTask::WK7ViewerMode	mMode;
	const char						*mpItem;
	const char						*mpOption;
};

static char motionRateStr    [64];
static char camWobbleScaleStr[64];

static WK7ViewerMenuItem	viewerMenuItem[] = {
	{ WK7ViewerTask::WK7VIEWERMODE_MODELSELECT            , "Model Load"          , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_MOTIONLOAD_MODELSELECT , "Motion Load"         , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_CAMMOTIONLOAD          , "Camera Motion Load"  , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_STAGELOAD              , "Stage Load"          , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_PLAYLOAD               , "Chara Geki Load"     , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_MOVIELOAD              , "Movie Play"          , NULL  },
//	{ WK7ViewerTask::WK7VIEWERMODE_SCREENTONE             , "Screen Tone"         , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_PERFMETER              , "Performance Meter"   , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_RENDERMEMORY           , "Memory Disp"         , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_SHADOW                 , "Shadow"              , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_TEXTURE                , "Texture"             , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_INFODISP               , "Information Disp"    , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_ORIGDISP               , "OriginAxis Disp"     , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_CAMTGTDISP             , "CameraTarget Disp"   , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_MOTIONLOOP             , "Motion Loop"         , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_DEFLIGHT               , "Default Light"       , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_MOTIONRATE             , "Motion Rate"         , motionRateStr     },
	{ WK7ViewerTask::WK7VIEWERMODE_CAMWOBBLE              , "Camera Wobble"       , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_CAMWOBBLESCALE         , "Camera Wobble Scale" , camWobbleScaleStr },
	{ WK7ViewerTask::WK7VIEWERMODE_CINEMASCOPE            , "Cinema Scope"        , "On" },
	{ WK7ViewerTask::WK7VIEWERMODE_WALKAREA               , "Walk Area"           , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_HITOBJCHECK            , "HitObj Check"        , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_STREAM                 , "Stream"              , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_GXWARNING              , "GX Warning"          , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_MODEINFO               , "Mode Info"           , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_PLAYENDSTOP            , "CharaGeki End Stop"  , "Off" },
	{ WK7ViewerTask::WK7VIEWERMODE_ZANDEBUGINFO           , "Zan Debug Info"      , "On"  },
	{ WK7ViewerTask::WK7VIEWERMODE_ZANLOAD                , "Zan Load"            , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_SYSMESLOAD             , "SysMes Load"         , NULL  },
	{ WK7ViewerTask::WK7VIEWERMODE_CHANGEDISK             , "Change Disk"         , NULL  },
#ifndef	ORBITAL
	{ WK7ViewerTask::WK7VIEWERMODE_EXIT                   , "Exit"                , NULL  },		// exit͕KŌ
#endif
};
#define	WK7VIEWERMENUMITEM_NUM		(sizeof(viewerMenuItem) / sizeof(WK7ViewerMenuItem))

WK7ViewerMenuItem* GetMenu(WK7ViewerTask::WK7ViewerMode mode);
WK7ViewerMenuItem* GetMenu(WK7ViewerTask::WK7ViewerMode mode)
{
	WK7ViewerMenuItem	*pItem;
	int					i;
	pItem = viewerMenuItem;
	for(i=0 ; i<WK7VIEWERMENUMITEM_NUM ; i++,pItem++){
		if( pItem->mMode==mode ){
			return pItem;
		}
	}
	return NULL;
}

#define	CAMWOBBLESCALE_UNIT		(100)

#ifndef	FILE_USB
// ǂݍ݂gcs
#define	READ_HD
#endif

#define	MODEL_TYPE				(0)
#define	STAGE_TYPE				(K7OBJTYPE_STG)
//#define	STAGE_TYPE				(K7OBJTYPE_PLAY|WK7PLAY_RES_MODEL)
#define	MOTION_TYPE				(K7MOT_ATTR)
#define	CAMMOTION_TYPE			(1|K7MOT_ATTR)
#define	LIGHT_TYPE				(2)

#define	mUsbServ				usbFile

#ifdef	USE_ISDOLVIEWER
#undef	READ_HD
#endif

#define	FILELIST_DISPMAX		(24)
//#define	FILELIST_DISPMAX		(20)
//#define	FILELIST_DISPMAX		(22)

#define	SCREEN_WIDTH			(640)
#define	SCREEN_HEIGHT			(480)

#define	DIRLIGHT_COLOR		{ 0xff, 0xff, 0xff, 0xff }					// color
//#define	DIRLIGHT_COLOR		{ 128, 128, 128, 0xff }					// color

static	HSD_WObjDesc shadow_dir_light_pos_wobjdesc = {
	NULL,
	{ 5.000000f, 5.000000f, 2.000000f },		// wobj position
};

static	float	dir_light_shininess = 50.0f;

static	HSD_LightDesc dir_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_LightDesc amb_light = {
	NULL,
	&dir_light,									// link
//	LOBJ_DIFFUSE,								// flags
//	LOBJ_AMBIENT,								// attnflags
	LOBJ_AMBIENT,								// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 0xff, 0xff, 0xff, 0xff },					// color
	NULL,										// position
	NULL,										// interest
	NULL,
};

static	HSD_LightDesc shadow_dir_light = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE|LOBJ_SPECULAR,	// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	DIRLIGHT_COLOR,		//{ 255, 255, 255, 0xff },					// color
	&shadow_dir_light_pos_wobjdesc,				// position
	NULL,
	&dir_light_shininess,
};

static HSD_SceneLightSet amb_lightset = {
	&amb_light,
	NULL,
};

static HSD_SceneLightSet dir_lightset = {
	&dir_light,
	NULL,
};

static HSD_SceneLightSet shadow_dir_lightset = {
	&shadow_dir_light,
	NULL,
};

static HSD_WObjDesc cameyepos   = {
	NULL,
	{ 0.0f, 20.0f, 20.0f, },
	NULL,
};
static HSD_WObjDesc caminterest = {
	NULL,
	{ 0.0f, 15.0f, 0.0f, },
	NULL,
};
static HSD_CameraDescPerspective camdesc = {
	NULL,
	0,
	1,
	{ 0,640,0,480 },
	{ 0,640,0,480 },
	&cameyepos,
	&caminterest,
	0.0f,
	NULL,
	0.1f,
	1000.0f,
	42.184677f,
	1.18f,
};

static HSD_SceneCameraSet camera_set = {
	(HSD_CameraDesc *)&camdesc,	// desc
	NULL,						// anim
};

HSD_FogDesc	fog_desc = {
	GX_FOG_LIN,					// fog type
	NULL,						// adjdesc
	2000.0f,					// startz
	5000.0f,					// endz
	{0x00,0x00,0x00,0x00},		// color
};
HSD_Fog		*fog = NULL;

bool WK7ViewerTask::CreateLObj(HSD_SceneLightSet *pLightSet)
{
	ReleaseLObj();
	ghmGcMemSetAllocName("C_LObj");
	if( pLightSet==NULL ){
		mpLObj       = new C_LObj(new (&dir_lightset       ) C_LightSet);
//		mpLObj       = new C_LObj(new (&amb_lightset       ) C_LightSet);
	}else{
		mpLObj       = new C_LObj(new (pLightSet           ) C_LightSet);
	}
	SetShadow();
	return true;
}

bool WK7ViewerTask::SetShadow(void)
{
	WK7SHADOW->SetEnable(true);
//	WK7SHADOW->SetEnable(mShadowTrigger);
	return true;
}

bool WK7ViewerTask::ReleaseLObj(void)
{
	GHM_SAFE_DELETE(mpLObj      );
	return true;
}

bool WK7ViewerTask::LoadModel(const char *pfilename)
{
	WK7ViewerModel	*pModel;
	ReleaseModel(mSelectModel);
	if( mSelectModel < 0 || mSelectModel > mModelNum ){
		mSelectModel = mModelNum;
	}
	if( mSelectModel < mModelNum ){
		pModel = GetModel(mSelectModel);
	}else{
		if( (pModel = CreateModel())!=NULL ){
			mModelNum++;
		}
	}
	if( pModel==NULL ){
		return false;
	}
	return pModel->LoadModel(pfilename);
}

bool WK7ViewerTask::LoadStage(const char *pfilename)
{
	if( ReleaseStageArchive()==false ){
		return false;
	}
	if( (mpStageArchive  = WK7Archive::Create())==NULL ){
		return false;
	}
	if( mpStageArchive->LoadArchiveB(pfilename)==false ){
		return false;
	}
	mpStageArchive->SetType(STAGE_TYPE);
	mpStageArchive->SetID  (0);
	WK7RenderObj::SetReserveFileName(pfilename);
	if( (mpStageObj=WK7RenderObj::CreateStage(0))==NULL ){
//	if( (mpStageObj=WK7RenderObj::CreatePlayRenderObj(K7OBJTYPE_PLAY|WK7PLAY_RES_MODEL,0))==NULL ){
		ReleaseStageArchive();
		return false;
	}
	if( (mpStage = mpStageObj->GetModel())==NULL ){
		ReleaseStageArchive();
		return false;
	}
	ghmGcMemSetAllocName("VTSTFN");
	mpStageFileName = (char *)K7AppSmallMemAlloc((int)(strlen(pfilename) + 1));
	if( mpStageFileName==NULL ){
		ReleaseStageArchive();
		return false;
	}
	mpStageObj->SetRenderFlag(true);
	strcpy(mpStageFileName,pfilename);
	HSD_CameraDesc		*pCameraDesc = mpStageArchive->GetCameraDesc("persp");
	if( pCameraDesc!=NULL ){
		WK7CAM->SetFar (pCameraDesc->common.ffar );
		WK7CAM->SetNear(pCameraDesc->common.nnear);
		switch( pCameraDesc->common.projection_type ){
		case	COBJ_PROJECTION_PERSPECTIVE:
			WK7CAM->SetFov(pCameraDesc->perspective.fov);
			break;
		default:
			break;
		}
	}
	
//	GXColor		col = { 0x00,0x00,0x00,0x00 };
//	mpStageObj->SetMaterialAmbientColorLE(col,WK7_TICK_PER_SEC * 2);
//	mpStageObj->SetMaterialDiffuseColorLE(col,WK7_TICK_PER_SEC * 2);
	
	return true;
}

bool WK7ViewerTask::LoadMotion(const char *pfilename)
{
	WK7ViewerModel		*pModel = GetModel(mSelectModel);
	if( pModel==NULL ){
		return false;
	}
	ReleaseMotionArchive(mSelectModel,mSelectMotion,false);
	return pModel->LoadMotion(mSelectMotion,pfilename);
}

#if 0
bool WK7ViewerTask::ReleaseModelArchive(void)
{
	WK7ViewerModel	*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	WK7ViewerModel	*pNext;
	while( pModel!=NULL ){
		pNext  = pModel->GetNext();
		delete pModel;
		pModel = pNext;
	}
	if( mpCharaObj!=NULL ){
		mMotionPlay = false;
		if( mpModel!=NULL ){
			mpModel->StopMotion();
			mpModel->StopShapeMotion();
			mpModel->DetachMotion();
			mpModel->DetachShapeMotion();
		}
		delete mpCharaObj;
		mpModelArchive = NULL;
		mpCharaObj     = NULL;
		mpModel        = NULL;
		mpCurrentJObj  = NULL;
	}else{
		GHM_SAFE_DELETE(mpModelArchive);
	}
	GHMGCMEM_SAFE_FREE(mpModelFileName);
	return true;
}
#endif

extern	HSD_CameraDescPerspective	defpers;
bool WK7ViewerTask::ReleaseStageArchive(void)
{
	WK7SHADOW->SetLight(NULL);
	if( mpStageObj!=NULL ){
		if( mpStage!=NULL ){
			mpStage->StopMotion();
		}
		WK7Stage::DeleteStage(mpStageObj);
		mpStageArchive = NULL;
		mpStageObj     = NULL;
		mpStage        = NULL;
	}else{
		GHM_SAFE_DELETE(mpStageArchive);
	}
	GHMGCMEM_SAFE_FREE(mpStageFileName);
	WK7CAM->SetFar (defpers.ffar );
	WK7CAM->SetNear(defpers.nnear);
	WK7CAM->SetFov (defpers.fov  );
	return true;
}

bool WK7ViewerTask::ReleaseMotionArchive(int mdlid,int motid,bool workRelease)
{
	WK7ViewerModel		*pModel = GetModel(mdlid);
	if( pModel==NULL ){
		return false;
	}
	return pModel->ReleaseMotion(motid,workRelease);
}

bool WK7ViewerTask::ReleaseModel(int id,bool workRelease)
{
	WK7ViewerModel	*pModel = GetModel(id);
	if( pModel==NULL ){
		return false;
	}
	if( id==mCurrentModel ){
		mpCurrentJObj = NULL;
	}
	if( workRelease==true ){
		delete pModel;
		mModelNum--;
	}else{
		if( pModel->ReleaseModel()==false ){
			return false;
		}
	}
	return true;
}

bool WK7ViewerTask::ReleaseModelAll(void)
{
	WK7ViewerModel	*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	WK7ViewerModel	*pNext;
	while( pModel!=NULL ){
		pNext  = pModel->GetNext();
		delete pModel;
		pModel = pNext;
	}
	mModelNum = 0;
	return true;
}

#if 0
bool WK7ViewerTask::ReleaseMotionArchiveAll(void)
{
	WK7ViewerModel	*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		pModel->ReleaseMotionAll();
		pModel = pModel->GetNext();
	}
	if( mpModel!=NULL ){
		mMotionPlay = false;
		mpModel->StopMotion();
		mpModel->StopMatMotion();
		mpModel->StopShapeMotion();
		mpModel->DetachMotion();
		mpModel->DetachMatMotion();
		mpModel->DetachShapeMotion();
	}
	WK7ViewerMotion		*pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	WK7ViewerMotion		*pNextMotion;
	while( pMotion!=NULL ){
		pNextMotion = pMotion->GetNext();
		delete pMotion;
		pMotion = pNextMotion;
	}
	mMotionNum = 0;
	return true;
}
#endif

bool WK7ViewerTask::LoadCamMotion(const char *pfilename)
{
	ReleaseCamMotionArchive();
	if( (mpCameraMotionArchive = WK7Archive::Create())==NULL ){
		return false;
	}
	mpCameraMotionArchive->SetType(CAMMOTION_TYPE);
	mpCameraMotionArchive->SetID  (0);
	if( mpCameraMotionArchive->LoadArchiveB(pfilename)==false ){
		GHM_SAFE_DELETE(mpCameraMotionArchive);
		return false;
	}
	if( (mpCameraMotion=mpCameraMotionArchive->CreateCameraMotion())==NULL ){
		GHM_SAFE_DELETE(mpCameraMotionArchive);
		return false;
	}
	ghmGcMemSetAllocName("VTCMFN");
	mpCameraMotionFileName = (char *)K7AppSmallMemAlloc((int)(strlen(pfilename) + 1));
	if( mpCameraMotionFileName==NULL ){
		ReleaseCamMotionArchive();
		return false;
	}
	strcpy(mpCameraMotionFileName,pfilename);
	return true;
}

bool WK7ViewerTask::ReleaseCamMotionArchive(void)
{
	if( mpCameraMotion!=NULL ){
		GHMGCMEM_SAFE_FREE(mpCameraMotionFileName);
		WK7CAM->StopMotion  ();
		WK7CAM->DetachMotion();
		delete mpCameraMotion;
		mpCameraMotion = NULL;
		mpCameraMotionArchive = NULL;
	}
	return true;
}

WK7ViewerPlay::WK7ViewerPlay(ghmGcListObj *pAnchor,int prio) : ghmGcListObj(pAnchor,prio)
{
	mpFileName = NULL;
	mpDirName  = NULL;
}

WK7ViewerPlay::~WK7ViewerPlay()
{
	GHM_SAFE_DELETE_ARRAY(mpFileName);
	GHM_SAFE_DELETE_ARRAY(mpDirName );
}

bool WK7ViewerPlay::SetFileName(const char *pfname)
{
	GHM_SAFE_DELETE_ARRAY(mpFileName);
	if( pfname==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("FileName");
	if( (mpFileName = new char[strlen(pfname) + 1])==NULL ){
		return false;
	}
	strcpy(mpFileName,pfname);
	return true;
}

bool WK7ViewerPlay::SetDirName(const char *pdirname)
{
	GHM_SAFE_DELETE_ARRAY(mpDirName);
	if( pdirname==NULL ){
		return true;
	}
	ghmGcMemSetAllocName("DirName");
	if( (mpDirName = new char[strlen(pdirname) + 1])==NULL ){
		return false;
	}
	strcpy(mpDirName,pdirname);
	return true;
}

bool WK7ViewerPlay::GetFullFileName(char *pfname)
{
	if( mpFileName==NULL ){
		return false;
	}
	strcpy(pfname,"/");
	if( mpDirName!=NULL ){
		strcat(pfname,mpDirName);
	}
	strcat(pfname,mpFileName);
	return true;
}

WK7ViewerPlay* WK7ViewerTask::GetPlay(int index)
{
	if( index < 0 ){
		return NULL;
	}
	WK7ViewerPlay		*pPlay = (WK7ViewerPlay *)mPlayAnchor.GetNext();
	
	while( index > 0 ){
		if( pPlay==NULL ){
			return NULL;
		}
		index--;
		pPlay = pPlay->GetNext();
	}
	return pPlay;
}

WK7ViewerPlay* WK7ViewerTask::CreatePlay(void)
{
	WK7ViewerPlay		*pPlay;
	int					lastPrio = GHMGCLIST_DEFAULT_PRIO-1;
	pPlay = (WK7ViewerPlay *)mPlayAnchor.GetNext();
	while( pPlay!=NULL ){
		WK7ViewerPlay		*pNext = pPlay->GetNext();
		if( pNext==NULL ){
			lastPrio = pPlay->GetPriority();
		}
		pPlay = pNext;
	}
	ghmGcMemSetAllocName("ViewerPl");
	if( (pPlay = new WK7ViewerPlay(&mPlayAnchor,lastPrio+1))==NULL ){
		return NULL;
	}
	mPlayNum++;
	return pPlay;
}

bool WK7ViewerTask::RemovePlay(int index)
{
	WK7ViewerPlay		*pPlay = GetPlay(index);
	if( pPlay==NULL ){
		return false;
	}
	delete pPlay;
	mPlayNum--;
	return true;
}

void WK7ViewerTask::ClearPlay(void)
{
	WK7ViewerPlay		*pPlay = (WK7ViewerPlay *)mPlayAnchor.GetNext();
	WK7ViewerPlay		*pNext;
	while( pPlay!=NULL ){
		pNext = pPlay->GetNext();
		delete pPlay;
		pPlay = pNext;
	}
	mPlayNum = 0;
}

bool WK7ViewerTask::SetMenuItem(WK7ViewerTask::WK7ViewerMode mode,bool flag)
{
	WK7ViewerMenuItem	*pMenuItem = GetMenu(mode);
	if( pMenuItem==NULL ){
		return false;
	}
	if( flag==true ){
		pMenuItem->mpOption = "On";
	}else{
		pMenuItem->mpOption = "Off";
	}
	return true;
}

bool WK7ViewerTask::SetInfoDisp(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_INFODISP,flag)==false ){
		return false;
	}
	mInfoDisp = flag;
	return true;
}

bool WK7ViewerTask::SetOrigDisp(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_ORIGDISP,flag)==false ){
		return false;
	}
	mOrigDisp = flag;
	return true;
}

bool WK7ViewerTask::SetCamTargetDisp(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_CAMTGTDISP,flag)==false ){
		return false;
	}
	mCamTargetDisp = flag;
	return true;
}

bool WK7ViewerTask::SetRenderMemory(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_RENDERMEMORY,flag)==false ){
		return false;
	}
	mRenderMemory = flag;
	ghmGcMem::SetRender      (mRenderMemory);
	return true;
}

bool WK7ViewerTask::SetPerfMeter(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_PERFMETER,flag)==false ){
		return false;
	}
	mPerfMeter = flag;
	k7app.SetVisiblePerfMeter(mPerfMeter);
	k7app.SetEnablePerfMeter (mPerfMeter);
	return true;
}

bool WK7ViewerTask::SetCamWobble(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_CAMWOBBLE,flag)==false ){
		return false;
	}
	mCamWobble = flag;
	WK7CAM->SetWobbleEnable(flag);
	return true;
}

bool WK7ViewerTask::SetCinemaScope(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_CINEMASCOPE,flag)==false ){
		return false;
	}
	mCinemaScope = flag;
	WK7CAM->SetCinemaScopeMode(flag);
	return true;
}

bool WK7ViewerTask::SetWalkArea(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_WALKAREA,flag)==false ){
		return false;
	}
	mainMenu.SetEneWalkArea(flag);
	return true;
}

bool WK7ViewerTask::SetHitObjCheck(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_HITOBJCHECK,flag)==false ){
		return false;
	}
	mHitObjCheck = flag;
	return true;
}

bool WK7ViewerTask::SetStream(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_STREAM,flag)==false ){
		return false;
	}
#ifdef _DEBUG
	if( flag==true ){
		gpSound->mSetSoundDebug(false);
	}else{
		gpSound->mSetSoundDebug(true);
	}
#endif
	mStreamFlag = flag;
	return true;
}

bool WK7ViewerTask::SetGXWarning(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_GXWARNING,flag)==false ){
		return false;
	}
	mainMenu.SetGxWarning(flag);
	return true;
}

bool WK7ViewerTask::SetModeInfo(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_MODEINFO,flag)==false ){
		return false;
	}
	mainMenu.SetModeInfo(flag);
	return true;
}

bool WK7ViewerTask::SetZanDebugInfo(bool flag)
{
	if( SetMenuItem(WK7VIEWERMODE_ZANDEBUGINFO,flag)==false ){
		return false;
	}
#ifdef	_DEBUG
	WK7Zan::SetDebugInfo(flag);
#endif
	return true;
}

WK7ViewerMotion::WK7ViewerMotion(ghmGcListObj *pAnchor,int prio) : ghmGcListObj(pAnchor,prio)
{
	mpArchive         = NULL;
	mpModelMotion     = NULL;
	mpCameraMotion    = NULL;
	mpFileName        = NULL;
	mInterpolate      = false;
	mInterpolateFrame = 10.0f;
}

WK7ViewerMotion::~WK7ViewerMotion()
{
	ReleaseMotion();
}

bool WK7ViewerMotion::ReleaseMotion(void)
{
	GHM_SAFE_DELETE   (mpCameraMotion);
	GHM_SAFE_DELETE   (mpModelMotion );
	GHMGCMEM_SAFE_FREE(mpFileName    );
	mpArchive         = NULL;
//	mInterpolate      = true;
	mInterpolateFrame = 10.0f;
	return true;
}

const char* WK7ViewerMotion::GetArchiveVersionStr(void)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = mpArchive->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mpVersionStr;
}

int WK7ViewerMotion::GetArchiveVersion(void)
{
	if( mpArchive==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = mpArchive->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mVersion;
}

bool	WK7ViewerModel::mMotionPlayAll  = false;
bool	WK7ViewerModel::mMotionPauseAll = false;
bool	WK7ViewerModel::mMotionLoopAll  = false;
u32		WK7ViewerModel::mModelIDSeed    = 0;
u32		WK7ViewerModel::mMotionIDSeed   = 0;
WK7ViewerModel::WK7ViewerModel(ghmGcListObj *pAnchor,int prio) : ghmGcListObj(pAnchor,prio)
{
	mpModelArchive    = NULL;
	mpCharaObj        = NULL;
	mpModel           = NULL;
	mpModelFileName   = NULL;
	mpModelMotion     = NULL;
	mpCameraMotion    = NULL;
	mCurrentMotion    = 0;
	mMotionNum        = 0;
	mMotionPlay       = false;
}

WK7ViewerModel::~WK7ViewerModel()
{
	ReleaseModel();
	ReleaseMotionAll();
}

bool WK7ViewerModel::RenderInfo(bool checked)
{
	const char			*pModelName;
	const char			*pModelVersionStr;
	const char			*pMotionName;
	const char			*pMotionVersionStr;
	WK7ViewerMotion		*pMotion;
	bool				motion;
	pModelVersionStr  = 
	pMotionVersionStr = "-.---";
	if( mpModelArchive!=NULL && (pModelName = GetArchiveVersionStr())!=NULL ){
		pModelVersionStr = pModelName;
	}
	if( mpModelFileName!=NULL ){
		pModelName = mpModelFileName;
	}else{
		pModelName = "---";
	}
	if( (pMotion = GetMotion(mCurrentMotion))==NULL ){
		if( mpModelMotion!=NULL ){
			pMotionVersionStr = pModelVersionStr;
			pMotionName = pModelName;
			motion      = true;
		}else{
			pMotionName = "---";
			motion      = false;
		}
	}else{
		if( (pMotionName = pMotion->GetArchiveVersionStr())!=NULL ){
			pMotionVersionStr = pMotionName;
		}
		if( pMotion!=NULL ){
			pMotionName = pMotion->mpFileName;
			motion      = true;
		}else{
			pMotionName = "---";
			motion      = false;
		}
	}
	PRINTF("%sModel  : %-5s %46s\n",checked==true? "*":" ",pModelVersionStr,pModelName);
	char	str[256];
	if( motion==true && mpModel!=NULL && mMotionPlay==true ){
		sprintf(str,"%s(%.1f,%.1f)",pMotionName,
		                            mpModel->GetCurrentMotionFrame(),
		                            mpModel->GetTotalMotionFrame  ());
	}else{
		sprintf(str,"%s(---,---)",pMotionName);
	}
	PRINTF("    Anm : %4s %46s\n",pMotionVersionStr,str);
	return true;
}

bool WK7ViewerModel::SetMotionLoopAll(bool flag)
{
	WK7ViewerMenuItem	*pMenuItem = GetMenu(WK7ViewerTask::WK7VIEWERMODE_MOTIONLOOP);
	if( pMenuItem!=NULL ){
		if( flag==true ){
			pMenuItem->mpOption = "On";
		}else{
			pMenuItem->mpOption = "Off";
		}
	}
	mMotionLoopAll = flag;
//	WK7CAM->SetMotionLoop(flag);
	return true;
}

bool WK7ViewerModel::SetMotionPauseAll(bool flag)
{
	mMotionPauseAll = flag;
	return true;
}

bool WK7ViewerModel::SetMotionPlayAll(bool flag)
{
	mMotionPlayAll = flag;
	if( flag==true ){
		SetMotionPauseAll(false);
	}
	return true;
}

#define	WK7VIEWERMODEL_DISPCOUNTER_MAX		(4800 * 3)
bool WK7ViewerModel::MotionControl(void)
{
	if( mpModel==NULL || mMotionPlay==false || mMotionPlayAll==false ){
		return false;
	}
	if( mDispCounter.IsAnimating()==false ){
		mDispCounter.SetValue(WK7VIEWERMODEL_DISPCOUNTER_MAX);
		mDispCounter.Play    (0,WK7VIEWERMODEL_DISPCOUNTER_MAX);
	}
	mDispCounter.FrameProcess();
	if( mpModel->GetMotionState()!=AOBJ_NO_ANIM ){
		return true;
	}
	// [VI
	int		count = 0;
	while( 1 ){
		mCurrentMotion++;
		if( mCurrentMotion >= mMotionNum ){
			mCurrentMotion = 0;
			if( mMotionLoopAll==false ){
				mMotionPlay = false;
				return true;
			}
		}
		if( PlayMotion()==false ){
			if( count > mMotionNum ){
				mMotionPlay = false;
				StopMotion();
				return false;
			}
			count++;
		}
		break;
	}
	return true;
}

bool WK7ViewerModel::RenderVersionCheck(bool anim)
{
	if( anim==false ){
		return true;
	}
	WK7ViewerMotion		*pMotion = GetMotion(mCurrentMotion);
	WK7SdExpInfo		*pSdExpInfo;
	const char			*pFileName;
	if( pMotion!=NULL && pMotion->mpArchive!=NULL ){
		pSdExpInfo = pMotion->mpArchive->GetSdExpInfo();
		pFileName  = pMotion->mpFileName;
	}else if( mpModelMotion!=NULL ){
		pSdExpInfo = mpModelMotion->GetSdExpInfo();
		pFileName  = mpModelFileName;
	}else if( mpCameraMotion!=NULL ){
		pSdExpInfo = mpCameraMotion->GetSdExpInfo();
		pFileName  = mpModelFileName;
	}else{
		return false;
	}
	if( mDispCounter.GetValue() >  WK7VIEWERMODEL_DISPCOUNTER_MAX / 3 ){
		char		str[512];
		if( pSdExpInfo==NULL || pFileName==NULL || pSdExpInfo->mVersion < 142 ){
			sprintf(str,"Warning : %s - Old Motion Data!",pFileName);
		}else if( pSdExpInfo->mCreateStartKey || pSdExpInfo->mCreateEndKey ){
			sprintf(str,"Warning : %s - Trouble Motion Data!",pFileName);
		}else{
			str[0] = '\0';
		}
		PRINTF(str);
	}
	return true;
}

bool WK7ViewerModel::ReleaseMotion(int index,bool workRelease)
{
	if( mpModel!=NULL && mCurrentMotion==index ){
		mMotionPlay = false;
		mpModel->StopMotionAll  ();
		mpModel->DetachMotionAll();
	}
	WK7ViewerMotion		*pMotion = GetMotion(index);
	if( pMotion==NULL ){
		return false;
	}
	if( workRelease==true ){
		delete pMotion;
		mMotionNum--;
	}else{
		if( pMotion->ReleaseMotion()==false ){
			return false;
		}
	}
	return true;
}

bool WK7ViewerModel::ReleaseMotionAll(void)
{
	if( mpModel!=NULL ){
		mMotionPlay = false;
		mpModel->StopMotionAll  ();
		mpModel->DetachMotionAll();
	}
	WK7ViewerMotion		*pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	WK7ViewerMotion		*pNextMotion;
	while( pMotion!=NULL ){
		pNextMotion = pMotion->GetNext();
		delete pMotion;
		pMotion = pNextMotion;
	}
	mMotionNum = 0;
	return true;
}

bool WK7ViewerModel::LoadModel(const char *pfilename)
{
	if( ReleaseModel()==false ){
		return false;
	}
	if( (mpModelArchive = WK7Archive::Create())==NULL ){
		return false;
	}
	if( mpModelArchive->LoadArchiveB(pfilename)==false ){
		return false;
	}
	u32		id = mModelIDSeed++;
	mpModelArchive->SetType(MODEL_TYPE);
	mpModelArchive->SetID  (id);
	if( (mpCharaObj=WK7RenderObj::CreateRenderObj(MODEL_TYPE,id))==NULL ){
		ReleaseModel();
		return false;
	}
	mpCharaObj->CreateLight();
//	mpCharaObj->SetMirrorType(WK7MODEL_MIRROR_Y);
//	mpCharaObj->CreateMirrorModel();
	if( (mpModel=mpCharaObj->GetModel())==NULL ){
		ReleaseModel();
		return false;
	}
	ghmGcMemSetAllocName("VTMDLFN");
	mpModelFileName = (char *)K7AppSmallMemAlloc((int)(strlen(pfilename) + 1));
	if( mpModelFileName==NULL ){
		ReleaseModel();
		return false;
	}
	
	mpModelMotion  = mpModelArchive->CreateModelMotion();
	mpCameraMotion = mpModelArchive->CreateCameraMotion();
	
	mpCharaObj->SetRenderFlag(true);
	// Ƃ肠
	mpCharaObj->SetPlayerRenderID();
	
	strcpy(mpModelFileName,pfilename);
//	mpCurrentJObj = mpModel->GetTopObj();
	mCurrentMotion = 0;
	
//	GXColor		col = { 0x00,0x00,0x00,0x00 };
//	mpCharaObj->SetMaterialAmbientColorLE(col,WK7_TICK_PER_SEC * 2);
//	mpCharaObj->SetMaterialDiffuseColorLE(col,WK7_TICK_PER_SEC * 2);
	
	return true;
}

WK7ViewerMotion* WK7ViewerModel::CreateMotion(void)
{
	WK7ViewerMotion		*pMotion;
	int					lastPrio = GHMGCLIST_DEFAULT_PRIO-1;
	pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	while( pMotion!=NULL ){
		WK7ViewerMotion		*pNext = pMotion->GetNext();
		if( pNext==NULL ){
			lastPrio = pMotion->GetPriority();
		}
		pMotion = pNext;
	}
	ghmGcMemSetAllocName("ViewerMt");
	return new WK7ViewerMotion(&mMotionAnchor,lastPrio+1);
}

bool WK7ViewerModel::LoadMotion(int index,const char *pfilename)
{
	ReleaseMotion(index,false);
	WK7ViewerMotion		*pMotion;
	if( index < 0 || index > mMotionNum ){
		index = mMotionNum;
	}
	if( index < mMotionNum ){
		pMotion = GetMotion(index);
	}else{
		if( (pMotion = CreateMotion())!=NULL ){
			mMotionNum++;
		}
	}
	if( pMotion==NULL ){
		return false;
	}
	if( (pMotion->mpArchive = WK7Archive::Create())==NULL ){
		return false;
	}
	if( pMotion->mpArchive->LoadArchiveB(pfilename)==false ){
		return false;
	}
	pMotion->mpArchive->SetType(MOTION_TYPE);
	pMotion->mpArchive->SetID  (mMotionIDSeed++);
	ghmGcMemSetAllocName("VTMDMTFN");
	pMotion->mpFileName = (char *)K7AppSmallMemAlloc((int)(strlen(pfilename) + 1));
	if( pMotion->mpFileName!=NULL ){
		strcpy(pMotion->mpFileName,pfilename);
	}
	pMotion->mpModelMotion  = pMotion->mpArchive->CreateModelMotion ();
	pMotion->mpCameraMotion = pMotion->mpArchive->CreateCameraMotion();
	return true;
}

bool WK7ViewerModel::ReleaseModel(void)
{
	if( mpModel!=NULL ){
		mpModel->StopMotionAll  ();
		mpModel->DetachMotionAll();
	}
	if( mpCameraMotion!=NULL ){
		WK7CAM->StopMotion  ();
		WK7CAM->DetachMotion();
		GHM_SAFE_DELETE(mpCameraMotion );
	}
	GHM_SAFE_DELETE   (mpModelMotion  );
	GHM_SAFE_DELETE   (mpCharaObj     );
	GHMGCMEM_SAFE_FREE(mpModelFileName);
	mpModelArchive = NULL;
	mpModel        = NULL;
	return true;
}

WK7CameraMotion* WK7ViewerModel::GetCurrentCamMotion(void)
{
	WK7ViewerMotion		*pMotion = GetMotion(mCurrentMotion);
	if( pMotion!=NULL && pMotion->mpCameraMotion!=NULL ){
		return pMotion->mpCameraMotion;
	}
	if( mpCameraMotion!=NULL ){
		return mpCameraMotion;
	}
	return NULL;
}

const char* WK7ViewerModel::GetCurrentCamMotionFileName(void)
{
	WK7ViewerMotion		*pMotion = GetMotion(mCurrentMotion);
	if( pMotion!=NULL && pMotion->mpCameraMotion!=NULL ){
		return pMotion->mpFileName;
	}
	if( mpCameraMotion!=NULL ){
		return mpModelFileName;
	}
	return NULL;
}

WK7ViewerMotion* WK7ViewerModel::GetMotion(int index)
{
	if( index < 0 ){
		return NULL;
	}
	WK7ViewerMotion		*pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	
	while( index > 0 ){
		if( pMotion==NULL ){
			return NULL;
		}
		index--;
		pMotion = pMotion->GetNext();
	}
	
	return pMotion;
}

bool WK7ViewerModel::PlayMotion(void)
{
	WK7ViewerMotion		*pMotion = GetMotion(mCurrentMotion);
	if( mpModel==NULL ){
		return false;
	}
	WK7ModelMotion		*pModelMotion;
	bool				ip;
	f32					ipframe;
	if( pMotion!=NULL ){
		pModelMotion = pMotion->mpModelMotion;
		ip           = pMotion->mInterpolate;
		ipframe      = pMotion->mInterpolateFrame;
	}else{
		pModelMotion = mpModelMotion;
		ip           = false;
		ipframe      = 0.0f;
	}
	if( pModelMotion==NULL ){
		return false;
	}
	bool	play = false;
	mpModel->StopMotionAll  ();
	mpModel->DetachMotionAll();
	if( mpModel->AttachMotion(pModelMotion)!=0 ){
		play = true;
	}
	if( mpModel->AttachMatMotion(pModelMotion)!=0 ){
		play = true;
	}
	if( mpModel->AttachShapeMotion(pModelMotion)!=0 ){
		play = true;
	}
	if( play==true ){
		mpModel->PlayMotionAll(0.0f,ip,ipframe);
		mpModel->SetMotionLoop(false);
	}
	mMotionPlay = play;
	return play;
}

bool WK7ViewerModel::StopMotion(void)
{
	mCurrentMotion = 0;
	mMotionPlay = false;
	if( mpModel==NULL ){
		return false;
	}
	mpModel->StopMotionAll  ();
	mpModel->DetachMotionAll();
	return true;
}

bool WK7ViewerModel::PauseMotion(void)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->StopMotionAll();
	return true;
}

bool WK7ViewerModel::ReplayMotion(void)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->ReplayMotionAll();
	return true;
}

bool WK7ViewerModel::SetPosition(Vec &pos)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->SetPosition(pos);
	return true;
}

bool WK7ViewerModel::SetRotY(f32 roty)
{
	if( mpModel==NULL ){
		return false;
	}
	mpModel->SetRotY(roty);
	return true;
}

bool WK7ViewerModel::SetDispLight(WK7Light *pLight,bool flag)
{
	if( mpCharaObj==NULL ){
		return false;
	}
	return mpCharaObj->SetDispLight(pLight,flag);
}

const char* WK7ViewerModel::GetArchiveVersionStr(void)
{
	if( mpModelArchive==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = mpModelArchive->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mpVersionStr;
}

int WK7ViewerModel::GetArchiveVersion(void)
{
	if( mpModelArchive==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = mpModelArchive->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mVersion;
}

WK7ViewerModel* WK7ViewerTask::GetModel(int index)
{
	if( index < 0 || index >= mModelNum ){
		return NULL;
	}
	WK7ViewerModel		*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( index > 0 ){
		if( pModel==NULL ){
			return NULL;
		}
		index--;
		pModel = pModel->GetNext();
	}
	return pModel;
}

#if 0
WK7ViewerMotion* WK7ViewerTask::GetMotion(int index)
{
	if( index < 0 ){
		return NULL;
	}
	WK7ViewerMotion		*pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	
	while( index > 0 ){
		if( pMotion==NULL ){
			return NULL;
		}
		index--;
		pMotion = pMotion->GetNext();
	}
	return pMotion;
}

WK7ViewerMotion* WK7ViewerTask::CreateMotion(void)
{
	WK7ViewerMotion		*pMotion;
	int					lastPrio = GHMGCLIST_DEFAULT_PRIO-1;
	pMotion = (WK7ViewerMotion *)mMotionAnchor.GetNext();
	while( pMotion!=NULL ){
		WK7ViewerMotion		*pNext = pMotion->GetNext();
		if( pNext==NULL ){
			lastPrio = pMotion->GetPriority();
		}
		pMotion = pNext;
	}
	ghmGcMemSetAllocName("ViewerMt");
	return new WK7ViewerMotion(&mMotionAnchor,lastPrio+1);
}
#endif

WK7ViewerModel* WK7ViewerTask::CreateModel(void)
{
	WK7ViewerModel		*pModel;
	int					lastPrio = GHMGCLIST_DEFAULT_PRIO-1;
	pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		WK7ViewerModel		*pNext = pModel->GetNext();
		if( pNext==NULL ){
			lastPrio = pModel->GetPriority();
		}
		pModel = pNext;
	}
	ghmGcMemSetAllocName("ViewerMd");
	return new WK7ViewerModel(&mModelAnchor,lastPrio+1);
}

bool WK7ViewerTask::MotionTrigger(void)
{
	if( WK7ViewerModel::GetMotionPlayAll()==true ){
		PlayMotion();
		PlayCamMotion();
	}else{
		StopMotion();
		StopCamMotion();
	}
	return true;
}

bool WK7ViewerTask::MotionPauseTrigger(void)
{
	if( WK7ViewerModel::GetMotionPauseAll()==true ){
		PauseMotion();
		PauseCamMotion();
	}else{
		ReplayMotion();
		ReplayCamMotion();
	}
	return true;
}

bool WK7ViewerTask::PlayMotion(void)
{
	WK7ViewerModel		*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	bool				play = false;
//	GetSdExpInfo();
	while( pModel!=NULL ){
		if( pModel->PlayMotion()==true ){
			play = true;
		}
		pModel = pModel->GetNext();
	}
	return play;
}

bool WK7ViewerTask::StopMotion(void)
{
	WK7ViewerModel		*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		pModel->StopMotion();
		pModel = pModel->GetNext();
	}
	return true;
}

bool WK7ViewerTask::PauseMotion(void)
{
	WK7ViewerModel		*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		pModel->PauseMotion();
		pModel = pModel->GetNext();
	}
	return true;
}

bool WK7ViewerTask::ReplayMotion(void)
{
	WK7ViewerModel		*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		pModel->ReplayMotion();
		pModel = pModel->GetNext();
	}
	return true;
}

WK7CameraMotion* WK7ViewerTask::GetCurrentCamMotion(void)
{
	WK7CameraMotion			*pCameraMotion;
	if( mpCameraMotion!=NULL ){
		pCameraMotion = mpCameraMotion;
	}else{
		WK7ViewerModel		*pModel;
		for(pModel=(WK7ViewerModel *)mModelAnchor.GetNext() ; pModel!=NULL ; pModel=pModel->GetNext()){
			if( (pCameraMotion = pModel->GetCurrentCamMotion())!=NULL ){
				break;
			}
		}
	}
	return pCameraMotion;
}

const char* WK7ViewerTask::GetCurrentCamMotionArchiveVersionStr(void)
{
	if( mpCameraMotionArchive!=NULL ){
		WK7SdExpInfo			*pSdExpInfo;
		pSdExpInfo = mpCameraMotionArchive->GetSdExpInfo();
		if( pSdExpInfo==NULL ){
			return NULL;
		}
		return pSdExpInfo->mpVersionStr;
	}
	WK7ViewerModel		*pModel;
	WK7CameraMotion		*pCameraMotion;
	for(pModel=(WK7ViewerModel *)mModelAnchor.GetNext() ; pModel!=NULL ; pModel=pModel->GetNext()){
		if( (pCameraMotion=pModel->GetCurrentCamMotion())!=NULL ){
			break;
		}
	}
	if( pModel==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = pCameraMotion->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mpVersionStr;
}

int WK7ViewerTask::GetCurrentCamMotionArchiveVersion(void)
{
	if( mpCameraMotionArchive!=NULL ){
		WK7SdExpInfo			*pSdExpInfo;
		pSdExpInfo = mpCameraMotionArchive->GetSdExpInfo();
		if( pSdExpInfo==NULL ){
			return NULL;
		}
		return pSdExpInfo->mVersion;
	}
	WK7ViewerModel		*pModel;
	WK7CameraMotion		*pCameraMotion;
	for(pModel=(WK7ViewerModel *)mModelAnchor.GetNext() ; pModel!=NULL ; pModel=pModel->GetNext()){
		if( (pCameraMotion=pModel->GetCurrentCamMotion())!=NULL ){
			break;
		}
	}
	if( pModel==NULL ){
		return NULL;
	}
	WK7SdExpInfo	*pSdExpInfo = pCameraMotion->GetSdExpInfo();
	if( pSdExpInfo==NULL ){
		return NULL;
	}
	return pSdExpInfo->mVersion;
}

WK7ViewerModel* WK7ViewerTask::GetCurrentCamMotionModel(void)
{
	if( mpCameraMotion!=NULL ){
		return NULL;
	}
	WK7ViewerModel		*pModel;
	for(pModel=(WK7ViewerModel *)mModelAnchor.GetNext() ; pModel!=NULL ; pModel=pModel->GetNext()){
		if( pModel->GetCurrentCamMotion()!=NULL ){
			break;
		}
	}
	return pModel;
}

bool WK7ViewerTask::PlayCamMotion(void)
{
	WK7CameraMotion			*pCameraMotion = GetCurrentCamMotion();
	if( pCameraMotion==NULL ){
		return false;
	}
	mCameraMotionPlay = true;
	SetCamMode(mMode);
	WK7CAM->DetachMotion();
	WK7CAM->GetPosition      (mCamStorePosition      );
	WK7CAM->GetTargetPosition(mCamStoreTargetPosition);
	WK7CAM->AttachMotion(pCameraMotion);
	WK7CAM->PlayMotion();
	WK7CAM->SetMotionLoop(false);
//	WK7CAM->SetMotionLoop(WK7ViewerModel::GetMotionLoopAll());
	return true;
}

bool WK7ViewerTask::StopCamMotion(void)
{
	bool	restore;
	if( mCameraMotionPlay==true ){
		restore = true;
	}else{
		restore = false;
	}
	mCameraMotionPlay = false;
	SetCamMode(mMode);
	WK7CAM->StopMotion();
	WK7CAM->DetachMotion();
	if( restore==true ){
		WK7CAM->SetDesc(NULL);
		WK7CAM->SetPosition      (mCamStorePosition      );
		WK7CAM->SetTargetPosition(mCamStoreTargetPosition);
	}
	return true;
}

bool WK7ViewerTask::PauseCamMotion(void)
{
	WK7CAM->StopMotion();
	return true;
}

bool WK7ViewerTask::ReplayCamMotion(void)
{
	WK7CAM->ReplayMotion();
	return true;
}

bool WK7ViewerTask::InitializeCallBack(void)
{
	
	OSDebugReport("WK7ViewerTask Init : Heap = 0x%08x,0x%08x, TaskSize = 0x%08x\n",ghmGcMemGetFreeSize(),k7app.SmallGetFreeSize(),sizeof(*this));
	
	sprintf(motionRateStr    ,"%f"  ,WK7Motion::GetWholeMotionRate());
	sprintf(camWobbleScaleStr,"%.3f",WK7CAM->   GetWobblePosRate  ());
	mCamWobbleScale = (int)(CAMWOBBLESCALE_UNIT * WK7CAM->GetWobblePosRate());
	
	WK7Fog::Initialize();
	WK7RenderObj::InitializeAll();
	WK7CharaPresent::Initialize();
	WK7CAM->SetCinemaScopeMode(false);
	
	// ^XNRg[
	mFrameProcessTaskController.Initialize();
	mRenderProcessTaskController.Initialize();
	WK7HitObj::SetDefaultTaskController(&mFrameProcessTaskController);
	
	GameInfo.SetScenarioID(K7SCN_UNKNOWN);
	GameInfo.InitScenario();
	GameInfo.SetTaskController(&mFrameProcessTaskController);
	
#ifdef	_DEBUG
	mainMenu.Initialize();
	mainMenu.SetFrameProcessTaskController(&mFrameProcessTaskController);
#if	!defined(K7APP_MASTER) && !defined(ORBITAL) && !defined(K7APP_MODEINFO) && !defined(USE_USB)
	SetModeInfo(true);
#else
	SetModeInfo(false);
#endif
#if	!defined(K7APP_GXWARNING) && !defined(USE_USB)
	SetGXWarning(true);
#endif
	SetGXWarning(false);
	SetZanDebugInfo(true);
#endif
	
	// L
	WK7Play::Initialize();
	
	// 
	WK7Memo::Initialize();
	
	// p[eBNVXȅ
//	USE_PARTICLE;
	
//	// GtFNg
//	EffectInit(&mRenderProcessTaskController,WK7MAINTASK_SCREENCAPTURE_TASK_PRIO);
//	
//	// JIuWFNg̃Zbg
//	SetEffectCamera(WK7CAM->GetCObj());
//	
//	//쐬̏
//	mK7InitProc();
//	
//	if( (g_pSpData = new SK7SpecialData)!=NULL ){
//		g_pSpData->Initialize();
//	}
	
	// ogRg[[
	BattleCtrl.InitScenario();
	
	// vC[Rg[
	WK7PLAYERCONTROL->Initialize();
	
	WK7Stage::Clear();
	
	WK7EVENTCONTROLLER->Initialize();
	WK7EVENTCONTROLLER->SetTaskController(&mFrameProcessTaskController,&mRenderProcessTaskController);
//	WK7EVENTCONTROLLER->LoadStaticData();
	
	// J
	WK7CAM->SetRenderFlag(true);
	
	mpDefLight = WK7Light::Create(new (&amb_lightset) C_LightSet,LIGHT_TYPE,0xffffffff);
	mpLObj       = NULL;
	
	WK7RenderObj::GetVFX();
	WK7Npc::InitializeAll();
//	WK7Sight::Initialize();
	WK7SIGHT->SetPosition(320.0f,240.0f);
	
	// mobAuew
	WK7RenderObj::SetVfxFlag(true);
	WK7RenderObj::VFXSetIntensity(0.1f);
	
//	mpLObj       = new C_LObj(new (&amb_lightset       ) C_LightSet);
	CreateLObj();
	
	ghmGcFile		file;
	if( file.Open("/Wat/crystal.dat")==false ){
		return false;
	}
	if( (mpOriginArchive=file.ReadB())==NULL ){
		return false;
	}
	file.Close();
	
	C_SceneDesc		*pSceneDesc = new(mpOriginArchive)C_SceneDesc();
	ghmGcMemSetAllocName("C_JObj");
	mpOriginJObj = new C_JObj(pSceneDesc->GetModelSet((u32)0));
	
	SetPerfMeter(mPerfMeter);
//	k7app.SetVisiblePerfMeter(mPerfMeter);
//	k7app.SetEnablePerfMeter (mPerfMeter);
	SetRenderMemory(mRenderMemory);
//	ghmGcMem::SetRender      (mRenderMemory);
	
	WK7CAM->GetPosition      (mCamDefaultPosition);
	WK7CAM->GetTargetPosition(mCamDefaultTargetPosition);
	mEditCamStartPosition       = 
	mEditCamEndPosition         = mCamDefaultPosition;
	mEditCamStartTargetPosition = 
	mEditCamEndTargetPosition   = mCamDefaultTargetPosition;
	mEditCamStartFov            = 
	mEditCamEndFov              = WK7CAM->GetFov();
	
	SetShadow();
	
	SceneBlur.CreateScreen( 2.0f, 0.0f,200.0f,0x40);
	SceneBlur.CreateScreen( 0.0f, 2.0f,200.0f,0x40);
	SceneBlur.CreateScreen(-2.0f, 0.0f,300.0f,0x40);
	SceneBlur.CreateScreen( 0.0f,-2.0f,300.0f,0x40);
	SceneBlur.SetVisible(mSceneBlurVisible);
	mSceneBlurID = 0;
	
	mPreScreenCaptureTaskID   = mRenderProcessTaskController.Start(_PreScreenCaptureTask  ,(u32)this,0,NULL,-1,WK7MAINTASK_PRE_SCREENCAPTURE_TASK_PRIO  );
	mScreenCaptureTaskID      = mRenderProcessTaskController.Start(_ScreenCaptureTask     ,(u32)this,0,NULL,-1,WK7MAINTASK_SCREENCAPTURE_TASK_PRIO      );
	mPostScreenCaptureTaskID  = mRenderProcessTaskController.Start(_PostScreenCaptureTask ,(u32)this,0,NULL,-1,WK7MAINTASK_POST_SCREENCAPTURE_TASK_PRIO );
	mPostScreenCapture2TaskID = mRenderProcessTaskController.Start(_PostScreenCapture2Task,(u32)this,0,NULL,-1,WK7MAINTASK_POST_SCREENCAPTURE2_TASK_PRIO);
//	mLastFrameProcessTaskID   = mFrameProcessTaskController .Start(_LastFrameProcessTask  ,(u32)this,0,NULL,-1,WK7MAINTASK_LAST_FRAMEPROCESS_TASK_PRIO  );
	
	WK7Stage::SetRenderStage(true);
	WK7Chara::SetRenderChara(true);
	WK7Item::SetRenderItem  (true);
	
	GameInfo.SetMode(WK7GameInfo::INIT);
	
	gMask.Start(0,0,0);
//	fog = HSD_FogLoadDesc(&fog_desc);
	
	return true;
}

bool WK7ViewerTask::TerminateCallBack(void)
{
	ghmGcApp		*pApp = GetApplication();
	
	if( mPreScreenCaptureTaskID  >= 0 ){
		mRenderProcessTaskController.Stop(mPreScreenCaptureTaskID );
		mPreScreenCaptureTaskID   = -1;
	}
	if( mScreenCaptureTaskID     >= 0 ){
		mRenderProcessTaskController.Stop(mScreenCaptureTaskID    );
		mScreenCaptureTaskID      = -1;
	}
	if( mPostScreenCaptureTaskID >= 0 ){
		mRenderProcessTaskController.Stop(mPostScreenCaptureTaskID);
		mPostScreenCaptureTaskID  = -1;
	}
	if( mPostScreenCapture2TaskID >= 0 ){
		mRenderProcessTaskController.Stop(mPostScreenCapture2TaskID);
		mPostScreenCapture2TaskID  = -1;
	}
	if( mLastFrameProcessTaskID   >= 0 ){
		mFrameProcessTaskController.Stop(mLastFrameProcessTaskID);
		mLastFrameProcessTaskID   = -1;
	}
	
//	ReleaseMotionArchiveAll();
//	ReleaseModelArchive    ();
	ReleaseModelAll        ();
	ReleaseStageArchive    ();
	ReleaseCamMotionArchive();
	
	GHM_SAFE_DELETE(mpDefLight  );
	GHM_SAFE_DELETE(mpLObj      );
	GHM_SAFE_DELETE(mpOriginJObj);
	GHMGCMEM_SAFE_FREE(mpOriginArchive);
	GHMGCMEM_SAFE_FREE(mpTexture);
	GHM_SAFE_DELETE(mpPlay);
	GHMGCMEM_SAFE_FREE(mpPlayResource);
	
	// vC[Rg[I
	WK7PLAYERCONTROL->Terminate();
	
	// mob
	WK7Npc::ReleaseAll();
	WK7Npc::TerminateAll();
	
//	WK7Sight::Terminate();
	
	// ogRg[[J
	BattleCtrl.ReleaseScenario();
	
	// I
	WK7Memo::Terminate();
	
	// LI
	WK7Play::Terminate();
	
	SceneBlur.ReleaseScreenAll();
	
#ifdef	_DEBUG
	mainMenu.Terminate();
#endif
	
	WK7CharaPresent::Terminate();
	
	WK7Stage::DeleteStageAll();
	WK7RenderObj::ReleaseAll();
	WK7MotionObj::ReleaseAll();
	
	WK7EVENTCONTROLLER->ReleaseDynamicData();
	WK7EVENTCONTROLLER->ReleaseStaticData();
	
	WK7Archive::ReleaseDynamicAll();
	
	WK7RenderObj::TerminateAll();
	WK7Fog::Terminate();
	
	// ^XNRg[I
	WK7HitObj::SetDefaultTaskController(NULL);
	mFrameProcessTaskController.Terminate();
	mRenderProcessTaskController.Terminate();
	
	// CxgRg[I
	WK7EVENTCONTROLLER->Terminate();
	
	GameInfo.Terminate();
	GameInfo.SetTaskController(NULL);
	
	k7app.SetVisiblePerfMeter(false);
	k7app.SetEnablePerfMeter (true);
	ghmGcMem::SetRender      (false);
	
	if( fog != NULL ){
		HSD_FogUnref(fog);
		fog = NULL;
	}
	
	WK7Stage::Clear();
	
	delete this;
	
	C_Font::C_Line::DeleteAll();
	K7AppDebugPrintDelete();
	
#if	!defined(ORBITAL) && !defined(USE_ISDOLVIEWER)
	K7AppDumpMemory();
#endif
	
	screenImageFullColor.FreeBuffer();
	screenImageMonoColor.FreeBuffer();
	
	WK7Stage::SetRenderStage(true);
	WK7Chara::SetRenderChara(true);
	WK7Item::SetRenderItem  (true);
	
	ghmGcMemSetAllocName("MenuTask");
	new WK7MenuTask(pApp);
	
	return true;
}

bool WK7ViewerTask::RenewCursorRange(int itemnum,int dispnum)
{
	if( mProc < 0 ){
		mProc   = itemnum-1;
		mCursor = itemnum-1;
	}else if( mProc >= itemnum ){
		mProc   = 0;
		mCursor = 0;
	}
	if( mCursor < 0 ){
		mCursor = 0;
	}else if( mCursor > dispnum-1 ){
		mCursor = dispnum-1;
	}
	return true;
}

bool WK7ViewerTask::FrameProcessFileList(int itemnum,int dispnum)
{
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mProc--;
		mCursor--;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_UP ){
		mProc  -= d;
		mCursor-= d;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mProc++;
		mCursor++;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_DOWN ){
		mProc  += d;
		mCursor+= d;
	}
	if( dispnum < 0 ){
		dispnum = FILELIST_DISPMAX;
	}
	if( itemnum < 0 ){
		itemnum = mFileList.GetFileNum();
	}
	RenewCursorRange(itemnum,dispnum);
	mFileList.SetCursorID(mProc);
	return true;
}

bool WK7ViewerTask::RenderFileList(const char *pTitle,int dispmax)
{
	C_Paper				paper(0,0,0.75f);
	int					i,c;
	const char			*pCursor;
	const char			*pFileName;
	
	if( dispmax < 0 ){
		dispmax = FILELIST_DISPMAX;
	}
	
	if( pTitle==NULL ){
		return false;
	}
	for(i=0 ; pTitle[i]!='\0' ; i++){
		if( pTitle[i]=='\n' ){
			dispmax--;
		}
	}
	
	i   = mProc - mCursor;
	
	PRINTF("\n\n");
	if( pTitle!=NULL ){
		PRINTF("%s [/%s]",pTitle,mFileList.GetDirName());
	}else{
		PRINTF("[%s]",mFileList.GetDirName());
	}
	PRINTF("\n\n");
	
	for(c=0 ; c<dispmax && i<mFileList.GetFileNum() ; i++,c++){
		pFileName = mFileList.GetFileName(i);
		if( c==mCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( mFileList.IsDir(i) > 0 ){
			// fBNg
			PRINTF(" %s [%s]\n",pCursor,pFileName);
		}else{
			PRINTF(" %s %s\n",pCursor,pFileName);
		}
	}
	
	return true;
}

bool WK7ViewerTask::FrameProcessEditModeViewer(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		if( HSD_PadGetButton(0) & HSD_PAD_A ){
			WK7CAM->SetPosition      (mCamDefaultPosition      );
			WK7CAM->SetTargetPosition(mCamDefaultTargetPosition);
			return true;
		}else{
			WK7ViewerModel	*pModel = GetModel(mCurrentModel);
			if( pModel!=NULL ){
				Vec		tgtpos;
				Vec		pos;
				f32		rot;
				WK7CAM->GetTargetPosition(tgtpos);
				WK7CAM->GetPosition      (pos);
				rot = atan2f(pos.x - tgtpos.x,pos.z - tgtpos.z);
				pModel->SetPosition(tgtpos);
				pModel->SetRotY    (rot);
			}
//			if( mpModel!=NULL ){
//				Vec		tgtpos;
//				Vec		pos;
//				f32		rot;
//				WK7CAM->GetTargetPosition(tgtpos);
//				WK7CAM->GetPosition      (pos);
//				rot = atan2f(pos.x - tgtpos.x,pos.z - tgtpos.z);
//				mpModel->SetPosition(tgtpos);
//				mpModel->SetRotY    (rot);
//				return true;
//			}
		}
	}
	return false;
}

bool WK7ViewerTask::FrameProcessEditModeMotionPlay(void)
{
	if( mMode==WK7VIEWERMODE_PLAY ){
		return false;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( WK7ViewerModel::GetMotionPauseAll()==true ){
			WK7ViewerModel::SetMotionPauseAll(false);
		}else{
			WK7ViewerModel::SetMotionPauseAll(true);
		}
		MotionPauseTrigger();
	}
	if( WK7ViewerModel::GetMotionPauseAll()==true ){
		if( HSD_PadGetRepeat(0) & HSD_PAD_Y ){
			ReplayMotion();
			ReplayCamMotion();
		}else{
			MotionPauseTrigger();
		}
	}else{
		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
			if( WK7ViewerModel::GetMotionPlayAll()==true ){
				WK7ViewerModel::SetMotionPlayAll(false);
			}else{
				WK7ViewerModel::SetMotionPlayAll(true);
			}
			MotionTrigger();
		}
	}
	return false;
}

bool WK7ViewerTask::FrameProcessEditModeCamEdit(void)
{
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
		return true;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mEditCamProc--;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mEditCamProc++;
	}
	mEditCamProcMax = 5;
	if( mEditCamProc < 0 ){
		mEditCamProc = mEditCamProcMax-1;
	}else if( mEditCamProc >= mEditCamProcMax ){
		mEditCamProc = 0;
	}
//	switch( mEditCamProc ){
//	case	0:
//		WK7CAM->SetDebugOperate(true);
//		break;
//	default:
//		WK7CAM->SetDebugOperate(false);
//		break;
//	}
	switch( mEditCamProc ){
	case	0:
		// ^Cvݒ
//		if( HSD_PadGetTrigger(0)==HSD_PAD_B ){
//		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
			Vec		pos,tgt;
			f32		n,f,fov;
			WK7CAM->GetPosition      (pos);
			WK7CAM->GetTargetPosition(tgt);
			n   = WK7CAM->GetNear();
			f   = WK7CAM->GetFar ();
			fov = WK7CAM->GetFov ();
			OSDebugReport("%.3f\t%.3f\t%.3f\n",pos.x,pos.y,pos.z);
			OSDebugReport("%.3f\t%.3f\t%.3f\n",tgt.x,tgt.y,tgt.z);
			OSDebugReport("%.3f\n",n);
			OSDebugReport("%.3f\n",f);
			OSDebugReport("%.3f\n",fov);
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			bool	play = true;
			switch( WK7CAM->GetMode() ){
			case	WK7Cam::WK7CAM_LINIP_LINPATH:
			case	WK7Cam::WK7CAM_DELAYIP_LINPATH:
			case	WK7Cam::WK7CAM_LINIP_CIRPATH:
				WK7CAM->StopInterpolate();
				WK7CAM->EnterDebugMode();
				break;
			default:
				switch( mEditCamType ){
				case	LINIP_LINPATH:
					WK7CAM->SetPosition                       (mEditCamStartPosition);
					WK7CAM->SetTargetPosition                 (mEditCamStartTargetPosition);
					WK7CAM->SetFov                            (mEditCamStartFov);
					WK7CAM->StartLinearInterpolateOnLinearPath(mEditCamEndPosition,
					                                           mEditCamEndTargetPosition,
					                                           WK7_TICK_TO_FRAME((f32)mEditCamInterpolateTime),
					                                           mEditCamEndFov);
					break;
				case	DELAYIP_LINPATH:
					WK7CAM->SetPosition                       (mEditCamStartPosition);
					WK7CAM->SetTargetPosition                 (mEditCamStartTargetPosition);
					WK7CAM->SetFov                            (mEditCamStartFov);
					WK7CAM->StartDelayInterpolateOnLinearPath (mEditCamEndPosition,
					                                           mEditCamEndTargetPosition,
					                                           (f32)mEditCamDelayRate / EDITCAM_DELAYRATE_MAX,
					                                           mEditCamEndFov);
					break;
				case	LINIP_CIRPATH:
					WK7CAM->SetPosition                       (mEditCamStartPosition);
					WK7CAM->SetTargetPosition                 (mEditCamStartTargetPosition);
					WK7CAM->SetFov                            (mEditCamStartFov);
					WK7CAM->StartLinearInterpolateOnCirclePath(mEditCamEndPosition,
					                                           mEditCamEndTargetPosition,
					                                           WK7_TICK_TO_FRAME((f32)mEditCamInterpolateTime),
					                                           mEditCamEndFov);
					break;
				default:
					play = false;
					WK7CAM->StopInterpolate();
					break;
				}
				if( play==true ){
					OSDebugReport("%.3f\t%.3f\t%.3f\n",mEditCamStartPosition.x,
					                                   mEditCamStartPosition.y,
					                                   mEditCamStartPosition.z);
					OSDebugReport("%.3f\t%.3f\t%.3f\n",mEditCamStartTargetPosition.x,
					                                   mEditCamStartTargetPosition.y,
					                                   mEditCamStartTargetPosition.z);
					OSDebugReport("%.3f\t%.3f\t%.3f\n",mEditCamEndPosition.x,
					                                   mEditCamEndPosition.y,
					                                   mEditCamEndPosition.z);
					OSDebugReport("%.3f\t%.3f\t%.3f\n",mEditCamEndTargetPosition.x,
					                                   mEditCamEndTargetPosition.y,
					                                   mEditCamEndTargetPosition.z);
				}
				break;
			}
			return true;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			mEditCamType = (EditCamType)(mEditCamType + 1);
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			mEditCamType = (EditCamType)(mEditCamType - 1);
		}
		if( mEditCamType < 0 ){
			mEditCamType = (EditCamType)(EDITCAMTYPE_MAX-1);
		}else if( mEditCamType >= EDITCAMTYPE_MAX ){
			mEditCamType = LINIP_LINPATH;
		}
		break;
	case	1:
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			WK7CAM->GetPosition      (mEditCamStartPosition      );
			WK7CAM->GetTargetPosition(mEditCamStartTargetPosition);
			mEditCamStartFov = WK7CAM->GetFov();
			return true;
		}
		break;
	case	2:
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			WK7CAM->GetPosition      (mEditCamEndPosition      );
			WK7CAM->GetTargetPosition(mEditCamEndTargetPosition);
			mEditCamEndFov = WK7CAM->GetFov();
			return true;
		}
		break;
	case	3:{
		// Ԑݒ
		int		deltatime;
		if( HSD_PadGetButton(0) & HSD_PAD_Y ){
			if( HSD_PadGetButton(0) & HSD_PAD_A ){
				deltatime = WK7_TICK_PER_SEC;
			}else{
				deltatime = WK7_TICK_PER_FRAME;
			}
		}else{
			deltatime = 1;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			mEditCamInterpolateTime += deltatime;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			mEditCamInterpolateTime -= deltatime;
		}
		if( mEditCamInterpolateTime < 1 ){
			mEditCamInterpolateTime = 1;
		}
		}break;
	case	4:{
		// fBCݒ
		int		deltadelay;
		if( HSD_PadGetButton(0) & HSD_PAD_Y ){
			if( HSD_PadGetButton(0) & HSD_PAD_A ){
				deltadelay = EDITCAM_DELAYRATE_MAX / 100;
			}else{
				deltadelay = EDITCAM_DELAYRATE_MAX / 1000;
			}
		}else{
			deltadelay = 1;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			mEditCamDelayRate += deltadelay;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			mEditCamDelayRate -= deltadelay;
		}
		if( mEditCamDelayRate < 1 ){
			mEditCamDelayRate = 1;
		}else if( mEditCamDelayRate > EDITCAM_DELAYRATE_MAX ){
			mEditCamDelayRate = EDITCAM_DELAYRATE_MAX;
		}
		}break;
	default:
		mEditCamProc = 0;
		break;
	}
	return false;
}

int WK7ViewerTask::GetCurrentModel(void)
{
	return mCurrentModel;
}

bool WK7ViewerTask::SetCurrentModel(int index)
{
	if( index < 0 ){
		if( mModelNum<=0 ){
			index = 0;
		}else{
			index = mModelNum-1;
		}
	}else if( index >= mModelNum ){
		index = 0;
	}
	if( index==mCurrentModel ){
		return true;
	}
	mCurrentModel = index;
	mpCurrentJObj = NULL;
	return true;
}

bool WK7ViewerTask::FrameProcessEditModeHierarchy(void)
{
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
		return false;
	}
	if( HSD_PadGetButton(0) & HSD_PAD_A ){
		int		index = GetCurrentModel();
		if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
			index--;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
			index++;
		}
		if( index!=GetCurrentModel() ){
			SetCurrentModel(index);
		}
	}
	WK7ViewerModel	*pModel;
	if( (pModel=GetModel(mCurrentModel))==NULL ){
		return false;
	}
	WK7JObj		*pOldJObj = mpCurrentJObj;
	WK7JObj		*pJObj;
	if( mpCurrentJObj==NULL ){
		WK7Model	*pMdl;
		if( (pMdl=pModel->GetModel())==NULL ){
			return false;
		}
		if( (mpCurrentJObj = pMdl->GetTopObj())==NULL ){
			return false;
		}
	}
	if( HSD_PadGetButton(0) & HSD_PAD_A ){
		if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
			Vec		pos,tgt,dir;
			WK7CAM->GetPosition      (pos);
			WK7CAM->GetTargetPosition(tgt);
			VECSubtract(&tgt,&pos,&dir);
			mpCurrentJObj->GetWorldPosition(&tgt);
			VECSubtract(&tgt,&dir,&pos);
			WK7CAM->SetPosition      (pos);
			WK7CAM->SetTargetPosition(tgt);
			return true;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_UP ){
			mpCurrentJObj->Disp(false,true);
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_DOWN ){
			mpCurrentJObj->Hide(false,true);
		}
		return false;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		if( mpCurrentJObj->IsHidden()==true ){
			mpCurrentJObj->Disp(false,false);
		}else{
			mpCurrentJObj->Hide(false,false);
		}
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		if( mpCurrentJObj->GetPrev()!=NULL ){
			mpCurrentJObj = mpCurrentJObj->GetPrev();
		}else{
			for(pJObj=mpCurrentJObj->GetParent() ; pJObj!=NULL ; pJObj=pJObj->GetParent()){
				if( pJObj->GetPrev()!=NULL ){
					mpCurrentJObj = pJObj->GetPrev();
					break;
				}
			}
		}
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		if( mpCurrentJObj->GetNext()!=NULL ){
			mpCurrentJObj = mpCurrentJObj->GetNext();
		}else{
			for(pJObj=mpCurrentJObj->GetChild() ; pJObj!=NULL ; pJObj=pJObj->GetChild()){
				if( pJObj->GetNext()!=NULL ){
					mpCurrentJObj = pJObj->GetNext();
					break;
				}
			}
			if( pJObj==NULL ){
				for(pJObj=mpCurrentJObj->GetParent() ; pJObj!=NULL ; pJObj=pJObj->GetParent()){
					if( pJObj->GetNext()!=NULL ){
						mpCurrentJObj = pJObj->GetNext();
						break;
					}
				}
			}
		}
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
		if( mpCurrentJObj->GetChild()!=NULL ){
			mpCurrentJObj = mpCurrentJObj->GetChild();
		}else{
			for(pJObj=mpCurrentJObj->GetNext() ; pJObj!=NULL ; pJObj=pJObj->GetNext()){
				if( pJObj->GetChild()!=NULL ){
					mpCurrentJObj = pJObj->GetChild();
					break;
				}
			}
			if( pJObj==NULL ){
				for(pJObj=mpCurrentJObj->GetPrev() ; pJObj!=NULL ; pJObj=pJObj->GetPrev()){
					if( pJObj->GetChild()!=NULL ){
						mpCurrentJObj = pJObj->GetChild();
						break;
					}
				}
			}
		}
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
		if( mpCurrentJObj->GetParent()!=NULL ){
			mpCurrentJObj = mpCurrentJObj->GetParent();
		}else{
			for(pJObj=mpCurrentJObj->GetPrev() ; pJObj!=NULL ; pJObj=pJObj->GetPrev()){
				if( pJObj->GetParent()!=NULL ){
					mpCurrentJObj = pJObj->GetParent();
					break;
				}
			}
		}
	}
	if( pOldJObj != mpCurrentJObj ){
		return true;
	}
	return false;
}

bool WK7ViewerTask::FrameProcessEditModeBlurEdit(void)
{
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
		return true;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mSceneBlurProc--;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mSceneBlurProc++;
	}
	if( mSceneBlurProc < 0 ){
		mSceneBlurProc = 6;
	}else if( mSceneBlurProc > 6 ){
		mSceneBlurProc = 0;
	}
	WK7SceneBlurScreen	*pScreen;
	if( (pScreen=SceneBlur.GetScreen(mSceneBlurID))==NULL ){
		return false;
	}
	
	f32		val;
	
	switch( mSceneBlurProc ){
	case	0:
		if( HSD_PadGetRepeat(0) & (HSD_PAD_LEFT|HSD_PAD_RIGHT) ){
			if( mSceneBlurVisible==true ){
				mSceneBlurVisible = false;
			}else{
				mSceneBlurVisible = true;
			}
			SceneBlur.SetVisible(mSceneBlurVisible);
		}
		break;
	case	1:
		if( HSD_PadGetRepeat(0) & (HSD_PAD_LEFT|HSD_PAD_RIGHT) ){
			mSceneBlurID++;
		}
		mSceneBlurID %= SceneBlur.GetScreenNum();
		break;
	case	2:
		val = pScreen->GetZDist();
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			val += WK7CAM->GetCameraMoveSpeed();
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			val -= WK7CAM->GetCameraMoveSpeed();
		}
		if( val < 0.0f ){
			val = 0.0f;
		}
		pScreen->SetZDist(val);
		break;
	case	3:
		val = pScreen->GetOffsetX();
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			val += 1.0f;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			val -= 1.0f;
		}
		pScreen->SetOffsetX(val);
		break;
	case	4:
		val = pScreen->GetOffsetY();
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			val += 1.0f;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			val -= 1.0f;
		}
		pScreen->SetOffsetY(val);
		break;
	case	5:{
		s32		alpha,d;
		alpha = (s32)pScreen->GetAlpha();
		if( HSD_PadGetButton(0) & HSD_PAD_A ){
			d = 4;
		}else{
			d = 1;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			alpha += d;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			alpha -= d;
		}
		if( alpha < 0 ){
			alpha = 0;
		}else if( alpha > 255 ){
			alpha = 255;
		}
		pScreen->SetAlpha((u32)alpha);
		}break;
	case	6:
		if( HSD_PadGetRepeat(0) & (HSD_PAD_LEFT|HSD_PAD_RIGHT) ){
			if( pScreen->GetVisible()==true ){
				pScreen->SetVisible(false);
			}else{
				pScreen->SetVisible(true);
			}
		}
		break;
	default:
		mSceneBlurProc = 0;
		break;
	}
	return false;
}

WK7Light* WK7ViewerTask::GetLight(int index)
{
	WK7LightFindData	data;
	WK7Light			*pLight = NULL;
	data.Initialize();
	while( index>=0 && (pLight=WK7Light::Find(data))!=NULL ){
		index--;
	}
	return pLight;
}

HSD_LObj* GetLObj(WK7Light *pLight,u32 type=0xffffffff);
HSD_LObj* GetLObj(WK7Light *pLight,u32 type)
{
	if( pLight==NULL ){
		return NULL;
	}
	HSD_LObj	*pLObj = pLight->GetHSDLObj();
	if( type==0xffffffff ){
		return pLObj;
	}
	while( pLObj!=NULL ){
		if( HSD_LObjGetType(pLObj)==type ){
			return pLObj;
		}
		pLObj = pLObj->next;
	}
	return pLObj;
}

static	float	new_dir_light_shininess = 50.0f;
static	HSD_WObjDesc new_dir_light_pos_wobjdesc = {
	NULL,
	{ 0.000000f, 1.000000f, 0.000000f },		// wobj position
};

static	HSD_LightDesc	new_dir_light_desc = {
	NULL,
	NULL,										// link
	LOBJ_INFINITE|LOBJ_DIFFUSE,					// flags
	LOBJ_LIGHT_ATTN_NONE,						// attnflags
	{ 0xff, 0xff, 0xff, 0xff },					// color
	&new_dir_light_pos_wobjdesc,				// position
	NULL,
	&new_dir_light_shininess,
};
static	u32				light_id = 0x00010000;

bool WK7ViewerTask::FrameProcessEditModeLightEdit(void)
{
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
		return true;
	}
	if( HSD_PadGetRepeat(1) & HSD_PAD_UP ){
		mLightEditProc--;
	}
	if( HSD_PadGetRepeat(1) & HSD_PAD_DOWN ){
		mLightEditProc++;
	}
#define	LIGHTEDDITPROC_NUM		(3)
	if( mLightEditProc < 0 ){
		mLightEditProc = LIGHTEDDITPROC_NUM-1;
	}else if( mLightEditProc >= LIGHTEDDITPROC_NUM ){
		mLightEditProc = 0;
	}
	
	WK7Light	*pLight;
	HSD_LObj	*pLObj;
	pLight = GetLight(mLightID);
	pLObj  = GetLObj(pLight);
	
	if( pLight!=NULL && pLObj!=NULL ){
		if( HSD_PadGetTrigger(1) & HSD_PAD_START ){
			HSD_LObj	*pLObjTgt = pLObj;
			for(pLObjTgt=pLObj ; pLObj!=NULL ; pLObj = pLObj->next){
				switch(  HSD_LObjGetType(pLObj) ){
				case	LOBJ_INFINITE:
					pLObjTgt = pLObj;
					break;
				case	LOBJ_POINT:
				case	LOBJ_SPOT:
					pLObjTgt = pLObj;
					continue;
				default:
					continue;
				}
				break;
			}
			Vec			pos,tgt;
			GXColor		color;
			HSD_LObjGetPosition(pLObjTgt,&pos);
			HSD_LObjGetInterest(pLObjTgt,&tgt);
			HSD_LObjGetColor   (pLObjTgt,&color);
			OSReport("%.3f,%.3f,%.3f\n",pos.x,pos.y,pos.z);
			OSReport("%.3f,%.3f,%.3f\n",tgt.x,tgt.y,tgt.z);
			OSReport("%d,%d,%d\n",color.r,color.g,color.b);
		}
	}
	
	switch( mLightEditProc ){
	case	0:
		if( HSD_PadGetRepeat(1) & HSD_PAD_RIGHT ){
			mLightID++;
		}
		if( HSD_PadGetRepeat(1) & HSD_PAD_LEFT ){
			mLightID--;
		}
		if( mLightID < -1 ){
			mLightID = WK7Light::GetCount()-1;
		}else if( mLightID >= WK7Light::GetCount() ){
			mLightID = -1;
		}
		if( (HSD_PadGetButton(1) & HSD_PAD_A) && (HSD_PadGetTrigger(1) & HSD_PAD_Y) ){
			if( pLight==NULL ){
				if( (pLight=WK7Light::Create(&new_dir_light_desc,K7OBJTYPE_PLAY|(WK7PLAY_RES_MODEL<<WK7PLAY_RES_ID_SHIFT),light_id++))!=NULL ){
					mLightID = 0;
					break;
				}
			}else if( pLight==mpDefLight ){
				break;
			}else{
				delete pLight;
				pLight = NULL;
				break;
			}
		}
		break;
	case	1:
		if( pLight==NULL ){
			break;
		}
		if( HSD_PadGetRepeat(1) & (HSD_PAD_LEFT|HSD_PAD_RIGHT) ){
			if( pLight->GetEnable()==true ){
				pLight->SetEnable(false);
			}else{
				pLight->SetEnable(true);
			}
		}
		break;
	case	2:
		if( pLObj==NULL ){
			break;
		}else{
			GXColor		color;
			int			val,d;
			HSD_LObjGetColor(pLObj,&color);
			val = color.r;
			if( HSD_PadGetButton(1) & HSD_PAD_A ){
				d = 4;
			}else{
				d = 1;
			}
			if( HSD_PadGetRepeat(1) & HSD_PAD_LEFT ){
				val -= d;
			}
			if( HSD_PadGetRepeat(1) & HSD_PAD_RIGHT ){
				val += d;
			}
			if( val < 0 ){
				val = 0;
			}else if( val > 255 ){
				val = 255;
			}
			color.r = (u8)val;
			color.g = (u8)val;
			color.b = (u8)val;
			HSD_LObjSetColor(pLObj,color);
		}
		break;
	default:
		mLightEditProc = 0;
		break;
	}
	
	if( pLight==NULL ){
		return false;
	}
	
	if( (pLObj = GetLObj(pLight,LOBJ_INFINITE))==NULL ){
		return false;
	}
	
	f32			x = HSD_PadGetNormalSubStickX(1);
	f32			y = HSD_PadGetNormalSubStickY(1);
	
	if( x==0.0f && y==0.0f ){
		return false;
	}
	
	Vec			pos;
	f32			dist;
	f32			rotx,roty;
	
	HSD_LObjGetPosition(pLObj,&pos);
	
	dist = GHM_VEC_GET_LEN(&pos);
	roty = sqrtf(pos.x * pos.x + pos.z * pos.z);
	rotx = atan2f(pos.y,roty);
	roty = atan2f(pos.x,pos.z);
	
#define	ROT_SPD_DEFAULT		(0.03125f * 60.0f / WK7_FRAME_RATE);
#define	ROTX_MARGIN			(0.0001f)
	roty += x * ROT_SPD_DEFAULT;
	rotx += y * ROT_SPD_DEFAULT;
	GHM_LIMIT      (rotx,HALF_PI - ROTX_MARGIN,-HALF_PI + ROTX_MARGIN);
	GHM_LIMIT_RANGE(roty,PI,-PI);
	
	pos.y = cosf(rotx);
	pos.z = pos.y * cosf(roty);
	pos.x = pos.y * sinf(roty);
	pos.y = sinf(rotx);
	VECScale(&pos,&pos,dist);
	
	HSD_LObjSetPosition(pLObj,&pos);
	
	return true;
}

#define	CIRCLE_DIVNUM		(32)
bool RenderCircle(Vec &center,Vec &rotaxis,f32 radius,u32 color);
bool RenderCircle(Vec &center,Vec &rotaxis,f32 radius,u32 color)
{
	Vec		pos,pos0;
	Mtx		mtx,tmtx;
	f32		ang;
	int		i;
	
	if( rotaxis.x==0.0f && rotaxis.z==0.0f ){
		pos.x = 1.0f;
		pos.y = 0.0f;
		pos.z = 0.0f;
	}else{
		pos.x = 0.0f;
		pos.y = 1.0f;
		pos.z = 0.0f;
	}
	VECCrossProduct(&rotaxis,&pos,&pos);
	VECNormalize   (&pos,&pos);
	VECScale       (&pos,&pos0,radius);
	
	MTXTrans(tmtx,center.x,center.y,center.z);
	
	GXBegin(GX_LINESTRIP,GX_VTXFMT0,CIRCLE_DIVNUM+1);
		
	ang = -PI;
	for(i=0 ; i<CIRCLE_DIVNUM ; i++,ang+=(TWO_PI/CIRCLE_DIVNUM)){
		
		MTXRotAxisRad(mtx,&rotaxis,ang);
		MTXConcat    (tmtx,mtx,mtx);
		MTXMultVec   (mtx,&pos0,&pos);
		
		GXPosition3f32(pos.x,pos.y,pos.z);
		GXColor1u32   (color);
		
	}
	
	MTXRotAxisRad(mtx,&rotaxis,-PI);
	MTXConcat    (tmtx,mtx,mtx);
	MTXMultVec   (mtx,&pos0,&pos);
	GXPosition3f32(pos.x,pos.y,pos.z);
	GXColor1u32   (color);
	
	GXEnd();
	
	return true;
}

bool WK7ViewerTask::RenderProcessEditModeLightEdit(void)
{
	if( WK7CAM->IsDebugMode()==false ){
		return true;
	}
	
	WK7Light	*pLight;
	HSD_LObj	*pLObj;
	pLight = GetLight(mLightID);
	
	if( pLight==NULL ){
		return true;
	}
	
	if( (pLObj = GetLObj(pLight,LOBJ_INFINITE))==NULL ){
		return true;
	}
	
	Vec			pos,tgt,dir;
	f32			dist;
	u32			color = 0xffff00ff;
	Mtx			mtx;
	
	WK7CAM->GetViewingMtxCurrent(mtx);
	WK7CAM->GetTargetPosition   (tgt);
	WK7CAM->GetPosition         (pos);
	dist = GHM_VEC_GET_DIST(&tgt,&pos) * 0.125f;
	HSD_LObjGetPosition(pLObj,&dir);
	VECNormalize(&dir,&dir);
	VECScale    (&dir,&dir,dist);
	VECAdd      (&dir,&tgt,&pos);
	
	if( WK7CAM->SetCurrent()==true ){
		
		GXLoadPosMtxImm   (mtx,GX_PNMTX0);
		GXLoadNrmMtxImm   (mtx,GX_PNMTX0);
		GXSetCurrentMtx   (GX_PNMTX0);
		
		GXSetCullMode     (GX_CULL_NONE);
		
		GXSetZMode        (GX_TRUE,GX_LEQUAL,GX_TRUE);
		GXSetZCompLoc     (GX_FALSE);
		GXSetColorUpdate  (GX_TRUE);
		GXSetAlphaUpdate  (GX_FALSE);
		
		GXClearVtxDesc    ();
		GXSetVtxDesc      (GX_VA_POS ,GX_DIRECT);
		GXSetVtxDesc      (GX_VA_CLR0,GX_DIRECT);
		
		GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_F32  ,0);
		GXSetVtxAttrFmt   (GX_VTXFMT0,GX_VA_CLR0,GX_CLR_RGBA,GX_RGBA8,0);
		
		GXSetNumTexGens   (0);
		
		GXSetNumTevStages (1);
		GXSetTevOp        (GX_TEVSTAGE0,GX_PASSCLR);
		GXSetTevOrder     (GX_TEVSTAGE0,GX_TEXCOORD_NULL,GX_TEXMAP_NULL,GX_COLOR0A0);
		
static	Vec		yaxis = { 0.0f , 1.0f , 0.0f };
		Vec		rotaxis;
		RenderCircle(tgt,yaxis,dist,0x008000ff);
		if( dir.x==0.0f && dir.z==0.0f ){
			rotaxis.x = 1.0f;
			rotaxis.y = 0.0f;
			rotaxis.z = 0.0f;
			dir    .x = 0.0f;
			dir    .y = 0.0f;
			dir    .z = dist;
		}else{
			rotaxis.x = -dir.z;
			rotaxis.y = 0.0f;
			rotaxis.z =  dir.x;
			dir    .y = 0.0f;
			VECNormalize(&dir,&dir);
			VECScale    (&dir,&dir,dist);
		}
		RenderCircle(tgt,rotaxis,dist,0x800000ff);
		
		GXBegin(GX_LINES,GX_VTXFMT0,10);
		
			GXPosition3f32(tgt.x,tgt.y,tgt.z);
			GXColor1u32   (color);
			
			GXPosition3f32(pos.x,pos.y,pos.z);
			GXColor1u32   (color);
			
			GXPosition3f32(tgt.x + dir.x,tgt.y,tgt.z + dir.z);
			GXColor1u32   (0x800000ff);
			
			GXPosition3f32(tgt.x - dir.x,tgt.y,tgt.z - dir.z);
			GXColor1u32   (0x800000ff);
			
			GXPosition3f32(tgt.x + dist,tgt.y,tgt.z);
			GXColor1u32   (0x008000ff);
			
			GXPosition3f32(tgt.x - dist,tgt.y,tgt.z);
			GXColor1u32   (0x008000ff);
			
			GXPosition3f32(tgt.x,tgt.y,tgt.z + dist);
			GXColor1u32   (0x008000ff);
			
			GXPosition3f32(tgt.x,tgt.y,tgt.z - dist);
			GXColor1u32   (0x008000ff);
			
			GXPosition3f32(tgt.x,tgt.y + dist,tgt.z);
			GXColor1u32   (0x800000ff);
			
			GXPosition3f32(tgt.x,tgt.y - dist,tgt.z);
			GXColor1u32   (0x800000ff);
			
		GXEnd();
		
		WK7CAM->EndCurrent();
	}
	
	return true;
}

bool WK7ViewerTask::FrameProcessEditMode(void)
{
	bool	result;
	switch( mEditMode ){
	case	VIEWER:
		result = FrameProcessEditModeViewer();
		break;
	case	MOTIONPLAY:
		result = FrameProcessEditModeMotionPlay();
		break;
	case	CAMEDIT:
		result = FrameProcessEditModeCamEdit();
		break;
	case	HIERARCHY:
		result = FrameProcessEditModeHierarchy();
		break;
	case	BLUREDIT:
		result = FrameProcessEditModeBlurEdit();
		break;
	case	LIGHTEDIT:
		result = FrameProcessEditModeLightEdit();
		break;
	default:
		result = false;
		break;
	}
	if( result==true ){
		return true;
	}
	if( ChangeEditMode()==true ){
		return true;
	}
	return false;
}

bool WK7ViewerTask::RenderProcessEditMode(void)
{
	bool	result = false;
	switch( mEditMode ){
	case	VIEWER:
//		result = RenderProcessEditModeViewer();
		break;
	case	MOTIONPLAY:
//		result = RenderProcessEditModeMotionPlay();
		break;
	case	CAMEDIT:
//		result = RenderProcessEditModeCamEdit();
		break;
	case	HIERARCHY:
//		result = RenderProcessEditModeHierarchy();
		break;
	case	BLUREDIT:
//		result = RenderProcessEditModeBlurEdit();
		break;
	case	LIGHTEDIT:
		result = RenderProcessEditModeLightEdit();
		break;
	default:
		break;
	}
	return result;
}

bool WK7ViewerTask::FrameProcessOperate(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	return FrameProcessEditMode();
}

bool WK7ViewerTask::RenderOperate(void)
{
	RenderInfo();
	
	RenderProcessEditMode();
	
	return true;
}

bool WK7ViewerTask::FrameProcessMenu(void)
{
	if( HSD_PadGetTrigger(0) & (HSD_PAD_START|HSD_PAD_B) ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( mProc >= 0 && mProc < WK7VIEWERMENUMITEM_NUM ){
		WK7ViewerMode		mode = viewerMenuItem[mProc].mMode;
		switch( mode ){
		case	WK7VIEWERMODE_CAMWOBBLESCALE:{
			int		d;
			if( HSD_PadGetButton(0) & HSD_PAD_Z ){
				if( HSD_PadGetButton(0) & HSD_PAD_A ){
					d = CAMWOBBLESCALE_UNIT;
				}else{
					d = CAMWOBBLESCALE_UNIT / 10;
				}
			}else{
				d = CAMWOBBLESCALE_UNIT / 100;
			}
			if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
				mCamWobbleScale -= d;
			}
			if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
				mCamWobbleScale += d;
			}
			if( mCamWobbleScale < 0 ){
				mCamWobbleScale = 0;
			}
			WK7CAM->SetWobblePosRate((f32)mCamWobbleScale / CAMWOBBLESCALE_UNIT);
			sprintf(camWobbleScaleStr,"%.3f",WK7CAM->GetWobblePosRate());
			}break;
		case	WK7VIEWERMODE_MOTIONRATE:{
			f32		rate = WK7Motion::GetWholeMotionRate();
			if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
				mFrameRate--;
			}
			if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
				mFrameRate++;
			}
			if( mFrameRate < -8 ){
				rate = 0.0f;
			}else if( mFrameRate < 0 ){
				int		cnt;
				rate = 1.0f;
				for(cnt=mFrameRate ; cnt<0 ; cnt++){
					rate *= 0.5f;
				}
			}else{
				rate = (f32)(mFrameRate+1);
			}
			sprintf(motionRateStr,"%f",rate);
			WK7Motion::SetWholeMotionRate(rate);
			}break;
		default:
			break;
		}
	}
	if( HSD_PadGetTrigger(0) & (HSD_PAD_LEFT|HSD_PAD_RIGHT) ){
		if( mProc >= 0 && mProc < WK7VIEWERMENUMITEM_NUM ){
			WK7ViewerMode		mode = viewerMenuItem[mProc].mMode;
			switch( mode ){
			case	WK7VIEWERMODE_DEFLIGHT:
				if( mDefLight==true ){
					mDefLight = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mDefLight = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			case	WK7VIEWERMODE_WALKAREA:
				if( mainMenu.IsEneWalkArea()==true ){
					SetWalkArea(false);
				}else{
					SetWalkArea(true);
				}
				break;
			case	WK7VIEWERMODE_CAMWOBBLE:
				if( WK7CAM->GetWobbleEnable()==true ){
					SetCamWobble(false);
				}else{
					SetCamWobble(true);
				}
				break;
			case	WK7VIEWERMODE_CINEMASCOPE:
				if( WK7CAM->GetCinemaScopeMode()==true ){
					SetCinemaScope(false);
				}else{
					SetCinemaScope(true);
				}
				break;
			case	WK7VIEWERMODE_HITOBJCHECK:
				if( mHitObjCheck==true ){
					SetHitObjCheck(false);
				}else{
					SetHitObjCheck(true);
				}
				break;
			case	WK7VIEWERMODE_STREAM:
				if( mStreamFlag==true ){
					SetStream(false);
				}else{
					SetStream(true);
				}
				break;
			case	WK7VIEWERMODE_MOTIONLOOP:
				if( WK7ViewerModel::GetMotionLoopAll()==true ){
//				if( mMotionLoop==true ){
//					mMotionLoop = false;
					WK7ViewerModel::SetMotionLoopAll(false);
				}else{
//					mMotionLoop = true;
					WK7ViewerModel::SetMotionLoopAll(true);
				}
				break;
//			case	WK7VIEWERMODE_CAMMOTIONLOOP:
//				if( mCameraMotionLoop==true ){
//					mCameraMotionLoop = false;
//					viewerMenuItem[mProc].mpOption = "Off";
//				}else{
//					mCameraMotionLoop = true;
//					viewerMenuItem[mProc].mpOption = "On";
//				}
//				break;
			case	WK7VIEWERMODE_ORIGDISP:
				if( mOrigDisp==true ){
					mOrigDisp = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mOrigDisp = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			case	WK7VIEWERMODE_CAMTGTDISP:
				if( mCamTargetDisp==true ){
					mCamTargetDisp = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mCamTargetDisp = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			case	WK7VIEWERMODE_INFODISP:
				if( mInfoDisp==true ){
					mInfoDisp = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mInfoDisp = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			case	WK7VIEWERMODE_TEXTURE:
				if( mTextureVisible==true ){
					mTextureVisible = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mTextureVisible = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			case	WK7VIEWERMODE_SHADOW:
				if( mShadowTrigger==true ){
					mShadowTrigger = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mShadowTrigger = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				SetShadow();
				break;
			case	WK7VIEWERMODE_PERFMETER:
				if( mPerfMeter==true ){
					mPerfMeter = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mPerfMeter = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				k7app.SetVisiblePerfMeter(mPerfMeter);
				k7app.SetEnablePerfMeter (mPerfMeter);
				break;
			case	WK7VIEWERMODE_RENDERMEMORY:
				if( mRenderMemory==true ){
					mRenderMemory = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mRenderMemory = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				ghmGcMem::SetRender(mRenderMemory);
				break;
			case	WK7VIEWERMODE_SCREENTONE:
				if( mScreenTone==true ){
					mScreenTone = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mScreenTone = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				return false;
			case	WK7VIEWERMODE_GXWARNING:
				if( mainMenu.GetGxWarning()==true ){
					SetGXWarning(false);
				}else{
					SetGXWarning(true);
				}
				break;
			case	WK7VIEWERMODE_MODEINFO:
				if( mainMenu.GetModeInfo()==true ){
					SetModeInfo(false);
				}else{
					SetModeInfo(true);
				}
				break;
			case	WK7VIEWERMODE_ZANDEBUGINFO:
#ifdef	_DEBUG
				if( WK7Zan::GetDebugInfo()==true ){
					SetZanDebugInfo(false);
				}else{
					SetZanDebugInfo(true);
				}
#endif
				break;
			case	WK7VIEWERMODE_PLAYENDSTOP:
				if( mPlayEndStop==true ){
					mPlayEndStop = false;
					viewerMenuItem[mProc].mpOption = "Off";
				}else{
					mPlayEndStop = true;
					viewerMenuItem[mProc].mpOption = "On";
				}
				break;
			default:
				break;
			}
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		if( mProc >= 0 && mProc < WK7VIEWERMENUMITEM_NUM ){
			WK7ViewerMode		mode = viewerMenuItem[mProc].mMode;
			switch( mode ){
//			case	WK7VIEWERMODE_MODELLOAD:
//				ReleaseModelArchive();
//				break;
			case	WK7VIEWERMODE_STAGELOAD:
				ReleaseStageArchive();
				break;
			case	WK7VIEWERMODE_CAMMOTIONLOAD:
				ReleaseCamMotionArchive();
				break;
			default:
				return false;
			}
		}
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( mProc >= 0 && mProc < WK7VIEWERMENUMITEM_NUM ){
			WK7ViewerMode		mode = viewerMenuItem[mProc].mMode;
			switch( mode ){
			case	WK7VIEWERMODE_TEXTURE:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("bin");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_MOTIONLOAD_MODELSELECT:
//			case	WK7VIEWERMODE_MOTIONLOAD:
//				mFileList.ReleaseFileList();
//				mFileList.CreateFileList(mUsbServ,"dat");
//				break;
				SetMode(mode);
				return true;
			case	WK7VIEWERMODE_MODELSELECT:
				SetMode(mode);
				return true;
			case	WK7VIEWERMODE_CHANGEDISK:
				mReqDiskID = ghmGcFile::GetCurrentDiskID();
				SetMode(mode);
				return true;
//			case	WK7VIEWERMODE_MODELLOAD:
//				mFileList.ReleaseFileList();
//				mFileList.SetFilter("dat");
//				mFileList.CreateFileList(mUsbServ);
//				break;
			case	WK7VIEWERMODE_STAGELOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("dat");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_PLAYLOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("rsl");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_CAMMOTIONLOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("dat");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_ZANLOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("zan");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_SYSMESLOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("jmb");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_MOVIELOAD:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("h4m");
				mFileList.CreateFileList(mUsbServ);
				break;
			case	WK7VIEWERMODE_EXIT:
				SetMode(mode);
				return true;
			default:
				return false;
			}
			if( mFileList.GetFileNum() > 0 ){
				SetMode(mode);
				return true;
			}
		}
	}
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mProc--;
		mCursor--;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_UP ){
		mProc  -= d;
		mCursor-= d;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mProc++;
		mCursor++;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_DOWN ){
		mProc  += d;
		mCursor+= d;
	}
#define	MENU_DISP_MAX		(24)
	RenewCursorRange(WK7VIEWERMENUMITEM_NUM,MENU_DISP_MAX);
	return false;
}

bool WK7ViewerTask::RenderMenu(void)
{
	C_Paper				paper(0,0,0.75f);
	int					i,c;
	WK7ViewerMenuItem	*pMenuItem;
	const char			*pCursor;
	
	PRINTF("\n\n Killer7 Viewer - Ver " VER "\n\n");
	
	i = mProc - mCursor;
	pMenuItem = viewerMenuItem + i;
	
	for(c=0 ; c<MENU_DISP_MAX && i<WK7VIEWERMENUMITEM_NUM ; i++,c++,pMenuItem++){
		if( c==mCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( pMenuItem->mpOption==NULL ){
			PRINTF(" %s %s\n",pCursor,pMenuItem->mpItem);
		}else{
			PRINTF(" %s %-20s : %s\n",pCursor,pMenuItem->mpItem,pMenuItem->mpOption);
		}
	}
	
	return true;
}

#define	MODEL_FILELIST_DISPMAX		(13)
//#define	MODEL_FILELIST_DISPMAX		(10)
bool WK7ViewerTask::FrameProcessModelSelect(bool newmodel)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ReleaseModel(mProc,false);
		return true;
	}
	int		modelnum = mModelNum;
	if( newmodel==true ){
		modelnum++;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( mProc >= 0 && mProc < modelnum ){
			mSelectModel = mProc;
			switch( mMode ){
			case	WK7VIEWERMODE_MODELSELECT:
				mFileList.ReleaseFileList();
				mFileList.SetFilter("dat");
				mFileList.CreateFileList(mUsbServ);
				if( mFileList.GetFileNum() > 0 ){
					SetMode(WK7VIEWERMODE_MODELLOAD);
				}
				break;
			case	WK7VIEWERMODE_MOTIONLOAD_MODELSELECT:
				SetMode(WK7VIEWERMODE_MOTIONLOAD);
				break;
			default:
				return false;
			}
			return true;
		}
	}
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mProc--;
		mCursor--;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_UP ){
		mProc  -= d;
		mCursor-= d;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mProc++;
		mCursor++;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_DOWN ){
		mProc  += d;
		mCursor+= d;
	}
	RenewCursorRange(modelnum,MODEL_FILELIST_DISPMAX);
	return false;
}

bool WK7ViewerTask::RenderModelSelect(bool newmodel)
{
	C_Paper				paper(0,0,0.75f);
	int					i,c;
	const char			*pCursor;
	const char			*pFileName;
	const char			*pVersionStr;
	WK7ViewerModel		*pModel;
	int					modelnum;
	
	modelnum = mModelNum;
	if( newmodel==true ){
		modelnum++;
	}
	
	i = mProc - mCursor;
	pModel = GetModel(i);
	
	PRINTF("\n\n  <Model List>\n\n");
	
	for(c=0 ; c<MODEL_FILELIST_DISPMAX && i<modelnum ; i++,c++){
		if( c==mCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( i==mModelNum ){
			PRINTF(" %s --- New Model ---\n",pCursor);
		}else{
			if( pModel==NULL ){
				break;
			}
			if( (pFileName = pModel->GetFileName())==NULL ){
				pFileName = "--- Not Loaded ---";
			}
			if( (pVersionStr = pModel->GetArchiveVersionStr())==NULL ){
				pVersionStr = "-.--";
			}
			PRINTF(" %s %s %s\n",pCursor,pVersionStr,pFileName);
			pModel = pModel->GetNext();
		}
	}
	return true;
}

bool WK7ViewerTask::SelectFile(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_LEFT ){
		if( mFileList.GetDirLevel()!=0 ){
			mProc = 0;
			return true;
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		return true;
	}
	return false;
}
bool WK7ViewerTask::FrameProcessModelLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MODELSELECT);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ReleaseModel(mSelectModel,false);
//		ReleaseModelArchive();
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					StopMotion();
					if( LoadModel(filename)==true ){
						WK7ViewerModel::SetMotionPlayAll(true);
						MotionTrigger();
						SetMode(WK7VIEWERMODE_OPERATE);
						return true;
					}
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderModelLoad(void)
{
	
	RenderFileList("  <Model Load>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessStageLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ReleaseStageArchive();
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					if( LoadStage(filename)==true ){
						C_LightSet		*pLightSet = mpStageArchive->GetLightSet(0);
						// epCg擾
						WK7Light			*pLight;
						WK7Light			*pShadowLight = NULL;
						WK7LightFindData	data;
						HSD_LObj			*pLObj;
						data.Initialize();
						while( (pLight=WK7Light::Find(data))!=NULL ){
							pLObj = pLight->GetHSDLObj();
							switch( HSD_LObjGetType(pLObj) ){
							case	LOBJ_INFINITE:
								pShadowLight = pLight;
								break;
							case	LOBJ_POINT:
							case	LOBJ_SPOT:
								if( pShadowLight!=NULL ){
									break;
								}
								pShadowLight = pLight;
								continue;
							case	LOBJ_AMBIENT:
							default:
								continue;
							}
							break;
						}
						if( pShadowLight!=NULL ){
							WK7SHADOW->SetLight(pShadowLight->GetHSDLObj());
						}else{
							WK7SHADOW->SetLight(NULL);
						}
						CreateLObj(pLightSet);
						SetMode(WK7VIEWERMODE_OPERATE);
						return true;
					}
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderStageLoad(void)
{
	
	RenderFileList("  <Stage Load>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessMotionLoadModelSelect(void)
{
	return FrameProcessModelSelect(false);
}

bool WK7ViewerTask::RenderMotionLoadModelSelect(void)
{
	return RenderModelSelect(false);
}

#define	MOTION_FILELIST_DISPMAX		(13)
//#define	MOTION_FILELIST_DISPMAX		(10)
bool WK7ViewerTask::FrameProcessMotionLoad(void)
{
	WK7ViewerModel	*pModel = GetModel(mSelectModel);
	if( pModel==NULL ){
		SetMode(WK7VIEWERMODE_MOTIONLOAD_MODELSELECT);
		return true;
	}
	int				motionNum = pModel->GetMotionNum();
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MOTIONLOAD_MODELSELECT);
//		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ReleaseMotionArchive(mSelectModel,mProc,false);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( mProc >= 0 && mProc <= motionNum ){
			mSelectMotion = mProc;
			mFileList.ReleaseFileList();
			mFileList.SetFilter("dat");
			mFileList.CreateFileList(mUsbServ);
			if( mFileList.GetFileNum() > 0 ){
				SetMode(WK7VIEWERMODE_MOTIONLOADSUB);
			}
			return true;
		}
	}
	if( mProc != motionNum ){
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			mProcSub++;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			mProcSub--;
		}
		if( mProcSub < 0 ){
			mProcSub = 2;
		}else if( mProcSub > 2 ){
			mProcSub = 0;
		}
	}
	WK7ViewerMotion		*pMotion = pModel->GetMotion(mProc);
	switch( mProcSub ){
	case	1:
		if( pMotion!=NULL ){
			if( HSD_PadGetRepeat(0) & (HSD_PAD_UP|HSD_PAD_DOWN) ){
				pMotion->mInterpolate = pMotion->mInterpolate==true? false : true;
			}
		}
		return false;
	case	2:
		if( pMotion!=NULL ){
			if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
				pMotion->mInterpolateFrame += 1.0f;
			}
			if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
				pMotion->mInterpolateFrame -= 1.0f;
			}
			if( pMotion->mInterpolateFrame < 0.0f ){
				pMotion->mInterpolateFrame = 0.0f;
			}
		}
		return false;
	default:
		break;
	}
	int			d;
	d = (int)(fabs(HSD_PadGetNormalStickY(0) * 4.0f));
	if( HSD_PadGetRepeat(0) & HSD_PAD_UP ){
		mProc--;
		mCursor--;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_UP ){
		mProc  -= d;
		mCursor-= d;
	}
	if( HSD_PadGetRepeat(0) & HSD_PAD_DOWN ){
		mProc++;
		mCursor++;
	}else if( HSD_PadGetRepeat(0) & HSD_PAD_STICK_DOWN ){
		mProc  += d;
		mCursor+= d;
	}
	RenewCursorRange(motionNum+1,MOTION_FILELIST_DISPMAX);
	return false;
}

bool WK7ViewerTask::RenderMotionLoad(void)
{
	WK7ViewerModel	*pModel = GetModel(mSelectModel);
	if( pModel==NULL ){
		return true;
	}
	
	C_Paper				paper(0,0,0.75f);
	int					i,c;
	const char			*pCursor;
	const char			*pFileName;
	const char			*pVersionStr;
	WK7ViewerMotion		*pMotion;
	int					motionNum = pModel->GetMotionNum();
	
	i = mProc - mCursor;
	pMotion = pModel->GetMotion(i);
	
	if( (pFileName=pModel->GetFileName())==NULL ){
		pFileName = "---";
	}
	
	PRINTF("\n\n  <Motion List> : %s\n\n",pFileName);
	
	for(c=0 ; c<MOTION_FILELIST_DISPMAX && i<=motionNum ; i++,c++){
		if( c==mCursor ){
			pCursor = ">";
		}else{
			pCursor = " ";
		}
		if( i==motionNum ){
			PRINTF(" %s --- New Motion ---\n",pCursor);
		}else{
			if( pMotion==NULL ){
				break;
			}
			if( (pFileName = pMotion->mpFileName)==NULL ){
				pFileName = "--- Not Loaded ---";
			}
			if( (pVersionStr = pMotion->GetArchiveVersionStr())==NULL ){
				pVersionStr = "-.---";
			}
			PRINTF(" %s %s %s\n",pCursor,pVersionStr,pFileName);
			PRINTF("     %-3s %.0f\n",pMotion->mInterpolate==true? "On":"Off",pMotion->mInterpolateFrame);
			pMotion = pMotion->GetNext();
		}
	}
	
	return true;
}

bool WK7ViewerTask::FrameProcessMotionLoadSub(void)
{
	WK7ViewerModel	*pModel = GetModel(mSelectModel);
	if( pModel==NULL ){
		SetMode(WK7VIEWERMODE_MOTIONLOAD);
		return true;
	}
	int		motionNum = pModel->GetMotionNum();
	
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		int		cursor = mPrevCursor;
		SetMode(WK7VIEWERMODE_MOTIONLOAD);
		mCursor = cursor;
		mProc = mSelectMotion;
		RenewCursorRange(motionNum+1,MOTION_FILELIST_DISPMAX);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		pModel->ReleaseMotion(mSelectMotion,false);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					StopMotion();
					if( LoadMotion(filename)==true ){
						int		cursor = mPrevCursor;
						WK7ViewerModel::SetMotionPlayAll(true);
						MotionTrigger();
						SetMode(WK7VIEWERMODE_MOTIONLOAD);
						mCursor = cursor;
						mProc = mSelectMotion;
						RenewCursorRange(motionNum+1,MOTION_FILELIST_DISPMAX);
						return true;
					}
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList(mFileList.GetFileNum(),FILELIST_DISPMAX-1);
	return false;
}

bool WK7ViewerTask::RenderMotionLoadSub(void)
{
	WK7ViewerModel	*pModel = GetModel(mSelectModel);
	char			str[512];
	
	if( pModel==NULL ){
		return true;
	}
	const char		*pFileName;
	if( (pFileName=pModel->GetFileName())==NULL ){
		pFileName = "---";
	}
	sprintf(str,"  <Motion Load> : %s\n"
	            "               ",pFileName);
	
	RenderFileList(str,FILELIST_DISPMAX);
	
	return true;
}

bool WK7ViewerTask::FrameProcessTextureLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					GHMGCMEM_SAFE_FREE(mpTexture);
					ghmGcFile		file;
					if( file.Open(filename)==false ){
						return false;
					}
					if( (mpTexture = (GhmGcTexHeader *)file.ReadB())==NULL ){
						return false;
					}
					SetMode(WK7VIEWERMODE_OPERATE);
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderTextureLoad(void)
{
	RenderFileList("  <Texture Load>");
	
	return true;
}

#define	RELEASEDATA
extern	int		captureFrameStart;
static	int		mode = 0;
bool WK7ViewerTask::FrameProcessPlayLoad(void)
{
#if defined(RELEASEDATA)
static	int		proc = 0;
	if( proc ){
		if( WK7EVENTCONTROLLER->IsReleasedTempData2()==true ){
			proc = 0;
			goto play_charageki;
		}
		return true;
	}
#endif
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
#if defined(RELEASEDATA)
				if( WK7EVENTCONTROLLER->IsLoadedData()==false ){
					return true;
				}
				WK7EVENTCONTROLLER->ReleaseTempData2();
				proc++;
				return true;
play_charageki:
#endif
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					void		*pResource;
					ghmGcFile	file;
					if( file.Open(filename)==false ){
						return false;
					}
					if( (pResource = file.ReadB())==NULL ){
						return false;
					}
					GHM_SAFE_DELETE(mpPlay);
					GHMGCMEM_SAFE_FREE(mpPlayResource);
					mpPlayResource = pResource;
//#ifdef	USE_USB
					int		i;
					i = (int)strlen(filename);
					filename[i+1] = '\0';
					for(i-- ; i>=0 ; i--){
						filename[i+1] = filename[i];
					}
					filename[0] = '/';
//#endif
					if( (mpPlay = WK7Play::Create(pResource,filename))==NULL ){
						GHMGCMEM_SAFE_FREE(mpPlayResource);
						return false;
					}
					WK7CAM->GetPosition      (mCamStorePosition      );
					WK7CAM->GetTargetPosition(mCamStoreTargetPosition);
					mpPlay->Start();
					WK7SHADOW->SetEnable(true);
					SceneBlur.SetVisible(true);
					SetMode(WK7VIEWERMODE_PLAY);
					mPlayProc        = 0;
					mPlayCount       = 0;
					mPlayStartTime   = 0.0f;
					mPlayWaitTime    = 0.0f;
#if	defined(USE_USB) && defined(_DEBUG)
					captureFrameStart = mCaptureFrame;
#endif
					return true;
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	if( !(HSD_PadGetButton(1) & HSD_PAD_B) ){
		if( HSD_PadGetRepeat(1) & HSD_PAD_RIGHT ){
			mCaptureFrameIndex--;
		}
		if( HSD_PadGetRepeat(1) & HSD_PAD_LEFT ){
			mCaptureFrameIndex++;
		}
	}
#define	CAPTURE_FRAME_INDEX_MAX		(4)
	if( mCaptureFrameIndex < 0 ){
		mCaptureFrameIndex = CAPTURE_FRAME_INDEX_MAX;
	}else if( mCaptureFrameIndex > CAPTURE_FRAME_INDEX_MAX ){
		mCaptureFrameIndex = 0;
	}
	int		frame = mCaptureFrame;
	int		i,t;
	for(i=0 ; i<mCaptureFrameIndex ; i++){
		frame /= 10;
	}
	frame %= 10;
	for(i=0,t=frame ; i<mCaptureFrameIndex ; i++,t*=10){}
	mCaptureFrame -= t;
	switch( HSD_PadGetRepeat(1) & (HSD_PAD_DOWN|HSD_PAD_UP) ){
	case	HSD_PAD_DOWN:
		frame--;
		if( frame < 0 ){
			frame = 9;
		}
		break;
	case	HSD_PAD_UP:
		frame++;
		if( frame > 9 ){
			frame = 0;
		}
		break;
	default:
		break;
	}
	for(i=0 ; i<mCaptureFrameIndex ; i++){
		frame *= 10;
	}
	mCaptureFrame += frame;
	if( HSD_PadGetButton(1) & HSD_PAD_B ){
		if( HSD_PadGetRepeat(1) & HSD_PAD_LEFT ){
			mode--;
			if( mode < 0 ){
				mode = 2;
			}
		}
		if( HSD_PadGetRepeat(1) & HSD_PAD_RIGHT ){
			mode++;
			if( mode > 2 ){
				mode = 0;
			}
		}
	}
	if( HSD_PadGetTrigger(1) & HSD_PAD_A ){
		switch( mode ){
		case	0:
			SETCAPTUREMODE(!GETCAPTUREMODE());
			break;
		case	1:
			SETPLAYCAPTUREMODE(!GETPLAYCAPTUREMODE());
			break;
		case	2:
			SETPS2MODE(!GETPS2MODE());
			break;
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_RIGHT ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.IsFile(mProc)==true ){
				WK7ViewerPlay	*pPlay = CreatePlay();
				if( pPlay!=NULL ){
					pPlay->SetFileName(mFileList.GetFileName(mProc));
					pPlay->SetDirName (mFileList.GetDirName());
					return true;
				}
			}
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_LEFT ){
		if( RemovePlay(mPlayNum-1)==true ){
			return true;
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_X ){
		if( mPlayNum > 0 ){
			SetMode(WK7VIEWERMODE_SEQPLAY);
			mCurrentPlay = 0;
			if( (mPlayTaskID = mFrameProcessTaskController.Start(SeqPlayTask,(u32)this)) >= 0 ){
				return true;
			}
		}
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ClearPlay();
		return true;
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderPlayLoad(void)
{
	RenderFileList("  <Chara Geki Load>");
	
	{
		C_Paper				paper(320,72,0.75f);
		WK7ViewerPlay		*pPlay = (WK7ViewerPlay *)mPlayAnchor.GetNext();
		PRINTF("%30s\n","<SEQ Play List>");
		PRINTF("%30s\n","Play -> X , Clear -> Y");
		while( pPlay!=NULL ){
			PRINTF("%30s\n",pPlay->GetFileName());
			pPlay = pPlay->GetNext();
		}
	}
	
	{
		C_Paper				paper(320,320,0.75f);
		char				bar[16];
		int					i,imax = (5-1)-mCaptureFrameIndex;
		for(i=0 ; i<imax ; i++){ bar[i]=' '; }
		bar[i  ] = '^';
		bar[i+1] = '\0';
		PRINTF("Capture Frame : %5d\n",mCaptureFrame);
		PRINTF("                %s\n",bar);
		PRINTF("%c%c%c\n",GETCAPTUREMODE    ()==true ? 'O':'.',
		                  GETPLAYCAPTUREMODE()==true ? 'O':'.',
		                  GETPS2MODE        ()==false? 'O':'.');
		for(i=0 ; i<3 ; i++){
			if( mode==i ){
				bar[i] = '^';
			}else{
				bar[i] = ' ';
			}
		}
		bar[i] = '\0';
		PRINTF("%s\n",bar);
	}
	
	return true;
}

bool WK7ViewerTask::ReleasePlay(void)
{
	GHM_SAFE_DELETE(mpPlay);
	GHMGCMEM_SAFE_FREE(mpPlayResource);
	GHM_SAFE_DELETE(mpPrevPlay);
	GHMGCMEM_SAFE_FREE(mpPrevPlayResource);
	k7app.SetFadeColor(0);
	k7app.FadeStart(0,0);
	WK7CAM->StopMotion  ();
	WK7CAM->DetachMotion();
	WK7CAM->SetDesc          (NULL);
	WK7CAM->SetPosition      (mCamStorePosition      );
	WK7CAM->SetTargetPosition(mCamStoreTargetPosition);
	WK7CAM->StopInterpolate();
	SetCamWobble  (mCamWobble  );
	SetCinemaScope(mCinemaScope);
	SceneBlur.SetVisible(mSceneBlurVisible);
	SetShadow();
	gpSound->mStopStream();
#if defined(RELEASEDATA)
	WK7EVENTCONTROLLER->LoadData();
#endif
	return true;
}

bool WK7ViewerTask::FrameProcessPlay(void)
{
	if( HSD_PadGetTrigger(0)==HSD_PAD_B && (HSD_PadGetButton(0) & HSD_PAD_A) ){
		SetMode(WK7VIEWERMODE_PLAYLOAD);
		ReleasePlay();
		return true;
	}
	if( mpPlay==NULL ){
		SetMode(WK7VIEWERMODE_OPERATE);
		ReleasePlay();
		return true;
	}
	if( mpPlay->GetState()==WK7Play::PLAYED ){
		if( mPlayEndStop==true && !(HSD_PadGetTrigger(0) & HSD_PAD_A) ){
			return true;
		}
		SetMode(WK7VIEWERMODE_PLAYLOAD);
		ReleasePlay();
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		switch( mPlayProc ){
		case	0:
			mPlayStartTime=(f32)mpPlay->GetPlayCount() / 60.0f;
			break;
		case	1:
			mPlayWaitTime =(f32)mpPlay->GetPlayCount() / 60.0f - mPlayStartTime;
			OSReport("%3d\t%.3f\t%.3f\n",mPlayCount,mPlayStartTime,mPlayWaitTime);
			mPlayCount++;
			break;
		}
		mPlayProc ^= 1;
	}
#if 0
static	bool	trig = true;
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		if( trig==true ){
			trig = false;
			WK7CAM->StopMotion();
		}else{
			trig = true;
			WK7CAM->ReplayMotion();
		}
	}
	if( trig==false ){
		if( HSD_PadGetRepeat(0) & HSD_PAD_Y ){
			WK7CAM->ReplayMotion();
		}else{
			WK7CAM->StopMotion();
		}
	}
#endif
	
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		if( WK7CAM->IsDebugMode()==true ){
			WK7CAM->ExitDebugMode();
			mpPlay->SetStopScript(false);
		}else{
			WK7CAM->EnterDebugMode();
			mpPlay->SetStopScript(true);
			WK7CAM->StopInterpolate();
		}
	}
	if( WK7CAM->IsDebugMode()==true ){
		return FrameProcessEditMode();
	}
	return false;
}

bool WK7ViewerTask::RenderPlay(void)
{
	RenderInfo();
	RenderProcessEditMode();
	if( mInfoDisp==true ){
		C_Paper		paper(32,32);
	//	PRINTF("CharaGeki Play - %06x%d\n",mZanID & 0xffffff,mZanMesID);
		if( mPlayProc ){
			PRINTF(" %.3f -> ----\n",mPlayStartTime);
		}else{
			PRINTF(" %.3f -> %.3f\n",mPlayStartTime,mPlayWaitTime);
		}
	}
	return true;
}

#ifndef	USE_ISDOLVIEWER
#define	TTYPRINTF(...)	TTYPrintf(__VA_ARGS__)
#else
#define	TTYPRINTF(...)	
#endif

void WK7ViewerTask::_SeqPlayTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
//	char	str[256];
	
	WK7CAM->GetPosition      (mCamStorePosition      );
	WK7CAM->GetTargetPosition(mCamStoreTargetPosition);
	SceneBlur.SetVisible(true);
	WK7SHADOW->SetEnable(true);
	
	GHM_SAFE_DELETE(mpPlay);
	GHM_SAFE_DELETE(mpPrevPlay);
	while( mCurrentPlay < mPlayNum ){
		WK7ViewerPlay	*pViewerPlay = GetPlay(mCurrentPlay);
		char			fname[256];
		pViewerPlay->GetFullFileName(fname);
		
//		sprintf(str,"CreatePlay : %s",fname);
//		K7AppDebugPrint(str);
//		OSReport("%s\n",str);
//		TTYPRINTF("%s\n",str);
		
		while( (mpPlay = WK7Play::Create(fname))==NULL ){
			if( mpPrevPlay!=NULL && mpPrevPlay->GetState()==WK7Play::PLAYED ){
				k7app.FadeStart(0xff,4800);
				k7app.SetFadeColor(0);
				while( k7app.IsFade()==true ){
					GHMGCTASK_RETSYS();
				}
				GHM_SAFE_DELETE(mpPrevPlay);
			}
			GHMGCTASK_RETSYS();
		}
		if( mpPrevPlay!=NULL ){
			while( mpPrevPlay->GetState()!=WK7Play::PLAYED ){
				GHMGCTASK_RETSYS();
			}
		}
		
//		sprintf(str,"LoadWaitPlay : %s",mpPlay->GetResourceName());
//		K7AppDebugPrint(str);
//		OSReport("%s\n",str);
//		TTYPRINTF("%s\n",str);
		
		while( mpPlay->GetState()!=WK7Play::LOADED ){
			GHMGCTASK_RETSYS();
		}
		GHMGCTASK_RETSYS();
		if( mpPrevPlay==NULL ){
			k7app.FadeStart(0x00,4800);
		}
		
//		sprintf(str,"StartPlay : %s",mpPlay->GetResourceName());
//		K7AppDebugPrint(str);
//		OSReport("%s\n",str);
//		TTYPRINTF("%s\n",str);
		
		mpPlay->Start();
		GHM_SAFE_DELETE(mpPrevPlay);
		mpPrevPlay = mpPlay;
		mpPlay     = NULL;
		mCurrentPlay++;
	}
	if( mpPrevPlay!=NULL ){
		while( mpPrevPlay->GetState()!=WK7Play::PLAYED ){
			GHMGCTASK_RETSYS();
		}
	}
	mCurrentPlay = -1;
	mPlayTaskID = -1;
	SetMode(WK7VIEWERMODE_PLAYLOAD);
	ReleasePlay();
}

void WK7ViewerTask::SeqPlayTask(ghmGcTask *pTask)
{
	WK7ViewerTask	*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	pViewerTask->_SeqPlayTask(pTask);
}

bool WK7ViewerTask::FrameProcessSeqPlay(void)
{
	if( HSD_PadGetTrigger(0)==HSD_PAD_B && (HSD_PadGetButton(0) & HSD_PAD_A) ){
		if( mPlayTaskID >= 0 ){
			mFrameProcessTaskController.Stop(mPlayTaskID);
			mPlayTaskID = -1;
		}
		SetMode(WK7VIEWERMODE_PLAYLOAD);
		ReleasePlay();
		k7app.SetFadeColor(0);
		k7app.FadeStart(0x00,0);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		if( WK7CAM->IsDebugMode()==true ){
			WK7CAM->ExitDebugMode();
			mpPlay->SetStopScript(false);
		}else{
			WK7CAM->EnterDebugMode();
			mpPlay->SetStopScript(true);
			WK7CAM->StopInterpolate();
		}
	}
	if( WK7CAM->IsDebugMode()==true ){
		return FrameProcessEditMode();
	}
	return false;
}

bool WK7ViewerTask::RenderSeqPlay(void)
{
	RenderInfo();
	RenderProcessEditMode();
	return true;
}

bool WK7ViewerTask::FrameProcessCamMotionLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_Y ){
		ReleaseCamMotionArchive();
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					if( LoadCamMotion(filename)==true ){
						SetMode(WK7VIEWERMODE_OPERATE);
						WK7ViewerModel::SetMotionPlayAll(true);
						MotionTrigger();
						return true;
					}
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderCamMotionLoad(void)
{
	RenderFileList("  <CamMotion Load>");
	
	return true;
}

bool WK7ViewerTask::MotionControl(void)
{
	WK7ViewerModel	*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	bool			result = true;
	int				playnum = 0;
	while( pModel!=NULL ){
		if( pModel->MotionControl()==false ){
			result = false;
		}else{
			playnum++;
		}
		pModel = pModel->GetNext();
	}
	if( WK7CAM->GetMotionState()!=AOBJ_NO_ANIM ){
		playnum++;
	}else{
		if( mCameraMotionPlay==true ){
			if( !playnum && WK7ViewerModel::GetMotionLoopAll()==false ){
				mCameraMotionPlay = false;
			}else{
				playnum++;
				PlayCamMotion();
			}
		}else{
			mCameraMotionPlay = false;
		}
	}
	if( WK7ViewerModel::GetMotionPlayAll()==true ){
		if( playnum==0 ){
			SetCamMode(mMode);
			WK7ViewerModel::SetMotionPlayAll(false);
		}
	}
	return result;
}

bool WK7ViewerTask::FrameProcessMovieLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				mMovieID = mProc;
				SetMode(WK7VIEWERMODE_MOVIEPLAY);
				return true;
//				char	filename[1024];
//				if( mFileList.GetFullFileName(mProc,filename)==true ){
//					k7app.SetVisiblePerfMeter(false);
//					k7app.SetEnablePerfMeter (false);
//					ghmGcMem::SetRender      (false);
//					if( gpMovie->mRequest(filename)==true ){
//						k7app.SetVisiblePerfMeter(false);
//						k7app.SetEnablePerfMeter (false);
//						ghmGcMem::SetRender      (false);
//						SetMode(WK7VIEWERMODE_MOVIEPLAY);
//						return true;
//					}
//				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderMovieLoad(void)
{
	RenderFileList("  <Movie>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessMoviePlay(void)
{
	switch( mProcSub ){
	case	0:
		if( WK7EVENTCONTROLLER->ReleaseTempData()==false ){
			return false;
		}
		mProcSub++;
		return true;
	case	1:
		if( WK7EVENTCONTROLLER->IsReleasedTempData()==false ){
			return false;
		}
		mProcSub++;
		return true;
	case	2:{
		char		filename[256];
		if( mFileList.GetFullFileName(mMovieID,filename)==false ){
			mProcSub = -1;
			mReqMode = WK7VIEWERMODE_MOVIELOAD;
			break;
		}
		if( gpMovie->mRequest(filename)==false ){
			mProcSub = -1;
			mReqMode = WK7VIEWERMODE_MOVIELOAD;
			break;
		}
		mProcSub++;
		}break;
	case	3:
		if( gpMovie->mGetStatus()==eMvProcStandby ){
			// ĐI`FbN
			mProcSub = -1;
			mReqMode = WK7VIEWERMODE_MOVIELOAD;
			return true;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
			mProcSub = -1;
			mReqMode = WK7VIEWERMODE_OPERATE;
			return true;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			mProcSub = -1;
			mReqMode = WK7VIEWERMODE_MOVIELOAD;
			return true;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( gpMovie->mGetPauseFlag()==true ){
				gpMovie->mReleasePause();
			}else{
				gpMovie->mSetPause();
			}
		}
		break;
	case	-1:
		gpMovie->mStop();
		mProcSub--;
	case	-2:
		if( gpMovie->mGetStatus()!=eMvProcStandby ){
			break;
		}
		mProcSub--;
	case	-3:
		if( WK7EVENTCONTROLLER->LoadData()==false ){
			return false;
		}
		mProcSub--;
		return true;
	case	-4:
		if( WK7EVENTCONTROLLER->IsLoadedData()==false ){
			return false;
		}
		SetMode(mReqMode);
		break;
	default:
		break;
	}
		
	return true;
}

bool WK7ViewerTask::RenderMoviePlay(void)
{
//	RenderFileList("  <Movie>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessZanLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					int		i,j;
					mZanID = 0;
					for(i=0 ; i<sizeof(filename) ; i++){
						switch( filename[i] ){
						case	'.':
							break;
						case	'\0':
							return false;
						default:
							continue;
						}
						break;
					}
					if( i==sizeof(filename) ){
						return false;
					}
					for(i-=7,j=0 ; j<6 ; j++,i++){
						if( filename[i] < '0' || filename[i] > '9' ){
							return false;
						}
						mZanID <<= 4;
						mZanID  += (u32)(filename[i] - '0');
					}
					if( filename[i] < '0' || filename[i] > '9' ){
						return false;
					}
					mZanMesID = (u32)(filename[i] - '0');
					mZanProc         = 0;
					mZanCount        = 0;
					mZanStartTime    = 0.0f;
					mZanWaitTime     = 0.0f;
					GameInfo.SetZanID   (mZanID);
					GameInfo.SetZanMesID(mZanMesID);
					GameInfo.SetMode    (WK7GameInfo::ZAN);
					SetMode(WK7VIEWERMODE_ZANPLAY);
					return true;
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::RenderZanLoad(void)
{
	RenderFileList("  <Zan Load>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessZanPlay(void)
{
	if( GameInfo.GetMode()!=WK7GameInfo::ZAN ){
		SetMode(WK7VIEWERMODE_ZANLOAD);
		return true;
	}
	
	if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
		WK7Zan	*pZan = GameInfo.GetZan();
		if( pZan!=NULL ){
			switch( mZanProc ){
			case	0:
				mZanStartTime=WK7_TICK_TO_SEC(pZan->GetCounter());
				break;
			case	1:
				mZanWaitTime =WK7_TICK_TO_SEC(pZan->GetCounter()) - mZanStartTime;
				OSReport("%3d\t%.3f\t%.3f\n",mZanCount,mZanStartTime,mZanWaitTime);
				mZanCount++;
				break;
			}
			mZanProc ^= 1;
		}
	}
	return true;
}

bool WK7ViewerTask::RenderZanPlay(void)
{
#ifdef	_DEBUG
	if( WK7Zan::GetDebugInfo()==false ){
		return true;
	}
#endif
	C_Paper		paper(32,32);
	PRINTF("Zan Play - %06x%d\n",mZanID & 0xffffff,mZanMesID);
	if( mZanProc ){
		PRINTF(" %.3f -> ----\n",mZanStartTime);
	}else{
		PRINTF(" %.3f -> %.3f\n",mZanStartTime,mZanWaitTime);
	}
	return true;
}

bool WK7ViewerTask::FrameProcessSysMesLoad(void)
{
	if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
		SetMode(WK7VIEWERMODE_MENU);
		return true;
	}
	if( SelectFile()==true ){
		if( mProc >= 0 && mProc < mFileList.GetFileNum() ){
			if( mFileList.ChangeDir(mUsbServ,mProc)==false ){
				char	filename[1024];
				if( mFileList.GetFullFileName(mProc,filename)==true ){
					if( (mSysMesHandle=::LoadMessagePack(filename)) < 0 ){
						return false;
					}
					mSysMesProc      = 0;
					mpSysMesResource = NULL;
					SetMode(WK7VIEWERMODE_SYSMESPLAY);
					return true;
				}
			}else{
//				mProc = 0;
//				mCursor = 0;
				mProc = 
				mCursor = mFileList.GetCursorID();
				RenewCursorRange(FILELIST_DISPMAX,mFileList.GetFileNum());
			}
		}
	}
	FrameProcessFileList();
	return false;
}

bool WK7ViewerTask::ReleaseSysMes(void)
{
	if( mpSysMesEffect != NULL && CheckEffectValidState(mpSysMesEffect,mSysMesEffectID)==TRUE ){
		::DeleteEffect(mpSysMesEffect);
	}
	if( mSysMesHandle >= 0 ){
		::ReleaseMessagePack((s8)mSysMesHandle);
	}
	mSysMesProc      = -1;
	mSysMesHandle    = -1;
	mSysMesSelect    = 0;
	mpSysMesResource = NULL;
	mpSysMesEffect   = NULL;
	mSysMesEffectID  = 0xffffffff;
	mSysMesCount     = 0;
	mSysMesFlag      = 0;
	return true;
}

bool WK7ViewerTask::RenderSysMesLoad(void)
{
	RenderFileList("  <SysMes Load>");
	
	return true;
}

bool WK7ViewerTask::FrameProcessSysMesPlay(void)
{
	switch( mSysMesProc ){
	case	0:
		if( ::CheckMessagePackLoadComp((s8)mSysMesHandle)==0 ){
			MESSAGEPACK	*pMessagePack = GetMessagePack((s8)mSysMesHandle);
			if( pMessagePack==NULL || (mpSysMesResource = (stSentence *)pMessagePack->JmbData)==NULL ){
				ReleaseSysMes();
				SetMode(WK7VIEWERMODE_SYSMESLOAD);
				return true;
			}
			mSysMesProc   = 16;
			mSysMesSelect = 0;
		}
		break;
	case	16:
		if( HSD_PadGetTrigger(0) & HSD_PAD_START ){
			ReleaseSysMes();
			SetMode(WK7VIEWERMODE_OPERATE);
			return true;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_B ){
			ReleaseSysMes();
			SetMode(WK7VIEWERMODE_SYSMESLOAD);
			break;
		}
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( (mpSysMesEffect=::CreateMessage2Effect((s8)mSysMesHandle,(u16)mSysMesSelect))==NULL ){
				return false;
			}
			mSysMesEffectID = ::GetEffectID(mpSysMesEffect);
			mSysMesProc = 32;
			break;
		}
		if( HSD_PadGetRepeat(0) & (HSD_PAD_DOWN|HSD_PAD_RIGHT) ){
			mSysMesSelect++;
		}
		if( HSD_PadGetRepeat(0) & (HSD_PAD_UP  |HSD_PAD_LEFT ) ){
			mSysMesSelect--;
		}
		if( mSysMesSelect < 0 ){
			mSysMesSelect = mpSysMesResource->num-1;
		}else if( mSysMesSelect >= mpSysMesResource->num ){
			mSysMesSelect = 0;
		}
		break;
	case	32:
		if( CheckEffectValidState(mpSysMesEffect,mSysMesEffectID)==FALSE ){
			mpSysMesEffect  = NULL;
			mSysMesEffectID = 0xffffffff;
			mSysMesProc     = 16;
			break;
		}
		break;
	default:
		SetMode(WK7VIEWERMODE_SYSMESLOAD);
		break;
	}
	return true;
}

bool WK7ViewerTask::RenderSysMesPlay(void)
{
	C_Paper		paper(32,32);
	char		numstr[16];
	
	if( mpSysMesResource==NULL ){
		strcpy(numstr,"---");
	}else{
		sprintf(numstr,"%d",mpSysMesResource->num);
	}
	
	PRINTF("SysMes Select - %d(%s)",mSysMesSelect,numstr);
	
//	switch( mSysMesProc ){
//	case	32:
//		if( mSysMesCount > 0 ){
//			mSysMesCount--;
//		}else{
//			mSysMesFlag ^= 1;
//			mSysMesCount = 15;
//		}
//		if( mSysMesFlag ){
//			PRINTF("   << Playing >>\n");
//		}
//		break;
//	default:
//		break;
//	}
	
	return true;
}

bool WK7ViewerTask::RenderChangeDisk(void)
{
	C_Paper		paper(32,32);
	switch( mProcSub ){
	case	0:
		PRINTF("Select Disk : %d (<=%d)\n",mReqDiskID+1,ghmGcFile::GetDiskNum());
		break;
	default:
//		PRINTF("Now Disk Changing : Insert Disk %d\n",mReqDiskID+1);
		break;
	}
	return true;
}

bool WK7ViewerTask::FrameProcessChangeDisk(void)
{
	switch( mProcSub ){
	case	0:
		if( HSD_PadGetRepeat(0) & HSD_PAD_LEFT ){
			mReqDiskID--;
		}
		if( HSD_PadGetRepeat(0) & HSD_PAD_RIGHT ){
			mReqDiskID++;
		}
		GHM_LIMIT_RANGE(mReqDiskID,ghmGcFile::GetDiskNum()-1,0);
		if( HSD_PadGetTrigger(0) & HSD_PAD_A ){
			if( mReqDiskID != ghmGcFile::GetCurrentDiskID() ){
				mProcSub++;
			}else{
				SetMode(WK7VIEWERMODE_OPERATE);
				return true;
			}
		}
		if( HSD_PadGetTrigger(0) & (HSD_PAD_B|HSD_PAD_START) ){
			SetMode(WK7VIEWERMODE_OPERATE);
			return true;
		}
		break;
	case	1:
		if( ghmGcFile::ChangeDisk(mReqDiskID)==false ){
			break;
		}
		mProcSub++;
		break;
	case	2:
		if( ghmGcFile::GetCurrentDiskID()!=mReqDiskID ){
			break;
		}
		SetMode(WK7VIEWERMODE_OPERATE);
		return true;
	}
	return false;
}

bool WK7ViewerTask::FrameProcess(void)
{
#if 0
	if( HSD_PadGetTrigger(0) & HSD_PAD_X ){
		if( DeleteTerminate()==true ){
			return true;
		}
	}
#endif
	
#if 1
	if( HSD_PadGetTrigger(1) & HSD_PAD_DOWN ){
		OSDebugReport("Free Memory Size = %08x,%08x\n",K7AppSmallMemGetFreeSize(),ghmGcMemGetFreeSize());
	}
	if( HSD_PadGetTrigger(1)==HSD_PAD_A ){
		Vec					campos,camtgt;
		WK7CAM->GetPosition(campos);
		WK7CAM->GetTargetPosition(camtgt);
		OSReport("%.3ff, %.3ff, %.3ff, %.3ff, %.3ff, %.3ff\n",campos.x,campos.y,campos.z,camtgt.x,camtgt.y,camtgt.z);
	}
	if( HSD_PadGetTrigger(1)==HSD_PAD_B ){
		Vec					campos,camtgt;
		WK7CAM->GetPosition(campos);
		WK7CAM->GetTargetPosition(camtgt);
		OSReport("{{%.3ff, %.3ff, %.3ff},{%.3ff, %.3ff, %.3ff}},\n",camtgt.x,camtgt.y,camtgt.z,campos.x,campos.y,campos.z);
	}
#endif
//	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
//		WK7CAM->SetCinemaScopeMode(WK7CAM->GetCinemaScopeMode()==true? false : true);
//	}
	
#ifdef	AFTERIMAGE_TEST
	if( HSD_PadGetTrigger(1) & HSD_PAD_B ){
static	u32		tick = WK7_TICK_PER_SEC / 2;
		if( afterImage.GetBackIntensity()==0 ){
			afterImage.SetBackIntensity(0xff,0);
		}else{
			afterImage.SetBackIntensity(0,tick);
		}
	}
#endif
	
//	if( mpCharaObj!=NULL && mpDefLight!=NULL ){
//		mpCharaObj->SetDispLight(mpDefLight,mDefLight);
//	}
	
	if( mHitObjCheck==true ){
		WK7SIGHT->PeekData();
		if( WK7SIGHT->IsValidPeekData() ){
			u32		argb = WK7SIGHT->GetPeekARGB();
			Vec     hitPos = {0.f, 0.f, 0.f};
			WK7HitObj::HitCheck(WK7RenderObj::ConvAlphaToRenderID((u8)(argb >> 24)), WK7HITOBJINFO_TYPE_NORMALSHOT, 0, 0, hitPos);
		}
	}
	
	// p[eBNVXẽt[
	int		i = WK7_FRAME_COUNT;
	while( i-- ){
		PARTICLE.Proc(GetEffectCamera());
	}
	
	switch( mMode ){
	case	WK7VIEWERMODE_OPERATE:
		FrameProcessOperate();
		break;
	case	WK7VIEWERMODE_MENU:
		FrameProcessMenu();
		if( mMode==WK7VIEWERMODE_EXIT ){
			if( DeleteTerminate()==true ){
				return true;
			}
		}
		break;
	case	WK7VIEWERMODE_MODELSELECT:
		FrameProcessModelSelect();
		break;
	case	WK7VIEWERMODE_MODELLOAD:
		FrameProcessModelLoad();
		break;
	case	WK7VIEWERMODE_STAGELOAD:
		FrameProcessStageLoad();
		break;
	case	WK7VIEWERMODE_MOTIONLOAD_MODELSELECT:
		FrameProcessMotionLoadModelSelect();
		break;
	case	WK7VIEWERMODE_MOTIONLOAD:
		FrameProcessMotionLoad();
		break;
	case	WK7VIEWERMODE_MOTIONLOADSUB:
		FrameProcessMotionLoadSub();
		break;
	case	WK7VIEWERMODE_TEXTURE:
		FrameProcessTextureLoad();
		break;
	case	WK7VIEWERMODE_PLAYLOAD:
		FrameProcessPlayLoad();
		break;
	case	WK7VIEWERMODE_PLAY:
		FrameProcessPlay();
		break;
	case	WK7VIEWERMODE_SEQPLAY:
		FrameProcessSeqPlay();
		break;
	case	WK7VIEWERMODE_CAMMOTIONLOAD:
		FrameProcessCamMotionLoad();
		break;
	case	WK7VIEWERMODE_MOVIELOAD:
		FrameProcessMovieLoad();
		break;
	case	WK7VIEWERMODE_MOVIEPLAY:
		FrameProcessMoviePlay();
		break;
	case	WK7VIEWERMODE_ZANLOAD:
		FrameProcessZanLoad();
		break;
	case	WK7VIEWERMODE_ZANPLAY:
		FrameProcessZanPlay();
		break;
	case	WK7VIEWERMODE_SYSMESLOAD:
		FrameProcessSysMesLoad();
		break;
	case	WK7VIEWERMODE_SYSMESPLAY:
		FrameProcessSysMesPlay();
		break;
	case	WK7VIEWERMODE_CHANGEDISK:
		FrameProcessChangeDisk();
		break;
	default:
		break;
	}
	
	GameInfo.FrameProcess();
	
	screenImageFullColor.FrameProcess();
	screenImageMonoColor.FrameProcess();
	afterImage.FrameProcess();
	
	WK7CAM->SetCurrent();
	
	// L
	WK7Play::FrameProcessAll();
	
	WK7Memo::LoadProcess();
	
	// CxgRg[I
	WK7EVENTCONTROLLER->FrameProcess();
	
	WK7CharaPresent::FrameProcessAll();
	
	// A[JCu
	WK7Archive::FrameProcessAll();
	
	// J
	WK7CAM->FrameProcess();
	WK7CAM->SetCurrent();
	
	WK7MotionObj::FrameProcessAll();
	
	WK7RenderObj::FrameProcessAll();
	
#if 0
	switch( mMode ){
	case	WK7VIEWERMODE_PLAY:
	case	WK7VIEWERMODE_SEQPLAY:
		break;
	default:{
		Vec	pos;
//		if( mpModel!=NULL ){
//			mpModel->GetPosition(pos);
//		}else{
			WK7CAM->GetTargetPosition(pos);
//		}
		WK7SHADOW->SetTargetPosition(pos);
		}break;
	}
#endif
	
	if( mMode!=WK7VIEWERMODE_PLAY ){
		
		// [VRg[
		MotionControl();
		
		if( mpOriginJObj!=NULL ){
			mpOriginJObj->Proc();
		}
		
	}
	
	// VhE{[
	WK7RenderObj::FrameProcessEdgeShadow();
	
	//쐬̃t[
	mK7FrameProc();
	
	if( g_pSpData!=NULL ){
		g_pSpData->FrameProcess();
	}
	if( g_pStageData!=NULL ){
		g_pStageData->FrameProcess();
	}
	
	WK7Mirror::FrameProcessAll();
	
	// ^XNRg[
	mFrameProcessTaskController.FrameProcess();
	
	// GtFNg
	WK7RenderObj::VFXProc();
	
	gMask.FrameProcess();
	
	WK7ViewerModel	*pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
	while( pModel!=NULL ){
		pModel->SetDispLight(mpDefLight,mDefLight);
		pModel = pModel->GetNext();
	}
	
	// TCg
	WK7SIGHT->FrameProcess();
	
	WK7CAM->SetCurrent();
	
	// DCg
	WK7RenderObj::PrivateLightProcessAll();
	
	// Cg
	WK7Light::FrameProcessAll();
	
	// Xe[WԕύX
	WK7Stage::StateProcessAll();
	
	// eẽt[
	WK7SHADOW->FrameProcess();
	
	return true;
}

bool WK7ViewerTask::LastFrameProcessTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	return true;
}

void WK7ViewerTask::_LastFrameProcessTask(ghmGcTask *pTask)
{
	WK7ViewerTask		*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pViewerTask->LastFrameProcessTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

bool WK7ViewerTask::PreRenderProcess(void)
{
	HSD_StartRender(HSD_RP_SCREEN);
	
	if( WK7CAM->SetCurrent()==true ){ 
		
		WK7SHADOW->RenderProcess();
		
		WK7CAM->EndCurrent();
	}
	
	if( WK7CAM->SetCurrent()==true ){ 
		
		WK7Mirror::RenderProcessAll();
		
		WK7CAM->EndCurrent();
	}
	
#if FUJITA
	if( WK7CAM->SetCurrent()==true ){ 
		
		// {Xp̃sJsJ
		C_RadialBlur::RenderProcessAll();
		
		WK7CAM->EndCurrent();
	}
#endif
	
	HSD_EndRender();
	
	return true;
}

bool WK7ViewerTask::RenderProcess(void)
{
	
	afterImage.PreRenderProcess();
	
	if(gpMovie!=NULL)gpMovie->mRender();	//[r[_O
	
//	if( HSD_PadGetTrigger(1) & HSD_PAD_RIGHT ){
//		k7app.ScreenCapture(CAPTURE_RGBA,"pre.bmp");
//	}
	
	// sysdolphinԖ
	HSD_StateInvalidate(HSD_STATE_ALL);
	
	HSD_StateSetDither(TRUE);
	HSD_SetZSortMode(true,true);
//	HSD_SetZSortMode(true,false);
	
	// JgJݒ
	if( WK7CAM->SetCurrent()==true ){
		
		// Jݒ肪\L̈Ȃ`
		
		C_LObj::DispStart();
		
		// Cgo^
		if( mpLObj != NULL ){
			HSD_LObj	*pLObj = mpLObj->GetLObj();
			HSD_LObjSetCurrentAll(pLObj);
		}
		
		if( mOrigDisp==true && mpOriginJObj!=NULL ){
			mpOriginJObj->Disp();
		}
		
		C_LObj::DispEnd();
		
		// tHOݒ
		if( fog != NULL ){
			HSD_FogSet(fog);
		}
		
		WK7RenderObj::RenderProcessAll();
		
		if( mCamTargetDisp==true ){
			WK7CAM->RenderProcess();
		}
		
		// JgJł̕`I
		WK7CAM->EndCurrent();
		
		// p[eBNVXe̕`
		PARTICLE.Disp();
		
		if( mScreenTone==true ){
			C_ScreenTone	tone( 480-260, 0, 486-255 );
			GXSetDither(TRUE);
			tone.Disp();
		}
		
	}
	
	// ^XNRg[
	mRenderProcessTaskController.FrameProcess();
	
	WK7Sight::DrawSyncToken();
//	WK7Sight::WaitSyncToken();
	
//	if( mpPlay!=NULL ){
//		extern	int	playcount;
//		playcount = mpPlay->GetPlayCount();
//	}
	
	return true;
}

// XN[Lv`[OiɂRcnj
bool WK7ViewerTask::PreScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	gMask.RenderProcess();
	
	screenImageFullColor.RenderProcess(false);
	screenImageMonoColor.RenderProcess(false);
	
	GameInfo.PreScreenCaptureRenderProcess();
	
	afterImage.RenderProcess();
	
	return true;
}

void WK7ViewerTask::_PreScreenCaptureTask(ghmGcTask *pTask)
{
	WK7ViewerTask		*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pViewerTask->PreScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

// XN[Lv`[
bool WK7ViewerTask::ScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	WK7CAM->RenderCinemaScopeFrame(true);
	
	GameInfo.RenderProcess();
	
	// XN[Rs[
	screenImageFullColor.ScreenCopy();
	screenImageMonoColor.ScreenCopy();
	
	if( mpPrevPlay!=NULL || mpPlay!=NULL ){
		// eNX`Rs[
		WK7RenderObj::VFXCopyTex();
		// GtFNg`
#ifdef	_DEBUG
		if( !GETPS2MODE() ){
#endif
		WK7RenderObj::VFXDisp   ();
#ifdef	_DEBUG
		}
#endif
	}
	
	// i{P
	SceneBlur.RenderProcess(screenImageFullColor.GetTexObj());
	
	return true;
}

void WK7ViewerTask::_ScreenCaptureTask(ghmGcTask *pTask)
{
	WK7ViewerTask		*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pViewerTask->ScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
		
	}
}

// XN[Lv`[㏈iɂQcnj
bool WK7ViewerTask::PostScreenCaptureTask(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	if( WK7RenderObj::InitEdgeShadowAll()==true ){
		if( WK7CAM->SetCurrent()==true ){
			// {[VhE`
			WK7RenderObj::RenderEdgeShadowAll();
			WK7CAM->EndCurrent();
		}
		// {[VhEhԂ
		WK7RenderObj::RenderEdgeShadowPaint();
	}
	
	screenImageFullColor.RenderProcess(true);
	screenImageMonoColor.RenderProcess(true);
	
	GameInfo.PostScreenCaptureRenderProcess();
	
	// TCg_O
	WK7SIGHT->RenderProcess();
	
	WK7SELECTIF->RenderProcess();
	
	WK7CharaPresent::RenderProcessAll();
	
	WK7Play::RenderProcessAll();
	
	//쐬̃_[
	mK7RenderProc();
	
	WK7Npc::RenderProcessAll();
	
	GXSetCullMode(GX_CULL_NONE);
	switch( mMode ){
	case	WK7VIEWERMODE_OPERATE:
		RenderOperate();
		break;
	case	WK7VIEWERMODE_MENU:
		RenderMenu();
		break;
	case	WK7VIEWERMODE_MODELSELECT:
		RenderModelSelect();
		break;
	case	WK7VIEWERMODE_MODELLOAD:
		RenderModelLoad();
		break;
	case	WK7VIEWERMODE_STAGELOAD:
		RenderStageLoad();
		break;
	case	WK7VIEWERMODE_MOTIONLOAD_MODELSELECT:
		RenderMotionLoadModelSelect();
		break;
	case	WK7VIEWERMODE_MOTIONLOAD:
		RenderMotionLoad();
		break;
	case	WK7VIEWERMODE_MOTIONLOADSUB:
		RenderMotionLoadSub();
		break;
	case	WK7VIEWERMODE_TEXTURE:
		RenderTextureLoad();
		break;
	case	WK7VIEWERMODE_PLAYLOAD:
		RenderPlayLoad();
		break;
	case	WK7VIEWERMODE_PLAY:
		RenderPlay();
		break;
	case	WK7VIEWERMODE_SEQPLAY:
		RenderSeqPlay();
		break;
	case	WK7VIEWERMODE_CAMMOTIONLOAD:
		RenderCamMotionLoad();
		break;
	case	WK7VIEWERMODE_MOVIELOAD:
		RenderMovieLoad();
		break;
	case	WK7VIEWERMODE_MOVIEPLAY:
		RenderMoviePlay();
		break;
	case	WK7VIEWERMODE_ZANLOAD:
		RenderZanLoad();
		break;
	case	WK7VIEWERMODE_ZANPLAY:
		RenderZanPlay();
		break;
	case	WK7VIEWERMODE_SYSMESLOAD:
		RenderSysMesLoad();
		break;
	case	WK7VIEWERMODE_SYSMESPLAY:
		RenderSysMesPlay();
		break;
	case	WK7VIEWERMODE_CHANGEDISK:
		RenderChangeDisk();
		break;
	default:
		break;
	}
	
	switch( mMode ){
	case	WK7VIEWERMODE_PLAY:
	case	WK7VIEWERMODE_PLAYLOAD:
	case	WK7VIEWERMODE_MOVIELOAD:
	case	WK7VIEWERMODE_MOVIEPLAY:
		break;
	default:
		// eNX``
		SetCamera2D  ();
		RenderTexture();
		break;
	}
	
	HSD_StateInvalidate(HSD_STATE_ALL);
	
#ifdef	_DEBUG
	if( mShadowTrigger==true ){
		WK7SHADOW->GetShadow()->DrawTex();
	}
#endif
	
	return true;
}

void WK7ViewerTask::_PostScreenCaptureTask(ghmGcTask *pTask)
{
	WK7ViewerTask		*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pViewerTask->PostScreenCaptureTask(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

bool WK7ViewerTask::PostScreenCapture2Task(ghmGcTask *pTask)
{
#pragma unused(pTask)
	
	GameInfo.PostScreenCaptureRenderProcess2();
	
	return true;
}

void WK7ViewerTask::_PostScreenCapture2Task(ghmGcTask *pTask)
{
	WK7ViewerTask		*pViewerTask = (WK7ViewerTask *)GHMGCTASK_GETPARAM(0);
	while( 1 ){
		
		pViewerTask->PostScreenCapture2Task(pTask);
		
		GHMGCTASK_RETSYS();
	}
}

bool ghmGcLineF2::Render(void)
{
	// v~eBu̎ނw
	GXBegin(GX_LINES,GX_VTXFMT1,2);
		
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		GXPosition3s16(mPos[0].mX,mPos[0].mY,mLayer);
		GXColor1u32   (mColor32);
		
		GXPosition3s16(mPos[1].mX,mPos[1].mY,mLayer);
		GXColor1u32   (mColor32);
		
	GXEnd();
	
	return true;
}


#define	HIERARCHY_SIZE		(16)
#define	HIERARCHY_INTERVAL	(4)
//#define	HIERARCHY_SIZE		(24)
//#define	HIERARCHY_INTERVAL	(8)
#define	HIERARCHY_RIGHT_LIMIT	(240)
#define	HIERARCHY_BOTTOM_LIMIT	(320)
//#define	HIERARCHY_RIGHT_LIMIT	(320)
//#define	HIERARCHY_BOTTOM_LIMIT	(440)
bool WK7ViewerTask::CalcTopHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite)
{
	if( pJObj==NULL ){
		return false;
	}
	if( pJObj==mpCurrentJObj ){
		if( psprite->mTop + psprite->mHeight > HIERARCHY_BOTTOM_LIMIT ){
			psprite->mTop = (short)(HIERARCHY_BOTTOM_LIMIT - psprite->mHeight - psprite->mTop);
		}
		if( psprite->mLeft + psprite->mWidth > HIERARCHY_RIGHT_LIMIT ){
			psprite->mLeft = (short)(HIERARCHY_RIGHT_LIMIT - psprite->mWidth - psprite->mLeft);
		}
		return true;
	}
	if( pJObj->GetChild()!=NULL ){
		psprite->mLeft += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
		if( CalcTopHierarchy(pJObj->GetChild(),psprite)==true ){
			return true;
		}
		psprite->mLeft -= HIERARCHY_SIZE + HIERARCHY_INTERVAL;
	}
	WK7JObj	*pNextJObj;
	if( pJObj->GetPrev()==NULL && (pNextJObj=pJObj->GetNext())!=NULL ){
		for( ; pNextJObj!=NULL ; pNextJObj=pNextJObj->GetNext()){
			psprite->mTop += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
			if( CalcTopHierarchy(pNextJObj,psprite)==true ){
				return true;
			}
		}
	}
//	if( pJObj->GetNext()!=NULL ){
//		psprite->mTop += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
//		if( CalcTopHierarchy(pJObj->GetNext (),psprite)==true ){
//			return true;
//		}
//	}
	return false;
}

bool WK7ViewerTask::RenderHierarchy(WK7JObj *pJObj,ghmGcSpriteF *psprite)
{
	if( pJObj==NULL ){
		return true;
	}
	
	short	ctop;
	
	if( pJObj==mpCurrentJObj ){
		C_Paper		paper(320,32,0.75f);
		
		HSD_JObj	*pHSDJObj = pJObj->GetJObj();
		HSD_DObj	*pHSDDObj;
		char		str[256] = "";
		
		PRINTF("JObj Information\n\n");
		
		PRINTF("[%s]\n",pJObj->GetName());
		PRINTF("TR %.3f,%.3f,%.3f\n",pHSDJObj->translate.x,pHSDJObj->translate.y,pHSDJObj->translate.z);
		PRINTF("RT %.3f,%.3f,%.3f\n",pHSDJObj->rotate   .x,pHSDJObj->rotate   .y,pHSDJObj->rotate   .z);
		if( pHSDJObj->scale.x!=1.0f ||
		    pHSDJObj->scale.y!=1.0f ||
		    pHSDJObj->scale.z!=1.0f ){
			PRINTF("SC %.3f,%.3f.%.3f\n",pHSDJObj->scale.x,pHSDJObj->scale.y,pHSDJObj->scale.z);
		}
		if( pHSDJObj->aobj!=NULL ){
			strcat(str,"Anim ");
		}
		if( pHSDJObj->flags & JOBJ_HIDDEN ){
			strcat(str,"Hide ");
		}
		if( pHSDJObj->flags & JOBJ_ENVELOPE_MODEL ){
			strcat(str,"Skin ");
		}
//		if( pHSDJObj->flags & JOBJ_OPA ){
//			strcat(str,"Opa ");
//		}
		if( pHSDJObj->flags & JOBJ_XLU ){
			strcat(str,"SemiTrans ");
		}
		if( pHSDJObj->flags & JOBJ_TEXEDGE ){
			strcat(str,"AlphaZero ");
		}
		if( strlen(str) > 0 ){
			PRINTF("%s\n",str);
		}
		int			mtcnt = 0;
		pHSDDObj = HSD_JObjGetDObj(pHSDJObj);
		while( pHSDDObj!=NULL ){
			mtcnt++;
			pHSDDObj = pHSDDObj->next;
		}
		PRINTF("MT %d\n",mtcnt);
		pHSDDObj = HSD_JObjGetDObj(pHSDJObj);
		while( pHSDDObj!=NULL ){
			PRINTF("   %s\n",pJObj->GetDObjName(pHSDDObj));
			pHSDDObj = pHSDDObj->next;
		}
		
		psprite->mColor.r = 0xff;
		psprite->mColor.g = 0x00;
		psprite->mColor.b = 0x00;
		psprite->mColor.a = 0xff;
	}else{
		psprite->mColor.r = 0xc0;
		psprite->mColor.g = 0xc0;
		psprite->mColor.b = 0xc0;
		psprite->mColor.a = 0x80;
	}
	
	psprite->Render();
	ctop = psprite->mTop;
	
	if( pJObj->GetChild()!=NULL ){
		ghmGcLineF2		line;
		line.mColor32 = 0xc0c0c080;
		line.mLayer   = 0;
		line.mPos[0].mX = (short)(psprite->mLeft + HIERARCHY_SIZE);
		line.mPos[0].mY = (short)(psprite->mTop  + psprite->mHeight / 2);
		line.mPos[1].mX = (short)(line.mPos[0].mX + HIERARCHY_INTERVAL);
		line.mPos[1].mY = line.mPos[0].mY;
		line.Render();
		psprite->mLeft += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
		RenderHierarchy(pJObj->GetChild(),psprite);
		psprite->mLeft -= HIERARCHY_SIZE + HIERARCHY_INTERVAL;
	}
	
	WK7JObj	*pNextJObj;
	if( pJObj->GetPrev()==NULL && (pNextJObj=pJObj->GetNext())!=NULL ){
		for( ; pNextJObj!=NULL ; pNextJObj=pNextJObj->GetNext()){
			ghmGcLineF2		line;
			psprite->mTop  += HIERARCHY_SIZE + HIERARCHY_INTERVAL;
			line.mColor32 = 0xc0c0c080;
			line.mPos[0].mX = (short)(psprite->mLeft + psprite->mWidth / 2);
			line.mPos[0].mY = (short)(ctop  + HIERARCHY_SIZE);
			line.mPos[1].mX = line.mPos[0].mX;
			line.mPos[1].mY = psprite->mTop;
			line.mLayer   = 0;
			line.Render();
			ctop = psprite->mTop;
			if( RenderHierarchy(pNextJObj,psprite)==false ){
				return false;
			}
		}
//		RenderHierarchy(pJObj->GetNext(),psprite);
	}
	
	return true;
}

#define	FONT_H				(18)
bool WK7ViewerTask::RenderInfo(void)
{
	if( mInfoDisp==false ){
		return false;
	}
	
	const char			*pMotionName = NULL;
	const char			*pStageName  = NULL;
	const char			*pCameraMotionName = NULL;
	Vec					campos,camtgt;
	WK7ViewerModel		*pModel;
	
	WK7CAM->GetPosition(campos);
	WK7CAM->GetTargetPosition(camtgt);
	
	{
		C_Paper				paper(440,24,0.75f);
		const char			*pEditMode;
		switch( mEditMode ){
		case	VIEWER:
			pEditMode = "<Viewer>";
			break;
		case	MOTIONPLAY:
			pEditMode = "<Motion Play>";
			break;
		case	CAMEDIT:
			pEditMode = "<Camera Edit>";
			break;
		case	HIERARCHY:
			pEditMode = "<Hierarchy>";
			break;
		case	BLUREDIT:
			pEditMode = "<Blur Edit>";
			break;
		case	LIGHTEDIT:
			pEditMode = "<Light Edit>";
			break;
		default:
			pEditMode = "<--->";
			break;
		}
		PRINTF("%20s\n\n",pEditMode);
	}
	
	switch( mEditMode ){
	case	HIERARCHY:{
		WK7Model		*pMdl;
		pModel = GetModel(mCurrentModel);
		if( pModel!=NULL && (pMdl=pModel->GetModel())!=NULL && pMdl->GetTopObj()!=NULL ){
			ghmGcSpriteF	sprite;
			sprite.mLeft   = 32;
			sprite.mTop    = 32;
			sprite.mWidth  = HIERARCHY_SIZE;
			sprite.mHeight = HIERARCHY_SIZE;
			sprite.mLayer  = 0;
			CalcTopHierarchy(pMdl->GetTopObj(),&sprite);
			if( sprite.mLeft < 0 ){
				sprite.mLeft += 32;
			}else{
				sprite.mLeft  = 32;
			}
			if( sprite.mTop  < 0 ){
				sprite.mTop  += 32;
			}else{
				sprite.mTop   = 32;
			}
			GXSetLineWidth(12,GX_TO_ZERO);
			ghmGcSprite::RenderStart();
			RenderHierarchy(pMdl->GetTopObj(),&sprite);
			ghmGcSprite::RenderEnd();
		}
		}break;
	case	CAMEDIT:{
		C_Paper				paper(12,40,0.75f);
		const char			*pType;
		
		switch( mEditCamType ){
		case	LINIP_LINPATH:
			pType = "Linear";
			break;
		case	DELAYIP_LINPATH:
			pType = "Delay";
			break;
		case	LINIP_CIRPATH:
			pType = "Circle";
			break;
		default:
			pType = "---";
			break;
		}
		
		PRINTF("%s Type  : %s\n",mEditCamProc==0? ">":" ",pType);
		
		PRINTF("%s Start : %.3f,%.3f,%.3f\n",mEditCamProc==1? ">":" ",
		                                    mEditCamStartPosition.x,
		                                    mEditCamStartPosition.y,
		                                    mEditCamStartPosition.z);
		PRINTF("          %.3f,%.3f,%.3f\n",mEditCamStartTargetPosition.x,
		                                    mEditCamStartTargetPosition.y,
		                                    mEditCamStartTargetPosition.z);
		PRINTF("     fov  %.3f\n"          ,mEditCamStartFov);
		
		PRINTF("%s End   : %.3f,%.3f,%.3f\n",mEditCamProc==2? ">":" ",
		                                    mEditCamEndPosition.x,
		                                    mEditCamEndPosition.y,
		                                    mEditCamEndPosition.z);
		PRINTF("          %.3f,%.3f,%.3f\n",mEditCamEndTargetPosition.x,
		                                    mEditCamEndTargetPosition.y,
		                                    mEditCamEndTargetPosition.z);
		PRINTF("     fov  %.3f\n"          ,mEditCamEndFov);
		
		PRINTF("%s Time  : %.4f(%d)\n",mEditCamProc==3? ">":" ",
		                              (f32)mEditCamInterpolateTime / WK7_TICK_PER_SEC,
		                              mEditCamInterpolateTime);
		PRINTF("%s Delay : %.4f\n",mEditCamProc==4? ">":" ",
		                           (f32)mEditCamDelayRate / EDITCAM_DELAYRATE_MAX);
		}break;
	case	BLUREDIT:{
		C_Paper				paper(12,40,0.75f);
		WK7SceneBlurScreen	*pScreen = SceneBlur.GetScreen(mSceneBlurID);
		if( pScreen!=NULL ){
			PRINTF("%s Blur    : %s\n\n",mSceneBlurProc==0? ">" : " ",mSceneBlurVisible==true? "On":"Off");
			PRINTF("%s ID      : %d\n",mSceneBlurProc==1? ">" : " ",mSceneBlurID);
			PRINTF("%s Dist    : %.3f\n",mSceneBlurProc==2? ">" : " ",pScreen->GetZDist());
			PRINTF("%s OffsetX : %.3f\n",mSceneBlurProc==3? ">" : " ",pScreen->GetOffsetX());
			PRINTF("%s OffsetY : %.3f\n",mSceneBlurProc==4? ">" : " ",pScreen->GetOffsetY());
			PRINTF("%s Alpha   : %d\n",mSceneBlurProc==5? ">" : " ",pScreen->GetAlpha());
			PRINTF("%s Visible : %s\n",mSceneBlurProc==6? ">" : " ",pScreen->GetVisible()==true? "On":"Off");
		}
		}break;
	case	LIGHTEDIT:{
		C_Paper				paper(12,40,0.75f);
		WK7Light			*pLight = GetLight(mLightID);
		if( pLight!=NULL ){
			char			typestr[256];
			typestr[0] = '\0';
			if( pLight->GetType() & (1<<LOBJ_AMBIENT) ){
				strcat(typestr,"Ambient ");
			}
			if( pLight->GetType() & (1<<LOBJ_INFINITE) ){
				strcat(typestr,"Direction ");
			}
			if( pLight->GetType() & (1<<LOBJ_POINT) ){
				strcat(typestr,"Point ");
			}
			if( pLight->GetType() & (1<<LOBJ_SPOT) ){
				strcat(typestr,"Spot ");
			}
			if( strlen(typestr)==0 ){
				strcat(typestr,"Unknown");
			}
			Vec				pos,tgt;
			u32				type = 0xffffffff;
			int				intensity = 0;
			GXColor			color;
			HSD_LObj		*pLObj;
			for(pLObj=pLight->GetHSDLObj() ; pLObj!=NULL ; pLObj=pLObj->next){
				u32		ltype = HSD_LObjGetType(pLObj);
				switch( ltype ){
				case	LOBJ_INFINITE:
					type = ltype;
					HSD_LObjGetPosition(pLObj,&pos);
					HSD_LObjGetColor   (pLObj,&color);
					intensity = color.r;
					break;
				case	LOBJ_SPOT:
					type = ltype;
					HSD_LObjGetPosition(pLObj,&pos);
					HSD_LObjGetInterest(pLObj,&tgt);
					HSD_LObjGetColor   (pLObj,&color);
					intensity = color.r;
					continue;
				case	LOBJ_POINT:
					type = ltype;
					HSD_LObjGetPosition(pLObj,&pos);
					HSD_LObjGetColor   (pLObj,&color);
					intensity = color.r;
					continue;
				default:
					continue;
				}
				break;
			}
			
			PRINTF("%s ID        : 0x%08x\n",mLightEditProc==0? ">" : " ",pLight->GetObjectID());
			PRINTF("%s Valid     : %s\n"    ,mLightEditProc==1? ">" : " ",pLight->GetEnable()==true?"Valid":"Invalid");
			PRINTF("%s Intensity : %d\n"    ,mLightEditProc==2? ">" : " ",intensity);
			PRINTF( "  Type      : %s\n"    ,typestr);
			switch( type ){
			case	LOBJ_INFINITE:
				PRINTF( "  Dir       : %.3f,%.3f,%.3f\n",pos.x,pos.y,pos.z);
				break;
			case	LOBJ_SPOT:
				PRINTF( "  Pos       : %.3f,%.3f,%.3f\n",pos.x,pos.y,pos.z);
				PRINTF( "  Interest  : %.3f,%.3f,%.3f\n",tgt.x,tgt.y,tgt.z);
				break;
			case	LOBJ_POINT:
				PRINTF( "  Pos       : %.3f,%.3f,%.3f\n",pos.x,pos.y,pos.z);
				break;
			}
		}else{
			PRINTF("%s ID        : new\n",mLightEditProc==0? ">" : " ");
			PRINTF("%s Valid     : ---\n",mLightEditProc==1? ">" : " ");
			PRINTF("%s Intensity : ---\n",mLightEditProc==2? ">" : " ");
			PRINTF( "  Type      : ---\n");
		}
		}break;
	}
	
	if( mEditMode != HIERARCHY ){
		{
			C_Paper				paper(470,48,0.75f);
			PRINTF("Camera Information\n\n");
		}
		{
			C_Paper				paper(480,66+6,0.75f);
			PRINTF(" TX %.3f\n",camtgt.x);
			PRINTF(" TY %.3f\n",camtgt.y);
			PRINTF(" TZ %.3f\n",camtgt.z);
		}
		{
			C_Paper				paper(480,66+18*3+6*2,0.75f);
			PRINTF(" EX %.3f\n",campos.x);
			PRINTF(" EY %.3f\n",campos.y);
			PRINTF(" EZ %.3f\n",campos.z);
		}
		{
			C_Paper				paper(480,66+18*6+6*3,0.75f);
			PRINTF(" TD %.3f\n",WK7CAM->GetTargetDistance());
			PRINTF(" SP %.3f\n",WK7CAM->GetCameraMoveSpeed());
		}
		{
			C_Paper				paper(480,66+18*8+6*4,0.75f);
			PRINTF(" N  %.3f\n",WK7CAM->GetNear());
			PRINTF(" F  %.3f\n",WK7CAM->GetFar());
			PRINTF(" FV %.3f\n",WK7CAM->GetFov());
		}
	}
	
	switch( mMode ){
	case	WK7VIEWERMODE_PLAY:
	case	WK7VIEWERMODE_SEQPLAY:
		if( mPlayInfoDispCounter ){
			mPlayInfoDispCounter--;
		}else{
			if( mPlayInfoDisp==true ){
				mPlayInfoDisp = false;
				mPlayInfoDispCounter = 30;
			}else{
				mPlayInfoDisp = true;
				mPlayInfoDispCounter = 60;
			}
		}
		mPlayInfoDisp = true;
		if( mPlayInfoDisp==true ){
			WK7Play		*pPlay;
			if( mpPrevPlay!=NULL ){
				pPlay = mpPrevPlay;
			}else if( mpPlay!=NULL ){
				pPlay = mpPlay;
			}else{
				pPlay = NULL;
			}
			if( pPlay!=NULL ){
static int	posx = 540,posy = 430;
				int		len = (int)((strlen(pPlay->GetResourceName()) + 7) * 12);
				C_Paper	paper(posx - len,posy,0.75f);
				PRINTF("<%s ... Playing(%05d)>\n",pPlay->GetResourceName(),pPlay->GetPlayCount());
			}
			
//			if( pPlay->GetPlayCount()==2930 ){
//				::DeleteEffectAll();
//			}
			
		}
		break;
	default:
		{
			C_Paper				paper(12,438 - FONT_H*2 - FONT_H * 2 * mModelNum,0.75f);
			const char			*pStageVersionStr;
			const char			*pCameraMotionVersionStr = GetCurrentCamMotionArchiveVersionStr();
			if( pCameraMotionVersionStr==NULL ){
				pCameraMotionVersionStr = "-.--";
			}
			pStageVersionStr = "-.--";
			if( mpStageArchive!=NULL ){
				WK7SdExpInfo	*pSdExpInfo;
				if( (pSdExpInfo = mpStageArchive->GetSdExpInfo())!=NULL ){
					pStageVersionStr = pSdExpInfo->mpVersionStr;
				}
			}
			if( mpStage!=NULL ){
				pStageName = mpStageFileName;
			}else{
				PRINTF("\n");
			}
			WK7CameraMotion		*pCameraMotion = GetCurrentCamMotion();
			if( pCameraMotion!=NULL ){
				if( mpCameraMotionFileName!=NULL ){
					pCameraMotionName = mpCameraMotionFileName;
				}else{
					if( (pModel=GetCurrentCamMotionModel())==NULL ){
						pCameraMotionName = "---";
					}else{
						pCameraMotionName = pModel->GetCurrentCamMotionFileName();
					}
				}
			}else{
				PRINTF("\n");
			}
			int					index = 0;
			pModel = (WK7ViewerModel *)mModelAnchor.GetNext();
			while( pModel!=NULL ){
				if( index==mCurrentModel ){
					pModel->RenderInfo(true);
				}else{
					pModel->RenderInfo(false);
				}
				pModel = pModel->GetNext();
				index++;
			}
			if( pStageName!=NULL ){
				PRINTF(" Stage  : %4s %46s\n",pStageVersionStr,pStageName);
			}
			if( pCameraMotionName!=NULL ){
				char	str[256];
				if( mCameraMotionPlay==true ){
					sprintf(str,"%s(%.1f,%.1f)",pCameraMotionName,
					                            WK7CAM->GetCurrentMotionFrame(),
					                            WK7CAM->GetTotalMotionFrame  ());
				}else{
					sprintf(str,"%s(---,---)",pCameraMotionName);
				}
				PRINTF(" CamAnm : %4s %46s\n",pCameraMotionVersionStr,str);
			}
		}
		{
			static 	int		h = 300;
			C_Paper		paper(12,h,0.75f);
			bool		anim = WK7ViewerModel::GetMotionPlayAll();
			for(pModel=(WK7ViewerModel *)mModelAnchor.GetNext() ; pModel!=NULL ; pModel=pModel->GetNext()){
				pModel->RenderVersionCheck(anim);
			}
		}
		break;
	}
	
	return true;
}

bool WK7ViewerTask::RenderTexture(void)
{
	if( mpTexture==NULL || mTextureVisible==false ){
		return false;
	}
	
	short		x0,y0,x1,y1;
	
	GXInitTexObj(&mTexObj,
	             (void *)((u_int)mpTexture + mpTexture->mImagePtr),
	             mpTexture->mWidth,
	             mpTexture->mHeight,
	             mpTexture->mFormat,
	             GX_CLAMP,
	             GX_CLAMP,
	             GX_FALSE);		// wrap_s,wrap_t,mipmap
	
	// eNX`[h
	GXLoadTexObj    (&mTexObj,GX_TEXMAP0);
	
	// _OXe[gݒ
	GXSetZMode      (GX_FALSE,GX_ALWAYS,GX_FALSE);
	GXSetColorUpdate(GX_TRUE);
	GXSetAlphaUpdate(GX_TRUE);
	GXSetBlendMode  (GX_BM_BLEND,GX_BL_SRCALPHA,GX_BL_INVSRCALPHA,GX_LO_CLEAR);
	GXSetDither     (GX_TRUE);
	
	// ǂ̑_tH[}bgɂ邩w肵ACfbNXQƂA_CNgQƂw
	GXClearVtxDesc   ();
	GXSetVtxDesc     (GX_VA_POS ,GX_DIRECT);
	GXSetVtxDesc     (GX_VA_NRM ,GX_NONE  );
	GXSetVtxDesc     (GX_VA_CLR0,GX_NONE  );
	GXSetVtxDesc     (GX_VA_TEX0,GX_DIRECT);
	
	GXSetNumTexGens  (1);
	GXSetTexCoordGen (GX_TEXCOORD0,GX_TG_MTX2x4,GX_TG_TEX0,GX_IDENTITY);
	
	GXSetNumTevStages(1);
	
	GXSetTevOp       (GX_TEVSTAGE0,GX_REPLACE);
	GXSetTevOrder    (GX_TEVSTAGE0,GX_TEXCOORD0,GX_TEXMAP0,GX_COLOR0A0);
	
	GXSetNumChans    (1);
	GXSetChanCtrl    (GX_COLOR0A0,GX_FALSE,GX_SRC_VTX,GX_SRC_VTX,GX_LIGHT_NULL,GX_DF_NONE,GX_AF_NONE);
	
	static	GXColor		ambcol = { 0x40,0x00,0x00,0xff, };
	static	GXColor		matcol = { 0x00,0x00,0x40,0xff, };
	
	GXSetChanAmbColor(GX_COLOR0A0,ambcol);
	GXSetChanMatColor(GX_COLOR0A0,matcol);
	
	GXSetCullMode    (GX_CULL_NONE);
	
	// ꂼ̗̑vfƎނw
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_POS ,GX_POS_XYZ ,GX_S16  ,0);
	GXSetVtxAttrFmt(GX_VTXFMT0,GX_VA_TEX0,GX_TEX_ST  ,GX_F32  ,0);
	
	x0 = (short)((SCREEN_WIDTH  - mpTexture->mWidth ) >> 1);
	y0 = (short)((SCREEN_HEIGHT - mpTexture->mHeight) >> 1);
	x1 = (short)(x0 + mpTexture->mWidth );
	y1 = (short)(y0 + mpTexture->mHeight);
	
	// v~eBu̎ނw
	GXBegin(GX_QUADS,GX_VTXFMT0,4);
		
		// _LqqƑtH[}bg킹A̒_GPɑv~eBu`
		
		GXPosition3s16(x0,y0,0);
		GXTexCoord2f32(0.0f,0.0f);
		
		GXPosition3s16(x1,y0,0);
		GXTexCoord2f32(1.0f,0.0f);
		
		GXPosition3s16(x1,y1,0);
		GXTexCoord2f32(1.0f,1.0f);
		
		GXPosition3s16(x0,y1,0);
		GXTexCoord2f32(0.0f,1.0f);
		
	GXEnd();
	
	return true;
}

bool WK7ViewerTask::SetCamera2D(float nearz,float farz)
{
	Mtx			view;
	Mtx44		proj;
	Vec			vPos;
	Vec			vUp;
	Vec			vAt;
	
	vUp .x =    0.0f;
	vUp .y = -  1.0f;
	vUp .z =    0.0f;
	vPos.x =    0.0f;
	vPos.y =    0.0f;
	vPos.z =    0.0f;
	vAt .x =  vPos.x;
	vAt .y =  vPos.y;
	vAt .z =  300.0f;
	
	// [Jr[ϊ}gNXݒ
	MTXLookAt       (view,&vPos,&vUp,&vAt);
	MTXOrtho        (proj,0,-SCREEN_HEIGHT,0,SCREEN_WIDTH,nearz,farz);
	GXLoadPosMtxImm (view,GX_PNMTX0);
	GXLoadNrmMtxImm (view,GX_PNMTX0);
	GXSetCurrentMtx (GX_PNMTX0);
	GXSetProjection (proj,GX_ORTHOGRAPHIC);
	
	GXSetScissor    (0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
	GXSetViewport   (0.0f,0.0f,SCREEN_WIDTH,SCREEN_HEIGHT,0.0f,1.0f);
	
	return true;
	
}

WK7ViewerTask::WK7ViewerTask(ghmGcApp *pApp,int prio) : ghmGcAppTask(pApp,prio)
{
	mCaptureFrame             = 0;
	mCaptureFrameIndex        = 0;
	mPreScreenCaptureTaskID   = -1;
	mScreenCaptureTaskID      = -1;
	mPostScreenCaptureTaskID  = -1;
	mPostScreenCapture2TaskID = -1;
	mLastFrameProcessTaskID   = -1;
	mpLObj                    = NULL;
	mpDefLight                = NULL;
	mDefLight                 = false;
	mMode                     = WK7VIEWERMODE_OPERATE;
	mReqMode                  = WK7VIEWERMODE_OPERATE;
	mScreenTone               = false;
#if defined(USE_USB)
	SetPerfMeter    (false);
	SetInfoDisp     (false);
	SetOrigDisp     (false);
	SetCamTargetDisp(false);
#else
	SetPerfMeter    (true);
	SetInfoDisp     (true);
	SetOrigDisp     (true);
	SetCamTargetDisp(true);
#endif
	mShadowTrigger            = false;
	mpOriginArchive           = NULL;
	mpOriginJObj              = NULL;
	mpTexture                 = NULL;
	mpStage                   = NULL;
	mpStageArchive            = NULL;
	mpStageObj                = NULL;
	mpStageFileName           = NULL;
	WK7ViewerModel::SetMotionPlayAll(false);
#ifdef	ORBITAL
	mRenderMemory             = false;
	WK7ViewerModel::SetMotionLoopAll(false);
	mEditMode                 = MOTIONPLAY;
#else
#if defined(USE_USB)
	mRenderMemory             = false;
#else
	mRenderMemory             = true;
#endif
	WK7ViewerModel::SetMotionLoopAll(true);
	mEditMode                 = VIEWER;
#endif
	mSelectMotion             = 0;
	mModelNum                 = 0;
	SetCurrentModel(0);
	mSelectModel              = 0;
	mPlayNum                  = 0;
	mFrameRate                = 0;
	mpCameraMotionArchive     = NULL;
	mpCameraMotion            = NULL;
	mpCameraMotionFileName    = NULL;
	mCameraMotionPlay         = false;
	mEditCamType              = LINIP_LINPATH;
	mEditCamProc              = 0;
	mEditCamProcMax           = 5;
	mEditCamDelayRate         = EDITCAM_DELAYRATE_MAX / 100;
	mEditCamInterpolateTime   = 3 * WK7_TICK_PER_SEC;	// 3b
	mPlayInfoDisp             = true;
	mPlayInfoDispCounter      = 0;
	mpPlay                    = NULL;
	mpPlayResource            = NULL;
	mpPrevPlay                = NULL;
	mpPrevPlayResource        = NULL;
	mSysMesProc               = -1;
	mSysMesHandle             = -1;
	mSysMesSelect             = 0;
	mpSysMesResource          = NULL;
	mpSysMesEffect            = NULL;
	mSysMesEffectID           = 0xffffffff;
	mSysMesCount              = 0;
	mSysMesFlag               = 0;
	mpCurrentJObj             = NULL;
	mSceneBlurVisible         = false;
	mSceneBlurID              = 0;
	mSceneBlurProc            = 0;
	mLightEditProc            = 0;
	mLightID                  = -1;
	mMovieID                  = 0;
	screenImageFullColor.SetFormat(GX_TF_RGBA8);
	screenImageMonoColor.SetFormat(GX_TF_I8);
	screenImageFullColor.AllocBuffer();
	screenImageMonoColor.AllocBuffer();
	WK7ViewerMenuItem		*pMenuItem = GetMenu(WK7ViewerTask::WK7VIEWERMODE_RENDERMEMORY);
	if( pMenuItem!=NULL ){
		if( mRenderMemory==true ){
			pMenuItem->mpOption = "On";
		}else{
			pMenuItem->mpOption = "Off";
		}
	}
#if defined(ORBITAL)
	afterImage.SetEnable(false);
	afterImage.SetClearColor(0x00004000);
//	SetCinemaScope(true);
	SetCinemaScope(false);
#else
	SetCinemaScope(false);
#ifdef	AFTERIMAGE_TEST
	afterImage.SetEnable(true);
	afterImage.SetClearColor(0x00000000);
#else
	afterImage.SetEnable(false);
	afterImage.SetClearColor(0x00004000);
#endif
#endif
	SetCamWobble(true);
	SetWalkArea(true);
	SetHitObjCheck(true);
#if	defined(_DEBUG) && defined(K7APP_STREAM_DEFAULT) && K7APP_STREAM_DEFAULT==0
	SetStream(false);
#else
	SetStream(true);
#endif
	mZanID           = 0;
	mZanMesID        = 0;
	mZanProc         = 0;
	mZanStartTime    = 0.0f;
	mZanWaitTime     = 0.0f;
	mPlayProc        = 0;
	mPlayCount       = 0;
	mPlayStartTime   = 0.0f;
	mPlayWaitTime    = 0.0f;
	mPlayEndStop     = false;
}

WK7ViewerTask::~WK7ViewerTask()
{
	screenImageFullColor.FreeBuffer();
	screenImageMonoColor.FreeBuffer();
}

bool WK7ViewerTask::ChangeEditMode(void)
{
	if( HSD_PadGetButton(0) & HSD_PAD_Z ){
		return false;
	}
	if( HSD_PadGetButton(0)!=HSD_PAD_X ||  HSD_PadGetTrigger(0)!=HSD_PAD_X ){
		return false;
	}
	mEditMode = (EditMode)(mEditMode + 1);
	if( mEditMode >= EDITMODE_MAX ){
		mEditMode  = VIEWER;
	}
//	switch( mEditMode ){
//	case	CAMEDIT:
//		WK7CAM->SetDebugOperate(false);
//		break;
//	default:
//		WK7CAM->SetDebugOperate(true);
//		break;
//	}
	return true;
}

bool WK7ViewerTask::SetMode(WK7ViewerMode mode)
{
	mMode = mode;
	mProcSub = 0;
	mPrevCursor = mCursor;
	WK7CAM->SetDebugOperate(true);
	SetCamMode(mode);
	switch( mMode ){
	case	WK7VIEWERMODE_TEXTURE:
	case	WK7VIEWERMODE_STAGELOAD:
	case	WK7VIEWERMODE_PLAYLOAD:
	case	WK7VIEWERMODE_CAMMOTIONLOAD:
	case	WK7VIEWERMODE_ZANLOAD:
	case	WK7VIEWERMODE_SYSMESLOAD:
	case	WK7VIEWERMODE_MOVIELOAD:
	case	WK7VIEWERMODE_MODELLOAD:
	case	WK7VIEWERMODE_MOTIONLOADSUB:
		mProc = mCursor = mFileList.GetCursorID();
		RenewCursorRange(mFileList.GetFileNum(),FILELIST_DISPMAX);
		break;
	case	WK7VIEWERMODE_PLAY:
		mPlayInfoDisp           = true;
		mPlayInfoDispCounter    = 0;
	default:
		mProc = 0;
		mCursor = 0;
		break;
	}
	return true;
}

bool WK7ViewerTask::SetCamMode(WK7ViewerMode mode)
{
	switch( mode ){
	case	WK7VIEWERMODE_OPERATE:
		if( mCameraMotionPlay==true ){
//		if( mCameraMotionPlay==true && mpCameraMotion!=NULL ){
			WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
			WK7CAM->ExitDebugMode();
		}else{
			WK7CAM->SetMode(WK7Cam::WK7CAM_DEBUG);
			WK7CAM->EnterDebugMode();
		}
		break;
	default:
		WK7CAM->SetMode(WK7Cam::WK7CAM_FREE_TARGET);
		WK7CAM->ExitDebugMode();
		break;
	}
	return true;
}


class WK7FindFile{
public:
	char			*mpFileName;
	bool			mIsDir;
	WK7FindFile		*mpNext;
	WK7FindFile(const char *pfilename,WK7FindFile *pPrev){
		int	len = (int)(strlen(pfilename) + 1);
		ghmGcMemSetAllocName("VTFFFN");
		mpFileName = (char *)K7AppSmallMemAlloc(len);
		strcpy(mpFileName,pfilename);
		mpNext     = NULL;
		if( pPrev!=NULL ){
			pPrev->mpNext = this;
		}
		mIsDir = false;
	}
	~WK7FindFile(){
		K7AppSmallMemFree(mpFileName);
		if( mpNext != NULL ){
			delete mpNext;
		}
	}
	
	void *operator new(u32 blocksize);
	void *operator new[](u32 blocksize);
	void operator delete(void *pblock);
	void operator delete[](void *pblock);
};

void* WK7FindFile::operator new(u32 blocksize)
{
	return K7AppSmallMemAlloc((int)blocksize);
}
 
void* WK7FindFile::operator new[](u32 blocksize)
{
	return K7AppSmallMemAlloc((int)blocksize);
}
 
void WK7FindFile::operator delete(void *pblock)
{
	K7AppSmallMemFree(pblock);
}
 
void WK7FindFile::operator delete[](void *pblock)
{
	K7AppSmallMemFree(pblock);
}

WK7ViewerFileList::WK7ViewerFileList()
{
	ghmGcMemSetAllocName("VTFLDN");
	mpDirName   = (char *)K7AppSmallMemAlloc(1024);
	mDirLevel   = 0;
	mpFiles     = NULL;
	mFileNum    = 0;
	memset(mExt,0,sizeof(mExt));
	mCursorID = 0;
	for(int i=0 ; i<WK7VIEWERFILELIST_CURSOR_STACKNUM ; i++){
		mCursorStack[i] = 0;
	}
}

WK7ViewerFileList::~WK7ViewerFileList()
{
	ReleaseFileList();
	GHMGCMEM_SAFE_FREE(mpDirName);
}

bool WK7ViewerFileList::CompareExt(const char *pfilename,const char *pext)
{
	const char	*pch = pfilename;
	while( *pch != '\0' ){
		if( *pch=='.' ){
			pch++;
			if( strcmp(pch,pext)==0 ){
				return true;
			}else{
				return false;
			}
		}
		pch++;
	}
	return false;
}

char* strupr(char *pstr);
char* strupr(char *pstr)
{
	char		*pstrtop = pstr;
	while( *pstr!='\0' ){
		if( *pstr >= 'a' && *pstr <= 'z' ){
			*pstr += 'A' - 'a';
		}
		pstr++;
	}
	return pstrtop;
}

bool WK7ViewerFileList::SetCursorID(int id)
{
	mCursorID = id;
	if( mDirLevel < WK7VIEWERFILELIST_CURSOR_STACKNUM ){
		mCursorStack[mDirLevel] = mCursorID;
	}else{
		return false;
	}
	return true;
}

bool WK7ViewerFileList::ChangeDir(ghmGcUsb &serv,int index)
{
	if( IsDir(index) <= 0 ){
		return false;
	}
	if( IsParent(index) > 0 ){
		return MoveParentDir(serv);
	}
	char	dir[1024];
	strcpy(dir,GetDirName());
	strcat(dir,GetFileName(index));
	strcat(dir,"/");
	ReleaseFileList();
	if( mDirLevel < WK7VIEWERFILELIST_CURSOR_STACKNUM ){
		mCursorStack[mDirLevel] = mCursorID;;
	}
	mDirLevel++;
	if( CreateFileList(serv,dir)==false ){
		mDirLevel--;
		return false;
	}
	mCursorID = 0;
//	if( mDirLevel < WK7VIEWERFILELIST_CURSOR_STACKNUM ){
//		mCursorID = mCursorStack[mDirLevel];
//	}
	return true;
}

bool WK7ViewerFileList::MoveParentDir(ghmGcUsb &serv)
{
	if( mDirLevel==0 || strcmp(mpDirName,"")==0 || strcmp(mpDirName,"/")==0 ){
		return false;
	}
	char	dir[1024];
	char	*pDirName;
	int		len = 0;
	bool	find_slash = false;
	int		last_slash = -1;
	pDirName = mpDirName;
	while( *pDirName!='\0' ){
		if( find_slash==true ){
			last_slash = len;
			find_slash = false;
		}
		if( *pDirName=='/' ){
			find_slash = true;
		}
		pDirName++;
		len++;
	}
	if( len==0 || last_slash < 0 ){
		strcpy(dir,"");
	}else{
		strcpy(dir,mpDirName);
		dir[last_slash] = '\0';
	}
	ReleaseFileList();
	if( mDirLevel < WK7VIEWERFILELIST_CURSOR_STACKNUM ){
		mCursorStack[mDirLevel] = mCursorID;
	}
	mDirLevel--;
	if( CreateFileList(serv,dir)==false ){
		mDirLevel++;
		return false;
	}
	if( mDirLevel < WK7VIEWERFILELIST_CURSOR_STACKNUM ){
		mCursorID = mCursorStack[mDirLevel];
	}
	return true;
}

bool WK7ViewerFileList::CreateFileList(ghmGcUsb &serv,const char *pdir)
{
	if( mFileNum ){
		return false;
	}
	WK7FindFile		*pFindFile,*pPrevFindFile = NULL;
	WK7FindFile		*pTopFindFile = NULL;
	char			filename[_MAX_PATH];
	if( pdir==NULL ){
		if( mDirLevel > 0 ){
			strcpy(filename,mpDirName);
		}else{
			strcpy(filename,"");
			strcpy(mpDirName,"");
		}
	}else{
		strcpy(filename,pdir);
		strcpy(mpDirName,pdir);
	}
	
	mFileNum = 0;
	
	if( mDirLevel > 0 ){
		ghmGcMemSetAllocName("FindFile");
		pPrevFindFile = new WK7FindFile("..",NULL);
		pPrevFindFile->mIsDir  = true;
		pTopFindFile = pPrevFindFile;
		mFileNum++;
	}
	
#ifndef	READ_HD
	
#ifndef	USE_ISDOLVIEWER
	strcat(filename,"*.");
	strcat(filename,mExt);
#endif
	
	if( serv.FindFirst(filename)==true ){
		do{
			const char		*pFindFileName;
			pFindFileName = serv.GetFindFileName();
			if( serv.GetFindAttr() & FIO_ATTRIBUTE_DIRECTORY ){
				continue;
			}
#ifdef	USE_ISDOLVIEWER
			strcpy(filename,pFindFileName);
			strupr(filename);
			if( CompareExt(filename,mExt)==false ){
				continue;
			}
#endif
			ghmGcMemSetAllocName("FindFile");
			pFindFile = new WK7FindFile(pFindFileName,pPrevFindFile);
			if( pPrevFindFile==NULL ){
				pTopFindFile = pFindFile;
			}
			pPrevFindFile = pFindFile;
			mFileNum++;
		}while( serv.FindNext()==true );
		serv.FindClose();
	}
#else
#pragma unused(serv)
	DVDDir		dir;
	DVDDirEntry	entry;
	if( DVDOpenDir(mpDirName,&dir)==TRUE ){
		while( DVDReadDir(&dir,&entry)==TRUE ){
			if( entry.isDir==FALSE ){
				strcpy(filename,entry.name);
				strupr(filename);
				if( CompareExt(filename,mExt)==false ){
					continue;
				}
			}else{
				strcpy(filename,entry.name);
				strupr(filename);
				if( strcmp(filename,"CVS")==0 ){
					continue;
				}
			}
			mFileNum++;
			ghmGcMemSetAllocName("FindFile");
			pFindFile = new WK7FindFile(entry.name,pPrevFindFile);
			if( entry.isDir==TRUE ){
				pFindFile->mIsDir = true;
			}
			if( pPrevFindFile==NULL ){
				pTopFindFile = pFindFile;
			}
			pPrevFindFile = pFindFile;
		}
		DVDCloseDir(&dir);
	}
#endif
	
	//OSReport("create file num %d\n",mFileNum);
	
	if( pTopFindFile != NULL && mFileNum > 0 ){
		int			i;
		ghmGcMemSetAllocName("FileList");
		mpFiles = new WK7ViewerFileListItem[mFileNum];
		for(pFindFile=pTopFindFile,i=0 ; pFindFile!=NULL ; pFindFile=pFindFile->mpNext,i++){
			strcpy(filename,pFindFile->mpFileName);
			int		len = (int)(strlen(filename) + 1);
			ghmGcMemSetAllocName("VTFLFNS");
			if( (mpFiles[i].mpFileName = (char *)K7AppSmallMemAlloc(len))!=NULL ){
				strcpy(mpFiles[i].mpFileName,filename);
			}
			mpFiles[i].mIsDir = pFindFile->mIsDir;
			if( mDirLevel > 0 && i==0 ){
				mpFiles[i].mParent = 1;
			}
		}
		delete pTopFindFile;
	}
	return true;
}

bool WK7ViewerFileList::GetFullFileName(int index,char *pFileName)
{
	if( index < 0 || index >=mFileNum ){
		return false;
	}
	strcpy(pFileName,mpDirName);
	strcat(pFileName,mpFiles[index].mpFileName);
	return true;
}

bool WK7ViewerFileList::ReleaseFileList()
{
	GHM_SAFE_DELETE_ARRAY(mpFiles);
	mFileNum = 0;
	return true;
}

void WK7ViewerFileList::SetFilter(const char *pExt)
{
	if( pExt==NULL ){
		memset(mExt,0,sizeof(mExt));
		return;
	}
	strcpy(mExt,pExt);
	strupr(mExt);
}

WK7ViewerFileListItem::WK7ViewerFileListItem()
{
	mpFileName = NULL;
	mIsDir     = false;
	mFlag      = 0;
}

WK7ViewerFileListItem::~WK7ViewerFileListItem()
{
	GHMGCMEM_SAFE_FREE(mpFileName);
}

